/**
 * @file Checkbox
 * @author fex
 */
import React from 'react';
import { ClassNamesFn } from '../theme';
interface CheckboxProps {
    id?: string;
    key?: string | number;
    style?: React.CSSProperties;
    type: 'checkbox' | 'radio';
    size?: 'sm' | 'lg' | 'small' | 'large';
    label?: string;
    labelClassName?: string;
    className?: string;
    onChange?: (value: any) => void;
    value?: any;
    containerClass?: string;
    inline?: boolean;
    trueValue?: boolean;
    falseValue?: boolean;
    disabled?: boolean;
    readOnly?: boolean;
    checked?: boolean;
    name?: string;
    description?: string;
    classPrefix: string;
    classnames: ClassNamesFn;
    partial?: boolean;
    data?: any;
}
export declare class Checkbox extends React.Component<CheckboxProps, any> {
    static defaultProps: Pick<CheckboxProps, 'trueValue' | 'falseValue' | 'type'>;
    handleCheck(e: React.ChangeEvent<any>): void;
    render(): JSX.Element;
}
declare const _default: React.ComponentClass<Pick<Pick<CheckboxProps, "disabled" | "data" | "label" | "style" | "size" | "inline" | "key" | "name" | "value" | "id" | "className" | "classPrefix" | "classnames" | "description" | "checked" | "readOnly" | "onChange" | "labelClassName" | "containerClass" | "partial"> & Partial<Pick<CheckboxProps, "type" | "trueValue" | "falseValue">> & Partial<Pick<Pick<CheckboxProps, "type" | "trueValue" | "falseValue">, never>>, "disabled" | "data" | "label" | "style" | "size" | "inline" | "key" | "type" | "name" | "value" | "id" | "className" | "description" | "checked" | "readOnly" | "onChange" | "trueValue" | "falseValue" | "labelClassName" | "containerClass" | "partial"> & {
    theme?: string | undefined;
    classPrefix?: string | undefined;
    classnames?: ClassNamesFn | undefined;
}, any> & {
    ComposedComponent: typeof Checkbox;
};
export default _default;
