import moment from 'moment';
import DaysView from 'react-datetime/src/DaysView';
import React from 'react';
interface CustomDaysViewProps {
    classPrefix?: string;
    prevIcon?: string;
    nextIcon?: string;
    viewDate: moment.Moment;
    selectedDate: moment.Moment;
    timeFormat: string;
    requiredConfirm?: boolean;
    isEndDate?: boolean;
    renderDay?: Function;
    onClose?: () => void;
    onChange: (value: moment.Moment) => void;
    setDateTimeState: (state: any) => void;
    setTime: (type: string, amount: number) => void;
    subtractTime: (amount: number, type: string, toSelected?: moment.Moment) => () => void;
    addTime: (amount: number, type: string, toSelected?: moment.Moment) => () => void;
    isValidDate?: (currentDate: moment.Moment, selected?: moment.Moment) => boolean;
    showView: (view: string) => () => void;
    updateSelectedDate: (event: React.MouseEvent<any>, close?: boolean) => void;
    handleClickOutside: () => void;
}
export default class CustomDaysView extends DaysView {
    props: CustomDaysViewProps;
    getDaysOfWeek: (locale: any) => any;
    renderDays: () => JSX.Element;
    updateSelectedDate: (event: React.MouseEvent<any, MouseEvent>) => void;
    setTime: (type: "hours" | "minutes" | "seconds" | "milliseconds", value: number) => void;
    confirm: () => void;
    cancel: () => void;
    renderDay: (props: any, currentDate: moment.Moment) => JSX.Element;
    renderTimes: () => JSX.Element;
    renderFooter: () => JSX.Element | null;
    render(): JSX.Element;
}
export {};
