import React from 'react';
import { RendererProps } from '../factory';
import { ImageThumbProps } from './Image';
export interface ImagesProps extends RendererProps {
    className: string;
    defaultImage: string;
    placeholder: string;
    delimiter: string;
    thumbMode: 'w-full' | 'h-full' | 'contain' | 'cover';
    thumbRatio: '1:1' | '4:3' | '16:9';
    name?: string;
    value?: any;
    source?: string;
    src?: string;
    originalSrc?: string;
    enlargeAble?: boolean;
    onEnlarge?: (info: ImageThumbProps & {
        list?: Array<Pick<ImageThumbProps, 'src' | 'originalSrc' | 'title' | 'caption'>>;
    }) => void;
    showDimensions?: boolean;
}
export declare class ImagesField extends React.Component<ImagesProps> {
    static defaultProps: Pick<ImagesProps, 'className' | 'delimiter' | 'defaultImage' | 'placehoder' | 'thumbMode' | 'thumbRatio'>;
    list: Array<any>;
    handleEnlarge(info: ImageThumbProps): void;
    render(): JSX.Element;
}
export declare class ImagesFieldRenderer extends ImagesField {
}
