var require, define;
(function () {
    var loadingMap = {};
    var factoryMap = {};
    var modulesMap = {};

    define = function (id, factory) {
        id = id.replace(/\.js$/i, '');
        factoryMap[id] = factory;

        var queue = loadingMap[id];
        if (queue) {
            for (var i = 0, n = queue.length; i < n; i++) {
                queue[i]();
            }
            delete loadingMap[id];
        }
    };

    require = function (id) {
        id = require.alias(id);

        var mod = modulesMap[id];
        if (mod) {
            return mod.exports;
        }

        var factory = factoryMap[id];
        if (!factory) {
            throw '[ModJS] Cannot find module `' + id + '`';
        }

        mod = modulesMap[id] = {
            exports: {}
        };

        var ret = (typeof factory === 'function') ? factory.apply(mod, [require, mod.exports, mod]) : factory;

        if (ret) {
            mod.exports = ret;
        }

        return mod.exports;
    };

    require.alias = function (id) {
        return id.replace(/\.js$/i, '');
    };
})(this);
/**! node_modules/monaco-editor/esm/vs/base/common/linkedList.js*/
define("45886bc",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=e("6ad26fe"),i=function(){function e(t){this.element=t,this.next=e.Undefined,this.prev=e.Undefined}return e.Undefined=new e(void 0),e}(),r=function(){function e(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}return Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.isEmpty=function(){return this._first===i.Undefined},e.prototype.clear=function(){this._first=i.Undefined,this._last=i.Undefined,this._size=0},e.prototype.unshift=function(e){return this._insert(e,!1)},e.prototype.push=function(e){return this._insert(e,!0)},e.prototype._insert=function(e,t){var n=this,r=new i(e);if(this._first===i.Undefined)this._first=r,this._last=r;else if(t){var s=this._last;this._last=r,r.prev=s,s.next=r}else{var f=this._first;this._first=r,r.next=f,f.prev=r}this._size+=1;var d=!1;return function(){d||(d=!0,n._remove(r))}},e.prototype.shift=function(){if(this._first===i.Undefined)return void 0;var e=this._first.element;return this._remove(this._first),e},e.prototype._remove=function(e){if(e.prev!==i.Undefined&&e.next!==i.Undefined){var t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===i.Undefined&&e.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):e.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):e.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1},e.prototype.iterator=function(){var e,t=this._first;return{next:function(){return t===i.Undefined?n.FIN:(e?e.value=t.element:e={done:!1,value:t.element},t=t.next,e)}}},e.prototype.toArray=function(){for(var e=[],t=this._first;t!==i.Undefined;t=t.next)e.push(t.element);return e},e}();t.LinkedList=r});
/**! node_modules/monaco-editor/esm/vs/base/common/functional.js*/
define("4af2228",function(e,n){"use strict";function t(e){var n,t=this,r=!1;return function(){return r?n:(r=!0,n=e.apply(t,arguments))}}Object.defineProperty(n,"__esModule",{value:!0}),n.once=t});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/parser.js*/
define("38cea32",function(e,n){"use strict";function r(e,n){function r(e,n,r,t){a.value=e,a.offset=n,a.length=r,a.type=t,a.colonOffset=void 0,i=a}var t=[],o=new Object,i=void 0,a={value:{},offset:0,length:0,type:"object",parent:void 0},f=!1;try{l(e,{onObjectBegin:function(e){if(e>=n)throw o;i=void 0,f=n>e,t.push("")},onObjectProperty:function(e,i,a){if(i>n)throw o;if(r(e,i,a,"property"),t[t.length-1]=e,i+a>=n)throw o},onObjectEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onArrayBegin:function(e){if(e>=n)throw o;i=void 0,t.push(0)},onArrayEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onLiteralValue:function(e,t,i){if(t>n)throw o;if(r(e,t,i,h(e)),t+i>=n)throw o},onSeparator:function(e,r){if(r>=n)throw o;if(":"===e&&i&&"property"===i.type)i.colonOffset=r,f=!1,i=void 0;else if(","===e){var a=t[t.length-1];"number"==typeof a?t[t.length-1]=a+1:(f=!0,t[t.length-1]=""),i=void 0}}})}catch(c){if(c!==o)throw c}return{path:t,previousNode:i,isAtPropertyKey:f,matches:function(e){for(var n=0,r=0;n<e.length&&r<t.length;r++)if(e[n]===t[r]||"*"===e[n])n++;else if("**"!==e[n])return!1;return n===e.length}}}function t(e,n,r){function t(e){Array.isArray(i)?i.push(e):o&&(i[o]=e)}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var o=null,i=[],a=[],f={onObjectBegin:function(){var e={};t(e),a.push(i),i=e,o=null},onObjectProperty:function(e){o=e},onObjectEnd:function(){i=a.pop()},onArrayBegin:function(){var e=[];t(e),a.push(i),i=e,o=null},onArrayEnd:function(){i=a.pop()},onLiteralValue:t,onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};return l(e,f,r),i[0]}function o(e,n,r){function t(e){"property"===i.type&&(i.length=e-i.offset,i=i.parent)}function o(e){return i.children.push(e),e}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var i={type:"array",offset:-1,length:-1,children:[],parent:void 0},a={onObjectBegin:function(e){i=o({type:"object",offset:e,length:-1,parent:i,children:[]})},onObjectProperty:function(e,n,r){i=o({type:"property",offset:n,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:e,offset:n,length:r,parent:i})},onObjectEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onArrayBegin:function(e){i=o({type:"array",offset:e,length:-1,parent:i,children:[]})},onArrayEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onLiteralValue:function(e,n,r){o({type:h(e),offset:n,length:r,parent:i,value:e}),t(n+r)},onSeparator:function(e,n){"property"===i.type&&(":"===e?i.colonOffset=n:","===e&&t(n))},onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};l(e,a,r);var f=i.children[0];return f&&delete f.parent,f}function i(e,n){if(!e)return void 0;for(var r=e,t=0,o=n;t<o.length;t++){var i=o[t];if("string"==typeof i){if("object"!==r.type||!Array.isArray(r.children))return void 0;for(var a=!1,f=0,c=r.children;f<c.length;f++){var u=c[f];if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],a=!0;break}}if(!a)return void 0}else{var l=i;if("array"!==r.type||0>l||!Array.isArray(r.children)||l>=r.children.length)return void 0;r=r.children[l]}}return r}function a(e){if(!e.parent||!e.parent.children)return[];var n=a(e.parent);if("property"===e.parent.type){var r=e.parent.children[0].value;n.push(r)}else if("array"===e.parent.type){var t=e.parent.children.indexOf(e);-1!==t&&n.push(t)}return n}function f(e){switch(e.type){case"array":return e.children.map(f);case"object":for(var n=Object.create(null),r=0,t=e.children;r<t.length;r++){var o=t[r],i=o.children[1];i&&(n[o.children[0].value]=f(i))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return void 0}}function c(e,n,r){return void 0===r&&(r=!1),n>=e.offset&&n<e.offset+e.length||r&&n===e.offset+e.length}function u(e,n,r){if(void 0===r&&(r=!1),c(e,n,r)){var t=e.children;if(Array.isArray(t))for(var o=0;o<t.length&&t[o].offset<=n;o++){var i=u(t[o],n,r);if(i)return i}return e}return void 0}function l(e,n,r){function t(e){return e?function(){return e(g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function o(e){return e?function(n){return e(n,g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function i(){for(;;){var e=g.scan();switch(g.getTokenError()){case 4:a(14);break;case 5:a(15);break;case 3:a(13);break;case 1:m||a(11);break;case 2:a(12);break;case 6:a(16)}switch(e){case 12:case 13:m?a(10):w();break;case 16:a(1);break;case 15:case 14:break;default:return e}}}function a(e,n,r){if(void 0===n&&(n=[]),void 0===r&&(r=[]),j(e),n.length+r.length>0)for(var t=g.getToken();17!==t;){if(-1!==n.indexOf(t)){i();break}if(-1!==r.indexOf(t))break;t=i()}}function f(e){var n=g.getTokenValue();return e?A(n):y(n),i(),!0}function c(){switch(g.getToken()){case 11:var e=0;try{e=JSON.parse(g.getTokenValue()),"number"!=typeof e&&(a(2),e=0)}catch(n){a(2)}A(e);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return i(),!0}function u(){return 10!==g.getToken()?(a(3,[],[2,5]),!1):(f(!1),6===g.getToken()?(O(":"),i(),h()||a(4,[],[2,5])):a(5,[],[2,5]),!0)}function l(){v(),i();for(var e=!1;2!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),2===g.getToken()&&E)break}else e&&a(6,[],[]);u()||a(4,[],[2,5]),e=!0}return b(),2!==g.getToken()?a(7,[2],[]):i(),!0}function s(){k(),i();for(var e=!1;4!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),4===g.getToken()&&E)break}else e&&a(6,[],[]);h()||a(4,[],[4,5]),e=!0}return T(),4!==g.getToken()?a(8,[4],[]):i(),!0}function h(){switch(g.getToken()){case 3:return s();case 1:return l();case 10:return f(!0);default:return c()}}void 0===r&&(r=p.DEFAULT);var g=d.createScanner(e,!1),v=t(n.onObjectBegin),y=o(n.onObjectProperty),b=t(n.onObjectEnd),k=t(n.onArrayBegin),T=t(n.onArrayEnd),A=o(n.onLiteralValue),O=o(n.onSeparator),w=t(n.onComment),j=o(n.onError),m=r&&r.disallowComments,E=r&&r.allowTrailingComma;return i(),17===g.getToken()?!0:h()?(17!==g.getToken()&&a(9,[],[]),!0):(a(4,[],[]),!1)}function s(e,n){var r,t,o=d.createScanner(e),i=[],a=0;do switch(t=o.getPosition(),r=o.scan()){case 12:case 13:case 17:a!==t&&i.push(e.substring(a,t)),void 0!==n&&i.push(o.getTokenValue().replace(/[^\r\n]/g,n)),a=o.getPosition()}while(17!==r);return i.join("")}function h(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";default:return"null"}}Object.defineProperty(n,"__esModule",{value:!0});var p,d=e("aedc3c9");!function(e){e.DEFAULT={allowTrailingComma:!1}}(p||(p={})),n.getLocation=r,n.parse=t,n.parseTree=o,n.findNodeAtLocation=i,n.getNodePath=a,n.getNodeValue=f,n.contains=c,n.findNodeAtOffset=u,n.visit=l,n.stripComments=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/scanner.js*/
define("aedc3c9",function(e,r){"use strict";function t(e,r){function t(r,t){for(var n=0,a=0;r>n||!t;){var c=e.charCodeAt(d);if(c>=48&&57>=c)a=16*a+c-48;else if(c>=65&&70>=c)a=16*a+c-65+10;else{if(!(c>=97&&102>=c))break;a=16*a+c-97+10}d++,n++}return r>n&&(a=-1),a}function o(e){d=e,g="",b=0,l=16,A=0}function s(){var r=d;if(48===e.charCodeAt(d))d++;else for(d++;d<e.length&&c(e.charCodeAt(d));)d++;if(d<e.length&&46===e.charCodeAt(d)){if(d++,!(d<e.length&&c(e.charCodeAt(d))))return A=3,e.substring(r,d);for(d++;d<e.length&&c(e.charCodeAt(d));)d++}var t=d;if(d<e.length&&(69===e.charCodeAt(d)||101===e.charCodeAt(d)))if(d++,(d<e.length&&43===e.charCodeAt(d)||45===e.charCodeAt(d))&&d++,d<e.length&&c(e.charCodeAt(d))){for(d++;d<e.length&&c(e.charCodeAt(d));)d++;t=d}else A=3;return e.substring(r,t)}function u(){for(var r="",n=d;;){if(d>=C){r+=e.substring(n,d),A=2;break}var c=e.charCodeAt(d);if(34===c){r+=e.substring(n,d),d++;break}if(92!==c){if(c>=0&&31>=c){if(a(c)){r+=e.substring(n,d),A=2;break}A=6}d++}else{if(r+=e.substring(n,d),d++,d>=C){A=2;break}switch(c=e.charCodeAt(d++)){case 34:r+='"';break;case 92:r+="\\";break;case 47:r+="/";break;case 98:r+="\b";break;case 102:r+="\f";break;case 110:r+="\n";break;case 114:r+="\r";break;case 116:r+="	";break;case 117:var o=t(4,!0);o>=0?r+=String.fromCharCode(o):A=4;break;default:A=5}n=d}}return r}function i(){if(g="",A=0,b=d,d>=C)return b=C,l=17;var r=e.charCodeAt(d);if(n(r)){do d++,g+=String.fromCharCode(r),r=e.charCodeAt(d);while(n(r));return l=15}if(a(r))return d++,g+=String.fromCharCode(r),13===r&&10===e.charCodeAt(d)&&(d++,g+="\n"),l=14;switch(r){case 123:return d++,l=1;case 125:return d++,l=2;case 91:return d++,l=3;case 93:return d++,l=4;case 58:return d++,l=6;case 44:return d++,l=5;case 34:return d++,g=u(),l=10;case 47:var t=d-1;if(47===e.charCodeAt(d+1)){for(d+=2;C>d&&!a(e.charCodeAt(d));)d++;return g=e.substring(t,d),l=12}if(42===e.charCodeAt(d+1)){d+=2;for(var o=C-1,i=!1;o>d;){var h=e.charCodeAt(d);if(42===h&&47===e.charCodeAt(d+1)){d+=2,i=!0;break}d++}return i||(d++,A=1),g=e.substring(t,d),l=13}return g+=String.fromCharCode(r),d++,l=16;case 45:if(g+=String.fromCharCode(r),d++,d===C||!c(e.charCodeAt(d)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=s(),l=11;default:for(;C>d&&f(r);)d++,r=e.charCodeAt(d);if(b!==d){switch(g=e.substring(b,d)){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return g+=String.fromCharCode(r),d++,l=16}}function f(e){if(n(e)||a(e))return!1;switch(e){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function h(){var e;do e=i();while(e>=12&&15>=e);return e}void 0===r&&(r=!1);var d=0,C=e.length,g="",b=0,l=16,A=0;return{setPosition:o,getPosition:function(){return d},scan:r?h:i,getToken:function(){return l},getTokenValue:function(){return g},getTokenOffset:function(){return b},getTokenLength:function(){return d-b},getTokenError:function(){return A}}}function n(e){return 32===e||9===e||11===e||12===e||160===e||5760===e||e>=8192&&8203>=e||8239===e||8287===e||12288===e||65279===e}function a(e){return 10===e||13===e||8232===e||8233===e}function c(e){return e>=48&&57>=e}Object.defineProperty(r,"__esModule",{value:!0}),r.createScanner=t});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/parser.js*/
define("38cea32",function(e,n){"use strict";function r(e,n){function r(e,n,r,t){a.value=e,a.offset=n,a.length=r,a.type=t,a.colonOffset=void 0,i=a}var t=[],o=new Object,i=void 0,a={value:{},offset:0,length:0,type:"object",parent:void 0},f=!1;try{l(e,{onObjectBegin:function(e){if(e>=n)throw o;i=void 0,f=n>e,t.push("")},onObjectProperty:function(e,i,a){if(i>n)throw o;if(r(e,i,a,"property"),t[t.length-1]=e,i+a>=n)throw o},onObjectEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onArrayBegin:function(e){if(e>=n)throw o;i=void 0,t.push(0)},onArrayEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onLiteralValue:function(e,t,i){if(t>n)throw o;if(r(e,t,i,h(e)),t+i>=n)throw o},onSeparator:function(e,r){if(r>=n)throw o;if(":"===e&&i&&"property"===i.type)i.colonOffset=r,f=!1,i=void 0;else if(","===e){var a=t[t.length-1];"number"==typeof a?t[t.length-1]=a+1:(f=!0,t[t.length-1]=""),i=void 0}}})}catch(c){if(c!==o)throw c}return{path:t,previousNode:i,isAtPropertyKey:f,matches:function(e){for(var n=0,r=0;n<e.length&&r<t.length;r++)if(e[n]===t[r]||"*"===e[n])n++;else if("**"!==e[n])return!1;return n===e.length}}}function t(e,n,r){function t(e){Array.isArray(i)?i.push(e):o&&(i[o]=e)}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var o=null,i=[],a=[],f={onObjectBegin:function(){var e={};t(e),a.push(i),i=e,o=null},onObjectProperty:function(e){o=e},onObjectEnd:function(){i=a.pop()},onArrayBegin:function(){var e=[];t(e),a.push(i),i=e,o=null},onArrayEnd:function(){i=a.pop()},onLiteralValue:t,onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};return l(e,f,r),i[0]}function o(e,n,r){function t(e){"property"===i.type&&(i.length=e-i.offset,i=i.parent)}function o(e){return i.children.push(e),e}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var i={type:"array",offset:-1,length:-1,children:[],parent:void 0},a={onObjectBegin:function(e){i=o({type:"object",offset:e,length:-1,parent:i,children:[]})},onObjectProperty:function(e,n,r){i=o({type:"property",offset:n,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:e,offset:n,length:r,parent:i})},onObjectEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onArrayBegin:function(e){i=o({type:"array",offset:e,length:-1,parent:i,children:[]})},onArrayEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onLiteralValue:function(e,n,r){o({type:h(e),offset:n,length:r,parent:i,value:e}),t(n+r)},onSeparator:function(e,n){"property"===i.type&&(":"===e?i.colonOffset=n:","===e&&t(n))},onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};l(e,a,r);var f=i.children[0];return f&&delete f.parent,f}function i(e,n){if(!e)return void 0;for(var r=e,t=0,o=n;t<o.length;t++){var i=o[t];if("string"==typeof i){if("object"!==r.type||!Array.isArray(r.children))return void 0;for(var a=!1,f=0,c=r.children;f<c.length;f++){var u=c[f];if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],a=!0;break}}if(!a)return void 0}else{var l=i;if("array"!==r.type||0>l||!Array.isArray(r.children)||l>=r.children.length)return void 0;r=r.children[l]}}return r}function a(e){if(!e.parent||!e.parent.children)return[];var n=a(e.parent);if("property"===e.parent.type){var r=e.parent.children[0].value;n.push(r)}else if("array"===e.parent.type){var t=e.parent.children.indexOf(e);-1!==t&&n.push(t)}return n}function f(e){switch(e.type){case"array":return e.children.map(f);case"object":for(var n=Object.create(null),r=0,t=e.children;r<t.length;r++){var o=t[r],i=o.children[1];i&&(n[o.children[0].value]=f(i))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return void 0}}function c(e,n,r){return void 0===r&&(r=!1),n>=e.offset&&n<e.offset+e.length||r&&n===e.offset+e.length}function u(e,n,r){if(void 0===r&&(r=!1),c(e,n,r)){var t=e.children;if(Array.isArray(t))for(var o=0;o<t.length&&t[o].offset<=n;o++){var i=u(t[o],n,r);if(i)return i}return e}return void 0}function l(e,n,r){function t(e){return e?function(){return e(g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function o(e){return e?function(n){return e(n,g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function i(){for(;;){var e=g.scan();switch(g.getTokenError()){case 4:a(14);break;case 5:a(15);break;case 3:a(13);break;case 1:m||a(11);break;case 2:a(12);break;case 6:a(16)}switch(e){case 12:case 13:m?a(10):w();break;case 16:a(1);break;case 15:case 14:break;default:return e}}}function a(e,n,r){if(void 0===n&&(n=[]),void 0===r&&(r=[]),j(e),n.length+r.length>0)for(var t=g.getToken();17!==t;){if(-1!==n.indexOf(t)){i();break}if(-1!==r.indexOf(t))break;t=i()}}function f(e){var n=g.getTokenValue();return e?A(n):y(n),i(),!0}function c(){switch(g.getToken()){case 11:var e=0;try{e=JSON.parse(g.getTokenValue()),"number"!=typeof e&&(a(2),e=0)}catch(n){a(2)}A(e);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return i(),!0}function u(){return 10!==g.getToken()?(a(3,[],[2,5]),!1):(f(!1),6===g.getToken()?(O(":"),i(),h()||a(4,[],[2,5])):a(5,[],[2,5]),!0)}function l(){v(),i();for(var e=!1;2!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),2===g.getToken()&&E)break}else e&&a(6,[],[]);u()||a(4,[],[2,5]),e=!0}return b(),2!==g.getToken()?a(7,[2],[]):i(),!0}function s(){k(),i();for(var e=!1;4!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),4===g.getToken()&&E)break}else e&&a(6,[],[]);h()||a(4,[],[4,5]),e=!0}return T(),4!==g.getToken()?a(8,[4],[]):i(),!0}function h(){switch(g.getToken()){case 3:return s();case 1:return l();case 10:return f(!0);default:return c()}}void 0===r&&(r=p.DEFAULT);var g=d.createScanner(e,!1),v=t(n.onObjectBegin),y=o(n.onObjectProperty),b=t(n.onObjectEnd),k=t(n.onArrayBegin),T=t(n.onArrayEnd),A=o(n.onLiteralValue),O=o(n.onSeparator),w=t(n.onComment),j=o(n.onError),m=r&&r.disallowComments,E=r&&r.allowTrailingComma;return i(),17===g.getToken()?!0:h()?(17!==g.getToken()&&a(9,[],[]),!0):(a(4,[],[]),!1)}function s(e,n){var r,t,o=d.createScanner(e),i=[],a=0;do switch(t=o.getPosition(),r=o.scan()){case 12:case 13:case 17:a!==t&&i.push(e.substring(a,t)),void 0!==n&&i.push(o.getTokenValue().replace(/[^\r\n]/g,n)),a=o.getPosition()}while(17!==r);return i.join("")}function h(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";default:return"null"}}Object.defineProperty(n,"__esModule",{value:!0});var p,d=e("aedc3c9");!function(e){e.DEFAULT={allowTrailingComma:!1}}(p||(p={})),n.getLocation=r,n.parse=t,n.parseTree=o,n.findNodeAtLocation=i,n.getNodePath=a,n.getNodeValue=f,n.contains=c,n.findNodeAtOffset=u,n.visit=l,n.stripComments=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/scanner.js*/
define("aedc3c9",function(e,r){"use strict";function t(e,r){function t(r,t){for(var n=0,a=0;r>n||!t;){var c=e.charCodeAt(d);if(c>=48&&57>=c)a=16*a+c-48;else if(c>=65&&70>=c)a=16*a+c-65+10;else{if(!(c>=97&&102>=c))break;a=16*a+c-97+10}d++,n++}return r>n&&(a=-1),a}function o(e){d=e,g="",b=0,l=16,A=0}function s(){var r=d;if(48===e.charCodeAt(d))d++;else for(d++;d<e.length&&c(e.charCodeAt(d));)d++;if(d<e.length&&46===e.charCodeAt(d)){if(d++,!(d<e.length&&c(e.charCodeAt(d))))return A=3,e.substring(r,d);for(d++;d<e.length&&c(e.charCodeAt(d));)d++}var t=d;if(d<e.length&&(69===e.charCodeAt(d)||101===e.charCodeAt(d)))if(d++,(d<e.length&&43===e.charCodeAt(d)||45===e.charCodeAt(d))&&d++,d<e.length&&c(e.charCodeAt(d))){for(d++;d<e.length&&c(e.charCodeAt(d));)d++;t=d}else A=3;return e.substring(r,t)}function u(){for(var r="",n=d;;){if(d>=C){r+=e.substring(n,d),A=2;break}var c=e.charCodeAt(d);if(34===c){r+=e.substring(n,d),d++;break}if(92!==c){if(c>=0&&31>=c){if(a(c)){r+=e.substring(n,d),A=2;break}A=6}d++}else{if(r+=e.substring(n,d),d++,d>=C){A=2;break}switch(c=e.charCodeAt(d++)){case 34:r+='"';break;case 92:r+="\\";break;case 47:r+="/";break;case 98:r+="\b";break;case 102:r+="\f";break;case 110:r+="\n";break;case 114:r+="\r";break;case 116:r+="	";break;case 117:var o=t(4,!0);o>=0?r+=String.fromCharCode(o):A=4;break;default:A=5}n=d}}return r}function i(){if(g="",A=0,b=d,d>=C)return b=C,l=17;var r=e.charCodeAt(d);if(n(r)){do d++,g+=String.fromCharCode(r),r=e.charCodeAt(d);while(n(r));return l=15}if(a(r))return d++,g+=String.fromCharCode(r),13===r&&10===e.charCodeAt(d)&&(d++,g+="\n"),l=14;switch(r){case 123:return d++,l=1;case 125:return d++,l=2;case 91:return d++,l=3;case 93:return d++,l=4;case 58:return d++,l=6;case 44:return d++,l=5;case 34:return d++,g=u(),l=10;case 47:var t=d-1;if(47===e.charCodeAt(d+1)){for(d+=2;C>d&&!a(e.charCodeAt(d));)d++;return g=e.substring(t,d),l=12}if(42===e.charCodeAt(d+1)){d+=2;for(var o=C-1,i=!1;o>d;){var h=e.charCodeAt(d);if(42===h&&47===e.charCodeAt(d+1)){d+=2,i=!0;break}d++}return i||(d++,A=1),g=e.substring(t,d),l=13}return g+=String.fromCharCode(r),d++,l=16;case 45:if(g+=String.fromCharCode(r),d++,d===C||!c(e.charCodeAt(d)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=s(),l=11;default:for(;C>d&&f(r);)d++,r=e.charCodeAt(d);if(b!==d){switch(g=e.substring(b,d)){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return g+=String.fromCharCode(r),d++,l=16}}function f(e){if(n(e)||a(e))return!1;switch(e){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function h(){var e;do e=i();while(e>=12&&15>=e);return e}void 0===r&&(r=!1);var d=0,C=e.length,g="",b=0,l=16,A=0;return{setPosition:o,getPosition:function(){return d},scan:r?h:i,getToken:function(){return l},getTokenValue:function(){return g},getTokenOffset:function(){return b},getTokenLength:function(){return d-b},getTokenError:function(){return A}}}function n(e){return 32===e||9===e||11===e||12===e||160===e||5760===e||e>=8192&&8203>=e||8239===e||8287===e||12288===e||65279===e}function a(e){return 10===e||13===e||8232===e||8233===e}function c(e){return e>=48&&57>=e}Object.defineProperty(r,"__esModule",{value:!0}),r.createScanner=t});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/edit.js*/
define("98ab305",function(e,t){"use strict";function n(e,t,n){return r(e,t,void 0,n)}function r(e,t,n,r,o){for(var i,l=t.slice(),s=[],c=h.parseTree(e,s),d=void 0,g=void 0;l.length>0&&(g=l.pop(),d=h.findNodeAtLocation(c,l),void 0===d&&void 0!==n);)"string"==typeof g?(i={},i[g]=n,n=i):n=[n];if(d){if("object"===d.type&&"string"==typeof g&&Array.isArray(d.children)){var a=h.findNodeAtLocation(d,[g]);if(void 0!==a){if(void 0===n){if(!a.parent)throw new Error("Malformed AST");var v=d.children.indexOf(a.parent),u=void 0,p=a.parent.offset+a.parent.length;if(v>0){var y=d.children[v-1];u=y.offset+y.length}else if(u=d.offset+1,d.children.length>1){var m=d.children[1];p=m.offset}return f(e,{offset:u,length:p-u,content:""},r)}return f(e,{offset:a.offset,length:a.length,content:JSON.stringify(n)},r)}if(void 0===n)return[];var O=JSON.stringify(g)+": "+JSON.stringify(n),b=o?o(d.children.map(function(e){return e.children[0].value})):d.children.length,A=void 0;if(b>0){var y=d.children[b-1];A={offset:y.offset+y.length,length:0,content:","+O}}else A=0===d.children.length?{offset:d.offset+1,length:0,content:O}:{offset:d.offset+1,length:0,content:O+","};return f(e,A,r)}if("array"===d.type&&"number"==typeof g&&Array.isArray(d.children)){var w=g;if(-1===w){var O=""+JSON.stringify(n),A=void 0;if(0===d.children.length)A={offset:d.offset+1,length:0,content:O};else{var y=d.children[d.children.length-1];A={offset:y.offset+y.length,length:0,content:","+O}}return f(e,A,r)}if(void 0===n&&d.children.length>=0){var E=g,N=d.children[E],A=void 0;if(1===d.children.length)A={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===E){var y=d.children[E-1],S=y.offset+y.length,J=d.offset+d.length;A={offset:S,length:J-2-S,content:""}}else A={offset:N.offset,length:d.children[E+1].offset-N.offset,content:""};return f(e,A,r)}throw new Error("Array modification not supported yet")}throw new Error("Can not add "+("number"!=typeof g?"index":"property")+" to parent of type "+d.type)}if(void 0===n)throw new Error("Can not delete in empty document");return f(e,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(n)},r)}function f(e,t,n){var r=o(e,t),f=t.offset,i=t.offset+t.content.length;if(0===t.length||0===t.content.length){for(;f>0&&!l.isEOL(r,f-1);)f--;for(;i<r.length&&!l.isEOL(r,i);)i++}for(var h=l.format(r,{offset:f,length:i-f},n),s=h.length-1;s>=0;s--){var c=h[s];r=o(r,c),f=Math.min(f,c.offset),i=Math.max(i,c.offset+c.length),i+=c.content.length-c.length}var d=e.length-(r.length-i)-f;return[{offset:f,length:d,content:r.substring(f,i)}]}function o(e,t){return e.substring(0,t.offset)+t.content+e.substring(t.offset+t.length)}function i(e,t){return-1!=="\r\n 	".indexOf(e.charAt(t))}Object.defineProperty(t,"__esModule",{value:!0});var l=e("86b561e"),h=e("38cea32");t.removeProperty=n,t.setProperty=r,t.applyEdit=o,t.isWS=i});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/format.js*/
define("86b561e",function(e,r){"use strict";function n(e,r,n){function o(){return T+t(O,g+A)}function i(){var e=S.scan();for(d=!1;15===e||14===e;)d=d||14===e,e=S.scan();return p=16===e||0!==S.getTokenError(),e}function u(r,n,t){!p&&l>n&&t>k&&e.substring(n,t)!==r&&L.push({offset:n,length:t-n,content:r})}var g,h,v,k,l;if(r){for(k=r.offset,l=k+r.length,v=k;v>0&&!s(e,v-1);)v--;for(var b=l;b<e.length&&!s(e,b);)b++;h=e.substring(v,b),g=a(h,n)}else h=e,g=0,v=0,k=0,l=e.length;var O,T=f(n,e),d=!1,A=0;O=n.insertSpaces?t(" ",n.tabSize||4):"	";var S=c.createScanner(h,!1),p=!1,L=[],m=i();if(17!==m){var z=S.getTokenOffset()+v,E=t(O,g);u(E,v,z)}for(;17!==m;){for(var M=S.getTokenOffset()+S.getTokenLength()+v,_=i(),j="";!d&&(12===_||13===_);){var w=S.getTokenOffset()+v;u(" ",M,w),M=S.getTokenOffset()+S.getTokenLength()+v,j=12===_?o():"",_=i()}if(2===_)1!==m&&(A--,j=o());else if(4===_)3!==m&&(A--,j=o());else{switch(m){case 3:case 1:A++,j=o();break;case 5:case 12:j=o();break;case 13:j=d?o():" ";break;case 6:j=" ";break;case 10:if(6===_){j="";break}case 7:case 8:case 9:case 11:case 2:case 4:12===_||13===_?j=" ":5!==_&&17!==_&&(p=!0);break;case 16:p=!0}!d||12!==_&&13!==_||(j=o())}var x=S.getTokenOffset()+v;u(j,M,x),m=_}return L}function t(e,r){for(var n="",t=0;r>t;t++)n+=e;return n}function a(e,r){for(var n=0,t=0,a=r.tabSize||4;n<e.length;){var f=e.charAt(n);if(" "===f)t++;else{if("	"!==f)break;t+=a}n++}return Math.floor(t/a)}function f(e,r){for(var n=0;n<r.length;n++){var t=r.charAt(n);if("\r"===t)return n+1<r.length&&"\n"===r.charAt(n+1)?"\r\n":"\r";if("\n"===t)return"\n"}return e&&e.eol||"\n"}function s(e,r){return-1!=="\r\n".indexOf(e.charAt(r))}Object.defineProperty(r,"__esModule",{value:!0});var c=e("aedc3c9");r.format=n,r.isEOL=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/parser.js*/
define("38cea32",function(e,n){"use strict";function r(e,n){function r(e,n,r,t){a.value=e,a.offset=n,a.length=r,a.type=t,a.colonOffset=void 0,i=a}var t=[],o=new Object,i=void 0,a={value:{},offset:0,length:0,type:"object",parent:void 0},f=!1;try{l(e,{onObjectBegin:function(e){if(e>=n)throw o;i=void 0,f=n>e,t.push("")},onObjectProperty:function(e,i,a){if(i>n)throw o;if(r(e,i,a,"property"),t[t.length-1]=e,i+a>=n)throw o},onObjectEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onArrayBegin:function(e){if(e>=n)throw o;i=void 0,t.push(0)},onArrayEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onLiteralValue:function(e,t,i){if(t>n)throw o;if(r(e,t,i,h(e)),t+i>=n)throw o},onSeparator:function(e,r){if(r>=n)throw o;if(":"===e&&i&&"property"===i.type)i.colonOffset=r,f=!1,i=void 0;else if(","===e){var a=t[t.length-1];"number"==typeof a?t[t.length-1]=a+1:(f=!0,t[t.length-1]=""),i=void 0}}})}catch(c){if(c!==o)throw c}return{path:t,previousNode:i,isAtPropertyKey:f,matches:function(e){for(var n=0,r=0;n<e.length&&r<t.length;r++)if(e[n]===t[r]||"*"===e[n])n++;else if("**"!==e[n])return!1;return n===e.length}}}function t(e,n,r){function t(e){Array.isArray(i)?i.push(e):o&&(i[o]=e)}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var o=null,i=[],a=[],f={onObjectBegin:function(){var e={};t(e),a.push(i),i=e,o=null},onObjectProperty:function(e){o=e},onObjectEnd:function(){i=a.pop()},onArrayBegin:function(){var e=[];t(e),a.push(i),i=e,o=null},onArrayEnd:function(){i=a.pop()},onLiteralValue:t,onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};return l(e,f,r),i[0]}function o(e,n,r){function t(e){"property"===i.type&&(i.length=e-i.offset,i=i.parent)}function o(e){return i.children.push(e),e}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var i={type:"array",offset:-1,length:-1,children:[],parent:void 0},a={onObjectBegin:function(e){i=o({type:"object",offset:e,length:-1,parent:i,children:[]})},onObjectProperty:function(e,n,r){i=o({type:"property",offset:n,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:e,offset:n,length:r,parent:i})},onObjectEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onArrayBegin:function(e){i=o({type:"array",offset:e,length:-1,parent:i,children:[]})},onArrayEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onLiteralValue:function(e,n,r){o({type:h(e),offset:n,length:r,parent:i,value:e}),t(n+r)},onSeparator:function(e,n){"property"===i.type&&(":"===e?i.colonOffset=n:","===e&&t(n))},onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};l(e,a,r);var f=i.children[0];return f&&delete f.parent,f}function i(e,n){if(!e)return void 0;for(var r=e,t=0,o=n;t<o.length;t++){var i=o[t];if("string"==typeof i){if("object"!==r.type||!Array.isArray(r.children))return void 0;for(var a=!1,f=0,c=r.children;f<c.length;f++){var u=c[f];if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],a=!0;break}}if(!a)return void 0}else{var l=i;if("array"!==r.type||0>l||!Array.isArray(r.children)||l>=r.children.length)return void 0;r=r.children[l]}}return r}function a(e){if(!e.parent||!e.parent.children)return[];var n=a(e.parent);if("property"===e.parent.type){var r=e.parent.children[0].value;n.push(r)}else if("array"===e.parent.type){var t=e.parent.children.indexOf(e);-1!==t&&n.push(t)}return n}function f(e){switch(e.type){case"array":return e.children.map(f);case"object":for(var n=Object.create(null),r=0,t=e.children;r<t.length;r++){var o=t[r],i=o.children[1];i&&(n[o.children[0].value]=f(i))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return void 0}}function c(e,n,r){return void 0===r&&(r=!1),n>=e.offset&&n<e.offset+e.length||r&&n===e.offset+e.length}function u(e,n,r){if(void 0===r&&(r=!1),c(e,n,r)){var t=e.children;if(Array.isArray(t))for(var o=0;o<t.length&&t[o].offset<=n;o++){var i=u(t[o],n,r);if(i)return i}return e}return void 0}function l(e,n,r){function t(e){return e?function(){return e(g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function o(e){return e?function(n){return e(n,g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function i(){for(;;){var e=g.scan();switch(g.getTokenError()){case 4:a(14);break;case 5:a(15);break;case 3:a(13);break;case 1:m||a(11);break;case 2:a(12);break;case 6:a(16)}switch(e){case 12:case 13:m?a(10):w();break;case 16:a(1);break;case 15:case 14:break;default:return e}}}function a(e,n,r){if(void 0===n&&(n=[]),void 0===r&&(r=[]),j(e),n.length+r.length>0)for(var t=g.getToken();17!==t;){if(-1!==n.indexOf(t)){i();break}if(-1!==r.indexOf(t))break;t=i()}}function f(e){var n=g.getTokenValue();return e?A(n):y(n),i(),!0}function c(){switch(g.getToken()){case 11:var e=0;try{e=JSON.parse(g.getTokenValue()),"number"!=typeof e&&(a(2),e=0)}catch(n){a(2)}A(e);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return i(),!0}function u(){return 10!==g.getToken()?(a(3,[],[2,5]),!1):(f(!1),6===g.getToken()?(O(":"),i(),h()||a(4,[],[2,5])):a(5,[],[2,5]),!0)}function l(){v(),i();for(var e=!1;2!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),2===g.getToken()&&E)break}else e&&a(6,[],[]);u()||a(4,[],[2,5]),e=!0}return b(),2!==g.getToken()?a(7,[2],[]):i(),!0}function s(){k(),i();for(var e=!1;4!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),4===g.getToken()&&E)break}else e&&a(6,[],[]);h()||a(4,[],[4,5]),e=!0}return T(),4!==g.getToken()?a(8,[4],[]):i(),!0}function h(){switch(g.getToken()){case 3:return s();case 1:return l();case 10:return f(!0);default:return c()}}void 0===r&&(r=p.DEFAULT);var g=d.createScanner(e,!1),v=t(n.onObjectBegin),y=o(n.onObjectProperty),b=t(n.onObjectEnd),k=t(n.onArrayBegin),T=t(n.onArrayEnd),A=o(n.onLiteralValue),O=o(n.onSeparator),w=t(n.onComment),j=o(n.onError),m=r&&r.disallowComments,E=r&&r.allowTrailingComma;return i(),17===g.getToken()?!0:h()?(17!==g.getToken()&&a(9,[],[]),!0):(a(4,[],[]),!1)}function s(e,n){var r,t,o=d.createScanner(e),i=[],a=0;do switch(t=o.getPosition(),r=o.scan()){case 12:case 13:case 17:a!==t&&i.push(e.substring(a,t)),void 0!==n&&i.push(o.getTokenValue().replace(/[^\r\n]/g,n)),a=o.getPosition()}while(17!==r);return i.join("")}function h(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";default:return"null"}}Object.defineProperty(n,"__esModule",{value:!0});var p,d=e("aedc3c9");!function(e){e.DEFAULT={allowTrailingComma:!1}}(p||(p={})),n.getLocation=r,n.parse=t,n.parseTree=o,n.findNodeAtLocation=i,n.getNodePath=a,n.getNodeValue=f,n.contains=c,n.findNodeAtOffset=u,n.visit=l,n.stripComments=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/scanner.js*/
define("aedc3c9",function(e,r){"use strict";function t(e,r){function t(r,t){for(var n=0,a=0;r>n||!t;){var c=e.charCodeAt(d);if(c>=48&&57>=c)a=16*a+c-48;else if(c>=65&&70>=c)a=16*a+c-65+10;else{if(!(c>=97&&102>=c))break;a=16*a+c-97+10}d++,n++}return r>n&&(a=-1),a}function o(e){d=e,g="",b=0,l=16,A=0}function s(){var r=d;if(48===e.charCodeAt(d))d++;else for(d++;d<e.length&&c(e.charCodeAt(d));)d++;if(d<e.length&&46===e.charCodeAt(d)){if(d++,!(d<e.length&&c(e.charCodeAt(d))))return A=3,e.substring(r,d);for(d++;d<e.length&&c(e.charCodeAt(d));)d++}var t=d;if(d<e.length&&(69===e.charCodeAt(d)||101===e.charCodeAt(d)))if(d++,(d<e.length&&43===e.charCodeAt(d)||45===e.charCodeAt(d))&&d++,d<e.length&&c(e.charCodeAt(d))){for(d++;d<e.length&&c(e.charCodeAt(d));)d++;t=d}else A=3;return e.substring(r,t)}function u(){for(var r="",n=d;;){if(d>=C){r+=e.substring(n,d),A=2;break}var c=e.charCodeAt(d);if(34===c){r+=e.substring(n,d),d++;break}if(92!==c){if(c>=0&&31>=c){if(a(c)){r+=e.substring(n,d),A=2;break}A=6}d++}else{if(r+=e.substring(n,d),d++,d>=C){A=2;break}switch(c=e.charCodeAt(d++)){case 34:r+='"';break;case 92:r+="\\";break;case 47:r+="/";break;case 98:r+="\b";break;case 102:r+="\f";break;case 110:r+="\n";break;case 114:r+="\r";break;case 116:r+="	";break;case 117:var o=t(4,!0);o>=0?r+=String.fromCharCode(o):A=4;break;default:A=5}n=d}}return r}function i(){if(g="",A=0,b=d,d>=C)return b=C,l=17;var r=e.charCodeAt(d);if(n(r)){do d++,g+=String.fromCharCode(r),r=e.charCodeAt(d);while(n(r));return l=15}if(a(r))return d++,g+=String.fromCharCode(r),13===r&&10===e.charCodeAt(d)&&(d++,g+="\n"),l=14;switch(r){case 123:return d++,l=1;case 125:return d++,l=2;case 91:return d++,l=3;case 93:return d++,l=4;case 58:return d++,l=6;case 44:return d++,l=5;case 34:return d++,g=u(),l=10;case 47:var t=d-1;if(47===e.charCodeAt(d+1)){for(d+=2;C>d&&!a(e.charCodeAt(d));)d++;return g=e.substring(t,d),l=12}if(42===e.charCodeAt(d+1)){d+=2;for(var o=C-1,i=!1;o>d;){var h=e.charCodeAt(d);if(42===h&&47===e.charCodeAt(d+1)){d+=2,i=!0;break}d++}return i||(d++,A=1),g=e.substring(t,d),l=13}return g+=String.fromCharCode(r),d++,l=16;case 45:if(g+=String.fromCharCode(r),d++,d===C||!c(e.charCodeAt(d)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=s(),l=11;default:for(;C>d&&f(r);)d++,r=e.charCodeAt(d);if(b!==d){switch(g=e.substring(b,d)){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return g+=String.fromCharCode(r),d++,l=16}}function f(e){if(n(e)||a(e))return!1;switch(e){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function h(){var e;do e=i();while(e>=12&&15>=e);return e}void 0===r&&(r=!1);var d=0,C=e.length,g="",b=0,l=16,A=0;return{setPosition:o,getPosition:function(){return d},scan:r?h:i,getToken:function(){return l},getTokenValue:function(){return g},getTokenOffset:function(){return b},getTokenLength:function(){return d-b},getTokenError:function(){return A}}}function n(e){return 32===e||9===e||11===e||12===e||160===e||5760===e||e>=8192&&8203>=e||8239===e||8287===e||12288===e||65279===e}function a(e){return 10===e||13===e||8232===e||8233===e}function c(e){return e>=48&&57>=e}Object.defineProperty(r,"__esModule",{value:!0}),r.createScanner=t});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/edit.js*/
define("98ab305",function(e,t){"use strict";function n(e,t,n){return r(e,t,void 0,n)}function r(e,t,n,r,o){for(var i,l=t.slice(),s=[],c=h.parseTree(e,s),d=void 0,g=void 0;l.length>0&&(g=l.pop(),d=h.findNodeAtLocation(c,l),void 0===d&&void 0!==n);)"string"==typeof g?(i={},i[g]=n,n=i):n=[n];if(d){if("object"===d.type&&"string"==typeof g&&Array.isArray(d.children)){var a=h.findNodeAtLocation(d,[g]);if(void 0!==a){if(void 0===n){if(!a.parent)throw new Error("Malformed AST");var v=d.children.indexOf(a.parent),u=void 0,p=a.parent.offset+a.parent.length;if(v>0){var y=d.children[v-1];u=y.offset+y.length}else if(u=d.offset+1,d.children.length>1){var m=d.children[1];p=m.offset}return f(e,{offset:u,length:p-u,content:""},r)}return f(e,{offset:a.offset,length:a.length,content:JSON.stringify(n)},r)}if(void 0===n)return[];var O=JSON.stringify(g)+": "+JSON.stringify(n),b=o?o(d.children.map(function(e){return e.children[0].value})):d.children.length,A=void 0;if(b>0){var y=d.children[b-1];A={offset:y.offset+y.length,length:0,content:","+O}}else A=0===d.children.length?{offset:d.offset+1,length:0,content:O}:{offset:d.offset+1,length:0,content:O+","};return f(e,A,r)}if("array"===d.type&&"number"==typeof g&&Array.isArray(d.children)){var w=g;if(-1===w){var O=""+JSON.stringify(n),A=void 0;if(0===d.children.length)A={offset:d.offset+1,length:0,content:O};else{var y=d.children[d.children.length-1];A={offset:y.offset+y.length,length:0,content:","+O}}return f(e,A,r)}if(void 0===n&&d.children.length>=0){var E=g,N=d.children[E],A=void 0;if(1===d.children.length)A={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===E){var y=d.children[E-1],S=y.offset+y.length,J=d.offset+d.length;A={offset:S,length:J-2-S,content:""}}else A={offset:N.offset,length:d.children[E+1].offset-N.offset,content:""};return f(e,A,r)}throw new Error("Array modification not supported yet")}throw new Error("Can not add "+("number"!=typeof g?"index":"property")+" to parent of type "+d.type)}if(void 0===n)throw new Error("Can not delete in empty document");return f(e,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(n)},r)}function f(e,t,n){var r=o(e,t),f=t.offset,i=t.offset+t.content.length;if(0===t.length||0===t.content.length){for(;f>0&&!l.isEOL(r,f-1);)f--;for(;i<r.length&&!l.isEOL(r,i);)i++}for(var h=l.format(r,{offset:f,length:i-f},n),s=h.length-1;s>=0;s--){var c=h[s];r=o(r,c),f=Math.min(f,c.offset),i=Math.max(i,c.offset+c.length),i+=c.content.length-c.length}var d=e.length-(r.length-i)-f;return[{offset:f,length:d,content:r.substring(f,i)}]}function o(e,t){return e.substring(0,t.offset)+t.content+e.substring(t.offset+t.length)}function i(e,t){return-1!=="\r\n 	".indexOf(e.charAt(t))}Object.defineProperty(t,"__esModule",{value:!0});var l=e("86b561e"),h=e("38cea32");t.removeProperty=n,t.setProperty=r,t.applyEdit=o,t.isWS=i});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/format.js*/
define("86b561e",function(e,r){"use strict";function n(e,r,n){function o(){return T+t(O,g+A)}function i(){var e=S.scan();for(d=!1;15===e||14===e;)d=d||14===e,e=S.scan();return p=16===e||0!==S.getTokenError(),e}function u(r,n,t){!p&&l>n&&t>k&&e.substring(n,t)!==r&&L.push({offset:n,length:t-n,content:r})}var g,h,v,k,l;if(r){for(k=r.offset,l=k+r.length,v=k;v>0&&!s(e,v-1);)v--;for(var b=l;b<e.length&&!s(e,b);)b++;h=e.substring(v,b),g=a(h,n)}else h=e,g=0,v=0,k=0,l=e.length;var O,T=f(n,e),d=!1,A=0;O=n.insertSpaces?t(" ",n.tabSize||4):"	";var S=c.createScanner(h,!1),p=!1,L=[],m=i();if(17!==m){var z=S.getTokenOffset()+v,E=t(O,g);u(E,v,z)}for(;17!==m;){for(var M=S.getTokenOffset()+S.getTokenLength()+v,_=i(),j="";!d&&(12===_||13===_);){var w=S.getTokenOffset()+v;u(" ",M,w),M=S.getTokenOffset()+S.getTokenLength()+v,j=12===_?o():"",_=i()}if(2===_)1!==m&&(A--,j=o());else if(4===_)3!==m&&(A--,j=o());else{switch(m){case 3:case 1:A++,j=o();break;case 5:case 12:j=o();break;case 13:j=d?o():" ";break;case 6:j=" ";break;case 10:if(6===_){j="";break}case 7:case 8:case 9:case 11:case 2:case 4:12===_||13===_?j=" ":5!==_&&17!==_&&(p=!0);break;case 16:p=!0}!d||12!==_&&13!==_||(j=o())}var x=S.getTokenOffset()+v;u(j,M,x),m=_}return L}function t(e,r){for(var n="",t=0;r>t;t++)n+=e;return n}function a(e,r){for(var n=0,t=0,a=r.tabSize||4;n<e.length;){var f=e.charAt(n);if(" "===f)t++;else{if("	"!==f)break;t+=a}n++}return Math.floor(t/a)}function f(e,r){for(var n=0;n<r.length;n++){var t=r.charAt(n);if("\r"===t)return n+1<r.length&&"\n"===r.charAt(n+1)?"\r\n":"\r";if("\n"===t)return"\n"}return e&&e.eol||"\n"}function s(e,r){return-1!=="\r\n".indexOf(e.charAt(r))}Object.defineProperty(r,"__esModule",{value:!0});var c=e("aedc3c9");r.format=n,r.isEOL=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/parser.js*/
define("38cea32",function(e,n){"use strict";function r(e,n){function r(e,n,r,t){a.value=e,a.offset=n,a.length=r,a.type=t,a.colonOffset=void 0,i=a}var t=[],o=new Object,i=void 0,a={value:{},offset:0,length:0,type:"object",parent:void 0},f=!1;try{l(e,{onObjectBegin:function(e){if(e>=n)throw o;i=void 0,f=n>e,t.push("")},onObjectProperty:function(e,i,a){if(i>n)throw o;if(r(e,i,a,"property"),t[t.length-1]=e,i+a>=n)throw o},onObjectEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onArrayBegin:function(e){if(e>=n)throw o;i=void 0,t.push(0)},onArrayEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onLiteralValue:function(e,t,i){if(t>n)throw o;if(r(e,t,i,h(e)),t+i>=n)throw o},onSeparator:function(e,r){if(r>=n)throw o;if(":"===e&&i&&"property"===i.type)i.colonOffset=r,f=!1,i=void 0;else if(","===e){var a=t[t.length-1];"number"==typeof a?t[t.length-1]=a+1:(f=!0,t[t.length-1]=""),i=void 0}}})}catch(c){if(c!==o)throw c}return{path:t,previousNode:i,isAtPropertyKey:f,matches:function(e){for(var n=0,r=0;n<e.length&&r<t.length;r++)if(e[n]===t[r]||"*"===e[n])n++;else if("**"!==e[n])return!1;return n===e.length}}}function t(e,n,r){function t(e){Array.isArray(i)?i.push(e):o&&(i[o]=e)}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var o=null,i=[],a=[],f={onObjectBegin:function(){var e={};t(e),a.push(i),i=e,o=null},onObjectProperty:function(e){o=e},onObjectEnd:function(){i=a.pop()},onArrayBegin:function(){var e=[];t(e),a.push(i),i=e,o=null},onArrayEnd:function(){i=a.pop()},onLiteralValue:t,onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};return l(e,f,r),i[0]}function o(e,n,r){function t(e){"property"===i.type&&(i.length=e-i.offset,i=i.parent)}function o(e){return i.children.push(e),e}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var i={type:"array",offset:-1,length:-1,children:[],parent:void 0},a={onObjectBegin:function(e){i=o({type:"object",offset:e,length:-1,parent:i,children:[]})},onObjectProperty:function(e,n,r){i=o({type:"property",offset:n,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:e,offset:n,length:r,parent:i})},onObjectEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onArrayBegin:function(e){i=o({type:"array",offset:e,length:-1,parent:i,children:[]})},onArrayEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onLiteralValue:function(e,n,r){o({type:h(e),offset:n,length:r,parent:i,value:e}),t(n+r)},onSeparator:function(e,n){"property"===i.type&&(":"===e?i.colonOffset=n:","===e&&t(n))},onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};l(e,a,r);var f=i.children[0];return f&&delete f.parent,f}function i(e,n){if(!e)return void 0;for(var r=e,t=0,o=n;t<o.length;t++){var i=o[t];if("string"==typeof i){if("object"!==r.type||!Array.isArray(r.children))return void 0;for(var a=!1,f=0,c=r.children;f<c.length;f++){var u=c[f];if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],a=!0;break}}if(!a)return void 0}else{var l=i;if("array"!==r.type||0>l||!Array.isArray(r.children)||l>=r.children.length)return void 0;r=r.children[l]}}return r}function a(e){if(!e.parent||!e.parent.children)return[];var n=a(e.parent);if("property"===e.parent.type){var r=e.parent.children[0].value;n.push(r)}else if("array"===e.parent.type){var t=e.parent.children.indexOf(e);-1!==t&&n.push(t)}return n}function f(e){switch(e.type){case"array":return e.children.map(f);case"object":for(var n=Object.create(null),r=0,t=e.children;r<t.length;r++){var o=t[r],i=o.children[1];i&&(n[o.children[0].value]=f(i))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return void 0}}function c(e,n,r){return void 0===r&&(r=!1),n>=e.offset&&n<e.offset+e.length||r&&n===e.offset+e.length}function u(e,n,r){if(void 0===r&&(r=!1),c(e,n,r)){var t=e.children;if(Array.isArray(t))for(var o=0;o<t.length&&t[o].offset<=n;o++){var i=u(t[o],n,r);if(i)return i}return e}return void 0}function l(e,n,r){function t(e){return e?function(){return e(g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function o(e){return e?function(n){return e(n,g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function i(){for(;;){var e=g.scan();switch(g.getTokenError()){case 4:a(14);break;case 5:a(15);break;case 3:a(13);break;case 1:m||a(11);break;case 2:a(12);break;case 6:a(16)}switch(e){case 12:case 13:m?a(10):w();break;case 16:a(1);break;case 15:case 14:break;default:return e}}}function a(e,n,r){if(void 0===n&&(n=[]),void 0===r&&(r=[]),j(e),n.length+r.length>0)for(var t=g.getToken();17!==t;){if(-1!==n.indexOf(t)){i();break}if(-1!==r.indexOf(t))break;t=i()}}function f(e){var n=g.getTokenValue();return e?A(n):y(n),i(),!0}function c(){switch(g.getToken()){case 11:var e=0;try{e=JSON.parse(g.getTokenValue()),"number"!=typeof e&&(a(2),e=0)}catch(n){a(2)}A(e);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return i(),!0}function u(){return 10!==g.getToken()?(a(3,[],[2,5]),!1):(f(!1),6===g.getToken()?(O(":"),i(),h()||a(4,[],[2,5])):a(5,[],[2,5]),!0)}function l(){v(),i();for(var e=!1;2!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),2===g.getToken()&&E)break}else e&&a(6,[],[]);u()||a(4,[],[2,5]),e=!0}return b(),2!==g.getToken()?a(7,[2],[]):i(),!0}function s(){k(),i();for(var e=!1;4!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),4===g.getToken()&&E)break}else e&&a(6,[],[]);h()||a(4,[],[4,5]),e=!0}return T(),4!==g.getToken()?a(8,[4],[]):i(),!0}function h(){switch(g.getToken()){case 3:return s();case 1:return l();case 10:return f(!0);default:return c()}}void 0===r&&(r=p.DEFAULT);var g=d.createScanner(e,!1),v=t(n.onObjectBegin),y=o(n.onObjectProperty),b=t(n.onObjectEnd),k=t(n.onArrayBegin),T=t(n.onArrayEnd),A=o(n.onLiteralValue),O=o(n.onSeparator),w=t(n.onComment),j=o(n.onError),m=r&&r.disallowComments,E=r&&r.allowTrailingComma;return i(),17===g.getToken()?!0:h()?(17!==g.getToken()&&a(9,[],[]),!0):(a(4,[],[]),!1)}function s(e,n){var r,t,o=d.createScanner(e),i=[],a=0;do switch(t=o.getPosition(),r=o.scan()){case 12:case 13:case 17:a!==t&&i.push(e.substring(a,t)),void 0!==n&&i.push(o.getTokenValue().replace(/[^\r\n]/g,n)),a=o.getPosition()}while(17!==r);return i.join("")}function h(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";default:return"null"}}Object.defineProperty(n,"__esModule",{value:!0});var p,d=e("aedc3c9");!function(e){e.DEFAULT={allowTrailingComma:!1}}(p||(p={})),n.getLocation=r,n.parse=t,n.parseTree=o,n.findNodeAtLocation=i,n.getNodePath=a,n.getNodeValue=f,n.contains=c,n.findNodeAtOffset=u,n.visit=l,n.stripComments=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/scanner.js*/
define("aedc3c9",function(e,r){"use strict";function t(e,r){function t(r,t){for(var n=0,a=0;r>n||!t;){var c=e.charCodeAt(d);if(c>=48&&57>=c)a=16*a+c-48;else if(c>=65&&70>=c)a=16*a+c-65+10;else{if(!(c>=97&&102>=c))break;a=16*a+c-97+10}d++,n++}return r>n&&(a=-1),a}function o(e){d=e,g="",b=0,l=16,A=0}function s(){var r=d;if(48===e.charCodeAt(d))d++;else for(d++;d<e.length&&c(e.charCodeAt(d));)d++;if(d<e.length&&46===e.charCodeAt(d)){if(d++,!(d<e.length&&c(e.charCodeAt(d))))return A=3,e.substring(r,d);for(d++;d<e.length&&c(e.charCodeAt(d));)d++}var t=d;if(d<e.length&&(69===e.charCodeAt(d)||101===e.charCodeAt(d)))if(d++,(d<e.length&&43===e.charCodeAt(d)||45===e.charCodeAt(d))&&d++,d<e.length&&c(e.charCodeAt(d))){for(d++;d<e.length&&c(e.charCodeAt(d));)d++;t=d}else A=3;return e.substring(r,t)}function u(){for(var r="",n=d;;){if(d>=C){r+=e.substring(n,d),A=2;break}var c=e.charCodeAt(d);if(34===c){r+=e.substring(n,d),d++;break}if(92!==c){if(c>=0&&31>=c){if(a(c)){r+=e.substring(n,d),A=2;break}A=6}d++}else{if(r+=e.substring(n,d),d++,d>=C){A=2;break}switch(c=e.charCodeAt(d++)){case 34:r+='"';break;case 92:r+="\\";break;case 47:r+="/";break;case 98:r+="\b";break;case 102:r+="\f";break;case 110:r+="\n";break;case 114:r+="\r";break;case 116:r+="	";break;case 117:var o=t(4,!0);o>=0?r+=String.fromCharCode(o):A=4;break;default:A=5}n=d}}return r}function i(){if(g="",A=0,b=d,d>=C)return b=C,l=17;var r=e.charCodeAt(d);if(n(r)){do d++,g+=String.fromCharCode(r),r=e.charCodeAt(d);while(n(r));return l=15}if(a(r))return d++,g+=String.fromCharCode(r),13===r&&10===e.charCodeAt(d)&&(d++,g+="\n"),l=14;switch(r){case 123:return d++,l=1;case 125:return d++,l=2;case 91:return d++,l=3;case 93:return d++,l=4;case 58:return d++,l=6;case 44:return d++,l=5;case 34:return d++,g=u(),l=10;case 47:var t=d-1;if(47===e.charCodeAt(d+1)){for(d+=2;C>d&&!a(e.charCodeAt(d));)d++;return g=e.substring(t,d),l=12}if(42===e.charCodeAt(d+1)){d+=2;for(var o=C-1,i=!1;o>d;){var h=e.charCodeAt(d);if(42===h&&47===e.charCodeAt(d+1)){d+=2,i=!0;break}d++}return i||(d++,A=1),g=e.substring(t,d),l=13}return g+=String.fromCharCode(r),d++,l=16;case 45:if(g+=String.fromCharCode(r),d++,d===C||!c(e.charCodeAt(d)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=s(),l=11;default:for(;C>d&&f(r);)d++,r=e.charCodeAt(d);if(b!==d){switch(g=e.substring(b,d)){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return g+=String.fromCharCode(r),d++,l=16}}function f(e){if(n(e)||a(e))return!1;switch(e){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function h(){var e;do e=i();while(e>=12&&15>=e);return e}void 0===r&&(r=!1);var d=0,C=e.length,g="",b=0,l=16,A=0;return{setPosition:o,getPosition:function(){return d},scan:r?h:i,getToken:function(){return l},getTokenValue:function(){return g},getTokenOffset:function(){return b},getTokenLength:function(){return d-b},getTokenError:function(){return A}}}function n(e){return 32===e||9===e||11===e||12===e||160===e||5760===e||e>=8192&&8203>=e||8239===e||8287===e||12288===e||65279===e}function a(e){return 10===e||13===e||8232===e||8233===e}function c(e){return e>=48&&57>=e}Object.defineProperty(r,"__esModule",{value:!0}),r.createScanner=t});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/edit.js*/
define("98ab305",function(e,t){"use strict";function n(e,t,n){return r(e,t,void 0,n)}function r(e,t,n,r,o){for(var i,l=t.slice(),s=[],c=h.parseTree(e,s),d=void 0,g=void 0;l.length>0&&(g=l.pop(),d=h.findNodeAtLocation(c,l),void 0===d&&void 0!==n);)"string"==typeof g?(i={},i[g]=n,n=i):n=[n];if(d){if("object"===d.type&&"string"==typeof g&&Array.isArray(d.children)){var a=h.findNodeAtLocation(d,[g]);if(void 0!==a){if(void 0===n){if(!a.parent)throw new Error("Malformed AST");var v=d.children.indexOf(a.parent),u=void 0,p=a.parent.offset+a.parent.length;if(v>0){var y=d.children[v-1];u=y.offset+y.length}else if(u=d.offset+1,d.children.length>1){var m=d.children[1];p=m.offset}return f(e,{offset:u,length:p-u,content:""},r)}return f(e,{offset:a.offset,length:a.length,content:JSON.stringify(n)},r)}if(void 0===n)return[];var O=JSON.stringify(g)+": "+JSON.stringify(n),b=o?o(d.children.map(function(e){return e.children[0].value})):d.children.length,A=void 0;if(b>0){var y=d.children[b-1];A={offset:y.offset+y.length,length:0,content:","+O}}else A=0===d.children.length?{offset:d.offset+1,length:0,content:O}:{offset:d.offset+1,length:0,content:O+","};return f(e,A,r)}if("array"===d.type&&"number"==typeof g&&Array.isArray(d.children)){var w=g;if(-1===w){var O=""+JSON.stringify(n),A=void 0;if(0===d.children.length)A={offset:d.offset+1,length:0,content:O};else{var y=d.children[d.children.length-1];A={offset:y.offset+y.length,length:0,content:","+O}}return f(e,A,r)}if(void 0===n&&d.children.length>=0){var E=g,N=d.children[E],A=void 0;if(1===d.children.length)A={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===E){var y=d.children[E-1],S=y.offset+y.length,J=d.offset+d.length;A={offset:S,length:J-2-S,content:""}}else A={offset:N.offset,length:d.children[E+1].offset-N.offset,content:""};return f(e,A,r)}throw new Error("Array modification not supported yet")}throw new Error("Can not add "+("number"!=typeof g?"index":"property")+" to parent of type "+d.type)}if(void 0===n)throw new Error("Can not delete in empty document");return f(e,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(n)},r)}function f(e,t,n){var r=o(e,t),f=t.offset,i=t.offset+t.content.length;if(0===t.length||0===t.content.length){for(;f>0&&!l.isEOL(r,f-1);)f--;for(;i<r.length&&!l.isEOL(r,i);)i++}for(var h=l.format(r,{offset:f,length:i-f},n),s=h.length-1;s>=0;s--){var c=h[s];r=o(r,c),f=Math.min(f,c.offset),i=Math.max(i,c.offset+c.length),i+=c.content.length-c.length}var d=e.length-(r.length-i)-f;return[{offset:f,length:d,content:r.substring(f,i)}]}function o(e,t){return e.substring(0,t.offset)+t.content+e.substring(t.offset+t.length)}function i(e,t){return-1!=="\r\n 	".indexOf(e.charAt(t))}Object.defineProperty(t,"__esModule",{value:!0});var l=e("86b561e"),h=e("38cea32");t.removeProperty=n,t.setProperty=r,t.applyEdit=o,t.isWS=i});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/format.js*/
define("86b561e",function(e,r){"use strict";function n(e,r,n){function o(){return T+t(O,g+A)}function i(){var e=S.scan();for(d=!1;15===e||14===e;)d=d||14===e,e=S.scan();return p=16===e||0!==S.getTokenError(),e}function u(r,n,t){!p&&l>n&&t>k&&e.substring(n,t)!==r&&L.push({offset:n,length:t-n,content:r})}var g,h,v,k,l;if(r){for(k=r.offset,l=k+r.length,v=k;v>0&&!s(e,v-1);)v--;for(var b=l;b<e.length&&!s(e,b);)b++;h=e.substring(v,b),g=a(h,n)}else h=e,g=0,v=0,k=0,l=e.length;var O,T=f(n,e),d=!1,A=0;O=n.insertSpaces?t(" ",n.tabSize||4):"	";var S=c.createScanner(h,!1),p=!1,L=[],m=i();if(17!==m){var z=S.getTokenOffset()+v,E=t(O,g);u(E,v,z)}for(;17!==m;){for(var M=S.getTokenOffset()+S.getTokenLength()+v,_=i(),j="";!d&&(12===_||13===_);){var w=S.getTokenOffset()+v;u(" ",M,w),M=S.getTokenOffset()+S.getTokenLength()+v,j=12===_?o():"",_=i()}if(2===_)1!==m&&(A--,j=o());else if(4===_)3!==m&&(A--,j=o());else{switch(m){case 3:case 1:A++,j=o();break;case 5:case 12:j=o();break;case 13:j=d?o():" ";break;case 6:j=" ";break;case 10:if(6===_){j="";break}case 7:case 8:case 9:case 11:case 2:case 4:12===_||13===_?j=" ":5!==_&&17!==_&&(p=!0);break;case 16:p=!0}!d||12!==_&&13!==_||(j=o())}var x=S.getTokenOffset()+v;u(j,M,x),m=_}return L}function t(e,r){for(var n="",t=0;r>t;t++)n+=e;return n}function a(e,r){for(var n=0,t=0,a=r.tabSize||4;n<e.length;){var f=e.charAt(n);if(" "===f)t++;else{if("	"!==f)break;t+=a}n++}return Math.floor(t/a)}function f(e,r){for(var n=0;n<r.length;n++){var t=r.charAt(n);if("\r"===t)return n+1<r.length&&"\n"===r.charAt(n+1)?"\r\n":"\r";if("\n"===t)return"\n"}return e&&e.eol||"\n"}function s(e,r){return-1!=="\r\n".indexOf(e.charAt(r))}Object.defineProperty(r,"__esModule",{value:!0});var c=e("aedc3c9");r.format=n,r.isEOL=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/parser.js*/
define("38cea32",function(e,n){"use strict";function r(e,n){function r(e,n,r,t){a.value=e,a.offset=n,a.length=r,a.type=t,a.colonOffset=void 0,i=a}var t=[],o=new Object,i=void 0,a={value:{},offset:0,length:0,type:"object",parent:void 0},f=!1;try{l(e,{onObjectBegin:function(e){if(e>=n)throw o;i=void 0,f=n>e,t.push("")},onObjectProperty:function(e,i,a){if(i>n)throw o;if(r(e,i,a,"property"),t[t.length-1]=e,i+a>=n)throw o},onObjectEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onArrayBegin:function(e){if(e>=n)throw o;i=void 0,t.push(0)},onArrayEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onLiteralValue:function(e,t,i){if(t>n)throw o;if(r(e,t,i,h(e)),t+i>=n)throw o},onSeparator:function(e,r){if(r>=n)throw o;if(":"===e&&i&&"property"===i.type)i.colonOffset=r,f=!1,i=void 0;else if(","===e){var a=t[t.length-1];"number"==typeof a?t[t.length-1]=a+1:(f=!0,t[t.length-1]=""),i=void 0}}})}catch(c){if(c!==o)throw c}return{path:t,previousNode:i,isAtPropertyKey:f,matches:function(e){for(var n=0,r=0;n<e.length&&r<t.length;r++)if(e[n]===t[r]||"*"===e[n])n++;else if("**"!==e[n])return!1;return n===e.length}}}function t(e,n,r){function t(e){Array.isArray(i)?i.push(e):o&&(i[o]=e)}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var o=null,i=[],a=[],f={onObjectBegin:function(){var e={};t(e),a.push(i),i=e,o=null},onObjectProperty:function(e){o=e},onObjectEnd:function(){i=a.pop()},onArrayBegin:function(){var e=[];t(e),a.push(i),i=e,o=null},onArrayEnd:function(){i=a.pop()},onLiteralValue:t,onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};return l(e,f,r),i[0]}function o(e,n,r){function t(e){"property"===i.type&&(i.length=e-i.offset,i=i.parent)}function o(e){return i.children.push(e),e}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var i={type:"array",offset:-1,length:-1,children:[],parent:void 0},a={onObjectBegin:function(e){i=o({type:"object",offset:e,length:-1,parent:i,children:[]})},onObjectProperty:function(e,n,r){i=o({type:"property",offset:n,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:e,offset:n,length:r,parent:i})},onObjectEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onArrayBegin:function(e){i=o({type:"array",offset:e,length:-1,parent:i,children:[]})},onArrayEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onLiteralValue:function(e,n,r){o({type:h(e),offset:n,length:r,parent:i,value:e}),t(n+r)},onSeparator:function(e,n){"property"===i.type&&(":"===e?i.colonOffset=n:","===e&&t(n))},onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};l(e,a,r);var f=i.children[0];return f&&delete f.parent,f}function i(e,n){if(!e)return void 0;for(var r=e,t=0,o=n;t<o.length;t++){var i=o[t];if("string"==typeof i){if("object"!==r.type||!Array.isArray(r.children))return void 0;for(var a=!1,f=0,c=r.children;f<c.length;f++){var u=c[f];if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],a=!0;break}}if(!a)return void 0}else{var l=i;if("array"!==r.type||0>l||!Array.isArray(r.children)||l>=r.children.length)return void 0;r=r.children[l]}}return r}function a(e){if(!e.parent||!e.parent.children)return[];var n=a(e.parent);if("property"===e.parent.type){var r=e.parent.children[0].value;n.push(r)}else if("array"===e.parent.type){var t=e.parent.children.indexOf(e);-1!==t&&n.push(t)}return n}function f(e){switch(e.type){case"array":return e.children.map(f);case"object":for(var n=Object.create(null),r=0,t=e.children;r<t.length;r++){var o=t[r],i=o.children[1];i&&(n[o.children[0].value]=f(i))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return void 0}}function c(e,n,r){return void 0===r&&(r=!1),n>=e.offset&&n<e.offset+e.length||r&&n===e.offset+e.length}function u(e,n,r){if(void 0===r&&(r=!1),c(e,n,r)){var t=e.children;if(Array.isArray(t))for(var o=0;o<t.length&&t[o].offset<=n;o++){var i=u(t[o],n,r);if(i)return i}return e}return void 0}function l(e,n,r){function t(e){return e?function(){return e(g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function o(e){return e?function(n){return e(n,g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function i(){for(;;){var e=g.scan();switch(g.getTokenError()){case 4:a(14);break;case 5:a(15);break;case 3:a(13);break;case 1:m||a(11);break;case 2:a(12);break;case 6:a(16)}switch(e){case 12:case 13:m?a(10):w();break;case 16:a(1);break;case 15:case 14:break;default:return e}}}function a(e,n,r){if(void 0===n&&(n=[]),void 0===r&&(r=[]),j(e),n.length+r.length>0)for(var t=g.getToken();17!==t;){if(-1!==n.indexOf(t)){i();break}if(-1!==r.indexOf(t))break;t=i()}}function f(e){var n=g.getTokenValue();return e?A(n):y(n),i(),!0}function c(){switch(g.getToken()){case 11:var e=0;try{e=JSON.parse(g.getTokenValue()),"number"!=typeof e&&(a(2),e=0)}catch(n){a(2)}A(e);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return i(),!0}function u(){return 10!==g.getToken()?(a(3,[],[2,5]),!1):(f(!1),6===g.getToken()?(O(":"),i(),h()||a(4,[],[2,5])):a(5,[],[2,5]),!0)}function l(){v(),i();for(var e=!1;2!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),2===g.getToken()&&E)break}else e&&a(6,[],[]);u()||a(4,[],[2,5]),e=!0}return b(),2!==g.getToken()?a(7,[2],[]):i(),!0}function s(){k(),i();for(var e=!1;4!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),4===g.getToken()&&E)break}else e&&a(6,[],[]);h()||a(4,[],[4,5]),e=!0}return T(),4!==g.getToken()?a(8,[4],[]):i(),!0}function h(){switch(g.getToken()){case 3:return s();case 1:return l();case 10:return f(!0);default:return c()}}void 0===r&&(r=p.DEFAULT);var g=d.createScanner(e,!1),v=t(n.onObjectBegin),y=o(n.onObjectProperty),b=t(n.onObjectEnd),k=t(n.onArrayBegin),T=t(n.onArrayEnd),A=o(n.onLiteralValue),O=o(n.onSeparator),w=t(n.onComment),j=o(n.onError),m=r&&r.disallowComments,E=r&&r.allowTrailingComma;return i(),17===g.getToken()?!0:h()?(17!==g.getToken()&&a(9,[],[]),!0):(a(4,[],[]),!1)}function s(e,n){var r,t,o=d.createScanner(e),i=[],a=0;do switch(t=o.getPosition(),r=o.scan()){case 12:case 13:case 17:a!==t&&i.push(e.substring(a,t)),void 0!==n&&i.push(o.getTokenValue().replace(/[^\r\n]/g,n)),a=o.getPosition()}while(17!==r);return i.join("")}function h(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";default:return"null"}}Object.defineProperty(n,"__esModule",{value:!0});var p,d=e("aedc3c9");!function(e){e.DEFAULT={allowTrailingComma:!1}}(p||(p={})),n.getLocation=r,n.parse=t,n.parseTree=o,n.findNodeAtLocation=i,n.getNodePath=a,n.getNodeValue=f,n.contains=c,n.findNodeAtOffset=u,n.visit=l,n.stripComments=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/scanner.js*/
define("aedc3c9",function(e,r){"use strict";function t(e,r){function t(r,t){for(var n=0,a=0;r>n||!t;){var c=e.charCodeAt(d);if(c>=48&&57>=c)a=16*a+c-48;else if(c>=65&&70>=c)a=16*a+c-65+10;else{if(!(c>=97&&102>=c))break;a=16*a+c-97+10}d++,n++}return r>n&&(a=-1),a}function o(e){d=e,g="",b=0,l=16,A=0}function s(){var r=d;if(48===e.charCodeAt(d))d++;else for(d++;d<e.length&&c(e.charCodeAt(d));)d++;if(d<e.length&&46===e.charCodeAt(d)){if(d++,!(d<e.length&&c(e.charCodeAt(d))))return A=3,e.substring(r,d);for(d++;d<e.length&&c(e.charCodeAt(d));)d++}var t=d;if(d<e.length&&(69===e.charCodeAt(d)||101===e.charCodeAt(d)))if(d++,(d<e.length&&43===e.charCodeAt(d)||45===e.charCodeAt(d))&&d++,d<e.length&&c(e.charCodeAt(d))){for(d++;d<e.length&&c(e.charCodeAt(d));)d++;t=d}else A=3;return e.substring(r,t)}function u(){for(var r="",n=d;;){if(d>=C){r+=e.substring(n,d),A=2;break}var c=e.charCodeAt(d);if(34===c){r+=e.substring(n,d),d++;break}if(92!==c){if(c>=0&&31>=c){if(a(c)){r+=e.substring(n,d),A=2;break}A=6}d++}else{if(r+=e.substring(n,d),d++,d>=C){A=2;break}switch(c=e.charCodeAt(d++)){case 34:r+='"';break;case 92:r+="\\";break;case 47:r+="/";break;case 98:r+="\b";break;case 102:r+="\f";break;case 110:r+="\n";break;case 114:r+="\r";break;case 116:r+="	";break;case 117:var o=t(4,!0);o>=0?r+=String.fromCharCode(o):A=4;break;default:A=5}n=d}}return r}function i(){if(g="",A=0,b=d,d>=C)return b=C,l=17;var r=e.charCodeAt(d);if(n(r)){do d++,g+=String.fromCharCode(r),r=e.charCodeAt(d);while(n(r));return l=15}if(a(r))return d++,g+=String.fromCharCode(r),13===r&&10===e.charCodeAt(d)&&(d++,g+="\n"),l=14;switch(r){case 123:return d++,l=1;case 125:return d++,l=2;case 91:return d++,l=3;case 93:return d++,l=4;case 58:return d++,l=6;case 44:return d++,l=5;case 34:return d++,g=u(),l=10;case 47:var t=d-1;if(47===e.charCodeAt(d+1)){for(d+=2;C>d&&!a(e.charCodeAt(d));)d++;return g=e.substring(t,d),l=12}if(42===e.charCodeAt(d+1)){d+=2;for(var o=C-1,i=!1;o>d;){var h=e.charCodeAt(d);if(42===h&&47===e.charCodeAt(d+1)){d+=2,i=!0;break}d++}return i||(d++,A=1),g=e.substring(t,d),l=13}return g+=String.fromCharCode(r),d++,l=16;case 45:if(g+=String.fromCharCode(r),d++,d===C||!c(e.charCodeAt(d)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=s(),l=11;default:for(;C>d&&f(r);)d++,r=e.charCodeAt(d);if(b!==d){switch(g=e.substring(b,d)){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return g+=String.fromCharCode(r),d++,l=16}}function f(e){if(n(e)||a(e))return!1;switch(e){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function h(){var e;do e=i();while(e>=12&&15>=e);return e}void 0===r&&(r=!1);var d=0,C=e.length,g="",b=0,l=16,A=0;return{setPosition:o,getPosition:function(){return d},scan:r?h:i,getToken:function(){return l},getTokenValue:function(){return g},getTokenOffset:function(){return b},getTokenLength:function(){return d-b},getTokenError:function(){return A}}}function n(e){return 32===e||9===e||11===e||12===e||160===e||5760===e||e>=8192&&8203>=e||8239===e||8287===e||12288===e||65279===e}function a(e){return 10===e||13===e||8232===e||8233===e}function c(e){return e>=48&&57>=e}Object.defineProperty(r,"__esModule",{value:!0}),r.createScanner=t});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/edit.js*/
define("98ab305",function(e,t){"use strict";function n(e,t,n){return r(e,t,void 0,n)}function r(e,t,n,r,o){for(var i,l=t.slice(),s=[],c=h.parseTree(e,s),d=void 0,g=void 0;l.length>0&&(g=l.pop(),d=h.findNodeAtLocation(c,l),void 0===d&&void 0!==n);)"string"==typeof g?(i={},i[g]=n,n=i):n=[n];if(d){if("object"===d.type&&"string"==typeof g&&Array.isArray(d.children)){var a=h.findNodeAtLocation(d,[g]);if(void 0!==a){if(void 0===n){if(!a.parent)throw new Error("Malformed AST");var v=d.children.indexOf(a.parent),u=void 0,p=a.parent.offset+a.parent.length;if(v>0){var y=d.children[v-1];u=y.offset+y.length}else if(u=d.offset+1,d.children.length>1){var m=d.children[1];p=m.offset}return f(e,{offset:u,length:p-u,content:""},r)}return f(e,{offset:a.offset,length:a.length,content:JSON.stringify(n)},r)}if(void 0===n)return[];var O=JSON.stringify(g)+": "+JSON.stringify(n),b=o?o(d.children.map(function(e){return e.children[0].value})):d.children.length,A=void 0;if(b>0){var y=d.children[b-1];A={offset:y.offset+y.length,length:0,content:","+O}}else A=0===d.children.length?{offset:d.offset+1,length:0,content:O}:{offset:d.offset+1,length:0,content:O+","};return f(e,A,r)}if("array"===d.type&&"number"==typeof g&&Array.isArray(d.children)){var w=g;if(-1===w){var O=""+JSON.stringify(n),A=void 0;if(0===d.children.length)A={offset:d.offset+1,length:0,content:O};else{var y=d.children[d.children.length-1];A={offset:y.offset+y.length,length:0,content:","+O}}return f(e,A,r)}if(void 0===n&&d.children.length>=0){var E=g,N=d.children[E],A=void 0;if(1===d.children.length)A={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===E){var y=d.children[E-1],S=y.offset+y.length,J=d.offset+d.length;A={offset:S,length:J-2-S,content:""}}else A={offset:N.offset,length:d.children[E+1].offset-N.offset,content:""};return f(e,A,r)}throw new Error("Array modification not supported yet")}throw new Error("Can not add "+("number"!=typeof g?"index":"property")+" to parent of type "+d.type)}if(void 0===n)throw new Error("Can not delete in empty document");return f(e,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(n)},r)}function f(e,t,n){var r=o(e,t),f=t.offset,i=t.offset+t.content.length;if(0===t.length||0===t.content.length){for(;f>0&&!l.isEOL(r,f-1);)f--;for(;i<r.length&&!l.isEOL(r,i);)i++}for(var h=l.format(r,{offset:f,length:i-f},n),s=h.length-1;s>=0;s--){var c=h[s];r=o(r,c),f=Math.min(f,c.offset),i=Math.max(i,c.offset+c.length),i+=c.content.length-c.length}var d=e.length-(r.length-i)-f;return[{offset:f,length:d,content:r.substring(f,i)}]}function o(e,t){return e.substring(0,t.offset)+t.content+e.substring(t.offset+t.length)}function i(e,t){return-1!=="\r\n 	".indexOf(e.charAt(t))}Object.defineProperty(t,"__esModule",{value:!0});var l=e("86b561e"),h=e("38cea32");t.removeProperty=n,t.setProperty=r,t.applyEdit=o,t.isWS=i});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/format.js*/
define("86b561e",function(e,r){"use strict";function n(e,r,n){function o(){return T+t(O,g+A)}function i(){var e=S.scan();for(d=!1;15===e||14===e;)d=d||14===e,e=S.scan();return p=16===e||0!==S.getTokenError(),e}function u(r,n,t){!p&&l>n&&t>k&&e.substring(n,t)!==r&&L.push({offset:n,length:t-n,content:r})}var g,h,v,k,l;if(r){for(k=r.offset,l=k+r.length,v=k;v>0&&!s(e,v-1);)v--;for(var b=l;b<e.length&&!s(e,b);)b++;h=e.substring(v,b),g=a(h,n)}else h=e,g=0,v=0,k=0,l=e.length;var O,T=f(n,e),d=!1,A=0;O=n.insertSpaces?t(" ",n.tabSize||4):"	";var S=c.createScanner(h,!1),p=!1,L=[],m=i();if(17!==m){var z=S.getTokenOffset()+v,E=t(O,g);u(E,v,z)}for(;17!==m;){for(var M=S.getTokenOffset()+S.getTokenLength()+v,_=i(),j="";!d&&(12===_||13===_);){var w=S.getTokenOffset()+v;u(" ",M,w),M=S.getTokenOffset()+S.getTokenLength()+v,j=12===_?o():"",_=i()}if(2===_)1!==m&&(A--,j=o());else if(4===_)3!==m&&(A--,j=o());else{switch(m){case 3:case 1:A++,j=o();break;case 5:case 12:j=o();break;case 13:j=d?o():" ";break;case 6:j=" ";break;case 10:if(6===_){j="";break}case 7:case 8:case 9:case 11:case 2:case 4:12===_||13===_?j=" ":5!==_&&17!==_&&(p=!0);break;case 16:p=!0}!d||12!==_&&13!==_||(j=o())}var x=S.getTokenOffset()+v;u(j,M,x),m=_}return L}function t(e,r){for(var n="",t=0;r>t;t++)n+=e;return n}function a(e,r){for(var n=0,t=0,a=r.tabSize||4;n<e.length;){var f=e.charAt(n);if(" "===f)t++;else{if("	"!==f)break;t+=a}n++}return Math.floor(t/a)}function f(e,r){for(var n=0;n<r.length;n++){var t=r.charAt(n);if("\r"===t)return n+1<r.length&&"\n"===r.charAt(n+1)?"\r\n":"\r";if("\n"===t)return"\n"}return e&&e.eol||"\n"}function s(e,r){return-1!=="\r\n".indexOf(e.charAt(r))}Object.defineProperty(r,"__esModule",{value:!0});var c=e("aedc3c9");r.format=n,r.isEOL=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-uri/index.js*/
define("a199806",function(t,e){"use strict";function r(t){if(t.scheme&&!c.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path)if(t.authority){if(!p.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(d.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}function n(t,e){switch(t){case"https":case"http":case"file":e?e[0]!==y&&(e=y+e):e=y}return e}function o(t,e){for(var r=void 0,n=-1,o=0;o<t.length;o++){var i=t.charCodeAt(o);if(i>=97&&122>=i||i>=65&&90>=i||i>=48&&57>=i||45===i||46===i||95===i||126===i||e&&47===i)-1!==n&&(r+=encodeURIComponent(t.substring(n,o)),n=-1),void 0!==r&&(r+=t.charAt(o));else{void 0===r&&(r=t.substr(0,o));var h=C[i];void 0!==h?(-1!==n&&(r+=encodeURIComponent(t.substring(n,o)),n=-1),r+=h):-1===n&&(n=o)}}return-1!==n&&(r+=encodeURIComponent(t.substring(n))),void 0!==r?r:t}function i(t){for(var e=void 0,r=0;r<t.length;r++){var n=t.charCodeAt(r);35===n||63===n?(void 0===e&&(e=t.substr(0,r)),e+=C[n]):void 0!==e&&(e+=t[r])}return void 0!==e?e:t}function h(t){var e;return e=t.authority&&t.path.length>1&&"file"===t.scheme?"//"+t.authority+t.path:47===t.path.charCodeAt(0)&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&58===t.path.charCodeAt(2)?t.path[1].toLowerCase()+t.path.substr(2):t.path,s&&(e=e.replace(/\//g,"\\")),e}function a(t,e){var r=e?i:o,n="",h=t.scheme,a=t.authority,s=t.path,u=t.query,f=t.fragment;if(h&&(n+=h,n+=":"),(a||"file"===h)&&(n+=y,n+=y),a){var c=a.indexOf("@");if(-1!==c){var p=a.substr(0,c);a=a.substr(c+1),c=p.indexOf(":"),-1===c?n+=r(p,!1):(n+=r(p.substr(0,c),!1),n+=":",n+=r(p.substr(c+1),!1)),n+="@"}a=a.toLowerCase(),c=a.indexOf(":"),-1===c?n+=r(a,!1):(n+=r(a.substr(0,c),!1),n+=a.substr(c))}if(s){if(s.length>=3&&47===s.charCodeAt(0)&&58===s.charCodeAt(2)){var d=s.charCodeAt(1);d>=65&&90>=d&&(s="/"+String.fromCharCode(d+32)+":"+s.substr(3))}else if(s.length>=2&&58===s.charCodeAt(1)){var d=s.charCodeAt(0);d>=65&&90>=d&&(s=String.fromCharCode(d+32)+":"+s.substr(2))}n+=r(s,!0)}return u&&(n+="?",n+=r(u,!1)),f&&(n+="#",n+=e?f:o(f,!1)),n}Object.defineProperty(e,"__esModule",{value:!0});var s,u=this&&this.__extends||function(){var t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])};return function(e,r){function n(){this.constructor=e}t(e,r),e.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}();if("object"==typeof navigator){var f=navigator.userAgent;s=f.indexOf("Windows")>=0}var c=/^\w[\w\d+.-]*$/,p=/^\//,d=/^\/\//,m="",y="/",l=/^(([^:\/?#]+?):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,g=function(){function t(t,e,o,i,h){"object"==typeof t?(this.scheme=t.scheme||m,this.authority=t.authority||m,this.path=t.path||m,this.query=t.query||m,this.fragment=t.fragment||m):(this.scheme=t||m,this.authority=e||m,this.path=n(this.scheme,o||m),this.query=i||m,this.fragment=h||m,r(this))}return t.isUri=function(e){return e instanceof t?!0:e?"string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme:!1},Object.defineProperty(t.prototype,"fsPath",{get:function(){return h(this)},enumerable:!0,configurable:!0}),t.prototype.with=function(t){if(!t)return this;var e=t.scheme,r=t.authority,n=t.path,o=t.query,i=t.fragment;return void 0===e?e=this.scheme:null===e&&(e=m),void 0===r?r=this.authority:null===r&&(r=m),void 0===n?n=this.path:null===n&&(n=m),void 0===o?o=this.query:null===o&&(o=m),void 0===i?i=this.fragment:null===i&&(i=m),e===this.scheme&&r===this.authority&&n===this.path&&o===this.query&&i===this.fragment?this:new b(e,r,n,o,i)},t.parse=function(t){var e=l.exec(t);return e?new b(e[2]||m,decodeURIComponent(e[4]||m),decodeURIComponent(e[5]||m),decodeURIComponent(e[7]||m),decodeURIComponent(e[9]||m)):new b(m,m,m,m,m)},t.file=function(t){var e=m;if(s&&(t=t.replace(/\\/g,y)),t[0]===y&&t[1]===y){var r=t.indexOf(y,2);-1===r?(e=t.substring(2),t=y):(e=t.substring(2,r),t=t.substring(r)||y)}return new b("file",e,t,m,m)},t.from=function(t){return new b(t.scheme,t.authority,t.path,t.query,t.fragment)},t.prototype.toString=function(t){return void 0===t&&(t=!1),a(this,t)},t.prototype.toJSON=function(){return this},t.revive=function(e){if(e){if(e instanceof t)return e;var r=new b(e);return r._fsPath=e.fsPath,r._formatted=e.external,r}return e},t}();e.default=g;var v,b=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e._formatted=null,e._fsPath=null,e}return u(e,t),Object.defineProperty(e.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=h(this)),this._fsPath},enumerable:!0,configurable:!0}),e.prototype.toString=function(t){return void 0===t&&(t=!1),t?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)},e.prototype.toJSON=function(){var t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t},e}(g),C=(v={},v[58]="%3A",v[47]="%2F",v[63]="%3F",v[35]="%23",v[91]="%5B",v[93]="%5D",v[64]="%40",v[33]="%21",v[36]="%24",v[38]="%26",v[39]="%27",v[40]="%28",v[41]="%29",v[42]="%2A",v[43]="%2B",v[44]="%2C",v[59]="%3B",v[61]="%3D",v[32]="%20",v)});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-uri/index.js*/
define("a199806",function(t,e){"use strict";function r(t){if(t.scheme&&!c.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path)if(t.authority){if(!p.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(d.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}function n(t,e){switch(t){case"https":case"http":case"file":e?e[0]!==y&&(e=y+e):e=y}return e}function o(t,e){for(var r=void 0,n=-1,o=0;o<t.length;o++){var i=t.charCodeAt(o);if(i>=97&&122>=i||i>=65&&90>=i||i>=48&&57>=i||45===i||46===i||95===i||126===i||e&&47===i)-1!==n&&(r+=encodeURIComponent(t.substring(n,o)),n=-1),void 0!==r&&(r+=t.charAt(o));else{void 0===r&&(r=t.substr(0,o));var h=C[i];void 0!==h?(-1!==n&&(r+=encodeURIComponent(t.substring(n,o)),n=-1),r+=h):-1===n&&(n=o)}}return-1!==n&&(r+=encodeURIComponent(t.substring(n))),void 0!==r?r:t}function i(t){for(var e=void 0,r=0;r<t.length;r++){var n=t.charCodeAt(r);35===n||63===n?(void 0===e&&(e=t.substr(0,r)),e+=C[n]):void 0!==e&&(e+=t[r])}return void 0!==e?e:t}function h(t){var e;return e=t.authority&&t.path.length>1&&"file"===t.scheme?"//"+t.authority+t.path:47===t.path.charCodeAt(0)&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&58===t.path.charCodeAt(2)?t.path[1].toLowerCase()+t.path.substr(2):t.path,s&&(e=e.replace(/\//g,"\\")),e}function a(t,e){var r=e?i:o,n="",h=t.scheme,a=t.authority,s=t.path,u=t.query,f=t.fragment;if(h&&(n+=h,n+=":"),(a||"file"===h)&&(n+=y,n+=y),a){var c=a.indexOf("@");if(-1!==c){var p=a.substr(0,c);a=a.substr(c+1),c=p.indexOf(":"),-1===c?n+=r(p,!1):(n+=r(p.substr(0,c),!1),n+=":",n+=r(p.substr(c+1),!1)),n+="@"}a=a.toLowerCase(),c=a.indexOf(":"),-1===c?n+=r(a,!1):(n+=r(a.substr(0,c),!1),n+=a.substr(c))}if(s){if(s.length>=3&&47===s.charCodeAt(0)&&58===s.charCodeAt(2)){var d=s.charCodeAt(1);d>=65&&90>=d&&(s="/"+String.fromCharCode(d+32)+":"+s.substr(3))}else if(s.length>=2&&58===s.charCodeAt(1)){var d=s.charCodeAt(0);d>=65&&90>=d&&(s=String.fromCharCode(d+32)+":"+s.substr(2))}n+=r(s,!0)}return u&&(n+="?",n+=r(u,!1)),f&&(n+="#",n+=e?f:o(f,!1)),n}Object.defineProperty(e,"__esModule",{value:!0});var s,u=this&&this.__extends||function(){var t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])};return function(e,r){function n(){this.constructor=e}t(e,r),e.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}();if("object"==typeof navigator){var f=navigator.userAgent;s=f.indexOf("Windows")>=0}var c=/^\w[\w\d+.-]*$/,p=/^\//,d=/^\/\//,m="",y="/",l=/^(([^:\/?#]+?):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,g=function(){function t(t,e,o,i,h){"object"==typeof t?(this.scheme=t.scheme||m,this.authority=t.authority||m,this.path=t.path||m,this.query=t.query||m,this.fragment=t.fragment||m):(this.scheme=t||m,this.authority=e||m,this.path=n(this.scheme,o||m),this.query=i||m,this.fragment=h||m,r(this))}return t.isUri=function(e){return e instanceof t?!0:e?"string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme:!1},Object.defineProperty(t.prototype,"fsPath",{get:function(){return h(this)},enumerable:!0,configurable:!0}),t.prototype.with=function(t){if(!t)return this;var e=t.scheme,r=t.authority,n=t.path,o=t.query,i=t.fragment;return void 0===e?e=this.scheme:null===e&&(e=m),void 0===r?r=this.authority:null===r&&(r=m),void 0===n?n=this.path:null===n&&(n=m),void 0===o?o=this.query:null===o&&(o=m),void 0===i?i=this.fragment:null===i&&(i=m),e===this.scheme&&r===this.authority&&n===this.path&&o===this.query&&i===this.fragment?this:new b(e,r,n,o,i)},t.parse=function(t){var e=l.exec(t);return e?new b(e[2]||m,decodeURIComponent(e[4]||m),decodeURIComponent(e[5]||m),decodeURIComponent(e[7]||m),decodeURIComponent(e[9]||m)):new b(m,m,m,m,m)},t.file=function(t){var e=m;if(s&&(t=t.replace(/\\/g,y)),t[0]===y&&t[1]===y){var r=t.indexOf(y,2);-1===r?(e=t.substring(2),t=y):(e=t.substring(2,r),t=t.substring(r)||y)}return new b("file",e,t,m,m)},t.from=function(t){return new b(t.scheme,t.authority,t.path,t.query,t.fragment)},t.prototype.toString=function(t){return void 0===t&&(t=!1),a(this,t)},t.prototype.toJSON=function(){return this},t.revive=function(e){if(e){if(e instanceof t)return e;var r=new b(e);return r._fsPath=e.fsPath,r._formatted=e.external,r}return e},t}();e.default=g;var v,b=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e._formatted=null,e._fsPath=null,e}return u(e,t),Object.defineProperty(e.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=h(this)),this._fsPath},enumerable:!0,configurable:!0}),e.prototype.toString=function(t){return void 0===t&&(t=!1),t?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)},e.prototype.toJSON=function(){var t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t},e}(g),C=(v={},v[58]="%3A",v[47]="%2F",v[63]="%3F",v[35]="%23",v[91]="%5B",v[93]="%5D",v[64]="%40",v[33]="%21",v[36]="%24",v[38]="%26",v[39]="%27",v[40]="%28",v[41]="%29",v[42]="%2A",v[43]="%2B",v[44]="%2C",v[59]="%3B",v[61]="%3D",v[32]="%20",v)});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-uri/index.js*/
define("a199806",function(t,e){"use strict";function r(t){if(t.scheme&&!c.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path)if(t.authority){if(!p.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(d.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}function n(t,e){switch(t){case"https":case"http":case"file":e?e[0]!==y&&(e=y+e):e=y}return e}function o(t,e){for(var r=void 0,n=-1,o=0;o<t.length;o++){var i=t.charCodeAt(o);if(i>=97&&122>=i||i>=65&&90>=i||i>=48&&57>=i||45===i||46===i||95===i||126===i||e&&47===i)-1!==n&&(r+=encodeURIComponent(t.substring(n,o)),n=-1),void 0!==r&&(r+=t.charAt(o));else{void 0===r&&(r=t.substr(0,o));var h=C[i];void 0!==h?(-1!==n&&(r+=encodeURIComponent(t.substring(n,o)),n=-1),r+=h):-1===n&&(n=o)}}return-1!==n&&(r+=encodeURIComponent(t.substring(n))),void 0!==r?r:t}function i(t){for(var e=void 0,r=0;r<t.length;r++){var n=t.charCodeAt(r);35===n||63===n?(void 0===e&&(e=t.substr(0,r)),e+=C[n]):void 0!==e&&(e+=t[r])}return void 0!==e?e:t}function h(t){var e;return e=t.authority&&t.path.length>1&&"file"===t.scheme?"//"+t.authority+t.path:47===t.path.charCodeAt(0)&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&58===t.path.charCodeAt(2)?t.path[1].toLowerCase()+t.path.substr(2):t.path,s&&(e=e.replace(/\//g,"\\")),e}function a(t,e){var r=e?i:o,n="",h=t.scheme,a=t.authority,s=t.path,u=t.query,f=t.fragment;if(h&&(n+=h,n+=":"),(a||"file"===h)&&(n+=y,n+=y),a){var c=a.indexOf("@");if(-1!==c){var p=a.substr(0,c);a=a.substr(c+1),c=p.indexOf(":"),-1===c?n+=r(p,!1):(n+=r(p.substr(0,c),!1),n+=":",n+=r(p.substr(c+1),!1)),n+="@"}a=a.toLowerCase(),c=a.indexOf(":"),-1===c?n+=r(a,!1):(n+=r(a.substr(0,c),!1),n+=a.substr(c))}if(s){if(s.length>=3&&47===s.charCodeAt(0)&&58===s.charCodeAt(2)){var d=s.charCodeAt(1);d>=65&&90>=d&&(s="/"+String.fromCharCode(d+32)+":"+s.substr(3))}else if(s.length>=2&&58===s.charCodeAt(1)){var d=s.charCodeAt(0);d>=65&&90>=d&&(s=String.fromCharCode(d+32)+":"+s.substr(2))}n+=r(s,!0)}return u&&(n+="?",n+=r(u,!1)),f&&(n+="#",n+=e?f:o(f,!1)),n}Object.defineProperty(e,"__esModule",{value:!0});var s,u=this&&this.__extends||function(){var t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])};return function(e,r){function n(){this.constructor=e}t(e,r),e.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}();if("object"==typeof navigator){var f=navigator.userAgent;s=f.indexOf("Windows")>=0}var c=/^\w[\w\d+.-]*$/,p=/^\//,d=/^\/\//,m="",y="/",l=/^(([^:\/?#]+?):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,g=function(){function t(t,e,o,i,h){"object"==typeof t?(this.scheme=t.scheme||m,this.authority=t.authority||m,this.path=t.path||m,this.query=t.query||m,this.fragment=t.fragment||m):(this.scheme=t||m,this.authority=e||m,this.path=n(this.scheme,o||m),this.query=i||m,this.fragment=h||m,r(this))}return t.isUri=function(e){return e instanceof t?!0:e?"string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme:!1},Object.defineProperty(t.prototype,"fsPath",{get:function(){return h(this)},enumerable:!0,configurable:!0}),t.prototype.with=function(t){if(!t)return this;var e=t.scheme,r=t.authority,n=t.path,o=t.query,i=t.fragment;return void 0===e?e=this.scheme:null===e&&(e=m),void 0===r?r=this.authority:null===r&&(r=m),void 0===n?n=this.path:null===n&&(n=m),void 0===o?o=this.query:null===o&&(o=m),void 0===i?i=this.fragment:null===i&&(i=m),e===this.scheme&&r===this.authority&&n===this.path&&o===this.query&&i===this.fragment?this:new b(e,r,n,o,i)},t.parse=function(t){var e=l.exec(t);return e?new b(e[2]||m,decodeURIComponent(e[4]||m),decodeURIComponent(e[5]||m),decodeURIComponent(e[7]||m),decodeURIComponent(e[9]||m)):new b(m,m,m,m,m)},t.file=function(t){var e=m;if(s&&(t=t.replace(/\\/g,y)),t[0]===y&&t[1]===y){var r=t.indexOf(y,2);-1===r?(e=t.substring(2),t=y):(e=t.substring(2,r),t=t.substring(r)||y)}return new b("file",e,t,m,m)},t.from=function(t){return new b(t.scheme,t.authority,t.path,t.query,t.fragment)},t.prototype.toString=function(t){return void 0===t&&(t=!1),a(this,t)},t.prototype.toJSON=function(){return this},t.revive=function(e){if(e){if(e instanceof t)return e;var r=new b(e);return r._fsPath=e.fsPath,r._formatted=e.external,r}return e},t}();e.default=g;var v,b=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e._formatted=null,e._fsPath=null,e}return u(e,t),Object.defineProperty(e.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=h(this)),this._fsPath},enumerable:!0,configurable:!0}),e.prototype.toString=function(t){return void 0===t&&(t=!1),t?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)},e.prototype.toJSON=function(){var t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t},e}(g),C=(v={},v[58]="%3A",v[47]="%2F",v[63]="%3F",v[35]="%23",v[91]="%5B",v[93]="%5D",v[64]="%40",v[33]="%21",v[36]="%24",v[38]="%26",v[39]="%27",v[40]="%28",v[41]="%29",v[42]="%2A",v[43]="%2B",v[44]="%2C",v[59]="%3B",v[61]="%3D",v[32]="%20",v)});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/parser.js*/
define("38cea32",function(e,n){"use strict";function r(e,n){function r(e,n,r,t){a.value=e,a.offset=n,a.length=r,a.type=t,a.colonOffset=void 0,i=a}var t=[],o=new Object,i=void 0,a={value:{},offset:0,length:0,type:"object",parent:void 0},f=!1;try{l(e,{onObjectBegin:function(e){if(e>=n)throw o;i=void 0,f=n>e,t.push("")},onObjectProperty:function(e,i,a){if(i>n)throw o;if(r(e,i,a,"property"),t[t.length-1]=e,i+a>=n)throw o},onObjectEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onArrayBegin:function(e){if(e>=n)throw o;i=void 0,t.push(0)},onArrayEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onLiteralValue:function(e,t,i){if(t>n)throw o;if(r(e,t,i,h(e)),t+i>=n)throw o},onSeparator:function(e,r){if(r>=n)throw o;if(":"===e&&i&&"property"===i.type)i.colonOffset=r,f=!1,i=void 0;else if(","===e){var a=t[t.length-1];"number"==typeof a?t[t.length-1]=a+1:(f=!0,t[t.length-1]=""),i=void 0}}})}catch(c){if(c!==o)throw c}return{path:t,previousNode:i,isAtPropertyKey:f,matches:function(e){for(var n=0,r=0;n<e.length&&r<t.length;r++)if(e[n]===t[r]||"*"===e[n])n++;else if("**"!==e[n])return!1;return n===e.length}}}function t(e,n,r){function t(e){Array.isArray(i)?i.push(e):o&&(i[o]=e)}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var o=null,i=[],a=[],f={onObjectBegin:function(){var e={};t(e),a.push(i),i=e,o=null},onObjectProperty:function(e){o=e},onObjectEnd:function(){i=a.pop()},onArrayBegin:function(){var e=[];t(e),a.push(i),i=e,o=null},onArrayEnd:function(){i=a.pop()},onLiteralValue:t,onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};return l(e,f,r),i[0]}function o(e,n,r){function t(e){"property"===i.type&&(i.length=e-i.offset,i=i.parent)}function o(e){return i.children.push(e),e}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var i={type:"array",offset:-1,length:-1,children:[],parent:void 0},a={onObjectBegin:function(e){i=o({type:"object",offset:e,length:-1,parent:i,children:[]})},onObjectProperty:function(e,n,r){i=o({type:"property",offset:n,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:e,offset:n,length:r,parent:i})},onObjectEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onArrayBegin:function(e){i=o({type:"array",offset:e,length:-1,parent:i,children:[]})},onArrayEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onLiteralValue:function(e,n,r){o({type:h(e),offset:n,length:r,parent:i,value:e}),t(n+r)},onSeparator:function(e,n){"property"===i.type&&(":"===e?i.colonOffset=n:","===e&&t(n))},onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};l(e,a,r);var f=i.children[0];return f&&delete f.parent,f}function i(e,n){if(!e)return void 0;for(var r=e,t=0,o=n;t<o.length;t++){var i=o[t];if("string"==typeof i){if("object"!==r.type||!Array.isArray(r.children))return void 0;for(var a=!1,f=0,c=r.children;f<c.length;f++){var u=c[f];if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],a=!0;break}}if(!a)return void 0}else{var l=i;if("array"!==r.type||0>l||!Array.isArray(r.children)||l>=r.children.length)return void 0;r=r.children[l]}}return r}function a(e){if(!e.parent||!e.parent.children)return[];var n=a(e.parent);if("property"===e.parent.type){var r=e.parent.children[0].value;n.push(r)}else if("array"===e.parent.type){var t=e.parent.children.indexOf(e);-1!==t&&n.push(t)}return n}function f(e){switch(e.type){case"array":return e.children.map(f);case"object":for(var n=Object.create(null),r=0,t=e.children;r<t.length;r++){var o=t[r],i=o.children[1];i&&(n[o.children[0].value]=f(i))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return void 0}}function c(e,n,r){return void 0===r&&(r=!1),n>=e.offset&&n<e.offset+e.length||r&&n===e.offset+e.length}function u(e,n,r){if(void 0===r&&(r=!1),c(e,n,r)){var t=e.children;if(Array.isArray(t))for(var o=0;o<t.length&&t[o].offset<=n;o++){var i=u(t[o],n,r);if(i)return i}return e}return void 0}function l(e,n,r){function t(e){return e?function(){return e(g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function o(e){return e?function(n){return e(n,g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function i(){for(;;){var e=g.scan();switch(g.getTokenError()){case 4:a(14);break;case 5:a(15);break;case 3:a(13);break;case 1:m||a(11);break;case 2:a(12);break;case 6:a(16)}switch(e){case 12:case 13:m?a(10):w();break;case 16:a(1);break;case 15:case 14:break;default:return e}}}function a(e,n,r){if(void 0===n&&(n=[]),void 0===r&&(r=[]),j(e),n.length+r.length>0)for(var t=g.getToken();17!==t;){if(-1!==n.indexOf(t)){i();break}if(-1!==r.indexOf(t))break;t=i()}}function f(e){var n=g.getTokenValue();return e?A(n):y(n),i(),!0}function c(){switch(g.getToken()){case 11:var e=0;try{e=JSON.parse(g.getTokenValue()),"number"!=typeof e&&(a(2),e=0)}catch(n){a(2)}A(e);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return i(),!0}function u(){return 10!==g.getToken()?(a(3,[],[2,5]),!1):(f(!1),6===g.getToken()?(O(":"),i(),h()||a(4,[],[2,5])):a(5,[],[2,5]),!0)}function l(){v(),i();for(var e=!1;2!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),2===g.getToken()&&E)break}else e&&a(6,[],[]);u()||a(4,[],[2,5]),e=!0}return b(),2!==g.getToken()?a(7,[2],[]):i(),!0}function s(){k(),i();for(var e=!1;4!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),4===g.getToken()&&E)break}else e&&a(6,[],[]);h()||a(4,[],[4,5]),e=!0}return T(),4!==g.getToken()?a(8,[4],[]):i(),!0}function h(){switch(g.getToken()){case 3:return s();case 1:return l();case 10:return f(!0);default:return c()}}void 0===r&&(r=p.DEFAULT);var g=d.createScanner(e,!1),v=t(n.onObjectBegin),y=o(n.onObjectProperty),b=t(n.onObjectEnd),k=t(n.onArrayBegin),T=t(n.onArrayEnd),A=o(n.onLiteralValue),O=o(n.onSeparator),w=t(n.onComment),j=o(n.onError),m=r&&r.disallowComments,E=r&&r.allowTrailingComma;return i(),17===g.getToken()?!0:h()?(17!==g.getToken()&&a(9,[],[]),!0):(a(4,[],[]),!1)}function s(e,n){var r,t,o=d.createScanner(e),i=[],a=0;do switch(t=o.getPosition(),r=o.scan()){case 12:case 13:case 17:a!==t&&i.push(e.substring(a,t)),void 0!==n&&i.push(o.getTokenValue().replace(/[^\r\n]/g,n)),a=o.getPosition()}while(17!==r);return i.join("")}function h(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";default:return"null"}}Object.defineProperty(n,"__esModule",{value:!0});var p,d=e("aedc3c9");!function(e){e.DEFAULT={allowTrailingComma:!1}}(p||(p={})),n.getLocation=r,n.parse=t,n.parseTree=o,n.findNodeAtLocation=i,n.getNodePath=a,n.getNodeValue=f,n.contains=c,n.findNodeAtOffset=u,n.visit=l,n.stripComments=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/scanner.js*/
define("aedc3c9",function(e,r){"use strict";function t(e,r){function t(r,t){for(var n=0,a=0;r>n||!t;){var c=e.charCodeAt(d);if(c>=48&&57>=c)a=16*a+c-48;else if(c>=65&&70>=c)a=16*a+c-65+10;else{if(!(c>=97&&102>=c))break;a=16*a+c-97+10}d++,n++}return r>n&&(a=-1),a}function o(e){d=e,g="",b=0,l=16,A=0}function s(){var r=d;if(48===e.charCodeAt(d))d++;else for(d++;d<e.length&&c(e.charCodeAt(d));)d++;if(d<e.length&&46===e.charCodeAt(d)){if(d++,!(d<e.length&&c(e.charCodeAt(d))))return A=3,e.substring(r,d);for(d++;d<e.length&&c(e.charCodeAt(d));)d++}var t=d;if(d<e.length&&(69===e.charCodeAt(d)||101===e.charCodeAt(d)))if(d++,(d<e.length&&43===e.charCodeAt(d)||45===e.charCodeAt(d))&&d++,d<e.length&&c(e.charCodeAt(d))){for(d++;d<e.length&&c(e.charCodeAt(d));)d++;t=d}else A=3;return e.substring(r,t)}function u(){for(var r="",n=d;;){if(d>=C){r+=e.substring(n,d),A=2;break}var c=e.charCodeAt(d);if(34===c){r+=e.substring(n,d),d++;break}if(92!==c){if(c>=0&&31>=c){if(a(c)){r+=e.substring(n,d),A=2;break}A=6}d++}else{if(r+=e.substring(n,d),d++,d>=C){A=2;break}switch(c=e.charCodeAt(d++)){case 34:r+='"';break;case 92:r+="\\";break;case 47:r+="/";break;case 98:r+="\b";break;case 102:r+="\f";break;case 110:r+="\n";break;case 114:r+="\r";break;case 116:r+="	";break;case 117:var o=t(4,!0);o>=0?r+=String.fromCharCode(o):A=4;break;default:A=5}n=d}}return r}function i(){if(g="",A=0,b=d,d>=C)return b=C,l=17;var r=e.charCodeAt(d);if(n(r)){do d++,g+=String.fromCharCode(r),r=e.charCodeAt(d);while(n(r));return l=15}if(a(r))return d++,g+=String.fromCharCode(r),13===r&&10===e.charCodeAt(d)&&(d++,g+="\n"),l=14;switch(r){case 123:return d++,l=1;case 125:return d++,l=2;case 91:return d++,l=3;case 93:return d++,l=4;case 58:return d++,l=6;case 44:return d++,l=5;case 34:return d++,g=u(),l=10;case 47:var t=d-1;if(47===e.charCodeAt(d+1)){for(d+=2;C>d&&!a(e.charCodeAt(d));)d++;return g=e.substring(t,d),l=12}if(42===e.charCodeAt(d+1)){d+=2;for(var o=C-1,i=!1;o>d;){var h=e.charCodeAt(d);if(42===h&&47===e.charCodeAt(d+1)){d+=2,i=!0;break}d++}return i||(d++,A=1),g=e.substring(t,d),l=13}return g+=String.fromCharCode(r),d++,l=16;case 45:if(g+=String.fromCharCode(r),d++,d===C||!c(e.charCodeAt(d)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=s(),l=11;default:for(;C>d&&f(r);)d++,r=e.charCodeAt(d);if(b!==d){switch(g=e.substring(b,d)){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return g+=String.fromCharCode(r),d++,l=16}}function f(e){if(n(e)||a(e))return!1;switch(e){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function h(){var e;do e=i();while(e>=12&&15>=e);return e}void 0===r&&(r=!1);var d=0,C=e.length,g="",b=0,l=16,A=0;return{setPosition:o,getPosition:function(){return d},scan:r?h:i,getToken:function(){return l},getTokenValue:function(){return g},getTokenOffset:function(){return b},getTokenLength:function(){return d-b},getTokenError:function(){return A}}}function n(e){return 32===e||9===e||11===e||12===e||160===e||5760===e||e>=8192&&8203>=e||8239===e||8287===e||12288===e||65279===e}function a(e){return 10===e||13===e||8232===e||8233===e}function c(e){return e>=48&&57>=e}Object.defineProperty(r,"__esModule",{value:!0}),r.createScanner=t});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/edit.js*/
define("98ab305",function(e,t){"use strict";function n(e,t,n){return r(e,t,void 0,n)}function r(e,t,n,r,o){for(var i,l=t.slice(),s=[],c=h.parseTree(e,s),d=void 0,g=void 0;l.length>0&&(g=l.pop(),d=h.findNodeAtLocation(c,l),void 0===d&&void 0!==n);)"string"==typeof g?(i={},i[g]=n,n=i):n=[n];if(d){if("object"===d.type&&"string"==typeof g&&Array.isArray(d.children)){var a=h.findNodeAtLocation(d,[g]);if(void 0!==a){if(void 0===n){if(!a.parent)throw new Error("Malformed AST");var v=d.children.indexOf(a.parent),u=void 0,p=a.parent.offset+a.parent.length;if(v>0){var y=d.children[v-1];u=y.offset+y.length}else if(u=d.offset+1,d.children.length>1){var m=d.children[1];p=m.offset}return f(e,{offset:u,length:p-u,content:""},r)}return f(e,{offset:a.offset,length:a.length,content:JSON.stringify(n)},r)}if(void 0===n)return[];var O=JSON.stringify(g)+": "+JSON.stringify(n),b=o?o(d.children.map(function(e){return e.children[0].value})):d.children.length,A=void 0;if(b>0){var y=d.children[b-1];A={offset:y.offset+y.length,length:0,content:","+O}}else A=0===d.children.length?{offset:d.offset+1,length:0,content:O}:{offset:d.offset+1,length:0,content:O+","};return f(e,A,r)}if("array"===d.type&&"number"==typeof g&&Array.isArray(d.children)){var w=g;if(-1===w){var O=""+JSON.stringify(n),A=void 0;if(0===d.children.length)A={offset:d.offset+1,length:0,content:O};else{var y=d.children[d.children.length-1];A={offset:y.offset+y.length,length:0,content:","+O}}return f(e,A,r)}if(void 0===n&&d.children.length>=0){var E=g,N=d.children[E],A=void 0;if(1===d.children.length)A={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===E){var y=d.children[E-1],S=y.offset+y.length,J=d.offset+d.length;A={offset:S,length:J-2-S,content:""}}else A={offset:N.offset,length:d.children[E+1].offset-N.offset,content:""};return f(e,A,r)}throw new Error("Array modification not supported yet")}throw new Error("Can not add "+("number"!=typeof g?"index":"property")+" to parent of type "+d.type)}if(void 0===n)throw new Error("Can not delete in empty document");return f(e,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(n)},r)}function f(e,t,n){var r=o(e,t),f=t.offset,i=t.offset+t.content.length;if(0===t.length||0===t.content.length){for(;f>0&&!l.isEOL(r,f-1);)f--;for(;i<r.length&&!l.isEOL(r,i);)i++}for(var h=l.format(r,{offset:f,length:i-f},n),s=h.length-1;s>=0;s--){var c=h[s];r=o(r,c),f=Math.min(f,c.offset),i=Math.max(i,c.offset+c.length),i+=c.content.length-c.length}var d=e.length-(r.length-i)-f;return[{offset:f,length:d,content:r.substring(f,i)}]}function o(e,t){return e.substring(0,t.offset)+t.content+e.substring(t.offset+t.length)}function i(e,t){return-1!=="\r\n 	".indexOf(e.charAt(t))}Object.defineProperty(t,"__esModule",{value:!0});var l=e("86b561e"),h=e("38cea32");t.removeProperty=n,t.setProperty=r,t.applyEdit=o,t.isWS=i});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/format.js*/
define("86b561e",function(e,r){"use strict";function n(e,r,n){function o(){return T+t(O,g+A)}function i(){var e=S.scan();for(d=!1;15===e||14===e;)d=d||14===e,e=S.scan();return p=16===e||0!==S.getTokenError(),e}function u(r,n,t){!p&&l>n&&t>k&&e.substring(n,t)!==r&&L.push({offset:n,length:t-n,content:r})}var g,h,v,k,l;if(r){for(k=r.offset,l=k+r.length,v=k;v>0&&!s(e,v-1);)v--;for(var b=l;b<e.length&&!s(e,b);)b++;h=e.substring(v,b),g=a(h,n)}else h=e,g=0,v=0,k=0,l=e.length;var O,T=f(n,e),d=!1,A=0;O=n.insertSpaces?t(" ",n.tabSize||4):"	";var S=c.createScanner(h,!1),p=!1,L=[],m=i();if(17!==m){var z=S.getTokenOffset()+v,E=t(O,g);u(E,v,z)}for(;17!==m;){for(var M=S.getTokenOffset()+S.getTokenLength()+v,_=i(),j="";!d&&(12===_||13===_);){var w=S.getTokenOffset()+v;u(" ",M,w),M=S.getTokenOffset()+S.getTokenLength()+v,j=12===_?o():"",_=i()}if(2===_)1!==m&&(A--,j=o());else if(4===_)3!==m&&(A--,j=o());else{switch(m){case 3:case 1:A++,j=o();break;case 5:case 12:j=o();break;case 13:j=d?o():" ";break;case 6:j=" ";break;case 10:if(6===_){j="";break}case 7:case 8:case 9:case 11:case 2:case 4:12===_||13===_?j=" ":5!==_&&17!==_&&(p=!0);break;case 16:p=!0}!d||12!==_&&13!==_||(j=o())}var x=S.getTokenOffset()+v;u(j,M,x),m=_}return L}function t(e,r){for(var n="",t=0;r>t;t++)n+=e;return n}function a(e,r){for(var n=0,t=0,a=r.tabSize||4;n<e.length;){var f=e.charAt(n);if(" "===f)t++;else{if("	"!==f)break;t+=a}n++}return Math.floor(t/a)}function f(e,r){for(var n=0;n<r.length;n++){var t=r.charAt(n);if("\r"===t)return n+1<r.length&&"\n"===r.charAt(n+1)?"\r\n":"\r";if("\n"===t)return"\n"}return e&&e.eol||"\n"}function s(e,r){return-1!=="\r\n".indexOf(e.charAt(r))}Object.defineProperty(r,"__esModule",{value:!0});var c=e("aedc3c9");r.format=n,r.isEOL=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-uri/index.js*/
define("a199806",function(t,e){"use strict";function r(t){if(t.scheme&&!c.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path)if(t.authority){if(!p.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(d.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}function n(t,e){switch(t){case"https":case"http":case"file":e?e[0]!==y&&(e=y+e):e=y}return e}function o(t,e){for(var r=void 0,n=-1,o=0;o<t.length;o++){var i=t.charCodeAt(o);if(i>=97&&122>=i||i>=65&&90>=i||i>=48&&57>=i||45===i||46===i||95===i||126===i||e&&47===i)-1!==n&&(r+=encodeURIComponent(t.substring(n,o)),n=-1),void 0!==r&&(r+=t.charAt(o));else{void 0===r&&(r=t.substr(0,o));var h=C[i];void 0!==h?(-1!==n&&(r+=encodeURIComponent(t.substring(n,o)),n=-1),r+=h):-1===n&&(n=o)}}return-1!==n&&(r+=encodeURIComponent(t.substring(n))),void 0!==r?r:t}function i(t){for(var e=void 0,r=0;r<t.length;r++){var n=t.charCodeAt(r);35===n||63===n?(void 0===e&&(e=t.substr(0,r)),e+=C[n]):void 0!==e&&(e+=t[r])}return void 0!==e?e:t}function h(t){var e;return e=t.authority&&t.path.length>1&&"file"===t.scheme?"//"+t.authority+t.path:47===t.path.charCodeAt(0)&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&58===t.path.charCodeAt(2)?t.path[1].toLowerCase()+t.path.substr(2):t.path,s&&(e=e.replace(/\//g,"\\")),e}function a(t,e){var r=e?i:o,n="",h=t.scheme,a=t.authority,s=t.path,u=t.query,f=t.fragment;if(h&&(n+=h,n+=":"),(a||"file"===h)&&(n+=y,n+=y),a){var c=a.indexOf("@");if(-1!==c){var p=a.substr(0,c);a=a.substr(c+1),c=p.indexOf(":"),-1===c?n+=r(p,!1):(n+=r(p.substr(0,c),!1),n+=":",n+=r(p.substr(c+1),!1)),n+="@"}a=a.toLowerCase(),c=a.indexOf(":"),-1===c?n+=r(a,!1):(n+=r(a.substr(0,c),!1),n+=a.substr(c))}if(s){if(s.length>=3&&47===s.charCodeAt(0)&&58===s.charCodeAt(2)){var d=s.charCodeAt(1);d>=65&&90>=d&&(s="/"+String.fromCharCode(d+32)+":"+s.substr(3))}else if(s.length>=2&&58===s.charCodeAt(1)){var d=s.charCodeAt(0);d>=65&&90>=d&&(s=String.fromCharCode(d+32)+":"+s.substr(2))}n+=r(s,!0)}return u&&(n+="?",n+=r(u,!1)),f&&(n+="#",n+=e?f:o(f,!1)),n}Object.defineProperty(e,"__esModule",{value:!0});var s,u=this&&this.__extends||function(){var t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])};return function(e,r){function n(){this.constructor=e}t(e,r),e.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}();if("object"==typeof navigator){var f=navigator.userAgent;s=f.indexOf("Windows")>=0}var c=/^\w[\w\d+.-]*$/,p=/^\//,d=/^\/\//,m="",y="/",l=/^(([^:\/?#]+?):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,g=function(){function t(t,e,o,i,h){"object"==typeof t?(this.scheme=t.scheme||m,this.authority=t.authority||m,this.path=t.path||m,this.query=t.query||m,this.fragment=t.fragment||m):(this.scheme=t||m,this.authority=e||m,this.path=n(this.scheme,o||m),this.query=i||m,this.fragment=h||m,r(this))}return t.isUri=function(e){return e instanceof t?!0:e?"string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme:!1},Object.defineProperty(t.prototype,"fsPath",{get:function(){return h(this)},enumerable:!0,configurable:!0}),t.prototype.with=function(t){if(!t)return this;var e=t.scheme,r=t.authority,n=t.path,o=t.query,i=t.fragment;return void 0===e?e=this.scheme:null===e&&(e=m),void 0===r?r=this.authority:null===r&&(r=m),void 0===n?n=this.path:null===n&&(n=m),void 0===o?o=this.query:null===o&&(o=m),void 0===i?i=this.fragment:null===i&&(i=m),e===this.scheme&&r===this.authority&&n===this.path&&o===this.query&&i===this.fragment?this:new b(e,r,n,o,i)},t.parse=function(t){var e=l.exec(t);return e?new b(e[2]||m,decodeURIComponent(e[4]||m),decodeURIComponent(e[5]||m),decodeURIComponent(e[7]||m),decodeURIComponent(e[9]||m)):new b(m,m,m,m,m)},t.file=function(t){var e=m;if(s&&(t=t.replace(/\\/g,y)),t[0]===y&&t[1]===y){var r=t.indexOf(y,2);-1===r?(e=t.substring(2),t=y):(e=t.substring(2,r),t=t.substring(r)||y)}return new b("file",e,t,m,m)},t.from=function(t){return new b(t.scheme,t.authority,t.path,t.query,t.fragment)},t.prototype.toString=function(t){return void 0===t&&(t=!1),a(this,t)},t.prototype.toJSON=function(){return this},t.revive=function(e){if(e){if(e instanceof t)return e;var r=new b(e);return r._fsPath=e.fsPath,r._formatted=e.external,r}return e},t}();e.default=g;var v,b=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e._formatted=null,e._fsPath=null,e}return u(e,t),Object.defineProperty(e.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=h(this)),this._fsPath},enumerable:!0,configurable:!0}),e.prototype.toString=function(t){return void 0===t&&(t=!1),t?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)},e.prototype.toJSON=function(){var t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t},e}(g),C=(v={},v[58]="%3A",v[47]="%2F",v[63]="%3F",v[35]="%23",v[91]="%5B",v[93]="%5D",v[64]="%40",v[33]="%21",v[36]="%24",v[38]="%26",v[39]="%27",v[40]="%28",v[41]="%29",v[42]="%2A",v[43]="%2B",v[44]="%2C",v[59]="%3B",v[61]="%3D",v[32]="%20",v)});
/**! node_modules/monaco-editor/esm/vs/language/json/fillers/vscode-nls.js*/
define("60eaf5a",function(e,n){"use strict";function r(e,n){var r;return r=0===n.length?e:e.replace(/\{(\d+)\}/g,function(e,r){var t=r[0];return"undefined"!=typeof n[t]?n[t]:e})}function t(e,n){for(var t=[],u=2;u<arguments.length;u++)t[u-2]=arguments[u];return r(n,t)}function u(){return t}function f(){return u}Object.defineProperty(n,"__esModule",{value:!0}),n.loadMessageBundle=u,n.config=f});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/utils/objects.js*/
define("de6a48e",function(r,e){"use strict";function n(r,e){if(r===e)return!0;if(null===r||void 0===r||null===e||void 0===e)return!1;if(typeof r!=typeof e)return!1;if("object"!=typeof r)return!1;if(Array.isArray(r)!==Array.isArray(e))return!1;var t,i;if(Array.isArray(r)){if(r.length!==e.length)return!1;for(t=0;t<r.length;t++)if(!n(r[t],e[t]))return!1}else{var f=[];for(i in r)f.push(i);f.sort();var u=[];for(i in e)u.push(i);if(u.sort(),!n(f,u))return!1;for(t=0;t<f.length;t++)if(!n(r[f[t]],e[f[t]]))return!1}return!0}function t(r){return"number"==typeof r}function i(r){return"undefined"!=typeof r}function f(r){return"boolean"==typeof r}function u(r){return"string"==typeof r}Object.defineProperty(e,"__esModule",{value:!0}),e.equals=n,e.isNumber=t,e.isDefined=i,e.isBoolean=f,e.isString=u});
/**! node_modules/monaco-editor/esm/vs/base/common/linkedList.js*/
define("45886bc",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=e("6ad26fe"),i=function(){function e(t){this.element=t,this.next=e.Undefined,this.prev=e.Undefined}return e.Undefined=new e(void 0),e}(),r=function(){function e(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}return Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.isEmpty=function(){return this._first===i.Undefined},e.prototype.clear=function(){this._first=i.Undefined,this._last=i.Undefined,this._size=0},e.prototype.unshift=function(e){return this._insert(e,!1)},e.prototype.push=function(e){return this._insert(e,!0)},e.prototype._insert=function(e,t){var n=this,r=new i(e);if(this._first===i.Undefined)this._first=r,this._last=r;else if(t){var s=this._last;this._last=r,r.prev=s,s.next=r}else{var f=this._first;this._first=r,r.next=f,f.prev=r}this._size+=1;var d=!1;return function(){d||(d=!0,n._remove(r))}},e.prototype.shift=function(){if(this._first===i.Undefined)return void 0;var e=this._first.element;return this._remove(this._first),e},e.prototype._remove=function(e){if(e.prev!==i.Undefined&&e.next!==i.Undefined){var t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===i.Undefined&&e.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):e.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):e.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1},e.prototype.iterator=function(){var e,t=this._first;return{next:function(){return t===i.Undefined?n.FIN:(e?e.value=t.element:e={done:!1,value:t.element},t=t.next,e)}}},e.prototype.toArray=function(){for(var e=[],t=this._first;t!==i.Undefined;t=t.next)e.push(t.element);return e},e}();t.LinkedList=r});
/**! node_modules/monaco-editor/esm/vs/base/common/functional.js*/
define("4af2228",function(e,n){"use strict";function t(e){var n,t=this,r=!1;return function(){return r?n:(r=!0,n=e.apply(t,arguments))}}Object.defineProperty(n,"__esModule",{value:!0}),n.once=t});
/**! node_modules/monaco-editor/esm/vs/base/common/event.js*/
define("8451667",function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n=this&&this.__extends||function(){var t=function(e,n){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(e,n)};return function(e,n){function i(){this.constructor=e}t(e,n),e.prototype=null===n?Object.create(n):(i.prototype=n.prototype,new i)}}(),i=t("22e50b6"),r=t("4af2228"),o=t("a0b8cca"),s=t("45886bc");!function(t){function e(t){return function(e,n,i){void 0===n&&(n=null);var r,o=!1;return r=t(function(t){return o?void 0:(r?r.dispose():o=!0,e.call(n,t))},null,i),o&&r.dispose(),r}}function n(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){return n.call(i,e(t))},null,r)})}function i(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){e(t),n.call(i,t)},null,r)})}function r(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){return e(t)&&n.call(i,t)},null,r)})}function s(t){return t}function u(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];return function(e,n,i){return void 0===n&&(n=null),o.combinedDisposable(t.map(function(t){return t(function(t){return e.call(n,t)},null,i)}))}}function c(t,e,i){var r=i;return n(t,function(t){return r=e(r,t)})}function a(t){var e,n=new f({onFirstListenerAdd:function(){e=t(n.fire,n)},onLastListenerRemove:function(){e.dispose()}});return n.event}function h(t,e,n,i,r){void 0===n&&(n=100),void 0===i&&(i=!1);var o,s=void 0,u=void 0,c=0,a=new f({leakWarningThreshold:r,onFirstListenerAdd:function(){o=t(function(t){c++,s=e(s,t),i&&!u&&a.fire(s),clearTimeout(u),u=setTimeout(function(){var t=s;s=void 0,u=void 0,(!i||c>1)&&a.fire(t),c=0},n)})},onLastListenerRemove:function(){o.dispose()}});return a.event}function p(t){var i=(new Date).getTime();return n(e(t),function(){return(new Date).getTime()-i})}function v(t){var e,n=!0;return r(t,function(t){var i=n||t!==e;return n=!1,e=t,i})}function l(t,e,n){void 0===e&&(e=!1),void 0===n&&(n=[]);var i=n.slice(),r=t(function(t){i?i.push(t):s.fire(t)}),o=function(){i&&i.forEach(function(t){return s.fire(t)}),i=null},s=new f({onFirstListenerAdd:function(){r||(r=t(function(t){return s.fire(t)}))},onFirstListenerDidAdd:function(){i&&(e?setTimeout(o):o())},onLastListenerRemove:function(){r&&r.dispose(),r=null}});return s.event}function d(t){return new w(t)}function _(t,e,n){void 0===n&&(n=function(t){return t});var i=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];return s.fire(n.apply(void 0,t))},r=function(){return t.on(e,i)},o=function(){return t.removeListener(e,i)},s=new f({onFirstListenerAdd:r,onLastListenerRemove:o});return s.event}function m(t){var e=new f,n=!1;return t.then(void 0,function(){return null}).then(function(){n?e.fire(void 0):setTimeout(function(){return e.fire(void 0)},0)}),n=!0,e.event}function y(t){return new Promise(function(n){return e(t)(n)})}var L={dispose:function(){}};t.None=function(){return L},t.once=e,t.map=n,t.forEach=i,t.filter=r,t.signal=s,t.any=u,t.reduce=c,t.snapshot=a,t.debounce=h,t.stopwatch=p,t.latch=v,t.buffer=l;var w=function(){function t(t){this.event=t}return t.prototype.map=function(e){return new t(n(this.event,e))},t.prototype.forEach=function(e){return new t(i(this.event,e))},t.prototype.filter=function(e){return new t(r(this.event,e))},t.prototype.reduce=function(e,n){return new t(c(this.event,e,n))},t.prototype.latch=function(){return new t(v(this.event))},t.prototype.on=function(t,e,n){return this.event(t,e,n)},t.prototype.once=function(t,n,i){return e(this.event)(t,n,i)},t}();t.chain=d,t.fromNodeEventEmitter=_,t.fromPromise=m,t.toPromise=y}(e.Event||(e.Event={}));var u=-1,c=function(){function t(t,e){void 0===e&&(e=Math.random().toString(18).slice(2,5)),this.customThreshold=t,this.name=e,this._warnCountdown=0}return t.prototype.dispose=function(){this._stacks&&this._stacks.clear()},t.prototype.check=function(t){var e=this,n=u;if("number"==typeof this.customThreshold&&(n=this.customThreshold),0>=n||n>t)return void 0;this._stacks||(this._stacks=new Map);var i=(new Error).stack.split("\n").slice(3).join("\n"),r=this._stacks.get(i)||0;if(this._stacks.set(i,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=.5*n;var o,s=0;this._stacks.forEach(function(t,e){(!o||t>s)&&(o=e,s=t)}),console.warn("["+this.name+"] potential listener LEAK detected, having "+t+" listeners already. MOST frequent listener ("+s+"):"),console.warn(o)}return function(){var t=e._stacks.get(i)||0;e._stacks.set(i,t-1)}},t}(),f=function(){function t(t){this._disposed=!1,this._options=t,this._leakageMon=u>0?new c(this._options&&this._options.leakWarningThreshold):void 0}return Object.defineProperty(t.prototype,"event",{get:function(){var e=this;return this._event||(this._event=function(n,i,r){e._listeners||(e._listeners=new s.LinkedList);var o=e._listeners.isEmpty();o&&e._options&&e._options.onFirstListenerAdd&&e._options.onFirstListenerAdd(e);var u=e._listeners.push(i?[n,i]:n);o&&e._options&&e._options.onFirstListenerDidAdd&&e._options.onFirstListenerDidAdd(e),e._options&&e._options.onListenerDidAdd&&e._options.onListenerDidAdd(e,n,i);var c;e._leakageMon&&(c=e._leakageMon.check(e._listeners.size));var f;return f={dispose:function(){if(c&&c(),f.dispose=t._noop,!e._disposed&&(u(),e._options&&e._options.onLastListenerRemove)){var n=e._listeners&&!e._listeners.isEmpty();n||e._options.onLastListenerRemove(e)}}},Array.isArray(r)&&r.push(f),f}),this._event},enumerable:!0,configurable:!0}),t.prototype.fire=function(t){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(var e=this._listeners.iterator(),n=e.next();!n.done;n=e.next())this._deliveryQueue.push([n.value,t]);for(;this._deliveryQueue.size>0;){var r=this._deliveryQueue.shift(),o=r[0],u=r[1];try{"function"==typeof o?o.call(void 0,u):o[0].call(o[1],u)}catch(n){i.onUnexpectedError(n)}}}},t.prototype.dispose=function(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),this._disposed=!0},t._noop=function(){},t}();e.Emitter=f;var a=function(t){function e(e){var n=t.call(this,e)||this;return n._isPaused=0,n._eventQueue=new s.LinkedList,n._mergeFn=e&&e.merge,n}return n(e,t),e.prototype.pause=function(){this._isPaused++},e.prototype.resume=function(){if(0!==this._isPaused&&0===--this._isPaused)if(this._mergeFn){var e=this._eventQueue.toArray();this._eventQueue.clear(),t.prototype.fire.call(this,this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)t.prototype.fire.call(this,this._eventQueue.shift())},e.prototype.fire=function(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):t.prototype.fire.call(this,e))},e}(f);e.PauseableEmitter=a;var h=function(){function t(){var t=this;this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:function(){return t.onFirstListenerAdd()},onLastListenerRemove:function(){return t.onLastListenerRemove()}})}return Object.defineProperty(t.prototype,"event",{get:function(){return this.emitter.event},enumerable:!0,configurable:!0}),t.prototype.add=function(t){var e=this,n={event:t,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);var i=function(){e.hasListeners&&e.unhook(n);var t=e.events.indexOf(n);e.events.splice(t,1)};return o.toDisposable(r.once(i))},t.prototype.onFirstListenerAdd=function(){var t=this;this.hasListeners=!0,this.events.forEach(function(e){return t.hook(e)})},t.prototype.onLastListenerRemove=function(){var t=this;this.hasListeners=!1,this.events.forEach(function(e){return t.unhook(e)})},t.prototype.hook=function(t){var e=this;t.listener=t.event(function(t){return e.emitter.fire(t)})},t.prototype.unhook=function(t){t.listener&&t.listener.dispose(),t.listener=null},t.prototype.dispose=function(){this.emitter.dispose()},t}();e.EventMultiplexer=h;var p=function(){function t(){this.buffers=[]}return t.prototype.wrapEvent=function(t){var e=this;return function(n,i,r){return t(function(t){var r=e.buffers[e.buffers.length-1];r?r.push(function(){return n.call(i,t)}):n.call(i,t)},void 0,r)}},t.prototype.bufferEvents=function(t){var e=[];this.buffers.push(e);var n=t();return this.buffers.pop(),e.forEach(function(t){return t()}),n},t}();e.EventBufferer=p;var v=function(){function t(){var t=this;this.listening=!1,this.inputEvent=e.Event.None,this.inputEventListener=o.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:function(){t.listening=!0,t.inputEventListener=t.inputEvent(t.emitter.fire,t.emitter)},onLastListenerRemove:function(){t.listening=!1,t.inputEventListener.dispose()}}),this.event=this.emitter.event}return Object.defineProperty(t.prototype,"input",{set:function(t){this.inputEvent=t,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=t(this.emitter.fire,this.emitter))},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){this.inputEventListener.dispose(),this.emitter.dispose()},t}();e.Relay=v});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/uint.js*/
define("4186ef1",function(t,n){"use strict";function r(t){return 0>t?0:t>255?255:0|t}function i(t){return 0>t?0:t>4294967295?4294967295:0|t}function e(t){for(var n=t.length,r=new Uint32Array(n),e=0;n>e;e++)r[e]=i(t[e]);return r}Object.defineProperty(n,"__esModule",{value:!0});var o=function(){function t(t,n,r){for(var i=new Uint8Array(t*n),e=0,o=t*n;o>e;e++)i[e]=r;this._data=i,this.rows=t,this.cols=n}return t.prototype.get=function(t,n){return this._data[t*this.cols+n]},t.prototype.set=function(t,n,r){this._data[t*this.cols+n]=r},t}();n.Uint8Matrix=o,n.toUint8=r,n.toUint32=i,n.toUint32Array=e});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/uint.js*/
define("4186ef1",function(t,n){"use strict";function r(t){return 0>t?0:t>255?255:0|t}function i(t){return 0>t?0:t>4294967295?4294967295:0|t}function e(t){for(var n=t.length,r=new Uint32Array(n),e=0;n>e;e++)r[e]=i(t[e]);return r}Object.defineProperty(n,"__esModule",{value:!0});var o=function(){function t(t,n,r){for(var i=new Uint8Array(t*n),e=0,o=t*n;o>e;e++)i[e]=r;this._data=i,this.rows=t,this.cols=n}return t.prototype.get=function(t,n){return this._data[t*this.cols+n]},t.prototype.set=function(t,n,r){this._data[t*this.cols+n]=r},t}();n.Uint8Matrix=o,n.toUint8=r,n.toUint32=i,n.toUint32Array=e});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/parser.js*/
define("38cea32",function(e,n){"use strict";function r(e,n){function r(e,n,r,t){a.value=e,a.offset=n,a.length=r,a.type=t,a.colonOffset=void 0,i=a}var t=[],o=new Object,i=void 0,a={value:{},offset:0,length:0,type:"object",parent:void 0},f=!1;try{l(e,{onObjectBegin:function(e){if(e>=n)throw o;i=void 0,f=n>e,t.push("")},onObjectProperty:function(e,i,a){if(i>n)throw o;if(r(e,i,a,"property"),t[t.length-1]=e,i+a>=n)throw o},onObjectEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onArrayBegin:function(e){if(e>=n)throw o;i=void 0,t.push(0)},onArrayEnd:function(e){if(e>=n)throw o;i=void 0,t.pop()},onLiteralValue:function(e,t,i){if(t>n)throw o;if(r(e,t,i,h(e)),t+i>=n)throw o},onSeparator:function(e,r){if(r>=n)throw o;if(":"===e&&i&&"property"===i.type)i.colonOffset=r,f=!1,i=void 0;else if(","===e){var a=t[t.length-1];"number"==typeof a?t[t.length-1]=a+1:(f=!0,t[t.length-1]=""),i=void 0}}})}catch(c){if(c!==o)throw c}return{path:t,previousNode:i,isAtPropertyKey:f,matches:function(e){for(var n=0,r=0;n<e.length&&r<t.length;r++)if(e[n]===t[r]||"*"===e[n])n++;else if("**"!==e[n])return!1;return n===e.length}}}function t(e,n,r){function t(e){Array.isArray(i)?i.push(e):o&&(i[o]=e)}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var o=null,i=[],a=[],f={onObjectBegin:function(){var e={};t(e),a.push(i),i=e,o=null},onObjectProperty:function(e){o=e},onObjectEnd:function(){i=a.pop()},onArrayBegin:function(){var e=[];t(e),a.push(i),i=e,o=null},onArrayEnd:function(){i=a.pop()},onLiteralValue:t,onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};return l(e,f,r),i[0]}function o(e,n,r){function t(e){"property"===i.type&&(i.length=e-i.offset,i=i.parent)}function o(e){return i.children.push(e),e}void 0===n&&(n=[]),void 0===r&&(r=p.DEFAULT);var i={type:"array",offset:-1,length:-1,children:[],parent:void 0},a={onObjectBegin:function(e){i=o({type:"object",offset:e,length:-1,parent:i,children:[]})},onObjectProperty:function(e,n,r){i=o({type:"property",offset:n,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:e,offset:n,length:r,parent:i})},onObjectEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onArrayBegin:function(e){i=o({type:"array",offset:e,length:-1,parent:i,children:[]})},onArrayEnd:function(e,n){i.length=e+n-i.offset,i=i.parent,t(e+n)},onLiteralValue:function(e,n,r){o({type:h(e),offset:n,length:r,parent:i,value:e}),t(n+r)},onSeparator:function(e,n){"property"===i.type&&(":"===e?i.colonOffset=n:","===e&&t(n))},onError:function(e,r,t){n.push({error:e,offset:r,length:t})}};l(e,a,r);var f=i.children[0];return f&&delete f.parent,f}function i(e,n){if(!e)return void 0;for(var r=e,t=0,o=n;t<o.length;t++){var i=o[t];if("string"==typeof i){if("object"!==r.type||!Array.isArray(r.children))return void 0;for(var a=!1,f=0,c=r.children;f<c.length;f++){var u=c[f];if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],a=!0;break}}if(!a)return void 0}else{var l=i;if("array"!==r.type||0>l||!Array.isArray(r.children)||l>=r.children.length)return void 0;r=r.children[l]}}return r}function a(e){if(!e.parent||!e.parent.children)return[];var n=a(e.parent);if("property"===e.parent.type){var r=e.parent.children[0].value;n.push(r)}else if("array"===e.parent.type){var t=e.parent.children.indexOf(e);-1!==t&&n.push(t)}return n}function f(e){switch(e.type){case"array":return e.children.map(f);case"object":for(var n=Object.create(null),r=0,t=e.children;r<t.length;r++){var o=t[r],i=o.children[1];i&&(n[o.children[0].value]=f(i))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return void 0}}function c(e,n,r){return void 0===r&&(r=!1),n>=e.offset&&n<e.offset+e.length||r&&n===e.offset+e.length}function u(e,n,r){if(void 0===r&&(r=!1),c(e,n,r)){var t=e.children;if(Array.isArray(t))for(var o=0;o<t.length&&t[o].offset<=n;o++){var i=u(t[o],n,r);if(i)return i}return e}return void 0}function l(e,n,r){function t(e){return e?function(){return e(g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function o(e){return e?function(n){return e(n,g.getTokenOffset(),g.getTokenLength())}:function(){return!0}}function i(){for(;;){var e=g.scan();switch(g.getTokenError()){case 4:a(14);break;case 5:a(15);break;case 3:a(13);break;case 1:m||a(11);break;case 2:a(12);break;case 6:a(16)}switch(e){case 12:case 13:m?a(10):w();break;case 16:a(1);break;case 15:case 14:break;default:return e}}}function a(e,n,r){if(void 0===n&&(n=[]),void 0===r&&(r=[]),j(e),n.length+r.length>0)for(var t=g.getToken();17!==t;){if(-1!==n.indexOf(t)){i();break}if(-1!==r.indexOf(t))break;t=i()}}function f(e){var n=g.getTokenValue();return e?A(n):y(n),i(),!0}function c(){switch(g.getToken()){case 11:var e=0;try{e=JSON.parse(g.getTokenValue()),"number"!=typeof e&&(a(2),e=0)}catch(n){a(2)}A(e);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return i(),!0}function u(){return 10!==g.getToken()?(a(3,[],[2,5]),!1):(f(!1),6===g.getToken()?(O(":"),i(),h()||a(4,[],[2,5])):a(5,[],[2,5]),!0)}function l(){v(),i();for(var e=!1;2!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),2===g.getToken()&&E)break}else e&&a(6,[],[]);u()||a(4,[],[2,5]),e=!0}return b(),2!==g.getToken()?a(7,[2],[]):i(),!0}function s(){k(),i();for(var e=!1;4!==g.getToken()&&17!==g.getToken();){if(5===g.getToken()){if(e||a(4,[],[]),O(","),i(),4===g.getToken()&&E)break}else e&&a(6,[],[]);h()||a(4,[],[4,5]),e=!0}return T(),4!==g.getToken()?a(8,[4],[]):i(),!0}function h(){switch(g.getToken()){case 3:return s();case 1:return l();case 10:return f(!0);default:return c()}}void 0===r&&(r=p.DEFAULT);var g=d.createScanner(e,!1),v=t(n.onObjectBegin),y=o(n.onObjectProperty),b=t(n.onObjectEnd),k=t(n.onArrayBegin),T=t(n.onArrayEnd),A=o(n.onLiteralValue),O=o(n.onSeparator),w=t(n.onComment),j=o(n.onError),m=r&&r.disallowComments,E=r&&r.allowTrailingComma;return i(),17===g.getToken()?!0:h()?(17!==g.getToken()&&a(9,[],[]),!0):(a(4,[],[]),!1)}function s(e,n){var r,t,o=d.createScanner(e),i=[],a=0;do switch(t=o.getPosition(),r=o.scan()){case 12:case 13:case 17:a!==t&&i.push(e.substring(a,t)),void 0!==n&&i.push(o.getTokenValue().replace(/[^\r\n]/g,n)),a=o.getPosition()}while(17!==r);return i.join("")}function h(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";default:return"null"}}Object.defineProperty(n,"__esModule",{value:!0});var p,d=e("aedc3c9");!function(e){e.DEFAULT={allowTrailingComma:!1}}(p||(p={})),n.getLocation=r,n.parse=t,n.parseTree=o,n.findNodeAtLocation=i,n.getNodePath=a,n.getNodeValue=f,n.contains=c,n.findNodeAtOffset=u,n.visit=l,n.stripComments=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/scanner.js*/
define("aedc3c9",function(e,r){"use strict";function t(e,r){function t(r,t){for(var n=0,a=0;r>n||!t;){var c=e.charCodeAt(d);if(c>=48&&57>=c)a=16*a+c-48;else if(c>=65&&70>=c)a=16*a+c-65+10;else{if(!(c>=97&&102>=c))break;a=16*a+c-97+10}d++,n++}return r>n&&(a=-1),a}function o(e){d=e,g="",b=0,l=16,A=0}function s(){var r=d;if(48===e.charCodeAt(d))d++;else for(d++;d<e.length&&c(e.charCodeAt(d));)d++;if(d<e.length&&46===e.charCodeAt(d)){if(d++,!(d<e.length&&c(e.charCodeAt(d))))return A=3,e.substring(r,d);for(d++;d<e.length&&c(e.charCodeAt(d));)d++}var t=d;if(d<e.length&&(69===e.charCodeAt(d)||101===e.charCodeAt(d)))if(d++,(d<e.length&&43===e.charCodeAt(d)||45===e.charCodeAt(d))&&d++,d<e.length&&c(e.charCodeAt(d))){for(d++;d<e.length&&c(e.charCodeAt(d));)d++;t=d}else A=3;return e.substring(r,t)}function u(){for(var r="",n=d;;){if(d>=C){r+=e.substring(n,d),A=2;break}var c=e.charCodeAt(d);if(34===c){r+=e.substring(n,d),d++;break}if(92!==c){if(c>=0&&31>=c){if(a(c)){r+=e.substring(n,d),A=2;break}A=6}d++}else{if(r+=e.substring(n,d),d++,d>=C){A=2;break}switch(c=e.charCodeAt(d++)){case 34:r+='"';break;case 92:r+="\\";break;case 47:r+="/";break;case 98:r+="\b";break;case 102:r+="\f";break;case 110:r+="\n";break;case 114:r+="\r";break;case 116:r+="	";break;case 117:var o=t(4,!0);o>=0?r+=String.fromCharCode(o):A=4;break;default:A=5}n=d}}return r}function i(){if(g="",A=0,b=d,d>=C)return b=C,l=17;var r=e.charCodeAt(d);if(n(r)){do d++,g+=String.fromCharCode(r),r=e.charCodeAt(d);while(n(r));return l=15}if(a(r))return d++,g+=String.fromCharCode(r),13===r&&10===e.charCodeAt(d)&&(d++,g+="\n"),l=14;switch(r){case 123:return d++,l=1;case 125:return d++,l=2;case 91:return d++,l=3;case 93:return d++,l=4;case 58:return d++,l=6;case 44:return d++,l=5;case 34:return d++,g=u(),l=10;case 47:var t=d-1;if(47===e.charCodeAt(d+1)){for(d+=2;C>d&&!a(e.charCodeAt(d));)d++;return g=e.substring(t,d),l=12}if(42===e.charCodeAt(d+1)){d+=2;for(var o=C-1,i=!1;o>d;){var h=e.charCodeAt(d);if(42===h&&47===e.charCodeAt(d+1)){d+=2,i=!0;break}d++}return i||(d++,A=1),g=e.substring(t,d),l=13}return g+=String.fromCharCode(r),d++,l=16;case 45:if(g+=String.fromCharCode(r),d++,d===C||!c(e.charCodeAt(d)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=s(),l=11;default:for(;C>d&&f(r);)d++,r=e.charCodeAt(d);if(b!==d){switch(g=e.substring(b,d)){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return g+=String.fromCharCode(r),d++,l=16}}function f(e){if(n(e)||a(e))return!1;switch(e){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function h(){var e;do e=i();while(e>=12&&15>=e);return e}void 0===r&&(r=!1);var d=0,C=e.length,g="",b=0,l=16,A=0;return{setPosition:o,getPosition:function(){return d},scan:r?h:i,getToken:function(){return l},getTokenValue:function(){return g},getTokenOffset:function(){return b},getTokenLength:function(){return d-b},getTokenError:function(){return A}}}function n(e){return 32===e||9===e||11===e||12===e||160===e||5760===e||e>=8192&&8203>=e||8239===e||8287===e||12288===e||65279===e}function a(e){return 10===e||13===e||8232===e||8233===e}function c(e){return e>=48&&57>=e}Object.defineProperty(r,"__esModule",{value:!0}),r.createScanner=t});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/edit.js*/
define("98ab305",function(e,t){"use strict";function n(e,t,n){return r(e,t,void 0,n)}function r(e,t,n,r,o){for(var i,l=t.slice(),s=[],c=h.parseTree(e,s),d=void 0,g=void 0;l.length>0&&(g=l.pop(),d=h.findNodeAtLocation(c,l),void 0===d&&void 0!==n);)"string"==typeof g?(i={},i[g]=n,n=i):n=[n];if(d){if("object"===d.type&&"string"==typeof g&&Array.isArray(d.children)){var a=h.findNodeAtLocation(d,[g]);if(void 0!==a){if(void 0===n){if(!a.parent)throw new Error("Malformed AST");var v=d.children.indexOf(a.parent),u=void 0,p=a.parent.offset+a.parent.length;if(v>0){var y=d.children[v-1];u=y.offset+y.length}else if(u=d.offset+1,d.children.length>1){var m=d.children[1];p=m.offset}return f(e,{offset:u,length:p-u,content:""},r)}return f(e,{offset:a.offset,length:a.length,content:JSON.stringify(n)},r)}if(void 0===n)return[];var O=JSON.stringify(g)+": "+JSON.stringify(n),b=o?o(d.children.map(function(e){return e.children[0].value})):d.children.length,A=void 0;if(b>0){var y=d.children[b-1];A={offset:y.offset+y.length,length:0,content:","+O}}else A=0===d.children.length?{offset:d.offset+1,length:0,content:O}:{offset:d.offset+1,length:0,content:O+","};return f(e,A,r)}if("array"===d.type&&"number"==typeof g&&Array.isArray(d.children)){var w=g;if(-1===w){var O=""+JSON.stringify(n),A=void 0;if(0===d.children.length)A={offset:d.offset+1,length:0,content:O};else{var y=d.children[d.children.length-1];A={offset:y.offset+y.length,length:0,content:","+O}}return f(e,A,r)}if(void 0===n&&d.children.length>=0){var E=g,N=d.children[E],A=void 0;if(1===d.children.length)A={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===E){var y=d.children[E-1],S=y.offset+y.length,J=d.offset+d.length;A={offset:S,length:J-2-S,content:""}}else A={offset:N.offset,length:d.children[E+1].offset-N.offset,content:""};return f(e,A,r)}throw new Error("Array modification not supported yet")}throw new Error("Can not add "+("number"!=typeof g?"index":"property")+" to parent of type "+d.type)}if(void 0===n)throw new Error("Can not delete in empty document");return f(e,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(n)},r)}function f(e,t,n){var r=o(e,t),f=t.offset,i=t.offset+t.content.length;if(0===t.length||0===t.content.length){for(;f>0&&!l.isEOL(r,f-1);)f--;for(;i<r.length&&!l.isEOL(r,i);)i++}for(var h=l.format(r,{offset:f,length:i-f},n),s=h.length-1;s>=0;s--){var c=h[s];r=o(r,c),f=Math.min(f,c.offset),i=Math.max(i,c.offset+c.length),i+=c.content.length-c.length}var d=e.length-(r.length-i)-f;return[{offset:f,length:d,content:r.substring(f,i)}]}function o(e,t){return e.substring(0,t.offset)+t.content+e.substring(t.offset+t.length)}function i(e,t){return-1!=="\r\n 	".indexOf(e.charAt(t))}Object.defineProperty(t,"__esModule",{value:!0});var l=e("86b561e"),h=e("38cea32");t.removeProperty=n,t.setProperty=r,t.applyEdit=o,t.isWS=i});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/impl/format.js*/
define("86b561e",function(e,r){"use strict";function n(e,r,n){function o(){return T+t(O,g+A)}function i(){var e=S.scan();for(d=!1;15===e||14===e;)d=d||14===e,e=S.scan();return p=16===e||0!==S.getTokenError(),e}function u(r,n,t){!p&&l>n&&t>k&&e.substring(n,t)!==r&&L.push({offset:n,length:t-n,content:r})}var g,h,v,k,l;if(r){for(k=r.offset,l=k+r.length,v=k;v>0&&!s(e,v-1);)v--;for(var b=l;b<e.length&&!s(e,b);)b++;h=e.substring(v,b),g=a(h,n)}else h=e,g=0,v=0,k=0,l=e.length;var O,T=f(n,e),d=!1,A=0;O=n.insertSpaces?t(" ",n.tabSize||4):"	";var S=c.createScanner(h,!1),p=!1,L=[],m=i();if(17!==m){var z=S.getTokenOffset()+v,E=t(O,g);u(E,v,z)}for(;17!==m;){for(var M=S.getTokenOffset()+S.getTokenLength()+v,_=i(),j="";!d&&(12===_||13===_);){var w=S.getTokenOffset()+v;u(" ",M,w),M=S.getTokenOffset()+S.getTokenLength()+v,j=12===_?o():"",_=i()}if(2===_)1!==m&&(A--,j=o());else if(4===_)3!==m&&(A--,j=o());else{switch(m){case 3:case 1:A++,j=o();break;case 5:case 12:j=o();break;case 13:j=d?o():" ";break;case 6:j=" ";break;case 10:if(6===_){j="";break}case 7:case 8:case 9:case 11:case 2:case 4:12===_||13===_?j=" ":5!==_&&17!==_&&(p=!0);break;case 16:p=!0}!d||12!==_&&13!==_||(j=o())}var x=S.getTokenOffset()+v;u(j,M,x),m=_}return L}function t(e,r){for(var n="",t=0;r>t;t++)n+=e;return n}function a(e,r){for(var n=0,t=0,a=r.tabSize||4;n<e.length;){var f=e.charAt(n);if(" "===f)t++;else{if("	"!==f)break;t+=a}n++}return Math.floor(t/a)}function f(e,r){for(var n=0;n<r.length;n++){var t=r.charAt(n);if("\r"===t)return n+1<r.length&&"\n"===r.charAt(n+1)?"\r\n":"\r";if("\n"===t)return"\n"}return e&&e.eol||"\n"}function s(e,r){return-1!=="\r\n".indexOf(e.charAt(r))}Object.defineProperty(r,"__esModule",{value:!0});var c=e("aedc3c9");r.format=n,r.isEOL=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/jsonLanguageTypes.js*/
define("683e3e1",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var t=e("737c70e");n.Range=t.Range,n.TextEdit=t.TextEdit,n.Color=t.Color,n.ColorInformation=t.ColorInformation,n.ColorPresentation=t.ColorPresentation,n.FoldingRange=t.FoldingRange,n.FoldingRangeKind=t.FoldingRangeKind,function(e){e.Empty="",e.Statement="statement",e.Declaration="declaration"}(n.SelectionRangeKind||(n.SelectionRangeKind={})),function(e){e[e.Undefined=0]="Undefined",e[e.EnumValueMismatch=1]="EnumValueMismatch",e[e.UnexpectedEndOfComment=257]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=258]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=259]="UnexpectedEndOfNumber",e[e.InvalidUnicode=260]="InvalidUnicode",e[e.InvalidEscapeCharacter=261]="InvalidEscapeCharacter",e[e.InvalidCharacter=262]="InvalidCharacter",e[e.PropertyExpected=513]="PropertyExpected",e[e.CommaExpected=514]="CommaExpected",e[e.ColonExpected=515]="ColonExpected",e[e.ValueExpected=516]="ValueExpected",e[e.CommaOrCloseBacketExpected=517]="CommaOrCloseBacketExpected",e[e.CommaOrCloseBraceExpected=518]="CommaOrCloseBraceExpected",e[e.TrailingComma=519]="TrailingComma",e[e.DuplicateKey=520]="DuplicateKey",e[e.CommentNotPermitted=521]="CommentNotPermitted",e[e.SchemaResolveError=768]="SchemaResolveError"}(n.ErrorCode||(n.ErrorCode={})),function(e){e.LATEST={textDocument:{completion:{completionItem:{documentationFormat:[t.MarkupKind.Markdown,t.MarkupKind.PlainText]}}}}}(n.ClientCapabilities||(n.ClientCapabilities={}))});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/main.js*/
define("26128d7",function(e,t){"use strict";function r(e){switch(e){case 1:return"InvalidSymbol";case 2:return"InvalidNumberFormat";case 3:return"PropertyNameExpected";case 4:return"ValueExpected";case 5:return"ColonExpected";case 6:return"CommaExpected";case 7:return"CloseBraceExpected";case 8:return"CloseBracketExpected";case 9:return"EndOfFileExpected";case 10:return"InvalidCommentToken";case 11:return"UnexpectedEndOfComment";case 12:return"UnexpectedEndOfString";case 13:return"UnexpectedEndOfNumber";case 14:return"InvalidUnicode";case 15:return"InvalidEscapeCharacter";case 16:return"InvalidCharacter"}return"<unknown ParseErrorCode>"}function n(e,t,r){return d.format(e,t,r)}function a(e,t,r,n){return i.setProperty(e,t,r,n.formattingOptions,n.getInsertionIndex)}function o(e,t){for(var r=t.length-1;r>=0;r--)e=i.applyEdit(e,t[r]);return e}Object.defineProperty(t,"__esModule",{value:!0});var c=e("11ed2ab"),d=c.__importStar(e("86b561e")),i=c.__importStar(e("98ab305")),s=c.__importStar(e("aedc3c9")),u=c.__importStar(e("38cea32"));t.createScanner=s.createScanner,t.getLocation=u.getLocation,t.parse=u.parse,t.parseTree=u.parseTree,t.findNodeAtLocation=u.findNodeAtLocation,t.findNodeAtOffset=u.findNodeAtOffset,t.getNodePath=u.getNodePath,t.getNodeValue=u.getNodeValue,t.visit=u.visit,t.stripComments=u.stripComments,t.printParseErrorCode=r,t.format=n,t.modify=a,t.applyEdits=o});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/jsonLanguageTypes.js*/
define("683e3e1",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var t=e("737c70e");n.Range=t.Range,n.TextEdit=t.TextEdit,n.Color=t.Color,n.ColorInformation=t.ColorInformation,n.ColorPresentation=t.ColorPresentation,n.FoldingRange=t.FoldingRange,n.FoldingRangeKind=t.FoldingRangeKind,function(e){e.Empty="",e.Statement="statement",e.Declaration="declaration"}(n.SelectionRangeKind||(n.SelectionRangeKind={})),function(e){e[e.Undefined=0]="Undefined",e[e.EnumValueMismatch=1]="EnumValueMismatch",e[e.UnexpectedEndOfComment=257]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=258]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=259]="UnexpectedEndOfNumber",e[e.InvalidUnicode=260]="InvalidUnicode",e[e.InvalidEscapeCharacter=261]="InvalidEscapeCharacter",e[e.InvalidCharacter=262]="InvalidCharacter",e[e.PropertyExpected=513]="PropertyExpected",e[e.CommaExpected=514]="CommaExpected",e[e.ColonExpected=515]="ColonExpected",e[e.ValueExpected=516]="ValueExpected",e[e.CommaOrCloseBacketExpected=517]="CommaOrCloseBacketExpected",e[e.CommaOrCloseBraceExpected=518]="CommaOrCloseBraceExpected",e[e.TrailingComma=519]="TrailingComma",e[e.DuplicateKey=520]="DuplicateKey",e[e.CommentNotPermitted=521]="CommentNotPermitted",e[e.SchemaResolveError=768]="SchemaResolveError"}(n.ErrorCode||(n.ErrorCode={})),function(e){e.LATEST={textDocument:{completion:{completionItem:{documentationFormat:[t.MarkupKind.Markdown,t.MarkupKind.PlainText]}}}}}(n.ClientCapabilities||(n.ClientCapabilities={}))});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/main.js*/
define("26128d7",function(e,t){"use strict";function r(e){switch(e){case 1:return"InvalidSymbol";case 2:return"InvalidNumberFormat";case 3:return"PropertyNameExpected";case 4:return"ValueExpected";case 5:return"ColonExpected";case 6:return"CommaExpected";case 7:return"CloseBraceExpected";case 8:return"CloseBracketExpected";case 9:return"EndOfFileExpected";case 10:return"InvalidCommentToken";case 11:return"UnexpectedEndOfComment";case 12:return"UnexpectedEndOfString";case 13:return"UnexpectedEndOfNumber";case 14:return"InvalidUnicode";case 15:return"InvalidEscapeCharacter";case 16:return"InvalidCharacter"}return"<unknown ParseErrorCode>"}function n(e,t,r){return d.format(e,t,r)}function a(e,t,r,n){return i.setProperty(e,t,r,n.formattingOptions,n.getInsertionIndex)}function o(e,t){for(var r=t.length-1;r>=0;r--)e=i.applyEdit(e,t[r]);return e}Object.defineProperty(t,"__esModule",{value:!0});var c=e("11ed2ab"),d=c.__importStar(e("86b561e")),i=c.__importStar(e("98ab305")),s=c.__importStar(e("aedc3c9")),u=c.__importStar(e("38cea32"));t.createScanner=s.createScanner,t.getLocation=u.getLocation,t.parse=u.parse,t.parseTree=u.parseTree,t.findNodeAtLocation=u.findNodeAtLocation,t.findNodeAtOffset=u.findNodeAtOffset,t.getNodePath=u.getNodePath,t.getNodeValue=u.getNodeValue,t.visit=u.visit,t.stripComments=u.stripComments,t.printParseErrorCode=r,t.format=n,t.modify=a,t.applyEdits=o});
/**! node_modules/monaco-editor/esm/vs/language/json/fillers/vscode-nls.js*/
define("60eaf5a",function(e,n){"use strict";function r(e,n){var r;return r=0===n.length?e:e.replace(/\{(\d+)\}/g,function(e,r){var t=r[0];return"undefined"!=typeof n[t]?n[t]:e})}function t(e,n){for(var t=[],u=2;u<arguments.length;u++)t[u-2]=arguments[u];return r(n,t)}function u(){return t}function f(){return u}Object.defineProperty(n,"__esModule",{value:!0}),n.loadMessageBundle=u,n.config=f});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/utils/strings.js*/
define("a0f93b8",function(e,t){"use strict";function n(e,t){if(e.length<t.length)return!1;for(var n=0;n<t.length;n++)if(e[n]!==t[n])return!1;return!0}function r(e,t){var n=e.length-t.length;return n>0?e.lastIndexOf(t)===n:0===n?e===t:!1}function i(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function u(e,t){for(var n="";t>0;)1===(1&t)&&(n+=e),e+=e,t>>>=1;return n}Object.defineProperty(t,"__esModule",{value:!0}),t.startsWith=n,t.endsWith=r,t.convertSimple2RegExpPattern=i,t.repeat=u});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-uri/index.js*/
define("a199806",function(t,e){"use strict";function r(t){if(t.scheme&&!c.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path)if(t.authority){if(!p.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(d.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}function n(t,e){switch(t){case"https":case"http":case"file":e?e[0]!==y&&(e=y+e):e=y}return e}function o(t,e){for(var r=void 0,n=-1,o=0;o<t.length;o++){var i=t.charCodeAt(o);if(i>=97&&122>=i||i>=65&&90>=i||i>=48&&57>=i||45===i||46===i||95===i||126===i||e&&47===i)-1!==n&&(r+=encodeURIComponent(t.substring(n,o)),n=-1),void 0!==r&&(r+=t.charAt(o));else{void 0===r&&(r=t.substr(0,o));var h=C[i];void 0!==h?(-1!==n&&(r+=encodeURIComponent(t.substring(n,o)),n=-1),r+=h):-1===n&&(n=o)}}return-1!==n&&(r+=encodeURIComponent(t.substring(n))),void 0!==r?r:t}function i(t){for(var e=void 0,r=0;r<t.length;r++){var n=t.charCodeAt(r);35===n||63===n?(void 0===e&&(e=t.substr(0,r)),e+=C[n]):void 0!==e&&(e+=t[r])}return void 0!==e?e:t}function h(t){var e;return e=t.authority&&t.path.length>1&&"file"===t.scheme?"//"+t.authority+t.path:47===t.path.charCodeAt(0)&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&58===t.path.charCodeAt(2)?t.path[1].toLowerCase()+t.path.substr(2):t.path,s&&(e=e.replace(/\//g,"\\")),e}function a(t,e){var r=e?i:o,n="",h=t.scheme,a=t.authority,s=t.path,u=t.query,f=t.fragment;if(h&&(n+=h,n+=":"),(a||"file"===h)&&(n+=y,n+=y),a){var c=a.indexOf("@");if(-1!==c){var p=a.substr(0,c);a=a.substr(c+1),c=p.indexOf(":"),-1===c?n+=r(p,!1):(n+=r(p.substr(0,c),!1),n+=":",n+=r(p.substr(c+1),!1)),n+="@"}a=a.toLowerCase(),c=a.indexOf(":"),-1===c?n+=r(a,!1):(n+=r(a.substr(0,c),!1),n+=a.substr(c))}if(s){if(s.length>=3&&47===s.charCodeAt(0)&&58===s.charCodeAt(2)){var d=s.charCodeAt(1);d>=65&&90>=d&&(s="/"+String.fromCharCode(d+32)+":"+s.substr(3))}else if(s.length>=2&&58===s.charCodeAt(1)){var d=s.charCodeAt(0);d>=65&&90>=d&&(s=String.fromCharCode(d+32)+":"+s.substr(2))}n+=r(s,!0)}return u&&(n+="?",n+=r(u,!1)),f&&(n+="#",n+=e?f:o(f,!1)),n}Object.defineProperty(e,"__esModule",{value:!0});var s,u=this&&this.__extends||function(){var t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])};return function(e,r){function n(){this.constructor=e}t(e,r),e.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}();if("object"==typeof navigator){var f=navigator.userAgent;s=f.indexOf("Windows")>=0}var c=/^\w[\w\d+.-]*$/,p=/^\//,d=/^\/\//,m="",y="/",l=/^(([^:\/?#]+?):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,g=function(){function t(t,e,o,i,h){"object"==typeof t?(this.scheme=t.scheme||m,this.authority=t.authority||m,this.path=t.path||m,this.query=t.query||m,this.fragment=t.fragment||m):(this.scheme=t||m,this.authority=e||m,this.path=n(this.scheme,o||m),this.query=i||m,this.fragment=h||m,r(this))}return t.isUri=function(e){return e instanceof t?!0:e?"string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme:!1},Object.defineProperty(t.prototype,"fsPath",{get:function(){return h(this)},enumerable:!0,configurable:!0}),t.prototype.with=function(t){if(!t)return this;var e=t.scheme,r=t.authority,n=t.path,o=t.query,i=t.fragment;return void 0===e?e=this.scheme:null===e&&(e=m),void 0===r?r=this.authority:null===r&&(r=m),void 0===n?n=this.path:null===n&&(n=m),void 0===o?o=this.query:null===o&&(o=m),void 0===i?i=this.fragment:null===i&&(i=m),e===this.scheme&&r===this.authority&&n===this.path&&o===this.query&&i===this.fragment?this:new b(e,r,n,o,i)},t.parse=function(t){var e=l.exec(t);return e?new b(e[2]||m,decodeURIComponent(e[4]||m),decodeURIComponent(e[5]||m),decodeURIComponent(e[7]||m),decodeURIComponent(e[9]||m)):new b(m,m,m,m,m)},t.file=function(t){var e=m;if(s&&(t=t.replace(/\\/g,y)),t[0]===y&&t[1]===y){var r=t.indexOf(y,2);-1===r?(e=t.substring(2),t=y):(e=t.substring(2,r),t=t.substring(r)||y)}return new b("file",e,t,m,m)},t.from=function(t){return new b(t.scheme,t.authority,t.path,t.query,t.fragment)},t.prototype.toString=function(t){return void 0===t&&(t=!1),a(this,t)},t.prototype.toJSON=function(){return this},t.revive=function(e){if(e){if(e instanceof t)return e;var r=new b(e);return r._fsPath=e.fsPath,r._formatted=e.external,r}return e},t}();e.default=g;var v,b=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e._formatted=null,e._fsPath=null,e}return u(e,t),Object.defineProperty(e.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=h(this)),this._fsPath},enumerable:!0,configurable:!0}),e.prototype.toString=function(t){return void 0===t&&(t=!1),t?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)},e.prototype.toJSON=function(){var t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t},e}(g),C=(v={},v[58]="%3A",v[47]="%2F",v[63]="%3F",v[35]="%23",v[91]="%5B",v[93]="%5D",v[64]="%40",v[33]="%21",v[36]="%24",v[38]="%26",v[39]="%27",v[40]="%28",v[41]="%29",v[42]="%2A",v[43]="%2B",v[44]="%2C",v[59]="%3B",v[61]="%3D",v[32]="%20",v)});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/main.js*/
define("26128d7",function(e,t){"use strict";function r(e){switch(e){case 1:return"InvalidSymbol";case 2:return"InvalidNumberFormat";case 3:return"PropertyNameExpected";case 4:return"ValueExpected";case 5:return"ColonExpected";case 6:return"CommaExpected";case 7:return"CloseBraceExpected";case 8:return"CloseBracketExpected";case 9:return"EndOfFileExpected";case 10:return"InvalidCommentToken";case 11:return"UnexpectedEndOfComment";case 12:return"UnexpectedEndOfString";case 13:return"UnexpectedEndOfNumber";case 14:return"InvalidUnicode";case 15:return"InvalidEscapeCharacter";case 16:return"InvalidCharacter"}return"<unknown ParseErrorCode>"}function n(e,t,r){return d.format(e,t,r)}function a(e,t,r,n){return i.setProperty(e,t,r,n.formattingOptions,n.getInsertionIndex)}function o(e,t){for(var r=t.length-1;r>=0;r--)e=i.applyEdit(e,t[r]);return e}Object.defineProperty(t,"__esModule",{value:!0});var c=e("11ed2ab"),d=c.__importStar(e("86b561e")),i=c.__importStar(e("98ab305")),s=c.__importStar(e("aedc3c9")),u=c.__importStar(e("38cea32"));t.createScanner=s.createScanner,t.getLocation=u.getLocation,t.parse=u.parse,t.parseTree=u.parseTree,t.findNodeAtLocation=u.findNodeAtLocation,t.findNodeAtOffset=u.findNodeAtOffset,t.getNodePath=u.getNodePath,t.getNodeValue=u.getNodeValue,t.visit=u.visit,t.stripComments=u.stripComments,t.printParseErrorCode=r,t.format=n,t.modify=a,t.applyEdits=o});
/**! node_modules/monaco-editor/esm/vs/language/json/fillers/vscode-nls.js*/
define("60eaf5a",function(e,n){"use strict";function r(e,n){var r;return r=0===n.length?e:e.replace(/\{(\d+)\}/g,function(e,r){var t=r[0];return"undefined"!=typeof n[t]?n[t]:e})}function t(e,n){for(var t=[],u=2;u<arguments.length;u++)t[u-2]=arguments[u];return r(n,t)}function u(){return t}function f(){return u}Object.defineProperty(n,"__esModule",{value:!0}),n.loadMessageBundle=u,n.config=f});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-uri/index.js*/
define("a199806",function(t,e){"use strict";function r(t){if(t.scheme&&!c.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path)if(t.authority){if(!p.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(d.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}function n(t,e){switch(t){case"https":case"http":case"file":e?e[0]!==y&&(e=y+e):e=y}return e}function o(t,e){for(var r=void 0,n=-1,o=0;o<t.length;o++){var i=t.charCodeAt(o);if(i>=97&&122>=i||i>=65&&90>=i||i>=48&&57>=i||45===i||46===i||95===i||126===i||e&&47===i)-1!==n&&(r+=encodeURIComponent(t.substring(n,o)),n=-1),void 0!==r&&(r+=t.charAt(o));else{void 0===r&&(r=t.substr(0,o));var h=C[i];void 0!==h?(-1!==n&&(r+=encodeURIComponent(t.substring(n,o)),n=-1),r+=h):-1===n&&(n=o)}}return-1!==n&&(r+=encodeURIComponent(t.substring(n))),void 0!==r?r:t}function i(t){for(var e=void 0,r=0;r<t.length;r++){var n=t.charCodeAt(r);35===n||63===n?(void 0===e&&(e=t.substr(0,r)),e+=C[n]):void 0!==e&&(e+=t[r])}return void 0!==e?e:t}function h(t){var e;return e=t.authority&&t.path.length>1&&"file"===t.scheme?"//"+t.authority+t.path:47===t.path.charCodeAt(0)&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&58===t.path.charCodeAt(2)?t.path[1].toLowerCase()+t.path.substr(2):t.path,s&&(e=e.replace(/\//g,"\\")),e}function a(t,e){var r=e?i:o,n="",h=t.scheme,a=t.authority,s=t.path,u=t.query,f=t.fragment;if(h&&(n+=h,n+=":"),(a||"file"===h)&&(n+=y,n+=y),a){var c=a.indexOf("@");if(-1!==c){var p=a.substr(0,c);a=a.substr(c+1),c=p.indexOf(":"),-1===c?n+=r(p,!1):(n+=r(p.substr(0,c),!1),n+=":",n+=r(p.substr(c+1),!1)),n+="@"}a=a.toLowerCase(),c=a.indexOf(":"),-1===c?n+=r(a,!1):(n+=r(a.substr(0,c),!1),n+=a.substr(c))}if(s){if(s.length>=3&&47===s.charCodeAt(0)&&58===s.charCodeAt(2)){var d=s.charCodeAt(1);d>=65&&90>=d&&(s="/"+String.fromCharCode(d+32)+":"+s.substr(3))}else if(s.length>=2&&58===s.charCodeAt(1)){var d=s.charCodeAt(0);d>=65&&90>=d&&(s=String.fromCharCode(d+32)+":"+s.substr(2))}n+=r(s,!0)}return u&&(n+="?",n+=r(u,!1)),f&&(n+="#",n+=e?f:o(f,!1)),n}Object.defineProperty(e,"__esModule",{value:!0});var s,u=this&&this.__extends||function(){var t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])};return function(e,r){function n(){this.constructor=e}t(e,r),e.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}();if("object"==typeof navigator){var f=navigator.userAgent;s=f.indexOf("Windows")>=0}var c=/^\w[\w\d+.-]*$/,p=/^\//,d=/^\/\//,m="",y="/",l=/^(([^:\/?#]+?):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,g=function(){function t(t,e,o,i,h){"object"==typeof t?(this.scheme=t.scheme||m,this.authority=t.authority||m,this.path=t.path||m,this.query=t.query||m,this.fragment=t.fragment||m):(this.scheme=t||m,this.authority=e||m,this.path=n(this.scheme,o||m),this.query=i||m,this.fragment=h||m,r(this))}return t.isUri=function(e){return e instanceof t?!0:e?"string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme:!1},Object.defineProperty(t.prototype,"fsPath",{get:function(){return h(this)},enumerable:!0,configurable:!0}),t.prototype.with=function(t){if(!t)return this;var e=t.scheme,r=t.authority,n=t.path,o=t.query,i=t.fragment;return void 0===e?e=this.scheme:null===e&&(e=m),void 0===r?r=this.authority:null===r&&(r=m),void 0===n?n=this.path:null===n&&(n=m),void 0===o?o=this.query:null===o&&(o=m),void 0===i?i=this.fragment:null===i&&(i=m),e===this.scheme&&r===this.authority&&n===this.path&&o===this.query&&i===this.fragment?this:new b(e,r,n,o,i)},t.parse=function(t){var e=l.exec(t);return e?new b(e[2]||m,decodeURIComponent(e[4]||m),decodeURIComponent(e[5]||m),decodeURIComponent(e[7]||m),decodeURIComponent(e[9]||m)):new b(m,m,m,m,m)},t.file=function(t){var e=m;if(s&&(t=t.replace(/\\/g,y)),t[0]===y&&t[1]===y){var r=t.indexOf(y,2);-1===r?(e=t.substring(2),t=y):(e=t.substring(2,r),t=t.substring(r)||y)}return new b("file",e,t,m,m)},t.from=function(t){return new b(t.scheme,t.authority,t.path,t.query,t.fragment)},t.prototype.toString=function(t){return void 0===t&&(t=!1),a(this,t)},t.prototype.toJSON=function(){return this},t.revive=function(e){if(e){if(e instanceof t)return e;var r=new b(e);return r._fsPath=e.fsPath,r._formatted=e.external,r}return e},t}();e.default=g;var v,b=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e._formatted=null,e._fsPath=null,e}return u(e,t),Object.defineProperty(e.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=h(this)),this._fsPath},enumerable:!0,configurable:!0}),e.prototype.toString=function(t){return void 0===t&&(t=!1),t?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)},e.prototype.toJSON=function(){var t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t},e}(g),C=(v={},v[58]="%3A",v[47]="%2F",v[63]="%3F",v[35]="%23",v[91]="%5B",v[93]="%5D",v[64]="%40",v[33]="%21",v[36]="%24",v[38]="%26",v[39]="%27",v[40]="%28",v[41]="%29",v[42]="%2A",v[43]="%2B",v[44]="%2C",v[59]="%3B",v[61]="%3D",v[32]="%20",v)});
/**! node_modules/monaco-editor/esm/vs/language/json/fillers/vscode-nls.js*/
define("60eaf5a",function(e,n){"use strict";function r(e,n){var r;return r=0===n.length?e:e.replace(/\{(\d+)\}/g,function(e,r){var t=r[0];return"undefined"!=typeof n[t]?n[t]:e})}function t(e,n){for(var t=[],u=2;u<arguments.length;u++)t[u-2]=arguments[u];return r(n,t)}function u(){return t}function f(){return u}Object.defineProperty(n,"__esModule",{value:!0}),n.loadMessageBundle=u,n.config=f});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/jsonLanguageTypes.js*/
define("683e3e1",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var t=e("737c70e");n.Range=t.Range,n.TextEdit=t.TextEdit,n.Color=t.Color,n.ColorInformation=t.ColorInformation,n.ColorPresentation=t.ColorPresentation,n.FoldingRange=t.FoldingRange,n.FoldingRangeKind=t.FoldingRangeKind,function(e){e.Empty="",e.Statement="statement",e.Declaration="declaration"}(n.SelectionRangeKind||(n.SelectionRangeKind={})),function(e){e[e.Undefined=0]="Undefined",e[e.EnumValueMismatch=1]="EnumValueMismatch",e[e.UnexpectedEndOfComment=257]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=258]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=259]="UnexpectedEndOfNumber",e[e.InvalidUnicode=260]="InvalidUnicode",e[e.InvalidEscapeCharacter=261]="InvalidEscapeCharacter",e[e.InvalidCharacter=262]="InvalidCharacter",e[e.PropertyExpected=513]="PropertyExpected",e[e.CommaExpected=514]="CommaExpected",e[e.ColonExpected=515]="ColonExpected",e[e.ValueExpected=516]="ValueExpected",e[e.CommaOrCloseBacketExpected=517]="CommaOrCloseBacketExpected",e[e.CommaOrCloseBraceExpected=518]="CommaOrCloseBraceExpected",e[e.TrailingComma=519]="TrailingComma",e[e.DuplicateKey=520]="DuplicateKey",e[e.CommentNotPermitted=521]="CommentNotPermitted",e[e.SchemaResolveError=768]="SchemaResolveError"}(n.ErrorCode||(n.ErrorCode={})),function(e){e.LATEST={textDocument:{completion:{completionItem:{documentationFormat:[t.MarkupKind.Markdown,t.MarkupKind.PlainText]}}}}}(n.ClientCapabilities||(n.ClientCapabilities={}))});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/utils/objects.js*/
define("de6a48e",function(r,e){"use strict";function n(r,e){if(r===e)return!0;if(null===r||void 0===r||null===e||void 0===e)return!1;if(typeof r!=typeof e)return!1;if("object"!=typeof r)return!1;if(Array.isArray(r)!==Array.isArray(e))return!1;var t,i;if(Array.isArray(r)){if(r.length!==e.length)return!1;for(t=0;t<r.length;t++)if(!n(r[t],e[t]))return!1}else{var f=[];for(i in r)f.push(i);f.sort();var u=[];for(i in e)u.push(i);if(u.sort(),!n(f,u))return!1;for(t=0;t<f.length;t++)if(!n(r[f[t]],e[f[t]]))return!1}return!0}function t(r){return"number"==typeof r}function i(r){return"undefined"!=typeof r}function f(r){return"boolean"==typeof r}function u(r){return"string"==typeof r}Object.defineProperty(e,"__esModule",{value:!0}),e.equals=n,e.isNumber=t,e.isDefined=i,e.isBoolean=f,e.isString=u});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/main.js*/
define("26128d7",function(e,t){"use strict";function r(e){switch(e){case 1:return"InvalidSymbol";case 2:return"InvalidNumberFormat";case 3:return"PropertyNameExpected";case 4:return"ValueExpected";case 5:return"ColonExpected";case 6:return"CommaExpected";case 7:return"CloseBraceExpected";case 8:return"CloseBracketExpected";case 9:return"EndOfFileExpected";case 10:return"InvalidCommentToken";case 11:return"UnexpectedEndOfComment";case 12:return"UnexpectedEndOfString";case 13:return"UnexpectedEndOfNumber";case 14:return"InvalidUnicode";case 15:return"InvalidEscapeCharacter";case 16:return"InvalidCharacter"}return"<unknown ParseErrorCode>"}function n(e,t,r){return d.format(e,t,r)}function a(e,t,r,n){return i.setProperty(e,t,r,n.formattingOptions,n.getInsertionIndex)}function o(e,t){for(var r=t.length-1;r>=0;r--)e=i.applyEdit(e,t[r]);return e}Object.defineProperty(t,"__esModule",{value:!0});var c=e("11ed2ab"),d=c.__importStar(e("86b561e")),i=c.__importStar(e("98ab305")),s=c.__importStar(e("aedc3c9")),u=c.__importStar(e("38cea32"));t.createScanner=s.createScanner,t.getLocation=u.getLocation,t.parse=u.parse,t.parseTree=u.parseTree,t.findNodeAtLocation=u.findNodeAtLocation,t.findNodeAtOffset=u.findNodeAtOffset,t.getNodePath=u.getNodePath,t.getNodeValue=u.getNodeValue,t.visit=u.visit,t.stripComments=u.stripComments,t.printParseErrorCode=r,t.format=n,t.modify=a,t.applyEdits=o});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/utils/colors.js*/
define("e7af929",function(e,r){"use strict";function t(e){return o>e?0:d>=e?e-o:(n>e&&(e+=n-h),e>=n&&u>=e?e-n+10:0)}function a(e){if("#"!==e[0])return null;switch(e.length){case 4:return{red:17*t(e.charCodeAt(1))/255,green:17*t(e.charCodeAt(2))/255,blue:17*t(e.charCodeAt(3))/255,alpha:1};case 5:return{red:17*t(e.charCodeAt(1))/255,green:17*t(e.charCodeAt(2))/255,blue:17*t(e.charCodeAt(3))/255,alpha:17*t(e.charCodeAt(4))/255};case 7:return{red:(16*t(e.charCodeAt(1))+t(e.charCodeAt(2)))/255,green:(16*t(e.charCodeAt(3))+t(e.charCodeAt(4)))/255,blue:(16*t(e.charCodeAt(5))+t(e.charCodeAt(6)))/255,alpha:1};case 9:return{red:(16*t(e.charCodeAt(1))+t(e.charCodeAt(2)))/255,green:(16*t(e.charCodeAt(3))+t(e.charCodeAt(4)))/255,blue:(16*t(e.charCodeAt(5))+t(e.charCodeAt(6)))/255,alpha:(16*t(e.charCodeAt(7))+t(e.charCodeAt(8)))/255}}return null}function c(e,r,t,a){return void 0===a&&(a=1),{red:e/255,green:r/255,blue:t/255,alpha:a}}Object.defineProperty(r,"__esModule",{value:!0});var o=48,d=57,h=65,n=97,u=102;r.hexDigit=t,r.colorFromHex=a,r.colorFrom256RGB=c});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/utils/strings.js*/
define("a0f93b8",function(e,t){"use strict";function n(e,t){if(e.length<t.length)return!1;for(var n=0;n<t.length;n++)if(e[n]!==t[n])return!1;return!0}function r(e,t){var n=e.length-t.length;return n>0?e.lastIndexOf(t)===n:0===n?e===t:!1}function i(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function u(e,t){for(var n="";t>0;)1===(1&t)&&(n+=e),e+=e,t>>>=1;return n}Object.defineProperty(t,"__esModule",{value:!0}),t.startsWith=n,t.endsWith=r,t.convertSimple2RegExpPattern=i,t.repeat=u});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/parser/jsonParser.js*/
define("8408640",function(e,t){"use strict";function r(e){return p.isBoolean(e)?e?{}:{not:{}}:e}function n(e,t){return void 0===t&&(t=[]),new P(e,t,[])}function o(e){return f.getNodeValue(e)}function i(e){return f.getNodePath(e)}function a(e,t,r){return void 0===r&&(r=!1),t>=e.offset&&t<e.offset+e.length||r&&t===e.offset+e.length}function s(e,t,n,i){function a(){function a(t){return e.type===t||"integer"===t&&"number"===e.type&&e.isInteger}if(Array.isArray(t.type)?t.type.some(a)||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("typeArrayMismatchWarning","Incorrect type. Expected one of {0}.",t.type.join(", "))}):t.type&&(a(t.type)||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("typeMismatchWarning",'Incorrect type. Expected "{0}".',t.type)})),Array.isArray(t.allOf))for(var l=0,u=t.allOf;l<u.length;l++){var c=u[l];s(e,r(c),n,i)}var f=r(t.not);if(f){var m=new w,h=i.newSub();s(e,f,m,h),m.hasProblems()||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("notSchemaWarning","Matches a schema that is not allowed.")});for(var y=0,b=h.schemas;y<b.length;y++){var x=b[y];x.inverted=!x.inverted,i.add(x)}}var M=function(t,o){for(var a=[],l=null,u=0,c=t;u<c.length;u++){var f=c[u],p=r(f),g=new w,m=i.newSub();if(s(e,p,g,m),g.hasProblems()||a.push(p),l)if(o||g.hasProblems()||l.validationResult.hasProblems()){var h=g.compare(l.validationResult);h>0?l={schema:p,validationResult:g,matchingSchemas:m}:0===h&&(l.matchingSchemas.merge(m),l.validationResult.mergeEnumValues(g))}else l.matchingSchemas.merge(m),l.validationResult.propertiesMatches+=g.propertiesMatches,l.validationResult.propertiesValueMatches+=g.propertiesValueMatches;else l={schema:p,validationResult:g,matchingSchemas:m}}return a.length>1&&o&&n.problems.push({location:{offset:e.offset,length:1},severity:d.DiagnosticSeverity.Warning,message:v("oneOfWarning","Matches multiple schemas when only one must validate.")}),null!==l&&(n.merge(l.validationResult),n.propertiesMatches+=l.validationResult.propertiesMatches,n.propertiesValueMatches+=l.validationResult.propertiesValueMatches,i.merge(l.matchingSchemas)),a.length};Array.isArray(t.anyOf)&&M(t.anyOf,!1),Array.isArray(t.oneOf)&&M(t.oneOf,!0);var E=function(t){var o=new w,a=i.newSub();s(e,r(t),o,a),n.merge(o),n.propertiesMatches+=o.propertiesMatches,n.propertiesValueMatches+=o.propertiesValueMatches,i.merge(a)},k=function(t,n,o){var a=r(t),l=new w,u=i.newSub();s(e,a,l,u),i.merge(u),l.hasProblems()?o&&E(o):n&&E(n)},S=r(t.if);if(S&&k(S,r(t.then),r(t.else)),Array.isArray(t.enum)){for(var O=o(e),V=!1,N=0,W=t.enum;N<W.length;N++){var T=W[N];if(p.equals(O,T)){V=!0;break}}n.enumValues=t.enum,n.enumValueMatch=V,V||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,code:g.ErrorCode.EnumValueMismatch,message:t.errorMessage||v("enumWarning","Value is not accepted. Valid values: {0}.",t.enum.map(function(e){return JSON.stringify(e)}).join(", "))})}if(p.isDefined(t.const)){var O=o(e);p.equals(O,t.const)?n.enumValueMatch=!0:(n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,code:g.ErrorCode.EnumValueMismatch,message:t.errorMessage||v("constWarning","Value must be {0}.",JSON.stringify(t.const))}),n.enumValueMatch=!1),n.enumValues=[t.const]}t.deprecationMessage&&e.parent&&n.problems.push({location:{offset:e.parent.offset,length:e.parent.length},severity:d.DiagnosticSeverity.Warning,message:t.deprecationMessage})}function l(e,t,r){function n(e,t){return p.isNumber(t)?t:p.isBoolean(t)&&t?e:void 0}function o(e,t){return p.isBoolean(t)&&t?void 0:e}var i=e.value;p.isNumber(t.multipleOf)&&i%t.multipleOf!==0&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("multipleOfWarning","Value is not divisible by {0}.",t.multipleOf)});var a=n(t.minimum,t.exclusiveMinimum);p.isNumber(a)&&a>=i&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("exclusiveMinimumWarning","Value is below the exclusive minimum of {0}.",a)});var s=n(t.maximum,t.exclusiveMaximum);p.isNumber(s)&&i>=s&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("exclusiveMaximumWarning","Value is above the exclusive maximum of {0}.",s)});var l=o(t.minimum,t.exclusiveMinimum);p.isNumber(l)&&l>i&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("minimumWarning","Value is below the minimum of {0}.",l)});var u=o(t.maximum,t.exclusiveMaximum);p.isNumber(u)&&i>u&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("maximumWarning","Value is above the maximum of {0}.",u)})}function u(e,t,r){if(p.isNumber(t.minLength)&&e.value.length<t.minLength&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("minLengthWarning","String is shorter than the minimum length of {0}.",t.minLength)}),p.isNumber(t.maxLength)&&e.value.length>t.maxLength&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("maxLengthWarning","String is longer than the maximum length of {0}.",t.maxLength)}),p.isString(t.pattern)){var n=new RegExp(t.pattern);n.test(e.value)||r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("patternWarning",'String does not match the pattern of "{0}".',t.pattern)})}if(t.format)switch(t.format){case"uri":case"uri-reference":var o=void 0;if(e.value)try{var i=h.default.parse(e.value);i.scheme||"uri"!==t.format||(o=v("uriSchemeMissing","URI with a scheme is expected."))}catch(a){o=a.message}else o=v("uriEmpty","URI expected.");o&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("uriFormatWarning","String is not a URI: {0}",o)});break;case"email":e.value.match(b)||r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("emailFormatWarning","String is not an e-mail address.")});break;case"color-hex":e.value.match(y)||r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("colorHexFormatWarning","Invalid color format. Use #RGB, #RGBA, #RRGGBB or #RRGGBBAA.")})}}function c(e,t,n,i){if(Array.isArray(t.items)){for(var a=t.items,l=0;l<a.length;l++){var u=a[l],c=r(u),f=new w,g=e.items[l];g?(s(g,c,f,i),n.mergePropertyMatch(f)):e.items.length>=a.length&&n.propertiesValueMatches++}if(e.items.length>a.length)if("object"==typeof t.additionalItems)for(var m=a.length;m<e.items.length;m++){var f=new w;s(e.items[m],t.additionalItems,f,i),n.mergePropertyMatch(f)}else t.additionalItems===!1&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("additionalItemsWarning","Array has too many items according to schema. Expected {0} or fewer.",a.length)})}else{var h=r(t.items);if(h)for(var y=0,b=e.items;y<b.length;y++){var g=b[y],f=new w;s(g,h,f,i),n.mergePropertyMatch(f)}}var x=r(t.contains);if(x){var M=e.items.some(function(e){var t=new w;return s(e,x,t,T.instance),!t.hasProblems()});M||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("requiredItemMissingWarning","Array does not contain required item.")})}if(p.isNumber(t.minItems)&&e.items.length<t.minItems&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("minItemsWarning","Array has too few items. Expected {0} or more.",t.minItems)}),p.isNumber(t.maxItems)&&e.items.length>t.maxItems&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("maxItemsWarning","Array has too many items. Expected {0} or fewer.",t.maxItems)}),t.uniqueItems===!0){var E=o(e),k=E.some(function(e,t){return t!==E.lastIndexOf(e)});k&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("uniqueItemsWarning","Array has duplicate items.")})}}function f(e,t,n,o){for(var i=Object.create(null),a=[],l=0,u=e.properties;l<u.length;l++){var c=u[l],f=c.keyNode.value;i[f]=c.valueNode,a.push(f)}if(Array.isArray(t.required))for(var g=0,m=t.required;g<m.length;g++){var h=m[g];if(!i[h]){var y=e.parent&&"property"===e.parent.type&&e.parent.keyNode,b=y?{offset:y.offset,length:y.length}:{offset:e.offset,length:1};n.problems.push({location:b,severity:d.DiagnosticSeverity.Warning,message:v("MissingRequiredPropWarning",'Missing property "{0}".',h)})}}var x=function(e){for(var t=a.indexOf(e);t>=0;)a.splice(t,1),t=a.indexOf(e)};if(t.properties)for(var M=0,E=Object.keys(t.properties);M<E.length;M++){var h=E[M];x(h);var k=t.properties[h],S=i[h];if(S)if(p.isBoolean(k))if(k)n.propertiesMatches++,n.propertiesValueMatches++;else{var c=S.parent;n.problems.push({location:{offset:c.keyNode.offset,length:c.keyNode.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("DisallowedExtraPropWarning","Property {0} is not allowed.",h)})}else{var O=new w;s(S,k,O,o),n.mergePropertyMatch(O)}}if(t.patternProperties)for(var V=0,N=Object.keys(t.patternProperties);V<N.length;V++)for(var W=N[V],P=new RegExp(W),A=0,C=a.slice(0);A<C.length;A++){var h=C[A];if(P.test(h)){x(h);var S=i[h];if(S){var k=t.patternProperties[W];if(p.isBoolean(k))if(k)n.propertiesMatches++,n.propertiesValueMatches++;else{var c=S.parent;n.problems.push({location:{offset:c.keyNode.offset,length:c.keyNode.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("DisallowedExtraPropWarning","Property {0} is not allowed.",h)})}else{var O=new w;s(S,k,O,o),n.mergePropertyMatch(O)}}}}if("object"==typeof t.additionalProperties)for(var D=0,I=a;D<I.length;D++){var h=I[D],S=i[h];if(S){var O=new w;s(S,t.additionalProperties,O,o),n.mergePropertyMatch(O)}}else if(t.additionalProperties===!1&&a.length>0)for(var j=0,R=a;j<R.length;j++){var h=R[j],S=i[h];if(S){var c=S.parent;n.problems.push({location:{offset:c.keyNode.offset,length:c.keyNode.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("DisallowedExtraPropWarning","Property {0} is not allowed.",h)})}}if(p.isNumber(t.maxProperties)&&e.properties.length>t.maxProperties&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("MaxPropWarning","Object has more properties than limit of {0}.",t.maxProperties)}),p.isNumber(t.minProperties)&&e.properties.length<t.minProperties&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("MinPropWarning","Object has fewer properties than the required number of {0}",t.minProperties)}),t.dependencies)for(var U=0,_=Object.keys(t.dependencies);U<_.length;U++){var f=_[U],B=i[f];if(B){var q=t.dependencies[f];if(Array.isArray(q))for(var L=0,F=q;L<F.length;L++){var J=F[L];i[J]?n.propertiesValueMatches++:n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("RequiredDependentPropWarning","Object is missing property {0} required by property {1}.",J,f)})}else{var k=r(q);if(k){var O=new w;s(e,k,O,o),n.mergePropertyMatch(O)}}}}var G=r(t.propertyNames);if(G)for(var K=0,z=e.properties;K<z.length;K++){var Z=z[K],f=Z.keyNode;f&&s(f,G,n,T.instance)}}if(e&&i.include(e)){switch(e.type){case"object":f(e,t,n,i);break;case"array":c(e,t,n,i);break;case"string":u(e,t,n,i);break;case"number":l(e,t,n,i);break;case"property":return s(e.valueNode,t,n,i)}a(),i.add({node:e,schema:t})}}function l(e,t){function r(){for(;;){var t=T.scan();switch(i(),t){case 12:case 13:Array.isArray(w)&&w.push(d.Range.create(e.positionAt(T.getTokenOffset()),e.positionAt(T.getTokenOffset()+T.getTokenLength())));break;case 15:case 14:break;default:return t}}}function n(t,r,n,o,i){if(void 0===i&&(i=d.DiagnosticSeverity.Error),0===b.length||n!==x){var a=d.Range.create(e.positionAt(n),e.positionAt(o));b.push(d.Diagnostic.create(a,t,i,r,e.languageId)),x=n}}function o(e,t,o,i,s){void 0===o&&(o=null),void 0===i&&(i=[]),void 0===s&&(s=[]);var l=T.getTokenOffset(),u=T.getTokenOffset()+T.getTokenLength();if(l===u&&l>0){for(l--;l>0&&/\s/.test(W.charAt(l));)l--;u=l+1}if(n(e,t,l,u),o&&a(o,!1),i.length+s.length>0)for(var c=T.getToken();17!==c;){if(-1!==i.indexOf(c)){r();break}if(-1!==s.indexOf(c))break;c=r()}return o}function i(){switch(T.getTokenError()){case 4:return o(v("InvalidUnicode","Invalid unicode sequence in string."),g.ErrorCode.InvalidUnicode),!0;case 5:return o(v("InvalidEscapeCharacter","Invalid escape character in string."),g.ErrorCode.InvalidEscapeCharacter),!0;case 3:return o(v("UnexpectedEndOfNumber","Unexpected end of number."),g.ErrorCode.UnexpectedEndOfNumber),!0;case 1:return o(v("UnexpectedEndOfComment","Unexpected end of comment."),g.ErrorCode.UnexpectedEndOfComment),!0;case 2:return o(v("UnexpectedEndOfString","Unexpected end of string."),g.ErrorCode.UnexpectedEndOfString),!0;case 6:return o(v("InvalidCharacter","Invalid characters in string. Control characters must be escaped."),g.ErrorCode.InvalidCharacter),!0}return!1}function a(e,t){return e.length=T.getTokenOffset()+T.getTokenLength()-e.offset,t&&r(),e}function s(e){if(3!==T.getToken())return null;var t=new k(e,T.getTokenOffset());r();for(var i=0,s=!1;4!==T.getToken()&&17!==T.getToken();){if(5===T.getToken()){s||o(v("ValueExpected","Value expected"),g.ErrorCode.ValueExpected);var l=T.getTokenOffset();if(r(),4===T.getToken()){s&&n(v("TrailingComma","Trailing comma"),g.ErrorCode.TrailingComma,l,l+1);continue}}else s&&o(v("ExpectedComma","Expected comma"),g.ErrorCode.CommaExpected);var u=y(t,i++);u?t.items.push(u):o(v("PropertyExpected","Value expected"),g.ErrorCode.ValueExpected,null,[],[4,5]),s=!0}return 4!==T.getToken()?o(v("ExpectedCloseBracket","Expected comma or closing bracket"),g.ErrorCode.CommaOrCloseBacketExpected,t):a(t,!0)}function l(t,i){var a=new V(t,T.getTokenOffset()),s=c(a);if(!s){if(16!==T.getToken())return null;o(v("DoubleQuotesExpected","Property keys must be doublequoted"),g.ErrorCode.Undefined);var l=new O(a,T.getTokenOffset(),T.getTokenLength());l.value=T.getTokenValue(),s=l,r()}a.keyNode=s;var u=i[s.value];if(u?(n(v("DuplicateKeyWarning","Duplicate object key"),g.ErrorCode.DuplicateKey,a.keyNode.offset,a.keyNode.offset+a.keyNode.length,d.DiagnosticSeverity.Warning),"object"==typeof u&&n(v("DuplicateKeyWarning","Duplicate object key"),g.ErrorCode.DuplicateKey,u.keyNode.offset,u.keyNode.offset+u.keyNode.length,d.DiagnosticSeverity.Warning),i[s.value]=!0):i[s.value]=a,6===T.getToken())a.colonOffset=T.getTokenOffset(),r();else if(o(v("ColonExpected","Colon expected"),g.ErrorCode.ColonExpected),10===T.getToken()&&e.positionAt(s.offset+s.length).line<e.positionAt(T.getTokenOffset()).line)return a.length=s.length,a;var f=y(a,s.value);return f?(a.valueNode=f,a.length=f.offset+f.length-a.offset,a):o(v("ValueExpected","Value expected"),g.ErrorCode.ValueExpected,a,[],[2,5])}function u(e){if(1!==T.getToken())return null;var t=new N(e,T.getTokenOffset()),i=Object.create(null);r();for(var s=!1;2!==T.getToken()&&17!==T.getToken();){if(5===T.getToken()){s||o(v("PropertyExpected","Property expected"),g.ErrorCode.PropertyExpected);var u=T.getTokenOffset();if(r(),2===T.getToken()){s&&n(v("TrailingComma","Trailing comma"),g.ErrorCode.TrailingComma,u,u+1);continue}}else s&&o(v("ExpectedComma","Expected comma"),g.ErrorCode.CommaExpected);var c=l(t,i);c?t.properties.push(c):o(v("PropertyExpected","Property expected"),g.ErrorCode.PropertyExpected,null,[],[2,5]),s=!0}return 2!==T.getToken()?o(v("ExpectedCloseBrace","Expected comma or closing brace"),g.ErrorCode.CommaOrCloseBraceExpected,t):a(t,!0)}function c(e){if(10!==T.getToken())return null;var t=new O(e,T.getTokenOffset());return t.value=T.getTokenValue(),a(t,!0)}function m(e){if(11!==T.getToken())return null;var t=new S(e,T.getTokenOffset());if(0===T.getTokenError()){var r=T.getTokenValue();try{var n=JSON.parse(r);if(!p.isNumber(n))return o(v("InvalidNumberFormat","Invalid number format."),g.ErrorCode.Undefined,t);t.value=n}catch(i){return o(v("InvalidNumberFormat","Invalid number format."),g.ErrorCode.Undefined,t)}t.isInteger=-1===r.indexOf(".")}return a(t,!0)}function h(e){switch(T.getToken()){case 7:return a(new M(e,T.getTokenOffset()),!0);case 8:return a(new E(e,!0,T.getTokenOffset()),!0);case 9:return a(new E(e,!1,T.getTokenOffset()),!0);default:return null}}function y(e){return s(e)||u(e)||c(e)||m(e)||h(e)}var b=[],x=-1,W=e.getText(),T=f.createScanner(W,!1),w=t&&t.collectComments?[]:void 0,A=null,C=r();return 17!==C&&(A=y(null,null),A?17!==T.getToken()&&o(v("End of file expected","End of file expected."),g.ErrorCode.Undefined):o(v("Invalid symbol","Expected a JSON object, array or literal."),g.ErrorCode.Undefined)),new P(A,b,w)}Object.defineProperty(t,"__esModule",{value:!0});var u=e("11ed2ab"),c=this&&this.__extends||function(){var e=function(t,r){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(t,r)};return function(t,r){function n(){this.constructor=t}e(t,r),t.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}(),f=u.__importStar(e("26128d7")),p=e("de6a48e"),g=e("683e3e1"),m=u.__importStar(e("60eaf5a")),h=u.__importDefault(e("a199806")),d=e("737c70e"),v=m.loadMessageBundle(),y=/^#([0-9A-Fa-f]{3,4}|([0-9A-Fa-f]{2}){3,4})$/,b=/^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,x=function(){function e(e,t,r){this.offset=t,this.length=r,this.parent=e}return Object.defineProperty(e.prototype,"children",{get:function(){return[]},enumerable:!0,configurable:!0}),e.prototype.toString=function(){return"type: "+this.type+" ("+this.offset+"/"+this.length+")"+(this.parent?" parent: {"+this.parent.toString()+"}":"")},e}();t.ASTNodeImpl=x;var M=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="null",n.value=null,n}return c(t,e),t}(x);t.NullASTNodeImpl=M;var E=function(e){function t(t,r,n){var o=e.call(this,t,n)||this;return o.type="boolean",o.value=r,o}return c(t,e),t}(x);t.BooleanASTNodeImpl=E;var k=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="array",n.items=[],n}return c(t,e),Object.defineProperty(t.prototype,"children",{get:function(){return this.items},enumerable:!0,configurable:!0}),t}(x);t.ArrayASTNodeImpl=k;var S=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="number",n.isInteger=!0,n.value=Number.NaN,n}return c(t,e),t}(x);t.NumberASTNodeImpl=S;var O=function(e){function t(t,r,n){var o=e.call(this,t,r,n)||this;return o.type="string",o.value="",o}return c(t,e),t}(x);t.StringASTNodeImpl=O;var V=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="property",n.colonOffset=-1,n}return c(t,e),Object.defineProperty(t.prototype,"children",{get:function(){return this.valueNode?[this.keyNode,this.valueNode]:[this.keyNode]},enumerable:!0,configurable:!0}),t}(x);t.PropertyASTNodeImpl=V;var N=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="object",n.properties=[],n}return c(t,e),Object.defineProperty(t.prototype,"children",{get:function(){return this.properties},enumerable:!0,configurable:!0}),t}(x);t.ObjectASTNodeImpl=N,t.asSchema=r,function(e){e[e.Key=0]="Key",e[e.Enum=1]="Enum"}(t.EnumMatch||(t.EnumMatch={}));var W=function(){function e(e,t){void 0===e&&(e=-1),void 0===t&&(t=null),this.focusOffset=e,this.exclude=t,this.schemas=[]}return e.prototype.add=function(e){this.schemas.push(e)},e.prototype.merge=function(e){var t;(t=this.schemas).push.apply(t,e.schemas)},e.prototype.include=function(e){return(-1===this.focusOffset||a(e,this.focusOffset))&&e!==this.exclude},e.prototype.newSub=function(){return new e(-1,this.exclude)},e}(),T=function(){function e(){}return Object.defineProperty(e.prototype,"schemas",{get:function(){return[]},enumerable:!0,configurable:!0}),e.prototype.add=function(){},e.prototype.merge=function(){},e.prototype.include=function(){return!0},e.prototype.newSub=function(){return this},e.instance=new e,e}(),w=function(){function e(){this.problems=[],this.propertiesMatches=0,this.propertiesValueMatches=0,this.primaryValueMatches=0,this.enumValueMatch=!1,this.enumValues=null}return e.prototype.hasProblems=function(){return!!this.problems.length},e.prototype.mergeAll=function(e){for(var t=0,r=e;t<r.length;t++){var n=r[t];this.merge(n)}},e.prototype.merge=function(e){this.problems=this.problems.concat(e.problems)},e.prototype.mergeEnumValues=function(e){if(!this.enumValueMatch&&!e.enumValueMatch&&this.enumValues&&e.enumValues){this.enumValues=this.enumValues.concat(e.enumValues);for(var t=0,r=this.problems;t<r.length;t++){var n=r[t];n.code===g.ErrorCode.EnumValueMismatch&&(n.message=v("enumWarning","Value is not accepted. Valid values: {0}.",this.enumValues.map(function(e){return JSON.stringify(e)}).join(", ")))}}},e.prototype.mergePropertyMatch=function(e){this.merge(e),this.propertiesMatches++,(e.enumValueMatch||!e.hasProblems()&&e.propertiesMatches)&&this.propertiesValueMatches++,e.enumValueMatch&&e.enumValues&&1===e.enumValues.length&&this.primaryValueMatches++},e.prototype.compare=function(e){var t=this.hasProblems();return t!==e.hasProblems()?t?-1:1:this.enumValueMatch!==e.enumValueMatch?e.enumValueMatch?-1:1:this.primaryValueMatches!==e.primaryValueMatches?this.primaryValueMatches-e.primaryValueMatches:this.propertiesValueMatches!==e.propertiesValueMatches?this.propertiesValueMatches-e.propertiesValueMatches:this.propertiesMatches-e.propertiesMatches},e}();t.ValidationResult=w,t.newJSONDocument=n,t.getNodeValue=o,t.getNodePath=i,t.contains=a;var P=function(){function e(e,t,r){void 0===t&&(t=[]),void 0===r&&(r=[]),this.root=e,this.syntaxErrors=t,this.comments=r}return e.prototype.getNodeFromOffset=function(e,t){return void 0===t&&(t=!1),this.root?f.findNodeAtOffset(this.root,e,t):void 0},e.prototype.visit=function(e){if(this.root){var t=function(r){var n=e(r),o=r.children;if(Array.isArray(o))for(var i=0;i<o.length&&n;i++)n=t(o[i]);return n};t(this.root)}},e.prototype.validate=function(e,t){if(this.root&&t){var r=new w;return s(this.root,t,r,T.instance),r.problems.map(function(t){var r=d.Range.create(e.positionAt(t.location.offset),e.positionAt(t.location.offset+t.location.length));return d.Diagnostic.create(r,t.message,t.severity,t.code)})}return null},e.prototype.getMatchingSchemas=function(e,t,r){void 0===t&&(t=-1),void 0===r&&(r=null);var n=new W(t,r);return this.root&&e&&s(this.root,e,new w,n),n.schemas},e}();t.JSONDocument=P,t.parse=l});
/**! node_modules/monaco-editor/esm/vs/language/json/fillers/vscode-nls.js*/
define("60eaf5a",function(e,n){"use strict";function r(e,n){var r;return r=0===n.length?e:e.replace(/\{(\d+)\}/g,function(e,r){var t=r[0];return"undefined"!=typeof n[t]?n[t]:e})}function t(e,n){for(var t=[],u=2;u<arguments.length;u++)t[u-2]=arguments[u];return r(n,t)}function u(){return t}function f(){return u}Object.defineProperty(n,"__esModule",{value:!0}),n.loadMessageBundle=u,n.config=f});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/jsonLanguageTypes.js*/
define("683e3e1",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var t=e("737c70e");n.Range=t.Range,n.TextEdit=t.TextEdit,n.Color=t.Color,n.ColorInformation=t.ColorInformation,n.ColorPresentation=t.ColorPresentation,n.FoldingRange=t.FoldingRange,n.FoldingRangeKind=t.FoldingRangeKind,function(e){e.Empty="",e.Statement="statement",e.Declaration="declaration"}(n.SelectionRangeKind||(n.SelectionRangeKind={})),function(e){e[e.Undefined=0]="Undefined",e[e.EnumValueMismatch=1]="EnumValueMismatch",e[e.UnexpectedEndOfComment=257]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=258]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=259]="UnexpectedEndOfNumber",e[e.InvalidUnicode=260]="InvalidUnicode",e[e.InvalidEscapeCharacter=261]="InvalidEscapeCharacter",e[e.InvalidCharacter=262]="InvalidCharacter",e[e.PropertyExpected=513]="PropertyExpected",e[e.CommaExpected=514]="CommaExpected",e[e.ColonExpected=515]="ColonExpected",e[e.ValueExpected=516]="ValueExpected",e[e.CommaOrCloseBacketExpected=517]="CommaOrCloseBacketExpected",e[e.CommaOrCloseBraceExpected=518]="CommaOrCloseBraceExpected",e[e.TrailingComma=519]="TrailingComma",e[e.DuplicateKey=520]="DuplicateKey",e[e.CommentNotPermitted=521]="CommentNotPermitted",e[e.SchemaResolveError=768]="SchemaResolveError"}(n.ErrorCode||(n.ErrorCode={})),function(e){e.LATEST={textDocument:{completion:{completionItem:{documentationFormat:[t.MarkupKind.Markdown,t.MarkupKind.PlainText]}}}}}(n.ClientCapabilities||(n.ClientCapabilities={}))});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/services/jsonSchemaService.js*/
define("a1f43d9",function(e,t){"use strict";function r(e){try{var t=s.default.parse(e);if("file"===t.scheme)return t.fsPath}catch(r){}return e}Object.defineProperty(t,"__esModule",{value:!0});var n=e("11ed2ab"),i=n.__importStar(e("26128d7")),s=n.__importDefault(e("a199806")),o=n.__importStar(e("a0f93b8")),a=n.__importStar(e("8408640")),c=n.__importStar(e("60eaf5a")),h=c.loadMessageBundle(),u=function(){function e(e){try{this.patternRegExp=new RegExp(o.convertSimple2RegExpPattern(e)+"$")}catch(t){this.patternRegExp=null}this.schemas=[]}return e.prototype.addSchema=function(e){this.schemas.push(e)},e.prototype.matchesPattern=function(e){return this.patternRegExp&&this.patternRegExp.test(e)},e.prototype.getSchemas=function(){return this.schemas},e}(),l=function(){function e(e,t,r){this.service=e,this.url=t,this.dependencies={},r&&(this.unresolvedSchema=this.service.promise.resolve(new f(r)))}return e.prototype.getUnresolvedSchema=function(){return this.unresolvedSchema||(this.unresolvedSchema=this.service.loadSchema(this.url)),this.unresolvedSchema},e.prototype.getResolvedSchema=function(){var e=this;return this.resolvedSchema||(this.resolvedSchema=this.getUnresolvedSchema().then(function(t){return e.service.resolveSchemaContent(t,e.url,e.dependencies)})),this.resolvedSchema},e.prototype.clearSchema=function(){this.resolvedSchema=null,this.unresolvedSchema=null,this.dependencies={}},e}(),f=function(){function e(e,t){void 0===t&&(t=[]),this.schema=e,this.errors=t}return e}();t.UnresolvedSchema=f;var d=function(){function e(e,t){void 0===t&&(t=[]),this.schema=e,this.errors=t}return e.prototype.getSection=function(e){return a.asSchema(this.getSectionRecursive(e,this.schema))},e.prototype.getSectionRecursive=function(e,t){if(!t||"boolean"==typeof t||0===e.length)return t;var r=e.shift();if(t.properties)return this.getSectionRecursive(e,t.properties[r]);if(t.patternProperties)for(var n=0,i=Object.keys(t.patternProperties);n<i.length;n++){var s=i[n],o=new RegExp(s);if(o.test(r))return this.getSectionRecursive(e,t.patternProperties[s])}else{if("object"==typeof t.additionalProperties)return this.getSectionRecursive(e,t.additionalProperties);if(r.match("[0-9]+"))if(Array.isArray(t.items)){var a=parseInt(r,10);if(!isNaN(a)&&t.items[a])return this.getSectionRecursive(e,t.items[a])}else if(t.items)return this.getSectionRecursive(e,t.items)}return null},e}();t.ResolvedSchema=d;var m=function(){function e(e,t,r){this.contextService=t,this.requestService=e,this.promiseConstructor=r||Promise,this.callOnDispose=[],this.contributionSchemas={},this.contributionAssociations={},this.schemasById={},this.filePatternAssociations=[],this.filePatternAssociationById={},this.registeredSchemasIds={}}return e.prototype.getRegisteredSchemaIds=function(e){return Object.keys(this.registeredSchemasIds).filter(function(t){var r=s.default.parse(t).scheme;return"schemaservice"!==r&&(!e||e(r))})},Object.defineProperty(e.prototype,"promise",{get:function(){return this.promiseConstructor},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){for(;this.callOnDispose.length>0;)this.callOnDispose.pop()()},e.prototype.onResourceChange=function(e){var t=this,r=!1;e=this.normalizeId(e);for(var n=[e],i=Object.keys(this.schemasById).map(function(e){return t.schemasById[e]});n.length;)for(var s=n.pop(),o=0;o<i.length;o++){var a=i[o];a&&(a.url===s||a.dependencies[s])&&(a.url!==s&&n.push(a.url),a.clearSchema(),i[o]=void 0,r=!0)}return r},e.prototype.normalizeId=function(e){return s.default.parse(e).toString()},e.prototype.setSchemaContributions=function(e){if(e.schemas){var t=e.schemas;for(var r in t){var n=this.normalizeId(r);this.contributionSchemas[n]=this.addSchemaHandle(n,t[r])}}if(e.schemaAssociations){var i=e.schemaAssociations;for(var s in i){var o=i[s];this.contributionAssociations[s]=o;for(var a=this.getOrAddFilePatternAssociation(s),c=0,h=o;c<h.length;c++){var u=h[c],r=this.normalizeId(u);a.addSchema(r)}}}},e.prototype.addSchemaHandle=function(e,t){var r=new l(this,e,t);return this.schemasById[e]=r,r},e.prototype.getOrAddSchemaHandle=function(e,t){return this.schemasById[e]||this.addSchemaHandle(e,t)},e.prototype.getOrAddFilePatternAssociation=function(e){var t=this.filePatternAssociationById[e];return t||(t=new u(e),this.filePatternAssociationById[e]=t,this.filePatternAssociations.push(t)),t},e.prototype.registerExternalSchema=function(e,t,r){void 0===t&&(t=null);var n=this.normalizeId(e);if(this.registeredSchemasIds[n]=!0,t)for(var i=0,s=t;i<s.length;i++){var o=s[i];this.getOrAddFilePatternAssociation(o).addSchema(n)}return r?this.addSchemaHandle(n,r):this.getOrAddSchemaHandle(n)},e.prototype.clearExternalSchemas=function(){this.schemasById={},this.filePatternAssociations=[],this.filePatternAssociationById={},this.registeredSchemasIds={};for(var e in this.contributionSchemas)this.schemasById[e]=this.contributionSchemas[e],this.registeredSchemasIds[e]=!0;for(var t in this.contributionAssociations)for(var r=this.getOrAddFilePatternAssociation(t),n=0,i=this.contributionAssociations[t];n<i.length;n++){var s=i[n],e=this.normalizeId(s);r.addSchema(e)}},e.prototype.getResolvedSchema=function(e){var t=this.normalizeId(e),r=this.schemasById[t];return r?r.getResolvedSchema():this.promise.resolve(null)},e.prototype.loadSchema=function(e){if(!this.requestService){var t=h("json.schema.norequestservice","Unable to load schema from '{0}'. No schema request service available",r(e));return this.promise.resolve(new f({},[t]))}return this.requestService(e).then(function(t){if(!t){var n=h("json.schema.nocontent","Unable to load schema from '{0}': No content.",r(e));return new f({},[n])}var s={},o=[];s=i.parse(t,o);var a=o.length?[h("json.schema.invalidFormat","Unable to parse content from '{0}': Parse error at offset {1}.",r(e),o[0].offset)]:[];return new f(s,a)},function(e){var t=e.toString(),r=e.toString().split("Error: ");return r.length>1&&(t=r[1]),new f({},[t])})},e.prototype.resolveSchemaContent=function(e,t,r){var n=this,i=e.errors.slice(0),s=e.schema,o=this.contextService,a=function(e,t){if(!t)return e;var r=e;return"/"===t[0]&&(t=t.substr(1)),t.split("/").some(function(e){return r=r[e],!r}),r},c=function(e,t,r,n){var s=a(t,n);if(s)for(var o in s)s.hasOwnProperty(o)&&!e.hasOwnProperty(o)&&(e[o]=s[o]);else i.push(h("json.schema.invalidref","$ref '{0}' in '{1}' can not be resolved.",n,r))},u=function(e,t,r,s,a){o&&!/^\w+:\/\/.*/.test(t)&&(t=o.resolveRelativePath(t,s)),t=n.normalizeId(t);var u=n.getOrAddSchemaHandle(t);return u.getUnresolvedSchema().then(function(n){if(a[t]=!0,n.errors.length){var s=r?t+"#"+r:t;i.push(h("json.schema.problemloadingref","Problems loading reference '{0}': {1}",s,n.errors[0]))}return c(e,n.schema,t,r),l(e,n.schema,t,u.dependencies)})},l=function(e,t,r,i){if(!e||"object"!=typeof e)return Promise.resolve(null);for(var s=[e],o=[],a=[],h=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var r=0,n=e;r<n.length;r++){var i=n[r];"object"==typeof i&&s.push(i)}},l=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var r=0,n=e;r<n.length;r++){var i=n[r];if("object"==typeof i)for(var o in i){var a=i[o];"object"==typeof a&&s.push(a)}}},f=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var r=0,n=e;r<n.length;r++){var i=n[r];if(Array.isArray(i))for(var o=0,a=i;o<a.length;o++){var c=a[o];"object"==typeof c&&s.push(c)}}},d=function(e){for(var n=[];e.$ref;){var s=e.$ref,o=s.split("#",2);if(delete e.$ref,o[0].length>0)return void a.push(u(e,o[0],o[1],r,i));-1===n.indexOf(s)&&(c(e,t,r,o[1]),n.push(s))}h(e.items,e.additionalProperties,e.not,e.contains,e.propertyNames,e.if,e.then,e.else),l(e.definitions,e.properties,e.patternProperties,e.dependencies),f(e.anyOf,e.allOf,e.oneOf,e.items)};s.length;){var m=s.pop();o.indexOf(m)>=0||(o.push(m),d(m))}return n.promise.all(a)};return l(s,s,t,r).then(function(){return new d(s,i)})},e.prototype.getSchemaForResource=function(e,t){if(t&&t.root&&"object"===t.root.type){var r=t.root.properties.filter(function(e){return"$schema"===e.keyNode.value&&e.valueNode&&"string"===e.valueNode.type});if(r.length>0){var n=a.getNodeValue(r[0].valueNode);if(n&&o.startsWith(n,".")&&this.contextService&&(n=this.contextService.resolveRelativePath(n,e)),n){var i=this.normalizeId(n);return this.getOrAddSchemaHandle(i).getResolvedSchema()}}}for(var s=Object.create(null),c=[],h=0,u=this.filePatternAssociations;h<u.length;h++){var l=u[h];if(l.matchesPattern(e))for(var f=0,d=l.getSchemas();f<d.length;f++){var m=d[f];s[m]||(c.push(m),s[m]=!0)}}return c.length>0?this.createCombinedSchema(e,c).getResolvedSchema():this.promise.resolve(null)},e.prototype.createCombinedSchema=function(e,t){if(1===t.length)return this.getOrAddSchemaHandle(t[0]);var r="schemaservice://combinedSchema/"+encodeURIComponent(e),n={allOf:t.map(function(e){return{$ref:e}})};return this.addSchemaHandle(r,n)},e}();t.JSONSchemaService=m});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/parser/jsonParser.js*/
define("8408640",function(e,t){"use strict";function r(e){return p.isBoolean(e)?e?{}:{not:{}}:e}function n(e,t){return void 0===t&&(t=[]),new P(e,t,[])}function o(e){return f.getNodeValue(e)}function i(e){return f.getNodePath(e)}function a(e,t,r){return void 0===r&&(r=!1),t>=e.offset&&t<e.offset+e.length||r&&t===e.offset+e.length}function s(e,t,n,i){function a(){function a(t){return e.type===t||"integer"===t&&"number"===e.type&&e.isInteger}if(Array.isArray(t.type)?t.type.some(a)||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("typeArrayMismatchWarning","Incorrect type. Expected one of {0}.",t.type.join(", "))}):t.type&&(a(t.type)||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("typeMismatchWarning",'Incorrect type. Expected "{0}".',t.type)})),Array.isArray(t.allOf))for(var l=0,u=t.allOf;l<u.length;l++){var c=u[l];s(e,r(c),n,i)}var f=r(t.not);if(f){var m=new w,h=i.newSub();s(e,f,m,h),m.hasProblems()||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("notSchemaWarning","Matches a schema that is not allowed.")});for(var y=0,b=h.schemas;y<b.length;y++){var x=b[y];x.inverted=!x.inverted,i.add(x)}}var M=function(t,o){for(var a=[],l=null,u=0,c=t;u<c.length;u++){var f=c[u],p=r(f),g=new w,m=i.newSub();if(s(e,p,g,m),g.hasProblems()||a.push(p),l)if(o||g.hasProblems()||l.validationResult.hasProblems()){var h=g.compare(l.validationResult);h>0?l={schema:p,validationResult:g,matchingSchemas:m}:0===h&&(l.matchingSchemas.merge(m),l.validationResult.mergeEnumValues(g))}else l.matchingSchemas.merge(m),l.validationResult.propertiesMatches+=g.propertiesMatches,l.validationResult.propertiesValueMatches+=g.propertiesValueMatches;else l={schema:p,validationResult:g,matchingSchemas:m}}return a.length>1&&o&&n.problems.push({location:{offset:e.offset,length:1},severity:d.DiagnosticSeverity.Warning,message:v("oneOfWarning","Matches multiple schemas when only one must validate.")}),null!==l&&(n.merge(l.validationResult),n.propertiesMatches+=l.validationResult.propertiesMatches,n.propertiesValueMatches+=l.validationResult.propertiesValueMatches,i.merge(l.matchingSchemas)),a.length};Array.isArray(t.anyOf)&&M(t.anyOf,!1),Array.isArray(t.oneOf)&&M(t.oneOf,!0);var E=function(t){var o=new w,a=i.newSub();s(e,r(t),o,a),n.merge(o),n.propertiesMatches+=o.propertiesMatches,n.propertiesValueMatches+=o.propertiesValueMatches,i.merge(a)},k=function(t,n,o){var a=r(t),l=new w,u=i.newSub();s(e,a,l,u),i.merge(u),l.hasProblems()?o&&E(o):n&&E(n)},S=r(t.if);if(S&&k(S,r(t.then),r(t.else)),Array.isArray(t.enum)){for(var O=o(e),V=!1,N=0,W=t.enum;N<W.length;N++){var T=W[N];if(p.equals(O,T)){V=!0;break}}n.enumValues=t.enum,n.enumValueMatch=V,V||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,code:g.ErrorCode.EnumValueMismatch,message:t.errorMessage||v("enumWarning","Value is not accepted. Valid values: {0}.",t.enum.map(function(e){return JSON.stringify(e)}).join(", "))})}if(p.isDefined(t.const)){var O=o(e);p.equals(O,t.const)?n.enumValueMatch=!0:(n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,code:g.ErrorCode.EnumValueMismatch,message:t.errorMessage||v("constWarning","Value must be {0}.",JSON.stringify(t.const))}),n.enumValueMatch=!1),n.enumValues=[t.const]}t.deprecationMessage&&e.parent&&n.problems.push({location:{offset:e.parent.offset,length:e.parent.length},severity:d.DiagnosticSeverity.Warning,message:t.deprecationMessage})}function l(e,t,r){function n(e,t){return p.isNumber(t)?t:p.isBoolean(t)&&t?e:void 0}function o(e,t){return p.isBoolean(t)&&t?void 0:e}var i=e.value;p.isNumber(t.multipleOf)&&i%t.multipleOf!==0&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("multipleOfWarning","Value is not divisible by {0}.",t.multipleOf)});var a=n(t.minimum,t.exclusiveMinimum);p.isNumber(a)&&a>=i&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("exclusiveMinimumWarning","Value is below the exclusive minimum of {0}.",a)});var s=n(t.maximum,t.exclusiveMaximum);p.isNumber(s)&&i>=s&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("exclusiveMaximumWarning","Value is above the exclusive maximum of {0}.",s)});var l=o(t.minimum,t.exclusiveMinimum);p.isNumber(l)&&l>i&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("minimumWarning","Value is below the minimum of {0}.",l)});var u=o(t.maximum,t.exclusiveMaximum);p.isNumber(u)&&i>u&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("maximumWarning","Value is above the maximum of {0}.",u)})}function u(e,t,r){if(p.isNumber(t.minLength)&&e.value.length<t.minLength&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("minLengthWarning","String is shorter than the minimum length of {0}.",t.minLength)}),p.isNumber(t.maxLength)&&e.value.length>t.maxLength&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("maxLengthWarning","String is longer than the maximum length of {0}.",t.maxLength)}),p.isString(t.pattern)){var n=new RegExp(t.pattern);n.test(e.value)||r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("patternWarning",'String does not match the pattern of "{0}".',t.pattern)})}if(t.format)switch(t.format){case"uri":case"uri-reference":var o=void 0;if(e.value)try{var i=h.default.parse(e.value);i.scheme||"uri"!==t.format||(o=v("uriSchemeMissing","URI with a scheme is expected."))}catch(a){o=a.message}else o=v("uriEmpty","URI expected.");o&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("uriFormatWarning","String is not a URI: {0}",o)});break;case"email":e.value.match(b)||r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("emailFormatWarning","String is not an e-mail address.")});break;case"color-hex":e.value.match(y)||r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("colorHexFormatWarning","Invalid color format. Use #RGB, #RGBA, #RRGGBB or #RRGGBBAA.")})}}function c(e,t,n,i){if(Array.isArray(t.items)){for(var a=t.items,l=0;l<a.length;l++){var u=a[l],c=r(u),f=new w,g=e.items[l];g?(s(g,c,f,i),n.mergePropertyMatch(f)):e.items.length>=a.length&&n.propertiesValueMatches++}if(e.items.length>a.length)if("object"==typeof t.additionalItems)for(var m=a.length;m<e.items.length;m++){var f=new w;s(e.items[m],t.additionalItems,f,i),n.mergePropertyMatch(f)}else t.additionalItems===!1&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("additionalItemsWarning","Array has too many items according to schema. Expected {0} or fewer.",a.length)})}else{var h=r(t.items);if(h)for(var y=0,b=e.items;y<b.length;y++){var g=b[y],f=new w;s(g,h,f,i),n.mergePropertyMatch(f)}}var x=r(t.contains);if(x){var M=e.items.some(function(e){var t=new w;return s(e,x,t,T.instance),!t.hasProblems()});M||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("requiredItemMissingWarning","Array does not contain required item.")})}if(p.isNumber(t.minItems)&&e.items.length<t.minItems&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("minItemsWarning","Array has too few items. Expected {0} or more.",t.minItems)}),p.isNumber(t.maxItems)&&e.items.length>t.maxItems&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("maxItemsWarning","Array has too many items. Expected {0} or fewer.",t.maxItems)}),t.uniqueItems===!0){var E=o(e),k=E.some(function(e,t){return t!==E.lastIndexOf(e)});k&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("uniqueItemsWarning","Array has duplicate items.")})}}function f(e,t,n,o){for(var i=Object.create(null),a=[],l=0,u=e.properties;l<u.length;l++){var c=u[l],f=c.keyNode.value;i[f]=c.valueNode,a.push(f)}if(Array.isArray(t.required))for(var g=0,m=t.required;g<m.length;g++){var h=m[g];if(!i[h]){var y=e.parent&&"property"===e.parent.type&&e.parent.keyNode,b=y?{offset:y.offset,length:y.length}:{offset:e.offset,length:1};n.problems.push({location:b,severity:d.DiagnosticSeverity.Warning,message:v("MissingRequiredPropWarning",'Missing property "{0}".',h)})}}var x=function(e){for(var t=a.indexOf(e);t>=0;)a.splice(t,1),t=a.indexOf(e)};if(t.properties)for(var M=0,E=Object.keys(t.properties);M<E.length;M++){var h=E[M];x(h);var k=t.properties[h],S=i[h];if(S)if(p.isBoolean(k))if(k)n.propertiesMatches++,n.propertiesValueMatches++;else{var c=S.parent;n.problems.push({location:{offset:c.keyNode.offset,length:c.keyNode.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("DisallowedExtraPropWarning","Property {0} is not allowed.",h)})}else{var O=new w;s(S,k,O,o),n.mergePropertyMatch(O)}}if(t.patternProperties)for(var V=0,N=Object.keys(t.patternProperties);V<N.length;V++)for(var W=N[V],P=new RegExp(W),A=0,C=a.slice(0);A<C.length;A++){var h=C[A];if(P.test(h)){x(h);var S=i[h];if(S){var k=t.patternProperties[W];if(p.isBoolean(k))if(k)n.propertiesMatches++,n.propertiesValueMatches++;else{var c=S.parent;n.problems.push({location:{offset:c.keyNode.offset,length:c.keyNode.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("DisallowedExtraPropWarning","Property {0} is not allowed.",h)})}else{var O=new w;s(S,k,O,o),n.mergePropertyMatch(O)}}}}if("object"==typeof t.additionalProperties)for(var D=0,I=a;D<I.length;D++){var h=I[D],S=i[h];if(S){var O=new w;s(S,t.additionalProperties,O,o),n.mergePropertyMatch(O)}}else if(t.additionalProperties===!1&&a.length>0)for(var j=0,R=a;j<R.length;j++){var h=R[j],S=i[h];if(S){var c=S.parent;n.problems.push({location:{offset:c.keyNode.offset,length:c.keyNode.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("DisallowedExtraPropWarning","Property {0} is not allowed.",h)})}}if(p.isNumber(t.maxProperties)&&e.properties.length>t.maxProperties&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("MaxPropWarning","Object has more properties than limit of {0}.",t.maxProperties)}),p.isNumber(t.minProperties)&&e.properties.length<t.minProperties&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("MinPropWarning","Object has fewer properties than the required number of {0}",t.minProperties)}),t.dependencies)for(var U=0,_=Object.keys(t.dependencies);U<_.length;U++){var f=_[U],B=i[f];if(B){var q=t.dependencies[f];if(Array.isArray(q))for(var L=0,F=q;L<F.length;L++){var J=F[L];i[J]?n.propertiesValueMatches++:n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("RequiredDependentPropWarning","Object is missing property {0} required by property {1}.",J,f)})}else{var k=r(q);if(k){var O=new w;s(e,k,O,o),n.mergePropertyMatch(O)}}}}var G=r(t.propertyNames);if(G)for(var K=0,z=e.properties;K<z.length;K++){var Z=z[K],f=Z.keyNode;f&&s(f,G,n,T.instance)}}if(e&&i.include(e)){switch(e.type){case"object":f(e,t,n,i);break;case"array":c(e,t,n,i);break;case"string":u(e,t,n,i);break;case"number":l(e,t,n,i);break;case"property":return s(e.valueNode,t,n,i)}a(),i.add({node:e,schema:t})}}function l(e,t){function r(){for(;;){var t=T.scan();switch(i(),t){case 12:case 13:Array.isArray(w)&&w.push(d.Range.create(e.positionAt(T.getTokenOffset()),e.positionAt(T.getTokenOffset()+T.getTokenLength())));break;case 15:case 14:break;default:return t}}}function n(t,r,n,o,i){if(void 0===i&&(i=d.DiagnosticSeverity.Error),0===b.length||n!==x){var a=d.Range.create(e.positionAt(n),e.positionAt(o));b.push(d.Diagnostic.create(a,t,i,r,e.languageId)),x=n}}function o(e,t,o,i,s){void 0===o&&(o=null),void 0===i&&(i=[]),void 0===s&&(s=[]);var l=T.getTokenOffset(),u=T.getTokenOffset()+T.getTokenLength();if(l===u&&l>0){for(l--;l>0&&/\s/.test(W.charAt(l));)l--;u=l+1}if(n(e,t,l,u),o&&a(o,!1),i.length+s.length>0)for(var c=T.getToken();17!==c;){if(-1!==i.indexOf(c)){r();break}if(-1!==s.indexOf(c))break;c=r()}return o}function i(){switch(T.getTokenError()){case 4:return o(v("InvalidUnicode","Invalid unicode sequence in string."),g.ErrorCode.InvalidUnicode),!0;case 5:return o(v("InvalidEscapeCharacter","Invalid escape character in string."),g.ErrorCode.InvalidEscapeCharacter),!0;case 3:return o(v("UnexpectedEndOfNumber","Unexpected end of number."),g.ErrorCode.UnexpectedEndOfNumber),!0;case 1:return o(v("UnexpectedEndOfComment","Unexpected end of comment."),g.ErrorCode.UnexpectedEndOfComment),!0;case 2:return o(v("UnexpectedEndOfString","Unexpected end of string."),g.ErrorCode.UnexpectedEndOfString),!0;case 6:return o(v("InvalidCharacter","Invalid characters in string. Control characters must be escaped."),g.ErrorCode.InvalidCharacter),!0}return!1}function a(e,t){return e.length=T.getTokenOffset()+T.getTokenLength()-e.offset,t&&r(),e}function s(e){if(3!==T.getToken())return null;var t=new k(e,T.getTokenOffset());r();for(var i=0,s=!1;4!==T.getToken()&&17!==T.getToken();){if(5===T.getToken()){s||o(v("ValueExpected","Value expected"),g.ErrorCode.ValueExpected);var l=T.getTokenOffset();if(r(),4===T.getToken()){s&&n(v("TrailingComma","Trailing comma"),g.ErrorCode.TrailingComma,l,l+1);continue}}else s&&o(v("ExpectedComma","Expected comma"),g.ErrorCode.CommaExpected);var u=y(t,i++);u?t.items.push(u):o(v("PropertyExpected","Value expected"),g.ErrorCode.ValueExpected,null,[],[4,5]),s=!0}return 4!==T.getToken()?o(v("ExpectedCloseBracket","Expected comma or closing bracket"),g.ErrorCode.CommaOrCloseBacketExpected,t):a(t,!0)}function l(t,i){var a=new V(t,T.getTokenOffset()),s=c(a);if(!s){if(16!==T.getToken())return null;o(v("DoubleQuotesExpected","Property keys must be doublequoted"),g.ErrorCode.Undefined);var l=new O(a,T.getTokenOffset(),T.getTokenLength());l.value=T.getTokenValue(),s=l,r()}a.keyNode=s;var u=i[s.value];if(u?(n(v("DuplicateKeyWarning","Duplicate object key"),g.ErrorCode.DuplicateKey,a.keyNode.offset,a.keyNode.offset+a.keyNode.length,d.DiagnosticSeverity.Warning),"object"==typeof u&&n(v("DuplicateKeyWarning","Duplicate object key"),g.ErrorCode.DuplicateKey,u.keyNode.offset,u.keyNode.offset+u.keyNode.length,d.DiagnosticSeverity.Warning),i[s.value]=!0):i[s.value]=a,6===T.getToken())a.colonOffset=T.getTokenOffset(),r();else if(o(v("ColonExpected","Colon expected"),g.ErrorCode.ColonExpected),10===T.getToken()&&e.positionAt(s.offset+s.length).line<e.positionAt(T.getTokenOffset()).line)return a.length=s.length,a;var f=y(a,s.value);return f?(a.valueNode=f,a.length=f.offset+f.length-a.offset,a):o(v("ValueExpected","Value expected"),g.ErrorCode.ValueExpected,a,[],[2,5])}function u(e){if(1!==T.getToken())return null;var t=new N(e,T.getTokenOffset()),i=Object.create(null);r();for(var s=!1;2!==T.getToken()&&17!==T.getToken();){if(5===T.getToken()){s||o(v("PropertyExpected","Property expected"),g.ErrorCode.PropertyExpected);var u=T.getTokenOffset();if(r(),2===T.getToken()){s&&n(v("TrailingComma","Trailing comma"),g.ErrorCode.TrailingComma,u,u+1);continue}}else s&&o(v("ExpectedComma","Expected comma"),g.ErrorCode.CommaExpected);var c=l(t,i);c?t.properties.push(c):o(v("PropertyExpected","Property expected"),g.ErrorCode.PropertyExpected,null,[],[2,5]),s=!0}return 2!==T.getToken()?o(v("ExpectedCloseBrace","Expected comma or closing brace"),g.ErrorCode.CommaOrCloseBraceExpected,t):a(t,!0)}function c(e){if(10!==T.getToken())return null;var t=new O(e,T.getTokenOffset());return t.value=T.getTokenValue(),a(t,!0)}function m(e){if(11!==T.getToken())return null;var t=new S(e,T.getTokenOffset());if(0===T.getTokenError()){var r=T.getTokenValue();try{var n=JSON.parse(r);if(!p.isNumber(n))return o(v("InvalidNumberFormat","Invalid number format."),g.ErrorCode.Undefined,t);t.value=n}catch(i){return o(v("InvalidNumberFormat","Invalid number format."),g.ErrorCode.Undefined,t)}t.isInteger=-1===r.indexOf(".")}return a(t,!0)}function h(e){switch(T.getToken()){case 7:return a(new M(e,T.getTokenOffset()),!0);case 8:return a(new E(e,!0,T.getTokenOffset()),!0);case 9:return a(new E(e,!1,T.getTokenOffset()),!0);default:return null}}function y(e){return s(e)||u(e)||c(e)||m(e)||h(e)}var b=[],x=-1,W=e.getText(),T=f.createScanner(W,!1),w=t&&t.collectComments?[]:void 0,A=null,C=r();return 17!==C&&(A=y(null,null),A?17!==T.getToken()&&o(v("End of file expected","End of file expected."),g.ErrorCode.Undefined):o(v("Invalid symbol","Expected a JSON object, array or literal."),g.ErrorCode.Undefined)),new P(A,b,w)}Object.defineProperty(t,"__esModule",{value:!0});var u=e("11ed2ab"),c=this&&this.__extends||function(){var e=function(t,r){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(t,r)};return function(t,r){function n(){this.constructor=t}e(t,r),t.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}(),f=u.__importStar(e("26128d7")),p=e("de6a48e"),g=e("683e3e1"),m=u.__importStar(e("60eaf5a")),h=u.__importDefault(e("a199806")),d=e("737c70e"),v=m.loadMessageBundle(),y=/^#([0-9A-Fa-f]{3,4}|([0-9A-Fa-f]{2}){3,4})$/,b=/^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,x=function(){function e(e,t,r){this.offset=t,this.length=r,this.parent=e}return Object.defineProperty(e.prototype,"children",{get:function(){return[]},enumerable:!0,configurable:!0}),e.prototype.toString=function(){return"type: "+this.type+" ("+this.offset+"/"+this.length+")"+(this.parent?" parent: {"+this.parent.toString()+"}":"")},e}();t.ASTNodeImpl=x;var M=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="null",n.value=null,n}return c(t,e),t}(x);t.NullASTNodeImpl=M;var E=function(e){function t(t,r,n){var o=e.call(this,t,n)||this;return o.type="boolean",o.value=r,o}return c(t,e),t}(x);t.BooleanASTNodeImpl=E;var k=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="array",n.items=[],n}return c(t,e),Object.defineProperty(t.prototype,"children",{get:function(){return this.items},enumerable:!0,configurable:!0}),t}(x);t.ArrayASTNodeImpl=k;var S=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="number",n.isInteger=!0,n.value=Number.NaN,n}return c(t,e),t}(x);t.NumberASTNodeImpl=S;var O=function(e){function t(t,r,n){var o=e.call(this,t,r,n)||this;return o.type="string",o.value="",o}return c(t,e),t}(x);t.StringASTNodeImpl=O;var V=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="property",n.colonOffset=-1,n}return c(t,e),Object.defineProperty(t.prototype,"children",{get:function(){return this.valueNode?[this.keyNode,this.valueNode]:[this.keyNode]},enumerable:!0,configurable:!0}),t}(x);t.PropertyASTNodeImpl=V;var N=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="object",n.properties=[],n}return c(t,e),Object.defineProperty(t.prototype,"children",{get:function(){return this.properties},enumerable:!0,configurable:!0}),t}(x);t.ObjectASTNodeImpl=N,t.asSchema=r,function(e){e[e.Key=0]="Key",e[e.Enum=1]="Enum"}(t.EnumMatch||(t.EnumMatch={}));var W=function(){function e(e,t){void 0===e&&(e=-1),void 0===t&&(t=null),this.focusOffset=e,this.exclude=t,this.schemas=[]}return e.prototype.add=function(e){this.schemas.push(e)},e.prototype.merge=function(e){var t;(t=this.schemas).push.apply(t,e.schemas)},e.prototype.include=function(e){return(-1===this.focusOffset||a(e,this.focusOffset))&&e!==this.exclude},e.prototype.newSub=function(){return new e(-1,this.exclude)},e}(),T=function(){function e(){}return Object.defineProperty(e.prototype,"schemas",{get:function(){return[]},enumerable:!0,configurable:!0}),e.prototype.add=function(){},e.prototype.merge=function(){},e.prototype.include=function(){return!0},e.prototype.newSub=function(){return this},e.instance=new e,e}(),w=function(){function e(){this.problems=[],this.propertiesMatches=0,this.propertiesValueMatches=0,this.primaryValueMatches=0,this.enumValueMatch=!1,this.enumValues=null}return e.prototype.hasProblems=function(){return!!this.problems.length},e.prototype.mergeAll=function(e){for(var t=0,r=e;t<r.length;t++){var n=r[t];this.merge(n)}},e.prototype.merge=function(e){this.problems=this.problems.concat(e.problems)},e.prototype.mergeEnumValues=function(e){if(!this.enumValueMatch&&!e.enumValueMatch&&this.enumValues&&e.enumValues){this.enumValues=this.enumValues.concat(e.enumValues);for(var t=0,r=this.problems;t<r.length;t++){var n=r[t];n.code===g.ErrorCode.EnumValueMismatch&&(n.message=v("enumWarning","Value is not accepted. Valid values: {0}.",this.enumValues.map(function(e){return JSON.stringify(e)}).join(", ")))}}},e.prototype.mergePropertyMatch=function(e){this.merge(e),this.propertiesMatches++,(e.enumValueMatch||!e.hasProblems()&&e.propertiesMatches)&&this.propertiesValueMatches++,e.enumValueMatch&&e.enumValues&&1===e.enumValues.length&&this.primaryValueMatches++},e.prototype.compare=function(e){var t=this.hasProblems();return t!==e.hasProblems()?t?-1:1:this.enumValueMatch!==e.enumValueMatch?e.enumValueMatch?-1:1:this.primaryValueMatches!==e.primaryValueMatches?this.primaryValueMatches-e.primaryValueMatches:this.propertiesValueMatches!==e.propertiesValueMatches?this.propertiesValueMatches-e.propertiesValueMatches:this.propertiesMatches-e.propertiesMatches},e}();t.ValidationResult=w,t.newJSONDocument=n,t.getNodeValue=o,t.getNodePath=i,t.contains=a;var P=function(){function e(e,t,r){void 0===t&&(t=[]),void 0===r&&(r=[]),this.root=e,this.syntaxErrors=t,this.comments=r}return e.prototype.getNodeFromOffset=function(e,t){return void 0===t&&(t=!1),this.root?f.findNodeAtOffset(this.root,e,t):void 0},e.prototype.visit=function(e){if(this.root){var t=function(r){var n=e(r),o=r.children;if(Array.isArray(o))for(var i=0;i<o.length&&n;i++)n=t(o[i]);return n};t(this.root)}},e.prototype.validate=function(e,t){if(this.root&&t){var r=new w;return s(this.root,t,r,T.instance),r.problems.map(function(t){var r=d.Range.create(e.positionAt(t.location.offset),e.positionAt(t.location.offset+t.location.length));return d.Diagnostic.create(r,t.message,t.severity,t.code)})}return null},e.prototype.getMatchingSchemas=function(e,t,r){void 0===t&&(t=-1),void 0===r&&(r=null);var n=new W(t,r);return this.root&&e&&s(this.root,e,new w,n),n.schemas},e}();t.JSONDocument=P,t.parse=l});
/**! node_modules/monaco-editor/esm/vs/language/json/fillers/vscode-nls.js*/
define("60eaf5a",function(e,n){"use strict";function r(e,n){var r;return r=0===n.length?e:e.replace(/\{(\d+)\}/g,function(e,r){var t=r[0];return"undefined"!=typeof n[t]?n[t]:e})}function t(e,n){for(var t=[],u=2;u<arguments.length;u++)t[u-2]=arguments[u];return r(n,t)}function u(){return t}function f(){return u}Object.defineProperty(n,"__esModule",{value:!0}),n.loadMessageBundle=u,n.config=f});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/utils/objects.js*/
define("de6a48e",function(r,e){"use strict";function n(r,e){if(r===e)return!0;if(null===r||void 0===r||null===e||void 0===e)return!1;if(typeof r!=typeof e)return!1;if("object"!=typeof r)return!1;if(Array.isArray(r)!==Array.isArray(e))return!1;var t,i;if(Array.isArray(r)){if(r.length!==e.length)return!1;for(t=0;t<r.length;t++)if(!n(r[t],e[t]))return!1}else{var f=[];for(i in r)f.push(i);f.sort();var u=[];for(i in e)u.push(i);if(u.sort(),!n(f,u))return!1;for(t=0;t<f.length;t++)if(!n(r[f[t]],e[f[t]]))return!1}return!0}function t(r){return"number"==typeof r}function i(r){return"undefined"!=typeof r}function f(r){return"boolean"==typeof r}function u(r){return"string"==typeof r}Object.defineProperty(e,"__esModule",{value:!0}),e.equals=n,e.isNumber=t,e.isDefined=i,e.isBoolean=f,e.isString=u});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/utils/strings.js*/
define("a0f93b8",function(e,t){"use strict";function n(e,t){if(e.length<t.length)return!1;for(var n=0;n<t.length;n++)if(e[n]!==t[n])return!1;return!0}function r(e,t){var n=e.length-t.length;return n>0?e.lastIndexOf(t)===n:0===n?e===t:!1}function i(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function u(e,t){for(var n="";t>0;)1===(1&t)&&(n+=e),e+=e,t>>>=1;return n}Object.defineProperty(t,"__esModule",{value:!0}),t.startsWith=n,t.endsWith=r,t.convertSimple2RegExpPattern=i,t.repeat=u});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/utils/json.js*/
define("7e231df",function(e,r){"use strict";function n(e,r,t){if(null!==e&&"object"==typeof e){var i=r+"	";if(Array.isArray(e)){if(0===e.length)return"[]";for(var f="[\n",u=0;u<e.length;u++)f+=i+n(e[u],i,t),u<e.length-1&&(f+=","),f+="\n";return f+=r+"]"}var l=Object.keys(e);if(0===l.length)return"{}";for(var f="{\n",u=0;u<l.length;u++){var a=l[u];f+=i+JSON.stringify(a)+": "+n(e[a],i,t),u<l.length-1&&(f+=","),f+="\n"}return f+=r+"}"}return t(e)}Object.defineProperty(r,"__esModule",{value:!0}),r.stringifyObject=n});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/main.js*/
define("26128d7",function(e,t){"use strict";function r(e){switch(e){case 1:return"InvalidSymbol";case 2:return"InvalidNumberFormat";case 3:return"PropertyNameExpected";case 4:return"ValueExpected";case 5:return"ColonExpected";case 6:return"CommaExpected";case 7:return"CloseBraceExpected";case 8:return"CloseBracketExpected";case 9:return"EndOfFileExpected";case 10:return"InvalidCommentToken";case 11:return"UnexpectedEndOfComment";case 12:return"UnexpectedEndOfString";case 13:return"UnexpectedEndOfNumber";case 14:return"InvalidUnicode";case 15:return"InvalidEscapeCharacter";case 16:return"InvalidCharacter"}return"<unknown ParseErrorCode>"}function n(e,t,r){return d.format(e,t,r)}function a(e,t,r,n){return i.setProperty(e,t,r,n.formattingOptions,n.getInsertionIndex)}function o(e,t){for(var r=t.length-1;r>=0;r--)e=i.applyEdit(e,t[r]);return e}Object.defineProperty(t,"__esModule",{value:!0});var c=e("11ed2ab"),d=c.__importStar(e("86b561e")),i=c.__importStar(e("98ab305")),s=c.__importStar(e("aedc3c9")),u=c.__importStar(e("38cea32"));t.createScanner=s.createScanner,t.getLocation=u.getLocation,t.parse=u.parse,t.parseTree=u.parseTree,t.findNodeAtLocation=u.findNodeAtLocation,t.findNodeAtOffset=u.findNodeAtOffset,t.getNodePath=u.getNodePath,t.getNodeValue=u.getNodeValue,t.visit=u.visit,t.stripComments=u.stripComments,t.printParseErrorCode=r,t.format=n,t.modify=a,t.applyEdits=o});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/parser/jsonParser.js*/
define("8408640",function(e,t){"use strict";function r(e){return p.isBoolean(e)?e?{}:{not:{}}:e}function n(e,t){return void 0===t&&(t=[]),new P(e,t,[])}function o(e){return f.getNodeValue(e)}function i(e){return f.getNodePath(e)}function a(e,t,r){return void 0===r&&(r=!1),t>=e.offset&&t<e.offset+e.length||r&&t===e.offset+e.length}function s(e,t,n,i){function a(){function a(t){return e.type===t||"integer"===t&&"number"===e.type&&e.isInteger}if(Array.isArray(t.type)?t.type.some(a)||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("typeArrayMismatchWarning","Incorrect type. Expected one of {0}.",t.type.join(", "))}):t.type&&(a(t.type)||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("typeMismatchWarning",'Incorrect type. Expected "{0}".',t.type)})),Array.isArray(t.allOf))for(var l=0,u=t.allOf;l<u.length;l++){var c=u[l];s(e,r(c),n,i)}var f=r(t.not);if(f){var m=new w,h=i.newSub();s(e,f,m,h),m.hasProblems()||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("notSchemaWarning","Matches a schema that is not allowed.")});for(var y=0,b=h.schemas;y<b.length;y++){var x=b[y];x.inverted=!x.inverted,i.add(x)}}var M=function(t,o){for(var a=[],l=null,u=0,c=t;u<c.length;u++){var f=c[u],p=r(f),g=new w,m=i.newSub();if(s(e,p,g,m),g.hasProblems()||a.push(p),l)if(o||g.hasProblems()||l.validationResult.hasProblems()){var h=g.compare(l.validationResult);h>0?l={schema:p,validationResult:g,matchingSchemas:m}:0===h&&(l.matchingSchemas.merge(m),l.validationResult.mergeEnumValues(g))}else l.matchingSchemas.merge(m),l.validationResult.propertiesMatches+=g.propertiesMatches,l.validationResult.propertiesValueMatches+=g.propertiesValueMatches;else l={schema:p,validationResult:g,matchingSchemas:m}}return a.length>1&&o&&n.problems.push({location:{offset:e.offset,length:1},severity:d.DiagnosticSeverity.Warning,message:v("oneOfWarning","Matches multiple schemas when only one must validate.")}),null!==l&&(n.merge(l.validationResult),n.propertiesMatches+=l.validationResult.propertiesMatches,n.propertiesValueMatches+=l.validationResult.propertiesValueMatches,i.merge(l.matchingSchemas)),a.length};Array.isArray(t.anyOf)&&M(t.anyOf,!1),Array.isArray(t.oneOf)&&M(t.oneOf,!0);var E=function(t){var o=new w,a=i.newSub();s(e,r(t),o,a),n.merge(o),n.propertiesMatches+=o.propertiesMatches,n.propertiesValueMatches+=o.propertiesValueMatches,i.merge(a)},k=function(t,n,o){var a=r(t),l=new w,u=i.newSub();s(e,a,l,u),i.merge(u),l.hasProblems()?o&&E(o):n&&E(n)},S=r(t.if);if(S&&k(S,r(t.then),r(t.else)),Array.isArray(t.enum)){for(var O=o(e),V=!1,N=0,W=t.enum;N<W.length;N++){var T=W[N];if(p.equals(O,T)){V=!0;break}}n.enumValues=t.enum,n.enumValueMatch=V,V||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,code:g.ErrorCode.EnumValueMismatch,message:t.errorMessage||v("enumWarning","Value is not accepted. Valid values: {0}.",t.enum.map(function(e){return JSON.stringify(e)}).join(", "))})}if(p.isDefined(t.const)){var O=o(e);p.equals(O,t.const)?n.enumValueMatch=!0:(n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,code:g.ErrorCode.EnumValueMismatch,message:t.errorMessage||v("constWarning","Value must be {0}.",JSON.stringify(t.const))}),n.enumValueMatch=!1),n.enumValues=[t.const]}t.deprecationMessage&&e.parent&&n.problems.push({location:{offset:e.parent.offset,length:e.parent.length},severity:d.DiagnosticSeverity.Warning,message:t.deprecationMessage})}function l(e,t,r){function n(e,t){return p.isNumber(t)?t:p.isBoolean(t)&&t?e:void 0}function o(e,t){return p.isBoolean(t)&&t?void 0:e}var i=e.value;p.isNumber(t.multipleOf)&&i%t.multipleOf!==0&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("multipleOfWarning","Value is not divisible by {0}.",t.multipleOf)});var a=n(t.minimum,t.exclusiveMinimum);p.isNumber(a)&&a>=i&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("exclusiveMinimumWarning","Value is below the exclusive minimum of {0}.",a)});var s=n(t.maximum,t.exclusiveMaximum);p.isNumber(s)&&i>=s&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("exclusiveMaximumWarning","Value is above the exclusive maximum of {0}.",s)});var l=o(t.minimum,t.exclusiveMinimum);p.isNumber(l)&&l>i&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("minimumWarning","Value is below the minimum of {0}.",l)});var u=o(t.maximum,t.exclusiveMaximum);p.isNumber(u)&&i>u&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("maximumWarning","Value is above the maximum of {0}.",u)})}function u(e,t,r){if(p.isNumber(t.minLength)&&e.value.length<t.minLength&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("minLengthWarning","String is shorter than the minimum length of {0}.",t.minLength)}),p.isNumber(t.maxLength)&&e.value.length>t.maxLength&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("maxLengthWarning","String is longer than the maximum length of {0}.",t.maxLength)}),p.isString(t.pattern)){var n=new RegExp(t.pattern);n.test(e.value)||r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("patternWarning",'String does not match the pattern of "{0}".',t.pattern)})}if(t.format)switch(t.format){case"uri":case"uri-reference":var o=void 0;if(e.value)try{var i=h.default.parse(e.value);i.scheme||"uri"!==t.format||(o=v("uriSchemeMissing","URI with a scheme is expected."))}catch(a){o=a.message}else o=v("uriEmpty","URI expected.");o&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("uriFormatWarning","String is not a URI: {0}",o)});break;case"email":e.value.match(b)||r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("emailFormatWarning","String is not an e-mail address.")});break;case"color-hex":e.value.match(y)||r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("colorHexFormatWarning","Invalid color format. Use #RGB, #RGBA, #RRGGBB or #RRGGBBAA.")})}}function c(e,t,n,i){if(Array.isArray(t.items)){for(var a=t.items,l=0;l<a.length;l++){var u=a[l],c=r(u),f=new w,g=e.items[l];g?(s(g,c,f,i),n.mergePropertyMatch(f)):e.items.length>=a.length&&n.propertiesValueMatches++}if(e.items.length>a.length)if("object"==typeof t.additionalItems)for(var m=a.length;m<e.items.length;m++){var f=new w;s(e.items[m],t.additionalItems,f,i),n.mergePropertyMatch(f)}else t.additionalItems===!1&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("additionalItemsWarning","Array has too many items according to schema. Expected {0} or fewer.",a.length)})}else{var h=r(t.items);if(h)for(var y=0,b=e.items;y<b.length;y++){var g=b[y],f=new w;s(g,h,f,i),n.mergePropertyMatch(f)}}var x=r(t.contains);if(x){var M=e.items.some(function(e){var t=new w;return s(e,x,t,T.instance),!t.hasProblems()});M||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("requiredItemMissingWarning","Array does not contain required item.")})}if(p.isNumber(t.minItems)&&e.items.length<t.minItems&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("minItemsWarning","Array has too few items. Expected {0} or more.",t.minItems)}),p.isNumber(t.maxItems)&&e.items.length>t.maxItems&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("maxItemsWarning","Array has too many items. Expected {0} or fewer.",t.maxItems)}),t.uniqueItems===!0){var E=o(e),k=E.some(function(e,t){return t!==E.lastIndexOf(e)});k&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("uniqueItemsWarning","Array has duplicate items.")})}}function f(e,t,n,o){for(var i=Object.create(null),a=[],l=0,u=e.properties;l<u.length;l++){var c=u[l],f=c.keyNode.value;i[f]=c.valueNode,a.push(f)}if(Array.isArray(t.required))for(var g=0,m=t.required;g<m.length;g++){var h=m[g];if(!i[h]){var y=e.parent&&"property"===e.parent.type&&e.parent.keyNode,b=y?{offset:y.offset,length:y.length}:{offset:e.offset,length:1};n.problems.push({location:b,severity:d.DiagnosticSeverity.Warning,message:v("MissingRequiredPropWarning",'Missing property "{0}".',h)})}}var x=function(e){for(var t=a.indexOf(e);t>=0;)a.splice(t,1),t=a.indexOf(e)};if(t.properties)for(var M=0,E=Object.keys(t.properties);M<E.length;M++){var h=E[M];x(h);var k=t.properties[h],S=i[h];if(S)if(p.isBoolean(k))if(k)n.propertiesMatches++,n.propertiesValueMatches++;else{var c=S.parent;n.problems.push({location:{offset:c.keyNode.offset,length:c.keyNode.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("DisallowedExtraPropWarning","Property {0} is not allowed.",h)})}else{var O=new w;s(S,k,O,o),n.mergePropertyMatch(O)}}if(t.patternProperties)for(var V=0,N=Object.keys(t.patternProperties);V<N.length;V++)for(var W=N[V],P=new RegExp(W),A=0,C=a.slice(0);A<C.length;A++){var h=C[A];if(P.test(h)){x(h);var S=i[h];if(S){var k=t.patternProperties[W];if(p.isBoolean(k))if(k)n.propertiesMatches++,n.propertiesValueMatches++;else{var c=S.parent;n.problems.push({location:{offset:c.keyNode.offset,length:c.keyNode.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("DisallowedExtraPropWarning","Property {0} is not allowed.",h)})}else{var O=new w;s(S,k,O,o),n.mergePropertyMatch(O)}}}}if("object"==typeof t.additionalProperties)for(var D=0,I=a;D<I.length;D++){var h=I[D],S=i[h];if(S){var O=new w;s(S,t.additionalProperties,O,o),n.mergePropertyMatch(O)}}else if(t.additionalProperties===!1&&a.length>0)for(var j=0,R=a;j<R.length;j++){var h=R[j],S=i[h];if(S){var c=S.parent;n.problems.push({location:{offset:c.keyNode.offset,length:c.keyNode.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("DisallowedExtraPropWarning","Property {0} is not allowed.",h)})}}if(p.isNumber(t.maxProperties)&&e.properties.length>t.maxProperties&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("MaxPropWarning","Object has more properties than limit of {0}.",t.maxProperties)}),p.isNumber(t.minProperties)&&e.properties.length<t.minProperties&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("MinPropWarning","Object has fewer properties than the required number of {0}",t.minProperties)}),t.dependencies)for(var U=0,_=Object.keys(t.dependencies);U<_.length;U++){var f=_[U],B=i[f];if(B){var q=t.dependencies[f];if(Array.isArray(q))for(var L=0,F=q;L<F.length;L++){var J=F[L];i[J]?n.propertiesValueMatches++:n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("RequiredDependentPropWarning","Object is missing property {0} required by property {1}.",J,f)})}else{var k=r(q);if(k){var O=new w;s(e,k,O,o),n.mergePropertyMatch(O)}}}}var G=r(t.propertyNames);if(G)for(var K=0,z=e.properties;K<z.length;K++){var Z=z[K],f=Z.keyNode;f&&s(f,G,n,T.instance)}}if(e&&i.include(e)){switch(e.type){case"object":f(e,t,n,i);break;case"array":c(e,t,n,i);break;case"string":u(e,t,n,i);break;case"number":l(e,t,n,i);break;case"property":return s(e.valueNode,t,n,i)}a(),i.add({node:e,schema:t})}}function l(e,t){function r(){for(;;){var t=T.scan();switch(i(),t){case 12:case 13:Array.isArray(w)&&w.push(d.Range.create(e.positionAt(T.getTokenOffset()),e.positionAt(T.getTokenOffset()+T.getTokenLength())));break;case 15:case 14:break;default:return t}}}function n(t,r,n,o,i){if(void 0===i&&(i=d.DiagnosticSeverity.Error),0===b.length||n!==x){var a=d.Range.create(e.positionAt(n),e.positionAt(o));b.push(d.Diagnostic.create(a,t,i,r,e.languageId)),x=n}}function o(e,t,o,i,s){void 0===o&&(o=null),void 0===i&&(i=[]),void 0===s&&(s=[]);var l=T.getTokenOffset(),u=T.getTokenOffset()+T.getTokenLength();if(l===u&&l>0){for(l--;l>0&&/\s/.test(W.charAt(l));)l--;u=l+1}if(n(e,t,l,u),o&&a(o,!1),i.length+s.length>0)for(var c=T.getToken();17!==c;){if(-1!==i.indexOf(c)){r();break}if(-1!==s.indexOf(c))break;c=r()}return o}function i(){switch(T.getTokenError()){case 4:return o(v("InvalidUnicode","Invalid unicode sequence in string."),g.ErrorCode.InvalidUnicode),!0;case 5:return o(v("InvalidEscapeCharacter","Invalid escape character in string."),g.ErrorCode.InvalidEscapeCharacter),!0;case 3:return o(v("UnexpectedEndOfNumber","Unexpected end of number."),g.ErrorCode.UnexpectedEndOfNumber),!0;case 1:return o(v("UnexpectedEndOfComment","Unexpected end of comment."),g.ErrorCode.UnexpectedEndOfComment),!0;case 2:return o(v("UnexpectedEndOfString","Unexpected end of string."),g.ErrorCode.UnexpectedEndOfString),!0;case 6:return o(v("InvalidCharacter","Invalid characters in string. Control characters must be escaped."),g.ErrorCode.InvalidCharacter),!0}return!1}function a(e,t){return e.length=T.getTokenOffset()+T.getTokenLength()-e.offset,t&&r(),e}function s(e){if(3!==T.getToken())return null;var t=new k(e,T.getTokenOffset());r();for(var i=0,s=!1;4!==T.getToken()&&17!==T.getToken();){if(5===T.getToken()){s||o(v("ValueExpected","Value expected"),g.ErrorCode.ValueExpected);var l=T.getTokenOffset();if(r(),4===T.getToken()){s&&n(v("TrailingComma","Trailing comma"),g.ErrorCode.TrailingComma,l,l+1);continue}}else s&&o(v("ExpectedComma","Expected comma"),g.ErrorCode.CommaExpected);var u=y(t,i++);u?t.items.push(u):o(v("PropertyExpected","Value expected"),g.ErrorCode.ValueExpected,null,[],[4,5]),s=!0}return 4!==T.getToken()?o(v("ExpectedCloseBracket","Expected comma or closing bracket"),g.ErrorCode.CommaOrCloseBacketExpected,t):a(t,!0)}function l(t,i){var a=new V(t,T.getTokenOffset()),s=c(a);if(!s){if(16!==T.getToken())return null;o(v("DoubleQuotesExpected","Property keys must be doublequoted"),g.ErrorCode.Undefined);var l=new O(a,T.getTokenOffset(),T.getTokenLength());l.value=T.getTokenValue(),s=l,r()}a.keyNode=s;var u=i[s.value];if(u?(n(v("DuplicateKeyWarning","Duplicate object key"),g.ErrorCode.DuplicateKey,a.keyNode.offset,a.keyNode.offset+a.keyNode.length,d.DiagnosticSeverity.Warning),"object"==typeof u&&n(v("DuplicateKeyWarning","Duplicate object key"),g.ErrorCode.DuplicateKey,u.keyNode.offset,u.keyNode.offset+u.keyNode.length,d.DiagnosticSeverity.Warning),i[s.value]=!0):i[s.value]=a,6===T.getToken())a.colonOffset=T.getTokenOffset(),r();else if(o(v("ColonExpected","Colon expected"),g.ErrorCode.ColonExpected),10===T.getToken()&&e.positionAt(s.offset+s.length).line<e.positionAt(T.getTokenOffset()).line)return a.length=s.length,a;var f=y(a,s.value);return f?(a.valueNode=f,a.length=f.offset+f.length-a.offset,a):o(v("ValueExpected","Value expected"),g.ErrorCode.ValueExpected,a,[],[2,5])}function u(e){if(1!==T.getToken())return null;var t=new N(e,T.getTokenOffset()),i=Object.create(null);r();for(var s=!1;2!==T.getToken()&&17!==T.getToken();){if(5===T.getToken()){s||o(v("PropertyExpected","Property expected"),g.ErrorCode.PropertyExpected);var u=T.getTokenOffset();if(r(),2===T.getToken()){s&&n(v("TrailingComma","Trailing comma"),g.ErrorCode.TrailingComma,u,u+1);continue}}else s&&o(v("ExpectedComma","Expected comma"),g.ErrorCode.CommaExpected);var c=l(t,i);c?t.properties.push(c):o(v("PropertyExpected","Property expected"),g.ErrorCode.PropertyExpected,null,[],[2,5]),s=!0}return 2!==T.getToken()?o(v("ExpectedCloseBrace","Expected comma or closing brace"),g.ErrorCode.CommaOrCloseBraceExpected,t):a(t,!0)}function c(e){if(10!==T.getToken())return null;var t=new O(e,T.getTokenOffset());return t.value=T.getTokenValue(),a(t,!0)}function m(e){if(11!==T.getToken())return null;var t=new S(e,T.getTokenOffset());if(0===T.getTokenError()){var r=T.getTokenValue();try{var n=JSON.parse(r);if(!p.isNumber(n))return o(v("InvalidNumberFormat","Invalid number format."),g.ErrorCode.Undefined,t);t.value=n}catch(i){return o(v("InvalidNumberFormat","Invalid number format."),g.ErrorCode.Undefined,t)}t.isInteger=-1===r.indexOf(".")}return a(t,!0)}function h(e){switch(T.getToken()){case 7:return a(new M(e,T.getTokenOffset()),!0);case 8:return a(new E(e,!0,T.getTokenOffset()),!0);case 9:return a(new E(e,!1,T.getTokenOffset()),!0);default:return null}}function y(e){return s(e)||u(e)||c(e)||m(e)||h(e)}var b=[],x=-1,W=e.getText(),T=f.createScanner(W,!1),w=t&&t.collectComments?[]:void 0,A=null,C=r();return 17!==C&&(A=y(null,null),A?17!==T.getToken()&&o(v("End of file expected","End of file expected."),g.ErrorCode.Undefined):o(v("Invalid symbol","Expected a JSON object, array or literal."),g.ErrorCode.Undefined)),new P(A,b,w)}Object.defineProperty(t,"__esModule",{value:!0});var u=e("11ed2ab"),c=this&&this.__extends||function(){var e=function(t,r){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(t,r)};return function(t,r){function n(){this.constructor=t}e(t,r),t.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}(),f=u.__importStar(e("26128d7")),p=e("de6a48e"),g=e("683e3e1"),m=u.__importStar(e("60eaf5a")),h=u.__importDefault(e("a199806")),d=e("737c70e"),v=m.loadMessageBundle(),y=/^#([0-9A-Fa-f]{3,4}|([0-9A-Fa-f]{2}){3,4})$/,b=/^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,x=function(){function e(e,t,r){this.offset=t,this.length=r,this.parent=e}return Object.defineProperty(e.prototype,"children",{get:function(){return[]},enumerable:!0,configurable:!0}),e.prototype.toString=function(){return"type: "+this.type+" ("+this.offset+"/"+this.length+")"+(this.parent?" parent: {"+this.parent.toString()+"}":"")},e}();t.ASTNodeImpl=x;var M=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="null",n.value=null,n}return c(t,e),t}(x);t.NullASTNodeImpl=M;var E=function(e){function t(t,r,n){var o=e.call(this,t,n)||this;return o.type="boolean",o.value=r,o}return c(t,e),t}(x);t.BooleanASTNodeImpl=E;var k=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="array",n.items=[],n}return c(t,e),Object.defineProperty(t.prototype,"children",{get:function(){return this.items},enumerable:!0,configurable:!0}),t}(x);t.ArrayASTNodeImpl=k;var S=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="number",n.isInteger=!0,n.value=Number.NaN,n}return c(t,e),t}(x);t.NumberASTNodeImpl=S;var O=function(e){function t(t,r,n){var o=e.call(this,t,r,n)||this;return o.type="string",o.value="",o}return c(t,e),t}(x);t.StringASTNodeImpl=O;var V=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="property",n.colonOffset=-1,n}return c(t,e),Object.defineProperty(t.prototype,"children",{get:function(){return this.valueNode?[this.keyNode,this.valueNode]:[this.keyNode]},enumerable:!0,configurable:!0}),t}(x);t.PropertyASTNodeImpl=V;var N=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="object",n.properties=[],n}return c(t,e),Object.defineProperty(t.prototype,"children",{get:function(){return this.properties},enumerable:!0,configurable:!0}),t}(x);t.ObjectASTNodeImpl=N,t.asSchema=r,function(e){e[e.Key=0]="Key",e[e.Enum=1]="Enum"}(t.EnumMatch||(t.EnumMatch={}));var W=function(){function e(e,t){void 0===e&&(e=-1),void 0===t&&(t=null),this.focusOffset=e,this.exclude=t,this.schemas=[]}return e.prototype.add=function(e){this.schemas.push(e)},e.prototype.merge=function(e){var t;(t=this.schemas).push.apply(t,e.schemas)},e.prototype.include=function(e){return(-1===this.focusOffset||a(e,this.focusOffset))&&e!==this.exclude},e.prototype.newSub=function(){return new e(-1,this.exclude)},e}(),T=function(){function e(){}return Object.defineProperty(e.prototype,"schemas",{get:function(){return[]},enumerable:!0,configurable:!0}),e.prototype.add=function(){},e.prototype.merge=function(){},e.prototype.include=function(){return!0},e.prototype.newSub=function(){return this},e.instance=new e,e}(),w=function(){function e(){this.problems=[],this.propertiesMatches=0,this.propertiesValueMatches=0,this.primaryValueMatches=0,this.enumValueMatch=!1,this.enumValues=null}return e.prototype.hasProblems=function(){return!!this.problems.length},e.prototype.mergeAll=function(e){for(var t=0,r=e;t<r.length;t++){var n=r[t];this.merge(n)}},e.prototype.merge=function(e){this.problems=this.problems.concat(e.problems)},e.prototype.mergeEnumValues=function(e){if(!this.enumValueMatch&&!e.enumValueMatch&&this.enumValues&&e.enumValues){this.enumValues=this.enumValues.concat(e.enumValues);for(var t=0,r=this.problems;t<r.length;t++){var n=r[t];n.code===g.ErrorCode.EnumValueMismatch&&(n.message=v("enumWarning","Value is not accepted. Valid values: {0}.",this.enumValues.map(function(e){return JSON.stringify(e)}).join(", ")))}}},e.prototype.mergePropertyMatch=function(e){this.merge(e),this.propertiesMatches++,(e.enumValueMatch||!e.hasProblems()&&e.propertiesMatches)&&this.propertiesValueMatches++,e.enumValueMatch&&e.enumValues&&1===e.enumValues.length&&this.primaryValueMatches++},e.prototype.compare=function(e){var t=this.hasProblems();return t!==e.hasProblems()?t?-1:1:this.enumValueMatch!==e.enumValueMatch?e.enumValueMatch?-1:1:this.primaryValueMatches!==e.primaryValueMatches?this.primaryValueMatches-e.primaryValueMatches:this.propertiesValueMatches!==e.propertiesValueMatches?this.propertiesValueMatches-e.propertiesValueMatches:this.propertiesMatches-e.propertiesMatches},e}();t.ValidationResult=w,t.newJSONDocument=n,t.getNodeValue=o,t.getNodePath=i,t.contains=a;var P=function(){function e(e,t,r){void 0===t&&(t=[]),void 0===r&&(r=[]),this.root=e,this.syntaxErrors=t,this.comments=r}return e.prototype.getNodeFromOffset=function(e,t){return void 0===t&&(t=!1),this.root?f.findNodeAtOffset(this.root,e,t):void 0},e.prototype.visit=function(e){if(this.root){var t=function(r){var n=e(r),o=r.children;if(Array.isArray(o))for(var i=0;i<o.length&&n;i++)n=t(o[i]);return n};t(this.root)}},e.prototype.validate=function(e,t){if(this.root&&t){var r=new w;return s(this.root,t,r,T.instance),r.problems.map(function(t){var r=d.Range.create(e.positionAt(t.location.offset),e.positionAt(t.location.offset+t.location.length));return d.Diagnostic.create(r,t.message,t.severity,t.code)})}return null},e.prototype.getMatchingSchemas=function(e,t,r){void 0===t&&(t=-1),void 0===r&&(r=null);var n=new W(t,r);return this.root&&e&&s(this.root,e,new w,n),n.schemas},e}();t.JSONDocument=P,t.parse=l});
/**! node_modules/monaco-editor/esm/vs/editor/common/standalone/standaloneEnums.js*/
define("2e266ae",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),function(e){e[e.Unnecessary=1]="Unnecessary"}(n.MarkerTag||(n.MarkerTag={})),function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"}(n.MarkerSeverity||(n.MarkerSeverity={})),function(e){e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"}(n.KeyCode||(n.KeyCode={})),function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"}(n.SelectionDirection||(n.SelectionDirection={})),function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"}(n.ScrollbarVisibility||(n.ScrollbarVisibility={})),function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"}(n.OverviewRulerLane||(n.OverviewRulerLane={})),function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(n.EndOfLinePreference||(n.EndOfLinePreference={})),function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(n.DefaultEndOfLine||(n.DefaultEndOfLine={})),function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"}(n.EndOfLineSequence||(n.EndOfLineSequence={})),function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"}(n.TrackedRangeStickiness||(n.TrackedRangeStickiness={})),function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"}(n.ScrollType||(n.ScrollType={})),function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"}(n.CursorChangeReason||(n.CursorChangeReason={})),function(e){e[e.None=0]="None",e[e.Small=1]="Small",e[e.Large=2]="Large",e[e.SmallBlocks=3]="SmallBlocks",e[e.LargeBlocks=4]="LargeBlocks"}(n.RenderMinimap||(n.RenderMinimap={})),function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"}(n.WrappingIndent||(n.WrappingIndent={})),function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"}(n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={})),function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"}(n.TextEditorCursorStyle||(n.TextEditorCursorStyle={})),function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"}(n.RenderLineNumbersType||(n.RenderLineNumbersType={})),function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"}(n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={})),function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"}(n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={})),function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"}(n.MouseTargetType||(n.MouseTargetType={})),function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"}(n.IndentAction||(n.IndentAction={})),function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.Snippet=25]="Snippet"}(n.CompletionItemKind||(n.CompletionItemKind={})),function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"}(n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={})),function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"}(n.CompletionTriggerKind||(n.CompletionTriggerKind={})),function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"}(n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={})),function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"}(n.DocumentHighlightKind||(n.DocumentHighlightKind={})),function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"}(n.SymbolKind||(n.SymbolKind={}))});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/token.js*/
define("57d67ff",function(t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var e=function(){function t(t,n,e){this.offset=0|t,this.type=n,this.language=e}return t.prototype.toString=function(){return"("+this.offset+", "+this.type+")"},t}();n.Token=e;var i=function(){function t(t,n){this.tokens=t,this.endState=n}return t}();n.TokenizationResult=i;var o=function(){function t(t,n){this.tokens=t,this.endState=n}return t}();n.TokenizationResult2=o});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/selection.js*/
define("3b7eb07",function(t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var e=this&&this.__extends||function(){var t=function(n,e){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,n){t.__proto__=n}||function(t,n){for(var e in n)n.hasOwnProperty(e)&&(t[e]=n[e])})(n,e)};return function(n,e){function i(){this.constructor=n}t(n,e),n.prototype=null===e?Object.create(e):(i.prototype=e.prototype,new i)}}(),i=t("5ddf902"),o=t("4661130"),r=function(t){function n(n,e,i,o){var r=t.call(this,n,e,i,o)||this;return r.selectionStartLineNumber=n,r.selectionStartColumn=e,r.positionLineNumber=i,r.positionColumn=o,r}return e(n,t),n.prototype.clone=function(){return new n(this.selectionStartLineNumber,this.selectionStartColumn,this.positionLineNumber,this.positionColumn)},n.prototype.toString=function(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"},n.prototype.equalsSelection=function(t){return n.selectionsEqual(this,t)},n.selectionsEqual=function(t,n){return t.selectionStartLineNumber===n.selectionStartLineNumber&&t.selectionStartColumn===n.selectionStartColumn&&t.positionLineNumber===n.positionLineNumber&&t.positionColumn===n.positionColumn},n.prototype.getDirection=function(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1},n.prototype.setEndPosition=function(t,e){return 0===this.getDirection()?new n(this.startLineNumber,this.startColumn,t,e):new n(t,e,this.startLineNumber,this.startColumn)},n.prototype.getPosition=function(){return new i.Position(this.positionLineNumber,this.positionColumn)},n.prototype.setStartPosition=function(t,e){return 0===this.getDirection()?new n(t,e,this.endLineNumber,this.endColumn):new n(this.endLineNumber,this.endColumn,t,e)},n.fromPositions=function(t,e){return void 0===e&&(e=t),new n(t.lineNumber,t.column,e.lineNumber,e.column)},n.liftSelection=function(t){return new n(t.selectionStartLineNumber,t.selectionStartColumn,t.positionLineNumber,t.positionColumn)},n.selectionsArrEqual=function(t,n){if(t&&!n||!t&&n)return!1;if(!t&&!n)return!0;if(t.length!==n.length)return!1;for(var e=0,i=t.length;i>e;e++)if(!this.selectionsEqual(t[e],n[e]))return!1;return!0},n.isISelection=function(t){return t&&"number"==typeof t.selectionStartLineNumber&&"number"==typeof t.selectionStartColumn&&"number"==typeof t.positionLineNumber&&"number"==typeof t.positionColumn},n.createWithDirection=function(t,e,i,o,r){return 0===r?new n(t,e,i,o):new n(i,o,t,e)},n}(o.Range);n.Selection=r});
/**! node_modules/monaco-editor/esm/vs/base/common/keyCodes.js*/
define("651ae9b",function(e,t){"use strict";function n(e,t){var n=(65535&t)<<16>>>0;return(e|n)>>>0}function r(e,t){if(0===e)return null;var n=(65535&e)>>>0,r=(4294901760&e)>>>16;return new h(0!==r?[i(n,t),i(r,t)]:[i(n,t)])}function i(e,t){var n=2048&e?!0:!1,r=256&e?!0:!1,i=2===t?r:n,o=1024&e?!0:!1,u=512&e?!0:!1,s=2===t?n:r,a=255&e;return new y(i,o,u,s,a)}Object.defineProperty(t,"__esModule",{value:!0});var o=e("22e50b6"),u=function(){function e(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}return e.prototype.define=function(e,t){this._keyCodeToStr[e]=t,this._strToKeyCode[t.toLowerCase()]=e},e.prototype.keyCodeToStr=function(e){return this._keyCodeToStr[e]},e.prototype.strToKeyCode=function(e){return this._strToKeyCode[e.toLowerCase()]||0},e}(),s=new u,a=new u,d=new u;!function(){function e(e,t,n,r){void 0===n&&(n=t),void 0===r&&(r=n),s.define(e,t),a.define(e,n),d.define(e,r)}e(0,"unknown"),e(1,"Backspace"),e(2,"Tab"),e(3,"Enter"),e(4,"Shift"),e(5,"Ctrl"),e(6,"Alt"),e(7,"PauseBreak"),e(8,"CapsLock"),e(9,"Escape"),e(10,"Space"),e(11,"PageUp"),e(12,"PageDown"),e(13,"End"),e(14,"Home"),e(15,"LeftArrow","Left"),e(16,"UpArrow","Up"),e(17,"RightArrow","Right"),e(18,"DownArrow","Down"),e(19,"Insert"),e(20,"Delete"),e(21,"0"),e(22,"1"),e(23,"2"),e(24,"3"),e(25,"4"),e(26,"5"),e(27,"6"),e(28,"7"),e(29,"8"),e(30,"9"),e(31,"A"),e(32,"B"),e(33,"C"),e(34,"D"),e(35,"E"),e(36,"F"),e(37,"G"),e(38,"H"),e(39,"I"),e(40,"J"),e(41,"K"),e(42,"L"),e(43,"M"),e(44,"N"),e(45,"O"),e(46,"P"),e(47,"Q"),e(48,"R"),e(49,"S"),e(50,"T"),e(51,"U"),e(52,"V"),e(53,"W"),e(54,"X"),e(55,"Y"),e(56,"Z"),e(57,"Meta"),e(58,"ContextMenu"),e(59,"F1"),e(60,"F2"),e(61,"F3"),e(62,"F4"),e(63,"F5"),e(64,"F6"),e(65,"F7"),e(66,"F8"),e(67,"F9"),e(68,"F10"),e(69,"F11"),e(70,"F12"),e(71,"F13"),e(72,"F14"),e(73,"F15"),e(74,"F16"),e(75,"F17"),e(76,"F18"),e(77,"F19"),e(78,"NumLock"),e(79,"ScrollLock"),e(80,";",";","OEM_1"),e(81,"=","=","OEM_PLUS"),e(82,",",",","OEM_COMMA"),e(83,"-","-","OEM_MINUS"),e(84,".",".","OEM_PERIOD"),e(85,"/","/","OEM_2"),e(86,"`","`","OEM_3"),e(110,"ABNT_C1"),e(111,"ABNT_C2"),e(87,"[","[","OEM_4"),e(88,"\\","\\","OEM_5"),e(89,"]","]","OEM_6"),e(90,"'","'","OEM_7"),e(91,"OEM_8"),e(92,"OEM_102"),e(93,"NumPad0"),e(94,"NumPad1"),e(95,"NumPad2"),e(96,"NumPad3"),e(97,"NumPad4"),e(98,"NumPad5"),e(99,"NumPad6"),e(100,"NumPad7"),e(101,"NumPad8"),e(102,"NumPad9"),e(103,"NumPad_Multiply"),e(104,"NumPad_Add"),e(105,"NumPad_Separator"),e(106,"NumPad_Subtract"),e(107,"NumPad_Decimal"),e(108,"NumPad_Divide")}(),function(e){function t(e){return s.keyCodeToStr(e)}function n(e){return s.strToKeyCode(e)}function r(e){return a.keyCodeToStr(e)}function i(e){return d.keyCodeToStr(e)}function o(e){return a.strToKeyCode(e)||d.strToKeyCode(e)}e.toString=t,e.fromString=n,e.toUserSettingsUS=r,e.toUserSettingsGeneral=i,e.fromUserSettings=o}(t.KeyCodeUtils||(t.KeyCodeUtils={})),t.KeyChord=n,t.createKeybinding=r,t.createSimpleKeybinding=i;var y=function(){function e(e,t,n,r,i){this.ctrlKey=e,this.shiftKey=t,this.altKey=n,this.metaKey=r,this.keyCode=i}return e.prototype.equals=function(e){return this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode},e.prototype.isModifierKey=function(){return 0===this.keyCode||5===this.keyCode||57===this.keyCode||6===this.keyCode||4===this.keyCode},e.prototype.toChord=function(){return new h([this])},e.prototype.isDuplicateModifierCase=function(){return this.ctrlKey&&5===this.keyCode||this.shiftKey&&4===this.keyCode||this.altKey&&6===this.keyCode||this.metaKey&&57===this.keyCode},e}();t.SimpleKeybinding=y;var h=function(){function e(e){if(0===e.length)throw o.illegalArgument("parts");this.parts=e}return e.prototype.equals=function(e){if(null===e)return!1;if(this.parts.length!==e.parts.length)return!1;for(var t=0;t<this.parts.length;t++)if(!this.parts[t].equals(e.parts[t]))return!1;return!0},e}();t.ChordKeybinding=h;var f=function(){function e(e,t,n,r,i,o){this.ctrlKey=e,this.shiftKey=t,this.altKey=n,this.metaKey=r,this.keyLabel=i,this.keyAriaLabel=o}return e}();t.ResolvedKeybindingPart=f;var c=function(){function e(){}return e}();t.ResolvedKeybinding=c});
/**! node_modules/monaco-editor/esm/vs/base/common/event.js*/
define("8451667",function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n=this&&this.__extends||function(){var t=function(e,n){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(e,n)};return function(e,n){function i(){this.constructor=e}t(e,n),e.prototype=null===n?Object.create(n):(i.prototype=n.prototype,new i)}}(),i=t("22e50b6"),r=t("4af2228"),o=t("a0b8cca"),s=t("45886bc");!function(t){function e(t){return function(e,n,i){void 0===n&&(n=null);var r,o=!1;return r=t(function(t){return o?void 0:(r?r.dispose():o=!0,e.call(n,t))},null,i),o&&r.dispose(),r}}function n(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){return n.call(i,e(t))},null,r)})}function i(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){e(t),n.call(i,t)},null,r)})}function r(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){return e(t)&&n.call(i,t)},null,r)})}function s(t){return t}function u(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];return function(e,n,i){return void 0===n&&(n=null),o.combinedDisposable(t.map(function(t){return t(function(t){return e.call(n,t)},null,i)}))}}function c(t,e,i){var r=i;return n(t,function(t){return r=e(r,t)})}function a(t){var e,n=new f({onFirstListenerAdd:function(){e=t(n.fire,n)},onLastListenerRemove:function(){e.dispose()}});return n.event}function h(t,e,n,i,r){void 0===n&&(n=100),void 0===i&&(i=!1);var o,s=void 0,u=void 0,c=0,a=new f({leakWarningThreshold:r,onFirstListenerAdd:function(){o=t(function(t){c++,s=e(s,t),i&&!u&&a.fire(s),clearTimeout(u),u=setTimeout(function(){var t=s;s=void 0,u=void 0,(!i||c>1)&&a.fire(t),c=0},n)})},onLastListenerRemove:function(){o.dispose()}});return a.event}function p(t){var i=(new Date).getTime();return n(e(t),function(){return(new Date).getTime()-i})}function v(t){var e,n=!0;return r(t,function(t){var i=n||t!==e;return n=!1,e=t,i})}function l(t,e,n){void 0===e&&(e=!1),void 0===n&&(n=[]);var i=n.slice(),r=t(function(t){i?i.push(t):s.fire(t)}),o=function(){i&&i.forEach(function(t){return s.fire(t)}),i=null},s=new f({onFirstListenerAdd:function(){r||(r=t(function(t){return s.fire(t)}))},onFirstListenerDidAdd:function(){i&&(e?setTimeout(o):o())},onLastListenerRemove:function(){r&&r.dispose(),r=null}});return s.event}function d(t){return new w(t)}function _(t,e,n){void 0===n&&(n=function(t){return t});var i=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];return s.fire(n.apply(void 0,t))},r=function(){return t.on(e,i)},o=function(){return t.removeListener(e,i)},s=new f({onFirstListenerAdd:r,onLastListenerRemove:o});return s.event}function m(t){var e=new f,n=!1;return t.then(void 0,function(){return null}).then(function(){n?e.fire(void 0):setTimeout(function(){return e.fire(void 0)},0)}),n=!0,e.event}function y(t){return new Promise(function(n){return e(t)(n)})}var L={dispose:function(){}};t.None=function(){return L},t.once=e,t.map=n,t.forEach=i,t.filter=r,t.signal=s,t.any=u,t.reduce=c,t.snapshot=a,t.debounce=h,t.stopwatch=p,t.latch=v,t.buffer=l;var w=function(){function t(t){this.event=t}return t.prototype.map=function(e){return new t(n(this.event,e))},t.prototype.forEach=function(e){return new t(i(this.event,e))},t.prototype.filter=function(e){return new t(r(this.event,e))},t.prototype.reduce=function(e,n){return new t(c(this.event,e,n))},t.prototype.latch=function(){return new t(v(this.event))},t.prototype.on=function(t,e,n){return this.event(t,e,n)},t.prototype.once=function(t,n,i){return e(this.event)(t,n,i)},t}();t.chain=d,t.fromNodeEventEmitter=_,t.fromPromise=m,t.toPromise=y}(e.Event||(e.Event={}));var u=-1,c=function(){function t(t,e){void 0===e&&(e=Math.random().toString(18).slice(2,5)),this.customThreshold=t,this.name=e,this._warnCountdown=0}return t.prototype.dispose=function(){this._stacks&&this._stacks.clear()},t.prototype.check=function(t){var e=this,n=u;if("number"==typeof this.customThreshold&&(n=this.customThreshold),0>=n||n>t)return void 0;this._stacks||(this._stacks=new Map);var i=(new Error).stack.split("\n").slice(3).join("\n"),r=this._stacks.get(i)||0;if(this._stacks.set(i,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=.5*n;var o,s=0;this._stacks.forEach(function(t,e){(!o||t>s)&&(o=e,s=t)}),console.warn("["+this.name+"] potential listener LEAK detected, having "+t+" listeners already. MOST frequent listener ("+s+"):"),console.warn(o)}return function(){var t=e._stacks.get(i)||0;e._stacks.set(i,t-1)}},t}(),f=function(){function t(t){this._disposed=!1,this._options=t,this._leakageMon=u>0?new c(this._options&&this._options.leakWarningThreshold):void 0}return Object.defineProperty(t.prototype,"event",{get:function(){var e=this;return this._event||(this._event=function(n,i,r){e._listeners||(e._listeners=new s.LinkedList);var o=e._listeners.isEmpty();o&&e._options&&e._options.onFirstListenerAdd&&e._options.onFirstListenerAdd(e);var u=e._listeners.push(i?[n,i]:n);o&&e._options&&e._options.onFirstListenerDidAdd&&e._options.onFirstListenerDidAdd(e),e._options&&e._options.onListenerDidAdd&&e._options.onListenerDidAdd(e,n,i);var c;e._leakageMon&&(c=e._leakageMon.check(e._listeners.size));var f;return f={dispose:function(){if(c&&c(),f.dispose=t._noop,!e._disposed&&(u(),e._options&&e._options.onLastListenerRemove)){var n=e._listeners&&!e._listeners.isEmpty();n||e._options.onLastListenerRemove(e)}}},Array.isArray(r)&&r.push(f),f}),this._event},enumerable:!0,configurable:!0}),t.prototype.fire=function(t){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(var e=this._listeners.iterator(),n=e.next();!n.done;n=e.next())this._deliveryQueue.push([n.value,t]);for(;this._deliveryQueue.size>0;){var r=this._deliveryQueue.shift(),o=r[0],u=r[1];try{"function"==typeof o?o.call(void 0,u):o[0].call(o[1],u)}catch(n){i.onUnexpectedError(n)}}}},t.prototype.dispose=function(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),this._disposed=!0},t._noop=function(){},t}();e.Emitter=f;var a=function(t){function e(e){var n=t.call(this,e)||this;return n._isPaused=0,n._eventQueue=new s.LinkedList,n._mergeFn=e&&e.merge,n}return n(e,t),e.prototype.pause=function(){this._isPaused++},e.prototype.resume=function(){if(0!==this._isPaused&&0===--this._isPaused)if(this._mergeFn){var e=this._eventQueue.toArray();this._eventQueue.clear(),t.prototype.fire.call(this,this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)t.prototype.fire.call(this,this._eventQueue.shift())},e.prototype.fire=function(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):t.prototype.fire.call(this,e))},e}(f);e.PauseableEmitter=a;var h=function(){function t(){var t=this;this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:function(){return t.onFirstListenerAdd()},onLastListenerRemove:function(){return t.onLastListenerRemove()}})}return Object.defineProperty(t.prototype,"event",{get:function(){return this.emitter.event},enumerable:!0,configurable:!0}),t.prototype.add=function(t){var e=this,n={event:t,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);var i=function(){e.hasListeners&&e.unhook(n);var t=e.events.indexOf(n);e.events.splice(t,1)};return o.toDisposable(r.once(i))},t.prototype.onFirstListenerAdd=function(){var t=this;this.hasListeners=!0,this.events.forEach(function(e){return t.hook(e)})},t.prototype.onLastListenerRemove=function(){var t=this;this.hasListeners=!1,this.events.forEach(function(e){return t.unhook(e)})},t.prototype.hook=function(t){var e=this;t.listener=t.event(function(t){return e.emitter.fire(t)})},t.prototype.unhook=function(t){t.listener&&t.listener.dispose(),t.listener=null},t.prototype.dispose=function(){this.emitter.dispose()},t}();e.EventMultiplexer=h;var p=function(){function t(){this.buffers=[]}return t.prototype.wrapEvent=function(t){var e=this;return function(n,i,r){return t(function(t){var r=e.buffers[e.buffers.length-1];r?r.push(function(){return n.call(i,t)}):n.call(i,t)},void 0,r)}},t.prototype.bufferEvents=function(t){var e=[];this.buffers.push(e);var n=t();return this.buffers.pop(),e.forEach(function(t){return t()}),n},t}();e.EventBufferer=p;var v=function(){function t(){var t=this;this.listening=!1,this.inputEvent=e.Event.None,this.inputEventListener=o.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:function(){t.listening=!0,t.inputEventListener=t.inputEvent(t.emitter.fire,t.emitter)},onLastListenerRemove:function(){t.listening=!1,t.inputEventListener.dispose()}}),this.event=this.emitter.event}return Object.defineProperty(t.prototype,"input",{set:function(t){this.inputEvent=t,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=t(this.emitter.fire,this.emitter))},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){this.inputEventListener.dispose(),this.emitter.dispose()},t}();e.Relay=v});
/**! node_modules/monaco-editor/esm/vs/base/common/cancellation.js*/
define("7ed507d",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=e("8451667"),i=Object.freeze(function(e,t){var n=setTimeout(e.bind(t),0);return{dispose:function(){clearTimeout(n)}}});!function(e){function t(t){return t===e.None||t===e.Cancelled?!0:t instanceof o?!0:t&&"object"==typeof t?"boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested:!1}e.isCancellationToken=t,e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})}(t.CancellationToken||(t.CancellationToken={}));var o=function(){function e(){this._isCancelled=!1,this._emitter=null}return e.prototype.cancel=function(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))},Object.defineProperty(e.prototype,"isCancellationRequested",{get:function(){return this._isCancelled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onCancellationRequested",{get:function(){return this._isCancelled?i:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this._emitter&&(this._emitter.dispose(),this._emitter=null)},e}(),s=function(){function e(e){this._token=void 0,this._parentListener=void 0,this._parentListener=e&&e.onCancellationRequested(this.cancel,this)}return Object.defineProperty(e.prototype,"token",{get:function(){return this._token||(this._token=new o),this._token},enumerable:!0,configurable:!0}),e.prototype.cancel=function(){this._token?this._token instanceof o&&this._token.cancel():this._token=t.CancellationToken.Cancelled},e.prototype.dispose=function(){this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof o&&this._token.dispose():this._token=t.CancellationToken.None},e}();t.CancellationTokenSource=s});
/**! node_modules/monaco-editor/esm/vs/editor/common/standalone/promise-polyfill/polyfill.js*/
define("4a24931",function(e,n,t,o){!function(e,r){"object"==typeof n&&"undefined"!=typeof t?r():"function"==typeof o&&o.amd?o(r):r()}(this,function(){"use strict";function e(e){var n=this.constructor;return this.then(function(t){return n.resolve(e()).then(function(){return t})},function(t){return n.resolve(e()).then(function(){return n.reject(t)})})}function n(){}function t(e,n){return function(){e.apply(n,arguments)}}function o(e){if(!(this instanceof o))throw new TypeError("Promises must be constructed via new");if("function"!=typeof e)throw new TypeError("not a function");this._state=0,this._handled=!1,this._value=void 0,this._deferreds=[],a(e,this)}function r(e,n){for(;3===e._state;)e=e._value;return 0===e._state?void e._deferreds.push(n):(e._handled=!0,void o._immediateFn(function(){var t=1===e._state?n.onFulfilled:n.onRejected;if(null===t)return void(1===e._state?i:f)(n.promise,e._value);var o;try{o=t(e._value)}catch(r){return void f(n.promise,r)}i(n.promise,o)}))}function i(e,n){try{if(n===e)throw new TypeError("A promise cannot be resolved with itself.");if(n&&("object"==typeof n||"function"==typeof n)){var r=n.then;if(n instanceof o)return e._state=3,e._value=n,void u(e);if("function"==typeof r)return void a(t(r,n),e)}e._state=1,e._value=n,u(e)}catch(i){f(e,i)}}function f(e,n){e._state=2,e._value=n,u(e)}function u(e){2===e._state&&0===e._deferreds.length&&o._immediateFn(function(){e._handled||o._unhandledRejectionFn(e._value)});for(var n=0,t=e._deferreds.length;t>n;n++)r(e,e._deferreds[n]);e._deferreds=null}function c(e,n,t){this.onFulfilled="function"==typeof e?e:null,this.onRejected="function"==typeof n?n:null,this.promise=t}function a(e,n){var t=!1;try{e(function(e){t||(t=!0,i(n,e))},function(e){t||(t=!0,f(n,e))})}catch(o){if(t)return;t=!0,f(n,o)}}var l=setTimeout;o.prototype["catch"]=function(e){return this.then(null,e)},o.prototype.then=function(e,t){var o=new this.constructor(n);return r(this,new c(e,t,o)),o},o.prototype["finally"]=e,o.all=function(e){return new o(function(n,t){function o(e,f){try{if(f&&("object"==typeof f||"function"==typeof f)){var u=f.then;if("function"==typeof u)return void u.call(f,function(n){o(e,n)},t)}r[e]=f,0===--i&&n(r)}catch(c){t(c)}}if(!e||"undefined"==typeof e.length)throw new TypeError("Promise.all accepts an array");var r=Array.prototype.slice.call(e);if(0===r.length)return n([]);for(var i=r.length,f=0;f<r.length;f++)o(f,r[f])})},o.resolve=function(e){return e&&"object"==typeof e&&e.constructor===o?e:new o(function(n){n(e)})},o.reject=function(e){return new o(function(n,t){t(e)})},o.race=function(e){return new o(function(n,t){for(var o=0,r=e.length;r>o;o++)e[o].then(n,t)})},o._immediateFn="function"==typeof setImmediate&&function(e){setImmediate(e)}||function(e){l(e,0)},o._unhandledRejectionFn=function(e){"undefined"!=typeof console&&console&&console.warn("Possible Unhandled Promise Rejection:",e)};var s=function(){if("undefined"!=typeof self)return self;if("undefined"!=typeof window)return window;if("undefined"!=typeof global)return global;throw new Error("unable to locate global object")}();"Promise"in s?s.Promise.prototype["finally"]||(s.Promise.prototype["finally"]=e):s.Promise=o})});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/uint.js*/
define("4186ef1",function(t,n){"use strict";function r(t){return 0>t?0:t>255?255:0|t}function i(t){return 0>t?0:t>4294967295?4294967295:0|t}function e(t){for(var n=t.length,r=new Uint32Array(n),e=0;n>e;e++)r[e]=i(t[e]);return r}Object.defineProperty(n,"__esModule",{value:!0});var o=function(){function t(t,n,r){for(var i=new Uint8Array(t*n),e=0,o=t*n;o>e;e++)i[e]=r;this._data=i,this.rows=t,this.cols=n}return t.prototype.get=function(t,n){return this._data[t*this.cols+n]},t.prototype.set=function(t,n,r){this._data[t*this.cols+n]=r},t}();n.Uint8Matrix=o,n.toUint8=r,n.toUint32=i,n.toUint32Array=e});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/characterClassifier.js*/
define("206e614",function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i=t("4186ef1"),a=function(){function t(e){var a=i.toUint8(e);this._defaultValue=a,this._asciiMap=t._createAsciiMap(a),this._map=new Map}return t._createAsciiMap=function(t){for(var e=new Uint8Array(256),i=0;256>i;i++)e[i]=t;return e},t.prototype.set=function(t,e){var a=i.toUint8(e);t>=0&&256>t?this._asciiMap[t]=a:this._map.set(t,a)},t.prototype.get=function(t){return t>=0&&256>t?this._asciiMap[t]:this._map.get(t)||this._defaultValue},t}();e.CharacterClassifier=a;var n=function(){function t(){this._actual=new a(0)}return t.prototype.add=function(t){this._actual.set(t,1)},t.prototype.has=function(t){return 1===this._actual.get(t)},t}();e.CharacterSet=n});
/**! node_modules/monaco-editor/esm/vs/editor/common/viewModel/prefixSumComputer.js*/
define("cf86ba2",function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i=t("4186ef1"),u=function(){function t(t,e){this.index=t,this.remainder=e}return t}();e.PrefixSumIndexOfResult=u;var a=function(){function t(t){this.values=t,this.prefixSum=new Uint32Array(t.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}return t.prototype.getCount=function(){return this.values.length},t.prototype.insertValues=function(t,e){t=i.toUint32(t);var u=this.values,a=this.prefixSum,r=e.length;return 0===r?!1:(this.values=new Uint32Array(u.length+r),this.values.set(u.subarray(0,t),0),this.values.set(u.subarray(t),t+r),this.values.set(e,t),t-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=t-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},t.prototype.changeValue=function(t,e){return t=i.toUint32(t),e=i.toUint32(e),this.values[t]===e?!1:(this.values[t]=e,t-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=t-1),!0)},t.prototype.removeValues=function(t,e){t=i.toUint32(t),e=i.toUint32(e);var u=this.values,a=this.prefixSum;if(t>=u.length)return!1;var r=u.length-t;return e>=r&&(e=r),0===e?!1:(this.values=new Uint32Array(u.length-e),this.values.set(u.subarray(0,t),0),this.values.set(u.subarray(t+e),t),this.prefixSum=new Uint32Array(this.values.length),t-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=t-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},t.prototype.getTotalValue=function(){return 0===this.values.length?0:this._getAccumulatedValue(this.values.length-1)},t.prototype.getAccumulatedValue=function(t){return 0>t?0:(t=i.toUint32(t),this._getAccumulatedValue(t))},t.prototype._getAccumulatedValue=function(t){if(t<=this.prefixSumValidIndex[0])return this.prefixSum[t];var e=this.prefixSumValidIndex[0]+1;0===e&&(this.prefixSum[0]=this.values[0],e++),t>=this.values.length&&(t=this.values.length-1);for(var i=e;t>=i;i++)this.prefixSum[i]=this.prefixSum[i-1]+this.values[i];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],t),this.prefixSum[t]},t.prototype.getIndexOf=function(t){t=Math.floor(t),this.getTotalValue();for(var e=0,i=this.values.length-1,a=0,r=0,s=0;i>=e;)if(a=e+(i-e)/2|0,r=this.prefixSum[a],s=r-this.values[a],s>t)i=a-1;else{if(!(t>=r))break;e=a+1}return new u(a,t-s)},t}();e.PrefixSumComputer=a;var r=function(){function t(t){this._cacheAccumulatedValueStart=0,this._cache=null,this._actual=new a(t),this._bustCache()}return t.prototype._bustCache=function(){this._cacheAccumulatedValueStart=0,this._cache=null},t.prototype.insertValues=function(t,e){this._actual.insertValues(t,e)&&this._bustCache()},t.prototype.changeValue=function(t,e){this._actual.changeValue(t,e)&&this._bustCache()},t.prototype.removeValues=function(t,e){this._actual.removeValues(t,e)&&this._bustCache()},t.prototype.getTotalValue=function(){return this._actual.getTotalValue()},t.prototype.getAccumulatedValue=function(t){return this._actual.getAccumulatedValue(t)},t.prototype.getIndexOf=function(t){if(t=Math.floor(t),null!==this._cache){var e=t-this._cacheAccumulatedValueStart;if(e>=0&&e<this._cache.length)return this._cache[e]}return this._actual.getIndexOf(t)},t.prototype.warmUpCache=function(t,e){for(var i=[],u=t;e>=u;u++)i[u-t]=this.getIndexOf(u);this._cache=i,this._cacheAccumulatedValueStart=t},t}();e.PrefixSumComputerWithCache=r});
/**! node_modules/monaco-editor/esm/vs/base/common/strings.js*/
define("572f899",function(r,t){"use strict";function e(r){return r&&"string"==typeof r?0===r.trim().length:!0}function n(r,t,e){void 0===e&&(e="0");for(var n=""+r,u=[n],i=n.length;t>i;i++)u.push(e);return u.reverse().join("")}function u(r){for(var t=[],e=1;e<arguments.length;e++)t[e-1]=arguments[e];return 0===t.length?r:r.replace(U,function(r,e){var n=parseInt(e,10);return isNaN(n)||0>n||n>=t.length?r:t[n]})}function i(r){return r.replace(/[<>&]/g,function(r){switch(r){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return r}})}function o(r){return r.replace(/[\-\\\{\}\*\+\?\|\^\$\.\[\]\(\)\#]/g,"\\$&")}function a(r,t){void 0===t&&(t=" ");var e=f(r,t);return c(e,t)}function f(r,t){if(!r||!t)return r;var e=t.length;if(0===e||0===r.length)return r;for(var n=0;r.indexOf(t,n)===n;)n+=e;return r.substring(n)}function c(r,t){if(!r||!t)return r;var e=t.length,n=r.length;if(0===e||0===n)return r;for(var u=n,i=-1;;){if(i=r.lastIndexOf(t,u-1),-1===i||i+e!==u)break;if(0===i)return"";u=i}return r.substring(0,u)}function s(r){return r.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function g(r,t){if(r.length<t.length)return!1;if(r===t)return!0;for(var e=0;e<t.length;e++)if(r[e]!==t[e])return!1;return!0}function h(r,t){var e=r.length-t.length;return e>0?r.indexOf(t,e)===e:0===e?r===t:!1}function l(r,t,e){if(void 0===e&&(e={}),!r)throw new Error("Cannot create regex from empty string");t||(r=o(r)),e.wholeWord&&(/\B/.test(r.charAt(0))||(r="\\b"+r),/\B/.test(r.charAt(r.length-1))||(r+="\\b"));var n="";return e.global&&(n+="g"),e.matchCase||(n+="i"),e.multiline&&(n+="m"),e.unicode&&(n+="u"),new RegExp(r,n)}function D(r){if("^"===r.source||"^$"===r.source||"$"===r.source||"^\\s*$"===r.source)return!1;var t=r.exec("");return!(!t||0!==r.lastIndex)}function F(r){return(r.global?"g":"")+(r.ignoreCase?"i":"")+(r.multiline?"m":"")+(r.unicode?"u":"")}function C(r){for(var t=0,e=r.length;e>t;t++){var n=r.charCodeAt(t);if(32!==n&&9!==n)return t}return-1}function d(r,t,e){void 0===t&&(t=0),void 0===e&&(e=r.length);for(var n=t;e>n;n++){var u=r.charCodeAt(n);if(32!==u&&9!==u)return r.substring(t,n)}return r.substring(t,e)}function v(r,t){void 0===t&&(t=r.length-1);for(var e=t;e>=0;e--){var n=r.charCodeAt(e);if(32!==n&&9!==n)return e}return-1}function E(r,t){return t>r?-1:r>t?1:0}function p(r){return r>=97&&122>=r}function m(r){return r>=65&&90>=r}function A(r){return p(r)||m(r)}function B(r,t){var e=r?r.length:0,n=t?t.length:0;return e!==n?!1:x(r,t)}function x(r,t,e){if(void 0===e&&(e=r.length),"string"!=typeof r||"string"!=typeof t)return!1;for(var n=0;e>n;n++){var u=r.charCodeAt(n),i=t.charCodeAt(n);if(u!==i)if(A(u)&&A(i)){var o=Math.abs(u-i);if(0!==o&&32!==o)return!1}else if(String.fromCharCode(u).toLowerCase()!==String.fromCharCode(i).toLowerCase())return!1}return!0}function b(r,t){var e=t.length;return t.length>r.length?!1:x(r,t,e)}function L(r,t){var e,n=Math.min(r.length,t.length);for(e=0;n>e;e++)if(r.charCodeAt(e)!==t.charCodeAt(e))return e;return n}function W(r,t){var e,n=Math.min(r.length,t.length),u=r.length-1,i=t.length-1;for(e=0;n>e;e++)if(r.charCodeAt(u-e)!==t.charCodeAt(i-e))return e;return n}function I(r){return r>=55296&&56319>=r}function w(r){return r>=56320&&57343>=r}function R(r){return _.test(r)}function S(r){return j.test(r)}function $(r){return P.test(r)}function y(r){for(var t=0,e=r.length;e>t;t++)if(O(r.charCodeAt(t)))return!0;return!1}function O(r){return r=+r,r>=11904&&55215>=r||r>=63744&&64255>=r||r>=65281&&65374>=r}function M(r){return!!(r&&r.length>0&&65279===r.charCodeAt(0))}function T(r){return btoa(encodeURIComponent(r))}function N(r,t){for(var e="",n=0;t>n;n++)e+=r;return e}Object.defineProperty(t,"__esModule",{value:!0}),t.empty="",t.isFalsyOrWhitespace=e,t.pad=n;var U=/{(\d+)}/g;t.format=u,t.escape=i,t.escapeRegExpCharacters=o,t.trim=a,t.ltrim=f,t.rtrim=c,t.convertSimple2RegExpPattern=s,t.startsWith=g,t.endsWith=h,t.createRegExp=l,t.regExpLeadsToEndlessLoop=D,t.regExpFlags=F,t.firstNonWhitespaceIndex=C,t.getLeadingWhitespace=d,t.lastNonWhitespaceIndex=v,t.compare=E,t.isLowerAsciiLetter=p,t.isUpperAsciiLetter=m,t.equalsIgnoreCase=B,t.startsWithIgnoreCase=b,t.commonPrefixLength=L,t.commonSuffixLength=W,t.isHighSurrogate=I,t.isLowSurrogate=w;var _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;t.containsRTL=R;var j=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEF8]|\uD83E[\uDD00-\uDDE6])/;t.containsEmoji=S;var P=/^[\t\n\r\x20-\x7E]*$/;t.isBasicASCII=$,t.containsFullWidthCharacter=y,t.isFullWidthCharacter=O,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),t.startsWithUTF8BOM=M,t.safeBtoa=T,t.repeat=N});
/**! node_modules/monaco-editor/esm/vs/base/common/diff/diffChange.js*/
define("a895ddf",function(i,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var e=function(){function i(i,t,e,n){this.originalStart=i,this.originalLength=t,this.modifiedStart=e,this.modifiedLength=n}return i.prototype.getOriginalEnd=function(){return this.originalStart+this.originalLength},i.prototype.getModifiedEnd=function(){return this.modifiedStart+this.modifiedLength},i}();t.DiffChange=e});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/jsonLanguageTypes.js*/
define("683e3e1",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var t=e("737c70e");n.Range=t.Range,n.TextEdit=t.TextEdit,n.Color=t.Color,n.ColorInformation=t.ColorInformation,n.ColorPresentation=t.ColorPresentation,n.FoldingRange=t.FoldingRange,n.FoldingRangeKind=t.FoldingRangeKind,function(e){e.Empty="",e.Statement="statement",e.Declaration="declaration"}(n.SelectionRangeKind||(n.SelectionRangeKind={})),function(e){e[e.Undefined=0]="Undefined",e[e.EnumValueMismatch=1]="EnumValueMismatch",e[e.UnexpectedEndOfComment=257]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=258]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=259]="UnexpectedEndOfNumber",e[e.InvalidUnicode=260]="InvalidUnicode",e[e.InvalidEscapeCharacter=261]="InvalidEscapeCharacter",e[e.InvalidCharacter=262]="InvalidCharacter",e[e.PropertyExpected=513]="PropertyExpected",e[e.CommaExpected=514]="CommaExpected",e[e.ColonExpected=515]="ColonExpected",e[e.ValueExpected=516]="ValueExpected",e[e.CommaOrCloseBacketExpected=517]="CommaOrCloseBacketExpected",e[e.CommaOrCloseBraceExpected=518]="CommaOrCloseBraceExpected",e[e.TrailingComma=519]="TrailingComma",e[e.DuplicateKey=520]="DuplicateKey",e[e.CommentNotPermitted=521]="CommentNotPermitted",e[e.SchemaResolveError=768]="SchemaResolveError"}(n.ErrorCode||(n.ErrorCode={})),function(e){e.LATEST={textDocument:{completion:{completionItem:{documentationFormat:[t.MarkupKind.Markdown,t.MarkupKind.PlainText]}}}}}(n.ClientCapabilities||(n.ClientCapabilities={}))});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/jsonc-parser/main.js*/
define("26128d7",function(e,t){"use strict";function r(e){switch(e){case 1:return"InvalidSymbol";case 2:return"InvalidNumberFormat";case 3:return"PropertyNameExpected";case 4:return"ValueExpected";case 5:return"ColonExpected";case 6:return"CommaExpected";case 7:return"CloseBraceExpected";case 8:return"CloseBracketExpected";case 9:return"EndOfFileExpected";case 10:return"InvalidCommentToken";case 11:return"UnexpectedEndOfComment";case 12:return"UnexpectedEndOfString";case 13:return"UnexpectedEndOfNumber";case 14:return"InvalidUnicode";case 15:return"InvalidEscapeCharacter";case 16:return"InvalidCharacter"}return"<unknown ParseErrorCode>"}function n(e,t,r){return d.format(e,t,r)}function a(e,t,r,n){return i.setProperty(e,t,r,n.formattingOptions,n.getInsertionIndex)}function o(e,t){for(var r=t.length-1;r>=0;r--)e=i.applyEdit(e,t[r]);return e}Object.defineProperty(t,"__esModule",{value:!0});var c=e("11ed2ab"),d=c.__importStar(e("86b561e")),i=c.__importStar(e("98ab305")),s=c.__importStar(e("aedc3c9")),u=c.__importStar(e("38cea32"));t.createScanner=s.createScanner,t.getLocation=u.getLocation,t.parse=u.parse,t.parseTree=u.parseTree,t.findNodeAtLocation=u.findNodeAtLocation,t.findNodeAtOffset=u.findNodeAtOffset,t.getNodePath=u.getNodePath,t.getNodeValue=u.getNodeValue,t.visit=u.visit,t.stripComments=u.stripComments,t.printParseErrorCode=r,t.format=n,t.modify=a,t.applyEdits=o});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/services/jsonSelectionRanges.js*/
define("08f16e5",function(e,t){"use strict";function n(e,t,n){function s(t){var r=e.offsetAt(t),a=n.getNodeFromOffset(r,!0);if(!a)return[];for(var o=[];a;){switch(a.type){case"string":case"object":case"array":var s=a.offset+1,i=a.offset+a.length-1;i>s&&r>=s&&i>=r&&o.push(f(s,i)),o.push(f(a.offset,a.offset+a.length));break;case"number":case"boolean":case"null":case"property":o.push(f(a.offset,a.offset+a.length))}if("property"===a.type||a.parent&&"array"===a.parent.type){var u=c(a.offset+a.length,5);-1!==u&&o.push(f(a.offset,u))}a=a.parent}return o}function f(t,n){return{range:r.Range.create(e.positionAt(t),e.positionAt(n)),kind:o.SelectionRangeKind.Declaration}}function c(e,t){i.setPosition(e);var n=i.scan();return n===t?i.getTokenOffset()+i.getTokenLength():-1}var i=a.createScanner(e.getText(),!0);return t.map(s)}Object.defineProperty(t,"__esModule",{value:!0});var r=e("737c70e"),a=e("26128d7"),o=e("683e3e1");t.getSelectionRanges=n});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/services/jsonFolding.js*/
define("576a913",function(e,n){"use strict";function t(e,n){function t(e){o.push(e),s.push(g.length)}for(var o=[],s=[],g=[],f=-1,d=r.createScanner(e.getText(),!1),l=d.scan();17!==l;){switch(l){case 1:case 3:var c=e.positionAt(d.getTokenOffset()).line,v={startLine:c,endLine:c,kind:1===l?"object":"array"};g.push(v);break;case 2:case 4:var h=2===l?"object":"array";if(g.length>0&&g[g.length-1].kind===h){var v=g.pop(),k=e.positionAt(d.getTokenOffset()).line;v&&k>v.startLine+1&&f!==v.startLine&&(v.endLine=k-1,t(v),f=v.startLine)}break;case 13:var c=e.positionAt(d.getTokenOffset()).line,u=e.positionAt(d.getTokenOffset()+d.getTokenLength()).line;1===d.getTokenError()&&c+1<e.lineCount?d.setPosition(e.offsetAt(i.Position.create(c+1,0))):u>c&&(t({startLine:c,endLine:u,kind:a.FoldingRangeKind.Comment}),f=c);break;case 12:var L=e.getText().substr(d.getTokenOffset(),d.getTokenLength()),p=L.match(/^\/\/\s*#(region\b)|(endregion\b)/);if(p){var k=e.positionAt(d.getTokenOffset()).line;if(p[1]){var v={startLine:k,endLine:k,kind:a.FoldingRangeKind.Region};g.push(v)}else{for(var b=g.length-1;b>=0&&g[b].kind!==a.FoldingRangeKind.Region;)b--;if(b>=0){var v=g[b];g.length=b,k>v.startLine&&f!==v.startLine&&(v.endLine=k,t(v),f=v.startLine)}}}}l=d.scan()}var T=n&&n.rangeLimit;if("number"!=typeof T||o.length<=T)return o;for(var m=[],O=0,A=s;O<A.length;O++){var R=A[O];30>R&&(m[R]=(m[R]||0)+1)}for(var y=0,F=0,b=0;b<m.length;b++){var j=m[b];if(j){if(j+y>T){F=b;break}y+=j}}for(var K=[],b=0;b<o.length;b++){var R=s[b];"number"==typeof R&&(F>R||R===F&&y++<T)&&K.push(o[b])}return K}Object.defineProperty(n,"__esModule",{value:!0});var i=e("737c70e"),r=e("26128d7"),a=e("683e3e1");n.getFoldingRanges=t});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/services/jsonSchemaService.js*/
define("a1f43d9",function(e,t){"use strict";function r(e){try{var t=s.default.parse(e);if("file"===t.scheme)return t.fsPath}catch(r){}return e}Object.defineProperty(t,"__esModule",{value:!0});var n=e("11ed2ab"),i=n.__importStar(e("26128d7")),s=n.__importDefault(e("a199806")),o=n.__importStar(e("a0f93b8")),a=n.__importStar(e("8408640")),c=n.__importStar(e("60eaf5a")),h=c.loadMessageBundle(),u=function(){function e(e){try{this.patternRegExp=new RegExp(o.convertSimple2RegExpPattern(e)+"$")}catch(t){this.patternRegExp=null}this.schemas=[]}return e.prototype.addSchema=function(e){this.schemas.push(e)},e.prototype.matchesPattern=function(e){return this.patternRegExp&&this.patternRegExp.test(e)},e.prototype.getSchemas=function(){return this.schemas},e}(),l=function(){function e(e,t,r){this.service=e,this.url=t,this.dependencies={},r&&(this.unresolvedSchema=this.service.promise.resolve(new f(r)))}return e.prototype.getUnresolvedSchema=function(){return this.unresolvedSchema||(this.unresolvedSchema=this.service.loadSchema(this.url)),this.unresolvedSchema},e.prototype.getResolvedSchema=function(){var e=this;return this.resolvedSchema||(this.resolvedSchema=this.getUnresolvedSchema().then(function(t){return e.service.resolveSchemaContent(t,e.url,e.dependencies)})),this.resolvedSchema},e.prototype.clearSchema=function(){this.resolvedSchema=null,this.unresolvedSchema=null,this.dependencies={}},e}(),f=function(){function e(e,t){void 0===t&&(t=[]),this.schema=e,this.errors=t}return e}();t.UnresolvedSchema=f;var d=function(){function e(e,t){void 0===t&&(t=[]),this.schema=e,this.errors=t}return e.prototype.getSection=function(e){return a.asSchema(this.getSectionRecursive(e,this.schema))},e.prototype.getSectionRecursive=function(e,t){if(!t||"boolean"==typeof t||0===e.length)return t;var r=e.shift();if(t.properties)return this.getSectionRecursive(e,t.properties[r]);if(t.patternProperties)for(var n=0,i=Object.keys(t.patternProperties);n<i.length;n++){var s=i[n],o=new RegExp(s);if(o.test(r))return this.getSectionRecursive(e,t.patternProperties[s])}else{if("object"==typeof t.additionalProperties)return this.getSectionRecursive(e,t.additionalProperties);if(r.match("[0-9]+"))if(Array.isArray(t.items)){var a=parseInt(r,10);if(!isNaN(a)&&t.items[a])return this.getSectionRecursive(e,t.items[a])}else if(t.items)return this.getSectionRecursive(e,t.items)}return null},e}();t.ResolvedSchema=d;var m=function(){function e(e,t,r){this.contextService=t,this.requestService=e,this.promiseConstructor=r||Promise,this.callOnDispose=[],this.contributionSchemas={},this.contributionAssociations={},this.schemasById={},this.filePatternAssociations=[],this.filePatternAssociationById={},this.registeredSchemasIds={}}return e.prototype.getRegisteredSchemaIds=function(e){return Object.keys(this.registeredSchemasIds).filter(function(t){var r=s.default.parse(t).scheme;return"schemaservice"!==r&&(!e||e(r))})},Object.defineProperty(e.prototype,"promise",{get:function(){return this.promiseConstructor},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){for(;this.callOnDispose.length>0;)this.callOnDispose.pop()()},e.prototype.onResourceChange=function(e){var t=this,r=!1;e=this.normalizeId(e);for(var n=[e],i=Object.keys(this.schemasById).map(function(e){return t.schemasById[e]});n.length;)for(var s=n.pop(),o=0;o<i.length;o++){var a=i[o];a&&(a.url===s||a.dependencies[s])&&(a.url!==s&&n.push(a.url),a.clearSchema(),i[o]=void 0,r=!0)}return r},e.prototype.normalizeId=function(e){return s.default.parse(e).toString()},e.prototype.setSchemaContributions=function(e){if(e.schemas){var t=e.schemas;for(var r in t){var n=this.normalizeId(r);this.contributionSchemas[n]=this.addSchemaHandle(n,t[r])}}if(e.schemaAssociations){var i=e.schemaAssociations;for(var s in i){var o=i[s];this.contributionAssociations[s]=o;for(var a=this.getOrAddFilePatternAssociation(s),c=0,h=o;c<h.length;c++){var u=h[c],r=this.normalizeId(u);a.addSchema(r)}}}},e.prototype.addSchemaHandle=function(e,t){var r=new l(this,e,t);return this.schemasById[e]=r,r},e.prototype.getOrAddSchemaHandle=function(e,t){return this.schemasById[e]||this.addSchemaHandle(e,t)},e.prototype.getOrAddFilePatternAssociation=function(e){var t=this.filePatternAssociationById[e];return t||(t=new u(e),this.filePatternAssociationById[e]=t,this.filePatternAssociations.push(t)),t},e.prototype.registerExternalSchema=function(e,t,r){void 0===t&&(t=null);var n=this.normalizeId(e);if(this.registeredSchemasIds[n]=!0,t)for(var i=0,s=t;i<s.length;i++){var o=s[i];this.getOrAddFilePatternAssociation(o).addSchema(n)}return r?this.addSchemaHandle(n,r):this.getOrAddSchemaHandle(n)},e.prototype.clearExternalSchemas=function(){this.schemasById={},this.filePatternAssociations=[],this.filePatternAssociationById={},this.registeredSchemasIds={};for(var e in this.contributionSchemas)this.schemasById[e]=this.contributionSchemas[e],this.registeredSchemasIds[e]=!0;for(var t in this.contributionAssociations)for(var r=this.getOrAddFilePatternAssociation(t),n=0,i=this.contributionAssociations[t];n<i.length;n++){var s=i[n],e=this.normalizeId(s);r.addSchema(e)}},e.prototype.getResolvedSchema=function(e){var t=this.normalizeId(e),r=this.schemasById[t];return r?r.getResolvedSchema():this.promise.resolve(null)},e.prototype.loadSchema=function(e){if(!this.requestService){var t=h("json.schema.norequestservice","Unable to load schema from '{0}'. No schema request service available",r(e));return this.promise.resolve(new f({},[t]))}return this.requestService(e).then(function(t){if(!t){var n=h("json.schema.nocontent","Unable to load schema from '{0}': No content.",r(e));return new f({},[n])}var s={},o=[];s=i.parse(t,o);var a=o.length?[h("json.schema.invalidFormat","Unable to parse content from '{0}': Parse error at offset {1}.",r(e),o[0].offset)]:[];return new f(s,a)},function(e){var t=e.toString(),r=e.toString().split("Error: ");return r.length>1&&(t=r[1]),new f({},[t])})},e.prototype.resolveSchemaContent=function(e,t,r){var n=this,i=e.errors.slice(0),s=e.schema,o=this.contextService,a=function(e,t){if(!t)return e;var r=e;return"/"===t[0]&&(t=t.substr(1)),t.split("/").some(function(e){return r=r[e],!r}),r},c=function(e,t,r,n){var s=a(t,n);if(s)for(var o in s)s.hasOwnProperty(o)&&!e.hasOwnProperty(o)&&(e[o]=s[o]);else i.push(h("json.schema.invalidref","$ref '{0}' in '{1}' can not be resolved.",n,r))},u=function(e,t,r,s,a){o&&!/^\w+:\/\/.*/.test(t)&&(t=o.resolveRelativePath(t,s)),t=n.normalizeId(t);var u=n.getOrAddSchemaHandle(t);return u.getUnresolvedSchema().then(function(n){if(a[t]=!0,n.errors.length){var s=r?t+"#"+r:t;i.push(h("json.schema.problemloadingref","Problems loading reference '{0}': {1}",s,n.errors[0]))}return c(e,n.schema,t,r),l(e,n.schema,t,u.dependencies)})},l=function(e,t,r,i){if(!e||"object"!=typeof e)return Promise.resolve(null);for(var s=[e],o=[],a=[],h=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var r=0,n=e;r<n.length;r++){var i=n[r];"object"==typeof i&&s.push(i)}},l=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var r=0,n=e;r<n.length;r++){var i=n[r];if("object"==typeof i)for(var o in i){var a=i[o];"object"==typeof a&&s.push(a)}}},f=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var r=0,n=e;r<n.length;r++){var i=n[r];if(Array.isArray(i))for(var o=0,a=i;o<a.length;o++){var c=a[o];"object"==typeof c&&s.push(c)}}},d=function(e){for(var n=[];e.$ref;){var s=e.$ref,o=s.split("#",2);if(delete e.$ref,o[0].length>0)return void a.push(u(e,o[0],o[1],r,i));-1===n.indexOf(s)&&(c(e,t,r,o[1]),n.push(s))}h(e.items,e.additionalProperties,e.not,e.contains,e.propertyNames,e.if,e.then,e.else),l(e.definitions,e.properties,e.patternProperties,e.dependencies),f(e.anyOf,e.allOf,e.oneOf,e.items)};s.length;){var m=s.pop();o.indexOf(m)>=0||(o.push(m),d(m))}return n.promise.all(a)};return l(s,s,t,r).then(function(){return new d(s,i)})},e.prototype.getSchemaForResource=function(e,t){if(t&&t.root&&"object"===t.root.type){var r=t.root.properties.filter(function(e){return"$schema"===e.keyNode.value&&e.valueNode&&"string"===e.valueNode.type});if(r.length>0){var n=a.getNodeValue(r[0].valueNode);if(n&&o.startsWith(n,".")&&this.contextService&&(n=this.contextService.resolveRelativePath(n,e)),n){var i=this.normalizeId(n);return this.getOrAddSchemaHandle(i).getResolvedSchema()}}}for(var s=Object.create(null),c=[],h=0,u=this.filePatternAssociations;h<u.length;h++){var l=u[h];if(l.matchesPattern(e))for(var f=0,d=l.getSchemas();f<d.length;f++){var m=d[f];s[m]||(c.push(m),s[m]=!0)}}return c.length>0?this.createCombinedSchema(e,c).getResolvedSchema():this.promise.resolve(null)},e.prototype.createCombinedSchema=function(e,t){if(1===t.length)return this.getOrAddSchemaHandle(t[0]);var r="schemaservice://combinedSchema/"+encodeURIComponent(e),n={allOf:t.map(function(e){return{$ref:e}})};return this.addSchemaHandle(r,n)},e}();t.JSONSchemaService=m});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/services/configuration.js*/
define("4cc3293",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=e("11ed2ab"),a=i.__importStar(e("60eaf5a")),n=a.loadMessageBundle();t.schemaContributions={schemaAssociations:{},schemas:{"http://json-schema.org/draft-04/schema#":{title:n("schema.json","Describes a JSON file using a schema. See json-schema.org for more info."),$schema:"http://json-schema.org/draft-04/schema#",definitions:{schemaArray:{type:"array",minItems:1,items:{$ref:"#"}},positiveInteger:{type:"integer",minimum:0},positiveIntegerDefault0:{allOf:[{$ref:"#/definitions/positiveInteger"},{"default":0}]},simpleTypes:{type:"string","enum":["array","boolean","integer","null","number","object","string"]},stringArray:{type:"array",items:{type:"string"},minItems:1,uniqueItems:!0}},type:"object",properties:{id:{type:"string",format:"uri"},$schema:{type:"string",format:"uri"},title:{type:"string"},description:{type:"string"},"default":{},multipleOf:{type:"number",minimum:0,exclusiveMinimum:!0},maximum:{type:"number"},exclusiveMaximum:{type:"boolean","default":!1},minimum:{type:"number"},exclusiveMinimum:{type:"boolean","default":!1},maxLength:{allOf:[{$ref:"#/definitions/positiveInteger"}]},minLength:{allOf:[{$ref:"#/definitions/positiveIntegerDefault0"}]},pattern:{type:"string",format:"regex"},additionalItems:{anyOf:[{type:"boolean"},{$ref:"#"}],"default":{}},items:{anyOf:[{$ref:"#"},{$ref:"#/definitions/schemaArray"}],"default":{}},maxItems:{allOf:[{$ref:"#/definitions/positiveInteger"}]},minItems:{allOf:[{$ref:"#/definitions/positiveIntegerDefault0"}]},uniqueItems:{type:"boolean","default":!1},maxProperties:{allOf:[{$ref:"#/definitions/positiveInteger"}]},minProperties:{allOf:[{$ref:"#/definitions/positiveIntegerDefault0"}]},required:{allOf:[{$ref:"#/definitions/stringArray"}]},additionalProperties:{anyOf:[{type:"boolean"},{$ref:"#"}],"default":{}},definitions:{type:"object",additionalProperties:{$ref:"#"},"default":{}},properties:{type:"object",additionalProperties:{$ref:"#"},"default":{}},patternProperties:{type:"object",additionalProperties:{$ref:"#"},"default":{}},dependencies:{type:"object",additionalProperties:{anyOf:[{$ref:"#"},{$ref:"#/definitions/stringArray"}]}},"enum":{type:"array",minItems:1,uniqueItems:!0},type:{anyOf:[{$ref:"#/definitions/simpleTypes"},{type:"array",items:{$ref:"#/definitions/simpleTypes"},minItems:1,uniqueItems:!0}]},format:{anyOf:[{type:"string","enum":["date-time","uri","email","hostname","ipv4","ipv6","regex"]},{type:"string"}]},allOf:{allOf:[{$ref:"#/definitions/schemaArray"}]},anyOf:{allOf:[{$ref:"#/definitions/schemaArray"}]},oneOf:{allOf:[{$ref:"#/definitions/schemaArray"}]},not:{allOf:[{$ref:"#"}]}},dependencies:{exclusiveMaximum:["maximum"],exclusiveMinimum:["minimum"]},"default":{}},"http://json-schema.org/draft-07/schema#":{title:n("schema.json","Describes a JSON file using a schema. See json-schema.org for more info."),definitions:{schemaArray:{type:"array",minItems:1,items:{$ref:"#"}},nonNegativeInteger:{type:"integer",minimum:0},nonNegativeIntegerDefault0:{allOf:[{$ref:"#/definitions/nonNegativeInteger"},{"default":0}]},simpleTypes:{"enum":["array","boolean","integer","null","number","object","string"]},stringArray:{type:"array",items:{type:"string"},uniqueItems:!0,"default":[]}},type:["object","boolean"],properties:{$id:{type:"string",format:"uri-reference"},$schema:{type:"string",format:"uri"},$ref:{type:"string",format:"uri-reference"},$comment:{type:"string"},title:{type:"string"},description:{type:"string"},"default":!0,readOnly:{type:"boolean","default":!1},examples:{type:"array",items:!0},multipleOf:{type:"number",exclusiveMinimum:0},maximum:{type:"number"},exclusiveMaximum:{type:"number"},minimum:{type:"number"},exclusiveMinimum:{type:"number"},maxLength:{$ref:"#/definitions/nonNegativeInteger"},minLength:{$ref:"#/definitions/nonNegativeIntegerDefault0"},pattern:{type:"string",format:"regex"},additionalItems:{$ref:"#"},items:{anyOf:[{$ref:"#"},{$ref:"#/definitions/schemaArray"}],"default":!0},maxItems:{$ref:"#/definitions/nonNegativeInteger"},minItems:{$ref:"#/definitions/nonNegativeIntegerDefault0"},uniqueItems:{type:"boolean","default":!1},contains:{$ref:"#"},maxProperties:{$ref:"#/definitions/nonNegativeInteger"},minProperties:{$ref:"#/definitions/nonNegativeIntegerDefault0"},required:{$ref:"#/definitions/stringArray"},additionalProperties:{$ref:"#"},definitions:{type:"object",additionalProperties:{$ref:"#"},"default":{}},properties:{type:"object",additionalProperties:{$ref:"#"},"default":{}},patternProperties:{type:"object",additionalProperties:{$ref:"#"},propertyNames:{format:"regex"},"default":{}},dependencies:{type:"object",additionalProperties:{anyOf:[{$ref:"#"},{$ref:"#/definitions/stringArray"}]}},propertyNames:{$ref:"#"},"const":!0,"enum":{type:"array",items:!0,minItems:1,uniqueItems:!0},type:{anyOf:[{$ref:"#/definitions/simpleTypes"},{type:"array",items:{$ref:"#/definitions/simpleTypes"},minItems:1,uniqueItems:!0}]},format:{type:"string"},contentMediaType:{type:"string"},contentEncoding:{type:"string"},"if":{$ref:"#"},then:{$ref:"#"},"else":{$ref:"#"},allOf:{$ref:"#/definitions/schemaArray"},anyOf:{$ref:"#/definitions/schemaArray"},oneOf:{$ref:"#/definitions/schemaArray"},not:{$ref:"#"}},"default":!0}}};var s={id:n("schema.json.id","A unique identifier for the schema."),$schema:n("schema.json.$schema","The schema to verify this document against."),title:n("schema.json.title","A descriptive title of the element."),description:n("schema.json.description","A long description of the element. Used in hover menus and suggestions."),"default":n("schema.json.default","A default value. Used by suggestions."),multipleOf:n("schema.json.multipleOf","A number that should cleanly divide the current value (i.e. have no remainder)."),maximum:n("schema.json.maximum","The maximum numerical value, inclusive by default."),exclusiveMaximum:n("schema.json.exclusiveMaximum","Makes the maximum property exclusive."),minimum:n("schema.json.minimum","The minimum numerical value, inclusive by default."),exclusiveMinimum:n("schema.json.exclusiveMininum","Makes the minimum property exclusive."),maxLength:n("schema.json.maxLength","The maximum length of a string."),minLength:n("schema.json.minLength","The minimum length of a string."),pattern:n("schema.json.pattern","A regular expression to match the string against. It is not implicitly anchored."),additionalItems:n("schema.json.additionalItems","For arrays, only when items is set as an array. If it is a schema, then this schema validates items after the ones specified by the items array. If it is false, then additional items will cause validation to fail."),items:n("schema.json.items","For arrays. Can either be a schema to validate every element against or an array of schemas to validate each item against in order (the first schema will validate the first element, the second schema will validate the second element, and so on."),maxItems:n("schema.json.maxItems","The maximum number of items that can be inside an array. Inclusive."),minItems:n("schema.json.minItems","The minimum number of items that can be inside an array. Inclusive."),uniqueItems:n("schema.json.uniqueItems","If all of the items in the array must be unique. Defaults to false."),maxProperties:n("schema.json.maxProperties","The maximum number of properties an object can have. Inclusive."),minProperties:n("schema.json.minProperties","The minimum number of properties an object can have. Inclusive."),required:n("schema.json.required","An array of strings that lists the names of all properties required on this object."),additionalProperties:n("schema.json.additionalProperties","Either a schema or a boolean. If a schema, then used to validate all properties not matched by 'properties' or 'patternProperties'. If false, then any properties not matched by either will cause this schema to fail."),definitions:n("schema.json.definitions","Not used for validation. Place subschemas here that you wish to reference inline with $ref."),properties:n("schema.json.properties","A map of property names to schemas for each property."),patternProperties:n("schema.json.patternProperties","A map of regular expressions on property names to schemas for matching properties."),dependencies:n("schema.json.dependencies","A map of property names to either an array of property names or a schema. An array of property names means the property named in the key depends on the properties in the array being present in the object in order to be valid. If the value is a schema, then the schema is only applied to the object if the property in the key exists on the object."),"enum":n("schema.json.enum","The set of literal values that are valid."),type:n("schema.json.type","Either a string of one of the basic schema types (number, integer, null, array, object, boolean, string) or an array of strings specifying a subset of those types."),format:n("schema.json.format","Describes the format expected for the value."),allOf:n("schema.json.allOf","An array of schemas, all of which must match."),anyOf:n("schema.json.anyOf","An array of schemas, where at least one must match."),oneOf:n("schema.json.oneOf","An array of schemas, exactly one of which must match."),not:n("schema.json.not","A schema which must not match."),$id:n("schema.json.$id","A unique identifier for the schema."),$ref:n("schema.json.$ref","Reference a definition hosted on any location."),$comment:n("schema.json.$comment","Comments from schema authors to readers or maintainers of the schema."),readOnly:n("schema.json.readOnly","Indicates that the value of the instance is managed exclusively by the owning authority."),examples:n("schema.json.examples","Sample JSON values associated with a particular schema, for the purpose of illustrating usage."),contains:n("schema.json.contains",'An array instance is valid against "contains" if at least one of its elements is valid against the given schema.'),propertyNames:n("schema.json.propertyNames","If the instance is an object, this keyword validates if every property name in the instance validates against the provided schema."),"const":n("schema.json.const","An instance validates successfully against this keyword if its value is equal to the value of the keyword."),contentMediaType:n("schema.json.contentMediaType","Describes the media type of a string property."),contentEncoding:n("schema.json.contentEncoding","Describes the content encoding of a string property."),"if":n("schema.json.if",'The validation outcome of the "if" subschema controls which of the "then" or "else" keywords are evaluated.'),then:n("schema.json.then",'The "if" subschema is used for validation when the "if" subschema succeeds.'),"else":n("schema.json.else",'The "else" subschema is used for validation when the "if" subschema fails.')};for(var r in t.schemaContributions.schemas){var o=t.schemaContributions.schemas[r];for(var m in o.properties){var f=o.properties[m];f===!0&&(f=o.properties[m]={});var l=s[m];l?f.description=l:console.log(m+": localize('schema.json."+m+'\', "")')}}});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/parser/jsonParser.js*/
define("8408640",function(e,t){"use strict";function r(e){return p.isBoolean(e)?e?{}:{not:{}}:e}function n(e,t){return void 0===t&&(t=[]),new P(e,t,[])}function o(e){return f.getNodeValue(e)}function i(e){return f.getNodePath(e)}function a(e,t,r){return void 0===r&&(r=!1),t>=e.offset&&t<e.offset+e.length||r&&t===e.offset+e.length}function s(e,t,n,i){function a(){function a(t){return e.type===t||"integer"===t&&"number"===e.type&&e.isInteger}if(Array.isArray(t.type)?t.type.some(a)||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("typeArrayMismatchWarning","Incorrect type. Expected one of {0}.",t.type.join(", "))}):t.type&&(a(t.type)||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("typeMismatchWarning",'Incorrect type. Expected "{0}".',t.type)})),Array.isArray(t.allOf))for(var l=0,u=t.allOf;l<u.length;l++){var c=u[l];s(e,r(c),n,i)}var f=r(t.not);if(f){var m=new w,h=i.newSub();s(e,f,m,h),m.hasProblems()||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("notSchemaWarning","Matches a schema that is not allowed.")});for(var y=0,b=h.schemas;y<b.length;y++){var x=b[y];x.inverted=!x.inverted,i.add(x)}}var M=function(t,o){for(var a=[],l=null,u=0,c=t;u<c.length;u++){var f=c[u],p=r(f),g=new w,m=i.newSub();if(s(e,p,g,m),g.hasProblems()||a.push(p),l)if(o||g.hasProblems()||l.validationResult.hasProblems()){var h=g.compare(l.validationResult);h>0?l={schema:p,validationResult:g,matchingSchemas:m}:0===h&&(l.matchingSchemas.merge(m),l.validationResult.mergeEnumValues(g))}else l.matchingSchemas.merge(m),l.validationResult.propertiesMatches+=g.propertiesMatches,l.validationResult.propertiesValueMatches+=g.propertiesValueMatches;else l={schema:p,validationResult:g,matchingSchemas:m}}return a.length>1&&o&&n.problems.push({location:{offset:e.offset,length:1},severity:d.DiagnosticSeverity.Warning,message:v("oneOfWarning","Matches multiple schemas when only one must validate.")}),null!==l&&(n.merge(l.validationResult),n.propertiesMatches+=l.validationResult.propertiesMatches,n.propertiesValueMatches+=l.validationResult.propertiesValueMatches,i.merge(l.matchingSchemas)),a.length};Array.isArray(t.anyOf)&&M(t.anyOf,!1),Array.isArray(t.oneOf)&&M(t.oneOf,!0);var E=function(t){var o=new w,a=i.newSub();s(e,r(t),o,a),n.merge(o),n.propertiesMatches+=o.propertiesMatches,n.propertiesValueMatches+=o.propertiesValueMatches,i.merge(a)},k=function(t,n,o){var a=r(t),l=new w,u=i.newSub();s(e,a,l,u),i.merge(u),l.hasProblems()?o&&E(o):n&&E(n)},S=r(t.if);if(S&&k(S,r(t.then),r(t.else)),Array.isArray(t.enum)){for(var O=o(e),V=!1,N=0,W=t.enum;N<W.length;N++){var T=W[N];if(p.equals(O,T)){V=!0;break}}n.enumValues=t.enum,n.enumValueMatch=V,V||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,code:g.ErrorCode.EnumValueMismatch,message:t.errorMessage||v("enumWarning","Value is not accepted. Valid values: {0}.",t.enum.map(function(e){return JSON.stringify(e)}).join(", "))})}if(p.isDefined(t.const)){var O=o(e);p.equals(O,t.const)?n.enumValueMatch=!0:(n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,code:g.ErrorCode.EnumValueMismatch,message:t.errorMessage||v("constWarning","Value must be {0}.",JSON.stringify(t.const))}),n.enumValueMatch=!1),n.enumValues=[t.const]}t.deprecationMessage&&e.parent&&n.problems.push({location:{offset:e.parent.offset,length:e.parent.length},severity:d.DiagnosticSeverity.Warning,message:t.deprecationMessage})}function l(e,t,r){function n(e,t){return p.isNumber(t)?t:p.isBoolean(t)&&t?e:void 0}function o(e,t){return p.isBoolean(t)&&t?void 0:e}var i=e.value;p.isNumber(t.multipleOf)&&i%t.multipleOf!==0&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("multipleOfWarning","Value is not divisible by {0}.",t.multipleOf)});var a=n(t.minimum,t.exclusiveMinimum);p.isNumber(a)&&a>=i&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("exclusiveMinimumWarning","Value is below the exclusive minimum of {0}.",a)});var s=n(t.maximum,t.exclusiveMaximum);p.isNumber(s)&&i>=s&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("exclusiveMaximumWarning","Value is above the exclusive maximum of {0}.",s)});var l=o(t.minimum,t.exclusiveMinimum);p.isNumber(l)&&l>i&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("minimumWarning","Value is below the minimum of {0}.",l)});var u=o(t.maximum,t.exclusiveMaximum);p.isNumber(u)&&i>u&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("maximumWarning","Value is above the maximum of {0}.",u)})}function u(e,t,r){if(p.isNumber(t.minLength)&&e.value.length<t.minLength&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("minLengthWarning","String is shorter than the minimum length of {0}.",t.minLength)}),p.isNumber(t.maxLength)&&e.value.length>t.maxLength&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("maxLengthWarning","String is longer than the maximum length of {0}.",t.maxLength)}),p.isString(t.pattern)){var n=new RegExp(t.pattern);n.test(e.value)||r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("patternWarning",'String does not match the pattern of "{0}".',t.pattern)})}if(t.format)switch(t.format){case"uri":case"uri-reference":var o=void 0;if(e.value)try{var i=h.default.parse(e.value);i.scheme||"uri"!==t.format||(o=v("uriSchemeMissing","URI with a scheme is expected."))}catch(a){o=a.message}else o=v("uriEmpty","URI expected.");o&&r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("uriFormatWarning","String is not a URI: {0}",o)});break;case"email":e.value.match(b)||r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("emailFormatWarning","String is not an e-mail address.")});break;case"color-hex":e.value.match(y)||r.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.patternErrorMessage||t.errorMessage||v("colorHexFormatWarning","Invalid color format. Use #RGB, #RGBA, #RRGGBB or #RRGGBBAA.")})}}function c(e,t,n,i){if(Array.isArray(t.items)){for(var a=t.items,l=0;l<a.length;l++){var u=a[l],c=r(u),f=new w,g=e.items[l];g?(s(g,c,f,i),n.mergePropertyMatch(f)):e.items.length>=a.length&&n.propertiesValueMatches++}if(e.items.length>a.length)if("object"==typeof t.additionalItems)for(var m=a.length;m<e.items.length;m++){var f=new w;s(e.items[m],t.additionalItems,f,i),n.mergePropertyMatch(f)}else t.additionalItems===!1&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("additionalItemsWarning","Array has too many items according to schema. Expected {0} or fewer.",a.length)})}else{var h=r(t.items);if(h)for(var y=0,b=e.items;y<b.length;y++){var g=b[y],f=new w;s(g,h,f,i),n.mergePropertyMatch(f)}}var x=r(t.contains);if(x){var M=e.items.some(function(e){var t=new w;return s(e,x,t,T.instance),!t.hasProblems()});M||n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("requiredItemMissingWarning","Array does not contain required item.")})}if(p.isNumber(t.minItems)&&e.items.length<t.minItems&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("minItemsWarning","Array has too few items. Expected {0} or more.",t.minItems)}),p.isNumber(t.maxItems)&&e.items.length>t.maxItems&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("maxItemsWarning","Array has too many items. Expected {0} or fewer.",t.maxItems)}),t.uniqueItems===!0){var E=o(e),k=E.some(function(e,t){return t!==E.lastIndexOf(e)});k&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("uniqueItemsWarning","Array has duplicate items.")})}}function f(e,t,n,o){for(var i=Object.create(null),a=[],l=0,u=e.properties;l<u.length;l++){var c=u[l],f=c.keyNode.value;i[f]=c.valueNode,a.push(f)}if(Array.isArray(t.required))for(var g=0,m=t.required;g<m.length;g++){var h=m[g];if(!i[h]){var y=e.parent&&"property"===e.parent.type&&e.parent.keyNode,b=y?{offset:y.offset,length:y.length}:{offset:e.offset,length:1};n.problems.push({location:b,severity:d.DiagnosticSeverity.Warning,message:v("MissingRequiredPropWarning",'Missing property "{0}".',h)})}}var x=function(e){for(var t=a.indexOf(e);t>=0;)a.splice(t,1),t=a.indexOf(e)};if(t.properties)for(var M=0,E=Object.keys(t.properties);M<E.length;M++){var h=E[M];x(h);var k=t.properties[h],S=i[h];if(S)if(p.isBoolean(k))if(k)n.propertiesMatches++,n.propertiesValueMatches++;else{var c=S.parent;n.problems.push({location:{offset:c.keyNode.offset,length:c.keyNode.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("DisallowedExtraPropWarning","Property {0} is not allowed.",h)})}else{var O=new w;s(S,k,O,o),n.mergePropertyMatch(O)}}if(t.patternProperties)for(var V=0,N=Object.keys(t.patternProperties);V<N.length;V++)for(var W=N[V],P=new RegExp(W),A=0,C=a.slice(0);A<C.length;A++){var h=C[A];if(P.test(h)){x(h);var S=i[h];if(S){var k=t.patternProperties[W];if(p.isBoolean(k))if(k)n.propertiesMatches++,n.propertiesValueMatches++;else{var c=S.parent;n.problems.push({location:{offset:c.keyNode.offset,length:c.keyNode.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("DisallowedExtraPropWarning","Property {0} is not allowed.",h)})}else{var O=new w;s(S,k,O,o),n.mergePropertyMatch(O)}}}}if("object"==typeof t.additionalProperties)for(var D=0,I=a;D<I.length;D++){var h=I[D],S=i[h];if(S){var O=new w;s(S,t.additionalProperties,O,o),n.mergePropertyMatch(O)}}else if(t.additionalProperties===!1&&a.length>0)for(var j=0,R=a;j<R.length;j++){var h=R[j],S=i[h];if(S){var c=S.parent;n.problems.push({location:{offset:c.keyNode.offset,length:c.keyNode.length},severity:d.DiagnosticSeverity.Warning,message:t.errorMessage||v("DisallowedExtraPropWarning","Property {0} is not allowed.",h)})}}if(p.isNumber(t.maxProperties)&&e.properties.length>t.maxProperties&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("MaxPropWarning","Object has more properties than limit of {0}.",t.maxProperties)}),p.isNumber(t.minProperties)&&e.properties.length<t.minProperties&&n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("MinPropWarning","Object has fewer properties than the required number of {0}",t.minProperties)}),t.dependencies)for(var U=0,_=Object.keys(t.dependencies);U<_.length;U++){var f=_[U],B=i[f];if(B){var q=t.dependencies[f];if(Array.isArray(q))for(var L=0,F=q;L<F.length;L++){var J=F[L];i[J]?n.propertiesValueMatches++:n.problems.push({location:{offset:e.offset,length:e.length},severity:d.DiagnosticSeverity.Warning,message:v("RequiredDependentPropWarning","Object is missing property {0} required by property {1}.",J,f)})}else{var k=r(q);if(k){var O=new w;s(e,k,O,o),n.mergePropertyMatch(O)}}}}var G=r(t.propertyNames);if(G)for(var K=0,z=e.properties;K<z.length;K++){var Z=z[K],f=Z.keyNode;f&&s(f,G,n,T.instance)}}if(e&&i.include(e)){switch(e.type){case"object":f(e,t,n,i);break;case"array":c(e,t,n,i);break;case"string":u(e,t,n,i);break;case"number":l(e,t,n,i);break;case"property":return s(e.valueNode,t,n,i)}a(),i.add({node:e,schema:t})}}function l(e,t){function r(){for(;;){var t=T.scan();switch(i(),t){case 12:case 13:Array.isArray(w)&&w.push(d.Range.create(e.positionAt(T.getTokenOffset()),e.positionAt(T.getTokenOffset()+T.getTokenLength())));break;case 15:case 14:break;default:return t}}}function n(t,r,n,o,i){if(void 0===i&&(i=d.DiagnosticSeverity.Error),0===b.length||n!==x){var a=d.Range.create(e.positionAt(n),e.positionAt(o));b.push(d.Diagnostic.create(a,t,i,r,e.languageId)),x=n}}function o(e,t,o,i,s){void 0===o&&(o=null),void 0===i&&(i=[]),void 0===s&&(s=[]);var l=T.getTokenOffset(),u=T.getTokenOffset()+T.getTokenLength();if(l===u&&l>0){for(l--;l>0&&/\s/.test(W.charAt(l));)l--;u=l+1}if(n(e,t,l,u),o&&a(o,!1),i.length+s.length>0)for(var c=T.getToken();17!==c;){if(-1!==i.indexOf(c)){r();break}if(-1!==s.indexOf(c))break;c=r()}return o}function i(){switch(T.getTokenError()){case 4:return o(v("InvalidUnicode","Invalid unicode sequence in string."),g.ErrorCode.InvalidUnicode),!0;case 5:return o(v("InvalidEscapeCharacter","Invalid escape character in string."),g.ErrorCode.InvalidEscapeCharacter),!0;case 3:return o(v("UnexpectedEndOfNumber","Unexpected end of number."),g.ErrorCode.UnexpectedEndOfNumber),!0;case 1:return o(v("UnexpectedEndOfComment","Unexpected end of comment."),g.ErrorCode.UnexpectedEndOfComment),!0;case 2:return o(v("UnexpectedEndOfString","Unexpected end of string."),g.ErrorCode.UnexpectedEndOfString),!0;case 6:return o(v("InvalidCharacter","Invalid characters in string. Control characters must be escaped."),g.ErrorCode.InvalidCharacter),!0}return!1}function a(e,t){return e.length=T.getTokenOffset()+T.getTokenLength()-e.offset,t&&r(),e}function s(e){if(3!==T.getToken())return null;var t=new k(e,T.getTokenOffset());r();for(var i=0,s=!1;4!==T.getToken()&&17!==T.getToken();){if(5===T.getToken()){s||o(v("ValueExpected","Value expected"),g.ErrorCode.ValueExpected);var l=T.getTokenOffset();if(r(),4===T.getToken()){s&&n(v("TrailingComma","Trailing comma"),g.ErrorCode.TrailingComma,l,l+1);continue}}else s&&o(v("ExpectedComma","Expected comma"),g.ErrorCode.CommaExpected);var u=y(t,i++);u?t.items.push(u):o(v("PropertyExpected","Value expected"),g.ErrorCode.ValueExpected,null,[],[4,5]),s=!0}return 4!==T.getToken()?o(v("ExpectedCloseBracket","Expected comma or closing bracket"),g.ErrorCode.CommaOrCloseBacketExpected,t):a(t,!0)}function l(t,i){var a=new V(t,T.getTokenOffset()),s=c(a);if(!s){if(16!==T.getToken())return null;o(v("DoubleQuotesExpected","Property keys must be doublequoted"),g.ErrorCode.Undefined);var l=new O(a,T.getTokenOffset(),T.getTokenLength());l.value=T.getTokenValue(),s=l,r()}a.keyNode=s;var u=i[s.value];if(u?(n(v("DuplicateKeyWarning","Duplicate object key"),g.ErrorCode.DuplicateKey,a.keyNode.offset,a.keyNode.offset+a.keyNode.length,d.DiagnosticSeverity.Warning),"object"==typeof u&&n(v("DuplicateKeyWarning","Duplicate object key"),g.ErrorCode.DuplicateKey,u.keyNode.offset,u.keyNode.offset+u.keyNode.length,d.DiagnosticSeverity.Warning),i[s.value]=!0):i[s.value]=a,6===T.getToken())a.colonOffset=T.getTokenOffset(),r();else if(o(v("ColonExpected","Colon expected"),g.ErrorCode.ColonExpected),10===T.getToken()&&e.positionAt(s.offset+s.length).line<e.positionAt(T.getTokenOffset()).line)return a.length=s.length,a;var f=y(a,s.value);return f?(a.valueNode=f,a.length=f.offset+f.length-a.offset,a):o(v("ValueExpected","Value expected"),g.ErrorCode.ValueExpected,a,[],[2,5])}function u(e){if(1!==T.getToken())return null;var t=new N(e,T.getTokenOffset()),i=Object.create(null);r();for(var s=!1;2!==T.getToken()&&17!==T.getToken();){if(5===T.getToken()){s||o(v("PropertyExpected","Property expected"),g.ErrorCode.PropertyExpected);var u=T.getTokenOffset();if(r(),2===T.getToken()){s&&n(v("TrailingComma","Trailing comma"),g.ErrorCode.TrailingComma,u,u+1);continue}}else s&&o(v("ExpectedComma","Expected comma"),g.ErrorCode.CommaExpected);var c=l(t,i);c?t.properties.push(c):o(v("PropertyExpected","Property expected"),g.ErrorCode.PropertyExpected,null,[],[2,5]),s=!0}return 2!==T.getToken()?o(v("ExpectedCloseBrace","Expected comma or closing brace"),g.ErrorCode.CommaOrCloseBraceExpected,t):a(t,!0)}function c(e){if(10!==T.getToken())return null;var t=new O(e,T.getTokenOffset());return t.value=T.getTokenValue(),a(t,!0)}function m(e){if(11!==T.getToken())return null;var t=new S(e,T.getTokenOffset());if(0===T.getTokenError()){var r=T.getTokenValue();try{var n=JSON.parse(r);if(!p.isNumber(n))return o(v("InvalidNumberFormat","Invalid number format."),g.ErrorCode.Undefined,t);t.value=n}catch(i){return o(v("InvalidNumberFormat","Invalid number format."),g.ErrorCode.Undefined,t)}t.isInteger=-1===r.indexOf(".")}return a(t,!0)}function h(e){switch(T.getToken()){case 7:return a(new M(e,T.getTokenOffset()),!0);case 8:return a(new E(e,!0,T.getTokenOffset()),!0);case 9:return a(new E(e,!1,T.getTokenOffset()),!0);default:return null}}function y(e){return s(e)||u(e)||c(e)||m(e)||h(e)}var b=[],x=-1,W=e.getText(),T=f.createScanner(W,!1),w=t&&t.collectComments?[]:void 0,A=null,C=r();return 17!==C&&(A=y(null,null),A?17!==T.getToken()&&o(v("End of file expected","End of file expected."),g.ErrorCode.Undefined):o(v("Invalid symbol","Expected a JSON object, array or literal."),g.ErrorCode.Undefined)),new P(A,b,w)}Object.defineProperty(t,"__esModule",{value:!0});var u=e("11ed2ab"),c=this&&this.__extends||function(){var e=function(t,r){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(t,r)};return function(t,r){function n(){this.constructor=t}e(t,r),t.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}(),f=u.__importStar(e("26128d7")),p=e("de6a48e"),g=e("683e3e1"),m=u.__importStar(e("60eaf5a")),h=u.__importDefault(e("a199806")),d=e("737c70e"),v=m.loadMessageBundle(),y=/^#([0-9A-Fa-f]{3,4}|([0-9A-Fa-f]{2}){3,4})$/,b=/^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,x=function(){function e(e,t,r){this.offset=t,this.length=r,this.parent=e}return Object.defineProperty(e.prototype,"children",{get:function(){return[]},enumerable:!0,configurable:!0}),e.prototype.toString=function(){return"type: "+this.type+" ("+this.offset+"/"+this.length+")"+(this.parent?" parent: {"+this.parent.toString()+"}":"")},e}();t.ASTNodeImpl=x;var M=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="null",n.value=null,n}return c(t,e),t}(x);t.NullASTNodeImpl=M;var E=function(e){function t(t,r,n){var o=e.call(this,t,n)||this;return o.type="boolean",o.value=r,o}return c(t,e),t}(x);t.BooleanASTNodeImpl=E;var k=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="array",n.items=[],n}return c(t,e),Object.defineProperty(t.prototype,"children",{get:function(){return this.items},enumerable:!0,configurable:!0}),t}(x);t.ArrayASTNodeImpl=k;var S=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="number",n.isInteger=!0,n.value=Number.NaN,n}return c(t,e),t}(x);t.NumberASTNodeImpl=S;var O=function(e){function t(t,r,n){var o=e.call(this,t,r,n)||this;return o.type="string",o.value="",o}return c(t,e),t}(x);t.StringASTNodeImpl=O;var V=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="property",n.colonOffset=-1,n}return c(t,e),Object.defineProperty(t.prototype,"children",{get:function(){return this.valueNode?[this.keyNode,this.valueNode]:[this.keyNode]},enumerable:!0,configurable:!0}),t}(x);t.PropertyASTNodeImpl=V;var N=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.type="object",n.properties=[],n}return c(t,e),Object.defineProperty(t.prototype,"children",{get:function(){return this.properties},enumerable:!0,configurable:!0}),t}(x);t.ObjectASTNodeImpl=N,t.asSchema=r,function(e){e[e.Key=0]="Key",e[e.Enum=1]="Enum"}(t.EnumMatch||(t.EnumMatch={}));var W=function(){function e(e,t){void 0===e&&(e=-1),void 0===t&&(t=null),this.focusOffset=e,this.exclude=t,this.schemas=[]}return e.prototype.add=function(e){this.schemas.push(e)},e.prototype.merge=function(e){var t;(t=this.schemas).push.apply(t,e.schemas)},e.prototype.include=function(e){return(-1===this.focusOffset||a(e,this.focusOffset))&&e!==this.exclude},e.prototype.newSub=function(){return new e(-1,this.exclude)},e}(),T=function(){function e(){}return Object.defineProperty(e.prototype,"schemas",{get:function(){return[]},enumerable:!0,configurable:!0}),e.prototype.add=function(){},e.prototype.merge=function(){},e.prototype.include=function(){return!0},e.prototype.newSub=function(){return this},e.instance=new e,e}(),w=function(){function e(){this.problems=[],this.propertiesMatches=0,this.propertiesValueMatches=0,this.primaryValueMatches=0,this.enumValueMatch=!1,this.enumValues=null}return e.prototype.hasProblems=function(){return!!this.problems.length},e.prototype.mergeAll=function(e){for(var t=0,r=e;t<r.length;t++){var n=r[t];this.merge(n)}},e.prototype.merge=function(e){this.problems=this.problems.concat(e.problems)},e.prototype.mergeEnumValues=function(e){if(!this.enumValueMatch&&!e.enumValueMatch&&this.enumValues&&e.enumValues){this.enumValues=this.enumValues.concat(e.enumValues);for(var t=0,r=this.problems;t<r.length;t++){var n=r[t];n.code===g.ErrorCode.EnumValueMismatch&&(n.message=v("enumWarning","Value is not accepted. Valid values: {0}.",this.enumValues.map(function(e){return JSON.stringify(e)}).join(", ")))}}},e.prototype.mergePropertyMatch=function(e){this.merge(e),this.propertiesMatches++,(e.enumValueMatch||!e.hasProblems()&&e.propertiesMatches)&&this.propertiesValueMatches++,e.enumValueMatch&&e.enumValues&&1===e.enumValues.length&&this.primaryValueMatches++},e.prototype.compare=function(e){var t=this.hasProblems();return t!==e.hasProblems()?t?-1:1:this.enumValueMatch!==e.enumValueMatch?e.enumValueMatch?-1:1:this.primaryValueMatches!==e.primaryValueMatches?this.primaryValueMatches-e.primaryValueMatches:this.propertiesValueMatches!==e.propertiesValueMatches?this.propertiesValueMatches-e.propertiesValueMatches:this.propertiesMatches-e.propertiesMatches},e}();t.ValidationResult=w,t.newJSONDocument=n,t.getNodeValue=o,t.getNodePath=i,t.contains=a;var P=function(){function e(e,t,r){void 0===t&&(t=[]),void 0===r&&(r=[]),this.root=e,this.syntaxErrors=t,this.comments=r}return e.prototype.getNodeFromOffset=function(e,t){return void 0===t&&(t=!1),this.root?f.findNodeAtOffset(this.root,e,t):void 0},e.prototype.visit=function(e){if(this.root){var t=function(r){var n=e(r),o=r.children;if(Array.isArray(o))for(var i=0;i<o.length&&n;i++)n=t(o[i]);return n};t(this.root)}},e.prototype.validate=function(e,t){if(this.root&&t){var r=new w;return s(this.root,t,r,T.instance),r.problems.map(function(t){var r=d.Range.create(e.positionAt(t.location.offset),e.positionAt(t.location.offset+t.location.length));return d.Diagnostic.create(r,t.message,t.severity,t.code)})}return null},e.prototype.getMatchingSchemas=function(e,t,r){void 0===t&&(t=-1),void 0===r&&(r=null);var n=new W(t,r);return this.root&&e&&s(this.root,e,new w,n),n.schemas},e}();t.JSONDocument=P,t.parse=l});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/services/jsonDocumentSymbols.js*/
define("8a165f8",function(e,r){"use strict";function t(e,r){return u.Range.create(e.positionAt(r.offset),e.positionAt(r.offset+r.length))}Object.defineProperty(r,"__esModule",{value:!0});var n=e("11ed2ab"),o=n.__importStar(e("8408640")),a=n.__importStar(e("a0f93b8")),i=e("e7af929"),u=e("737c70e"),c=function(){function e(e){this.schemaService=e}return e.prototype.findDocumentSymbols=function(e,r){var n=this,i=r.root;if(!i)return null;var c=e.uri;if(("vscode://defaultsettings/keybindings.json"===c||a.endsWith(c.toLowerCase(),"/user/keybindings.json"))&&"array"===i.type){var s=[];return i.items.forEach(function(r){if("object"===r.type)for(var n=0,a=r.properties;n<a.length;n++){var i=a[n];if("key"===i.keyNode.value&&i.valueNode){if(i.valueNode){var c=u.Location.create(e.uri,t(e,r));s.push({name:o.getNodeValue(i.valueNode),kind:u.SymbolKind.Function,location:c})}return}}}),s}var l=function(r,o,a){return"array"===o.type?o.items.forEach(function(e){return l(r,e,a)}):"object"===o.type&&o.properties.forEach(function(o){var i=u.Location.create(e.uri,t(e,o)),c=o.valueNode;if(c){var s=a?a+"."+o.keyNode.value:o.keyNode.value;r.push({name:n.getKeyLabel(o),kind:n.getSymbolKind(c.type),location:i,containerName:a}),l(r,c,s)}}),r},d=l([],i,void 0);return d},e.prototype.findDocumentSymbols2=function(e,r){var n=this,i=r.root;if(!i)return null;var c=e.uri;if(("vscode://defaultsettings/keybindings.json"===c||a.endsWith(c.toLowerCase(),"/user/keybindings.json"))&&"array"===i.type){var s=[];return i.items.forEach(function(r){if("object"===r.type)for(var n=0,a=r.properties;n<a.length;n++){var i=a[n];if("key"===i.keyNode.value){if(i.valueNode){var c=t(e,r),l=t(e,i.keyNode);s.push({name:o.getNodeValue(i.valueNode),kind:u.SymbolKind.Function,range:c,selectionRange:l})}return}}}),s}var l=function(r,o){return"array"===o.type?o.items.forEach(function(o,a){if(o){var i=t(e,o),u=i,c=String(a),s=l([],o);r.push({name:c,kind:n.getSymbolKind(o.type),range:i,selectionRange:u,children:s})}}):"object"===o.type&&o.properties.forEach(function(o){var a=o.valueNode;if(a){var i=t(e,o),u=t(e,o.keyNode),c=l([],a);r.push({name:n.getKeyLabel(o),kind:n.getSymbolKind(a.type),range:i,selectionRange:u,children:c})}}),r},d=l([],i);return d},e.prototype.getSymbolKind=function(e){switch(e){case"object":return u.SymbolKind.Module;case"string":return u.SymbolKind.String;case"number":return u.SymbolKind.Number;case"array":return u.SymbolKind.Array;case"boolean":return u.SymbolKind.Boolean;default:return u.SymbolKind.Variable}},e.prototype.getKeyLabel=function(e){var r=e.keyNode.value;return r&&(r=r.replace(/[\n]/g,"↵")),r&&r.trim()?r:'"'+r+'"'},e.prototype.findDocumentColors=function(e,r){return this.schemaService.getSchemaForResource(e.uri,r).then(function(n){var a=[];if(n)for(var u=r.getMatchingSchemas(n.schema),c={},s=0,l=u;s<l.length;s++){var d=l[s];if(!d.inverted&&d.schema&&("color"===d.schema.format||"color-hex"===d.schema.format)&&d.node&&"string"===d.node.type){var f=String(d.node.offset);if(!c[f]){var y=i.colorFromHex(o.getNodeValue(d.node));if(y){var p=t(e,d.node);a.push({color:y,range:p})}c[f]=!0}}}return a})},e.prototype.getColorPresentations=function(e,r,t,n){function o(e){var r=e.toString(16);return 2!==r.length?"0"+r:r}var a,i=[],c=Math.round(255*t.red),s=Math.round(255*t.green),l=Math.round(255*t.blue);return a=1===t.alpha?"#"+o(c)+o(s)+o(l):"#"+o(c)+o(s)+o(l)+o(Math.round(255*t.alpha)),i.push({label:a,textEdit:u.TextEdit.replace(n,JSON.stringify(a))}),i},e}();r.JSONDocumentSymbols=c});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/services/jsonValidation.js*/
define("1519ff4",function(e,r){"use strict";function t(e){if(e&&"object"==typeof e){if(e.allowComments)return!0;if(e.allOf)return e.allOf.some(t)}return!1}function o(e){switch(e){case"error":return a.DiagnosticSeverity.Error;case"warning":return a.DiagnosticSeverity.Warning;case"ignore":return void 0}return void 0}Object.defineProperty(r,"__esModule",{value:!0});var i=e("11ed2ab"),n=e("a1f43d9"),a=e("737c70e"),s=e("683e3e1"),c=i.__importStar(e("60eaf5a")),f=c.loadMessageBundle(),v=function(){function e(e,r){this.jsonSchemaService=e,this.promise=r,this.validationEnabled=!0}return e.prototype.configure=function(e){e&&(this.validationEnabled=e.validate,this.commentSeverity=e.allowComments?void 0:a.DiagnosticSeverity.Error)},e.prototype.doValidation=function(e,r,i,c){var v=this;if(!this.validationEnabled)return this.promise.resolve([]);var l=[],u={},d=function(e){var r=e.range.start.line+" "+e.range.start.character+" "+e.message;u[r]||(u[r]=!0,l.push(e))},h=function(n){var c=i?o(i.trailingCommas):a.DiagnosticSeverity.Error,m=i?o(i.comments):v.commentSeverity;if(n){if(n.errors.length&&r.root){var u=r.root,h="object"===u.type?u.properties[0]:null;if(h&&"$schema"===h.keyNode.value){var g=h.valueNode||h,S=a.Range.create(e.positionAt(g.offset),e.positionAt(g.offset+g.length));d(a.Diagnostic.create(S,n.errors[0],a.DiagnosticSeverity.Warning,s.ErrorCode.SchemaResolveError))}else{var S=a.Range.create(e.positionAt(u.offset),e.positionAt(u.offset+1));d(a.Diagnostic.create(S,n.errors[0],a.DiagnosticSeverity.Warning,s.ErrorCode.SchemaResolveError))}}else{var p=r.validate(e,n.schema);p&&p.forEach(d)}t(n.schema)&&(c=m=void 0)}for(var y=0,E=r.syntaxErrors;y<E.length;y++){var C=E[y];if(C.code===s.ErrorCode.TrailingComma){if("number"!=typeof c)continue;C.severity=c}d(C)}if("number"==typeof m){var b=f("InvalidCommentToken","Comments are not permitted in JSON.");r.comments.forEach(function(e){d(a.Diagnostic.create(e,b,m,s.ErrorCode.CommentNotPermitted))})}return l};if(c){var g=c.id||"schemaservice://untitled/"+m++;return this.jsonSchemaService.resolveSchemaContent(new n.UnresolvedSchema(c),g,{}).then(function(e){return h(e)})}return this.jsonSchemaService.getSchemaForResource(e.uri,r).then(function(e){return h(e)})},e}();r.JSONValidation=v;var m=0});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/services/jsonHover.js*/
define("f9e39b3",function(e,t){"use strict";function n(e){if(e){var t=e.replace(/([^\n\r])(\r?\n)([^\n\r])/gm,"$1\n\n$3");return t.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}return void 0}Object.defineProperty(t,"__esModule",{value:!0});var r=e("11ed2ab"),i=r.__importStar(e("8408640")),o=e("737c70e"),s=function(){function e(e,t,n){void 0===t&&(t=[]),this.schemaService=e,this.contributions=t,this.promise=n||Promise}return e.prototype.doHover=function(e,t,r){var s=e.offsetAt(t),u=r.getNodeFromOffset(s);if(!u||("object"===u.type||"array"===u.type)&&s>u.offset+1&&s<u.offset+u.length-1)return this.promise.resolve(null);var a=u;if("string"===u.type){var c=u.parent;if(c&&"property"===c.type&&c.keyNode===u&&(u=c.valueNode,!u))return this.promise.resolve(null)}for(var f=o.Range.create(e.positionAt(a.offset),e.positionAt(a.offset+a.length)),m=function(e){var t={contents:e,range:f};return t},h=i.getNodePath(u),l=this.contributions.length-1;l>=0;l--){var p=this.contributions[l],v=p.getInfoContribution(e.uri,h);if(v)return v.then(function(e){return m(e)})}return this.schemaService.getSchemaForResource(e.uri,r).then(function(e){if(e){var t=r.getMatchingSchemas(e.schema,u.offset),o=null,s=null,a=null,c=null;t.every(function(e){if(e.node===u&&!e.inverted&&e.schema&&(o=o||e.schema.title,s=s||e.schema.markdownDescription||n(e.schema.description),e.schema.enum)){var t=e.schema.enum.indexOf(i.getNodeValue(u));e.schema.markdownEnumDescriptions?a=e.schema.markdownEnumDescriptions[t]:e.schema.enumDescriptions&&(a=n(e.schema.enumDescriptions[t])),a&&(c=e.schema.enum[t],"string"!=typeof c&&(c=JSON.stringify(c)))}return!0});var f="";return o&&(f=n(o)),s&&(f.length>0&&(f+="\n\n"),f+=s),a&&(f.length>0&&(f+="\n\n"),f+="`"+n(c)+"`: "+a),m([f])}return null})},e}();t.JSONHover=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/services/jsonCompletion.js*/
define("bc93086",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=e("11ed2ab"),n=r.__importStar(e("8408640")),o=r.__importStar(e("26128d7")),i=e("7e231df"),a=e("a0f93b8"),s=e("de6a48e"),l=e("737c70e"),u=r.__importStar(e("60eaf5a")),p=u.loadMessageBundle(),c=function(){function e(e,t,r,n){void 0===t&&(t=[]),void 0===r&&(r=Promise),void 0===n&&(n={}),this.schemaService=e,this.contributions=t,this.promiseConstructor=r,this.clientCapabilities=n,this.templateVarIdCounter=0}return e.prototype.doResolve=function(e){for(var t=this.contributions.length-1;t>=0;t--)if(this.contributions[t].resolveCompletion){var r=this.contributions[t].resolveCompletion(e);if(r)return r}return this.promiseConstructor.resolve(e)},e.prototype.doComplete=function(e,t,r){var o=this,i={items:[],isIncomplete:!1},a=e.offsetAt(t),s=r.getNodeFromOffset(a,!0);if(this.isInComment(e,s?s.offset:0,a))return Promise.resolve(i);var u=this.getCurrentWord(e,a),p=null;if(!s||"string"!==s.type&&"number"!==s.type&&"boolean"!==s.type&&"null"!==s.type){var c=a-u.length;c>0&&'"'===e.getText()[c-1]&&c--,p=l.Range.create(e.positionAt(c),t)}else p=l.Range.create(e.positionAt(s.offset),e.positionAt(s.offset+s.length));var d={},f={add:function(e){var t=d[e.label];t?t.documentation||(t.documentation=e.documentation):(d[e.label]=e,p&&(e.textEdit=l.TextEdit.replace(p,e.insertText)),i.items.push(e))},setAsIncomplete:function(){i.isIncomplete=!0},error:function(e){console.error(e)},log:function(e){console.log(e)},getNumberOfProposals:function(){return i.items.length}};return this.schemaService.getSchemaForResource(e.uri,r).then(function(t){var c=[],m=!0,g="",y=null;if(s&&"string"===s.type){var h=s.parent;h&&"property"===h.type&&h.keyNode===s&&(m=!h.valueNode,y=h,g=e.getText().substr(s.offset+1,s.length-2),h&&(s=h.parent))}if(s&&"object"===s.type){if(s.offset===a)return i;var x=s.properties;x.forEach(function(e){y&&y===e||(d[e.keyNode.value]=l.CompletionItem.create("__"))});var T="";m&&(T=o.evaluateSeparatorAfter(e,e.offsetAt(p.end))),t?o.getPropertyCompletions(t,r,s,m,T,f):o.getSchemaLessPropertyCompletions(r,s,g,f);var v=n.getNodePath(s);o.contributions.forEach(function(t){var r=t.collectPropertyCompletions(e.uri,v,u,m,""===T,f);r&&c.push(r)}),!t&&u.length>0&&'"'!==e.getText().charAt(a-u.length-1)&&(f.add({kind:l.CompletionItemKind.Property,label:o.getLabelForValue(u),insertText:o.getInsertTextForProperty(u,null,!1,T),insertTextFormat:l.InsertTextFormat.Snippet,documentation:""}),f.setAsIncomplete())}var b={};return t?o.getValueCompletions(t,r,s,a,e,f,b):o.getSchemaLessValueCompletions(r,s,a,e,f),o.contributions.length>0&&o.getContributedValueCompletions(r,s,a,e,f,c),o.promiseConstructor.all(c).then(function(){if(0===f.getNumberOfProposals()){var t=a;!s||"string"!==s.type&&"number"!==s.type&&"boolean"!==s.type&&"null"!==s.type||(t=s.offset+s.length);var r=o.evaluateSeparatorAfter(e,t);o.addFillerValueCompletions(b,r,f)}return i})})},e.prototype.getPropertyCompletions=function(e,t,r,n,o,i){var s=this,u=t.getMatchingSchemas(e.schema,r.offset);u.forEach(function(e){if(e.node===r&&!e.inverted){var t=e.schema.properties;t&&Object.keys(t).forEach(function(e){var r=t[e];if("object"==typeof r&&!r.deprecationMessage&&!r.doNotSuggest){var u={kind:l.CompletionItemKind.Property,label:s.sanitizeLabel(e),insertText:s.getInsertTextForProperty(e,r,n,o),insertTextFormat:l.InsertTextFormat.Snippet,filterText:s.getFilterTextForValue(e),documentation:s.fromMarkup(r.markdownDescription)||r.description||""};a.endsWith(u.insertText,"$1"+o)&&(u.command={title:"Suggest",command:"editor.action.triggerSuggest"}),i.add(u)}})}})},e.prototype.getSchemaLessPropertyCompletions=function(e,t,r,n){var o=this,i=function(e){e.properties.forEach(function(e){var t=e.keyNode.value;n.add({kind:l.CompletionItemKind.Property,label:o.sanitizeLabel(t),insertText:o.getInsertTextForValue(t,""),insertTextFormat:l.InsertTextFormat.Snippet,filterText:o.getFilterTextForValue(t),documentation:""})})};if(t.parent)if("property"===t.parent.type){var a=t.parent.keyNode.value;e.visit(function(e){return"property"===e.type&&e!==t.parent&&e.keyNode.value===a&&e.valueNode&&"object"===e.valueNode.type&&i(e.valueNode),!0})}else"array"===t.parent.type&&t.parent.items.forEach(function(e){"object"===e.type&&e!==t&&i(e)});else"object"===t.type&&n.add({kind:l.CompletionItemKind.Property,label:"$schema",insertText:this.getInsertTextForProperty("$schema",null,!0,""),insertTextFormat:l.InsertTextFormat.Snippet,documentation:"",filterText:this.getFilterTextForValue("$schema")})},e.prototype.getSchemaLessValueCompletions=function(e,t,r,o,i){var a=this,s=r;if(!t||"string"!==t.type&&"number"!==t.type&&"boolean"!==t.type&&"null"!==t.type||(s=t.offset+t.length,t=t.parent),!t)return i.add({kind:this.getSuggestionKind("object"),label:"Empty object",insertText:this.getInsertTextForValue({},""),insertTextFormat:l.InsertTextFormat.Snippet,documentation:""}),void i.add({kind:this.getSuggestionKind("array"),label:"Empty array",insertText:this.getInsertTextForValue([],""),insertTextFormat:l.InsertTextFormat.Snippet,documentation:""});var u=this.evaluateSeparatorAfter(o,s),p=function(e){n.contains(e.parent,r,!0)||i.add({kind:a.getSuggestionKind(e.type),label:a.getLabelTextForMatchingNode(e,o),insertText:a.getInsertTextForMatchingNode(e,o,u),insertTextFormat:l.InsertTextFormat.Snippet,documentation:""}),"boolean"===e.type&&a.addBooleanValueCompletion(!e.value,u,i)};if("property"===t.type&&r>t.colonOffset){var c=t.valueNode;if(c&&(r>c.offset+c.length||"object"===c.type||"array"===c.type))return;var d=t.keyNode.value;e.visit(function(e){return"property"===e.type&&e.keyNode.value===d&&e.valueNode&&p(e.valueNode),!0}),"$schema"===d&&t.parent&&!t.parent.parent&&this.addDollarSchemaCompletions(u,i)}if("array"===t.type)if(t.parent&&"property"===t.parent.type){var f=t.parent.keyNode.value;e.visit(function(e){return"property"===e.type&&e.keyNode.value===f&&e.valueNode&&"array"===e.valueNode.type&&e.valueNode.items.forEach(p),!0})}else t.items.forEach(p)},e.prototype.getValueCompletions=function(e,t,r,n,o,i,a){var s=this,l=n,u=null,p=null;if(!r||"string"!==r.type&&"number"!==r.type&&"boolean"!==r.type&&"null"!==r.type||(l=r.offset+r.length,p=r,r=r.parent),!r)return void this.addSchemaValueCompletions(e.schema,"",i,a);if("property"===r.type&&n>r.colonOffset){var c=r.valueNode;if(c&&n>c.offset+c.length)return;u=r.keyNode.value,r=r.parent}if(r&&(null!==u||"array"===r.type)){var d=this.evaluateSeparatorAfter(o,l),f=t.getMatchingSchemas(e.schema,r.offset,p);f.forEach(function(e){if(e.node===r&&!e.inverted&&e.schema){if("array"===r.type&&e.schema.items)if(Array.isArray(e.schema.items)){var t=s.findItemAtOffset(r,o,n);t<e.schema.items.length&&s.addSchemaValueCompletions(e.schema.items[t],d,i,a)}else s.addSchemaValueCompletions(e.schema.items,d,i,a);if(e.schema.properties){var l=e.schema.properties[u];l&&s.addSchemaValueCompletions(l,d,i,a)}}}),"$schema"!==u||r.parent||this.addDollarSchemaCompletions(d,i),a["boolean"]&&(this.addBooleanValueCompletion(!0,d,i),this.addBooleanValueCompletion(!1,d,i)),a["null"]&&this.addNullValueCompletion(d,i)}},e.prototype.getContributedValueCompletions=function(e,t,r,o,i,a){if(t){if(("string"===t.type||"number"===t.type||"boolean"===t.type||"null"===t.type)&&(t=t.parent),"property"===t.type&&r>t.colonOffset){var s=t.keyNode.value,l=t.valueNode;if(!l||r<=l.offset+l.length){var u=n.getNodePath(t.parent);this.contributions.forEach(function(e){var t=e.collectValueCompletions(o.uri,u,s,i);t&&a.push(t)})}}}else this.contributions.forEach(function(e){var t=e.collectDefaultCompletions(o.uri,i);t&&a.push(t)})},e.prototype.addSchemaValueCompletions=function(e,t,r,n){var o=this;"object"==typeof e&&(this.addEnumValueCompletions(e,t,r),this.addDefaultValueCompletions(e,t,r),this.collectTypes(e,n),Array.isArray(e.allOf)&&e.allOf.forEach(function(e){return o.addSchemaValueCompletions(e,t,r,n)}),Array.isArray(e.anyOf)&&e.anyOf.forEach(function(e){return o.addSchemaValueCompletions(e,t,r,n)}),Array.isArray(e.oneOf)&&e.oneOf.forEach(function(e){return o.addSchemaValueCompletions(e,t,r,n)}))},e.prototype.addDefaultValueCompletions=function(e,t,r,n){var o=this;void 0===n&&(n=0);var i=!1;if(s.isDefined(e.default)){for(var a=e.type,u=e.default,c=n;c>0;c--)u=[u],a="array";r.add({kind:this.getSuggestionKind(a),label:this.getLabelForValue(u),insertText:this.getInsertTextForValue(u,t),insertTextFormat:l.InsertTextFormat.Snippet,detail:p("json.suggest.default","Default value")}),i=!0}Array.isArray(e.examples)&&e.examples.forEach(function(a){for(var s=e.type,u=a,p=n;p>0;p--)u=[u],s="array";r.add({kind:o.getSuggestionKind(s),label:o.getLabelForValue(u),insertText:o.getInsertTextForValue(u,t),insertTextFormat:l.InsertTextFormat.Snippet}),i=!0}),Array.isArray(e.defaultSnippets)&&e.defaultSnippets.forEach(function(a){var u,p,c=e.type,d=a.body,f=a.label;if(s.isDefined(d)){for(var m=e.type,g=n;g>0;g--)d=[d],m="array";u=o.getInsertTextForSnippetValue(d,t),p=o.getFilterTextForSnippetValue(d),f=f||o.getLabelForSnippetValue(d)}else if("string"==typeof a.bodyText){for(var y="",h="",x="",g=n;g>0;g--)y=y+x+"[\n",h=h+"\n"+x+"]",x+="	",c="array";u=y+x+a.bodyText.split("\n").join("\n"+x)+h+t,f=f||o.sanitizeLabel(u),p=u.replace(/[\n]/g,"")}r.add({kind:o.getSuggestionKind(c),label:f,documentation:o.fromMarkup(a.markdownDescription)||a.description,insertText:u,insertTextFormat:l.InsertTextFormat.Snippet,filterText:p}),i=!0}),i||"object"!=typeof e.items||Array.isArray(e.items)||this.addDefaultValueCompletions(e.items,t,r,n+1)},e.prototype.addEnumValueCompletions=function(e,t,r){if(s.isDefined(e.const)&&r.add({kind:this.getSuggestionKind(e.type),label:this.getLabelForValue(e.const),insertText:this.getInsertTextForValue(e.const,t),insertTextFormat:l.InsertTextFormat.Snippet,documentation:this.fromMarkup(e.markdownDescription)||e.description}),Array.isArray(e.enum))for(var n=0,o=e.enum.length;o>n;n++){var i=e.enum[n],a=this.fromMarkup(e.markdownDescription)||e.description;e.markdownEnumDescriptions&&n<e.markdownEnumDescriptions.length&&this.doesSupportMarkdown()?a=this.fromMarkup(e.markdownEnumDescriptions[n]):e.enumDescriptions&&n<e.enumDescriptions.length&&(a=e.enumDescriptions[n]),r.add({kind:this.getSuggestionKind(e.type),label:this.getLabelForValue(i),insertText:this.getInsertTextForValue(i,t),insertTextFormat:l.InsertTextFormat.Snippet,documentation:a})}},e.prototype.collectTypes=function(e,t){if(!Array.isArray(e.enum)&&!s.isDefined(e.const)){var r=e.type;Array.isArray(r)?r.forEach(function(e){return t[e]=!0}):t[r]=!0}},e.prototype.addFillerValueCompletions=function(e,t,r){e.object&&r.add({kind:this.getSuggestionKind("object"),label:"{}",insertText:this.getInsertTextForGuessedValue({},t),insertTextFormat:l.InsertTextFormat.Snippet,detail:p("defaults.object","New object"),documentation:""}),e.array&&r.add({kind:this.getSuggestionKind("array"),label:"[]",insertText:this.getInsertTextForGuessedValue([],t),insertTextFormat:l.InsertTextFormat.Snippet,detail:p("defaults.array","New array"),documentation:""})},e.prototype.addBooleanValueCompletion=function(e,t,r){r.add({kind:this.getSuggestionKind("boolean"),label:e?"true":"false",insertText:this.getInsertTextForValue(e,t),insertTextFormat:l.InsertTextFormat.Snippet,documentation:""})},e.prototype.addNullValueCompletion=function(e,t){t.add({kind:this.getSuggestionKind("null"),label:"null",insertText:"null"+e,insertTextFormat:l.InsertTextFormat.Snippet,documentation:""})},e.prototype.addDollarSchemaCompletions=function(e,t){var r=this,n=this.schemaService.getRegisteredSchemaIds(function(e){return"http"===e||"https"===e});n.forEach(function(n){return t.add({kind:l.CompletionItemKind.Module,label:r.getLabelForValue(n),filterText:r.getFilterTextForValue(n),insertText:r.getInsertTextForValue(n,e),insertTextFormat:l.InsertTextFormat.Snippet,documentation:""})})},e.prototype.sanitizeLabel=function(e){return e=e.replace(/[\n]/g,"↵"),e.length>57&&(e=e.substr(0,57).trim()+"..."),e},e.prototype.getLabelForValue=function(e){return this.sanitizeLabel(JSON.stringify(e))},e.prototype.getFilterTextForValue=function(e){return JSON.stringify(e)},e.prototype.getFilterTextForSnippetValue=function(e){return JSON.stringify(e).replace(/\$\{\d+:([^}]+)\}|\$\d+/g,"$1")},e.prototype.getLabelForSnippetValue=function(e){var t=JSON.stringify(e);return t=t.replace(/\$\{\d+:([^}]+)\}|\$\d+/g,"$1"),this.sanitizeLabel(t)},e.prototype.getInsertTextForPlainText=function(e){return e.replace(/[\\\$\}]/g,"\\$&")},e.prototype.getInsertTextForValue=function(e,t){var r=JSON.stringify(e,null,"	");return"{}"===r?"{$1}"+t:"[]"===r?"[$1]"+t:this.getInsertTextForPlainText(r+t)},e.prototype.getInsertTextForSnippetValue=function(e,t){var r=function(e){return"string"==typeof e&&"^"===e[0]?e.substr(1):JSON.stringify(e)};return i.stringifyObject(e,"",r)+t},e.prototype.getInsertTextForGuessedValue=function(e,t){switch(typeof e){case"object":return null===e?"${1:null}"+t:this.getInsertTextForValue(e,t);case"string":var r=JSON.stringify(e);return r=r.substr(1,r.length-2),r=this.getInsertTextForPlainText(r),'"${1:'+r+'}"'+t;case"number":case"boolean":return"${1:"+JSON.stringify(e)+"}"+t}return this.getInsertTextForValue(e,t)},e.prototype.getSuggestionKind=function(e){if(Array.isArray(e)){var t=e;e=t.length>0?t[0]:null}if(!e)return l.CompletionItemKind.Value;switch(e){case"string":return l.CompletionItemKind.Value;case"object":return l.CompletionItemKind.Module;case"property":return l.CompletionItemKind.Property;default:return l.CompletionItemKind.Value}},e.prototype.getLabelTextForMatchingNode=function(e,t){switch(e.type){case"array":return"[]";case"object":return"{}";default:var r=t.getText().substr(e.offset,e.length);return r}},e.prototype.getInsertTextForMatchingNode=function(e,t,r){switch(e.type){case"array":return this.getInsertTextForValue([],r);case"object":return this.getInsertTextForValue({},r);default:var n=t.getText().substr(e.offset,e.length)+r;return this.getInsertTextForPlainText(n)}},e.prototype.getInsertTextForProperty=function(e,t,r,n){var o=this.getInsertTextForValue(e,"");if(!r)return o;var i,a=o+": ",l=0;if(t){if(Array.isArray(t.defaultSnippets)){if(1===t.defaultSnippets.length){var u=t.defaultSnippets[0].body;s.isDefined(u)&&(i=this.getInsertTextForSnippetValue(u,""))}l+=t.defaultSnippets.length}if(t.enum&&(i||1!==t.enum.length||(i=this.getInsertTextForGuessedValue(t.enum[0],"")),l+=t.enum.length),s.isDefined(t.default)&&(i||(i=this.getInsertTextForGuessedValue(t.default,"")),l++),0===l){var p=Array.isArray(t.type)?t.type[0]:t.type;switch(p||(t.properties?p="object":t.items&&(p="array")),p){case"boolean":i="$1";break;case"string":i='"$1"';break;case"object":i="{$1}";break;case"array":i="[$1]";break;case"number":case"integer":i="${1:0}";break;case"null":i="${1:null}";break;default:return o}}}return(!i||l>1)&&(i="$1"),a+i+n},e.prototype.getCurrentWord=function(e,t){for(var r=t-1,n=e.getText();r>=0&&-1===' 	\n\r":{[,]}'.indexOf(n.charAt(r));)r--;return n.substring(r+1,t)},e.prototype.evaluateSeparatorAfter=function(e,t){var r=o.createScanner(e.getText(),!0);r.setPosition(t);var n=r.scan();switch(n){case 5:case 2:case 4:case 17:return"";default:return","}},e.prototype.findItemAtOffset=function(e,t,r){for(var n=o.createScanner(t.getText(),!0),i=e.items,a=i.length-1;a>=0;a--){var s=i[a];if(r>s.offset+s.length){n.setPosition(s.offset+s.length);var l=n.scan();return 5===l&&r>=n.getTokenOffset()+n.getTokenLength()?a+1:a}if(r>=s.offset)return a}return 0},e.prototype.isInComment=function(e,t,r){var n=o.createScanner(e.getText(),!1);n.setPosition(t);for(var i=n.scan();17!==i&&n.getTokenOffset()+n.getTokenLength()<r;)i=n.scan();return(12===i||13===i)&&n.getTokenOffset()<=r},e.prototype.fromMarkup=function(e){return e&&this.doesSupportMarkdown()?{kind:l.MarkupKind.Markdown,value:e}:void 0},e.prototype.doesSupportMarkdown=function(){if(!s.isDefined(this.supportsMarkdown)){var e=this.clientCapabilities.textDocument&&this.clientCapabilities.textDocument.completion;this.supportsMarkdown=e&&e.completionItem&&Array.isArray(e.completionItem.documentationFormat)&&-1!==e.completionItem.documentationFormat.indexOf(l.MarkupKind.Markdown)}return this.supportsMarkdown},e}();t.JSONCompletion=c});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-languageserver-types/main.js*/
define("737c70e",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),function(e){function n(e,n){return{line:e,character:n}}function t(e){var n=e;return a.objectLiteral(n)&&a.number(n.line)&&a.number(n.character)}e.create=n,e.is=t}(n.Position||(n.Position={})),function(e){function t(e,t,i,r){if(a.number(e)&&a.number(t)&&a.number(i)&&a.number(r))return{start:n.Position.create(e,t),end:n.Position.create(i,r)};if(n.Position.is(e)&&n.Position.is(t))return{start:e,end:t};throw new Error("Range#create called with invalid arguments["+e+", "+t+", "+i+", "+r+"]")}function i(e){var t=e;return a.objectLiteral(t)&&n.Position.is(t.start)&&n.Position.is(t.end)}e.create=t,e.is=i}(n.Range||(n.Range={})),function(e){function t(e,n){return{uri:e,range:n}}function i(e){var t=e;return a.defined(t)&&n.Range.is(t.range)&&(a.string(t.uri)||a.undefined(t.uri))}e.create=t,e.is=i}(n.Location||(n.Location={})),function(e){function t(e,n,t,i){return{targetUri:e,targetRange:n,targetSelectionRange:t,originSelectionRange:i}}function i(e){var t=e;return a.defined(t)&&n.Range.is(t.targetRange)&&a.string(t.targetUri)&&(n.Range.is(t.targetSelectionRange)||a.undefined(t.targetSelectionRange))&&(n.Range.is(t.originSelectionRange)||a.undefined(t.originSelectionRange))}e.create=t,e.is=i}(n.LocationLink||(n.LocationLink={})),function(e){function n(e,n,t,i){return{red:e,green:n,blue:t,alpha:i}}function t(e){var n=e;return a.number(n.red)&&a.number(n.green)&&a.number(n.blue)&&a.number(n.alpha)}e.create=n,e.is=t}(n.Color||(n.Color={})),function(e){function t(e,n){return{range:e,color:n}}function i(e){var t=e;return n.Range.is(t.range)&&n.Color.is(t.color)}e.create=t,e.is=i}(n.ColorInformation||(n.ColorInformation={})),function(e){function t(e,n,t){return{label:e,textEdit:n,additionalTextEdits:t}}function i(e){var t=e;return a.string(t.label)&&(a.undefined(t.textEdit)||n.TextEdit.is(t))&&(a.undefined(t.additionalTextEdits)||a.typedArray(t.additionalTextEdits,n.TextEdit.is))}e.create=t,e.is=i}(n.ColorPresentation||(n.ColorPresentation={})),function(e){e.Comment="comment",e.Imports="imports",e.Region="region"}(n.FoldingRangeKind||(n.FoldingRangeKind={})),function(e){function n(e,n,t,i,r){var o={startLine:e,endLine:n};return a.defined(t)&&(o.startCharacter=t),a.defined(i)&&(o.endCharacter=i),a.defined(r)&&(o.kind=r),o}function t(e){var n=e;return a.number(n.startLine)&&a.number(n.startLine)&&(a.undefined(n.startCharacter)||a.number(n.startCharacter))&&(a.undefined(n.endCharacter)||a.number(n.endCharacter))&&(a.undefined(n.kind)||a.string(n.kind))}e.create=n,e.is=t}(n.FoldingRange||(n.FoldingRange={})),function(e){function t(e,n){return{location:e,message:n}}function i(e){var t=e;return a.defined(t)&&n.Location.is(t.location)&&a.string(t.message)}e.create=t,e.is=i}(n.DiagnosticRelatedInformation||(n.DiagnosticRelatedInformation={})),function(e){e.Error=1,e.Warning=2,e.Information=3,e.Hint=4}(n.DiagnosticSeverity||(n.DiagnosticSeverity={})),function(e){function t(e,n,t,i,r,o){var u={range:e,message:n};return a.defined(t)&&(u.severity=t),a.defined(i)&&(u.code=i),a.defined(r)&&(u.source=r),a.defined(o)&&(u.relatedInformation=o),u}function i(e){var t=e;return a.defined(t)&&n.Range.is(t.range)&&a.string(t.message)&&(a.number(t.severity)||a.undefined(t.severity))&&(a.number(t.code)||a.string(t.code)||a.undefined(t.code))&&(a.string(t.source)||a.undefined(t.source))&&(a.undefined(t.relatedInformation)||a.typedArray(t.relatedInformation,n.DiagnosticRelatedInformation.is))}e.create=t,e.is=i}(n.Diagnostic||(n.Diagnostic={})),function(e){function n(e,n){for(var t=[],i=2;i<arguments.length;i++)t[i-2]=arguments[i];var r={title:e,command:n};return a.defined(t)&&t.length>0&&(r.arguments=t),r}function t(e){var n=e;return a.defined(n)&&a.string(n.title)&&a.string(n.command)}e.create=n,e.is=t}(n.Command||(n.Command={})),function(e){function t(e,n){return{range:e,newText:n}}function i(e,n){return{range:{start:e,end:e},newText:n}}function r(e){return{range:e,newText:""}}function o(e){var t=e;return a.objectLiteral(t)&&a.string(t.newText)&&n.Range.is(t.range)}e.replace=t,e.insert=i,e.del=r,e.is=o}(n.TextEdit||(n.TextEdit={})),function(e){function t(e,n){return{textDocument:e,edits:n}}function i(e){var t=e;return a.defined(t)&&n.VersionedTextDocumentIdentifier.is(t.textDocument)&&Array.isArray(t.edits)}e.create=t,e.is=i}(n.TextDocumentEdit||(n.TextDocumentEdit={})),function(e){function n(e,n){var t={kind:"create",uri:e};return void 0===n||void 0===n.overwrite&&void 0===n.ignoreIfExists||(t.options=n),t}function t(e){var n=e;return n&&"create"===n.kind&&a.string(n.uri)&&(void 0===n.options||(void 0===n.options.overwrite||a.boolean(n.options.overwrite))&&(void 0===n.options.ignoreIfExists||a.boolean(n.options.ignoreIfExists)))}e.create=n,e.is=t}(n.CreateFile||(n.CreateFile={})),function(e){function n(e,n,t){var i={kind:"rename",oldUri:e,newUri:n};return void 0===t||void 0===t.overwrite&&void 0===t.ignoreIfExists||(i.options=t),i}function t(e){var n=e;return n&&"rename"===n.kind&&a.string(n.oldUri)&&a.string(n.newUri)&&(void 0===n.options||(void 0===n.options.overwrite||a.boolean(n.options.overwrite))&&(void 0===n.options.ignoreIfExists||a.boolean(n.options.ignoreIfExists)))}e.create=n,e.is=t}(n.RenameFile||(n.RenameFile={})),function(e){function n(e,n){var t={kind:"delete",uri:e};return void 0===n||void 0===n.recursive&&void 0===n.ignoreIfNotExists||(t.options=n),t}function t(e){var n=e;return n&&"delete"===n.kind&&a.string(n.uri)&&(void 0===n.options||(void 0===n.options.recursive||a.boolean(n.options.recursive))&&(void 0===n.options.ignoreIfNotExists||a.boolean(n.options.ignoreIfNotExists)))}e.create=n,e.is=t}(n.DeleteFile||(n.DeleteFile={})),function(e){function t(e){var t=e;return t&&(void 0!==t.changes||void 0!==t.documentChanges)&&(void 0===t.documentChanges||t.documentChanges.every(function(e){return a.string(e.kind)?n.CreateFile.is(e)||n.RenameFile.is(e)||n.DeleteFile.is(e):n.TextDocumentEdit.is(e)}))}e.is=t}(n.WorkspaceEdit||(n.WorkspaceEdit={}));var t=function(){function e(e){this.edits=e}return e.prototype.insert=function(e,t){this.edits.push(n.TextEdit.insert(e,t))},e.prototype.replace=function(e,t){this.edits.push(n.TextEdit.replace(e,t))},e.prototype.delete=function(e){this.edits.push(n.TextEdit.del(e))},e.prototype.add=function(e){this.edits.push(e)},e.prototype.all=function(){return this.edits},e.prototype.clear=function(){this.edits.splice(0,this.edits.length)},e}(),i=function(){function e(e){var i=this;this._textEditChanges=Object.create(null),e&&(this._workspaceEdit=e,e.documentChanges?e.documentChanges.forEach(function(e){if(n.TextDocumentEdit.is(e)){var r=new t(e.edits);i._textEditChanges[e.textDocument.uri]=r}}):e.changes&&Object.keys(e.changes).forEach(function(n){var r=new t(e.changes[n]);i._textEditChanges[n]=r}))}return Object.defineProperty(e.prototype,"edit",{get:function(){return this._workspaceEdit},enumerable:!0,configurable:!0}),e.prototype.getTextEditChange=function(e){if(n.VersionedTextDocumentIdentifier.is(e)){if(this._workspaceEdit||(this._workspaceEdit={documentChanges:[]}),!this._workspaceEdit.documentChanges)throw new Error("Workspace edit is not configured for document changes.");var i=e,r=this._textEditChanges[i.uri];if(!r){var o=[],a={textDocument:i,edits:o};this._workspaceEdit.documentChanges.push(a),r=new t(o),this._textEditChanges[i.uri]=r}return r}if(this._workspaceEdit||(this._workspaceEdit={changes:Object.create(null)}),!this._workspaceEdit.changes)throw new Error("Workspace edit is not configured for normal text edit changes.");var r=this._textEditChanges[e];if(!r){var o=[];this._workspaceEdit.changes[e]=o,r=new t(o),this._textEditChanges[e]=r}return r},e.prototype.createFile=function(e,t){this.checkDocumentChanges(),this._workspaceEdit.documentChanges.push(n.CreateFile.create(e,t))},e.prototype.renameFile=function(e,t,i){this.checkDocumentChanges(),this._workspaceEdit.documentChanges.push(n.RenameFile.create(e,t,i))},e.prototype.deleteFile=function(e,t){this.checkDocumentChanges(),this._workspaceEdit.documentChanges.push(n.DeleteFile.create(e,t))},e.prototype.checkDocumentChanges=function(){if(!this._workspaceEdit||!this._workspaceEdit.documentChanges)throw new Error("Workspace edit is not configured for document changes.")},e}();n.WorkspaceChange=i,function(e){function n(e){return{uri:e}}function t(e){var n=e;return a.defined(n)&&a.string(n.uri)}e.create=n,e.is=t}(n.TextDocumentIdentifier||(n.TextDocumentIdentifier={})),function(e){function n(e,n){return{uri:e,version:n}}function t(e){var n=e;return a.defined(n)&&a.string(n.uri)&&(null===n.version||a.number(n.version))}e.create=n,e.is=t}(n.VersionedTextDocumentIdentifier||(n.VersionedTextDocumentIdentifier={})),function(e){function n(e,n,t,i){return{uri:e,languageId:n,version:t,text:i}}function t(e){var n=e;return a.defined(n)&&a.string(n.uri)&&a.string(n.languageId)&&a.number(n.version)&&a.string(n.text)}e.create=n,e.is=t}(n.TextDocumentItem||(n.TextDocumentItem={})),function(e){e.PlainText="plaintext",e.Markdown="markdown"}(n.MarkupKind||(n.MarkupKind={})),function(e){function n(n){var t=n;return t===e.PlainText||t===e.Markdown}e.is=n}(n.MarkupKind||(n.MarkupKind={})),function(e){function t(e){var t=e;return a.objectLiteral(e)&&n.MarkupKind.is(t.kind)&&a.string(t.value)}e.is=t}(n.MarkupContent||(n.MarkupContent={})),function(e){e.Text=1,e.Method=2,e.Function=3,e.Constructor=4,e.Field=5,e.Variable=6,e.Class=7,e.Interface=8,e.Module=9,e.Property=10,e.Unit=11,e.Value=12,e.Enum=13,e.Keyword=14,e.Snippet=15,e.Color=16,e.File=17,e.Reference=18,e.Folder=19,e.EnumMember=20,e.Constant=21,e.Struct=22,e.Event=23,e.Operator=24,e.TypeParameter=25}(n.CompletionItemKind||(n.CompletionItemKind={})),function(e){e.PlainText=1,e.Snippet=2}(n.InsertTextFormat||(n.InsertTextFormat={})),function(e){function n(e){return{label:e}}e.create=n}(n.CompletionItem||(n.CompletionItem={})),function(e){function n(e,n){return{items:e?e:[],isIncomplete:!!n}}e.create=n}(n.CompletionList||(n.CompletionList={})),function(e){function n(e){return e.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}function t(e){var n=e;return a.string(n)||a.objectLiteral(n)&&a.string(n.language)&&a.string(n.value)}e.fromPlainText=n,e.is=t}(n.MarkedString||(n.MarkedString={})),function(e){function t(e){var t=e;return!!t&&a.objectLiteral(t)&&(n.MarkupContent.is(t.contents)||n.MarkedString.is(t.contents)||a.typedArray(t.contents,n.MarkedString.is))&&(void 0===e.range||n.Range.is(e.range))}e.is=t}(n.Hover||(n.Hover={})),function(e){function n(e,n){return n?{label:e,documentation:n}:{label:e}}e.create=n}(n.ParameterInformation||(n.ParameterInformation={})),function(e){function n(e,n){for(var t=[],i=2;i<arguments.length;i++)t[i-2]=arguments[i];var r={label:e};return a.defined(n)&&(r.documentation=n),r.parameters=a.defined(t)?t:[],r}e.create=n}(n.SignatureInformation||(n.SignatureInformation={})),function(e){e.Text=1,e.Read=2,e.Write=3}(n.DocumentHighlightKind||(n.DocumentHighlightKind={})),function(e){function n(e,n){var t={range:e};return a.number(n)&&(t.kind=n),t}e.create=n}(n.DocumentHighlight||(n.DocumentHighlight={})),function(e){e.File=1,e.Module=2,e.Namespace=3,e.Package=4,e.Class=5,e.Method=6,e.Property=7,e.Field=8,e.Constructor=9,e.Enum=10,e.Interface=11,e.Function=12,e.Variable=13,e.Constant=14,e.String=15,e.Number=16,e.Boolean=17,e.Array=18,e.Object=19,e.Key=20,e.Null=21,e.EnumMember=22,e.Struct=23,e.Event=24,e.Operator=25,e.TypeParameter=26}(n.SymbolKind||(n.SymbolKind={})),function(e){function n(e,n,t,i,r){var o={name:e,kind:n,location:{uri:i,range:t}};return r&&(o.containerName=r),o}e.create=n}(n.SymbolInformation||(n.SymbolInformation={}));var r=function(){function e(){}return e}();n.DocumentSymbol=r,function(e){function t(e,n,t,i,r,o){var a={name:e,detail:n,kind:t,range:i,selectionRange:r};return void 0!==o&&(a.children=o),a}function i(e){var t=e;return t&&a.string(t.name)&&a.number(t.kind)&&n.Range.is(t.range)&&n.Range.is(t.selectionRange)&&(void 0===t.detail||a.string(t.detail))&&(void 0===t.deprecated||a.boolean(t.deprecated))&&(void 0===t.children||Array.isArray(t.children))}e.create=t,e.is=i}(r||(n.DocumentSymbol=r={})),function(e){e.QuickFix="quickfix",e.Refactor="refactor",e.RefactorExtract="refactor.extract",e.RefactorInline="refactor.inline",e.RefactorRewrite="refactor.rewrite",e.Source="source",e.SourceOrganizeImports="source.organizeImports"}(n.CodeActionKind||(n.CodeActionKind={})),function(e){function t(e,n){var t={diagnostics:e};return void 0!==n&&null!==n&&(t.only=n),t}function i(e){var t=e;return a.defined(t)&&a.typedArray(t.diagnostics,n.Diagnostic.is)&&(void 0===t.only||a.typedArray(t.only,a.string))}e.create=t,e.is=i}(n.CodeActionContext||(n.CodeActionContext={})),function(e){function t(e,t,i){var r={title:e};return n.Command.is(t)?r.command=t:r.edit=t,void 0!==i&&(r.kind=i),r}function i(e){var t=e;return!(!t||!a.string(t.title)||void 0!==t.diagnostics&&!a.typedArray(t.diagnostics,n.Diagnostic.is)||void 0!==t.kind&&!a.string(t.kind)||void 0===t.edit&&void 0===t.command||void 0!==t.command&&!n.Command.is(t.command)||void 0!==t.edit&&!n.WorkspaceEdit.is(t.edit))}e.create=t,e.is=i}(n.CodeAction||(n.CodeAction={})),function(e){function t(e,n){var t={range:e};return a.defined(n)&&(t.data=n),t}function i(e){var t=e;return a.defined(t)&&n.Range.is(t.range)&&(a.undefined(t.command)||n.Command.is(t.command))}e.create=t,e.is=i}(n.CodeLens||(n.CodeLens={})),function(e){function n(e,n){return{tabSize:e,insertSpaces:n}}function t(e){var n=e;return a.defined(n)&&a.number(n.tabSize)&&a.boolean(n.insertSpaces)}e.create=n,e.is=t}(n.FormattingOptions||(n.FormattingOptions={}));var o=function(){function e(){}return e}();n.DocumentLink=o,function(e){function t(e,n,t){return{range:e,target:n,data:t}}function i(e){var t=e;return a.defined(t)&&n.Range.is(t.range)&&(a.undefined(t.target)||a.string(t.target))}e.create=t,e.is=i}(o||(n.DocumentLink=o={})),n.EOL=["\n","\r\n","\r"],function(e){function n(e,n,t,i){return new u(e,n,t,i)}function t(e){var n=e;return a.defined(n)&&a.string(n.uri)&&(a.undefined(n.languageId)||a.string(n.languageId))&&a.number(n.lineCount)&&a.func(n.getText)&&a.func(n.positionAt)&&a.func(n.offsetAt)?!0:!1}function i(e,n){for(var t=e.getText(),i=r(n,function(e,n){var t=e.range.start.line-n.range.start.line;return 0===t?e.range.start.character-n.range.start.character:t}),o=t.length,a=i.length-1;a>=0;a--){var u=i[a],c=e.offsetAt(u.range.start),s=e.offsetAt(u.range.end);if(!(o>=s))throw new Error("Overlapping edit");t=t.substring(0,c)+u.newText+t.substring(s,t.length),o=c}return t}function r(e,n){if(e.length<=1)return e;var t=e.length/2|0,i=e.slice(0,t),o=e.slice(t);r(i,n),r(o,n);for(var a=0,u=0,c=0;a<i.length&&u<o.length;){var s=n(i[a],o[u]);e[c++]=0>=s?i[a++]:o[u++]}for(;a<i.length;)e[c++]=i[a++];for(;u<o.length;)e[c++]=o[u++];return e}e.create=n,e.is=t,e.applyEdits=i}(n.TextDocument||(n.TextDocument={})),function(e){e.Manual=1,e.AfterDelay=2,e.FocusOut=3}(n.TextDocumentSaveReason||(n.TextDocumentSaveReason={}));var a,u=function(){function e(e,n,t,i){this._uri=e,this._languageId=n,this._version=t,this._content=i,this._lineOffsets=null}return Object.defineProperty(e.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"languageId",{get:function(){return this._languageId},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"version",{get:function(){return this._version},enumerable:!0,configurable:!0}),e.prototype.getText=function(e){if(e){var n=this.offsetAt(e.start),t=this.offsetAt(e.end);return this._content.substring(n,t)}return this._content},e.prototype.update=function(e,n){this._content=e.text,this._version=n,this._lineOffsets=null},e.prototype.getLineOffsets=function(){if(null===this._lineOffsets){for(var e=[],n=this._content,t=!0,i=0;i<n.length;i++){t&&(e.push(i),t=!1);var r=n.charAt(i);t="\r"===r||"\n"===r,"\r"===r&&i+1<n.length&&"\n"===n.charAt(i+1)&&i++}t&&n.length>0&&e.push(n.length),this._lineOffsets=e}return this._lineOffsets},e.prototype.positionAt=function(e){e=Math.max(Math.min(e,this._content.length),0);var t=this.getLineOffsets(),i=0,r=t.length;if(0===r)return n.Position.create(0,e);for(;r>i;){var o=Math.floor((i+r)/2);t[o]>e?r=o:i=o+1}var a=i-1;return n.Position.create(a,e-t[a])},e.prototype.offsetAt=function(e){var n=this.getLineOffsets();if(e.line>=n.length)return this._content.length;if(e.line<0)return 0;var t=n[e.line],i=e.line+1<n.length?n[e.line+1]:this._content.length;return Math.max(Math.min(t+e.character,i),t)},Object.defineProperty(e.prototype,"lineCount",{get:function(){return this.getLineOffsets().length},enumerable:!0,configurable:!0}),e}();!function(e){function n(e){return"undefined"!=typeof e}function t(e){return"undefined"==typeof e}function i(e){return e===!0||e===!1}function r(e){return"[object String]"===s.call(e)}function o(e){return"[object Number]"===s.call(e)}function a(e){return"[object Function]"===s.call(e)}function u(e){return null!==e&&"object"==typeof e}function c(e,n){return Array.isArray(e)&&e.every(n)}var s=Object.prototype.toString;e.defined=n,e.undefined=t,e.boolean=i,e.string=r,e.number=o,e.func=a,e.objectLiteral=u,e.typedArray=c}(a||(a={}))});
/**! node_modules/monaco-editor/esm/vs/base/common/types.js*/
define("01fef85",function(n,t){"use strict";function r(n){return Array.isArray?Array.isArray(n):n&&typeof n.length===b.number&&n.constructor===Array?!0:!1}function e(n){return typeof n===b.string||n instanceof String?!0:!1}function o(n){return!(typeof n!==b.object||null===n||Array.isArray(n)||n instanceof RegExp||n instanceof Date)}function i(n){return(typeof n===b.number||n instanceof Number)&&!isNaN(n)?!0:!1}function u(n){return n===!0||n===!1}function f(n){return typeof n===b.undefined}function c(n){return f(n)||null===n}function a(n){if(!o(n))return!1;for(var t in n)if(m.call(n,t))return!1;return!0}function s(n){return typeof n===b.function}function l(n,t){for(var r=Math.min(n.length,t.length),e=0;r>e;e++)y(n[e],t[e])}function y(n,t){if(e(t)){if(typeof n!==t)throw new Error("argument does not match constraint: typeof "+t)}else if(s(t)){try{if(n instanceof t)return}catch(r){}if(!c(n)&&n.constructor===t)return;if(1===t.length&&t.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function d(n){for(var t=[],r=Object.getPrototypeOf(n);Object.prototype!==r;)t=t.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return t}function p(n){return null===n?void 0:n}function g(n){return"undefined"==typeof n?null:n}Object.defineProperty(t,"__esModule",{value:!0});var b={number:"number",string:"string",undefined:"undefined",object:"object","function":"function"};t.isArray=r,t.isString=e,t.isObject=o,t.isNumber=i,t.isBoolean=u,t.isUndefined=f,t.isUndefinedOrNull=c;var m=Object.prototype.hasOwnProperty;t.isEmptyObject=a,t.isFunction=s,t.validateConstraints=l,t.validateConstraint=y,t.getAllPropertyNames=d,t.withNullAsUndefined=p,t.withUndefinedAsNull=g});
/**! node_modules/monaco-editor/esm/vs/editor/common/standalone/standaloneBase.js*/
define("4dc9450",function(e,o){"use strict";function n(){return{editor:void 0,languages:void 0,CancellationTokenSource:t.CancellationTokenSource,Emitter:i.Emitter,KeyCode:S.KeyCode,KeyMod:k,Position:d.Position,Range:l.Range,Selection:u.Selection,SelectionDirection:S.SelectionDirection,MarkerSeverity:S.MarkerSeverity,MarkerTag:S.MarkerTag,Uri:c.URI,Token:f.Token}}Object.defineProperty(o,"__esModule",{value:!0});var r=e("11ed2ab");e("4a24931");var t=e("7ed507d"),i=e("8451667"),a=e("651ae9b"),c=e("50db2b4"),d=e("5ddf902"),l=e("4661130"),u=e("3b7eb07"),f=e("57d67ff"),S=r.__importStar(e("2e266ae")),k=function(){function e(){}return e.chord=function(e,o){return a.KeyChord(e,o)},e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256,e}();o.KeyMod=k,o.createMonacoBaseAPI=n});
/**! node_modules/monaco-editor/esm/vs/editor/common/modes/supports/inplaceReplaceSupport.js*/
define("670df80",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(){function e(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}return e.prototype.navigateValueSet=function(e,t,a,l,n){if(e&&t){var r=this.doNavigateValueSet(t,n);if(r)return{range:e,value:r}}if(a&&l){var r=this.doNavigateValueSet(l,n);if(r)return{range:a,value:r}}return null},e.prototype.doNavigateValueSet=function(e,t){var a=this.numberReplace(e,t);return null!==a?a:this.textReplace(e,t)},e.prototype.numberReplace=function(e,t){var a=Math.pow(10,e.length-(e.lastIndexOf(".")+1)),l=Number(e),n=parseFloat(e);return isNaN(l)||isNaN(n)||l!==n?null:0!==l||t?(l=Math.floor(l*a),l+=t?a:-a,String(l/a)):null},e.prototype.textReplace=function(e,t){return this.valueSetsReplace(this._defaultValueSet,e,t)},e.prototype.valueSetsReplace=function(e,t,a){for(var l=null,n=0,r=e.length;null===l&&r>n;n++)l=this.valueSetReplace(e[n],t,a);return l},e.prototype.valueSetReplace=function(e,t,a){var l=e.indexOf(t);return l>=0?(l+=a?1:-1,0>l?l=e.length-1:l%=e.length,e[l]):null},e.INSTANCE=new e,e}();t.BasicInplaceReplace=a});
/**! node_modules/monaco-editor/esm/vs/editor/common/modes/linkComputer.js*/
define("fabf684",function(e,t){"use strict";function n(){return null===c&&(c=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),c}function r(){if(null===s){s=new i.CharacterClassifier(0);for(var e=" 	<>'\"、。｡､，．：；？！＠＃＄％＆＊‘“〈《「『【〔（［｛｢｣｝］）〕】』」》〉”’｀～…",t=0;t<e.length;t++)s.set(e.charCodeAt(t),1);for(var n=".,;",t=0;t<n.length;t++)s.set(n.charCodeAt(t),2)}return s}function a(e){return e&&"function"==typeof e.getLineCount&&"function"==typeof e.getLineContent?f.computeLinks(e):[]}Object.defineProperty(t,"__esModule",{value:!0});var i=e("206e614"),o=e("4186ef1"),u=function(){function e(e){for(var t=0,n=0,r=0,a=e.length;a>r;r++){var i=e[r],u=i[0],c=i[1],s=i[2];c>t&&(t=c),u>n&&(n=u),s>n&&(n=s)}t++,n++;for(var f=new o.Uint8Matrix(n,t,0),r=0,a=e.length;a>r;r++){var h=e[r],u=h[0],c=h[1],s=h[2];f.set(u,c,s)}this._states=f,this._maxCharCode=t}return e.prototype.nextState=function(e,t){return 0>t||t>=this._maxCharCode?0:this._states.get(e,t)},e}();t.StateMachine=u;var c=null,s=null,f=function(){function e(){}return e._createLink=function(e,t,n,r,a){var i=a-1;do{var o=t.charCodeAt(i),u=e.get(o);if(2!==u)break;i--}while(i>r);if(r>0){var c=t.charCodeAt(r-1),s=t.charCodeAt(i);(40===c&&41===s||91===c&&93===s||123===c&&125===s)&&i--}return{range:{startLineNumber:n,startColumn:r+1,endLineNumber:n,endColumn:i+2},url:t.substring(r,i+1)}},e.computeLinks=function(t,a){void 0===a&&(a=n());for(var i=r(),o=[],u=1,c=t.getLineCount();c>=u;u++){for(var s=t.getLineContent(u),f=s.length,h=0,l=0,v=0,C=1,d=!1,k=!1,b=!1;f>h;){var g=!1,L=s.charCodeAt(h);if(13===C){var m=void 0;switch(L){case 40:d=!0,m=0;break;case 41:m=d?0:1;break;case 91:k=!0,m=0;break;case 93:m=k?0:1;break;case 123:b=!0,m=0;break;case 125:m=b?0:1;break;case 39:m=34===v||96===v?0:1;break;case 34:m=39===v||96===v?0:1;break;case 96:m=39===v||34===v?0:1;break;default:m=i.get(L)}1===m&&(o.push(e._createLink(i,s,u,l,h)),g=!0)}else if(12===C){var m=void 0;91===L?(k=!0,m=0):m=i.get(L),1===m?g=!0:C=13}else C=a.nextState(C,L),0===C&&(g=!0);g&&(C=1,d=!1,k=!1,b=!1,l=h+1,v=L),h++}13===C&&o.push(e._createLink(i,s,u,l,f))}return o},e}();t.LinkComputer=f,t.computeLinks=a});
/**! node_modules/monaco-editor/esm/vs/editor/common/model/wordHelper.js*/
define("3af5c49",function(e,n){"use strict";function r(e){void 0===e&&(e="");for(var r="(-?\\d*\\.\\d\\w*)|([^",t=0,a=n.USUAL_WORD_SEPARATORS;t<a.length;t++){var i=a[t];e.indexOf(i)>=0||(r+="\\"+i)}return r+="\\s]+)",new RegExp(r,"g")}function t(e){var r=n.DEFAULT_WORD_REGEXP;if(e&&e instanceof RegExp)if(e.global)r=e;else{var t="g";e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),e.unicode&&(t+="u"),r=new RegExp(e.source,t)}return r.lastIndex=0,r}function a(e,n,r,t){var a=e-1-t,i=r.lastIndexOf(" ",a-1)+1;n.lastIndex=i;for(var l;l=n.exec(r);){var u=l.index||0;if(a>=u&&n.lastIndex>=a)return{word:l[0],startColumn:t+1+u,endColumn:t+1+n.lastIndex}}return null}function i(e,n,r,t){var a=e-1-t;n.lastIndex=0;for(var i;i=n.exec(r);){var l=i.index||0;if(l>a)return null;if(n.lastIndex>=a)return{word:i[0],startColumn:t+1+l,endColumn:t+1+n.lastIndex}}return null}function l(e,n,r,t){n.lastIndex=0;var l=n.exec(r);if(!l)return null;var u=l[0].indexOf(" ")>=0?i(e,n,r,t):a(e,n,r,t);return n.lastIndex=0,u}Object.defineProperty(n,"__esModule",{value:!0}),n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?",n.DEFAULT_WORD_REGEXP=r(),n.ensureValidWordDefinition=t,n.getWordAtText=l});
/**! node_modules/monaco-editor/esm/vs/editor/common/model/mirrorTextModel.js*/
define("6250482",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=e("5ddf902"),i=e("cf86ba2"),s=function(){function e(e,t,n,i){this._uri=e,this._lines=t,this._eol=n,this._versionId=i,this._lineStarts=null}return e.prototype.dispose=function(){this._lines.length=0},e.prototype.getText=function(){return this._lines.join(this._eol)},e.prototype.onEvents=function(e){e.eol&&e.eol!==this._eol&&(this._eol=e.eol,this._lineStarts=null);for(var t=e.changes,i=0,s=t;i<s.length;i++){var r=s[i];this._acceptDeleteRange(r.range),this._acceptInsertText(new n.Position(r.range.startLineNumber,r.range.startColumn),r.text)}this._versionId=e.versionId},e.prototype._ensureLineStarts=function(){if(!this._lineStarts){for(var e=this._eol.length,t=this._lines.length,n=new Uint32Array(t),s=0;t>s;s++)n[s]=this._lines[s].length+e;this._lineStarts=new i.PrefixSumComputer(n)}},e.prototype._setLineText=function(e,t){this._lines[e]=t,this._lineStarts&&this._lineStarts.changeValue(e,this._lines[e].length+this._eol.length)},e.prototype._acceptDeleteRange=function(e){if(e.startLineNumber===e.endLineNumber){if(e.startColumn===e.endColumn)return;return void this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.startLineNumber-1].substring(e.endColumn-1))}this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.endLineNumber-1].substring(e.endColumn-1)),this._lines.splice(e.startLineNumber,e.endLineNumber-e.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(e.startLineNumber,e.endLineNumber-e.startLineNumber)},e.prototype._acceptInsertText=function(e,t){if(0!==t.length){var n=t.split(/\r\n|\r|\n/);if(1===n.length)return void this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+n[0]+this._lines[e.lineNumber-1].substring(e.column-1));n[n.length-1]+=this._lines[e.lineNumber-1].substring(e.column-1),this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+n[0]);for(var i=new Uint32Array(n.length-1),s=1;s<n.length;s++)this._lines.splice(e.lineNumber+s-1,0,n[s]),i[s-1]=n[s].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(e.lineNumber,i)}},e}();t.MirrorTextModel=s});
/**! node_modules/monaco-editor/esm/vs/editor/common/diff/diffComputer.js*/
define("d327c41",function(i,t){"use strict";function e(i,t,e,n){var r=new o.LcsDiff(i,t,e);return r.ComputeDiff(n)}function n(i){if(i.length<=1)return i;for(var t=[i[0]],e=t[0],n=1,r=i.length;r>n;n++){var o=i[n],a=o.originalStart-(e.originalStart+e.originalLength),h=o.modifiedStart-(e.modifiedStart+e.modifiedLength),u=Math.min(a,h);s>u?(e.originalLength=o.originalStart+o.originalLength-e.originalStart,e.modifiedLength=o.modifiedStart+o.modifiedLength-e.modifiedStart):(t.push(o),e=o)}return t}Object.defineProperty(t,"__esModule",{value:!0});var r=i("11ed2ab"),o=i("e1c5605"),a=r.__importStar(i("572f899")),h=5e3,s=3,u=function(){function i(t){for(var e=[],n=[],r=0,o=t.length;o>r;r++)e[r]=i._getFirstNonBlankColumn(t[r],1),n[r]=i._getLastNonBlankColumn(t[r],1);this._lines=t,this._startColumns=e,this._endColumns=n}return i.prototype.getLength=function(){return this._lines.length},i.prototype.getElementAtIndex=function(i){return this._lines[i].substring(this._startColumns[i]-1,this._endColumns[i]-1)},i.prototype.getStartLineNumber=function(i){return i+1},i.prototype.getEndLineNumber=function(i){return i+1},i._getFirstNonBlankColumn=function(i,t){var e=a.firstNonWhitespaceIndex(i);return-1===e?t:e+1},i._getLastNonBlankColumn=function(i,t){var e=a.lastNonWhitespaceIndex(i);return-1===e?t:e+2},i.prototype.getCharSequence=function(i,t,e){for(var n=[],r=[],o=[],a=0,h=t;e>=h;h++)for(var s=this._lines[h],u=i?this._startColumns[h]:1,m=i?this._endColumns[h]:s.length+1,g=u;m>g;g++)n[a]=s.charCodeAt(g-1),r[a]=h+1,o[a]=g,a++;return new d(n,r,o)},i}(),d=function(){function i(i,t,e){this._charCodes=i,this._lineNumbers=t,this._columns=e}return i.prototype.getLength=function(){return this._charCodes.length},i.prototype.getElementAtIndex=function(i){return this._charCodes[i]},i.prototype.getStartLineNumber=function(i){return this._lineNumbers[i]},i.prototype.getStartColumn=function(i){return this._columns[i]},i.prototype.getEndLineNumber=function(i){return this._lineNumbers[i]},i.prototype.getEndColumn=function(i){return this._columns[i]+1},i}(),m=function(){function i(i,t,e,n,r,o,a,h){this.originalStartLineNumber=i,this.originalStartColumn=t,this.originalEndLineNumber=e,this.originalEndColumn=n,this.modifiedStartLineNumber=r,this.modifiedStartColumn=o,this.modifiedEndLineNumber=a,this.modifiedEndColumn=h}return i.createFromDiffChange=function(t,e,n){var r,o,a,h,s,u,d,m;return 0===t.originalLength?(r=0,o=0,a=0,h=0):(r=e.getStartLineNumber(t.originalStart),o=e.getStartColumn(t.originalStart),a=e.getEndLineNumber(t.originalStart+t.originalLength-1),h=e.getEndColumn(t.originalStart+t.originalLength-1)),0===t.modifiedLength?(s=0,u=0,d=0,m=0):(s=n.getStartLineNumber(t.modifiedStart),u=n.getStartColumn(t.modifiedStart),d=n.getEndLineNumber(t.modifiedStart+t.modifiedLength-1),m=n.getEndColumn(t.modifiedStart+t.modifiedLength-1)),new i(r,o,a,h,s,u,d,m)},i}(),g=function(){function i(i,t,e,n,r){this.originalStartLineNumber=i,this.originalEndLineNumber=t,this.modifiedStartLineNumber=e,this.modifiedEndLineNumber=n,this.charChanges=r}return i.createFromDiffResult=function(t,r,o,a,h,s,u){var d,g,l,f,c=void 0;if(0===r.originalLength?(d=o.getStartLineNumber(r.originalStart)-1,g=0):(d=o.getStartLineNumber(r.originalStart),g=o.getEndLineNumber(r.originalStart+r.originalLength-1)),0===r.modifiedLength?(l=a.getStartLineNumber(r.modifiedStart)-1,f=0):(l=a.getStartLineNumber(r.modifiedStart),f=a.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),s&&0!==r.originalLength&&0!==r.modifiedLength&&h()){var C=o.getCharSequence(t,r.originalStart,r.originalStart+r.originalLength-1),L=a.getCharSequence(t,r.modifiedStart,r.modifiedStart+r.modifiedLength-1),p=e(C,L,h,!0);u&&(p=n(p)),c=[];for(var S=0,N=p.length;N>S;S++)c.push(m.createFromDiffChange(p[S],C,L))}return new i(d,g,l,f,c)},i}(),l=function(){function i(i,t,e){this.shouldComputeCharChanges=e.shouldComputeCharChanges,this.shouldPostProcessCharChanges=e.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=e.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=e.shouldMakePrettyDiff,this.maximumRunTimeMs=h,this.originalLines=i,this.modifiedLines=t,this.original=new u(i),this.modified=new u(t)}return i.prototype.computeDiff=function(){if(1===this.original.getLength()&&0===this.original.getElementAtIndex(0).length)return[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.getLength(),charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}];if(1===this.modified.getLength()&&0===this.modified.getElementAtIndex(0).length)return[{originalStartLineNumber:1,originalEndLineNumber:this.original.getLength(),modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}];this.computationStartTime=(new Date).getTime();var i=e(this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldMakePrettyDiff);if(this.shouldIgnoreTrimWhitespace){for(var t=[],n=0,r=i.length;r>n;n++)t.push(g.createFromDiffResult(this.shouldIgnoreTrimWhitespace,i[n],this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return t}for(var o=[],a=0,h=0,n=-1,s=i.length;s>n;n++){for(var d=s>n+1?i[n+1]:null,m=d?d.originalStart:this.originalLines.length,l=d?d.modifiedStart:this.modifiedLines.length;m>a&&l>h;){var f=this.originalLines[a],c=this.modifiedLines[h];if(f!==c){for(var C=u._getFirstNonBlankColumn(f,1),L=u._getFirstNonBlankColumn(c,1);C>1&&L>1;){var p=f.charCodeAt(C-2),S=c.charCodeAt(L-2);if(p!==S)break;C--,L--}(C>1||L>1)&&this._pushTrimWhitespaceCharChange(o,a+1,1,C,h+1,1,L);for(var N=u._getLastNonBlankColumn(f,1),b=u._getLastNonBlankColumn(c,1),_=f.length+1,E=c.length+1;_>N&&E>b;){var p=f.charCodeAt(N-1),S=f.charCodeAt(b-1);if(p!==S)break;N++,b++}(_>N||E>b)&&this._pushTrimWhitespaceCharChange(o,a+1,N,_,h+1,b,E)}a++,h++}d&&(o.push(g.createFromDiffResult(this.shouldIgnoreTrimWhitespace,d,this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),a+=d.originalLength,h+=d.modifiedLength)}return o},i.prototype._pushTrimWhitespaceCharChange=function(i,t,e,n,r,o,a){if(!this._mergeTrimWhitespaceCharChange(i,t,e,n,r,o,a)){var h=void 0;this.shouldComputeCharChanges&&(h=[new m(t,e,t,n,r,o,r,a)]),i.push(new g(t,t,r,r,h))}},i.prototype._mergeTrimWhitespaceCharChange=function(i,t,e,n,r,o,a){var h=i.length;if(0===h)return!1;var s=i[h-1];return 0===s.originalEndLineNumber||0===s.modifiedEndLineNumber?!1:s.originalEndLineNumber+1===t&&s.modifiedEndLineNumber+1===r?(s.originalEndLineNumber=t,s.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&s.charChanges.push(new m(t,e,t,n,r,o,r,a)),!0):!1},i.prototype._continueProcessingPredicate=function(){if(0===this.maximumRunTimeMs)return!0;var i=(new Date).getTime();return i-this.computationStartTime<this.maximumRunTimeMs},i}();t.DiffComputer=l});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/range.js*/
define("4661130",function(n,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=n("5ddf902"),r=function(){function n(n,e,t,r){n>t||n===t&&e>r?(this.startLineNumber=t,this.startColumn=r,this.endLineNumber=n,this.endColumn=e):(this.startLineNumber=n,this.startColumn=e,this.endLineNumber=t,this.endColumn=r)}return n.prototype.isEmpty=function(){return n.isEmpty(this)},n.isEmpty=function(n){return n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn},n.prototype.containsPosition=function(e){return n.containsPosition(this,e)},n.containsPosition=function(n,e){return e.lineNumber<n.startLineNumber||e.lineNumber>n.endLineNumber?!1:e.lineNumber===n.startLineNumber&&e.column<n.startColumn?!1:e.lineNumber===n.endLineNumber&&e.column>n.endColumn?!1:!0},n.prototype.containsRange=function(e){return n.containsRange(this,e)},n.containsRange=function(n,e){return e.startLineNumber<n.startLineNumber||e.endLineNumber<n.startLineNumber?!1:e.startLineNumber>n.endLineNumber||e.endLineNumber>n.endLineNumber?!1:e.startLineNumber===n.startLineNumber&&e.startColumn<n.startColumn?!1:e.endLineNumber===n.endLineNumber&&e.endColumn>n.endColumn?!1:!0},n.prototype.plusRange=function(e){return n.plusRange(this,e)},n.plusRange=function(e,t){var r,u,i,m;return t.startLineNumber<e.startLineNumber?(r=t.startLineNumber,u=t.startColumn):t.startLineNumber===e.startLineNumber?(r=t.startLineNumber,u=Math.min(t.startColumn,e.startColumn)):(r=e.startLineNumber,u=e.startColumn),t.endLineNumber>e.endLineNumber?(i=t.endLineNumber,m=t.endColumn):t.endLineNumber===e.endLineNumber?(i=t.endLineNumber,m=Math.max(t.endColumn,e.endColumn)):(i=e.endLineNumber,m=e.endColumn),new n(r,u,i,m)},n.prototype.intersectRanges=function(e){return n.intersectRanges(this,e)},n.intersectRanges=function(e,t){var r=e.startLineNumber,u=e.startColumn,i=e.endLineNumber,m=e.endColumn,o=t.startLineNumber,s=t.startColumn,a=t.endLineNumber,b=t.endColumn;return o>r?(r=o,u=s):r===o&&(u=Math.max(u,s)),i>a?(i=a,m=b):i===a&&(m=Math.min(m,b)),r>i?null:r===i&&u>m?null:new n(r,u,i,m)},n.prototype.equalsRange=function(e){return n.equalsRange(this,e)},n.equalsRange=function(n,e){return!!n&&!!e&&n.startLineNumber===e.startLineNumber&&n.startColumn===e.startColumn&&n.endLineNumber===e.endLineNumber&&n.endColumn===e.endColumn},n.prototype.getEndPosition=function(){return new t.Position(this.endLineNumber,this.endColumn)},n.prototype.getStartPosition=function(){return new t.Position(this.startLineNumber,this.startColumn)},n.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},n.prototype.setEndPosition=function(e,t){return new n(this.startLineNumber,this.startColumn,e,t)},n.prototype.setStartPosition=function(e,t){return new n(e,t,this.endLineNumber,this.endColumn)},n.prototype.collapseToStart=function(){return n.collapseToStart(this)},n.collapseToStart=function(e){return new n(e.startLineNumber,e.startColumn,e.startLineNumber,e.startColumn)},n.fromPositions=function(e,t){return void 0===t&&(t=e),new n(e.lineNumber,e.column,t.lineNumber,t.column)},n.lift=function(e){return e?new n(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn):null},n.isIRange=function(n){return n&&"number"==typeof n.startLineNumber&&"number"==typeof n.startColumn&&"number"==typeof n.endLineNumber&&"number"==typeof n.endColumn},n.areIntersectingOrTouching=function(n,e){return n.endLineNumber<e.startLineNumber||n.endLineNumber===e.startLineNumber&&n.endColumn<e.startColumn?!1:e.endLineNumber<n.startLineNumber||e.endLineNumber===n.startLineNumber&&e.endColumn<n.startColumn?!1:!0},n.areIntersecting=function(n,e){return n.endLineNumber<e.startLineNumber||n.endLineNumber===e.startLineNumber&&n.endColumn<=e.startColumn?!1:e.endLineNumber<n.startLineNumber||e.endLineNumber===n.startLineNumber&&e.endColumn<=n.startColumn?!1:!0},n.compareRangesUsingStarts=function(n,e){if(n&&e){var t=0|n.startLineNumber,r=0|e.startLineNumber;if(t===r){var u=0|n.startColumn,i=0|e.startColumn;if(u===i){var m=0|n.endLineNumber,o=0|e.endLineNumber;if(m===o){var s=0|n.endColumn,a=0|e.endColumn;return s-a}return m-o}return u-i}return t-r}var b=n?1:0,N=e?1:0;return b-N},n.compareRangesUsingEnds=function(n,e){return n.endLineNumber===e.endLineNumber?n.endColumn===e.endColumn?n.startLineNumber===e.startLineNumber?n.startColumn-e.startColumn:n.startLineNumber-e.startLineNumber:n.endColumn-e.endColumn:n.endLineNumber-e.endLineNumber},n.spansMultipleLines=function(n){return n.endLineNumber>n.startLineNumber},n}();e.Range=r});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/position.js*/
define("5ddf902",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var u=function(){function e(e,n){this.lineNumber=e,this.column=n}return e.prototype.with=function(n,u){return void 0===n&&(n=this.lineNumber),void 0===u&&(u=this.column),n===this.lineNumber&&u===this.column?this:new e(n,u)},e.prototype.delta=function(e,n){return void 0===e&&(e=0),void 0===n&&(n=0),this.with(this.lineNumber+e,this.column+n)},e.prototype.equals=function(n){return e.equals(this,n)},e.equals=function(e,n){return e||n?!!e&&!!n&&e.lineNumber===n.lineNumber&&e.column===n.column:!0},e.prototype.isBefore=function(n){return e.isBefore(this,n)},e.isBefore=function(e,n){return e.lineNumber<n.lineNumber?!0:n.lineNumber<e.lineNumber?!1:e.column<n.column},e.prototype.isBeforeOrEqual=function(n){return e.isBeforeOrEqual(this,n)},e.isBeforeOrEqual=function(e,n){return e.lineNumber<n.lineNumber?!0:n.lineNumber<e.lineNumber?!1:e.column<=n.column},e.compare=function(e,n){var u=0|e.lineNumber,i=0|n.lineNumber;if(u===i){var r=0|e.column,t=0|n.column;return r-t}return u-i},e.prototype.clone=function(){return new e(this.lineNumber,this.column)},e.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},e.lift=function(n){return new e(n.lineNumber,n.column)},e.isIPosition=function(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column},e}();n.Position=u});
/**! node_modules/monaco-editor/esm/vs/base/common/uri.js*/
define("50db2b4",function(t,e){"use strict";function r(t,e){if(!t.scheme){if(e||y)throw new Error('[UriError]: Scheme is missing: {scheme: "", authority: "'+t.authority+'", path: "'+t.path+'", query: "'+t.query+'", fragment: "'+t.fragment+'"}');console.warn('[UriError]: Scheme is missing: {scheme: "", authority: "'+t.authority+'", path: "'+t.path+'", query: "'+t.query+'", fragment: "'+t.fragment+'"}')}if(t.scheme&&!p.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path)if(t.authority){if(!m.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(d.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}function n(t,e){return e||y?t||l:(t||(console.trace("BAD uri lacks scheme, falling back to file-scheme."),t="file"),t)}function i(t,e){switch(t){case"https":case"http":case"file":e?e[0]!==g&&(e=g+e):e=g}return e}function o(t,e){for(var r=void 0,n=-1,i=0;i<t.length;i++){var o=t.charCodeAt(i);if(o>=97&&122>=o||o>=65&&90>=o||o>=48&&57>=o||45===o||46===o||95===o||126===o||e&&47===o)-1!==n&&(r+=encodeURIComponent(t.substring(n,i)),n=-1),void 0!==r&&(r+=t.charAt(i));else{void 0===r&&(r=t.substr(0,i));var h=C[o];void 0!==h?(-1!==n&&(r+=encodeURIComponent(t.substring(n,i)),n=-1),r+=h):-1===n&&(n=i)}}return-1!==n&&(r+=encodeURIComponent(t.substring(n))),void 0!==r?r:t}function h(t){for(var e=void 0,r=0;r<t.length;r++){var n=t.charCodeAt(r);35===n||63===n?(void 0===e&&(e=t.substr(0,r)),e+=C[n]):void 0!==e&&(e+=t[r])}return void 0!==e?e:t}function s(t){var e;return e=t.authority&&t.path.length>1&&"file"===t.scheme?"//"+t.authority+t.path:47===t.path.charCodeAt(0)&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&58===t.path.charCodeAt(2)?t.path[1].toLowerCase()+t.path.substr(2):t.path,c.isWindows&&(e=e.replace(/\//g,"\\")),e}function a(t,e){var r=e?h:o,n="",i=t.scheme,s=t.authority,a=t.path,u=t.query,f=t.fragment;if(i&&(n+=i,n+=":"),(s||"file"===i)&&(n+=g,n+=g),s){var c=s.indexOf("@");if(-1!==c){var p=s.substr(0,c);s=s.substr(c+1),c=p.indexOf(":"),-1===c?n+=r(p,!1):(n+=r(p.substr(0,c),!1),n+=":",n+=r(p.substr(c+1),!1)),n+="@"}s=s.toLowerCase(),c=s.indexOf(":"),-1===c?n+=r(s,!1):(n+=r(s.substr(0,c),!1),n+=s.substr(c))}if(a){if(a.length>=3&&47===a.charCodeAt(0)&&58===a.charCodeAt(2)){var m=a.charCodeAt(1);m>=65&&90>=m&&(a="/"+String.fromCharCode(m+32)+":"+a.substr(3))}else if(a.length>=2&&58===a.charCodeAt(1)){var m=a.charCodeAt(0);m>=65&&90>=m&&(a=String.fromCharCode(m+32)+":"+a.substr(2))}n+=r(a,!0)}return u&&(n+="?",n+=r(u,!1)),f&&(n+="#",n+=e?f:o(f,!1)),n}Object.defineProperty(e,"__esModule",{value:!0});var u,f=this&&this.__extends||function(){var t=function(e,r){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])})(e,r)};return function(e,r){function n(){this.constructor=e}t(e,r),e.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}(),c=t("17c8d25"),p=/^\w[\w\d+.-]*$/,m=/^\//,d=/^\/\//,y=!0,l="",g="/",v=/^(([^:\/?#]+?):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,b=function(){function t(t,e,o,h,s,a){void 0===a&&(a=!1),"object"==typeof t?(this.scheme=t.scheme||l,this.authority=t.authority||l,this.path=t.path||l,this.query=t.query||l,this.fragment=t.fragment||l):(this.scheme=n(t,a),this.authority=e||l,this.path=i(this.scheme,o||l),this.query=h||l,this.fragment=s||l,r(this,a))}return t.isUri=function(e){return e instanceof t?!0:e?"string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme&&"function"==typeof e.fsPath&&"function"==typeof e.with&&"function"==typeof e.toString:!1},Object.defineProperty(t.prototype,"fsPath",{get:function(){return s(this)},enumerable:!0,configurable:!0}),t.prototype.with=function(t){if(!t)return this;var e=t.scheme,r=t.authority,n=t.path,i=t.query,o=t.fragment;return void 0===e?e=this.scheme:null===e&&(e=l),void 0===r?r=this.authority:null===r&&(r=l),void 0===n?n=this.path:null===n&&(n=l),void 0===i?i=this.query:null===i&&(i=l),void 0===o?o=this.fragment:null===o&&(o=l),e===this.scheme&&r===this.authority&&n===this.path&&i===this.query&&o===this.fragment?this:new w(e,r,n,i,o)},t.parse=function(t,e){void 0===e&&(e=!1);var r=v.exec(t);return r?new w(r[2]||l,decodeURIComponent(r[4]||l),decodeURIComponent(r[5]||l),decodeURIComponent(r[7]||l),decodeURIComponent(r[9]||l),e):new w(l,l,l,l,l)},t.file=function(t){var e=l;if(c.isWindows&&(t=t.replace(/\\/g,g)),t[0]===g&&t[1]===g){var r=t.indexOf(g,2);-1===r?(e=t.substring(2),t=g):(e=t.substring(2,r),t=t.substring(r)||g)}return new w("file",e,t,l,l)},t.from=function(t){return new w(t.scheme,t.authority,t.path,t.query,t.fragment)},t.prototype.toString=function(t){return void 0===t&&(t=!1),a(this,t)},t.prototype.toJSON=function(){return this},t.revive=function(e){if(e){if(e instanceof t)return e;var r=new w(e);return r._fsPath=e.fsPath,r._formatted=e.external,r}return e},t}();e.URI=b;var w=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e._formatted=null,e._fsPath=null,e}return f(e,t),Object.defineProperty(e.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=s(this)),this._fsPath},enumerable:!0,configurable:!0}),e.prototype.toString=function(t){return void 0===t&&(t=!1),t?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)},e.prototype.toJSON=function(){var t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t},e}(b),C=(u={},u[58]="%3A",u[47]="%2F",u[63]="%3F",u[35]="%23",u[91]="%5B",u[93]="%5D",u[64]="%40",u[33]="%21",u[36]="%24",u[38]="%26",u[39]="%27",u[40]="%28",u[41]="%29",u[42]="%2A",u[43]="%2B",u[44]="%2C",u[59]="%3B",u[61]="%3D",u[32]="%20",u)});
/**! node_modules/monaco-editor/esm/vs/base/common/platform.js*/
define("17c8d25",function(e,i){"use strict";function a(e){return null===c&&(c=i.globals.setImmediate?i.globals.setImmediate.bind(i.globals):i.globals.setTimeout.bind(i.globals)),c(e)}Object.defineProperty(i,"__esModule",{value:!0});var t="en",o=!1,s=!1,l=!1,n=!1,b=!1,d=void 0,g=t,r=!1;if("object"!=typeof navigator||r);else{var f=navigator.userAgent;o=f.indexOf("Windows")>=0,s=f.indexOf("Macintosh")>=0,l=f.indexOf("Linux")>=0,b=!0,d=navigator.language,g=d}var u=0;n&&(s?u=1:o?u=3:l&&(u=2)),i.isWindows=o,i.isMacintosh=s,i.isLinux=l,i.isNative=n,i.isWeb=b;var v="object"==typeof self?self:"object"==typeof global?global:{};i.globals=v;var c=null;i.setImmediate=a,i.OS=s?2:o?1:3});
/**! node_modules/monaco-editor/esm/vs/base/common/iterator.js*/
define("6ad26fe",function(t,n){"use strict";function r(t){return Array.isArray(t)?n.Iterator.fromArray(t):t}Object.defineProperty(n,"__esModule",{value:!0});var e=this&&this.__extends||function(){var t=function(n,r){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,n){t.__proto__=n}||function(t,n){for(var r in n)n.hasOwnProperty(r)&&(t[r]=n[r])})(n,r)};return function(n,r){function e(){this.constructor=n}t(n,r),n.prototype=null===r?Object.create(r):(e.prototype=r.prototype,new e)}}();n.FIN={done:!0,value:void 0},function(t){function r(){return s}function e(t,r,e){return void 0===r&&(r=0),void 0===e&&(e=t.length),{next:function(){return r>=e?n.FIN:{done:!1,value:t[r++]}}}}function i(n){return n?Array.isArray(n)?t.fromArray(n):n:t.empty()}function o(t,r){return{next:function(){var e=t.next();return e.done?n.FIN:{done:!1,value:r(e.value)}}}}function u(t,r){return{next:function(){for(;;){var e=t.next();if(e.done)return n.FIN;if(r(e.value))return{done:!1,value:e.value}}}}}function a(t,n){for(var r=t.next();!r.done;r=t.next())n(r.value)}function c(t){var n=[];return a(t,function(t){return n.push(t)}),n}var s={next:function(){return n.FIN}};t.empty=r,t.fromArray=e,t.from=i,t.map=o,t.filter=u,t.forEach=a,t.collect=c}(n.Iterator||(n.Iterator={})),n.getSequenceIterator=r;var i=function(){function t(t,n,r,e){void 0===n&&(n=0),void 0===r&&(r=t.length),void 0===e&&(e=n-1),this.items=t,this.start=n,this.end=r,this.index=e}return t.prototype.next=function(){return this.index=Math.min(this.index+1,this.end),this.current()},t.prototype.current=function(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]},t}();n.ArrayIterator=i;var o=function(t){function n(n,r,e,i){return void 0===r&&(r=0),void 0===e&&(e=n.length),void 0===i&&(i=r-1),t.call(this,n,r,e,i)||this}return e(n,t),n.prototype.current=function(){return t.prototype.current.call(this)},n.prototype.previous=function(){return this.index=Math.max(this.index-1,this.start-1),this.current()},n.prototype.first=function(){return this.index=this.start,this.current()},n.prototype.last=function(){return this.index=this.end-1,this.current()},n.prototype.parent=function(){return null},n}(i);n.ArrayNavigator=o;var u=function(){function t(t,n){this.iterator=t,this.fn=n}return t.prototype.next=function(){return this.fn(this.iterator.next())},t}();n.MappedIterator=u});
/**! node_modules/monaco-editor/esm/vs/base/common/diff/diff.js*/
define("e1c5605",function(t,e){"use strict";function i(t){return{getLength:function(){return t.length},getElementAtIndex:function(e){return t.charCodeAt(e)}}}function n(t,e,n){return new d(i(t),i(e)).ComputeDiff(n)}Object.defineProperty(e,"__esModule",{value:!0});var r=t("a895ddf");e.stringDiff=n;var o=function(){function t(){}return t.Assert=function(t,e){if(!t)throw new Error(e)},t}();e.Debug=o;var a=function(){function t(){}return t.Copy=function(t,e,i,n,r){for(var o=0;r>o;o++)i[n+o]=t[e+o]},t}();e.MyArray=a;var h=1447,s=function(){function t(){this.m_changes=[],this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE,this.m_originalCount=0,this.m_modifiedCount=0}return t.prototype.MarkNextChange=function(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new r.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE},t.prototype.AddOriginalElement=function(t,e){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_originalCount++},t.prototype.AddModifiedElement=function(t,e){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_modifiedCount++},t.prototype.getChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes},t.prototype.getReverseChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes},t}(),d=function(){function t(t,e,i){void 0===i&&(i=null),this.OriginalSequence=t,this.ModifiedSequence=e,this.ContinueProcessingPredicate=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}return t.prototype.ElementsAreEqual=function(t,e){return this.OriginalSequence.getElementAtIndex(t)===this.ModifiedSequence.getElementAtIndex(e)},t.prototype.OriginalElementsAreEqual=function(t,e){return this.OriginalSequence.getElementAtIndex(t)===this.OriginalSequence.getElementAtIndex(e)},t.prototype.ModifiedElementsAreEqual=function(t,e){return this.ModifiedSequence.getElementAtIndex(t)===this.ModifiedSequence.getElementAtIndex(e)},t.prototype.ComputeDiff=function(t){return this._ComputeDiff(0,this.OriginalSequence.getLength()-1,0,this.ModifiedSequence.getLength()-1,t)},t.prototype._ComputeDiff=function(t,e,i,n,r){var o=[!1],a=this.ComputeDiffRecursive(t,e,i,n,o);return r?this.PrettifyChanges(a):a},t.prototype.ComputeDiffRecursive=function(t,e,i,n,a){for(a[0]=!1;e>=t&&n>=i&&this.ElementsAreEqual(t,i);)t++,i++;for(;e>=t&&n>=i&&this.ElementsAreEqual(e,n);)e--,n--;if(t>e||i>n){var h=void 0;return n>=i?(o.Assert(t===e+1,"originalStart should only be one more than originalEnd"),h=[new r.DiffChange(t,0,i,n-i+1)]):e>=t?(o.Assert(i===n+1,"modifiedStart should only be one more than modifiedEnd"),h=[new r.DiffChange(t,e-t+1,i,0)]):(o.Assert(t===e+1,"originalStart should only be one more than originalEnd"),o.Assert(i===n+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}var s=[0],d=[0],g=this.ComputeRecursionPoint(t,e,i,n,s,d,a),f=s[0],u=d[0];if(null!==g)return g;if(!a[0]){var l=this.ComputeDiffRecursive(t,f,i,u,a),m=[];return m=a[0]?[new r.DiffChange(f+1,e-(f+1)+1,u+1,n-(u+1)+1)]:this.ComputeDiffRecursive(f+1,e,u+1,n,a),this.ConcatenateChanges(l,m)}return[new r.DiffChange(t,e-t+1,i,n-i+1)]},t.prototype.WALKTRACE=function(t,e,i,n,o,a,h,d,g,f,u,l,m,c,p,C,y,S){var _,A=null,v=null,E=new s,L=e,M=i,q=m[0]-C[0]-n,O=Number.MIN_VALUE,w=this.m_forwardHistory.length-1;do _=q+t,_===L||M>_&&g[_-1]<g[_+1]?(u=g[_+1],c=u-q-n,O>u&&E.MarkNextChange(),O=u,E.AddModifiedElement(u+1,c),q=_+1-t):(u=g[_-1]+1,c=u-q-n,O>u&&E.MarkNextChange(),O=u-1,E.AddOriginalElement(u,c+1),q=_-1-t),w>=0&&(g=this.m_forwardHistory[w],t=g[0],L=1,M=g.length-1);while(--w>=-1);if(A=E.getReverseChanges(),S[0]){var D=m[0]+1,I=C[0]+1;if(null!==A&&A.length>0){var b=A[A.length-1];D=Math.max(D,b.getOriginalEnd()),I=Math.max(I,b.getModifiedEnd())}v=[new r.DiffChange(D,l-D+1,I,p-I+1)]}else{E=new s,L=a,M=h,q=m[0]-C[0]-d,O=Number.MAX_VALUE,w=y?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do _=q+o,_===L||M>_&&f[_-1]>=f[_+1]?(u=f[_+1]-1,c=u-q-d,u>O&&E.MarkNextChange(),O=u+1,E.AddOriginalElement(u+1,c+1),q=_+1-o):(u=f[_-1],c=u-q-d,u>O&&E.MarkNextChange(),O=u,E.AddModifiedElement(u+1,c+1),q=_-1-o),w>=0&&(f=this.m_reverseHistory[w],o=f[0],L=1,M=f.length-1);while(--w>=-1);v=E.getChanges()}return this.ConcatenateChanges(A,v)},t.prototype.ComputeRecursionPoint=function(t,e,i,n,o,s,d){var g,f=0,u=0,l=0,m=0,c=0,p=0;t--,i--,o[0]=0,s[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];var C=e-t+(n-i),y=C+1,S=new Array(y),_=new Array(y),A=n-i,v=e-t,E=t-i,L=e-n,M=v-A,q=M%2===0;S[A]=t,_[v]=e,d[0]=!1;var O,w;for(g=1;C/2+1>=g;g++){var D=0,I=0;for(l=this.ClipDiagonalBound(A-g,g,A,y),m=this.ClipDiagonalBound(A+g,g,A,y),O=l;m>=O;O+=2){for(f=O===l||m>O&&S[O-1]<S[O+1]?S[O+1]:S[O-1]+1,u=f-(O-A)-E,w=f;e>f&&n>u&&this.ElementsAreEqual(f+1,u+1);)f++,u++;if(S[O]=f,f+u>D+I&&(D=f,I=u),!q&&Math.abs(O-v)<=g-1&&f>=_[O])return o[0]=f,s[0]=u,w<=_[O]&&h>0&&h+1>=g?this.WALKTRACE(A,l,m,E,v,c,p,L,S,_,f,e,o,u,n,s,q,d):null}var b=(D-t+(I-i)-g)/2;if(null!==this.ContinueProcessingPredicate&&!this.ContinueProcessingPredicate(D,this.OriginalSequence,b))return d[0]=!0,o[0]=D,s[0]=I,b>0&&h>0&&h+1>=g?this.WALKTRACE(A,l,m,E,v,c,p,L,S,_,f,e,o,u,n,s,q,d):(t++,i++,[new r.DiffChange(t,e-t+1,i,n-i+1)]);for(c=this.ClipDiagonalBound(v-g,g,v,y),p=this.ClipDiagonalBound(v+g,g,v,y),O=c;p>=O;O+=2){for(f=O===c||p>O&&_[O-1]>=_[O+1]?_[O+1]-1:_[O-1],u=f-(O-v)-L,w=f;f>t&&u>i&&this.ElementsAreEqual(f,u);)f--,u--;if(_[O]=f,q&&Math.abs(O-A)<=g&&f<=S[O])return o[0]=f,s[0]=u,w>=S[O]&&h>0&&h+1>=g?this.WALKTRACE(A,l,m,E,v,c,p,L,S,_,f,e,o,u,n,s,q,d):null}if(h>=g){var B=new Array(m-l+2);B[0]=A-l+1,a.Copy(S,l,B,1,m-l+1),this.m_forwardHistory.push(B),B=new Array(p-c+2),B[0]=v-c+1,a.Copy(_,c,B,1,p-c+1),this.m_reverseHistory.push(B)}}return this.WALKTRACE(A,l,m,E,v,c,p,L,S,_,f,e,o,u,n,s,q,d)},t.prototype.PrettifyChanges=function(t){for(var e=0;e<t.length;e++){for(var i=t[e],n=e<t.length-1?t[e+1].originalStart:this.OriginalSequence.getLength(),r=e<t.length-1?t[e+1].modifiedStart:this.ModifiedSequence.getLength(),o=i.originalLength>0,a=i.modifiedLength>0;i.originalStart+i.originalLength<n&&i.modifiedStart+i.modifiedLength<r&&(!o||this.OriginalElementsAreEqual(i.originalStart,i.originalStart+i.originalLength))&&(!a||this.ModifiedElementsAreEqual(i.modifiedStart,i.modifiedStart+i.modifiedLength));)i.originalStart++,i.modifiedStart++;var h=[null];e<t.length-1&&this.ChangesOverlap(t[e],t[e+1],h)&&(t[e]=h[0],t.splice(e+1,1),e--)}for(var e=t.length-1;e>=0;e--){var i=t[e],n=0,r=0;if(e>0){var s=t[e-1];s.originalLength>0&&(n=s.originalStart+s.originalLength),s.modifiedLength>0&&(r=s.modifiedStart+s.modifiedLength)}for(var o=i.originalLength>0,a=i.modifiedLength>0,d=0,g=this._boundaryScore(i.originalStart,i.originalLength,i.modifiedStart,i.modifiedLength),f=1;;f++){var u=i.originalStart-f,l=i.modifiedStart-f;if(n>u||r>l)break;if(o&&!this.OriginalElementsAreEqual(u,u+i.originalLength))break;if(a&&!this.ModifiedElementsAreEqual(l,l+i.modifiedLength))break;var m=this._boundaryScore(u,i.originalLength,l,i.modifiedLength);m>g&&(g=m,d=f)}i.originalStart-=d,i.modifiedStart-=d}return t},t.prototype._OriginalIsBoundary=function(t){if(0>=t||t>=this.OriginalSequence.getLength()-1)return!0;var e=this.OriginalSequence.getElementAtIndex(t);return"string"==typeof e&&/^\s*$/.test(e)},t.prototype._OriginalRegionIsBoundary=function(t,e){if(this._OriginalIsBoundary(t)||this._OriginalIsBoundary(t-1))return!0;if(e>0){var i=t+e;if(this._OriginalIsBoundary(i-1)||this._OriginalIsBoundary(i))return!0}return!1},t.prototype._ModifiedIsBoundary=function(t){if(0>=t||t>=this.ModifiedSequence.getLength()-1)return!0;var e=this.ModifiedSequence.getElementAtIndex(t);return"string"==typeof e&&/^\s*$/.test(e)},t.prototype._ModifiedRegionIsBoundary=function(t,e){if(this._ModifiedIsBoundary(t)||this._ModifiedIsBoundary(t-1))return!0;if(e>0){var i=t+e;if(this._ModifiedIsBoundary(i-1)||this._ModifiedIsBoundary(i))return!0}return!1},t.prototype._boundaryScore=function(t,e,i,n){var r=this._OriginalRegionIsBoundary(t,e)?1:0,o=this._ModifiedRegionIsBoundary(i,n)?1:0;return r+o},t.prototype.ConcatenateChanges=function(t,e){var i=[];if(0===t.length||0===e.length)return e.length>0?e:t;if(this.ChangesOverlap(t[t.length-1],e[0],i)){var n=new Array(t.length+e.length-1);return a.Copy(t,0,n,0,t.length-1),n[t.length-1]=i[0],a.Copy(e,1,n,t.length,e.length-1),n}var n=new Array(t.length+e.length);return a.Copy(t,0,n,0,t.length),a.Copy(e,0,n,t.length,e.length),n},t.prototype.ChangesOverlap=function(t,e,i){if(o.Assert(t.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),o.Assert(t.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),t.originalStart+t.originalLength>=e.originalStart||t.modifiedStart+t.modifiedLength>=e.modifiedStart){var n=t.originalStart,a=t.originalLength,h=t.modifiedStart,s=t.modifiedLength;return t.originalStart+t.originalLength>=e.originalStart&&(a=e.originalStart+e.originalLength-t.originalStart),t.modifiedStart+t.modifiedLength>=e.modifiedStart&&(s=e.modifiedStart+e.modifiedLength-t.modifiedStart),i[0]=new r.DiffChange(n,a,h,s),!0}return i[0]=null,!1},t.prototype.ClipDiagonalBound=function(t,e,i,n){if(t>=0&&n>t)return t;var r=i,o=n-i-1,a=e%2===0;if(0>t){var h=r%2===0;return a===h?0:1}var s=o%2===0;return a===s?n-1:n-2},t}();e.LcsDiff=d});
/**! node_modules/monaco-editor/esm/vs/base/common/arrays.js*/
define("2e30c88",function(r,n){"use strict";function t(r,n){return void 0===n&&(n=0),r[r.length-(1+n)]}function e(r){if(0===r.length)throw new Error("Invalid tail call");return[r.slice(0,r.length-1),r[r.length-1]]}function i(r,n,t){if(void 0===t&&(t=function(r,n){return r===n}),r===n)return!0;if(!r||!n)return!1;if(r.length!==n.length)return!1;for(var e=0,i=r.length;i>e;e++)if(!t(r[e],n[e]))return!1;return!0}function u(r,n,t){for(var e=0,i=r.length-1;i>=e;){var u=(e+i)/2|0,f=t(r[u],n);if(0>f)e=u+1;else{if(!(f>0))return u;i=u-1}}return-(e+1)}function f(r,n){var t=0,e=r.length;if(0===e)return 0;for(;e>t;){var i=Math.floor((t+e)/2);n(r[i])?e=i:t=i+1}return t}function o(r,n){return c(r,n,0,r.length-1,[]),r}function a(r,n,t,e,i,u){for(var f=t,o=e+1,a=t;i>=a;a++)u[a]=r[a];for(var a=t;i>=a;a++)r[a]=f>e?u[o++]:o>i?u[f++]:n(u[o],u[f])<0?u[o++]:u[f++]}function c(r,n,t,e,i){if(!(t>=e)){var u=t+(e-t)/2|0;c(r,n,t,u,i),c(r,n,u+1,e,i),n(r[u],r[u+1])<=0||a(r,n,t,u,e,i)}}function l(r,n){for(var t=[],e=void 0,i=0,u=o(r.slice(0),n);i<u.length;i++){var f=u[i];e&&0===n(e[0],f)?e.push(f):(e=[f],t.push(e))}return t}function s(r){return r?r.filter(function(r){return!!r}):r}function v(r){return!Array.isArray(r)||0===r.length}function h(r){return Array.isArray(r)&&r.length>0}function d(r,n){if(!n)return r.filter(function(n,t){return r.indexOf(n)===t});var t=Object.create(null);return r.filter(function(r){var e=n(r);return t[e]?!1:(t[e]=!0,!0)})}function y(r){var n=new Set;return r.filter(function(r){return n.has(r)?!1:(n.add(r),!0)})}function g(r,n){for(var t=0;t<r.length;t++){var e=r[t];if(n(e))return t}return-1}function p(r,n,t){void 0===t&&(t=void 0);var e=g(r,n);return 0>e?t:r[e]}function A(r){var n;return(n=[]).concat.apply(n,r)}function m(r,n){var t="number"==typeof n?r:0;"number"==typeof n?t=r:(t=0,n=r);var e=[];if(n>=t)for(var i=t;n>i;i++)e.push(i);else for(var i=t;i>n;i--)e.push(i);return e}function O(r,n,t){var e=r.slice(0,n),i=r.slice(n);return e.concat(t,i)}function S(r,n){var t=r.indexOf(n);t>-1&&(r.splice(t,1),r.unshift(n))}function b(r,n){var t=r.indexOf(n);t>-1&&(r.splice(t,1),r.push(n))}function E(r){return Array.isArray(r)?r:[r]}Object.defineProperty(n,"__esModule",{value:!0}),n.tail=t,n.tail2=e,n.equals=i,n.binarySearch=u,n.findFirstInSorted=f,n.mergeSort=o,n.groupBy=l,n.coalesce=s,n.isFalsyOrEmpty=v,n.isNonEmptyArray=h,n.distinct=d,n.distinctES6=y,n.firstIndex=g,n.first=p,n.flatten=A,n.range=m,n.arrayInsert=O,n.pushToStart=S,n.pushToEnd=b,n.asArray=E});
/**! node_modules/monaco-editor/esm/vs/base/common/types.js*/
define("01fef85",function(n,t){"use strict";function r(n){return Array.isArray?Array.isArray(n):n&&typeof n.length===b.number&&n.constructor===Array?!0:!1}function e(n){return typeof n===b.string||n instanceof String?!0:!1}function o(n){return!(typeof n!==b.object||null===n||Array.isArray(n)||n instanceof RegExp||n instanceof Date)}function i(n){return(typeof n===b.number||n instanceof Number)&&!isNaN(n)?!0:!1}function u(n){return n===!0||n===!1}function f(n){return typeof n===b.undefined}function c(n){return f(n)||null===n}function a(n){if(!o(n))return!1;for(var t in n)if(m.call(n,t))return!1;return!0}function s(n){return typeof n===b.function}function l(n,t){for(var r=Math.min(n.length,t.length),e=0;r>e;e++)y(n[e],t[e])}function y(n,t){if(e(t)){if(typeof n!==t)throw new Error("argument does not match constraint: typeof "+t)}else if(s(t)){try{if(n instanceof t)return}catch(r){}if(!c(n)&&n.constructor===t)return;if(1===t.length&&t.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function d(n){for(var t=[],r=Object.getPrototypeOf(n);Object.prototype!==r;)t=t.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return t}function p(n){return null===n?void 0:n}function g(n){return"undefined"==typeof n?null:n}Object.defineProperty(t,"__esModule",{value:!0});var b={number:"number",string:"string",undefined:"undefined",object:"object","function":"function"};t.isArray=r,t.isString=e,t.isObject=o,t.isNumber=i,t.isBoolean=u,t.isUndefined=f,t.isUndefinedOrNull=c;var m=Object.prototype.hasOwnProperty;t.isEmptyObject=a,t.isFunction=s,t.validateConstraints=l,t.validateConstraint=y,t.getAllPropertyNames=d,t.withNullAsUndefined=p,t.withUndefinedAsNull=g});
/**! node_modules/monaco-editor/esm/vs/base/common/platform.js*/
define("17c8d25",function(e,i){"use strict";function a(e){return null===c&&(c=i.globals.setImmediate?i.globals.setImmediate.bind(i.globals):i.globals.setTimeout.bind(i.globals)),c(e)}Object.defineProperty(i,"__esModule",{value:!0});var t="en",o=!1,s=!1,l=!1,n=!1,b=!1,d=void 0,g=t,r=!1;if("object"!=typeof navigator||r);else{var f=navigator.userAgent;o=f.indexOf("Windows")>=0,s=f.indexOf("Macintosh")>=0,l=f.indexOf("Linux")>=0,b=!0,d=navigator.language,g=d}var u=0;n&&(s?u=1:o?u=3:l&&(u=2)),i.isWindows=o,i.isMacintosh=s,i.isLinux=l,i.isNative=n,i.isWeb=b;var v="object"==typeof self?self:"object"==typeof global?global:{};i.globals=v;var c=null;i.setImmediate=a,i.OS=s?2:o?1:3});
/**! node_modules/monaco-editor/esm/vs/base/common/lifecycle.js*/
define("a0b8cca",function(e,s){"use strict";function i(e){return"function"==typeof e.dispose&&0===e.dispose.length}function o(e){for(var s=[],i=1;i<arguments.length;i++)s[i-1]=arguments[i];return Array.isArray(e)?(e.forEach(function(e){return e&&e.dispose()}),[]):0===s.length?e?(e.dispose(),e):void 0:(o(e),o(s),[])}function t(e){return{dispose:function(){return o(e)}}}function n(e){return{dispose:function(){e()}}}Object.defineProperty(s,"__esModule",{value:!0}),s.isDisposable=i,s.dispose=o,s.combinedDisposable=t,s.toDisposable=n;var r=function(){function e(){this._toDispose=[],this._lifecycle_disposable_isDisposed=!1}return e.prototype.dispose=function(){this._lifecycle_disposable_isDisposed=!0,this._toDispose=o(this._toDispose)},e.prototype._register=function(e){return this._lifecycle_disposable_isDisposed?(console.warn("Registering disposable on object that has already been disposed."),e.dispose()):this._toDispose.push(e),e},e.None=Object.freeze({dispose:function(){}}),e}();s.Disposable=r;var p=function(){function e(e){this.object=e}return e.prototype.dispose=function(){},e}();s.ImmortalReference=p});
/**! node_modules/monaco-editor/esm/vs/base/common/errors.js*/
define("22e50b6",function(r,e){"use strict";function n(r){return void(a(r)||e.errorHandler.onUnexpectedError(r))}function t(r){return void(a(r)||e.errorHandler.onUnexpectedExternalError(r))}function o(r){if(r instanceof Error){var e=r.name,n=r.message,t=r.stacktrace||r.stack;return{$isError:!0,name:e,message:n,stack:t}}return r}function a(r){return r instanceof Error&&r.name===u&&r.message===u}function i(){var r=new Error(u);return r.name=r.message,r}function c(r){return new Error(r?"Illegal argument: "+r:"Illegal argument")}function s(r){return new Error(r?"Illegal state: "+r:"Illegal state")}Object.defineProperty(e,"__esModule",{value:!0});var l=function(){function r(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(function(){if(r.stack)throw new Error(r.message+"\n\n"+r.stack);throw r},0)}}return r.prototype.emit=function(r){this.listeners.forEach(function(e){e(r)})},r.prototype.onUnexpectedError=function(r){this.unexpectedErrorHandler(r),this.emit(r)},r.prototype.onUnexpectedExternalError=function(r){this.unexpectedErrorHandler(r)},r}();e.ErrorHandler=l,e.errorHandler=new l,e.onUnexpectedError=n,e.onUnexpectedExternalError=t,e.transformErrorForSerialization=o;var u="Canceled";e.isPromiseCanceledError=a,e.canceled=i,e.illegalArgument=c,e.illegalState=s});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-languageserver-types/main.js*/
define("737c70e",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),function(e){function n(e,n){return{line:e,character:n}}function t(e){var n=e;return a.objectLiteral(n)&&a.number(n.line)&&a.number(n.character)}e.create=n,e.is=t}(n.Position||(n.Position={})),function(e){function t(e,t,i,r){if(a.number(e)&&a.number(t)&&a.number(i)&&a.number(r))return{start:n.Position.create(e,t),end:n.Position.create(i,r)};if(n.Position.is(e)&&n.Position.is(t))return{start:e,end:t};throw new Error("Range#create called with invalid arguments["+e+", "+t+", "+i+", "+r+"]")}function i(e){var t=e;return a.objectLiteral(t)&&n.Position.is(t.start)&&n.Position.is(t.end)}e.create=t,e.is=i}(n.Range||(n.Range={})),function(e){function t(e,n){return{uri:e,range:n}}function i(e){var t=e;return a.defined(t)&&n.Range.is(t.range)&&(a.string(t.uri)||a.undefined(t.uri))}e.create=t,e.is=i}(n.Location||(n.Location={})),function(e){function t(e,n,t,i){return{targetUri:e,targetRange:n,targetSelectionRange:t,originSelectionRange:i}}function i(e){var t=e;return a.defined(t)&&n.Range.is(t.targetRange)&&a.string(t.targetUri)&&(n.Range.is(t.targetSelectionRange)||a.undefined(t.targetSelectionRange))&&(n.Range.is(t.originSelectionRange)||a.undefined(t.originSelectionRange))}e.create=t,e.is=i}(n.LocationLink||(n.LocationLink={})),function(e){function n(e,n,t,i){return{red:e,green:n,blue:t,alpha:i}}function t(e){var n=e;return a.number(n.red)&&a.number(n.green)&&a.number(n.blue)&&a.number(n.alpha)}e.create=n,e.is=t}(n.Color||(n.Color={})),function(e){function t(e,n){return{range:e,color:n}}function i(e){var t=e;return n.Range.is(t.range)&&n.Color.is(t.color)}e.create=t,e.is=i}(n.ColorInformation||(n.ColorInformation={})),function(e){function t(e,n,t){return{label:e,textEdit:n,additionalTextEdits:t}}function i(e){var t=e;return a.string(t.label)&&(a.undefined(t.textEdit)||n.TextEdit.is(t))&&(a.undefined(t.additionalTextEdits)||a.typedArray(t.additionalTextEdits,n.TextEdit.is))}e.create=t,e.is=i}(n.ColorPresentation||(n.ColorPresentation={})),function(e){e.Comment="comment",e.Imports="imports",e.Region="region"}(n.FoldingRangeKind||(n.FoldingRangeKind={})),function(e){function n(e,n,t,i,r){var o={startLine:e,endLine:n};return a.defined(t)&&(o.startCharacter=t),a.defined(i)&&(o.endCharacter=i),a.defined(r)&&(o.kind=r),o}function t(e){var n=e;return a.number(n.startLine)&&a.number(n.startLine)&&(a.undefined(n.startCharacter)||a.number(n.startCharacter))&&(a.undefined(n.endCharacter)||a.number(n.endCharacter))&&(a.undefined(n.kind)||a.string(n.kind))}e.create=n,e.is=t}(n.FoldingRange||(n.FoldingRange={})),function(e){function t(e,n){return{location:e,message:n}}function i(e){var t=e;return a.defined(t)&&n.Location.is(t.location)&&a.string(t.message)}e.create=t,e.is=i}(n.DiagnosticRelatedInformation||(n.DiagnosticRelatedInformation={})),function(e){e.Error=1,e.Warning=2,e.Information=3,e.Hint=4}(n.DiagnosticSeverity||(n.DiagnosticSeverity={})),function(e){function t(e,n,t,i,r,o){var u={range:e,message:n};return a.defined(t)&&(u.severity=t),a.defined(i)&&(u.code=i),a.defined(r)&&(u.source=r),a.defined(o)&&(u.relatedInformation=o),u}function i(e){var t=e;return a.defined(t)&&n.Range.is(t.range)&&a.string(t.message)&&(a.number(t.severity)||a.undefined(t.severity))&&(a.number(t.code)||a.string(t.code)||a.undefined(t.code))&&(a.string(t.source)||a.undefined(t.source))&&(a.undefined(t.relatedInformation)||a.typedArray(t.relatedInformation,n.DiagnosticRelatedInformation.is))}e.create=t,e.is=i}(n.Diagnostic||(n.Diagnostic={})),function(e){function n(e,n){for(var t=[],i=2;i<arguments.length;i++)t[i-2]=arguments[i];var r={title:e,command:n};return a.defined(t)&&t.length>0&&(r.arguments=t),r}function t(e){var n=e;return a.defined(n)&&a.string(n.title)&&a.string(n.command)}e.create=n,e.is=t}(n.Command||(n.Command={})),function(e){function t(e,n){return{range:e,newText:n}}function i(e,n){return{range:{start:e,end:e},newText:n}}function r(e){return{range:e,newText:""}}function o(e){var t=e;return a.objectLiteral(t)&&a.string(t.newText)&&n.Range.is(t.range)}e.replace=t,e.insert=i,e.del=r,e.is=o}(n.TextEdit||(n.TextEdit={})),function(e){function t(e,n){return{textDocument:e,edits:n}}function i(e){var t=e;return a.defined(t)&&n.VersionedTextDocumentIdentifier.is(t.textDocument)&&Array.isArray(t.edits)}e.create=t,e.is=i}(n.TextDocumentEdit||(n.TextDocumentEdit={})),function(e){function n(e,n){var t={kind:"create",uri:e};return void 0===n||void 0===n.overwrite&&void 0===n.ignoreIfExists||(t.options=n),t}function t(e){var n=e;return n&&"create"===n.kind&&a.string(n.uri)&&(void 0===n.options||(void 0===n.options.overwrite||a.boolean(n.options.overwrite))&&(void 0===n.options.ignoreIfExists||a.boolean(n.options.ignoreIfExists)))}e.create=n,e.is=t}(n.CreateFile||(n.CreateFile={})),function(e){function n(e,n,t){var i={kind:"rename",oldUri:e,newUri:n};return void 0===t||void 0===t.overwrite&&void 0===t.ignoreIfExists||(i.options=t),i}function t(e){var n=e;return n&&"rename"===n.kind&&a.string(n.oldUri)&&a.string(n.newUri)&&(void 0===n.options||(void 0===n.options.overwrite||a.boolean(n.options.overwrite))&&(void 0===n.options.ignoreIfExists||a.boolean(n.options.ignoreIfExists)))}e.create=n,e.is=t}(n.RenameFile||(n.RenameFile={})),function(e){function n(e,n){var t={kind:"delete",uri:e};return void 0===n||void 0===n.recursive&&void 0===n.ignoreIfNotExists||(t.options=n),t}function t(e){var n=e;return n&&"delete"===n.kind&&a.string(n.uri)&&(void 0===n.options||(void 0===n.options.recursive||a.boolean(n.options.recursive))&&(void 0===n.options.ignoreIfNotExists||a.boolean(n.options.ignoreIfNotExists)))}e.create=n,e.is=t}(n.DeleteFile||(n.DeleteFile={})),function(e){function t(e){var t=e;return t&&(void 0!==t.changes||void 0!==t.documentChanges)&&(void 0===t.documentChanges||t.documentChanges.every(function(e){return a.string(e.kind)?n.CreateFile.is(e)||n.RenameFile.is(e)||n.DeleteFile.is(e):n.TextDocumentEdit.is(e)}))}e.is=t}(n.WorkspaceEdit||(n.WorkspaceEdit={}));var t=function(){function e(e){this.edits=e}return e.prototype.insert=function(e,t){this.edits.push(n.TextEdit.insert(e,t))},e.prototype.replace=function(e,t){this.edits.push(n.TextEdit.replace(e,t))},e.prototype.delete=function(e){this.edits.push(n.TextEdit.del(e))},e.prototype.add=function(e){this.edits.push(e)},e.prototype.all=function(){return this.edits},e.prototype.clear=function(){this.edits.splice(0,this.edits.length)},e}(),i=function(){function e(e){var i=this;this._textEditChanges=Object.create(null),e&&(this._workspaceEdit=e,e.documentChanges?e.documentChanges.forEach(function(e){if(n.TextDocumentEdit.is(e)){var r=new t(e.edits);i._textEditChanges[e.textDocument.uri]=r}}):e.changes&&Object.keys(e.changes).forEach(function(n){var r=new t(e.changes[n]);i._textEditChanges[n]=r}))}return Object.defineProperty(e.prototype,"edit",{get:function(){return this._workspaceEdit},enumerable:!0,configurable:!0}),e.prototype.getTextEditChange=function(e){if(n.VersionedTextDocumentIdentifier.is(e)){if(this._workspaceEdit||(this._workspaceEdit={documentChanges:[]}),!this._workspaceEdit.documentChanges)throw new Error("Workspace edit is not configured for document changes.");var i=e,r=this._textEditChanges[i.uri];if(!r){var o=[],a={textDocument:i,edits:o};this._workspaceEdit.documentChanges.push(a),r=new t(o),this._textEditChanges[i.uri]=r}return r}if(this._workspaceEdit||(this._workspaceEdit={changes:Object.create(null)}),!this._workspaceEdit.changes)throw new Error("Workspace edit is not configured for normal text edit changes.");var r=this._textEditChanges[e];if(!r){var o=[];this._workspaceEdit.changes[e]=o,r=new t(o),this._textEditChanges[e]=r}return r},e.prototype.createFile=function(e,t){this.checkDocumentChanges(),this._workspaceEdit.documentChanges.push(n.CreateFile.create(e,t))},e.prototype.renameFile=function(e,t,i){this.checkDocumentChanges(),this._workspaceEdit.documentChanges.push(n.RenameFile.create(e,t,i))},e.prototype.deleteFile=function(e,t){this.checkDocumentChanges(),this._workspaceEdit.documentChanges.push(n.DeleteFile.create(e,t))},e.prototype.checkDocumentChanges=function(){if(!this._workspaceEdit||!this._workspaceEdit.documentChanges)throw new Error("Workspace edit is not configured for document changes.")},e}();n.WorkspaceChange=i,function(e){function n(e){return{uri:e}}function t(e){var n=e;return a.defined(n)&&a.string(n.uri)}e.create=n,e.is=t}(n.TextDocumentIdentifier||(n.TextDocumentIdentifier={})),function(e){function n(e,n){return{uri:e,version:n}}function t(e){var n=e;return a.defined(n)&&a.string(n.uri)&&(null===n.version||a.number(n.version))}e.create=n,e.is=t}(n.VersionedTextDocumentIdentifier||(n.VersionedTextDocumentIdentifier={})),function(e){function n(e,n,t,i){return{uri:e,languageId:n,version:t,text:i}}function t(e){var n=e;return a.defined(n)&&a.string(n.uri)&&a.string(n.languageId)&&a.number(n.version)&&a.string(n.text)}e.create=n,e.is=t}(n.TextDocumentItem||(n.TextDocumentItem={})),function(e){e.PlainText="plaintext",e.Markdown="markdown"}(n.MarkupKind||(n.MarkupKind={})),function(e){function n(n){var t=n;return t===e.PlainText||t===e.Markdown}e.is=n}(n.MarkupKind||(n.MarkupKind={})),function(e){function t(e){var t=e;return a.objectLiteral(e)&&n.MarkupKind.is(t.kind)&&a.string(t.value)}e.is=t}(n.MarkupContent||(n.MarkupContent={})),function(e){e.Text=1,e.Method=2,e.Function=3,e.Constructor=4,e.Field=5,e.Variable=6,e.Class=7,e.Interface=8,e.Module=9,e.Property=10,e.Unit=11,e.Value=12,e.Enum=13,e.Keyword=14,e.Snippet=15,e.Color=16,e.File=17,e.Reference=18,e.Folder=19,e.EnumMember=20,e.Constant=21,e.Struct=22,e.Event=23,e.Operator=24,e.TypeParameter=25}(n.CompletionItemKind||(n.CompletionItemKind={})),function(e){e.PlainText=1,e.Snippet=2}(n.InsertTextFormat||(n.InsertTextFormat={})),function(e){function n(e){return{label:e}}e.create=n}(n.CompletionItem||(n.CompletionItem={})),function(e){function n(e,n){return{items:e?e:[],isIncomplete:!!n}}e.create=n}(n.CompletionList||(n.CompletionList={})),function(e){function n(e){return e.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}function t(e){var n=e;return a.string(n)||a.objectLiteral(n)&&a.string(n.language)&&a.string(n.value)}e.fromPlainText=n,e.is=t}(n.MarkedString||(n.MarkedString={})),function(e){function t(e){var t=e;return!!t&&a.objectLiteral(t)&&(n.MarkupContent.is(t.contents)||n.MarkedString.is(t.contents)||a.typedArray(t.contents,n.MarkedString.is))&&(void 0===e.range||n.Range.is(e.range))}e.is=t}(n.Hover||(n.Hover={})),function(e){function n(e,n){return n?{label:e,documentation:n}:{label:e}}e.create=n}(n.ParameterInformation||(n.ParameterInformation={})),function(e){function n(e,n){for(var t=[],i=2;i<arguments.length;i++)t[i-2]=arguments[i];var r={label:e};return a.defined(n)&&(r.documentation=n),r.parameters=a.defined(t)?t:[],r}e.create=n}(n.SignatureInformation||(n.SignatureInformation={})),function(e){e.Text=1,e.Read=2,e.Write=3}(n.DocumentHighlightKind||(n.DocumentHighlightKind={})),function(e){function n(e,n){var t={range:e};return a.number(n)&&(t.kind=n),t}e.create=n}(n.DocumentHighlight||(n.DocumentHighlight={})),function(e){e.File=1,e.Module=2,e.Namespace=3,e.Package=4,e.Class=5,e.Method=6,e.Property=7,e.Field=8,e.Constructor=9,e.Enum=10,e.Interface=11,e.Function=12,e.Variable=13,e.Constant=14,e.String=15,e.Number=16,e.Boolean=17,e.Array=18,e.Object=19,e.Key=20,e.Null=21,e.EnumMember=22,e.Struct=23,e.Event=24,e.Operator=25,e.TypeParameter=26}(n.SymbolKind||(n.SymbolKind={})),function(e){function n(e,n,t,i,r){var o={name:e,kind:n,location:{uri:i,range:t}};return r&&(o.containerName=r),o}e.create=n}(n.SymbolInformation||(n.SymbolInformation={}));var r=function(){function e(){}return e}();n.DocumentSymbol=r,function(e){function t(e,n,t,i,r,o){var a={name:e,detail:n,kind:t,range:i,selectionRange:r};return void 0!==o&&(a.children=o),a}function i(e){var t=e;return t&&a.string(t.name)&&a.number(t.kind)&&n.Range.is(t.range)&&n.Range.is(t.selectionRange)&&(void 0===t.detail||a.string(t.detail))&&(void 0===t.deprecated||a.boolean(t.deprecated))&&(void 0===t.children||Array.isArray(t.children))}e.create=t,e.is=i}(r||(n.DocumentSymbol=r={})),function(e){e.QuickFix="quickfix",e.Refactor="refactor",e.RefactorExtract="refactor.extract",e.RefactorInline="refactor.inline",e.RefactorRewrite="refactor.rewrite",e.Source="source",e.SourceOrganizeImports="source.organizeImports"}(n.CodeActionKind||(n.CodeActionKind={})),function(e){function t(e,n){var t={diagnostics:e};return void 0!==n&&null!==n&&(t.only=n),t}function i(e){var t=e;return a.defined(t)&&a.typedArray(t.diagnostics,n.Diagnostic.is)&&(void 0===t.only||a.typedArray(t.only,a.string))}e.create=t,e.is=i}(n.CodeActionContext||(n.CodeActionContext={})),function(e){function t(e,t,i){var r={title:e};return n.Command.is(t)?r.command=t:r.edit=t,void 0!==i&&(r.kind=i),r}function i(e){var t=e;return!(!t||!a.string(t.title)||void 0!==t.diagnostics&&!a.typedArray(t.diagnostics,n.Diagnostic.is)||void 0!==t.kind&&!a.string(t.kind)||void 0===t.edit&&void 0===t.command||void 0!==t.command&&!n.Command.is(t.command)||void 0!==t.edit&&!n.WorkspaceEdit.is(t.edit))}e.create=t,e.is=i}(n.CodeAction||(n.CodeAction={})),function(e){function t(e,n){var t={range:e};return a.defined(n)&&(t.data=n),t}function i(e){var t=e;return a.defined(t)&&n.Range.is(t.range)&&(a.undefined(t.command)||n.Command.is(t.command))}e.create=t,e.is=i}(n.CodeLens||(n.CodeLens={})),function(e){function n(e,n){return{tabSize:e,insertSpaces:n}}function t(e){var n=e;return a.defined(n)&&a.number(n.tabSize)&&a.boolean(n.insertSpaces)}e.create=n,e.is=t}(n.FormattingOptions||(n.FormattingOptions={}));var o=function(){function e(){}return e}();n.DocumentLink=o,function(e){function t(e,n,t){return{range:e,target:n,data:t}}function i(e){var t=e;return a.defined(t)&&n.Range.is(t.range)&&(a.undefined(t.target)||a.string(t.target))}e.create=t,e.is=i}(o||(n.DocumentLink=o={})),n.EOL=["\n","\r\n","\r"],function(e){function n(e,n,t,i){return new u(e,n,t,i)}function t(e){var n=e;return a.defined(n)&&a.string(n.uri)&&(a.undefined(n.languageId)||a.string(n.languageId))&&a.number(n.lineCount)&&a.func(n.getText)&&a.func(n.positionAt)&&a.func(n.offsetAt)?!0:!1}function i(e,n){for(var t=e.getText(),i=r(n,function(e,n){var t=e.range.start.line-n.range.start.line;return 0===t?e.range.start.character-n.range.start.character:t}),o=t.length,a=i.length-1;a>=0;a--){var u=i[a],c=e.offsetAt(u.range.start),s=e.offsetAt(u.range.end);if(!(o>=s))throw new Error("Overlapping edit");t=t.substring(0,c)+u.newText+t.substring(s,t.length),o=c}return t}function r(e,n){if(e.length<=1)return e;var t=e.length/2|0,i=e.slice(0,t),o=e.slice(t);r(i,n),r(o,n);for(var a=0,u=0,c=0;a<i.length&&u<o.length;){var s=n(i[a],o[u]);e[c++]=0>=s?i[a++]:o[u++]}for(;a<i.length;)e[c++]=i[a++];for(;u<o.length;)e[c++]=o[u++];return e}e.create=n,e.is=t,e.applyEdits=i}(n.TextDocument||(n.TextDocument={})),function(e){e.Manual=1,e.AfterDelay=2,e.FocusOut=3}(n.TextDocumentSaveReason||(n.TextDocumentSaveReason={}));var a,u=function(){function e(e,n,t,i){this._uri=e,this._languageId=n,this._version=t,this._content=i,this._lineOffsets=null}return Object.defineProperty(e.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"languageId",{get:function(){return this._languageId},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"version",{get:function(){return this._version},enumerable:!0,configurable:!0}),e.prototype.getText=function(e){if(e){var n=this.offsetAt(e.start),t=this.offsetAt(e.end);return this._content.substring(n,t)}return this._content},e.prototype.update=function(e,n){this._content=e.text,this._version=n,this._lineOffsets=null},e.prototype.getLineOffsets=function(){if(null===this._lineOffsets){for(var e=[],n=this._content,t=!0,i=0;i<n.length;i++){t&&(e.push(i),t=!1);var r=n.charAt(i);t="\r"===r||"\n"===r,"\r"===r&&i+1<n.length&&"\n"===n.charAt(i+1)&&i++}t&&n.length>0&&e.push(n.length),this._lineOffsets=e}return this._lineOffsets},e.prototype.positionAt=function(e){e=Math.max(Math.min(e,this._content.length),0);var t=this.getLineOffsets(),i=0,r=t.length;if(0===r)return n.Position.create(0,e);for(;r>i;){var o=Math.floor((i+r)/2);t[o]>e?r=o:i=o+1}var a=i-1;return n.Position.create(a,e-t[a])},e.prototype.offsetAt=function(e){var n=this.getLineOffsets();if(e.line>=n.length)return this._content.length;if(e.line<0)return 0;var t=n[e.line],i=e.line+1<n.length?n[e.line+1]:this._content.length;return Math.max(Math.min(t+e.character,i),t)},Object.defineProperty(e.prototype,"lineCount",{get:function(){return this.getLineOffsets().length},enumerable:!0,configurable:!0}),e}();!function(e){function n(e){return"undefined"!=typeof e}function t(e){return"undefined"==typeof e}function i(e){return e===!0||e===!1}function r(e){return"[object String]"===s.call(e)}function o(e){return"[object Number]"===s.call(e)}function a(e){return"[object Function]"===s.call(e)}function u(e){return null!==e&&"object"==typeof e}function c(e,n){return Array.isArray(e)&&e.every(n)}var s=Object.prototype.toString;e.defined=n,e.undefined=t,e.boolean=i,e.string=r,e.number=o,e.func=a,e.objectLiteral=u,e.typedArray=c}(a||(a={}))});
/**! node_modules/monaco-editor/esm/vs/language/json/_deps/vscode-json-languageservice/jsonLanguageService.js*/
define("d1bec86",function(e,n){"use strict";function t(e){var n=e.promiseConstructor||Promise,t=new f.JSONSchemaService(e.schemaRequestService,e.workspaceContext,n);t.setSchemaContributions(u.schemaContributions);var o=new r.JSONCompletion(t,e.contributions,n,e.clientCapabilities),g=new a.JSONHover(t,e.contributions,n),b=new c.JSONDocumentSymbols(t),p=new s.JSONValidation(t,n);return{configure:function(e){t.clearExternalSchemas(),e.schemas&&e.schemas.forEach(function(e){t.registerExternalSchema(e.uri,e.fileMatch,e.schema)}),p.configure(e)},resetSchema:function(e){return t.onResourceChange(e)},doValidation:p.doValidation.bind(p),parseJSONDocument:function(e){return m.parse(e,{collectComments:!0})},newJSONDocument:function(e,n){return m.newJSONDocument(e,n)},doResolve:o.doResolve.bind(o),doComplete:o.doComplete.bind(o),findDocumentSymbols:b.findDocumentSymbols.bind(b),findDocumentSymbols2:b.findDocumentSymbols2.bind(b),findColorSymbols:function(e,n){return b.findDocumentColors(e,n).then(function(e){return e.map(function(e){return e.range})})},findDocumentColors:b.findDocumentColors.bind(b),getColorPresentations:b.getColorPresentations.bind(b),doHover:g.doHover.bind(g),getFoldingRanges:l.getFoldingRanges,getSelectionRanges:d.getSelectionRanges,format:function(e,n,t){var o=void 0;if(n){var r=e.offsetAt(n.start),a=e.offsetAt(n.end)-r;o={offset:r,length:a}}var s={tabSize:t?t.tabSize:4,insertSpaces:t?t.insertSpaces:!0,eol:"\n"};return S.format(e.getText(),o,s).map(function(n){return i.TextEdit.replace(i.Range.create(e.positionAt(n.offset),e.positionAt(n.offset+n.length)),n.content)})}}}Object.defineProperty(n,"__esModule",{value:!0});var o=e("11ed2ab"),i=e("737c70e");n.TextDocument=i.TextDocument,n.Position=i.Position,n.CompletionItem=i.CompletionItem,n.CompletionList=i.CompletionList,n.Hover=i.Hover,n.Range=i.Range,n.SymbolInformation=i.SymbolInformation,n.Diagnostic=i.Diagnostic,n.TextEdit=i.TextEdit,n.FormattingOptions=i.FormattingOptions,n.MarkedString=i.MarkedString;var r=e("bc93086"),a=e("f9e39b3"),s=e("1519ff4"),c=e("8a165f8"),m=e("8408640"),u=e("4cc3293"),f=e("a1f43d9"),l=e("576a913"),d=e("08f16e5"),S=e("26128d7");o.__exportStar(e("683e3e1"),n),n.getLanguageService=t});
/**! node_modules/monaco-editor/esm/vs/editor/common/services/editorSimpleWorker.js*/
define("0854f85",function(e,t){"use strict";function n(){return new y(null)}Object.defineProperty(t,"__esModule",{value:!0});var r=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}(),o=e("2e30c88"),i=e("e1c5605"),u=e("6ad26fe"),s=e("17c8d25"),l=e("50db2b4"),a=e("5ddf902"),m=e("4661130"),d=e("d327c41"),c=e("6250482"),f=e("3af5c49"),g=e("fabf684"),p=e("670df80"),h=e("4dc9450"),_=e("01fef85"),v=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),Object.defineProperty(t.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"version",{get:function(){return this._versionId},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"eol",{get:function(){return this._eol},enumerable:!0,configurable:!0}),t.prototype.getValue=function(){return this.getText()},t.prototype.getLinesContent=function(){return this._lines.slice(0)},t.prototype.getLineCount=function(){return this._lines.length},t.prototype.getLineContent=function(e){return this._lines[e-1]},t.prototype.getWordAtPosition=function(e,t){var n=f.getWordAtText(e.column,f.ensureValidWordDefinition(t),this._lines[e.lineNumber-1],0);return n?new m.Range(e.lineNumber,n.startColumn,e.lineNumber,n.endColumn):null},t.prototype.getWordUntilPosition=function(e,t){var n=this.getWordAtPosition(e,t);return n?{word:this._lines[e.lineNumber-1].substring(n.startColumn-1,e.column-1),startColumn:n.startColumn,endColumn:e.column}:{word:"",startColumn:e.column,endColumn:e.column}},t.prototype.createWordIterator=function(e){var t,n,r=this,o=0,i=0,s=[],l=function(){if(i<s.length){var a=n.substring(s[i].start,s[i].end);return i+=1,t?t.value=a:t={done:!1,value:a},t}return o>=r._lines.length?u.FIN:(n=r._lines[o],s=r._wordenize(n,e),i=0,o+=1,l())};return{next:l}},t.prototype.getLineWords=function(e,t){for(var n=this._lines[e-1],r=this._wordenize(n,t),o=[],i=0,u=r;i<u.length;i++){var s=u[i];o.push({word:n.substring(s.start,s.end),startColumn:s.start+1,endColumn:s.end+1})}return o},t.prototype._wordenize=function(e,t){var n,r=[];for(t.lastIndex=0;(n=t.exec(e))&&0!==n[0].length;)r.push({start:n.index,end:n.index+n[0].length});return r},t.prototype.getValueInRange=function(e){if(e=this._validateRange(e),e.startLineNumber===e.endLineNumber)return this._lines[e.startLineNumber-1].substring(e.startColumn-1,e.endColumn-1);var t=this._eol,n=e.startLineNumber-1,r=e.endLineNumber-1,o=[];o.push(this._lines[n].substring(e.startColumn-1));for(var i=n+1;r>i;i++)o.push(this._lines[i]);return o.push(this._lines[r].substring(0,e.endColumn-1)),o.join(t)},t.prototype.offsetAt=function(e){return e=this._validatePosition(e),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(e.lineNumber-2)+(e.column-1)},t.prototype.positionAt=function(e){e=Math.floor(e),e=Math.max(0,e),this._ensureLineStarts();var t=this._lineStarts.getIndexOf(e),n=this._lines[t.index].length;return{lineNumber:1+t.index,column:1+Math.min(t.remainder,n)}},t.prototype._validateRange=function(e){var t=this._validatePosition({lineNumber:e.startLineNumber,column:e.startColumn}),n=this._validatePosition({lineNumber:e.endLineNumber,column:e.endColumn});return t.lineNumber!==e.startLineNumber||t.column!==e.startColumn||n.lineNumber!==e.endLineNumber||n.column!==e.endColumn?{startLineNumber:t.lineNumber,startColumn:t.column,endLineNumber:n.lineNumber,endColumn:n.column}:e},t.prototype._validatePosition=function(e){if(!a.Position.isIPosition(e))throw new Error("bad position");var t=e.lineNumber,n=e.column,r=!1;if(1>t)t=1,n=1,r=!0;else if(t>this._lines.length)t=this._lines.length,n=this._lines[t-1].length+1,r=!0;else{var o=this._lines[t-1].length+1;1>n?(n=1,r=!0):n>o&&(n=o,r=!0)}return r?{lineNumber:t,column:n}:e},t}(c.MirrorTextModel),b=function(){function e(e){this._foreignModuleFactory=e,this._foreignModule=null}return e.prototype.computeDiff=function(e,t,n){var r=this._getModel(e),o=this._getModel(t);if(!r||!o)return Promise.resolve(null);var i=r.getLinesContent(),u=o.getLinesContent(),s=new d.DiffComputer(i,u,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:n,shouldMakePrettyDiff:!0}),l=s.computeDiff(),a=l.length>0?!1:this._modelsAreIdentical(r,o);return Promise.resolve({identical:a,changes:l})},e.prototype._modelsAreIdentical=function(e,t){var n=e.getLineCount(),r=t.getLineCount();if(n!==r)return!1;for(var o=1;n>=o;o++){var i=e.getLineContent(o),u=t.getLineContent(o);if(i!==u)return!1}return!0},e.prototype.computeMoreMinimalEdits=function(t,n){var r=this._getModel(t);if(!r)return Promise.resolve(n);var u=[],s=void 0;n=o.mergeSort(n,function(e,t){if(e.range&&t.range)return m.Range.compareRangesUsingStarts(e.range,t.range);var n=e.range?0:1,r=t.range?0:1;return n-r});for(var l=0,a=n;l<a.length;l++){var d=a[l],c=d.range,f=d.text,g=d.eol;if("number"==typeof g&&(s=g),!m.Range.isEmpty(c)||f){var p=r.getValueInRange(c);if(f=f.replace(/\r\n|\n|\r/g,r.eol),p!==f)if(Math.max(f.length,p.length)>e._diffLimit)u.push({range:c,text:f});else for(var h=i.stringDiff(p,f,!1),_=r.offsetAt(m.Range.lift(c).getStartPosition()),v=0,b=h;v<b.length;v++){var y=b[v],C=r.positionAt(_+y.originalStart),N=r.positionAt(_+y.originalStart+y.originalLength),L={text:f.substr(y.modifiedStart,y.modifiedLength),range:{startLineNumber:C.lineNumber,startColumn:C.column,endLineNumber:N.lineNumber,endColumn:N.column}};r.getValueInRange(L.range)!==L.text&&u.push(L)}}}return"number"==typeof s&&u.push({eol:s,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),Promise.resolve(u)},e.prototype.computeLinks=function(e){var t=this._getModel(e);return Promise.resolve(t?g.computeLinks(t):null)},e.prototype.textualSuggest=function(t,n,r,o){var i=this._getModel(t);if(!i)return Promise.resolve(null);var u=Object.create(null),s=[],l=new RegExp(r,o),a=i.getWordUntilPosition(n,l),m=i.getWordAtPosition(n,l);m&&(u[i.getValueInRange(m)]=!0);for(var d=i.createWordIterator(l),c=d.next();!c.done&&s.length<=e._suggestionsLimit;c=d.next()){var f=c.value;u[f]||(u[f]=!0,isNaN(Number(f))&&s.push({kind:18,label:f,insertText:f,range:{startLineNumber:n.lineNumber,startColumn:a.startColumn,endLineNumber:n.lineNumber,endColumn:a.endColumn}}))}return Promise.resolve({suggestions:s})},e.prototype.computeWordRanges=function(e,t,n,r){var o=this._getModel(e);if(!o)return Promise.resolve(Object.create(null));for(var i=new RegExp(n,r),u=Object.create(null),s=t.startLineNumber;s<t.endLineNumber;s++)for(var l=o.getLineWords(s,i),a=0,m=l;a<m.length;a++){var d=m[a];if(isNaN(Number(d.word))){var c=u[d.word];c||(c=[],u[d.word]=c),c.push({startLineNumber:s,startColumn:d.startColumn,endLineNumber:s,endColumn:d.endColumn})}}return Promise.resolve(u)},e.prototype.navigateValueSet=function(e,t,n,r,o){var i=this._getModel(e);if(!i)return Promise.resolve(null);var u=new RegExp(r,o);t.startColumn===t.endColumn&&(t={startLineNumber:t.startLineNumber,startColumn:t.startColumn,endLineNumber:t.endLineNumber,endColumn:t.endColumn+1});var s=i.getValueInRange(t),l=i.getWordAtPosition({lineNumber:t.startLineNumber,column:t.startColumn},u);if(!l)return Promise.resolve(null);var a=i.getValueInRange(l),m=p.BasicInplaceReplace.INSTANCE.navigateValueSet(t,s,l,a,n);return Promise.resolve(m)},e.prototype.loadForeignModule=function(e,t){var n=this,r={getMirrorModels:function(){return n._getModels()}};if(this._foreignModuleFactory){this._foreignModule=this._foreignModuleFactory(r,t);for(var o=[],i=0,u=_.getAllPropertyNames(this._foreignModule);i<u.length;i++){var s=u[i];"function"==typeof this._foreignModule[s]&&o.push(s)}return Promise.resolve(o)}return Promise.reject(new Error("Unexpected usage"))},e.prototype.fmr=function(e,t){if(!this._foreignModule||"function"!=typeof this._foreignModule[e])return Promise.reject(new Error("Missing requestHandler or method: "+e));try{return Promise.resolve(this._foreignModule[e].apply(this._foreignModule,t))}catch(n){return Promise.reject(n)}},e._diffLimit=1e5,e._suggestionsLimit=1e4,e}();t.BaseEditorSimpleWorker=b;var y=function(e){function t(t){var n=e.call(this,t)||this;return n._models=Object.create(null),n}return r(t,e),t.prototype.dispose=function(){this._models=Object.create(null)},t.prototype._getModel=function(e){return this._models[e]},t.prototype._getModels=function(){var e=this,t=[];return Object.keys(this._models).forEach(function(n){return t.push(e._models[n])}),t},t.prototype.acceptNewModel=function(e){this._models[e.url]=new v(l.URI.parse(e.url),e.lines,e.EOL,e.versionId)},t.prototype.acceptModelChanged=function(e,t){if(this._models[e]){var n=this._models[e];n.onEvents(t)}},t.prototype.acceptRemovedModel=function(e){this._models[e]&&delete this._models[e]},t}(b);t.EditorSimpleWorkerImpl=y,t.create=n,"function"==typeof importScripts&&(s.globals.monaco=h.createMonacoBaseAPI())});
/**! node_modules/monaco-editor/esm/vs/base/common/worker/simpleWorker.js*/
define("e9bd7e4",function(e,r){"use strict";function t(e){a.isWeb&&(c||(c=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/Microsoft/monaco-editor#faq")),console.warn(e.message))}function n(e){return new p(e,null)}Object.defineProperty(r,"__esModule",{value:!0});var o=this&&this.__extends||function(){var e=function(r,t){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,r){e.__proto__=r}||function(e,r){for(var t in r)r.hasOwnProperty(t)&&(e[t]=r[t])})(r,t)};return function(r,t){function n(){this.constructor=r}e(r,t),r.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}}(),s=e("22e50b6"),i=e("a0b8cca"),a=e("17c8d25"),u=e("01fef85"),l="$initialize",c=!1;r.logOnceWebWorkerWarning=t;var d=function(){function e(e){this._workerId=-1,this._handler=e,this._lastSentReq=0,this._pendingReplies=Object.create(null)}return e.prototype.setWorkerId=function(e){this._workerId=e},e.prototype.sendMessage=function(e,r){var t=this,n=String(++this._lastSentReq);return new Promise(function(o,s){t._pendingReplies[n]={resolve:o,reject:s},t._send({vsWorker:t._workerId,req:n,method:e,args:r})})},e.prototype.handleMessage=function(e){var r;try{r=JSON.parse(e)}catch(t){return}r&&r.vsWorker&&(-1===this._workerId||r.vsWorker===this._workerId)&&this._handleMessage(r)},e.prototype._handleMessage=function(e){var r=this;if(e.seq){var t=e;if(!this._pendingReplies[t.seq])return void console.warn("Got reply to unknown seq");var n=this._pendingReplies[t.seq];if(delete this._pendingReplies[t.seq],t.err){var o=t.err;return t.err.$isError&&(o=new Error,o.name=t.err.name,o.message=t.err.message,o.stack=t.err.stack),void n.reject(o)}return void n.resolve(t.res)}var i=e,a=i.req,u=this._handler.handleMessage(i.method,i.args);u.then(function(e){r._send({vsWorker:r._workerId,seq:a,res:e,err:void 0})},function(e){e.detail instanceof Error&&(e.detail=s.transformErrorForSerialization(e.detail)),r._send({vsWorker:r._workerId,seq:a,res:void 0,err:s.transformErrorForSerialization(e)})})},e.prototype._send=function(e){var r=JSON.stringify(e);this._handler.sendMessage(r)},e}(),f=function(e){function r(r,t){var n=e.call(this)||this,o=null;n._worker=n._register(r.create("vs/base/common/worker/simpleWorker",function(e){n._protocol.handleMessage(e)},function(e){o&&o(e)})),n._protocol=new d({sendMessage:function(e){n._worker.postMessage(e)},handleMessage:function(){return Promise.resolve(null)}}),n._protocol.setWorkerId(n._worker.getId());var s=null;"undefined"!=typeof self.require&&"function"==typeof self.require.getConfig?s=self.require.getConfig():"undefined"!=typeof self.requirejs&&(s=self.requirejs.s.contexts._.config),n._onModuleLoaded=n._protocol.sendMessage(l,[n._worker.getId(),t,s]),n._lazyProxy=new Promise(function(e,r){o=r,n._onModuleLoaded.then(function(r){for(var t={},n=0,o=r;n<o.length;n++){var s=o[n];t[s]=a(s,i)}e(t)},function(e){r(e),n._onError("Worker failed to load "+t,e)})});var i=function(e,r){return n._request(e,r)},a=function(e,r){return function(){var t=Array.prototype.slice.call(arguments,0);return r(e,t)}};return n}return o(r,e),r.prototype.getProxyObject=function(){return this._lazyProxy},r.prototype._request=function(e,r){var t=this;return new Promise(function(n,o){t._onModuleLoaded.then(function(){t._protocol.sendMessage(e,r).then(n,o)},o)})},r.prototype._onError=function(e,r){console.error(e),console.info(r)},r}(i.Disposable);r.SimpleWorkerClient=f;var p=function(){function e(e,r){var t=this;this._requestHandler=r,this._protocol=new d({sendMessage:function(r){e(r)},handleMessage:function(e,r){return t._handleMessage(e,r)}})}return e.prototype.onmessage=function(e){this._protocol.handleMessage(e)},e.prototype._handleMessage=function(e,r){if(e===l)return this.initialize(r[0],r[1],r[2]);if(!this._requestHandler||"function"!=typeof this._requestHandler[e])return Promise.reject(new Error("Missing requestHandler or method: "+e));try{return Promise.resolve(this._requestHandler[e].apply(this._requestHandler,r))}catch(t){return Promise.reject(t)}},e.prototype.initialize=function(e,r,t){var n=this;if(this._protocol.setWorkerId(e),this._requestHandler){for(var o=[],s=0,i=u.getAllPropertyNames(this._requestHandler);s<i.length;s++){var a=i[s];"function"==typeof this._requestHandler[a]&&o.push(a)}return Promise.resolve(o)}return t&&("undefined"!=typeof t.baseUrl&&delete t.baseUrl,"undefined"!=typeof t.paths&&"undefined"!=typeof t.paths.vs&&delete t.paths.vs,t.catchError=!0,self.require.config(t)),new Promise(function(e,t){self.require([r],function(){for(var r=[],o=0;o<arguments.length;o++)r[o]=arguments[o];var s=r[0];if(n._requestHandler=s.create(),!n._requestHandler)return void t(new Error("No RequestHandler!"));for(var i=[],a=0,l=u.getAllPropertyNames(n._requestHandler);a<l.length;a++){var c=l[a];"function"==typeof n._requestHandler[c]&&i.push(c)}e(i)},t)})},e}();r.SimpleWorkerServer=p,r.create=n});
/**! node_modules/monaco-editor/esm/vs/language/json/jsonWorker.js*/
define("b6f55bd",function(e,t){"use strict";function r(e,t){return new s(e,t)}Object.defineProperty(t,"__esModule",{value:!0});var n,o=e("11ed2ab"),i=o.__importStar(e("d1bec86")),u=o.__importStar(e("737c70e"));"undefined"!=typeof fetch&&(n=function(e){return fetch(e).then(function(e){return e.text()})});var a=function(){function e(e){this.wrapped=new Promise(e)}return e.prototype.then=function(e,t){var r=this.wrapped;return r.then(e,t)},e.prototype.getWrapped=function(){return this.wrapped},e.resolve=function(e){return Promise.resolve(e)},e.reject=function(e){return Promise.reject(e)},e.all=function(e){return Promise.all(e)},e}(),s=function(){function e(e,t){this._ctx=e,this._languageSettings=t.languageSettings,this._languageId=t.languageId,this._languageService=i.getLanguageService({schemaRequestService:t.enableSchemaRequest&&n,promiseConstructor:a}),this._languageService.configure(this._languageSettings)}return e.prototype.doValidation=function(e){var t=this._getTextDocument(e);if(t){var r=this._languageService.parseJSONDocument(t);return this._languageService.doValidation(t,r)}return Promise.resolve([])},e.prototype.doComplete=function(e,t){var r=this._getTextDocument(e),n=this._languageService.parseJSONDocument(r);return this._languageService.doComplete(r,t,n)},e.prototype.doResolve=function(e){return this._languageService.doResolve(e)},e.prototype.doHover=function(e,t){var r=this._getTextDocument(e),n=this._languageService.parseJSONDocument(r);return this._languageService.doHover(r,t,n)},e.prototype.format=function(e,t,r){var n=this._getTextDocument(e),o=this._languageService.format(n,t,r);return Promise.resolve(o)},e.prototype.resetSchema=function(e){return Promise.resolve(this._languageService.resetSchema(e))},e.prototype.findDocumentSymbols=function(e){var t=this._getTextDocument(e),r=this._languageService.parseJSONDocument(t),n=this._languageService.findDocumentSymbols(t,r);return Promise.resolve(n)},e.prototype.findDocumentColors=function(e){var t=this._getTextDocument(e),r=this._languageService.parseJSONDocument(t),n=this._languageService.findDocumentColors(t,r);return Promise.resolve(n)},e.prototype.getColorPresentations=function(e,t,r){var n=this._getTextDocument(e),o=this._languageService.parseJSONDocument(n),i=this._languageService.getColorPresentations(n,o,t,r);return Promise.resolve(i)},e.prototype.provideFoldingRanges=function(e,t){var r=this._getTextDocument(e),n=this._languageService.getFoldingRanges(r,t);return Promise.resolve(n)},e.prototype._getTextDocument=function(e){for(var t=this._ctx.getMirrorModels(),r=0,n=t;r<n.length;r++){var o=n[r];if(o.uri.toString()===e)return u.TextDocument.create(e,this._languageId,o.version,o.getValue())}return null},e}();t.JSONWorker=s,t.create=r});
/**! node_modules/monaco-editor/esm/vs/editor/editor.worker.js*/
define("ca932bd",function(e,n){"use strict";function i(e){if(!t){t=!0;var n=new o.EditorSimpleWorkerImpl(e),i=new s.SimpleWorkerServer(function(e){self.postMessage(e)},n);self.onmessage=function(e){i.onmessage(e.data)}}}Object.defineProperty(n,"__esModule",{value:!0});var s=e("e9bd7e4"),o=e("0854f85"),t=!1;n.initialize=i,self.onmessage=function(){t||i(null)}});
/**! node_modules/tslib/tslib.js*/
define("11ed2ab",function(t,e,n,r){var o,a,u,c,i,f,l,s,y,p,b,_,h,v,d,m,w,g,O,j;!function(t){function e(t,e){return t!==o&&("function"==typeof Object.create?Object.defineProperty(t,"__esModule",{value:!0}):t.__esModule=!0),function(n,r){return t[n]=e?e(n,r):r}}var o="object"==typeof global?global:"object"==typeof self?self:"object"==typeof this?this:{};"function"==typeof r&&r.amd?r("tslib",["exports"],function(n){t(e(o,e(n)))}):t("object"==typeof n&&"object"==typeof n.exports?e(o,e(n.exports)):e(o))}(function(t){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])};o=function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)},a=Object.assign||function(t){for(var e,n=1,r=arguments.length;r>n;n++){e=arguments[n];for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&(t[o]=e[o])}return t},u=function(t,e){var n={};for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&e.indexOf(r)<0&&(n[r]=t[r]);if(null!=t&&"function"==typeof Object.getOwnPropertySymbols)for(var o=0,r=Object.getOwnPropertySymbols(t);o<r.length;o++)e.indexOf(r[o])<0&&Object.prototype.propertyIsEnumerable.call(t,r[o])&&(n[r[o]]=t[r[o]]);return n},c=function(t,e,n,r){var o,a=arguments.length,u=3>a?e:null===r?r=Object.getOwnPropertyDescriptor(e,n):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)u=Reflect.decorate(t,e,n,r);else for(var c=t.length-1;c>=0;c--)(o=t[c])&&(u=(3>a?o(u):a>3?o(e,n,u):o(e,n))||u);return a>3&&u&&Object.defineProperty(e,n,u),u},i=function(t,e){return function(n,r){e(n,r,t)}},f=function(t,e){return"object"==typeof Reflect&&"function"==typeof Reflect.metadata?Reflect.metadata(t,e):void 0},l=function(t,e,n,r){return new(n||(n=Promise))(function(o,a){function u(t){try{i(r.next(t))}catch(e){a(e)}}function c(t){try{i(r["throw"](t))}catch(e){a(e)}}function i(t){t.done?o(t.value):new n(function(e){e(t.value)}).then(u,c)}i((r=r.apply(t,e||[])).next())})},s=function(t,e){function n(t){return function(e){return r([t,e])}}function r(n){if(o)throw new TypeError("Generator is already executing.");for(;i;)try{if(o=1,a&&(u=2&n[0]?a["return"]:n[0]?a["throw"]||((u=a["return"])&&u.call(a),0):a.next)&&!(u=u.call(a,n[1])).done)return u;switch(a=0,u&&(n=[2&n[0],u.value]),n[0]){case 0:case 1:u=n;break;case 4:return i.label++,{value:n[1],done:!1};case 5:i.label++,a=n[1],n=[0];continue;case 7:n=i.ops.pop(),i.trys.pop();continue;default:if(u=i.trys,!(u=u.length>0&&u[u.length-1])&&(6===n[0]||2===n[0])){i=0;continue}if(3===n[0]&&(!u||n[1]>u[0]&&n[1]<u[3])){i.label=n[1];break}if(6===n[0]&&i.label<u[1]){i.label=u[1],u=n;break}if(u&&i.label<u[2]){i.label=u[2],i.ops.push(n);break}u[2]&&i.ops.pop(),i.trys.pop();continue}n=e.call(t,i)}catch(r){n=[6,r],a=0}finally{o=u=0}if(5&n[0])throw n[1];return{value:n[0]?n[1]:void 0,done:!0}}var o,a,u,c,i={label:0,sent:function(){if(1&u[0])throw u[1];return u[1]},trys:[],ops:[]};return c={next:n(0),"throw":n(1),"return":n(2)},"function"==typeof Symbol&&(c[Symbol.iterator]=function(){return this}),c},y=function(t,e){for(var n in t)e.hasOwnProperty(n)||(e[n]=t[n])},p=function(t){var e="function"==typeof Symbol&&t[Symbol.iterator],n=0;return e?e.call(t):{next:function(){return t&&n>=t.length&&(t=void 0),{value:t&&t[n++],done:!t}}}},b=function(t,e){var n="function"==typeof Symbol&&t[Symbol.iterator];if(!n)return t;var r,o,a=n.call(t),u=[];try{for(;(void 0===e||e-->0)&&!(r=a.next()).done;)u.push(r.value)}catch(c){o={error:c}}finally{try{r&&!r.done&&(n=a["return"])&&n.call(a)}finally{if(o)throw o.error}}return u},_=function(){for(var t=[],e=0;e<arguments.length;e++)t=t.concat(b(arguments[e]));return t},h=function(){for(var t=0,e=0,n=arguments.length;n>e;e++)t+=arguments[e].length;for(var r=Array(t),o=0,e=0;n>e;e++)for(var a=arguments[e],u=0,c=a.length;c>u;u++,o++)r[o]=a[u];return r},v=function(t){return this instanceof v?(this.v=t,this):new v(t)},d=function(t,e,n){function r(t){l[t]&&(f[t]=function(e){return new Promise(function(n,r){s.push([t,e,n,r])>1||o(t,e)})})}function o(t,e){try{a(l[t](e))}catch(n){i(s[0][3],n)}}function a(t){t.value instanceof v?Promise.resolve(t.value.v).then(u,c):i(s[0][2],t)}function u(t){o("next",t)}function c(t){o("throw",t)}function i(t,e){t(e),s.shift(),s.length&&o(s[0][0],s[0][1])}if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var f,l=n.apply(t,e||[]),s=[];return f={},r("next"),r("throw"),r("return"),f[Symbol.asyncIterator]=function(){return this},f},m=function(t){function e(e,o){n[e]=t[e]?function(n){return(r=!r)?{value:v(t[e](n)),done:"return"===e}:o?o(n):n}:o}var n,r;return n={},e("next"),e("throw",function(t){throw t}),e("return"),n[Symbol.iterator]=function(){return this},n},w=function(t){function e(e){r[e]=t[e]&&function(r){return new Promise(function(o,a){r=t[e](r),n(o,a,r.done,r.value)})}}function n(t,e,n,r){Promise.resolve(r).then(function(e){t({value:e,done:n})},e)}if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var r,o=t[Symbol.asyncIterator];return o?o.call(t):(t="function"==typeof p?p(t):t[Symbol.iterator](),r={},e("next"),e("throw"),e("return"),r[Symbol.asyncIterator]=function(){return this},r)},g=function(t,e){return Object.defineProperty?Object.defineProperty(t,"raw",{value:e}):t.raw=e,t},O=function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var n in t)Object.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e["default"]=t,e},j=function(t){return t&&t.__esModule?t:{"default":t}},t("__extends",o),t("__assign",a),t("__rest",u),t("__decorate",c),t("__param",i),t("__metadata",f),t("__awaiter",l),t("__generator",s),t("__exportStar",y),t("__values",p),t("__read",b),t("__spread",_),t("__spreadArrays",h),t("__await",v),t("__asyncGenerator",d),t("__asyncDelegator",m),t("__asyncValues",w),t("__makeTemplateObject",g),t("__importStar",O),t("__importDefault",j)})});
/**! node_modules/monaco-editor/esm/vs/language/json/json.worker.js*/
define("aafb056",function(e,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0});var n=e("11ed2ab"),t=n.__importStar(e("ca932bd")),a=e("b6f55bd");self.onmessage=function(){t.initialize(function(e,i){return new a.JSONWorker(e,i)})}});
require('aafb056')