var require, define;
(function () {
    var loadingMap = {};
    var factoryMap = {};
    var modulesMap = {};

    define = function (id, factory) {
        id = id.replace(/\.js$/i, '');
        factoryMap[id] = factory;

        var queue = loadingMap[id];
        if (queue) {
            for (var i = 0, n = queue.length; i < n; i++) {
                queue[i]();
            }
            delete loadingMap[id];
        }
    };

    require = function (id) {
        id = require.alias(id);

        var mod = modulesMap[id];
        if (mod) {
            return mod.exports;
        }

        var factory = factoryMap[id];
        if (!factory) {
            throw '[ModJS] Cannot find module `' + id + '`';
        }

        mod = modulesMap[id] = {
            exports: {}
        };

        var ret = (typeof factory === 'function') ? factory.apply(mod, [require, mod.exports, mod]) : factory;

        if (ret) {
            mod.exports = ret;
        }

        return mod.exports;
    };

    require.alias = function (id) {
        return id.replace(/\.js$/i, '');
    };
})(this);
/**! node_modules/monaco-editor/esm/vs/base/common/linkedList.js*/
define("45886bc",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=e("6ad26fe"),i=function(){function e(t){this.element=t,this.next=e.Undefined,this.prev=e.Undefined}return e.Undefined=new e(void 0),e}(),r=function(){function e(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}return Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.isEmpty=function(){return this._first===i.Undefined},e.prototype.clear=function(){this._first=i.Undefined,this._last=i.Undefined,this._size=0},e.prototype.unshift=function(e){return this._insert(e,!1)},e.prototype.push=function(e){return this._insert(e,!0)},e.prototype._insert=function(e,t){var n=this,r=new i(e);if(this._first===i.Undefined)this._first=r,this._last=r;else if(t){var s=this._last;this._last=r,r.prev=s,s.next=r}else{var f=this._first;this._first=r,r.next=f,f.prev=r}this._size+=1;var d=!1;return function(){d||(d=!0,n._remove(r))}},e.prototype.shift=function(){if(this._first===i.Undefined)return void 0;var e=this._first.element;return this._remove(this._first),e},e.prototype._remove=function(e){if(e.prev!==i.Undefined&&e.next!==i.Undefined){var t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===i.Undefined&&e.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):e.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):e.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1},e.prototype.iterator=function(){var e,t=this._first;return{next:function(){return t===i.Undefined?n.FIN:(e?e.value=t.element:e={done:!1,value:t.element},t=t.next,e)}}},e.prototype.toArray=function(){for(var e=[],t=this._first;t!==i.Undefined;t=t.next)e.push(t.element);return e},e}();t.LinkedList=r});
/**! node_modules/monaco-editor/esm/vs/base/common/functional.js*/
define("4af2228",function(e,n){"use strict";function t(e){var n,t=this,r=!1;return function(){return r?n:(r=!0,n=e.apply(t,arguments))}}Object.defineProperty(n,"__esModule",{value:!0}),n.once=t});
/**! node_modules/monaco-editor/esm/vs/base/common/linkedList.js*/
define("45886bc",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=e("6ad26fe"),i=function(){function e(t){this.element=t,this.next=e.Undefined,this.prev=e.Undefined}return e.Undefined=new e(void 0),e}(),r=function(){function e(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}return Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.isEmpty=function(){return this._first===i.Undefined},e.prototype.clear=function(){this._first=i.Undefined,this._last=i.Undefined,this._size=0},e.prototype.unshift=function(e){return this._insert(e,!1)},e.prototype.push=function(e){return this._insert(e,!0)},e.prototype._insert=function(e,t){var n=this,r=new i(e);if(this._first===i.Undefined)this._first=r,this._last=r;else if(t){var s=this._last;this._last=r,r.prev=s,s.next=r}else{var f=this._first;this._first=r,r.next=f,f.prev=r}this._size+=1;var d=!1;return function(){d||(d=!0,n._remove(r))}},e.prototype.shift=function(){if(this._first===i.Undefined)return void 0;var e=this._first.element;return this._remove(this._first),e},e.prototype._remove=function(e){if(e.prev!==i.Undefined&&e.next!==i.Undefined){var t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===i.Undefined&&e.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):e.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):e.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1},e.prototype.iterator=function(){var e,t=this._first;return{next:function(){return t===i.Undefined?n.FIN:(e?e.value=t.element:e={done:!1,value:t.element},t=t.next,e)}}},e.prototype.toArray=function(){for(var e=[],t=this._first;t!==i.Undefined;t=t.next)e.push(t.element);return e},e}();t.LinkedList=r});
/**! node_modules/monaco-editor/esm/vs/base/common/functional.js*/
define("4af2228",function(e,n){"use strict";function t(e){var n,t=this,r=!1;return function(){return r?n:(r=!0,n=e.apply(t,arguments))}}Object.defineProperty(n,"__esModule",{value:!0}),n.once=t});
/**! node_modules/monaco-editor/esm/vs/base/common/event.js*/
define("8451667",function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n=this&&this.__extends||function(){var t=function(e,n){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(e,n)};return function(e,n){function i(){this.constructor=e}t(e,n),e.prototype=null===n?Object.create(n):(i.prototype=n.prototype,new i)}}(),i=t("22e50b6"),r=t("4af2228"),o=t("a0b8cca"),s=t("45886bc");!function(t){function e(t){return function(e,n,i){void 0===n&&(n=null);var r,o=!1;return r=t(function(t){return o?void 0:(r?r.dispose():o=!0,e.call(n,t))},null,i),o&&r.dispose(),r}}function n(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){return n.call(i,e(t))},null,r)})}function i(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){e(t),n.call(i,t)},null,r)})}function r(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){return e(t)&&n.call(i,t)},null,r)})}function s(t){return t}function u(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];return function(e,n,i){return void 0===n&&(n=null),o.combinedDisposable(t.map(function(t){return t(function(t){return e.call(n,t)},null,i)}))}}function c(t,e,i){var r=i;return n(t,function(t){return r=e(r,t)})}function a(t){var e,n=new f({onFirstListenerAdd:function(){e=t(n.fire,n)},onLastListenerRemove:function(){e.dispose()}});return n.event}function h(t,e,n,i,r){void 0===n&&(n=100),void 0===i&&(i=!1);var o,s=void 0,u=void 0,c=0,a=new f({leakWarningThreshold:r,onFirstListenerAdd:function(){o=t(function(t){c++,s=e(s,t),i&&!u&&a.fire(s),clearTimeout(u),u=setTimeout(function(){var t=s;s=void 0,u=void 0,(!i||c>1)&&a.fire(t),c=0},n)})},onLastListenerRemove:function(){o.dispose()}});return a.event}function p(t){var i=(new Date).getTime();return n(e(t),function(){return(new Date).getTime()-i})}function v(t){var e,n=!0;return r(t,function(t){var i=n||t!==e;return n=!1,e=t,i})}function l(t,e,n){void 0===e&&(e=!1),void 0===n&&(n=[]);var i=n.slice(),r=t(function(t){i?i.push(t):s.fire(t)}),o=function(){i&&i.forEach(function(t){return s.fire(t)}),i=null},s=new f({onFirstListenerAdd:function(){r||(r=t(function(t){return s.fire(t)}))},onFirstListenerDidAdd:function(){i&&(e?setTimeout(o):o())},onLastListenerRemove:function(){r&&r.dispose(),r=null}});return s.event}function d(t){return new w(t)}function _(t,e,n){void 0===n&&(n=function(t){return t});var i=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];return s.fire(n.apply(void 0,t))},r=function(){return t.on(e,i)},o=function(){return t.removeListener(e,i)},s=new f({onFirstListenerAdd:r,onLastListenerRemove:o});return s.event}function m(t){var e=new f,n=!1;return t.then(void 0,function(){return null}).then(function(){n?e.fire(void 0):setTimeout(function(){return e.fire(void 0)},0)}),n=!0,e.event}function y(t){return new Promise(function(n){return e(t)(n)})}var L={dispose:function(){}};t.None=function(){return L},t.once=e,t.map=n,t.forEach=i,t.filter=r,t.signal=s,t.any=u,t.reduce=c,t.snapshot=a,t.debounce=h,t.stopwatch=p,t.latch=v,t.buffer=l;var w=function(){function t(t){this.event=t}return t.prototype.map=function(e){return new t(n(this.event,e))},t.prototype.forEach=function(e){return new t(i(this.event,e))},t.prototype.filter=function(e){return new t(r(this.event,e))},t.prototype.reduce=function(e,n){return new t(c(this.event,e,n))},t.prototype.latch=function(){return new t(v(this.event))},t.prototype.on=function(t,e,n){return this.event(t,e,n)},t.prototype.once=function(t,n,i){return e(this.event)(t,n,i)},t}();t.chain=d,t.fromNodeEventEmitter=_,t.fromPromise=m,t.toPromise=y}(e.Event||(e.Event={}));var u=-1,c=function(){function t(t,e){void 0===e&&(e=Math.random().toString(18).slice(2,5)),this.customThreshold=t,this.name=e,this._warnCountdown=0}return t.prototype.dispose=function(){this._stacks&&this._stacks.clear()},t.prototype.check=function(t){var e=this,n=u;if("number"==typeof this.customThreshold&&(n=this.customThreshold),0>=n||n>t)return void 0;this._stacks||(this._stacks=new Map);var i=(new Error).stack.split("\n").slice(3).join("\n"),r=this._stacks.get(i)||0;if(this._stacks.set(i,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=.5*n;var o,s=0;this._stacks.forEach(function(t,e){(!o||t>s)&&(o=e,s=t)}),console.warn("["+this.name+"] potential listener LEAK detected, having "+t+" listeners already. MOST frequent listener ("+s+"):"),console.warn(o)}return function(){var t=e._stacks.get(i)||0;e._stacks.set(i,t-1)}},t}(),f=function(){function t(t){this._disposed=!1,this._options=t,this._leakageMon=u>0?new c(this._options&&this._options.leakWarningThreshold):void 0}return Object.defineProperty(t.prototype,"event",{get:function(){var e=this;return this._event||(this._event=function(n,i,r){e._listeners||(e._listeners=new s.LinkedList);var o=e._listeners.isEmpty();o&&e._options&&e._options.onFirstListenerAdd&&e._options.onFirstListenerAdd(e);var u=e._listeners.push(i?[n,i]:n);o&&e._options&&e._options.onFirstListenerDidAdd&&e._options.onFirstListenerDidAdd(e),e._options&&e._options.onListenerDidAdd&&e._options.onListenerDidAdd(e,n,i);var c;e._leakageMon&&(c=e._leakageMon.check(e._listeners.size));var f;return f={dispose:function(){if(c&&c(),f.dispose=t._noop,!e._disposed&&(u(),e._options&&e._options.onLastListenerRemove)){var n=e._listeners&&!e._listeners.isEmpty();n||e._options.onLastListenerRemove(e)}}},Array.isArray(r)&&r.push(f),f}),this._event},enumerable:!0,configurable:!0}),t.prototype.fire=function(t){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(var e=this._listeners.iterator(),n=e.next();!n.done;n=e.next())this._deliveryQueue.push([n.value,t]);for(;this._deliveryQueue.size>0;){var r=this._deliveryQueue.shift(),o=r[0],u=r[1];try{"function"==typeof o?o.call(void 0,u):o[0].call(o[1],u)}catch(n){i.onUnexpectedError(n)}}}},t.prototype.dispose=function(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),this._disposed=!0},t._noop=function(){},t}();e.Emitter=f;var a=function(t){function e(e){var n=t.call(this,e)||this;return n._isPaused=0,n._eventQueue=new s.LinkedList,n._mergeFn=e&&e.merge,n}return n(e,t),e.prototype.pause=function(){this._isPaused++},e.prototype.resume=function(){if(0!==this._isPaused&&0===--this._isPaused)if(this._mergeFn){var e=this._eventQueue.toArray();this._eventQueue.clear(),t.prototype.fire.call(this,this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)t.prototype.fire.call(this,this._eventQueue.shift())},e.prototype.fire=function(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):t.prototype.fire.call(this,e))},e}(f);e.PauseableEmitter=a;var h=function(){function t(){var t=this;this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:function(){return t.onFirstListenerAdd()},onLastListenerRemove:function(){return t.onLastListenerRemove()}})}return Object.defineProperty(t.prototype,"event",{get:function(){return this.emitter.event},enumerable:!0,configurable:!0}),t.prototype.add=function(t){var e=this,n={event:t,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);var i=function(){e.hasListeners&&e.unhook(n);var t=e.events.indexOf(n);e.events.splice(t,1)};return o.toDisposable(r.once(i))},t.prototype.onFirstListenerAdd=function(){var t=this;this.hasListeners=!0,this.events.forEach(function(e){return t.hook(e)})},t.prototype.onLastListenerRemove=function(){var t=this;this.hasListeners=!1,this.events.forEach(function(e){return t.unhook(e)})},t.prototype.hook=function(t){var e=this;t.listener=t.event(function(t){return e.emitter.fire(t)})},t.prototype.unhook=function(t){t.listener&&t.listener.dispose(),t.listener=null},t.prototype.dispose=function(){this.emitter.dispose()},t}();e.EventMultiplexer=h;var p=function(){function t(){this.buffers=[]}return t.prototype.wrapEvent=function(t){var e=this;return function(n,i,r){return t(function(t){var r=e.buffers[e.buffers.length-1];r?r.push(function(){return n.call(i,t)}):n.call(i,t)},void 0,r)}},t.prototype.bufferEvents=function(t){var e=[];this.buffers.push(e);var n=t();return this.buffers.pop(),e.forEach(function(t){return t()}),n},t}();e.EventBufferer=p;var v=function(){function t(){var t=this;this.listening=!1,this.inputEvent=e.Event.None,this.inputEventListener=o.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:function(){t.listening=!0,t.inputEventListener=t.inputEvent(t.emitter.fire,t.emitter)},onLastListenerRemove:function(){t.listening=!1,t.inputEventListener.dispose()}}),this.event=this.emitter.event}return Object.defineProperty(t.prototype,"input",{set:function(t){this.inputEvent=t,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=t(this.emitter.fire,this.emitter))},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){this.inputEventListener.dispose(),this.emitter.dispose()},t}();e.Relay=v});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/uint.js*/
define("4186ef1",function(t,n){"use strict";function r(t){return 0>t?0:t>255?255:0|t}function i(t){return 0>t?0:t>4294967295?4294967295:0|t}function e(t){for(var n=t.length,r=new Uint32Array(n),e=0;n>e;e++)r[e]=i(t[e]);return r}Object.defineProperty(n,"__esModule",{value:!0});var o=function(){function t(t,n,r){for(var i=new Uint8Array(t*n),e=0,o=t*n;o>e;e++)i[e]=r;this._data=i,this.rows=t,this.cols=n}return t.prototype.get=function(t,n){return this._data[t*this.cols+n]},t.prototype.set=function(t,n,r){this._data[t*this.cols+n]=r},t}();n.Uint8Matrix=o,n.toUint8=r,n.toUint32=i,n.toUint32Array=e});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/uint.js*/
define("4186ef1",function(t,n){"use strict";function r(t){return 0>t?0:t>255?255:0|t}function i(t){return 0>t?0:t>4294967295?4294967295:0|t}function e(t){for(var n=t.length,r=new Uint32Array(n),e=0;n>e;e++)r[e]=i(t[e]);return r}Object.defineProperty(n,"__esModule",{value:!0});var o=function(){function t(t,n,r){for(var i=new Uint8Array(t*n),e=0,o=t*n;o>e;e++)i[e]=r;this._data=i,this.rows=t,this.cols=n}return t.prototype.get=function(t,n){return this._data[t*this.cols+n]},t.prototype.set=function(t,n,r){this._data[t*this.cols+n]=r},t}();n.Uint8Matrix=o,n.toUint8=r,n.toUint32=i,n.toUint32Array=e});
/**! node_modules/monaco-editor/esm/vs/editor/common/standalone/standaloneEnums.js*/
define("2e266ae",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),function(e){e[e.Unnecessary=1]="Unnecessary"}(n.MarkerTag||(n.MarkerTag={})),function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"}(n.MarkerSeverity||(n.MarkerSeverity={})),function(e){e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"}(n.KeyCode||(n.KeyCode={})),function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"}(n.SelectionDirection||(n.SelectionDirection={})),function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"}(n.ScrollbarVisibility||(n.ScrollbarVisibility={})),function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"}(n.OverviewRulerLane||(n.OverviewRulerLane={})),function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(n.EndOfLinePreference||(n.EndOfLinePreference={})),function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(n.DefaultEndOfLine||(n.DefaultEndOfLine={})),function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"}(n.EndOfLineSequence||(n.EndOfLineSequence={})),function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"}(n.TrackedRangeStickiness||(n.TrackedRangeStickiness={})),function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"}(n.ScrollType||(n.ScrollType={})),function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"}(n.CursorChangeReason||(n.CursorChangeReason={})),function(e){e[e.None=0]="None",e[e.Small=1]="Small",e[e.Large=2]="Large",e[e.SmallBlocks=3]="SmallBlocks",e[e.LargeBlocks=4]="LargeBlocks"}(n.RenderMinimap||(n.RenderMinimap={})),function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"}(n.WrappingIndent||(n.WrappingIndent={})),function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"}(n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={})),function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"}(n.TextEditorCursorStyle||(n.TextEditorCursorStyle={})),function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"}(n.RenderLineNumbersType||(n.RenderLineNumbersType={})),function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"}(n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={})),function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"}(n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={})),function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"}(n.MouseTargetType||(n.MouseTargetType={})),function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"}(n.IndentAction||(n.IndentAction={})),function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.Snippet=25]="Snippet"}(n.CompletionItemKind||(n.CompletionItemKind={})),function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"}(n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={})),function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"}(n.CompletionTriggerKind||(n.CompletionTriggerKind={})),function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"}(n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={})),function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"}(n.DocumentHighlightKind||(n.DocumentHighlightKind={})),function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"}(n.SymbolKind||(n.SymbolKind={}))});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/token.js*/
define("57d67ff",function(t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var e=function(){function t(t,n,e){this.offset=0|t,this.type=n,this.language=e}return t.prototype.toString=function(){return"("+this.offset+", "+this.type+")"},t}();n.Token=e;var i=function(){function t(t,n){this.tokens=t,this.endState=n}return t}();n.TokenizationResult=i;var o=function(){function t(t,n){this.tokens=t,this.endState=n}return t}();n.TokenizationResult2=o});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/selection.js*/
define("3b7eb07",function(t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var e=this&&this.__extends||function(){var t=function(n,e){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,n){t.__proto__=n}||function(t,n){for(var e in n)n.hasOwnProperty(e)&&(t[e]=n[e])})(n,e)};return function(n,e){function i(){this.constructor=n}t(n,e),n.prototype=null===e?Object.create(e):(i.prototype=e.prototype,new i)}}(),i=t("5ddf902"),o=t("4661130"),r=function(t){function n(n,e,i,o){var r=t.call(this,n,e,i,o)||this;return r.selectionStartLineNumber=n,r.selectionStartColumn=e,r.positionLineNumber=i,r.positionColumn=o,r}return e(n,t),n.prototype.clone=function(){return new n(this.selectionStartLineNumber,this.selectionStartColumn,this.positionLineNumber,this.positionColumn)},n.prototype.toString=function(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"},n.prototype.equalsSelection=function(t){return n.selectionsEqual(this,t)},n.selectionsEqual=function(t,n){return t.selectionStartLineNumber===n.selectionStartLineNumber&&t.selectionStartColumn===n.selectionStartColumn&&t.positionLineNumber===n.positionLineNumber&&t.positionColumn===n.positionColumn},n.prototype.getDirection=function(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1},n.prototype.setEndPosition=function(t,e){return 0===this.getDirection()?new n(this.startLineNumber,this.startColumn,t,e):new n(t,e,this.startLineNumber,this.startColumn)},n.prototype.getPosition=function(){return new i.Position(this.positionLineNumber,this.positionColumn)},n.prototype.setStartPosition=function(t,e){return 0===this.getDirection()?new n(t,e,this.endLineNumber,this.endColumn):new n(this.endLineNumber,this.endColumn,t,e)},n.fromPositions=function(t,e){return void 0===e&&(e=t),new n(t.lineNumber,t.column,e.lineNumber,e.column)},n.liftSelection=function(t){return new n(t.selectionStartLineNumber,t.selectionStartColumn,t.positionLineNumber,t.positionColumn)},n.selectionsArrEqual=function(t,n){if(t&&!n||!t&&n)return!1;if(!t&&!n)return!0;if(t.length!==n.length)return!1;for(var e=0,i=t.length;i>e;e++)if(!this.selectionsEqual(t[e],n[e]))return!1;return!0},n.isISelection=function(t){return t&&"number"==typeof t.selectionStartLineNumber&&"number"==typeof t.selectionStartColumn&&"number"==typeof t.positionLineNumber&&"number"==typeof t.positionColumn},n.createWithDirection=function(t,e,i,o,r){return 0===r?new n(t,e,i,o):new n(i,o,t,e)},n}(o.Range);n.Selection=r});
/**! node_modules/monaco-editor/esm/vs/base/common/keyCodes.js*/
define("651ae9b",function(e,t){"use strict";function n(e,t){var n=(65535&t)<<16>>>0;return(e|n)>>>0}function r(e,t){if(0===e)return null;var n=(65535&e)>>>0,r=(4294901760&e)>>>16;return new h(0!==r?[i(n,t),i(r,t)]:[i(n,t)])}function i(e,t){var n=2048&e?!0:!1,r=256&e?!0:!1,i=2===t?r:n,o=1024&e?!0:!1,u=512&e?!0:!1,s=2===t?n:r,a=255&e;return new y(i,o,u,s,a)}Object.defineProperty(t,"__esModule",{value:!0});var o=e("22e50b6"),u=function(){function e(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}return e.prototype.define=function(e,t){this._keyCodeToStr[e]=t,this._strToKeyCode[t.toLowerCase()]=e},e.prototype.keyCodeToStr=function(e){return this._keyCodeToStr[e]},e.prototype.strToKeyCode=function(e){return this._strToKeyCode[e.toLowerCase()]||0},e}(),s=new u,a=new u,d=new u;!function(){function e(e,t,n,r){void 0===n&&(n=t),void 0===r&&(r=n),s.define(e,t),a.define(e,n),d.define(e,r)}e(0,"unknown"),e(1,"Backspace"),e(2,"Tab"),e(3,"Enter"),e(4,"Shift"),e(5,"Ctrl"),e(6,"Alt"),e(7,"PauseBreak"),e(8,"CapsLock"),e(9,"Escape"),e(10,"Space"),e(11,"PageUp"),e(12,"PageDown"),e(13,"End"),e(14,"Home"),e(15,"LeftArrow","Left"),e(16,"UpArrow","Up"),e(17,"RightArrow","Right"),e(18,"DownArrow","Down"),e(19,"Insert"),e(20,"Delete"),e(21,"0"),e(22,"1"),e(23,"2"),e(24,"3"),e(25,"4"),e(26,"5"),e(27,"6"),e(28,"7"),e(29,"8"),e(30,"9"),e(31,"A"),e(32,"B"),e(33,"C"),e(34,"D"),e(35,"E"),e(36,"F"),e(37,"G"),e(38,"H"),e(39,"I"),e(40,"J"),e(41,"K"),e(42,"L"),e(43,"M"),e(44,"N"),e(45,"O"),e(46,"P"),e(47,"Q"),e(48,"R"),e(49,"S"),e(50,"T"),e(51,"U"),e(52,"V"),e(53,"W"),e(54,"X"),e(55,"Y"),e(56,"Z"),e(57,"Meta"),e(58,"ContextMenu"),e(59,"F1"),e(60,"F2"),e(61,"F3"),e(62,"F4"),e(63,"F5"),e(64,"F6"),e(65,"F7"),e(66,"F8"),e(67,"F9"),e(68,"F10"),e(69,"F11"),e(70,"F12"),e(71,"F13"),e(72,"F14"),e(73,"F15"),e(74,"F16"),e(75,"F17"),e(76,"F18"),e(77,"F19"),e(78,"NumLock"),e(79,"ScrollLock"),e(80,";",";","OEM_1"),e(81,"=","=","OEM_PLUS"),e(82,",",",","OEM_COMMA"),e(83,"-","-","OEM_MINUS"),e(84,".",".","OEM_PERIOD"),e(85,"/","/","OEM_2"),e(86,"`","`","OEM_3"),e(110,"ABNT_C1"),e(111,"ABNT_C2"),e(87,"[","[","OEM_4"),e(88,"\\","\\","OEM_5"),e(89,"]","]","OEM_6"),e(90,"'","'","OEM_7"),e(91,"OEM_8"),e(92,"OEM_102"),e(93,"NumPad0"),e(94,"NumPad1"),e(95,"NumPad2"),e(96,"NumPad3"),e(97,"NumPad4"),e(98,"NumPad5"),e(99,"NumPad6"),e(100,"NumPad7"),e(101,"NumPad8"),e(102,"NumPad9"),e(103,"NumPad_Multiply"),e(104,"NumPad_Add"),e(105,"NumPad_Separator"),e(106,"NumPad_Subtract"),e(107,"NumPad_Decimal"),e(108,"NumPad_Divide")}(),function(e){function t(e){return s.keyCodeToStr(e)}function n(e){return s.strToKeyCode(e)}function r(e){return a.keyCodeToStr(e)}function i(e){return d.keyCodeToStr(e)}function o(e){return a.strToKeyCode(e)||d.strToKeyCode(e)}e.toString=t,e.fromString=n,e.toUserSettingsUS=r,e.toUserSettingsGeneral=i,e.fromUserSettings=o}(t.KeyCodeUtils||(t.KeyCodeUtils={})),t.KeyChord=n,t.createKeybinding=r,t.createSimpleKeybinding=i;var y=function(){function e(e,t,n,r,i){this.ctrlKey=e,this.shiftKey=t,this.altKey=n,this.metaKey=r,this.keyCode=i}return e.prototype.equals=function(e){return this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode},e.prototype.isModifierKey=function(){return 0===this.keyCode||5===this.keyCode||57===this.keyCode||6===this.keyCode||4===this.keyCode},e.prototype.toChord=function(){return new h([this])},e.prototype.isDuplicateModifierCase=function(){return this.ctrlKey&&5===this.keyCode||this.shiftKey&&4===this.keyCode||this.altKey&&6===this.keyCode||this.metaKey&&57===this.keyCode},e}();t.SimpleKeybinding=y;var h=function(){function e(e){if(0===e.length)throw o.illegalArgument("parts");this.parts=e}return e.prototype.equals=function(e){if(null===e)return!1;if(this.parts.length!==e.parts.length)return!1;for(var t=0;t<this.parts.length;t++)if(!this.parts[t].equals(e.parts[t]))return!1;return!0},e}();t.ChordKeybinding=h;var f=function(){function e(e,t,n,r,i,o){this.ctrlKey=e,this.shiftKey=t,this.altKey=n,this.metaKey=r,this.keyLabel=i,this.keyAriaLabel=o}return e}();t.ResolvedKeybindingPart=f;var c=function(){function e(){}return e}();t.ResolvedKeybinding=c});
/**! node_modules/monaco-editor/esm/vs/base/common/event.js*/
define("8451667",function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n=this&&this.__extends||function(){var t=function(e,n){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(e,n)};return function(e,n){function i(){this.constructor=e}t(e,n),e.prototype=null===n?Object.create(n):(i.prototype=n.prototype,new i)}}(),i=t("22e50b6"),r=t("4af2228"),o=t("a0b8cca"),s=t("45886bc");!function(t){function e(t){return function(e,n,i){void 0===n&&(n=null);var r,o=!1;return r=t(function(t){return o?void 0:(r?r.dispose():o=!0,e.call(n,t))},null,i),o&&r.dispose(),r}}function n(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){return n.call(i,e(t))},null,r)})}function i(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){e(t),n.call(i,t)},null,r)})}function r(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){return e(t)&&n.call(i,t)},null,r)})}function s(t){return t}function u(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];return function(e,n,i){return void 0===n&&(n=null),o.combinedDisposable(t.map(function(t){return t(function(t){return e.call(n,t)},null,i)}))}}function c(t,e,i){var r=i;return n(t,function(t){return r=e(r,t)})}function a(t){var e,n=new f({onFirstListenerAdd:function(){e=t(n.fire,n)},onLastListenerRemove:function(){e.dispose()}});return n.event}function h(t,e,n,i,r){void 0===n&&(n=100),void 0===i&&(i=!1);var o,s=void 0,u=void 0,c=0,a=new f({leakWarningThreshold:r,onFirstListenerAdd:function(){o=t(function(t){c++,s=e(s,t),i&&!u&&a.fire(s),clearTimeout(u),u=setTimeout(function(){var t=s;s=void 0,u=void 0,(!i||c>1)&&a.fire(t),c=0},n)})},onLastListenerRemove:function(){o.dispose()}});return a.event}function p(t){var i=(new Date).getTime();return n(e(t),function(){return(new Date).getTime()-i})}function v(t){var e,n=!0;return r(t,function(t){var i=n||t!==e;return n=!1,e=t,i})}function l(t,e,n){void 0===e&&(e=!1),void 0===n&&(n=[]);var i=n.slice(),r=t(function(t){i?i.push(t):s.fire(t)}),o=function(){i&&i.forEach(function(t){return s.fire(t)}),i=null},s=new f({onFirstListenerAdd:function(){r||(r=t(function(t){return s.fire(t)}))},onFirstListenerDidAdd:function(){i&&(e?setTimeout(o):o())},onLastListenerRemove:function(){r&&r.dispose(),r=null}});return s.event}function d(t){return new w(t)}function _(t,e,n){void 0===n&&(n=function(t){return t});var i=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];return s.fire(n.apply(void 0,t))},r=function(){return t.on(e,i)},o=function(){return t.removeListener(e,i)},s=new f({onFirstListenerAdd:r,onLastListenerRemove:o});return s.event}function m(t){var e=new f,n=!1;return t.then(void 0,function(){return null}).then(function(){n?e.fire(void 0):setTimeout(function(){return e.fire(void 0)},0)}),n=!0,e.event}function y(t){return new Promise(function(n){return e(t)(n)})}var L={dispose:function(){}};t.None=function(){return L},t.once=e,t.map=n,t.forEach=i,t.filter=r,t.signal=s,t.any=u,t.reduce=c,t.snapshot=a,t.debounce=h,t.stopwatch=p,t.latch=v,t.buffer=l;var w=function(){function t(t){this.event=t}return t.prototype.map=function(e){return new t(n(this.event,e))},t.prototype.forEach=function(e){return new t(i(this.event,e))},t.prototype.filter=function(e){return new t(r(this.event,e))},t.prototype.reduce=function(e,n){return new t(c(this.event,e,n))},t.prototype.latch=function(){return new t(v(this.event))},t.prototype.on=function(t,e,n){return this.event(t,e,n)},t.prototype.once=function(t,n,i){return e(this.event)(t,n,i)},t}();t.chain=d,t.fromNodeEventEmitter=_,t.fromPromise=m,t.toPromise=y}(e.Event||(e.Event={}));var u=-1,c=function(){function t(t,e){void 0===e&&(e=Math.random().toString(18).slice(2,5)),this.customThreshold=t,this.name=e,this._warnCountdown=0}return t.prototype.dispose=function(){this._stacks&&this._stacks.clear()},t.prototype.check=function(t){var e=this,n=u;if("number"==typeof this.customThreshold&&(n=this.customThreshold),0>=n||n>t)return void 0;this._stacks||(this._stacks=new Map);var i=(new Error).stack.split("\n").slice(3).join("\n"),r=this._stacks.get(i)||0;if(this._stacks.set(i,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=.5*n;var o,s=0;this._stacks.forEach(function(t,e){(!o||t>s)&&(o=e,s=t)}),console.warn("["+this.name+"] potential listener LEAK detected, having "+t+" listeners already. MOST frequent listener ("+s+"):"),console.warn(o)}return function(){var t=e._stacks.get(i)||0;e._stacks.set(i,t-1)}},t}(),f=function(){function t(t){this._disposed=!1,this._options=t,this._leakageMon=u>0?new c(this._options&&this._options.leakWarningThreshold):void 0}return Object.defineProperty(t.prototype,"event",{get:function(){var e=this;return this._event||(this._event=function(n,i,r){e._listeners||(e._listeners=new s.LinkedList);var o=e._listeners.isEmpty();o&&e._options&&e._options.onFirstListenerAdd&&e._options.onFirstListenerAdd(e);var u=e._listeners.push(i?[n,i]:n);o&&e._options&&e._options.onFirstListenerDidAdd&&e._options.onFirstListenerDidAdd(e),e._options&&e._options.onListenerDidAdd&&e._options.onListenerDidAdd(e,n,i);var c;e._leakageMon&&(c=e._leakageMon.check(e._listeners.size));var f;return f={dispose:function(){if(c&&c(),f.dispose=t._noop,!e._disposed&&(u(),e._options&&e._options.onLastListenerRemove)){var n=e._listeners&&!e._listeners.isEmpty();n||e._options.onLastListenerRemove(e)}}},Array.isArray(r)&&r.push(f),f}),this._event},enumerable:!0,configurable:!0}),t.prototype.fire=function(t){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(var e=this._listeners.iterator(),n=e.next();!n.done;n=e.next())this._deliveryQueue.push([n.value,t]);for(;this._deliveryQueue.size>0;){var r=this._deliveryQueue.shift(),o=r[0],u=r[1];try{"function"==typeof o?o.call(void 0,u):o[0].call(o[1],u)}catch(n){i.onUnexpectedError(n)}}}},t.prototype.dispose=function(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),this._disposed=!0},t._noop=function(){},t}();e.Emitter=f;var a=function(t){function e(e){var n=t.call(this,e)||this;return n._isPaused=0,n._eventQueue=new s.LinkedList,n._mergeFn=e&&e.merge,n}return n(e,t),e.prototype.pause=function(){this._isPaused++},e.prototype.resume=function(){if(0!==this._isPaused&&0===--this._isPaused)if(this._mergeFn){var e=this._eventQueue.toArray();this._eventQueue.clear(),t.prototype.fire.call(this,this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)t.prototype.fire.call(this,this._eventQueue.shift())},e.prototype.fire=function(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):t.prototype.fire.call(this,e))},e}(f);e.PauseableEmitter=a;var h=function(){function t(){var t=this;this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:function(){return t.onFirstListenerAdd()},onLastListenerRemove:function(){return t.onLastListenerRemove()}})}return Object.defineProperty(t.prototype,"event",{get:function(){return this.emitter.event},enumerable:!0,configurable:!0}),t.prototype.add=function(t){var e=this,n={event:t,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);var i=function(){e.hasListeners&&e.unhook(n);var t=e.events.indexOf(n);e.events.splice(t,1)};return o.toDisposable(r.once(i))},t.prototype.onFirstListenerAdd=function(){var t=this;this.hasListeners=!0,this.events.forEach(function(e){return t.hook(e)})},t.prototype.onLastListenerRemove=function(){var t=this;this.hasListeners=!1,this.events.forEach(function(e){return t.unhook(e)})},t.prototype.hook=function(t){var e=this;t.listener=t.event(function(t){return e.emitter.fire(t)})},t.prototype.unhook=function(t){t.listener&&t.listener.dispose(),t.listener=null},t.prototype.dispose=function(){this.emitter.dispose()},t}();e.EventMultiplexer=h;var p=function(){function t(){this.buffers=[]}return t.prototype.wrapEvent=function(t){var e=this;return function(n,i,r){return t(function(t){var r=e.buffers[e.buffers.length-1];r?r.push(function(){return n.call(i,t)}):n.call(i,t)},void 0,r)}},t.prototype.bufferEvents=function(t){var e=[];this.buffers.push(e);var n=t();return this.buffers.pop(),e.forEach(function(t){return t()}),n},t}();e.EventBufferer=p;var v=function(){function t(){var t=this;this.listening=!1,this.inputEvent=e.Event.None,this.inputEventListener=o.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:function(){t.listening=!0,t.inputEventListener=t.inputEvent(t.emitter.fire,t.emitter)},onLastListenerRemove:function(){t.listening=!1,t.inputEventListener.dispose()}}),this.event=this.emitter.event}return Object.defineProperty(t.prototype,"input",{set:function(t){this.inputEvent=t,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=t(this.emitter.fire,this.emitter))},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){this.inputEventListener.dispose(),this.emitter.dispose()},t}();e.Relay=v});
/**! node_modules/monaco-editor/esm/vs/base/common/cancellation.js*/
define("7ed507d",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=e("8451667"),i=Object.freeze(function(e,t){var n=setTimeout(e.bind(t),0);return{dispose:function(){clearTimeout(n)}}});!function(e){function t(t){return t===e.None||t===e.Cancelled?!0:t instanceof o?!0:t&&"object"==typeof t?"boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested:!1}e.isCancellationToken=t,e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})}(t.CancellationToken||(t.CancellationToken={}));var o=function(){function e(){this._isCancelled=!1,this._emitter=null}return e.prototype.cancel=function(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))},Object.defineProperty(e.prototype,"isCancellationRequested",{get:function(){return this._isCancelled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onCancellationRequested",{get:function(){return this._isCancelled?i:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this._emitter&&(this._emitter.dispose(),this._emitter=null)},e}(),s=function(){function e(e){this._token=void 0,this._parentListener=void 0,this._parentListener=e&&e.onCancellationRequested(this.cancel,this)}return Object.defineProperty(e.prototype,"token",{get:function(){return this._token||(this._token=new o),this._token},enumerable:!0,configurable:!0}),e.prototype.cancel=function(){this._token?this._token instanceof o&&this._token.cancel():this._token=t.CancellationToken.Cancelled},e.prototype.dispose=function(){this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof o&&this._token.dispose():this._token=t.CancellationToken.None},e}();t.CancellationTokenSource=s});
/**! node_modules/monaco-editor/esm/vs/editor/common/standalone/promise-polyfill/polyfill.js*/
define("4a24931",function(e,n,t,o){!function(e,r){"object"==typeof n&&"undefined"!=typeof t?r():"function"==typeof o&&o.amd?o(r):r()}(this,function(){"use strict";function e(e){var n=this.constructor;return this.then(function(t){return n.resolve(e()).then(function(){return t})},function(t){return n.resolve(e()).then(function(){return n.reject(t)})})}function n(){}function t(e,n){return function(){e.apply(n,arguments)}}function o(e){if(!(this instanceof o))throw new TypeError("Promises must be constructed via new");if("function"!=typeof e)throw new TypeError("not a function");this._state=0,this._handled=!1,this._value=void 0,this._deferreds=[],a(e,this)}function r(e,n){for(;3===e._state;)e=e._value;return 0===e._state?void e._deferreds.push(n):(e._handled=!0,void o._immediateFn(function(){var t=1===e._state?n.onFulfilled:n.onRejected;if(null===t)return void(1===e._state?i:f)(n.promise,e._value);var o;try{o=t(e._value)}catch(r){return void f(n.promise,r)}i(n.promise,o)}))}function i(e,n){try{if(n===e)throw new TypeError("A promise cannot be resolved with itself.");if(n&&("object"==typeof n||"function"==typeof n)){var r=n.then;if(n instanceof o)return e._state=3,e._value=n,void u(e);if("function"==typeof r)return void a(t(r,n),e)}e._state=1,e._value=n,u(e)}catch(i){f(e,i)}}function f(e,n){e._state=2,e._value=n,u(e)}function u(e){2===e._state&&0===e._deferreds.length&&o._immediateFn(function(){e._handled||o._unhandledRejectionFn(e._value)});for(var n=0,t=e._deferreds.length;t>n;n++)r(e,e._deferreds[n]);e._deferreds=null}function c(e,n,t){this.onFulfilled="function"==typeof e?e:null,this.onRejected="function"==typeof n?n:null,this.promise=t}function a(e,n){var t=!1;try{e(function(e){t||(t=!0,i(n,e))},function(e){t||(t=!0,f(n,e))})}catch(o){if(t)return;t=!0,f(n,o)}}var l=setTimeout;o.prototype["catch"]=function(e){return this.then(null,e)},o.prototype.then=function(e,t){var o=new this.constructor(n);return r(this,new c(e,t,o)),o},o.prototype["finally"]=e,o.all=function(e){return new o(function(n,t){function o(e,f){try{if(f&&("object"==typeof f||"function"==typeof f)){var u=f.then;if("function"==typeof u)return void u.call(f,function(n){o(e,n)},t)}r[e]=f,0===--i&&n(r)}catch(c){t(c)}}if(!e||"undefined"==typeof e.length)throw new TypeError("Promise.all accepts an array");var r=Array.prototype.slice.call(e);if(0===r.length)return n([]);for(var i=r.length,f=0;f<r.length;f++)o(f,r[f])})},o.resolve=function(e){return e&&"object"==typeof e&&e.constructor===o?e:new o(function(n){n(e)})},o.reject=function(e){return new o(function(n,t){t(e)})},o.race=function(e){return new o(function(n,t){for(var o=0,r=e.length;r>o;o++)e[o].then(n,t)})},o._immediateFn="function"==typeof setImmediate&&function(e){setImmediate(e)}||function(e){l(e,0)},o._unhandledRejectionFn=function(e){"undefined"!=typeof console&&console&&console.warn("Possible Unhandled Promise Rejection:",e)};var s=function(){if("undefined"!=typeof self)return self;if("undefined"!=typeof window)return window;if("undefined"!=typeof global)return global;throw new Error("unable to locate global object")}();"Promise"in s?s.Promise.prototype["finally"]||(s.Promise.prototype["finally"]=e):s.Promise=o})});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/uint.js*/
define("4186ef1",function(t,n){"use strict";function r(t){return 0>t?0:t>255?255:0|t}function i(t){return 0>t?0:t>4294967295?4294967295:0|t}function e(t){for(var n=t.length,r=new Uint32Array(n),e=0;n>e;e++)r[e]=i(t[e]);return r}Object.defineProperty(n,"__esModule",{value:!0});var o=function(){function t(t,n,r){for(var i=new Uint8Array(t*n),e=0,o=t*n;o>e;e++)i[e]=r;this._data=i,this.rows=t,this.cols=n}return t.prototype.get=function(t,n){return this._data[t*this.cols+n]},t.prototype.set=function(t,n,r){this._data[t*this.cols+n]=r},t}();n.Uint8Matrix=o,n.toUint8=r,n.toUint32=i,n.toUint32Array=e});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/characterClassifier.js*/
define("206e614",function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i=t("4186ef1"),a=function(){function t(e){var a=i.toUint8(e);this._defaultValue=a,this._asciiMap=t._createAsciiMap(a),this._map=new Map}return t._createAsciiMap=function(t){for(var e=new Uint8Array(256),i=0;256>i;i++)e[i]=t;return e},t.prototype.set=function(t,e){var a=i.toUint8(e);t>=0&&256>t?this._asciiMap[t]=a:this._map.set(t,a)},t.prototype.get=function(t){return t>=0&&256>t?this._asciiMap[t]:this._map.get(t)||this._defaultValue},t}();e.CharacterClassifier=a;var n=function(){function t(){this._actual=new a(0)}return t.prototype.add=function(t){this._actual.set(t,1)},t.prototype.has=function(t){return 1===this._actual.get(t)},t}();e.CharacterSet=n});
/**! node_modules/monaco-editor/esm/vs/editor/common/viewModel/prefixSumComputer.js*/
define("cf86ba2",function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i=t("4186ef1"),u=function(){function t(t,e){this.index=t,this.remainder=e}return t}();e.PrefixSumIndexOfResult=u;var a=function(){function t(t){this.values=t,this.prefixSum=new Uint32Array(t.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}return t.prototype.getCount=function(){return this.values.length},t.prototype.insertValues=function(t,e){t=i.toUint32(t);var u=this.values,a=this.prefixSum,r=e.length;return 0===r?!1:(this.values=new Uint32Array(u.length+r),this.values.set(u.subarray(0,t),0),this.values.set(u.subarray(t),t+r),this.values.set(e,t),t-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=t-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},t.prototype.changeValue=function(t,e){return t=i.toUint32(t),e=i.toUint32(e),this.values[t]===e?!1:(this.values[t]=e,t-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=t-1),!0)},t.prototype.removeValues=function(t,e){t=i.toUint32(t),e=i.toUint32(e);var u=this.values,a=this.prefixSum;if(t>=u.length)return!1;var r=u.length-t;return e>=r&&(e=r),0===e?!1:(this.values=new Uint32Array(u.length-e),this.values.set(u.subarray(0,t),0),this.values.set(u.subarray(t+e),t),this.prefixSum=new Uint32Array(this.values.length),t-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=t-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},t.prototype.getTotalValue=function(){return 0===this.values.length?0:this._getAccumulatedValue(this.values.length-1)},t.prototype.getAccumulatedValue=function(t){return 0>t?0:(t=i.toUint32(t),this._getAccumulatedValue(t))},t.prototype._getAccumulatedValue=function(t){if(t<=this.prefixSumValidIndex[0])return this.prefixSum[t];var e=this.prefixSumValidIndex[0]+1;0===e&&(this.prefixSum[0]=this.values[0],e++),t>=this.values.length&&(t=this.values.length-1);for(var i=e;t>=i;i++)this.prefixSum[i]=this.prefixSum[i-1]+this.values[i];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],t),this.prefixSum[t]},t.prototype.getIndexOf=function(t){t=Math.floor(t),this.getTotalValue();for(var e=0,i=this.values.length-1,a=0,r=0,s=0;i>=e;)if(a=e+(i-e)/2|0,r=this.prefixSum[a],s=r-this.values[a],s>t)i=a-1;else{if(!(t>=r))break;e=a+1}return new u(a,t-s)},t}();e.PrefixSumComputer=a;var r=function(){function t(t){this._cacheAccumulatedValueStart=0,this._cache=null,this._actual=new a(t),this._bustCache()}return t.prototype._bustCache=function(){this._cacheAccumulatedValueStart=0,this._cache=null},t.prototype.insertValues=function(t,e){this._actual.insertValues(t,e)&&this._bustCache()},t.prototype.changeValue=function(t,e){this._actual.changeValue(t,e)&&this._bustCache()},t.prototype.removeValues=function(t,e){this._actual.removeValues(t,e)&&this._bustCache()},t.prototype.getTotalValue=function(){return this._actual.getTotalValue()},t.prototype.getAccumulatedValue=function(t){return this._actual.getAccumulatedValue(t)},t.prototype.getIndexOf=function(t){if(t=Math.floor(t),null!==this._cache){var e=t-this._cacheAccumulatedValueStart;if(e>=0&&e<this._cache.length)return this._cache[e]}return this._actual.getIndexOf(t)},t.prototype.warmUpCache=function(t,e){for(var i=[],u=t;e>=u;u++)i[u-t]=this.getIndexOf(u);this._cache=i,this._cacheAccumulatedValueStart=t},t}();e.PrefixSumComputerWithCache=r});
/**! node_modules/monaco-editor/esm/vs/base/common/strings.js*/
define("572f899",function(r,t){"use strict";function e(r){return r&&"string"==typeof r?0===r.trim().length:!0}function n(r,t,e){void 0===e&&(e="0");for(var n=""+r,u=[n],i=n.length;t>i;i++)u.push(e);return u.reverse().join("")}function u(r){for(var t=[],e=1;e<arguments.length;e++)t[e-1]=arguments[e];return 0===t.length?r:r.replace(U,function(r,e){var n=parseInt(e,10);return isNaN(n)||0>n||n>=t.length?r:t[n]})}function i(r){return r.replace(/[<>&]/g,function(r){switch(r){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return r}})}function o(r){return r.replace(/[\-\\\{\}\*\+\?\|\^\$\.\[\]\(\)\#]/g,"\\$&")}function a(r,t){void 0===t&&(t=" ");var e=f(r,t);return c(e,t)}function f(r,t){if(!r||!t)return r;var e=t.length;if(0===e||0===r.length)return r;for(var n=0;r.indexOf(t,n)===n;)n+=e;return r.substring(n)}function c(r,t){if(!r||!t)return r;var e=t.length,n=r.length;if(0===e||0===n)return r;for(var u=n,i=-1;;){if(i=r.lastIndexOf(t,u-1),-1===i||i+e!==u)break;if(0===i)return"";u=i}return r.substring(0,u)}function s(r){return r.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function g(r,t){if(r.length<t.length)return!1;if(r===t)return!0;for(var e=0;e<t.length;e++)if(r[e]!==t[e])return!1;return!0}function h(r,t){var e=r.length-t.length;return e>0?r.indexOf(t,e)===e:0===e?r===t:!1}function l(r,t,e){if(void 0===e&&(e={}),!r)throw new Error("Cannot create regex from empty string");t||(r=o(r)),e.wholeWord&&(/\B/.test(r.charAt(0))||(r="\\b"+r),/\B/.test(r.charAt(r.length-1))||(r+="\\b"));var n="";return e.global&&(n+="g"),e.matchCase||(n+="i"),e.multiline&&(n+="m"),e.unicode&&(n+="u"),new RegExp(r,n)}function D(r){if("^"===r.source||"^$"===r.source||"$"===r.source||"^\\s*$"===r.source)return!1;var t=r.exec("");return!(!t||0!==r.lastIndex)}function F(r){return(r.global?"g":"")+(r.ignoreCase?"i":"")+(r.multiline?"m":"")+(r.unicode?"u":"")}function C(r){for(var t=0,e=r.length;e>t;t++){var n=r.charCodeAt(t);if(32!==n&&9!==n)return t}return-1}function d(r,t,e){void 0===t&&(t=0),void 0===e&&(e=r.length);for(var n=t;e>n;n++){var u=r.charCodeAt(n);if(32!==u&&9!==u)return r.substring(t,n)}return r.substring(t,e)}function v(r,t){void 0===t&&(t=r.length-1);for(var e=t;e>=0;e--){var n=r.charCodeAt(e);if(32!==n&&9!==n)return e}return-1}function E(r,t){return t>r?-1:r>t?1:0}function p(r){return r>=97&&122>=r}function m(r){return r>=65&&90>=r}function A(r){return p(r)||m(r)}function B(r,t){var e=r?r.length:0,n=t?t.length:0;return e!==n?!1:x(r,t)}function x(r,t,e){if(void 0===e&&(e=r.length),"string"!=typeof r||"string"!=typeof t)return!1;for(var n=0;e>n;n++){var u=r.charCodeAt(n),i=t.charCodeAt(n);if(u!==i)if(A(u)&&A(i)){var o=Math.abs(u-i);if(0!==o&&32!==o)return!1}else if(String.fromCharCode(u).toLowerCase()!==String.fromCharCode(i).toLowerCase())return!1}return!0}function b(r,t){var e=t.length;return t.length>r.length?!1:x(r,t,e)}function L(r,t){var e,n=Math.min(r.length,t.length);for(e=0;n>e;e++)if(r.charCodeAt(e)!==t.charCodeAt(e))return e;return n}function W(r,t){var e,n=Math.min(r.length,t.length),u=r.length-1,i=t.length-1;for(e=0;n>e;e++)if(r.charCodeAt(u-e)!==t.charCodeAt(i-e))return e;return n}function I(r){return r>=55296&&56319>=r}function w(r){return r>=56320&&57343>=r}function R(r){return _.test(r)}function S(r){return j.test(r)}function $(r){return P.test(r)}function y(r){for(var t=0,e=r.length;e>t;t++)if(O(r.charCodeAt(t)))return!0;return!1}function O(r){return r=+r,r>=11904&&55215>=r||r>=63744&&64255>=r||r>=65281&&65374>=r}function M(r){return!!(r&&r.length>0&&65279===r.charCodeAt(0))}function T(r){return btoa(encodeURIComponent(r))}function N(r,t){for(var e="",n=0;t>n;n++)e+=r;return e}Object.defineProperty(t,"__esModule",{value:!0}),t.empty="",t.isFalsyOrWhitespace=e,t.pad=n;var U=/{(\d+)}/g;t.format=u,t.escape=i,t.escapeRegExpCharacters=o,t.trim=a,t.ltrim=f,t.rtrim=c,t.convertSimple2RegExpPattern=s,t.startsWith=g,t.endsWith=h,t.createRegExp=l,t.regExpLeadsToEndlessLoop=D,t.regExpFlags=F,t.firstNonWhitespaceIndex=C,t.getLeadingWhitespace=d,t.lastNonWhitespaceIndex=v,t.compare=E,t.isLowerAsciiLetter=p,t.isUpperAsciiLetter=m,t.equalsIgnoreCase=B,t.startsWithIgnoreCase=b,t.commonPrefixLength=L,t.commonSuffixLength=W,t.isHighSurrogate=I,t.isLowSurrogate=w;var _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;t.containsRTL=R;var j=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEF8]|\uD83E[\uDD00-\uDDE6])/;t.containsEmoji=S;var P=/^[\t\n\r\x20-\x7E]*$/;t.isBasicASCII=$,t.containsFullWidthCharacter=y,t.isFullWidthCharacter=O,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),t.startsWithUTF8BOM=M,t.safeBtoa=T,t.repeat=N});
/**! node_modules/monaco-editor/esm/vs/base/common/diff/diffChange.js*/
define("a895ddf",function(i,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var e=function(){function i(i,t,e,n){this.originalStart=i,this.originalLength=t,this.modifiedStart=e,this.modifiedLength=n}return i.prototype.getOriginalEnd=function(){return this.originalStart+this.originalLength},i.prototype.getModifiedEnd=function(){return this.modifiedStart+this.modifiedLength},i}();t.DiffChange=e});
/**! node_modules/monaco-editor/esm/vs/base/common/types.js*/
define("01fef85",function(n,t){"use strict";function r(n){return Array.isArray?Array.isArray(n):n&&typeof n.length===b.number&&n.constructor===Array?!0:!1}function e(n){return typeof n===b.string||n instanceof String?!0:!1}function o(n){return!(typeof n!==b.object||null===n||Array.isArray(n)||n instanceof RegExp||n instanceof Date)}function i(n){return(typeof n===b.number||n instanceof Number)&&!isNaN(n)?!0:!1}function u(n){return n===!0||n===!1}function f(n){return typeof n===b.undefined}function c(n){return f(n)||null===n}function a(n){if(!o(n))return!1;for(var t in n)if(m.call(n,t))return!1;return!0}function s(n){return typeof n===b.function}function l(n,t){for(var r=Math.min(n.length,t.length),e=0;r>e;e++)y(n[e],t[e])}function y(n,t){if(e(t)){if(typeof n!==t)throw new Error("argument does not match constraint: typeof "+t)}else if(s(t)){try{if(n instanceof t)return}catch(r){}if(!c(n)&&n.constructor===t)return;if(1===t.length&&t.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function d(n){for(var t=[],r=Object.getPrototypeOf(n);Object.prototype!==r;)t=t.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return t}function p(n){return null===n?void 0:n}function g(n){return"undefined"==typeof n?null:n}Object.defineProperty(t,"__esModule",{value:!0});var b={number:"number",string:"string",undefined:"undefined",object:"object","function":"function"};t.isArray=r,t.isString=e,t.isObject=o,t.isNumber=i,t.isBoolean=u,t.isUndefined=f,t.isUndefinedOrNull=c;var m=Object.prototype.hasOwnProperty;t.isEmptyObject=a,t.isFunction=s,t.validateConstraints=l,t.validateConstraint=y,t.getAllPropertyNames=d,t.withNullAsUndefined=p,t.withUndefinedAsNull=g});
/**! node_modules/monaco-editor/esm/vs/editor/common/standalone/standaloneBase.js*/
define("4dc9450",function(e,o){"use strict";function n(){return{editor:void 0,languages:void 0,CancellationTokenSource:t.CancellationTokenSource,Emitter:i.Emitter,KeyCode:S.KeyCode,KeyMod:k,Position:d.Position,Range:l.Range,Selection:u.Selection,SelectionDirection:S.SelectionDirection,MarkerSeverity:S.MarkerSeverity,MarkerTag:S.MarkerTag,Uri:c.URI,Token:f.Token}}Object.defineProperty(o,"__esModule",{value:!0});var r=e("11ed2ab");e("4a24931");var t=e("7ed507d"),i=e("8451667"),a=e("651ae9b"),c=e("50db2b4"),d=e("5ddf902"),l=e("4661130"),u=e("3b7eb07"),f=e("57d67ff"),S=r.__importStar(e("2e266ae")),k=function(){function e(){}return e.chord=function(e,o){return a.KeyChord(e,o)},e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256,e}();o.KeyMod=k,o.createMonacoBaseAPI=n});
/**! node_modules/monaco-editor/esm/vs/editor/common/modes/supports/inplaceReplaceSupport.js*/
define("670df80",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(){function e(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}return e.prototype.navigateValueSet=function(e,t,a,l,n){if(e&&t){var r=this.doNavigateValueSet(t,n);if(r)return{range:e,value:r}}if(a&&l){var r=this.doNavigateValueSet(l,n);if(r)return{range:a,value:r}}return null},e.prototype.doNavigateValueSet=function(e,t){var a=this.numberReplace(e,t);return null!==a?a:this.textReplace(e,t)},e.prototype.numberReplace=function(e,t){var a=Math.pow(10,e.length-(e.lastIndexOf(".")+1)),l=Number(e),n=parseFloat(e);return isNaN(l)||isNaN(n)||l!==n?null:0!==l||t?(l=Math.floor(l*a),l+=t?a:-a,String(l/a)):null},e.prototype.textReplace=function(e,t){return this.valueSetsReplace(this._defaultValueSet,e,t)},e.prototype.valueSetsReplace=function(e,t,a){for(var l=null,n=0,r=e.length;null===l&&r>n;n++)l=this.valueSetReplace(e[n],t,a);return l},e.prototype.valueSetReplace=function(e,t,a){var l=e.indexOf(t);return l>=0?(l+=a?1:-1,0>l?l=e.length-1:l%=e.length,e[l]):null},e.INSTANCE=new e,e}();t.BasicInplaceReplace=a});
/**! node_modules/monaco-editor/esm/vs/editor/common/modes/linkComputer.js*/
define("fabf684",function(e,t){"use strict";function n(){return null===c&&(c=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),c}function r(){if(null===s){s=new i.CharacterClassifier(0);for(var e=" 	<>'\"、。｡､，．：；？！＠＃＄％＆＊‘“〈《「『【〔（［｛｢｣｝］）〕】』」》〉”’｀～…",t=0;t<e.length;t++)s.set(e.charCodeAt(t),1);for(var n=".,;",t=0;t<n.length;t++)s.set(n.charCodeAt(t),2)}return s}function a(e){return e&&"function"==typeof e.getLineCount&&"function"==typeof e.getLineContent?f.computeLinks(e):[]}Object.defineProperty(t,"__esModule",{value:!0});var i=e("206e614"),o=e("4186ef1"),u=function(){function e(e){for(var t=0,n=0,r=0,a=e.length;a>r;r++){var i=e[r],u=i[0],c=i[1],s=i[2];c>t&&(t=c),u>n&&(n=u),s>n&&(n=s)}t++,n++;for(var f=new o.Uint8Matrix(n,t,0),r=0,a=e.length;a>r;r++){var h=e[r],u=h[0],c=h[1],s=h[2];f.set(u,c,s)}this._states=f,this._maxCharCode=t}return e.prototype.nextState=function(e,t){return 0>t||t>=this._maxCharCode?0:this._states.get(e,t)},e}();t.StateMachine=u;var c=null,s=null,f=function(){function e(){}return e._createLink=function(e,t,n,r,a){var i=a-1;do{var o=t.charCodeAt(i),u=e.get(o);if(2!==u)break;i--}while(i>r);if(r>0){var c=t.charCodeAt(r-1),s=t.charCodeAt(i);(40===c&&41===s||91===c&&93===s||123===c&&125===s)&&i--}return{range:{startLineNumber:n,startColumn:r+1,endLineNumber:n,endColumn:i+2},url:t.substring(r,i+1)}},e.computeLinks=function(t,a){void 0===a&&(a=n());for(var i=r(),o=[],u=1,c=t.getLineCount();c>=u;u++){for(var s=t.getLineContent(u),f=s.length,h=0,l=0,v=0,C=1,d=!1,k=!1,b=!1;f>h;){var g=!1,L=s.charCodeAt(h);if(13===C){var m=void 0;switch(L){case 40:d=!0,m=0;break;case 41:m=d?0:1;break;case 91:k=!0,m=0;break;case 93:m=k?0:1;break;case 123:b=!0,m=0;break;case 125:m=b?0:1;break;case 39:m=34===v||96===v?0:1;break;case 34:m=39===v||96===v?0:1;break;case 96:m=39===v||34===v?0:1;break;default:m=i.get(L)}1===m&&(o.push(e._createLink(i,s,u,l,h)),g=!0)}else if(12===C){var m=void 0;91===L?(k=!0,m=0):m=i.get(L),1===m?g=!0:C=13}else C=a.nextState(C,L),0===C&&(g=!0);g&&(C=1,d=!1,k=!1,b=!1,l=h+1,v=L),h++}13===C&&o.push(e._createLink(i,s,u,l,f))}return o},e}();t.LinkComputer=f,t.computeLinks=a});
/**! node_modules/monaco-editor/esm/vs/editor/common/model/wordHelper.js*/
define("3af5c49",function(e,n){"use strict";function r(e){void 0===e&&(e="");for(var r="(-?\\d*\\.\\d\\w*)|([^",t=0,a=n.USUAL_WORD_SEPARATORS;t<a.length;t++){var i=a[t];e.indexOf(i)>=0||(r+="\\"+i)}return r+="\\s]+)",new RegExp(r,"g")}function t(e){var r=n.DEFAULT_WORD_REGEXP;if(e&&e instanceof RegExp)if(e.global)r=e;else{var t="g";e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),e.unicode&&(t+="u"),r=new RegExp(e.source,t)}return r.lastIndex=0,r}function a(e,n,r,t){var a=e-1-t,i=r.lastIndexOf(" ",a-1)+1;n.lastIndex=i;for(var l;l=n.exec(r);){var u=l.index||0;if(a>=u&&n.lastIndex>=a)return{word:l[0],startColumn:t+1+u,endColumn:t+1+n.lastIndex}}return null}function i(e,n,r,t){var a=e-1-t;n.lastIndex=0;for(var i;i=n.exec(r);){var l=i.index||0;if(l>a)return null;if(n.lastIndex>=a)return{word:i[0],startColumn:t+1+l,endColumn:t+1+n.lastIndex}}return null}function l(e,n,r,t){n.lastIndex=0;var l=n.exec(r);if(!l)return null;var u=l[0].indexOf(" ")>=0?i(e,n,r,t):a(e,n,r,t);return n.lastIndex=0,u}Object.defineProperty(n,"__esModule",{value:!0}),n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?",n.DEFAULT_WORD_REGEXP=r(),n.ensureValidWordDefinition=t,n.getWordAtText=l});
/**! node_modules/monaco-editor/esm/vs/editor/common/model/mirrorTextModel.js*/
define("6250482",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=e("5ddf902"),i=e("cf86ba2"),s=function(){function e(e,t,n,i){this._uri=e,this._lines=t,this._eol=n,this._versionId=i,this._lineStarts=null}return e.prototype.dispose=function(){this._lines.length=0},e.prototype.getText=function(){return this._lines.join(this._eol)},e.prototype.onEvents=function(e){e.eol&&e.eol!==this._eol&&(this._eol=e.eol,this._lineStarts=null);for(var t=e.changes,i=0,s=t;i<s.length;i++){var r=s[i];this._acceptDeleteRange(r.range),this._acceptInsertText(new n.Position(r.range.startLineNumber,r.range.startColumn),r.text)}this._versionId=e.versionId},e.prototype._ensureLineStarts=function(){if(!this._lineStarts){for(var e=this._eol.length,t=this._lines.length,n=new Uint32Array(t),s=0;t>s;s++)n[s]=this._lines[s].length+e;this._lineStarts=new i.PrefixSumComputer(n)}},e.prototype._setLineText=function(e,t){this._lines[e]=t,this._lineStarts&&this._lineStarts.changeValue(e,this._lines[e].length+this._eol.length)},e.prototype._acceptDeleteRange=function(e){if(e.startLineNumber===e.endLineNumber){if(e.startColumn===e.endColumn)return;return void this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.startLineNumber-1].substring(e.endColumn-1))}this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.endLineNumber-1].substring(e.endColumn-1)),this._lines.splice(e.startLineNumber,e.endLineNumber-e.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(e.startLineNumber,e.endLineNumber-e.startLineNumber)},e.prototype._acceptInsertText=function(e,t){if(0!==t.length){var n=t.split(/\r\n|\r|\n/);if(1===n.length)return void this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+n[0]+this._lines[e.lineNumber-1].substring(e.column-1));n[n.length-1]+=this._lines[e.lineNumber-1].substring(e.column-1),this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+n[0]);for(var i=new Uint32Array(n.length-1),s=1;s<n.length;s++)this._lines.splice(e.lineNumber+s-1,0,n[s]),i[s-1]=n[s].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(e.lineNumber,i)}},e}();t.MirrorTextModel=s});
/**! node_modules/monaco-editor/esm/vs/editor/common/diff/diffComputer.js*/
define("d327c41",function(i,t){"use strict";function e(i,t,e,n){var r=new o.LcsDiff(i,t,e);return r.ComputeDiff(n)}function n(i){if(i.length<=1)return i;for(var t=[i[0]],e=t[0],n=1,r=i.length;r>n;n++){var o=i[n],a=o.originalStart-(e.originalStart+e.originalLength),h=o.modifiedStart-(e.modifiedStart+e.modifiedLength),u=Math.min(a,h);s>u?(e.originalLength=o.originalStart+o.originalLength-e.originalStart,e.modifiedLength=o.modifiedStart+o.modifiedLength-e.modifiedStart):(t.push(o),e=o)}return t}Object.defineProperty(t,"__esModule",{value:!0});var r=i("11ed2ab"),o=i("e1c5605"),a=r.__importStar(i("572f899")),h=5e3,s=3,u=function(){function i(t){for(var e=[],n=[],r=0,o=t.length;o>r;r++)e[r]=i._getFirstNonBlankColumn(t[r],1),n[r]=i._getLastNonBlankColumn(t[r],1);this._lines=t,this._startColumns=e,this._endColumns=n}return i.prototype.getLength=function(){return this._lines.length},i.prototype.getElementAtIndex=function(i){return this._lines[i].substring(this._startColumns[i]-1,this._endColumns[i]-1)},i.prototype.getStartLineNumber=function(i){return i+1},i.prototype.getEndLineNumber=function(i){return i+1},i._getFirstNonBlankColumn=function(i,t){var e=a.firstNonWhitespaceIndex(i);return-1===e?t:e+1},i._getLastNonBlankColumn=function(i,t){var e=a.lastNonWhitespaceIndex(i);return-1===e?t:e+2},i.prototype.getCharSequence=function(i,t,e){for(var n=[],r=[],o=[],a=0,h=t;e>=h;h++)for(var s=this._lines[h],u=i?this._startColumns[h]:1,m=i?this._endColumns[h]:s.length+1,g=u;m>g;g++)n[a]=s.charCodeAt(g-1),r[a]=h+1,o[a]=g,a++;return new d(n,r,o)},i}(),d=function(){function i(i,t,e){this._charCodes=i,this._lineNumbers=t,this._columns=e}return i.prototype.getLength=function(){return this._charCodes.length},i.prototype.getElementAtIndex=function(i){return this._charCodes[i]},i.prototype.getStartLineNumber=function(i){return this._lineNumbers[i]},i.prototype.getStartColumn=function(i){return this._columns[i]},i.prototype.getEndLineNumber=function(i){return this._lineNumbers[i]},i.prototype.getEndColumn=function(i){return this._columns[i]+1},i}(),m=function(){function i(i,t,e,n,r,o,a,h){this.originalStartLineNumber=i,this.originalStartColumn=t,this.originalEndLineNumber=e,this.originalEndColumn=n,this.modifiedStartLineNumber=r,this.modifiedStartColumn=o,this.modifiedEndLineNumber=a,this.modifiedEndColumn=h}return i.createFromDiffChange=function(t,e,n){var r,o,a,h,s,u,d,m;return 0===t.originalLength?(r=0,o=0,a=0,h=0):(r=e.getStartLineNumber(t.originalStart),o=e.getStartColumn(t.originalStart),a=e.getEndLineNumber(t.originalStart+t.originalLength-1),h=e.getEndColumn(t.originalStart+t.originalLength-1)),0===t.modifiedLength?(s=0,u=0,d=0,m=0):(s=n.getStartLineNumber(t.modifiedStart),u=n.getStartColumn(t.modifiedStart),d=n.getEndLineNumber(t.modifiedStart+t.modifiedLength-1),m=n.getEndColumn(t.modifiedStart+t.modifiedLength-1)),new i(r,o,a,h,s,u,d,m)},i}(),g=function(){function i(i,t,e,n,r){this.originalStartLineNumber=i,this.originalEndLineNumber=t,this.modifiedStartLineNumber=e,this.modifiedEndLineNumber=n,this.charChanges=r}return i.createFromDiffResult=function(t,r,o,a,h,s,u){var d,g,l,f,c=void 0;if(0===r.originalLength?(d=o.getStartLineNumber(r.originalStart)-1,g=0):(d=o.getStartLineNumber(r.originalStart),g=o.getEndLineNumber(r.originalStart+r.originalLength-1)),0===r.modifiedLength?(l=a.getStartLineNumber(r.modifiedStart)-1,f=0):(l=a.getStartLineNumber(r.modifiedStart),f=a.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),s&&0!==r.originalLength&&0!==r.modifiedLength&&h()){var C=o.getCharSequence(t,r.originalStart,r.originalStart+r.originalLength-1),L=a.getCharSequence(t,r.modifiedStart,r.modifiedStart+r.modifiedLength-1),p=e(C,L,h,!0);u&&(p=n(p)),c=[];for(var S=0,N=p.length;N>S;S++)c.push(m.createFromDiffChange(p[S],C,L))}return new i(d,g,l,f,c)},i}(),l=function(){function i(i,t,e){this.shouldComputeCharChanges=e.shouldComputeCharChanges,this.shouldPostProcessCharChanges=e.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=e.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=e.shouldMakePrettyDiff,this.maximumRunTimeMs=h,this.originalLines=i,this.modifiedLines=t,this.original=new u(i),this.modified=new u(t)}return i.prototype.computeDiff=function(){if(1===this.original.getLength()&&0===this.original.getElementAtIndex(0).length)return[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.getLength(),charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}];if(1===this.modified.getLength()&&0===this.modified.getElementAtIndex(0).length)return[{originalStartLineNumber:1,originalEndLineNumber:this.original.getLength(),modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}];this.computationStartTime=(new Date).getTime();var i=e(this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldMakePrettyDiff);if(this.shouldIgnoreTrimWhitespace){for(var t=[],n=0,r=i.length;r>n;n++)t.push(g.createFromDiffResult(this.shouldIgnoreTrimWhitespace,i[n],this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return t}for(var o=[],a=0,h=0,n=-1,s=i.length;s>n;n++){for(var d=s>n+1?i[n+1]:null,m=d?d.originalStart:this.originalLines.length,l=d?d.modifiedStart:this.modifiedLines.length;m>a&&l>h;){var f=this.originalLines[a],c=this.modifiedLines[h];if(f!==c){for(var C=u._getFirstNonBlankColumn(f,1),L=u._getFirstNonBlankColumn(c,1);C>1&&L>1;){var p=f.charCodeAt(C-2),S=c.charCodeAt(L-2);if(p!==S)break;C--,L--}(C>1||L>1)&&this._pushTrimWhitespaceCharChange(o,a+1,1,C,h+1,1,L);for(var N=u._getLastNonBlankColumn(f,1),b=u._getLastNonBlankColumn(c,1),_=f.length+1,E=c.length+1;_>N&&E>b;){var p=f.charCodeAt(N-1),S=f.charCodeAt(b-1);if(p!==S)break;N++,b++}(_>N||E>b)&&this._pushTrimWhitespaceCharChange(o,a+1,N,_,h+1,b,E)}a++,h++}d&&(o.push(g.createFromDiffResult(this.shouldIgnoreTrimWhitespace,d,this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),a+=d.originalLength,h+=d.modifiedLength)}return o},i.prototype._pushTrimWhitespaceCharChange=function(i,t,e,n,r,o,a){if(!this._mergeTrimWhitespaceCharChange(i,t,e,n,r,o,a)){var h=void 0;this.shouldComputeCharChanges&&(h=[new m(t,e,t,n,r,o,r,a)]),i.push(new g(t,t,r,r,h))}},i.prototype._mergeTrimWhitespaceCharChange=function(i,t,e,n,r,o,a){var h=i.length;if(0===h)return!1;var s=i[h-1];return 0===s.originalEndLineNumber||0===s.modifiedEndLineNumber?!1:s.originalEndLineNumber+1===t&&s.modifiedEndLineNumber+1===r?(s.originalEndLineNumber=t,s.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&s.charChanges.push(new m(t,e,t,n,r,o,r,a)),!0):!1},i.prototype._continueProcessingPredicate=function(){if(0===this.maximumRunTimeMs)return!0;var i=(new Date).getTime();return i-this.computationStartTime<this.maximumRunTimeMs},i}();t.DiffComputer=l});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/range.js*/
define("4661130",function(n,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=n("5ddf902"),r=function(){function n(n,e,t,r){n>t||n===t&&e>r?(this.startLineNumber=t,this.startColumn=r,this.endLineNumber=n,this.endColumn=e):(this.startLineNumber=n,this.startColumn=e,this.endLineNumber=t,this.endColumn=r)}return n.prototype.isEmpty=function(){return n.isEmpty(this)},n.isEmpty=function(n){return n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn},n.prototype.containsPosition=function(e){return n.containsPosition(this,e)},n.containsPosition=function(n,e){return e.lineNumber<n.startLineNumber||e.lineNumber>n.endLineNumber?!1:e.lineNumber===n.startLineNumber&&e.column<n.startColumn?!1:e.lineNumber===n.endLineNumber&&e.column>n.endColumn?!1:!0},n.prototype.containsRange=function(e){return n.containsRange(this,e)},n.containsRange=function(n,e){return e.startLineNumber<n.startLineNumber||e.endLineNumber<n.startLineNumber?!1:e.startLineNumber>n.endLineNumber||e.endLineNumber>n.endLineNumber?!1:e.startLineNumber===n.startLineNumber&&e.startColumn<n.startColumn?!1:e.endLineNumber===n.endLineNumber&&e.endColumn>n.endColumn?!1:!0},n.prototype.plusRange=function(e){return n.plusRange(this,e)},n.plusRange=function(e,t){var r,u,i,m;return t.startLineNumber<e.startLineNumber?(r=t.startLineNumber,u=t.startColumn):t.startLineNumber===e.startLineNumber?(r=t.startLineNumber,u=Math.min(t.startColumn,e.startColumn)):(r=e.startLineNumber,u=e.startColumn),t.endLineNumber>e.endLineNumber?(i=t.endLineNumber,m=t.endColumn):t.endLineNumber===e.endLineNumber?(i=t.endLineNumber,m=Math.max(t.endColumn,e.endColumn)):(i=e.endLineNumber,m=e.endColumn),new n(r,u,i,m)},n.prototype.intersectRanges=function(e){return n.intersectRanges(this,e)},n.intersectRanges=function(e,t){var r=e.startLineNumber,u=e.startColumn,i=e.endLineNumber,m=e.endColumn,o=t.startLineNumber,s=t.startColumn,a=t.endLineNumber,b=t.endColumn;return o>r?(r=o,u=s):r===o&&(u=Math.max(u,s)),i>a?(i=a,m=b):i===a&&(m=Math.min(m,b)),r>i?null:r===i&&u>m?null:new n(r,u,i,m)},n.prototype.equalsRange=function(e){return n.equalsRange(this,e)},n.equalsRange=function(n,e){return!!n&&!!e&&n.startLineNumber===e.startLineNumber&&n.startColumn===e.startColumn&&n.endLineNumber===e.endLineNumber&&n.endColumn===e.endColumn},n.prototype.getEndPosition=function(){return new t.Position(this.endLineNumber,this.endColumn)},n.prototype.getStartPosition=function(){return new t.Position(this.startLineNumber,this.startColumn)},n.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},n.prototype.setEndPosition=function(e,t){return new n(this.startLineNumber,this.startColumn,e,t)},n.prototype.setStartPosition=function(e,t){return new n(e,t,this.endLineNumber,this.endColumn)},n.prototype.collapseToStart=function(){return n.collapseToStart(this)},n.collapseToStart=function(e){return new n(e.startLineNumber,e.startColumn,e.startLineNumber,e.startColumn)},n.fromPositions=function(e,t){return void 0===t&&(t=e),new n(e.lineNumber,e.column,t.lineNumber,t.column)},n.lift=function(e){return e?new n(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn):null},n.isIRange=function(n){return n&&"number"==typeof n.startLineNumber&&"number"==typeof n.startColumn&&"number"==typeof n.endLineNumber&&"number"==typeof n.endColumn},n.areIntersectingOrTouching=function(n,e){return n.endLineNumber<e.startLineNumber||n.endLineNumber===e.startLineNumber&&n.endColumn<e.startColumn?!1:e.endLineNumber<n.startLineNumber||e.endLineNumber===n.startLineNumber&&e.endColumn<n.startColumn?!1:!0},n.areIntersecting=function(n,e){return n.endLineNumber<e.startLineNumber||n.endLineNumber===e.startLineNumber&&n.endColumn<=e.startColumn?!1:e.endLineNumber<n.startLineNumber||e.endLineNumber===n.startLineNumber&&e.endColumn<=n.startColumn?!1:!0},n.compareRangesUsingStarts=function(n,e){if(n&&e){var t=0|n.startLineNumber,r=0|e.startLineNumber;if(t===r){var u=0|n.startColumn,i=0|e.startColumn;if(u===i){var m=0|n.endLineNumber,o=0|e.endLineNumber;if(m===o){var s=0|n.endColumn,a=0|e.endColumn;return s-a}return m-o}return u-i}return t-r}var b=n?1:0,N=e?1:0;return b-N},n.compareRangesUsingEnds=function(n,e){return n.endLineNumber===e.endLineNumber?n.endColumn===e.endColumn?n.startLineNumber===e.startLineNumber?n.startColumn-e.startColumn:n.startLineNumber-e.startLineNumber:n.endColumn-e.endColumn:n.endLineNumber-e.endLineNumber},n.spansMultipleLines=function(n){return n.endLineNumber>n.startLineNumber},n}();e.Range=r});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/position.js*/
define("5ddf902",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var u=function(){function e(e,n){this.lineNumber=e,this.column=n}return e.prototype.with=function(n,u){return void 0===n&&(n=this.lineNumber),void 0===u&&(u=this.column),n===this.lineNumber&&u===this.column?this:new e(n,u)},e.prototype.delta=function(e,n){return void 0===e&&(e=0),void 0===n&&(n=0),this.with(this.lineNumber+e,this.column+n)},e.prototype.equals=function(n){return e.equals(this,n)},e.equals=function(e,n){return e||n?!!e&&!!n&&e.lineNumber===n.lineNumber&&e.column===n.column:!0},e.prototype.isBefore=function(n){return e.isBefore(this,n)},e.isBefore=function(e,n){return e.lineNumber<n.lineNumber?!0:n.lineNumber<e.lineNumber?!1:e.column<n.column},e.prototype.isBeforeOrEqual=function(n){return e.isBeforeOrEqual(this,n)},e.isBeforeOrEqual=function(e,n){return e.lineNumber<n.lineNumber?!0:n.lineNumber<e.lineNumber?!1:e.column<=n.column},e.compare=function(e,n){var u=0|e.lineNumber,i=0|n.lineNumber;if(u===i){var r=0|e.column,t=0|n.column;return r-t}return u-i},e.prototype.clone=function(){return new e(this.lineNumber,this.column)},e.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},e.lift=function(n){return new e(n.lineNumber,n.column)},e.isIPosition=function(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column},e}();n.Position=u});
/**! node_modules/monaco-editor/esm/vs/base/common/uri.js*/
define("50db2b4",function(t,e){"use strict";function r(t,e){if(!t.scheme){if(e||y)throw new Error('[UriError]: Scheme is missing: {scheme: "", authority: "'+t.authority+'", path: "'+t.path+'", query: "'+t.query+'", fragment: "'+t.fragment+'"}');console.warn('[UriError]: Scheme is missing: {scheme: "", authority: "'+t.authority+'", path: "'+t.path+'", query: "'+t.query+'", fragment: "'+t.fragment+'"}')}if(t.scheme&&!p.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path)if(t.authority){if(!m.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(d.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}function n(t,e){return e||y?t||l:(t||(console.trace("BAD uri lacks scheme, falling back to file-scheme."),t="file"),t)}function i(t,e){switch(t){case"https":case"http":case"file":e?e[0]!==g&&(e=g+e):e=g}return e}function o(t,e){for(var r=void 0,n=-1,i=0;i<t.length;i++){var o=t.charCodeAt(i);if(o>=97&&122>=o||o>=65&&90>=o||o>=48&&57>=o||45===o||46===o||95===o||126===o||e&&47===o)-1!==n&&(r+=encodeURIComponent(t.substring(n,i)),n=-1),void 0!==r&&(r+=t.charAt(i));else{void 0===r&&(r=t.substr(0,i));var h=C[o];void 0!==h?(-1!==n&&(r+=encodeURIComponent(t.substring(n,i)),n=-1),r+=h):-1===n&&(n=i)}}return-1!==n&&(r+=encodeURIComponent(t.substring(n))),void 0!==r?r:t}function h(t){for(var e=void 0,r=0;r<t.length;r++){var n=t.charCodeAt(r);35===n||63===n?(void 0===e&&(e=t.substr(0,r)),e+=C[n]):void 0!==e&&(e+=t[r])}return void 0!==e?e:t}function s(t){var e;return e=t.authority&&t.path.length>1&&"file"===t.scheme?"//"+t.authority+t.path:47===t.path.charCodeAt(0)&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&58===t.path.charCodeAt(2)?t.path[1].toLowerCase()+t.path.substr(2):t.path,c.isWindows&&(e=e.replace(/\//g,"\\")),e}function a(t,e){var r=e?h:o,n="",i=t.scheme,s=t.authority,a=t.path,u=t.query,f=t.fragment;if(i&&(n+=i,n+=":"),(s||"file"===i)&&(n+=g,n+=g),s){var c=s.indexOf("@");if(-1!==c){var p=s.substr(0,c);s=s.substr(c+1),c=p.indexOf(":"),-1===c?n+=r(p,!1):(n+=r(p.substr(0,c),!1),n+=":",n+=r(p.substr(c+1),!1)),n+="@"}s=s.toLowerCase(),c=s.indexOf(":"),-1===c?n+=r(s,!1):(n+=r(s.substr(0,c),!1),n+=s.substr(c))}if(a){if(a.length>=3&&47===a.charCodeAt(0)&&58===a.charCodeAt(2)){var m=a.charCodeAt(1);m>=65&&90>=m&&(a="/"+String.fromCharCode(m+32)+":"+a.substr(3))}else if(a.length>=2&&58===a.charCodeAt(1)){var m=a.charCodeAt(0);m>=65&&90>=m&&(a=String.fromCharCode(m+32)+":"+a.substr(2))}n+=r(a,!0)}return u&&(n+="?",n+=r(u,!1)),f&&(n+="#",n+=e?f:o(f,!1)),n}Object.defineProperty(e,"__esModule",{value:!0});var u,f=this&&this.__extends||function(){var t=function(e,r){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])})(e,r)};return function(e,r){function n(){this.constructor=e}t(e,r),e.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}(),c=t("17c8d25"),p=/^\w[\w\d+.-]*$/,m=/^\//,d=/^\/\//,y=!0,l="",g="/",v=/^(([^:\/?#]+?):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,b=function(){function t(t,e,o,h,s,a){void 0===a&&(a=!1),"object"==typeof t?(this.scheme=t.scheme||l,this.authority=t.authority||l,this.path=t.path||l,this.query=t.query||l,this.fragment=t.fragment||l):(this.scheme=n(t,a),this.authority=e||l,this.path=i(this.scheme,o||l),this.query=h||l,this.fragment=s||l,r(this,a))}return t.isUri=function(e){return e instanceof t?!0:e?"string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme&&"function"==typeof e.fsPath&&"function"==typeof e.with&&"function"==typeof e.toString:!1},Object.defineProperty(t.prototype,"fsPath",{get:function(){return s(this)},enumerable:!0,configurable:!0}),t.prototype.with=function(t){if(!t)return this;var e=t.scheme,r=t.authority,n=t.path,i=t.query,o=t.fragment;return void 0===e?e=this.scheme:null===e&&(e=l),void 0===r?r=this.authority:null===r&&(r=l),void 0===n?n=this.path:null===n&&(n=l),void 0===i?i=this.query:null===i&&(i=l),void 0===o?o=this.fragment:null===o&&(o=l),e===this.scheme&&r===this.authority&&n===this.path&&i===this.query&&o===this.fragment?this:new w(e,r,n,i,o)},t.parse=function(t,e){void 0===e&&(e=!1);var r=v.exec(t);return r?new w(r[2]||l,decodeURIComponent(r[4]||l),decodeURIComponent(r[5]||l),decodeURIComponent(r[7]||l),decodeURIComponent(r[9]||l),e):new w(l,l,l,l,l)},t.file=function(t){var e=l;if(c.isWindows&&(t=t.replace(/\\/g,g)),t[0]===g&&t[1]===g){var r=t.indexOf(g,2);-1===r?(e=t.substring(2),t=g):(e=t.substring(2,r),t=t.substring(r)||g)}return new w("file",e,t,l,l)},t.from=function(t){return new w(t.scheme,t.authority,t.path,t.query,t.fragment)},t.prototype.toString=function(t){return void 0===t&&(t=!1),a(this,t)},t.prototype.toJSON=function(){return this},t.revive=function(e){if(e){if(e instanceof t)return e;var r=new w(e);return r._fsPath=e.fsPath,r._formatted=e.external,r}return e},t}();e.URI=b;var w=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e._formatted=null,e._fsPath=null,e}return f(e,t),Object.defineProperty(e.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=s(this)),this._fsPath},enumerable:!0,configurable:!0}),e.prototype.toString=function(t){return void 0===t&&(t=!1),t?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)},e.prototype.toJSON=function(){var t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t},e}(b),C=(u={},u[58]="%3A",u[47]="%2F",u[63]="%3F",u[35]="%23",u[91]="%5B",u[93]="%5D",u[64]="%40",u[33]="%21",u[36]="%24",u[38]="%26",u[39]="%27",u[40]="%28",u[41]="%29",u[42]="%2A",u[43]="%2B",u[44]="%2C",u[59]="%3B",u[61]="%3D",u[32]="%20",u)});
/**! node_modules/monaco-editor/esm/vs/base/common/platform.js*/
define("17c8d25",function(e,i){"use strict";function a(e){return null===c&&(c=i.globals.setImmediate?i.globals.setImmediate.bind(i.globals):i.globals.setTimeout.bind(i.globals)),c(e)}Object.defineProperty(i,"__esModule",{value:!0});var t="en",o=!1,s=!1,l=!1,n=!1,b=!1,d=void 0,g=t,r=!1;if("object"!=typeof navigator||r);else{var f=navigator.userAgent;o=f.indexOf("Windows")>=0,s=f.indexOf("Macintosh")>=0,l=f.indexOf("Linux")>=0,b=!0,d=navigator.language,g=d}var u=0;n&&(s?u=1:o?u=3:l&&(u=2)),i.isWindows=o,i.isMacintosh=s,i.isLinux=l,i.isNative=n,i.isWeb=b;var v="object"==typeof self?self:"object"==typeof global?global:{};i.globals=v;var c=null;i.setImmediate=a,i.OS=s?2:o?1:3});
/**! node_modules/monaco-editor/esm/vs/base/common/iterator.js*/
define("6ad26fe",function(t,n){"use strict";function r(t){return Array.isArray(t)?n.Iterator.fromArray(t):t}Object.defineProperty(n,"__esModule",{value:!0});var e=this&&this.__extends||function(){var t=function(n,r){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,n){t.__proto__=n}||function(t,n){for(var r in n)n.hasOwnProperty(r)&&(t[r]=n[r])})(n,r)};return function(n,r){function e(){this.constructor=n}t(n,r),n.prototype=null===r?Object.create(r):(e.prototype=r.prototype,new e)}}();n.FIN={done:!0,value:void 0},function(t){function r(){return s}function e(t,r,e){return void 0===r&&(r=0),void 0===e&&(e=t.length),{next:function(){return r>=e?n.FIN:{done:!1,value:t[r++]}}}}function i(n){return n?Array.isArray(n)?t.fromArray(n):n:t.empty()}function o(t,r){return{next:function(){var e=t.next();return e.done?n.FIN:{done:!1,value:r(e.value)}}}}function u(t,r){return{next:function(){for(;;){var e=t.next();if(e.done)return n.FIN;if(r(e.value))return{done:!1,value:e.value}}}}}function a(t,n){for(var r=t.next();!r.done;r=t.next())n(r.value)}function c(t){var n=[];return a(t,function(t){return n.push(t)}),n}var s={next:function(){return n.FIN}};t.empty=r,t.fromArray=e,t.from=i,t.map=o,t.filter=u,t.forEach=a,t.collect=c}(n.Iterator||(n.Iterator={})),n.getSequenceIterator=r;var i=function(){function t(t,n,r,e){void 0===n&&(n=0),void 0===r&&(r=t.length),void 0===e&&(e=n-1),this.items=t,this.start=n,this.end=r,this.index=e}return t.prototype.next=function(){return this.index=Math.min(this.index+1,this.end),this.current()},t.prototype.current=function(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]},t}();n.ArrayIterator=i;var o=function(t){function n(n,r,e,i){return void 0===r&&(r=0),void 0===e&&(e=n.length),void 0===i&&(i=r-1),t.call(this,n,r,e,i)||this}return e(n,t),n.prototype.current=function(){return t.prototype.current.call(this)},n.prototype.previous=function(){return this.index=Math.max(this.index-1,this.start-1),this.current()},n.prototype.first=function(){return this.index=this.start,this.current()},n.prototype.last=function(){return this.index=this.end-1,this.current()},n.prototype.parent=function(){return null},n}(i);n.ArrayNavigator=o;var u=function(){function t(t,n){this.iterator=t,this.fn=n}return t.prototype.next=function(){return this.fn(this.iterator.next())},t}();n.MappedIterator=u});
/**! node_modules/monaco-editor/esm/vs/base/common/diff/diff.js*/
define("e1c5605",function(t,e){"use strict";function i(t){return{getLength:function(){return t.length},getElementAtIndex:function(e){return t.charCodeAt(e)}}}function n(t,e,n){return new d(i(t),i(e)).ComputeDiff(n)}Object.defineProperty(e,"__esModule",{value:!0});var r=t("a895ddf");e.stringDiff=n;var o=function(){function t(){}return t.Assert=function(t,e){if(!t)throw new Error(e)},t}();e.Debug=o;var a=function(){function t(){}return t.Copy=function(t,e,i,n,r){for(var o=0;r>o;o++)i[n+o]=t[e+o]},t}();e.MyArray=a;var h=1447,s=function(){function t(){this.m_changes=[],this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE,this.m_originalCount=0,this.m_modifiedCount=0}return t.prototype.MarkNextChange=function(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new r.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE},t.prototype.AddOriginalElement=function(t,e){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_originalCount++},t.prototype.AddModifiedElement=function(t,e){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_modifiedCount++},t.prototype.getChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes},t.prototype.getReverseChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes},t}(),d=function(){function t(t,e,i){void 0===i&&(i=null),this.OriginalSequence=t,this.ModifiedSequence=e,this.ContinueProcessingPredicate=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}return t.prototype.ElementsAreEqual=function(t,e){return this.OriginalSequence.getElementAtIndex(t)===this.ModifiedSequence.getElementAtIndex(e)},t.prototype.OriginalElementsAreEqual=function(t,e){return this.OriginalSequence.getElementAtIndex(t)===this.OriginalSequence.getElementAtIndex(e)},t.prototype.ModifiedElementsAreEqual=function(t,e){return this.ModifiedSequence.getElementAtIndex(t)===this.ModifiedSequence.getElementAtIndex(e)},t.prototype.ComputeDiff=function(t){return this._ComputeDiff(0,this.OriginalSequence.getLength()-1,0,this.ModifiedSequence.getLength()-1,t)},t.prototype._ComputeDiff=function(t,e,i,n,r){var o=[!1],a=this.ComputeDiffRecursive(t,e,i,n,o);return r?this.PrettifyChanges(a):a},t.prototype.ComputeDiffRecursive=function(t,e,i,n,a){for(a[0]=!1;e>=t&&n>=i&&this.ElementsAreEqual(t,i);)t++,i++;for(;e>=t&&n>=i&&this.ElementsAreEqual(e,n);)e--,n--;if(t>e||i>n){var h=void 0;return n>=i?(o.Assert(t===e+1,"originalStart should only be one more than originalEnd"),h=[new r.DiffChange(t,0,i,n-i+1)]):e>=t?(o.Assert(i===n+1,"modifiedStart should only be one more than modifiedEnd"),h=[new r.DiffChange(t,e-t+1,i,0)]):(o.Assert(t===e+1,"originalStart should only be one more than originalEnd"),o.Assert(i===n+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}var s=[0],d=[0],g=this.ComputeRecursionPoint(t,e,i,n,s,d,a),f=s[0],u=d[0];if(null!==g)return g;if(!a[0]){var l=this.ComputeDiffRecursive(t,f,i,u,a),m=[];return m=a[0]?[new r.DiffChange(f+1,e-(f+1)+1,u+1,n-(u+1)+1)]:this.ComputeDiffRecursive(f+1,e,u+1,n,a),this.ConcatenateChanges(l,m)}return[new r.DiffChange(t,e-t+1,i,n-i+1)]},t.prototype.WALKTRACE=function(t,e,i,n,o,a,h,d,g,f,u,l,m,c,p,C,y,S){var _,A=null,v=null,E=new s,L=e,M=i,q=m[0]-C[0]-n,O=Number.MIN_VALUE,w=this.m_forwardHistory.length-1;do _=q+t,_===L||M>_&&g[_-1]<g[_+1]?(u=g[_+1],c=u-q-n,O>u&&E.MarkNextChange(),O=u,E.AddModifiedElement(u+1,c),q=_+1-t):(u=g[_-1]+1,c=u-q-n,O>u&&E.MarkNextChange(),O=u-1,E.AddOriginalElement(u,c+1),q=_-1-t),w>=0&&(g=this.m_forwardHistory[w],t=g[0],L=1,M=g.length-1);while(--w>=-1);if(A=E.getReverseChanges(),S[0]){var D=m[0]+1,I=C[0]+1;if(null!==A&&A.length>0){var b=A[A.length-1];D=Math.max(D,b.getOriginalEnd()),I=Math.max(I,b.getModifiedEnd())}v=[new r.DiffChange(D,l-D+1,I,p-I+1)]}else{E=new s,L=a,M=h,q=m[0]-C[0]-d,O=Number.MAX_VALUE,w=y?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do _=q+o,_===L||M>_&&f[_-1]>=f[_+1]?(u=f[_+1]-1,c=u-q-d,u>O&&E.MarkNextChange(),O=u+1,E.AddOriginalElement(u+1,c+1),q=_+1-o):(u=f[_-1],c=u-q-d,u>O&&E.MarkNextChange(),O=u,E.AddModifiedElement(u+1,c+1),q=_-1-o),w>=0&&(f=this.m_reverseHistory[w],o=f[0],L=1,M=f.length-1);while(--w>=-1);v=E.getChanges()}return this.ConcatenateChanges(A,v)},t.prototype.ComputeRecursionPoint=function(t,e,i,n,o,s,d){var g,f=0,u=0,l=0,m=0,c=0,p=0;t--,i--,o[0]=0,s[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];var C=e-t+(n-i),y=C+1,S=new Array(y),_=new Array(y),A=n-i,v=e-t,E=t-i,L=e-n,M=v-A,q=M%2===0;S[A]=t,_[v]=e,d[0]=!1;var O,w;for(g=1;C/2+1>=g;g++){var D=0,I=0;for(l=this.ClipDiagonalBound(A-g,g,A,y),m=this.ClipDiagonalBound(A+g,g,A,y),O=l;m>=O;O+=2){for(f=O===l||m>O&&S[O-1]<S[O+1]?S[O+1]:S[O-1]+1,u=f-(O-A)-E,w=f;e>f&&n>u&&this.ElementsAreEqual(f+1,u+1);)f++,u++;if(S[O]=f,f+u>D+I&&(D=f,I=u),!q&&Math.abs(O-v)<=g-1&&f>=_[O])return o[0]=f,s[0]=u,w<=_[O]&&h>0&&h+1>=g?this.WALKTRACE(A,l,m,E,v,c,p,L,S,_,f,e,o,u,n,s,q,d):null}var b=(D-t+(I-i)-g)/2;if(null!==this.ContinueProcessingPredicate&&!this.ContinueProcessingPredicate(D,this.OriginalSequence,b))return d[0]=!0,o[0]=D,s[0]=I,b>0&&h>0&&h+1>=g?this.WALKTRACE(A,l,m,E,v,c,p,L,S,_,f,e,o,u,n,s,q,d):(t++,i++,[new r.DiffChange(t,e-t+1,i,n-i+1)]);for(c=this.ClipDiagonalBound(v-g,g,v,y),p=this.ClipDiagonalBound(v+g,g,v,y),O=c;p>=O;O+=2){for(f=O===c||p>O&&_[O-1]>=_[O+1]?_[O+1]-1:_[O-1],u=f-(O-v)-L,w=f;f>t&&u>i&&this.ElementsAreEqual(f,u);)f--,u--;if(_[O]=f,q&&Math.abs(O-A)<=g&&f<=S[O])return o[0]=f,s[0]=u,w>=S[O]&&h>0&&h+1>=g?this.WALKTRACE(A,l,m,E,v,c,p,L,S,_,f,e,o,u,n,s,q,d):null}if(h>=g){var B=new Array(m-l+2);B[0]=A-l+1,a.Copy(S,l,B,1,m-l+1),this.m_forwardHistory.push(B),B=new Array(p-c+2),B[0]=v-c+1,a.Copy(_,c,B,1,p-c+1),this.m_reverseHistory.push(B)}}return this.WALKTRACE(A,l,m,E,v,c,p,L,S,_,f,e,o,u,n,s,q,d)},t.prototype.PrettifyChanges=function(t){for(var e=0;e<t.length;e++){for(var i=t[e],n=e<t.length-1?t[e+1].originalStart:this.OriginalSequence.getLength(),r=e<t.length-1?t[e+1].modifiedStart:this.ModifiedSequence.getLength(),o=i.originalLength>0,a=i.modifiedLength>0;i.originalStart+i.originalLength<n&&i.modifiedStart+i.modifiedLength<r&&(!o||this.OriginalElementsAreEqual(i.originalStart,i.originalStart+i.originalLength))&&(!a||this.ModifiedElementsAreEqual(i.modifiedStart,i.modifiedStart+i.modifiedLength));)i.originalStart++,i.modifiedStart++;var h=[null];e<t.length-1&&this.ChangesOverlap(t[e],t[e+1],h)&&(t[e]=h[0],t.splice(e+1,1),e--)}for(var e=t.length-1;e>=0;e--){var i=t[e],n=0,r=0;if(e>0){var s=t[e-1];s.originalLength>0&&(n=s.originalStart+s.originalLength),s.modifiedLength>0&&(r=s.modifiedStart+s.modifiedLength)}for(var o=i.originalLength>0,a=i.modifiedLength>0,d=0,g=this._boundaryScore(i.originalStart,i.originalLength,i.modifiedStart,i.modifiedLength),f=1;;f++){var u=i.originalStart-f,l=i.modifiedStart-f;if(n>u||r>l)break;if(o&&!this.OriginalElementsAreEqual(u,u+i.originalLength))break;if(a&&!this.ModifiedElementsAreEqual(l,l+i.modifiedLength))break;var m=this._boundaryScore(u,i.originalLength,l,i.modifiedLength);m>g&&(g=m,d=f)}i.originalStart-=d,i.modifiedStart-=d}return t},t.prototype._OriginalIsBoundary=function(t){if(0>=t||t>=this.OriginalSequence.getLength()-1)return!0;var e=this.OriginalSequence.getElementAtIndex(t);return"string"==typeof e&&/^\s*$/.test(e)},t.prototype._OriginalRegionIsBoundary=function(t,e){if(this._OriginalIsBoundary(t)||this._OriginalIsBoundary(t-1))return!0;if(e>0){var i=t+e;if(this._OriginalIsBoundary(i-1)||this._OriginalIsBoundary(i))return!0}return!1},t.prototype._ModifiedIsBoundary=function(t){if(0>=t||t>=this.ModifiedSequence.getLength()-1)return!0;var e=this.ModifiedSequence.getElementAtIndex(t);return"string"==typeof e&&/^\s*$/.test(e)},t.prototype._ModifiedRegionIsBoundary=function(t,e){if(this._ModifiedIsBoundary(t)||this._ModifiedIsBoundary(t-1))return!0;if(e>0){var i=t+e;if(this._ModifiedIsBoundary(i-1)||this._ModifiedIsBoundary(i))return!0}return!1},t.prototype._boundaryScore=function(t,e,i,n){var r=this._OriginalRegionIsBoundary(t,e)?1:0,o=this._ModifiedRegionIsBoundary(i,n)?1:0;return r+o},t.prototype.ConcatenateChanges=function(t,e){var i=[];if(0===t.length||0===e.length)return e.length>0?e:t;if(this.ChangesOverlap(t[t.length-1],e[0],i)){var n=new Array(t.length+e.length-1);return a.Copy(t,0,n,0,t.length-1),n[t.length-1]=i[0],a.Copy(e,1,n,t.length,e.length-1),n}var n=new Array(t.length+e.length);return a.Copy(t,0,n,0,t.length),a.Copy(e,0,n,t.length,e.length),n},t.prototype.ChangesOverlap=function(t,e,i){if(o.Assert(t.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),o.Assert(t.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),t.originalStart+t.originalLength>=e.originalStart||t.modifiedStart+t.modifiedLength>=e.modifiedStart){var n=t.originalStart,a=t.originalLength,h=t.modifiedStart,s=t.modifiedLength;return t.originalStart+t.originalLength>=e.originalStart&&(a=e.originalStart+e.originalLength-t.originalStart),t.modifiedStart+t.modifiedLength>=e.modifiedStart&&(s=e.modifiedStart+e.modifiedLength-t.modifiedStart),i[0]=new r.DiffChange(n,a,h,s),!0}return i[0]=null,!1},t.prototype.ClipDiagonalBound=function(t,e,i,n){if(t>=0&&n>t)return t;var r=i,o=n-i-1,a=e%2===0;if(0>t){var h=r%2===0;return a===h?0:1}var s=o%2===0;return a===s?n-1:n-2},t}();e.LcsDiff=d});
/**! node_modules/monaco-editor/esm/vs/base/common/arrays.js*/
define("2e30c88",function(r,n){"use strict";function t(r,n){return void 0===n&&(n=0),r[r.length-(1+n)]}function e(r){if(0===r.length)throw new Error("Invalid tail call");return[r.slice(0,r.length-1),r[r.length-1]]}function i(r,n,t){if(void 0===t&&(t=function(r,n){return r===n}),r===n)return!0;if(!r||!n)return!1;if(r.length!==n.length)return!1;for(var e=0,i=r.length;i>e;e++)if(!t(r[e],n[e]))return!1;return!0}function u(r,n,t){for(var e=0,i=r.length-1;i>=e;){var u=(e+i)/2|0,f=t(r[u],n);if(0>f)e=u+1;else{if(!(f>0))return u;i=u-1}}return-(e+1)}function f(r,n){var t=0,e=r.length;if(0===e)return 0;for(;e>t;){var i=Math.floor((t+e)/2);n(r[i])?e=i:t=i+1}return t}function o(r,n){return c(r,n,0,r.length-1,[]),r}function a(r,n,t,e,i,u){for(var f=t,o=e+1,a=t;i>=a;a++)u[a]=r[a];for(var a=t;i>=a;a++)r[a]=f>e?u[o++]:o>i?u[f++]:n(u[o],u[f])<0?u[o++]:u[f++]}function c(r,n,t,e,i){if(!(t>=e)){var u=t+(e-t)/2|0;c(r,n,t,u,i),c(r,n,u+1,e,i),n(r[u],r[u+1])<=0||a(r,n,t,u,e,i)}}function l(r,n){for(var t=[],e=void 0,i=0,u=o(r.slice(0),n);i<u.length;i++){var f=u[i];e&&0===n(e[0],f)?e.push(f):(e=[f],t.push(e))}return t}function s(r){return r?r.filter(function(r){return!!r}):r}function v(r){return!Array.isArray(r)||0===r.length}function h(r){return Array.isArray(r)&&r.length>0}function d(r,n){if(!n)return r.filter(function(n,t){return r.indexOf(n)===t});var t=Object.create(null);return r.filter(function(r){var e=n(r);return t[e]?!1:(t[e]=!0,!0)})}function y(r){var n=new Set;return r.filter(function(r){return n.has(r)?!1:(n.add(r),!0)})}function g(r,n){for(var t=0;t<r.length;t++){var e=r[t];if(n(e))return t}return-1}function p(r,n,t){void 0===t&&(t=void 0);var e=g(r,n);return 0>e?t:r[e]}function A(r){var n;return(n=[]).concat.apply(n,r)}function m(r,n){var t="number"==typeof n?r:0;"number"==typeof n?t=r:(t=0,n=r);var e=[];if(n>=t)for(var i=t;n>i;i++)e.push(i);else for(var i=t;i>n;i--)e.push(i);return e}function O(r,n,t){var e=r.slice(0,n),i=r.slice(n);return e.concat(t,i)}function S(r,n){var t=r.indexOf(n);t>-1&&(r.splice(t,1),r.unshift(n))}function b(r,n){var t=r.indexOf(n);t>-1&&(r.splice(t,1),r.push(n))}function E(r){return Array.isArray(r)?r:[r]}Object.defineProperty(n,"__esModule",{value:!0}),n.tail=t,n.tail2=e,n.equals=i,n.binarySearch=u,n.findFirstInSorted=f,n.mergeSort=o,n.groupBy=l,n.coalesce=s,n.isFalsyOrEmpty=v,n.isNonEmptyArray=h,n.distinct=d,n.distinctES6=y,n.firstIndex=g,n.first=p,n.flatten=A,n.range=m,n.arrayInsert=O,n.pushToStart=S,n.pushToEnd=b,n.asArray=E});
/**! node_modules/monaco-editor/esm/vs/base/common/types.js*/
define("01fef85",function(n,t){"use strict";function r(n){return Array.isArray?Array.isArray(n):n&&typeof n.length===b.number&&n.constructor===Array?!0:!1}function e(n){return typeof n===b.string||n instanceof String?!0:!1}function o(n){return!(typeof n!==b.object||null===n||Array.isArray(n)||n instanceof RegExp||n instanceof Date)}function i(n){return(typeof n===b.number||n instanceof Number)&&!isNaN(n)?!0:!1}function u(n){return n===!0||n===!1}function f(n){return typeof n===b.undefined}function c(n){return f(n)||null===n}function a(n){if(!o(n))return!1;for(var t in n)if(m.call(n,t))return!1;return!0}function s(n){return typeof n===b.function}function l(n,t){for(var r=Math.min(n.length,t.length),e=0;r>e;e++)y(n[e],t[e])}function y(n,t){if(e(t)){if(typeof n!==t)throw new Error("argument does not match constraint: typeof "+t)}else if(s(t)){try{if(n instanceof t)return}catch(r){}if(!c(n)&&n.constructor===t)return;if(1===t.length&&t.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function d(n){for(var t=[],r=Object.getPrototypeOf(n);Object.prototype!==r;)t=t.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return t}function p(n){return null===n?void 0:n}function g(n){return"undefined"==typeof n?null:n}Object.defineProperty(t,"__esModule",{value:!0});var b={number:"number",string:"string",undefined:"undefined",object:"object","function":"function"};t.isArray=r,t.isString=e,t.isObject=o,t.isNumber=i,t.isBoolean=u,t.isUndefined=f,t.isUndefinedOrNull=c;var m=Object.prototype.hasOwnProperty;t.isEmptyObject=a,t.isFunction=s,t.validateConstraints=l,t.validateConstraint=y,t.getAllPropertyNames=d,t.withNullAsUndefined=p,t.withUndefinedAsNull=g});
/**! node_modules/monaco-editor/esm/vs/base/common/platform.js*/
define("17c8d25",function(e,i){"use strict";function a(e){return null===c&&(c=i.globals.setImmediate?i.globals.setImmediate.bind(i.globals):i.globals.setTimeout.bind(i.globals)),c(e)}Object.defineProperty(i,"__esModule",{value:!0});var t="en",o=!1,s=!1,l=!1,n=!1,b=!1,d=void 0,g=t,r=!1;if("object"!=typeof navigator||r);else{var f=navigator.userAgent;o=f.indexOf("Windows")>=0,s=f.indexOf("Macintosh")>=0,l=f.indexOf("Linux")>=0,b=!0,d=navigator.language,g=d}var u=0;n&&(s?u=1:o?u=3:l&&(u=2)),i.isWindows=o,i.isMacintosh=s,i.isLinux=l,i.isNative=n,i.isWeb=b;var v="object"==typeof self?self:"object"==typeof global?global:{};i.globals=v;var c=null;i.setImmediate=a,i.OS=s?2:o?1:3});
/**! node_modules/monaco-editor/esm/vs/base/common/lifecycle.js*/
define("a0b8cca",function(e,s){"use strict";function i(e){return"function"==typeof e.dispose&&0===e.dispose.length}function o(e){for(var s=[],i=1;i<arguments.length;i++)s[i-1]=arguments[i];return Array.isArray(e)?(e.forEach(function(e){return e&&e.dispose()}),[]):0===s.length?e?(e.dispose(),e):void 0:(o(e),o(s),[])}function t(e){return{dispose:function(){return o(e)}}}function n(e){return{dispose:function(){e()}}}Object.defineProperty(s,"__esModule",{value:!0}),s.isDisposable=i,s.dispose=o,s.combinedDisposable=t,s.toDisposable=n;var r=function(){function e(){this._toDispose=[],this._lifecycle_disposable_isDisposed=!1}return e.prototype.dispose=function(){this._lifecycle_disposable_isDisposed=!0,this._toDispose=o(this._toDispose)},e.prototype._register=function(e){return this._lifecycle_disposable_isDisposed?(console.warn("Registering disposable on object that has already been disposed."),e.dispose()):this._toDispose.push(e),e},e.None=Object.freeze({dispose:function(){}}),e}();s.Disposable=r;var p=function(){function e(e){this.object=e}return e.prototype.dispose=function(){},e}();s.ImmortalReference=p});
/**! node_modules/monaco-editor/esm/vs/base/common/errors.js*/
define("22e50b6",function(r,e){"use strict";function n(r){return void(a(r)||e.errorHandler.onUnexpectedError(r))}function t(r){return void(a(r)||e.errorHandler.onUnexpectedExternalError(r))}function o(r){if(r instanceof Error){var e=r.name,n=r.message,t=r.stacktrace||r.stack;return{$isError:!0,name:e,message:n,stack:t}}return r}function a(r){return r instanceof Error&&r.name===u&&r.message===u}function i(){var r=new Error(u);return r.name=r.message,r}function c(r){return new Error(r?"Illegal argument: "+r:"Illegal argument")}function s(r){return new Error(r?"Illegal state: "+r:"Illegal state")}Object.defineProperty(e,"__esModule",{value:!0});var l=function(){function r(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(function(){if(r.stack)throw new Error(r.message+"\n\n"+r.stack);throw r},0)}}return r.prototype.emit=function(r){this.listeners.forEach(function(e){e(r)})},r.prototype.onUnexpectedError=function(r){this.unexpectedErrorHandler(r),this.emit(r)},r.prototype.onUnexpectedExternalError=function(r){this.unexpectedErrorHandler(r)},r}();e.ErrorHandler=l,e.errorHandler=new l,e.onUnexpectedError=n,e.onUnexpectedExternalError=t,e.transformErrorForSerialization=o;var u="Canceled";e.isPromiseCanceledError=a,e.canceled=i,e.illegalArgument=c,e.illegalState=s});
/**! node_modules/monaco-editor/esm/vs/language/typescript/lib/lib.js*/
define("ba73a73",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.lib_es2015_symbol_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n\ninterface SymbolConstructor {\n    /**\n     * A reference to the prototype.\n     */\n    readonly prototype: Symbol;\n\n    /**\n     * Returns a new unique Symbol value.\n     * @param  description Description of the new Symbol object.\n     */\n    (description?: string | number): symbol;\n\n    /**\n     * Returns a Symbol object from the global symbol registry matching the given key if found.\n     * Otherwise, returns a new symbol with this key.\n     * @param key key to search for.\n     */\n    for(key: string): symbol;\n\n    /**\n     * Returns a key from the global symbol registry matching the given Symbol if found.\n     * Otherwise, returns a undefined.\n     * @param sym Symbol to find the key for.\n     */\n    keyFor(sym: symbol): string | undefined;\n}\n\ndeclare var Symbol: SymbolConstructor;',n.lib_es2015_symbol_wellknown_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n'+n.lib_es2015_symbol_dts+'\ninterface SymbolConstructor {\n    /**\n     * A method that determines if a constructor object recognizes an object as one of the\n     * constructor’s instances. Called by the semantics of the instanceof operator.\n     */\n    readonly hasInstance: symbol;\n\n    /**\n     * A Boolean value that if true indicates that an object should flatten to its array elements\n     * by Array.prototype.concat.\n     */\n    readonly isConcatSpreadable: symbol;\n\n    /**\n     * A regular expression method that matches the regular expression against a string. Called\n     * by the String.prototype.match method.\n     */\n    readonly match: symbol;\n\n    /**\n     * A regular expression method that replaces matched substrings of a string. Called by the\n     * String.prototype.replace method.\n     */\n    readonly replace: symbol;\n\n    /**\n     * A regular expression method that returns the index within a string that matches the\n     * regular expression. Called by the String.prototype.search method.\n     */\n    readonly search: symbol;\n\n    /**\n     * A function valued property that is the constructor function that is used to create\n     * derived objects.\n     */\n    readonly species: symbol;\n\n    /**\n     * A regular expression method that splits a string at the indices that match the regular\n     * expression. Called by the String.prototype.split method.\n     */\n    readonly split: symbol;\n\n    /**\n     * A method that converts an object to a corresponding primitive value.\n     * Called by the ToPrimitive abstract operation.\n     */\n    readonly toPrimitive: symbol;\n\n    /**\n     * A String value that is used in the creation of the default string description of an object.\n     * Called by the built-in method Object.prototype.toString.\n     */\n    readonly toStringTag: symbol;\n\n    /**\n     * An Object whose own property names are property names that are excluded from the \'with\'\n     * environment bindings of the associated objects.\n     */\n    readonly unscopables: symbol;\n}\n\ninterface Symbol {\n    readonly [Symbol.toStringTag]: string;\n}\n\ninterface Array<T> {\n    /**\n     * Returns an object whose properties have the value \'true\'\n     * when they will be absent when used in a \'with\' statement.\n     */\n    [Symbol.unscopables](): {\n        copyWithin: boolean;\n        entries: boolean;\n        fill: boolean;\n        find: boolean;\n        findIndex: boolean;\n        keys: boolean;\n        values: boolean;\n    };\n}\n\ninterface Date {\n    /**\n     * Converts a Date object to a string.\n     */\n    [Symbol.toPrimitive](hint: "default"): string;\n    /**\n     * Converts a Date object to a string.\n     */\n    [Symbol.toPrimitive](hint: "string"): string;\n    /**\n     * Converts a Date object to a number.\n     */\n    [Symbol.toPrimitive](hint: "number"): number;\n    /**\n     * Converts a Date object to a string or number.\n     *\n     * @param hint The strings "number", "string", or "default" to specify what primitive to return.\n     *\n     * @throws {TypeError} If \'hint\' was given something other than "number", "string", or "default".\n     * @returns A number if \'hint\' was "number", a string if \'hint\' was "string" or "default".\n     */\n    [Symbol.toPrimitive](hint: string): string | number;\n}\n\ninterface Map<K, V> {\n    readonly [Symbol.toStringTag]: string;\n}\n\ninterface WeakMap<K extends object, V> {\n    readonly [Symbol.toStringTag]: string;\n}\n\ninterface Set<T> {\n    readonly [Symbol.toStringTag]: string;\n}\n\ninterface WeakSet<T extends object> {\n    readonly [Symbol.toStringTag]: string;\n}\n\ninterface JSON {\n    readonly [Symbol.toStringTag]: string;\n}\n\ninterface Function {\n    /**\n     * Determines whether the given value inherits from this function if this function was used\n     * as a constructor function.\n     *\n     * A constructor function can control which objects are recognized as its instances by\n     * \'instanceof\' by overriding this method.\n     */\n    [Symbol.hasInstance](value: any): boolean;\n}\n\ninterface GeneratorFunction {\n    readonly [Symbol.toStringTag]: string;\n}\n\ninterface Math {\n    readonly [Symbol.toStringTag]: string;\n}\n\ninterface Promise<T> {\n    readonly [Symbol.toStringTag]: string;\n}\n\ninterface PromiseConstructor {\n    readonly [Symbol.species]: PromiseConstructor;\n}\n\ninterface RegExp {\n    /**\n     * Matches a string with this regular expression, and returns an array containing the results of\n     * that search.\n     * @param string A string to search within.\n     */\n    [Symbol.match](string: string): RegExpMatchArray | null;\n\n    /**\n     * Replaces text in a string, using this regular expression.\n     * @param string A String object or string literal whose contents matching against\n     *               this regular expression will be replaced\n     * @param replaceValue A String object or string literal containing the text to replace for every\n     *                     successful match of this regular expression.\n     */\n    [Symbol.replace](string: string, replaceValue: string): string;\n\n    /**\n     * Replaces text in a string, using this regular expression.\n     * @param string A String object or string literal whose contents matching against\n     *               this regular expression will be replaced\n     * @param replacer A function that returns the replacement text.\n     */\n    [Symbol.replace](string: string, replacer: (substring: string, ...args: any[]) => string): string;\n\n    /**\n     * Finds the position beginning first substring match in a regular expression search\n     * using this regular expression.\n     *\n     * @param string The string to search within.\n     */\n    [Symbol.search](string: string): number;\n\n    /**\n     * Returns an array of substrings that were delimited by strings in the original input that\n     * match against this regular expression.\n     *\n     * If the regular expression contains capturing parentheses, then each time this\n     * regular expression matches, the results (including any undefined results) of the\n     * capturing parentheses are spliced.\n     *\n     * @param string string value to split\n     * @param limit if not undefined, the output array is truncated so that it contains no more\n     * than \'limit\' elements.\n     */\n    [Symbol.split](string: string, limit?: number): string[];\n}\n\ninterface RegExpConstructor {\n    readonly [Symbol.species]: RegExpConstructor;\n}\n\ninterface String {\n    /**\n     * Matches a string an object that supports being matched against, and returns an array containing the results of that search.\n     * @param matcher An object that supports being matched against.\n     */\n    match(matcher: { [Symbol.match](string: string): RegExpMatchArray | null; }): RegExpMatchArray | null;\n\n    /**\n     * Replaces text in a string, using an object that supports replacement within a string.\n     * @param searchValue A object can search for and replace matches within a string.\n     * @param replaceValue A string containing the text to replace for every successful match of searchValue in this string.\n     */\n    replace(searchValue: { [Symbol.replace](string: string, replaceValue: string): string; }, replaceValue: string): string;\n\n    /**\n     * Replaces text in a string, using an object that supports replacement within a string.\n     * @param searchValue A object can search for and replace matches within a string.\n     * @param replacer A function that returns the replacement text.\n     */\n    replace(searchValue: { [Symbol.replace](string: string, replacer: (substring: string, ...args: any[]) => string): string; }, replacer: (substring: string, ...args: any[]) => string): string;\n\n    /**\n     * Finds the first substring match in a regular expression search.\n     * @param searcher An object which supports searching within a string.\n     */\n    search(searcher: { [Symbol.search](string: string): number; }): number;\n\n    /**\n     * Split a string into substrings using the specified separator and return them as an array.\n     * @param splitter An object that can split a string.\n     * @param limit A value used to limit the number of elements returned in the array.\n     */\n    split(splitter: { [Symbol.split](string: string, limit?: number): string[]; }, limit?: number): string[];\n}\n\ninterface ArrayBuffer {\n    readonly [Symbol.toStringTag]: string;\n}\n\ninterface DataView {\n    readonly [Symbol.toStringTag]: string;\n}\n\ninterface Int8Array {\n    readonly [Symbol.toStringTag]: "Int8Array";\n}\n\ninterface Uint8Array {\n    readonly [Symbol.toStringTag]: "UInt8Array";\n}\n\ninterface Uint8ClampedArray {\n    readonly [Symbol.toStringTag]: "Uint8ClampedArray";\n}\n\ninterface Int16Array {\n    readonly [Symbol.toStringTag]: "Int16Array";\n}\n\ninterface Uint16Array {\n    readonly [Symbol.toStringTag]: "Uint16Array";\n}\n\ninterface Int32Array {\n    readonly [Symbol.toStringTag]: "Int32Array";\n}\n\ninterface Uint32Array {\n    readonly [Symbol.toStringTag]: "Uint32Array";\n}\n\ninterface Float32Array {\n    readonly [Symbol.toStringTag]: "Float32Array";\n}\n\ninterface Float64Array {\n    readonly [Symbol.toStringTag]: "Float64Array";\n}\n\ninterface ArrayConstructor {\n    readonly [Symbol.species]: ArrayConstructor;\n}\ninterface MapConstructor {\n    readonly [Symbol.species]: MapConstructor;\n}\ninterface SetConstructor {\n    readonly [Symbol.species]: SetConstructor;\n}\ninterface ArrayBufferConstructor {\n    readonly [Symbol.species]: ArrayBufferConstructor;\n}',n.lib_es2015_reflect_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n\ndeclare namespace Reflect {\n    function apply(target: Function, thisArgument: any, argumentsList: ArrayLike<any>): any;\n    function construct(target: Function, argumentsList: ArrayLike<any>, newTarget?: any): any;\n    function defineProperty(target: object, propertyKey: PropertyKey, attributes: PropertyDescriptor): boolean;\n    function deleteProperty(target: object, propertyKey: PropertyKey): boolean;\n    function get(target: object, propertyKey: PropertyKey, receiver?: any): any;\n    function getOwnPropertyDescriptor(target: object, propertyKey: PropertyKey): PropertyDescriptor | undefined;\n    function getPrototypeOf(target: object): object;\n    function has(target: object, propertyKey: PropertyKey): boolean;\n    function isExtensible(target: object): boolean;\n    function ownKeys(target: object): PropertyKey[];\n    function preventExtensions(target: object): boolean;\n    function set(target: object, propertyKey: PropertyKey, value: any, receiver?: any): boolean;\n    function setPrototypeOf(target: object, proto: any): boolean;\n}\n',n.lib_es2015_proxy_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n\ninterface ProxyHandler<T extends object> {\n    getPrototypeOf? (target: T): object | null;\n    setPrototypeOf? (target: T, v: any): boolean;\n    isExtensible? (target: T): boolean;\n    preventExtensions? (target: T): boolean;\n    getOwnPropertyDescriptor? (target: T, p: PropertyKey): PropertyDescriptor | undefined;\n    has? (target: T, p: PropertyKey): boolean;\n    get? (target: T, p: PropertyKey, receiver: any): any;\n    set? (target: T, p: PropertyKey, value: any, receiver: any): boolean;\n    deleteProperty? (target: T, p: PropertyKey): boolean;\n    defineProperty? (target: T, p: PropertyKey, attributes: PropertyDescriptor): boolean;\n    enumerate? (target: T): PropertyKey[];\n    ownKeys? (target: T): PropertyKey[];\n    apply? (target: T, thisArg: any, argArray?: any): any;\n    construct? (target: T, argArray: any, newTarget?: any): object;\n}\n\ninterface ProxyConstructor {\n    revocable<T extends object>(target: T, handler: ProxyHandler<T>): { proxy: T; revoke: () => void; };\n    new <T extends object>(target: T, handler: ProxyHandler<T>): T;\n}\ndeclare var Proxy: ProxyConstructor;\n',n.lib_es2015_iterable_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n'+n.lib_es2015_symbol_dts+"\ninterface SymbolConstructor {\n    /**\n     * A method that returns the default iterator for an object. Called by the semantics of the\n     * for-of statement.\n     */\n    readonly iterator: symbol;\n}\n\ninterface IteratorResult<T> {\n    done: boolean;\n    value: T;\n}\n\ninterface Iterator<T> {\n    next(value?: any): IteratorResult<T>;\n    return?(value?: any): IteratorResult<T>;\n    throw?(e?: any): IteratorResult<T>;\n}\n\ninterface Iterable<T> {\n    [Symbol.iterator](): Iterator<T>;\n}\n\ninterface IterableIterator<T> extends Iterator<T> {\n    [Symbol.iterator](): IterableIterator<T>;\n}\n\ninterface Array<T> {\n    /** Iterator */\n    [Symbol.iterator](): IterableIterator<T>;\n\n    /**\n     * Returns an iterable of key, value pairs for every entry in the array\n     */\n    entries(): IterableIterator<[number, T]>;\n\n    /**\n     * Returns an iterable of keys in the array\n     */\n    keys(): IterableIterator<number>;\n\n    /**\n     * Returns an iterable of values in the array\n     */\n    values(): IterableIterator<T>;\n}\n\ninterface ArrayConstructor {\n    /**\n     * Creates an array from an iterable object.\n     * @param iterable An iterable object to convert to an array.\n     */\n    from<T>(iterable: Iterable<T> | ArrayLike<T>): T[];\n\n    /**\n     * Creates an array from an iterable object.\n     * @param iterable An iterable object to convert to an array.\n     * @param mapfn A mapping function to call on every element of the array.\n     * @param thisArg Value of 'this' used to invoke the mapfn.\n     */\n    from<T, U>(iterable: Iterable<T> | ArrayLike<T>, mapfn: (v: T, k: number) => U, thisArg?: any): U[];\n}\n\ninterface ReadonlyArray<T> {\n    /** Iterator of values in the array. */\n    [Symbol.iterator](): IterableIterator<T>;\n\n    /**\n     * Returns an iterable of key, value pairs for every entry in the array\n     */\n    entries(): IterableIterator<[number, T]>;\n\n    /**\n     * Returns an iterable of keys in the array\n     */\n    keys(): IterableIterator<number>;\n\n    /**\n     * Returns an iterable of values in the array\n     */\n    values(): IterableIterator<T>;\n}\n\ninterface IArguments {\n    /** Iterator */\n    [Symbol.iterator](): IterableIterator<any>;\n}\n\ninterface Map<K, V> {\n    /** Returns an iterable of entries in the map. */\n    [Symbol.iterator](): IterableIterator<[K, V]>;\n\n    /**\n     * Returns an iterable of key, value pairs for every entry in the map.\n     */\n    entries(): IterableIterator<[K, V]>;\n\n    /**\n     * Returns an iterable of keys in the map\n     */\n    keys(): IterableIterator<K>;\n\n    /**\n     * Returns an iterable of values in the map\n     */\n    values(): IterableIterator<V>;\n}\n\ninterface ReadonlyMap<K, V> {\n    /** Returns an iterable of entries in the map. */\n    [Symbol.iterator](): IterableIterator<[K, V]>;\n\n    /**\n     * Returns an iterable of key, value pairs for every entry in the map.\n     */\n    entries(): IterableIterator<[K, V]>;\n\n    /**\n     * Returns an iterable of keys in the map\n     */\n    keys(): IterableIterator<K>;\n\n    /**\n     * Returns an iterable of values in the map\n     */\n    values(): IterableIterator<V>;\n}\n\ninterface MapConstructor {\n    new <K, V>(iterable: Iterable<readonly [K, V]>): Map<K, V>;\n}\n\ninterface WeakMap<K extends object, V> { }\n\ninterface WeakMapConstructor {\n    new <K extends object, V>(iterable: Iterable<[K, V]>): WeakMap<K, V>;\n}\n\ninterface Set<T> {\n    /** Iterates over values in the set. */\n    [Symbol.iterator](): IterableIterator<T>;\n    /**\n     * Returns an iterable of [v,v] pairs for every value `v` in the set.\n     */\n    entries(): IterableIterator<[T, T]>;\n    /**\n     * Despite its name, returns an iterable of the values in the set,\n     */\n    keys(): IterableIterator<T>;\n\n    /**\n     * Returns an iterable of values in the set.\n     */\n    values(): IterableIterator<T>;\n}\n\ninterface ReadonlySet<T> {\n    /** Iterates over values in the set. */\n    [Symbol.iterator](): IterableIterator<T>;\n\n    /**\n     * Returns an iterable of [v,v] pairs for every value `v` in the set.\n     */\n    entries(): IterableIterator<[T, T]>;\n\n    /**\n     * Despite its name, returns an iterable of the values in the set,\n     */\n    keys(): IterableIterator<T>;\n\n    /**\n     * Returns an iterable of values in the set.\n     */\n    values(): IterableIterator<T>;\n}\n\ninterface SetConstructor {\n    new <T>(iterable?: Iterable<T> | null): Set<T>;\n}\n\ninterface WeakSet<T extends object> { }\n\ninterface WeakSetConstructor {\n    new <T extends object = object>(iterable: Iterable<T>): WeakSet<T>;\n}\n\ninterface Promise<T> { }\n\ninterface PromiseConstructor {\n    /**\n     * Creates a Promise that is resolved with an array of results when all of the provided Promises\n     * resolve, or rejected when any Promise is rejected.\n     * @param values An array of Promises.\n     * @returns A new Promise.\n     */\n    all<TAll>(values: Iterable<TAll | PromiseLike<TAll>>): Promise<TAll[]>;\n\n    /**\n     * Creates a Promise that is resolved or rejected when any of the provided Promises are resolved\n     * or rejected.\n     * @param values An array of Promises.\n     * @returns A new Promise.\n     */\n    race<T>(values: Iterable<T | PromiseLike<T>>): Promise<T>;\n}\n\ndeclare namespace Reflect {\n    function enumerate(target: object): IterableIterator<any>;\n}\n\ninterface String {\n    /** Iterator */\n    [Symbol.iterator](): IterableIterator<string>;\n}\n\ninterface Int8Array {\n    [Symbol.iterator](): IterableIterator<number>;\n    /**\n     * Returns an array of key, value pairs for every entry in the array\n     */\n    entries(): IterableIterator<[number, number]>;\n    /**\n     * Returns an list of keys in the array\n     */\n    keys(): IterableIterator<number>;\n    /**\n     * Returns an list of values in the array\n     */\n    values(): IterableIterator<number>;\n}\n\ninterface Int8ArrayConstructor {\n    new (elements: Iterable<number>): Int8Array;\n\n    /**\n     * Creates an array from an array-like or iterable object.\n     * @param arrayLike An array-like or iterable object to convert to an array.\n     * @param mapfn A mapping function to call on every element of the array.\n     * @param thisArg Value of 'this' used to invoke the mapfn.\n     */\n    from(arrayLike: Iterable<number>, mapfn?: (v: number, k: number) => number, thisArg?: any): Int8Array;\n}\n\ninterface Uint8Array {\n    [Symbol.iterator](): IterableIterator<number>;\n    /**\n     * Returns an array of key, value pairs for every entry in the array\n     */\n    entries(): IterableIterator<[number, number]>;\n    /**\n     * Returns an list of keys in the array\n     */\n    keys(): IterableIterator<number>;\n    /**\n     * Returns an list of values in the array\n     */\n    values(): IterableIterator<number>;\n}\n\ninterface Uint8ArrayConstructor {\n    new (elements: Iterable<number>): Uint8Array;\n\n    /**\n     * Creates an array from an array-like or iterable object.\n     * @param arrayLike An array-like or iterable object to convert to an array.\n     * @param mapfn A mapping function to call on every element of the array.\n     * @param thisArg Value of 'this' used to invoke the mapfn.\n     */\n    from(arrayLike: Iterable<number>, mapfn?: (v: number, k: number) => number, thisArg?: any): Uint8Array;\n}\n\ninterface Uint8ClampedArray {\n    [Symbol.iterator](): IterableIterator<number>;\n    /**\n     * Returns an array of key, value pairs for every entry in the array\n     */\n    entries(): IterableIterator<[number, number]>;\n\n    /**\n     * Returns an list of keys in the array\n     */\n    keys(): IterableIterator<number>;\n\n    /**\n     * Returns an list of values in the array\n     */\n    values(): IterableIterator<number>;\n}\n\ninterface Uint8ClampedArrayConstructor {\n    new (elements: Iterable<number>): Uint8ClampedArray;\n\n\n    /**\n     * Creates an array from an array-like or iterable object.\n     * @param arrayLike An array-like or iterable object to convert to an array.\n     * @param mapfn A mapping function to call on every element of the array.\n     * @param thisArg Value of 'this' used to invoke the mapfn.\n     */\n    from(arrayLike: Iterable<number>, mapfn?: (v: number, k: number) => number, thisArg?: any): Uint8ClampedArray;\n}\n\ninterface Int16Array {\n    [Symbol.iterator](): IterableIterator<number>;\n    /**\n     * Returns an array of key, value pairs for every entry in the array\n     */\n    entries(): IterableIterator<[number, number]>;\n\n    /**\n     * Returns an list of keys in the array\n     */\n    keys(): IterableIterator<number>;\n\n    /**\n     * Returns an list of values in the array\n     */\n    values(): IterableIterator<number>;\n}\n\ninterface Int16ArrayConstructor {\n    new (elements: Iterable<number>): Int16Array;\n\n    /**\n     * Creates an array from an array-like or iterable object.\n     * @param arrayLike An array-like or iterable object to convert to an array.\n     * @param mapfn A mapping function to call on every element of the array.\n     * @param thisArg Value of 'this' used to invoke the mapfn.\n     */\n    from(arrayLike: Iterable<number>, mapfn?: (v: number, k: number) => number, thisArg?: any): Int16Array;\n}\n\ninterface Uint16Array {\n    [Symbol.iterator](): IterableIterator<number>;\n    /**\n     * Returns an array of key, value pairs for every entry in the array\n     */\n    entries(): IterableIterator<[number, number]>;\n    /**\n     * Returns an list of keys in the array\n     */\n    keys(): IterableIterator<number>;\n    /**\n     * Returns an list of values in the array\n     */\n    values(): IterableIterator<number>;\n}\n\ninterface Uint16ArrayConstructor {\n    new (elements: Iterable<number>): Uint16Array;\n\n    /**\n     * Creates an array from an array-like or iterable object.\n     * @param arrayLike An array-like or iterable object to convert to an array.\n     * @param mapfn A mapping function to call on every element of the array.\n     * @param thisArg Value of 'this' used to invoke the mapfn.\n     */\n    from(arrayLike: Iterable<number>, mapfn?: (v: number, k: number) => number, thisArg?: any): Uint16Array;\n}\n\ninterface Int32Array {\n    [Symbol.iterator](): IterableIterator<number>;\n    /**\n     * Returns an array of key, value pairs for every entry in the array\n     */\n    entries(): IterableIterator<[number, number]>;\n    /**\n     * Returns an list of keys in the array\n     */\n    keys(): IterableIterator<number>;\n    /**\n     * Returns an list of values in the array\n     */\n    values(): IterableIterator<number>;\n}\n\ninterface Int32ArrayConstructor {\n    new (elements: Iterable<number>): Int32Array;\n\n    /**\n     * Creates an array from an array-like or iterable object.\n     * @param arrayLike An array-like or iterable object to convert to an array.\n     * @param mapfn A mapping function to call on every element of the array.\n     * @param thisArg Value of 'this' used to invoke the mapfn.\n     */\n    from(arrayLike: Iterable<number>, mapfn?: (v: number, k: number) => number, thisArg?: any): Int32Array;\n}\n\ninterface Uint32Array {\n    [Symbol.iterator](): IterableIterator<number>;\n    /**\n     * Returns an array of key, value pairs for every entry in the array\n     */\n    entries(): IterableIterator<[number, number]>;\n    /**\n     * Returns an list of keys in the array\n     */\n    keys(): IterableIterator<number>;\n    /**\n     * Returns an list of values in the array\n     */\n    values(): IterableIterator<number>;\n}\n\ninterface Uint32ArrayConstructor {\n    new (elements: Iterable<number>): Uint32Array;\n\n    /**\n     * Creates an array from an array-like or iterable object.\n     * @param arrayLike An array-like or iterable object to convert to an array.\n     * @param mapfn A mapping function to call on every element of the array.\n     * @param thisArg Value of 'this' used to invoke the mapfn.\n     */\n    from(arrayLike: Iterable<number>, mapfn?: (v: number, k: number) => number, thisArg?: any): Uint32Array;\n}\n\ninterface Float32Array {\n    [Symbol.iterator](): IterableIterator<number>;\n    /**\n     * Returns an array of key, value pairs for every entry in the array\n     */\n    entries(): IterableIterator<[number, number]>;\n    /**\n     * Returns an list of keys in the array\n     */\n    keys(): IterableIterator<number>;\n    /**\n     * Returns an list of values in the array\n     */\n    values(): IterableIterator<number>;\n}\n\ninterface Float32ArrayConstructor {\n    new (elements: Iterable<number>): Float32Array;\n\n    /**\n     * Creates an array from an array-like or iterable object.\n     * @param arrayLike An array-like or iterable object to convert to an array.\n     * @param mapfn A mapping function to call on every element of the array.\n     * @param thisArg Value of 'this' used to invoke the mapfn.\n     */\n    from(arrayLike: Iterable<number>, mapfn?: (v: number, k: number) => number, thisArg?: any): Float32Array;\n}\n\ninterface Float64Array {\n    [Symbol.iterator](): IterableIterator<number>;\n    /**\n     * Returns an array of key, value pairs for every entry in the array\n     */\n    entries(): IterableIterator<[number, number]>;\n    /**\n     * Returns an list of keys in the array\n     */\n    keys(): IterableIterator<number>;\n    /**\n     * Returns an list of values in the array\n     */\n    values(): IterableIterator<number>;\n}\n\ninterface Float64ArrayConstructor {\n    new (elements: Iterable<number>): Float64Array;\n\n    /**\n     * Creates an array from an array-like or iterable object.\n     * @param arrayLike An array-like or iterable object to convert to an array.\n     * @param mapfn A mapping function to call on every element of the array.\n     * @param thisArg Value of 'this' used to invoke the mapfn.\n     */\n    from(arrayLike: Iterable<number>, mapfn?: (v: number, k: number) => number, thisArg?: any): Float64Array;\n}\n",n.lib_es2015_promise_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n\ninterface PromiseConstructor {\n    /**\n     * A reference to the prototype.\n     */\n    readonly prototype: Promise<any>;\n\n    /**\n     * Creates a new Promise.\n     * @param executor A callback used to initialize the promise. This callback is passed two arguments:\n     * a resolve callback used to resolve the promise with a value or the result of another promise,\n     * and a reject callback used to reject the promise with a provided reason or error.\n     */\n    new <T>(executor: (resolve: (value?: T | PromiseLike<T>) => void, reject: (reason?: any) => void) => void): Promise<T>;\n\n    /**\n     * Creates a Promise that is resolved with an array of results when all of the provided Promises\n     * resolve, or rejected when any Promise is rejected.\n     * @param values An array of Promises.\n     * @returns A new Promise.\n     */\n    all<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10>(values: [T1 | PromiseLike<T1>, T2 | PromiseLike<T2>, T3 | PromiseLike<T3>, T4 | PromiseLike <T4>, T5 | PromiseLike<T5>, T6 | PromiseLike<T6>, T7 | PromiseLike<T7>, T8 | PromiseLike<T8>, T9 | PromiseLike<T9>, T10 | PromiseLike<T10>]): Promise<[T1, T2, T3, T4, T5, T6, T7, T8, T9, T10]>;\n\n    /**\n     * Creates a Promise that is resolved with an array of results when all of the provided Promises\n     * resolve, or rejected when any Promise is rejected.\n     * @param values An array of Promises.\n     * @returns A new Promise.\n     */\n    all<T1, T2, T3, T4, T5, T6, T7, T8, T9>(values: [T1 | PromiseLike<T1>, T2 | PromiseLike<T2>, T3 | PromiseLike<T3>, T4 | PromiseLike <T4>, T5 | PromiseLike<T5>, T6 | PromiseLike<T6>, T7 | PromiseLike<T7>, T8 | PromiseLike<T8>, T9 | PromiseLike<T9>]): Promise<[T1, T2, T3, T4, T5, T6, T7, T8, T9]>;\n\n    /**\n     * Creates a Promise that is resolved with an array of results when all of the provided Promises\n     * resolve, or rejected when any Promise is rejected.\n     * @param values An array of Promises.\n     * @returns A new Promise.\n     */\n    all<T1, T2, T3, T4, T5, T6, T7, T8>(values: [T1 | PromiseLike<T1>, T2 | PromiseLike<T2>, T3 | PromiseLike<T3>, T4 | PromiseLike <T4>, T5 | PromiseLike<T5>, T6 | PromiseLike<T6>, T7 | PromiseLike<T7>, T8 | PromiseLike<T8>]): Promise<[T1, T2, T3, T4, T5, T6, T7, T8]>;\n\n    /**\n     * Creates a Promise that is resolved with an array of results when all of the provided Promises\n     * resolve, or rejected when any Promise is rejected.\n     * @param values An array of Promises.\n     * @returns A new Promise.\n     */\n    all<T1, T2, T3, T4, T5, T6, T7>(values: [T1 | PromiseLike<T1>, T2 | PromiseLike<T2>, T3 | PromiseLike<T3>, T4 | PromiseLike <T4>, T5 | PromiseLike<T5>, T6 | PromiseLike<T6>, T7 | PromiseLike<T7>]): Promise<[T1, T2, T3, T4, T5, T6, T7]>;\n\n    /**\n     * Creates a Promise that is resolved with an array of results when all of the provided Promises\n     * resolve, or rejected when any Promise is rejected.\n     * @param values An array of Promises.\n     * @returns A new Promise.\n     */\n    all<T1, T2, T3, T4, T5, T6>(values: [T1 | PromiseLike<T1>, T2 | PromiseLike<T2>, T3 | PromiseLike<T3>, T4 | PromiseLike <T4>, T5 | PromiseLike<T5>, T6 | PromiseLike<T6>]): Promise<[T1, T2, T3, T4, T5, T6]>;\n\n    /**\n     * Creates a Promise that is resolved with an array of results when all of the provided Promises\n     * resolve, or rejected when any Promise is rejected.\n     * @param values An array of Promises.\n     * @returns A new Promise.\n     */\n    all<T1, T2, T3, T4, T5>(values: [T1 | PromiseLike<T1>, T2 | PromiseLike<T2>, T3 | PromiseLike<T3>, T4 | PromiseLike <T4>, T5 | PromiseLike<T5>]): Promise<[T1, T2, T3, T4, T5]>;\n\n    /**\n     * Creates a Promise that is resolved with an array of results when all of the provided Promises\n     * resolve, or rejected when any Promise is rejected.\n     * @param values An array of Promises.\n     * @returns A new Promise.\n     */\n    all<T1, T2, T3, T4>(values: [T1 | PromiseLike<T1>, T2 | PromiseLike<T2>, T3 | PromiseLike<T3>, T4 | PromiseLike <T4>]): Promise<[T1, T2, T3, T4]>;\n\n    /**\n     * Creates a Promise that is resolved with an array of results when all of the provided Promises\n     * resolve, or rejected when any Promise is rejected.\n     * @param values An array of Promises.\n     * @returns A new Promise.\n     */\n    all<T1, T2, T3>(values: [T1 | PromiseLike<T1>, T2 | PromiseLike<T2>, T3 | PromiseLike<T3>]): Promise<[T1, T2, T3]>;\n\n    /**\n     * Creates a Promise that is resolved with an array of results when all of the provided Promises\n     * resolve, or rejected when any Promise is rejected.\n     * @param values An array of Promises.\n     * @returns A new Promise.\n     */\n    all<T1, T2>(values: [T1 | PromiseLike<T1>, T2 | PromiseLike<T2>]): Promise<[T1, T2]>;\n\n    /**\n     * Creates a Promise that is resolved with an array of results when all of the provided Promises\n     * resolve, or rejected when any Promise is rejected.\n     * @param values An array of Promises.\n     * @returns A new Promise.\n     */\n    all<T>(values: (T | PromiseLike<T>)[]): Promise<T[]>;\n\n    /**\n     * Creates a Promise that is resolved or rejected when any of the provided Promises are resolved\n     * or rejected.\n     * @param values An array of Promises.\n     * @returns A new Promise.\n     */\n    race<T>(values: T[]): Promise<T extends PromiseLike<infer U> ? U : T>;\n\n    /**\n     * Creates a Promise that is resolved or rejected when any of the provided Promises are resolved\n     * or rejected.\n     * @param values An iterable of Promises.\n     * @returns A new Promise.\n     */\n    race<T>(values: Iterable<T>): Promise<T extends PromiseLike<infer U> ? U : T>;\n\n    /**\n     * Creates a new rejected promise for the provided reason.\n     * @param reason The reason the promise was rejected.\n     * @returns A new rejected Promise.\n     */\n    reject<T = never>(reason?: any): Promise<T>;\n\n    /**\n     * Creates a new resolved promise for the provided value.\n     * @param value A promise.\n     * @returns A promise whose internal state matches the provided promise.\n     */\n    resolve<T>(value: T | PromiseLike<T>): Promise<T>;\n\n    /**\n     * Creates a new resolved promise .\n     * @returns A resolved promise.\n     */\n    resolve(): Promise<void>;\n}\n\ndeclare var Promise: PromiseConstructor;\n',n.lib_es2015_generator_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n\ninterface Generator extends Iterator<any> { }\n\ninterface GeneratorFunction {\n    /**\n     * Creates a new Generator object.\n     * @param args A list of arguments the function accepts.\n     */\n    new (...args: any[]): Generator;\n    /**\n     * Creates a new Generator object.\n     * @param args A list of arguments the function accepts.\n     */\n    (...args: any[]): Generator;\n    /**\n     * The length of the arguments.\n     */\n    readonly length: number;\n    /**\n     * Returns the name of the function.\n     */\n    readonly name: string;\n    /**\n     * A reference to the prototype.\n     */\n    readonly prototype: Generator;\n}\n\ninterface GeneratorFunctionConstructor {\n    /**\n     * Creates a new Generator function.\n     * @param args A list of arguments the function accepts.\n     */\n    new (...args: string[]): GeneratorFunction;\n    /**\n     * Creates a new Generator function.\n     * @param args A list of arguments the function accepts.\n     */\n    (...args: string[]): GeneratorFunction;\n    /**\n     * The length of the arguments.\n     */\n    readonly length: number;\n    /**\n     * Returns the name of the function.\n     */\n    readonly name: string;\n    /**\n     * A reference to the prototype.\n     */\n    readonly prototype: GeneratorFunction;\n}\n',n.lib_es2015_collection_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n\ninterface Map<K, V> {\n    clear(): void;\n    delete(key: K): boolean;\n    forEach(callbackfn: (value: V, key: K, map: Map<K, V>) => void, thisArg?: any): void;\n    get(key: K): V | undefined;\n    has(key: K): boolean;\n    set(key: K, value: V): this;\n    readonly size: number;\n}\n\ninterface MapConstructor {\n    new(): Map<any, any>;\n    new<K, V>(entries?: ReadonlyArray<readonly [K, V]> | null): Map<K, V>;\n    readonly prototype: Map<any, any>;\n}\ndeclare var Map: MapConstructor;\n\ninterface ReadonlyMap<K, V> {\n    forEach(callbackfn: (value: V, key: K, map: ReadonlyMap<K, V>) => void, thisArg?: any): void;\n    get(key: K): V | undefined;\n    has(key: K): boolean;\n    readonly size: number;\n}\n\ninterface WeakMap<K extends object, V> {\n    delete(key: K): boolean;\n    get(key: K): V | undefined;\n    has(key: K): boolean;\n    set(key: K, value: V): this;\n}\n\ninterface WeakMapConstructor {\n    new <K extends object = object, V = any>(entries?: ReadonlyArray<[K, V]> | null): WeakMap<K, V>;\n    readonly prototype: WeakMap<object, any>;\n}\ndeclare var WeakMap: WeakMapConstructor;\n\ninterface Set<T> {\n    add(value: T): this;\n    clear(): void;\n    delete(value: T): boolean;\n    forEach(callbackfn: (value: T, value2: T, set: Set<T>) => void, thisArg?: any): void;\n    has(value: T): boolean;\n    readonly size: number;\n}\n\ninterface SetConstructor {\n    new <T = any>(values?: ReadonlyArray<T> | null): Set<T>;\n    readonly prototype: Set<any>;\n}\ndeclare var Set: SetConstructor;\n\ninterface ReadonlySet<T> {\n    forEach(callbackfn: (value: T, value2: T, set: ReadonlySet<T>) => void, thisArg?: any): void;\n    has(value: T): boolean;\n    readonly size: number;\n}\n\ninterface WeakSet<T extends object> {\n    add(value: T): this;\n    delete(value: T): boolean;\n    has(value: T): boolean;\n}\n\ninterface WeakSetConstructor {\n    new <T extends object = object>(values?: ReadonlyArray<T> | null): WeakSet<T>;\n    readonly prototype: WeakSet<object>;\n}\ndeclare var WeakSet: WeakSetConstructor;\n',n.lib_es2015_core_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n\ninterface Array<T> {\n    /**\n     * Returns the value of the first element in the array where predicate is true, and undefined\n     * otherwise.\n     * @param predicate find calls predicate once for each element of the array, in ascending\n     * order, until it finds one where predicate returns true. If such an element is found, find\n     * immediately returns that element value. Otherwise, find returns undefined.\n     * @param thisArg If provided, it will be used as the this value for each invocation of\n     * predicate. If it is not provided, undefined is used instead.\n     */\n    find<S extends T>(predicate: (this: void, value: T, index: number, obj: T[]) => value is S, thisArg?: any): S | undefined;\n    find(predicate: (value: T, index: number, obj: T[]) => unknown, thisArg?: any): T | undefined;\n\n    /**\n     * Returns the index of the first element in the array where predicate is true, and -1\n     * otherwise.\n     * @param predicate find calls predicate once for each element of the array, in ascending\n     * order, until it finds one where predicate returns true. If such an element is found,\n     * findIndex immediately returns that element index. Otherwise, findIndex returns -1.\n     * @param thisArg If provided, it will be used as the this value for each invocation of\n     * predicate. If it is not provided, undefined is used instead.\n     */\n    findIndex(predicate: (value: T, index: number, obj: T[]) => unknown, thisArg?: any): number;\n\n    /**\n     * Returns the this object after filling the section identified by start and end with value\n     * @param value value to fill array section with\n     * @param start index to start filling the array at. If start is negative, it is treated as\n     * length+start where length is the length of the array.\n     * @param end index to stop filling the array at. If end is negative, it is treated as\n     * length+end.\n     */\n    fill(value: T, start?: number, end?: number): this;\n\n    /**\n     * Returns the this object after copying a section of the array identified by start and end\n     * to the same array starting at position target\n     * @param target If target is negative, it is treated as length+target where length is the\n     * length of the array.\n     * @param start If start is negative, it is treated as length+start. If end is negative, it\n     * is treated as length+end.\n     * @param end If not specified, length of the this object is used as its default value.\n     */\n    copyWithin(target: number, start: number, end?: number): this;\n}\n\ninterface ArrayConstructor {\n    /**\n     * Creates an array from an array-like object.\n     * @param arrayLike An array-like object to convert to an array.\n     */\n    from<T>(arrayLike: ArrayLike<T>): T[];\n\n    /**\n     * Creates an array from an iterable object.\n     * @param arrayLike An array-like object to convert to an array.\n     * @param mapfn A mapping function to call on every element of the array.\n     * @param thisArg Value of \'this\' used to invoke the mapfn.\n     */\n    from<T, U>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => U, thisArg?: any): U[];\n\n    /**\n     * Returns a new array from a set of elements.\n     * @param items A set of elements to include in the new array object.\n     */\n    of<T>(...items: T[]): T[];\n}\n\ninterface DateConstructor {\n    new (value: number | string | Date): Date;\n}\n\ninterface Function {\n    /**\n     * Returns the name of the function. Function names are read-only and can not be changed.\n     */\n    readonly name: string;\n}\n\ninterface Math {\n    /**\n     * Returns the number of leading zero bits in the 32-bit binary representation of a number.\n     * @param x A numeric expression.\n     */\n    clz32(x: number): number;\n\n    /**\n     * Returns the result of 32-bit multiplication of two numbers.\n     * @param x First number\n     * @param y Second number\n     */\n    imul(x: number, y: number): number;\n\n    /**\n     * Returns the sign of the x, indicating whether x is positive, negative or zero.\n     * @param x The numeric expression to test\n     */\n    sign(x: number): number;\n\n    /**\n     * Returns the base 10 logarithm of a number.\n     * @param x A numeric expression.\n     */\n    log10(x: number): number;\n\n    /**\n     * Returns the base 2 logarithm of a number.\n     * @param x A numeric expression.\n     */\n    log2(x: number): number;\n\n    /**\n     * Returns the natural logarithm of 1 + x.\n     * @param x A numeric expression.\n     */\n    log1p(x: number): number;\n\n    /**\n     * Returns the result of (e^x - 1), which is an implementation-dependent approximation to\n     * subtracting 1 from the exponential function of x (e raised to the power of x, where e\n     * is the base of the natural logarithms).\n     * @param x A numeric expression.\n     */\n    expm1(x: number): number;\n\n    /**\n     * Returns the hyperbolic cosine of a number.\n     * @param x A numeric expression that contains an angle measured in radians.\n     */\n    cosh(x: number): number;\n\n    /**\n     * Returns the hyperbolic sine of a number.\n     * @param x A numeric expression that contains an angle measured in radians.\n     */\n    sinh(x: number): number;\n\n    /**\n     * Returns the hyperbolic tangent of a number.\n     * @param x A numeric expression that contains an angle measured in radians.\n     */\n    tanh(x: number): number;\n\n    /**\n     * Returns the inverse hyperbolic cosine of a number.\n     * @param x A numeric expression that contains an angle measured in radians.\n     */\n    acosh(x: number): number;\n\n    /**\n     * Returns the inverse hyperbolic sine of a number.\n     * @param x A numeric expression that contains an angle measured in radians.\n     */\n    asinh(x: number): number;\n\n    /**\n     * Returns the inverse hyperbolic tangent of a number.\n     * @param x A numeric expression that contains an angle measured in radians.\n     */\n    atanh(x: number): number;\n\n    /**\n     * Returns the square root of the sum of squares of its arguments.\n     * @param values Values to compute the square root for.\n     *     If no arguments are passed, the result is +0.\n     *     If there is only one argument, the result is the absolute value.\n     *     If any argument is +Infinity or -Infinity, the result is +Infinity.\n     *     If any argument is NaN, the result is NaN.\n     *     If all arguments are either +0 or −0, the result is +0.\n     */\n    hypot(...values: number[]): number;\n\n    /**\n     * Returns the integral part of the a numeric expression, x, removing any fractional digits.\n     * If x is already an integer, the result is x.\n     * @param x A numeric expression.\n     */\n    trunc(x: number): number;\n\n    /**\n     * Returns the nearest single precision float representation of a number.\n     * @param x A numeric expression.\n     */\n    fround(x: number): number;\n\n    /**\n     * Returns an implementation-dependent approximation to the cube root of number.\n     * @param x A numeric expression.\n     */\n    cbrt(x: number): number;\n}\n\ninterface NumberConstructor {\n    /**\n     * The value of Number.EPSILON is the difference between 1 and the smallest value greater than 1\n     * that is representable as a Number value, which is approximately:\n     * 2.2204460492503130808472633361816 x 10‍−‍16.\n     */\n    readonly EPSILON: number;\n\n    /**\n     * Returns true if passed value is finite.\n     * Unlike the global isFinite, Number.isFinite doesn\'t forcibly convert the parameter to a\n     * number. Only finite values of the type number, result in true.\n     * @param number A numeric value.\n     */\n    isFinite(number: number): boolean;\n\n    /**\n     * Returns true if the value passed is an integer, false otherwise.\n     * @param number A numeric value.\n     */\n    isInteger(number: number): boolean;\n\n    /**\n     * Returns a Boolean value that indicates whether a value is the reserved value NaN (not a\n     * number). Unlike the global isNaN(), Number.isNaN() doesn\'t forcefully convert the parameter\n     * to a number. Only values of the type number, that are also NaN, result in true.\n     * @param number A numeric value.\n     */\n    isNaN(number: number): boolean;\n\n    /**\n     * Returns true if the value passed is a safe integer.\n     * @param number A numeric value.\n     */\n    isSafeInteger(number: number): boolean;\n\n    /**\n     * The value of the largest integer n such that n and n + 1 are both exactly representable as\n     * a Number value.\n     * The value of Number.MAX_SAFE_INTEGER is 9007199254740991 2^53 − 1.\n     */\n    readonly MAX_SAFE_INTEGER: number;\n\n    /**\n     * The value of the smallest integer n such that n and n − 1 are both exactly representable as\n     * a Number value.\n     * The value of Number.MIN_SAFE_INTEGER is −9007199254740991 (−(2^53 − 1)).\n     */\n    readonly MIN_SAFE_INTEGER: number;\n\n    /**\n     * Converts a string to a floating-point number.\n     * @param string A string that contains a floating-point number.\n     */\n    parseFloat(string: string): number;\n\n    /**\n     * Converts A string to an integer.\n     * @param s A string to convert into a number.\n     * @param radix A value between 2 and 36 that specifies the base of the number in numString.\n     * If this argument is not supplied, strings with a prefix of \'0x\' are considered hexadecimal.\n     * All other strings are considered decimal.\n     */\n    parseInt(string: string, radix?: number): number;\n}\n\ninterface ObjectConstructor {\n    /**\n     * Copy the values of all of the enumerable own properties from one or more source objects to a\n     * target object. Returns the target object.\n     * @param target The target object to copy to.\n     * @param source The source object from which to copy properties.\n     */\n    assign<T, U>(target: T, source: U): T & U;\n\n    /**\n     * Copy the values of all of the enumerable own properties from one or more source objects to a\n     * target object. Returns the target object.\n     * @param target The target object to copy to.\n     * @param source1 The first source object from which to copy properties.\n     * @param source2 The second source object from which to copy properties.\n     */\n    assign<T, U, V>(target: T, source1: U, source2: V): T & U & V;\n\n    /**\n     * Copy the values of all of the enumerable own properties from one or more source objects to a\n     * target object. Returns the target object.\n     * @param target The target object to copy to.\n     * @param source1 The first source object from which to copy properties.\n     * @param source2 The second source object from which to copy properties.\n     * @param source3 The third source object from which to copy properties.\n     */\n    assign<T, U, V, W>(target: T, source1: U, source2: V, source3: W): T & U & V & W;\n\n    /**\n     * Copy the values of all of the enumerable own properties from one or more source objects to a\n     * target object. Returns the target object.\n     * @param target The target object to copy to.\n     * @param sources One or more source objects from which to copy properties\n     */\n    assign(target: object, ...sources: any[]): any;\n\n    /**\n     * Returns an array of all symbol properties found directly on object o.\n     * @param o Object to retrieve the symbols from.\n     */\n    getOwnPropertySymbols(o: any): symbol[];\n\n    /**\n      * Returns the names of the enumerable string properties and methods of an object.\n      * @param o Object that contains the properties and methods. This can be an object that you created or an existing Document Object Model (DOM) object.\n      */\n    keys(o: {}): string[];\n\n    /**\n     * Returns true if the values are the same value, false otherwise.\n     * @param value1 The first value.\n     * @param value2 The second value.\n     */\n    is(value1: any, value2: any): boolean;\n\n    /**\n     * Sets the prototype of a specified object o to  object proto or null. Returns the object o.\n     * @param o The object to change its prototype.\n     * @param proto The value of the new prototype or null.\n     */\n    setPrototypeOf(o: any, proto: object | null): any;\n}\n\ninterface ReadonlyArray<T> {\n    /**\n     * Returns the value of the first element in the array where predicate is true, and undefined\n     * otherwise.\n     * @param predicate find calls predicate once for each element of the array, in ascending\n     * order, until it finds one where predicate returns true. If such an element is found, find\n     * immediately returns that element value. Otherwise, find returns undefined.\n     * @param thisArg If provided, it will be used as the this value for each invocation of\n     * predicate. If it is not provided, undefined is used instead.\n     */\n    find<S extends T>(predicate: (this: void, value: T, index: number, obj: ReadonlyArray<T>) => value is S, thisArg?: any): S | undefined;\n    find(predicate: (value: T, index: number, obj: ReadonlyArray<T>) => unknown, thisArg?: any): T | undefined;\n\n    /**\n     * Returns the index of the first element in the array where predicate is true, and -1\n     * otherwise.\n     * @param predicate find calls predicate once for each element of the array, in ascending\n     * order, until it finds one where predicate returns true. If such an element is found,\n     * findIndex immediately returns that element index. Otherwise, findIndex returns -1.\n     * @param thisArg If provided, it will be used as the this value for each invocation of\n     * predicate. If it is not provided, undefined is used instead.\n     */\n    findIndex(predicate: (value: T, index: number, obj: ReadonlyArray<T>) => unknown, thisArg?: any): number;\n}\n\ninterface RegExp {\n    /**\n     * Returns a string indicating the flags of the regular expression in question. This field is read-only.\n     * The characters in this string are sequenced and concatenated in the following order:\n     *\n     *    - "g" for global\n     *    - "i" for ignoreCase\n     *    - "m" for multiline\n     *    - "u" for unicode\n     *    - "y" for sticky\n     *\n     * If no flags are set, the value is the empty string.\n     */\n    readonly flags: string;\n\n    /**\n     * Returns a Boolean value indicating the state of the sticky flag (y) used with a regular\n     * expression. Default is false. Read-only.\n     */\n    readonly sticky: boolean;\n\n    /**\n     * Returns a Boolean value indicating the state of the Unicode flag (u) used with a regular\n     * expression. Default is false. Read-only.\n     */\n    readonly unicode: boolean;\n}\n\ninterface RegExpConstructor {\n    new (pattern: RegExp, flags?: string): RegExp;\n    (pattern: RegExp, flags?: string): RegExp;\n}\n\ninterface String {\n    /**\n     * Returns a nonnegative integer Number less than 1114112 (0x110000) that is the code point\n     * value of the UTF-16 encoded code point starting at the string element at position pos in\n     * the String resulting from converting this object to a String.\n     * If there is no element at that position, the result is undefined.\n     * If a valid UTF-16 surrogate pair does not begin at pos, the result is the code unit at pos.\n     */\n    codePointAt(pos: number): number | undefined;\n\n    /**\n     * Returns true if searchString appears as a substring of the result of converting this\n     * object to a String, at one or more positions that are\n     * greater than or equal to position; otherwise, returns false.\n     * @param searchString search string\n     * @param position If position is undefined, 0 is assumed, so as to search all of the String.\n     */\n    includes(searchString: string, position?: number): boolean;\n\n    /**\n     * Returns true if the sequence of elements of searchString converted to a String is the\n     * same as the corresponding elements of this object (converted to a String) starting at\n     * endPosition – length(this). Otherwise returns false.\n     */\n    endsWith(searchString: string, endPosition?: number): boolean;\n\n    /**\n     * Returns the String value result of normalizing the string into the normalization form\n     * named by form as specified in Unicode Standard Annex #15, Unicode Normalization Forms.\n     * @param form Applicable values: "NFC", "NFD", "NFKC", or "NFKD", If not specified default\n     * is "NFC"\n     */\n    normalize(form: "NFC" | "NFD" | "NFKC" | "NFKD"): string;\n\n    /**\n     * Returns the String value result of normalizing the string into the normalization form\n     * named by form as specified in Unicode Standard Annex #15, Unicode Normalization Forms.\n     * @param form Applicable values: "NFC", "NFD", "NFKC", or "NFKD", If not specified default\n     * is "NFC"\n     */\n    normalize(form?: string): string;\n\n    /**\n     * Returns a String value that is made from count copies appended together. If count is 0,\n     * the empty string is returned.\n     * @param count number of copies to append\n     */\n    repeat(count: number): string;\n\n    /**\n     * Returns true if the sequence of elements of searchString converted to a String is the\n     * same as the corresponding elements of this object (converted to a String) starting at\n     * position. Otherwise returns false.\n     */\n    startsWith(searchString: string, position?: number): boolean;\n\n    /**\n     * Returns an <a> HTML anchor element and sets the name attribute to the text value\n     * @param name\n     */\n    anchor(name: string): string;\n\n    /** Returns a <big> HTML element */\n    big(): string;\n\n    /** Returns a <blink> HTML element */\n    blink(): string;\n\n    /** Returns a <b> HTML element */\n    bold(): string;\n\n    /** Returns a <tt> HTML element */\n    fixed(): string;\n\n    /** Returns a <font> HTML element and sets the color attribute value */\n    fontcolor(color: string): string;\n\n    /** Returns a <font> HTML element and sets the size attribute value */\n    fontsize(size: number): string;\n\n    /** Returns a <font> HTML element and sets the size attribute value */\n    fontsize(size: string): string;\n\n    /** Returns an <i> HTML element */\n    italics(): string;\n\n    /** Returns an <a> HTML element and sets the href attribute value */\n    link(url: string): string;\n\n    /** Returns a <small> HTML element */\n    small(): string;\n\n    /** Returns a <strike> HTML element */\n    strike(): string;\n\n    /** Returns a <sub> HTML element */\n    sub(): string;\n\n    /** Returns a <sup> HTML element */\n    sup(): string;\n}\n\ninterface StringConstructor {\n    /**\n     * Return the String value whose elements are, in order, the elements in the List elements.\n     * If length is 0, the empty string is returned.\n     */\n    fromCodePoint(...codePoints: number[]): string;\n\n    /**\n     * String.raw is intended for use as a tag function of a Tagged Template String. When called\n     * as such the first argument will be a well formed template call site object and the rest\n     * parameter will contain the substitution values.\n     * @param template A well-formed template string call site representation.\n     * @param substitutions A set of substitution values.\n     */\n    raw(template: TemplateStringsArray, ...substitutions: any[]): string;\n}\n',n.lib_dom_iterable_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n\n/////////////////////////////\n/// DOM Iterable APIs\n/////////////////////////////\n\ninterface AudioParamMap extends ReadonlyMap<string, AudioParam> {\n}\n\ninterface AudioTrackList {\n    [Symbol.iterator](): IterableIterator<AudioTrack>;\n}\n\ninterface CSSRuleList {\n    [Symbol.iterator](): IterableIterator<CSSRule>;\n}\n\ninterface CSSStyleDeclaration {\n    [Symbol.iterator](): IterableIterator<string>;\n}\n\ninterface ClientRectList {\n    [Symbol.iterator](): IterableIterator<ClientRect>;\n}\n\ninterface DOMRectList {\n    [Symbol.iterator](): IterableIterator<DOMRect>;\n}\n\ninterface DOMStringList {\n    [Symbol.iterator](): IterableIterator<string>;\n}\n\ninterface DOMTokenList {\n    [Symbol.iterator](): IterableIterator<string>;\n    entries(): IterableIterator<[number, string]>;\n    keys(): IterableIterator<number>;\n    values(): IterableIterator<string>;\n}\n\ninterface DataTransferItemList {\n    [Symbol.iterator](): IterableIterator<DataTransferItem>;\n}\n\ninterface FileList {\n    [Symbol.iterator](): IterableIterator<File>;\n}\n\ninterface FormData {\n    [Symbol.iterator](): IterableIterator<[string, FormDataEntryValue]>;\n    /**\n     * Returns an array of key, value pairs for every entry in the list.\n     */\n    entries(): IterableIterator<[string, FormDataEntryValue]>;\n    /**\n     * Returns a list of keys in the list.\n     */\n    keys(): IterableIterator<string>;\n    /**\n     * Returns a list of values in the list.\n     */\n    values(): IterableIterator<FormDataEntryValue>;\n}\n\ninterface HTMLAllCollection {\n    [Symbol.iterator](): IterableIterator<Element>;\n}\n\ninterface HTMLCollectionBase {\n    [Symbol.iterator](): IterableIterator<Element>;\n}\n\ninterface HTMLCollectionOf<T extends Element> {\n    [Symbol.iterator](): IterableIterator<T>;\n}\n\ninterface HTMLFormElement {\n    [Symbol.iterator](): IterableIterator<Element>;\n}\n\ninterface HTMLSelectElement {\n    [Symbol.iterator](): IterableIterator<Element>;\n}\n\ninterface Headers {\n    [Symbol.iterator](): IterableIterator<[string, string]>;\n    /**\n     * Returns an iterator allowing to go through all key/value pairs contained in this object.\n     */\n    entries(): IterableIterator<[string, string]>;\n    /**\n     * Returns an iterator allowing to go through all keys of the key/value pairs contained in this object.\n     */\n    keys(): IterableIterator<string>;\n    /**\n     * Returns an iterator allowing to go through all values of the key/value pairs contained in this object.\n     */\n    values(): IterableIterator<string>;\n}\n\ninterface MediaKeyStatusMap {\n    [Symbol.iterator](): IterableIterator<[BufferSource, MediaKeyStatus]>;\n    entries(): IterableIterator<[BufferSource, MediaKeyStatus]>;\n    keys(): IterableIterator<BufferSource>;\n    values(): IterableIterator<MediaKeyStatus>;\n}\n\ninterface MediaList {\n    [Symbol.iterator](): IterableIterator<string>;\n}\n\ninterface MimeTypeArray {\n    [Symbol.iterator](): IterableIterator<Plugin>;\n}\n\ninterface NamedNodeMap {\n    [Symbol.iterator](): IterableIterator<Attr>;\n}\n\ninterface NodeList {\n    [Symbol.iterator](): IterableIterator<Node>;\n    /**\n     * Returns an array of key, value pairs for every entry in the list.\n     */\n    entries(): IterableIterator<[number, Node]>;\n    /**\n     * Returns an list of keys in the list.\n     */\n    keys(): IterableIterator<number>;\n    /**\n     * Returns an list of values in the list.\n     */\n    values(): IterableIterator<Node>;\n}\n\ninterface NodeListOf<TNode extends Node> {\n    [Symbol.iterator](): IterableIterator<TNode>;\n    /**\n     * Returns an array of key, value pairs for every entry in the list.\n     */\n    entries(): IterableIterator<[number, TNode]>;\n    /**\n     * Returns an list of keys in the list.\n     */\n    keys(): IterableIterator<number>;\n    /**\n     * Returns an list of values in the list.\n     */\n    values(): IterableIterator<TNode>;\n}\n\ninterface Plugin {\n    [Symbol.iterator](): IterableIterator<MimeType>;\n}\n\ninterface PluginArray {\n    [Symbol.iterator](): IterableIterator<Plugin>;\n}\n\ninterface RTCStatsReport extends ReadonlyMap<string, any> {\n}\n\ninterface SVGLengthList {\n    [Symbol.iterator](): IterableIterator<SVGLength>;\n}\n\ninterface SVGNumberList {\n    [Symbol.iterator](): IterableIterator<SVGNumber>;\n}\n\ninterface SVGPointList {\n    [Symbol.iterator](): IterableIterator<DOMPoint>;\n}\n\ninterface SVGStringList {\n    [Symbol.iterator](): IterableIterator<string>;\n}\n\ninterface SourceBufferList {\n    [Symbol.iterator](): IterableIterator<SourceBuffer>;\n}\n\ninterface SpeechGrammarList {\n    [Symbol.iterator](): IterableIterator<SpeechGrammar>;\n}\n\ninterface SpeechRecognitionResult {\n    [Symbol.iterator](): IterableIterator<SpeechRecognitionAlternative>;\n}\n\ninterface SpeechRecognitionResultList {\n    [Symbol.iterator](): IterableIterator<SpeechRecognitionResult>;\n}\n\ninterface StyleSheetList {\n    [Symbol.iterator](): IterableIterator<StyleSheet>;\n}\n\ninterface TextTrackCueList {\n    [Symbol.iterator](): IterableIterator<TextTrackCue>;\n}\n\ninterface TextTrackList {\n    [Symbol.iterator](): IterableIterator<TextTrack>;\n}\n\ninterface TouchList {\n    [Symbol.iterator](): IterableIterator<Touch>;\n}\n\ninterface URLSearchParams {\n    [Symbol.iterator](): IterableIterator<[string, string]>;\n    /**\n     * Returns an array of key, value pairs for every entry in the search params.\n     */\n    entries(): IterableIterator<[string, string]>;\n    /**\n     * Returns a list of keys in the search params.\n     */\n    keys(): IterableIterator<string>;\n    /**\n     * Returns a list of values in the search params.\n     */\n    values(): IterableIterator<string>;\n}\n\ninterface VideoTrackList {\n    [Symbol.iterator](): IterableIterator<VideoTrack>;\n}\n',n.lib_scripthost_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n\n\n\n/////////////////////////////\n/// Windows Script Host APIS\n/////////////////////////////\n\n\ninterface ActiveXObject {\n    new (s: string): any;\n}\ndeclare var ActiveXObject: ActiveXObject;\n\ninterface ITextWriter {\n    Write(s: string): void;\n    WriteLine(s: string): void;\n    Close(): void;\n}\n\ninterface TextStreamBase {\n    /**\n     * The column number of the current character position in an input stream.\n     */\n    Column: number;\n\n    /**\n     * The current line number in an input stream.\n     */\n    Line: number;\n\n    /**\n     * Closes a text stream.\n     * It is not necessary to close standard streams; they close automatically when the process ends. If\n     * you close a standard stream, be aware that any other pointers to that standard stream become invalid.\n     */\n    Close(): void;\n}\n\ninterface TextStreamWriter extends TextStreamBase {\n    /**\n     * Sends a string to an output stream.\n     */\n    Write(s: string): void;\n\n    /**\n     * Sends a specified number of blank lines (newline characters) to an output stream.\n     */\n    WriteBlankLines(intLines: number): void;\n\n    /**\n     * Sends a string followed by a newline character to an output stream.\n     */\n    WriteLine(s: string): void;\n}\n\ninterface TextStreamReader extends TextStreamBase {\n    /**\n     * Returns a specified number of characters from an input stream, starting at the current pointer position.\n     * Does not return until the ENTER key is pressed.\n     * Can only be used on a stream in reading mode; causes an error in writing or appending mode.\n     */\n    Read(characters: number): string;\n\n    /**\n     * Returns all characters from an input stream.\n     * Can only be used on a stream in reading mode; causes an error in writing or appending mode.\n     */\n    ReadAll(): string;\n\n    /**\n     * Returns an entire line from an input stream.\n     * Although this method extracts the newline character, it does not add it to the returned string.\n     * Can only be used on a stream in reading mode; causes an error in writing or appending mode.\n     */\n    ReadLine(): string;\n\n    /**\n     * Skips a specified number of characters when reading from an input text stream.\n     * Can only be used on a stream in reading mode; causes an error in writing or appending mode.\n     * @param characters Positive number of characters to skip forward. (Backward skipping is not supported.)\n     */\n    Skip(characters: number): void;\n\n    /**\n     * Skips the next line when reading from an input text stream.\n     * Can only be used on a stream in reading mode, not writing or appending mode.\n     */\n    SkipLine(): void;\n\n    /**\n     * Indicates whether the stream pointer position is at the end of a line.\n     */\n    AtEndOfLine: boolean;\n\n    /**\n     * Indicates whether the stream pointer position is at the end of a stream.\n     */\n    AtEndOfStream: boolean;\n}\n\ndeclare var WScript: {\n    /**\n     * Outputs text to either a message box (under WScript.exe) or the command console window followed by\n     * a newline (under CScript.exe).\n     */\n    Echo(s: any): void;\n\n    /**\n     * Exposes the write-only error output stream for the current script.\n     * Can be accessed only while using CScript.exe.\n     */\n    StdErr: TextStreamWriter;\n\n    /**\n     * Exposes the write-only output stream for the current script.\n     * Can be accessed only while using CScript.exe.\n     */\n    StdOut: TextStreamWriter;\n    Arguments: { length: number; Item(n: number): string; };\n\n    /**\n     *  The full path of the currently running script.\n     */\n    ScriptFullName: string;\n\n    /**\n     * Forces the script to stop immediately, with an optional exit code.\n     */\n    Quit(exitCode?: number): number;\n\n    /**\n     * The Windows Script Host build version number.\n     */\n    BuildVersion: number;\n\n    /**\n     * Fully qualified path of the host executable.\n     */\n    FullName: string;\n\n    /**\n     * Gets/sets the script mode - interactive(true) or batch(false).\n     */\n    Interactive: boolean;\n\n    /**\n     * The name of the host executable (WScript.exe or CScript.exe).\n     */\n    Name: string;\n\n    /**\n     * Path of the directory containing the host executable.\n     */\n    Path: string;\n\n    /**\n     * The filename of the currently running script.\n     */\n    ScriptName: string;\n\n    /**\n     * Exposes the read-only input stream for the current script.\n     * Can be accessed only while using CScript.exe.\n     */\n    StdIn: TextStreamReader;\n\n    /**\n     * Windows Script Host version\n     */\n    Version: string;\n\n    /**\n     * Connects a COM object\'s event sources to functions named with a given prefix, in the form prefix_event.\n     */\n    ConnectObject(objEventSource: any, strPrefix: string): void;\n\n    /**\n     * Creates a COM object.\n     * @param strProgiID\n     * @param strPrefix Function names in the form prefix_event will be bound to this object\'s COM events.\n     */\n    CreateObject(strProgID: string, strPrefix?: string): any;\n\n    /**\n     * Disconnects a COM object from its event sources.\n     */\n    DisconnectObject(obj: any): void;\n\n    /**\n     * Retrieves an existing object with the specified ProgID from memory, or creates a new one from a file.\n     * @param strPathname Fully qualified path to the file containing the object persisted to disk.\n     *                       For objects in memory, pass a zero-length string.\n     * @param strProgID\n     * @param strPrefix Function names in the form prefix_event will be bound to this object\'s COM events.\n     */\n    GetObject(strPathname: string, strProgID?: string, strPrefix?: string): any;\n\n    /**\n     * Suspends script execution for a specified length of time, then continues execution.\n     * @param intTime Interval (in milliseconds) to suspend script execution.\n     */\n    Sleep(intTime: number): void;\n};\n\n/**\n * WSH is an alias for WScript under Windows Script Host\n */\ndeclare var WSH: typeof WScript;\n\n/**\n * Represents an Automation SAFEARRAY\n */\ndeclare class SafeArray<T = any> {\n    private constructor();\n    private SafeArray_typekey: SafeArray<T>;\n}\n\n/**\n * Allows enumerating over a COM collection, which may not have indexed item access.\n */\ninterface Enumerator<T = any> {\n    /**\n     * Returns true if the current item is the last one in the collection, or the collection is empty,\n     * or the current item is undefined.\n     */\n    atEnd(): boolean;\n\n    /**\n     * Returns the current item in the collection\n     */\n    item(): T;\n\n    /**\n     * Resets the current item in the collection to the first item. If there are no items in the collection,\n     * the current item is set to undefined.\n     */\n    moveFirst(): void;\n\n    /**\n     * Moves the current item to the next item in the collection. If the enumerator is at the end of\n     * the collection or the collection is empty, the current item is set to undefined.\n     */\n    moveNext(): void;\n}\n\ninterface EnumeratorConstructor {\n    new <T = any>(safearray: SafeArray<T>): Enumerator<T>;\n    new <T = any>(collection: { Item(index: any): T }): Enumerator<T>;\n    new <T = any>(collection: any): Enumerator<T>;\n}\n\ndeclare var Enumerator: EnumeratorConstructor;\n\n/**\n * Enables reading from a COM safe array, which might have an alternate lower bound, or multiple dimensions.\n */\ninterface VBArray<T = any> {\n    /**\n     * Returns the number of dimensions (1-based).\n     */\n    dimensions(): number;\n\n    /**\n     * Takes an index for each dimension in the array, and returns the item at the corresponding location.\n     */\n    getItem(dimension1Index: number, ...dimensionNIndexes: number[]): T;\n\n    /**\n     * Returns the smallest available index for a given dimension.\n     * @param dimension 1-based dimension (defaults to 1)\n     */\n    lbound(dimension?: number): number;\n\n    /**\n     * Returns the largest available index for a given dimension.\n     * @param dimension 1-based dimension (defaults to 1)\n     */\n    ubound(dimension?: number): number;\n\n    /**\n     * Returns a Javascript array with all the elements in the VBArray. If there are multiple dimensions,\n     * each successive dimension is appended to the end of the array.\n     * Example: [[1,2,3],[4,5,6]] becomes [1,2,3,4,5,6]\n     */\n    toArray(): T[];\n}\n\ninterface VBArrayConstructor {\n    new <T = any>(safeArray: SafeArray<T>): VBArray<T>;\n}\n\ndeclare var VBArray: VBArrayConstructor;\n\n/**\n * Automation date (VT_DATE)\n */\ndeclare class VarDate {\n    private constructor();\n    private VarDate_typekey: VarDate;\n}\n\ninterface DateConstructor {\n    new (vd: VarDate): Date;\n}\n\ninterface Date {\n    getVarDate: () => VarDate;\n}\n',n.lib_webworker_importscripts_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n\n\n/////////////////////////////\n/// WorkerGlobalScope APIs\n/////////////////////////////\n// These are only available in a Web Worker\ndeclare function importScripts(...urls: string[]): void;\n',n.lib_dom_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n\n/////////////////////////////\n/// DOM APIs\n/////////////////////////////\n\ninterface Account {\n    displayName: string;\n    id: string;\n    imageURL?: string;\n    name?: string;\n    rpDisplayName: string;\n}\n\ninterface AddEventListenerOptions extends EventListenerOptions {\n    once?: boolean;\n    passive?: boolean;\n}\n\ninterface AesCbcParams extends Algorithm {\n    iv: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer;\n}\n\ninterface AesCtrParams extends Algorithm {\n    counter: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer;\n    length: number;\n}\n\ninterface AesDerivedKeyParams extends Algorithm {\n    length: number;\n}\n\ninterface AesGcmParams extends Algorithm {\n    additionalData?: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer;\n    iv: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer;\n    tagLength?: number;\n}\n\ninterface AesKeyAlgorithm extends KeyAlgorithm {\n    length: number;\n}\n\ninterface AesKeyGenParams extends Algorithm {\n    length: number;\n}\n\ninterface Algorithm {\n    name: string;\n}\n\ninterface AnalyserOptions extends AudioNodeOptions {\n    fftSize?: number;\n    maxDecibels?: number;\n    minDecibels?: number;\n    smoothingTimeConstant?: number;\n}\n\ninterface AnimationEventInit extends EventInit {\n    animationName?: string;\n    elapsedTime?: number;\n    pseudoElement?: string;\n}\n\ninterface AnimationPlaybackEventInit extends EventInit {\n    currentTime?: number | null;\n    timelineTime?: number | null;\n}\n\ninterface AssertionOptions {\n    allowList?: ScopedCredentialDescriptor[];\n    extensions?: WebAuthnExtensions;\n    rpId?: string;\n    timeoutSeconds?: number;\n}\n\ninterface AssignedNodesOptions {\n    flatten?: boolean;\n}\n\ninterface AudioBufferOptions {\n    length: number;\n    numberOfChannels?: number;\n    sampleRate: number;\n}\n\ninterface AudioBufferSourceOptions {\n    buffer?: AudioBuffer | null;\n    detune?: number;\n    loop?: boolean;\n    loopEnd?: number;\n    loopStart?: number;\n    playbackRate?: number;\n}\n\ninterface AudioContextInfo {\n    currentTime?: number;\n    sampleRate?: number;\n}\n\ninterface AudioContextOptions {\n    latencyHint?: AudioContextLatencyCategory | number;\n    sampleRate?: number;\n}\n\ninterface AudioNodeOptions {\n    channelCount?: number;\n    channelCountMode?: ChannelCountMode;\n    channelInterpretation?: ChannelInterpretation;\n}\n\ninterface AudioParamDescriptor {\n    automationRate?: AutomationRate;\n    defaultValue?: number;\n    maxValue?: number;\n    minValue?: number;\n    name: string;\n}\n\ninterface AudioProcessingEventInit extends EventInit {\n    inputBuffer: AudioBuffer;\n    outputBuffer: AudioBuffer;\n    playbackTime: number;\n}\n\ninterface AudioTimestamp {\n    contextTime?: number;\n    performanceTime?: number;\n}\n\ninterface AudioWorkletNodeOptions extends AudioNodeOptions {\n    numberOfInputs?: number;\n    numberOfOutputs?: number;\n    outputChannelCount?: number[];\n    parameterData?: Record<string, number>;\n    processorOptions?: any;\n}\n\ninterface BiquadFilterOptions extends AudioNodeOptions {\n    Q?: number;\n    detune?: number;\n    frequency?: number;\n    gain?: number;\n    type?: BiquadFilterType;\n}\n\ninterface BlobPropertyBag {\n    endings?: EndingType;\n    type?: string;\n}\n\ninterface ByteLengthChunk {\n    byteLength?: number;\n}\n\ninterface CacheQueryOptions {\n    ignoreMethod?: boolean;\n    ignoreSearch?: boolean;\n    ignoreVary?: boolean;\n}\n\ninterface CanvasRenderingContext2DSettings {\n    alpha?: boolean;\n}\n\ninterface ChannelMergerOptions extends AudioNodeOptions {\n    numberOfInputs?: number;\n}\n\ninterface ChannelSplitterOptions extends AudioNodeOptions {\n    numberOfOutputs?: number;\n}\n\ninterface ClientData {\n    challenge: string;\n    extensions?: WebAuthnExtensions;\n    hashAlg: string | Algorithm;\n    origin: string;\n    rpId: string;\n    tokenBinding?: string;\n}\n\ninterface ClientQueryOptions {\n    includeUncontrolled?: boolean;\n    type?: ClientTypes;\n}\n\ninterface ClipboardEventInit extends EventInit {\n    clipboardData?: DataTransfer | null;\n}\n\ninterface CloseEventInit extends EventInit {\n    code?: number;\n    reason?: string;\n    wasClean?: boolean;\n}\n\ninterface CompositionEventInit extends UIEventInit {\n    data?: string;\n}\n\ninterface ComputedEffectTiming extends EffectTiming {\n    activeDuration?: number;\n    currentIteration?: number | null;\n    endTime?: number;\n    localTime?: number | null;\n    progress?: number | null;\n}\n\ninterface ComputedKeyframe {\n    composite: CompositeOperationOrAuto;\n    computedOffset: number;\n    easing: string;\n    offset: number | null;\n    [property: string]: string | number | null | undefined;\n}\n\ninterface ConfirmSiteSpecificExceptionsInformation extends ExceptionInformation {\n    arrayOfDomainStrings?: string[];\n}\n\ninterface ConstantSourceOptions {\n    offset?: number;\n}\n\ninterface ConstrainBooleanParameters {\n    exact?: boolean;\n    ideal?: boolean;\n}\n\ninterface ConstrainDOMStringParameters {\n    exact?: string | string[];\n    ideal?: string | string[];\n}\n\ninterface ConstrainDoubleRange extends DoubleRange {\n    exact?: number;\n    ideal?: number;\n}\n\ninterface ConstrainULongRange extends ULongRange {\n    exact?: number;\n    ideal?: number;\n}\n\ninterface ConstrainVideoFacingModeParameters {\n    exact?: VideoFacingModeEnum | VideoFacingModeEnum[];\n    ideal?: VideoFacingModeEnum | VideoFacingModeEnum[];\n}\n\ninterface ConvolverOptions extends AudioNodeOptions {\n    buffer?: AudioBuffer | null;\n    disableNormalization?: boolean;\n}\n\ninterface CustomEventInit<T = any> extends EventInit {\n    detail?: T;\n}\n\ninterface DOMMatrix2DInit {\n    a?: number;\n    b?: number;\n    c?: number;\n    d?: number;\n    e?: number;\n    f?: number;\n    m11?: number;\n    m12?: number;\n    m21?: number;\n    m22?: number;\n    m41?: number;\n    m42?: number;\n}\n\ninterface DOMMatrixInit extends DOMMatrix2DInit {\n    is2D?: boolean;\n    m13?: number;\n    m14?: number;\n    m23?: number;\n    m24?: number;\n    m31?: number;\n    m32?: number;\n    m33?: number;\n    m34?: number;\n    m43?: number;\n    m44?: number;\n}\n\ninterface DOMPointInit {\n    w?: number;\n    x?: number;\n    y?: number;\n    z?: number;\n}\n\ninterface DOMQuadInit {\n    p1?: DOMPointInit;\n    p2?: DOMPointInit;\n    p3?: DOMPointInit;\n    p4?: DOMPointInit;\n}\n\ninterface DOMRectInit {\n    height?: number;\n    width?: number;\n    x?: number;\n    y?: number;\n}\n\ninterface DelayOptions extends AudioNodeOptions {\n    delayTime?: number;\n    maxDelayTime?: number;\n}\n\ninterface DeviceLightEventInit extends EventInit {\n    value?: number;\n}\n\ninterface DeviceMotionEventAccelerationInit {\n    x?: number | null;\n    y?: number | null;\n    z?: number | null;\n}\n\ninterface DeviceMotionEventInit extends EventInit {\n    acceleration?: DeviceMotionEventAccelerationInit;\n    accelerationIncludingGravity?: DeviceMotionEventAccelerationInit;\n    interval?: number;\n    rotationRate?: DeviceMotionEventRotationRateInit;\n}\n\ninterface DeviceMotionEventRotationRateInit {\n    alpha?: number | null;\n    beta?: number | null;\n    gamma?: number | null;\n}\n\ninterface DeviceOrientationEventInit extends EventInit {\n    absolute?: boolean;\n    alpha?: number | null;\n    beta?: number | null;\n    gamma?: number | null;\n}\n\ninterface DevicePermissionDescriptor extends PermissionDescriptor {\n    deviceId?: string;\n    name: "camera" | "microphone" | "speaker";\n}\n\ninterface DocumentTimelineOptions {\n    originTime?: number;\n}\n\ninterface DoubleRange {\n    max?: number;\n    min?: number;\n}\n\ninterface DragEventInit extends MouseEventInit {\n    dataTransfer?: DataTransfer | null;\n}\n\ninterface DynamicsCompressorOptions extends AudioNodeOptions {\n    attack?: number;\n    knee?: number;\n    ratio?: number;\n    release?: number;\n    threshold?: number;\n}\n\ninterface EcKeyAlgorithm extends KeyAlgorithm {\n    namedCurve: NamedCurve;\n}\n\ninterface EcKeyGenParams extends Algorithm {\n    namedCurve: NamedCurve;\n}\n\ninterface EcKeyImportParams extends Algorithm {\n    namedCurve: NamedCurve;\n}\n\ninterface EcdhKeyDeriveParams extends Algorithm {\n    public: CryptoKey;\n}\n\ninterface EcdsaParams extends Algorithm {\n    hash: HashAlgorithmIdentifier;\n}\n\ninterface EffectTiming {\n    delay?: number;\n    direction?: PlaybackDirection;\n    duration?: number | string;\n    easing?: string;\n    endDelay?: number;\n    fill?: FillMode;\n    iterationStart?: number;\n    iterations?: number;\n}\n\ninterface ElementCreationOptions {\n    is?: string;\n}\n\ninterface ElementDefinitionOptions {\n    extends?: string;\n}\n\ninterface ErrorEventInit extends EventInit {\n    colno?: number;\n    error?: any;\n    filename?: string;\n    lineno?: number;\n    message?: string;\n}\n\ninterface EventInit {\n    bubbles?: boolean;\n    cancelable?: boolean;\n    composed?: boolean;\n}\n\ninterface EventListenerOptions {\n    capture?: boolean;\n}\n\ninterface EventModifierInit extends UIEventInit {\n    altKey?: boolean;\n    ctrlKey?: boolean;\n    metaKey?: boolean;\n    modifierAltGraph?: boolean;\n    modifierCapsLock?: boolean;\n    modifierFn?: boolean;\n    modifierFnLock?: boolean;\n    modifierHyper?: boolean;\n    modifierNumLock?: boolean;\n    modifierOS?: boolean;\n    modifierScrollLock?: boolean;\n    modifierSuper?: boolean;\n    modifierSymbol?: boolean;\n    modifierSymbolLock?: boolean;\n    shiftKey?: boolean;\n}\n\ninterface EventSourceInit {\n    withCredentials?: boolean;\n}\n\ninterface ExceptionInformation {\n    domain?: string | null;\n}\n\ninterface FilePropertyBag extends BlobPropertyBag {\n    lastModified?: number;\n}\n\ninterface FocusEventInit extends UIEventInit {\n    relatedTarget?: EventTarget | null;\n}\n\ninterface FocusNavigationEventInit extends EventInit {\n    navigationReason?: string | null;\n    originHeight?: number;\n    originLeft?: number;\n    originTop?: number;\n    originWidth?: number;\n}\n\ninterface FocusNavigationOrigin {\n    originHeight?: number;\n    originLeft?: number;\n    originTop?: number;\n    originWidth?: number;\n}\n\ninterface FocusOptions {\n    preventScroll?: boolean;\n}\n\ninterface FullscreenOptions {\n    navigationUI?: FullscreenNavigationUI;\n}\n\ninterface GainOptions extends AudioNodeOptions {\n    gain?: number;\n}\n\ninterface GamepadEventInit extends EventInit {\n    gamepad: Gamepad;\n}\n\ninterface GetNotificationOptions {\n    tag?: string;\n}\n\ninterface GetRootNodeOptions {\n    composed?: boolean;\n}\n\ninterface HashChangeEventInit extends EventInit {\n    newURL?: string;\n    oldURL?: string;\n}\n\ninterface HkdfParams extends Algorithm {\n    hash: HashAlgorithmIdentifier;\n    info: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer;\n    salt: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer;\n}\n\ninterface HmacImportParams extends Algorithm {\n    hash: HashAlgorithmIdentifier;\n    length?: number;\n}\n\ninterface HmacKeyAlgorithm extends KeyAlgorithm {\n    hash: KeyAlgorithm;\n    length: number;\n}\n\ninterface HmacKeyGenParams extends Algorithm {\n    hash: HashAlgorithmIdentifier;\n    length?: number;\n}\n\ninterface IDBIndexParameters {\n    multiEntry?: boolean;\n    unique?: boolean;\n}\n\ninterface IDBObjectStoreParameters {\n    autoIncrement?: boolean;\n    keyPath?: string | string[] | null;\n}\n\ninterface IDBVersionChangeEventInit extends EventInit {\n    newVersion?: number | null;\n    oldVersion?: number;\n}\n\ninterface IIRFilterOptions extends AudioNodeOptions {\n    feedback: number[];\n    feedforward: number[];\n}\n\ninterface ImageEncodeOptions {\n    quality?: number;\n    type?: string;\n}\n\ninterface IntersectionObserverEntryInit {\n    boundingClientRect: DOMRectInit;\n    intersectionRatio: number;\n    intersectionRect: DOMRectInit;\n    isIntersecting: boolean;\n    rootBounds: DOMRectInit | null;\n    target: Element;\n    time: number;\n}\n\ninterface IntersectionObserverInit {\n    root?: Element | null;\n    rootMargin?: string;\n    threshold?: number | number[];\n}\n\ninterface JsonWebKey {\n    alg?: string;\n    crv?: string;\n    d?: string;\n    dp?: string;\n    dq?: string;\n    e?: string;\n    ext?: boolean;\n    k?: string;\n    key_ops?: string[];\n    kty?: string;\n    n?: string;\n    oth?: RsaOtherPrimesInfo[];\n    p?: string;\n    q?: string;\n    qi?: string;\n    use?: string;\n    x?: string;\n    y?: string;\n}\n\ninterface KeyAlgorithm {\n    name: string;\n}\n\ninterface KeyboardEventInit extends EventModifierInit {\n    code?: string;\n    key?: string;\n    location?: number;\n    repeat?: boolean;\n}\n\ninterface Keyframe {\n    composite?: CompositeOperationOrAuto;\n    easing?: string;\n    offset?: number | null;\n    [property: string]: string | number | null | undefined;\n}\n\ninterface KeyframeAnimationOptions extends KeyframeEffectOptions {\n    id?: string;\n}\n\ninterface KeyframeEffectOptions extends EffectTiming {\n    composite?: CompositeOperation;\n    iterationComposite?: IterationCompositeOperation;\n}\n\ninterface MediaElementAudioSourceOptions {\n    mediaElement: HTMLMediaElement;\n}\n\ninterface MediaEncryptedEventInit extends EventInit {\n    initData?: ArrayBuffer | null;\n    initDataType?: string;\n}\n\ninterface MediaKeyMessageEventInit extends EventInit {\n    message: ArrayBuffer;\n    messageType: MediaKeyMessageType;\n}\n\ninterface MediaKeySystemConfiguration {\n    audioCapabilities?: MediaKeySystemMediaCapability[];\n    distinctiveIdentifier?: MediaKeysRequirement;\n    initDataTypes?: string[];\n    label?: string;\n    persistentState?: MediaKeysRequirement;\n    sessionTypes?: string[];\n    videoCapabilities?: MediaKeySystemMediaCapability[];\n}\n\ninterface MediaKeySystemMediaCapability {\n    contentType?: string;\n    robustness?: string;\n}\n\ninterface MediaQueryListEventInit extends EventInit {\n    matches?: boolean;\n    media?: string;\n}\n\ninterface MediaStreamAudioSourceOptions {\n    mediaStream: MediaStream;\n}\n\ninterface MediaStreamConstraints {\n    audio?: boolean | MediaTrackConstraints;\n    peerIdentity?: string;\n    video?: boolean | MediaTrackConstraints;\n}\n\ninterface MediaStreamErrorEventInit extends EventInit {\n    error?: MediaStreamError | null;\n}\n\ninterface MediaStreamEventInit extends EventInit {\n    stream?: MediaStream;\n}\n\ninterface MediaStreamTrackAudioSourceOptions {\n    mediaStreamTrack: MediaStreamTrack;\n}\n\ninterface MediaStreamTrackEventInit extends EventInit {\n    track: MediaStreamTrack;\n}\n\ninterface MediaTrackCapabilities {\n    aspectRatio?: DoubleRange;\n    autoGainControl?: boolean[];\n    channelCount?: ULongRange;\n    deviceId?: string;\n    echoCancellation?: boolean[];\n    facingMode?: string[];\n    frameRate?: DoubleRange;\n    groupId?: string;\n    height?: ULongRange;\n    latency?: DoubleRange;\n    noiseSuppression?: boolean[];\n    resizeMode?: string[];\n    sampleRate?: ULongRange;\n    sampleSize?: ULongRange;\n    volume?: DoubleRange;\n    width?: ULongRange;\n}\n\ninterface MediaTrackConstraintSet {\n    aspectRatio?: ConstrainDouble;\n    autoGainControl?: ConstrainBoolean;\n    channelCount?: ConstrainULong;\n    deviceId?: ConstrainDOMString;\n    echoCancellation?: ConstrainBoolean;\n    facingMode?: ConstrainDOMString;\n    frameRate?: ConstrainDouble;\n    groupId?: ConstrainDOMString;\n    height?: ConstrainULong;\n    latency?: ConstrainDouble;\n    noiseSuppression?: ConstrainBoolean;\n    resizeMode?: ConstrainDOMString;\n    sampleRate?: ConstrainULong;\n    sampleSize?: ConstrainULong;\n    volume?: ConstrainDouble;\n    width?: ConstrainULong;\n}\n\ninterface MediaTrackConstraints extends MediaTrackConstraintSet {\n    advanced?: MediaTrackConstraintSet[];\n}\n\ninterface MediaTrackSettings {\n    aspectRatio?: number;\n    autoGainControl?: boolean;\n    channelCount?: number;\n    deviceId?: string;\n    echoCancellation?: boolean;\n    facingMode?: string;\n    frameRate?: number;\n    groupId?: string;\n    height?: number;\n    latency?: number;\n    noiseSuppression?: boolean;\n    resizeMode?: string;\n    sampleRate?: number;\n    sampleSize?: number;\n    volume?: number;\n    width?: number;\n}\n\ninterface MediaTrackSupportedConstraints {\n    aspectRatio?: boolean;\n    autoGainControl?: boolean;\n    channelCount?: boolean;\n    deviceId?: boolean;\n    echoCancellation?: boolean;\n    facingMode?: boolean;\n    frameRate?: boolean;\n    groupId?: boolean;\n    height?: boolean;\n    latency?: boolean;\n    noiseSuppression?: boolean;\n    resizeMode?: boolean;\n    sampleRate?: boolean;\n    sampleSize?: boolean;\n    volume?: boolean;\n    width?: boolean;\n}\n\ninterface MessageEventInit extends EventInit {\n    data?: any;\n    lastEventId?: string;\n    origin?: string;\n    ports?: MessagePort[];\n    source?: MessageEventSource | null;\n}\n\ninterface MidiPermissionDescriptor extends PermissionDescriptor {\n    name: "midi";\n    sysex?: boolean;\n}\n\ninterface MouseEventInit extends EventModifierInit {\n    button?: number;\n    buttons?: number;\n    clientX?: number;\n    clientY?: number;\n    movementX?: number;\n    movementY?: number;\n    relatedTarget?: EventTarget | null;\n    screenX?: number;\n    screenY?: number;\n}\n\ninterface MultiCacheQueryOptions extends CacheQueryOptions {\n    cacheName?: string;\n}\n\ninterface MutationObserverInit {\n    attributeFilter?: string[];\n    attributeOldValue?: boolean;\n    attributes?: boolean;\n    characterData?: boolean;\n    characterDataOldValue?: boolean;\n    childList?: boolean;\n    subtree?: boolean;\n}\n\ninterface NavigationPreloadState {\n    enabled?: boolean;\n    headerValue?: string;\n}\n\ninterface NotificationAction {\n    action: string;\n    icon?: string;\n    title: string;\n}\n\ninterface NotificationOptions {\n    actions?: NotificationAction[];\n    badge?: string;\n    body?: string;\n    data?: any;\n    dir?: NotificationDirection;\n    icon?: string;\n    image?: string;\n    lang?: string;\n    renotify?: boolean;\n    requireInteraction?: boolean;\n    silent?: boolean;\n    tag?: string;\n    timestamp?: number;\n    vibrate?: VibratePattern;\n}\n\ninterface OfflineAudioCompletionEventInit extends EventInit {\n    renderedBuffer: AudioBuffer;\n}\n\ninterface OfflineAudioContextOptions {\n    length: number;\n    numberOfChannels?: number;\n    sampleRate: number;\n}\n\ninterface OptionalEffectTiming {\n    delay?: number;\n    direction?: PlaybackDirection;\n    duration?: number | string;\n    easing?: string;\n    endDelay?: number;\n    fill?: FillMode;\n    iterationStart?: number;\n    iterations?: number;\n}\n\ninterface OscillatorOptions extends AudioNodeOptions {\n    detune?: number;\n    frequency?: number;\n    periodicWave?: PeriodicWave;\n    type?: OscillatorType;\n}\n\ninterface PannerOptions extends AudioNodeOptions {\n    coneInnerAngle?: number;\n    coneOuterAngle?: number;\n    coneOuterGain?: number;\n    distanceModel?: DistanceModelType;\n    maxDistance?: number;\n    orientationX?: number;\n    orientationY?: number;\n    orientationZ?: number;\n    panningModel?: PanningModelType;\n    positionX?: number;\n    positionY?: number;\n    positionZ?: number;\n    refDistance?: number;\n    rolloffFactor?: number;\n}\n\ninterface PaymentCurrencyAmount {\n    currency: string;\n    currencySystem?: string;\n    value: string;\n}\n\ninterface PaymentDetailsBase {\n    displayItems?: PaymentItem[];\n    modifiers?: PaymentDetailsModifier[];\n    shippingOptions?: PaymentShippingOption[];\n}\n\ninterface PaymentDetailsInit extends PaymentDetailsBase {\n    id?: string;\n    total: PaymentItem;\n}\n\ninterface PaymentDetailsModifier {\n    additionalDisplayItems?: PaymentItem[];\n    data?: any;\n    supportedMethods: string | string[];\n    total?: PaymentItem;\n}\n\ninterface PaymentDetailsUpdate extends PaymentDetailsBase {\n    error?: string;\n    total?: PaymentItem;\n}\n\ninterface PaymentItem {\n    amount: PaymentCurrencyAmount;\n    label: string;\n    pending?: boolean;\n}\n\ninterface PaymentMethodData {\n    data?: any;\n    supportedMethods: string | string[];\n}\n\ninterface PaymentOptions {\n    requestPayerEmail?: boolean;\n    requestPayerName?: boolean;\n    requestPayerPhone?: boolean;\n    requestShipping?: boolean;\n    shippingType?: string;\n}\n\ninterface PaymentRequestUpdateEventInit extends EventInit {\n}\n\ninterface PaymentShippingOption {\n    amount: PaymentCurrencyAmount;\n    id: string;\n    label: string;\n    selected?: boolean;\n}\n\ninterface Pbkdf2Params extends Algorithm {\n    hash: HashAlgorithmIdentifier;\n    iterations: number;\n    salt: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer;\n}\n\ninterface PerformanceObserverInit {\n    buffered?: boolean;\n    entryTypes?: string[];\n    type?: string;\n}\n\ninterface PeriodicWaveConstraints {\n    disableNormalization?: boolean;\n}\n\ninterface PeriodicWaveOptions extends PeriodicWaveConstraints {\n    imag?: number[] | Float32Array;\n    real?: number[] | Float32Array;\n}\n\ninterface PermissionDescriptor {\n    name: PermissionName;\n}\n\ninterface PipeOptions {\n    preventAbort?: boolean;\n    preventCancel?: boolean;\n    preventClose?: boolean;\n    signal?: AbortSignal;\n}\n\ninterface PointerEventInit extends MouseEventInit {\n    height?: number;\n    isPrimary?: boolean;\n    pointerId?: number;\n    pointerType?: string;\n    pressure?: number;\n    tangentialPressure?: number;\n    tiltX?: number;\n    tiltY?: number;\n    twist?: number;\n    width?: number;\n}\n\ninterface PopStateEventInit extends EventInit {\n    state?: any;\n}\n\ninterface PositionOptions {\n    enableHighAccuracy?: boolean;\n    maximumAge?: number;\n    timeout?: number;\n}\n\ninterface PostMessageOptions {\n    transfer?: any[];\n}\n\ninterface ProgressEventInit extends EventInit {\n    lengthComputable?: boolean;\n    loaded?: number;\n    total?: number;\n}\n\ninterface PromiseRejectionEventInit extends EventInit {\n    promise: Promise<any>;\n    reason?: any;\n}\n\ninterface PropertyIndexedKeyframes {\n    composite?: CompositeOperationOrAuto | CompositeOperationOrAuto[];\n    easing?: string | string[];\n    offset?: number | (number | null)[];\n    [property: string]: string | string[] | number | null | (number | null)[] | undefined;\n}\n\ninterface PushPermissionDescriptor extends PermissionDescriptor {\n    name: "push";\n    userVisibleOnly?: boolean;\n}\n\ninterface PushSubscriptionJSON {\n    endpoint?: string;\n    expirationTime?: number | null;\n    keys?: Record<string, string>;\n}\n\ninterface PushSubscriptionOptionsInit {\n    applicationServerKey?: BufferSource | string | null;\n    userVisibleOnly?: boolean;\n}\n\ninterface QueuingStrategy<T = any> {\n    highWaterMark?: number;\n    size?: QueuingStrategySizeCallback<T>;\n}\n\ninterface RTCAnswerOptions extends RTCOfferAnswerOptions {\n}\n\ninterface RTCCertificateExpiration {\n    expires?: number;\n}\n\ninterface RTCConfiguration {\n    bundlePolicy?: RTCBundlePolicy;\n    certificates?: RTCCertificate[];\n    iceCandidatePoolSize?: number;\n    iceServers?: RTCIceServer[];\n    iceTransportPolicy?: RTCIceTransportPolicy;\n    peerIdentity?: string;\n    rtcpMuxPolicy?: RTCRtcpMuxPolicy;\n}\n\ninterface RTCDTMFToneChangeEventInit extends EventInit {\n    tone: string;\n}\n\ninterface RTCDataChannelEventInit extends EventInit {\n    channel: RTCDataChannel;\n}\n\ninterface RTCDataChannelInit {\n    id?: number;\n    maxPacketLifeTime?: number;\n    maxRetransmits?: number;\n    negotiated?: boolean;\n    ordered?: boolean;\n    priority?: RTCPriorityType;\n    protocol?: string;\n}\n\ninterface RTCDtlsFingerprint {\n    algorithm?: string;\n    value?: string;\n}\n\ninterface RTCDtlsParameters {\n    fingerprints?: RTCDtlsFingerprint[];\n    role?: RTCDtlsRole;\n}\n\ninterface RTCErrorEventInit extends EventInit {\n    error?: RTCError | null;\n}\n\ninterface RTCIceCandidateAttributes extends RTCStats {\n    addressSourceUrl?: string;\n    candidateType?: RTCStatsIceCandidateType;\n    ipAddress?: string;\n    portNumber?: number;\n    priority?: number;\n    transport?: string;\n}\n\ninterface RTCIceCandidateComplete {\n}\n\ninterface RTCIceCandidateDictionary {\n    foundation?: string;\n    ip?: string;\n    msMTurnSessionId?: string;\n    port?: number;\n    priority?: number;\n    protocol?: RTCIceProtocol;\n    relatedAddress?: string;\n    relatedPort?: number;\n    tcpType?: RTCIceTcpCandidateType;\n    type?: RTCIceCandidateType;\n}\n\ninterface RTCIceCandidateInit {\n    candidate?: string;\n    sdpMLineIndex?: number | null;\n    sdpMid?: string | null;\n    usernameFragment?: string;\n}\n\ninterface RTCIceCandidatePair {\n    local?: RTCIceCandidate;\n    remote?: RTCIceCandidate;\n}\n\ninterface RTCIceCandidatePairStats extends RTCStats {\n    availableIncomingBitrate?: number;\n    availableOutgoingBitrate?: number;\n    bytesReceived?: number;\n    bytesSent?: number;\n    localCandidateId?: string;\n    nominated?: boolean;\n    priority?: number;\n    readable?: boolean;\n    remoteCandidateId?: string;\n    roundTripTime?: number;\n    state?: RTCStatsIceCandidatePairState;\n    transportId?: string;\n    writable?: boolean;\n}\n\ninterface RTCIceGatherOptions {\n    gatherPolicy?: RTCIceGatherPolicy;\n    iceservers?: RTCIceServer[];\n}\n\ninterface RTCIceParameters {\n    password?: string;\n    usernameFragment?: string;\n}\n\ninterface RTCIceServer {\n    credential?: string | RTCOAuthCredential;\n    credentialType?: RTCIceCredentialType;\n    urls: string | string[];\n    username?: string;\n}\n\ninterface RTCIdentityProviderOptions {\n    peerIdentity?: string;\n    protocol?: string;\n    usernameHint?: string;\n}\n\ninterface RTCInboundRTPStreamStats extends RTCRTPStreamStats {\n    bytesReceived?: number;\n    fractionLost?: number;\n    jitter?: number;\n    packetsLost?: number;\n    packetsReceived?: number;\n}\n\ninterface RTCMediaStreamTrackStats extends RTCStats {\n    audioLevel?: number;\n    echoReturnLoss?: number;\n    echoReturnLossEnhancement?: number;\n    frameHeight?: number;\n    frameWidth?: number;\n    framesCorrupted?: number;\n    framesDecoded?: number;\n    framesDropped?: number;\n    framesPerSecond?: number;\n    framesReceived?: number;\n    framesSent?: number;\n    remoteSource?: boolean;\n    ssrcIds?: string[];\n    trackIdentifier?: string;\n}\n\ninterface RTCOAuthCredential {\n    accessToken: string;\n    macKey: string;\n}\n\ninterface RTCOfferAnswerOptions {\n    voiceActivityDetection?: boolean;\n}\n\ninterface RTCOfferOptions extends RTCOfferAnswerOptions {\n    iceRestart?: boolean;\n    offerToReceiveAudio?: boolean;\n    offerToReceiveVideo?: boolean;\n}\n\ninterface RTCOutboundRTPStreamStats extends RTCRTPStreamStats {\n    bytesSent?: number;\n    packetsSent?: number;\n    roundTripTime?: number;\n    targetBitrate?: number;\n}\n\ninterface RTCPeerConnectionIceErrorEventInit extends EventInit {\n    errorCode: number;\n    hostCandidate?: string;\n    statusText?: string;\n    url?: string;\n}\n\ninterface RTCPeerConnectionIceEventInit extends EventInit {\n    candidate?: RTCIceCandidate | null;\n    url?: string | null;\n}\n\ninterface RTCRTPStreamStats extends RTCStats {\n    associateStatsId?: string;\n    codecId?: string;\n    firCount?: number;\n    isRemote?: boolean;\n    mediaTrackId?: string;\n    mediaType?: string;\n    nackCount?: number;\n    pliCount?: number;\n    sliCount?: number;\n    ssrc?: string;\n    transportId?: string;\n}\n\ninterface RTCRtcpFeedback {\n    parameter?: string;\n    type?: string;\n}\n\ninterface RTCRtcpParameters {\n    cname?: string;\n    reducedSize?: boolean;\n}\n\ninterface RTCRtpCapabilities {\n    codecs: RTCRtpCodecCapability[];\n    headerExtensions: RTCRtpHeaderExtensionCapability[];\n}\n\ninterface RTCRtpCodecCapability {\n    channels?: number;\n    clockRate: number;\n    mimeType: string;\n    sdpFmtpLine?: string;\n}\n\ninterface RTCRtpCodecParameters {\n    channels?: number;\n    clockRate: number;\n    mimeType: string;\n    payloadType: number;\n    sdpFmtpLine?: string;\n}\n\ninterface RTCRtpCodingParameters {\n    rid?: string;\n}\n\ninterface RTCRtpContributingSource {\n    audioLevel?: number;\n    source: number;\n    timestamp: number;\n}\n\ninterface RTCRtpDecodingParameters extends RTCRtpCodingParameters {\n}\n\ninterface RTCRtpEncodingParameters extends RTCRtpCodingParameters {\n    active?: boolean;\n    codecPayloadType?: number;\n    dtx?: RTCDtxStatus;\n    maxBitrate?: number;\n    maxFramerate?: number;\n    priority?: RTCPriorityType;\n    ptime?: number;\n    scaleResolutionDownBy?: number;\n}\n\ninterface RTCRtpFecParameters {\n    mechanism?: string;\n    ssrc?: number;\n}\n\ninterface RTCRtpHeaderExtension {\n    kind?: string;\n    preferredEncrypt?: boolean;\n    preferredId?: number;\n    uri?: string;\n}\n\ninterface RTCRtpHeaderExtensionCapability {\n    uri?: string;\n}\n\ninterface RTCRtpHeaderExtensionParameters {\n    encrypted?: boolean;\n    id: number;\n    uri: string;\n}\n\ninterface RTCRtpParameters {\n    codecs: RTCRtpCodecParameters[];\n    headerExtensions: RTCRtpHeaderExtensionParameters[];\n    rtcp: RTCRtcpParameters;\n}\n\ninterface RTCRtpReceiveParameters extends RTCRtpParameters {\n    encodings: RTCRtpDecodingParameters[];\n}\n\ninterface RTCRtpRtxParameters {\n    ssrc?: number;\n}\n\ninterface RTCRtpSendParameters extends RTCRtpParameters {\n    degradationPreference?: RTCDegradationPreference;\n    encodings: RTCRtpEncodingParameters[];\n    transactionId: string;\n}\n\ninterface RTCRtpSynchronizationSource extends RTCRtpContributingSource {\n    voiceActivityFlag?: boolean;\n}\n\ninterface RTCRtpTransceiverInit {\n    direction?: RTCRtpTransceiverDirection;\n    sendEncodings?: RTCRtpEncodingParameters[];\n    streams?: MediaStream[];\n}\n\ninterface RTCRtpUnhandled {\n    muxId?: string;\n    payloadType?: number;\n    ssrc?: number;\n}\n\ninterface RTCSessionDescriptionInit {\n    sdp?: string;\n    type: RTCSdpType;\n}\n\ninterface RTCSrtpKeyParam {\n    keyMethod?: string;\n    keySalt?: string;\n    lifetime?: string;\n    mkiLength?: number;\n    mkiValue?: number;\n}\n\ninterface RTCSrtpSdesParameters {\n    cryptoSuite?: string;\n    keyParams?: RTCSrtpKeyParam[];\n    sessionParams?: string[];\n    tag?: number;\n}\n\ninterface RTCSsrcRange {\n    max?: number;\n    min?: number;\n}\n\ninterface RTCStats {\n    id: string;\n    timestamp: number;\n    type: RTCStatsType;\n}\n\ninterface RTCStatsEventInit extends EventInit {\n    report: RTCStatsReport;\n}\n\ninterface RTCStatsReport {\n}\n\ninterface RTCTrackEventInit extends EventInit {\n    receiver: RTCRtpReceiver;\n    streams?: MediaStream[];\n    track: MediaStreamTrack;\n    transceiver: RTCRtpTransceiver;\n}\n\ninterface RTCTransportStats extends RTCStats {\n    activeConnection?: boolean;\n    bytesReceived?: number;\n    bytesSent?: number;\n    localCertificateId?: string;\n    remoteCertificateId?: string;\n    rtcpTransportStatsId?: string;\n    selectedCandidatePairId?: string;\n}\n\ninterface RegistrationOptions {\n    scope?: string;\n    type?: WorkerType;\n    updateViaCache?: ServiceWorkerUpdateViaCache;\n}\n\ninterface RequestInit {\n    body?: BodyInit | null;\n    cache?: RequestCache;\n    credentials?: RequestCredentials;\n    headers?: HeadersInit;\n    integrity?: string;\n    keepalive?: boolean;\n    method?: string;\n    mode?: RequestMode;\n    redirect?: RequestRedirect;\n    referrer?: string;\n    referrerPolicy?: ReferrerPolicy;\n    signal?: AbortSignal | null;\n    window?: any;\n}\n\ninterface ResponseInit {\n    headers?: HeadersInit;\n    status?: number;\n    statusText?: string;\n}\n\ninterface RsaHashedImportParams extends Algorithm {\n    hash: HashAlgorithmIdentifier;\n}\n\ninterface RsaHashedKeyAlgorithm extends RsaKeyAlgorithm {\n    hash: KeyAlgorithm;\n}\n\ninterface RsaHashedKeyGenParams extends RsaKeyGenParams {\n    hash: HashAlgorithmIdentifier;\n}\n\ninterface RsaKeyAlgorithm extends KeyAlgorithm {\n    modulusLength: number;\n    publicExponent: BigInteger;\n}\n\ninterface RsaKeyGenParams extends Algorithm {\n    modulusLength: number;\n    publicExponent: BigInteger;\n}\n\ninterface RsaOaepParams extends Algorithm {\n    label?: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer;\n}\n\ninterface RsaOtherPrimesInfo {\n    d?: string;\n    r?: string;\n    t?: string;\n}\n\ninterface RsaPssParams extends Algorithm {\n    saltLength: number;\n}\n\ninterface SVGBoundingBoxOptions {\n    clipped?: boolean;\n    fill?: boolean;\n    markers?: boolean;\n    stroke?: boolean;\n}\n\ninterface ScopedCredentialDescriptor {\n    id: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer | null;\n    transports?: Transport[];\n    type: ScopedCredentialType;\n}\n\ninterface ScopedCredentialOptions {\n    excludeList?: ScopedCredentialDescriptor[];\n    extensions?: WebAuthnExtensions;\n    rpId?: string;\n    timeoutSeconds?: number;\n}\n\ninterface ScopedCredentialParameters {\n    algorithm: string | Algorithm;\n    type: ScopedCredentialType;\n}\n\ninterface ScrollIntoViewOptions extends ScrollOptions {\n    block?: ScrollLogicalPosition;\n    inline?: ScrollLogicalPosition;\n}\n\ninterface ScrollOptions {\n    behavior?: ScrollBehavior;\n}\n\ninterface ScrollToOptions extends ScrollOptions {\n    left?: number;\n    top?: number;\n}\n\ninterface SecurityPolicyViolationEventInit extends EventInit {\n    blockedURI?: string;\n    columnNumber?: number;\n    documentURI?: string;\n    effectiveDirective?: string;\n    lineNumber?: number;\n    originalPolicy?: string;\n    referrer?: string;\n    sourceFile?: string;\n    statusCode?: number;\n    violatedDirective?: string;\n}\n\ninterface ServiceWorkerMessageEventInit extends EventInit {\n    data?: any;\n    lastEventId?: string;\n    origin?: string;\n    ports?: MessagePort[] | null;\n    source?: ServiceWorker | MessagePort | null;\n}\n\ninterface ShadowRootInit {\n    delegatesFocus?: boolean;\n    mode: ShadowRootMode;\n}\n\ninterface StereoPannerOptions extends AudioNodeOptions {\n    pan?: number;\n}\n\ninterface StorageEstimate {\n    quota?: number;\n    usage?: number;\n}\n\ninterface StorageEventInit extends EventInit {\n    key?: string | null;\n    newValue?: string | null;\n    oldValue?: string | null;\n    storageArea?: Storage | null;\n    url?: string;\n}\n\ninterface StoreExceptionsInformation extends ExceptionInformation {\n    detailURI?: string | null;\n    explanationString?: string | null;\n    siteName?: string | null;\n}\n\ninterface StoreSiteSpecificExceptionsInformation extends StoreExceptionsInformation {\n    arrayOfDomainStrings?: string[];\n}\n\ninterface TextDecodeOptions {\n    stream?: boolean;\n}\n\ninterface TextDecoderOptions {\n    fatal?: boolean;\n    ignoreBOM?: boolean;\n}\n\ninterface TextEncoderEncodeIntoResult {\n    read?: number;\n    written?: number;\n}\n\ninterface TouchEventInit extends EventModifierInit {\n    changedTouches?: Touch[];\n    targetTouches?: Touch[];\n    touches?: Touch[];\n}\n\ninterface TouchInit {\n    altitudeAngle?: number;\n    azimuthAngle?: number;\n    clientX?: number;\n    clientY?: number;\n    force?: number;\n    identifier: number;\n    pageX?: number;\n    pageY?: number;\n    radiusX?: number;\n    radiusY?: number;\n    rotationAngle?: number;\n    screenX?: number;\n    screenY?: number;\n    target: EventTarget;\n    touchType?: TouchType;\n}\n\ninterface TrackEventInit extends EventInit {\n    track?: VideoTrack | AudioTrack | TextTrack | null;\n}\n\ninterface Transformer<I = any, O = any> {\n    flush?: TransformStreamDefaultControllerCallback<O>;\n    readableType?: undefined;\n    start?: TransformStreamDefaultControllerCallback<O>;\n    transform?: TransformStreamDefaultControllerTransformCallback<I, O>;\n    writableType?: undefined;\n}\n\ninterface TransitionEventInit extends EventInit {\n    elapsedTime?: number;\n    propertyName?: string;\n    pseudoElement?: string;\n}\n\ninterface UIEventInit extends EventInit {\n    detail?: number;\n    view?: Window | null;\n}\n\ninterface ULongRange {\n    max?: number;\n    min?: number;\n}\n\ninterface UnderlyingByteSource {\n    autoAllocateChunkSize?: number;\n    cancel?: ReadableStreamErrorCallback;\n    pull?: ReadableByteStreamControllerCallback;\n    start?: ReadableByteStreamControllerCallback;\n    type: "bytes";\n}\n\ninterface UnderlyingSink<W = any> {\n    abort?: WritableStreamErrorCallback;\n    close?: WritableStreamDefaultControllerCloseCallback;\n    start?: WritableStreamDefaultControllerStartCallback;\n    type?: undefined;\n    write?: WritableStreamDefaultControllerWriteCallback<W>;\n}\n\ninterface UnderlyingSource<R = any> {\n    cancel?: ReadableStreamErrorCallback;\n    pull?: ReadableStreamDefaultControllerCallback<R>;\n    start?: ReadableStreamDefaultControllerCallback<R>;\n    type?: undefined;\n}\n\ninterface VRDisplayEventInit extends EventInit {\n    display: VRDisplay;\n    reason?: VRDisplayEventReason;\n}\n\ninterface VRLayer {\n    leftBounds?: number[] | Float32Array | null;\n    rightBounds?: number[] | Float32Array | null;\n    source?: HTMLCanvasElement | null;\n}\n\ninterface VRStageParameters {\n    sittingToStandingTransform?: Float32Array;\n    sizeX?: number;\n    sizeY?: number;\n}\n\ninterface WaveShaperOptions extends AudioNodeOptions {\n    curve?: number[] | Float32Array;\n    oversample?: OverSampleType;\n}\n\ninterface WebAuthnExtensions {\n}\n\ninterface WebGLContextAttributes {\n    alpha?: GLboolean;\n    antialias?: GLboolean;\n    depth?: GLboolean;\n    failIfMajorPerformanceCaveat?: boolean;\n    powerPreference?: WebGLPowerPreference;\n    premultipliedAlpha?: GLboolean;\n    preserveDrawingBuffer?: GLboolean;\n    stencil?: GLboolean;\n}\n\ninterface WebGLContextEventInit extends EventInit {\n    statusMessage?: string;\n}\n\ninterface WheelEventInit extends MouseEventInit {\n    deltaMode?: number;\n    deltaX?: number;\n    deltaY?: number;\n    deltaZ?: number;\n}\n\ninterface WorkerOptions {\n    credentials?: RequestCredentials;\n    name?: string;\n    type?: WorkerType;\n}\n\ninterface WorkletOptions {\n    credentials?: RequestCredentials;\n}\n\ninterface EventListener {\n    (evt: Event): void;\n}\n\ntype XPathNSResolver = ((prefix: string | null) => string | null) | { lookupNamespaceURI(prefix: string | null): string | null; };\n\n/** The ANGLE_instanced_arrays extension is part of the WebGL API and allows to draw the same object, or groups of similar objects multiple times, if they share the same vertex data, primitive count and type. */\ninterface ANGLE_instanced_arrays {\n    drawArraysInstancedANGLE(mode: GLenum, first: GLint, count: GLsizei, primcount: GLsizei): void;\n    drawElementsInstancedANGLE(mode: GLenum, count: GLsizei, type: GLenum, offset: GLintptr, primcount: GLsizei): void;\n    vertexAttribDivisorANGLE(index: GLuint, divisor: GLuint): void;\n    readonly VERTEX_ATTRIB_ARRAY_DIVISOR_ANGLE: GLenum;\n}\n\n/** A controller object that allows you to abort one or more DOM requests as and when desired. */\ninterface AbortController {\n    /**\n     * Returns the AbortSignal object associated with this object.\n     */\n    readonly signal: AbortSignal;\n    /**\n     * Invoking this method will set this object\'s AbortSignal\'s aborted flag and\n     * signal to any observers that the associated activity is to be aborted.\n     */\n    abort(): void;\n}\n\ndeclare var AbortController: {\n    prototype: AbortController;\n    new(): AbortController;\n};\n\ninterface AbortSignalEventMap {\n    "abort": Event;\n}\n\n/** A signal object that allows you to communicate with a DOM request (such as a Fetch) and abort it if required via an AbortController object. */\ninterface AbortSignal extends EventTarget {\n    /**\n     * Returns true if this AbortSignal\'s AbortController has signaled to abort, and false\n     * otherwise.\n     */\n    readonly aborted: boolean;\n    onabort: ((this: AbortSignal, ev: Event) => any) | null;\n    addEventListener<K extends keyof AbortSignalEventMap>(type: K, listener: (this: AbortSignal, ev: AbortSignalEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof AbortSignalEventMap>(type: K, listener: (this: AbortSignal, ev: AbortSignalEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var AbortSignal: {\n    prototype: AbortSignal;\n    new(): AbortSignal;\n};\n\ninterface AbstractRange {\n    readonly collapsed: boolean;\n    readonly endContainer: Node;\n    readonly endOffset: number;\n    readonly startContainer: Node;\n    readonly startOffset: number;\n}\n\ndeclare var AbstractRange: {\n    prototype: AbstractRange;\n    new(): AbstractRange;\n};\n\ninterface AbstractWorkerEventMap {\n    "error": ErrorEvent;\n}\n\ninterface AbstractWorker {\n    onerror: ((this: AbstractWorker, ev: ErrorEvent) => any) | null;\n    addEventListener<K extends keyof AbstractWorkerEventMap>(type: K, listener: (this: AbstractWorker, ev: AbstractWorkerEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof AbstractWorkerEventMap>(type: K, listener: (this: AbstractWorker, ev: AbstractWorkerEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ninterface AesCfbParams extends Algorithm {\n    iv: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer;\n}\n\ninterface AesCmacParams extends Algorithm {\n    length: number;\n}\n\n/** A node able to provide real-time frequency and time-domain analysis information. It is an AudioNode that passes the audio stream unchanged from the input to the output, but allows you to take the generated data, process it, and create audio visualizations. */\ninterface AnalyserNode extends AudioNode {\n    fftSize: number;\n    readonly frequencyBinCount: number;\n    maxDecibels: number;\n    minDecibels: number;\n    smoothingTimeConstant: number;\n    getByteFrequencyData(array: Uint8Array): void;\n    getByteTimeDomainData(array: Uint8Array): void;\n    getFloatFrequencyData(array: Float32Array): void;\n    getFloatTimeDomainData(array: Float32Array): void;\n}\n\ndeclare var AnalyserNode: {\n    prototype: AnalyserNode;\n    new(context: BaseAudioContext, options?: AnalyserOptions): AnalyserNode;\n};\n\ninterface Animatable {\n    animate(keyframes: Keyframe[] | PropertyIndexedKeyframes | null, options?: number | KeyframeAnimationOptions): Animation;\n    getAnimations(): Animation[];\n}\n\ninterface AnimationEventMap {\n    "cancel": AnimationPlaybackEvent;\n    "finish": AnimationPlaybackEvent;\n}\n\ninterface Animation extends EventTarget {\n    currentTime: number | null;\n    effect: AnimationEffect | null;\n    readonly finished: Promise<Animation>;\n    id: string;\n    oncancel: ((this: Animation, ev: AnimationPlaybackEvent) => any) | null;\n    onfinish: ((this: Animation, ev: AnimationPlaybackEvent) => any) | null;\n    readonly pending: boolean;\n    readonly playState: AnimationPlayState;\n    playbackRate: number;\n    readonly ready: Promise<Animation>;\n    startTime: number | null;\n    timeline: AnimationTimeline | null;\n    cancel(): void;\n    finish(): void;\n    pause(): void;\n    play(): void;\n    reverse(): void;\n    updatePlaybackRate(playbackRate: number): void;\n    addEventListener<K extends keyof AnimationEventMap>(type: K, listener: (this: Animation, ev: AnimationEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof AnimationEventMap>(type: K, listener: (this: Animation, ev: AnimationEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var Animation: {\n    prototype: Animation;\n    new(effect?: AnimationEffect | null, timeline?: AnimationTimeline | null): Animation;\n};\n\ninterface AnimationEffect {\n    getComputedTiming(): ComputedEffectTiming;\n    getTiming(): EffectTiming;\n    updateTiming(timing?: OptionalEffectTiming): void;\n}\n\ndeclare var AnimationEffect: {\n    prototype: AnimationEffect;\n    new(): AnimationEffect;\n};\n\n/** Events providing information related to animations. */\ninterface AnimationEvent extends Event {\n    readonly animationName: string;\n    readonly elapsedTime: number;\n    readonly pseudoElement: string;\n}\n\ndeclare var AnimationEvent: {\n    prototype: AnimationEvent;\n    new(type: string, animationEventInitDict?: AnimationEventInit): AnimationEvent;\n};\n\ninterface AnimationPlaybackEvent extends Event {\n    readonly currentTime: number | null;\n    readonly timelineTime: number | null;\n}\n\ndeclare var AnimationPlaybackEvent: {\n    prototype: AnimationPlaybackEvent;\n    new(type: string, eventInitDict?: AnimationPlaybackEventInit): AnimationPlaybackEvent;\n};\n\ninterface AnimationTimeline {\n    readonly currentTime: number | null;\n}\n\ndeclare var AnimationTimeline: {\n    prototype: AnimationTimeline;\n    new(): AnimationTimeline;\n};\n\ninterface ApplicationCacheEventMap {\n    "cached": Event;\n    "checking": Event;\n    "downloading": Event;\n    "error": Event;\n    "noupdate": Event;\n    "obsolete": Event;\n    "progress": ProgressEvent;\n    "updateready": Event;\n}\n\ninterface ApplicationCache extends EventTarget {\n    /** @deprecated */\n    oncached: ((this: ApplicationCache, ev: Event) => any) | null;\n    /** @deprecated */\n    onchecking: ((this: ApplicationCache, ev: Event) => any) | null;\n    /** @deprecated */\n    ondownloading: ((this: ApplicationCache, ev: Event) => any) | null;\n    /** @deprecated */\n    onerror: ((this: ApplicationCache, ev: Event) => any) | null;\n    /** @deprecated */\n    onnoupdate: ((this: ApplicationCache, ev: Event) => any) | null;\n    /** @deprecated */\n    onobsolete: ((this: ApplicationCache, ev: Event) => any) | null;\n    /** @deprecated */\n    onprogress: ((this: ApplicationCache, ev: ProgressEvent) => any) | null;\n    /** @deprecated */\n    onupdateready: ((this: ApplicationCache, ev: Event) => any) | null;\n    /** @deprecated */\n    readonly status: number;\n    /** @deprecated */\n    abort(): void;\n    /** @deprecated */\n    swapCache(): void;\n    /** @deprecated */\n    update(): void;\n    readonly CHECKING: number;\n    readonly DOWNLOADING: number;\n    readonly IDLE: number;\n    readonly OBSOLETE: number;\n    readonly UNCACHED: number;\n    readonly UPDATEREADY: number;\n    addEventListener<K extends keyof ApplicationCacheEventMap>(type: K, listener: (this: ApplicationCache, ev: ApplicationCacheEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof ApplicationCacheEventMap>(type: K, listener: (this: ApplicationCache, ev: ApplicationCacheEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var ApplicationCache: {\n    prototype: ApplicationCache;\n    new(): ApplicationCache;\n    readonly CHECKING: number;\n    readonly DOWNLOADING: number;\n    readonly IDLE: number;\n    readonly OBSOLETE: number;\n    readonly UNCACHED: number;\n    readonly UPDATEREADY: number;\n};\n\n/** A DOM element\'s attribute as an object. In most DOM methods, you will probably directly retrieve the attribute as a string (e.g., Element.getAttribute(), but certain functions (e.g., Element.getAttributeNode()) or means of iterating give Attr types. */\ninterface Attr extends Node {\n    readonly localName: string;\n    readonly name: string;\n    readonly namespaceURI: string | null;\n    readonly ownerElement: Element | null;\n    readonly prefix: string | null;\n    readonly specified: boolean;\n    value: string;\n}\n\ndeclare var Attr: {\n    prototype: Attr;\n    new(): Attr;\n};\n\n/** A short audio asset residing in memory, created from an audio file using the AudioContext.decodeAudioData() method, or from raw data using AudioContext.createBuffer(). Once put into an AudioBuffer, the audio can then be played by being passed into an AudioBufferSourceNode. */\ninterface AudioBuffer {\n    readonly duration: number;\n    readonly length: number;\n    readonly numberOfChannels: number;\n    readonly sampleRate: number;\n    copyFromChannel(destination: Float32Array, channelNumber: number, startInChannel?: number): void;\n    copyToChannel(source: Float32Array, channelNumber: number, startInChannel?: number): void;\n    getChannelData(channel: number): Float32Array;\n}\n\ndeclare var AudioBuffer: {\n    prototype: AudioBuffer;\n    new(options: AudioBufferOptions): AudioBuffer;\n};\n\n/** An AudioScheduledSourceNode which represents an audio source consisting of in-memory audio data, stored in an AudioBuffer. It\'s especially useful for playing back audio which has particularly stringent timing accuracy requirements, such as for sounds that must match a specific rhythm and can be kept in memory rather than being played from disk or the network. */\ninterface AudioBufferSourceNode extends AudioScheduledSourceNode {\n    buffer: AudioBuffer | null;\n    readonly detune: AudioParam;\n    loop: boolean;\n    loopEnd: number;\n    loopStart: number;\n    readonly playbackRate: AudioParam;\n    start(when?: number, offset?: number, duration?: number): void;\n    addEventListener<K extends keyof AudioScheduledSourceNodeEventMap>(type: K, listener: (this: AudioBufferSourceNode, ev: AudioScheduledSourceNodeEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof AudioScheduledSourceNodeEventMap>(type: K, listener: (this: AudioBufferSourceNode, ev: AudioScheduledSourceNodeEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var AudioBufferSourceNode: {\n    prototype: AudioBufferSourceNode;\n    new(context: BaseAudioContext, options?: AudioBufferSourceOptions): AudioBufferSourceNode;\n};\n\n/** An audio-processing graph built from audio modules linked together, each represented by an AudioNode. */\ninterface AudioContext extends BaseAudioContext {\n    readonly baseLatency: number;\n    readonly outputLatency: number;\n    close(): Promise<void>;\n    createMediaElementSource(mediaElement: HTMLMediaElement): MediaElementAudioSourceNode;\n    createMediaStreamDestination(): MediaStreamAudioDestinationNode;\n    createMediaStreamSource(mediaStream: MediaStream): MediaStreamAudioSourceNode;\n    createMediaStreamTrackSource(mediaStreamTrack: MediaStreamTrack): MediaStreamTrackAudioSourceNode;\n    getOutputTimestamp(): AudioTimestamp;\n    resume(): Promise<void>;\n    suspend(): Promise<void>;\n    addEventListener<K extends keyof BaseAudioContextEventMap>(type: K, listener: (this: AudioContext, ev: BaseAudioContextEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof BaseAudioContextEventMap>(type: K, listener: (this: AudioContext, ev: BaseAudioContextEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var AudioContext: {\n    prototype: AudioContext;\n    new(contextOptions?: AudioContextOptions): AudioContext;\n};\n\n/** AudioDestinationNode has no output (as it is the output, no more AudioNode can be linked after it in the audio graph) and one input. The number of channels in the input must be between 0 and the maxChannelCount value or an exception is raised. */\ninterface AudioDestinationNode extends AudioNode {\n    readonly maxChannelCount: number;\n}\n\ndeclare var AudioDestinationNode: {\n    prototype: AudioDestinationNode;\n    new(): AudioDestinationNode;\n};\n\n/** The position and orientation of the unique person listening to the audio scene, and is used in audio spatialization. All PannerNodes spatialize in relation to the AudioListener stored in the BaseAudioContext.listener attribute. */\ninterface AudioListener {\n    readonly forwardX: AudioParam;\n    readonly forwardY: AudioParam;\n    readonly forwardZ: AudioParam;\n    readonly positionX: AudioParam;\n    readonly positionY: AudioParam;\n    readonly positionZ: AudioParam;\n    readonly upX: AudioParam;\n    readonly upY: AudioParam;\n    readonly upZ: AudioParam;\n    /** @deprecated */\n    setOrientation(x: number, y: number, z: number, xUp: number, yUp: number, zUp: number): void;\n    /** @deprecated */\n    setPosition(x: number, y: number, z: number): void;\n}\n\ndeclare var AudioListener: {\n    prototype: AudioListener;\n    new(): AudioListener;\n};\n\n/** A generic interface for representing an audio processing module. Examples include: */\ninterface AudioNode extends EventTarget {\n    channelCount: number;\n    channelCountMode: ChannelCountMode;\n    channelInterpretation: ChannelInterpretation;\n    readonly context: BaseAudioContext;\n    readonly numberOfInputs: number;\n    readonly numberOfOutputs: number;\n    connect(destinationNode: AudioNode, output?: number, input?: number): AudioNode;\n    connect(destinationParam: AudioParam, output?: number): void;\n    disconnect(): void;\n    disconnect(output: number): void;\n    disconnect(destinationNode: AudioNode): void;\n    disconnect(destinationNode: AudioNode, output: number): void;\n    disconnect(destinationNode: AudioNode, output: number, input: number): void;\n    disconnect(destinationParam: AudioParam): void;\n    disconnect(destinationParam: AudioParam, output: number): void;\n}\n\ndeclare var AudioNode: {\n    prototype: AudioNode;\n    new(): AudioNode;\n};\n\n/** The Web Audio API\'s AudioParam interface represents an audio-related parameter, usually a parameter of an AudioNode (such as GainNode.gain). */\ninterface AudioParam {\n    automationRate: AutomationRate;\n    readonly defaultValue: number;\n    readonly maxValue: number;\n    readonly minValue: number;\n    value: number;\n    cancelAndHoldAtTime(cancelTime: number): AudioParam;\n    cancelScheduledValues(cancelTime: number): AudioParam;\n    exponentialRampToValueAtTime(value: number, endTime: number): AudioParam;\n    linearRampToValueAtTime(value: number, endTime: number): AudioParam;\n    setTargetAtTime(target: number, startTime: number, timeConstant: number): AudioParam;\n    setValueAtTime(value: number, startTime: number): AudioParam;\n    setValueCurveAtTime(values: number[] | Float32Array, startTime: number, duration: number): AudioParam;\n}\n\ndeclare var AudioParam: {\n    prototype: AudioParam;\n    new(): AudioParam;\n};\n\ninterface AudioParamMap {\n    forEach(callbackfn: (value: AudioParam, key: string, parent: AudioParamMap) => void, thisArg?: any): void;\n}\n\ndeclare var AudioParamMap: {\n    prototype: AudioParamMap;\n    new(): AudioParamMap;\n};\n\n/** The Web Audio API events that occur when a ScriptProcessorNode input buffer is ready to be processed. */\ninterface AudioProcessingEvent extends Event {\n    readonly inputBuffer: AudioBuffer;\n    readonly outputBuffer: AudioBuffer;\n    readonly playbackTime: number;\n}\n\ndeclare var AudioProcessingEvent: {\n    prototype: AudioProcessingEvent;\n    new(type: string, eventInitDict: AudioProcessingEventInit): AudioProcessingEvent;\n};\n\ninterface AudioScheduledSourceNodeEventMap {\n    "ended": Event;\n}\n\ninterface AudioScheduledSourceNode extends AudioNode {\n    onended: ((this: AudioScheduledSourceNode, ev: Event) => any) | null;\n    start(when?: number): void;\n    stop(when?: number): void;\n    addEventListener<K extends keyof AudioScheduledSourceNodeEventMap>(type: K, listener: (this: AudioScheduledSourceNode, ev: AudioScheduledSourceNodeEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof AudioScheduledSourceNodeEventMap>(type: K, listener: (this: AudioScheduledSourceNode, ev: AudioScheduledSourceNodeEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var AudioScheduledSourceNode: {\n    prototype: AudioScheduledSourceNode;\n    new(): AudioScheduledSourceNode;\n};\n\n/** A single audio track from one of the HTML media elements, <audio> or <video>.  */\ninterface AudioTrack {\n    enabled: boolean;\n    readonly id: string;\n    kind: string;\n    readonly label: string;\n    language: string;\n    readonly sourceBuffer: SourceBuffer | null;\n}\n\ndeclare var AudioTrack: {\n    prototype: AudioTrack;\n    new(): AudioTrack;\n};\n\ninterface AudioTrackListEventMap {\n    "addtrack": TrackEvent;\n    "change": Event;\n    "removetrack": TrackEvent;\n}\n\n/** Used to represent a list of the audio tracks contained within a given HTML media element, with each track represented by a separate AudioTrack object in the list. */\ninterface AudioTrackList extends EventTarget {\n    readonly length: number;\n    onaddtrack: ((this: AudioTrackList, ev: TrackEvent) => any) | null;\n    onchange: ((this: AudioTrackList, ev: Event) => any) | null;\n    onremovetrack: ((this: AudioTrackList, ev: TrackEvent) => any) | null;\n    getTrackById(id: string): AudioTrack | null;\n    item(index: number): AudioTrack;\n    addEventListener<K extends keyof AudioTrackListEventMap>(type: K, listener: (this: AudioTrackList, ev: AudioTrackListEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof AudioTrackListEventMap>(type: K, listener: (this: AudioTrackList, ev: AudioTrackListEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n    [index: number]: AudioTrack;\n}\n\ndeclare var AudioTrackList: {\n    prototype: AudioTrackList;\n    new(): AudioTrackList;\n};\n\ninterface AudioWorklet extends Worklet {\n}\n\ndeclare var AudioWorklet: {\n    prototype: AudioWorklet;\n    new(): AudioWorklet;\n};\n\ninterface AudioWorkletNodeEventMap {\n    "processorerror": Event;\n}\n\ninterface AudioWorkletNode extends AudioNode {\n    onprocessorerror: ((this: AudioWorkletNode, ev: Event) => any) | null;\n    readonly parameters: AudioParamMap;\n    readonly port: MessagePort;\n    addEventListener<K extends keyof AudioWorkletNodeEventMap>(type: K, listener: (this: AudioWorkletNode, ev: AudioWorkletNodeEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof AudioWorkletNodeEventMap>(type: K, listener: (this: AudioWorkletNode, ev: AudioWorkletNodeEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var AudioWorkletNode: {\n    prototype: AudioWorkletNode;\n    new(context: BaseAudioContext, name: string, options?: AudioWorkletNodeOptions): AudioWorkletNode;\n};\n\ninterface BarProp {\n    readonly visible: boolean;\n}\n\ndeclare var BarProp: {\n    prototype: BarProp;\n    new(): BarProp;\n};\n\ninterface BaseAudioContextEventMap {\n    "statechange": Event;\n}\n\ninterface BaseAudioContext extends EventTarget {\n    readonly audioWorklet: AudioWorklet;\n    readonly currentTime: number;\n    readonly destination: AudioDestinationNode;\n    readonly listener: AudioListener;\n    onstatechange: ((this: BaseAudioContext, ev: Event) => any) | null;\n    readonly sampleRate: number;\n    readonly state: AudioContextState;\n    createAnalyser(): AnalyserNode;\n    createBiquadFilter(): BiquadFilterNode;\n    createBuffer(numberOfChannels: number, length: number, sampleRate: number): AudioBuffer;\n    createBufferSource(): AudioBufferSourceNode;\n    createChannelMerger(numberOfInputs?: number): ChannelMergerNode;\n    createChannelSplitter(numberOfOutputs?: number): ChannelSplitterNode;\n    createConstantSource(): ConstantSourceNode;\n    createConvolver(): ConvolverNode;\n    createDelay(maxDelayTime?: number): DelayNode;\n    createDynamicsCompressor(): DynamicsCompressorNode;\n    createGain(): GainNode;\n    createIIRFilter(feedforward: number[], feedback: number[]): IIRFilterNode;\n    createOscillator(): OscillatorNode;\n    createPanner(): PannerNode;\n    createPeriodicWave(real: number[] | Float32Array, imag: number[] | Float32Array, constraints?: PeriodicWaveConstraints): PeriodicWave;\n    createScriptProcessor(bufferSize?: number, numberOfInputChannels?: number, numberOfOutputChannels?: number): ScriptProcessorNode;\n    createStereoPanner(): StereoPannerNode;\n    createWaveShaper(): WaveShaperNode;\n    decodeAudioData(audioData: ArrayBuffer, successCallback?: DecodeSuccessCallback | null, errorCallback?: DecodeErrorCallback | null): Promise<AudioBuffer>;\n    addEventListener<K extends keyof BaseAudioContextEventMap>(type: K, listener: (this: BaseAudioContext, ev: BaseAudioContextEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof BaseAudioContextEventMap>(type: K, listener: (this: BaseAudioContext, ev: BaseAudioContextEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var BaseAudioContext: {\n    prototype: BaseAudioContext;\n    new(): BaseAudioContext;\n};\n\n/** The beforeunload event is fired when the window, the document and its resources are about to be unloaded. */\ninterface BeforeUnloadEvent extends Event {\n    returnValue: any;\n}\n\ndeclare var BeforeUnloadEvent: {\n    prototype: BeforeUnloadEvent;\n    new(): BeforeUnloadEvent;\n};\n\ninterface BhxBrowser {\n    readonly lastError: DOMException;\n    checkMatchesGlobExpression(pattern: string, value: string): boolean;\n    checkMatchesUriExpression(pattern: string, value: string): boolean;\n    clearLastError(): void;\n    currentWindowId(): number;\n    fireExtensionApiTelemetry(functionName: string, isSucceeded: boolean, isSupported: boolean, errorString: string): void;\n    genericFunction(functionId: number, destination: any, parameters?: string, callbackId?: number): void;\n    genericSynchronousFunction(functionId: number, parameters?: string): string;\n    getExtensionId(): string;\n    getThisAddress(): any;\n    registerGenericFunctionCallbackHandler(callbackHandler: Function): void;\n    registerGenericListenerHandler(eventHandler: Function): void;\n    setLastError(parameters: string): void;\n    webPlatformGenericFunction(destination: any, parameters?: string, callbackId?: number): void;\n}\n\ndeclare var BhxBrowser: {\n    prototype: BhxBrowser;\n    new(): BhxBrowser;\n};\n\n/** A simple low-order filter, and is created using the AudioContext.createBiquadFilter() method. It is an AudioNode that can represent different kinds of filters, tone control devices, and graphic equalizers. */\ninterface BiquadFilterNode extends AudioNode {\n    readonly Q: AudioParam;\n    readonly detune: AudioParam;\n    readonly frequency: AudioParam;\n    readonly gain: AudioParam;\n    type: BiquadFilterType;\n    getFrequencyResponse(frequencyHz: Float32Array, magResponse: Float32Array, phaseResponse: Float32Array): void;\n}\n\ndeclare var BiquadFilterNode: {\n    prototype: BiquadFilterNode;\n    new(context: BaseAudioContext, options?: BiquadFilterOptions): BiquadFilterNode;\n};\n\n/** A file-like object of immutable, raw data. Blobs represent data that isn\'t necessarily in a JavaScript-native format. The File interface is based on Blob, inheriting blob functionality and expanding it to support files on the user\'s system. */\ninterface Blob {\n    readonly size: number;\n    readonly type: string;\n    slice(start?: number, end?: number, contentType?: string): Blob;\n}\n\ndeclare var Blob: {\n    prototype: Blob;\n    new(blobParts?: BlobPart[], options?: BlobPropertyBag): Blob;\n};\n\ninterface Body {\n    readonly body: ReadableStream<Uint8Array> | null;\n    readonly bodyUsed: boolean;\n    arrayBuffer(): Promise<ArrayBuffer>;\n    blob(): Promise<Blob>;\n    formData(): Promise<FormData>;\n    json(): Promise<any>;\n    text(): Promise<string>;\n}\n\ninterface BroadcastChannelEventMap {\n    "message": MessageEvent;\n    "messageerror": MessageEvent;\n}\n\ninterface BroadcastChannel extends EventTarget {\n    /**\n     * Returns the channel name (as passed to the constructor).\n     */\n    readonly name: string;\n    onmessage: ((this: BroadcastChannel, ev: MessageEvent) => any) | null;\n    onmessageerror: ((this: BroadcastChannel, ev: MessageEvent) => any) | null;\n    /**\n     * Closes the BroadcastChannel object, opening it up to garbage collection.\n     */\n    close(): void;\n    /**\n     * Sends the given message to other BroadcastChannel objects set up for this channel. Messages can be structured objects, e.g. nested objects and arrays.\n     */\n    postMessage(message: any): void;\n    addEventListener<K extends keyof BroadcastChannelEventMap>(type: K, listener: (this: BroadcastChannel, ev: BroadcastChannelEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof BroadcastChannelEventMap>(type: K, listener: (this: BroadcastChannel, ev: BroadcastChannelEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var BroadcastChannel: {\n    prototype: BroadcastChannel;\n    new(name: string): BroadcastChannel;\n};\n\n/** An interface of the Streams API provides a built-in byte length queuing strategy that can be used when constructing streams. */\ninterface ByteLengthQueuingStrategy extends QueuingStrategy<ArrayBufferView> {\n    highWaterMark: number;\n    size(chunk: ArrayBufferView): number;\n}\n\ndeclare var ByteLengthQueuingStrategy: {\n    prototype: ByteLengthQueuingStrategy;\n    new(options: { highWaterMark: number }): ByteLengthQueuingStrategy;\n};\n\n/** A CDATA section that can be used within XML to include extended portions of unescaped text. The symbols < and & don’t need escaping as they normally do when inside a CDATA section. */\ninterface CDATASection extends Text {\n}\n\ndeclare var CDATASection: {\n    prototype: CDATASection;\n    new(): CDATASection;\n};\n\n/** Holds useful CSS-related methods. No object with this interface are implemented: it contains only static methods and therefore is a utilitarian interface. */\ninterface CSS {\n    escape(value: string): string;\n    supports(property: string, value?: string): boolean;\n}\ndeclare var CSS: CSS;\n\n/** A single condition CSS at-rule, which consists of a condition and a statement block. It is a child of CSSGroupingRule. */\ninterface CSSConditionRule extends CSSGroupingRule {\n    conditionText: string;\n}\n\ndeclare var CSSConditionRule: {\n    prototype: CSSConditionRule;\n    new(): CSSConditionRule;\n};\n\ninterface CSSFontFaceRule extends CSSRule {\n    readonly style: CSSStyleDeclaration;\n}\n\ndeclare var CSSFontFaceRule: {\n    prototype: CSSFontFaceRule;\n    new(): CSSFontFaceRule;\n};\n\n/** Any CSS at-rule that contains other rules nested within it. */\ninterface CSSGroupingRule extends CSSRule {\n    readonly cssRules: CSSRuleList;\n    deleteRule(index: number): void;\n    insertRule(rule: string, index: number): number;\n}\n\ndeclare var CSSGroupingRule: {\n    prototype: CSSGroupingRule;\n    new(): CSSGroupingRule;\n};\n\ninterface CSSImportRule extends CSSRule {\n    readonly href: string;\n    readonly media: MediaList;\n    readonly styleSheet: CSSStyleSheet;\n}\n\ndeclare var CSSImportRule: {\n    prototype: CSSImportRule;\n    new(): CSSImportRule;\n};\n\n/** An object representing a set of style for a given keyframe. It corresponds to the contains of a single keyframe of a @keyframes at-rule. It implements the CSSRule interface with a type value of 8 (CSSRule.KEYFRAME_RULE). */\ninterface CSSKeyframeRule extends CSSRule {\n    keyText: string;\n    readonly style: CSSStyleDeclaration;\n}\n\ndeclare var CSSKeyframeRule: {\n    prototype: CSSKeyframeRule;\n    new(): CSSKeyframeRule;\n};\n\n/** An object representing a complete set of keyframes for a CSS animation. It corresponds to the contains of a whole @keyframes at-rule. It implements the CSSRule interface with a type value of 7 (CSSRule.KEYFRAMES_RULE). */\ninterface CSSKeyframesRule extends CSSRule {\n    readonly cssRules: CSSRuleList;\n    name: string;\n    appendRule(rule: string): void;\n    deleteRule(select: string): void;\n    findRule(select: string): CSSKeyframeRule | null;\n}\n\ndeclare var CSSKeyframesRule: {\n    prototype: CSSKeyframesRule;\n    new(): CSSKeyframesRule;\n};\n\n/** A single CSS @media rule. It implements the CSSConditionRule interface, and therefore the CSSGroupingRule and the CSSRule interface with a type value of 4 (CSSRule.MEDIA_RULE). */\ninterface CSSMediaRule extends CSSConditionRule {\n    readonly media: MediaList;\n}\n\ndeclare var CSSMediaRule: {\n    prototype: CSSMediaRule;\n    new(): CSSMediaRule;\n};\n\n/** An object representing a single CSS @namespace at-rule. It implements the CSSRule interface, with a type value of 10 (CSSRule.NAMESPACE_RULE). */\ninterface CSSNamespaceRule extends CSSRule {\n    readonly namespaceURI: string;\n    readonly prefix: string;\n}\n\ndeclare var CSSNamespaceRule: {\n    prototype: CSSNamespaceRule;\n    new(): CSSNamespaceRule;\n};\n\n/** CSSPageRule is an interface representing a single CSS @page rule. It implements the CSSRule interface with a type value of 6 (CSSRule.PAGE_RULE). */\ninterface CSSPageRule extends CSSRule {\n    readonly pseudoClass: string;\n    readonly selector: string;\n    selectorText: string;\n    readonly style: CSSStyleDeclaration;\n}\n\ndeclare var CSSPageRule: {\n    prototype: CSSPageRule;\n    new(): CSSPageRule;\n};\n\n/** A single CSS rule. There are several types of rules, listed in the Type constants section below. */\ninterface CSSRule {\n    cssText: string;\n    readonly parentRule: CSSRule | null;\n    readonly parentStyleSheet: CSSStyleSheet | null;\n    readonly type: number;\n    readonly CHARSET_RULE: number;\n    readonly FONT_FACE_RULE: number;\n    readonly IMPORT_RULE: number;\n    readonly KEYFRAMES_RULE: number;\n    readonly KEYFRAME_RULE: number;\n    readonly MEDIA_RULE: number;\n    readonly NAMESPACE_RULE: number;\n    readonly PAGE_RULE: number;\n    readonly STYLE_RULE: number;\n    readonly SUPPORTS_RULE: number;\n    readonly UNKNOWN_RULE: number;\n    readonly VIEWPORT_RULE: number;\n}\n\ndeclare var CSSRule: {\n    prototype: CSSRule;\n    new(): CSSRule;\n    readonly CHARSET_RULE: number;\n    readonly FONT_FACE_RULE: number;\n    readonly IMPORT_RULE: number;\n    readonly KEYFRAMES_RULE: number;\n    readonly KEYFRAME_RULE: number;\n    readonly MEDIA_RULE: number;\n    readonly NAMESPACE_RULE: number;\n    readonly PAGE_RULE: number;\n    readonly STYLE_RULE: number;\n    readonly SUPPORTS_RULE: number;\n    readonly UNKNOWN_RULE: number;\n    readonly VIEWPORT_RULE: number;\n};\n\n/** A CSSRuleList is an (indirect-modify only) array-like object containing an ordered collection of CSSRule objects. */\ninterface CSSRuleList {\n    readonly length: number;\n    item(index: number): CSSRule | null;\n    [index: number]: CSSRule;\n}\n\ndeclare var CSSRuleList: {\n    prototype: CSSRuleList;\n    new(): CSSRuleList;\n};\n\n/** An object that is a CSS declaration block, and exposes style information and various style-related methods and properties. */\ninterface CSSStyleDeclaration {\n    alignContent: string | null;\n    alignItems: string | null;\n    alignSelf: string | null;\n    alignmentBaseline: string | null;\n    animation: string;\n    animationDelay: string;\n    animationDirection: string;\n    animationDuration: string;\n    animationFillMode: string;\n    animationIterationCount: string;\n    animationName: string;\n    animationPlayState: string;\n    animationTimingFunction: string;\n    backfaceVisibility: string | null;\n    background: string | null;\n    backgroundAttachment: string | null;\n    backgroundClip: string | null;\n    backgroundColor: string | null;\n    backgroundImage: string | null;\n    backgroundOrigin: string | null;\n    backgroundPosition: string | null;\n    backgroundPositionX: string | null;\n    backgroundPositionY: string | null;\n    backgroundRepeat: string | null;\n    backgroundSize: string | null;\n    baselineShift: string | null;\n    border: string | null;\n    borderBottom: string | null;\n    borderBottomColor: string | null;\n    borderBottomLeftRadius: string | null;\n    borderBottomRightRadius: string | null;\n    borderBottomStyle: string | null;\n    borderBottomWidth: string | null;\n    borderCollapse: string | null;\n    borderColor: string | null;\n    borderImage: string | null;\n    borderImageOutset: string | null;\n    borderImageRepeat: string | null;\n    borderImageSlice: string | null;\n    borderImageSource: string | null;\n    borderImageWidth: string | null;\n    borderLeft: string | null;\n    borderLeftColor: string | null;\n    borderLeftStyle: string | null;\n    borderLeftWidth: string | null;\n    borderRadius: string | null;\n    borderRight: string | null;\n    borderRightColor: string | null;\n    borderRightStyle: string | null;\n    borderRightWidth: string | null;\n    borderSpacing: string | null;\n    borderStyle: string | null;\n    borderTop: string | null;\n    borderTopColor: string | null;\n    borderTopLeftRadius: string | null;\n    borderTopRightRadius: string | null;\n    borderTopStyle: string | null;\n    borderTopWidth: string | null;\n    borderWidth: string | null;\n    bottom: string | null;\n    boxShadow: string | null;\n    boxSizing: string;\n    breakAfter: string | null;\n    breakBefore: string | null;\n    breakInside: string | null;\n    captionSide: string | null;\n    caretColor: string;\n    clear: string | null;\n    clip: string | null;\n    clipPath: string | null;\n    clipRule: string | null;\n    color: string | null;\n    colorInterpolationFilters: string | null;\n    columnCount: string;\n    columnFill: string;\n    columnGap: string;\n    columnRule: string;\n    columnRuleColor: string;\n    columnRuleStyle: string;\n    columnRuleWidth: string;\n    columnSpan: string;\n    columnWidth: string;\n    columns: string;\n    content: string | null;\n    counterIncrement: string | null;\n    counterReset: string | null;\n    cssFloat: string | null;\n    cssText: string;\n    cursor: string;\n    direction: string | null;\n    display: string | null;\n    dominantBaseline: string | null;\n    emptyCells: string | null;\n    enableBackground: string | null;\n    fill: string | null;\n    fillOpacity: string | null;\n    fillRule: string | null;\n    filter: string | null;\n    flex: string | null;\n    flexBasis: string | null;\n    flexDirection: string | null;\n    flexFlow: string | null;\n    flexGrow: string | null;\n    flexShrink: string | null;\n    flexWrap: string | null;\n    floodColor: string | null;\n    floodOpacity: string | null;\n    font: string | null;\n    fontFamily: string | null;\n    fontFeatureSettings: string | null;\n    fontSize: string | null;\n    fontSizeAdjust: string | null;\n    fontStretch: string | null;\n    fontStyle: string | null;\n    fontVariant: string | null;\n    fontWeight: string | null;\n    gap: string | null;\n    glyphOrientationHorizontal: string | null;\n    glyphOrientationVertical: string | null;\n    grid: string | null;\n    gridArea: string | null;\n    gridAutoColumns: string | null;\n    gridAutoFlow: string | null;\n    gridAutoRows: string | null;\n    gridColumn: string | null;\n    gridColumnEnd: string | null;\n    gridColumnGap: string | null;\n    gridColumnStart: string | null;\n    gridGap: string | null;\n    gridRow: string | null;\n    gridRowEnd: string | null;\n    gridRowGap: string | null;\n    gridRowStart: string | null;\n    gridTemplate: string | null;\n    gridTemplateAreas: string | null;\n    gridTemplateColumns: string | null;\n    gridTemplateRows: string | null;\n    height: string | null;\n    imageOrientation: string;\n    imageRendering: string;\n    imeMode: string | null;\n    justifyContent: string | null;\n    justifyItems: string | null;\n    justifySelf: string | null;\n    kerning: string | null;\n    layoutGrid: string | null;\n    layoutGridChar: string | null;\n    layoutGridLine: string | null;\n    layoutGridMode: string | null;\n    layoutGridType: string | null;\n    left: string | null;\n    readonly length: number;\n    letterSpacing: string | null;\n    lightingColor: string | null;\n    lineBreak: string | null;\n    lineHeight: string | null;\n    listStyle: string | null;\n    listStyleImage: string | null;\n    listStylePosition: string | null;\n    listStyleType: string | null;\n    margin: string | null;\n    marginBottom: string | null;\n    marginLeft: string | null;\n    marginRight: string | null;\n    marginTop: string | null;\n    marker: string | null;\n    markerEnd: string | null;\n    markerMid: string | null;\n    markerStart: string | null;\n    mask: string | null;\n    maskImage: string | null;\n    maxHeight: string | null;\n    maxWidth: string | null;\n    minHeight: string | null;\n    minWidth: string | null;\n    msContentZoomChaining: string | null;\n    msContentZoomLimit: string | null;\n    msContentZoomLimitMax: any;\n    msContentZoomLimitMin: any;\n    msContentZoomSnap: string | null;\n    msContentZoomSnapPoints: string | null;\n    msContentZoomSnapType: string | null;\n    msContentZooming: string | null;\n    msFlowFrom: string | null;\n    msFlowInto: string | null;\n    msFontFeatureSettings: string | null;\n    msGridColumn: any;\n    msGridColumnAlign: string | null;\n    msGridColumnSpan: any;\n    msGridColumns: string | null;\n    msGridRow: any;\n    msGridRowAlign: string | null;\n    msGridRowSpan: any;\n    msGridRows: string | null;\n    msHighContrastAdjust: string | null;\n    msHyphenateLimitChars: string | null;\n    msHyphenateLimitLines: any;\n    msHyphenateLimitZone: any;\n    msHyphens: string | null;\n    msImeAlign: string | null;\n    msOverflowStyle: string | null;\n    msScrollChaining: string | null;\n    msScrollLimit: string | null;\n    msScrollLimitXMax: any;\n    msScrollLimitXMin: any;\n    msScrollLimitYMax: any;\n    msScrollLimitYMin: any;\n    msScrollRails: string | null;\n    msScrollSnapPointsX: string | null;\n    msScrollSnapPointsY: string | null;\n    msScrollSnapType: string | null;\n    msScrollSnapX: string | null;\n    msScrollSnapY: string | null;\n    msScrollTranslation: string | null;\n    msTextCombineHorizontal: string | null;\n    msTextSizeAdjust: any;\n    msTouchAction: string | null;\n    msTouchSelect: string | null;\n    msUserSelect: string | null;\n    msWrapFlow: string;\n    msWrapMargin: any;\n    msWrapThrough: string;\n    objectFit: string;\n    objectPosition: string;\n    opacity: string | null;\n    order: string | null;\n    orphans: string | null;\n    outline: string;\n    outlineColor: string;\n    outlineOffset: string;\n    outlineStyle: string;\n    outlineWidth: string;\n    overflow: string | null;\n    overflowX: string | null;\n    overflowY: string | null;\n    padding: string | null;\n    paddingBottom: string | null;\n    paddingLeft: string | null;\n    paddingRight: string | null;\n    paddingTop: string | null;\n    pageBreakAfter: string | null;\n    pageBreakBefore: string | null;\n    pageBreakInside: string | null;\n    readonly parentRule: CSSRule;\n    penAction: string | null;\n    perspective: string | null;\n    perspectiveOrigin: string | null;\n    pointerEvents: string | null;\n    position: string | null;\n    quotes: string | null;\n    resize: string | null;\n    right: string | null;\n    rotate: string | null;\n    rowGap: string | null;\n    rubyAlign: string | null;\n    rubyOverhang: string | null;\n    rubyPosition: string | null;\n    scale: string | null;\n    scrollBehavior: string;\n    stopColor: string | null;\n    stopOpacity: string | null;\n    stroke: string | null;\n    strokeDasharray: string | null;\n    strokeDashoffset: string | null;\n    strokeLinecap: string | null;\n    strokeLinejoin: string | null;\n    strokeMiterlimit: string | null;\n    strokeOpacity: string | null;\n    strokeWidth: string | null;\n    tableLayout: string | null;\n    textAlign: string | null;\n    textAlignLast: string | null;\n    textAnchor: string | null;\n    textCombineUpright: string | null;\n    textDecoration: string | null;\n    textIndent: string | null;\n    textJustify: string | null;\n    textKashida: string | null;\n    textKashidaSpace: string | null;\n    textOverflow: string;\n    textShadow: string | null;\n    textTransform: string | null;\n    textUnderlinePosition: string | null;\n    top: string | null;\n    touchAction: string;\n    transform: string | null;\n    transformOrigin: string | null;\n    transformStyle: string | null;\n    transition: string;\n    transitionDelay: string;\n    transitionDuration: string;\n    transitionProperty: string;\n    transitionTimingFunction: string;\n    translate: string | null;\n    unicodeBidi: string | null;\n    userSelect: string | null;\n    verticalAlign: string | null;\n    visibility: string | null;\n    /** @deprecated */\n    webkitAlignContent: string;\n    /** @deprecated */\n    webkitAlignItems: string;\n    /** @deprecated */\n    webkitAlignSelf: string;\n    /** @deprecated */\n    webkitAnimation: string;\n    /** @deprecated */\n    webkitAnimationDelay: string;\n    /** @deprecated */\n    webkitAnimationDirection: string;\n    /** @deprecated */\n    webkitAnimationDuration: string;\n    /** @deprecated */\n    webkitAnimationFillMode: string;\n    /** @deprecated */\n    webkitAnimationIterationCount: string;\n    /** @deprecated */\n    webkitAnimationName: string;\n    /** @deprecated */\n    webkitAnimationPlayState: string;\n    /** @deprecated */\n    webkitAnimationTimingFunction: string;\n    /** @deprecated */\n    webkitAppearance: string;\n    /** @deprecated */\n    webkitBackfaceVisibility: string;\n    /** @deprecated */\n    webkitBackgroundClip: string;\n    /** @deprecated */\n    webkitBackgroundOrigin: string;\n    /** @deprecated */\n    webkitBackgroundSize: string;\n    /** @deprecated */\n    webkitBorderBottomLeftRadius: string;\n    /** @deprecated */\n    webkitBorderBottomRightRadius: string;\n    webkitBorderImage: string | null;\n    /** @deprecated */\n    webkitBorderRadius: string;\n    /** @deprecated */\n    webkitBorderTopLeftRadius: string;\n    /** @deprecated */\n    webkitBorderTopRightRadius: string;\n    /** @deprecated */\n    webkitBoxAlign: string;\n    webkitBoxDirection: string | null;\n    /** @deprecated */\n    webkitBoxFlex: string;\n    /** @deprecated */\n    webkitBoxOrdinalGroup: string;\n    webkitBoxOrient: string | null;\n    /** @deprecated */\n    webkitBoxPack: string;\n    /** @deprecated */\n    webkitBoxShadow: string;\n    /** @deprecated */\n    webkitBoxSizing: string;\n    webkitColumnBreakAfter: string | null;\n    webkitColumnBreakBefore: string | null;\n    webkitColumnBreakInside: string | null;\n    webkitColumnCount: any;\n    webkitColumnGap: any;\n    webkitColumnRule: string | null;\n    webkitColumnRuleColor: any;\n    webkitColumnRuleStyle: string | null;\n    webkitColumnRuleWidth: any;\n    webkitColumnSpan: string | null;\n    webkitColumnWidth: any;\n    webkitColumns: string | null;\n    /** @deprecated */\n    webkitFilter: string;\n    /** @deprecated */\n    webkitFlex: string;\n    /** @deprecated */\n    webkitFlexBasis: string;\n    /** @deprecated */\n    webkitFlexDirection: string;\n    /** @deprecated */\n    webkitFlexFlow: string;\n    /** @deprecated */\n    webkitFlexGrow: string;\n    /** @deprecated */\n    webkitFlexShrink: string;\n    /** @deprecated */\n    webkitFlexWrap: string;\n    /** @deprecated */\n    webkitJustifyContent: string;\n    /** @deprecated */\n    webkitMask: string;\n    /** @deprecated */\n    webkitMaskBoxImage: string;\n    /** @deprecated */\n    webkitMaskBoxImageOutset: string;\n    /** @deprecated */\n    webkitMaskBoxImageRepeat: string;\n    /** @deprecated */\n    webkitMaskBoxImageSlice: string;\n    /** @deprecated */\n    webkitMaskBoxImageSource: string;\n    /** @deprecated */\n    webkitMaskBoxImageWidth: string;\n    /** @deprecated */\n    webkitMaskClip: string;\n    /** @deprecated */\n    webkitMaskComposite: string;\n    /** @deprecated */\n    webkitMaskImage: string;\n    /** @deprecated */\n    webkitMaskOrigin: string;\n    /** @deprecated */\n    webkitMaskPosition: string;\n    /** @deprecated */\n    webkitMaskRepeat: string;\n    /** @deprecated */\n    webkitMaskSize: string;\n    /** @deprecated */\n    webkitOrder: string;\n    /** @deprecated */\n    webkitPerspective: string;\n    /** @deprecated */\n    webkitPerspectiveOrigin: string;\n    webkitTapHighlightColor: string | null;\n    /** @deprecated */\n    webkitTextFillColor: string;\n    /** @deprecated */\n    webkitTextSizeAdjust: string;\n    /** @deprecated */\n    webkitTextStroke: string;\n    /** @deprecated */\n    webkitTextStrokeColor: string;\n    /** @deprecated */\n    webkitTextStrokeWidth: string;\n    /** @deprecated */\n    webkitTransform: string;\n    /** @deprecated */\n    webkitTransformOrigin: string;\n    /** @deprecated */\n    webkitTransformStyle: string;\n    /** @deprecated */\n    webkitTransition: string;\n    /** @deprecated */\n    webkitTransitionDelay: string;\n    /** @deprecated */\n    webkitTransitionDuration: string;\n    /** @deprecated */\n    webkitTransitionProperty: string;\n    /** @deprecated */\n    webkitTransitionTimingFunction: string;\n    webkitUserModify: string | null;\n    webkitUserSelect: string | null;\n    webkitWritingMode: string | null;\n    whiteSpace: string | null;\n    widows: string | null;\n    width: string | null;\n    willChange: string;\n    wordBreak: string | null;\n    wordSpacing: string | null;\n    wordWrap: string | null;\n    writingMode: string | null;\n    zIndex: string | null;\n    zoom: string | null;\n    getPropertyPriority(propertyName: string): string;\n    getPropertyValue(propertyName: string): string;\n    item(index: number): string;\n    removeProperty(propertyName: string): string;\n    setProperty(propertyName: string, value: string | null, priority?: string | null): void;\n    [index: number]: string;\n}\n\ndeclare var CSSStyleDeclaration: {\n    prototype: CSSStyleDeclaration;\n    new(): CSSStyleDeclaration;\n};\n\n/** CSSStyleRule represents a single CSS style rule. It implements the CSSRule interface with a type value of 1 (CSSRule.STYLE_RULE). */\ninterface CSSStyleRule extends CSSRule {\n    selectorText: string;\n    readonly style: CSSStyleDeclaration;\n}\n\ndeclare var CSSStyleRule: {\n    prototype: CSSStyleRule;\n    new(): CSSStyleRule;\n};\n\n/** A single CSS style sheet. It inherits properties and methods from its parent, StyleSheet. */\ninterface CSSStyleSheet extends StyleSheet {\n    readonly cssRules: CSSRuleList;\n    /** @deprecated */\n    cssText: string;\n    /** @deprecated */\n    readonly id: string;\n    /** @deprecated */\n    readonly imports: StyleSheetList;\n    /** @deprecated */\n    readonly isAlternate: boolean;\n    /** @deprecated */\n    readonly isPrefAlternate: boolean;\n    readonly ownerRule: CSSRule | null;\n    /** @deprecated */\n    readonly owningElement: Element;\n    /** @deprecated */\n    readonly pages: any;\n    /** @deprecated */\n    readonly readOnly: boolean;\n    readonly rules: CSSRuleList;\n    /** @deprecated */\n    addImport(bstrURL: string, lIndex?: number): number;\n    /** @deprecated */\n    addPageRule(bstrSelector: string, bstrStyle: string, lIndex?: number): number;\n    addRule(bstrSelector: string, bstrStyle?: string, lIndex?: number): number;\n    deleteRule(index?: number): void;\n    insertRule(rule: string, index?: number): number;\n    /** @deprecated */\n    removeImport(lIndex: number): void;\n    removeRule(lIndex: number): void;\n}\n\ndeclare var CSSStyleSheet: {\n    prototype: CSSStyleSheet;\n    new(): CSSStyleSheet;\n};\n\n/** An object representing a single CSS @supports at-rule. It implements the CSSConditionRule interface, and therefore the CSSRule and CSSGroupingRule interfaces with a type value of 12 (CSSRule.SUPPORTS_RULE). */\ninterface CSSSupportsRule extends CSSConditionRule {\n}\n\ndeclare var CSSSupportsRule: {\n    prototype: CSSSupportsRule;\n    new(): CSSSupportsRule;\n};\n\n/** Provides a storage mechanism for Request / Response object pairs that are cached, for example as part of the ServiceWorker life cycle. Note that the Cache interface is exposed to windowed scopes as well as workers. You don\'t have to use it in conjunction with service workers, even though it is defined in the service worker spec. */\ninterface Cache {\n    add(request: RequestInfo): Promise<void>;\n    addAll(requests: RequestInfo[]): Promise<void>;\n    delete(request: RequestInfo, options?: CacheQueryOptions): Promise<boolean>;\n    keys(request?: RequestInfo, options?: CacheQueryOptions): Promise<ReadonlyArray<Request>>;\n    match(request: RequestInfo, options?: CacheQueryOptions): Promise<Response | undefined>;\n    matchAll(request?: RequestInfo, options?: CacheQueryOptions): Promise<ReadonlyArray<Response>>;\n    put(request: RequestInfo, response: Response): Promise<void>;\n}\n\ndeclare var Cache: {\n    prototype: Cache;\n    new(): Cache;\n};\n\n/** The storage for Cache objects. */\ninterface CacheStorage {\n    delete(cacheName: string): Promise<boolean>;\n    has(cacheName: string): Promise<boolean>;\n    keys(): Promise<string[]>;\n    match(request: RequestInfo, options?: CacheQueryOptions): Promise<Response | undefined>;\n    open(cacheName: string): Promise<Cache>;\n}\n\ndeclare var CacheStorage: {\n    prototype: CacheStorage;\n    new(): CacheStorage;\n};\n\ninterface CanvasCompositing {\n    globalAlpha: number;\n    globalCompositeOperation: string;\n}\n\ninterface CanvasDrawImage {\n    drawImage(image: CanvasImageSource, dx: number, dy: number): void;\n    drawImage(image: CanvasImageSource, dx: number, dy: number, dw: number, dh: number): void;\n    drawImage(image: CanvasImageSource, sx: number, sy: number, sw: number, sh: number, dx: number, dy: number, dw: number, dh: number): void;\n}\n\ninterface CanvasDrawPath {\n    beginPath(): void;\n    clip(fillRule?: CanvasFillRule): void;\n    clip(path: Path2D, fillRule?: CanvasFillRule): void;\n    fill(fillRule?: CanvasFillRule): void;\n    fill(path: Path2D, fillRule?: CanvasFillRule): void;\n    isPointInPath(x: number, y: number, fillRule?: CanvasFillRule): boolean;\n    isPointInPath(path: Path2D, x: number, y: number, fillRule?: CanvasFillRule): boolean;\n    isPointInStroke(x: number, y: number): boolean;\n    isPointInStroke(path: Path2D, x: number, y: number): boolean;\n    stroke(): void;\n    stroke(path: Path2D): void;\n}\n\ninterface CanvasFillStrokeStyles {\n    fillStyle: string | CanvasGradient | CanvasPattern;\n    strokeStyle: string | CanvasGradient | CanvasPattern;\n    createLinearGradient(x0: number, y0: number, x1: number, y1: number): CanvasGradient;\n    createPattern(image: CanvasImageSource, repetition: string): CanvasPattern | null;\n    createRadialGradient(x0: number, y0: number, r0: number, x1: number, y1: number, r1: number): CanvasGradient;\n}\n\ninterface CanvasFilters {\n    filter: string;\n}\n\n/** An opaque object describing a gradient. It is returned by the methods CanvasRenderingContext2D.createLinearGradient() or CanvasRenderingContext2D.createRadialGradient(). */\ninterface CanvasGradient {\n    /**\n     * Adds a color stop with the given color to the gradient at the given offset. 0.0 is the offset\n     * at one end of the gradient, 1.0 is the offset at the other end.\n     * Throws an "IndexSizeError" DOMException if the offset\n     * is out of range. Throws a "SyntaxError" DOMException if\n     * the color cannot be parsed.\n     */\n    addColorStop(offset: number, color: string): void;\n}\n\ndeclare var CanvasGradient: {\n    prototype: CanvasGradient;\n    new(): CanvasGradient;\n};\n\ninterface CanvasImageData {\n    createImageData(sw: number, sh: number): ImageData;\n    createImageData(imagedata: ImageData): ImageData;\n    getImageData(sx: number, sy: number, sw: number, sh: number): ImageData;\n    putImageData(imagedata: ImageData, dx: number, dy: number): void;\n    putImageData(imagedata: ImageData, dx: number, dy: number, dirtyX: number, dirtyY: number, dirtyWidth: number, dirtyHeight: number): void;\n}\n\ninterface CanvasImageSmoothing {\n    imageSmoothingEnabled: boolean;\n    imageSmoothingQuality: ImageSmoothingQuality;\n}\n\ninterface CanvasPath {\n    arc(x: number, y: number, radius: number, startAngle: number, endAngle: number, anticlockwise?: boolean): void;\n    arcTo(x1: number, y1: number, x2: number, y2: number, radius: number): void;\n    bezierCurveTo(cp1x: number, cp1y: number, cp2x: number, cp2y: number, x: number, y: number): void;\n    closePath(): void;\n    ellipse(x: number, y: number, radiusX: number, radiusY: number, rotation: number, startAngle: number, endAngle: number, anticlockwise?: boolean): void;\n    lineTo(x: number, y: number): void;\n    moveTo(x: number, y: number): void;\n    quadraticCurveTo(cpx: number, cpy: number, x: number, y: number): void;\n    rect(x: number, y: number, w: number, h: number): void;\n}\n\ninterface CanvasPathDrawingStyles {\n    lineCap: CanvasLineCap;\n    lineDashOffset: number;\n    lineJoin: CanvasLineJoin;\n    lineWidth: number;\n    miterLimit: number;\n    getLineDash(): number[];\n    setLineDash(segments: number[]): void;\n}\n\n/** An opaque object describing a pattern, based on an image, a canvas, or a video, created by the CanvasRenderingContext2D.createPattern() method. */\ninterface CanvasPattern {\n    /**\n     * Sets the transformation matrix that will be used when rendering the pattern during a fill or\n     * stroke painting operation.\n     */\n    setTransform(transform?: DOMMatrix2DInit): void;\n}\n\ndeclare var CanvasPattern: {\n    prototype: CanvasPattern;\n    new(): CanvasPattern;\n};\n\ninterface CanvasRect {\n    clearRect(x: number, y: number, w: number, h: number): void;\n    fillRect(x: number, y: number, w: number, h: number): void;\n    strokeRect(x: number, y: number, w: number, h: number): void;\n}\n\n/** The CanvasRenderingContext2D interface, part of the Canvas API, provides the 2D rendering context for the drawing surface of a <canvas> element. It is used for drawing shapes, text, images, and other objects. */\ninterface CanvasRenderingContext2D extends CanvasState, CanvasTransform, CanvasCompositing, CanvasImageSmoothing, CanvasFillStrokeStyles, CanvasShadowStyles, CanvasFilters, CanvasRect, CanvasDrawPath, CanvasUserInterface, CanvasText, CanvasDrawImage, CanvasImageData, CanvasPathDrawingStyles, CanvasTextDrawingStyles, CanvasPath {\n    readonly canvas: HTMLCanvasElement;\n}\n\ndeclare var CanvasRenderingContext2D: {\n    prototype: CanvasRenderingContext2D;\n    new(): CanvasRenderingContext2D;\n};\n\ninterface CanvasShadowStyles {\n    shadowBlur: number;\n    shadowColor: string;\n    shadowOffsetX: number;\n    shadowOffsetY: number;\n}\n\ninterface CanvasState {\n    restore(): void;\n    save(): void;\n}\n\ninterface CanvasText {\n    fillText(text: string, x: number, y: number, maxWidth?: number): void;\n    measureText(text: string): TextMetrics;\n    strokeText(text: string, x: number, y: number, maxWidth?: number): void;\n}\n\ninterface CanvasTextDrawingStyles {\n    direction: CanvasDirection;\n    font: string;\n    textAlign: CanvasTextAlign;\n    textBaseline: CanvasTextBaseline;\n}\n\ninterface CanvasTransform {\n    getTransform(): DOMMatrix;\n    resetTransform(): void;\n    rotate(angle: number): void;\n    scale(x: number, y: number): void;\n    setTransform(a: number, b: number, c: number, d: number, e: number, f: number): void;\n    setTransform(transform?: DOMMatrix2DInit): void;\n    transform(a: number, b: number, c: number, d: number, e: number, f: number): void;\n    translate(x: number, y: number): void;\n}\n\ninterface CanvasUserInterface {\n    drawFocusIfNeeded(element: Element): void;\n    drawFocusIfNeeded(path: Path2D, element: Element): void;\n    scrollPathIntoView(): void;\n    scrollPathIntoView(path: Path2D): void;\n}\n\ninterface CaretPosition {\n    readonly offset: number;\n    readonly offsetNode: Node;\n    getClientRect(): DOMRect | null;\n}\n\ndeclare var CaretPosition: {\n    prototype: CaretPosition;\n    new(): CaretPosition;\n};\n\n/** The ChannelMergerNode interface, often used in conjunction with its opposite, ChannelSplitterNode, reunites different mono inputs into a single output. Each input is used to fill a channel of the output. This is useful for accessing each channels separately, e.g. for performing channel mixing where gain must be separately controlled on each channel. */\ninterface ChannelMergerNode extends AudioNode {\n}\n\ndeclare var ChannelMergerNode: {\n    prototype: ChannelMergerNode;\n    new(context: BaseAudioContext, options?: ChannelMergerOptions): ChannelMergerNode;\n};\n\n/** The ChannelSplitterNode interface, often used in conjunction with its opposite, ChannelMergerNode, separates the different channels of an audio source into a set of mono outputs. This is useful for accessing each channel separately, e.g. for performing channel mixing where gain must be separately controlled on each channel. */\ninterface ChannelSplitterNode extends AudioNode {\n}\n\ndeclare var ChannelSplitterNode: {\n    prototype: ChannelSplitterNode;\n    new(context: BaseAudioContext, options?: ChannelSplitterOptions): ChannelSplitterNode;\n};\n\n/** The CharacterData abstract interface represents a Node object that contains characters. This is an abstract interface, meaning there aren\'t any object of type CharacterData: it is implemented by other interfaces, like Text, Comment, or ProcessingInstruction which aren\'t abstract. */\ninterface CharacterData extends Node, NonDocumentTypeChildNode, ChildNode {\n    data: string;\n    readonly length: number;\n    appendData(data: string): void;\n    deleteData(offset: number, count: number): void;\n    insertData(offset: number, data: string): void;\n    replaceData(offset: number, count: number, data: string): void;\n    substringData(offset: number, count: number): string;\n}\n\ndeclare var CharacterData: {\n    prototype: CharacterData;\n    new(): CharacterData;\n};\n\ninterface ChildNode extends Node {\n    /**\n     * Inserts nodes just after node, while replacing strings in nodes with equivalent Text nodes.\n     * Throws a "HierarchyRequestError" DOMException if the constraints of\n     * the node tree are violated.\n     */\n    after(...nodes: (Node | string)[]): void;\n    /**\n     * Inserts nodes just before node, while replacing strings in nodes with equivalent Text nodes.\n     * Throws a "HierarchyRequestError" DOMException if the constraints of\n     * the node tree are violated.\n     */\n    before(...nodes: (Node | string)[]): void;\n    /**\n     * Removes node.\n     */\n    remove(): void;\n    /**\n     * Replaces node with nodes, while replacing strings in nodes with equivalent Text nodes.\n     * Throws a "HierarchyRequestError" DOMException if the constraints of\n     * the node tree are violated.\n     */\n    replaceWith(...nodes: (Node | string)[]): void;\n}\n\ninterface ClientRect {\n    bottom: number;\n    readonly height: number;\n    left: number;\n    right: number;\n    top: number;\n    readonly width: number;\n}\n\ndeclare var ClientRect: {\n    prototype: ClientRect;\n    new(): ClientRect;\n};\n\ninterface ClientRectList {\n    readonly length: number;\n    item(index: number): ClientRect;\n    [index: number]: ClientRect;\n}\n\ndeclare var ClientRectList: {\n    prototype: ClientRectList;\n    new(): ClientRectList;\n};\n\ninterface Clipboard extends EventTarget {\n    readText(): Promise<string>;\n    writeText(data: string): Promise<void>;\n}\n\ndeclare var Clipboard: {\n    prototype: Clipboard;\n    new(): Clipboard;\n};\n\n/** Events providing information related to modification of the clipboard, that is cut, copy, and paste events. */\ninterface ClipboardEvent extends Event {\n    readonly clipboardData: DataTransfer | null;\n}\n\ndeclare var ClipboardEvent: {\n    prototype: ClipboardEvent;\n    new(type: string, eventInitDict?: ClipboardEventInit): ClipboardEvent;\n};\n\n/** A CloseEvent is sent to clients using WebSockets when the connection is closed. This is delivered to the listener indicated by the WebSocket object\'s onclose attribute. */\ninterface CloseEvent extends Event {\n    readonly code: number;\n    readonly reason: string;\n    readonly wasClean: boolean;\n    /** @deprecated */\n    initCloseEvent(typeArg: string, canBubbleArg: boolean, cancelableArg: boolean, wasCleanArg: boolean, codeArg: number, reasonArg: string): void;\n}\n\ndeclare var CloseEvent: {\n    prototype: CloseEvent;\n    new(type: string, eventInitDict?: CloseEventInit): CloseEvent;\n};\n\n/** Textual notations within markup; although it is generally not visually shown, such comments are available to be read in the source view. */\ninterface Comment extends CharacterData {\n}\n\ndeclare var Comment: {\n    prototype: Comment;\n    new(data?: string): Comment;\n};\n\n/** The DOM CompositionEvent represents events that occur due to the user indirectly entering text. */\ninterface CompositionEvent extends UIEvent {\n    readonly data: string;\n    readonly locale: string;\n    initCompositionEvent(typeArg: string, canBubbleArg: boolean, cancelableArg: boolean, viewArg: Window, dataArg: string, locale: string): void;\n}\n\ndeclare var CompositionEvent: {\n    prototype: CompositionEvent;\n    new(typeArg: string, eventInitDict?: CompositionEventInit): CompositionEvent;\n};\n\ninterface ConcatParams extends Algorithm {\n    algorithmId: Uint8Array;\n    hash?: string | Algorithm;\n    partyUInfo: Uint8Array;\n    partyVInfo: Uint8Array;\n    privateInfo?: Uint8Array;\n    publicInfo?: Uint8Array;\n}\n\n/** Provides access to the browser\'s debugging console (e.g. the Web Console in Firefox). The specifics of how it works varies from browser to browser, but there is a de facto set of features that are typically provided. */\ninterface Console {\n    memory: any;\n    assert(condition?: boolean, message?: string, ...data: any[]): void;\n    clear(): void;\n    count(label?: string): void;\n    debug(message?: any, ...optionalParams: any[]): void;\n    dir(value?: any, ...optionalParams: any[]): void;\n    dirxml(value: any): void;\n    error(message?: any, ...optionalParams: any[]): void;\n    exception(message?: string, ...optionalParams: any[]): void;\n    group(groupTitle?: string, ...optionalParams: any[]): void;\n    groupCollapsed(groupTitle?: string, ...optionalParams: any[]): void;\n    groupEnd(): void;\n    info(message?: any, ...optionalParams: any[]): void;\n    log(message?: any, ...optionalParams: any[]): void;\n    markTimeline(label?: string): void;\n    profile(reportName?: string): void;\n    profileEnd(reportName?: string): void;\n    table(...tabularData: any[]): void;\n    time(label?: string): void;\n    timeEnd(label?: string): void;\n    timeStamp(label?: string): void;\n    timeline(label?: string): void;\n    timelineEnd(label?: string): void;\n    trace(message?: any, ...optionalParams: any[]): void;\n    warn(message?: any, ...optionalParams: any[]): void;\n}\n\ndeclare var Console: {\n    prototype: Console;\n    new(): Console;\n};\n\ninterface ConstantSourceNode extends AudioScheduledSourceNode {\n    readonly offset: AudioParam;\n    addEventListener<K extends keyof AudioScheduledSourceNodeEventMap>(type: K, listener: (this: ConstantSourceNode, ev: AudioScheduledSourceNodeEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof AudioScheduledSourceNodeEventMap>(type: K, listener: (this: ConstantSourceNode, ev: AudioScheduledSourceNodeEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var ConstantSourceNode: {\n    prototype: ConstantSourceNode;\n    new(context: BaseAudioContext, options?: ConstantSourceOptions): ConstantSourceNode;\n};\n\n/** An AudioNode that performs a Linear Convolution on a given AudioBuffer, often used to achieve a reverb effect. A ConvolverNode always has exactly one input and one output. */\ninterface ConvolverNode extends AudioNode {\n    buffer: AudioBuffer | null;\n    normalize: boolean;\n}\n\ndeclare var ConvolverNode: {\n    prototype: ConvolverNode;\n    new(context: BaseAudioContext, options?: ConvolverOptions): ConvolverNode;\n};\n\n/** The position and altitude of the device on Earth, as well as the accuracy with which these properties are calculated. */\ninterface Coordinates {\n    readonly accuracy: number;\n    readonly altitude: number | null;\n    readonly altitudeAccuracy: number | null;\n    readonly heading: number | null;\n    readonly latitude: number;\n    readonly longitude: number;\n    readonly speed: number | null;\n}\n\n/** An interface of the Streams API provides a built-in byte length queuing strategy that can be used when constructing streams. */\ninterface CountQueuingStrategy extends QueuingStrategy {\n    highWaterMark: number;\n    size(chunk: any): 1;\n}\n\ndeclare var CountQueuingStrategy: {\n    prototype: CountQueuingStrategy;\n    new(options: { highWaterMark: number }): CountQueuingStrategy;\n};\n\n/** Basic cryptography features available in the current context. It allows access to a cryptographically strong random number generator and to cryptographic primitives. */\ninterface Crypto {\n    readonly subtle: SubtleCrypto;\n    getRandomValues<T extends Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | null>(array: T): T;\n}\n\ndeclare var Crypto: {\n    prototype: Crypto;\n    new(): Crypto;\n};\n\n/** The CryptoKey dictionary of the Web Crypto API represents a cryptographic key. */\ninterface CryptoKey {\n    readonly algorithm: KeyAlgorithm;\n    readonly extractable: boolean;\n    readonly type: KeyType;\n    readonly usages: KeyUsage[];\n}\n\ndeclare var CryptoKey: {\n    prototype: CryptoKey;\n    new(): CryptoKey;\n};\n\n/** The CryptoKeyPair dictionary of the Web Crypto API represents a key pair for an asymmetric cryptography algorithm, also known as a public-key algorithm. */\ninterface CryptoKeyPair {\n    privateKey: CryptoKey;\n    publicKey: CryptoKey;\n}\n\ndeclare var CryptoKeyPair: {\n    prototype: CryptoKeyPair;\n    new(): CryptoKeyPair;\n};\n\ninterface CustomElementRegistry {\n    define(name: string, constructor: Function, options?: ElementDefinitionOptions): void;\n    get(name: string): any;\n    upgrade(root: Node): void;\n    whenDefined(name: string): Promise<void>;\n}\n\ndeclare var CustomElementRegistry: {\n    prototype: CustomElementRegistry;\n    new(): CustomElementRegistry;\n};\n\ninterface CustomEvent<T = any> extends Event {\n    /**\n     * Returns any custom data event was created with.\n     * Typically used for synthetic events.\n     */\n    readonly detail: T;\n    initCustomEvent(typeArg: string, canBubbleArg: boolean, cancelableArg: boolean, detailArg: T): void;\n}\n\ndeclare var CustomEvent: {\n    prototype: CustomEvent;\n    new<T>(typeArg: string, eventInitDict?: CustomEventInit<T>): CustomEvent<T>;\n};\n\n/** An error object that contains an error name. */\ninterface DOMError {\n    readonly name: string;\n    toString(): string;\n}\n\ndeclare var DOMError: {\n    prototype: DOMError;\n    new(): DOMError;\n};\n\n/** An abnormal event (called an exception) which occurs as a result of calling a method or accessing a property of a web API. */\ninterface DOMException {\n    readonly code: number;\n    readonly message: string;\n    readonly name: string;\n    readonly ABORT_ERR: number;\n    readonly DATA_CLONE_ERR: number;\n    readonly DOMSTRING_SIZE_ERR: number;\n    readonly HIERARCHY_REQUEST_ERR: number;\n    readonly INDEX_SIZE_ERR: number;\n    readonly INUSE_ATTRIBUTE_ERR: number;\n    readonly INVALID_ACCESS_ERR: number;\n    readonly INVALID_CHARACTER_ERR: number;\n    readonly INVALID_MODIFICATION_ERR: number;\n    readonly INVALID_NODE_TYPE_ERR: number;\n    readonly INVALID_STATE_ERR: number;\n    readonly NAMESPACE_ERR: number;\n    readonly NETWORK_ERR: number;\n    readonly NOT_FOUND_ERR: number;\n    readonly NOT_SUPPORTED_ERR: number;\n    readonly NO_DATA_ALLOWED_ERR: number;\n    readonly NO_MODIFICATION_ALLOWED_ERR: number;\n    readonly QUOTA_EXCEEDED_ERR: number;\n    readonly SECURITY_ERR: number;\n    readonly SYNTAX_ERR: number;\n    readonly TIMEOUT_ERR: number;\n    readonly TYPE_MISMATCH_ERR: number;\n    readonly URL_MISMATCH_ERR: number;\n    readonly VALIDATION_ERR: number;\n    readonly WRONG_DOCUMENT_ERR: number;\n}\n\ndeclare var DOMException: {\n    prototype: DOMException;\n    new(message?: string, name?: string): DOMException;\n    readonly ABORT_ERR: number;\n    readonly DATA_CLONE_ERR: number;\n    readonly DOMSTRING_SIZE_ERR: number;\n    readonly HIERARCHY_REQUEST_ERR: number;\n    readonly INDEX_SIZE_ERR: number;\n    readonly INUSE_ATTRIBUTE_ERR: number;\n    readonly INVALID_ACCESS_ERR: number;\n    readonly INVALID_CHARACTER_ERR: number;\n    readonly INVALID_MODIFICATION_ERR: number;\n    readonly INVALID_NODE_TYPE_ERR: number;\n    readonly INVALID_STATE_ERR: number;\n    readonly NAMESPACE_ERR: number;\n    readonly NETWORK_ERR: number;\n    readonly NOT_FOUND_ERR: number;\n    readonly NOT_SUPPORTED_ERR: number;\n    readonly NO_DATA_ALLOWED_ERR: number;\n    readonly NO_MODIFICATION_ALLOWED_ERR: number;\n    readonly QUOTA_EXCEEDED_ERR: number;\n    readonly SECURITY_ERR: number;\n    readonly SYNTAX_ERR: number;\n    readonly TIMEOUT_ERR: number;\n    readonly TYPE_MISMATCH_ERR: number;\n    readonly URL_MISMATCH_ERR: number;\n    readonly VALIDATION_ERR: number;\n    readonly WRONG_DOCUMENT_ERR: number;\n};\n\n/** An object providing methods which are not dependent on any particular document. Such an object is returned by the Document.implementation property. */\ninterface DOMImplementation {\n    createDocument(namespaceURI: string | null, qualifiedName: string | null, doctype: DocumentType | null): Document;\n    createDocumentType(qualifiedName: string, publicId: string, systemId: string): DocumentType;\n    createHTMLDocument(title?: string): Document;\n    /** @deprecated */\n    hasFeature(...args: any[]): true;\n}\n\ndeclare var DOMImplementation: {\n    prototype: DOMImplementation;\n    new(): DOMImplementation;\n};\n\ninterface DOML2DeprecatedColorProperty {\n    color: string;\n}\n\ninterface DOMMatrix extends DOMMatrixReadOnly {\n    a: number;\n    b: number;\n    c: number;\n    d: number;\n    e: number;\n    f: number;\n    m11: number;\n    m12: number;\n    m13: number;\n    m14: number;\n    m21: number;\n    m22: number;\n    m23: number;\n    m24: number;\n    m31: number;\n    m32: number;\n    m33: number;\n    m34: number;\n    m41: number;\n    m42: number;\n    m43: number;\n    m44: number;\n    invertSelf(): DOMMatrix;\n    multiplySelf(other?: DOMMatrixInit): DOMMatrix;\n    preMultiplySelf(other?: DOMMatrixInit): DOMMatrix;\n    rotateAxisAngleSelf(x?: number, y?: number, z?: number, angle?: number): DOMMatrix;\n    rotateFromVectorSelf(x?: number, y?: number): DOMMatrix;\n    rotateSelf(rotX?: number, rotY?: number, rotZ?: number): DOMMatrix;\n    scale3dSelf(scale?: number, originX?: number, originY?: number, originZ?: number): DOMMatrix;\n    scaleSelf(scaleX?: number, scaleY?: number, scaleZ?: number, originX?: number, originY?: number, originZ?: number): DOMMatrix;\n    setMatrixValue(transformList: string): DOMMatrix;\n    skewXSelf(sx?: number): DOMMatrix;\n    skewYSelf(sy?: number): DOMMatrix;\n    translateSelf(tx?: number, ty?: number, tz?: number): DOMMatrix;\n}\n\ndeclare var DOMMatrix: {\n    prototype: DOMMatrix;\n    new(init?: string | number[]): DOMMatrix;\n    fromFloat32Array(array32: Float32Array): DOMMatrix;\n    fromFloat64Array(array64: Float64Array): DOMMatrix;\n    fromMatrix(other?: DOMMatrixInit): DOMMatrix;\n};\n\ntype SVGMatrix = DOMMatrix;\ndeclare var SVGMatrix: typeof DOMMatrix;\n\ntype WebKitCSSMatrix = DOMMatrix;\ndeclare var WebKitCSSMatrix: typeof DOMMatrix;\n\ninterface DOMMatrixReadOnly {\n    readonly a: number;\n    readonly b: number;\n    readonly c: number;\n    readonly d: number;\n    readonly e: number;\n    readonly f: number;\n    readonly is2D: boolean;\n    readonly isIdentity: boolean;\n    readonly m11: number;\n    readonly m12: number;\n    readonly m13: number;\n    readonly m14: number;\n    readonly m21: number;\n    readonly m22: number;\n    readonly m23: number;\n    readonly m24: number;\n    readonly m31: number;\n    readonly m32: number;\n    readonly m33: number;\n    readonly m34: number;\n    readonly m41: number;\n    readonly m42: number;\n    readonly m43: number;\n    readonly m44: number;\n    flipX(): DOMMatrix;\n    flipY(): DOMMatrix;\n    inverse(): DOMMatrix;\n    multiply(other?: DOMMatrixInit): DOMMatrix;\n    rotate(rotX?: number, rotY?: number, rotZ?: number): DOMMatrix;\n    rotateAxisAngle(x?: number, y?: number, z?: number, angle?: number): DOMMatrix;\n    rotateFromVector(x?: number, y?: number): DOMMatrix;\n    scale(scaleX?: number, scaleY?: number, scaleZ?: number, originX?: number, originY?: number, originZ?: number): DOMMatrix;\n    scale3d(scale?: number, originX?: number, originY?: number, originZ?: number): DOMMatrix;\n    /** @deprecated */\n    scaleNonUniform(scaleX?: number, scaleY?: number): DOMMatrix;\n    skewX(sx?: number): DOMMatrix;\n    skewY(sy?: number): DOMMatrix;\n    toFloat32Array(): Float32Array;\n    toFloat64Array(): Float64Array;\n    toJSON(): any;\n    transformPoint(point?: DOMPointInit): DOMPoint;\n    translate(tx?: number, ty?: number, tz?: number): DOMMatrix;\n}\n\ndeclare var DOMMatrixReadOnly: {\n    prototype: DOMMatrixReadOnly;\n    new(init?: string | number[]): DOMMatrixReadOnly;\n    fromFloat32Array(array32: Float32Array): DOMMatrixReadOnly;\n    fromFloat64Array(array64: Float64Array): DOMMatrixReadOnly;\n    fromMatrix(other?: DOMMatrixInit): DOMMatrixReadOnly;\n};\n\n/** Provides the ability to parse XML or HTML source code from a string into a DOM Document. */\ninterface DOMParser {\n    parseFromString(str: string, type: SupportedType): Document;\n}\n\ndeclare var DOMParser: {\n    prototype: DOMParser;\n    new(): DOMParser;\n};\n\ninterface DOMPoint extends DOMPointReadOnly {\n    w: number;\n    x: number;\n    y: number;\n    z: number;\n}\n\ndeclare var DOMPoint: {\n    prototype: DOMPoint;\n    new(x?: number, y?: number, z?: number, w?: number): DOMPoint;\n    fromPoint(other?: DOMPointInit): DOMPoint;\n};\n\ntype SVGPoint = DOMPoint;\ndeclare var SVGPoint: typeof DOMPoint;\n\ninterface DOMPointReadOnly {\n    readonly w: number;\n    readonly x: number;\n    readonly y: number;\n    readonly z: number;\n    matrixTransform(matrix?: DOMMatrixInit): DOMPoint;\n    toJSON(): any;\n}\n\ndeclare var DOMPointReadOnly: {\n    prototype: DOMPointReadOnly;\n    new(x?: number, y?: number, z?: number, w?: number): DOMPointReadOnly;\n    fromPoint(other?: DOMPointInit): DOMPointReadOnly;\n};\n\ninterface DOMQuad {\n    readonly p1: DOMPoint;\n    readonly p2: DOMPoint;\n    readonly p3: DOMPoint;\n    readonly p4: DOMPoint;\n    getBounds(): DOMRect;\n    toJSON(): any;\n}\n\ndeclare var DOMQuad: {\n    prototype: DOMQuad;\n    new(p1?: DOMPointInit, p2?: DOMPointInit, p3?: DOMPointInit, p4?: DOMPointInit): DOMQuad;\n    fromQuad(other?: DOMQuadInit): DOMQuad;\n    fromRect(other?: DOMRectInit): DOMQuad;\n};\n\ninterface DOMRect extends DOMRectReadOnly {\n    height: number;\n    width: number;\n    x: number;\n    y: number;\n}\n\ndeclare var DOMRect: {\n    prototype: DOMRect;\n    new(x?: number, y?: number, width?: number, height?: number): DOMRect;\n    fromRect(other?: DOMRectInit): DOMRect;\n};\n\ntype SVGRect = DOMRect;\ndeclare var SVGRect: typeof DOMRect;\n\ninterface DOMRectList {\n    readonly length: number;\n    item(index: number): DOMRect | null;\n    [index: number]: DOMRect;\n}\n\ndeclare var DOMRectList: {\n    prototype: DOMRectList;\n    new(): DOMRectList;\n};\n\ninterface DOMRectReadOnly {\n    readonly bottom: number;\n    readonly height: number;\n    readonly left: number;\n    readonly right: number;\n    readonly top: number;\n    readonly width: number;\n    readonly x: number;\n    readonly y: number;\n    toJSON(): any;\n}\n\ndeclare var DOMRectReadOnly: {\n    prototype: DOMRectReadOnly;\n    new(x?: number, y?: number, width?: number, height?: number): DOMRectReadOnly;\n    fromRect(other?: DOMRectInit): DOMRectReadOnly;\n};\n\ninterface DOMSettableTokenList extends DOMTokenList {\n    value: string;\n}\n\ndeclare var DOMSettableTokenList: {\n    prototype: DOMSettableTokenList;\n    new(): DOMSettableTokenList;\n};\n\n/** A type returned by some APIs which contains a list of DOMString (strings). */\ninterface DOMStringList {\n    /**\n     * Returns the number of strings in strings.\n     */\n    readonly length: number;\n    /**\n     * Returns true if strings contains string, and false\n     * otherwise.\n     */\n    contains(string: string): boolean;\n    /**\n     * Returns the string with index index from strings.\n     */\n    item(index: number): string | null;\n    [index: number]: string;\n}\n\ndeclare var DOMStringList: {\n    prototype: DOMStringList;\n    new(): DOMStringList;\n};\n\n/** Used by the dataset HTML attribute to represent data for custom attributes added to elements. */\ninterface DOMStringMap {\n    [name: string]: string | undefined;\n}\n\ndeclare var DOMStringMap: {\n    prototype: DOMStringMap;\n    new(): DOMStringMap;\n};\n\n/** A set of space-separated tokens. Such a set is returned by Element.classList, HTMLLinkElement.relList, HTMLAnchorElement.relList, HTMLAreaElement.relList, HTMLIframeElement.sandbox, or HTMLOutputElement.htmlFor. It is indexed beginning with 0 as with JavaScript Array objects. DOMTokenList is always case-sensitive. */\ninterface DOMTokenList {\n    /**\n     * Returns the number of tokens.\n     */\n    readonly length: number;\n    /**\n     * Returns the associated set as string.\n     * Can be set, to change the associated attribute.\n     */\n    value: string;\n    /**\n     * Adds all arguments passed, except those already present.\n     * Throws a "SyntaxError" DOMException if one of the arguments is the empty\n     * string.\n     * Throws an "InvalidCharacterError" DOMException if one of the arguments\n     * contains any ASCII whitespace.\n     */\n    add(...tokens: string[]): void;\n    /**\n     * Returns true if token is present, and false otherwise.\n     */\n    contains(token: string): boolean;\n    /**\n     * tokenlist[index]\n     */\n    item(index: number): string | null;\n    /**\n     * Removes arguments passed, if they are present.\n     * Throws a "SyntaxError" DOMException if one of the arguments is the empty\n     * string.\n     * Throws an "InvalidCharacterError" DOMException if one of the arguments\n     * contains any ASCII whitespace.\n     */\n    remove(...tokens: string[]): void;\n    /**\n     * Replaces token with newToken.\n     * Returns true if token was replaced with newToken, and false otherwise.\n     * Throws a "SyntaxError" DOMException if one of the arguments is the empty\n     * string.\n     * Throws an "InvalidCharacterError" DOMException if one of the arguments\n     * contains any ASCII whitespace.\n     */\n    replace(oldToken: string, newToken: string): void;\n    /**\n     * Returns true if token is in the associated attribute\'s supported tokens. Returns\n     * false otherwise.\n     * Throws a TypeError if the associated attribute has no supported tokens defined.\n     */\n    supports(token: string): boolean;\n    toggle(token: string, force?: boolean): boolean;\n    forEach(callbackfn: (value: string, key: number, parent: DOMTokenList) => void, thisArg?: any): void;\n    [index: number]: string;\n}\n\ndeclare var DOMTokenList: {\n    prototype: DOMTokenList;\n    new(): DOMTokenList;\n};\n\ninterface DataCue extends TextTrackCue {\n    data: ArrayBuffer;\n    addEventListener<K extends keyof TextTrackCueEventMap>(type: K, listener: (this: DataCue, ev: TextTrackCueEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof TextTrackCueEventMap>(type: K, listener: (this: DataCue, ev: TextTrackCueEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var DataCue: {\n    prototype: DataCue;\n    new(): DataCue;\n};\n\n/** Used to hold the data that is being dragged during a drag and drop operation. It may hold one or more data items, each of one or more data types. For more information about drag and drop, see HTML Drag and Drop API. */\ninterface DataTransfer {\n    dropEffect: string;\n    effectAllowed: string;\n    /**\n     * Returns a FileList of the files being dragged, if any.\n     */\n    readonly files: FileList;\n    /**\n     * Returns a DataTransferItemList object, with the drag data.\n     */\n    readonly items: DataTransferItemList;\n    /**\n     * Returns a frozen array listing the formats that were set in the dragstart event. In addition, if any files are being\n     * dragged, then one of the types will be the string "Files".\n     */\n    readonly types: ReadonlyArray<string>;\n    /**\n     * Removes the data of the specified formats. Removes all data if the argument is omitted.\n     */\n    clearData(format?: string): void;\n    /**\n     * Returns the specified data. If there is no such data, returns the empty string.\n     */\n    getData(format: string): string;\n    /**\n     * Adds the specified data.\n     */\n    setData(format: string, data: string): void;\n    /**\n     * Uses the given element to update the drag feedback, replacing any previously specified\n     * feedback.\n     */\n    setDragImage(image: Element, x: number, y: number): void;\n}\n\ndeclare var DataTransfer: {\n    prototype: DataTransfer;\n    new(): DataTransfer;\n};\n\n/** One drag data item. During a drag operation, each drag event has a dataTransfer property which contains a list of drag data items. Each item in the list is a DataTransferItem object. */\ninterface DataTransferItem {\n    /**\n     * Returns the drag data item kind, one of: "string",\n     * "file".\n     */\n    readonly kind: string;\n    /**\n     * Returns the drag data item type string.\n     */\n    readonly type: string;\n    /**\n     * Returns a File object, if the drag data item kind is File.\n     */\n    getAsFile(): File | null;\n    /**\n     * Invokes the callback with the string data as the argument, if the drag data item\n     * kind is Plain Unicode string.\n     */\n    getAsString(callback: FunctionStringCallback | null): void;\n    webkitGetAsEntry(): any;\n}\n\ndeclare var DataTransferItem: {\n    prototype: DataTransferItem;\n    new(): DataTransferItem;\n};\n\n/** A list of DataTransferItem objects representing items being dragged. During a drag operation, each DragEvent has a dataTransfer property and that property is a DataTransferItemList. */\ninterface DataTransferItemList {\n    /**\n     * Returns the number of items in the drag data store.\n     */\n    readonly length: number;\n    /**\n     * Adds a new entry for the given data to the drag data store. If the data is plain\n     * text  then a type string has to be provided\n     * also.\n     */\n    add(data: string, type: string): DataTransferItem | null;\n    add(data: File): DataTransferItem | null;\n    /**\n     * Removes all the entries in the drag data store.\n     */\n    clear(): void;\n    item(index: number): DataTransferItem;\n    /**\n     * Removes the indexth entry in the drag data store.\n     */\n    remove(index: number): void;\n    [name: number]: DataTransferItem;\n}\n\ndeclare var DataTransferItemList: {\n    prototype: DataTransferItemList;\n    new(): DataTransferItemList;\n};\n\ninterface DeferredPermissionRequest {\n    readonly id: number;\n    readonly type: MSWebViewPermissionType;\n    readonly uri: string;\n    allow(): void;\n    deny(): void;\n}\n\ndeclare var DeferredPermissionRequest: {\n    prototype: DeferredPermissionRequest;\n    new(): DeferredPermissionRequest;\n};\n\n/** A delay-line; an AudioNode audio-processing module that causes a delay between the arrival of an input data and its propagation to the output. */\ninterface DelayNode extends AudioNode {\n    readonly delayTime: AudioParam;\n}\n\ndeclare var DelayNode: {\n    prototype: DelayNode;\n    new(context: BaseAudioContext, options?: DelayOptions): DelayNode;\n};\n\n/** Provides information about the amount of acceleration the device is experiencing along all three axes. */\ninterface DeviceAcceleration {\n    readonly x: number | null;\n    readonly y: number | null;\n    readonly z: number | null;\n}\n\ndeclare var DeviceAcceleration: {\n    prototype: DeviceAcceleration;\n    new(): DeviceAcceleration;\n};\n\n/** The DeviceLightEvent provides web developers with information from photo sensors or similiar detectors about ambient light levels near the device. For example this may be useful to adjust the screen\'s brightness based on the current ambient light level in order to save energy or provide better readability. */\ninterface DeviceLightEvent extends Event {\n    readonly value: number;\n}\n\ndeclare var DeviceLightEvent: {\n    prototype: DeviceLightEvent;\n    new(typeArg: string, eventInitDict?: DeviceLightEventInit): DeviceLightEvent;\n};\n\n/** The DeviceMotionEvent provides web developers with information about the speed of changes for the device\'s position and orientation. */\ninterface DeviceMotionEvent extends Event {\n    readonly acceleration: DeviceMotionEventAcceleration | null;\n    readonly accelerationIncludingGravity: DeviceMotionEventAcceleration | null;\n    readonly interval: number;\n    readonly rotationRate: DeviceMotionEventRotationRate | null;\n}\n\ndeclare var DeviceMotionEvent: {\n    prototype: DeviceMotionEvent;\n    new(type: string, eventInitDict?: DeviceMotionEventInit): DeviceMotionEvent;\n};\n\ninterface DeviceMotionEventAcceleration {\n    readonly x: number | null;\n    readonly y: number | null;\n    readonly z: number | null;\n}\n\ninterface DeviceMotionEventRotationRate {\n    readonly alpha: number | null;\n    readonly beta: number | null;\n    readonly gamma: number | null;\n}\n\n/** The DeviceOrientationEvent provides web developers with information from the physical orientation of the device running the web page. */\ninterface DeviceOrientationEvent extends Event {\n    readonly absolute: boolean;\n    readonly alpha: number | null;\n    readonly beta: number | null;\n    readonly gamma: number | null;\n}\n\ndeclare var DeviceOrientationEvent: {\n    prototype: DeviceOrientationEvent;\n    new(type: string, eventInitDict?: DeviceOrientationEventInit): DeviceOrientationEvent;\n};\n\n/** Provides information about the rate at which the device is rotating around all three axes. */\ninterface DeviceRotationRate {\n    readonly alpha: number | null;\n    readonly beta: number | null;\n    readonly gamma: number | null;\n}\n\ndeclare var DeviceRotationRate: {\n    prototype: DeviceRotationRate;\n    new(): DeviceRotationRate;\n};\n\ninterface DhImportKeyParams extends Algorithm {\n    generator: Uint8Array;\n    prime: Uint8Array;\n}\n\ninterface DhKeyAlgorithm extends KeyAlgorithm {\n    generator: Uint8Array;\n    prime: Uint8Array;\n}\n\ninterface DhKeyDeriveParams extends Algorithm {\n    public: CryptoKey;\n}\n\ninterface DhKeyGenParams extends Algorithm {\n    generator: Uint8Array;\n    prime: Uint8Array;\n}\n\ninterface DocumentEventMap extends GlobalEventHandlersEventMap, DocumentAndElementEventHandlersEventMap {\n    "fullscreenchange": Event;\n    "fullscreenerror": Event;\n    "pointerlockchange": Event;\n    "pointerlockerror": Event;\n    "readystatechange": ProgressEvent;\n    "visibilitychange": Event;\n}\n\n/** Any web page loaded in the browser and serves as an entry point into the web page\'s content, which is the DOM tree. */\ninterface Document extends Node, NonElementParentNode, DocumentOrShadowRoot, ParentNode, XPathEvaluatorBase, GlobalEventHandlers, DocumentAndElementEventHandlers {\n    /**\n     * Sets or gets the URL for the current document.\n     */\n    readonly URL: string;\n    /**\n     * Gets the object that has the focus when the parent document has focus.\n     */\n    readonly activeElement: Element | null;\n    /**\n     * Sets or gets the color of all active links in the document.\n     */\n    /** @deprecated */\n    alinkColor: string;\n    /**\n     * Returns a reference to the collection of elements contained by the object.\n     */\n    /** @deprecated */\n    readonly all: HTMLAllCollection;\n    /**\n     * Retrieves a collection of all a objects that have a name and/or id property. Objects in this collection are in HTML source order.\n     */\n    /** @deprecated */\n    readonly anchors: HTMLCollectionOf<HTMLAnchorElement>;\n    /**\n     * Retrieves a collection of all applet objects in the document.\n     */\n    /** @deprecated */\n    readonly applets: HTMLCollectionOf<HTMLAppletElement>;\n    /**\n     * Deprecated. Sets or retrieves a value that indicates the background color behind the object.\n     */\n    /** @deprecated */\n    bgColor: string;\n    /**\n     * Specifies the beginning and end of the document body.\n     */\n    body: HTMLElement;\n    /**\n     * Returns document\'s encoding.\n     */\n    readonly characterSet: string;\n    /**\n     * Gets or sets the character set used to encode the object.\n     */\n    readonly charset: string;\n    /**\n     * Gets a value that indicates whether standards-compliant mode is switched on for the object.\n     */\n    readonly compatMode: string;\n    /**\n     * Returns document\'s content type.\n     */\n    readonly contentType: string;\n    /**\n     * Returns the HTTP cookies that apply to the Document. If there are no cookies or\n     * cookies can\'t be applied to this resource, the empty string will be returned.\n     * Can be set, to add a new cookie to the element\'s set of HTTP cookies.\n     * If the contents are sandboxed into a\n     * unique origin (e.g. in an iframe with the sandbox attribute), a\n     * "SecurityError" DOMException will be thrown on getting\n     * and setting.\n     */\n    cookie: string;\n    /**\n     * Returns the script element, or the SVG script element,\n     * that is currently executing, as long as the element represents a classic script.\n     * In the case of reentrant script execution, returns the one that most recently started executing\n     * amongst those that have not yet finished executing.\n     * Returns null if the Document is not currently executing a script\n     * or SVG script element (e.g., because the running script is an event\n     * handler, or a timeout), or if the currently executing script or SVG\n     * script element represents a module script.\n     */\n    readonly currentScript: HTMLOrSVGScriptElement | null;\n    readonly defaultView: WindowProxy | null;\n    /**\n     * Sets or gets a value that indicates whether the document can be edited.\n     */\n    designMode: string;\n    /**\n     * Sets or retrieves a value that indicates the reading order of the object.\n     */\n    dir: string;\n    /**\n     * Gets an object representing the document type declaration associated with the current document.\n     */\n    readonly doctype: DocumentType | null;\n    /**\n     * Gets a reference to the root node of the document.\n     */\n    readonly documentElement: HTMLElement;\n    /**\n     * Returns document\'s URL.\n     */\n    readonly documentURI: string;\n    /**\n     * Sets or gets the security domain of the document.\n     */\n    domain: string;\n    /**\n     * Retrieves a collection of all embed objects in the document.\n     */\n    readonly embeds: HTMLCollectionOf<HTMLEmbedElement>;\n    /**\n     * Sets or gets the foreground (text) color of the document.\n     */\n    /** @deprecated */\n    fgColor: string;\n    /**\n     * Retrieves a collection, in source order, of all form objects in the document.\n     */\n    readonly forms: HTMLCollectionOf<HTMLFormElement>;\n    /** @deprecated */\n    readonly fullscreen: boolean;\n    /**\n     * Returns true if document has the ability to display elements fullscreen\n     * and fullscreen is supported, or false otherwise.\n     */\n    readonly fullscreenEnabled: boolean;\n    /**\n     * Returns the head element.\n     */\n    readonly head: HTMLHeadElement;\n    readonly hidden: boolean;\n    /**\n     * Retrieves a collection, in source order, of img objects in the document.\n     */\n    readonly images: HTMLCollectionOf<HTMLImageElement>;\n    /**\n     * Gets the implementation object of the current document.\n     */\n    readonly implementation: DOMImplementation;\n    /**\n     * Returns the character encoding used to create the webpage that is loaded into the document object.\n     */\n    readonly inputEncoding: string;\n    /**\n     * Gets the date that the page was last modified, if the page supplies one.\n     */\n    readonly lastModified: string;\n    /**\n     * Sets or gets the color of the document links.\n     */\n    /** @deprecated */\n    linkColor: string;\n    /**\n     * Retrieves a collection of all a objects that specify the href property and all area objects in the document.\n     */\n    readonly links: HTMLCollectionOf<HTMLAnchorElement | HTMLAreaElement>;\n    /**\n     * Contains information about the current URL.\n     */\n    location: Location;\n    onfullscreenchange: ((this: Document, ev: Event) => any) | null;\n    onfullscreenerror: ((this: Document, ev: Event) => any) | null;\n    onpointerlockchange: ((this: Document, ev: Event) => any) | null;\n    onpointerlockerror: ((this: Document, ev: Event) => any) | null;\n    /**\n     * Fires when the state of the object has changed.\n     * @param ev The event\n     */\n    onreadystatechange: ((this: Document, ev: ProgressEvent) => any) | null;\n    onvisibilitychange: ((this: Document, ev: Event) => any) | null;\n    /**\n     * Returns document\'s origin.\n     */\n    readonly origin: string;\n    /**\n     * Return an HTMLCollection of the embed elements in the Document.\n     */\n    readonly plugins: HTMLCollectionOf<HTMLEmbedElement>;\n    /**\n     * Retrieves a value that indicates the current state of the object.\n     */\n    readonly readyState: DocumentReadyState;\n    /**\n     * Gets the URL of the location that referred the user to the current page.\n     */\n    readonly referrer: string;\n    /**\n     * Retrieves a collection of all script objects in the document.\n     */\n    readonly scripts: HTMLCollectionOf<HTMLScriptElement>;\n    readonly scrollingElement: Element | null;\n    readonly timeline: DocumentTimeline;\n    /**\n     * Contains the title of the document.\n     */\n    title: string;\n    readonly visibilityState: VisibilityState;\n    /**\n     * Sets or gets the color of the links that the user has visited.\n     */\n    /** @deprecated */\n    vlinkColor: string;\n    /**\n     * Moves node from another document and returns it.\n     * If node is a document, throws a "NotSupportedError" DOMException or, if node is a shadow root, throws a\n     * "HierarchyRequestError" DOMException.\n     */\n    adoptNode<T extends Node>(source: T): T;\n    /** @deprecated */\n    captureEvents(): void;\n    caretPositionFromPoint(x: number, y: number): CaretPosition | null;\n    /** @deprecated */\n    caretRangeFromPoint(x: number, y: number): Range;\n    /** @deprecated */\n    clear(): void;\n    /**\n     * Closes an output stream and forces the sent data to display.\n     */\n    close(): void;\n    /**\n     * Creates an attribute object with a specified name.\n     * @param name String that sets the attribute object\'s name.\n     */\n    createAttribute(localName: string): Attr;\n    createAttributeNS(namespace: string | null, qualifiedName: string): Attr;\n    /**\n     * Returns a CDATASection node whose data is data.\n     */\n    createCDATASection(data: string): CDATASection;\n    /**\n     * Creates a comment object with the specified data.\n     * @param data Sets the comment object\'s data.\n     */\n    createComment(data: string): Comment;\n    /**\n     * Creates a new document.\n     */\n    createDocumentFragment(): DocumentFragment;\n    /**\n     * Creates an instance of the element for the specified tag.\n     * @param tagName The name of an element.\n     */\n    createElement<K extends keyof HTMLElementTagNameMap>(tagName: K, options?: ElementCreationOptions): HTMLElementTagNameMap[K];\n    /** @deprecated */\n    createElement<K extends keyof HTMLElementDeprecatedTagNameMap>(tagName: K, options?: ElementCreationOptions): HTMLElementDeprecatedTagNameMap[K];\n    createElement(tagName: string, options?: ElementCreationOptions): HTMLElement;\n    /**\n     * Returns an element with namespace namespace. Its namespace prefix will be everything before ":" (U+003E) in qualifiedName or null. Its local name will be everything after\n     * ":" (U+003E) in qualifiedName or qualifiedName.\n     * If localName does not match the Name production an\n     * "InvalidCharacterError" DOMException will be thrown.\n     * If one of the following conditions is true a "NamespaceError" DOMException will be thrown:\n     * localName does not match the QName production.\n     * Namespace prefix is not null and namespace is the empty string.\n     * Namespace prefix is "xml" and namespace is not the XML namespace.\n     * qualifiedName or namespace prefix is "xmlns" and namespace is not the XMLNS namespace.\n     * namespace is the XMLNS namespace and\n     * neither qualifiedName nor namespace prefix is "xmlns".\n     * When supplied, options\'s is can be used to create a customized built-in element.\n     */\n    createElementNS(namespaceURI: "http://www.w3.org/1999/xhtml", qualifiedName: string): HTMLElement;\n    createElementNS<K extends keyof SVGElementTagNameMap>(namespaceURI: "http://www.w3.org/2000/svg", qualifiedName: K): SVGElementTagNameMap[K];\n    createElementNS(namespaceURI: "http://www.w3.org/2000/svg", qualifiedName: string): SVGElement;\n    createElementNS(namespaceURI: string | null, qualifiedName: string, options?: ElementCreationOptions): Element;\n    createElementNS(namespace: string | null, qualifiedName: string, options?: string | ElementCreationOptions): Element;\n    createEvent(eventInterface: "AnimationEvent"): AnimationEvent;\n    createEvent(eventInterface: "AnimationPlaybackEvent"): AnimationPlaybackEvent;\n    createEvent(eventInterface: "AudioProcessingEvent"): AudioProcessingEvent;\n    createEvent(eventInterface: "BeforeUnloadEvent"): BeforeUnloadEvent;\n    createEvent(eventInterface: "ClipboardEvent"): ClipboardEvent;\n    createEvent(eventInterface: "CloseEvent"): CloseEvent;\n    createEvent(eventInterface: "CompositionEvent"): CompositionEvent;\n    createEvent(eventInterface: "CustomEvent"): CustomEvent;\n    createEvent(eventInterface: "DeviceLightEvent"): DeviceLightEvent;\n    createEvent(eventInterface: "DeviceMotionEvent"): DeviceMotionEvent;\n    createEvent(eventInterface: "DeviceOrientationEvent"): DeviceOrientationEvent;\n    createEvent(eventInterface: "DragEvent"): DragEvent;\n    createEvent(eventInterface: "ErrorEvent"): ErrorEvent;\n    createEvent(eventInterface: "Event"): Event;\n    createEvent(eventInterface: "Events"): Event;\n    createEvent(eventInterface: "FocusEvent"): FocusEvent;\n    createEvent(eventInterface: "FocusNavigationEvent"): FocusNavigationEvent;\n    createEvent(eventInterface: "GamepadEvent"): GamepadEvent;\n    createEvent(eventInterface: "HashChangeEvent"): HashChangeEvent;\n    createEvent(eventInterface: "IDBVersionChangeEvent"): IDBVersionChangeEvent;\n    createEvent(eventInterface: "KeyboardEvent"): KeyboardEvent;\n    createEvent(eventInterface: "ListeningStateChangedEvent"): ListeningStateChangedEvent;\n    createEvent(eventInterface: "MSGestureEvent"): MSGestureEvent;\n    createEvent(eventInterface: "MSMediaKeyMessageEvent"): MSMediaKeyMessageEvent;\n    createEvent(eventInterface: "MSMediaKeyNeededEvent"): MSMediaKeyNeededEvent;\n    createEvent(eventInterface: "MSPointerEvent"): MSPointerEvent;\n    createEvent(eventInterface: "MediaEncryptedEvent"): MediaEncryptedEvent;\n    createEvent(eventInterface: "MediaKeyMessageEvent"): MediaKeyMessageEvent;\n    createEvent(eventInterface: "MediaQueryListEvent"): MediaQueryListEvent;\n    createEvent(eventInterface: "MediaStreamErrorEvent"): MediaStreamErrorEvent;\n    createEvent(eventInterface: "MediaStreamEvent"): MediaStreamEvent;\n    createEvent(eventInterface: "MediaStreamTrackEvent"): MediaStreamTrackEvent;\n    createEvent(eventInterface: "MessageEvent"): MessageEvent;\n    createEvent(eventInterface: "MouseEvent"): MouseEvent;\n    createEvent(eventInterface: "MouseEvents"): MouseEvent;\n    createEvent(eventInterface: "MutationEvent"): MutationEvent;\n    createEvent(eventInterface: "MutationEvents"): MutationEvent;\n    createEvent(eventInterface: "OfflineAudioCompletionEvent"): OfflineAudioCompletionEvent;\n    createEvent(eventInterface: "OverflowEvent"): OverflowEvent;\n    createEvent(eventInterface: "PageTransitionEvent"): PageTransitionEvent;\n    createEvent(eventInterface: "PaymentRequestUpdateEvent"): PaymentRequestUpdateEvent;\n    createEvent(eventInterface: "PermissionRequestedEvent"): PermissionRequestedEvent;\n    createEvent(eventInterface: "PointerEvent"): PointerEvent;\n    createEvent(eventInterface: "PopStateEvent"): PopStateEvent;\n    createEvent(eventInterface: "ProgressEvent"): ProgressEvent;\n    createEvent(eventInterface: "PromiseRejectionEvent"): PromiseRejectionEvent;\n    createEvent(eventInterface: "RTCDTMFToneChangeEvent"): RTCDTMFToneChangeEvent;\n    createEvent(eventInterface: "RTCDataChannelEvent"): RTCDataChannelEvent;\n    createEvent(eventInterface: "RTCDtlsTransportStateChangedEvent"): RTCDtlsTransportStateChangedEvent;\n    createEvent(eventInterface: "RTCErrorEvent"): RTCErrorEvent;\n    createEvent(eventInterface: "RTCIceCandidatePairChangedEvent"): RTCIceCandidatePairChangedEvent;\n    createEvent(eventInterface: "RTCIceGathererEvent"): RTCIceGathererEvent;\n    createEvent(eventInterface: "RTCIceTransportStateChangedEvent"): RTCIceTransportStateChangedEvent;\n    createEvent(eventInterface: "RTCPeerConnectionIceErrorEvent"): RTCPeerConnectionIceErrorEvent;\n    createEvent(eventInterface: "RTCPeerConnectionIceEvent"): RTCPeerConnectionIceEvent;\n    createEvent(eventInterface: "RTCSsrcConflictEvent"): RTCSsrcConflictEvent;\n    createEvent(eventInterface: "RTCStatsEvent"): RTCStatsEvent;\n    createEvent(eventInterface: "RTCTrackEvent"): RTCTrackEvent;\n    createEvent(eventInterface: "SVGZoomEvent"): SVGZoomEvent;\n    createEvent(eventInterface: "SVGZoomEvents"): SVGZoomEvent;\n    createEvent(eventInterface: "SecurityPolicyViolationEvent"): SecurityPolicyViolationEvent;\n    createEvent(eventInterface: "ServiceWorkerMessageEvent"): ServiceWorkerMessageEvent;\n    createEvent(eventInterface: "SpeechRecognitionError"): SpeechRecognitionError;\n    createEvent(eventInterface: "SpeechRecognitionEvent"): SpeechRecognitionEvent;\n    createEvent(eventInterface: "SpeechSynthesisErrorEvent"): SpeechSynthesisErrorEvent;\n    createEvent(eventInterface: "SpeechSynthesisEvent"): SpeechSynthesisEvent;\n    createEvent(eventInterface: "StorageEvent"): StorageEvent;\n    createEvent(eventInterface: "TextEvent"): TextEvent;\n    createEvent(eventInterface: "TouchEvent"): TouchEvent;\n    createEvent(eventInterface: "TrackEvent"): TrackEvent;\n    createEvent(eventInterface: "TransitionEvent"): TransitionEvent;\n    createEvent(eventInterface: "UIEvent"): UIEvent;\n    createEvent(eventInterface: "UIEvents"): UIEvent;\n    createEvent(eventInterface: "VRDisplayEvent"): VRDisplayEvent;\n    createEvent(eventInterface: "VRDisplayEvent "): VRDisplayEvent ;\n    createEvent(eventInterface: "WebGLContextEvent"): WebGLContextEvent;\n    createEvent(eventInterface: "WheelEvent"): WheelEvent;\n    createEvent(eventInterface: string): Event;\n    /**\n     * Creates a NodeIterator object that you can use to traverse filtered lists of nodes or elements in a document.\n     * @param root The root element or node to start traversing on.\n     * @param whatToShow The type of nodes or elements to appear in the node list\n     * @param filter A custom NodeFilter function to use. For more information, see filter. Use null for no filter.\n     * @param entityReferenceExpansion A flag that specifies whether entity reference nodes are expanded.\n     */\n    createNodeIterator(root: Node, whatToShow?: number, filter?: NodeFilter | null): NodeIterator;\n    /**\n     * Returns a ProcessingInstruction node whose target is target and data is data.\n     * If target does not match the Name production an\n     * "InvalidCharacterError" DOMException will be thrown.\n     * If data contains "?>" an\n     * "InvalidCharacterError" DOMException will be thrown.\n     */\n    createProcessingInstruction(target: string, data: string): ProcessingInstruction;\n    /**\n     *  Returns an empty range object that has both of its boundary points positioned at the beginning of the document.\n     */\n    createRange(): Range;\n    /**\n     * Creates a text string from the specified value.\n     * @param data String that specifies the nodeValue property of the text node.\n     */\n    createTextNode(data: string): Text;\n    createTouch(view: WindowProxy, target: EventTarget, identifier: number, pageX: number, pageY: number, screenX: number, screenY: number): Touch;\n    createTouchList(...touches: Touch[]): TouchList;\n    /**\n     * Creates a TreeWalker object that you can use to traverse filtered lists of nodes or elements in a document.\n     * @param root The root element or node to start traversing on.\n     * @param whatToShow The type of nodes or elements to appear in the node list. For more information, see whatToShow.\n     * @param filter A custom NodeFilter function to use.\n     * @param entityReferenceExpansion A flag that specifies whether entity reference nodes are expanded.\n     */\n    createTreeWalker(root: Node, whatToShow?: number, filter?: NodeFilter | null): TreeWalker;\n    /** @deprecated */\n    createTreeWalker(root: Node, whatToShow: number, filter: NodeFilter | null, entityReferenceExpansion?: boolean): TreeWalker;\n    /**\n     * Returns the element for the specified x coordinate and the specified y coordinate.\n     * @param x The x-offset\n     * @param y The y-offset\n     */\n    elementFromPoint(x: number, y: number): Element | null;\n    elementsFromPoint(x: number, y: number): Element[];\n    /**\n     * Executes a command on the current document, current selection, or the given range.\n     * @param commandId String that specifies the command to execute. This command can be any of the command identifiers that can be executed in script.\n     * @param showUI Display the user interface, defaults to false.\n     * @param value Value to assign.\n     */\n    execCommand(commandId: string, showUI?: boolean, value?: string): boolean;\n    /**\n     * Stops document\'s fullscreen element from being displayed fullscreen and\n     * resolves promise when done.\n     */\n    exitFullscreen(): Promise<void>;\n    exitPointerLock(): void;\n    getAnimations(): Animation[];\n    /**\n     * Returns a reference to the first object with the specified value of the ID or NAME attribute.\n     * @param elementId String that specifies the ID value. Case-insensitive.\n     */\n    getElementById(elementId: string): HTMLElement | null;\n    /**\n     * collection = element . getElementsByClassName(classNames)\n     */\n    getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;\n    /**\n     * Gets a collection of objects based on the value of the NAME or ID attribute.\n     * @param elementName Gets a collection of objects based on the value of the NAME or ID attribute.\n     */\n    getElementsByName(elementName: string): NodeListOf<HTMLElement>;\n    /**\n     * Retrieves a collection of objects based on the specified element name.\n     * @param name Specifies the name of an element.\n     */\n    getElementsByTagName<K extends keyof HTMLElementTagNameMap>(qualifiedName: K): HTMLCollectionOf<HTMLElementTagNameMap[K]>;\n    getElementsByTagName<K extends keyof SVGElementTagNameMap>(qualifiedName: K): HTMLCollectionOf<SVGElementTagNameMap[K]>;\n    getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;\n    /**\n     * If namespace and localName are\n     * "*" returns a HTMLCollection of all descendant elements.\n     * If only namespace is "*" returns a HTMLCollection of all descendant elements whose local name is localName.\n     * If only localName is "*" returns a HTMLCollection of all descendant elements whose namespace is namespace.\n     * Otherwise, returns a HTMLCollection of all descendant elements whose namespace is namespace and local name is localName.\n     */\n    getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;\n    getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;\n    getElementsByTagNameNS(namespaceURI: string, localName: string): HTMLCollectionOf<Element>;\n    /**\n     * Returns an object representing the current selection of the document that is loaded into the object displaying a webpage.\n     */\n    getSelection(): Selection | null;\n    /**\n     * Gets a value indicating whether the object currently has focus.\n     */\n    hasFocus(): boolean;\n    /**\n     * Returns a copy of node. If deep is true, the copy also includes the node\'s descendants.\n     * If node is a document or a shadow root, throws a\n     * "NotSupportedError" DOMException.\n     */\n    importNode<T extends Node>(importedNode: T, deep: boolean): T;\n    /**\n     * Opens a new window and loads a document specified by a given URL. Also, opens a new window that uses the url parameter and the name parameter to collect the output of the write method and the writeln method.\n     * @param url Specifies a MIME type for the document.\n     * @param name Specifies the name of the window. This name is used as the value for the TARGET attribute on a form or an anchor element.\n     * @param features Contains a list of items separated by commas. Each item consists of an option and a value, separated by an equals sign (for example, "fullscreen=yes, toolbar=yes"). The following values are supported.\n     * @param replace Specifies whether the existing entry for the document is replaced in the history list.\n     */\n    open(url?: string, name?: string, features?: string, replace?: boolean): Document;\n    /**\n     * Returns a Boolean value that indicates whether a specified command can be successfully executed using execCommand, given the current state of the document.\n     * @param commandId Specifies a command identifier.\n     */\n    queryCommandEnabled(commandId: string): boolean;\n    /**\n     * Returns a Boolean value that indicates whether the specified command is in the indeterminate state.\n     * @param commandId String that specifies a command identifier.\n     */\n    queryCommandIndeterm(commandId: string): boolean;\n    /**\n     * Returns a Boolean value that indicates the current state of the command.\n     * @param commandId String that specifies a command identifier.\n     */\n    queryCommandState(commandId: string): boolean;\n    /**\n     * Returns a Boolean value that indicates whether the current command is supported on the current range.\n     * @param commandId Specifies a command identifier.\n     */\n    queryCommandSupported(commandId: string): boolean;\n    /**\n     * Returns the current value of the document, range, or current selection for the given command.\n     * @param commandId String that specifies a command identifier.\n     */\n    queryCommandValue(commandId: string): string;\n    /** @deprecated */\n    releaseEvents(): void;\n    /**\n     * Writes one or more HTML expressions to a document in the specified window.\n     * @param content Specifies the text and HTML tags to write.\n     */\n    write(...text: string[]): void;\n    /**\n     * Writes one or more HTML expressions, followed by a carriage return, to a document in the specified window.\n     * @param content The text and HTML tags to write.\n     */\n    writeln(...text: string[]): void;\n    addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: Document, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var Document: {\n    prototype: Document;\n    new(): Document;\n};\n\ninterface DocumentAndElementEventHandlersEventMap {\n    "copy": ClipboardEvent;\n    "cut": ClipboardEvent;\n    "paste": ClipboardEvent;\n}\n\ninterface DocumentAndElementEventHandlers {\n    oncopy: ((this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any) | null;\n    oncut: ((this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any) | null;\n    onpaste: ((this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any) | null;\n    addEventListener<K extends keyof DocumentAndElementEventHandlersEventMap>(type: K, listener: (this: DocumentAndElementEventHandlers, ev: DocumentAndElementEventHandlersEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof DocumentAndElementEventHandlersEventMap>(type: K, listener: (this: DocumentAndElementEventHandlers, ev: DocumentAndElementEventHandlersEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ninterface DocumentEvent {\n    createEvent(eventInterface: "AnimationEvent"): AnimationEvent;\n    createEvent(eventInterface: "AnimationPlaybackEvent"): AnimationPlaybackEvent;\n    createEvent(eventInterface: "AudioProcessingEvent"): AudioProcessingEvent;\n    createEvent(eventInterface: "BeforeUnloadEvent"): BeforeUnloadEvent;\n    createEvent(eventInterface: "ClipboardEvent"): ClipboardEvent;\n    createEvent(eventInterface: "CloseEvent"): CloseEvent;\n    createEvent(eventInterface: "CompositionEvent"): CompositionEvent;\n    createEvent(eventInterface: "CustomEvent"): CustomEvent;\n    createEvent(eventInterface: "DeviceLightEvent"): DeviceLightEvent;\n    createEvent(eventInterface: "DeviceMotionEvent"): DeviceMotionEvent;\n    createEvent(eventInterface: "DeviceOrientationEvent"): DeviceOrientationEvent;\n    createEvent(eventInterface: "DragEvent"): DragEvent;\n    createEvent(eventInterface: "ErrorEvent"): ErrorEvent;\n    createEvent(eventInterface: "Event"): Event;\n    createEvent(eventInterface: "Events"): Event;\n    createEvent(eventInterface: "FocusEvent"): FocusEvent;\n    createEvent(eventInterface: "FocusNavigationEvent"): FocusNavigationEvent;\n    createEvent(eventInterface: "GamepadEvent"): GamepadEvent;\n    createEvent(eventInterface: "HashChangeEvent"): HashChangeEvent;\n    createEvent(eventInterface: "IDBVersionChangeEvent"): IDBVersionChangeEvent;\n    createEvent(eventInterface: "KeyboardEvent"): KeyboardEvent;\n    createEvent(eventInterface: "ListeningStateChangedEvent"): ListeningStateChangedEvent;\n    createEvent(eventInterface: "MSGestureEvent"): MSGestureEvent;\n    createEvent(eventInterface: "MSMediaKeyMessageEvent"): MSMediaKeyMessageEvent;\n    createEvent(eventInterface: "MSMediaKeyNeededEvent"): MSMediaKeyNeededEvent;\n    createEvent(eventInterface: "MSPointerEvent"): MSPointerEvent;\n    createEvent(eventInterface: "MediaEncryptedEvent"): MediaEncryptedEvent;\n    createEvent(eventInterface: "MediaKeyMessageEvent"): MediaKeyMessageEvent;\n    createEvent(eventInterface: "MediaQueryListEvent"): MediaQueryListEvent;\n    createEvent(eventInterface: "MediaStreamErrorEvent"): MediaStreamErrorEvent;\n    createEvent(eventInterface: "MediaStreamEvent"): MediaStreamEvent;\n    createEvent(eventInterface: "MediaStreamTrackEvent"): MediaStreamTrackEvent;\n    createEvent(eventInterface: "MessageEvent"): MessageEvent;\n    createEvent(eventInterface: "MouseEvent"): MouseEvent;\n    createEvent(eventInterface: "MouseEvents"): MouseEvent;\n    createEvent(eventInterface: "MutationEvent"): MutationEvent;\n    createEvent(eventInterface: "MutationEvents"): MutationEvent;\n    createEvent(eventInterface: "OfflineAudioCompletionEvent"): OfflineAudioCompletionEvent;\n    createEvent(eventInterface: "OverflowEvent"): OverflowEvent;\n    createEvent(eventInterface: "PageTransitionEvent"): PageTransitionEvent;\n    createEvent(eventInterface: "PaymentRequestUpdateEvent"): PaymentRequestUpdateEvent;\n    createEvent(eventInterface: "PermissionRequestedEvent"): PermissionRequestedEvent;\n    createEvent(eventInterface: "PointerEvent"): PointerEvent;\n    createEvent(eventInterface: "PopStateEvent"): PopStateEvent;\n    createEvent(eventInterface: "ProgressEvent"): ProgressEvent;\n    createEvent(eventInterface: "PromiseRejectionEvent"): PromiseRejectionEvent;\n    createEvent(eventInterface: "RTCDTMFToneChangeEvent"): RTCDTMFToneChangeEvent;\n    createEvent(eventInterface: "RTCDataChannelEvent"): RTCDataChannelEvent;\n    createEvent(eventInterface: "RTCDtlsTransportStateChangedEvent"): RTCDtlsTransportStateChangedEvent;\n    createEvent(eventInterface: "RTCErrorEvent"): RTCErrorEvent;\n    createEvent(eventInterface: "RTCIceCandidatePairChangedEvent"): RTCIceCandidatePairChangedEvent;\n    createEvent(eventInterface: "RTCIceGathererEvent"): RTCIceGathererEvent;\n    createEvent(eventInterface: "RTCIceTransportStateChangedEvent"): RTCIceTransportStateChangedEvent;\n    createEvent(eventInterface: "RTCPeerConnectionIceErrorEvent"): RTCPeerConnectionIceErrorEvent;\n    createEvent(eventInterface: "RTCPeerConnectionIceEvent"): RTCPeerConnectionIceEvent;\n    createEvent(eventInterface: "RTCSsrcConflictEvent"): RTCSsrcConflictEvent;\n    createEvent(eventInterface: "RTCStatsEvent"): RTCStatsEvent;\n    createEvent(eventInterface: "RTCTrackEvent"): RTCTrackEvent;\n    createEvent(eventInterface: "SVGZoomEvent"): SVGZoomEvent;\n    createEvent(eventInterface: "SVGZoomEvents"): SVGZoomEvent;\n    createEvent(eventInterface: "SecurityPolicyViolationEvent"): SecurityPolicyViolationEvent;\n    createEvent(eventInterface: "ServiceWorkerMessageEvent"): ServiceWorkerMessageEvent;\n    createEvent(eventInterface: "SpeechRecognitionError"): SpeechRecognitionError;\n    createEvent(eventInterface: "SpeechRecognitionEvent"): SpeechRecognitionEvent;\n    createEvent(eventInterface: "SpeechSynthesisErrorEvent"): SpeechSynthesisErrorEvent;\n    createEvent(eventInterface: "SpeechSynthesisEvent"): SpeechSynthesisEvent;\n    createEvent(eventInterface: "StorageEvent"): StorageEvent;\n    createEvent(eventInterface: "TextEvent"): TextEvent;\n    createEvent(eventInterface: "TouchEvent"): TouchEvent;\n    createEvent(eventInterface: "TrackEvent"): TrackEvent;\n    createEvent(eventInterface: "TransitionEvent"): TransitionEvent;\n    createEvent(eventInterface: "UIEvent"): UIEvent;\n    createEvent(eventInterface: "UIEvents"): UIEvent;\n    createEvent(eventInterface: "VRDisplayEvent"): VRDisplayEvent;\n    createEvent(eventInterface: "VRDisplayEvent "): VRDisplayEvent ;\n    createEvent(eventInterface: "WebGLContextEvent"): WebGLContextEvent;\n    createEvent(eventInterface: "WheelEvent"): WheelEvent;\n    createEvent(eventInterface: string): Event;\n}\n\n/** A minimal document object that has no parent. It is used as a lightweight version of Document that stores a segment of a document structure comprised of nodes just like a standard document. The key difference is that because the document fragment isn\'t part of the active document tree structure, changes made to the fragment don\'t affect the document, cause reflow, or incur any performance impact that can occur when changes are made. */\ninterface DocumentFragment extends Node, NonElementParentNode, ParentNode {\n    getElementById(elementId: string): HTMLElement | null;\n}\n\ndeclare var DocumentFragment: {\n    prototype: DocumentFragment;\n    new(): DocumentFragment;\n};\n\ninterface DocumentOrShadowRoot {\n    readonly activeElement: Element | null;\n    readonly fullscreenElement: Element | null;\n    readonly pointerLockElement: Element | null;\n    /**\n     * Retrieves a collection of styleSheet objects representing the style sheets that correspond to each instance of a link or style object in the document.\n     */\n    readonly styleSheets: StyleSheetList;\n    caretPositionFromPoint(x: number, y: number): CaretPosition | null;\n    /** @deprecated */\n    caretRangeFromPoint(x: number, y: number): Range;\n    elementFromPoint(x: number, y: number): Element | null;\n    elementsFromPoint(x: number, y: number): Element[];\n    getSelection(): Selection | null;\n}\n\ninterface DocumentTimeline extends AnimationTimeline {\n}\n\ndeclare var DocumentTimeline: {\n    prototype: DocumentTimeline;\n    new(options?: DocumentTimelineOptions): DocumentTimeline;\n};\n\n/** A Node containing a doctype. */\ninterface DocumentType extends Node, ChildNode {\n    readonly name: string;\n    readonly publicId: string;\n    readonly systemId: string;\n}\n\ndeclare var DocumentType: {\n    prototype: DocumentType;\n    new(): DocumentType;\n};\n\n/** A DOM event that represents a drag and drop interaction. The user initiates a drag by placing a pointer device (such as a mouse) on the touch surface and then dragging the pointer to a new location (such as another DOM element). Applications are free to interpret a drag and drop interaction in an application-specific way. */\ninterface DragEvent extends MouseEvent {\n    /**\n     * Returns the DataTransfer object for the event.\n     */\n    readonly dataTransfer: DataTransfer | null;\n}\n\ndeclare var DragEvent: {\n    prototype: DragEvent;\n    new(type: string, eventInitDict?: DragEventInit): DragEvent;\n};\n\n/** Inherits properties from its parent, AudioNode. */\ninterface DynamicsCompressorNode extends AudioNode {\n    readonly attack: AudioParam;\n    readonly knee: AudioParam;\n    readonly ratio: AudioParam;\n    readonly reduction: number;\n    readonly release: AudioParam;\n    readonly threshold: AudioParam;\n}\n\ndeclare var DynamicsCompressorNode: {\n    prototype: DynamicsCompressorNode;\n    new(context: BaseAudioContext, options?: DynamicsCompressorOptions): DynamicsCompressorNode;\n};\n\ninterface EXT_blend_minmax {\n    readonly MAX_EXT: GLenum;\n    readonly MIN_EXT: GLenum;\n}\n\n/** The EXT_frag_depth extension is part of the WebGL API and enables to set a depth value of a fragment from within the fragment shader. */\ninterface EXT_frag_depth {\n}\n\ninterface EXT_sRGB {\n    readonly FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT: GLenum;\n    readonly SRGB8_ALPHA8_EXT: GLenum;\n    readonly SRGB_ALPHA_EXT: GLenum;\n    readonly SRGB_EXT: GLenum;\n}\n\ninterface EXT_shader_texture_lod {\n}\n\n/** The EXT_texture_filter_anisotropic extension is part of the WebGL API and exposes two constants for anisotropic filtering (AF). */\ninterface EXT_texture_filter_anisotropic {\n    readonly MAX_TEXTURE_MAX_ANISOTROPY_EXT: GLenum;\n    readonly TEXTURE_MAX_ANISOTROPY_EXT: GLenum;\n}\n\ninterface ElementEventMap {\n    "fullscreenchange": Event;\n    "fullscreenerror": Event;\n}\n\n/** Element is the most general base class from which all objects in a Document inherit. It only has methods and properties common to all kinds of elements. More specific classes inherit from Element. */\ninterface Element extends Node, ParentNode, NonDocumentTypeChildNode, ChildNode, Slotable, InnerHTML, Animatable {\n    readonly assignedSlot: HTMLSlotElement | null;\n    readonly attributes: NamedNodeMap;\n    /**\n     * Allows for manipulation of element\'s class content attribute as a\n     * set of whitespace-separated tokens through a DOMTokenList object.\n     */\n    readonly classList: DOMTokenList;\n    /**\n     * Returns the value of element\'s class content attribute. Can be set\n     * to change it.\n     */\n    className: string;\n    readonly clientHeight: number;\n    readonly clientLeft: number;\n    readonly clientTop: number;\n    readonly clientWidth: number;\n    /**\n     * Returns the value of element\'s id content attribute. Can be set to\n     * change it.\n     */\n    id: string;\n    /**\n     * Returns the local name.\n     */\n    readonly localName: string;\n    /**\n     * Returns the namespace.\n     */\n    readonly namespaceURI: string | null;\n    onfullscreenchange: ((this: Element, ev: Event) => any) | null;\n    onfullscreenerror: ((this: Element, ev: Event) => any) | null;\n    outerHTML: string;\n    /**\n     * Returns the namespace prefix.\n     */\n    readonly prefix: string | null;\n    readonly scrollHeight: number;\n    scrollLeft: number;\n    scrollTop: number;\n    readonly scrollWidth: number;\n    /**\n     * Returns element\'s shadow root, if any, and if shadow root\'s mode is "open", and null otherwise.\n     */\n    readonly shadowRoot: ShadowRoot | null;\n    /**\n     * Returns the value of element\'s slot content attribute. Can be set to\n     * change it.\n     */\n    slot: string;\n    /**\n     * Returns the HTML-uppercased qualified name.\n     */\n    readonly tagName: string;\n    /**\n     * Creates a shadow root for element and returns it.\n     */\n    attachShadow(init: ShadowRootInit): ShadowRoot;\n    /**\n     * Returns the first (starting at element) inclusive ancestor that matches selectors, and null otherwise.\n     */\n    closest<K extends keyof HTMLElementTagNameMap>(selector: K): HTMLElementTagNameMap[K] | null;\n    closest<K extends keyof SVGElementTagNameMap>(selector: K): SVGElementTagNameMap[K] | null;\n    closest(selector: string): Element | null;\n    /**\n     * Returns element\'s first attribute whose qualified name is qualifiedName, and null if there is no such attribute otherwise.\n     */\n    getAttribute(qualifiedName: string): string | null;\n    /**\n     * Returns element\'s attribute whose namespace is namespace and local name is localName, and null if there is\n     * no such attribute otherwise.\n     */\n    getAttributeNS(namespace: string | null, localName: string): string | null;\n    /**\n     * Returns the qualified names of all element\'s attributes.\n     * Can contain duplicates.\n     */\n    getAttributeNames(): string[];\n    getAttributeNode(name: string): Attr | null;\n    getAttributeNodeNS(namespaceURI: string, localName: string): Attr | null;\n    getBoundingClientRect(): ClientRect | DOMRect;\n    getClientRects(): ClientRectList | DOMRectList;\n    getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;\n    getElementsByTagName<K extends keyof HTMLElementTagNameMap>(qualifiedName: K): HTMLCollectionOf<HTMLElementTagNameMap[K]>;\n    getElementsByTagName<K extends keyof SVGElementTagNameMap>(qualifiedName: K): HTMLCollectionOf<SVGElementTagNameMap[K]>;\n    getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;\n    getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;\n    getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;\n    getElementsByTagNameNS(namespaceURI: string, localName: string): HTMLCollectionOf<Element>;\n    /**\n     * Returns true if element has an attribute whose qualified name is qualifiedName, and false otherwise.\n     */\n    hasAttribute(qualifiedName: string): boolean;\n    /**\n     * Returns true if element has an attribute whose namespace is namespace and local name is localName.\n     */\n    hasAttributeNS(namespace: string | null, localName: string): boolean;\n    /**\n     * Returns true if element has attributes, and false otherwise.\n     */\n    hasAttributes(): boolean;\n    hasPointerCapture(pointerId: number): boolean;\n    insertAdjacentElement(position: InsertPosition, insertedElement: Element): Element | null;\n    insertAdjacentHTML(where: InsertPosition, html: string): void;\n    insertAdjacentText(where: InsertPosition, text: string): void;\n    /**\n     * Returns true if matching selectors against element\'s root yields element, and false otherwise.\n     */\n    matches(selectors: string): boolean;\n    msGetRegionContent(): any;\n    releasePointerCapture(pointerId: number): void;\n    /**\n     * Removes element\'s first attribute whose qualified name is qualifiedName.\n     */\n    removeAttribute(qualifiedName: string): void;\n    /**\n     * Removes element\'s attribute whose namespace is namespace and local name is localName.\n     */\n    removeAttributeNS(namespace: string | null, localName: string): void;\n    removeAttributeNode(attr: Attr): Attr;\n    /**\n     * Displays element fullscreen and resolves promise when done.\n     * When supplied, options\'s navigationUI member indicates whether showing\n     * navigation UI while in fullscreen is preferred or not. If set to "show", navigation\n     * simplicity is preferred over screen space, and if set to "hide", more screen space\n     * is preferred. User agents are always free to honor user preference over the application\'s. The\n     * default value "auto" indicates no application preference.\n     */\n    requestFullscreen(options?: FullscreenOptions): Promise<void>;\n    requestPointerLock(): void;\n    scroll(options?: ScrollToOptions): void;\n    scroll(x: number, y: number): void;\n    scrollBy(options?: ScrollToOptions): void;\n    scrollBy(x: number, y: number): void;\n    scrollIntoView(arg?: boolean | ScrollIntoViewOptions): void;\n    scrollTo(options?: ScrollToOptions): void;\n    scrollTo(x: number, y: number): void;\n    /**\n     * Sets the value of element\'s first attribute whose qualified name is qualifiedName to value.\n     */\n    setAttribute(qualifiedName: string, value: string): void;\n    /**\n     * Sets the value of element\'s attribute whose namespace is namespace and local name is localName to value.\n     */\n    setAttributeNS(namespace: string | null, qualifiedName: string, value: string): void;\n    setAttributeNode(attr: Attr): Attr | null;\n    setAttributeNodeNS(attr: Attr): Attr | null;\n    setPointerCapture(pointerId: number): void;\n    /**\n     * If force is not given, "toggles" qualifiedName, removing it if it is\n     * present and adding it if it is not present. If force is true, adds qualifiedName. If force is false, removes qualifiedName.\n     * Returns true if qualifiedName is now present, and false otherwise.\n     */\n    toggleAttribute(qualifiedName: string, force?: boolean): boolean;\n    webkitMatchesSelector(selectors: string): boolean;\n    addEventListener<K extends keyof ElementEventMap>(type: K, listener: (this: Element, ev: ElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof ElementEventMap>(type: K, listener: (this: Element, ev: ElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var Element: {\n    prototype: Element;\n    new(): Element;\n};\n\ninterface ElementCSSInlineStyle {\n    readonly style: CSSStyleDeclaration;\n}\n\ninterface ElementContentEditable {\n    contentEditable: string;\n    inputMode: string;\n    readonly isContentEditable: boolean;\n}\n\n/** Events providing information related to errors in scripts or in files. */\ninterface ErrorEvent extends Event {\n    readonly colno: number;\n    readonly error: any;\n    readonly filename: string;\n    readonly lineno: number;\n    readonly message: string;\n}\n\ndeclare var ErrorEvent: {\n    prototype: ErrorEvent;\n    new(type: string, eventInitDict?: ErrorEventInit): ErrorEvent;\n};\n\n/** An event which takes place in the DOM. */\ninterface Event {\n    /**\n     * Returns true or false depending on how event was initialized. True if event goes through its target\'s ancestors in reverse tree order, and false otherwise.\n     */\n    readonly bubbles: boolean;\n    cancelBubble: boolean;\n    readonly cancelable: boolean;\n    /**\n     * Returns true or false depending on how event was initialized. True if event invokes listeners past a ShadowRoot node that is the root of its target, and false otherwise.\n     */\n    readonly composed: boolean;\n    /**\n     * Returns the object whose event listener\'s callback is currently being\n     * invoked.\n     */\n    readonly currentTarget: EventTarget | null;\n    readonly defaultPrevented: boolean;\n    readonly eventPhase: number;\n    /**\n     * Returns true if event was dispatched by the user agent, and\n     * false otherwise.\n     */\n    readonly isTrusted: boolean;\n    returnValue: boolean;\n    /** @deprecated */\n    readonly srcElement: EventTarget | null;\n    /**\n     * Returns the object to which event is dispatched (its target).\n     */\n    readonly target: EventTarget | null;\n    /**\n     * Returns the event\'s timestamp as the number of milliseconds measured relative to\n     * the time origin.\n     */\n    readonly timeStamp: number;\n    /**\n     * Returns the type of event, e.g.\n     * "click", "hashchange", or\n     * "submit".\n     */\n    readonly type: string;\n    composedPath(): EventTarget[];\n    initEvent(type: string, bubbles?: boolean, cancelable?: boolean): void;\n    preventDefault(): void;\n    /**\n     * Invoking this method prevents event from reaching\n     * any registered event listeners after the current one finishes running and, when dispatched in a tree, also prevents event from reaching any\n     * other objects.\n     */\n    stopImmediatePropagation(): void;\n    /**\n     * When dispatched in a tree, invoking this method prevents event from reaching any objects other than the current object.\n     */\n    stopPropagation(): void;\n    readonly AT_TARGET: number;\n    readonly BUBBLING_PHASE: number;\n    readonly CAPTURING_PHASE: number;\n    readonly NONE: number;\n}\n\ndeclare var Event: {\n    prototype: Event;\n    new(type: string, eventInitDict?: EventInit): Event;\n    readonly AT_TARGET: number;\n    readonly BUBBLING_PHASE: number;\n    readonly CAPTURING_PHASE: number;\n    readonly NONE: number;\n};\n\ninterface EventListenerObject {\n    handleEvent(evt: Event): void;\n}\n\ninterface EventSourceEventMap {\n    "error": Event;\n    "message": MessageEvent;\n    "open": Event;\n}\n\ninterface EventSource extends EventTarget {\n    onerror: ((this: EventSource, ev: Event) => any) | null;\n    onmessage: ((this: EventSource, ev: MessageEvent) => any) | null;\n    onopen: ((this: EventSource, ev: Event) => any) | null;\n    /**\n     * Returns the state of this EventSource object\'s connection. It can have the\n     * values described below.\n     */\n    readonly readyState: number;\n    /**\n     * Returns the URL providing the event stream.\n     */\n    readonly url: string;\n    /**\n     * Returns true if the credentials mode\n     * for connection requests to the URL providing the\n     * event stream is set to "include", and false otherwise.\n     */\n    readonly withCredentials: boolean;\n    close(): void;\n    readonly CLOSED: number;\n    readonly CONNECTING: number;\n    readonly OPEN: number;\n    addEventListener<K extends keyof EventSourceEventMap>(type: K, listener: (this: EventSource, ev: EventSourceEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof EventSourceEventMap>(type: K, listener: (this: EventSource, ev: EventSourceEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var EventSource: {\n    prototype: EventSource;\n    new(url: string, eventSourceInitDict?: EventSourceInit): EventSource;\n    readonly CLOSED: number;\n    readonly CONNECTING: number;\n    readonly OPEN: number;\n};\n\n/** EventTarget is a DOM interface implemented by objects that can receive events and may have listeners for them. */\ninterface EventTarget {\n    /**\n     * Appends an event listener for events whose type attribute value is type. The callback argument sets the callback that will be invoked when the event is dispatched.\n     * The options argument sets listener-specific options. For compatibility this can be a\n     * boolean, in which case the method behaves exactly as if the value was specified as options\'s capture.\n     * When set to true, options\'s capture prevents callback from being invoked when the event\'s eventPhase attribute value is BUBBLING_PHASE. When false (or not present), callback will not be invoked when event\'s eventPhase attribute value is CAPTURING_PHASE. Either way, callback will be invoked if event\'s eventPhase attribute value is AT_TARGET.\n     * When set to true, options\'s passive indicates that the callback will not cancel the event by invoking preventDefault(). This is used to enable performance optimizations described in §2.8 Observing event listeners.\n     * When set to true, options\'s once indicates that the callback will only be invoked once after which the event listener will\n     * be removed.\n     * The event listener is appended to target\'s event listener list and is not appended if it has the same type, callback, and capture.\n     */\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject | null, options?: boolean | AddEventListenerOptions): void;\n    /**\n     * Dispatches a synthetic event event to target and returns true\n     * if either event\'s cancelable attribute value is false or its preventDefault() method was not invoked, and false otherwise.\n     */\n    dispatchEvent(event: Event): boolean;\n    /**\n     * Removes the event listener in target\'s event listener list with the same type, callback, and options.\n     */\n    removeEventListener(type: string, callback: EventListenerOrEventListenerObject | null, options?: EventListenerOptions | boolean): void;\n}\n\ndeclare var EventTarget: {\n    prototype: EventTarget;\n    new(): EventTarget;\n};\n\ninterface ExtensionScriptApis {\n    extensionIdToShortId(extensionId: string): number;\n    fireExtensionApiTelemetry(functionName: string, isSucceeded: boolean, isSupported: boolean, errorString: string): void;\n    genericFunction(routerAddress: any, parameters?: string, callbackId?: number): void;\n    genericSynchronousFunction(functionId: number, parameters?: string): string;\n    genericWebRuntimeCallout(to: any, from: any, payload: string): void;\n    getExtensionId(): string;\n    registerGenericFunctionCallbackHandler(callbackHandler: Function): void;\n    registerGenericPersistentCallbackHandler(callbackHandler: Function): void;\n    registerWebRuntimeCallbackHandler(handler: Function): any;\n}\n\ndeclare var ExtensionScriptApis: {\n    prototype: ExtensionScriptApis;\n    new(): ExtensionScriptApis;\n};\n\ninterface External {\n    /** @deprecated */\n    AddSearchProvider(): void;\n    /** @deprecated */\n    IsSearchProviderInstalled(): void;\n}\n\n/** Provides information about files and allows JavaScript in a web page to access their content. */\ninterface File extends Blob {\n    readonly lastModified: number;\n    readonly name: string;\n}\n\ndeclare var File: {\n    prototype: File;\n    new(fileBits: BlobPart[], fileName: string, options?: FilePropertyBag): File;\n};\n\n/** An object of this type is returned by the files property of the HTML <input> element; this lets you access the list of files selected with the <input type="file"> element. It\'s also used for a list of files dropped into web content when using the drag and drop API; see the DataTransfer object for details on this usage. */\ninterface FileList {\n    readonly length: number;\n    item(index: number): File | null;\n    [index: number]: File;\n}\n\ndeclare var FileList: {\n    prototype: FileList;\n    new(): FileList;\n};\n\ninterface FileReaderEventMap {\n    "abort": ProgressEvent;\n    "error": ProgressEvent;\n    "load": ProgressEvent;\n    "loadend": ProgressEvent;\n    "loadstart": ProgressEvent;\n    "progress": ProgressEvent;\n}\n\n/** Lets web applications asynchronously read the contents of files (or raw data buffers) stored on the user\'s computer, using File or Blob objects to specify the file or data to read. */\ninterface FileReader extends EventTarget {\n    readonly error: DOMException | null;\n    onabort: ((this: FileReader, ev: ProgressEvent) => any) | null;\n    onerror: ((this: FileReader, ev: ProgressEvent) => any) | null;\n    onload: ((this: FileReader, ev: ProgressEvent) => any) | null;\n    onloadend: ((this: FileReader, ev: ProgressEvent) => any) | null;\n    onloadstart: ((this: FileReader, ev: ProgressEvent) => any) | null;\n    onprogress: ((this: FileReader, ev: ProgressEvent) => any) | null;\n    readonly readyState: number;\n    readonly result: string | ArrayBuffer | null;\n    abort(): void;\n    readAsArrayBuffer(blob: Blob): void;\n    readAsBinaryString(blob: Blob): void;\n    readAsDataURL(blob: Blob): void;\n    readAsText(blob: Blob, encoding?: string): void;\n    readonly DONE: number;\n    readonly EMPTY: number;\n    readonly LOADING: number;\n    addEventListener<K extends keyof FileReaderEventMap>(type: K, listener: (this: FileReader, ev: FileReaderEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof FileReaderEventMap>(type: K, listener: (this: FileReader, ev: FileReaderEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var FileReader: {\n    prototype: FileReader;\n    new(): FileReader;\n    readonly DONE: number;\n    readonly EMPTY: number;\n    readonly LOADING: number;\n};\n\n/** Focus-related events like focus, blur, focusin, or focusout. */\ninterface FocusEvent extends UIEvent {\n    readonly relatedTarget: EventTarget;\n    initFocusEvent(typeArg: string, canBubbleArg: boolean, cancelableArg: boolean, viewArg: Window, detailArg: number, relatedTargetArg: EventTarget): void;\n}\n\ndeclare var FocusEvent: {\n    prototype: FocusEvent;\n    new(typeArg: string, eventInitDict?: FocusEventInit): FocusEvent;\n};\n\ninterface FocusNavigationEvent extends Event {\n    readonly navigationReason: NavigationReason;\n    readonly originHeight: number;\n    readonly originLeft: number;\n    readonly originTop: number;\n    readonly originWidth: number;\n    requestFocus(): void;\n}\n\ndeclare var FocusNavigationEvent: {\n    prototype: FocusNavigationEvent;\n    new(type: string, eventInitDict?: FocusNavigationEventInit): FocusNavigationEvent;\n};\n\n/** Provides a way to easily construct a set of key/value pairs representing form fields and their values, which can then be easily sent using the XMLHttpRequest.send() method. It uses the same format a form would use if the encoding type were set to "multipart/form-data". */\ninterface FormData {\n    append(name: string, value: string | Blob, fileName?: string): void;\n    delete(name: string): void;\n    get(name: string): FormDataEntryValue | null;\n    getAll(name: string): FormDataEntryValue[];\n    has(name: string): boolean;\n    set(name: string, value: string | Blob, fileName?: string): void;\n    forEach(callbackfn: (value: FormDataEntryValue, key: string, parent: FormData) => void, thisArg?: any): void;\n}\n\ndeclare var FormData: {\n    prototype: FormData;\n    new(form?: HTMLFormElement): FormData;\n};\n\n/** A change in volume. It is an AudioNode audio-processing module that causes a given gain to be applied to the input data before its propagation to the output. A GainNode always has exactly one input and one output, both with the same number of channels. */\ninterface GainNode extends AudioNode {\n    readonly gain: AudioParam;\n}\n\ndeclare var GainNode: {\n    prototype: GainNode;\n    new(context: BaseAudioContext, options?: GainOptions): GainNode;\n};\n\n/** An interface of the Gamepad API defines an individual gamepad or other controller, allowing access to information such as button presses, axis positions, and id. */\ninterface Gamepad {\n    readonly axes: ReadonlyArray<number>;\n    readonly buttons: ReadonlyArray<GamepadButton>;\n    readonly connected: boolean;\n    readonly hand: GamepadHand;\n    readonly hapticActuators: ReadonlyArray<GamepadHapticActuator>;\n    readonly id: string;\n    readonly index: number;\n    readonly mapping: GamepadMappingType;\n    readonly pose: GamepadPose | null;\n    readonly timestamp: number;\n}\n\ndeclare var Gamepad: {\n    prototype: Gamepad;\n    new(): Gamepad;\n};\n\n/** An individual button of a gamepad or other controller, allowing access to the current state of different types of buttons available on the control device. */\ninterface GamepadButton {\n    readonly pressed: boolean;\n    readonly touched: boolean;\n    readonly value: number;\n}\n\ndeclare var GamepadButton: {\n    prototype: GamepadButton;\n    new(): GamepadButton;\n};\n\n/** An interface of the Gamepad API contains references to gamepads connected to the system, which is what the gamepad events Window.gamepadconnected and Window.gamepaddisconnected are fired in response to. */\ninterface GamepadEvent extends Event {\n    readonly gamepad: Gamepad;\n}\n\ndeclare var GamepadEvent: {\n    prototype: GamepadEvent;\n    new(type: string, eventInitDict: GamepadEventInit): GamepadEvent;\n};\n\n/** An interface of the Gamepad API represents hardware in the controller designed to provide haptic feedback to the user (if available), most commonly vibration hardware. */\ninterface GamepadHapticActuator {\n    readonly type: GamepadHapticActuatorType;\n    pulse(value: number, duration: number): Promise<boolean>;\n}\n\ndeclare var GamepadHapticActuator: {\n    prototype: GamepadHapticActuator;\n    new(): GamepadHapticActuator;\n};\n\n/** An interface of the Gamepad API represents the pose of a WebVR controller at a given timestamp (which includes orientation, position, velocity, and acceleration information.) */\ninterface GamepadPose {\n    readonly angularAcceleration: Float32Array | null;\n    readonly angularVelocity: Float32Array | null;\n    readonly hasOrientation: boolean;\n    readonly hasPosition: boolean;\n    readonly linearAcceleration: Float32Array | null;\n    readonly linearVelocity: Float32Array | null;\n    readonly orientation: Float32Array | null;\n    readonly position: Float32Array | null;\n}\n\ndeclare var GamepadPose: {\n    prototype: GamepadPose;\n    new(): GamepadPose;\n};\n\ninterface GenericTransformStream {\n    readonly readable: ReadableStream;\n    /**\n     * Returns a writable stream which accepts string chunks and runs them through UTF-8\'s encoder before making them available to readable.\n     * Typically this will be used via the pipeThrough() method on a ReadableStream source.\n     * textReadable\n     * .pipeThrough(new TextEncoderStream())\n     * .pipeTo(byteWritable);\n     */\n    readonly writable: WritableStream;\n}\n\n/** An object able to programmatically obtain the position of the device. It gives Web content access to the location of the device. This allows a Web site or app to offer customized results based on the user\'s location. */\ninterface Geolocation {\n    clearWatch(watchId: number): void;\n    getCurrentPosition(successCallback: PositionCallback, errorCallback?: PositionErrorCallback, options?: PositionOptions): void;\n    watchPosition(successCallback: PositionCallback, errorCallback?: PositionErrorCallback, options?: PositionOptions): number;\n}\n\ninterface GlobalEventHandlersEventMap {\n    "abort": UIEvent;\n    "animationcancel": AnimationEvent;\n    "animationend": AnimationEvent;\n    "animationiteration": AnimationEvent;\n    "animationstart": AnimationEvent;\n    "auxclick": MouseEvent;\n    "blur": FocusEvent;\n    "cancel": Event;\n    "canplay": Event;\n    "canplaythrough": Event;\n    "change": Event;\n    "click": MouseEvent;\n    "close": Event;\n    "contextmenu": MouseEvent;\n    "cuechange": Event;\n    "dblclick": MouseEvent;\n    "drag": DragEvent;\n    "dragend": DragEvent;\n    "dragenter": DragEvent;\n    "dragexit": Event;\n    "dragleave": DragEvent;\n    "dragover": DragEvent;\n    "dragstart": DragEvent;\n    "drop": DragEvent;\n    "durationchange": Event;\n    "emptied": Event;\n    "ended": Event;\n    "error": ErrorEvent;\n    "focus": FocusEvent;\n    "gotpointercapture": PointerEvent;\n    "input": Event;\n    "invalid": Event;\n    "keydown": KeyboardEvent;\n    "keypress": KeyboardEvent;\n    "keyup": KeyboardEvent;\n    "load": Event;\n    "loadeddata": Event;\n    "loadedmetadata": Event;\n    "loadend": ProgressEvent;\n    "loadstart": Event;\n    "lostpointercapture": PointerEvent;\n    "mousedown": MouseEvent;\n    "mouseenter": MouseEvent;\n    "mouseleave": MouseEvent;\n    "mousemove": MouseEvent;\n    "mouseout": MouseEvent;\n    "mouseover": MouseEvent;\n    "mouseup": MouseEvent;\n    "pause": Event;\n    "play": Event;\n    "playing": Event;\n    "pointercancel": PointerEvent;\n    "pointerdown": PointerEvent;\n    "pointerenter": PointerEvent;\n    "pointerleave": PointerEvent;\n    "pointermove": PointerEvent;\n    "pointerout": PointerEvent;\n    "pointerover": PointerEvent;\n    "pointerup": PointerEvent;\n    "progress": ProgressEvent;\n    "ratechange": Event;\n    "reset": Event;\n    "resize": UIEvent;\n    "scroll": Event;\n    "securitypolicyviolation": SecurityPolicyViolationEvent;\n    "seeked": Event;\n    "seeking": Event;\n    "select": Event;\n    "selectionchange": Event;\n    "selectstart": Event;\n    "stalled": Event;\n    "submit": Event;\n    "suspend": Event;\n    "timeupdate": Event;\n    "toggle": Event;\n    "touchcancel": TouchEvent;\n    "touchend": TouchEvent;\n    "touchmove": TouchEvent;\n    "touchstart": TouchEvent;\n    "transitioncancel": TransitionEvent;\n    "transitionend": TransitionEvent;\n    "transitionrun": TransitionEvent;\n    "transitionstart": TransitionEvent;\n    "volumechange": Event;\n    "waiting": Event;\n    "wheel": WheelEvent;\n}\n\ninterface GlobalEventHandlers {\n    /**\n     * Fires when the user aborts the download.\n     * @param ev The event.\n     */\n    onabort: ((this: GlobalEventHandlers, ev: UIEvent) => any) | null;\n    onanimationcancel: ((this: GlobalEventHandlers, ev: AnimationEvent) => any) | null;\n    onanimationend: ((this: GlobalEventHandlers, ev: AnimationEvent) => any) | null;\n    onanimationiteration: ((this: GlobalEventHandlers, ev: AnimationEvent) => any) | null;\n    onanimationstart: ((this: GlobalEventHandlers, ev: AnimationEvent) => any) | null;\n    onauxclick: ((this: GlobalEventHandlers, ev: MouseEvent) => any) | null;\n    /**\n     * Fires when the object loses the input focus.\n     * @param ev The focus event.\n     */\n    onblur: ((this: GlobalEventHandlers, ev: FocusEvent) => any) | null;\n    oncancel: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Occurs when playback is possible, but would require further buffering.\n     * @param ev The event.\n     */\n    oncanplay: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    oncanplaythrough: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Fires when the contents of the object or selection have changed.\n     * @param ev The event.\n     */\n    onchange: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Fires when the user clicks the left mouse button on the object\n     * @param ev The mouse event.\n     */\n    onclick: ((this: GlobalEventHandlers, ev: MouseEvent) => any) | null;\n    onclose: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Fires when the user clicks the right mouse button in the client area, opening the context menu.\n     * @param ev The mouse event.\n     */\n    oncontextmenu: ((this: GlobalEventHandlers, ev: MouseEvent) => any) | null;\n    oncuechange: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Fires when the user double-clicks the object.\n     * @param ev The mouse event.\n     */\n    ondblclick: ((this: GlobalEventHandlers, ev: MouseEvent) => any) | null;\n    /**\n     * Fires on the source object continuously during a drag operation.\n     * @param ev The event.\n     */\n    ondrag: ((this: GlobalEventHandlers, ev: DragEvent) => any) | null;\n    /**\n     * Fires on the source object when the user releases the mouse at the close of a drag operation.\n     * @param ev The event.\n     */\n    ondragend: ((this: GlobalEventHandlers, ev: DragEvent) => any) | null;\n    /**\n     * Fires on the target element when the user drags the object to a valid drop target.\n     * @param ev The drag event.\n     */\n    ondragenter: ((this: GlobalEventHandlers, ev: DragEvent) => any) | null;\n    ondragexit: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Fires on the target object when the user moves the mouse out of a valid drop target during a drag operation.\n     * @param ev The drag event.\n     */\n    ondragleave: ((this: GlobalEventHandlers, ev: DragEvent) => any) | null;\n    /**\n     * Fires on the target element continuously while the user drags the object over a valid drop target.\n     * @param ev The event.\n     */\n    ondragover: ((this: GlobalEventHandlers, ev: DragEvent) => any) | null;\n    /**\n     * Fires on the source object when the user starts to drag a text selection or selected object.\n     * @param ev The event.\n     */\n    ondragstart: ((this: GlobalEventHandlers, ev: DragEvent) => any) | null;\n    ondrop: ((this: GlobalEventHandlers, ev: DragEvent) => any) | null;\n    /**\n     * Occurs when the duration attribute is updated.\n     * @param ev The event.\n     */\n    ondurationchange: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Occurs when the media element is reset to its initial state.\n     * @param ev The event.\n     */\n    onemptied: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Occurs when the end of playback is reached.\n     * @param ev The event\n     */\n    onended: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Fires when an error occurs during object loading.\n     * @param ev The event.\n     */\n    onerror: OnErrorEventHandler;\n    /**\n     * Fires when the object receives focus.\n     * @param ev The event.\n     */\n    onfocus: ((this: GlobalEventHandlers, ev: FocusEvent) => any) | null;\n    ongotpointercapture: ((this: GlobalEventHandlers, ev: PointerEvent) => any) | null;\n    oninput: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    oninvalid: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Fires when the user presses a key.\n     * @param ev The keyboard event\n     */\n    onkeydown: ((this: GlobalEventHandlers, ev: KeyboardEvent) => any) | null;\n    /**\n     * Fires when the user presses an alphanumeric key.\n     * @param ev The event.\n     */\n    onkeypress: ((this: GlobalEventHandlers, ev: KeyboardEvent) => any) | null;\n    /**\n     * Fires when the user releases a key.\n     * @param ev The keyboard event\n     */\n    onkeyup: ((this: GlobalEventHandlers, ev: KeyboardEvent) => any) | null;\n    /**\n     * Fires immediately after the browser loads the object.\n     * @param ev The event.\n     */\n    onload: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Occurs when media data is loaded at the current playback position.\n     * @param ev The event.\n     */\n    onloadeddata: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Occurs when the duration and dimensions of the media have been determined.\n     * @param ev The event.\n     */\n    onloadedmetadata: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    onloadend: ((this: GlobalEventHandlers, ev: ProgressEvent) => any) | null;\n    /**\n     * Occurs when Internet Explorer begins looking for media data.\n     * @param ev The event.\n     */\n    onloadstart: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    onlostpointercapture: ((this: GlobalEventHandlers, ev: PointerEvent) => any) | null;\n    /**\n     * Fires when the user clicks the object with either mouse button.\n     * @param ev The mouse event.\n     */\n    onmousedown: ((this: GlobalEventHandlers, ev: MouseEvent) => any) | null;\n    onmouseenter: ((this: GlobalEventHandlers, ev: MouseEvent) => any) | null;\n    onmouseleave: ((this: GlobalEventHandlers, ev: MouseEvent) => any) | null;\n    /**\n     * Fires when the user moves the mouse over the object.\n     * @param ev The mouse event.\n     */\n    onmousemove: ((this: GlobalEventHandlers, ev: MouseEvent) => any) | null;\n    /**\n     * Fires when the user moves the mouse pointer outside the boundaries of the object.\n     * @param ev The mouse event.\n     */\n    onmouseout: ((this: GlobalEventHandlers, ev: MouseEvent) => any) | null;\n    /**\n     * Fires when the user moves the mouse pointer into the object.\n     * @param ev The mouse event.\n     */\n    onmouseover: ((this: GlobalEventHandlers, ev: MouseEvent) => any) | null;\n    /**\n     * Fires when the user releases a mouse button while the mouse is over the object.\n     * @param ev The mouse event.\n     */\n    onmouseup: ((this: GlobalEventHandlers, ev: MouseEvent) => any) | null;\n    /**\n     * Occurs when playback is paused.\n     * @param ev The event.\n     */\n    onpause: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Occurs when the play method is requested.\n     * @param ev The event.\n     */\n    onplay: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Occurs when the audio or video has started playing.\n     * @param ev The event.\n     */\n    onplaying: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    onpointercancel: ((this: GlobalEventHandlers, ev: PointerEvent) => any) | null;\n    onpointerdown: ((this: GlobalEventHandlers, ev: PointerEvent) => any) | null;\n    onpointerenter: ((this: GlobalEventHandlers, ev: PointerEvent) => any) | null;\n    onpointerleave: ((this: GlobalEventHandlers, ev: PointerEvent) => any) | null;\n    onpointermove: ((this: GlobalEventHandlers, ev: PointerEvent) => any) | null;\n    onpointerout: ((this: GlobalEventHandlers, ev: PointerEvent) => any) | null;\n    onpointerover: ((this: GlobalEventHandlers, ev: PointerEvent) => any) | null;\n    onpointerup: ((this: GlobalEventHandlers, ev: PointerEvent) => any) | null;\n    /**\n     * Occurs to indicate progress while downloading media data.\n     * @param ev The event.\n     */\n    onprogress: ((this: GlobalEventHandlers, ev: ProgressEvent) => any) | null;\n    /**\n     * Occurs when the playback rate is increased or decreased.\n     * @param ev The event.\n     */\n    onratechange: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Fires when the user resets a form.\n     * @param ev The event.\n     */\n    onreset: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    onresize: ((this: GlobalEventHandlers, ev: UIEvent) => any) | null;\n    /**\n     * Fires when the user repositions the scroll box in the scroll bar on the object.\n     * @param ev The event.\n     */\n    onscroll: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    onsecuritypolicyviolation: ((this: GlobalEventHandlers, ev: SecurityPolicyViolationEvent) => any) | null;\n    /**\n     * Occurs when the seek operation ends.\n     * @param ev The event.\n     */\n    onseeked: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Occurs when the current playback position is moved.\n     * @param ev The event.\n     */\n    onseeking: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Fires when the current selection changes.\n     * @param ev The event.\n     */\n    onselect: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    onselectionchange: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    onselectstart: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Occurs when the download has stopped.\n     * @param ev The event.\n     */\n    onstalled: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    onsubmit: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Occurs if the load operation has been intentionally halted.\n     * @param ev The event.\n     */\n    onsuspend: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Occurs to indicate the current playback position.\n     * @param ev The event.\n     */\n    ontimeupdate: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    ontoggle: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    ontouchcancel: ((this: GlobalEventHandlers, ev: TouchEvent) => any) | null;\n    ontouchend: ((this: GlobalEventHandlers, ev: TouchEvent) => any) | null;\n    ontouchmove: ((this: GlobalEventHandlers, ev: TouchEvent) => any) | null;\n    ontouchstart: ((this: GlobalEventHandlers, ev: TouchEvent) => any) | null;\n    ontransitioncancel: ((this: GlobalEventHandlers, ev: TransitionEvent) => any) | null;\n    ontransitionend: ((this: GlobalEventHandlers, ev: TransitionEvent) => any) | null;\n    ontransitionrun: ((this: GlobalEventHandlers, ev: TransitionEvent) => any) | null;\n    ontransitionstart: ((this: GlobalEventHandlers, ev: TransitionEvent) => any) | null;\n    /**\n     * Occurs when the volume is changed, or playback is muted or unmuted.\n     * @param ev The event.\n     */\n    onvolumechange: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    /**\n     * Occurs when playback stops because the next frame of a video resource is not available.\n     * @param ev The event.\n     */\n    onwaiting: ((this: GlobalEventHandlers, ev: Event) => any) | null;\n    onwheel: ((this: GlobalEventHandlers, ev: WheelEvent) => any) | null;\n    addEventListener<K extends keyof GlobalEventHandlersEventMap>(type: K, listener: (this: GlobalEventHandlers, ev: GlobalEventHandlersEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof GlobalEventHandlersEventMap>(type: K, listener: (this: GlobalEventHandlers, ev: GlobalEventHandlersEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ninterface GlobalFetch {\n    fetch(input: RequestInfo, init?: RequestInit): Promise<Response>;\n}\n\ninterface HTMLAllCollection {\n    /**\n     * Returns the number of elements in the collection.\n     */\n    readonly length: number;\n    /**\n     * element = collection(index)\n     */\n    item(nameOrIndex?: string): HTMLCollection | Element | null;\n    /**\n     * element = collection(name)\n     */\n    namedItem(name: string): HTMLCollection | Element | null;\n    [index: number]: Element;\n}\n\ndeclare var HTMLAllCollection: {\n    prototype: HTMLAllCollection;\n    new(): HTMLAllCollection;\n};\n\n/** Hyperlink elements and provides special properties and methods (beyond those of the regular HTMLElement object interface that they inherit from) for manipulating the layout and presentation of such elements. */\ninterface HTMLAnchorElement extends HTMLElement, HTMLHyperlinkElementUtils {\n    /**\n     * Sets or retrieves the character set used to encode the object.\n     */\n    /** @deprecated */\n    charset: string;\n    /**\n     * Sets or retrieves the coordinates of the object.\n     */\n    /** @deprecated */\n    coords: string;\n    download: string;\n    /**\n     * Sets or retrieves the language code of the object.\n     */\n    hreflang: string;\n    /**\n     * Sets or retrieves the shape of the object.\n     */\n    /** @deprecated */\n    name: string;\n    ping: string;\n    referrerPolicy: string;\n    /**\n     * Sets or retrieves the relationship between the object and the destination of the link.\n     */\n    rel: string;\n    readonly relList: DOMTokenList;\n    /**\n     * Sets or retrieves the relationship between the object and the destination of the link.\n     */\n    /** @deprecated */\n    rev: string;\n    /**\n     * Sets or retrieves the shape of the object.\n     */\n    /** @deprecated */\n    shape: string;\n    /**\n     * Sets or retrieves the window or frame at which to target content.\n     */\n    target: string;\n    /**\n     * Retrieves or sets the text of the object as a string.\n     */\n    text: string;\n    type: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLAnchorElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLAnchorElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLAnchorElement: {\n    prototype: HTMLAnchorElement;\n    new(): HTMLAnchorElement;\n};\n\ninterface HTMLAppletElement extends HTMLElement {\n    /** @deprecated */\n    align: string;\n    /**\n     * Sets or retrieves a text alternative to the graphic.\n     */\n    /** @deprecated */\n    alt: string;\n    /**\n     * Sets or retrieves a character string that can be used to implement your own archive functionality for the object.\n     */\n    /** @deprecated */\n    archive: string;\n    /** @deprecated */\n    code: string;\n    /**\n     * Sets or retrieves the URL of the component.\n     */\n    /** @deprecated */\n    codeBase: string;\n    readonly form: HTMLFormElement | null;\n    /**\n     * Sets or retrieves the height of the object.\n     */\n    /** @deprecated */\n    height: string;\n    /** @deprecated */\n    hspace: number;\n    /**\n     * Sets or retrieves the shape of the object.\n     */\n    /** @deprecated */\n    name: string;\n    /** @deprecated */\n    object: string;\n    /** @deprecated */\n    vspace: number;\n    /** @deprecated */\n    width: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLAppletElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLAppletElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLAppletElement: {\n    prototype: HTMLAppletElement;\n    new(): HTMLAppletElement;\n};\n\n/** Provides special properties and methods (beyond those of the regular object HTMLElement interface it also has available to it by inheritance) for manipulating the layout and presentation of <area> elements. */\ninterface HTMLAreaElement extends HTMLElement, HTMLHyperlinkElementUtils {\n    /**\n     * Sets or retrieves a text alternative to the graphic.\n     */\n    alt: string;\n    /**\n     * Sets or retrieves the coordinates of the object.\n     */\n    coords: string;\n    download: string;\n    /**\n     * Sets or gets whether clicks in this region cause action.\n     */\n    /** @deprecated */\n    noHref: boolean;\n    ping: string;\n    referrerPolicy: string;\n    rel: string;\n    readonly relList: DOMTokenList;\n    /**\n     * Sets or retrieves the shape of the object.\n     */\n    shape: string;\n    /**\n     * Sets or retrieves the window or frame at which to target content.\n     */\n    target: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLAreaElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLAreaElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLAreaElement: {\n    prototype: HTMLAreaElement;\n    new(): HTMLAreaElement;\n};\n\n/** Provides access to the properties of <audio> elements, as well as methods to manipulate them. It derives from the HTMLMediaElement interface. */\ninterface HTMLAudioElement extends HTMLMediaElement {\n    addEventListener<K extends keyof HTMLMediaElementEventMap>(type: K, listener: (this: HTMLAudioElement, ev: HTMLMediaElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLMediaElementEventMap>(type: K, listener: (this: HTMLAudioElement, ev: HTMLMediaElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLAudioElement: {\n    prototype: HTMLAudioElement;\n    new(): HTMLAudioElement;\n};\n\n/** A HTML line break element (<br>). It inherits from HTMLElement. */\ninterface HTMLBRElement extends HTMLElement {\n    /**\n     * Sets or retrieves the side on which floating objects are not to be positioned when any IHTMLBlockElement is inserted into the document.\n     */\n    /** @deprecated */\n    clear: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLBRElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLBRElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLBRElement: {\n    prototype: HTMLBRElement;\n    new(): HTMLBRElement;\n};\n\n/** Contains the base URI for a document. This object inherits all of the properties and methods as described in the HTMLElement interface. */\ninterface HTMLBaseElement extends HTMLElement {\n    /**\n     * Gets or sets the baseline URL on which relative links are based.\n     */\n    href: string;\n    /**\n     * Sets or retrieves the window or frame at which to target content.\n     */\n    target: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLBaseElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLBaseElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLBaseElement: {\n    prototype: HTMLBaseElement;\n    new(): HTMLBaseElement;\n};\n\n/** Provides special properties (beyond the regular HTMLElement interface it also has available to it by inheritance) for manipulating <basefont> elements. */\ninterface HTMLBaseFontElement extends HTMLElement, DOML2DeprecatedColorProperty {\n    /**\n     * Sets or retrieves the current typeface family.\n     */\n    /** @deprecated */\n    face: string;\n    /**\n     * Sets or retrieves the font size of the object.\n     */\n    /** @deprecated */\n    size: number;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLBaseFontElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLBaseFontElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLBaseFontElement: {\n    prototype: HTMLBaseFontElement;\n    new(): HTMLBaseFontElement;\n};\n\ninterface HTMLBodyElementEventMap extends HTMLElementEventMap, WindowEventHandlersEventMap {\n    "orientationchange": Event;\n}\n\n/** Provides special properties (beyond those inherited from the regular HTMLElement interface) for manipulating <body> elements. */\ninterface HTMLBodyElement extends HTMLElement, WindowEventHandlers {\n    /** @deprecated */\n    aLink: string;\n    /** @deprecated */\n    background: string;\n    /** @deprecated */\n    bgColor: string;\n    bgProperties: string;\n    /** @deprecated */\n    link: string;\n    /** @deprecated */\n    noWrap: boolean;\n    /** @deprecated */\n    onorientationchange: ((this: HTMLBodyElement, ev: Event) => any) | null;\n    /** @deprecated */\n    text: string;\n    /** @deprecated */\n    vLink: string;\n    addEventListener<K extends keyof HTMLBodyElementEventMap>(type: K, listener: (this: HTMLBodyElement, ev: HTMLBodyElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLBodyElementEventMap>(type: K, listener: (this: HTMLBodyElement, ev: HTMLBodyElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLBodyElement: {\n    prototype: HTMLBodyElement;\n    new(): HTMLBodyElement;\n};\n\n/** Provides properties and methods (beyond the regular HTMLElement interface it also has available to it by inheritance) for manipulating <button> elements. */\ninterface HTMLButtonElement extends HTMLElement {\n    /**\n     * Provides a way to direct a user to a specific field when a document loads. This can provide both direction and convenience for a user, reducing the need to click or tab to a field when a page opens. This attribute is true when present on an element, and false when missing.\n     */\n    autofocus: boolean;\n    disabled: boolean;\n    /**\n     * Retrieves a reference to the form that the object is embedded in.\n     */\n    readonly form: HTMLFormElement | null;\n    /**\n     * Overrides the action attribute (where the data on a form is sent) on the parent form element.\n     */\n    formAction: string;\n    /**\n     * Used to override the encoding (formEnctype attribute) specified on the form element.\n     */\n    formEnctype: string;\n    /**\n     * Overrides the submit method attribute previously specified on a form element.\n     */\n    formMethod: string;\n    /**\n     * Overrides any validation or required attributes on a form or form elements to allow it to be submitted without validation. This can be used to create a "save draft"-type submit option.\n     */\n    formNoValidate: boolean;\n    /**\n     * Overrides the target attribute on a form element.\n     */\n    formTarget: string;\n    readonly labels: NodeListOf<HTMLLabelElement>;\n    /**\n     * Sets or retrieves the name of the object.\n     */\n    name: string;\n    /**\n     * Gets the classification and default behavior of the button.\n     */\n    type: string;\n    /**\n     * Returns the error message that would be displayed if the user submits the form, or an empty string if no error message. It also triggers the standard error message, such as "this is a required field". The result is that the user sees validation messages without actually submitting.\n     */\n    readonly validationMessage: string;\n    /**\n     * Returns a  ValidityState object that represents the validity states of an element.\n     */\n    readonly validity: ValidityState;\n    /**\n     * Sets or retrieves the default or selected value of the control.\n     */\n    value: string;\n    /**\n     * Returns whether an element will successfully validate based on forms validation rules and constraints.\n     */\n    readonly willValidate: boolean;\n    /**\n     * Returns whether a form will validate when it is submitted, without having to submit it.\n     */\n    checkValidity(): boolean;\n    reportValidity(): boolean;\n    /**\n     * Sets a custom error message that is displayed when a form is submitted.\n     * @param error Sets a custom error message that is displayed when a form is submitted.\n     */\n    setCustomValidity(error: string): void;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLButtonElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLButtonElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLButtonElement: {\n    prototype: HTMLButtonElement;\n    new(): HTMLButtonElement;\n};\n\n/** Provides properties and methods for manipulating the layout and presentation of <canvas> elements. The HTMLCanvasElement interface also inherits the properties and methods of the HTMLElement interface. */\ninterface HTMLCanvasElement extends HTMLElement {\n    /**\n     * Gets or sets the height of a canvas element on a document.\n     */\n    height: number;\n    /**\n     * Gets or sets the width of a canvas element on a document.\n     */\n    width: number;\n    /**\n     * Returns an object that provides methods and properties for drawing and manipulating images and graphics on a canvas element in a document. A context object includes information about colors, line widths, fonts, and other graphic parameters that can be drawn on a canvas.\n     * @param contextId The identifier (ID) of the type of canvas to create. Internet Explorer 9 and Internet Explorer 10 support only a 2-D context using canvas.getContext("2d"); IE11 Preview also supports 3-D or WebGL context using canvas.getContext("experimental-webgl");\n     */\n    getContext(contextId: "2d", contextAttributes?: CanvasRenderingContext2DSettings): CanvasRenderingContext2D | null;\n    getContext(contextId: "webgl" | "experimental-webgl", contextAttributes?: WebGLContextAttributes): WebGLRenderingContext | null;\n    getContext(contextId: string, contextAttributes?: {}): CanvasRenderingContext2D | WebGLRenderingContext | null;\n    toBlob(callback: BlobCallback, type?: string, quality?: any): void;\n    /**\n     * Returns the content of the current canvas as an image that you can use as a source for another canvas or an HTML element.\n     * @param type The standard MIME type for the image format to return. If you do not specify this parameter, the default value is a PNG format image.\n     */\n    toDataURL(type?: string, quality?: any): string;\n    transferControlToOffscreen(): OffscreenCanvas;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLCanvasElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLCanvasElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLCanvasElement: {\n    prototype: HTMLCanvasElement;\n    new(): HTMLCanvasElement;\n};\n\n/** A generic collection (array-like object similar to arguments) of elements (in document order) and offers methods and properties for selecting from the list. */\ninterface HTMLCollectionBase {\n    /**\n     * Sets or retrieves the number of objects in a collection.\n     */\n    readonly length: number;\n    /**\n     * Retrieves an object from various collections.\n     */\n    item(index: number): Element | null;\n    [index: number]: Element;\n}\n\ninterface HTMLCollection extends HTMLCollectionBase {\n    /**\n     * Retrieves a select object or an object from an options collection.\n     */\n    namedItem(name: string): Element | null;\n}\n\ndeclare var HTMLCollection: {\n    prototype: HTMLCollection;\n    new(): HTMLCollection;\n};\n\ninterface HTMLCollectionOf<T extends Element> extends HTMLCollectionBase {\n    item(index: number): T | null;\n    namedItem(name: string): T | null;\n    [index: number]: T;\n}\n\n/** Provides special properties (beyond those of the regular HTMLElement interface it also has available to it by inheritance) for manipulating definition list (<dl>) elements. */\ninterface HTMLDListElement extends HTMLElement {\n    /** @deprecated */\n    compact: boolean;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDListElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDListElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLDListElement: {\n    prototype: HTMLDListElement;\n    new(): HTMLDListElement;\n};\n\n/** Provides special properties (beyond the regular HTMLElement interface it also has available to it by inheritance) for manipulating <data> elements. */\ninterface HTMLDataElement extends HTMLElement {\n    value: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDataElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDataElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLDataElement: {\n    prototype: HTMLDataElement;\n    new(): HTMLDataElement;\n};\n\n/** Provides special properties (beyond the HTMLElement object interface it also has available to it by inheritance) to manipulate <datalist> elements and their content. */\ninterface HTMLDataListElement extends HTMLElement {\n    readonly options: HTMLCollectionOf<HTMLOptionElement>;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDataListElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDataListElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLDataListElement: {\n    prototype: HTMLDataListElement;\n    new(): HTMLDataListElement;\n};\n\ninterface HTMLDetailsElement extends HTMLElement {\n    open: boolean;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDetailsElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDetailsElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLDetailsElement: {\n    prototype: HTMLDetailsElement;\n    new(): HTMLDetailsElement;\n};\n\ninterface HTMLDialogElement extends HTMLElement {\n    open: boolean;\n    returnValue: string;\n    close(returnValue?: string): void;\n    show(): void;\n    showModal(): void;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDialogElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDialogElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLDialogElement: {\n    prototype: HTMLDialogElement;\n    new(): HTMLDialogElement;\n};\n\ninterface HTMLDirectoryElement extends HTMLElement {\n    /** @deprecated */\n    compact: boolean;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDirectoryElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDirectoryElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLDirectoryElement: {\n    prototype: HTMLDirectoryElement;\n    new(): HTMLDirectoryElement;\n};\n\n/** Provides special properties (beyond the regular HTMLElement interface it also has available to it by inheritance) for manipulating <div> elements. */\ninterface HTMLDivElement extends HTMLElement {\n    /**\n     * Sets or retrieves how the object is aligned with adjacent text.\n     */\n    /** @deprecated */\n    align: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDivElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLDivElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLDivElement: {\n    prototype: HTMLDivElement;\n    new(): HTMLDivElement;\n};\n\n/** The HTMLDocument property of Window objects is an alias that browsers expose for the Document interface object. */\ninterface HTMLDocument extends Document {\n    addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: HTMLDocument, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: HTMLDocument, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLDocument: {\n    prototype: HTMLDocument;\n    new(): HTMLDocument;\n};\n\ninterface HTMLElementEventMap extends ElementEventMap, GlobalEventHandlersEventMap, DocumentAndElementEventHandlersEventMap {\n}\n\n/** Any HTML element. Some elements directly implement this interface, while others implement it via an interface that inherits it. */\ninterface HTMLElement extends Element, GlobalEventHandlers, DocumentAndElementEventHandlers, ElementContentEditable, HTMLOrSVGElement, ElementCSSInlineStyle {\n    accessKey: string;\n    readonly accessKeyLabel: string;\n    autocapitalize: string;\n    dir: string;\n    draggable: boolean;\n    hidden: boolean;\n    innerText: string;\n    lang: string;\n    readonly offsetHeight: number;\n    readonly offsetLeft: number;\n    readonly offsetParent: Element | null;\n    readonly offsetTop: number;\n    readonly offsetWidth: number;\n    spellcheck: boolean;\n    title: string;\n    translate: boolean;\n    click(): void;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLElement: {\n    prototype: HTMLElement;\n    new(): HTMLElement;\n};\n\n/** Provides special properties (beyond the regular HTMLElement interface it also has available to it by inheritance) for manipulating <embed> elements. */\ninterface HTMLEmbedElement extends HTMLElement {\n    /** @deprecated */\n    align: string;\n    /**\n     * Sets or retrieves the height of the object.\n     */\n    height: string;\n    /**\n     * Sets or retrieves the name of the object.\n     */\n    /** @deprecated */\n    name: string;\n    /**\n     * Sets or retrieves a URL to be loaded by the object.\n     */\n    src: string;\n    type: string;\n    /**\n     * Sets or retrieves the width of the object.\n     */\n    width: string;\n    getSVGDocument(): Document | null;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLEmbedElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLEmbedElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLEmbedElement: {\n    prototype: HTMLEmbedElement;\n    new(): HTMLEmbedElement;\n};\n\n/** Provides special properties and methods (beyond the regular HTMLElement interface it also has available to it by inheritance) for manipulating the layout and presentation of <fieldset> elements. */\ninterface HTMLFieldSetElement extends HTMLElement {\n    disabled: boolean;\n    readonly elements: HTMLCollection;\n    /**\n     * Retrieves a reference to the form that the object is embedded in.\n     */\n    readonly form: HTMLFormElement | null;\n    name: string;\n    readonly type: string;\n    /**\n     * Returns the error message that would be displayed if the user submits the form, or an empty string if no error message. It also triggers the standard error message, such as "this is a required field". The result is that the user sees validation messages without actually submitting.\n     */\n    readonly validationMessage: string;\n    /**\n     * Returns a  ValidityState object that represents the validity states of an element.\n     */\n    readonly validity: ValidityState;\n    /**\n     * Returns whether an element will successfully validate based on forms validation rules and constraints.\n     */\n    readonly willValidate: boolean;\n    /**\n     * Returns whether a form will validate when it is submitted, without having to submit it.\n     */\n    checkValidity(): boolean;\n    reportValidity(): boolean;\n    /**\n     * Sets a custom error message that is displayed when a form is submitted.\n     * @param error Sets a custom error message that is displayed when a form is submitted.\n     */\n    setCustomValidity(error: string): void;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLFieldSetElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLFieldSetElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLFieldSetElement: {\n    prototype: HTMLFieldSetElement;\n    new(): HTMLFieldSetElement;\n};\n\n/** Implements the document object model (DOM) representation of the font element. The HTML Font Element <font> defines the font size, font face and color of text. */\ninterface HTMLFontElement extends HTMLElement {\n    /** @deprecated */\n    color: string;\n    /**\n     * Sets or retrieves the current typeface family.\n     */\n    /** @deprecated */\n    face: string;\n    /** @deprecated */\n    size: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLFontElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLFontElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLFontElement: {\n    prototype: HTMLFontElement;\n    new(): HTMLFontElement;\n};\n\n/** A collection of HTML form control elements.  */\ninterface HTMLFormControlsCollection extends HTMLCollectionBase {\n    /**\n     * element = collection[name]\n     */\n    namedItem(name: string): RadioNodeList | Element | null;\n}\n\ndeclare var HTMLFormControlsCollection: {\n    prototype: HTMLFormControlsCollection;\n    new(): HTMLFormControlsCollection;\n};\n\n/** A <form> element in the DOM; it allows access to and in some cases modification of aspects of the form, as well as access to its component elements. */\ninterface HTMLFormElement extends HTMLElement {\n    /**\n     * Sets or retrieves a list of character encodings for input data that must be accepted by the server processing the form.\n     */\n    acceptCharset: string;\n    /**\n     * Sets or retrieves the URL to which the form content is sent for processing.\n     */\n    action: string;\n    /**\n     * Specifies whether autocomplete is applied to an editable text field.\n     */\n    autocomplete: string;\n    /**\n     * Retrieves a collection, in source order, of all controls in a given form.\n     */\n    readonly elements: HTMLFormControlsCollection;\n    /**\n     * Sets or retrieves the MIME encoding for the form.\n     */\n    encoding: string;\n    /**\n     * Sets or retrieves the encoding type for the form.\n     */\n    enctype: string;\n    /**\n     * Sets or retrieves the number of objects in a collection.\n     */\n    readonly length: number;\n    /**\n     * Sets or retrieves how to send the form data to the server.\n     */\n    method: string;\n    /**\n     * Sets or retrieves the name of the object.\n     */\n    name: string;\n    /**\n     * Designates a form that is not validated when submitted.\n     */\n    noValidate: boolean;\n    /**\n     * Sets or retrieves the window or frame at which to target content.\n     */\n    target: string;\n    /**\n     * Returns whether a form will validate when it is submitted, without having to submit it.\n     */\n    checkValidity(): boolean;\n    reportValidity(): boolean;\n    /**\n     * Fires when the user resets a form.\n     */\n    reset(): void;\n    /**\n     * Fires when a FORM is about to be submitted.\n     */\n    submit(): void;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLFormElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLFormElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n    [index: number]: Element;\n    [name: string]: any;\n}\n\ndeclare var HTMLFormElement: {\n    prototype: HTMLFormElement;\n    new(): HTMLFormElement;\n};\n\ninterface HTMLFrameElement extends HTMLElement {\n    /**\n     * Retrieves the document object of the page or frame.\n     */\n    /** @deprecated */\n    readonly contentDocument: Document | null;\n    /**\n     * Retrieves the object of the specified.\n     */\n    /** @deprecated */\n    readonly contentWindow: WindowProxy | null;\n    /**\n     * Sets or retrieves whether to display a border for the frame.\n     */\n    /** @deprecated */\n    frameBorder: string;\n    /**\n     * Sets or retrieves a URI to a long description of the object.\n     */\n    /** @deprecated */\n    longDesc: string;\n    /**\n     * Sets or retrieves the top and bottom margin heights before displaying the text in a frame.\n     */\n    /** @deprecated */\n    marginHeight: string;\n    /**\n     * Sets or retrieves the left and right margin widths before displaying the text in a frame.\n     */\n    /** @deprecated */\n    marginWidth: string;\n    /**\n     * Sets or retrieves the frame name.\n     */\n    /** @deprecated */\n    name: string;\n    /**\n     * Sets or retrieves whether the user can resize the frame.\n     */\n    /** @deprecated */\n    noResize: boolean;\n    /**\n     * Sets or retrieves whether the frame can be scrolled.\n     */\n    /** @deprecated */\n    scrolling: string;\n    /**\n     * Sets or retrieves a URL to be loaded by the object.\n     */\n    /** @deprecated */\n    src: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLFrameElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLFrameElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLFrameElement: {\n    prototype: HTMLFrameElement;\n    new(): HTMLFrameElement;\n};\n\ninterface HTMLFrameSetElementEventMap extends HTMLElementEventMap, WindowEventHandlersEventMap {\n}\n\n/** Provides special properties (beyond those of the regular HTMLElement interface they also inherit) for manipulating <frameset> elements. */\ninterface HTMLFrameSetElement extends HTMLElement, WindowEventHandlers {\n    /**\n     * Sets or retrieves the frame widths of the object.\n     */\n    /** @deprecated */\n    cols: string;\n    /**\n     * Sets or retrieves the frame heights of the object.\n     */\n    /** @deprecated */\n    rows: string;\n    addEventListener<K extends keyof HTMLFrameSetElementEventMap>(type: K, listener: (this: HTMLFrameSetElement, ev: HTMLFrameSetElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLFrameSetElementEventMap>(type: K, listener: (this: HTMLFrameSetElement, ev: HTMLFrameSetElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLFrameSetElement: {\n    prototype: HTMLFrameSetElement;\n    new(): HTMLFrameSetElement;\n};\n\n/** Provides special properties (beyond those of the HTMLElement interface it also has available to it by inheritance) for manipulating <hr> elements. */\ninterface HTMLHRElement extends HTMLElement {\n    /**\n     * Sets or retrieves how the object is aligned with adjacent text.\n     */\n    /** @deprecated */\n    align: string;\n    /** @deprecated */\n    color: string;\n    /**\n     * Sets or retrieves whether the horizontal rule is drawn with 3-D shading.\n     */\n    /** @deprecated */\n    noShade: boolean;\n    /** @deprecated */\n    size: string;\n    /**\n     * Sets or retrieves the width of the object.\n     */\n    /** @deprecated */\n    width: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLHRElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLHRElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLHRElement: {\n    prototype: HTMLHRElement;\n    new(): HTMLHRElement;\n};\n\n/** Contains the descriptive information, or metadata, for a document. This object inherits all of the properties and methods described in the HTMLElement interface. */\ninterface HTMLHeadElement extends HTMLElement {\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLHeadElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLHeadElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLHeadElement: {\n    prototype: HTMLHeadElement;\n    new(): HTMLHeadElement;\n};\n\n/** The different heading elements. It inherits methods and properties from the HTMLElement interface. */\ninterface HTMLHeadingElement extends HTMLElement {\n    /**\n     * Sets or retrieves a value that indicates the table alignment.\n     */\n    /** @deprecated */\n    align: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLHeadingElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLHeadingElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLHeadingElement: {\n    prototype: HTMLHeadingElement;\n    new(): HTMLHeadingElement;\n};\n\n/** Serves as the root node for a given HTML document. This object inherits the properties and methods described in the HTMLElement interface. */\ninterface HTMLHtmlElement extends HTMLElement {\n    /**\n     * Sets or retrieves the DTD version that governs the current document.\n     */\n    /** @deprecated */\n    version: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLHtmlElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLHtmlElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLHtmlElement: {\n    prototype: HTMLHtmlElement;\n    new(): HTMLHtmlElement;\n};\n\ninterface HTMLHyperlinkElementUtils {\n    hash: string;\n    host: string;\n    hostname: string;\n    href: string;\n    readonly origin: string;\n    password: string;\n    pathname: string;\n    port: string;\n    protocol: string;\n    search: string;\n    username: string;\n}\n\n/** Provides special properties and methods (beyond those of the HTMLElement interface it also has available to it by inheritance) for manipulating the layout and presentation of inline frame elements. */\ninterface HTMLIFrameElement extends HTMLElement {\n    /**\n     * Sets or retrieves how the object is aligned with adjacent text.\n     */\n    /** @deprecated */\n    align: string;\n    allow: string;\n    allowFullscreen: boolean;\n    allowPaymentRequest: boolean;\n    /**\n     * Retrieves the document object of the page or frame.\n     */\n    readonly contentDocument: Document | null;\n    /**\n     * Retrieves the object of the specified.\n     */\n    readonly contentWindow: WindowProxy | null;\n    /**\n     * Sets or retrieves whether to display a border for the frame.\n     */\n    /** @deprecated */\n    frameBorder: string;\n    /**\n     * Sets or retrieves the height of the object.\n     */\n    height: string;\n    /**\n     * Sets or retrieves a URI to a long description of the object.\n     */\n    /** @deprecated */\n    longDesc: string;\n    /**\n     * Sets or retrieves the top and bottom margin heights before displaying the text in a frame.\n     */\n    /** @deprecated */\n    marginHeight: string;\n    /**\n     * Sets or retrieves the left and right margin widths before displaying the text in a frame.\n     */\n    /** @deprecated */\n    marginWidth: string;\n    /**\n     * Sets or retrieves the frame name.\n     */\n    name: string;\n    referrerPolicy: ReferrerPolicy;\n    readonly sandbox: DOMTokenList;\n    /**\n     * Sets or retrieves whether the frame can be scrolled.\n     */\n    /** @deprecated */\n    scrolling: string;\n    /**\n     * Sets or retrieves a URL to be loaded by the object.\n     */\n    src: string;\n    /**\n     * Sets or retrives the content of the page that is to contain.\n     */\n    srcdoc: string;\n    /**\n     * Sets or retrieves the width of the object.\n     */\n    width: string;\n    getSVGDocument(): Document | null;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLIFrameElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLIFrameElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLIFrameElement: {\n    prototype: HTMLIFrameElement;\n    new(): HTMLIFrameElement;\n};\n\n/** Provides special properties and methods for manipulating <img> elements. */\ninterface HTMLImageElement extends HTMLElement {\n    /**\n     * Sets or retrieves how the object is aligned with adjacent text.\n     */\n    /** @deprecated */\n    align: string;\n    /**\n     * Sets or retrieves a text alternative to the graphic.\n     */\n    alt: string;\n    /**\n     * Specifies the properties of a border drawn around an object.\n     */\n    /** @deprecated */\n    border: string;\n    /**\n     * Retrieves whether the object is fully loaded.\n     */\n    readonly complete: boolean;\n    crossOrigin: string | null;\n    readonly currentSrc: string;\n    decoding: "async" | "sync" | "auto";\n    /**\n     * Sets or retrieves the height of the object.\n     */\n    height: number;\n    /**\n     * Sets or retrieves the width of the border to draw around the object.\n     */\n    /** @deprecated */\n    hspace: number;\n    /**\n     * Sets or retrieves whether the image is a server-side image map.\n     */\n    isMap: boolean;\n    /**\n     * Sets or retrieves a Uniform Resource Identifier (URI) to a long description of the object.\n     */\n    /** @deprecated */\n    longDesc: string;\n    /** @deprecated */\n    lowsrc: string;\n    /**\n     * Sets or retrieves the name of the object.\n     */\n    /** @deprecated */\n    name: string;\n    /**\n     * The original height of the image resource before sizing.\n     */\n    readonly naturalHeight: number;\n    /**\n     * The original width of the image resource before sizing.\n     */\n    readonly naturalWidth: number;\n    referrerPolicy: string;\n    sizes: string;\n    /**\n     * The address or URL of the a media resource that is to be considered.\n     */\n    src: string;\n    srcset: string;\n    /**\n     * Sets or retrieves the URL, often with a bookmark extension (#name), to use as a client-side image map.\n     */\n    useMap: string;\n    /**\n     * Sets or retrieves the vertical margin for the object.\n     */\n    /** @deprecated */\n    vspace: number;\n    /**\n     * Sets or retrieves the width of the object.\n     */\n    width: number;\n    readonly x: number;\n    readonly y: number;\n    decode(): Promise<void>;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLImageElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLImageElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLImageElement: {\n    prototype: HTMLImageElement;\n    new(): HTMLImageElement;\n};\n\n/** Provides special properties and methods for manipulating the options, layout, and presentation of <input> elements. */\ninterface HTMLInputElement extends HTMLElement {\n    /**\n     * Sets or retrieves a comma-separated list of content types.\n     */\n    accept: string;\n    /**\n     * Sets or retrieves how the object is aligned with adjacent text.\n     */\n    /** @deprecated */\n    align: string;\n    /**\n     * Sets or retrieves a text alternative to the graphic.\n     */\n    alt: string;\n    /**\n     * Specifies whether autocomplete is applied to an editable text field.\n     */\n    autocomplete: string;\n    /**\n     * Provides a way to direct a user to a specific field when a document loads. This can provide both direction and convenience for a user, reducing the need to click or tab to a field when a page opens. This attribute is true when present on an element, and false when missing.\n     */\n    autofocus: boolean;\n    /**\n     * Sets or retrieves the state of the check box or radio button.\n     */\n    checked: boolean;\n    /**\n     * Sets or retrieves the state of the check box or radio button.\n     */\n    defaultChecked: boolean;\n    /**\n     * Sets or retrieves the initial contents of the object.\n     */\n    defaultValue: string;\n    dirName: string;\n    disabled: boolean;\n    /**\n     * Returns a FileList object on a file type input object.\n     */\n    files: FileList | null;\n    /**\n     * Retrieves a reference to the form that the object is embedded in.\n     */\n    readonly form: HTMLFormElement | null;\n    /**\n     * Overrides the action attribute (where the data on a form is sent) on the parent form element.\n     */\n    formAction: string;\n    /**\n     * Used to override the encoding (formEnctype attribute) specified on the form element.\n     */\n    formEnctype: string;\n    /**\n     * Overrides the submit method attribute previously specified on a form element.\n     */\n    formMethod: string;\n    /**\n     * Overrides any validation or required attributes on a form or form elements to allow it to be submitted without validation. This can be used to create a "save draft"-type submit option.\n     */\n    formNoValidate: boolean;\n    /**\n     * Overrides the target attribute on a form element.\n     */\n    formTarget: string;\n    /**\n     * Sets or retrieves the height of the object.\n     */\n    height: number;\n    indeterminate: boolean;\n    readonly labels: NodeListOf<HTMLLabelElement> | null;\n    /**\n     * Specifies the ID of a pre-defined datalist of options for an input element.\n     */\n    readonly list: HTMLElement | null;\n    /**\n     * Defines the maximum acceptable value for an input element with type="number".When used with the min and step attributes, lets you control the range and increment (such as only even numbers) that the user can enter into an input field.\n     */\n    max: string;\n    /**\n     * Sets or retrieves the maximum number of characters that the user can enter in a text control.\n     */\n    maxLength: number;\n    /**\n     * Defines the minimum acceptable value for an input element with type="number". When used with the max and step attributes, lets you control the range and increment (such as even numbers only) that the user can enter into an input field.\n     */\n    min: string;\n    minLength: number;\n    /**\n     * Sets or retrieves the Boolean value indicating whether multiple items can be selected from a list.\n     */\n    multiple: boolean;\n    /**\n     * Sets or retrieves the name of the object.\n     */\n    name: string;\n    /**\n     * Gets or sets a string containing a regular expression that the user\'s input must match.\n     */\n    pattern: string;\n    /**\n     * Gets or sets a text string that is displayed in an input field as a hint or prompt to users as the format or type of information they need to enter.The text appears in an input field until the user puts focus on the field.\n     */\n    placeholder: string;\n    readOnly: boolean;\n    /**\n     * When present, marks an element that can\'t be submitted without a value.\n     */\n    required: boolean;\n    selectionDirection: string | null;\n    /**\n     * Gets or sets the end position or offset of a text selection.\n     */\n    selectionEnd: number | null;\n    /**\n     * Gets or sets the starting position or offset of a text selection.\n     */\n    selectionStart: number | null;\n    size: number;\n    /**\n     * The address or URL of the a media resource that is to be considered.\n     */\n    src: string;\n    /**\n     * Defines an increment or jump between values that you want to allow the user to enter. When used with the max and min attributes, lets you control the range and increment (for example, allow only even numbers) that the user can enter into an input field.\n     */\n    step: string;\n    /**\n     * Returns the content type of the object.\n     */\n    type: string;\n    /**\n     * Sets or retrieves the URL, often with a bookmark extension (#name), to use as a client-side image map.\n     */\n    /** @deprecated */\n    useMap: string;\n    /**\n     * Returns the error message that would be displayed if the user submits the form, or an empty string if no error message. It also triggers the standard error message, such as "this is a required field". The result is that the user sees validation messages without actually submitting.\n     */\n    readonly validationMessage: string;\n    /**\n     * Returns a  ValidityState object that represents the validity states of an element.\n     */\n    readonly validity: ValidityState;\n    /**\n     * Returns the value of the data at the cursor\'s current position.\n     */\n    value: string;\n    /**\n     * Returns a Date object representing the form control\'s value, if applicable; otherwise, returns null. Can be set, to change the value. Throws an "InvalidStateError" DOMException if the control isn\'t date- or time-based.\n     */\n    valueAsDate: Date | null;\n    /**\n     * Returns the input field value as a number.\n     */\n    valueAsNumber: number;\n    /**\n     * Sets or retrieves the width of the object.\n     */\n    width: number;\n    /**\n     * Returns whether an element will successfully validate based on forms validation rules and constraints.\n     */\n    readonly willValidate: boolean;\n    /**\n     * Returns whether a form will validate when it is submitted, without having to submit it.\n     */\n    checkValidity(): boolean;\n    reportValidity(): boolean;\n    /**\n     * Makes the selection equal to the current object.\n     */\n    select(): void;\n    /**\n     * Sets a custom error message that is displayed when a form is submitted.\n     * @param error Sets a custom error message that is displayed when a form is submitted.\n     */\n    setCustomValidity(error: string): void;\n    setRangeText(replacement: string): void;\n    setRangeText(replacement: string, start: number, end: number, selectionMode?: SelectionMode): void;\n    /**\n     * Sets the start and end positions of a selection in a text field.\n     * @param start The offset into the text field for the start of the selection.\n     * @param end The offset into the text field for the end of the selection.\n     * @param direction The direction in which the selection is performed.\n     */\n    setSelectionRange(start: number, end: number, direction?: "forward" | "backward" | "none"): void;\n    /**\n     * Decrements a range input control\'s value by the value given by the Step attribute. If the optional parameter is used, it will decrement the input control\'s step value multiplied by the parameter\'s value.\n     * @param n Value to decrement the value by.\n     */\n    stepDown(n?: number): void;\n    /**\n     * Increments a range input control\'s value by the value given by the Step attribute. If the optional parameter is used, will increment the input control\'s value by that value.\n     * @param n Value to increment the value by.\n     */\n    stepUp(n?: number): void;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLInputElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLInputElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLInputElement: {\n    prototype: HTMLInputElement;\n    new(): HTMLInputElement;\n};\n\n/** Exposes specific properties and methods (beyond those defined by regular HTMLElement interface it also has available to it by inheritance) for manipulating list elements. */\ninterface HTMLLIElement extends HTMLElement {\n    /** @deprecated */\n    type: string;\n    /**\n     * Sets or retrieves the value of a list item.\n     */\n    value: number;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLLIElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLLIElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLLIElement: {\n    prototype: HTMLLIElement;\n    new(): HTMLLIElement;\n};\n\n/** Gives access to properties specific to <label> elements. It inherits methods and properties from the base HTMLElement interface. */\ninterface HTMLLabelElement extends HTMLElement {\n    readonly control: HTMLElement | null;\n    /**\n     * Retrieves a reference to the form that the object is embedded in.\n     */\n    readonly form: HTMLFormElement | null;\n    /**\n     * Sets or retrieves the object to which the given label object is assigned.\n     */\n    htmlFor: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLLabelElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLLabelElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLLabelElement: {\n    prototype: HTMLLabelElement;\n    new(): HTMLLabelElement;\n};\n\n/** The HTMLLegendElement is an interface allowing to access properties of the <legend> elements. It inherits properties and methods from the HTMLElement interface. */\ninterface HTMLLegendElement extends HTMLElement {\n    /** @deprecated */\n    align: string;\n    /**\n     * Retrieves a reference to the form that the object is embedded in.\n     */\n    readonly form: HTMLFormElement | null;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLLegendElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLLegendElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLLegendElement: {\n    prototype: HTMLLegendElement;\n    new(): HTMLLegendElement;\n};\n\n/** Reference information for external resources and the relationship of those resources to a document and vice-versa. This object inherits all of the properties and methods of the HTMLElement interface. */\ninterface HTMLLinkElement extends HTMLElement, LinkStyle {\n    as: string;\n    /**\n     * Sets or retrieves the character set used to encode the object.\n     */\n    /** @deprecated */\n    charset: string;\n    crossOrigin: string | null;\n    disabled: boolean;\n    /**\n     * Sets or retrieves a destination URL or an anchor point.\n     */\n    href: string;\n    /**\n     * Sets or retrieves the language code of the object.\n     */\n    hreflang: string;\n    imageSizes: string;\n    imageSrcset: string;\n    integrity: string;\n    /**\n     * Sets or retrieves the media type.\n     */\n    media: string;\n    referrerPolicy: string;\n    /**\n     * Sets or retrieves the relationship between the object and the destination of the link.\n     */\n    rel: string;\n    readonly relList: DOMTokenList;\n    /**\n     * Sets or retrieves the relationship between the object and the destination of the link.\n     */\n    /** @deprecated */\n    rev: string;\n    readonly sizes: DOMTokenList;\n    /**\n     * Sets or retrieves the window or frame at which to target content.\n     */\n    /** @deprecated */\n    target: string;\n    /**\n     * Sets or retrieves the MIME type of the object.\n     */\n    type: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLLinkElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLLinkElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLLinkElement: {\n    prototype: HTMLLinkElement;\n    new(): HTMLLinkElement;\n};\n\n/** Provides special properties and methods (beyond those of the regular object HTMLElement interface it also has available to it by inheritance) for manipulating the layout and presentation of map elements. */\ninterface HTMLMapElement extends HTMLElement {\n    /**\n     * Retrieves a collection of the area objects defined for the given map object.\n     */\n    readonly areas: HTMLCollection;\n    /**\n     * Sets or retrieves the name of the object.\n     */\n    name: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLMapElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLMapElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLMapElement: {\n    prototype: HTMLMapElement;\n    new(): HTMLMapElement;\n};\n\ninterface HTMLMarqueeElementEventMap extends HTMLElementEventMap {\n    "bounce": Event;\n    "finish": Event;\n    "start": Event;\n}\n\n/** Provides methods to manipulate <marquee> elements. */\ninterface HTMLMarqueeElement extends HTMLElement {\n    /** @deprecated */\n    behavior: string;\n    /** @deprecated */\n    bgColor: string;\n    /** @deprecated */\n    direction: string;\n    /** @deprecated */\n    height: string;\n    /** @deprecated */\n    hspace: number;\n    /** @deprecated */\n    loop: number;\n    /** @deprecated */\n    onbounce: ((this: HTMLMarqueeElement, ev: Event) => any) | null;\n    /** @deprecated */\n    onfinish: ((this: HTMLMarqueeElement, ev: Event) => any) | null;\n    /** @deprecated */\n    onstart: ((this: HTMLMarqueeElement, ev: Event) => any) | null;\n    /** @deprecated */\n    scrollAmount: number;\n    /** @deprecated */\n    scrollDelay: number;\n    /** @deprecated */\n    trueSpeed: boolean;\n    /** @deprecated */\n    vspace: number;\n    /** @deprecated */\n    width: string;\n    /** @deprecated */\n    start(): void;\n    /** @deprecated */\n    stop(): void;\n    addEventListener<K extends keyof HTMLMarqueeElementEventMap>(type: K, listener: (this: HTMLMarqueeElement, ev: HTMLMarqueeElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLMarqueeElementEventMap>(type: K, listener: (this: HTMLMarqueeElement, ev: HTMLMarqueeElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLMarqueeElement: {\n    prototype: HTMLMarqueeElement;\n    new(): HTMLMarqueeElement;\n};\n\ninterface HTMLMediaElementEventMap extends HTMLElementEventMap {\n    "encrypted": MediaEncryptedEvent;\n    "msneedkey": Event;\n    "waitingforkey": Event;\n}\n\n/** Adds to HTMLElement the properties and methods needed to support basic media-related capabilities that are common to audio and video. */\ninterface HTMLMediaElement extends HTMLElement {\n    /**\n     * Returns an AudioTrackList object with the audio tracks for a given video element.\n     */\n    readonly audioTracks: AudioTrackList;\n    /**\n     * Gets or sets a value that indicates whether to start playing the media automatically.\n     */\n    autoplay: boolean;\n    /**\n     * Gets a collection of buffered time ranges.\n     */\n    readonly buffered: TimeRanges;\n    /**\n     * Gets or sets a flag that indicates whether the client provides a set of controls for the media (in case the developer does not include controls for the player).\n     */\n    controls: boolean;\n    crossOrigin: string | null;\n    /**\n     * Gets the address or URL of the current media resource that is selected by IHTMLMediaElement.\n     */\n    readonly currentSrc: string;\n    /**\n     * Gets or sets the current playback position, in seconds.\n     */\n    currentTime: number;\n    defaultMuted: boolean;\n    /**\n     * Gets or sets the default playback rate when the user is not using fast forward or reverse for a video or audio resource.\n     */\n    defaultPlaybackRate: number;\n    /**\n     * Returns the duration in seconds of the current media resource. A NaN value is returned if duration is not available, or Infinity if the media resource is streaming.\n     */\n    readonly duration: number;\n    /**\n     * Gets information about whether the playback has ended or not.\n     */\n    readonly ended: boolean;\n    /**\n     * Returns an object representing the current error state of the audio or video element.\n     */\n    readonly error: MediaError | null;\n    /**\n     * Gets or sets a flag to specify whether playback should restart after it completes.\n     */\n    loop: boolean;\n    readonly mediaKeys: MediaKeys | null;\n    /**\n     * Specifies the purpose of the audio or video media, such as background audio or alerts.\n     */\n    msAudioCategory: string;\n    /**\n     * Specifies the output device id that the audio will be sent to.\n     */\n    msAudioDeviceType: string;\n    readonly msGraphicsTrustStatus: MSGraphicsTrust;\n    /**\n     * Gets the MSMediaKeys object, which is used for decrypting media data, that is associated with this media element.\n     */\n    /** @deprecated */\n    readonly msKeys: MSMediaKeys;\n    /**\n     * Gets or sets whether the DLNA PlayTo device is available.\n     */\n    msPlayToDisabled: boolean;\n    /**\n     * Gets or sets the path to the preferred media source. This enables the Play To target device to stream the media content, which can be DRM protected, from a different location, such as a cloud media server.\n     */\n    msPlayToPreferredSourceUri: string;\n    /**\n     * Gets or sets the primary DLNA PlayTo device.\n     */\n    msPlayToPrimary: boolean;\n    /**\n     * Gets the source associated with the media element for use by the PlayToManager.\n     */\n    readonly msPlayToSource: any;\n    /**\n     * Specifies whether or not to enable low-latency playback on the media element.\n     */\n    msRealTime: boolean;\n    /**\n     * Gets or sets a flag that indicates whether the audio (either audio or the audio track on video media) is muted.\n     */\n    muted: boolean;\n    /**\n     * Gets the current network activity for the element.\n     */\n    readonly networkState: number;\n    onencrypted: ((this: HTMLMediaElement, ev: MediaEncryptedEvent) => any) | null;\n    /** @deprecated */\n    onmsneedkey: ((this: HTMLMediaElement, ev: Event) => any) | null;\n    onwaitingforkey: ((this: HTMLMediaElement, ev: Event) => any) | null;\n    /**\n     * Gets a flag that specifies whether playback is paused.\n     */\n    readonly paused: boolean;\n    /**\n     * Gets or sets the current rate of speed for the media resource to play. This speed is expressed as a multiple of the normal speed of the media resource.\n     */\n    playbackRate: number;\n    /**\n     * Gets TimeRanges for the current media resource that has been played.\n     */\n    readonly played: TimeRanges;\n    /**\n     * Gets or sets the current playback position, in seconds.\n     */\n    preload: string;\n    readonly readyState: number;\n    /**\n     * Returns a TimeRanges object that represents the ranges of the current media resource that can be seeked.\n     */\n    readonly seekable: TimeRanges;\n    /**\n     * Gets a flag that indicates whether the client is currently moving to a new playback position in the media resource.\n     */\n    readonly seeking: boolean;\n    /**\n     * The address or URL of the a media resource that is to be considered.\n     */\n    src: string;\n    srcObject: MediaStream | MediaSource | Blob | null;\n    readonly textTracks: TextTrackList;\n    readonly videoTracks: VideoTrackList;\n    /**\n     * Gets or sets the volume level for audio portions of the media element.\n     */\n    volume: number;\n    addTextTrack(kind: TextTrackKind, label?: string, language?: string): TextTrack;\n    /**\n     * Returns a string that specifies whether the client can play a given media resource type.\n     */\n    canPlayType(type: string): CanPlayTypeResult;\n    /**\n     * Resets the audio or video object and loads a new media resource.\n     */\n    load(): void;\n    /**\n     * Clears all effects from the media pipeline.\n     */\n    msClearEffects(): void;\n    msGetAsCastingSource(): any;\n    /**\n     * Inserts the specified audio effect into media pipeline.\n     */\n    msInsertAudioEffect(activatableClassId: string, effectRequired: boolean, config?: any): void;\n    /** @deprecated */\n    msSetMediaKeys(mediaKeys: MSMediaKeys): void;\n    /**\n     * Specifies the media protection manager for a given media pipeline.\n     */\n    msSetMediaProtectionManager(mediaProtectionManager?: any): void;\n    /**\n     * Pauses the current playback and sets paused to TRUE. This can be used to test whether the media is playing or paused. You can also use the pause or play events to tell whether the media is playing or not.\n     */\n    pause(): void;\n    /**\n     * Loads and starts playback of a media resource.\n     */\n    play(): Promise<void>;\n    setMediaKeys(mediaKeys: MediaKeys | null): Promise<void>;\n    readonly HAVE_CURRENT_DATA: number;\n    readonly HAVE_ENOUGH_DATA: number;\n    readonly HAVE_FUTURE_DATA: number;\n    readonly HAVE_METADATA: number;\n    readonly HAVE_NOTHING: number;\n    readonly NETWORK_EMPTY: number;\n    readonly NETWORK_IDLE: number;\n    readonly NETWORK_LOADING: number;\n    readonly NETWORK_NO_SOURCE: number;\n    addEventListener<K extends keyof HTMLMediaElementEventMap>(type: K, listener: (this: HTMLMediaElement, ev: HTMLMediaElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLMediaElementEventMap>(type: K, listener: (this: HTMLMediaElement, ev: HTMLMediaElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLMediaElement: {\n    prototype: HTMLMediaElement;\n    new(): HTMLMediaElement;\n    readonly HAVE_CURRENT_DATA: number;\n    readonly HAVE_ENOUGH_DATA: number;\n    readonly HAVE_FUTURE_DATA: number;\n    readonly HAVE_METADATA: number;\n    readonly HAVE_NOTHING: number;\n    readonly NETWORK_EMPTY: number;\n    readonly NETWORK_IDLE: number;\n    readonly NETWORK_LOADING: number;\n    readonly NETWORK_NO_SOURCE: number;\n};\n\ninterface HTMLMenuElement extends HTMLElement {\n    /** @deprecated */\n    compact: boolean;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLMenuElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLMenuElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLMenuElement: {\n    prototype: HTMLMenuElement;\n    new(): HTMLMenuElement;\n};\n\n/** Contains descriptive metadata about a document. It inherits all of the properties and methods described in the HTMLElement interface. */\ninterface HTMLMetaElement extends HTMLElement {\n    /**\n     * Gets or sets meta-information to associate with httpEquiv or name.\n     */\n    content: string;\n    /**\n     * Gets or sets information used to bind the value of a content attribute of a meta element to an HTTP response header.\n     */\n    httpEquiv: string;\n    /**\n     * Sets or retrieves the value specified in the content attribute of the meta object.\n     */\n    name: string;\n    /**\n     * Sets or retrieves a scheme to be used in interpreting the value of a property specified for the object.\n     */\n    /** @deprecated */\n    scheme: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLMetaElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLMetaElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLMetaElement: {\n    prototype: HTMLMetaElement;\n    new(): HTMLMetaElement;\n};\n\n/** The HTML <meter> elements expose the HTMLMeterElement interface, which provides special properties and methods (beyond the HTMLElement object interface they also have available to them by inheritance) for manipulating the layout and presentation of <meter> elements. */\ninterface HTMLMeterElement extends HTMLElement {\n    high: number;\n    readonly labels: NodeListOf<HTMLLabelElement>;\n    low: number;\n    max: number;\n    min: number;\n    optimum: number;\n    value: number;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLMeterElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLMeterElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLMeterElement: {\n    prototype: HTMLMeterElement;\n    new(): HTMLMeterElement;\n};\n\n/** Provides special properties (beyond the regular methods and properties available through the HTMLElement interface they also have available to them by inheritance) for manipulating modification elements, that is <del> and <ins>. */\ninterface HTMLModElement extends HTMLElement {\n    /**\n     * Sets or retrieves reference information about the object.\n     */\n    cite: string;\n    /**\n     * Sets or retrieves the date and time of a modification to the object.\n     */\n    dateTime: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLModElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLModElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLModElement: {\n    prototype: HTMLModElement;\n    new(): HTMLModElement;\n};\n\n/** Provides special properties (beyond those defined on the regular HTMLElement interface it also has available to it by inheritance) for manipulating ordered list elements. */\ninterface HTMLOListElement extends HTMLElement {\n    /** @deprecated */\n    compact: boolean;\n    reversed: boolean;\n    /**\n     * The starting number.\n     */\n    start: number;\n    type: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLOListElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLOListElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLOListElement: {\n    prototype: HTMLOListElement;\n    new(): HTMLOListElement;\n};\n\n/** Provides special properties and methods (beyond those on the HTMLElement interface it also has available to it by inheritance) for manipulating the layout and presentation of <object> element, representing external resources. */\ninterface HTMLObjectElement extends HTMLElement {\n    /** @deprecated */\n    align: string;\n    /**\n     * Sets or retrieves a character string that can be used to implement your own archive functionality for the object.\n     */\n    /** @deprecated */\n    archive: string;\n    /** @deprecated */\n    border: string;\n    /**\n     * Sets or retrieves the URL of the file containing the compiled Java class.\n     */\n    /** @deprecated */\n    code: string;\n    /**\n     * Sets or retrieves the URL of the component.\n     */\n    /** @deprecated */\n    codeBase: string;\n    /**\n     * Sets or retrieves the Internet media type for the code associated with the object.\n     */\n    /** @deprecated */\n    codeType: string;\n    /**\n     * Retrieves the document object of the page or frame.\n     */\n    readonly contentDocument: Document | null;\n    readonly contentWindow: WindowProxy | null;\n    /**\n     * Sets or retrieves the URL that references the data of the object.\n     */\n    data: string;\n    /** @deprecated */\n    declare: boolean;\n    /**\n     * Retrieves a reference to the form that the object is embedded in.\n     */\n    readonly form: HTMLFormElement | null;\n    /**\n     * Sets or retrieves the height of the object.\n     */\n    height: string;\n    /** @deprecated */\n    hspace: number;\n    /**\n     * Sets or retrieves the name of the object.\n     */\n    name: string;\n    /**\n     * Sets or retrieves a message to be displayed while an object is loading.\n     */\n    /** @deprecated */\n    standby: string;\n    /**\n     * Sets or retrieves the MIME type of the object.\n     */\n    type: string;\n    typeMustMatch: boolean;\n    /**\n     * Sets or retrieves the URL, often with a bookmark extension (#name), to use as a client-side image map.\n     */\n    useMap: string;\n    /**\n     * Returns the error message that would be displayed if the user submits the form, or an empty string if no error message. It also triggers the standard error message, such as "this is a required field". The result is that the user sees validation messages without actually submitting.\n     */\n    readonly validationMessage: string;\n    /**\n     * Returns a  ValidityState object that represents the validity states of an element.\n     */\n    readonly validity: ValidityState;\n    /** @deprecated */\n    vspace: number;\n    /**\n     * Sets or retrieves the width of the object.\n     */\n    width: string;\n    /**\n     * Returns whether an element will successfully validate based on forms validation rules and constraints.\n     */\n    readonly willValidate: boolean;\n    /**\n     * Returns whether a form will validate when it is submitted, without having to submit it.\n     */\n    checkValidity(): boolean;\n    getSVGDocument(): Document | null;\n    reportValidity(): boolean;\n    /**\n     * Sets a custom error message that is displayed when a form is submitted.\n     * @param error Sets a custom error message that is displayed when a form is submitted.\n     */\n    setCustomValidity(error: string): void;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLObjectElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLObjectElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLObjectElement: {\n    prototype: HTMLObjectElement;\n    new(): HTMLObjectElement;\n};\n\n/** Provides special properties and methods (beyond the regular HTMLElement object interface they also have available to them by inheritance) for manipulating the layout and presentation of <optgroup> elements. */\ninterface HTMLOptGroupElement extends HTMLElement {\n    disabled: boolean;\n    /**\n     * Retrieves a reference to the form that the object is embedded in.\n     */\n    readonly form: HTMLFormElement | null;\n    /**\n     * Sets or retrieves a value that you can use to implement your own label functionality for the object.\n     */\n    label: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLOptGroupElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLOptGroupElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLOptGroupElement: {\n    prototype: HTMLOptGroupElement;\n    new(): HTMLOptGroupElement;\n};\n\n/** <option> elements and inherits all classes and methods of the HTMLElement interface. */\ninterface HTMLOptionElement extends HTMLElement {\n    /**\n     * Sets or retrieves the status of an option.\n     */\n    defaultSelected: boolean;\n    disabled: boolean;\n    /**\n     * Retrieves a reference to the form that the object is embedded in.\n     */\n    readonly form: HTMLFormElement | null;\n    /**\n     * Sets or retrieves the ordinal position of an option in a list box.\n     */\n    readonly index: number;\n    /**\n     * Sets or retrieves a value that you can use to implement your own label functionality for the object.\n     */\n    label: string;\n    /**\n     * Sets or retrieves whether the option in the list box is the default item.\n     */\n    selected: boolean;\n    /**\n     * Sets or retrieves the text string specified by the option tag.\n     */\n    text: string;\n    /**\n     * Sets or retrieves the value which is returned to the server when the form control is submitted.\n     */\n    value: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLOptionElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLOptionElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLOptionElement: {\n    prototype: HTMLOptionElement;\n    new(): HTMLOptionElement;\n};\n\n/** HTMLOptionsCollection is an interface representing a collection of HTML option elements (in document order) and offers methods and properties for traversing the list as well as optionally altering its items. This type is returned solely by the "options" property of select. */\ninterface HTMLOptionsCollection extends HTMLCollectionOf<HTMLOptionElement> {\n    /**\n     * Returns the number of elements in the collection.\n     * When set to a smaller number, truncates the number of option elements in the corresponding container.\n     * When set to a greater number, adds new blank option elements to that container.\n     */\n    length: number;\n    /**\n     * Returns the index of the first selected item, if any, or −1 if there is no selected\n     * item.\n     * Can be set, to change the selection.\n     */\n    selectedIndex: number;\n    /**\n     * Inserts element before the node given by before.\n     * The before argument can be a number, in which case element is inserted before the item with that number, or an element from the\n     * collection, in which case element is inserted before that element.\n     * If before is omitted, null, or a number out of range, then element will be added at the end of the list.\n     * This method will throw a "HierarchyRequestError" DOMException if\n     * element is an ancestor of the element into which it is to be inserted.\n     */\n    add(element: HTMLOptionElement | HTMLOptGroupElement, before?: HTMLElement | number | null): void;\n    /**\n     * Removes the item with index index from the collection.\n     */\n    remove(index: number): void;\n}\n\ndeclare var HTMLOptionsCollection: {\n    prototype: HTMLOptionsCollection;\n    new(): HTMLOptionsCollection;\n};\n\ninterface HTMLOrSVGElement {\n    readonly dataset: DOMStringMap;\n    nonce?: string;\n    tabIndex: number;\n    blur(): void;\n    focus(options?: FocusOptions): void;\n}\n\n/** Provides properties and methods (beyond those inherited from HTMLElement) for manipulating the layout and presentation of <output> elements. */\ninterface HTMLOutputElement extends HTMLElement {\n    defaultValue: string;\n    readonly form: HTMLFormElement | null;\n    readonly htmlFor: DOMTokenList;\n    readonly labels: NodeListOf<HTMLLabelElement>;\n    name: string;\n    readonly type: string;\n    readonly validationMessage: string;\n    readonly validity: ValidityState;\n    value: string;\n    readonly willValidate: boolean;\n    checkValidity(): boolean;\n    reportValidity(): boolean;\n    setCustomValidity(error: string): void;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLOutputElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLOutputElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLOutputElement: {\n    prototype: HTMLOutputElement;\n    new(): HTMLOutputElement;\n};\n\n/** Provides special properties (beyond those of the regular HTMLElement object interface it inherits) for manipulating <p> elements. */\ninterface HTMLParagraphElement extends HTMLElement {\n    /**\n     * Sets or retrieves how the object is aligned with adjacent text.\n     */\n    /** @deprecated */\n    align: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLParagraphElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLParagraphElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLParagraphElement: {\n    prototype: HTMLParagraphElement;\n    new(): HTMLParagraphElement;\n};\n\n/** Provides special properties (beyond those of the regular HTMLElement object interface it inherits) for manipulating <param> elements, representing a pair of a key and a value that acts as a parameter for an <object> element. */\ninterface HTMLParamElement extends HTMLElement {\n    /**\n     * Sets or retrieves the name of an input parameter for an element.\n     */\n    name: string;\n    /**\n     * Sets or retrieves the content type of the resource designated by the value attribute.\n     */\n    /** @deprecated */\n    type: string;\n    /**\n     * Sets or retrieves the value of an input parameter for an element.\n     */\n    value: string;\n    /**\n     * Sets or retrieves the data type of the value attribute.\n     */\n    /** @deprecated */\n    valueType: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLParamElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLParamElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLParamElement: {\n    prototype: HTMLParamElement;\n    new(): HTMLParamElement;\n};\n\n/** A <picture> HTML element. It doesn\'t implement specific properties or methods. */\ninterface HTMLPictureElement extends HTMLElement {\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLPictureElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLPictureElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLPictureElement: {\n    prototype: HTMLPictureElement;\n    new(): HTMLPictureElement;\n};\n\n/** Exposes specific properties and methods (beyond those of the HTMLElement interface it also has available to it by inheritance) for manipulating a block of preformatted text (<pre>). */\ninterface HTMLPreElement extends HTMLElement {\n    /**\n     * Sets or gets a value that you can use to implement your own width functionality for the object.\n     */\n    /** @deprecated */\n    width: number;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLPreElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLPreElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLPreElement: {\n    prototype: HTMLPreElement;\n    new(): HTMLPreElement;\n};\n\n/** Provides special properties and methods (beyond the regular HTMLElement interface it also has available to it by inheritance) for manipulating the layout and presentation of <progress> elements. */\ninterface HTMLProgressElement extends HTMLElement {\n    readonly labels: NodeListOf<HTMLLabelElement>;\n    /**\n     * Defines the maximum, or "done" value for a progress element.\n     */\n    max: number;\n    /**\n     * Returns the quotient of value/max when the value attribute is set (determinate progress bar), or -1 when the value attribute is missing (indeterminate progress bar).\n     */\n    readonly position: number;\n    /**\n     * Sets or gets the current value of a progress element. The value must be a non-negative number between 0 and the max value.\n     */\n    value: number;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLProgressElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLProgressElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLProgressElement: {\n    prototype: HTMLProgressElement;\n    new(): HTMLProgressElement;\n};\n\n/** Provides special properties and methods (beyond the regular HTMLElement interface it also has available to it by inheritance) for manipulating quoting elements, like <blockquote> and <q>, but not the <cite> element. */\ninterface HTMLQuoteElement extends HTMLElement {\n    /**\n     * Sets or retrieves reference information about the object.\n     */\n    cite: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLQuoteElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLQuoteElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLQuoteElement: {\n    prototype: HTMLQuoteElement;\n    new(): HTMLQuoteElement;\n};\n\n/** HTML <script> elements expose the HTMLScriptElement interface, which provides special properties and methods for manipulating the behavior and execution of <script> elements (beyond the inherited HTMLElement interface). */\ninterface HTMLScriptElement extends HTMLElement {\n    async: boolean;\n    /**\n     * Sets or retrieves the character set used to encode the object.\n     */\n    /** @deprecated */\n    charset: string;\n    crossOrigin: string | null;\n    /**\n     * Sets or retrieves the status of the script.\n     */\n    defer: boolean;\n    /**\n     * Sets or retrieves the event for which the script is written.\n     */\n    /** @deprecated */\n    event: string;\n    /**\n     * Sets or retrieves the object that is bound to the event script.\n     */\n    /** @deprecated */\n    htmlFor: string;\n    integrity: string;\n    noModule: boolean;\n    referrerPolicy: string;\n    /**\n     * Retrieves the URL to an external file that contains the source code or data.\n     */\n    src: string;\n    /**\n     * Retrieves or sets the text of the object as a string.\n     */\n    text: string;\n    /**\n     * Sets or retrieves the MIME type for the associated scripting engine.\n     */\n    type: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLScriptElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLScriptElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLScriptElement: {\n    prototype: HTMLScriptElement;\n    new(): HTMLScriptElement;\n};\n\n/** A <select> HTML Element. These elements also share all of the properties and methods of other HTML elements via the HTMLElement interface. */\ninterface HTMLSelectElement extends HTMLElement {\n    autocomplete: string;\n    /**\n     * Provides a way to direct a user to a specific field when a document loads. This can provide both direction and convenience for a user, reducing the need to click or tab to a field when a page opens. This attribute is true when present on an element, and false when missing.\n     */\n    autofocus: boolean;\n    disabled: boolean;\n    /**\n     * Retrieves a reference to the form that the object is embedded in.\n     */\n    readonly form: HTMLFormElement | null;\n    readonly labels: NodeListOf<HTMLLabelElement>;\n    /**\n     * Sets or retrieves the number of objects in a collection.\n     */\n    length: number;\n    /**\n     * Sets or retrieves the Boolean value indicating whether multiple items can be selected from a list.\n     */\n    multiple: boolean;\n    /**\n     * Sets or retrieves the name of the object.\n     */\n    name: string;\n    readonly options: HTMLOptionsCollection;\n    /**\n     * When present, marks an element that can\'t be submitted without a value.\n     */\n    required: boolean;\n    /**\n     * Sets or retrieves the index of the selected option in a select object.\n     */\n    selectedIndex: number;\n    readonly selectedOptions: HTMLCollectionOf<HTMLOptionElement>;\n    /**\n     * Sets or retrieves the number of rows in the list box.\n     */\n    size: number;\n    /**\n     * Retrieves the type of select control based on the value of the MULTIPLE attribute.\n     */\n    readonly type: string;\n    /**\n     * Returns the error message that would be displayed if the user submits the form, or an empty string if no error message. It also triggers the standard error message, such as "this is a required field". The result is that the user sees validation messages without actually submitting.\n     */\n    readonly validationMessage: string;\n    /**\n     * Returns a  ValidityState object that represents the validity states of an element.\n     */\n    readonly validity: ValidityState;\n    /**\n     * Sets or retrieves the value which is returned to the server when the form control is submitted.\n     */\n    value: string;\n    /**\n     * Returns whether an element will successfully validate based on forms validation rules and constraints.\n     */\n    readonly willValidate: boolean;\n    /**\n     * Adds an element to the areas, controlRange, or options collection.\n     * @param element Variant of type Number that specifies the index position in the collection where the element is placed. If no value is given, the method places the element at the end of the collection.\n     * @param before Variant of type Object that specifies an element to insert before, or null to append the object to the collection.\n     */\n    add(element: HTMLOptionElement | HTMLOptGroupElement, before?: HTMLElement | number | null): void;\n    /**\n     * Returns whether a form will validate when it is submitted, without having to submit it.\n     */\n    checkValidity(): boolean;\n    /**\n     * Retrieves a select object or an object from an options collection.\n     * @param name Variant of type Number or String that specifies the object or collection to retrieve. If this parameter is an integer, it is the zero-based index of the object. If this parameter is a string, all objects with matching name or id properties are retrieved, and a collection is returned if more than one match is made.\n     * @param index Variant of type Number that specifies the zero-based index of the object to retrieve when a collection is returned.\n     */\n    item(index: number): Element | null;\n    /**\n     * Retrieves a select object or an object from an options collection.\n     * @param namedItem A String that specifies the name or id property of the object to retrieve. A collection is returned if more than one match is made.\n     */\n    namedItem(name: string): HTMLOptionElement | null;\n    /**\n     * Removes an element from the collection.\n     * @param index Number that specifies the zero-based index of the element to remove from the collection.\n     */\n    remove(): void;\n    remove(index: number): void;\n    reportValidity(): boolean;\n    /**\n     * Sets a custom error message that is displayed when a form is submitted.\n     * @param error Sets a custom error message that is displayed when a form is submitted.\n     */\n    setCustomValidity(error: string): void;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLSelectElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLSelectElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n    [name: number]: HTMLOptionElement | HTMLOptGroupElement;\n}\n\ndeclare var HTMLSelectElement: {\n    prototype: HTMLSelectElement;\n    new(): HTMLSelectElement;\n};\n\ninterface HTMLSlotElement extends HTMLElement {\n    name: string;\n    assignedElements(options?: AssignedNodesOptions): Element[];\n    assignedNodes(options?: AssignedNodesOptions): Node[];\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLSlotElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLSlotElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLSlotElement: {\n    prototype: HTMLSlotElement;\n    new(): HTMLSlotElement;\n};\n\n/** Provides special properties (beyond the regular HTMLElement object interface it also has available to it by inheritance) for manipulating <source> elements. */\ninterface HTMLSourceElement extends HTMLElement {\n    /**\n     * Gets or sets the intended media type of the media source.\n     */\n    media: string;\n    sizes: string;\n    /**\n     * The address or URL of the a media resource that is to be considered.\n     */\n    src: string;\n    srcset: string;\n    /**\n     * Gets or sets the MIME type of a media resource.\n     */\n    type: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLSourceElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLSourceElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLSourceElement: {\n    prototype: HTMLSourceElement;\n    new(): HTMLSourceElement;\n};\n\n/** A <span> element and derives from the HTMLElement interface, but without implementing any additional properties or methods. */\ninterface HTMLSpanElement extends HTMLElement {\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLSpanElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLSpanElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLSpanElement: {\n    prototype: HTMLSpanElement;\n    new(): HTMLSpanElement;\n};\n\n/** A <style> element. It inherits properties and methods from its parent, HTMLElement, and from LinkStyle. */\ninterface HTMLStyleElement extends HTMLElement, LinkStyle {\n    /**\n     * Sets or retrieves the media type.\n     */\n    media: string;\n    /**\n     * Retrieves the CSS language in which the style sheet is written.\n     */\n    /** @deprecated */\n    type: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLStyleElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLStyleElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLStyleElement: {\n    prototype: HTMLStyleElement;\n    new(): HTMLStyleElement;\n};\n\n/** Special properties (beyond the regular HTMLElement interface it also has available to it by inheritance) for manipulating table caption elements. */\ninterface HTMLTableCaptionElement extends HTMLElement {\n    /**\n     * Sets or retrieves the alignment of the caption or legend.\n     */\n    /** @deprecated */\n    align: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableCaptionElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableCaptionElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLTableCaptionElement: {\n    prototype: HTMLTableCaptionElement;\n    new(): HTMLTableCaptionElement;\n};\n\n/** Provides special properties and methods (beyond the regular HTMLElement interface it also has available to it by inheritance) for manipulating the layout and presentation of table cells, either header or data cells, in an HTML document. */\ninterface HTMLTableCellElement extends HTMLElement {\n    /**\n     * Sets or retrieves abbreviated text for the object.\n     */\n    abbr: string;\n    /**\n     * Sets or retrieves how the object is aligned with adjacent text.\n     */\n    /** @deprecated */\n    align: string;\n    /**\n     * Sets or retrieves a comma-delimited list of conceptual categories associated with the object.\n     */\n    /** @deprecated */\n    axis: string;\n    /** @deprecated */\n    bgColor: string;\n    /**\n     * Retrieves the position of the object in the cells collection of a row.\n     */\n    readonly cellIndex: number;\n    /** @deprecated */\n    ch: string;\n    /** @deprecated */\n    chOff: string;\n    /**\n     * Sets or retrieves the number columns in the table that the object should span.\n     */\n    colSpan: number;\n    /**\n     * Sets or retrieves a list of header cells that provide information for the object.\n     */\n    headers: string;\n    /**\n     * Sets or retrieves the height of the object.\n     */\n    /** @deprecated */\n    height: string;\n    /**\n     * Sets or retrieves whether the browser automatically performs wordwrap.\n     */\n    /** @deprecated */\n    noWrap: boolean;\n    /**\n     * Sets or retrieves how many rows in a table the cell should span.\n     */\n    rowSpan: number;\n    /**\n     * Sets or retrieves the group of cells in a table to which the object\'s information applies.\n     */\n    scope: string;\n    /** @deprecated */\n    vAlign: string;\n    /**\n     * Sets or retrieves the width of the object.\n     */\n    /** @deprecated */\n    width: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableCellElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableCellElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLTableCellElement: {\n    prototype: HTMLTableCellElement;\n    new(): HTMLTableCellElement;\n};\n\n/** Provides special properties (beyond the HTMLElement interface it also has available to it inheritance) for manipulating single or grouped table column elements. */\ninterface HTMLTableColElement extends HTMLElement {\n    /**\n     * Sets or retrieves the alignment of the object relative to the display or table.\n     */\n    /** @deprecated */\n    align: string;\n    /** @deprecated */\n    ch: string;\n    /** @deprecated */\n    chOff: string;\n    /**\n     * Sets or retrieves the number of columns in the group.\n     */\n    span: number;\n    /** @deprecated */\n    vAlign: string;\n    /**\n     * Sets or retrieves the width of the object.\n     */\n    /** @deprecated */\n    width: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableColElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableColElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLTableColElement: {\n    prototype: HTMLTableColElement;\n    new(): HTMLTableColElement;\n};\n\ninterface HTMLTableDataCellElement extends HTMLTableCellElement {\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableDataCellElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableDataCellElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLTableDataCellElement: {\n    prototype: HTMLTableDataCellElement;\n    new(): HTMLTableDataCellElement;\n};\n\n/** Provides special properties and methods (beyond the regular HTMLElement object interface it also has available to it by inheritance) for manipulating the layout and presentation of tables in an HTML document. */\ninterface HTMLTableElement extends HTMLElement {\n    /**\n     * Sets or retrieves a value that indicates the table alignment.\n     */\n    /** @deprecated */\n    align: string;\n    /** @deprecated */\n    bgColor: string;\n    /**\n     * Sets or retrieves the width of the border to draw around the object.\n     */\n    /** @deprecated */\n    border: string;\n    /**\n     * Retrieves the caption object of a table.\n     */\n    caption: HTMLTableCaptionElement | null;\n    /**\n     * Sets or retrieves the amount of space between the border of the cell and the content of the cell.\n     */\n    /** @deprecated */\n    cellPadding: string;\n    /**\n     * Sets or retrieves the amount of space between cells in a table.\n     */\n    /** @deprecated */\n    cellSpacing: string;\n    /**\n     * Sets or retrieves the way the border frame around the table is displayed.\n     */\n    /** @deprecated */\n    frame: string;\n    /**\n     * Sets or retrieves the number of horizontal rows contained in the object.\n     */\n    readonly rows: HTMLCollectionOf<HTMLTableRowElement>;\n    /**\n     * Sets or retrieves which dividing lines (inner borders) are displayed.\n     */\n    /** @deprecated */\n    rules: string;\n    /**\n     * Sets or retrieves a description and/or structure of the object.\n     */\n    /** @deprecated */\n    summary: string;\n    /**\n     * Retrieves a collection of all tBody objects in the table. Objects in this collection are in source order.\n     */\n    readonly tBodies: HTMLCollectionOf<HTMLTableSectionElement>;\n    /**\n     * Retrieves the tFoot object of the table.\n     */\n    tFoot: HTMLTableSectionElement | null;\n    /**\n     * Retrieves the tHead object of the table.\n     */\n    tHead: HTMLTableSectionElement | null;\n    /**\n     * Sets or retrieves the width of the object.\n     */\n    /** @deprecated */\n    width: string;\n    /**\n     * Creates an empty caption element in the table.\n     */\n    createCaption(): HTMLTableCaptionElement;\n    /**\n     * Creates an empty tBody element in the table.\n     */\n    createTBody(): HTMLTableSectionElement;\n    /**\n     * Creates an empty tFoot element in the table.\n     */\n    createTFoot(): HTMLTableSectionElement;\n    /**\n     * Returns the tHead element object if successful, or null otherwise.\n     */\n    createTHead(): HTMLTableSectionElement;\n    /**\n     * Deletes the caption element and its contents from the table.\n     */\n    deleteCaption(): void;\n    /**\n     * Removes the specified row (tr) from the element and from the rows collection.\n     * @param index Number that specifies the zero-based position in the rows collection of the row to remove.\n     */\n    deleteRow(index: number): void;\n    /**\n     * Deletes the tFoot element and its contents from the table.\n     */\n    deleteTFoot(): void;\n    /**\n     * Deletes the tHead element and its contents from the table.\n     */\n    deleteTHead(): void;\n    /**\n     * Creates a new row (tr) in the table, and adds the row to the rows collection.\n     * @param index Number that specifies where to insert the row in the rows collection. The default value is -1, which appends the new row to the end of the rows collection.\n     */\n    insertRow(index?: number): HTMLTableRowElement;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLTableElement: {\n    prototype: HTMLTableElement;\n    new(): HTMLTableElement;\n};\n\ninterface HTMLTableHeaderCellElement extends HTMLTableCellElement {\n    scope: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableHeaderCellElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableHeaderCellElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLTableHeaderCellElement: {\n    prototype: HTMLTableHeaderCellElement;\n    new(): HTMLTableHeaderCellElement;\n};\n\n/** Provides special properties and methods (beyond the HTMLElement interface it also has available to it by inheritance) for manipulating the layout and presentation of rows in an HTML table. */\ninterface HTMLTableRowElement extends HTMLElement {\n    /**\n     * Sets or retrieves how the object is aligned with adjacent text.\n     */\n    /** @deprecated */\n    align: string;\n    /** @deprecated */\n    bgColor: string;\n    /**\n     * Retrieves a collection of all cells in the table row.\n     */\n    readonly cells: HTMLCollectionOf<HTMLTableDataCellElement | HTMLTableHeaderCellElement>;\n    /** @deprecated */\n    ch: string;\n    /** @deprecated */\n    chOff: string;\n    /**\n     * Retrieves the position of the object in the rows collection for the table.\n     */\n    readonly rowIndex: number;\n    /**\n     * Retrieves the position of the object in the collection.\n     */\n    readonly sectionRowIndex: number;\n    /** @deprecated */\n    vAlign: string;\n    /**\n     * Removes the specified cell from the table row, as well as from the cells collection.\n     * @param index Number that specifies the zero-based position of the cell to remove from the table row. If no value is provided, the last cell in the cells collection is deleted.\n     */\n    deleteCell(index: number): void;\n    /**\n     * Creates a new cell in the table row, and adds the cell to the cells collection.\n     * @param index Number that specifies where to insert the cell in the tr. The default value is -1, which appends the new cell to the end of the cells collection.\n     */\n    insertCell(index?: number): HTMLTableDataCellElement;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableRowElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableRowElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLTableRowElement: {\n    prototype: HTMLTableRowElement;\n    new(): HTMLTableRowElement;\n};\n\n/** Provides special properties and methods (beyond the HTMLElement interface it also has available to it by inheritance) for manipulating the layout and presentation of sections, that is headers, footers and bodies, in an HTML table. */\ninterface HTMLTableSectionElement extends HTMLElement {\n    /**\n     * Sets or retrieves a value that indicates the table alignment.\n     */\n    /** @deprecated */\n    align: string;\n    /** @deprecated */\n    ch: string;\n    /** @deprecated */\n    chOff: string;\n    /**\n     * Sets or retrieves the number of horizontal rows contained in the object.\n     */\n    readonly rows: HTMLCollectionOf<HTMLTableRowElement>;\n    /** @deprecated */\n    vAlign: string;\n    /**\n     * Removes the specified row (tr) from the element and from the rows collection.\n     * @param index Number that specifies the zero-based position in the rows collection of the row to remove.\n     */\n    deleteRow(index: number): void;\n    /**\n     * Creates a new row (tr) in the table, and adds the row to the rows collection.\n     * @param index Number that specifies where to insert the row in the rows collection. The default value is -1, which appends the new row to the end of the rows collection.\n     */\n    insertRow(index?: number): HTMLTableRowElement;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableSectionElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTableSectionElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLTableSectionElement: {\n    prototype: HTMLTableSectionElement;\n    new(): HTMLTableSectionElement;\n};\n\n/** Enables access to the contents of an HTML <template> element. */\ninterface HTMLTemplateElement extends HTMLElement {\n    readonly content: DocumentFragment;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTemplateElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTemplateElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLTemplateElement: {\n    prototype: HTMLTemplateElement;\n    new(): HTMLTemplateElement;\n};\n\n/** Provides special properties and methods for manipulating the layout and presentation of <textarea> elements. */\ninterface HTMLTextAreaElement extends HTMLElement {\n    autocomplete: string;\n    /**\n     * Provides a way to direct a user to a specific field when a document loads. This can provide both direction and convenience for a user, reducing the need to click or tab to a field when a page opens. This attribute is true when present on an element, and false when missing.\n     */\n    autofocus: boolean;\n    /**\n     * Sets or retrieves the width of the object.\n     */\n    cols: number;\n    /**\n     * Sets or retrieves the initial contents of the object.\n     */\n    defaultValue: string;\n    dirName: string;\n    disabled: boolean;\n    /**\n     * Retrieves a reference to the form that the object is embedded in.\n     */\n    readonly form: HTMLFormElement | null;\n    readonly labels: NodeListOf<HTMLLabelElement>;\n    /**\n     * Sets or retrieves the maximum number of characters that the user can enter in a text control.\n     */\n    maxLength: number;\n    minLength: number;\n    /**\n     * Sets or retrieves the name of the object.\n     */\n    name: string;\n    /**\n     * Gets or sets a text string that is displayed in an input field as a hint or prompt to users as the format or type of information they need to enter.The text appears in an input field until the user puts focus on the field.\n     */\n    placeholder: string;\n    /**\n     * Sets or retrieves the value indicated whether the content of the object is read-only.\n     */\n    readOnly: boolean;\n    /**\n     * When present, marks an element that can\'t be submitted without a value.\n     */\n    required: boolean;\n    /**\n     * Sets or retrieves the number of horizontal rows contained in the object.\n     */\n    rows: number;\n    selectionDirection: string;\n    /**\n     * Gets or sets the end position or offset of a text selection.\n     */\n    selectionEnd: number;\n    /**\n     * Gets or sets the starting position or offset of a text selection.\n     */\n    selectionStart: number;\n    readonly textLength: number;\n    /**\n     * Retrieves the type of control.\n     */\n    readonly type: string;\n    /**\n     * Returns the error message that would be displayed if the user submits the form, or an empty string if no error message. It also triggers the standard error message, such as "this is a required field". The result is that the user sees validation messages without actually submitting.\n     */\n    readonly validationMessage: string;\n    /**\n     * Returns a  ValidityState object that represents the validity states of an element.\n     */\n    readonly validity: ValidityState;\n    /**\n     * Retrieves or sets the text in the entry field of the textArea element.\n     */\n    value: string;\n    /**\n     * Returns whether an element will successfully validate based on forms validation rules and constraints.\n     */\n    readonly willValidate: boolean;\n    /**\n     * Sets or retrieves how to handle wordwrapping in the object.\n     */\n    wrap: string;\n    /**\n     * Returns whether a form will validate when it is submitted, without having to submit it.\n     */\n    checkValidity(): boolean;\n    reportValidity(): boolean;\n    /**\n     * Highlights the input area of a form element.\n     */\n    select(): void;\n    /**\n     * Sets a custom error message that is displayed when a form is submitted.\n     * @param error Sets a custom error message that is displayed when a form is submitted.\n     */\n    setCustomValidity(error: string): void;\n    setRangeText(replacement: string): void;\n    setRangeText(replacement: string, start: number, end: number, selectionMode?: SelectionMode): void;\n    /**\n     * Sets the start and end positions of a selection in a text field.\n     * @param start The offset into the text field for the start of the selection.\n     * @param end The offset into the text field for the end of the selection.\n     * @param direction The direction in which the selection is performed.\n     */\n    setSelectionRange(start: number, end: number, direction?: "forward" | "backward" | "none"): void;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTextAreaElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTextAreaElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLTextAreaElement: {\n    prototype: HTMLTextAreaElement;\n    new(): HTMLTextAreaElement;\n};\n\n/** Provides special properties (beyond the regular HTMLElement interface it also has available to it by inheritance) for manipulating <time> elements. */\ninterface HTMLTimeElement extends HTMLElement {\n    dateTime: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTimeElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTimeElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLTimeElement: {\n    prototype: HTMLTimeElement;\n    new(): HTMLTimeElement;\n};\n\n/** Contains the title for a document. This element inherits all of the properties and methods of the HTMLElement interface. */\ninterface HTMLTitleElement extends HTMLElement {\n    /**\n     * Retrieves or sets the text of the object as a string.\n     */\n    text: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTitleElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTitleElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLTitleElement: {\n    prototype: HTMLTitleElement;\n    new(): HTMLTitleElement;\n};\n\n/** The HTMLTrackElement */\ninterface HTMLTrackElement extends HTMLElement {\n    default: boolean;\n    kind: string;\n    label: string;\n    readonly readyState: number;\n    src: string;\n    srclang: string;\n    readonly track: TextTrack;\n    readonly ERROR: number;\n    readonly LOADED: number;\n    readonly LOADING: number;\n    readonly NONE: number;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTrackElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLTrackElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLTrackElement: {\n    prototype: HTMLTrackElement;\n    new(): HTMLTrackElement;\n    readonly ERROR: number;\n    readonly LOADED: number;\n    readonly LOADING: number;\n    readonly NONE: number;\n};\n\n/** Provides special properties (beyond those defined on the regular HTMLElement interface it also has available to it by inheritance) for manipulating unordered list elements. */\ninterface HTMLUListElement extends HTMLElement {\n    /** @deprecated */\n    compact: boolean;\n    /** @deprecated */\n    type: string;\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLUListElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLUListElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLUListElement: {\n    prototype: HTMLUListElement;\n    new(): HTMLUListElement;\n};\n\n/** An invalid HTML element and derives from the HTMLElement interface, but without implementing any additional properties or methods. */\ninterface HTMLUnknownElement extends HTMLElement {\n    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLUnknownElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLUnknownElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLUnknownElement: {\n    prototype: HTMLUnknownElement;\n    new(): HTMLUnknownElement;\n};\n\ninterface HTMLVideoElementEventMap extends HTMLMediaElementEventMap {\n    "MSVideoFormatChanged": Event;\n    "MSVideoFrameStepCompleted": Event;\n    "MSVideoOptimalLayoutChanged": Event;\n}\n\n/** Provides special properties and methods for manipulating video objects. It also inherits properties and methods of HTMLMediaElement and HTMLElement. */\ninterface HTMLVideoElement extends HTMLMediaElement {\n    /**\n     * Gets or sets the height of the video element.\n     */\n    height: number;\n    msHorizontalMirror: boolean;\n    readonly msIsLayoutOptimalForPlayback: boolean;\n    readonly msIsStereo3D: boolean;\n    msStereo3DPackingMode: string;\n    msStereo3DRenderMode: string;\n    msZoom: boolean;\n    onMSVideoFormatChanged: ((this: HTMLVideoElement, ev: Event) => any) | null;\n    onMSVideoFrameStepCompleted: ((this: HTMLVideoElement, ev: Event) => any) | null;\n    onMSVideoOptimalLayoutChanged: ((this: HTMLVideoElement, ev: Event) => any) | null;\n    /**\n     * Gets or sets a URL of an image to display, for example, like a movie poster. This can be a still frame from the video, or another image if no video data is available.\n     */\n    poster: string;\n    /**\n     * Gets the intrinsic height of a video in CSS pixels, or zero if the dimensions are not known.\n     */\n    readonly videoHeight: number;\n    /**\n     * Gets the intrinsic width of a video in CSS pixels, or zero if the dimensions are not known.\n     */\n    readonly videoWidth: number;\n    readonly webkitDisplayingFullscreen: boolean;\n    readonly webkitSupportsFullscreen: boolean;\n    /**\n     * Gets or sets the width of the video element.\n     */\n    width: number;\n    getVideoPlaybackQuality(): VideoPlaybackQuality;\n    msFrameStep(forward: boolean): void;\n    msInsertVideoEffect(activatableClassId: string, effectRequired: boolean, config?: any): void;\n    msSetVideoRectangle(left: number, top: number, right: number, bottom: number): void;\n    webkitEnterFullScreen(): void;\n    webkitEnterFullscreen(): void;\n    webkitExitFullScreen(): void;\n    webkitExitFullscreen(): void;\n    addEventListener<K extends keyof HTMLVideoElementEventMap>(type: K, listener: (this: HTMLVideoElement, ev: HTMLVideoElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof HTMLVideoElementEventMap>(type: K, listener: (this: HTMLVideoElement, ev: HTMLVideoElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var HTMLVideoElement: {\n    prototype: HTMLVideoElement;\n    new(): HTMLVideoElement;\n};\n\n/** Events that fire when the fragment identifier of the URL has changed. */\ninterface HashChangeEvent extends Event {\n    readonly newURL: string;\n    readonly oldURL: string;\n}\n\ndeclare var HashChangeEvent: {\n    prototype: HashChangeEvent;\n    new(type: string, eventInitDict?: HashChangeEventInit): HashChangeEvent;\n};\n\n/** An interface of the Fetch API allows you to perform various actions on HTTP request and response headers. These actions include retrieving, setting, adding to, and removing. A Headers object has an associated header list, which is initially empty and consists of zero or more name and value pairs.  You can add to this using methods like append() (see Examples.) In all methods of this interface, header names are matched by case-insensitive byte sequence. */\ninterface Headers {\n    append(name: string, value: string): void;\n    delete(name: string): void;\n    get(name: string): string | null;\n    has(name: string): boolean;\n    set(name: string, value: string): void;\n    forEach(callbackfn: (value: string, key: string, parent: Headers) => void, thisArg?: any): void;\n}\n\ndeclare var Headers: {\n    prototype: Headers;\n    new(init?: HeadersInit): Headers;\n};\n\n/** Allows manipulation of the browser session history, that is the pages visited in the tab or frame that the current page is loaded in. */\ninterface History {\n    readonly length: number;\n    scrollRestoration: ScrollRestoration;\n    readonly state: any;\n    back(): void;\n    forward(): void;\n    go(delta?: number): void;\n    pushState(data: any, title: string, url?: string | null): void;\n    replaceState(data: any, title: string, url?: string | null): void;\n}\n\ndeclare var History: {\n    prototype: History;\n    new(): History;\n};\n\ninterface HkdfCtrParams extends Algorithm {\n    context: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer;\n    hash: string | Algorithm;\n    label: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer;\n}\n\ninterface IDBArrayKey extends Array<IDBValidKey> {\n}\n\n/** An interface of the IndexedDB API represents a cursor for traversing or iterating over multiple records in a database. */\ninterface IDBCursor {\n    /**\n     * Returns the direction ("next", "nextunique", "prev" or "prevunique")\n     * of the cursor.\n     */\n    readonly direction: IDBCursorDirection;\n    /**\n     * Returns the key of the cursor.\n     * Throws a "InvalidStateError" DOMException if the cursor is advancing or is finished.\n     */\n    readonly key: IDBValidKey;\n    /**\n     * Returns the effective key of the cursor.\n     * Throws a "InvalidStateError" DOMException if the cursor is advancing or is finished.\n     */\n    readonly primaryKey: IDBValidKey;\n    /**\n     * Returns the IDBObjectStore or IDBIndex the cursor was opened from.\n     */\n    readonly source: IDBObjectStore | IDBIndex;\n    /**\n     * Advances the cursor through the next count records in\n     * range.\n     */\n    advance(count: number): void;\n    /**\n     * Advances the cursor to the next record in range matching or\n     * after key.\n     */\n    continue(key?: IDBValidKey): void;\n    /**\n     * Advances the cursor to the next record in range matching\n     * or after key and primaryKey. Throws an "InvalidAccessError" DOMException if the source is not an index.\n     */\n    continuePrimaryKey(key: IDBValidKey, primaryKey: IDBValidKey): void;\n    /**\n     * Delete the record pointed at by the cursor with a new value.\n     * If successful, request\'s result will be undefined.\n     */\n    delete(): IDBRequest<undefined>;\n    /**\n     * Updated the record pointed at by the cursor with a new value.\n     * Throws a "DataError" DOMException if the effective object store uses in-line keys and the key would have changed.\n     * If successful, request\'s result will be the record\'s key.\n     */\n    update(value: any): IDBRequest<IDBValidKey>;\n}\n\ndeclare var IDBCursor: {\n    prototype: IDBCursor;\n    new(): IDBCursor;\n};\n\n/** An interface of the IndexedDB API represents a cursor for traversing or iterating over multiple records in a database. It is the same as the IDBCursor, except that it includes the value property. */\ninterface IDBCursorWithValue extends IDBCursor {\n    /**\n     * Returns the cursor\'s current value.\n     */\n    readonly value: any;\n}\n\ndeclare var IDBCursorWithValue: {\n    prototype: IDBCursorWithValue;\n    new(): IDBCursorWithValue;\n};\n\ninterface IDBDatabaseEventMap {\n    "abort": Event;\n    "close": Event;\n    "error": Event;\n    "versionchange": IDBVersionChangeEvent;\n}\n\n/** An interface of the IndexedDB API provides a connection to a database; you can use an IDBDatabase object to open a transaction on your database then create, manipulate, and delete objects (data) in that database. The interface provides the only way to get and manage versions of the database. */\ninterface IDBDatabase extends EventTarget {\n    /**\n     * Returns the name of the database.\n     */\n    readonly name: string;\n    /**\n     * Returns a list of the names of object stores in the database.\n     */\n    readonly objectStoreNames: DOMStringList;\n    onabort: ((this: IDBDatabase, ev: Event) => any) | null;\n    onclose: ((this: IDBDatabase, ev: Event) => any) | null;\n    onerror: ((this: IDBDatabase, ev: Event) => any) | null;\n    onversionchange: ((this: IDBDatabase, ev: IDBVersionChangeEvent) => any) | null;\n    /**\n     * Returns the version of the database.\n     */\n    readonly version: number;\n    /**\n     * Closes the connection once all running transactions have finished.\n     */\n    close(): void;\n    /**\n     * Creates a new object store with the given name and options and returns a new IDBObjectStore.\n     * Throws a "InvalidStateError" DOMException if not called within an upgrade transaction.\n     */\n    createObjectStore(name: string, optionalParameters?: IDBObjectStoreParameters): IDBObjectStore;\n    /**\n     * Deletes the object store with the given name.\n     * Throws a "InvalidStateError" DOMException if not called within an upgrade transaction.\n     */\n    deleteObjectStore(name: string): void;\n    /**\n     * Returns a new transaction with the given mode ("readonly" or "readwrite")\n     * and scope which can be a single object store name or an array of names.\n     */\n    transaction(storeNames: string | string[], mode?: IDBTransactionMode): IDBTransaction;\n    addEventListener<K extends keyof IDBDatabaseEventMap>(type: K, listener: (this: IDBDatabase, ev: IDBDatabaseEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof IDBDatabaseEventMap>(type: K, listener: (this: IDBDatabase, ev: IDBDatabaseEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var IDBDatabase: {\n    prototype: IDBDatabase;\n    new(): IDBDatabase;\n};\n\ninterface IDBEnvironment {\n    readonly indexedDB: IDBFactory;\n}\n\n/** In the following code snippet, we make a request to open a database, and include handlers for the success and error cases. For a full working example, see our To-do Notifications app (view example live.) */\ninterface IDBFactory {\n    /**\n     * Compares two values as keys. Returns -1 if key1 precedes key2, 1 if key2 precedes key1, and 0 if\n     * the keys are equal.\n     * Throws a "DataError" DOMException if either input is not a valid key.\n     */\n    cmp(first: any, second: any): number;\n    /**\n     * Attempts to delete the named database. If the\n     * database already exists and there are open connections that don\'t close in response to a versionchange event, the request will be blocked until all they close. If the request\n     * is successful request\'s result will be null.\n     */\n    deleteDatabase(name: string): IDBOpenDBRequest;\n    /**\n     * Attempts to open a connection to the named database with the specified version. If the database already exists\n     * with a lower version and there are open connections that don\'t close in response to a versionchange event, the request will be blocked until all they close, then an upgrade\n     * will occur. If the database already exists with a higher\n     * version the request will fail. If the request is\n     * successful request\'s result will\n     * be the connection.\n     */\n    open(name: string, version?: number): IDBOpenDBRequest;\n}\n\ndeclare var IDBFactory: {\n    prototype: IDBFactory;\n    new(): IDBFactory;\n};\n\n/** IDBIndex interface of the IndexedDB API provides asynchronous access to an index in a database. An index is a kind of object store for looking up records in another object store, called the referenced object store. You use this interface to retrieve data. */\ninterface IDBIndex {\n    readonly keyPath: string | string[];\n    readonly multiEntry: boolean;\n    /**\n     * Updates the name of the store to newName.\n     * Throws an "InvalidStateError" DOMException if not called within an upgrade\n     * transaction.\n     */\n    name: string;\n    /**\n     * Returns the IDBObjectStore the index belongs to.\n     */\n    readonly objectStore: IDBObjectStore;\n    readonly unique: boolean;\n    /**\n     * Retrieves the number of records matching the given key or key range in query.\n     * If successful, request\'s result will be the\n     * count.\n     */\n    count(key?: IDBValidKey | IDBKeyRange): IDBRequest<number>;\n    /**\n     * Retrieves the value of the first record matching the\n     * given key or key range in query.\n     * If successful, request\'s result will be the value, or undefined if there was no matching record.\n     */\n    get(key: IDBValidKey | IDBKeyRange): IDBRequest<any | undefined>;\n    /**\n     * Retrieves the values of the records matching the given key or key range in query (up to count if given).\n     * If successful, request\'s result will be an Array of the values.\n     */\n    getAll(query?: IDBValidKey | IDBKeyRange, count?: number): IDBRequest<any[]>;\n    /**\n     * Retrieves the keys of records matching the given key or key range in query (up to count if given).\n     * If successful, request\'s result will be an Array of the keys.\n     */\n    getAllKeys(query?: IDBValidKey | IDBKeyRange, count?: number): IDBRequest<IDBValidKey[]>;\n    /**\n     * Retrieves the key of the first record matching the\n     * given key or key range in query.\n     * If successful, request\'s result will be the key, or undefined if there was no matching record.\n     */\n    getKey(key: IDBValidKey | IDBKeyRange): IDBRequest<IDBValidKey | undefined>;\n    /**\n     * Opens a cursor over the records matching query,\n     * ordered by direction. If query is null, all records in index are matched.\n     * If successful, request\'s result will be an IDBCursorWithValue, or null if there were no matching records.\n     */\n    openCursor(range?: IDBValidKey | IDBKeyRange, direction?: IDBCursorDirection): IDBRequest<IDBCursorWithValue | null>;\n    /**\n     * Opens a cursor with key only flag set over the records matching query, ordered by direction. If query is null, all records in index are matched.\n     * If successful, request\'s result will be an IDBCursor, or null if there were no matching records.\n     */\n    openKeyCursor(range?: IDBValidKey | IDBKeyRange, direction?: IDBCursorDirection): IDBRequest<IDBCursor | null>;\n}\n\ndeclare var IDBIndex: {\n    prototype: IDBIndex;\n    new(): IDBIndex;\n};\n\n/** A key range can be a single value or a range with upper and lower bounds or endpoints. If the key range has both upper and lower bounds, then it is bounded; if it has no bounds, it is unbounded. A bounded key range can either be open (the endpoints are excluded) or closed (the endpoints are included). To retrieve all keys within a certain range, you can use the following code constructs: */\ninterface IDBKeyRange {\n    /**\n     * Returns lower bound, or undefined if none.\n     */\n    readonly lower: any;\n    /**\n     * Returns true if the lower open flag is set, and false otherwise.\n     */\n    readonly lowerOpen: boolean;\n    /**\n     * Returns upper bound, or undefined if none.\n     */\n    readonly upper: any;\n    /**\n     * Returns true if the upper open flag is set, and false otherwise.\n     */\n    readonly upperOpen: boolean;\n    /**\n     * Returns true if key is included in the range, and false otherwise.\n     */\n    includes(key: any): boolean;\n}\n\ndeclare var IDBKeyRange: {\n    prototype: IDBKeyRange;\n    new(): IDBKeyRange;\n    /**\n     * Returns a new IDBKeyRange spanning from lower to upper.\n     * If lowerOpen is true, lower is not included in the range.\n     * If upperOpen is true, upper is not included in the range.\n     */\n    bound(lower: any, upper: any, lowerOpen?: boolean, upperOpen?: boolean): IDBKeyRange;\n    /**\n     * Returns a new IDBKeyRange starting at key with no\n     * upper bound. If open is true, key is not included in the\n     * range.\n     */\n    lowerBound(lower: any, open?: boolean): IDBKeyRange;\n    /**\n     * Returns a new IDBKeyRange spanning only key.\n     */\n    only(value: any): IDBKeyRange;\n    /**\n     * Returns a new IDBKeyRange with no lower bound and ending at key. If open is true, key is not included in the range.\n     */\n    upperBound(upper: any, open?: boolean): IDBKeyRange;\n};\n\n/** This example shows a variety of different uses of object stores, from updating the data structure with IDBObjectStore.createIndex inside an onupgradeneeded function, to adding a new item to our object store with IDBObjectStore.add. For a full working example, see our To-do Notifications app (view example live.) */\ninterface IDBObjectStore {\n    /**\n     * Returns true if the store has a key generator, and false otherwise.\n     */\n    readonly autoIncrement: boolean;\n    /**\n     * Returns a list of the names of indexes in the store.\n     */\n    readonly indexNames: DOMStringList;\n    /**\n     * Returns the key path of the store, or null if none.\n     */\n    readonly keyPath: string | string[];\n    /**\n     * Updates the name of the store to newName.\n     * Throws "InvalidStateError" DOMException if not called within an upgrade\n     * transaction.\n     */\n    name: string;\n    /**\n     * Returns the associated transaction.\n     */\n    readonly transaction: IDBTransaction;\n    add(value: any, key?: IDBValidKey): IDBRequest<IDBValidKey>;\n    /**\n     * Deletes all records in store.\n     * If successful, request\'s result will\n     * be undefined.\n     */\n    clear(): IDBRequest<undefined>;\n    /**\n     * Retrieves the number of records matching the\n     * given key or key range in query.\n     * If successful, request\'s result will be the count.\n     */\n    count(key?: IDBValidKey | IDBKeyRange): IDBRequest<number>;\n    /**\n     * Creates a new index in store with the given name, keyPath and options and returns a new IDBIndex. If the keyPath and options define constraints that cannot be\n     * satisfied with the data already in store the upgrade\n     * transaction will abort with\n     * a "ConstraintError" DOMException.\n     * Throws an "InvalidStateError" DOMException if not called within an upgrade\n     * transaction.\n     */\n    createIndex(name: string, keyPath: string | string[], options?: IDBIndexParameters): IDBIndex;\n    /**\n     * Deletes records in store with the given key or in the given key range in query.\n     * If successful, request\'s result will\n     * be undefined.\n     */\n    delete(key: IDBValidKey | IDBKeyRange): IDBRequest<undefined>;\n    /**\n     * Deletes the index in store with the given name.\n     * Throws an "InvalidStateError" DOMException if not called within an upgrade\n     * transaction.\n     */\n    deleteIndex(name: string): void;\n    /**\n     * Retrieves the value of the first record matching the\n     * given key or key range in query.\n     * If successful, request\'s result will be the value, or undefined if there was no matching record.\n     */\n    get(query: IDBValidKey | IDBKeyRange): IDBRequest<any | undefined>;\n    /**\n     * Retrieves the values of the records matching the\n     * given key or key range in query (up to count if given).\n     * If successful, request\'s result will\n     * be an Array of the values.\n     */\n    getAll(query?: IDBValidKey | IDBKeyRange, count?: number): IDBRequest<any[]>;\n    /**\n     * Retrieves the keys of records matching the\n     * given key or key range in query (up to count if given).\n     * If successful, request\'s result will\n     * be an Array of the keys.\n     */\n    getAllKeys(query?: IDBValidKey | IDBKeyRange, count?: number): IDBRequest<IDBValidKey[]>;\n    /**\n     * Retrieves the key of the first record matching the\n     * given key or key range in query.\n     * If successful, request\'s result will be the key, or undefined if there was no matching record.\n     */\n    getKey(query: IDBValidKey | IDBKeyRange): IDBRequest<IDBValidKey | undefined>;\n    index(name: string): IDBIndex;\n    /**\n     * Opens a cursor over the records matching query,\n     * ordered by direction. If query is null, all records in store are matched.\n     * If successful, request\'s result will be an IDBCursorWithValue pointing at the first matching record, or null if there were no matching records.\n     */\n    openCursor(range?: IDBValidKey | IDBKeyRange, direction?: IDBCursorDirection): IDBRequest<IDBCursorWithValue | null>;\n    /**\n     * Opens a cursor with key only flag set over the records matching query, ordered by direction. If query is null, all records in store are matched.\n     * If successful, request\'s result will be an IDBCursor pointing at the first matching record, or\n     * null if there were no matching records.\n     */\n    openKeyCursor(query?: IDBValidKey | IDBKeyRange, direction?: IDBCursorDirection): IDBRequest<IDBCursor | null>;\n    put(value: any, key?: IDBValidKey): IDBRequest<IDBValidKey>;\n}\n\ndeclare var IDBObjectStore: {\n    prototype: IDBObjectStore;\n    new(): IDBObjectStore;\n};\n\ninterface IDBOpenDBRequestEventMap extends IDBRequestEventMap {\n    "blocked": Event;\n    "upgradeneeded": IDBVersionChangeEvent;\n}\n\n/** Also inherits methods from its parents IDBRequest and EventTarget. */\ninterface IDBOpenDBRequest extends IDBRequest<IDBDatabase> {\n    onblocked: ((this: IDBOpenDBRequest, ev: Event) => any) | null;\n    onupgradeneeded: ((this: IDBOpenDBRequest, ev: IDBVersionChangeEvent) => any) | null;\n    addEventListener<K extends keyof IDBOpenDBRequestEventMap>(type: K, listener: (this: IDBOpenDBRequest, ev: IDBOpenDBRequestEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof IDBOpenDBRequestEventMap>(type: K, listener: (this: IDBOpenDBRequest, ev: IDBOpenDBRequestEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var IDBOpenDBRequest: {\n    prototype: IDBOpenDBRequest;\n    new(): IDBOpenDBRequest;\n};\n\ninterface IDBRequestEventMap {\n    "error": Event;\n    "success": Event;\n}\n\n/** The request object does not initially contain any information about the result of the operation, but once information becomes available, an event is fired on the request, and the information becomes available through the properties of the IDBRequest instance. */\ninterface IDBRequest<T = any> extends EventTarget {\n    /**\n     * When a request is completed, returns the error (a DOMException), or null if the request succeeded. Throws\n     * a "InvalidStateError" DOMException if the request is still pending.\n     */\n    readonly error: DOMException | null;\n    onerror: ((this: IDBRequest<T>, ev: Event) => any) | null;\n    onsuccess: ((this: IDBRequest<T>, ev: Event) => any) | null;\n    /**\n     * Returns "pending" until a request is complete,\n     * then returns "done".\n     */\n    readonly readyState: IDBRequestReadyState;\n    /**\n     * When a request is completed, returns the result,\n     * or undefined if the request failed. Throws a\n     * "InvalidStateError" DOMException if the request is still pending.\n     */\n    readonly result: T;\n    /**\n     * Returns the IDBObjectStore, IDBIndex, or IDBCursor the request was made against, or null if is was an open\n     * request.\n     */\n    readonly source: IDBObjectStore | IDBIndex | IDBCursor;\n    /**\n     * Returns the IDBTransaction the request was made within.\n     * If this as an open request, then it returns an upgrade transaction while it is running, or null otherwise.\n     */\n    readonly transaction: IDBTransaction | null;\n    addEventListener<K extends keyof IDBRequestEventMap>(type: K, listener: (this: IDBRequest<T>, ev: IDBRequestEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof IDBRequestEventMap>(type: K, listener: (this: IDBRequest<T>, ev: IDBRequestEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var IDBRequest: {\n    prototype: IDBRequest;\n    new(): IDBRequest;\n};\n\ninterface IDBTransactionEventMap {\n    "abort": Event;\n    "complete": Event;\n    "error": Event;\n}\n\ninterface IDBTransaction extends EventTarget {\n    /**\n     * Returns the transaction\'s connection.\n     */\n    readonly db: IDBDatabase;\n    /**\n     * If the transaction was aborted, returns the\n     * error (a DOMException) providing the reason.\n     */\n    readonly error: DOMException;\n    /**\n     * Returns the mode the transaction was created with\n     * ("readonly" or "readwrite"), or "versionchange" for\n     * an upgrade transaction.\n     */\n    readonly mode: IDBTransactionMode;\n    /**\n     * Returns a list of the names of object stores in the\n     * transaction\'s scope. For an upgrade transaction this is all object stores in the database.\n     */\n    readonly objectStoreNames: DOMStringList;\n    onabort: ((this: IDBTransaction, ev: Event) => any) | null;\n    oncomplete: ((this: IDBTransaction, ev: Event) => any) | null;\n    onerror: ((this: IDBTransaction, ev: Event) => any) | null;\n    /**\n     * Aborts the transaction. All pending requests will fail with\n     * a "AbortError" DOMException and all changes made to the database will be\n     * reverted.\n     */\n    abort(): void;\n    /**\n     * Returns an IDBObjectStore in the transaction\'s scope.\n     */\n    objectStore(name: string): IDBObjectStore;\n    addEventListener<K extends keyof IDBTransactionEventMap>(type: K, listener: (this: IDBTransaction, ev: IDBTransactionEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof IDBTransactionEventMap>(type: K, listener: (this: IDBTransaction, ev: IDBTransactionEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var IDBTransaction: {\n    prototype: IDBTransaction;\n    new(): IDBTransaction;\n};\n\n/** An interface of the IndexedDB API indicates that the version of the database has changed, as the result of an IDBOpenDBRequest.onupgradeneeded event handler function. */\ninterface IDBVersionChangeEvent extends Event {\n    readonly newVersion: number | null;\n    readonly oldVersion: number;\n}\n\ndeclare var IDBVersionChangeEvent: {\n    prototype: IDBVersionChangeEvent;\n    new(type: string, eventInitDict?: IDBVersionChangeEventInit): IDBVersionChangeEvent;\n};\n\n/** The IIRFilterNode interface of the Web Audio API is a AudioNode processor which implements a general infinite impulse response (IIR)  filter; this type of filter can be used to implement tone control devices and graphic equalizers as well. It lets the parameters of the filter response be specified, so that it can be tuned as needed. */\ninterface IIRFilterNode extends AudioNode {\n    getFrequencyResponse(frequencyHz: Float32Array, magResponse: Float32Array, phaseResponse: Float32Array): void;\n}\n\ndeclare var IIRFilterNode: {\n    prototype: IIRFilterNode;\n    new(context: BaseAudioContext, options: IIRFilterOptions): IIRFilterNode;\n};\n\ninterface ImageBitmap {\n    /**\n     * Returns the intrinsic height of the image, in CSS\n     * pixels.\n     */\n    readonly height: number;\n    /**\n     * Returns the intrinsic width of the image, in CSS\n     * pixels.\n     */\n    readonly width: number;\n    /**\n     * Releases imageBitmap\'s underlying bitmap data.\n     */\n    close(): void;\n}\n\ndeclare var ImageBitmap: {\n    prototype: ImageBitmap;\n    new(): ImageBitmap;\n};\n\ninterface ImageBitmapOptions {\n    colorSpaceConversion?: "none" | "default";\n    imageOrientation?: "none" | "flipY";\n    premultiplyAlpha?: "none" | "premultiply" | "default";\n    resizeHeight?: number;\n    resizeQuality?: "pixelated" | "low" | "medium" | "high";\n    resizeWidth?: number;\n}\n\ninterface ImageBitmapRenderingContext {\n    /**\n     * Returns the canvas element that the context is bound to.\n     */\n    readonly canvas: HTMLCanvasElement;\n    /**\n     * Replaces contents of the canvas element to which context\n     * is bound with a transparent black bitmap whose size corresponds to the width and height\n     * content attributes of the canvas element.\n     */\n    transferFromImageBitmap(bitmap: ImageBitmap | null): void;\n}\n\ndeclare var ImageBitmapRenderingContext: {\n    prototype: ImageBitmapRenderingContext;\n    new(): ImageBitmapRenderingContext;\n};\n\n/** The underlying pixel data of an area of a <canvas> element. It is created using the ImageData() constructor or creator methods on the CanvasRenderingContext2D object associated with a canvas: createImageData() and getImageData(). It can also be used to set a part of the canvas by using putImageData(). */\ninterface ImageData {\n    /**\n     * Returns the one-dimensional array containing the data in RGBA order, as integers in the\n     * range 0 to 255.\n     */\n    readonly data: Uint8ClampedArray;\n    /**\n     * Returns the actual dimensions of the data in the ImageData object, in\n     * pixels.\n     */\n    readonly height: number;\n    readonly width: number;\n}\n\ndeclare var ImageData: {\n    prototype: ImageData;\n    new(width: number, height: number): ImageData;\n    new(array: Uint8ClampedArray, width: number, height: number): ImageData;\n};\n\ninterface InnerHTML {\n    innerHTML: string;\n}\n\ninterface InputDeviceInfo extends MediaDeviceInfo {\n    getCapabilities(): MediaTrackCapabilities;\n}\n\ndeclare var InputDeviceInfo: {\n    prototype: InputDeviceInfo;\n    new(): InputDeviceInfo;\n};\n\n/** provides a way to asynchronously observe changes in the intersection of a target element with an ancestor element or with a top-level document\'s viewport. */\ninterface IntersectionObserver {\n    readonly root: Element | null;\n    readonly rootMargin: string;\n    readonly thresholds: ReadonlyArray<number>;\n    disconnect(): void;\n    observe(target: Element): void;\n    takeRecords(): IntersectionObserverEntry[];\n    unobserve(target: Element): void;\n}\n\ndeclare var IntersectionObserver: {\n    prototype: IntersectionObserver;\n    new(callback: IntersectionObserverCallback, options?: IntersectionObserverInit): IntersectionObserver;\n};\n\n/** An interface of the Intersection Observer API describes the intersection between the target element and its root container at a specific moment of transition. */\ninterface IntersectionObserverEntry {\n    readonly boundingClientRect: ClientRect | DOMRect;\n    readonly intersectionRatio: number;\n    readonly intersectionRect: ClientRect | DOMRect;\n    readonly isIntersecting: boolean;\n    readonly rootBounds: ClientRect | DOMRect | null;\n    readonly target: Element;\n    readonly time: number;\n}\n\ndeclare var IntersectionObserverEntry: {\n    prototype: IntersectionObserverEntry;\n    new(intersectionObserverEntryInit: IntersectionObserverEntryInit): IntersectionObserverEntry;\n};\n\n/** KeyboardEvent objects describe a user interaction with the keyboard; each event describes a single interaction between the user and a key (or combination of a key with modifier keys) on the keyboard. */\ninterface KeyboardEvent extends UIEvent {\n    readonly altKey: boolean;\n    /** @deprecated */\n    char: string;\n    /** @deprecated */\n    readonly charCode: number;\n    readonly code: string;\n    readonly ctrlKey: boolean;\n    readonly key: string;\n    /** @deprecated */\n    readonly keyCode: number;\n    readonly location: number;\n    readonly metaKey: boolean;\n    readonly repeat: boolean;\n    readonly shiftKey: boolean;\n    /** @deprecated */\n    readonly which: number;\n    getModifierState(keyArg: string): boolean;\n    /** @deprecated */\n    initKeyboardEvent(typeArg: string, canBubbleArg: boolean, cancelableArg: boolean, viewArg: Window, keyArg: string, locationArg: number, modifiersListArg: string, repeat: boolean, locale: string): void;\n    readonly DOM_KEY_LOCATION_JOYSTICK: number;\n    readonly DOM_KEY_LOCATION_LEFT: number;\n    readonly DOM_KEY_LOCATION_MOBILE: number;\n    readonly DOM_KEY_LOCATION_NUMPAD: number;\n    readonly DOM_KEY_LOCATION_RIGHT: number;\n    readonly DOM_KEY_LOCATION_STANDARD: number;\n}\n\ndeclare var KeyboardEvent: {\n    prototype: KeyboardEvent;\n    new(typeArg: string, eventInitDict?: KeyboardEventInit): KeyboardEvent;\n    readonly DOM_KEY_LOCATION_JOYSTICK: number;\n    readonly DOM_KEY_LOCATION_LEFT: number;\n    readonly DOM_KEY_LOCATION_MOBILE: number;\n    readonly DOM_KEY_LOCATION_NUMPAD: number;\n    readonly DOM_KEY_LOCATION_RIGHT: number;\n    readonly DOM_KEY_LOCATION_STANDARD: number;\n};\n\ninterface KeyframeEffect extends AnimationEffect {\n    composite: CompositeOperation;\n    iterationComposite: IterationCompositeOperation;\n    target: Element | null;\n    getKeyframes(): ComputedKeyframe[];\n    setKeyframes(keyframes: Keyframe[] | PropertyIndexedKeyframes | null): void;\n}\n\ndeclare var KeyframeEffect: {\n    prototype: KeyframeEffect;\n    new(target: Element | null, keyframes: Keyframe[] | PropertyIndexedKeyframes | null, options?: number | KeyframeEffectOptions): KeyframeEffect;\n    new(source: KeyframeEffect): KeyframeEffect;\n};\n\ninterface LinkStyle {\n    readonly sheet: StyleSheet | null;\n}\n\ninterface ListeningStateChangedEvent extends Event {\n    readonly label: string;\n    readonly state: ListeningState;\n}\n\ndeclare var ListeningStateChangedEvent: {\n    prototype: ListeningStateChangedEvent;\n    new(): ListeningStateChangedEvent;\n};\n\n/** The location (URL) of the object it is linked to. Changes done on it are reflected on the object it relates to. Both the Document and Window interface have such a linked Location, accessible via Document.location and Window.location respectively. */\ninterface Location {\n    /**\n     * Returns a DOMStringList object listing the origins of the ancestor browsing contexts, from the parent browsing\n     * context to the top-level browsing context.\n     */\n    readonly ancestorOrigins: DOMStringList;\n    /**\n     * Returns the Location object\'s URL\'s fragment (includes leading "#" if non-empty).\n     * Can be set, to navigate to the same URL with a changed fragment (ignores leading "#").\n     */\n    hash: string;\n    /**\n     * Returns the Location object\'s URL\'s host and port (if different from the default\n     * port for the scheme).\n     * Can be set, to navigate to the same URL with a changed host and port.\n     */\n    host: string;\n    /**\n     * Returns the Location object\'s URL\'s host.\n     * Can be set, to navigate to the same URL with a changed host.\n     */\n    hostname: string;\n    /**\n     * Returns the Location object\'s URL.\n     * Can be set, to navigate to the given URL.\n     */\n    href: string;\n    /**\n     * Returns the Location object\'s URL\'s origin.\n     */\n    readonly origin: string;\n    /**\n     * Returns the Location object\'s URL\'s path.\n     * Can be set, to navigate to the same URL with a changed path.\n     */\n    pathname: string;\n    /**\n     * Returns the Location object\'s URL\'s port.\n     * Can be set, to navigate to the same URL with a changed port.\n     */\n    port: string;\n    /**\n     * Returns the Location object\'s URL\'s scheme.\n     * Can be set, to navigate to the same URL with a changed scheme.\n     */\n    protocol: string;\n    /**\n     * Returns the Location object\'s URL\'s query (includes leading "?" if non-empty).\n     * Can be set, to navigate to the same URL with a changed query (ignores leading "?").\n     */\n    search: string;\n    /**\n     * Navigates to the given URL.\n     */\n    assign(url: string): void;\n    /**\n     * Reloads the current page.\n     */\n    reload(): void;\n    /** @deprecated */\n    reload(forcedReload: boolean): void;\n    /**\n     * Removes the current page from the session history and navigates to the given URL.\n     */\n    replace(url: string): void;\n}\n\ndeclare var Location: {\n    prototype: Location;\n    new(): Location;\n};\n\ninterface MSAssertion {\n    readonly id: string;\n    readonly type: MSCredentialType;\n}\n\ndeclare var MSAssertion: {\n    prototype: MSAssertion;\n    new(): MSAssertion;\n};\n\ninterface MSBlobBuilder {\n    append(data: any, endings?: string): void;\n    getBlob(contentType?: string): Blob;\n}\n\ndeclare var MSBlobBuilder: {\n    prototype: MSBlobBuilder;\n    new(): MSBlobBuilder;\n};\n\ninterface MSFIDOCredentialAssertion extends MSAssertion {\n    readonly algorithm: string | Algorithm;\n    readonly attestation: any;\n    readonly publicKey: string;\n    readonly transportHints: MSTransportType[];\n}\n\ndeclare var MSFIDOCredentialAssertion: {\n    prototype: MSFIDOCredentialAssertion;\n    new(): MSFIDOCredentialAssertion;\n};\n\ninterface MSFIDOSignature {\n    readonly authnrData: string;\n    readonly clientData: string;\n    readonly signature: string;\n}\n\ndeclare var MSFIDOSignature: {\n    prototype: MSFIDOSignature;\n    new(): MSFIDOSignature;\n};\n\ninterface MSFIDOSignatureAssertion extends MSAssertion {\n    readonly signature: MSFIDOSignature;\n}\n\ndeclare var MSFIDOSignatureAssertion: {\n    prototype: MSFIDOSignatureAssertion;\n    new(): MSFIDOSignatureAssertion;\n};\n\ninterface MSFileSaver {\n    msSaveBlob(blob: any, defaultName?: string): boolean;\n    msSaveOrOpenBlob(blob: any, defaultName?: string): boolean;\n}\n\ninterface MSGesture {\n    target: Element;\n    addPointer(pointerId: number): void;\n    stop(): void;\n}\n\ndeclare var MSGesture: {\n    prototype: MSGesture;\n    new(): MSGesture;\n};\n\n/** The MSGestureEvent is a proprietary interface specific to Internet Explorer and Microsoft Edge which represents events that occur due to touch gestures. Events using this interface include MSGestureStart, MSGestureEnd, MSGestureTap, MSGestureHold, MSGestureChange, and MSInertiaStart. */\ninterface MSGestureEvent extends UIEvent {\n    readonly clientX: number;\n    readonly clientY: number;\n    readonly expansion: number;\n    readonly gestureObject: any;\n    readonly hwTimestamp: number;\n    readonly offsetX: number;\n    readonly offsetY: number;\n    readonly rotation: number;\n    readonly scale: number;\n    readonly screenX: number;\n    readonly screenY: number;\n    readonly translationX: number;\n    readonly translationY: number;\n    readonly velocityAngular: number;\n    readonly velocityExpansion: number;\n    readonly velocityX: number;\n    readonly velocityY: number;\n    initGestureEvent(typeArg: string, canBubbleArg: boolean, cancelableArg: boolean, viewArg: Window, detailArg: number, screenXArg: number, screenYArg: number, clientXArg: number, clientYArg: number, offsetXArg: number, offsetYArg: number, translationXArg: number, translationYArg: number, scaleArg: number, expansionArg: number, rotationArg: number, velocityXArg: number, velocityYArg: number, velocityExpansionArg: number, velocityAngularArg: number, hwTimestampArg: number): void;\n    readonly MSGESTURE_FLAG_BEGIN: number;\n    readonly MSGESTURE_FLAG_CANCEL: number;\n    readonly MSGESTURE_FLAG_END: number;\n    readonly MSGESTURE_FLAG_INERTIA: number;\n    readonly MSGESTURE_FLAG_NONE: number;\n}\n\ndeclare var MSGestureEvent: {\n    prototype: MSGestureEvent;\n    new(): MSGestureEvent;\n    readonly MSGESTURE_FLAG_BEGIN: number;\n    readonly MSGESTURE_FLAG_CANCEL: number;\n    readonly MSGESTURE_FLAG_END: number;\n    readonly MSGESTURE_FLAG_INERTIA: number;\n    readonly MSGESTURE_FLAG_NONE: number;\n};\n\n/** The msGraphicsTrust() constructor returns an object that provides properties for info on protected video playback. */\ninterface MSGraphicsTrust {\n    readonly constrictionActive: boolean;\n    readonly status: string;\n}\n\ndeclare var MSGraphicsTrust: {\n    prototype: MSGraphicsTrust;\n    new(): MSGraphicsTrust;\n};\n\ninterface MSInputMethodContextEventMap {\n    "MSCandidateWindowHide": Event;\n    "MSCandidateWindowShow": Event;\n    "MSCandidateWindowUpdate": Event;\n}\n\ninterface MSInputMethodContext extends EventTarget {\n    readonly compositionEndOffset: number;\n    readonly compositionStartOffset: number;\n    oncandidatewindowhide: ((this: MSInputMethodContext, ev: Event) => any) | null;\n    oncandidatewindowshow: ((this: MSInputMethodContext, ev: Event) => any) | null;\n    oncandidatewindowupdate: ((this: MSInputMethodContext, ev: Event) => any) | null;\n    readonly target: HTMLElement;\n    getCandidateWindowClientRect(): ClientRect;\n    getCompositionAlternatives(): string[];\n    hasComposition(): boolean;\n    isCandidateWindowVisible(): boolean;\n    addEventListener<K extends keyof MSInputMethodContextEventMap>(type: K, listener: (this: MSInputMethodContext, ev: MSInputMethodContextEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof MSInputMethodContextEventMap>(type: K, listener: (this: MSInputMethodContext, ev: MSInputMethodContextEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var MSInputMethodContext: {\n    prototype: MSInputMethodContext;\n    new(): MSInputMethodContext;\n};\n\ninterface MSMediaKeyError {\n    readonly code: number;\n    readonly systemCode: number;\n    readonly MS_MEDIA_KEYERR_CLIENT: number;\n    readonly MS_MEDIA_KEYERR_DOMAIN: number;\n    readonly MS_MEDIA_KEYERR_HARDWARECHANGE: number;\n    readonly MS_MEDIA_KEYERR_OUTPUT: number;\n    readonly MS_MEDIA_KEYERR_SERVICE: number;\n    readonly MS_MEDIA_KEYERR_UNKNOWN: number;\n}\n\ndeclare var MSMediaKeyError: {\n    prototype: MSMediaKeyError;\n    new(): MSMediaKeyError;\n    readonly MS_MEDIA_KEYERR_CLIENT: number;\n    readonly MS_MEDIA_KEYERR_DOMAIN: number;\n    readonly MS_MEDIA_KEYERR_HARDWARECHANGE: number;\n    readonly MS_MEDIA_KEYERR_OUTPUT: number;\n    readonly MS_MEDIA_KEYERR_SERVICE: number;\n    readonly MS_MEDIA_KEYERR_UNKNOWN: number;\n};\n\ninterface MSMediaKeyMessageEvent extends Event {\n    readonly destinationURL: string | null;\n    readonly message: Uint8Array;\n}\n\ndeclare var MSMediaKeyMessageEvent: {\n    prototype: MSMediaKeyMessageEvent;\n    new(): MSMediaKeyMessageEvent;\n};\n\ninterface MSMediaKeyNeededEvent extends Event {\n    readonly initData: Uint8Array | null;\n}\n\ndeclare var MSMediaKeyNeededEvent: {\n    prototype: MSMediaKeyNeededEvent;\n    new(): MSMediaKeyNeededEvent;\n};\n\ninterface MSMediaKeySession extends EventTarget {\n    readonly error: MSMediaKeyError | null;\n    readonly keySystem: string;\n    readonly sessionId: string;\n    close(): void;\n    update(key: Uint8Array): void;\n}\n\ndeclare var MSMediaKeySession: {\n    prototype: MSMediaKeySession;\n    new(): MSMediaKeySession;\n};\n\ninterface MSMediaKeys {\n    readonly keySystem: string;\n    createSession(type: string, initData: Uint8Array, cdmData?: Uint8Array | null): MSMediaKeySession;\n}\n\ndeclare var MSMediaKeys: {\n    prototype: MSMediaKeys;\n    new(keySystem: string): MSMediaKeys;\n    isTypeSupported(keySystem: string, type?: string | null): boolean;\n    isTypeSupportedWithFeatures(keySystem: string, type?: string | null): string;\n};\n\ninterface MSNavigatorDoNotTrack {\n    confirmSiteSpecificTrackingException(args: ConfirmSiteSpecificExceptionsInformation): boolean;\n    confirmWebWideTrackingException(args: ExceptionInformation): boolean;\n    removeSiteSpecificTrackingException(args: ExceptionInformation): void;\n    removeWebWideTrackingException(args: ExceptionInformation): void;\n    storeSiteSpecificTrackingException(args: StoreSiteSpecificExceptionsInformation): void;\n    storeWebWideTrackingException(args: StoreExceptionsInformation): void;\n}\n\ninterface MSPointerEvent extends MouseEvent {\n    readonly currentPoint: any;\n    readonly height: number;\n    readonly hwTimestamp: number;\n    readonly intermediatePoints: any;\n    readonly isPrimary: boolean;\n    readonly pointerId: number;\n    readonly pointerType: any;\n    readonly pressure: number;\n    readonly rotation: number;\n    readonly tiltX: number;\n    readonly tiltY: number;\n    readonly width: number;\n    getCurrentPoint(element: Element): void;\n    getIntermediatePoints(element: Element): void;\n    initPointerEvent(typeArg: string, canBubbleArg: boolean, cancelableArg: boolean, viewArg: Window, detailArg: number, screenXArg: number, screenYArg: number, clientXArg: number, clientYArg: number, ctrlKeyArg: boolean, altKeyArg: boolean, shiftKeyArg: boolean, metaKeyArg: boolean, buttonArg: number, relatedTargetArg: EventTarget, offsetXArg: number, offsetYArg: number, widthArg: number, heightArg: number, pressure: number, rotation: number, tiltX: number, tiltY: number, pointerIdArg: number, pointerType: any, hwTimestampArg: number, isPrimary: boolean): void;\n}\n\ndeclare var MSPointerEvent: {\n    prototype: MSPointerEvent;\n    new(typeArg: string, eventInitDict?: PointerEventInit): MSPointerEvent;\n};\n\ninterface MSStream {\n    readonly type: string;\n    msClose(): void;\n    msDetachStream(): any;\n}\n\ndeclare var MSStream: {\n    prototype: MSStream;\n    new(): MSStream;\n};\n\n/** The MediaDevicesInfo interface contains information that describes a single media input or output device. */\ninterface MediaDeviceInfo {\n    readonly deviceId: string;\n    readonly groupId: string;\n    readonly kind: MediaDeviceKind;\n    readonly label: string;\n    toJSON(): any;\n}\n\ndeclare var MediaDeviceInfo: {\n    prototype: MediaDeviceInfo;\n    new(): MediaDeviceInfo;\n};\n\ninterface MediaDevicesEventMap {\n    "devicechange": Event;\n}\n\n/** Provides access to connected media input devices like cameras and microphones, as well as screen sharing. In essence, it lets you obtain access to any hardware source of media data. */\ninterface MediaDevices extends EventTarget {\n    ondevicechange: ((this: MediaDevices, ev: Event) => any) | null;\n    enumerateDevices(): Promise<MediaDeviceInfo[]>;\n    getSupportedConstraints(): MediaTrackSupportedConstraints;\n    getUserMedia(constraints?: MediaStreamConstraints): Promise<MediaStream>;\n    addEventListener<K extends keyof MediaDevicesEventMap>(type: K, listener: (this: MediaDevices, ev: MediaDevicesEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof MediaDevicesEventMap>(type: K, listener: (this: MediaDevices, ev: MediaDevicesEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var MediaDevices: {\n    prototype: MediaDevices;\n    new(): MediaDevices;\n};\n\n/** A MediaElementSourceNode has no inputs and exactly one output, and is created using the AudioContext.createMediaElementSource method. The amount of channels in the output equals the number of channels of the audio referenced by the HTMLMediaElement used in the creation of the node, or is 1 if the HTMLMediaElement has no audio. */\ninterface MediaElementAudioSourceNode extends AudioNode {\n    readonly mediaElement: HTMLMediaElement;\n}\n\ndeclare var MediaElementAudioSourceNode: {\n    prototype: MediaElementAudioSourceNode;\n    new(context: AudioContext, options: MediaElementAudioSourceOptions): MediaElementAudioSourceNode;\n};\n\ninterface MediaEncryptedEvent extends Event {\n    readonly initData: ArrayBuffer | null;\n    readonly initDataType: string;\n}\n\ndeclare var MediaEncryptedEvent: {\n    prototype: MediaEncryptedEvent;\n    new(type: string, eventInitDict?: MediaEncryptedEventInit): MediaEncryptedEvent;\n};\n\n/** An error which occurred while handling media in an HTML media element based on HTMLMediaElement, such as <audio> or <video>. */\ninterface MediaError {\n    readonly code: number;\n    readonly message: string;\n    readonly msExtendedCode: number;\n    readonly MEDIA_ERR_ABORTED: number;\n    readonly MEDIA_ERR_DECODE: number;\n    readonly MEDIA_ERR_NETWORK: number;\n    readonly MEDIA_ERR_SRC_NOT_SUPPORTED: number;\n    readonly MS_MEDIA_ERR_ENCRYPTED: number;\n}\n\ndeclare var MediaError: {\n    prototype: MediaError;\n    new(): MediaError;\n    readonly MEDIA_ERR_ABORTED: number;\n    readonly MEDIA_ERR_DECODE: number;\n    readonly MEDIA_ERR_NETWORK: number;\n    readonly MEDIA_ERR_SRC_NOT_SUPPORTED: number;\n    readonly MS_MEDIA_ERR_ENCRYPTED: number;\n};\n\n/** An interface of the EncryptedMediaExtensions API contains the content and related data when the content decryption module generates a message for the session. */\ninterface MediaKeyMessageEvent extends Event {\n    readonly message: ArrayBuffer;\n    readonly messageType: MediaKeyMessageType;\n}\n\ndeclare var MediaKeyMessageEvent: {\n    prototype: MediaKeyMessageEvent;\n    new(type: string, eventInitDict: MediaKeyMessageEventInit): MediaKeyMessageEvent;\n};\n\ninterface MediaKeySessionEventMap {\n    "keystatuseschange": Event;\n    "message": MessageEvent;\n}\n\n/** An interface of the EncryptedMediaExtensions API represents a context for message exchange with a content decryption module (CDM). */\ninterface MediaKeySession extends EventTarget {\n    readonly closed: Promise<void>;\n    readonly expiration: number;\n    readonly keyStatuses: MediaKeyStatusMap;\n    onkeystatuseschange: ((this: MediaKeySession, ev: Event) => any) | null;\n    onmessage: ((this: MediaKeySession, ev: MessageEvent) => any) | null;\n    readonly sessionId: string;\n    close(): Promise<void>;\n    generateRequest(initDataType: string, initData: BufferSource): Promise<void>;\n    load(sessionId: string): Promise<boolean>;\n    remove(): Promise<void>;\n    update(response: BufferSource): Promise<void>;\n    addEventListener<K extends keyof MediaKeySessionEventMap>(type: K, listener: (this: MediaKeySession, ev: MediaKeySessionEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof MediaKeySessionEventMap>(type: K, listener: (this: MediaKeySession, ev: MediaKeySessionEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var MediaKeySession: {\n    prototype: MediaKeySession;\n    new(): MediaKeySession;\n};\n\n/** An interface of the EncryptedMediaExtensions API is a read-only map of media key statuses by key IDs. */\ninterface MediaKeyStatusMap {\n    readonly size: number;\n    get(keyId: BufferSource): any;\n    has(keyId: BufferSource): boolean;\n    forEach(callbackfn: (value: MediaKeyStatus, key: BufferSource, parent: MediaKeyStatusMap) => void, thisArg?: any): void;\n}\n\ndeclare var MediaKeyStatusMap: {\n    prototype: MediaKeyStatusMap;\n    new(): MediaKeyStatusMap;\n};\n\n/** An interface of the EncryptedMediaExtensions API provides access to a Key System for decryption and/or a content protection provider. You can request an instance of this object using the Navigator.requestMediaKeySystemAccess method. */\ninterface MediaKeySystemAccess {\n    readonly keySystem: string;\n    createMediaKeys(): Promise<MediaKeys>;\n    getConfiguration(): MediaKeySystemConfiguration;\n}\n\ndeclare var MediaKeySystemAccess: {\n    prototype: MediaKeySystemAccess;\n    new(): MediaKeySystemAccess;\n};\n\n/** An interface of the EncryptedMediaExtensions API the represents a set of keys that an associated HTMLMediaElement can use for decryption of media data during playback. */\ninterface MediaKeys {\n    createSession(sessionType?: MediaKeySessionType): MediaKeySession;\n    setServerCertificate(serverCertificate: BufferSource): Promise<boolean>;\n}\n\ndeclare var MediaKeys: {\n    prototype: MediaKeys;\n    new(): MediaKeys;\n};\n\ninterface MediaList {\n    readonly length: number;\n    mediaText: string;\n    appendMedium(medium: string): void;\n    deleteMedium(medium: string): void;\n    item(index: number): string | null;\n    toString(): number;\n    [index: number]: string;\n}\n\ndeclare var MediaList: {\n    prototype: MediaList;\n    new(): MediaList;\n};\n\ninterface MediaQueryListEventMap {\n    "change": MediaQueryListEvent;\n}\n\n/** Stores information on a media query applied to a document, and handles sending notifications to listeners when the media query state change (i.e. when the media query test starts or stops evaluating to true). */\ninterface MediaQueryList extends EventTarget {\n    readonly matches: boolean;\n    readonly media: string;\n    onchange: ((this: MediaQueryList, ev: MediaQueryListEvent) => any) | null;\n    /** @deprecated */\n    addListener(listener: ((this: MediaQueryList, ev: MediaQueryListEvent) => any) | null): void;\n    /** @deprecated */\n    removeListener(listener: ((this: MediaQueryList, ev: MediaQueryListEvent) => any) | null): void;\n    addEventListener<K extends keyof MediaQueryListEventMap>(type: K, listener: (this: MediaQueryList, ev: MediaQueryListEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof MediaQueryListEventMap>(type: K, listener: (this: MediaQueryList, ev: MediaQueryListEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var MediaQueryList: {\n    prototype: MediaQueryList;\n    new(): MediaQueryList;\n};\n\ninterface MediaQueryListEvent extends Event {\n    readonly matches: boolean;\n    readonly media: string;\n}\n\ndeclare var MediaQueryListEvent: {\n    prototype: MediaQueryListEvent;\n    new(type: string, eventInitDict?: MediaQueryListEventInit): MediaQueryListEvent;\n};\n\ninterface MediaSourceEventMap {\n    "sourceclose": Event;\n    "sourceended": Event;\n    "sourceopen": Event;\n}\n\n/** An interface of the Media Source Extensions API represents a source of media data for an HTMLMediaElement object. A MediaSource object can be attached to a HTMLMediaElement to be played in the user agent. */\ninterface MediaSource extends EventTarget {\n    readonly activeSourceBuffers: SourceBufferList;\n    duration: number;\n    onsourceclose: ((this: MediaSource, ev: Event) => any) | null;\n    onsourceended: ((this: MediaSource, ev: Event) => any) | null;\n    onsourceopen: ((this: MediaSource, ev: Event) => any) | null;\n    readonly readyState: ReadyState;\n    readonly sourceBuffers: SourceBufferList;\n    addSourceBuffer(type: string): SourceBuffer;\n    clearLiveSeekableRange(): void;\n    endOfStream(error?: EndOfStreamError): void;\n    removeSourceBuffer(sourceBuffer: SourceBuffer): void;\n    setLiveSeekableRange(start: number, end: number): void;\n    addEventListener<K extends keyof MediaSourceEventMap>(type: K, listener: (this: MediaSource, ev: MediaSourceEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof MediaSourceEventMap>(type: K, listener: (this: MediaSource, ev: MediaSourceEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var MediaSource: {\n    prototype: MediaSource;\n    new(): MediaSource;\n    isTypeSupported(type: string): boolean;\n};\n\ninterface MediaStreamEventMap {\n    "addtrack": MediaStreamTrackEvent;\n    "removetrack": MediaStreamTrackEvent;\n}\n\n/** A stream of media content. A stream consists of several tracks such as video or audio tracks. Each track is specified as an instance of MediaStreamTrack. */\ninterface MediaStream extends EventTarget {\n    readonly active: boolean;\n    readonly id: string;\n    onaddtrack: ((this: MediaStream, ev: MediaStreamTrackEvent) => any) | null;\n    onremovetrack: ((this: MediaStream, ev: MediaStreamTrackEvent) => any) | null;\n    addTrack(track: MediaStreamTrack): void;\n    clone(): MediaStream;\n    getAudioTracks(): MediaStreamTrack[];\n    getTrackById(trackId: string): MediaStreamTrack | null;\n    getTracks(): MediaStreamTrack[];\n    getVideoTracks(): MediaStreamTrack[];\n    removeTrack(track: MediaStreamTrack): void;\n    addEventListener<K extends keyof MediaStreamEventMap>(type: K, listener: (this: MediaStream, ev: MediaStreamEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof MediaStreamEventMap>(type: K, listener: (this: MediaStream, ev: MediaStreamEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var MediaStream: {\n    prototype: MediaStream;\n    new(): MediaStream;\n    new(stream: MediaStream): MediaStream;\n    new(tracks: MediaStreamTrack[]): MediaStream;\n};\n\ninterface MediaStreamAudioDestinationNode extends AudioNode {\n    readonly stream: MediaStream;\n}\n\ndeclare var MediaStreamAudioDestinationNode: {\n    prototype: MediaStreamAudioDestinationNode;\n    new(context: AudioContext, options?: AudioNodeOptions): MediaStreamAudioDestinationNode;\n};\n\n/** A type of AudioNode which operates as an audio source whose media is received from a MediaStream obtained using the WebRTC or Media Capture and Streams APIs. */\ninterface MediaStreamAudioSourceNode extends AudioNode {\n    readonly mediaStream: MediaStream;\n}\n\ndeclare var MediaStreamAudioSourceNode: {\n    prototype: MediaStreamAudioSourceNode;\n    new(context: AudioContext, options: MediaStreamAudioSourceOptions): MediaStreamAudioSourceNode;\n};\n\ninterface MediaStreamError {\n    readonly constraintName: string | null;\n    readonly message: string | null;\n    readonly name: string;\n}\n\ndeclare var MediaStreamError: {\n    prototype: MediaStreamError;\n    new(): MediaStreamError;\n};\n\ninterface MediaStreamErrorEvent extends Event {\n    readonly error: MediaStreamError | null;\n}\n\ndeclare var MediaStreamErrorEvent: {\n    prototype: MediaStreamErrorEvent;\n    new(typeArg: string, eventInitDict?: MediaStreamErrorEventInit): MediaStreamErrorEvent;\n};\n\n/** Events that occurs in relation to a MediaStream. Two events of this type can be thrown: addstream and removestream. */\ninterface MediaStreamEvent extends Event {\n    readonly stream: MediaStream | null;\n}\n\ndeclare var MediaStreamEvent: {\n    prototype: MediaStreamEvent;\n    new(type: string, eventInitDict: MediaStreamEventInit): MediaStreamEvent;\n};\n\ninterface MediaStreamTrackEventMap {\n    "ended": Event;\n    "isolationchange": Event;\n    "mute": Event;\n    "overconstrained": MediaStreamErrorEvent;\n    "unmute": Event;\n}\n\n/** A single media track within a stream; typically, these are audio or video tracks, but other track types may exist as well. */\ninterface MediaStreamTrack extends EventTarget {\n    enabled: boolean;\n    readonly id: string;\n    readonly isolated: boolean;\n    readonly kind: string;\n    readonly label: string;\n    readonly muted: boolean;\n    onended: ((this: MediaStreamTrack, ev: Event) => any) | null;\n    onisolationchange: ((this: MediaStreamTrack, ev: Event) => any) | null;\n    onmute: ((this: MediaStreamTrack, ev: Event) => any) | null;\n    onoverconstrained: ((this: MediaStreamTrack, ev: MediaStreamErrorEvent) => any) | null;\n    onunmute: ((this: MediaStreamTrack, ev: Event) => any) | null;\n    readonly readyState: MediaStreamTrackState;\n    applyConstraints(constraints?: MediaTrackConstraints): Promise<void>;\n    clone(): MediaStreamTrack;\n    getCapabilities(): MediaTrackCapabilities;\n    getConstraints(): MediaTrackConstraints;\n    getSettings(): MediaTrackSettings;\n    stop(): void;\n    addEventListener<K extends keyof MediaStreamTrackEventMap>(type: K, listener: (this: MediaStreamTrack, ev: MediaStreamTrackEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof MediaStreamTrackEventMap>(type: K, listener: (this: MediaStreamTrack, ev: MediaStreamTrackEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var MediaStreamTrack: {\n    prototype: MediaStreamTrack;\n    new(): MediaStreamTrack;\n};\n\ninterface MediaStreamTrackAudioSourceNode extends AudioNode {\n}\n\ndeclare var MediaStreamTrackAudioSourceNode: {\n    prototype: MediaStreamTrackAudioSourceNode;\n    new(context: AudioContext, options: MediaStreamTrackAudioSourceOptions): MediaStreamTrackAudioSourceNode;\n};\n\n/** Events which indicate that a MediaStream has had tracks added to or removed from the stream through calls to Media Stream API methods. These events are sent to the stream when these changes occur. */\ninterface MediaStreamTrackEvent extends Event {\n    readonly track: MediaStreamTrack;\n}\n\ndeclare var MediaStreamTrackEvent: {\n    prototype: MediaStreamTrackEvent;\n    new(type: string, eventInitDict: MediaStreamTrackEventInit): MediaStreamTrackEvent;\n};\n\n/** An interface of the Channel Messaging API allows us to create a new message channel and send data through it via its two MessagePort properties. */\ninterface MessageChannel {\n    readonly port1: MessagePort;\n    readonly port2: MessagePort;\n}\n\ndeclare var MessageChannel: {\n    prototype: MessageChannel;\n    new(): MessageChannel;\n};\n\n/** A message received by a target object. */\ninterface MessageEvent extends Event {\n    /**\n     * Returns the data of the message.\n     */\n    readonly data: any;\n    /**\n     * Returns the last event ID string, for\n     * server-sent events.\n     */\n    readonly lastEventId: string;\n    /**\n     * Returns the origin of the message, for server-sent events and\n     * cross-document messaging.\n     */\n    readonly origin: string;\n    /**\n     * Returns the MessagePort array sent with the message, for cross-document\n     * messaging and channel messaging.\n     */\n    readonly ports: ReadonlyArray<MessagePort>;\n    /**\n     * Returns the WindowProxy of the source window, for cross-document\n     * messaging, and the MessagePort being attached, in the connect event fired at\n     * SharedWorkerGlobalScope objects.\n     */\n    readonly source: MessageEventSource | null;\n}\n\ndeclare var MessageEvent: {\n    prototype: MessageEvent;\n    new(type: string, eventInitDict?: MessageEventInit): MessageEvent;\n};\n\ninterface MessagePortEventMap {\n    "message": MessageEvent;\n    "messageerror": MessageEvent;\n}\n\n/** An interface of the Channel Messaging API represents one of the two ports of a MessageChannel, allowing messages to be sent from one port and listening out for them arriving at the other. */\ninterface MessagePort extends EventTarget {\n    onmessage: ((this: MessagePort, ev: MessageEvent) => any) | null;\n    onmessageerror: ((this: MessagePort, ev: MessageEvent) => any) | null;\n    /**\n     * Disconnects the port, so that it is no longer active.\n     */\n    close(): void;\n    postMessage(message: any, transfer: Transferable[]): void;\n    postMessage(message: any, options?: PostMessageOptions): void;\n    /**\n     * Begins dispatching messages received on the port.\n     */\n    start(): void;\n    addEventListener<K extends keyof MessagePortEventMap>(type: K, listener: (this: MessagePort, ev: MessagePortEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof MessagePortEventMap>(type: K, listener: (this: MessagePort, ev: MessagePortEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var MessagePort: {\n    prototype: MessagePort;\n    new(): MessagePort;\n};\n\n/** Provides contains information about a MIME type associated with a particular plugin. NavigatorPlugins.mimeTypes returns an array of this object. */\ninterface MimeType {\n    readonly description: string;\n    readonly enabledPlugin: Plugin;\n    readonly suffixes: string;\n    readonly type: string;\n}\n\ndeclare var MimeType: {\n    prototype: MimeType;\n    new(): MimeType;\n};\n\n/** Returns an array of MimeType instances, each of which contains information about a supported browser plugins. This object is returned by NavigatorPlugins.mimeTypes. */\ninterface MimeTypeArray {\n    readonly length: number;\n    item(index: number): Plugin;\n    namedItem(type: string): Plugin;\n    [index: number]: Plugin;\n}\n\ndeclare var MimeTypeArray: {\n    prototype: MimeTypeArray;\n    new(): MimeTypeArray;\n};\n\n/** Events that occur due to the user interacting with a pointing device (such as a mouse). Common events using this interface include click, dblclick, mouseup, mousedown. */\ninterface MouseEvent extends UIEvent {\n    readonly altKey: boolean;\n    readonly button: number;\n    readonly buttons: number;\n    readonly clientX: number;\n    readonly clientY: number;\n    readonly ctrlKey: boolean;\n    /** @deprecated */\n    readonly fromElement: Element;\n    readonly layerX: number;\n    readonly layerY: number;\n    readonly metaKey: boolean;\n    readonly movementX: number;\n    readonly movementY: number;\n    readonly offsetX: number;\n    readonly offsetY: number;\n    readonly pageX: number;\n    readonly pageY: number;\n    readonly relatedTarget: EventTarget;\n    readonly screenX: number;\n    readonly screenY: number;\n    readonly shiftKey: boolean;\n    /** @deprecated */\n    readonly toElement: Element;\n    /** @deprecated */\n    readonly which: number;\n    readonly x: number;\n    readonly y: number;\n    getModifierState(keyArg: string): boolean;\n    initMouseEvent(typeArg: string, canBubbleArg: boolean, cancelableArg: boolean, viewArg: Window, detailArg: number, screenXArg: number, screenYArg: number, clientXArg: number, clientYArg: number, ctrlKeyArg: boolean, altKeyArg: boolean, shiftKeyArg: boolean, metaKeyArg: boolean, buttonArg: number, relatedTargetArg: EventTarget | null): void;\n}\n\ndeclare var MouseEvent: {\n    prototype: MouseEvent;\n    new(typeArg: string, eventInitDict?: MouseEventInit): MouseEvent;\n};\n\n/** Provides event properties that are specific to modifications to the Document Object Model (DOM) hierarchy and nodes. */\ninterface MutationEvent extends Event {\n    readonly attrChange: number;\n    readonly attrName: string;\n    readonly newValue: string;\n    readonly prevValue: string;\n    readonly relatedNode: Node;\n    initMutationEvent(typeArg: string, canBubbleArg: boolean, cancelableArg: boolean, relatedNodeArg: Node, prevValueArg: string, newValueArg: string, attrNameArg: string, attrChangeArg: number): void;\n    readonly ADDITION: number;\n    readonly MODIFICATION: number;\n    readonly REMOVAL: number;\n}\n\ndeclare var MutationEvent: {\n    prototype: MutationEvent;\n    new(): MutationEvent;\n    readonly ADDITION: number;\n    readonly MODIFICATION: number;\n    readonly REMOVAL: number;\n};\n\n/** Provides the ability to watch for changes being made to the DOM tree. It is designed as a replacement for the older Mutation Events feature which was part of the DOM3 Events specification. */\ninterface MutationObserver {\n    disconnect(): void;\n    /**\n     * Instructs the user agent to observe a given target (a node) and report any mutations based on\n     * the criteria given by options (an object).\n     * The options argument allows for setting mutation\n     * observation options via object members. These are the object members that\n     * can be used:\n     * childList\n     * Set to true if mutations to target\'s children are to be observed.\n     * attributes\n     * Set to true if mutations to target\'s attributes are to be observed. Can be omitted if attributeOldValue or attributeFilter is\n     * specified.\n     * characterData\n     * Set to true if mutations to target\'s data are to be observed. Can be omitted if characterDataOldValue is specified.\n     * subtree\n     * Set to true if mutations to not just target, but\n     * also target\'s descendants are to be\n     * observed.\n     * attributeOldValue\n     * Set to true if attributes is true or omitted\n     * and target\'s attribute value before the mutation\n     * needs to be recorded.\n     * characterDataOldValue\n     * Set to true if characterData is set to true or omitted and target\'s data before the mutation\n     * needs to be recorded.\n     * attributeFilter\n     * Set to a list of attribute local names (without namespace) if not all attribute mutations need to be\n     * observed and attributes is true\n     * or omitted.\n     */\n    observe(target: Node, options?: MutationObserverInit): void;\n    /**\n     * Empties the record queue and\n     * returns what was in there.\n     */\n    takeRecords(): MutationRecord[];\n}\n\ndeclare var MutationObserver: {\n    prototype: MutationObserver;\n    new(callback: MutationCallback): MutationObserver;\n};\n\n/** A MutationRecord represents an individual DOM mutation. It is the object that is passed to MutationObserver\'s callback. */\ninterface MutationRecord {\n    readonly addedNodes: NodeList;\n    /**\n     * Returns the local name of the\n     * changed attribute, and null otherwise.\n     */\n    readonly attributeName: string | null;\n    /**\n     * Returns the namespace of the\n     * changed attribute, and null otherwise.\n     */\n    readonly attributeNamespace: string | null;\n    /**\n     * Return the previous and next sibling respectively\n     * of the added or removed nodes, and null otherwise.\n     */\n    readonly nextSibling: Node | null;\n    /**\n     * The return value depends on type. For\n     * "attributes", it is the value of the\n     * changed attribute before the change.\n     * For "characterData", it is the data of the changed node before the change. For\n     * "childList", it is null.\n     */\n    readonly oldValue: string | null;\n    readonly previousSibling: Node | null;\n    /**\n     * Return the nodes added and removed\n     * respectively.\n     */\n    readonly removedNodes: NodeList;\n    readonly target: Node;\n    /**\n     * Returns "attributes" if it was an attribute mutation.\n     * "characterData" if it was a mutation to a CharacterData node. And\n     * "childList" if it was a mutation to the tree of nodes.\n     */\n    readonly type: MutationRecordType;\n}\n\ndeclare var MutationRecord: {\n    prototype: MutationRecord;\n    new(): MutationRecord;\n};\n\n/** A collection of Attr objects. Objects inside a NamedNodeMap are not in any particular order, unlike NodeList, although they may be accessed by an index as in an array. */\ninterface NamedNodeMap {\n    readonly length: number;\n    getNamedItem(qualifiedName: string): Attr | null;\n    getNamedItemNS(namespace: string | null, localName: string): Attr | null;\n    item(index: number): Attr | null;\n    removeNamedItem(qualifiedName: string): Attr;\n    removeNamedItemNS(namespace: string | null, localName: string): Attr;\n    setNamedItem(attr: Attr): Attr | null;\n    setNamedItemNS(attr: Attr): Attr | null;\n    [index: number]: Attr;\n}\n\ndeclare var NamedNodeMap: {\n    prototype: NamedNodeMap;\n    new(): NamedNodeMap;\n};\n\ninterface NavigationPreloadManager {\n    disable(): Promise<void>;\n    enable(): Promise<void>;\n    getState(): Promise<NavigationPreloadState>;\n    setHeaderValue(value: string): Promise<void>;\n}\n\ndeclare var NavigationPreloadManager: {\n    prototype: NavigationPreloadManager;\n    new(): NavigationPreloadManager;\n};\n\n/** The state and the identity of the user agent. It allows scripts to query it and to register themselves to carry on some activities. */\ninterface Navigator extends NavigatorID, NavigatorOnLine, NavigatorContentUtils, NavigatorStorageUtils, MSNavigatorDoNotTrack, MSFileSaver, NavigatorBeacon, NavigatorConcurrentHardware, NavigatorUserMedia, NavigatorLanguage, NavigatorStorage, NavigatorAutomationInformation {\n    readonly activeVRDisplays: ReadonlyArray<VRDisplay>;\n    readonly authentication: WebAuthentication;\n    readonly clipboard: Clipboard;\n    readonly cookieEnabled: boolean;\n    readonly doNotTrack: string | null;\n    gamepadInputEmulation: GamepadInputEmulationType;\n    readonly geolocation: Geolocation;\n    readonly maxTouchPoints: number;\n    readonly mediaDevices: MediaDevices;\n    readonly mimeTypes: MimeTypeArray;\n    readonly msManipulationViewsEnabled: boolean;\n    readonly msMaxTouchPoints: number;\n    readonly msPointerEnabled: boolean;\n    readonly permissions: Permissions;\n    readonly plugins: PluginArray;\n    readonly pointerEnabled: boolean;\n    readonly serviceWorker: ServiceWorkerContainer;\n    readonly webdriver: boolean;\n    getGamepads(): (Gamepad | null)[];\n    getUserMedia(constraints: MediaStreamConstraints, successCallback: NavigatorUserMediaSuccessCallback, errorCallback: NavigatorUserMediaErrorCallback): void;\n    getVRDisplays(): Promise<VRDisplay[]>;\n    javaEnabled(): boolean;\n    msLaunchUri(uri: string, successCallback?: MSLaunchUriCallback, noHandlerCallback?: MSLaunchUriCallback): void;\n    requestMediaKeySystemAccess(keySystem: string, supportedConfigurations: MediaKeySystemConfiguration[]): Promise<MediaKeySystemAccess>;\n    vibrate(pattern: number | number[]): boolean;\n}\n\ndeclare var Navigator: {\n    prototype: Navigator;\n    new(): Navigator;\n};\n\ninterface NavigatorAutomationInformation {\n    readonly webdriver: boolean;\n}\n\ninterface NavigatorBeacon {\n    sendBeacon(url: string, data?: Blob | Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer | FormData | string | null): boolean;\n}\n\ninterface NavigatorConcurrentHardware {\n    readonly hardwareConcurrency: number;\n}\n\ninterface NavigatorContentUtils {\n}\n\ninterface NavigatorID {\n    readonly appCodeName: string;\n    readonly appName: string;\n    readonly appVersion: string;\n    readonly platform: string;\n    readonly product: string;\n    readonly productSub: string;\n    readonly userAgent: string;\n    readonly vendor: string;\n    readonly vendorSub: string;\n}\n\ninterface NavigatorLanguage {\n    readonly language: string;\n    readonly languages: ReadonlyArray<string>;\n}\n\ninterface NavigatorOnLine {\n    readonly onLine: boolean;\n}\n\ninterface NavigatorStorage {\n    readonly storage: StorageManager;\n}\n\ninterface NavigatorStorageUtils {\n}\n\ninterface NavigatorUserMedia {\n    readonly mediaDevices: MediaDevices;\n    getDisplayMedia(constraints: MediaStreamConstraints): Promise<MediaStream>;\n    getUserMedia(constraints: MediaStreamConstraints, successCallback: NavigatorUserMediaSuccessCallback, errorCallback: NavigatorUserMediaErrorCallback): void;\n}\n\n/** Node is an interface from which a number of DOM API object types inherit. It allows those types to be treated similarly; for example, inheriting the same set of methods, or being tested in the same way. */\ninterface Node extends EventTarget {\n    /**\n     * Returns node\'s node document\'s document base URL.\n     */\n    readonly baseURI: string;\n    /**\n     * Returns the children.\n     */\n    readonly childNodes: NodeListOf<ChildNode>;\n    /**\n     * Returns the first child.\n     */\n    readonly firstChild: ChildNode | null;\n    /**\n     * Returns true if node is connected and false otherwise.\n     */\n    readonly isConnected: boolean;\n    /**\n     * Returns the last child.\n     */\n    readonly lastChild: ChildNode | null;\n    /** @deprecated */\n    readonly namespaceURI: string | null;\n    /**\n     * Returns the next sibling.\n     */\n    readonly nextSibling: ChildNode | null;\n    /**\n     * Returns a string appropriate for the type of node, as\n     * follows:\n     * Element\n     * Its HTML-uppercased qualified name.\n     * Attr\n     * Its qualified name.\n     * Text\n     * "#text".\n     * CDATASection\n     * "#cdata-section".\n     * ProcessingInstruction\n     * Its target.\n     * Comment\n     * "#comment".\n     * Document\n     * "#document".\n     * DocumentType\n     * Its name.\n     * DocumentFragment\n     * "#document-fragment".\n     */\n    readonly nodeName: string;\n    readonly nodeType: number;\n    nodeValue: string | null;\n    /**\n     * Returns the node document.\n     * Returns null for documents.\n     */\n    readonly ownerDocument: Document | null;\n    /**\n     * Returns the parent element.\n     */\n    readonly parentElement: HTMLElement | null;\n    /**\n     * Returns the parent.\n     */\n    readonly parentNode: Node & ParentNode | null;\n    /**\n     * Returns the previous sibling.\n     */\n    readonly previousSibling: Node | null;\n    textContent: string | null;\n    appendChild<T extends Node>(newChild: T): T;\n    /**\n     * Returns a copy of node. If deep is true, the copy also includes the node\'s descendants.\n     */\n    cloneNode(deep?: boolean): Node;\n    compareDocumentPosition(other: Node): number;\n    /**\n     * Returns true if other is an inclusive descendant of node, and false otherwise.\n     */\n    contains(other: Node | null): boolean;\n    /**\n     * Returns node\'s shadow-including root.\n     */\n    getRootNode(options?: GetRootNodeOptions): Node;\n    /**\n     * Returns whether node has children.\n     */\n    hasChildNodes(): boolean;\n    insertBefore<T extends Node>(newChild: T, refChild: Node | null): T;\n    isDefaultNamespace(namespace: string | null): boolean;\n    /**\n     * Returns whether node and otherNode have the same properties.\n     */\n    isEqualNode(otherNode: Node | null): boolean;\n    isSameNode(otherNode: Node | null): boolean;\n    lookupNamespaceURI(prefix: string | null): string | null;\n    lookupPrefix(namespace: string | null): string | null;\n    /**\n     * Removes empty exclusive Text nodes and concatenates the data of remaining contiguous exclusive Text nodes into the first of their nodes.\n     */\n    normalize(): void;\n    removeChild<T extends Node>(oldChild: T): T;\n    replaceChild<T extends Node>(newChild: Node, oldChild: T): T;\n    readonly ATTRIBUTE_NODE: number;\n    readonly CDATA_SECTION_NODE: number;\n    readonly COMMENT_NODE: number;\n    readonly DOCUMENT_FRAGMENT_NODE: number;\n    readonly DOCUMENT_NODE: number;\n    readonly DOCUMENT_POSITION_CONTAINED_BY: number;\n    readonly DOCUMENT_POSITION_CONTAINS: number;\n    readonly DOCUMENT_POSITION_DISCONNECTED: number;\n    readonly DOCUMENT_POSITION_FOLLOWING: number;\n    readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;\n    readonly DOCUMENT_POSITION_PRECEDING: number;\n    readonly DOCUMENT_TYPE_NODE: number;\n    readonly ELEMENT_NODE: number;\n    readonly ENTITY_NODE: number;\n    readonly ENTITY_REFERENCE_NODE: number;\n    readonly NOTATION_NODE: number;\n    readonly PROCESSING_INSTRUCTION_NODE: number;\n    readonly TEXT_NODE: number;\n}\n\ndeclare var Node: {\n    prototype: Node;\n    new(): Node;\n    readonly ATTRIBUTE_NODE: number;\n    readonly CDATA_SECTION_NODE: number;\n    readonly COMMENT_NODE: number;\n    readonly DOCUMENT_FRAGMENT_NODE: number;\n    readonly DOCUMENT_NODE: number;\n    readonly DOCUMENT_POSITION_CONTAINED_BY: number;\n    readonly DOCUMENT_POSITION_CONTAINS: number;\n    readonly DOCUMENT_POSITION_DISCONNECTED: number;\n    readonly DOCUMENT_POSITION_FOLLOWING: number;\n    readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;\n    readonly DOCUMENT_POSITION_PRECEDING: number;\n    readonly DOCUMENT_TYPE_NODE: number;\n    readonly ELEMENT_NODE: number;\n    readonly ENTITY_NODE: number;\n    readonly ENTITY_REFERENCE_NODE: number;\n    readonly NOTATION_NODE: number;\n    readonly PROCESSING_INSTRUCTION_NODE: number;\n    readonly TEXT_NODE: number;\n};\n\n/** An object used to filter the nodes in a NodeIterator or TreeWalker. They don\'t know anything about the DOM or how to traverse nodes; they just know how to evaluate a single node against the provided filter. */\ninterface NodeFilter {\n    acceptNode(node: Node): number;\n}\n\ndeclare var NodeFilter: {\n    readonly FILTER_ACCEPT: number;\n    readonly FILTER_REJECT: number;\n    readonly FILTER_SKIP: number;\n    readonly SHOW_ALL: number;\n    readonly SHOW_ATTRIBUTE: number;\n    readonly SHOW_CDATA_SECTION: number;\n    readonly SHOW_COMMENT: number;\n    readonly SHOW_DOCUMENT: number;\n    readonly SHOW_DOCUMENT_FRAGMENT: number;\n    readonly SHOW_DOCUMENT_TYPE: number;\n    readonly SHOW_ELEMENT: number;\n    readonly SHOW_ENTITY: number;\n    readonly SHOW_ENTITY_REFERENCE: number;\n    readonly SHOW_NOTATION: number;\n    readonly SHOW_PROCESSING_INSTRUCTION: number;\n    readonly SHOW_TEXT: number;\n};\n\n/** An iterator over the members of a list of the nodes in a subtree of the DOM. The nodes will be returned in document order. */\ninterface NodeIterator {\n    readonly filter: NodeFilter | null;\n    readonly pointerBeforeReferenceNode: boolean;\n    readonly referenceNode: Node;\n    readonly root: Node;\n    readonly whatToShow: number;\n    detach(): void;\n    nextNode(): Node | null;\n    previousNode(): Node | null;\n}\n\ndeclare var NodeIterator: {\n    prototype: NodeIterator;\n    new(): NodeIterator;\n};\n\n/** NodeList objects are collections of nodes, usually returned by properties such as Node.childNodes and methods such as document.querySelectorAll(). */\ninterface NodeList {\n    /**\n     * Returns the number of nodes in the collection.\n     */\n    readonly length: number;\n    /**\n     * element = collection[index]\n     */\n    item(index: number): Node | null;\n    /**\n     * Performs the specified action for each node in an list.\n     * @param callbackfn  A function that accepts up to three arguments. forEach calls the callbackfn function one time for each element in the list.\n     * @param thisArg  An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n     */\n    forEach(callbackfn: (value: Node, key: number, parent: NodeList) => void, thisArg?: any): void;\n    [index: number]: Node;\n}\n\ndeclare var NodeList: {\n    prototype: NodeList;\n    new(): NodeList;\n};\n\ninterface NodeListOf<TNode extends Node> extends NodeList {\n    length: number;\n    item(index: number): TNode;\n    /**\n     * Performs the specified action for each node in an list.\n     * @param callbackfn  A function that accepts up to three arguments. forEach calls the callbackfn function one time for each element in the list.\n     * @param thisArg  An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n     */\n    forEach(callbackfn: (value: TNode, key: number, parent: NodeListOf<TNode>) => void, thisArg?: any): void;\n    [index: number]: TNode;\n}\n\ninterface NonDocumentTypeChildNode {\n    /**\n     * Returns the first following sibling that\n     * is an element, and null otherwise.\n     */\n    readonly nextElementSibling: Element | null;\n    /**\n     * Returns the first preceding sibling that\n     * is an element, and null otherwise.\n     */\n    readonly previousElementSibling: Element | null;\n}\n\ninterface NonElementParentNode {\n    /**\n     * Returns the first element within node\'s descendants whose ID is elementId.\n     */\n    getElementById(elementId: string): Element | null;\n}\n\ninterface NotificationEventMap {\n    "click": Event;\n    "close": Event;\n    "error": Event;\n    "show": Event;\n}\n\n/** An interface of the Notifications API is used to configure and display desktop notifications to the user. */\ninterface Notification extends EventTarget {\n    readonly actions: ReadonlyArray<NotificationAction>;\n    readonly badge: string;\n    readonly body: string;\n    readonly data: any;\n    readonly dir: NotificationDirection;\n    readonly icon: string;\n    readonly image: string;\n    readonly lang: string;\n    onclick: ((this: Notification, ev: Event) => any) | null;\n    onclose: ((this: Notification, ev: Event) => any) | null;\n    onerror: ((this: Notification, ev: Event) => any) | null;\n    onshow: ((this: Notification, ev: Event) => any) | null;\n    readonly renotify: boolean;\n    readonly requireInteraction: boolean;\n    readonly silent: boolean;\n    readonly tag: string;\n    readonly timestamp: number;\n    readonly title: string;\n    readonly vibrate: ReadonlyArray<number>;\n    close(): void;\n    addEventListener<K extends keyof NotificationEventMap>(type: K, listener: (this: Notification, ev: NotificationEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof NotificationEventMap>(type: K, listener: (this: Notification, ev: NotificationEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var Notification: {\n    prototype: Notification;\n    new(title: string, options?: NotificationOptions): Notification;\n    readonly maxActions: number;\n    readonly permission: NotificationPermission;\n    requestPermission(deprecatedCallback?: NotificationPermissionCallback): Promise<NotificationPermission>;\n};\n\n/** The OES_element_index_uint extension is part of the WebGL API and adds support for gl.UNSIGNED_INT types to WebGLRenderingContext.drawElements(). */\ninterface OES_element_index_uint {\n}\n\n/** The OES_standard_derivatives extension is part of the WebGL API and adds the GLSL derivative functions dFdx, dFdy, and fwidth. */\ninterface OES_standard_derivatives {\n    readonly FRAGMENT_SHADER_DERIVATIVE_HINT_OES: GLenum;\n}\n\n/** The OES_texture_float extension is part of the WebGL API and exposes floating-point pixel types for textures. */\ninterface OES_texture_float {\n}\n\n/** The OES_texture_float_linear extension is part of the WebGL API and allows linear filtering with floating-point pixel types for textures. */\ninterface OES_texture_float_linear {\n}\n\n/** The OES_texture_half_float extension is part of the WebGL API and adds texture formats with 16- (aka half float) and 32-bit floating-point components. */\ninterface OES_texture_half_float {\n    readonly HALF_FLOAT_OES: GLenum;\n}\n\n/** The OES_texture_half_float_linear extension is part of the WebGL API and allows linear filtering with half floating-point pixel types for textures. */\ninterface OES_texture_half_float_linear {\n}\n\ninterface OES_vertex_array_object {\n    bindVertexArrayOES(arrayObject: WebGLVertexArrayObjectOES | null): void;\n    createVertexArrayOES(): WebGLVertexArrayObjectOES | null;\n    deleteVertexArrayOES(arrayObject: WebGLVertexArrayObjectOES | null): void;\n    isVertexArrayOES(arrayObject: WebGLVertexArrayObjectOES | null): GLboolean;\n    readonly VERTEX_ARRAY_BINDING_OES: GLenum;\n}\n\n/** The Web Audio API OfflineAudioCompletionEvent interface represents events that occur when the processing of an OfflineAudioContext is terminated. The complete event implements this interface. */\ninterface OfflineAudioCompletionEvent extends Event {\n    readonly renderedBuffer: AudioBuffer;\n}\n\ndeclare var OfflineAudioCompletionEvent: {\n    prototype: OfflineAudioCompletionEvent;\n    new(type: string, eventInitDict: OfflineAudioCompletionEventInit): OfflineAudioCompletionEvent;\n};\n\ninterface OfflineAudioContextEventMap extends BaseAudioContextEventMap {\n    "complete": OfflineAudioCompletionEvent;\n}\n\n/** An AudioContext interface representing an audio-processing graph built from linked together AudioNodes. In contrast with a standard AudioContext, an OfflineAudioContext doesn\'t render the audio to the device hardware; instead, it generates it, as fast as it can, and outputs the result to an AudioBuffer. */\ninterface OfflineAudioContext extends BaseAudioContext {\n    readonly length: number;\n    oncomplete: ((this: OfflineAudioContext, ev: OfflineAudioCompletionEvent) => any) | null;\n    resume(): Promise<void>;\n    startRendering(): Promise<AudioBuffer>;\n    suspend(suspendTime: number): Promise<void>;\n    addEventListener<K extends keyof OfflineAudioContextEventMap>(type: K, listener: (this: OfflineAudioContext, ev: OfflineAudioContextEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof OfflineAudioContextEventMap>(type: K, listener: (this: OfflineAudioContext, ev: OfflineAudioContextEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var OfflineAudioContext: {\n    prototype: OfflineAudioContext;\n    new(contextOptions: OfflineAudioContextOptions): OfflineAudioContext;\n    new(numberOfChannels: number, length: number, sampleRate: number): OfflineAudioContext;\n};\n\ninterface OffscreenCanvas extends EventTarget {\n    /**\n     * These attributes return the dimensions of the OffscreenCanvas object\'s bitmap.\n     * They can be set, to replace the bitmap with a\n     * new, transparent black bitmap of the specified dimensions (effectively resizing\n     * it).\n     */\n    height: number;\n    width: number;\n    /**\n     * Returns a promise that will fulfill with a new Blob object representing a file\n     * containing the image in the OffscreenCanvas object.\n     * The argument, if provided, is a dictionary that controls the encoding options of the image\n     * file to be created. The type\n     * field specifies the file format and has a default value of "image/png"; that type\n     * is also used if the requested type isn\'t supported. If the image format supports variable\n     * quality (such as "image/jpeg"), then the quality field is a number in the range 0.0\n     * to 1.0 inclusive indicating the desired quality level for the resulting image.\n     */\n    convertToBlob(options?: ImageEncodeOptions): Promise<Blob>;\n    /**\n     * Returns an object that exposes an API for drawing on the OffscreenCanvas\n     * object. contextId specifies the desired API: "2d" or "webgl". options is handled by that\n     * API.\n     * This specification defines the "2d" context below,\n     * which is similar but distinct from the "2d"\n     * context that is created from a canvas element. There is also a specification that\n     * defines a "webgl" context. [WEBGL]\n     * Returns null if the canvas has already been initialized with another context type (e.g.,\n     * trying to get a "2d" context after getting a\n     * "webgl" context).\n     */\n    getContext(contextId: OffscreenRenderingContextId, options?: any): OffscreenRenderingContext | null;\n    /**\n     * Returns a newly created ImageBitmap object with the image in the\n     * OffscreenCanvas object. The image in the OffscreenCanvas object is\n     * replaced with a new blank image.\n     */\n    transferToImageBitmap(): ImageBitmap;\n}\n\ndeclare var OffscreenCanvas: {\n    prototype: OffscreenCanvas;\n    new(width: number, height: number): OffscreenCanvas;\n};\n\ninterface OffscreenCanvasRenderingContext2D extends CanvasState, CanvasTransform, CanvasCompositing, CanvasImageSmoothing, CanvasFillStrokeStyles, CanvasShadowStyles, CanvasFilters, CanvasRect, CanvasDrawPath, CanvasText, CanvasDrawImage, CanvasImageData, CanvasPathDrawingStyles, CanvasTextDrawingStyles, CanvasPath {\n    readonly canvas: OffscreenCanvas;\n    commit(): void;\n}\n\ndeclare var OffscreenCanvasRenderingContext2D: {\n    prototype: OffscreenCanvasRenderingContext2D;\n    new(): OffscreenCanvasRenderingContext2D;\n};\n\n/** The OscillatorNode interface represents a periodic waveform, such as a sine wave. It is an AudioScheduledSourceNode audio-processing module that causes a specified frequency of a given wave to be created—in effect, a constant tone. */\ninterface OscillatorNode extends AudioScheduledSourceNode {\n    readonly detune: AudioParam;\n    readonly frequency: AudioParam;\n    type: OscillatorType;\n    setPeriodicWave(periodicWave: PeriodicWave): void;\n    addEventListener<K extends keyof AudioScheduledSourceNodeEventMap>(type: K, listener: (this: OscillatorNode, ev: AudioScheduledSourceNodeEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof AudioScheduledSourceNodeEventMap>(type: K, listener: (this: OscillatorNode, ev: AudioScheduledSourceNodeEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var OscillatorNode: {\n    prototype: OscillatorNode;\n    new(context: BaseAudioContext, options?: OscillatorOptions): OscillatorNode;\n};\n\ninterface OverconstrainedError extends Error {\n    constraint: string;\n}\n\ndeclare var OverconstrainedError: {\n    prototype: OverconstrainedError;\n    new(): OverconstrainedError;\n};\n\ninterface OverflowEvent extends UIEvent {\n    readonly horizontalOverflow: boolean;\n    readonly orient: number;\n    readonly verticalOverflow: boolean;\n    readonly BOTH: number;\n    readonly HORIZONTAL: number;\n    readonly VERTICAL: number;\n}\n\ndeclare var OverflowEvent: {\n    prototype: OverflowEvent;\n    new(): OverflowEvent;\n    readonly BOTH: number;\n    readonly HORIZONTAL: number;\n    readonly VERTICAL: number;\n};\n\n/** The PageTransitionEvent is fired when a document is being loaded or unloaded. */\ninterface PageTransitionEvent extends Event {\n    readonly persisted: boolean;\n}\n\ndeclare var PageTransitionEvent: {\n    prototype: PageTransitionEvent;\n    new(): PageTransitionEvent;\n};\n\n/** A PannerNode always has exactly one input and one output: the input can be mono or stereo but the output is always stereo (2 channels); you can\'t have panning effects without at least two audio channels! */\ninterface PannerNode extends AudioNode {\n    coneInnerAngle: number;\n    coneOuterAngle: number;\n    coneOuterGain: number;\n    distanceModel: DistanceModelType;\n    maxDistance: number;\n    readonly orientationX: AudioParam;\n    readonly orientationY: AudioParam;\n    readonly orientationZ: AudioParam;\n    panningModel: PanningModelType;\n    readonly positionX: AudioParam;\n    readonly positionY: AudioParam;\n    readonly positionZ: AudioParam;\n    refDistance: number;\n    rolloffFactor: number;\n    /** @deprecated */\n    setOrientation(x: number, y: number, z: number): void;\n    /** @deprecated */\n    setPosition(x: number, y: number, z: number): void;\n}\n\ndeclare var PannerNode: {\n    prototype: PannerNode;\n    new(context: BaseAudioContext, options?: PannerOptions): PannerNode;\n};\n\ninterface ParentNode {\n    readonly childElementCount: number;\n    /**\n     * Returns the child elements.\n     */\n    readonly children: HTMLCollection;\n    /**\n     * Returns the first child that is an element, and null otherwise.\n     */\n    readonly firstElementChild: Element | null;\n    /**\n     * Returns the last child that is an element, and null otherwise.\n     */\n    readonly lastElementChild: Element | null;\n    /**\n     * Inserts nodes after the last child of node, while replacing\n     * strings in nodes with equivalent Text nodes.\n     * Throws a "HierarchyRequestError" DOMException if the constraints of\n     * the node tree are violated.\n     */\n    append(...nodes: (Node | string)[]): void;\n    /**\n     * Inserts nodes before the first child of node, while\n     * replacing strings in nodes with equivalent Text nodes.\n     * Throws a "HierarchyRequestError" DOMException if the constraints of\n     * the node tree are violated.\n     */\n    prepend(...nodes: (Node | string)[]): void;\n    /**\n     * Returns the first element that is a descendant of node that\n     * matches selectors.\n     */\n    querySelector<K extends keyof HTMLElementTagNameMap>(selectors: K): HTMLElementTagNameMap[K] | null;\n    querySelector<K extends keyof SVGElementTagNameMap>(selectors: K): SVGElementTagNameMap[K] | null;\n    querySelector<E extends Element = Element>(selectors: string): E | null;\n    /**\n     * Returns all element descendants of node that\n     * match selectors.\n     */\n    querySelectorAll<K extends keyof HTMLElementTagNameMap>(selectors: K): NodeListOf<HTMLElementTagNameMap[K]>;\n    querySelectorAll<K extends keyof SVGElementTagNameMap>(selectors: K): NodeListOf<SVGElementTagNameMap[K]>;\n    querySelectorAll<E extends Element = Element>(selectors: string): NodeListOf<E>;\n}\n\n/** Of the Canvas 2D API is used to declare a path that can then be used on a CanvasRenderingContext2D object. The path methods of the CanvasRenderingContext2D interface are also present on this interface, which gives you the convenience of being able to retain and replay your path whenever desired. */\ninterface Path2D extends CanvasPath {\n    addPath(path: Path2D, transform?: DOMMatrix2DInit): void;\n}\n\ndeclare var Path2D: {\n    prototype: Path2D;\n    new(path?: Path2D | string): Path2D;\n};\n\n/** An interface of the Payment Request API is used to store shipping or payment address information. */\ninterface PaymentAddress {\n    readonly addressLine: string[];\n    readonly city: string;\n    readonly country: string;\n    readonly dependentLocality: string;\n    readonly languageCode: string;\n    readonly organization: string;\n    readonly phone: string;\n    readonly postalCode: string;\n    readonly recipient: string;\n    readonly region: string;\n    readonly sortingCode: string;\n    toJSON(): any;\n}\n\ndeclare var PaymentAddress: {\n    prototype: PaymentAddress;\n    new(): PaymentAddress;\n};\n\ninterface PaymentRequestEventMap {\n    "shippingaddresschange": Event;\n    "shippingoptionchange": Event;\n}\n\n/** An interface of the Payment Request API is the primary access point into the API , and lets web content and apps accept payments from the end user. */\ninterface PaymentRequest extends EventTarget {\n    readonly id: string;\n    onshippingaddresschange: ((this: PaymentRequest, ev: Event) => any) | null;\n    onshippingoptionchange: ((this: PaymentRequest, ev: Event) => any) | null;\n    readonly shippingAddress: PaymentAddress | null;\n    readonly shippingOption: string | null;\n    readonly shippingType: PaymentShippingType | null;\n    abort(): Promise<void>;\n    canMakePayment(): Promise<boolean>;\n    show(): Promise<PaymentResponse>;\n    addEventListener<K extends keyof PaymentRequestEventMap>(type: K, listener: (this: PaymentRequest, ev: PaymentRequestEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof PaymentRequestEventMap>(type: K, listener: (this: PaymentRequest, ev: PaymentRequestEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var PaymentRequest: {\n    prototype: PaymentRequest;\n    new(methodData: PaymentMethodData[], details: PaymentDetailsInit, options?: PaymentOptions): PaymentRequest;\n};\n\n/** An interface of the Payment Request API enables a web page to update the details of a PaymentRequest in response to a user action. */\ninterface PaymentRequestUpdateEvent extends Event {\n    updateWith(detailsPromise: PaymentDetailsUpdate | Promise<PaymentDetailsUpdate>): void;\n}\n\ndeclare var PaymentRequestUpdateEvent: {\n    prototype: PaymentRequestUpdateEvent;\n    new(type: string, eventInitDict?: PaymentRequestUpdateEventInit): PaymentRequestUpdateEvent;\n};\n\n/** An interface of the Payment Request API is returned after a user selects a payment method and approves a payment request. */\ninterface PaymentResponse {\n    readonly details: any;\n    readonly methodName: string;\n    readonly payerEmail: string | null;\n    readonly payerName: string | null;\n    readonly payerPhone: string | null;\n    readonly requestId: string;\n    readonly shippingAddress: PaymentAddress | null;\n    readonly shippingOption: string | null;\n    complete(result?: PaymentComplete): Promise<void>;\n    toJSON(): any;\n}\n\ndeclare var PaymentResponse: {\n    prototype: PaymentResponse;\n    new(): PaymentResponse;\n};\n\ninterface PerfWidgetExternal {\n    readonly activeNetworkRequestCount: number;\n    readonly averageFrameTime: number;\n    readonly averagePaintTime: number;\n    readonly extraInformationEnabled: boolean;\n    readonly independentRenderingEnabled: boolean;\n    readonly irDisablingContentString: string;\n    readonly irStatusAvailable: boolean;\n    readonly maxCpuSpeed: number;\n    readonly paintRequestsPerSecond: number;\n    readonly performanceCounter: number;\n    readonly performanceCounterFrequency: number;\n    addEventListener(eventType: string, callback: Function): void;\n    getMemoryUsage(): number;\n    getProcessCpuUsage(): number;\n    getRecentCpuUsage(last: number | null): any;\n    getRecentFrames(last: number | null): any;\n    getRecentMemoryUsage(last: number | null): any;\n    getRecentPaintRequests(last: number | null): any;\n    removeEventListener(eventType: string, callback: Function): void;\n    repositionWindow(x: number, y: number): void;\n    resizeWindow(width: number, height: number): void;\n}\n\ndeclare var PerfWidgetExternal: {\n    prototype: PerfWidgetExternal;\n    new(): PerfWidgetExternal;\n};\n\ninterface PerformanceEventMap {\n    "resourcetimingbufferfull": Event;\n}\n\n/** Provides access to performance-related information for the current page. It\'s part of the High Resolution Time API, but is enhanced by the Performance Timeline API, the Navigation Timing API, the User Timing API, and the Resource Timing API. */\ninterface Performance extends EventTarget {\n    /** @deprecated */\n    readonly navigation: PerformanceNavigation;\n    onresourcetimingbufferfull: ((this: Performance, ev: Event) => any) | null;\n    readonly timeOrigin: number;\n    /** @deprecated */\n    readonly timing: PerformanceTiming;\n    clearMarks(markName?: string): void;\n    clearMeasures(measureName?: string): void;\n    clearResourceTimings(): void;\n    getEntries(): PerformanceEntryList;\n    getEntriesByName(name: string, type?: string): PerformanceEntryList;\n    getEntriesByType(type: string): PerformanceEntryList;\n    mark(markName: string): void;\n    measure(measureName: string, startMark?: string, endMark?: string): void;\n    now(): number;\n    setResourceTimingBufferSize(maxSize: number): void;\n    toJSON(): any;\n    addEventListener<K extends keyof PerformanceEventMap>(type: K, listener: (this: Performance, ev: PerformanceEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof PerformanceEventMap>(type: K, listener: (this: Performance, ev: PerformanceEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var Performance: {\n    prototype: Performance;\n    new(): Performance;\n};\n\n/** Encapsulates a single performance metric that is part of the performance timeline. A performance entry can be directly created by making a performance mark or measure (for example by calling the mark() method) at an explicit point in an application. Performance entries are also created in indirect ways such as loading a resource (such as an image). */\ninterface PerformanceEntry {\n    readonly duration: number;\n    readonly entryType: string;\n    readonly name: string;\n    readonly startTime: number;\n    toJSON(): any;\n}\n\ndeclare var PerformanceEntry: {\n    prototype: PerformanceEntry;\n    new(): PerformanceEntry;\n};\n\n/** PerformanceMark is an abstract interface for PerformanceEntry objects with an entryType of "mark". Entries of this type are created by calling performance.mark() to add a named DOMHighResTimeStamp (the mark) to the browser\'s performance timeline. */\ninterface PerformanceMark extends PerformanceEntry {\n}\n\ndeclare var PerformanceMark: {\n    prototype: PerformanceMark;\n    new(): PerformanceMark;\n};\n\n/** PerformanceMeasure is an abstract interface for PerformanceEntry objects with an entryType of "measure". Entries of this type are created by calling performance.measure() to add a named DOMHighResTimeStamp (the measure) between two marks to the browser\'s performance timeline. */\ninterface PerformanceMeasure extends PerformanceEntry {\n}\n\ndeclare var PerformanceMeasure: {\n    prototype: PerformanceMeasure;\n    new(): PerformanceMeasure;\n};\n\n/** The legacy PerformanceNavigation interface represents information about how the navigation to the current document was done. */\ninterface PerformanceNavigation {\n    readonly redirectCount: number;\n    readonly type: number;\n    toJSON(): any;\n    readonly TYPE_BACK_FORWARD: number;\n    readonly TYPE_NAVIGATE: number;\n    readonly TYPE_RELOAD: number;\n    readonly TYPE_RESERVED: number;\n}\n\ndeclare var PerformanceNavigation: {\n    prototype: PerformanceNavigation;\n    new(): PerformanceNavigation;\n    readonly TYPE_BACK_FORWARD: number;\n    readonly TYPE_NAVIGATE: number;\n    readonly TYPE_RELOAD: number;\n    readonly TYPE_RESERVED: number;\n};\n\n/** Provides methods and properties to store and retrieve metrics regarding the browser\'s document navigation events. For example, this interface can be used to determine how much time it takes to load or unload a document. */\ninterface PerformanceNavigationTiming extends PerformanceResourceTiming {\n    readonly domComplete: number;\n    readonly domContentLoadedEventEnd: number;\n    readonly domContentLoadedEventStart: number;\n    readonly domInteractive: number;\n    readonly loadEventEnd: number;\n    readonly loadEventStart: number;\n    readonly redirectCount: number;\n    readonly type: NavigationType;\n    readonly unloadEventEnd: number;\n    readonly unloadEventStart: number;\n    toJSON(): any;\n}\n\ndeclare var PerformanceNavigationTiming: {\n    prototype: PerformanceNavigationTiming;\n    new(): PerformanceNavigationTiming;\n};\n\ninterface PerformanceObserver {\n    disconnect(): void;\n    observe(options?: PerformanceObserverInit): void;\n    takeRecords(): PerformanceEntryList;\n}\n\ndeclare var PerformanceObserver: {\n    prototype: PerformanceObserver;\n    new(callback: PerformanceObserverCallback): PerformanceObserver;\n    readonly supportedEntryTypes: ReadonlyArray<string>;\n};\n\ninterface PerformanceObserverEntryList {\n    getEntries(): PerformanceEntryList;\n    getEntriesByName(name: string, type?: string): PerformanceEntryList;\n    getEntriesByType(type: string): PerformanceEntryList;\n}\n\ndeclare var PerformanceObserverEntryList: {\n    prototype: PerformanceObserverEntryList;\n    new(): PerformanceObserverEntryList;\n};\n\n/** Enables retrieval and analysis of detailed network timing data regarding the loading of an application\'s resources. An application can use the timing metrics to determine, for example, the length of time it takes to fetch a specific resource, such as an XMLHttpRequest, <SVG>, image, or script. */\ninterface PerformanceResourceTiming extends PerformanceEntry {\n    readonly connectEnd: number;\n    readonly connectStart: number;\n    readonly decodedBodySize: number;\n    readonly domainLookupEnd: number;\n    readonly domainLookupStart: number;\n    readonly encodedBodySize: number;\n    readonly fetchStart: number;\n    readonly initiatorType: string;\n    readonly nextHopProtocol: string;\n    readonly redirectEnd: number;\n    readonly redirectStart: number;\n    readonly requestStart: number;\n    readonly responseEnd: number;\n    readonly responseStart: number;\n    readonly secureConnectionStart: number;\n    readonly transferSize: number;\n    readonly workerStart: number;\n    toJSON(): any;\n}\n\ndeclare var PerformanceResourceTiming: {\n    prototype: PerformanceResourceTiming;\n    new(): PerformanceResourceTiming;\n};\n\n/** A legacy interface kept for backwards compatibility and contains properties that offer performance timing information for various events which occur during the loading and use of the current page. You get a PerformanceTiming object describing your page using the window.performance.timing property. */\ninterface PerformanceTiming {\n    readonly connectEnd: number;\n    readonly connectStart: number;\n    readonly domComplete: number;\n    readonly domContentLoadedEventEnd: number;\n    readonly domContentLoadedEventStart: number;\n    readonly domInteractive: number;\n    readonly domLoading: number;\n    readonly domainLookupEnd: number;\n    readonly domainLookupStart: number;\n    readonly fetchStart: number;\n    readonly loadEventEnd: number;\n    readonly loadEventStart: number;\n    readonly navigationStart: number;\n    readonly redirectEnd: number;\n    readonly redirectStart: number;\n    readonly requestStart: number;\n    readonly responseEnd: number;\n    readonly responseStart: number;\n    readonly secureConnectionStart: number;\n    readonly unloadEventEnd: number;\n    readonly unloadEventStart: number;\n    toJSON(): any;\n}\n\ndeclare var PerformanceTiming: {\n    prototype: PerformanceTiming;\n    new(): PerformanceTiming;\n};\n\n/** PeriodicWave has no inputs or outputs; it is used to define custom oscillators when calling OscillatorNode.setPeriodicWave(). The PeriodicWave itself is created/returned by AudioContext.createPeriodicWave(). */\ninterface PeriodicWave {\n}\n\ndeclare var PeriodicWave: {\n    prototype: PeriodicWave;\n    new(context: BaseAudioContext, options?: PeriodicWaveOptions): PeriodicWave;\n};\n\ninterface PermissionRequest extends DeferredPermissionRequest {\n    readonly state: MSWebViewPermissionState;\n    defer(): void;\n}\n\ndeclare var PermissionRequest: {\n    prototype: PermissionRequest;\n    new(): PermissionRequest;\n};\n\ninterface PermissionRequestedEvent extends Event {\n    readonly permissionRequest: PermissionRequest;\n}\n\ndeclare var PermissionRequestedEvent: {\n    prototype: PermissionRequestedEvent;\n    new(): PermissionRequestedEvent;\n};\n\ninterface PermissionStatusEventMap {\n    "change": Event;\n}\n\ninterface PermissionStatus extends EventTarget {\n    onchange: ((this: PermissionStatus, ev: Event) => any) | null;\n    readonly state: PermissionState;\n    addEventListener<K extends keyof PermissionStatusEventMap>(type: K, listener: (this: PermissionStatus, ev: PermissionStatusEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof PermissionStatusEventMap>(type: K, listener: (this: PermissionStatus, ev: PermissionStatusEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var PermissionStatus: {\n    prototype: PermissionStatus;\n    new(): PermissionStatus;\n};\n\ninterface Permissions {\n    query(permissionDesc: PermissionDescriptor | DevicePermissionDescriptor | MidiPermissionDescriptor | PushPermissionDescriptor): Promise<PermissionStatus>;\n}\n\ndeclare var Permissions: {\n    prototype: Permissions;\n    new(): Permissions;\n};\n\n/** Provides information about a browser plugin. */\ninterface Plugin {\n    readonly description: string;\n    readonly filename: string;\n    readonly length: number;\n    readonly name: string;\n    readonly version: string;\n    item(index: number): MimeType;\n    namedItem(type: string): MimeType;\n    [index: number]: MimeType;\n}\n\ndeclare var Plugin: {\n    prototype: Plugin;\n    new(): Plugin;\n};\n\n/** Used to store a list of Plugin objects describing the available plugins; it\'s returned by the window.navigator.plugins property. The PluginArray is not a JavaScript array, but has the length property and supports accessing individual items using bracket notation (plugins[2]), as well as via item(index) and namedItem("name") methods. */\ninterface PluginArray {\n    readonly length: number;\n    item(index: number): Plugin;\n    namedItem(name: string): Plugin;\n    refresh(reload?: boolean): void;\n    [index: number]: Plugin;\n}\n\ndeclare var PluginArray: {\n    prototype: PluginArray;\n    new(): PluginArray;\n};\n\n/** The state of a DOM event produced by a pointer such as the geometry of the contact point, the device type that generated the event, the amount of pressure that was applied on the contact surface, etc. */\ninterface PointerEvent extends MouseEvent {\n    readonly height: number;\n    readonly isPrimary: boolean;\n    readonly pointerId: number;\n    readonly pointerType: string;\n    readonly pressure: number;\n    readonly tangentialPressure: number;\n    readonly tiltX: number;\n    readonly tiltY: number;\n    readonly twist: number;\n    readonly width: number;\n}\n\ndeclare var PointerEvent: {\n    prototype: PointerEvent;\n    new(type: string, eventInitDict?: PointerEventInit): PointerEvent;\n};\n\n/** PopStateEvent is an event handler for the popstate event on the window. */\ninterface PopStateEvent extends Event {\n    readonly state: any;\n}\n\ndeclare var PopStateEvent: {\n    prototype: PopStateEvent;\n    new(type: string, eventInitDict?: PopStateEventInit): PopStateEvent;\n};\n\n/** The position of the concerned device at a given time. The position, represented by a Coordinates object, comprehends the 2D position of the device, on a spheroid representing the Earth, but also its altitude and its speed. */\ninterface Position {\n    readonly coords: Coordinates;\n    readonly timestamp: number;\n}\n\n/** The reason of an error occurring when using the geolocating device. */\ninterface PositionError {\n    readonly code: number;\n    readonly message: string;\n    readonly PERMISSION_DENIED: number;\n    readonly POSITION_UNAVAILABLE: number;\n    readonly TIMEOUT: number;\n}\n\n/** A processing instruction embeds application-specific instructions in XML which can be ignored by other applications that don\'t recognize them. */\ninterface ProcessingInstruction extends CharacterData {\n    readonly target: string;\n}\n\ndeclare var ProcessingInstruction: {\n    prototype: ProcessingInstruction;\n    new(): ProcessingInstruction;\n};\n\n/** Events measuring progress of an underlying process, like an HTTP request (for an XMLHttpRequest, or the loading of the underlying resource of an <img>, <audio>, <video>, <style> or <link>). */\ninterface ProgressEvent extends Event {\n    readonly lengthComputable: boolean;\n    readonly loaded: number;\n    readonly total: number;\n}\n\ndeclare var ProgressEvent: {\n    prototype: ProgressEvent;\n    new(type: string, eventInitDict?: ProgressEventInit): ProgressEvent;\n};\n\ninterface PromiseRejectionEvent extends Event {\n    readonly promise: Promise<any>;\n    readonly reason: any;\n}\n\ndeclare var PromiseRejectionEvent: {\n    prototype: PromiseRejectionEvent;\n    new(type: string, eventInitDict: PromiseRejectionEventInit): PromiseRejectionEvent;\n};\n\n/** An interface of the Push API provides a way to receive notifications from third-party servers as well as request URLs for push notifications. */\ninterface PushManager {\n    getSubscription(): Promise<PushSubscription | null>;\n    permissionState(options?: PushSubscriptionOptionsInit): Promise<PushPermissionState>;\n    subscribe(options?: PushSubscriptionOptionsInit): Promise<PushSubscription>;\n}\n\ndeclare var PushManager: {\n    prototype: PushManager;\n    new(): PushManager;\n    readonly supportedContentEncodings: ReadonlyArray<string>;\n};\n\n/** An interface of the Push API provides a subcription\'s URL endpoint and allows unsubscription from a push service. */\ninterface PushSubscription {\n    readonly endpoint: string;\n    readonly expirationTime: number | null;\n    readonly options: PushSubscriptionOptions;\n    getKey(name: PushEncryptionKeyName): ArrayBuffer | null;\n    toJSON(): PushSubscriptionJSON;\n    unsubscribe(): Promise<boolean>;\n}\n\ndeclare var PushSubscription: {\n    prototype: PushSubscription;\n    new(): PushSubscription;\n};\n\ninterface PushSubscriptionOptions {\n    readonly applicationServerKey: ArrayBuffer | null;\n    readonly userVisibleOnly: boolean;\n}\n\ndeclare var PushSubscriptionOptions: {\n    prototype: PushSubscriptionOptions;\n    new(): PushSubscriptionOptions;\n};\n\ninterface RTCCertificate {\n    readonly expires: number;\n    getFingerprints(): RTCDtlsFingerprint[];\n}\n\ndeclare var RTCCertificate: {\n    prototype: RTCCertificate;\n    new(): RTCCertificate;\n    getSupportedAlgorithms(): AlgorithmIdentifier[];\n};\n\ninterface RTCDTMFSenderEventMap {\n    "tonechange": RTCDTMFToneChangeEvent;\n}\n\ninterface RTCDTMFSender extends EventTarget {\n    readonly canInsertDTMF: boolean;\n    ontonechange: ((this: RTCDTMFSender, ev: RTCDTMFToneChangeEvent) => any) | null;\n    readonly toneBuffer: string;\n    insertDTMF(tones: string, duration?: number, interToneGap?: number): void;\n    addEventListener<K extends keyof RTCDTMFSenderEventMap>(type: K, listener: (this: RTCDTMFSender, ev: RTCDTMFSenderEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof RTCDTMFSenderEventMap>(type: K, listener: (this: RTCDTMFSender, ev: RTCDTMFSenderEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var RTCDTMFSender: {\n    prototype: RTCDTMFSender;\n    new(): RTCDTMFSender;\n};\n\n/** Events sent to indicate that DTMF tones have started or finished playing. This interface is used by the tonechange event. */\ninterface RTCDTMFToneChangeEvent extends Event {\n    readonly tone: string;\n}\n\ndeclare var RTCDTMFToneChangeEvent: {\n    prototype: RTCDTMFToneChangeEvent;\n    new(type: string, eventInitDict: RTCDTMFToneChangeEventInit): RTCDTMFToneChangeEvent;\n};\n\ninterface RTCDataChannelEventMap {\n    "bufferedamountlow": Event;\n    "close": Event;\n    "error": RTCErrorEvent;\n    "message": MessageEvent;\n    "open": Event;\n}\n\ninterface RTCDataChannel extends EventTarget {\n    binaryType: string;\n    readonly bufferedAmount: number;\n    bufferedAmountLowThreshold: number;\n    readonly id: number | null;\n    readonly label: string;\n    readonly maxPacketLifeTime: number | null;\n    readonly maxRetransmits: number | null;\n    readonly negotiated: boolean;\n    onbufferedamountlow: ((this: RTCDataChannel, ev: Event) => any) | null;\n    onclose: ((this: RTCDataChannel, ev: Event) => any) | null;\n    onerror: ((this: RTCDataChannel, ev: RTCErrorEvent) => any) | null;\n    onmessage: ((this: RTCDataChannel, ev: MessageEvent) => any) | null;\n    onopen: ((this: RTCDataChannel, ev: Event) => any) | null;\n    readonly ordered: boolean;\n    readonly priority: RTCPriorityType;\n    readonly protocol: string;\n    readonly readyState: RTCDataChannelState;\n    close(): void;\n    send(data: string): void;\n    send(data: Blob): void;\n    send(data: ArrayBuffer): void;\n    send(data: ArrayBufferView): void;\n    addEventListener<K extends keyof RTCDataChannelEventMap>(type: K, listener: (this: RTCDataChannel, ev: RTCDataChannelEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof RTCDataChannelEventMap>(type: K, listener: (this: RTCDataChannel, ev: RTCDataChannelEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var RTCDataChannel: {\n    prototype: RTCDataChannel;\n    new(): RTCDataChannel;\n};\n\ninterface RTCDataChannelEvent extends Event {\n    readonly channel: RTCDataChannel;\n}\n\ndeclare var RTCDataChannelEvent: {\n    prototype: RTCDataChannelEvent;\n    new(type: string, eventInitDict: RTCDataChannelEventInit): RTCDataChannelEvent;\n};\n\ninterface RTCDtlsTransportEventMap {\n    "error": RTCErrorEvent;\n    "statechange": Event;\n}\n\ninterface RTCDtlsTransport extends EventTarget {\n    onerror: ((this: RTCDtlsTransport, ev: RTCErrorEvent) => any) | null;\n    onstatechange: ((this: RTCDtlsTransport, ev: Event) => any) | null;\n    readonly state: RTCDtlsTransportState;\n    readonly transport: RTCIceTransport;\n    getRemoteCertificates(): ArrayBuffer[];\n    addEventListener<K extends keyof RTCDtlsTransportEventMap>(type: K, listener: (this: RTCDtlsTransport, ev: RTCDtlsTransportEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof RTCDtlsTransportEventMap>(type: K, listener: (this: RTCDtlsTransport, ev: RTCDtlsTransportEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var RTCDtlsTransport: {\n    prototype: RTCDtlsTransport;\n    new(): RTCDtlsTransport;\n};\n\ninterface RTCDtlsTransportStateChangedEvent extends Event {\n    readonly state: RTCDtlsTransportState;\n}\n\ndeclare var RTCDtlsTransportStateChangedEvent: {\n    prototype: RTCDtlsTransportStateChangedEvent;\n    new(): RTCDtlsTransportStateChangedEvent;\n};\n\ninterface RTCDtmfSenderEventMap {\n    "tonechange": RTCDTMFToneChangeEvent;\n}\n\ninterface RTCDtmfSender extends EventTarget {\n    readonly canInsertDTMF: boolean;\n    readonly duration: number;\n    readonly interToneGap: number;\n    ontonechange: ((this: RTCDtmfSender, ev: RTCDTMFToneChangeEvent) => any) | null;\n    readonly sender: RTCRtpSender;\n    readonly toneBuffer: string;\n    insertDTMF(tones: string, duration?: number, interToneGap?: number): void;\n    addEventListener<K extends keyof RTCDtmfSenderEventMap>(type: K, listener: (this: RTCDtmfSender, ev: RTCDtmfSenderEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof RTCDtmfSenderEventMap>(type: K, listener: (this: RTCDtmfSender, ev: RTCDtmfSenderEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var RTCDtmfSender: {\n    prototype: RTCDtmfSender;\n    new(sender: RTCRtpSender): RTCDtmfSender;\n};\n\ninterface RTCError extends Error {\n    errorDetail: string;\n    httpRequestStatusCode: number;\n    message: string;\n    name: string;\n    receivedAlert: number | null;\n    sctpCauseCode: number;\n    sdpLineNumber: number;\n    sentAlert: number | null;\n}\n\ndeclare var RTCError: {\n    prototype: RTCError;\n    new(errorDetail?: string, message?: string): RTCError;\n};\n\ninterface RTCErrorEvent extends Event {\n    readonly error: RTCError | null;\n}\n\ndeclare var RTCErrorEvent: {\n    prototype: RTCErrorEvent;\n    new(type: string, eventInitDict: RTCErrorEventInit): RTCErrorEvent;\n};\n\n/** The RTCIceCandidate interface—part of the WebRTC API—represents a candidate Internet Connectivity Establishment (ICE) configuration which may be used to establish an RTCPeerConnection. */\ninterface RTCIceCandidate {\n    readonly candidate: string;\n    readonly component: RTCIceComponent | null;\n    readonly foundation: string | null;\n    readonly ip: string | null;\n    readonly port: number | null;\n    readonly priority: number | null;\n    readonly protocol: RTCIceProtocol | null;\n    readonly relatedAddress: string | null;\n    readonly relatedPort: number | null;\n    readonly sdpMLineIndex: number | null;\n    readonly sdpMid: string | null;\n    readonly tcpType: RTCIceTcpCandidateType | null;\n    readonly type: RTCIceCandidateType | null;\n    readonly usernameFragment: string | null;\n    toJSON(): RTCIceCandidateInit;\n}\n\ndeclare var RTCIceCandidate: {\n    prototype: RTCIceCandidate;\n    new(candidateInitDict?: RTCIceCandidateInit): RTCIceCandidate;\n};\n\ninterface RTCIceCandidatePairChangedEvent extends Event {\n    readonly pair: RTCIceCandidatePair;\n}\n\ndeclare var RTCIceCandidatePairChangedEvent: {\n    prototype: RTCIceCandidatePairChangedEvent;\n    new(): RTCIceCandidatePairChangedEvent;\n};\n\ninterface RTCIceGathererEventMap {\n    "error": Event;\n    "localcandidate": RTCIceGathererEvent;\n}\n\ninterface RTCIceGatherer extends RTCStatsProvider {\n    readonly component: RTCIceComponent;\n    onerror: ((this: RTCIceGatherer, ev: Event) => any) | null;\n    onlocalcandidate: ((this: RTCIceGatherer, ev: RTCIceGathererEvent) => any) | null;\n    createAssociatedGatherer(): RTCIceGatherer;\n    getLocalCandidates(): RTCIceCandidateDictionary[];\n    getLocalParameters(): RTCIceParameters;\n    addEventListener<K extends keyof RTCIceGathererEventMap>(type: K, listener: (this: RTCIceGatherer, ev: RTCIceGathererEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof RTCIceGathererEventMap>(type: K, listener: (this: RTCIceGatherer, ev: RTCIceGathererEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var RTCIceGatherer: {\n    prototype: RTCIceGatherer;\n    new(options: RTCIceGatherOptions): RTCIceGatherer;\n};\n\ninterface RTCIceGathererEvent extends Event {\n    readonly candidate: RTCIceCandidateDictionary | RTCIceCandidateComplete;\n}\n\ndeclare var RTCIceGathererEvent: {\n    prototype: RTCIceGathererEvent;\n    new(): RTCIceGathererEvent;\n};\n\ninterface RTCIceTransportEventMap {\n    "gatheringstatechange": Event;\n    "selectedcandidatepairchange": Event;\n    "statechange": Event;\n}\n\n/** Provides access to information about the ICE transport layer over which the data is being sent and received. */\ninterface RTCIceTransport extends EventTarget {\n    readonly component: RTCIceComponent;\n    readonly gatheringState: RTCIceGathererState;\n    ongatheringstatechange: ((this: RTCIceTransport, ev: Event) => any) | null;\n    onselectedcandidatepairchange: ((this: RTCIceTransport, ev: Event) => any) | null;\n    onstatechange: ((this: RTCIceTransport, ev: Event) => any) | null;\n    readonly role: RTCIceRole;\n    readonly state: RTCIceTransportState;\n    getLocalCandidates(): RTCIceCandidate[];\n    getLocalParameters(): RTCIceParameters | null;\n    getRemoteCandidates(): RTCIceCandidate[];\n    getRemoteParameters(): RTCIceParameters | null;\n    getSelectedCandidatePair(): RTCIceCandidatePair | null;\n    addEventListener<K extends keyof RTCIceTransportEventMap>(type: K, listener: (this: RTCIceTransport, ev: RTCIceTransportEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof RTCIceTransportEventMap>(type: K, listener: (this: RTCIceTransport, ev: RTCIceTransportEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var RTCIceTransport: {\n    prototype: RTCIceTransport;\n    new(): RTCIceTransport;\n};\n\ninterface RTCIceTransportStateChangedEvent extends Event {\n    readonly state: RTCIceTransportState;\n}\n\ndeclare var RTCIceTransportStateChangedEvent: {\n    prototype: RTCIceTransportStateChangedEvent;\n    new(): RTCIceTransportStateChangedEvent;\n};\n\ninterface RTCIdentityAssertion {\n    idp: string;\n    name: string;\n}\n\ndeclare var RTCIdentityAssertion: {\n    prototype: RTCIdentityAssertion;\n    new(idp: string, name: string): RTCIdentityAssertion;\n};\n\ninterface RTCPeerConnectionEventMap {\n    "connectionstatechange": Event;\n    "datachannel": RTCDataChannelEvent;\n    "icecandidate": RTCPeerConnectionIceEvent;\n    "icecandidateerror": RTCPeerConnectionIceErrorEvent;\n    "iceconnectionstatechange": Event;\n    "icegatheringstatechange": Event;\n    "negotiationneeded": Event;\n    "signalingstatechange": Event;\n    "statsended": RTCStatsEvent;\n    "track": RTCTrackEvent;\n}\n\n/** A WebRTC connection between the local computer and a remote peer. It provides methods to connect to a remote peer, maintain and monitor the connection, and close the connection once it\'s no longer needed. */\ninterface RTCPeerConnection extends EventTarget {\n    readonly canTrickleIceCandidates: boolean | null;\n    readonly connectionState: RTCPeerConnectionState;\n    readonly currentLocalDescription: RTCSessionDescription | null;\n    readonly currentRemoteDescription: RTCSessionDescription | null;\n    readonly iceConnectionState: RTCIceConnectionState;\n    readonly iceGatheringState: RTCIceGatheringState;\n    readonly idpErrorInfo: string | null;\n    readonly idpLoginUrl: string | null;\n    readonly localDescription: RTCSessionDescription | null;\n    onconnectionstatechange: ((this: RTCPeerConnection, ev: Event) => any) | null;\n    ondatachannel: ((this: RTCPeerConnection, ev: RTCDataChannelEvent) => any) | null;\n    onicecandidate: ((this: RTCPeerConnection, ev: RTCPeerConnectionIceEvent) => any) | null;\n    onicecandidateerror: ((this: RTCPeerConnection, ev: RTCPeerConnectionIceErrorEvent) => any) | null;\n    oniceconnectionstatechange: ((this: RTCPeerConnection, ev: Event) => any) | null;\n    onicegatheringstatechange: ((this: RTCPeerConnection, ev: Event) => any) | null;\n    onnegotiationneeded: ((this: RTCPeerConnection, ev: Event) => any) | null;\n    onsignalingstatechange: ((this: RTCPeerConnection, ev: Event) => any) | null;\n    onstatsended: ((this: RTCPeerConnection, ev: RTCStatsEvent) => any) | null;\n    ontrack: ((this: RTCPeerConnection, ev: RTCTrackEvent) => any) | null;\n    readonly peerIdentity: Promise<RTCIdentityAssertion>;\n    readonly pendingLocalDescription: RTCSessionDescription | null;\n    readonly pendingRemoteDescription: RTCSessionDescription | null;\n    readonly remoteDescription: RTCSessionDescription | null;\n    readonly sctp: RTCSctpTransport | null;\n    readonly signalingState: RTCSignalingState;\n    addIceCandidate(candidate: RTCIceCandidateInit | RTCIceCandidate): Promise<void>;\n    addTrack(track: MediaStreamTrack, ...streams: MediaStream[]): RTCRtpSender;\n    addTransceiver(trackOrKind: MediaStreamTrack | string, init?: RTCRtpTransceiverInit): RTCRtpTransceiver;\n    close(): void;\n    createAnswer(options?: RTCOfferOptions): Promise<RTCSessionDescriptionInit>;\n    createDataChannel(label: string, dataChannelDict?: RTCDataChannelInit): RTCDataChannel;\n    createOffer(options?: RTCOfferOptions): Promise<RTCSessionDescriptionInit>;\n    getConfiguration(): RTCConfiguration;\n    getIdentityAssertion(): Promise<string>;\n    getReceivers(): RTCRtpReceiver[];\n    getSenders(): RTCRtpSender[];\n    getStats(selector?: MediaStreamTrack | null): Promise<RTCStatsReport>;\n    getTransceivers(): RTCRtpTransceiver[];\n    removeTrack(sender: RTCRtpSender): void;\n    setConfiguration(configuration: RTCConfiguration): void;\n    setIdentityProvider(provider: string, options?: RTCIdentityProviderOptions): void;\n    setLocalDescription(description: RTCSessionDescriptionInit): Promise<void>;\n    setRemoteDescription(description: RTCSessionDescriptionInit): Promise<void>;\n    addEventListener<K extends keyof RTCPeerConnectionEventMap>(type: K, listener: (this: RTCPeerConnection, ev: RTCPeerConnectionEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof RTCPeerConnectionEventMap>(type: K, listener: (this: RTCPeerConnection, ev: RTCPeerConnectionEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var RTCPeerConnection: {\n    prototype: RTCPeerConnection;\n    new(configuration?: RTCConfiguration): RTCPeerConnection;\n    generateCertificate(keygenAlgorithm: AlgorithmIdentifier): Promise<RTCCertificate>;\n    getDefaultIceServers(): RTCIceServer[];\n};\n\ninterface RTCPeerConnectionIceErrorEvent extends Event {\n    readonly errorCode: number;\n    readonly errorText: string;\n    readonly hostCandidate: string;\n    readonly url: string;\n}\n\ndeclare var RTCPeerConnectionIceErrorEvent: {\n    prototype: RTCPeerConnectionIceErrorEvent;\n    new(type: string, eventInitDict: RTCPeerConnectionIceErrorEventInit): RTCPeerConnectionIceErrorEvent;\n};\n\n/** Events that occurs in relation to ICE candidates with the target, usually an RTCPeerConnection. Only one event is of this type: icecandidate. */\ninterface RTCPeerConnectionIceEvent extends Event {\n    readonly candidate: RTCIceCandidate | null;\n    readonly url: string | null;\n}\n\ndeclare var RTCPeerConnectionIceEvent: {\n    prototype: RTCPeerConnectionIceEvent;\n    new(type: string, eventInitDict?: RTCPeerConnectionIceEventInit): RTCPeerConnectionIceEvent;\n};\n\n/** An interface of the WebRTC API manages the reception and decoding of data for a MediaStreamTrack on an RTCPeerConnection. */\ninterface RTCRtpReceiver {\n    readonly rtcpTransport: RTCDtlsTransport | null;\n    readonly track: MediaStreamTrack;\n    readonly transport: RTCDtlsTransport | null;\n    getContributingSources(): RTCRtpContributingSource[];\n    getParameters(): RTCRtpReceiveParameters;\n    getStats(): Promise<RTCStatsReport>;\n    getSynchronizationSources(): RTCRtpSynchronizationSource[];\n}\n\ndeclare var RTCRtpReceiver: {\n    prototype: RTCRtpReceiver;\n    new(): RTCRtpReceiver;\n    getCapabilities(kind: string): RTCRtpCapabilities | null;\n};\n\n/** Provides the ability to control and obtain details about how a particular MediaStreamTrack is encoded and sent to a remote peer. */\ninterface RTCRtpSender {\n    readonly dtmf: RTCDTMFSender | null;\n    readonly rtcpTransport: RTCDtlsTransport | null;\n    readonly track: MediaStreamTrack | null;\n    readonly transport: RTCDtlsTransport | null;\n    getParameters(): RTCRtpSendParameters;\n    getStats(): Promise<RTCStatsReport>;\n    replaceTrack(withTrack: MediaStreamTrack | null): Promise<void>;\n    setParameters(parameters: RTCRtpSendParameters): Promise<void>;\n    setStreams(...streams: MediaStream[]): void;\n}\n\ndeclare var RTCRtpSender: {\n    prototype: RTCRtpSender;\n    new(): RTCRtpSender;\n    getCapabilities(kind: string): RTCRtpCapabilities | null;\n};\n\ninterface RTCRtpTransceiver {\n    readonly currentDirection: RTCRtpTransceiverDirection | null;\n    direction: RTCRtpTransceiverDirection;\n    readonly mid: string | null;\n    readonly receiver: RTCRtpReceiver;\n    readonly sender: RTCRtpSender;\n    readonly stopped: boolean;\n    setCodecPreferences(codecs: RTCRtpCodecCapability[]): void;\n    stop(): void;\n}\n\ndeclare var RTCRtpTransceiver: {\n    prototype: RTCRtpTransceiver;\n    new(): RTCRtpTransceiver;\n};\n\ninterface RTCSctpTransportEventMap {\n    "statechange": Event;\n}\n\ninterface RTCSctpTransport {\n    readonly maxChannels: number | null;\n    readonly maxMessageSize: number;\n    onstatechange: ((this: RTCSctpTransport, ev: Event) => any) | null;\n    readonly state: RTCSctpTransportState;\n    readonly transport: RTCDtlsTransport;\n    addEventListener<K extends keyof RTCSctpTransportEventMap>(type: K, listener: (this: RTCSctpTransport, ev: RTCSctpTransportEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof RTCSctpTransportEventMap>(type: K, listener: (this: RTCSctpTransport, ev: RTCSctpTransportEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var RTCSctpTransport: {\n    prototype: RTCSctpTransport;\n    new(): RTCSctpTransport;\n};\n\n/** One end of a connection—or potential connection—and how it\'s configured. Each RTCSessionDescription consists of a description type indicating which part of the offer/answer negotiation process it describes and of the SDP descriptor of the session. */\ninterface RTCSessionDescription {\n    readonly sdp: string;\n    readonly type: RTCSdpType;\n    toJSON(): any;\n}\n\ndeclare var RTCSessionDescription: {\n    prototype: RTCSessionDescription;\n    new(descriptionInitDict: RTCSessionDescriptionInit): RTCSessionDescription;\n};\n\ninterface RTCSrtpSdesTransportEventMap {\n    "error": Event;\n}\n\ninterface RTCSrtpSdesTransport extends EventTarget {\n    onerror: ((this: RTCSrtpSdesTransport, ev: Event) => any) | null;\n    readonly transport: RTCIceTransport;\n    addEventListener<K extends keyof RTCSrtpSdesTransportEventMap>(type: K, listener: (this: RTCSrtpSdesTransport, ev: RTCSrtpSdesTransportEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof RTCSrtpSdesTransportEventMap>(type: K, listener: (this: RTCSrtpSdesTransport, ev: RTCSrtpSdesTransportEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var RTCSrtpSdesTransport: {\n    prototype: RTCSrtpSdesTransport;\n    new(transport: RTCIceTransport, encryptParameters: RTCSrtpSdesParameters, decryptParameters: RTCSrtpSdesParameters): RTCSrtpSdesTransport;\n    getLocalParameters(): RTCSrtpSdesParameters[];\n};\n\ninterface RTCSsrcConflictEvent extends Event {\n    readonly ssrc: number;\n}\n\ndeclare var RTCSsrcConflictEvent: {\n    prototype: RTCSsrcConflictEvent;\n    new(): RTCSsrcConflictEvent;\n};\n\ninterface RTCStatsEvent extends Event {\n    readonly report: RTCStatsReport;\n}\n\ndeclare var RTCStatsEvent: {\n    prototype: RTCStatsEvent;\n    new(type: string, eventInitDict: RTCStatsEventInit): RTCStatsEvent;\n};\n\ninterface RTCStatsProvider extends EventTarget {\n    getStats(): Promise<RTCStatsReport>;\n    msGetStats(): Promise<RTCStatsReport>;\n}\n\ndeclare var RTCStatsProvider: {\n    prototype: RTCStatsProvider;\n    new(): RTCStatsProvider;\n};\n\ninterface RTCStatsReport {\n    forEach(callbackfn: (value: any, key: string, parent: RTCStatsReport) => void, thisArg?: any): void;\n}\n\ndeclare var RTCStatsReport: {\n    prototype: RTCStatsReport;\n    new(): RTCStatsReport;\n};\n\ninterface RTCTrackEvent extends Event {\n    readonly receiver: RTCRtpReceiver;\n    readonly streams: ReadonlyArray<MediaStream>;\n    readonly track: MediaStreamTrack;\n    readonly transceiver: RTCRtpTransceiver;\n}\n\ndeclare var RTCTrackEvent: {\n    prototype: RTCTrackEvent;\n    new(type: string, eventInitDict: RTCTrackEventInit): RTCTrackEvent;\n};\n\ninterface RadioNodeList extends NodeList {\n    value: string;\n}\n\ndeclare var RadioNodeList: {\n    prototype: RadioNodeList;\n    new(): RadioNodeList;\n};\n\ninterface RandomSource {\n    getRandomValues<T extends Int8Array | Uint8ClampedArray | Uint8Array | Int16Array | Uint16Array | Int32Array | Uint32Array>(array: T): T;\n}\n\ndeclare var RandomSource: {\n    prototype: RandomSource;\n    new(): RandomSource;\n};\n\n/** A fragment of a document that can contain nodes and parts of text nodes. */\ninterface Range extends AbstractRange {\n    /**\n     * Returns the node, furthest away from\n     * the document, that is an ancestor of both range\'s start node and end node.\n     */\n    readonly commonAncestorContainer: Node;\n    cloneContents(): DocumentFragment;\n    cloneRange(): Range;\n    collapse(toStart?: boolean): void;\n    compareBoundaryPoints(how: number, sourceRange: Range): number;\n    /**\n     * Returns −1 if the point is before the range, 0 if the point is\n     * in the range, and 1 if the point is after the range.\n     */\n    comparePoint(node: Node, offset: number): number;\n    createContextualFragment(fragment: string): DocumentFragment;\n    deleteContents(): void;\n    detach(): void;\n    extractContents(): DocumentFragment;\n    getBoundingClientRect(): ClientRect | DOMRect;\n    getClientRects(): ClientRectList | DOMRectList;\n    insertNode(node: Node): void;\n    /**\n     * Returns whether range intersects node.\n     */\n    intersectsNode(node: Node): boolean;\n    isPointInRange(node: Node, offset: number): boolean;\n    selectNode(node: Node): void;\n    selectNodeContents(node: Node): void;\n    setEnd(node: Node, offset: number): void;\n    setEndAfter(node: Node): void;\n    setEndBefore(node: Node): void;\n    setStart(node: Node, offset: number): void;\n    setStartAfter(node: Node): void;\n    setStartBefore(node: Node): void;\n    surroundContents(newParent: Node): void;\n    readonly END_TO_END: number;\n    readonly END_TO_START: number;\n    readonly START_TO_END: number;\n    readonly START_TO_START: number;\n}\n\ndeclare var Range: {\n    prototype: Range;\n    new(): Range;\n    readonly END_TO_END: number;\n    readonly END_TO_START: number;\n    readonly START_TO_END: number;\n    readonly START_TO_START: number;\n};\n\ninterface ReadableByteStreamController {\n    readonly byobRequest: ReadableStreamBYOBRequest | undefined;\n    readonly desiredSize: number | null;\n    close(): void;\n    enqueue(chunk: ArrayBufferView): void;\n    error(error?: any): void;\n}\n\n/** An interface of the Streams API represents a readable stream of byte data. The Fetch API offers a concrete instance of a ReadableStream through the body property of a Response object. */\ninterface ReadableStream<R = any> {\n    readonly locked: boolean;\n    cancel(reason?: any): Promise<void>;\n    getReader(options: { mode: "byob" }): ReadableStreamBYOBReader;\n    getReader(): ReadableStreamDefaultReader<R>;\n    pipeThrough<T>({ writable, readable }: { writable: WritableStream<R>, readable: ReadableStream<T> }, options?: PipeOptions): ReadableStream<T>;\n    pipeTo(dest: WritableStream<R>, options?: PipeOptions): Promise<void>;\n    tee(): [ReadableStream<R>, ReadableStream<R>];\n}\n\ndeclare var ReadableStream: {\n    prototype: ReadableStream;\n    new(underlyingSource: UnderlyingByteSource, strategy?: { highWaterMark?: number, size?: undefined }): ReadableStream<Uint8Array>;\n    new<R = any>(underlyingSource?: UnderlyingSource<R>, strategy?: QueuingStrategy<R>): ReadableStream<R>;\n};\n\ninterface ReadableStreamBYOBReader {\n    readonly closed: Promise<void>;\n    cancel(reason?: any): Promise<void>;\n    read<T extends ArrayBufferView>(view: T): Promise<ReadableStreamReadResult<T>>;\n    releaseLock(): void;\n}\n\ninterface ReadableStreamBYOBRequest {\n    readonly view: ArrayBufferView;\n    respond(bytesWritten: number): void;\n    respondWithNewView(view: ArrayBufferView): void;\n}\n\ninterface ReadableStreamDefaultController<R = any> {\n    readonly desiredSize: number | null;\n    close(): void;\n    enqueue(chunk: R): void;\n    error(error?: any): void;\n}\n\ninterface ReadableStreamDefaultReader<R = any> {\n    readonly closed: Promise<void>;\n    cancel(reason?: any): Promise<void>;\n    read(): Promise<ReadableStreamReadResult<R>>;\n    releaseLock(): void;\n}\n\ninterface ReadableStreamReadResult<T> {\n    done: boolean;\n    value: T;\n}\n\ninterface ReadableStreamReader<R = any> {\n    cancel(): Promise<void>;\n    read(): Promise<ReadableStreamReadResult<R>>;\n    releaseLock(): void;\n}\n\ndeclare var ReadableStreamReader: {\n    prototype: ReadableStreamReader;\n    new(): ReadableStreamReader;\n};\n\n/** An interface of the Fetch API represents a resource request. */\ninterface Request extends Body {\n    /**\n     * Returns the cache mode associated with request, which is a string indicating\n     * how the request will interact with the browser\'s cache when fetching.\n     */\n    readonly cache: RequestCache;\n    /**\n     * Returns the credentials mode associated with request, which is a string\n     * indicating whether credentials will be sent with the request always, never, or only when sent to a\n     * same-origin URL.\n     */\n    readonly credentials: RequestCredentials;\n    /**\n     * Returns the kind of resource requested by request, e.g., "document" or\n     * "script".\n     */\n    readonly destination: RequestDestination;\n    /**\n     * Returns a Headers object consisting of the headers associated with request.\n     * Note that headers added in the network layer by the user agent will not be accounted for in this\n     * object, e.g., the "Host" header.\n     */\n    readonly headers: Headers;\n    /**\n     * Returns request\'s subresource integrity metadata, which is a cryptographic hash of\n     * the resource being fetched. Its value consists of multiple hashes separated by whitespace. [SRI]\n     */\n    readonly integrity: string;\n    /**\n     * Returns a boolean indicating whether or not request is for a history\n     * navigation (a.k.a. back-foward navigation).\n     */\n    readonly isHistoryNavigation: boolean;\n    /**\n     * Returns a boolean indicating whether or not request is for a reload navigation.\n     */\n    readonly isReloadNavigation: boolean;\n    /**\n     * Returns a boolean indicating whether or not request can outlive the global in which\n     * it was created.\n     */\n    readonly keepalive: boolean;\n    /**\n     * Returns request\'s HTTP method, which is "GET" by default.\n     */\n    readonly method: string;\n    /**\n     * Returns the mode associated with request, which is a string indicating\n     * whether the request will use CORS, or will be restricted to same-origin URLs.\n     */\n    readonly mode: RequestMode;\n    /**\n     * Returns the redirect mode associated with request, which is a string\n     * indicating how redirects for the request will be handled during fetching. A request will follow redirects by default.\n     */\n    readonly redirect: RequestRedirect;\n    /**\n     * Returns the referrer of request. Its value can be a same-origin URL if\n     * explicitly set in init, the empty string to indicate no referrer, and\n     * "about:client" when defaulting to the global\'s default. This is used during\n     * fetching to determine the value of the `Referer` header of the request being made.\n     */\n    readonly referrer: string;\n    /**\n     * Returns the referrer policy associated with request. This is used during\n     * fetching to compute the value of the request\'s referrer.\n     */\n    readonly referrerPolicy: ReferrerPolicy;\n    /**\n     * Returns the signal associated with request, which is an AbortSignal object indicating whether or not request has been aborted, and its abort\n     * event handler.\n     */\n    readonly signal: AbortSignal;\n    /**\n     * Returns the URL of request as a string.\n     */\n    readonly url: string;\n    clone(): Request;\n}\n\ndeclare var Request: {\n    prototype: Request;\n    new(input: RequestInfo, init?: RequestInit): Request;\n};\n\n/** An interface of the Fetch API represents the response to a request. */\ninterface Response extends Body {\n    readonly headers: Headers;\n    readonly ok: boolean;\n    readonly redirected: boolean;\n    readonly status: number;\n    readonly statusText: string;\n    readonly trailer: Promise<Headers>;\n    readonly type: ResponseType;\n    readonly url: string;\n    clone(): Response;\n}\n\ndeclare var Response: {\n    prototype: Response;\n    new(body?: BodyInit | null, init?: ResponseInit): Response;\n    error(): Response;\n    redirect(url: string, status?: number): Response;\n};\n\n/** Provides access to the properties of <a> element, as well as methods to manipulate them. */\ninterface SVGAElement extends SVGGraphicsElement, SVGURIReference {\n    readonly target: SVGAnimatedString;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGAElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGAElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGAElement: {\n    prototype: SVGAElement;\n    new(): SVGAElement;\n};\n\n/** Used to represent a value that can be an <angle> or <number> value. An SVGAngle reflected through the animVal attribute is always read only. */\ninterface SVGAngle {\n    readonly unitType: number;\n    value: number;\n    valueAsString: string;\n    valueInSpecifiedUnits: number;\n    convertToSpecifiedUnits(unitType: number): void;\n    newValueSpecifiedUnits(unitType: number, valueInSpecifiedUnits: number): void;\n    readonly SVG_ANGLETYPE_DEG: number;\n    readonly SVG_ANGLETYPE_GRAD: number;\n    readonly SVG_ANGLETYPE_RAD: number;\n    readonly SVG_ANGLETYPE_UNKNOWN: number;\n    readonly SVG_ANGLETYPE_UNSPECIFIED: number;\n}\n\ndeclare var SVGAngle: {\n    prototype: SVGAngle;\n    new(): SVGAngle;\n    readonly SVG_ANGLETYPE_DEG: number;\n    readonly SVG_ANGLETYPE_GRAD: number;\n    readonly SVG_ANGLETYPE_RAD: number;\n    readonly SVG_ANGLETYPE_UNKNOWN: number;\n    readonly SVG_ANGLETYPE_UNSPECIFIED: number;\n};\n\ninterface SVGAnimateElement extends SVGAnimationElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGAnimateElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGAnimateElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGAnimateElement: {\n    prototype: SVGAnimateElement;\n    new(): SVGAnimateElement;\n};\n\ninterface SVGAnimateMotionElement extends SVGAnimationElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGAnimateMotionElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGAnimateMotionElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGAnimateMotionElement: {\n    prototype: SVGAnimateMotionElement;\n    new(): SVGAnimateMotionElement;\n};\n\ninterface SVGAnimateTransformElement extends SVGAnimationElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGAnimateTransformElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGAnimateTransformElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGAnimateTransformElement: {\n    prototype: SVGAnimateTransformElement;\n    new(): SVGAnimateTransformElement;\n};\n\n/** Used for attributes of basic type <angle> which can be animated. */\ninterface SVGAnimatedAngle {\n    readonly animVal: SVGAngle;\n    readonly baseVal: SVGAngle;\n}\n\ndeclare var SVGAnimatedAngle: {\n    prototype: SVGAnimatedAngle;\n    new(): SVGAnimatedAngle;\n};\n\n/** Used for attributes of type boolean which can be animated. */\ninterface SVGAnimatedBoolean {\n    readonly animVal: boolean;\n    baseVal: boolean;\n}\n\ndeclare var SVGAnimatedBoolean: {\n    prototype: SVGAnimatedBoolean;\n    new(): SVGAnimatedBoolean;\n};\n\n/** Used for attributes whose value must be a constant from a particular enumeration and which can be animated. */\ninterface SVGAnimatedEnumeration {\n    readonly animVal: number;\n    baseVal: number;\n}\n\ndeclare var SVGAnimatedEnumeration: {\n    prototype: SVGAnimatedEnumeration;\n    new(): SVGAnimatedEnumeration;\n};\n\n/** Used for attributes of basic type <integer> which can be animated. */\ninterface SVGAnimatedInteger {\n    readonly animVal: number;\n    baseVal: number;\n}\n\ndeclare var SVGAnimatedInteger: {\n    prototype: SVGAnimatedInteger;\n    new(): SVGAnimatedInteger;\n};\n\n/** Used for attributes of basic type <length> which can be animated. */\ninterface SVGAnimatedLength {\n    readonly animVal: SVGLength;\n    readonly baseVal: SVGLength;\n}\n\ndeclare var SVGAnimatedLength: {\n    prototype: SVGAnimatedLength;\n    new(): SVGAnimatedLength;\n};\n\n/** Used for attributes of type SVGLengthList which can be animated. */\ninterface SVGAnimatedLengthList {\n    readonly animVal: SVGLengthList;\n    readonly baseVal: SVGLengthList;\n}\n\ndeclare var SVGAnimatedLengthList: {\n    prototype: SVGAnimatedLengthList;\n    new(): SVGAnimatedLengthList;\n};\n\n/** Used for attributes of basic type <Number> which can be animated. */\ninterface SVGAnimatedNumber {\n    readonly animVal: number;\n    baseVal: number;\n}\n\ndeclare var SVGAnimatedNumber: {\n    prototype: SVGAnimatedNumber;\n    new(): SVGAnimatedNumber;\n};\n\n/** The SVGAnimatedNumber interface is used for attributes which take a list of numbers and which can be animated. */\ninterface SVGAnimatedNumberList {\n    readonly animVal: SVGNumberList;\n    readonly baseVal: SVGNumberList;\n}\n\ndeclare var SVGAnimatedNumberList: {\n    prototype: SVGAnimatedNumberList;\n    new(): SVGAnimatedNumberList;\n};\n\ninterface SVGAnimatedPoints {\n    readonly animatedPoints: SVGPointList;\n    readonly points: SVGPointList;\n}\n\n/** Used for attributes of type SVGPreserveAspectRatio which can be animated. */\ninterface SVGAnimatedPreserveAspectRatio {\n    readonly animVal: SVGPreserveAspectRatio;\n    readonly baseVal: SVGPreserveAspectRatio;\n}\n\ndeclare var SVGAnimatedPreserveAspectRatio: {\n    prototype: SVGAnimatedPreserveAspectRatio;\n    new(): SVGAnimatedPreserveAspectRatio;\n};\n\n/** Used for attributes of basic SVGRect which can be animated. */\ninterface SVGAnimatedRect {\n    readonly animVal: DOMRectReadOnly;\n    readonly baseVal: DOMRect;\n}\n\ndeclare var SVGAnimatedRect: {\n    prototype: SVGAnimatedRect;\n    new(): SVGAnimatedRect;\n};\n\n/** The SVGAnimatedString interface represents string attributes which can be animated from each SVG declaration. You need to create SVG attribute before doing anything else, everything should be declared inside this. */\ninterface SVGAnimatedString {\n    readonly animVal: string;\n    baseVal: string;\n}\n\ndeclare var SVGAnimatedString: {\n    prototype: SVGAnimatedString;\n    new(): SVGAnimatedString;\n};\n\n/** Used for attributes which take a list of numbers and which can be animated. */\ninterface SVGAnimatedTransformList {\n    readonly animVal: SVGTransformList;\n    readonly baseVal: SVGTransformList;\n}\n\ndeclare var SVGAnimatedTransformList: {\n    prototype: SVGAnimatedTransformList;\n    new(): SVGAnimatedTransformList;\n};\n\ninterface SVGAnimationElement extends SVGElement {\n    readonly targetElement: SVGElement;\n    getCurrentTime(): number;\n    getSimpleDuration(): number;\n    getStartTime(): number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGAnimationElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGAnimationElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGAnimationElement: {\n    prototype: SVGAnimationElement;\n    new(): SVGAnimationElement;\n};\n\n/** An interface for the <circle> element. The circle element is defined by the cx and cy attributes that denote the coordinates of the centre of the circle. */\ninterface SVGCircleElement extends SVGGeometryElement {\n    readonly cx: SVGAnimatedLength;\n    readonly cy: SVGAnimatedLength;\n    readonly r: SVGAnimatedLength;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGCircleElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGCircleElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGCircleElement: {\n    prototype: SVGCircleElement;\n    new(): SVGCircleElement;\n};\n\n/** Provides access to the properties of <clipPath> elements, as well as methods to manipulate them. */\ninterface SVGClipPathElement extends SVGGraphicsElement {\n    readonly clipPathUnits: SVGAnimatedEnumeration;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGClipPathElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGClipPathElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGClipPathElement: {\n    prototype: SVGClipPathElement;\n    new(): SVGClipPathElement;\n};\n\n/** A base interface used by the component transfer function interfaces. */\ninterface SVGComponentTransferFunctionElement extends SVGElement {\n    readonly amplitude: SVGAnimatedNumber;\n    readonly exponent: SVGAnimatedNumber;\n    readonly intercept: SVGAnimatedNumber;\n    readonly offset: SVGAnimatedNumber;\n    readonly slope: SVGAnimatedNumber;\n    readonly tableValues: SVGAnimatedNumberList;\n    readonly type: SVGAnimatedEnumeration;\n    readonly SVG_FECOMPONENTTRANSFER_TYPE_DISCRETE: number;\n    readonly SVG_FECOMPONENTTRANSFER_TYPE_GAMMA: number;\n    readonly SVG_FECOMPONENTTRANSFER_TYPE_IDENTITY: number;\n    readonly SVG_FECOMPONENTTRANSFER_TYPE_LINEAR: number;\n    readonly SVG_FECOMPONENTTRANSFER_TYPE_TABLE: number;\n    readonly SVG_FECOMPONENTTRANSFER_TYPE_UNKNOWN: number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGComponentTransferFunctionElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGComponentTransferFunctionElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGComponentTransferFunctionElement: {\n    prototype: SVGComponentTransferFunctionElement;\n    new(): SVGComponentTransferFunctionElement;\n    readonly SVG_FECOMPONENTTRANSFER_TYPE_DISCRETE: number;\n    readonly SVG_FECOMPONENTTRANSFER_TYPE_GAMMA: number;\n    readonly SVG_FECOMPONENTTRANSFER_TYPE_IDENTITY: number;\n    readonly SVG_FECOMPONENTTRANSFER_TYPE_LINEAR: number;\n    readonly SVG_FECOMPONENTTRANSFER_TYPE_TABLE: number;\n    readonly SVG_FECOMPONENTTRANSFER_TYPE_UNKNOWN: number;\n};\n\ninterface SVGCursorElement extends SVGElement {\n    readonly x: SVGAnimatedLength;\n    readonly y: SVGAnimatedLength;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGCursorElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGCursorElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGCursorElement: {\n    prototype: SVGCursorElement;\n    new(): SVGCursorElement;\n};\n\n/** Corresponds to the <defs> element. */\ninterface SVGDefsElement extends SVGGraphicsElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGDefsElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGDefsElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGDefsElement: {\n    prototype: SVGDefsElement;\n    new(): SVGDefsElement;\n};\n\n/** Corresponds to the <desc> element. */\ninterface SVGDescElement extends SVGElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGDescElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGDescElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGDescElement: {\n    prototype: SVGDescElement;\n    new(): SVGDescElement;\n};\n\ninterface SVGElementEventMap extends ElementEventMap, GlobalEventHandlersEventMap, DocumentAndElementEventHandlersEventMap {\n}\n\n/** All of the SVG DOM interfaces that correspond directly to elements in the SVG language derive from the SVGElement interface. */\ninterface SVGElement extends Element, GlobalEventHandlers, DocumentAndElementEventHandlers, SVGElementInstance, HTMLOrSVGElement, ElementCSSInlineStyle {\n    /** @deprecated */\n    readonly className: any;\n    readonly ownerSVGElement: SVGSVGElement | null;\n    readonly viewportElement: SVGElement | null;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGElement: {\n    prototype: SVGElement;\n    new(): SVGElement;\n};\n\ninterface SVGElementInstance extends EventTarget {\n    readonly correspondingElement: SVGElement;\n    readonly correspondingUseElement: SVGUseElement;\n}\n\ndeclare var SVGElementInstance: {\n    prototype: SVGElementInstance;\n    new(): SVGElementInstance;\n};\n\ninterface SVGElementInstanceList {\n    /** @deprecated */\n    readonly length: number;\n    /** @deprecated */\n    item(index: number): SVGElementInstance;\n}\n\ndeclare var SVGElementInstanceList: {\n    prototype: SVGElementInstanceList;\n    new(): SVGElementInstanceList;\n};\n\n/** Provides access to the properties of <ellipse> elements. */\ninterface SVGEllipseElement extends SVGGeometryElement {\n    readonly cx: SVGAnimatedLength;\n    readonly cy: SVGAnimatedLength;\n    readonly rx: SVGAnimatedLength;\n    readonly ry: SVGAnimatedLength;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGEllipseElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGEllipseElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGEllipseElement: {\n    prototype: SVGEllipseElement;\n    new(): SVGEllipseElement;\n};\n\n/** Corresponds to the <feBlend> element. */\ninterface SVGFEBlendElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly in1: SVGAnimatedString;\n    readonly in2: SVGAnimatedString;\n    readonly mode: SVGAnimatedEnumeration;\n    readonly SVG_FEBLEND_MODE_COLOR: number;\n    readonly SVG_FEBLEND_MODE_COLOR_BURN: number;\n    readonly SVG_FEBLEND_MODE_COLOR_DODGE: number;\n    readonly SVG_FEBLEND_MODE_DARKEN: number;\n    readonly SVG_FEBLEND_MODE_DIFFERENCE: number;\n    readonly SVG_FEBLEND_MODE_EXCLUSION: number;\n    readonly SVG_FEBLEND_MODE_HARD_LIGHT: number;\n    readonly SVG_FEBLEND_MODE_HUE: number;\n    readonly SVG_FEBLEND_MODE_LIGHTEN: number;\n    readonly SVG_FEBLEND_MODE_LUMINOSITY: number;\n    readonly SVG_FEBLEND_MODE_MULTIPLY: number;\n    readonly SVG_FEBLEND_MODE_NORMAL: number;\n    readonly SVG_FEBLEND_MODE_OVERLAY: number;\n    readonly SVG_FEBLEND_MODE_SATURATION: number;\n    readonly SVG_FEBLEND_MODE_SCREEN: number;\n    readonly SVG_FEBLEND_MODE_SOFT_LIGHT: number;\n    readonly SVG_FEBLEND_MODE_UNKNOWN: number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEBlendElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEBlendElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEBlendElement: {\n    prototype: SVGFEBlendElement;\n    new(): SVGFEBlendElement;\n    readonly SVG_FEBLEND_MODE_COLOR: number;\n    readonly SVG_FEBLEND_MODE_COLOR_BURN: number;\n    readonly SVG_FEBLEND_MODE_COLOR_DODGE: number;\n    readonly SVG_FEBLEND_MODE_DARKEN: number;\n    readonly SVG_FEBLEND_MODE_DIFFERENCE: number;\n    readonly SVG_FEBLEND_MODE_EXCLUSION: number;\n    readonly SVG_FEBLEND_MODE_HARD_LIGHT: number;\n    readonly SVG_FEBLEND_MODE_HUE: number;\n    readonly SVG_FEBLEND_MODE_LIGHTEN: number;\n    readonly SVG_FEBLEND_MODE_LUMINOSITY: number;\n    readonly SVG_FEBLEND_MODE_MULTIPLY: number;\n    readonly SVG_FEBLEND_MODE_NORMAL: number;\n    readonly SVG_FEBLEND_MODE_OVERLAY: number;\n    readonly SVG_FEBLEND_MODE_SATURATION: number;\n    readonly SVG_FEBLEND_MODE_SCREEN: number;\n    readonly SVG_FEBLEND_MODE_SOFT_LIGHT: number;\n    readonly SVG_FEBLEND_MODE_UNKNOWN: number;\n};\n\n/** Corresponds to the <feColorMatrix> element. */\ninterface SVGFEColorMatrixElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly in1: SVGAnimatedString;\n    readonly type: SVGAnimatedEnumeration;\n    readonly values: SVGAnimatedNumberList;\n    readonly SVG_FECOLORMATRIX_TYPE_HUEROTATE: number;\n    readonly SVG_FECOLORMATRIX_TYPE_LUMINANCETOALPHA: number;\n    readonly SVG_FECOLORMATRIX_TYPE_MATRIX: number;\n    readonly SVG_FECOLORMATRIX_TYPE_SATURATE: number;\n    readonly SVG_FECOLORMATRIX_TYPE_UNKNOWN: number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEColorMatrixElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEColorMatrixElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEColorMatrixElement: {\n    prototype: SVGFEColorMatrixElement;\n    new(): SVGFEColorMatrixElement;\n    readonly SVG_FECOLORMATRIX_TYPE_HUEROTATE: number;\n    readonly SVG_FECOLORMATRIX_TYPE_LUMINANCETOALPHA: number;\n    readonly SVG_FECOLORMATRIX_TYPE_MATRIX: number;\n    readonly SVG_FECOLORMATRIX_TYPE_SATURATE: number;\n    readonly SVG_FECOLORMATRIX_TYPE_UNKNOWN: number;\n};\n\n/** Corresponds to the <feComponentTransfer> element. */\ninterface SVGFEComponentTransferElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly in1: SVGAnimatedString;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEComponentTransferElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEComponentTransferElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEComponentTransferElement: {\n    prototype: SVGFEComponentTransferElement;\n    new(): SVGFEComponentTransferElement;\n};\n\n/** Corresponds to the <feComposite> element. */\ninterface SVGFECompositeElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly in1: SVGAnimatedString;\n    readonly in2: SVGAnimatedString;\n    readonly k1: SVGAnimatedNumber;\n    readonly k2: SVGAnimatedNumber;\n    readonly k3: SVGAnimatedNumber;\n    readonly k4: SVGAnimatedNumber;\n    readonly operator: SVGAnimatedEnumeration;\n    readonly SVG_FECOMPOSITE_OPERATOR_ARITHMETIC: number;\n    readonly SVG_FECOMPOSITE_OPERATOR_ATOP: number;\n    readonly SVG_FECOMPOSITE_OPERATOR_IN: number;\n    readonly SVG_FECOMPOSITE_OPERATOR_OUT: number;\n    readonly SVG_FECOMPOSITE_OPERATOR_OVER: number;\n    readonly SVG_FECOMPOSITE_OPERATOR_UNKNOWN: number;\n    readonly SVG_FECOMPOSITE_OPERATOR_XOR: number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFECompositeElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFECompositeElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFECompositeElement: {\n    prototype: SVGFECompositeElement;\n    new(): SVGFECompositeElement;\n    readonly SVG_FECOMPOSITE_OPERATOR_ARITHMETIC: number;\n    readonly SVG_FECOMPOSITE_OPERATOR_ATOP: number;\n    readonly SVG_FECOMPOSITE_OPERATOR_IN: number;\n    readonly SVG_FECOMPOSITE_OPERATOR_OUT: number;\n    readonly SVG_FECOMPOSITE_OPERATOR_OVER: number;\n    readonly SVG_FECOMPOSITE_OPERATOR_UNKNOWN: number;\n    readonly SVG_FECOMPOSITE_OPERATOR_XOR: number;\n};\n\n/** Corresponds to the <feConvolveMatrix> element. */\ninterface SVGFEConvolveMatrixElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly bias: SVGAnimatedNumber;\n    readonly divisor: SVGAnimatedNumber;\n    readonly edgeMode: SVGAnimatedEnumeration;\n    readonly in1: SVGAnimatedString;\n    readonly kernelMatrix: SVGAnimatedNumberList;\n    readonly kernelUnitLengthX: SVGAnimatedNumber;\n    readonly kernelUnitLengthY: SVGAnimatedNumber;\n    readonly orderX: SVGAnimatedInteger;\n    readonly orderY: SVGAnimatedInteger;\n    readonly preserveAlpha: SVGAnimatedBoolean;\n    readonly targetX: SVGAnimatedInteger;\n    readonly targetY: SVGAnimatedInteger;\n    readonly SVG_EDGEMODE_DUPLICATE: number;\n    readonly SVG_EDGEMODE_NONE: number;\n    readonly SVG_EDGEMODE_UNKNOWN: number;\n    readonly SVG_EDGEMODE_WRAP: number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEConvolveMatrixElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEConvolveMatrixElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEConvolveMatrixElement: {\n    prototype: SVGFEConvolveMatrixElement;\n    new(): SVGFEConvolveMatrixElement;\n    readonly SVG_EDGEMODE_DUPLICATE: number;\n    readonly SVG_EDGEMODE_NONE: number;\n    readonly SVG_EDGEMODE_UNKNOWN: number;\n    readonly SVG_EDGEMODE_WRAP: number;\n};\n\n/** Corresponds to the <feDiffuseLighting> element. */\ninterface SVGFEDiffuseLightingElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly diffuseConstant: SVGAnimatedNumber;\n    readonly in1: SVGAnimatedString;\n    readonly kernelUnitLengthX: SVGAnimatedNumber;\n    readonly kernelUnitLengthY: SVGAnimatedNumber;\n    readonly surfaceScale: SVGAnimatedNumber;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEDiffuseLightingElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEDiffuseLightingElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEDiffuseLightingElement: {\n    prototype: SVGFEDiffuseLightingElement;\n    new(): SVGFEDiffuseLightingElement;\n};\n\n/** Corresponds to the <feDisplacementMap> element. */\ninterface SVGFEDisplacementMapElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly in1: SVGAnimatedString;\n    readonly in2: SVGAnimatedString;\n    readonly scale: SVGAnimatedNumber;\n    readonly xChannelSelector: SVGAnimatedEnumeration;\n    readonly yChannelSelector: SVGAnimatedEnumeration;\n    readonly SVG_CHANNEL_A: number;\n    readonly SVG_CHANNEL_B: number;\n    readonly SVG_CHANNEL_G: number;\n    readonly SVG_CHANNEL_R: number;\n    readonly SVG_CHANNEL_UNKNOWN: number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEDisplacementMapElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEDisplacementMapElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEDisplacementMapElement: {\n    prototype: SVGFEDisplacementMapElement;\n    new(): SVGFEDisplacementMapElement;\n    readonly SVG_CHANNEL_A: number;\n    readonly SVG_CHANNEL_B: number;\n    readonly SVG_CHANNEL_G: number;\n    readonly SVG_CHANNEL_R: number;\n    readonly SVG_CHANNEL_UNKNOWN: number;\n};\n\n/** Corresponds to the <feDistantLight> element. */\ninterface SVGFEDistantLightElement extends SVGElement {\n    readonly azimuth: SVGAnimatedNumber;\n    readonly elevation: SVGAnimatedNumber;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEDistantLightElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEDistantLightElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEDistantLightElement: {\n    prototype: SVGFEDistantLightElement;\n    new(): SVGFEDistantLightElement;\n};\n\ninterface SVGFEDropShadowElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly dx: SVGAnimatedNumber;\n    readonly dy: SVGAnimatedNumber;\n    readonly in1: SVGAnimatedString;\n    readonly stdDeviationX: SVGAnimatedNumber;\n    readonly stdDeviationY: SVGAnimatedNumber;\n    setStdDeviation(stdDeviationX: number, stdDeviationY: number): void;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEDropShadowElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEDropShadowElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEDropShadowElement: {\n    prototype: SVGFEDropShadowElement;\n    new(): SVGFEDropShadowElement;\n};\n\n/** Corresponds to the <feFlood> element. */\ninterface SVGFEFloodElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEFloodElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEFloodElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEFloodElement: {\n    prototype: SVGFEFloodElement;\n    new(): SVGFEFloodElement;\n};\n\n/** Corresponds to the <feFuncA> element. */\ninterface SVGFEFuncAElement extends SVGComponentTransferFunctionElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEFuncAElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEFuncAElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEFuncAElement: {\n    prototype: SVGFEFuncAElement;\n    new(): SVGFEFuncAElement;\n};\n\n/** Corresponds to the <feFuncB> element. */\ninterface SVGFEFuncBElement extends SVGComponentTransferFunctionElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEFuncBElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEFuncBElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEFuncBElement: {\n    prototype: SVGFEFuncBElement;\n    new(): SVGFEFuncBElement;\n};\n\n/** Corresponds to the <feFuncG> element. */\ninterface SVGFEFuncGElement extends SVGComponentTransferFunctionElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEFuncGElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEFuncGElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEFuncGElement: {\n    prototype: SVGFEFuncGElement;\n    new(): SVGFEFuncGElement;\n};\n\n/** Corresponds to the <feFuncR> element. */\ninterface SVGFEFuncRElement extends SVGComponentTransferFunctionElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEFuncRElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEFuncRElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEFuncRElement: {\n    prototype: SVGFEFuncRElement;\n    new(): SVGFEFuncRElement;\n};\n\n/** Corresponds to the <feGaussianBlur> element. */\ninterface SVGFEGaussianBlurElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly in1: SVGAnimatedString;\n    readonly stdDeviationX: SVGAnimatedNumber;\n    readonly stdDeviationY: SVGAnimatedNumber;\n    setStdDeviation(stdDeviationX: number, stdDeviationY: number): void;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEGaussianBlurElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEGaussianBlurElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEGaussianBlurElement: {\n    prototype: SVGFEGaussianBlurElement;\n    new(): SVGFEGaussianBlurElement;\n};\n\n/** Corresponds to the <feImage> element. */\ninterface SVGFEImageElement extends SVGElement, SVGFilterPrimitiveStandardAttributes, SVGURIReference {\n    readonly preserveAspectRatio: SVGAnimatedPreserveAspectRatio;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEImageElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEImageElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEImageElement: {\n    prototype: SVGFEImageElement;\n    new(): SVGFEImageElement;\n};\n\n/** Corresponds to the <feMerge> element. */\ninterface SVGFEMergeElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEMergeElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEMergeElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEMergeElement: {\n    prototype: SVGFEMergeElement;\n    new(): SVGFEMergeElement;\n};\n\n/** Corresponds to the <feMergeNode> element. */\ninterface SVGFEMergeNodeElement extends SVGElement {\n    readonly in1: SVGAnimatedString;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEMergeNodeElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEMergeNodeElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEMergeNodeElement: {\n    prototype: SVGFEMergeNodeElement;\n    new(): SVGFEMergeNodeElement;\n};\n\n/** Corresponds to the <feMorphology> element. */\ninterface SVGFEMorphologyElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly in1: SVGAnimatedString;\n    readonly operator: SVGAnimatedEnumeration;\n    readonly radiusX: SVGAnimatedNumber;\n    readonly radiusY: SVGAnimatedNumber;\n    readonly SVG_MORPHOLOGY_OPERATOR_DILATE: number;\n    readonly SVG_MORPHOLOGY_OPERATOR_ERODE: number;\n    readonly SVG_MORPHOLOGY_OPERATOR_UNKNOWN: number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEMorphologyElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEMorphologyElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEMorphologyElement: {\n    prototype: SVGFEMorphologyElement;\n    new(): SVGFEMorphologyElement;\n    readonly SVG_MORPHOLOGY_OPERATOR_DILATE: number;\n    readonly SVG_MORPHOLOGY_OPERATOR_ERODE: number;\n    readonly SVG_MORPHOLOGY_OPERATOR_UNKNOWN: number;\n};\n\n/** Corresponds to the <feOffset> element. */\ninterface SVGFEOffsetElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly dx: SVGAnimatedNumber;\n    readonly dy: SVGAnimatedNumber;\n    readonly in1: SVGAnimatedString;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEOffsetElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEOffsetElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEOffsetElement: {\n    prototype: SVGFEOffsetElement;\n    new(): SVGFEOffsetElement;\n};\n\n/** Corresponds to the <fePointLight> element. */\ninterface SVGFEPointLightElement extends SVGElement {\n    readonly x: SVGAnimatedNumber;\n    readonly y: SVGAnimatedNumber;\n    readonly z: SVGAnimatedNumber;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEPointLightElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFEPointLightElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFEPointLightElement: {\n    prototype: SVGFEPointLightElement;\n    new(): SVGFEPointLightElement;\n};\n\n/** Corresponds to the <feSpecularLighting> element. */\ninterface SVGFESpecularLightingElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly in1: SVGAnimatedString;\n    readonly kernelUnitLengthX: SVGAnimatedNumber;\n    readonly kernelUnitLengthY: SVGAnimatedNumber;\n    readonly specularConstant: SVGAnimatedNumber;\n    readonly specularExponent: SVGAnimatedNumber;\n    readonly surfaceScale: SVGAnimatedNumber;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFESpecularLightingElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFESpecularLightingElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFESpecularLightingElement: {\n    prototype: SVGFESpecularLightingElement;\n    new(): SVGFESpecularLightingElement;\n};\n\n/** Corresponds to the <feSpotLight> element. */\ninterface SVGFESpotLightElement extends SVGElement {\n    readonly limitingConeAngle: SVGAnimatedNumber;\n    readonly pointsAtX: SVGAnimatedNumber;\n    readonly pointsAtY: SVGAnimatedNumber;\n    readonly pointsAtZ: SVGAnimatedNumber;\n    readonly specularExponent: SVGAnimatedNumber;\n    readonly x: SVGAnimatedNumber;\n    readonly y: SVGAnimatedNumber;\n    readonly z: SVGAnimatedNumber;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFESpotLightElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFESpotLightElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFESpotLightElement: {\n    prototype: SVGFESpotLightElement;\n    new(): SVGFESpotLightElement;\n};\n\n/** Corresponds to the <feTile> element. */\ninterface SVGFETileElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly in1: SVGAnimatedString;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFETileElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFETileElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFETileElement: {\n    prototype: SVGFETileElement;\n    new(): SVGFETileElement;\n};\n\n/** Corresponds to the <feTurbulence> element. */\ninterface SVGFETurbulenceElement extends SVGElement, SVGFilterPrimitiveStandardAttributes {\n    readonly baseFrequencyX: SVGAnimatedNumber;\n    readonly baseFrequencyY: SVGAnimatedNumber;\n    readonly numOctaves: SVGAnimatedInteger;\n    readonly seed: SVGAnimatedNumber;\n    readonly stitchTiles: SVGAnimatedEnumeration;\n    readonly type: SVGAnimatedEnumeration;\n    readonly SVG_STITCHTYPE_NOSTITCH: number;\n    readonly SVG_STITCHTYPE_STITCH: number;\n    readonly SVG_STITCHTYPE_UNKNOWN: number;\n    readonly SVG_TURBULENCE_TYPE_FRACTALNOISE: number;\n    readonly SVG_TURBULENCE_TYPE_TURBULENCE: number;\n    readonly SVG_TURBULENCE_TYPE_UNKNOWN: number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFETurbulenceElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFETurbulenceElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFETurbulenceElement: {\n    prototype: SVGFETurbulenceElement;\n    new(): SVGFETurbulenceElement;\n    readonly SVG_STITCHTYPE_NOSTITCH: number;\n    readonly SVG_STITCHTYPE_STITCH: number;\n    readonly SVG_STITCHTYPE_UNKNOWN: number;\n    readonly SVG_TURBULENCE_TYPE_FRACTALNOISE: number;\n    readonly SVG_TURBULENCE_TYPE_TURBULENCE: number;\n    readonly SVG_TURBULENCE_TYPE_UNKNOWN: number;\n};\n\n/** Provides access to the properties of <filter> elements, as well as methods to manipulate them. */\ninterface SVGFilterElement extends SVGElement, SVGURIReference {\n    /** @deprecated */\n    readonly filterResX: SVGAnimatedInteger;\n    /** @deprecated */\n    readonly filterResY: SVGAnimatedInteger;\n    readonly filterUnits: SVGAnimatedEnumeration;\n    readonly height: SVGAnimatedLength;\n    readonly primitiveUnits: SVGAnimatedEnumeration;\n    readonly width: SVGAnimatedLength;\n    readonly x: SVGAnimatedLength;\n    readonly y: SVGAnimatedLength;\n    /** @deprecated */\n    setFilterRes(filterResX: number, filterResY: number): void;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFilterElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGFilterElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGFilterElement: {\n    prototype: SVGFilterElement;\n    new(): SVGFilterElement;\n};\n\ninterface SVGFilterPrimitiveStandardAttributes {\n    readonly height: SVGAnimatedLength;\n    readonly result: SVGAnimatedString;\n    readonly width: SVGAnimatedLength;\n    readonly x: SVGAnimatedLength;\n    readonly y: SVGAnimatedLength;\n}\n\ninterface SVGFitToViewBox {\n    readonly preserveAspectRatio: SVGAnimatedPreserveAspectRatio;\n    readonly viewBox: SVGAnimatedRect;\n}\n\n/** Provides access to the properties of <foreignObject> elements, as well as methods to manipulate them. */\ninterface SVGForeignObjectElement extends SVGGraphicsElement {\n    readonly height: SVGAnimatedLength;\n    readonly width: SVGAnimatedLength;\n    readonly x: SVGAnimatedLength;\n    readonly y: SVGAnimatedLength;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGForeignObjectElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGForeignObjectElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGForeignObjectElement: {\n    prototype: SVGForeignObjectElement;\n    new(): SVGForeignObjectElement;\n};\n\n/** Corresponds to the <g> element. */\ninterface SVGGElement extends SVGGraphicsElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGGElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGGElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGGElement: {\n    prototype: SVGGElement;\n    new(): SVGGElement;\n};\n\ninterface SVGGeometryElement extends SVGGraphicsElement {\n    readonly pathLength: SVGAnimatedNumber;\n    getPointAtLength(distance: number): DOMPoint;\n    getTotalLength(): number;\n    isPointInFill(point?: DOMPointInit): boolean;\n    isPointInStroke(point?: DOMPointInit): boolean;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGGeometryElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGGeometryElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGGeometryElement: {\n    prototype: SVGGeometryElement;\n    new(): SVGGeometryElement;\n};\n\n/** The SVGGradient interface is a base interface used by SVGLinearGradientElement and SVGRadialGradientElement. */\ninterface SVGGradientElement extends SVGElement, SVGURIReference {\n    readonly gradientTransform: SVGAnimatedTransformList;\n    readonly gradientUnits: SVGAnimatedEnumeration;\n    readonly spreadMethod: SVGAnimatedEnumeration;\n    readonly SVG_SPREADMETHOD_PAD: number;\n    readonly SVG_SPREADMETHOD_REFLECT: number;\n    readonly SVG_SPREADMETHOD_REPEAT: number;\n    readonly SVG_SPREADMETHOD_UNKNOWN: number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGGradientElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGGradientElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGGradientElement: {\n    prototype: SVGGradientElement;\n    new(): SVGGradientElement;\n    readonly SVG_SPREADMETHOD_PAD: number;\n    readonly SVG_SPREADMETHOD_REFLECT: number;\n    readonly SVG_SPREADMETHOD_REPEAT: number;\n    readonly SVG_SPREADMETHOD_UNKNOWN: number;\n};\n\n/** SVG elements whose primary purpose is to directly render graphics into a group. */\ninterface SVGGraphicsElement extends SVGElement, SVGTests {\n    readonly transform: SVGAnimatedTransformList;\n    getBBox(options?: SVGBoundingBoxOptions): DOMRect;\n    getCTM(): DOMMatrix | null;\n    getScreenCTM(): DOMMatrix | null;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGGraphicsElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGGraphicsElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGGraphicsElement: {\n    prototype: SVGGraphicsElement;\n    new(): SVGGraphicsElement;\n};\n\n/** Corresponds to the <image> element. */\ninterface SVGImageElement extends SVGGraphicsElement, SVGURIReference {\n    readonly height: SVGAnimatedLength;\n    readonly preserveAspectRatio: SVGAnimatedPreserveAspectRatio;\n    readonly width: SVGAnimatedLength;\n    readonly x: SVGAnimatedLength;\n    readonly y: SVGAnimatedLength;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGImageElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGImageElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGImageElement: {\n    prototype: SVGImageElement;\n    new(): SVGImageElement;\n};\n\n/** Correspond to the <length> basic data type. */\ninterface SVGLength {\n    readonly unitType: number;\n    value: number;\n    valueAsString: string;\n    valueInSpecifiedUnits: number;\n    convertToSpecifiedUnits(unitType: number): void;\n    newValueSpecifiedUnits(unitType: number, valueInSpecifiedUnits: number): void;\n    readonly SVG_LENGTHTYPE_CM: number;\n    readonly SVG_LENGTHTYPE_EMS: number;\n    readonly SVG_LENGTHTYPE_EXS: number;\n    readonly SVG_LENGTHTYPE_IN: number;\n    readonly SVG_LENGTHTYPE_MM: number;\n    readonly SVG_LENGTHTYPE_NUMBER: number;\n    readonly SVG_LENGTHTYPE_PC: number;\n    readonly SVG_LENGTHTYPE_PERCENTAGE: number;\n    readonly SVG_LENGTHTYPE_PT: number;\n    readonly SVG_LENGTHTYPE_PX: number;\n    readonly SVG_LENGTHTYPE_UNKNOWN: number;\n}\n\ndeclare var SVGLength: {\n    prototype: SVGLength;\n    new(): SVGLength;\n    readonly SVG_LENGTHTYPE_CM: number;\n    readonly SVG_LENGTHTYPE_EMS: number;\n    readonly SVG_LENGTHTYPE_EXS: number;\n    readonly SVG_LENGTHTYPE_IN: number;\n    readonly SVG_LENGTHTYPE_MM: number;\n    readonly SVG_LENGTHTYPE_NUMBER: number;\n    readonly SVG_LENGTHTYPE_PC: number;\n    readonly SVG_LENGTHTYPE_PERCENTAGE: number;\n    readonly SVG_LENGTHTYPE_PT: number;\n    readonly SVG_LENGTHTYPE_PX: number;\n    readonly SVG_LENGTHTYPE_UNKNOWN: number;\n};\n\n/** The SVGLengthList defines a list of SVGLength objects. */\ninterface SVGLengthList {\n    readonly length: number;\n    readonly numberOfItems: number;\n    appendItem(newItem: SVGLength): SVGLength;\n    clear(): void;\n    getItem(index: number): SVGLength;\n    initialize(newItem: SVGLength): SVGLength;\n    insertItemBefore(newItem: SVGLength, index: number): SVGLength;\n    removeItem(index: number): SVGLength;\n    replaceItem(newItem: SVGLength, index: number): SVGLength;\n    [index: number]: SVGLength;\n}\n\ndeclare var SVGLengthList: {\n    prototype: SVGLengthList;\n    new(): SVGLengthList;\n};\n\n/** Provides access to the properties of <line> elements, as well as methods to manipulate them. */\ninterface SVGLineElement extends SVGGeometryElement {\n    readonly x1: SVGAnimatedLength;\n    readonly x2: SVGAnimatedLength;\n    readonly y1: SVGAnimatedLength;\n    readonly y2: SVGAnimatedLength;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGLineElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGLineElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGLineElement: {\n    prototype: SVGLineElement;\n    new(): SVGLineElement;\n};\n\n/** Corresponds to the <linearGradient> element. */\ninterface SVGLinearGradientElement extends SVGGradientElement {\n    readonly x1: SVGAnimatedLength;\n    readonly x2: SVGAnimatedLength;\n    readonly y1: SVGAnimatedLength;\n    readonly y2: SVGAnimatedLength;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGLinearGradientElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGLinearGradientElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGLinearGradientElement: {\n    prototype: SVGLinearGradientElement;\n    new(): SVGLinearGradientElement;\n};\n\ninterface SVGMarkerElement extends SVGElement, SVGFitToViewBox {\n    readonly markerHeight: SVGAnimatedLength;\n    readonly markerUnits: SVGAnimatedEnumeration;\n    readonly markerWidth: SVGAnimatedLength;\n    readonly orientAngle: SVGAnimatedAngle;\n    readonly orientType: SVGAnimatedEnumeration;\n    readonly refX: SVGAnimatedLength;\n    readonly refY: SVGAnimatedLength;\n    setOrientToAngle(angle: SVGAngle): void;\n    setOrientToAuto(): void;\n    readonly SVG_MARKERUNITS_STROKEWIDTH: number;\n    readonly SVG_MARKERUNITS_UNKNOWN: number;\n    readonly SVG_MARKERUNITS_USERSPACEONUSE: number;\n    readonly SVG_MARKER_ORIENT_ANGLE: number;\n    readonly SVG_MARKER_ORIENT_AUTO: number;\n    readonly SVG_MARKER_ORIENT_UNKNOWN: number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGMarkerElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGMarkerElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGMarkerElement: {\n    prototype: SVGMarkerElement;\n    new(): SVGMarkerElement;\n    readonly SVG_MARKERUNITS_STROKEWIDTH: number;\n    readonly SVG_MARKERUNITS_UNKNOWN: number;\n    readonly SVG_MARKERUNITS_USERSPACEONUSE: number;\n    readonly SVG_MARKER_ORIENT_ANGLE: number;\n    readonly SVG_MARKER_ORIENT_AUTO: number;\n    readonly SVG_MARKER_ORIENT_UNKNOWN: number;\n};\n\n/** Provides access to the properties of <mask> elements, as well as methods to manipulate them. */\ninterface SVGMaskElement extends SVGElement, SVGTests {\n    readonly height: SVGAnimatedLength;\n    readonly maskContentUnits: SVGAnimatedEnumeration;\n    readonly maskUnits: SVGAnimatedEnumeration;\n    readonly width: SVGAnimatedLength;\n    readonly x: SVGAnimatedLength;\n    readonly y: SVGAnimatedLength;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGMaskElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGMaskElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGMaskElement: {\n    prototype: SVGMaskElement;\n    new(): SVGMaskElement;\n};\n\n/** Corresponds to the <metadata> element. */\ninterface SVGMetadataElement extends SVGElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGMetadataElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGMetadataElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGMetadataElement: {\n    prototype: SVGMetadataElement;\n    new(): SVGMetadataElement;\n};\n\n/** Corresponds to the <number> basic data type. */\ninterface SVGNumber {\n    value: number;\n}\n\ndeclare var SVGNumber: {\n    prototype: SVGNumber;\n    new(): SVGNumber;\n};\n\n/** The SVGNumberList defines a list of SVGNumber objects. */\ninterface SVGNumberList {\n    readonly length: number;\n    readonly numberOfItems: number;\n    appendItem(newItem: SVGNumber): SVGNumber;\n    clear(): void;\n    getItem(index: number): SVGNumber;\n    initialize(newItem: SVGNumber): SVGNumber;\n    insertItemBefore(newItem: SVGNumber, index: number): SVGNumber;\n    removeItem(index: number): SVGNumber;\n    replaceItem(newItem: SVGNumber, index: number): SVGNumber;\n    [index: number]: SVGNumber;\n}\n\ndeclare var SVGNumberList: {\n    prototype: SVGNumberList;\n    new(): SVGNumberList;\n};\n\n/** Corresponds to the <path> element. */\ninterface SVGPathElement extends SVGGraphicsElement {\n    /** @deprecated */\n    readonly pathSegList: SVGPathSegList;\n    /** @deprecated */\n    createSVGPathSegArcAbs(x: number, y: number, r1: number, r2: number, angle: number, largeArcFlag: boolean, sweepFlag: boolean): SVGPathSegArcAbs;\n    /** @deprecated */\n    createSVGPathSegArcRel(x: number, y: number, r1: number, r2: number, angle: number, largeArcFlag: boolean, sweepFlag: boolean): SVGPathSegArcRel;\n    /** @deprecated */\n    createSVGPathSegClosePath(): SVGPathSegClosePath;\n    /** @deprecated */\n    createSVGPathSegCurvetoCubicAbs(x: number, y: number, x1: number, y1: number, x2: number, y2: number): SVGPathSegCurvetoCubicAbs;\n    /** @deprecated */\n    createSVGPathSegCurvetoCubicRel(x: number, y: number, x1: number, y1: number, x2: number, y2: number): SVGPathSegCurvetoCubicRel;\n    /** @deprecated */\n    createSVGPathSegCurvetoCubicSmoothAbs(x: number, y: number, x2: number, y2: number): SVGPathSegCurvetoCubicSmoothAbs;\n    /** @deprecated */\n    createSVGPathSegCurvetoCubicSmoothRel(x: number, y: number, x2: number, y2: number): SVGPathSegCurvetoCubicSmoothRel;\n    /** @deprecated */\n    createSVGPathSegCurvetoQuadraticAbs(x: number, y: number, x1: number, y1: number): SVGPathSegCurvetoQuadraticAbs;\n    /** @deprecated */\n    createSVGPathSegCurvetoQuadraticRel(x: number, y: number, x1: number, y1: number): SVGPathSegCurvetoQuadraticRel;\n    /** @deprecated */\n    createSVGPathSegCurvetoQuadraticSmoothAbs(x: number, y: number): SVGPathSegCurvetoQuadraticSmoothAbs;\n    /** @deprecated */\n    createSVGPathSegCurvetoQuadraticSmoothRel(x: number, y: number): SVGPathSegCurvetoQuadraticSmoothRel;\n    /** @deprecated */\n    createSVGPathSegLinetoAbs(x: number, y: number): SVGPathSegLinetoAbs;\n    /** @deprecated */\n    createSVGPathSegLinetoHorizontalAbs(x: number): SVGPathSegLinetoHorizontalAbs;\n    /** @deprecated */\n    createSVGPathSegLinetoHorizontalRel(x: number): SVGPathSegLinetoHorizontalRel;\n    /** @deprecated */\n    createSVGPathSegLinetoRel(x: number, y: number): SVGPathSegLinetoRel;\n    /** @deprecated */\n    createSVGPathSegLinetoVerticalAbs(y: number): SVGPathSegLinetoVerticalAbs;\n    /** @deprecated */\n    createSVGPathSegLinetoVerticalRel(y: number): SVGPathSegLinetoVerticalRel;\n    /** @deprecated */\n    createSVGPathSegMovetoAbs(x: number, y: number): SVGPathSegMovetoAbs;\n    /** @deprecated */\n    createSVGPathSegMovetoRel(x: number, y: number): SVGPathSegMovetoRel;\n    /** @deprecated */\n    getPathSegAtLength(distance: number): number;\n    getPointAtLength(distance: number): SVGPoint;\n    getTotalLength(): number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGPathElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGPathElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGPathElement: {\n    prototype: SVGPathElement;\n    new(): SVGPathElement;\n};\n\ninterface SVGPathSeg {\n    readonly pathSegType: number;\n    readonly pathSegTypeAsLetter: string;\n    readonly PATHSEG_ARC_ABS: number;\n    readonly PATHSEG_ARC_REL: number;\n    readonly PATHSEG_CLOSEPATH: number;\n    readonly PATHSEG_CURVETO_CUBIC_ABS: number;\n    readonly PATHSEG_CURVETO_CUBIC_REL: number;\n    readonly PATHSEG_CURVETO_CUBIC_SMOOTH_ABS: number;\n    readonly PATHSEG_CURVETO_CUBIC_SMOOTH_REL: number;\n    readonly PATHSEG_CURVETO_QUADRATIC_ABS: number;\n    readonly PATHSEG_CURVETO_QUADRATIC_REL: number;\n    readonly PATHSEG_CURVETO_QUADRATIC_SMOOTH_ABS: number;\n    readonly PATHSEG_CURVETO_QUADRATIC_SMOOTH_REL: number;\n    readonly PATHSEG_LINETO_ABS: number;\n    readonly PATHSEG_LINETO_HORIZONTAL_ABS: number;\n    readonly PATHSEG_LINETO_HORIZONTAL_REL: number;\n    readonly PATHSEG_LINETO_REL: number;\n    readonly PATHSEG_LINETO_VERTICAL_ABS: number;\n    readonly PATHSEG_LINETO_VERTICAL_REL: number;\n    readonly PATHSEG_MOVETO_ABS: number;\n    readonly PATHSEG_MOVETO_REL: number;\n    readonly PATHSEG_UNKNOWN: number;\n}\n\ndeclare var SVGPathSeg: {\n    prototype: SVGPathSeg;\n    new(): SVGPathSeg;\n    readonly PATHSEG_ARC_ABS: number;\n    readonly PATHSEG_ARC_REL: number;\n    readonly PATHSEG_CLOSEPATH: number;\n    readonly PATHSEG_CURVETO_CUBIC_ABS: number;\n    readonly PATHSEG_CURVETO_CUBIC_REL: number;\n    readonly PATHSEG_CURVETO_CUBIC_SMOOTH_ABS: number;\n    readonly PATHSEG_CURVETO_CUBIC_SMOOTH_REL: number;\n    readonly PATHSEG_CURVETO_QUADRATIC_ABS: number;\n    readonly PATHSEG_CURVETO_QUADRATIC_REL: number;\n    readonly PATHSEG_CURVETO_QUADRATIC_SMOOTH_ABS: number;\n    readonly PATHSEG_CURVETO_QUADRATIC_SMOOTH_REL: number;\n    readonly PATHSEG_LINETO_ABS: number;\n    readonly PATHSEG_LINETO_HORIZONTAL_ABS: number;\n    readonly PATHSEG_LINETO_HORIZONTAL_REL: number;\n    readonly PATHSEG_LINETO_REL: number;\n    readonly PATHSEG_LINETO_VERTICAL_ABS: number;\n    readonly PATHSEG_LINETO_VERTICAL_REL: number;\n    readonly PATHSEG_MOVETO_ABS: number;\n    readonly PATHSEG_MOVETO_REL: number;\n    readonly PATHSEG_UNKNOWN: number;\n};\n\ninterface SVGPathSegArcAbs extends SVGPathSeg {\n    angle: number;\n    largeArcFlag: boolean;\n    r1: number;\n    r2: number;\n    sweepFlag: boolean;\n    x: number;\n    y: number;\n}\n\ndeclare var SVGPathSegArcAbs: {\n    prototype: SVGPathSegArcAbs;\n    new(): SVGPathSegArcAbs;\n};\n\ninterface SVGPathSegArcRel extends SVGPathSeg {\n    angle: number;\n    largeArcFlag: boolean;\n    r1: number;\n    r2: number;\n    sweepFlag: boolean;\n    x: number;\n    y: number;\n}\n\ndeclare var SVGPathSegArcRel: {\n    prototype: SVGPathSegArcRel;\n    new(): SVGPathSegArcRel;\n};\n\ninterface SVGPathSegClosePath extends SVGPathSeg {\n}\n\ndeclare var SVGPathSegClosePath: {\n    prototype: SVGPathSegClosePath;\n    new(): SVGPathSegClosePath;\n};\n\ninterface SVGPathSegCurvetoCubicAbs extends SVGPathSeg {\n    x: number;\n    x1: number;\n    x2: number;\n    y: number;\n    y1: number;\n    y2: number;\n}\n\ndeclare var SVGPathSegCurvetoCubicAbs: {\n    prototype: SVGPathSegCurvetoCubicAbs;\n    new(): SVGPathSegCurvetoCubicAbs;\n};\n\ninterface SVGPathSegCurvetoCubicRel extends SVGPathSeg {\n    x: number;\n    x1: number;\n    x2: number;\n    y: number;\n    y1: number;\n    y2: number;\n}\n\ndeclare var SVGPathSegCurvetoCubicRel: {\n    prototype: SVGPathSegCurvetoCubicRel;\n    new(): SVGPathSegCurvetoCubicRel;\n};\n\ninterface SVGPathSegCurvetoCubicSmoothAbs extends SVGPathSeg {\n    x: number;\n    x2: number;\n    y: number;\n    y2: number;\n}\n\ndeclare var SVGPathSegCurvetoCubicSmoothAbs: {\n    prototype: SVGPathSegCurvetoCubicSmoothAbs;\n    new(): SVGPathSegCurvetoCubicSmoothAbs;\n};\n\ninterface SVGPathSegCurvetoCubicSmoothRel extends SVGPathSeg {\n    x: number;\n    x2: number;\n    y: number;\n    y2: number;\n}\n\ndeclare var SVGPathSegCurvetoCubicSmoothRel: {\n    prototype: SVGPathSegCurvetoCubicSmoothRel;\n    new(): SVGPathSegCurvetoCubicSmoothRel;\n};\n\ninterface SVGPathSegCurvetoQuadraticAbs extends SVGPathSeg {\n    x: number;\n    x1: number;\n    y: number;\n    y1: number;\n}\n\ndeclare var SVGPathSegCurvetoQuadraticAbs: {\n    prototype: SVGPathSegCurvetoQuadraticAbs;\n    new(): SVGPathSegCurvetoQuadraticAbs;\n};\n\ninterface SVGPathSegCurvetoQuadraticRel extends SVGPathSeg {\n    x: number;\n    x1: number;\n    y: number;\n    y1: number;\n}\n\ndeclare var SVGPathSegCurvetoQuadraticRel: {\n    prototype: SVGPathSegCurvetoQuadraticRel;\n    new(): SVGPathSegCurvetoQuadraticRel;\n};\n\ninterface SVGPathSegCurvetoQuadraticSmoothAbs extends SVGPathSeg {\n    x: number;\n    y: number;\n}\n\ndeclare var SVGPathSegCurvetoQuadraticSmoothAbs: {\n    prototype: SVGPathSegCurvetoQuadraticSmoothAbs;\n    new(): SVGPathSegCurvetoQuadraticSmoothAbs;\n};\n\ninterface SVGPathSegCurvetoQuadraticSmoothRel extends SVGPathSeg {\n    x: number;\n    y: number;\n}\n\ndeclare var SVGPathSegCurvetoQuadraticSmoothRel: {\n    prototype: SVGPathSegCurvetoQuadraticSmoothRel;\n    new(): SVGPathSegCurvetoQuadraticSmoothRel;\n};\n\ninterface SVGPathSegLinetoAbs extends SVGPathSeg {\n    x: number;\n    y: number;\n}\n\ndeclare var SVGPathSegLinetoAbs: {\n    prototype: SVGPathSegLinetoAbs;\n    new(): SVGPathSegLinetoAbs;\n};\n\ninterface SVGPathSegLinetoHorizontalAbs extends SVGPathSeg {\n    x: number;\n}\n\ndeclare var SVGPathSegLinetoHorizontalAbs: {\n    prototype: SVGPathSegLinetoHorizontalAbs;\n    new(): SVGPathSegLinetoHorizontalAbs;\n};\n\ninterface SVGPathSegLinetoHorizontalRel extends SVGPathSeg {\n    x: number;\n}\n\ndeclare var SVGPathSegLinetoHorizontalRel: {\n    prototype: SVGPathSegLinetoHorizontalRel;\n    new(): SVGPathSegLinetoHorizontalRel;\n};\n\ninterface SVGPathSegLinetoRel extends SVGPathSeg {\n    x: number;\n    y: number;\n}\n\ndeclare var SVGPathSegLinetoRel: {\n    prototype: SVGPathSegLinetoRel;\n    new(): SVGPathSegLinetoRel;\n};\n\ninterface SVGPathSegLinetoVerticalAbs extends SVGPathSeg {\n    y: number;\n}\n\ndeclare var SVGPathSegLinetoVerticalAbs: {\n    prototype: SVGPathSegLinetoVerticalAbs;\n    new(): SVGPathSegLinetoVerticalAbs;\n};\n\ninterface SVGPathSegLinetoVerticalRel extends SVGPathSeg {\n    y: number;\n}\n\ndeclare var SVGPathSegLinetoVerticalRel: {\n    prototype: SVGPathSegLinetoVerticalRel;\n    new(): SVGPathSegLinetoVerticalRel;\n};\n\ninterface SVGPathSegList {\n    readonly numberOfItems: number;\n    appendItem(newItem: SVGPathSeg): SVGPathSeg;\n    clear(): void;\n    getItem(index: number): SVGPathSeg;\n    initialize(newItem: SVGPathSeg): SVGPathSeg;\n    insertItemBefore(newItem: SVGPathSeg, index: number): SVGPathSeg;\n    removeItem(index: number): SVGPathSeg;\n    replaceItem(newItem: SVGPathSeg, index: number): SVGPathSeg;\n}\n\ndeclare var SVGPathSegList: {\n    prototype: SVGPathSegList;\n    new(): SVGPathSegList;\n};\n\ninterface SVGPathSegMovetoAbs extends SVGPathSeg {\n    x: number;\n    y: number;\n}\n\ndeclare var SVGPathSegMovetoAbs: {\n    prototype: SVGPathSegMovetoAbs;\n    new(): SVGPathSegMovetoAbs;\n};\n\ninterface SVGPathSegMovetoRel extends SVGPathSeg {\n    x: number;\n    y: number;\n}\n\ndeclare var SVGPathSegMovetoRel: {\n    prototype: SVGPathSegMovetoRel;\n    new(): SVGPathSegMovetoRel;\n};\n\n/** Corresponds to the <pattern> element. */\ninterface SVGPatternElement extends SVGElement, SVGTests, SVGFitToViewBox, SVGURIReference {\n    readonly height: SVGAnimatedLength;\n    readonly patternContentUnits: SVGAnimatedEnumeration;\n    readonly patternTransform: SVGAnimatedTransformList;\n    readonly patternUnits: SVGAnimatedEnumeration;\n    readonly width: SVGAnimatedLength;\n    readonly x: SVGAnimatedLength;\n    readonly y: SVGAnimatedLength;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGPatternElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGPatternElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGPatternElement: {\n    prototype: SVGPatternElement;\n    new(): SVGPatternElement;\n};\n\ninterface SVGPointList {\n    readonly length: number;\n    readonly numberOfItems: number;\n    appendItem(newItem: DOMPoint): DOMPoint;\n    clear(): void;\n    getItem(index: number): DOMPoint;\n    initialize(newItem: DOMPoint): DOMPoint;\n    insertItemBefore(newItem: DOMPoint, index: number): DOMPoint;\n    removeItem(index: number): DOMPoint;\n    replaceItem(newItem: DOMPoint, index: number): DOMPoint;\n    [index: number]: DOMPoint;\n}\n\ndeclare var SVGPointList: {\n    prototype: SVGPointList;\n    new(): SVGPointList;\n};\n\n/** Provides access to the properties of <polygon> elements, as well as methods to manipulate them. */\ninterface SVGPolygonElement extends SVGGeometryElement, SVGAnimatedPoints {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGPolygonElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGPolygonElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGPolygonElement: {\n    prototype: SVGPolygonElement;\n    new(): SVGPolygonElement;\n};\n\n/** Provides access to the properties of <polyline> elements, as well as methods to manipulate them. */\ninterface SVGPolylineElement extends SVGGeometryElement, SVGAnimatedPoints {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGPolylineElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGPolylineElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGPolylineElement: {\n    prototype: SVGPolylineElement;\n    new(): SVGPolylineElement;\n};\n\n/** Corresponds to the preserveAspectRatio attribute, which is available for some of SVG\'s elements. */\ninterface SVGPreserveAspectRatio {\n    align: number;\n    meetOrSlice: number;\n    readonly SVG_MEETORSLICE_MEET: number;\n    readonly SVG_MEETORSLICE_SLICE: number;\n    readonly SVG_MEETORSLICE_UNKNOWN: number;\n    readonly SVG_PRESERVEASPECTRATIO_NONE: number;\n    readonly SVG_PRESERVEASPECTRATIO_UNKNOWN: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMAXYMAX: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMAXYMID: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMAXYMIN: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMIDYMAX: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMIDYMID: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMIDYMIN: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMINYMAX: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMINYMID: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMINYMIN: number;\n}\n\ndeclare var SVGPreserveAspectRatio: {\n    prototype: SVGPreserveAspectRatio;\n    new(): SVGPreserveAspectRatio;\n    readonly SVG_MEETORSLICE_MEET: number;\n    readonly SVG_MEETORSLICE_SLICE: number;\n    readonly SVG_MEETORSLICE_UNKNOWN: number;\n    readonly SVG_PRESERVEASPECTRATIO_NONE: number;\n    readonly SVG_PRESERVEASPECTRATIO_UNKNOWN: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMAXYMAX: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMAXYMID: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMAXYMIN: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMIDYMAX: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMIDYMID: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMIDYMIN: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMINYMAX: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMINYMID: number;\n    readonly SVG_PRESERVEASPECTRATIO_XMINYMIN: number;\n};\n\n/** Corresponds to the <RadialGradient> element. */\ninterface SVGRadialGradientElement extends SVGGradientElement {\n    readonly cx: SVGAnimatedLength;\n    readonly cy: SVGAnimatedLength;\n    readonly fx: SVGAnimatedLength;\n    readonly fy: SVGAnimatedLength;\n    readonly r: SVGAnimatedLength;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGRadialGradientElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGRadialGradientElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGRadialGradientElement: {\n    prototype: SVGRadialGradientElement;\n    new(): SVGRadialGradientElement;\n};\n\n/** Provides access to the properties of <rect> elements, as well as methods to manipulate them. */\ninterface SVGRectElement extends SVGGeometryElement {\n    readonly height: SVGAnimatedLength;\n    readonly rx: SVGAnimatedLength;\n    readonly ry: SVGAnimatedLength;\n    readonly width: SVGAnimatedLength;\n    readonly x: SVGAnimatedLength;\n    readonly y: SVGAnimatedLength;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGRectElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGRectElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGRectElement: {\n    prototype: SVGRectElement;\n    new(): SVGRectElement;\n};\n\ninterface SVGSVGElementEventMap extends SVGElementEventMap {\n    "SVGUnload": Event;\n    "SVGZoom": SVGZoomEvent;\n}\n\n/** Provides access to the properties of <svg> elements, as well as methods to manipulate them. This interface contains also various miscellaneous commonly-used utility methods, such as matrix operations and the ability to control the time of redraw on visual rendering devices. */\ninterface SVGSVGElement extends SVGGraphicsElement, DocumentEvent, SVGFitToViewBox, SVGZoomAndPan {\n    /** @deprecated */\n    contentScriptType: string;\n    /** @deprecated */\n    contentStyleType: string;\n    currentScale: number;\n    readonly currentTranslate: SVGPoint;\n    readonly height: SVGAnimatedLength;\n    onunload: ((this: SVGSVGElement, ev: Event) => any) | null;\n    onzoom: ((this: SVGSVGElement, ev: SVGZoomEvent) => any) | null;\n    /** @deprecated */\n    readonly pixelUnitToMillimeterX: number;\n    /** @deprecated */\n    readonly pixelUnitToMillimeterY: number;\n    /** @deprecated */\n    readonly screenPixelToMillimeterX: number;\n    /** @deprecated */\n    readonly screenPixelToMillimeterY: number;\n    /** @deprecated */\n    readonly viewport: SVGRect;\n    readonly width: SVGAnimatedLength;\n    readonly x: SVGAnimatedLength;\n    readonly y: SVGAnimatedLength;\n    animationsPaused(): boolean;\n    checkEnclosure(element: SVGElement, rect: SVGRect): boolean;\n    checkIntersection(element: SVGElement, rect: SVGRect): boolean;\n    createSVGAngle(): SVGAngle;\n    createSVGLength(): SVGLength;\n    createSVGMatrix(): SVGMatrix;\n    createSVGNumber(): SVGNumber;\n    createSVGPoint(): SVGPoint;\n    createSVGRect(): SVGRect;\n    createSVGTransform(): SVGTransform;\n    createSVGTransformFromMatrix(matrix: SVGMatrix): SVGTransform;\n    deselectAll(): void;\n    /** @deprecated */\n    forceRedraw(): void;\n    getComputedStyle(elt: Element, pseudoElt?: string | null): CSSStyleDeclaration;\n    getCurrentTime(): number;\n    getElementById(elementId: string): Element;\n    getEnclosureList(rect: SVGRect, referenceElement: SVGElement): NodeListOf<SVGCircleElement | SVGEllipseElement | SVGImageElement | SVGLineElement | SVGPathElement | SVGPolygonElement | SVGPolylineElement | SVGRectElement | SVGTextElement | SVGUseElement>;\n    getIntersectionList(rect: SVGRect, referenceElement: SVGElement): NodeListOf<SVGCircleElement | SVGEllipseElement | SVGImageElement | SVGLineElement | SVGPathElement | SVGPolygonElement | SVGPolylineElement | SVGRectElement | SVGTextElement | SVGUseElement>;\n    pauseAnimations(): void;\n    setCurrentTime(seconds: number): void;\n    /** @deprecated */\n    suspendRedraw(maxWaitMilliseconds: number): number;\n    unpauseAnimations(): void;\n    /** @deprecated */\n    unsuspendRedraw(suspendHandleID: number): void;\n    /** @deprecated */\n    unsuspendRedrawAll(): void;\n    addEventListener<K extends keyof SVGSVGElementEventMap>(type: K, listener: (this: SVGSVGElement, ev: SVGSVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGSVGElementEventMap>(type: K, listener: (this: SVGSVGElement, ev: SVGSVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGSVGElement: {\n    prototype: SVGSVGElement;\n    new(): SVGSVGElement;\n    readonly SVG_ZOOMANDPAN_DISABLE: number;\n    readonly SVG_ZOOMANDPAN_MAGNIFY: number;\n    readonly SVG_ZOOMANDPAN_UNKNOWN: number;\n};\n\n/** Corresponds to the SVG <script> element. */\ninterface SVGScriptElement extends SVGElement, SVGURIReference {\n    type: string;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGScriptElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGScriptElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGScriptElement: {\n    prototype: SVGScriptElement;\n    new(): SVGScriptElement;\n};\n\n/** Corresponds to the <stop> element. */\ninterface SVGStopElement extends SVGElement {\n    readonly offset: SVGAnimatedNumber;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGStopElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGStopElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGStopElement: {\n    prototype: SVGStopElement;\n    new(): SVGStopElement;\n};\n\n/** The SVGStringList defines a list of DOMString objects. */\ninterface SVGStringList {\n    readonly length: number;\n    readonly numberOfItems: number;\n    appendItem(newItem: string): string;\n    clear(): void;\n    getItem(index: number): string;\n    initialize(newItem: string): string;\n    insertItemBefore(newItem: string, index: number): string;\n    removeItem(index: number): string;\n    replaceItem(newItem: string, index: number): string;\n    [index: number]: string;\n}\n\ndeclare var SVGStringList: {\n    prototype: SVGStringList;\n    new(): SVGStringList;\n};\n\n/** Corresponds to the SVG <style> element. */\ninterface SVGStyleElement extends SVGElement {\n    disabled: boolean;\n    media: string;\n    title: string;\n    type: string;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGStyleElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGStyleElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGStyleElement: {\n    prototype: SVGStyleElement;\n    new(): SVGStyleElement;\n};\n\n/** Corresponds to the <switch> element. */\ninterface SVGSwitchElement extends SVGGraphicsElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGSwitchElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGSwitchElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGSwitchElement: {\n    prototype: SVGSwitchElement;\n    new(): SVGSwitchElement;\n};\n\n/** Corresponds to the <symbol> element. */\ninterface SVGSymbolElement extends SVGElement, SVGFitToViewBox {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGSymbolElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGSymbolElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGSymbolElement: {\n    prototype: SVGSymbolElement;\n    new(): SVGSymbolElement;\n};\n\n/** A <tspan> element. */\ninterface SVGTSpanElement extends SVGTextPositioningElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGTSpanElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGTSpanElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGTSpanElement: {\n    prototype: SVGTSpanElement;\n    new(): SVGTSpanElement;\n};\n\ninterface SVGTests {\n    readonly requiredExtensions: SVGStringList;\n    readonly systemLanguage: SVGStringList;\n}\n\n/** Implemented by elements that support rendering child text content. It is inherited by various text-related interfaces, such as SVGTextElement, SVGTSpanElement, SVGTRefElement, SVGAltGlyphElement and SVGTextPathElement. */\ninterface SVGTextContentElement extends SVGGraphicsElement {\n    readonly lengthAdjust: SVGAnimatedEnumeration;\n    readonly textLength: SVGAnimatedLength;\n    getCharNumAtPosition(point: SVGPoint): number;\n    getComputedTextLength(): number;\n    getEndPositionOfChar(charnum: number): SVGPoint;\n    getExtentOfChar(charnum: number): SVGRect;\n    getNumberOfChars(): number;\n    getRotationOfChar(charnum: number): number;\n    getStartPositionOfChar(charnum: number): SVGPoint;\n    getSubStringLength(charnum: number, nchars: number): number;\n    selectSubString(charnum: number, nchars: number): void;\n    readonly LENGTHADJUST_SPACING: number;\n    readonly LENGTHADJUST_SPACINGANDGLYPHS: number;\n    readonly LENGTHADJUST_UNKNOWN: number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGTextContentElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGTextContentElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGTextContentElement: {\n    prototype: SVGTextContentElement;\n    new(): SVGTextContentElement;\n    readonly LENGTHADJUST_SPACING: number;\n    readonly LENGTHADJUST_SPACINGANDGLYPHS: number;\n    readonly LENGTHADJUST_UNKNOWN: number;\n};\n\n/** Corresponds to the <text> elements. */\ninterface SVGTextElement extends SVGTextPositioningElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGTextElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGTextElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGTextElement: {\n    prototype: SVGTextElement;\n    new(): SVGTextElement;\n};\n\n/** Corresponds to the <textPath> element. */\ninterface SVGTextPathElement extends SVGTextContentElement, SVGURIReference {\n    readonly method: SVGAnimatedEnumeration;\n    readonly spacing: SVGAnimatedEnumeration;\n    readonly startOffset: SVGAnimatedLength;\n    readonly TEXTPATH_METHODTYPE_ALIGN: number;\n    readonly TEXTPATH_METHODTYPE_STRETCH: number;\n    readonly TEXTPATH_METHODTYPE_UNKNOWN: number;\n    readonly TEXTPATH_SPACINGTYPE_AUTO: number;\n    readonly TEXTPATH_SPACINGTYPE_EXACT: number;\n    readonly TEXTPATH_SPACINGTYPE_UNKNOWN: number;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGTextPathElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGTextPathElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGTextPathElement: {\n    prototype: SVGTextPathElement;\n    new(): SVGTextPathElement;\n    readonly TEXTPATH_METHODTYPE_ALIGN: number;\n    readonly TEXTPATH_METHODTYPE_STRETCH: number;\n    readonly TEXTPATH_METHODTYPE_UNKNOWN: number;\n    readonly TEXTPATH_SPACINGTYPE_AUTO: number;\n    readonly TEXTPATH_SPACINGTYPE_EXACT: number;\n    readonly TEXTPATH_SPACINGTYPE_UNKNOWN: number;\n};\n\n/** Implemented by elements that support attributes that position individual text glyphs. It is inherited by SVGTextElement, SVGTSpanElement, SVGTRefElement and SVGAltGlyphElement. */\ninterface SVGTextPositioningElement extends SVGTextContentElement {\n    readonly dx: SVGAnimatedLengthList;\n    readonly dy: SVGAnimatedLengthList;\n    readonly rotate: SVGAnimatedNumberList;\n    readonly x: SVGAnimatedLengthList;\n    readonly y: SVGAnimatedLengthList;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGTextPositioningElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGTextPositioningElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGTextPositioningElement: {\n    prototype: SVGTextPositioningElement;\n    new(): SVGTextPositioningElement;\n};\n\n/** Corresponds to the <title> element. */\ninterface SVGTitleElement extends SVGElement {\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGTitleElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGTitleElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGTitleElement: {\n    prototype: SVGTitleElement;\n    new(): SVGTitleElement;\n};\n\n/** SVGTransform is the interface for one of the component transformations within an SVGTransformList; thus, an SVGTransform object corresponds to a single component (e.g., scale(…) or matrix(…)) within a transform attribute. */\ninterface SVGTransform {\n    readonly angle: number;\n    readonly matrix: SVGMatrix;\n    readonly type: number;\n    setMatrix(matrix: SVGMatrix): void;\n    setRotate(angle: number, cx: number, cy: number): void;\n    setScale(sx: number, sy: number): void;\n    setSkewX(angle: number): void;\n    setSkewY(angle: number): void;\n    setTranslate(tx: number, ty: number): void;\n    readonly SVG_TRANSFORM_MATRIX: number;\n    readonly SVG_TRANSFORM_ROTATE: number;\n    readonly SVG_TRANSFORM_SCALE: number;\n    readonly SVG_TRANSFORM_SKEWX: number;\n    readonly SVG_TRANSFORM_SKEWY: number;\n    readonly SVG_TRANSFORM_TRANSLATE: number;\n    readonly SVG_TRANSFORM_UNKNOWN: number;\n}\n\ndeclare var SVGTransform: {\n    prototype: SVGTransform;\n    new(): SVGTransform;\n    readonly SVG_TRANSFORM_MATRIX: number;\n    readonly SVG_TRANSFORM_ROTATE: number;\n    readonly SVG_TRANSFORM_SCALE: number;\n    readonly SVG_TRANSFORM_SKEWX: number;\n    readonly SVG_TRANSFORM_SKEWY: number;\n    readonly SVG_TRANSFORM_TRANSLATE: number;\n    readonly SVG_TRANSFORM_UNKNOWN: number;\n};\n\n/** The SVGTransformList defines a list of SVGTransform objects. */\ninterface SVGTransformList {\n    readonly numberOfItems: number;\n    appendItem(newItem: SVGTransform): SVGTransform;\n    clear(): void;\n    consolidate(): SVGTransform;\n    createSVGTransformFromMatrix(matrix: SVGMatrix): SVGTransform;\n    getItem(index: number): SVGTransform;\n    initialize(newItem: SVGTransform): SVGTransform;\n    insertItemBefore(newItem: SVGTransform, index: number): SVGTransform;\n    removeItem(index: number): SVGTransform;\n    replaceItem(newItem: SVGTransform, index: number): SVGTransform;\n}\n\ndeclare var SVGTransformList: {\n    prototype: SVGTransformList;\n    new(): SVGTransformList;\n};\n\ninterface SVGURIReference {\n    readonly href: SVGAnimatedString;\n}\n\n/** A commonly used set of constants used for reflecting gradientUnits, patternContentUnits and other similar attributes. */\ninterface SVGUnitTypes {\n    readonly SVG_UNIT_TYPE_OBJECTBOUNDINGBOX: number;\n    readonly SVG_UNIT_TYPE_UNKNOWN: number;\n    readonly SVG_UNIT_TYPE_USERSPACEONUSE: number;\n}\n\ndeclare var SVGUnitTypes: {\n    prototype: SVGUnitTypes;\n    new(): SVGUnitTypes;\n    readonly SVG_UNIT_TYPE_OBJECTBOUNDINGBOX: number;\n    readonly SVG_UNIT_TYPE_UNKNOWN: number;\n    readonly SVG_UNIT_TYPE_USERSPACEONUSE: number;\n};\n\n/** Corresponds to the <use> element. */\ninterface SVGUseElement extends SVGGraphicsElement, SVGURIReference {\n    readonly animatedInstanceRoot: SVGElementInstance | null;\n    readonly height: SVGAnimatedLength;\n    readonly instanceRoot: SVGElementInstance | null;\n    readonly width: SVGAnimatedLength;\n    readonly x: SVGAnimatedLength;\n    readonly y: SVGAnimatedLength;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGUseElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGUseElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGUseElement: {\n    prototype: SVGUseElement;\n    new(): SVGUseElement;\n};\n\n/** Provides access to the properties of <view> elements, as well as methods to manipulate them. */\ninterface SVGViewElement extends SVGElement, SVGFitToViewBox, SVGZoomAndPan {\n    /** @deprecated */\n    readonly viewTarget: SVGStringList;\n    addEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGViewElement, ev: SVGElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SVGElementEventMap>(type: K, listener: (this: SVGViewElement, ev: SVGElementEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SVGViewElement: {\n    prototype: SVGViewElement;\n    new(): SVGViewElement;\n    readonly SVG_ZOOMANDPAN_DISABLE: number;\n    readonly SVG_ZOOMANDPAN_MAGNIFY: number;\n    readonly SVG_ZOOMANDPAN_UNKNOWN: number;\n};\n\n/** Used to reflect the zoomAndPan attribute, and is mixed in to other interfaces for elements that support this attribute. */\ninterface SVGZoomAndPan {\n    readonly zoomAndPan: number;\n}\n\ndeclare var SVGZoomAndPan: {\n    readonly SVG_ZOOMANDPAN_DISABLE: number;\n    readonly SVG_ZOOMANDPAN_MAGNIFY: number;\n    readonly SVG_ZOOMANDPAN_UNKNOWN: number;\n};\n\ninterface SVGZoomEvent extends UIEvent {\n    readonly newScale: number;\n    readonly newTranslate: SVGPoint;\n    readonly previousScale: number;\n    readonly previousTranslate: SVGPoint;\n    readonly zoomRectScreen: SVGRect;\n}\n\ndeclare var SVGZoomEvent: {\n    prototype: SVGZoomEvent;\n    new(): SVGZoomEvent;\n};\n\ninterface ScopedCredential {\n    readonly id: ArrayBuffer;\n    readonly type: ScopedCredentialType;\n}\n\ndeclare var ScopedCredential: {\n    prototype: ScopedCredential;\n    new(): ScopedCredential;\n};\n\ninterface ScopedCredentialInfo {\n    readonly credential: ScopedCredential;\n    readonly publicKey: CryptoKey;\n}\n\ndeclare var ScopedCredentialInfo: {\n    prototype: ScopedCredentialInfo;\n    new(): ScopedCredentialInfo;\n};\n\n/** A screen, usually the one on which the current window is being rendered, and is obtained using window.screen. */\ninterface Screen {\n    readonly availHeight: number;\n    readonly availWidth: number;\n    readonly colorDepth: number;\n    readonly height: number;\n    readonly orientation: ScreenOrientation;\n    readonly pixelDepth: number;\n    readonly width: number;\n}\n\ndeclare var Screen: {\n    prototype: Screen;\n    new(): Screen;\n};\n\ninterface ScreenOrientationEventMap {\n    "change": Event;\n}\n\ninterface ScreenOrientation extends EventTarget {\n    readonly angle: number;\n    onchange: ((this: ScreenOrientation, ev: Event) => any) | null;\n    readonly type: OrientationType;\n    lock(orientation: OrientationLockType): Promise<void>;\n    unlock(): void;\n    addEventListener<K extends keyof ScreenOrientationEventMap>(type: K, listener: (this: ScreenOrientation, ev: ScreenOrientationEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof ScreenOrientationEventMap>(type: K, listener: (this: ScreenOrientation, ev: ScreenOrientationEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var ScreenOrientation: {\n    prototype: ScreenOrientation;\n    new(): ScreenOrientation;\n};\n\ninterface ScriptProcessorNodeEventMap {\n    "audioprocess": AudioProcessingEvent;\n}\n\n/** Allows the generation, processing, or analyzing of audio using JavaScript. */\ninterface ScriptProcessorNode extends AudioNode {\n    /** @deprecated */\n    readonly bufferSize: number;\n    /** @deprecated */\n    onaudioprocess: ((this: ScriptProcessorNode, ev: AudioProcessingEvent) => any) | null;\n    addEventListener<K extends keyof ScriptProcessorNodeEventMap>(type: K, listener: (this: ScriptProcessorNode, ev: ScriptProcessorNodeEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof ScriptProcessorNodeEventMap>(type: K, listener: (this: ScriptProcessorNode, ev: ScriptProcessorNodeEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var ScriptProcessorNode: {\n    prototype: ScriptProcessorNode;\n    new(): ScriptProcessorNode;\n};\n\n/** Inherits from Event, and represents the event object of an event sent on a document or worker when its content security policy is violated. */\ninterface SecurityPolicyViolationEvent extends Event {\n    readonly blockedURI: string;\n    readonly columnNumber: number;\n    readonly documentURI: string;\n    readonly effectiveDirective: string;\n    readonly lineNumber: number;\n    readonly originalPolicy: string;\n    readonly referrer: string;\n    readonly sourceFile: string;\n    readonly statusCode: number;\n    readonly violatedDirective: string;\n}\n\ndeclare var SecurityPolicyViolationEvent: {\n    prototype: SecurityPolicyViolationEvent;\n    new(type: string, eventInitDict?: SecurityPolicyViolationEventInit): SecurityPolicyViolationEvent;\n};\n\n/** A Selection object represents the range of text selected by the user or the current position of the caret. To obtain a Selection object for examination or modification, call Window.getSelection(). */\ninterface Selection {\n    readonly anchorNode: Node | null;\n    readonly anchorOffset: number;\n    readonly focusNode: Node | null;\n    readonly focusOffset: number;\n    readonly isCollapsed: boolean;\n    readonly rangeCount: number;\n    readonly type: string;\n    addRange(range: Range): void;\n    collapse(node: Node | null, offset?: number): void;\n    collapseToEnd(): void;\n    collapseToStart(): void;\n    containsNode(node: Node, allowPartialContainment?: boolean): boolean;\n    deleteFromDocument(): void;\n    empty(): void;\n    extend(node: Node, offset?: number): void;\n    getRangeAt(index: number): Range;\n    removeAllRanges(): void;\n    removeRange(range: Range): void;\n    selectAllChildren(node: Node): void;\n    setBaseAndExtent(anchorNode: Node, anchorOffset: number, focusNode: Node, focusOffset: number): void;\n    setPosition(node: Node | null, offset?: number): void;\n}\n\ndeclare var Selection: {\n    prototype: Selection;\n    new(): Selection;\n};\n\ninterface ServiceUIFrameContext {\n    getCachedFrameMessage(key: string): string;\n    postFrameMessage(key: string, data: string): void;\n}\ndeclare var ServiceUIFrameContext: ServiceUIFrameContext;\n\ninterface ServiceWorkerEventMap extends AbstractWorkerEventMap {\n    "statechange": Event;\n}\n\n/** An interface of the ServiceWorker API provides a reference to a service worker. Multiple browsing contexts (e.g. pages, workers, etc.) can be associated with the same service worker, each through a unique ServiceWorker object. */\ninterface ServiceWorker extends EventTarget, AbstractWorker {\n    onstatechange: ((this: ServiceWorker, ev: Event) => any) | null;\n    readonly scriptURL: string;\n    readonly state: ServiceWorkerState;\n    postMessage(message: any, transfer: Transferable[]): void;\n    postMessage(message: any, options?: PostMessageOptions): void;\n    addEventListener<K extends keyof ServiceWorkerEventMap>(type: K, listener: (this: ServiceWorker, ev: ServiceWorkerEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof ServiceWorkerEventMap>(type: K, listener: (this: ServiceWorker, ev: ServiceWorkerEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var ServiceWorker: {\n    prototype: ServiceWorker;\n    new(): ServiceWorker;\n};\n\ninterface ServiceWorkerContainerEventMap {\n    "controllerchange": Event;\n    "message": MessageEvent;\n    "messageerror": MessageEvent;\n}\n\n/** The ServiceWorkerContainer interface of the ServiceWorker API provides an object representing the service worker as an overall unit in the network ecosystem, including facilities to register, unregister and update service workers, and access the state of service workers and their registrations. */\ninterface ServiceWorkerContainer extends EventTarget {\n    readonly controller: ServiceWorker | null;\n    oncontrollerchange: ((this: ServiceWorkerContainer, ev: Event) => any) | null;\n    onmessage: ((this: ServiceWorkerContainer, ev: MessageEvent) => any) | null;\n    onmessageerror: ((this: ServiceWorkerContainer, ev: MessageEvent) => any) | null;\n    readonly ready: Promise<ServiceWorkerRegistration>;\n    getRegistration(clientURL?: string): Promise<ServiceWorkerRegistration | undefined>;\n    getRegistrations(): Promise<ReadonlyArray<ServiceWorkerRegistration>>;\n    register(scriptURL: string, options?: RegistrationOptions): Promise<ServiceWorkerRegistration>;\n    startMessages(): void;\n    addEventListener<K extends keyof ServiceWorkerContainerEventMap>(type: K, listener: (this: ServiceWorkerContainer, ev: ServiceWorkerContainerEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof ServiceWorkerContainerEventMap>(type: K, listener: (this: ServiceWorkerContainer, ev: ServiceWorkerContainerEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var ServiceWorkerContainer: {\n    prototype: ServiceWorkerContainer;\n    new(): ServiceWorkerContainer;\n};\n\n/** An interface of the ServiceWorker API contains information about an event sent to a ServiceWorkerContainer target. This extends the default message event to allow setting a ServiceWorker object as the source of a message. The event object is accessed via the handler function of a message event, when fired by a message received from a service worker. */\ninterface ServiceWorkerMessageEvent extends Event {\n    readonly data: any;\n    readonly lastEventId: string;\n    readonly origin: string;\n    readonly ports: ReadonlyArray<MessagePort> | null;\n    readonly source: ServiceWorker | MessagePort | null;\n}\n\ndeclare var ServiceWorkerMessageEvent: {\n    prototype: ServiceWorkerMessageEvent;\n    new(type: string, eventInitDict?: ServiceWorkerMessageEventInit): ServiceWorkerMessageEvent;\n};\n\ninterface ServiceWorkerRegistrationEventMap {\n    "updatefound": Event;\n}\n\n/** An interface of the ServiceWorker API represents the service worker registration. You register a service worker to control one or more pages that share the same origin. */\ninterface ServiceWorkerRegistration extends EventTarget {\n    readonly active: ServiceWorker | null;\n    readonly installing: ServiceWorker | null;\n    readonly navigationPreload: NavigationPreloadManager;\n    onupdatefound: ((this: ServiceWorkerRegistration, ev: Event) => any) | null;\n    readonly pushManager: PushManager;\n    readonly scope: string;\n    readonly sync: SyncManager;\n    readonly updateViaCache: ServiceWorkerUpdateViaCache;\n    readonly waiting: ServiceWorker | null;\n    getNotifications(filter?: GetNotificationOptions): Promise<Notification[]>;\n    showNotification(title: string, options?: NotificationOptions): Promise<void>;\n    unregister(): Promise<boolean>;\n    update(): Promise<void>;\n    addEventListener<K extends keyof ServiceWorkerRegistrationEventMap>(type: K, listener: (this: ServiceWorkerRegistration, ev: ServiceWorkerRegistrationEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof ServiceWorkerRegistrationEventMap>(type: K, listener: (this: ServiceWorkerRegistration, ev: ServiceWorkerRegistrationEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var ServiceWorkerRegistration: {\n    prototype: ServiceWorkerRegistration;\n    new(): ServiceWorkerRegistration;\n};\n\ninterface ShadowRoot extends DocumentFragment, DocumentOrShadowRoot, InnerHTML {\n    readonly host: Element;\n    readonly mode: ShadowRootMode;\n}\n\ndeclare var ShadowRoot: {\n    prototype: ShadowRoot;\n    new(): ShadowRoot;\n};\n\ninterface Slotable {\n    readonly assignedSlot: HTMLSlotElement | null;\n}\n\ninterface SourceBufferEventMap {\n    "abort": Event;\n    "error": Event;\n    "update": Event;\n    "updateend": Event;\n    "updatestart": Event;\n}\n\n/** A chunk of media to be passed into an HTMLMediaElement and played, via a MediaSource object. This can be made up of one or several media segments. */\ninterface SourceBuffer extends EventTarget {\n    appendWindowEnd: number;\n    appendWindowStart: number;\n    readonly audioTracks: AudioTrackList;\n    readonly buffered: TimeRanges;\n    mode: AppendMode;\n    onabort: ((this: SourceBuffer, ev: Event) => any) | null;\n    onerror: ((this: SourceBuffer, ev: Event) => any) | null;\n    onupdate: ((this: SourceBuffer, ev: Event) => any) | null;\n    onupdateend: ((this: SourceBuffer, ev: Event) => any) | null;\n    onupdatestart: ((this: SourceBuffer, ev: Event) => any) | null;\n    readonly textTracks: TextTrackList;\n    timestampOffset: number;\n    readonly updating: boolean;\n    readonly videoTracks: VideoTrackList;\n    abort(): void;\n    appendBuffer(data: BufferSource): void;\n    remove(start: number, end: number): void;\n    addEventListener<K extends keyof SourceBufferEventMap>(type: K, listener: (this: SourceBuffer, ev: SourceBufferEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SourceBufferEventMap>(type: K, listener: (this: SourceBuffer, ev: SourceBufferEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SourceBuffer: {\n    prototype: SourceBuffer;\n    new(): SourceBuffer;\n};\n\ninterface SourceBufferListEventMap {\n    "addsourcebuffer": Event;\n    "removesourcebuffer": Event;\n}\n\n/** A simple container list for multiple SourceBuffer objects. */\ninterface SourceBufferList extends EventTarget {\n    readonly length: number;\n    onaddsourcebuffer: ((this: SourceBufferList, ev: Event) => any) | null;\n    onremovesourcebuffer: ((this: SourceBufferList, ev: Event) => any) | null;\n    addEventListener<K extends keyof SourceBufferListEventMap>(type: K, listener: (this: SourceBufferList, ev: SourceBufferListEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SourceBufferListEventMap>(type: K, listener: (this: SourceBufferList, ev: SourceBufferListEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n    [index: number]: SourceBuffer;\n}\n\ndeclare var SourceBufferList: {\n    prototype: SourceBufferList;\n    new(): SourceBufferList;\n};\n\ninterface SpeechGrammar {\n    src: string;\n    weight: number;\n}\n\ndeclare var SpeechGrammar: {\n    prototype: SpeechGrammar;\n    new(): SpeechGrammar;\n};\n\ninterface SpeechGrammarList {\n    readonly length: number;\n    addFromString(string: string, weight?: number): void;\n    addFromURI(src: string, weight?: number): void;\n    item(index: number): SpeechGrammar;\n    [index: number]: SpeechGrammar;\n}\n\ndeclare var SpeechGrammarList: {\n    prototype: SpeechGrammarList;\n    new(): SpeechGrammarList;\n};\n\ninterface SpeechRecognitionEventMap {\n    "audioend": Event;\n    "audiostart": Event;\n    "end": Event;\n    "error": SpeechRecognitionError;\n    "nomatch": SpeechRecognitionEvent;\n    "result": SpeechRecognitionEvent;\n    "soundend": Event;\n    "soundstart": Event;\n    "speechend": Event;\n    "speechstart": Event;\n    "start": Event;\n}\n\ninterface SpeechRecognition extends EventTarget {\n    continuous: boolean;\n    grammars: SpeechGrammarList;\n    interimResults: boolean;\n    lang: string;\n    maxAlternatives: number;\n    onaudioend: ((this: SpeechRecognition, ev: Event) => any) | null;\n    onaudiostart: ((this: SpeechRecognition, ev: Event) => any) | null;\n    onend: ((this: SpeechRecognition, ev: Event) => any) | null;\n    onerror: ((this: SpeechRecognition, ev: SpeechRecognitionError) => any) | null;\n    onnomatch: ((this: SpeechRecognition, ev: SpeechRecognitionEvent) => any) | null;\n    onresult: ((this: SpeechRecognition, ev: SpeechRecognitionEvent) => any) | null;\n    onsoundend: ((this: SpeechRecognition, ev: Event) => any) | null;\n    onsoundstart: ((this: SpeechRecognition, ev: Event) => any) | null;\n    onspeechend: ((this: SpeechRecognition, ev: Event) => any) | null;\n    onspeechstart: ((this: SpeechRecognition, ev: Event) => any) | null;\n    onstart: ((this: SpeechRecognition, ev: Event) => any) | null;\n    serviceURI: string;\n    abort(): void;\n    start(): void;\n    stop(): void;\n    addEventListener<K extends keyof SpeechRecognitionEventMap>(type: K, listener: (this: SpeechRecognition, ev: SpeechRecognitionEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SpeechRecognitionEventMap>(type: K, listener: (this: SpeechRecognition, ev: SpeechRecognitionEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SpeechRecognition: {\n    prototype: SpeechRecognition;\n    new(): SpeechRecognition;\n};\n\ninterface SpeechRecognitionAlternative {\n    readonly confidence: number;\n    readonly transcript: string;\n}\n\ndeclare var SpeechRecognitionAlternative: {\n    prototype: SpeechRecognitionAlternative;\n    new(): SpeechRecognitionAlternative;\n};\n\ninterface SpeechRecognitionError extends Event {\n    readonly error: SpeechRecognitionErrorCode;\n    readonly message: string;\n}\n\ndeclare var SpeechRecognitionError: {\n    prototype: SpeechRecognitionError;\n    new(): SpeechRecognitionError;\n};\n\ninterface SpeechRecognitionEvent extends Event {\n    readonly emma: Document | null;\n    readonly interpretation: any;\n    readonly resultIndex: number;\n    readonly results: SpeechRecognitionResultList;\n}\n\ndeclare var SpeechRecognitionEvent: {\n    prototype: SpeechRecognitionEvent;\n    new(): SpeechRecognitionEvent;\n};\n\ninterface SpeechRecognitionResult {\n    readonly isFinal: boolean;\n    readonly length: number;\n    item(index: number): SpeechRecognitionAlternative;\n    [index: number]: SpeechRecognitionAlternative;\n}\n\ndeclare var SpeechRecognitionResult: {\n    prototype: SpeechRecognitionResult;\n    new(): SpeechRecognitionResult;\n};\n\ninterface SpeechRecognitionResultList {\n    readonly length: number;\n    item(index: number): SpeechRecognitionResult;\n    [index: number]: SpeechRecognitionResult;\n}\n\ndeclare var SpeechRecognitionResultList: {\n    prototype: SpeechRecognitionResultList;\n    new(): SpeechRecognitionResultList;\n};\n\ninterface SpeechSynthesisEventMap {\n    "voiceschanged": Event;\n}\n\n/** An interface of the Web Speech API is the controller interface for the speech service; this can be used to retrieve information about the synthesis voices available on the device, start and pause speech, and other commands besides. */\ninterface SpeechSynthesis extends EventTarget {\n    onvoiceschanged: ((this: SpeechSynthesis, ev: Event) => any) | null;\n    readonly paused: boolean;\n    readonly pending: boolean;\n    readonly speaking: boolean;\n    cancel(): void;\n    getVoices(): SpeechSynthesisVoice[];\n    pause(): void;\n    resume(): void;\n    speak(utterance: SpeechSynthesisUtterance): void;\n    addEventListener<K extends keyof SpeechSynthesisEventMap>(type: K, listener: (this: SpeechSynthesis, ev: SpeechSynthesisEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SpeechSynthesisEventMap>(type: K, listener: (this: SpeechSynthesis, ev: SpeechSynthesisEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SpeechSynthesis: {\n    prototype: SpeechSynthesis;\n    new(): SpeechSynthesis;\n};\n\ninterface SpeechSynthesisErrorEvent extends SpeechSynthesisEvent {\n    readonly error: SpeechSynthesisErrorCode;\n}\n\ndeclare var SpeechSynthesisErrorEvent: {\n    prototype: SpeechSynthesisErrorEvent;\n    new(): SpeechSynthesisErrorEvent;\n};\n\n/** An interface of the Web Speech API contains information about the current state of SpeechSynthesisUtterance objects that have been processed in the speech service. */\ninterface SpeechSynthesisEvent extends Event {\n    readonly charIndex: number;\n    readonly elapsedTime: number;\n    readonly name: string;\n    readonly utterance: SpeechSynthesisUtterance;\n}\n\ndeclare var SpeechSynthesisEvent: {\n    prototype: SpeechSynthesisEvent;\n    new(): SpeechSynthesisEvent;\n};\n\ninterface SpeechSynthesisUtteranceEventMap {\n    "boundary": SpeechSynthesisEvent;\n    "end": SpeechSynthesisEvent;\n    "error": SpeechSynthesisErrorEvent;\n    "mark": SpeechSynthesisEvent;\n    "pause": SpeechSynthesisEvent;\n    "resume": SpeechSynthesisEvent;\n    "start": SpeechSynthesisEvent;\n}\n\n/** An interface of the Web Speech API represents a speech request. It contains the content the speech service should read and information about how to read it (e.g. language, pitch and volume.) */\ninterface SpeechSynthesisUtterance extends EventTarget {\n    lang: string;\n    onboundary: ((this: SpeechSynthesisUtterance, ev: SpeechSynthesisEvent) => any) | null;\n    onend: ((this: SpeechSynthesisUtterance, ev: SpeechSynthesisEvent) => any) | null;\n    onerror: ((this: SpeechSynthesisUtterance, ev: SpeechSynthesisErrorEvent) => any) | null;\n    onmark: ((this: SpeechSynthesisUtterance, ev: SpeechSynthesisEvent) => any) | null;\n    onpause: ((this: SpeechSynthesisUtterance, ev: SpeechSynthesisEvent) => any) | null;\n    onresume: ((this: SpeechSynthesisUtterance, ev: SpeechSynthesisEvent) => any) | null;\n    onstart: ((this: SpeechSynthesisUtterance, ev: SpeechSynthesisEvent) => any) | null;\n    pitch: number;\n    rate: number;\n    text: string;\n    voice: SpeechSynthesisVoice;\n    volume: number;\n    addEventListener<K extends keyof SpeechSynthesisUtteranceEventMap>(type: K, listener: (this: SpeechSynthesisUtterance, ev: SpeechSynthesisUtteranceEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof SpeechSynthesisUtteranceEventMap>(type: K, listener: (this: SpeechSynthesisUtterance, ev: SpeechSynthesisUtteranceEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var SpeechSynthesisUtterance: {\n    prototype: SpeechSynthesisUtterance;\n    new(): SpeechSynthesisUtterance;\n    new(text: string): SpeechSynthesisUtterance;\n};\n\n/** An interface of the Web Speech API represents a voice that the system supports. Every SpeechSynthesisVoice has its own relative speech service including information about language, name and URI. */\ninterface SpeechSynthesisVoice {\n    readonly default: boolean;\n    readonly lang: string;\n    readonly localService: boolean;\n    readonly name: string;\n    readonly voiceURI: string;\n}\n\ndeclare var SpeechSynthesisVoice: {\n    prototype: SpeechSynthesisVoice;\n    new(): SpeechSynthesisVoice;\n};\n\ninterface StaticRange extends AbstractRange {\n}\n\ndeclare var StaticRange: {\n    prototype: StaticRange;\n    new(): StaticRange;\n};\n\n/** The pan property takes a unitless value between -1 (full left pan) and 1 (full right pan). This interface was introduced as a much simpler way to apply a simple panning effect than having to use a full PannerNode. */\ninterface StereoPannerNode extends AudioNode {\n    readonly pan: AudioParam;\n}\n\ndeclare var StereoPannerNode: {\n    prototype: StereoPannerNode;\n    new(context: BaseAudioContext, options?: StereoPannerOptions): StereoPannerNode;\n};\n\n/** An interface of the Web Storage API provides access to a particular domain\'s session or local storage. It allows, for example, the addition, modification, or deletion of stored data items. */\ninterface Storage {\n    /**\n     * Returns the number of key/value pairs currently present in the list associated with the\n     * object.\n     */\n    readonly length: number;\n    /**\n     * Empties the list associated with the object of all key/value pairs, if there are any.\n     */\n    clear(): void;\n    /**\n     * value = storage[key]\n     */\n    getItem(key: string): string | null;\n    /**\n     * Returns the name of the nth key in the list, or null if n is greater\n     * than or equal to the number of key/value pairs in the object.\n     */\n    key(index: number): string | null;\n    /**\n     * delete storage[key]\n     */\n    removeItem(key: string): void;\n    /**\n     * storage[key] = value\n     */\n    setItem(key: string, value: string): void;\n    [name: string]: any;\n}\n\ndeclare var Storage: {\n    prototype: Storage;\n    new(): Storage;\n};\n\n/** A StorageEvent is sent to a window when a storage area it has access to is changed within the context of another document. */\ninterface StorageEvent extends Event {\n    /**\n     * Returns the key of the storage item being changed.\n     */\n    readonly key: string | null;\n    /**\n     * Returns the new value of the key of the storage item whose value is being changed.\n     */\n    readonly newValue: string | null;\n    /**\n     * Returns the old value of the key of the storage item whose value is being changed.\n     */\n    readonly oldValue: string | null;\n    /**\n     * Returns the Storage object that was affected.\n     */\n    readonly storageArea: Storage | null;\n    /**\n     * Returns the URL of the document whose storage item changed.\n     */\n    readonly url: string;\n}\n\ndeclare var StorageEvent: {\n    prototype: StorageEvent;\n    new(type: string, eventInitDict?: StorageEventInit): StorageEvent;\n};\n\ninterface StorageManager {\n    estimate(): Promise<StorageEstimate>;\n    persist(): Promise<boolean>;\n    persisted(): Promise<boolean>;\n}\n\ndeclare var StorageManager: {\n    prototype: StorageManager;\n    new(): StorageManager;\n};\n\ninterface StyleMedia {\n    readonly type: string;\n    matchMedium(mediaquery: string): boolean;\n}\n\ndeclare var StyleMedia: {\n    prototype: StyleMedia;\n    new(): StyleMedia;\n};\n\n/** A single style sheet. CSS style sheets will further implement the more specialized CSSStyleSheet interface. */\ninterface StyleSheet {\n    disabled: boolean;\n    readonly href: string | null;\n    readonly media: MediaList;\n    readonly ownerNode: Node;\n    readonly parentStyleSheet: StyleSheet | null;\n    readonly title: string | null;\n    readonly type: string;\n}\n\ndeclare var StyleSheet: {\n    prototype: StyleSheet;\n    new(): StyleSheet;\n};\n\n/** A list of StyleSheet. */\ninterface StyleSheetList {\n    readonly length: number;\n    item(index: number): StyleSheet | null;\n    [index: number]: StyleSheet;\n}\n\ndeclare var StyleSheetList: {\n    prototype: StyleSheetList;\n    new(): StyleSheetList;\n};\n\n/** An interface of the Web Crypto API provides a number of low-level cryptographic functions. It is accessed via the Crypto.subtle properties available in a window context (via Window.crypto). */\ninterface SubtleCrypto {\n    decrypt(algorithm: string | RsaOaepParams | AesCtrParams | AesCbcParams | AesCmacParams | AesGcmParams | AesCfbParams, key: CryptoKey, data: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer): PromiseLike<ArrayBuffer>;\n    deriveBits(algorithm: string | EcdhKeyDeriveParams | DhKeyDeriveParams | ConcatParams | HkdfCtrParams | Pbkdf2Params, baseKey: CryptoKey, length: number): PromiseLike<ArrayBuffer>;\n    deriveKey(algorithm: string | EcdhKeyDeriveParams | DhKeyDeriveParams | ConcatParams | HkdfCtrParams | Pbkdf2Params, baseKey: CryptoKey, derivedKeyType: string | AesDerivedKeyParams | HmacImportParams | ConcatParams | HkdfCtrParams | Pbkdf2Params, extractable: boolean, keyUsages: string[]): PromiseLike<CryptoKey>;\n    digest(algorithm: string | Algorithm, data: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer): PromiseLike<ArrayBuffer>;\n    encrypt(algorithm: string | RsaOaepParams | AesCtrParams | AesCbcParams | AesCmacParams | AesGcmParams | AesCfbParams, key: CryptoKey, data: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer): PromiseLike<ArrayBuffer>;\n    exportKey(format: "jwk", key: CryptoKey): PromiseLike<JsonWebKey>;\n    exportKey(format: "raw" | "pkcs8" | "spki", key: CryptoKey): PromiseLike<ArrayBuffer>;\n    exportKey(format: string, key: CryptoKey): PromiseLike<JsonWebKey | ArrayBuffer>;\n    generateKey(algorithm: string, extractable: boolean, keyUsages: string[]): PromiseLike<CryptoKeyPair | CryptoKey>;\n    generateKey(algorithm: RsaHashedKeyGenParams | EcKeyGenParams | DhKeyGenParams, extractable: boolean, keyUsages: string[]): PromiseLike<CryptoKeyPair>;\n    generateKey(algorithm: AesKeyGenParams | HmacKeyGenParams | Pbkdf2Params, extractable: boolean, keyUsages: string[]): PromiseLike<CryptoKey>;\n    importKey(format: "jwk", keyData: JsonWebKey, algorithm: string | RsaHashedImportParams | EcKeyImportParams | HmacImportParams | DhImportKeyParams | AesKeyAlgorithm, extractable: boolean, keyUsages: string[]): PromiseLike<CryptoKey>;\n    importKey(format: "raw" | "pkcs8" | "spki", keyData: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer, algorithm: string | RsaHashedImportParams | EcKeyImportParams | HmacImportParams | DhImportKeyParams | AesKeyAlgorithm, extractable: boolean, keyUsages: string[]): PromiseLike<CryptoKey>;\n    importKey(format: string, keyData: JsonWebKey | Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer, algorithm: string | RsaHashedImportParams | EcKeyImportParams | HmacImportParams | DhImportKeyParams | AesKeyAlgorithm, extractable: boolean, keyUsages: string[]): PromiseLike<CryptoKey>;\n    sign(algorithm: string | RsaPssParams | EcdsaParams | AesCmacParams, key: CryptoKey, data: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer): PromiseLike<ArrayBuffer>;\n    unwrapKey(format: string, wrappedKey: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer, unwrappingKey: CryptoKey, unwrapAlgorithm: string | Algorithm, unwrappedKeyAlgorithm: string | Algorithm, extractable: boolean, keyUsages: string[]): PromiseLike<CryptoKey>;\n    verify(algorithm: string | RsaPssParams | EcdsaParams | AesCmacParams, key: CryptoKey, signature: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer, data: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer): PromiseLike<boolean>;\n    wrapKey(format: string, key: CryptoKey, wrappingKey: CryptoKey, wrapAlgorithm: string | Algorithm): PromiseLike<ArrayBuffer>;\n}\n\ndeclare var SubtleCrypto: {\n    prototype: SubtleCrypto;\n    new(): SubtleCrypto;\n};\n\n/** An interface of the ServiceWorker API provides an interface for registering and listing sync registrations. */\ninterface SyncManager {\n    getTags(): Promise<string[]>;\n    register(tag: string): Promise<void>;\n}\n\ndeclare var SyncManager: {\n    prototype: SyncManager;\n    new(): SyncManager;\n};\n\n/** The textual content of Element or Attr. If an element has no markup within its content, it has a single child implementing Text that contains the element\'s text. However, if the element contains markup, it is parsed into information items and Text nodes that form its children. */\ninterface Text extends CharacterData, Slotable {\n    readonly assignedSlot: HTMLSlotElement | null;\n    /**\n     * Returns the combined data of all direct Text node siblings.\n     */\n    readonly wholeText: string;\n    /**\n     * Splits data at the given offset and returns the remainder as Text node.\n     */\n    splitText(offset: number): Text;\n}\n\ndeclare var Text: {\n    prototype: Text;\n    new(data?: string): Text;\n};\n\n/** A decoder for a specific method, that is a specific character encoding, like utf-8, iso-8859-2, koi8, cp1261, gbk, etc. A decoder takes a stream of bytes as input and emits a stream of code points. For a more scalable, non-native library, see StringView – a C-like representation of strings based on typed arrays. */\ninterface TextDecoder extends TextDecoderCommon {\n    /**\n     * Returns the result of running encoding\'s decoder.\n     * The method can be invoked zero or more times with options\'s stream set to\n     * true, and then once without options\'s stream (or set to false), to process\n     * a fragmented stream. If the invocation without options\'s stream (or set to\n     * false) has no input, it\'s clearest to omit both arguments.\n     * var string = "", decoder = new TextDecoder(encoding), buffer;\n     * while(buffer = next_chunk()) {\n     * string += decoder.decode(buffer, {stream:true});\n     * }\n     * string += decoder.decode(); // end-of-stream\n     * If the error mode is "fatal" and encoding\'s decoder returns error, throws a TypeError.\n     */\n    decode(input?: BufferSource, options?: TextDecodeOptions): string;\n}\n\ndeclare var TextDecoder: {\n    prototype: TextDecoder;\n    new(label?: string, options?: TextDecoderOptions): TextDecoder;\n};\n\ninterface TextDecoderCommon {\n    readonly encoding: string;\n    readonly fatal: boolean;\n    readonly ignoreBOM: boolean;\n}\n\ninterface TextDecoderStream extends TextDecoderCommon, GenericTransformStream {\n}\n\ndeclare var TextDecoderStream: {\n    prototype: TextDecoderStream;\n    new(label?: string, options?: TextDecoderOptions): TextDecoderStream;\n};\n\n/** TextEncoder takes a stream of code points as input and emits a stream of bytes. For a more scalable, non-native library, see StringView – a C-like representation of strings based on typed arrays. */\ninterface TextEncoder extends TextEncoderCommon {\n    /**\n     * Returns the result of running UTF-8\'s encoder.\n     */\n    encode(input?: string): Uint8Array;\n    /**\n     * Runs the UTF-8 encoder on source, stores the result of that operation into destination, and returns the progress made as a dictionary whereby read is the number of converted code units of source and written is the number of bytes modified in destination.\n     */\n    encodeInto(source: string, destination: Uint8Array): TextEncoderEncodeIntoResult;\n}\n\ndeclare var TextEncoder: {\n    prototype: TextEncoder;\n    new(): TextEncoder;\n};\n\ninterface TextEncoderCommon {\n    readonly encoding: string;\n}\n\ninterface TextEncoderStream extends TextEncoderCommon, GenericTransformStream {\n}\n\ndeclare var TextEncoderStream: {\n    prototype: TextEncoderStream;\n    new(): TextEncoderStream;\n};\n\ninterface TextEvent extends UIEvent {\n    readonly data: string;\n    initTextEvent(typeArg: string, canBubbleArg: boolean, cancelableArg: boolean, viewArg: Window, dataArg: string, inputMethod: number, locale: string): void;\n    readonly DOM_INPUT_METHOD_DROP: number;\n    readonly DOM_INPUT_METHOD_HANDWRITING: number;\n    readonly DOM_INPUT_METHOD_IME: number;\n    readonly DOM_INPUT_METHOD_KEYBOARD: number;\n    readonly DOM_INPUT_METHOD_MULTIMODAL: number;\n    readonly DOM_INPUT_METHOD_OPTION: number;\n    readonly DOM_INPUT_METHOD_PASTE: number;\n    readonly DOM_INPUT_METHOD_SCRIPT: number;\n    readonly DOM_INPUT_METHOD_UNKNOWN: number;\n    readonly DOM_INPUT_METHOD_VOICE: number;\n}\n\ndeclare var TextEvent: {\n    prototype: TextEvent;\n    new(): TextEvent;\n    readonly DOM_INPUT_METHOD_DROP: number;\n    readonly DOM_INPUT_METHOD_HANDWRITING: number;\n    readonly DOM_INPUT_METHOD_IME: number;\n    readonly DOM_INPUT_METHOD_KEYBOARD: number;\n    readonly DOM_INPUT_METHOD_MULTIMODAL: number;\n    readonly DOM_INPUT_METHOD_OPTION: number;\n    readonly DOM_INPUT_METHOD_PASTE: number;\n    readonly DOM_INPUT_METHOD_SCRIPT: number;\n    readonly DOM_INPUT_METHOD_UNKNOWN: number;\n    readonly DOM_INPUT_METHOD_VOICE: number;\n};\n\n/** The dimensions of a piece of text in the canvas, as created by the CanvasRenderingContext2D.measureText() method. */\ninterface TextMetrics {\n    readonly actualBoundingBoxAscent: number;\n    readonly actualBoundingBoxDescent: number;\n    readonly actualBoundingBoxLeft: number;\n    readonly actualBoundingBoxRight: number;\n    readonly alphabeticBaseline: number;\n    readonly emHeightAscent: number;\n    readonly emHeightDescent: number;\n    readonly fontBoundingBoxAscent: number;\n    readonly fontBoundingBoxDescent: number;\n    readonly hangingBaseline: number;\n    /**\n     * Returns the measurement described below.\n     */\n    readonly ideographicBaseline: number;\n    readonly width: number;\n}\n\ndeclare var TextMetrics: {\n    prototype: TextMetrics;\n    new(): TextMetrics;\n};\n\ninterface TextTrackEventMap {\n    "cuechange": Event;\n    "error": Event;\n    "load": Event;\n}\n\n/** This interface also inherits properties from EventTarget. */\ninterface TextTrack extends EventTarget {\n    readonly activeCues: TextTrackCueList;\n    readonly cues: TextTrackCueList;\n    readonly inBandMetadataTrackDispatchType: string;\n    readonly kind: string;\n    readonly label: string;\n    readonly language: string;\n    mode: TextTrackMode | number;\n    oncuechange: ((this: TextTrack, ev: Event) => any) | null;\n    onerror: ((this: TextTrack, ev: Event) => any) | null;\n    onload: ((this: TextTrack, ev: Event) => any) | null;\n    readonly readyState: number;\n    readonly sourceBuffer: SourceBuffer | null;\n    addCue(cue: TextTrackCue): void;\n    removeCue(cue: TextTrackCue): void;\n    readonly DISABLED: number;\n    readonly ERROR: number;\n    readonly HIDDEN: number;\n    readonly LOADED: number;\n    readonly LOADING: number;\n    readonly NONE: number;\n    readonly SHOWING: number;\n    addEventListener<K extends keyof TextTrackEventMap>(type: K, listener: (this: TextTrack, ev: TextTrackEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof TextTrackEventMap>(type: K, listener: (this: TextTrack, ev: TextTrackEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var TextTrack: {\n    prototype: TextTrack;\n    new(): TextTrack;\n    readonly DISABLED: number;\n    readonly ERROR: number;\n    readonly HIDDEN: number;\n    readonly LOADED: number;\n    readonly LOADING: number;\n    readonly NONE: number;\n    readonly SHOWING: number;\n};\n\ninterface TextTrackCueEventMap {\n    "enter": Event;\n    "exit": Event;\n}\n\n/** TextTrackCues represent a string of text that will be displayed for some duration of time on a TextTrack. This includes the start and end times that the cue will be displayed. A TextTrackCue cannot be used directly, instead one of the derived types (e.g. VTTCue) must be used. */\ninterface TextTrackCue extends EventTarget {\n    endTime: number;\n    id: string;\n    onenter: ((this: TextTrackCue, ev: Event) => any) | null;\n    onexit: ((this: TextTrackCue, ev: Event) => any) | null;\n    pauseOnExit: boolean;\n    startTime: number;\n    text: string;\n    readonly track: TextTrack;\n    getCueAsHTML(): DocumentFragment;\n    addEventListener<K extends keyof TextTrackCueEventMap>(type: K, listener: (this: TextTrackCue, ev: TextTrackCueEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof TextTrackCueEventMap>(type: K, listener: (this: TextTrackCue, ev: TextTrackCueEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var TextTrackCue: {\n    prototype: TextTrackCue;\n    new(startTime: number, endTime: number, text: string): TextTrackCue;\n};\n\ninterface TextTrackCueList {\n    readonly length: number;\n    getCueById(id: string): TextTrackCue;\n    item(index: number): TextTrackCue;\n    [index: number]: TextTrackCue;\n}\n\ndeclare var TextTrackCueList: {\n    prototype: TextTrackCueList;\n    new(): TextTrackCueList;\n};\n\ninterface TextTrackListEventMap {\n    "addtrack": TrackEvent;\n}\n\ninterface TextTrackList extends EventTarget {\n    readonly length: number;\n    onaddtrack: ((this: TextTrackList, ev: TrackEvent) => any) | null;\n    item(index: number): TextTrack;\n    addEventListener<K extends keyof TextTrackListEventMap>(type: K, listener: (this: TextTrackList, ev: TextTrackListEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof TextTrackListEventMap>(type: K, listener: (this: TextTrackList, ev: TextTrackListEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n    [index: number]: TextTrack;\n}\n\ndeclare var TextTrackList: {\n    prototype: TextTrackList;\n    new(): TextTrackList;\n};\n\n/** Used to represent a set of time ranges, primarily for the purpose of tracking which portions of media have been buffered when loading it for use by the <audio> and <video> elements. */\ninterface TimeRanges {\n    readonly length: number;\n    end(index: number): number;\n    start(index: number): number;\n}\n\ndeclare var TimeRanges: {\n    prototype: TimeRanges;\n    new(): TimeRanges;\n};\n\n/** A single contact point on a touch-sensitive device. The contact point is commonly a finger or stylus and the device may be a touchscreen or trackpad. */\ninterface Touch {\n    readonly altitudeAngle: number;\n    readonly azimuthAngle: number;\n    readonly clientX: number;\n    readonly clientY: number;\n    readonly force: number;\n    readonly identifier: number;\n    readonly pageX: number;\n    readonly pageY: number;\n    readonly radiusX: number;\n    readonly radiusY: number;\n    readonly rotationAngle: number;\n    readonly screenX: number;\n    readonly screenY: number;\n    readonly target: EventTarget;\n    readonly touchType: TouchType;\n}\n\ndeclare var Touch: {\n    prototype: Touch;\n    new(touchInitDict: TouchInit): Touch;\n};\n\n/** An event sent when the state of contacts with a touch-sensitive surface changes. This surface can be a touch screen or trackpad, for example. The event can describe one or more points of contact with the screen and includes support for detecting movement, addition and removal of contact points, and so forth. */\ninterface TouchEvent extends UIEvent {\n    readonly altKey: boolean;\n    readonly changedTouches: TouchList;\n    readonly ctrlKey: boolean;\n    readonly metaKey: boolean;\n    readonly shiftKey: boolean;\n    readonly targetTouches: TouchList;\n    readonly touches: TouchList;\n}\n\ndeclare var TouchEvent: {\n    prototype: TouchEvent;\n    new(type: string, eventInitDict?: TouchEventInit): TouchEvent;\n};\n\n/** A list of contact points on a touch surface. For example, if the user has three fingers on the touch surface (such as a screen or trackpad), the corresponding TouchList object would have one Touch object for each finger, for a total of three entries. */\ninterface TouchList {\n    readonly length: number;\n    item(index: number): Touch | null;\n    [index: number]: Touch;\n}\n\ndeclare var TouchList: {\n    prototype: TouchList;\n    new(): TouchList;\n};\n\n/** The TrackEvent interface, part of the HTML DOM specification, is used for events which represent changes to the set of available tracks on an HTML media element; these events are addtrack and removetrack. */\ninterface TrackEvent extends Event {\n    readonly track: VideoTrack | AudioTrack | TextTrack | null;\n}\n\ndeclare var TrackEvent: {\n    prototype: TrackEvent;\n    new(typeArg: string, eventInitDict?: TrackEventInit): TrackEvent;\n};\n\ninterface TransformStream<I = any, O = any> {\n    readonly readable: ReadableStream<O>;\n    readonly writable: WritableStream<I>;\n}\n\ndeclare var TransformStream: {\n    prototype: TransformStream;\n    new<I = any, O = any>(transformer?: Transformer<I, O>, writableStrategy?: QueuingStrategy<I>, readableStrategy?: QueuingStrategy<O>): TransformStream<I, O>;\n};\n\ninterface TransformStreamDefaultController<O = any> {\n    readonly desiredSize: number | null;\n    enqueue(chunk: O): void;\n    error(reason?: any): void;\n    terminate(): void;\n}\n\n/** Events providing information related to transitions. */\ninterface TransitionEvent extends Event {\n    readonly elapsedTime: number;\n    readonly propertyName: string;\n    readonly pseudoElement: string;\n}\n\ndeclare var TransitionEvent: {\n    prototype: TransitionEvent;\n    new(type: string, transitionEventInitDict?: TransitionEventInit): TransitionEvent;\n};\n\n/** The nodes of a document subtree and a position within them. */\ninterface TreeWalker {\n    currentNode: Node;\n    readonly filter: NodeFilter | null;\n    readonly root: Node;\n    readonly whatToShow: number;\n    firstChild(): Node | null;\n    lastChild(): Node | null;\n    nextNode(): Node | null;\n    nextSibling(): Node | null;\n    parentNode(): Node | null;\n    previousNode(): Node | null;\n    previousSibling(): Node | null;\n}\n\ndeclare var TreeWalker: {\n    prototype: TreeWalker;\n    new(): TreeWalker;\n};\n\n/** Simple user interface events. */\ninterface UIEvent extends Event {\n    readonly detail: number;\n    readonly view: Window;\n    initUIEvent(typeArg: string, canBubbleArg: boolean, cancelableArg: boolean, viewArg: Window, detailArg: number): void;\n}\n\ndeclare var UIEvent: {\n    prototype: UIEvent;\n    new(typeArg: string, eventInitDict?: UIEventInit): UIEvent;\n};\n\n/** The URL interface represents an object providing static methods used for creating object URLs. */\ninterface URL {\n    hash: string;\n    host: string;\n    hostname: string;\n    href: string;\n    readonly origin: string;\n    password: string;\n    pathname: string;\n    port: string;\n    protocol: string;\n    search: string;\n    readonly searchParams: URLSearchParams;\n    username: string;\n    toJSON(): string;\n}\n\ndeclare var URL: {\n    prototype: URL;\n    new(url: string, base?: string | URL): URL;\n    createObjectURL(object: any): string;\n    revokeObjectURL(url: string): void;\n};\n\ntype webkitURL = URL;\ndeclare var webkitURL: typeof URL;\n\ninterface URLSearchParams {\n    /**\n     * Appends a specified key/value pair as a new search parameter.\n     */\n    append(name: string, value: string): void;\n    /**\n     * Deletes the given search parameter, and its associated value, from the list of all search parameters.\n     */\n    delete(name: string): void;\n    /**\n     * Returns the first value associated to the given search parameter.\n     */\n    get(name: string): string | null;\n    /**\n     * Returns all the values association with a given search parameter.\n     */\n    getAll(name: string): string[];\n    /**\n     * Returns a Boolean indicating if such a search parameter exists.\n     */\n    has(name: string): boolean;\n    /**\n     * Sets the value associated to a given search parameter to the given value. If there were several values, delete the others.\n     */\n    set(name: string, value: string): void;\n    sort(): void;\n    forEach(callbackfn: (value: string, key: string, parent: URLSearchParams) => void, thisArg?: any): void;\n}\n\ndeclare var URLSearchParams: {\n    prototype: URLSearchParams;\n    new(init?: string[][] | Record<string, string> | string | URLSearchParams): URLSearchParams;\n};\n\n/** An interface of the WebVR API represents any VR device supported by this API . It includes generic information such as device IDs and descriptions, as well as methods for starting to present a VR scene, retrieving eye parameters and display capabilities, and other important functionality. */\ninterface VRDisplay extends EventTarget {\n    readonly capabilities: VRDisplayCapabilities;\n    depthFar: number;\n    depthNear: number;\n    readonly displayId: number;\n    readonly displayName: string;\n    readonly isConnected: boolean;\n    readonly isPresenting: boolean;\n    readonly stageParameters: VRStageParameters | null;\n    cancelAnimationFrame(handle: number): void;\n    exitPresent(): Promise<void>;\n    getEyeParameters(whichEye: string): VREyeParameters;\n    getFrameData(frameData: VRFrameData): boolean;\n    getLayers(): VRLayer[];\n    /** @deprecated */\n    getPose(): VRPose;\n    requestAnimationFrame(callback: FrameRequestCallback): number;\n    requestPresent(layers: VRLayer[]): Promise<void>;\n    resetPose(): void;\n    submitFrame(pose?: VRPose): void;\n}\n\ndeclare var VRDisplay: {\n    prototype: VRDisplay;\n    new(): VRDisplay;\n};\n\n/** An interface of the WebVR API describes the capabilities of a VRDisplay — its features can be used to perform VR device capability tests, for example can it return position information. */\ninterface VRDisplayCapabilities {\n    readonly canPresent: boolean;\n    readonly hasExternalDisplay: boolean;\n    readonly hasOrientation: boolean;\n    readonly hasPosition: boolean;\n    readonly maxLayers: number;\n}\n\ndeclare var VRDisplayCapabilities: {\n    prototype: VRDisplayCapabilities;\n    new(): VRDisplayCapabilities;\n};\n\n/** An interface of the WebVR API represents represents the event object of WebVR-related events (see the list of WebVR window extensions). */\ninterface VRDisplayEvent extends Event {\n    readonly display: VRDisplay;\n    readonly reason: VRDisplayEventReason | null;\n}\n\ndeclare var VRDisplayEvent: {\n    prototype: VRDisplayEvent;\n    new(type: string, eventInitDict: VRDisplayEventInit): VRDisplayEvent;\n};\n\n/** An interface of the WebVR API represents all the information required to correctly render a scene for a given eye, including field of view information. */\ninterface VREyeParameters {\n    /** @deprecated */\n    readonly fieldOfView: VRFieldOfView;\n    readonly offset: Float32Array;\n    readonly renderHeight: number;\n    readonly renderWidth: number;\n}\n\ndeclare var VREyeParameters: {\n    prototype: VREyeParameters;\n    new(): VREyeParameters;\n};\n\n/** An interface of the WebVR API represents a field of view defined by 4 different degree values describing the view from a center point. */\ninterface VRFieldOfView {\n    readonly downDegrees: number;\n    readonly leftDegrees: number;\n    readonly rightDegrees: number;\n    readonly upDegrees: number;\n}\n\ndeclare var VRFieldOfView: {\n    prototype: VRFieldOfView;\n    new(): VRFieldOfView;\n};\n\n/** An interface of the WebVR API represents all the information needed to render a single frame of a VR scene; constructed by VRDisplay.getFrameData(). */\ninterface VRFrameData {\n    readonly leftProjectionMatrix: Float32Array;\n    readonly leftViewMatrix: Float32Array;\n    readonly pose: VRPose;\n    readonly rightProjectionMatrix: Float32Array;\n    readonly rightViewMatrix: Float32Array;\n    readonly timestamp: number;\n}\n\ndeclare var VRFrameData: {\n    prototype: VRFrameData;\n    new(): VRFrameData;\n};\n\n/** An interface of the WebVR API represents the state of a VR sensor at a given timestamp (which includes orientation, position, velocity, and acceleration information.) */\ninterface VRPose {\n    readonly angularAcceleration: Float32Array | null;\n    readonly angularVelocity: Float32Array | null;\n    readonly linearAcceleration: Float32Array | null;\n    readonly linearVelocity: Float32Array | null;\n    readonly orientation: Float32Array | null;\n    readonly position: Float32Array | null;\n    readonly timestamp: number;\n}\n\ndeclare var VRPose: {\n    prototype: VRPose;\n    new(): VRPose;\n};\n\ninterface VTTCue extends TextTrackCue {\n    align: AlignSetting;\n    line: LineAndPositionSetting;\n    lineAlign: LineAlignSetting;\n    position: LineAndPositionSetting;\n    positionAlign: PositionAlignSetting;\n    region: VTTRegion | null;\n    size: number;\n    snapToLines: boolean;\n    text: string;\n    vertical: DirectionSetting;\n    getCueAsHTML(): DocumentFragment;\n    addEventListener<K extends keyof TextTrackCueEventMap>(type: K, listener: (this: VTTCue, ev: TextTrackCueEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof TextTrackCueEventMap>(type: K, listener: (this: VTTCue, ev: TextTrackCueEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var VTTCue: {\n    prototype: VTTCue;\n    new(startTime: number, endTime: number, text: string): VTTCue;\n};\n\ninterface VTTRegion {\n    id: string;\n    lines: number;\n    regionAnchorX: number;\n    regionAnchorY: number;\n    scroll: ScrollSetting;\n    viewportAnchorX: number;\n    viewportAnchorY: number;\n    width: number;\n}\n\ndeclare var VTTRegion: {\n    prototype: VTTRegion;\n    new(): VTTRegion;\n};\n\n/** The validity states that an element can be in, with respect to constraint validation. Together, they help explain why an element\'s value fails to validate, if it\'s not valid. */\ninterface ValidityState {\n    readonly badInput: boolean;\n    readonly customError: boolean;\n    readonly patternMismatch: boolean;\n    readonly rangeOverflow: boolean;\n    readonly rangeUnderflow: boolean;\n    readonly stepMismatch: boolean;\n    readonly tooLong: boolean;\n    readonly tooShort: boolean;\n    readonly typeMismatch: boolean;\n    readonly valid: boolean;\n    readonly valueMissing: boolean;\n}\n\ndeclare var ValidityState: {\n    prototype: ValidityState;\n    new(): ValidityState;\n};\n\n/** Returned by the HTMLVideoElement.getVideoPlaybackQuality() method and contains metrics that can be used to determine the playback quality of a video. */\ninterface VideoPlaybackQuality {\n    readonly corruptedVideoFrames: number;\n    readonly creationTime: number;\n    readonly droppedVideoFrames: number;\n    readonly totalFrameDelay: number;\n    readonly totalVideoFrames: number;\n}\n\ndeclare var VideoPlaybackQuality: {\n    prototype: VideoPlaybackQuality;\n    new(): VideoPlaybackQuality;\n};\n\n/** A single video track from a <video> element. */\ninterface VideoTrack {\n    readonly id: string;\n    kind: string;\n    readonly label: string;\n    language: string;\n    selected: boolean;\n    readonly sourceBuffer: SourceBuffer | null;\n}\n\ndeclare var VideoTrack: {\n    prototype: VideoTrack;\n    new(): VideoTrack;\n};\n\ninterface VideoTrackListEventMap {\n    "addtrack": TrackEvent;\n    "change": Event;\n    "removetrack": TrackEvent;\n}\n\n/** Used to represent a list of the video tracks contained within a <video> element, with each track represented by a separate VideoTrack object in the list. */\ninterface VideoTrackList extends EventTarget {\n    readonly length: number;\n    onaddtrack: ((this: VideoTrackList, ev: TrackEvent) => any) | null;\n    onchange: ((this: VideoTrackList, ev: Event) => any) | null;\n    onremovetrack: ((this: VideoTrackList, ev: TrackEvent) => any) | null;\n    readonly selectedIndex: number;\n    getTrackById(id: string): VideoTrack | null;\n    item(index: number): VideoTrack;\n    addEventListener<K extends keyof VideoTrackListEventMap>(type: K, listener: (this: VideoTrackList, ev: VideoTrackListEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof VideoTrackListEventMap>(type: K, listener: (this: VideoTrackList, ev: VideoTrackListEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n    [index: number]: VideoTrack;\n}\n\ndeclare var VideoTrackList: {\n    prototype: VideoTrackList;\n    new(): VideoTrackList;\n};\n\ninterface WEBGL_color_buffer_float {\n    readonly FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT: GLenum;\n    readonly RGBA32F_EXT: GLenum;\n    readonly UNSIGNED_NORMALIZED_EXT: GLenum;\n}\n\ninterface WEBGL_compressed_texture_astc {\n    getSupportedProfiles(): string[];\n    readonly COMPRESSED_RGBA_ASTC_10x10_KHR: GLenum;\n    readonly COMPRESSED_RGBA_ASTC_10x5_KHR: GLenum;\n    readonly COMPRESSED_RGBA_ASTC_10x6_KHR: GLenum;\n    readonly COMPRESSED_RGBA_ASTC_10x8_KHR: GLenum;\n    readonly COMPRESSED_RGBA_ASTC_12x10_KHR: GLenum;\n    readonly COMPRESSED_RGBA_ASTC_12x12_KHR: GLenum;\n    readonly COMPRESSED_RGBA_ASTC_4x4_KHR: GLenum;\n    readonly COMPRESSED_RGBA_ASTC_5x4_KHR: GLenum;\n    readonly COMPRESSED_RGBA_ASTC_5x5_KHR: GLenum;\n    readonly COMPRESSED_RGBA_ASTC_6x5_KHR: GLenum;\n    readonly COMPRESSED_RGBA_ASTC_6x6_KHR: GLenum;\n    readonly COMPRESSED_RGBA_ASTC_8x5_KHR: GLenum;\n    readonly COMPRESSED_RGBA_ASTC_8x6_KHR: GLenum;\n    readonly COMPRESSED_RGBA_ASTC_8x8_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR: GLenum;\n    readonly COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR: GLenum;\n}\n\n/** The WEBGL_compressed_texture_s3tc extension is part of the WebGL API and exposes four S3TC compressed texture formats. */\ninterface WEBGL_compressed_texture_s3tc {\n    readonly COMPRESSED_RGBA_S3TC_DXT1_EXT: GLenum;\n    readonly COMPRESSED_RGBA_S3TC_DXT3_EXT: GLenum;\n    readonly COMPRESSED_RGBA_S3TC_DXT5_EXT: GLenum;\n    readonly COMPRESSED_RGB_S3TC_DXT1_EXT: GLenum;\n}\n\ninterface WEBGL_compressed_texture_s3tc_srgb {\n    readonly COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT: GLenum;\n    readonly COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT: GLenum;\n    readonly COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT: GLenum;\n    readonly COMPRESSED_SRGB_S3TC_DXT1_EXT: GLenum;\n}\n\n/** The WEBGL_debug_renderer_info extension is part of the WebGL API and exposes two constants with information about the graphics driver for debugging purposes. */\ninterface WEBGL_debug_renderer_info {\n    readonly UNMASKED_RENDERER_WEBGL: GLenum;\n    readonly UNMASKED_VENDOR_WEBGL: GLenum;\n}\n\ninterface WEBGL_debug_shaders {\n    getTranslatedShaderSource(shader: WebGLShader): string;\n}\n\n/** The WEBGL_depth_texture extension is part of the WebGL API and defines 2D depth and depth-stencil textures. */\ninterface WEBGL_depth_texture {\n    readonly UNSIGNED_INT_24_8_WEBGL: GLenum;\n}\n\ninterface WEBGL_draw_buffers {\n    drawBuffersWEBGL(buffers: GLenum[]): void;\n    readonly COLOR_ATTACHMENT0_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT10_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT11_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT12_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT13_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT14_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT15_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT1_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT2_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT3_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT4_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT5_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT6_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT7_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT8_WEBGL: GLenum;\n    readonly COLOR_ATTACHMENT9_WEBGL: GLenum;\n    readonly DRAW_BUFFER0_WEBGL: GLenum;\n    readonly DRAW_BUFFER10_WEBGL: GLenum;\n    readonly DRAW_BUFFER11_WEBGL: GLenum;\n    readonly DRAW_BUFFER12_WEBGL: GLenum;\n    readonly DRAW_BUFFER13_WEBGL: GLenum;\n    readonly DRAW_BUFFER14_WEBGL: GLenum;\n    readonly DRAW_BUFFER15_WEBGL: GLenum;\n    readonly DRAW_BUFFER1_WEBGL: GLenum;\n    readonly DRAW_BUFFER2_WEBGL: GLenum;\n    readonly DRAW_BUFFER3_WEBGL: GLenum;\n    readonly DRAW_BUFFER4_WEBGL: GLenum;\n    readonly DRAW_BUFFER5_WEBGL: GLenum;\n    readonly DRAW_BUFFER6_WEBGL: GLenum;\n    readonly DRAW_BUFFER7_WEBGL: GLenum;\n    readonly DRAW_BUFFER8_WEBGL: GLenum;\n    readonly DRAW_BUFFER9_WEBGL: GLenum;\n    readonly MAX_COLOR_ATTACHMENTS_WEBGL: GLenum;\n    readonly MAX_DRAW_BUFFERS_WEBGL: GLenum;\n}\n\ninterface WEBGL_lose_context {\n    loseContext(): void;\n    restoreContext(): void;\n}\n\n/** A WaveShaperNode always has exactly one input and one output. */\ninterface WaveShaperNode extends AudioNode {\n    curve: Float32Array | null;\n    oversample: OverSampleType;\n}\n\ndeclare var WaveShaperNode: {\n    prototype: WaveShaperNode;\n    new(context: BaseAudioContext, options?: WaveShaperOptions): WaveShaperNode;\n};\n\ninterface WebAuthentication {\n    getAssertion(assertionChallenge: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer | null, options?: AssertionOptions): Promise<WebAuthnAssertion>;\n    makeCredential(accountInformation: Account, cryptoParameters: ScopedCredentialParameters[], attestationChallenge: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer | null, options?: ScopedCredentialOptions): Promise<ScopedCredentialInfo>;\n}\n\ndeclare var WebAuthentication: {\n    prototype: WebAuthentication;\n    new(): WebAuthentication;\n};\n\ninterface WebAuthnAssertion {\n    readonly authenticatorData: ArrayBuffer;\n    readonly clientData: ArrayBuffer;\n    readonly credential: ScopedCredential;\n    readonly signature: ArrayBuffer;\n}\n\ndeclare var WebAuthnAssertion: {\n    prototype: WebAuthnAssertion;\n    new(): WebAuthnAssertion;\n};\n\n/** Part of the WebGL API and represents the information returned by calling the WebGLRenderingContext.getActiveAttrib() and WebGLRenderingContext.getActiveUniform() methods. */\ninterface WebGLActiveInfo {\n    readonly name: string;\n    readonly size: GLint;\n    readonly type: GLenum;\n}\n\ndeclare var WebGLActiveInfo: {\n    prototype: WebGLActiveInfo;\n    new(): WebGLActiveInfo;\n};\n\n/** Part of the WebGL API and represents an opaque buffer object storing data such as vertices or colors. */\ninterface WebGLBuffer extends WebGLObject {\n}\n\ndeclare var WebGLBuffer: {\n    prototype: WebGLBuffer;\n    new(): WebGLBuffer;\n};\n\n/** The WebContextEvent interface is part of the WebGL API and is an interface for an event that is generated in response to a status change to the WebGL rendering context. */\ninterface WebGLContextEvent extends Event {\n    readonly statusMessage: string;\n}\n\ndeclare var WebGLContextEvent: {\n    prototype: WebGLContextEvent;\n    new(type: string, eventInit?: WebGLContextEventInit): WebGLContextEvent;\n};\n\n/** Part of the WebGL API and represents a collection of buffers that serve as a rendering destination. */\ninterface WebGLFramebuffer extends WebGLObject {\n}\n\ndeclare var WebGLFramebuffer: {\n    prototype: WebGLFramebuffer;\n    new(): WebGLFramebuffer;\n};\n\ninterface WebGLObject {\n}\n\ndeclare var WebGLObject: {\n    prototype: WebGLObject;\n    new(): WebGLObject;\n};\n\n/** The WebGLProgram is part of the WebGL API and is a combination of two compiled WebGLShaders consisting of a vertex shader and a fragment shader (both written in GLSL). */\ninterface WebGLProgram extends WebGLObject {\n}\n\ndeclare var WebGLProgram: {\n    prototype: WebGLProgram;\n    new(): WebGLProgram;\n};\n\n/** Part of the WebGL API and represents a buffer that can contain an image, or can be source or target of an rendering operation. */\ninterface WebGLRenderbuffer extends WebGLObject {\n}\n\ndeclare var WebGLRenderbuffer: {\n    prototype: WebGLRenderbuffer;\n    new(): WebGLRenderbuffer;\n};\n\n/** Provides an interface to the OpenGL ES 2.0 graphics rendering context for the drawing surface of an HTML <canvas> element. */\ninterface WebGLRenderingContext extends WebGLRenderingContextBase {\n}\n\ndeclare var WebGLRenderingContext: {\n    prototype: WebGLRenderingContext;\n    new(): WebGLRenderingContext;\n    readonly ACTIVE_ATTRIBUTES: GLenum;\n    readonly ACTIVE_TEXTURE: GLenum;\n    readonly ACTIVE_UNIFORMS: GLenum;\n    readonly ALIASED_LINE_WIDTH_RANGE: GLenum;\n    readonly ALIASED_POINT_SIZE_RANGE: GLenum;\n    readonly ALPHA: GLenum;\n    readonly ALPHA_BITS: GLenum;\n    readonly ALWAYS: GLenum;\n    readonly ARRAY_BUFFER: GLenum;\n    readonly ARRAY_BUFFER_BINDING: GLenum;\n    readonly ATTACHED_SHADERS: GLenum;\n    readonly BACK: GLenum;\n    readonly BLEND: GLenum;\n    readonly BLEND_COLOR: GLenum;\n    readonly BLEND_DST_ALPHA: GLenum;\n    readonly BLEND_DST_RGB: GLenum;\n    readonly BLEND_EQUATION: GLenum;\n    readonly BLEND_EQUATION_ALPHA: GLenum;\n    readonly BLEND_EQUATION_RGB: GLenum;\n    readonly BLEND_SRC_ALPHA: GLenum;\n    readonly BLEND_SRC_RGB: GLenum;\n    readonly BLUE_BITS: GLenum;\n    readonly BOOL: GLenum;\n    readonly BOOL_VEC2: GLenum;\n    readonly BOOL_VEC3: GLenum;\n    readonly BOOL_VEC4: GLenum;\n    readonly BROWSER_DEFAULT_WEBGL: GLenum;\n    readonly BUFFER_SIZE: GLenum;\n    readonly BUFFER_USAGE: GLenum;\n    readonly BYTE: GLenum;\n    readonly CCW: GLenum;\n    readonly CLAMP_TO_EDGE: GLenum;\n    readonly COLOR_ATTACHMENT0: GLenum;\n    readonly COLOR_BUFFER_BIT: GLenum;\n    readonly COLOR_CLEAR_VALUE: GLenum;\n    readonly COLOR_WRITEMASK: GLenum;\n    readonly COMPILE_STATUS: GLenum;\n    readonly COMPRESSED_TEXTURE_FORMATS: GLenum;\n    readonly CONSTANT_ALPHA: GLenum;\n    readonly CONSTANT_COLOR: GLenum;\n    readonly CONTEXT_LOST_WEBGL: GLenum;\n    readonly CULL_FACE: GLenum;\n    readonly CULL_FACE_MODE: GLenum;\n    readonly CURRENT_PROGRAM: GLenum;\n    readonly CURRENT_VERTEX_ATTRIB: GLenum;\n    readonly CW: GLenum;\n    readonly DECR: GLenum;\n    readonly DECR_WRAP: GLenum;\n    readonly DELETE_STATUS: GLenum;\n    readonly DEPTH_ATTACHMENT: GLenum;\n    readonly DEPTH_BITS: GLenum;\n    readonly DEPTH_BUFFER_BIT: GLenum;\n    readonly DEPTH_CLEAR_VALUE: GLenum;\n    readonly DEPTH_COMPONENT: GLenum;\n    readonly DEPTH_COMPONENT16: GLenum;\n    readonly DEPTH_FUNC: GLenum;\n    readonly DEPTH_RANGE: GLenum;\n    readonly DEPTH_STENCIL: GLenum;\n    readonly DEPTH_STENCIL_ATTACHMENT: GLenum;\n    readonly DEPTH_TEST: GLenum;\n    readonly DEPTH_WRITEMASK: GLenum;\n    readonly DITHER: GLenum;\n    readonly DONT_CARE: GLenum;\n    readonly DST_ALPHA: GLenum;\n    readonly DST_COLOR: GLenum;\n    readonly DYNAMIC_DRAW: GLenum;\n    readonly ELEMENT_ARRAY_BUFFER: GLenum;\n    readonly ELEMENT_ARRAY_BUFFER_BINDING: GLenum;\n    readonly EQUAL: GLenum;\n    readonly FASTEST: GLenum;\n    readonly FLOAT: GLenum;\n    readonly FLOAT_MAT2: GLenum;\n    readonly FLOAT_MAT3: GLenum;\n    readonly FLOAT_MAT4: GLenum;\n    readonly FLOAT_VEC2: GLenum;\n    readonly FLOAT_VEC3: GLenum;\n    readonly FLOAT_VEC4: GLenum;\n    readonly FRAGMENT_SHADER: GLenum;\n    readonly FRAMEBUFFER: GLenum;\n    readonly FRAMEBUFFER_ATTACHMENT_OBJECT_NAME: GLenum;\n    readonly FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE: GLenum;\n    readonly FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE: GLenum;\n    readonly FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL: GLenum;\n    readonly FRAMEBUFFER_BINDING: GLenum;\n    readonly FRAMEBUFFER_COMPLETE: GLenum;\n    readonly FRAMEBUFFER_INCOMPLETE_ATTACHMENT: GLenum;\n    readonly FRAMEBUFFER_INCOMPLETE_DIMENSIONS: GLenum;\n    readonly FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT: GLenum;\n    readonly FRAMEBUFFER_UNSUPPORTED: GLenum;\n    readonly FRONT: GLenum;\n    readonly FRONT_AND_BACK: GLenum;\n    readonly FRONT_FACE: GLenum;\n    readonly FUNC_ADD: GLenum;\n    readonly FUNC_REVERSE_SUBTRACT: GLenum;\n    readonly FUNC_SUBTRACT: GLenum;\n    readonly GENERATE_MIPMAP_HINT: GLenum;\n    readonly GEQUAL: GLenum;\n    readonly GREATER: GLenum;\n    readonly GREEN_BITS: GLenum;\n    readonly HIGH_FLOAT: GLenum;\n    readonly HIGH_INT: GLenum;\n    readonly IMPLEMENTATION_COLOR_READ_FORMAT: GLenum;\n    readonly IMPLEMENTATION_COLOR_READ_TYPE: GLenum;\n    readonly INCR: GLenum;\n    readonly INCR_WRAP: GLenum;\n    readonly INT: GLenum;\n    readonly INT_VEC2: GLenum;\n    readonly INT_VEC3: GLenum;\n    readonly INT_VEC4: GLenum;\n    readonly INVALID_ENUM: GLenum;\n    readonly INVALID_FRAMEBUFFER_OPERATION: GLenum;\n    readonly INVALID_OPERATION: GLenum;\n    readonly INVALID_VALUE: GLenum;\n    readonly INVERT: GLenum;\n    readonly KEEP: GLenum;\n    readonly LEQUAL: GLenum;\n    readonly LESS: GLenum;\n    readonly LINEAR: GLenum;\n    readonly LINEAR_MIPMAP_LINEAR: GLenum;\n    readonly LINEAR_MIPMAP_NEAREST: GLenum;\n    readonly LINES: GLenum;\n    readonly LINE_LOOP: GLenum;\n    readonly LINE_STRIP: GLenum;\n    readonly LINE_WIDTH: GLenum;\n    readonly LINK_STATUS: GLenum;\n    readonly LOW_FLOAT: GLenum;\n    readonly LOW_INT: GLenum;\n    readonly LUMINANCE: GLenum;\n    readonly LUMINANCE_ALPHA: GLenum;\n    readonly MAX_COMBINED_TEXTURE_IMAGE_UNITS: GLenum;\n    readonly MAX_CUBE_MAP_TEXTURE_SIZE: GLenum;\n    readonly MAX_FRAGMENT_UNIFORM_VECTORS: GLenum;\n    readonly MAX_RENDERBUFFER_SIZE: GLenum;\n    readonly MAX_TEXTURE_IMAGE_UNITS: GLenum;\n    readonly MAX_TEXTURE_SIZE: GLenum;\n    readonly MAX_VARYING_VECTORS: GLenum;\n    readonly MAX_VERTEX_ATTRIBS: GLenum;\n    readonly MAX_VERTEX_TEXTURE_IMAGE_UNITS: GLenum;\n    readonly MAX_VERTEX_UNIFORM_VECTORS: GLenum;\n    readonly MAX_VIEWPORT_DIMS: GLenum;\n    readonly MEDIUM_FLOAT: GLenum;\n    readonly MEDIUM_INT: GLenum;\n    readonly MIRRORED_REPEAT: GLenum;\n    readonly NEAREST: GLenum;\n    readonly NEAREST_MIPMAP_LINEAR: GLenum;\n    readonly NEAREST_MIPMAP_NEAREST: GLenum;\n    readonly NEVER: GLenum;\n    readonly NICEST: GLenum;\n    readonly NONE: GLenum;\n    readonly NOTEQUAL: GLenum;\n    readonly NO_ERROR: GLenum;\n    readonly ONE: GLenum;\n    readonly ONE_MINUS_CONSTANT_ALPHA: GLenum;\n    readonly ONE_MINUS_CONSTANT_COLOR: GLenum;\n    readonly ONE_MINUS_DST_ALPHA: GLenum;\n    readonly ONE_MINUS_DST_COLOR: GLenum;\n    readonly ONE_MINUS_SRC_ALPHA: GLenum;\n    readonly ONE_MINUS_SRC_COLOR: GLenum;\n    readonly OUT_OF_MEMORY: GLenum;\n    readonly PACK_ALIGNMENT: GLenum;\n    readonly POINTS: GLenum;\n    readonly POLYGON_OFFSET_FACTOR: GLenum;\n    readonly POLYGON_OFFSET_FILL: GLenum;\n    readonly POLYGON_OFFSET_UNITS: GLenum;\n    readonly RED_BITS: GLenum;\n    readonly RENDERBUFFER: GLenum;\n    readonly RENDERBUFFER_ALPHA_SIZE: GLenum;\n    readonly RENDERBUFFER_BINDING: GLenum;\n    readonly RENDERBUFFER_BLUE_SIZE: GLenum;\n    readonly RENDERBUFFER_DEPTH_SIZE: GLenum;\n    readonly RENDERBUFFER_GREEN_SIZE: GLenum;\n    readonly RENDERBUFFER_HEIGHT: GLenum;\n    readonly RENDERBUFFER_INTERNAL_FORMAT: GLenum;\n    readonly RENDERBUFFER_RED_SIZE: GLenum;\n    readonly RENDERBUFFER_STENCIL_SIZE: GLenum;\n    readonly RENDERBUFFER_WIDTH: GLenum;\n    readonly RENDERER: GLenum;\n    readonly REPEAT: GLenum;\n    readonly REPLACE: GLenum;\n    readonly RGB: GLenum;\n    readonly RGB565: GLenum;\n    readonly RGB5_A1: GLenum;\n    readonly RGBA: GLenum;\n    readonly RGBA4: GLenum;\n    readonly SAMPLER_2D: GLenum;\n    readonly SAMPLER_CUBE: GLenum;\n    readonly SAMPLES: GLenum;\n    readonly SAMPLE_ALPHA_TO_COVERAGE: GLenum;\n    readonly SAMPLE_BUFFERS: GLenum;\n    readonly SAMPLE_COVERAGE: GLenum;\n    readonly SAMPLE_COVERAGE_INVERT: GLenum;\n    readonly SAMPLE_COVERAGE_VALUE: GLenum;\n    readonly SCISSOR_BOX: GLenum;\n    readonly SCISSOR_TEST: GLenum;\n    readonly SHADER_TYPE: GLenum;\n    readonly SHADING_LANGUAGE_VERSION: GLenum;\n    readonly SHORT: GLenum;\n    readonly SRC_ALPHA: GLenum;\n    readonly SRC_ALPHA_SATURATE: GLenum;\n    readonly SRC_COLOR: GLenum;\n    readonly STATIC_DRAW: GLenum;\n    readonly STENCIL_ATTACHMENT: GLenum;\n    readonly STENCIL_BACK_FAIL: GLenum;\n    readonly STENCIL_BACK_FUNC: GLenum;\n    readonly STENCIL_BACK_PASS_DEPTH_FAIL: GLenum;\n    readonly STENCIL_BACK_PASS_DEPTH_PASS: GLenum;\n    readonly STENCIL_BACK_REF: GLenum;\n    readonly STENCIL_BACK_VALUE_MASK: GLenum;\n    readonly STENCIL_BACK_WRITEMASK: GLenum;\n    readonly STENCIL_BITS: GLenum;\n    readonly STENCIL_BUFFER_BIT: GLenum;\n    readonly STENCIL_CLEAR_VALUE: GLenum;\n    readonly STENCIL_FAIL: GLenum;\n    readonly STENCIL_FUNC: GLenum;\n    readonly STENCIL_INDEX8: GLenum;\n    readonly STENCIL_PASS_DEPTH_FAIL: GLenum;\n    readonly STENCIL_PASS_DEPTH_PASS: GLenum;\n    readonly STENCIL_REF: GLenum;\n    readonly STENCIL_TEST: GLenum;\n    readonly STENCIL_VALUE_MASK: GLenum;\n    readonly STENCIL_WRITEMASK: GLenum;\n    readonly STREAM_DRAW: GLenum;\n    readonly SUBPIXEL_BITS: GLenum;\n    readonly TEXTURE: GLenum;\n    readonly TEXTURE0: GLenum;\n    readonly TEXTURE1: GLenum;\n    readonly TEXTURE10: GLenum;\n    readonly TEXTURE11: GLenum;\n    readonly TEXTURE12: GLenum;\n    readonly TEXTURE13: GLenum;\n    readonly TEXTURE14: GLenum;\n    readonly TEXTURE15: GLenum;\n    readonly TEXTURE16: GLenum;\n    readonly TEXTURE17: GLenum;\n    readonly TEXTURE18: GLenum;\n    readonly TEXTURE19: GLenum;\n    readonly TEXTURE2: GLenum;\n    readonly TEXTURE20: GLenum;\n    readonly TEXTURE21: GLenum;\n    readonly TEXTURE22: GLenum;\n    readonly TEXTURE23: GLenum;\n    readonly TEXTURE24: GLenum;\n    readonly TEXTURE25: GLenum;\n    readonly TEXTURE26: GLenum;\n    readonly TEXTURE27: GLenum;\n    readonly TEXTURE28: GLenum;\n    readonly TEXTURE29: GLenum;\n    readonly TEXTURE3: GLenum;\n    readonly TEXTURE30: GLenum;\n    readonly TEXTURE31: GLenum;\n    readonly TEXTURE4: GLenum;\n    readonly TEXTURE5: GLenum;\n    readonly TEXTURE6: GLenum;\n    readonly TEXTURE7: GLenum;\n    readonly TEXTURE8: GLenum;\n    readonly TEXTURE9: GLenum;\n    readonly TEXTURE_2D: GLenum;\n    readonly TEXTURE_BINDING_2D: GLenum;\n    readonly TEXTURE_BINDING_CUBE_MAP: GLenum;\n    readonly TEXTURE_CUBE_MAP: GLenum;\n    readonly TEXTURE_CUBE_MAP_NEGATIVE_X: GLenum;\n    readonly TEXTURE_CUBE_MAP_NEGATIVE_Y: GLenum;\n    readonly TEXTURE_CUBE_MAP_NEGATIVE_Z: GLenum;\n    readonly TEXTURE_CUBE_MAP_POSITIVE_X: GLenum;\n    readonly TEXTURE_CUBE_MAP_POSITIVE_Y: GLenum;\n    readonly TEXTURE_CUBE_MAP_POSITIVE_Z: GLenum;\n    readonly TEXTURE_MAG_FILTER: GLenum;\n    readonly TEXTURE_MIN_FILTER: GLenum;\n    readonly TEXTURE_WRAP_S: GLenum;\n    readonly TEXTURE_WRAP_T: GLenum;\n    readonly TRIANGLES: GLenum;\n    readonly TRIANGLE_FAN: GLenum;\n    readonly TRIANGLE_STRIP: GLenum;\n    readonly UNPACK_ALIGNMENT: GLenum;\n    readonly UNPACK_COLORSPACE_CONVERSION_WEBGL: GLenum;\n    readonly UNPACK_FLIP_Y_WEBGL: GLenum;\n    readonly UNPACK_PREMULTIPLY_ALPHA_WEBGL: GLenum;\n    readonly UNSIGNED_BYTE: GLenum;\n    readonly UNSIGNED_INT: GLenum;\n    readonly UNSIGNED_SHORT: GLenum;\n    readonly UNSIGNED_SHORT_4_4_4_4: GLenum;\n    readonly UNSIGNED_SHORT_5_5_5_1: GLenum;\n    readonly UNSIGNED_SHORT_5_6_5: GLenum;\n    readonly VALIDATE_STATUS: GLenum;\n    readonly VENDOR: GLenum;\n    readonly VERSION: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_BUFFER_BINDING: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_ENABLED: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_NORMALIZED: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_POINTER: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_SIZE: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_STRIDE: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_TYPE: GLenum;\n    readonly VERTEX_SHADER: GLenum;\n    readonly VIEWPORT: GLenum;\n    readonly ZERO: GLenum;\n};\n\ninterface WebGLRenderingContextBase {\n    readonly canvas: HTMLCanvasElement;\n    readonly drawingBufferHeight: GLsizei;\n    readonly drawingBufferWidth: GLsizei;\n    activeTexture(texture: GLenum): void;\n    attachShader(program: WebGLProgram, shader: WebGLShader): void;\n    bindAttribLocation(program: WebGLProgram, index: GLuint, name: string): void;\n    bindBuffer(target: GLenum, buffer: WebGLBuffer | null): void;\n    bindFramebuffer(target: GLenum, framebuffer: WebGLFramebuffer | null): void;\n    bindRenderbuffer(target: GLenum, renderbuffer: WebGLRenderbuffer | null): void;\n    bindTexture(target: GLenum, texture: WebGLTexture | null): void;\n    blendColor(red: GLclampf, green: GLclampf, blue: GLclampf, alpha: GLclampf): void;\n    blendEquation(mode: GLenum): void;\n    blendEquationSeparate(modeRGB: GLenum, modeAlpha: GLenum): void;\n    blendFunc(sfactor: GLenum, dfactor: GLenum): void;\n    blendFuncSeparate(srcRGB: GLenum, dstRGB: GLenum, srcAlpha: GLenum, dstAlpha: GLenum): void;\n    bufferData(target: GLenum, size: GLsizeiptr, usage: GLenum): void;\n    bufferData(target: GLenum, data: BufferSource | null, usage: GLenum): void;\n    bufferSubData(target: GLenum, offset: GLintptr, data: BufferSource): void;\n    checkFramebufferStatus(target: GLenum): GLenum;\n    clear(mask: GLbitfield): void;\n    clearColor(red: GLclampf, green: GLclampf, blue: GLclampf, alpha: GLclampf): void;\n    clearDepth(depth: GLclampf): void;\n    clearStencil(s: GLint): void;\n    colorMask(red: GLboolean, green: GLboolean, blue: GLboolean, alpha: GLboolean): void;\n    compileShader(shader: WebGLShader): void;\n    compressedTexImage2D(target: GLenum, level: GLint, internalformat: GLenum, width: GLsizei, height: GLsizei, border: GLint, data: ArrayBufferView): void;\n    compressedTexSubImage2D(target: GLenum, level: GLint, xoffset: GLint, yoffset: GLint, width: GLsizei, height: GLsizei, format: GLenum, data: ArrayBufferView): void;\n    copyTexImage2D(target: GLenum, level: GLint, internalformat: GLenum, x: GLint, y: GLint, width: GLsizei, height: GLsizei, border: GLint): void;\n    copyTexSubImage2D(target: GLenum, level: GLint, xoffset: GLint, yoffset: GLint, x: GLint, y: GLint, width: GLsizei, height: GLsizei): void;\n    createBuffer(): WebGLBuffer | null;\n    createFramebuffer(): WebGLFramebuffer | null;\n    createProgram(): WebGLProgram | null;\n    createRenderbuffer(): WebGLRenderbuffer | null;\n    createShader(type: GLenum): WebGLShader | null;\n    createTexture(): WebGLTexture | null;\n    cullFace(mode: GLenum): void;\n    deleteBuffer(buffer: WebGLBuffer | null): void;\n    deleteFramebuffer(framebuffer: WebGLFramebuffer | null): void;\n    deleteProgram(program: WebGLProgram | null): void;\n    deleteRenderbuffer(renderbuffer: WebGLRenderbuffer | null): void;\n    deleteShader(shader: WebGLShader | null): void;\n    deleteTexture(texture: WebGLTexture | null): void;\n    depthFunc(func: GLenum): void;\n    depthMask(flag: GLboolean): void;\n    depthRange(zNear: GLclampf, zFar: GLclampf): void;\n    detachShader(program: WebGLProgram, shader: WebGLShader): void;\n    disable(cap: GLenum): void;\n    disableVertexAttribArray(index: GLuint): void;\n    drawArrays(mode: GLenum, first: GLint, count: GLsizei): void;\n    drawElements(mode: GLenum, count: GLsizei, type: GLenum, offset: GLintptr): void;\n    enable(cap: GLenum): void;\n    enableVertexAttribArray(index: GLuint): void;\n    finish(): void;\n    flush(): void;\n    framebufferRenderbuffer(target: GLenum, attachment: GLenum, renderbuffertarget: GLenum, renderbuffer: WebGLRenderbuffer | null): void;\n    framebufferTexture2D(target: GLenum, attachment: GLenum, textarget: GLenum, texture: WebGLTexture | null, level: GLint): void;\n    frontFace(mode: GLenum): void;\n    generateMipmap(target: GLenum): void;\n    getActiveAttrib(program: WebGLProgram, index: GLuint): WebGLActiveInfo | null;\n    getActiveUniform(program: WebGLProgram, index: GLuint): WebGLActiveInfo | null;\n    getAttachedShaders(program: WebGLProgram): WebGLShader[] | null;\n    getAttribLocation(program: WebGLProgram, name: string): GLint;\n    getBufferParameter(target: GLenum, pname: GLenum): any;\n    getContextAttributes(): WebGLContextAttributes | null;\n    getError(): GLenum;\n    getExtension(extensionName: "EXT_blend_minmax"): EXT_blend_minmax | null;\n    getExtension(extensionName: "EXT_texture_filter_anisotropic"): EXT_texture_filter_anisotropic | null;\n    getExtension(extensionName: "EXT_frag_depth"): EXT_frag_depth | null;\n    getExtension(extensionName: "EXT_shader_texture_lod"): EXT_shader_texture_lod | null;\n    getExtension(extensionName: "EXT_sRGB"): EXT_sRGB | null;\n    getExtension(extensionName: "OES_vertex_array_object"): OES_vertex_array_object | null;\n    getExtension(extensionName: "WEBGL_color_buffer_float"): WEBGL_color_buffer_float | null;\n    getExtension(extensionName: "WEBGL_compressed_texture_astc"): WEBGL_compressed_texture_astc | null;\n    getExtension(extensionName: "WEBGL_compressed_texture_s3tc_srgb"): WEBGL_compressed_texture_s3tc_srgb | null;\n    getExtension(extensionName: "WEBGL_debug_shaders"): WEBGL_debug_shaders | null;\n    getExtension(extensionName: "WEBGL_draw_buffers"): WEBGL_draw_buffers | null;\n    getExtension(extensionName: "WEBGL_lose_context"): WEBGL_lose_context | null;\n    getExtension(extensionName: "WEBGL_depth_texture"): WEBGL_depth_texture | null;\n    getExtension(extensionName: "WEBGL_debug_renderer_info"): WEBGL_debug_renderer_info | null;\n    getExtension(extensionName: "WEBGL_compressed_texture_s3tc"): WEBGL_compressed_texture_s3tc | null;\n    getExtension(extensionName: "OES_texture_half_float_linear"): OES_texture_half_float_linear | null;\n    getExtension(extensionName: "OES_texture_half_float"): OES_texture_half_float | null;\n    getExtension(extensionName: "OES_texture_float_linear"): OES_texture_float_linear | null;\n    getExtension(extensionName: "OES_texture_float"): OES_texture_float | null;\n    getExtension(extensionName: "OES_standard_derivatives"): OES_standard_derivatives | null;\n    getExtension(extensionName: "OES_element_index_uint"): OES_element_index_uint | null;\n    getExtension(extensionName: "ANGLE_instanced_arrays"): ANGLE_instanced_arrays | null;\n    getExtension(extensionName: string): any;\n    getFramebufferAttachmentParameter(target: GLenum, attachment: GLenum, pname: GLenum): any;\n    getParameter(pname: GLenum): any;\n    getProgramInfoLog(program: WebGLProgram): string | null;\n    getProgramParameter(program: WebGLProgram, pname: GLenum): any;\n    getRenderbufferParameter(target: GLenum, pname: GLenum): any;\n    getShaderInfoLog(shader: WebGLShader): string | null;\n    getShaderParameter(shader: WebGLShader, pname: GLenum): any;\n    getShaderPrecisionFormat(shadertype: GLenum, precisiontype: GLenum): WebGLShaderPrecisionFormat | null;\n    getShaderSource(shader: WebGLShader): string | null;\n    getSupportedExtensions(): string[] | null;\n    getTexParameter(target: GLenum, pname: GLenum): any;\n    getUniform(program: WebGLProgram, location: WebGLUniformLocation): any;\n    getUniformLocation(program: WebGLProgram, name: string): WebGLUniformLocation | null;\n    getVertexAttrib(index: GLuint, pname: GLenum): any;\n    getVertexAttribOffset(index: GLuint, pname: GLenum): GLintptr;\n    hint(target: GLenum, mode: GLenum): void;\n    isBuffer(buffer: WebGLBuffer | null): GLboolean;\n    isContextLost(): boolean;\n    isEnabled(cap: GLenum): GLboolean;\n    isFramebuffer(framebuffer: WebGLFramebuffer | null): GLboolean;\n    isProgram(program: WebGLProgram | null): GLboolean;\n    isRenderbuffer(renderbuffer: WebGLRenderbuffer | null): GLboolean;\n    isShader(shader: WebGLShader | null): GLboolean;\n    isTexture(texture: WebGLTexture | null): GLboolean;\n    lineWidth(width: GLfloat): void;\n    linkProgram(program: WebGLProgram): void;\n    pixelStorei(pname: GLenum, param: GLint | GLboolean): void;\n    polygonOffset(factor: GLfloat, units: GLfloat): void;\n    readPixels(x: GLint, y: GLint, width: GLsizei, height: GLsizei, format: GLenum, type: GLenum, pixels: ArrayBufferView | null): void;\n    renderbufferStorage(target: GLenum, internalformat: GLenum, width: GLsizei, height: GLsizei): void;\n    sampleCoverage(value: GLclampf, invert: GLboolean): void;\n    scissor(x: GLint, y: GLint, width: GLsizei, height: GLsizei): void;\n    shaderSource(shader: WebGLShader, source: string): void;\n    stencilFunc(func: GLenum, ref: GLint, mask: GLuint): void;\n    stencilFuncSeparate(face: GLenum, func: GLenum, ref: GLint, mask: GLuint): void;\n    stencilMask(mask: GLuint): void;\n    stencilMaskSeparate(face: GLenum, mask: GLuint): void;\n    stencilOp(fail: GLenum, zfail: GLenum, zpass: GLenum): void;\n    stencilOpSeparate(face: GLenum, fail: GLenum, zfail: GLenum, zpass: GLenum): void;\n    texImage2D(target: GLenum, level: GLint, internalformat: GLint, width: GLsizei, height: GLsizei, border: GLint, format: GLenum, type: GLenum, pixels: ArrayBufferView | null): void;\n    texImage2D(target: GLenum, level: GLint, internalformat: GLint, format: GLenum, type: GLenum, source: TexImageSource): void;\n    texParameterf(target: GLenum, pname: GLenum, param: GLfloat): void;\n    texParameteri(target: GLenum, pname: GLenum, param: GLint): void;\n    texSubImage2D(target: GLenum, level: GLint, xoffset: GLint, yoffset: GLint, width: GLsizei, height: GLsizei, format: GLenum, type: GLenum, pixels: ArrayBufferView | null): void;\n    texSubImage2D(target: GLenum, level: GLint, xoffset: GLint, yoffset: GLint, format: GLenum, type: GLenum, source: TexImageSource): void;\n    uniform1f(location: WebGLUniformLocation | null, x: GLfloat): void;\n    uniform1fv(location: WebGLUniformLocation | null, v: Float32List): void;\n    uniform1i(location: WebGLUniformLocation | null, x: GLint): void;\n    uniform1iv(location: WebGLUniformLocation | null, v: Int32List): void;\n    uniform2f(location: WebGLUniformLocation | null, x: GLfloat, y: GLfloat): void;\n    uniform2fv(location: WebGLUniformLocation | null, v: Float32List): void;\n    uniform2i(location: WebGLUniformLocation | null, x: GLint, y: GLint): void;\n    uniform2iv(location: WebGLUniformLocation | null, v: Int32List): void;\n    uniform3f(location: WebGLUniformLocation | null, x: GLfloat, y: GLfloat, z: GLfloat): void;\n    uniform3fv(location: WebGLUniformLocation | null, v: Float32List): void;\n    uniform3i(location: WebGLUniformLocation | null, x: GLint, y: GLint, z: GLint): void;\n    uniform3iv(location: WebGLUniformLocation | null, v: Int32List): void;\n    uniform4f(location: WebGLUniformLocation | null, x: GLfloat, y: GLfloat, z: GLfloat, w: GLfloat): void;\n    uniform4fv(location: WebGLUniformLocation | null, v: Float32List): void;\n    uniform4i(location: WebGLUniformLocation | null, x: GLint, y: GLint, z: GLint, w: GLint): void;\n    uniform4iv(location: WebGLUniformLocation | null, v: Int32List): void;\n    uniformMatrix2fv(location: WebGLUniformLocation | null, transpose: GLboolean, value: Float32List): void;\n    uniformMatrix3fv(location: WebGLUniformLocation | null, transpose: GLboolean, value: Float32List): void;\n    uniformMatrix4fv(location: WebGLUniformLocation | null, transpose: GLboolean, value: Float32List): void;\n    useProgram(program: WebGLProgram | null): void;\n    validateProgram(program: WebGLProgram): void;\n    vertexAttrib1f(index: GLuint, x: GLfloat): void;\n    vertexAttrib1fv(index: GLuint, values: Float32List): void;\n    vertexAttrib2f(index: GLuint, x: GLfloat, y: GLfloat): void;\n    vertexAttrib2fv(index: GLuint, values: Float32List): void;\n    vertexAttrib3f(index: GLuint, x: GLfloat, y: GLfloat, z: GLfloat): void;\n    vertexAttrib3fv(index: GLuint, values: Float32List): void;\n    vertexAttrib4f(index: GLuint, x: GLfloat, y: GLfloat, z: GLfloat, w: GLfloat): void;\n    vertexAttrib4fv(index: GLuint, values: Float32List): void;\n    vertexAttribPointer(index: GLuint, size: GLint, type: GLenum, normalized: GLboolean, stride: GLsizei, offset: GLintptr): void;\n    viewport(x: GLint, y: GLint, width: GLsizei, height: GLsizei): void;\n    readonly ACTIVE_ATTRIBUTES: GLenum;\n    readonly ACTIVE_TEXTURE: GLenum;\n    readonly ACTIVE_UNIFORMS: GLenum;\n    readonly ALIASED_LINE_WIDTH_RANGE: GLenum;\n    readonly ALIASED_POINT_SIZE_RANGE: GLenum;\n    readonly ALPHA: GLenum;\n    readonly ALPHA_BITS: GLenum;\n    readonly ALWAYS: GLenum;\n    readonly ARRAY_BUFFER: GLenum;\n    readonly ARRAY_BUFFER_BINDING: GLenum;\n    readonly ATTACHED_SHADERS: GLenum;\n    readonly BACK: GLenum;\n    readonly BLEND: GLenum;\n    readonly BLEND_COLOR: GLenum;\n    readonly BLEND_DST_ALPHA: GLenum;\n    readonly BLEND_DST_RGB: GLenum;\n    readonly BLEND_EQUATION: GLenum;\n    readonly BLEND_EQUATION_ALPHA: GLenum;\n    readonly BLEND_EQUATION_RGB: GLenum;\n    readonly BLEND_SRC_ALPHA: GLenum;\n    readonly BLEND_SRC_RGB: GLenum;\n    readonly BLUE_BITS: GLenum;\n    readonly BOOL: GLenum;\n    readonly BOOL_VEC2: GLenum;\n    readonly BOOL_VEC3: GLenum;\n    readonly BOOL_VEC4: GLenum;\n    readonly BROWSER_DEFAULT_WEBGL: GLenum;\n    readonly BUFFER_SIZE: GLenum;\n    readonly BUFFER_USAGE: GLenum;\n    readonly BYTE: GLenum;\n    readonly CCW: GLenum;\n    readonly CLAMP_TO_EDGE: GLenum;\n    readonly COLOR_ATTACHMENT0: GLenum;\n    readonly COLOR_BUFFER_BIT: GLenum;\n    readonly COLOR_CLEAR_VALUE: GLenum;\n    readonly COLOR_WRITEMASK: GLenum;\n    readonly COMPILE_STATUS: GLenum;\n    readonly COMPRESSED_TEXTURE_FORMATS: GLenum;\n    readonly CONSTANT_ALPHA: GLenum;\n    readonly CONSTANT_COLOR: GLenum;\n    readonly CONTEXT_LOST_WEBGL: GLenum;\n    readonly CULL_FACE: GLenum;\n    readonly CULL_FACE_MODE: GLenum;\n    readonly CURRENT_PROGRAM: GLenum;\n    readonly CURRENT_VERTEX_ATTRIB: GLenum;\n    readonly CW: GLenum;\n    readonly DECR: GLenum;\n    readonly DECR_WRAP: GLenum;\n    readonly DELETE_STATUS: GLenum;\n    readonly DEPTH_ATTACHMENT: GLenum;\n    readonly DEPTH_BITS: GLenum;\n    readonly DEPTH_BUFFER_BIT: GLenum;\n    readonly DEPTH_CLEAR_VALUE: GLenum;\n    readonly DEPTH_COMPONENT: GLenum;\n    readonly DEPTH_COMPONENT16: GLenum;\n    readonly DEPTH_FUNC: GLenum;\n    readonly DEPTH_RANGE: GLenum;\n    readonly DEPTH_STENCIL: GLenum;\n    readonly DEPTH_STENCIL_ATTACHMENT: GLenum;\n    readonly DEPTH_TEST: GLenum;\n    readonly DEPTH_WRITEMASK: GLenum;\n    readonly DITHER: GLenum;\n    readonly DONT_CARE: GLenum;\n    readonly DST_ALPHA: GLenum;\n    readonly DST_COLOR: GLenum;\n    readonly DYNAMIC_DRAW: GLenum;\n    readonly ELEMENT_ARRAY_BUFFER: GLenum;\n    readonly ELEMENT_ARRAY_BUFFER_BINDING: GLenum;\n    readonly EQUAL: GLenum;\n    readonly FASTEST: GLenum;\n    readonly FLOAT: GLenum;\n    readonly FLOAT_MAT2: GLenum;\n    readonly FLOAT_MAT3: GLenum;\n    readonly FLOAT_MAT4: GLenum;\n    readonly FLOAT_VEC2: GLenum;\n    readonly FLOAT_VEC3: GLenum;\n    readonly FLOAT_VEC4: GLenum;\n    readonly FRAGMENT_SHADER: GLenum;\n    readonly FRAMEBUFFER: GLenum;\n    readonly FRAMEBUFFER_ATTACHMENT_OBJECT_NAME: GLenum;\n    readonly FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE: GLenum;\n    readonly FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE: GLenum;\n    readonly FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL: GLenum;\n    readonly FRAMEBUFFER_BINDING: GLenum;\n    readonly FRAMEBUFFER_COMPLETE: GLenum;\n    readonly FRAMEBUFFER_INCOMPLETE_ATTACHMENT: GLenum;\n    readonly FRAMEBUFFER_INCOMPLETE_DIMENSIONS: GLenum;\n    readonly FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT: GLenum;\n    readonly FRAMEBUFFER_UNSUPPORTED: GLenum;\n    readonly FRONT: GLenum;\n    readonly FRONT_AND_BACK: GLenum;\n    readonly FRONT_FACE: GLenum;\n    readonly FUNC_ADD: GLenum;\n    readonly FUNC_REVERSE_SUBTRACT: GLenum;\n    readonly FUNC_SUBTRACT: GLenum;\n    readonly GENERATE_MIPMAP_HINT: GLenum;\n    readonly GEQUAL: GLenum;\n    readonly GREATER: GLenum;\n    readonly GREEN_BITS: GLenum;\n    readonly HIGH_FLOAT: GLenum;\n    readonly HIGH_INT: GLenum;\n    readonly IMPLEMENTATION_COLOR_READ_FORMAT: GLenum;\n    readonly IMPLEMENTATION_COLOR_READ_TYPE: GLenum;\n    readonly INCR: GLenum;\n    readonly INCR_WRAP: GLenum;\n    readonly INT: GLenum;\n    readonly INT_VEC2: GLenum;\n    readonly INT_VEC3: GLenum;\n    readonly INT_VEC4: GLenum;\n    readonly INVALID_ENUM: GLenum;\n    readonly INVALID_FRAMEBUFFER_OPERATION: GLenum;\n    readonly INVALID_OPERATION: GLenum;\n    readonly INVALID_VALUE: GLenum;\n    readonly INVERT: GLenum;\n    readonly KEEP: GLenum;\n    readonly LEQUAL: GLenum;\n    readonly LESS: GLenum;\n    readonly LINEAR: GLenum;\n    readonly LINEAR_MIPMAP_LINEAR: GLenum;\n    readonly LINEAR_MIPMAP_NEAREST: GLenum;\n    readonly LINES: GLenum;\n    readonly LINE_LOOP: GLenum;\n    readonly LINE_STRIP: GLenum;\n    readonly LINE_WIDTH: GLenum;\n    readonly LINK_STATUS: GLenum;\n    readonly LOW_FLOAT: GLenum;\n    readonly LOW_INT: GLenum;\n    readonly LUMINANCE: GLenum;\n    readonly LUMINANCE_ALPHA: GLenum;\n    readonly MAX_COMBINED_TEXTURE_IMAGE_UNITS: GLenum;\n    readonly MAX_CUBE_MAP_TEXTURE_SIZE: GLenum;\n    readonly MAX_FRAGMENT_UNIFORM_VECTORS: GLenum;\n    readonly MAX_RENDERBUFFER_SIZE: GLenum;\n    readonly MAX_TEXTURE_IMAGE_UNITS: GLenum;\n    readonly MAX_TEXTURE_SIZE: GLenum;\n    readonly MAX_VARYING_VECTORS: GLenum;\n    readonly MAX_VERTEX_ATTRIBS: GLenum;\n    readonly MAX_VERTEX_TEXTURE_IMAGE_UNITS: GLenum;\n    readonly MAX_VERTEX_UNIFORM_VECTORS: GLenum;\n    readonly MAX_VIEWPORT_DIMS: GLenum;\n    readonly MEDIUM_FLOAT: GLenum;\n    readonly MEDIUM_INT: GLenum;\n    readonly MIRRORED_REPEAT: GLenum;\n    readonly NEAREST: GLenum;\n    readonly NEAREST_MIPMAP_LINEAR: GLenum;\n    readonly NEAREST_MIPMAP_NEAREST: GLenum;\n    readonly NEVER: GLenum;\n    readonly NICEST: GLenum;\n    readonly NONE: GLenum;\n    readonly NOTEQUAL: GLenum;\n    readonly NO_ERROR: GLenum;\n    readonly ONE: GLenum;\n    readonly ONE_MINUS_CONSTANT_ALPHA: GLenum;\n    readonly ONE_MINUS_CONSTANT_COLOR: GLenum;\n    readonly ONE_MINUS_DST_ALPHA: GLenum;\n    readonly ONE_MINUS_DST_COLOR: GLenum;\n    readonly ONE_MINUS_SRC_ALPHA: GLenum;\n    readonly ONE_MINUS_SRC_COLOR: GLenum;\n    readonly OUT_OF_MEMORY: GLenum;\n    readonly PACK_ALIGNMENT: GLenum;\n    readonly POINTS: GLenum;\n    readonly POLYGON_OFFSET_FACTOR: GLenum;\n    readonly POLYGON_OFFSET_FILL: GLenum;\n    readonly POLYGON_OFFSET_UNITS: GLenum;\n    readonly RED_BITS: GLenum;\n    readonly RENDERBUFFER: GLenum;\n    readonly RENDERBUFFER_ALPHA_SIZE: GLenum;\n    readonly RENDERBUFFER_BINDING: GLenum;\n    readonly RENDERBUFFER_BLUE_SIZE: GLenum;\n    readonly RENDERBUFFER_DEPTH_SIZE: GLenum;\n    readonly RENDERBUFFER_GREEN_SIZE: GLenum;\n    readonly RENDERBUFFER_HEIGHT: GLenum;\n    readonly RENDERBUFFER_INTERNAL_FORMAT: GLenum;\n    readonly RENDERBUFFER_RED_SIZE: GLenum;\n    readonly RENDERBUFFER_STENCIL_SIZE: GLenum;\n    readonly RENDERBUFFER_WIDTH: GLenum;\n    readonly RENDERER: GLenum;\n    readonly REPEAT: GLenum;\n    readonly REPLACE: GLenum;\n    readonly RGB: GLenum;\n    readonly RGB565: GLenum;\n    readonly RGB5_A1: GLenum;\n    readonly RGBA: GLenum;\n    readonly RGBA4: GLenum;\n    readonly SAMPLER_2D: GLenum;\n    readonly SAMPLER_CUBE: GLenum;\n    readonly SAMPLES: GLenum;\n    readonly SAMPLE_ALPHA_TO_COVERAGE: GLenum;\n    readonly SAMPLE_BUFFERS: GLenum;\n    readonly SAMPLE_COVERAGE: GLenum;\n    readonly SAMPLE_COVERAGE_INVERT: GLenum;\n    readonly SAMPLE_COVERAGE_VALUE: GLenum;\n    readonly SCISSOR_BOX: GLenum;\n    readonly SCISSOR_TEST: GLenum;\n    readonly SHADER_TYPE: GLenum;\n    readonly SHADING_LANGUAGE_VERSION: GLenum;\n    readonly SHORT: GLenum;\n    readonly SRC_ALPHA: GLenum;\n    readonly SRC_ALPHA_SATURATE: GLenum;\n    readonly SRC_COLOR: GLenum;\n    readonly STATIC_DRAW: GLenum;\n    readonly STENCIL_ATTACHMENT: GLenum;\n    readonly STENCIL_BACK_FAIL: GLenum;\n    readonly STENCIL_BACK_FUNC: GLenum;\n    readonly STENCIL_BACK_PASS_DEPTH_FAIL: GLenum;\n    readonly STENCIL_BACK_PASS_DEPTH_PASS: GLenum;\n    readonly STENCIL_BACK_REF: GLenum;\n    readonly STENCIL_BACK_VALUE_MASK: GLenum;\n    readonly STENCIL_BACK_WRITEMASK: GLenum;\n    readonly STENCIL_BITS: GLenum;\n    readonly STENCIL_BUFFER_BIT: GLenum;\n    readonly STENCIL_CLEAR_VALUE: GLenum;\n    readonly STENCIL_FAIL: GLenum;\n    readonly STENCIL_FUNC: GLenum;\n    readonly STENCIL_INDEX8: GLenum;\n    readonly STENCIL_PASS_DEPTH_FAIL: GLenum;\n    readonly STENCIL_PASS_DEPTH_PASS: GLenum;\n    readonly STENCIL_REF: GLenum;\n    readonly STENCIL_TEST: GLenum;\n    readonly STENCIL_VALUE_MASK: GLenum;\n    readonly STENCIL_WRITEMASK: GLenum;\n    readonly STREAM_DRAW: GLenum;\n    readonly SUBPIXEL_BITS: GLenum;\n    readonly TEXTURE: GLenum;\n    readonly TEXTURE0: GLenum;\n    readonly TEXTURE1: GLenum;\n    readonly TEXTURE10: GLenum;\n    readonly TEXTURE11: GLenum;\n    readonly TEXTURE12: GLenum;\n    readonly TEXTURE13: GLenum;\n    readonly TEXTURE14: GLenum;\n    readonly TEXTURE15: GLenum;\n    readonly TEXTURE16: GLenum;\n    readonly TEXTURE17: GLenum;\n    readonly TEXTURE18: GLenum;\n    readonly TEXTURE19: GLenum;\n    readonly TEXTURE2: GLenum;\n    readonly TEXTURE20: GLenum;\n    readonly TEXTURE21: GLenum;\n    readonly TEXTURE22: GLenum;\n    readonly TEXTURE23: GLenum;\n    readonly TEXTURE24: GLenum;\n    readonly TEXTURE25: GLenum;\n    readonly TEXTURE26: GLenum;\n    readonly TEXTURE27: GLenum;\n    readonly TEXTURE28: GLenum;\n    readonly TEXTURE29: GLenum;\n    readonly TEXTURE3: GLenum;\n    readonly TEXTURE30: GLenum;\n    readonly TEXTURE31: GLenum;\n    readonly TEXTURE4: GLenum;\n    readonly TEXTURE5: GLenum;\n    readonly TEXTURE6: GLenum;\n    readonly TEXTURE7: GLenum;\n    readonly TEXTURE8: GLenum;\n    readonly TEXTURE9: GLenum;\n    readonly TEXTURE_2D: GLenum;\n    readonly TEXTURE_BINDING_2D: GLenum;\n    readonly TEXTURE_BINDING_CUBE_MAP: GLenum;\n    readonly TEXTURE_CUBE_MAP: GLenum;\n    readonly TEXTURE_CUBE_MAP_NEGATIVE_X: GLenum;\n    readonly TEXTURE_CUBE_MAP_NEGATIVE_Y: GLenum;\n    readonly TEXTURE_CUBE_MAP_NEGATIVE_Z: GLenum;\n    readonly TEXTURE_CUBE_MAP_POSITIVE_X: GLenum;\n    readonly TEXTURE_CUBE_MAP_POSITIVE_Y: GLenum;\n    readonly TEXTURE_CUBE_MAP_POSITIVE_Z: GLenum;\n    readonly TEXTURE_MAG_FILTER: GLenum;\n    readonly TEXTURE_MIN_FILTER: GLenum;\n    readonly TEXTURE_WRAP_S: GLenum;\n    readonly TEXTURE_WRAP_T: GLenum;\n    readonly TRIANGLES: GLenum;\n    readonly TRIANGLE_FAN: GLenum;\n    readonly TRIANGLE_STRIP: GLenum;\n    readonly UNPACK_ALIGNMENT: GLenum;\n    readonly UNPACK_COLORSPACE_CONVERSION_WEBGL: GLenum;\n    readonly UNPACK_FLIP_Y_WEBGL: GLenum;\n    readonly UNPACK_PREMULTIPLY_ALPHA_WEBGL: GLenum;\n    readonly UNSIGNED_BYTE: GLenum;\n    readonly UNSIGNED_INT: GLenum;\n    readonly UNSIGNED_SHORT: GLenum;\n    readonly UNSIGNED_SHORT_4_4_4_4: GLenum;\n    readonly UNSIGNED_SHORT_5_5_5_1: GLenum;\n    readonly UNSIGNED_SHORT_5_6_5: GLenum;\n    readonly VALIDATE_STATUS: GLenum;\n    readonly VENDOR: GLenum;\n    readonly VERSION: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_BUFFER_BINDING: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_ENABLED: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_NORMALIZED: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_POINTER: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_SIZE: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_STRIDE: GLenum;\n    readonly VERTEX_ATTRIB_ARRAY_TYPE: GLenum;\n    readonly VERTEX_SHADER: GLenum;\n    readonly VIEWPORT: GLenum;\n    readonly ZERO: GLenum;\n}\n\n/** The WebGLShader is part of the WebGL API and can either be a vertex or a fragment shader. A WebGLProgram requires both types of shaders. */\ninterface WebGLShader extends WebGLObject {\n}\n\ndeclare var WebGLShader: {\n    prototype: WebGLShader;\n    new(): WebGLShader;\n};\n\n/** Part of the WebGL API and represents the information returned by calling the WebGLRenderingContext.getShaderPrecisionFormat() method. */\ninterface WebGLShaderPrecisionFormat {\n    readonly precision: GLint;\n    readonly rangeMax: GLint;\n    readonly rangeMin: GLint;\n}\n\ndeclare var WebGLShaderPrecisionFormat: {\n    prototype: WebGLShaderPrecisionFormat;\n    new(): WebGLShaderPrecisionFormat;\n};\n\n/** Part of the WebGL API and represents an opaque texture object providing storage and state for texturing operations. */\ninterface WebGLTexture extends WebGLObject {\n}\n\ndeclare var WebGLTexture: {\n    prototype: WebGLTexture;\n    new(): WebGLTexture;\n};\n\n/** Part of the WebGL API and represents the location of a uniform variable in a shader program. */\ninterface WebGLUniformLocation {\n}\n\ndeclare var WebGLUniformLocation: {\n    prototype: WebGLUniformLocation;\n    new(): WebGLUniformLocation;\n};\n\ninterface WebGLVertexArrayObjectOES extends WebGLObject {\n}\n\ninterface WebKitPoint {\n    x: number;\n    y: number;\n}\n\ndeclare var WebKitPoint: {\n    prototype: WebKitPoint;\n    new(x?: number, y?: number): WebKitPoint;\n};\n\ninterface WebSocketEventMap {\n    "close": CloseEvent;\n    "error": Event;\n    "message": MessageEvent;\n    "open": Event;\n}\n\n/** Provides the API for creating and managing a WebSocket connection to a server, as well as for sending and receiving data on the connection. */\ninterface WebSocket extends EventTarget {\n    binaryType: BinaryType;\n    readonly bufferedAmount: number;\n    readonly extensions: string;\n    onclose: ((this: WebSocket, ev: CloseEvent) => any) | null;\n    onerror: ((this: WebSocket, ev: Event) => any) | null;\n    onmessage: ((this: WebSocket, ev: MessageEvent) => any) | null;\n    onopen: ((this: WebSocket, ev: Event) => any) | null;\n    readonly protocol: string;\n    readonly readyState: number;\n    readonly url: string;\n    close(code?: number, reason?: string): void;\n    send(data: string | ArrayBufferLike | Blob | ArrayBufferView): void;\n    readonly CLOSED: number;\n    readonly CLOSING: number;\n    readonly CONNECTING: number;\n    readonly OPEN: number;\n    addEventListener<K extends keyof WebSocketEventMap>(type: K, listener: (this: WebSocket, ev: WebSocketEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof WebSocketEventMap>(type: K, listener: (this: WebSocket, ev: WebSocketEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var WebSocket: {\n    prototype: WebSocket;\n    new(url: string, protocols?: string | string[]): WebSocket;\n    readonly CLOSED: number;\n    readonly CLOSING: number;\n    readonly CONNECTING: number;\n    readonly OPEN: number;\n};\n\n/** Events that occur due to the user moving a mouse wheel or similar input device. */\ninterface WheelEvent extends MouseEvent {\n    readonly deltaMode: number;\n    readonly deltaX: number;\n    readonly deltaY: number;\n    readonly deltaZ: number;\n    getCurrentPoint(element: Element): void;\n    initWheelEvent(typeArg: string, canBubbleArg: boolean, cancelableArg: boolean, viewArg: Window, detailArg: number, screenXArg: number, screenYArg: number, clientXArg: number, clientYArg: number, buttonArg: number, relatedTargetArg: EventTarget, modifiersListArg: string, deltaXArg: number, deltaYArg: number, deltaZArg: number, deltaMode: number): void;\n    readonly DOM_DELTA_LINE: number;\n    readonly DOM_DELTA_PAGE: number;\n    readonly DOM_DELTA_PIXEL: number;\n}\n\ndeclare var WheelEvent: {\n    prototype: WheelEvent;\n    new(typeArg: string, eventInitDict?: WheelEventInit): WheelEvent;\n    readonly DOM_DELTA_LINE: number;\n    readonly DOM_DELTA_PAGE: number;\n    readonly DOM_DELTA_PIXEL: number;\n};\n\ninterface WindowEventMap extends GlobalEventHandlersEventMap, WindowEventHandlersEventMap {\n    "abort": UIEvent;\n    "afterprint": Event;\n    "beforeprint": Event;\n    "beforeunload": BeforeUnloadEvent;\n    "blur": FocusEvent;\n    "canplay": Event;\n    "canplaythrough": Event;\n    "change": Event;\n    "click": MouseEvent;\n    "compassneedscalibration": Event;\n    "contextmenu": MouseEvent;\n    "dblclick": MouseEvent;\n    "devicelight": DeviceLightEvent;\n    "devicemotion": DeviceMotionEvent;\n    "deviceorientation": DeviceOrientationEvent;\n    "deviceorientationabsolute": DeviceOrientationEvent;\n    "drag": DragEvent;\n    "dragend": DragEvent;\n    "dragenter": DragEvent;\n    "dragleave": DragEvent;\n    "dragover": DragEvent;\n    "dragstart": DragEvent;\n    "drop": DragEvent;\n    "durationchange": Event;\n    "emptied": Event;\n    "ended": Event;\n    "error": ErrorEvent;\n    "focus": FocusEvent;\n    "hashchange": HashChangeEvent;\n    "input": Event;\n    "invalid": Event;\n    "keydown": KeyboardEvent;\n    "keypress": KeyboardEvent;\n    "keyup": KeyboardEvent;\n    "load": Event;\n    "loadeddata": Event;\n    "loadedmetadata": Event;\n    "loadstart": Event;\n    "message": MessageEvent;\n    "mousedown": MouseEvent;\n    "mouseenter": MouseEvent;\n    "mouseleave": MouseEvent;\n    "mousemove": MouseEvent;\n    "mouseout": MouseEvent;\n    "mouseover": MouseEvent;\n    "mouseup": MouseEvent;\n    "mousewheel": Event;\n    "MSGestureChange": Event;\n    "MSGestureDoubleTap": Event;\n    "MSGestureEnd": Event;\n    "MSGestureHold": Event;\n    "MSGestureStart": Event;\n    "MSGestureTap": Event;\n    "MSInertiaStart": Event;\n    "MSPointerCancel": Event;\n    "MSPointerDown": Event;\n    "MSPointerEnter": Event;\n    "MSPointerLeave": Event;\n    "MSPointerMove": Event;\n    "MSPointerOut": Event;\n    "MSPointerOver": Event;\n    "MSPointerUp": Event;\n    "offline": Event;\n    "online": Event;\n    "orientationchange": Event;\n    "pagehide": PageTransitionEvent;\n    "pageshow": PageTransitionEvent;\n    "pause": Event;\n    "play": Event;\n    "playing": Event;\n    "popstate": PopStateEvent;\n    "progress": ProgressEvent;\n    "ratechange": Event;\n    "readystatechange": ProgressEvent;\n    "reset": Event;\n    "resize": UIEvent;\n    "scroll": Event;\n    "seeked": Event;\n    "seeking": Event;\n    "select": Event;\n    "stalled": Event;\n    "storage": StorageEvent;\n    "submit": Event;\n    "suspend": Event;\n    "timeupdate": Event;\n    "unload": Event;\n    "volumechange": Event;\n    "vrdisplayactivate": Event;\n    "vrdisplayblur": Event;\n    "vrdisplayconnect": Event;\n    "vrdisplaydeactivate": Event;\n    "vrdisplaydisconnect": Event;\n    "vrdisplayfocus": Event;\n    "vrdisplaypointerrestricted": Event;\n    "vrdisplaypointerunrestricted": Event;\n    "vrdisplaypresentchange": Event;\n    "waiting": Event;\n}\n\n/** A window containing a DOM document; the document property points to the DOM document loaded in that window. */\ninterface Window extends EventTarget, WindowTimers, WindowSessionStorage, WindowLocalStorage, WindowConsole, GlobalEventHandlers, IDBEnvironment, WindowBase64, GlobalFetch, WindowOrWorkerGlobalScope, WindowEventHandlers {\n    Blob: typeof Blob;\n    TextDecoder: typeof TextDecoder;\n    TextEncoder: typeof TextEncoder;\n    URL: typeof URL;\n    URLSearchParams: typeof URLSearchParams;\n    readonly applicationCache: ApplicationCache;\n    readonly caches: CacheStorage;\n    readonly clientInformation: Navigator;\n    readonly closed: boolean;\n    readonly crypto: Crypto;\n    customElements: CustomElementRegistry;\n    defaultStatus: string;\n    readonly devicePixelRatio: number;\n    readonly doNotTrack: string;\n    readonly document: Document;\n    /** @deprecated */\n    readonly event: Event | undefined;\n    /** @deprecated */\n    readonly external: External;\n    readonly frameElement: Element;\n    readonly frames: Window;\n    readonly history: History;\n    readonly innerHeight: number;\n    readonly innerWidth: number;\n    readonly isSecureContext: boolean;\n    readonly length: number;\n    location: Location;\n    readonly locationbar: BarProp;\n    readonly menubar: BarProp;\n    readonly msContentScript: ExtensionScriptApis;\n    name: string;\n    readonly navigator: Navigator;\n    offscreenBuffering: string | boolean;\n    oncompassneedscalibration: ((this: Window, ev: Event) => any) | null;\n    ondevicelight: ((this: Window, ev: DeviceLightEvent) => any) | null;\n    ondevicemotion: ((this: Window, ev: DeviceMotionEvent) => any) | null;\n    ondeviceorientation: ((this: Window, ev: DeviceOrientationEvent) => any) | null;\n    ondeviceorientationabsolute: ((this: Window, ev: DeviceOrientationEvent) => any) | null;\n    onmousewheel: ((this: Window, ev: Event) => any) | null;\n    onmsgesturechange: ((this: Window, ev: Event) => any) | null;\n    onmsgesturedoubletap: ((this: Window, ev: Event) => any) | null;\n    onmsgestureend: ((this: Window, ev: Event) => any) | null;\n    onmsgesturehold: ((this: Window, ev: Event) => any) | null;\n    onmsgesturestart: ((this: Window, ev: Event) => any) | null;\n    onmsgesturetap: ((this: Window, ev: Event) => any) | null;\n    onmsinertiastart: ((this: Window, ev: Event) => any) | null;\n    onmspointercancel: ((this: Window, ev: Event) => any) | null;\n    onmspointerdown: ((this: Window, ev: Event) => any) | null;\n    onmspointerenter: ((this: Window, ev: Event) => any) | null;\n    onmspointerleave: ((this: Window, ev: Event) => any) | null;\n    onmspointermove: ((this: Window, ev: Event) => any) | null;\n    onmspointerout: ((this: Window, ev: Event) => any) | null;\n    onmspointerover: ((this: Window, ev: Event) => any) | null;\n    onmspointerup: ((this: Window, ev: Event) => any) | null;\n    /** @deprecated */\n    onorientationchange: ((this: Window, ev: Event) => any) | null;\n    onreadystatechange: ((this: Window, ev: ProgressEvent) => any) | null;\n    onvrdisplayactivate: ((this: Window, ev: Event) => any) | null;\n    onvrdisplayblur: ((this: Window, ev: Event) => any) | null;\n    onvrdisplayconnect: ((this: Window, ev: Event) => any) | null;\n    onvrdisplaydeactivate: ((this: Window, ev: Event) => any) | null;\n    onvrdisplaydisconnect: ((this: Window, ev: Event) => any) | null;\n    onvrdisplayfocus: ((this: Window, ev: Event) => any) | null;\n    onvrdisplaypointerrestricted: ((this: Window, ev: Event) => any) | null;\n    onvrdisplaypointerunrestricted: ((this: Window, ev: Event) => any) | null;\n    onvrdisplaypresentchange: ((this: Window, ev: Event) => any) | null;\n    opener: any;\n    /** @deprecated */\n    readonly orientation: string | number;\n    readonly outerHeight: number;\n    readonly outerWidth: number;\n    readonly pageXOffset: number;\n    readonly pageYOffset: number;\n    readonly parent: Window;\n    readonly performance: Performance;\n    readonly personalbar: BarProp;\n    readonly screen: Screen;\n    readonly screenLeft: number;\n    readonly screenTop: number;\n    readonly screenX: number;\n    readonly screenY: number;\n    readonly scrollX: number;\n    readonly scrollY: number;\n    readonly scrollbars: BarProp;\n    readonly self: Window;\n    readonly speechSynthesis: SpeechSynthesis;\n    status: string;\n    readonly statusbar: BarProp;\n    readonly styleMedia: StyleMedia;\n    readonly toolbar: BarProp;\n    readonly top: Window;\n    readonly window: Window;\n    alert(message?: any): void;\n    blur(): void;\n    cancelAnimationFrame(handle: number): void;\n    /** @deprecated */\n    captureEvents(): void;\n    close(): void;\n    confirm(message?: string): boolean;\n    departFocus(navigationReason: NavigationReason, origin: FocusNavigationOrigin): void;\n    focus(): void;\n    getComputedStyle(elt: Element, pseudoElt?: string | null): CSSStyleDeclaration;\n    getMatchedCSSRules(elt: Element, pseudoElt?: string | null): CSSRuleList;\n    getSelection(): Selection | null;\n    matchMedia(query: string): MediaQueryList;\n    moveBy(x: number, y: number): void;\n    moveTo(x: number, y: number): void;\n    msWriteProfilerMark(profilerMarkName: string): void;\n    open(url?: string, target?: string, features?: string, replace?: boolean): Window | null;\n    postMessage(message: any, targetOrigin: string, transfer?: Transferable[]): void;\n    print(): void;\n    prompt(message?: string, _default?: string): string | null;\n    /** @deprecated */\n    releaseEvents(): void;\n    requestAnimationFrame(callback: FrameRequestCallback): number;\n    resizeBy(x: number, y: number): void;\n    resizeTo(x: number, y: number): void;\n    scroll(options?: ScrollToOptions): void;\n    scroll(x: number, y: number): void;\n    scrollBy(options?: ScrollToOptions): void;\n    scrollBy(x: number, y: number): void;\n    scrollTo(options?: ScrollToOptions): void;\n    scrollTo(x: number, y: number): void;\n    stop(): void;\n    webkitCancelAnimationFrame(handle: number): void;\n    webkitConvertPointFromNodeToPage(node: Node, pt: WebKitPoint): WebKitPoint;\n    webkitConvertPointFromPageToNode(node: Node, pt: WebKitPoint): WebKitPoint;\n    webkitRequestAnimationFrame(callback: FrameRequestCallback): number;\n    addEventListener<K extends keyof WindowEventMap>(type: K, listener: (this: Window, ev: WindowEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof WindowEventMap>(type: K, listener: (this: Window, ev: WindowEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n    [index: number]: Window;\n}\n\ndeclare var Window: {\n    prototype: Window;\n    new(): Window;\n};\n\ninterface WindowBase64 {\n    atob(encodedString: string): string;\n    btoa(rawString: string): string;\n}\n\ninterface WindowConsole {\n    readonly console: Console;\n}\n\ninterface WindowEventHandlersEventMap {\n    "afterprint": Event;\n    "beforeprint": Event;\n    "beforeunload": BeforeUnloadEvent;\n    "hashchange": HashChangeEvent;\n    "languagechange": Event;\n    "message": MessageEvent;\n    "messageerror": MessageEvent;\n    "offline": Event;\n    "online": Event;\n    "pagehide": PageTransitionEvent;\n    "pageshow": PageTransitionEvent;\n    "popstate": PopStateEvent;\n    "rejectionhandled": Event;\n    "storage": StorageEvent;\n    "unhandledrejection": PromiseRejectionEvent;\n    "unload": Event;\n}\n\ninterface WindowEventHandlers {\n    onafterprint: ((this: WindowEventHandlers, ev: Event) => any) | null;\n    onbeforeprint: ((this: WindowEventHandlers, ev: Event) => any) | null;\n    onbeforeunload: ((this: WindowEventHandlers, ev: BeforeUnloadEvent) => any) | null;\n    onhashchange: ((this: WindowEventHandlers, ev: HashChangeEvent) => any) | null;\n    onlanguagechange: ((this: WindowEventHandlers, ev: Event) => any) | null;\n    onmessage: ((this: WindowEventHandlers, ev: MessageEvent) => any) | null;\n    onmessageerror: ((this: WindowEventHandlers, ev: MessageEvent) => any) | null;\n    onoffline: ((this: WindowEventHandlers, ev: Event) => any) | null;\n    ononline: ((this: WindowEventHandlers, ev: Event) => any) | null;\n    onpagehide: ((this: WindowEventHandlers, ev: PageTransitionEvent) => any) | null;\n    onpageshow: ((this: WindowEventHandlers, ev: PageTransitionEvent) => any) | null;\n    onpopstate: ((this: WindowEventHandlers, ev: PopStateEvent) => any) | null;\n    onrejectionhandled: ((this: WindowEventHandlers, ev: Event) => any) | null;\n    onstorage: ((this: WindowEventHandlers, ev: StorageEvent) => any) | null;\n    onunhandledrejection: ((this: WindowEventHandlers, ev: PromiseRejectionEvent) => any) | null;\n    onunload: ((this: WindowEventHandlers, ev: Event) => any) | null;\n    addEventListener<K extends keyof WindowEventHandlersEventMap>(type: K, listener: (this: WindowEventHandlers, ev: WindowEventHandlersEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof WindowEventHandlersEventMap>(type: K, listener: (this: WindowEventHandlers, ev: WindowEventHandlersEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ninterface WindowLocalStorage {\n    readonly localStorage: Storage;\n}\n\ninterface WindowOrWorkerGlobalScope {\n    readonly caches: CacheStorage;\n    readonly crypto: Crypto;\n    readonly indexedDB: IDBFactory;\n    readonly origin: string;\n    readonly performance: Performance;\n    atob(data: string): string;\n    btoa(data: string): string;\n    clearInterval(handle?: number): void;\n    clearTimeout(handle?: number): void;\n    createImageBitmap(image: ImageBitmapSource): Promise<ImageBitmap>;\n    createImageBitmap(image: ImageBitmapSource, sx: number, sy: number, sw: number, sh: number): Promise<ImageBitmap>;\n    fetch(input: RequestInfo, init?: RequestInit): Promise<Response>;\n    queueMicrotask(callback: Function): void;\n    setInterval(handler: TimerHandler, timeout?: number, ...arguments: any[]): number;\n    setTimeout(handler: TimerHandler, timeout?: number, ...arguments: any[]): number;\n}\n\ninterface WindowSessionStorage {\n    readonly sessionStorage: Storage;\n}\n\ninterface WindowTimers {\n}\n\ninterface WorkerEventMap extends AbstractWorkerEventMap {\n    "message": MessageEvent;\n}\n\n/** An interface of the Web Workers API represents a background task that can be easily created and can send messages back to its creator. Creating a worker is as simple as calling the Worker() constructor and specifying a script to be run in the worker thread. */\ninterface Worker extends EventTarget, AbstractWorker {\n    onmessage: ((this: Worker, ev: MessageEvent) => any) | null;\n    postMessage(message: any, transfer: Transferable[]): void;\n    postMessage(message: any, options?: PostMessageOptions): void;\n    terminate(): void;\n    addEventListener<K extends keyof WorkerEventMap>(type: K, listener: (this: Worker, ev: WorkerEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof WorkerEventMap>(type: K, listener: (this: Worker, ev: WorkerEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var Worker: {\n    prototype: Worker;\n    new(stringUrl: string | URL, options?: WorkerOptions): Worker;\n};\n\ninterface Worklet {\n    addModule(moduleURL: string, options?: WorkletOptions): Promise<void>;\n}\n\ndeclare var Worklet: {\n    prototype: Worklet;\n    new(): Worklet;\n};\n\n/** An interface of the Streams API provides a standard abstraction for writing streaming data to a destination, known as a sink. This object comes with built-in backpressure and queuing. */\ninterface WritableStream<W = any> {\n    readonly locked: boolean;\n    abort(reason?: any): Promise<void>;\n    getWriter(): WritableStreamDefaultWriter<W>;\n}\n\ndeclare var WritableStream: {\n    prototype: WritableStream;\n    new<W = any>(underlyingSink?: UnderlyingSink<W>, strategy?: QueuingStrategy<W>): WritableStream<W>;\n};\n\n/** An interface of the Streams API represents a controller allowing control of a WritableStream\'s state. When constructing a WritableStream, the underlying sink is given a corresponding WritableStreamDefaultController instance to manipulate. */\ninterface WritableStreamDefaultController {\n    error(error?: any): void;\n}\n\n/** An interface of the Streams API is the object returned by WritableStream.getWriter() and once created locks the < writer to the WritableStream ensuring that no other streams can write to the underlying sink. */\ninterface WritableStreamDefaultWriter<W = any> {\n    readonly closed: Promise<void>;\n    readonly desiredSize: number | null;\n    readonly ready: Promise<void>;\n    abort(reason?: any): Promise<void>;\n    close(): Promise<void>;\n    releaseLock(): void;\n    write(chunk: W): Promise<void>;\n}\n\n/** An XML document. It inherits from the generic Document and does not add any specific methods or properties to it: nevertheless, several algorithms behave differently with the two types of documents. */\ninterface XMLDocument extends Document {\n    addEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: XMLDocument, ev: DocumentEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof DocumentEventMap>(type: K, listener: (this: XMLDocument, ev: DocumentEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var XMLDocument: {\n    prototype: XMLDocument;\n    new(): XMLDocument;\n};\n\ninterface XMLHttpRequestEventMap extends XMLHttpRequestEventTargetEventMap {\n    "readystatechange": Event;\n}\n\n/** Use XMLHttpRequest (XHR) objects to interact with servers. You can retrieve data from a URL without having to do a full page refresh. This enables a Web page to update just part of a page without disrupting what the user is doing. */\ninterface XMLHttpRequest extends XMLHttpRequestEventTarget {\n    onreadystatechange: ((this: XMLHttpRequest, ev: Event) => any) | null;\n    /**\n     * Returns client\'s state.\n     */\n    readonly readyState: number;\n    /**\n     * Returns the response\'s body.\n     */\n    readonly response: any;\n    /**\n     * Returns the text response.\n     * Throws an "InvalidStateError" DOMException if responseType is not the empty string or "text".\n     */\n    readonly responseText: string;\n    /**\n     * Returns the response type.\n     * Can be set to change the response type. Values are:\n     * the empty string (default),\n     * "arraybuffer",\n     * "blob",\n     * "document",\n     * "json", and\n     * "text".\n     * When set: setting to "document" is ignored if current global object is not a Window object.\n     * When set: throws an "InvalidStateError" DOMException if state is loading or done.\n     * When set: throws an "InvalidAccessError" DOMException if the synchronous flag is set and current global object is a Window object.\n     */\n    responseType: XMLHttpRequestResponseType;\n    readonly responseURL: string;\n    /**\n     * Returns the document response.\n     * Throws an "InvalidStateError" DOMException if responseType is not the empty string or "document".\n     */\n    readonly responseXML: Document | null;\n    readonly status: number;\n    readonly statusText: string;\n    /**\n     * Can be set to a time in milliseconds. When set to a non-zero value will cause fetching to terminate after the given time has passed. When the time has passed, the\n     * request has not yet completed, and the synchronous flag is unset, a timeout event will then be dispatched, or a\n     * "TimeoutError" DOMException will be thrown otherwise (for the send() method).\n     * When set: throws an "InvalidAccessError" DOMException if the synchronous flag is set and current global object is a Window object.\n     */\n    timeout: number;\n    /**\n     * Returns the associated XMLHttpRequestUpload object. It can be used to gather transmission information when data is\n     * transferred to a server.\n     */\n    readonly upload: XMLHttpRequestUpload;\n    /**\n     * True when credentials are to be included in a cross-origin request. False when they are\n     * to be excluded in a cross-origin request and when cookies are to be ignored in its response.\n     * Initially false.\n     * When set: throws an "InvalidStateError" DOMException if state is not unsent or opened, or if the send() flag is set.\n     */\n    withCredentials: boolean;\n    /**\n     * Cancels any network activity.\n     */\n    abort(): void;\n    getAllResponseHeaders(): string;\n    getResponseHeader(name: string): string | null;\n    /**\n     * Sets the request method, request URL, and synchronous flag.\n     * Throws a "SyntaxError" DOMException if either method is not a\n     * valid HTTP method or url cannot be parsed.\n     * Throws a "SecurityError" DOMException if method is a\n     * case-insensitive match for `CONNECT`, `TRACE`, or `TRACK`.\n     * Throws an "InvalidAccessError" DOMException if async is false, current global object is a Window object, and the timeout attribute is not zero or the responseType attribute is not the empty string.\n     */\n    open(method: string, url: string): void;\n    open(method: string, url: string, async: boolean, username?: string | null, password?: string | null): void;\n    /**\n     * Acts as if the `Content-Type` header value for response is mime.\n     * (It does not actually change the header though.)\n     * Throws an "InvalidStateError" DOMException if state is loading or done.\n     */\n    overrideMimeType(mime: string): void;\n    /**\n     * Initiates the request. The body argument provides the request body, if any,\n     * and is ignored if the request method is GET or HEAD.\n     * Throws an "InvalidStateError" DOMException if either state is not opened or the send() flag is set.\n     */\n    send(body?: Document | BodyInit | null): void;\n    /**\n     * Combines a header in author request headers.\n     * Throws an "InvalidStateError" DOMException if either state is not opened or the send() flag is set.\n     * Throws a "SyntaxError" DOMException if name is not a header name\n     * or if value is not a header value.\n     */\n    setRequestHeader(name: string, value: string): void;\n    readonly DONE: number;\n    readonly HEADERS_RECEIVED: number;\n    readonly LOADING: number;\n    readonly OPENED: number;\n    readonly UNSENT: number;\n    addEventListener<K extends keyof XMLHttpRequestEventMap>(type: K, listener: (this: XMLHttpRequest, ev: XMLHttpRequestEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof XMLHttpRequestEventMap>(type: K, listener: (this: XMLHttpRequest, ev: XMLHttpRequestEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var XMLHttpRequest: {\n    prototype: XMLHttpRequest;\n    new(): XMLHttpRequest;\n    readonly DONE: number;\n    readonly HEADERS_RECEIVED: number;\n    readonly LOADING: number;\n    readonly OPENED: number;\n    readonly UNSENT: number;\n};\n\ninterface XMLHttpRequestEventTargetEventMap {\n    "abort": ProgressEvent;\n    "error": ProgressEvent;\n    "load": ProgressEvent;\n    "loadend": ProgressEvent;\n    "loadstart": ProgressEvent;\n    "progress": ProgressEvent;\n    "timeout": ProgressEvent;\n}\n\ninterface XMLHttpRequestEventTarget extends EventTarget {\n    onabort: ((this: XMLHttpRequest, ev: ProgressEvent) => any) | null;\n    onerror: ((this: XMLHttpRequest, ev: ProgressEvent) => any) | null;\n    onload: ((this: XMLHttpRequest, ev: ProgressEvent) => any) | null;\n    onloadend: ((this: XMLHttpRequest, ev: ProgressEvent) => any) | null;\n    onloadstart: ((this: XMLHttpRequest, ev: ProgressEvent) => any) | null;\n    onprogress: ((this: XMLHttpRequest, ev: ProgressEvent) => any) | null;\n    ontimeout: ((this: XMLHttpRequest, ev: ProgressEvent) => any) | null;\n    addEventListener<K extends keyof XMLHttpRequestEventTargetEventMap>(type: K, listener: (this: XMLHttpRequestEventTarget, ev: XMLHttpRequestEventTargetEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof XMLHttpRequestEventTargetEventMap>(type: K, listener: (this: XMLHttpRequestEventTarget, ev: XMLHttpRequestEventTargetEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var XMLHttpRequestEventTarget: {\n    prototype: XMLHttpRequestEventTarget;\n    new(): XMLHttpRequestEventTarget;\n};\n\ninterface XMLHttpRequestUpload extends XMLHttpRequestEventTarget {\n    addEventListener<K extends keyof XMLHttpRequestEventTargetEventMap>(type: K, listener: (this: XMLHttpRequestUpload, ev: XMLHttpRequestEventTargetEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof XMLHttpRequestEventTargetEventMap>(type: K, listener: (this: XMLHttpRequestUpload, ev: XMLHttpRequestEventTargetEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var XMLHttpRequestUpload: {\n    prototype: XMLHttpRequestUpload;\n    new(): XMLHttpRequestUpload;\n};\n\n/** Provides the serializeToString() method to construct an XML string representing a DOM tree. */\ninterface XMLSerializer {\n    serializeToString(root: Node): string;\n}\n\ndeclare var XMLSerializer: {\n    prototype: XMLSerializer;\n    new(): XMLSerializer;\n};\n\n/** The XPathEvaluator interface allows to compile and evaluate XPath expressions. */\ninterface XPathEvaluator extends XPathEvaluatorBase {\n}\n\ndeclare var XPathEvaluator: {\n    prototype: XPathEvaluator;\n    new(): XPathEvaluator;\n};\n\ninterface XPathEvaluatorBase {\n    createExpression(expression: string, resolver?: XPathNSResolver | null): XPathExpression;\n    createNSResolver(nodeResolver: Node): XPathNSResolver;\n    evaluate(expression: string, contextNode: Node, resolver?: XPathNSResolver | null, type?: number, result?: XPathResult | null): XPathResult;\n}\n\n/** This interface is a compiled XPath expression that can be evaluated on a document or specific node to return information its DOM tree. */\ninterface XPathExpression {\n    evaluate(contextNode: Node, type?: number, result?: XPathResult | null): XPathResult;\n}\n\ndeclare var XPathExpression: {\n    prototype: XPathExpression;\n    new(): XPathExpression;\n};\n\n/** The results generated by evaluating an XPath expression within the context of a given node. */\ninterface XPathResult {\n    readonly booleanValue: boolean;\n    readonly invalidIteratorState: boolean;\n    readonly numberValue: number;\n    readonly resultType: number;\n    readonly singleNodeValue: Node | null;\n    readonly snapshotLength: number;\n    readonly stringValue: string;\n    iterateNext(): Node | null;\n    snapshotItem(index: number): Node | null;\n    readonly ANY_TYPE: number;\n    readonly ANY_UNORDERED_NODE_TYPE: number;\n    readonly BOOLEAN_TYPE: number;\n    readonly FIRST_ORDERED_NODE_TYPE: number;\n    readonly NUMBER_TYPE: number;\n    readonly ORDERED_NODE_ITERATOR_TYPE: number;\n    readonly ORDERED_NODE_SNAPSHOT_TYPE: number;\n    readonly STRING_TYPE: number;\n    readonly UNORDERED_NODE_ITERATOR_TYPE: number;\n    readonly UNORDERED_NODE_SNAPSHOT_TYPE: number;\n}\n\ndeclare var XPathResult: {\n    prototype: XPathResult;\n    new(): XPathResult;\n    readonly ANY_TYPE: number;\n    readonly ANY_UNORDERED_NODE_TYPE: number;\n    readonly BOOLEAN_TYPE: number;\n    readonly FIRST_ORDERED_NODE_TYPE: number;\n    readonly NUMBER_TYPE: number;\n    readonly ORDERED_NODE_ITERATOR_TYPE: number;\n    readonly ORDERED_NODE_SNAPSHOT_TYPE: number;\n    readonly STRING_TYPE: number;\n    readonly UNORDERED_NODE_ITERATOR_TYPE: number;\n    readonly UNORDERED_NODE_SNAPSHOT_TYPE: number;\n};\n\n/** An XSLTProcessor applies an XSLT stylesheet transformation to an XML document to produce a new XML document as output. It has methods to load the XSLT stylesheet, to manipulate <xsl:param> parameter values, and to apply the transformation to documents. */\ninterface XSLTProcessor {\n    clearParameters(): void;\n    getParameter(namespaceURI: string, localName: string): any;\n    importStylesheet(style: Node): void;\n    removeParameter(namespaceURI: string, localName: string): void;\n    reset(): void;\n    setParameter(namespaceURI: string, localName: string, value: any): void;\n    transformToDocument(source: Node): Document;\n    transformToFragment(source: Node, document: Document): DocumentFragment;\n}\n\ndeclare var XSLTProcessor: {\n    prototype: XSLTProcessor;\n    new(): XSLTProcessor;\n};\n\ninterface webkitRTCPeerConnection extends RTCPeerConnection {\n    addEventListener<K extends keyof RTCPeerConnectionEventMap>(type: K, listener: (this: webkitRTCPeerConnection, ev: RTCPeerConnectionEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\n    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\n    removeEventListener<K extends keyof RTCPeerConnectionEventMap>(type: K, listener: (this: webkitRTCPeerConnection, ev: RTCPeerConnectionEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\n    removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\n}\n\ndeclare var webkitRTCPeerConnection: {\n    prototype: webkitRTCPeerConnection;\n    new(configuration: RTCConfiguration): webkitRTCPeerConnection;\n};\n\ndeclare type EventListenerOrEventListenerObject = EventListener | EventListenerObject;\n\ndeclare namespace WebAssembly {\n    interface CompileError {\n    }\n    \n    var CompileError: {\n        prototype: CompileError;\n        new(): CompileError;\n    };\n    \n    interface Global {\n        value: any;\n        valueOf(): any;\n    }\n    \n    var Global: {\n        prototype: Global;\n        new(descriptor: GlobalDescriptor, value?: any): Global;\n    };\n    \n    interface Instance {\n        readonly exports: any;\n    }\n    \n    var Instance: {\n        prototype: Instance;\n        new(module: Module, importObject?: any): Instance;\n    };\n    \n    interface LinkError {\n    }\n    \n    var LinkError: {\n        prototype: LinkError;\n        new(): LinkError;\n    };\n    \n    interface Memory {\n        readonly buffer: ArrayBuffer;\n        grow(delta: number): number;\n    }\n    \n    var Memory: {\n        prototype: Memory;\n        new(descriptor: MemoryDescriptor): Memory;\n    };\n    \n    interface Module {\n    }\n    \n    var Module: {\n        prototype: Module;\n        new(bytes: BufferSource): Module;\n        customSections(module: Module, sectionName: string): ArrayBuffer[];\n        exports(module: Module): ModuleExportDescriptor[];\n        imports(module: Module): ModuleImportDescriptor[];\n    };\n    \n    interface RuntimeError {\n    }\n    \n    var RuntimeError: {\n        prototype: RuntimeError;\n        new(): RuntimeError;\n    };\n    \n    interface Table {\n        readonly length: number;\n        get(index: number): Function | null;\n        grow(delta: number): number;\n        set(index: number, value: Function | null): void;\n    }\n    \n    var Table: {\n        prototype: Table;\n        new(descriptor: TableDescriptor): Table;\n    };\n    \n    interface GlobalDescriptor {\n        mutable?: boolean;\n        value: string;\n    }\n    \n    interface MemoryDescriptor {\n        initial: number;\n        maximum?: number;\n    }\n    \n    interface ModuleExportDescriptor {\n        kind: ImportExportKind;\n        name: string;\n    }\n    \n    interface ModuleImportDescriptor {\n        kind: ImportExportKind;\n        module: string;\n        name: string;\n    }\n    \n    interface TableDescriptor {\n        element: TableKind;\n        initial: number;\n        maximum?: number;\n    }\n    \n    interface WebAssemblyInstantiatedSource {\n        instance: Instance;\n        module: Module;\n    }\n    \n    type ImportExportKind = "function" | "table" | "memory" | "global";\n    type TableKind = "anyfunc";\n    function compile(bytes: BufferSource): Promise<Module>;\n    function instantiate(bytes: BufferSource, importObject?: any): Promise<WebAssemblyInstantiatedSource>;\n    function instantiate(moduleObject: Module, importObject?: any): Promise<Instance>;\n    function validate(bytes: BufferSource): boolean;\n}\n\ninterface BlobCallback {\n    (blob: Blob | null): void;\n}\n\ninterface DecodeErrorCallback {\n    (error: DOMException): void;\n}\n\ninterface DecodeSuccessCallback {\n    (decodedData: AudioBuffer): void;\n}\n\ninterface EventHandlerNonNull {\n    (event: Event): any;\n}\n\ninterface ForEachCallback {\n    (keyId: Int8Array | Int16Array | Int32Array | Uint8Array | Uint16Array | Uint32Array | Uint8ClampedArray | Float32Array | Float64Array | DataView | ArrayBuffer | null, status: MediaKeyStatus): void;\n}\n\ninterface FrameRequestCallback {\n    (time: number): void;\n}\n\ninterface FunctionStringCallback {\n    (data: string): void;\n}\n\ninterface IntersectionObserverCallback {\n    (entries: IntersectionObserverEntry[], observer: IntersectionObserver): void;\n}\n\ninterface MSLaunchUriCallback {\n    (): void;\n}\n\ninterface MutationCallback {\n    (mutations: MutationRecord[], observer: MutationObserver): void;\n}\n\ninterface NavigatorUserMediaErrorCallback {\n    (error: MediaStreamError): void;\n}\n\ninterface NavigatorUserMediaSuccessCallback {\n    (stream: MediaStream): void;\n}\n\ninterface NotificationPermissionCallback {\n    (permission: NotificationPermission): void;\n}\n\ninterface OnBeforeUnloadEventHandlerNonNull {\n    (event: Event): string | null;\n}\n\ninterface OnErrorEventHandlerNonNull {\n    (event: Event | string, source?: string, lineno?: number, colno?: number, error?: Error): any;\n}\n\ninterface PerformanceObserverCallback {\n    (entries: PerformanceObserverEntryList, observer: PerformanceObserver): void;\n}\n\ninterface PositionCallback {\n    (position: Position): void;\n}\n\ninterface PositionErrorCallback {\n    (positionError: PositionError): void;\n}\n\ninterface QueuingStrategySizeCallback<T = any> {\n    (chunk: T): number;\n}\n\ninterface RTCPeerConnectionErrorCallback {\n    (error: DOMException): void;\n}\n\ninterface RTCSessionDescriptionCallback {\n    (description: RTCSessionDescriptionInit): void;\n}\n\ninterface RTCStatsCallback {\n    (report: RTCStatsReport): void;\n}\n\ninterface ReadableByteStreamControllerCallback {\n    (controller: ReadableByteStreamController): void | PromiseLike<void>;\n}\n\ninterface ReadableStreamDefaultControllerCallback<R> {\n    (controller: ReadableStreamDefaultController<R>): void | PromiseLike<void>;\n}\n\ninterface ReadableStreamErrorCallback {\n    (reason: any): void | PromiseLike<void>;\n}\n\ninterface TransformStreamDefaultControllerCallback<O> {\n    (controller: TransformStreamDefaultController<O>): void | PromiseLike<void>;\n}\n\ninterface TransformStreamDefaultControllerTransformCallback<I, O> {\n    (chunk: I, controller: TransformStreamDefaultController<O>): void | PromiseLike<void>;\n}\n\ninterface VoidFunction {\n    (): void;\n}\n\ninterface WritableStreamDefaultControllerCloseCallback {\n    (): void | PromiseLike<void>;\n}\n\ninterface WritableStreamDefaultControllerStartCallback {\n    (controller: WritableStreamDefaultController): void | PromiseLike<void>;\n}\n\ninterface WritableStreamDefaultControllerWriteCallback<W> {\n    (chunk: W, controller: WritableStreamDefaultController): void | PromiseLike<void>;\n}\n\ninterface WritableStreamErrorCallback {\n    (reason: any): void | PromiseLike<void>;\n}\n\ninterface HTMLElementTagNameMap {\n    "a": HTMLAnchorElement;\n    "abbr": HTMLElement;\n    "address": HTMLElement;\n    "applet": HTMLAppletElement;\n    "area": HTMLAreaElement;\n    "article": HTMLElement;\n    "aside": HTMLElement;\n    "audio": HTMLAudioElement;\n    "b": HTMLElement;\n    "base": HTMLBaseElement;\n    "basefont": HTMLBaseFontElement;\n    "bdi": HTMLElement;\n    "bdo": HTMLElement;\n    "blockquote": HTMLQuoteElement;\n    "body": HTMLBodyElement;\n    "br": HTMLBRElement;\n    "button": HTMLButtonElement;\n    "canvas": HTMLCanvasElement;\n    "caption": HTMLTableCaptionElement;\n    "cite": HTMLElement;\n    "code": HTMLElement;\n    "col": HTMLTableColElement;\n    "colgroup": HTMLTableColElement;\n    "data": HTMLDataElement;\n    "datalist": HTMLDataListElement;\n    "dd": HTMLElement;\n    "del": HTMLModElement;\n    "details": HTMLDetailsElement;\n    "dfn": HTMLElement;\n    "dialog": HTMLDialogElement;\n    "dir": HTMLDirectoryElement;\n    "div": HTMLDivElement;\n    "dl": HTMLDListElement;\n    "dt": HTMLElement;\n    "em": HTMLElement;\n    "embed": HTMLEmbedElement;\n    "fieldset": HTMLFieldSetElement;\n    "figcaption": HTMLElement;\n    "figure": HTMLElement;\n    "font": HTMLFontElement;\n    "footer": HTMLElement;\n    "form": HTMLFormElement;\n    "frame": HTMLFrameElement;\n    "frameset": HTMLFrameSetElement;\n    "h1": HTMLHeadingElement;\n    "h2": HTMLHeadingElement;\n    "h3": HTMLHeadingElement;\n    "h4": HTMLHeadingElement;\n    "h5": HTMLHeadingElement;\n    "h6": HTMLHeadingElement;\n    "head": HTMLHeadElement;\n    "header": HTMLElement;\n    "hgroup": HTMLElement;\n    "hr": HTMLHRElement;\n    "html": HTMLHtmlElement;\n    "i": HTMLElement;\n    "iframe": HTMLIFrameElement;\n    "img": HTMLImageElement;\n    "input": HTMLInputElement;\n    "ins": HTMLModElement;\n    "kbd": HTMLElement;\n    "label": HTMLLabelElement;\n    "legend": HTMLLegendElement;\n    "li": HTMLLIElement;\n    "link": HTMLLinkElement;\n    "main": HTMLElement;\n    "map": HTMLMapElement;\n    "mark": HTMLElement;\n    "marquee": HTMLMarqueeElement;\n    "menu": HTMLMenuElement;\n    "meta": HTMLMetaElement;\n    "meter": HTMLMeterElement;\n    "nav": HTMLElement;\n    "noscript": HTMLElement;\n    "object": HTMLObjectElement;\n    "ol": HTMLOListElement;\n    "optgroup": HTMLOptGroupElement;\n    "option": HTMLOptionElement;\n    "output": HTMLOutputElement;\n    "p": HTMLParagraphElement;\n    "param": HTMLParamElement;\n    "picture": HTMLPictureElement;\n    "pre": HTMLPreElement;\n    "progress": HTMLProgressElement;\n    "q": HTMLQuoteElement;\n    "rp": HTMLElement;\n    "rt": HTMLElement;\n    "ruby": HTMLElement;\n    "s": HTMLElement;\n    "samp": HTMLElement;\n    "script": HTMLScriptElement;\n    "section": HTMLElement;\n    "select": HTMLSelectElement;\n    "slot": HTMLSlotElement;\n    "small": HTMLElement;\n    "source": HTMLSourceElement;\n    "span": HTMLSpanElement;\n    "strong": HTMLElement;\n    "style": HTMLStyleElement;\n    "sub": HTMLElement;\n    "summary": HTMLElement;\n    "sup": HTMLElement;\n    "table": HTMLTableElement;\n    "tbody": HTMLTableSectionElement;\n    "td": HTMLTableDataCellElement;\n    "template": HTMLTemplateElement;\n    "textarea": HTMLTextAreaElement;\n    "tfoot": HTMLTableSectionElement;\n    "th": HTMLTableHeaderCellElement;\n    "thead": HTMLTableSectionElement;\n    "time": HTMLTimeElement;\n    "title": HTMLTitleElement;\n    "tr": HTMLTableRowElement;\n    "track": HTMLTrackElement;\n    "u": HTMLElement;\n    "ul": HTMLUListElement;\n    "var": HTMLElement;\n    "video": HTMLVideoElement;\n    "wbr": HTMLElement;\n}\n\ninterface HTMLElementDeprecatedTagNameMap {\n    "listing": HTMLPreElement;\n    "xmp": HTMLPreElement;\n}\n\ninterface SVGElementTagNameMap {\n    "a": SVGAElement;\n    "circle": SVGCircleElement;\n    "clipPath": SVGClipPathElement;\n    "defs": SVGDefsElement;\n    "desc": SVGDescElement;\n    "ellipse": SVGEllipseElement;\n    "feBlend": SVGFEBlendElement;\n    "feColorMatrix": SVGFEColorMatrixElement;\n    "feComponentTransfer": SVGFEComponentTransferElement;\n    "feComposite": SVGFECompositeElement;\n    "feConvolveMatrix": SVGFEConvolveMatrixElement;\n    "feDiffuseLighting": SVGFEDiffuseLightingElement;\n    "feDisplacementMap": SVGFEDisplacementMapElement;\n    "feDistantLight": SVGFEDistantLightElement;\n    "feFlood": SVGFEFloodElement;\n    "feFuncA": SVGFEFuncAElement;\n    "feFuncB": SVGFEFuncBElement;\n    "feFuncG": SVGFEFuncGElement;\n    "feFuncR": SVGFEFuncRElement;\n    "feGaussianBlur": SVGFEGaussianBlurElement;\n    "feImage": SVGFEImageElement;\n    "feMerge": SVGFEMergeElement;\n    "feMergeNode": SVGFEMergeNodeElement;\n    "feMorphology": SVGFEMorphologyElement;\n    "feOffset": SVGFEOffsetElement;\n    "fePointLight": SVGFEPointLightElement;\n    "feSpecularLighting": SVGFESpecularLightingElement;\n    "feSpotLight": SVGFESpotLightElement;\n    "feTile": SVGFETileElement;\n    "feTurbulence": SVGFETurbulenceElement;\n    "filter": SVGFilterElement;\n    "foreignObject": SVGForeignObjectElement;\n    "g": SVGGElement;\n    "image": SVGImageElement;\n    "line": SVGLineElement;\n    "linearGradient": SVGLinearGradientElement;\n    "marker": SVGMarkerElement;\n    "mask": SVGMaskElement;\n    "metadata": SVGMetadataElement;\n    "path": SVGPathElement;\n    "pattern": SVGPatternElement;\n    "polygon": SVGPolygonElement;\n    "polyline": SVGPolylineElement;\n    "radialGradient": SVGRadialGradientElement;\n    "rect": SVGRectElement;\n    "script": SVGScriptElement;\n    "stop": SVGStopElement;\n    "style": SVGStyleElement;\n    "svg": SVGSVGElement;\n    "switch": SVGSwitchElement;\n    "symbol": SVGSymbolElement;\n    "text": SVGTextElement;\n    "textPath": SVGTextPathElement;\n    "title": SVGTitleElement;\n    "tspan": SVGTSpanElement;\n    "use": SVGUseElement;\n    "view": SVGViewElement;\n}\n\n/** @deprecated Directly use HTMLElementTagNameMap or SVGElementTagNameMap as appropriate, instead. */\ntype ElementTagNameMap = HTMLElementTagNameMap & Pick<SVGElementTagNameMap, Exclude<keyof SVGElementTagNameMap, keyof HTMLElementTagNameMap>>;\n\ndeclare var Audio: {\n    new(src?: string): HTMLAudioElement;\n};\ndeclare var Image: {\n    new(width?: number, height?: number): HTMLImageElement;\n};\ndeclare var Option: {\n    new(text?: string, value?: string, defaultSelected?: boolean, selected?: boolean): HTMLOptionElement;\n};\ndeclare var Blob: typeof Blob;\ndeclare var TextDecoder: typeof TextDecoder;\ndeclare var TextEncoder: typeof TextEncoder;\ndeclare var URL: typeof URL;\ndeclare var URLSearchParams: typeof URLSearchParams;\ndeclare var applicationCache: ApplicationCache;\ndeclare var caches: CacheStorage;\ndeclare var clientInformation: Navigator;\ndeclare var closed: boolean;\ndeclare var crypto: Crypto;\ndeclare var customElements: CustomElementRegistry;\ndeclare var defaultStatus: string;\ndeclare var devicePixelRatio: number;\ndeclare var doNotTrack: string;\ndeclare var document: Document;\n/** @deprecated */\ndeclare var event: Event | undefined;\n/** @deprecated */\ndeclare var external: External;\ndeclare var frameElement: Element;\ndeclare var frames: Window;\ndeclare var history: History;\ndeclare var innerHeight: number;\ndeclare var innerWidth: number;\ndeclare var isSecureContext: boolean;\ndeclare var length: number;\ndeclare var location: Location;\ndeclare var locationbar: BarProp;\ndeclare var menubar: BarProp;\ndeclare var msContentScript: ExtensionScriptApis;\ndeclare const name: never;\ndeclare var navigator: Navigator;\ndeclare var offscreenBuffering: string | boolean;\ndeclare var oncompassneedscalibration: ((this: Window, ev: Event) => any) | null;\ndeclare var ondevicelight: ((this: Window, ev: DeviceLightEvent) => any) | null;\ndeclare var ondevicemotion: ((this: Window, ev: DeviceMotionEvent) => any) | null;\ndeclare var ondeviceorientation: ((this: Window, ev: DeviceOrientationEvent) => any) | null;\ndeclare var ondeviceorientationabsolute: ((this: Window, ev: DeviceOrientationEvent) => any) | null;\ndeclare var onmousewheel: ((this: Window, ev: Event) => any) | null;\ndeclare var onmsgesturechange: ((this: Window, ev: Event) => any) | null;\ndeclare var onmsgesturedoubletap: ((this: Window, ev: Event) => any) | null;\ndeclare var onmsgestureend: ((this: Window, ev: Event) => any) | null;\ndeclare var onmsgesturehold: ((this: Window, ev: Event) => any) | null;\ndeclare var onmsgesturestart: ((this: Window, ev: Event) => any) | null;\ndeclare var onmsgesturetap: ((this: Window, ev: Event) => any) | null;\ndeclare var onmsinertiastart: ((this: Window, ev: Event) => any) | null;\ndeclare var onmspointercancel: ((this: Window, ev: Event) => any) | null;\ndeclare var onmspointerdown: ((this: Window, ev: Event) => any) | null;\ndeclare var onmspointerenter: ((this: Window, ev: Event) => any) | null;\ndeclare var onmspointerleave: ((this: Window, ev: Event) => any) | null;\ndeclare var onmspointermove: ((this: Window, ev: Event) => any) | null;\ndeclare var onmspointerout: ((this: Window, ev: Event) => any) | null;\ndeclare var onmspointerover: ((this: Window, ev: Event) => any) | null;\ndeclare var onmspointerup: ((this: Window, ev: Event) => any) | null;\n/** @deprecated */\ndeclare var onorientationchange: ((this: Window, ev: Event) => any) | null;\ndeclare var onreadystatechange: ((this: Window, ev: ProgressEvent) => any) | null;\ndeclare var onvrdisplayactivate: ((this: Window, ev: Event) => any) | null;\ndeclare var onvrdisplayblur: ((this: Window, ev: Event) => any) | null;\ndeclare var onvrdisplayconnect: ((this: Window, ev: Event) => any) | null;\ndeclare var onvrdisplaydeactivate: ((this: Window, ev: Event) => any) | null;\ndeclare var onvrdisplaydisconnect: ((this: Window, ev: Event) => any) | null;\ndeclare var onvrdisplayfocus: ((this: Window, ev: Event) => any) | null;\ndeclare var onvrdisplaypointerrestricted: ((this: Window, ev: Event) => any) | null;\ndeclare var onvrdisplaypointerunrestricted: ((this: Window, ev: Event) => any) | null;\ndeclare var onvrdisplaypresentchange: ((this: Window, ev: Event) => any) | null;\ndeclare var opener: any;\n/** @deprecated */\ndeclare var orientation: string | number;\ndeclare var outerHeight: number;\ndeclare var outerWidth: number;\ndeclare var pageXOffset: number;\ndeclare var pageYOffset: number;\ndeclare var parent: Window;\ndeclare var performance: Performance;\ndeclare var personalbar: BarProp;\ndeclare var screen: Screen;\ndeclare var screenLeft: number;\ndeclare var screenTop: number;\ndeclare var screenX: number;\ndeclare var screenY: number;\ndeclare var scrollX: number;\ndeclare var scrollY: number;\ndeclare var scrollbars: BarProp;\ndeclare var self: Window;\ndeclare var speechSynthesis: SpeechSynthesis;\ndeclare var status: string;\ndeclare var statusbar: BarProp;\ndeclare var styleMedia: StyleMedia;\ndeclare var toolbar: BarProp;\ndeclare var top: Window;\ndeclare var window: Window;\ndeclare function alert(message?: any): void;\ndeclare function blur(): void;\ndeclare function cancelAnimationFrame(handle: number): void;\n/** @deprecated */\ndeclare function captureEvents(): void;\ndeclare function close(): void;\ndeclare function confirm(message?: string): boolean;\ndeclare function departFocus(navigationReason: NavigationReason, origin: FocusNavigationOrigin): void;\ndeclare function focus(): void;\ndeclare function getComputedStyle(elt: Element, pseudoElt?: string | null): CSSStyleDeclaration;\ndeclare function getMatchedCSSRules(elt: Element, pseudoElt?: string | null): CSSRuleList;\ndeclare function getSelection(): Selection | null;\ndeclare function matchMedia(query: string): MediaQueryList;\ndeclare function moveBy(x: number, y: number): void;\ndeclare function moveTo(x: number, y: number): void;\ndeclare function msWriteProfilerMark(profilerMarkName: string): void;\ndeclare function open(url?: string, target?: string, features?: string, replace?: boolean): Window | null;\ndeclare function postMessage(message: any, targetOrigin: string, transfer?: Transferable[]): void;\ndeclare function print(): void;\ndeclare function prompt(message?: string, _default?: string): string | null;\n/** @deprecated */\ndeclare function releaseEvents(): void;\ndeclare function requestAnimationFrame(callback: FrameRequestCallback): number;\ndeclare function resizeBy(x: number, y: number): void;\ndeclare function resizeTo(x: number, y: number): void;\ndeclare function scroll(options?: ScrollToOptions): void;\ndeclare function scroll(x: number, y: number): void;\ndeclare function scrollBy(options?: ScrollToOptions): void;\ndeclare function scrollBy(x: number, y: number): void;\ndeclare function scrollTo(options?: ScrollToOptions): void;\ndeclare function scrollTo(x: number, y: number): void;\ndeclare function stop(): void;\ndeclare function webkitCancelAnimationFrame(handle: number): void;\ndeclare function webkitConvertPointFromNodeToPage(node: Node, pt: WebKitPoint): WebKitPoint;\ndeclare function webkitConvertPointFromPageToNode(node: Node, pt: WebKitPoint): WebKitPoint;\ndeclare function webkitRequestAnimationFrame(callback: FrameRequestCallback): number;\ndeclare function toString(): string;\n/**\n * Dispatches a synthetic event event to target and returns true\n * if either event\'s cancelable attribute value is false or its preventDefault() method was not invoked, and false otherwise.\n */\ndeclare function dispatchEvent(event: Event): boolean;\ndeclare var sessionStorage: Storage;\ndeclare var localStorage: Storage;\ndeclare var console: Console;\n/**\n * Fires when the user aborts the download.\n * @param ev The event.\n */\ndeclare var onabort: ((this: Window, ev: UIEvent) => any) | null;\ndeclare var onanimationcancel: ((this: Window, ev: AnimationEvent) => any) | null;\ndeclare var onanimationend: ((this: Window, ev: AnimationEvent) => any) | null;\ndeclare var onanimationiteration: ((this: Window, ev: AnimationEvent) => any) | null;\ndeclare var onanimationstart: ((this: Window, ev: AnimationEvent) => any) | null;\ndeclare var onauxclick: ((this: Window, ev: MouseEvent) => any) | null;\n/**\n * Fires when the object loses the input focus.\n * @param ev The focus event.\n */\ndeclare var onblur: ((this: Window, ev: FocusEvent) => any) | null;\ndeclare var oncancel: ((this: Window, ev: Event) => any) | null;\n/**\n * Occurs when playback is possible, but would require further buffering.\n * @param ev The event.\n */\ndeclare var oncanplay: ((this: Window, ev: Event) => any) | null;\ndeclare var oncanplaythrough: ((this: Window, ev: Event) => any) | null;\n/**\n * Fires when the contents of the object or selection have changed.\n * @param ev The event.\n */\ndeclare var onchange: ((this: Window, ev: Event) => any) | null;\n/**\n * Fires when the user clicks the left mouse button on the object\n * @param ev The mouse event.\n */\ndeclare var onclick: ((this: Window, ev: MouseEvent) => any) | null;\ndeclare var onclose: ((this: Window, ev: Event) => any) | null;\n/**\n * Fires when the user clicks the right mouse button in the client area, opening the context menu.\n * @param ev The mouse event.\n */\ndeclare var oncontextmenu: ((this: Window, ev: MouseEvent) => any) | null;\ndeclare var oncuechange: ((this: Window, ev: Event) => any) | null;\n/**\n * Fires when the user double-clicks the object.\n * @param ev The mouse event.\n */\ndeclare var ondblclick: ((this: Window, ev: MouseEvent) => any) | null;\n/**\n * Fires on the source object continuously during a drag operation.\n * @param ev The event.\n */\ndeclare var ondrag: ((this: Window, ev: DragEvent) => any) | null;\n/**\n * Fires on the source object when the user releases the mouse at the close of a drag operation.\n * @param ev The event.\n */\ndeclare var ondragend: ((this: Window, ev: DragEvent) => any) | null;\n/**\n * Fires on the target element when the user drags the object to a valid drop target.\n * @param ev The drag event.\n */\ndeclare var ondragenter: ((this: Window, ev: DragEvent) => any) | null;\ndeclare var ondragexit: ((this: Window, ev: Event) => any) | null;\n/**\n * Fires on the target object when the user moves the mouse out of a valid drop target during a drag operation.\n * @param ev The drag event.\n */\ndeclare var ondragleave: ((this: Window, ev: DragEvent) => any) | null;\n/**\n * Fires on the target element continuously while the user drags the object over a valid drop target.\n * @param ev The event.\n */\ndeclare var ondragover: ((this: Window, ev: DragEvent) => any) | null;\n/**\n * Fires on the source object when the user starts to drag a text selection or selected object.\n * @param ev The event.\n */\ndeclare var ondragstart: ((this: Window, ev: DragEvent) => any) | null;\ndeclare var ondrop: ((this: Window, ev: DragEvent) => any) | null;\n/**\n * Occurs when the duration attribute is updated.\n * @param ev The event.\n */\ndeclare var ondurationchange: ((this: Window, ev: Event) => any) | null;\n/**\n * Occurs when the media element is reset to its initial state.\n * @param ev The event.\n */\ndeclare var onemptied: ((this: Window, ev: Event) => any) | null;\n/**\n * Occurs when the end of playback is reached.\n * @param ev The event\n */\ndeclare var onended: ((this: Window, ev: Event) => any) | null;\n/**\n * Fires when an error occurs during object loading.\n * @param ev The event.\n */\ndeclare var onerror: OnErrorEventHandler;\n/**\n * Fires when the object receives focus.\n * @param ev The event.\n */\ndeclare var onfocus: ((this: Window, ev: FocusEvent) => any) | null;\ndeclare var ongotpointercapture: ((this: Window, ev: PointerEvent) => any) | null;\ndeclare var oninput: ((this: Window, ev: Event) => any) | null;\ndeclare var oninvalid: ((this: Window, ev: Event) => any) | null;\n/**\n * Fires when the user presses a key.\n * @param ev The keyboard event\n */\ndeclare var onkeydown: ((this: Window, ev: KeyboardEvent) => any) | null;\n/**\n * Fires when the user presses an alphanumeric key.\n * @param ev The event.\n */\ndeclare var onkeypress: ((this: Window, ev: KeyboardEvent) => any) | null;\n/**\n * Fires when the user releases a key.\n * @param ev The keyboard event\n */\ndeclare var onkeyup: ((this: Window, ev: KeyboardEvent) => any) | null;\n/**\n * Fires immediately after the browser loads the object.\n * @param ev The event.\n */\ndeclare var onload: ((this: Window, ev: Event) => any) | null;\n/**\n * Occurs when media data is loaded at the current playback position.\n * @param ev The event.\n */\ndeclare var onloadeddata: ((this: Window, ev: Event) => any) | null;\n/**\n * Occurs when the duration and dimensions of the media have been determined.\n * @param ev The event.\n */\ndeclare var onloadedmetadata: ((this: Window, ev: Event) => any) | null;\ndeclare var onloadend: ((this: Window, ev: ProgressEvent) => any) | null;\n/**\n * Occurs when Internet Explorer begins looking for media data.\n * @param ev The event.\n */\ndeclare var onloadstart: ((this: Window, ev: Event) => any) | null;\ndeclare var onlostpointercapture: ((this: Window, ev: PointerEvent) => any) | null;\n/**\n * Fires when the user clicks the object with either mouse button.\n * @param ev The mouse event.\n */\ndeclare var onmousedown: ((this: Window, ev: MouseEvent) => any) | null;\ndeclare var onmouseenter: ((this: Window, ev: MouseEvent) => any) | null;\ndeclare var onmouseleave: ((this: Window, ev: MouseEvent) => any) | null;\n/**\n * Fires when the user moves the mouse over the object.\n * @param ev The mouse event.\n */\ndeclare var onmousemove: ((this: Window, ev: MouseEvent) => any) | null;\n/**\n * Fires when the user moves the mouse pointer outside the boundaries of the object.\n * @param ev The mouse event.\n */\ndeclare var onmouseout: ((this: Window, ev: MouseEvent) => any) | null;\n/**\n * Fires when the user moves the mouse pointer into the object.\n * @param ev The mouse event.\n */\ndeclare var onmouseover: ((this: Window, ev: MouseEvent) => any) | null;\n/**\n * Fires when the user releases a mouse button while the mouse is over the object.\n * @param ev The mouse event.\n */\ndeclare var onmouseup: ((this: Window, ev: MouseEvent) => any) | null;\n/**\n * Occurs when playback is paused.\n * @param ev The event.\n */\ndeclare var onpause: ((this: Window, ev: Event) => any) | null;\n/**\n * Occurs when the play method is requested.\n * @param ev The event.\n */\ndeclare var onplay: ((this: Window, ev: Event) => any) | null;\n/**\n * Occurs when the audio or video has started playing.\n * @param ev The event.\n */\ndeclare var onplaying: ((this: Window, ev: Event) => any) | null;\ndeclare var onpointercancel: ((this: Window, ev: PointerEvent) => any) | null;\ndeclare var onpointerdown: ((this: Window, ev: PointerEvent) => any) | null;\ndeclare var onpointerenter: ((this: Window, ev: PointerEvent) => any) | null;\ndeclare var onpointerleave: ((this: Window, ev: PointerEvent) => any) | null;\ndeclare var onpointermove: ((this: Window, ev: PointerEvent) => any) | null;\ndeclare var onpointerout: ((this: Window, ev: PointerEvent) => any) | null;\ndeclare var onpointerover: ((this: Window, ev: PointerEvent) => any) | null;\ndeclare var onpointerup: ((this: Window, ev: PointerEvent) => any) | null;\n/**\n * Occurs to indicate progress while downloading media data.\n * @param ev The event.\n */\ndeclare var onprogress: ((this: Window, ev: ProgressEvent) => any) | null;\n/**\n * Occurs when the playback rate is increased or decreased.\n * @param ev The event.\n */\ndeclare var onratechange: ((this: Window, ev: Event) => any) | null;\n/**\n * Fires when the user resets a form.\n * @param ev The event.\n */\ndeclare var onreset: ((this: Window, ev: Event) => any) | null;\ndeclare var onresize: ((this: Window, ev: UIEvent) => any) | null;\n/**\n * Fires when the user repositions the scroll box in the scroll bar on the object.\n * @param ev The event.\n */\ndeclare var onscroll: ((this: Window, ev: Event) => any) | null;\ndeclare var onsecuritypolicyviolation: ((this: Window, ev: SecurityPolicyViolationEvent) => any) | null;\n/**\n * Occurs when the seek operation ends.\n * @param ev The event.\n */\ndeclare var onseeked: ((this: Window, ev: Event) => any) | null;\n/**\n * Occurs when the current playback position is moved.\n * @param ev The event.\n */\ndeclare var onseeking: ((this: Window, ev: Event) => any) | null;\n/**\n * Fires when the current selection changes.\n * @param ev The event.\n */\ndeclare var onselect: ((this: Window, ev: Event) => any) | null;\ndeclare var onselectionchange: ((this: Window, ev: Event) => any) | null;\ndeclare var onselectstart: ((this: Window, ev: Event) => any) | null;\n/**\n * Occurs when the download has stopped.\n * @param ev The event.\n */\ndeclare var onstalled: ((this: Window, ev: Event) => any) | null;\ndeclare var onsubmit: ((this: Window, ev: Event) => any) | null;\n/**\n * Occurs if the load operation has been intentionally halted.\n * @param ev The event.\n */\ndeclare var onsuspend: ((this: Window, ev: Event) => any) | null;\n/**\n * Occurs to indicate the current playback position.\n * @param ev The event.\n */\ndeclare var ontimeupdate: ((this: Window, ev: Event) => any) | null;\ndeclare var ontoggle: ((this: Window, ev: Event) => any) | null;\ndeclare var ontouchcancel: ((this: Window, ev: TouchEvent) => any) | null;\ndeclare var ontouchend: ((this: Window, ev: TouchEvent) => any) | null;\ndeclare var ontouchmove: ((this: Window, ev: TouchEvent) => any) | null;\ndeclare var ontouchstart: ((this: Window, ev: TouchEvent) => any) | null;\ndeclare var ontransitioncancel: ((this: Window, ev: TransitionEvent) => any) | null;\ndeclare var ontransitionend: ((this: Window, ev: TransitionEvent) => any) | null;\ndeclare var ontransitionrun: ((this: Window, ev: TransitionEvent) => any) | null;\ndeclare var ontransitionstart: ((this: Window, ev: TransitionEvent) => any) | null;\n/**\n * Occurs when the volume is changed, or playback is muted or unmuted.\n * @param ev The event.\n */\ndeclare var onvolumechange: ((this: Window, ev: Event) => any) | null;\n/**\n * Occurs when playback stops because the next frame of a video resource is not available.\n * @param ev The event.\n */\ndeclare var onwaiting: ((this: Window, ev: Event) => any) | null;\ndeclare var onwheel: ((this: Window, ev: WheelEvent) => any) | null;\ndeclare var indexedDB: IDBFactory;\ndeclare function atob(encodedString: string): string;\ndeclare function btoa(rawString: string): string;\ndeclare function fetch(input: RequestInfo, init?: RequestInit): Promise<Response>;\ndeclare var caches: CacheStorage;\ndeclare var crypto: Crypto;\ndeclare var indexedDB: IDBFactory;\ndeclare var origin: string;\ndeclare var performance: Performance;\ndeclare function atob(data: string): string;\ndeclare function btoa(data: string): string;\ndeclare function clearInterval(handle?: number): void;\ndeclare function clearTimeout(handle?: number): void;\ndeclare function createImageBitmap(image: ImageBitmapSource): Promise<ImageBitmap>;\ndeclare function createImageBitmap(image: ImageBitmapSource, sx: number, sy: number, sw: number, sh: number): Promise<ImageBitmap>;\ndeclare function fetch(input: RequestInfo, init?: RequestInit): Promise<Response>;\ndeclare function queueMicrotask(callback: Function): void;\ndeclare function setInterval(handler: TimerHandler, timeout?: number, ...arguments: any[]): number;\ndeclare function setTimeout(handler: TimerHandler, timeout?: number, ...arguments: any[]): number;\ndeclare var sessionStorage: Storage;\ndeclare var localStorage: Storage;\ndeclare var onafterprint: ((this: Window, ev: Event) => any) | null;\ndeclare var onbeforeprint: ((this: Window, ev: Event) => any) | null;\ndeclare var onbeforeunload: ((this: Window, ev: BeforeUnloadEvent) => any) | null;\ndeclare var onhashchange: ((this: Window, ev: HashChangeEvent) => any) | null;\ndeclare var onlanguagechange: ((this: Window, ev: Event) => any) | null;\ndeclare var onmessage: ((this: Window, ev: MessageEvent) => any) | null;\ndeclare var onmessageerror: ((this: Window, ev: MessageEvent) => any) | null;\ndeclare var onoffline: ((this: Window, ev: Event) => any) | null;\ndeclare var ononline: ((this: Window, ev: Event) => any) | null;\ndeclare var onpagehide: ((this: Window, ev: PageTransitionEvent) => any) | null;\ndeclare var onpageshow: ((this: Window, ev: PageTransitionEvent) => any) | null;\ndeclare var onpopstate: ((this: Window, ev: PopStateEvent) => any) | null;\ndeclare var onrejectionhandled: ((this: Window, ev: Event) => any) | null;\ndeclare var onstorage: ((this: Window, ev: StorageEvent) => any) | null;\ndeclare var onunhandledrejection: ((this: Window, ev: PromiseRejectionEvent) => any) | null;\ndeclare var onunload: ((this: Window, ev: Event) => any) | null;\ndeclare function addEventListener<K extends keyof WindowEventMap>(type: K, listener: (this: Window, ev: WindowEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;\ndeclare function addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;\ndeclare function removeEventListener<K extends keyof WindowEventMap>(type: K, listener: (this: Window, ev: WindowEventMap[K]) => any, options?: boolean | EventListenerOptions): void;\ndeclare function removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;\ntype BlobPart = BufferSource | Blob | string;\ntype HeadersInit = Headers | string[][] | Record<string, string>;\ntype BodyInit = Blob | BufferSource | FormData | URLSearchParams | ReadableStream<Uint8Array> | string;\ntype RequestInfo = Request | string;\ntype DOMHighResTimeStamp = number;\ntype RenderingContext = CanvasRenderingContext2D | ImageBitmapRenderingContext | WebGLRenderingContext;\ntype HTMLOrSVGImageElement = HTMLImageElement | SVGImageElement;\ntype CanvasImageSource = HTMLOrSVGImageElement | HTMLVideoElement | HTMLCanvasElement | ImageBitmap | OffscreenCanvas;\ntype OffscreenRenderingContext = OffscreenCanvasRenderingContext2D | WebGLRenderingContext;\ntype MessageEventSource = WindowProxy | MessagePort | ServiceWorker;\ntype HTMLOrSVGScriptElement = HTMLScriptElement | SVGScriptElement;\ntype ImageBitmapSource = CanvasImageSource | Blob | ImageData;\ntype OnErrorEventHandler = OnErrorEventHandlerNonNull | null;\ntype OnBeforeUnloadEventHandler = OnBeforeUnloadEventHandlerNonNull | null;\ntype TimerHandler = string | Function;\ntype ConstrainULong = number | ConstrainULongRange;\ntype ConstrainDouble = number | ConstrainDoubleRange;\ntype ConstrainBoolean = boolean | ConstrainBooleanParameters;\ntype ConstrainDOMString = string | string[] | ConstrainDOMStringParameters;\ntype PerformanceEntryList = PerformanceEntry[];\ntype VibratePattern = number | number[];\ntype AlgorithmIdentifier = string | Algorithm;\ntype HashAlgorithmIdentifier = AlgorithmIdentifier;\ntype BigInteger = Uint8Array;\ntype NamedCurve = string;\ntype GLenum = number;\ntype GLboolean = boolean;\ntype GLbitfield = number;\ntype GLint = number;\ntype GLsizei = number;\ntype GLintptr = number;\ntype GLsizeiptr = number;\ntype GLuint = number;\ntype GLfloat = number;\ntype GLclampf = number;\ntype TexImageSource = ImageBitmap | ImageData | HTMLImageElement | HTMLCanvasElement | HTMLVideoElement;\ntype Float32List = Float32Array | GLfloat[];\ntype Int32List = Int32Array | GLint[];\ntype BufferSource = ArrayBufferView | ArrayBuffer;\ntype DOMTimeStamp = number;\ntype LineAndPositionSetting = number | AutoKeyword;\ntype FormDataEntryValue = File | string;\ntype InsertPosition = "beforebegin" | "afterbegin" | "beforeend" | "afterend";\ntype IDBValidKey = number | string | Date | BufferSource | IDBArrayKey;\ntype MutationRecordType = "attributes" | "characterData" | "childList";\ntype IDBKeyPath = string;\ntype Transferable = ArrayBuffer | MessagePort | ImageBitmap;\ntype RTCIceGatherCandidate = RTCIceCandidateDictionary | RTCIceCandidateComplete;\ntype RTCTransport = RTCDtlsTransport | RTCSrtpSdesTransport;\n/** @deprecated */\ntype MouseWheelEvent = WheelEvent;\ntype WindowProxy = Window;\ntype AlignSetting = "start" | "center" | "end" | "left" | "right";\ntype AnimationPlayState = "idle" | "running" | "paused" | "finished";\ntype AppendMode = "segments" | "sequence";\ntype AudioContextLatencyCategory = "balanced" | "interactive" | "playback";\ntype AudioContextState = "suspended" | "running" | "closed";\ntype AutoKeyword = "auto";\ntype AutomationRate = "a-rate" | "k-rate";\ntype BinaryType = "blob" | "arraybuffer";\ntype BiquadFilterType = "lowpass" | "highpass" | "bandpass" | "lowshelf" | "highshelf" | "peaking" | "notch" | "allpass";\ntype CanPlayTypeResult = "" | "maybe" | "probably";\ntype CanvasDirection = "ltr" | "rtl" | "inherit";\ntype CanvasFillRule = "nonzero" | "evenodd";\ntype CanvasLineCap = "butt" | "round" | "square";\ntype CanvasLineJoin = "round" | "bevel" | "miter";\ntype CanvasTextAlign = "start" | "end" | "left" | "right" | "center";\ntype CanvasTextBaseline = "top" | "hanging" | "middle" | "alphabetic" | "ideographic" | "bottom";\ntype ChannelCountMode = "max" | "clamped-max" | "explicit";\ntype ChannelInterpretation = "speakers" | "discrete";\ntype ClientTypes = "window" | "worker" | "sharedworker" | "all";\ntype CompositeOperation = "replace" | "add" | "accumulate";\ntype CompositeOperationOrAuto = "replace" | "add" | "accumulate" | "auto";\ntype DirectionSetting = "" | "rl" | "lr";\ntype DisplayCaptureSurfaceType = "monitor" | "window" | "application" | "browser";\ntype DistanceModelType = "linear" | "inverse" | "exponential";\ntype DocumentReadyState = "loading" | "interactive" | "complete";\ntype EndOfStreamError = "network" | "decode";\ntype EndingType = "transparent" | "native";\ntype FillMode = "none" | "forwards" | "backwards" | "both" | "auto";\ntype FullscreenNavigationUI = "auto" | "show" | "hide";\ntype GamepadHand = "" | "left" | "right";\ntype GamepadHapticActuatorType = "vibration";\ntype GamepadInputEmulationType = "mouse" | "keyboard" | "gamepad";\ntype GamepadMappingType = "" | "standard";\ntype IDBCursorDirection = "next" | "nextunique" | "prev" | "prevunique";\ntype IDBRequestReadyState = "pending" | "done";\ntype IDBTransactionMode = "readonly" | "readwrite" | "versionchange";\ntype ImageSmoothingQuality = "low" | "medium" | "high";\ntype IterationCompositeOperation = "replace" | "accumulate";\ntype KeyFormat = "raw" | "spki" | "pkcs8" | "jwk";\ntype KeyType = "public" | "private" | "secret";\ntype KeyUsage = "encrypt" | "decrypt" | "sign" | "verify" | "deriveKey" | "deriveBits" | "wrapKey" | "unwrapKey";\ntype LineAlignSetting = "start" | "center" | "end";\ntype ListeningState = "inactive" | "active" | "disambiguation";\ntype MSCredentialType = "FIDO_2_0";\ntype MSTransportType = "Embedded" | "USB" | "NFC" | "BT";\ntype MSWebViewPermissionState = "unknown" | "defer" | "allow" | "deny";\ntype MSWebViewPermissionType = "geolocation" | "unlimitedIndexedDBQuota" | "media" | "pointerlock" | "webnotifications";\ntype MediaDeviceKind = "audioinput" | "audiooutput" | "videoinput";\ntype MediaKeyMessageType = "license-request" | "license-renewal" | "license-release" | "individualization-request";\ntype MediaKeySessionType = "temporary" | "persistent-license";\ntype MediaKeyStatus = "usable" | "expired" | "released" | "output-restricted" | "output-downscaled" | "status-pending" | "internal-error";\ntype MediaKeysRequirement = "required" | "optional" | "not-allowed";\ntype MediaStreamTrackState = "live" | "ended";\ntype NavigationReason = "up" | "down" | "left" | "right";\ntype NavigationType = "navigate" | "reload" | "back_forward" | "prerender";\ntype NotificationDirection = "auto" | "ltr" | "rtl";\ntype NotificationPermission = "default" | "denied" | "granted";\ntype OffscreenRenderingContextId = "2d" | "webgl";\ntype OrientationLockType = "any" | "natural" | "landscape" | "portrait" | "portrait-primary" | "portrait-secondary" | "landscape-primary" | "landscape-secondary";\ntype OrientationType = "portrait-primary" | "portrait-secondary" | "landscape-primary" | "landscape-secondary";\ntype OscillatorType = "sine" | "square" | "sawtooth" | "triangle" | "custom";\ntype OverSampleType = "none" | "2x" | "4x";\ntype PanningModelType = "equalpower" | "HRTF";\ntype PaymentComplete = "success" | "fail" | "unknown";\ntype PaymentShippingType = "shipping" | "delivery" | "pickup";\ntype PermissionName = "geolocation" | "notifications" | "push" | "midi" | "camera" | "microphone" | "speaker" | "device-info" | "background-sync" | "bluetooth" | "persistent-storage" | "ambient-light-sensor" | "accelerometer" | "gyroscope" | "magnetometer" | "clipboard";\ntype PermissionState = "granted" | "denied" | "prompt";\ntype PlaybackDirection = "normal" | "reverse" | "alternate" | "alternate-reverse";\ntype PositionAlignSetting = "line-left" | "center" | "line-right" | "auto";\ntype PushEncryptionKeyName = "p256dh" | "auth";\ntype PushPermissionState = "denied" | "granted" | "prompt";\ntype RTCBundlePolicy = "balanced" | "max-compat" | "max-bundle";\ntype RTCDataChannelState = "connecting" | "open" | "closing" | "closed";\ntype RTCDegradationPreference = "maintain-framerate" | "maintain-resolution" | "balanced";\ntype RTCDtlsRole = "auto" | "client" | "server";\ntype RTCDtlsTransportState = "new" | "connecting" | "connected" | "closed" | "failed";\ntype RTCDtxStatus = "disabled" | "enabled";\ntype RTCErrorDetailType = "data-channel-failure" | "dtls-failure" | "fingerprint-failure" | "idp-bad-script-failure" | "idp-execution-failure" | "idp-load-failure" | "idp-need-login" | "idp-timeout" | "idp-tls-failure" | "idp-token-expired" | "idp-token-invalid" | "sctp-failure" | "sdp-syntax-error" | "hardware-encoder-not-available" | "hardware-encoder-error";\ntype RTCIceCandidateType = "host" | "srflx" | "prflx" | "relay";\ntype RTCIceComponent = "rtp" | "rtcp";\ntype RTCIceConnectionState = "new" | "checking" | "connected" | "completed" | "disconnected" | "failed" | "closed";\ntype RTCIceCredentialType = "password" | "oauth";\ntype RTCIceGatherPolicy = "all" | "nohost" | "relay";\ntype RTCIceGathererState = "new" | "gathering" | "complete";\ntype RTCIceGatheringState = "new" | "gathering" | "complete";\ntype RTCIceProtocol = "udp" | "tcp";\ntype RTCIceRole = "controlling" | "controlled";\ntype RTCIceTcpCandidateType = "active" | "passive" | "so";\ntype RTCIceTransportPolicy = "relay" | "all";\ntype RTCIceTransportState = "new" | "checking" | "connected" | "completed" | "disconnected" | "failed" | "closed";\ntype RTCPeerConnectionState = "new" | "connecting" | "connected" | "disconnected" | "failed" | "closed";\ntype RTCPriorityType = "very-low" | "low" | "medium" | "high";\ntype RTCRtcpMuxPolicy = "negotiate" | "require";\ntype RTCRtpTransceiverDirection = "sendrecv" | "sendonly" | "recvonly" | "inactive";\ntype RTCSctpTransportState = "connecting" | "connected" | "closed";\ntype RTCSdpType = "offer" | "pranswer" | "answer" | "rollback";\ntype RTCSignalingState = "stable" | "have-local-offer" | "have-remote-offer" | "have-local-pranswer" | "have-remote-pranswer" | "closed";\ntype RTCStatsIceCandidatePairState = "frozen" | "waiting" | "inprogress" | "failed" | "succeeded" | "cancelled";\ntype RTCStatsIceCandidateType = "host" | "serverreflexive" | "peerreflexive" | "relayed";\ntype RTCStatsType = "inboundrtp" | "outboundrtp" | "session" | "datachannel" | "track" | "transport" | "candidatepair" | "localcandidate" | "remotecandidate";\ntype ReadyState = "closed" | "open" | "ended";\ntype ReferrerPolicy = "" | "no-referrer" | "no-referrer-when-downgrade" | "same-origin" | "origin" | "strict-origin" | "origin-when-cross-origin" | "strict-origin-when-cross-origin" | "unsafe-url";\ntype RequestCache = "default" | "no-store" | "reload" | "no-cache" | "force-cache" | "only-if-cached";\ntype RequestCredentials = "omit" | "same-origin" | "include";\ntype RequestDestination = "" | "audio" | "audioworklet" | "document" | "embed" | "font" | "image" | "manifest" | "object" | "paintworklet" | "report" | "script" | "sharedworker" | "style" | "track" | "video" | "worker" | "xslt";\ntype RequestMode = "navigate" | "same-origin" | "no-cors" | "cors";\ntype RequestRedirect = "follow" | "error" | "manual";\ntype ResponseType = "basic" | "cors" | "default" | "error" | "opaque" | "opaqueredirect";\ntype ScopedCredentialType = "ScopedCred";\ntype ScrollBehavior = "auto" | "smooth";\ntype ScrollLogicalPosition = "start" | "center" | "end" | "nearest";\ntype ScrollRestoration = "auto" | "manual";\ntype ScrollSetting = "" | "up";\ntype SelectionMode = "select" | "start" | "end" | "preserve";\ntype ServiceWorkerState = "installing" | "installed" | "activating" | "activated" | "redundant";\ntype ServiceWorkerUpdateViaCache = "imports" | "all" | "none";\ntype ShadowRootMode = "open" | "closed";\ntype SpeechRecognitionErrorCode = "no-speech" | "aborted" | "audio-capture" | "network" | "not-allowed" | "service-not-allowed" | "bad-grammar" | "language-not-supported";\ntype SpeechSynthesisErrorCode = "canceled" | "interrupted" | "audio-busy" | "audio-hardware" | "network" | "synthesis-unavailable" | "synthesis-failed" | "language-unavailable" | "voice-unavailable" | "text-too-long" | "invalid-argument";\ntype SupportedType = "text/html" | "text/xml" | "application/xml" | "application/xhtml+xml" | "image/svg+xml";\ntype TextTrackKind = "subtitles" | "captions" | "descriptions" | "chapters" | "metadata";\ntype TextTrackMode = "disabled" | "hidden" | "showing";\ntype TouchType = "direct" | "stylus";\ntype Transport = "usb" | "nfc" | "ble";\ntype VRDisplayEventReason = "mounted" | "navigation" | "requested" | "unmounted";\ntype VideoFacingModeEnum = "user" | "environment" | "left" | "right";\ntype VisibilityState = "hidden" | "visible" | "prerender";\ntype WebGLPowerPreference = "default" | "low-power" | "high-performance";\ntype WorkerType = "classic" | "module";\ntype XMLHttpRequestResponseType = "" | "arraybuffer" | "blob" | "document" | "json" | "text";\n',n.lib_es5_dts="/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the \"License\"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib=\"true\"/>\n\n\n/////////////////////////////\n/// ECMAScript APIs\n/////////////////////////////\n\ndeclare var NaN: number;\ndeclare var Infinity: number;\n\n/**\n  * Evaluates JavaScript code and executes it.\n  * @param x A String value that contains valid JavaScript code.\n  */\ndeclare function eval(x: string): any;\n\n/**\n  * Converts A string to an integer.\n  * @param s A string to convert into a number.\n  * @param radix A value between 2 and 36 that specifies the base of the number in numString.\n  * If this argument is not supplied, strings with a prefix of '0x' are considered hexadecimal.\n  * All other strings are considered decimal.\n  */\ndeclare function parseInt(s: string, radix?: number): number;\n\n/**\n  * Converts a string to a floating-point number.\n  * @param string A string that contains a floating-point number.\n  */\ndeclare function parseFloat(string: string): number;\n\n/**\n  * Returns a Boolean value that indicates whether a value is the reserved value NaN (not a number).\n  * @param number A numeric value.\n  */\ndeclare function isNaN(number: number): boolean;\n\n/**\n  * Determines whether a supplied number is finite.\n  * @param number Any numeric value.\n  */\ndeclare function isFinite(number: number): boolean;\n\n/**\n  * Gets the unencoded version of an encoded Uniform Resource Identifier (URI).\n  * @param encodedURI A value representing an encoded URI.\n  */\ndeclare function decodeURI(encodedURI: string): string;\n\n/**\n  * Gets the unencoded version of an encoded component of a Uniform Resource Identifier (URI).\n  * @param encodedURIComponent A value representing an encoded URI component.\n  */\ndeclare function decodeURIComponent(encodedURIComponent: string): string;\n\n/**\n  * Encodes a text string as a valid Uniform Resource Identifier (URI)\n  * @param uri A value representing an encoded URI.\n  */\ndeclare function encodeURI(uri: string): string;\n\n/**\n  * Encodes a text string as a valid component of a Uniform Resource Identifier (URI).\n  * @param uriComponent A value representing an encoded URI component.\n  */\ndeclare function encodeURIComponent(uriComponent: string | number | boolean): string;\n\n/**\n  * Computes a new string in which certain characters have been replaced by a hexadecimal escape sequence.\n  * @param string A string value\n  */\ndeclare function escape(string: string): string;\n\n/**\n  * Computes a new string in which hexadecimal escape sequences are replaced with the character that it represents.\n  * @param string A string value\n  */\ndeclare function unescape(string: string): string;\n\ninterface Symbol {\n  /** Returns a string representation of an object. */\n  toString(): string;\n\n  /** Returns the primitive value of the specified object. */\n  valueOf(): symbol;\n}\n\ndeclare type PropertyKey = string | number | symbol;\n\ninterface PropertyDescriptor {\n    configurable?: boolean;\n    enumerable?: boolean;\n    value?: any;\n    writable?: boolean;\n    get?(): any;\n    set?(v: any): void;\n}\n\ninterface PropertyDescriptorMap {\n    [s: string]: PropertyDescriptor;\n}\n\ninterface Object {\n    /** The initial value of Object.prototype.constructor is the standard built-in Object constructor. */\n    constructor: Function;\n\n    /** Returns a string representation of an object. */\n    toString(): string;\n\n    /** Returns a date converted to a string using the current locale. */\n    toLocaleString(): string;\n\n    /** Returns the primitive value of the specified object. */\n    valueOf(): Object;\n\n    /**\n      * Determines whether an object has a property with the specified name.\n      * @param v A property name.\n      */\n    hasOwnProperty(v: PropertyKey): boolean;\n\n    /**\n      * Determines whether an object exists in another object's prototype chain.\n      * @param v Another object whose prototype chain is to be checked.\n      */\n    isPrototypeOf(v: Object): boolean;\n\n    /**\n      * Determines whether a specified property is enumerable.\n      * @param v A property name.\n      */\n    propertyIsEnumerable(v: PropertyKey): boolean;\n}\n\ninterface ObjectConstructor {\n    new(value?: any): Object;\n    (): any;\n    (value: any): any;\n\n    /** A reference to the prototype for a class of objects. */\n    readonly prototype: Object;\n\n    /**\n      * Returns the prototype of an object.\n      * @param o The object that references the prototype.\n      */\n    getPrototypeOf(o: any): any;\n\n    /**\n      * Gets the own property descriptor of the specified object.\n      * An own property descriptor is one that is defined directly on the object and is not inherited from the object's prototype.\n      * @param o Object that contains the property.\n      * @param p Name of the property.\n    */\n    getOwnPropertyDescriptor(o: any, p: PropertyKey): PropertyDescriptor | undefined;\n\n    /**\n      * Returns the names of the own properties of an object. The own properties of an object are those that are defined directly\n      * on that object, and are not inherited from the object's prototype. The properties of an object include both fields (objects) and functions.\n      * @param o Object that contains the own properties.\n      */\n    getOwnPropertyNames(o: any): string[];\n\n    /**\n      * Creates an object that has the specified prototype or that has null prototype.\n      * @param o Object to use as a prototype. May be null.\n      */\n    create(o: object | null): any;\n\n    /**\n      * Creates an object that has the specified prototype, and that optionally contains specified properties.\n      * @param o Object to use as a prototype. May be null\n      * @param properties JavaScript object that contains one or more property descriptors.\n      */\n    create(o: object | null, properties: PropertyDescriptorMap & ThisType<any>): any;\n\n    /**\n      * Adds a property to an object, or modifies attributes of an existing property.\n      * @param o Object on which to add or modify the property. This can be a native JavaScript object (that is, a user-defined object or a built in object) or a DOM object.\n      * @param p The property name.\n      * @param attributes Descriptor for the property. It can be for a data property or an accessor property.\n      */\n    defineProperty(o: any, p: PropertyKey, attributes: PropertyDescriptor & ThisType<any>): any;\n\n    /**\n      * Adds one or more properties to an object, and/or modifies attributes of existing properties.\n      * @param o Object on which to add or modify the properties. This can be a native JavaScript object or a DOM object.\n      * @param properties JavaScript object that contains one or more descriptor objects. Each descriptor object describes a data property or an accessor property.\n      */\n    defineProperties(o: any, properties: PropertyDescriptorMap & ThisType<any>): any;\n\n    /**\n      * Prevents the modification of attributes of existing properties, and prevents the addition of new properties.\n      * @param o Object on which to lock the attributes.\n      */\n    seal<T>(o: T): T;\n\n    /**\n      * Prevents the modification of existing property attributes and values, and prevents the addition of new properties.\n      * @param o Object on which to lock the attributes.\n      */\n    freeze<T>(a: T[]): ReadonlyArray<T>;\n\n    /**\n      * Prevents the modification of existing property attributes and values, and prevents the addition of new properties.\n      * @param o Object on which to lock the attributes.\n      */\n    freeze<T extends Function>(f: T): T;\n\n    /**\n      * Prevents the modification of existing property attributes and values, and prevents the addition of new properties.\n      * @param o Object on which to lock the attributes.\n      */\n    freeze<T>(o: T): Readonly<T>;\n\n    /**\n      * Prevents the addition of new properties to an object.\n      * @param o Object to make non-extensible.\n      */\n    preventExtensions<T>(o: T): T;\n\n    /**\n      * Returns true if existing property attributes cannot be modified in an object and new properties cannot be added to the object.\n      * @param o Object to test.\n      */\n    isSealed(o: any): boolean;\n\n    /**\n      * Returns true if existing property attributes and values cannot be modified in an object, and new properties cannot be added to the object.\n      * @param o Object to test.\n      */\n    isFrozen(o: any): boolean;\n\n    /**\n      * Returns a value that indicates whether new properties can be added to an object.\n      * @param o Object to test.\n      */\n    isExtensible(o: any): boolean;\n\n    /**\n      * Returns the names of the enumerable string properties and methods of an object.\n      * @param o Object that contains the properties and methods. This can be an object that you created or an existing Document Object Model (DOM) object.\n      */\n     keys(o: object): string[];\n}\n\n/**\n  * Provides functionality common to all JavaScript objects.\n  */\ndeclare var Object: ObjectConstructor;\n\n/**\n  * Creates a new function.\n  */\ninterface Function {\n    /**\n      * Calls the function, substituting the specified object for the this value of the function, and the specified array for the arguments of the function.\n      * @param thisArg The object to be used as the this object.\n      * @param argArray A set of arguments to be passed to the function.\n      */\n    apply(this: Function, thisArg: any, argArray?: any): any;\n\n    /**\n      * Calls a method of an object, substituting another object for the current object.\n      * @param thisArg The object to be used as the current object.\n      * @param argArray A list of arguments to be passed to the method.\n      */\n    call(this: Function, thisArg: any, ...argArray: any[]): any;\n\n    /**\n      * For a given function, creates a bound function that has the same body as the original function.\n      * The this object of the bound function is associated with the specified object, and has the specified initial parameters.\n      * @param thisArg An object to which the this keyword can refer inside the new function.\n      * @param argArray A list of arguments to be passed to the new function.\n      */\n    bind(this: Function, thisArg: any, ...argArray: any[]): any;\n\n    /** Returns a string representation of a function. */\n    toString(): string;\n\n    prototype: any;\n    readonly length: number;\n\n    // Non-standard extensions\n    arguments: any;\n    caller: Function;\n}\n\ninterface FunctionConstructor {\n    /**\n      * Creates a new function.\n      * @param args A list of arguments the function accepts.\n      */\n    new(...args: string[]): Function;\n    (...args: string[]): Function;\n    readonly prototype: Function;\n}\n\ndeclare var Function: FunctionConstructor;\n\n/**\n * Extracts the type of the 'this' parameter of a function type, or 'unknown' if the function type has no 'this' parameter.\n */\ntype ThisParameterType<T> = T extends (this: unknown, ...args: any[]) => any ? unknown : T extends (this: infer U, ...args: any[]) => any ? U : unknown;\n\n/**\n * Removes the 'this' parameter from a function type.\n */\ntype OmitThisParameter<T> = unknown extends ThisParameterType<T> ? T : T extends (...args: infer A) => infer R ? (...args: A) => R : T;\n\ninterface CallableFunction extends Function {\n    /**\n      * Calls the function with the specified object as the this value and the elements of specified array as the arguments.\n      * @param thisArg The object to be used as the this object.\n      * @param args An array of argument values to be passed to the function.\n      */\n    apply<T, R>(this: (this: T) => R, thisArg: T): R;\n    apply<T, A extends any[], R>(this: (this: T, ...args: A) => R, thisArg: T, args: A): R;\n\n    /**\n      * Calls the function with the specified object as the this value and the specified rest arguments as the arguments.\n      * @param thisArg The object to be used as the this object.\n      * @param args Argument values to be passed to the function.\n      */\n    call<T, A extends any[], R>(this: (this: T, ...args: A) => R, thisArg: T, ...args: A): R;\n\n    /**\n      * For a given function, creates a bound function that has the same body as the original function.\n      * The this object of the bound function is associated with the specified object, and has the specified initial parameters.\n      * @param thisArg The object to be used as the this object.\n      * @param args Arguments to bind to the parameters of the function.\n      */\n    bind<T>(this: T, thisArg: ThisParameterType<T>): OmitThisParameter<T>;\n    bind<T, A0, A extends any[], R>(this: (this: T, arg0: A0, ...args: A) => R, thisArg: T, arg0: A0): (...args: A) => R;\n    bind<T, A0, A1, A extends any[], R>(this: (this: T, arg0: A0, arg1: A1, ...args: A) => R, thisArg: T, arg0: A0, arg1: A1): (...args: A) => R;\n    bind<T, A0, A1, A2, A extends any[], R>(this: (this: T, arg0: A0, arg1: A1, arg2: A2, ...args: A) => R, thisArg: T, arg0: A0, arg1: A1, arg2: A2): (...args: A) => R;\n    bind<T, A0, A1, A2, A3, A extends any[], R>(this: (this: T, arg0: A0, arg1: A1, arg2: A2, arg3: A3, ...args: A) => R, thisArg: T, arg0: A0, arg1: A1, arg2: A2, arg3: A3): (...args: A) => R;\n    bind<T, AX, R>(this: (this: T, ...args: AX[]) => R, thisArg: T, ...args: AX[]): (...args: AX[]) => R;\n}\n\ninterface NewableFunction extends Function {\n    /**\n      * Calls the function with the specified object as the this value and the elements of specified array as the arguments.\n      * @param thisArg The object to be used as the this object.\n      * @param args An array of argument values to be passed to the function.\n      */\n    apply<T>(this: new () => T, thisArg: T): void;\n    apply<T, A extends any[]>(this: new (...args: A) => T, thisArg: T, args: A): void;\n\n    /**\n      * Calls the function with the specified object as the this value and the specified rest arguments as the arguments.\n      * @param thisArg The object to be used as the this object.\n      * @param args Argument values to be passed to the function.\n      */\n    call<T, A extends any[]>(this: new (...args: A) => T, thisArg: T, ...args: A): void;\n\n    /**\n      * For a given function, creates a bound function that has the same body as the original function.\n      * The this object of the bound function is associated with the specified object, and has the specified initial parameters.\n      * @param thisArg The object to be used as the this object.\n      * @param args Arguments to bind to the parameters of the function.\n      */\n    bind<T>(this: T, thisArg: any): T;\n    bind<A0, A extends any[], R>(this: new (arg0: A0, ...args: A) => R, thisArg: any, arg0: A0): new (...args: A) => R;\n    bind<A0, A1, A extends any[], R>(this: new (arg0: A0, arg1: A1, ...args: A) => R, thisArg: any, arg0: A0, arg1: A1): new (...args: A) => R;\n    bind<A0, A1, A2, A extends any[], R>(this: new (arg0: A0, arg1: A1, arg2: A2, ...args: A) => R, thisArg: any, arg0: A0, arg1: A1, arg2: A2): new (...args: A) => R;\n    bind<A0, A1, A2, A3, A extends any[], R>(this: new (arg0: A0, arg1: A1, arg2: A2, arg3: A3, ...args: A) => R, thisArg: any, arg0: A0, arg1: A1, arg2: A2, arg3: A3): new (...args: A) => R;\n    bind<AX, R>(this: new (...args: AX[]) => R, thisArg: any, ...args: AX[]): new (...args: AX[]) => R;\n}\n\ninterface IArguments {\n    [index: number]: any;\n    length: number;\n    callee: Function;\n}\n\ninterface String {\n    /** Returns a string representation of a string. */\n    toString(): string;\n\n    /**\n      * Returns the character at the specified index.\n      * @param pos The zero-based index of the desired character.\n      */\n    charAt(pos: number): string;\n\n    /**\n      * Returns the Unicode value of the character at the specified location.\n      * @param index The zero-based index of the desired character. If there is no character at the specified index, NaN is returned.\n      */\n    charCodeAt(index: number): number;\n\n    /**\n      * Returns a string that contains the concatenation of two or more strings.\n      * @param strings The strings to append to the end of the string.\n      */\n    concat(...strings: string[]): string;\n\n    /**\n      * Returns the position of the first occurrence of a substring.\n      * @param searchString The substring to search for in the string\n      * @param position The index at which to begin searching the String object. If omitted, search starts at the beginning of the string.\n      */\n    indexOf(searchString: string, position?: number): number;\n\n    /**\n      * Returns the last occurrence of a substring in the string.\n      * @param searchString The substring to search for.\n      * @param position The index at which to begin searching. If omitted, the search begins at the end of the string.\n      */\n    lastIndexOf(searchString: string, position?: number): number;\n\n    /**\n      * Determines whether two strings are equivalent in the current locale.\n      * @param that String to compare to target string\n      */\n    localeCompare(that: string): number;\n\n    /**\n      * Matches a string with a regular expression, and returns an array containing the results of that search.\n      * @param regexp A variable name or string literal containing the regular expression pattern and flags.\n      */\n    match(regexp: string | RegExp): RegExpMatchArray | null;\n\n    /**\n      * Replaces text in a string, using a regular expression or search string.\n      * @param searchValue A string to search for.\n      * @param replaceValue A string containing the text to replace for every successful match of searchValue in this string.\n      */\n    replace(searchValue: string | RegExp, replaceValue: string): string;\n\n    /**\n      * Replaces text in a string, using a regular expression or search string.\n      * @param searchValue A string to search for.\n      * @param replacer A function that returns the replacement text.\n      */\n    replace(searchValue: string | RegExp, replacer: (substring: string, ...args: any[]) => string): string;\n\n    /**\n      * Finds the first substring match in a regular expression search.\n      * @param regexp The regular expression pattern and applicable flags.\n      */\n    search(regexp: string | RegExp): number;\n\n    /**\n      * Returns a section of a string.\n      * @param start The index to the beginning of the specified portion of stringObj.\n      * @param end The index to the end of the specified portion of stringObj. The substring includes the characters up to, but not including, the character indicated by end.\n      * If this value is not specified, the substring continues to the end of stringObj.\n      */\n    slice(start?: number, end?: number): string;\n\n    /**\n      * Split a string into substrings using the specified separator and return them as an array.\n      * @param separator A string that identifies character or characters to use in separating the string. If omitted, a single-element array containing the entire string is returned.\n      * @param limit A value used to limit the number of elements returned in the array.\n      */\n    split(separator: string | RegExp, limit?: number): string[];\n\n    /**\n      * Returns the substring at the specified location within a String object.\n      * @param start The zero-based index number indicating the beginning of the substring.\n      * @param end Zero-based index number indicating the end of the substring. The substring includes the characters up to, but not including, the character indicated by end.\n      * If end is omitted, the characters from start through the end of the original string are returned.\n      */\n    substring(start: number, end?: number): string;\n\n    /** Converts all the alphabetic characters in a string to lowercase. */\n    toLowerCase(): string;\n\n    /** Converts all alphabetic characters to lowercase, taking into account the host environment's current locale. */\n    toLocaleLowerCase(): string;\n\n    /** Converts all the alphabetic characters in a string to uppercase. */\n    toUpperCase(): string;\n\n    /** Returns a string where all alphabetic characters have been converted to uppercase, taking into account the host environment's current locale. */\n    toLocaleUpperCase(): string;\n\n    /** Removes the leading and trailing white space and line terminator characters from a string. */\n    trim(): string;\n\n    /** Returns the length of a String object. */\n    readonly length: number;\n\n    // IE extensions\n    /**\n      * Gets a substring beginning at the specified location and having the specified length.\n      * @param from The starting position of the desired substring. The index of the first character in the string is zero.\n      * @param length The number of characters to include in the returned substring.\n      */\n    substr(from: number, length?: number): string;\n\n    /** Returns the primitive value of the specified object. */\n    valueOf(): string;\n\n    readonly [index: number]: string;\n}\n\ninterface StringConstructor {\n    new(value?: any): String;\n    (value?: any): string;\n    readonly prototype: String;\n    fromCharCode(...codes: number[]): string;\n}\n\n/**\n  * Allows manipulation and formatting of text strings and determination and location of substrings within strings.\n  */\ndeclare var String: StringConstructor;\n\ninterface Boolean {\n    /** Returns the primitive value of the specified object. */\n    valueOf(): boolean;\n}\n\ninterface BooleanConstructor {\n    new(value?: any): Boolean;\n    <T>(value?: T): boolean;\n    readonly prototype: Boolean;\n}\n\ndeclare var Boolean: BooleanConstructor;\n\ninterface Number {\n    /**\n      * Returns a string representation of an object.\n      * @param radix Specifies a radix for converting numeric values to strings. This value is only used for numbers.\n      */\n    toString(radix?: number): string;\n\n    /**\n      * Returns a string representing a number in fixed-point notation.\n      * @param fractionDigits Number of digits after the decimal point. Must be in the range 0 - 20, inclusive.\n      */\n    toFixed(fractionDigits?: number): string;\n\n    /**\n      * Returns a string containing a number represented in exponential notation.\n      * @param fractionDigits Number of digits after the decimal point. Must be in the range 0 - 20, inclusive.\n      */\n    toExponential(fractionDigits?: number): string;\n\n    /**\n      * Returns a string containing a number represented either in exponential or fixed-point notation with a specified number of digits.\n      * @param precision Number of significant digits. Must be in the range 1 - 21, inclusive.\n      */\n    toPrecision(precision?: number): string;\n\n    /** Returns the primitive value of the specified object. */\n    valueOf(): number;\n}\n\ninterface NumberConstructor {\n    new(value?: any): Number;\n    (value?: any): number;\n    readonly prototype: Number;\n\n    /** The largest number that can be represented in JavaScript. Equal to approximately 1.79E+308. */\n    readonly MAX_VALUE: number;\n\n    /** The closest number to zero that can be represented in JavaScript. Equal to approximately 5.00E-324. */\n    readonly MIN_VALUE: number;\n\n    /**\n      * A value that is not a number.\n      * In equality comparisons, NaN does not equal any value, including itself. To test whether a value is equivalent to NaN, use the isNaN function.\n      */\n    readonly NaN: number;\n\n    /**\n      * A value that is less than the largest negative number that can be represented in JavaScript.\n      * JavaScript displays NEGATIVE_INFINITY values as -infinity.\n      */\n    readonly NEGATIVE_INFINITY: number;\n\n    /**\n      * A value greater than the largest number that can be represented in JavaScript.\n      * JavaScript displays POSITIVE_INFINITY values as infinity.\n      */\n    readonly POSITIVE_INFINITY: number;\n}\n\n/** An object that represents a number of any kind. All JavaScript numbers are 64-bit floating-point numbers. */\ndeclare var Number: NumberConstructor;\n\ninterface TemplateStringsArray extends ReadonlyArray<string> {\n    readonly raw: ReadonlyArray<string>;\n}\n\n/**\n * The type of `import.meta`.\n *\n * If you need to declare that a given property exists on `import.meta`,\n * this type may be augmented via interface merging.\n */\ninterface ImportMeta {\n}\n\ninterface Math {\n    /** The mathematical constant e. This is Euler's number, the base of natural logarithms. */\n    readonly E: number;\n    /** The natural logarithm of 10. */\n    readonly LN10: number;\n    /** The natural logarithm of 2. */\n    readonly LN2: number;\n    /** The base-2 logarithm of e. */\n    readonly LOG2E: number;\n    /** The base-10 logarithm of e. */\n    readonly LOG10E: number;\n    /** Pi. This is the ratio of the circumference of a circle to its diameter. */\n    readonly PI: number;\n    /** The square root of 0.5, or, equivalently, one divided by the square root of 2. */\n    readonly SQRT1_2: number;\n    /** The square root of 2. */\n    readonly SQRT2: number;\n    /**\n      * Returns the absolute value of a number (the value without regard to whether it is positive or negative).\n      * For example, the absolute value of -5 is the same as the absolute value of 5.\n      * @param x A numeric expression for which the absolute value is needed.\n      */\n    abs(x: number): number;\n    /**\n      * Returns the arc cosine (or inverse cosine) of a number.\n      * @param x A numeric expression.\n      */\n    acos(x: number): number;\n    /**\n      * Returns the arcsine of a number.\n      * @param x A numeric expression.\n      */\n    asin(x: number): number;\n    /**\n      * Returns the arctangent of a number.\n      * @param x A numeric expression for which the arctangent is needed.\n      */\n    atan(x: number): number;\n    /**\n      * Returns the angle (in radians) from the X axis to a point.\n      * @param y A numeric expression representing the cartesian y-coordinate.\n      * @param x A numeric expression representing the cartesian x-coordinate.\n      */\n    atan2(y: number, x: number): number;\n    /**\n      * Returns the smallest integer greater than or equal to its numeric argument.\n      * @param x A numeric expression.\n      */\n    ceil(x: number): number;\n    /**\n      * Returns the cosine of a number.\n      * @param x A numeric expression that contains an angle measured in radians.\n      */\n    cos(x: number): number;\n    /**\n      * Returns e (the base of natural logarithms) raised to a power.\n      * @param x A numeric expression representing the power of e.\n      */\n    exp(x: number): number;\n    /**\n      * Returns the greatest integer less than or equal to its numeric argument.\n      * @param x A numeric expression.\n      */\n    floor(x: number): number;\n    /**\n      * Returns the natural logarithm (base e) of a number.\n      * @param x A numeric expression.\n      */\n    log(x: number): number;\n    /**\n      * Returns the larger of a set of supplied numeric expressions.\n      * @param values Numeric expressions to be evaluated.\n      */\n    max(...values: number[]): number;\n    /**\n      * Returns the smaller of a set of supplied numeric expressions.\n      * @param values Numeric expressions to be evaluated.\n      */\n    min(...values: number[]): number;\n    /**\n      * Returns the value of a base expression taken to a specified power.\n      * @param x The base value of the expression.\n      * @param y The exponent value of the expression.\n      */\n    pow(x: number, y: number): number;\n    /** Returns a pseudorandom number between 0 and 1. */\n    random(): number;\n    /**\n      * Returns a supplied numeric expression rounded to the nearest number.\n      * @param x The value to be rounded to the nearest number.\n      */\n    round(x: number): number;\n    /**\n      * Returns the sine of a number.\n      * @param x A numeric expression that contains an angle measured in radians.\n      */\n    sin(x: number): number;\n    /**\n      * Returns the square root of a number.\n      * @param x A numeric expression.\n      */\n    sqrt(x: number): number;\n    /**\n      * Returns the tangent of a number.\n      * @param x A numeric expression that contains an angle measured in radians.\n      */\n    tan(x: number): number;\n}\n/** An intrinsic object that provides basic mathematics functionality and constants. */\ndeclare var Math: Math;\n\n/** Enables basic storage and retrieval of dates and times. */\ninterface Date {\n    /** Returns a string representation of a date. The format of the string depends on the locale. */\n    toString(): string;\n    /** Returns a date as a string value. */\n    toDateString(): string;\n    /** Returns a time as a string value. */\n    toTimeString(): string;\n    /** Returns a value as a string value appropriate to the host environment's current locale. */\n    toLocaleString(): string;\n    /** Returns a date as a string value appropriate to the host environment's current locale. */\n    toLocaleDateString(): string;\n    /** Returns a time as a string value appropriate to the host environment's current locale. */\n    toLocaleTimeString(): string;\n    /** Returns the stored time value in milliseconds since midnight, January 1, 1970 UTC. */\n    valueOf(): number;\n    /** Gets the time value in milliseconds. */\n    getTime(): number;\n    /** Gets the year, using local time. */\n    getFullYear(): number;\n    /** Gets the year using Universal Coordinated Time (UTC). */\n    getUTCFullYear(): number;\n    /** Gets the month, using local time. */\n    getMonth(): number;\n    /** Gets the month of a Date object using Universal Coordinated Time (UTC). */\n    getUTCMonth(): number;\n    /** Gets the day-of-the-month, using local time. */\n    getDate(): number;\n    /** Gets the day-of-the-month, using Universal Coordinated Time (UTC). */\n    getUTCDate(): number;\n    /** Gets the day of the week, using local time. */\n    getDay(): number;\n    /** Gets the day of the week using Universal Coordinated Time (UTC). */\n    getUTCDay(): number;\n    /** Gets the hours in a date, using local time. */\n    getHours(): number;\n    /** Gets the hours value in a Date object using Universal Coordinated Time (UTC). */\n    getUTCHours(): number;\n    /** Gets the minutes of a Date object, using local time. */\n    getMinutes(): number;\n    /** Gets the minutes of a Date object using Universal Coordinated Time (UTC). */\n    getUTCMinutes(): number;\n    /** Gets the seconds of a Date object, using local time. */\n    getSeconds(): number;\n    /** Gets the seconds of a Date object using Universal Coordinated Time (UTC). */\n    getUTCSeconds(): number;\n    /** Gets the milliseconds of a Date, using local time. */\n    getMilliseconds(): number;\n    /** Gets the milliseconds of a Date object using Universal Coordinated Time (UTC). */\n    getUTCMilliseconds(): number;\n    /** Gets the difference in minutes between the time on the local computer and Universal Coordinated Time (UTC). */\n    getTimezoneOffset(): number;\n    /**\n      * Sets the date and time value in the Date object.\n      * @param time A numeric value representing the number of elapsed milliseconds since midnight, January 1, 1970 GMT.\n      */\n    setTime(time: number): number;\n    /**\n      * Sets the milliseconds value in the Date object using local time.\n      * @param ms A numeric value equal to the millisecond value.\n      */\n    setMilliseconds(ms: number): number;\n    /**\n      * Sets the milliseconds value in the Date object using Universal Coordinated Time (UTC).\n      * @param ms A numeric value equal to the millisecond value.\n      */\n    setUTCMilliseconds(ms: number): number;\n\n    /**\n      * Sets the seconds value in the Date object using local time.\n      * @param sec A numeric value equal to the seconds value.\n      * @param ms A numeric value equal to the milliseconds value.\n      */\n    setSeconds(sec: number, ms?: number): number;\n    /**\n      * Sets the seconds value in the Date object using Universal Coordinated Time (UTC).\n      * @param sec A numeric value equal to the seconds value.\n      * @param ms A numeric value equal to the milliseconds value.\n      */\n    setUTCSeconds(sec: number, ms?: number): number;\n    /**\n      * Sets the minutes value in the Date object using local time.\n      * @param min A numeric value equal to the minutes value.\n      * @param sec A numeric value equal to the seconds value.\n      * @param ms A numeric value equal to the milliseconds value.\n      */\n    setMinutes(min: number, sec?: number, ms?: number): number;\n    /**\n      * Sets the minutes value in the Date object using Universal Coordinated Time (UTC).\n      * @param min A numeric value equal to the minutes value.\n      * @param sec A numeric value equal to the seconds value.\n      * @param ms A numeric value equal to the milliseconds value.\n      */\n    setUTCMinutes(min: number, sec?: number, ms?: number): number;\n    /**\n      * Sets the hour value in the Date object using local time.\n      * @param hours A numeric value equal to the hours value.\n      * @param min A numeric value equal to the minutes value.\n      * @param sec A numeric value equal to the seconds value.\n      * @param ms A numeric value equal to the milliseconds value.\n      */\n    setHours(hours: number, min?: number, sec?: number, ms?: number): number;\n    /**\n      * Sets the hours value in the Date object using Universal Coordinated Time (UTC).\n      * @param hours A numeric value equal to the hours value.\n      * @param min A numeric value equal to the minutes value.\n      * @param sec A numeric value equal to the seconds value.\n      * @param ms A numeric value equal to the milliseconds value.\n      */\n    setUTCHours(hours: number, min?: number, sec?: number, ms?: number): number;\n    /**\n      * Sets the numeric day-of-the-month value of the Date object using local time.\n      * @param date A numeric value equal to the day of the month.\n      */\n    setDate(date: number): number;\n    /**\n      * Sets the numeric day of the month in the Date object using Universal Coordinated Time (UTC).\n      * @param date A numeric value equal to the day of the month.\n      */\n    setUTCDate(date: number): number;\n    /**\n      * Sets the month value in the Date object using local time.\n      * @param month A numeric value equal to the month. The value for January is 0, and other month values follow consecutively.\n      * @param date A numeric value representing the day of the month. If this value is not supplied, the value from a call to the getDate method is used.\n      */\n    setMonth(month: number, date?: number): number;\n    /**\n      * Sets the month value in the Date object using Universal Coordinated Time (UTC).\n      * @param month A numeric value equal to the month. The value for January is 0, and other month values follow consecutively.\n      * @param date A numeric value representing the day of the month. If it is not supplied, the value from a call to the getUTCDate method is used.\n      */\n    setUTCMonth(month: number, date?: number): number;\n    /**\n      * Sets the year of the Date object using local time.\n      * @param year A numeric value for the year.\n      * @param month A zero-based numeric value for the month (0 for January, 11 for December). Must be specified if numDate is specified.\n      * @param date A numeric value equal for the day of the month.\n      */\n    setFullYear(year: number, month?: number, date?: number): number;\n    /**\n      * Sets the year value in the Date object using Universal Coordinated Time (UTC).\n      * @param year A numeric value equal to the year.\n      * @param month A numeric value equal to the month. The value for January is 0, and other month values follow consecutively. Must be supplied if numDate is supplied.\n      * @param date A numeric value equal to the day of the month.\n      */\n    setUTCFullYear(year: number, month?: number, date?: number): number;\n    /** Returns a date converted to a string using Universal Coordinated Time (UTC). */\n    toUTCString(): string;\n    /** Returns a date as a string value in ISO format. */\n    toISOString(): string;\n    /** Used by the JSON.stringify method to enable the transformation of an object's data for JavaScript Object Notation (JSON) serialization. */\n    toJSON(key?: any): string;\n}\n\ninterface DateConstructor {\n    new(): Date;\n    new(value: number | string): Date;\n    new(year: number, month: number, date?: number, hours?: number, minutes?: number, seconds?: number, ms?: number): Date;\n    (): string;\n    readonly prototype: Date;\n    /**\n      * Parses a string containing a date, and returns the number of milliseconds between that date and midnight, January 1, 1970.\n      * @param s A date string\n      */\n    parse(s: string): number;\n    /**\n      * Returns the number of milliseconds between midnight, January 1, 1970 Universal Coordinated Time (UTC) (or GMT) and the specified date.\n      * @param year The full year designation is required for cross-century date accuracy. If year is between 0 and 99 is used, then year is assumed to be 1900 + year.\n      * @param month The month as an number between 0 and 11 (January to December).\n      * @param date The date as an number between 1 and 31.\n      * @param hours Must be supplied if minutes is supplied. An number from 0 to 23 (midnight to 11pm) that specifies the hour.\n      * @param minutes Must be supplied if seconds is supplied. An number from 0 to 59 that specifies the minutes.\n      * @param seconds Must be supplied if milliseconds is supplied. An number from 0 to 59 that specifies the seconds.\n      * @param ms An number from 0 to 999 that specifies the milliseconds.\n      */\n    UTC(year: number, month: number, date?: number, hours?: number, minutes?: number, seconds?: number, ms?: number): number;\n    now(): number;\n}\n\ndeclare var Date: DateConstructor;\n\ninterface RegExpMatchArray extends Array<string> {\n    index?: number;\n    input?: string;\n}\n\ninterface RegExpExecArray extends Array<string> {\n    index: number;\n    input: string;\n}\n\ninterface RegExp {\n    /**\n      * Executes a search on a string using a regular expression pattern, and returns an array containing the results of that search.\n      * @param string The String object or string literal on which to perform the search.\n      */\n    exec(string: string): RegExpExecArray | null;\n\n    /**\n      * Returns a Boolean value that indicates whether or not a pattern exists in a searched string.\n      * @param string String on which to perform the search.\n      */\n    test(string: string): boolean;\n\n    /** Returns a copy of the text of the regular expression pattern. Read-only. The regExp argument is a Regular expression object. It can be a variable name or a literal. */\n    readonly source: string;\n\n    /** Returns a Boolean value indicating the state of the global flag (g) used with a regular expression. Default is false. Read-only. */\n    readonly global: boolean;\n\n    /** Returns a Boolean value indicating the state of the ignoreCase flag (i) used with a regular expression. Default is false. Read-only. */\n    readonly ignoreCase: boolean;\n\n    /** Returns a Boolean value indicating the state of the multiline flag (m) used with a regular expression. Default is false. Read-only. */\n    readonly multiline: boolean;\n\n    lastIndex: number;\n\n    // Non-standard extensions\n    compile(): this;\n}\n\ninterface RegExpConstructor {\n    new(pattern: RegExp | string): RegExp;\n    new(pattern: string, flags?: string): RegExp;\n    (pattern: RegExp | string): RegExp;\n    (pattern: string, flags?: string): RegExp;\n    readonly prototype: RegExp;\n\n    // Non-standard extensions\n    $1: string;\n    $2: string;\n    $3: string;\n    $4: string;\n    $5: string;\n    $6: string;\n    $7: string;\n    $8: string;\n    $9: string;\n    lastMatch: string;\n}\n\ndeclare var RegExp: RegExpConstructor;\n\ninterface Error {\n    name: string;\n    message: string;\n    stack?: string;\n}\n\ninterface ErrorConstructor {\n    new(message?: string): Error;\n    (message?: string): Error;\n    readonly prototype: Error;\n}\n\ndeclare var Error: ErrorConstructor;\n\ninterface EvalError extends Error {\n}\n\ninterface EvalErrorConstructor {\n    new(message?: string): EvalError;\n    (message?: string): EvalError;\n    readonly prototype: EvalError;\n}\n\ndeclare var EvalError: EvalErrorConstructor;\n\ninterface RangeError extends Error {\n}\n\ninterface RangeErrorConstructor {\n    new(message?: string): RangeError;\n    (message?: string): RangeError;\n    readonly prototype: RangeError;\n}\n\ndeclare var RangeError: RangeErrorConstructor;\n\ninterface ReferenceError extends Error {\n}\n\ninterface ReferenceErrorConstructor {\n    new(message?: string): ReferenceError;\n    (message?: string): ReferenceError;\n    readonly prototype: ReferenceError;\n}\n\ndeclare var ReferenceError: ReferenceErrorConstructor;\n\ninterface SyntaxError extends Error {\n}\n\ninterface SyntaxErrorConstructor {\n    new(message?: string): SyntaxError;\n    (message?: string): SyntaxError;\n    readonly prototype: SyntaxError;\n}\n\ndeclare var SyntaxError: SyntaxErrorConstructor;\n\ninterface TypeError extends Error {\n}\n\ninterface TypeErrorConstructor {\n    new(message?: string): TypeError;\n    (message?: string): TypeError;\n    readonly prototype: TypeError;\n}\n\ndeclare var TypeError: TypeErrorConstructor;\n\ninterface URIError extends Error {\n}\n\ninterface URIErrorConstructor {\n    new(message?: string): URIError;\n    (message?: string): URIError;\n    readonly prototype: URIError;\n}\n\ndeclare var URIError: URIErrorConstructor;\n\ninterface JSON {\n    /**\n      * Converts a JavaScript Object Notation (JSON) string into an object.\n      * @param text A valid JSON string.\n      * @param reviver A function that transforms the results. This function is called for each member of the object.\n      * If a member contains nested objects, the nested objects are transformed before the parent object is.\n      */\n    parse(text: string, reviver?: (this: any, key: string, value: any) => any): any;\n    /**\n      * Converts a JavaScript value to a JavaScript Object Notation (JSON) string.\n      * @param value A JavaScript value, usually an object or array, to be converted.\n      * @param replacer A function that transforms the results.\n      * @param space Adds indentation, white space, and line break characters to the return-value JSON text to make it easier to read.\n      */\n    stringify(value: any, replacer?: (this: any, key: string, value: any) => any, space?: string | number): string;\n    /**\n      * Converts a JavaScript value to a JavaScript Object Notation (JSON) string.\n      * @param value A JavaScript value, usually an object or array, to be converted.\n      * @param replacer An array of strings and numbers that acts as a approved list for selecting the object properties that will be stringified.\n      * @param space Adds indentation, white space, and line break characters to the return-value JSON text to make it easier to read.\n      */\n    stringify(value: any, replacer?: (number | string)[] | null, space?: string | number): string;\n}\n\n/**\n  * An intrinsic object that provides functions to convert JavaScript values to and from the JavaScript Object Notation (JSON) format.\n  */\ndeclare var JSON: JSON;\n\n\n/////////////////////////////\n/// ECMAScript Array API (specially handled by compiler)\n/////////////////////////////\n\ninterface ReadonlyArray<T> {\n    /**\n      * Gets the length of the array. This is a number one higher than the highest element defined in an array.\n      */\n    readonly length: number;\n    /**\n      * Returns a string representation of an array.\n      */\n    toString(): string;\n    /**\n      * Returns a string representation of an array. The elements are converted to string using their toLocalString methods.\n      */\n    toLocaleString(): string;\n    /**\n      * Combines two or more arrays.\n      * @param items Additional items to add to the end of array1.\n      */\n    concat(...items: ConcatArray<T>[]): T[];\n    /**\n      * Combines two or more arrays.\n      * @param items Additional items to add to the end of array1.\n      */\n    concat(...items: (T | ConcatArray<T>)[]): T[];\n    /**\n      * Adds all the elements of an array separated by the specified separator string.\n      * @param separator A string used to separate one element of an array from the next in the resulting String. If omitted, the array elements are separated with a comma.\n      */\n    join(separator?: string): string;\n    /**\n      * Returns a section of an array.\n      * @param start The beginning of the specified portion of the array.\n      * @param end The end of the specified portion of the array.\n      */\n    slice(start?: number, end?: number): T[];\n    /**\n      * Returns the index of the first occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the search starts at index 0.\n      */\n    indexOf(searchElement: T, fromIndex?: number): number;\n    /**\n      * Returns the index of the last occurrence of a specified value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the search starts at the last index in the array.\n      */\n    lastIndexOf(searchElement: T, fromIndex?: number): number;\n    /**\n      * Determines whether all the members of an array satisfy the specified test.\n      * @param callbackfn A function that accepts up to three arguments. The every method calls the callbackfn function for each element in array1 until the callbackfn returns false, or until the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n      */\n    every(callbackfn: (value: T, index: number, array: ReadonlyArray<T>) => unknown, thisArg?: any): boolean;\n    /**\n      * Determines whether the specified callback function returns true for any element of an array.\n      * @param callbackfn A function that accepts up to three arguments. The some method calls the callbackfn function for each element in array1 until the callbackfn returns true, or until the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n      */\n    some(callbackfn: (value: T, index: number, array: ReadonlyArray<T>) => unknown, thisArg?: any): boolean;\n    /**\n      * Performs the specified action for each element in an array.\n      * @param callbackfn  A function that accepts up to three arguments. forEach calls the callbackfn function one time for each element in the array.\n      * @param thisArg  An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n      */\n    forEach(callbackfn: (value: T, index: number, array: ReadonlyArray<T>) => void, thisArg?: any): void;\n    /**\n      * Calls a defined callback function on each element of an array, and returns an array that contains the results.\n      * @param callbackfn A function that accepts up to three arguments. The map method calls the callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n      */\n    map<U>(callbackfn: (value: T, index: number, array: ReadonlyArray<T>) => U, thisArg?: any): U[];\n    /**\n     * Returns the elements of an array that meet the condition specified in a callback function.\n     * @param callbackfn A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.\n     * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n     */\n    filter<S extends T>(callbackfn: (value: T, index: number, array: ReadonlyArray<T>) => value is S, thisArg?: any): S[];\n    /**\n      * Returns the elements of an array that meet the condition specified in a callback function.\n      * @param callbackfn A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n      */\n    filter(callbackfn: (value: T, index: number, array: ReadonlyArray<T>) => unknown, thisArg?: any): T[];\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.\n      */\n    reduce(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: ReadonlyArray<T>) => T): T;\n    reduce(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: ReadonlyArray<T>) => T, initialValue: T): T;\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.\n      */\n    reduce<U>(callbackfn: (previousValue: U, currentValue: T, currentIndex: number, array: ReadonlyArray<T>) => U, initialValue: U): U;\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.\n      */\n    reduceRight(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: ReadonlyArray<T>) => T): T;\n    reduceRight(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: ReadonlyArray<T>) => T, initialValue: T): T;\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.\n      */\n    reduceRight<U>(callbackfn: (previousValue: U, currentValue: T, currentIndex: number, array: ReadonlyArray<T>) => U, initialValue: U): U;\n\n    readonly [n: number]: T;\n}\n\ninterface ConcatArray<T> {\n    readonly length: number;\n    readonly [n: number]: T;\n    join(separator?: string): string;\n    slice(start?: number, end?: number): T[];\n}\n\ninterface Array<T> {\n    /**\n      * Gets or sets the length of the array. This is a number one higher than the highest element defined in an array.\n      */\n    length: number;\n    /**\n      * Returns a string representation of an array.\n      */\n    toString(): string;\n    /**\n      * Returns a string representation of an array. The elements are converted to string using their toLocalString methods.\n      */\n    toLocaleString(): string;\n    /**\n      * Removes the last element from an array and returns it.\n      */\n    pop(): T | undefined;\n    /**\n      * Appends new elements to an array, and returns the new length of the array.\n      * @param items New elements of the Array.\n      */\n    push(...items: T[]): number;\n    /**\n      * Combines two or more arrays.\n      * @param items Additional items to add to the end of array1.\n      */\n    concat(...items: ConcatArray<T>[]): T[];\n    /**\n      * Combines two or more arrays.\n      * @param items Additional items to add to the end of array1.\n      */\n    concat(...items: (T | ConcatArray<T>)[]): T[];\n    /**\n      * Adds all the elements of an array separated by the specified separator string.\n      * @param separator A string used to separate one element of an array from the next in the resulting String. If omitted, the array elements are separated with a comma.\n      */\n    join(separator?: string): string;\n    /**\n      * Reverses the elements in an Array.\n      */\n    reverse(): T[];\n    /**\n      * Removes the first element from an array and returns it.\n      */\n    shift(): T | undefined;\n    /**\n      * Returns a section of an array.\n      * @param start The beginning of the specified portion of the array.\n      * @param end The end of the specified portion of the array.\n      */\n    slice(start?: number, end?: number): T[];\n    /**\n      * Sorts an array.\n      * @param compareFn The name of the function used to determine the order of the elements. If omitted, the elements are sorted in ascending, ASCII character order.\n      */\n    sort(compareFn?: (a: T, b: T) => number): this;\n    /**\n      * Removes elements from an array and, if necessary, inserts new elements in their place, returning the deleted elements.\n      * @param start The zero-based location in the array from which to start removing elements.\n      * @param deleteCount The number of elements to remove.\n      */\n    splice(start: number, deleteCount?: number): T[];\n    /**\n      * Removes elements from an array and, if necessary, inserts new elements in their place, returning the deleted elements.\n      * @param start The zero-based location in the array from which to start removing elements.\n      * @param deleteCount The number of elements to remove.\n      * @param items Elements to insert into the array in place of the deleted elements.\n      */\n    splice(start: number, deleteCount: number, ...items: T[]): T[];\n    /**\n      * Inserts new elements at the start of an array.\n      * @param items  Elements to insert at the start of the Array.\n      */\n    unshift(...items: T[]): number;\n    /**\n      * Returns the index of the first occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the search starts at index 0.\n      */\n    indexOf(searchElement: T, fromIndex?: number): number;\n    /**\n      * Returns the index of the last occurrence of a specified value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the search starts at the last index in the array.\n      */\n    lastIndexOf(searchElement: T, fromIndex?: number): number;\n    /**\n      * Determines whether all the members of an array satisfy the specified test.\n      * @param callbackfn A function that accepts up to three arguments. The every method calls the callbackfn function for each element in array1 until the callbackfn returns false, or until the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n      */\n    every(callbackfn: (value: T, index: number, array: T[]) => unknown, thisArg?: any): boolean;\n    /**\n      * Determines whether the specified callback function returns true for any element of an array.\n      * @param callbackfn A function that accepts up to three arguments. The some method calls the callbackfn function for each element in array1 until the callbackfn returns true, or until the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n      */\n    some(callbackfn: (value: T, index: number, array: T[]) => unknown, thisArg?: any): boolean;\n    /**\n      * Performs the specified action for each element in an array.\n      * @param callbackfn  A function that accepts up to three arguments. forEach calls the callbackfn function one time for each element in the array.\n      * @param thisArg  An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n      */\n    forEach(callbackfn: (value: T, index: number, array: T[]) => void, thisArg?: any): void;\n    /**\n      * Calls a defined callback function on each element of an array, and returns an array that contains the results.\n      * @param callbackfn A function that accepts up to three arguments. The map method calls the callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n      */\n    map<U>(callbackfn: (value: T, index: number, array: T[]) => U, thisArg?: any): U[];\n    /**\n     * Returns the elements of an array that meet the condition specified in a callback function.\n     * @param callbackfn A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.\n     * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n     */\n    filter<S extends T>(callbackfn: (value: T, index: number, array: T[]) => value is S, thisArg?: any): S[];\n    /**\n      * Returns the elements of an array that meet the condition specified in a callback function.\n      * @param callbackfn A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.\n      */\n    filter(callbackfn: (value: T, index: number, array: T[]) => unknown, thisArg?: any): T[];\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.\n      */\n    reduce(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: T[]) => T): T;\n    reduce(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: T[]) => T, initialValue: T): T;\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.\n      */\n    reduce<U>(callbackfn: (previousValue: U, currentValue: T, currentIndex: number, array: T[]) => U, initialValue: U): U;\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.\n      */\n    reduceRight(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: T[]) => T): T;\n    reduceRight(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: T[]) => T, initialValue: T): T;\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.\n      */\n    reduceRight<U>(callbackfn: (previousValue: U, currentValue: T, currentIndex: number, array: T[]) => U, initialValue: U): U;\n\n    [n: number]: T;\n}\n\ninterface ArrayConstructor {\n    new(arrayLength?: number): any[];\n    new <T>(arrayLength: number): T[];\n    new <T>(...items: T[]): T[];\n    (arrayLength?: number): any[];\n    <T>(arrayLength: number): T[];\n    <T>(...items: T[]): T[];\n    isArray(arg: any): arg is Array<any>;\n    readonly prototype: Array<any>;\n}\n\ndeclare var Array: ArrayConstructor;\n\ninterface TypedPropertyDescriptor<T> {\n    enumerable?: boolean;\n    configurable?: boolean;\n    writable?: boolean;\n    value?: T;\n    get?: () => T;\n    set?: (value: T) => void;\n}\n\ndeclare type ClassDecorator = <TFunction extends Function>(target: TFunction) => TFunction | void;\ndeclare type PropertyDecorator = (target: Object, propertyKey: string | symbol) => void;\ndeclare type MethodDecorator = <T>(target: Object, propertyKey: string | symbol, descriptor: TypedPropertyDescriptor<T>) => TypedPropertyDescriptor<T> | void;\ndeclare type ParameterDecorator = (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;\n\ndeclare type PromiseConstructorLike = new <T>(executor: (resolve: (value?: T | PromiseLike<T>) => void, reject: (reason?: any) => void) => void) => PromiseLike<T>;\n\ninterface PromiseLike<T> {\n    /**\n     * Attaches callbacks for the resolution and/or rejection of the Promise.\n     * @param onfulfilled The callback to execute when the Promise is resolved.\n     * @param onrejected The callback to execute when the Promise is rejected.\n     * @returns A Promise for the completion of which ever callback is executed.\n     */\n    then<TResult1 = T, TResult2 = never>(onfulfilled?: ((value: T) => TResult1 | PromiseLike<TResult1>) | undefined | null, onrejected?: ((reason: any) => TResult2 | PromiseLike<TResult2>) | undefined | null): PromiseLike<TResult1 | TResult2>;\n}\n\n/**\n * Represents the completion of an asynchronous operation\n */\ninterface Promise<T> {\n    /**\n     * Attaches callbacks for the resolution and/or rejection of the Promise.\n     * @param onfulfilled The callback to execute when the Promise is resolved.\n     * @param onrejected The callback to execute when the Promise is rejected.\n     * @returns A Promise for the completion of which ever callback is executed.\n     */\n    then<TResult1 = T, TResult2 = never>(onfulfilled?: ((value: T) => TResult1 | PromiseLike<TResult1>) | undefined | null, onrejected?: ((reason: any) => TResult2 | PromiseLike<TResult2>) | undefined | null): Promise<TResult1 | TResult2>;\n\n    /**\n     * Attaches a callback for only the rejection of the Promise.\n     * @param onrejected The callback to execute when the Promise is rejected.\n     * @returns A Promise for the completion of the callback.\n     */\n    catch<TResult = never>(onrejected?: ((reason: any) => TResult | PromiseLike<TResult>) | undefined | null): Promise<T | TResult>;\n}\n\ninterface ArrayLike<T> {\n    readonly length: number;\n    readonly [n: number]: T;\n}\n\n/**\n * Make all properties in T optional\n */\ntype Partial<T> = {\n    [P in keyof T]?: T[P];\n};\n\n/**\n * Make all properties in T required\n */\ntype Required<T> = {\n    [P in keyof T]-?: T[P];\n};\n\n/**\n * Make all properties in T readonly\n */\ntype Readonly<T> = {\n    readonly [P in keyof T]: T[P];\n};\n\n/**\n * From T, pick a set of properties whose keys are in the union K\n */\ntype Pick<T, K extends keyof T> = {\n    [P in K]: T[P];\n};\n\n/**\n * Construct a type with a set of properties K of type T\n */\ntype Record<K extends keyof any, T> = {\n    [P in K]: T;\n};\n\n/**\n * Exclude from T those types that are assignable to U\n */\ntype Exclude<T, U> = T extends U ? never : T;\n\n/**\n * Extract from T those types that are assignable to U\n */\ntype Extract<T, U> = T extends U ? T : never;\n\n/**\n * Construct a type with the properties of T except for those in type K.\n */\ntype Omit<T, K extends keyof any> = Pick<T, Exclude<keyof T, K>>;\n\n/**\n * Exclude null and undefined from T\n */\ntype NonNullable<T> = T extends null | undefined ? never : T;\n\n/**\n * Obtain the parameters of a function type in a tuple\n */\ntype Parameters<T extends (...args: any) => any> = T extends (...args: infer P) => any ? P : never;\n\n/**\n * Obtain the parameters of a constructor function type in a tuple\n */\ntype ConstructorParameters<T extends new (...args: any) => any> = T extends new (...args: infer P) => any ? P : never;\n\n/**\n * Obtain the return type of a function type\n */\ntype ReturnType<T extends (...args: any) => any> = T extends (...args: any) => infer R ? R : any;\n\n/**\n * Obtain the return type of a constructor function type\n */\ntype InstanceType<T extends new (...args: any) => any> = T extends new (...args: any) => infer R ? R : any;\n\n/**\n * Marker for contextual 'this' type\n */\ninterface ThisType<T> { }\n\n/**\n  * Represents a raw buffer of binary data, which is used to store data for the\n  * different typed arrays. ArrayBuffers cannot be read from or written to directly,\n  * but can be passed to a typed array or DataView Object to interpret the raw\n  * buffer as needed.\n  */\ninterface ArrayBuffer {\n    /**\n      * Read-only. The length of the ArrayBuffer (in bytes).\n      */\n    readonly byteLength: number;\n\n    /**\n      * Returns a section of an ArrayBuffer.\n      */\n    slice(begin: number, end?: number): ArrayBuffer;\n}\n\n/**\n * Allowed ArrayBuffer types for the buffer of an ArrayBufferView and related Typed Arrays.\n */\ninterface ArrayBufferTypes {\n    ArrayBuffer: ArrayBuffer;\n}\ntype ArrayBufferLike = ArrayBufferTypes[keyof ArrayBufferTypes];\n\ninterface ArrayBufferConstructor {\n    readonly prototype: ArrayBuffer;\n    new(byteLength: number): ArrayBuffer;\n    isView(arg: any): arg is ArrayBufferView;\n}\ndeclare var ArrayBuffer: ArrayBufferConstructor;\n\ninterface ArrayBufferView {\n    /**\n      * The ArrayBuffer instance referenced by the array.\n      */\n    buffer: ArrayBufferLike;\n\n    /**\n      * The length in bytes of the array.\n      */\n    byteLength: number;\n\n    /**\n      * The offset in bytes of the array.\n      */\n    byteOffset: number;\n}\n\ninterface DataView {\n    readonly buffer: ArrayBuffer;\n    readonly byteLength: number;\n    readonly byteOffset: number;\n    /**\n      * Gets the Float32 value at the specified byte offset from the start of the view. There is\n      * no alignment constraint; multi-byte values may be fetched from any offset.\n      * @param byteOffset The place in the buffer at which the value should be retrieved.\n      */\n    getFloat32(byteOffset: number, littleEndian?: boolean): number;\n\n    /**\n      * Gets the Float64 value at the specified byte offset from the start of the view. There is\n      * no alignment constraint; multi-byte values may be fetched from any offset.\n      * @param byteOffset The place in the buffer at which the value should be retrieved.\n      */\n    getFloat64(byteOffset: number, littleEndian?: boolean): number;\n\n    /**\n      * Gets the Int8 value at the specified byte offset from the start of the view. There is\n      * no alignment constraint; multi-byte values may be fetched from any offset.\n      * @param byteOffset The place in the buffer at which the value should be retrieved.\n      */\n    getInt8(byteOffset: number): number;\n\n    /**\n      * Gets the Int16 value at the specified byte offset from the start of the view. There is\n      * no alignment constraint; multi-byte values may be fetched from any offset.\n      * @param byteOffset The place in the buffer at which the value should be retrieved.\n      */\n    getInt16(byteOffset: number, littleEndian?: boolean): number;\n    /**\n      * Gets the Int32 value at the specified byte offset from the start of the view. There is\n      * no alignment constraint; multi-byte values may be fetched from any offset.\n      * @param byteOffset The place in the buffer at which the value should be retrieved.\n      */\n    getInt32(byteOffset: number, littleEndian?: boolean): number;\n\n    /**\n      * Gets the Uint8 value at the specified byte offset from the start of the view. There is\n      * no alignment constraint; multi-byte values may be fetched from any offset.\n      * @param byteOffset The place in the buffer at which the value should be retrieved.\n      */\n    getUint8(byteOffset: number): number;\n\n    /**\n      * Gets the Uint16 value at the specified byte offset from the start of the view. There is\n      * no alignment constraint; multi-byte values may be fetched from any offset.\n      * @param byteOffset The place in the buffer at which the value should be retrieved.\n      */\n    getUint16(byteOffset: number, littleEndian?: boolean): number;\n\n    /**\n      * Gets the Uint32 value at the specified byte offset from the start of the view. There is\n      * no alignment constraint; multi-byte values may be fetched from any offset.\n      * @param byteOffset The place in the buffer at which the value should be retrieved.\n      */\n    getUint32(byteOffset: number, littleEndian?: boolean): number;\n\n    /**\n      * Stores an Float32 value at the specified byte offset from the start of the view.\n      * @param byteOffset The place in the buffer at which the value should be set.\n      * @param value The value to set.\n      * @param littleEndian If false or undefined, a big-endian value should be written,\n      * otherwise a little-endian value should be written.\n      */\n    setFloat32(byteOffset: number, value: number, littleEndian?: boolean): void;\n\n    /**\n      * Stores an Float64 value at the specified byte offset from the start of the view.\n      * @param byteOffset The place in the buffer at which the value should be set.\n      * @param value The value to set.\n      * @param littleEndian If false or undefined, a big-endian value should be written,\n      * otherwise a little-endian value should be written.\n      */\n    setFloat64(byteOffset: number, value: number, littleEndian?: boolean): void;\n\n    /**\n      * Stores an Int8 value at the specified byte offset from the start of the view.\n      * @param byteOffset The place in the buffer at which the value should be set.\n      * @param value The value to set.\n      */\n    setInt8(byteOffset: number, value: number): void;\n\n    /**\n      * Stores an Int16 value at the specified byte offset from the start of the view.\n      * @param byteOffset The place in the buffer at which the value should be set.\n      * @param value The value to set.\n      * @param littleEndian If false or undefined, a big-endian value should be written,\n      * otherwise a little-endian value should be written.\n      */\n    setInt16(byteOffset: number, value: number, littleEndian?: boolean): void;\n\n    /**\n      * Stores an Int32 value at the specified byte offset from the start of the view.\n      * @param byteOffset The place in the buffer at which the value should be set.\n      * @param value The value to set.\n      * @param littleEndian If false or undefined, a big-endian value should be written,\n      * otherwise a little-endian value should be written.\n      */\n    setInt32(byteOffset: number, value: number, littleEndian?: boolean): void;\n\n    /**\n      * Stores an Uint8 value at the specified byte offset from the start of the view.\n      * @param byteOffset The place in the buffer at which the value should be set.\n      * @param value The value to set.\n      */\n    setUint8(byteOffset: number, value: number): void;\n\n    /**\n      * Stores an Uint16 value at the specified byte offset from the start of the view.\n      * @param byteOffset The place in the buffer at which the value should be set.\n      * @param value The value to set.\n      * @param littleEndian If false or undefined, a big-endian value should be written,\n      * otherwise a little-endian value should be written.\n      */\n    setUint16(byteOffset: number, value: number, littleEndian?: boolean): void;\n\n    /**\n      * Stores an Uint32 value at the specified byte offset from the start of the view.\n      * @param byteOffset The place in the buffer at which the value should be set.\n      * @param value The value to set.\n      * @param littleEndian If false or undefined, a big-endian value should be written,\n      * otherwise a little-endian value should be written.\n      */\n    setUint32(byteOffset: number, value: number, littleEndian?: boolean): void;\n}\n\ninterface DataViewConstructor {\n    new(buffer: ArrayBufferLike, byteOffset?: number, byteLength?: number): DataView;\n}\ndeclare var DataView: DataViewConstructor;\n\n/**\n  * A typed array of 8-bit integer values. The contents are initialized to 0. If the requested\n  * number of bytes could not be allocated an exception is raised.\n  */\ninterface Int8Array {\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * The ArrayBuffer instance referenced by the array.\n      */\n    readonly buffer: ArrayBufferLike;\n\n    /**\n      * The length in bytes of the array.\n      */\n    readonly byteLength: number;\n\n    /**\n      * The offset in bytes of the array.\n      */\n    readonly byteOffset: number;\n\n    /**\n      * Returns the this object after copying a section of the array identified by start and end\n      * to the same array starting at position target\n      * @param target If target is negative, it is treated as length+target where length is the\n      * length of the array.\n      * @param start If start is negative, it is treated as length+start. If end is negative, it\n      * is treated as length+end.\n      * @param end If not specified, length of the this object is used as its default value.\n      */\n    copyWithin(target: number, start: number, end?: number): this;\n\n    /**\n      * Determines whether all the members of an array satisfy the specified test.\n      * @param callbackfn A function that accepts up to three arguments. The every method calls\n      * the callbackfn function for each element in array1 until the callbackfn returns false,\n      * or until the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    every(callbackfn: (value: number, index: number, array: Int8Array) => boolean, thisArg?: any): boolean;\n\n    /**\n        * Returns the this object after filling the section identified by start and end with value\n        * @param value value to fill array section with\n        * @param start index to start filling the array at. If start is negative, it is treated as\n        * length+start where length is the length of the array.\n        * @param end index to stop filling the array at. If end is negative, it is treated as\n        * length+end.\n        */\n    fill(value: number, start?: number, end?: number): this;\n\n    /**\n      * Returns the elements of an array that meet the condition specified in a callback function.\n      * @param callbackfn A function that accepts up to three arguments. The filter method calls\n      * the callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    filter(callbackfn: (value: number, index: number, array: Int8Array) => any, thisArg?: any): Int8Array;\n\n    /**\n      * Returns the value of the first element in the array where predicate is true, and undefined\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found, find\n      * immediately returns that element value. Otherwise, find returns undefined.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    find(predicate: (value: number, index: number, obj: Int8Array) => boolean, thisArg?: any): number | undefined;\n\n    /**\n      * Returns the index of the first element in the array where predicate is true, and -1\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found,\n      * findIndex immediately returns that element index. Otherwise, findIndex returns -1.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    findIndex(predicate: (value: number, index: number, obj: Int8Array) => boolean, thisArg?: any): number;\n\n    /**\n      * Performs the specified action for each element in an array.\n      * @param callbackfn  A function that accepts up to three arguments. forEach calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg  An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    forEach(callbackfn: (value: number, index: number, array: Int8Array) => void, thisArg?: any): void;\n\n    /**\n      * Returns the index of the first occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      *  search starts at index 0.\n      */\n    indexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * Adds all the elements of an array separated by the specified separator string.\n      * @param separator A string used to separate one element of an array from the next in the\n      * resulting String. If omitted, the array elements are separated with a comma.\n      */\n    join(separator?: string): string;\n\n    /**\n      * Returns the index of the last occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      * search starts at index 0.\n      */\n    lastIndexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * The length of the array.\n      */\n    readonly length: number;\n\n    /**\n      * Calls a defined callback function on each element of an array, and returns an array that\n      * contains the results.\n      * @param callbackfn A function that accepts up to three arguments. The map method calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    map(callbackfn: (value: number, index: number, array: Int8Array) => number, thisArg?: any): Int8Array;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Int8Array) => number): number;\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Int8Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Int8Array) => U, initialValue: U): U;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an\n      * argument instead of an array value.\n      */\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Int8Array) => number): number;\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Int8Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduceRight<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Int8Array) => U, initialValue: U): U;\n\n    /**\n      * Reverses the elements in an Array.\n      */\n    reverse(): Int8Array;\n\n    /**\n      * Sets a value or an array of values.\n      * @param array A typed or untyped array of values to set.\n      * @param offset The index in the current array at which the values are to be written.\n      */\n    set(array: ArrayLike<number>, offset?: number): void;\n\n    /**\n      * Returns a section of an array.\n      * @param start The beginning of the specified portion of the array.\n      * @param end The end of the specified portion of the array.\n      */\n    slice(start?: number, end?: number): Int8Array;\n\n    /**\n      * Determines whether the specified callback function returns true for any element of an array.\n      * @param callbackfn A function that accepts up to three arguments. The some method calls the\n      * callbackfn function for each element in array1 until the callbackfn returns true, or until\n      * the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    some(callbackfn: (value: number, index: number, array: Int8Array) => boolean, thisArg?: any): boolean;\n\n    /**\n      * Sorts an array.\n      * @param compareFn The name of the function used to determine the order of the elements. If\n      * omitted, the elements are sorted in ascending, ASCII character order.\n      */\n    sort(compareFn?: (a: number, b: number) => number): this;\n\n    /**\n      * Gets a new Int8Array view of the ArrayBuffer store for this array, referencing the elements\n      * at begin, inclusive, up to end, exclusive.\n      * @param begin The index of the beginning of the array.\n      * @param end The index of the end of the array.\n      */\n    subarray(begin: number, end?: number): Int8Array;\n\n    /**\n      * Converts a number to a string by using the current locale.\n      */\n    toLocaleString(): string;\n\n    /**\n      * Returns a string representation of an array.\n      */\n    toString(): string;\n\n    [index: number]: number;\n}\ninterface Int8ArrayConstructor {\n    readonly prototype: Int8Array;\n    new(length: number): Int8Array;\n    new(arrayOrArrayBuffer: ArrayLike<number> | ArrayBufferLike): Int8Array;\n    new(buffer: ArrayBufferLike, byteOffset: number, length?: number): Int8Array;\n\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * Returns a new array from a set of elements.\n      * @param items A set of elements to include in the new array object.\n      */\n    of(...items: number[]): Int8Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      */\n    from(arrayLike: ArrayLike<number>): Int8Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      * @param mapfn A mapping function to call on every element of the array.\n      * @param thisArg Value of 'this' used to invoke the mapfn.\n      */\n    from<T>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => number, thisArg?: any): Int8Array;\n\n\n}\ndeclare var Int8Array: Int8ArrayConstructor;\n\n/**\n  * A typed array of 8-bit unsigned integer values. The contents are initialized to 0. If the\n  * requested number of bytes could not be allocated an exception is raised.\n  */\ninterface Uint8Array {\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * The ArrayBuffer instance referenced by the array.\n      */\n    readonly buffer: ArrayBufferLike;\n\n    /**\n      * The length in bytes of the array.\n      */\n    readonly byteLength: number;\n\n    /**\n      * The offset in bytes of the array.\n      */\n    readonly byteOffset: number;\n\n    /**\n      * Returns the this object after copying a section of the array identified by start and end\n      * to the same array starting at position target\n      * @param target If target is negative, it is treated as length+target where length is the\n      * length of the array.\n      * @param start If start is negative, it is treated as length+start. If end is negative, it\n      * is treated as length+end.\n      * @param end If not specified, length of the this object is used as its default value.\n      */\n    copyWithin(target: number, start: number, end?: number): this;\n\n    /**\n      * Determines whether all the members of an array satisfy the specified test.\n      * @param callbackfn A function that accepts up to three arguments. The every method calls\n      * the callbackfn function for each element in array1 until the callbackfn returns false,\n      * or until the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    every(callbackfn: (value: number, index: number, array: Uint8Array) => boolean, thisArg?: any): boolean;\n\n    /**\n        * Returns the this object after filling the section identified by start and end with value\n        * @param value value to fill array section with\n        * @param start index to start filling the array at. If start is negative, it is treated as\n        * length+start where length is the length of the array.\n        * @param end index to stop filling the array at. If end is negative, it is treated as\n        * length+end.\n        */\n    fill(value: number, start?: number, end?: number): this;\n\n    /**\n      * Returns the elements of an array that meet the condition specified in a callback function.\n      * @param callbackfn A function that accepts up to three arguments. The filter method calls\n      * the callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    filter(callbackfn: (value: number, index: number, array: Uint8Array) => any, thisArg?: any): Uint8Array;\n\n    /**\n      * Returns the value of the first element in the array where predicate is true, and undefined\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found, find\n      * immediately returns that element value. Otherwise, find returns undefined.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    find(predicate: (value: number, index: number, obj: Uint8Array) => boolean, thisArg?: any): number | undefined;\n\n    /**\n      * Returns the index of the first element in the array where predicate is true, and -1\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found,\n      * findIndex immediately returns that element index. Otherwise, findIndex returns -1.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    findIndex(predicate: (value: number, index: number, obj: Uint8Array) => boolean, thisArg?: any): number;\n\n    /**\n      * Performs the specified action for each element in an array.\n      * @param callbackfn  A function that accepts up to three arguments. forEach calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg  An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    forEach(callbackfn: (value: number, index: number, array: Uint8Array) => void, thisArg?: any): void;\n\n    /**\n      * Returns the index of the first occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      *  search starts at index 0.\n      */\n    indexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * Adds all the elements of an array separated by the specified separator string.\n      * @param separator A string used to separate one element of an array from the next in the\n      * resulting String. If omitted, the array elements are separated with a comma.\n      */\n    join(separator?: string): string;\n\n    /**\n      * Returns the index of the last occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      * search starts at index 0.\n      */\n    lastIndexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * The length of the array.\n      */\n    readonly length: number;\n\n    /**\n      * Calls a defined callback function on each element of an array, and returns an array that\n      * contains the results.\n      * @param callbackfn A function that accepts up to three arguments. The map method calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    map(callbackfn: (value: number, index: number, array: Uint8Array) => number, thisArg?: any): Uint8Array;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array) => number): number;\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Uint8Array) => U, initialValue: U): U;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an\n      * argument instead of an array value.\n      */\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array) => number): number;\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduceRight<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Uint8Array) => U, initialValue: U): U;\n\n    /**\n      * Reverses the elements in an Array.\n      */\n    reverse(): Uint8Array;\n\n    /**\n      * Sets a value or an array of values.\n      * @param array A typed or untyped array of values to set.\n      * @param offset The index in the current array at which the values are to be written.\n      */\n    set(array: ArrayLike<number>, offset?: number): void;\n\n    /**\n      * Returns a section of an array.\n      * @param start The beginning of the specified portion of the array.\n      * @param end The end of the specified portion of the array.\n      */\n    slice(start?: number, end?: number): Uint8Array;\n\n    /**\n      * Determines whether the specified callback function returns true for any element of an array.\n      * @param callbackfn A function that accepts up to three arguments. The some method calls the\n      * callbackfn function for each element in array1 until the callbackfn returns true, or until\n      * the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    some(callbackfn: (value: number, index: number, array: Uint8Array) => boolean, thisArg?: any): boolean;\n\n    /**\n      * Sorts an array.\n      * @param compareFn The name of the function used to determine the order of the elements. If\n      * omitted, the elements are sorted in ascending, ASCII character order.\n      */\n    sort(compareFn?: (a: number, b: number) => number): this;\n\n    /**\n      * Gets a new Uint8Array view of the ArrayBuffer store for this array, referencing the elements\n      * at begin, inclusive, up to end, exclusive.\n      * @param begin The index of the beginning of the array.\n      * @param end The index of the end of the array.\n      */\n    subarray(begin: number, end?: number): Uint8Array;\n\n    /**\n      * Converts a number to a string by using the current locale.\n      */\n    toLocaleString(): string;\n\n    /**\n      * Returns a string representation of an array.\n      */\n    toString(): string;\n\n    [index: number]: number;\n}\n\ninterface Uint8ArrayConstructor {\n    readonly prototype: Uint8Array;\n    new(length: number): Uint8Array;\n    new(arrayOrArrayBuffer: ArrayLike<number> | ArrayBufferLike): Uint8Array;\n    new(buffer: ArrayBufferLike, byteOffset: number, length?: number): Uint8Array;\n\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * Returns a new array from a set of elements.\n      * @param items A set of elements to include in the new array object.\n      */\n    of(...items: number[]): Uint8Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      */\n    from(arrayLike: ArrayLike<number>): Uint8Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      * @param mapfn A mapping function to call on every element of the array.\n      * @param thisArg Value of 'this' used to invoke the mapfn.\n      */\n    from<T>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => number, thisArg?: any): Uint8Array;\n\n}\ndeclare var Uint8Array: Uint8ArrayConstructor;\n\n/**\n  * A typed array of 8-bit unsigned integer (clamped) values. The contents are initialized to 0.\n  * If the requested number of bytes could not be allocated an exception is raised.\n  */\ninterface Uint8ClampedArray {\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * The ArrayBuffer instance referenced by the array.\n      */\n    readonly buffer: ArrayBufferLike;\n\n    /**\n      * The length in bytes of the array.\n      */\n    readonly byteLength: number;\n\n    /**\n      * The offset in bytes of the array.\n      */\n    readonly byteOffset: number;\n\n    /**\n      * Returns the this object after copying a section of the array identified by start and end\n      * to the same array starting at position target\n      * @param target If target is negative, it is treated as length+target where length is the\n      * length of the array.\n      * @param start If start is negative, it is treated as length+start. If end is negative, it\n      * is treated as length+end.\n      * @param end If not specified, length of the this object is used as its default value.\n      */\n    copyWithin(target: number, start: number, end?: number): this;\n\n    /**\n      * Determines whether all the members of an array satisfy the specified test.\n      * @param callbackfn A function that accepts up to three arguments. The every method calls\n      * the callbackfn function for each element in array1 until the callbackfn returns false,\n      * or until the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    every(callbackfn: (value: number, index: number, array: Uint8ClampedArray) => boolean, thisArg?: any): boolean;\n\n    /**\n        * Returns the this object after filling the section identified by start and end with value\n        * @param value value to fill array section with\n        * @param start index to start filling the array at. If start is negative, it is treated as\n        * length+start where length is the length of the array.\n        * @param end index to stop filling the array at. If end is negative, it is treated as\n        * length+end.\n        */\n    fill(value: number, start?: number, end?: number): this;\n\n    /**\n      * Returns the elements of an array that meet the condition specified in a callback function.\n      * @param callbackfn A function that accepts up to three arguments. The filter method calls\n      * the callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    filter(callbackfn: (value: number, index: number, array: Uint8ClampedArray) => any, thisArg?: any): Uint8ClampedArray;\n\n    /**\n      * Returns the value of the first element in the array where predicate is true, and undefined\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found, find\n      * immediately returns that element value. Otherwise, find returns undefined.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    find(predicate: (value: number, index: number, obj: Uint8ClampedArray) => boolean, thisArg?: any): number | undefined;\n\n    /**\n      * Returns the index of the first element in the array where predicate is true, and -1\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found,\n      * findIndex immediately returns that element index. Otherwise, findIndex returns -1.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    findIndex(predicate: (value: number, index: number, obj: Uint8ClampedArray) => boolean, thisArg?: any): number;\n\n    /**\n      * Performs the specified action for each element in an array.\n      * @param callbackfn  A function that accepts up to three arguments. forEach calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg  An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    forEach(callbackfn: (value: number, index: number, array: Uint8ClampedArray) => void, thisArg?: any): void;\n\n    /**\n      * Returns the index of the first occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      *  search starts at index 0.\n      */\n    indexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * Adds all the elements of an array separated by the specified separator string.\n      * @param separator A string used to separate one element of an array from the next in the\n      * resulting String. If omitted, the array elements are separated with a comma.\n      */\n    join(separator?: string): string;\n\n    /**\n      * Returns the index of the last occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      * search starts at index 0.\n      */\n    lastIndexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * The length of the array.\n      */\n    readonly length: number;\n\n    /**\n      * Calls a defined callback function on each element of an array, and returns an array that\n      * contains the results.\n      * @param callbackfn A function that accepts up to three arguments. The map method calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    map(callbackfn: (value: number, index: number, array: Uint8ClampedArray) => number, thisArg?: any): Uint8ClampedArray;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8ClampedArray) => number): number;\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8ClampedArray) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Uint8ClampedArray) => U, initialValue: U): U;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an\n      * argument instead of an array value.\n      */\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8ClampedArray) => number): number;\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8ClampedArray) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduceRight<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Uint8ClampedArray) => U, initialValue: U): U;\n\n    /**\n      * Reverses the elements in an Array.\n      */\n    reverse(): Uint8ClampedArray;\n\n    /**\n      * Sets a value or an array of values.\n      * @param array A typed or untyped array of values to set.\n      * @param offset The index in the current array at which the values are to be written.\n      */\n    set(array: ArrayLike<number>, offset?: number): void;\n\n    /**\n      * Returns a section of an array.\n      * @param start The beginning of the specified portion of the array.\n      * @param end The end of the specified portion of the array.\n      */\n    slice(start?: number, end?: number): Uint8ClampedArray;\n\n    /**\n      * Determines whether the specified callback function returns true for any element of an array.\n      * @param callbackfn A function that accepts up to three arguments. The some method calls the\n      * callbackfn function for each element in array1 until the callbackfn returns true, or until\n      * the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    some(callbackfn: (value: number, index: number, array: Uint8ClampedArray) => boolean, thisArg?: any): boolean;\n\n    /**\n      * Sorts an array.\n      * @param compareFn The name of the function used to determine the order of the elements. If\n      * omitted, the elements are sorted in ascending, ASCII character order.\n      */\n    sort(compareFn?: (a: number, b: number) => number): this;\n\n    /**\n      * Gets a new Uint8ClampedArray view of the ArrayBuffer store for this array, referencing the elements\n      * at begin, inclusive, up to end, exclusive.\n      * @param begin The index of the beginning of the array.\n      * @param end The index of the end of the array.\n      */\n    subarray(begin: number, end?: number): Uint8ClampedArray;\n\n    /**\n      * Converts a number to a string by using the current locale.\n      */\n    toLocaleString(): string;\n\n    /**\n      * Returns a string representation of an array.\n      */\n    toString(): string;\n\n    [index: number]: number;\n}\n\ninterface Uint8ClampedArrayConstructor {\n    readonly prototype: Uint8ClampedArray;\n    new(length: number): Uint8ClampedArray;\n    new(arrayOrArrayBuffer: ArrayLike<number> | ArrayBufferLike): Uint8ClampedArray;\n    new(buffer: ArrayBufferLike, byteOffset: number, length?: number): Uint8ClampedArray;\n\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * Returns a new array from a set of elements.\n      * @param items A set of elements to include in the new array object.\n      */\n    of(...items: number[]): Uint8ClampedArray;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      */\n    from(arrayLike: ArrayLike<number>): Uint8ClampedArray;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      * @param mapfn A mapping function to call on every element of the array.\n      * @param thisArg Value of 'this' used to invoke the mapfn.\n      */\n    from<T>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => number, thisArg?: any): Uint8ClampedArray;\n}\ndeclare var Uint8ClampedArray: Uint8ClampedArrayConstructor;\n\n/**\n  * A typed array of 16-bit signed integer values. The contents are initialized to 0. If the\n  * requested number of bytes could not be allocated an exception is raised.\n  */\ninterface Int16Array {\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * The ArrayBuffer instance referenced by the array.\n      */\n    readonly buffer: ArrayBufferLike;\n\n    /**\n      * The length in bytes of the array.\n      */\n    readonly byteLength: number;\n\n    /**\n      * The offset in bytes of the array.\n      */\n    readonly byteOffset: number;\n\n    /**\n      * Returns the this object after copying a section of the array identified by start and end\n      * to the same array starting at position target\n      * @param target If target is negative, it is treated as length+target where length is the\n      * length of the array.\n      * @param start If start is negative, it is treated as length+start. If end is negative, it\n      * is treated as length+end.\n      * @param end If not specified, length of the this object is used as its default value.\n      */\n    copyWithin(target: number, start: number, end?: number): this;\n\n    /**\n      * Determines whether all the members of an array satisfy the specified test.\n      * @param callbackfn A function that accepts up to three arguments. The every method calls\n      * the callbackfn function for each element in array1 until the callbackfn returns false,\n      * or until the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    every(callbackfn: (value: number, index: number, array: Int16Array) => boolean, thisArg?: any): boolean;\n\n    /**\n        * Returns the this object after filling the section identified by start and end with value\n        * @param value value to fill array section with\n        * @param start index to start filling the array at. If start is negative, it is treated as\n        * length+start where length is the length of the array.\n        * @param end index to stop filling the array at. If end is negative, it is treated as\n        * length+end.\n        */\n    fill(value: number, start?: number, end?: number): this;\n\n    /**\n      * Returns the elements of an array that meet the condition specified in a callback function.\n      * @param callbackfn A function that accepts up to three arguments. The filter method calls\n      * the callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    filter(callbackfn: (value: number, index: number, array: Int16Array) => any, thisArg?: any): Int16Array;\n\n    /**\n      * Returns the value of the first element in the array where predicate is true, and undefined\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found, find\n      * immediately returns that element value. Otherwise, find returns undefined.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    find(predicate: (value: number, index: number, obj: Int16Array) => boolean, thisArg?: any): number | undefined;\n\n    /**\n      * Returns the index of the first element in the array where predicate is true, and -1\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found,\n      * findIndex immediately returns that element index. Otherwise, findIndex returns -1.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    findIndex(predicate: (value: number, index: number, obj: Int16Array) => boolean, thisArg?: any): number;\n\n    /**\n      * Performs the specified action for each element in an array.\n      * @param callbackfn  A function that accepts up to three arguments. forEach calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg  An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    forEach(callbackfn: (value: number, index: number, array: Int16Array) => void, thisArg?: any): void;\n    /**\n      * Returns the index of the first occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      *  search starts at index 0.\n      */\n    indexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * Adds all the elements of an array separated by the specified separator string.\n      * @param separator A string used to separate one element of an array from the next in the\n      * resulting String. If omitted, the array elements are separated with a comma.\n      */\n    join(separator?: string): string;\n\n    /**\n      * Returns the index of the last occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      * search starts at index 0.\n      */\n    lastIndexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * The length of the array.\n      */\n    readonly length: number;\n\n    /**\n      * Calls a defined callback function on each element of an array, and returns an array that\n      * contains the results.\n      * @param callbackfn A function that accepts up to three arguments. The map method calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    map(callbackfn: (value: number, index: number, array: Int16Array) => number, thisArg?: any): Int16Array;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Int16Array) => number): number;\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Int16Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Int16Array) => U, initialValue: U): U;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an\n      * argument instead of an array value.\n      */\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Int16Array) => number): number;\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Int16Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduceRight<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Int16Array) => U, initialValue: U): U;\n\n    /**\n      * Reverses the elements in an Array.\n      */\n    reverse(): Int16Array;\n\n    /**\n      * Sets a value or an array of values.\n      * @param array A typed or untyped array of values to set.\n      * @param offset The index in the current array at which the values are to be written.\n      */\n    set(array: ArrayLike<number>, offset?: number): void;\n\n    /**\n      * Returns a section of an array.\n      * @param start The beginning of the specified portion of the array.\n      * @param end The end of the specified portion of the array.\n      */\n    slice(start?: number, end?: number): Int16Array;\n\n    /**\n      * Determines whether the specified callback function returns true for any element of an array.\n      * @param callbackfn A function that accepts up to three arguments. The some method calls the\n      * callbackfn function for each element in array1 until the callbackfn returns true, or until\n      * the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    some(callbackfn: (value: number, index: number, array: Int16Array) => boolean, thisArg?: any): boolean;\n\n    /**\n      * Sorts an array.\n      * @param compareFn The name of the function used to determine the order of the elements. If\n      * omitted, the elements are sorted in ascending, ASCII character order.\n      */\n    sort(compareFn?: (a: number, b: number) => number): this;\n\n    /**\n      * Gets a new Int16Array view of the ArrayBuffer store for this array, referencing the elements\n      * at begin, inclusive, up to end, exclusive.\n      * @param begin The index of the beginning of the array.\n      * @param end The index of the end of the array.\n      */\n    subarray(begin: number, end?: number): Int16Array;\n\n    /**\n      * Converts a number to a string by using the current locale.\n      */\n    toLocaleString(): string;\n\n    /**\n      * Returns a string representation of an array.\n      */\n    toString(): string;\n\n    [index: number]: number;\n}\n\ninterface Int16ArrayConstructor {\n    readonly prototype: Int16Array;\n    new(length: number): Int16Array;\n    new(arrayOrArrayBuffer: ArrayLike<number> | ArrayBufferLike): Int16Array;\n    new(buffer: ArrayBufferLike, byteOffset: number, length?: number): Int16Array;\n\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * Returns a new array from a set of elements.\n      * @param items A set of elements to include in the new array object.\n      */\n    of(...items: number[]): Int16Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      */\n    from(arrayLike: ArrayLike<number>): Int16Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      * @param mapfn A mapping function to call on every element of the array.\n      * @param thisArg Value of 'this' used to invoke the mapfn.\n      */\n    from<T>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => number, thisArg?: any): Int16Array;\n\n\n}\ndeclare var Int16Array: Int16ArrayConstructor;\n\n/**\n  * A typed array of 16-bit unsigned integer values. The contents are initialized to 0. If the\n  * requested number of bytes could not be allocated an exception is raised.\n  */\ninterface Uint16Array {\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * The ArrayBuffer instance referenced by the array.\n      */\n    readonly buffer: ArrayBufferLike;\n\n    /**\n      * The length in bytes of the array.\n      */\n    readonly byteLength: number;\n\n    /**\n      * The offset in bytes of the array.\n      */\n    readonly byteOffset: number;\n\n    /**\n      * Returns the this object after copying a section of the array identified by start and end\n      * to the same array starting at position target\n      * @param target If target is negative, it is treated as length+target where length is the\n      * length of the array.\n      * @param start If start is negative, it is treated as length+start. If end is negative, it\n      * is treated as length+end.\n      * @param end If not specified, length of the this object is used as its default value.\n      */\n    copyWithin(target: number, start: number, end?: number): this;\n\n    /**\n      * Determines whether all the members of an array satisfy the specified test.\n      * @param callbackfn A function that accepts up to three arguments. The every method calls\n      * the callbackfn function for each element in array1 until the callbackfn returns false,\n      * or until the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    every(callbackfn: (value: number, index: number, array: Uint16Array) => boolean, thisArg?: any): boolean;\n\n    /**\n        * Returns the this object after filling the section identified by start and end with value\n        * @param value value to fill array section with\n        * @param start index to start filling the array at. If start is negative, it is treated as\n        * length+start where length is the length of the array.\n        * @param end index to stop filling the array at. If end is negative, it is treated as\n        * length+end.\n        */\n    fill(value: number, start?: number, end?: number): this;\n\n    /**\n      * Returns the elements of an array that meet the condition specified in a callback function.\n      * @param callbackfn A function that accepts up to three arguments. The filter method calls\n      * the callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    filter(callbackfn: (value: number, index: number, array: Uint16Array) => any, thisArg?: any): Uint16Array;\n\n    /**\n      * Returns the value of the first element in the array where predicate is true, and undefined\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found, find\n      * immediately returns that element value. Otherwise, find returns undefined.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    find(predicate: (value: number, index: number, obj: Uint16Array) => boolean, thisArg?: any): number | undefined;\n\n    /**\n      * Returns the index of the first element in the array where predicate is true, and -1\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found,\n      * findIndex immediately returns that element index. Otherwise, findIndex returns -1.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    findIndex(predicate: (value: number, index: number, obj: Uint16Array) => boolean, thisArg?: any): number;\n\n    /**\n      * Performs the specified action for each element in an array.\n      * @param callbackfn  A function that accepts up to three arguments. forEach calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg  An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    forEach(callbackfn: (value: number, index: number, array: Uint16Array) => void, thisArg?: any): void;\n\n    /**\n      * Returns the index of the first occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      *  search starts at index 0.\n      */\n    indexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * Adds all the elements of an array separated by the specified separator string.\n      * @param separator A string used to separate one element of an array from the next in the\n      * resulting String. If omitted, the array elements are separated with a comma.\n      */\n    join(separator?: string): string;\n\n    /**\n      * Returns the index of the last occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      * search starts at index 0.\n      */\n    lastIndexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * The length of the array.\n      */\n    readonly length: number;\n\n    /**\n      * Calls a defined callback function on each element of an array, and returns an array that\n      * contains the results.\n      * @param callbackfn A function that accepts up to three arguments. The map method calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    map(callbackfn: (value: number, index: number, array: Uint16Array) => number, thisArg?: any): Uint16Array;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint16Array) => number): number;\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint16Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Uint16Array) => U, initialValue: U): U;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an\n      * argument instead of an array value.\n      */\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint16Array) => number): number;\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint16Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduceRight<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Uint16Array) => U, initialValue: U): U;\n\n    /**\n      * Reverses the elements in an Array.\n      */\n    reverse(): Uint16Array;\n\n    /**\n      * Sets a value or an array of values.\n      * @param array A typed or untyped array of values to set.\n      * @param offset The index in the current array at which the values are to be written.\n      */\n    set(array: ArrayLike<number>, offset?: number): void;\n\n    /**\n      * Returns a section of an array.\n      * @param start The beginning of the specified portion of the array.\n      * @param end The end of the specified portion of the array.\n      */\n    slice(start?: number, end?: number): Uint16Array;\n\n    /**\n      * Determines whether the specified callback function returns true for any element of an array.\n      * @param callbackfn A function that accepts up to three arguments. The some method calls the\n      * callbackfn function for each element in array1 until the callbackfn returns true, or until\n      * the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    some(callbackfn: (value: number, index: number, array: Uint16Array) => boolean, thisArg?: any): boolean;\n\n    /**\n      * Sorts an array.\n      * @param compareFn The name of the function used to determine the order of the elements. If\n      * omitted, the elements are sorted in ascending, ASCII character order.\n      */\n    sort(compareFn?: (a: number, b: number) => number): this;\n\n    /**\n      * Gets a new Uint16Array view of the ArrayBuffer store for this array, referencing the elements\n      * at begin, inclusive, up to end, exclusive.\n      * @param begin The index of the beginning of the array.\n      * @param end The index of the end of the array.\n      */\n    subarray(begin: number, end?: number): Uint16Array;\n\n    /**\n      * Converts a number to a string by using the current locale.\n      */\n    toLocaleString(): string;\n\n    /**\n      * Returns a string representation of an array.\n      */\n    toString(): string;\n\n    [index: number]: number;\n}\n\ninterface Uint16ArrayConstructor {\n    readonly prototype: Uint16Array;\n    new(length: number): Uint16Array;\n    new(arrayOrArrayBuffer: ArrayLike<number> | ArrayBufferLike): Uint16Array;\n    new(buffer: ArrayBufferLike, byteOffset: number, length?: number): Uint16Array;\n\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * Returns a new array from a set of elements.\n      * @param items A set of elements to include in the new array object.\n      */\n    of(...items: number[]): Uint16Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      */\n    from(arrayLike: ArrayLike<number>): Uint16Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      * @param mapfn A mapping function to call on every element of the array.\n      * @param thisArg Value of 'this' used to invoke the mapfn.\n      */\n    from<T>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => number, thisArg?: any): Uint16Array;\n\n\n}\ndeclare var Uint16Array: Uint16ArrayConstructor;\n/**\n  * A typed array of 32-bit signed integer values. The contents are initialized to 0. If the\n  * requested number of bytes could not be allocated an exception is raised.\n  */\ninterface Int32Array {\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * The ArrayBuffer instance referenced by the array.\n      */\n    readonly buffer: ArrayBufferLike;\n\n    /**\n      * The length in bytes of the array.\n      */\n    readonly byteLength: number;\n\n    /**\n      * The offset in bytes of the array.\n      */\n    readonly byteOffset: number;\n\n    /**\n      * Returns the this object after copying a section of the array identified by start and end\n      * to the same array starting at position target\n      * @param target If target is negative, it is treated as length+target where length is the\n      * length of the array.\n      * @param start If start is negative, it is treated as length+start. If end is negative, it\n      * is treated as length+end.\n      * @param end If not specified, length of the this object is used as its default value.\n      */\n    copyWithin(target: number, start: number, end?: number): this;\n\n    /**\n      * Determines whether all the members of an array satisfy the specified test.\n      * @param callbackfn A function that accepts up to three arguments. The every method calls\n      * the callbackfn function for each element in array1 until the callbackfn returns false,\n      * or until the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    every(callbackfn: (value: number, index: number, array: Int32Array) => boolean, thisArg?: any): boolean;\n\n    /**\n        * Returns the this object after filling the section identified by start and end with value\n        * @param value value to fill array section with\n        * @param start index to start filling the array at. If start is negative, it is treated as\n        * length+start where length is the length of the array.\n        * @param end index to stop filling the array at. If end is negative, it is treated as\n        * length+end.\n        */\n    fill(value: number, start?: number, end?: number): this;\n\n    /**\n      * Returns the elements of an array that meet the condition specified in a callback function.\n      * @param callbackfn A function that accepts up to three arguments. The filter method calls\n      * the callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    filter(callbackfn: (value: number, index: number, array: Int32Array) => any, thisArg?: any): Int32Array;\n\n    /**\n      * Returns the value of the first element in the array where predicate is true, and undefined\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found, find\n      * immediately returns that element value. Otherwise, find returns undefined.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    find(predicate: (value: number, index: number, obj: Int32Array) => boolean, thisArg?: any): number | undefined;\n\n    /**\n      * Returns the index of the first element in the array where predicate is true, and -1\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found,\n      * findIndex immediately returns that element index. Otherwise, findIndex returns -1.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    findIndex(predicate: (value: number, index: number, obj: Int32Array) => boolean, thisArg?: any): number;\n\n    /**\n      * Performs the specified action for each element in an array.\n      * @param callbackfn  A function that accepts up to three arguments. forEach calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg  An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    forEach(callbackfn: (value: number, index: number, array: Int32Array) => void, thisArg?: any): void;\n\n    /**\n      * Returns the index of the first occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      *  search starts at index 0.\n      */\n    indexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * Adds all the elements of an array separated by the specified separator string.\n      * @param separator A string used to separate one element of an array from the next in the\n      * resulting String. If omitted, the array elements are separated with a comma.\n      */\n    join(separator?: string): string;\n\n    /**\n      * Returns the index of the last occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      * search starts at index 0.\n      */\n    lastIndexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * The length of the array.\n      */\n    readonly length: number;\n\n    /**\n      * Calls a defined callback function on each element of an array, and returns an array that\n      * contains the results.\n      * @param callbackfn A function that accepts up to three arguments. The map method calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    map(callbackfn: (value: number, index: number, array: Int32Array) => number, thisArg?: any): Int32Array;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Int32Array) => number): number;\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Int32Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Int32Array) => U, initialValue: U): U;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an\n      * argument instead of an array value.\n      */\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Int32Array) => number): number;\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Int32Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduceRight<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Int32Array) => U, initialValue: U): U;\n\n    /**\n      * Reverses the elements in an Array.\n      */\n    reverse(): Int32Array;\n\n    /**\n      * Sets a value or an array of values.\n      * @param array A typed or untyped array of values to set.\n      * @param offset The index in the current array at which the values are to be written.\n      */\n    set(array: ArrayLike<number>, offset?: number): void;\n\n    /**\n      * Returns a section of an array.\n      * @param start The beginning of the specified portion of the array.\n      * @param end The end of the specified portion of the array.\n      */\n    slice(start?: number, end?: number): Int32Array;\n\n    /**\n      * Determines whether the specified callback function returns true for any element of an array.\n      * @param callbackfn A function that accepts up to three arguments. The some method calls the\n      * callbackfn function for each element in array1 until the callbackfn returns true, or until\n      * the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    some(callbackfn: (value: number, index: number, array: Int32Array) => boolean, thisArg?: any): boolean;\n\n    /**\n      * Sorts an array.\n      * @param compareFn The name of the function used to determine the order of the elements. If\n      * omitted, the elements are sorted in ascending, ASCII character order.\n      */\n    sort(compareFn?: (a: number, b: number) => number): this;\n\n    /**\n      * Gets a new Int32Array view of the ArrayBuffer store for this array, referencing the elements\n      * at begin, inclusive, up to end, exclusive.\n      * @param begin The index of the beginning of the array.\n      * @param end The index of the end of the array.\n      */\n    subarray(begin: number, end?: number): Int32Array;\n\n    /**\n      * Converts a number to a string by using the current locale.\n      */\n    toLocaleString(): string;\n\n    /**\n      * Returns a string representation of an array.\n      */\n    toString(): string;\n\n    [index: number]: number;\n}\n\ninterface Int32ArrayConstructor {\n    readonly prototype: Int32Array;\n    new(length: number): Int32Array;\n    new(arrayOrArrayBuffer: ArrayLike<number> | ArrayBufferLike): Int32Array;\n    new(buffer: ArrayBufferLike, byteOffset: number, length?: number): Int32Array;\n\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * Returns a new array from a set of elements.\n      * @param items A set of elements to include in the new array object.\n      */\n    of(...items: number[]): Int32Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      */\n    from(arrayLike: ArrayLike<number>): Int32Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      * @param mapfn A mapping function to call on every element of the array.\n      * @param thisArg Value of 'this' used to invoke the mapfn.\n      */\n    from<T>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => number, thisArg?: any): Int32Array;\n\n}\ndeclare var Int32Array: Int32ArrayConstructor;\n\n/**\n  * A typed array of 32-bit unsigned integer values. The contents are initialized to 0. If the\n  * requested number of bytes could not be allocated an exception is raised.\n  */\ninterface Uint32Array {\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * The ArrayBuffer instance referenced by the array.\n      */\n    readonly buffer: ArrayBufferLike;\n\n    /**\n      * The length in bytes of the array.\n      */\n    readonly byteLength: number;\n\n    /**\n      * The offset in bytes of the array.\n      */\n    readonly byteOffset: number;\n\n    /**\n      * Returns the this object after copying a section of the array identified by start and end\n      * to the same array starting at position target\n      * @param target If target is negative, it is treated as length+target where length is the\n      * length of the array.\n      * @param start If start is negative, it is treated as length+start. If end is negative, it\n      * is treated as length+end.\n      * @param end If not specified, length of the this object is used as its default value.\n      */\n    copyWithin(target: number, start: number, end?: number): this;\n\n    /**\n      * Determines whether all the members of an array satisfy the specified test.\n      * @param callbackfn A function that accepts up to three arguments. The every method calls\n      * the callbackfn function for each element in array1 until the callbackfn returns false,\n      * or until the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    every(callbackfn: (value: number, index: number, array: Uint32Array) => boolean, thisArg?: any): boolean;\n\n    /**\n        * Returns the this object after filling the section identified by start and end with value\n        * @param value value to fill array section with\n        * @param start index to start filling the array at. If start is negative, it is treated as\n        * length+start where length is the length of the array.\n        * @param end index to stop filling the array at. If end is negative, it is treated as\n        * length+end.\n        */\n    fill(value: number, start?: number, end?: number): this;\n\n    /**\n      * Returns the elements of an array that meet the condition specified in a callback function.\n      * @param callbackfn A function that accepts up to three arguments. The filter method calls\n      * the callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    filter(callbackfn: (value: number, index: number, array: Uint32Array) => any, thisArg?: any): Uint32Array;\n\n    /**\n      * Returns the value of the first element in the array where predicate is true, and undefined\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found, find\n      * immediately returns that element value. Otherwise, find returns undefined.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    find(predicate: (value: number, index: number, obj: Uint32Array) => boolean, thisArg?: any): number | undefined;\n\n    /**\n      * Returns the index of the first element in the array where predicate is true, and -1\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found,\n      * findIndex immediately returns that element index. Otherwise, findIndex returns -1.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    findIndex(predicate: (value: number, index: number, obj: Uint32Array) => boolean, thisArg?: any): number;\n\n    /**\n      * Performs the specified action for each element in an array.\n      * @param callbackfn  A function that accepts up to three arguments. forEach calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg  An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    forEach(callbackfn: (value: number, index: number, array: Uint32Array) => void, thisArg?: any): void;\n    /**\n      * Returns the index of the first occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      *  search starts at index 0.\n      */\n    indexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * Adds all the elements of an array separated by the specified separator string.\n      * @param separator A string used to separate one element of an array from the next in the\n      * resulting String. If omitted, the array elements are separated with a comma.\n      */\n    join(separator?: string): string;\n\n    /**\n      * Returns the index of the last occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      * search starts at index 0.\n      */\n    lastIndexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * The length of the array.\n      */\n    readonly length: number;\n\n    /**\n      * Calls a defined callback function on each element of an array, and returns an array that\n      * contains the results.\n      * @param callbackfn A function that accepts up to three arguments. The map method calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    map(callbackfn: (value: number, index: number, array: Uint32Array) => number, thisArg?: any): Uint32Array;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint32Array) => number): number;\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint32Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Uint32Array) => U, initialValue: U): U;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an\n      * argument instead of an array value.\n      */\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint32Array) => number): number;\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint32Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduceRight<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Uint32Array) => U, initialValue: U): U;\n\n    /**\n      * Reverses the elements in an Array.\n      */\n    reverse(): Uint32Array;\n\n    /**\n      * Sets a value or an array of values.\n      * @param array A typed or untyped array of values to set.\n      * @param offset The index in the current array at which the values are to be written.\n      */\n    set(array: ArrayLike<number>, offset?: number): void;\n\n    /**\n      * Returns a section of an array.\n      * @param start The beginning of the specified portion of the array.\n      * @param end The end of the specified portion of the array.\n      */\n    slice(start?: number, end?: number): Uint32Array;\n\n    /**\n      * Determines whether the specified callback function returns true for any element of an array.\n      * @param callbackfn A function that accepts up to three arguments. The some method calls the\n      * callbackfn function for each element in array1 until the callbackfn returns true, or until\n      * the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    some(callbackfn: (value: number, index: number, array: Uint32Array) => boolean, thisArg?: any): boolean;\n\n    /**\n      * Sorts an array.\n      * @param compareFn The name of the function used to determine the order of the elements. If\n      * omitted, the elements are sorted in ascending, ASCII character order.\n      */\n    sort(compareFn?: (a: number, b: number) => number): this;\n\n    /**\n      * Gets a new Uint32Array view of the ArrayBuffer store for this array, referencing the elements\n      * at begin, inclusive, up to end, exclusive.\n      * @param begin The index of the beginning of the array.\n      * @param end The index of the end of the array.\n      */\n    subarray(begin: number, end?: number): Uint32Array;\n\n    /**\n      * Converts a number to a string by using the current locale.\n      */\n    toLocaleString(): string;\n\n    /**\n      * Returns a string representation of an array.\n      */\n    toString(): string;\n\n    [index: number]: number;\n}\n\ninterface Uint32ArrayConstructor {\n    readonly prototype: Uint32Array;\n    new(length: number): Uint32Array;\n    new(arrayOrArrayBuffer: ArrayLike<number> | ArrayBufferLike): Uint32Array;\n    new(buffer: ArrayBufferLike, byteOffset: number, length?: number): Uint32Array;\n\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * Returns a new array from a set of elements.\n      * @param items A set of elements to include in the new array object.\n      */\n    of(...items: number[]): Uint32Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      */\n    from(arrayLike: ArrayLike<number>): Uint32Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      * @param mapfn A mapping function to call on every element of the array.\n      * @param thisArg Value of 'this' used to invoke the mapfn.\n      */\n    from<T>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => number, thisArg?: any): Uint32Array;\n\n}\ndeclare var Uint32Array: Uint32ArrayConstructor;\n\n/**\n  * A typed array of 32-bit float values. The contents are initialized to 0. If the requested number\n  * of bytes could not be allocated an exception is raised.\n  */\ninterface Float32Array {\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * The ArrayBuffer instance referenced by the array.\n      */\n    readonly buffer: ArrayBufferLike;\n\n    /**\n      * The length in bytes of the array.\n      */\n    readonly byteLength: number;\n\n    /**\n      * The offset in bytes of the array.\n      */\n    readonly byteOffset: number;\n\n    /**\n      * Returns the this object after copying a section of the array identified by start and end\n      * to the same array starting at position target\n      * @param target If target is negative, it is treated as length+target where length is the\n      * length of the array.\n      * @param start If start is negative, it is treated as length+start. If end is negative, it\n      * is treated as length+end.\n      * @param end If not specified, length of the this object is used as its default value.\n      */\n    copyWithin(target: number, start: number, end?: number): this;\n\n    /**\n      * Determines whether all the members of an array satisfy the specified test.\n      * @param callbackfn A function that accepts up to three arguments. The every method calls\n      * the callbackfn function for each element in array1 until the callbackfn returns false,\n      * or until the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    every(callbackfn: (value: number, index: number, array: Float32Array) => boolean, thisArg?: any): boolean;\n\n    /**\n        * Returns the this object after filling the section identified by start and end with value\n        * @param value value to fill array section with\n        * @param start index to start filling the array at. If start is negative, it is treated as\n        * length+start where length is the length of the array.\n        * @param end index to stop filling the array at. If end is negative, it is treated as\n        * length+end.\n        */\n    fill(value: number, start?: number, end?: number): this;\n\n    /**\n      * Returns the elements of an array that meet the condition specified in a callback function.\n      * @param callbackfn A function that accepts up to three arguments. The filter method calls\n      * the callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    filter(callbackfn: (value: number, index: number, array: Float32Array) => any, thisArg?: any): Float32Array;\n\n    /**\n      * Returns the value of the first element in the array where predicate is true, and undefined\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found, find\n      * immediately returns that element value. Otherwise, find returns undefined.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    find(predicate: (value: number, index: number, obj: Float32Array) => boolean, thisArg?: any): number | undefined;\n\n    /**\n      * Returns the index of the first element in the array where predicate is true, and -1\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found,\n      * findIndex immediately returns that element index. Otherwise, findIndex returns -1.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    findIndex(predicate: (value: number, index: number, obj: Float32Array) => boolean, thisArg?: any): number;\n\n    /**\n      * Performs the specified action for each element in an array.\n      * @param callbackfn  A function that accepts up to three arguments. forEach calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg  An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    forEach(callbackfn: (value: number, index: number, array: Float32Array) => void, thisArg?: any): void;\n\n    /**\n      * Returns the index of the first occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      *  search starts at index 0.\n      */\n    indexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * Adds all the elements of an array separated by the specified separator string.\n      * @param separator A string used to separate one element of an array from the next in the\n      * resulting String. If omitted, the array elements are separated with a comma.\n      */\n    join(separator?: string): string;\n\n    /**\n      * Returns the index of the last occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      * search starts at index 0.\n      */\n    lastIndexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * The length of the array.\n      */\n    readonly length: number;\n\n    /**\n      * Calls a defined callback function on each element of an array, and returns an array that\n      * contains the results.\n      * @param callbackfn A function that accepts up to three arguments. The map method calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    map(callbackfn: (value: number, index: number, array: Float32Array) => number, thisArg?: any): Float32Array;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Float32Array) => number): number;\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Float32Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Float32Array) => U, initialValue: U): U;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an\n      * argument instead of an array value.\n      */\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Float32Array) => number): number;\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Float32Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduceRight<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Float32Array) => U, initialValue: U): U;\n\n    /**\n      * Reverses the elements in an Array.\n      */\n    reverse(): Float32Array;\n\n    /**\n      * Sets a value or an array of values.\n      * @param array A typed or untyped array of values to set.\n      * @param offset The index in the current array at which the values are to be written.\n      */\n    set(array: ArrayLike<number>, offset?: number): void;\n\n    /**\n      * Returns a section of an array.\n      * @param start The beginning of the specified portion of the array.\n      * @param end The end of the specified portion of the array.\n      */\n    slice(start?: number, end?: number): Float32Array;\n\n    /**\n      * Determines whether the specified callback function returns true for any element of an array.\n      * @param callbackfn A function that accepts up to three arguments. The some method calls the\n      * callbackfn function for each element in array1 until the callbackfn returns true, or until\n      * the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    some(callbackfn: (value: number, index: number, array: Float32Array) => boolean, thisArg?: any): boolean;\n\n    /**\n      * Sorts an array.\n      * @param compareFn The name of the function used to determine the order of the elements. If\n      * omitted, the elements are sorted in ascending, ASCII character order.\n      */\n    sort(compareFn?: (a: number, b: number) => number): this;\n\n    /**\n      * Gets a new Float32Array view of the ArrayBuffer store for this array, referencing the elements\n      * at begin, inclusive, up to end, exclusive.\n      * @param begin The index of the beginning of the array.\n      * @param end The index of the end of the array.\n      */\n    subarray(begin: number, end?: number): Float32Array;\n\n    /**\n      * Converts a number to a string by using the current locale.\n      */\n    toLocaleString(): string;\n\n    /**\n      * Returns a string representation of an array.\n      */\n    toString(): string;\n\n    [index: number]: number;\n}\n\ninterface Float32ArrayConstructor {\n    readonly prototype: Float32Array;\n    new(length: number): Float32Array;\n    new(arrayOrArrayBuffer: ArrayLike<number> | ArrayBufferLike): Float32Array;\n    new(buffer: ArrayBufferLike, byteOffset: number, length?: number): Float32Array;\n\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * Returns a new array from a set of elements.\n      * @param items A set of elements to include in the new array object.\n      */\n    of(...items: number[]): Float32Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      */\n    from(arrayLike: ArrayLike<number>): Float32Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      * @param mapfn A mapping function to call on every element of the array.\n      * @param thisArg Value of 'this' used to invoke the mapfn.\n      */\n    from<T>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => number, thisArg?: any): Float32Array;\n\n\n}\ndeclare var Float32Array: Float32ArrayConstructor;\n\n/**\n  * A typed array of 64-bit float values. The contents are initialized to 0. If the requested\n  * number of bytes could not be allocated an exception is raised.\n  */\ninterface Float64Array {\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * The ArrayBuffer instance referenced by the array.\n      */\n    readonly buffer: ArrayBufferLike;\n\n    /**\n      * The length in bytes of the array.\n      */\n    readonly byteLength: number;\n\n    /**\n      * The offset in bytes of the array.\n      */\n    readonly byteOffset: number;\n\n    /**\n      * Returns the this object after copying a section of the array identified by start and end\n      * to the same array starting at position target\n      * @param target If target is negative, it is treated as length+target where length is the\n      * length of the array.\n      * @param start If start is negative, it is treated as length+start. If end is negative, it\n      * is treated as length+end.\n      * @param end If not specified, length of the this object is used as its default value.\n      */\n    copyWithin(target: number, start: number, end?: number): this;\n\n    /**\n      * Determines whether all the members of an array satisfy the specified test.\n      * @param callbackfn A function that accepts up to three arguments. The every method calls\n      * the callbackfn function for each element in array1 until the callbackfn returns false,\n      * or until the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    every(callbackfn: (value: number, index: number, array: Float64Array) => boolean, thisArg?: any): boolean;\n\n    /**\n        * Returns the this object after filling the section identified by start and end with value\n        * @param value value to fill array section with\n        * @param start index to start filling the array at. If start is negative, it is treated as\n        * length+start where length is the length of the array.\n        * @param end index to stop filling the array at. If end is negative, it is treated as\n        * length+end.\n        */\n    fill(value: number, start?: number, end?: number): this;\n\n    /**\n      * Returns the elements of an array that meet the condition specified in a callback function.\n      * @param callbackfn A function that accepts up to three arguments. The filter method calls\n      * the callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    filter(callbackfn: (value: number, index: number, array: Float64Array) => any, thisArg?: any): Float64Array;\n\n    /**\n      * Returns the value of the first element in the array where predicate is true, and undefined\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found, find\n      * immediately returns that element value. Otherwise, find returns undefined.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    find(predicate: (value: number, index: number, obj: Float64Array) => boolean, thisArg?: any): number | undefined;\n\n    /**\n      * Returns the index of the first element in the array where predicate is true, and -1\n      * otherwise.\n      * @param predicate find calls predicate once for each element of the array, in ascending\n      * order, until it finds one where predicate returns true. If such an element is found,\n      * findIndex immediately returns that element index. Otherwise, findIndex returns -1.\n      * @param thisArg If provided, it will be used as the this value for each invocation of\n      * predicate. If it is not provided, undefined is used instead.\n      */\n    findIndex(predicate: (value: number, index: number, obj: Float64Array) => boolean, thisArg?: any): number;\n\n    /**\n      * Performs the specified action for each element in an array.\n      * @param callbackfn  A function that accepts up to three arguments. forEach calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg  An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    forEach(callbackfn: (value: number, index: number, array: Float64Array) => void, thisArg?: any): void;\n\n    /**\n      * Returns the index of the first occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      *  search starts at index 0.\n      */\n    indexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * Adds all the elements of an array separated by the specified separator string.\n      * @param separator A string used to separate one element of an array from the next in the\n      * resulting String. If omitted, the array elements are separated with a comma.\n      */\n    join(separator?: string): string;\n\n    /**\n      * Returns the index of the last occurrence of a value in an array.\n      * @param searchElement The value to locate in the array.\n      * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the\n      * search starts at index 0.\n      */\n    lastIndexOf(searchElement: number, fromIndex?: number): number;\n\n    /**\n      * The length of the array.\n      */\n    readonly length: number;\n\n    /**\n      * Calls a defined callback function on each element of an array, and returns an array that\n      * contains the results.\n      * @param callbackfn A function that accepts up to three arguments. The map method calls the\n      * callbackfn function one time for each element in the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    map(callbackfn: (value: number, index: number, array: Float64Array) => number, thisArg?: any): Float64Array;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Float64Array) => number): number;\n    reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Float64Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array. The return value of\n      * the callback function is the accumulated result, and is provided as an argument in the next\n      * call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduce method calls the\n      * callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduce<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Float64Array) => U, initialValue: U): U;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an\n      * argument instead of an array value.\n      */\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Float64Array) => number): number;\n    reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Float64Array) => number, initialValue: number): number;\n\n    /**\n      * Calls the specified callback function for all the elements in an array, in descending order.\n      * The return value of the callback function is the accumulated result, and is provided as an\n      * argument in the next call to the callback function.\n      * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls\n      * the callbackfn function one time for each element in the array.\n      * @param initialValue If initialValue is specified, it is used as the initial value to start\n      * the accumulation. The first call to the callbackfn function provides this value as an argument\n      * instead of an array value.\n      */\n    reduceRight<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Float64Array) => U, initialValue: U): U;\n\n    /**\n      * Reverses the elements in an Array.\n      */\n    reverse(): Float64Array;\n\n    /**\n      * Sets a value or an array of values.\n      * @param array A typed or untyped array of values to set.\n      * @param offset The index in the current array at which the values are to be written.\n      */\n    set(array: ArrayLike<number>, offset?: number): void;\n\n    /**\n      * Returns a section of an array.\n      * @param start The beginning of the specified portion of the array.\n      * @param end The end of the specified portion of the array.\n      */\n    slice(start?: number, end?: number): Float64Array;\n\n    /**\n      * Determines whether the specified callback function returns true for any element of an array.\n      * @param callbackfn A function that accepts up to three arguments. The some method calls the\n      * callbackfn function for each element in array1 until the callbackfn returns true, or until\n      * the end of the array.\n      * @param thisArg An object to which the this keyword can refer in the callbackfn function.\n      * If thisArg is omitted, undefined is used as the this value.\n      */\n    some(callbackfn: (value: number, index: number, array: Float64Array) => boolean, thisArg?: any): boolean;\n\n    /**\n      * Sorts an array.\n      * @param compareFn The name of the function used to determine the order of the elements. If\n      * omitted, the elements are sorted in ascending, ASCII character order.\n      */\n    sort(compareFn?: (a: number, b: number) => number): this;\n\n    /**\n      * Gets a new Float64Array view of the ArrayBuffer store for this array, referencing the elements\n      * at begin, inclusive, up to end, exclusive.\n      * @param begin The index of the beginning of the array.\n      * @param end The index of the end of the array.\n      */\n    subarray(begin: number, end?: number): Float64Array;\n\n    /**\n      * Converts a number to a string by using the current locale.\n      */\n    toLocaleString(): string;\n\n    /**\n      * Returns a string representation of an array.\n      */\n    toString(): string;\n\n    [index: number]: number;\n}\n\ninterface Float64ArrayConstructor {\n    readonly prototype: Float64Array;\n    new(length: number): Float64Array;\n    new(arrayOrArrayBuffer: ArrayLike<number> | ArrayBufferLike): Float64Array;\n    new(buffer: ArrayBufferLike, byteOffset: number, length?: number): Float64Array;\n\n    /**\n      * The size in bytes of each element in the array.\n      */\n    readonly BYTES_PER_ELEMENT: number;\n\n    /**\n      * Returns a new array from a set of elements.\n      * @param items A set of elements to include in the new array object.\n      */\n    of(...items: number[]): Float64Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      */\n    from(arrayLike: ArrayLike<number>): Float64Array;\n\n    /**\n      * Creates an array from an array-like or iterable object.\n      * @param arrayLike An array-like or iterable object to convert to an array.\n      * @param mapfn A mapping function to call on every element of the array.\n      * @param thisArg Value of 'this' used to invoke the mapfn.\n      */\n    from<T>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => number, thisArg?: any): Float64Array;\n\n}\ndeclare var Float64Array: Float64ArrayConstructor;\n\n/////////////////////////////\n/// ECMAScript Internationalization API\n/////////////////////////////\n\ndeclare namespace Intl {\n    interface CollatorOptions {\n        usage?: string;\n        localeMatcher?: string;\n        numeric?: boolean;\n        caseFirst?: string;\n        sensitivity?: string;\n        ignorePunctuation?: boolean;\n    }\n\n    interface ResolvedCollatorOptions {\n        locale: string;\n        usage: string;\n        sensitivity: string;\n        ignorePunctuation: boolean;\n        collation: string;\n        caseFirst: string;\n        numeric: boolean;\n    }\n\n    interface Collator {\n        compare(x: string, y: string): number;\n        resolvedOptions(): ResolvedCollatorOptions;\n    }\n    var Collator: {\n        new(locales?: string | string[], options?: CollatorOptions): Collator;\n        (locales?: string | string[], options?: CollatorOptions): Collator;\n        supportedLocalesOf(locales: string | string[], options?: CollatorOptions): string[];\n    };\n\n    interface NumberFormatOptions {\n        localeMatcher?: string;\n        style?: string;\n        currency?: string;\n        currencyDisplay?: string;\n        useGrouping?: boolean;\n        minimumIntegerDigits?: number;\n        minimumFractionDigits?: number;\n        maximumFractionDigits?: number;\n        minimumSignificantDigits?: number;\n        maximumSignificantDigits?: number;\n    }\n\n    interface ResolvedNumberFormatOptions {\n        locale: string;\n        numberingSystem: string;\n        style: string;\n        currency?: string;\n        currencyDisplay?: string;\n        minimumIntegerDigits: number;\n        minimumFractionDigits: number;\n        maximumFractionDigits: number;\n        minimumSignificantDigits?: number;\n        maximumSignificantDigits?: number;\n        useGrouping: boolean;\n    }\n\n    interface NumberFormat {\n        format(value: number): string;\n        resolvedOptions(): ResolvedNumberFormatOptions;\n    }\n    var NumberFormat: {\n        new(locales?: string | string[], options?: NumberFormatOptions): NumberFormat;\n        (locales?: string | string[], options?: NumberFormatOptions): NumberFormat;\n        supportedLocalesOf(locales: string | string[], options?: NumberFormatOptions): string[];\n    };\n\n    interface DateTimeFormatOptions {\n        localeMatcher?: string;\n        weekday?: string;\n        era?: string;\n        year?: string;\n        month?: string;\n        day?: string;\n        hour?: string;\n        minute?: string;\n        second?: string;\n        timeZoneName?: string;\n        formatMatcher?: string;\n        hour12?: boolean;\n        timeZone?: string;\n    }\n\n    interface ResolvedDateTimeFormatOptions {\n        locale: string;\n        calendar: string;\n        numberingSystem: string;\n        timeZone: string;\n        hour12?: boolean;\n        weekday?: string;\n        era?: string;\n        year?: string;\n        month?: string;\n        day?: string;\n        hour?: string;\n        minute?: string;\n        second?: string;\n        timeZoneName?: string;\n    }\n\n    interface DateTimeFormat {\n        format(date?: Date | number): string;\n        resolvedOptions(): ResolvedDateTimeFormatOptions;\n    }\n    var DateTimeFormat: {\n        new(locales?: string | string[], options?: DateTimeFormatOptions): DateTimeFormat;\n        (locales?: string | string[], options?: DateTimeFormatOptions): DateTimeFormat;\n        supportedLocalesOf(locales: string | string[], options?: DateTimeFormatOptions): string[];\n    };\n}\n\ninterface String {\n    /**\n      * Determines whether two strings are equivalent in the current or specified locale.\n      * @param that String to compare to target string\n      * @param locales A locale string or array of locale strings that contain one or more language or locale tags. If you include more than one locale string, list them in descending order of priority so that the first entry is the preferred locale. If you omit this parameter, the default locale of the JavaScript runtime is used. This parameter must conform to BCP 47 standards; see the Intl.Collator object for details.\n      * @param options An object that contains one or more properties that specify comparison options. see the Intl.Collator object for details.\n      */\n    localeCompare(that: string, locales?: string | string[], options?: Intl.CollatorOptions): number;\n}\n\ninterface Number {\n    /**\n      * Converts a number to a string by using the current or specified locale.\n      * @param locales A locale string or array of locale strings that contain one or more language or locale tags. If you include more than one locale string, list them in descending order of priority so that the first entry is the preferred locale. If you omit this parameter, the default locale of the JavaScript runtime is used.\n      * @param options An object that contains one or more properties that specify comparison options.\n      */\n    toLocaleString(locales?: string | string[], options?: Intl.NumberFormatOptions): string;\n}\n\ninterface Date {\n    /**\n      * Converts a date and time to a string by using the current or specified locale.\n      * @param locales A locale string or array of locale strings that contain one or more language or locale tags. If you include more than one locale string, list them in descending order of priority so that the first entry is the preferred locale. If you omit this parameter, the default locale of the JavaScript runtime is used.\n      * @param options An object that contains one or more properties that specify comparison options.\n      */\n    toLocaleString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;\n    /**\n      * Converts a date to a string by using the current or specified locale.\n      * @param locales A locale string or array of locale strings that contain one or more language or locale tags. If you include more than one locale string, list them in descending order of priority so that the first entry is the preferred locale. If you omit this parameter, the default locale of the JavaScript runtime is used.\n      * @param options An object that contains one or more properties that specify comparison options.\n      */\n    toLocaleDateString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;\n\n    /**\n      * Converts a time to a string by using the current or specified locale.\n      * @param locales A locale string or array of locale strings that contain one or more language or locale tags. If you include more than one locale string, list them in descending order of priority so that the first entry is the preferred locale. If you omit this parameter, the default locale of the JavaScript runtime is used.\n      * @param options An object that contains one or more properties that specify comparison options.\n      */\n    toLocaleTimeString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;\n}\n",n.lib_es2015_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n'+n.lib_es5_dts+n.lib_es2015_core_dts+n.lib_es2015_collection_dts+n.lib_es2015_generator_dts+n.lib_es2015_promise_dts+n.lib_es2015_iterable_dts+n.lib_es2015_proxy_dts+n.lib_es2015_reflect_dts+n.lib_es2015_symbol_dts+n.lib_es2015_symbol_wellknown_dts,n.lib_es6_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n'+n.lib_es2015_dts+n.lib_dom_dts+n.lib_dom_iterable_dts+n.lib_webworker_importscripts_dts+n.lib_scripthost_dts,n.lib_dts='/*! *****************************************************************************\nCopyright (c) Microsoft Corporation. All rights reserved. \nLicensed under the Apache License, Version 2.0 (the "License"); you may not use\nthis file except in compliance with the License. You may obtain a copy of the\nLicense at http://www.apache.org/licenses/LICENSE-2.0  \n \nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, \nMERCHANTABLITY OR NON-INFRINGEMENT. \n \nSee the Apache Version 2.0 License for specific language governing permissions\nand limitations under the License.\n***************************************************************************** */\n\n\n\n/// <reference no-default-lib="true"/>\n\n'+n.lib_es5_dts+n.lib_dom_dts+n.lib_webworker_importscripts_dts+n.lib_scripthost_dts
});
/**! node_modules/monaco-editor/esm/vs/language/typescript/lib/typescriptServices.js*/
define("03ff426",function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n,i=this&&this.__assign||function(){return i=Object.assign||function(e){for(var t,r=1,n=arguments.length;n>r;r++){t=arguments[r];for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i])}return e},i.apply(this,arguments)},a=this&&this.__generator||function(e,t){function r(e){return function(t){return n([e,t])}}function n(r){if(i)throw new TypeError("Generator is already executing.");for(;c;)try{if(i=1,a&&(o=2&r[0]?a["return"]:r[0]?a["throw"]||((o=a["return"])&&o.call(a),0):a.next)&&!(o=o.call(a,r[1])).done)return o;switch(a=0,o&&(r=[2&r[0],o.value]),r[0]){case 0:case 1:o=r;break;case 4:return c.label++,{value:r[1],done:!1};case 5:c.label++,a=r[1],r=[0];continue;case 7:r=c.ops.pop(),c.trys.pop();continue;default:if(o=c.trys,!(o=o.length>0&&o[o.length-1])&&(6===r[0]||2===r[0])){c=0;continue}if(3===r[0]&&(!o||r[1]>o[0]&&r[1]<o[3])){c.label=r[1];break}if(6===r[0]&&c.label<o[1]){c.label=o[1],o=r;break}if(o&&c.label<o[2]){c.label=o[2],c.ops.push(r);break}o[2]&&c.ops.pop(),c.trys.pop();continue}r=t.call(e,c)}catch(n){r=[6,n],a=0}finally{i=o=0}if(5&r[0])throw r[1];return{value:r[0]?r[1]:void 0,done:!0}}var i,a,o,s,c={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return s={next:r(0),"throw":r(1),"return":r(2)},"function"==typeof Symbol&&(s[Symbol.iterator]=function(){return this}),s},o=this&&this.__makeTemplateObject||function(e,t){return Object.defineProperty?Object.defineProperty(e,"raw",{value:t}):e.raw=t,e},s=this&&this.__extends||function(){var e=function(t,r){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(t,r)};return function(t,r){function n(){this.constructor=t}e(t,r),t.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}();!function(e){e.versionMajorMinor="3.5",e.version=e.versionMajorMinor+".1"}(n||(n={})),function(e){var t;!function(e){e[e.LessThan=-1]="LessThan",e[e.EqualTo=0]="EqualTo",e[e.GreaterThan=1]="GreaterThan"}(t=e.Comparison||(e.Comparison={}))}(n||(n={})),function(e){function t(){var e=Object.create(null);return e.__=void 0,delete e.__,e}function r(){return new e.MapCtr}function n(e){for(var t=r(),n=0,i=e;n<i.length;n++){var a=i[n],o=a[0],s=a[1];t.set(o,s)}return t}function i(t){var r=new e.MapCtr;for(var n in t)Kr.call(t,n)&&r.set(n,t[n]);return r}function a(){var e=function(){function e(e,t){this.currentEntry=e,this.selector=t}return e.prototype.next=function(){for(;this.currentEntry;){var e=!!this.currentEntry.skipNext;if(this.currentEntry=this.currentEntry.nextEntry,!e)break}return this.currentEntry?{value:this.selector(this.currentEntry.key,this.currentEntry.value),done:!1}:{value:void 0,done:!0}},e}();return function(){function r(){this.data=t(),this.size=0,this.firstEntry={},this.lastEntry=this.firstEntry}return r.prototype.get=function(e){var t=this.data[e];return t&&t.value},r.prototype.set=function(e,t){if(this.has(e))this.data[e].value=t;else{this.size++;var r={key:e,value:t};this.data[e]=r;var n=this.lastEntry;n.nextEntry=r,r.previousEntry=n,this.lastEntry=r}return this},r.prototype.has=function(e){return e in this.data},r.prototype.delete=function(e){if(this.has(e)){this.size--;var t=this.data[e];delete this.data[e];var r=t.previousEntry;return r.nextEntry=t.nextEntry,t.nextEntry&&(t.nextEntry.previousEntry=r),this.lastEntry===t&&(this.lastEntry=r),t.previousEntry=void 0,t.nextEntry=r,t.skipNext=!0,!0}return!1},r.prototype.clear=function(){this.data=t(),this.size=0;for(var e=this.firstEntry,r=e.nextEntry;r;){var n=r.nextEntry;r.previousEntry=void 0,r.nextEntry=e,r.skipNext=!0,r=n}e.nextEntry=void 0,this.lastEntry=e},r.prototype.keys=function(){return new e(this.firstEntry,function(e){return e})},r.prototype.values=function(){return new e(this.firstEntry,function(e,t){return t})},r.prototype.entries=function(){return new e(this.firstEntry,function(e,t){return[e,t]})},r.prototype.forEach=function(e){for(var t=this.entries();;){var r=t.next(),n=r.value,i=r.done;if(i)break;e(n[1],n[0])}},r}()}function o(e){return e?e.length:0}function s(e,t){if(e)for(var r=0;r<e.length;r++){var n=t(e[r],r);if(n)return n}return void 0}function c(e,t){if(void 0===e)return void 0;for(var r=0;r<e.length;r++){var n=t(e[r],r);if(void 0!==n)return n}return void 0}function u(e,t){for(;;){var r=e.next(),n=r.value,i=r.done;if(i)return void 0;var a=t(n);if(void 0!==a)return a}}function l(t,r,n){var i=[];e.Debug.assertEqual(t.length,r.length);for(var a=0;a<t.length;a++)i.push(n(t[a],r[a],a));return i}function _(t,r){e.Debug.assertEqual(t.length,r.length);var n=0;return{next:function(){return n===t.length?{value:void 0,done:!0}:(n++,{value:[t[n-1],r[n-1]],done:!1})}}}function d(t,n){e.Debug.assert(t.length===n.length);for(var i=r(),a=0;a<t.length;++a)i.set(t[a],n[a]);return i}function p(e,t){if(e)for(var r=0;r<e.length;r++)if(!t(e[r],r))return!1;return!0}function f(e,t){for(var r=0;r<e.length;r++){var n=e[r];if(t(n,r))return n}return void 0}function m(e,t){for(var r=e.length-1;r>=0;r--){var n=e[r];if(t(n,r))return n}return void 0}function g(e,t,r){for(var n=r||0;n<e.length;n++)if(t(e[n],n))return n;return-1}function v(e,t,r){for(var n=void 0===r?e.length-1:r;n>=0;n--)if(t(e[n],n))return n;return-1}function y(t,r){for(var n=0;n<t.length;n++){var i=r(t[n],n);if(i)return i}return e.Debug.fail()}function h(e,t,r){if(void 0===r&&(r=er),e)for(var n=0,i=e;n<i.length;n++){var a=i[n];if(r(a,t))return!0}return!1}function b(e,t,r){return void 0===r&&(r=er),e.length===t.length&&e.every(function(e,n){return r(e,t[n])})}function x(e,t,r){for(var n=r||0;n<e.length;n++)if(h(t,e.charCodeAt(n)))return n;return-1}function D(e,t){var r=0;if(e)for(var n=0;n<e.length;n++){var i=e[n];t(i,n)&&r++}return r}function S(e,t){if(e){for(var r=e.length,n=0;r>n&&t(e[n]);)n++;if(r>n){var i=e.slice(0,n);for(n++;r>n;){var a=e[n];t(a)&&i.push(a),n++}return i}}return e}function C(e,t){for(var r=0,n=0;n<e.length;n++)t(e[n],n,e)&&(e[r]=e[n],r++);e.length=r}function k(e){e.length=0}function T(e,t){var r;if(e){r=[];for(var n=0;n<e.length;n++)r.push(t(e[n],n))}return r}function E(e,t){return{next:function(){var r=e.next();return r.done?r:{value:t(r.value),done:!1}}}}function N(e,t){if(e)for(var r=0;r<e.length;r++){var n=e[r],i=t(n,r);if(n!==i){var a=e.slice(0,r);for(a.push(i),r++;r<e.length;r++)a.push(t(e[r],r));return a}}return e}function A(e){var t;if(e){t=[];for(var r=0,n=e;r<n.length;r++){var i=n[r];i&&(jt(i)?tt(t,i):t.push(i))}}return t}function F(t,r){var n;if(t)for(var i=0;i<t.length;i++){var a=r(t[i],i);a&&(n=jt(a)?tt(n,a):$(n,a))}return n||e.emptyArray}function P(e,t){var r=[];if(e)for(var n=0;n<e.length;n++){var i=t(e[n],n);i&&(jt(i)?tt(r,i):r.push(i))}return r}function w(t,r){function n(t){var n=r(t);return void 0===n?e.emptyIterator:jt(n)?ot(n):n}var i=t.next();if(i.done)return e.emptyIterator;var a=n(i.value);return{next:function(){for(;;){var e=a.next();if(!e.done)return e;var r=t.next();if(r.done)return r;a=n(r.value)}}}}function I(e,t){var r;if(e)for(var n=0;n<e.length;n++){var i=e[n],a=t(i,n);(r||i!==a||jt(a))&&(r||(r=e.slice(0,n)),jt(a)?tt(r,a):r.push(a))}return r||e}function O(e,t){for(var r=[],n=0;n<e.length;n++){var i=t(e[n],n);if(void 0===i)return void 0;r.push(i)}return r}function M(e,t){var r=[];if(e)for(var n=0;n<e.length;n++){var i=t(e[n],n);void 0!==i&&r.push(i)}return r}function L(e,t){return{next:function(){for(;;){var r=e.next();if(r.done)return r;var n=t(r.value);if(void 0!==n)return{value:n,done:!1}}}}}function R(e){var t=!1;return{next:function(){var r=t;return t=!0,r?{value:void 0,done:!0}:{value:e,done:!1}}}}function B(e,t,r){var n;if(e){n=[];for(var i=e.length,a=void 0,o=void 0,s=0,c=0;i>s;){for(;i>c;){var u=e[c];if(o=t(u,c),0===c)a=o;else if(o!==a)break;c++}if(c>s){var l=r(e.slice(s,c),a,s,c);l&&n.push(l),s=c}a=o,c++}}return n}function j(e,t){if(!e)return void 0;var n=r();return e.forEach(function(e,r){var i=t(r,e),a=i[0],o=i[1];n.set(a,o)}),n}function J(e,t){if(e){if(!t)return e.length>0;for(var r=0,n=e;r<n.length;r++){var i=n[r];if(t(i))return!0}}return!1}function z(e,t,r){for(var n,i=0;i<e.length;i++)t(e[i])?n=void 0===n?i:n:void 0!==n&&(r(n,i),n=void 0);void 0!==n&&r(n,e.length)}function V(e,t){return J(t)?J(e)?e.concat(t):t:e}function U(e,t,r){var n=e.map(function(e,t){return t});it(e,n,r);for(var i=e[n[0]],a=[n[0]],o=1;o<n.length;o++){var s=n[o],c=e[s];t(i,c)||(a.push(s),i=c)}return a.sort(),a.map(function(t){return e[t]})}function K(e,t){for(var r=[],n=0,i=e;n<i.length;n++){var a=i[n];rt(r,a,t)}return r}function q(e,t,r){return 0===e.length?[]:1===e.length?e.slice():r?U(e,t,r):K(e,t)}function W(t,r){if(0===t.length)return e.emptyArray;for(var n=t[0],i=[n],a=1;a<t.length;a++){var o=t[a];switch(r(o,n)){case!0:case 0:continue;case-1:return e.Debug.fail("Array is unsorted.")}i.push(n=o)}return i}function H(e,t,r){if(0===e.length)return void e.push(t);var n=yt(e,t,Qt,r);0>n&&e.splice(~n,0,t)}function G(e,t,r){return W(at(e,t),r||t||sr)}function Q(e,t,r){if(void 0===r&&(r=er),!e||!t)return e===t;if(e.length!==t.length)return!1;for(var n=0;n<e.length;n++)if(!r(e[n],t[n],n))return!1;return!0}function X(e){var t;if(e)for(var r=0;r<e.length;r++){var n=e[r];(t||!n)&&(t||(t=e.slice(0,r)),n&&t.push(n))}return t||e}function Y(t,r,n){if(!r||!t||0===r.length||0===t.length)return r;var i=[];e:for(var a=0,o=0;o<r.length;o++){o>0&&e.Debug.assertGreaterThanOrEqual(n(r[o],r[o-1]),0);t:for(var s=a;a<t.length;a++)switch(a>s&&e.Debug.assertGreaterThanOrEqual(n(t[a],t[a-1]),0),n(r[o],t[a])){case-1:i.push(r[o]);continue e;case 0:continue e;case 1:continue t}}return i}function Z(e,t){for(var r=0,n=0,i=e;n<i.length;n++){var a=i[n];r+=a[t]}return r}function $(e,t){return void 0===t?e:void 0===e?[t]:(e.push(t),e)}function et(e,t){return 0>t?e.length+t:t}function tt(e,t,r,n){if(void 0===t||0===t.length)return e;if(void 0===e)return t.slice(r,n);r=void 0===r?0:et(t,r),n=void 0===n?t.length:et(t,n);for(var i=r;n>i&&i<t.length;i++)void 0!==t[i]&&e.push(t[i]);return e}function rt(e,t,r){return h(e,t,r)?!1:(e.push(t),!0)}function nt(e,t,r){return e?(rt(e,t,r),e):[t]}function it(e,t,r){t.sort(function(t,n){return r(e[t],e[n])||ir(t,n)})}function at(e,t){return 0===e.length?e:e.slice().sort(t)}function ot(e){var t=0;return{next:function(){return t===e.length?{value:void 0,done:!0}:(t++,{value:e[t-1],done:!1})}}}function st(e){var t=e.length;return{next:function(){return 0===t?{value:void 0,done:!0}:(t--,{value:e[t],done:!1})}}}function ct(e,t){var r=e.map(function(e,t){return t});return it(e,r,t),r.map(function(t){return e[t]})}function ut(e,t,r,n){for(;n>r;){if(e[r]!==t[r])return!1;r++}return!0}function lt(e,t){return e&&(t=et(e,t),t<e.length)?e[t]:void 0}function _t(e){return 0===e.length?void 0:e[0]}function dt(t){return e.Debug.assert(0!==t.length),t[0]}function pt(e){return 0===e.length?void 0:e[e.length-1]}function ft(t){return e.Debug.assert(0!==t.length),t[t.length-1]}function mt(e){return e&&1===e.length?e[0]:void 0}function gt(e){return e&&1===e.length?e[0]:e}function vt(e,t,r){var n=e.slice(0);return n[t]=r,n}function yt(e,t,r,n,i){return ht(e,r(t),r,n,i)}function ht(e,t,r,n,i){if(!J(e))return-1;for(var a=i||0,o=e.length-1;o>=a;){var s=a+(o-a>>1),c=r(e[s]);switch(n(c,t)){case-1:a=s+1;break;case 0:return s;case 1:o=s-1}}return~a}function bt(e,t,r,n,i){if(e&&e.length>0){var a=e.length;if(a>0){var o=void 0===n||0>n?0:n,s=void 0===i||o+i>a-1?a-1:o+i,c=void 0;for(arguments.length<=2?(c=e[o],o++):c=r;s>=o;)c=t(c,e[o],o),o++;return c}}return r}function xt(e,t){return Kr.call(e,t)}function Dt(e,t){return Kr.call(e,t)?e[t]:void 0}function St(e){var t=[];for(var r in e)Kr.call(e,r)&&t.push(r);return t}function Ct(e){var t=[];for(var r in e)Kr.call(e,r)&&t.push(e[r]);return t}function kt(e,t){for(var r,n=[],i=e.next(),a=i.value,o=i.done;!o;r=e.next(),a=r.value,o=r.done,r)n.push(t?t(a):a);return n}function Tt(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];for(var n=0,i=t;n<i.length;n++){var a=i[n];if(void 0!==a)for(var o in a)xt(a,o)&&(e[o]=a[o])}return e}function Et(e,t,r){if(void 0===r&&(r=er),e===t)return!0;if(!e||!t)return!1;for(var n in e)if(Kr.call(e,n)){if(!Kr.call(t,n))return!1;if(!r(e[n],t[n]))return!1}for(var n in t)if(Kr.call(t,n)&&!Kr.call(e,n))return!1;return!0}function Nt(e,t,n){void 0===n&&(n=Qt);for(var i=r(),a=0,o=e;a<o.length;a++){var s=o[a],c=t(s);void 0!==c&&i.set(c,n(s))}return i}function At(e,t,r){void 0===r&&(r=Qt);for(var n=[],i=0,a=e;i<a.length;i++){var o=a[i];n[t(o)]=r(o)}return n}function Ft(e,t,r){void 0===r&&(r=Qt);for(var n=Lt(),i=0,a=e;i<a.length;i++){var o=a[i];n.add(t(o),r(o))}return n}function Pt(e,t){return kt(Ft(e,t).values())}function wt(e){var t={};for(var r in e)Kr.call(e,r)&&(t[r]=e[r]);return t}function It(e,t){var r={};for(var n in t)Kr.call(t,n)&&(r[n]=t[n]);for(var n in e)Kr.call(e,n)&&(r[n]=e[n]);return r}function Ot(e,t){for(var r in t)Kr.call(t,r)&&(e[r]=t[r])}function Mt(e,t){return t?t.bind(e):void 0}function Lt(){var e=r();return e.add=Rt,e.remove=Bt,e}function Rt(e,t){var r=this.get(e);return r?r.push(t):this.set(e,r=[t]),r}function Bt(e,t){var r=this.get(e);r&&(Tr(r,t),r.length||this.delete(e))}function jt(e){return Array.isArray?Array.isArray(e):e instanceof Array}function Jt(e){return jt(e)?e:[e]}function zt(e){return"string"==typeof e}function Vt(e){return"number"==typeof e}function Ut(e,t){return void 0!==e&&t(e)?e:void 0}function Kt(t,r){return void 0!==t&&r(t)?t:e.Debug.fail("Invalid cast. The supplied value "+t+" did not pass the test '"+e.Debug.getFunctionName(r)+"'.")}function qt(){}function Wt(){return!1}function Ht(){return!0}function Gt(){return void 0}function Qt(e){return e}function Xt(e){return e.toLowerCase()}function Yt(){throw new Error("Not implemented")}function Zt(e){var t;return function(){return e&&(t=e(),e=void 0),t}}function $t(e,t,r,n,i){if(i){for(var a=[],o=0;o<arguments.length;o++)a[o]=arguments[o];return function(e){return bt(a,function(e,t){return t(e)},e)}}return n?function(i){return n(r(t(e(i))))}:r?function(n){return r(t(e(n)))}:t?function(r){return t(e(r))}:e?function(t){return e(t)}:function(e){return e}}function er(e,t){return e===t}function tr(e,t){return e===t||void 0!==e&&void 0!==t&&e.toUpperCase()===t.toUpperCase()}function rr(e,t){return er(e,t)}function nr(e,t){return e===t?0:void 0===e?-1:void 0===t?1:t>e?-1:1}function ir(e,t){return nr(e,t)}function ar(e,t,r){return-1===r(e,t)?e:t}function or(e,t){return e===t?0:void 0===e?-1:void 0===t?1:(e=e.toUpperCase(),t=t.toUpperCase(),t>e?-1:e>t?1:0)}function sr(e,t){return nr(e,t)}function cr(e){return e?or:sr}function ur(){return Hr}function lr(e){Hr!==e&&(Hr=e,Wr=void 0)}function _r(e,t){var r=Wr||(Wr=Gr(Hr));return r(e,t)}function dr(e,t,r,n){return e===t?0:void 0===e?-1:void 0===t?1:n(e[r],t[r])}function pr(e,t){return ir(e?1:0,t?1:0)}function fr(t,r,n){for(var i,a=Math.min(2,Math.floor(.34*t.length)),o=Math.floor(.4*t.length)+1,s=!1,c=t.toLowerCase(),u=0,l=r;u<l.length;u++){var _=l[u],d=n(_);if(void 0!==d&&Math.abs(d.length-c.length)<=a){var p=d.toLowerCase();if(p===c){if(d===t)continue;return _}if(s)continue;if(d.length<3)continue;var f=mr(c,p,o-1);if(void 0===f)continue;3>f?(s=!0,i=_):(e.Debug.assert(o>f),o=f,i=_)}}return i}function mr(e,t,r){for(var n=new Array(t.length+1),i=new Array(t.length+1),a=r+1,o=0;o<=t.length;o++)n[o]=o;for(var o=1;o<=e.length;o++){var s=e.charCodeAt(o-1),c=o>r?o-r:1,u=t.length>r+o?r+o:t.length;i[0]=o;for(var l=o,_=1;c>_;_++)i[_]=a;for(var _=c;u>=_;_++){var d=s===t.charCodeAt(_-1)?n[_-1]:Math.min(n[_]+1,i[_-1]+1,n[_-1]+2);i[_]=d,l=Math.min(l,d)}for(var _=u+1;_<=t.length;_++)i[_]=a;if(l>r)return void 0;var p=n;n=i,i=p}var f=n[t.length];return f>r?void 0:f}function gr(e,t){var r=e.length-t.length;return r>=0&&e.indexOf(t,r)===r}function vr(e,t){return gr(e,t)?e.slice(0,e.length-t.length):e}function yr(e,t){return gr(e,t)?e.slice(0,e.length-t.length):void 0}function hr(e,t){return-1!==e.indexOf(t)}function br(e,t){return e.length>t.length&&gr(e,t)}function xr(e,t){for(var r=0,n=t;r<n.length;r++){var i=n[r];if(br(e,i))return!0}return!1}function Dr(e){var t=/[.-]((min)|(\d+(\.\d+)*))$/;return e.replace(t,"").replace(t,"")}function Sr(e,t){for(var r=0;r<e.length;r++)if(e[r]===t)return Cr(e,r),!0;return!1}function Cr(e,t){for(var r=t;r<e.length-1;r++)e[r]=e[r+1];e.pop()}function kr(e,t){e[t]=e[e.length-1],e.pop()}function Tr(e,t){return Er(e,function(e){return e===t})}function Er(e,t){for(var r=0;r<e.length;r++)if(t(e[r]))return kr(e,r),!0;return!1}function Nr(e){return e?Qt:Xt}function Ar(e){var t=e.prefix,r=e.suffix;return t+"*"+r}function Fr(t,r){return e.Debug.assert(Mr(t,r)),r.substring(t.prefix.length,r.length-t.suffix.length)}function Pr(e,t,r){for(var n,i=-1,a=0,o=e;a<o.length;a++){var s=o[a],c=t(s);Mr(c,r)&&c.prefix.length>i&&(i=c.prefix.length,n=s)}return n}function wr(e,t){return 0===e.lastIndexOf(t,0)}function Ir(e,t){return wr(e,t)?e.substr(t.length):e}function Or(e,t,r){return void 0===r&&(r=Qt),wr(r(e),r(t))?e.substring(t.length):void 0}function Mr(e,t){var r=e.prefix,n=e.suffix;return t.length>=r.length+n.length&&wr(t,r)&&gr(t,n)}function Lr(e,t){return function(r){return e(r)&&t(r)}}function Rr(e,t){return function(r){return e(r)||t(r)}}function Br(){}function jr(e){return void 0===e?void 0:[e]}function Jr(e,t,r,n,i,a){a=a||qt;for(var o=0,s=0,c=e.length,u=t.length;c>o&&u>s;){var l=e[o],_=t[s],d=r(l,_);-1===d?(n(l),o++):1===d?(i(_),s++):(a(_,l),o++,s++)}for(;c>o;)n(e[o++]);for(;u>s;)i(t[s++])}function zr(e,t){for(var r=Array(e),n=0;e>n;n++)r[n]=t(n);return r}function Vr(e){var t=[];return Ur(e,t,void 0,0),t}function Ur(e,t,r,n){for(var i=0,a=e[n];i<a.length;i++){var o=a[i],s=void 0;r?(s=r.slice(),s.push(o)):s=[o],n===e.length-1?t.push(s):Ur(e,t,s,n+1)}}e.emptyArray=[],e.createMap=r,e.createMapFromEntries=n,e.createMapFromTemplate=i,e.MapCtr="undefined"!=typeof Map&&"entries"in Map.prototype?Map:a(),e.shimMap=a,e.length=o,e.forEach=s,e.firstDefined=c,e.firstDefinedIterator=u,e.zipWith=l,e.zipToIterator=_,e.zipToMap=d,e.every=p,e.find=f,e.findLast=m,e.findIndex=g,e.findLastIndex=v,e.findMap=y,e.contains=h,e.arraysEqual=b,e.indexOfAnyCharCode=x,e.countWhere=D,e.filter=S,e.filterMutate=C,e.clear=k,e.map=T,e.mapIterator=E,e.sameMap=N,e.flatten=A,e.flatMap=F,e.flatMapToMutable=P,e.flatMapIterator=w,e.sameFlatMap=I,e.mapAllOrFail=O,e.mapDefined=M,e.mapDefinedIterator=L,e.emptyIterator={next:function(){return{value:void 0,done:!0}}},e.singleIterator=R,e.spanMap=B,e.mapEntries=j,e.some=J,e.getRangesWhere=z,e.concatenate=V,e.deduplicate=q,e.insertSorted=H,e.sortAndDeduplicate=G,e.arrayIsEqualTo=Q,e.compact=X,e.relativeComplement=Y,e.sum=Z,e.append=$,e.addRange=tt,e.pushIfUnique=rt,e.appendIfUnique=nt,e.sort=at,e.arrayIterator=ot,e.arrayReverseIterator=st,e.stableSort=ct,e.rangeEquals=ut,e.elementAt=lt,e.firstOrUndefined=_t,e.first=dt,e.lastOrUndefined=pt,e.last=ft,e.singleOrUndefined=mt,e.singleOrMany=gt,e.replaceElement=vt,e.binarySearch=yt,e.binarySearchKey=ht,e.reduceLeft=bt;var Kr=Object.prototype.hasOwnProperty;e.hasProperty=xt,e.getProperty=Dt,e.getOwnKeys=St,e.getOwnValues=Ct,e.arrayFrom=kt,e.assign=Tt,e.equalOwnProperties=Et,e.arrayToMap=Nt,e.arrayToNumericMap=At,e.arrayToMultiMap=Ft,e.group=Pt,e.clone=wt,e.extend=It,e.copyProperties=Ot,e.maybeBind=Mt,e.createMultiMap=Lt,e.isArray=jt,e.toArray=Jt,e.isString=zt,e.isNumber=Vt,e.tryCast=Ut,e.cast=Kt,e.noop=qt,e.returnFalse=Wt,e.returnTrue=Ht,e.returnUndefined=Gt,e.identity=Qt,e.toLowerCase=Xt,e.notImplemented=Yt,e.memoize=Zt,e.compose=$t;var qr;!function(e){e[e.None=0]="None",e[e.Normal=1]="Normal",e[e.Aggressive=2]="Aggressive",e[e.VeryAggressive=3]="VeryAggressive"}(qr=e.AssertionLevel||(e.AssertionLevel={})),e.equateValues=er,e.equateStringsCaseInsensitive=tr,e.equateStringsCaseSensitive=rr,e.compareValues=ir,e.min=ar,e.compareStringsCaseInsensitive=or,e.compareStringsCaseSensitive=sr,e.getStringComparer=cr;var Wr,Hr,Gr=function(){function e(e,t,r){if(e===t)return 0;if(void 0===e)return-1;if(void 0===t)return 1;var n=r(e,t);return 0>n?-1:n>0?1:0}function t(t){var r=new Intl.Collator(t,{usage:"sort",sensitivity:"variant"}).compare;return function(t,n){return e(t,n,r)}}function r(t){function r(e,t){return e.localeCompare(t)}return void 0!==t?n():function(t,n){return e(t,n,r)}}function n(){function t(e,t){return r(e.toUpperCase(),t.toUpperCase())||r(e,t)}function r(e,t){return t>e?-1:e>t?1:0}return function(r,n){return e(r,n,t)}}function i(){return"object"==typeof Intl&&"function"==typeof Intl.Collator?t:"function"==typeof String.prototype.localeCompare&&"function"==typeof String.prototype.toLocaleUpperCase&&"a".localeCompare("B")<0?r:n}function a(e){return void 0===e?o||(o=c(e)):"en-US"===e?s||(s=c(e)):c(e)}var o,s,c=i();return a}();e.getUILocale=ur,e.setUILocale=lr,e.compareStringsCaseSensitiveUI=_r,e.compareProperties=dr,e.compareBooleans=pr,e.getSpellingSuggestion=fr,e.endsWith=gr,e.removeSuffix=vr,e.tryRemoveSuffix=yr,e.stringContains=hr,e.fileExtensionIs=br,e.fileExtensionIsOneOf=xr,e.removeMinAndVersionNumbers=Dr,e.orderedRemoveItem=Sr,e.orderedRemoveItemAt=Cr,e.unorderedRemoveItemAt=kr,e.unorderedRemoveItem=Tr,e.createGetCanonicalFileName=Nr,e.patternText=Ar,e.matchedText=Fr,e.findBestPatternMatch=Pr,e.startsWith=wr,e.removePrefix=Ir,e.tryRemovePrefix=Or,e.and=Lr,e.or=Rr,e.assertType=Br,e.singleElementArray=jr,e.enumerateInsertsAndDeletes=Jr,e.fill=zr,e.cartesianProduct=Vr}(n||(n={}));var n;!function(e){var t;!function(t){function r(e){return t.currentAssertionLevel>=e}function n(e,t,r,i){e||(r&&(t+="\r\nVerbose Debug Information: "+("string"==typeof r?r:r())),c(t?"False expression: "+t:"False expression.",i||n))}function i(e,t,r,n){if(e!==t){var i=r?n?r+" "+n:r:"";c("Expected "+e+" === "+t+". "+i)}}function a(e,t,r){e>=t&&c("Expected "+e+" < "+t+". "+(r||""))}function o(e,t){e>t&&c("Expected "+e+" <= "+t)}function s(e,t){t>e&&c("Expected "+e+" >= "+t)}function c(e,t){var r=new Error(e?"Debug Failure. "+e:"Debug Failure.");throw Error.captureStackTrace&&Error.captureStackTrace(r,t||c),r}function u(e,t){return void 0===e||null===e?c(t):e}function l(e,t){for(var r=0,n=e;r<n.length;r++){var i=n[r];u(i,t)}return e}function _(e,t,r){void 0===t&&(t="Illegal value:");var n="object"==typeof e&&"kind"in e&&"pos"in e&&g?"SyntaxKind: "+g(e.kind):JSON.stringify(e);return c(t+" "+n,r||_)}function d(e){if("function"!=typeof e)return"";if(e.hasOwnProperty("name"))return e.name;var t=Function.prototype.toString.call(e),r=/^function\s+([\w\$]+)\s*\(/.exec(t);return r?r[1]:""}function p(t){return"{ name: "+e.unescapeLeadingUnderscores(t.escapedName)+"; flags: "+x(t.flags)+"; declarations: "+e.map(t.declarations,function(e){return g(e.kind)})+" }"}function f(e,t,r){void 0===e&&(e=0);var n=m(t);if(0===e)return n.length>0&&0===n[0][0]?n[0][1]:"0";if(r){for(var i="",a=e,o=n.length-1;o>=0&&0!==a;o--){var s=n[o],c=s[0],u=s[1];0!==c&&(a&c)===c&&(a&=~c,i=""+u+(i?"|":"")+i)}if(0===a)return i}else for(var l=0,_=n;l<_.length;l++){var d=_[l],c=d[0],u=d[1];if(c===e)return u}return e.toString()}function m(t){var r=[];for(var n in t){var i=t[n];"number"==typeof i&&r.push([i,n])}return e.stableSort(r,function(t,r){return e.compareValues(t[0],r[0])})}function g(t){return f(t,e.SyntaxKind,!1)}function v(t){return f(t,e.NodeFlags,!0)}function y(t){return f(t,e.ModifierFlags,!0)}function h(t){return f(t,e.TransformFlags,!0)}function b(t){return f(t,e.EmitFlags,!0)}function x(t){return f(t,e.SymbolFlags,!0)}function D(t){return f(t,e.TypeFlags,!0)}function S(t){return f(t,e.ObjectFlags,!0)}function C(e,t){return c((t||"Unexpected node.")+"\r\nNode "+g(e.kind)+" was unexpected.",C)}function k(){if(!T){Object.defineProperties(e.objectAllocator.getSymbolConstructor().prototype,{__debugFlags:{get:function(){return x(this.flags)}}}),Object.defineProperties(e.objectAllocator.getTypeConstructor().prototype,{__debugFlags:{get:function(){return D(this.flags)}},__debugObjectFlags:{get:function(){return 524288&this.flags?S(this.objectFlags):""}},__debugTypeToString:{value:function(){return this.checker.typeToString(this)}}});for(var t=[e.objectAllocator.getNodeConstructor(),e.objectAllocator.getIdentifierConstructor(),e.objectAllocator.getTokenConstructor(),e.objectAllocator.getSourceFileConstructor()],r=0,n=t;r<n.length;r++){var i=n[r];i.prototype.hasOwnProperty("__debugKind")||Object.defineProperties(i.prototype,{__debugKind:{get:function(){return g(this.kind)}},__debugNodeFlags:{get:function(){return v(this.flags)}},__debugModifierFlags:{get:function(){return y(e.getModifierFlagsNoCache(this))}},__debugTransformFlags:{get:function(){return h(this.transformFlags)}},__debugIsParseTreeNode:{get:function(){return e.isParseTreeNode(this)}},__debugEmitFlags:{get:function(){return b(e.getEmitFlags(this))}},__debugGetText:{value:function(t){if(e.nodeIsSynthesized(this))return"";var r=e.getParseTreeNode(this),n=r&&e.getSourceFileOfNode(r);return n?e.getSourceTextOfNodeFromSourceFile(n,r,t):""}}})}T=!0}}t.currentAssertionLevel=0,t.isDebugging=!1,t.shouldAssert=r,t.assert=n,t.assertEqual=i,t.assertLessThan=a,t.assertLessThanOrEqual=o,t.assertGreaterThanOrEqual=s,t.fail=c,t.assertDefined=u,t.assertEachDefined=l,t.assertNever=_,t.getFunctionName=d,t.formatSymbol=p,t.formatEnum=f,t.formatSyntaxKind=g,t.formatNodeFlags=v,t.formatModifierFlags=y,t.formatTransformFlags=h,t.formatEmitFlags=b,t.formatSymbolFlags=x,t.formatTypeFlags=D,t.formatObjectFlags=S,t.failBadSyntaxKind=C,t.assertEachNode=r(1)?function(r,i,a){return n(void 0===i||e.every(r,i),a||"Unexpected node.",function(){return"Node array did not pass test '"+d(i)+"'."},t.assertEachNode)}:e.noop,t.assertNode=r(1)?function(e,r,i){return n(void 0===r||r(e),i||"Unexpected node.",function(){return"Node "+g(e.kind)+" did not pass test '"+d(r)+"'."},t.assertNode)}:e.noop,t.assertOptionalNode=r(1)?function(e,r,i){return n(void 0===r||void 0===e||r(e),i||"Unexpected node.",function(){return"Node "+g(e.kind)+" did not pass test '"+d(r)+"'."},t.assertOptionalNode)}:e.noop,t.assertOptionalToken=r(1)?function(e,r,i){return n(void 0===r||void 0===e||e.kind===r,i||"Unexpected node.",function(){return"Node "+g(e.kind)+" was not a '"+g(r)+"' token."},t.assertOptionalToken)}:e.noop,t.assertMissingNode=r(1)?function(e,r){return n(void 0===e,r||"Unexpected node.",function(){return"Node "+g(e.kind)+" was unexpected'."},t.assertMissingNode)}:e.noop;var T=!1;t.enableDebugInfo=k}(t=e.Debug||(e.Debug={}))}(n||(n={}));var n;!function(e){e.timestamp="undefined"!=typeof performance&&performance.now?function(){return performance.now()}:Date.now?Date.now:function(){return+new Date}}(n||(n={})),function(e){var t;!function(t){function r(e,r,i,a){return e?n(r,i,a):t.nullTimer}function n(t,r,n){function o(){1===++c&&i(r)}function s(){0===--c?(i(n),a(t,r,n)):0>c&&e.Debug.fail("enter/exit count does not match.")}var c=0;return{enter:o,exit:s}}function i(t){m&&(d.set(t,e.timestamp()),_.set(t,(_.get(t)||0)+1),f(t))}function a(t,r,n){if(m){var i=n&&d.get(n)||e.timestamp(),a=r&&d.get(r)||g;p.set(t,(p.get(t)||0)+(i-a))}}function o(e){return _&&_.get(e)||0}function s(e){return p&&p.get(e)||0}function c(e){p.forEach(function(t,r){e(r,t)})}function u(){_=e.createMap(),d=e.createMap(),p=e.createMap(),m=!0,g=e.timestamp()}function l(){m=!1}var _,d,p,f="function"==typeof onProfilerEvent&&onProfilerEvent.profiler===!0?onProfilerEvent:function(){},m=!1,g=0;t.createTimerIf=r,t.createTimer=n,t.nullTimer={enter:e.noop,exit:e.noop},t.mark=i,t.measure=a,t.getCount=o,t.getDuration=s,t.forEachMeasure=c,t.enable=u,t.disable=l}(t=e.performance||(e.performance={}))}(n||(n={}));var n;!function(e){function t(e){var t=m.exec(e);if(!t)return void 0;var r=t[1],n=t[2],i=void 0===n?"0":n,a=t[3],o=void 0===a?"0":a,s=t[4],c=void 0===s?"":s,u=t[5],l=void 0===u?"":u;return c&&!g.test(c)?void 0:l&&!v.test(l)?void 0:{major:parseInt(r,10),minor:parseInt(i,10),patch:parseInt(o,10),prerelease:c,build:l}}function r(t,r){if(t===r)return 0;if(0===t.length)return 0===r.length?0:1;if(0===r.length)return-1;for(var n=Math.min(t.length,r.length),i=0;n>i;i++){var a=t[i],o=r[i];if(a!==o){var s=y.test(a),c=y.test(o);if(s||c){if(s!==c)return s?-1:1;var u=e.compareValues(+a,+o);if(u)return u}else{var u=e.compareStringsCaseSensitive(a,o);if(u)return u}}}return e.compareValues(t.length,r.length)}function n(e){for(var t=[],r=0,n=e.trim().split(x);r<n.length;r++){var i=n[r];if(i){var s=[],c=C.exec(i);if(c){if(!a(c[1],c[2],s))return void 0}else for(var u=0,l=i.split(D);u<l.length;u++){var _=l[u],d=k.exec(_);if(!d||!o(d[1],d[2],s))return void 0}t.push(s)}}return t}function i(e){var t=S.exec(e);if(!t)return void 0;var r=t[1],n=t[2],i=void 0===n?"*":n,a=t[3],o=void 0===a?"*":a,c=t[4],u=t[5],l=new h(s(r)?0:parseInt(r,10),s(r)||s(i)?0:parseInt(i,10),s(r)||s(i)||s(o)?0:parseInt(o,10),c,u);return{version:l,major:r,minor:i,patch:o}}function a(e,t,r){var n=i(e);if(!n)return!1;var a=i(t);return a?(s(n.major)||r.push(c(">=",n.version)),s(a.major)||r.push(s(a.minor)?c("<",a.version.increment("major")):s(a.patch)?c("<",a.version.increment("minor")):c("<=",a.version)),!0):!1}function o(e,t,r){var n=i(t);if(!n)return!1;var a=n.version,o=n.major,u=n.minor,l=n.patch;if(s(o))("<"===e||">"===e)&&r.push(c("<",h.zero));else switch(e){case"~":r.push(c(">=",a)),r.push(c("<",a.increment(s(u)?"major":"minor")));break;case"^":r.push(c(">=",a)),r.push(c("<",a.increment(a.major>0||s(u)?"major":a.minor>0||s(l)?"minor":"patch")));break;case"<":case">=":r.push(c(e,a));break;case"<=":case">":r.push(s(u)?c("<="===e?"<":">=",a.increment("major")):s(l)?c("<="===e?"<":">=",a.increment("minor")):c(e,a));break;case"=":case void 0:s(u)||s(l)?(r.push(c(">=",a)),r.push(c("<",a.increment(s(u)?"major":"minor")))):r.push(c("=",a));break;default:return!1}return!0}function s(e){return"*"===e||"x"===e||"X"===e}function c(e,t){return{operator:e,operand:t}}function u(e,t){if(0===t.length)return!0;for(var r=0,n=t;r<n.length;r++){var i=n[r];if(l(e,i))return!0}return!1}function l(e,t){for(var r=0,n=t;r<n.length;r++){var i=n[r];if(!_(e,i.operator,i.operand))return!1}return!0}function _(t,r,n){var i=t.compareTo(n);switch(r){case"<":return 0>i;case"<=":return 0>=i;case">":return i>0;case">=":return i>=0;case"=":return 0===i;default:return e.Debug.assertNever(r)}}function d(t){return e.map(t,p).join(" || ")||"*"}function p(t){return e.map(t,f).join(" ")}function f(e){return""+e.operator+e.operand}var m=/^(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i,g=/^(?:0|[1-9]\d*|[a-z-][a-z0-9-]*)(?:\.(?:0|[1-9]\d*|[a-z-][a-z0-9-]*))*$/i,v=/^[a-z0-9-]+(?:\.[a-z0-9-]+)*$/i,y=/^(0|[1-9]\d*)$/,h=function(){function n(r,n,i,a,o){if(void 0===n&&(n=0),void 0===i&&(i=0),void 0===a&&(a=""),void 0===o&&(o=""),"string"==typeof r){var s=e.Debug.assertDefined(t(r),"Invalid version");r=s.major,n=s.minor,i=s.patch,a=s.prerelease,o=s.build}e.Debug.assert(r>=0,"Invalid argument: major"),e.Debug.assert(n>=0,"Invalid argument: minor"),e.Debug.assert(i>=0,"Invalid argument: patch"),e.Debug.assert(!a||g.test(a),"Invalid argument: prerelease"),e.Debug.assert(!o||v.test(o),"Invalid argument: build"),this.major=r,this.minor=n,this.patch=i,this.prerelease=a?a.split("."):e.emptyArray,this.build=o?o.split("."):e.emptyArray}return n.tryParse=function(e){var r=t(e);if(!r)return void 0;var i=r.major,a=r.minor,o=r.patch,s=r.prerelease,c=r.build;return new n(i,a,o,s,c)},n.prototype.compareTo=function(t){return this===t?0:void 0===t?1:e.compareValues(this.major,t.major)||e.compareValues(this.minor,t.minor)||e.compareValues(this.patch,t.patch)||r(this.prerelease,t.prerelease)},n.prototype.increment=function(t){switch(t){case"major":return new n(this.major+1,0,0);case"minor":return new n(this.major,this.minor+1,0);case"patch":return new n(this.major,this.minor,this.patch+1);default:return e.Debug.assertNever(t)}},n.prototype.toString=function(){var t=this.major+"."+this.minor+"."+this.patch;return e.some(this.prerelease)&&(t+="-"+this.prerelease.join(".")),e.some(this.build)&&(t+="+"+this.build.join(".")),t
},n.zero=new n(0,0,0),n}();e.Version=h;var b=function(){function t(t){this._alternatives=t?e.Debug.assertDefined(n(t),"Invalid range spec."):e.emptyArray}return t.tryParse=function(e){var r=n(e);if(r){var i=new t("");return i._alternatives=r,i}return void 0},t.prototype.test=function(e){return"string"==typeof e&&(e=new h(e)),u(e,this._alternatives)},t.prototype.toString=function(){return d(this._alternatives)},t}();e.VersionRange=b;var x=/\s*\|\|\s*/g,D=/\s+/g,S=/^([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i,C=/^\s*([a-z0-9-+.*]+)\s+-\s+([a-z0-9-+.*]+)\s*$/i,k=/^\s*(~|\^|<|<=|>|>=|=)?\s*([a-z0-9-+.*]+)$/i}(n||(n={}));var n;!function(e){function t(e,t){void 0===t&&(t=!0);var r=L[e.category];return t?r.toLowerCase():r}var r;!function(e){e[e.Unknown=0]="Unknown",e[e.EndOfFileToken=1]="EndOfFileToken",e[e.SingleLineCommentTrivia=2]="SingleLineCommentTrivia",e[e.MultiLineCommentTrivia=3]="MultiLineCommentTrivia",e[e.NewLineTrivia=4]="NewLineTrivia",e[e.WhitespaceTrivia=5]="WhitespaceTrivia",e[e.ShebangTrivia=6]="ShebangTrivia",e[e.ConflictMarkerTrivia=7]="ConflictMarkerTrivia",e[e.NumericLiteral=8]="NumericLiteral",e[e.BigIntLiteral=9]="BigIntLiteral",e[e.StringLiteral=10]="StringLiteral",e[e.JsxText=11]="JsxText",e[e.JsxTextAllWhiteSpaces=12]="JsxTextAllWhiteSpaces",e[e.RegularExpressionLiteral=13]="RegularExpressionLiteral",e[e.NoSubstitutionTemplateLiteral=14]="NoSubstitutionTemplateLiteral",e[e.TemplateHead=15]="TemplateHead",e[e.TemplateMiddle=16]="TemplateMiddle",e[e.TemplateTail=17]="TemplateTail",e[e.OpenBraceToken=18]="OpenBraceToken",e[e.CloseBraceToken=19]="CloseBraceToken",e[e.OpenParenToken=20]="OpenParenToken",e[e.CloseParenToken=21]="CloseParenToken",e[e.OpenBracketToken=22]="OpenBracketToken",e[e.CloseBracketToken=23]="CloseBracketToken",e[e.DotToken=24]="DotToken",e[e.DotDotDotToken=25]="DotDotDotToken",e[e.SemicolonToken=26]="SemicolonToken",e[e.CommaToken=27]="CommaToken",e[e.LessThanToken=28]="LessThanToken",e[e.LessThanSlashToken=29]="LessThanSlashToken",e[e.GreaterThanToken=30]="GreaterThanToken",e[e.LessThanEqualsToken=31]="LessThanEqualsToken",e[e.GreaterThanEqualsToken=32]="GreaterThanEqualsToken",e[e.EqualsEqualsToken=33]="EqualsEqualsToken",e[e.ExclamationEqualsToken=34]="ExclamationEqualsToken",e[e.EqualsEqualsEqualsToken=35]="EqualsEqualsEqualsToken",e[e.ExclamationEqualsEqualsToken=36]="ExclamationEqualsEqualsToken",e[e.EqualsGreaterThanToken=37]="EqualsGreaterThanToken",e[e.PlusToken=38]="PlusToken",e[e.MinusToken=39]="MinusToken",e[e.AsteriskToken=40]="AsteriskToken",e[e.AsteriskAsteriskToken=41]="AsteriskAsteriskToken",e[e.SlashToken=42]="SlashToken",e[e.PercentToken=43]="PercentToken",e[e.PlusPlusToken=44]="PlusPlusToken",e[e.MinusMinusToken=45]="MinusMinusToken",e[e.LessThanLessThanToken=46]="LessThanLessThanToken",e[e.GreaterThanGreaterThanToken=47]="GreaterThanGreaterThanToken",e[e.GreaterThanGreaterThanGreaterThanToken=48]="GreaterThanGreaterThanGreaterThanToken",e[e.AmpersandToken=49]="AmpersandToken",e[e.BarToken=50]="BarToken",e[e.CaretToken=51]="CaretToken",e[e.ExclamationToken=52]="ExclamationToken",e[e.TildeToken=53]="TildeToken",e[e.AmpersandAmpersandToken=54]="AmpersandAmpersandToken",e[e.BarBarToken=55]="BarBarToken",e[e.QuestionToken=56]="QuestionToken",e[e.ColonToken=57]="ColonToken",e[e.AtToken=58]="AtToken",e[e.BacktickToken=59]="BacktickToken",e[e.EqualsToken=60]="EqualsToken",e[e.PlusEqualsToken=61]="PlusEqualsToken",e[e.MinusEqualsToken=62]="MinusEqualsToken",e[e.AsteriskEqualsToken=63]="AsteriskEqualsToken",e[e.AsteriskAsteriskEqualsToken=64]="AsteriskAsteriskEqualsToken",e[e.SlashEqualsToken=65]="SlashEqualsToken",e[e.PercentEqualsToken=66]="PercentEqualsToken",e[e.LessThanLessThanEqualsToken=67]="LessThanLessThanEqualsToken",e[e.GreaterThanGreaterThanEqualsToken=68]="GreaterThanGreaterThanEqualsToken",e[e.GreaterThanGreaterThanGreaterThanEqualsToken=69]="GreaterThanGreaterThanGreaterThanEqualsToken",e[e.AmpersandEqualsToken=70]="AmpersandEqualsToken",e[e.BarEqualsToken=71]="BarEqualsToken",e[e.CaretEqualsToken=72]="CaretEqualsToken",e[e.Identifier=73]="Identifier",e[e.BreakKeyword=74]="BreakKeyword",e[e.CaseKeyword=75]="CaseKeyword",e[e.CatchKeyword=76]="CatchKeyword",e[e.ClassKeyword=77]="ClassKeyword",e[e.ConstKeyword=78]="ConstKeyword",e[e.ContinueKeyword=79]="ContinueKeyword",e[e.DebuggerKeyword=80]="DebuggerKeyword",e[e.DefaultKeyword=81]="DefaultKeyword",e[e.DeleteKeyword=82]="DeleteKeyword",e[e.DoKeyword=83]="DoKeyword",e[e.ElseKeyword=84]="ElseKeyword",e[e.EnumKeyword=85]="EnumKeyword",e[e.ExportKeyword=86]="ExportKeyword",e[e.ExtendsKeyword=87]="ExtendsKeyword",e[e.FalseKeyword=88]="FalseKeyword",e[e.FinallyKeyword=89]="FinallyKeyword",e[e.ForKeyword=90]="ForKeyword",e[e.FunctionKeyword=91]="FunctionKeyword",e[e.IfKeyword=92]="IfKeyword",e[e.ImportKeyword=93]="ImportKeyword",e[e.InKeyword=94]="InKeyword",e[e.InstanceOfKeyword=95]="InstanceOfKeyword",e[e.NewKeyword=96]="NewKeyword",e[e.NullKeyword=97]="NullKeyword",e[e.ReturnKeyword=98]="ReturnKeyword",e[e.SuperKeyword=99]="SuperKeyword",e[e.SwitchKeyword=100]="SwitchKeyword",e[e.ThisKeyword=101]="ThisKeyword",e[e.ThrowKeyword=102]="ThrowKeyword",e[e.TrueKeyword=103]="TrueKeyword",e[e.TryKeyword=104]="TryKeyword",e[e.TypeOfKeyword=105]="TypeOfKeyword",e[e.VarKeyword=106]="VarKeyword",e[e.VoidKeyword=107]="VoidKeyword",e[e.WhileKeyword=108]="WhileKeyword",e[e.WithKeyword=109]="WithKeyword",e[e.ImplementsKeyword=110]="ImplementsKeyword",e[e.InterfaceKeyword=111]="InterfaceKeyword",e[e.LetKeyword=112]="LetKeyword",e[e.PackageKeyword=113]="PackageKeyword",e[e.PrivateKeyword=114]="PrivateKeyword",e[e.ProtectedKeyword=115]="ProtectedKeyword",e[e.PublicKeyword=116]="PublicKeyword",e[e.StaticKeyword=117]="StaticKeyword",e[e.YieldKeyword=118]="YieldKeyword",e[e.AbstractKeyword=119]="AbstractKeyword",e[e.AsKeyword=120]="AsKeyword",e[e.AnyKeyword=121]="AnyKeyword",e[e.AsyncKeyword=122]="AsyncKeyword",e[e.AwaitKeyword=123]="AwaitKeyword",e[e.BooleanKeyword=124]="BooleanKeyword",e[e.ConstructorKeyword=125]="ConstructorKeyword",e[e.DeclareKeyword=126]="DeclareKeyword",e[e.GetKeyword=127]="GetKeyword",e[e.InferKeyword=128]="InferKeyword",e[e.IsKeyword=129]="IsKeyword",e[e.KeyOfKeyword=130]="KeyOfKeyword",e[e.ModuleKeyword=131]="ModuleKeyword",e[e.NamespaceKeyword=132]="NamespaceKeyword",e[e.NeverKeyword=133]="NeverKeyword",e[e.ReadonlyKeyword=134]="ReadonlyKeyword",e[e.RequireKeyword=135]="RequireKeyword",e[e.NumberKeyword=136]="NumberKeyword",e[e.ObjectKeyword=137]="ObjectKeyword",e[e.SetKeyword=138]="SetKeyword",e[e.StringKeyword=139]="StringKeyword",e[e.SymbolKeyword=140]="SymbolKeyword",e[e.TypeKeyword=141]="TypeKeyword",e[e.UndefinedKeyword=142]="UndefinedKeyword",e[e.UniqueKeyword=143]="UniqueKeyword",e[e.UnknownKeyword=144]="UnknownKeyword",e[e.FromKeyword=145]="FromKeyword",e[e.GlobalKeyword=146]="GlobalKeyword",e[e.BigIntKeyword=147]="BigIntKeyword",e[e.OfKeyword=148]="OfKeyword",e[e.QualifiedName=149]="QualifiedName",e[e.ComputedPropertyName=150]="ComputedPropertyName",e[e.TypeParameter=151]="TypeParameter",e[e.Parameter=152]="Parameter",e[e.Decorator=153]="Decorator",e[e.PropertySignature=154]="PropertySignature",e[e.PropertyDeclaration=155]="PropertyDeclaration",e[e.MethodSignature=156]="MethodSignature",e[e.MethodDeclaration=157]="MethodDeclaration",e[e.Constructor=158]="Constructor",e[e.GetAccessor=159]="GetAccessor",e[e.SetAccessor=160]="SetAccessor",e[e.CallSignature=161]="CallSignature",e[e.ConstructSignature=162]="ConstructSignature",e[e.IndexSignature=163]="IndexSignature",e[e.TypePredicate=164]="TypePredicate",e[e.TypeReference=165]="TypeReference",e[e.FunctionType=166]="FunctionType",e[e.ConstructorType=167]="ConstructorType",e[e.TypeQuery=168]="TypeQuery",e[e.TypeLiteral=169]="TypeLiteral",e[e.ArrayType=170]="ArrayType",e[e.TupleType=171]="TupleType",e[e.OptionalType=172]="OptionalType",e[e.RestType=173]="RestType",e[e.UnionType=174]="UnionType",e[e.IntersectionType=175]="IntersectionType",e[e.ConditionalType=176]="ConditionalType",e[e.InferType=177]="InferType",e[e.ParenthesizedType=178]="ParenthesizedType",e[e.ThisType=179]="ThisType",e[e.TypeOperator=180]="TypeOperator",e[e.IndexedAccessType=181]="IndexedAccessType",e[e.MappedType=182]="MappedType",e[e.LiteralType=183]="LiteralType",e[e.ImportType=184]="ImportType",e[e.ObjectBindingPattern=185]="ObjectBindingPattern",e[e.ArrayBindingPattern=186]="ArrayBindingPattern",e[e.BindingElement=187]="BindingElement",e[e.ArrayLiteralExpression=188]="ArrayLiteralExpression",e[e.ObjectLiteralExpression=189]="ObjectLiteralExpression",e[e.PropertyAccessExpression=190]="PropertyAccessExpression",e[e.ElementAccessExpression=191]="ElementAccessExpression",e[e.CallExpression=192]="CallExpression",e[e.NewExpression=193]="NewExpression",e[e.TaggedTemplateExpression=194]="TaggedTemplateExpression",e[e.TypeAssertionExpression=195]="TypeAssertionExpression",e[e.ParenthesizedExpression=196]="ParenthesizedExpression",e[e.FunctionExpression=197]="FunctionExpression",e[e.ArrowFunction=198]="ArrowFunction",e[e.DeleteExpression=199]="DeleteExpression",e[e.TypeOfExpression=200]="TypeOfExpression",e[e.VoidExpression=201]="VoidExpression",e[e.AwaitExpression=202]="AwaitExpression",e[e.PrefixUnaryExpression=203]="PrefixUnaryExpression",e[e.PostfixUnaryExpression=204]="PostfixUnaryExpression",e[e.BinaryExpression=205]="BinaryExpression",e[e.ConditionalExpression=206]="ConditionalExpression",e[e.TemplateExpression=207]="TemplateExpression",e[e.YieldExpression=208]="YieldExpression",e[e.SpreadElement=209]="SpreadElement",e[e.ClassExpression=210]="ClassExpression",e[e.OmittedExpression=211]="OmittedExpression",e[e.ExpressionWithTypeArguments=212]="ExpressionWithTypeArguments",e[e.AsExpression=213]="AsExpression",e[e.NonNullExpression=214]="NonNullExpression",e[e.MetaProperty=215]="MetaProperty",e[e.SyntheticExpression=216]="SyntheticExpression",e[e.TemplateSpan=217]="TemplateSpan",e[e.SemicolonClassElement=218]="SemicolonClassElement",e[e.Block=219]="Block",e[e.VariableStatement=220]="VariableStatement",e[e.EmptyStatement=221]="EmptyStatement",e[e.ExpressionStatement=222]="ExpressionStatement",e[e.IfStatement=223]="IfStatement",e[e.DoStatement=224]="DoStatement",e[e.WhileStatement=225]="WhileStatement",e[e.ForStatement=226]="ForStatement",e[e.ForInStatement=227]="ForInStatement",e[e.ForOfStatement=228]="ForOfStatement",e[e.ContinueStatement=229]="ContinueStatement",e[e.BreakStatement=230]="BreakStatement",e[e.ReturnStatement=231]="ReturnStatement",e[e.WithStatement=232]="WithStatement",e[e.SwitchStatement=233]="SwitchStatement",e[e.LabeledStatement=234]="LabeledStatement",e[e.ThrowStatement=235]="ThrowStatement",e[e.TryStatement=236]="TryStatement",e[e.DebuggerStatement=237]="DebuggerStatement",e[e.VariableDeclaration=238]="VariableDeclaration",e[e.VariableDeclarationList=239]="VariableDeclarationList",e[e.FunctionDeclaration=240]="FunctionDeclaration",e[e.ClassDeclaration=241]="ClassDeclaration",e[e.InterfaceDeclaration=242]="InterfaceDeclaration",e[e.TypeAliasDeclaration=243]="TypeAliasDeclaration",e[e.EnumDeclaration=244]="EnumDeclaration",e[e.ModuleDeclaration=245]="ModuleDeclaration",e[e.ModuleBlock=246]="ModuleBlock",e[e.CaseBlock=247]="CaseBlock",e[e.NamespaceExportDeclaration=248]="NamespaceExportDeclaration",e[e.ImportEqualsDeclaration=249]="ImportEqualsDeclaration",e[e.ImportDeclaration=250]="ImportDeclaration",e[e.ImportClause=251]="ImportClause",e[e.NamespaceImport=252]="NamespaceImport",e[e.NamedImports=253]="NamedImports",e[e.ImportSpecifier=254]="ImportSpecifier",e[e.ExportAssignment=255]="ExportAssignment",e[e.ExportDeclaration=256]="ExportDeclaration",e[e.NamedExports=257]="NamedExports",e[e.ExportSpecifier=258]="ExportSpecifier",e[e.MissingDeclaration=259]="MissingDeclaration",e[e.ExternalModuleReference=260]="ExternalModuleReference",e[e.JsxElement=261]="JsxElement",e[e.JsxSelfClosingElement=262]="JsxSelfClosingElement",e[e.JsxOpeningElement=263]="JsxOpeningElement",e[e.JsxClosingElement=264]="JsxClosingElement",e[e.JsxFragment=265]="JsxFragment",e[e.JsxOpeningFragment=266]="JsxOpeningFragment",e[e.JsxClosingFragment=267]="JsxClosingFragment",e[e.JsxAttribute=268]="JsxAttribute",e[e.JsxAttributes=269]="JsxAttributes",e[e.JsxSpreadAttribute=270]="JsxSpreadAttribute",e[e.JsxExpression=271]="JsxExpression",e[e.CaseClause=272]="CaseClause",e[e.DefaultClause=273]="DefaultClause",e[e.HeritageClause=274]="HeritageClause",e[e.CatchClause=275]="CatchClause",e[e.PropertyAssignment=276]="PropertyAssignment",e[e.ShorthandPropertyAssignment=277]="ShorthandPropertyAssignment",e[e.SpreadAssignment=278]="SpreadAssignment",e[e.EnumMember=279]="EnumMember",e[e.UnparsedPrologue=280]="UnparsedPrologue",e[e.UnparsedPrepend=281]="UnparsedPrepend",e[e.UnparsedText=282]="UnparsedText",e[e.UnparsedInternalText=283]="UnparsedInternalText",e[e.UnparsedSyntheticReference=284]="UnparsedSyntheticReference",e[e.SourceFile=285]="SourceFile",e[e.Bundle=286]="Bundle",e[e.UnparsedSource=287]="UnparsedSource",e[e.InputFiles=288]="InputFiles",e[e.JSDocTypeExpression=289]="JSDocTypeExpression",e[e.JSDocAllType=290]="JSDocAllType",e[e.JSDocUnknownType=291]="JSDocUnknownType",e[e.JSDocNullableType=292]="JSDocNullableType",e[e.JSDocNonNullableType=293]="JSDocNonNullableType",e[e.JSDocOptionalType=294]="JSDocOptionalType",e[e.JSDocFunctionType=295]="JSDocFunctionType",e[e.JSDocVariadicType=296]="JSDocVariadicType",e[e.JSDocComment=297]="JSDocComment",e[e.JSDocTypeLiteral=298]="JSDocTypeLiteral",e[e.JSDocSignature=299]="JSDocSignature",e[e.JSDocTag=300]="JSDocTag",e[e.JSDocAugmentsTag=301]="JSDocAugmentsTag",e[e.JSDocClassTag=302]="JSDocClassTag",e[e.JSDocCallbackTag=303]="JSDocCallbackTag",e[e.JSDocEnumTag=304]="JSDocEnumTag",e[e.JSDocParameterTag=305]="JSDocParameterTag",e[e.JSDocReturnTag=306]="JSDocReturnTag",e[e.JSDocThisTag=307]="JSDocThisTag",e[e.JSDocTypeTag=308]="JSDocTypeTag",e[e.JSDocTemplateTag=309]="JSDocTemplateTag",e[e.JSDocTypedefTag=310]="JSDocTypedefTag",e[e.JSDocPropertyTag=311]="JSDocPropertyTag",e[e.SyntaxList=312]="SyntaxList",e[e.NotEmittedStatement=313]="NotEmittedStatement",e[e.PartiallyEmittedExpression=314]="PartiallyEmittedExpression",e[e.CommaListExpression=315]="CommaListExpression",e[e.MergeDeclarationMarker=316]="MergeDeclarationMarker",e[e.EndOfDeclarationMarker=317]="EndOfDeclarationMarker",e[e.Count=318]="Count",e[e.FirstAssignment=60]="FirstAssignment",e[e.LastAssignment=72]="LastAssignment",e[e.FirstCompoundAssignment=61]="FirstCompoundAssignment",e[e.LastCompoundAssignment=72]="LastCompoundAssignment",e[e.FirstReservedWord=74]="FirstReservedWord",e[e.LastReservedWord=109]="LastReservedWord",e[e.FirstKeyword=74]="FirstKeyword",e[e.LastKeyword=148]="LastKeyword",e[e.FirstFutureReservedWord=110]="FirstFutureReservedWord",e[e.LastFutureReservedWord=118]="LastFutureReservedWord",e[e.FirstTypeNode=164]="FirstTypeNode",e[e.LastTypeNode=184]="LastTypeNode",e[e.FirstPunctuation=18]="FirstPunctuation",e[e.LastPunctuation=72]="LastPunctuation",e[e.FirstToken=0]="FirstToken",e[e.LastToken=148]="LastToken",e[e.FirstTriviaToken=2]="FirstTriviaToken",e[e.LastTriviaToken=7]="LastTriviaToken",e[e.FirstLiteralToken=8]="FirstLiteralToken",e[e.LastLiteralToken=14]="LastLiteralToken",e[e.FirstTemplateToken=14]="FirstTemplateToken",e[e.LastTemplateToken=17]="LastTemplateToken",e[e.FirstBinaryOperator=28]="FirstBinaryOperator",e[e.LastBinaryOperator=72]="LastBinaryOperator",e[e.FirstNode=149]="FirstNode",e[e.FirstJSDocNode=289]="FirstJSDocNode",e[e.LastJSDocNode=311]="LastJSDocNode",e[e.FirstJSDocTagNode=300]="FirstJSDocTagNode",e[e.LastJSDocTagNode=311]="LastJSDocTagNode",e[e.FirstContextualKeyword=119]="FirstContextualKeyword",e[e.LastContextualKeyword=148]="LastContextualKeyword"}(r=e.SyntaxKind||(e.SyntaxKind={}));var n;!function(e){e[e.None=0]="None",e[e.Let=1]="Let",e[e.Const=2]="Const",e[e.NestedNamespace=4]="NestedNamespace",e[e.Synthesized=8]="Synthesized",e[e.Namespace=16]="Namespace",e[e.ExportContext=32]="ExportContext",e[e.ContainsThis=64]="ContainsThis",e[e.HasImplicitReturn=128]="HasImplicitReturn",e[e.HasExplicitReturn=256]="HasExplicitReturn",e[e.GlobalAugmentation=512]="GlobalAugmentation",e[e.HasAsyncFunctions=1024]="HasAsyncFunctions",e[e.DisallowInContext=2048]="DisallowInContext",e[e.YieldContext=4096]="YieldContext",e[e.DecoratorContext=8192]="DecoratorContext",e[e.AwaitContext=16384]="AwaitContext",e[e.ThisNodeHasError=32768]="ThisNodeHasError",e[e.JavaScriptFile=65536]="JavaScriptFile",e[e.ThisNodeOrAnySubNodesHasError=131072]="ThisNodeOrAnySubNodesHasError",e[e.HasAggregatedChildData=262144]="HasAggregatedChildData",e[e.PossiblyContainsDynamicImport=524288]="PossiblyContainsDynamicImport",e[e.PossiblyContainsImportMeta=1048576]="PossiblyContainsImportMeta",e[e.JSDoc=2097152]="JSDoc",e[e.Ambient=4194304]="Ambient",e[e.InWithStatement=8388608]="InWithStatement",e[e.JsonFile=16777216]="JsonFile",e[e.BlockScoped=3]="BlockScoped",e[e.ReachabilityCheckFlags=384]="ReachabilityCheckFlags",e[e.ReachabilityAndEmitFlags=1408]="ReachabilityAndEmitFlags",e[e.ContextFlags=12679168]="ContextFlags",e[e.TypeExcludesFlags=20480]="TypeExcludesFlags",e[e.PermanentlySetIncrementalFlags=1572864]="PermanentlySetIncrementalFlags"}(n=e.NodeFlags||(e.NodeFlags={}));var i;!function(e){e[e.None=0]="None",e[e.Export=1]="Export",e[e.Ambient=2]="Ambient",e[e.Public=4]="Public",e[e.Private=8]="Private",e[e.Protected=16]="Protected",e[e.Static=32]="Static",e[e.Readonly=64]="Readonly",e[e.Abstract=128]="Abstract",e[e.Async=256]="Async",e[e.Default=512]="Default",e[e.Const=2048]="Const",e[e.HasComputedFlags=536870912]="HasComputedFlags",e[e.AccessibilityModifier=28]="AccessibilityModifier",e[e.ParameterPropertyModifier=92]="ParameterPropertyModifier",e[e.NonPublicAccessibilityModifier=24]="NonPublicAccessibilityModifier",e[e.TypeScriptModifier=2270]="TypeScriptModifier",e[e.ExportDefault=513]="ExportDefault",e[e.All=3071]="All"}(i=e.ModifierFlags||(e.ModifierFlags={}));var a;!function(e){e[e.None=0]="None",e[e.IntrinsicNamedElement=1]="IntrinsicNamedElement",e[e.IntrinsicIndexedElement=2]="IntrinsicIndexedElement",e[e.IntrinsicElement=3]="IntrinsicElement"}(a=e.JsxFlags||(e.JsxFlags={}));var o;!function(e){e[e.Succeeded=1]="Succeeded",e[e.Failed=2]="Failed",e[e.FailedAndReported=3]="FailedAndReported"}(o=e.RelationComparisonResult||(e.RelationComparisonResult={}));var s;!function(e){e[e.None=0]="None",e[e.Auto=1]="Auto",e[e.Loop=2]="Loop",e[e.Unique=3]="Unique",e[e.Node=4]="Node",e[e.KindMask=7]="KindMask",e[e.ReservedInNestedScopes=8]="ReservedInNestedScopes",e[e.Optimistic=16]="Optimistic",e[e.FileLevel=32]="FileLevel"}(s=e.GeneratedIdentifierFlags||(e.GeneratedIdentifierFlags={}));var c;!function(e){e[e.None=0]="None",e[e.PrecedingLineBreak=1]="PrecedingLineBreak",e[e.PrecedingJSDocComment=2]="PrecedingJSDocComment",e[e.Unterminated=4]="Unterminated",e[e.ExtendedUnicodeEscape=8]="ExtendedUnicodeEscape",e[e.Scientific=16]="Scientific",e[e.Octal=32]="Octal",e[e.HexSpecifier=64]="HexSpecifier",e[e.BinarySpecifier=128]="BinarySpecifier",e[e.OctalSpecifier=256]="OctalSpecifier",e[e.ContainsSeparator=512]="ContainsSeparator",e[e.BinaryOrOctalSpecifier=384]="BinaryOrOctalSpecifier",e[e.NumericLiteralFlags=1008]="NumericLiteralFlags"}(c=e.TokenFlags||(e.TokenFlags={}));var u;!function(e){e[e.Unreachable=1]="Unreachable",e[e.Start=2]="Start",e[e.BranchLabel=4]="BranchLabel",e[e.LoopLabel=8]="LoopLabel",e[e.Assignment=16]="Assignment",e[e.TrueCondition=32]="TrueCondition",e[e.FalseCondition=64]="FalseCondition",e[e.SwitchClause=128]="SwitchClause",e[e.ArrayMutation=256]="ArrayMutation",e[e.Referenced=512]="Referenced",e[e.Shared=1024]="Shared",e[e.PreFinally=2048]="PreFinally",e[e.AfterFinally=4096]="AfterFinally",e[e.Cached=8192]="Cached",e[e.Label=12]="Label",e[e.Condition=96]="Condition"}(u=e.FlowFlags||(e.FlowFlags={}));var l=function(){function e(){}return e}();e.OperationCanceledException=l;var _;!function(e){e[e.Not=0]="Not",e[e.SafeModules=1]="SafeModules",e[e.Completely=2]="Completely"}(_=e.StructureIsReused||(e.StructureIsReused={}));var d;!function(e){e[e.Success=0]="Success",e[e.DiagnosticsPresent_OutputsSkipped=1]="DiagnosticsPresent_OutputsSkipped",e[e.DiagnosticsPresent_OutputsGenerated=2]="DiagnosticsPresent_OutputsGenerated"}(d=e.ExitStatus||(e.ExitStatus={}));var p;!function(e){e[e.None=0]="None",e[e.Literal=1]="Literal",e[e.Subtype=2]="Subtype"}(p=e.UnionReduction||(e.UnionReduction={}));var f;!function(e){e[e.None=0]="None",e[e.NoTruncation=1]="NoTruncation",e[e.WriteArrayAsGenericType=2]="WriteArrayAsGenericType",e[e.GenerateNamesForShadowedTypeParams=4]="GenerateNamesForShadowedTypeParams",e[e.UseStructuralFallback=8]="UseStructuralFallback",e[e.ForbidIndexedAccessSymbolReferences=16]="ForbidIndexedAccessSymbolReferences",e[e.WriteTypeArgumentsOfSignature=32]="WriteTypeArgumentsOfSignature",e[e.UseFullyQualifiedType=64]="UseFullyQualifiedType",e[e.UseOnlyExternalAliasing=128]="UseOnlyExternalAliasing",e[e.SuppressAnyReturnType=256]="SuppressAnyReturnType",e[e.WriteTypeParametersInQualifiedName=512]="WriteTypeParametersInQualifiedName",e[e.MultilineObjectLiterals=1024]="MultilineObjectLiterals",e[e.WriteClassExpressionAsTypeLiteral=2048]="WriteClassExpressionAsTypeLiteral",e[e.UseTypeOfFunction=4096]="UseTypeOfFunction",e[e.OmitParameterModifiers=8192]="OmitParameterModifiers",e[e.UseAliasDefinedOutsideCurrentScope=16384]="UseAliasDefinedOutsideCurrentScope",e[e.AllowThisInObjectLiteral=32768]="AllowThisInObjectLiteral",e[e.AllowQualifedNameInPlaceOfIdentifier=65536]="AllowQualifedNameInPlaceOfIdentifier",e[e.AllowAnonymousIdentifier=131072]="AllowAnonymousIdentifier",e[e.AllowEmptyUnionOrIntersection=262144]="AllowEmptyUnionOrIntersection",e[e.AllowEmptyTuple=524288]="AllowEmptyTuple",e[e.AllowUniqueESSymbolType=1048576]="AllowUniqueESSymbolType",e[e.AllowEmptyIndexInfoType=2097152]="AllowEmptyIndexInfoType",e[e.AllowNodeModulesRelativePaths=67108864]="AllowNodeModulesRelativePaths",e[e.DoNotIncludeSymbolChain=134217728]="DoNotIncludeSymbolChain",e[e.IgnoreErrors=70221824]="IgnoreErrors",e[e.InObjectTypeLiteral=4194304]="InObjectTypeLiteral",e[e.InTypeAlias=8388608]="InTypeAlias",e[e.InInitialEntityName=16777216]="InInitialEntityName",e[e.InReverseMappedType=33554432]="InReverseMappedType"}(f=e.NodeBuilderFlags||(e.NodeBuilderFlags={}));var m;!function(e){e[e.None=0]="None",e[e.NoTruncation=1]="NoTruncation",e[e.WriteArrayAsGenericType=2]="WriteArrayAsGenericType",e[e.UseStructuralFallback=8]="UseStructuralFallback",e[e.WriteTypeArgumentsOfSignature=32]="WriteTypeArgumentsOfSignature",e[e.UseFullyQualifiedType=64]="UseFullyQualifiedType",e[e.SuppressAnyReturnType=256]="SuppressAnyReturnType",e[e.MultilineObjectLiterals=1024]="MultilineObjectLiterals",e[e.WriteClassExpressionAsTypeLiteral=2048]="WriteClassExpressionAsTypeLiteral",e[e.UseTypeOfFunction=4096]="UseTypeOfFunction",e[e.OmitParameterModifiers=8192]="OmitParameterModifiers",e[e.UseAliasDefinedOutsideCurrentScope=16384]="UseAliasDefinedOutsideCurrentScope",e[e.AllowUniqueESSymbolType=1048576]="AllowUniqueESSymbolType",e[e.AddUndefined=131072]="AddUndefined",e[e.WriteArrowStyleSignature=262144]="WriteArrowStyleSignature",e[e.InArrayType=524288]="InArrayType",e[e.InElementType=2097152]="InElementType",e[e.InFirstTypeArgument=4194304]="InFirstTypeArgument",e[e.InTypeAlias=8388608]="InTypeAlias",e[e.WriteOwnNameForAnyLike=0]="WriteOwnNameForAnyLike",e[e.NodeBuilderFlagsMask=9469291]="NodeBuilderFlagsMask"}(m=e.TypeFormatFlags||(e.TypeFormatFlags={}));var g;!function(e){e[e.None=0]="None",e[e.WriteTypeParametersOrArguments=1]="WriteTypeParametersOrArguments",e[e.UseOnlyExternalAliasing=2]="UseOnlyExternalAliasing",e[e.AllowAnyNodeKind=4]="AllowAnyNodeKind",e[e.UseAliasDefinedOutsideCurrentScope=8]="UseAliasDefinedOutsideCurrentScope",e[e.DoNotIncludeSymbolChain=16]="DoNotIncludeSymbolChain"}(g=e.SymbolFormatFlags||(e.SymbolFormatFlags={}));var v;!function(e){e[e.Accessible=0]="Accessible",e[e.NotAccessible=1]="NotAccessible",e[e.CannotBeNamed=2]="CannotBeNamed"}(v=e.SymbolAccessibility||(e.SymbolAccessibility={}));var y;!function(e){e[e.UnionOrIntersection=0]="UnionOrIntersection",e[e.Spread=1]="Spread"}(y=e.SyntheticSymbolKind||(e.SyntheticSymbolKind={}));var h;!function(e){e[e.This=0]="This",e[e.Identifier=1]="Identifier"}(h=e.TypePredicateKind||(e.TypePredicateKind={}));var b;!function(e){e[e.Unknown=0]="Unknown",e[e.TypeWithConstructSignatureAndValue=1]="TypeWithConstructSignatureAndValue",e[e.VoidNullableOrNeverType=2]="VoidNullableOrNeverType",e[e.NumberLikeType=3]="NumberLikeType",e[e.BigIntLikeType=4]="BigIntLikeType",e[e.StringLikeType=5]="StringLikeType",e[e.BooleanType=6]="BooleanType",e[e.ArrayLikeType=7]="ArrayLikeType",e[e.ESSymbolType=8]="ESSymbolType",e[e.Promise=9]="Promise",e[e.TypeWithCallSignature=10]="TypeWithCallSignature",e[e.ObjectType=11]="ObjectType"}(b=e.TypeReferenceSerializationKind||(e.TypeReferenceSerializationKind={}));var x;!function(e){e[e.None=0]="None",e[e.FunctionScopedVariable=1]="FunctionScopedVariable",e[e.BlockScopedVariable=2]="BlockScopedVariable",e[e.Property=4]="Property",e[e.EnumMember=8]="EnumMember",e[e.Function=16]="Function",e[e.Class=32]="Class",e[e.Interface=64]="Interface",e[e.ConstEnum=128]="ConstEnum",e[e.RegularEnum=256]="RegularEnum",e[e.ValueModule=512]="ValueModule",e[e.NamespaceModule=1024]="NamespaceModule",e[e.TypeLiteral=2048]="TypeLiteral",e[e.ObjectLiteral=4096]="ObjectLiteral",e[e.Method=8192]="Method",e[e.Constructor=16384]="Constructor",e[e.GetAccessor=32768]="GetAccessor",e[e.SetAccessor=65536]="SetAccessor",e[e.Signature=131072]="Signature",e[e.TypeParameter=262144]="TypeParameter",e[e.TypeAlias=524288]="TypeAlias",e[e.ExportValue=1048576]="ExportValue",e[e.Alias=2097152]="Alias",e[e.Prototype=4194304]="Prototype",e[e.ExportStar=8388608]="ExportStar",e[e.Optional=16777216]="Optional",e[e.Transient=33554432]="Transient",e[e.Assignment=67108864]="Assignment",e[e.ModuleExports=134217728]="ModuleExports",e[e.All=67108863]="All",e[e.Enum=384]="Enum",e[e.Variable=3]="Variable",e[e.Value=67220415]="Value",e[e.Type=67897832]="Type",e[e.Namespace=1920]="Namespace",e[e.Module=1536]="Module",e[e.Accessor=98304]="Accessor",e[e.FunctionScopedVariableExcludes=67220414]="FunctionScopedVariableExcludes",e[e.BlockScopedVariableExcludes=67220415]="BlockScopedVariableExcludes",e[e.ParameterExcludes=67220415]="ParameterExcludes",e[e.PropertyExcludes=0]="PropertyExcludes",e[e.EnumMemberExcludes=68008959]="EnumMemberExcludes",e[e.FunctionExcludes=67219887]="FunctionExcludes",e[e.ClassExcludes=68008383]="ClassExcludes",e[e.InterfaceExcludes=67897736]="InterfaceExcludes",e[e.RegularEnumExcludes=68008191]="RegularEnumExcludes",e[e.ConstEnumExcludes=68008831]="ConstEnumExcludes",e[e.ValueModuleExcludes=110735]="ValueModuleExcludes",e[e.NamespaceModuleExcludes=0]="NamespaceModuleExcludes",e[e.MethodExcludes=67212223]="MethodExcludes",e[e.GetAccessorExcludes=67154879]="GetAccessorExcludes",e[e.SetAccessorExcludes=67187647]="SetAccessorExcludes",e[e.TypeParameterExcludes=67635688]="TypeParameterExcludes",e[e.TypeAliasExcludes=67897832]="TypeAliasExcludes",e[e.AliasExcludes=2097152]="AliasExcludes",e[e.ModuleMember=2623475]="ModuleMember",e[e.ExportHasLocal=944]="ExportHasLocal",e[e.BlockScoped=418]="BlockScoped",e[e.PropertyOrAccessor=98308]="PropertyOrAccessor",e[e.ClassMember=106500]="ClassMember",e[e.Classifiable=2885600]="Classifiable",e[e.LateBindingContainer=6240]="LateBindingContainer"}(x=e.SymbolFlags||(e.SymbolFlags={}));var D;!function(e){e[e.Numeric=0]="Numeric",e[e.Literal=1]="Literal"}(D=e.EnumKind||(e.EnumKind={}));var S;!function(e){e[e.Instantiated=1]="Instantiated",e[e.SyntheticProperty=2]="SyntheticProperty",e[e.SyntheticMethod=4]="SyntheticMethod",e[e.Readonly=8]="Readonly",e[e.ReadPartial=16]="ReadPartial",e[e.WritePartial=32]="WritePartial",e[e.HasNonUniformType=64]="HasNonUniformType",e[e.HasLiteralType=128]="HasLiteralType",e[e.ContainsPublic=256]="ContainsPublic",e[e.ContainsProtected=512]="ContainsProtected",e[e.ContainsPrivate=1024]="ContainsPrivate",e[e.ContainsStatic=2048]="ContainsStatic",e[e.Late=4096]="Late",e[e.ReverseMapped=8192]="ReverseMapped",e[e.OptionalParameter=16384]="OptionalParameter",e[e.RestParameter=32768]="RestParameter",e[e.DeferredType=65536]="DeferredType",e[e.Synthetic=6]="Synthetic",e[e.Discriminant=192]="Discriminant",e[e.Partial=48]="Partial"}(S=e.CheckFlags||(e.CheckFlags={}));var C;!function(e){e.Call="__call",e.Constructor="__constructor",e.New="__new",e.Index="__index",e.ExportStar="__export",e.Global="__global",e.Missing="__missing",e.Type="__type",e.Object="__object",e.JSXAttributes="__jsxAttributes",e.Class="__class",e.Function="__function",e.Computed="__computed",e.Resolving="__resolving__",e.ExportEquals="export=",e.Default="default",e.This="this"}(C=e.InternalSymbolName||(e.InternalSymbolName={}));var k;!function(e){e[e.TypeChecked=1]="TypeChecked",e[e.LexicalThis=2]="LexicalThis",e[e.CaptureThis=4]="CaptureThis",e[e.CaptureNewTarget=8]="CaptureNewTarget",e[e.SuperInstance=256]="SuperInstance",e[e.SuperStatic=512]="SuperStatic",e[e.ContextChecked=1024]="ContextChecked",e[e.AsyncMethodWithSuper=2048]="AsyncMethodWithSuper",e[e.AsyncMethodWithSuperBinding=4096]="AsyncMethodWithSuperBinding",e[e.CaptureArguments=8192]="CaptureArguments",e[e.EnumValuesComputed=16384]="EnumValuesComputed",e[e.LexicalModuleMergesWithClass=32768]="LexicalModuleMergesWithClass",e[e.LoopWithCapturedBlockScopedBinding=65536]="LoopWithCapturedBlockScopedBinding",e[e.ContainsCapturedBlockScopeBinding=131072]="ContainsCapturedBlockScopeBinding",e[e.CapturedBlockScopedBinding=262144]="CapturedBlockScopedBinding",e[e.BlockScopedBindingInLoop=524288]="BlockScopedBindingInLoop",e[e.ClassWithBodyScopedClassBinding=1048576]="ClassWithBodyScopedClassBinding",e[e.BodyScopedClassBinding=2097152]="BodyScopedClassBinding",e[e.NeedsLoopOutParameter=4194304]="NeedsLoopOutParameter",e[e.AssignmentsMarked=8388608]="AssignmentsMarked",e[e.ClassWithConstructorReference=16777216]="ClassWithConstructorReference",e[e.ConstructorReferenceInClass=33554432]="ConstructorReferenceInClass"}(k=e.NodeCheckFlags||(e.NodeCheckFlags={}));var T;!function(e){e[e.Any=1]="Any",e[e.Unknown=2]="Unknown",e[e.String=4]="String",e[e.Number=8]="Number",e[e.Boolean=16]="Boolean",e[e.Enum=32]="Enum",e[e.BigInt=64]="BigInt",e[e.StringLiteral=128]="StringLiteral",e[e.NumberLiteral=256]="NumberLiteral",e[e.BooleanLiteral=512]="BooleanLiteral",e[e.EnumLiteral=1024]="EnumLiteral",e[e.BigIntLiteral=2048]="BigIntLiteral",e[e.ESSymbol=4096]="ESSymbol",e[e.UniqueESSymbol=8192]="UniqueESSymbol",e[e.Void=16384]="Void",e[e.Undefined=32768]="Undefined",e[e.Null=65536]="Null",e[e.Never=131072]="Never",e[e.TypeParameter=262144]="TypeParameter",e[e.Object=524288]="Object",e[e.Union=1048576]="Union",e[e.Intersection=2097152]="Intersection",e[e.Index=4194304]="Index",e[e.IndexedAccess=8388608]="IndexedAccess",e[e.Conditional=16777216]="Conditional",e[e.Substitution=33554432]="Substitution",e[e.NonPrimitive=67108864]="NonPrimitive",e[e.AnyOrUnknown=3]="AnyOrUnknown",e[e.Nullable=98304]="Nullable",e[e.Literal=2944]="Literal",e[e.Unit=109440]="Unit",e[e.StringOrNumberLiteral=384]="StringOrNumberLiteral",e[e.StringOrNumberLiteralOrUnique=8576]="StringOrNumberLiteralOrUnique",e[e.DefinitelyFalsy=117632]="DefinitelyFalsy",e[e.PossiblyFalsy=117724]="PossiblyFalsy",e[e.Intrinsic=67359327]="Intrinsic",e[e.Primitive=131068]="Primitive",e[e.StringLike=132]="StringLike",e[e.NumberLike=296]="NumberLike",e[e.BigIntLike=2112]="BigIntLike",e[e.BooleanLike=528]="BooleanLike",e[e.EnumLike=1056]="EnumLike",e[e.ESSymbolLike=12288]="ESSymbolLike",e[e.VoidLike=49152]="VoidLike",e[e.DisjointDomains=67238908]="DisjointDomains",e[e.UnionOrIntersection=3145728]="UnionOrIntersection",e[e.StructuredType=3670016]="StructuredType",e[e.TypeVariable=8650752]="TypeVariable",e[e.InstantiableNonPrimitive=58982400]="InstantiableNonPrimitive",e[e.InstantiablePrimitive=4194304]="InstantiablePrimitive",e[e.Instantiable=63176704]="Instantiable",e[e.StructuredOrInstantiable=66846720]="StructuredOrInstantiable",e[e.ObjectFlagsType=3899392]="ObjectFlagsType",e[e.Simplifiable=25165824]="Simplifiable",e[e.Narrowable=133970943]="Narrowable",e[e.NotUnionOrUnit=67637251]="NotUnionOrUnit",e[e.NotPrimitiveUnion=66994211]="NotPrimitiveUnion",e[e.IncludesMask=1835007]="IncludesMask",e[e.IncludesStructuredOrInstantiable=262144]="IncludesStructuredOrInstantiable",e[e.IncludesNonWideningType=2097152]="IncludesNonWideningType",e[e.IncludesWildcard=4194304]="IncludesWildcard",e[e.IncludesEmptyObject=8388608]="IncludesEmptyObject",e[e.GenericMappedType=131072]="GenericMappedType"
}(T=e.TypeFlags||(e.TypeFlags={}));var E;!function(e){e[e.Class=1]="Class",e[e.Interface=2]="Interface",e[e.Reference=4]="Reference",e[e.Tuple=8]="Tuple",e[e.Anonymous=16]="Anonymous",e[e.Mapped=32]="Mapped",e[e.Instantiated=64]="Instantiated",e[e.ObjectLiteral=128]="ObjectLiteral",e[e.EvolvingArray=256]="EvolvingArray",e[e.ObjectLiteralPatternWithComputedProperties=512]="ObjectLiteralPatternWithComputedProperties",e[e.ContainsSpread=1024]="ContainsSpread",e[e.ReverseMapped=2048]="ReverseMapped",e[e.JsxAttributes=4096]="JsxAttributes",e[e.MarkerType=8192]="MarkerType",e[e.JSLiteral=16384]="JSLiteral",e[e.FreshLiteral=32768]="FreshLiteral",e[e.PrimitiveUnion=65536]="PrimitiveUnion",e[e.ContainsWideningType=131072]="ContainsWideningType",e[e.ContainsObjectLiteral=262144]="ContainsObjectLiteral",e[e.NonInferrableType=524288]="NonInferrableType",e[e.ClassOrInterface=3]="ClassOrInterface",e[e.RequiresWidening=393216]="RequiresWidening",e[e.PropagatingFlags=917504]="PropagatingFlags"}(E=e.ObjectFlags||(e.ObjectFlags={}));var N;!function(e){e[e.Invariant=0]="Invariant",e[e.Covariant=1]="Covariant",e[e.Contravariant=2]="Contravariant",e[e.Bivariant=3]="Bivariant",e[e.Independent=4]="Independent",e[e.VarianceMask=7]="VarianceMask",e[e.Unmeasurable=8]="Unmeasurable",e[e.Unreliable=16]="Unreliable",e[e.AllowsStructuralFallback=24]="AllowsStructuralFallback"}(N=e.VarianceFlags||(e.VarianceFlags={}));var A;!function(e){e[e.Component=0]="Component",e[e.Function=1]="Function",e[e.Mixed=2]="Mixed"}(A=e.JsxReferenceKind||(e.JsxReferenceKind={}));var F;!function(e){e[e.Call=0]="Call",e[e.Construct=1]="Construct"}(F=e.SignatureKind||(e.SignatureKind={}));var P;!function(e){e[e.String=0]="String",e[e.Number=1]="Number"}(P=e.IndexKind||(e.IndexKind={}));var w;!function(e){e[e.NakedTypeVariable=1]="NakedTypeVariable",e[e.HomomorphicMappedType=2]="HomomorphicMappedType",e[e.PartialHomomorphicMappedType=4]="PartialHomomorphicMappedType",e[e.MappedTypeConstraint=8]="MappedTypeConstraint",e[e.ReturnType=16]="ReturnType",e[e.LiteralKeyof=32]="LiteralKeyof",e[e.NoConstraints=64]="NoConstraints",e[e.AlwaysStrict=128]="AlwaysStrict",e[e.PriorityImpliesCombination=56]="PriorityImpliesCombination"}(w=e.InferencePriority||(e.InferencePriority={}));var I;!function(e){e[e.None=0]="None",e[e.NoDefault=1]="NoDefault",e[e.AnyDefault=2]="AnyDefault",e[e.SkippedGenericFunction=4]="SkippedGenericFunction"}(I=e.InferenceFlags||(e.InferenceFlags={}));var O;!function(e){e[e.False=0]="False",e[e.Maybe=1]="Maybe",e[e.True=-1]="True"}(O=e.Ternary||(e.Ternary={}));var M;!function(e){e[e.None=0]="None",e[e.ExportsProperty=1]="ExportsProperty",e[e.ModuleExports=2]="ModuleExports",e[e.PrototypeProperty=3]="PrototypeProperty",e[e.ThisProperty=4]="ThisProperty",e[e.Property=5]="Property",e[e.Prototype=6]="Prototype",e[e.ObjectDefinePropertyValue=7]="ObjectDefinePropertyValue",e[e.ObjectDefinePropertyExports=8]="ObjectDefinePropertyExports",e[e.ObjectDefinePrototypeProperty=9]="ObjectDefinePrototypeProperty"}(M=e.AssignmentDeclarationKind||(e.AssignmentDeclarationKind={}));var L;!function(e){e[e.Warning=0]="Warning",e[e.Error=1]="Error",e[e.Suggestion=2]="Suggestion",e[e.Message=3]="Message"}(L=e.DiagnosticCategory||(e.DiagnosticCategory={})),e.diagnosticCategoryName=t;var R;!function(e){e[e.Classic=1]="Classic",e[e.NodeJs=2]="NodeJs"}(R=e.ModuleResolutionKind||(e.ModuleResolutionKind={}));var B;!function(e){e[e.None=0]="None",e[e.CommonJS=1]="CommonJS",e[e.AMD=2]="AMD",e[e.UMD=3]="UMD",e[e.System=4]="System",e[e.ES2015=5]="ES2015",e[e.ESNext=6]="ESNext"}(B=e.ModuleKind||(e.ModuleKind={}));var j;!function(e){e[e.None=0]="None",e[e.Preserve=1]="Preserve",e[e.React=2]="React",e[e.ReactNative=3]="ReactNative"}(j=e.JsxEmit||(e.JsxEmit={}));var J;!function(e){e[e.CarriageReturnLineFeed=0]="CarriageReturnLineFeed",e[e.LineFeed=1]="LineFeed"}(J=e.NewLineKind||(e.NewLineKind={}));var z;!function(e){e[e.Unknown=0]="Unknown",e[e.JS=1]="JS",e[e.JSX=2]="JSX",e[e.TS=3]="TS",e[e.TSX=4]="TSX",e[e.External=5]="External",e[e.JSON=6]="JSON",e[e.Deferred=7]="Deferred"}(z=e.ScriptKind||(e.ScriptKind={}));var V;!function(e){e[e.ES3=0]="ES3",e[e.ES5=1]="ES5",e[e.ES2015=2]="ES2015",e[e.ES2016=3]="ES2016",e[e.ES2017=4]="ES2017",e[e.ES2018=5]="ES2018",e[e.ES2019=6]="ES2019",e[e.ES2020=7]="ES2020",e[e.ESNext=8]="ESNext",e[e.JSON=100]="JSON",e[e.Latest=8]="Latest"}(V=e.ScriptTarget||(e.ScriptTarget={}));var U;!function(e){e[e.Standard=0]="Standard",e[e.JSX=1]="JSX"}(U=e.LanguageVariant||(e.LanguageVariant={}));var K;!function(e){e[e.None=0]="None",e[e.Recursive=1]="Recursive"}(K=e.WatchDirectoryFlags||(e.WatchDirectoryFlags={}));var q;!function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.backtick=96]="backtick",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.hash=35]="hash",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"}(q=e.CharacterCodes||(e.CharacterCodes={}));var W;!function(e){e.Ts=".ts",e.Tsx=".tsx",e.Dts=".d.ts",e.Js=".js",e.Jsx=".jsx",e.Json=".json",e.TsBuildInfo=".tsbuildinfo"}(W=e.Extension||(e.Extension={}));var H;!function(e){e[e.None=0]="None",e[e.ContainsTypeScript=1]="ContainsTypeScript",e[e.ContainsJsx=2]="ContainsJsx",e[e.ContainsESNext=4]="ContainsESNext",e[e.ContainsES2019=8]="ContainsES2019",e[e.ContainsES2018=16]="ContainsES2018",e[e.ContainsES2017=32]="ContainsES2017",e[e.ContainsES2016=64]="ContainsES2016",e[e.ContainsES2015=128]="ContainsES2015",e[e.ContainsGenerator=256]="ContainsGenerator",e[e.ContainsDestructuringAssignment=512]="ContainsDestructuringAssignment",e[e.ContainsTypeScriptClassSyntax=1024]="ContainsTypeScriptClassSyntax",e[e.ContainsLexicalThis=2048]="ContainsLexicalThis",e[e.ContainsRestOrSpread=4096]="ContainsRestOrSpread",e[e.ContainsObjectRestOrSpread=8192]="ContainsObjectRestOrSpread",e[e.ContainsComputedPropertyName=16384]="ContainsComputedPropertyName",e[e.ContainsBlockScopedBinding=32768]="ContainsBlockScopedBinding",e[e.ContainsBindingPattern=65536]="ContainsBindingPattern",e[e.ContainsYield=131072]="ContainsYield",e[e.ContainsHoistedDeclarationOrCompletion=262144]="ContainsHoistedDeclarationOrCompletion",e[e.ContainsDynamicImport=524288]="ContainsDynamicImport",e[e.HasComputedFlags=536870912]="HasComputedFlags",e[e.AssertTypeScript=1]="AssertTypeScript",e[e.AssertJsx=2]="AssertJsx",e[e.AssertESNext=4]="AssertESNext",e[e.AssertES2019=8]="AssertES2019",e[e.AssertES2018=16]="AssertES2018",e[e.AssertES2017=32]="AssertES2017",e[e.AssertES2016=64]="AssertES2016",e[e.AssertES2015=128]="AssertES2015",e[e.AssertGenerator=256]="AssertGenerator",e[e.AssertDestructuringAssignment=512]="AssertDestructuringAssignment",e[e.OuterExpressionExcludes=536870912]="OuterExpressionExcludes",e[e.PropertyAccessExcludes=536870912]="PropertyAccessExcludes",e[e.NodeExcludes=536870912]="NodeExcludes",e[e.ArrowFunctionExcludes=537371648]="ArrowFunctionExcludes",e[e.FunctionExcludes=537373696]="FunctionExcludes",e[e.ConstructorExcludes=537372672]="ConstructorExcludes",e[e.MethodOrAccessorExcludes=537372672]="MethodOrAccessorExcludes",e[e.PropertyExcludes=536872960]="PropertyExcludes",e[e.ClassExcludes=536888320]="ClassExcludes",e[e.ModuleExcludes=537168896]="ModuleExcludes",e[e.TypeExcludes=-2]="TypeExcludes",e[e.ObjectLiteralExcludes=536896512]="ObjectLiteralExcludes",e[e.ArrayLiteralOrCallOrNewExcludes=536875008]="ArrayLiteralOrCallOrNewExcludes",e[e.VariableDeclarationListExcludes=536944640]="VariableDeclarationListExcludes",e[e.ParameterExcludes=536870912]="ParameterExcludes",e[e.CatchClauseExcludes=536879104]="CatchClauseExcludes",e[e.BindingPatternExcludes=536875008]="BindingPatternExcludes",e[e.PropertyNamePropagatingFlags=2048]="PropertyNamePropagatingFlags"}(H=e.TransformFlags||(e.TransformFlags={}));var G;!function(e){e[e.None=0]="None",e[e.SingleLine=1]="SingleLine",e[e.AdviseOnEmitNode=2]="AdviseOnEmitNode",e[e.NoSubstitution=4]="NoSubstitution",e[e.CapturesThis=8]="CapturesThis",e[e.NoLeadingSourceMap=16]="NoLeadingSourceMap",e[e.NoTrailingSourceMap=32]="NoTrailingSourceMap",e[e.NoSourceMap=48]="NoSourceMap",e[e.NoNestedSourceMaps=64]="NoNestedSourceMaps",e[e.NoTokenLeadingSourceMaps=128]="NoTokenLeadingSourceMaps",e[e.NoTokenTrailingSourceMaps=256]="NoTokenTrailingSourceMaps",e[e.NoTokenSourceMaps=384]="NoTokenSourceMaps",e[e.NoLeadingComments=512]="NoLeadingComments",e[e.NoTrailingComments=1024]="NoTrailingComments",e[e.NoComments=1536]="NoComments",e[e.NoNestedComments=2048]="NoNestedComments",e[e.HelperName=4096]="HelperName",e[e.ExportName=8192]="ExportName",e[e.LocalName=16384]="LocalName",e[e.InternalName=32768]="InternalName",e[e.Indented=65536]="Indented",e[e.NoIndentation=131072]="NoIndentation",e[e.AsyncFunctionBody=262144]="AsyncFunctionBody",e[e.ReuseTempVariableScope=524288]="ReuseTempVariableScope",e[e.CustomPrologue=1048576]="CustomPrologue",e[e.NoHoisting=2097152]="NoHoisting",e[e.HasEndOfDeclarationMarker=4194304]="HasEndOfDeclarationMarker",e[e.Iterator=8388608]="Iterator",e[e.NoAsciiEscaping=16777216]="NoAsciiEscaping",e[e.TypeScriptClassWrapper=33554432]="TypeScriptClassWrapper",e[e.NeverApplyImportHelper=67108864]="NeverApplyImportHelper"}(G=e.EmitFlags||(e.EmitFlags={}));var Q;!function(e){e[e.Extends=1]="Extends",e[e.Assign=2]="Assign",e[e.Rest=4]="Rest",e[e.Decorate=8]="Decorate",e[e.Metadata=16]="Metadata",e[e.Param=32]="Param",e[e.Awaiter=64]="Awaiter",e[e.Generator=128]="Generator",e[e.Values=256]="Values",e[e.Read=512]="Read",e[e.Spread=1024]="Spread",e[e.Await=2048]="Await",e[e.AsyncGenerator=4096]="AsyncGenerator",e[e.AsyncDelegator=8192]="AsyncDelegator",e[e.AsyncValues=16384]="AsyncValues",e[e.ExportStar=32768]="ExportStar",e[e.MakeTemplateObject=65536]="MakeTemplateObject",e[e.FirstEmitHelper=1]="FirstEmitHelper",e[e.LastEmitHelper=65536]="LastEmitHelper",e[e.ForOfIncludes=256]="ForOfIncludes",e[e.ForAwaitOfIncludes=16384]="ForAwaitOfIncludes",e[e.AsyncGeneratorIncludes=6144]="AsyncGeneratorIncludes",e[e.AsyncDelegatorIncludes=26624]="AsyncDelegatorIncludes",e[e.SpreadIncludes=1536]="SpreadIncludes"}(Q=e.ExternalEmitHelpers||(e.ExternalEmitHelpers={}));var X;!function(e){e[e.SourceFile=0]="SourceFile",e[e.Expression=1]="Expression",e[e.IdentifierName=2]="IdentifierName",e[e.MappedTypeParameter=3]="MappedTypeParameter",e[e.Unspecified=4]="Unspecified",e[e.EmbeddedStatement=5]="EmbeddedStatement"}(X=e.EmitHint||(e.EmitHint={}));var Y;!function(e){e.Prologue="prologue",e.EmitHelpers="emitHelpers",e.NoDefaultLib="no-default-lib",e.Reference="reference",e.Type="type",e.Lib="lib",e.Prepend="prepend",e.Text="text",e.Internal="internal"}(Y=e.BundleFileSectionKind||(e.BundleFileSectionKind={}));var Z;!function(e){e[e.None=0]="None",e[e.SingleLine=0]="SingleLine",e[e.MultiLine=1]="MultiLine",e[e.PreserveLines=2]="PreserveLines",e[e.LinesMask=3]="LinesMask",e[e.NotDelimited=0]="NotDelimited",e[e.BarDelimited=4]="BarDelimited",e[e.AmpersandDelimited=8]="AmpersandDelimited",e[e.CommaDelimited=16]="CommaDelimited",e[e.AsteriskDelimited=32]="AsteriskDelimited",e[e.DelimitersMask=60]="DelimitersMask",e[e.AllowTrailingComma=64]="AllowTrailingComma",e[e.Indented=128]="Indented",e[e.SpaceBetweenBraces=256]="SpaceBetweenBraces",e[e.SpaceBetweenSiblings=512]="SpaceBetweenSiblings",e[e.Braces=1024]="Braces",e[e.Parenthesis=2048]="Parenthesis",e[e.AngleBrackets=4096]="AngleBrackets",e[e.SquareBrackets=8192]="SquareBrackets",e[e.BracketsMask=15360]="BracketsMask",e[e.OptionalIfUndefined=16384]="OptionalIfUndefined",e[e.OptionalIfEmpty=32768]="OptionalIfEmpty",e[e.Optional=49152]="Optional",e[e.PreferNewLine=65536]="PreferNewLine",e[e.NoTrailingNewLine=131072]="NoTrailingNewLine",e[e.NoInterveningComments=262144]="NoInterveningComments",e[e.NoSpaceIfEmpty=524288]="NoSpaceIfEmpty",e[e.SingleElement=1048576]="SingleElement",e[e.Modifiers=262656]="Modifiers",e[e.HeritageClauses=512]="HeritageClauses",e[e.SingleLineTypeLiteralMembers=768]="SingleLineTypeLiteralMembers",e[e.MultiLineTypeLiteralMembers=32897]="MultiLineTypeLiteralMembers",e[e.TupleTypeElements=528]="TupleTypeElements",e[e.UnionTypeConstituents=516]="UnionTypeConstituents",e[e.IntersectionTypeConstituents=520]="IntersectionTypeConstituents",e[e.ObjectBindingPatternElements=525136]="ObjectBindingPatternElements",e[e.ArrayBindingPatternElements=524880]="ArrayBindingPatternElements",e[e.ObjectLiteralExpressionProperties=526226]="ObjectLiteralExpressionProperties",e[e.ArrayLiteralExpressionElements=8914]="ArrayLiteralExpressionElements",e[e.CommaListElements=528]="CommaListElements",e[e.CallExpressionArguments=2576]="CallExpressionArguments",e[e.NewExpressionArguments=18960]="NewExpressionArguments",e[e.TemplateExpressionSpans=262144]="TemplateExpressionSpans",e[e.SingleLineBlockStatements=768]="SingleLineBlockStatements",e[e.MultiLineBlockStatements=129]="MultiLineBlockStatements",e[e.VariableDeclarationList=528]="VariableDeclarationList",e[e.SingleLineFunctionBodyStatements=768]="SingleLineFunctionBodyStatements",e[e.MultiLineFunctionBodyStatements=1]="MultiLineFunctionBodyStatements",e[e.ClassHeritageClauses=0]="ClassHeritageClauses",e[e.ClassMembers=129]="ClassMembers",e[e.InterfaceMembers=129]="InterfaceMembers",e[e.EnumMembers=145]="EnumMembers",e[e.CaseBlockClauses=129]="CaseBlockClauses",e[e.NamedImportsOrExportsElements=525136]="NamedImportsOrExportsElements",e[e.JsxElementOrFragmentChildren=262144]="JsxElementOrFragmentChildren",e[e.JsxElementAttributes=262656]="JsxElementAttributes",e[e.CaseOrDefaultClauseStatements=163969]="CaseOrDefaultClauseStatements",e[e.HeritageClauseTypes=528]="HeritageClauseTypes",e[e.SourceFileStatements=131073]="SourceFileStatements",e[e.Decorators=49153]="Decorators",e[e.TypeArguments=53776]="TypeArguments",e[e.TypeParameters=53776]="TypeParameters",e[e.Parameters=2576]="Parameters",e[e.IndexSignatureParameters=8848]="IndexSignatureParameters",e[e.JSDocComment=33]="JSDocComment"}(Z=e.ListFormat||(e.ListFormat={}));var $;!function(e){e[e.None=0]="None",e[e.TripleSlashXML=1]="TripleSlashXML",e[e.SingleLine=2]="SingleLine",e[e.MultiLine=4]="MultiLine",e[e.All=7]="All",e[e.Default=7]="Default"}($=e.PragmaKindFlags||(e.PragmaKindFlags={})),e.commentPragmas={reference:{args:[{name:"types",optional:!0,captureSpan:!0},{name:"lib",optional:!0,captureSpan:!0},{name:"path",optional:!0,captureSpan:!0},{name:"no-default-lib",optional:!0}],kind:1},"amd-dependency":{args:[{name:"path"},{name:"name",optional:!0}],kind:1},"amd-module":{args:[{name:"name"}],kind:1},"ts-check":{kind:2},"ts-nocheck":{kind:2},jsx:{args:[{name:"factory"}],kind:4}}}(n||(n={}));var n;!function(e){function t(e){for(var t=5381,r=0;r<e.length;r++)t=(t<<5)+t+e.charCodeAt(r);return t.toString()}function r(){Error.stackTraceLimit<100&&(Error.stackTraceLimit=100)}function n(e){var t;return t={},t[d.Low]=e.Low,t[d.Medium]=e.Medium,t[d.High]=e.High,t}function a(t){function r(e,r){return t.getEnvironmentVariable(e+"_"+r.toUpperCase())}function a(e){function t(t){var i=r(e,t);i&&((n||(n={}))[t]=Number(i))}var n;return t("Low"),t("Medium"),t("High"),n}function o(e,t){function r(e){t[e]=n[e]||t[e]}var n=a(e);return n?(r("Low"),r("Medium"),r("High"),!0):!1}function s(e,t){var r=a(e);return(c||r)&&n(r?i({},t,r):t)}if(t.getEnvironmentVariable){var c=o("TSC_WATCH_POLLINGINTERVAL",d);f=s("TSC_WATCH_POLLINGCHUNKSIZE",p)||f,e.unchangedPollThresholds=s("TSC_WATCH_UNCHANGEDPOLLTHRESHOLDS",p)||e.unchangedPollThresholds}}function o(t){function r(t,r,n){var i={fileName:t,callback:r,unchangedPolls:0,mtime:m(t)};return g.push(i),u(i,n),{close:function(){i.isClosed=!0,e.unorderedRemoveItem(g,i)}}}function n(e){var t=[];return t.pollingInterval=e,t.pollIndex=0,t.pollScheduled=!1,t}function i(t){t.pollIndex=o(t,t.pollingInterval,t.pollIndex,f[t.pollingInterval]),t.length?p(t.pollingInterval):(e.Debug.assert(0===t.pollIndex),t.pollScheduled=!1)}function a(e){o(v,d.Low,0,v.length),i(e),!e.pollScheduled&&v.length&&p(d.Low)}function o(t,r,n,i){function a(){n++,n===t.length&&(n>c&&(t.length=c),n=0,c=0)}for(var o=t.length,c=n,_=0;i>_&&o>0;a(),o--){var p=t[n];if(p)if(p.isClosed)t[n]=void 0;else{_++;var f=s(p,m(p.fileName));p.isClosed?t[n]=void 0:f?(p.unchangedPolls=0,t!==v&&(t[n]=void 0,l(p))):p.unchangedPolls!==e.unchangedPollThresholds[r]?p.unchangedPolls++:t===v?(p.unchangedPolls=1,t[n]=void 0,u(p,d.Low)):r!==d.High&&(p.unchangedPolls++,t[n]=void 0,u(p,r===d.Low?d.Medium:d.High)),t[n]&&(n>c&&(t[c]=p,t[n]=void 0),c++)}}return n}function c(e){switch(e){case d.Low:return y;case d.Medium:return h;case d.High:return b}}function u(e,t){c(t).push(e),_(t)}function l(e){v.push(e),_(d.Low)}function _(e){c(e).pollScheduled||p(e)}function p(e){c(e).pollScheduled=t.setTimeout(e===d.Low?a:i,e,c(e))}function m(r){return t.getModifiedTime(r)||e.missingFileModifiedTime}var g=[],v=[],y=n(d.Low),h=n(d.Medium),b=n(d.High);return r}function s(e,t){var r=e.mtime.getTime(),n=t.getTime();return r!==n?(e.mtime=t,e.callback(e.fileName,c(r,n)),!0):!1}function c(e,t){return 0===e?_.Created:0===t?_.Deleted:_.Changed}function u(t){function r(r,i){var o=l(r),u=s.get(o);return u?u.refCount++:(u={watcher:t.watchDirectory(r,function(t){a(t)||(c.forEach(function(r,n){(n===o||e.startsWith(o,n)&&o[n.length]===e.directorySeparator)&&r.forEach(function(e){return e(t)})}),n(r,o))}),refCount:1,childWatches:e.emptyArray},s.set(o,u),n(r,o)),i&&c.add(o,i),{dirName:r,close:function(){var t=e.Debug.assertDefined(s.get(o));i&&c.remove(o,i),t.refCount--,t.refCount||(s.delete(o),e.closeFileWatcherOf(t),t.childWatches.forEach(e.closeFileWatcher))}}}function n(e,t){var r=s.get(t);r&&(r.childWatches=i(e,r.childWatches))}function i(n,i){function o(e){var t=r(e);s(t)}function s(e){(c||(c=[])).push(e)}var c;return e.enumerateInsertsAndDeletes(t.directoryExists(n)?e.mapDefined(t.getAccessibleSortedChildDirectories(n),function(r){var i=e.getNormalizedAbsolutePath(r,n);return a(i)||0!==u(i,e.normalizePath(t.realpath(i)))?void 0:i}):e.emptyArray,i,function(e,t){return u(e,t.dirName)},o,e.closeFileWatcher,s),c||e.emptyArray}function a(t){return e.some(e.ignoredPaths,function(e){return o(t,e)})}function o(r,n){return e.stringContains(r,n)?!0:t.useCaseSensitiveFileNames?!1:e.stringContains(l(r),n)}var s=e.createMap(),c=e.createMultiMap(),u=e.getStringComparer(!t.useCaseSensitiveFileNames),l=e.createGetCanonicalFileName(t.useCaseSensitiveFileNames);return r}function l(){return void 0}e.generateDjb2Hash=t,e.setStackTraceLimit=r;var _;!function(e){e[e.Created=0]="Created",e[e.Changed=1]="Changed",e[e.Deleted=2]="Deleted"}(_=e.FileWatcherEventKind||(e.FileWatcherEventKind={}));var d;!function(e){e[e.High=2e3]="High",e[e.Medium=500]="Medium",e[e.Low=250]="Low"}(d=e.PollingInterval||(e.PollingInterval={})),e.missingFileModifiedTime=new Date(0);var p={Low:32,Medium:64,High:256},f=n(p);e.unchangedPollThresholds=n(p),e.setCustomPollingValues=a,e.createDynamicPriorityPollingWatchFile=o,e.onWatchedFileStat=s,e.getFileWatcherEventKind=c,e.ignoredPaths=["/node_modules/.","/.git"],e.createRecursiveDirectoryWatcher=u,e.getNodeMajorVersion=l,e.sys=void 0,e.sys&&e.sys.getEnvironmentVariable&&(a(e.sys),e.Debug.currentAssertionLevel=/^development$/i.test(e.sys.getEnvironmentVariable("NODE_ENV"))?1:0),e.sys&&e.sys.debugMode&&(e.Debug.isDebugging=!0)}(n||(n={}));var n;!function(e){function t(e,t,r,n,i){return{code:e,category:t,key:r,message:n,reportsUnnecessary:i}}e.Diagnostics={Unterminated_string_literal:t(1002,e.DiagnosticCategory.Error,"Unterminated_string_literal_1002","Unterminated string literal."),Identifier_expected:t(1003,e.DiagnosticCategory.Error,"Identifier_expected_1003","Identifier expected."),_0_expected:t(1005,e.DiagnosticCategory.Error,"_0_expected_1005","'{0}' expected."),A_file_cannot_have_a_reference_to_itself:t(1006,e.DiagnosticCategory.Error,"A_file_cannot_have_a_reference_to_itself_1006","A file cannot have a reference to itself."),Trailing_comma_not_allowed:t(1009,e.DiagnosticCategory.Error,"Trailing_comma_not_allowed_1009","Trailing comma not allowed."),Asterisk_Slash_expected:t(1010,e.DiagnosticCategory.Error,"Asterisk_Slash_expected_1010","'*/' expected."),An_element_access_expression_should_take_an_argument:t(1011,e.DiagnosticCategory.Error,"An_element_access_expression_should_take_an_argument_1011","An element access expression should take an argument."),Unexpected_token:t(1012,e.DiagnosticCategory.Error,"Unexpected_token_1012","Unexpected token."),A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma:t(1013,e.DiagnosticCategory.Error,"A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma_1013","A rest parameter or binding pattern may not have a trailing comma."),A_rest_parameter_must_be_last_in_a_parameter_list:t(1014,e.DiagnosticCategory.Error,"A_rest_parameter_must_be_last_in_a_parameter_list_1014","A rest parameter must be last in a parameter list."),Parameter_cannot_have_question_mark_and_initializer:t(1015,e.DiagnosticCategory.Error,"Parameter_cannot_have_question_mark_and_initializer_1015","Parameter cannot have question mark and initializer."),A_required_parameter_cannot_follow_an_optional_parameter:t(1016,e.DiagnosticCategory.Error,"A_required_parameter_cannot_follow_an_optional_parameter_1016","A required parameter cannot follow an optional parameter."),An_index_signature_cannot_have_a_rest_parameter:t(1017,e.DiagnosticCategory.Error,"An_index_signature_cannot_have_a_rest_parameter_1017","An index signature cannot have a rest parameter."),An_index_signature_parameter_cannot_have_an_accessibility_modifier:t(1018,e.DiagnosticCategory.Error,"An_index_signature_parameter_cannot_have_an_accessibility_modifier_1018","An index signature parameter cannot have an accessibility modifier."),An_index_signature_parameter_cannot_have_a_question_mark:t(1019,e.DiagnosticCategory.Error,"An_index_signature_parameter_cannot_have_a_question_mark_1019","An index signature parameter cannot have a question mark."),An_index_signature_parameter_cannot_have_an_initializer:t(1020,e.DiagnosticCategory.Error,"An_index_signature_parameter_cannot_have_an_initializer_1020","An index signature parameter cannot have an initializer."),An_index_signature_must_have_a_type_annotation:t(1021,e.DiagnosticCategory.Error,"An_index_signature_must_have_a_type_annotation_1021","An index signature must have a type annotation."),An_index_signature_parameter_must_have_a_type_annotation:t(1022,e.DiagnosticCategory.Error,"An_index_signature_parameter_must_have_a_type_annotation_1022","An index signature parameter must have a type annotation."),An_index_signature_parameter_type_must_be_string_or_number:t(1023,e.DiagnosticCategory.Error,"An_index_signature_parameter_type_must_be_string_or_number_1023","An index signature parameter type must be 'string' or 'number'."),readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature:t(1024,e.DiagnosticCategory.Error,"readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature_1024","'readonly' modifier can only appear on a property declaration or index signature."),Accessibility_modifier_already_seen:t(1028,e.DiagnosticCategory.Error,"Accessibility_modifier_already_seen_1028","Accessibility modifier already seen."),_0_modifier_must_precede_1_modifier:t(1029,e.DiagnosticCategory.Error,"_0_modifier_must_precede_1_modifier_1029","'{0}' modifier must precede '{1}' modifier."),_0_modifier_already_seen:t(1030,e.DiagnosticCategory.Error,"_0_modifier_already_seen_1030","'{0}' modifier already seen."),_0_modifier_cannot_appear_on_a_class_element:t(1031,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_a_class_element_1031","'{0}' modifier cannot appear on a class element."),super_must_be_followed_by_an_argument_list_or_member_access:t(1034,e.DiagnosticCategory.Error,"super_must_be_followed_by_an_argument_list_or_member_access_1034","'super' must be followed by an argument list or member access."),Only_ambient_modules_can_use_quoted_names:t(1035,e.DiagnosticCategory.Error,"Only_ambient_modules_can_use_quoted_names_1035","Only ambient modules can use quoted names."),Statements_are_not_allowed_in_ambient_contexts:t(1036,e.DiagnosticCategory.Error,"Statements_are_not_allowed_in_ambient_contexts_1036","Statements are not allowed in ambient contexts."),A_declare_modifier_cannot_be_used_in_an_already_ambient_context:t(1038,e.DiagnosticCategory.Error,"A_declare_modifier_cannot_be_used_in_an_already_ambient_context_1038","A 'declare' modifier cannot be used in an already ambient context."),Initializers_are_not_allowed_in_ambient_contexts:t(1039,e.DiagnosticCategory.Error,"Initializers_are_not_allowed_in_ambient_contexts_1039","Initializers are not allowed in ambient contexts."),_0_modifier_cannot_be_used_in_an_ambient_context:t(1040,e.DiagnosticCategory.Error,"_0_modifier_cannot_be_used_in_an_ambient_context_1040","'{0}' modifier cannot be used in an ambient context."),_0_modifier_cannot_be_used_with_a_class_declaration:t(1041,e.DiagnosticCategory.Error,"_0_modifier_cannot_be_used_with_a_class_declaration_1041","'{0}' modifier cannot be used with a class declaration."),_0_modifier_cannot_be_used_here:t(1042,e.DiagnosticCategory.Error,"_0_modifier_cannot_be_used_here_1042","'{0}' modifier cannot be used here."),_0_modifier_cannot_appear_on_a_data_property:t(1043,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_a_data_property_1043","'{0}' modifier cannot appear on a data property."),_0_modifier_cannot_appear_on_a_module_or_namespace_element:t(1044,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_a_module_or_namespace_element_1044","'{0}' modifier cannot appear on a module or namespace element."),A_0_modifier_cannot_be_used_with_an_interface_declaration:t(1045,e.DiagnosticCategory.Error,"A_0_modifier_cannot_be_used_with_an_interface_declaration_1045","A '{0}' modifier cannot be used with an interface declaration."),Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier:t(1046,e.DiagnosticCategory.Error,"Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier_1046","Top-level declarations in .d.ts files must start with either a 'declare' or 'export' modifier."),A_rest_parameter_cannot_be_optional:t(1047,e.DiagnosticCategory.Error,"A_rest_parameter_cannot_be_optional_1047","A rest parameter cannot be optional."),A_rest_parameter_cannot_have_an_initializer:t(1048,e.DiagnosticCategory.Error,"A_rest_parameter_cannot_have_an_initializer_1048","A rest parameter cannot have an initializer."),A_set_accessor_must_have_exactly_one_parameter:t(1049,e.DiagnosticCategory.Error,"A_set_accessor_must_have_exactly_one_parameter_1049","A 'set' accessor must have exactly one parameter."),A_set_accessor_cannot_have_an_optional_parameter:t(1051,e.DiagnosticCategory.Error,"A_set_accessor_cannot_have_an_optional_parameter_1051","A 'set' accessor cannot have an optional parameter."),A_set_accessor_parameter_cannot_have_an_initializer:t(1052,e.DiagnosticCategory.Error,"A_set_accessor_parameter_cannot_have_an_initializer_1052","A 'set' accessor parameter cannot have an initializer."),A_set_accessor_cannot_have_rest_parameter:t(1053,e.DiagnosticCategory.Error,"A_set_accessor_cannot_have_rest_parameter_1053","A 'set' accessor cannot have rest parameter."),A_get_accessor_cannot_have_parameters:t(1054,e.DiagnosticCategory.Error,"A_get_accessor_cannot_have_parameters_1054","A 'get' accessor cannot have parameters."),Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value:t(1055,e.DiagnosticCategory.Error,"Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Prom_1055","Type '{0}' is not a valid async function return type in ES5/ES3 because it does not refer to a Promise-compatible constructor value."),Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher:t(1056,e.DiagnosticCategory.Error,"Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher_1056","Accessors are only available when targeting ECMAScript 5 and higher."),An_async_function_or_method_must_have_a_valid_awaitable_return_type:t(1057,e.DiagnosticCategory.Error,"An_async_function_or_method_must_have_a_valid_awaitable_return_type_1057","An async function or method must have a valid awaitable return type."),The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:t(1058,e.DiagnosticCategory.Error,"The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_t_1058","The return type of an async function must either be a valid promise or must not contain a callable 'then' member."),A_promise_must_have_a_then_method:t(1059,e.DiagnosticCategory.Error,"A_promise_must_have_a_then_method_1059","A promise must have a 'then' method."),The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback:t(1060,e.DiagnosticCategory.Error,"The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback_1060","The first parameter of the 'then' method of a promise must be a callback."),Enum_member_must_have_initializer:t(1061,e.DiagnosticCategory.Error,"Enum_member_must_have_initializer_1061","Enum member must have initializer."),Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method:t(1062,e.DiagnosticCategory.Error,"Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method_1062","Type is referenced directly or indirectly in the fulfillment callback of its own 'then' method."),An_export_assignment_cannot_be_used_in_a_namespace:t(1063,e.DiagnosticCategory.Error,"An_export_assignment_cannot_be_used_in_a_namespace_1063","An export assignment cannot be used in a namespace."),The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type:t(1064,e.DiagnosticCategory.Error,"The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_1064","The return type of an async function or method must be the global Promise<T> type."),In_ambient_enum_declarations_member_initializer_must_be_constant_expression:t(1066,e.DiagnosticCategory.Error,"In_ambient_enum_declarations_member_initializer_must_be_constant_expression_1066","In ambient enum declarations member initializer must be constant expression."),Unexpected_token_A_constructor_method_accessor_or_property_was_expected:t(1068,e.DiagnosticCategory.Error,"Unexpected_token_A_constructor_method_accessor_or_property_was_expected_1068","Unexpected token. A constructor, method, accessor, or property was expected."),Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces:t(1069,e.DiagnosticCategory.Error,"Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces_1069","Unexpected token. A type parameter name was expected without curly braces."),_0_modifier_cannot_appear_on_a_type_member:t(1070,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_a_type_member_1070","'{0}' modifier cannot appear on a type member."),_0_modifier_cannot_appear_on_an_index_signature:t(1071,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_an_index_signature_1071","'{0}' modifier cannot appear on an index signature."),A_0_modifier_cannot_be_used_with_an_import_declaration:t(1079,e.DiagnosticCategory.Error,"A_0_modifier_cannot_be_used_with_an_import_declaration_1079","A '{0}' modifier cannot be used with an import declaration."),Invalid_reference_directive_syntax:t(1084,e.DiagnosticCategory.Error,"Invalid_reference_directive_syntax_1084","Invalid 'reference' directive syntax."),Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0:t(1085,e.DiagnosticCategory.Error,"Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0_1085","Octal literals are not available when targeting ECMAScript 5 and higher. Use the syntax '{0}'."),An_accessor_cannot_be_declared_in_an_ambient_context:t(1086,e.DiagnosticCategory.Error,"An_accessor_cannot_be_declared_in_an_ambient_context_1086","An accessor cannot be declared in an ambient context."),_0_modifier_cannot_appear_on_a_constructor_declaration:t(1089,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_a_constructor_declaration_1089","'{0}' modifier cannot appear on a constructor declaration."),_0_modifier_cannot_appear_on_a_parameter:t(1090,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_a_parameter_1090","'{0}' modifier cannot appear on a parameter."),Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement:t(1091,e.DiagnosticCategory.Error,"Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement_1091","Only a single variable declaration is allowed in a 'for...in' statement."),Type_parameters_cannot_appear_on_a_constructor_declaration:t(1092,e.DiagnosticCategory.Error,"Type_parameters_cannot_appear_on_a_constructor_declaration_1092","Type parameters cannot appear on a constructor declaration."),Type_annotation_cannot_appear_on_a_constructor_declaration:t(1093,e.DiagnosticCategory.Error,"Type_annotation_cannot_appear_on_a_constructor_declaration_1093","Type annotation cannot appear on a constructor declaration."),An_accessor_cannot_have_type_parameters:t(1094,e.DiagnosticCategory.Error,"An_accessor_cannot_have_type_parameters_1094","An accessor cannot have type parameters."),A_set_accessor_cannot_have_a_return_type_annotation:t(1095,e.DiagnosticCategory.Error,"A_set_accessor_cannot_have_a_return_type_annotation_1095","A 'set' accessor cannot have a return type annotation."),An_index_signature_must_have_exactly_one_parameter:t(1096,e.DiagnosticCategory.Error,"An_index_signature_must_have_exactly_one_parameter_1096","An index signature must have exactly one parameter."),_0_list_cannot_be_empty:t(1097,e.DiagnosticCategory.Error,"_0_list_cannot_be_empty_1097","'{0}' list cannot be empty."),Type_parameter_list_cannot_be_empty:t(1098,e.DiagnosticCategory.Error,"Type_parameter_list_cannot_be_empty_1098","Type parameter list cannot be empty."),Type_argument_list_cannot_be_empty:t(1099,e.DiagnosticCategory.Error,"Type_argument_list_cannot_be_empty_1099","Type argument list cannot be empty."),Invalid_use_of_0_in_strict_mode:t(1100,e.DiagnosticCategory.Error,"Invalid_use_of_0_in_strict_mode_1100","Invalid use of '{0}' in strict mode."),with_statements_are_not_allowed_in_strict_mode:t(1101,e.DiagnosticCategory.Error,"with_statements_are_not_allowed_in_strict_mode_1101","'with' statements are not allowed in strict mode."),delete_cannot_be_called_on_an_identifier_in_strict_mode:t(1102,e.DiagnosticCategory.Error,"delete_cannot_be_called_on_an_identifier_in_strict_mode_1102","'delete' cannot be called on an identifier in strict mode."),A_for_await_of_statement_is_only_allowed_within_an_async_function_or_async_generator:t(1103,e.DiagnosticCategory.Error,"A_for_await_of_statement_is_only_allowed_within_an_async_function_or_async_generator_1103","A 'for-await-of' statement is only allowed within an async function or async generator."),A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement:t(1104,e.DiagnosticCategory.Error,"A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement_1104","A 'continue' statement can only be used within an enclosing iteration statement."),A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement:t(1105,e.DiagnosticCategory.Error,"A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement_1105","A 'break' statement can only be used within an enclosing iteration or switch statement."),Jump_target_cannot_cross_function_boundary:t(1107,e.DiagnosticCategory.Error,"Jump_target_cannot_cross_function_boundary_1107","Jump target cannot cross function boundary."),A_return_statement_can_only_be_used_within_a_function_body:t(1108,e.DiagnosticCategory.Error,"A_return_statement_can_only_be_used_within_a_function_body_1108","A 'return' statement can only be used within a function body."),Expression_expected:t(1109,e.DiagnosticCategory.Error,"Expression_expected_1109","Expression expected."),Type_expected:t(1110,e.DiagnosticCategory.Error,"Type_expected_1110","Type expected."),A_default_clause_cannot_appear_more_than_once_in_a_switch_statement:t(1113,e.DiagnosticCategory.Error,"A_default_clause_cannot_appear_more_than_once_in_a_switch_statement_1113","A 'default' clause cannot appear more than once in a 'switch' statement."),Duplicate_label_0:t(1114,e.DiagnosticCategory.Error,"Duplicate_label_0_1114","Duplicate label '{0}'."),A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement:t(1115,e.DiagnosticCategory.Error,"A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement_1115","A 'continue' statement can only jump to a label of an enclosing iteration statement."),A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement:t(1116,e.DiagnosticCategory.Error,"A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement_1116","A 'break' statement can only jump to a label of an enclosing statement."),An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode:t(1117,e.DiagnosticCategory.Error,"An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode_1117","An object literal cannot have multiple properties with the same name in strict mode."),An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name:t(1118,e.DiagnosticCategory.Error,"An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name_1118","An object literal cannot have multiple get/set accessors with the same name."),An_object_literal_cannot_have_property_and_accessor_with_the_same_name:t(1119,e.DiagnosticCategory.Error,"An_object_literal_cannot_have_property_and_accessor_with_the_same_name_1119","An object literal cannot have property and accessor with the same name."),An_export_assignment_cannot_have_modifiers:t(1120,e.DiagnosticCategory.Error,"An_export_assignment_cannot_have_modifiers_1120","An export assignment cannot have modifiers."),Octal_literals_are_not_allowed_in_strict_mode:t(1121,e.DiagnosticCategory.Error,"Octal_literals_are_not_allowed_in_strict_mode_1121","Octal literals are not allowed in strict mode."),Variable_declaration_list_cannot_be_empty:t(1123,e.DiagnosticCategory.Error,"Variable_declaration_list_cannot_be_empty_1123","Variable declaration list cannot be empty."),Digit_expected:t(1124,e.DiagnosticCategory.Error,"Digit_expected_1124","Digit expected."),Hexadecimal_digit_expected:t(1125,e.DiagnosticCategory.Error,"Hexadecimal_digit_expected_1125","Hexadecimal digit expected."),Unexpected_end_of_text:t(1126,e.DiagnosticCategory.Error,"Unexpected_end_of_text_1126","Unexpected end of text."),Invalid_character:t(1127,e.DiagnosticCategory.Error,"Invalid_character_1127","Invalid character."),Declaration_or_statement_expected:t(1128,e.DiagnosticCategory.Error,"Declaration_or_statement_expected_1128","Declaration or statement expected."),Statement_expected:t(1129,e.DiagnosticCategory.Error,"Statement_expected_1129","Statement expected."),case_or_default_expected:t(1130,e.DiagnosticCategory.Error,"case_or_default_expected_1130","'case' or 'default' expected."),Property_or_signature_expected:t(1131,e.DiagnosticCategory.Error,"Property_or_signature_expected_1131","Property or signature expected."),Enum_member_expected:t(1132,e.DiagnosticCategory.Error,"Enum_member_expected_1132","Enum member expected."),Variable_declaration_expected:t(1134,e.DiagnosticCategory.Error,"Variable_declaration_expected_1134","Variable declaration expected."),Argument_expression_expected:t(1135,e.DiagnosticCategory.Error,"Argument_expression_expected_1135","Argument expression expected."),Property_assignment_expected:t(1136,e.DiagnosticCategory.Error,"Property_assignment_expected_1136","Property assignment expected."),Expression_or_comma_expected:t(1137,e.DiagnosticCategory.Error,"Expression_or_comma_expected_1137","Expression or comma expected."),Parameter_declaration_expected:t(1138,e.DiagnosticCategory.Error,"Parameter_declaration_expected_1138","Parameter declaration expected."),Type_parameter_declaration_expected:t(1139,e.DiagnosticCategory.Error,"Type_parameter_declaration_expected_1139","Type parameter declaration expected."),Type_argument_expected:t(1140,e.DiagnosticCategory.Error,"Type_argument_expected_1140","Type argument expected."),String_literal_expected:t(1141,e.DiagnosticCategory.Error,"String_literal_expected_1141","String literal expected."),Line_break_not_permitted_here:t(1142,e.DiagnosticCategory.Error,"Line_break_not_permitted_here_1142","Line break not permitted here."),or_expected:t(1144,e.DiagnosticCategory.Error,"or_expected_1144","'{' or ';' expected."),Declaration_expected:t(1146,e.DiagnosticCategory.Error,"Declaration_expected_1146","Declaration expected."),Import_declarations_in_a_namespace_cannot_reference_a_module:t(1147,e.DiagnosticCategory.Error,"Import_declarations_in_a_namespace_cannot_reference_a_module_1147","Import declarations in a namespace cannot reference a module."),Cannot_use_imports_exports_or_module_augmentations_when_module_is_none:t(1148,e.DiagnosticCategory.Error,"Cannot_use_imports_exports_or_module_augmentations_when_module_is_none_1148","Cannot use imports, exports, or module augmentations when '--module' is 'none'."),File_name_0_differs_from_already_included_file_name_1_only_in_casing:t(1149,e.DiagnosticCategory.Error,"File_name_0_differs_from_already_included_file_name_1_only_in_casing_1149","File name '{0}' differs from already included file name '{1}' only in casing."),new_T_cannot_be_used_to_create_an_array_Use_new_Array_T_instead:t(1150,e.DiagnosticCategory.Error,"new_T_cannot_be_used_to_create_an_array_Use_new_Array_T_instead_1150","'new T[]' cannot be used to create an array. Use 'new Array<T>()' instead."),const_declarations_must_be_initialized:t(1155,e.DiagnosticCategory.Error,"const_declarations_must_be_initialized_1155","'const' declarations must be initialized."),const_declarations_can_only_be_declared_inside_a_block:t(1156,e.DiagnosticCategory.Error,"const_declarations_can_only_be_declared_inside_a_block_1156","'const' declarations can only be declared inside a block."),let_declarations_can_only_be_declared_inside_a_block:t(1157,e.DiagnosticCategory.Error,"let_declarations_can_only_be_declared_inside_a_block_1157","'let' declarations can only be declared inside a block."),Unterminated_template_literal:t(1160,e.DiagnosticCategory.Error,"Unterminated_template_literal_1160","Unterminated template literal."),Unterminated_regular_expression_literal:t(1161,e.DiagnosticCategory.Error,"Unterminated_regular_expression_literal_1161","Unterminated regular expression literal."),An_object_member_cannot_be_declared_optional:t(1162,e.DiagnosticCategory.Error,"An_object_member_cannot_be_declared_optional_1162","An object member cannot be declared optional."),A_yield_expression_is_only_allowed_in_a_generator_body:t(1163,e.DiagnosticCategory.Error,"A_yield_expression_is_only_allowed_in_a_generator_body_1163","A 'yield' expression is only allowed in a generator body."),Computed_property_names_are_not_allowed_in_enums:t(1164,e.DiagnosticCategory.Error,"Computed_property_names_are_not_allowed_in_enums_1164","Computed property names are not allowed in enums."),A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type:t(1165,e.DiagnosticCategory.Error,"A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_t_1165","A computed property name in an ambient context must refer to an expression whose type is a literal type or a 'unique symbol' type."),A_computed_property_name_in_a_class_property_declaration_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type:t(1166,e.DiagnosticCategory.Error,"A_computed_property_name_in_a_class_property_declaration_must_refer_to_an_expression_whose_type_is_a_1166","A computed property name in a class property declaration must refer to an expression whose type is a literal type or a 'unique symbol' type."),A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type:t(1168,e.DiagnosticCategory.Error,"A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_ty_1168","A computed property name in a method overload must refer to an expression whose type is a literal type or a 'unique symbol' type."),A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type:t(1169,e.DiagnosticCategory.Error,"A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_1169","A computed property name in an interface must refer to an expression whose type is a literal type or a 'unique symbol' type."),A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type:t(1170,e.DiagnosticCategory.Error,"A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type__1170","A computed property name in a type literal must refer to an expression whose type is a literal type or a 'unique symbol' type."),A_comma_expression_is_not_allowed_in_a_computed_property_name:t(1171,e.DiagnosticCategory.Error,"A_comma_expression_is_not_allowed_in_a_computed_property_name_1171","A comma expression is not allowed in a computed property name."),extends_clause_already_seen:t(1172,e.DiagnosticCategory.Error,"extends_clause_already_seen_1172","'extends' clause already seen."),extends_clause_must_precede_implements_clause:t(1173,e.DiagnosticCategory.Error,"extends_clause_must_precede_implements_clause_1173","'extends' clause must precede 'implements' clause."),Classes_can_only_extend_a_single_class:t(1174,e.DiagnosticCategory.Error,"Classes_can_only_extend_a_single_class_1174","Classes can only extend a single class."),implements_clause_already_seen:t(1175,e.DiagnosticCategory.Error,"implements_clause_already_seen_1175","'implements' clause already seen."),Interface_declaration_cannot_have_implements_clause:t(1176,e.DiagnosticCategory.Error,"Interface_declaration_cannot_have_implements_clause_1176","Interface declaration cannot have 'implements' clause."),Binary_digit_expected:t(1177,e.DiagnosticCategory.Error,"Binary_digit_expected_1177","Binary digit expected."),Octal_digit_expected:t(1178,e.DiagnosticCategory.Error,"Octal_digit_expected_1178","Octal digit expected."),Unexpected_token_expected:t(1179,e.DiagnosticCategory.Error,"Unexpected_token_expected_1179","Unexpected token. '{' expected."),Property_destructuring_pattern_expected:t(1180,e.DiagnosticCategory.Error,"Property_destructuring_pattern_expected_1180","Property destructuring pattern expected."),Array_element_destructuring_pattern_expected:t(1181,e.DiagnosticCategory.Error,"Array_element_destructuring_pattern_expected_1181","Array element destructuring pattern expected."),A_destructuring_declaration_must_have_an_initializer:t(1182,e.DiagnosticCategory.Error,"A_destructuring_declaration_must_have_an_initializer_1182","A destructuring declaration must have an initializer."),An_implementation_cannot_be_declared_in_ambient_contexts:t(1183,e.DiagnosticCategory.Error,"An_implementation_cannot_be_declared_in_ambient_contexts_1183","An implementation cannot be declared in ambient contexts."),Modifiers_cannot_appear_here:t(1184,e.DiagnosticCategory.Error,"Modifiers_cannot_appear_here_1184","Modifiers cannot appear here."),Merge_conflict_marker_encountered:t(1185,e.DiagnosticCategory.Error,"Merge_conflict_marker_encountered_1185","Merge conflict marker encountered."),A_rest_element_cannot_have_an_initializer:t(1186,e.DiagnosticCategory.Error,"A_rest_element_cannot_have_an_initializer_1186","A rest element cannot have an initializer."),A_parameter_property_may_not_be_declared_using_a_binding_pattern:t(1187,e.DiagnosticCategory.Error,"A_parameter_property_may_not_be_declared_using_a_binding_pattern_1187","A parameter property may not be declared using a binding pattern."),Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement:t(1188,e.DiagnosticCategory.Error,"Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement_1188","Only a single variable declaration is allowed in a 'for...of' statement."),The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer:t(1189,e.DiagnosticCategory.Error,"The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer_1189","The variable declaration of a 'for...in' statement cannot have an initializer."),The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer:t(1190,e.DiagnosticCategory.Error,"The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer_1190","The variable declaration of a 'for...of' statement cannot have an initializer."),An_import_declaration_cannot_have_modifiers:t(1191,e.DiagnosticCategory.Error,"An_import_declaration_cannot_have_modifiers_1191","An import declaration cannot have modifiers."),Module_0_has_no_default_export:t(1192,e.DiagnosticCategory.Error,"Module_0_has_no_default_export_1192","Module '{0}' has no default export."),An_export_declaration_cannot_have_modifiers:t(1193,e.DiagnosticCategory.Error,"An_export_declaration_cannot_have_modifiers_1193","An export declaration cannot have modifiers."),Export_declarations_are_not_permitted_in_a_namespace:t(1194,e.DiagnosticCategory.Error,"Export_declarations_are_not_permitted_in_a_namespace_1194","Export declarations are not permitted in a namespace."),Catch_clause_variable_cannot_have_a_type_annotation:t(1196,e.DiagnosticCategory.Error,"Catch_clause_variable_cannot_have_a_type_annotation_1196","Catch clause variable cannot have a type annotation."),Catch_clause_variable_cannot_have_an_initializer:t(1197,e.DiagnosticCategory.Error,"Catch_clause_variable_cannot_have_an_initializer_1197","Catch clause variable cannot have an initializer."),An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive:t(1198,e.DiagnosticCategory.Error,"An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive_1198","An extended Unicode escape value must be between 0x0 and 0x10FFFF inclusive."),Unterminated_Unicode_escape_sequence:t(1199,e.DiagnosticCategory.Error,"Unterminated_Unicode_escape_sequence_1199","Unterminated Unicode escape sequence."),Line_terminator_not_permitted_before_arrow:t(1200,e.DiagnosticCategory.Error,"Line_terminator_not_permitted_before_arrow_1200","Line terminator not permitted before arrow."),Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead:t(1202,e.DiagnosticCategory.Error,"Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_1202","Import assignment cannot be used when targeting ECMAScript modules. Consider using 'import * as ns from \"mod\"', 'import {a} from \"mod\"', 'import d from \"mod\"', or another module format instead."),Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead:t(1203,e.DiagnosticCategory.Error,"Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or__1203","Export assignment cannot be used when targeting ECMAScript modules. Consider using 'export default' or another module format instead."),Cannot_re_export_a_type_when_the_isolatedModules_flag_is_provided:t(1205,e.DiagnosticCategory.Error,"Cannot_re_export_a_type_when_the_isolatedModules_flag_is_provided_1205","Cannot re-export a type when the '--isolatedModules' flag is provided."),Decorators_are_not_valid_here:t(1206,e.DiagnosticCategory.Error,"Decorators_are_not_valid_here_1206","Decorators are not valid here."),Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name:t(1207,e.DiagnosticCategory.Error,"Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name_1207","Decorators cannot be applied to multiple get/set accessors of the same name."),All_files_must_be_modules_when_the_isolatedModules_flag_is_provided:t(1208,e.DiagnosticCategory.Error,"All_files_must_be_modules_when_the_isolatedModules_flag_is_provided_1208","All files must be modules when the '--isolatedModules' flag is provided."),Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode:t(1210,e.DiagnosticCategory.Error,"Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode_1210","Invalid use of '{0}'. Class definitions are automatically in strict mode."),A_class_declaration_without_the_default_modifier_must_have_a_name:t(1211,e.DiagnosticCategory.Error,"A_class_declaration_without_the_default_modifier_must_have_a_name_1211","A class declaration without the 'default' modifier must have a name."),Identifier_expected_0_is_a_reserved_word_in_strict_mode:t(1212,e.DiagnosticCategory.Error,"Identifier_expected_0_is_a_reserved_word_in_strict_mode_1212","Identifier expected. '{0}' is a reserved word in strict mode."),Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode:t(1213,e.DiagnosticCategory.Error,"Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_stric_1213","Identifier expected. '{0}' is a reserved word in strict mode. Class definitions are automatically in strict mode."),Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode:t(1214,e.DiagnosticCategory.Error,"Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode_1214","Identifier expected. '{0}' is a reserved word in strict mode. Modules are automatically in strict mode."),Invalid_use_of_0_Modules_are_automatically_in_strict_mode:t(1215,e.DiagnosticCategory.Error,"Invalid_use_of_0_Modules_are_automatically_in_strict_mode_1215","Invalid use of '{0}'. Modules are automatically in strict mode."),Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules:t(1216,e.DiagnosticCategory.Error,"Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules_1216","Identifier expected. '__esModule' is reserved as an exported marker when transforming ECMAScript modules."),Export_assignment_is_not_supported_when_module_flag_is_system:t(1218,e.DiagnosticCategory.Error,"Export_assignment_is_not_supported_when_module_flag_is_system_1218","Export assignment is not supported when '--module' flag is 'system'."),Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning:t(1219,e.DiagnosticCategory.Error,"Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_t_1219","Experimental support for decorators is a feature that is subject to change in a future release. Set the 'experimentalDecorators' option in your 'tsconfig' or 'jsconfig' to remove this warning."),Generators_are_only_available_when_targeting_ECMAScript_2015_or_higher:t(1220,e.DiagnosticCategory.Error,"Generators_are_only_available_when_targeting_ECMAScript_2015_or_higher_1220","Generators are only available when targeting ECMAScript 2015 or higher."),Generators_are_not_allowed_in_an_ambient_context:t(1221,e.DiagnosticCategory.Error,"Generators_are_not_allowed_in_an_ambient_context_1221","Generators are not allowed in an ambient context."),An_overload_signature_cannot_be_declared_as_a_generator:t(1222,e.DiagnosticCategory.Error,"An_overload_signature_cannot_be_declared_as_a_generator_1222","An overload signature cannot be declared as a generator."),_0_tag_already_specified:t(1223,e.DiagnosticCategory.Error,"_0_tag_already_specified_1223","'{0}' tag already specified."),Signature_0_must_be_a_type_predicate:t(1224,e.DiagnosticCategory.Error,"Signature_0_must_be_a_type_predicate_1224","Signature '{0}' must be a type predicate."),Cannot_find_parameter_0:t(1225,e.DiagnosticCategory.Error,"Cannot_find_parameter_0_1225","Cannot find parameter '{0}'."),Type_predicate_0_is_not_assignable_to_1:t(1226,e.DiagnosticCategory.Error,"Type_predicate_0_is_not_assignable_to_1_1226","Type predicate '{0}' is not assignable to '{1}'."),Parameter_0_is_not_in_the_same_position_as_parameter_1:t(1227,e.DiagnosticCategory.Error,"Parameter_0_is_not_in_the_same_position_as_parameter_1_1227","Parameter '{0}' is not in the same position as parameter '{1}'."),A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods:t(1228,e.DiagnosticCategory.Error,"A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods_1228","A type predicate is only allowed in return type position for functions and methods."),A_type_predicate_cannot_reference_a_rest_parameter:t(1229,e.DiagnosticCategory.Error,"A_type_predicate_cannot_reference_a_rest_parameter_1229","A type predicate cannot reference a rest parameter."),A_type_predicate_cannot_reference_element_0_in_a_binding_pattern:t(1230,e.DiagnosticCategory.Error,"A_type_predicate_cannot_reference_element_0_in_a_binding_pattern_1230","A type predicate cannot reference element '{0}' in a binding pattern."),An_export_assignment_can_only_be_used_in_a_module:t(1231,e.DiagnosticCategory.Error,"An_export_assignment_can_only_be_used_in_a_module_1231","An export assignment can only be used in a module."),An_import_declaration_can_only_be_used_in_a_namespace_or_module:t(1232,e.DiagnosticCategory.Error,"An_import_declaration_can_only_be_used_in_a_namespace_or_module_1232","An import declaration can only be used in a namespace or module."),An_export_declaration_can_only_be_used_in_a_module:t(1233,e.DiagnosticCategory.Error,"An_export_declaration_can_only_be_used_in_a_module_1233","An export declaration can only be used in a module."),An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file:t(1234,e.DiagnosticCategory.Error,"An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file_1234","An ambient module declaration is only allowed at the top level in a file."),A_namespace_declaration_is_only_allowed_in_a_namespace_or_module:t(1235,e.DiagnosticCategory.Error,"A_namespace_declaration_is_only_allowed_in_a_namespace_or_module_1235","A namespace declaration is only allowed in a namespace or module."),The_return_type_of_a_property_decorator_function_must_be_either_void_or_any:t(1236,e.DiagnosticCategory.Error,"The_return_type_of_a_property_decorator_function_must_be_either_void_or_any_1236","The return type of a property decorator function must be either 'void' or 'any'."),The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any:t(1237,e.DiagnosticCategory.Error,"The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any_1237","The return type of a parameter decorator function must be either 'void' or 'any'."),Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression:t(1238,e.DiagnosticCategory.Error,"Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression_1238","Unable to resolve signature of class decorator when called as an expression."),Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression:t(1239,e.DiagnosticCategory.Error,"Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression_1239","Unable to resolve signature of parameter decorator when called as an expression."),Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression:t(1240,e.DiagnosticCategory.Error,"Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression_1240","Unable to resolve signature of property decorator when called as an expression."),Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression:t(1241,e.DiagnosticCategory.Error,"Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression_1241","Unable to resolve signature of method decorator when called as an expression."),abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration:t(1242,e.DiagnosticCategory.Error,"abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration_1242","'abstract' modifier can only appear on a class, method, or property declaration."),_0_modifier_cannot_be_used_with_1_modifier:t(1243,e.DiagnosticCategory.Error,"_0_modifier_cannot_be_used_with_1_modifier_1243","'{0}' modifier cannot be used with '{1}' modifier."),Abstract_methods_can_only_appear_within_an_abstract_class:t(1244,e.DiagnosticCategory.Error,"Abstract_methods_can_only_appear_within_an_abstract_class_1244","Abstract methods can only appear within an abstract class."),Method_0_cannot_have_an_implementation_because_it_is_marked_abstract:t(1245,e.DiagnosticCategory.Error,"Method_0_cannot_have_an_implementation_because_it_is_marked_abstract_1245","Method '{0}' cannot have an implementation because it is marked abstract."),An_interface_property_cannot_have_an_initializer:t(1246,e.DiagnosticCategory.Error,"An_interface_property_cannot_have_an_initializer_1246","An interface property cannot have an initializer."),A_type_literal_property_cannot_have_an_initializer:t(1247,e.DiagnosticCategory.Error,"A_type_literal_property_cannot_have_an_initializer_1247","A type literal property cannot have an initializer."),A_class_member_cannot_have_the_0_keyword:t(1248,e.DiagnosticCategory.Error,"A_class_member_cannot_have_the_0_keyword_1248","A class member cannot have the '{0}' keyword."),A_decorator_can_only_decorate_a_method_implementation_not_an_overload:t(1249,e.DiagnosticCategory.Error,"A_decorator_can_only_decorate_a_method_implementation_not_an_overload_1249","A decorator can only decorate a method implementation, not an overload."),Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5:t(1250,e.DiagnosticCategory.Error,"Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_1250","Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'."),Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode:t(1251,e.DiagnosticCategory.Error,"Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_d_1251","Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Class definitions are automatically in strict mode."),Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode:t(1252,e.DiagnosticCategory.Error,"Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_1252","Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Modules are automatically in strict mode."),_0_tag_cannot_be_used_independently_as_a_top_level_JSDoc_tag:t(1253,e.DiagnosticCategory.Error,"_0_tag_cannot_be_used_independently_as_a_top_level_JSDoc_tag_1253","'{0}' tag cannot be used independently as a top level JSDoc tag."),A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference:t(1254,e.DiagnosticCategory.Error,"A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_refere_1254","A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference."),A_definite_assignment_assertion_is_not_permitted_in_this_context:t(1255,e.DiagnosticCategory.Error,"A_definite_assignment_assertion_is_not_permitted_in_this_context_1255","A definite assignment assertion '!' is not permitted in this context."),A_rest_element_must_be_last_in_a_tuple_type:t(1256,e.DiagnosticCategory.Error,"A_rest_element_must_be_last_in_a_tuple_type_1256","A rest element must be last in a tuple type."),A_required_element_cannot_follow_an_optional_element:t(1257,e.DiagnosticCategory.Error,"A_required_element_cannot_follow_an_optional_element_1257","A required element cannot follow an optional element."),Definite_assignment_assertions_can_only_be_used_along_with_a_type_annotation:t(1258,e.DiagnosticCategory.Error,"Definite_assignment_assertions_can_only_be_used_along_with_a_type_annotation_1258","Definite assignment assertions can only be used along with a type annotation."),Module_0_can_only_be_default_imported_using_the_1_flag:t(1259,e.DiagnosticCategory.Error,"Module_0_can_only_be_default_imported_using_the_1_flag_1259","Module '{0}' can only be default-imported using the '{1}' flag"),with_statements_are_not_allowed_in_an_async_function_block:t(1300,e.DiagnosticCategory.Error,"with_statements_are_not_allowed_in_an_async_function_block_1300","'with' statements are not allowed in an async function block."),await_expression_is_only_allowed_within_an_async_function:t(1308,e.DiagnosticCategory.Error,"await_expression_is_only_allowed_within_an_async_function_1308","'await' expression is only allowed within an async function."),can_only_be_used_in_an_object_literal_property_inside_a_destructuring_assignment:t(1312,e.DiagnosticCategory.Error,"can_only_be_used_in_an_object_literal_property_inside_a_destructuring_assignment_1312","'=' can only be used in an object literal property inside a destructuring assignment."),The_body_of_an_if_statement_cannot_be_the_empty_statement:t(1313,e.DiagnosticCategory.Error,"The_body_of_an_if_statement_cannot_be_the_empty_statement_1313","The body of an 'if' statement cannot be the empty statement."),Global_module_exports_may_only_appear_in_module_files:t(1314,e.DiagnosticCategory.Error,"Global_module_exports_may_only_appear_in_module_files_1314","Global module exports may only appear in module files."),Global_module_exports_may_only_appear_in_declaration_files:t(1315,e.DiagnosticCategory.Error,"Global_module_exports_may_only_appear_in_declaration_files_1315","Global module exports may only appear in declaration files."),Global_module_exports_may_only_appear_at_top_level:t(1316,e.DiagnosticCategory.Error,"Global_module_exports_may_only_appear_at_top_level_1316","Global module exports may only appear at top level."),A_parameter_property_cannot_be_declared_using_a_rest_parameter:t(1317,e.DiagnosticCategory.Error,"A_parameter_property_cannot_be_declared_using_a_rest_parameter_1317","A parameter property cannot be declared using a rest parameter."),An_abstract_accessor_cannot_have_an_implementation:t(1318,e.DiagnosticCategory.Error,"An_abstract_accessor_cannot_have_an_implementation_1318","An abstract accessor cannot have an implementation."),A_default_export_can_only_be_used_in_an_ECMAScript_style_module:t(1319,e.DiagnosticCategory.Error,"A_default_export_can_only_be_used_in_an_ECMAScript_style_module_1319","A default export can only be used in an ECMAScript-style module."),Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:t(1320,e.DiagnosticCategory.Error,"Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member_1320","Type of 'await' operand must either be a valid promise or must not contain a callable 'then' member."),Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:t(1321,e.DiagnosticCategory.Error,"Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_cal_1321","Type of 'yield' operand in an async generator must either be a valid promise or must not contain a callable 'then' member."),Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:t(1322,e.DiagnosticCategory.Error,"Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_con_1322","Type of iterated elements of a 'yield*' operand must either be a valid promise or must not contain a callable 'then' member."),Dynamic_import_is_only_supported_when_module_flag_is_commonjs_or_esNext:t(1323,e.DiagnosticCategory.Error,"Dynamic_import_is_only_supported_when_module_flag_is_commonjs_or_esNext_1323","Dynamic import is only supported when '--module' flag is 'commonjs' or 'esNext'."),Dynamic_import_must_have_one_specifier_as_an_argument:t(1324,e.DiagnosticCategory.Error,"Dynamic_import_must_have_one_specifier_as_an_argument_1324","Dynamic import must have one specifier as an argument."),Specifier_of_dynamic_import_cannot_be_spread_element:t(1325,e.DiagnosticCategory.Error,"Specifier_of_dynamic_import_cannot_be_spread_element_1325","Specifier of dynamic import cannot be spread element."),Dynamic_import_cannot_have_type_arguments:t(1326,e.DiagnosticCategory.Error,"Dynamic_import_cannot_have_type_arguments_1326","Dynamic import cannot have type arguments"),String_literal_with_double_quotes_expected:t(1327,e.DiagnosticCategory.Error,"String_literal_with_double_quotes_expected_1327","String literal with double quotes expected."),Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal:t(1328,e.DiagnosticCategory.Error,"Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_li_1328","Property value can only be string literal, numeric literal, 'true', 'false', 'null', object literal or array literal."),_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0:t(1329,e.DiagnosticCategory.Error,"_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write__1329","'{0}' accepts too few arguments to be used as a decorator here. Did you mean to call it first and write '@{0}()'?"),A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly:t(1330,e.DiagnosticCategory.Error,"A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly_1330","A property of an interface or type literal whose type is a 'unique symbol' type must be 'readonly'."),A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly:t(1331,e.DiagnosticCategory.Error,"A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly_1331","A property of a class whose type is a 'unique symbol' type must be both 'static' and 'readonly'."),A_variable_whose_type_is_a_unique_symbol_type_must_be_const:t(1332,e.DiagnosticCategory.Error,"A_variable_whose_type_is_a_unique_symbol_type_must_be_const_1332","A variable whose type is a 'unique symbol' type must be 'const'."),unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name:t(1333,e.DiagnosticCategory.Error,"unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name_1333","'unique symbol' types may not be used on a variable declaration with a binding name."),unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement:t(1334,e.DiagnosticCategory.Error,"unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement_1334","'unique symbol' types are only allowed on variables in a variable statement."),unique_symbol_types_are_not_allowed_here:t(1335,e.DiagnosticCategory.Error,"unique_symbol_types_are_not_allowed_here_1335","'unique symbol' types are not allowed here."),An_index_signature_parameter_type_cannot_be_a_type_alias_Consider_writing_0_Colon_1_Colon_2_instead:t(1336,e.DiagnosticCategory.Error,"An_index_signature_parameter_type_cannot_be_a_type_alias_Consider_writing_0_Colon_1_Colon_2_instead_1336","An index signature parameter type cannot be a type alias. Consider writing '[{0}: {1}]: {2}' instead."),An_index_signature_parameter_type_cannot_be_a_union_type_Consider_using_a_mapped_object_type_instead:t(1337,e.DiagnosticCategory.Error,"An_index_signature_parameter_type_cannot_be_a_union_type_Consider_using_a_mapped_object_type_instead_1337","An index signature parameter type cannot be a union type. Consider using a mapped object type instead."),infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type:t(1338,e.DiagnosticCategory.Error,"infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type_1338","'infer' declarations are only permitted in the 'extends' clause of a conditional type."),Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here:t(1339,e.DiagnosticCategory.Error,"Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here_1339","Module '{0}' does not refer to a value, but is used as a value here."),Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0:t(1340,e.DiagnosticCategory.Error,"Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0_1340","Module '{0}' does not refer to a type, but is used as a type here. Did you mean 'typeof import('{0}')'?"),Type_arguments_cannot_be_used_here:t(1342,e.DiagnosticCategory.Error,"Type_arguments_cannot_be_used_here_1342","Type arguments cannot be used here."),The_import_meta_meta_property_is_only_allowed_using_ESNext_for_the_target_and_module_compiler_options:t(1343,e.DiagnosticCategory.Error,"The_import_meta_meta_property_is_only_allowed_using_ESNext_for_the_target_and_module_compiler_option_1343","The 'import.meta' meta-property is only allowed using 'ESNext' for the 'target' and 'module' compiler options."),A_label_is_not_allowed_here:t(1344,e.DiagnosticCategory.Error,"A_label_is_not_allowed_here_1344","'A label is not allowed here."),An_expression_of_type_void_cannot_be_tested_for_truthiness:t(1345,e.DiagnosticCategory.Error,"An_expression_of_type_void_cannot_be_tested_for_truthiness_1345","An expression of type 'void' cannot be tested for truthiness"),This_parameter_is_not_allowed_with_use_strict_directive:t(1346,e.DiagnosticCategory.Error,"This_parameter_is_not_allowed_with_use_strict_directive_1346","This parameter is not allowed with 'use strict' directive."),use_strict_directive_cannot_be_used_with_non_simple_parameter_list:t(1347,e.DiagnosticCategory.Error,"use_strict_directive_cannot_be_used_with_non_simple_parameter_list_1347","'use strict' directive cannot be used with non-simple parameter list."),Non_simple_parameter_declared_here:t(1348,e.DiagnosticCategory.Error,"Non_simple_parameter_declared_here_1348","Non-simple parameter declared here."),use_strict_directive_used_here:t(1349,e.DiagnosticCategory.Error,"use_strict_directive_used_here_1349","'use strict' directive used here."),Print_the_final_configuration_instead_of_building:t(1350,e.DiagnosticCategory.Message,"Print_the_final_configuration_instead_of_building_1350","Print the final configuration instead of building."),An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal:t(1351,e.DiagnosticCategory.Error,"An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal_1351","An identifier or keyword cannot immediately follow a numeric literal."),A_bigint_literal_cannot_use_exponential_notation:t(1352,e.DiagnosticCategory.Error,"A_bigint_literal_cannot_use_exponential_notation_1352","A bigint literal cannot use exponential notation."),A_bigint_literal_must_be_an_integer:t(1353,e.DiagnosticCategory.Error,"A_bigint_literal_must_be_an_integer_1353","A bigint literal must be an integer."),readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types:t(1354,e.DiagnosticCategory.Error,"readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types_1354","'readonly' type modifier is only permitted on array and tuple literal types."),A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals:t(1355,e.DiagnosticCategory.Error,"A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array__1355","A 'const' assertions can only be applied to references to enum members, or string, number, boolean, array, or object literals."),Did_you_mean_to_mark_this_function_as_async:t(1356,e.DiagnosticCategory.Error,"Did_you_mean_to_mark_this_function_as_async_1356","Did you mean to mark this function as 'async'?"),Duplicate_identifier_0:t(2300,e.DiagnosticCategory.Error,"Duplicate_identifier_0_2300","Duplicate identifier '{0}'."),Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor:t(2301,e.DiagnosticCategory.Error,"Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2301","Initializer of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."),Static_members_cannot_reference_class_type_parameters:t(2302,e.DiagnosticCategory.Error,"Static_members_cannot_reference_class_type_parameters_2302","Static members cannot reference class type parameters."),Circular_definition_of_import_alias_0:t(2303,e.DiagnosticCategory.Error,"Circular_definition_of_import_alias_0_2303","Circular definition of import alias '{0}'."),Cannot_find_name_0:t(2304,e.DiagnosticCategory.Error,"Cannot_find_name_0_2304","Cannot find name '{0}'."),Module_0_has_no_exported_member_1:t(2305,e.DiagnosticCategory.Error,"Module_0_has_no_exported_member_1_2305","Module '{0}' has no exported member '{1}'."),File_0_is_not_a_module:t(2306,e.DiagnosticCategory.Error,"File_0_is_not_a_module_2306","File '{0}' is not a module."),Cannot_find_module_0:t(2307,e.DiagnosticCategory.Error,"Cannot_find_module_0_2307","Cannot find module '{0}'."),Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity:t(2308,e.DiagnosticCategory.Error,"Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambig_2308","Module {0} has already exported a member named '{1}'. Consider explicitly re-exporting to resolve the ambiguity."),An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements:t(2309,e.DiagnosticCategory.Error,"An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements_2309","An export assignment cannot be used in a module with other exported elements."),Type_0_recursively_references_itself_as_a_base_type:t(2310,e.DiagnosticCategory.Error,"Type_0_recursively_references_itself_as_a_base_type_2310","Type '{0}' recursively references itself as a base type."),A_class_may_only_extend_another_class:t(2311,e.DiagnosticCategory.Error,"A_class_may_only_extend_another_class_2311","A class may only extend another class."),An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members:t(2312,e.DiagnosticCategory.Error,"An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_me_2312","An interface can only extend an object type or intersection of object types with statically known members."),Type_parameter_0_has_a_circular_constraint:t(2313,e.DiagnosticCategory.Error,"Type_parameter_0_has_a_circular_constraint_2313","Type parameter '{0}' has a circular constraint."),Generic_type_0_requires_1_type_argument_s:t(2314,e.DiagnosticCategory.Error,"Generic_type_0_requires_1_type_argument_s_2314","Generic type '{0}' requires {1} type argument(s)."),Type_0_is_not_generic:t(2315,e.DiagnosticCategory.Error,"Type_0_is_not_generic_2315","Type '{0}' is not generic."),Global_type_0_must_be_a_class_or_interface_type:t(2316,e.DiagnosticCategory.Error,"Global_type_0_must_be_a_class_or_interface_type_2316","Global type '{0}' must be a class or interface type."),Global_type_0_must_have_1_type_parameter_s:t(2317,e.DiagnosticCategory.Error,"Global_type_0_must_have_1_type_parameter_s_2317","Global type '{0}' must have {1} type parameter(s)."),Cannot_find_global_type_0:t(2318,e.DiagnosticCategory.Error,"Cannot_find_global_type_0_2318","Cannot find global type '{0}'."),Named_property_0_of_types_1_and_2_are_not_identical:t(2319,e.DiagnosticCategory.Error,"Named_property_0_of_types_1_and_2_are_not_identical_2319","Named property '{0}' of types '{1}' and '{2}' are not identical."),Interface_0_cannot_simultaneously_extend_types_1_and_2:t(2320,e.DiagnosticCategory.Error,"Interface_0_cannot_simultaneously_extend_types_1_and_2_2320","Interface '{0}' cannot simultaneously extend types '{1}' and '{2}'."),Excessive_stack_depth_comparing_types_0_and_1:t(2321,e.DiagnosticCategory.Error,"Excessive_stack_depth_comparing_types_0_and_1_2321","Excessive stack depth comparing types '{0}' and '{1}'."),Type_0_is_not_assignable_to_type_1:t(2322,e.DiagnosticCategory.Error,"Type_0_is_not_assignable_to_type_1_2322","Type '{0}' is not assignable to type '{1}'."),Cannot_redeclare_exported_variable_0:t(2323,e.DiagnosticCategory.Error,"Cannot_redeclare_exported_variable_0_2323","Cannot redeclare exported variable '{0}'."),Property_0_is_missing_in_type_1:t(2324,e.DiagnosticCategory.Error,"Property_0_is_missing_in_type_1_2324","Property '{0}' is missing in type '{1}'."),Property_0_is_private_in_type_1_but_not_in_type_2:t(2325,e.DiagnosticCategory.Error,"Property_0_is_private_in_type_1_but_not_in_type_2_2325","Property '{0}' is private in type '{1}' but not in type '{2}'."),Types_of_property_0_are_incompatible:t(2326,e.DiagnosticCategory.Error,"Types_of_property_0_are_incompatible_2326","Types of property '{0}' are incompatible."),Property_0_is_optional_in_type_1_but_required_in_type_2:t(2327,e.DiagnosticCategory.Error,"Property_0_is_optional_in_type_1_but_required_in_type_2_2327","Property '{0}' is optional in type '{1}' but required in type '{2}'."),Types_of_parameters_0_and_1_are_incompatible:t(2328,e.DiagnosticCategory.Error,"Types_of_parameters_0_and_1_are_incompatible_2328","Types of parameters '{0}' and '{1}' are incompatible."),Index_signature_is_missing_in_type_0:t(2329,e.DiagnosticCategory.Error,"Index_signature_is_missing_in_type_0_2329","Index signature is missing in type '{0}'."),Index_signatures_are_incompatible:t(2330,e.DiagnosticCategory.Error,"Index_signatures_are_incompatible_2330","Index signatures are incompatible."),this_cannot_be_referenced_in_a_module_or_namespace_body:t(2331,e.DiagnosticCategory.Error,"this_cannot_be_referenced_in_a_module_or_namespace_body_2331","'this' cannot be referenced in a module or namespace body."),this_cannot_be_referenced_in_current_location:t(2332,e.DiagnosticCategory.Error,"this_cannot_be_referenced_in_current_location_2332","'this' cannot be referenced in current location."),this_cannot_be_referenced_in_constructor_arguments:t(2333,e.DiagnosticCategory.Error,"this_cannot_be_referenced_in_constructor_arguments_2333","'this' cannot be referenced in constructor arguments."),this_cannot_be_referenced_in_a_static_property_initializer:t(2334,e.DiagnosticCategory.Error,"this_cannot_be_referenced_in_a_static_property_initializer_2334","'this' cannot be referenced in a static property initializer."),super_can_only_be_referenced_in_a_derived_class:t(2335,e.DiagnosticCategory.Error,"super_can_only_be_referenced_in_a_derived_class_2335","'super' can only be referenced in a derived class."),super_cannot_be_referenced_in_constructor_arguments:t(2336,e.DiagnosticCategory.Error,"super_cannot_be_referenced_in_constructor_arguments_2336","'super' cannot be referenced in constructor arguments."),Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors:t(2337,e.DiagnosticCategory.Error,"Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors_2337","Super calls are not permitted outside constructors or in nested functions inside constructors."),super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class:t(2338,e.DiagnosticCategory.Error,"super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_der_2338","'super' property access is permitted only in a constructor, member function, or member accessor of a derived class."),Property_0_does_not_exist_on_type_1:t(2339,e.DiagnosticCategory.Error,"Property_0_does_not_exist_on_type_1_2339","Property '{0}' does not exist on type '{1}'."),Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword:t(2340,e.DiagnosticCategory.Error,"Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword_2340","Only public and protected methods of the base class are accessible via the 'super' keyword."),Property_0_is_private_and_only_accessible_within_class_1:t(2341,e.DiagnosticCategory.Error,"Property_0_is_private_and_only_accessible_within_class_1_2341","Property '{0}' is private and only accessible within class '{1}'."),An_index_expression_argument_must_be_of_type_string_number_symbol_or_any:t(2342,e.DiagnosticCategory.Error,"An_index_expression_argument_must_be_of_type_string_number_symbol_or_any_2342","An index expression argument must be of type 'string', 'number', 'symbol', or 'any'."),This_syntax_requires_an_imported_helper_named_1_but_module_0_has_no_exported_member_1:t(2343,e.DiagnosticCategory.Error,"This_syntax_requires_an_imported_helper_named_1_but_module_0_has_no_exported_member_1_2343","This syntax requires an imported helper named '{1}', but module '{0}' has no exported member '{1}'."),Type_0_does_not_satisfy_the_constraint_1:t(2344,e.DiagnosticCategory.Error,"Type_0_does_not_satisfy_the_constraint_1_2344","Type '{0}' does not satisfy the constraint '{1}'."),Argument_of_type_0_is_not_assignable_to_parameter_of_type_1:t(2345,e.DiagnosticCategory.Error,"Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_2345","Argument of type '{0}' is not assignable to parameter of type '{1}'."),Call_target_does_not_contain_any_signatures:t(2346,e.DiagnosticCategory.Error,"Call_target_does_not_contain_any_signatures_2346","Call target does not contain any signatures."),Untyped_function_calls_may_not_accept_type_arguments:t(2347,e.DiagnosticCategory.Error,"Untyped_function_calls_may_not_accept_type_arguments_2347","Untyped function calls may not accept type arguments."),Value_of_type_0_is_not_callable_Did_you_mean_to_include_new:t(2348,e.DiagnosticCategory.Error,"Value_of_type_0_is_not_callable_Did_you_mean_to_include_new_2348","Value of type '{0}' is not callable. Did you mean to include 'new'?"),Cannot_invoke_an_expression_whose_type_lacks_a_call_signature_Type_0_has_no_compatible_call_signatures:t(2349,e.DiagnosticCategory.Error,"Cannot_invoke_an_expression_whose_type_lacks_a_call_signature_Type_0_has_no_compatible_call_signatur_2349","Cannot invoke an expression whose type lacks a call signature. Type '{0}' has no compatible call signatures."),Only_a_void_function_can_be_called_with_the_new_keyword:t(2350,e.DiagnosticCategory.Error,"Only_a_void_function_can_be_called_with_the_new_keyword_2350","Only a void function can be called with the 'new' keyword."),Cannot_use_new_with_an_expression_whose_type_lacks_a_call_or_construct_signature:t(2351,e.DiagnosticCategory.Error,"Cannot_use_new_with_an_expression_whose_type_lacks_a_call_or_construct_signature_2351","Cannot use 'new' with an expression whose type lacks a call or construct signature."),Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first:t(2352,e.DiagnosticCategory.Error,"Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the__2352","Conversion of type '{0}' to type '{1}' may be a mistake because neither type sufficiently overlaps with the other. If this was intentional, convert the expression to 'unknown' first."),Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1:t(2353,e.DiagnosticCategory.Error,"Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1_2353","Object literal may only specify known properties, and '{0}' does not exist in type '{1}'."),This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found:t(2354,e.DiagnosticCategory.Error,"This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found_2354","This syntax requires an imported helper but module '{0}' cannot be found."),A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value:t(2355,e.DiagnosticCategory.Error,"A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value_2355","A function whose declared type is neither 'void' nor 'any' must return a value."),An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type:t(2356,e.DiagnosticCategory.Error,"An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type_2356","An arithmetic operand must be of type 'any', 'number', 'bigint' or an enum type."),The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access:t(2357,e.DiagnosticCategory.Error,"The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access_2357","The operand of an increment or decrement operator must be a variable or a property access."),The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter:t(2358,e.DiagnosticCategory.Error,"The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_paramete_2358","The left-hand side of an 'instanceof' expression must be of type 'any', an object type or a type parameter."),The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type:t(2359,e.DiagnosticCategory.Error,"The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_F_2359","The right-hand side of an 'instanceof' expression must be of type 'any' or of a type assignable to the 'Function' interface type."),The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol:t(2360,e.DiagnosticCategory.Error,"The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol_2360","The left-hand side of an 'in' expression must be of type 'any', 'string', 'number', or 'symbol'."),The_right_hand_side_of_an_in_expression_must_be_of_type_any_an_object_type_or_a_type_parameter:t(2361,e.DiagnosticCategory.Error,"The_right_hand_side_of_an_in_expression_must_be_of_type_any_an_object_type_or_a_type_parameter_2361","The right-hand side of an 'in' expression must be of type 'any', an object type or a type parameter."),The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type:t(2362,e.DiagnosticCategory.Error,"The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2362","The left-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type:t(2363,e.DiagnosticCategory.Error,"The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2363","The right-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access:t(2364,e.DiagnosticCategory.Error,"The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access_2364","The left-hand side of an assignment expression must be a variable or a property access."),Operator_0_cannot_be_applied_to_types_1_and_2:t(2365,e.DiagnosticCategory.Error,"Operator_0_cannot_be_applied_to_types_1_and_2_2365","Operator '{0}' cannot be applied to types '{1}' and '{2}'."),Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined:t(2366,e.DiagnosticCategory.Error,"Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined_2366","Function lacks ending return statement and return type does not include 'undefined'."),This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap:t(2367,e.DiagnosticCategory.Error,"This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap_2367","This condition will always return '{0}' since the types '{1}' and '{2}' have no overlap."),Type_parameter_name_cannot_be_0:t(2368,e.DiagnosticCategory.Error,"Type_parameter_name_cannot_be_0_2368","Type parameter name cannot be '{0}'."),A_parameter_property_is_only_allowed_in_a_constructor_implementation:t(2369,e.DiagnosticCategory.Error,"A_parameter_property_is_only_allowed_in_a_constructor_implementation_2369","A parameter property is only allowed in a constructor implementation."),A_rest_parameter_must_be_of_an_array_type:t(2370,e.DiagnosticCategory.Error,"A_rest_parameter_must_be_of_an_array_type_2370","A rest parameter must be of an array type."),A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation:t(2371,e.DiagnosticCategory.Error,"A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation_2371","A parameter initializer is only allowed in a function or constructor implementation."),Parameter_0_cannot_be_referenced_in_its_initializer:t(2372,e.DiagnosticCategory.Error,"Parameter_0_cannot_be_referenced_in_its_initializer_2372","Parameter '{0}' cannot be referenced in its initializer."),Initializer_of_parameter_0_cannot_reference_identifier_1_declared_after_it:t(2373,e.DiagnosticCategory.Error,"Initializer_of_parameter_0_cannot_reference_identifier_1_declared_after_it_2373","Initializer of parameter '{0}' cannot reference identifier '{1}' declared after it."),Duplicate_string_index_signature:t(2374,e.DiagnosticCategory.Error,"Duplicate_string_index_signature_2374","Duplicate string index signature."),Duplicate_number_index_signature:t(2375,e.DiagnosticCategory.Error,"Duplicate_number_index_signature_2375","Duplicate number index signature."),A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_properties_or_has_parameter_properties:t(2376,e.DiagnosticCategory.Error,"A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_proper_2376","A 'super' call must be the first statement in the constructor when a class contains initialized properties or has parameter properties."),Constructors_for_derived_classes_must_contain_a_super_call:t(2377,e.DiagnosticCategory.Error,"Constructors_for_derived_classes_must_contain_a_super_call_2377","Constructors for derived classes must contain a 'super' call."),A_get_accessor_must_return_a_value:t(2378,e.DiagnosticCategory.Error,"A_get_accessor_must_return_a_value_2378","A 'get' accessor must return a value."),Getter_and_setter_accessors_do_not_agree_in_visibility:t(2379,e.DiagnosticCategory.Error,"Getter_and_setter_accessors_do_not_agree_in_visibility_2379","Getter and setter accessors do not agree in visibility."),get_and_set_accessor_must_have_the_same_type:t(2380,e.DiagnosticCategory.Error,"get_and_set_accessor_must_have_the_same_type_2380","'get' and 'set' accessor must have the same type."),A_signature_with_an_implementation_cannot_use_a_string_literal_type:t(2381,e.DiagnosticCategory.Error,"A_signature_with_an_implementation_cannot_use_a_string_literal_type_2381","A signature with an implementation cannot use a string literal type."),Specialized_overload_signature_is_not_assignable_to_any_non_specialized_signature:t(2382,e.DiagnosticCategory.Error,"Specialized_overload_signature_is_not_assignable_to_any_non_specialized_signature_2382","Specialized overload signature is not assignable to any non-specialized signature."),Overload_signatures_must_all_be_exported_or_non_exported:t(2383,e.DiagnosticCategory.Error,"Overload_signatures_must_all_be_exported_or_non_exported_2383","Overload signatures must all be exported or non-exported."),Overload_signatures_must_all_be_ambient_or_non_ambient:t(2384,e.DiagnosticCategory.Error,"Overload_signatures_must_all_be_ambient_or_non_ambient_2384","Overload signatures must all be ambient or non-ambient."),Overload_signatures_must_all_be_public_private_or_protected:t(2385,e.DiagnosticCategory.Error,"Overload_signatures_must_all_be_public_private_or_protected_2385","Overload signatures must all be public, private or protected."),Overload_signatures_must_all_be_optional_or_required:t(2386,e.DiagnosticCategory.Error,"Overload_signatures_must_all_be_optional_or_required_2386","Overload signatures must all be optional or required."),Function_overload_must_be_static:t(2387,e.DiagnosticCategory.Error,"Function_overload_must_be_static_2387","Function overload must be static."),Function_overload_must_not_be_static:t(2388,e.DiagnosticCategory.Error,"Function_overload_must_not_be_static_2388","Function overload must not be static."),Function_implementation_name_must_be_0:t(2389,e.DiagnosticCategory.Error,"Function_implementation_name_must_be_0_2389","Function implementation name must be '{0}'."),Constructor_implementation_is_missing:t(2390,e.DiagnosticCategory.Error,"Constructor_implementation_is_missing_2390","Constructor implementation is missing."),Function_implementation_is_missing_or_not_immediately_following_the_declaration:t(2391,e.DiagnosticCategory.Error,"Function_implementation_is_missing_or_not_immediately_following_the_declaration_2391","Function implementation is missing or not immediately following the declaration."),Multiple_constructor_implementations_are_not_allowed:t(2392,e.DiagnosticCategory.Error,"Multiple_constructor_implementations_are_not_allowed_2392","Multiple constructor implementations are not allowed."),Duplicate_function_implementation:t(2393,e.DiagnosticCategory.Error,"Duplicate_function_implementation_2393","Duplicate function implementation."),This_overload_signature_is_not_compatible_with_its_implementation_signature:t(2394,e.DiagnosticCategory.Error,"This_overload_signature_is_not_compatible_with_its_implementation_signature_2394","This overload signature is not compatible with its implementation signature."),Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local:t(2395,e.DiagnosticCategory.Error,"Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local_2395","Individual declarations in merged declaration '{0}' must be all exported or all local."),Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters:t(2396,e.DiagnosticCategory.Error,"Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters_2396","Duplicate identifier 'arguments'. Compiler uses 'arguments' to initialize rest parameters."),Declaration_name_conflicts_with_built_in_global_identifier_0:t(2397,e.DiagnosticCategory.Error,"Declaration_name_conflicts_with_built_in_global_identifier_0_2397","Declaration name conflicts with built-in global identifier '{0}'."),Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference:t(2399,e.DiagnosticCategory.Error,"Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference_2399","Duplicate identifier '_this'. Compiler uses variable declaration '_this' to capture 'this' reference."),Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference:t(2400,e.DiagnosticCategory.Error,"Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference_2400","Expression resolves to variable declaration '_this' that compiler uses to capture 'this' reference."),Duplicate_identifier_super_Compiler_uses_super_to_capture_base_class_reference:t(2401,e.DiagnosticCategory.Error,"Duplicate_identifier_super_Compiler_uses_super_to_capture_base_class_reference_2401","Duplicate identifier '_super'. Compiler uses '_super' to capture base class reference."),Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference:t(2402,e.DiagnosticCategory.Error,"Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference_2402","Expression resolves to '_super' that compiler uses to capture base class reference."),Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2:t(2403,e.DiagnosticCategory.Error,"Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_t_2403","Subsequent variable declarations must have the same type.  Variable '{0}' must be of type '{1}', but here has type '{2}'."),The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation:t(2404,e.DiagnosticCategory.Error,"The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation_2404","The left-hand side of a 'for...in' statement cannot use a type annotation."),The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any:t(2405,e.DiagnosticCategory.Error,"The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any_2405","The left-hand side of a 'for...in' statement must be of type 'string' or 'any'."),The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access:t(2406,e.DiagnosticCategory.Error,"The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access_2406","The left-hand side of a 'for...in' statement must be a variable or a property access."),The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0:t(2407,e.DiagnosticCategory.Error,"The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_2407","The right-hand side of a 'for...in' statement must be of type 'any', an object type or a type parameter, but here has type '{0}'."),Setters_cannot_return_a_value:t(2408,e.DiagnosticCategory.Error,"Setters_cannot_return_a_value_2408","Setters cannot return a value."),Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class:t(2409,e.DiagnosticCategory.Error,"Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class_2409","Return type of constructor signature must be assignable to the instance type of the class."),The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any:t(2410,e.DiagnosticCategory.Error,"The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any_2410","The 'with' statement is not supported. All symbols in a 'with' block will have type 'any'."),Property_0_of_type_1_is_not_assignable_to_string_index_type_2:t(2411,e.DiagnosticCategory.Error,"Property_0_of_type_1_is_not_assignable_to_string_index_type_2_2411","Property '{0}' of type '{1}' is not assignable to string index type '{2}'."),Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2:t(2412,e.DiagnosticCategory.Error,"Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2_2412","Property '{0}' of type '{1}' is not assignable to numeric index type '{2}'."),Numeric_index_type_0_is_not_assignable_to_string_index_type_1:t(2413,e.DiagnosticCategory.Error,"Numeric_index_type_0_is_not_assignable_to_string_index_type_1_2413","Numeric index type '{0}' is not assignable to string index type '{1}'."),Class_name_cannot_be_0:t(2414,e.DiagnosticCategory.Error,"Class_name_cannot_be_0_2414","Class name cannot be '{0}'."),Class_0_incorrectly_extends_base_class_1:t(2415,e.DiagnosticCategory.Error,"Class_0_incorrectly_extends_base_class_1_2415","Class '{0}' incorrectly extends base class '{1}'."),Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2:t(2416,e.DiagnosticCategory.Error,"Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2_2416","Property '{0}' in type '{1}' is not assignable to the same property in base type '{2}'."),Class_static_side_0_incorrectly_extends_base_class_static_side_1:t(2417,e.DiagnosticCategory.Error,"Class_static_side_0_incorrectly_extends_base_class_static_side_1_2417","Class static side '{0}' incorrectly extends base class static side '{1}'."),Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1:t(2418,e.DiagnosticCategory.Error,"Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1_2418","Type of computed property's value is '{0}', which is not assignable to type '{1}'."),Class_0_incorrectly_implements_interface_1:t(2420,e.DiagnosticCategory.Error,"Class_0_incorrectly_implements_interface_1_2420","Class '{0}' incorrectly implements interface '{1}'."),A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members:t(2422,e.DiagnosticCategory.Error,"A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_memb_2422","A class can only implement an object type or intersection of object types with statically known members."),Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor:t(2423,e.DiagnosticCategory.Error,"Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_access_2423","Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member accessor."),Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_property:t(2424,e.DiagnosticCategory.Error,"Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_proper_2424","Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member property."),Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function:t(2425,e.DiagnosticCategory.Error,"Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_functi_2425","Class '{0}' defines instance member property '{1}', but extended class '{2}' defines it as instance member function."),Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function:t(2426,e.DiagnosticCategory.Error,"Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_functi_2426","Class '{0}' defines instance member accessor '{1}', but extended class '{2}' defines it as instance member function."),Interface_name_cannot_be_0:t(2427,e.DiagnosticCategory.Error,"Interface_name_cannot_be_0_2427","Interface name cannot be '{0}'."),All_declarations_of_0_must_have_identical_type_parameters:t(2428,e.DiagnosticCategory.Error,"All_declarations_of_0_must_have_identical_type_parameters_2428","All declarations of '{0}' must have identical type parameters."),Interface_0_incorrectly_extends_interface_1:t(2430,e.DiagnosticCategory.Error,"Interface_0_incorrectly_extends_interface_1_2430","Interface '{0}' incorrectly extends interface '{1}'."),Enum_name_cannot_be_0:t(2431,e.DiagnosticCategory.Error,"Enum_name_cannot_be_0_2431","Enum name cannot be '{0}'."),In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element:t(2432,e.DiagnosticCategory.Error,"In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enu_2432","In an enum with multiple declarations, only one declaration can omit an initializer for its first enum element."),A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged:t(2433,e.DiagnosticCategory.Error,"A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merg_2433","A namespace declaration cannot be in a different file from a class or function with which it is merged."),A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged:t(2434,e.DiagnosticCategory.Error,"A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged_2434","A namespace declaration cannot be located prior to a class or function with which it is merged."),Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces:t(2435,e.DiagnosticCategory.Error,"Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces_2435","Ambient modules cannot be nested in other modules or namespaces."),Ambient_module_declaration_cannot_specify_relative_module_name:t(2436,e.DiagnosticCategory.Error,"Ambient_module_declaration_cannot_specify_relative_module_name_2436","Ambient module declaration cannot specify relative module name."),Module_0_is_hidden_by_a_local_declaration_with_the_same_name:t(2437,e.DiagnosticCategory.Error,"Module_0_is_hidden_by_a_local_declaration_with_the_same_name_2437","Module '{0}' is hidden by a local declaration with the same name."),Import_name_cannot_be_0:t(2438,e.DiagnosticCategory.Error,"Import_name_cannot_be_0_2438","Import name cannot be '{0}'."),Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name:t(2439,e.DiagnosticCategory.Error,"Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relati_2439","Import or export declaration in an ambient module declaration cannot reference module through relative module name."),Import_declaration_conflicts_with_local_declaration_of_0:t(2440,e.DiagnosticCategory.Error,"Import_declaration_conflicts_with_local_declaration_of_0_2440","Import declaration conflicts with local declaration of '{0}'."),Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module:t(2441,e.DiagnosticCategory.Error,"Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_2441","Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module."),Types_have_separate_declarations_of_a_private_property_0:t(2442,e.DiagnosticCategory.Error,"Types_have_separate_declarations_of_a_private_property_0_2442","Types have separate declarations of a private property '{0}'."),Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2:t(2443,e.DiagnosticCategory.Error,"Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2_2443","Property '{0}' is protected but type '{1}' is not a class derived from '{2}'."),Property_0_is_protected_in_type_1_but_public_in_type_2:t(2444,e.DiagnosticCategory.Error,"Property_0_is_protected_in_type_1_but_public_in_type_2_2444","Property '{0}' is protected in type '{1}' but public in type '{2}'."),Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses:t(2445,e.DiagnosticCategory.Error,"Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses_2445","Property '{0}' is protected and only accessible within class '{1}' and its subclasses."),Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1:t(2446,e.DiagnosticCategory.Error,"Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_2446","Property '{0}' is protected and only accessible through an instance of class '{1}'."),The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead:t(2447,e.DiagnosticCategory.Error,"The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead_2447","The '{0}' operator is not allowed for boolean types. Consider using '{1}' instead."),Block_scoped_variable_0_used_before_its_declaration:t(2448,e.DiagnosticCategory.Error,"Block_scoped_variable_0_used_before_its_declaration_2448","Block-scoped variable '{0}' used before its declaration."),Class_0_used_before_its_declaration:t(2449,e.DiagnosticCategory.Error,"Class_0_used_before_its_declaration_2449","Class '{0}' used before its declaration."),Enum_0_used_before_its_declaration:t(2450,e.DiagnosticCategory.Error,"Enum_0_used_before_its_declaration_2450","Enum '{0}' used before its declaration."),Cannot_redeclare_block_scoped_variable_0:t(2451,e.DiagnosticCategory.Error,"Cannot_redeclare_block_scoped_variable_0_2451","Cannot redeclare block-scoped variable '{0}'."),An_enum_member_cannot_have_a_numeric_name:t(2452,e.DiagnosticCategory.Error,"An_enum_member_cannot_have_a_numeric_name_2452","An enum member cannot have a numeric name."),The_type_argument_for_type_parameter_0_cannot_be_inferred_from_the_usage_Consider_specifying_the_type_arguments_explicitly:t(2453,e.DiagnosticCategory.Error,"The_type_argument_for_type_parameter_0_cannot_be_inferred_from_the_usage_Consider_specifying_the_typ_2453","The type argument for type parameter '{0}' cannot be inferred from the usage. Consider specifying the type arguments explicitly."),Variable_0_is_used_before_being_assigned:t(2454,e.DiagnosticCategory.Error,"Variable_0_is_used_before_being_assigned_2454","Variable '{0}' is used before being assigned."),Type_argument_candidate_1_is_not_a_valid_type_argument_because_it_is_not_a_supertype_of_candidate_0:t(2455,e.DiagnosticCategory.Error,"Type_argument_candidate_1_is_not_a_valid_type_argument_because_it_is_not_a_supertype_of_candidate_0_2455","Type argument candidate '{1}' is not a valid type argument because it is not a supertype of candidate '{0}'."),Type_alias_0_circularly_references_itself:t(2456,e.DiagnosticCategory.Error,"Type_alias_0_circularly_references_itself_2456","Type alias '{0}' circularly references itself."),Type_alias_name_cannot_be_0:t(2457,e.DiagnosticCategory.Error,"Type_alias_name_cannot_be_0_2457","Type alias name cannot be '{0}'."),An_AMD_module_cannot_have_multiple_name_assignments:t(2458,e.DiagnosticCategory.Error,"An_AMD_module_cannot_have_multiple_name_assignments_2458","An AMD module cannot have multiple name assignments."),Type_0_is_not_an_array_type:t(2461,e.DiagnosticCategory.Error,"Type_0_is_not_an_array_type_2461","Type '{0}' is not an array type."),A_rest_element_must_be_last_in_a_destructuring_pattern:t(2462,e.DiagnosticCategory.Error,"A_rest_element_must_be_last_in_a_destructuring_pattern_2462","A rest element must be last in a destructuring pattern."),A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature:t(2463,e.DiagnosticCategory.Error,"A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature_2463","A binding pattern parameter cannot be optional in an implementation signature."),A_computed_property_name_must_be_of_type_string_number_symbol_or_any:t(2464,e.DiagnosticCategory.Error,"A_computed_property_name_must_be_of_type_string_number_symbol_or_any_2464","A computed property name must be of type 'string', 'number', 'symbol', or 'any'."),this_cannot_be_referenced_in_a_computed_property_name:t(2465,e.DiagnosticCategory.Error,"this_cannot_be_referenced_in_a_computed_property_name_2465","'this' cannot be referenced in a computed property name."),super_cannot_be_referenced_in_a_computed_property_name:t(2466,e.DiagnosticCategory.Error,"super_cannot_be_referenced_in_a_computed_property_name_2466","'super' cannot be referenced in a computed property name."),A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type:t(2467,e.DiagnosticCategory.Error,"A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type_2467","A computed property name cannot reference a type parameter from its containing type."),Cannot_find_global_value_0:t(2468,e.DiagnosticCategory.Error,"Cannot_find_global_value_0_2468","Cannot find global value '{0}'."),The_0_operator_cannot_be_applied_to_type_symbol:t(2469,e.DiagnosticCategory.Error,"The_0_operator_cannot_be_applied_to_type_symbol_2469","The '{0}' operator cannot be applied to type 'symbol'."),Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object:t(2470,e.DiagnosticCategory.Error,"Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object_2470","'Symbol' reference does not refer to the global Symbol constructor object."),A_computed_property_name_of_the_form_0_must_be_of_type_symbol:t(2471,e.DiagnosticCategory.Error,"A_computed_property_name_of_the_form_0_must_be_of_type_symbol_2471","A computed property name of the form '{0}' must be of type 'symbol'."),Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher:t(2472,e.DiagnosticCategory.Error,"Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher_2472","Spread operator in 'new' expressions is only available when targeting ECMAScript 5 and higher."),Enum_declarations_must_all_be_const_or_non_const:t(2473,e.DiagnosticCategory.Error,"Enum_declarations_must_all_be_const_or_non_const_2473","Enum declarations must all be const or non-const."),const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values:t(2474,e.DiagnosticCategory.Error,"const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values_2474","const enum member initializers can only contain literal values and other computed enum values."),const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query:t(2475,e.DiagnosticCategory.Error,"const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_im_2475","'const' enums can only be used in property or index access expressions or the right hand side of an import declaration or export assignment or type query."),A_const_enum_member_can_only_be_accessed_using_a_string_literal:t(2476,e.DiagnosticCategory.Error,"A_const_enum_member_can_only_be_accessed_using_a_string_literal_2476","A const enum member can only be accessed using a string literal."),const_enum_member_initializer_was_evaluated_to_a_non_finite_value:t(2477,e.DiagnosticCategory.Error,"const_enum_member_initializer_was_evaluated_to_a_non_finite_value_2477","'const' enum member initializer was evaluated to a non-finite value."),const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN:t(2478,e.DiagnosticCategory.Error,"const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN_2478","'const' enum member initializer was evaluated to disallowed value 'NaN'."),Property_0_does_not_exist_on_const_enum_1:t(2479,e.DiagnosticCategory.Error,"Property_0_does_not_exist_on_const_enum_1_2479","Property '{0}' does not exist on 'const' enum '{1}'."),let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations:t(2480,e.DiagnosticCategory.Error,"let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations_2480","'let' is not allowed to be used as a name in 'let' or 'const' declarations."),Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1:t(2481,e.DiagnosticCategory.Error,"Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1_2481","Cannot initialize outer scoped variable '{0}' in the same scope as block scoped declaration '{1}'."),The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation:t(2483,e.DiagnosticCategory.Error,"The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation_2483","The left-hand side of a 'for...of' statement cannot use a type annotation."),Export_declaration_conflicts_with_exported_declaration_of_0:t(2484,e.DiagnosticCategory.Error,"Export_declaration_conflicts_with_exported_declaration_of_0_2484","Export declaration conflicts with exported declaration of '{0}'."),The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access:t(2487,e.DiagnosticCategory.Error,"The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access_2487","The left-hand side of a 'for...of' statement must be a variable or a property access."),Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator:t(2488,e.DiagnosticCategory.Error,"Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator_2488","Type '{0}' must have a '[Symbol.iterator]()' method that returns an iterator."),An_iterator_must_have_a_next_method:t(2489,e.DiagnosticCategory.Error,"An_iterator_must_have_a_next_method_2489","An iterator must have a 'next()' method."),The_type_returned_by_the_next_method_of_an_iterator_must_have_a_value_property:t(2490,e.DiagnosticCategory.Error,"The_type_returned_by_the_next_method_of_an_iterator_must_have_a_value_property_2490","The type returned by the 'next()' method of an iterator must have a 'value' property."),The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern:t(2491,e.DiagnosticCategory.Error,"The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern_2491","The left-hand side of a 'for...in' statement cannot be a destructuring pattern."),Cannot_redeclare_identifier_0_in_catch_clause:t(2492,e.DiagnosticCategory.Error,"Cannot_redeclare_identifier_0_in_catch_clause_2492","Cannot redeclare identifier '{0}' in catch clause."),Tuple_type_0_of_length_1_has_no_element_at_index_2:t(2493,e.DiagnosticCategory.Error,"Tuple_type_0_of_length_1_has_no_element_at_index_2_2493","Tuple type '{0}' of length '{1}' has no element at index '{2}'."),Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher:t(2494,e.DiagnosticCategory.Error,"Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher_2494","Using a string in a 'for...of' statement is only supported in ECMAScript 5 and higher."),Type_0_is_not_an_array_type_or_a_string_type:t(2495,e.DiagnosticCategory.Error,"Type_0_is_not_an_array_type_or_a_string_type_2495","Type '{0}' is not an array type or a string type."),The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression:t(2496,e.DiagnosticCategory.Error,"The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_stand_2496","The 'arguments' object cannot be referenced in an arrow function in ES3 and ES5. Consider using a standard function expression."),This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export:t(2497,e.DiagnosticCategory.Error,"This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_2497","This module can only be referenced with ECMAScript imports/exports by turning on the '{0}' flag and referencing its default export."),Module_0_uses_export_and_cannot_be_used_with_export_Asterisk:t(2498,e.DiagnosticCategory.Error,"Module_0_uses_export_and_cannot_be_used_with_export_Asterisk_2498","Module '{0}' uses 'export =' and cannot be used with 'export *'."),An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments:t(2499,e.DiagnosticCategory.Error,"An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments_2499","An interface can only extend an identifier/qualified-name with optional type arguments."),A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments:t(2500,e.DiagnosticCategory.Error,"A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments_2500","A class can only implement an identifier/qualified-name with optional type arguments."),A_rest_element_cannot_contain_a_binding_pattern:t(2501,e.DiagnosticCategory.Error,"A_rest_element_cannot_contain_a_binding_pattern_2501","A rest element cannot contain a binding pattern."),_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation:t(2502,e.DiagnosticCategory.Error,"_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation_2502","'{0}' is referenced directly or indirectly in its own type annotation."),Cannot_find_namespace_0:t(2503,e.DiagnosticCategory.Error,"Cannot_find_namespace_0_2503","Cannot find namespace '{0}'."),Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator:t(2504,e.DiagnosticCategory.Error,"Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator_2504","Type '{0}' must have a '[Symbol.asyncIterator]()' method that returns an async iterator."),A_generator_cannot_have_a_void_type_annotation:t(2505,e.DiagnosticCategory.Error,"A_generator_cannot_have_a_void_type_annotation_2505","A generator cannot have a 'void' type annotation."),_0_is_referenced_directly_or_indirectly_in_its_own_base_expression:t(2506,e.DiagnosticCategory.Error,"_0_is_referenced_directly_or_indirectly_in_its_own_base_expression_2506","'{0}' is referenced directly or indirectly in its own base expression."),Type_0_is_not_a_constructor_function_type:t(2507,e.DiagnosticCategory.Error,"Type_0_is_not_a_constructor_function_type_2507","Type '{0}' is not a constructor function type."),No_base_constructor_has_the_specified_number_of_type_arguments:t(2508,e.DiagnosticCategory.Error,"No_base_constructor_has_the_specified_number_of_type_arguments_2508","No base constructor has the specified number of type arguments."),Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members:t(2509,e.DiagnosticCategory.Error,"Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_2509","Base constructor return type '{0}' is not an object type or intersection of object types with statically known members."),Base_constructors_must_all_have_the_same_return_type:t(2510,e.DiagnosticCategory.Error,"Base_constructors_must_all_have_the_same_return_type_2510","Base constructors must all have the same return type."),Cannot_create_an_instance_of_an_abstract_class:t(2511,e.DiagnosticCategory.Error,"Cannot_create_an_instance_of_an_abstract_class_2511","Cannot create an instance of an abstract class."),Overload_signatures_must_all_be_abstract_or_non_abstract:t(2512,e.DiagnosticCategory.Error,"Overload_signatures_must_all_be_abstract_or_non_abstract_2512","Overload signatures must all be abstract or non-abstract."),Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression:t(2513,e.DiagnosticCategory.Error,"Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression_2513","Abstract method '{0}' in class '{1}' cannot be accessed via super expression."),Classes_containing_abstract_methods_must_be_marked_abstract:t(2514,e.DiagnosticCategory.Error,"Classes_containing_abstract_methods_must_be_marked_abstract_2514","Classes containing abstract methods must be marked abstract."),Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2:t(2515,e.DiagnosticCategory.Error,"Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2_2515","Non-abstract class '{0}' does not implement inherited abstract member '{1}' from class '{2}'."),All_declarations_of_an_abstract_method_must_be_consecutive:t(2516,e.DiagnosticCategory.Error,"All_declarations_of_an_abstract_method_must_be_consecutive_2516","All declarations of an abstract method must be consecutive."),Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type:t(2517,e.DiagnosticCategory.Error,"Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type_2517","Cannot assign an abstract constructor type to a non-abstract constructor type."),A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard:t(2518,e.DiagnosticCategory.Error,"A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard_2518","A 'this'-based type guard is not compatible with a parameter-based type guard."),An_async_iterator_must_have_a_next_method:t(2519,e.DiagnosticCategory.Error,"An_async_iterator_must_have_a_next_method_2519","An async iterator must have a 'next()' method."),Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions:t(2520,e.DiagnosticCategory.Error,"Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions_2520","Duplicate identifier '{0}'. Compiler uses declaration '{1}' to support async functions."),Expression_resolves_to_variable_declaration_0_that_compiler_uses_to_support_async_functions:t(2521,e.DiagnosticCategory.Error,"Expression_resolves_to_variable_declaration_0_that_compiler_uses_to_support_async_functions_2521","Expression resolves to variable declaration '{0}' that compiler uses to support async functions."),The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method:t(2522,e.DiagnosticCategory.Error,"The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_usi_2522","The 'arguments' object cannot be referenced in an async function or method in ES3 and ES5. Consider using a standard function or method."),yield_expressions_cannot_be_used_in_a_parameter_initializer:t(2523,e.DiagnosticCategory.Error,"yield_expressions_cannot_be_used_in_a_parameter_initializer_2523","'yield' expressions cannot be used in a parameter initializer."),await_expressions_cannot_be_used_in_a_parameter_initializer:t(2524,e.DiagnosticCategory.Error,"await_expressions_cannot_be_used_in_a_parameter_initializer_2524","'await' expressions cannot be used in a parameter initializer."),Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value:t(2525,e.DiagnosticCategory.Error,"Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value_2525","Initializer provides no value for this binding element and the binding element has no default value."),A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface:t(2526,e.DiagnosticCategory.Error,"A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface_2526","A 'this' type is available only in a non-static member of a class or interface."),The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary:t(2527,e.DiagnosticCategory.Error,"The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary_2527","The inferred type of '{0}' references an inaccessible '{1}' type. A type annotation is necessary."),A_module_cannot_have_multiple_default_exports:t(2528,e.DiagnosticCategory.Error,"A_module_cannot_have_multiple_default_exports_2528","A module cannot have multiple default exports."),Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions:t(2529,e.DiagnosticCategory.Error,"Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_func_2529","Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module containing async functions."),Property_0_is_incompatible_with_index_signature:t(2530,e.DiagnosticCategory.Error,"Property_0_is_incompatible_with_index_signature_2530","Property '{0}' is incompatible with index signature."),Object_is_possibly_null:t(2531,e.DiagnosticCategory.Error,"Object_is_possibly_null_2531","Object is possibly 'null'."),Object_is_possibly_undefined:t(2532,e.DiagnosticCategory.Error,"Object_is_possibly_undefined_2532","Object is possibly 'undefined'."),Object_is_possibly_null_or_undefined:t(2533,e.DiagnosticCategory.Error,"Object_is_possibly_null_or_undefined_2533","Object is possibly 'null' or 'undefined'."),A_function_returning_never_cannot_have_a_reachable_end_point:t(2534,e.DiagnosticCategory.Error,"A_function_returning_never_cannot_have_a_reachable_end_point_2534","A function returning 'never' cannot have a reachable end point."),Enum_type_0_has_members_with_initializers_that_are_not_literals:t(2535,e.DiagnosticCategory.Error,"Enum_type_0_has_members_with_initializers_that_are_not_literals_2535","Enum type '{0}' has members with initializers that are not literals."),Type_0_cannot_be_used_to_index_type_1:t(2536,e.DiagnosticCategory.Error,"Type_0_cannot_be_used_to_index_type_1_2536","Type '{0}' cannot be used to index type '{1}'."),Type_0_has_no_matching_index_signature_for_type_1:t(2537,e.DiagnosticCategory.Error,"Type_0_has_no_matching_index_signature_for_type_1_2537","Type '{0}' has no matching index signature for type '{1}'."),Type_0_cannot_be_used_as_an_index_type:t(2538,e.DiagnosticCategory.Error,"Type_0_cannot_be_used_as_an_index_type_2538","Type '{0}' cannot be used as an index type."),Cannot_assign_to_0_because_it_is_not_a_variable:t(2539,e.DiagnosticCategory.Error,"Cannot_assign_to_0_because_it_is_not_a_variable_2539","Cannot assign to '{0}' because it is not a variable."),Cannot_assign_to_0_because_it_is_a_read_only_property:t(2540,e.DiagnosticCategory.Error,"Cannot_assign_to_0_because_it_is_a_read_only_property_2540","Cannot assign to '{0}' because it is a read-only property."),The_target_of_an_assignment_must_be_a_variable_or_a_property_access:t(2541,e.DiagnosticCategory.Error,"The_target_of_an_assignment_must_be_a_variable_or_a_property_access_2541","The target of an assignment must be a variable or a property access."),Index_signature_in_type_0_only_permits_reading:t(2542,e.DiagnosticCategory.Error,"Index_signature_in_type_0_only_permits_reading_2542","Index signature in type '{0}' only permits reading."),Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference:t(2543,e.DiagnosticCategory.Error,"Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_me_2543","Duplicate identifier '_newTarget'. Compiler uses variable declaration '_newTarget' to capture 'new.target' meta-property reference."),Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference:t(2544,e.DiagnosticCategory.Error,"Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta__2544","Expression resolves to variable declaration '_newTarget' that compiler uses to capture 'new.target' meta-property reference."),A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any:t(2545,e.DiagnosticCategory.Error,"A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any_2545","A mixin class must have a constructor with a single rest parameter of type 'any[]'."),Property_0_has_conflicting_declarations_and_is_inaccessible_in_type_1:t(2546,e.DiagnosticCategory.Error,"Property_0_has_conflicting_declarations_and_is_inaccessible_in_type_1_2546","Property '{0}' has conflicting declarations and is inaccessible in type '{1}'."),The_type_returned_by_the_next_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property:t(2547,e.DiagnosticCategory.Error,"The_type_returned_by_the_next_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value__2547","The type returned by the 'next()' method of an async iterator must be a promise for a type with a 'value' property."),Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator:t(2548,e.DiagnosticCategory.Error,"Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator_2548","Type '{0}' is not an array type or does not have a '[Symbol.iterator]()' method that returns an iterator."),Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator:t(2549,e.DiagnosticCategory.Error,"Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns__2549","Type '{0}' is not an array type or a string type or does not have a '[Symbol.iterator]()' method that returns an iterator."),Property_0_does_not_exist_on_type_1_Did_you_mean_2:t(2551,e.DiagnosticCategory.Error,"Property_0_does_not_exist_on_type_1_Did_you_mean_2_2551","Property '{0}' does not exist on type '{1}'. Did you mean '{2}'?"),Cannot_find_name_0_Did_you_mean_1:t(2552,e.DiagnosticCategory.Error,"Cannot_find_name_0_Did_you_mean_1_2552","Cannot find name '{0}'. Did you mean '{1}'?"),Computed_values_are_not_permitted_in_an_enum_with_string_valued_members:t(2553,e.DiagnosticCategory.Error,"Computed_values_are_not_permitted_in_an_enum_with_string_valued_members_2553","Computed values are not permitted in an enum with string valued members."),Expected_0_arguments_but_got_1:t(2554,e.DiagnosticCategory.Error,"Expected_0_arguments_but_got_1_2554","Expected {0} arguments, but got {1}."),Expected_at_least_0_arguments_but_got_1:t(2555,e.DiagnosticCategory.Error,"Expected_at_least_0_arguments_but_got_1_2555","Expected at least {0} arguments, but got {1}."),Expected_0_arguments_but_got_1_or_more:t(2556,e.DiagnosticCategory.Error,"Expected_0_arguments_but_got_1_or_more_2556","Expected {0} arguments, but got {1} or more."),Expected_at_least_0_arguments_but_got_1_or_more:t(2557,e.DiagnosticCategory.Error,"Expected_at_least_0_arguments_but_got_1_or_more_2557","Expected at least {0} arguments, but got {1} or more."),Expected_0_type_arguments_but_got_1:t(2558,e.DiagnosticCategory.Error,"Expected_0_type_arguments_but_got_1_2558","Expected {0} type arguments, but got {1}."),Type_0_has_no_properties_in_common_with_type_1:t(2559,e.DiagnosticCategory.Error,"Type_0_has_no_properties_in_common_with_type_1_2559","Type '{0}' has no properties in common with type '{1}'."),Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it:t(2560,e.DiagnosticCategory.Error,"Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it_2560","Value of type '{0}' has no properties in common with type '{1}'. Did you mean to call it?"),Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2:t(2561,e.DiagnosticCategory.Error,"Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_writ_2561","Object literal may only specify known properties, but '{0}' does not exist in type '{1}'. Did you mean to write '{2}'?"),Base_class_expressions_cannot_reference_class_type_parameters:t(2562,e.DiagnosticCategory.Error,"Base_class_expressions_cannot_reference_class_type_parameters_2562","Base class expressions cannot reference class type parameters."),The_containing_function_or_module_body_is_too_large_for_control_flow_analysis:t(2563,e.DiagnosticCategory.Error,"The_containing_function_or_module_body_is_too_large_for_control_flow_analysis_2563","The containing function or module body is too large for control flow analysis."),Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor:t(2564,e.DiagnosticCategory.Error,"Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor_2564","Property '{0}' has no initializer and is not definitely assigned in the constructor."),Property_0_is_used_before_being_assigned:t(2565,e.DiagnosticCategory.Error,"Property_0_is_used_before_being_assigned_2565","Property '{0}' is used before being assigned."),A_rest_element_cannot_have_a_property_name:t(2566,e.DiagnosticCategory.Error,"A_rest_element_cannot_have_a_property_name_2566","A rest element cannot have a property name."),Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations:t(2567,e.DiagnosticCategory.Error,"Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations_2567","Enum declarations can only merge with namespace or other enum declarations."),Type_0_is_not_an_array_type_or_a_string_type_Use_compiler_option_downlevelIteration_to_allow_iterating_of_iterators:t(2569,e.DiagnosticCategory.Error,"Type_0_is_not_an_array_type_or_a_string_type_Use_compiler_option_downlevelIteration_to_allow_iterati_2569","Type '{0}' is not an array type or a string type. Use compiler option '--downlevelIteration' to allow iterating of iterators."),Property_0_does_not_exist_on_type_1_Did_you_forget_to_use_await:t(2570,e.DiagnosticCategory.Error,"Property_0_does_not_exist_on_type_1_Did_you_forget_to_use_await_2570","Property '{0}' does not exist on type '{1}'. Did you forget to use 'await'?"),Object_is_of_type_unknown:t(2571,e.DiagnosticCategory.Error,"Object_is_of_type_unknown_2571","Object is of type 'unknown'."),Rest_signatures_are_incompatible:t(2572,e.DiagnosticCategory.Error,"Rest_signatures_are_incompatible_2572","Rest signatures are incompatible."),Property_0_is_incompatible_with_rest_element_type:t(2573,e.DiagnosticCategory.Error,"Property_0_is_incompatible_with_rest_element_type_2573","Property '{0}' is incompatible with rest element type."),A_rest_element_type_must_be_an_array_type:t(2574,e.DiagnosticCategory.Error,"A_rest_element_type_must_be_an_array_type_2574","A rest element type must be an array type."),No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments:t(2575,e.DiagnosticCategory.Error,"No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments_2575","No overload expects {0} arguments, but overloads do exist that expect either {1} or {2} arguments."),Property_0_is_a_static_member_of_type_1:t(2576,e.DiagnosticCategory.Error,"Property_0_is_a_static_member_of_type_1_2576","Property '{0}' is a static member of type '{1}'"),Return_type_annotation_circularly_references_itself:t(2577,e.DiagnosticCategory.Error,"Return_type_annotation_circularly_references_itself_2577","Return type annotation circularly references itself."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_types_Slashnode:t(2580,e.DiagnosticCategory.Error,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_types_Slashnode_2580","Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i @types/node`."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_types_Slashjquery:t(2581,e.DiagnosticCategory.Error,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_types_Slashjquery_2581","Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i @types/jquery`."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_types_Slashjest_or_npm_i_types_Slashmocha:t(2582,e.DiagnosticCategory.Error,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_types_Slashje_2582","Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i @types/jest` or `npm i @types/mocha`."),Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later:t(2583,e.DiagnosticCategory.Error,"Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2583","Cannot find name '{0}'. Do you need to change your target library? Try changing the `lib` compiler option to es2015 or later."),Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom:t(2584,e.DiagnosticCategory.Error,"Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2584","Cannot find name '{0}'. Do you need to change your target library? Try changing the `lib` compiler option to include 'dom'."),_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later:t(2585,e.DiagnosticCategory.Error,"_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_2585","'{0}' only refers to a type, but is being used as a value here. Do you need to change your target library? Try changing the `lib` compiler option to es2015 or later."),Enum_type_0_circularly_references_itself:t(2586,e.DiagnosticCategory.Error,"Enum_type_0_circularly_references_itself_2586","Enum type '{0}' circularly references itself."),JSDoc_type_0_circularly_references_itself:t(2587,e.DiagnosticCategory.Error,"JSDoc_type_0_circularly_references_itself_2587","JSDoc type '{0}' circularly references itself."),Cannot_assign_to_0_because_it_is_a_constant:t(2588,e.DiagnosticCategory.Error,"Cannot_assign_to_0_because_it_is_a_constant_2588","Cannot assign to '{0}' because it is a constant."),Type_instantiation_is_excessively_deep_and_possibly_infinite:t(2589,e.DiagnosticCategory.Error,"Type_instantiation_is_excessively_deep_and_possibly_infinite_2589","Type instantiation is excessively deep and possibly infinite."),Expression_produces_a_union_type_that_is_too_complex_to_represent:t(2590,e.DiagnosticCategory.Error,"Expression_produces_a_union_type_that_is_too_complex_to_represent_2590","Expression produces a union type that is too complex to represent."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig:t(2591,e.DiagnosticCategory.Error,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_types_Slashnode_and_th_2591","Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i @types/node` and then add `node` to the types field in your tsconfig."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig:t(2592,e.DiagnosticCategory.Error,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_types_Slashjquery_an_2592","Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i @types/jquery` and then add `jquery` to the types field in your tsconfig."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_types_Slashjest_or_npm_i_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig:t(2593,e.DiagnosticCategory.Error,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_types_Slashje_2593","Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i @types/jest` or `npm i @types/mocha` and then add `jest` or `mocha` to the types field in your tsconfig."),This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag:t(2594,e.DiagnosticCategory.Error,"This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the__2594","This module is declared with using 'export =', and can only be used with a default import when using the '{0}' flag."),JSX_element_attributes_type_0_may_not_be_a_union_type:t(2600,e.DiagnosticCategory.Error,"JSX_element_attributes_type_0_may_not_be_a_union_type_2600","JSX element attributes type '{0}' may not be a union type."),The_return_type_of_a_JSX_element_constructor_must_return_an_object_type:t(2601,e.DiagnosticCategory.Error,"The_return_type_of_a_JSX_element_constructor_must_return_an_object_type_2601","The return type of a JSX element constructor must return an object type."),JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist:t(2602,e.DiagnosticCategory.Error,"JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist_2602","JSX element implicitly has type 'any' because the global type 'JSX.Element' does not exist."),Property_0_in_type_1_is_not_assignable_to_type_2:t(2603,e.DiagnosticCategory.Error,"Property_0_in_type_1_is_not_assignable_to_type_2_2603","Property '{0}' in type '{1}' is not assignable to type '{2}'."),JSX_element_type_0_does_not_have_any_construct_or_call_signatures:t(2604,e.DiagnosticCategory.Error,"JSX_element_type_0_does_not_have_any_construct_or_call_signatures_2604","JSX element type '{0}' does not have any construct or call signatures."),JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements:t(2605,e.DiagnosticCategory.Error,"JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements_2605","JSX element type '{0}' is not a constructor function for JSX elements."),Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property:t(2606,e.DiagnosticCategory.Error,"Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property_2606","Property '{0}' of JSX spread attribute is not assignable to target property."),JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property:t(2607,e.DiagnosticCategory.Error,"JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property_2607","JSX element class does not support attributes because it does not have a '{0}' property."),The_global_type_JSX_0_may_not_have_more_than_one_property:t(2608,e.DiagnosticCategory.Error,"The_global_type_JSX_0_may_not_have_more_than_one_property_2608","The global type 'JSX.{0}' may not have more than one property."),JSX_spread_child_must_be_an_array_type:t(2609,e.DiagnosticCategory.Error,"JSX_spread_child_must_be_an_array_type_2609","JSX spread child must be an array type."),Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity:t(2649,e.DiagnosticCategory.Error,"Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity_2649","Cannot augment module '{0}' with value exports because it resolves to a non-module entity."),A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums:t(2651,e.DiagnosticCategory.Error,"A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_memb_2651","A member initializer in a enum declaration cannot reference members declared after it, including members defined in other enums."),Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead:t(2652,e.DiagnosticCategory.Error,"Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_d_2652","Merged declaration '{0}' cannot include a default export declaration. Consider adding a separate 'export default {0}' declaration instead."),Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1:t(2653,e.DiagnosticCategory.Error,"Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1_2653","Non-abstract class expression does not implement inherited abstract member '{0}' from class '{1}'."),Exported_external_package_typings_file_cannot_contain_tripleslash_references_Please_contact_the_package_author_to_update_the_package_definition:t(2654,e.DiagnosticCategory.Error,"Exported_external_package_typings_file_cannot_contain_tripleslash_references_Please_contact_the_pack_2654","Exported external package typings file cannot contain tripleslash references. Please contact the package author to update the package definition."),Exported_external_package_typings_file_0_is_not_a_module_Please_contact_the_package_author_to_update_the_package_definition:t(2656,e.DiagnosticCategory.Error,"Exported_external_package_typings_file_0_is_not_a_module_Please_contact_the_package_author_to_update_2656","Exported external package typings file '{0}' is not a module. Please contact the package author to update the package definition."),JSX_expressions_must_have_one_parent_element:t(2657,e.DiagnosticCategory.Error,"JSX_expressions_must_have_one_parent_element_2657","JSX expressions must have one parent element."),Type_0_provides_no_match_for_the_signature_1:t(2658,e.DiagnosticCategory.Error,"Type_0_provides_no_match_for_the_signature_1_2658","Type '{0}' provides no match for the signature '{1}'."),super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher:t(2659,e.DiagnosticCategory.Error,"super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_highe_2659","'super' is only allowed in members of object literal expressions when option 'target' is 'ES2015' or higher."),super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions:t(2660,e.DiagnosticCategory.Error,"super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions_2660","'super' can only be referenced in members of derived classes or object literal expressions."),Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module:t(2661,e.DiagnosticCategory.Error,"Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module_2661","Cannot export '{0}'. Only local declarations can be exported from a module."),Cannot_find_name_0_Did_you_mean_the_static_member_1_0:t(2662,e.DiagnosticCategory.Error,"Cannot_find_name_0_Did_you_mean_the_static_member_1_0_2662","Cannot find name '{0}'. Did you mean the static member '{1}.{0}'?"),Cannot_find_name_0_Did_you_mean_the_instance_member_this_0:t(2663,e.DiagnosticCategory.Error,"Cannot_find_name_0_Did_you_mean_the_instance_member_this_0_2663","Cannot find name '{0}'. Did you mean the instance member 'this.{0}'?"),Invalid_module_name_in_augmentation_module_0_cannot_be_found:t(2664,e.DiagnosticCategory.Error,"Invalid_module_name_in_augmentation_module_0_cannot_be_found_2664","Invalid module name in augmentation, module '{0}' cannot be found."),Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented:t(2665,e.DiagnosticCategory.Error,"Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augm_2665","Invalid module name in augmentation. Module '{0}' resolves to an untyped module at '{1}', which cannot be augmented."),Exports_and_export_assignments_are_not_permitted_in_module_augmentations:t(2666,e.DiagnosticCategory.Error,"Exports_and_export_assignments_are_not_permitted_in_module_augmentations_2666","Exports and export assignments are not permitted in module augmentations."),Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module:t(2667,e.DiagnosticCategory.Error,"Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_mod_2667","Imports are not permitted in module augmentations. Consider moving them to the enclosing external module."),export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible:t(2668,e.DiagnosticCategory.Error,"export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always__2668","'export' modifier cannot be applied to ambient modules and module augmentations since they are always visible."),Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations:t(2669,e.DiagnosticCategory.Error,"Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_2669","Augmentations for the global scope can only be directly nested in external modules or ambient module declarations."),Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context:t(2670,e.DiagnosticCategory.Error,"Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambien_2670","Augmentations for the global scope should have 'declare' modifier unless they appear in already ambient context."),Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity:t(2671,e.DiagnosticCategory.Error,"Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity_2671","Cannot augment module '{0}' because it resolves to a non-module entity."),Cannot_assign_a_0_constructor_type_to_a_1_constructor_type:t(2672,e.DiagnosticCategory.Error,"Cannot_assign_a_0_constructor_type_to_a_1_constructor_type_2672","Cannot assign a '{0}' constructor type to a '{1}' constructor type."),Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration:t(2673,e.DiagnosticCategory.Error,"Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration_2673","Constructor of class '{0}' is private and only accessible within the class declaration."),Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration:t(2674,e.DiagnosticCategory.Error,"Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration_2674","Constructor of class '{0}' is protected and only accessible within the class declaration."),Cannot_extend_a_class_0_Class_constructor_is_marked_as_private:t(2675,e.DiagnosticCategory.Error,"Cannot_extend_a_class_0_Class_constructor_is_marked_as_private_2675","Cannot extend a class '{0}'. Class constructor is marked as private."),Accessors_must_both_be_abstract_or_non_abstract:t(2676,e.DiagnosticCategory.Error,"Accessors_must_both_be_abstract_or_non_abstract_2676","Accessors must both be abstract or non-abstract."),A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type:t(2677,e.DiagnosticCategory.Error,"A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type_2677","A type predicate's type must be assignable to its parameter's type."),Type_0_is_not_comparable_to_type_1:t(2678,e.DiagnosticCategory.Error,"Type_0_is_not_comparable_to_type_1_2678","Type '{0}' is not comparable to type '{1}'."),A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void:t(2679,e.DiagnosticCategory.Error,"A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void_2679","A function that is called with the 'new' keyword cannot have a 'this' type that is 'void'."),A_0_parameter_must_be_the_first_parameter:t(2680,e.DiagnosticCategory.Error,"A_0_parameter_must_be_the_first_parameter_2680","A '{0}' parameter must be the first parameter."),A_constructor_cannot_have_a_this_parameter:t(2681,e.DiagnosticCategory.Error,"A_constructor_cannot_have_a_this_parameter_2681","A constructor cannot have a 'this' parameter."),get_and_set_accessor_must_have_the_same_this_type:t(2682,e.DiagnosticCategory.Error,"get_and_set_accessor_must_have_the_same_this_type_2682","'get' and 'set' accessor must have the same 'this' type."),this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation:t(2683,e.DiagnosticCategory.Error,"this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_2683","'this' implicitly has type 'any' because it does not have a type annotation."),The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1:t(2684,e.DiagnosticCategory.Error,"The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1_2684","The 'this' context of type '{0}' is not assignable to method's 'this' of type '{1}'."),The_this_types_of_each_signature_are_incompatible:t(2685,e.DiagnosticCategory.Error,"The_this_types_of_each_signature_are_incompatible_2685","The 'this' types of each signature are incompatible."),_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead:t(2686,e.DiagnosticCategory.Error,"_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead_2686","'{0}' refers to a UMD global, but the current file is a module. Consider adding an import instead."),All_declarations_of_0_must_have_identical_modifiers:t(2687,e.DiagnosticCategory.Error,"All_declarations_of_0_must_have_identical_modifiers_2687","All declarations of '{0}' must have identical modifiers."),Cannot_find_type_definition_file_for_0:t(2688,e.DiagnosticCategory.Error,"Cannot_find_type_definition_file_for_0_2688","Cannot find type definition file for '{0}'."),Cannot_extend_an_interface_0_Did_you_mean_implements:t(2689,e.DiagnosticCategory.Error,"Cannot_extend_an_interface_0_Did_you_mean_implements_2689","Cannot extend an interface '{0}'. Did you mean 'implements'?"),An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead:t(2691,e.DiagnosticCategory.Error,"An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead_2691","An import path cannot end with a '{0}' extension. Consider importing '{1}' instead."),_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible:t(2692,e.DiagnosticCategory.Error,"_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible_2692","'{0}' is a primitive, but '{1}' is a wrapper object. Prefer using '{0}' when possible."),_0_only_refers_to_a_type_but_is_being_used_as_a_value_here:t(2693,e.DiagnosticCategory.Error,"_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_2693","'{0}' only refers to a type, but is being used as a value here."),Namespace_0_has_no_exported_member_1:t(2694,e.DiagnosticCategory.Error,"Namespace_0_has_no_exported_member_1_2694","Namespace '{0}' has no exported member '{1}'."),Left_side_of_comma_operator_is_unused_and_has_no_side_effects:t(2695,e.DiagnosticCategory.Error,"Left_side_of_comma_operator_is_unused_and_has_no_side_effects_2695","Left side of comma operator is unused and has no side effects.",!0),The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead:t(2696,e.DiagnosticCategory.Error,"The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead_2696","The 'Object' type is assignable to very few other types. Did you mean to use the 'any' type instead?"),An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option:t(2697,e.DiagnosticCategory.Error,"An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_in_2697","An async function or method must return a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your `--lib` option."),Spread_types_may_only_be_created_from_object_types:t(2698,e.DiagnosticCategory.Error,"Spread_types_may_only_be_created_from_object_types_2698","Spread types may only be created from object types."),Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1:t(2699,e.DiagnosticCategory.Error,"Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1_2699","Static property '{0}' conflicts with built-in property 'Function.{0}' of constructor function '{1}'."),Rest_types_may_only_be_created_from_object_types:t(2700,e.DiagnosticCategory.Error,"Rest_types_may_only_be_created_from_object_types_2700","Rest types may only be created from object types."),The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access:t(2701,e.DiagnosticCategory.Error,"The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access_2701","The target of an object rest assignment must be a variable or a property access."),_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here:t(2702,e.DiagnosticCategory.Error,"_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here_2702","'{0}' only refers to a type, but is being used as a namespace here."),The_operand_of_a_delete_operator_must_be_a_property_reference:t(2703,e.DiagnosticCategory.Error,"The_operand_of_a_delete_operator_must_be_a_property_reference_2703","The operand of a delete operator must be a property reference."),The_operand_of_a_delete_operator_cannot_be_a_read_only_property:t(2704,e.DiagnosticCategory.Error,"The_operand_of_a_delete_operator_cannot_be_a_read_only_property_2704","The operand of a delete operator cannot be a read-only property."),An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option:t(2705,e.DiagnosticCategory.Error,"An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_de_2705","An async function or method in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your `--lib` option."),Required_type_parameters_may_not_follow_optional_type_parameters:t(2706,e.DiagnosticCategory.Error,"Required_type_parameters_may_not_follow_optional_type_parameters_2706","Required type parameters may not follow optional type parameters."),Generic_type_0_requires_between_1_and_2_type_arguments:t(2707,e.DiagnosticCategory.Error,"Generic_type_0_requires_between_1_and_2_type_arguments_2707","Generic type '{0}' requires between {1} and {2} type arguments."),Cannot_use_namespace_0_as_a_value:t(2708,e.DiagnosticCategory.Error,"Cannot_use_namespace_0_as_a_value_2708","Cannot use namespace '{0}' as a value."),Cannot_use_namespace_0_as_a_type:t(2709,e.DiagnosticCategory.Error,"Cannot_use_namespace_0_as_a_type_2709","Cannot use namespace '{0}' as a type."),_0_are_specified_twice_The_attribute_named_0_will_be_overwritten:t(2710,e.DiagnosticCategory.Error,"_0_are_specified_twice_The_attribute_named_0_will_be_overwritten_2710","'{0}' are specified twice. The attribute named '{0}' will be overwritten."),A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option:t(2711,e.DiagnosticCategory.Error,"A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES20_2711","A dynamic import call returns a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your `--lib` option."),A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option:t(2712,e.DiagnosticCategory.Error,"A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declarat_2712","A dynamic import call in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your `--lib` option."),Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1:t(2713,e.DiagnosticCategory.Error,"Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_p_2713","Cannot access '{0}.{1}' because '{0}' is a type, but not a namespace. Did you mean to retrieve the type of the property '{1}' in '{0}' with '{0}[\"{1}\"]'?"),The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context:t(2714,e.DiagnosticCategory.Error,"The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context_2714","The expression of an export assignment must be an identifier or qualified name in an ambient context."),Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor:t(2715,e.DiagnosticCategory.Error,"Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor_2715","Abstract property '{0}' in class '{1}' cannot be accessed in the constructor."),Type_parameter_0_has_a_circular_default:t(2716,e.DiagnosticCategory.Error,"Type_parameter_0_has_a_circular_default_2716","Type parameter '{0}' has a circular default."),Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2:t(2717,e.DiagnosticCategory.Error,"Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_t_2717","Subsequent property declarations must have the same type.  Property '{0}' must be of type '{1}', but here has type '{2}'."),Duplicate_property_0:t(2718,e.DiagnosticCategory.Error,"Duplicate_property_0_2718","Duplicate property '{0}'."),Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated:t(2719,e.DiagnosticCategory.Error,"Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated_2719","Type '{0}' is not assignable to type '{1}'. Two different types with this name exist, but they are unrelated."),Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass:t(2720,e.DiagnosticCategory.Error,"Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclas_2720","Class '{0}' incorrectly implements class '{1}'. Did you mean to extend '{1}' and inherit its members as a subclass?"),Cannot_invoke_an_object_which_is_possibly_null:t(2721,e.DiagnosticCategory.Error,"Cannot_invoke_an_object_which_is_possibly_null_2721","Cannot invoke an object which is possibly 'null'."),Cannot_invoke_an_object_which_is_possibly_undefined:t(2722,e.DiagnosticCategory.Error,"Cannot_invoke_an_object_which_is_possibly_undefined_2722","Cannot invoke an object which is possibly 'undefined'."),Cannot_invoke_an_object_which_is_possibly_null_or_undefined:t(2723,e.DiagnosticCategory.Error,"Cannot_invoke_an_object_which_is_possibly_null_or_undefined_2723","Cannot invoke an object which is possibly 'null' or 'undefined'."),Module_0_has_no_exported_member_1_Did_you_mean_2:t(2724,e.DiagnosticCategory.Error,"Module_0_has_no_exported_member_1_Did_you_mean_2_2724","Module '{0}' has no exported member '{1}'. Did you mean '{2}'?"),Class_name_cannot_be_Object_when_targeting_ES5_with_module_0:t(2725,e.DiagnosticCategory.Error,"Class_name_cannot_be_Object_when_targeting_ES5_with_module_0_2725","Class name cannot be 'Object' when targeting ES5 with module {0}."),Cannot_find_lib_definition_for_0:t(2726,e.DiagnosticCategory.Error,"Cannot_find_lib_definition_for_0_2726","Cannot find lib definition for '{0}'."),Cannot_find_lib_definition_for_0_Did_you_mean_1:t(2727,e.DiagnosticCategory.Error,"Cannot_find_lib_definition_for_0_Did_you_mean_1_2727","Cannot find lib definition for '{0}'. Did you mean '{1}'?"),_0_is_declared_here:t(2728,e.DiagnosticCategory.Message,"_0_is_declared_here_2728","'{0}' is declared here."),Property_0_is_used_before_its_initialization:t(2729,e.DiagnosticCategory.Error,"Property_0_is_used_before_its_initialization_2729","Property '{0}' is used before its initialization."),An_arrow_function_cannot_have_a_this_parameter:t(2730,e.DiagnosticCategory.Error,"An_arrow_function_cannot_have_a_this_parameter_2730","An arrow function cannot have a 'this' parameter."),Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String:t(2731,e.DiagnosticCategory.Error,"Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_i_2731","Implicit conversion of a 'symbol' to a 'string' will fail at runtime. Consider wrapping this expression in 'String(...)'."),Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension:t(2732,e.DiagnosticCategory.Error,"Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension_2732","Cannot find module '{0}'. Consider using '--resolveJsonModule' to import module with '.json' extension"),Property_0_was_also_declared_here:t(2733,e.DiagnosticCategory.Error,"Property_0_was_also_declared_here_2733","Property '{0}' was also declared here."),It_is_highly_likely_that_you_are_missing_a_semicolon:t(2734,e.DiagnosticCategory.Error,"It_is_highly_likely_that_you_are_missing_a_semicolon_2734","It is highly likely that you are missing a semicolon."),Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1:t(2735,e.DiagnosticCategory.Error,"Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1_2735","Did you mean for '{0}' to be constrained to type 'new (...args: any[]) => {1}'?"),Operator_0_cannot_be_applied_to_type_1:t(2736,e.DiagnosticCategory.Error,"Operator_0_cannot_be_applied_to_type_1_2736","Operator '{0}' cannot be applied to type '{1}'."),BigInt_literals_are_not_available_when_targeting_lower_than_ESNext:t(2737,e.DiagnosticCategory.Error,"BigInt_literals_are_not_available_when_targeting_lower_than_ESNext_2737","BigInt literals are not available when targeting lower than ESNext."),An_outer_value_of_this_is_shadowed_by_this_container:t(2738,e.DiagnosticCategory.Message,"An_outer_value_of_this_is_shadowed_by_this_container_2738","An outer value of 'this' is shadowed by this container."),Type_0_is_missing_the_following_properties_from_type_1_Colon_2:t(2739,e.DiagnosticCategory.Error,"Type_0_is_missing_the_following_properties_from_type_1_Colon_2_2739","Type '{0}' is missing the following properties from type '{1}': {2}"),Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more:t(2740,e.DiagnosticCategory.Error,"Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more_2740","Type '{0}' is missing the following properties from type '{1}': {2}, and {3} more."),Property_0_is_missing_in_type_1_but_required_in_type_2:t(2741,e.DiagnosticCategory.Error,"Property_0_is_missing_in_type_1_but_required_in_type_2_2741","Property '{0}' is missing in type '{1}' but required in type '{2}'."),The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary:t(2742,e.DiagnosticCategory.Error,"The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_a_2742","The inferred type of '{0}' cannot be named without a reference to '{1}'. This is likely not portable. A type annotation is necessary."),No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments:t(2743,e.DiagnosticCategory.Error,"No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments_2743","No overload expects {0} type arguments, but overloads do exist that expect either {1} or {2} type arguments."),Type_parameter_defaults_can_only_reference_previously_declared_type_parameters:t(2744,e.DiagnosticCategory.Error,"Type_parameter_defaults_can_only_reference_previously_declared_type_parameters_2744","Type parameter defaults can only reference previously declared type parameters."),This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided:t(2745,e.DiagnosticCategory.Error,"This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_pr_2745","This JSX tag's '{0}' prop expects type '{1}' which requires multiple children, but only a single child was provided."),This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided:t(2746,e.DiagnosticCategory.Error,"This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided_2746","This JSX tag's '{0}' prop expects a single child of type '{1}', but multiple children were provided."),_0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2:t(2747,e.DiagnosticCategory.Error,"_0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_t_2747","'{0}' components don't accept text as child elements. Text in JSX has the type 'string', but the expected type of '{1}' is '{2}'."),Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided:t(2748,e.DiagnosticCategory.Error,"Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided_2748","Cannot access ambient const enums when the '--isolatedModules' flag is provided."),_0_refers_to_a_value_but_is_being_used_as_a_type_here:t(2749,e.DiagnosticCategory.Error,"_0_refers_to_a_value_but_is_being_used_as_a_type_here_2749","'{0}' refers to a value, but is being used as a type here."),The_implementation_signature_is_declared_here:t(2750,e.DiagnosticCategory.Error,"The_implementation_signature_is_declared_here_2750","The implementation signature is declared here."),Circularity_originates_in_type_at_this_location:t(2751,e.DiagnosticCategory.Error,"Circularity_originates_in_type_at_this_location_2751","Circularity originates in type at this location."),The_first_export_default_is_here:t(2752,e.DiagnosticCategory.Error,"The_first_export_default_is_here_2752","The first export default is here."),Another_export_default_is_here:t(2753,e.DiagnosticCategory.Error,"Another_export_default_is_here_2753","Another export default is here."),super_may_not_use_type_arguments:t(2754,e.DiagnosticCategory.Error,"super_may_not_use_type_arguments_2754","'super' may not use type arguments."),Import_declaration_0_is_using_private_name_1:t(4e3,e.DiagnosticCategory.Error,"Import_declaration_0_is_using_private_name_1_4000","Import declaration '{0}' is using private name '{1}'."),Type_parameter_0_of_exported_class_has_or_is_using_private_name_1:t(4002,e.DiagnosticCategory.Error,"Type_parameter_0_of_exported_class_has_or_is_using_private_name_1_4002","Type parameter '{0}' of exported class has or is using private name '{1}'."),Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1:t(4004,e.DiagnosticCategory.Error,"Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1_4004","Type parameter '{0}' of exported interface has or is using private name '{1}'."),Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1:t(4006,e.DiagnosticCategory.Error,"Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4006","Type parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1:t(4008,e.DiagnosticCategory.Error,"Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4008","Type parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:t(4010,e.DiagnosticCategory.Error,"Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4010","Type parameter '{0}' of public static method from exported class has or is using private name '{1}'."),Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:t(4012,e.DiagnosticCategory.Error,"Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4012","Type parameter '{0}' of public method from exported class has or is using private name '{1}'."),Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1:t(4014,e.DiagnosticCategory.Error,"Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4014","Type parameter '{0}' of method from exported interface has or is using private name '{1}'."),Type_parameter_0_of_exported_function_has_or_is_using_private_name_1:t(4016,e.DiagnosticCategory.Error,"Type_parameter_0_of_exported_function_has_or_is_using_private_name_1_4016","Type parameter '{0}' of exported function has or is using private name '{1}'."),Implements_clause_of_exported_class_0_has_or_is_using_private_name_1:t(4019,e.DiagnosticCategory.Error,"Implements_clause_of_exported_class_0_has_or_is_using_private_name_1_4019","Implements clause of exported class '{0}' has or is using private name '{1}'."),extends_clause_of_exported_class_0_has_or_is_using_private_name_1:t(4020,e.DiagnosticCategory.Error,"extends_clause_of_exported_class_0_has_or_is_using_private_name_1_4020","'extends' clause of exported class '{0}' has or is using private name '{1}'."),extends_clause_of_exported_interface_0_has_or_is_using_private_name_1:t(4022,e.DiagnosticCategory.Error,"extends_clause_of_exported_interface_0_has_or_is_using_private_name_1_4022","'extends' clause of exported interface '{0}' has or is using private name '{1}'."),Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4023,e.DiagnosticCategory.Error,"Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4023","Exported variable '{0}' has or is using name '{1}' from external module {2} but cannot be named."),Exported_variable_0_has_or_is_using_name_1_from_private_module_2:t(4024,e.DiagnosticCategory.Error,"Exported_variable_0_has_or_is_using_name_1_from_private_module_2_4024","Exported variable '{0}' has or is using name '{1}' from private module '{2}'."),Exported_variable_0_has_or_is_using_private_name_1:t(4025,e.DiagnosticCategory.Error,"Exported_variable_0_has_or_is_using_private_name_1_4025","Exported variable '{0}' has or is using private name '{1}'."),Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4026,e.DiagnosticCategory.Error,"Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot__4026","Public static property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:t(4027,e.DiagnosticCategory.Error,"Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4027","Public static property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_static_property_0_of_exported_class_has_or_is_using_private_name_1:t(4028,e.DiagnosticCategory.Error,"Public_static_property_0_of_exported_class_has_or_is_using_private_name_1_4028","Public static property '{0}' of exported class has or is using private name '{1}'."),Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4029,e.DiagnosticCategory.Error,"Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_name_4029","Public property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:t(4030,e.DiagnosticCategory.Error,"Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4030","Public property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_property_0_of_exported_class_has_or_is_using_private_name_1:t(4031,e.DiagnosticCategory.Error,"Public_property_0_of_exported_class_has_or_is_using_private_name_1_4031","Public property '{0}' of exported class has or is using private name '{1}'."),Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:t(4032,e.DiagnosticCategory.Error,"Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4032","Property '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),Property_0_of_exported_interface_has_or_is_using_private_name_1:t(4033,e.DiagnosticCategory.Error,"Property_0_of_exported_interface_has_or_is_using_private_name_1_4033","Property '{0}' of exported interface has or is using private name '{1}'."),Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:t(4034,e.DiagnosticCategory.Error,"Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_mod_4034","Parameter type of public static setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1:t(4035,e.DiagnosticCategory.Error,"Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1_4035","Parameter type of public static setter '{0}' from exported class has or is using private name '{1}'."),Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:t(4036,e.DiagnosticCategory.Error,"Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4036","Parameter type of public setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1:t(4037,e.DiagnosticCategory.Error,"Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1_4037","Parameter type of public setter '{0}' from exported class has or is using private name '{1}'."),Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4038,e.DiagnosticCategory.Error,"Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_modul_4038","Return type of public static getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:t(4039,e.DiagnosticCategory.Error,"Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_4039","Return type of public static getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1:t(4040,e.DiagnosticCategory.Error,"Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1_4040","Return type of public static getter '{0}' from exported class has or is using private name '{1}'."),Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4041,e.DiagnosticCategory.Error,"Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_4041","Return type of public getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:t(4042,e.DiagnosticCategory.Error,"Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4042","Return type of public getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1:t(4043,e.DiagnosticCategory.Error,"Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1_4043","Return type of public getter '{0}' from exported class has or is using private name '{1}'."),Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:t(4044,e.DiagnosticCategory.Error,"Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_mod_4044","Return type of constructor signature from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0:t(4045,e.DiagnosticCategory.Error,"Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0_4045","Return type of constructor signature from exported interface has or is using private name '{0}'."),Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:t(4046,e.DiagnosticCategory.Error,"Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4046","Return type of call signature from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0:t(4047,e.DiagnosticCategory.Error,"Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0_4047","Return type of call signature from exported interface has or is using private name '{0}'."),Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:t(4048,e.DiagnosticCategory.Error,"Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4048","Return type of index signature from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0:t(4049,e.DiagnosticCategory.Error,"Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0_4049","Return type of index signature from exported interface has or is using private name '{0}'."),Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:t(4050,e.DiagnosticCategory.Error,"Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module__4050","Return type of public static method from exported class has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:t(4051,e.DiagnosticCategory.Error,"Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4051","Return type of public static method from exported class has or is using name '{0}' from private module '{1}'."),Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0:t(4052,e.DiagnosticCategory.Error,"Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0_4052","Return type of public static method from exported class has or is using private name '{0}'."),Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:t(4053,e.DiagnosticCategory.Error,"Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_c_4053","Return type of public method from exported class has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:t(4054,e.DiagnosticCategory.Error,"Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4054","Return type of public method from exported class has or is using name '{0}' from private module '{1}'."),Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0:t(4055,e.DiagnosticCategory.Error,"Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0_4055","Return type of public method from exported class has or is using private name '{0}'."),Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1:t(4056,e.DiagnosticCategory.Error,"Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4056","Return type of method from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0:t(4057,e.DiagnosticCategory.Error,"Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0_4057","Return type of method from exported interface has or is using private name '{0}'."),Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:t(4058,e.DiagnosticCategory.Error,"Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named_4058","Return type of exported function has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1:t(4059,e.DiagnosticCategory.Error,"Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1_4059","Return type of exported function has or is using name '{0}' from private module '{1}'."),Return_type_of_exported_function_has_or_is_using_private_name_0:t(4060,e.DiagnosticCategory.Error,"Return_type_of_exported_function_has_or_is_using_private_name_0_4060","Return type of exported function has or is using private name '{0}'."),Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4061,e.DiagnosticCategory.Error,"Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_can_4061","Parameter '{0}' of constructor from exported class has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2:t(4062,e.DiagnosticCategory.Error,"Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2_4062","Parameter '{0}' of constructor from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1:t(4063,e.DiagnosticCategory.Error,"Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1_4063","Parameter '{0}' of constructor from exported class has or is using private name '{1}'."),Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:t(4064,e.DiagnosticCategory.Error,"Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_mod_4064","Parameter '{0}' of constructor signature from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1:t(4065,e.DiagnosticCategory.Error,"Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4065","Parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:t(4066,e.DiagnosticCategory.Error,"Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4066","Parameter '{0}' of call signature from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1:t(4067,e.DiagnosticCategory.Error,"Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4067","Parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4068,e.DiagnosticCategory.Error,"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module__4068","Parameter '{0}' of public static method from exported class has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:t(4069,e.DiagnosticCategory.Error,"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4069","Parameter '{0}' of public static method from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:t(4070,e.DiagnosticCategory.Error,"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4070","Parameter '{0}' of public static method from exported class has or is using private name '{1}'."),Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4071,e.DiagnosticCategory.Error,"Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_c_4071","Parameter '{0}' of public method from exported class has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:t(4072,e.DiagnosticCategory.Error,"Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4072","Parameter '{0}' of public method from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:t(4073,e.DiagnosticCategory.Error,"Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4073","Parameter '{0}' of public method from exported class has or is using private name '{1}'."),Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2:t(4074,e.DiagnosticCategory.Error,"Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4074","Parameter '{0}' of method from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1:t(4075,e.DiagnosticCategory.Error,"Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4075","Parameter '{0}' of method from exported interface has or is using private name '{1}'."),Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4076,e.DiagnosticCategory.Error,"Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4076","Parameter '{0}' of exported function has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2:t(4077,e.DiagnosticCategory.Error,"Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2_4077","Parameter '{0}' of exported function has or is using name '{1}' from private module '{2}'."),Parameter_0_of_exported_function_has_or_is_using_private_name_1:t(4078,e.DiagnosticCategory.Error,"Parameter_0_of_exported_function_has_or_is_using_private_name_1_4078","Parameter '{0}' of exported function has or is using private name '{1}'."),Exported_type_alias_0_has_or_is_using_private_name_1:t(4081,e.DiagnosticCategory.Error,"Exported_type_alias_0_has_or_is_using_private_name_1_4081","Exported type alias '{0}' has or is using private name '{1}'."),Default_export_of_the_module_has_or_is_using_private_name_0:t(4082,e.DiagnosticCategory.Error,"Default_export_of_the_module_has_or_is_using_private_name_0_4082","Default export of the module has or is using private name '{0}'."),Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1:t(4083,e.DiagnosticCategory.Error,"Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1_4083","Type parameter '{0}' of exported type alias has or is using private name '{1}'."),Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict:t(4090,e.DiagnosticCategory.Error,"Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_librar_4090","Conflicting definitions for '{0}' found at '{1}' and '{2}'. Consider installing a specific version of this library to resolve the conflict."),Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:t(4091,e.DiagnosticCategory.Error,"Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4091","Parameter '{0}' of index signature from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1:t(4092,e.DiagnosticCategory.Error,"Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1_4092","Parameter '{0}' of index signature from exported interface has or is using private name '{1}'."),Property_0_of_exported_class_expression_may_not_be_private_or_protected:t(4094,e.DiagnosticCategory.Error,"Property_0_of_exported_class_expression_may_not_be_private_or_protected_4094","Property '{0}' of exported class expression may not be private or protected."),Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4095,e.DiagnosticCategory.Error,"Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_4095","Public static method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:t(4096,e.DiagnosticCategory.Error,"Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4096","Public static method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_static_method_0_of_exported_class_has_or_is_using_private_name_1:t(4097,e.DiagnosticCategory.Error,"Public_static_method_0_of_exported_class_has_or_is_using_private_name_1_4097","Public static method '{0}' of exported class has or is using private name '{1}'."),Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4098,e.DiagnosticCategory.Error,"Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4098","Public method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:t(4099,e.DiagnosticCategory.Error,"Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4099","Public method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_method_0_of_exported_class_has_or_is_using_private_name_1:t(4100,e.DiagnosticCategory.Error,"Public_method_0_of_exported_class_has_or_is_using_private_name_1_4100","Public method '{0}' of exported class has or is using private name '{1}'."),Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:t(4101,e.DiagnosticCategory.Error,"Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4101","Method '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),Method_0_of_exported_interface_has_or_is_using_private_name_1:t(4102,e.DiagnosticCategory.Error,"Method_0_of_exported_interface_has_or_is_using_private_name_1_4102","Method '{0}' of exported interface has or is using private name '{1}'."),Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1:t(4103,e.DiagnosticCategory.Error,"Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1_4103","Type parameter '{0}' of exported mapped object type is using private name '{1}'."),The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1:t(4104,e.DiagnosticCategory.Error,"The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1_4104","The type '{0}' is 'readonly' and cannot be assigned to the mutable type '{1}'."),The_current_host_does_not_support_the_0_option:t(5001,e.DiagnosticCategory.Error,"The_current_host_does_not_support_the_0_option_5001","The current host does not support the '{0}' option."),Cannot_find_the_common_subdirectory_path_for_the_input_files:t(5009,e.DiagnosticCategory.Error,"Cannot_find_the_common_subdirectory_path_for_the_input_files_5009","Cannot find the common subdirectory path for the input files."),File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0:t(5010,e.DiagnosticCategory.Error,"File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0_5010","File specification cannot end in a recursive directory wildcard ('**'): '{0}'."),Cannot_read_file_0_Colon_1:t(5012,e.DiagnosticCategory.Error,"Cannot_read_file_0_Colon_1_5012","Cannot read file '{0}': {1}."),Failed_to_parse_file_0_Colon_1:t(5014,e.DiagnosticCategory.Error,"Failed_to_parse_file_0_Colon_1_5014","Failed to parse file '{0}': {1}."),Unknown_compiler_option_0:t(5023,e.DiagnosticCategory.Error,"Unknown_compiler_option_0_5023","Unknown compiler option '{0}'."),Compiler_option_0_requires_a_value_of_type_1:t(5024,e.DiagnosticCategory.Error,"Compiler_option_0_requires_a_value_of_type_1_5024","Compiler option '{0}' requires a value of type {1}."),Could_not_write_file_0_Colon_1:t(5033,e.DiagnosticCategory.Error,"Could_not_write_file_0_Colon_1_5033","Could not write file '{0}': {1}."),Option_project_cannot_be_mixed_with_source_files_on_a_command_line:t(5042,e.DiagnosticCategory.Error,"Option_project_cannot_be_mixed_with_source_files_on_a_command_line_5042","Option 'project' cannot be mixed with source files on a command line."),Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher:t(5047,e.DiagnosticCategory.Error,"Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES_5047","Option 'isolatedModules' can only be used when either option '--module' is provided or option 'target' is 'ES2015' or higher."),Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided:t(5051,e.DiagnosticCategory.Error,"Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided_5051","Option '{0} can only be used when either option '--inlineSourceMap' or option '--sourceMap' is provided."),Option_0_cannot_be_specified_without_specifying_option_1:t(5052,e.DiagnosticCategory.Error,"Option_0_cannot_be_specified_without_specifying_option_1_5052","Option '{0}' cannot be specified without specifying option '{1}'."),Option_0_cannot_be_specified_with_option_1:t(5053,e.DiagnosticCategory.Error,"Option_0_cannot_be_specified_with_option_1_5053","Option '{0}' cannot be specified with option '{1}'."),A_tsconfig_json_file_is_already_defined_at_Colon_0:t(5054,e.DiagnosticCategory.Error,"A_tsconfig_json_file_is_already_defined_at_Colon_0_5054","A 'tsconfig.json' file is already defined at: '{0}'."),Cannot_write_file_0_because_it_would_overwrite_input_file:t(5055,e.DiagnosticCategory.Error,"Cannot_write_file_0_because_it_would_overwrite_input_file_5055","Cannot write file '{0}' because it would overwrite input file."),Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files:t(5056,e.DiagnosticCategory.Error,"Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files_5056","Cannot write file '{0}' because it would be overwritten by multiple input files."),Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0:t(5057,e.DiagnosticCategory.Error,"Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0_5057","Cannot find a tsconfig.json file at the specified directory: '{0}'."),The_specified_path_does_not_exist_Colon_0:t(5058,e.DiagnosticCategory.Error,"The_specified_path_does_not_exist_Colon_0_5058","The specified path does not exist: '{0}'."),Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier:t(5059,e.DiagnosticCategory.Error,"Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier_5059","Invalid value for '--reactNamespace'. '{0}' is not a valid identifier."),Option_paths_cannot_be_used_without_specifying_baseUrl_option:t(5060,e.DiagnosticCategory.Error,"Option_paths_cannot_be_used_without_specifying_baseUrl_option_5060","Option 'paths' cannot be used without specifying '--baseUrl' option."),Pattern_0_can_have_at_most_one_Asterisk_character:t(5061,e.DiagnosticCategory.Error,"Pattern_0_can_have_at_most_one_Asterisk_character_5061","Pattern '{0}' can have at most one '*' character."),Substitution_0_in_pattern_1_in_can_have_at_most_one_Asterisk_character:t(5062,e.DiagnosticCategory.Error,"Substitution_0_in_pattern_1_in_can_have_at_most_one_Asterisk_character_5062","Substitution '{0}' in pattern '{1}' in can have at most one '*' character."),Substitutions_for_pattern_0_should_be_an_array:t(5063,e.DiagnosticCategory.Error,"Substitutions_for_pattern_0_should_be_an_array_5063","Substitutions for pattern '{0}' should be an array."),Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2:t(5064,e.DiagnosticCategory.Error,"Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2_5064","Substitution '{0}' for pattern '{1}' has incorrect type, expected 'string', got '{2}'."),File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0:t(5065,e.DiagnosticCategory.Error,"File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildca_5065","File specification cannot contain a parent directory ('..') that appears after a recursive directory wildcard ('**'): '{0}'."),Substitutions_for_pattern_0_shouldn_t_be_an_empty_array:t(5066,e.DiagnosticCategory.Error,"Substitutions_for_pattern_0_shouldn_t_be_an_empty_array_5066","Substitutions for pattern '{0}' shouldn't be an empty array."),Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name:t(5067,e.DiagnosticCategory.Error,"Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name_5067","Invalid value for 'jsxFactory'. '{0}' is not a valid identifier or qualified-name."),Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig:t(5068,e.DiagnosticCategory.Error,"Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript__5068","Adding a tsconfig.json file will help organize projects that contain both TypeScript and JavaScript files. Learn more at https://aka.ms/tsconfig."),Option_0_cannot_be_specified_without_specifying_option_1_or_option_2:t(5069,e.DiagnosticCategory.Error,"Option_0_cannot_be_specified_without_specifying_option_1_or_option_2_5069","Option '{0}' cannot be specified without specifying option '{1}' or option '{2}'."),Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy:t(5070,e.DiagnosticCategory.Error,"Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy_5070","Option '--resolveJsonModule' cannot be specified without 'node' module resolution strategy."),Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_esNext:t(5071,e.DiagnosticCategory.Error,"Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_5071","Option '--resolveJsonModule' can only be specified when module code generation is 'commonjs', 'amd', 'es2015' or 'esNext'."),Unknown_build_option_0:t(5072,e.DiagnosticCategory.Error,"Unknown_build_option_0_5072","Unknown build option '{0}'."),Build_option_0_requires_a_value_of_type_1:t(5073,e.DiagnosticCategory.Error,"Build_option_0_requires_a_value_of_type_1_5073","Build option '{0}' requires a value of type {1}."),Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified:t(5074,e.DiagnosticCategory.Error,"Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBui_5074","Option '--incremental' can only be specified using tsconfig, emitting to single file or when option `--tsBuildInfoFile` is specified."),_0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2:t(5075,e.DiagnosticCategory.Error,"_0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_5075","'{0}' is assignable to the constraint of type '{1}', but '{1}' could be instantiated with a different subtype of constraint '{2}'."),Generates_a_sourcemap_for_each_corresponding_d_ts_file:t(6e3,e.DiagnosticCategory.Message,"Generates_a_sourcemap_for_each_corresponding_d_ts_file_6000","Generates a sourcemap for each corresponding '.d.ts' file."),Concatenate_and_emit_output_to_single_file:t(6001,e.DiagnosticCategory.Message,"Concatenate_and_emit_output_to_single_file_6001","Concatenate and emit output to single file."),Generates_corresponding_d_ts_file:t(6002,e.DiagnosticCategory.Message,"Generates_corresponding_d_ts_file_6002","Generates corresponding '.d.ts' file."),Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations:t(6003,e.DiagnosticCategory.Message,"Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations_6003","Specify the location where debugger should locate map files instead of generated locations."),Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations:t(6004,e.DiagnosticCategory.Message,"Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations_6004","Specify the location where debugger should locate TypeScript files instead of source locations."),Watch_input_files:t(6005,e.DiagnosticCategory.Message,"Watch_input_files_6005","Watch input files."),Redirect_output_structure_to_the_directory:t(6006,e.DiagnosticCategory.Message,"Redirect_output_structure_to_the_directory_6006","Redirect output structure to the directory."),Do_not_erase_const_enum_declarations_in_generated_code:t(6007,e.DiagnosticCategory.Message,"Do_not_erase_const_enum_declarations_in_generated_code_6007","Do not erase const enum declarations in generated code."),Do_not_emit_outputs_if_any_errors_were_reported:t(6008,e.DiagnosticCategory.Message,"Do_not_emit_outputs_if_any_errors_were_reported_6008","Do not emit outputs if any errors were reported."),Do_not_emit_comments_to_output:t(6009,e.DiagnosticCategory.Message,"Do_not_emit_comments_to_output_6009","Do not emit comments to output."),Do_not_emit_outputs:t(6010,e.DiagnosticCategory.Message,"Do_not_emit_outputs_6010","Do not emit outputs."),Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking:t(6011,e.DiagnosticCategory.Message,"Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typech_6011","Allow default imports from modules with no default export. This does not affect code emit, just typechecking."),Skip_type_checking_of_declaration_files:t(6012,e.DiagnosticCategory.Message,"Skip_type_checking_of_declaration_files_6012","Skip type checking of declaration files."),Do_not_resolve_the_real_path_of_symlinks:t(6013,e.DiagnosticCategory.Message,"Do_not_resolve_the_real_path_of_symlinks_6013","Do not resolve the real path of symlinks."),Only_emit_d_ts_declaration_files:t(6014,e.DiagnosticCategory.Message,"Only_emit_d_ts_declaration_files_6014","Only emit '.d.ts' declaration files."),Specify_ECMAScript_target_version_Colon_ES3_default_ES5_ES2015_ES2016_ES2017_ES2018_ES2019_or_ESNEXT:t(6015,e.DiagnosticCategory.Message,"Specify_ECMAScript_target_version_Colon_ES3_default_ES5_ES2015_ES2016_ES2017_ES2018_ES2019_or_ESNEXT_6015","Specify ECMAScript target version: 'ES3' (default), 'ES5', 'ES2015', 'ES2016', 'ES2017', 'ES2018', 'ES2019' or 'ESNEXT'."),Specify_module_code_generation_Colon_none_commonjs_amd_system_umd_es2015_or_ESNext:t(6016,e.DiagnosticCategory.Message,"Specify_module_code_generation_Colon_none_commonjs_amd_system_umd_es2015_or_ESNext_6016","Specify module code generation: 'none', 'commonjs', 'amd', 'system', 'umd', 'es2015', or 'ESNext'."),Print_this_message:t(6017,e.DiagnosticCategory.Message,"Print_this_message_6017","Print this message."),Print_the_compiler_s_version:t(6019,e.DiagnosticCategory.Message,"Print_the_compiler_s_version_6019","Print the compiler's version."),Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json:t(6020,e.DiagnosticCategory.Message,"Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json_6020","Compile the project given the path to its configuration file, or to a folder with a 'tsconfig.json'."),Syntax_Colon_0:t(6023,e.DiagnosticCategory.Message,"Syntax_Colon_0_6023","Syntax: {0}"),options:t(6024,e.DiagnosticCategory.Message,"options_6024","options"),file:t(6025,e.DiagnosticCategory.Message,"file_6025","file"),Examples_Colon_0:t(6026,e.DiagnosticCategory.Message,"Examples_Colon_0_6026","Examples: {0}"),Options_Colon:t(6027,e.DiagnosticCategory.Message,"Options_Colon_6027","Options:"),Version_0:t(6029,e.DiagnosticCategory.Message,"Version_0_6029","Version {0}"),Insert_command_line_options_and_files_from_a_file:t(6030,e.DiagnosticCategory.Message,"Insert_command_line_options_and_files_from_a_file_6030","Insert command line options and files from a file."),Starting_compilation_in_watch_mode:t(6031,e.DiagnosticCategory.Message,"Starting_compilation_in_watch_mode_6031","Starting compilation in watch mode..."),File_change_detected_Starting_incremental_compilation:t(6032,e.DiagnosticCategory.Message,"File_change_detected_Starting_incremental_compilation_6032","File change detected. Starting incremental compilation..."),KIND:t(6034,e.DiagnosticCategory.Message,"KIND_6034","KIND"),FILE:t(6035,e.DiagnosticCategory.Message,"FILE_6035","FILE"),VERSION:t(6036,e.DiagnosticCategory.Message,"VERSION_6036","VERSION"),LOCATION:t(6037,e.DiagnosticCategory.Message,"LOCATION_6037","LOCATION"),DIRECTORY:t(6038,e.DiagnosticCategory.Message,"DIRECTORY_6038","DIRECTORY"),STRATEGY:t(6039,e.DiagnosticCategory.Message,"STRATEGY_6039","STRATEGY"),FILE_OR_DIRECTORY:t(6040,e.DiagnosticCategory.Message,"FILE_OR_DIRECTORY_6040","FILE OR DIRECTORY"),Generates_corresponding_map_file:t(6043,e.DiagnosticCategory.Message,"Generates_corresponding_map_file_6043","Generates corresponding '.map' file."),Compiler_option_0_expects_an_argument:t(6044,e.DiagnosticCategory.Error,"Compiler_option_0_expects_an_argument_6044","Compiler option '{0}' expects an argument."),Unterminated_quoted_string_in_response_file_0:t(6045,e.DiagnosticCategory.Error,"Unterminated_quoted_string_in_response_file_0_6045","Unterminated quoted string in response file '{0}'."),Argument_for_0_option_must_be_Colon_1:t(6046,e.DiagnosticCategory.Error,"Argument_for_0_option_must_be_Colon_1_6046","Argument for '{0}' option must be: {1}."),Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1:t(6048,e.DiagnosticCategory.Error,"Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1_6048","Locale must be of the form <language> or <language>-<territory>. For example '{0}' or '{1}'."),Unsupported_locale_0:t(6049,e.DiagnosticCategory.Error,"Unsupported_locale_0_6049","Unsupported locale '{0}'."),Unable_to_open_file_0:t(6050,e.DiagnosticCategory.Error,"Unable_to_open_file_0_6050","Unable to open file '{0}'."),Corrupted_locale_file_0:t(6051,e.DiagnosticCategory.Error,"Corrupted_locale_file_0_6051","Corrupted locale file {0}."),Raise_error_on_expressions_and_declarations_with_an_implied_any_type:t(6052,e.DiagnosticCategory.Message,"Raise_error_on_expressions_and_declarations_with_an_implied_any_type_6052","Raise error on expressions and declarations with an implied 'any' type."),File_0_not_found:t(6053,e.DiagnosticCategory.Error,"File_0_not_found_6053","File '{0}' not found."),File_0_has_unsupported_extension_The_only_supported_extensions_are_1:t(6054,e.DiagnosticCategory.Error,"File_0_has_unsupported_extension_The_only_supported_extensions_are_1_6054","File '{0}' has unsupported extension. The only supported extensions are {1}."),Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures:t(6055,e.DiagnosticCategory.Message,"Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures_6055","Suppress noImplicitAny errors for indexing objects lacking index signatures."),Do_not_emit_declarations_for_code_that_has_an_internal_annotation:t(6056,e.DiagnosticCategory.Message,"Do_not_emit_declarations_for_code_that_has_an_internal_annotation_6056","Do not emit declarations for code that has an '@internal' annotation."),Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir:t(6058,e.DiagnosticCategory.Message,"Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir_6058","Specify the root directory of input files. Use to control the output directory structure with --outDir."),File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files:t(6059,e.DiagnosticCategory.Error,"File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files_6059","File '{0}' is not under 'rootDir' '{1}'. 'rootDir' is expected to contain all source files."),Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix:t(6060,e.DiagnosticCategory.Message,"Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix_6060","Specify the end of line sequence to be used when emitting files: 'CRLF' (dos) or 'LF' (unix)."),NEWLINE:t(6061,e.DiagnosticCategory.Message,"NEWLINE_6061","NEWLINE"),Option_0_can_only_be_specified_in_tsconfig_json_file:t(6064,e.DiagnosticCategory.Error,"Option_0_can_only_be_specified_in_tsconfig_json_file_6064","Option '{0}' can only be specified in 'tsconfig.json' file."),Enables_experimental_support_for_ES7_decorators:t(6065,e.DiagnosticCategory.Message,"Enables_experimental_support_for_ES7_decorators_6065","Enables experimental support for ES7 decorators."),Enables_experimental_support_for_emitting_type_metadata_for_decorators:t(6066,e.DiagnosticCategory.Message,"Enables_experimental_support_for_emitting_type_metadata_for_decorators_6066","Enables experimental support for emitting type metadata for decorators."),Enables_experimental_support_for_ES7_async_functions:t(6068,e.DiagnosticCategory.Message,"Enables_experimental_support_for_ES7_async_functions_6068","Enables experimental support for ES7 async functions."),Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6:t(6069,e.DiagnosticCategory.Message,"Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6_6069","Specify module resolution strategy: 'node' (Node.js) or 'classic' (TypeScript pre-1.6)."),Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file:t(6070,e.DiagnosticCategory.Message,"Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file_6070","Initializes a TypeScript project and creates a tsconfig.json file."),Successfully_created_a_tsconfig_json_file:t(6071,e.DiagnosticCategory.Message,"Successfully_created_a_tsconfig_json_file_6071","Successfully created a tsconfig.json file."),Suppress_excess_property_checks_for_object_literals:t(6072,e.DiagnosticCategory.Message,"Suppress_excess_property_checks_for_object_literals_6072","Suppress excess property checks for object literals."),Stylize_errors_and_messages_using_color_and_context_experimental:t(6073,e.DiagnosticCategory.Message,"Stylize_errors_and_messages_using_color_and_context_experimental_6073","Stylize errors and messages using color and context (experimental)."),Do_not_report_errors_on_unused_labels:t(6074,e.DiagnosticCategory.Message,"Do_not_report_errors_on_unused_labels_6074","Do not report errors on unused labels."),Report_error_when_not_all_code_paths_in_function_return_a_value:t(6075,e.DiagnosticCategory.Message,"Report_error_when_not_all_code_paths_in_function_return_a_value_6075","Report error when not all code paths in function return a value."),Report_errors_for_fallthrough_cases_in_switch_statement:t(6076,e.DiagnosticCategory.Message,"Report_errors_for_fallthrough_cases_in_switch_statement_6076","Report errors for fallthrough cases in switch statement."),Do_not_report_errors_on_unreachable_code:t(6077,e.DiagnosticCategory.Message,"Do_not_report_errors_on_unreachable_code_6077","Do not report errors on unreachable code."),Disallow_inconsistently_cased_references_to_the_same_file:t(6078,e.DiagnosticCategory.Message,"Disallow_inconsistently_cased_references_to_the_same_file_6078","Disallow inconsistently-cased references to the same file."),Specify_library_files_to_be_included_in_the_compilation:t(6079,e.DiagnosticCategory.Message,"Specify_library_files_to_be_included_in_the_compilation_6079","Specify library files to be included in the compilation."),Specify_JSX_code_generation_Colon_preserve_react_native_or_react:t(6080,e.DiagnosticCategory.Message,"Specify_JSX_code_generation_Colon_preserve_react_native_or_react_6080","Specify JSX code generation: 'preserve', 'react-native', or 'react'."),File_0_has_an_unsupported_extension_so_skipping_it:t(6081,e.DiagnosticCategory.Message,"File_0_has_an_unsupported_extension_so_skipping_it_6081","File '{0}' has an unsupported extension, so skipping it."),Only_amd_and_system_modules_are_supported_alongside_0:t(6082,e.DiagnosticCategory.Error,"Only_amd_and_system_modules_are_supported_alongside_0_6082","Only 'amd' and 'system' modules are supported alongside --{0}."),Base_directory_to_resolve_non_absolute_module_names:t(6083,e.DiagnosticCategory.Message,"Base_directory_to_resolve_non_absolute_module_names_6083","Base directory to resolve non-absolute module names."),Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit:t(6084,e.DiagnosticCategory.Message,"Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react__6084","[Deprecated] Use '--jsxFactory' instead. Specify the object invoked for createElement when targeting 'react' JSX emit"),Enable_tracing_of_the_name_resolution_process:t(6085,e.DiagnosticCategory.Message,"Enable_tracing_of_the_name_resolution_process_6085","Enable tracing of the name resolution process."),Resolving_module_0_from_1:t(6086,e.DiagnosticCategory.Message,"Resolving_module_0_from_1_6086","======== Resolving module '{0}' from '{1}'. ========"),Explicitly_specified_module_resolution_kind_Colon_0:t(6087,e.DiagnosticCategory.Message,"Explicitly_specified_module_resolution_kind_Colon_0_6087","Explicitly specified module resolution kind: '{0}'."),Module_resolution_kind_is_not_specified_using_0:t(6088,e.DiagnosticCategory.Message,"Module_resolution_kind_is_not_specified_using_0_6088","Module resolution kind is not specified, using '{0}'."),Module_name_0_was_successfully_resolved_to_1:t(6089,e.DiagnosticCategory.Message,"Module_name_0_was_successfully_resolved_to_1_6089","======== Module name '{0}' was successfully resolved to '{1}'. ========"),Module_name_0_was_not_resolved:t(6090,e.DiagnosticCategory.Message,"Module_name_0_was_not_resolved_6090","======== Module name '{0}' was not resolved. ========"),paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0:t(6091,e.DiagnosticCategory.Message,"paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0_6091","'paths' option is specified, looking for a pattern to match module name '{0}'."),Module_name_0_matched_pattern_1:t(6092,e.DiagnosticCategory.Message,"Module_name_0_matched_pattern_1_6092","Module name '{0}', matched pattern '{1}'."),Trying_substitution_0_candidate_module_location_Colon_1:t(6093,e.DiagnosticCategory.Message,"Trying_substitution_0_candidate_module_location_Colon_1_6093","Trying substitution '{0}', candidate module location: '{1}'."),Resolving_module_name_0_relative_to_base_url_1_2:t(6094,e.DiagnosticCategory.Message,"Resolving_module_name_0_relative_to_base_url_1_2_6094","Resolving module name '{0}' relative to base url '{1}' - '{2}'."),Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1:t(6095,e.DiagnosticCategory.Message,"Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1_6095","Loading module as file / folder, candidate module location '{0}', target file type '{1}'."),File_0_does_not_exist:t(6096,e.DiagnosticCategory.Message,"File_0_does_not_exist_6096","File '{0}' does not exist."),File_0_exist_use_it_as_a_name_resolution_result:t(6097,e.DiagnosticCategory.Message,"File_0_exist_use_it_as_a_name_resolution_result_6097","File '{0}' exist - use it as a name resolution result."),Loading_module_0_from_node_modules_folder_target_file_type_1:t(6098,e.DiagnosticCategory.Message,"Loading_module_0_from_node_modules_folder_target_file_type_1_6098","Loading module '{0}' from 'node_modules' folder, target file type '{1}'."),Found_package_json_at_0:t(6099,e.DiagnosticCategory.Message,"Found_package_json_at_0_6099","Found 'package.json' at '{0}'."),package_json_does_not_have_a_0_field:t(6100,e.DiagnosticCategory.Message,"package_json_does_not_have_a_0_field_6100","'package.json' does not have a '{0}' field."),package_json_has_0_field_1_that_references_2:t(6101,e.DiagnosticCategory.Message,"package_json_has_0_field_1_that_references_2_6101","'package.json' has '{0}' field '{1}' that references '{2}'."),Allow_javascript_files_to_be_compiled:t(6102,e.DiagnosticCategory.Message,"Allow_javascript_files_to_be_compiled_6102","Allow javascript files to be compiled."),Option_0_should_have_array_of_strings_as_a_value:t(6103,e.DiagnosticCategory.Error,"Option_0_should_have_array_of_strings_as_a_value_6103","Option '{0}' should have array of strings as a value."),Checking_if_0_is_the_longest_matching_prefix_for_1_2:t(6104,e.DiagnosticCategory.Message,"Checking_if_0_is_the_longest_matching_prefix_for_1_2_6104","Checking if '{0}' is the longest matching prefix for '{1}' - '{2}'."),Expected_type_of_0_field_in_package_json_to_be_1_got_2:t(6105,e.DiagnosticCategory.Message,"Expected_type_of_0_field_in_package_json_to_be_1_got_2_6105","Expected type of '{0}' field in 'package.json' to be '{1}', got '{2}'."),baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1:t(6106,e.DiagnosticCategory.Message,"baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1_6106","'baseUrl' option is set to '{0}', using this value to resolve non-relative module name '{1}'."),rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0:t(6107,e.DiagnosticCategory.Message,"rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0_6107","'rootDirs' option is set, using it to resolve relative module name '{0}'."),Longest_matching_prefix_for_0_is_1:t(6108,e.DiagnosticCategory.Message,"Longest_matching_prefix_for_0_is_1_6108","Longest matching prefix for '{0}' is '{1}'."),Loading_0_from_the_root_dir_1_candidate_location_2:t(6109,e.DiagnosticCategory.Message,"Loading_0_from_the_root_dir_1_candidate_location_2_6109","Loading '{0}' from the root dir '{1}', candidate location '{2}'."),Trying_other_entries_in_rootDirs:t(6110,e.DiagnosticCategory.Message,"Trying_other_entries_in_rootDirs_6110","Trying other entries in 'rootDirs'."),Module_resolution_using_rootDirs_has_failed:t(6111,e.DiagnosticCategory.Message,"Module_resolution_using_rootDirs_has_failed_6111","Module resolution using 'rootDirs' has failed."),Do_not_emit_use_strict_directives_in_module_output:t(6112,e.DiagnosticCategory.Message,"Do_not_emit_use_strict_directives_in_module_output_6112","Do not emit 'use strict' directives in module output."),Enable_strict_null_checks:t(6113,e.DiagnosticCategory.Message,"Enable_strict_null_checks_6113","Enable strict null checks."),Unknown_option_excludes_Did_you_mean_exclude:t(6114,e.DiagnosticCategory.Error,"Unknown_option_excludes_Did_you_mean_exclude_6114","Unknown option 'excludes'. Did you mean 'exclude'?"),Raise_error_on_this_expressions_with_an_implied_any_type:t(6115,e.DiagnosticCategory.Message,"Raise_error_on_this_expressions_with_an_implied_any_type_6115","Raise error on 'this' expressions with an implied 'any' type."),Resolving_type_reference_directive_0_containing_file_1_root_directory_2:t(6116,e.DiagnosticCategory.Message,"Resolving_type_reference_directive_0_containing_file_1_root_directory_2_6116","======== Resolving type reference directive '{0}', containing file '{1}', root directory '{2}'. ========"),Resolving_using_primary_search_paths:t(6117,e.DiagnosticCategory.Message,"Resolving_using_primary_search_paths_6117","Resolving using primary search paths..."),Resolving_from_node_modules_folder:t(6118,e.DiagnosticCategory.Message,"Resolving_from_node_modules_folder_6118","Resolving from node_modules folder..."),Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2:t(6119,e.DiagnosticCategory.Message,"Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2_6119","======== Type reference directive '{0}' was successfully resolved to '{1}', primary: {2}. ========"),Type_reference_directive_0_was_not_resolved:t(6120,e.DiagnosticCategory.Message,"Type_reference_directive_0_was_not_resolved_6120","======== Type reference directive '{0}' was not resolved. ========"),Resolving_with_primary_search_path_0:t(6121,e.DiagnosticCategory.Message,"Resolving_with_primary_search_path_0_6121","Resolving with primary search path '{0}'."),Root_directory_cannot_be_determined_skipping_primary_search_paths:t(6122,e.DiagnosticCategory.Message,"Root_directory_cannot_be_determined_skipping_primary_search_paths_6122","Root directory cannot be determined, skipping primary search paths."),Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set:t(6123,e.DiagnosticCategory.Message,"Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set_6123","======== Resolving type reference directive '{0}', containing file '{1}', root directory not set. ========"),Type_declaration_files_to_be_included_in_compilation:t(6124,e.DiagnosticCategory.Message,"Type_declaration_files_to_be_included_in_compilation_6124","Type declaration files to be included in compilation."),Looking_up_in_node_modules_folder_initial_location_0:t(6125,e.DiagnosticCategory.Message,"Looking_up_in_node_modules_folder_initial_location_0_6125","Looking up in 'node_modules' folder, initial location '{0}'."),Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder:t(6126,e.DiagnosticCategory.Message,"Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_mod_6126","Containing file is not specified and root directory cannot be determined, skipping lookup in 'node_modules' folder."),Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1:t(6127,e.DiagnosticCategory.Message,"Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1_6127","======== Resolving type reference directive '{0}', containing file not set, root directory '{1}'. ========"),Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set:t(6128,e.DiagnosticCategory.Message,"Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set_6128","======== Resolving type reference directive '{0}', containing file not set, root directory not set. ========"),Resolving_real_path_for_0_result_1:t(6130,e.DiagnosticCategory.Message,"Resolving_real_path_for_0_result_1_6130","Resolving real path for '{0}', result '{1}'."),Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system:t(6131,e.DiagnosticCategory.Error,"Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system_6131","Cannot compile modules using option '{0}' unless the '--module' flag is 'amd' or 'system'."),File_name_0_has_a_1_extension_stripping_it:t(6132,e.DiagnosticCategory.Message,"File_name_0_has_a_1_extension_stripping_it_6132","File name '{0}' has a '{1}' extension - stripping it."),_0_is_declared_but_its_value_is_never_read:t(6133,e.DiagnosticCategory.Error,"_0_is_declared_but_its_value_is_never_read_6133","'{0}' is declared but its value is never read.",!0),Report_errors_on_unused_locals:t(6134,e.DiagnosticCategory.Message,"Report_errors_on_unused_locals_6134","Report errors on unused locals."),Report_errors_on_unused_parameters:t(6135,e.DiagnosticCategory.Message,"Report_errors_on_unused_parameters_6135","Report errors on unused parameters."),The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files:t(6136,e.DiagnosticCategory.Message,"The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files_6136","The maximum dependency depth to search under node_modules and load JavaScript files."),Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1:t(6137,e.DiagnosticCategory.Error,"Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1_6137","Cannot import type declaration files. Consider importing '{0}' instead of '{1}'."),Property_0_is_declared_but_its_value_is_never_read:t(6138,e.DiagnosticCategory.Error,"Property_0_is_declared_but_its_value_is_never_read_6138","Property '{0}' is declared but its value is never read.",!0),Import_emit_helpers_from_tslib:t(6139,e.DiagnosticCategory.Message,"Import_emit_helpers_from_tslib_6139","Import emit helpers from 'tslib'."),Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2:t(6140,e.DiagnosticCategory.Error,"Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using__6140","Auto discovery for typings is enabled in project '{0}'. Running extra resolution pass for module '{1}' using cache location '{2}'."),Parse_in_strict_mode_and_emit_use_strict_for_each_source_file:t(6141,e.DiagnosticCategory.Message,"Parse_in_strict_mode_and_emit_use_strict_for_each_source_file_6141",'Parse in strict mode and emit "use strict" for each source file.'),Module_0_was_resolved_to_1_but_jsx_is_not_set:t(6142,e.DiagnosticCategory.Error,"Module_0_was_resolved_to_1_but_jsx_is_not_set_6142","Module '{0}' was resolved to '{1}', but '--jsx' is not set."),Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1:t(6144,e.DiagnosticCategory.Message,"Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1_6144","Module '{0}' was resolved as locally declared ambient module in file '{1}'."),Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified:t(6145,e.DiagnosticCategory.Message,"Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified_6145","Module '{0}' was resolved as ambient module declared in '{1}' since this file was not modified."),Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h:t(6146,e.DiagnosticCategory.Message,"Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h_6146","Specify the JSX factory function to use when targeting 'react' JSX emit, e.g. 'React.createElement' or 'h'."),Resolution_for_module_0_was_found_in_cache_from_location_1:t(6147,e.DiagnosticCategory.Message,"Resolution_for_module_0_was_found_in_cache_from_location_1_6147","Resolution for module '{0}' was found in cache from location '{1}'."),Directory_0_does_not_exist_skipping_all_lookups_in_it:t(6148,e.DiagnosticCategory.Message,"Directory_0_does_not_exist_skipping_all_lookups_in_it_6148","Directory '{0}' does not exist, skipping all lookups in it."),Show_diagnostic_information:t(6149,e.DiagnosticCategory.Message,"Show_diagnostic_information_6149","Show diagnostic information."),Show_verbose_diagnostic_information:t(6150,e.DiagnosticCategory.Message,"Show_verbose_diagnostic_information_6150","Show verbose diagnostic information."),Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file:t(6151,e.DiagnosticCategory.Message,"Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file_6151","Emit a single file with source maps instead of having a separate file."),Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set:t(6152,e.DiagnosticCategory.Message,"Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap__6152","Emit the source alongside the sourcemaps within a single file; requires '--inlineSourceMap' or '--sourceMap' to be set."),Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule:t(6153,e.DiagnosticCategory.Message,"Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule_6153","Transpile each file as a separate module (similar to 'ts.transpileModule')."),Print_names_of_generated_files_part_of_the_compilation:t(6154,e.DiagnosticCategory.Message,"Print_names_of_generated_files_part_of_the_compilation_6154","Print names of generated files part of the compilation."),Print_names_of_files_part_of_the_compilation:t(6155,e.DiagnosticCategory.Message,"Print_names_of_files_part_of_the_compilation_6155","Print names of files part of the compilation."),The_locale_used_when_displaying_messages_to_the_user_e_g_en_us:t(6156,e.DiagnosticCategory.Message,"The_locale_used_when_displaying_messages_to_the_user_e_g_en_us_6156","The locale used when displaying messages to the user (e.g. 'en-us')"),Do_not_generate_custom_helper_functions_like_extends_in_compiled_output:t(6157,e.DiagnosticCategory.Message,"Do_not_generate_custom_helper_functions_like_extends_in_compiled_output_6157","Do not generate custom helper functions like '__extends' in compiled output."),Do_not_include_the_default_library_file_lib_d_ts:t(6158,e.DiagnosticCategory.Message,"Do_not_include_the_default_library_file_lib_d_ts_6158","Do not include the default library file (lib.d.ts)."),Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files:t(6159,e.DiagnosticCategory.Message,"Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files_6159","Do not add triple-slash references or imported modules to the list of compiled files."),Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files:t(6160,e.DiagnosticCategory.Message,"Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files_6160","[Deprecated] Use '--skipLibCheck' instead. Skip type checking of default library declaration files."),List_of_folders_to_include_type_definitions_from:t(6161,e.DiagnosticCategory.Message,"List_of_folders_to_include_type_definitions_from_6161","List of folders to include type definitions from."),Disable_size_limitations_on_JavaScript_projects:t(6162,e.DiagnosticCategory.Message,"Disable_size_limitations_on_JavaScript_projects_6162","Disable size limitations on JavaScript projects."),The_character_set_of_the_input_files:t(6163,e.DiagnosticCategory.Message,"The_character_set_of_the_input_files_6163","The character set of the input files."),Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files:t(6164,e.DiagnosticCategory.Message,"Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files_6164","Emit a UTF-8 Byte Order Mark (BOM) in the beginning of output files."),Do_not_truncate_error_messages:t(6165,e.DiagnosticCategory.Message,"Do_not_truncate_error_messages_6165","Do not truncate error messages."),Output_directory_for_generated_declaration_files:t(6166,e.DiagnosticCategory.Message,"Output_directory_for_generated_declaration_files_6166","Output directory for generated declaration files."),A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl:t(6167,e.DiagnosticCategory.Message,"A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl_6167","A series of entries which re-map imports to lookup locations relative to the 'baseUrl'."),List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime:t(6168,e.DiagnosticCategory.Message,"List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime_6168","List of root folders whose combined content represents the structure of the project at runtime."),Show_all_compiler_options:t(6169,e.DiagnosticCategory.Message,"Show_all_compiler_options_6169","Show all compiler options."),Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file:t(6170,e.DiagnosticCategory.Message,"Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file_6170","[Deprecated] Use '--outFile' instead. Concatenate and emit output to single file"),Command_line_Options:t(6171,e.DiagnosticCategory.Message,"Command_line_Options_6171","Command-line Options"),Basic_Options:t(6172,e.DiagnosticCategory.Message,"Basic_Options_6172","Basic Options"),Strict_Type_Checking_Options:t(6173,e.DiagnosticCategory.Message,"Strict_Type_Checking_Options_6173","Strict Type-Checking Options"),Module_Resolution_Options:t(6174,e.DiagnosticCategory.Message,"Module_Resolution_Options_6174","Module Resolution Options"),Source_Map_Options:t(6175,e.DiagnosticCategory.Message,"Source_Map_Options_6175","Source Map Options"),Additional_Checks:t(6176,e.DiagnosticCategory.Message,"Additional_Checks_6176","Additional Checks"),Experimental_Options:t(6177,e.DiagnosticCategory.Message,"Experimental_Options_6177","Experimental Options"),Advanced_Options:t(6178,e.DiagnosticCategory.Message,"Advanced_Options_6178","Advanced Options"),Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3:t(6179,e.DiagnosticCategory.Message,"Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3_6179","Provide full support for iterables in 'for-of', spread, and destructuring when targeting 'ES5' or 'ES3'."),Enable_all_strict_type_checking_options:t(6180,e.DiagnosticCategory.Message,"Enable_all_strict_type_checking_options_6180","Enable all strict type-checking options."),List_of_language_service_plugins:t(6181,e.DiagnosticCategory.Message,"List_of_language_service_plugins_6181","List of language service plugins."),Scoped_package_detected_looking_in_0:t(6182,e.DiagnosticCategory.Message,"Scoped_package_detected_looking_in_0_6182","Scoped package detected, looking in '{0}'"),Reusing_resolution_of_module_0_to_file_1_from_old_program:t(6183,e.DiagnosticCategory.Message,"Reusing_resolution_of_module_0_to_file_1_from_old_program_6183","Reusing resolution of module '{0}' to file '{1}' from old program."),Reusing_module_resolutions_originating_in_0_since_resolutions_are_unchanged_from_old_program:t(6184,e.DiagnosticCategory.Message,"Reusing_module_resolutions_originating_in_0_since_resolutions_are_unchanged_from_old_program_6184","Reusing module resolutions originating in '{0}' since resolutions are unchanged from old program."),Disable_strict_checking_of_generic_signatures_in_function_types:t(6185,e.DiagnosticCategory.Message,"Disable_strict_checking_of_generic_signatures_in_function_types_6185","Disable strict checking of generic signatures in function types."),Enable_strict_checking_of_function_types:t(6186,e.DiagnosticCategory.Message,"Enable_strict_checking_of_function_types_6186","Enable strict checking of function types."),Enable_strict_checking_of_property_initialization_in_classes:t(6187,e.DiagnosticCategory.Message,"Enable_strict_checking_of_property_initialization_in_classes_6187","Enable strict checking of property initialization in classes."),Numeric_separators_are_not_allowed_here:t(6188,e.DiagnosticCategory.Error,"Numeric_separators_are_not_allowed_here_6188","Numeric separators are not allowed here."),Multiple_consecutive_numeric_separators_are_not_permitted:t(6189,e.DiagnosticCategory.Error,"Multiple_consecutive_numeric_separators_are_not_permitted_6189","Multiple consecutive numeric separators are not permitted."),Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen:t(6191,e.DiagnosticCategory.Message,"Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen_6191","Whether to keep outdated console output in watch mode instead of clearing the screen."),All_imports_in_import_declaration_are_unused:t(6192,e.DiagnosticCategory.Error,"All_imports_in_import_declaration_are_unused_6192","All imports in import declaration are unused.",!0),Found_1_error_Watching_for_file_changes:t(6193,e.DiagnosticCategory.Message,"Found_1_error_Watching_for_file_changes_6193","Found 1 error. Watching for file changes."),Found_0_errors_Watching_for_file_changes:t(6194,e.DiagnosticCategory.Message,"Found_0_errors_Watching_for_file_changes_6194","Found {0} errors. Watching for file changes."),Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols:t(6195,e.DiagnosticCategory.Message,"Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols_6195","Resolve 'keyof' to string valued property names only (no numbers or symbols)."),_0_is_declared_but_never_used:t(6196,e.DiagnosticCategory.Error,"_0_is_declared_but_never_used_6196","'{0}' is declared but never used.",!0),Include_modules_imported_with_json_extension:t(6197,e.DiagnosticCategory.Message,"Include_modules_imported_with_json_extension_6197","Include modules imported with '.json' extension"),All_destructured_elements_are_unused:t(6198,e.DiagnosticCategory.Error,"All_destructured_elements_are_unused_6198","All destructured elements are unused.",!0),All_variables_are_unused:t(6199,e.DiagnosticCategory.Error,"All_variables_are_unused_6199","All variables are unused.",!0),Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0:t(6200,e.DiagnosticCategory.Error,"Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0_6200","Definitions of the following identifiers conflict with those in another file: {0}"),Conflicts_are_in_this_file:t(6201,e.DiagnosticCategory.Message,"Conflicts_are_in_this_file_6201","Conflicts are in this file."),_0_was_also_declared_here:t(6203,e.DiagnosticCategory.Message,"_0_was_also_declared_here_6203","'{0}' was also declared here."),and_here:t(6204,e.DiagnosticCategory.Message,"and_here_6204","and here."),All_type_parameters_are_unused:t(6205,e.DiagnosticCategory.Error,"All_type_parameters_are_unused_6205","All type parameters are unused"),package_json_has_a_typesVersions_field_with_version_specific_path_mappings:t(6206,e.DiagnosticCategory.Message,"package_json_has_a_typesVersions_field_with_version_specific_path_mappings_6206","'package.json' has a 'typesVersions' field with version-specific path mappings."),package_json_does_not_have_a_typesVersions_entry_that_matches_version_0:t(6207,e.DiagnosticCategory.Message,"package_json_does_not_have_a_typesVersions_entry_that_matches_version_0_6207","'package.json' does not have a 'typesVersions' entry that matches version '{0}'."),package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2:t(6208,e.DiagnosticCategory.Message,"package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_ma_6208","'package.json' has a 'typesVersions' entry '{0}' that matches compiler version '{1}', looking for a pattern to match module name '{2}'."),package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range:t(6209,e.DiagnosticCategory.Message,"package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range_6209","'package.json' has a 'typesVersions' entry '{0}' that is not a valid semver range."),An_argument_for_0_was_not_provided:t(6210,e.DiagnosticCategory.Message,"An_argument_for_0_was_not_provided_6210","An argument for '{0}' was not provided."),An_argument_matching_this_binding_pattern_was_not_provided:t(6211,e.DiagnosticCategory.Message,"An_argument_matching_this_binding_pattern_was_not_provided_6211","An argument matching this binding pattern was not provided."),Did_you_mean_to_call_this_expression:t(6212,e.DiagnosticCategory.Message,"Did_you_mean_to_call_this_expression_6212","Did you mean to call this expression?"),Did_you_mean_to_use_new_with_this_expression:t(6213,e.DiagnosticCategory.Message,"Did_you_mean_to_use_new_with_this_expression_6213","Did you mean to use 'new' with this expression?"),Enable_strict_bind_call_and_apply_methods_on_functions:t(6214,e.DiagnosticCategory.Message,"Enable_strict_bind_call_and_apply_methods_on_functions_6214","Enable strict 'bind', 'call', and 'apply' methods on functions."),Using_compiler_options_of_project_reference_redirect_0:t(6215,e.DiagnosticCategory.Message,"Using_compiler_options_of_project_reference_redirect_0_6215","Using compiler options of project reference redirect '{0}'."),Found_1_error:t(6216,e.DiagnosticCategory.Message,"Found_1_error_6216","Found 1 error."),Found_0_errors:t(6217,e.DiagnosticCategory.Message,"Found_0_errors_6217","Found {0} errors."),Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2:t(6218,e.DiagnosticCategory.Message,"Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2_6218","======== Module name '{0}' was successfully resolved to '{1}' with Package ID '{2}'. ========"),Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3:t(6219,e.DiagnosticCategory.Message,"Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3_6219","======== Type reference directive '{0}' was successfully resolved to '{1}' with Package ID '{2}', primary: {3}. ========"),package_json_had_a_falsy_0_field:t(6220,e.DiagnosticCategory.Message,"package_json_had_a_falsy_0_field_6220","'package.json' had a falsy '{0}' field."),Projects_to_reference:t(6300,e.DiagnosticCategory.Message,"Projects_to_reference_6300","Projects to reference"),Enable_project_compilation:t(6302,e.DiagnosticCategory.Message,"Enable_project_compilation_6302","Enable project compilation"),Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0:t(6202,e.DiagnosticCategory.Error,"Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0_6202","Project references may not form a circular graph. Cycle detected: {0}"),Composite_projects_may_not_disable_declaration_emit:t(6304,e.DiagnosticCategory.Error,"Composite_projects_may_not_disable_declaration_emit_6304","Composite projects may not disable declaration emit."),Output_file_0_has_not_been_built_from_source_file_1:t(6305,e.DiagnosticCategory.Error,"Output_file_0_has_not_been_built_from_source_file_1_6305","Output file '{0}' has not been built from source file '{1}'."),Referenced_project_0_must_have_setting_composite_Colon_true:t(6306,e.DiagnosticCategory.Error,"Referenced_project_0_must_have_setting_composite_Colon_true_6306","Referenced project '{0}' must have setting \"composite\": true."),File_0_is_not_in_project_file_list_Projects_must_list_all_files_or_use_an_include_pattern:t(6307,e.DiagnosticCategory.Error,"File_0_is_not_in_project_file_list_Projects_must_list_all_files_or_use_an_include_pattern_6307","File '{0}' is not in project file list. Projects must list all files or use an 'include' pattern."),Cannot_prepend_project_0_because_it_does_not_have_outFile_set:t(6308,e.DiagnosticCategory.Error,"Cannot_prepend_project_0_because_it_does_not_have_outFile_set_6308","Cannot prepend project '{0}' because it does not have 'outFile' set"),Output_file_0_from_project_1_does_not_exist:t(6309,e.DiagnosticCategory.Error,"Output_file_0_from_project_1_does_not_exist_6309","Output file '{0}' from project '{1}' does not exist"),Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2:t(6350,e.DiagnosticCategory.Message,"Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2_6350","Project '{0}' is out of date because oldest output '{1}' is older than newest input '{2}'"),Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2:t(6351,e.DiagnosticCategory.Message,"Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2_6351","Project '{0}' is up to date because newest input '{1}' is older than oldest output '{2}'"),Project_0_is_out_of_date_because_output_file_1_does_not_exist:t(6352,e.DiagnosticCategory.Message,"Project_0_is_out_of_date_because_output_file_1_does_not_exist_6352","Project '{0}' is out of date because output file '{1}' does not exist"),Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date:t(6353,e.DiagnosticCategory.Message,"Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date_6353","Project '{0}' is out of date because its dependency '{1}' is out of date"),Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies:t(6354,e.DiagnosticCategory.Message,"Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies_6354","Project '{0}' is up to date with .d.ts files from its dependencies"),Projects_in_this_build_Colon_0:t(6355,e.DiagnosticCategory.Message,"Projects_in_this_build_Colon_0_6355","Projects in this build: {0}"),A_non_dry_build_would_delete_the_following_files_Colon_0:t(6356,e.DiagnosticCategory.Message,"A_non_dry_build_would_delete_the_following_files_Colon_0_6356","A non-dry build would delete the following files: {0}"),A_non_dry_build_would_build_project_0:t(6357,e.DiagnosticCategory.Message,"A_non_dry_build_would_build_project_0_6357","A non-dry build would build project '{0}'"),Building_project_0:t(6358,e.DiagnosticCategory.Message,"Building_project_0_6358","Building project '{0}'..."),Updating_output_timestamps_of_project_0:t(6359,e.DiagnosticCategory.Message,"Updating_output_timestamps_of_project_0_6359","Updating output timestamps of project '{0}'..."),delete_this_Project_0_is_up_to_date_because_it_was_previously_built:t(6360,e.DiagnosticCategory.Message,"delete_this_Project_0_is_up_to_date_because_it_was_previously_built_6360","delete this - Project '{0}' is up to date because it was previously built"),Project_0_is_up_to_date:t(6361,e.DiagnosticCategory.Message,"Project_0_is_up_to_date_6361","Project '{0}' is up to date"),Skipping_build_of_project_0_because_its_dependency_1_has_errors:t(6362,e.DiagnosticCategory.Message,"Skipping_build_of_project_0_because_its_dependency_1_has_errors_6362","Skipping build of project '{0}' because its dependency '{1}' has errors"),Project_0_can_t_be_built_because_its_dependency_1_has_errors:t(6363,e.DiagnosticCategory.Message,"Project_0_can_t_be_built_because_its_dependency_1_has_errors_6363","Project '{0}' can't be built because its dependency '{1}' has errors"),Build_one_or_more_projects_and_their_dependencies_if_out_of_date:t(6364,e.DiagnosticCategory.Message,"Build_one_or_more_projects_and_their_dependencies_if_out_of_date_6364","Build one or more projects and their dependencies, if out of date"),Delete_the_outputs_of_all_projects:t(6365,e.DiagnosticCategory.Message,"Delete_the_outputs_of_all_projects_6365","Delete the outputs of all projects"),Enable_verbose_logging:t(6366,e.DiagnosticCategory.Message,"Enable_verbose_logging_6366","Enable verbose logging"),Show_what_would_be_built_or_deleted_if_specified_with_clean:t(6367,e.DiagnosticCategory.Message,"Show_what_would_be_built_or_deleted_if_specified_with_clean_6367","Show what would be built (or deleted, if specified with '--clean')"),Build_all_projects_including_those_that_appear_to_be_up_to_date:t(6368,e.DiagnosticCategory.Message,"Build_all_projects_including_those_that_appear_to_be_up_to_date_6368","Build all projects, including those that appear to be up to date"),Option_build_must_be_the_first_command_line_argument:t(6369,e.DiagnosticCategory.Error,"Option_build_must_be_the_first_command_line_argument_6369","Option '--build' must be the first command line argument."),Options_0_and_1_cannot_be_combined:t(6370,e.DiagnosticCategory.Error,"Options_0_and_1_cannot_be_combined_6370","Options '{0}' and '{1}' cannot be combined."),Updating_unchanged_output_timestamps_of_project_0:t(6371,e.DiagnosticCategory.Message,"Updating_unchanged_output_timestamps_of_project_0_6371","Updating unchanged output timestamps of project '{0}'..."),Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed:t(6372,e.DiagnosticCategory.Message,"Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed_6372","Project '{0}' is out of date because output of its dependency '{1}' has changed"),Updating_output_of_project_0:t(6373,e.DiagnosticCategory.Message,"Updating_output_of_project_0_6373","Updating output of project '{0}'..."),A_non_dry_build_would_update_timestamps_for_output_of_project_0:t(6374,e.DiagnosticCategory.Message,"A_non_dry_build_would_update_timestamps_for_output_of_project_0_6374","A non-dry build would update timestamps for output of project '{0}'"),A_non_dry_build_would_update_output_of_project_0:t(6375,e.DiagnosticCategory.Message,"A_non_dry_build_would_update_output_of_project_0_6375","A non-dry build would update output of project '{0}'"),Cannot_update_output_of_project_0_because_there_was_error_reading_file_1:t(6376,e.DiagnosticCategory.Message,"Cannot_update_output_of_project_0_because_there_was_error_reading_file_1_6376","Cannot update output of project '{0}' because there was error reading file '{1}'"),Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1:t(6377,e.DiagnosticCategory.Error,"Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1_6377","Cannot write file '{0}' because it will overwrite '.tsbuildinfo' file generated by referenced project '{1}'"),Enable_incremental_compilation:t(6378,e.DiagnosticCategory.Message,"Enable_incremental_compilation_6378","Enable incremental compilation"),Composite_projects_may_not_disable_incremental_compilation:t(6379,e.DiagnosticCategory.Error,"Composite_projects_may_not_disable_incremental_compilation_6379","Composite projects may not disable incremental compilation."),Specify_file_to_store_incremental_compilation_information:t(6380,e.DiagnosticCategory.Message,"Specify_file_to_store_incremental_compilation_information_6380","Specify file to store incremental compilation information"),Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2:t(6381,e.DiagnosticCategory.Message,"Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_curren_6381","Project '{0}' is out of date because output for it was generated with version '{1}' that differs with current version '{2}'"),The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1:t(6500,e.DiagnosticCategory.Message,"The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1_6500","The expected type comes from property '{0}' which is declared here on type '{1}'"),The_expected_type_comes_from_this_index_signature:t(6501,e.DiagnosticCategory.Message,"The_expected_type_comes_from_this_index_signature_6501","The expected type comes from this index signature."),The_expected_type_comes_from_the_return_type_of_this_signature:t(6502,e.DiagnosticCategory.Message,"The_expected_type_comes_from_the_return_type_of_this_signature_6502","The expected type comes from the return type of this signature."),Variable_0_implicitly_has_an_1_type:t(7005,e.DiagnosticCategory.Error,"Variable_0_implicitly_has_an_1_type_7005","Variable '{0}' implicitly has an '{1}' type."),Parameter_0_implicitly_has_an_1_type:t(7006,e.DiagnosticCategory.Error,"Parameter_0_implicitly_has_an_1_type_7006","Parameter '{0}' implicitly has an '{1}' type."),Member_0_implicitly_has_an_1_type:t(7008,e.DiagnosticCategory.Error,"Member_0_implicitly_has_an_1_type_7008","Member '{0}' implicitly has an '{1}' type."),new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type:t(7009,e.DiagnosticCategory.Error,"new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type_7009","'new' expression, whose target lacks a construct signature, implicitly has an 'any' type."),_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type:t(7010,e.DiagnosticCategory.Error,"_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type_7010","'{0}', which lacks return-type annotation, implicitly has an '{1}' return type."),Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type:t(7011,e.DiagnosticCategory.Error,"Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7011","Function expression, which lacks return-type annotation, implicitly has an '{0}' return type."),Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type:t(7013,e.DiagnosticCategory.Error,"Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7013","Construct signature, which lacks return-type annotation, implicitly has an 'any' return type."),Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type:t(7014,e.DiagnosticCategory.Error,"Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7014","Function type, which lacks return-type annotation, implicitly has an '{0}' return type."),Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number:t(7015,e.DiagnosticCategory.Error,"Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number_7015","Element implicitly has an 'any' type because index expression is not of type 'number'."),Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type:t(7016,e.DiagnosticCategory.Error,"Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type_7016","Could not find a declaration file for module '{0}'. '{1}' implicitly has an 'any' type."),Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature:t(7017,e.DiagnosticCategory.Error,"Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_7017","Element implicitly has an 'any' type because type '{0}' has no index signature."),Object_literal_s_property_0_implicitly_has_an_1_type:t(7018,e.DiagnosticCategory.Error,"Object_literal_s_property_0_implicitly_has_an_1_type_7018","Object literal's property '{0}' implicitly has an '{1}' type."),Rest_parameter_0_implicitly_has_an_any_type:t(7019,e.DiagnosticCategory.Error,"Rest_parameter_0_implicitly_has_an_any_type_7019","Rest parameter '{0}' implicitly has an 'any[]' type."),Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type:t(7020,e.DiagnosticCategory.Error,"Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7020","Call signature, which lacks return-type annotation, implicitly has an 'any' return type."),_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer:t(7022,e.DiagnosticCategory.Error,"_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or__7022","'{0}' implicitly has type 'any' because it does not have a type annotation and is referenced directly or indirectly in its own initializer."),_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions:t(7023,e.DiagnosticCategory.Error,"_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_reference_7023","'{0}' implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions:t(7024,e.DiagnosticCategory.Error,"Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_ref_7024","Function implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),Generator_implicitly_has_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type:t(7025,e.DiagnosticCategory.Error,"Generator_implicitly_has_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_typ_7025","Generator implicitly has type '{0}' because it does not yield any values. Consider supplying a return type."),JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists:t(7026,e.DiagnosticCategory.Error,"JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists_7026","JSX element implicitly has type 'any' because no interface 'JSX.{0}' exists."),Unreachable_code_detected:t(7027,e.DiagnosticCategory.Error,"Unreachable_code_detected_7027","Unreachable code detected.",!0),Unused_label:t(7028,e.DiagnosticCategory.Error,"Unused_label_7028","Unused label.",!0),Fallthrough_case_in_switch:t(7029,e.DiagnosticCategory.Error,"Fallthrough_case_in_switch_7029","Fallthrough case in switch."),Not_all_code_paths_return_a_value:t(7030,e.DiagnosticCategory.Error,"Not_all_code_paths_return_a_value_7030","Not all code paths return a value."),Binding_element_0_implicitly_has_an_1_type:t(7031,e.DiagnosticCategory.Error,"Binding_element_0_implicitly_has_an_1_type_7031","Binding element '{0}' implicitly has an '{1}' type."),Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation:t(7032,e.DiagnosticCategory.Error,"Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation_7032","Property '{0}' implicitly has type 'any', because its set accessor lacks a parameter type annotation."),Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation:t(7033,e.DiagnosticCategory.Error,"Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation_7033","Property '{0}' implicitly has type 'any', because its get accessor lacks a return type annotation."),Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined:t(7034,e.DiagnosticCategory.Error,"Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined_7034","Variable '{0}' implicitly has type '{1}' in some locations where its type cannot be determined."),Try_npm_install_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0:t(7035,e.DiagnosticCategory.Error,"Try_npm_install_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_mod_7035","Try `npm install @types/{1}` if it exists or add a new declaration (.d.ts) file containing `declare module '{0}';`"),Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0:t(7036,e.DiagnosticCategory.Error,"Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0_7036","Dynamic import's specifier must be of type 'string', but here has type '{0}'."),Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for_all_imports_Implies_allowSyntheticDefaultImports:t(7037,e.DiagnosticCategory.Message,"Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for__7037","Enables emit interoperability between CommonJS and ES Modules via creation of namespace objects for all imports. Implies 'allowSyntheticDefaultImports'."),Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead:t(7038,e.DiagnosticCategory.Message,"Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cau_7038","Type originates at this import. A namespace-style import cannot be called or constructed, and will cause a failure at runtime. Consider using a default import or import require here instead."),Mapped_object_type_implicitly_has_an_any_template_type:t(7039,e.DiagnosticCategory.Error,"Mapped_object_type_implicitly_has_an_any_template_type_7039","Mapped object type implicitly has an 'any' template type."),If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1:t(7040,e.DiagnosticCategory.Error,"If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_S_7040","If the '{0}' package actually exposes this module, consider sending a pull request to amend 'https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/{1}`"),The_containing_arrow_function_captures_the_global_value_of_this:t(7041,e.DiagnosticCategory.Error,"The_containing_arrow_function_captures_the_global_value_of_this_7041","The containing arrow function captures the global value of 'this'."),Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used:t(7042,e.DiagnosticCategory.Error,"Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used_7042","Module '{0}' was resolved to '{1}', but '--resolveJsonModule' is not used."),Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage:t(7043,e.DiagnosticCategory.Suggestion,"Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7043","Variable '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage:t(7044,e.DiagnosticCategory.Suggestion,"Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7044","Parameter '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage:t(7045,e.DiagnosticCategory.Suggestion,"Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7045","Member '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage:t(7046,e.DiagnosticCategory.Suggestion,"Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage_7046","Variable '{0}' implicitly has type '{1}' in some locations, but a better type may be inferred from usage."),Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage:t(7047,e.DiagnosticCategory.Suggestion,"Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage_7047","Rest parameter '{0}' implicitly has an 'any[]' type, but a better type may be inferred from usage."),Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage:t(7048,e.DiagnosticCategory.Suggestion,"Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage_7048","Property '{0}' implicitly has type 'any', but a better type for its get accessor may be inferred from usage."),Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage:t(7049,e.DiagnosticCategory.Suggestion,"Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage_7049","Property '{0}' implicitly has type 'any', but a better type for its set accessor may be inferred from usage."),_0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage:t(7050,e.DiagnosticCategory.Suggestion,"_0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage_7050","'{0}' implicitly has an '{1}' return type, but a better type may be inferred from usage."),Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1:t(7051,e.DiagnosticCategory.Error,"Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1_7051","Parameter has a name but no type. Did you mean '{0}: {1}'?"),Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1:t(7052,e.DiagnosticCategory.Error,"Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1_7052","Element implicitly has an 'any' type because type '{0}' has no index signature. Did you mean to call '{1}' ?"),Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1:t(7053,e.DiagnosticCategory.Error,"Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1_7053","Element implicitly has an 'any' type because expression of type '{0}' can't be used to index type '{1}'."),No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1:t(7054,e.DiagnosticCategory.Error,"No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1_7054","No index signature with a parameter of type '{0}' was found on type '{1}'."),You_cannot_rename_this_element:t(8e3,e.DiagnosticCategory.Error,"You_cannot_rename_this_element_8000","You cannot rename this element."),You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library:t(8001,e.DiagnosticCategory.Error,"You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library_8001","You cannot rename elements that are defined in the standard TypeScript library."),import_can_only_be_used_in_a_ts_file:t(8002,e.DiagnosticCategory.Error,"import_can_only_be_used_in_a_ts_file_8002","'import ... =' can only be used in a .ts file."),export_can_only_be_used_in_a_ts_file:t(8003,e.DiagnosticCategory.Error,"export_can_only_be_used_in_a_ts_file_8003","'export=' can only be used in a .ts file."),type_parameter_declarations_can_only_be_used_in_a_ts_file:t(8004,e.DiagnosticCategory.Error,"type_parameter_declarations_can_only_be_used_in_a_ts_file_8004","'type parameter declarations' can only be used in a .ts file."),implements_clauses_can_only_be_used_in_a_ts_file:t(8005,e.DiagnosticCategory.Error,"implements_clauses_can_only_be_used_in_a_ts_file_8005","'implements clauses' can only be used in a .ts file."),interface_declarations_can_only_be_used_in_a_ts_file:t(8006,e.DiagnosticCategory.Error,"interface_declarations_can_only_be_used_in_a_ts_file_8006","'interface declarations' can only be used in a .ts file."),module_declarations_can_only_be_used_in_a_ts_file:t(8007,e.DiagnosticCategory.Error,"module_declarations_can_only_be_used_in_a_ts_file_8007","'module declarations' can only be used in a .ts file."),type_aliases_can_only_be_used_in_a_ts_file:t(8008,e.DiagnosticCategory.Error,"type_aliases_can_only_be_used_in_a_ts_file_8008","'type aliases' can only be used in a .ts file."),_0_can_only_be_used_in_a_ts_file:t(8009,e.DiagnosticCategory.Error,"_0_can_only_be_used_in_a_ts_file_8009","'{0}' can only be used in a .ts file."),types_can_only_be_used_in_a_ts_file:t(8010,e.DiagnosticCategory.Error,"types_can_only_be_used_in_a_ts_file_8010","'types' can only be used in a .ts file."),type_arguments_can_only_be_used_in_a_ts_file:t(8011,e.DiagnosticCategory.Error,"type_arguments_can_only_be_used_in_a_ts_file_8011","'type arguments' can only be used in a .ts file."),parameter_modifiers_can_only_be_used_in_a_ts_file:t(8012,e.DiagnosticCategory.Error,"parameter_modifiers_can_only_be_used_in_a_ts_file_8012","'parameter modifiers' can only be used in a .ts file."),non_null_assertions_can_only_be_used_in_a_ts_file:t(8013,e.DiagnosticCategory.Error,"non_null_assertions_can_only_be_used_in_a_ts_file_8013","'non-null assertions' can only be used in a .ts file."),enum_declarations_can_only_be_used_in_a_ts_file:t(8015,e.DiagnosticCategory.Error,"enum_declarations_can_only_be_used_in_a_ts_file_8015","'enum declarations' can only be used in a .ts file."),type_assertion_expressions_can_only_be_used_in_a_ts_file:t(8016,e.DiagnosticCategory.Error,"type_assertion_expressions_can_only_be_used_in_a_ts_file_8016","'type assertion expressions' can only be used in a .ts file."),Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0:t(8017,e.DiagnosticCategory.Error,"Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0_8017","Octal literal types must use ES2015 syntax. Use the syntax '{0}'."),Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0:t(8018,e.DiagnosticCategory.Error,"Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0_8018","Octal literals are not allowed in enums members initializer. Use the syntax '{0}'."),Report_errors_in_js_files:t(8019,e.DiagnosticCategory.Message,"Report_errors_in_js_files_8019","Report errors in .js files."),JSDoc_types_can_only_be_used_inside_documentation_comments:t(8020,e.DiagnosticCategory.Error,"JSDoc_types_can_only_be_used_inside_documentation_comments_8020","JSDoc types can only be used inside documentation comments."),JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags:t(8021,e.DiagnosticCategory.Error,"JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags_8021","JSDoc '@typedef' tag should either have a type annotation or be followed by '@property' or '@member' tags."),JSDoc_0_is_not_attached_to_a_class:t(8022,e.DiagnosticCategory.Error,"JSDoc_0_is_not_attached_to_a_class_8022","JSDoc '@{0}' is not attached to a class."),JSDoc_0_1_does_not_match_the_extends_2_clause:t(8023,e.DiagnosticCategory.Error,"JSDoc_0_1_does_not_match_the_extends_2_clause_8023","JSDoc '@{0} {1}' does not match the 'extends {2}' clause."),JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name:t(8024,e.DiagnosticCategory.Error,"JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_8024","JSDoc '@param' tag has name '{0}', but there is no parameter with that name."),Class_declarations_cannot_have_more_than_one_augments_or_extends_tag:t(8025,e.DiagnosticCategory.Error,"Class_declarations_cannot_have_more_than_one_augments_or_extends_tag_8025","Class declarations cannot have more than one `@augments` or `@extends` tag."),Expected_0_type_arguments_provide_these_with_an_extends_tag:t(8026,e.DiagnosticCategory.Error,"Expected_0_type_arguments_provide_these_with_an_extends_tag_8026","Expected {0} type arguments; provide these with an '@extends' tag."),Expected_0_1_type_arguments_provide_these_with_an_extends_tag:t(8027,e.DiagnosticCategory.Error,"Expected_0_1_type_arguments_provide_these_with_an_extends_tag_8027","Expected {0}-{1} type arguments; provide these with an '@extends' tag."),JSDoc_may_only_appear_in_the_last_parameter_of_a_signature:t(8028,e.DiagnosticCategory.Error,"JSDoc_may_only_appear_in_the_last_parameter_of_a_signature_8028","JSDoc '...' may only appear in the last parameter of a signature."),JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type:t(8029,e.DiagnosticCategory.Error,"JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_h_8029","JSDoc '@param' tag has name '{0}', but there is no parameter with that name. It would match 'arguments' if it had an array type."),The_type_of_a_function_declaration_must_match_the_function_s_signature:t(8030,e.DiagnosticCategory.Error,"The_type_of_a_function_declaration_must_match_the_function_s_signature_8030","The type of a function declaration must match the function's signature."),You_cannot_rename_a_module_via_a_global_import:t(8031,e.DiagnosticCategory.Error,"You_cannot_rename_a_module_via_a_global_import_8031","You cannot rename a module via a global import."),Qualified_name_0_is_not_allowed_without_a_leading_param_object_1:t(8032,e.DiagnosticCategory.Error,"Qualified_name_0_is_not_allowed_without_a_leading_param_object_1_8032","Qualified name '{0}' is not allowed without a leading '@param {object} {1}'."),Only_identifiers_Slashqualified_names_with_optional_type_arguments_are_currently_supported_in_a_class_extends_clause:t(9002,e.DiagnosticCategory.Error,"Only_identifiers_Slashqualified_names_with_optional_type_arguments_are_currently_supported_in_a_clas_9002","Only identifiers/qualified-names with optional type arguments are currently supported in a class 'extends' clause."),class_expressions_are_not_currently_supported:t(9003,e.DiagnosticCategory.Error,"class_expressions_are_not_currently_supported_9003","'class' expressions are not currently supported."),Language_service_is_disabled:t(9004,e.DiagnosticCategory.Error,"Language_service_is_disabled_9004","Language service is disabled."),JSX_attributes_must_only_be_assigned_a_non_empty_expression:t(17e3,e.DiagnosticCategory.Error,"JSX_attributes_must_only_be_assigned_a_non_empty_expression_17000","JSX attributes must only be assigned a non-empty 'expression'."),JSX_elements_cannot_have_multiple_attributes_with_the_same_name:t(17001,e.DiagnosticCategory.Error,"JSX_elements_cannot_have_multiple_attributes_with_the_same_name_17001","JSX elements cannot have multiple attributes with the same name."),Expected_corresponding_JSX_closing_tag_for_0:t(17002,e.DiagnosticCategory.Error,"Expected_corresponding_JSX_closing_tag_for_0_17002","Expected corresponding JSX closing tag for '{0}'."),JSX_attribute_expected:t(17003,e.DiagnosticCategory.Error,"JSX_attribute_expected_17003","JSX attribute expected."),Cannot_use_JSX_unless_the_jsx_flag_is_provided:t(17004,e.DiagnosticCategory.Error,"Cannot_use_JSX_unless_the_jsx_flag_is_provided_17004","Cannot use JSX unless the '--jsx' flag is provided."),A_constructor_cannot_contain_a_super_call_when_its_class_extends_null:t(17005,e.DiagnosticCategory.Error,"A_constructor_cannot_contain_a_super_call_when_its_class_extends_null_17005","A constructor cannot contain a 'super' call when its class extends 'null'."),An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses:t(17006,e.DiagnosticCategory.Error,"An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_ex_17006","An unary expression with the '{0}' operator is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses:t(17007,e.DiagnosticCategory.Error,"A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Con_17007","A type assertion expression is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),JSX_element_0_has_no_corresponding_closing_tag:t(17008,e.DiagnosticCategory.Error,"JSX_element_0_has_no_corresponding_closing_tag_17008","JSX element '{0}' has no corresponding closing tag."),super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class:t(17009,e.DiagnosticCategory.Error,"super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class_17009","'super' must be called before accessing 'this' in the constructor of a derived class."),Unknown_type_acquisition_option_0:t(17010,e.DiagnosticCategory.Error,"Unknown_type_acquisition_option_0_17010","Unknown type acquisition option '{0}'."),super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class:t(17011,e.DiagnosticCategory.Error,"super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class_17011","'super' must be called before accessing a property of 'super' in the constructor of a derived class."),_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2:t(17012,e.DiagnosticCategory.Error,"_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2_17012","'{0}' is not a valid meta-property for keyword '{1}'. Did you mean '{2}'?"),Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor:t(17013,e.DiagnosticCategory.Error,"Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constru_17013","Meta-property '{0}' is only allowed in the body of a function declaration, function expression, or constructor."),JSX_fragment_has_no_corresponding_closing_tag:t(17014,e.DiagnosticCategory.Error,"JSX_fragment_has_no_corresponding_closing_tag_17014","JSX fragment has no corresponding closing tag."),Expected_corresponding_closing_tag_for_JSX_fragment:t(17015,e.DiagnosticCategory.Error,"Expected_corresponding_closing_tag_for_JSX_fragment_17015","Expected corresponding closing tag for JSX fragment."),JSX_fragment_is_not_supported_when_using_jsxFactory:t(17016,e.DiagnosticCategory.Error,"JSX_fragment_is_not_supported_when_using_jsxFactory_17016","JSX fragment is not supported when using --jsxFactory"),JSX_fragment_is_not_supported_when_using_an_inline_JSX_factory_pragma:t(17017,e.DiagnosticCategory.Error,"JSX_fragment_is_not_supported_when_using_an_inline_JSX_factory_pragma_17017","JSX fragment is not supported when using an inline JSX factory pragma"),Circularity_detected_while_resolving_configuration_Colon_0:t(18e3,e.DiagnosticCategory.Error,"Circularity_detected_while_resolving_configuration_Colon_0_18000","Circularity detected while resolving configuration: {0}"),A_path_in_an_extends_option_must_be_relative_or_rooted_but_0_is_not:t(18001,e.DiagnosticCategory.Error,"A_path_in_an_extends_option_must_be_relative_or_rooted_but_0_is_not_18001","A path in an 'extends' option must be relative or rooted, but '{0}' is not."),The_files_list_in_config_file_0_is_empty:t(18002,e.DiagnosticCategory.Error,"The_files_list_in_config_file_0_is_empty_18002","The 'files' list in config file '{0}' is empty."),No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2:t(18003,e.DiagnosticCategory.Error,"No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2_18003","No inputs were found in config file '{0}'. Specified 'include' paths were '{1}' and 'exclude' paths were '{2}'."),File_is_a_CommonJS_module_it_may_be_converted_to_an_ES6_module:t(80001,e.DiagnosticCategory.Suggestion,"File_is_a_CommonJS_module_it_may_be_converted_to_an_ES6_module_80001","File is a CommonJS module; it may be converted to an ES6 module."),This_constructor_function_may_be_converted_to_a_class_declaration:t(80002,e.DiagnosticCategory.Suggestion,"This_constructor_function_may_be_converted_to_a_class_declaration_80002","This constructor function may be converted to a class declaration."),Import_may_be_converted_to_a_default_import:t(80003,e.DiagnosticCategory.Suggestion,"Import_may_be_converted_to_a_default_import_80003","Import may be converted to a default import."),JSDoc_types_may_be_moved_to_TypeScript_types:t(80004,e.DiagnosticCategory.Suggestion,"JSDoc_types_may_be_moved_to_TypeScript_types_80004","JSDoc types may be moved to TypeScript types."),require_call_may_be_converted_to_an_import:t(80005,e.DiagnosticCategory.Suggestion,"require_call_may_be_converted_to_an_import_80005","'require' call may be converted to an import."),This_may_be_converted_to_an_async_function:t(80006,e.DiagnosticCategory.Suggestion,"This_may_be_converted_to_an_async_function_80006","This may be converted to an async function."),Add_missing_super_call:t(90001,e.DiagnosticCategory.Message,"Add_missing_super_call_90001","Add missing 'super()' call"),Make_super_call_the_first_statement_in_the_constructor:t(90002,e.DiagnosticCategory.Message,"Make_super_call_the_first_statement_in_the_constructor_90002","Make 'super()' call the first statement in the constructor"),Change_extends_to_implements:t(90003,e.DiagnosticCategory.Message,"Change_extends_to_implements_90003","Change 'extends' to 'implements'"),Remove_declaration_for_Colon_0:t(90004,e.DiagnosticCategory.Message,"Remove_declaration_for_Colon_0_90004","Remove declaration for: '{0}'"),Remove_import_from_0:t(90005,e.DiagnosticCategory.Message,"Remove_import_from_0_90005","Remove import from '{0}'"),Implement_interface_0:t(90006,e.DiagnosticCategory.Message,"Implement_interface_0_90006","Implement interface '{0}'"),Implement_inherited_abstract_class:t(90007,e.DiagnosticCategory.Message,"Implement_inherited_abstract_class_90007","Implement inherited abstract class"),Add_0_to_unresolved_variable:t(90008,e.DiagnosticCategory.Message,"Add_0_to_unresolved_variable_90008","Add '{0}.' to unresolved variable"),Remove_destructuring:t(90009,e.DiagnosticCategory.Message,"Remove_destructuring_90009","Remove destructuring"),Remove_variable_statement:t(90010,e.DiagnosticCategory.Message,"Remove_variable_statement_90010","Remove variable statement"),Remove_template_tag:t(90011,e.DiagnosticCategory.Message,"Remove_template_tag_90011","Remove template tag"),Remove_type_parameters:t(90012,e.DiagnosticCategory.Message,"Remove_type_parameters_90012","Remove type parameters"),Import_0_from_module_1:t(90013,e.DiagnosticCategory.Message,"Import_0_from_module_1_90013","Import '{0}' from module \"{1}\""),Change_0_to_1:t(90014,e.DiagnosticCategory.Message,"Change_0_to_1_90014","Change '{0}' to '{1}'"),Add_0_to_existing_import_declaration_from_1:t(90015,e.DiagnosticCategory.Message,"Add_0_to_existing_import_declaration_from_1_90015","Add '{0}' to existing import declaration from \"{1}\""),Declare_property_0:t(90016,e.DiagnosticCategory.Message,"Declare_property_0_90016","Declare property '{0}'"),Add_index_signature_for_property_0:t(90017,e.DiagnosticCategory.Message,"Add_index_signature_for_property_0_90017","Add index signature for property '{0}'"),Disable_checking_for_this_file:t(90018,e.DiagnosticCategory.Message,"Disable_checking_for_this_file_90018","Disable checking for this file"),Ignore_this_error_message:t(90019,e.DiagnosticCategory.Message,"Ignore_this_error_message_90019","Ignore this error message"),Initialize_property_0_in_the_constructor:t(90020,e.DiagnosticCategory.Message,"Initialize_property_0_in_the_constructor_90020","Initialize property '{0}' in the constructor"),Initialize_static_property_0:t(90021,e.DiagnosticCategory.Message,"Initialize_static_property_0_90021","Initialize static property '{0}'"),Change_spelling_to_0:t(90022,e.DiagnosticCategory.Message,"Change_spelling_to_0_90022","Change spelling to '{0}'"),Declare_method_0:t(90023,e.DiagnosticCategory.Message,"Declare_method_0_90023","Declare method '{0}'"),Declare_static_method_0:t(90024,e.DiagnosticCategory.Message,"Declare_static_method_0_90024","Declare static method '{0}'"),Prefix_0_with_an_underscore:t(90025,e.DiagnosticCategory.Message,"Prefix_0_with_an_underscore_90025","Prefix '{0}' with an underscore"),Rewrite_as_the_indexed_access_type_0:t(90026,e.DiagnosticCategory.Message,"Rewrite_as_the_indexed_access_type_0_90026","Rewrite as the indexed access type '{0}'"),Declare_static_property_0:t(90027,e.DiagnosticCategory.Message,"Declare_static_property_0_90027","Declare static property '{0}'"),Call_decorator_expression:t(90028,e.DiagnosticCategory.Message,"Call_decorator_expression_90028","Call decorator expression"),Add_async_modifier_to_containing_function:t(90029,e.DiagnosticCategory.Message,"Add_async_modifier_to_containing_function_90029","Add async modifier to containing function"),Replace_infer_0_with_unknown:t(90030,e.DiagnosticCategory.Message,"Replace_infer_0_with_unknown_90030","Replace 'infer {0}' with 'unknown'"),Replace_all_unused_infer_with_unknown:t(90031,e.DiagnosticCategory.Message,"Replace_all_unused_infer_with_unknown_90031","Replace all unused 'infer' with 'unknown'"),Import_default_0_from_module_1:t(90032,e.DiagnosticCategory.Message,"Import_default_0_from_module_1_90032","Import default '{0}' from module \"{1}\""),Add_default_import_0_to_existing_import_declaration_from_1:t(90033,e.DiagnosticCategory.Message,"Add_default_import_0_to_existing_import_declaration_from_1_90033","Add default import '{0}' to existing import declaration from \"{1}\""),Add_parameter_name:t(90034,e.DiagnosticCategory.Message,"Add_parameter_name_90034","Add parameter name"),Convert_function_to_an_ES2015_class:t(95001,e.DiagnosticCategory.Message,"Convert_function_to_an_ES2015_class_95001","Convert function to an ES2015 class"),Convert_function_0_to_class:t(95002,e.DiagnosticCategory.Message,"Convert_function_0_to_class_95002","Convert function '{0}' to class"),Extract_to_0_in_1:t(95004,e.DiagnosticCategory.Message,"Extract_to_0_in_1_95004","Extract to {0} in {1}"),Extract_function:t(95005,e.DiagnosticCategory.Message,"Extract_function_95005","Extract function"),Extract_constant:t(95006,e.DiagnosticCategory.Message,"Extract_constant_95006","Extract constant"),Extract_to_0_in_enclosing_scope:t(95007,e.DiagnosticCategory.Message,"Extract_to_0_in_enclosing_scope_95007","Extract to {0} in enclosing scope"),Extract_to_0_in_1_scope:t(95008,e.DiagnosticCategory.Message,"Extract_to_0_in_1_scope_95008","Extract to {0} in {1} scope"),Annotate_with_type_from_JSDoc:t(95009,e.DiagnosticCategory.Message,"Annotate_with_type_from_JSDoc_95009","Annotate with type from JSDoc"),Annotate_with_types_from_JSDoc:t(95010,e.DiagnosticCategory.Message,"Annotate_with_types_from_JSDoc_95010","Annotate with types from JSDoc"),Infer_type_of_0_from_usage:t(95011,e.DiagnosticCategory.Message,"Infer_type_of_0_from_usage_95011","Infer type of '{0}' from usage"),Infer_parameter_types_from_usage:t(95012,e.DiagnosticCategory.Message,"Infer_parameter_types_from_usage_95012","Infer parameter types from usage"),Convert_to_default_import:t(95013,e.DiagnosticCategory.Message,"Convert_to_default_import_95013","Convert to default import"),Install_0:t(95014,e.DiagnosticCategory.Message,"Install_0_95014","Install '{0}'"),Replace_import_with_0:t(95015,e.DiagnosticCategory.Message,"Replace_import_with_0_95015","Replace import with '{0}'."),Use_synthetic_default_member:t(95016,e.DiagnosticCategory.Message,"Use_synthetic_default_member_95016","Use synthetic 'default' member."),Convert_to_ES6_module:t(95017,e.DiagnosticCategory.Message,"Convert_to_ES6_module_95017","Convert to ES6 module"),Add_undefined_type_to_property_0:t(95018,e.DiagnosticCategory.Message,"Add_undefined_type_to_property_0_95018","Add 'undefined' type to property '{0}'"),Add_initializer_to_property_0:t(95019,e.DiagnosticCategory.Message,"Add_initializer_to_property_0_95019","Add initializer to property '{0}'"),Add_definite_assignment_assertion_to_property_0:t(95020,e.DiagnosticCategory.Message,"Add_definite_assignment_assertion_to_property_0_95020","Add definite assignment assertion to property '{0}'"),Add_all_missing_members:t(95022,e.DiagnosticCategory.Message,"Add_all_missing_members_95022","Add all missing members"),Infer_all_types_from_usage:t(95023,e.DiagnosticCategory.Message,"Infer_all_types_from_usage_95023","Infer all types from usage"),Delete_all_unused_declarations:t(95024,e.DiagnosticCategory.Message,"Delete_all_unused_declarations_95024","Delete all unused declarations"),Prefix_all_unused_declarations_with_where_possible:t(95025,e.DiagnosticCategory.Message,"Prefix_all_unused_declarations_with_where_possible_95025","Prefix all unused declarations with '_' where possible"),Fix_all_detected_spelling_errors:t(95026,e.DiagnosticCategory.Message,"Fix_all_detected_spelling_errors_95026","Fix all detected spelling errors"),Add_initializers_to_all_uninitialized_properties:t(95027,e.DiagnosticCategory.Message,"Add_initializers_to_all_uninitialized_properties_95027","Add initializers to all uninitialized properties"),Add_definite_assignment_assertions_to_all_uninitialized_properties:t(95028,e.DiagnosticCategory.Message,"Add_definite_assignment_assertions_to_all_uninitialized_properties_95028","Add definite assignment assertions to all uninitialized properties"),Add_undefined_type_to_all_uninitialized_properties:t(95029,e.DiagnosticCategory.Message,"Add_undefined_type_to_all_uninitialized_properties_95029","Add undefined type to all uninitialized properties"),Change_all_jsdoc_style_types_to_TypeScript:t(95030,e.DiagnosticCategory.Message,"Change_all_jsdoc_style_types_to_TypeScript_95030","Change all jsdoc-style types to TypeScript"),Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types:t(95031,e.DiagnosticCategory.Message,"Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types_95031","Change all jsdoc-style types to TypeScript (and add '| undefined' to nullable types)"),Implement_all_unimplemented_interfaces:t(95032,e.DiagnosticCategory.Message,"Implement_all_unimplemented_interfaces_95032","Implement all unimplemented interfaces"),Install_all_missing_types_packages:t(95033,e.DiagnosticCategory.Message,"Install_all_missing_types_packages_95033","Install all missing types packages"),Rewrite_all_as_indexed_access_types:t(95034,e.DiagnosticCategory.Message,"Rewrite_all_as_indexed_access_types_95034","Rewrite all as indexed access types"),Convert_all_to_default_imports:t(95035,e.DiagnosticCategory.Message,"Convert_all_to_default_imports_95035","Convert all to default imports"),Make_all_super_calls_the_first_statement_in_their_constructor:t(95036,e.DiagnosticCategory.Message,"Make_all_super_calls_the_first_statement_in_their_constructor_95036","Make all 'super()' calls the first statement in their constructor"),Add_qualifier_to_all_unresolved_variables_matching_a_member_name:t(95037,e.DiagnosticCategory.Message,"Add_qualifier_to_all_unresolved_variables_matching_a_member_name_95037","Add qualifier to all unresolved variables matching a member name"),Change_all_extended_interfaces_to_implements:t(95038,e.DiagnosticCategory.Message,"Change_all_extended_interfaces_to_implements_95038","Change all extended interfaces to 'implements'"),Add_all_missing_super_calls:t(95039,e.DiagnosticCategory.Message,"Add_all_missing_super_calls_95039","Add all missing super calls"),Implement_all_inherited_abstract_classes:t(95040,e.DiagnosticCategory.Message,"Implement_all_inherited_abstract_classes_95040","Implement all inherited abstract classes"),Add_all_missing_async_modifiers:t(95041,e.DiagnosticCategory.Message,"Add_all_missing_async_modifiers_95041","Add all missing 'async' modifiers"),Add_ts_ignore_to_all_error_messages:t(95042,e.DiagnosticCategory.Message,"Add_ts_ignore_to_all_error_messages_95042","Add '@ts-ignore' to all error messages"),Annotate_everything_with_types_from_JSDoc:t(95043,e.DiagnosticCategory.Message,"Annotate_everything_with_types_from_JSDoc_95043","Annotate everything with types from JSDoc"),Add_to_all_uncalled_decorators:t(95044,e.DiagnosticCategory.Message,"Add_to_all_uncalled_decorators_95044","Add '()' to all uncalled decorators"),Convert_all_constructor_functions_to_classes:t(95045,e.DiagnosticCategory.Message,"Convert_all_constructor_functions_to_classes_95045","Convert all constructor functions to classes"),Generate_get_and_set_accessors:t(95046,e.DiagnosticCategory.Message,"Generate_get_and_set_accessors_95046","Generate 'get' and 'set' accessors"),Convert_require_to_import:t(95047,e.DiagnosticCategory.Message,"Convert_require_to_import_95047","Convert 'require' to 'import'"),Convert_all_require_to_import:t(95048,e.DiagnosticCategory.Message,"Convert_all_require_to_import_95048","Convert all 'require' to 'import'"),Move_to_a_new_file:t(95049,e.DiagnosticCategory.Message,"Move_to_a_new_file_95049","Move to a new file"),Remove_unreachable_code:t(95050,e.DiagnosticCategory.Message,"Remove_unreachable_code_95050","Remove unreachable code"),Remove_all_unreachable_code:t(95051,e.DiagnosticCategory.Message,"Remove_all_unreachable_code_95051","Remove all unreachable code"),Add_missing_typeof:t(95052,e.DiagnosticCategory.Message,"Add_missing_typeof_95052","Add missing 'typeof'"),Remove_unused_label:t(95053,e.DiagnosticCategory.Message,"Remove_unused_label_95053","Remove unused label"),Remove_all_unused_labels:t(95054,e.DiagnosticCategory.Message,"Remove_all_unused_labels_95054","Remove all unused labels"),Convert_0_to_mapped_object_type:t(95055,e.DiagnosticCategory.Message,"Convert_0_to_mapped_object_type_95055","Convert '{0}' to mapped object type"),Convert_namespace_import_to_named_imports:t(95056,e.DiagnosticCategory.Message,"Convert_namespace_import_to_named_imports_95056","Convert namespace import to named imports"),Convert_named_imports_to_namespace_import:t(95057,e.DiagnosticCategory.Message,"Convert_named_imports_to_namespace_import_95057","Convert named imports to namespace import"),Add_or_remove_braces_in_an_arrow_function:t(95058,e.DiagnosticCategory.Message,"Add_or_remove_braces_in_an_arrow_function_95058","Add or remove braces in an arrow function"),Add_braces_to_arrow_function:t(95059,e.DiagnosticCategory.Message,"Add_braces_to_arrow_function_95059","Add braces to arrow function"),Remove_braces_from_arrow_function:t(95060,e.DiagnosticCategory.Message,"Remove_braces_from_arrow_function_95060","Remove braces from arrow function"),Convert_default_export_to_named_export:t(95061,e.DiagnosticCategory.Message,"Convert_default_export_to_named_export_95061","Convert default export to named export"),Convert_named_export_to_default_export:t(95062,e.DiagnosticCategory.Message,"Convert_named_export_to_default_export_95062","Convert named export to default export"),Add_missing_enum_member_0:t(95063,e.DiagnosticCategory.Message,"Add_missing_enum_member_0_95063","Add missing enum member '{0}'"),Add_all_missing_imports:t(95064,e.DiagnosticCategory.Message,"Add_all_missing_imports_95064","Add all missing imports"),Convert_to_async_function:t(95065,e.DiagnosticCategory.Message,"Convert_to_async_function_95065","Convert to async function"),Convert_all_to_async_functions:t(95066,e.DiagnosticCategory.Message,"Convert_all_to_async_functions_95066","Convert all to async functions"),Add_unknown_conversion_for_non_overlapping_types:t(95069,e.DiagnosticCategory.Message,"Add_unknown_conversion_for_non_overlapping_types_95069","Add 'unknown' conversion for non-overlapping types"),Add_unknown_to_all_conversions_of_non_overlapping_types:t(95070,e.DiagnosticCategory.Message,"Add_unknown_to_all_conversions_of_non_overlapping_types_95070","Add 'unknown' to all conversions of non-overlapping types"),Add_missing_new_operator_to_call:t(95071,e.DiagnosticCategory.Message,"Add_missing_new_operator_to_call_95071","Add missing 'new' operator to call"),Add_missing_new_operator_to_all_calls:t(95072,e.DiagnosticCategory.Message,"Add_missing_new_operator_to_all_calls_95072","Add missing 'new' operator to all calls"),Add_names_to_all_parameters_without_names:t(95073,e.DiagnosticCategory.Message,"Add_names_to_all_parameters_without_names_95073","Add names to all parameters without names"),Enable_the_experimentalDecorators_option_in_your_configuration_file:t(95074,e.DiagnosticCategory.Message,"Enable_the_experimentalDecorators_option_in_your_configuration_file_95074","Enable the 'experimentalDecorators' option in your configuration file"),Convert_parameters_to_destructured_object:t(95075,e.DiagnosticCategory.Message,"Convert_parameters_to_destructured_object_95075","Convert parameters to destructured object"),Allow_accessing_UMD_globals_from_modules:t(95076,e.DiagnosticCategory.Message,"Allow_accessing_UMD_globals_from_modules_95076","Allow accessing UMD globals from modules."),Extract_type:t(95077,e.DiagnosticCategory.Message,"Extract_type_95077","Extract type"),Extract_to_type_alias:t(95078,e.DiagnosticCategory.Message,"Extract_to_type_alias_95078","Extract to type alias"),Extract_to_typedef:t(95079,e.DiagnosticCategory.Message,"Extract_to_typedef_95079","Extract to typedef"),No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer:t(18004,e.DiagnosticCategory.Error,"No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer_18004","No value exists in scope for the shorthand property '{0}'. Either declare one or provide an initializer."),Quoted_constructors_have_previously_been_interpreted_as_methods_which_is_incorrect_In_TypeScript_3_6_they_will_be_correctly_parsed_as_constructors_In_the_meantime_consider_using_constructor_to_write_a_constructor_or_constructor_to_write_a_method:t(18005,e.DiagnosticCategory.Error,"Quoted_constructors_have_previously_been_interpreted_as_methods_which_is_incorrect_In_TypeScript_3_6_18005","Quoted constructors have previously been interpreted as methods, which is incorrect. In TypeScript 3.6, they will be correctly parsed as constructors. In the meantime, consider using 'constructor()' to write a constructor, or '[\"constructor\"]()' to write a method."),Classes_may_not_have_a_field_named_constructor:t(18006,e.DiagnosticCategory.Error,"Classes_may_not_have_a_field_named_constructor_18006","Classes may not have a field named 'constructor'.")}
}(n||(n={}));var n;!function(e){function t(e){return e>=73}function r(e){return 30===e||t(e)}function n(e,t){if(e<t[0])return!1;for(var r,n=0,i=t.length;i>n+1;){if(r=n+(i-n)/2,r-=r%2,t[r]<=e&&e<=t[r+1])return!0;e<t[r]?i=r:n=r+2}return!1}function a(e,t){return t>=1?n(e,W):n(e,K)}function o(e,t){return t>=1?n(e,H):n(e,q)}function s(e){var t=[];return e.forEach(function(e,r){t[e]=r}),t}function c(e){return G[e]}function u(e){return U.get(e)}function l(e){for(var t=new Array,r=0,n=0;r<e.length;){var i=e.charCodeAt(r);switch(r++,i){case 13:10===e.charCodeAt(r)&&r++;case 10:t.push(n),n=r;break;default:i>127&&y(i)&&(t.push(n),n=r)}}return t.push(n),t}function _(e,t,r,n){return e.getPositionOfLineAndCharacter?e.getPositionOfLineAndCharacter(t,r,n):d(p(e),t,r,e.text,n)}function d(t,r,n,i,a){(0>r||r>=t.length)&&(a?r=0>r?0:r>=t.length?t.length-1:r:e.Debug.fail("Bad line number. Line: "+r+", lineStarts.length: "+t.length+" , line map is correct? "+(void 0!==i?e.arraysEqual(t,l(i)):"unknown")));var o=t[r]+n;return a?o>t[r+1]?t[r+1]:"string"==typeof i&&o>i.length?i.length:o:(r<t.length-1?e.Debug.assert(o<t[r+1]):void 0!==i&&e.Debug.assert(o<=i.length),o)}function p(e){return e.lineMap||(e.lineMap=l(e.text))}function f(t,r){var n=e.binarySearch(t,r,e.identity,e.compareValues);return 0>n&&(n=~n-1,e.Debug.assert(-1!==n,"position cannot precede the beginning of the file")),{line:n,character:r-t[n]}}function m(e,t){return f(p(e),t)}function g(e){return v(e)||y(e)}function v(e){return 32===e||9===e||11===e||12===e||160===e||133===e||5760===e||e>=8192&&8203>=e||8239===e||8287===e||12288===e||65279===e}function y(e){return 10===e||13===e||8232===e||8233===e}function h(e){return e>=48&&57>=e}function b(e){return e>=48&&55>=e}function x(e,t){var r=e.charCodeAt(t);switch(r){case 13:case 10:case 9:case 11:case 12:case 32:case 47:case 60:case 124:case 61:case 62:return!0;case 35:return 0===t;default:return r>127}}function D(t,r,n,i){if(void 0===i&&(i=!1),e.positionIsSynthesized(r))return r;for(;;){var a=t.charCodeAt(r);switch(a){case 13:10===t.charCodeAt(r+1)&&r++;case 10:if(r++,n)return r;continue;case 9:case 11:case 12:case 32:r++;continue;case 47:if(i)break;if(47===t.charCodeAt(r+1)){for(r+=2;r<t.length&&!y(t.charCodeAt(r));)r++;continue}if(42===t.charCodeAt(r+1)){for(r+=2;r<t.length;){if(42===t.charCodeAt(r)&&47===t.charCodeAt(r+1)){r+=2;break}r++}continue}break;case 60:case 124:case 61:case 62:if(S(t,r)){r=C(t,r);continue}break;case 35:if(0===r&&k(t,r)){r=T(t,r);continue}break;default:if(a>127&&g(a)){r++;continue}}return r}}function S(t,r){if(e.Debug.assert(r>=0),0===r||y(t.charCodeAt(r-1))){var n=t.charCodeAt(r);if(r+Q<t.length){for(var i=0;Q>i;i++)if(t.charCodeAt(r+i)!==n)return!1;return 61===n||32===t.charCodeAt(r+Q)}}return!1}function C(t,r,n){n&&n(e.Diagnostics.Merge_conflict_marker_encountered,r,Q);var i=t.charCodeAt(r),a=t.length;if(60===i||62===i)for(;a>r&&!y(t.charCodeAt(r));)r++;else for(e.Debug.assert(124===i||61===i);a>r;){var o=t.charCodeAt(r);if((61===o||62===o)&&o!==i&&S(t,r))break;r++}return r}function k(t,r){return e.Debug.assert(0===r),X.test(t)}function T(e,t){var r=X.exec(e)[0];return t+=r.length}function E(e,t,r,n,i,a,o){var s,c,u,l,_=!1,d=n,p=o;if(0===r){d=!0;var f=M(t);f&&(r=f.length)}e:for(;r>=0&&r<t.length;){var m=t.charCodeAt(r);switch(m){case 13:10===t.charCodeAt(r+1)&&r++;case 10:if(r++,n)break e;d=!0,_&&(l=!0);continue;case 9:case 11:case 12:case 32:r++;continue;case 47:var v=t.charCodeAt(r+1),h=!1;if(47===v||42===v){var b=47===v?2:3,x=r;if(r+=2,47===v)for(;r<t.length;){if(y(t.charCodeAt(r))){h=!0;break}r++}else for(;r<t.length;){if(42===t.charCodeAt(r)&&47===t.charCodeAt(r+1)){r+=2;break}r++}if(d){if(_&&(p=i(s,c,u,l,a,p),!e&&p))return p;s=x,c=r,u=b,l=h,_=!0}continue}break e;default:if(m>127&&g(m)){_&&y(m)&&(l=!0),r++;continue}break e}}return _&&(p=i(s,c,u,l,a,p)),p}function N(e,t,r,n){return E(!1,e,t,!1,r,n)}function A(e,t,r,n){return E(!1,e,t,!0,r,n)}function F(e,t,r,n,i){return E(!0,e,t,!1,r,n,i)}function P(e,t,r,n,i){return E(!0,e,t,!0,r,n,i)}function w(e,t,r,n,i,a){return a||(a=[]),a.push({kind:r,pos:e,end:t,hasTrailingNewLine:n}),a}function I(e,t){return F(e,t,w,void 0,void 0)}function O(e,t){return P(e,t,w,void 0,void 0)}function M(e){var t=X.exec(e);return t?t[0]:void 0}function L(e,t){return e>=65&&90>=e||e>=97&&122>=e||36===e||95===e||e>127&&a(e,t)}function R(e,t){return e>=65&&90>=e||e>=97&&122>=e||e>=48&&57>=e||36===e||95===e||e>127&&o(e,t)}function B(e,t){if(!L(e.charCodeAt(0),t))return!1;for(var r=1;r<e.length;r++)if(!R(e.charCodeAt(r),t))return!1;return!0}function j(r,n,i,a,o,s,c){function u(e,t,r){if(void 0===t&&(t=st),o){var n=st;st=t,o(e,r||0),st=n}}function l(){for(var t=st,r=!1,n=!1,i="";;){var a=ft.charCodeAt(st);if(95!==a){if(!h(a))break;r=!0,n=!1,st++}else pt|=512,r?(r=!1,n=!0,i+=ft.substring(t,st)):n?u(e.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted,st,1):u(e.Diagnostics.Numeric_separators_are_not_allowed_here,st,1),st++,t=st}return 95===ft.charCodeAt(st-1)&&u(e.Diagnostics.Numeric_separators_are_not_allowed_here,st-1,1),i+ft.substring(t,st)}function _(){var t,r,n=st,i=l();46===ft.charCodeAt(st)&&(st++,t=l());var a=st;if(69===ft.charCodeAt(st)||101===ft.charCodeAt(st)){st++,pt|=16,(43===ft.charCodeAt(st)||45===ft.charCodeAt(st))&&st++;var o=st,s=l();s?(r=ft.substring(a,o)+s,a=st):u(e.Diagnostics.Digit_expected)}var c;if(512&pt?(c=i,t&&(c+="."+t),r&&(c+=r)):c=ft.substring(n,a),void 0!==t||16&pt)return d(n,void 0===t&&!!(16&pt)),{type:8,value:""+ +c};dt=c;var _=B();return d(n),{type:_,value:dt}}function d(t,n){if(L(ft.charCodeAt(st),r)){var i=st,a=I().length;1===a&&"n"===ft[i]?n?u(e.Diagnostics.A_bigint_literal_cannot_use_exponential_notation,t,i-t+1):u(e.Diagnostics.A_bigint_literal_must_be_an_integer,t,i-t+1):(u(e.Diagnostics.An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal,i,a),st=i)}}function p(){for(var e=st;b(ft.charCodeAt(st));)st++;return+ft.substring(e,st)}function f(e,t){var r=x(e,!1,t);return r?parseInt(r,16):-1}function m(e,t){return x(e,!0,t)}function x(t,r,n){for(var i=[],a=!1,o=!1;i.length<t||r;){var s=ft.charCodeAt(st);if(n&&95===s)pt|=512,a?(a=!1,o=!0):o?u(e.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted,st,1):u(e.Diagnostics.Numeric_separators_are_not_allowed_here,st,1),st++;else{if(a=n,s>=65&&70>=s)s+=32;else if(!(s>=48&&57>=s||s>=97&&102>=s))break;i.push(s),st++,o=!1}}return i.length<t&&(i=[]),95===ft.charCodeAt(st-1)&&u(e.Diagnostics.Numeric_separators_are_not_allowed_here,st-1,1),String.fromCharCode.apply(String,i)}function D(t){void 0===t&&(t=!1);var r=ft.charCodeAt(st);st++;for(var n="",i=st;;){if(st>=ct){n+=ft.substring(i,st),pt|=4,u(e.Diagnostics.Unterminated_string_literal);break}var a=ft.charCodeAt(st);if(a===r){n+=ft.substring(i,st),st++;break}if(92!==a||t){if(y(a)&&!t){n+=ft.substring(i,st),pt|=4,u(e.Diagnostics.Unterminated_string_literal);break}st++}else n+=ft.substring(i,st),n+=N(),i=st}return n}function E(){var t=96===ft.charCodeAt(st);st++;for(var r,n=st,i="";;){if(st>=ct){i+=ft.substring(n,st),pt|=4,u(e.Diagnostics.Unterminated_template_literal),r=t?14:17;break}var a=ft.charCodeAt(st);if(96===a){i+=ft.substring(n,st),st++,r=t?14:17;break}if(36===a&&ct>st+1&&123===ft.charCodeAt(st+1)){i+=ft.substring(n,st),st+=2,r=t?15:16;break}92!==a?13!==a?st++:(i+=ft.substring(n,st),st++,ct>st&&10===ft.charCodeAt(st)&&st++,i+="\n",n=st):(i+=ft.substring(n,st),i+=N(),n=st)}return e.Debug.assert(void 0!==r),dt=i,r}function N(){if(st++,st>=ct)return u(e.Diagnostics.Unexpected_end_of_text),"";var t=ft.charCodeAt(st);switch(st++,t){case 48:return"\x00";case 98:return"\b";case 116:return"	";case 110:return"\n";case 118:return"";case 102:return"\f";case 114:return"\r";case 39:return"'";case 34:return'"';case 117:return ct>st&&123===ft.charCodeAt(st)?(pt|=8,st++,F()):A(4);case 120:return A(2);case 13:ct>st&&10===ft.charCodeAt(st)&&st++;case 10:case 8232:case 8233:return"";default:return String.fromCharCode(t)}}function A(t){var r=f(t,!1);return r>=0?String.fromCharCode(r):(u(e.Diagnostics.Hexadecimal_digit_expected),"")}function F(){var t=m(1,!1),r=t?parseInt(t,16):-1,n=!1;return 0>r?(u(e.Diagnostics.Hexadecimal_digit_expected),n=!0):r>1114111&&(u(e.Diagnostics.An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive),n=!0),st>=ct?(u(e.Diagnostics.Unexpected_end_of_text),n=!0):125===ft.charCodeAt(st)?st++:(u(e.Diagnostics.Unterminated_Unicode_escape_sequence),n=!0),n?"":P(r)}function P(t){if(e.Debug.assert(t>=0&&1114111>=t),65535>=t)return String.fromCharCode(t);var r=Math.floor((t-65536)/1024)+55296,n=(t-65536)%1024+56320;return String.fromCharCode(r,n)}function w(){if(ct>st+5&&117===ft.charCodeAt(st+1)){var e=st;st+=2;var t=f(4,!1);return st=e,t}return-1}function I(){for(var e="",t=st;ct>st;){var n=ft.charCodeAt(st);if(R(n,r))st++;else{if(92!==n)break;if(n=w(),!(n>=0&&R(n,r)))break;e+=ft.substring(t,st),e+=String.fromCharCode(n),st+=6,t=st}}return e+=ft.substring(t,st)}function O(){var e=dt.length;if(e>=2&&11>=e){var t=dt.charCodeAt(0);if(t>=97&&122>=t){var r=V.get(dt);if(void 0!==r)return _t=r}}return _t=73}function M(t){for(var r="",n=!1,i=!1;;){var a=ft.charCodeAt(st);if(95!==a){if(n=!0,!h(a)||a-48>=t)break;r+=ft[st],st++,i=!1}else pt|=512,n?(n=!1,i=!0):i?u(e.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted,st,1):u(e.Diagnostics.Numeric_separators_are_not_allowed_here,st,1),st++}return 95===ft.charCodeAt(st-1)&&u(e.Diagnostics.Numeric_separators_are_not_allowed_here,st-1,1),r}function B(){if(110===ft.charCodeAt(st))return dt+="n",384&pt&&(dt=e.parsePseudoBigInt(dt)+"n"),st++,9;var t=128&pt?parseInt(dt.slice(2),2):256&pt?parseInt(dt.slice(2),8):+dt;return dt=""+t,8}function j(){var t;ut=st,pt=0;for(var a=!1;;){if(lt=st,st>=ct)return _t=1;var o=ft.charCodeAt(st);if(35===o&&0===st&&k(ft,st)){if(st=T(ft,st),n)continue;return _t=6}switch(o){case 10:case 13:if(pt|=1,n){st++;continue}return 13===o&&ct>st+1&&10===ft.charCodeAt(st+1)?st+=2:st++,_t=4;case 9:case 11:case 12:case 32:case 160:case 5760:case 8192:case 8193:case 8194:case 8195:case 8196:case 8197:case 8198:case 8199:case 8200:case 8201:case 8202:case 8203:case 8239:case 8287:case 12288:case 65279:if(n){st++;continue}for(;ct>st&&v(ft.charCodeAt(st));)st++;return _t=5;case 33:return 61===ft.charCodeAt(st+1)?61===ft.charCodeAt(st+2)?(st+=3,_t=36):(st+=2,_t=34):(st++,_t=52);case 34:case 39:return dt=D(),_t=10;case 96:return _t=E();case 37:return 61===ft.charCodeAt(st+1)?(st+=2,_t=66):(st++,_t=43);case 38:return 38===ft.charCodeAt(st+1)?(st+=2,_t=54):61===ft.charCodeAt(st+1)?(st+=2,_t=70):(st++,_t=49);case 40:return st++,_t=20;case 41:return st++,_t=21;case 42:if(61===ft.charCodeAt(st+1))return st+=2,_t=63;if(42===ft.charCodeAt(st+1))return 61===ft.charCodeAt(st+2)?(st+=3,_t=64):(st+=2,_t=41);if(st++,mt&&!a&&1&pt){a=!0;continue}return _t=40;case 43:return 43===ft.charCodeAt(st+1)?(st+=2,_t=44):61===ft.charCodeAt(st+1)?(st+=2,_t=61):(st++,_t=38);case 44:return st++,_t=27;case 45:return 45===ft.charCodeAt(st+1)?(st+=2,_t=45):61===ft.charCodeAt(st+1)?(st+=2,_t=62):(st++,_t=39);case 46:return h(ft.charCodeAt(st+1))?(dt=_().value,_t=8):46===ft.charCodeAt(st+1)&&46===ft.charCodeAt(st+2)?(st+=3,_t=25):(st++,_t=24);case 47:if(47===ft.charCodeAt(st+1)){for(st+=2;ct>st&&!y(ft.charCodeAt(st));)st++;if(n)continue;return _t=2}if(42===ft.charCodeAt(st+1)){st+=2,42===ft.charCodeAt(st)&&47!==ft.charCodeAt(st+1)&&(pt|=2);for(var s=!1;ct>st;){var c=ft.charCodeAt(st);if(42===c&&47===ft.charCodeAt(st+1)){st+=2,s=!0;break}y(c)&&(pt|=1),st++}if(s||u(e.Diagnostics.Asterisk_Slash_expected),n)continue;return s||(pt|=4),_t=3}return 61===ft.charCodeAt(st+1)?(st+=2,_t=65):(st++,_t=42);case 48:if(ct>st+2&&(88===ft.charCodeAt(st+1)||120===ft.charCodeAt(st+1)))return st+=2,dt=m(1,!0),dt||(u(e.Diagnostics.Hexadecimal_digit_expected),dt="0"),dt="0x"+dt,pt|=64,_t=B();if(ct>st+2&&(66===ft.charCodeAt(st+1)||98===ft.charCodeAt(st+1)))return st+=2,dt=M(2),dt||(u(e.Diagnostics.Binary_digit_expected),dt="0"),dt="0b"+dt,pt|=128,_t=B();if(ct>st+2&&(79===ft.charCodeAt(st+1)||111===ft.charCodeAt(st+1)))return st+=2,dt=M(8),dt||(u(e.Diagnostics.Octal_digit_expected),dt="0"),dt="0o"+dt,pt|=256,_t=B();if(ct>st+1&&b(ft.charCodeAt(st+1)))return dt=""+p(),pt|=32,_t=8;case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t=_(),_t=t.type,dt=t.value,_t;case 58:return st++,_t=57;case 59:return st++,_t=26;case 60:if(S(ft,st)){if(st=C(ft,st,u),n)continue;return _t=7}return 60===ft.charCodeAt(st+1)?61===ft.charCodeAt(st+2)?(st+=3,_t=67):(st+=2,_t=46):61===ft.charCodeAt(st+1)?(st+=2,_t=31):1===i&&47===ft.charCodeAt(st+1)&&42!==ft.charCodeAt(st+2)?(st+=2,_t=29):(st++,_t=28);case 61:if(S(ft,st)){if(st=C(ft,st,u),n)continue;return _t=7}return 61===ft.charCodeAt(st+1)?61===ft.charCodeAt(st+2)?(st+=3,_t=35):(st+=2,_t=33):62===ft.charCodeAt(st+1)?(st+=2,_t=37):(st++,_t=60);case 62:if(S(ft,st)){if(st=C(ft,st,u),n)continue;return _t=7}return st++,_t=30;case 63:return st++,_t=56;case 91:return st++,_t=22;case 93:return st++,_t=23;case 94:return 61===ft.charCodeAt(st+1)?(st+=2,_t=72):(st++,_t=51);case 123:return st++,_t=18;case 124:if(S(ft,st)){if(st=C(ft,st,u),n)continue;return _t=7}return 124===ft.charCodeAt(st+1)?(st+=2,_t=55):61===ft.charCodeAt(st+1)?(st+=2,_t=71):(st++,_t=50);case 125:return st++,_t=19;case 126:return st++,_t=53;case 64:return st++,_t=58;case 92:var l=w();return l>=0&&L(l,r)?(st+=6,dt=String.fromCharCode(l)+I(),_t=O()):(u(e.Diagnostics.Invalid_character),st++,_t=0);default:if(L(o,r)){for(st++;ct>st&&R(o=ft.charCodeAt(st),r);)st++;return dt=ft.substring(lt,st),92===o&&(dt+=I()),_t=O()}if(v(o)){st++;continue}if(y(o)){pt|=1,st++;continue}return u(e.Diagnostics.Invalid_character),st++,_t=0}}}function J(){if(30===_t){if(62===ft.charCodeAt(st))return 62===ft.charCodeAt(st+1)?61===ft.charCodeAt(st+2)?(st+=3,_t=69):(st+=2,_t=48):61===ft.charCodeAt(st+1)?(st+=2,_t=68):(st++,_t=47);if(61===ft.charCodeAt(st))return st++,_t=32}return _t}function z(){if(42===_t||65===_t){for(var t=lt+1,n=!1,i=!1;;){if(t>=ct){pt|=4,u(e.Diagnostics.Unterminated_regular_expression_literal);break}var a=ft.charCodeAt(t);if(y(a)){pt|=4,u(e.Diagnostics.Unterminated_regular_expression_literal);break}if(n)n=!1;else{if(47===a&&!i){t++;break}91===a?i=!0:92===a?n=!0:93===a&&(i=!1)}t++}for(;ct>t&&R(ft.charCodeAt(t),r);)t++;st=t,dt=ft.substring(lt,st),_t=13}return _t}function U(){return e.Debug.assert(19===_t,"'reScanTemplateToken' should only be called on a '}'"),st=lt,_t=E()}function K(){return st=lt=ut,_t=W()}function q(){return 46===_t?(st=lt+1,_t=28):_t}function W(){if(ut=lt=st,st>=ct)return _t=1;var e=ft.charCodeAt(st);if(60===e)return 47===ft.charCodeAt(st+1)?(st+=2,_t=29):(st++,_t=28);if(123===e)return st++,_t=18;for(var t=0;ct>st&&(e=ft.charCodeAt(st),123!==e);){if(60===e){if(S(ft,st))return st=C(ft,st,u),_t=7;break}y(e)&&0===t?t=-1:g(e)||(t=st),st++}return dt=ft.substring(ut,st),-1===t?12:11}function H(){if(t(_t)){for(var e=st;ct>st;){var n=ft.charCodeAt(st);if(45!==n&&(e===st?!L(n,r):!R(n,r)))break;st++}dt+=ft.substring(e,st)}return _t}function G(){switch(ut=st,ft.charCodeAt(st)){case 34:case 39:return dt=D(!0),_t=10;default:return j()}}function Q(){if(ut=lt=st,pt=0,st>=ct)return _t=1;var e=ft.charCodeAt(st);switch(st++,e){case 9:case 11:case 12:case 32:for(;ct>st&&v(ft.charCodeAt(st));)st++;return _t=5;case 64:return _t=58;case 10:case 13:return pt|=1,_t=4;case 42:return _t=40;case 123:return _t=18;case 125:return _t=19;case 91:return _t=22;case 93:return _t=23;case 60:return _t=28;case 61:return _t=60;case 44:return _t=27;case 46:return _t=24;case 96:return _t=59}if(L(e,8)){for(;R(ft.charCodeAt(st),8)&&ct>st;)st++;return dt=ft.substring(lt,st),_t=O()}return _t=0}function X(e,t){var r=st,n=ut,i=lt,a=_t,o=dt,s=pt,c=e();return(!c||t)&&(st=r,ut=n,lt=i,_t=a,dt=o,pt=s),c}function Y(e,t,r){var n=ct,i=st,a=ut,o=lt,s=_t,c=dt,u=pt;tt(ft,e,t);var l=r();return ct=n,st=i,ut=a,lt=o,_t=s,dt=c,pt=u,l}function Z(e){return X(e,!0)}function $(e){return X(e,!1)}function et(){return ft}function tt(e,t,r){ft=e||"",ct=void 0===r?ft.length:t+r,at(t||0)}function rt(e){o=e}function nt(e){r=e}function it(e){i=e}function at(t){e.Debug.assert(t>=0),st=t,ut=t,lt=t,_t=0,dt=void 0,pt=0}function ot(e){mt+=e?1:-1}void 0===i&&(i=0);var st,ct,ut,lt,_t,dt,pt,ft=a,mt=0;return tt(ft,s,c),{getStartPos:function(){return ut},getTextPos:function(){return st},getToken:function(){return _t},getTokenPos:function(){return lt},getTokenText:function(){return ft.substring(lt,st)},getTokenValue:function(){return dt},hasExtendedUnicodeEscape:function(){return 0!==(8&pt)},hasPrecedingLineBreak:function(){return 0!==(1&pt)},isIdentifier:function(){return 73===_t||_t>109},isReservedWord:function(){return _t>=74&&109>=_t},isUnterminated:function(){return 0!==(4&pt)},getTokenFlags:function(){return pt},reScanGreaterToken:J,reScanSlashToken:z,reScanTemplateToken:U,scanJsxIdentifier:H,scanJsxAttributeValue:G,reScanJsxToken:K,reScanLessThanToken:q,scanJsxToken:W,scanJsDocToken:Q,scan:j,getText:et,setText:tt,setScriptTarget:nt,setLanguageVariant:it,setOnError:rt,setTextPos:at,setInJSDocType:ot,tryScan:$,lookAhead:Z,scanRange:Y}}var J;e.tokenIsIdentifierOrKeyword=t,e.tokenIsIdentifierOrKeywordOrGreaterThan=r;var z=(J={"abstract":119,any:121,as:120,bigint:147,"boolean":124,"break":74,"case":75,"catch":76,"class":77,"continue":79,"const":78},J.constructor=125,J.debugger=80,J.declare=126,J.default=81,J.delete=82,J.do=83,J.else=84,J.enum=85,J.export=86,J.extends=87,J.false=88,J.finally=89,J.for=90,J.from=145,J.function=91,J.get=127,J.if=92,J.implements=110,J.import=93,J.in=94,J.infer=128,J.instanceof=95,J.interface=111,J.is=129,J.keyof=130,J.let=112,J.module=131,J.namespace=132,J.never=133,J.new=96,J.null=97,J.number=136,J.object=137,J.package=113,J.private=114,J.protected=115,J.public=116,J.readonly=134,J.require=135,J.global=146,J.return=98,J.set=138,J.static=117,J.string=139,J.super=99,J.switch=100,J.symbol=140,J.this=101,J.throw=102,J.true=103,J.try=104,J.type=141,J.typeof=105,J.undefined=142,J.unique=143,J.unknown=144,J.var=106,J.void=107,J.while=108,J.with=109,J.yield=118,J.async=122,J.await=123,J.of=148,J),V=e.createMapFromTemplate(z),U=e.createMapFromTemplate(i({},z,{"{":18,"}":19,"(":20,")":21,"[":22,"]":23,".":24,"...":25,";":26,",":27,"<":28,">":30,"<=":31,">=":32,"==":33,"!=":34,"===":35,"!==":36,"=>":37,"+":38,"-":39,"**":41,"*":40,"/":42,"%":43,"++":44,"--":45,"<<":46,"</":29,">>":47,">>>":48,"&":49,"|":50,"^":51,"!":52,"~":53,"&&":54,"||":55,"?":56,":":57,"=":60,"+=":61,"-=":62,"*=":63,"**=":64,"/=":65,"%=":66,"<<=":67,">>=":68,">>>=":69,"&=":70,"|=":71,"^=":72,"@":58})),K=[170,170,181,181,186,186,192,214,216,246,248,543,546,563,592,685,688,696,699,705,720,721,736,740,750,750,890,890,902,902,904,906,908,908,910,929,931,974,976,983,986,1011,1024,1153,1164,1220,1223,1224,1227,1228,1232,1269,1272,1273,1329,1366,1369,1369,1377,1415,1488,1514,1520,1522,1569,1594,1600,1610,1649,1747,1749,1749,1765,1766,1786,1788,1808,1808,1810,1836,1920,1957,2309,2361,2365,2365,2384,2384,2392,2401,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2524,2525,2527,2529,2544,2545,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2649,2652,2654,2654,2674,2676,2693,2699,2701,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2749,2749,2768,2768,2784,2784,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2870,2873,2877,2877,2908,2909,2911,2913,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,2997,2999,3001,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3168,3169,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3294,3294,3296,3297,3333,3340,3342,3344,3346,3368,3370,3385,3424,3425,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3585,3632,3634,3635,3648,3654,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3760,3762,3763,3773,3773,3776,3780,3782,3782,3804,3805,3840,3840,3904,3911,3913,3946,3976,3979,4096,4129,4131,4135,4137,4138,4176,4181,4256,4293,4304,4342,4352,4441,4447,4514,4520,4601,4608,4614,4616,4678,4680,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4742,4744,4744,4746,4749,4752,4782,4784,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4814,4816,4822,4824,4846,4848,4878,4880,4880,4882,4885,4888,4894,4896,4934,4936,4954,5024,5108,5121,5740,5743,5750,5761,5786,5792,5866,6016,6067,6176,6263,6272,6312,7680,7835,7840,7929,7936,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8319,8319,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8497,8499,8505,8544,8579,12293,12295,12321,12329,12337,12341,12344,12346,12353,12436,12445,12446,12449,12538,12540,12542,12549,12588,12593,12686,12704,12727,13312,19893,19968,40869,40960,42124,44032,55203,63744,64045,64256,64262,64275,64279,64285,64285,64287,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65136,65138,65140,65140,65142,65276,65313,65338,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500],q=[170,170,181,181,186,186,192,214,216,246,248,543,546,563,592,685,688,696,699,705,720,721,736,740,750,750,768,846,864,866,890,890,902,902,904,906,908,908,910,929,931,974,976,983,986,1011,1024,1153,1155,1158,1164,1220,1223,1224,1227,1228,1232,1269,1272,1273,1329,1366,1369,1369,1377,1415,1425,1441,1443,1465,1467,1469,1471,1471,1473,1474,1476,1476,1488,1514,1520,1522,1569,1594,1600,1621,1632,1641,1648,1747,1749,1756,1759,1768,1770,1773,1776,1788,1808,1836,1840,1866,1920,1968,2305,2307,2309,2361,2364,2381,2384,2388,2392,2403,2406,2415,2433,2435,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2492,2492,2494,2500,2503,2504,2507,2509,2519,2519,2524,2525,2527,2531,2534,2545,2562,2562,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2620,2620,2622,2626,2631,2632,2635,2637,2649,2652,2654,2654,2662,2676,2689,2691,2693,2699,2701,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2748,2757,2759,2761,2763,2765,2768,2768,2784,2784,2790,2799,2817,2819,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2870,2873,2876,2883,2887,2888,2891,2893,2902,2903,2908,2909,2911,2913,2918,2927,2946,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,2997,2999,3001,3006,3010,3014,3016,3018,3021,3031,3031,3047,3055,3073,3075,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3134,3140,3142,3144,3146,3149,3157,3158,3168,3169,3174,3183,3202,3203,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3262,3268,3270,3272,3274,3277,3285,3286,3294,3294,3296,3297,3302,3311,3330,3331,3333,3340,3342,3344,3346,3368,3370,3385,3390,3395,3398,3400,3402,3405,3415,3415,3424,3425,3430,3439,3458,3459,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3530,3530,3535,3540,3542,3542,3544,3551,3570,3571,3585,3642,3648,3662,3664,3673,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3769,3771,3773,3776,3780,3782,3782,3784,3789,3792,3801,3804,3805,3840,3840,3864,3865,3872,3881,3893,3893,3895,3895,3897,3897,3902,3911,3913,3946,3953,3972,3974,3979,3984,3991,3993,4028,4038,4038,4096,4129,4131,4135,4137,4138,4140,4146,4150,4153,4160,4169,4176,4185,4256,4293,4304,4342,4352,4441,4447,4514,4520,4601,4608,4614,4616,4678,4680,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4742,4744,4744,4746,4749,4752,4782,4784,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4814,4816,4822,4824,4846,4848,4878,4880,4880,4882,4885,4888,4894,4896,4934,4936,4954,4969,4977,5024,5108,5121,5740,5743,5750,5761,5786,5792,5866,6016,6099,6112,6121,6160,6169,6176,6263,6272,6313,7680,7835,7840,7929,7936,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8255,8256,8319,8319,8400,8412,8417,8417,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8497,8499,8505,8544,8579,12293,12295,12321,12335,12337,12341,12344,12346,12353,12436,12441,12442,12445,12446,12449,12542,12549,12588,12593,12686,12704,12727,13312,19893,19968,40869,40960,42124,44032,55203,63744,64045,64256,64262,64275,64279,64285,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65056,65059,65075,65076,65101,65103,65136,65138,65140,65140,65142,65276,65296,65305,65313,65338,65343,65343,65345,65370,65381,65470,65474,65479,65482,65487,65490,65495,65498,65500],W=[170,170,181,181,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,880,884,886,887,890,893,902,902,904,906,908,908,910,929,931,1013,1015,1153,1162,1319,1329,1366,1369,1369,1377,1415,1488,1514,1520,1522,1568,1610,1646,1647,1649,1747,1749,1749,1765,1766,1774,1775,1786,1788,1791,1791,1808,1808,1810,1839,1869,1957,1969,1969,1994,2026,2036,2037,2042,2042,2048,2069,2074,2074,2084,2084,2088,2088,2112,2136,2208,2208,2210,2220,2308,2361,2365,2365,2384,2384,2392,2401,2417,2423,2425,2431,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2493,2493,2510,2510,2524,2525,2527,2529,2544,2545,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2649,2652,2654,2654,2674,2676,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2749,2749,2768,2768,2784,2785,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2877,2877,2908,2909,2911,2913,2929,2929,2947,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3024,3024,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3133,3133,3160,3161,3168,3169,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3261,3261,3294,3294,3296,3297,3313,3314,3333,3340,3342,3344,3346,3386,3389,3389,3406,3406,3424,3425,3450,3455,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3585,3632,3634,3635,3648,3654,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3760,3762,3763,3773,3773,3776,3780,3782,3782,3804,3807,3840,3840,3904,3911,3913,3948,3976,3980,4096,4138,4159,4159,4176,4181,4186,4189,4193,4193,4197,4198,4206,4208,4213,4225,4238,4238,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4992,5007,5024,5108,5121,5740,5743,5759,5761,5786,5792,5866,5870,5872,5888,5900,5902,5905,5920,5937,5952,5969,5984,5996,5998,6e3,6016,6067,6103,6103,6108,6108,6176,6263,6272,6312,6314,6314,6320,6389,6400,6428,6480,6509,6512,6516,6528,6571,6593,6599,6656,6678,6688,6740,6823,6823,6917,6963,6981,6987,7043,7072,7086,7087,7098,7141,7168,7203,7245,7247,7258,7293,7401,7404,7406,7409,7413,7414,7424,7615,7680,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8305,8305,8319,8319,8336,8348,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11310,11312,11358,11360,11492,11499,11502,11506,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11648,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,11823,11823,12293,12295,12321,12329,12337,12341,12344,12348,12353,12438,12445,12447,12449,12538,12540,12543,12549,12589,12593,12686,12704,12730,12784,12799,13312,19893,19968,40908,40960,42124,42192,42237,42240,42508,42512,42527,42538,42539,42560,42606,42623,42647,42656,42735,42775,42783,42786,42888,42891,42894,42896,42899,42912,42922,43e3,43009,43011,43013,43015,43018,43020,43042,43072,43123,43138,43187,43250,43255,43259,43259,43274,43301,43312,43334,43360,43388,43396,43442,43471,43471,43520,43560,43584,43586,43588,43595,43616,43638,43642,43642,43648,43695,43697,43697,43701,43702,43705,43709,43712,43712,43714,43714,43739,43741,43744,43754,43762,43764,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43968,44002,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64285,64287,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65136,65140,65142,65276,65313,65338,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500],H=[170,170,181,181,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,768,884,886,887,890,893,902,902,904,906,908,908,910,929,931,1013,1015,1153,1155,1159,1162,1319,1329,1366,1369,1369,1377,1415,1425,1469,1471,1471,1473,1474,1476,1477,1479,1479,1488,1514,1520,1522,1552,1562,1568,1641,1646,1747,1749,1756,1759,1768,1770,1788,1791,1791,1808,1866,1869,1969,1984,2037,2042,2042,2048,2093,2112,2139,2208,2208,2210,2220,2276,2302,2304,2403,2406,2415,2417,2423,2425,2431,2433,2435,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2492,2500,2503,2504,2507,2510,2519,2519,2524,2525,2527,2531,2534,2545,2561,2563,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2620,2620,2622,2626,2631,2632,2635,2637,2641,2641,2649,2652,2654,2654,2662,2677,2689,2691,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2748,2757,2759,2761,2763,2765,2768,2768,2784,2787,2790,2799,2817,2819,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2876,2884,2887,2888,2891,2893,2902,2903,2908,2909,2911,2915,2918,2927,2929,2929,2946,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3006,3010,3014,3016,3018,3021,3024,3024,3031,3031,3046,3055,3073,3075,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3133,3140,3142,3144,3146,3149,3157,3158,3160,3161,3168,3171,3174,3183,3202,3203,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3260,3268,3270,3272,3274,3277,3285,3286,3294,3294,3296,3299,3302,3311,3313,3314,3330,3331,3333,3340,3342,3344,3346,3386,3389,3396,3398,3400,3402,3406,3415,3415,3424,3427,3430,3439,3450,3455,3458,3459,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3530,3530,3535,3540,3542,3542,3544,3551,3570,3571,3585,3642,3648,3662,3664,3673,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3769,3771,3773,3776,3780,3782,3782,3784,3789,3792,3801,3804,3807,3840,3840,3864,3865,3872,3881,3893,3893,3895,3895,3897,3897,3902,3911,3913,3948,3953,3972,3974,3991,3993,4028,4038,4038,4096,4169,4176,4253,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4957,4959,4992,5007,5024,5108,5121,5740,5743,5759,5761,5786,5792,5866,5870,5872,5888,5900,5902,5908,5920,5940,5952,5971,5984,5996,5998,6e3,6002,6003,6016,6099,6103,6103,6108,6109,6112,6121,6155,6157,6160,6169,6176,6263,6272,6314,6320,6389,6400,6428,6432,6443,6448,6459,6470,6509,6512,6516,6528,6571,6576,6601,6608,6617,6656,6683,6688,6750,6752,6780,6783,6793,6800,6809,6823,6823,6912,6987,6992,7001,7019,7027,7040,7155,7168,7223,7232,7241,7245,7293,7376,7378,7380,7414,7424,7654,7676,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8204,8205,8255,8256,8276,8276,8305,8305,8319,8319,8336,8348,8400,8412,8417,8417,8421,8432,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11310,11312,11358,11360,11492,11499,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11647,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,11744,11775,11823,11823,12293,12295,12321,12335,12337,12341,12344,12348,12353,12438,12441,12442,12445,12447,12449,12538,12540,12543,12549,12589,12593,12686,12704,12730,12784,12799,13312,19893,19968,40908,40960,42124,42192,42237,42240,42508,42512,42539,42560,42607,42612,42621,42623,42647,42655,42737,42775,42783,42786,42888,42891,42894,42896,42899,42912,42922,43e3,43047,43072,43123,43136,43204,43216,43225,43232,43255,43259,43259,43264,43309,43312,43347,43360,43388,43392,43456,43471,43481,43520,43574,43584,43597,43600,43609,43616,43638,43642,43643,43648,43714,43739,43741,43744,43759,43762,43766,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43968,44010,44012,44013,44016,44025,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65024,65039,65056,65062,65075,65076,65101,65103,65136,65140,65142,65276,65296,65305,65313,65338,65343,65343,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500];
e.isUnicodeIdentifierStart=a;var G=s(U);e.tokenToString=c,e.stringToToken=u,e.computeLineStarts=l,e.getPositionOfLineAndCharacter=_,e.computePositionOfLineAndCharacter=d,e.getLineStarts=p,e.computeLineAndCharacterOfPosition=f,e.getLineAndCharacterOfPosition=m,e.isWhiteSpaceLike=g,e.isWhiteSpaceSingleLine=v,e.isLineBreak=y,e.isOctalDigit=b,e.couldStartTrivia=x,e.skipTrivia=D;var Q="<<<<<<<".length,X=/^#!.*/;e.isShebangTrivia=k,e.scanShebangTrivia=T,e.forEachLeadingCommentRange=N,e.forEachTrailingCommentRange=A,e.reduceEachLeadingCommentRange=F,e.reduceEachTrailingCommentRange=P,e.getLeadingCommentRanges=I,e.getTrailingCommentRanges=O,e.getShebang=M,e.isIdentifierStart=L,e.isIdentifierPart=R,e.isIdentifierText=B,e.createScanner=j}(n||(n={}));var n;!function(e){function t(t){return e.pathIsRelative(t)||e.isRootedDiskPath(t)}function r(t){return e.sortAndDeduplicate(t,e.compareDiagnostics)}e.isExternalModuleNameRelative=t,e.sortAndDeduplicateDiagnostics=r}(n||(n={})),function(e){function t(e,t){var r=e.declarations;if(r)for(var n=0,i=r;n<i.length;n++){var a=i[n];if(a.kind===t)return a}return void 0}function r(){return new e.MapCtr}function n(e){return!!e&&!!e.size}function a(t){var r=e.createMap();if(t)for(var n=0,i=t;n<i.length;n++){var a=i[n];r.set(a.escapedName,a)}return r}function o(){var t="",r=function(e){return t+=e};return{getText:function(){return t},write:r,rawWrite:r,writeKeyword:r,writeOperator:r,writePunctuation:r,writeSpace:r,writeStringLiteral:r,writeLiteral:r,writeParameter:r,writeProperty:r,writeSymbol:function(e){return r(e)},writeTrailingSemicolon:r,writeComment:r,getTextPos:function(){return t.length},getLine:function(){return 0},getColumn:function(){return 0},getIndent:function(){return 0},isAtStartOfLine:function(){return!1},writeLine:function(){return t+=" "},increaseIndent:e.noop,decreaseIndent:e.noop,clear:function(){return t=""},trackSymbol:e.noop,reportInaccessibleThisError:e.noop,reportInaccessibleUniqueSymbolError:e.noop,reportPrivateInBaseOfClassExpression:e.noop}}function s(t,r,n){var i=e.isRootedDiskPath(t)?e.normalizePath(t):e.getNormalizedAbsolutePath(t,r);return n(i)}function c(e,t){return e.configFilePath!==t.configFilePath||u(e,t)}function u(t,r){return e.moduleResolutionOptionDeclarations.some(function(n){return!e.isJsonEqual(e.getCompilerOptionValue(t,n),e.getCompilerOptionValue(r,n))})}function l(e,t){for(;e;){var r=t(e);if("quit"===r)return void 0;if(r)return e;e=e.parent}return void 0}function _(t,r){for(;;){var n=r(t);if("quit"===n)return void 0;if(void 0!==n)return n;if(e.isSourceFile(t))return void 0;t=t.parent}}function d(e,t){for(var r,n=e.entries(),i=n.next(),a=i.value,o=i.done;!o;r=n.next(),a=r.value,o=r.done,r){var s=a[0],c=a[1],u=t(c,s);if(u)return u}return void 0}function p(e,t){for(var r,n=e.keys(),i=n.next(),a=i.value,o=i.done;!o;r=n.next(),a=r.value,o=r.done,r){var s=t(a);if(s)return s}return void 0}function f(e,t){e.forEach(function(e,r){t.set(r,e)})}function m(t,r){return e.arrayToMap(t,r||function(e){return e},function(){return!0})}function g(t){var r=e.createMap();return f(t,r),r}function v(e){var t=is.getText();try{return e(is),is.getText()}finally{is.clear(),is.writeKeyword(t)}}function y(e){return e.end-e.pos}function h(e,t){return e&&e.resolvedModules&&e.resolvedModules.get(t)}function b(t,r,n){t.resolvedModules||(t.resolvedModules=e.createMap()),t.resolvedModules.set(r,n)}function x(t,r,n){t.resolvedTypeReferenceDirectiveNames||(t.resolvedTypeReferenceDirectiveNames=e.createMap()),t.resolvedTypeReferenceDirectiveNames.set(r,n)}function D(e,t){return e.path===t.path&&!e.prepend==!t.prepend&&!e.circular==!t.circular}function S(e,t){return e.isExternalLibraryImport===t.isExternalLibraryImport&&e.extension===t.extension&&e.resolvedFileName===t.resolvedFileName&&e.originalPath===t.originalPath&&C(e.packageId,t.packageId)}function C(e,t){return e===t||!!e&&!!t&&e.name===t.name&&e.subModuleName===t.subModuleName&&e.version===t.version}function k(e){var t=e.name,r=e.subModuleName,n=e.version,i=r?t+"/"+r:t;return i+"@"+n}function T(e,t){return e.resolvedFileName===t.resolvedFileName&&e.primary===t.primary}function E(t,r,n,i){e.Debug.assert(t.length===r.length);for(var a=0;a<t.length;a++){var o=r[a],s=n&&n.get(t[a]),c=s?!o||!i(s,o):o;if(c)return!0}return!1}function N(e){return A(e),0!==(131072&e.flags)}function A(t){if(!(262144&t.flags)){var r=0!==(32768&t.flags)||e.forEachChild(t,N);r&&(t.flags|=131072),t.flags|=262144}}function F(e){for(;e&&285!==e.kind;)e=e.parent;return e}function P(e){switch(e.kind){case 219:case 247:case 226:case 227:case 228:return!0}return!1}function w(t,r){return e.Debug.assert(t>=0),e.getLineStarts(r)[t]}function I(t){var r=F(t),n=e.getLineAndCharacterOfPosition(r,t.pos);return r.fileName+"("+(n.line+1)+","+(n.character+1)+")"}function O(t,r){e.Debug.assert(t>=0);var n=e.getLineStarts(r),i=t,a=r.text;if(i+1===n.length)return a.length-1;var o=n[i],s=n[i+1]-1;for(e.Debug.assert(e.isLineBreak(a.charCodeAt(s)));s>=o&&e.isLineBreak(a.charCodeAt(s));)s--;return s}function M(e,t,r){return!(r&&r(t)||e.identifiers.has(t))}function L(e){return void 0===e?!0:e.pos===e.end&&e.pos>=0&&1!==e.kind}function R(e){return!L(e)}function B(e,t,r){if(void 0===t||0===t.length)return e;for(var n=0;n<e.length&&r(e[n]);++n);return e.splice.apply(e,[n,0].concat(t)),e}function j(e,t,r){if(void 0===t)return e;for(var n=0;n<e.length&&r(e[n]);++n);return e.splice(n,0,t),e}function J(e){return Wt(e)||!!(1048576&tt(e))}function z(e,t){return B(e,t,Wt)}function V(e,t){return B(e,t,J)}function U(e,t){return j(e,t,Wt)}function K(e,t){return j(e,t,J)}function q(t,r,n){if(47===t.charCodeAt(r+1)&&n>r+2&&47===t.charCodeAt(r+2)){var i=t.substring(r,n);return i.match(e.fullTripleSlashReferencePathRegEx)||i.match(e.fullTripleSlashAMDReferencePathRegEx)||i.match(as)||i.match(os)?!0:!1}return!1}function W(e,t){return 42===e.charCodeAt(t+1)&&33===e.charCodeAt(t+2)}function H(t,r,n){return L(t)?t.pos:e.isJSDocNode(t)?e.skipTrivia((r||F(t)).text,t.pos,!1,!0):n&&e.hasJSDocNodes(t)?H(t.jsDoc[0]):312===t.kind&&t._children.length>0?H(t._children[0],r,n):e.skipTrivia((r||F(t)).text,t.pos)}function G(t,r){return L(t)||!t.decorators?H(t,r):e.skipTrivia((r||F(t)).text,t.decorators.end)}function Q(e,t,r){return void 0===r&&(r=!1),Y(e.text,t,r)}function X(e){return 289===e.kind||e.parent&&X(e.parent)}function Y(t,r,n){if(void 0===n&&(n=!1),L(r))return"";var i=t.substring(n?r.pos:e.skipTrivia(t,r.pos),r.end);return X(r)&&(i=i.replace(/(^|\r?\n|\r)\s*\*\s*/g,"$1")),i}function Z(e,t){return void 0===t&&(t=!1),Q(F(e),e,t)}function $(e){return e.pos}function et(t,r){return e.binarySearch(t,r,$,e.compareValues)}function tt(e){var t=e.emitNode;return t&&t.flags||0}function rt(t,r,n){if(!Ii(t)&&t.parent&&!(e.isNumericLiteral(t)&&512&t.numericLiteralFlags||e.isBigIntLiteral(t)))return Q(r,t);var i=n||16777216&tt(t)?Vi:Wi;switch(t.kind){case 10:return t.singleQuote?"'"+i(t.text,39)+"'":'"'+i(t.text,34)+'"';case 14:return"`"+i(t.text,96)+"`";case 15:return"`"+i(t.text,96)+"${";case 16:return"}"+i(t.text,96)+"${";case 17:return"}"+i(t.text,96)+"`";case 8:case 9:case 13:return t.text}return e.Debug.fail("Literal kind '"+t.kind+"' not accounted for.")}function nt(t){return e.isString(t)?'"'+Wi(t)+'"':""+t}function it(t){return e.getBaseFileName(t).replace(/^(\d)/,"_$1").replace(/\W/g,"_")}function at(t){return 0!==(3&e.getCombinedNodeFlags(t))||ot(t)}function ot(e){var t=Pi(e);return 238===t.kind&&275===t.parent.kind}function st(t){return e.isModuleDeclaration(t)&&(10===t.name.kind||ft(t))}function ct(t){return e.isModuleDeclaration(t)&&10===t.name.kind}function ut(t){return e.isModuleDeclaration(t)&&e.isStringLiteral(t.name)}function lt(t){return e.isModuleDeclaration(t)||e.isIdentifier(t)}function _t(e){return dt(e.valueDeclaration)}function dt(e){return e&&245===e.kind&&!e.body}function pt(t){return 285===t.kind||245===t.kind||e.isFunctionLike(t)}function ft(e){return!!(512&e.flags)}function mt(e){return st(e)&&gt(e)}function gt(t){switch(t.parent.kind){case 285:return e.isExternalModule(t.parent);case 246:return st(t.parent.parent)&&e.isSourceFile(t.parent.parent.parent)&&!e.isExternalModule(t.parent.parent.parent)}return!1}function vt(t){return e.find(t.declarations,function(t){return!(mt(t)||e.isModuleDeclaration(t)&&ft(t))})}function yt(t,r){return e.isExternalModule(t)||r.isolatedModules||e.getEmitModuleKind(r)===e.ModuleKind.CommonJS&&!!t.commonJsModuleIndicator}function ht(t,r){switch(t.kind){case 285:case 247:case 275:case 245:case 226:case 227:case 228:case 158:case 157:case 159:case 160:case 240:case 197:case 198:return!0;case 219:return!e.isFunctionLike(r)}return!1}function bt(t){switch(t.kind){case 303:case 310:case 299:return!0;default:return e.assertType(t),xt(t)}}function xt(t){switch(t.kind){case 161:case 162:case 156:case 163:case 166:case 167:case 295:case 241:case 210:case 242:case 243:case 309:case 240:case 157:case 158:case 159:case 160:case 197:case 198:return!0;default:return e.assertType(t),!1}}function Dt(e){switch(e.kind){case 250:case 249:return!0;default:return!1}}function St(e){switch(e.kind){case 250:case 249:case 220:case 241:case 240:case 245:case 243:case 242:case 244:return!0;default:return!1}}function Ct(t){return Dt(t)||e.isExportDeclaration(t)}function kt(e){return l(e.parent,function(e){return ht(e,e.parent)})}function Tt(e){return e&&0!==y(e)?Z(e):"(Missing)"}function Et(e){return e.declaration?Tt(e.declaration.parameters[0].name):void 0}function Nt(t){switch(t.kind){case 73:return t.escapedText;case 10:case 8:case 14:return e.escapeLeadingUnderscores(t.text);case 150:return yi(t.expression)?e.escapeLeadingUnderscores(t.expression.text):e.Debug.fail("Text of property name cannot be read from non-literal-valued ComputedPropertyNames");default:return e.Debug.assertNever(t)}}function At(t){switch(t.kind){case 73:return 0===y(t)?e.idText(t):Z(t);case 149:return At(t.left)+"."+At(t.right);case 190:return At(t.expression)+"."+At(t.name);default:throw e.Debug.assertNever(t)}}function Ft(e,t,r,n,i,a){var o=F(e);return wt(o,e,t,r,n,i,a)}function Pt(t,r,n,i,a,o,s){var c=e.skipTrivia(t.text,r.pos);return e.createFileDiagnostic(t,c,r.end-c,n,i,a,o,s)}function wt(t,r,n,i,a,o,s){var c=Lt(t,r);return e.createFileDiagnostic(t,c.start,c.length,n,i,a,o,s)}function It(e,t,r){var n=F(e),i=Lt(n,e);return{file:n,start:i.start,length:i.length,code:t.code,category:t.category,messageText:t.next?t:t.messageText,relatedInformation:r}}function Ot(t,r){var n=e.createScanner(t.languageVersion,!0,t.languageVariant,t.text,void 0,r);n.scan();var i=n.getTokenPos();return e.createTextSpanFromBounds(i,n.getTextPos())}function Mt(t,r){var n=e.skipTrivia(t.text,r.pos);if(r.body&&219===r.body.kind){var i=e.getLineAndCharacterOfPosition(t,r.body.pos).line,a=e.getLineAndCharacterOfPosition(t,r.body.end).line;if(a>i)return e.createTextSpan(n,O(i,t)-n+1)}return e.createTextSpanFromBounds(n,r.end)}function Lt(t,r){var n=r;switch(r.kind){case 285:var i=e.skipTrivia(t.text,0,!1);return i===t.text.length?e.createTextSpan(0,0):Ot(t,i);case 238:case 187:case 241:case 210:case 242:case 245:case 244:case 279:case 240:case 197:case 157:case 159:case 160:case 243:case 155:case 154:n=r.name;break;case 198:return Mt(t,r)}if(void 0===n)return Ot(t,r.pos);var a=L(n),o=a||e.isJsxText(r)?n.pos:e.skipTrivia(t.text,n.pos);return a?(e.Debug.assert(o===n.pos,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809"),e.Debug.assert(o===n.end,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809")):(e.Debug.assert(o>=n.pos,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809"),e.Debug.assert(o<=n.end,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809")),e.createTextSpanFromBounds(o,n.end)}function Rt(e){return void 0!==(e.externalModuleIndicator||e.commonJsModuleIndicator)}function Bt(e){return 6===e.scriptKind}function jt(t){return!!(2048&e.getCombinedModifierFlags(t))}function Jt(t){return!(!(64&e.getCombinedModifierFlags(t))||e.isParameterPropertyDeclaration(t))}function zt(t){return!!(2&e.getCombinedNodeFlags(t))}function Vt(t){return!!(1&e.getCombinedNodeFlags(t))}function Ut(e){return 192===e.kind&&99===e.expression.kind}function Kt(e){return 192===e.kind&&93===e.expression.kind}function qt(t){return e.isImportTypeNode(t)&&e.isLiteralTypeNode(t.argument)&&e.isStringLiteral(t.argument.literal)}function Wt(e){return 222===e.kind&&10===e.expression.kind}function Ht(t,r){return 11!==t.kind?e.getLeadingCommentRanges(r.text,t.pos):void 0}function Gt(t,r){var n=152===t.kind||151===t.kind||197===t.kind||198===t.kind||196===t.kind?e.concatenate(e.getTrailingCommentRanges(r,t.pos),e.getLeadingCommentRanges(r,t.pos)):e.getLeadingCommentRanges(r,t.pos);return e.filter(n,function(e){return 42===r.charCodeAt(e.pos+1)&&42===r.charCodeAt(e.pos+2)&&47!==r.charCodeAt(e.pos+3)})}function Qt(t){if(164<=t.kind&&t.kind<=184)return!0;switch(t.kind){case 121:case 144:case 136:case 147:case 139:case 124:case 140:case 137:case 142:case 133:return!0;case 107:return 201!==t.parent.kind;case 212:return!Wa(t);case 151:return 182===t.parent.kind||177===t.parent.kind;case 73:149===t.parent.kind&&t.parent.right===t?t=t.parent:190===t.parent.kind&&t.parent.name===t&&(t=t.parent),e.Debug.assert(73===t.kind||149===t.kind||190===t.kind,"'node' was expected to be a qualified name, identifier or property access in 'isPartOfTypeNode'.");case 149:case 190:case 101:var r=t.parent;if(168===r.kind)return!1;if(184===r.kind)return!r.isTypeOf;if(164<=r.kind&&r.kind<=184)return!0;switch(r.kind){case 212:return!Wa(r);case 151:return t===r.constraint;case 309:return t===r.constraint;case 155:case 154:case 152:case 238:return t===r.type;case 240:case 197:case 198:case 158:case 157:case 156:case 159:case 160:return t===r.type;case 161:case 162:case 163:return t===r.type;case 195:return t===r.type;case 192:case 193:return e.contains(r.typeArguments,t);case 194:return!1}}return!1}function Xt(e,t){for(;e;){if(e.kind===t)return!0;e=e.parent}return!1}function Yt(t,r){function n(t){switch(t.kind){case 231:return r(t);case 247:case 219:case 223:case 224:case 225:case 226:case 227:case 228:case 232:case 233:case 272:case 273:case 234:case 236:case 275:return e.forEachChild(t,n)}}return n(t)}function Zt(t,r){function n(t){switch(t.kind){case 208:r(t);var i=t.expression;return void(i&&n(i));case 244:case 242:case 245:case 243:case 241:case 210:return;default:if(e.isFunctionLike(t)){if(t.name&&150===t.name.kind)return void n(t.name.expression)}else Qt(t)||e.forEachChild(t,n)}}return n(t)}function $t(t){return t&&170===t.kind?t.elementType:t&&165===t.kind?e.singleOrUndefined(t.typeArguments):void 0}function er(e){switch(e.kind){case 242:case 241:case 210:case 169:return e.members;case 189:return e.properties}}function tr(e){if(e)switch(e.kind){case 187:case 279:case 152:case 276:case 155:case 154:case 277:case 238:return!0}return!1}function rr(t){return tr(t)||e.isAccessor(t)}function nr(e){return 239===e.parent.kind&&220===e.parent.parent.kind}function ir(t){return e.isVariableDeclaration(t)?zt(t)&&e.isIdentifier(t.name)&&nr(t):e.isPropertyDeclaration(t)?Ma(t)&&Oa(t):e.isPropertySignature(t)&&Ma(t)}function ar(e){switch(e.kind){case 157:case 156:case 158:case 159:case 160:case 240:case 197:return!0}return!1}function or(e,t){for(;;){if(t&&t(e),234!==e.statement.kind)return e.statement;e=e.statement}}function sr(t){return t&&219===t.kind&&e.isFunctionLike(t.parent)}function cr(e){return e&&157===e.kind&&189===e.parent.kind}function ur(e){return 157===e.kind&&(189===e.parent.kind||210===e.parent.kind)}function lr(e){return e&&1===e.kind}function _r(e){return e&&0===e.kind}function dr(e,t,r){return e.properties.filter(function(e){if(276===e.kind){var n=Nt(e.name);return t===n||!!r&&r===n}return!1})}function pr(t){if(t&&t.statements.length){var r=t.statements[0].expression;return e.tryCast(r,e.isObjectLiteralExpression)}}function fr(t,r,n){return e.firstDefined(mr(t,r),function(t){return e.isArrayLiteralExpression(t.initializer)?e.find(t.initializer.elements,function(t){return e.isStringLiteral(t)&&t.text===n}):void 0})}function mr(t,r){var n=pr(t);return n?dr(n,r):e.emptyArray}function gr(t){return l(t.parent,e.isFunctionLike)}function vr(t){return l(t.parent,e.isFunctionLikeDeclaration)}function yr(t){return l(t.parent,e.isClassLike)}function hr(t,r){for(e.Debug.assert(285!==t.kind);;){if(t=t.parent,!t)return e.Debug.fail();switch(t.kind){case 150:if(e.isClassLike(t.parent.parent))return t;t=t.parent;break;case 153:152===t.parent.kind&&e.isClassElement(t.parent.parent)?t=t.parent.parent:e.isClassElement(t.parent)&&(t=t.parent);break;case 198:if(!r)continue;case 240:case 197:case 245:case 155:case 154:case 157:case 156:case 158:case 159:case 160:case 161:case 162:case 163:case 244:case 285:return t}}}function br(e){var t=hr(e,!1);if(t)switch(t.kind){case 158:case 240:case 197:return t}return void 0}function xr(t,r){for(;;){if(t=t.parent,!t)return t;switch(t.kind){case 150:t=t.parent;break;case 240:case 197:case 198:if(!r)continue;case 155:case 154:case 157:case 156:case 158:case 159:case 160:return t;case 153:152===t.parent.kind&&e.isClassElement(t.parent.parent)?t=t.parent.parent:e.isClassElement(t.parent)&&(t=t.parent)}}}function Dr(e){if(197===e.kind||198===e.kind){for(var t=e,r=e.parent;196===r.kind;)t=r,r=r.parent;if(192===r.kind&&r.expression===t)return r}}function Sr(e){return 99===e.kind||Cr(e)}function Cr(e){var t=e.kind;return(190===t||191===t)&&99===e.expression.kind}function kr(e){var t=e.kind;return(190===t||191===t)&&101===e.expression.kind}function Tr(e){switch(e.kind){case 165:return e.typeName;case 212:return Ha(e.expression)?e.expression:void 0;case 73:case 149:return e}return void 0}function Er(e){switch(e.kind){case 194:return e.tag;case 263:case 262:return e.tagName;default:return e.expression}}function Nr(e,t,r){switch(e.kind){case 241:return!0;case 155:return 241===t.kind;case 159:case 160:case 157:return void 0!==e.body&&241===t.kind;case 152:return void 0!==t.body&&(158===t.kind||157===t.kind||160===t.kind)&&241===r.kind}return!1}function Ar(e,t,r){return void 0!==e.decorators&&Nr(e,t,r)}function Fr(e,t,r){return Ar(e,t,r)||Pr(e,t)}function Pr(t,r){switch(t.kind){case 241:return e.some(t.members,function(e){return Fr(e,t,r)});case 157:case 160:return e.some(t.parameters,function(e){return Ar(e,t,r)});default:return!1}}function wr(e){var t=e.parent;return 263===t.kind||262===t.kind||264===t.kind?t.tagName===e:!1}function Ir(e){switch(e.kind){case 99:case 97:case 103:case 88:case 13:case 188:case 189:case 190:case 191:case 192:case 193:case 194:case 213:case 195:case 214:case 196:case 197:case 210:case 198:case 201:case 199:case 200:case 203:case 204:case 205:case 206:case 209:case 207:case 14:case 211:case 261:case 262:case 265:case 208:case 202:case 215:return!0;case 149:for(;149===e.parent.kind;)e=e.parent;return 168===e.parent.kind||wr(e);case 73:if(168===e.parent.kind||wr(e))return!0;case 8:case 9:case 10:case 101:return Or(e);default:return!1}}function Or(e){var t=e.parent;switch(t.kind){case 238:case 152:case 155:case 154:case 279:case 276:case 187:return t.initializer===e;case 222:case 223:case 224:case 225:case 231:case 232:case 233:case 272:case 235:return t.expression===e;case 226:var r=t;return r.initializer===e&&239!==r.initializer.kind||r.condition===e||r.incrementor===e;case 227:case 228:var n=t;return n.initializer===e&&239!==n.initializer.kind||n.expression===e;case 195:case 213:return e===t.expression;case 217:return e===t.expression;case 150:return e===t.expression;case 153:case 271:case 270:case 278:return!0;case 212:return t.expression===e&&Wa(t);case 277:return t.objectAssignmentInitializer===e;default:return Ir(t)}}function Mr(e){return 249===e.kind&&260===e.moduleReference.kind}function Lr(t){return e.Debug.assert(Mr(t)),t.moduleReference.expression}function Rr(e){return 249===e.kind&&260!==e.moduleReference.kind}function Br(e){return Jr(e)}function jr(e){return!Jr(e)}function Jr(e){return!!e&&!!(65536&e.flags)}function zr(e){return!!e&&!!(16777216&e.flags)}function Vr(e){return!!e&&!!(2097152&e.flags)}function Ur(t){return e.isTypeReferenceNode(t)&&e.isIdentifier(t.typeName)&&"Object"===t.typeName.escapedText&&t.typeArguments&&2===t.typeArguments.length&&(139===t.typeArguments[0].kind||136===t.typeArguments[0].kind)}function Kr(t,r){if(192!==t.kind)return!1;var n=t,i=n.expression,a=n.arguments;if(73!==i.kind||"require"!==i.escapedText)return!1;if(1!==a.length)return!1;var o=a[0];return!r||e.isStringLiteralLike(o)}function qr(e){return 39===e||34===e}function Wr(e,t){return 34===Q(t,e).charCodeAt(0)}function Hr(t){if(!t.parent)return void 0;var r,n;if(e.isVariableDeclaration(t.parent)&&t.parent.initializer===t){if(!Jr(t)&&!zt(t.parent))return void 0;r=t.parent.name,n=t.parent}else if(e.isBinaryExpression(t.parent)&&60===t.parent.operatorToken.kind&&t.parent.right===t)r=t.parent.left,n=r;else if(e.isBinaryExpression(t.parent)&&55===t.parent.operatorToken.kind&&(e.isVariableDeclaration(t.parent.parent)&&t.parent.parent.initializer===t.parent?(r=t.parent.parent.name,n=t.parent.parent):e.isBinaryExpression(t.parent.parent)&&60===t.parent.parent.operatorToken.kind&&t.parent.parent.right===t.parent&&(r=t.parent.parent.left,n=r),!r||!Ha(r)||!nn(r,t.parent.left)))return void 0;return r&&$r(t,Xa(r))?n:void 0}function Gr(t){return e.isBinaryExpression(t)||e.isPropertyAccessExpression(t)||e.isIdentifier(t)||e.isCallExpression(t)}function Qr(t){return Jr(t)&&t.initializer&&e.isBinaryExpression(t.initializer)&&55===t.initializer.operatorToken.kind&&t.name&&Ha(t.name)&&nn(t.name,t.initializer.left)?t.initializer.right:t.initializer}function Xr(e){var t=Qr(e);return t&&$r(t,Xa(e.name))}function Yr(t,r){return e.forEach(t.properties,function(t){return e.isPropertyAssignment(t)&&e.isIdentifier(t.name)&&"value"===t.name.escapedText&&t.initializer&&$r(t.initializer,r)})}function Zr(t){if(t&&t.parent&&e.isBinaryExpression(t.parent)&&60===t.parent.operatorToken.kind){var r=Xa(t.parent.left);return $r(t.parent.right,r)||en(t.parent.left,t.parent.right,r)}if(t&&e.isCallExpression(t)&&un(t)){var n=Yr(t.arguments[2],"prototype"===t.arguments[1].text);if(n)return n}}function $r(t,r){if(e.isCallExpression(t)){var n=Wn(t.expression);return 197===n.kind||198===n.kind?t:void 0}return 197===t.kind||210===t.kind||198===t.kind?t:e.isObjectLiteralExpression(t)&&(0===t.properties.length||r)?t:void 0}function en(t,r,n){var i=e.isBinaryExpression(r)&&55===r.operatorToken.kind&&$r(r.right,n);return i&&nn(t,r.left)?i:void 0}function tn(t){var r=e.isVariableDeclaration(t.parent)?t.parent.name:e.isBinaryExpression(t.parent)&&60===t.parent.operatorToken.kind?t.parent.left:void 0;return r&&$r(t.right,Xa(r))&&Ha(r)&&nn(r,t.left)}function rn(t){if(e.isBinaryExpression(t.parent)){var r=55===t.parent.operatorToken.kind&&e.isBinaryExpression(t.parent.parent)?t.parent.parent:t.parent;if(60===r.operatorToken.kind&&e.isIdentifier(r.left))return r.left}else if(e.isVariableDeclaration(t.parent))return t.parent.name}function nn(t,r){return e.isIdentifier(t)&&e.isIdentifier(r)?t.escapedText===r.escapedText:e.isIdentifier(t)&&e.isPropertyAccessExpression(r)?(101===r.expression.kind||e.isIdentifier(r.expression)&&("window"===r.expression.escapedText||"self"===r.expression.escapedText||"global"===r.expression.escapedText))&&nn(t,r.name):e.isPropertyAccessExpression(t)&&e.isPropertyAccessExpression(r)?t.name.escapedText===r.name.escapedText&&nn(t.expression,r.expression):!1}function an(e){for(;Ka(e,!0);)e=e.right;return e}function on(t){return e.isIdentifier(t)&&"exports"===t.escapedText}function sn(t){return e.isPropertyAccessExpression(t)&&e.isIdentifier(t.expression)&&"module"===t.expression.escapedText&&"exports"===t.name.escapedText}function cn(e){var t=ln(e);return 5===t||Jr(e)?t:0}function un(t){return 3===e.length(t.arguments)&&e.isPropertyAccessExpression(t.expression)&&e.isIdentifier(t.expression.expression)&&"Object"===e.idText(t.expression.expression)&&"defineProperty"===e.idText(t.expression.name)&&yi(t.arguments[1])&&Ha(t.arguments[0])}function ln(t){if(e.isCallExpression(t)){if(!un(t))return 0;var r=t.arguments[0];return on(r)||sn(r)?8:e.isPropertyAccessExpression(r)&&"prototype"===r.name.escapedText&&Ha(r.expression)?9:7}if(60!==t.operatorToken.kind||!e.isPropertyAccessExpression(t.left))return 0;var n=t.left;return Ha(n.expression)&&"prototype"===n.name.escapedText&&e.isObjectLiteralExpression(dn(t))?6:_n(n)}function _n(t){if(101===t.expression.kind)return 4;if(sn(t))return 2;if(Ha(t.expression)){if(Xa(t.expression))return 3;for(var r=t;e.isPropertyAccessExpression(r.expression);)r=r.expression;e.Debug.assert(e.isIdentifier(r.expression));var n=r.expression;return"exports"===n.escapedText||"module"===n.escapedText&&"exports"===r.name.escapedText?1:5}return 0}function dn(t){for(;e.isBinaryExpression(t.right);)t=t.right;return t.right}function pn(t){return e.isBinaryExpression(t)&&3===cn(t)}function fn(t){return Jr(t)&&t.parent&&222===t.parent.kind&&!!e.getJSDocTypeTag(t.parent)}function mn(t){if(!t||!t.valueDeclaration)return!1;var r=t.valueDeclaration;return 240===r.kind||e.isVariableDeclaration(r)&&r.initializer&&e.isFunctionLike(r.initializer)}function gn(t){return vn(t)||e.Debug.failBadSyntaxKind(t.parent)}function vn(t){switch(t.parent.kind){case 250:case 256:return t.parent;case 260:return t.parent.parent;case 192:return Kt(t.parent)||Kr(t.parent,!1)?t.parent:void 0;case 183:return e.Debug.assert(e.isStringLiteral(t)),e.tryCast(t.parent.parent,e.isImportTypeNode);default:return void 0}}function yn(t){switch(t.kind){case 250:case 256:return t.moduleSpecifier;case 249:return 260===t.moduleReference.kind?t.moduleReference.expression:void 0;case 184:return qt(t)?t.argument.literal:void 0;default:return e.Debug.assertNever(t)}}function hn(t){switch(t.kind){case 250:return t.importClause&&e.tryCast(t.importClause.namedBindings,e.isNamespaceImport);case 249:return t;case 256:return void 0;default:return e.Debug.assertNever(t)}}function bn(e){return 250===e.kind&&!!e.importClause&&!!e.importClause.name}function xn(e){if(e)switch(e.kind){case 152:case 157:case 156:case 277:case 276:case 155:case 154:return void 0!==e.questionToken}return!1}function Dn(t){var r=e.isJSDocFunctionType(t)?e.firstOrUndefined(t.parameters):void 0,n=e.tryCast(r&&r.name,e.isIdentifier);return!!n&&"new"===n.escapedText}function Sn(e){return 310===e.kind||303===e.kind}function Cn(t){return Sn(t)||e.isTypeAliasDeclaration(t)}function kn(t){return e.isExpressionStatement(t)&&t.expression&&e.isBinaryExpression(t.expression)&&60===t.expression.operatorToken.kind?t.expression.right:void 0}function Tn(t){return e.isExpressionStatement(t)&&e.isBinaryExpression(t.expression)&&0!==cn(t.expression)&&e.isBinaryExpression(t.expression.right)&&55===t.expression.right.operatorToken.kind?t.expression.right.right:void 0}function En(e){switch(e.kind){case 220:var t=Nn(e);return t&&t.initializer;case 155:return e.initializer;case 276:return e.initializer}}function Nn(t){return e.isVariableStatement(t)?e.firstOrUndefined(t.declarationList.declarations):void 0}function An(t){return e.isModuleDeclaration(t)&&t.body&&245===t.body.kind?t.body:void 0}function Fn(t){var r;tr(t)&&e.hasInitializer(t)&&e.hasJSDocNodes(t.initializer)&&(r=e.addRange(r,t.initializer.jsDoc));for(var n=t;n&&n.parent;){if(e.hasJSDocNodes(n)&&(r=e.addRange(r,n.jsDoc)),152===n.kind){r=e.addRange(r,e.getJSDocParameterTags(n));break}if(151===n.kind){r=e.addRange(r,e.getJSDocTypeParameterTags(n));break}n=Pn(n)}return r||e.emptyArray}function Pn(t){var r=t.parent;return 276===r.kind||255===r.kind||155===r.kind||222===r.kind&&190===t.kind||An(r)||e.isBinaryExpression(t)&&60===t.operatorToken.kind?r:r.parent&&(Nn(r.parent)===t||e.isBinaryExpression(r)&&60===r.operatorToken.kind)?r.parent:r.parent&&r.parent.parent&&(Nn(r.parent.parent)||En(r.parent.parent)===t||Tn(r.parent.parent))?r.parent.parent:void 0}function wn(t){if(t.symbol)return t.symbol;if(!e.isIdentifier(t.name))return void 0;var r=t.name.escapedText,n=In(t);if(!n)return void 0;var i=e.find(n.parameters,function(e){return 73===e.name.kind&&e.name.escapedText===r});return i&&i.symbol}function In(e){return On(Mn(e))}function On(t){var r=Tn(t)||kn(t)||En(t)||Nn(t)||An(t)||t;return r&&e.isFunctionLike(r)?r:void 0}function Mn(t){return e.Debug.assertDefined(l(t.parent,e.isJSDoc)).parent}function Ln(t){var r=t.name.escapedText,n=t.parent.parent.parent.typeParameters;return e.find(n,function(e){return e.name.escapedText===r})}function Rn(t){var r=e.lastOrUndefined(t.parameters);return!!r&&Bn(r)}function Bn(t){var r=e.isJSDocParameterTag(t)?t.typeExpression&&t.typeExpression.type:t.type;return void 0!==t.dotDotDotToken||!!r&&296===r.kind}function jn(e){for(var t=e.parent;;){switch(t.kind){case 205:var r=t.operatorToken.kind;return za(r)&&t.left===e?60===r?1:2:0;case 203:case 204:var n=t.operator;return 44===n||45===n?2:0;case 227:case 228:return t.initializer===e?1:0;case 196:case 188:case 209:case 214:e=t;break;case 277:if(t.name!==e)return 0;e=t.parent;break;case 276:if(t.name===e)return 0;e=t.parent;break;default:return 0}t=e.parent}}function Jn(e){return 0!==jn(e)}function zn(e){switch(e.kind){case 219:case 220:case 232:case 223:case 233:case 247:case 272:case 273:case 234:case 226:case 227:case 228:case 224:case 225:case 236:case 275:return!0}return!1}function Vn(t){return e.isFunctionExpression(t)||e.isArrowFunction(t)||e.isMethodOrAccessor(t)||e.isFunctionDeclaration(t)||e.isConstructorDeclaration(t)}function Un(e,t){for(;e&&e.kind===t;)e=e.parent;return e}function Kn(e){return Un(e,178)}function qn(e){return Un(e,196)}function Wn(e){for(;196===e.kind;)e=e.expression;return e}function Hn(e){for(;196===e.kind;)e=e.parent;return e}function Gn(e){return 190!==e.kind&&191!==e.kind?!1:(e=qn(e.parent),e&&199===e.kind)}function Qn(e,t){for(;e;){if(e===t)return!0;e=e.parent}return!1}function Xn(t){return!e.isSourceFile(t)&&!e.isBindingPattern(t)&&e.isDeclaration(t.parent)&&t.parent.name===t}function Yn(t){var r=t.parent;switch(t.kind){case 10:case 8:if(e.isComputedPropertyName(r))return r.parent;case 73:if(e.isDeclaration(r))return r.name===t?r:void 0;if(e.isQualifiedName(r)){var n=r.parent;return e.isJSDocParameterTag(n)&&n.name===r?n:void 0}var i=r.parent;return e.isBinaryExpression(i)&&0!==cn(i)&&(i.left.symbol||i.symbol)&&e.getNameOfDeclaration(i)===t?i:void 0;default:return void 0}}function Zn(t){return(10===t.kind||8===t.kind)&&150===t.parent.kind&&e.isDeclaration(t.parent.parent)}function $n(e){var t=e.parent;switch(t.kind){case 155:case 154:case 157:case 156:case 159:case 160:case 279:case 276:case 190:return t.name===e;case 149:if(t.right===e){for(;149===t.kind;)t=t.parent;return 168===t.kind||165===t.kind}return!1;case 187:case 254:return t.propertyName===e;case 258:case 268:return!0}return!1}function ei(t){return 249===t.kind||248===t.kind||251===t.kind&&!!t.name||252===t.kind||254===t.kind||258===t.kind||255===t.kind&&ti(t)||e.isBinaryExpression(t)&&2===cn(t)&&ti(t)}function ti(t){var r=e.isExportAssignment(t)?t.expression:t.right;return Ha(r)||e.isClassExpression(r)}function ri(t){var r=ni(t);if(r&&Jr(t)){var n=e.getJSDocAugmentsTag(t);if(n)return n.class}return r}function ni(e){var t=si(e.heritageClauses,87);return t&&t.types.length>0?t.types[0]:void 0}function ii(e){var t=si(e.heritageClauses,110);return t?t.types:void 0}function ai(t){return e.isInterfaceDeclaration(t)?oi(t)||e.emptyArray:e.isClassLike(t)?e.concatenate(e.singleElementArray(ri(t)),ii(t))||e.emptyArray:e.emptyArray}function oi(e){var t=si(e.heritageClauses,87);return t?t.types:void 0}function si(e,t){if(e)for(var r=0,n=e;r<n.length;r++){var i=n[r];if(i.token===t)return i}return void 0}function ci(t,r,n){if(!t.getCompilerOptions().noResolve){var i=e.isRootedDiskPath(n.fileName)?n.fileName:e.combinePaths(e.getDirectoryPath(r.fileName),n.fileName);return t.getSourceFile(i)}}function ui(e,t){for(;e;){if(e.kind===t)return e;
e=e.parent}return void 0}function li(e){return e>=74&&148>=e}function _i(e){return e>=119&&148>=e}function di(e){return li(e)&&!_i(e)}function pi(t){var r=e.stringToToken(t);return void 0!==r&&di(r)}function fi(e){var t=e.originalKeywordKind;return!!t&&!_i(t)}function mi(e){return e>=2&&7>=e}function gi(e){if(!e)return 4;var t=0;switch(e.kind){case 240:case 197:case 157:e.asteriskToken&&(t|=1);case 198:Ia(e,256)&&(t|=2)}return e.body||(t|=4),t}function vi(e){switch(e.kind){case 240:case 197:case 198:case 157:return void 0!==e.body&&void 0===e.asteriskToken&&Ia(e,256)}return!1}function yi(t){return e.isStringLiteralLike(t)||e.isNumericLiteral(t)}function hi(t){var r=e.getNameOfDeclaration(t);return!!r&&bi(r)}function bi(e){return 150===e.kind&&!yi(e.expression)&&!xi(e.expression)}function xi(t){return e.isPropertyAccessExpression(t)&&Ni(t.expression)}function Di(t){switch(t.kind){case 73:return t.escapedText;case 10:case 8:return e.escapeLeadingUnderscores(t.text);case 150:var r=t.expression;return xi(r)?Ti(e.idText(r.name)):yi(r)?e.escapeLeadingUnderscores(r.text):void 0;default:return e.Debug.assertNever(t)}}function Si(e){switch(e.kind){case 73:case 10:case 14:case 8:return!0;default:return!1}}function Ci(t){return 73===t.kind?e.idText(t):t.text}function ki(t){return 73===t.kind?t.escapedText:e.escapeLeadingUnderscores(t.text)}function Ti(e){return"__@"+e}function Ei(t){return e.startsWith(t.escapedName,"__@")}function Ni(e){return 73===e.kind&&"Symbol"===e.escapedText}function Ai(e){return"push"===e.escapedText||"unshift"===e.escapedText}function Fi(e){var t=Pi(e);return 152===t.kind}function Pi(e){for(;187===e.kind;)e=e.parent.parent;return e}function wi(e){var t=e.kind;return 158===t||197===t||240===t||198===t||157===t||159===t||160===t||245===t||285===t}function Ii(t){return e.positionIsSynthesized(t.pos)||e.positionIsSynthesized(t.end)}function Oi(t){return e.getParseTreeNode(t,e.isSourceFile)||t}function Mi(e){var t=Bi(e),r=193===e.kind&&void 0!==e.arguments;return Li(e.kind,t,r)}function Li(e,t,r){switch(e){case 193:return r?0:1;case 203:case 200:case 201:case 199:case 202:case 206:case 208:return 1;case 205:switch(t){case 41:case 60:case 61:case 62:case 64:case 63:case 65:case 66:case 67:case 68:case 69:case 70:case 72:case 71:return 1}}return 0}function Ri(e){var t=Bi(e),r=193===e.kind&&void 0!==e.arguments;return ji(e.kind,t,r)}function Bi(e){return 205===e.kind?e.operatorToken.kind:203===e.kind||204===e.kind?e.operator:e.kind}function ji(e,t,r){switch(e){case 315:return 0;case 209:return 1;case 208:return 2;case 206:return 4;case 205:switch(t){case 27:return 0;case 60:case 61:case 62:case 64:case 63:case 65:case 66:case 67:case 68:case 69:case 70:case 72:case 71:return 3;default:return Ji(t)}case 203:case 200:case 201:case 199:case 202:return 16;case 204:return 17;case 192:return 18;case 193:return r?19:18;case 194:case 190:case 191:return 19;case 101:case 99:case 73:case 97:case 103:case 88:case 8:case 9:case 10:case 188:case 189:case 197:case 198:case 210:case 261:case 262:case 265:case 13:case 14:case 207:case 196:case 211:return 20;default:return-1}}function Ji(e){switch(e){case 55:return 5;case 54:return 6;case 50:return 7;case 51:return 8;case 49:return 9;case 33:case 34:case 35:case 36:return 10;case 28:case 30:case 31:case 32:case 95:case 94:case 120:return 11;case 46:case 47:case 48:return 12;case 38:case 39:return 13;case 40:case 42:case 43:return 14;case 41:return 15}return-1}function zi(){function t(t){e.forEach(c.get(t.fileName),function(e){return e.file=t})}function r(t){var r;if(r=t.file?c.get(t.file.fileName):o,!r)return void 0;var n=e.binarySearch(r,t,e.identity,e.compareDiagnosticsSkipRelatedInformation);return n>=0?r[n]:void 0}function n(t){var r;t.file?(r=c.get(t.file.fileName),r||(r=[],c.set(t.file.fileName,r),e.insertSorted(s,t.file.fileName,e.compareStringsCaseSensitive))):(u&&(u=!1,o=o.slice()),r=o),e.insertSorted(r,t,e.compareDiagnostics)}function i(){return u=!0,o}function a(t){if(t)return c.get(t)||[];var r=e.flatMapToMutable(s,function(e){return c.get(e)});return o.length?(r.unshift.apply(r,o),r):r}var o=[],s=[],c=e.createMap(),u=!1;return{add:n,lookup:r,getGlobalDiagnostics:i,getDiagnostics:a,reattachFileDiagnostics:t}}function Vi(e,t){var r=96===t?ds:39===t?_s:ls;return e.replace(r,Ui)}function Ui(e,t,r){if(0===e.charCodeAt(0)){var n=r.charCodeAt(t+e.length);return n>=48&&57>=n?"\\x00":"\\0"}return ps.get(e)||qi(e.charCodeAt(0))}function Ki(t){var r=t.charCodeAt(0);return r>=97&&122>=r||e.stringContains(t,"-")}function qi(e){var t=e.toString(16).toUpperCase(),r=("0000"+t).slice(-4);return"\\u"+r}function Wi(e,t){return e=Vi(e,t),fs.test(e)?e.replace(fs,function(e){return qi(e.charCodeAt(0))}):e}function Hi(e){return void 0===ms[e]&&(ms[e]=Hi(e-1)+ms[1]),ms[e]}function Gi(){return ms[1].length}function Qi(t){function r(t){var r=e.computeLineStarts(t);r.length>1?(d=d+r.length-1,p=u.length-t.length+e.last(r),_=p-u.length===0):_=!1}function n(e){e&&e.length&&(_&&(e=Hi(l)+e,_=!1),u+=e,r(e))}function i(){u="",l=0,_=!0,d=0,p=0}function a(e){void 0!==e&&(u+=e,r(e))}function o(e){e&&e.length&&n(e)}function s(){_||(u+=t,d++,p=u.length,_=!0)}function c(){return _?u.length:u.length+t.length}var u,l,_,d,p;return i(),{write:n,rawWrite:a,writeLiteral:o,writeLine:s,increaseIndent:function(){l++},decreaseIndent:function(){l--},getIndent:function(){return l},getTextPos:function(){return u.length},getLine:function(){return d},getColumn:function(){return _?l*Gi():u.length-p},getText:function(){return u},isAtStartOfLine:function(){return _},clear:i,reportInaccessibleThisError:e.noop,reportPrivateInBaseOfClassExpression:e.noop,reportInaccessibleUniqueSymbolError:e.noop,trackSymbol:e.noop,writeKeyword:n,writeOperator:n,writeParameter:n,writeProperty:n,writePunctuation:n,writeSpace:n,writeStringLiteral:n,writeSymbol:function(e){return n(e)},writeTrailingSemicolon:n,writeComment:n,getTextPosWithWriteLine:c}}function Xi(e){function t(){r&&(e.writeTrailingSemicolon(";"),r=!1)}var r=!1;return i({},e,{writeTrailingSemicolon:function(){r=!0},writeLiteral:function(r){t(),e.writeLiteral(r)},writeStringLiteral:function(r){t(),e.writeStringLiteral(r)},writeSymbol:function(r,n){t(),e.writeSymbol(r,n)},writePunctuation:function(r){t(),e.writePunctuation(r)},writeKeyword:function(r){t(),e.writeKeyword(r)},writeOperator:function(r){t(),e.writeOperator(r)},writeParameter:function(r){t(),e.writeParameter(r)},writeSpace:function(r){t(),e.writeSpace(r)},writeProperty:function(r){t(),e.writeProperty(r)},writeComment:function(r){t(),e.writeComment(r)},writeLine:function(){t(),e.writeLine()},increaseIndent:function(){t(),e.increaseIndent()},decreaseIndent:function(){t(),e.decreaseIndent()}})}function Yi(e,t,r){return t.moduleName||$i(e,t.fileName,r&&r.fileName)}function Zi(e,t,r){var n=t.getExternalModuleFileFromDeclaration(r);return!n||n.isDeclarationFile?void 0:Yi(e,n)}function $i(t,r,n){var i=function(e){return t.getCanonicalFileName(e)},a=s(n?e.getDirectoryPath(n):t.getCommonSourceDirectory(),t.getCurrentDirectory(),i),o=e.getNormalizedAbsolutePath(r,t.getCurrentDirectory()),c=e.getRelativePathToDirectoryOrUrl(a,o,a,i,!1),u=e.removeFileExtension(c);return n?e.ensurePathIsNonModuleName(u):u}function ea(t,r,n){var i,a=r.getCompilerOptions();return i=e.removeFileExtension(a.outDir?aa(t,r,a.outDir):t),i+n}function ta(e,t){return ra(e,t.getCompilerOptions(),t.getCurrentDirectory(),t.getCommonSourceDirectory(),function(e){return t.getCanonicalFileName(e)})}function ra(t,r,n,i,a){var o=r.declarationDir||r.outDir,s=o?oa(t,o,n,i,a):t;return e.removeFileExtension(s)+".d.ts"}function na(t,r){var n=t.getCompilerOptions(),i=function(e){return t.isSourceFileFromExternalLibrary(e)},a=function(e){return t.getResolvedProjectReferenceToRedirect(e)};if(n.outFile||n.out){var o=e.getEmitModuleKind(n),s=n.emitDeclarationOnly||o===e.ModuleKind.AMD||o===e.ModuleKind.System;return e.filter(t.getSourceFiles(),function(t){return(s||!e.isExternalModule(t))&&ia(t,n,i,a)})}var c=void 0===r?t.getSourceFiles():[r];return e.filter(c,function(e){return ia(e,n,i,a)})}function ia(e,t,r,n){return!(t.noEmitForJsFiles&&Br(e)||e.isDeclarationFile||r(e)||Bt(e)&&n(e.fileName))}function aa(e,t,r){return oa(e,r,t.getCurrentDirectory(),t.getCommonSourceDirectory(),function(e){return t.getCanonicalFileName(e)})}function oa(t,r,n,i,a){var o=e.getNormalizedAbsolutePath(t,n),s=0===a(o).indexOf(a(i));return o=s?o.substring(i.length):o,e.combinePaths(r,o)}function sa(t,r,n,i,a,o){t.writeFile(n,i,a,function(t){r.add(e.createCompilerDiagnostic(e.Diagnostics.Could_not_write_file_0_Colon_1,n,t))},o)}function ca(t,r){return e.getLineAndCharacterOfPosition(t,r).line}function ua(t,r){return e.computeLineAndCharacterOfPosition(t,r).line}function la(t){return e.find(t.members,function(t){return e.isConstructorDeclaration(t)&&R(t.body)})}function _a(e){if(e&&e.parameters.length>0){var t=2===e.parameters.length&&fa(e.parameters[0]);return e.parameters[t?1:0]}}function da(e){var t=_a(e);return t&&t.type}function pa(t){if(t.parameters.length&&!e.isJSDocSignature(t)){var r=t.parameters[0];if(fa(r))return r}}function fa(e){return ma(e.name)}function ma(e){return!!e&&73===e.kind&&ga(e)}function ga(e){return 101===e.originalKeywordKind}function va(t,r){var n,i,a,o;return hi(r)?(n=r,159===r.kind?a=r:160===r.kind?o=r:e.Debug.fail("Accessor has wrong kind")):e.forEach(t,function(t){if(e.isAccessor(t)&&Ia(t,32)===Ia(r,32)){var s=Di(t.name),c=Di(r.name);s===c&&(n?i||(i=t):n=t,159!==t.kind||a||(a=t),160!==t.kind||o||(o=t))}}),{firstAccessor:n,secondAccessor:i,getAccessor:a,setAccessor:o}}function ya(t){var r=t.type;return r||!Jr(t)?r:e.isJSDocPropertyLikeTag(t)?t.typeExpression&&t.typeExpression.type:e.getJSDocType(t)}function ha(e){return e.type}function ba(t){return e.isJSDocSignature(t)?t.type&&t.type.typeExpression&&t.type.typeExpression.type:t.type||(Jr(t)?e.getJSDocReturnType(t):void 0)}function xa(t){return e.flatMap(e.getJSDocTags(t),function(e){return Da(e)?e.typeParameters:void 0})}function Da(t){return e.isJSDocTemplateTag(t)&&!(297===t.parent.kind&&t.parent.tags.some(Sn))}function Sa(e){var t=_a(e);return t&&ya(t)}function Ca(e,t,r,n){ka(e,t,r.pos,n)}function ka(e,t,r,n){n&&n.length&&r!==n[0].pos&&ua(e,r)!==ua(e,n[0].pos)&&t.writeLine()}function Ta(e,t,r,n){r!==n&&ua(e,r)!==ua(e,n)&&t.writeLine()}function Ea(e,t,r,n,i,a,o,s){if(n&&n.length>0){i&&r.writeSpace(" ");for(var c=!1,u=0,l=n;u<l.length;u++){var _=l[u];c&&(r.writeSpace(" "),c=!1),s(e,t,r,_.pos,_.end,o),_.hasTrailingNewLine?r.writeLine():c=!0}c&&a&&r.writeSpace(" ")}}function Na(t,r,n,i,a,o,s){function c(e){return W(t,e.pos)}var u,l;if(s?0===a.pos&&(u=e.filter(e.getLeadingCommentRanges(t,a.pos),c)):u=e.getLeadingCommentRanges(t,a.pos),u){for(var _=[],d=void 0,p=0,f=u;p<f.length;p++){var m=f[p];if(d){var g=ua(r,d.end),v=ua(r,m.pos);if(v>=g+2)break}_.push(m),d=m}if(_.length){var g=ua(r,e.last(_).end),y=ua(r,e.skipTrivia(t,a.pos));y>=g+2&&(Ca(r,n,a,u),Ea(t,r,n,_,!1,!0,o,i),l={nodePos:a.pos,detachedCommentEndPos:e.last(_).end})}}return l}function Aa(t,r,n,i,a,o){if(42===t.charCodeAt(i+1))for(var s=e.computeLineAndCharacterOfPosition(r,i),c=r.length,u=void 0,l=i,_=s.line;a>l;_++){var d=_+1===c?t.length+1:r[_+1];if(l!==i){void 0===u&&(u=Pa(t,r[s.line],i));var p=n.getIndent()*Gi(),f=p-u+Pa(t,l,d);if(f>0){var m=f%Gi(),g=Hi((f-m)/Gi());for(n.rawWrite(g);m;)n.rawWrite(" "),m--}else n.rawWrite("")}Fa(t,a,n,o,l,d),l=d}else n.writeComment(t.substring(i,a))}function Fa(e,t,r,n,i,a){var o=Math.min(t,a-1),s=e.substring(i,o).replace(/^\s+|\s+$/g,"");s?(r.writeComment(s),o!==t&&r.writeLine()):r.rawWrite(n)}function Pa(t,r,n){for(var i=0;n>r&&e.isWhiteSpaceSingleLine(t.charCodeAt(r));r++)9===t.charCodeAt(r)?i+=Gi()-i%Gi():i++;return i}function wa(e){return 0!==Ra(e)}function Ia(e,t){return!!La(e,t)}function Oa(e){return Ia(e,32)}function Ma(e){return Ia(e,64)}function La(e,t){return Ra(e)&t}function Ra(e){if(536870912&e.modifierFlagsCache)return-536870913&e.modifierFlagsCache;var t=Ba(e);return e.modifierFlagsCache=536870912|t,t}function Ba(e){var t=0;if(e.modifiers)for(var r=0,n=e.modifiers;r<n.length;r++){var i=n[r];t|=ja(i.kind)}return(4&e.flags||73===e.kind&&e.isInJSDocNamespace)&&(t|=1),t}function ja(e){switch(e){case 117:return 32;case 116:return 4;case 115:return 16;case 114:return 8;case 119:return 128;case 86:return 1;case 126:return 2;case 78:return 2048;case 81:return 512;case 122:return 256;case 134:return 64}return 0}function Ja(e){return 55===e||54===e||52===e}function za(e){return e>=60&&72>=e}function Va(e){var t=Ua(e);return t&&!t.isImplements?t.class:void 0}function Ua(t){return e.isExpressionWithTypeArguments(t)&&e.isHeritageClause(t.parent)&&e.isClassLike(t.parent.parent)?{"class":t.parent.parent,isImplements:110===t.parent.token}:void 0}function Ka(t,r){return e.isBinaryExpression(t)&&(r?60===t.operatorToken.kind:za(t.operatorToken.kind))&&e.isLeftHandSideExpression(t.left)}function qa(e){if(Ka(e,!0)){var t=e.left.kind;return 189===t||188===t}return!1}function Wa(e){return void 0!==Va(e)}function Ha(e){return 73===e.kind||Ga(e)}function Ga(t){return e.isPropertyAccessExpression(t)&&Ha(t.expression)}function Qa(t){return e.isPropertyAccessExpression(t)?Qa(t.expression)+"."+t.name:e.isIdentifier(t)?e.unescapeLeadingUnderscores(t.escapedText):void 0}function Xa(t){return e.isPropertyAccessExpression(t)&&"prototype"===t.name.escapedText}function Ya(e){return 149===e.parent.kind&&e.parent.right===e||190===e.parent.kind&&e.parent.name===e}function Za(e){return 189===e.kind&&0===e.properties.length}function $a(e){return 188===e.kind&&0===e.elements.length}function eo(e){return to(e)?e.declarations[0].localSymbol:void 0}function to(t){return t&&e.length(t.declarations)>0&&Ia(t.declarations[0],512)}function ro(t){return e.find(e.supportedTSExtensionsForExtractExtension,function(r){return e.fileExtensionIs(t,r)})}function no(t){for(var r=[],n=t.length,i=0;n>i;i++){var a=t.charCodeAt(i);128>a?r.push(a):2048>a?(r.push(a>>6|192),r.push(63&a|128)):65536>a?(r.push(a>>12|224),r.push(a>>6&63|128),r.push(63&a|128)):131072>a?(r.push(a>>18|240),r.push(a>>12&63|128),r.push(a>>6&63|128),r.push(63&a|128)):e.Debug.assert(!1,"Unexpected code point")}return r}function io(e){for(var t,r,n,i,a="",o=no(e),s=0,c=o.length;c>s;)t=o[s]>>2,r=(3&o[s])<<4|o[s+1]>>4,n=(15&o[s+1])<<2|o[s+2]>>6,i=63&o[s+2],s+1>=c?n=i=64:s+2>=c&&(i=64),a+=gs.charAt(t)+gs.charAt(r)+gs.charAt(n)+gs.charAt(i),s+=3;return a}function ao(e){for(var t="",r=0,n=e.length;n>r;){var i=e[r];if(128>i)t+=String.fromCharCode(i),r++;else if(192===(192&i)){var a=63&i;r++;for(var o=e[r];128===(192&o);)a=a<<6|63&o,r++,o=e[r];t+=String.fromCharCode(a)}else t+=String.fromCharCode(i),r++}return t}function oo(e,t){return e&&e.base64encode?e.base64encode(t):io(t)}function so(e,t){if(e&&e.base64decode)return e.base64decode(t);for(var r=t.length,n=[],i=0;r>i&&t.charCodeAt(i)!==gs.charCodeAt(64);){var a=gs.indexOf(t[i]),o=gs.indexOf(t[i+1]),s=gs.indexOf(t[i+2]),c=gs.indexOf(t[i+3]),u=(63&a)<<2|o>>4&3,l=(15&o)<<4|s>>2&15,_=(3&s)<<6|63&c;0===l&&0!==s?n.push(u):0===_&&0!==c?n.push(u,l):n.push(u,l,_),i+=4}return ao(n)}function co(t,r){try{var n=r.readFile(t);if(!n)return{};var i=e.parseConfigFileTextToJson(t,n);return i.error?{}:i.config}catch(a){return{}}}function uo(e,t){return!t.directoryExists||t.directoryExists(e)}function lo(t,r){switch(t.newLine){case 0:return vs;case 1:return ys}return r?r():e.sys?e.sys.newLine:vs}function _o(t,r){return void 0===r&&(r=t),e.Debug.assert(r>=t||-1===r),{pos:t,end:r}}function po(e,t){return _o(e.pos,t)}function fo(e,t){return _o(t,e.end)}function mo(e){return e.decorators&&e.decorators.length>0?fo(e,e.decorators.end):e}function go(e){return e.modifiers&&e.modifiers.length>0?fo(e,e.modifiers.end):mo(e)}function vo(e){return e.pos===e.end}function yo(t,r){return _o(t,t+e.tokenToString(r).length)}function ho(e,t){return Do(e,e,t)}function bo(e,t,r){return ko(To(e,r),To(t,r),r)}function xo(e,t,r){return ko(e.end,t.end,r)}function Do(e,t,r){return ko(To(e,r),t.end,r)}function So(e,t,r){return ko(e.end,To(t,r),r)}function Co(e,t){return!ko(e.pos,e.end,t)}function ko(e,t,r){return e===t||ca(r,e)===ca(r,t)}function To(t,r){return e.positionIsSynthesized(t.pos)?-1:e.skipTrivia(r.text,t.pos)}function Eo(t){var r=e.getParseTreeNode(t);if(r)switch(r.parent.kind){case 244:case 245:return r===r.parent.name}return!1}function No(t){return e.filter(t.declarations,Ao)}function Ao(e){return void 0!==e.initializer}function Fo(e){return e.watch&&e.hasOwnProperty("watch")}function Po(e){e.close()}function wo(e){return 33554432&e.flags?e.checkFlags:0}function Io(t){if(t.valueDeclaration){var r=e.getCombinedModifierFlags(t.valueDeclaration);return t.parent&&32&t.parent.flags?r:-29&r}if(6&wo(t)){var n=t.checkFlags,i=1024&n?8:256&n?4:16,a=2048&n?32:0;return i|a}return 4194304&t.flags?36:0}function Oo(e,t){return 2097152&e.flags?t.getAliasedSymbol(e):e}function Mo(e){return e.exportSymbol?e.exportSymbol.flags|e.flags:e.flags}function Lo(e){return 1===Bo(e)}function Ro(e){return 0!==Bo(e)}function Bo(e){function t(){return r.parent&&222===Hn(r.parent).kind?1:2}var r=e.parent;if(!r)return 0;switch(r.kind){case 196:return Bo(r);case 204:case 203:var n=r.operator;return 44===n||45===n?t():0;case 205:var i=r,a=i.left,o=i.operatorToken;return a===e&&za(o.kind)?60===o.kind?1:t():0;case 190:return r.name!==e?0:Bo(r);case 276:var s=Bo(r.parent);return e===r.name?jo(s):s;case 277:return e===r.objectAssignmentInitializer?0:Bo(r.parent);case 188:return Bo(r);default:return 0}}function jo(t){switch(t){case 0:return 1;case 1:return 0;case 2:return 2;default:return e.Debug.assertNever(t)}}function Jo(e,t){if(!e||!t||Object.keys(e).length!==Object.keys(t).length)return!1;for(var r in e)if("object"==typeof e[r]){if(!Jo(e[r],t[r]))return!1}else if("function"!=typeof e[r]&&e[r]!==t[r])return!1;return!0}function zo(e,t){e.forEach(t),e.clear()}function Vo(e,t,r){var n=r.createNewValue,i=r.onDeleteValue,a=r.onExistingValue;e.forEach(function(r,n){var o=t.get(n);void 0===o?(e.delete(n),i(r,n)):a&&a(r,o,n)}),t.forEach(function(t,r){e.has(r)||e.set(r,n(r,t))})}function Uo(t,r){for(;;){var n=r(t);if(void 0!==n)return n;var i=e.getDirectoryPath(t);if(i===t)return void 0;t=i}}function Ko(e){return!!(16&Ho(e))&&!!e.symbol&&qo(e.symbol)}function qo(e){if(32&e.flags){var t=Wo(e);return!!t&&Ia(t,128)}return!1}function Wo(t){return e.find(t.declarations,e.isClassLike)}function Ho(e){return 3899392&e.flags?e.objectFlags:0}function Go(e,t){return 0!==t.getSignaturesOfType(e,0).length||0!==t.getSignaturesOfType(e,1).length}function Qo(e,t){return!!Uo(e,function(e){return t(e)?!0:void 0})}function Xo(t){return!!t&&!!t.declarations&&!!t.declarations[0]&&e.isNamespaceExportDeclaration(t.declarations[0])}function Yo(t){var r=t.moduleSpecifier;return e.isStringLiteral(r)?r.text:Z(r)}function Zo(t){var r;return e.forEachChild(t,function(e){R(e)&&(r=e)},function(e){for(var t=e.length-1;t>=0;t--)if(R(e[t])){r=e[t];break}}),r}function $o(e,t,r){return void 0===r&&(r=!0),t=String(t),e.has(t)?!1:(e.set(t,r),!0)}function es(t){return e.isClassLike(t)||e.isInterfaceDeclaration(t)||e.isTypeLiteralNode(t)}function ts(e){return e>=164&&184>=e||121===e||144===e||136===e||147===e||137===e||124===e||139===e||140===e||101===e||107===e||142===e||97===e||133===e||212===e||290===e||291===e||292===e||293===e||294===e||295===e||296===e}function rs(e){return 190===e.kind||191===e.kind}function ns(e){switch(e.kind){case"text":case"internal":return!0;default:return!1}}e.resolvingEmptyArray=[],e.emptyMap=e.createMap(),e.emptyUnderscoreEscapedMap=e.emptyMap,e.externalHelpersModuleNameText="tslib",e.defaultMaximumTruncationLength=160,e.getDeclarationOfKind=t,e.createUnderscoreEscapedMap=r,e.hasEntries=n,e.createSymbolTable=a;var is=o();e.toPath=s,e.changesAffectModuleResolution=c,e.optionsHaveModuleResolutionChanges=u,e.findAncestor=l,e.forEachAncestor=_,e.forEachEntry=d,e.forEachKey=p,e.copyEntries=f,e.arrayToSet=m,e.cloneMap=g,e.usingSingleLineStringWriter=v,e.getFullWidth=y,e.getResolvedModule=h,e.setResolvedModule=b,e.setResolvedTypeReferenceDirective=x,e.projectReferenceIsEqualTo=D,e.moduleResolutionIsEqualTo=S,e.packageIdToString=k,e.typeDirectiveIsEqualTo=T,e.hasChangesInResolutions=E,e.containsParseError=N,e.getSourceFileOfNode=F,e.isStatementWithLocals=P,e.getStartPositionOfLine=w,e.nodePosToString=I,e.getEndLinePosition=O,e.isFileLevelUniqueName=M,e.nodeIsMissing=L,e.nodeIsPresent=R,e.insertStatementsAfterStandardPrologue=z,e.insertStatementsAfterCustomPrologue=V,e.insertStatementAfterStandardPrologue=U,e.insertStatementAfterCustomPrologue=K,e.isRecognizedTripleSlashComment=q,e.isPinnedComment=W,e.getTokenPosOfNode=H,e.getNonDecoratorTokenPosOfNode=G,e.getSourceTextOfNodeFromSourceFile=Q,e.getTextOfNodeFromSourceText=Y,e.getTextOfNode=Z,e.indexOfNode=et,e.getEmitFlags=tt,e.getLiteralText=rt,e.getTextOfConstantValue=nt,e.makeIdentifierFromModuleName=it,e.isBlockOrCatchScoped=at,e.isCatchClauseVariableDeclarationOrBindingElement=ot,e.isAmbientModule=st,e.isModuleWithStringLiteralName=ct,e.isNonGlobalAmbientModule=ut,e.isEffectiveModuleDeclaration=lt,e.isShorthandAmbientModuleSymbol=_t,e.isBlockScopedContainerTopLevel=pt,e.isGlobalScopeAugmentation=ft,e.isExternalModuleAugmentation=mt,e.isModuleAugmentationExternal=gt,e.getNonAugmentationDeclaration=vt,e.isEffectiveExternalModule=yt,e.isBlockScope=ht,e.isDeclarationWithTypeParameters=bt,e.isDeclarationWithTypeParameterChildren=xt,e.isAnyImportSyntax=Dt,e.isLateVisibilityPaintedStatement=St,e.isAnyImportOrReExport=Ct,e.getEnclosingBlockScopeContainer=kt,e.declarationNameToString=Tt,e.getNameFromIndexInfo=Et,e.getTextOfPropertyName=Nt,e.entityNameToString=At,e.createDiagnosticForNode=Ft,e.createDiagnosticForNodeArray=Pt,e.createDiagnosticForNodeInSourceFile=wt,e.createDiagnosticForNodeFromMessageChain=It,e.getSpanOfTokenAtPosition=Ot,e.getErrorSpanForNode=Lt,e.isExternalOrCommonJsModule=Rt,e.isJsonSourceFile=Bt,e.isEnumConst=jt,e.isDeclarationReadonly=Jt,e.isVarConst=zt,e.isLet=Vt,e.isSuperCall=Ut,e.isImportCall=Kt,e.isLiteralImportTypeNode=qt,e.isPrologueDirective=Wt,e.getLeadingCommentRangesOfNode=Ht,e.getJSDocCommentRanges=Gt,e.fullTripleSlashReferencePathRegEx=/^(\/\/\/\s*<reference\s+path\s*=\s*)('|")(.+?)\2.*?\/>/;var as=/^(\/\/\/\s*<reference\s+types\s*=\s*)('|")(.+?)\2.*?\/>/;e.fullTripleSlashAMDReferencePathRegEx=/^(\/\/\/\s*<amd-dependency\s+path\s*=\s*)('|")(.+?)\2.*?\/>/;var os=/^(\/\/\/\s*<reference\s+no-default-lib\s*=\s*)('|")(.+?)\2\s*\/>/;e.isPartOfTypeNode=Qt,e.isChildOfNodeWithKind=Xt,e.forEachReturnStatement=Yt,e.forEachYieldExpression=Zt,e.getRestParameterElementType=$t,e.getMembersOfDeclaration=er,e.isVariableLike=tr,e.isVariableLikeOrAccessor=rr,e.isVariableDeclarationInVariableStatement=nr,e.isValidESSymbolDeclaration=ir,e.introducesArgumentsExoticObject=ar,e.unwrapInnermostStatementOfLabel=or,e.isFunctionBlock=sr,e.isObjectLiteralMethod=cr,e.isObjectLiteralOrClassExpressionMethod=ur,e.isIdentifierTypePredicate=lr,e.isThisTypePredicate=_r,e.getPropertyAssignment=dr,e.getTsConfigObjectLiteralExpression=pr,e.getTsConfigPropArrayElementValue=fr,e.getTsConfigPropArray=mr,e.getContainingFunction=gr,e.getContainingFunctionDeclaration=vr,e.getContainingClass=yr,e.getThisContainer=hr,e.getNewTargetContainer=br,e.getSuperContainer=xr,e.getImmediatelyInvokedFunctionExpression=Dr,e.isSuperOrSuperProperty=Sr,e.isSuperProperty=Cr,e.isThisProperty=kr,e.getEntityNameFromTypeNode=Tr,e.getInvokedExpression=Er,e.nodeCanBeDecorated=Nr,e.nodeIsDecorated=Ar,e.nodeOrChildIsDecorated=Fr,e.childIsDecorated=Pr,e.isJSXTagName=wr,e.isExpressionNode=Ir,e.isInExpressionContext=Or,e.isExternalModuleImportEqualsDeclaration=Mr,e.getExternalModuleImportEqualsDeclarationExpression=Lr,e.isInternalModuleImportEqualsDeclaration=Rr,e.isSourceFileJS=Br,e.isSourceFileNotJS=jr,e.isInJSFile=Jr,e.isInJsonFile=zr,e.isInJSDoc=Vr,e.isJSDocIndexSignature=Ur,e.isRequireCall=Kr,e.isSingleOrDoubleQuote=qr,e.isStringDoubleQuoted=Wr,e.getDeclarationOfExpando=Hr,e.isAssignmentDeclaration=Gr,e.getEffectiveInitializer=Qr,e.getDeclaredExpandoInitializer=Xr,e.getAssignedExpandoInitializer=Zr,e.getExpandoInitializer=$r,e.isDefaultedExpandoInitializer=tn,e.getNameOfExpando=rn,e.getRightMostAssignedExpression=an,e.isExportsIdentifier=on,e.isModuleExportsPropertyAccessExpression=sn,e.getAssignmentDeclarationKind=cn,e.isBindableObjectDefinePropertyCall=un,e.getAssignmentDeclarationPropertyAccessKind=_n,e.getInitializerOfBinaryExpression=dn,e.isPrototypePropertyAssignment=pn,e.isSpecialPropertyDeclaration=fn,e.isFunctionSymbol=mn,e.importFromModuleSpecifier=gn,e.tryGetImportFromModuleSpecifier=vn,e.getExternalModuleName=yn,e.getNamespaceDeclarationNode=hn,e.isDefaultImport=bn,e.hasQuestionToken=xn,e.isJSDocConstructSignature=Dn,e.isJSDocTypeAlias=Sn,e.isTypeAlias=Cn,e.getSingleInitializerOfVariableStatementOrPropertyDeclaration=En,e.getJSDocCommentsAndTags=Fn,e.getParameterSymbolFromJSDoc=wn,e.getHostSignatureFromJSDoc=In,e.getHostSignatureFromJSDocHost=On,e.getJSDocHost=Mn,e.getTypeParameterFromJsDoc=Ln,e.hasRestParameter=Rn,e.isRestParameter=Bn;var ss;!function(e){e[e.None=0]="None",e[e.Definite=1]="Definite",e[e.Compound=2]="Compound"}(ss=e.AssignmentKind||(e.AssignmentKind={})),e.getAssignmentTargetKind=jn,e.isAssignmentTarget=Jn,e.isNodeWithPossibleHoistedDeclaration=zn,e.isValueSignatureDeclaration=Vn,e.walkUpParenthesizedTypes=Kn,e.walkUpParenthesizedExpressions=qn,e.skipParentheses=Wn,e.isDeleteTarget=Gn,e.isNodeDescendantOf=Qn,e.isDeclarationName=Xn,e.getDeclarationFromName=Yn,e.isLiteralComputedPropertyDeclarationName=Zn,e.isIdentifierName=$n,e.isAliasSymbolDeclaration=ei,e.exportAssignmentIsAlias=ti,e.getEffectiveBaseTypeNode=ri,e.getClassExtendsHeritageElement=ni,e.getClassImplementsHeritageClauseElements=ii,e.getAllSuperTypeNodes=ai,e.getInterfaceBaseTypeNodes=oi,e.getHeritageClause=si,e.tryResolveScriptReference=ci,e.getAncestor=ui,e.isKeyword=li,e.isContextualKeyword=_i,e.isNonContextualKeyword=di,e.isStringANonContextualKeyword=pi,e.isIdentifierANonContextualKeyword=fi,e.isTrivia=mi;var cs;!function(e){e[e.Normal=0]="Normal",e[e.Generator=1]="Generator",e[e.Async=2]="Async",e[e.Invalid=4]="Invalid",e[e.AsyncGenerator=3]="AsyncGenerator"}(cs=e.FunctionFlags||(e.FunctionFlags={})),e.getFunctionFlags=gi,e.isAsyncFunction=vi,e.isStringOrNumericLiteralLike=yi,e.hasDynamicName=hi,e.isDynamicName=bi,e.isWellKnownSymbolSyntactically=xi,e.getPropertyNameForPropertyNameNode=Di,e.isPropertyNameLiteral=Si,e.getTextOfIdentifierOrLiteral=Ci,e.getEscapedTextOfIdentifierOrLiteral=ki,e.getPropertyNameForKnownSymbolName=Ti,e.isKnownSymbol=Ei,e.isESSymbolIdentifier=Ni,e.isPushOrUnshiftIdentifier=Ai,e.isParameterDeclaration=Fi,e.getRootDeclaration=Pi,e.nodeStartsNewLexicalEnvironment=wi,e.nodeIsSynthesized=Ii,e.getOriginalSourceFile=Oi;var us;!function(e){e[e.Left=0]="Left",e[e.Right=1]="Right"}(us=e.Associativity||(e.Associativity={})),e.getExpressionAssociativity=Mi,e.getOperatorAssociativity=Li,e.getExpressionPrecedence=Ri,e.getOperator=Bi,e.getOperatorPrecedence=ji,e.getBinaryOperatorPrecedence=Ji,e.createDiagnosticCollection=zi;var ls=/[\\\"\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g,_s=/[\\\'\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g,ds=/[\\\`\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g,ps=e.createMapFromTemplate({"	":"\\t","":"\\v","\f":"\\f","\b":"\\b","\r":"\\r","\n":"\\n","\\":"\\\\",'"':'\\"',"'":"\\'","`":"\\`","\u2028":"\\u2028","\u2029":"\\u2029","":"\\u0085"});e.escapeString=Vi,e.isIntrinsicJsxName=Ki;var fs=/[^\u0000-\u007F]/g;e.escapeNonAsciiString=Wi;var ms=["","    "];e.getIndentString=Hi,e.getIndentSize=Gi,e.createTextWriter=Qi,e.getTrailingSemicolonOmittingWriter=Xi,e.getResolvedExternalModuleName=Yi,e.getExternalModuleNameFromDeclaration=Zi,e.getExternalModuleNameFromPath=$i,e.getOwnEmitOutputFilePath=ea,e.getDeclarationEmitOutputFilePath=ta,e.getDeclarationEmitOutputFilePathWorker=ra,e.getSourceFilesToEmit=na,e.sourceFileMayBeEmitted=ia,e.getSourceFilePathInNewDir=aa,e.getSourceFilePathInNewDirWorker=oa,e.writeFile=sa,e.getLineOfLocalPosition=ca,e.getLineOfLocalPositionFromLineMap=ua,e.getFirstConstructorWithBody=la,e.getSetAccessorTypeAnnotationNode=da,e.getThisParameter=pa,e.parameterIsThisKeyword=fa,e.isThisIdentifier=ma,e.identifierIsThisKeyword=ga,e.getAllAccessorDeclarations=va,e.getEffectiveTypeAnnotationNode=ya,e.getTypeAnnotationNode=ha,e.getEffectiveReturnTypeNode=ba,e.getJSDocTypeParameterDeclarations=xa,e.getEffectiveSetAccessorTypeAnnotationNode=Sa,e.emitNewLineBeforeLeadingComments=Ca,e.emitNewLineBeforeLeadingCommentsOfPosition=ka,e.emitNewLineBeforeLeadingCommentOfPosition=Ta,e.emitComments=Ea,e.emitDetachedComments=Na,e.writeCommentRange=Aa,e.hasModifiers=wa,e.hasModifier=Ia,e.hasStaticModifier=Oa,e.hasReadonlyModifier=Ma,e.getSelectedModifierFlags=La,e.getModifierFlags=Ra,e.getModifierFlagsNoCache=Ba,e.modifierToFlag=ja,e.isLogicalOperator=Ja,e.isAssignmentOperator=za,e.tryGetClassExtendingExpressionWithTypeArguments=Va,e.tryGetClassImplementingOrExtendingExpressionWithTypeArguments=Ua,e.isAssignmentExpression=Ka,e.isDestructuringAssignment=qa,e.isExpressionWithTypeArgumentsInClassExtendsClause=Wa,e.isEntityNameExpression=Ha,e.isPropertyAccessEntityNameExpression=Ga,e.tryGetPropertyAccessOrIdentifierToString=Qa,e.isPrototypeAccess=Xa,e.isRightSideOfQualifiedNameOrPropertyAccess=Ya,e.isEmptyObjectLiteral=Za,e.isEmptyArrayLiteral=$a,e.getLocalSymbolForExportDefault=eo,e.tryExtractTSExtension=ro;var gs="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";e.convertToBase64=io,e.base64encode=oo,e.base64decode=so,e.readJson=co,e.directoryProbablyExists=uo;var vs="\r\n",ys="\n";e.getNewLineCharacter=lo,e.createRange=_o,e.moveRangeEnd=po,e.moveRangePos=fo,e.moveRangePastDecorators=mo,e.moveRangePastModifiers=go,e.isCollapsedRange=vo,e.createTokenRange=yo,e.rangeIsOnSingleLine=ho,e.rangeStartPositionsAreOnSameLine=bo,e.rangeEndPositionsAreOnSameLine=xo,e.rangeStartIsOnSameLineAsRangeEnd=Do,e.rangeEndIsOnSameLineAsRangeStart=So,e.isNodeArrayMultiLine=Co,e.positionsAreOnSameLine=ko,e.getStartPositionOfRange=To,e.isDeclarationNameOfEnumOrNamespace=Eo,e.getInitializedVariables=No,e.isWatchSet=Fo,e.closeFileWatcher=Po,e.getCheckFlags=wo,e.getDeclarationModifierFlagsFromSymbol=Io,e.skipAlias=Oo,e.getCombinedLocalAndExportSymbolFlags=Mo,e.isWriteOnlyAccess=Lo,e.isWriteAccess=Ro;var hs;!function(e){e[e.Read=0]="Read",e[e.Write=1]="Write",e[e.ReadWrite=2]="ReadWrite"}(hs||(hs={})),e.compareDataObjects=Jo,e.clearMap=zo,e.mutateMap=Vo,e.forEachAncestorDirectory=Uo,e.isAbstractConstructorType=Ko,e.isAbstractConstructorSymbol=qo,e.getClassLikeDeclarationOfSymbol=Wo,e.getObjectFlags=Ho,e.typeHasCallOrConstructSignatures=Go,e.forSomeAncestorDirectory=Qo,e.isUMDExportSymbol=Xo,e.showModuleSpecifier=Yo,e.getLastChild=Zo,e.addToSeen=$o,e.isObjectTypeDeclaration=es,e.isTypeNodeKind=ts,e.isAccessExpression=rs,e.isBundleFileTextLike=ns}(n||(n={})),function(e){function t(e){switch(e.target){case 8:return"lib.esnext.full.d.ts";case 7:return"lib.es2020.full.d.ts";case 6:return"lib.es2019.full.d.ts";case 5:return"lib.es2018.full.d.ts";case 4:return"lib.es2017.full.d.ts";case 3:return"lib.es2016.full.d.ts";case 2:return"lib.es6.d.ts";default:return"lib.d.ts"}}function r(e){return e.start+e.length}function n(e){return 0===e.length}function i(e,t){return t>=e.start&&t<r(e)}function a(e,t){return t>=e.pos&&t<=e.end}function o(e,t){return t.start>=e.start&&r(t)<=r(e)}function s(e,t){return void 0!==c(e,t)}function c(e,t){var r=p(e,t);return r&&0===r.length?void 0:r}function u(e,t){return _(e.start,e.length,t.start,t.length)}function l(e,t,r){return _(e.start,e.length,t,r)}function _(e,t,r,n){var i=e+t,a=r+n;return i>=r&&a>=e}function d(e,t){return t<=r(e)&&t>=e.start}function p(e,t){var n=Math.max(e.start,t.start),i=Math.min(r(e),r(t));return i>=n?m(n,i):void 0}function f(e,t){if(0>e)throw new Error("start < 0");if(0>t)throw new Error("length < 0");return{start:e,length:t}}function m(e,t){return f(e,t-e)
}function g(e){return f(e.span.start,e.newLength)}function v(e){return n(e.span)&&0===e.newLength}function y(e,t){if(0>t)throw new Error("newLength < 0");return{span:e,newLength:t}}function h(t){if(0===t.length)return e.unchangedTextChangeRange;if(1===t.length)return t[0];for(var n=t[0],i=n.span.start,a=r(n.span),o=i+n.newLength,s=1;s<t.length;s++){var c=t[s],u=i,l=a,_=o,d=c.span.start,p=r(c.span),f=d+c.newLength;i=Math.min(u,d),a=Math.max(l,l+(p-_)),o=Math.max(f,f+(_-p))}return y(m(i,a),o-i)}function b(t){if(t&&151===t.kind)for(var r=t;r;r=r.parent)if(e.isFunctionLike(r)||e.isClassLike(r)||242===r.kind)return r}function x(t){return e.hasModifier(t,92)&&158===t.parent.kind}function D(t){return e.isBindingPattern(t)?e.every(t.elements,S):!1}function S(t){return e.isOmittedExpression(t)?!0:D(t.name)}function C(t){for(var r=t.parent;e.isBindingElement(r.parent);)r=r.parent.parent;return r.parent}function k(t,r){e.isBindingElement(t)&&(t=C(t));var n=r(t);return 238===t.kind&&(t=t.parent),t&&239===t.kind&&(n|=r(t),t=t.parent),t&&220===t.kind&&(n|=r(t)),n}function T(t){return k(t,e.getModifierFlags)}function E(e){return k(e,function(e){return e.flags})}function N(t,r,n){function i(t,n,i){var a=e.normalizePath(r.getExecutingFilePath()),o=e.getDirectoryPath(a),s=e.combinePaths(o,t);if(n&&(s=s+"-"+n),s=r.resolvePath(e.combinePaths(s,"diagnosticMessages.generated.json")),!r.fileExists(s))return!1;var c="";try{c=r.readFile(s)}catch(u){return i&&i.push(e.createCompilerDiagnostic(e.Diagnostics.Unable_to_open_file_0,s)),!1}try{e.localizedDiagnosticMessages=JSON.parse(c)}catch(l){return i&&i.push(e.createCompilerDiagnostic(e.Diagnostics.Corrupted_locale_file_0,s)),!1}return!0}var a=/^([a-z]+)([_\-]([a-z]+))?$/.exec(t.toLowerCase());if(!a)return void(n&&n.push(e.createCompilerDiagnostic(e.Diagnostics.Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1,"en","ja-jp")));var o=a[1],s=a[3];i(o,s,n)||i(o,void 0,n),e.setUILocale(t)}function A(e,t){if(e)for(;void 0!==e.original;)e=e.original;return!t||t(e)?e:void 0}function F(e){return 0===(8&e.flags)}function P(e,t){return void 0===e||F(e)?e:(e=A(e),!F(e)||t&&!t(e)?void 0:e)}function w(e){return e.length>=2&&95===e.charCodeAt(0)&&95===e.charCodeAt(1)?"_"+e:e}function I(e){var t=e;return t.length>=3&&95===t.charCodeAt(0)&&95===t.charCodeAt(1)&&95===t.charCodeAt(2)?t.substr(1):t}function O(e){return I(e.escapedText)}function M(e){return I(e.escapedName)}function L(t){var r=t.parent.parent;if(!r)return void 0;if(e.isDeclaration(r))return R(r);switch(r.kind){case 220:if(r.declarationList&&r.declarationList.declarations[0])return R(r.declarationList.declarations[0]);break;case 222:var n=r.expression;switch(n.kind){case 190:return n.name;case 191:var i=n.argumentExpression;if(e.isIdentifier(i))return i}break;case 196:return R(r.expression);case 234:if(e.isDeclaration(r.statement)||e.isExpression(r.statement))return R(r.statement)}}function R(t){var r=z(t);return r&&e.isIdentifier(r)?r:void 0}function B(e){return e.name||L(e)}function j(e){return!!e.name}function J(t){switch(t.kind){case 73:return t;case 311:case 305:var r=t.name;if(149===r.kind)return r.right;break;case 192:case 205:var n=t;switch(e.getAssignmentDeclarationKind(n)){case 1:case 4:case 5:case 3:return n.left.name;case 7:case 8:case 9:return n.arguments[1];default:return void 0}case 310:return B(t);case 255:var i=t.expression;return e.isIdentifier(i)?i:void 0}return t.name}function z(t){return void 0===t?void 0:J(t)||(e.isFunctionExpression(t)||e.isClassExpression(t)?V(t):void 0)}function V(t){if(!t.parent)return void 0;if(e.isPropertyAssignment(t.parent)||e.isBindingElement(t.parent))return t.parent.name;if(e.isBinaryExpression(t.parent)&&t===t.parent.right){if(e.isIdentifier(t.parent.left))return t.parent.left;if(e.isPropertyAccessExpression(t.parent.left))return t.parent.left.name}}function U(t){if(t.name){if(e.isIdentifier(t.name)){var r=t.name.escapedText;return tt(t.parent).filter(function(t){return e.isJSDocParameterTag(t)&&e.isIdentifier(t.name)&&t.name.escapedText===r})}var n=t.parent.parameters.indexOf(t);e.Debug.assert(n>-1,"Parameters should always be in their parents' parameter list");var i=tt(t.parent).filter(e.isJSDocParameterTag);if(n<i.length)return[i[n]]}return e.emptyArray}function K(t){var r=t.name.escapedText;return tt(t.parent).filter(function(t){return e.isJSDocTemplateTag(t)&&t.typeParameters.some(function(e){return e.name.escapedText===r})})}function q(t){return!!rt(t,e.isJSDocParameterTag)}function W(t){return rt(t,e.isJSDocAugmentsTag)}function H(t){return rt(t,e.isJSDocClassTag)}function G(t){return rt(t,e.isJSDocEnumTag)}function Q(t){return rt(t,e.isJSDocThisTag)}function X(t){return rt(t,e.isJSDocReturnTag)}function Y(t){return rt(t,e.isJSDocTemplateTag)}function Z(t){var r=rt(t,e.isJSDocTypeTag);return r&&r.typeExpression&&r.typeExpression.type?r:void 0}function $(t){var r=rt(t,e.isJSDocTypeTag);return!r&&e.isParameter(t)&&(r=e.find(U(t),function(e){return!!e.typeExpression})),r&&r.typeExpression&&r.typeExpression.type}function et(t){var r=X(t);if(r&&r.typeExpression)return r.typeExpression.type;var n=Z(t);if(n&&n.typeExpression){var i=n.typeExpression.type;if(e.isTypeLiteralNode(i)){var a=e.find(i.members,e.isCallSignatureDeclaration);return a&&a.type}if(e.isFunctionTypeNode(i))return i.type}}function tt(t){var r=t.jsDocCache;if(void 0===r){var n=e.getJSDocCommentsAndTags(t);e.Debug.assert(n.length<2||n[0]!==n[1]),t.jsDocCache=r=e.flatMap(n,function(t){return e.isJSDoc(t)?t.tags:t})}return r}function rt(t,r){return e.find(tt(t),r)}function nt(e,t){return tt(e).filter(function(e){return e.kind===t})}function it(t){if(e.isJSDocSignature(t))return e.emptyArray;if(e.isJSDocTypeAlias(t))return e.Debug.assert(297===t.parent.kind),e.flatMap(t.parent.tags,function(t){return e.isJSDocTemplateTag(t)?t.typeParameters:void 0});if(t.typeParameters)return t.typeParameters;if(e.isInJSFile(t)){var r=e.getJSDocTypeParameterDeclarations(t);if(r.length)return r;var n=$(t);if(n&&e.isFunctionTypeNode(n)&&n.typeParameters)return n.typeParameters}return e.emptyArray}function at(t){return t.constraint?t.constraint:e.isJSDocTemplateTag(t.parent)&&t===t.parent.typeParameters[0]?t.parent.constraint:void 0}e.getDefaultLibFileName=t,e.textSpanEnd=r,e.textSpanIsEmpty=n,e.textSpanContainsPosition=i,e.textRangeContainsPositionInclusive=a,e.textSpanContainsTextSpan=o,e.textSpanOverlapsWith=s,e.textSpanOverlap=c,e.textSpanIntersectsWithTextSpan=u,e.textSpanIntersectsWith=l,e.decodedTextSpanIntersectsWith=_,e.textSpanIntersectsWithPosition=d,e.textSpanIntersection=p,e.createTextSpan=f,e.createTextSpanFromBounds=m,e.textChangeRangeNewSpan=g,e.textChangeRangeIsUnchanged=v,e.createTextChangeRange=y,e.unchangedTextChangeRange=y(f(0,0),0),e.collapseTextChangeRangesAcrossMultipleVersions=h,e.getTypeParameterOwner=b,e.isParameterPropertyDeclaration=x,e.isEmptyBindingPattern=D,e.isEmptyBindingElement=S,e.walkUpBindingElementsAndPatterns=C,e.getCombinedModifierFlags=T,e.getCombinedNodeFlags=E,e.validateLocaleAndSetLanguage=N,e.getOriginalNode=A,e.isParseTreeNode=F,e.getParseTreeNode=P,e.escapeLeadingUnderscores=w,e.unescapeLeadingUnderscores=I,e.idText=O,e.symbolName=M,e.getNameOfJSDocTypedef=B,e.isNamedDeclaration=j,e.getNonAssignedNameOfDeclaration=J,e.getNameOfDeclaration=z,e.getJSDocParameterTags=U,e.getJSDocTypeParameterTags=K,e.hasJSDocParameterTags=q,e.getJSDocAugmentsTag=W,e.getJSDocClassTag=H,e.getJSDocEnumTag=G,e.getJSDocThisTag=Q,e.getJSDocReturnTag=X,e.getJSDocTemplateTag=Y,e.getJSDocTypeTag=Z,e.getJSDocType=$,e.getJSDocReturnType=et,e.getJSDocTags=tt,e.getAllJSDocTagsOfKind=nt,e.getEffectiveTypeParameterDeclarations=it,e.getEffectiveConstraintOfTypeParameter=at}(n||(n={})),function(e){function t(e){return 8===e.kind}function r(e){return 9===e.kind}function n(e){return 10===e.kind}function i(e){return 11===e.kind}function a(e){return 13===e.kind}function o(e){return 14===e.kind}function s(e){return 15===e.kind}function c(e){return 16===e.kind}function u(e){return 17===e.kind}function l(e){return 73===e.kind}function _(e){return 149===e.kind}function d(e){return 150===e.kind}function p(e){return 151===e.kind}function f(e){return 152===e.kind}function m(e){return 153===e.kind}function g(e){return 154===e.kind}function v(e){return 155===e.kind}function y(e){return 156===e.kind}function h(e){return 157===e.kind}function b(e){return 158===e.kind}function x(e){return 159===e.kind}function D(e){return 160===e.kind}function S(e){return 161===e.kind}function C(e){return 162===e.kind}function k(e){return 163===e.kind}function T(e){return 160===e.kind||159===e.kind}function E(e){return 164===e.kind}function N(e){return 165===e.kind}function A(e){return 166===e.kind}function F(e){return 167===e.kind}function P(e){return 168===e.kind}function w(e){return 169===e.kind}function I(e){return 170===e.kind}function O(e){return 171===e.kind}function M(e){return 174===e.kind}function L(e){return 175===e.kind}function R(e){return 176===e.kind}function B(e){return 177===e.kind}function j(e){return 178===e.kind}function J(e){return 179===e.kind}function z(e){return 180===e.kind}function V(e){return 181===e.kind}function U(e){return 182===e.kind}function K(e){return 183===e.kind}function q(e){return 184===e.kind}function W(e){return 185===e.kind}function H(e){return 186===e.kind}function G(e){return 187===e.kind}function Q(e){return 188===e.kind}function X(e){return 189===e.kind}function Y(e){return 190===e.kind}function Z(e){return 191===e.kind}function $(e){return 192===e.kind}function et(e){return 193===e.kind}function tt(e){return 194===e.kind}function rt(e){return 195===e.kind}function nt(e){return N(e)&&l(e.typeName)&&"const"===e.typeName.escapedText&&!e.typeArguments}function it(e){return 196===e.kind}function at(e){for(;314===e.kind;)e=e.expression;return e}function ot(e){return 197===e.kind}function st(e){return 198===e.kind}function ct(e){return 199===e.kind}function ut(e){return 200===e.kind}function lt(e){return 201===e.kind}function _t(e){return 202===e.kind}function dt(e){return 203===e.kind}function pt(e){return 204===e.kind}function ft(e){return 205===e.kind}function mt(e){return 206===e.kind}function gt(e){return 207===e.kind}function vt(e){return 208===e.kind}function yt(e){return 209===e.kind}function ht(e){return 210===e.kind}function bt(e){return 211===e.kind}function xt(e){return 212===e.kind}function Dt(e){return 213===e.kind}function St(e){return 214===e.kind}function Ct(e){return 215===e.kind}function kt(e){return 217===e.kind}function Tt(e){return 218===e.kind}function Et(e){return 219===e.kind}function Nt(e){return 220===e.kind}function At(e){return 221===e.kind}function Ft(e){return 222===e.kind}function Pt(e){return 223===e.kind}function wt(e){return 224===e.kind}function It(e){return 225===e.kind}function Ot(e){return 226===e.kind}function Mt(e){return 227===e.kind}function Lt(e){return 228===e.kind}function Rt(e){return 229===e.kind}function Bt(e){return 230===e.kind}function jt(e){return 230===e.kind||229===e.kind}function Jt(e){return 231===e.kind}function zt(e){return 232===e.kind}function Vt(e){return 233===e.kind}function Ut(e){return 234===e.kind}function Kt(e){return 235===e.kind}function qt(e){return 236===e.kind}function Wt(e){return 237===e.kind}function Ht(e){return 238===e.kind}function Gt(e){return 239===e.kind}function Qt(e){return 240===e.kind}function Xt(e){return 241===e.kind}function Yt(e){return 242===e.kind}function Zt(e){return 243===e.kind}function $t(e){return 244===e.kind}function er(e){return 245===e.kind}function tr(e){return 246===e.kind}function rr(e){return 247===e.kind}function nr(e){return 248===e.kind}function ir(e){return 249===e.kind}function ar(e){return 250===e.kind}function or(e){return 251===e.kind}function sr(e){return 252===e.kind}function cr(e){return 253===e.kind}function ur(e){return 254===e.kind}function lr(e){return 255===e.kind}function _r(e){return 256===e.kind}function dr(e){return 257===e.kind}function pr(e){return 258===e.kind}function fr(e){return 259===e.kind}function mr(e){return 260===e.kind}function gr(e){return 261===e.kind}function vr(e){return 262===e.kind}function yr(e){return 263===e.kind}function hr(e){return 264===e.kind}function br(e){return 265===e.kind}function xr(e){return 266===e.kind}function Dr(e){return 267===e.kind}function Sr(e){return 268===e.kind}function Cr(e){return 269===e.kind}function kr(e){return 270===e.kind}function Tr(e){return 271===e.kind}function Er(e){return 272===e.kind}function Nr(e){return 273===e.kind}function Ar(e){return 274===e.kind}function Fr(e){return 275===e.kind}function Pr(e){return 276===e.kind}function wr(e){return 277===e.kind}function Ir(e){return 278===e.kind}function Or(e){return 279===e.kind}function Mr(e){return 285===e.kind}function Lr(e){return 286===e.kind}function Rr(e){return 287===e.kind}function Br(e){return 281===e.kind}function jr(e){switch(e.kind){case 282:case 283:return!0;default:return!1}}function Jr(e){return jr(e)||280===e.kind||284===e.kind}function zr(e){return 289===e.kind}function Vr(e){return 290===e.kind}function Ur(e){return 291===e.kind}function Kr(e){return 292===e.kind}function qr(e){return 293===e.kind}function Wr(e){return 294===e.kind}function Hr(e){return 295===e.kind}function Gr(e){return 296===e.kind}function Qr(e){return 297===e.kind}function Xr(e){return 301===e.kind}function Yr(e){return 302===e.kind}function Zr(e){return 304===e.kind}function $r(e){return 307===e.kind}function en(e){return 305===e.kind}function tn(e){return 306===e.kind}function rn(e){return 308===e.kind}function nn(e){return 309===e.kind}function an(e){return 310===e.kind}function on(e){return 311===e.kind}function sn(e){return 311===e.kind||305===e.kind}function cn(e){return 298===e.kind}function un(e){return 303===e.kind}function ln(e){return 299===e.kind}e.isNumericLiteral=t,e.isBigIntLiteral=r,e.isStringLiteral=n,e.isJsxText=i,e.isRegularExpressionLiteral=a,e.isNoSubstitutionTemplateLiteral=o,e.isTemplateHead=s,e.isTemplateMiddle=c,e.isTemplateTail=u,e.isIdentifier=l,e.isQualifiedName=_,e.isComputedPropertyName=d,e.isTypeParameterDeclaration=p,e.isParameter=f,e.isDecorator=m,e.isPropertySignature=g,e.isPropertyDeclaration=v,e.isMethodSignature=y,e.isMethodDeclaration=h,e.isConstructorDeclaration=b,e.isGetAccessorDeclaration=x,e.isSetAccessorDeclaration=D,e.isCallSignatureDeclaration=S,e.isConstructSignatureDeclaration=C,e.isIndexSignatureDeclaration=k,e.isGetOrSetAccessorDeclaration=T,e.isTypePredicateNode=E,e.isTypeReferenceNode=N,e.isFunctionTypeNode=A,e.isConstructorTypeNode=F,e.isTypeQueryNode=P,e.isTypeLiteralNode=w,e.isArrayTypeNode=I,e.isTupleTypeNode=O,e.isUnionTypeNode=M,e.isIntersectionTypeNode=L,e.isConditionalTypeNode=R,e.isInferTypeNode=B,e.isParenthesizedTypeNode=j,e.isThisTypeNode=J,e.isTypeOperatorNode=z,e.isIndexedAccessTypeNode=V,e.isMappedTypeNode=U,e.isLiteralTypeNode=K,e.isImportTypeNode=q,e.isObjectBindingPattern=W,e.isArrayBindingPattern=H,e.isBindingElement=G,e.isArrayLiteralExpression=Q,e.isObjectLiteralExpression=X,e.isPropertyAccessExpression=Y,e.isElementAccessExpression=Z,e.isCallExpression=$,e.isNewExpression=et,e.isTaggedTemplateExpression=tt,e.isTypeAssertion=rt,e.isConstTypeReference=nt,e.isParenthesizedExpression=it,e.skipPartiallyEmittedExpressions=at,e.isFunctionExpression=ot,e.isArrowFunction=st,e.isDeleteExpression=ct,e.isTypeOfExpression=ut,e.isVoidExpression=lt,e.isAwaitExpression=_t,e.isPrefixUnaryExpression=dt,e.isPostfixUnaryExpression=pt,e.isBinaryExpression=ft,e.isConditionalExpression=mt,e.isTemplateExpression=gt,e.isYieldExpression=vt,e.isSpreadElement=yt,e.isClassExpression=ht,e.isOmittedExpression=bt,e.isExpressionWithTypeArguments=xt,e.isAsExpression=Dt,e.isNonNullExpression=St,e.isMetaProperty=Ct,e.isTemplateSpan=kt,e.isSemicolonClassElement=Tt,e.isBlock=Et,e.isVariableStatement=Nt,e.isEmptyStatement=At,e.isExpressionStatement=Ft,e.isIfStatement=Pt,e.isDoStatement=wt,e.isWhileStatement=It,e.isForStatement=Ot,e.isForInStatement=Mt,e.isForOfStatement=Lt,e.isContinueStatement=Rt,e.isBreakStatement=Bt,e.isBreakOrContinueStatement=jt,e.isReturnStatement=Jt,e.isWithStatement=zt,e.isSwitchStatement=Vt,e.isLabeledStatement=Ut,e.isThrowStatement=Kt,e.isTryStatement=qt,e.isDebuggerStatement=Wt,e.isVariableDeclaration=Ht,e.isVariableDeclarationList=Gt,e.isFunctionDeclaration=Qt,e.isClassDeclaration=Xt,e.isInterfaceDeclaration=Yt,e.isTypeAliasDeclaration=Zt,e.isEnumDeclaration=$t,e.isModuleDeclaration=er,e.isModuleBlock=tr,e.isCaseBlock=rr,e.isNamespaceExportDeclaration=nr,e.isImportEqualsDeclaration=ir,e.isImportDeclaration=ar,e.isImportClause=or,e.isNamespaceImport=sr,e.isNamedImports=cr,e.isImportSpecifier=ur,e.isExportAssignment=lr,e.isExportDeclaration=_r,e.isNamedExports=dr,e.isExportSpecifier=pr,e.isMissingDeclaration=fr,e.isExternalModuleReference=mr,e.isJsxElement=gr,e.isJsxSelfClosingElement=vr,e.isJsxOpeningElement=yr,e.isJsxClosingElement=hr,e.isJsxFragment=br,e.isJsxOpeningFragment=xr,e.isJsxClosingFragment=Dr,e.isJsxAttribute=Sr,e.isJsxAttributes=Cr,e.isJsxSpreadAttribute=kr,e.isJsxExpression=Tr,e.isCaseClause=Er,e.isDefaultClause=Nr,e.isHeritageClause=Ar,e.isCatchClause=Fr,e.isPropertyAssignment=Pr,e.isShorthandPropertyAssignment=wr,e.isSpreadAssignment=Ir,e.isEnumMember=Or,e.isSourceFile=Mr,e.isBundle=Lr,e.isUnparsedSource=Rr,e.isUnparsedPrepend=Br,e.isUnparsedTextLike=jr,e.isUnparsedNode=Jr,e.isJSDocTypeExpression=zr,e.isJSDocAllType=Vr,e.isJSDocUnknownType=Ur,e.isJSDocNullableType=Kr,e.isJSDocNonNullableType=qr,e.isJSDocOptionalType=Wr,e.isJSDocFunctionType=Hr,e.isJSDocVariadicType=Gr,e.isJSDoc=Qr,e.isJSDocAugmentsTag=Xr,e.isJSDocClassTag=Yr,e.isJSDocEnumTag=Zr,e.isJSDocThisTag=$r,e.isJSDocParameterTag=en,e.isJSDocReturnTag=tn,e.isJSDocTypeTag=rn,e.isJSDocTemplateTag=nn,e.isJSDocTypedefTag=an,e.isJSDocPropertyTag=on,e.isJSDocPropertyLikeTag=sn,e.isJSDocTypeLiteral=cn,e.isJSDocCallbackTag=un,e.isJSDocSignature=ln}(n||(n={})),function(e){function t(e){return 312===e.kind}function r(e){return n(e.kind)}function n(e){return e>=149}function i(e){return e.kind>=0&&e.kind<=148}function a(e){return e.hasOwnProperty("pos")&&e.hasOwnProperty("end")}function o(e){return e>=8&&14>=e}function s(e){return o(e.kind)}function c(e){return e>=14&&17>=e}function u(e){return c(e.kind)}function l(e){var t=e.kind;return 16===t||17===t}function _(t){return e.isImportSpecifier(t)||e.isExportSpecifier(t)}function d(e){return 10===e.kind||c(e.kind)}function p(t){return e.isIdentifier(t)&&(7&t.autoGenerateFlags)>0}function f(e){switch(e){case 119:case 122:case 78:case 126:case 81:case 86:case 116:case 114:case 115:case 134:case 117:return!0}return!1}function m(t){return!!(92&e.modifierToFlag(t))}function g(e){return m(e)||117===e}function v(e){return f(e.kind)}function y(e){var t=e.kind;return 149===t||73===t}function h(e){var t=e.kind;return 73===t||10===t||8===t||150===t}function b(e){var t=e.kind;return 73===t||185===t||186===t}function x(e){return e&&C(e.kind)}function D(e){return e&&S(e.kind)}function S(e){switch(e){case 240:case 157:case 158:case 159:case 160:case 197:case 198:return!0;default:return!1}}function C(e){switch(e){case 156:case 161:case 299:case 162:case 163:case 166:case 295:case 167:return!0;default:return S(e)}}function k(t){return e.isSourceFile(t)||e.isModuleBlock(t)||e.isBlock(t)&&x(t.parent)}function T(e){var t=e.kind;return 158===t||155===t||157===t||159===t||160===t||163===t||218===t}function E(e){return e&&(241===e.kind||210===e.kind)}function N(e){return e&&(159===e.kind||160===e.kind)}function A(e){switch(e.kind){case 157:case 159:case 160:return!0;default:return!1}}function F(e){var t=e.kind;return 162===t||161===t||154===t||156===t||163===t}function P(e){return F(e)||T(e)}function w(e){var t=e.kind;return 276===t||277===t||278===t||157===t||159===t||160===t}function I(t){return e.isTypeNodeKind(t.kind)}function O(e){switch(e.kind){case 166:case 167:return!0}return!1}function M(e){if(e){var t=e.kind;return 186===t||185===t}return!1}function L(e){var t=e.kind;return 188===t||189===t}function R(e){var t=e.kind;return 187===t||211===t}function B(e){switch(e.kind){case 238:case 152:case 187:return!0}return!1}function j(e){return J(e)||z(e)}function J(e){switch(e.kind){case 185:case 189:return!0}return!1}function z(e){switch(e.kind){case 186:case 188:return!0}return!1}function V(e){var t=e.kind;return 190===t||149===t||184===t}function U(e){var t=e.kind;return 190===t||149===t}function K(e){switch(e.kind){case 263:case 262:case 192:case 193:case 194:case 153:return!0;default:return!1}}function q(e){return 192===e.kind||193===e.kind}function W(e){var t=e.kind;return 207===t||14===t}function H(t){return G(e.skipPartiallyEmittedExpressions(t).kind)}function G(e){switch(e){case 190:case 191:case 193:case 192:case 261:case 262:case 265:case 194:case 188:case 196:case 189:case 210:case 197:case 73:case 13:case 8:case 9:case 10:case 14:case 207:case 88:case 97:case 101:case 103:case 99:case 214:case 215:case 93:return!0;default:return!1}}function Q(t){return X(e.skipPartiallyEmittedExpressions(t).kind)}function X(e){switch(e){case 203:case 204:case 199:case 200:case 201:case 202:case 195:return!0;default:return G(e)}}function Y(e){switch(e.kind){case 204:return!0;case 203:return 44===e.operator||45===e.operator;default:return!1}}function Z(t){return $(e.skipPartiallyEmittedExpressions(t).kind)}function $(e){switch(e){case 206:case 208:case 198:case 205:case 209:case 213:case 211:case 315:case 314:return!0;default:return X(e)}}function et(e){var t=e.kind;return 195===t||213===t}function tt(e){return 314===e.kind}function rt(e){return 313===e.kind}function nt(e){return rt(e)||tt(e)}function it(e,t){switch(e.kind){case 226:case 227:case 228:case 224:case 225:return!0;case 234:return t&&it(e.statement,t)}return!1}function at(e){return 227===e.kind||228===e.kind}function ot(t){return e.isBlock(t)||Z(t)}function st(t){return e.isBlock(t)}function ct(t){return e.isVariableDeclarationList(t)||Z(t)}function ut(e){var t=e.kind;return 246===t||245===t||73===t}function lt(e){var t=e.kind;return 246===t||245===t}function _t(e){var t=e.kind;return 73===t||245===t}function dt(e){var t=e.kind;return 253===t||252===t}function pt(e){return 245===e.kind||244===e.kind}function ft(e){return 198===e||187===e||241===e||210===e||158===e||244===e||279===e||258===e||240===e||197===e||159===e||251===e||249===e||254===e||242===e||268===e||157===e||156===e||245===e||248===e||252===e||152===e||276===e||155===e||154===e||160===e||277===e||243===e||151===e||238===e||310===e||303===e||311===e}function mt(e){return 240===e||259===e||241===e||242===e||243===e||244===e||245===e||250===e||249===e||256===e||255===e||248===e}function gt(e){return 230===e||229===e||237===e||224===e||222===e||221===e||227===e||228===e||226===e||223===e||234===e||231===e||233===e||235===e||236===e||220===e||225===e||232===e||313===e||317===e||316===e}function vt(t){return 151===t.kind?t.parent&&309!==t.parent.kind||e.isInJSFile(t):ft(t.kind)}function yt(e){return mt(e.kind)}function ht(e){return gt(e.kind)}function bt(e){var t=e.kind;return gt(t)||mt(t)||xt(e)}function xt(t){return 219!==t.kind?!1:void 0===t.parent||236!==t.parent.kind&&275!==t.parent.kind?!e.isFunctionBlock(t):!1}function Dt(e){var t=e.kind;return 260===t||149===t||73===t}function St(e){var t=e.kind;return 101===t||73===t||190===t}function Ct(e){var t=e.kind;return 261===t||271===t||262===t||11===t||265===t}function kt(e){var t=e.kind;return 268===t||270===t}function Tt(e){var t=e.kind;return 10===t||271===t}function Et(e){var t=e.kind;return 263===t||262===t}function Nt(e){var t=e.kind;return 272===t||273===t}function At(e){return e.kind>=289&&e.kind<=311}function Ft(t){return 297===t.kind||Pt(t)||e.isJSDocTypeLiteral(t)||e.isJSDocSignature(t)}function Pt(e){return e.kind>=300&&e.kind<=311}function wt(e){return 160===e.kind}function It(e){return 159===e.kind}function Ot(e){var t=e.jsDoc;return!!t&&t.length>0}function Mt(e){return!!e.type}function Lt(e){return!!e.initializer}function Rt(t){return Lt(t)&&!e.isForStatement(t)&&!e.isForInStatement(t)&&!e.isForOfStatement(t)&&!e.isJsxAttribute(t)}function Bt(e){return 268===e.kind||270===e.kind||w(e)}function jt(e){return 165===e.kind||212===e.kind}function Jt(t){for(var r=Vt,n=0,i=t;n<i.length;n++){var a=i[n];if(a.length){for(var o=0;o<a.length&&r>o&&e.isWhiteSpaceLike(a.charCodeAt(o));o++);if(r>o&&(r=o),0===r)return 0}}return r===Vt?void 0:r}function zt(e){return 10===e.kind||14===e.kind}e.isSyntaxList=t,e.isNode=r,e.isNodeKind=n,e.isToken=i,e.isNodeArray=a,e.isLiteralKind=o,e.isLiteralExpression=s,e.isTemplateLiteralKind=c,e.isTemplateLiteralToken=u,e.isTemplateMiddleOrTemplateTail=l,e.isImportOrExportSpecifier=_,e.isStringTextContainingNode=d,e.isGeneratedIdentifier=p,e.isModifierKind=f,e.isParameterPropertyModifier=m,e.isClassMemberModifier=g,e.isModifier=v,e.isEntityName=y,e.isPropertyName=h,e.isBindingName=b,e.isFunctionLike=x,e.isFunctionLikeDeclaration=D,e.isFunctionLikeKind=C,e.isFunctionOrModuleBlock=k,e.isClassElement=T,e.isClassLike=E,e.isAccessor=N,e.isMethodOrAccessor=A,e.isTypeElement=F,e.isClassOrTypeElement=P,e.isObjectLiteralElementLike=w,e.isTypeNode=I,e.isFunctionOrConstructorTypeNode=O,e.isBindingPattern=M,e.isAssignmentPattern=L,e.isArrayBindingElement=R,e.isDeclarationBindingElement=B,e.isBindingOrAssignmentPattern=j,e.isObjectBindingOrAssignmentPattern=J,e.isArrayBindingOrAssignmentPattern=z,e.isPropertyAccessOrQualifiedNameOrImportTypeNode=V,e.isPropertyAccessOrQualifiedName=U,e.isCallLikeExpression=K,e.isCallOrNewExpression=q,e.isTemplateLiteral=W,e.isLeftHandSideExpression=H,e.isUnaryExpression=Q,e.isUnaryExpressionWithWrite=Y,e.isExpression=Z,e.isAssertionExpression=et,e.isPartiallyEmittedExpression=tt,e.isNotEmittedStatement=rt,e.isNotEmittedOrPartiallyEmittedNode=nt,e.isIterationStatement=it,e.isForInOrOfStatement=at,e.isConciseBody=ot,e.isFunctionBody=st,e.isForInitializer=ct,e.isModuleBody=ut,e.isNamespaceBody=lt,e.isJSDocNamespaceBody=_t,e.isNamedImportBindings=dt,e.isModuleOrEnumDeclaration=pt,e.isDeclaration=vt,e.isDeclarationStatement=yt,e.isStatementButNotDeclaration=ht,e.isStatement=bt,e.isModuleReference=Dt,e.isJsxTagNameExpression=St,e.isJsxChild=Ct,e.isJsxAttributeLike=kt,e.isStringLiteralOrJsxExpression=Tt,e.isJsxOpeningLikeElement=Et,e.isCaseOrDefaultClause=Nt,e.isJSDocNode=At,e.isJSDocCommentContainingNode=Ft,e.isJSDocTag=Pt,e.isSetAccessor=wt,e.isGetAccessor=It,e.hasJSDocNodes=Ot,e.hasType=Mt,e.hasInitializer=Lt,e.hasOnlyExpressionInitializer=Rt,e.isObjectLiteralElement=Bt,e.isTypeReferenceType=jt;var Vt=1073741823;e.guessIndentation=Jt,e.isStringLiteralLike=zt}(n||(n={})),function(e){function t(e){return 253===e.kind||257===e.kind}function r(e,t){this.flags=e,this.escapedName=t,this.declarations=void 0,this.valueDeclaration=void 0,this.id=void 0,this.mergeId=void 0,this.parent=void 0}function n(t,r){this.flags=r,e.Debug.isDebugging&&(this.checker=t)}function i(){}function a(e,t,r){this.pos=t,this.end=r,this.kind=e,this.id=0,this.flags=0,this.modifierFlagsCache=0,this.transformFlags=0,this.parent=void 0,this.original=void 0}function o(e,t,r){this.fileName=e,this.text=t,this.skipTrivia=r||function(e){return e}}function s(t,r,n){return void 0===n&&(n=0),t.replace(/{(\d+)}/g,function(t,i){return""+e.Debug.assertDefined(r[+i+n])})}function c(t){return e.localizedDiagnosticMessages&&e.localizedDiagnosticMessages[t.key]||t.message}function u(t,r,n,i){e.Debug.assertGreaterThanOrEqual(r,0),e.Debug.assertGreaterThanOrEqual(n,0),t&&(e.Debug.assertLessThanOrEqual(r,t.text.length),e.Debug.assertLessThanOrEqual(r+n,t.text.length));var a=c(i);return arguments.length>4&&(a=s(a,arguments,4)),{file:t,start:r,length:n,messageText:a,category:i.category,code:i.code,reportsUnnecessary:i.reportsUnnecessary}}function l(e,t){var r=c(t);return arguments.length>2&&(r=s(r,arguments,2)),r}function _(e){var t=c(e);return arguments.length>1&&(t=s(t,arguments,1)),{file:void 0,start:void 0,length:void 0,messageText:t,category:e.category,code:e.code,reportsUnnecessary:e.reportsUnnecessary}}function d(e){return{file:void 0,start:void 0,length:void 0,code:e.code,category:e.category,messageText:e.next?e:e.messageText}}function p(e,t){var r=c(t);return arguments.length>2&&(r=s(r,arguments,2)),{messageText:r,category:t.category,code:t.code,next:e}}function f(e,t){for(var r=e;r.next;)r=r.next;return r.next=t,e}function m(e){return e.file?e.file.path:void 0}function g(e,t){return v(e,t)||y(e,t)||0}function v(t,r){return e.compareStringsCaseSensitive(m(t),m(r))||e.compareValues(t.start,r.start)||e.compareValues(t.length,r.length)||e.compareValues(t.code,r.code)||h(t.messageText,r.messageText)||0}function y(t,r){return t.relatedInformation||r.relatedInformation?t.relatedInformation&&r.relatedInformation?e.compareValues(t.relatedInformation.length,r.relatedInformation.length)||e.forEach(t.relatedInformation,function(e,t){var n=r.relatedInformation[t];return g(e,n)})||0:t.relatedInformation?-1:1:0}function h(t,r){for(var n=t,i=r;n&&i;){var a=e.isString(n)?n:n.messageText,o=e.isString(i)?i:i.messageText,s=e.compareStringsCaseSensitive(a,o);if(s)return s;n=e.isString(n)?void 0:n.next,i=e.isString(i)?void 0:i.next}return n||i?n?1:-1:0}function b(e){return e.target||0}function x(t){return"number"==typeof t.module?t.module:b(t)>=2?e.ModuleKind.ES2015:e.ModuleKind.CommonJS}function D(t){var r=t.moduleResolution;return void 0===r&&(r=x(t)===e.ModuleKind.CommonJS?e.ModuleResolutionKind.NodeJs:e.ModuleResolutionKind.Classic),r}function S(t){switch(x(t)){case e.ModuleKind.CommonJS:case e.ModuleKind.AMD:case e.ModuleKind.ES2015:case e.ModuleKind.ESNext:return!0;default:return!1}}function C(e){return e.allowUnreachableCode===!1}function k(e){return e.allowUnusedLabels===!1}function T(e){return!(!N(e)||!e.declarationMap)}function E(t){var r=x(t);return void 0!==t.allowSyntheticDefaultImports?t.allowSyntheticDefaultImports:t.esModuleInterop||r===e.ModuleKind.System}function N(e){return!(!e.declaration&&!e.composite)}function A(e){return!(!e.incremental&&!e.composite)}function F(e,t){return void 0===e[t]?!!e.strict:!!e[t]}function P(t,r){return r!==t&&e.semanticDiagnosticsOptionDeclarations.some(function(n){return!e.isJsonEqual(I(r,n),I(t,n))})}function w(t,r){return r!==t&&e.affectsEmitOptionDeclarations.some(function(n){return!e.isJsonEqual(I(r,n),I(t,n))})}function I(e,t){return t.strictFlag?F(e,t.name):e[t.name]}function O(e){for(var t=!1,r=0;r<e.length;r++)if(42===e.charCodeAt(r)){if(t)return!1;t=!0}return!0}function M(t){return t.replace(at,e.directorySeparator)}function L(e){return e>=97&&122>=e||e>=65&&90>=e}function R(e,t){var r=e.charCodeAt(t);if(58===r)return t+1;if(37===r&&51===e.charCodeAt(t+1)){var n=e.charCodeAt(t+2);if(97===n||65===n)return t+3}return-1}function B(t){if(!t)return 0;var r=t.charCodeAt(0);if(47===r||92===r){if(t.charCodeAt(1)!==r)return 1;var n=t.indexOf(47===r?e.directorySeparator:nt,2);return 0>n?t.length:n+1}if(L(r)&&58===t.charCodeAt(1)){var i=t.charCodeAt(2);if(47===i||92===i)return 3;if(2===t.length)return 2}var a=t.indexOf(it);if(-1!==a){var o=a+it.length,s=t.indexOf(e.directorySeparator,o);if(-1!==s){var c=t.slice(0,a),u=t.slice(o,s);if("file"===c&&(""===u||"localhost"===u)&&L(t.charCodeAt(s+1))){var l=R(t,s+2);if(-1!==l){if(47===t.charCodeAt(l))return~(l+1);if(l===t.length)return~l}}return~(s+1)}return~t.length}return 0}function j(e){var t=B(e);return 0>t?~t:t}function J(t){return e.resolvePath(t)}function z(t){t=M(t);var r=Y(X(t)),n=r[0],i=r.slice(1);if(i.length){var a=n+i.join(e.directorySeparator);return{path:e.hasTrailingDirectorySeparator(t)?e.ensureTrailingDirectorySeparator(a):a,parts:i}}return{path:n,parts:i}}function V(t){t=M(t);var r=j(t);return r===t.length?t:(t=e.removeTrailingDirectorySeparator(t),t.slice(0,Math.max(r,t.lastIndexOf(e.directorySeparator))))}function U(t,r,n){var i=n(t),a=n(r);return e.startsWith(i,a+"/")||e.startsWith(i,a+"\\")}function K(e){return B(e)<0}function q(e){return/^\.\.?($|[\\\/])/.test(e)
}function W(e){return B(e)>0}function H(e){var t=B(e);return t>0&&t===e.length}function G(t,r,n){return W(t)?e.getRelativePathToDirectoryOrUrl(r,t,r,n,!1):t}function Q(t,r){var n=t.substring(0,r),i=t.substring(r).split(e.directorySeparator);return i.length&&!e.lastOrUndefined(i)&&i.pop(),[n].concat(i)}function X(t,r){void 0===r&&(r=""),t=e.combinePaths(r,t);var n=j(t);return Q(t,n)}function Y(t){if(!e.some(t))return[];for(var r=[t[0]],n=1;n<t.length;n++){var i=t[n];if(i&&"."!==i){if(".."===i)if(r.length>1){if(".."!==r[r.length-1]){r.pop();continue}}else if(r[0])continue;r.push(i)}}return r}function Z(e,t){return Y(X(e,t))}function $(e,t){return et(Z(e,t))}function et(t){if(0===t.length)return"";var r=t[0]&&e.ensureTrailingDirectorySeparator(t[0]);return r+t.slice(1).join(e.directorySeparator)}function tt(e,t){return rt(Z(e,t))}function rt(t){return 0===t.length?"":t.slice(1).join(e.directorySeparator)}e.isNamedImportsOrExports=t,e.objectAllocator={getNodeConstructor:function(){return a},getTokenConstructor:function(){return a},getIdentifierConstructor:function(){return a},getSourceFileConstructor:function(){return a},getSymbolConstructor:function(){return r},getTypeConstructor:function(){return n},getSignatureConstructor:function(){return i},getSourceMapSourceConstructor:function(){return o}},e.formatStringFromArgs=s,e.getLocaleSpecificMessage=c,e.createFileDiagnostic=u,e.formatMessage=l,e.createCompilerDiagnostic=_,e.createCompilerDiagnosticFromMessageChain=d,e.chainDiagnosticMessages=p,e.concatenateDiagnosticMessageChains=f,e.compareDiagnostics=g,e.compareDiagnosticsSkipRelatedInformation=v,e.getEmitScriptTarget=b,e.getEmitModuleKind=x,e.getEmitModuleResolutionKind=D,e.hasJsonModuleEmitEnabled=S,e.unreachableCodeIsError=C,e.unusedLabelIsError=k,e.getAreDeclarationMapsEnabled=T,e.getAllowSyntheticDefaultImports=E,e.getEmitDeclarations=N,e.isIncrementalCompilation=A,e.getStrictOptionValue=F,e.compilerOptionsAffectSemanticDiagnostics=P,e.compilerOptionsAffectEmit=w,e.getCompilerOptionValue=I,e.hasZeroOrOneAsteriskCharacter=O,e.directorySeparator="/";var nt="\\",it="://",at=/\\/g;e.normalizeSlashes=M,e.getRootLength=j,e.normalizePath=J,e.normalizePathAndParts=z,e.getDirectoryPath=V,e.startsWithDirectory=U,e.isUrl=K,e.pathIsRelative=q,e.isRootedDiskPath=W,e.isDiskPathRoot=H,e.convertToRelativePath=G,e.getPathComponents=X,e.reducePathComponents=Y,e.getNormalizedPathComponents=Z,e.getNormalizedAbsolutePath=$,e.getPathFromPathComponents=et,e.getNormalizedAbsolutePathWithoutRoot=tt}(n||(n={})),function(e){function t(t,r,n,i){var a,o=e.reducePathComponents(e.getPathComponents(t)),s=e.reducePathComponents(e.getPathComponents(r));for(a=0;a<o.length&&a<s.length;a++){var c=i(o[a]),u=i(s[a]),l=0===a?e.equateStringsCaseInsensitive:n;if(!l(c,u))break}if(0===a)return s;for(var _=s.slice(a),d=[];a<o.length;a++)d.push("..");return[""].concat(d,_)}function r(t,r,i){return a(n(e.getDirectoryPath(t),r,i))}function n(r,n,i){e.Debug.assert(e.getRootLength(r)>0==e.getRootLength(n)>0,"Paths must either both be absolute or both be relative");var a="function"==typeof i?i:e.identity,o="boolean"==typeof i?i:!1,s=t(r,n,o?e.equateStringsCaseInsensitive:e.equateStringsCaseSensitive,a);return e.getPathFromPathComponents(s)}function i(r,n,i,a,o){var s=t(c(i,r),c(i,n),e.equateStringsCaseSensitive,a),u=s[0];if(o&&e.isRootedDiskPath(u)){var l=u.charAt(0)===e.directorySeparator?"file://":"file:///";s[0]=l+u}return e.getPathFromPathComponents(s)}function a(t){return 0!==e.getRootLength(t)||e.pathIsRelative(t)?t:"./"+t}function o(t,r,n){t=e.normalizeSlashes(t);var i=e.getRootLength(t);if(i===t.length)return"";t=l(t);var a=t.slice(Math.max(e.getRootLength(t),t.lastIndexOf(e.directorySeparator)+1)),o=void 0!==r&&void 0!==n?it(a,r,n):void 0;return o?a.slice(0,a.length-o.length):a}function s(t){for(var r=[],n=1;n<arguments.length;n++)r[n-1]=arguments[n];t&&(t=e.normalizeSlashes(t));for(var i=0,a=r;i<a.length;i++){var o=a[i];o&&(o=e.normalizeSlashes(o),t=t&&0===e.getRootLength(o)?_(t)+o:o)}return t}function c(t){for(var r=[],n=1;n<arguments.length;n++)r[n-1]=arguments[n];var i=e.some(r)?s.apply(void 0,[t].concat(r)):e.normalizeSlashes(t),a=e.getPathFromPathComponents(e.reducePathComponents(e.getPathComponents(i)));return a&&u(i)?_(a):a}function u(e){if(0===e.length)return!1;var t=e.charCodeAt(e.length-1);return 47===t||92===t}function l(e){return u(e)?e.substr(0,e.length-1):e}function _(t){return u(t)?t:t+e.directorySeparator}function d(t,r,n){if(t===r)return 0;if(void 0===t)return-1;if(void 0===r)return 1;var i=t.substring(0,e.getRootLength(t)),a=r.substring(0,e.getRootLength(r)),o=e.compareStringsCaseInsensitive(i,a);if(0!==o)return o;var s=t.substring(i.length),c=r.substring(a.length);if(!vt.test(s)&&!vt.test(c))return n(s,c);for(var u=e.reducePathComponents(e.getPathComponents(t)),l=e.reducePathComponents(e.getPathComponents(r)),_=Math.min(u.length,l.length),d=1;_>d;d++){var p=n(u[d],l[d]);if(0!==p)return p}return e.compareValues(u.length,l.length)}function p(t,r){return d(t,r,e.compareStringsCaseSensitive)}function f(t,r){return d(t,r,e.compareStringsCaseInsensitive)}function m(t,r,n,i){return"string"==typeof n?(t=s(n,t),r=s(n,r)):"boolean"==typeof n&&(i=n),d(t,r,e.getStringComparer(i))}function g(t,r,n,i){if("string"==typeof n?(t=s(n,t),r=s(n,r)):"boolean"==typeof n&&(i=n),void 0===t||void 0===r)return!1;if(t===r)return!0;var a=e.reducePathComponents(e.getPathComponents(t)),o=e.reducePathComponents(e.getPathComponents(r));if(o.length<a.length)return!1;for(var c=i?e.equateStringsCaseInsensitive:e.equateStringsCaseSensitive,u=0;u<a.length;u++){var l=0===u?e.equateStringsCaseInsensitive:c;if(!l(a[u],o[u]))return!1}return!0}function v(e){return 47===e||92===e}function y(e){return v(e.charCodeAt(0))?e.slice(1):void 0}function h(t,r,n){var i=e.tryRemovePrefix(t,r,n);return void 0===i?void 0:y(i)}function b(e){return e.replace(yt,x)}function x(e){return"\\"+e}function D(t){return e.stringContains(o(t),".")}function S(e,t,r){var n=C(e,t,r);if(!n||!n.length)return void 0;var i=n.map(function(e){return"("+e+")"}).join("|"),a="exclude"===r?"($|/)":"$";return"^("+i+")"+a}function C(t,r,n){return void 0===t||0===t.length?void 0:e.flatMap(t,function(e){return e&&T(e,r,n,Ct[n])})}function k(e){return!/[.*?]/.test(e)}function T(t,r,n,i){var a=i.singleAsteriskRegexFragment,o=i.doubleAsteriskRegexFragment,s=i.replaceWildcardCharacter,c="",u=!1,_=e.getNormalizedPathComponents(t,r),d=e.last(_);if("exclude"!==n&&"**"===d)return void 0;_[0]=l(_[0]),k(d)&&_.push("**","*");for(var p=0,f=0,m=_;f<m.length;f++){var g=m[f];if("**"===g)c+=o;else if("directories"===n&&(c+="(",p++),u&&(c+=e.directorySeparator),"exclude"!==n){var v="";42===g.charCodeAt(0)?(v+="([^./]"+a+")?",g=g.substr(1)):63===g.charCodeAt(0)&&(v+="[^./]",g=g.substr(1)),v+=g.replace(yt,s),v!==g&&(c+=bt),c+=v}else c+=g.replace(yt,s);u=!0}for(;p>0;)c+=")?",p--;return c}function E(e,t){return"*"===e?t:"?"===e?"[^/]":"\\"+e}function N(t,r,n,i,a){t=e.normalizePath(t),a=e.normalizePath(a);var o=s(a,t);return{includeFilePatterns:e.map(C(n,o,"files"),function(e){return"^"+e+"$"}),includeFilePattern:S(n,o,"files"),includeDirectoryPattern:S(n,o,"directories"),excludePattern:S(r,o,"exclude"),basePaths:P(t,n,i)}}function A(e,t){return new RegExp(e,t?"":"i")}function F(t,r,n,i,a,o,c,u,l){function _(t,n,i){var a=y(l(n));if(!v.has(a)){v.set(a,!0);for(var o=u(t),c=o.files,d=o.directories,h=function(i){var a=s(t,i),o=s(n,i);if(r&&!e.fileExtensionIsOneOf(a,r))return"continue";if(m&&m.test(o))return"continue";if(p){var c=e.findIndex(p,function(e){return e.test(o)});-1!==c&&g[c].push(a)}else g[0].push(a)},b=0,x=e.sort(c,e.compareStringsCaseSensitive);b<x.length;b++){var D=x[b];h(D)}if(void 0===i||(i--,0!==i))for(var S=0,C=e.sort(d,e.compareStringsCaseSensitive);S<C.length;S++){var D=C[S],k=s(t,D),T=s(n,D);f&&!f.test(T)||m&&m.test(T)||_(k,T,i)}}}t=e.normalizePath(t),o=e.normalizePath(o);for(var d=N(t,n,i,a,o),p=d.includeFilePatterns&&d.includeFilePatterns.map(function(e){return A(e,a)}),f=d.includeDirectoryPattern&&A(d.includeDirectoryPattern,a),m=d.excludePattern&&A(d.excludePattern,a),g=p?p.map(function(){return[]}):[[]],v=e.createMap(),y=e.createGetCanonicalFileName(a),h=0,b=d.basePaths;h<b.length;h++){var x=b[h];_(x,s(o,x),c)}return e.flatten(g)}function P(t,r,n){var i=[t];if(r){for(var a=[],o=0,c=r;o<c.length;o++){var u=c[o],l=e.isRootedDiskPath(u)?u:e.normalizePath(s(t,u));a.push(w(l))}a.sort(e.getStringComparer(!n));for(var _=function(r){e.every(i,function(e){return!g(e,r,t,!n)})&&i.push(r)},d=0,p=a;d<p.length;d++){var f=p[d];_(f)}}return i}function w(t){var r=e.indexOfAnyCharCode(t,ht);return 0>r?D(t)?l(e.getDirectoryPath(t)):t:t.substring(0,t.lastIndexOf(e.directorySeparator,r))}function I(e,t){return t||O(e)||3}function O(e){var t=e.substr(e.lastIndexOf("."));switch(t.toLowerCase()){case".js":return 1;case".jsx":return 2;case".ts":return 3;case".tsx":return 4;case".json":return 6;default:return 0}}function M(t,r){var n=t&&t.allowJs;if(!r||0===r.length)return n?kt:e.supportedTSExtensions;var i=(n?kt:e.supportedTSExtensions).concat(e.mapDefined(r,function(e){return 7===e.scriptKind||n&&R(e.scriptKind)?e.extension:void 0}));return e.deduplicate(i,e.equateStringsCaseSensitive,e.compareStringsCaseSensitive)}function L(t,r){return t&&t.resolveJsonModule?r===kt?Tt:r===e.supportedTSExtensions?e.supportedTSExtensionsWithJson:r.concat([".json"]):r}function R(e){return 1===e||2===e}function B(t){return e.some(e.supportedJSExtensions,function(r){return e.fileExtensionIs(t,r)})}function j(t){return e.supportedJSAndJsonExtensions.some(function(r){return e.fileExtensionIs(t,r)})}function J(t){return e.some(e.supportedTSExtensions,function(r){return e.fileExtensionIs(t,r)})}function z(t,r,n){if(!t)return!1;for(var i=M(r,n),a=0,o=L(r,i);a<o.length;a++){var s=o[a];if(e.fileExtensionIs(t,s))return!0}return!1}function V(t,r){for(var n=r.length-1;n>=0;n--)if(e.fileExtensionIs(t,r[n]))return U(n,r);return 0}function U(e,t){return 2>e?0:e<t.length?2:t.length}function K(e,t){return 2>e?2:t.length}function q(e){for(var t=0,r=Nt;t<r.length;t++){var n=r[t],i=W(e,n);if(void 0!==i)return i}return e}function W(t,r){return e.fileExtensionIs(t,r)?H(t,r):void 0}function H(e,t){return e.substring(0,e.length-t.length)}function G(e,t){return Q(e,t,Nt,!1)}function Q(t,r,n,i){var a=void 0!==n&&void 0!==i?it(t,n,i):it(t);return a?t.slice(0,t.length-a.length)+(e.startsWith(r,".")?r:"."+r):t}function X(t){e.Debug.assert(e.hasZeroOrOneAsteriskCharacter(t));var r=t.indexOf("*");return-1===r?void 0:{prefix:t.substr(0,r),suffix:t.substr(r+1)}}function Y(e){return!(e>=0)}function Z(e){return".ts"===e||".tsx"===e||".d.ts"===e}function $(e){return Z(e)||".json"===e}function et(t){var r=rt(t);return void 0!==r?r:e.Debug.fail("File "+t+" has unknown extension.")}function tt(e){return void 0!==rt(e)}function rt(t){return e.find(Nt,function(r){return e.fileExtensionIs(t,r)})}function nt(t,r,n){"string"==typeof r&&(r=[r]);for(var i=0,a=r;i<a.length;i++){var o=a[i];if(e.startsWith(o,".")||(o="."+o),t.length>=o.length&&"."===t.charAt(t.length-o.length)){var s=t.slice(t.length-o.length);if(n(s,o))return s}}return""}function it(t,r,n){if(r)return nt(t,r,n?e.equateStringsCaseInsensitive:e.equateStringsCaseSensitive);var i=o(t),a=i.lastIndexOf(".");return a>=0?i.substring(a):""}function at(e,t){return e.checkJsDirective?e.checkJsDirective.enabled:t.checkJs}function ot(t,r){for(var n=[],i=0,a=t;i<a.length;i++){var o=a[i],s=X(o);if(s)n.push(s);else if(o===r)return o}return e.findBestPatternMatch(n,function(e){return e},r)}function st(t,r){var n=t.indexOf(r);return e.Debug.assert(-1!==n),t.slice(n)}function ct(e){for(var t,r=[],n=1;n<arguments.length;n++)r[n-1]=arguments[n];return e.relatedInformation||(e.relatedInformation=[]),(t=e.relatedInformation).push.apply(t,r),e}function ut(t,r){e.Debug.assert(0!==t.length);for(var n=r(t[0]),i=n,a=1;a<t.length;a++){var o=r(t[a]);n>o?n=o:o>i&&(i=o)}return{min:n,max:i}}function lt(t){return{pos:e.getTokenPosOfNode(t),end:t.end}}function _t(e){return{pos:e.pos-1,end:e.end+1}}function dt(e,t){return t.skipLibCheck&&e.isDeclarationFile||t.skipDefaultLibCheck&&e.hasNoDefaultLib}function pt(t,r){return t===r||"object"==typeof t&&null!==t&&"object"==typeof r&&null!==r&&e.equalOwnProperties(t,r,pt)}function ft(e,t,r){var n=e.get(t);if(void 0===n){var i=r();return e.set(t,i),i}return n}function mt(e){var t;switch(e.charCodeAt(1)){case 98:case 66:t=1;break;case 111:case 79:t=3;break;case 120:case 88:t=4;break;default:for(var r=e.length-1,n=0;48===e.charCodeAt(n);)n++;return e.slice(n,r)||"0"}for(var i=2,a=e.length-1,o=(a-i)*t,s=new Uint16Array((o>>>4)+(15&o?1:0)),c=a-1,u=0;c>=i;c--,u+=t){var l=u>>>4,_=e.charCodeAt(c),d=57>=_?_-48:10+_-(70>=_?65:97),p=d<<(15&u);s[l]|=p;var f=p>>>16;f&&(s[l+1]|=f)}for(var m="",g=s.length-1,v=!0;v;){var y=0;v=!1;for(var l=g;l>=0;l--){var h=y<<16|s[l],b=h/10|0;s[l]=b,y=h-10*b,b&&!v&&(g=l,v=!0)}m=y+m}return m}function gt(e){var t=e.negative,r=e.base10Value;return(t&&"0"!==r?"-":"")+r}e.getPathComponentsRelativeTo=t,e.getRelativePathFromFile=r,e.getRelativePathFromDirectory=n,e.getRelativePathToDirectoryOrUrl=i,e.ensurePathIsNonModuleName=a,e.getBaseFileName=o,e.combinePaths=s,e.resolvePath=c,e.hasTrailingDirectorySeparator=u,e.removeTrailingDirectorySeparator=l,e.ensureTrailingDirectorySeparator=_;var vt=/(^|\/)\.{0,2}($|\/)/;e.comparePathsCaseSensitive=p,e.comparePathsCaseInsensitive=f,e.comparePaths=m,e.containsPath=g,e.tryRemoveDirectoryPrefix=h;var yt=/[^\w\s\/]/g;e.regExpEscape=b;var ht=[42,63];e.hasExtension=D,e.commonPackageFolders=["node_modules","bower_components","jspm_packages"];var bt="(?!("+e.commonPackageFolders.join("|")+")(/|$))",xt={singleAsteriskRegexFragment:"([^./]|(\\.(?!min\\.js$))?)*",doubleAsteriskRegexFragment:"(/"+bt+"[^/.][^/]*)*?",replaceWildcardCharacter:function(e){return E(e,xt.singleAsteriskRegexFragment)}},Dt={singleAsteriskRegexFragment:"[^/]*",doubleAsteriskRegexFragment:"(/"+bt+"[^/.][^/]*)*?",replaceWildcardCharacter:function(e){return E(e,Dt.singleAsteriskRegexFragment)}},St={singleAsteriskRegexFragment:"[^/]*",doubleAsteriskRegexFragment:"(/.+?)?",replaceWildcardCharacter:function(e){return E(e,St.singleAsteriskRegexFragment)}},Ct={files:xt,directories:Dt,exclude:St};e.getRegularExpressionForWildcard=S,e.getRegularExpressionsForWildcards=C,e.isImplicitGlob=k,e.getFileMatcherPatterns=N,e.getRegexFromPattern=A,e.matchFiles=F,e.ensureScriptKind=I,e.getScriptKindFromFileName=O,e.supportedTSExtensions=[".ts",".tsx",".d.ts"],e.supportedTSExtensionsWithJson=[".ts",".tsx",".d.ts",".json"],e.supportedTSExtensionsForExtractExtension=[".d.ts",".ts",".tsx"],e.supportedJSExtensions=[".js",".jsx"],e.supportedJSAndJsonExtensions=[".js",".jsx",".json"];var kt=e.supportedTSExtensions.concat(e.supportedJSExtensions),Tt=e.supportedTSExtensions.concat(e.supportedJSExtensions,[".json"]);e.getSupportedExtensions=M,e.getSuppoertedExtensionsWithJsonIfResolveJsonModule=L,e.hasJSFileExtension=B,e.hasJSOrJsonFileExtension=j,e.hasTSFileExtension=J,e.isSupportedSourceFileName=z;var Et;!function(e){e[e.TypeScriptFiles=0]="TypeScriptFiles",e[e.DeclarationAndJavaScriptFiles=2]="DeclarationAndJavaScriptFiles",e[e.Highest=0]="Highest",e[e.Lowest=2]="Lowest"}(Et=e.ExtensionPriority||(e.ExtensionPriority={})),e.getExtensionPriority=V,e.adjustExtensionPriority=U,e.getNextLowestExtensionPriority=K;var Nt=[".d.ts",".ts",".js",".tsx",".jsx",".json"];e.removeFileExtension=q,e.tryRemoveExtension=W,e.removeExtension=H,e.changeExtension=G,e.changeAnyExtension=Q,e.tryParsePattern=X,e.positionIsSynthesized=Y,e.extensionIsTS=Z,e.resolutionExtensionIsTSOrJson=$,e.extensionFromPath=et,e.isAnySupportedFileExtension=tt,e.tryGetExtensionFromPath=rt,e.getAnyExtensionFromPath=it,e.isCheckJsEnabledForFile=at,e.emptyFileSystemEntries={files:e.emptyArray,directories:e.emptyArray},e.matchPatternOrExact=ot,e.sliceAfter=st,e.addRelatedInfo=ct,e.minAndMax=ut;var At=function(){function t(){this.map=e.createMap()}return t.prototype.add=function(t){this.map.set(String(e.getNodeId(t)),t)},t.prototype.tryAdd=function(e){return this.has(e)?!1:(this.add(e),!0)},t.prototype.has=function(t){return this.map.has(String(e.getNodeId(t)))},t.prototype.forEach=function(e){this.map.forEach(e)},t.prototype.some=function(t){return e.forEachEntry(this.map,t)||!1},t}();e.NodeSet=At;var Ft=function(){function t(){this.map=e.createMap()}return t.prototype.get=function(t){var r=this.map.get(String(e.getNodeId(t)));return r&&r.value},t.prototype.getOrUpdate=function(e,t){var r=this.get(e);if(r)return r;var n=t();return this.set(e,n),n},t.prototype.set=function(t,r){this.map.set(String(e.getNodeId(t)),{node:t,value:r})},t.prototype.has=function(t){return this.map.has(String(e.getNodeId(t)))},t.prototype.forEach=function(e){this.map.forEach(function(t){var r=t.node,n=t.value;return e(n,r)})},t}();e.NodeMap=Ft,e.rangeOfNode=lt,e.rangeOfTypeParameters=_t,e.skipTypeChecking=dt,e.isJsonEqual=pt,e.getOrUpdate=ft,e.parsePseudoBigInt=mt,e.pseudoBigIntToString=gt}(n||(n={}));var n;!function(e){function t(t,r,n){return 285===t?new(k||(k=e.objectAllocator.getSourceFileConstructor()))(t,r,n):73===t?new(C||(C=e.objectAllocator.getIdentifierConstructor()))(t,r,n):e.isNodeKind(t)?new(D||(D=e.objectAllocator.getNodeConstructor()))(t,r,n):new(S||(S=e.objectAllocator.getTokenConstructor()))(t,r,n)}function r(e,t){return t&&e(t)}function n(e,t,r){if(r){if(t)return t(r);for(var n=0,i=r;n<i.length;n++){var a=i[n],o=e(a);if(o)return o}}}function i(e,t){return 42===e.charCodeAt(t+1)&&42===e.charCodeAt(t+2)&&47!==e.charCodeAt(t+3)}function a(t,i,a){if(t&&!(t.kind<=148))switch(t.kind){case 149:return r(i,t.left)||r(i,t.right);case 151:return r(i,t.name)||r(i,t.constraint)||r(i,t.default)||r(i,t.expression);case 277:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.name)||r(i,t.questionToken)||r(i,t.exclamationToken)||r(i,t.equalsToken)||r(i,t.objectAssignmentInitializer);case 278:return r(i,t.expression);case 152:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.dotDotDotToken)||r(i,t.name)||r(i,t.questionToken)||r(i,t.type)||r(i,t.initializer);case 155:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.name)||r(i,t.questionToken)||r(i,t.exclamationToken)||r(i,t.type)||r(i,t.initializer);case 154:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.name)||r(i,t.questionToken)||r(i,t.type)||r(i,t.initializer);case 276:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.name)||r(i,t.questionToken)||r(i,t.initializer);case 238:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.name)||r(i,t.exclamationToken)||r(i,t.type)||r(i,t.initializer);case 187:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.dotDotDotToken)||r(i,t.propertyName)||r(i,t.name)||r(i,t.initializer);case 166:case 167:case 161:case 162:case 163:return n(i,a,t.decorators)||n(i,a,t.modifiers)||n(i,a,t.typeParameters)||n(i,a,t.parameters)||r(i,t.type);case 157:case 156:case 158:case 159:case 160:case 197:case 240:case 198:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.asteriskToken)||r(i,t.name)||r(i,t.questionToken)||r(i,t.exclamationToken)||n(i,a,t.typeParameters)||n(i,a,t.parameters)||r(i,t.type)||r(i,t.equalsGreaterThanToken)||r(i,t.body);case 165:return r(i,t.typeName)||n(i,a,t.typeArguments);case 164:return r(i,t.parameterName)||r(i,t.type);case 168:return r(i,t.exprName);case 169:return n(i,a,t.members);case 170:return r(i,t.elementType);case 171:return n(i,a,t.elementTypes);case 174:case 175:return n(i,a,t.types);case 176:return r(i,t.checkType)||r(i,t.extendsType)||r(i,t.trueType)||r(i,t.falseType);case 177:return r(i,t.typeParameter);case 184:return r(i,t.argument)||r(i,t.qualifier)||n(i,a,t.typeArguments);case 178:case 180:return r(i,t.type);case 181:return r(i,t.objectType)||r(i,t.indexType);case 182:return r(i,t.readonlyToken)||r(i,t.typeParameter)||r(i,t.questionToken)||r(i,t.type);case 183:return r(i,t.literal);case 185:case 186:return n(i,a,t.elements);case 188:return n(i,a,t.elements);case 189:return n(i,a,t.properties);case 190:return r(i,t.expression)||r(i,t.name);case 191:return r(i,t.expression)||r(i,t.argumentExpression);case 192:case 193:return r(i,t.expression)||n(i,a,t.typeArguments)||n(i,a,t.arguments);case 194:return r(i,t.tag)||n(i,a,t.typeArguments)||r(i,t.template);case 195:return r(i,t.type)||r(i,t.expression);case 196:return r(i,t.expression);case 199:return r(i,t.expression);case 200:return r(i,t.expression);case 201:return r(i,t.expression);case 203:return r(i,t.operand);case 208:return r(i,t.asteriskToken)||r(i,t.expression);case 202:return r(i,t.expression);case 204:return r(i,t.operand);case 205:return r(i,t.left)||r(i,t.operatorToken)||r(i,t.right);case 213:return r(i,t.expression)||r(i,t.type);case 214:return r(i,t.expression);case 215:return r(i,t.name);case 206:return r(i,t.condition)||r(i,t.questionToken)||r(i,t.whenTrue)||r(i,t.colonToken)||r(i,t.whenFalse);case 209:return r(i,t.expression);case 219:case 246:return n(i,a,t.statements);case 285:return n(i,a,t.statements)||r(i,t.endOfFileToken);case 220:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.declarationList);case 239:return n(i,a,t.declarations);case 222:return r(i,t.expression);case 223:return r(i,t.expression)||r(i,t.thenStatement)||r(i,t.elseStatement);case 224:return r(i,t.statement)||r(i,t.expression);case 225:return r(i,t.expression)||r(i,t.statement);case 226:return r(i,t.initializer)||r(i,t.condition)||r(i,t.incrementor)||r(i,t.statement);case 227:return r(i,t.initializer)||r(i,t.expression)||r(i,t.statement);case 228:return r(i,t.awaitModifier)||r(i,t.initializer)||r(i,t.expression)||r(i,t.statement);case 229:case 230:return r(i,t.label);case 231:return r(i,t.expression);case 232:return r(i,t.expression)||r(i,t.statement);case 233:return r(i,t.expression)||r(i,t.caseBlock);case 247:return n(i,a,t.clauses);case 272:return r(i,t.expression)||n(i,a,t.statements);case 273:return n(i,a,t.statements);case 234:return r(i,t.label)||r(i,t.statement);case 235:return r(i,t.expression);case 236:return r(i,t.tryBlock)||r(i,t.catchClause)||r(i,t.finallyBlock);case 275:return r(i,t.variableDeclaration)||r(i,t.block);case 153:return r(i,t.expression);case 241:case 210:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.name)||n(i,a,t.typeParameters)||n(i,a,t.heritageClauses)||n(i,a,t.members);case 242:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.name)||n(i,a,t.typeParameters)||n(i,a,t.heritageClauses)||n(i,a,t.members);case 243:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.name)||n(i,a,t.typeParameters)||r(i,t.type);case 244:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.name)||n(i,a,t.members);case 279:return r(i,t.name)||r(i,t.initializer);case 245:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.name)||r(i,t.body);case 249:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.name)||r(i,t.moduleReference);case 250:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.importClause)||r(i,t.moduleSpecifier);case 251:return r(i,t.name)||r(i,t.namedBindings);case 248:return r(i,t.name);case 252:return r(i,t.name);case 253:case 257:return n(i,a,t.elements);case 256:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.exportClause)||r(i,t.moduleSpecifier);case 254:case 258:return r(i,t.propertyName)||r(i,t.name);case 255:return n(i,a,t.decorators)||n(i,a,t.modifiers)||r(i,t.expression);case 207:return r(i,t.head)||n(i,a,t.templateSpans);case 217:return r(i,t.expression)||r(i,t.literal);case 150:return r(i,t.expression);case 274:return n(i,a,t.types);case 212:return r(i,t.expression)||n(i,a,t.typeArguments);case 260:return r(i,t.expression);case 259:return n(i,a,t.decorators);case 315:return n(i,a,t.elements);case 261:return r(i,t.openingElement)||n(i,a,t.children)||r(i,t.closingElement);case 265:return r(i,t.openingFragment)||n(i,a,t.children)||r(i,t.closingFragment);case 262:case 263:return r(i,t.tagName)||n(i,a,t.typeArguments)||r(i,t.attributes);case 269:return n(i,a,t.properties);case 268:return r(i,t.name)||r(i,t.initializer);case 270:return r(i,t.expression);case 271:return r(i,t.dotDotDotToken)||r(i,t.expression);case 264:return r(i,t.tagName);case 172:case 173:case 289:case 293:case 292:case 294:case 296:return r(i,t.type);case 295:return n(i,a,t.parameters)||r(i,t.type);case 297:return n(i,a,t.tags);case 305:case 311:return r(i,t.tagName)||(t.isNameFirst?r(i,t.name)||r(i,t.typeExpression):r(i,t.typeExpression)||r(i,t.name));case 301:return r(i,t.tagName)||r(i,t.class);case 309:return r(i,t.tagName)||r(i,t.constraint)||n(i,a,t.typeParameters);case 310:return r(i,t.tagName)||(t.typeExpression&&289===t.typeExpression.kind?r(i,t.typeExpression)||r(i,t.fullName):r(i,t.fullName)||r(i,t.typeExpression));case 303:return r(i,t.tagName)||r(i,t.fullName)||r(i,t.typeExpression);case 306:case 308:case 307:case 304:return r(i,t.tagName)||r(i,t.typeExpression);case 299:return e.forEach(t.typeParameters,i)||e.forEach(t.parameters,i)||r(i,t.type);case 298:return e.forEach(t.jsDocPropertyTags,i);case 300:case 302:return r(i,t.tagName);case 314:return r(i,t.expression)}}function o(t,r,n,i,a){void 0===i&&(i=!1),e.performance.mark("beforeParse");var o;return o=100===n?T.parseSourceFile(t,r,n,void 0,i,6):T.parseSourceFile(t,r,n,void 0,i,a),e.performance.mark("afterParse"),e.performance.measure("Parse","beforeParse","afterParse"),o}function s(e,t){return T.parseIsolatedEntityName(e,t)}function c(e,t){return T.parseJsonText(e,t)}function u(e){return void 0!==e.externalModuleIndicator}function l(e,t,r,n){void 0===n&&(n=!1);var i=E.updateSourceFile(e,t,r,n);return i.flags|=1572864&e.flags,i}function _(e,t,r){var n=T.JSDocParser.parseIsolatedJSDocComment(e,t,r);return n&&n.jsDoc&&T.fixupParentReferences(n.jsDoc),n}function d(e,t,r){return T.JSDocParser.parseJSDocTypeExpressionForTests(e,t,r)}function p(t){return e.fileExtensionIs(t,".d.ts")}function f(t,r){for(var n=[],i=0,a=e.getLeadingCommentRanges(r,0)||e.emptyArray;i<a.length;i++){var o=a[i],s=r.substring(o.pos,o.end);v(n,o,s)}t.pragmas=e.createMap();for(var c=0,u=n;c<u.length;c++){var l=u[c];if(t.pragmas.has(l.name)){var _=t.pragmas.get(l.name);_ instanceof Array?_.push(l.args):t.pragmas.set(l.name,[_,l.args])}else t.pragmas.set(l.name,l.args)}}function m(t,r){t.checkJsDirective=void 0,t.referencedFiles=[],t.typeReferenceDirectives=[],t.libReferenceDirectives=[],t.amdDependencies=[],t.hasNoDefaultLib=!1,t.pragmas.forEach(function(n,i){switch(i){case"reference":var a=t.referencedFiles,o=t.typeReferenceDirectives,s=t.libReferenceDirectives;e.forEach(e.toArray(n),function(n){var i=n.arguments,c=i.types,u=i.lib,l=i.path;n.arguments["no-default-lib"]?t.hasNoDefaultLib=!0:c?o.push({pos:c.pos,end:c.end,fileName:c.value}):u?s.push({pos:u.pos,end:u.end,fileName:u.value}):l?a.push({pos:l.pos,end:l.end,fileName:l.value}):r(n.range.pos,n.range.end-n.range.pos,e.Diagnostics.Invalid_reference_directive_syntax)});break;case"amd-dependency":t.amdDependencies=e.map(e.toArray(n),function(e){return{name:e.arguments.name,path:e.arguments.path}});break;case"amd-module":if(n instanceof Array)for(var c=0,u=n;c<u.length;c++){var l=u[c];t.moduleName&&r(l.range.pos,l.range.end-l.range.pos,e.Diagnostics.An_AMD_module_cannot_have_multiple_name_assignments),t.moduleName=l.arguments.name}else t.moduleName=n.arguments.name;break;case"ts-nocheck":case"ts-check":e.forEach(e.toArray(n),function(e){(!t.checkJsDirective||e.range.pos>t.checkJsDirective.pos)&&(t.checkJsDirective={enabled:"ts-check"===i,end:e.range.end,pos:e.range.pos})});break;case"jsx":return;default:e.Debug.fail("Unhandled pragma kind")}})}function g(e){if(N.has(e))return N.get(e);var t=new RegExp("(\\s"+e+"\\s*=\\s*)('|\")(.+?)\\2","im");return N.set(e,t),t}function v(t,r,n){var i=2===r.kind&&A.exec(n);if(i){var a=i[1].toLowerCase(),o=e.commentPragmas[a];if(!(o&&1&o.kind))return;if(o.args){for(var s={},c=0,u=o.args;c<u.length;c++){var l=u[c],_=g(l.name),d=_.exec(n);if(!d&&!l.optional)return;if(d)if(l.captureSpan){var p=r.pos+d.index+d[1].length+d[2].length;s[l.name]={value:d[3],pos:p,end:p+d[3].length}}else s[l.name]=d[3]}t.push({name:a,args:{arguments:s,range:r}})}else t.push({name:a,args:{arguments:{},range:r}})}else{var f=2===r.kind&&F.exec(n);if(f)return y(t,r,2,f);if(3===r.kind)for(var m=/\s*@(\S+)\s*(.*)\s*$/gim,v=void 0;v=m.exec(n);)y(t,r,4,v)}}function y(t,r,n,i){if(i){var a=i[1].toLowerCase(),o=e.commentPragmas[a];if(o&&o.kind&n){var s=i[2],c=h(o,s);"fail"!==c&&t.push({name:a,args:{arguments:c,range:r}})}}}function h(t,r){if(!r)return{};if(!t.args)return{};for(var n=r.split(/\s+/),i={},a=0;a<t.args.length;a++){var o=t.args[a];if(!n[a]&&!o.optional)return"fail";if(o.captureSpan)return e.Debug.fail("Capture spans not yet implemented for non-xml pragmas");i[o.name]=n[a]}return i}function b(e,t){return e.kind!==t.kind?!1:73===e.kind?e.escapedText===t.escapedText:101===e.kind?!0:e.name.escapedText===t.name.escapedText&&b(e.expression,t.expression)}var x;!function(e){e[e.None=0]="None",e[e.Yield=1]="Yield",e[e.Await=2]="Await",e[e.Type=4]="Type",e[e.IgnoreMissingOpenBrace=16]="IgnoreMissingOpenBrace",e[e.JSDoc=32]="JSDoc"}(x||(x={}));var D,S,C,k;e.createNode=t,e.isJSDocLikeText=i,e.forEachChild=a,e.createSourceFile=o,e.parseIsolatedEntityName=s,e.parseJsonText=c,e.isExternalModule=u,e.updateSourceFile=l,e.parseIsolatedJSDocComment=_,e.parseJSDocTypeExpressionForTests=d;var T;!function(t){function r(t,r,n,i,a,s){if(void 0===a&&(a=!1),s=e.ensureScriptKind(t,s),6===s){var _=o(t,r,n,i,a);return e.convertToObjectWorker(_,_.parseDiagnostics,!1,void 0,void 0),_.referencedFiles=e.emptyArray,_.typeReferenceDirectives=e.emptyArray,_.libReferenceDirectives=e.emptyArray,_.amdDependencies=e.emptyArray,_.hasNoDefaultLib=!1,_.pragmas=e.emptyMap,_}c(r,n,i,s);var d=l(t,n,a,s);return u(),d}function n(e,t){c(e,t,void 0,1),K();var r=ur(!0),n=1===U()&&!Bo.length;return u(),n?r:void 0}function o(t,r,n,i,a){void 0===n&&(n=2),c(r,n,i,6),Ro=g(t,2,6,!1),Ro.flags=Wo,K();var o=V();if(1===U())Ro.statements=gt([],o,o),Ro.endOfFileToken=lt();else{var s=ft(222);switch(U()){case 22:s.expression=Ri();break;case 103:case 88:case 97:s.expression=lt();break;case 39:s.expression=et(function(){return 8===K()&&57!==K()})?$n():ji();break;case 8:case 10:if(et(function(){return 57!==K()})){s.expression=fr();break}default:s.expression=ji()}vt(s),Ro.statements=gt([s],o),Ro.endOfFileToken=ct(1,e.Diagnostics.Unexpected_token)}a&&d(Ro),Ro.parseDiagnostics=Bo;var l=Ro;return u(),l}function s(e){return 4===e||2===e||1===e||6===e?1:0}function c(t,r,n,i){switch(Io=e.objectAllocator.getNodeConstructor(),Oo=e.objectAllocator.getTokenConstructor(),Mo=e.objectAllocator.getIdentifierConstructor(),Lo=e.objectAllocator.getSourceFileConstructor(),zo=t,jo=n,Bo=[],qo=0,Uo=e.createMap(),Ko=0,Vo=0,i){case 1:case 2:Wo=65536;break;case 6:Wo=16842752;break;default:Wo=0}Qo=!1,Ho.setText(zo),Ho.setOnError(z),Ho.setScriptTarget(r),Ho.setLanguageVariant(s(i))}function u(){Ho.setText(""),Ho.setOnError(void 0),Bo=void 0,Ro=void 0,Uo=void 0,jo=void 0,zo=void 0}function l(t,r,n,i){function a(t,r,n){Bo.push(e.createFileDiagnostic(Ro,t,r,n))}var o=p(t);return o&&(Wo|=4194304),Ro=g(t,r,i,o),Ro.flags=Wo,K(),f(Ro,zo),m(Ro,a),Ro.statements=Kt(0,va),e.Debug.assert(1===U()),Ro.endOfFileToken=_(lt()),No(Ro),Ro.nodeCount=Vo,Ro.identifierCount=Ko,Ro.identifiers=Uo,Ro.parseDiagnostics=Bo,n&&d(Ro),Ro}function _(t){e.Debug.assert(!t.jsDoc);var r=e.mapDefined(e.getJSDocCommentRanges(t,Ro.text),function(e){return Zo.parseJSDocComment(t,e.pos,e.end-e.pos)});return r.length&&(t.jsDoc=r),t}function d(t){function r(t){if(t.parent!==n){t.parent=n;var i=n;if(n=t,a(t,r),e.hasJSDocNodes(t))for(var o=0,s=t.jsDoc;o<s.length;o++){var c=s[o];c.parent=t,n=c,a(c,r)}n=i}}var n=t;a(t,r)}function g(t,r,n,i){var a=new Lo(285,0,zo.length);return Vo++,a.text=zo,a.bindDiagnostics=[],a.bindSuggestionDiagnostics=void 0,a.languageVersion=r,a.fileName=e.normalizePath(t),a.languageVariant=s(n),a.isDeclarationFile=i,a.scriptKind=n,a}function v(e,t){e?Wo|=t:Wo&=~t}function y(e){v(e,2048)}function h(e){v(e,4096)
}function x(e){v(e,8192)}function D(e){v(e,16384)}function S(e,t){var r=e&Wo;if(r){v(!1,r);var n=t();return v(!0,r),n}return t()}function C(e,t){var r=e&~Wo;if(r){v(!0,r);var n=t();return v(!1,r),n}return t()}function k(e){return S(2048,e)}function T(e){return C(2048,e)}function E(e){return C(4096,e)}function N(e){return C(8192,e)}function A(e){return C(16384,e)}function F(e){return S(16384,e)}function P(e){return C(20480,e)}function w(e){return 0!==(Wo&e)}function I(){return w(4096)}function O(){return w(2048)}function M(){return w(8192)}function L(){return w(16384)}function R(e,t){j(Ho.getTokenPos(),Ho.getTextPos(),e,t)}function B(t,r,n,i){var a=e.lastOrUndefined(Bo);a&&t===a.start||Bo.push(e.createFileDiagnostic(Ro,t,r,n,i)),Qo=!0}function j(e,t,r,n){B(e,t-e,r,n)}function J(e,t,r){j(e.pos,e.end,t,r)}function z(e,t){B(Ho.getTextPos(),t,e)}function V(){return Ho.getStartPos()}function U(){return Jo}function K(){return Jo=Ho.scan()}function q(){return Jo=Ho.scanJsDocToken()}function W(){return Jo=Ho.reScanGreaterToken()}function H(){return Jo=Ho.reScanSlashToken()}function G(){return Jo=Ho.reScanTemplateToken()}function Q(){return Jo=Ho.reScanLessThanToken()}function X(){return Jo=Ho.scanJsxIdentifier()}function Y(){return Jo=Ho.scanJsxToken()}function Z(){return Jo=Ho.scanJsxAttributeValue()}function $(t,r){var n=Jo,i=Bo.length,a=Qo,o=Wo,s=r?Ho.lookAhead(t):Ho.tryScan(t);return e.Debug.assert(o===Wo),(!s||r)&&(Jo=n,Bo.length=i,Qo=a),s}function et(e){return $(e,!0)}function tt(e){return $(e,!1)}function rt(){return 73===U()?!0:118===U()&&I()?!1:123===U()&&L()?!1:U()>109}function nt(t,r,n){return void 0===n&&(n=!0),U()===t?(n&&K(),!0):(r?R(r):R(e.Diagnostics._0_expected,e.tokenToString(t)),!1)}function it(t){return U()===t?(q(),!0):(R(e.Diagnostics._0_expected,e.tokenToString(t)),!1)}function at(e){return U()===e?(K(),!0):!1}function ot(e){return U()===e?lt():void 0}function st(e){return U()===e?_t():void 0}function ct(t,r,n){return ot(t)||yt(t,!1,r||e.Diagnostics._0_expected,n||e.tokenToString(t))}function ut(t){return st(t)||yt(t,!1,e.Diagnostics._0_expected,e.tokenToString(t))}function lt(){var e=ft(U());return K(),vt(e)}function _t(){var e=ft(U());return q(),vt(e)}function dt(){return 26===U()?!0:19===U()||1===U()||Ho.hasPrecedingLineBreak()}function pt(){return dt()?(26===U()&&K(),!0):nt(26)}function ft(t,r){Vo++;var n=r>=0?r:Ho.getStartPos();return e.isNodeKind(t)||0===t?new Io(t,n,n):73===t?new Mo(t,n,n):new Oo(t,n,n)}function mt(e,t){var r=ft(e,t);return 2&Ho.getTokenFlags()&&_(r),r}function gt(e,t,r){var n=e.length,i=n>=1&&4>=n?e.slice():e;return i.pos=t,i.end=void 0===r?Ho.getStartPos():r,i}function vt(e,t){return e.end=void 0===t?Ho.getStartPos():t,Wo&&(e.flags|=Wo),Qo&&(Qo=!1,e.flags|=32768),e}function yt(t,r,n,i){r?B(Ho.getStartPos(),0,n,i):n&&R(n,i);var a=ft(t);return 73===t?a.escapedText="":(e.isLiteralKind(t)||e.isTemplateLiteralKind(t))&&(a.text=""),vt(a)}function ht(e){var t=Uo.get(e);return void 0===t&&Uo.set(e,t=e),t}function bt(t,r){if(Ko++,t){var n=ft(73);return 73!==U()&&(n.originalKeywordKind=U()),n.escapedText=e.escapeLeadingUnderscores(ht(Ho.getTokenValue())),K(),vt(n)}var i=1===U();return yt(73,i,r||e.Diagnostics.Identifier_expected)}function xt(e){return bt(rt(),e)}function Dt(t){return bt(e.tokenIsIdentifierOrKeyword(U()),t)}function St(){return e.tokenIsIdentifierOrKeyword(U())||10===U()||8===U()}function Ct(e){if(10===U()||8===U()){var t=fr();return t.text=ht(t.text),t}return e&&22===U()?Tt():Dt()}function kt(){return Ct(!0)}function Tt(){var e=ft(150);return nt(22),e.expression=k(Pn),nt(23),vt(e)}function Et(e){return U()===e&&tt(At)}function Nt(){return K(),Ho.hasPrecedingLineBreak()?!1:Pt()}function At(){switch(U()){case 78:return 85===K();case 86:return K(),81===U()?et(wt):40!==U()&&120!==U()&&18!==U()&&Pt();case 81:return wt();case 117:case 127:case 138:return K(),Pt();default:return Nt()}}function Ft(){return e.isModifierKind(U())&&tt(At)}function Pt(){return 22===U()||18===U()||40===U()||25===U()||St()}function wt(){return K(),77===U()||91===U()||111===U()||119===U()&&et(ua)||122===U()&&et(la)}function It(t,r){var n=Wt(t);if(n)return!0;switch(t){case 0:case 1:case 3:return!(26===U()&&r)&&fa();case 2:return 75===U()||81===U();case 4:return et(Ur);case 5:return et(Ja)||26===U()&&!r;case 6:return 22===U()||St();case 12:switch(U()){case 22:case 40:case 25:case 24:return!0;default:return St()}case 18:return St();case 9:return 22===U()||25===U()||St();case 7:return 18===U()?et(Ot):r?rt()&&!Bt():Nn()&&!Bt();case 8:return Ea();case 10:return 27===U()||25===U()||Ea();case 19:return rt();case 15:switch(U()){case 27:case 24:return!0}case 11:return 25===U()||An();case 16:return wr(!1);case 17:return wr(!0);case 20:case 21:return 27===U()||ln();case 22:return eo();case 23:return e.tokenIsIdentifierOrKeyword(U());case 13:return e.tokenIsIdentifierOrKeyword(U())||18===U();case 14:return!0}return e.Debug.fail("Non-exhaustive case in 'isListElement'.")}function Ot(){if(e.Debug.assert(18===U()),19===K()){var t=K();return 27===t||18===t||87===t||110===t}return!0}function Mt(){return K(),rt()}function Lt(){return K(),e.tokenIsIdentifierOrKeyword(U())}function Rt(){return K(),e.tokenIsIdentifierOrKeywordOrGreaterThan(U())}function Bt(){return 110===U()||87===U()?et(jt):!1}function jt(){return K(),An()}function Jt(){return K(),ln()}function zt(e){if(1===U())return!0;switch(e){case 1:case 2:case 4:case 5:case 6:case 12:case 9:case 23:return 19===U();case 3:return 19===U()||75===U()||81===U();case 7:return 18===U()||87===U()||110===U();case 8:return Vt();case 19:return 30===U()||20===U()||18===U()||87===U()||110===U();case 11:return 21===U()||26===U();case 15:case 21:case 10:return 23===U();case 17:case 16:case 18:return 21===U()||23===U();case 20:return 27!==U();case 22:return 18===U()||19===U();case 13:return 30===U()||42===U();case 14:return 28===U()&&et(po);default:return!1}}function Vt(){return dt()?!0:Gn(U())?!0:37===U()?!0:!1}function Ut(){for(var e=0;24>e;e++)if(qo&1<<e&&(It(e,!0)||zt(e)))return!0;return!1}function Kt(e,t){var r=qo;qo|=1<<e;for(var n=[],i=V();!zt(e);)if(It(e,!1)){var a=qt(e,t);n.push(a)}else if(nr(e))break;return qo=r,gt(n,i)}function qt(e,t){var r=Wt(e);return r?Ht(r):t()}function Wt(t){if(!jo||!Gt(t)||Qo)return void 0;var r=jo.currentNode(Ho.getStartPos());if(e.nodeIsMissing(r)||r.intersectsChange||e.containsParseError(r))return void 0;var n=12679168&r.flags;return n!==Wo?void 0:Qt(r,t)?(r.jsDocCache&&(r.jsDocCache=void 0),r):void 0}function Ht(e){return Ho.setTextPos(e.end),K(),e}function Gt(e){switch(e){case 5:case 2:case 0:case 1:case 3:case 6:case 4:case 8:case 17:case 16:return!0}return!1}function Qt(e,t){switch(t){case 5:return Xt(e);case 2:return Yt(e);case 0:case 1:case 3:return Zt(e);case 6:return $t(e);case 4:return er(e);case 8:return tr(e);case 17:case 16:return rr(e)}return!1}function Xt(e){if(e)switch(e.kind){case 158:case 163:case 159:case 160:case 155:case 218:return!0;case 157:var t=e,r=73===t.name.kind&&125===t.name.originalKeywordKind;return!r}return!1}function Yt(e){if(e)switch(e.kind){case 272:case 273:return!0}return!1}function Zt(e){if(e)switch(e.kind){case 240:case 220:case 219:case 223:case 222:case 235:case 231:case 233:case 230:case 229:case 227:case 228:case 226:case 225:case 232:case 221:case 236:case 234:case 224:case 237:case 250:case 249:case 256:case 255:case 245:case 241:case 242:case 244:case 243:return!0}return!1}function $t(e){return 279===e.kind}function er(e){if(e)switch(e.kind){case 162:case 156:case 163:case 154:case 161:return!0}return!1}function tr(e){if(238!==e.kind)return!1;var t=e;return void 0===t.initializer}function rr(e){if(152!==e.kind)return!1;var t=e;return void 0===t.initializer}function nr(e){return R(ir(e)),Ut()?!0:(K(),!1)}function ir(t){switch(t){case 0:return e.Diagnostics.Declaration_or_statement_expected;case 1:return e.Diagnostics.Declaration_or_statement_expected;case 2:return e.Diagnostics.case_or_default_expected;case 3:return e.Diagnostics.Statement_expected;case 18:case 4:return e.Diagnostics.Property_or_signature_expected;case 5:return e.Diagnostics.Unexpected_token_A_constructor_method_accessor_or_property_was_expected;case 6:return e.Diagnostics.Enum_member_expected;case 7:return e.Diagnostics.Expression_expected;case 8:return e.Diagnostics.Variable_declaration_expected;case 9:return e.Diagnostics.Property_destructuring_pattern_expected;case 10:return e.Diagnostics.Array_element_destructuring_pattern_expected;case 11:return e.Diagnostics.Argument_expression_expected;case 12:return e.Diagnostics.Property_assignment_expected;case 15:return e.Diagnostics.Expression_or_comma_expected;case 17:return e.Diagnostics.Parameter_declaration_expected;case 16:return e.Diagnostics.Parameter_declaration_expected;case 19:return e.Diagnostics.Type_parameter_declaration_expected;case 20:return e.Diagnostics.Type_argument_expected;case 21:return e.Diagnostics.Type_expected;case 22:return e.Diagnostics.Unexpected_token_expected;case 23:return e.Diagnostics.Identifier_expected;case 13:return e.Diagnostics.Identifier_expected;case 14:return e.Diagnostics.Identifier_expected;default:return void 0}}function ar(e,t,r){var n=qo;qo|=1<<e;for(var i=[],a=V(),o=-1;;)if(It(e,!1)){var s=Ho.getStartPos();if(i.push(qt(e,t)),o=Ho.getTokenPos(),at(27))continue;if(o=-1,zt(e))break;nt(27),r&&26===U()&&!Ho.hasPrecedingLineBreak()&&K(),s===Ho.getStartPos()&&K()}else{if(zt(e))break;if(nr(e))break}qo=n;var c=gt(i,a);return o>=0&&(c.hasTrailingComma=!0),c}function or(){var e=gt([],V());return e.isMissingList=!0,e}function sr(e){return!!e.isMissingList}function cr(e,t,r,n){if(nt(r)){var i=ar(e,t);return nt(n),i}return or()}function ur(e,t){for(var r=e?Dt(t):xt(t),n=Ho.getStartPos();at(24);){if(28===U()){r.jsdocDotPos=n;break}n=Ho.getStartPos(),r=lr(r,_r(e))}return r}function lr(e,t){var r=ft(149,e.pos);return r.left=e,r.right=t,vt(r)}function _r(t){if(Ho.hasPrecedingLineBreak()&&e.tokenIsIdentifierOrKeyword(U())){var r=et(ca);if(r)return yt(73,!0,e.Diagnostics.Identifier_expected)}return t?Dt():xt()}function dr(){var t=ft(207);t.head=mr(),e.Debug.assert(15===t.head.kind,"Template head has wrong token kind");var r=[],n=V();do r.push(pr());while(16===e.last(r).literal.kind);return t.templateSpans=gt(r,n),vt(t)}function pr(){var t=ft(217);t.expression=k(Pn);var r;return 19===U()?(G(),r=gr()):r=ct(17,e.Diagnostics._0_expected,e.tokenToString(19)),t.literal=r,vt(t)}function fr(){return vr(U())}function mr(){var t=vr(U());return e.Debug.assert(15===t.kind,"Template head has wrong token kind"),t}function gr(){var t=vr(U());return e.Debug.assert(16===t.kind||17===t.kind,"Template fragment has wrong token kind"),t}function vr(e){var t=ft(e);return t.text=Ho.getTokenValue(),Ho.hasExtendedUnicodeEscape()&&(t.hasExtendedUnicodeEscape=!0),Ho.isUnterminated()&&(t.isUnterminated=!0),8===t.kind&&(t.numericLiteralFlags=1008&Ho.getTokenFlags()),K(),vt(t),t}function yr(){var t=ft(165);return t.typeName=ur(!0,e.Diagnostics.Type_expected),Ho.hasPrecedingLineBreak()||28!==Q()||(t.typeArguments=cr(20,kn,28,30)),vt(t)}function hr(t){switch(t.kind){case 165:return e.nodeIsMissing(t.typeName);case 166:case 167:var r=t,n=r.parameters,i=r.type;return sr(n)||hr(i);case 178:return hr(t.type);default:return!1}}function br(e){K();var t=ft(164,e.pos);return t.parameterName=e,t.type=kn(),vt(t)}function xr(){var e=ft(179);return K(),vt(e)}function Dr(e){var t=ft(290);return e?pn(294,t):(K(),vt(t))}function Sr(){var e=ft(293);return K(),e.type=un(),vt(e)}function Cr(){var e=Ho.getStartPos();if(K(),27===U()||19===U()||21===U()||30===U()||60===U()||50===U()){var t=ft(291,e);return vt(t)}var t=ft(292,e);return t.type=kn(),vt(t)}function kr(){if(et(_o)){var e=mt(295);return K(),Or(57,36,e),vt(e)}var t=ft(165);return t.typeName=Dt(),vt(t)}function Tr(){var e=ft(152);return(101===U()||96===U())&&(e.name=Dt(),nt(57)),e.type=Er(),vt(e)}function Er(){Ho.setInJSDocType(!0);var e=ot(25),t=Sn();if(Ho.setInJSDocType(!1),e){var r=ft(296,e.pos);r.type=t,t=vt(r)}return 60===U()?pn(294,t):t}function Nr(){var e=ft(168);return nt(105),e.exprName=ur(!0),vt(e)}function Ar(){var e=ft(151);return e.name=xt(),at(87)&&(ln()||!An()?e.constraint=kn():e.expression=ai()),at(60)&&(e.default=kn()),vt(e)}function Fr(){return 28===U()?cr(19,Ar,28,30):void 0}function Pr(){return at(57)?kn():void 0}function wr(t){return 25===U()||Ea()||e.isModifierKind(U())||58===U()||ln(!t)}function Ir(){var t=mt(152);return 101===U()?(t.name=bt(!0),t.type=Pr(),vt(t)):(t.decorators=za(),t.modifiers=Va(),t.dotDotDotToken=ot(25),t.name=Na(),0===e.getFullWidth(t.name)&&!e.hasModifiers(t)&&e.isModifierKind(U())&&K(),t.questionToken=ot(56),t.type=Pr(),t.initializer=wn(),vt(t))}function Or(e,t,r){32&t||(r.typeParameters=Fr());var n=Lr(r,t);return Mr(e,!!(4&t))&&(r.type=Sn(),hr(r.type))?!1:n}function Mr(t,r){return 37===t?(nt(t),!0):at(57)?!0:r&&37===U()?(R(e.Diagnostics._0_expected,e.tokenToString(57)),K(),!0):!1}function Lr(e,t){if(!nt(20))return e.parameters=or(),!1;var r=I(),n=L();return h(!!(1&t)),D(!!(2&t)),e.parameters=32&t?ar(17,Tr):ar(16,Ir),h(r),D(n),nt(21)}function Rr(){at(27)||pt()}function Br(e){var t=mt(e);return 162===e&&nt(96),Or(57,4,t),Rr(),vt(t)}function jr(){return 22===U()&&et(Jr)}function Jr(){if(K(),25===U()||23===U())return!0;if(e.isModifierKind(U())){if(K(),rt())return!0}else{if(!rt())return!1;K()}return 57===U()||27===U()?!0:56!==U()?!1:(K(),57===U()||27===U()||23===U())}function zr(e){return e.kind=163,e.parameters=cr(16,Ir,22,23),e.type=En(),Rr(),vt(e)}function Vr(e){return e.name=kt(),e.questionToken=ot(56),20===U()||28===U()?(e.kind=156,Or(57,4,e)):(e.kind=154,e.type=En(),60===U()&&(e.initializer=wn())),Rr(),vt(e)}function Ur(){if(20===U()||28===U())return!0;for(var t=!1;e.isModifierKind(U());)t=!0,K();return 22===U()?!0:(St()&&(t=!0,K()),t?20===U()||28===U()||56===U()||57===U()||27===U()||dt():!1)}function Kr(){if(20===U()||28===U())return Br(161);if(96===U()&&et(qr))return Br(162);var e=mt(0);return e.modifiers=Va(),jr()?zr(e):Vr(e)}function qr(){return K(),20===U()||28===U()}function Wr(){return 24===K()}function Hr(){switch(K()){case 20:case 28:case 24:return!0}return!1}function Gr(){var e=ft(169);return e.members=Qr(),vt(e)}function Qr(){var e;return nt(18)?(e=Kt(4,Kr),nt(19)):e=or(),e}function Xr(){return K(),38===U()||39===U()?134===K():(134===U()&&K(),22===U()&&Mt()&&94===K())}function Yr(){var e=ft(151);return e.name=xt(),nt(94),e.constraint=kn(),vt(e)}function Zr(){var e=ft(182);return nt(18),(134===U()||38===U()||39===U())&&(e.readonlyToken=lt(),134!==e.readonlyToken.kind&&ct(134)),nt(22),e.typeParameter=Yr(),nt(23),(56===U()||38===U()||39===U())&&(e.questionToken=lt(),56!==e.questionToken.kind&&ct(56)),e.type=En(),pt(),nt(19),vt(e)}function $r(){var e=V();if(at(25)){var t=ft(173,e);return t.type=kn(),vt(t)}var r=kn();return 2097152&Wo||292!==r.kind||r.pos!==r.type.pos||(r.kind=172),r}function en(){var e=ft(171);return e.elementTypes=cr(21,$r,22,23),vt(e)}function tn(){var e=ft(178);return nt(20),e.type=kn(),nt(21),vt(e)}function rn(){var e=V(),t=at(96)?167:166,r=mt(t,e);return Or(37,4,r),vt(r)}function nn(){var e=lt();return 24===U()?void 0:e}function an(e){var t,r=ft(183);e&&(t=ft(203),t.operator=39,K());var n=103===U()||88===U()?lt():vr(U());return e&&(t.operand=n,vt(t),n=t),r.literal=n,vt(r)}function on(){return K(),93===U()}function sn(){Ro.flags|=524288;var t=ft(184);return at(105)&&(t.isTypeOf=!0),nt(93),nt(20),t.argument=kn(),nt(21),at(24)&&(t.qualifier=ur(!0,e.Diagnostics.Type_expected)),Ho.hasPrecedingLineBreak()||28!==Q()||(t.typeArguments=cr(20,kn,28,30)),vt(t)}function cn(){return K(),8===U()||9===U()}function un(){switch(U()){case 121:case 144:case 139:case 136:case 147:case 140:case 124:case 142:case 133:case 137:return tt(nn)||yr();case 40:return Dr(!1);case 63:return Dr(!0);case 56:return Cr();case 91:return kr();case 52:return Sr();case 14:case 10:case 8:case 9:case 103:case 88:return an();case 39:return et(cn)?an(!0):yr();case 107:case 97:return lt();case 101:var e=xr();return 129!==U()||Ho.hasPrecedingLineBreak()?e:br(e);case 105:return et(on)?sn():Nr();case 18:return et(Xr)?Zr():Gr();case 22:return en();case 20:return tn();case 93:return sn();default:return yr()}}function ln(e){switch(U()){case 121:case 144:case 139:case 136:case 147:case 124:case 134:case 140:case 143:case 107:case 142:case 97:case 101:case 105:case 133:case 18:case 22:case 28:case 50:case 49:case 96:case 10:case 8:case 9:case 103:case 88:case 137:case 40:case 56:case 52:case 25:case 128:case 93:return!0;case 91:return!e;case 39:return!e&&et(cn);case 20:return!e&&et(_n);default:return rt()}}function _n(){return K(),21===U()||wr(!1)||ln()}function dn(){for(var e=un();!Ho.hasPrecedingLineBreak();)switch(U()){case 52:e=pn(293,e);break;case 56:if(!(2097152&Wo)&&et(Jt))return e;e=pn(292,e);break;case 22:if(nt(22),ln()){var t=ft(181,e.pos);t.objectType=e,t.indexType=kn(),nt(23),e=vt(t)}else{var t=ft(170,e.pos);t.elementType=e,nt(23),e=vt(t)}break;default:return e}return e}function pn(e,t){K();var r=ft(e,t.pos);return r.type=t,vt(r)}function fn(e){var t=ft(180);return nt(e),t.operator=e,t.type=gn(),vt(t)}function mn(){var e=ft(177);nt(128);var t=ft(151);return t.name=xt(),e.typeParameter=vt(t),vt(e)}function gn(){var e=U();switch(e){case 130:case 143:case 134:return fn(e);case 128:return mn()}return dn()}function vn(e,t,r){var n=Ho.getStartPos(),i=at(r),a=t();if(U()===r||i){for(var o=[a];at(r);)o.push(t());var s=ft(e,n);s.types=gt(o,n),a=vt(s)}return a}function yn(){return vn(175,gn,49)}function hn(){return vn(174,yn,50)}function bn(){return 28===U()?!0:20===U()&&et(Dn)}function xn(){if(e.isModifierKind(U())&&Va(),rt()||101===U())return K(),!0;if(22===U()||18===U()){var t=Bo.length;return Na(),t===Bo.length}return!1}function Dn(){if(K(),21===U()||25===U())return!0;if(xn()){if(57===U()||27===U()||56===U()||60===U())return!0;if(21===U()&&(K(),37===U()))return!0}return!1}function Sn(){var e=rt()&&tt(Cn),t=kn();if(e){var r=ft(164,e.pos);return r.parameterName=e,r.type=t,vt(r)}return t}function Cn(){var e=xt();return 129!==U()||Ho.hasPrecedingLineBreak()?void 0:(K(),e)}function kn(){return S(20480,Tn)}function Tn(e){if(bn()||96===U())return rn();var t=hn();if(!e&&!Ho.hasPrecedingLineBreak()&&at(87)){var r=ft(176,t.pos);return r.checkType=t,r.extendsType=Tn(!0),nt(56),r.trueType=Tn(),nt(57),r.falseType=Tn(),vt(r)}return t}function En(){return at(57)?kn():void 0}function Nn(){switch(U()){case 101:case 99:case 97:case 103:case 88:case 8:case 9:case 10:case 14:case 15:case 20:case 22:case 18:case 91:case 77:case 96:case 42:case 65:case 73:return!0;case 93:return et(Hr);default:return rt()}}function An(){if(Nn())return!0;switch(U()){case 38:case 39:case 53:case 52:case 82:case 105:case 107:case 44:case 45:case 28:case 123:case 118:return!0;default:return Xn()?!0:rt()}}function Fn(){return 18!==U()&&91!==U()&&77!==U()&&58!==U()&&An()}function Pn(){var e=M();e&&x(!1);for(var t,r=In();t=ot(27);)r=Yn(r,t,In());return e&&x(!0),r}function wn(){return at(60)?In():void 0}function In(){if(On())return Ln();var t=Bn()||Vn();if(t)return t;var r=Hn(0);return 73===r.kind&&37===U()?Rn(r):e.isLeftHandSideExpression(r)&&e.isAssignmentOperator(W())?Yn(r,lt(),In()):Wn(r)}function On(){return 118===U()?I()?!0:et(_a):!1}function Mn(){return K(),!Ho.hasPrecedingLineBreak()&&rt()}function Ln(){var e=ft(208);return K(),Ho.hasPrecedingLineBreak()||40!==U()&&!An()?vt(e):(e.asteriskToken=ot(40),e.expression=In(),vt(e))}function Rn(t,r){e.Debug.assert(37===U(),"parseSimpleArrowFunctionExpression should only have been called if we had a =>");var n;r?(n=ft(198,r.pos),n.modifiers=r):n=ft(198,t.pos);var i=ft(152,t.pos);return i.name=t,vt(i),n.parameters=gt([i],i.pos,i.end),n.equalsGreaterThanToken=ct(37),n.body=qn(!!r),_(vt(n))}function Bn(){var t=jn();if(0===t)return void 0;var r=1===t?Kn(!0):tt(zn);if(!r)return void 0;var n=e.hasModifier(r,256),i=U();return r.equalsGreaterThanToken=ct(37),r.body=37===i||18===i?qn(n):xt(),vt(r)}function jn(){return 20===U()||28===U()||122===U()?et(Jn):37===U()?1:0}function Jn(){if(122===U()){if(K(),Ho.hasPrecedingLineBreak())return 0;if(20!==U()&&28!==U())return 0}var t=U(),r=K();if(20===t){if(21===r){var n=K();switch(n){case 37:case 57:case 18:return 1;default:return 0}}if(22===r||18===r)return 2;if(25===r)return 1;if(e.isModifierKind(r)&&122!==r&&et(Mt))return 1;if(!rt()&&101!==r)return 0;switch(K()){case 57:return 1;case 56:return K(),57===U()||27===U()||60===U()||21===U()?1:0;case 27:case 60:case 21:return 2}return 0}if(e.Debug.assert(28===t),!rt())return 0;if(1===Ro.languageVariant){var i=et(function(){var e=K();if(87===e){var t=K();switch(t){case 60:case 30:return!1;default:return!0}}else if(27===e)return!0;return!1});return i?1:0}return 2}function zn(){return Kn(!1)}function Vn(){if(122===U()&&1===et(Un)){var e=Ua(),t=Hn(0);return Rn(t,e)}return void 0}function Un(){if(122===U()){if(K(),Ho.hasPrecedingLineBreak()||37===U())return 0;var e=Hn(0);if(!Ho.hasPrecedingLineBreak()&&73===e.kind&&37===U())return 1}return 0}function Kn(t){var r=mt(198);r.modifiers=Ua();var n=e.hasModifier(r,256)?2:0;if(!Or(57,n,r)&&!t)return void 0;var i=r.type&&e.isJSDocFunctionType(r.type);return t||37===U()||!i&&18===U()?r:void 0}function qn(e){return 18===U()?Ki(e?2:0):26!==U()&&91!==U()&&77!==U()&&fa()&&!Fn()?Ki(16|(e?2:0)):e?A(In):F(In)}function Wn(t){var r=ot(56);if(!r)return t;var n=ft(206,t.pos);return n.condition=t,n.questionToken=r,n.whenTrue=S(Go,In),n.colonToken=ct(57),n.whenFalse=e.nodeIsPresent(n.colonToken)?In():yt(73,!1,e.Diagnostics._0_expected,e.tokenToString(57)),vt(n)}function Hn(e){var t=ai();return Qn(e,t)}function Gn(e){return 94===e||148===e}function Qn(t,r){for(;;){W();var n=e.getBinaryOperatorPrecedence(U()),i=41===U()?n>=t:n>t;if(!i)break;if(94===U()&&O())break;if(120===U()){if(Ho.hasPrecedingLineBreak())break;K(),r=Zn(r,kn())}else r=Yn(r,lt(),Hn(n))}return r}function Xn(){return O()&&94===U()?!1:e.getBinaryOperatorPrecedence(U())>0}function Yn(e,t,r){var n=ft(205,e.pos);return n.left=e,n.operatorToken=t,n.right=r,vt(n)}function Zn(e,t){var r=ft(213,e.pos);return r.expression=e,r.type=t,vt(r)}function $n(){var e=ft(203);return e.operator=U(),K(),e.operand=oi(),vt(e)}function ei(){var e=ft(199);return K(),e.expression=oi(),vt(e)}function ti(){var e=ft(200);return K(),e.expression=oi(),vt(e)}function ri(){var e=ft(201);return K(),e.expression=oi(),vt(e)}function ni(){return 123===U()?L()?!0:et(_a):!1}function ii(){var e=ft(202);return K(),e.expression=oi(),vt(e)}function ai(){if(si()){var t=ci();return 41===U()?Qn(e.getBinaryOperatorPrecedence(U()),t):t}var r=U(),n=oi();if(41===U()){var i=e.skipTrivia(zo,n.pos),a=n.end;195===n.kind?j(i,a,e.Diagnostics.A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses):j(i,a,e.Diagnostics.An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses,e.tokenToString(r))}return n}function oi(){switch(U()){case 38:case 39:case 53:case 52:return $n();case 82:return ei();case 105:return ti();case 107:return ri();case 28:return Ci();case 123:if(ni())return ii();default:return ci()}}function si(){switch(U()){case 38:case 39:case 53:case 52:case 82:case 105:case 107:case 123:return!1;case 28:if(1!==Ro.languageVariant)return!1;default:return!0}}function ci(){if(44===U()||45===U()){var t=ft(203);return t.operator=U(),K(),t.operand=ui(),vt(t)}if(1===Ro.languageVariant&&28===U()&&et(Rt))return di(!0);var r=ui();if(e.Debug.assert(e.isLeftHandSideExpression(r)),(44===U()||45===U())&&!Ho.hasPrecedingLineBreak()){var t=ft(204,r.pos);return t.operand=r,t.operator=U(),K(),vt(t)}return r}function ui(){var e;if(93===U())if(et(qr))Ro.flags|=524288,e=lt();else if(et(Wr)){var t=Ho.getStartPos();K(),K();var r=ft(215,t);r.keywordToken=93,r.name=Dt(),e=vt(r),Ro.flags|=1048576}else e=li();else e=99===U()?_i():li();return Ni(e)}function li(){var e=wi();return ki(e)}function _i(){var t=lt();if(28===U()){var r=V(),n=tt(Fi);void 0!==n&&j(r,V(),e.Diagnostics.super_may_not_use_type_arguments)}if(20===U()||24===U()||22===U())return t;var i=ft(190,t.pos);return i.expression=t,ct(24,e.Diagnostics.super_must_be_followed_by_an_argument_list_or_member_access),i.name=_r(!0),vt(i)}function di(t){var r,n=vi(t);if(263===n.kind){var i=ft(261,n.pos);i.openingElement=n,i.children=mi(i.openingElement),i.closingElement=Di(t),b(i.openingElement.tagName,i.closingElement.tagName)||J(i.closingElement,e.Diagnostics.Expected_corresponding_JSX_closing_tag_for_0,e.getTextOfNodeFromSourceText(zo,i.openingElement.tagName)),r=vt(i)}else if(266===n.kind){var i=ft(265,n.pos);i.openingFragment=n,i.children=mi(i.openingFragment),i.closingFragment=Si(t),r=vt(i)}else e.Debug.assert(262===n.kind),r=n;if(t&&28===U()){var a=tt(function(){return di(!0)});if(a){R(e.Diagnostics.JSX_expressions_must_have_one_parent_element);var o=ft(205,r.pos);return o.end=a.end,o.left=r,o.right=a,o.operatorToken=yt(27,!1),o.operatorToken.pos=o.operatorToken.end=o.right.pos,o}}return r}function pi(){var e=ft(11);return e.text=Ho.getTokenValue(),e.containsOnlyTriviaWhiteSpaces=12===Jo,Jo=Ho.scanJsxToken(),vt(e)}function fi(t,r){switch(r){case 1:return void(e.isJsxOpeningFragment(t)?J(t,e.Diagnostics.JSX_fragment_has_no_corresponding_closing_tag):J(t.tagName,e.Diagnostics.JSX_element_0_has_no_corresponding_closing_tag,e.getTextOfNodeFromSourceText(zo,t.tagName)));case 29:case 7:return void 0;case 11:case 12:return pi();case 18:return hi(!1);case 28:return di(!1);default:return e.Debug.assertNever(r)}}function mi(e){var t=[],r=V(),n=qo;for(qo|=16384;;){var i=fi(e,Jo=Ho.reScanJsxToken());if(!i)break;t.push(i)}return qo=n,gt(t,r)}function gi(){var e=ft(269);return e.properties=Kt(13,bi),vt(e)}function vi(e){var t=Ho.getStartPos();if(nt(28),30===U()){var r=ft(266,t);return Y(),vt(r)}var n,i=yi(),a=$a(),o=gi();return 30===U()?(n=ft(263,t),Y()):(nt(42),e?nt(30):(nt(30,void 0,!1),Y()),n=ft(262,t)),n.tagName=i,n.typeArguments=a,n.attributes=o,vt(n)}function yi(){X();for(var e=101===U()?lt():Dt();at(24);){var t=ft(190,e.pos);t.expression=e,t.name=_r(!0),e=vt(t)}return e}function hi(e){var t=ft(271);return nt(18)?(19!==U()&&(t.dotDotDotToken=ot(25),t.expression=In()),e?nt(19):(nt(19,void 0,!1),Y()),vt(t)):void 0}function bi(){if(18===U())return xi();X();var e=ft(268);if(e.name=Dt(),60===U())switch(Z()){case 10:e.initializer=fr();break;default:e.initializer=hi(!0)}return vt(e)}function xi(){var e=ft(270);return nt(18),nt(25),e.expression=Pn(),nt(19),vt(e)}function Di(e){var t=ft(264);return nt(29),t.tagName=yi(),e?nt(30):(nt(30,void 0,!1),Y()),vt(t)}function Si(t){var r=ft(267);return nt(29),e.tokenIsIdentifierOrKeyword(U())&&J(yi(),e.Diagnostics.Expected_corresponding_closing_tag_for_JSX_fragment),t?nt(30):(nt(30,void 0,!1),Y()),vt(r)}function Ci(){var e=ft(195);return nt(28),e.type=kn(),nt(30),e.expression=oi(),vt(e)}function ki(t){for(;;){var r=ot(24);if(r){var n=ft(190,t.pos);n.expression=t,n.name=_r(!0),t=vt(n)}else if(52!==U()||Ho.hasPrecedingLineBreak())if(M()||!at(22)){if(!Ti())return t;t=Ei(t,void 0)}else{var i=ft(191,t.pos);if(i.expression=t,23===U())i.argumentExpression=yt(73,!0,e.Diagnostics.An_element_access_expression_should_take_an_argument);else{var a=k(Pn);e.isStringOrNumericLiteralLike(a)&&(a.text=ht(a.text)),i.argumentExpression=a}nt(23),t=vt(i)}else{K();var o=ft(214,t.pos);o.expression=t,t=vt(o)}}}function Ti(){return 14===U()||15===U()}function Ei(e,t){var r=ft(194,e.pos);return r.tag=e,r.typeArguments=t,r.template=14===U()?fr():dr(),vt(r)}function Ni(e){for(;;)if(e=ki(e),28!==U()&&46!==U()){if(20!==U())return e;var t=ft(192,e.pos);t.expression=e,t.arguments=Ai(),e=vt(t)}else{var r=tt(Fi);if(!r)return e;if(Ti()){e=Ei(e,r);continue}var t=ft(192,e.pos);t.expression=e,t.typeArguments=r,t.arguments=Ai(),e=vt(t)}}function Ai(){nt(20);var e=ar(11,Li);return nt(21),e}function Fi(){if(28!==Q())return void 0;K();var e=ar(20,kn);return nt(30)&&e&&Pi()?e:void 0}function Pi(){switch(U()){case 20:case 14:case 15:case 24:case 21:case 23:case 57:case 26:case 56:case 33:case 35:case 34:case 36:case 54:case 55:case 51:case 49:case 50:case 19:case 1:return!0;case 27:case 18:default:return!1}}function wi(){switch(U()){case 8:case 9:case 10:case 14:return fr();case 101:case 99:case 97:case 103:case 88:return lt();case 20:return Ii();case 22:return Ri();case 18:return ji();case 122:if(!et(la))break;return Ji();case 77:return qa();case 91:return Ji();case 96:return Vi();case 42:case 65:if(13===H())return fr();break;case 15:return dr()}return xt(e.Diagnostics.Expression_expected)}function Ii(){var e=mt(196);return nt(20),e.expression=k(Pn),nt(21),vt(e)}function Oi(){var e=ft(209);return nt(25),e.expression=In(),vt(e)}function Mi(){return 25===U()?Oi():27===U()?ft(211):In()}function Li(){return S(Go,Mi)}function Ri(){var e=ft(188);return nt(22),Ho.hasPrecedingLineBreak()&&(e.multiLine=!0),e.elements=ar(15,Mi),nt(23),vt(e)}function Bi(){var e=mt(0);if(ot(25))return e.kind=278,e.expression=In(),vt(e);if(e.decorators=za(),e.modifiers=Va(),Et(127))return ja(e,159);if(Et(138))return ja(e,160);var t=ot(40),r=rt();if(e.name=kt(),e.questionToken=ot(56),e.exclamationToken=ot(52),t||20===U()||28===U())return La(e,t);var n=r&&57!==U();if(n){e.kind=277;var i=ot(60);i&&(e.equalsToken=i,e.objectAssignmentInitializer=k(In))}else e.kind=276,nt(57),e.initializer=k(In);return vt(e)}function ji(){var e=ft(189);return nt(18),Ho.hasPrecedingLineBreak()&&(e.multiLine=!0),e.properties=ar(12,Bi,!0),nt(19),vt(e)}function Ji(){var t=M();t&&x(!1);var r=mt(197);r.modifiers=Va(),nt(91),r.asteriskToken=ot(40);var n=r.asteriskToken?1:0,i=e.hasModifier(r,256)?2:0;return r.name=n&&i?P(zi):n?E(zi):i?A(zi):zi(),Or(57,n|i,r),r.body=Ki(n|i),t&&x(!0),vt(r)}function zi(){return rt()?xt():void 0}function Vi(){var t=Ho.getStartPos();if(nt(96),at(24)){var r=ft(215,t);return r.keywordToken=96,r.name=Dt(),vt(r)}for(var n,i=wi();;){i=ki(i),n=tt(Fi),Ti()&&(e.Debug.assert(!!n,"Expected a type argument list; all plain tagged template starts should be consumed in 'parseMemberExpressionRest'"),i=Ei(i,n),n=void 0);break}var a=ft(193,t);return a.expression=i,a.typeArguments=n,(a.typeArguments||20===U())&&(a.arguments=Ai()),vt(a)}function Ui(e,t){var r=ft(219);return nt(18,t)||e?(Ho.hasPrecedingLineBreak()&&(r.multiLine=!0),r.statements=Kt(1,va),nt(19)):r.statements=or(),vt(r)}function Ki(e,t){var r=I();h(!!(1&e));var n=L();D(!!(2&e));var i=M();i&&x(!1);var a=Ui(!!(16&e),t);return i&&x(!0),h(r),D(n),a}function qi(){var e=ft(221);return nt(26),vt(e)}function Wi(){var e=ft(223);return nt(92),nt(20),e.expression=k(Pn),nt(21),e.thenStatement=va(),e.elseStatement=at(84)?va():void 0,vt(e)}function Hi(){var e=ft(224);return nt(83),e.statement=va(),nt(108),nt(20),e.expression=k(Pn),nt(21),at(26),vt(e)}function Gi(){var e=ft(225);return nt(108),nt(20),e.expression=k(Pn),nt(21),e.statement=va(),vt(e)}function Qi(){var e=V();nt(90);var t=ot(123);nt(20);var r;26!==U()&&(r=106===U()||112===U()||78===U()?Pa(!0):T(Pn));var n;if(t?nt(148):at(148)){var i=ft(228,e);i.awaitModifier=t,i.initializer=r,i.expression=k(In),nt(21),n=i}else if(at(94)){var a=ft(227,e);a.initializer=r,a.expression=k(Pn),nt(21),n=a}else{var o=ft(226,e);o.initializer=r,nt(26),26!==U()&&21!==U()&&(o.condition=k(Pn)),nt(26),21!==U()&&(o.incrementor=k(Pn)),nt(21),n=o}return n.statement=va(),vt(n)}function Xi(e){var t=ft(e);return nt(230===e?74:79),dt()||(t.label=xt()),pt(),vt(t)}function Yi(){var e=ft(231);return nt(98),dt()||(e.expression=k(Pn)),pt(),vt(e)}function Zi(){var e=ft(232);return nt(109),nt(20),e.expression=k(Pn),nt(21),e.statement=C(8388608,va),vt(e)}function $i(){var e=ft(272);return nt(75),e.expression=k(Pn),nt(57),e.statements=Kt(3,va),vt(e)}function ea(){var e=ft(273);return nt(81),nt(57),e.statements=Kt(3,va),vt(e)}function ta(){return 75===U()?$i():ea()}function ra(){var e=ft(233);nt(100),nt(20),e.expression=k(Pn),nt(21);var t=ft(247);return nt(18),t.clauses=Kt(2,ta),nt(19),e.caseBlock=vt(t),vt(e)
}function na(){var e=ft(235);return nt(102),e.expression=Ho.hasPrecedingLineBreak()?void 0:k(Pn),pt(),vt(e)}function ia(){var e=ft(236);return nt(104),e.tryBlock=Ui(!1),e.catchClause=76===U()?aa():void 0,e.catchClause&&89!==U()||(nt(89),e.finallyBlock=Ui(!1)),vt(e)}function aa(){var e=ft(275);return nt(76),at(20)?(e.variableDeclaration=Fa(),nt(21)):e.variableDeclaration=void 0,e.block=Ui(!1),vt(e)}function oa(){var e=ft(237);return nt(80),pt(),vt(e)}function sa(){var e=mt(0),t=k(Pn);return 73===t.kind&&at(57)?(e.kind=234,e.label=t,e.statement=va()):(e.kind=222,e.expression=t,pt()),vt(e)}function ca(){return K(),e.tokenIsIdentifierOrKeyword(U())&&!Ho.hasPrecedingLineBreak()}function ua(){return K(),77===U()&&!Ho.hasPrecedingLineBreak()}function la(){return K(),91===U()&&!Ho.hasPrecedingLineBreak()}function _a(){return K(),(e.tokenIsIdentifierOrKeyword(U())||8===U()||9===U()||10===U())&&!Ho.hasPrecedingLineBreak()}function da(){for(;;)switch(U()){case 106:case 112:case 78:case 91:case 77:case 85:return!0;case 111:case 141:return Mn();case 131:case 132:return xa();case 119:case 122:case 126:case 114:case 115:case 116:case 134:if(K(),Ho.hasPrecedingLineBreak())return!1;continue;case 146:return K(),18===U()||73===U()||86===U();case 93:return K(),10===U()||40===U()||18===U()||e.tokenIsIdentifierOrKeyword(U());case 86:if(K(),60===U()||40===U()||18===U()||81===U()||120===U())return!0;continue;case 117:K();continue;default:return!1}}function pa(){return et(da)}function fa(){switch(U()){case 58:case 26:case 18:case 106:case 112:case 91:case 77:case 85:case 92:case 83:case 108:case 90:case 79:case 74:case 98:case 109:case 100:case 102:case 104:case 80:case 76:case 89:return!0;case 93:return pa()||et(Hr);case 78:case 86:return pa();case 122:case 126:case 111:case 131:case 132:case 141:case 146:return!0;case 116:case 114:case 115:case 117:case 134:return pa()||!et(ca);default:return An()}}function ma(){return K(),rt()||18===U()||22===U()}function ga(){return et(ma)}function va(){switch(U()){case 26:return qi();case 18:return Ui(!1);case 106:return Ia(mt(238));case 112:if(ga())return Ia(mt(238));break;case 91:return Oa(mt(240));case 77:return Wa(mt(241));case 92:return Wi();case 83:return Hi();case 108:return Gi();case 90:return Qi();case 79:return Xi(229);case 74:return Xi(230);case 98:return Yi();case 109:return Zi();case 100:return ra();case 102:return na();case 104:case 76:case 89:return ia();case 80:return oa();case 58:return ha();case 122:case 111:case 141:case 131:case 132:case 126:case 78:case 85:case 86:case 93:case 114:case 115:case 116:case 119:case 117:case 134:case 146:if(pa())return ha()}return sa()}function ya(e){return 126===e.kind}function ha(){var t=mt(0);if(t.decorators=za(),t.modifiers=Va(),e.some(t.modifiers,ya)){for(var r=0,n=t.modifiers;r<n.length;r++){var i=n[r];i.flags|=4194304}return C(4194304,function(){return ba(t)})}return ba(t)}function ba(t){switch(U()){case 106:case 112:case 78:return Ia(t);case 91:return Oa(t);case 77:return Wa(t);case 111:return ro(t);case 141:return no(t);case 85:return ao(t);case 146:case 131:case 132:return uo(t);case 93:return mo(t);case 86:switch(K(),U()){case 81:case 60:return Eo(t);case 120:return fo(t);default:return To(t)}default:if(t.decorators||t.modifiers){var r=yt(259,!0,e.Diagnostics.Declaration_expected);return r.pos=t.pos,r.decorators=t.decorators,r.modifiers=t.modifiers,vt(r)}return void 0}}function xa(){return K(),!Ho.hasPrecedingLineBreak()&&(rt()||10===U())}function Da(e,t){return 18!==U()&&dt()?void pt():Ki(e,t)}function Sa(){if(27===U())return ft(211);var e=ft(187);return e.dotDotDotToken=ot(25),e.name=Na(),e.initializer=wn(),vt(e)}function Ca(){var e=ft(187);e.dotDotDotToken=ot(25);var t=rt(),r=kt();return t&&57!==U()?e.name=r:(nt(57),e.propertyName=r,e.name=Na()),e.initializer=wn(),vt(e)}function ka(){var e=ft(185);return nt(18),e.elements=ar(9,Ca),nt(19),vt(e)}function Ta(){var e=ft(186);return nt(22),e.elements=ar(10,Sa),nt(23),vt(e)}function Ea(){return 18===U()||22===U()||rt()}function Na(){return 22===U()?Ta():18===U()?ka():xt()}function Aa(){return Fa(!0)}function Fa(e){var t=ft(238);return t.name=Na(),e&&73===t.name.kind&&52===U()&&!Ho.hasPrecedingLineBreak()&&(t.exclamationToken=lt()),t.type=En(),Gn(U())||(t.initializer=wn()),vt(t)}function Pa(t){var r=ft(239);switch(U()){case 106:break;case 112:r.flags|=1;break;case 78:r.flags|=2;break;default:e.Debug.fail()}if(K(),148===U()&&et(wa))r.declarations=or();else{var n=O();y(t),r.declarations=ar(8,t?Fa:Aa),y(n)}return vt(r)}function wa(){return Mt()&&21===K()}function Ia(e){return e.kind=220,e.declarationList=Pa(!1),pt(),vt(e)}function Oa(t){t.kind=240,nt(91),t.asteriskToken=ot(40),t.name=e.hasModifier(t,512)?zi():xt();var r=t.asteriskToken?1:0,n=e.hasModifier(t,256)?2:0;return Or(57,r|n,t),t.body=Da(r|n,e.Diagnostics.or_expected),vt(t)}function Ma(t){return t.kind=158,nt(125),Or(57,0,t),t.body=Da(0,e.Diagnostics.or_expected),vt(t)}function La(t,r,n){t.kind=157,t.asteriskToken=r;var i=r?1:0,a=e.hasModifier(t,256)?2:0;return Or(57,i|a,t),t.body=Da(i|a,n),vt(t)}function Ra(t){return t.kind=155,t.questionToken||52!==U()||Ho.hasPrecedingLineBreak()||(t.exclamationToken=lt()),t.type=En(),t.initializer=e.hasModifier(t,32)?k(wn):S(6144,wn),pt(),vt(t)}function Ba(t){var r=ot(40);return t.name=kt(),t.questionToken=ot(56),r||20===U()||28===U()?La(t,r,e.Diagnostics.or_expected):Ra(t)}function ja(e,t){return e.kind=t,e.name=kt(),Or(57,0,e),e.body=Da(0),vt(e)}function Ja(){var t;if(58===U())return!0;for(;e.isModifierKind(U());){if(t=U(),e.isClassMemberModifier(t))return!0;K()}if(40===U())return!0;if(St()&&(t=U(),K()),22===U())return!0;if(void 0!==t){if(!e.isKeyword(t)||138===t||127===t)return!0;switch(U()){case 20:case 28:case 52:case 57:case 60:case 56:return!0;default:return dt()}}return!1}function za(){for(var e,t=V();;){var r=V();if(!at(58))break;var n=ft(153,r);n.expression=N(ui),vt(n),(e||(e=[])).push(n)}return e&&gt(e,t)}function Va(e){for(var t,r=V();;){var n=Ho.getStartPos(),i=U();if(78===U()&&e){if(!tt(Nt))break}else if(!Ft())break;var a=vt(ft(i,n));(t||(t=[])).push(a)}return t&&gt(t,r)}function Ua(){var e;if(122===U()){var t=Ho.getStartPos(),r=U();K();var n=vt(ft(r,t));e=gt([n],t)}return e}function Ka(){if(26===U()){var t=ft(218);return K(),vt(t)}var r=mt(0);return r.decorators=za(),r.modifiers=Va(!0),Et(127)?ja(r,159):Et(138)?ja(r,160):125===U()?Ma(r):jr()?zr(r):e.tokenIsIdentifierOrKeyword(U())||10===U()||8===U()||40===U()||22===U()?Ba(r):r.decorators||r.modifiers?(r.name=yt(73,!0,e.Diagnostics.Declaration_expected),Ra(r)):e.Debug.fail("Should not have attempted to parse class member declaration.")}function qa(){return Ha(mt(0),210)}function Wa(e){return Ha(e,241)}function Ha(e,t){return e.kind=t,nt(77),e.name=Ga(),e.typeParameters=Fr(),e.heritageClauses=Xa(),nt(18)?(e.members=to(),nt(19)):e.members=or(),vt(e)}function Ga(){return rt()&&!Qa()?xt():void 0}function Qa(){return 110===U()&&et(Lt)}function Xa(){return eo()?Kt(22,Ya):void 0}function Ya(){var t=U();e.Debug.assert(87===t||110===t);var r=ft(274);return r.token=t,K(),r.types=ar(7,Za),vt(r)}function Za(){var e=ft(212);return e.expression=ui(),e.typeArguments=$a(),vt(e)}function $a(){return 28===U()?cr(20,kn,28,30):void 0}function eo(){return 87===U()||110===U()}function to(){return Kt(5,Ka)}function ro(e){return e.kind=242,nt(111),e.name=xt(),e.typeParameters=Fr(),e.heritageClauses=Xa(),e.members=Qr(),vt(e)}function no(e){return e.kind=243,nt(141),e.name=xt(),e.typeParameters=Fr(),nt(60),e.type=kn(),pt(),vt(e)}function io(){var e=mt(279);return e.name=kt(),e.initializer=k(wn),vt(e)}function ao(e){return e.kind=244,nt(85),e.name=xt(),nt(18)?(e.members=ar(6,io),nt(19)):e.members=or(),vt(e)}function oo(){var e=ft(246);return nt(18)?(e.statements=Kt(1,va),nt(19)):e.statements=or(),vt(e)}function so(e,t){e.kind=245;var r=16&t;return e.flags|=t,e.name=xt(),e.body=at(24)?so(ft(0),4|r):oo(),vt(e)}function co(e){return e.kind=245,146===U()?(e.name=xt(),e.flags|=512):(e.name=fr(),e.name.text=ht(e.name.text)),18===U()?e.body=oo():pt(),vt(e)}function uo(e){var t=0;if(146===U())return co(e);if(at(132))t|=16;else if(nt(131),10===U())return co(e);return so(e,t)}function lo(){return 135===U()&&et(_o)}function _o(){return 20===K()}function po(){return 42===K()}function fo(e){return e.kind=248,nt(120),nt(132),e.name=xt(),pt(),vt(e)}function mo(e){nt(93);var t,r=Ho.getStartPos();return rt()&&(t=xt(),27!==U()&&145!==U())?go(e,t):(e.kind=250,(t||40===U()||18===U())&&(e.importClause=vo(t,r),nt(145)),e.moduleSpecifier=bo(),pt(),vt(e))}function go(e,t){return e.kind=249,e.name=t,nt(60),e.moduleReference=yo(),pt(),vt(e)}function vo(e,t){var r=ft(251,t);return e&&(r.name=e),(!r.name||at(27))&&(r.namedBindings=40===U()?xo():Do(253)),vt(r)}function yo(){return lo()?ho():ur(!1)}function ho(){var e=ft(260);return nt(135),nt(20),e.expression=bo(),nt(21),vt(e)}function bo(){if(10===U()){var e=fr();return e.text=ht(e.text),e}return Pn()}function xo(){var e=ft(252);return nt(40),nt(120),e.name=xt(),vt(e)}function Do(e){var t=ft(e);return t.elements=cr(23,253===e?Co:So,18,19),vt(t)}function So(){return ko(258)}function Co(){return ko(254)}function ko(t){var r=ft(t),n=e.isKeyword(U())&&!rt(),i=Ho.getTokenPos(),a=Ho.getTextPos(),o=Dt();return 120===U()?(r.propertyName=o,nt(120),n=e.isKeyword(U())&&!rt(),i=Ho.getTokenPos(),a=Ho.getTextPos(),r.name=Dt()):r.name=o,254===t&&n&&j(i,a,e.Diagnostics.Identifier_expected),vt(r)}function To(e){return e.kind=256,at(40)?(nt(145),e.moduleSpecifier=bo()):(e.exportClause=Do(257),(145===U()||10===U()&&!Ho.hasPrecedingLineBreak())&&(nt(145),e.moduleSpecifier=bo())),pt(),vt(e)}function Eo(e){return e.kind=255,at(60)?e.isExportEquals=!0:nt(81),e.expression=In(),pt(),vt(e)}function No(t){t.externalModuleIndicator=e.forEach(t.statements,Ao)||Fo(t)}function Ao(t){return e.hasModifier(t,1)||249===t.kind&&260===t.moduleReference.kind||250===t.kind||255===t.kind||256===t.kind?t:void 0}function Fo(e){return 1048576&e.flags?Po(e):void 0}function Po(e){return wo(e)?e:a(e,Po)}function wo(t){return e.isMetaProperty(t)&&93===t.keywordToken&&"meta"===t.name.escapedText}var Io,Oo,Mo,Lo,Ro,Bo,jo,Jo,zo,Vo,Uo,Ko,qo,Wo,Ho=e.createScanner(8,!0),Go=10240,Qo=!1;t.parseSourceFile=r,t.parseIsolatedEntityName=n,t.parseJsonText=o,t.fixupParentReferences=d;var Xo;!function(e){e[e.SourceElements=0]="SourceElements",e[e.BlockStatements=1]="BlockStatements",e[e.SwitchClauses=2]="SwitchClauses",e[e.SwitchClauseStatements=3]="SwitchClauseStatements",e[e.TypeMembers=4]="TypeMembers",e[e.ClassMembers=5]="ClassMembers",e[e.EnumMembers=6]="EnumMembers",e[e.HeritageClauseElement=7]="HeritageClauseElement",e[e.VariableDeclarations=8]="VariableDeclarations",e[e.ObjectBindingElements=9]="ObjectBindingElements",e[e.ArrayBindingElements=10]="ArrayBindingElements",e[e.ArgumentExpressions=11]="ArgumentExpressions",e[e.ObjectLiteralMembers=12]="ObjectLiteralMembers",e[e.JsxAttributes=13]="JsxAttributes",e[e.JsxChildren=14]="JsxChildren",e[e.ArrayLiteralMembers=15]="ArrayLiteralMembers",e[e.Parameters=16]="Parameters",e[e.JSDocParameters=17]="JSDocParameters",e[e.RestProperties=18]="RestProperties",e[e.TypeParameters=19]="TypeParameters",e[e.TypeArguments=20]="TypeArguments",e[e.TupleElementTypes=21]="TupleElementTypes",e[e.HeritageClauses=22]="HeritageClauses",e[e.ImportOrExportSpecifiers=23]="ImportOrExportSpecifiers",e[e.Count=24]="Count"}(Xo||(Xo={}));var Yo;!function(e){e[e.False=0]="False",e[e.True=1]="True",e[e.Unknown=2]="Unknown"}(Yo||(Yo={}));var Zo;!function(t){function r(e,t,r){c(e,8,void 0,1),Ro=g("file.js",8,1,!1),Ho.setText(e,t,r),Jo=Ho.scan();var i=n(),a=Bo;return u(),i?{jsDocTypeExpression:i,diagnostics:a}:void 0}function n(e){var t=ft(289),r=(e?at:nt)(18);return t.type=C(2097152,Er),(!e||r)&&it(19),d(t),vt(t)}function a(e,t,r){c(e,8,void 0,1),Ro={languageVariant:0,text:e};var n=s(t,r),i=Bo;return u(),n?{jsDoc:n,diagnostics:i}:void 0}function o(e,t,r){var n,i=Jo,a=Bo.length,o=Qo,c=s(t,r);return c&&(c.parent=e),65536&Wo&&(Ro.jsDocDiagnostics||(Ro.jsDocDiagnostics=[]),(n=Ro.jsDocDiagnostics).push.apply(n,Bo)),Jo=i,Bo.length=a,Qo=o,c}function s(t,r){function a(e){for(;e.length&&("\n"===e[0]||"\r"===e[0]);)e.shift()}function o(e){for(;e.length&&""===e[e.length-1].trim();)e.pop()}function s(){var e=ft(297,t);return e.tags=W&&gt(W,H,G),e.comment=Q.length?Q.join(""):void 0,vt(e,K)}function c(){for(;;){if(q(),1===U())return!0;if(5!==U()&&4!==U())return!1}}function u(){if(5!==U()&&4!==U()||!et(c))for(;5===U()||4===U();)q()}function l(){if((5===U()||4===U())&&et(c))return"";for(var e=Ho.hasPrecedingLineBreak(),t=!1,r="";e&&40===U()||5===U()||4===U();)r+=Ho.getTokenText(),4===U()?(e=!0,t=!0,r=""):40===U()&&(e=!1),q();return t?r:""}function _(t){e.Debug.assert(58===U());var r=Ho.getTokenPos();q();var n,i=J(void 0),a=l();switch(i.escapedText){case"augments":case"extends":n=D(r,i);break;case"class":case"constructor":n=k(r,i);break;case"this":n=T(r,i);break;case"enum":n=E(r,i);break;case"arg":case"argument":case"param":return y(r,i,2,t);case"return":case"returns":n=b(r,i);break;case"template":n=L(r,i);break;case"type":n=x(r,i);break;case"typedef":n=N(r,i,t);break;case"callback":n=F(r,i,t);break;default:n=p(r,i)}return n.comment||(a||(t+=n.end-n.pos),n.comment=d(t,a.slice(t))),n}function d(t,r){function n(e){i||(i=t),s.push(e),t+=e.length}var i,s=[],c=0;r&&(n(r),c=2);var u=U();e:for(;;){switch(u){case 4:c>=1&&(c=0,s.push(Ho.getTokenText())),t=0;break;case 58:Ho.setTextPos(Ho.getTextPos()-1);case 1:break e;case 5:if(2===c)n(Ho.getTokenText());else{var l=Ho.getTokenText();void 0!==i&&t+l.length>i&&s.push(l.slice(i-t)),t+=l.length}break;case 18:c=2,et(function(){return 58===q()&&e.tokenIsIdentifierOrKeyword(q())&&"link"===Ho.getTokenText()})&&(n(Ho.getTokenText()),q(),n(Ho.getTokenText()),q()),n(Ho.getTokenText());break;case 40:if(0===c){c=1,t+=1;break}default:c=2,n(Ho.getTokenText())}u=q()}return a(s),o(s),0===s.length?void 0:s.join("")}function p(e,t){var r=ft(300,e);return r.tagName=t,vt(r)}function f(e){e&&(W?W.push(e):(W=[e],H=e.pos),G=e.end)}function m(){return l(),18===U()?n():void 0}function g(){var e=R(22);e&&u();var t=R(59),r=B();return t&&ut(59),e&&(u(),ot(60)&&Pn(),nt(23)),{name:r,isBracketed:e}}function v(t){switch(t.kind){case 137:return!0;case 170:return v(t.elementType);default:return e.isTypeReferenceNode(t)&&e.isIdentifier(t.typeName)&&"Object"===t.typeName.escapedText}}function y(e,t,r,n){var i=m(),a=!i;l();var o=g(),s=o.name,c=o.isBracketed;u(),a&&(i=m());var _=1===r?ft(311,e):ft(305,e),p=d(n+Ho.getStartPos()-e),f=4!==r&&h(i,s,r,n);return f&&(i=f,a=!0),_.tagName=t,_.typeExpression=i,_.name=s,_.isNameFirst=a,_.isBracketed=c,_.comment=p,vt(_)}function h(t,r,n,i){if(t&&v(t.type)){for(var a=ft(289,Ho.getTokenPos()),o=void 0,s=void 0,c=Ho.getStartPos(),u=void 0;o=tt(function(){return O(n,i,r)});)(305===o.kind||311===o.kind)&&(u=e.append(u,o));if(u)return s=ft(298,c),s.jsDocPropertyTags=u,170===t.type.kind&&(s.isArrayType=!0),a.type=vt(s),vt(a)}}function b(t,r){e.some(W,e.isJSDocReturnTag)&&j(r.pos,Ho.getTokenPos(),e.Diagnostics._0_tag_already_specified,r.escapedText);var n=ft(306,t);return n.tagName=r,n.typeExpression=m(),vt(n)}function x(t,r){e.some(W,e.isJSDocTypeTag)&&j(r.pos,Ho.getTokenPos(),e.Diagnostics._0_tag_already_specified,r.escapedText);var i=ft(308,t);return i.tagName=r,i.typeExpression=n(!0),vt(i)}function D(e,t){var r=ft(301,e);return r.tagName=t,r.class=S(),vt(r)}function S(){var e=at(18),t=ft(212);t.expression=C(),t.typeArguments=$a();var r=vt(t);return e&&nt(19),r}function C(){for(var e=J();at(24);){var t=ft(190,e.pos);t.expression=e,t.name=J(),e=vt(t)}return e}function k(e,t){var r=ft(302,e);return r.tagName=t,vt(r)}function T(e,t){var r=ft(307,e);return r.tagName=t,r.typeExpression=n(!0),u(),vt(r)}function E(e,t){var r=ft(304,e);return r.tagName=t,r.typeExpression=n(!0),u(),vt(r)}function N(t,r,n){var i=m();l();var a=ft(310,t);a.tagName=r,a.fullName=A(),a.name=P(a.fullName),u(),a.comment=d(n),a.typeExpression=i;var o;if(!i||v(i.type)){for(var s=void 0,c=void 0,_=void 0;s=tt(function(){return I(n)});)if(c||(c=ft(298,t)),308===s.kind){if(_)break;_=s}else c.jsDocPropertyTags=e.append(c.jsDocPropertyTags,s);c&&(i&&170===i.type.kind&&(c.isArrayType=!0),a.typeExpression=_&&_.typeExpression&&!v(_.typeExpression.type)?_.typeExpression:vt(c),o=a.typeExpression.end)}return vt(a,o||void 0!==a.comment?Ho.getStartPos():(a.fullName||a.typeExpression||a.tagName).end)}function A(t){var r=Ho.getTokenPos();if(!e.tokenIsIdentifierOrKeyword(U()))return void 0;var n=J();if(at(24)){var i=ft(245,r);return t&&(i.flags|=4),i.name=n,i.body=A(!0),vt(i)}return t&&(n.isInJSDocNamespace=!0),n}function F(t,r,n){var i=ft(303,t);i.tagName=r,i.fullName=A(),i.name=P(i.fullName),u(),i.comment=d(n);var a,o=ft(299,t);for(o.parameters=[];a=tt(function(){return O(4,n)});)o.parameters=e.append(o.parameters,a);var s=tt(function(){if(R(58)){var e=_(n);if(e&&306===e.kind)return e}});return s&&(o.type=s),i.typeExpression=vt(o),vt(i)}function P(t){if(t)for(var r=t;;){if(e.isIdentifier(r)||!r.body)return e.isIdentifier(r)?r:r.name;r=r.body}}function w(t,r){for(;!e.isIdentifier(t)||!e.isIdentifier(r);){if(e.isIdentifier(t)||e.isIdentifier(r)||t.right.escapedText!==r.right.escapedText)return!1;t=t.left,r=r.left}return t.escapedText===r.escapedText}function I(e){return O(1,e)}function O(t,r,n){for(var i=!0,a=!1;;)switch(q()){case 58:if(i){var o=M(t,r);return!o||305!==o.kind&&311!==o.kind||4===t||!n||!e.isIdentifier(o.name)&&w(n,o.name.left)?o:!1}a=!1;break;case 4:i=!0,a=!1;break;case 40:a&&(i=!1),a=!0;break;case 73:i=!1;break;case 1:return!1}}function M(t,r){e.Debug.assert(58===U());var n=Ho.getStartPos();q();var i=J();u();var a;switch(i.escapedText){case"type":return 1===t&&x(n,i);case"prop":case"property":a=1;break;case"arg":case"argument":case"param":a=6;break;default:return!1}return t&a?y(n,i,t,r):!1}function L(t,r){var i;18===U()&&(i=n());var a=[],o=V();do{u();var s=ft(151);s.name=J(e.Diagnostics.Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces),vt(s),u(),a.push(s)}while(R(27));var c=ft(309,t);return c.tagName=r,c.constraint=i,c.typeParameters=gt(a,o),vt(c),c}function R(e){return U()===e?(q(),!0):!1}function B(){var e=J();for(at(22)&&nt(23);at(24);){var t=J();at(22)&&nt(23),e=lr(e,t)}return e}function J(t){if(!e.tokenIsIdentifierOrKeyword(U()))return yt(73,!t,t||e.Diagnostics.Identifier_expected);var r=Ho.getTokenPos(),n=Ho.getTextPos(),i=ft(73,r);return i.escapedText=e.escapeLeadingUnderscores(Ho.getTokenText()),vt(i,n),q(),i}void 0===t&&(t=0);var z=zo,K=void 0===r?z.length:t+r;if(r=K-t,e.Debug.assert(t>=0),e.Debug.assert(K>=t),e.Debug.assert(K<=z.length),!i(z,t))return void 0;var W,H,G,Q=[];return Ho.scanRange(t+3,r-5,function(){function e(e){r||(r=i),Q.push(e),i+=e.length}var r,n=1,i=t-Math.max(z.lastIndexOf("\n",t),0)+4;for(q();R(5););R(4)&&(n=0,i=0);e:for(;;){switch(U()){case 58:0===n||1===n?(o(Q),f(_(i)),n=0,r=void 0):e(Ho.getTokenText());break;case 4:Q.push(Ho.getTokenText()),n=0,i=0;break;case 40:var c=Ho.getTokenText();1===n||2===n?(n=2,e(c)):(n=1,i+=c.length);break;case 5:var u=Ho.getTokenText();2===n?Q.push(u):void 0!==r&&i+u.length>r&&Q.push(u.slice(r-i-1)),i+=u.length;break;case 1:break e;default:n=2,e(Ho.getTokenText())}q()}return a(Q),o(Q),s()})}t.parseJSDocTypeExpressionForTests=r,t.parseJSDocTypeExpression=n,t.parseIsolatedJSDocComment=a,t.parseJSDocComment=o;var l;!function(e){e[e.BeginningOfLine=0]="BeginningOfLine",e[e.SawAsterisk=1]="SawAsterisk",e[e.SavingComments=2]="SavingComments"}(l||(l={}));var _;!function(e){e[e.Property=1]="Property",e[e.Parameter=2]="Parameter",e[e.CallbackParameter=4]="CallbackParameter"}(_||(_={})),t.parseJSDocCommentWorker=s}(Zo=t.JSDocParser||(t.JSDocParser={}))}(T||(T={}));var E;!function(t){function r(t,r,n,i){if(i=i||e.Debug.shouldAssert(2),_(t,r,n,i),e.textChangeRangeIsUnchanged(n))return t;if(0===t.statements.length)return T.parseSourceFile(t.fileName,r,t.languageVersion,void 0,!0,t.scriptKind);var a=t;e.Debug.assert(!a.hasBeenIncrementallyParsed),a.hasBeenIncrementallyParsed=!0;var o=t.text,s=d(t),l=u(t,n);_(t,r,l,i),e.Debug.assert(l.span.start<=n.span.start),e.Debug.assert(e.textSpanEnd(l.span)===e.textSpanEnd(n.span)),e.Debug.assert(e.textSpanEnd(e.textChangeRangeNewSpan(l))===e.textSpanEnd(e.textChangeRangeNewSpan(n)));var p=e.textChangeRangeNewSpan(l).length-l.span.length;c(a,l.span.start,e.textSpanEnd(l.span),e.textSpanEnd(e.textChangeRangeNewSpan(l)),p,o,r,i);var f=T.parseSourceFile(t.fileName,r,t.languageVersion,s,!0,t.scriptKind);return f}function n(t,r,n,o,c,u){function l(t){var r="";if(u&&i(t)&&(r=o.substring(t.pos,t.end)),t._children&&(t._children=void 0),t.pos+=n,t.end+=n,u&&i(t)&&e.Debug.assert(r===c.substring(t.pos,t.end)),a(t,l,_),e.hasJSDocNodes(t))for(var d=0,p=t.jsDoc;d<p.length;d++){var f=p[d];l(f)}s(t,u)}function _(e){e._children=void 0,e.pos+=n,e.end+=n;for(var t=0,r=e;t<r.length;t++){var i=r[t];l(i)}}r?_(t):l(t)}function i(e){switch(e.kind){case 10:case 8:case 73:return!0}return!1}function o(t,r,n,i,a){e.Debug.assert(t.end>=r,"Adjusting an element that was entirely before the change range"),e.Debug.assert(t.pos<=n,"Adjusting an element that was entirely after the change range"),e.Debug.assert(t.pos<=t.end),t.pos=Math.min(t.pos,i),t.end>=n?t.end+=a:t.end=Math.min(t.end,i),e.Debug.assert(t.pos<=t.end),t.parent&&(e.Debug.assert(t.pos>=t.parent.pos),e.Debug.assert(t.end<=t.parent.end))}function s(t,r){if(r){var n=t.pos,i=function(t){e.Debug.assert(t.pos>=n),n=t.end};if(e.hasJSDocNodes(t))for(var o=0,s=t.jsDoc;o<s.length;o++){var c=s[o];i(c)}a(t,i),e.Debug.assert(n<=t.end)}}function c(t,r,i,c,u,l,_,d){function p(t){if(e.Debug.assert(t.pos<=t.end),t.pos>i)return void n(t,!1,u,l,_,d);var m=t.end;if(m>=r){if(t.intersectsChange=!0,t._children=void 0,o(t,r,i,c,u),a(t,p,f),e.hasJSDocNodes(t))for(var g=0,v=t.jsDoc;g<v.length;g++){var y=v[g];p(y)}return void s(t,d)}e.Debug.assert(r>m)}function f(t){if(e.Debug.assert(t.pos<=t.end),t.pos>i)return void n(t,!0,u,l,_,d);var a=t.end;if(a>=r){t.intersectsChange=!0,t._children=void 0,o(t,r,i,c,u);for(var s=0,f=t;s<f.length;s++){var m=f[s];p(m)}}else e.Debug.assert(r>a)}p(t)}function u(t,r){for(var n=1,i=r.span.start,a=0;i>0&&n>=a;a++){var o=l(t,i);e.Debug.assert(o.pos<=i);var s=o.pos;i=Math.max(0,s-1)}var c=e.createTextSpanFromBounds(i,e.textSpanEnd(r.span)),u=r.newLength+(r.span.start-i);return e.createTextChangeRange(c,u)}function l(t,r){function n(t){for(;;){var r=e.getLastChild(t);if(!r)return t;t=r}}function i(t){return e.nodeIsMissing(t)?void 0:t.pos<=r?(t.pos>=s.pos&&(s=t),r<t.end?(a(t,i),!0):(e.Debug.assert(t.end<=r),void(o=t))):(e.Debug.assert(t.pos>r),!0)}var o,s=t;if(a(t,i),o){var c=n(o);c.pos>s.pos&&(s=c)}return s}function _(t,r,n,i){var a=t.text;if(n&&(e.Debug.assert(a.length-n.span.length+n.newLength===r.length),i||e.Debug.shouldAssert(3))){var o=a.substr(0,n.span.start),s=r.substr(0,n.span.start);e.Debug.assert(o===s);var c=a.substring(e.textSpanEnd(n.span),a.length),u=r.substring(e.textSpanEnd(e.textChangeRangeNewSpan(n)),r.length);e.Debug.assert(c===u)}}function d(t){function r(e){function r(t){return e>=t.pos&&e<t.end?(a(t,r,s),!0):!1}function s(t){if(e>=t.pos&&e<t.end)for(var c=0;c<t.length;c++){var u=t[c];if(u){if(u.pos===e)return n=t,i=c,o=u,!0;if(u.pos<e&&e<u.end)return a(u,r,s),!0}}return!1}n=void 0,i=-1,o=void 0,a(t,r,s)}var n=t.statements,i=0;e.Debug.assert(i<n.length);var o=n[i],s=-1;return{currentNode:function(t){return t!==s&&(o&&o.end===t&&i<n.length-1&&(i++,o=n[i]),o&&o.pos===t||r(t)),s=t,e.Debug.assert(!o||o.pos===t),o}}}t.updateSourceFile=r;var p;!function(e){e[e.Value=-1]="Value"}(p||(p={}))}(E||(E={})),e.isDeclarationFileName=p,e.processCommentPragmas=f,e.processPragmasIntoFields=m;var N=e.createMap(),A=/^\/\/\/\s*<(\S+)\s.*?\/>/im,F=/^\/\/\/?\s*@(\S+)\s*(.*)\s*$/im;e.tagNamesAreEquivalent=b}(n||(n={}));var n;!function(e){function t(e){return e&&void 0!==e.enableAutoDiscovery&&void 0===e.enable?{enable:e.enableAutoDiscovery,include:e.include||[],exclude:e.exclude||[]}:e}function r(){return St||(St=n(e.optionDeclarations))}function n(t){var r=e.createMap(),n=e.createMap();return e.forEach(t,function(e){r.set(e.name.toLowerCase(),e),e.shortName&&n.set(e.shortName,e.name)}),{optionNameMap:r,shortOptionNames:n}}function a(t){return o(t,e.createCompilerDiagnostic)}function o(t,r){var n=e.arrayFrom(t.type.keys()).map(function(e){return"'"+e+"'"}).join(", ");return r(e.Diagnostics.Argument_for_0_option_must_be_Colon_1,"--"+t.name,n)}function s(e,t,r){return ut(e,_t(t||""),r)}function c(t,r,n){if(void 0===r&&(r=""),r=_t(r),e.startsWith(r,"-"))return void 0;if(""===r)return[];var i=r.split(",");switch(t.element.type){case"number":return e.map(i,parseInt);case"string":return e.map(i,function(e){return e||""});default:return e.mapDefined(i,function(e){return s(t.element,e,n)})}}function u(t,r,n,i){function a(r){for(var n=0;n<r.length;){var i=r[n];if(n++,64===i.charCodeAt(0))o(i.slice(1));else if(45===i.charCodeAt(0)){var a=d(t,i.slice(45===i.charCodeAt(1)?2:1),!0);if(a)if(a.isTSConfigOnly)f.push(e.createCompilerDiagnostic(e.Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file,a.name));else switch(r[n]||"boolean"===a.type||f.push(e.createCompilerDiagnostic(l,a.name)),a.type){case"number":_[a.name]=parseInt(r[n]),n++;break;case"boolean":var m=r[n];_[a.name]="false"!==m,("false"===m||"true"===m)&&n++;break;case"string":_[a.name]=r[n]||"",n++;break;case"list":var g=c(a,r[n],f);_[a.name]=g||[],g&&n++;break;default:_[a.name]=s(a,r[n],f),n++}else f.push(e.createCompilerDiagnostic(u,i))}else p.push(i)}}function o(t){var r=i?i(t):e.sys.readFile(t);if(!r)return void f.push(e.createCompilerDiagnostic(e.Diagnostics.File_0_not_found,t));for(var n=[],o=0;;){for(;o<r.length&&r.charCodeAt(o)<=32;)o++;if(o>=r.length)break;var s=o;if(34===r.charCodeAt(s)){for(o++;o<r.length&&34!==r.charCodeAt(o);)o++;o<r.length?(n.push(r.substring(s+1,o)),o++):f.push(e.createCompilerDiagnostic(e.Diagnostics.Unterminated_quoted_string_in_response_file_0,t))}else{for(;r.charCodeAt(o)>32;)o++;n.push(r.substring(s,o))}}a(n)}var u=r[0],l=r[1],_={},p=[],f=[];return a(n),{options:_,fileNames:p,errors:f}}function l(t,n){return u(r,[e.Diagnostics.Unknown_compiler_option_0,e.Diagnostics.Compiler_option_0_expects_an_argument],t,n)}function _(e,t){return d(r,e,t)}function d(e,t,r){void 0===r&&(r=!1),t=t.toLowerCase();var n=e(),i=n.optionNameMap,a=n.shortOptionNames;if(r){var o=a.get(t);void 0!==o&&(t=o)}return i.get(t)}function p(t){var r,i=function(){return r||(r=n(e.buildOpts))},a=u(i,[e.Diagnostics.Unknown_build_option_0,e.Diagnostics.Build_option_0_requires_a_value_of_type_1],t),o=a.options,s=a.fileNames,c=a.errors,l=o;return 0===s.length&&s.push("."),l.clean&&l.force&&c.push(e.createCompilerDiagnostic(e.Diagnostics.Options_0_and_1_cannot_be_combined,"clean","force")),l.clean&&l.verbose&&c.push(e.createCompilerDiagnostic(e.Diagnostics.Options_0_and_1_cannot_be_combined,"clean","verbose")),l.clean&&l.watch&&c.push(e.createCompilerDiagnostic(e.Diagnostics.Options_0_and_1_cannot_be_combined,"clean","watch")),l.watch&&l.dry&&c.push(e.createCompilerDiagnostic(e.Diagnostics.Options_0_and_1_cannot_be_combined,"watch","dry")),{buildOptions:l,projects:s,errors:c}}function f(){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];var n=e.createCompilerDiagnostic.apply(void 0,arguments);return n.messageText}function m(){e.sys.write(f(e.Diagnostics.Version_0,e.version)+e.sys.newLine)}function g(t,r){function n(e){return void 0!==e.paramType?" "+f(e.paramType):""}function i(e){return Array(e+1).join(" ")}void 0===r&&(r="");var a=[],o=f(e.Diagnostics.Syntax_Colon_0,"").length,s=f(e.Diagnostics.Examples_Colon_0,"").length,c=Math.max(o,s),u=i(c-o);u+="tsc "+r+"["+f(e.Diagnostics.options)+"] ["+f(e.Diagnostics.file)+"...]",a.push(f(e.Diagnostics.Syntax_Colon_0,u)),a.push(e.sys.newLine+e.sys.newLine);var l=i(c);a.push(f(e.Diagnostics.Examples_Colon_0,i(c-s)+"tsc hello.ts")+e.sys.newLine),a.push(l+"tsc --outFile file.js file.ts"+e.sys.newLine),a.push(l+"tsc @args.txt"+e.sys.newLine),a.push(l+"tsc --build tsconfig.json"+e.sys.newLine),a.push(e.sys.newLine),a.push(f(e.Diagnostics.Options_Colon)+e.sys.newLine),c=0;for(var _=[],d=[],p=e.createMap(),m=0,g=t;m<g.length;m++){var v=g[m];if(v.description){var y=" ";v.shortName&&(y+="-"+v.shortName,y+=n(v),y+=", "),y+="--"+v.name,y+=n(v),_.push(y);var h=void 0;if("lib"===v.name){h=f(v.description);var b=v.element,x=b.type;p.set(h,e.arrayFrom(x.keys()).map(function(e){return"'"+e+"'"}))}else h=f(v.description);d.push(h),c=Math.max(y.length,c)}}var D=" @<"+f(e.Diagnostics.file)+">";_.push(D),d.push(f(e.Diagnostics.Insert_command_line_options_and_files_from_a_file)),c=Math.max(D.length,c);for(var S=0;S<_.length;S++){var C=_[S],h=d[S],k=p.get(h);if(a.push(C+i(c-C.length+2)+h+e.sys.newLine),k){a.push(i(c+4));for(var T=0,E=k;T<E.length;T++){var N=E[T];a.push(N+" ")}a.push(e.sys.newLine)}}for(var A=0,F=a;A<F.length;A++){var P=F[A];e.sys.write(P)}}function v(t,r,n,i){var a;try{a=n.readFile(t)}catch(o){var s=e.createCompilerDiagnostic(e.Diagnostics.Cannot_read_file_0_Colon_1,t,o.message);return void n.onUnRecoverableConfigFileDiagnostic(s)}if(!a){var s=e.createCompilerDiagnostic(e.Diagnostics.File_0_not_found,t);return void n.onUnRecoverableConfigFileDiagnostic(s)}var c=e.parseJsonText(t,a),u=n.getCurrentDirectory();return c.path=e.toPath(t,u,e.createGetCanonicalFileName(n.useCaseSensitiveFileNames)),c.resolvedPath=c.path,c.originalFileName=c.fileName,L(c,n,e.getNormalizedAbsolutePath(e.getDirectoryPath(t),u),r,e.getNormalizedAbsolutePath(t,u),void 0,void 0,i)}function y(t,r){var n=x(t,r);return e.isString(n)?h(t,n):{config:{},error:n}}function h(t,r){var n=e.parseJsonText(t,r);return{config:C(n,n.parseDiagnostics),error:n.parseDiagnostics.length?n.parseDiagnostics[0]:void 0}}function b(t,r){var n=x(t,r);return e.isString(n)?e.parseJsonText(t,n):{parseDiagnostics:[n]}}function x(t,r){var n;try{n=r(t)}catch(i){return e.createCompilerDiagnostic(e.Diagnostics.Cannot_read_file_0_Colon_1,t,i.message)}return void 0===n?e.createCompilerDiagnostic(e.Diagnostics.The_specified_path_does_not_exist_Colon_0,t):n}function D(t){return e.arrayToMap(t,function(e){return e.name})}function S(){return void 0===Ct&&(Ct={name:void 0,type:"object",elementOptions:D([{name:"compilerOptions",type:"object",elementOptions:D(e.optionDeclarations),extraKeyDiagnosticMessage:e.Diagnostics.Unknown_compiler_option_0},{name:"typingOptions",type:"object",elementOptions:D(e.typeAcquisitionDeclarations),extraKeyDiagnosticMessage:e.Diagnostics.Unknown_type_acquisition_option_0},{name:"typeAcquisition",type:"object",elementOptions:D(e.typeAcquisitionDeclarations),extraKeyDiagnosticMessage:e.Diagnostics.Unknown_type_acquisition_option_0},{name:"extends",type:"string"},{name:"references",type:"list",element:{name:"references",type:"object"}},{name:"files",type:"list",element:{name:"files",type:"string"}},{name:"include",type:"list",element:{name:"include",type:"string"}},{name:"exclude",type:"list",element:{name:"exclude",type:"string"}},e.compileOnSaveCommandLineOption])}),Ct}function C(e,t){return k(e,t,!0,void 0,void 0)}function k(t,r,n,i,a){function s(e){return i&&i.elementOptions===e}function c(i,o,c,u){for(var d=n?{}:void 0,p=0,f=i.properties;p<f.length;p++){var m=f[p];if(276===m.kind){m.questionToken&&r.push(e.createDiagnosticForNodeInSourceFile(t,m.questionToken,e.Diagnostics._0_can_only_be_used_in_a_ts_file,"?")),_(m.name)||r.push(e.createDiagnosticForNodeInSourceFile(t,m.name,e.Diagnostics.String_literal_with_double_quotes_expected));var g=e.getTextOfPropertyName(m.name),v=g&&e.unescapeLeadingUnderscores(g),y=v&&o?o.get(v):void 0;v&&c&&!y&&r.push(e.createDiagnosticForNodeInSourceFile(t,m.name,c,v));var h=l(m.initializer,y);if("undefined"!=typeof v&&(n&&(d[v]=h),a&&(u||s(o)))){var b=E(y,h);u?b&&a.onSetValidOptionKeyValueInParent(u,y,h):s(o)&&(b?a.onSetValidOptionKeyValueInRoot(v,m.name,h,m.initializer):y||a.onSetUnknownOptionKeyValueInRoot(v,m.name,h,m.initializer))
}}else r.push(e.createDiagnosticForNodeInSourceFile(t,m,e.Diagnostics.Property_assignment_expected))}return d}function u(t,r){return n?e.filter(t.map(function(e){return l(e,r)}),function(e){return void 0!==e}):t.forEach(function(e){return l(e,r)})}function l(n,i){function a(a){a&&r.push(e.createDiagnosticForNodeInSourceFile(t,n,e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,i.name,T(i)))}switch(n.kind){case 103:return a(i&&"boolean"!==i.type),!0;case 88:return a(i&&"boolean"!==i.type),!1;case 97:return a(i&&"extends"===i.name),null;case 10:_(n)||r.push(e.createDiagnosticForNodeInSourceFile(t,n,e.Diagnostics.String_literal_with_double_quotes_expected)),a(i&&e.isString(i.type)&&"string"!==i.type);var s=n.text;if(i&&!e.isString(i.type)){var l=i;l.type.has(s.toLowerCase())||r.push(o(l,function(r,i,a){return e.createDiagnosticForNodeInSourceFile(t,n,r,i,a)}))}return s;case 8:return a(i&&"number"!==i.type),Number(n.text);case 203:if(39!==n.operator||8!==n.operand.kind)break;return a(i&&"number"!==i.type),-Number(n.operand.text);case 189:a(i&&"object"!==i.type);var d=n;if(i){var p=i,f=p.elementOptions,m=p.extraKeyDiagnosticMessage,g=p.name;return c(d,f,m,g)}return c(d,void 0,void 0,void 0);case 188:return a(i&&"list"!==i.type),u(n.elements,i&&i.element)}return void(i?a(!0):r.push(e.createDiagnosticForNodeInSourceFile(t,n,e.Diagnostics.Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal)))}function _(r){return e.isStringLiteral(r)&&e.isStringDoubleQuoted(r,t)}return t.statements.length?l(t.statements[0].expression,i):n?{}:void 0}function T(t){return"list"===t.type?"Array":e.isString(t.type)?t.type:"string"}function E(t,r){if(t){if(B(r))return!0;if("list"===t.type)return e.isArray(r);var n=e.isString(t.type)?t.type:"string";return typeof r===n}return!1}function N(t,r,n){var a=e.createGetCanonicalFileName(n.useCaseSensitiveFileNames),o=e.map(e.filter(t.fileNames,t.configFileSpecs&&t.configFileSpecs.validatedIncludeSpecs?F(r,t.configFileSpecs.validatedIncludeSpecs,t.configFileSpecs.validatedExcludeSpecs):function(){return!0}),function(t){return e.getRelativePathFromFile(e.getNormalizedAbsolutePath(r,n.getCurrentDirectory()),e.getNormalizedAbsolutePath(t,n.getCurrentDirectory()),a)}),s=I(t.options,{configFilePath:e.getNormalizedAbsolutePath(r,n.getCurrentDirectory()),useCaseSensitiveFileNames:n.useCaseSensitiveFileNames}),c=i({compilerOptions:i({},e.arrayFrom(s.entries()).reduce(function(e,t){var r;return i({},e,(r={},r[t[0]]=t[1],r))},{}),{showConfig:void 0,configFile:void 0,configFilePath:void 0,help:void 0,init:void 0,listFiles:void 0,listEmittedFiles:void 0,project:void 0,build:void 0,version:void 0}),references:e.map(t.projectReferences,function(e){return i({},e,{path:e.originalPath,originalPath:void 0})}),files:e.length(o)?o:void 0},t.configFileSpecs?{include:A(t.configFileSpecs.validatedIncludeSpecs),exclude:t.configFileSpecs.validatedExcludeSpecs}:{},{compilerOnSave:t.compileOnSave?!0:void 0});return c}function A(t){return e.length(t)?1!==e.length(t)?t:"**/*"===t[0]?void 0:t:void 0}function F(t,r,n){if(!r)return function(){return!0};var i=e.getFileMatcherPatterns(t,n,r,e.sys.useCaseSensitiveFileNames,e.sys.getCurrentDirectory()),a=i.excludePattern&&e.getRegexFromPattern(i.excludePattern,e.sys.useCaseSensitiveFileNames),o=i.includeFilePattern&&e.getRegexFromPattern(i.includeFilePattern,e.sys.useCaseSensitiveFileNames);return o?a?function(e){return!(o.test(e)&&!a.test(e))}:function(e){return!o.test(e)}:a?function(e){return a.test(e)}:function(){return!0}}function P(e){return"string"===e.type||"number"===e.type||"boolean"===e.type||"object"===e.type?void 0:"list"===e.type?P(e.element):e.type}function w(t,r){return e.forEachEntry(r,function(e,r){return e===t?r:void 0})}function I(t,n){var i=e.createMap(),a=r().optionNameMap,o=n&&e.createGetCanonicalFileName(n.useCaseSensitiveFileNames),s=function(r){if(e.hasProperty(t,r)){if(a.has(r)&&a.get(r).category===e.Diagnostics.Command_line_Options)return"continue";var s=t[r],c=a.get(r.toLowerCase());if(c){var u=P(c);u?"list"===c.type?i.set(r,s.map(function(e){return w(e,u)})):i.set(r,w(s,u)):n&&c.isFilePath?i.set(r,e.getRelativePathFromFile(n.configFilePath,e.getNormalizedAbsolutePath(s,e.getDirectoryPath(n.configFilePath)),o)):i.set(r,s)}}};for(var c in t)s(c);return i}function O(t,r,n){function i(e){switch(e.type){case"number":return 1;case"boolean":return!0;case"string":return e.isFilePath?"./":"";case"list":return[];case"object":return{};default:return e.type.keys().next().value}}function a(e){return Array(e+1).join(" ")}function o(t){var r=t.category,n=t.name;return void 0!==r&&r!==e.Diagnostics.Command_line_Options&&(r!==e.Diagnostics.Advanced_Options||u.has(n))}function s(){for(var t=e.createMultiMap(),s=0,c=e.optionDeclarations;s<c.length;s++){var l=c[s],_=l.category;o(l)&&t.add(e.getLocaleSpecificMessage(_),l)}var d=0,p=0,f=[],m=[];t.forEach(function(t,r){0!==f.length&&(f.push(""),m.push("")),f.push("/* "+r+" */"),m.push("");for(var n=0,a=t;n<a.length;n++){var o=a[n],s=void 0;s=u.has(o.name)?'"'+o.name+'": '+JSON.stringify(u.get(o.name))+((p+=1)===u.size?"":","):'// "'+o.name+'": '+JSON.stringify(i(o))+",",f.push(s),m.push("/* "+(o.description&&e.getLocaleSpecificMessage(o.description)||o.name)+" */"),d=Math.max(s.length,d)}});var g=a(2),v=[];v.push("{"),v.push(g+'"compilerOptions": {');for(var y=0;y<f.length;y++){var h=f[y],b=m[y];v.push(h&&""+g+g+h+(b&&a(d-h.length+2)+b))}if(r.length){v.push(g+"},"),v.push(g+'"files": [');for(var y=0;y<r.length;y++)v.push(""+g+g+JSON.stringify(r[y])+(y===r.length-1?"":","));v.push(g+"]")}else v.push(g+"}");return v.push("}"),v.join(n)+n}var c=e.extend(t,e.defaultInitCompilerOptions),u=I(c);return s()}function M(e,t,r,n,i,a,o,s){return J(e,void 0,t,r,n,i,a,o,s)}function L(e,t,r,n,i,a,o,s){return J(void 0,e,t,r,n,i,a,o,s)}function R(e,t){t&&Object.defineProperty(e,"configFile",{enumerable:!1,writable:!1,value:t})}function B(e){return void 0===e||null===e}function j(t,r){return e.getDirectoryPath(e.getNormalizedAbsolutePath(t,r))}function J(t,r,n,i,a,o,s,c,u){function l(){var t;if(e.hasProperty(f,"files")&&!B(f.files))if(e.isArray(f.files)){t=f.files;var a=e.hasProperty(f,"references")&&!B(f.references),u=!a||0===f.references.length,l=e.hasProperty(f,"extends");if(0===t.length&&u&&!l)if(r){var p=o||"tsconfig.json",v=e.Diagnostics.The_files_list_in_config_file_0_is_empty,y=e.firstDefined(e.getTsConfigPropArray(r,"files"),function(e){return e.initializer}),h=y?e.createDiagnosticForNodeInSourceFile(r,y,v,p):e.createCompilerDiagnostic(v,p);d.push(h)}else _(e.Diagnostics.The_files_list_in_config_file_0_is_empty,o||"tsconfig.json")}else _(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,"files","Array");var b;e.hasProperty(f,"include")&&!B(f.include)&&(e.isArray(f.include)?b=f.include:_(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,"include","Array"));var x;if(e.hasProperty(f,"exclude")&&!B(f.exclude))e.isArray(f.exclude)?x=f.exclude:_(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,"exclude","Array");else if(f.compilerOptions){var D=f.compilerOptions.outDir,S=f.compilerOptions.declarationDir;(D||S)&&(x=[D,S].filter(function(e){return!!e}))}void 0===t&&void 0===b&&(b=["**/*"]);var C=dt(t,b,x,o?j(o,i):i,m,n,d,c,r);if(U(C,K(f),s)&&d.push(V(C.spec,o)),e.hasProperty(f,"references")&&!B(f.references))if(e.isArray(f.references))for(var k=0,T=f.references;k<T.length;k++){var E=T[k];"string"!=typeof E.path?_(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,"reference.path","string"):(g||(g=[])).push({path:e.getNormalizedAbsolutePath(E.path,i),originalPath:E.path,prepend:E.prepend,circular:E.circular})}else _(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,"references","Array");return C}function _(t,n,i){r||d.push(e.createCompilerDiagnostic(t,n,i))}void 0===a&&(a={}),void 0===s&&(s=[]),void 0===c&&(c=[]),e.Debug.assert(void 0===t&&void 0!==r||void 0!==t&&void 0===r);var d=[],p=H(t,r,n,i,o,s,d,u),f=p.raw,m=e.extend(a,p.options||{});m.configFilePath=o&&e.normalizeSlashes(o),R(m,r);var g,v=l(),y=v.fileNames,h=v.wildcardDirectories,b=v.spec;return{options:m,fileNames:y,projectReferences:g,typeAcquisition:p.typeAcquisition||nt(),raw:f,errors:d,wildcardDirectories:h,compileOnSave:!!f.compileOnSave,configFileSpecs:b}}function z(t){return t.code===e.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2.code}function V(t,r){var n=t.includeSpecs,i=t.excludeSpecs;return e.createCompilerDiagnostic(e.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2,r||"tsconfig.json",JSON.stringify(n||[]),JSON.stringify(i||[]))}function U(e,t,r){return 0===e.fileNames.length&&t&&(!r||0===r.length)}function K(t){return!e.hasProperty(t,"files")&&!e.hasProperty(t,"references")}function q(t,r,n,i,a){var o=i.length;return U(t,a)?i.push(V(n,r)):e.filterMutate(i,function(e){return!z(e)}),o!==i.length}function W(e){return!!e.options}function H(t,r,n,i,a,o,s,c){i=e.normalizeSlashes(i);var u=e.getNormalizedAbsolutePath(a||"",i);if(o.indexOf(u)>=0)return s.push(e.createCompilerDiagnostic(e.Diagnostics.Circularity_detected_while_resolving_configuration_Colon_0,o.concat([u]).join(" -> "))),{raw:t||C(r,s)};var l=t?G(t,n,i,a,s):Q(r,n,i,a,s);if(l.extendedConfigPath){o=o.concat([u]);var _=Y(r,l.extendedConfigPath,n,i,o,s,c);if(_&&W(_)){var d=_.raw,p=l.raw,f=function(e){var t=p[e]||d[e];t&&(p[e]=t)};f("include"),f("exclude"),f("files"),void 0===p.compileOnSave&&(p.compileOnSave=d.compileOnSave),l.options=e.assign({},_.options,l.options)}}return l}function G(t,r,n,i,a){e.hasProperty(t,"excludes")&&a.push(e.createCompilerDiagnostic(e.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude));var o=rt(t.compilerOptions,n,a,i),s=it(t.typeAcquisition||t.typingOptions,n,a,i);t.compileOnSave=Z(t,n,a);var c;if(t.extends)if(e.isString(t.extends)){var u=i?j(i,n):n;c=X(t.extends,r,u,a,e.createCompilerDiagnostic)}else a.push(e.createCompilerDiagnostic(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,"extends","string"));return{raw:t,options:o,typeAcquisition:s,extendedConfigPath:c}}function Q(t,r,n,i,a){var o,s,c,u=tt(i),l={onSetValidOptionKeyValueInParent:function(t,r,a){e.Debug.assert("compilerOptions"===t||"typeAcquisition"===t||"typingOptions"===t);var c="compilerOptions"===t?u:"typeAcquisition"===t?o||(o=nt(i)):s||(s=nt(i));c[r.name]=st(r,n,a)},onSetValidOptionKeyValueInRoot:function(o,s,u,l){switch(o){case"extends":var _=i?j(i,n):n;return void(c=X(u,r,_,a,function(r,n){return e.createDiagnosticForNodeInSourceFile(t,l,r,n)}))}},onSetUnknownOptionKeyValueInRoot:function(r,n){"excludes"===r&&a.push(e.createDiagnosticForNodeInSourceFile(t,n,e.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude))}},_=k(t,a,!0,S(),l);return o||(o=s?void 0!==s.enableAutoDiscovery?{enable:s.enableAutoDiscovery,include:s.include,exclude:s.exclude}:s:nt(i)),{raw:_,options:u,typeAcquisition:o,extendedConfigPath:c}}function X(t,r,n,i,a){if(t=e.normalizeSlashes(t),e.isRootedDiskPath(t)||e.startsWith(t,"./")||e.startsWith(t,"../")){var o=e.getNormalizedAbsolutePath(t,n);return r.fileExists(o)||e.endsWith(o,".json")||(o+=".json",r.fileExists(o))?o:void i.push(a(e.Diagnostics.File_0_not_found,t))}var s=e.nodeModuleNameResolver(t,e.combinePaths(n,"tsconfig.json"),{moduleResolution:e.ModuleResolutionKind.NodeJs},r,void 0,void 0,!0);return s.resolvedModule?s.resolvedModule.resolvedFileName:void i.push(a(e.Diagnostics.File_0_not_found,t))}function Y(t,r,n,i,a,o,s){var c,u,l,_,d=n.useCaseSensitiveFileNames?r:e.toLowerCase(r);if(s&&(u=s.get(d)))l=u.extendedResult,_=u.extendedConfig;else{if(l=b(r,function(e){return n.readFile(e)}),!l.parseDiagnostics.length){var p=e.getDirectoryPath(r);if(_=H(void 0,l,n,p,e.getBaseFileName(r),a,o,s),W(_)){var f=e.convertToRelativePath(p,i,e.identity),m=function(t){return e.isRootedDiskPath(t)?t:e.combinePaths(f,t)},g=function(t){v[t]&&(v[t]=e.map(v[t],m))},v=_.raw;g("include"),g("exclude"),g("files")}}s&&s.set(d,{extendedResult:l,extendedConfig:_})}return t&&(t.extendedSourceFiles=[l.fileName],l.extendedSourceFiles&&(c=t.extendedSourceFiles).push.apply(c,l.extendedSourceFiles)),l.parseDiagnostics.length?void o.push.apply(o,l.parseDiagnostics):_}function Z(t,r,n){if(!e.hasProperty(t,e.compileOnSaveCommandLineOption.name))return!1;var i=ot(e.compileOnSaveCommandLineOption,t.compileOnSave,r,n);return"boolean"==typeof i&&i}function $(e,t,r){var n=[],i=rt(e,t,n,r);return{options:i,errors:n}}function et(e,t,r){var n=[],i=it(e,t,n,r);return{options:i,errors:n}}function tt(t){var r=t&&"jsconfig.json"===e.getBaseFileName(t)?{allowJs:!0,maxNodeModuleJsDepth:2,allowSyntheticDefaultImports:!0,skipLibCheck:!0,noEmit:!0}:{};return r}function rt(t,r,n,i){var a=tt(i);return at(e.optionDeclarations,t,r,a,e.Diagnostics.Unknown_compiler_option_0,n),i&&(a.configFilePath=e.normalizeSlashes(i)),a}function nt(t){return{enable:!!t&&"jsconfig.json"===e.getBaseFileName(t),include:[],exclude:[]}}function it(r,n,i,a){var o=nt(a),s=t(r);return at(e.typeAcquisitionDeclarations,s,n,o,e.Diagnostics.Unknown_type_acquisition_option_0,i),o}function at(t,r,n,i,a,o){if(r){var s=D(t);for(var c in r){var u=s.get(c);u?i[u.name]=ot(u,r[c],n,o):o.push(e.createCompilerDiagnostic(a,c))}}}function ot(t,r,n,i){if(E(t,r)){var a=t.type;return"list"===a&&e.isArray(r)?lt(t,r,n,i):e.isString(a)?ct(t,n,r):ut(t,r,i)}i.push(e.createCompilerDiagnostic(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,t.name,T(t)))}function st(t,r,n){if(B(n))return void 0;if("list"===t.type){var i=t;return i.element.isFilePath||!e.isString(i.element.type)?e.filter(e.map(n,function(e){return st(i.element,r,e)}),function(e){return!!e}):n}return e.isString(t.type)?ct(t,r,n):t.type.get(e.isString(n)?n.toLowerCase():n)}function ct(t,r,n){return t.isFilePath&&(n=e.normalizePath(e.combinePaths(r,n)),""===n&&(n=".")),n}function ut(e,t,r){if(B(t))return void 0;var n=t.toLowerCase(),i=e.type.get(n);return void 0!==i?i:void r.push(a(e))}function lt(t,r,n,i){return e.filter(e.map(r,function(e){return ot(t.element,e,n,i)}),function(e){return!!e})}function _t(e){return"function"==typeof e.trim?e.trim():e.replace(/^[\s]+|[\s]+$/g,"")}function dt(t,r,n,i,a,o,s,c,u){i=e.normalizePath(i);var l,_;r&&(l=ft(r,s,!1,u,"include")),n&&(_=ft(n,s,!0,u,"exclude"));var d=gt(l,_,i,o.useCaseSensitiveFileNames),p={filesSpecs:t,includeSpecs:r,excludeSpecs:n,validatedIncludeSpecs:l,validatedExcludeSpecs:_,wildcardDirectories:d};return pt(p,i,a,o,c)}function pt(t,r,n,i,a){void 0===a&&(a=[]),r=e.normalizePath(r);var o=i.useCaseSensitiveFileNames?e.identity:e.toLowerCase,s=e.createMap(),c=e.createMap(),u=e.createMap(),l=t.filesSpecs,_=t.validatedIncludeSpecs,d=t.validatedExcludeSpecs,p=t.wildcardDirectories,f=e.getSupportedExtensions(n,a),m=e.getSuppoertedExtensionsWithJsonIfResolveJsonModule(n,f);if(l)for(var g=0,v=l;g<v.length;g++){var y=v[g],h=e.getNormalizedAbsolutePath(y,r);s.set(o(h),h)}var b;if(_&&_.length>0)for(var x=function(t){if(e.fileExtensionIs(t,".json")){if(!b){var n=_.filter(function(t){return e.endsWith(t,".json")}),a=e.map(e.getRegularExpressionsForWildcards(n,r,"files"),function(e){return"^"+e+"$"});b=a?a.map(function(t){return e.getRegexFromPattern(t,i.useCaseSensitiveFileNames)}):e.emptyArray}var l=e.findIndex(b,function(e){return e.test(t)});if(-1!==l){var d=o(t);s.has(d)||u.has(d)||u.set(d,t)}return"continue"}if(yt(t,s,c,f,o))return"continue";ht(t,c,f,o);var p=o(t);s.has(p)||c.has(p)||c.set(p,t)},D=0,S=i.readDirectory(r,m,d,_,void 0);D<S.length;D++){var h=S[D];x(h)}var C=e.arrayFrom(s.values()),k=e.arrayFrom(c.values());return{fileNames:C.concat(k,e.arrayFrom(u.values())),wildcardDirectories:p,spec:t}}function ft(t,r,n,i,a){function o(t,r){var n=e.getTsConfigPropArrayElementValue(i,a,r);return n?e.createDiagnosticForNodeInSourceFile(i,n,t,r):e.createCompilerDiagnostic(t,r)}return t.filter(function(e){var t=mt(e,n);return void 0!==t&&r.push(o(t,e)),void 0===t})}function mt(t,r){return!r&&kt.test(t)?e.Diagnostics.File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0:Tt.test(t)?e.Diagnostics.File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0:void 0}function gt(t,r,n,i){var a=e.getRegularExpressionForWildcard(r,n,"exclude"),o=a&&new RegExp(a,i?"":"i"),s={};if(void 0!==t){for(var c=[],u=0,l=t;u<l.length;u++){var _=l[u],d=e.normalizePath(e.combinePaths(n,_));if(!o||!o.test(d)){var p=vt(d,i);if(p){var f=p.key,m=p.flags,g=s[f];(void 0===g||m>g)&&(s[f]=m,1===m&&c.push(f))}}}for(var f in s)if(e.hasProperty(s,f))for(var v=0,y=c;v<y.length;v++){var h=y[v];f!==h&&e.containsPath(h,f,n,!i)&&delete s[f]}}return s}function vt(t,r){var n=Nt.exec(t);return n?{key:r?n[0]:n[0].toLowerCase(),flags:Et.test(t)?1:0}:e.isImplicitGlob(t)?{key:t,flags:1}:void 0}function yt(t,r,n,i,a){for(var o=e.getExtensionPriority(t,i),s=e.adjustExtensionPriority(o,i),c=0;s>c;c++){var u=i[c],l=a(e.changeExtension(t,u));if(r.has(l)||n.has(l))return!0}return!1}function ht(t,r,n,i){for(var a=e.getExtensionPriority(t,n),o=e.getNextLowestExtensionPriority(a,n),s=o;s<n.length;s++){var c=n[s],u=i(e.changeExtension(t,c));r.delete(u)}}function bt(e){var t={};for(var r in e)if(e.hasOwnProperty(r)){var n=_(r);void 0!==n&&(t[r]=xt(e[r],n))}return t}function xt(t,r){switch(r.type){case"object":return"";case"string":return"";case"number":return"number"==typeof t?t:"";case"boolean":return"boolean"==typeof t?t:"";case"list":var n=r.element;return e.isArray(t)?t.map(function(e){return xt(e,n)}):"";default:return e.forEachEntry(r.type,function(e,r){return e===t?r:void 0})}}e.compileOnSaveCommandLineOption={name:"compileOnSave",type:"boolean"};var Dt=[["es5","lib.es5.d.ts"],["es6","lib.es2015.d.ts"],["es2015","lib.es2015.d.ts"],["es7","lib.es2016.d.ts"],["es2016","lib.es2016.d.ts"],["es2017","lib.es2017.d.ts"],["es2018","lib.es2018.d.ts"],["es2019","lib.es2019.d.ts"],["es2020","lib.es2020.d.ts"],["esnext","lib.esnext.d.ts"],["dom","lib.dom.d.ts"],["dom.iterable","lib.dom.iterable.d.ts"],["webworker","lib.webworker.d.ts"],["webworker.importscripts","lib.webworker.importscripts.d.ts"],["scripthost","lib.scripthost.d.ts"],["es2015.core","lib.es2015.core.d.ts"],["es2015.collection","lib.es2015.collection.d.ts"],["es2015.generator","lib.es2015.generator.d.ts"],["es2015.iterable","lib.es2015.iterable.d.ts"],["es2015.promise","lib.es2015.promise.d.ts"],["es2015.proxy","lib.es2015.proxy.d.ts"],["es2015.reflect","lib.es2015.reflect.d.ts"],["es2015.symbol","lib.es2015.symbol.d.ts"],["es2015.symbol.wellknown","lib.es2015.symbol.wellknown.d.ts"],["es2016.array.include","lib.es2016.array.include.d.ts"],["es2017.object","lib.es2017.object.d.ts"],["es2017.sharedmemory","lib.es2017.sharedmemory.d.ts"],["es2017.string","lib.es2017.string.d.ts"],["es2017.intl","lib.es2017.intl.d.ts"],["es2017.typedarrays","lib.es2017.typedarrays.d.ts"],["es2018.asynciterable","lib.es2018.asynciterable.d.ts"],["es2018.intl","lib.es2018.intl.d.ts"],["es2018.promise","lib.es2018.promise.d.ts"],["es2018.regexp","lib.es2018.regexp.d.ts"],["es2019.array","lib.es2019.array.d.ts"],["es2019.object","lib.es2019.object.d.ts"],["es2019.string","lib.es2019.string.d.ts"],["es2019.symbol","lib.es2019.symbol.d.ts"],["es2020.string","lib.es2020.string.d.ts"],["es2020.symbol.wellknown","lib.es2020.symbol.wellknown.d.ts"],["esnext.array","lib.es2019.array.d.ts"],["esnext.symbol","lib.es2019.symbol.d.ts"],["esnext.asynciterable","lib.es2018.asynciterable.d.ts"],["esnext.intl","lib.esnext.intl.d.ts"],["esnext.bigint","lib.esnext.bigint.d.ts"]];e.libs=Dt.map(function(e){return e[0]}),e.libMap=e.createMapFromEntries(Dt),e.commonOptionsWithBuild=[{name:"help",shortName:"h",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Print_this_message},{name:"help",shortName:"?",type:"boolean"},{name:"watch",shortName:"w",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Watch_input_files},{name:"preserveWatchOutput",type:"boolean",showInSimplifiedHelpView:!1,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen},{name:"listFiles",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Print_names_of_files_part_of_the_compilation},{name:"listEmittedFiles",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Print_names_of_generated_files_part_of_the_compilation},{name:"pretty",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Stylize_errors_and_messages_using_color_and_context_experimental},{name:"traceResolution",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Enable_tracing_of_the_name_resolution_process},{name:"diagnostics",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Show_diagnostic_information},{name:"extendedDiagnostics",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Show_verbose_diagnostic_information},{name:"incremental",shortName:"i",type:"boolean",category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Enable_incremental_compilation}],e.optionDeclarations=e.commonOptionsWithBuild.concat([{name:"all",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Show_all_compiler_options},{name:"version",shortName:"v",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Print_the_compiler_s_version},{name:"init",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file},{name:"project",shortName:"p",type:"string",isFilePath:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,paramType:e.Diagnostics.FILE_OR_DIRECTORY,description:e.Diagnostics.Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json},{name:"build",type:"boolean",shortName:"b",showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Build_one_or_more_projects_and_their_dependencies_if_out_of_date},{name:"showConfig",type:"boolean",category:e.Diagnostics.Command_line_Options,isCommandLineOnly:!0,description:e.Diagnostics.Print_the_final_configuration_instead_of_building},{name:"target",shortName:"t",type:e.createMapFromTemplate({es3:0,es5:1,es6:2,es2015:2,es2016:3,es2017:4,es2018:5,es2019:6,es2020:7,esnext:8}),affectsSourceFile:!0,affectsModuleResolution:!0,affectsEmit:!0,paramType:e.Diagnostics.VERSION,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Specify_ECMAScript_target_version_Colon_ES3_default_ES5_ES2015_ES2016_ES2017_ES2018_ES2019_or_ESNEXT},{name:"module",shortName:"m",type:e.createMapFromTemplate({none:e.ModuleKind.None,commonjs:e.ModuleKind.CommonJS,amd:e.ModuleKind.AMD,system:e.ModuleKind.System,umd:e.ModuleKind.UMD,es6:e.ModuleKind.ES2015,es2015:e.ModuleKind.ES2015,esnext:e.ModuleKind.ESNext}),affectsModuleResolution:!0,paramType:e.Diagnostics.KIND,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Specify_module_code_generation_Colon_none_commonjs_amd_system_umd_es2015_or_ESNext},{name:"lib",type:"list",element:{name:"lib",type:e.libMap},affectsModuleResolution:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Specify_library_files_to_be_included_in_the_compilation},{name:"allowJs",type:"boolean",affectsModuleResolution:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Allow_javascript_files_to_be_compiled},{name:"checkJs",type:"boolean",category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Report_errors_in_js_files},{name:"jsx",type:e.createMapFromTemplate({preserve:1,"react-native":3,react:2}),affectsSourceFile:!0,paramType:e.Diagnostics.KIND,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Specify_JSX_code_generation_Colon_preserve_react_native_or_react},{name:"declaration",shortName:"d",type:"boolean",affectsEmit:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Generates_corresponding_d_ts_file},{name:"declarationMap",type:"boolean",affectsEmit:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Generates_a_sourcemap_for_each_corresponding_d_ts_file},{name:"emitDeclarationOnly",type:"boolean",affectsEmit:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Only_emit_d_ts_declaration_files},{name:"sourceMap",type:"boolean",affectsEmit:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Generates_corresponding_map_file},{name:"outFile",type:"string",affectsEmit:!0,isFilePath:!0,paramType:e.Diagnostics.FILE,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Concatenate_and_emit_output_to_single_file},{name:"outDir",type:"string",affectsEmit:!0,isFilePath:!0,paramType:e.Diagnostics.DIRECTORY,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Redirect_output_structure_to_the_directory},{name:"rootDir",type:"string",affectsEmit:!0,isFilePath:!0,paramType:e.Diagnostics.LOCATION,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir},{name:"composite",type:"boolean",affectsEmit:!0,isTSConfigOnly:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Enable_project_compilation},{name:"tsBuildInfoFile",type:"string",affectsEmit:!0,isFilePath:!0,paramType:e.Diagnostics.FILE,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Specify_file_to_store_incremental_compilation_information},{name:"removeComments",type:"boolean",affectsEmit:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Do_not_emit_comments_to_output},{name:"noEmit",type:"boolean",affectsEmit:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Do_not_emit_outputs},{name:"importHelpers",type:"boolean",affectsEmit:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Import_emit_helpers_from_tslib},{name:"downlevelIteration",type:"boolean",affectsEmit:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3},{name:"isolatedModules",type:"boolean",category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule},{name:"strict",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Enable_all_strict_type_checking_options},{name:"noImplicitAny",type:"boolean",affectsSemanticDiagnostics:!0,strictFlag:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Raise_error_on_expressions_and_declarations_with_an_implied_any_type},{name:"strictNullChecks",type:"boolean",affectsSemanticDiagnostics:!0,strictFlag:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Enable_strict_null_checks},{name:"strictFunctionTypes",type:"boolean",affectsSemanticDiagnostics:!0,strictFlag:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Enable_strict_checking_of_function_types},{name:"strictBindCallApply",type:"boolean",strictFlag:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Enable_strict_bind_call_and_apply_methods_on_functions},{name:"strictPropertyInitialization",type:"boolean",affectsSemanticDiagnostics:!0,strictFlag:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Enable_strict_checking_of_property_initialization_in_classes},{name:"noImplicitThis",type:"boolean",affectsSemanticDiagnostics:!0,strictFlag:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Raise_error_on_this_expressions_with_an_implied_any_type},{name:"alwaysStrict",type:"boolean",affectsSourceFile:!0,strictFlag:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Parse_in_strict_mode_and_emit_use_strict_for_each_source_file},{name:"noUnusedLocals",type:"boolean",affectsSemanticDiagnostics:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Additional_Checks,description:e.Diagnostics.Report_errors_on_unused_locals},{name:"noUnusedParameters",type:"boolean",affectsSemanticDiagnostics:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Additional_Checks,description:e.Diagnostics.Report_errors_on_unused_parameters},{name:"noImplicitReturns",type:"boolean",affectsSemanticDiagnostics:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Additional_Checks,description:e.Diagnostics.Report_error_when_not_all_code_paths_in_function_return_a_value},{name:"noFallthroughCasesInSwitch",type:"boolean",affectsBindDiagnostics:!0,affectsSemanticDiagnostics:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Additional_Checks,description:e.Diagnostics.Report_errors_for_fallthrough_cases_in_switch_statement},{name:"moduleResolution",type:e.createMapFromTemplate({node:e.ModuleResolutionKind.NodeJs,classic:e.ModuleResolutionKind.Classic}),affectsModuleResolution:!0,paramType:e.Diagnostics.STRATEGY,category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6},{name:"baseUrl",type:"string",affectsModuleResolution:!0,isFilePath:!0,category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.Base_directory_to_resolve_non_absolute_module_names},{name:"paths",type:"object",affectsModuleResolution:!0,isTSConfigOnly:!0,category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl},{name:"rootDirs",type:"list",isTSConfigOnly:!0,element:{name:"rootDirs",type:"string",isFilePath:!0},affectsModuleResolution:!0,category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime},{name:"typeRoots",type:"list",element:{name:"typeRoots",type:"string",isFilePath:!0},affectsModuleResolution:!0,category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.List_of_folders_to_include_type_definitions_from},{name:"types",type:"list",element:{name:"types",type:"string"},affectsModuleResolution:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.Type_declaration_files_to_be_included_in_compilation},{name:"allowSyntheticDefaultImports",type:"boolean",affectsSemanticDiagnostics:!0,category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking},{name:"esModuleInterop",type:"boolean",affectsSemanticDiagnostics:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for_all_imports_Implies_allowSyntheticDefaultImports},{name:"preserveSymlinks",type:"boolean",category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.Do_not_resolve_the_real_path_of_symlinks},{name:"allowUmdGlobalAccess",type:"boolean",affectsSemanticDiagnostics:!0,category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.Allow_accessing_UMD_globals_from_modules},{name:"sourceRoot",type:"string",affectsEmit:!0,paramType:e.Diagnostics.LOCATION,category:e.Diagnostics.Source_Map_Options,description:e.Diagnostics.Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations},{name:"mapRoot",type:"string",affectsEmit:!0,paramType:e.Diagnostics.LOCATION,category:e.Diagnostics.Source_Map_Options,description:e.Diagnostics.Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations},{name:"inlineSourceMap",type:"boolean",affectsEmit:!0,category:e.Diagnostics.Source_Map_Options,description:e.Diagnostics.Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file},{name:"inlineSources",type:"boolean",affectsEmit:!0,category:e.Diagnostics.Source_Map_Options,description:e.Diagnostics.Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set},{name:"experimentalDecorators",type:"boolean",category:e.Diagnostics.Experimental_Options,description:e.Diagnostics.Enables_experimental_support_for_ES7_decorators},{name:"emitDecoratorMetadata",type:"boolean",category:e.Diagnostics.Experimental_Options,description:e.Diagnostics.Enables_experimental_support_for_emitting_type_metadata_for_decorators},{name:"jsxFactory",type:"string",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h},{name:"resolveJsonModule",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Include_modules_imported_with_json_extension},{name:"out",type:"string",affectsEmit:!0,isFilePath:!1,category:e.Diagnostics.Advanced_Options,paramType:e.Diagnostics.FILE,description:e.Diagnostics.Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file},{name:"reactNamespace",type:"string",affectsEmit:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit},{name:"skipDefaultLibCheck",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files},{name:"charset",type:"string",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.The_character_set_of_the_input_files},{name:"emitBOM",type:"boolean",affectsEmit:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files},{name:"locale",type:"string",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.The_locale_used_when_displaying_messages_to_the_user_e_g_en_us},{name:"newLine",type:e.createMapFromTemplate({crlf:0,lf:1}),affectsEmit:!0,paramType:e.Diagnostics.NEWLINE,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix},{name:"noErrorTruncation",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_truncate_error_messages},{name:"noLib",type:"boolean",affectsModuleResolution:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_include_the_default_library_file_lib_d_ts},{name:"noResolve",type:"boolean",affectsModuleResolution:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files},{name:"stripInternal",type:"boolean",affectsEmit:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_emit_declarations_for_code_that_has_an_internal_annotation},{name:"disableSizeLimit",type:"boolean",affectsSourceFile:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Disable_size_limitations_on_JavaScript_projects},{name:"noImplicitUseStrict",type:"boolean",affectsSemanticDiagnostics:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_emit_use_strict_directives_in_module_output},{name:"noEmitHelpers",type:"boolean",affectsEmit:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_generate_custom_helper_functions_like_extends_in_compiled_output},{name:"noEmitOnError",type:"boolean",affectsEmit:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_emit_outputs_if_any_errors_were_reported},{name:"preserveConstEnums",type:"boolean",affectsEmit:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_erase_const_enum_declarations_in_generated_code},{name:"declarationDir",type:"string",affectsEmit:!0,isFilePath:!0,paramType:e.Diagnostics.DIRECTORY,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Output_directory_for_generated_declaration_files},{name:"skipLibCheck",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Skip_type_checking_of_declaration_files},{name:"allowUnusedLabels",type:"boolean",affectsBindDiagnostics:!0,affectsSemanticDiagnostics:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_report_errors_on_unused_labels},{name:"allowUnreachableCode",type:"boolean",affectsBindDiagnostics:!0,affectsSemanticDiagnostics:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_report_errors_on_unreachable_code},{name:"suppressExcessPropertyErrors",type:"boolean",affectsSemanticDiagnostics:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Suppress_excess_property_checks_for_object_literals},{name:"suppressImplicitAnyIndexErrors",type:"boolean",affectsSemanticDiagnostics:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures},{name:"forceConsistentCasingInFileNames",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Disallow_inconsistently_cased_references_to_the_same_file},{name:"maxNodeModuleJsDepth",type:"number",affectsModuleResolution:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files},{name:"noStrictGenericChecks",type:"boolean",affectsSemanticDiagnostics:!0,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Disable_strict_checking_of_generic_signatures_in_function_types},{name:"keyofStringsOnly",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols},{name:"plugins",type:"list",isTSConfigOnly:!0,element:{name:"plugin",type:"object"},description:e.Diagnostics.List_of_language_service_plugins}]),e.semanticDiagnosticsOptionDeclarations=e.optionDeclarations.filter(function(e){return!!e.affectsSemanticDiagnostics
}),e.affectsEmitOptionDeclarations=e.optionDeclarations.filter(function(e){return!!e.affectsEmit}),e.moduleResolutionOptionDeclarations=e.optionDeclarations.filter(function(e){return!!e.affectsModuleResolution}),e.sourceFileAffectingCompilerOptions=e.optionDeclarations.filter(function(e){return!!e.affectsSourceFile||!!e.affectsModuleResolution||!!e.affectsBindDiagnostics}),e.buildOpts=e.commonOptionsWithBuild.concat([{name:"verbose",shortName:"v",category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Enable_verbose_logging,type:"boolean"},{name:"dry",shortName:"d",category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Show_what_would_be_built_or_deleted_if_specified_with_clean,type:"boolean"},{name:"force",shortName:"f",category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Build_all_projects_including_those_that_appear_to_be_up_to_date,type:"boolean"},{name:"clean",category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Delete_the_outputs_of_all_projects,type:"boolean"}]),e.typeAcquisitionDeclarations=[{name:"enableAutoDiscovery",type:"boolean"},{name:"enable",type:"boolean"},{name:"include",type:"list",element:{name:"include",type:"string"}},{name:"exclude",type:"list",element:{name:"exclude",type:"string"}}],e.defaultInitCompilerOptions={module:e.ModuleKind.CommonJS,target:1,strict:!0,esModuleInterop:!0};var St;e.convertEnableAutoDiscoveryToEnable=t,e.createOptionNameMap=n,e.createCompilerDiagnosticForInvalidCustomType=a,e.parseCustomTypeOption=s,e.parseListTypeOption=c,e.parseCommandLine=l,e.getOptionFromName=_,e.parseBuildCommand=p,e.printVersion=m,e.printHelp=g,e.getParsedCommandLineOfConfigFile=v,e.readConfigFile=y,e.parseConfigFileTextToJson=h,e.readJsonConfigFile=b;var Ct;e.convertToObject=C,e.convertToObjectWorker=k,e.convertToTSConfig=N,e.generateTSConfig=O,e.parseJsonConfigFileContent=M,e.parseJsonSourceFileConfigFileContent=L,e.setConfigFileInOptions=R,e.canJsonReportNoInutFiles=K,e.updateErrorForNoInputFiles=q,e.convertCompilerOptionsFromJson=$,e.convertTypeAcquisitionFromJson=et;var kt=/(^|\/)\*\*\/?$/,Tt=/(^|\/)\*\*\/(.*\/)?\.\.($|\/)/,Et=/\/[^\/]*?[*?][^\/]*\//,Nt=/^[^*?]*(?=\/[^\/]*[*?])/;e.getFileNamesFromConfigSpecs=pt,e.convertCompilerOptionsForTelemetry=bt}(n||(n={}));var n;!function(e){function t(t){t.trace(e.formatMessage.apply(void 0,arguments))}function r(e,t){return!!e.traceResolution&&void 0!==t.trace}function n(t,r){var n;if(r&&t){var i=t.packageJsonContent;"string"==typeof i.name&&"string"==typeof i.version&&(n={name:i.name,subModuleName:r.path.slice(t.packageDirectory.length+e.directorySeparator.length),version:i.version})}return r&&{path:r.path,extension:r.ext,packageId:n}}function a(e){return n(void 0,e)}function o(t){return t?(e.Debug.assert(void 0===t.packageId),{path:t.path,ext:t.extension}):void 0}function s(t){return t?(e.Debug.assert(e.extensionIsTS(t.extension)),{fileName:t.path,packageId:t.packageId}):void 0}function c(e,t,r){return{resolvedModule:e&&{resolvedFileName:e.path,originalPath:e.originalPath===!0?void 0:e.originalPath,extension:e.extension,isExternalLibraryImport:t,packageId:e.packageId},failedLookupLocations:r}}function u(r,n,i,a){if(!e.hasProperty(r,n))return void(a.traceEnabled&&t(a.host,e.Diagnostics.package_json_does_not_have_a_0_field,n));var o=r[n];return typeof o!==i||null===o?void(a.traceEnabled&&t(a.host,e.Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2,n,i,null===o?"null":typeof o)):o}function l(r,n,i,a){var o=u(r,n,"string",a);if(void 0!==o){if(!o)return void(a.traceEnabled&&t(a.host,e.Diagnostics.package_json_had_a_falsy_0_field,n));var s=e.normalizePath(e.combinePaths(i,o));return a.traceEnabled&&t(a.host,e.Diagnostics.package_json_has_0_field_1_that_references_2,n,o,s),s}}function _(e,t,r){return l(e,"typings",t,r)||l(e,"types",t,r)}function d(e,t,r){return l(e,"tsconfig",t,r)}function p(e,t,r){return l(e,"main",t,r)}function f(r,n){var i=u(r,"typesVersions","object",n);if(void 0!==i)return n.traceEnabled&&t(n.host,e.Diagnostics.package_json_has_a_typesVersions_field_with_version_specific_path_mappings),i}function m(r,n){var i=f(r,n);if(void 0!==i){if(n.traceEnabled)for(var a in i)e.hasProperty(i,a)&&!e.VersionRange.tryParse(a)&&t(n.host,e.Diagnostics.package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range,a);var o=g(i);if(!o)return void(n.traceEnabled&&t(n.host,e.Diagnostics.package_json_does_not_have_a_typesVersions_entry_that_matches_version_0,e.versionMajorMinor));var s=o.version,c=o.paths;return"object"!=typeof c?void(n.traceEnabled&&t(n.host,e.Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2,"typesVersions['"+s+"']","object",typeof c)):o}}function g(t){dt||(dt=new e.Version(e.version));for(var r in t)if(e.hasProperty(t,r)){var n=e.VersionRange.tryParse(r);if(void 0!==n&&n.test(dt))return{version:r,paths:t[r]}}}function v(t,r){if(t.typeRoots)return t.typeRoots;var n;return t.configFilePath?n=e.getDirectoryPath(t.configFilePath):r.getCurrentDirectory&&(n=r.getCurrentDirectory()),void 0!==n?y(n,r):void 0}function y(t,r){if(!r.directoryExists)return[e.combinePaths(t,pt)];var n;return e.forEachAncestorDirectory(e.normalizePath(t),function(t){var i=e.combinePaths(t,pt);return void(r.directoryExists(i)&&(n||(n=[])).push(i))}),n}function h(n,i,a,o,c){function u(){return f&&f.length?(_&&t(o,e.Diagnostics.Resolving_with_primary_search_path_0,f.join(", ")),e.firstDefined(f,function(r){var i=e.combinePaths(r,n),a=e.getDirectoryPath(i),c=e.directoryProbablyExists(a,o);return!c&&_&&t(o,e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it,a),s(K(_t.DtsOnly,i,!c,p))})):void(_&&t(o,e.Diagnostics.Root_directory_cannot_be_determined_skipping_primary_search_paths))}function l(){var r=i&&e.getDirectoryPath(i);if(void 0!==r){_&&t(o,e.Diagnostics.Looking_up_in_node_modules_folder_initial_location_0,r);var a=void 0;if(e.isExternalModuleNameRelative(n)){var c=e.normalizePathAndParts(e.combinePaths(r,n)).path;a=L(_t.DtsOnly,c,!1,p,!0)}else{var u=X(_t.DtsOnly,n,r,p,void 0,void 0);a=u&&u.value}var l=s(a);return!l&&_&&t(o,e.Diagnostics.Type_reference_directive_0_was_not_resolved,n),l}_&&t(o,e.Diagnostics.Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder)}var _=r(a,o);c&&(a=c.commandLine.options);var d=[],p={compilerOptions:a,host:o,traceEnabled:_,failedLookupLocations:d},f=v(a,o);_&&(void 0===i?void 0===f?t(o,e.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set,n):t(o,e.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1,n,f):void 0===f?t(o,e.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set,n,i):t(o,e.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_2,n,i,f),c&&t(o,e.Diagnostics.Using_compiler_options_of_project_reference_redirect_0,c.sourceFile.fileName));var m=u(),g=!0;m||(m=l(),g=!1);var y;if(m){var h=m.fileName,b=m.packageId,x=a.preserveSymlinks?h:M(h,o,_);_&&(b?t(o,e.Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3,n,x,e.packageIdToString(b),g):t(o,e.Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2,n,x,g)),y={primary:g,resolvedFileName:x,packageId:b,isExternalLibraryImport:R(h)}}return{resolvedTypeReferenceDirective:y,failedLookupLocations:d}}function b(t,r){if(t.types)return t.types;var n=[];if(r.directoryExists&&r.getDirectories){var i=v(t,r);if(i)for(var a=0,o=i;a<o.length;a++){var s=o[a];if(r.directoryExists(s))for(var c=0,u=r.getDirectories(s);c<u.length;c++){var l=u[c],_=e.normalizePath(l),d=e.combinePaths(s,_,"package.json"),p=r.fileExists(d)&&null===e.readJson(d,r).typings;if(!p){var f=e.getBaseFileName(_);46!==f.charCodeAt(0)&&n.push(f)}}}}return n}function x(e,t,r){return S(D(r),D(r),e,t)}function D(t){function r(e){t=e}function n(e){o=e}function i(r){if(!r)return o;var n=r.sourceFile.path,i=s.get(n);return i||(i=!t||e.optionsHaveModuleResolutionChanges(t,r.commandLine.options)?e.createMap():o,s.set(n,i)),i}function a(){o.clear(),s.clear()}var o=e.createMap(),s=e.createMap();return{ownMap:o,redirectsMap:s,getOrCreateMapOfCacheRedirects:i,clear:a,setOwnOptions:r,setOwnMap:n}}function S(t,r,n,i){function a(r,a){var o=e.toPath(r,n,i);return s(t,a,o,e.createMap)}function o(t,n){return e.Debug.assert(!e.isExternalModuleNameRelative(t)),s(r,n,t,c)}function s(e,t,r,n){var i=e.getOrCreateMapOfCacheRedirects(t),a=i.get(r);return a||(a=n(),i.set(r,a)),a}function c(){function t(t){return o.get(e.toPath(t,n,i))}function r(t,r){var s=e.toPath(t,n,i);if(!o.has(s)){o.set(s,r);for(var c=r.resolvedModule&&(r.resolvedModule.originalPath||r.resolvedModule.resolvedFileName),u=c&&a(s,c),l=s;l!==u;){var _=e.getDirectoryPath(l);if(_===l||o.has(_))break;o.set(_,r),l=_}}}function a(t,r){for(var a=e.toPath(e.getDirectoryPath(r),n,i),o=0,s=Math.min(t.length,a.length);s>o&&t.charCodeAt(o)===a.charCodeAt(o);)o++;if(o===t.length&&(a.length===o||a[o]===e.directorySeparator))return t;var c=e.getRootLength(t);if(c>o)return void 0;var u=t.lastIndexOf(e.directorySeparator,o-1);return-1===u?void 0:t.substr(0,Math.max(u,c))}var o=e.createMap();return{get:t,set:r}}return{getOrCreateCacheForDirectory:a,getOrCreateCacheForModuleName:o,directoryToModuleNameMap:t,moduleNameToDirectoryMap:r}}function C(t,r,n){var i=e.getDirectoryPath(r),a=n&&n.getOrCreateCacheForDirectory(i);return a&&a.get(t)}function k(n,i,a,o,s,c){var u=r(a,o);c&&(a=c.commandLine.options),u&&(t(o,e.Diagnostics.Resolving_module_0_from_1,n,i),c&&t(o,e.Diagnostics.Using_compiler_options_of_project_reference_redirect_0,c.sourceFile.fileName));var l=e.getDirectoryPath(i),_=s&&s.getOrCreateCacheForDirectory(l,c),d=_&&_.get(n);if(d)u&&t(o,e.Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1,n,l);else{var p=a.moduleResolution;switch(void 0===p?(p=e.getEmitModuleKind(a)===e.ModuleKind.CommonJS?e.ModuleResolutionKind.NodeJs:e.ModuleResolutionKind.Classic,u&&t(o,e.Diagnostics.Module_resolution_kind_is_not_specified_using_0,e.ModuleResolutionKind[p])):u&&t(o,e.Diagnostics.Explicitly_specified_module_resolution_kind_Colon_0,e.ModuleResolutionKind[p]),p){case e.ModuleResolutionKind.NodeJs:d=I(n,i,a,o,s,c);break;case e.ModuleResolutionKind.Classic:d=ct(n,i,a,o,s,c);break;default:return e.Debug.fail("Unexpected moduleResolution: "+p)}_&&(_.set(n,d),e.isExternalModuleNameRelative(n)||s.getOrCreateCacheForModuleName(n,c).set(l,d))}return u&&(d.resolvedModule?d.resolvedModule.packageId?t(o,e.Diagnostics.Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2,n,d.resolvedModule.resolvedFileName,e.packageIdToString(d.resolvedModule.packageId)):t(o,e.Diagnostics.Module_name_0_was_successfully_resolved_to_1,n,d.resolvedModule.resolvedFileName):t(o,e.Diagnostics.Module_name_0_was_not_resolved,n)),d}function T(t,r,n,i,a){var o=E(t,r,i,a);return o?o.value:e.isExternalModuleNameRelative(r)?N(t,r,n,i,a):A(t,r,i,a)}function E(r,n,i,a){var o=a.compilerOptions,s=o.baseUrl,c=o.paths;return s&&c&&!e.pathIsRelative(n)?(a.traceEnabled&&(t(a.host,e.Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1,s,n),t(a.host,e.Diagnostics.paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0,n)),tt(r,n,s,c,i,!1,a)):void 0}function N(r,n,i,a,o){if(!o.compilerOptions.rootDirs)return void 0;o.traceEnabled&&t(o.host,e.Diagnostics.rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0,n);for(var s,c,u=e.normalizePath(e.combinePaths(i,n)),l=0,_=o.compilerOptions.rootDirs;l<_.length;l++){var d=_[l],p=e.normalizePath(d);e.endsWith(p,e.directorySeparator)||(p+=e.directorySeparator);var f=e.startsWith(u,p)&&(void 0===c||c.length<p.length);o.traceEnabled&&t(o.host,e.Diagnostics.Checking_if_0_is_the_longest_matching_prefix_for_1_2,p,u,f),f&&(c=p,s=d)}if(c){o.traceEnabled&&t(o.host,e.Diagnostics.Longest_matching_prefix_for_0_is_1,u,c);var m=u.substr(c.length);o.traceEnabled&&t(o.host,e.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2,m,c,u);var g=a(r,u,!e.directoryProbablyExists(i,o.host),o);if(g)return g;o.traceEnabled&&t(o.host,e.Diagnostics.Trying_other_entries_in_rootDirs);for(var v=0,y=o.compilerOptions.rootDirs;v<y.length;v++){var d=y[v];if(d!==s){var h=e.combinePaths(e.normalizePath(d),m);o.traceEnabled&&t(o.host,e.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2,m,d,h);var b=e.getDirectoryPath(h),x=a(r,h,!e.directoryProbablyExists(b,o.host),o);if(x)return x}}o.traceEnabled&&t(o.host,e.Diagnostics.Module_resolution_using_rootDirs_has_failed)}return void 0}function A(r,n,i,a){var o=a.compilerOptions.baseUrl;if(!o)return void 0;a.traceEnabled&&t(a.host,e.Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1,o,n);var s=e.normalizePath(e.combinePaths(o,n));return a.traceEnabled&&t(a.host,e.Diagnostics.Resolving_module_name_0_relative_to_base_url_1_2,n,o,s),i(r,s,!e.directoryProbablyExists(e.getDirectoryPath(s),a.host),a)}function F(e,t,r){var n=w(e,t,r),i=n.resolvedModule,a=n.failedLookupLocations;if(!i)throw new Error("Could not resolve JS module '"+e+"' starting at '"+t+"'. Looked in: "+a.join(", "));return i.resolvedFileName}function P(e,t,r){var n=w(e,t,r).resolvedModule;return n&&n.resolvedFileName}function w(t,r,n){return O(t,r,{moduleResolution:e.ModuleResolutionKind.NodeJs,allowJs:!0},n,void 0,ft,void 0)}function I(t,r,n,i,a,o,s){return O(t,e.getDirectoryPath(r),n,i,a,s?vt:n.resolveJsonModule?gt:mt,o)}function O(n,a,o,s,u,l,_){function d(r){var c=function(e,t,r,n){return L(e,t,r,n,!0)},l=T(r,n,a,c,m);if(l)return lt({resolved:l,isExternalLibraryImport:R(l.path)});if(e.isExternalModuleNameRelative(n)){var d=e.normalizePathAndParts(e.combinePaths(a,n)),f=d.path,g=d.parts,v=L(r,f,!1,m,!0);return v&&lt({resolved:v,isExternalLibraryImport:e.contains(g,"node_modules")})}p&&t(s,e.Diagnostics.Loading_module_0_from_node_modules_folder_target_file_type_1,n,_t[r]);var y=X(r,n,a,m,u,_);if(!y)return void 0;var h=y.value;if(!o.preserveSymlinks&&h&&!h.originalPath){var b=M(h.path,s,p),x=b===h.path?void 0:h.path;h=i({},h,{path:b,originalPath:x})}return{value:h&&{resolved:h,isExternalLibraryImport:!0}}}var p=r(o,s),f=[],m={compilerOptions:o,host:s,traceEnabled:p,failedLookupLocations:f},g=e.forEach(l,function(e){return d(e)});if(g&&g.value){var v=g.value,y=v.resolved,h=v.isExternalLibraryImport;return c(y,h,f)}return{resolvedModule:void 0,failedLookupLocations:f}}function M(r,n,i){if(!n.realpath)return r;var a=e.normalizePath(n.realpath(r));return i&&t(n,e.Diagnostics.Resolving_real_path_for_0_result_1,r,a),e.Debug.assert(n.fileExists(a),r+" linked to nonexistent file "+a),a}function L(r,i,a,o,s){if(o.traceEnabled&&t(o.host,e.Diagnostics.Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1,i,_t[r]),!e.hasTrailingDirectorySeparator(i)){if(!a){var c=e.getDirectoryPath(i);e.directoryProbablyExists(c,o.host)||(o.traceEnabled&&t(o.host,e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it,c),a=!0)}var u=z(r,i,a,o);if(u){var l=s?B(u):void 0,_=l?q(l,!1,o):void 0;return n(_,u)}}if(!a){var d=e.directoryProbablyExists(i,o.host);d||(o.traceEnabled&&t(o.host,e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it,i),a=!0)}return K(r,i,a,o,s)}function R(t){return e.stringContains(t,e.nodeModulesPathPart)}function B(t){var r=e.normalizePath(t.path),n=r.lastIndexOf(e.nodeModulesPathPart);if(-1===n)return void 0;var i=n+e.nodeModulesPathPart.length,a=j(r,i);return 64===r.charCodeAt(i)&&(a=j(r,a)),r.slice(0,a)}function j(t,r){var n=t.indexOf(e.directorySeparator,r+1);return-1===n?r:n}function J(e,t,r,n){return a(z(e,t,r,n))}function z(r,n,i,a){if(r===_t.Json||r===_t.TSConfig){var o=e.tryRemoveExtension(n,".json");return void 0===o&&r===_t.Json?void 0:V(o||n,r,i,a)}var s=V(n,r,i,a);if(s)return s;if(e.hasJSFileExtension(n)){var c=e.removeFileExtension(n);if(a.traceEnabled){var u=n.substring(c.length);t(a.host,e.Diagnostics.File_name_0_has_a_1_extension_stripping_it,n,u)}return V(c,r,i,a)}}function V(t,r,n,i){function a(e){var r=U(t+e,n,i);return void 0===r?void 0:{path:r,ext:e}}if(!n){var o=e.getDirectoryPath(t);o&&(n=!e.directoryProbablyExists(o,i.host))}switch(r){case _t.DtsOnly:return a(".d.ts");case _t.TypeScript:return a(".ts")||a(".tsx")||a(".d.ts");case _t.JavaScript:return a(".js")||a(".jsx");case _t.TSConfig:case _t.Json:return a(".json")}}function U(r,n,i){if(!n){if(i.host.fileExists(r))return i.traceEnabled&&t(i.host,e.Diagnostics.File_0_exist_use_it_as_a_name_resolution_result,r),r;i.traceEnabled&&t(i.host,e.Diagnostics.File_0_does_not_exist,r)}return void i.failedLookupLocations.push(r)}function K(e,t,r,i,a){void 0===a&&(a=!0);var o=a?q(t,r,i):void 0,s=o&&o.packageJsonContent,c=o&&o.versionPaths;return n(o,W(e,t,r,i,s,c))}function q(r,n,i){var a=i.host,o=i.traceEnabled,s=!n&&e.directoryProbablyExists(r,a),c=e.combinePaths(r,"package.json");if(s&&a.fileExists(c)){var u=e.readJson(c,a);o&&t(a,e.Diagnostics.Found_package_json_at_0,c);var l=m(u,i);return{packageDirectory:r,packageJsonContent:u,versionPaths:l}}s&&o&&t(a,e.Diagnostics.File_0_does_not_exist,c),i.failedLookupLocations.push(c)}function W(r,n,i,s,c,u){var l;if(c)switch(r){case _t.JavaScript:case _t.Json:l=p(c,n,s);break;case _t.TypeScript:l=_(c,n,s)||p(c,n,s);break;case _t.DtsOnly:l=_(c,n,s);break;case _t.TSConfig:l=d(c,n,s);break;default:return e.Debug.assertNever(r)}var f=function(r,n,i,o){var s=U(n,i,o);if(s){var c=H(r,s);if(c)return a(c);o.traceEnabled&&t(o.host,e.Diagnostics.File_0_has_an_unsupported_extension_so_skipping_it,s)}var u=r===_t.DtsOnly?_t.TypeScript:r;return L(u,n,i,o,!1)},m=l?!e.directoryProbablyExists(e.getDirectoryPath(l),s.host):void 0,g=i||!e.directoryProbablyExists(n,s.host),v=e.combinePaths(n,r===_t.TSConfig?"tsconfig":"index");if(u&&(!l||e.containsPath(n,l))){var y=e.getRelativePathFromDirectory(n,l||v,!1);s.traceEnabled&&t(s.host,e.Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2,u.version,e.version,y);var h=tt(r,y,n,u.paths,f,m||g,s);if(h)return o(h.value)}var b=l&&o(f(r,l,m,s));return b?b:z(r,v,g,s)}function H(t,r){var n=e.tryGetExtensionFromPath(r);return void 0!==n&&G(t,n)?{path:r,ext:n}:void 0}function G(e,t){switch(e){case _t.JavaScript:return".js"===t||".jsx"===t;case _t.TSConfig:case _t.Json:return".json"===t;case _t.TypeScript:return".ts"===t||".tsx"===t||".d.ts"===t;case _t.DtsOnly:return".d.ts"===t}}function Q(t){var r=t.indexOf(e.directorySeparator);return"@"===t[0]&&(r=t.indexOf(e.directorySeparator,r+1)),-1===r?{packageName:t,rest:""}:{packageName:t.slice(0,r),rest:t.slice(r+1)}}function X(e,t,r,n,i,a){return Z(e,t,r,n,!1,i,a)}function Y(e,t,r){return Z(_t.DtsOnly,e,t,r,!0,void 0,void 0)}function Z(t,r,n,i,a,o,s){var c=o&&o.getOrCreateCacheForModuleName(r,s);return e.forEachAncestorDirectory(e.normalizeSlashes(n),function(n){if("node_modules"!==e.getBaseFileName(n)){var o=st(c,r,n,i);return o?o:lt($(t,r,n,i,a))}})}function $(r,n,i,a,o){var s=e.combinePaths(i,"node_modules"),c=e.directoryProbablyExists(s,a.host);!c&&a.traceEnabled&&t(a.host,e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it,s);var u=o?void 0:et(r,n,s,c,a);if(u)return u;if(r===_t.TypeScript||r===_t.DtsOnly){var l=e.combinePaths(s,"@types"),_=c;return c&&!e.directoryProbablyExists(l,a.host)&&(a.traceEnabled&&t(a.host,e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it,l),_=!1),et(_t.DtsOnly,rt(n,a),l,_,a)}}function et(r,i,o,s,c){var u=e.normalizePath(e.combinePaths(o,i)),l=q(u,!s,c);if(l){var _=z(r,u,!s,c);if(_)return a(_);var d=W(r,u,!s,c,l.packageJsonContent,l.versionPaths);return n(l,d)}var p=function(e,t,r,i){var a=z(e,t,r,i)||W(e,t,r,i,l&&l.packageJsonContent,l&&l.versionPaths);return n(l,a)},f=Q(i),m=f.packageName,g=f.rest;if(""!==g){var v=e.combinePaths(o,m);if(l=q(v,!s,c),l&&l.versionPaths){c.traceEnabled&&t(c.host,e.Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2,l.versionPaths.version,e.version,g);var y=s&&e.directoryProbablyExists(v,c.host),h=tt(r,g,v,l.versionPaths.paths,p,!y,c);if(h)return h.value}}return p(r,u,!s,c)}function tt(r,n,i,o,s,c,u){var l=e.matchPatternOrExact(e.getOwnKeys(o),n);if(l){var _=e.isString(l)?void 0:e.matchedText(l,n),d=e.isString(l)?l:e.patternText(l);u.traceEnabled&&t(u.host,e.Diagnostics.Module_name_0_matched_pattern_1,n,d);var p=e.forEach(o[d],function(n){var o=_?n.replace("*",_):n,l=e.normalizePath(e.combinePaths(i,o));u.traceEnabled&&t(u.host,e.Diagnostics.Trying_substitution_0_candidate_module_location_Colon_1,n,o);var d=e.tryGetExtensionFromPath(l);if(void 0!==d){var p=U(l,c,u);if(void 0!==p)return a({path:p,ext:d})}return s(r,l,c||!e.directoryProbablyExists(e.getDirectoryPath(l),u.host),u)});return{value:p}}}function rt(r,n){var i=it(r);return n.traceEnabled&&i!==r&&t(n.host,e.Diagnostics.Scoped_package_detected_looking_in_0,i),i}function nt(e){return"@types/"+it(e)}function it(t){if(e.startsWith(t,"@")){var r=t.replace(e.directorySeparator,yt);if(r!==t)return r.slice(1)}return t}function at(t){var r=e.removePrefix(t,"@types/");return r!==t?ot(r):t}function ot(t){return e.stringContains(t,yt)?"@"+t.replace(yt,e.directorySeparator):t}function st(r,n,i,a){var o,s=r&&r.get(i);return s?(a.traceEnabled&&t(a.host,e.Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1,n,i),(o=a.failedLookupLocations).push.apply(o,s.failedLookupLocations),{value:s.resolvedModule&&{path:s.resolvedModule.resolvedFileName,originalPath:s.resolvedModule.originalPath||!0,extension:s.resolvedModule.extension,packageId:s.resolvedModule.packageId}}):void 0}function ct(t,n,i,a,o,s){function u(r){var n=T(r,t,p,J,d);if(n)return{value:n};if(e.isExternalModuleNameRelative(t)){var i=e.normalizePath(e.combinePaths(p,t));return lt(J(r,i,!1,d))}var a=o&&o.getOrCreateCacheForModuleName(t,s),c=e.forEachAncestorDirectory(p,function(n){var i=st(a,t,n,d);if(i)return i;var o=e.normalizePath(e.combinePaths(n,t));return lt(J(r,o,!1,d))});return c?c:r===_t.TypeScript?Y(t,p,d):void 0}var l=r(i,a),_=[],d={compilerOptions:i,host:a,traceEnabled:l,failedLookupLocations:_},p=e.getDirectoryPath(n),f=u(_t.TypeScript)||u(_t.JavaScript);return c(f&&f.value,!1,_)}function ut(n,i,a,o,s){var u=r(a,o);u&&t(o,e.Diagnostics.Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2,i,n,s);var l=[],_={compilerOptions:a,host:o,traceEnabled:u,failedLookupLocations:l},d=$(_t.DtsOnly,n,s,_,!1);return c(d,!0,l)}function lt(e){return void 0!==e?{value:e}:void 0}e.trace=t,e.isTraceEnabled=r;var _t;!function(e){e[e.TypeScript=0]="TypeScript",e[e.JavaScript=1]="JavaScript",e[e.Json=2]="Json",e[e.TSConfig=3]="TSConfig",e[e.DtsOnly=4]="DtsOnly"}(_t||(_t={}));var dt;e.getPackageJsonTypesVersionsPaths=g,e.getEffectiveTypeRoots=v;var pt=e.combinePaths("node_modules","@types");e.resolveTypeReferenceDirective=h,e.getAutomaticTypeDirectiveNames=b,e.createModuleResolutionCache=x,e.createCacheWithRedirects=D,e.createModuleResolutionCacheWithMaps=S,e.resolveModuleNameFromCache=C,e.resolveModuleName=k,e.resolveJSModule=F,e.tryResolveJSModule=P;var ft=[_t.JavaScript],mt=[_t.TypeScript,_t.JavaScript],gt=mt.concat([_t.Json]),vt=[_t.TSConfig];e.nodeModuleNameResolver=I,e.nodeModulesPathPart="/node_modules/",e.pathContainsNodeModules=R,e.parsePackageName=Q;var yt="__";e.getTypesPackageName=nt,e.mangleScopedPackageName=it,e.getPackageNameFromTypesPackageName=at,e.unmangleScopedPackageName=ot,e.classicNameResolver=ct,e.loadModuleFromGlobalCache=ut}(n||(n={}));var n;!function(e){function t(e){return e.body?r(e.body):1}function r(n){switch(n.kind){case 242:case 243:return 0;case 244:if(e.isEnumConst(n))return 2;break;case 250:case 249:if(!e.hasModifier(n,1))return 0;break;case 246:var i=0;return e.forEachChild(n,function(t){var n=r(t);switch(n){case 0:return;case 2:return void(i=2);case 1:return i=1,!0;default:e.Debug.assertNever(n)}}),i;case 245:return t(n);case 73:if(n.isInJSDocNamespace)return 0}return 1}function n(t,r){e.performance.mark("beforeBind"),q(t,r),e.performance.mark("afterBind"),e.performance.measure("Bind","beforeBind","afterBind")}function a(){function r(t,r,n,i,a){return e.createDiagnosticForNodeInSourceFile(e.getSourceFileOfNode(t)||Hr,t,r,n,i,a)}function n(t,r){Hr=t,Gr=r,Qr=e.getEmitScriptTarget(Gr),fn=a(Hr,r),gn=e.createUnderscoreEscapedMap(),yn=0,vn=Hr.isDeclarationFile,mn=e.objectAllocator.getSymbolConstructor(),Hr.locals||(nr(Hr),Hr.symbolCount=yn,Hr.classifiableNames=gn,Lt()),Hr=void 0,Gr=void 0,Qr=void 0,Xr=void 0,Yr=void 0,Zr=void 0,$r=void 0,en=void 0,tn=void 0,rn=!1,nn=void 0,an=void 0,on=void 0,sn=void 0,cn=void 0,un=void 0,_n=void 0,dn=!1,pn=0,xn=0}function a(t,r){return e.getStrictOptionValue(r,"alwaysStrict")&&!t.isDeclarationFile?!0:!!t.externalModuleIndicator}function s(e,t){return yn++,new mn(e,t)}function c(t,r,n){t.flags|=n,r.symbol=t,t.declarations=e.append(t.declarations,r),1955&n&&!t.exports&&(t.exports=e.createSymbolTable()),6240&n&&!t.members&&(t.members=e.createSymbolTable()),t.constEnumOnlyModule&&304&t.flags&&(t.constEnumOnlyModule=!1),67220415&n&&d(t,r)}function d(t,r){var n=t.valueDeclaration;(!n||e.isAssignmentDeclaration(n)&&!e.isAssignmentDeclaration(r)||n.kind!==r.kind&&e.isEffectiveModuleDeclaration(n))&&(t.valueDeclaration=r)}function p(t){if(255===t.kind)return t.isExportEquals?"export=":"default";var r=e.getNameOfDeclaration(t);if(r){if(e.isAmbientModule(t)){var n=e.getTextOfIdentifierOrLiteral(r);return e.isGlobalScopeAugmentation(t)?"__global":'"'+n+'"'}if(150===r.kind){var i=r.expression;return e.isStringOrNumericLiteralLike(i)?e.escapeLeadingUnderscores(i.text):(e.Debug.assert(e.isWellKnownSymbolSyntactically(i)),e.getPropertyNameForKnownSymbolName(e.idText(i.name)))}return e.isPropertyNameLiteral(r)?e.getEscapedTextOfIdentifierOrLiteral(r):void 0}switch(t.kind){case 158:return"__constructor";case 166:case 161:case 299:return"__call";case 167:case 162:return"__new";case 163:return"__index";case 256:return"__export";case 285:return"export=";case 205:if(2===e.getAssignmentDeclarationKind(t))return"export=";e.Debug.fail("Unknown binary declaration kind");break;case 295:return e.isJSDocConstructSignature(t)?"__new":"__call";case 152:e.Debug.assert(295===t.parent.kind,"Impossible parameter parent kind",function(){return"parent is: "+(e.SyntaxKind?e.SyntaxKind[t.parent.kind]:t.parent.kind)+", expected JSDocFunctionType"});var a=t.parent,o=a.parameters.indexOf(t);return"arg"+o}}function f(t){return e.isNamedDeclaration(t)?e.declarationNameToString(t.name):e.unescapeLeadingUnderscores(e.Debug.assertDefined(p(t)))}function m(t,n,i,a,o,u){e.Debug.assert(!e.hasDynamicName(i));var l,_=e.hasModifier(i,512),d=_&&n?"default":p(i);if(void 0===d)l=s(0,"__missing");else if(l=t.get(d),2885600&a&&gn.set(d,!0),l){if(u&&!l.isReplaceableByMethod)return l;if(l.flags&o)if(l.isReplaceableByMethod)t.set(d,l=s(0,d));else if(!(3&a&&67108864&l.flags)){e.isNamedDeclaration(i)&&(i.name.parent=i);var m=2&l.flags?e.Diagnostics.Cannot_redeclare_block_scoped_variable_0:e.Diagnostics.Duplicate_identifier_0,g=!0;(384&l.flags||384&a)&&(m=e.Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations,g=!1);var v=!1;e.length(l.declarations)&&(_?(m=e.Diagnostics.A_module_cannot_have_multiple_default_exports,g=!1,v=!0):l.declarations&&l.declarations.length&&255===i.kind&&!i.isExportEquals&&(m=e.Diagnostics.A_module_cannot_have_multiple_default_exports,g=!1,v=!0));var y=e.getNameOfDeclaration(i)||i,h=[];e.forEach(l.declarations,function(t,n){var i=e.getNameOfDeclaration(t)||t,a=r(i,m,g?f(t):void 0);Hr.bindDiagnostics.push(v?e.addRelatedInfo(a,r(y,0===n?e.Diagnostics.Another_export_default_is_here:e.Diagnostics.and_here)):a),v&&h.push(r(i,e.Diagnostics.The_first_export_default_is_here))});var b=r(y,m,g?f(i):void 0);Hr.bindDiagnostics.push(v?e.addRelatedInfo.apply(void 0,[b].concat(h)):b),l=s(0,d)}}else t.set(d,l=s(0,d)),u&&(l.isReplaceableByMethod=!0);return c(l,i,a),l.parent?e.Debug.assert(l.parent===n,"Existing symbol parent should match new one"):l.parent=n,l}function g(t,r,n){var i=1&e.getCombinedModifierFlags(t);if(2097152&r)return 258===t.kind||249===t.kind&&i?m(Yr.symbol.exports,Yr.symbol,t,r,n):m(Yr.locals,void 0,t,r,n);if(e.isJSDocTypeAlias(t)&&e.Debug.assert(e.isInJSFile(t)),!e.isAmbientModule(t)&&(i||32&Yr.flags)||e.isJSDocTypeAlias(t)){if(e.hasModifier(t,512)&&!p(t))return m(Yr.symbol.exports,Yr.symbol,t,r,n);var a=67220415&r?1048576:0,o=m(Yr.locals,void 0,t,a,n);return o.exportSymbol=m(Yr.symbol.exports,Yr.symbol,t,r,n),t.localSymbol=o,o}return m(Yr.locals,void 0,t,r,n)}function v(t,r){var n=Yr,i=Zr,a=$r;if(1&r?(198!==t.kind&&(Zr=Yr),Yr=$r=t,32&r&&(Yr.locals=e.createSymbolTable()),Dt(Yr)):2&r&&($r=t,$r.locals=void 0),4&r){var o=K,s=nn,c=an,u=on,l=sn,_=_n,d=dn,p=16&r&&!e.hasModifier(t,256)&&!t.asteriskToken&&!!e.getImmediatelyInvokedFunctionExpression(t);p||(nn={flags:2},144&r&&(nn.container=t)),sn=p||158===t.kind?F():void 0,an=void 0,on=void 0,_n=void 0,dn=!1,K=e.identity,y(t),t.flags&=-1409,!(1&nn.flags)&&8&r&&e.nodeIsPresent(t.body)&&(t.flags|=128,dn&&(t.flags|=256)),285===t.kind&&(t.flags|=pn),sn&&(I(sn,nn),nn=B(sn),158===t.kind&&(t.returnFlowNode=nn)),p||(nn=s),an=c,on=u,sn=l,_n=_,dn=d,K=o}else 64&r?(rn=!1,y(t),t.flags=rn?64|t.flags:-65&t.flags):y(t);Yr=n,Zr=i,$r=a}function y(e){if(vn)D(e);else if(536870912&e.transformFlags)vn=!0,D(e),vn=!1,xn|=e.transformFlags&~J(e.kind);else{var t=xn;xn=0,D(e),xn=t|_(e,xn)}}function h(e){b(e,function(e){return 240===e.kind?nr(e):void 0}),b(e,function(e){return 240!==e.kind?nr(e):void 0})}function b(t,r){if(void 0===r&&(r=nr),void 0!==t)if(vn)e.forEach(t,r);else{var n=xn;xn=0;for(var i=0,a=0,o=t;a<o.length;a++){var s=o[a];r(s),i|=-536870913&s.transformFlags}t.transformFlags=536870912|i,xn|=n}}function x(t){e.forEachChild(t,nr,b)}function D(e){if(Wr(e))return x(e),void ir(e);switch(e.kind){case 225:H(e);break;case 224:G(e);break;case 226:Q(e);break;case 227:case 228:X(e);break;case 223:Y(e);break;case 231:case 235:Z(e);break;case 230:case 229:tt(e);break;case 236:rt(e);break;case 233:nt(e);break;case 247:it(e);break;case 272:at(e);break;case 234:ct(e);break;case 203:dt(e);break;case 204:pt(e);break;case 205:ft(e);break;case 199:mt(e);break;case 206:gt(e);break;case 238:yt(e);break;case 192:bt(e);break;case 310:case 303:ht(e);break;case 285:h(e.statements),nr(e.endOfFileToken);break;case 219:case 246:h(e.statements);break;default:x(e)}ir(e)}function S(e){switch(e.kind){case 73:case 101:case 190:case 191:return C(e);case 192:return k(e);case 196:return S(e.expression);case 205:return N(e);case 203:return 52===e.operator&&S(e.operand);case 200:return S(e.expression)}return!1}function C(t){return 73===t.kind||101===t.kind||99===t.kind||(e.isPropertyAccessExpression(t)||e.isNonNullExpression(t)||e.isParenthesizedExpression(t))&&C(t.expression)||e.isElementAccessExpression(t)&&t.argumentExpression&&(e.isStringLiteral(t.argumentExpression)||e.isNumericLiteral(t.argumentExpression))&&C(t.expression)}function k(e){if(e.arguments)for(var t=0,r=e.arguments;t<r.length;t++){var n=r[t];if(C(n))return!0}return 190===e.expression.kind&&C(e.expression.expression)?!0:!1}function T(t,r){return e.isTypeOfExpression(t)&&A(t.expression)&&e.isStringLiteralLike(r)}function E(t,r){return e.isStringLiteralLike(t)&&S(r)}function N(e){switch(e.operatorToken.kind){case 60:return C(e.left);case 33:case 34:case 35:case 36:return A(e.left)||A(e.right)||T(e.right,e.left)||T(e.left,e.right);case 95:return A(e.left);case 94:return E(e.left,e.right);case 27:return S(e.right)}return!1}function A(e){switch(e.kind){case 196:return A(e.expression);case 205:switch(e.operatorToken.kind){case 60:return A(e.left);case 27:return A(e.right)}}return C(e)}function F(){return{flags:4,antecedents:void 0}
}function P(){return{flags:8,antecedents:void 0}}function w(e){e.flags|=512&e.flags?1024:512}function I(t,r){1&r.flags||e.contains(t.antecedents,r)||((t.antecedents||(t.antecedents=[])).push(r),w(r))}function O(e,t,r){return 1&t.flags?t:r?103===r.kind&&64&e||88===r.kind&&32&e?hn:S(r)?(w(t),K({flags:e,expression:r,antecedent:t})):t:32&e?t:hn}function M(e,t,r,n){return S(t.expression)?(w(e),K({flags:128,switchStatement:t,clauseStart:r,clauseEnd:n,antecedent:e})):e}function L(e,t){return w(e),K({flags:16,antecedent:e,node:t})}function R(e,t){w(e);var r=K({flags:256,antecedent:e,node:t});return r}function B(e){var t=e.antecedents;return t?1===t.length?t[0]:e:hn}function j(e){var t=e.parent;switch(t.kind){case 223:case 225:case 224:return t.expression===e;case 226:case 206:return t.condition===e}return!1}function V(e){for(;;)if(196===e.kind)e=e.expression;else{if(203!==e.kind||52!==e.operator)return 205===e.kind&&(54===e.operatorToken.kind||55===e.operatorToken.kind);e=e.operand}}function U(e){for(;196===e.parent.kind||203===e.parent.kind&&52===e.parent.operator;)e=e.parent;return!j(e)&&!V(e.parent)}function q(e,t,r){var n=cn,i=un;cn=t,un=r,nr(e),cn=n,un=i,e&&V(e)||(I(t,O(32,nn,e)),I(r,O(64,nn,e)))}function W(e,t,r){var n=an,i=on;an=t,on=r,nr(e),an=n,on=i}function H(e){var t=P(),r=F(),n=F();I(t,nn),nn=t,q(e.expression,r,n),nn=B(r),W(e.statement,n,t),I(t,nn),nn=B(n)}function G(t){var r=P(),n=234===t.parent.kind?e.lastOrUndefined(_n):void 0,i=n?n.continueTarget:F(),a=n?n.breakTarget:F();I(r,nn),nn=r,W(t.statement,a,i),I(i,nn),nn=B(i),q(t.expression,r,a),nn=B(a)}function Q(e){var t=P(),r=F(),n=F();nr(e.initializer),I(t,nn),nn=t,q(e.condition,r,n),nn=B(r),W(e.statement,n,t),nr(e.incrementor),I(t,nn),nn=B(n)}function X(e){var t=P(),r=F();I(t,nn),nn=t,228===e.kind&&nr(e.awaitModifier),nr(e.expression),I(r,nn),nr(e.initializer),239!==e.initializer.kind&&lt(e.initializer),W(e.statement,r,t),I(t,nn),nn=B(r)}function Y(e){var t=F(),r=F(),n=F();q(e.expression,t,r),nn=B(t),nr(e.thenStatement),I(n,nn),nn=B(r),nr(e.elseStatement),I(n,nn),nn=B(n)}function Z(e){nr(e.expression),231===e.kind&&(dn=!0,sn&&I(sn,nn)),nn=hn}function $(e){if(_n)for(var t=0,r=_n;t<r.length;t++){var n=r[t];if(n.name===e)return n}return void 0}function et(e,t,r){var n=230===e.kind?t:r;n&&(I(n,nn),nn=hn)}function tt(e){if(nr(e.label),e.label){var t=$(e.label.escapedText);t&&(t.referenced=!0,et(e,t.breakTarget,t.continueTarget))}else et(e,an,on)}function rt(e){var t=F(),r=nn,n=[],i=K;(e.catchClause||e.finallyBlock)&&(K=function(e){return n.push(e),e}),nr(e.tryBlock),K=i,I(t,nn);var a=nn,o=hn;if(e.catchClause){if(nn=r,n.length){var s=F();I(s,nn);for(var c=0,u=n;c<u.length;c++){var l=u[c];I(s,l)}nn=B(s)}nr(e.catchClause),I(t,nn),o=nn}if(e.finallyBlock){var _=r;if(!e.catchClause&&n.length){var d=F();I(d,r);for(var p=0,f=n;p<f.length;p++){var l=f[p];I(d,l)}_=B(d)}var m={flags:2048,antecedent:_,lock:{}};if(I(t,m),nn=B(t),nr(e.finallyBlock),1&nn.flags||1&a.flags&&1&o.flags&&(nn=a===bn||o===bn?bn:hn),!(1&nn.flags)){var g=K({flags:4096,antecedent:nn});m.lock=g,nn=g}}else nn=B(t)}function nt(t){var r=F();nr(t.expression);var n=an,i=ln;an=r,ln=nn,nr(t.caseBlock),I(r,nn);var a=e.forEach(t.caseBlock.clauses,function(e){return 273===e.kind});t.possiblyExhaustive=!a&&!r.antecedents,a||I(r,M(ln,t,0,0)),an=n,ln=i,nn=B(r)}function it(t){var r=xn;xn=0;for(var n=t.clauses,i=hn,a=0;a<n.length;a++){for(var o=a;!n[a].statements.length&&a+1<n.length;)nr(n[a]),a++;var s=F();I(s,M(ln,t.parent,o,a+1)),I(s,i),nn=B(s);var c=n[a];nr(c),i=nn,1&nn.flags||a===n.length-1||!Gr.noFallthroughCasesInSwitch||$t(c,e.Diagnostics.Fallthrough_case_in_switch)}n.transformFlags=536870912|xn,xn|=r}function at(e){var t=nn;nn=ln,nr(e.expression),nn=t,b(e.statements)}function ot(e,t,r){var n={name:e,breakTarget:t,continueTarget:r,referenced:!1};return(_n||(_n=[])).push(n),n}function st(){_n.pop()}function ct(t){var r=P(),n=F();nr(t.label),I(r,nn);var i=ot(t.label.escapedText,n,r);nr(t.statement),st(),i.referenced||Gr.allowUnusedLabels||er(e.unusedLabelIsError(Gr),t.label,e.Diagnostics.Unused_label),t.statement&&224===t.statement.kind||(I(n,nn),nn=B(n))}function ut(e){lt(205===e.kind&&60===e.operatorToken.kind?e.left:e)}function lt(e){if(C(e))nn=L(nn,e);else if(188===e.kind)for(var t=0,r=e.elements;t<r.length;t++){var n=r[t];209===n.kind?lt(n.expression):ut(n)}else if(189===e.kind)for(var i=0,a=e.properties;i<a.length;i++){var o=a[i];276===o.kind?ut(o.initializer):277===o.kind?lt(o.name):278===o.kind&&lt(o.expression)}}function _t(e,t,r){var n=F();54===e.operatorToken.kind?q(e.left,n,r):q(e.left,t,n),nn=B(n),nr(e.operatorToken),q(e.right,t,r)}function dt(e){if(52===e.operator){var t=cn;cn=un,un=t,x(e),un=cn,cn=t}else x(e),(44===e.operator||45===e.operator)&&lt(e.operand)}function pt(e){x(e),(44===e.operator||45===e.operator)&&lt(e.operand)}function ft(t){var r=t.operatorToken.kind;if(54===r||55===r)if(U(t)){var n=F();_t(t,n,n),nn=B(n)}else _t(t,cn,un);else if(x(t),e.isAssignmentOperator(r)&&!e.isAssignmentTarget(t)&&(lt(t.left),60===r&&191===t.left.kind)){var i=t.left;A(i.expression)&&(nn=R(nn,t))}}function mt(e){x(e),190===e.expression.kind&&lt(e.expression)}function gt(e){var t=F(),r=F(),n=F();q(e.condition,t,r),nn=B(t),nr(e.questionToken),nr(e.whenTrue),I(n,nn),nn=B(r),nr(e.colonToken),nr(e.whenFalse),I(n,nn),nn=B(n)}function vt(t){var r=e.isOmittedExpression(t)?void 0:t.name;if(e.isBindingPattern(r))for(var n=0,i=r.elements;n<i.length;n++){var a=i[n];vt(a)}else nn=L(nn,t)}function yt(t){x(t),(t.initializer||e.isForInOrOfStatement(t.parent.parent))&&vt(t)}function ht(e){e.tagName.parent=e,e.fullName&&z(e,e.fullName)}function bt(t){for(var r=t.expression;196===r.kind;)r=r.expression;if(197===r.kind||198===r.kind?(b(t.typeArguments),b(t.arguments),nr(t.expression)):x(t),190===t.expression.kind){var n=t.expression;A(n.expression)&&e.isPushOrUnshiftIdentifier(n.name)&&(nn=R(nn,t))}}function xt(t){switch(t.kind){case 210:case 241:case 244:case 189:case 169:case 298:case 269:return 1;case 242:return 65;case 245:case 243:case 182:return 33;case 285:return 37;case 157:if(e.isObjectLiteralOrClassExpressionMethod(t))return 173;case 158:case 240:case 156:case 159:case 160:case 161:case 299:case 295:case 166:case 162:case 163:case 167:return 45;case 197:case 198:return 61;case 246:return 4;case 155:return t.initializer?4:0;case 275:case 226:case 227:case 228:case 247:return 2;case 219:return e.isFunctionLike(t.parent)?0:2}return 0}function Dt(e){en&&(en.nextContainer=e),en=e}function St(e,t,r){switch(Yr.kind){case 245:return g(e,t,r);case 285:return kt(e,t,r);case 210:case 241:return Ct(e,t,r);case 244:return m(Yr.symbol.exports,Yr.symbol,e,t,r);case 169:case 298:case 189:case 242:case 269:return m(Yr.symbol.members,Yr.symbol,e,t,r);case 166:case 167:case 161:case 162:case 299:case 163:case 157:case 156:case 158:case 159:case 160:case 240:case 197:case 198:case 295:case 310:case 303:case 243:case 182:return m(Yr.locals,void 0,e,t,r)}}function Ct(t,r,n){return e.hasModifier(t,32)?m(Yr.symbol.exports,Yr.symbol,t,r,n):m(Yr.symbol.members,Yr.symbol,t,r,n)}function kt(t,r,n){return e.isExternalModule(Hr)?g(t,r,n):m(Hr.locals,void 0,t,r,n)}function Tt(t){var r=e.isSourceFile(t)?t:e.tryCast(t.body,e.isModuleBlock);return!!r&&r.statements.some(function(t){return e.isExportDeclaration(t)||e.isExportAssignment(t)})}function Et(e){4194304&e.flags&&!Tt(e)?e.flags|=32:e.flags&=-33}function Nt(t){if(Et(t),e.isAmbientModule(t))if(e.hasModifier(t,1)&&$t(t,e.Diagnostics.export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible),e.isModuleAugmentationExternal(t))At(t);else{var r=void 0;if(10===t.name.kind){var n=t.name.text;e.hasZeroOrOneAsteriskCharacter(n)?r=e.tryParsePattern(n):$t(t.name,e.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character,n)}var i=St(t,512,110735);Hr.patternAmbientModules=e.append(Hr.patternAmbientModules,r&&{pattern:r,symbol:i})}else{var a=At(t);if(0!==a){var i=t.symbol;i.constEnumOnlyModule=!(304&i.flags)&&2===a&&i.constEnumOnlyModule!==!1}}}function At(e){var r=t(e),n=0!==r;return St(e,n?512:1024,n?110735:0),r}function Ft(t){var r=s(131072,p(t));c(r,t,131072);var n=s(2048,"__type");c(n,t,2048),n.members=e.createSymbolTable(),n.members.set(r.escapedName,r)}function Pt(t){var r;if(function(e){e[e.Property=1]="Property",e[e.Accessor=2]="Accessor"}(r||(r={})),fn)for(var n=e.createUnderscoreEscapedMap(),i=0,a=t.properties;i<a.length;i++){var o=a[i];if(278!==o.kind&&73===o.name.kind){var s=o.name,c=276===o.kind||277===o.kind||157===o.kind?1:2,u=n.get(s.escapedText);if(u){if(1===c&&1===u){var l=e.getErrorSpanForNode(Hr,s);Hr.bindDiagnostics.push(e.createFileDiagnostic(Hr,l.start,l.length,e.Diagnostics.An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode))}}else n.set(s.escapedText,c)}}return Ot(t,4096,"__object")}function wt(e){return Ot(e,4096,"__jsxAttributes")}function It(e,t,r){return St(e,t,r)}function Ot(e,t,r){var n=s(t,r);return 106508&t&&(n.parent=Yr.symbol),c(n,e,t),n}function Mt(t,r,n){switch($r.kind){case 245:g(t,r,n);break;case 285:if(e.isExternalOrCommonJsModule(Yr)){g(t,r,n);break}default:$r.locals||($r.locals=e.createSymbolTable(),Dt($r)),m($r.locals,void 0,t,r,n)}}function Lt(){if(tn){for(var t=Yr,r=en,n=$r,i=Xr,a=nn,o=0,s=tn;o<s.length;o++){var c=s[o],u=e.getJSDocHost(c);Yr=e.findAncestor(u.parent,function(e){return!!(1&xt(e))})||Hr,$r=e.getEnclosingBlockScopeContainer(u)||Hr,nn={flags:2},Xr=c,nr(c.typeExpression),c.fullName&&73!==c.fullName.kind?nr(c.fullName):(Xr=c.parent,Mt(c,524288,67897832))}Yr=t,en=r,$r=n,Xr=i,nn=a}}function Rt(t){!(fn&&t.originalKeywordKind>=110&&t.originalKeywordKind<=118)||e.isIdentifierName(t)||4194304&t.flags||Hr.parseDiagnostics.length||Hr.bindDiagnostics.push(r(t,Bt(t),e.declarationNameToString(t)))}function Bt(t){return e.getContainingClass(t)?e.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode:Hr.externalModuleIndicator?e.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode:e.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode}function jt(t){fn&&e.isLeftHandSideExpression(t.left)&&e.isAssignmentOperator(t.operatorToken.kind)&&Ut(t,t.left)}function Jt(e){fn&&e.variableDeclaration&&Ut(e,e.variableDeclaration.name)}function zt(t){if(fn&&73===t.expression.kind){var r=e.getErrorSpanForNode(Hr,t.expression);Hr.bindDiagnostics.push(e.createFileDiagnostic(Hr,r.start,r.length,e.Diagnostics.delete_cannot_be_called_on_an_identifier_in_strict_mode))}}function Vt(t){return e.isIdentifier(t)&&("eval"===t.escapedText||"arguments"===t.escapedText)}function Ut(t,r){if(r&&73===r.kind){var n=r;if(Vt(n)){var i=e.getErrorSpanForNode(Hr,r);Hr.bindDiagnostics.push(e.createFileDiagnostic(Hr,i.start,i.length,Kt(t),e.idText(n)))}}}function Kt(t){return e.getContainingClass(t)?e.Diagnostics.Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode:Hr.externalModuleIndicator?e.Diagnostics.Invalid_use_of_0_Modules_are_automatically_in_strict_mode:e.Diagnostics.Invalid_use_of_0_in_strict_mode}function qt(e){fn&&Ut(e,e.name)}function Wt(t){return e.getContainingClass(t)?e.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode:Hr.externalModuleIndicator?e.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode:e.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5}function Ht(t){if(2>Qr&&285!==$r.kind&&245!==$r.kind&&!e.isFunctionLike($r)){var r=e.getErrorSpanForNode(Hr,t);Hr.bindDiagnostics.push(e.createFileDiagnostic(Hr,r.start,r.length,Wt(t)))}}function Gt(t){fn&&32&t.numericLiteralFlags&&Hr.bindDiagnostics.push(r(t,e.Diagnostics.Octal_literals_are_not_allowed_in_strict_mode))}function Qt(e){fn&&Ut(e,e.operand)}function Xt(e){fn&&(44===e.operator||45===e.operator)&&Ut(e,e.operand)}function Yt(t){fn&&$t(t,e.Diagnostics.with_statements_are_not_allowed_in_strict_mode)}function Zt(t){fn&&Gr.target>=2&&(e.isDeclarationStatement(t.statement)||e.isVariableStatement(t.statement))&&$t(t.label,e.Diagnostics.A_label_is_not_allowed_here)}function $t(t,r,n,i,a){var o=e.getSpanOfTokenAtPosition(Hr,t.pos);Hr.bindDiagnostics.push(e.createFileDiagnostic(Hr,o.start,o.length,r,n,i,a))}function er(e,t,r){tr(e,t,t,r)}function tr(t,r,n,i){rr(t,{pos:e.getTokenPosOfNode(r,Hr),end:n.end},i)}function rr(t,r,n){var a=e.createFileDiagnostic(Hr,r.pos,r.end-r.pos,n);t?Hr.bindDiagnostics.push(a):Hr.bindSuggestionDiagnostics=e.append(Hr.bindSuggestionDiagnostics,i({},a,{category:e.DiagnosticCategory.Suggestion}))}function nr(e){if(e){e.parent=Xr;var t=fn;if(sr(e),e.kind>148){var r=Xr;Xr=e;var n=xt(e);0===n?y(e):v(e,n),Xr=r}else if(!vn&&0===(536870912&e.transformFlags)){xn|=_(e,0);var r=Xr;1===e.kind&&(Xr=e),ir(e),Xr=r}fn=t}}function ir(t){if(e.hasJSDocNodes(t))if(e.isInJSFile(t))for(var r=0,n=t.jsDoc;r<n.length;r++){var i=n[r];nr(i)}else for(var a=0,o=t.jsDoc;a<o.length;a++){var i=o[a];z(t,i)}}function ar(t){if(!fn)for(var r=0,n=t;r<n.length;r++){var i=n[r];if(!e.isPrologueDirective(i))return;if(or(i))return void(fn=!0)}}function or(t){var r=e.getSourceTextOfNodeFromSourceFile(Hr,t.expression);return'"use strict"'===r||"'use strict'"===r}function sr(t){switch(t.kind){case 73:if(t.isInJSDocNamespace){for(var r=t.parent;r&&!e.isJSDocTypeAlias(r);)r=r.parent;Mt(r,524288,67897832);break}case 101:return nn&&(e.isExpression(t)||277===Xr.kind)&&(t.flowNode=nn),Rt(t);case 190:case 191:nn&&C(t)&&(t.flowNode=nn),e.isSpecialPropertyDeclaration(t)&&xr(t),e.isInJSFile(t)&&Hr.commonJsModuleIndicator&&e.isModuleExportsPropertyAccessExpression(t)&&!l($r,"module")&&m(Hr.locals,void 0,t.expression,134217729,67220414);break;case 205:var n=e.getAssignmentDeclarationKind(t);switch(n){case 1:yr(t);break;case 2:hr(t);break;case 3:Cr(t.left,t);break;case 6:Dr(t);break;case 4:br(t);break;case 5:Tr(t);break;case 0:break;default:e.Debug.fail("Unknown binary expression special property assignment kind")}return jt(t);case 275:return Jt(t);case 199:return zt(t);case 8:return Gt(t);case 204:return Qt(t);case 203:return Xt(t);case 232:return Yt(t);case 234:return Zt(t);case 179:return void(rn=!0);case 164:break;case 151:return Kr(t);case 152:return jr(t);case 238:return Br(t);case 187:return t.flowNode=nn,Br(t);case 155:case 154:return cr(t);case 276:case 277:return Vr(t,4,0);case 279:return Vr(t,8,68008959);case 161:case 162:case 163:return St(t,131072,0);case 157:case 156:return Vr(t,8192|(t.questionToken?16777216:0),e.isObjectLiteralMethod(t)?0:67212223);case 240:return Jr(t);case 158:return St(t,16384,0);case 159:return Vr(t,32768,67154879);case 160:return Vr(t,65536,67187647);case 166:case 295:case 299:case 167:return Ft(t);case 169:case 298:case 182:return ur(t);case 189:return Pt(t);case 197:case 198:return zr(t);case 192:var i=e.getAssignmentDeclarationKind(t);switch(i){case 7:return kr(t);case 8:return vr(t);case 9:return Sr(t);case 0:break;default:return e.Debug.fail("Unknown call expression assignment declaration kind")}e.isInJSFile(t)&&Mr(t);break;case 210:case 241:return fn=!0,Lr(t);case 242:return Mt(t,64,67897736);case 243:return Mt(t,524288,67897832);case 244:return Rr(t);case 245:return Nt(t);case 269:return wt(t);case 268:return It(t,4,0);case 249:case 252:case 254:case 258:return St(t,2097152,2097152);case 248:return pr(t);case 251:return mr(t);case 256:return fr(t);case 255:return dr(t);case 285:return ar(t.statements),lr();case 219:if(!e.isFunctionLike(t.parent))return;case 246:return ar(t.statements);case 305:if(299===t.parent.kind)return jr(t);if(298!==t.parent.kind)break;case 311:var a=t,o=a.isBracketed||a.typeExpression&&294===a.typeExpression.type.kind?16777220:4;return St(a,o,0);case 310:case 303:return(tn||(tn=[])).push(t)}}function cr(e){return Vr(e,4|(e.questionToken?16777216:0),0)}function ur(e){return Ot(e,2048,"__type")}function lr(){if(Et(Hr),e.isExternalModule(Hr))_r();else if(e.isJsonSourceFile(Hr)){_r();var t=Hr.symbol;m(Hr.symbol.exports,Hr.symbol,Hr,4,67108863),Hr.symbol=t}}function _r(){Ot(Hr,512,'"'+e.removeFileExtension(Hr.fileName)+'"')}function dr(t){if(Yr.symbol&&Yr.symbol.exports){var r=e.exportAssignmentIsAlias(t)?2097152:4,n=m(Yr.symbol.exports,Yr.symbol,t,r,67108863);t.isExportEquals&&d(n,t)}else Ot(t,2097152,p(t))}function pr(t){t.modifiers&&t.modifiers.length&&Hr.bindDiagnostics.push(r(t,e.Diagnostics.Modifiers_cannot_appear_here));var n=e.isSourceFile(t.parent)?e.isExternalModule(t.parent)?t.parent.isDeclarationFile?void 0:e.Diagnostics.Global_module_exports_may_only_appear_in_declaration_files:e.Diagnostics.Global_module_exports_may_only_appear_in_module_files:e.Diagnostics.Global_module_exports_may_only_appear_at_top_level;n?Hr.bindDiagnostics.push(r(t,n)):(Hr.symbol.globalExports=Hr.symbol.globalExports||e.createSymbolTable(),m(Hr.symbol.globalExports,Hr.symbol,t,2097152,2097152))}function fr(e){Yr.symbol&&Yr.symbol.exports?e.exportClause||m(Yr.symbol.exports,Yr.symbol,e,8388608,0):Ot(e,8388608,p(e))}function mr(e){e.name&&St(e,2097152,2097152)}function gr(e){return Hr.externalModuleIndicator?!1:(Hr.commonJsModuleIndicator||(Hr.commonJsModuleIndicator=e,_r()),!0)}function vr(e){if(gr(e)){var t=Or(e.arguments[0],void 0,function(e,t){return t&&c(t,e,67110400),t});if(t){var r=1048580;m(t.exports,t,e,r,0)}}}function yr(t){if(gr(t)){var r=t.left,n=Or(r.expression,void 0,function(e,t){return t&&c(t,e,67110400),t});if(n){var i=e.isClassExpression(t.right)?1048612:1048580;m(n.exports,n,r,i,0)}}}function hr(t){if(gr(t)){var r=e.getRightMostAssignedExpression(t.right);if(!(e.isEmptyObjectLiteral(r)||Yr===Hr&&u(Hr,r))){var n=e.exportAssignmentIsAlias(t)?2097152:1049092;m(Hr.symbol.exports,Hr.symbol,t,67108864|n,0)}}}function br(t){e.Debug.assert(e.isInJSFile(t));var r=e.getThisContainer(t,!1);switch(r.kind){case 240:case 197:var n=r.symbol;if(e.isBinaryExpression(r.parent)&&60===r.parent.operatorToken.kind){var i=r.parent.left;e.isPropertyAccessEntityNameExpression(i)&&e.isPrototypeAccess(i.expression)&&(n=Ir(i.expression.expression,Zr))}n&&(n.members=n.members||e.createSymbolTable(),m(n.members,n,t,4,0));break;case 158:case 155:case 157:case 159:case 160:var a=r.parent,o=e.hasModifier(r,32)?a.symbol.exports:a.symbol.members;m(o,a.symbol,t,4,0,!0);break;case 285:r.commonJsModuleIndicator?m(r.symbol.exports,r.symbol,t,1048580,0):St(t,1,67220414);break;default:e.Debug.failBadSyntaxKind(r)}}function xr(t){101===t.expression.kind?br(t):e.isPropertyAccessEntityNameExpression(t)&&285===t.parent.parent.kind&&(e.isPrototypeAccess(t.expression)?Cr(t,t.parent):Er(t))}function Dr(e){e.left.parent=e,e.right.parent=e;var t=e.left;Fr(t.expression,t,!1)}function Sr(e){var t=Ir(e.arguments[0].expression);Ar(e,t,!0)}function Cr(e,t){var r=e.expression,n=r.expression;e.parent=t,n.parent=r,r.parent=e,Fr(n,e,!0)}function kr(e){var t=Ir(e.arguments[0]),r=285===e.parent.parent.kind;t=Nr(t,e.arguments[0],r,!1),Ar(e,t,!1)}function Tr(t){var r=t.left,n=Ir(r.expression);(e.isInJSFile(t)||e.isFunctionSymbol(n))&&(t.left.parent=t,t.right.parent=t,e.isIdentifier(r.expression)&&Yr===Hr&&u(Hr,r.expression)?yr(t):Er(r))}function Er(e){e.expression.parent=e,Fr(e.expression,e,!1)}function Nr(t,r,n,i){if(!(!n||i||t&&1920&t.flags)){var a=67110400,o=110735;t=Or(r,t,function(t,r,n){if(r)return c(r,t,a),r;var i=n?n.exports:Hr.jsGlobalAugmentations||(Hr.jsGlobalAugmentations=e.createSymbolTable());return m(i,n,t,a,o)})}return t}function Ar(t,r,n){if(r&&Pr(r)){var i=n?r.members||(r.members=e.createSymbolTable()):r.exports||(r.exports=e.createSymbolTable()),a=e.isFunctionLikeDeclaration(e.getAssignedExpandoInitializer(t)),o=a?8192:4,s=a?67212223:0;m(i,r,t,67108864|o,-67108865&s)}}function Fr(t,r,n){var i=Ir(t),a=e.isBinaryExpression(r.parent)?285===wr(r.parent).parent.kind:285===r.parent.parent.kind;i=Nr(i,r.expression,a,n),Ar(r,i,n)}function Pr(t){if(1072&t.flags)return!0;var r=t.valueDeclaration;if(r&&e.isCallExpression(r))return!!e.getAssignedExpandoInitializer(r);var n=r?e.isVariableDeclaration(r)?r.initializer:e.isBinaryExpression(r)?r.right:e.isPropertyAccessExpression(r)&&e.isBinaryExpression(r.parent)?r.parent.right:void 0:void 0;if(n=n&&e.getRightMostAssignedExpression(n)){var i=e.isPrototypeAccess(e.isVariableDeclaration(r)?r.name:e.isBinaryExpression(r)?r.left:r);return!!e.getExpandoInitializer(e.isBinaryExpression(n)&&55===n.operatorToken.kind?n.right:n,i)}return!1}function wr(t){for(;e.isBinaryExpression(t.parent);)t=t.parent;return t.parent}function Ir(t,r){if(void 0===r&&(r=Yr),e.isIdentifier(t))return l(r,t.escapedText);var n=Ir(t.expression);return n&&n.exports&&n.exports.get(t.name.escapedText)}function Or(t,r,n){if(u(Hr,t))return Hr.symbol;if(e.isIdentifier(t))return n(t,Ir(t),r);var i=Or(t.expression,r,n);return n(t.name,i&&i.exports&&i.exports.get(t.name.escapedText),i)}function Mr(t){!Hr.commonJsModuleIndicator&&e.isRequireCall(t,!1)&&gr(t)}function Lr(t){if(241===t.kind)Mt(t,32,68008383);else{var n=t.name?t.name.escapedText:"__class";Ot(t,32,n),t.name&&gn.set(t.name.escapedText,!0)}var i=t.symbol,a=s(4194308,"prototype"),o=i.exports.get(a.escapedName);o&&(t.name&&(t.name.parent=t),Hr.bindDiagnostics.push(r(o.declarations[0],e.Diagnostics.Duplicate_identifier_0,e.symbolName(a)))),i.exports.set(a.escapedName,a),a.parent=i}function Rr(t){return e.isEnumConst(t)?Mt(t,128,68008831):Mt(t,256,68008191)}function Br(t){if(fn&&Ut(t,t.name),!e.isBindingPattern(t.name)){var r=e.isInJSFile(t)&&!!e.getJSDocEnumTag(t),n=r?256:0,i=r?68008191:0;e.isBlockOrCatchScoped(t)?Mt(t,2|n,67220415|i):e.isParameterDeclaration(t)?St(t,1,67220415):St(t,1|n,67220414|i)}}function jr(t){if((305!==t.kind||299===Yr.kind)&&(!fn||4194304&t.flags||Ut(t,t.name),e.isBindingPattern(t.name)?Ot(t,1,"__"+t.parent.parameters.indexOf(t)):St(t,1,67220415),e.isParameterPropertyDeclaration(t))){var r=t.parent.parent;m(r.symbol.members,r.symbol,t,4|(t.questionToken?16777216:0),0)}}function Jr(t){Hr.isDeclarationFile||4194304&t.flags||e.isAsyncFunction(t)&&(pn|=1024),qt(t),fn?(Ht(t),Mt(t,16,67219887)):St(t,16,67219887)}function zr(t){Hr.isDeclarationFile||4194304&t.flags||e.isAsyncFunction(t)&&(pn|=1024),nn&&(t.flowNode=nn),qt(t);var r=t.name?t.name.escapedText:"__function";return Ot(t,16,r)}function Vr(t,r,n){return Hr.isDeclarationFile||4194304&t.flags||!e.isAsyncFunction(t)||(pn|=1024),nn&&e.isObjectLiteralOrClassExpressionMethod(t)&&(t.flowNode=nn),e.hasDynamicName(t)?Ot(t,r,"__computed"):St(t,r,n)}function Ur(t){var r=e.findAncestor(t,function(t){return t.parent&&e.isConditionalTypeNode(t.parent)&&t.parent.extendsType===t});return r&&r.parent}function Kr(t){if(e.isJSDocTemplateTag(t.parent)){var r=e.find(t.parent.parent.tags,e.isJSDocTypeAlias)||e.getHostSignatureFromJSDoc(t.parent);r?(r.locals||(r.locals=e.createSymbolTable()),m(r.locals,void 0,t,262144,67635688)):St(t,262144,67635688)}else if(177===t.parent.kind){var n=Ur(t.parent);n?(n.locals||(n.locals=e.createSymbolTable()),m(n.locals,void 0,t,262144,67635688)):Ot(t,262144,p(t))}else St(t,262144,67635688)}function qr(e){var r=t(e);return 1===r||2===r&&!!Gr.preserveConstEnums}function Wr(t){if(!(1&nn.flags))return!1;if(nn===hn){var r=e.isStatementButNotDeclaration(t)&&221!==t.kind||241===t.kind||245===t.kind&&qr(t);if(r&&(nn=bn,!Gr.allowUnreachableCode)){var n=!(!e.unreachableCodeIsError(Gr)||4194304&t.flags||e.isVariableStatement(t)&&!(3&e.getCombinedNodeFlags(t.declarationList))&&!t.declarationList.declarations.some(function(e){return!!e.initializer}));o(t,function(t,r){return tr(n,t,r,e.Diagnostics.Unreachable_code_detected)})}}return!0}var Hr,Gr,Qr,Xr,Yr,Zr,$r,en,tn,rn,nn,an,on,sn,cn,un,ln,_n,dn,pn,fn,mn,gn,vn,yn=0,hn={flags:1},bn={flags:1},xn=0;return n}function o(t,r){if(e.isStatement(t)&&s(t)&&e.isBlock(t.parent)){var n=t.parent.statements,i=e.sliceAfter(n,t);e.getRangesWhere(i,s,function(e,t){return r(i[e],i[t-1])})}else r(t,t)}function s(t){return!(e.isFunctionDeclaration(t)||c(t)||e.isEnumDeclaration(t)||e.isVariableStatement(t)&&!(3&e.getCombinedNodeFlags(t))&&t.declarationList.declarations.some(function(e){return!e.initializer}))}function c(r){switch(r.kind){case 242:case 243:return!0;case 245:return 1!==t(r);case 244:return e.hasModifier(r,2048);default:return!1}}function u(t,r){for(var n=0,i=[r];i.length&&100>n;){if(n++,r=i.shift(),e.isExportsIdentifier(r)||e.isModuleExportsPropertyAccessExpression(r))return!0;if(e.isIdentifier(r)){var a=l(t,r.escapedText);if(a&&a.valueDeclaration&&e.isVariableDeclaration(a.valueDeclaration)&&a.valueDeclaration.initializer){var o=a.valueDeclaration.initializer;i.push(o),e.isAssignmentExpression(o,!0)&&(i.push(o.left),i.push(o.right))}}}return!1}function l(t,r){var n=t.locals&&t.locals.get(r);return n?n.exportSymbol||n:e.isSourceFile(t)&&t.jsGlobalAugmentations&&t.jsGlobalAugmentations.has(r)?t.jsGlobalAugmentations.get(r):t.symbol&&t.symbol.exports&&t.symbol.exports.get(r)}function _(e,t){var r=e.kind;switch(r){case 192:return d(e,t);case 193:return p(e,t);case 245:return L(e,t);case 196:return g(e,t);case 205:return f(e,t);case 222:return M(e,t);case 152:return m(e,t);case 198:return N(e,t);case 197:return E(e,t);case 240:return T(e,t);case 238:return P(e,t);case 239:return R(e,t);case 220:return w(e,t);case 234:return I(e,t);case 241:return v(e,t);case 210:return y(e,t);case 274:return h(e,t);case 275:return b(e,t);case 212:return x(e,t);case 158:return D(e,t);case 155:return k(e,t);case 157:return S(e,t);case 159:case 160:return C(e,t);case 249:return O(e,t);case 190:return A(e,t);case 191:return F(e,t);default:return B(e,r,t)}}function d(t,r){var n=r,i=e.skipOuterExpressions(t.expression),a=t.expression;return t.typeArguments&&(n|=1),(4096&r||e.isSuperOrSuperProperty(i))&&(n|=128,e.isSuperProperty(i)&&(n|=2048)),93===a.kind&&(n|=524288),t.transformFlags=536870912|n,-536875009&n}function p(e,t){var r=t;return e.typeArguments&&(r|=1),4096&t&&(r|=128),e.transformFlags=536870912|r,-536875009&r}function f(e,t){var r=t,n=e.operatorToken.kind,i=e.left.kind;return 60===n&&189===i?r|=656:60===n&&188===i?r|=640:(41===n||64===n)&&(r|=64),e.transformFlags=536870912|r,-536870913&r}function m(t,r){var n=r,i=t.name,a=t.initializer,o=t.dotDotDotToken;return(t.questionToken||t.type||1024&r&&e.some(t.decorators)||e.isThisIdentifier(i))&&(n|=1),e.hasModifier(t,92)&&(n|=1025),8192&r&&(n|=16),(65536&r||a||o)&&(n|=128),t.transformFlags=536870912|n,-536870913&n}function g(e,t){var r=t,n=e.expression,i=n.kind;return(213===i||195===i)&&(r|=1),e.transformFlags=536870912|r,-536870913&r}function v(t,r){var n;return e.hasModifier(t,2)?n=1:(n=128|r,(1024&r||t.typeParameters)&&(n|=1)),t.transformFlags=536870912|n,-536888321&n}function y(e,t){var r=128|t;return(1024&t||e.typeParameters)&&(r|=1),e.transformFlags=536870912|r,-536888321&r}function h(t,r){var n=r;switch(t.token){case 87:n|=128;break;case 110:n|=1;break;default:e.Debug.fail("Unexpected token for heritage clause")}return t.transformFlags=536870912|n,-536870913&n}function b(t,r){var n=r;return t.variableDeclaration?e.isBindingPattern(t.variableDeclaration.name)&&(n|=128):n|=8,t.transformFlags=536870912|n,-536879105&n}function x(e,t){var r=128|t;return e.typeArguments&&(r|=1),e.transformFlags=536870912|r,-536870913&r}function D(t,r){var n=r;return(e.hasModifier(t,2270)||!t.body)&&(n|=1),8192&r&&(n|=16),t.transformFlags=536870912|n,-537372673&n}function S(t,r){var n=128|r;return(t.decorators||e.hasModifier(t,2270)||t.typeParameters||t.type||t.name&&e.isComputedPropertyName(t.name)||!t.body)&&(n|=1),8192&r&&(n|=16),e.hasModifier(t,256)&&(n|=t.asteriskToken?16:32),t.asteriskToken&&(n|=256),t.transformFlags=536870912|n,j(t.name,-537372673&n)}function C(t,r){var n=r;return(t.decorators||e.hasModifier(t,2270)||t.type||t.name&&e.isComputedPropertyName(t.name)||!t.body)&&(n|=1),8192&r&&(n|=16),t.transformFlags=536870912|n,j(t.name,-537372673&n)}function k(t,r){var n=1|r;return(t.initializer||e.isComputedPropertyName(t.name))&&(n|=1024),t.transformFlags=536870912|n,j(t.name,-536872961&n)}function T(t,r){var n,i=e.getModifierFlags(t),a=t.body;return!a||2&i?n=1:(n=262144|r,(2270&i||t.typeParameters||t.type)&&(n|=1),256&i&&(n|=t.asteriskToken?16:32),8192&r&&(n|=16),t.asteriskToken&&(n|=256)),t.transformFlags=536870912|n,-537373697&n}function E(t,r){var n=r;return(e.hasModifier(t,2270)||t.typeParameters||t.type)&&(n|=1),e.hasModifier(t,256)&&(n|=t.asteriskToken?16:32),8192&r&&(n|=16),t.asteriskToken&&(n|=256),t.transformFlags=536870912|n,-537373697&n}function N(t,r){var n=128|r;return(e.hasModifier(t,2270)||t.typeParameters||t.type)&&(n|=1),e.hasModifier(t,256)&&(n|=32),8192&r&&(n|=16),t.transformFlags=536870912|n,-537371649&n}function A(e,t){var r=t;return 99===e.expression.kind&&(r|=48),e.transformFlags=536870912|r,-536870913&r}function F(e,t){var r=t;return 99===e.expression.kind&&(r|=48),e.transformFlags=536870912|r,-536870913&r}function P(e,t){var r=t;return r|=65664,8192&t&&(r|=16),e.type&&(r|=1),e.transformFlags=536870912|r,-536870913&r}function w(t,r){var n,i=t.declarationList.transformFlags;return e.hasModifier(t,2)?n=1:(n=r,65536&i&&(n|=128)),t.transformFlags=536870912|n,-536870913&n}function I(t,r){var n=r;return 32768&r&&e.isIterationStatement(t,!0)&&(n|=128),t.transformFlags=536870912|n,-536870913&n}function O(t,r){var n=r;return e.isExternalModuleImportEqualsDeclaration(t)||(n|=1),t.transformFlags=536870912|n,-536870913&n}function M(e,t){var r=t;return e.transformFlags=536870912|r,-536870913&r}function L(t,r){var n=1,i=e.getModifierFlags(t);return 0===(2&i)&&(n|=r),t.transformFlags=536870912|n,-537168897&n}function R(e,t){var r=262144|t;return 65536&t&&(r|=128),3&e.flags&&(r|=32896),e.transformFlags=536870912|r,-536944641&r}function B(e,t,r){var n=r,i=536870912;switch(t){case 122:case 202:n|=48;break;case 195:case 213:case 314:n|=1,i=536870912;break;case 116:case 114:case 115:case 119:case 126:case 78:case 244:case 279:case 214:case 134:n|=1;break;case 261:case 262:case 263:case 11:case 264:case 265:case 266:case 267:case 268:case 269:case 270:case 271:n|=2;break;case 14:case 15:case 16:case 17:case 207:case 194:case 277:case 117:case 215:n|=128;break;case 10:e.hasExtendedUnicodeEscape&&(n|=128);break;case 8:384&e.numericLiteralFlags&&(n|=128);break;case 9:n|=4;break;case 228:e.awaitModifier&&(n|=16),n|=128;break;case 208:n|=131216;break;case 121:case 136:case 147:case 133:case 137:case 139:case 124:case 140:case 107:case 151:case 154:case 156:case 161:case 162:case 163:case 164:case 165:case 166:case 167:case 168:case 169:case 170:case 171:case 172:case 173:case 174:case 175:case 176:case 177:case 178:case 242:case 243:case 179:case 180:case 181:case 182:case 183:case 248:n=1,i=-2;break;case 150:n|=16384;break;case 209:n|=4224;break;case 278:n|=8208;break;case 99:n|=128,i=536870912;break;case 101:n|=2048;break;case 185:n|=65664,4096&r&&(n|=8208),i=536875008;break;case 186:n|=65664,i=536875008;break;case 187:n|=128,e.dotDotDotToken&&(n|=4096);break;case 153:n|=1025;break;case 189:i=536896512,16384&r&&(n|=128),8192&r&&(n|=16);break;case 188:i=536875008;break;case 224:case 225:case 226:case 227:32768&r&&(n|=128);break;case 285:break;case 231:n|=262160;break;case 229:case 230:n|=262144}return e.transformFlags=536870912|n,n&~i}function j(e,t){return t|2048&e.transformFlags}function J(e){if(e>=164&&184>=e)return-2;switch(e){case 192:case 193:case 188:return 536875008;case 245:return 537168896;case 152:return 536870912;case 198:return 537371648;case 197:case 240:return 537373696;case 239:return 536944640;case 241:case 210:return 536888320;case 158:return 537372672;case 157:case 159:case 160:return 537372672;case 121:case 136:case 147:case 133:case 139:case 137:case 124:case 140:case 107:case 151:case 154:case 156:case 161:case 162:case 163:case 242:case 243:return-2;case 189:return 536896512;case 275:return 536879104;case 185:case 186:return 536875008;
case 195:case 213:case 314:case 196:case 99:return 536870912;case 190:case 191:return 536870912;default:return 536870912}}function z(t,r){r.parent=t,e.forEachChild(r,function(e){return z(r,e)})}var V;!function(e){e[e.NonInstantiated=0]="NonInstantiated",e[e.Instantiated=1]="Instantiated",e[e.ConstEnumOnly=2]="ConstEnumOnly"}(V=e.ModuleInstanceState||(e.ModuleInstanceState={})),e.getModuleInstanceState=t;var U;!function(e){e[e.None=0]="None",e[e.IsContainer=1]="IsContainer",e[e.IsBlockScopedContainer=2]="IsBlockScopedContainer",e[e.IsControlFlowContainer=4]="IsControlFlowContainer",e[e.IsFunctionLike=8]="IsFunctionLike",e[e.IsFunctionExpression=16]="IsFunctionExpression",e[e.HasLocals=32]="HasLocals",e[e.IsInterface=64]="IsInterface",e[e.IsObjectLiteralOrClassExpressionMethod=128]="IsObjectLiteralOrClassExpressionMethod"}(U||(U={}));var K=e.identity,q=a();e.bindSourceFile=n,e.isExportsOrModuleExportsOrAlias=u,e.computeTransformFlagsForNode=_,e.getTransformFlagsSubtreeExclusions=J}(n||(n={}));var n;!function(e){function t(t,r,n,i,a,o,s,c,u,l){function _(_){function d(e){if(e&&!S[e.id]){S[e.id]=e;var t=D(e.symbol);if(!t){if(524288&e.flags){var r=e,n=r.objectFlags;4&n&&p(e),32&n&&y(e),3&n&&b(e),24&n&&x(r)}262144&e.flags&&f(e),3145728&e.flags&&m(e),4194304&e.flags&&g(e),8388608&e.flags&&v(e)}}}function p(t){d(t.target),e.forEach(t.typeArguments,d)}function f(e){d(u(e))}function m(t){e.forEach(t.types,d)}function g(e){d(e.type)}function v(e){d(e.objectType),d(e.indexType),d(e.constraint)}function y(e){d(e.typeParameter),d(e.constraintType),d(e.templateType),d(e.modifiersType)}function h(i){var a=r(i);a&&d(a.type),e.forEach(i.typeParameters,d);for(var o=0,s=i.parameters;o<s.length;o++){var c=s[o];D(c)}d(t(i)),d(n(i))}function b(t){x(t),e.forEach(t.typeParameters,d),e.forEach(i(t),d),d(t.thisType)}function x(e){var t=c(e,0);d(t);var r=c(e,1);d(r);for(var n=a(e),i=0,o=n.callSignatures;i<o.length;i++){var s=o[i];h(s)}for(var u=0,l=n.constructSignatures;u<l.length;u++){var s=l[u];h(s)}for(var _=0,p=n.properties;_<p.length;_++){var f=p[_];D(f)}}function D(t){if(!t)return!1;var r=e.getSymbolId(t);if(C[r])return!1;if(C[r]=t,!_(t))return!0;var n=o(t);return d(n),t.exports&&t.exports.forEach(D),e.forEach(t.declarations,function(e){if(e.type&&168===e.type.kind){var t=e.type,r=s(l(t.exprName));D(r)}}),!1}void 0===_&&(_=function(){return!0});var S=[],C=[];return{walkType:function(t){try{return d(t),{visitedTypes:e.getOwnValues(S),visitedSymbols:e.getOwnValues(C)}}finally{e.clear(S),e.clear(C)}},walkSymbol:function(t){try{return D(t),{visitedTypes:e.getOwnValues(S),visitedSymbols:e.getOwnValues(C)}}finally{e.clear(S),e.clear(C)}}}}return _}e.createGetSymbolWalker=t}(n||(n={}));var n;!function(e){function t(e){return e.id||(e.id=_,_++),e.id}function r(e){return e.id||(e.id=l,l++),e.id}function n(t,r){var n=e.getModuleInstanceState(t);return 1===n||r&&2===n}function o(o,l){function _(t,r,n,i){var a=e.getParseTreeNode(t,e.isCallLikeExpression);BT=n;var o=a?xy(a,r,i):void 0;return BT=void 0,o}function m(t){if(t){var r=e.getSourceFileOfNode(t);if(r){if(r.localJsxNamespace)return r.localJsxNamespace;var n=r.pragmas.get("jsx");if(n){var i=e.isArray(n)?n[0]:n;if(r.localJsxFactory=e.parseIsolatedEntityName(i.arguments.factory,DT),r.localJsxFactory)return r.localJsxNamespace=iS(r.localJsxFactory).escapedText}}}return nA||(nA="React",xT.jsxFactory?(iA=e.parseIsolatedEntityName(xT.jsxFactory,DT),iA&&(nA=iS(iA).escapedText)):xT.reactNamespace&&(nA=e.escapeLeadingUnderscores(xT.reactNamespace))),nA}function g(e,t){return FS(e,t),IT}function v(t,r,n,i,a,o){var s=t?e.createDiagnosticForNode(t,r,n,i,a,o):e.createCompilerDiagnostic(r,n,i,a,o),c=tA.lookup(s);return c?c:(tA.add(s),s)}function y(t,r,n,i,a,o){var s=t?e.createDiagnosticForNode(t,r,n,i,a,o):e.createCompilerDiagnostic(r,n,i,a,o);return tA.add(s),s}function h(t,r){t?tA.add(r):rA.add(r.file.fileName,i({},r,{category:e.DiagnosticCategory.Suggestion}))}function b(t,r,n,i,a,o,s){h(t,"message"in n?e.createDiagnosticForNode(r,n,i,a,o,s):e.createDiagnosticForNodeFromMessageChain(r,n))}function x(e,t,r){mT++;var n=new _T(33554432|e,t);return n.checkFlags=r||0,n}function D(e){return 0!==(33554432&e.flags)}function S(e){var t=0;return 2&e&&(t|=67220415),1&e&&(t|=67220414),4&e&&(t|=0),8&e&&(t|=68008959),16&e&&(t|=67219887),32&e&&(t|=68008383),64&e&&(t|=67897736),256&e&&(t|=68008191),128&e&&(t|=68008831),512&e&&(t|=110735),8192&e&&(t|=67212223),32768&e&&(t|=67154879),65536&e&&(t|=67187647),262144&e&&(t|=67635688),524288&e&&(t|=67897832),2097152&e&&(t|=2097152),t}function C(e,t){t.mergeId||(t.mergeId=d,d++),zN[t.mergeId]=e}function k(t){var r=x(t.flags,t.escapedName);return r.declarations=t.declarations?t.declarations.slice():[],r.parent=t.parent,t.valueDeclaration&&(r.valueDeclaration=t.valueDeclaration),t.constEnumOnlyModule&&(r.constEnumOnlyModule=!0),t.members&&(r.members=e.cloneMap(t.members)),t.exports&&(r.exports=e.cloneMap(t.exports)),C(r,t),r}function T(t,r,n){function i(t,r){for(var n=0,i=r.declarations;n<i.length;n++){var a=i[n];e.pushIfUnique(t,(e.getExpandoInitializer(a,!1)?e.getNameOfExpando(a):e.getNameOfDeclaration(a))||a)}}if(void 0===n&&(n=!1),!(t.flags&S(r.flags))||67108864&(r.flags|t.flags)){if(e.Debug.assert(r!==t),!(33554432&t.flags)){var a=ht(t);if(a===XT)return r;t=k(a)}512&r.flags&&512&t.flags&&t.constEnumOnlyModule&&!r.constEnumOnlyModule&&(t.constEnumOnlyModule=!1),t.flags|=r.flags,r.valueDeclaration&&(!t.valueDeclaration||e.isAssignmentDeclaration(t.valueDeclaration)&&!e.isAssignmentDeclaration(r.valueDeclaration)||e.isEffectiveModuleDeclaration(t.valueDeclaration)&&!e.isEffectiveModuleDeclaration(r.valueDeclaration))&&(t.valueDeclaration=r.valueDeclaration),e.addRange(t.declarations,r.declarations),r.members&&(t.members||(t.members=e.createSymbolTable()),F(t.members,r.members,n)),r.exports&&(t.exports||(t.exports=e.createSymbolTable()),F(t.exports,r.exports,n)),n||C(t,r)}else if(1024&t.flags)t!==RT&&y(e.getNameOfDeclaration(r.declarations[0]),e.Diagnostics.Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity,kr(t));else{var o=!!(384&t.flags||384&r.flags),s=!!(2&t.flags||2&r.flags),c=o?e.Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations:s?e.Diagnostics.Cannot_redeclare_block_scoped_variable_0:e.Diagnostics.Duplicate_identifier_0,u=r.declarations&&e.getSourceFileOfNode(r.declarations[0]),l=t.declarations&&e.getSourceFileOfNode(t.declarations[0]),_=kr(r);if(u&&l&&LE&&!o&&u!==l){var d=-1===e.comparePaths(u.path,l.path)?u:l,p=d===u?l:u,f=e.getOrUpdate(LE,d.path+"|"+p.path,function(){return{firstFile:d,secondFile:p,conflictingSymbols:e.createMap()}}),m=e.getOrUpdate(f.conflictingSymbols,_,function(){return{isBlockScoped:s,firstFileLocations:[],secondFileLocations:[]}});i(m.firstFileLocations,r),i(m.secondFileLocations,t)}else E(r,c,_,t),E(t,c,_,r)}return t}function E(t,r,n,i){e.forEach(t.declarations,function(t){var a=(e.getExpandoInitializer(t,!1)?e.getNameOfExpando(t):e.getNameOfDeclaration(t))||t;N(a,r,n,i.declarations)})}function N(t,r,n,i){for(var a=v(t,r,n),o=0,s=i||e.emptyArray;o<s.length;o++){var c=s[o];a.relatedInformation=a.relatedInformation||[],e.length(a.relatedInformation)>=5||e.addRelatedInfo(a,e.length(a.relatedInformation)?e.createDiagnosticForNode(c,e.Diagnostics.and_here):e.createDiagnosticForNode(c,e.Diagnostics._0_was_also_declared_here,n))}}function A(t,r){if(!e.hasEntries(t))return r;if(!e.hasEntries(r))return t;var n=e.createSymbolTable();return F(n,t),F(n,r),n}function F(e,t,r){void 0===r&&(r=!1),t.forEach(function(t,n){var i=e.get(n);e.set(n,i?T(i,t,r):t)})}function P(t){var r=t.parent;if(r.symbol.declarations[0]!==r)return void e.Debug.assert(r.symbol.declarations.length>1);if(e.isGlobalScopeAugmentation(r))F(MT,r.symbol.exports);else{var n=4194304&t.parent.parent.flags?void 0:e.Diagnostics.Invalid_module_name_in_augmentation_module_0_cannot_be_found,i=Ft(t,t,n,!0);if(!i)return;if(i=Ot(i),1920&i.flags)if(e.some(BE,function(e){return i===e.symbol})){var a=T(r.symbol,i,!0);jE||(jE=e.createMap()),jE.set(t.text,a)}else T(i,r.symbol);else y(t,e.Diagnostics.Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity,t.text)}}function w(t,r,n){function i(t,r){return function(n){return tA.add(e.createDiagnosticForNode(n,r,t))}}r.forEach(function(r,a){var o=t.get(a);o?e.forEach(o.declarations,i(e.unescapeLeadingUnderscores(a),n)):t.set(a,r)})}function I(e){if(33554432&e.flags)return e;var t=r(e);return VN[t]||(VN[t]={})}function O(e){var r=t(e);return UN[r]||(UN[r]={flags:0})}function M(t){return 285===t.kind&&!e.isExternalOrCommonJsModule(t)}function L(t,r,n){if(n){var i=t.get(r);if(i){if(e.Debug.assert(0===(1&e.getCheckFlags(i)),"Should never get an instantiated symbol here."),i.flags&n)return i;if(2097152&i.flags){var a=bt(i);if(a===XT||a.flags&n)return i}}}}function R(t,r){var n=t.parent,i=t.parent.parent,a=L(n.locals,r,67220415),o=L(Ji(i.symbol),r,67220415);return a&&o?[a,o]:e.Debug.fail("There should exist two symbols, one as property declaration and one as parameter declaration")}function B(t,r){function n(t,r){var n=e.getEnclosingBlockScopeContainer(t);switch(t.parent.parent.kind){case 220:case 226:case 228:if(et(r,t,n))return!0}var i=t.parent.parent;return e.isForInOrOfStatement(i)&&et(r,i.expression,n)}function i(t,r,n){return!!e.findAncestor(t,function(i){if(i===n)return"quit";if(e.isFunctionLike(i))return!0;var a=i.parent&&155===i.parent.kind&&i.parent.initializer===i;if(a)if(e.hasModifier(i.parent,32)){if(157===r.kind)return!0}else{var o=155===r.kind&&!e.hasModifier(r,32);if(!o||e.getContainingClass(t)!==e.getContainingClass(r))return!0}return!1})}function a(t,r){if(r.end>t.end)return!1;var n=e.findAncestor(r,function(e){if(e===t)return"quit";switch(e.kind){case 198:case 155:return!0;case 219:switch(e.parent.kind){case 159:case 157:case 160:return!0;default:return!1}default:return!1}});return void 0===n}var s=e.getSourceFileOfNode(t),c=e.getSourceFileOfNode(r);if(s!==c){if(ST&&(s.externalModuleIndicator||c.externalModuleIndicator)||!xT.outFile&&!xT.out||fp(r)||4194304&t.flags)return!0;if(i(r,t))return!0;var u=o.getSourceFiles();return u.indexOf(s)<=u.indexOf(c)}if(t.pos<=r.pos){if(187===t.kind){var l=e.getAncestor(r,187);return l?e.findAncestor(l,e.isBindingElement)!==e.findAncestor(t,e.isBindingElement)||t.pos<l.pos:B(e.getAncestor(t,238),r)}return 238===t.kind?!n(t,r):e.isClassDeclaration(t)?!e.findAncestor(r,function(r){return e.isComputedPropertyName(r)&&r.parent.parent===t}):e.isPropertyDeclaration(t)?!a(t,r):!0}if(258===r.parent.kind||255===r.parent.kind&&r.parent.isExportEquals)return!0;if(255===r.kind&&r.isExportEquals)return!0;var _=e.getEnclosingBlockScopeContainer(t);return!!(2097152&r.flags)||fp(r)||i(r,t,_)}function j(e,t,r,n,i,a,o,s){return void 0===o&&(o=!1),J(e,t,r,n,i,a,o,L,s)}function J(t,r,n,i,a,o,s,c,u){var l,_,d,p,f,m,g=t,v=!1,h=t,x=!1;e:for(;t;){if(t.locals&&!M(t)&&(l=c(t.locals,r,n))){var D=!0;if(e.isFunctionLike(t)&&_&&_!==t.body){if(n&l.flags&67897832&&297!==_.kind&&(D=262144&l.flags?_===t.type||152===_.kind||151===_.kind:!1),n&l.flags&3){var S=t;xT.target&&xT.target>=2&&e.isParameter(_)&&S.body&&l.valueDeclaration.pos>=S.body.pos&&l.valueDeclaration.end<=S.body.end?D=!1:1&l.flags&&(D=152===_.kind||_===t.type&&!!e.findAncestor(l.valueDeclaration,e.isParameter))}}else 176===t.kind&&(D=_===t.trueType);if(D)break e;l=void 0}switch(v=v||z(t,_),t.kind){case 285:if(!e.isExternalOrCommonJsModule(t))break;x=!0;case 245:var C=Ht(t).exports;if(285===t.kind||e.isAmbientModule(t)){if(l=C.get("default")){var k=e.getLocalSymbolForExportDefault(l);if(k&&l.flags&n&&k.escapedName===r)break e;l=void 0}var T=C.get(r);if(T&&2097152===T.flags&&e.getDeclarationOfKind(T,258))break}if("default"!==r&&(l=c(C,r,2623475&n))){if(!e.isSourceFile(t)||!t.commonJsModuleIndicator||l.declarations.some(e.isJSDocTypeAlias))break e;l=void 0}break;case 244:if(l=c(Ht(t).exports,r,8&n))break e;break;case 155:if(!e.hasModifier(t,32)){var E=er(t.parent);E&&E.locals&&c(E.locals,r,67220415&n)&&(p=t)}break;case 241:case 210:case 242:if(l=c(Ht(t).members||hT,r,67897832&n)){if(!K(l,t)){l=void 0;break}if(_&&e.hasModifier(_,32))return void y(h,e.Diagnostics.Static_members_cannot_reference_class_type_parameters);break e}if(210===t.kind&&32&n){var N=t.name;if(N&&r===N.escapedText){l=t.symbol;break e}}break;case 212:if(_===t.expression&&87===t.parent.token){var A=t.parent.parent;if(e.isClassLike(A)&&(l=c(Ht(A).members,r,67897832&n)))return void(i&&y(h,e.Diagnostics.Base_class_expressions_cannot_reference_class_type_parameters))}break;case 150:if(m=t.parent.parent,(e.isClassLike(m)||242===m.kind)&&(l=c(Ht(m).members,r,67897832&n)))return void y(h,e.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);break;case 198:if(xT.target>=2)break;case 157:case 158:case 159:case 160:case 240:if(3&n&&"arguments"===r){l=jT;break e}break;case 197:if(3&n&&"arguments"===r){l=jT;break e}if(16&n){var F=t.name;if(F&&r===F.escapedText){l=t.symbol;break e}}break;case 153:t.parent&&152===t.parent.kind&&(t=t.parent),t.parent&&(e.isClassElement(t.parent)||241===t.parent.kind)&&(t=t.parent);break;case 310:case 303:t=e.getJSDocHost(t);break;case 152:_&&_===t.initializer&&(f=t);break;case 187:if(_&&_===t.initializer){var P=e.getRootDeclaration(t);152===P.kind&&(f=t)}}V(t)&&(d=t),_=t,t=t.parent}if(!o||!l||d&&l===d.symbol||(l.isReferenced|=n),!l){if(_&&(e.Debug.assert(285===_.kind),_.commonJsModuleIndicator&&"exports"===r&&n&_.symbol.flags))return _.symbol;s||(l=c(MT,r,n))}if(!l&&g&&e.isInJSFile(g)&&g.parent&&e.isRequireCall(g.parent,!1))return JT;if(!l){if(i&&!(h&&(q(h,r,a)||W(h)||G(h,r,n)||X(h,r,n)||Z(h,r,n)||Q(h,r,n)))){var w=void 0;if(u&&JN>jN&&(w=sv(g,r,n))){var I=kr(w),O=y(h,u,U(a),I);w.valueDeclaration&&e.addRelatedInfo(O,e.createDiagnosticForNode(w.valueDeclaration,e.Diagnostics._0_is_declared_here,I))}w||y(h,i,U(a)),jN++}return void 0}if(i){if(p){var L=p.name;return void y(h,e.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor,e.declarationNameToString(L),U(a))}if(h&&(2&n||(32&n||384&n)&&67220415===(67220415&n))){var R=Zt(l);(2&R.flags||32&R.flags||384&R.flags)&&$(R,h)}if(l&&x&&67220415===(67220415&n)&&!(2097152&g.flags)){var B=Wt(l);e.length(B.declarations)&&e.every(B.declarations,function(t){return e.isNamespaceExportDeclaration(t)||e.isSourceFile(t)&&!!t.symbol.globalExports})&&b(!xT.allowUmdGlobalAccess,h,e.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead,e.unescapeLeadingUnderscores(r))}if(l&&f&&!v&&67220415===(67220415&n)){var j=Wt(zi(l)),P=e.getRootDeclaration(f);j===Ht(f)?y(h,e.Diagnostics.Parameter_0_cannot_be_referenced_in_its_initializer,e.declarationNameToString(f.name)):j.valueDeclaration&&j.valueDeclaration.pos>f.pos&&P.parent.locals&&c(P.parent.locals,j.escapedName,n)===j&&y(h,e.Diagnostics.Initializer_of_parameter_0_cannot_reference_identifier_1_declared_after_it,e.declarationNameToString(f.name),e.declarationNameToString(h))}}return l}function z(t,r){return 198!==t.kind&&197!==t.kind?e.isTypeQueryNode(t)||(e.isFunctionLikeDeclaration(t)||155===t.kind&&!e.hasModifier(t,32))&&(!r||r!==t.name):r&&r===t.name?!1:t.asteriskToken||e.hasModifier(t,256)?!0:!e.getImmediatelyInvokedFunctionExpression(t)}function V(e){switch(e.kind){case 240:case 241:case 242:case 244:case 243:case 245:return!0;default:return!1}}function U(t){return e.isString(t)?e.unescapeLeadingUnderscores(t):e.declarationNameToString(t)}function K(t,r){for(var n=0,i=t.declarations;n<i.length;n++){var a=i[n];if(151===a.kind){var o=e.isJSDocTemplateTag(a.parent)?e.getJSDocHost(a.parent):a.parent;if(o===r)return!(e.isJSDocTemplateTag(a.parent)&&e.find(a.parent.parent.tags,e.isJSDocTypeAlias))}}return!1}function q(t,r,n){if(!e.isIdentifier(t)||t.escapedText!==r||RS(t)||fp(t))return!1;for(var i=e.getThisContainer(t,!1),a=i;a;){if(e.isClassLike(a.parent)){var o=Ht(a.parent);if(!o)break;var s=Un(o);if(ao(s,r))return y(t,e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0,U(n),kr(o)),!0;if(a===i&&!e.hasModifier(a,32)){var c=bi(o).thisType;if(ao(c,r))return y(t,e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0,U(n)),!0}}a=a.parent}return!1}function W(t){var r=H(t);return r&&kt(r,64,!0)?(y(t,e.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements,e.getTextOfNode(r)),!0):!1}function H(t){switch(t.kind){case 73:case 190:return t.parent?H(t.parent):void 0;case 212:if(e.isEntityNameExpression(t.expression))return t.expression;default:return void 0}}function G(t,r,n){var i=1920|(e.isInJSFile(t)?67220415:0);if(n===i){var a=ht(j(t,r,67897832&~i,void 0,void 0,!1)),o=t.parent;if(a){if(e.isQualifiedName(o)){e.Debug.assert(o.left===t,"Should only be resolving left side of qualified name as a namespace");var s=o.right.escapedText,c=ao(bi(a),s);if(c)return y(o,e.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1,e.unescapeLeadingUnderscores(r),e.unescapeLeadingUnderscores(s)),!0}return y(t,e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here,e.unescapeLeadingUnderscores(r)),!0}}return!1}function Q(t,r,n){if(67897448&n){var i=ht(j(t,r,111127,void 0,void 0,!1));if(i&&!(1920&i.flags))return y(t,e.Diagnostics._0_refers_to_a_value_but_is_being_used_as_a_type_here,e.unescapeLeadingUnderscores(r)),!0}return!1}function X(t,r,n){if(67220415&n){if("any"===r||"string"===r||"number"===r||"boolean"===r||"never"===r)return y(t,e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here,e.unescapeLeadingUnderscores(r)),!0;var i=ht(j(t,r,788544,void 0,void 0,!1));if(i&&!(1024&i.flags)){var a=Y(r)?e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later:e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here;return y(t,a,e.unescapeLeadingUnderscores(r)),!0}}return!1}function Y(e){switch(e){case"Promise":case"Symbol":case"Map":case"WeakMap":case"Set":case"WeakSet":return!0}return!1}function Z(t,r,n){if(111127&n){var i=ht(j(t,r,1024,void 0,void 0,!1));if(i)return y(t,e.Diagnostics.Cannot_use_namespace_0_as_a_value,e.unescapeLeadingUnderscores(r)),!0}else if(788544&n){var i=ht(j(t,r,1536,void 0,void 0,!1));if(i)return y(t,e.Diagnostics.Cannot_use_namespace_0_as_a_type,e.unescapeLeadingUnderscores(r)),!0}return!1}function $(t,r){e.Debug.assert(!!(2&t.flags||32&t.flags||384&t.flags));var n=e.find(t.declarations,function(t){return e.isBlockOrCatchScoped(t)||e.isClassLike(t)||244===t.kind||e.isInJSFile(t)&&!!e.getJSDocEnumTag(t)});if(void 0===n)return e.Debug.fail("Declaration to checkResolvedBlockScopedVariable is undefined");if(!(4194304&n.flags||B(n,r))){var i=void 0,a=e.declarationNameToString(e.getNameOfDeclaration(n));2&t.flags?i=y(r,e.Diagnostics.Block_scoped_variable_0_used_before_its_declaration,a):32&t.flags?i=y(r,e.Diagnostics.Class_0_used_before_its_declaration,a):256&t.flags?i=y(r,e.Diagnostics.Enum_0_used_before_its_declaration,a):(e.Debug.assert(!!(128&t.flags)),xT.preserveConstEnums&&(i=y(r,e.Diagnostics.Class_0_used_before_its_declaration,a))),i&&e.addRelatedInfo(i,e.createDiagnosticForNode(n,e.Diagnostics._0_is_declared_here,a))}}function et(t,r,n){return!!r&&!!e.findAncestor(t,function(t){return t===n||e.isFunctionLike(t)?"quit":t===r})}function tt(e){switch(e.kind){case 249:return e;case 251:return e.parent;case 252:return e.parent.parent;case 254:return e.parent.parent.parent;default:return void 0}}function rt(t){return e.find(t.declarations,e.isAliasSymbolDeclaration)}function nt(t,r){return 260===t.moduleReference.kind?Ot(At(t,e.getExternalModuleImportEqualsDeclarationExpression(t))):St(t.moduleReference,r)}function it(e,t,r){var n=e.exports.get("export=");return n?ao(Un(n),t):ht(e.exports.get(t),r)}function at(t){return e.isExportAssignment(t)&&!t.isExportEquals||e.hasModifier(t,512)||e.isExportSpecifier(t)}function ot(t,r,n){if(!CT)return!1;if(!t||t.isDeclarationFile){var i=it(r,"default",!0);return i&&e.some(i.declarations,at)?!1:it(r,e.escapeLeadingUnderscores("__esModule"),n)?!1:!0}return e.isSourceFileJS(t)?!t.externalModuleIndicator&&!it(r,e.escapeLeadingUnderscores("__esModule"),n):Rt(r)}function st(t,r){var n=At(t,t.parent.moduleSpecifier);if(n){var i=void 0;i=e.isShorthandAmbientModuleSymbol(n)?n:it(n,"default",r);var a=e.find(n.declarations,e.isSourceFile),o=ot(a,n,r);if(i||o){if(o)return Ot(n,r)||ht(n,r)}else if(Rt(n)){var s=ST>=e.ModuleKind.ES2015?"allowSyntheticDefaultImports":"esModuleInterop",c=n.exports.get("export="),u=c.valueDeclaration,l=y(t.name,e.Diagnostics.Module_0_can_only_be_default_imported_using_the_1_flag,kr(n),s);e.addRelatedInfo(l,e.createDiagnosticForNode(u,e.Diagnostics.This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag,s))}else y(t.name,e.Diagnostics.Module_0_has_no_default_export,kr(n));return i}}function ct(e,t){var r=e.parent.parent.moduleSpecifier;return Lt(At(e,r),r,t)}function ut(t,r){if(t===XT&&r===XT)return XT;if(67899368&t.flags)return t;var n=x(t.flags|r.flags,t.escapedName);return n.declarations=e.deduplicate(e.concatenate(t.declarations,r.declarations),e.equateValues),n.parent=t.parent||r.parent,t.valueDeclaration&&(n.valueDeclaration=t.valueDeclaration),r.members&&(n.members=r.members),t.exports&&(n.exports=t.exports),n}function lt(e,t,r){return 1536&e.flags?ht(Vt(e).get(t),r):void 0}function _t(e,t){if(3&e.flags){var r=e.valueDeclaration.type;if(r)return ht(ao(ju(r),t))}}function dt(t,r,n){void 0===n&&(n=!1);var i=At(t,t.moduleSpecifier),a=Lt(i,t.moduleSpecifier,n);if(a){var o=r.propertyName||r.name;if(o.escapedText){if(e.isShorthandAmbientModuleSymbol(i))return i;var s=void 0;s=i&&i.exports&&i.exports.get("export=")?ao(Un(a),o.escapedText):_t(a,o.escapedText),s=ht(s,n);var c=lt(a,o.escapedText,n);!c&&CT&&"default"===o.escapedText&&(c=Ot(i,n)||ht(i,n));var u=c&&s&&c!==s?ut(s,c):c||s;if(!u){var l=Ct(i,t),_=e.declarationNameToString(o),d=uv(o,a);if(void 0!==d){var p=kr(d),f=y(o,e.Diagnostics.Module_0_has_no_exported_member_1_Did_you_mean_2,l,_,p);d.valueDeclaration&&e.addRelatedInfo(f,e.createDiagnosticForNode(d.valueDeclaration,e.Diagnostics._0_is_declared_here,p))}else y(o,e.Diagnostics.Module_0_has_no_exported_member_1,l,_)}return u}}}function pt(e,t){return dt(e.parent.parent.parent,e,t)}function ft(e,t){return Ot(e.parent.symbol,t)}function mt(e,t,r){return e.parent.parent.moduleSpecifier?dt(e.parent.parent,e,r):kt(e.propertyName||e.name,t,!1,r)}function gt(t,r){var n=e.isExportAssignment(t)?t.expression:t.right;if(e.isClassExpression(n))return yb(n).symbol;var i=kt(n,68009983,!0,r);return i?i:(yb(n),O(n).resolvedSymbol)}function vt(t,r){switch(void 0===r&&(r=!1),t.kind){case 249:return nt(t,r);case 251:return st(t,r);case 252:return ct(t,r);case 254:return pt(t,r);case 258:return mt(t,68009983,r);case 255:case 205:return gt(t,r);case 248:return ft(t,r);default:return e.Debug.fail()}}function yt(e,t){return void 0===t&&(t=68009983),e?2097152===(e.flags&(2097152|t))||!!(2097152&e.flags&&67108864&e.flags):!1}function ht(e,t){return!t&&yt(e)?bt(e):e}function bt(t){e.Debug.assert(0!==(2097152&t.flags),"Should only get Alias here.");var r=I(t);if(r.target)r.target===YT&&(r.target=XT);else{r.target=YT;var n=rt(t);if(!n)return e.Debug.fail();var i=vt(n);r.target===YT?r.target=i||XT:y(n,e.Diagnostics.Circular_definition_of_import_alias_0,kr(t))}return r.target}function xt(e){var t=Ht(e),r=bt(t);if(r){var n=r===XT||67220415&r.flags&&!hC(r);n&&Dt(t)}}function Dt(t){var r=I(t);if(!r.referenced){r.referenced=!0;var n=rt(t);if(!n)return e.Debug.fail();255===n.kind?eb(n.expression):258===n.kind?eb(n.propertyName||n.name):e.isInternalModuleImportEqualsDeclaration(n)&&eb(n.moduleReference)}}function St(t,r){return 73===t.kind&&e.isRightSideOfQualifiedNameOrPropertyAccess(t)&&(t=t.parent),73===t.kind||149===t.parent.kind?kt(t,1920,!1,r):(e.Debug.assert(249===t.parent.kind),kt(t,68009983,!1,r))}function Ct(e,t){return e.parent?Ct(e.parent,t)+"."+kr(e):kr(e,t,void 0,20)}function kt(t,r,n,i,a){if(e.nodeIsMissing(t))return void 0;var o,s=1920|(e.isInJSFile(t)?67220415&r:0);if(73===t.kind){var c=r===s?e.Diagnostics.Cannot_find_namespace_0:dp(iS(t)),u=e.isInJSFile(t)?Tt(t,r):void 0;if(o=j(a||t,t.escapedText,r,n||u?void 0:c,t,!0),!o)return u}else{if(149!==t.kind&&190!==t.kind)throw e.Debug.assertNever(t,"Unknown entity name kind.");var l=149===t.kind?t.left:t.expression,_=149===t.kind?t.right:t.name,d=kt(l,s,n,!1,a);if(!d||e.nodeIsMissing(_))return void 0;if(d===XT)return d;if(e.isInJSFile(t)&&d.valueDeclaration&&e.isVariableDeclaration(d.valueDeclaration)&&d.valueDeclaration.initializer&&wy(d.valueDeclaration.initializer)){var p=d.valueDeclaration.initializer.arguments[0],f=At(p,p);if(f){var m=Ot(f);m&&(d=m)}}if(o=L(Vt(d),_.escapedText,r),!o)return void(n||y(_,e.Diagnostics.Namespace_0_has_no_exported_member_1,Ct(d),e.declarationNameToString(_)))}return e.Debug.assert(0===(1&e.getCheckFlags(o)),"Should never get an instantiated symbol here."),o.flags&r||i?o:bt(o)}function Tt(e,t){if(xs(e.parent)){var r=Et(e.parent);if(r)return j(r,e.escapedText,t,void 0,e,!0)}}function Et(t){var r=e.findAncestor(t,function(t){return e.isJSDocNode(t)||2097152&t.flags?e.isJSDocTypeAlias(t):"quit"});if(!r){var n=e.getJSDocHost(t);if(e.isExpressionStatement(n)&&e.isBinaryExpression(n.expression)&&3===e.getAssignmentDeclarationKind(n.expression)){var i=Ht(n.expression.left);if(i)return Nt(i)}if((e.isObjectLiteralMethod(n)||e.isPropertyAssignment(n))&&e.isBinaryExpression(n.parent.parent)&&6===e.getAssignmentDeclarationKind(n.parent.parent)){var i=Ht(n.parent.parent.left);if(i)return Nt(i)}var a=e.getHostSignatureFromJSDocHost(n);if(a){var i=Ht(a);return i&&i.valueDeclaration}}}function Nt(t){var r=t.parent.valueDeclaration;if(!r)return void 0;var n=e.isAssignmentDeclaration(r)?e.getAssignedExpandoInitializer(r):e.hasOnlyExpressionInitializer(r)?e.getDeclaredExpandoInitializer(r):void 0;return n||r}function At(t,r,n){return Ft(t,r,n?void 0:e.Diagnostics.Cannot_find_module_0)}function Ft(t,r,n,i){return void 0===i&&(i=!1),e.isStringLiteralLike(r)?Pt(t,r.text,n,r,i):void 0}function Pt(t,r,n,i,a){if(void 0===a&&(a=!1),void 0!==r){if(e.startsWith(r,"@types/")){var s=e.Diagnostics.Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1,c=e.removePrefix(r,"@types/");y(i,s,c,r)}var u=vo(r,!0);if(u)return u;var l=e.getSourceFileOfNode(t),_=e.getResolvedModule(l,r),d=_&&e.getResolutionDiagnostic(xT,_),p=_&&!d&&o.getSourceFile(_.resolvedFileName);if(p)return p.symbol?(_.isExternalLibraryImport&&!e.resolutionExtensionIsTSOrJson(_.extension)&&wt(!1,i,_,r),Wt(p.symbol)):void(n&&y(i,e.Diagnostics.File_0_is_not_a_module,p.fileName));if(BE){var f=e.findBestPatternMatch(BE,function(e){return e.pattern},r);if(f){var m=jE&&jE.get(r);return Wt(m?m:f.symbol)}}if(_&&!e.resolutionExtensionIsTSOrJson(_.extension)&&void 0===d||d===e.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type){if(a){var s=e.Diagnostics.Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented;y(i,s,r,_.resolvedFileName)}else wt(AT&&!!n,i,_,r);return void 0}if(n){if(_){var g=o.getProjectReferenceRedirect(_.resolvedFileName);if(g)return void y(i,e.Diagnostics.Output_file_0_has_not_been_built_from_source_file_1,g,_.resolvedFileName)}if(d)y(i,d,r,_.resolvedFileName);else{var v=e.tryExtractTSExtension(r);if(v){var s=e.Diagnostics.An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead;y(i,s,v,e.removeExtension(r,v))}else!xT.resolveJsonModule&&e.fileExtensionIs(r,".json")&&e.getEmitModuleResolutionKind(xT)===e.ModuleResolutionKind.NodeJs&&e.hasJsonModuleEmitEnabled(xT)?y(i,e.Diagnostics.Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension,r):y(i,n,r)}}return void 0}}function wt(t,r,n,i){var a=n.packageId,o=n.resolvedFileName,s=!e.isExternalModuleNameRelative(i)&&a?It(a.name)?e.chainDiagnosticMessages(void 0,e.Diagnostics.If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1,a.name,e.mangleScopedPackageName(a.name)):e.chainDiagnosticMessages(void 0,e.Diagnostics.Try_npm_install_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0,i,e.mangleScopedPackageName(a.name)):void 0;b(t,r,e.chainDiagnosticMessages(s,e.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type,i,o))}function It(t){return lT().has(e.getTypesPackageName(t))}function Ot(e,t){if(e){var r=ht(e.exports.get("export="),t),n=Mt(r,e);return Wt(n)||e}return void 0}function Mt(t,r){if(!t||t===XT||t===r||1===r.exports.size||2097152&t.flags)return t;var n=k(t);return void 0===n.exports&&(n.flags=512|n.flags,n.exports=e.createSymbolTable()),r.exports.forEach(function(e,t){"export="!==t&&n.exports.set(t,n.exports.has(t)?T(n.exports.get(t),e):e)}),n}function Lt(t,r,n){var i=Ot(t,n);if(!n&&i){if(!(1539&i.flags||e.getDeclarationOfKind(i,285))){var a=ST>=e.ModuleKind.ES2015?"allowSyntheticDefaultImports":"esModuleInterop";return y(r,e.Diagnostics.This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export,a),i}if(xT.esModuleInterop){var o=r.parent;if(e.isImportDeclaration(o)&&e.getNamespaceDeclarationNode(o)||e.isImportCall(o)){var s=Un(i),c=oo(s,0);if(c&&c.length||(c=oo(s,1)),c&&c.length){var u=Py(s,i,t),l=x(i.flags,i.escapedName);l.declarations=i.declarations?i.declarations.slice():[],l.parent=i.parent,l.target=i,l.originatingImport=o,i.valueDeclaration&&(l.valueDeclaration=i.valueDeclaration),i.constEnumOnlyModule&&(l.constEnumOnlyModule=!0),i.members&&(l.members=e.cloneMap(i.members)),i.exports&&(l.exports=e.cloneMap(i.exports));var _=Ta(u);return l.type=lr(l,_.members,e.emptyArray,e.emptyArray,_.stringIndexInfo,_.numberIndexInfo),l}}}}return i}function Rt(e){return void 0!==e.exports.get("export=")}function Bt(e){return mo(Ut(e))}function jt(t){var r=Bt(t),n=Ot(t);return n!==t&&e.addRange(r,Pa(Un(n))),r}function Jt(e,t){var r=Ut(t);return r?r.get(e):void 0}function zt(e,t){var r=Jt(e,t);if(r)return r;var n=Ot(t);if(n===t)return void 0;var i=Un(n);return 131068&i.flags?void 0:ao(i,e)}function Vt(e){return 32&e.flags?ji(e,"resolvedExports"):1536&e.flags?Ut(e):e.exports||hT}function Ut(e){var t=I(e);return t.resolvedExports||(t.resolvedExports=qt(e))}function Kt(t,r,n,i){r&&r.forEach(function(r,a){if("default"!==a){var o=t.get(a);if(o){if(n&&i&&o&&ht(o)!==ht(r)){var s=n.get(a);s.exportsWithDuplicate?s.exportsWithDuplicate.push(i):s.exportsWithDuplicate=[i]}}else t.set(a,r),n&&i&&n.set(a,{specifierText:e.getTextOfNode(i.moduleSpecifier)})}})}function qt(t){function r(t){if(t&&t.exports&&e.pushIfUnique(n,t)){var i=e.cloneMap(t.exports),a=t.exports.get("__export");if(a){for(var o=e.createSymbolTable(),s=e.createMap(),c=0,u=a.declarations;c<u.length;c++){var l=u[c],_=At(l,l.moduleSpecifier),d=r(_);Kt(o,d,s,l)}s.forEach(function(t,r){var n=t.exportsWithDuplicate;if("export="!==r&&n&&n.length&&!i.has(r))for(var a=0,o=n;a<o.length;a++){var c=o[a];tA.add(e.createDiagnosticForNode(c,e.Diagnostics.Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity,s.get(r).specifierText,e.unescapeLeadingUnderscores(r)))}}),Kt(i,o)}return i}}var n=[];return t=Ot(t),r(t)||hT}function Wt(e){var t;return e&&e.mergeId&&(t=zN[e.mergeId])?t:e}function Ht(e){return Wt(e.symbol&&zi(e.symbol))}function Gt(e){return Wt(e.parent&&zi(e.parent))}function Qt(r,n){var i,a=e.getSourceFileOfNode(n),s=""+t(a),c=I(r);if(c.extendedContainersByFile&&(i=c.extendedContainersByFile.get(s)))return i;
if(a&&a.imports){for(var u=0,l=a.imports;u<l.length;u++){var _=l[u];if(!e.nodeIsSynthesized(_)){var d=At(n,_,!0);if(d){var p=Yt(d,r);p&&(i=e.append(i,d))}}}if(e.length(i))return(c.extendedContainersByFile||(c.extendedContainersByFile=e.createMap())).set(s,i),i}if(c.extendedContainers)return c.extendedContainers;for(var f=o.getSourceFiles(),m=0,g=f;m<g.length;m++){var v=g[m];if(e.isExternalModule(v)){var y=Ht(v),p=Yt(y,r);p&&(i=e.append(i,y))}}return c.extendedContainers=i||e.emptyArray}function Xt(t,r){function n(e){var t=br(e),r=t&&t.exports&&t.exports.get("export=");return ht(r)===ht(i)?t:void 0}var i=Gt(t);if(i){var a=e.mapDefined(i.declarations,n),o=r&&Qt(t,r);if(r&&pr(i,r,1920,!1))return e.concatenate(e.concatenate([i],a),o);var s=e.append(a,i);return e.concatenate(s,o)}var c=e.mapDefined(t.declarations,function(t){return!e.isAmbientModule(t)&&t.parent&&Dr(t.parent)?Ht(t.parent):void 0});return e.length(c)?e.mapDefined(c,function(e){return Yt(e,t)?e:void 0}):void 0}function Yt(t,r){function n(e){return e===r||ht(e)===r||ht(e)===ht(r)?e:void 0}if(t===Gt(r))return r;var i=Vt(t),a=i.get(r.escapedName);return a&&n(a)?a:e.forEachEntry(i,function(e){return n(e)?e:void 0})}function Zt(e){return Wt(e&&0!==(1048576&e.flags)?e.exportSymbol:e)}function $t(e){return!!(67220415&e.flags||2097152&e.flags&&67220415&bt(e).flags)}function er(t){for(var r=t.members,n=0,i=r;n<i.length;n++){var a=i[n];if(158===a.kind&&e.nodeIsPresent(a.body))return a}}function tr(e){var t=new dT(zT,e);return fT++,t.id=fT,t}function rr(e,t,r){void 0===r&&(r=0);var n=tr(e);return n.intrinsicName=t,n.objectFlags=r,n}function nr(e){var t=Dc(e);return t.flags|=16,t.intrinsicName="boolean",t}function ir(e,t){var r=tr(524288);return r.objectFlags=e,r.symbol=t,r.members=void 0,r.properties=void 0,r.callSignatures=void 0,r.constructSignatures=void 0,r.stringIndexInfo=void 0,r.numberIndexInfo=void 0,r}function ar(){return Dc(e.arrayFrom(sA.keys(),Iu))}function or(e){var t=tr(262144);return e&&(t.symbol=e),t}function sr(e){return 95===e.charCodeAt(0)&&95===e.charCodeAt(1)&&95!==e.charCodeAt(2)&&64!==e.charCodeAt(2)}function cr(t){var r;return t.forEach(function(e,t){!sr(t)&&$t(e)&&(r||(r=[])).push(e)}),r||e.emptyArray}function ur(t,r,n,i,a,o){return t.members=r,t.properties=r===hT?e.emptyArray:cr(r),t.callSignatures=n,t.constructSignatures=i,t.stringIndexInfo=a,t.numberIndexInfo=o,t}function lr(e,t,r,n,i,a){return ur(ir(16,e),t,r,n,i,a)}function _r(t,r){for(var n,i=t;i;i=i.parent){if(i.locals&&!M(i)&&(n=r(i.locals)))return n;switch(i.kind){case 285:if(!e.isExternalOrCommonJsModule(i))break;case 245:if(n=r(Ht(i).exports))return n}}return r(MT)}function dr(e){return 67220415===e?67220415:1920}function pr(t,n,i,a,o){function s(t,r){if(!e.pushIfUnique(d,t))return void 0;var n=l(t,r);return d.pop(),n}function c(e,t){return!fr(e,n,t)||!!pr(e.parent,n,dr(t),a,o)}function u(r,n,a){return t===(n||r)&&!e.some(r.declarations,Dr)&&(a||c(r,i))}function l(r,o){return u(r.get(t.escapedName),void 0,o)?[t]:e.forEachEntry(r,function(r){if(!(!(2097152&r.flags&&"export="!==r.escapedName&&"default"!==r.escapedName)||e.isUMDExportSymbol(r)&&n&&e.isExternalModule(e.getSourceFileOfNode(n))||a&&!e.some(r.declarations,e.isExternalModuleImportEqualsDeclaration)||!o&&e.getDeclarationOfKind(r,258))){var l=bt(r);if(u(r,l,o))return[r];var _=Vt(l),d=_&&s(_,!0);if(d&&c(r,dr(i)))return[r].concat(d)}return r.escapedName===t.escapedName&&r.exportSymbol&&u(Wt(r.exportSymbol),void 0,o)?[t]:void 0})}if(void 0===o&&(o=e.createMap()),!t||mr(t))return void 0;var _=""+r(t),d=o.get(_);return d||o.set(_,d=[]),_r(n,s)}function fr(t,r,n){var i=!1;return _r(r,function(r){var a=Wt(r.get(t.escapedName));return a?a===t?!0:(a=2097152&a.flags&&!e.getDeclarationOfKind(a,258)?bt(a):a,a.flags&n?(i=!0,!0):!1):!1}),i}function mr(e){if(e.declarations&&e.declarations.length){for(var t=0,r=e.declarations;t<r.length;t++){var n=r[t];switch(n.kind){case 155:case 157:case 159:case 160:continue;default:return!1}}return!0}return!1}function gr(e,t){var r=hr(e,t,67897832,!1);return 0===r.accessibility}function vr(e,t){var r=hr(e,t,67220415,!1);return 0===r.accessibility}function yr(t,r,n,i,a){if(e.length(t)){for(var o,s=0,c=t;s<c.length;s++){var u=c[s],l=pr(u,r,i,!1);if(l){o=u;var _=Sr(l[0],a);if(_)return _}else if(e.some(u.declarations,Dr))return{accessibility:0};var d=Xt(u,r),p=e.first(u.declarations);!e.length(d)&&67220415&i&&p&&e.isObjectLiteralExpression(p)&&p.parent&&e.isVariableDeclaration(p.parent)&&p===p.parent.initializer&&(d=[Ht(p.parent)]);var f=yr(d,r,n,n===u?dr(i):i,a);if(f)return f}return o?{accessibility:1,errorSymbolName:kr(n,r,i),errorModuleName:o!==n?kr(o,r,1920):void 0}:void 0}}function hr(t,r,n,i){if(t&&r){var a=yr([t],r,t,n,i);if(a)return a;var o=e.forEach(t.declarations,br);if(o){var s=br(r);if(o!==s)return{accessibility:2,errorSymbolName:kr(t,r,n),errorModuleName:kr(o)}}return{accessibility:1,errorSymbolName:kr(t,r,n)}}return{accessibility:0}}function br(t){var r=e.findAncestor(t,xr);return r&&Ht(r)}function xr(t){return e.isAmbientModule(t)||285===t.kind&&e.isExternalOrCommonJsModule(t)}function Dr(t){return e.isModuleWithStringLiteralName(t)||285===t.kind&&e.isExternalOrCommonJsModule(t)}function Sr(t,r){function n(t){if(!jr(t)){var r=tt(t);return r&&!e.hasModifier(r,1)&&jr(r.parent)?i(t,r):e.isVariableDeclaration(t)&&e.isVariableStatement(t.parent.parent)&&!e.hasModifier(t.parent.parent,1)&&jr(t.parent.parent.parent)?i(t,t.parent.parent):e.isLateVisibilityPaintedStatement(t)&&!e.hasModifier(t,1)&&jr(t.parent)?i(t,t):!1}return!0}function i(t,n){return r&&(O(t).isVisible=!0,a=e.appendIfUnique(a,n)),!0}var a;return e.every(t.declarations,n)?{accessibility:0,aliasesToMakeVisible:a}:void 0}function Cr(t,r){var n;n=168===t.parent.kind||e.isExpressionWithTypeArgumentsInClassExtendsClause(t.parent)||150===t.parent.kind?68268991:149===t.kind||190===t.kind||249===t.parent.kind?1920:67897832;var i=iS(t),a=j(r,i.escapedText,n,void 0,void 0,!1);return a&&Sr(a,!0)||{accessibility:1,errorSymbolName:e.getTextOfNode(i),errorNode:i}}function kr(t,r,n,i,a){function o(i){var a=c(t,n,r,s),o=e.createPrinter({removeComments:!0}),u=r&&e.getSourceFileOfNode(r);return o.writeNode(4,a,u,i),i}void 0===i&&(i=4);var s=70221824;2&i&&(s|=128),1&i&&(s|=512),8&i&&(s|=16384),16&i&&(s|=134217728);var c=4&i?OT.symbolToExpression:OT.symbolToEntityName;return a?o(a).getText():e.usingSingleLineStringWriter(o)}function Tr(t,r,n,i,a){function o(a){var o;o=262144&n?1===i?167:166:1===i?162:161;var s=OT.signatureToSignatureDeclaration(t,o,r,70221824|Ar(n)|512),c=e.createPrinter({removeComments:!0,omitTrailingSemicolon:!0}),u=r&&e.getSourceFileOfNode(r);return c.writeNode(4,s,u,e.getTrailingSemicolonOmittingWriter(a)),a}return void 0===n&&(n=0),a?o(a).getText():e.usingSingleLineStringWriter(o)}function Er(t,r,n,i){void 0===n&&(n=1064960),void 0===i&&(i=e.createTextWriter(""));var a=xT.noErrorTruncation||1&n,o=OT.typeToTypeNode(t,r,70221824|Ar(n)|(a?1:0),i);if(void 0===o)return e.Debug.fail("should always get typenode");var s={removeComments:!0},c=e.createPrinter(s),u=r&&e.getSourceFileOfNode(r);c.writeNode(4,o,u,i);var l=i.getText(),_=a?void 0:2*e.defaultMaximumTruncationLength;return _&&l&&l.length>=_?l.substr(0,_-"...".length)+"...":l}function Nr(e,t){var r=Er(e),n=Er(t);return r===n&&(r=Er(e,void 0,64),n=Er(t,void 0,64)),[r,n]}function Ar(e){return void 0===e&&(e=0),9469291&e}function Fr(){function t(t,r,n,i){e.Debug.assert(void 0===t||0===(8&t.flags));var a={enclosingDeclaration:t,flags:r||0,tracker:n&&n.trackSymbol?n:{trackSymbol:e.noop,moduleResolverHost:134217728&r?{getCommonSourceDirectory:o.getCommonSourceDirectory?function(){return o.getCommonSourceDirectory()}:function(){return""},getSourceFiles:function(){return o.getSourceFiles()},getCurrentDirectory:o.getCurrentDirectory&&function(){return o.getCurrentDirectory()}}:void 0},encounteredError:!1,visitedTypes:void 0,symbolDepth:void 0,inferTypeParameters:void 0,approximateLength:0},s=i(a);return a.encounteredError?void 0:s}function n(t){return t.truncating?t.truncating:t.truncating=!(1&t.flags)&&t.approximateLength>e.defaultMaximumTruncationLength}function a(t,i){function o(t){e.Debug.assert(!!(524288&t.flags));var r,n=t.declaration.readonlyToken?e.createToken(t.declaration.readonlyToken.kind):void 0,o=t.declaration.questionToken?e.createToken(t.declaration.questionToken.kind):void 0;r=ha(t)?e.createTypeOperatorNode(a(ba(t),i)):a(ga(t),i);var s=f(ma(t),i,r),c=a(va(t),i),u=e.createMappedTypeNode(n,s,o,c);return i.approximateLength+=10,e.setEmitFlags(u,1)}function u(t){function n(){var t=!!(8192&c.flags)&&e.some(c.declarations,function(t){return e.hasModifier(t,32)}),r=!!(16&c.flags)&&(c.parent||e.forEach(c.declarations,function(e){return 285===e.parent.kind||246===e.parent.kind}));return t||r?(!!(4096&i.flags)||i.visitedTypes&&i.visitedTypes.has(o))&&(!(8&i.flags)||vr(c,i.enclosingDeclaration)):void 0}var a,o=""+t.id,c=t.symbol;if(c){var u=16&e.getObjectFlags(t)&&t.symbol&&32&t.symbol.flags;if(a=(u?"+":"")+r(c),Dy(c.valueDeclaration)){var l=t===Ey(c)?67897832:67220415;return C(c,i,l)}if(32&c.flags&&!Mn(c)&&!(210===c.valueDeclaration.kind&&2048&i.flags)||896&c.flags||n())return C(c,i,67220415);if(i.visitedTypes&&i.visitedTypes.has(o)){var _=Or(t);return _?C(_,i,67897832):s(i)}i.visitedTypes||(i.visitedTypes=e.createMap()),i.symbolDepth||(i.symbolDepth=e.createMap());var d=i.symbolDepth.get(a)||0;if(d>10)return s(i);i.symbolDepth.set(a,d+1),i.visitedTypes.set(o,!0);var p=m(t);return i.visitedTypes.delete(o),i.symbolDepth.set(a,d),p}return m(t)}function m(t){if(ka(t))return o(t);var r=Ta(t);if(!r.properties.length&&!r.stringIndexInfo&&!r.numberIndexInfo){if(!r.callSignatures.length&&!r.constructSignatures.length)return i.approximateLength+=2,e.setEmitFlags(e.createTypeLiteralNode(void 0),1);if(1===r.callSignatures.length&&!r.constructSignatures.length){var n=r.callSignatures[0],a=d(n,166,i);return a}if(1===r.constructSignatures.length&&!r.callSignatures.length){var n=r.constructSignatures[0],a=d(n,167,i);return a}}var s=i.flags;i.flags|=4194304;var c=h(r);i.flags=s;var u=e.createTypeLiteralNode(c);return i.approximateLength+=2,e.setEmitFlags(u,1024&i.flags?0:1)}function g(t){var r=t.typeArguments||e.emptyArray;if(t.target===KE||t.target===qE){if(2&i.flags){var n=a(r[0],i);return e.createTypeReferenceNode(t.target===KE?"Array":"ReadonlyArray",[n])}var o=a(r[0],i),s=e.createArrayTypeNode(o);return t.target===KE?s:e.createTypeOperatorNode(134,s)}if(8&t.target.objectFlags){if(r.length>0){var c=cs(t),_=l(r.slice(0,c),i),d=t.target.hasRestElement;if(_){for(var p=t.target.minLength;p<Math.min(c,_.length);p++)_[p]=d&&p===c-1?e.createRestTypeNode(e.createArrayTypeNode(_[p])):e.createOptionalTypeNode(_[p]);var f=e.createTupleTypeNode(_);return t.target.readonly?e.createTypeOperatorNode(134,f):f}}if(i.encounteredError||524288&i.flags){var f=e.createTupleTypeNode([]);return t.target.readonly?e.createTypeOperatorNode(134,f):f}return void(i.encounteredError=!0)}if(2048&i.flags&&t.symbol.valueDeclaration&&e.isClassLike(t.symbol.valueDeclaration)&&!vr(t.symbol,i.enclosingDeclaration))return u(t);var m=t.target.outerTypeParameters,p=0,g=void 0;if(m)for(var y=m.length;y>p;){var h=p,b=ns(m[p]);do p++;while(y>p&&ns(m[p])===b);if(!e.rangeEquals(m,r,h,p)){var x=l(r.slice(h,p),i),D=i.flags;i.flags|=16;var S=C(b,i,67897832,x);i.flags=D,g=g?v(g,S):S}}var k=void 0;if(r.length>0){var T=(t.target.typeParameters||e.emptyArray).length;k=l(r.slice(p,T),i)}var E=i.flags;i.flags|=16;var N=C(t.symbol,i,67897832,k);return i.flags=E,g?v(g,N):N}function v(t,r){if(e.isImportTypeNode(t)){var n=t.typeArguments;t.qualifier&&((e.isIdentifier(t.qualifier)?t.qualifier:t.qualifier.right).typeArguments=n),t.typeArguments=r.typeArguments;for(var i=y(r),a=0,o=i;a<o.length;a++){var s=o[a];t.qualifier=t.qualifier?e.createQualifiedName(t.qualifier,s):s}return t}var n=t.typeArguments;(e.isIdentifier(t.typeName)?t.typeName:t.typeName.right).typeArguments=n,t.typeArguments=r.typeArguments;for(var i=y(r),c=0,u=i;c<u.length;c++){var s=u[c];t.typeName=e.createQualifiedName(t.typeName,s)}return t}function y(t){for(var r=t.typeName,n=[];!e.isIdentifier(r);)n.unshift(r.right),r=r.left;return n.unshift(r),n}function h(t){if(n(i))return[e.createPropertySignature(void 0,"...",void 0,void 0,void 0)];for(var r=[],a=0,o=t.callSignatures;a<o.length;a++){var u=o[a];r.push(d(u,161,i))}for(var l=0,p=t.constructSignatures;l<p.length;l++){var u=p[l];r.push(d(u,162,i))}if(t.stringIndexInfo){var f=void 0;2048&t.objectFlags?(f=_(Zo(ZT,t.stringIndexInfo.isReadonly,t.stringIndexInfo.declaration),0,i),f.type=s(i)):f=_(t.stringIndexInfo,0,i),r.push(f)}t.numberIndexInfo&&r.push(_(t.numberIndexInfo,1,i));var m=t.properties;if(!m)return r;for(var g=0,v=0,y=m;v<y.length;v++){var h=y[v];if(g++,2048&i.flags){if(4194304&h.flags)continue;24&e.getDeclarationModifierFlagsFromSymbol(h)&&i.tracker.reportPrivateInBaseOfClassExpression&&i.tracker.reportPrivateInBaseOfClassExpression(e.unescapeLeadingUnderscores(h.escapedName))}if(n(i)&&g+2<m.length-1){r.push(e.createPropertySignature(void 0,"... "+(m.length-g)+" more ...",void 0,void 0,void 0)),c(m[m.length-1],i,r);break}c(h,i,r)}return r.length?r:void 0}oT&&oT.throwIfCancellationRequested&&oT.throwIfCancellationRequested();var b=8388608&i.flags;if(i.flags&=-8388609,!t)return void(i.encounteredError=!0);if(1&t.flags)return i.approximateLength+=3,e.createKeywordTypeNode(121);if(2&t.flags)return e.createKeywordTypeNode(144);if(4&t.flags)return i.approximateLength+=6,e.createKeywordTypeNode(139);if(8&t.flags)return i.approximateLength+=6,e.createKeywordTypeNode(136);if(64&t.flags)return i.approximateLength+=6,e.createKeywordTypeNode(147);if(16&t.flags)return i.approximateLength+=7,e.createKeywordTypeNode(124);if(1024&t.flags&&!(1048576&t.flags)){var x=Gt(t.symbol),D=C(x,i,67897832),S=bi(x)===t?D:v(D,e.createTypeReferenceNode(e.symbolName(t.symbol),void 0));return S}if(1056&t.flags)return C(t.symbol,i,67897832);if(128&t.flags)return i.approximateLength+=t.value.length+2,e.createLiteralTypeNode(e.setEmitFlags(e.createLiteral(t.value),16777216));if(256&t.flags){var k=t.value;return i.approximateLength+=(""+k).length,e.createLiteralTypeNode(0>k?e.createPrefix(39,e.createLiteral(-k)):e.createLiteral(k))}if(2048&t.flags)return i.approximateLength+=e.pseudoBigIntToString(t.value).length+1,e.createLiteralTypeNode(e.createLiteral(t.value));if(512&t.flags)return i.approximateLength+=t.intrinsicName.length,"true"===t.intrinsicName?e.createTrue():e.createFalse();if(8192&t.flags){if(!(1048576&i.flags)){if(vr(t.symbol,i.enclosingDeclaration))return i.approximateLength+=6,C(t.symbol,i,67220415);i.tracker.reportInaccessibleUniqueSymbolError&&i.tracker.reportInaccessibleUniqueSymbolError()}return i.approximateLength+=13,e.createTypeOperatorNode(143,e.createKeywordTypeNode(140))}if(16384&t.flags)return i.approximateLength+=4,e.createKeywordTypeNode(107);if(32768&t.flags)return i.approximateLength+=9,e.createKeywordTypeNode(142);if(65536&t.flags)return i.approximateLength+=4,e.createKeywordTypeNode(97);if(131072&t.flags)return i.approximateLength+=5,e.createKeywordTypeNode(133);if(4096&t.flags)return i.approximateLength+=6,e.createKeywordTypeNode(140);if(67108864&t.flags)return i.approximateLength+=6,e.createKeywordTypeNode(137);if(Zc(t))return 4194304&i.flags&&(i.encounteredError||32768&i.flags||(i.encounteredError=!0),i.tracker.reportInaccessibleThisError&&i.tracker.reportInaccessibleThisError()),i.approximateLength+=4,e.createThis();var T=e.getObjectFlags(t);if(4&T)return e.Debug.assert(!!(524288&t.flags)),g(t);if(262144&t.flags||3&T){if(262144&t.flags&&e.contains(i.inferTypeParameters,t))return i.approximateLength+=e.symbolName(t.symbol).length+6,e.createInferTypeNode(f(t,i,void 0));if(4&i.flags&&262144&t.flags&&e.length(t.symbol.declarations)&&e.isTypeParameterDeclaration(t.symbol.declarations[0])&&p(t,i)&&!gr(t.symbol,i.enclosingDeclaration)){var E=t.symbol.declarations[0].name;return i.approximateLength+=e.idText(E).length,e.createTypeReferenceNode(e.getGeneratedNameForNode(E,24),void 0)}return t.symbol?C(t.symbol,i,67897832):e.createTypeReferenceNode(e.createIdentifier("?"),void 0)}if(!b&&t.aliasSymbol&&(16384&i.flags||gr(t.aliasSymbol,i.enclosingDeclaration))){var N=l(t.aliasTypeArguments,i);return!sr(t.aliasSymbol.escapedName)||32&t.aliasSymbol.flags?C(t.aliasSymbol,i,67897832,N):e.createTypeReferenceNode(e.createIdentifier(""),N)}if(3145728&t.flags){var A=1048576&t.flags?wr(t.types):t.types;if(1===e.length(A))return a(A[0],i);var F=l(A,i,!0);if(F&&F.length>0){var P=e.createUnionOrIntersectionTypeNode(1048576&t.flags?174:175,F);return P}return void(i.encounteredError||262144&i.flags||(i.encounteredError=!0))}if(48&T)return e.Debug.assert(!!(524288&t.flags)),u(t);if(4194304&t.flags){var w=t.type;i.approximateLength+=6;var I=a(w,i);return e.createTypeOperatorNode(I)}if(8388608&t.flags){var O=a(t.objectType,i),I=a(t.indexType,i);return i.approximateLength+=2,e.createIndexedAccessTypeNode(O,I)}if(16777216&t.flags){var M=a(t.checkType,i),L=i.inferTypeParameters;i.inferTypeParameters=t.root.inferTypeParameters;var R=a(t.extendsType,i);i.inferTypeParameters=L;var B=a(du(t),i),j=a(pu(t),i);return i.approximateLength+=15,e.createConditionalTypeNode(M,R,B,j)}return 33554432&t.flags?a(t.typeVariable,i):e.Debug.fail("Should be unreachable.")}function s(t){return t.approximateLength+=3,1&t.flags?e.createKeywordTypeNode(121):e.createTypeReferenceNode(e.createIdentifier("..."),void 0)}function c(t,r,n){var i=!!(8192&e.getCheckFlags(t)),o=i&&33554432&r.flags?ZT:Un(t),c=r.enclosingDeclaration;if(r.enclosingDeclaration=void 0,r.tracker.trackSymbol&&4096&e.getCheckFlags(t)){var u=e.first(t.declarations);Ii(u)&&v(u.name,c,r)}var l=k(t,r,67220415,!0);r.approximateLength+=e.symbolName(t).length+1,r.enclosingDeclaration=c;var _=16777216&t.flags?e.createToken(56):void 0;if(8208&t.flags&&!Ea(o).length&&!bh(t))for(var p=so(o,0),f=0,m=p;f<m.length;f++){var g=m[f],y=d(g,156,r);y.name=l,y.questionToken=_,t.valueDeclaration&&e.setCommentRange(y,t.valueDeclaration),n.push(y)}else{var h=r.flags;r.flags|=i?33554432:0;var b=void 0;b=i&&33554432&h?s(r):o?a(o,r):e.createKeywordTypeNode(121),r.flags=h;var x=bh(t)?[e.createToken(134)]:void 0;x&&(r.approximateLength+=9);var D=e.createPropertySignature(x,l,_,b,void 0);t.valueDeclaration&&e.setCommentRange(D,t.valueDeclaration),n.push(D)}}function l(t,r,i){if(e.some(t)){if(n(r)){if(!i)return[e.createTypeReferenceNode("...",void 0)];if(t.length>2)return[a(t[0],r),e.createTypeReferenceNode("... "+(t.length-2)+" more ...",void 0),a(t[t.length-1],r)]}for(var o=[],s=0,c=0,u=t;c<u.length;c++){var l=u[c];if(s++,n(r)&&s+2<t.length-1){o.push(e.createTypeReferenceNode("... "+(t.length-s)+" more ...",void 0));var _=a(t[t.length-1],r);_&&o.push(_);break}r.approximateLength+=2;var d=a(l,r);d&&o.push(d)}return o}}function _(t,r,n){var i=e.getNameFromIndexInfo(t)||"x",o=e.createKeywordTypeNode(0===r?139:136),s=e.createParameter(void 0,void 0,void 0,i,void 0,o,void 0),c=a(t.type||ZT,n);return t.type||2097152&n.flags||(n.encounteredError=!0),n.approximateLength+=i.length+4,e.createIndexSignature(void 0,t.isReadonly?[e.createToken(134)]:void 0,[s],c)}function d(t,r,n){var i,o;32&n.flags&&t.target&&t.mapper&&t.target.typeParameters?o=t.target.typeParameters.map(function(e){return a(gl(e,t.mapper),n)}):i=t.typeParameters&&t.typeParameters.map(function(e){return m(e,n)});var s=Qi(t).map(function(e){return g(e,n,158===r)});if(t.thisParameter){var c=g(t.thisParameter,n);s.unshift(c)}var u,l=Io(t);if(l){var _=1===l.kind?e.setEmitFlags(e.createIdentifier(l.parameterName),16777216):e.createThisTypeNode(),d=a(l.type,n);u=e.createTypePredicateNode(_,d)}else{var p=Mo(t);u=p&&a(p,n)}return 256&n.flags?u&&121===u.kind&&(u=void 0):u||(u=e.createKeywordTypeNode(121)),n.approximateLength+=3,e.createSignatureDeclaration(r,i,s,u,o)}function p(e,t){return!!j(t.enclosingDeclaration,e.symbol.escapedName,67897832,void 0,e.symbol.escapedName,!1)}function f(t,r,n){var i=r.flags;r.flags&=-513;var o=4&r.flags&&t.symbol.declarations&&t.symbol.declarations[0]&&e.isTypeParameterDeclaration(t.symbol.declarations[0])&&p(t,r),s=o?e.getGeneratedNameForNode(t.symbol.declarations[0].name,24):k(t.symbol,r,67897832,!0),c=Xa(t),u=c&&a(c,r);return r.flags=i,e.createTypeParameterDeclaration(s,n,u)}function m(e,t,r){void 0===r&&(r=Ma(e));var n=r&&a(r,t);return f(e,t,n)}function g(t,r,n){function i(t){function n(t){r.tracker.trackSymbol&&e.isComputedPropertyName(t)&&Pi(t)&&v(t,r.enclosingDeclaration,r);var i=e.visitEachChild(t,n,e.nullTransformationContext,void 0,n),a=e.nodeIsSynthesized(i)?i:e.getSynthesizedClone(i);return 187===a.kind&&(a.initializer=void 0),e.setEmitFlags(a,16777217)}return n(t)}var o=e.getDeclarationOfKind(t,152);o||D(t)||(o=e.getDeclarationOfKind(t,305));var s=Un(t);o&&DC(o)&&(s=dd(s));var c=a(s,r),u=!(8192&r.flags)&&n&&o&&o.modifiers?o.modifiers.map(e.getSynthesizedClone):void 0,l=o&&e.isRestParameter(o)||32768&e.getCheckFlags(t),_=l?e.createToken(25):void 0,d=o&&o.name?73===o.name.kind?e.setEmitFlags(e.getSynthesizedClone(o.name),16777216):149===o.name.kind?e.setEmitFlags(e.getSynthesizedClone(o.name.right),16777216):i(o.name):e.symbolName(t),p=o&&yo(o)||16384&e.getCheckFlags(t),f=p?e.createToken(56):void 0,m=e.createParameter(void 0,u,_,d,f,c,void 0);return r.approximateLength+=e.symbolName(t).length+3,m}function v(e,t,r){if(r.tracker.trackSymbol){var n=iS(e.expression),i=j(n,n.escapedText,68268991,void 0,void 0,!0);i&&r.tracker.trackSymbol(i,t,67220415)}}function y(t,r,n,i){function a(t,n,o){function s(t,r){var n=c[t],i=c[r];if(n&&i){var a=e.pathIsRelative(i);return e.pathIsRelative(n)===a?e.moduleSpecifiers.countPathComponents(n)-e.moduleSpecifiers.countPathComponents(i):a?-1:1}return 0}var c,u=pr(t,r.enclosingDeclaration,n,!!(128&r.flags));if(!u||fr(u[0],r.enclosingDeclaration,1===u.length?n:dr(n))){var l=Xt(u?u[0]:t,r.enclosingDeclaration);if(e.length(l)){c=l.map(function(t){return e.some(t.declarations,Dr)?S(t,r):void 0});var _=l.map(function(e,t){return t});_.sort(s);for(var d=_.map(function(e){return l[e]}),p=0,f=d;p<f.length;p++){var m=f[p],g=a(m,dr(n),!1);if(g){u=g.concat(u||[Yt(m,t)||t]);break}}}}if(u)return u;if(o||!(6144&t.flags)){if(!o&&!i&&e.forEach(t.declarations,Dr))return;return[t]}}r.tracker.trackSymbol(t,r.enclosingDeclaration,n);var o,s=262144&t.flags;return s||!(r.enclosingDeclaration||64&r.flags)||134217728&r.flags?o=[t]:(o=e.Debug.assertDefined(a(t,n,!0)),e.Debug.assert(o&&o.length>0)),o}function h(t,r){var n,i=JD(t);return 524384&i.flags&&(n=e.createNodeArray(e.map(Xn(t),function(e){return m(e,r)}))),n}function b(t,n,i){e.Debug.assert(t&&n>=0&&n<t.length);var a=t[n],o=""+r(a);if(i.typeParameterSymbolList&&i.typeParameterSymbolList.get(o))return void 0;(i.typeParameterSymbolList||(i.typeParameterSymbolList=e.createMap())).set(o,!0);var s;if(512&i.flags&&n<t.length-1){var c=a,u=t[n+1];if(1&e.getCheckFlags(u)){var _=Yn(2097152&c.flags?bt(c):c);s=l(e.map(_,u.mapper),i)}else s=h(a,i)}return s}function x(t){return e.isIndexedAccessTypeNode(t.objectType)?x(t.objectType):t}function S(t,r){var n=e.getDeclarationOfKind(t,285);if(n&&void 0!==n.moduleName)return n.moduleName;if(!n){if(r.tracker.trackReferencedAmbientModule){var a=e.filter(t.declarations,e.isAmbientModule);if(e.length(a))for(var s=0,c=a;s<c.length;s++){var l=c[s];r.tracker.trackReferencedAmbientModule(l,t)}}if(u.test(t.escapedName))return t.escapedName.substring(1,t.escapedName.length-1)}if(!r.enclosingDeclaration||!r.tracker.moduleResolverHost)return u.test(t.escapedName)?t.escapedName.substring(1,t.escapedName.length-1):e.getSourceFileOfNode(e.getNonAugmentationDeclaration(t)).fileName;var _=e.getSourceFileOfNode(e.getOriginalNode(r.enclosingDeclaration)),d=I(t),p=d.specifierCache&&d.specifierCache.get(_.path);if(!p){var f=xT.out||xT.outFile,m=r.tracker.moduleResolverHost,g=f?i({},xT,{baseUrl:m.getCommonSourceDirectory()}):xT;p=e.first(e.moduleSpecifiers.getModuleSpecifiers(t,g,_,m,o.getSourceFiles(),{importModuleSpecifierPreference:f?"non-relative":"relative"},o.redirectTargetsMap)),d.specifierCache=d.specifierCache||e.createMap(),d.specifierCache.set(_.path,p)}return p}function C(t,r,n,i){function a(t,n,o){var s=n===t.length-1?i:b(t,n,r),c=t[n];0===n&&(r.flags|=16777216);var u=Br(c,r);r.approximateLength+=u.length+1,0===n&&(r.flags^=16777216);var l=t[n-1];if(!(16&r.flags)&&l&&Ji(l)&&Ji(l).get(c.escapedName)===c){var _=a(t,n-1,o);return e.isIndexedAccessTypeNode(_)?e.createIndexedAccessTypeNode(_,e.createLiteralTypeNode(e.createLiteral(u))):e.createIndexedAccessTypeNode(e.createTypeReferenceNode(_,s),e.createLiteralTypeNode(e.createLiteral(u)))}var d=e.setEmitFlags(e.createIdentifier(u,s),16777216);if(d.symbol=c,n>o){var _=a(t,n-1,o);return e.isEntityName(_)?e.createQualifiedName(_,d):e.Debug.fail("Impossible construct - an export of an indexed access cannot be reachable")}return d}var o=y(t,r,n,!(16384&r.flags)),s=67220415===n;if(e.some(o[0].declarations,Dr)){var c=o.length>1?a(o,o.length-1,1):void 0,u=i||b(o,0,r),l=S(o[0],r);!(67108864&r.flags)&&e.getEmitModuleResolutionKind(xT)===e.ModuleResolutionKind.NodeJs&&l.indexOf("/node_modules/")>=0&&(r.encounteredError=!0,r.tracker.reportLikelyUnsafeImportRequiredError&&r.tracker.reportLikelyUnsafeImportRequiredError(l));var _=e.createLiteralTypeNode(e.createLiteral(l));if(r.tracker.trackExternalModuleSymbolOfImportTypeNode&&r.tracker.trackExternalModuleSymbolOfImportTypeNode(o[0]),r.approximateLength+=l.length+10,!c||e.isEntityName(c)){if(c){var d=e.isIdentifier(c)?c:c.right;d.typeArguments=void 0}return e.createImportTypeNode(_,c,u,s)}var p=x(c),f=p.objectType.typeName;return e.createIndexedAccessTypeNode(e.createImportTypeNode(_,f,u,s),p.indexType)}var m=a(o,o.length-1,0);if(e.isIndexedAccessTypeNode(m))return m;if(s)return e.createTypeQueryNode(m);var d=e.isIdentifier(m)?m:m.right,g=d.typeArguments;return d.typeArguments=void 0,e.createTypeReferenceNode(m,g)}function k(t,r,n,i){function a(t,n){var i=b(t,n,r),o=t[n];0===n&&(r.flags|=16777216);var s=Br(o,r);0===n&&(r.flags^=16777216);var c=e.setEmitFlags(e.createIdentifier(s,i),16777216);return c.symbol=o,n>0?e.createQualifiedName(a(t,n-1),c):c}var o=y(t,r,n);return!i||1===o.length||r.encounteredError||65536&r.flags||(r.encounteredError=!0),a(o,o.length-1)}function T(t,r,n){function i(t,n){var a=b(t,n,r),o=t[n];if(e.some(o.declarations,Dr))return e.createLiteral(S(o,r));0===n&&(r.flags|=16777216);var s=Br(o,r);0===n&&(r.flags^=16777216);var c=s.charCodeAt(0),u=e.isIdentifierStart(c,DT);if(0===n||u){var l=e.setEmitFlags(e.createIdentifier(s,a),16777216);return l.symbol=o,n>0?e.createPropertyAccess(i(t,n-1),l):l}91===c&&(s=s.substring(1,s.length-1),c=s.charCodeAt(0));var _=void 0;return e.isSingleOrDoubleQuote(c)?(_=e.createLiteral(s.substring(1,s.length-1).replace(/\\./g,function(e){return e.substring(1)})),_.singleQuote=39===c):""+ +s===s&&(_=e.createLiteral(+s)),_||(_=e.setEmitFlags(e.createIdentifier(s,a),16777216),_.symbol=o),e.createElementAccess(i(t,n-1),_)}var a=y(t,r,n);return i(a,a.length-1)}return{typeToTypeNode:function(e,r,n,i){return t(r,n,i,function(t){return a(e,t)})},indexInfoToIndexSignatureDeclaration:function(e,r,n,i,a){return t(n,i,a,function(t){return _(e,r,t)})},signatureToSignatureDeclaration:function(e,r,n,i,a){return t(n,i,a,function(t){return d(e,r,t)})},symbolToEntityName:function(e,r,n,i,a){return t(n,i,a,function(t){return k(e,t,r,!1)})},symbolToExpression:function(e,r,n,i,a){return t(n,i,a,function(t){return T(e,t,r)})},symbolToTypeParameterDeclarations:function(e,r,n,i){return t(r,n,i,function(t){return h(e,t)})},symbolToParameterDeclaration:function(e,r,n,i){return t(r,n,i,function(t){return g(e,t)})},typeParameterToDeclaration:function(e,r,n,i){return t(r,n,i,function(t){return m(e,t)})}}}function Pr(t,r,n,i){function a(i){var a=e.createTypePredicateNode(1===t.kind?e.createIdentifier(t.parameterName):e.createThisTypeNode(),OT.typeToTypeNode(t.type,r,70221824|Ar(n)|512)),o=e.createPrinter({removeComments:!0}),s=r&&e.getSourceFileOfNode(r);return o.writeNode(4,a,s,i),i}return void 0===n&&(n=16384),i?a(i).getText():e.usingSingleLineStringWriter(a)}function wr(e){for(var t=[],r=0,n=0;n<e.length;n++){var i=e[n];if(r|=i.flags,!(98304&i.flags)){if(1536&i.flags){var a=512&i.flags?fE:mi(i);if(1048576&a.flags){var o=a.types.length;if(n+o<=e.length&&Pu(e[n+o-1])===Pu(a.types[o-1])){t.push(a),n+=o-1;continue}}}t.push(i)}}return 65536&r&&t.push(aE),32768&r&&t.push(nE),t||e}function Ir(e){return 8===e?"private":16===e?"protected":"public"}function Or(t){if(t.symbol&&2048&t.symbol.flags){var r=e.findAncestor(t.symbol.declarations[0].parent,function(e){return 178!==e.kind});if(243===r.kind)return Ht(r)}return void 0}function Mr(t){return t&&t.parent&&246===t.parent.kind&&e.isExternalModuleAugmentation(t.parent.parent)}function Lr(t){return 285===t.kind||e.isAmbientModule(t)}function Rr(t,r){var n=t.nameType;if(n){if(384&n.flags){var i=""+n.value;return e.isIdentifierText(i,xT.target)||ig(i)?i:'"'+e.escapeString(i,34)+'"'}if(8192&n.flags)return"["+Br(n.symbol,r)+"]"}}function Br(t,r){if(!(!r||"default"!==t.escapedName||16384&r.flags||16777216&r.flags&&t.declarations&&(!r.enclosingDeclaration||e.findAncestor(t.declarations[0],Lr)===e.findAncestor(r.enclosingDeclaration,Lr))))return"default";if(t.declarations&&t.declarations.length){var n=t.declarations[0],i=e.getNameOfDeclaration(n);if(i){if(e.isCallExpression(n)&&e.isBindableObjectDefinePropertyCall(n))return e.symbolName(t);if(e.isComputedPropertyName(i)&&!(4096&e.getCheckFlags(t))&&t.nameType&&384&t.nameType.flags){var a=Rr(t,r);if(void 0!==a)return a}return e.declarationNameToString(i)}if(n.parent&&238===n.parent.kind)return e.declarationNameToString(n.parent.name);switch(n.kind){case 210:case 197:case 198:return!r||r.encounteredError||131072&r.flags||(r.encounteredError=!0),210===n.kind?"(Anonymous class)":"(Anonymous function)"}}var o=Rr(t,r);return void 0!==o?o:e.symbolName(t)}function jr(t){function r(){switch(t.kind){case 303:case 310:return!!(t.parent&&t.parent.parent&&t.parent.parent.parent&&e.isSourceFile(t.parent.parent.parent));case 187:return jr(t.parent.parent);case 238:if(e.isBindingPattern(t.name)&&!t.name.elements.length)return!1;case 245:case 241:case 242:case 243:case 240:case 244:case 249:if(e.isExternalModuleAugmentation(t))return!0;var r=qr(t);return 1&e.getCombinedModifierFlags(t)||249!==t.kind&&285!==r.kind&&4194304&r.flags?jr(r):M(r);case 155:case 154:case 159:case 160:case 157:case 156:if(e.hasModifier(t,24))return!1;case 158:case 162:case 161:case 163:case 152:case 246:case 166:case 167:case 169:case 165:case 170:case 171:case 174:case 175:case 178:return jr(t.parent);case 251:case 252:case 254:return!1;case 151:case 285:case 248:return!0;case 255:return!1;default:return!1}}if(t){var n=O(t);return void 0===n.isVisible&&(n.isVisible=!!r()),n.isVisible}return!1}function Jr(t,r){function n(t){e.forEach(t,function(t){var i=tt(t)||t;if(r?O(t).isVisible=!0:(a=a||[],e.pushIfUnique(a,i)),e.isInternalModuleImportEqualsDeclaration(t)){var o=t.moduleReference,s=iS(o),c=j(t,s.escapedText,68009983,void 0,void 0,!1);c&&n(c.declarations)}})}var i;t.parent&&255===t.parent.kind?i=j(t,t.escapedText,70107135,void 0,t,!1):258===t.parent.kind&&(i=mt(t.parent,70107135));var a;return i&&n(i.declarations),a}function zr(e,t){var r=Vr(e,t);if(r>=0){for(var n=LN.length,i=r;n>i;i++)RN[i]=!1;return!1}return LN.push(e),RN.push(!0),BN.push(t),!0}function Vr(e,t){for(var r=LN.length-1;r>=0;r--){if(Ur(LN[r],BN[r]))return-1;if(LN[r]===e&&BN[r]===t)return r}return-1}function Ur(t,r){switch(r){case 0:return!!I(t).type;case 5:return!!O(t).resolvedEnumType;case 2:return!!I(t).declaredType;case 1:return!!t.resolvedBaseConstructorType;case 3:return!!t.resolvedReturnType;case 4:return!!t.immediateBaseConstraint;case 6:return!!I(t).resolvedJSDocType}return e.Debug.assertNever(r)}function Kr(){return LN.pop(),BN.pop(),RN.pop()}function qr(t){return e.findAncestor(e.getRootDeclaration(t),function(e){switch(e.kind){case 238:case 239:case 254:case 253:case 252:case 251:return!1;
default:return!0}}).parent}function Wr(t){var r=bi(Gt(t));return r.typeParameters?os(r,e.map(r.typeParameters,function(){return ZT})):r}function Hr(e,t){var r=ao(e,t);return r?Un(r):void 0}function Gr(e,t){return Hr(e,t)||ig(t)&&_o(e,1)||_o(e,0)||rE}function Qr(e){return e&&0!==(1&e.flags)}function Xr(e){var t=Ht(e);return t&&I(t).type||_n(e,!1)}function Yr(t){return 150===t.kind&&!e.isStringOrNumericLiteralLike(t.expression)}function Zr(t,r,n){if(t=cf(t,function(e){return!(98304&e.flags)}),131072&t.flags)return kE;if(1048576&t.flags)return lf(t,function(e){return Zr(e,r,n)});var i=Dc(e.map(r,Rc));if(Xc(t)||Yc(i)){if(131072&i.flags)return t;var a=Xs();return a?ls(a,[t,i]):tE}for(var o=e.createSymbolTable(),s=0,c=Pa(t);s<c.length;s++){var u=c[s];Pl(jc(u,8576),i)||24&e.getDeclarationModifierFlagsFromSymbol(u)||!Tu(u)||o.set(u.escapedName,Eu(u,!1))}var l=lo(t,0),_=lo(t,1);return lr(n,o,e.emptyArray,e.emptyArray,l,_)}function $r(e,t){var r=en(e);return r?Af(r,t):t}function en(t){var r=tn(t);if(r&&r.flowNode){var n=rn(t);if(n){var i=e.createNode(191,t.pos,t.end);i.parent=t,i.expression=r;var a=e.createNode(10,t.pos,t.end);return a.parent=i,a.text=n,i.argumentExpression=a,i.flowNode=r.flowNode,i}}}function tn(e){var t=e.parent.parent;switch(t.kind){case 187:case 276:return en(t);case 188:return en(e.parent);case 238:return t.initializer;case 205:return t.right}}function rn(e){var t=e.parent;return 187===e.kind&&185===t.kind?nn(e.propertyName||e.name):276===e.kind||277===e.kind?nn(e.name):""+t.elements.indexOf(e)}function nn(e){var t=Rc(e);return 384&t.flags?""+t.value:void 0}function an(t){var r=t.parent,n=Xr(r.parent);if(!n||Qr(n))return n;kT&&4194304&t.flags&&e.isParameterDeclaration(t)&&(n=fd(n));var i;if(185===r.kind)if(t.dotDotDotToken){if(2&n.flags||!ug(n))return y(t,e.Diagnostics.Rest_types_may_only_be_created_from_object_types),tE;for(var a=[],o=0,s=r.elements;o<s.length;o++){var c=s[o];c.dotDotDotToken||a.push(c.propertyName||c.name)}i=Zr(n,a,t.symbol)}else{var u=t.propertyName||t.name,l=Rc(u),_=jf(ou(n,l,u),t.name);i=$r(t,_)}else{var d=pD(n,r,!1,!1),p=r.elements.indexOf(t);if(t.dotDotDotToken)i=sf(n,td)?lf(n,function(e){return _c(e,p)}):ic(d);else if(U_(n)){var l=Iu(p),_=jf(ou(n,l,t.name),t.name);i=$r(t,_)}else i=d}return!kT||!t.initializer||32768&sd(rb(t))||(i=Ip(i,524288)),t.initializer&&!e.getEffectiveTypeAnnotationNode(e.walkUpBindingElementsAndPatterns(t))?Dc([i,rb(t)],2):i}function on(t){var r=e.getJSDocType(t);return r?ju(r):void 0}function sn(t){var r=e.skipParentheses(t);return 97===r.kind||73===r.kind&&pp(r)===LT}function cn(t){var r=e.skipParentheses(t);return 188===r.kind&&0===r.elements.length}function un(e,t){return void 0===t&&(t=!0),kT&&t?dd(e):e}function ln(e){return 152===e.kind&&(197===e.parent.kind||198===e.parent.kind)&&!!Rm(e.parent)}function _n(t,r){if(e.isVariableDeclaration(t)&&227===t.parent.parent.kind){var n=Vc(Hg(yb(t.parent.parent.expression)));return 4456448&n.flags?Uc(n):sE}if(e.isVariableDeclaration(t)&&228===t.parent.parent.kind){var i=t.parent.parent;return dD(i.expression,i.awaitModifier)||ZT}if(e.isBindingPattern(t.parent))return an(t);var a=r&&(e.isParameter(t)&&go(t)||!e.isBindingElement(t)&&!e.isVariableDeclaration(t)&&!!t.questionToken),o=Tn(t);if(o)return un(o,a);if(!(!AT&&!e.isInJSFile(t)||238!==t.kind||e.isBindingPattern(t.name)||1&e.getCombinedModifierFlags(t)||4194304&t.flags)){if(!(2&e.getCombinedNodeFlags(t)||t.initializer&&!sn(t.initializer)))return $T;if(t.initializer&&cn(t.initializer))return ZE}if(152===t.kind){var s=t.parent;if(160===s.kind&&!Oi(s)){var c=e.getDeclarationOfKind(Ht(t.parent),159);if(c){var u=Co(c),l=Ek(s);return l&&t===l?(e.Debug.assert(!l.type),Un(u.thisParameter)):Mo(u)}}if(e.isInJSFile(t)){var _=e.getJSDocType(s);if(_&&e.isFunctionTypeNode(_))return Uy(Co(_),s.parameters.indexOf(t))}var d="this"===t.symbol.escapedName?sm(s):cm(t);if(d)return un(d,a)}else if(e.isInJSFile(t)){var p=pn(t,Ht(t),e.getDeclaredExpandoInitializer(t));if(p)return p}if(t.initializer&&!ln(t)){var d=rb(t);return un(d,a)}return e.isJsxAttribute(t)?dE:e.isBindingPattern(t.name)&&!ln(t)?Dn(t.name,!1,!0):void 0}function dn(t,r){var n=e.getAssignedExpandoInitializer(t.valueDeclaration);if(n){var i=e.getJSDocTypeTag(n);if(i&&i.typeExpression)return ju(i.typeExpression);var a=pn(t.valueDeclaration,t,n);return a||Z_(eb(n))}for(var o,s,c=!1,u=!1,l=0,_=t.declarations;l<_.length;l++){var d=_[l],p=e.isBinaryExpression(d)||e.isCallExpression(d)?d:e.isPropertyAccessExpression(d)?e.isBinaryExpression(d.parent)?d.parent:d:void 0;if(!p)return tE;var f=e.isPropertyAccessExpression(p)?e.getAssignmentDeclarationPropertyAccessKind(p):e.getAssignmentDeclarationKind(p);4===f&&(gn(p)?c=!0:u=!0),e.isCallExpression(p)||(o=fn(o,p,t,d)),o||(s||(s=[])).push(e.isBinaryExpression(p)||e.isCallExpression(p)?mn(t,r,p,f):vE)}var m=o;if(!m){var g=c?vn(s,t.declarations):void 0;if(u){var v=yn(t);v&&((g||(g=[])).push(v),c=!0)}var y=e.some(g,function(e){return!!(-98305&e.flags)})?g:s;m=Dc(y,2)}var h=Td(un(m,u&&!c));return cf(h,function(e){return!!(-98305&e.flags)})===vE?(Ad(t.valueDeclaration,ZT),ZT):h}function pn(t,r,n){if(!e.isInJSFile(t)||!n||!e.isObjectLiteralExpression(n)||n.properties.length)return void 0;for(var i=e.createSymbolTable();e.isBinaryExpression(t)||e.isPropertyAccessExpression(t);){var a=Ht(t);a&&e.hasEntries(a.exports)&&F(i,a.exports),t=e.isBinaryExpression(t)?t.parent:t.parent.parent}var o=Ht(t);o&&e.hasEntries(o.exports)&&F(i,o.exports);var s=lr(r,i,e.emptyArray,e.emptyArray,void 0,void 0);return s.objectFlags|=16384,s}function fn(t,r,n,i){var a=e.getJSDocType(r.parent);if(a){var o=Td(ju(a));if(!t)return o;t===tE||o===tE||Tl(t,o)||Zx(void 0,t,i,o)}return t}function mn(t,r,n,i){if(e.isCallExpression(n)){if(r)return Un(r);var a=eb(n.arguments[2]),o=Hr(a,"value");if(o)return o;var s=Hr(a,"get");if(s){var c=Pv(s);if(c)return Mo(c)}var u=Hr(a,"set");if(u){var l=Pv(u);if(l)return Yy(l)}return ZT}var _=r?Un(r):Z_(eb(n.right));if(524288&_.flags&&2===i&&"export="===t.escapedName){var d=Ta(_),p=e.createSymbolTable();e.copyEntries(d.members,p),r&&!r.exports&&(r.exports=e.createSymbolTable()),(r||t).exports.forEach(function(e,t){if(p.has(t)){var r=d.members.get(t),n=x(e.flags|r.flags,t);n.type=Dc([Un(e),Un(r)]),p.set(t,n)}else p.set(t,e)});var f=lr(d.symbol,p,d.callSignatures,d.constructSignatures,d.stringIndexInfo,d.numberIndexInfo);return f.objectFlags|=16384&e.getObjectFlags(_),f}return K_(_)?(Ad(n,YE),YE):_}function gn(t){var r=e.getThisContainer(t,!1);return 158===r.kind||240===r.kind||197===r.kind&&!e.isPrototypePropertyAssignment(r.parent)}function vn(t,r){return e.Debug.assert(t.length===r.length),t.filter(function(t,n){var i=r[n],a=e.isBinaryExpression(i)?i:e.isBinaryExpression(i.parent)?i.parent:void 0;return a&&gn(a)})}function yn(t){var r=e.forEach(t.declarations,function(t){var r=e.getThisContainer(t,!1).parent;return e.isClassLike(r)&&r});if(r){var n=bi(Ht(r)),i=n&&ii(n)[0];if(i)return Hr(i,t.escapedName)}}function hn(t,r,n){return t.initializer?un(rb(t)):e.isBindingPattern(t.name)?Dn(t.name,r,n):(n&&!kn(t)&&Ad(t,ZT),ZT)}function bn(t,r,n){var i,a=e.createSymbolTable(),o=262272;e.forEach(t.elements,function(e){var t=e.propertyName||e.name;if(e.dotDotDotToken)return void(i=Zo(ZT,!1));var s=Rc(t);if(!Fi(s))return void(o|=512);var c=Li(s),u=4|(e.initializer?16777216:0),l=x(u,c);l.type=hn(e,r,n),l.bindingElement=e,a.set(l.escapedName,l)});var s=lr(void 0,a,e.emptyArray,e.emptyArray,i,void 0);return s.objectFlags|=o,r&&(s.pattern=t),s}function xn(t,r,n){var i=t.elements,a=e.lastOrUndefined(i),o=!(!a||187!==a.kind||!a.dotDotDotToken);if(0===i.length||1===i.length&&o)return DT>=2?rc(ZT):YE;var s=e.map(i,function(t){return e.isOmittedExpression(t)?ZT:hn(t,r,n)}),c=e.findLastIndex(i,function(t){return!e.isOmittedExpression(t)&&!Zm(t)},i.length-(o?2:1))+1,u=uc(s,c,o);return r&&(u=ss(u),u.pattern=t),u}function Dn(e,t,r){return void 0===t&&(t=!1),void 0===r&&(r=!1),185===e.kind?bn(e,t,r):xn(e,t,r)}function Sn(e,t){return Cn(_n(e,!0),e,t)}function Cn(t,r,n){return t?(n&&Fd(r,t),8192&t.flags&&(e.isBindingElement(r)||!r.type)&&t.symbol!==Ht(r)&&(t=mE),Td(t)):(t=e.isParameter(r)&&r.dotDotDotToken?YE:ZT,n&&(kn(r)||Ad(r,t)),t)}function kn(t){var r=e.getRootDeclaration(t),n=152===r.kind?r.parent:r;return rx(n)}function Tn(t){var r=e.getEffectiveTypeAnnotationNode(t);return r?ju(r):void 0}function En(e){var t=I(e);if(!t.type){var r=Nn(e);t.type||(t.type=r)}return t.type}function Nn(t){if(4194304&t.flags)return Wr(t);if(t===JT)return ZT;if(134217728&t.flags){var r=Ht(e.getSourceFileOfNode(t.valueDeclaration)),n=e.createSymbolTable();return n.set("exports",r),lr(t,n,e.emptyArray,e.emptyArray,void 0,void 0)}var i=t.valueDeclaration;if(e.isCatchClauseVariableDeclarationOrBindingElement(i))return ZT;if(e.isSourceFile(i)&&e.isJsonSourceFile(i)){if(!i.statements.length)return kE;var a=Z_(yb(i.statements[0].expression));return 524288&a.flags?hd(a):a}if(!zr(t,0))return 512&t.flags?Ln(t):zn(t);var o;if(255===i.kind)o=Cn(eb(i.expression),i);else if(e.isInJSFile(i)&&(e.isCallExpression(i)||e.isBinaryExpression(i)||e.isPropertyAccessExpression(i)&&e.isBinaryExpression(i.parent)))o=dn(t);else if(e.isJSDocPropertyLikeTag(i)||e.isPropertyAccessExpression(i)||e.isIdentifier(i)||e.isClassDeclaration(i)||e.isFunctionDeclaration(i)||e.isMethodDeclaration(i)&&!e.isObjectLiteralMethod(i)||e.isMethodSignature(i)||e.isSourceFile(i)){if(9136&t.flags)return Ln(t);o=e.isBinaryExpression(i.parent)?dn(t):Tn(i)||ZT}else if(e.isPropertyAssignment(i))o=Tn(i)||ob(i);else if(e.isJsxAttribute(i))o=Tn(i)||vg(i);else if(e.isShorthandPropertyAssignment(i))o=Tn(i)||ab(i.name,0);else if(e.isObjectLiteralMethod(i))o=Tn(i)||sb(i,0);else if(e.isParameter(i)||e.isPropertyDeclaration(i)||e.isPropertySignature(i)||e.isVariableDeclaration(i)||e.isBindingElement(i))o=Sn(i,!0);else if(e.isEnumDeclaration(i))o=Ln(t);else{if(!e.isEnumMember(i))return e.Debug.fail("Unhandled declaration kind! "+e.Debug.formatSyntaxKind(i.kind)+" for "+e.Debug.formatSymbol(t));o=Bn(t)}return Kr()?o:512&t.flags?Ln(t):zn(t)}function An(t){if(t){if(159===t.kind){var r=e.getEffectiveReturnTypeNode(t);return r}var n=e.getEffectiveSetAccessorTypeAnnotationNode(t);return n}return void 0}function Fn(e){var t=An(e);return t&&ju(t)}function Pn(e){var t=Ek(e);return t&&t.symbol}function wn(e){return Po(Co(e))}function In(e){var t=I(e);return t.type||(t.type=On(e))}function On(t){var r=e.getDeclarationOfKind(t,159),n=e.getDeclarationOfKind(t,160);if(r&&e.isInJSFile(r)){var i=on(r);if(i)return i}if(!zr(t,0))return tE;var a,o=Fn(r);if(o)a=o;else{var s=Fn(n);s?a=s:r&&r.body?a=oh(r):(n?b(AT,n,e.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation,kr(t)):(e.Debug.assert(!!r,"there must existed getter as we are current checking either setter or getter in this function"),b(AT,r,e.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation,kr(t))),a=ZT)}if(!Kr()&&(a=ZT,AT)){var c=e.getDeclarationOfKind(t,159);y(c,e.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions,kr(t))}return a}function Mn(e){var t=ni(li(e));return 8650752&t.flags?t:void 0}function Ln(t){var r=I(t),n=r;if(!r.type){var i=e.getDeclarationOfExpando(t.valueDeclaration);if(i){var a=Ht(i);a&&(e.hasEntries(a.exports)||e.hasEntries(a.members))&&(t=k(t),r=t,e.hasEntries(a.exports)&&(t.exports=t.exports||e.createSymbolTable(),F(t.exports,a.exports)),e.hasEntries(a.members)&&(t.members=t.members||e.createSymbolTable(),F(t.members,a.members)))}n.type=r.type=Rn(t)}return r.type}function Rn(t){var r=t.valueDeclaration;if(1536&t.flags&&e.isShorthandAmbientModuleSymbol(t))return ZT;if(205===r.kind||190===r.kind&&205===r.parent.kind)return dn(t);if(512&t.flags&&r&&e.isSourceFile(r)&&r.commonJsModuleIndicator){var n=Ot(t);if(n!==t){if(!zr(t,0))return tE;var i=Wt(t.exports.get("export=")),a=dn(i,i===n?void 0:n);return Kr()?a:zn(t)}}var o=ir(16,t);if(32&t.flags){var s=Mn(t);return s?Ic([o,s]):o}return kT&&16777216&t.flags?dd(o):o}function Bn(e){var t=I(e);return t.type||(t.type=vi(e))}function jn(e){var t=I(e);if(!t.type){var r=bt(e);t.type=67220415&r.flags?Un(r):tE}return t.type}function Jn(e){var t=I(e);if(!t.type){if(!zr(e,0))return t.type=tE;var r=gl(Un(t.target),t.mapper);Kr()||(r=zn(e)),t.type=r}return t.type}function zn(t){var r=t.valueDeclaration;return e.getEffectiveTypeAnnotationNode(r)?(y(t.valueDeclaration,e.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation,kr(t)),tE):(AT&&(152!==r.kind||r.initializer)&&y(t.valueDeclaration,e.Diagnostics._0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer,kr(t)),ZT)}function Vn(t){var r=I(t);return r.type||(e.Debug.assertDefined(r.deferralParent),e.Debug.assertDefined(r.deferralConstituents),r.type=1048576&r.deferralParent.flags?Dc(r.deferralConstituents):Ic(r.deferralConstituents)),r.type}function Un(t){return 65536&e.getCheckFlags(t)?Vn(t):1&e.getCheckFlags(t)?Jn(t):8192&e.getCheckFlags(t)?Gd(t):7&t.flags?En(t):9136&t.flags?Ln(t):8&t.flags?Bn(t):98304&t.flags?In(t):2097152&t.flags?jn(t):tE}function Kn(t,r){return void 0!==t&&void 0!==r&&0!==(4&e.getObjectFlags(t))&&t.target===r}function qn(t){return 4&e.getObjectFlags(t)?t.target:t}function Wn(t,r){function n(t){if(7&e.getObjectFlags(t)){var i=qn(t);return i===r||e.some(ii(i),n)}return 2097152&t.flags?e.some(t.types,n):!1}return n(t)}function Hn(t,r){for(var n=0,i=r;n<i.length;n++){var a=i[n];t=e.appendIfUnique(t,yi(Ht(a)))}return t}function Gn(t,r){for(;;){if(t=t.parent,!t)return void 0;switch(t.kind){case 241:case 210:case 242:case 161:case 162:case 156:case 166:case 167:case 295:case 240:case 157:case 197:case 198:case 243:case 309:case 310:case 303:case 182:case 176:var n=Gn(t,r);if(182===t.kind)return e.append(n,yi(Ht(t.typeParameter)));if(176===t.kind)return e.concatenate(n,mu(t));var i=Hn(n,e.getEffectiveTypeParameterDeclarations(t)),a=r&&(241===t.kind||210===t.kind||242===t.kind)&&li(Ht(t)).thisType;return a?e.append(i,a):i}}}function Qn(t){var r=32&t.flags?t.valueDeclaration:e.getDeclarationOfKind(t,242);return Gn(r)}function Xn(t){for(var r,n=0,i=t.declarations;n<i.length;n++){var a=i[n];if(242===a.kind||241===a.kind||210===a.kind||e.isTypeAlias(a)){var o=a;r=Hn(r,e.getEffectiveTypeParameterDeclarations(o))}}return r}function Yn(t){return e.concatenate(Qn(t),Xn(t))}function Zn(e){var t=so(e,1);if(1===t.length){var r=t[0];return!r.typeParameters&&1===r.parameters.length&&r.hasRestParameter&&zy(r.parameters[0])===YE}return!1}function $n(e){if(si(e)&&so(e,1).length>0)return!0;if(8650752&e.flags){var t=Ka(e);return!!t&&si(t)&&Zn(t)}return Sy(e)}function ei(t){return e.getEffectiveBaseTypeNode(t.symbol.valueDeclaration)}function ti(t,r,n){var i=e.length(r),a=e.isInJSFile(n);return e.filter(so(t,1),function(t){return(a||i>=Do(t.typeParameters))&&i<=e.length(t.typeParameters)})}function ri(t,r,n){var i=ti(t,r,n),a=e.map(r,ju);return e.sameMap(i,function(t){return e.some(t.typeParameters)?Jo(t,a,e.isInJSFile(n)):t})}function ni(t){if(!t.resolvedBaseConstructorType){var r=t.symbol.valueDeclaration,n=e.getEffectiveBaseTypeNode(r),i=ei(t);if(!i)return t.resolvedBaseConstructorType=nE;if(!zr(t,1))return tE;var a=yb(i.expression);if(n&&i!==n&&(e.Debug.assert(!n.typeArguments),yb(n.expression)),2621440&a.flags&&Ta(a),!Kr())return y(t.symbol.valueDeclaration,e.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_base_expression,kr(t.symbol)),t.resolvedBaseConstructorType=tE;if(!(1&a.flags||a===oE||$n(a))){var o=y(i.expression,e.Diagnostics.Type_0_is_not_a_constructor_function_type,Er(a));if(262144&a.flags){var s=rs(a),c=rE;if(s){var u=so(s,1);u[0]&&(c=Mo(u[0]))}e.addRelatedInfo(o,e.createDiagnosticForNode(a.symbol.declarations[0],e.Diagnostics.Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1,kr(a.symbol),Er(c)))}return t.resolvedBaseConstructorType=tE}t.resolvedBaseConstructorType=a}return t.resolvedBaseConstructorType}function ii(t){return t.resolvedBaseTypes||(8&t.objectFlags?t.resolvedBaseTypes=[ic(Dc(t.typeParameters||e.emptyArray),t.readonly)]:96&t.symbol.flags?(32&t.symbol.flags&&ai(t),64&t.symbol.flags&&ci(t)):e.Debug.fail("type must be class or interface")),t.resolvedBaseTypes}function ai(t){t.resolvedBaseTypes=e.resolvingEmptyArray;var r=to(ni(t));if(!(2621441&r.flags))return t.resolvedBaseTypes=e.emptyArray;var n,i=ei(t),a=Ts(i),o=Sy(r)?r:r.symbol?bi(r.symbol):void 0;if(r.symbol&&32&r.symbol.flags&&oi(o))n=us(i,r.symbol,a);else if(1&r.flags)n=r;else if(Sy(r))n=!i.typeArguments&&Cy(r.symbol)||ZT;else{var s=ri(r,i.typeArguments,i);if(!s.length)return y(i.expression,e.Diagnostics.No_base_constructor_has_the_specified_number_of_type_arguments),t.resolvedBaseTypes=e.emptyArray;n=Mo(s[0])}return n===tE?t.resolvedBaseTypes=e.emptyArray:si(n)?t===n||Wn(n,t)?(y(t.symbol.valueDeclaration,e.Diagnostics.Type_0_recursively_references_itself_as_a_base_type,Er(t,void 0,2)),t.resolvedBaseTypes=e.emptyArray):(t.resolvedBaseTypes===e.resolvingEmptyArray&&(t.members=void 0),t.resolvedBaseTypes=[n]):(y(i.expression,e.Diagnostics.Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members,Er(n)),t.resolvedBaseTypes=e.emptyArray)}function oi(e){var t=e.outerTypeParameters;if(t){var r=t.length-1,n=e.typeArguments;return t[r].symbol!==n[r].symbol}return!0}function si(t){return!!(67633153&t.flags)&&!ka(t)||!!(2097152&t.flags)&&e.every(t.types,si)}function ci(t){t.resolvedBaseTypes=t.resolvedBaseTypes||e.emptyArray;for(var r=0,n=t.symbol.declarations;r<n.length;r++){var i=n[r];if(242===i.kind&&e.getInterfaceBaseTypeNodes(i))for(var a=0,o=e.getInterfaceBaseTypeNodes(i);a<o.length;a++){var s=o[a],c=ju(s);c!==tE&&(si(c)?t===c||Wn(c,t)?y(i,e.Diagnostics.Type_0_recursively_references_itself_as_a_base_type,Er(t,void 0,2)):t.resolvedBaseTypes===e.emptyArray?t.resolvedBaseTypes=[c]:t.resolvedBaseTypes.push(c):y(s,e.Diagnostics.An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members))}}}function ui(t){for(var r=0,n=t.declarations;r<n.length;r++){var i=n[r];if(242===i.kind){if(64&i.flags)return!1;var a=e.getInterfaceBaseTypeNodes(i);if(a)for(var o=0,s=a;o<s.length;o++){var c=s[o];if(e.isEntityNameExpression(c.expression)){var u=kt(c.expression,67897832,!0);if(!u||!(64&u.flags)||li(u).thisType)return!1}}}}return!0}function li(t){var r=I(t);if(!r.declaredType){var n=32&t.flags?1:2,i=r.declaredType=ir(n,t),a=Qn(t),o=Xn(t);(a||o||1===n||!ui(t))&&(i.objectFlags|=4,i.typeParameters=e.concatenate(a,o),i.outerTypeParameters=a,i.localTypeParameters=o,i.instantiations=e.createMap(),i.instantiations.set(is(i.typeParameters),i),i.target=i,i.typeArguments=i.typeParameters,i.thisType=or(t),i.thisType.isThisType=!0,i.thisType.constraint=i)}return r.declaredType}function _i(t){var r=I(t);if(!r.declaredType){if(!zr(t,2))return tE;var n=e.find(t.declarations,function(t){return e.isJSDocTypeAlias(t)||243===t.kind}),i=e.isJSDocTypeAlias(n)?n.typeExpression:n.type,a=i?ju(i):tE;if(Kr()){var o=Xn(t);o&&(r.typeParameters=o,r.instantiations=e.createMap(),r.instantiations.set(is(o),a))}else a=tE,y(n.name,e.Diagnostics.Type_alias_0_circularly_references_itself,kr(t));r.declaredType=a}return r.declaredType}function di(e){return 10===e.kind?!0:205===e.kind?di(e.left)&&di(e.right):!1}function pi(t){var r=t.initializer;if(!r)return!(4194304&t.flags);switch(r.kind){case 10:case 8:return!0;case 203:return 39===r.operator&&8===r.operand.kind;case 73:return e.nodeIsMissing(r)||!!Ht(t.parent).exports.get(r.escapedText);case 205:return di(r);default:return!1}}function fi(e){var t=I(e);if(void 0!==t.enumKind)return t.enumKind;for(var r=!1,n=0,i=e.declarations;n<i.length;n++){var a=i[n];if(244===a.kind)for(var o=0,s=a.members;o<s.length;o++){var c=s[o];if(c.initializer&&10===c.initializer.kind)return t.enumKind=1;pi(c)||(r=!0)}}return t.enumKind=r?0:1}function mi(e){return 1024&e.flags&&!(1048576&e.flags)?bi(Gt(e.symbol)):e}function gi(e){var t=I(e);if(t.declaredType)return t.declaredType;if(1===fi(e)){gT++;for(var r=[],n=0,i=e.declarations;n<i.length;n++){var a=i[n];if(244===a.kind)for(var o=0,s=a.members;o<s.length;o++){var c=s[o],u=Fu(Iu(EC(c),gT,Ht(c)));I(Ht(c)).declaredType=u,r.push(Pu(u))}}if(r.length){var l=Dc(r,1,e,void 0);return 1048576&l.flags&&(l.flags|=1024,l.symbol=e),t.declaredType=l}}var _=tr(32);return _.symbol=e,t.declaredType=_}function vi(e){var t=I(e);if(!t.declaredType){var r=gi(Gt(e));t.declaredType||(t.declaredType=r)}return t.declaredType}function yi(e){var t=I(e);return t.declaredType||(t.declaredType=or(e))}function hi(e){var t=I(e);return t.declaredType||(t.declaredType=bi(bt(e)))}function bi(e){return xi(e)||tE}function xi(e){return 96&e.flags?li(e):524288&e.flags?_i(e):262144&e.flags?yi(e):384&e.flags?gi(e):8&e.flags?vi(e):2097152&e.flags?hi(e):void 0}function Di(e){switch(e.kind){case 121:case 144:case 139:case 136:case 147:case 124:case 140:case 137:case 107:case 142:case 97:case 133:case 183:return!0;case 170:return Di(e.elementType);case 165:return!e.typeArguments||e.typeArguments.every(Di)}return!1}function Si(t){var r=e.getEffectiveConstraintOfTypeParameter(t);return!r||Di(r)}function Ci(t){var r=e.getEffectiveTypeAnnotationNode(t);return r?Di(r):!e.hasInitializer(t)}function ki(t){var r=e.getEffectiveReturnTypeNode(t),n=e.getEffectiveTypeParameterDeclarations(t);return(158===t.kind||!!r&&Di(r))&&t.parameters.every(Ci)&&n.every(Si)}function Ti(e){if(e.declarations&&1===e.declarations.length){var t=e.declarations[0];if(t)switch(t.kind){case 155:case 154:return Ci(t);case 157:case 156:case 158:case 159:case 160:return ki(t)}}return!1}function Ei(t,r,n){for(var i=e.createSymbolTable(),a=0,o=t;a<o.length;a++){var s=o[a];i.set(s.escapedName,n&&Ti(s)?s:nl(s,r))}return i}function Ni(e,t){for(var r=0,n=t;r<n.length;r++){var i=n[r];e.has(i.escapedName)||e.set(i.escapedName,i)}}function Ai(t){if(!t.declaredProperties){var r=t.symbol,n=Ji(r);t.declaredProperties=cr(n),t.declaredCallSignatures=e.emptyArray,t.declaredConstructSignatures=e.emptyArray,t.declaredCallSignatures=Ao(n.get("__call")),t.declaredConstructSignatures=Ao(n.get("__new")),t.declaredStringIndexInfo=$o(r,0),t.declaredNumberIndexInfo=$o(r,1)}return t}function Fi(e){return!!(8576&e.flags)}function Pi(t){return e.isComputedPropertyName(t)&&e.isEntityNameExpression(t.expression)&&Fi(ag(t))}function wi(e){return 95===e.charCodeAt(0)&&95===e.charCodeAt(1)&&64===e.charCodeAt(2)}function Ii(t){var r=e.getNameOfDeclaration(t);return!!r&&Pi(r)}function Oi(t){return e.hasDynamicName(t)&&!Ii(t)}function Mi(t){return e.isDynamicName(t)&&!Pi(t)}function Li(t){return 8192&t.flags?t.escapedName:384&t.flags?e.escapeLeadingUnderscores(""+t.value):e.Debug.fail()}function Ri(t,r,n){e.Debug.assert(!!(4096&e.getCheckFlags(t)),"Expected a late-bound symbol."),t.flags|=n,I(r.symbol).lateSymbol=t,t.declarations?t.declarations.push(r):t.declarations=[r],67220415&n&&(t.valueDeclaration&&t.valueDeclaration.kind===r.kind||(t.valueDeclaration=r))}function Bi(t,r,n,i){e.Debug.assert(!!i.symbol,"The member is expected to have a symbol.");var a=O(i);if(!a.resolvedSymbol){a.resolvedSymbol=i.symbol;var o=ag(i.name);if(Fi(o)){var s=Li(o),c=i.symbol.flags,u=n.get(s);u||n.set(s,u=x(0,s,4096));var l=r&&r.get(s);if(u.flags&S(c)||l){var _=l?e.concatenate(l.declarations,u.declarations):u.declarations,d=!(8192&o.flags)&&e.unescapeLeadingUnderscores(s)||e.declarationNameToString(i.name);e.forEach(_,function(t){return y(e.getNameOfDeclaration(t)||t,e.Diagnostics.Property_0_was_also_declared_here,d)}),y(i.name||i,e.Diagnostics.Duplicate_property_0,d),u=x(0,s,4096)}return u.nameType=o,Ri(u,i,c),u.parent?e.Debug.assert(u.parent===t,"Existing symbol parent should match new one"):u.parent=t,a.resolvedSymbol=u}}return a.resolvedSymbol}function ji(t,r){var n=I(t);if(!n[r]){var i="resolvedExports"===r,a=i?1536&t.flags?qt(t):t.exports:t.members;n[r]=a||hT;for(var o=e.createSymbolTable(),s=0,c=t.declarations;s<c.length;s++){var u=c[s],l=e.getMembersOfDeclaration(u);if(l)for(var _=0,d=l;_<d.length;_++){var p=d[_];i===e.hasStaticModifier(p)&&Ii(p)&&Bi(t,a,o,p)}}n[r]=A(a,o)||hT}return n[r]}function Ji(e){return 6240&e.flags?ji(e,"resolvedMembers"):e.members||hT}function zi(t){if(106500&t.flags&&"__computed"===t.escapedName){var r=I(t);if(!r.lateSymbol&&e.some(t.declarations,Ii)){var n=Wt(t.parent);e.some(t.declarations,e.hasStaticModifier)?Vt(n):Ji(n)}return r.lateSymbol||(r.lateSymbol=t)}return t}function Vi(t,r,n){if(4&e.getObjectFlags(t)){var i=t.target,a=t.typeArguments;if(e.length(i.typeParameters)===e.length(a)){var o=os(i,e.concatenate(a,[r||i.thisType]));return n?to(o):o}}else if(2097152&t.flags)return Ic(e.map(t.types,function(e){return Vi(e,r,n)}));return n?to(t):t}function Ui(t,r,n,i){var a,o,s,c,u,l;e.rangeEquals(n,i,0,n.length)?(a=bT,o=r.symbol?Ji(r.symbol):e.createSymbolTable(r.declaredProperties),s=r.declaredCallSignatures,c=r.declaredConstructSignatures,u=r.declaredStringIndexInfo,l=r.declaredNumberIndexInfo):(a=Wu(n,i),o=Ei(r.declaredProperties,a,1===n.length),s=Vu(r.declaredCallSignatures,a),c=Vu(r.declaredConstructSignatures,a),u=bl(r.declaredStringIndexInfo,a),l=bl(r.declaredNumberIndexInfo,a));var _=ii(r);if(_.length){r.symbol&&o===Ji(r.symbol)&&(o=e.createSymbolTable(r.declaredProperties)),ur(t,o,s,c,u,l);for(var d=e.lastOrUndefined(i),p=0,f=_;p<f.length;p++){var m=f[p],g=d?Vi(gl(m,a),d):m;Ni(o,Pa(g)),s=e.concatenate(s,so(g,0)),c=e.concatenate(c,so(g,1)),u||(u=g===ZT?Zo(ZT,!1):lo(g,0)),l=l||lo(g,1)}}ur(t,o,s,c,u,l)}function Ki(t){Ui(t,Ai(t),e.emptyArray,e.emptyArray)}function qi(t){var r=Ai(t.target),n=e.concatenate(r.typeParameters,[r.thisType]),i=t.typeArguments&&t.typeArguments.length===n.length?t.typeArguments:e.concatenate(t.typeArguments,[t]);Ui(t,r,n,i)}function Wi(e,t,r,n,i,a,o,s,c){var u=new pT(zT);return u.declaration=e,u.typeParameters=t,u.parameters=n,u.thisParameter=r,u.resolvedReturnType=i,u.resolvedTypePredicate=a,u.minArgumentCount=o,u.hasRestParameter=s,u.hasLiteralTypes=c,u.target=void 0,u.mapper=void 0,u}function Hi(e){var t=Wi(e.declaration,e.typeParameters,e.thisParameter,e.parameters,void 0,void 0,e.minArgumentCount,e.hasRestParameter,e.hasLiteralTypes);return t.target=e.target,t.mapper=e.mapper,t}function Gi(e,t){var r=Hi(e);return r.unionSignatures=t,r.target=void 0,r.mapper=void 0,r}function Qi(t){if(t.hasRestParameter){var r=t.parameters.length-1,n=t.parameters[r],i=Un(n);if(td(i)){var a=i.typeArguments||e.emptyArray,o=i.target.minLength,s=i.target.hasRestElement?a.length-1:-1,c=e.map(a,function(e,n){var i=Vy(t,r+n),a=n===s?32768:n>=o?16384:0,c=x(1,i,a);return c.type=n===s?ic(e):e,c});return e.concatenate(t.parameters.slice(0,r),c)}}return t.parameters}function Xi(t){var r=ni(t),n=so(r,1);if(0===n.length)return[Wi(void 0,t.localTypeParameters,void 0,e.emptyArray,t,void 0,0,!1,!1)];for(var i=ei(t),a=e.isInJSFile(i),o=Ts(i),s=e.length(o),c=[],u=0,l=n;u<l.length;u++){var _=l[u],d=Do(_.typeParameters),p=e.length(_.typeParameters);if(a||s>=d&&p>=s){var f=p?Vo(_,So(o,_.typeParameters,d,a)):Hi(_);f.typeParameters=t.localTypeParameters,f.resolvedReturnType=t,c.push(f)}}return c}function Yi(e,t,r,n,i){for(var a=0,o=e;a<o.length;a++){var s=o[a];if(O_(s,t,r,n,i,r?Al:El))return s}}function Zi(t,r,n){if(r.typeParameters){if(n>0)return void 0;for(var i=1;i<t.length;i++)if(!Yi(t[i],r,!1,!1,!1))return void 0;return[r]}for(var a,i=0;i<t.length;i++){var o=i===n?r:Yi(t[i],r,!0,!0,!0);if(!o)return void 0;a=e.appendIfUnique(a,o)}return a}function $i(t){for(var r,n,i=0;i<t.length;i++){if(0===t[i].length)return e.emptyArray;t[i].length>1&&(n=void 0===n?i:-1);for(var a=0,o=t[i];a<o.length;a++){var s=o[a];if(!r||!Yi(r,s,!1,!0,!0)){var c=Zi(t,s,i);if(c){var u=s;if(c.length>1){var l=s.thisParameter,_=e.forEach(c,function(e){return e.thisParameter});if(_){var d=Dc(e.map(c,function(e){return e.thisParameter?Un(e.thisParameter):ZT}),2);l=vd(_,d)}u=Gi(s,c),u.thisParameter=l}(r||(r=[])).push(u)}}}}if(!e.length(r)&&-1!==n){for(var p=t[void 0!==n?n:0],f=p.slice(),m=function(t){if(t!==p){var r=t[0];if(e.Debug.assert(!!r,"getUnionSignatures bails early on empty signature lists and should not have empty lists on second pass"),f=r.typeParameters&&e.some(f,function(e){return!!e.typeParameters})?void 0:e.map(f,function(e){return ra(e,r)}),!f)return"break"}},g=0,v=t;g<v.length;g++){var y=v[g],h=m(y);if("break"===h)break}r=f}return r||e.emptyArray}function ea(e,t){if(!e||!t)return e||t;var r=Dc([Un(e),Un(t)],2);return vd(e,r)}function ta(e,t){for(var r=Wy(e)>=Wy(t)?e:t,n=r===e?t:e,i=Wy(r),a=Gy(e)||Gy(t),o=a&&!Gy(r),s=new Array(i+(o?1:0)),c=0;i>c;c++){var u=Ky(r,c),l=Ky(n,c)||rE,_=Ic([u,l]),d=a&&!o&&c===i-1,p=c>=Hy(r)&&c>=Hy(n),f=Vy(e,c),m=Vy(t,c),g=x(1|(p&&!d?16777216:0),f===m?f:"arg"+c);g.type=d?ic(_):_,s[c]=g}if(o){var v=x(1,"args");v.type=ic(Uy(n,i)),s[i]=v}return s}function ra(t,r){var n=t.declaration,i=ta(t,r),a=ea(t.thisParameter,r.thisParameter),o=Math.max(t.minArgumentCount,r.minArgumentCount),s=t.hasRestParameter||r.hasRestParameter,c=t.hasLiteralTypes||r.hasLiteralTypes,u=Wi(n,t.typeParameters||r.typeParameters,a,i,void 0,void 0,o,s,c);return u.unionSignatures=e.concatenate(t.unionSignatures||[t],[r]),u}function na(e,t){for(var r=[],n=!1,i=0,a=e;i<a.length;i++){var o=a[i],s=lo(o,t);if(!s)return void 0;r.push(s.type),n=n||s.isReadonly}return Zo(Dc(r,2),n)}function ia(t){var r=$i(e.map(t.types,function(e){return e===zE?[SN]:so(e,0)})),n=$i(e.map(t.types,function(e){return so(e,1)})),i=na(t.types,0),a=na(t.types,1);ur(t,hT,r,n,i,a)}function aa(e,t){return e?t?Ic([e,t]):e:t}function oa(e,t){return e?t?Zo(Ic([e.type,t.type]),e.isReadonly&&t.isReadonly):e:t}function sa(e,t){return e&&t&&Zo(Dc([e.type,t.type]),e.isReadonly||t.isReadonly)}function ca(t){var r=e.countWhere(t,function(e){return so(e,1).length>0}),n=e.map(t,Zn);if(r>0&&r===e.countWhere(n,function(e){return e})){var i=n.indexOf(!0);n[i]=!1}return n}function ua(e,t,r,n){for(var i=[],a=0;a<t.length;a++)a===n?i.push(e):r[a]&&i.push(Mo(so(t[a],1)[0]));return Ic(i)}function la(t){for(var r,n,i=e.emptyArray,a=e.emptyArray,o=t.types,s=ca(o),c=e.countWhere(s,function(e){return e}),u=function(u){var l=t.types[u];if(!s[u]){var _=so(l,1);_.length&&c>0&&(_=e.map(_,function(e){var t=Hi(e);return t.resolvedReturnType=ua(Mo(e),o,s,u),t})),a=e.concatenate(a,_)}i=e.concatenate(i,so(l,0)),r=oa(r,lo(l,0)),n=oa(n,lo(l,1))},l=0;l<o.length;l++)u(l);ur(t,hT,i,a,r,n)}function _a(t){var r=t.symbol;if(t.target){ur(t,hT,e.emptyArray,e.emptyArray,void 0,void 0);var n=Ei(Ea(t.target),t.mapper,!1),i=Vu(so(t.target,0),t.mapper),a=Vu(so(t.target,1),t.mapper),o=bl(lo(t.target,0),t.mapper),s=bl(lo(t.target,1),t.mapper);ur(t,n,i,a,o,s)}else if(2048&r.flags){ur(t,hT,e.emptyArray,e.emptyArray,void 0,void 0);var n=Ji(r),i=Ao(n.get("__call")),a=Ao(n.get("__new")),o=$o(r,0),s=$o(r,1);ur(t,n,i,a,o,s)}else{var n=hT,o=void 0;if(r.exports&&(n=Vt(r),r===RT)){var c=e.createMap();n.forEach(function(e){418&e.flags||c.set(e.escapedName,e)}),n=c}if(ur(t,n,e.emptyArray,e.emptyArray,void 0,void 0),32&r.flags){var u=li(r),l=ni(u);11272192&l.flags?(n=e.createSymbolTable(cr(n)),Ni(n,Pa(l))):l===ZT&&(o=Zo(ZT,!1))}var s=384&r.flags?TN:void 0;if(ur(t,n,e.emptyArray,e.emptyArray,o,s),8208&r.flags&&(t.callSignatures=Ao(r),t.constructSignatures=e.filter(t.callSignatures,function(e){return Dy(e.declaration)})),32&r.flags){var u=li(r),a=Ao(r.members.get("__constructor"));a.length||(a=Xi(u)),t.constructSignatures=a}}}function da(t){for(var r=lo(t.source,0),n=xa(t.mappedType),i=1&n?!1:!0,a=4&n?0:16777216,o=r&&Zo(Qd(r.type,t.mappedType,t.constraintType),i&&r.isReadonly),s=e.createSymbolTable(),c=0,u=Pa(t.source);c<u.length;c++){var l=u[c],_=8192|(i&&bh(l)?8:0),d=x(4|l.flags&a,l.escapedName,_);d.declarations=l.declarations,d.nameType=l.nameType,d.propertyType=Un(l),d.mappedType=t.mappedType,d.constraintType=t.constraintType,s.set(l.escapedName,d)
}ur(t,s,e.emptyArray,e.emptyArray,o,void 0)}function pa(t){if(131069&t.flags)return t;if(4194304&t.flags)return Vc(to(t.type));if(16777216&t.flags){if(t.root.isDistributive){var r=t.checkType,n=pa(r);if(n!==r){var i=Uu(t.root.checkType,n);return fl(t,Qu(i,t.mapper))}}return t}return 1048576&t.flags?Dc(e.sameMap(t.types,pa)):2097152&t.flags?Ic(e.sameMap(t.types,pa)):vE}function fa(t){function r(e){var r=Qu(t.mapper,Wu([o],[e])),s=gl(c,r);if(Fi(e)){var _=Li(e),d=ao(u,_),p=!!(4&l||!(8&l)&&d&&16777216&d.flags),f=!!(1&l||!(2&l)&&d&&bh(d)),m=x(4|(p?16777216:0),_,f?8:0);m.type=kT&&p&&!Pl(nE,s)?dd(s):kT&&!p&&d&&16777216&d.flags?Ip(s,524288):s,d&&(m.syntheticOrigin=d,m.declarations=d.declarations),m.nameType=e,a.set(_,m)}else 5&e.flags?n=Zo(s,!!(1&l)):8&e.flags&&(i=Zo(s,!!(1&l)))}var n,i,a=e.createSymbolTable();ur(t,hT,e.emptyArray,e.emptyArray,void 0,void 0);var o=ma(t),s=ga(t),c=va(t.target||t),u=to(ba(t)),l=xa(t),_=PT?128:8576;if(ha(t)){for(var d=0,p=Pa(u);d<p.length;d++){var f=p[d];r(jc(f,_))}(1&u.flags||lo(u,0))&&r(sE),!PT&&lo(u,1)&&r(cE)}else of(pa(s),r);ur(t,a,e.emptyArray,e.emptyArray,n,i)}function ma(e){return e.typeParameter||(e.typeParameter=yi(Ht(e.declaration.typeParameter)))}function ga(e){return e.constraintType||(e.constraintType=Ma(ma(e))||tE)}function va(e){return e.templateType||(e.templateType=e.declaration.type?gl(un(ju(e.declaration.type),!!(4&xa(e))),e.mapper||bT):tE)}function ya(t){return e.getEffectiveConstraintOfTypeParameter(t.declaration.typeParameter)}function ha(e){var t=ya(e);return 180===t.kind&&130===t.operator}function ba(e){if(!e.modifiersType)if(ha(e))e.modifiersType=gl(ju(ya(e).type),e.mapper||bT);else{var t=uu(e.declaration),r=ga(t),n=r&&262144&r.flags?Ma(r):r;e.modifiersType=n&&4194304&n.flags?gl(n.type,e.mapper||bT):rE}return e.modifiersType}function xa(e){var t=e.declaration;return(t.readonlyToken?39===t.readonlyToken.kind?2:1:0)|(t.questionToken?39===t.questionToken.kind?8:4:0)}function Da(e){var t=xa(e);return 8&t?-1:4&t?1:0}function Sa(e){var t=Da(e),r=ba(e);return t||(ka(r)?Da(r):0)}function Ca(t){return!!(32&e.getObjectFlags(t)&&4&xa(t))}function ka(t){return!!(32&e.getObjectFlags(t))&&Yc(ga(t))}function Ta(e){return e.members||(524288&e.flags?4&e.objectFlags?qi(e):3&e.objectFlags?Ki(e):2048&e.objectFlags?da(e):16&e.objectFlags?_a(e):32&e.objectFlags&&fa(e):1048576&e.flags?ia(e):2097152&e.flags&&la(e)),e}function Ea(t){return 524288&t.flags?Ta(t).properties:e.emptyArray}function Na(e,t){if(524288&e.flags){var r=Ta(e),n=r.members.get(t);if(n&&$t(n))return n}}function Aa(t){if(!t.resolvedProperties){for(var r=e.createSymbolTable(),n=0,i=t.types;n<i.length;n++){for(var a=i[n],o=0,s=Pa(a);o<s.length;o++){var c=s[o];if(!r.has(c.escapedName)){var u=io(t,c.escapedName);u&&r.set(c.escapedName,u)}}if(1048576&t.flags)break}t.resolvedProperties=cr(r)}return t.resolvedProperties}function Fa(t){if(t.possiblePropertyCache)return t.possiblePropertyCache.size?e.arrayFrom(t.possiblePropertyCache.values()):e.emptyArray;t.possiblePropertyCache=e.createSymbolTable();for(var r=0,n=t.types;r<n.length;r++)for(var i=n[r],a=0,o=Pa(i);a<o.length;a++){var s=o[a];if(!t.possiblePropertyCache.has(s.escapedName)){var c=no(t,s.escapedName);c&&t.possiblePropertyCache.set(s.escapedName,c)}}return t.possiblePropertyCache.size?e.arrayFrom(t.possiblePropertyCache.values()):e.emptyArray}function Pa(e){return e=to(e),3145728&e.flags?Aa(e):Ea(e)}function wa(e,t){var r=t.properties;return r.some(function(t){var r=t.name&&Rc(t.name),n=r&&Fi(r)?Li(r):void 0,i=void 0===n?void 0:Hr(e,n);return!!i&&X_(i)&&!Pl(XS(t),i)})}function Ia(t){var r=Dc(t);if(!(1048576&r.flags))return rC(r);for(var n=e.createSymbolTable(),i=0,a=t;i<a.length;i++)for(var o=a[i],s=0,c=rC(o);s<c.length;s++){var u=c[s].escapedName;if(!n.has(u)){var l=ro(r,u);l&&n.set(u,l)}}return e.arrayFrom(n.values())}function Oa(e){return 262144&e.flags?Ma(e):8388608&e.flags?La(e):16777216&e.flags?Va(e):Ka(e)}function Ma(e){return Wa(e)?rs(e):void 0}function La(e){return Wa(e)?Ba(e):void 0}function Ra(e){var t=$c(e,!1);return t!==e?t:Oa(e)}function Ba(e){var t=Ra(e.indexType);if(t&&t!==e.indexType){var r=su(e.objectType,t);if(r)return r}var n=Ra(e.objectType);return n&&n!==e.objectType?su(n,e.indexType):void 0}function ja(e){if(!e.resolvedDefaultConstraint){var t=fu(e),r=pu(e);e.resolvedDefaultConstraint=Qr(t)?r:Qr(r)?t:Dc([t,r])}return e.resolvedDefaultConstraint}function Ja(e){if(e.root.isDistributive&&e.restrictiveInstantiation!==e){var t=$c(e.checkType,!1),r=t===e.checkType?Oa(t):t;if(r&&r!==e.checkType){var n=Uu(e.root.checkType,r),i=fl(e,Qu(n,e.mapper));if(!(131072&i.flags))return i}}return void 0}function za(e){return Ja(e)||ja(e)}function Va(e){return Wa(e)?za(e):void 0}function Ua(t,r){for(var n,i=!1,a=0,o=t.types;a<o.length;a++){var s=o[a];if(63176704&s.flags){for(var c=Oa(s);c&&21233664&c.flags;)c=Oa(c);c&&(n=e.append(n,c))}else 67238908&s.flags&&(i=!0)}if(n&&(r||i)){if(i)for(var u=0,l=t.types;u<l.length;u++){var s=l[u];67238908&s.flags&&(n=e.append(n,s))}return Ic(n)}return void 0}function Ka(e){if(62128128&e.flags){var t=Ha(e);return t!==PE&&t!==wE?t:void 0}return 4194304&e.flags?SE:void 0}function qa(e){return Ka(e)||e}function Wa(e){return Ha(e)!==wE}function Ha(t){function r(t){if(!t.immediateBaseConstraint){if(!zr(t,4))return wE;if(yT>=50)return y(uT,e.Diagnostics.Type_instantiation_is_excessively_deep_and_possibly_infinite),a=!0,t.immediateBaseConstraint=PE;yT++;var r=i($c(t,!1));if(yT--,!Kr()){if(262144&t.flags){var n=es(t);if(n){var o=y(n,e.Diagnostics.Type_parameter_0_has_a_circular_constraint,Er(t));!uT||e.isNodeDescendantOf(n,uT)||e.isNodeDescendantOf(uT,n)||e.addRelatedInfo(o,e.createDiagnosticForNode(uT,e.Diagnostics.Circularity_originates_in_type_at_this_location))}}r=wE}a&&(r=wE),t.immediateBaseConstraint=r||PE}return t.immediateBaseConstraint}function n(e){var t=r(e);return t!==PE&&t!==wE?t:void 0}function i(e){if(262144&e.flags){var t=rs(e);return e.isThisType||!t?t:n(t)}if(3145728&e.flags){for(var r=e.types,i=[],a=0,o=r;a<o.length;a++){var s=o[a],c=n(s);c&&i.push(c)}return 1048576&e.flags&&i.length===r.length?Dc(i):2097152&e.flags&&i.length?Ic(i):void 0}if(4194304&e.flags)return SE;if(8388608&e.flags){var u=n(e.objectType),l=n(e.indexType),_=u&&l&&su(u,l);return _&&n(_)}if(16777216&e.flags){var t=za(e);yT++;var d=t&&n(t);return yT--,d}return 33554432&e.flags?n(e.substitute):e}var a=!1;return t.resolvedBaseConstraint||(t.resolvedBaseConstraint=Vi(r(t),t))}function Ga(e){return e.resolvedApparentType||(e.resolvedApparentType=Vi(e,e,!0))}function Qa(t){if(t.default)t.default===IE&&(t.default=wE);else if(t.target){var r=Qa(t.target);t.default=r?gl(r,t.mapper):PE}else{t.default=IE;var n=t.symbol&&e.forEach(t.symbol.declarations,function(t){return e.isTypeParameterDeclaration(t)&&t.default}),i=n?ju(n):PE;t.default===IE&&(t.default=i)}return t.default}function Xa(e){var t=Qa(e);return t!==PE&&t!==wE?t:void 0}function Ya(e){return Qa(e)!==wE}function Za(t){return!(!t.symbol||!e.forEach(t.symbol.declarations,function(t){return e.isTypeParameterDeclaration(t)&&t.default}))}function $a(e){return e.resolvedApparentType||(e.resolvedApparentType=eo(e))}function eo(e){var t=sl(e);if(t){var r=Ma(t);if(r&&(J_(r)||td(r))){var n=Uu(t,r);return gl(e,Qu(n,e.mapper))}}return e}function to(t){var r=63176704&t.flags?Ka(t)||rE:t;return 32&e.getObjectFlags(r)?$a(r):2097152&r.flags?Ga(r):132&r.flags?WE:296&r.flags?HE:2112&r.flags?Ys(DT>=8):528&r.flags?GE:12288&r.flags?Rs(DT>=2):67108864&r.flags?kE:4194304&r.flags?SE:2&r.flags&&!kT?kE:r}function ro(t,n){for(var i,a=e.createMap(),o=1048576&t.flags,s=o?24:0,c=o?0:16777216,u=4,l=0,_=0,d=t.types;_<d.length;_++){var p=d[_],f=to(p);if(f!==tE){var m=ao(f,n),g=m?e.getDeclarationModifierFlagsFromSymbol(m):0;if(!m||g&s){if(o){var v=!wi(n)&&(ig(n)&&lo(f,1)||lo(f,0));v?(l|=v.isReadonly?8:0,l|=32,i=e.append(i,td(f)?rd(f)||nE:v.type)):l|=16}}else{o?c|=16777216&m.flags:c&=m.flags;var y=""+r(m);a.has(y)||a.set(y,m),l|=(bh(m)?8:0)|(24&g?0:256)|(16&g?512:0)|(8&g?1024:0)|(32&g?2048:0),Vg(m)||(u=2)}}}if(!a.size)return void 0;var h=e.arrayFrom(a.values());if(!(1!==h.length||16&l||i))return h[0];for(var b,D,S,C,k=[],T=!1,E=0,N=h;E<N.length;E++){var m=N[E];C?m.valueDeclaration!==C&&(T=!0):C=m.valueDeclaration,b=e.addRange(b,m.declarations);var f=Un(m);D?f!==D&&(l|=64):(D=f,S=m.nameType),X_(f)&&(l|=128),k.push(f)}e.addRange(k,i);var A=x(4|c,n,u|l);return A.containingType=t,!T&&C&&(A.valueDeclaration=C,C.symbol.parent&&(A.parent=C.symbol.parent)),A.declarations=b,A.nameType=S,k.length>2?(A.checkFlags|=65536,A.deferralParent=t,A.deferralConstituents=k):A.type=o?Dc(k):Ic(k),A}function no(t,r){var n=t.propertyCache||(t.propertyCache=e.createSymbolTable()),i=n.get(r);return i||(i=ro(t,r),i&&n.set(r,i)),i}function io(t,r){var n=no(t,r);return!n||16&e.getCheckFlags(n)?void 0:n}function ao(e,t){if(e=to(e),524288&e.flags){var r=Ta(e),n=r.members.get(t);if(n&&$t(n))return n;var i=r===FE?zE:r.callSignatures.length?VE:r.constructSignatures.length?UE:void 0;if(i){var a=Na(i,t);if(a)return a}return Na(JE,t)}return 3145728&e.flags?io(e,t):void 0}function oo(t,r){if(3670016&t.flags){var n=Ta(t);return 0===r?n.callSignatures:n.constructSignatures}return e.emptyArray}function so(e,t){return oo(to(e),t)}function co(e,t){if(3670016&e.flags){var r=Ta(e);return 0===t?r.stringIndexInfo:r.numberIndexInfo}}function uo(e,t){var r=co(e,t);return r&&r.type}function lo(e,t){return co(to(e),t)}function _o(e,t){return uo(to(e),t)}function po(e,t){if(gd(e)){for(var r=[],n=0,i=Pa(e);n<i.length;n++){var a=i[n];(0===t||ig(a.escapedName))&&r.push(Un(a))}if(r.length)return Dc(r,2)}return void 0}function fo(t){for(var r,n=0,i=e.getEffectiveTypeParameterDeclarations(t);n<i.length;n++){var a=i[n];r=e.appendIfUnique(r,yi(a.symbol))}return r}function mo(e){var t=[];return e.forEach(function(e,r){sr(r)||t.push(e)}),t}function go(t){return e.isInJSFile(t)&&(t.type&&294===t.type.kind||e.getJSDocParameterTags(t).some(function(e){var t=e.isBracketed,r=e.typeExpression;return t||!!r&&294===r.type.kind}))}function vo(t,r){if(e.isExternalModuleNameRelative(t))return void 0;var n=L(MT,'"'+t+'"',512);return n&&r?Wt(n):n}function yo(t){if(e.hasQuestionToken(t)||ho(t)||go(t))return!0;if(t.initializer){var r=Co(t.parent),n=t.parent.parameters.indexOf(t);return e.Debug.assert(n>=0),n>=Hy(r)}var i=e.getImmediatelyInvokedFunctionExpression(t.parent);return i?!t.type&&!t.dotDotDotToken&&t.parent.parameters.indexOf(t)>=i.arguments.length:!1}function ho(t){if(!e.isJSDocParameterTag(t))return!1;var r=t.isBracketed,n=t.typeExpression;return r||!!n&&294===n.type.kind}function bo(e,t,r){return{kind:1,parameterName:e,parameterIndex:t,type:r}}function xo(e){return{kind:0,type:e}}function Do(e){var t=0;if(e)for(var r=0;r<e.length;r++)Za(e[r])||(t=r+1);return t}function So(t,r,n,i){var a=e.length(r);if(!a)return[];var o=e.length(t);if(i||o>=n&&a>=o){for(var s=t?t.slice():[],c=o;a>c;c++)s[c]=tE;for(var u=lp(i),c=o;a>c;c++){var l=Xa(r[c]);i&&l&&(Tl(l,rE)||Tl(l,kE))&&(l=ZT),s[c]=l?gl(l,Wu(r,s)):u}return s.length=r.length,s}return t&&t.slice()}function Co(t){var r=O(t);if(!r.resolvedSignature){for(var n=[],i=!1,a=0,o=void 0,s=!1,c=e.getImmediatelyInvokedFunctionExpression(t),u=e.isJSDocConstructSignature(t),l=!c&&e.isInJSFile(t)&&e.isValueSignatureDeclaration(t)&&!e.hasJSDocParameterTags(t)&&!e.getJSDocType(t),_=u?1:0;_<t.parameters.length;_++){var d=t.parameters[_],p=d.symbol,f=e.isJSDocParameterTag(d)?d.typeExpression&&d.typeExpression.type:d.type;if(p&&4&p.flags&&!e.isBindingPattern(d.name)){var m=j(d,p.escapedName,67220415,void 0,void 0,!1);p=m}0===_&&"this"===p.escapedName?(s=!0,o=d.symbol):n.push(p),f&&183===f.kind&&(i=!0);var g=ho(d)||d.initializer||d.questionToken||d.dotDotDotToken||c&&n.length>c.arguments.length&&!f||l||go(d);g||(a=n.length)}if(!(159!==t.kind&&160!==t.kind||Oi(t)||s&&o)){var v=159===t.kind?160:159,y=e.getDeclarationOfKind(Ht(t),v);y&&(o=Pn(y))}var h=158===t.kind?li(Wt(t.parent.symbol)):void 0,b=h?h.localTypeParameters:fo(t),x=e.hasRestParameter(t)||e.isInJSFile(t)&&ko(t,n);r.resolvedSignature=Wi(t,b,o,n,void 0,void 0,a,x,i)}return r.resolvedSignature}function ko(t,r){if(e.isJSDocSignature(t)||!No(t))return!1;var n=e.lastOrUndefined(t.parameters),i=n?e.getJSDocParameterTags(n):e.getJSDocTags(t).filter(e.isJSDocParameterTag),a=e.firstDefined(i,function(t){return t.typeExpression&&e.isJSDocVariadicType(t.typeExpression.type)?t.typeExpression.type:void 0}),o=x(3,"args",32768);return o.type=a?ic(ju(a.type)):YE,a&&r.pop(),r.push(o),!0}function To(t){var r=e.isInJSFile(t)?e.getJSDocTypeTag(t):void 0,n=r&&r.typeExpression&&Pv(ju(r.typeExpression));return n&&Ko(n)}function Eo(e){var t=To(e);return t&&Mo(t)}function No(t){function r(t){if(!t)return!1;switch(t.kind){case 73:return"arguments"===t.escapedText&&e.isExpressionNode(t);case 155:case 157:case 159:case 160:return 150===t.name.kind&&r(t.name);default:return!e.nodeStartsNewLexicalEnvironment(t)&&!e.isPartOfTypeNode(t)&&!!e.forEachChild(t,r)}}var n=O(t);return void 0===n.containsArgumentsReference&&(n.containsArgumentsReference=8192&n.flags?!0:r(t.body)),n.containsArgumentsReference}function Ao(t){if(!t)return e.emptyArray;for(var r=[],n=0;n<t.declarations.length;n++){var i=t.declarations[n];if(e.isFunctionLike(i)){if(n>0&&i.body){var a=t.declarations[n-1];if(i.parent===a.parent&&i.kind===a.kind&&i.pos===a.end)continue}r.push(Co(i))}}return r}function Fo(e){var t=At(e,e);if(t){var r=Ot(t);if(r)return Un(r)}return ZT}function Po(e){return e.thisParameter?Un(e.thisParameter):void 0}function wo(e){return void 0!==Io(e)}function Io(t){if(!t.resolvedTypePredicate){if(t.target){var r=Io(t.target);t.resolvedTypePredicate=r?tl(r,t.mapper):xN}else if(t.unionSignatures)t.resolvedTypePredicate=Sc(t.unionSignatures)||xN;else{var n=t.declaration&&e.getEffectiveReturnTypeNode(t.declaration),i=void 0;if(!n&&e.isInJSFile(t.declaration)){var a=To(t.declaration);a&&t!==a&&(i=Io(a))}t.resolvedTypePredicate=n&&e.isTypePredicateNode(n)?Oo(n,t):i||xN}e.Debug.assert(!!t.resolvedTypePredicate)}return t.resolvedTypePredicate===xN?void 0:t.resolvedTypePredicate}function Oo(t,r){var n=t.parameterName,i=ju(t.type);return 73===n.kind?bo(n.escapedText,e.findIndex(r.parameters,function(e){return e.escapedName===n.escapedText}),i):xo(i)}function Mo(t){if(!t.resolvedReturnType){if(!zr(t,3))return tE;var r=t.target?gl(Mo(t.target),t.mapper):t.unionSignatures?Dc(e.map(t.unionSignatures,Mo),2):Lo(t.declaration)||Dy(t.declaration)&&Cy(Ht(t.declaration))||(e.nodeIsMissing(t.declaration.body)?ZT:oh(t.declaration));if(!Kr()){if(t.declaration){var n=e.getEffectiveReturnTypeNode(t.declaration);if(n)y(n,e.Diagnostics.Return_type_annotation_circularly_references_itself);else if(AT){var i=t.declaration,a=e.getNameOfDeclaration(i);a?y(a,e.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions,e.declarationNameToString(a)):y(i,e.Diagnostics.Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions)}}r=ZT}t.resolvedReturnType=r}return t.resolvedReturnType}function Lo(t){if(158===t.kind)return li(Wt(t.parent.symbol));if(e.isJSDocConstructSignature(t))return ju(t.parameters[0].type);var r=e.getEffectiveReturnTypeNode(t);if(r)return ju(r);if(159===t.kind&&!Oi(t)){var n=e.isInJSFile(t)&&on(t);if(n)return n;var i=e.getDeclarationOfKind(Ht(t),160),a=Fn(i);if(a)return a}return Eo(t)}function Ro(e){return!e.resolvedReturnType&&Vr(e,3)>=0}function Bo(e){return jo(e)||ZT}function jo(e){if(e.hasRestParameter){var t=Un(e.parameters[e.parameters.length-1]),r=td(t)?rd(t):t;return r&&_o(r,1)}return void 0}function Jo(e,t,r,n){var i=zo(e,So(t,e.typeParameters,Do(e.typeParameters),r));if(n){var a=wv(Mo(i));if(a){var o=Hi(a);o.typeParameters=n;var s=Hi(i);return s.resolvedReturnType=Qo(o),s}}return i}function zo(t,r){var n=t.instantiations||(t.instantiations=e.createMap()),i=is(r),a=n.get(i);return a||n.set(i,a=Vo(t,r)),a}function Vo(e,t){return rl(e,Uo(e,t),!0)}function Uo(e,t){return Wu(e.typeParameters,t)}function Ko(e){return e.typeParameters?e.erasedSignatureCache||(e.erasedSignatureCache=qo(e)):e}function qo(e){return rl(e,Hu(e.typeParameters),!0)}function Wo(e){return e.typeParameters?e.canonicalSignatureCache||(e.canonicalSignatureCache=Ho(e)):e}function Ho(t){return Jo(t,e.map(t.typeParameters,function(e){return e.target&&!Ma(e.target)?e.target:e}),e.isInJSFile(t.declaration))}function Go(t){var r=t.typeParameters;if(r){var n=Hu(r),i=e.map(r,function(e){return gl(Ka(e),n)||rE});return rl(t,Wu(r,i),!0)}return t}function Qo(t){if(!t.isolatedSignatureType){var r=t.declaration?t.declaration.kind:0,n=158===r||162===r||167===r,i=ir(16);i.members=hT,i.properties=e.emptyArray,i.callSignatures=n?e.emptyArray:[t],i.constructSignatures=n?[t]:e.emptyArray,t.isolatedSignatureType=i}return t.isolatedSignatureType}function Xo(e){return e.members.get("__index")}function Yo(t,r){var n=1===r?136:139,i=Xo(t);if(i)for(var a=0,o=i.declarations;a<o.length;a++){var s=o[a],c=e.cast(s,e.isIndexSignatureDeclaration);if(1===c.parameters.length){var u=c.parameters[0];if(u.type&&u.type.kind===n)return c}}return void 0}function Zo(e,t,r){return{type:e,isReadonly:t,declaration:r}}function $o(t,r){var n=Yo(t,r);return n?Zo(n.type?ju(n.type):ZT,e.hasModifier(n,64),n):void 0}function es(t){var r=t.symbol&&e.getDeclarationOfKind(t.symbol,151);return r&&e.getEffectiveConstraintOfTypeParameter(r)}function ts(t){var r;if(t.symbol)for(var n=0,i=t.symbol.declarations;n<i.length;n++){var a=i[n];if(177===a.parent.kind){var o=a.parent.parent;if(165===o.kind){var s=o,c=Jb(s);if(c){var u=s.typeArguments.indexOf(a.parent);if(u<c.length){var l=Ma(c[u]);if(l){var _=Wu(c,Bb(s,c)),d=gl(l,_);d!==t&&(r=e.append(r,d))}}}}else 152===o.kind&&o.dotDotDotToken&&(r=e.append(r,ic(rE)))}}return r&&Ic(r)}function rs(e){if(!e.constraint)if(e.target){var t=Ma(e.target);e.constraint=t?gl(t,e.mapper):PE}else{var r=es(e);e.constraint=r?ju(r):ts(e)||PE}return e.constraint===PE?void 0:e.constraint}function ns(t){var r=e.getDeclarationOfKind(t.symbol,151),n=e.isJSDocTemplateTag(r.parent)?e.getHostSignatureFromJSDoc(r.parent):r.parent;return n&&Ht(n)}function is(e){var t="";if(e)for(var r=e.length,n=0;r>n;){for(var i=e[n].id,a=1;r>n+a&&e[n+a].id===i+a;)a++;t.length&&(t+=","),t+=i,a>1&&(t+=":"+a),n+=a}return t}function as(t,r){for(var n=0,i=0,a=t;i<a.length;i++){var o=a[i];o.flags&r||(n|=e.getObjectFlags(o))}return 917504&n}function os(e,t){var r=is(t),n=e.instantiations.get(r);return n||(n=ir(4,e.symbol),e.instantiations.set(r,n),n.objectFlags|=t?as(t,0):0,n.target=e,n.typeArguments=t),n}function ss(e){var t=tr(e.flags);return t.symbol=e.symbol,t.objectFlags=e.objectFlags,t.target=e.target,t.typeArguments=e.typeArguments,t}function cs(t){return e.length(t.target.typeParameters)}function us(t,r,n){var i=bi(Wt(r)),a=i.localTypeParameters;if(a){var o=e.length(t.typeArguments),s=Do(a),c=e.isInJSFile(t),u=!AT&&c;if(!u&&(s>o||o>a.length)){var l=c&&e.isExpressionWithTypeArguments(t)&&!e.isJSDocAugmentsTag(t.parent),_=s===a.length?l?e.Diagnostics.Expected_0_type_arguments_provide_these_with_an_extends_tag:e.Diagnostics.Generic_type_0_requires_1_type_argument_s:l?e.Diagnostics.Expected_0_1_type_arguments_provide_these_with_an_extends_tag:e.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments,d=Er(i,void 0,2);if(y(t,_,d,s,a.length),!c)return tE}var p=e.concatenate(i.outerTypeParameters,So(n,a,s,c));return os(i,p)}return Ds(t,r)?i:tE}function ls(t,r){var n=bi(t),i=I(t),a=i.typeParameters,o=is(r),s=i.instantiations.get(o);return s||i.instantiations.set(o,s=gl(n,Wu(a,So(r,a,Do(a),e.isInJSFile(t.valueDeclaration))))),s}function _s(t,r,n){var i=bi(r),a=I(r).typeParameters;if(a){var o=e.length(t.typeArguments),s=Do(a);return s>o||o>a.length?(y(t,s===a.length?e.Diagnostics.Generic_type_0_requires_1_type_argument_s:e.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments,kr(r),s,a.length),tE):ls(r,n)}return Ds(t,r)?i:tE}function ds(t){switch(t.kind){case 165:return t.typeName;case 212:var r=t.expression;if(e.isEntityNameExpression(r))return r}return void 0}function ps(e,t){return e?kt(e,t)||XT:XT}function fs(t,r){var n=Ts(t);if(r===XT)return tE;var i=gs(t,r,n);if(i)return i;var a=e.isInJSFile(t)&&r.valueDeclaration&&e.getJSDocEnumTag(r.valueDeclaration);if(a){var o=O(a);if(!zr(a,5))return tE;var s=a.typeExpression?ju(a.typeExpression):tE;return Kr()||(s=tE,y(t,e.Diagnostics.Enum_type_0_circularly_references_itself,kr(r))),o.resolvedEnumType=s}var c=xi(r);if(c)return Ds(t,r)?262144&c.flags?bs(c,t):Pu(c):tE;if(!(67220415&r.flags&&xs(t)))return tE;var u=ms(t,r,n);return u?u:(ps(ds(t),67897832),Un(r))}function ms(e,t,r){var n=Un(t),i=n.symbol&&n.symbol!==t&&gs(e,n.symbol,r);return i?I(t).resolvedJSDocType=i:void 0}function gs(t,r,n){if(96&r.flags){if(r.valueDeclaration&&r.valueDeclaration.parent&&e.isBinaryExpression(r.valueDeclaration.parent)){var i=ms(t,r,n);if(i)return i}return us(t,r,n)}if(524288&r.flags)return _s(t,r,n);if(16&r.flags&&xs(t)&&Dy(r.valueDeclaration)){var a=Ta(Un(r));if(1===a.callSignatures.length)return Mo(a.callSignatures[0])}}function vs(e,t){if(3&t.flags||t===e)return e;var r=pc(e)+">"+pc(t),n=HT.get(r);if(n)return n;var i=tr(33554432);return i.typeVariable=e,i.substitute=t,HT.set(r,i),i}function ys(e){return 171===e.kind&&1===e.elementTypes.length}function hs(e,t,r){return ys(t)&&ys(r)?hs(e,t.elementTypes[0],r.elementTypes[0]):lu(ju(t))===e?ju(r):void 0}function bs(t,r){for(var n;r&&!e.isStatement(r)&&297!==r.kind;){var i=r.parent;if(176===i.kind&&r===i.trueType){var a=hs(t,i.checkType,i.extendsType);a&&(n=e.append(n,a))}r=i}return n?vs(t,Ic(e.append(n,t))):t}function xs(e){return!!(2097152&e.flags)&&(165===e.kind||184===e.kind)}function Ds(t,r){return t.typeArguments?(y(t,e.Diagnostics.Type_0_is_not_generic,r?kr(r):t.typeName?e.declarationNameToString(t.typeName):"(anonymous)"),!1):!0}function Ss(t){if(e.isIdentifier(t.typeName)){var r=t.typeArguments;switch(t.typeName.escapedText){case"String":return Ds(t),sE;case"Number":return Ds(t),cE;case"Boolean":return Ds(t),fE;case"Void":return Ds(t),gE;case"Undefined":return Ds(t),nE;case"Null":return Ds(t),aE;case"Function":case"function":return Ds(t),zE;case"Array":case"array":return r&&r.length?void 0:YE;case"Promise":case"promise":return r&&r.length?void 0:nh(ZT);case"Object":if(r&&2===r.length){if(e.isJSDocIndexSignature(t)){var n=ju(r[0]),i=ju(r[1]),a=Zo(i,!1);return lr(void 0,hT,e.emptyArray,e.emptyArray,n===sE?a:void 0,n===cE?a:void 0)}return ZT}return Ds(t),ZT}}}function Cs(e){var t=ju(e.type);return kT?_d(t,65536):t}function ks(e){var t=O(e);if(!t.resolvedType){var r=void 0,n=void 0,i=67897832;xs(e)&&(n=Ss(e),i|=67220415),n||(r=ps(ds(e),i),n=fs(e,r)),t.resolvedSymbol=r,t.resolvedType=n}return t.resolvedType}function Ts(t){return e.map(t.typeArguments,ju)}function Es(e){var t=O(e);return t.resolvedType||(t.resolvedType=Pu(Td(yb(e.exprName)))),t.resolvedType}function Ns(t,r){function n(e){for(var t=e.declarations,r=0,n=t;r<n.length;r++){var i=n[r];switch(i.kind){case 241:case 242:case 244:return i}}}if(!t)return r?AE:kE;var i=bi(t);return 524288&i.flags?e.length(i.typeParameters)!==r?(y(n(t),e.Diagnostics.Global_type_0_must_have_1_type_parameter_s,e.symbolName(t),r),r?AE:kE):i:(y(n(t),e.Diagnostics.Global_type_0_must_be_a_class_or_interface_type,e.symbolName(t)),r?AE:kE)}function As(t,r){return Ps(t,67220415,r?e.Diagnostics.Cannot_find_global_value_0:void 0)}function Fs(t,r){return Ps(t,67897832,r?e.Diagnostics.Cannot_find_global_type_0:void 0)}function Ps(e,t,r){return j(void 0,e,t,r,e,!1)}function ws(e,t,r){var n=Fs(e,r);return n||r?Ns(n,t):void 0}function Is(){return nN||(nN=ws("TypedPropertyDescriptor",1,!0))||AE}function Os(){return fN||(fN=ws("TemplateStringsArray",0,!0))||kE}function Ms(){return mN||(mN=ws("ImportMeta",0,!0))||kE}function Ls(e){return tN||(tN=As("Symbol",e))}function Rs(e){return rN||(rN=ws("Symbol",0,e))||kE}function Bs(e){return iN||(iN=ws("Promise",1,e))||AE}function js(e){return aN||(aN=ws("PromiseLike",1,e))||AE}function Js(e){return oN||(oN=As("Promise",e))}function zs(e){return sN||(sN=ws("PromiseConstructorLike",0,e))||kE}function Vs(e){return _N||(_N=ws("AsyncIterable",1,e))||AE}function Us(e){return dN||(dN=ws("AsyncIterator",1,e))||AE}function Ks(e){return pN||(pN=ws("AsyncIterableIterator",1,e))||AE}function qs(e){return cN||(cN=ws("Iterable",1,e))||AE}function Ws(e){return uN||(uN=ws("Iterator",1,e))||AE}function Hs(e){return lN||(lN=ws("IterableIterator",1,e))||AE}function Gs(e,t){void 0===t&&(t=0);var r=Ps(e,67897832,void 0);return r&&Ns(r,t)}function Qs(){return gN||(gN=Ps("Extract",524288,e.Diagnostics.Cannot_find_global_type_0))}function Xs(){return vN||(vN=Ps("Omit",524288,e.Diagnostics.Cannot_find_global_type_0))}function Ys(e){return yN||(yN=ws("BigInt",0,e))||kE}function Zs(e,t){return e!==AE?os(e,t):kE}function $s(e){return Zs(Is(),[e])}function ec(e){return Zs(Vs(!0),[e])}function tc(e){return Zs(Ks(!0),[e])}function rc(e){return Zs(qs(!0),[e])}function nc(e){return Zs(Hs(!0),[e])}function ic(e,t){return Zs(t?qE:KE,[e])}function ac(e){var t=O(e);return t.resolvedType||(t.resolvedType=ic(ju(e.elementType),oc(e.parent))),t.resolvedType}function oc(t){return e.isTypeOperatorNode(t)&&134===t.operator}function sc(t,r,n,i,a){var o,s=[],c=n?t-1:t;if(t){o=new Array(t);for(var u=0;t>u;u++){var l=o[u]=or();if(c>u){var _=x(4|(u>=r?16777216:0),""+u,i?8:0);_.type=l,s.push(_)}}}for(var d=[],u=r;c>=u;u++)d.push(Iu(u));var p=x(4,"length");p.type=n?cE:Dc(d),s.push(p);var f=ir(12);return f.typeParameters=o,f.outerTypeParameters=void 0,f.localTypeParameters=o,f.instantiations=e.createMap(),f.instantiations.set(is(f.typeParameters),f),f.target=f,f.typeArguments=f.typeParameters,f.thisType=or(),f.thisType.isThisType=!0,f.thisType.constraint=f,f.declaredProperties=s,f.declaredCallSignatures=e.emptyArray,f.declaredConstructSignatures=e.emptyArray,f.declaredStringIndexInfo=void 0,f.declaredNumberIndexInfo=void 0,f.minLength=r,f.hasRestElement=n,f.readonly=i,f.associatedNames=a,f}function cc(e,t,r,n,i){var a=e+(r?"+":",")+t+(n?"R":"")+(i&&i.length?","+i.join(","):""),o=VT.get(a);return o||VT.set(a,o=sc(e,t,r,n,i)),o}function uc(e,t,r,n,i){void 0===t&&(t=e.length),void 0===r&&(r=!1),void 0===n&&(n=!1);var a=e.length;if(1===a&&r)return ic(e[0],n);var o=cc(a,t,a>0&&r,n,i);return e.length?os(o,e):o}function lc(t){var r=O(t);if(!r.resolvedType){var n=e.lastOrUndefined(t.elementTypes),i=n&&173===n.kind?n:void 0,a=e.findLastIndex(t.elementTypes,function(e){return 172!==e.kind&&e!==i})+1,o=e.map(t.elementTypes,function(e){var t=ju(e);return e===i&&_o(t,1)||t});r.resolvedType=uc(o,a,!!i,oc(t.parent))}return r.resolvedType}function _c(t,r){var n=t.target;return n.hasRestElement&&(r=Math.min(r,cs(t)-1)),uc((t.typeArguments||e.emptyArray).slice(r),Math.max(0,n.minLength-r),n.hasRestElement,n.readonly,n.associatedNames&&n.associatedNames.slice(r))}function dc(e){var t=ju(e.type);return kT?dd(t):t}function pc(e){return e.id}function fc(t,r){return e.binarySearch(t,r,pc,e.compareValues)>=0}function mc(t,r){var n=e.binarySearch(t,r,pc,e.compareValues);return 0>n?(t.splice(~n,0,r),!0):!1}function gc(e){for(var t=0,r=0,n=e.types;r<n.length;r++){var i=n[r];if(109440&i.flags&&109440&t)return!0;if(t|=i.flags,98304&t&&67633152&t||67108864&t&&130044&t||132&t&&67238776&t||296&t&&67238612&t||2112&t&&67236796&t||12288&t&&67226620&t||49152&t&&67189756&t)return!0}return!1}function vc(t,r,n){var i=n.flags;if(1048576&i)return yc(t,r,n.types);if(!(131072&i||2097152&i&&gc(n)))if(r|=1835007&i,66846720&i&&(r|=262144),n===eE&&(r|=4194304),!kT&&98304&i)131072&e.getObjectFlags(n)||(r|=2097152);else{var a=t.length,o=a&&n.id>t[a-1].id?~a:e.binarySearch(t,n,pc,e.compareValues);0>o&&t.splice(~o,0,n)}return r}function yc(e,t,r){for(var n=0,i=r;n<i.length;n++){var a=i[n];t=vc(e,t,a)}return t}function hc(e){var t=e[0];if(1024&t.flags){for(var r=Gt(t.symbol),n=1;n<e.length;n++){var i=e[n];if(!(1024&i.flags)||r!==Gt(i.symbol))return!1}return!0}return!1}function bc(t,r){var n=t.length;if(0===n||hc(t))return!0;for(var i=n,a=0;i>0;){i--;for(var o=t[i],s=0,c=t;s<c.length;s++){var u=c[s];if(o!==u){if(1e5===a){var l=a/(n-i)*n;if(l>(r?25e6:1e6))return y(uT,e.Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent),!1}if(a++,!(!Fl(o,u)||1&e.getObjectFlags(qn(o))&&1&e.getObjectFlags(qn(u))&&!wl(o,u))){e.orderedRemoveItemAt(t,i);break}}}}return!0}function xc(t,r){for(var n=t.length;n>0;){n--;var i=t[n],a=128&i.flags&&4&r||256&i.flags&&8&r||2048&i.flags&&64&r||8192&i.flags&&4096&r||wu(i)&&fc(t,i.regularType);a&&e.orderedRemoveItemAt(t,n)}}function Dc(e,t,r,n){if(void 0===t&&(t=1),0===e.length)return vE;if(1===e.length)return e[0];var i=[],a=yc(i,0,e);if(0!==t){if(3&a)return 1&a?4194304&a?eE:ZT:rE;switch(t){case 1:11136&a&&xc(i,a);break;case 2:if(!bc(i,!(262144&a)))return tE}if(0===i.length)return 65536&a?2097152&a?aE:oE:32768&a?2097152&a?nE:iE:vE}return kc(i,66994211&a?0:65536,r,n)}function Sc(t){for(var r,n=[],i=0,a=t;i<a.length;i++){var o=a[i],s=Io(o);if(s){if(r){if(!Cc(r,s))return void 0}else r=s;n.push(s.type)}}if(!r)return void 0;var c=Dc(n);return e.isIdentifierTypePredicate(r)?bo(r.parameterName,r.parameterIndex,c):xo(c)}function Cc(t,r){return e.isIdentifierTypePredicate(t)?e.isIdentifierTypePredicate(r)&&t.parameterIndex===r.parameterIndex:!e.isIdentifierTypePredicate(r)}function kc(e,t,r,n){if(0===e.length)return vE;if(1===e.length)return e[0];var i=is(e),a=UT.get(i);return a||(a=tr(1048576),UT.set(i,a),a.objectFlags=t|as(e,98304),a.types=e,a.aliasSymbol=r,a.aliasTypeArguments=n),a}function Tc(t){var r=O(t);if(!r.resolvedType){var n=Du(t);r.resolvedType=Dc(e.map(t.types,ju),1,n,Su(n))}return r.resolvedType}function Ec(t,r,n){var i=n.flags;return 2097152&i?Nc(t,r,n.types):(o_(n)?8388608&r||(r|=8388608,t.push(n)):(r|=1835007&i,3&i?n===eE&&(r|=4194304):!kT&&98304&i||e.contains(t,n)||t.push(n)),r)}function Nc(e,t,r){for(var n=0,i=r;n<i.length;n++){var a=i[n];t=Ec(e,t,Pu(a))}return t}function Ac(t,r){for(var n=t.length;n>0;){n--;var i=t[n],a=4&i.flags&&128&r||8&i.flags&&256&r||64&i.flags&&2048&r||4096&i.flags&&8192&r;a&&e.orderedRemoveItemAt(t,n)}}function Fc(e,t){for(var r=0,n=e;r<n.length;r++){var i=n[r];if(!fc(i.types,t)){var a=128&t.flags?sE:256&t.flags?cE:2048&t.flags?uE:8192&t.flags?mE:void 0;if(!a||!fc(i.types,a))return!1}}return!0}function Pc(t){var r,n=e.findIndex(t,function(t){return!!(65536&e.getObjectFlags(t))});if(0>n)return!1;for(var i=n+1;i<t.length;){var a=t[i];65536&e.getObjectFlags(a)?((r||(r=[t[n]])).push(a),e.orderedRemoveItemAt(t,i)):i++}if(!r)return!1;for(var o=[],s=[],c=0,u=r;c<u.length;c++)for(var l=u[c],_=0,d=l.types;_<d.length;_++){var a=d[_];mc(o,a)&&Fc(r,a)&&mc(s,a)}return t[n]=kc(s,65536),!0}function wc(e,t,r){var n=tr(2097152);return n.objectFlags=as(e,98304),n.types=e,n.aliasSymbol=t,n.aliasTypeArguments=r,n}function Ic(t,r,n){var i=[],a=Nc(i,0,t);if(131072&a)return vE;if(1&a)return 4194304&a?eE:ZT;if(!kT&&98304&a)return 32768&a?nE:aE;if((4&a&&128&a||8&a&&256&a||64&a&&2048&a||4096&a&&8192&a)&&Ac(i,a),8388608&a&&524288&a&&e.orderedRemoveItemAt(i,e.findIndex(i,o_)),0===i.length)return rE;if(1===i.length)return i[0];var o=is(i),s=KT.get(o);if(!s){if(1048576&a)if(Pc(i))s=Ic(i,r,n);else{var c=e.reduceLeft(i,function(e,t){return e*(1048576&t.flags?t.types.length:1)},1);if(c>=1e5)return y(uT,e.Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent),tE;var u=e.findIndex(i,function(e){return 0!==(1048576&e.flags)}),l=i[u];s=Dc(e.map(l.types,function(t){return Ic(e.replaceElement(i,u,t))}),1,r,n)}else s=wc(i,r,n);KT.set(o,s)}return s}function Oc(t){var r=O(t);if(!r.resolvedType){var n=Du(t);r.resolvedType=Ic(e.map(t.types,ju),n,Su(n))}return r.resolvedType}function Mc(e,t){var r=tr(4194304);return r.type=e,r.stringsOnly=t,r}function Lc(e,t){return t?e.resolvedStringIndexType||(e.resolvedStringIndexType=Mc(e,!0)):e.resolvedIndexType||(e.resolvedIndexType=Mc(e,!1))
}function Rc(t){return e.isIdentifier(t)?Iu(e.unescapeLeadingUnderscores(t.escapedText)):Pu(e.isComputedPropertyName(t)?ag(t):yb(t))}function Bc(t){return Iu({negative:!1,base10Value:e.parsePseudoBigInt(t.text)})}function jc(t,r){if(!(24&e.getDeclarationModifierFlagsFromSymbol(t))){var n=zi(t).nameType;if(!n&&!e.isKnownSymbol(t))if("default"===t.escapedName)n=Iu("default");else{var i=t.valueDeclaration&&e.getNameOfDeclaration(t.valueDeclaration);n=i&&Rc(i)||Iu(e.symbolName(t))}if(n&&n.flags&r)return n}return vE}function Jc(t,r){return Dc(e.map(Pa(t),function(e){return jc(e,r)}))}function zc(e){var t=lo(e,1);return t!==TN?t:void 0}function Vc(t,r,n){return void 0===r&&(r=PT),1048576&t.flags?Ic(e.map(t.types,function(e){return Vc(e,r,n)})):2097152&t.flags?Dc(e.map(t.types,function(e){return Vc(e,r,n)})):Ph(t,58982400)?Lc(t,r):32&e.getObjectFlags(t)?cf(ga(t),function(e){return!(n&&5&e.flags)}):t===eE?eE:2&t.flags?vE:131073&t.flags?SE:r?!n&&lo(t,0)?sE:Jc(t,128):!n&&lo(t,0)?Dc([sE,cE,Jc(t,8192)]):zc(t)?Dc([cE,Jc(t,8320)]):Jc(t,8576)}function Uc(e){if(PT)return e;var t=Qs();return t?ls(t,[e,sE]):sE}function Kc(e){var t=Uc(Vc(e));return 131072&t.flags?sE:t}function qc(t){var r=O(t);if(!r.resolvedType)switch(t.operator){case 130:r.resolvedType=Vc(ju(t.type));break;case 143:r.resolvedType=140===t.type.kind?Lu(e.walkUpParenthesizedTypes(t.parent)):tE;break;case 134:r.resolvedType=ju(t.type)}return r.resolvedType}function Wc(e,t){var r=tr(8388608);return r.objectType=e,r.indexType=t,r}function Hc(t){return AT?!1:16384&e.getObjectFlags(t)?!0:1048576&t.flags?e.every(t.types,Hc):2097152&t.flags?e.some(t.types,Hc):63176704&t.flags?Hc(Ha(t)):!1}function Gc(t,r,n,i,a,o,s){function c(t){t&&t.isReadonly&&u&&(e.isAssignmentTarget(u)||e.isDeleteTarget(u))&&y(u,e.Diagnostics.Index_signature_in_type_0_only_permits_reading,Er(r))}var u=o&&191===o.kind?o:void 0,l=Fi(n)?Li(n):u&&xv(u.argumentExpression,n,!1)?e.getPropertyNameForKnownSymbolName(e.idText(u.argumentExpression.name)):o&&e.isPropertyName(o)?e.getPropertyNameForPropertyNameNode(o):void 0;if(void 0!==l){var _=ao(r,l);if(_){if(u){if(pv(_,u,101===u.expression.kind),e.isAssignmentTarget(u)&&(xh(u,_)||Dh(u)))return void y(u.argumentExpression,e.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property,kr(_));4&s&&(O(o).resolvedSymbol=_)}var d=Un(_);return u&&1!==e.getAssignmentTargetKind(u)?Af(u,d):d}if(sf(r,td)&&ig(l)&&+l>=0){if(o&&sf(r,function(e){return!e.target.hasRestElement})){var p=Qc(o);td(r)?y(p,e.Diagnostics.Tuple_type_0_of_length_1_has_no_element_at_index_2,Er(r),cs(r),e.unescapeLeadingUnderscores(l)):y(p,e.Diagnostics.Property_0_does_not_exist_on_type_1,e.unescapeLeadingUnderscores(l),Er(r))}return c(lo(r,1)),lf(r,function(e){return rd(e)||nE})}}if(!(98304&n.flags)&&wh(n,12716)){if(131073&r.flags)return r;var f=lo(r,0),m=wh(n,296)&&lo(r,1)||f;if(m){if(1&s&&m===f)return void(u&&y(u,e.Diagnostics.Type_0_cannot_be_used_to_index_type_1,Er(n),Er(t)));if(o&&!wh(n,12)){var p=Qc(o);return y(p,e.Diagnostics.Type_0_cannot_be_used_as_an_index_type,Er(n)),m.type}return c(m),m.type}if(131072&n.flags)return vE;if(Hc(r))return ZT;if(u&&!Oh(r)){if(r.symbol===RT&&void 0!==l&&RT.exports.has(l)&&418&RT.exports.get(l).flags)y(u,e.Diagnostics.Property_0_does_not_exist_on_type_1,e.unescapeLeadingUnderscores(l),Er(r));else if(AT&&!xT.suppressImplicitAnyIndexErrors&&!a)if(void 0!==l&&iv(l,r))y(u,e.Diagnostics.Property_0_is_a_static_member_of_type_1,l,Er(r));else if(_o(r,1))y(u.argumentExpression,e.Diagnostics.Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number);else{var g=void 0;if(void 0!==l&&(g=ov(l,r)))void 0!==g&&y(u.argumentExpression,e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2,l,Er(r),g);else{var v=_v(r,u);if(void 0!==v)y(u,e.Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1,Er(r),v);else{var h=void 0;if(1024&n.flags)h=e.chainDiagnosticMessages(void 0,e.Diagnostics.Property_0_does_not_exist_on_type_1,"["+Er(n)+"]",Er(r));else if(8192&n.flags){var b=Ct(n.symbol,u);h=e.chainDiagnosticMessages(void 0,e.Diagnostics.Property_0_does_not_exist_on_type_1,"["+b+"]",Er(r))}else 128&n.flags?h=e.chainDiagnosticMessages(void 0,e.Diagnostics.Property_0_does_not_exist_on_type_1,n.value,Er(r)):256&n.flags?h=e.chainDiagnosticMessages(void 0,e.Diagnostics.Property_0_does_not_exist_on_type_1,n.value,Er(r)):12&n.flags&&(h=e.chainDiagnosticMessages(void 0,e.Diagnostics.No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1,Er(n),Er(r)));h=e.chainDiagnosticMessages(h,e.Diagnostics.Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1,Er(i),Er(r)),tA.add(e.createDiagnosticForNodeFromMessageChain(u,h))}}}return void 0}}if(Hc(r))return ZT;if(o){var p=Qc(o);384&n.flags?y(p,e.Diagnostics.Property_0_does_not_exist_on_type_1,""+n.value,Er(r)):12&n.flags?y(p,e.Diagnostics.Type_0_has_no_matching_index_signature_for_type_1,Er(r),Er(n)):y(p,e.Diagnostics.Type_0_cannot_be_used_as_an_index_type,Er(n))}return Qr(n)?n:void 0}function Qc(e){return 191===e.kind?e.argumentExpression:181===e.kind?e.indexType:150===e.kind?e.expression:e}function Xc(e){return Ph(e,59113472)}function Yc(e){return Ph(e,63176704)}function Zc(e){return!!(262144&e.flags&&e.isThisType)}function $c(e,t){return 8388608&e.flags?ru(e,t):16777216&e.flags?nu(e,t):e}function eu(t,r,n){if(3145728&t.flags){var i=e.map(t.types,function(e){return $c(ou(e,r),n)});return 2097152&t.flags||n?Ic(i):Dc(i)}}function tu(t,r,n){if(1048576&r.flags){var i=e.map(r.types,function(e){return $c(ou(t,e),n)});return n?Ic(i):Dc(i)}}function ru(e,t){var r=t?"simplifiedForWriting":"simplifiedForReading";if(e[r])return e[r]===wE?e:e[r];e[r]=wE;var n=$c(e.objectType,t),i=$c(e.indexType,t),a=tu(n,i,t);if(a)return e[r]=a;if(!(63176704&i.flags)){var o=eu(n,i,t);if(o)return e[r]=o}return e[r]=ka(n)?lf(au(n,e.indexType),function(e){return $c(e,t)}):e}function nu(e,t){var r=e.checkType,n=e.extendsType,i=du(e),a=pu(e);if(131072&a.flags&&lu(i)===lu(r)){if(1&r.flags||Pl(hl(r),hl(n)))return $c(i,t);if(iu(r,n))return vE}else if(131072&i.flags&&lu(a)===lu(r)){if(!(1&r.flags)&&Pl(hl(r),hl(n)))return vE;if(1&r.flags||iu(r,n))return $c(a,t)}return e}function iu(e,t){return!!(131072&Dc([aa(e,t),vE]).flags)}function au(e,t){var r=Wu([ma(e)],[t]),n=Qu(e.mapper,r);return gl(va(e),n)}function ou(e,t,r){return su(e,t,r,0)||(r?tE:rE)}function su(e,t,r,n){if(void 0===n&&(n=0),e===eE||t===eE)return eE;if(!s_(e)||98304&t.flags||!wh(t,12)||(t=sE),Yc(t)||(!r||181===r.kind)&&Xc(e)){if(3&e.flags)return e;var i=e.id+","+t.id,a=WT.get(i);return a||WT.set(i,a=Wc(e,t)),a}var o=to(e);if(1048576&t.flags&&!(16&t.flags)){for(var s=[],c=!1,u=0,l=t.types;u<l.length;u++){var _=l[u],d=Gc(e,o,_,t,c,r,n);if(d)s.push(d);else{if(!r)return void 0;c=!0}}return c?void 0:2&n?Ic(s):Dc(s)}return Gc(e,o,t,t,!1,r,4|n)}function cu(e){var t=O(e);if(!t.resolvedType){var r=ju(e.objectType),n=ju(e.indexType),i=ou(r,n,e);t.resolvedType=8388608&i.flags&&i.objectType===r&&i.indexType===n?bs(i,e):i}return t.resolvedType}function uu(e){var t=O(e);if(!t.resolvedType){var r=ir(32,e.symbol);r.declaration=e,r.aliasSymbol=Du(e),r.aliasTypeArguments=Su(r.aliasSymbol),t.resolvedType=r,ga(r)}return t.resolvedType}function lu(e){return 33554432&e.flags?e.typeVariable:8388608&e.flags&&(33554432&e.objectType.flags||33554432&e.indexType.flags)?ou(lu(e.objectType),lu(e.indexType)):e}function _u(e,t){var r=gl(e.checkType,t),n=gl(e.extendsType,t);if(r===eE||n===eE)return eE;var i,a=Ph(r,63307776);if(e.inferTypeParameters){var o=Id(e.inferTypeParameters,void 0,0);a||tp(o.inferences,r,n,192),i=Qu(t,o.mapper)}var s=i?gl(e.extendsType,i):n;if(!a&&!Ph(s,63307776)){if(3&s.flags)return gl(e.trueType,i||t);if(1&r.flags)return Dc([gl(e.trueType,i||t),gl(e.falseType,t)]);if(!Pl(yl(r),yl(s)))return gl(e.falseType,t);if(Pl(hl(r),hl(s)))return gl(e.trueType,i||t)}var c=lu(r),u=tr(16777216);return u.root=e,u.checkType=c,u.extendsType=n,u.mapper=t,u.combinedMapper=i,u.aliasSymbol=e.aliasSymbol,u.aliasTypeArguments=zu(e.aliasTypeArguments,t),u}function du(e){return e.resolvedTrueType||(e.resolvedTrueType=gl(e.root.trueType,e.mapper))}function pu(e){return e.resolvedFalseType||(e.resolvedFalseType=gl(e.root.falseType,e.mapper))}function fu(e){return e.resolvedInferredTrueType||(e.resolvedInferredTrueType=e.combinedMapper?gl(e.root.trueType,e.combinedMapper):du(e))}function mu(t){var r;return t.locals&&t.locals.forEach(function(t){262144&t.flags&&(r=e.append(r,bi(t)))}),r}function gu(t){var r=O(t);if(!r.resolvedType){var n=ju(t.checkType),i=Du(t),a=Su(i),o=Gn(t,!0),s=a?o:e.filter(o,function(e){return ol(e,t)}),c={node:t,checkType:n,extendsType:ju(t.extendsType),trueType:ju(t.trueType),falseType:ju(t.falseType),isDistributive:!!(262144&n.flags),inferTypeParameters:mu(t),outerTypeParameters:s,instantiations:void 0,aliasSymbol:i,aliasTypeArguments:a};r.resolvedType=_u(c,void 0),s&&(c.instantiations=e.createMap(),c.instantiations.set(is(s),r.resolvedType))}return r.resolvedType}function vu(e){var t=O(e);return t.resolvedType||(t.resolvedType=yi(Ht(e.typeParameter))),t.resolvedType}function yu(t){return e.isIdentifier(t)?[t]:e.append(yu(t.left),t.right)}function hu(t){var r=O(t);if(!r.resolvedType){if(t.isTypeOf&&t.typeArguments)return y(t,e.Diagnostics.Type_arguments_cannot_be_used_here),r.resolvedSymbol=XT,r.resolvedType=tE;if(!e.isLiteralImportTypeNode(t))return y(t.argument,e.Diagnostics.String_literal_expected),r.resolvedSymbol=XT,r.resolvedType=tE;var n=t.isTypeOf?67220415:2097152&t.flags?68008959:67897832,i=At(t,t.argument.literal);if(!i)return r.resolvedSymbol=XT,r.resolvedType=tE;var a=Ot(i,!1);if(e.nodeIsMissing(t.qualifier))if(a.flags&n)bu(t,r,a,n);else{var o=67220415===n?e.Diagnostics.Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here:e.Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0;y(t,o,t.argument.literal.text),r.resolvedSymbol=XT,r.resolvedType=tE}else{for(var s=yu(t.qualifier),c=a,u=void 0;u=s.shift();){var l=s.length?1920:n,_=L(Vt(Wt(ht(c))),u.escapedText,l);if(!_)return y(u,e.Diagnostics.Namespace_0_has_no_exported_member_1,Ct(c),e.declarationNameToString(u)),r.resolvedType=tE;O(u).resolvedSymbol=_,O(u.parent).resolvedSymbol=_,c=_}bu(t,r,c,n)}}return r.resolvedType}function bu(e,t,r,n){var i=ht(r);return t.resolvedSymbol=i,t.resolvedType=67220415===n?Un(r):fs(e,i)}function xu(t){var r=O(t);if(!r.resolvedType){var n=Du(t);if(0!==Ji(t.symbol).size||n){var i=ir(16,t.symbol);i.aliasSymbol=n,i.aliasTypeArguments=Su(n),e.isJSDocTypeLiteral(t)&&t.isArrayType&&(i=ic(i)),r.resolvedType=i}else r.resolvedType=NE}return r.resolvedType}function Du(t){return e.isTypeAlias(t.parent)?Ht(t.parent):void 0}function Su(e){return e?Xn(e):void 0}function Cu(e){return!!(524288&e.flags)&&!ka(e)}function ku(t,r,n,i,a){if(1&t.flags||1&r.flags)return ZT;if(2&t.flags||2&r.flags)return rE;if(131072&t.flags)return r;if(131072&r.flags)return t;if(1048576&t.flags)return lf(t,function(e){return ku(e,r,n,i,a)});if(1048576&r.flags)return lf(r,function(e){return ku(t,e,n,i,a)});if(71307260&r.flags)return t;if(Xc(t)||Xc(r)){if(a_(t))return r;if(2097152&t.flags){var o=t.types,s=o[o.length-1];if(Cu(s)&&Cu(r))return Ic(e.concatenate(o.slice(0,o.length-1),[ku(s,r,n,i,a)]))}return Ic([t,r])}var c,u,l=e.createSymbolTable(),_=e.createUnderscoreEscapedMap();t===kE?(c=lo(r,0),u=lo(r,1)):(c=sa(lo(t,0),lo(r,0)),u=sa(lo(t,1),lo(r,1)));for(var d=0,p=Pa(r);d<p.length;d++){var f=p[d];24&e.getDeclarationModifierFlagsFromSymbol(f)?_.set(f.escapedName,!0):Tu(f)&&l.set(f.escapedName,Eu(f,a))}for(var m=0,g=Pa(t);m<g.length;m++){var v=g[m];if(!_.has(v.escapedName)&&Tu(v))if(l.has(v.escapedName)){var f=l.get(v.escapedName),y=Un(f);if(16777216&f.flags){var h=e.concatenate(v.declarations,f.declarations),b=4|16777216&v.flags,D=x(b,v.escapedName);D.type=Dc([Un(v),Ip(y,524288)]),D.leftSpread=v,D.rightSpread=f,D.declarations=h,D.nameType=v.nameType,l.set(v.escapedName,D)}}else l.set(v.escapedName,Eu(v,a))}var S=lr(n,l,e.emptyArray,e.emptyArray,Nu(c,a),Nu(u,a));return S.objectFlags|=263296|i,S}function Tu(t){return!(106496&t.flags&&t.declarations.some(function(t){return e.isClassLike(t.parent)}))}function Eu(e,t){var r=65536&e.flags&&!(32768&e.flags);if(!r&&t===bh(e))return e;var n=4|16777216&e.flags,i=x(n,e.escapedName,t?8:0);return i.type=r?nE:Un(e),i.declarations=e.declarations,i.nameType=e.nameType,i.syntheticOrigin=e,i}function Nu(e,t){return e&&e.isReadonly!==t?Zo(e.type,t,e.declaration):e}function Au(e,t,r){var n=tr(e);return n.symbol=r,n.value=t,n}function Fu(e){if(2944&e.flags){if(!e.freshType){var t=Au(e.flags,e.value,e.symbol);t.regularType=e,t.freshType=t,e.freshType=t}return e.freshType}return e}function Pu(t){return 2944&t.flags?t.regularType:1048576&t.flags?Dc(e.sameMap(t.types,Pu)):t}function wu(e){return!!(2944&e.flags)&&e.freshType===e}function Iu(t,r,n){var i="number"==typeof t?"#":"string"==typeof t?"@":"n",a=(r?r:"")+i+("object"==typeof t?e.pseudoBigIntToString(t):t),o=qT.get(a);if(!o){var s=("number"==typeof t?256:"string"==typeof t?128:2048)|(r?1024:0);qT.set(a,o=Au(s,t,n)),o.regularType=o}return o}function Ou(e){var t=O(e);return t.resolvedType||(t.resolvedType=Pu(yb(e.literal))),t.resolvedType}function Mu(e){var t=tr(8192);return t.symbol=e,t.escapedName="__@"+t.symbol.escapedName+"@"+r(t.symbol),t}function Lu(t){if(e.isValidESSymbolDeclaration(t)){var r=Ht(t),n=I(r);return n.uniqueESSymbolType||(n.uniqueESSymbolType=Mu(r))}return mE}function Ru(t){var r=e.getThisContainer(t,!1),n=r&&r.parent;return!n||!e.isClassLike(n)&&242!==n.kind||e.hasModifier(r,32)||158===r.kind&&!e.isNodeDescendantOf(t,r.body)?(y(t,e.Diagnostics.A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface),tE):li(Ht(n)).thisType}function Bu(e){var t=O(e);return t.resolvedType||(t.resolvedType=Ru(e)),t.resolvedType}function ju(e){switch(e.kind){case 121:case 290:case 291:return ZT;case 144:return rE;case 139:return sE;case 136:return cE;case 147:return uE;case 124:return fE;case 140:return mE;case 107:return gE;case 142:return nE;case 97:return aE;case 133:return vE;case 137:return 65536&e.flags?ZT:xE;case 179:case 101:return Bu(e);case 183:return Ou(e);case 165:return ks(e);case 164:return fE;case 212:return ks(e);case 168:return Es(e);case 170:return ac(e);case 171:return lc(e);case 172:return dc(e);case 174:return Tc(e);case 175:return Oc(e);case 292:return Cs(e);case 294:return un(ju(e.type));case 178:case 173:case 293:case 289:return ju(e.type);case 296:return DS(e);case 166:case 167:case 169:case 298:case 295:case 299:return xu(e);case 180:return qc(e);case 181:return cu(e);case 182:return uu(e);case 176:return gu(e);case 177:return vu(e);case 184:return hu(e);case 73:case 149:var t=HS(e);return t?bi(t):tE;default:return tE}}function Ju(e,t,r){if(e&&e.length)for(var n=0;n<e.length;n++){var i=e[n],a=r(i,t);if(i!==a){var o=0===n?[]:e.slice(0,n);for(o.push(a),n++;n<e.length;n++)o.push(r(e[n],t));return o}}return e}function zu(e,t){return Ju(e,t,gl)}function Vu(e,t){return Ju(e,t,rl)}function Uu(e,t){return function(r){return r===e?t:r}}function Ku(e,t,r,n){return function(i){return i===e?t:i===r?n:i}}function qu(e,t){return function(r){for(var n=0;n<e.length;n++)if(r===e[n])return t?t[n]:ZT;return r}}function Wu(t,r){return e.Debug.assert(void 0===r||t.length===r.length),1===t.length?Uu(t[0],r?r[0]:ZT):2===t.length?Ku(t[0],r?r[0]:ZT,t[1],r?r[1]:ZT):qu(t,r)}function Hu(e){return Wu(e,void 0)}function Gu(t,r){return function(n){return e.findIndex(t.inferences,function(e){return e.typeParameter===n})>=r?rE:n}}function Qu(e,t){return e?t?function(r){return gl(e(r),t)}:e:t}function Xu(e,t,r){return function(n){return n===e?t:r(n)}}function Yu(e){return 262144&e.flags?eE:e}function Zu(e){return e.constraint===rE?e:e.restrictiveInstantiation||(e.restrictiveInstantiation=or(e.symbol),e.restrictiveInstantiation.constraint=rE,e.restrictiveInstantiation)}function $u(e){return 262144&e.flags?Zu(e):e}function el(e){var t=or(e.symbol);return t.target=e,t}function tl(t,r){return e.isIdentifierTypePredicate(t)?{kind:1,parameterName:t.parameterName,parameterIndex:t.parameterIndex,type:gl(t.type,r)}:{kind:0,type:gl(t.type,r)}}function rl(t,r,n){var i;if(t.typeParameters&&!n){i=e.map(t.typeParameters,el),r=Qu(Wu(t.typeParameters,i),r);for(var a=0,o=i;a<o.length;a++){var s=o[a];s.mapper=r}}var c=Wi(t.declaration,i,t.thisParameter&&nl(t.thisParameter,r),Ju(t.parameters,r,nl),void 0,void 0,t.minArgumentCount,t.hasRestParameter,t.hasLiteralTypes);return c.target=t,c.mapper=r,c}function nl(t,r){var n=I(t);if(n.type&&!Ph(n.type,63700992))return t;1&e.getCheckFlags(t)&&(t=n.target,r=Qu(n.mapper,r));var i=x(t.flags,t.escapedName,1|53256&e.getCheckFlags(t));return i.declarations=t.declarations,i.parent=t.parent,i.target=t,i.mapper=r,t.valueDeclaration&&(i.valueDeclaration=t.valueDeclaration),t.nameType&&(i.nameType=t.nameType),i}function il(t,r){var n=64&t.objectFlags?t.target:t,i=n.symbol,a=I(i),o=a.outerTypeParameters;if(!o){var s=i.declarations[0];if(e.isInJSFile(s)){var c=e.findAncestor(s,e.isJSDocParameterTag);if(c){var u=e.getParameterSymbolFromJSDoc(c);u&&(s=u.valueDeclaration)}}var l=Gn(s,!0);if(Dy(s)){var _=fo(s);l=e.addRange(l,_)}o=l||e.emptyArray,o=2048&i.flags&&!n.aliasTypeArguments?e.filter(o,function(e){return ol(e,s)}):o,a.outerTypeParameters=o,o.length&&(a.instantiations=e.createMap(),a.instantiations.set(is(o),n))}if(o.length){var d=64&t.objectFlags?Qu(t.mapper,r):r,p=e.map(o,d),f=is(p),m=a.instantiations.get(f);if(!m){var g=Wu(o,p);m=32&n.objectFlags?cl(n,g):pl(n,g),a.instantiations.set(f,m)}return m}return t}function al(e){return!(149===e.kind||165===e.parent.kind&&e.parent.typeArguments&&e===e.parent.typeName)}function ol(t,r){function n(r){switch(r.kind){case 179:return!!t.isThisType;case 73:return!t.isThisType&&e.isPartOfTypeNode(r)&&al(r)&&ju(r)===t;case 168:return!0}return!!e.forEachChild(r,n)}if(t.symbol&&t.symbol.declarations&&1===t.symbol.declarations.length){for(var i=t.symbol.declarations[0].parent,a=r;a!==i;a=a.parent)if(!a||219===a.kind||176===a.kind&&e.forEachChild(a.extendsType,n))return!0;return!!e.forEachChild(r,n)}return!0}function sl(e){var t=ga(e);if(4194304&t.flags){var r=lu(t.type);if(262144&r.flags)return r}return void 0}function cl(e,t){var r=sl(e);if(r){var n=gl(r,t);if(r!==n)return lf(n,function(n){if(61603843&n.flags&&n!==eE&&n!==tE){var i=Xu(r,n,t);return J_(n)?ll(n,e,i):td(n)?_l(n,e,i):pl(e,i)}return n})}return pl(e,t)}function ul(e,t){return 1&t?!0:2&t?!1:e}function ll(e,t,r){var n=dl(t,cE,!0,r);return n===tE?tE:ic(n,ul(z_(e),xa(t)))}function _l(t,r,n){var i=t.target.minLength,a=e.map(t.typeArguments||e.emptyArray,function(e,t){return dl(r,Iu(""+t),t>=i,n)}),o=xa(r),s=4&o?0:8&o?cs(t)-(t.target.hasRestElement?1:0):i,c=ul(t.target.readonly,o);return e.contains(a,tE)?tE:uc(a,s,t.target.hasRestElement,c,t.target.associatedNames)}function dl(e,t,r,n){var i=Qu(n,Wu([ma(e)],[t])),a=gl(va(e.target||e),i),o=xa(e);return kT&&4&o&&!Pl(nE,a)?dd(a):kT&&8&o&&r?Ip(a,524288):a}function pl(e,t){var r=ir(64|e.objectFlags,e.symbol);if(32&e.objectFlags){r.declaration=e.declaration;var n=ma(e),i=el(n);r.typeParameter=i,t=Qu(Uu(n,i),t),i.mapper=t}return r.target=e,r.mapper=t,r.aliasSymbol=e.aliasSymbol,r.aliasTypeArguments=zu(e.aliasTypeArguments,t),r}function fl(t,r){var n=t.root;if(n.outerTypeParameters){var i=e.map(n.outerTypeParameters,r),a=is(i),o=n.instantiations.get(a);if(!o){var s=Wu(n.outerTypeParameters,i);o=ml(n,s),n.instantiations.set(a,o)}return o}return t}function ml(e,t){if(e.isDistributive){var r=e.checkType,n=t(r);if(r!==n&&1179648&n.flags)return lf(n,function(n){return _u(e,Xu(r,n,t))})}return _u(e,t)}function gl(t,r){if(!t||!r||r===bT)return t;if(50===vT)return y(uT,e.Diagnostics.Type_instantiation_is_excessively_deep_and_possibly_infinite),tE;vT++;var n=vl(t,r);return vT--,n}function vl(e,t){var r=e.flags;if(262144&r)return t(e);if(524288&r){var n=e.objectFlags;if(16&n)return zd(e)?il(e,t):e;if(32&n)return il(e,t);if(4&n){var i=e.typeArguments,a=zu(i,t);return a!==i?os(e.target,a):e}return e}if(1048576&r&&!(131068&r)){var o=e.types,s=zu(o,t);return s!==o?Dc(s,1,e.aliasSymbol,zu(e.aliasTypeArguments,t)):e}if(2097152&r){var o=e.types,s=zu(o,t);return s!==o?Ic(s,e.aliasSymbol,zu(e.aliasTypeArguments,t)):e}if(4194304&r)return Vc(gl(e.type,t));if(8388608&r)return ou(gl(e.objectType,t),gl(e.indexType,t));if(16777216&r)return fl(e,Qu(e.mapper,t));if(33554432&r){var c=gl(e.typeVariable,t);if(8650752&c.flags)return vs(c,gl(e.substitute,t));var u=gl(e.substitute,t);return 3&u.flags||Pl(hl(c),hl(u))?c:u}return e}function yl(e){return 262143&e.flags?e:e.permissiveInstantiation||(e.permissiveInstantiation=gl(e,Yu))}function hl(e){return 262143&e.flags?e:e.restrictiveInstantiation?e.restrictiveInstantiation:(e.restrictiveInstantiation=gl(e,$u),e.restrictiveInstantiation.restrictiveInstantiation=e.restrictiveInstantiation,e.restrictiveInstantiation)}function bl(e,t){return e&&Zo(gl(e.type,t),e.isReadonly,e.declaration)}function xl(t){switch(e.Debug.assert(157!==t.kind||e.isObjectLiteralMethod(t)),t.kind){case 197:case 198:case 157:return Dl(t);case 189:return e.some(t.properties,xl);case 188:return e.some(t.elements,xl);case 206:return xl(t.whenTrue)||xl(t.whenFalse);case 205:return 55===t.operatorToken.kind&&(xl(t.left)||xl(t.right));case 276:return xl(t.initializer);case 196:return xl(t.expression);case 269:return e.some(t.properties,xl)||e.isJsxOpeningElement(t.parent)&&e.some(t.parent.parent.children,xl);case 268:var r=t.initializer;return!!r&&xl(r);case 271:var n=t.expression;return!!n&&xl(n)}return!1}function Dl(t){if(t.typeParameters)return!1;if(e.some(t.parameters,function(t){return!e.getEffectiveTypeAnnotationNode(t)}))return!0;if(198!==t.kind){var r=e.firstOrUndefined(t.parameters);if(!r||!e.parameterIsThisKeyword(r))return!0}return Sl(t)}function Sl(e){return!!e.body&&219!==e.body.kind&&xl(e.body)}function Cl(t){return(e.isInJSFile(t)&&e.isFunctionDeclaration(t)||Gm(t)||e.isObjectLiteralMethod(t))&&Dl(t)}function kl(t){if(524288&t.flags){var r=Ta(t);if(r.constructSignatures.length||r.callSignatures.length){var n=ir(16,t.symbol);return n.members=r.members,n.properties=r.properties,n.callSignatures=e.emptyArray,n.constructSignatures=e.emptyArray,n}}else if(2097152&t.flags)return Ic(e.map(t.types,kl));return t}function Tl(e,t){return l_(e,t,fA)}function El(e,t){return l_(e,t,fA)?-1:0}function Nl(e,t){return l_(e,t,dA)?-1:0}function Al(e,t){return l_(e,t,_A)?-1:0}function Fl(e,t){return l_(e,t,_A)}function Pl(e,t){return l_(e,t,dA)}function wl(t,r){return 1048576&t.flags?e.every(t.types,function(e){return wl(e,r)}):1048576&r.flags?e.some(r.types,function(e){return wl(t,e)}):58982400&t.flags?wl(Ka(t)||rE,r):r===JE?!!(67633152&t.flags):r===zE?!!(524288&t.flags)&&Pp(t):Wn(t,qn(r))}function Il(e,t){return l_(e,t,pA)}function Ol(e,t){return Il(e,t)||Il(t,e)}function Ml(e,t,r,n,i,a){return d_(e,t,dA,r,n,i,a)}function Ll(e,t,r,n,i,a){return Rl(e,t,dA,r,n,i,a)}function Rl(e,t,r,n,i,a,o){return l_(e,t,r)?!0:n&&jl(i,e,t,r,a)?!1:d_(e,t,r,n,a,o)}function Bl(t){return!!(16777216&t.flags||2097152&t.flags&&e.some(t.types,Bl))}function jl(e,t,r,n,i){if(!e||Bl(r))return!1;if(!d_(t,r,n,void 0)&&Jl(e,t,r,n,i))return!0;switch(e.kind){case 271:case 196:return jl(e.expression,t,r,n,i);case 205:switch(e.operatorToken.kind){case 60:case 27:return jl(e.right,t,r,n,i)}break;case 189:return Yl(e,t,r,n);case 188:return Ql(e,t,r,n);case 269:return Hl(e,t,r,n);case 198:return zl(e,t,r,n)}return!1}function Jl(t,r,n,i,a){for(var o=so(r,0),s=so(r,1),c=0,u=[s,o];c<u.length;c++){var l=u[c];if(e.some(l,function(e){var t=Mo(e);return!(131073&t.flags)&&d_(t,n,i,void 0)})){var _={};Ml(r,n,t,a,void 0,_);var d=_.error;return e.addRelatedInfo(d,e.createDiagnosticForNode(t,l===s?e.Diagnostics.Did_you_mean_to_use_new_with_this_expression:e.Diagnostics.Did_you_mean_to_call_this_expression)),!0}}return!1}function zl(t,r,n,i){if(e.isBlock(t.body))return!1;if(e.some(t.parameters,e.hasType))return!1;var a=Pv(r);if(!a)return!1;var o=so(n,0);if(!e.length(o))return!1;var s=t.body,c=Mo(a),u=Dc(e.map(o,Mo));if(!d_(c,u,i,void 0)){var l=s&&jl(s,c,u,i,void 0);if(l)return l;var _={};if(d_(c,u,i,s,void 0,void 0,_),_.error)return n.symbol&&e.length(n.symbol.declarations)&&e.addRelatedInfo(_.error,e.createDiagnosticForNode(n.symbol.declarations[0],e.Diagnostics.The_expected_type_comes_from_the_return_type_of_this_signature)),!0}return!1}function Vl(t,r,n,i){for(var a=!1,o=t.next();!o.done;o=t.next()){var s=o.value,c=s.errorNode,u=s.innerExpression,l=s.nameType,_=s.errorMessage,d=su(n,l);if(d&&!(8388608&d.flags)){var p=su(r,l);if(p&&!d_(p,d,i,void 0)){var f=u&&jl(u,p,d,i,void 0);if(f)a=!0;else{var m={},g=u?ab(u,0,p):p,v=d_(g,d,i,c,_,void 0,m);if(v&&g!==p&&d_(p,d,i,c,_,void 0,m),m.error){var y=m.error,h=Fi(l)?Li(l):void 0,b=void 0!==h?ao(n,h):void 0,x=!1;if(!b){var D=wh(l,296)&&lo(n,1)||lo(n,0)||void 0;D&&D.declaration&&!e.getSourceFileOfNode(D.declaration).hasNoDefaultLib&&(x=!0,e.addRelatedInfo(y,e.createDiagnosticForNode(D.declaration,e.Diagnostics.The_expected_type_comes_from_this_index_signature)))}if(!x&&(b&&e.length(b.declarations)||n.symbol&&e.length(n.symbol.declarations))){var S=b&&e.length(b.declarations)?b.declarations[0]:n.symbol.declarations[0];e.getSourceFileOfNode(S).hasNoDefaultLib||e.addRelatedInfo(y,e.createDiagnosticForNode(S,e.Diagnostics.The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1,!h||8192&l.flags?Er(l):e.unescapeLeadingUnderscores(h),Er(n)))}}a=!0}}}}return a}function Ul(t){var r,n,i;return a(this,function(a){switch(a.label){case 0:if(!e.length(t.properties))return[2];r=0,n=t.properties,a.label=1;case 1:return r<n.length?(i=n[r],e.isJsxSpreadAttribute(i)?[3,3]:[4,{errorNode:i.name,innerExpression:i.initializer,nameType:Iu(e.idText(i.name))}]):[3,4];case 2:a.sent(),a.label=3;case 3:return r++,[3,1];case 4:return[2]}})}function Kl(t,r){var n,i,o,s,c;return a(this,function(a){switch(a.label){case 0:if(!e.length(t.children))return[2];n=0,i=0,a.label=1;case 1:return i<t.children.length?(o=t.children[i],s=Iu(i-n),c=ql(o,s,r),c?[4,c]:[3,3]):[3,5];case 2:return a.sent(),[3,4];case 3:n++,a.label=4;case 4:return i++,[3,1];case 5:return[2]}})}function ql(t,r,n){switch(t.kind){case 271:return{errorNode:t,innerExpression:t.expression,nameType:r};case 11:if(t.containsOnlyTriviaWhiteSpaces)break;return{errorNode:t,innerExpression:void 0,nameType:r,errorMessage:n()};case 261:case 262:case 265:return{errorNode:t,innerExpression:t,nameType:r};default:return e.Debug.assertNever(t,"Found invalid jsx child")}}function Wl(t){return e.filter(t,function(t){return!e.isJsxText(t)||!t.containsOnlyTriviaWhiteSpaces})}function Hl(t,r,n,o){function s(){if(!c){var r=e.getTextOfNode(t.parent.tagName),a=Eg(Sg(t)),o=void 0===a?"children":e.unescapeLeadingUnderscores(a),s=ou(n,Iu(o)),u=e.Diagnostics._0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2;c=i({},u,{key:"!!ALREADY FORMATTED!!",message:e.formatMessage(void 0,u,r,o,Er(s))})}return c}var c,u=Vl(Ul(t),r,n,o);if(e.isJsxOpeningElement(t.parent)&&e.isJsxElement(t.parent.parent)){var l=t.parent.parent,_=Eg(Sg(t)),d=void 0===_?"children":e.unescapeLeadingUnderscores(_),p=Iu(d),f=ou(n,p),m=Wl(l.children);if(!e.length(m))return u;var g=e.length(m)>1,v=cf(f,W_),h=cf(f,function(e){return!W_(e)});if(g)if(v!==vE){var b=uc(hg(l,0));u=Vl(Kl(l,s),b,v,o)||u}else l_(ou(r,p),f,o)||(u=!0,y(l.openingElement.tagName,e.Diagnostics.This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided,d,Er(f)));else if(h!==vE){var x=m[0],D=ql(x,p,s);D&&(u=Vl(function(){return a(this,function(e){switch(e.label){case 0:return[4,D];case 1:return e.sent(),[2]}})}(),r,n,o)||u)}else l_(ou(r,p),f,o)||(u=!0,y(l.openingElement.tagName,e.Diagnostics.This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided,d,Er(f)))}return u}function Gl(t,r){var n,i,o,s;return a(this,function(a){switch(a.label){case 0:if(n=e.length(t.elements),!n)return[2];i=0,a.label=1;case 1:return n>i?q_(r)&&!ao(r,""+i)?[3,3]:(o=t.elements[i],e.isOmittedExpression(o)?[3,3]:(s=Iu(i),[4,{errorNode:o,innerExpression:o,nameType:s}])):[3,4];case 2:a.sent(),a.label=3;case 3:return i++,[3,1];case 4:return[2]}})}function Ql(e,t,r,n){if(131068&r.flags)return!1;if(q_(t))return Vl(Gl(e,r),t,r,n);var i=$m(e,1,!0);return q_(i)?Vl(Gl(e,r),i,r,n):!1}function Xl(t){var r,n,i,o,s;return a(this,function(a){switch(a.label){case 0:if(!e.length(t.properties))return[2];r=0,n=t.properties,a.label=1;case 1:if(!(r<n.length))return[3,8];if(i=n[r],e.isSpreadAssignment(i))return[3,7];if(o=jc(Ht(i),8576),!o||131072&o.flags)return[3,7];switch(s=i.kind){case 160:return[3,2];case 159:return[3,2];case 157:return[3,2];case 277:return[3,2];case 276:return[3,4]}return[3,6];case 2:return[4,{errorNode:i.name,innerExpression:void 0,nameType:o}];case 3:return a.sent(),[3,7];case 4:return[4,{errorNode:i.name,innerExpression:i.initializer,nameType:o,errorMessage:Yr(i.name)?e.Diagnostics.Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1:void 0}];case 5:return a.sent(),[3,7];case 6:e.Debug.assertNever(i),a.label=7;case 7:return r++,[3,1];case 8:return[2]}})}function Yl(e,t,r,n){return 131068&r.flags?!1:Vl(Xl(e),t,r,n)}function Zl(e,t,r,n,i){return d_(e,t,pA,r,n,i)}function $l(e,t,r){return 0!==t_(e,t,0,r,!1,void 0,Nl)}function e_(e){return!e.typeParameters&&(!e.thisParameter||Qr(zy(e.thisParameter)))&&1===e.parameters.length&&e.hasRestParameter&&(zy(e.parameters[0])===YE||Qr(zy(e.parameters[0])))&&Qr(Mo(e))}function t_(t,r,n,i,a,o,s){if(t===r)return-1;if(e_(r))return-1;var c=Wy(r);if(!Gy(r)&&Hy(t)>c)return 0;t.typeParameters&&t.typeParameters!==r.typeParameters&&(r=Wo(r),t=Ov(t,r,void 0,s));var u=Wy(t),l=Xy(t),_=Xy(r);if(l&&_&&u!==c)return 0;var d=r.declaration?r.declaration.kind:0,p=!n&&TT&&157!==d&&156!==d&&158!==d,f=-1,m=Po(t);if(m&&m!==gE){var g=Po(r);if(g){var v=!p&&s(m,g,!1)||s(g,m,a);if(!v)return a&&o(e.Diagnostics.The_this_types_of_each_signature_are_incompatible),0;f&=v}}for(var y=l||_?Math.min(u,c):Math.max(u,c),h=l||_?y-1:-1,b=0;y>b;b++){var x=b===h?qy(t,b):Uy(t,b),D=b===h?qy(r,b):Uy(r,b),S=n?void 0:Pv(fd(x)),C=n?void 0:Pv(fd(D)),k=S&&C&&!wo(S)&&!wo(C)&&(98304&sd(x))===(98304&sd(D)),v=k?t_(C,S,p?2:1,!1,a,o,s):!n&&!p&&s(x,D,!1)||s(D,x,a);if(!v)return a&&o(e.Diagnostics.Types_of_parameters_0_and_1_are_incompatible,e.unescapeLeadingUnderscores(Vy(t,b)),e.unescapeLeadingUnderscores(Vy(r,b))),0;f&=v}if(!i){var T=Ro(r)?ZT:r.declaration&&Dy(r.declaration)?Cy(r.declaration.symbol):Mo(r);if(T===gE)return f;var E=Ro(t)?ZT:t.declaration&&Dy(t.declaration)?Cy(t.declaration.symbol):Mo(t),N=Io(r);if(N){var A=Io(t);if(A)f&=r_(A,N,a,o,s);else if(e.isIdentifierTypePredicate(N))return a&&o(e.Diagnostics.Signature_0_must_be_a_type_predicate,Tr(t)),0}else f&=1===n&&s(T,E,!1)||s(E,T,a)}return f}function r_(t,r,n,i,a){if(t.kind!==r.kind)return n&&(i(e.Diagnostics.A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard),i(e.Diagnostics.Type_predicate_0_is_not_assignable_to_1,Pr(t),Pr(r))),0;if(1===t.kind&&t.parameterIndex!==r.parameterIndex)return n&&(i(e.Diagnostics.Parameter_0_is_not_in_the_same_position_as_parameter_1,t.parameterName,r.parameterName),i(e.Diagnostics.Type_predicate_0_is_not_assignable_to_1,Pr(t),Pr(r))),0;var o=a(t.type,r.type,n);return 0===o&&n&&i(e.Diagnostics.Type_predicate_0_is_not_assignable_to_1,Pr(t),Pr(r)),o}function n_(e,t){var r=Ko(e),n=Ko(t),i=Mo(r),a=Mo(n);return a===gE||l_(a,i,dA)||l_(i,a,dA)?$l(r,n,!0):!1}function i_(e){return 0===e.properties.length&&0===e.callSignatures.length&&0===e.constructSignatures.length&&!e.stringIndexInfo&&!e.numberIndexInfo}function a_(t){return 524288&t.flags?!ka(t)&&i_(Ta(t)):67108864&t.flags?!0:1048576&t.flags?e.some(t.types,a_):2097152&t.flags?e.every(t.types,a_):!1}function o_(t){return!!(16&e.getObjectFlags(t))&&a_(t)
}function s_(t){return 524288&t.flags&&!ka(t)&&0===Pa(t).length&&lo(t,0)&&!lo(t,1)||3145728&t.flags&&e.every(t.types,s_)||!1}function c_(t,n,i){if(t===n)return!0;var a=r(t)+","+r(n),o=mA.get(a);if(void 0!==o&&(2!==o||!i))return 1===o;if(!(t.escapedName===n.escapedName&&256&t.flags&&256&n.flags))return mA.set(a,3),!1;for(var s=Un(n),c=0,u=Pa(Un(t));c<u.length;c++){var l=u[c];if(8&l.flags){var _=ao(s,l.escapedName);if(!(_&&8&_.flags))return i?(i(e.Diagnostics.Property_0_is_missing_in_type_1,e.symbolName(l),Er(bi(n),void 0,64)),mA.set(a,3)):mA.set(a,2),!1}}return mA.set(a,1),!0}function u_(e,t,r,n){var i=e.flags,a=t.flags;if(3&a||131072&i||e===eE)return!0;if(131072&a)return!1;if(132&i&&4&a)return!0;if(128&i&&1024&i&&128&a&&!(1024&a)&&e.value===t.value)return!0;if(296&i&&8&a)return!0;if(256&i&&1024&i&&256&a&&!(1024&a)&&e.value===t.value)return!0;if(2112&i&&64&a)return!0;if(528&i&&16&a)return!0;if(12288&i&&4096&a)return!0;if(32&i&&32&a&&c_(e.symbol,t.symbol,n))return!0;if(1024&i&&1024&a){if(1048576&i&&1048576&a&&c_(e.symbol,t.symbol,n))return!0;if(2944&i&&2944&a&&e.value===t.value&&c_(Gt(e.symbol),Gt(t.symbol),n))return!0}if(32768&i&&(!kT||49152&a))return!0;if(65536&i&&(!kT||65536&a))return!0;if(524288&i&&67108864&a)return!0;if(r===dA||r===pA){if(1&i)return!0;if(264&i&&!(1024&i)&&(32&a||256&a&&1024&a))return!0}return!1}function l_(e,t,r){if(wu(e)&&(e=e.regularType),wu(t)&&(t=t.regularType),e===t||r===pA&&!(131072&t.flags)&&u_(t,e,r)||r!==fA&&u_(e,t,r))return!0;if(524288&e.flags&&524288&t.flags){var n=r.get(C_(e,t,r));if(void 0!==n)return 1===n}return 66846720&e.flags||66846720&t.flags?d_(e,t,r,void 0):!1}function __(t,r){return 4096&e.getObjectFlags(t)&&!mg(r.escapedName)}function d_(t,r,n,i,a,o,s){function c(t,r,n,a,o){e.Debug.assert(!!i),X=e.chainDiagnosticMessages(X,t,r,n,a,o)}function u(t){e.Debug.assert(!!X),Y?Y.push(t):Y=[t]}function l(t,r,i){var a=Nr(r,i),o=a[0],s=a[1];262144&i.flags&&void 0!==i.immediateBaseConstraint&&Pl(r,i.immediateBaseConstraint)&&c(e.Diagnostics._0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2,o,s,Er(i.immediateBaseConstraint)),t||(t=n===pA?e.Diagnostics.Type_0_is_not_comparable_to_type_1:o===s?e.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated:e.Diagnostics.Type_0_is_not_assignable_to_type_1),c(t,o,s)}function _(t,r){var n=Er(t),i=Er(r);(WE===t&&sE===r||HE===t&&cE===r||GE===t&&fE===r||Rs(!1)===t&&mE===r)&&c(e.Diagnostics._0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible,i,n)}function d(t,r,n){if(q_(t)){var i=t.target;return i&&i.readonly&&W_(r)&&(!z_(r)||td(r)&&!r.target.readonly)?(n&&c(e.Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1,Er(t),Er(r)),!1):U_(r)}return q_(r)?U_(t):z_(t)&&J_(r)&&!z_(r)?(n&&c(e.Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1,Er(t),Er(r)),!1):!0}function p(t,r,a,o,s){if(void 0===a&&(a=!1),wu(t)&&(t=t.regularType),wu(r)&&(r=r.regularType),33554432&t.flags&&(t=t.substitute),33554432&r.flags&&(r=r.typeVariable),25165824&t.flags&&(t=$c(t,!1)),25165824&r.flags&&(r=$c(r,!0)),1048576&r.flags&&524288&t.flags&&r.types.length<=3&&Ph(r,98304)){var u=_f(r,-98305);1179648&u.flags||(r=u)}if(t===r)return-1;if(n===fA)return m(t,r);if(n===pA&&!(131072&r.flags)&&u_(r,t,n)||u_(t,r,n,a?c:void 0))return-1;var v=!!(4096&e.getObjectFlags(t)),y=ap(t)&&32768&e.getObjectFlags(t);if(y){var h=1048576&r.flags?k(t,r):void 0;if(g(t,r,h,a))return a&&l(o,t,r),0}if(n!==pA&&!s&&2752508&t.flags&&t!==JE&&2621440&r.flags&&f_(r)&&(Pa(t).length>0||nC(t))&&!m_(t,r,v)){if(a){var x=so(t,0),D=so(t,1);x.length>0&&p(Mo(x[0]),r,!1)||D.length>0&&p(Mo(D[0]),r,!1)?c(e.Diagnostics.Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it,Er(t),Er(r)):c(e.Diagnostics.Type_0_has_no_properties_in_common_with_type_1,Er(t),Er(r))}return 0}var S=0,C=X,A=!!s;if(1048576&t.flags)S=n===pA?E(t,r,a&&!(131068&t.flags)):N(t,r,a&&!(131068&t.flags));else{if(1048576&r.flags){if(S=b(hd(t),r,!(!a||131068&t.flags||131068&r.flags)),S&&y){var h=1048576&r.flags?k(t,r):void 0;if(!J(t,h||r,a,void 0))return 0}}else if(2097152&r.flags){if(A=!0,S=T(hd(t),r,a),S&&y&&!J(t,r,a,void 0))return 0}else 2097152&t.flags&&(S=E(t,r,!1));!S&&(66846720&t.flags||66846720&r.flags)&&(S=F(t,r,a,A))&&(X=C)}if(!S&&2097152&t.flags){var P=Ua(t,!!(1048576&r.flags));P&&(S=p(P,r,a,void 0,A))&&(X=C)}if(!S&&a){var w=tt;if(tt=void 0,524288&t.flags&&524288&r.flags){var I=X;d(t,r,a),X!==I&&(w=X)}if(524288&t.flags&&131068&r.flags)_(t,r);else if(t.symbol&&524288&t.flags&&JE===t)c(e.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);else if(v&&2097152&r.flags){var O=r.types,M=xg(f.IntrinsicAttributes,i),L=xg(f.IntrinsicClassAttributes,i);if(M!==tE&&L!==tE&&(e.contains(O,M)||e.contains(O,L)))return S}if(!o&&w)return S;l(o,t,r)}return S}function m(e,t){var r,n=e.flags&t.flags;return 524288&n||8388608&n||16777216&n||4194304&n||33554432&n?F(e,t,!1,!1):3145728&n&&(r=h(e,t))&&(r&=h(t,e))?r:0}function g(t,r,a,o){if(!AT&&16384&e.getObjectFlags(r))return!1;if(jg(r)){var s=!!(4096&e.getObjectFlags(t));if((n===dA||n===pA)&&(nf(JE,r)||!s&&a_(r)))return!1;if(a)return g(t,a,void 0,o);for(var u=function(n){if(v(n,t.symbol)&&!Bg(r,n.escapedName,s)){if(o){var a=cf(r,jg);if(!i)return{value:e.Debug.fail()};if(e.isJsxAttributes(i)||e.isJsxOpeningLikeElement(i)||e.isJsxOpeningLikeElement(i.parent))c(e.Diagnostics.Property_0_does_not_exist_on_type_1,kr(n),Er(a));else{var u=t.symbol&&e.firstOrUndefined(t.symbol.declarations),l=void 0;if(n.valueDeclaration&&e.findAncestor(n.valueDeclaration,function(e){return e===u})){var _=n.valueDeclaration;e.Debug.assertNode(_,e.isObjectLiteralElementLike),i=_;var d=_.name;e.isIdentifier(d)&&(l=ov(d,a))}void 0!==l?c(e.Diagnostics.Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2,kr(n),Er(a),l):c(e.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1,kr(n),Er(a))}}return{value:!0}}},l=0,_=Pa(t);l<_.length;l++){var d=_[l],p=u(d);if("object"==typeof p)return p.value}}return!1}function v(e,t){return e.valueDeclaration&&t.valueDeclaration&&e.valueDeclaration.parent===t.valueDeclaration}function h(e,t){for(var r=-1,n=e.types,i=0,a=n;i<a.length;i++){var o=a[i],s=b(o,t,!1);if(!s)return 0;r&=s}return r}function b(e,t,r){var n=t.types;if(1048576&t.flags&&fc(n,e))return-1;for(var i=0,a=n;i<a.length;i++){var o=a[i],s=p(e,o,!1);if(s)return s}if(r){var c=k(e,t)||x(e,t)||D(e,t)||S(e,t)||C(e,t);p(e,c||n[n.length-1],!0)}return 0}function x(t,r){var n=e.getObjectFlags(t);return 20&n&&1048576&r.flags?e.find(r.types,function(r){if(524288&r.flags){var i=n&e.getObjectFlags(r);if(4&i)return t.target===r.target;if(16&i)return!!t.aliasSymbol&&t.aliasSymbol===r.aliasSymbol}return!1}):void 0}function D(t,r){return 128&e.getObjectFlags(t)&&of(r,U_)?e.find(r.types,function(e){return!U_(e)}):void 0}function S(t,r){var n=0,i=so(t,n).length>0||(n=1,so(t,n).length>0);return i?e.find(r.types,function(e){return so(e,n).length>0}):void 0}function C(t,r){for(var n,i=0,a=0,o=r.types;a<o.length;a++){var s=o[a],c=Ic([Vc(t),Vc(s)]);if(4194304&c.flags)n=s,i=1/0;else if(1048576&c.flags){var u=e.length(e.filter(c.types,Q_));u>=i&&(n=s,i=u)}else Q_(c)&&1>=i&&(n=s,i=1)}return n}function k(t,r){if(1048576&r.flags&&2621440&t.flags){var n=Pa(t);if(n){var i=Cp(n,r);if(i)return p_(r,e.map(i,function(e){return[function(){return Un(e)},e.escapedName]}),p)}}return void 0}function T(e,t,r){for(var n=-1,i=t.types,a=0,o=i;a<o.length;a++){var s=o[a],c=p(e,s,r,void 0,!0);if(!c)return 0;n&=c}return n}function E(e,t,r){var n=e.types;if(1048576&e.flags&&fc(n,t))return-1;for(var i=n.length,a=0;i>a;a++){var o=p(n[a],t,r&&a===i-1);if(o)return o}return 0}function N(e,t,r){for(var n=-1,i=e.types,a=0,o=i;a<o.length;a++){var s=o[a],c=p(s,t,r);if(!c)return 0;n&=c}return n}function A(t,r,i,a){if(void 0===t&&(t=e.emptyArray),void 0===r&&(r=e.emptyArray),void 0===i&&(i=e.emptyArray),t.length!==r.length&&n===fA)return 0;for(var o=t.length<=r.length?t.length:r.length,s=-1,c=0;o>c;c++){var u=c<i.length?i[c]:1,l=7&u;if(4!==l){var _=t[c],d=r[c],f=-1;if(8&u?f=n===fA?p(_,d,!1):El(_,d):1===l?f=p(_,d,a):2===l?f=p(d,_,a):3===l?(f=p(d,_,!1),f||(f=p(_,d,a))):(f=p(_,d,a),f&&(f&=p(d,_,a))),!f)return 0;s&=f}}return s}function F(e,t,r,i){if(at)return 0;var a=C_(e,t,n),o=n.get(a);if(void 0!==o&&(!r||2!==o))return 1===o?-1:0;if(Z){for(var s=0;rt>s;s++)if(a===Z[s])return 1;if(100===nt)return at=!0,0}else Z=[],$=[],et=[];var c=rt;Z[rt]=a,rt++,$[nt]=e,et[nt]=t,nt++;var u=it;1&it||!F_(e,$,nt)||(it|=1),2&it||!F_(t,et,nt)||(it|=2);var l=3!==it?P(e,t,r,i):1;if(it=u,nt--,l){if(-1===l||0===nt){for(var s=c;rt>s;s++)n.set(Z[s],1);rt=c}}else n.set(a,r?3:2),rt=c;return l}function P(t,r,i,a){function o(t,r,n){if(u=A(t,r,n,i))return u;if(e.some(n,function(e){return!!(24&e)}))return l=void 0,void(X=d);var a=r&&b_(r,n);if(_=!a,n!==e.emptyArray&&!a){if(_&&(!i||!e.some(n,function(e){return 0===(7&e)})))return 0;l=X,X=d}}var s=t.flags&r.flags;if(n===fA&&!(524288&s)){if(4194304&s)return p(t.type,r.type,!1);var c=0;return 8388608&s&&(c=p(t.objectType,r.objectType,!1))&&(c&=p(t.indexType,r.indexType,!1))?c:16777216&s&&t.root.isDistributive===r.root.isDistributive&&(c=p(t.checkType,r.checkType,!1))&&(c&=p(t.extendsType,r.extendsType,!1))&&(c&=p(du(t),du(r),!1))&&(c&=p(pu(t),pu(r),!1))?c:33554432&s?p(t.substitute,r.substitute,!1):0}var u,l,_=!1,d=X;if(17301504&t.flags&&t.aliasSymbol&&t.aliasTypeArguments&&t.aliasSymbol===r.aliasSymbol&&!t.aliasTypeArgumentsContainsMarker&&!r.aliasTypeArgumentsContainsMarker){var f=v_(t.aliasSymbol),m=o(t.aliasTypeArguments,r.aliasTypeArguments,f);if(void 0!==m)return m}if(262144&r.flags){if(32&e.getObjectFlags(t)&&p(Vc(r),ga(t))&&!(4&xa(t))){var g=va(t),v=ou(r,ma(t));if(u=p(g,v,i))return u}}else if(4194304&r.flags){if(4194304&t.flags&&(u=p(r.type,t.type,!1)))return u;var y=Ra(r.type);if(y&&-1===p(t,Vc(y,r.stringsOnly),i))return-1}else if(8388608&r.flags){if(n!==fA){var h=r.objectType,b=r.indexType,x=Ka(h)||h,D=Ka(b)||b;if(!Xc(x)&&!Yc(D)){var S=2|(x!==h?1:0),y=su(x,D,void 0,S);if(y&&(u=p(t,y,i)))return u}}}else if(ka(r)){var C=va(r),k=xa(r);if(!(8&k)){if(8388608&C.flags&&C.objectType===t&&C.indexType===ma(r))return-1;if(!ka(t)){var T=ga(r),E=Vc(t,void 0,!0),N=4&k&&1048576&T.flags,F=N?cf(T,function(e){return!!p(e,E)}):void 0;if(N?!(131072&F.flags):p(T,E)){var P=N?F:ma(r),v=ou(t,P),g=va(r);if(u=p(v,g,i))return u}l=X,X=d}}}if(8650752&t.flags)if(8388608&t.flags&&8388608&r.flags){if((u=p(t.objectType,r.objectType,i))&&(u&=p(t.indexType,r.indexType,i)),u)return X=d,u}else{var y=Oa(t);if(!y||262144&t.flags&&1&y.flags){if(u=p(kE,_f(r,-67108865)))return X=d,u}else{if(u=p(y,r,!1,void 0,a))return X=d,u;if(u=p(Vi(y,t),r,i,void 0,a))return X=d,u}}else if(4194304&t.flags){if(u=p(SE,r,i))return X=d,u}else if(16777216&t.flags)if(16777216&r.flags){if(Tl(t.extendsType,r.extendsType)&&(p(t.checkType,r.checkType)||p(r.checkType,t.checkType))&&((u=p(du(t),du(r),i))&&(u&=p(pu(t),pu(r),i)),u))return X=d,u}else{var w=Ja(t);if(w&&(u=p(w,r,i)))return X=d,u;var I=ja(t);if(I&&(u=p(I,r,i)))return X=d,u}else{if(n!==_A&&Ca(r)&&a_(t))return-1;if(ka(r))return ka(t)&&(u=M(t,r,i))?(X=d,u):0;var O=!!(131068&t.flags);if(n!==fA&&(t=to(t)),4&e.getObjectFlags(t)&&4&e.getObjectFlags(r)&&t.target===r.target&&!(8192&e.getObjectFlags(t)||8192&e.getObjectFlags(r))){var f=h_(t.target),m=o(t.typeArguments,r.typeArguments,f);if(void 0!==m)return m}else{if(z_(r)?J_(t)||td(t):J_(r)&&td(t)&&!t.target.readonly)return p(_o(t,1)||ZT,_o(r,1)||ZT,i);if(n===_A&&a_(r)&&32768&e.getObjectFlags(r)&&!a_(t))return 0}if(2621440&t.flags&&524288&r.flags){var R=i&&X===d&&!O;if(u=J(t,r,R,void 0),u&&(u&=V(t,r,0,R),u&&(u&=V(t,r,1,R),u&&(u&=H(t,r,0,O,R),u&&(u&=H(t,r,1,O,R))))),_&&u)X=l||X||d;else if(u)return u}if(2621440&t.flags&&1048576&r.flags){var B=_f(r,524288);if(1048576&B.flags){var j=L(t,B);if(j)return j}}}return 0}function w(e){return!aA||e!==OE&&e!==ME&&e!==bN||aA(!1),e}function O(e){return!aA||e!==OE&&e!==ME&&e!==bN||aA(!0),e}function M(e,t,r){var i=n===pA||(n===fA?xa(e)===xa(t):Sa(e)<=Sa(t));if(i){var a,o=ga(t),s=gl(ga(e),Sa(e)<0?w:O);if(a=p(o,s,r)){var c=Wu([ma(e)],[ma(t)]);return a&p(gl(va(e),c),va(t),r)}}return 0}function L(t,r){var n=Ea(t),i=Cp(n,r);if(!i)return 0;for(var a=1,o=0,s=i;o<s.length;o++){var c=s[o];if(a*=uf(Un(c)),a>25)return 0}for(var u=new Array(i.length),l=e.createUnderscoreEscapedMap(),_=0;_<i.length;_++){var c=i[_],d=Un(c);u[_]=1048576&d.flags?d.types:[d],l.set(c.escapedName,!0)}for(var p=e.cartesianProduct(u),f=[],m=function(n){var a=!1;e:for(var o=0,s=r.types;o<s.length;o++){for(var c=s[o],u=function(e){var a=i[e],o=Na(c,a.escapedName);if(!o)return"continue-outer";if(a===o)return"continue";var s=j(t,r,a,o,function(){return n[e]},!1);return s?void 0:"continue-outer"},l=0;l<i.length;l++){var _=u(l);switch(_){case"continue-outer":continue e}}e.pushIfUnique(f,c,e.equateValues),a=!0}return a?void 0:{value:0}},g=0,v=p;g<v.length;g++){var y=v[g],h=m(y);if("object"==typeof h)return h.value}for(var b=-1,x=0,D=f;x<D.length;x++){var S=D[x];if(b&=J(t,S,!1,l),b&&(b&=V(t,S,0,!1),b&&(b&=V(t,S,1,!1),b&&(b&=H(t,S,0,!1,!1),b&&(b&=H(t,S,1,!1,!1))))),!b)return b}return b}function R(e,t){if(!t||0===e.length)return e;for(var r,n=0;n<e.length;n++)t.has(e[n].escapedName)?r||(r=e.slice(0,n)):r&&r.push(e[n]);return r||e}function B(t,r,n,i){var a=kT&&!!(48&e.getCheckFlags(r)),o=n(t);if(65536&e.getCheckFlags(r)&&!I(r).type){var s=I(r);e.Debug.assertDefined(s.deferralParent),e.Debug.assertDefined(s.deferralConstituents);for(var c=!!(1048576&s.deferralParent.flags),u=c?0:-1,l=s.deferralConstituents,_=0,d=l;_<d.length;_++){var f=d[_],m=p(o,f,!1,void 0,!c);if(c){if(m)return m}else{if(!m)return p(o,un(Un(r),a),i);u&=m}}return c&&!u&&a&&(u=p(o,nE)),c&&!u&&i?p(o,un(Un(r),a),i):u}return p(o,un(Un(r),a),i)}function j(t,r,i,a,o,s){var u=e.getDeclarationModifierFlagsFromSymbol(i),l=e.getDeclarationModifierFlagsFromSymbol(a);if(8&u||8&l){var _=i.valueDeclaration!==a.valueDeclaration;if(1024&e.getCheckFlags(i)&&_)return s&&c(e.Diagnostics.Property_0_has_conflicting_declarations_and_is_inaccessible_in_type_1,kr(i),Er(t)),0;if(_)return s&&(8&u&&8&l?c(e.Diagnostics.Types_have_separate_declarations_of_a_private_property_0,kr(a)):c(e.Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2,kr(a),Er(8&u?t:r),Er(8&u?r:t))),0}else if(16&l){if(!N_(i,a))return s&&c(e.Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2,kr(a),Er(T_(i)||t),Er(T_(a)||r)),0}else if(16&u)return s&&c(e.Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2,kr(a),Er(t),Er(r)),0;var d=B(i,a,o,s);return d?n!==pA&&16777216&i.flags&&!(16777216&a.flags)?(s&&c(e.Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2,kr(a),Er(t),Er(r)),0):d:(s&&c(e.Diagnostics.Types_of_property_0_are_incompatible,kr(a)),0)}function J(t,r,i,o){if(n===fA)return z(t,r,o);var s=n===_A&&!ap(t)&&!K_(t)&&!td(t),l=Yd(t,r,s,!1);if(l){if(i){var _=e.arrayFrom(Xd(t,r,s,!1)),f=!1;if((!a||a.code!==e.Diagnostics.Class_0_incorrectly_implements_interface_1.code&&a.code!==e.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code)&&(f=!0),1===_.length){var m=kr(l);c.apply(void 0,[e.Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2,m].concat(Nr(t,r))),e.length(l.declarations)&&u(e.createDiagnosticForNode(l.declarations[0],e.Diagnostics._0_is_declared_here,m)),f&&(tt=X)}else d(t,r,!1)&&(_.length>5?c(e.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more,Er(t),Er(r),e.map(_.slice(0,4),function(e){return kr(e)}).join(", "),_.length-4):c(e.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2,Er(t),Er(r),e.map(_,function(e){return kr(e)}).join(", ")),f&&(tt=X))}return 0}if(ap(r))for(var g=0,v=R(Pa(t),o);g<v.length;g++){var y=v[g];if(!Na(r,y.escapedName)){var h=Un(y);if(h!==nE&&h!==iE)return i&&c(e.Diagnostics.Property_0_does_not_exist_on_type_1,kr(y),Er(r)),0}}var b=-1;if(td(r)){var x=rd(r);if(x){if(!td(t))return 0;var D=rd(t);if(D&&!p(D,x,i))return i&&c(e.Diagnostics.Rest_signatures_are_incompatible),0;for(var S=cs(r)-1,C=cs(t)-(D?1:0),k=S;C>k;k++){var T=p(t.typeArguments[k],x,i);if(!T)return i&&c(e.Diagnostics.Property_0_is_incompatible_with_rest_element_type,""+k),0;b&=T}}}for(var E=1048576&r.flags?Fa(r):Pa(r),N=0,A=R(E,o);N<A.length;N++){var F=A[N];if(!(4194304&F.flags)){var y=ao(t,F.escapedName);if(y&&y!==F){var T=j(t,r,y,F,Un,i);if(!T)return 0;b&=T}}}return b}function z(e,t,r){if(!(524288&e.flags&&524288&t.flags))return 0;var n=R(Ea(e),r),i=R(Ea(t),r);if(n.length!==i.length)return 0;for(var a=-1,o=0,s=n;o<s.length;o++){var c=s[o],u=Na(t,c.escapedName);if(!u)return 0;var l=w_(c,u,p);if(!l)return 0;a&=l}return a}function V(t,r,i,a){if(n===fA)return K(t,r,i);if(r===FE||t===FE)return-1;var o=t.symbol&&Dy(t.symbol.valueDeclaration),s=r.symbol&&Dy(r.symbol.valueDeclaration),u=so(t,o&&1===i?0:i),l=so(r,s&&1===i?0:i);if(1===i&&u.length&&l.length){if(e.isAbstractConstructorType(t)&&!e.isAbstractConstructorType(r))return a&&c(e.Diagnostics.Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type),0;if(!Q(u[0],l[0],a))return 0}var _=-1,d=X;if(64&e.getObjectFlags(t)&&64&e.getObjectFlags(r)&&t.symbol===r.symbol)for(var p=0;p<l.length;p++){var f=U(u[p],l[p],!0,a);if(!f)return 0;_&=f}else if(1===u.length&&1===l.length){var m=n===pA||!!xT.noStrictGenericChecks;_=U(u[0],l[0],m,a)}else e:for(var g=0,v=l;g<v.length;g++){for(var y=v[g],h=a,b=0,x=u;b<x.length;b++){var D=x[b],f=U(D,y,!0,h);if(f){_&=f,X=d;continue e}h=!1}return h&&c(e.Diagnostics.Type_0_provides_no_match_for_the_signature_1,Er(t),Tr(y,void 0,void 0,i)),0}return _}function U(e,t,r,n){return t_(r?Ko(e):e,r?Ko(t):t,0,!1,n,c,p)}function K(e,t,r){var n=so(e,r),i=so(t,r);if(n.length!==i.length)return 0;for(var a=-1,o=0;o<n.length;o++){var s=O_(n[o],i[o],!1,!1,!1,p);if(!s)return 0;a&=s}return a}function q(t,r,n,i){for(var a=-1,o=0,s=Ea(t);o<s.length;o++){var u=s[o];if(!__(t,u)&&!(u.nameType&&8192&u.nameType.flags||0!==n&&!ig(u.escapedName))){var l=p(Un(u),r,i);if(!l)return i&&c(e.Diagnostics.Property_0_is_incompatible_with_index_signature,kr(u)),0;a&=l}}return a}function W(t,r,n){var i=p(t.type,r.type,n);return!i&&n&&c(e.Diagnostics.Index_signatures_are_incompatible),i}function H(t,r,i,a,o){if(n===fA)return G(t,r,i);var s=lo(r,i);if(!s||1&s.type.flags&&!a)return-1;var u=lo(t,i)||1===i&&lo(t,0);if(u)return W(u,s,o);if(ka(t))return 0===i&&p(va(t),s.type,o);if(gd(t)){var l=-1;if(0===i){var _=lo(t,1);_&&(l=W(_,s,o))}return l&&(l&=q(t,s.type,i,o)),l}return o&&c(e.Diagnostics.Index_signature_is_missing_in_type_0,Er(t)),0}function G(e,t,r){var n=lo(t,r),i=lo(e,r);return i||n?i&&n&&i.isReadonly===n.isReadonly?p(i.type,n.type):0:-1}function Q(t,r,n){if(!t.declaration||!r.declaration)return!0;var i=e.getSelectedModifierFlags(t.declaration,24),a=e.getSelectedModifierFlags(r.declaration,24);return 8===a?!0:16===a&&8!==i?!0:16===a||i?(n&&c(e.Diagnostics.Cannot_assign_a_0_constructor_type_to_a_1_constructor_type,Ir(i),Ir(a)),!1):!0}var X,Y,Z,$,et,tt,rt=0,nt=0,it=0,at=!1;e.Debug.assert(n!==fA||!i,"no error reporting in identity checking");var ot=p(t,r,!!i,a);if(at)y(i,e.Diagnostics.Excessive_stack_depth_comparing_types_0_and_1,Er(t),Er(r));else if(X){if(o){var st=o();st&&(X=e.concatenateDiagnosticMessageChains(st,X))}var ct=void 0;if(a&&i&&!ot&&t.symbol){var ut=I(t.symbol);if(ut.originatingImport&&!e.isImportCall(ut.originatingImport)){var lt=d_(Un(ut.target),r,n,void 0);if(lt){var _t=e.createDiagnosticForNode(ut.originatingImport,e.Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead);ct=e.append(ct,_t)}}}var dt=e.createDiagnosticForNodeFromMessageChain(i,X,ct);Y&&e.addRelatedInfo.apply(void 0,[dt].concat(Y)),s&&(s.error=dt),tA.add(dt)}return 0!==ot}function p_(e,t,r,n){for(var i,a=0,o=t;a<o.length;a++)for(var s=o[a],c=s[0],u=s[1],l=0,_=e.types;l<_.length;l++){var d=_[l],p=Hr(d,u);if(p&&r(c(),p)){if(i){if(d===i)continue;return n}i=d}}return i||n}function f_(t){if(524288&t.flags){var r=Ta(t);return 0===r.callSignatures.length&&0===r.constructSignatures.length&&!r.stringIndexInfo&&!r.numberIndexInfo&&r.properties.length>0&&e.every(r.properties,function(e){return!!(16777216&e.flags)})}return 2097152&t.flags?e.every(t.types,f_):!1}function m_(e,t,r){for(var n=0,i=Pa(e);n<i.length;n++){var a=i[n];if(Bg(t,a.escapedName,r))return!0}return!1}function g_(t,r,n){var i=os(t,e.map(t.typeParameters,function(e){return e===r?n:e}));return i.objectFlags|=8192,i}function v_(e){var t=I(e);return y_(t.typeParameters,t,function(r,n,i){var a=ls(e,zu(t.typeParameters,Uu(n,i)));return a.aliasTypeArgumentsContainsMarker=!0,a})}function y_(t,r,n){void 0===t&&(t=e.emptyArray);var i=r.variances;if(!i){r.variances=e.emptyArray,i=[];for(var a=function(e){var t=!1,a=!1,o=aA;aA=function(e){return e?a=!0:t=!0};var s=n(r,e,OE),c=n(r,e,ME),u=(Pl(c,s)?1:0)|(Pl(s,c)?2:0);if(3===u&&Pl(n(r,e,bN),s)&&(u=4),aA=o,t||a){t&&(u|=8),a&&(u|=16);var l=C_(c,s,dA),_=C_(s,c,dA);dA.delete(l),dA.delete(_)}i.push(u)},o=0,s=t;o<s.length;o++){var c=s[o];a(c)}r.variances=i}return i}function h_(t){return t===KE||t===qE||8&t.objectFlags?e.emptyArray:y_(t.typeParameters,t,g_)}function b_(e,t){for(var r=0;r<t.length;r++)if(1===(7&t[r])&&16384&e[r].flags)return!0;return!1}function x_(e){return 262144&e.flags&&!Ma(e)}function D_(t){return!!(4&e.getObjectFlags(t))&&e.some(t.typeArguments,function(e){return x_(e)||D_(e)})}function S_(e,t,r){void 0===r&&(r=0);for(var n=""+e.target.id,i=0,a=e.typeArguments;i<a.length;i++){var o=a[i];if(x_(o)){var s=t.indexOf(o);0>s&&(s=t.length,t.push(o)),n+="="+s}else n+=4>r&&D_(o)?"<"+S_(o,t,r+1)+">":"-"+o.id}return n}function C_(e,t,r){if(r===fA&&e.id>t.id){var n=e;e=t,t=n}if(D_(e)&&D_(t)){var i=[];return S_(e,i)+","+S_(t,i)}return e.id+","+t.id}function k_(t,r){if(6&e.getCheckFlags(t)){for(var n=0,i=t.containingType.types;n<i.length;n++){var a=i[n],o=ao(a,t.escapedName),s=o&&k_(o,r);if(s)return s}return void 0}return r(t)}function T_(e){return e.parent&&32&e.parent.flags?bi(Gt(e)):void 0}function E_(e,t){return k_(e,function(e){var r=T_(e);return r?Wn(r,t):!1})}function N_(t,r){return!k_(r,function(r){return 16&e.getDeclarationModifierFlagsFromSymbol(r)?!E_(t,T_(r)):!1})}function A_(t,r){return k_(r,function(r){return 16&e.getDeclarationModifierFlagsFromSymbol(r)?!Wn(t,T_(r)):!1})?void 0:t}function F_(e,t,r){if(r>=5&&524288&e.flags){var n=e.symbol;if(n)for(var i=0,a=0;r>a;a++){var o=t[a];if(524288&o.flags&&o.symbol===n&&(i++,i>=5))return!0}}return!1}function P_(e,t){return 0!==w_(e,t,El)}function w_(t,r,n){if(t===r)return-1;var i=24&e.getDeclarationModifierFlagsFromSymbol(t),a=24&e.getDeclarationModifierFlagsFromSymbol(r);if(i!==a)return 0;if(i){if(JD(t)!==JD(r))return 0}else if((16777216&t.flags)!==(16777216&r.flags))return 0;return bh(t)!==bh(r)?0:n(Un(t),Un(r))}function I_(e,t,r){var n=Wy(e),i=Wy(t),a=Hy(e),o=Hy(t),s=Gy(e),c=Gy(t);return n===i&&a===o&&s===c?!0:r&&o>=a?!0:!1}function O_(t,r,n,i,a,o){if(t===r)return-1;if(!I_(t,r,n))return 0;if(e.length(t.typeParameters)!==e.length(r.typeParameters))return 0;t=Ko(t),r=Ko(r);var s=-1;if(!i){var c=Po(t);if(c){var u=Po(r);if(u){var l=o(c,u);if(!l)return 0;s&=l}}}for(var _=Wy(r),d=0;_>d;d++){var p=Uy(t,d),f=Uy(r,d),l=o(f,p);if(!l)return 0;s&=l}if(!a){var m=Io(t),g=Io(r);s&=void 0!==m||void 0!==g?M_(m,g,o):o(Mo(t),Mo(r))}return s}function M_(e,t,r){return void 0!==e&&void 0!==t&&Cc(e,t)?r(e.type,t.type):0}function L_(e){for(var t,r=0,n=e;r<n.length;r++){var i=n[r],a=Y_(i);if(t||(t=a),a===i||a!==t)return!1}return!0}function R_(t){return L_(t)?Dc(t):e.reduceLeft(t,function(e,t){return Fl(e,t)?t:e})}function B_(t){if(!kT)return R_(t);var r=e.filter(t,function(e){return!(98304&e.flags)});return r.length?_d(R_(r),98304&od(t)):Dc(t,2)}function j_(t){return e.reduceLeft(t,function(e,t){return Fl(t,e)?t:e})}function J_(t){return!!(4&e.getObjectFlags(t))&&(t.target===KE||t.target===qE)}function z_(t){return!!(4&e.getObjectFlags(t))&&t.target===qE}function V_(e){return J_(e)&&e.typeArguments?e.typeArguments[0]:void 0}function U_(e){return J_(e)||!(98304&e.flags)&&Pl(e,$E)}function K_(e){var t=J_(e)?e.typeArguments[0]:void 0;return t===iE||t===bE}function q_(e){return td(e)||!!ao(e,"0")}function W_(e){return U_(e)||q_(e)}function H_(e,t){var r=Hr(e,""+t);return r?r:sf(e,td)&&!sf(e,function(e){return!e.target.hasRestElement})?lf(e,function(e){return rd(e)||nE}):void 0}function G_(e){return!(240512&e.flags)}function Q_(e){return!!(109440&e.flags)}function X_(t){return 16&t.flags?!0:1048576&t.flags?1024&t.flags?!0:e.every(t.types,Q_):Q_(t)}function Y_(t){return 1024&t.flags?mi(t):128&t.flags?sE:256&t.flags?cE:2048&t.flags?uE:512&t.flags?fE:1048576&t.flags?Dc(e.sameMap(t.types,Y_)):t}function Z_(t){return 1024&t.flags&&wu(t)?mi(t):128&t.flags&&wu(t)?sE:256&t.flags&&wu(t)?cE:2048&t.flags&&wu(t)?uE:512&t.flags&&wu(t)?fE:1048576&t.flags?Dc(e.sameMap(t.types,Z_)):t}function $_(t){return 8192&t.flags?mE:1048576&t.flags?Dc(e.sameMap(t.types,$_)):t}function ed(e,t){return nb(e,t)||(e=$_(Z_(e))),e}function td(t){return!!(4&e.getObjectFlags(t)&&8&t.target.objectFlags)}function rd(e){return e.target.hasRestElement?e.typeArguments[e.target.typeParameters.length-1]:void 0}function nd(e){var t=rd(e);return t&&ic(t)}function id(e){return cs(e)-(e.target.hasRestElement?1:0)}function ad(e){var t=e.value;return"0"===t.base10Value}function od(e){for(var t=0,r=0,n=e;r<n.length;r++){var i=n[r];t|=sd(i)}return t}function sd(e){return 1048576&e.flags?od(e.types):128&e.flags?""===e.value?128:0:256&e.flags?0===e.value?256:0:2048&e.flags?ad(e)?2048:0:512&e.flags?e===lE||e===_E?512:0:117724&e.flags}function cd(e){return 117632&sd(e)?cf(e,function(e){return!(117632&sd(e))}):e}function ud(e){return lf(e,ld)}function ld(e){return 4&e.flags?IN:8&e.flags?ON:64&e.flags?MN:e===_E||e===lE||114688&e.flags||128&e.flags&&""===e.value||256&e.flags&&0===e.value||2048&e.flags&&ad(e)?e:vE}function _d(e,t){var r=t&~e.flags&98304;return 0===r?e:Dc(32768===r?[e,nE]:65536===r?[e,aE]:[e,nE,aE])}function dd(t){return e.Debug.assert(kT),32768&t.flags?t:Dc([t,nE])}function pd(e){return eN||(eN=Ps("NonNullable",524288,void 0)||XT),eN!==XT?ls(eN,[e]):Ip(e,2097152)}function fd(e){return kT?pd(e):e}function md(e,t){return 0!==(524&e.flags)&&0!==(28&t.flags)}function gd(e){return e.symbol&&0!==(6656&e.symbol.flags)&&!nC(e)}function vd(e,t){var r=x(e.flags,e.escapedName);return r.declarations=e.declarations,r.parent=e.parent,r.type=t,r.target=e,e.valueDeclaration&&(r.valueDeclaration=e.valueDeclaration),e.nameType&&(r.nameType=e.nameType),r}function yd(t,r){for(var n=e.createSymbolTable(),i=0,a=Ea(t);i<a.length;i++){var o=a[i],s=Un(o),c=r(s);n.set(o.escapedName,c===s?o:vd(o,c))}return n}function hd(t){if(!(ap(t)&&32768&e.getObjectFlags(t)))return t;var r=t.regularType;if(r)return r;var n=t,i=yd(t,hd),a=lr(n.symbol,i,n.callSignatures,n.constructSignatures,n.stringIndexInfo,n.numberIndexInfo);return a.flags=n.flags,a.objectFlags|=-32769&n.objectFlags,t.regularType=a,a}function bd(e,t,r){return{parent:e,propertyName:t,siblings:r,resolvedProperties:void 0}}function xd(e){if(!e.siblings){for(var t=[],r=0,n=xd(e.parent);r<n.length;r++){var i=n[r];if(ap(i)){var a=Na(i,e.propertyName);a&&of(Un(a),function(e){t.push(e)})}}e.siblings=t}return e.siblings}function Dd(t){if(!t.resolvedProperties){for(var r=e.createMap(),n=0,i=xd(t);n<i.length;n++){var a=i[n];if(ap(a)&&!(1024&e.getObjectFlags(a)))for(var o=0,s=Pa(a);o<s.length;o++){var c=s[o];r.set(c.escapedName,c)}}t.resolvedProperties=e.arrayFrom(r.values())}return t.resolvedProperties}function Sd(e,t){if(!(4&e.flags))return e;var r=Un(e),n=t&&bd(t,e.escapedName,void 0),i=Ed(r,n);return i===r?e:vd(e,i)}function Cd(e){var t=QT.get(e.escapedName);if(t)return t;var r=vd(e,nE);return r.flags|=16777216,QT.set(e.escapedName,r),r}function kd(t,r){for(var n=e.createSymbolTable(),i=0,a=Ea(t);i<a.length;i++){var o=a[i];n.set(o.escapedName,Sd(o,r))}if(r)for(var s=0,c=Dd(r);s<c.length;s++){var o=c[s];n.has(o.escapedName)||n.set(o.escapedName,Cd(o))}var u=lo(t,0),l=lo(t,1),_=lr(t.symbol,n,e.emptyArray,e.emptyArray,u&&Zo(Td(u.type),u.isReadonly),l&&Zo(Td(l.type),l.isReadonly));return _.objectFlags|=540672&e.getObjectFlags(t),_}function Td(e){return Ed(e,void 0)}function Ed(t,r){if(393216&e.getObjectFlags(t)){if(void 0===r&&t.widened)return t.widened;var n=void 0;if(98304&t.flags)n=ZT;else if(ap(t))n=kd(t,r);else if(1048576&t.flags){var i=r||bd(void 0,void 0,t.types),a=e.sameMap(t.types,function(e){return 98304&e.flags?e:Ed(e,i)});n=Dc(a,e.some(a,a_)?2:1)}else 2097152&t.flags?n=Ic(e.sameMap(t.types,Td)):(J_(t)||td(t))&&(n=os(t.target,e.sameMap(t.typeArguments,Td)));return n&&void 0===r&&(t.widened=n),n||t}return t}function Nd(t){var r=!1;if(131072&e.getObjectFlags(t)){if(1048576&t.flags)if(e.some(t.types,a_))r=!0;else for(var n=0,i=t.types;n<i.length;n++){var a=i[n];Nd(a)&&(r=!0)}if(J_(t)||td(t))for(var o=0,s=t.typeArguments;o<s.length;o++){var a=s[o];Nd(a)&&(r=!0)}if(ap(t))for(var c=0,u=Ea(t);c<u.length;c++){var l=u[c],a=Un(l);131072&e.getObjectFlags(a)&&(Nd(a)||y(l.valueDeclaration,e.Diagnostics.Object_literal_s_property_0_implicitly_has_an_1_type,kr(l),Er(Td(a))),r=!0)}}return r}function Ad(t,r){var n=Er(Td(r));if(!e.isInJSFile(t)||e.isCheckJsEnabledForFile(e.getSourceFileOfNode(t),xT)){var i;switch(t.kind){case 205:case 155:case 154:i=AT?e.Diagnostics.Member_0_implicitly_has_an_1_type:e.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;break;case 152:var a=t;if(e.isIdentifier(a.name)&&(e.isCallSignatureDeclaration(a.parent)||e.isMethodSignature(a.parent)||e.isFunctionTypeNode(a.parent))&&a.parent.parameters.indexOf(a)>-1&&(j(a,a.name.escapedText,67897832,void 0,a.name.escapedText,!0)||a.name.originalKeywordKind&&e.isTypeNodeKind(a.name.originalKeywordKind))){var o="arg"+a.parent.parameters.indexOf(a);return void b(AT,t,e.Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1,o,e.declarationNameToString(a.name))}i=t.dotDotDotToken?AT?e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type:e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage:AT?e.Diagnostics.Parameter_0_implicitly_has_an_1_type:e.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;break;case 187:if(i=e.Diagnostics.Binding_element_0_implicitly_has_an_1_type,!AT)return;break;case 295:return void y(t,e.Diagnostics.Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type,n);case 240:case 157:case 156:case 159:case 160:case 197:case 198:if(AT&&!t.name)return void y(t,e.Diagnostics.Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type,n);i=AT?e.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type:e.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage;break;case 182:return void(AT&&y(t,e.Diagnostics.Mapped_object_type_implicitly_has_an_any_template_type));default:i=AT?e.Diagnostics.Variable_0_implicitly_has_an_1_type:e.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage}b(AT,t,i,e.declarationNameToString(e.getNameOfDeclaration(t)),n)}}function Fd(t,r){l&&AT&&131072&e.getObjectFlags(r)&&(Nd(r)||Ad(t,r))}function Pd(e,t,r){var n=Wy(e),i=Wy(t),a=Qy(e),o=Qy(t),s=o?i-1:i,c=a?s:Math.min(n,s),u=Po(e);if(u){var l=Po(t);l&&r(u,l)}for(var _=0;c>_;_++)r(Uy(e,_),Uy(t,_));o&&r(qy(e,c),o)}function wd(e,t,r){var n=Io(e),i=Io(t);n&&i&&n.kind===i.kind&&(0===n.kind||n.parameterIndex===i.parameterIndex)?r(n.type,i.type):r(Mo(e),Mo(t))}function Id(e,t,r,n){return Ld(e.map(Bd),t,r,n||Nl)
}function Od(t,r){return void 0===r&&(r=0),t&&Ld(e.map(t.inferences,jd),t.signature,t.flags|r,t.compareTypes)}function Md(t){var r=e.filter(t.inferences,lb);return r.length?Ld(e.map(r,jd),t.signature,t.flags,t.compareTypes):void 0}function Ld(e,t,r,n){var i={inferences:e,signature:t,flags:r,compareTypes:n,mapper:function(e){return Rd(i,e,!0)},nonFixingMapper:function(e){return Rd(i,e,!1)}};return i}function Rd(e,t,r){for(var n=e.inferences,i=0;i<n.length;i++){var a=n[i];if(t===a.typeParameter)return r&&!a.isFixed&&(a.isFixed=!0,a.inferredType=void 0),up(e,i)}return t}function Bd(e){return{typeParameter:e,candidates:void 0,contraCandidates:void 0,inferredType:void 0,priority:void 0,topLevel:!0,isFixed:!1}}function jd(e){return{typeParameter:e.typeParameter,candidates:e.candidates&&e.candidates.slice(),contraCandidates:e.contraCandidates&&e.contraCandidates.slice(),inferredType:e.inferredType,priority:e.priority,topLevel:e.topLevel,isFixed:e.isFixed}}function Jd(e){return e&&e.mapper}function zd(t){var r=e.getObjectFlags(t);return!!(63176704&t.flags||4&r&&e.forEach(t.typeArguments,zd)||16&r&&t.symbol&&14384&t.symbol.flags&&t.symbol.declarations||32&r||3145728&t.flags&&Vd(t))}function Vd(t){return void 0===t.couldContainTypeVariables&&(t.couldContainTypeVariables=e.some(t.types,zd)),t.couldContainTypeVariables}function Ud(t,r){return t===r||!!(3145728&t.flags)&&e.some(t.types,function(e){return Ud(e,r)})}function Kd(t){var r=e.createSymbolTable();of(t,function(t){if(128&t.flags){var n=e.escapeLeadingUnderscores(t.value),i=x(4,n);i.type=ZT,t.symbol&&(i.declarations=t.symbol.declarations,i.valueDeclaration=t.symbol.valueDeclaration),r.set(n,i)}});var n=4&t.flags?Zo(kE,!1):void 0;return lr(void 0,r,e.emptyArray,e.emptyArray,n,void 0)}function qd(e,t,r){var n=e.id+","+t.id+","+r.id;if(EN.has(n))return EN.get(n);EN.set(n,void 0);var i=Hd(e,t,r);return EN.set(n,i),i}function Wd(t){return!(524288&e.getObjectFlags(t))||ap(t)&&e.some(Pa(t),function(e){return Wd(Un(e))})}function Hd(t,r,n){if(!(lo(t,0)||0!==Pa(t).length&&Wd(t)))return void 0;if(J_(t))return ic(Qd(t.typeArguments[0],r,n),z_(t));if(td(t)){var i=e.map(t.typeArguments||e.emptyArray,function(e){return Qd(e,r,n)}),a=4&xa(r)?cs(t)-(t.target.hasRestElement?1:0):t.target.minLength;return uc(i,a,t.target.hasRestElement,t.target.readonly,t.target.associatedNames)}var o=ir(2064,void 0);return o.source=t,o.mappedType=r,o.constraintType=n,o}function Gd(e){return Qd(e.propertyType,e.mappedType,e.constraintType)}function Qd(e,t,r){var n=ou(r.type,ma(t)),i=va(t),a=Bd(n);return tp([a],e,i),ep(a)||rE}function Xd(t,r,n,i){var o,s,c,u,l,_,d;return a(this,function(a){switch(a.label){case 0:o=1048576&r.flags?Fa(r):Pa(r),s=0,c=o,a.label=1;case 1:return s<c.length?(u=c[s],!n&&(16777216&u.flags||48&e.getCheckFlags(u))?[3,5]:(l=ao(t,u.escapedName),l?[3,3]:[4,u])):[3,6];case 2:return a.sent(),[3,5];case 3:return i?(_=Un(u),109440&_.flags?(d=Un(l),1&d.flags||Pu(d)===Pu(_)?[3,5]:[4,u]):[3,5]):[3,5];case 4:a.sent(),a.label=5;case 5:return s++,[3,1];case 6:return[2]}})}function Yd(e,t,r,n){return Xd(e,t,r,n).next().value}function Zd(e,t){return t.target.minLength>e.target.minLength||!rd(t)&&(!!rd(e)||id(t)<id(e))}function $d(e,t){return td(e)&&td(t)&&Zd(e,t)||!!Yd(e,t,!1,!0)&&!!Yd(t,e,!1,!0)}function ep(e){return e.candidates?Dc(e.candidates,2):e.contraCandidates?Ic(e.contraCandidates):void 0}function tp(t,r,n,i,a){function o(t,r){function u(t,r){var n=t.id+","+r.id;g&&g.get(n)||((g||(g=e.createMap())).set(n,!0),o(t,r))}if(zd(r)){if(t===eE){var _=v;return v=t,o(r,r),void(v=_)}if(t.aliasSymbol&&t.aliasTypeArguments&&t.aliasSymbol===r.aliasSymbol)for(var d=t.aliasTypeArguments,p=r.aliasTypeArguments,f=0;f<d.length;f++)o(d[f],p[f]);else{if(1048576&t.flags&&1048576&r.flags&&!(1024&t.flags&&1024&r.flags)||2097152&t.flags&&2097152&r.flags){if(t===r){for(var b=0,x=t.types;b<x.length;b++){var D=x[b];o(D,D)}return}for(var S=void 0,C=0,k=t.types;C<k.length;C++){var D=k[C];if(rp(D,r.types))(S||(S=[])).push(D),o(D,D);else if(384&D.flags){var T=Y_(D);rp(T,r.types)&&(S||(S=[])).push(D,T)}}S&&(t=np(t,S),r=np(r,S))}else 41943040&r.flags&&(r=lu(r));if(8650752&r.flags){if(524288&e.getObjectFlags(t)||t===yE||16&i&&(t===$T||t===ZE))return;var E=c(r);if(E){if(!E.isFixed){if((void 0===E.priority||i<E.priority)&&(E.candidates=void 0,E.contraCandidates=void 0,E.topLevel=!0,E.priority=i),i===E.priority){var N=v||t;a&&!y?e.contains(E.contraCandidates,N)||(E.contraCandidates=e.append(E.contraCandidates,N),E.inferredType=void 0):e.contains(E.candidates,N)||(E.candidates=e.append(E.candidates,N),E.inferredType=void 0)}!(16&i)&&262144&r.flags&&E.topLevel&&!Ud(n,r)&&(E.topLevel=!1,E.inferredType=void 0)}return}var A=$c(r,!1);if(A!==r)u(t,A);else if(8388608&r.flags){var F=$c(r.indexType,!1);if(63176704&F.flags){var P=eu($c(r.objectType,!1),F,!1);P&&P!==r&&u(t,P)}}}if(4&e.getObjectFlags(t)&&4&e.getObjectFlags(r)&&t.target===r.target)for(var d=t.typeArguments||e.emptyArray,p=r.typeArguments||e.emptyArray,w=d.length<p.length?d.length:p.length,I=h_(t.target),f=0;w>f;f++)f<I.length&&2===(7&I[f])?s(d[f],p[f]):o(d[f],p[f]);else if(4194304&t.flags&&4194304&r.flags)a=!a,o(t.type,r.type),a=!a;else if((X_(t)||4&t.flags)&&4194304&r.flags){var O=Kd(t);a=!a;var M=i;i|=32,o(O,r.type),i=M,a=!a}else if(8388608&t.flags&&8388608&r.flags)o(t.objectType,r.objectType),o(t.indexType,r.indexType);else if(16777216&t.flags&&16777216&r.flags)o(t.checkType,r.checkType),o(t.extendsType,r.extendsType),o(du(t),du(r)),o(pu(t),pu(r));else if(16777216&r.flags&&!a)o(t,du(r)),o(t,pu(r));else if(3145728&r.flags){for(var L=0,R=0,B=r.types;R<B.length;R++){var D=B[R];c(D)?L++:o(t,D)}if(1048576&r.flags?0!==L:1===L){var M=i;i|=1;for(var j=0,J=r.types;j<J.length;j++){var D=J[j];c(D)&&o(t,D)}i=M}}else if(1048576&t.flags)for(var d=t.types,z=0,V=d;z<V.length;z++){var U=V[z];o(U,r)}else{if(!(64&i&&65273856&t.flags)){var K=to(t);if(K!==t&&h&&!(2621440&K.flags))return h=!1,o(K,r);t=K}if(2621440&t.flags){var q=t.id+","+r.id;if(g&&g.get(q))return;(g||(g=e.createMap())).set(q,!0);var W=524288&r.flags&&!(16&e.getObjectFlags(r)&&r.symbol&&32&r.symbol.flags),H=W?r.symbol:void 0;if(H){if(e.contains(m,H))return;(m||(m=[])).push(H),l(t,r),m.pop()}else l(t,r)}}}}}function s(e,t){TT||128&i?(a=!a,o(e,t),a=!a):o(e,t)}function c(e){if(8650752&e.flags)for(var r=0,n=t;r<n.length;r++){var i=n[r];if(e===i.typeParameter)return i}return void 0}function u(t,r,n){if(1048576&n.flags){for(var a=!1,s=0,l=n.types;s<l.length;s++){var _=l[s];a=u(t,r,_)||a}return a}if(4194304&n.flags){var d=c(n.type);if(d&&!d.isFixed){var p=qd(t,r,n);if(p){var f=i;i|=524288&e.getObjectFlags(t)?4:2,o(p,d.typeParameter),i=f}}return!0}if(262144&n.flags){var f=i;i|=8,o(Vc(t),n),i=f;var m=Oa(n);if(m&&u(t,r,m))return!0;var g=e.map(Pa(t),Un),v=_o(t,0),y=zc(t),h=y&&y.type;return o(Dc(e.append(e.append(g,v),h)),va(r)),!0}return!1}function l(t,r){if(ka(t)&&ka(r)&&(o(ga(t),ga(r)),o(va(t),va(r))),32&e.getObjectFlags(r)){var n=ga(r);if(u(t,r,n))return}$d(t,r)||(_(t,r),d(t,r,0),d(t,r,1),f(t,r))}function _(e,t){if(J_(e)||td(e)){if(td(t)){for(var r=td(e)?id(e):0,n=id(t),i=td(e)?rd(e):V_(e),a=rd(t),s=r>n||i?n:r,c=0;s>c;c++)o(r>c?e.typeArguments[c]:i,t.typeArguments[c]);if(a){var u=r>s?e.typeArguments.slice(s,r):[];i&&u.push(i),u.length&&o(Dc(u),a)}return}if(J_(t))return void f(e,t)}for(var l=Ea(t),_=0,d=l;_<d.length;_++){var p=d[_],m=ao(e,p.escapedName);m&&o(Un(m),Un(p))}}function d(t,r,n){for(var i=so(t,n),a=so(r,n),o=i.length,s=a.length,c=s>o?o:s,u=!!(524288&e.getObjectFlags(t)),l=0;c>l;l++)p(Go(i[o-c+l]),Go(a[s-c+l]),u)}function p(e,t,r){if(!r){var n=y,i=t.declaration?t.declaration.kind:0;y=y||157===i||156===i||158===i,Pd(e,t,s),y=n}wd(e,t,o)}function f(e,t){var r=_o(t,0);if(r){var n=_o(e,0)||po(e,0);n&&o(n,r)}var i=_o(t,1);if(i){var n=_o(e,1)||_o(e,0)||po(e,1);n&&o(n,i)}}void 0===i&&(i=0),void 0===a&&(a=!1);var m,g,v,y=!1,h=!0;o(r,n)}function rp(e,t){for(var r=0,n=t;r<n.length;r++){var i=n[r];if(Tl(i,e))return!0}return!1}function np(e,t){for(var r=[],n=0,i=e.types;n<i.length;n++){var a=i[n];rp(a,t)||r.push(a)}return 1048576&e.flags?Dc(r):Ic(r)}function ip(e){var t=Ma(e);return!!t&&Ph(16777216&t.flags?ja(t):t,4325372)}function ap(t){return!!(128&e.getObjectFlags(t))}function op(t){if(t.length>1){var r=e.filter(t,ap);if(r.length){var n=Td(Dc(r,2));return e.concatenate(e.filter(t,function(e){return!ap(e)}),[n])}}return t}function sp(e){return 56&e.priority?Ic(e.contraCandidates):j_(e.contraCandidates)}function cp(t,r){var n=op(t.candidates),i=ip(t.typeParameter),a=!i&&t.topLevel&&(t.isFixed||!Ud(Mo(r),t.typeParameter)),o=i?e.sameMap(n,Pu):a?e.sameMap(n,Z_):n,s=56&t.priority?Dc(o,2):B_(o);return Td(s)}function up(e,t){var r=e.inferences[t];if(!r.inferredType){var n=void 0,i=e.signature;if(i){var a=r.candidates?cp(r,i):void 0;if(r.contraCandidates){var o=sp(r);n=!a||131072&a.flags||!Fl(a,o)?o:a}else if(a)n=a;else if(1&e.flags)n=yE;else{var s=Xa(r.typeParameter);s&&(n=gl(s,Qu(Gu(e,t),e.nonFixingMapper)))}}else n=ep(r);r.inferredType=n||lp(!!(2&e.flags));var c=Ma(r.typeParameter);if(c){var u=gl(c,e.nonFixingMapper);n&&e.compareTypes(n,Vi(u,n))||(r.inferredType=n=u)}}return r.inferredType}function lp(e){return e?ZT:rE}function _p(e){for(var t=[],r=0;r<e.inferences.length;r++)t.push(up(e,r));return t}function dp(t){switch(t.escapedText){case"document":case"console":return e.Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom;case"$":return xT.types?e.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig:e.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_types_Slashjquery;case"describe":case"suite":case"it":case"test":return xT.types?e.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_types_Slashjest_or_npm_i_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig:e.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_types_Slashjest_or_npm_i_types_Slashmocha;case"process":case"require":case"Buffer":case"module":return xT.types?e.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig:e.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_types_Slashnode;case"Map":case"Set":case"Promise":case"Symbol":case"WeakMap":case"WeakSet":case"Iterator":case"AsyncIterator":return e.Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later;default:return 277===t.parent.kind?e.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer:e.Diagnostics.Cannot_find_name_0}}function pp(t){var r=O(t);return r.resolvedSymbol||(r.resolvedSymbol=!e.nodeIsMissing(t)&&j(t,t.escapedText,68268991,dp(t),t,!e.isWriteOnlyAccess(t),!1,e.Diagnostics.Cannot_find_name_0_Did_you_mean_1)||XT),r.resolvedSymbol}function fp(t){return!!e.findAncestor(t,function(e){return 168===e.kind?!0:73===e.kind||149===e.kind?!1:"quit"})}function mp(e,n,i,a){switch(e.kind){case 73:var o=pp(e);return o!==XT?(a?t(a):"-1")+"|"+pc(n)+"|"+pc(i)+"|"+(Rf(e)?"@":"")+r(o):void 0;case 101:return"0";case 214:case 196:return mp(e.expression,n,i,a);case 190:case 191:var s=vp(e);if(void 0!==s){var c=mp(e.expression,n,i,a);return c&&c+"."+s}}return void 0}function gp(t,r){switch(r.kind){case 196:case 214:return gp(t,r.expression)}switch(t.kind){case 73:return 73===r.kind&&pp(t)===pp(r)||(238===r.kind||187===r.kind)&&Zt(pp(t))===Ht(r);case 101:return 101===r.kind;case 99:return 99===r.kind;case 214:case 196:return gp(t.expression,r);case 190:case 191:return e.isAccessExpression(r)&&vp(t)===vp(r)&&gp(t.expression,r.expression)}return!1}function vp(t){return 190===t.kind?t.name.escapedText:e.isStringLiteral(t.argumentExpression)||e.isNumericLiteral(t.argumentExpression)?e.escapeLeadingUnderscores(t.argumentExpression.text):void 0}function yp(t,r){for(;e.isAccessExpression(t);)if(t=t.expression,gp(t,r))return!0;return!1}function hp(t,r){var n;return e.isAccessExpression(r)&&yp(t,r.expression)&&void 0!==(n=vp(r))&&Dp(bp(r.expression),n)}function bp(t){if(73===t.kind)return Un(pp(t));if(e.isAccessExpression(t)){var r=bp(t.expression);if(r){var n=vp(t);return void 0!==n?Hr(r,n):void 0}}return void 0}function xp(e){return!!(1048576&e.flags&&(1040&e.flags||!Yc(e)))}function Dp(t,r){if(t&&1048576&t.flags){var n=no(t,r);if(n&&2&e.getCheckFlags(n))return void 0===n.isDiscriminantProperty&&(n.isDiscriminantProperty=192===(192&n.checkFlags)&&xp(Un(n))),!!n.isDiscriminantProperty}return!1}function Sp(t){return e.isAccessExpression(t)&&101===t.expression.kind&&!!(8&t.expression.flags)}function Cp(e,t){for(var r,n=0,i=e;n<i.length;n++){var a=i[n];if(Dp(t,a.escapedName)){if(r){r.push(a);continue}r=[a]}}return r}function kp(e,t){return gp(e,t)||yp(e,t)}function Tp(e,t){if(e.arguments)for(var r=0,n=e.arguments;r<n.length;r++){var i=n[r];if(kp(t,i))return!0}return 190===e.expression.kind&&kp(t,e.expression.expression)?!0:!1}function Ep(e){return e.id||(e.id=p,p++),e.id}function Np(e,t){if(!(1048576&e.flags))return Pl(e,t);for(var r=0,n=e.types;r<n.length;r++){var i=n[r];if(Pl(i,t))return!0}return!1}function Ap(e,t){if(e!==t){if(131072&t.flags)return t;var r=cf(e,function(e){return Np(t,e)});if(512&t.flags&&wu(t)&&(r=lf(r,Fu)),Pl(t,r))return r}return e}function Fp(e){for(var t=0,r=0,n=e;r<n.length;r++){var i=n[r];t|=wp(i)}return t}function Pp(e){var t=Ta(e);return!!(t.callSignatures.length||t.constructSignatures.length||t.members.get("bind")&&Fl(e,zE))}function wp(t){var r=t.flags;if(4&r)return kT?16317953:16776705;if(128&r){var n=""===t.value;return kT?n?12123649:7929345:n?12582401:16776705}if(40&r)return kT?16317698:16776450;if(256&r){var i=0===t.value;return kT?i?12123394:7929090:i?12582146:16776450}if(64&r)return kT?16317188:16775940;if(2048&r){var i=ad(t);return kT?i?12122884:7928580:i?12581636:16775940}return 16&r?kT?16316168:16774920:528&r?kT?t===lE||t===_E?12121864:7927560:t===lE||t===_E?12580616:16774920:524288&r?16&e.getObjectFlags(t)&&a_(t)?kT?16318463:16777215:Pp(t)?kT?7880640:16728e3:kT?7888800:16736160:49152&r?9830144:65536&r?9363232:12288&r?kT?7925520:16772880:67108864&r?kT?7888800:16736160:63176704&r?wp(Ka(t)||rE):3145728&r?Fp(t.types):16777215}function Ip(e,t){return cf(e,function(e){return 0!==(wp(e)&t)})}function Op(e,t){if(t){var r=gb(t);return Dc([Ip(e,524288),r])}return e}function Mp(e,t){var r=Rc(t);if(!Fi(r))return tE;var n=Li(r);return jf(Hr(e,n),t)||ig(n)&&_o(e,1)||_o(e,0)||tE}function Lp(e,t){return sf(e,q_)&&H_(e,t)||pD(e,void 0,!1,!1)||tE}function Rp(e){return ic(pD(e,void 0,!1,!1)||tE)}function Bp(e){var t=188===e.parent.kind&&jp(e.parent)||276===e.parent.kind&&jp(e.parent.parent);return t?Op(Kp(e),e.right):gb(e.right)}function jp(e){return 205===e.parent.kind&&e.parent.left===e||228===e.parent.kind&&e.parent.initializer===e}function Jp(e,t){return Lp(Kp(e),e.elements.indexOf(t))}function zp(e){return Rp(Kp(e.parent))}function Vp(e){return Mp(Kp(e.parent),e.name)}function Up(e){return Op(Vp(e),e.objectAssignmentInitializer)}function Kp(e){var t=e.parent;switch(t.kind){case 227:return sE;case 228:return dD(t.expression,t.awaitModifier)||tE;case 205:return Bp(t);case 199:return nE;case 188:return Jp(t,e);case 209:return zp(t);case 276:return Vp(t);case 277:return Up(t)}return tE}function qp(e){var t=e.parent,r=Gp(t.parent),n=185===t.kind?Mp(r,e.propertyName||e.name):e.dotDotDotToken?Rp(r):Lp(r,t.elements.indexOf(e));return Op(n,e.initializer)}function Wp(e){var t=O(e);return t.resolvedType||gb(e)}function Hp(e){return e.initializer?Wp(e.initializer):227===e.parent.parent.kind?sE:228===e.parent.parent.kind?dD(e.parent.parent.expression,e.parent.parent.awaitModifier)||tE:tE}function Gp(e){return 238===e.kind?Hp(e):qp(e)}function Qp(e,t){return jf(238===e.kind||187===e.kind?Gp(e):Kp(e),t)}function Xp(e){return 238===e.kind&&e.initializer&&cn(e.initializer)||187!==e.kind&&205===e.parent.kind&&cn(e.parent.right)}function Yp(e){switch(e.kind){case 196:return Yp(e.expression);case 205:switch(e.operatorToken.kind){case 60:return Yp(e.left);case 27:return Yp(e.right)}}return e}function Zp(e){var t=e.parent;return 196===t.kind||205===t.kind&&60===t.operatorToken.kind&&t.left===e||205===t.kind&&27===t.operatorToken.kind&&t.right===e?Zp(t):e}function $p(e){return 272===e.kind?Pu(gb(e.expression)):vE}function ef(e){var t=O(e);if(!t.switchTypes){t.switchTypes=[];for(var r=0,n=e.caseBlock.clauses;r<n.length;r++){var i=n[r];t.switchTypes.push($p(i))}}return t.switchTypes}function tf(t){for(var r=[],n=0,i=t.caseBlock.clauses;n<i.length;n++){var a=i[n];if(272===a.kind){if(10===a.expression.kind){r.push(a.expression.text);continue}return e.emptyArray}r.push(void 0)}return r}function rf(t,r){return 1048576&t.flags?!e.forEach(t.types,function(t){return!e.contains(r,t)}):e.contains(r,t)}function nf(e,t){return e===t||1048576&t.flags&&af(e,t)}function af(e,t){if(1048576&e.flags){for(var r=0,n=e.types;r<n.length;r++){var i=n[r];if(!fc(t.types,i))return!1}return!0}return 1024&e.flags&&mi(e)===t?!0:fc(t.types,e)}function of(t,r){return 1048576&t.flags?e.forEach(t.types,r):r(t)}function sf(t,r){return 1048576&t.flags?e.every(t.types,r):r(t)}function cf(t,r){if(1048576&t.flags){var n=t.types,i=e.filter(n,r);return i===n?t:kc(i,t.objectFlags)}return r(t)?t:vE}function uf(e){return 1048576&e.flags?e.types.length:1}function lf(e,t,r){if(131072&e.flags)return e;if(!(1048576&e.flags))return t(e);for(var n,i=0,a=e.types;i<a.length;i++){var o=a[i],s=t(o);s&&(n?n.push(s):n=[s])}return n&&Dc(n,r?0:1)}function _f(e,t){return cf(e,function(e){return 0!==(e.flags&t)})}function df(e,t){return nf(sE,e)&&Ph(t,128)||nf(cE,e)&&Ph(t,256)||nf(uE,e)&&Ph(t,2048)?lf(e,function(e){return 4&e.flags?_f(t,132):8&e.flags?_f(t,264):64&e.flags?_f(t,2112):e}):e}function pf(e){return 0===e.flags}function ff(e){return 0===e.flags?e.type:e}function mf(e,t){return t?{flags:0,type:e}:e}function gf(e){var t=ir(256);return t.elementType=e,t}function vf(e){return GT[e.id]||(GT[e.id]=gf(e))}function yf(e,t){var r=Y_(vb(t));return nf(r,e.elementType)?e:vf(Dc([e.elementType,r]))}function hf(e){return 131072&e.flags?ZE:ic(1048576&e.flags?Dc(e.types,2):e)}function bf(e){return e.finalArrayType||(e.finalArrayType=hf(e.elementType))}function xf(t){return 256&e.getObjectFlags(t)?bf(t):t}function Df(t){return 256&e.getObjectFlags(t)?t.elementType:vE}function Sf(t){for(var r=!1,n=0,i=t;n<i.length;n++){var a=i[n];if(!(131072&a.flags)){if(!(256&e.getObjectFlags(a)))return!1;r=!0}}return r}function Cf(t,r){return Sf(t)?vf(Dc(e.map(t,Df))):Dc(e.sameMap(t,xf),r)}function kf(t){var r=Zp(t),n=r.parent,i=190===n.kind&&("length"===n.name.escapedText||192===n.parent.kind&&e.isPushOrUnshiftIdentifier(n.name)),a=191===n.kind&&n.expression===r&&205===n.parent.kind&&60===n.parent.operatorToken.kind&&n.parent.left===n&&!e.isAssignmentTarget(n.parent)&&wh(gb(n.argumentExpression),296);return i||a}function Tf(e){var t=O(e);return void 0===t.maybeTypePredicate&&(t.maybeTypePredicate=Ef(e)),t.maybeTypePredicate}function Ef(t){if(99!==t.expression.kind){var r=Wg(t.expression);if(r!==yE){var n=to(r);return n!==tE&&e.some(so(n,0),wo)}}return!1}function Nf(t){var r=e.findAncestor(t,e.isFunctionOrModuleBlock),n=e.getSourceFileOfNode(t),i=e.getSpanOfTokenAtPosition(n,r.statements.pos);tA.add(e.createFileDiagnostic(n,i.start,i.length,e.Diagnostics.The_containing_function_or_module_body_is_too_large_for_control_flow_analysis))}function Af(t,r,n,i,a){function o(){return P?F:(P=!0,F=mp(t,r,n,i))}function s(e){if(2e3===w)return wN=!0,Nf(t),tE;for(w++;;){var a=e.flags;if(8192&a){var f=o();if(f){var m=Ep(e);if(qN[m]===f)return WN[m]}}if(1024&a)for(var g=I;PN>g;g++)if(XN[g]===e)return w--,YN[g];var v=void 0;if(4096&a)e.locked=!0,v=s(e.antecedent),e.locked=!1;else{if(2048&a){e=e.antecedent;continue}if(16&a){if(v=c(e),!v){e=e.antecedent;continue}if(FN===AN){var y=o();if(y&&!pf(v)){e.flags|=8192;var m=Ep(e);qN[m]=y,WN[m]=v}}}else if(96&a)v=l(e);else if(128&a)v=_(e);else if(12&a){if(1===e.antecedents.length){e=e.antecedents[0];continue}v=4&a?d(e):p(e)}else if(256&a){if(v=u(e),!v){e=e.antecedent;continue}}else if(2&a){var h=e.container;if(h&&h!==i&&190!==t.kind&&191!==t.kind&&101!==t.kind){e=h.flowNode;continue}v=n}else v=Xx(r)}return 1024&a&&(XN[PN]=e,YN[PN]=v,PN++),w--,v}}function c(n){var i=n.node;if(gp(t,i)){if(2===e.getAssignmentTargetKind(i)){var a=s(n.antecedent);return mf(Y_(ff(a)),pf(a))}if(r===$T||r===ZE){if(Xp(i))return vf(vE);var o=Y_(Qp(i,t));return Pl(o,r)?o:YE}return 1048576&r.flags?Ap(r,Qp(i,t)):r}if(yp(t,i)){if(e.isVariableDeclaration(i)&&(e.isInJSFile(i)||e.isVarConst(i))){var c=e.getDeclaredExpandoInitializer(i);if(c&&(197===c.kind||198===c.kind))return s(n.antecedent)}return r}return e.isVariableDeclaration(i)&&227===i.parent.parent.kind&&gp(t,i.parent.parent.expression)?Hg(ff(s(n.antecedent))):void 0}function u(n){if(r===$T||r===ZE){var i=n.node,a=192===i.kind?i.expression.expression:i.left.expression;if(gp(t,Yp(a))){var o=s(n.antecedent),c=ff(o);if(256&e.getObjectFlags(c)){var u=c;if(192===i.kind)for(var l=0,_=i.arguments;l<_.length;l++){var d=_[l];u=yf(u,d)}else{var p=vb(i.left.argumentExpression);wh(p,296)&&(u=yf(u,i.right))}return u===c?o:mf(u,pf(o))}return o}}return void 0}function l(e){var t=s(e.antecedent),r=ff(t);if(131072&r.flags)return t;var n=0!==(32&e.flags),i=xf(r),a=A(i,e.expression,n);if(a===i)return t;var o=pf(t),c=o&&131072&a.flags?yE:a;return mf(c,o)}function _(e){var n=e.switchStatement.expression,i=s(e.antecedent),a=ff(i);return gp(t,n)?a=D(a,e.switchStatement,e.clauseStart,e.clauseEnd):f(n,a)?a=m(a,n,function(t){return D(t,e.switchStatement,e.clauseStart,e.clauseEnd)}):200===n.kind&&gp(t,n.expression)?a=k(a,e.switchStatement,e.clauseStart,e.clauseEnd):hp(t,n)&&(a=r),mf(a,pf(i))}function d(t){for(var i=[],a=!1,o=!1,c=0,u=t.antecedents;c<u.length;c++){var l=u[c];if(!(2048&l.flags&&l.lock.locked)){var _=s(l),d=ff(_);if(d===r&&r===n)return d;e.pushIfUnique(i,d),nf(d,r)||(a=!0),pf(_)&&(o=!0)}}return mf(Cf(i,a?2:1),o)}function p(t){var n=Ep(t),i=KN[n]||(KN[n]=e.createMap()),a=o();if(!a)return r;var c=i.get(a);if(c)return c;for(var u=AN;FN>u;u++)if(HN[u]===t&&GN[u]===a&&QN[u].length)return mf(Cf(QN[u],1),!0);var l,_=[],d=!1;HN[FN]=t,GN[FN]=a,QN[FN]=_;for(var p=0,f=t.antecedents;p<f.length;p++){var m=f[p];FN++;var g=s(m);FN--,l||(l=g);var v=ff(g),y=i.get(a);if(y)return y;if(e.pushIfUnique(_,v),nf(v,r)||(d=!0),v===r)break}var h=Cf(_,d?2:1);return pf(l)?mf(h,!0):(i.set(a,h),h)}function f(r,n){if(!(1048576&n.flags&&e.isAccessExpression(r)))return!1;var i=vp(r);return void 0===i?!1:gp(t,r.expression)&&Dp(n,i)}function m(e,t,r){var n=vp(t);if(void 0===n)return e;var i=Hr(e,n),a=i&&r(i);return i===a?e:cf(e,function(e){return Il(Gr(e,n),a)})}function g(e,n,i){return gp(t,n)?Ip(e,i?4194304:8388608):f(n,r)?m(e,n,function(e){return Ip(e,i?4194304:8388608)}):hp(t,n)?r:e}function v(e,t,r){if(lo(e,0))return!0;var n=ao(e,t);return n?16777216&n.flags?!0:r:!r}function y(t,r,n){if(1572864&t.flags||Zc(t)){var i=e.escapeLeadingUnderscores(r.text);return cf(t,function(e){return v(e,i,n)})}return t}function h(n,i,a){switch(i.operatorToken.kind){case 60:return g(A(n,i.right,a),i.left,a);case 33:case 34:case 35:case 36:var o=i.operatorToken.kind,s=Yp(i.left),c=Yp(i.right);if(200===s.kind&&e.isStringLiteralLike(c))return x(n,s,o,c,a);if(200===c.kind&&e.isStringLiteralLike(s))return x(n,c,o,s,a);if(gp(t,s))return b(n,o,c,a);if(gp(t,c))return b(n,o,s,a);if(f(s,r))return m(n,s,function(e){return b(e,o,c,a)});if(f(c,r))return m(n,c,function(e){return b(e,o,s,a)});if(hp(t,s)||hp(t,c))return r;break;case 95:return T(n,i,a);case 94:var u=Yp(i.right);if(e.isStringLiteralLike(i.left)&&gp(t,u))return y(n,i.left,a);break;case 27:return A(n,i.right,a)}return n}function b(e,t,r,n){if(1&e.flags)return e;(34===t||36===t)&&(n=!n);var i=gb(r);if(2&e.flags&&35===t&&n)return 67239932&i.flags?i:524288&i.flags?xE:e;if(98304&i.flags){if(!kT)return e;var a=33===t||34===t,o=a?n?262144:2097152:65536&i.flags?n?131072:1048576:n?65536:524288;return Ip(e,o)}if(67637251&e.flags)return e;if(n){var s=33===t?function(e){return Ol(e,i)||md(e,i)}:function(e){return Ol(e,i)},c=cf(e,s);return 131072&c.flags?e:df(c,i)}if(Q_(i)){var u=Pu(i);return cf(e,function(e){return Pu(e)!==u})}return e}function x(e,n,i,a,o){function s(e){if(2&e.flags&&"object"===a.text)return Dc([xE,aE]);var t="function"===a.text?zE:uA.get(a.text);if(t){if(Fl(e,t))return e;if(Fl(t,e))return t;if(63176704&e.flags){var r=Ka(e)||ZT;if(Fl(t,r))return Ic([e,t])}}return e}var c=Yp(n.expression);if(!gp(t,c))return yp(t,c)?r:e;if((34===i||36===i)&&(o=!o),1&e.flags&&"function"===a.text)return e;var u=o?sA.get(a.text)||128:cA.get(a.text)||32768;return Ip(o?lf(e,s):e,u)}function D(t,r,n,i){var a=ef(r);if(!a.length)return t;var o=a.slice(n,i),s=n===i||e.contains(o,vE);if(2&t.flags&&!s){for(var c=void 0,u=0;u<o.length;u+=1){var l=o[u];if(67239932&l.flags)void 0!==c&&c.push(l);else{if(!(524288&l.flags))return t;void 0===c&&(c=o.slice(0,u)),c.push(xE)}}return Dc(void 0===c?o:c)}var _=Dc(o),d=131072&_.flags?vE:df(cf(t,function(e){return Ol(_,e)}),_);if(!s)return d;var p=cf(t,function(t){return!(Q_(t)&&e.contains(a,Pu(t)))});return 131072&d.flags?p:Dc([d,p])}function S(e,t){switch(t){case"function":return 1&e.flags?e:zE;case"object":return 2&e.flags?Dc([xE,aE]):e;default:return uA.get(t)||e}}function C(e){return function(t){if(Fl(e,t))return e;if(63176704&t.flags){var r=Ka(t)||ZT;if(Fl(e,r))return Ic([t,e])}return t}}function k(t,r,n,i){var a=tf(r);if(!a.length)return t;var o,s,c=e.findIndex(a,function(e){return void 0===e}),u=n===i||c>=n&&i>c;if(c>-1){var l=a.filter(function(e){return void 0!==e}),_=n>c?n-1:n,d=i>c?i-1:i;o=l.slice(_,d),s=uh(_,d,l,u)}else o=a.slice(n,i),s=uh(n,i,a,u);if(u)return cf(t,function(e){return(wp(e)&s)===s});var p=Ip(Dc(o.map(function(e){return S(t,e)})),s);return 1048576&p.flags&&(p=Ap(p,qa(t))),Ip(lf(t,C(p)),s)}function T(n,i,a){var o=Yp(i.left);if(!gp(t,o))return yp(t,o)&&!Sp(t)?r:n;var s=gb(i.right);if(!wl(s,zE))return n;var c,u=ao(s,"prototype");if(u){var l=Un(u);Qr(l)||(c=l)}if(Qr(n)&&(c===JE||c===zE))return n;if(!c){var _=so(s,1);c=_.length?Dc(e.map(_,function(e){return Mo(Ko(e))})):kE}return E(n,c,a,wl)}function E(e,t,r,n){if(!r)return cf(e,function(e){return!n(e,t)});if(1048576&e.flags){var i=cf(e,function(e){return n(e,t)});if(!(131072&i.flags))return i}return Fl(t,e)?t:Pl(e,t)?e:Pl(t,e)?t:Ic([e,t])}function N(n,i,a){if(!Tp(i,t)||!Tf(i))return n;var o=xy(i),s=Io(o);if(!s)return n;if(Qr(n)&&(s.type===JE||s.type===zE))return n;if(e.isIdentifierTypePredicate(s)){var c=i.arguments[s.parameterIndex];if(c){if(gp(t,c))return E(n,s.type,a,Fl);if(yp(t,c))return r}}else{var u=e.skipParentheses(i.expression);if(e.isAccessExpression(u)){var l=e.skipParentheses(u.expression);if(gp(t,l))return E(n,s.type,a,Fl);if(yp(t,l))return r}}return n}function A(e,t,r){switch(t.kind){case 73:case 101:case 99:case 190:case 191:return g(e,t,r);case 192:return N(e,t,r);case 196:return A(e,t.expression,r);case 205:return h(e,t,r);case 203:if(52===t.operator)return A(e,t.operand,!r)}return e}void 0===n&&(n=r);var F,P=!1,w=0;if(wN)return tE;if(!t.flowNode||!a&&!(133970943&r.flags))return r;var I=PN,O=ff(s(t.flowNode));PN=I;var M=256&e.getObjectFlags(O)&&kf(t)?ZE:xf(O);return t.parent&&214===t.parent.kind&&131072&Ip(M,2097152).flags?r:M}function Ff(t,r){if(t=t.exportSymbol||t,73===r.kind&&(e.isRightSideOfQualifiedNameOrPropertyAccess(r)&&(r=r.parent),e.isExpressionNode(r)&&!e.isAssignmentTarget(r))){var n=gb(r);if(Zt(O(r).resolvedSymbol)===t)return n}return Un(t)}function Pf(t){return e.findAncestor(t.parent,function(t){return e.isFunctionLike(t)&&!e.getImmediatelyInvokedFunctionExpression(t)||246===t.kind||285===t.kind||155===t.kind})}function wf(t){var r=e.getRootDeclaration(t.valueDeclaration).parent,n=O(r);return 8388608&n.flags||(n.flags|=8388608,If(r)||Of(r)),t.isAssigned||!1}function If(t){return!!e.findAncestor(t.parent,function(t){return e.isFunctionLike(t)&&!!(8388608&O(t).flags)})}function Of(t){if(73===t.kind){if(e.isAssignmentTarget(t)){var r=pp(t);r.valueDeclaration&&152===e.getRootDeclaration(r.valueDeclaration).kind&&(r.isAssigned=!0)}}else e.forEachChild(t,Of)}function Mf(e){return 3&e.flags&&0!==(2&zg(e))&&Un(e)!==ZE}function Lf(e,t){var r=kT&&152===t.kind&&t.initializer&&32768&sd(e)&&!(32768&sd(yb(t.initializer)));return r?Ip(e,524288):e}function Rf(e){var t=e.parent;return 190===t.kind||192===t.kind&&t.expression===e||191===t.kind&&t.expression===e||187===t.kind&&t.name===e&&!!t.initializer}function Bf(e){return 58982400&e.flags&&Ph(Ka(e)||rE,98304)}function jf(e,t){return e&&Rf(t)&&of(e,Bf)?lf(Td(e),qa):e}function Jf(e,t){!yt(e,67220415)||fp(t)||hC(bt(e))||Dt(e)}function zf(t){var r=pp(t);if(r===XT)return tE;if(r===jT){var n=e.getContainingFunction(t);return 2>DT&&(198===n.kind?y(t,e.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression):e.hasModifier(n,256)&&y(t,e.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method)),O(n).flags|=8192,Un(r)}t.parent&&e.isPropertyAccessExpression(t.parent)&&t.parent.expression===t||Jf(r,t);var i=Zt(r),a=i.valueDeclaration;if(32&i.flags)if(241===a.kind&&e.nodeIsDecorated(a))for(var n=e.getContainingClass(t);void 0!==n;){if(n===a&&n.name!==t){O(a).flags|=16777216,O(t).flags|=33554432;break}n=e.getContainingClass(n)}else if(210===a.kind)for(var n=e.getThisContainer(t,!1);285!==n.kind;){if(n.parent===a){155===n.kind&&e.hasModifier(n,32)&&(O(a).flags|=16777216,O(t).flags|=33554432);break}n=e.getThisContainer(n,!1)}Kf(t,r);var o=jf(Un(i),t),s=e.getAssignmentTargetKind(t);if(s){if(!(3&i.flags||e.isInJSFile(t)&&512&i.flags))return y(t,e.Diagnostics.Cannot_assign_to_0_because_it_is_not_a_variable,kr(r)),tE;if(bh(i))return 3&i.flags?y(t,e.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant,kr(r)):y(t,e.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property,kr(r)),tE}var u=2097152&i.flags;if(3&i.flags){if(1===s)return o}else{if(!u)return o;a=e.find(r.declarations,c)}if(!a)return o;for(var l=152===e.getRootDeclaration(a).kind,_=Pf(a),d=Pf(t),p=d!==_,f=t.parent&&t.parent.parent&&e.isSpreadAssignment(t.parent)&&jp(t.parent.parent),m=134217728&r.flags;d!==_&&(197===d.kind||198===d.kind||e.isObjectLiteralOrClassExpressionMethod(d))&&(Mf(i)||l&&!wf(i));)d=Pf(d);var g=l||u||p||f||m||e.isBindingElement(a)||o!==$T&&o!==ZE&&(!kT||0!==(3&o.flags)||fp(t)||258===t.parent.kind)||214===t.parent.kind||238===a.kind&&a.exclamationToken||4194304&a.flags,v=g?l?Lf(o,a):o:o===$T||o===ZE?nE:dd(o),h=Af(t,o,v,d,!g);if(kf(t)||o!==$T&&o!==ZE){if(!g&&!(32768&sd(o))&&32768&sd(h))return y(t,e.Diagnostics.Variable_0_is_used_before_being_assigned,kr(r)),o}else if(h===$T||h===ZE)return AT&&(y(e.getNameOfDeclaration(a),e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined,kr(r),Er(h)),y(t,e.Diagnostics.Variable_0_implicitly_has_an_1_type,kr(r),Er(h))),Xx(h);return s?Y_(h):h}function Vf(t,r){return!!e.findAncestor(t,function(t){return t===r?"quit":e.isFunctionLike(t)})}function Uf(t,r){return e.findAncestor(t,function(e){return e===r?"quit":e===r.initializer||e===r.condition||e===r.incrementor||e===r.statement})}function Kf(t,r){if(!(DT>=2||0===(34&r.flags)||e.isSourceFile(r.valueDeclaration)||275===r.valueDeclaration.parent.kind)){for(var n=e.getEnclosingBlockScopeContainer(r.valueDeclaration),i=Vf(t.parent,n),a=n,o=!1;a&&!e.nodeStartsNewLexicalEnvironment(a);){if(e.isIterationStatement(a,!1)){o=!0;break}a=a.parent}if(o){if(i){var s=!0;if(e.isForStatement(n)&&e.getAncestor(r.valueDeclaration,239).parent===n){var c=Uf(t.parent,n);
if(c){var u=O(c);u.flags|=131072;var l=u.capturedBlockScopeBindings||(u.capturedBlockScopeBindings=[]);e.pushIfUnique(l,r),c===n.initializer&&(s=!1)}}s&&(O(a).flags|=65536)}226===n.kind&&e.getAncestor(r.valueDeclaration,239).parent===n&&Wf(t,n)&&(O(r.valueDeclaration).flags|=4194304),O(r.valueDeclaration).flags|=524288}i&&(O(r.valueDeclaration).flags|=262144)}}function qf(t,r){var n=O(t);return!!n&&e.contains(n.capturedBlockScopeBindings,Ht(r))}function Wf(t,r){for(var n=t;196===n.parent.kind;)n=n.parent;var i=!1;if(e.isAssignmentTarget(n))i=!0;else if(203===n.parent.kind||204===n.parent.kind){var a=n.parent;i=44===a.operator||45===a.operator}return i?!!e.findAncestor(n,function(e){return e===r?"quit":e===r.statement}):!1}function Hf(e,t){if(O(e).flags|=2,155===t.kind||158===t.kind){var r=t.parent;O(r).flags|=4}else O(t).flags|=4}function Gf(t){return e.isSuperCall(t)?t:e.isFunctionLike(t)?void 0:e.forEachChild(t,Gf)}function Qf(e){var t=O(e);return void 0===t.hasSuperCall&&(t.superCall=Gf(e.body),t.hasSuperCall=t.superCall?!0:!1),t.superCall}function Xf(e){var t=Ht(e),r=bi(t),n=ni(r);return n===oE}function Yf(t,r,n){var i=r.parent,a=e.getClassExtendsHeritageElement(i);if(a&&!Xf(i)){var o=Qf(r);(!o||o.end>t.pos)&&y(t,n)}}function Zf(t){var r=e.getThisContainer(t,!0),n=!1;switch(158===r.kind&&Yf(t,r,e.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class),198===r.kind&&(r=e.getThisContainer(r,!1),n=!0),r.kind){case 245:y(t,e.Diagnostics.this_cannot_be_referenced_in_a_module_or_namespace_body);break;case 244:y(t,e.Diagnostics.this_cannot_be_referenced_in_current_location);break;case 158:rm(t,r)&&y(t,e.Diagnostics.this_cannot_be_referenced_in_constructor_arguments);break;case 155:case 154:e.hasModifier(r,32)&&y(t,e.Diagnostics.this_cannot_be_referenced_in_a_static_property_initializer);break;case 150:y(t,e.Diagnostics.this_cannot_be_referenced_in_a_computed_property_name)}n&&2>DT&&Hf(t,r);var i=$f(t,!0,r);if(FT){var a=Un(RT);if(i===a&&n)y(t,e.Diagnostics.The_containing_arrow_function_captures_the_global_value_of_this);else if(!i){var o=y(t,e.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation);if(!e.isSourceFile(r)){var s=$f(r);s&&s!==a&&e.addRelatedInfo(o,e.createDiagnosticForNode(r,e.Diagnostics.An_outer_value_of_this_is_shadowed_by_this_container))}}}return i||ZT}function $f(t,r,n){void 0===r&&(r=!0),void 0===n&&(n=e.getThisContainer(t,!1));var i=e.isInJSFile(t);if(e.isFunctionLike(n)&&(!mm(t)||e.getThisParameter(n))){var a=em(n);if(i&&a){var o=yb(a).symbol;if(o&&o.members&&16&o.flags){var s=Cy(o);if(s)return Af(t,s)}}else if(i&&(197===n.kind||240===n.kind)&&e.getJSDocClassTag(n)){var s=Cy(Wt(n.symbol));if(s)return Af(t,s)}var c=wn(n)||sm(n);if(c)return Af(t,c)}if(e.isClassLike(n.parent)){var u=Ht(n.parent),l=e.hasModifier(n,32)?Un(u):bi(u).thisType;return Af(t,l)}if(i){var l=tm(n);if(l&&l!==tE)return Af(t,l)}if(e.isSourceFile(n)){if(n.commonJsModuleIndicator){var _=Ht(n);return _&&Un(_)}if(r)return Un(RT)}}function em(t){return 197===t.kind&&e.isBinaryExpression(t.parent)&&3===e.getAssignmentDeclarationKind(t.parent)?t.parent.left.expression.expression:157===t.kind&&189===t.parent.kind&&e.isBinaryExpression(t.parent.parent)&&6===e.getAssignmentDeclarationKind(t.parent.parent)?t.parent.parent.left.expression:197===t.kind&&276===t.parent.kind&&189===t.parent.parent.kind&&e.isBinaryExpression(t.parent.parent.parent)&&6===e.getAssignmentDeclarationKind(t.parent.parent.parent)?t.parent.parent.parent.left.expression:197===t.kind&&e.isPropertyAssignment(t.parent)&&e.isIdentifier(t.parent.name)&&("value"===t.parent.name.escapedText||"get"===t.parent.name.escapedText||"set"===t.parent.name.escapedText)&&e.isObjectLiteralExpression(t.parent.parent)&&e.isCallExpression(t.parent.parent.parent)&&t.parent.parent.parent.arguments[2]===t.parent.parent&&9===e.getAssignmentDeclarationKind(t.parent.parent.parent)?t.parent.parent.parent.arguments[0].expression:e.isMethodDeclaration(t)&&e.isIdentifier(t.name)&&("value"===t.name.escapedText||"get"===t.name.escapedText||"set"===t.name.escapedText)&&e.isObjectLiteralExpression(t.parent)&&e.isCallExpression(t.parent.parent)&&t.parent.parent.arguments[2]===t.parent&&9===e.getAssignmentDeclarationKind(t.parent.parent)?t.parent.parent.arguments[0].expression:void 0}function tm(t){var r=e.getJSDocType(t);if(r&&295===r.kind){var n=r;if(n.parameters.length>0&&n.parameters[0].name&&"this"===n.parameters[0].name.escapedText)return ju(n.parameters[0].type)}var i=e.getJSDocThisTag(t);return i&&i.typeExpression?ju(i.typeExpression):void 0}function rm(t,r){return!!e.findAncestor(t,function(t){return e.isFunctionLikeDeclaration(t)?"quit":152===t.kind&&t.parent===r})}function nm(t){function r(t){return t?n?158===t.kind:e.isClassLike(t.parent)||189===t.parent.kind?e.hasModifier(t,32)?157===t.kind||156===t.kind||159===t.kind||160===t.kind:157===t.kind||156===t.kind||159===t.kind||160===t.kind||155===t.kind||154===t.kind||158===t.kind:!1:!1}var n=192===t.parent.kind&&t.parent.expression===t,i=e.getSuperContainer(t,!0),a=!1;if(!n)for(;i&&198===i.kind;)i=e.getSuperContainer(i,!0),a=2>DT;var o=r(i),s=0;if(!o){var c=e.findAncestor(t,function(e){return e===i?"quit":150===e.kind});return c&&150===c.kind?y(t,e.Diagnostics.super_cannot_be_referenced_in_a_computed_property_name):n?y(t,e.Diagnostics.Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors):i&&i.parent&&(e.isClassLike(i.parent)||189===i.parent.kind)?y(t,e.Diagnostics.super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class):y(t,e.Diagnostics.super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions),tE}if(n||158!==i.kind||Yf(t,i,e.Diagnostics.super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class),s=e.hasModifier(i,32)||n?512:256,O(t).flags|=s,157===i.kind&&e.hasModifier(i,256)&&(O(i).flags|=e.isSuperProperty(t.parent)&&e.isAssignmentTarget(t.parent)?4096:2048),a&&Hf(t.parent,i),189===i.parent.kind)return 2>DT?(y(t,e.Diagnostics.super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher),tE):ZT;var u=i.parent;if(!e.getClassExtendsHeritageElement(u))return y(t,e.Diagnostics.super_can_only_be_referenced_in_a_derived_class),tE;var l=bi(Ht(u)),_=l&&ii(l)[0];return _?158===i.kind&&rm(t,i)?(y(t,e.Diagnostics.super_cannot_be_referenced_in_constructor_arguments),tE):512===s?ni(l):Vi(_,l.thisType):tE}function im(e){return 157!==e.kind&&159!==e.kind&&160!==e.kind||189!==e.parent.kind?197===e.kind&&276===e.parent.kind?e.parent.parent:void 0:e.parent}function am(t){return 4&e.getObjectFlags(t)&&t.target===XE?t.typeArguments[0]:void 0}function om(t){return lf(t,function(t){return 2097152&t.flags?e.forEach(t.types,am):am(t)})}function sm(t){if(198===t.kind)return void 0;if(Cl(t)){var r=Xm(t);if(r){var n=r.thisParameter;if(n)return Un(n)}}var i=e.isInJSFile(t);if(FT||i){var a=im(t);if(a){for(var o=Om(a),s=a,c=o;c;){var u=om(c);if(u)return gl(u,Jd(Bm(a)));if(276!==s.parent.kind)break;s=s.parent.parent,c=Om(s)}return o?fd(o):eb(a)}var l=t.parent;if(205===l.kind&&60===l.operatorToken.kind){var _=l.left;if(190===_.kind||191===_.kind){var d=_.expression;if(i&&e.isIdentifier(d)){var p=e.getSourceFileOfNode(l);if(p.commonJsModuleIndicator&&pp(d)===p.symbol)return void 0}return eb(d)}}}return void 0}function cm(t){var r=t.parent;if(!Cl(r))return void 0;var n=e.getImmediatelyInvokedFunctionExpression(r);if(n&&n.arguments){var i=qv(n),a=r.parameters.indexOf(t);if(t.dotDotDotToken)return Bv(i,a,i.length,ZT,void 0);var o=O(n),s=o.resolvedSignature;o.resolvedSignature=DN;var c=a<i.length?Z_(yb(i[a])):t.initializer?void 0:iE;return o.resolvedSignature=s,c}var u=Xm(r);if(u){var l=r.parameters.indexOf(t)-(e.getThisParameter(r)?1:0);return t.dotDotDotToken&&e.lastOrUndefined(r.parameters)===t?qy(u,l):Ky(u,l)}}function um(t){var r=e.getEffectiveTypeAnnotationNode(t);if(r)return ju(r);switch(t.kind){case 152:return cm(t);case 187:return lm(t)}}function lm(t){var r=t.parent.parent,n=t.propertyName||t.name,i=um(r);if(i&&!e.isBindingPattern(n)&&!Yr(n)){var a=Rc(n);if(Fi(a)){var o=Li(a);return Hr(i,o)}}}function _m(t){var r=t.parent;if(e.hasInitializer(r)&&t===r.initializer){var n=um(r);if(n)return n;if(e.isBindingPattern(r.name))return Dn(r.name,!0,!1)}return void 0}function dm(t){var r=e.getContainingFunction(t);if(r){var n=e.getFunctionFlags(r);if(1&n)return void 0;var i=gm(r);if(i){if(2&n){var a=ox(i);return a&&Dc([a,ih(a)])}return i}}return void 0}function pm(e){var t=Rm(e);if(t){var r=ux(t);return r&&Dc([r,ih(r)])}return void 0}function fm(t){var r=e.getContainingFunction(t);if(r){var n=e.getFunctionFlags(r),i=gm(r);if(i)return t.asteriskToken?i:yD(i,0!==(2&n))}return void 0}function mm(t){for(var r=!1;t.parent&&!e.isFunctionLike(t.parent);){if(e.isParameter(t.parent)&&(r||t.parent.initializer===t))return!0;e.isBindingElement(t.parent)&&t.parent.initializer===t&&(r=!0),t=t.parent}return!1}function gm(e){var t=Lo(e);if(t)return t;var r=Qm(e);return r&&!Ro(r)?Mo(r):void 0}function vm(e,t){var r=qv(e),n=r.indexOf(t);return-1===n?void 0:ym(e,n)}function ym(t,r){var n=O(t).resolvedSignature===CN?CN:xy(t);return e.isJsxOpeningLikeElement(t)&&0===r?Jm(n,t):Uy(n,r)}function hm(e,t){return 194===e.parent.kind?vm(e.parent,t):void 0}function bm(t,r){var n=t.parent,i=n.left,a=n.operatorToken,o=n.right;switch(a.kind){case 60:if(t!==o)return void 0;var s=xm(n);return s?s===!0?gb(i):s:void 0;case 55:var c=Rm(n,r);return c||t!==o||e.isDefaultedExpandoInitializer(n)?c:gb(i);case 54:case 27:return t===o?Rm(n,r):void 0;default:return void 0}}function xm(t){var r=e.getAssignmentDeclarationKind(t);switch(r){case 0:return!0;case 5:case 1:case 6:case 3:if(t.left.symbol){var n=t.left.symbol.valueDeclaration;if(!n)return!1;var i=t.left,a=e.getEffectiveTypeAnnotationNode(n);if(a)return ju(a);if(e.isIdentifier(i.expression)){var o=i.expression,s=j(o,o.escapedText,67220415,void 0,o.escapedText,!0);if(s){var c=e.getEffectiveTypeAnnotationNode(s.valueDeclaration);if(c){var u=Dm(ju(c),i.name.escapedText);return u||!1}return!1}}return!e.isInJSFile(n)}return!0;case 2:case 4:if(!t.symbol)return!0;if(t.symbol.valueDeclaration){var c=e.getEffectiveTypeAnnotationNode(t.symbol.valueDeclaration);if(c){var u=ju(c);if(u)return u}}if(2===r)return!1;var l=t.left;if(!e.isObjectLiteralMethod(e.getThisContainer(l.expression,!1)))return!1;var _=Zf(l.expression);return _&&Dm(_,l.name.escapedText)||!1;case 7:case 8:case 9:return e.Debug.fail("Does not apply");default:return e.Debug.assertNever(r)}}function Dm(t,r){return lf(t,function(t){if(ka(t)){var n=ga(t),i=Ka(n)||n,a=Iu(e.unescapeLeadingUnderscores(r));if(Pl(a,i))return au(t,a)}else if(3670016&t.flags){var o=ao(t,r);if(o)return Un(o);if(td(t)){var s=rd(t);if(s&&ig(r)&&+r>=0)return s}return ig(r)&&Sm(t,1)||Sm(t,0)}return void 0},!0)}function Sm(e,t){return lf(e,function(e){return uo(e,t)},!0)}function Cm(t,r){return e.Debug.assert(e.isObjectLiteralMethod(t)),8388608&t.flags?void 0:km(t,r)}function km(e,t){var r=e.parent,n=Om(r,t);if(n){if(!Oi(e)){var i=Ht(e).escapedName,a=Dm(n,i);if(a)return a}return tg(e.name)&&Sm(n,1)||Sm(n,0)}return void 0}function Tm(e,t){return e&&(Dm(e,""+t)||fD(e,void 0,!1,!1,!1))}function Em(e,t){var r=e.parent;return e===r.whenTrue||e===r.whenFalse?Rm(r,t):void 0}function Nm(e,t){var r=Om(e.openingElement.tagName),n=Eg(Sg(e));if(!r||Qr(r)||!n||""===n)return void 0;var i=Wl(e.children),a=i.indexOf(t),o=Dm(r,n);return o&&(1===i.length?o:lf(o,function(e){return U_(e)?ou(e,Iu(a)):e},!0))}function Am(t){var r=t.parent;return e.isJsxAttributeLike(r)?Rm(t):e.isJsxElement(r)?Nm(r,t):void 0}function Fm(t){if(e.isJsxAttribute(t)){var r=Om(t.parent);return!r||Qr(r)?void 0:Dm(r,t.name.escapedText)}return Rm(t.parent)}function Pm(e){switch(e.kind){case 10:case 8:case 9:case 14:case 103:case 88:case 97:case 73:case 142:return!0;case 190:case 196:return Pm(e.expression);case 271:return!e.expression||Pm(e.expression)}return!1}function wm(t,r){return p_(r,e.map(e.filter(t.properties,function(e){return!!e.symbol&&276===e.kind&&Pm(e.initializer)&&Dp(r,e.symbol.escapedName)}),function(e){return[function(){return yb(e.initializer)},e.symbol.escapedName]}),Pl,r)}function Im(t,r){return p_(r,e.map(e.filter(t.properties,function(e){return!!e.symbol&&268===e.kind&&Dp(r,e.symbol.escapedName)&&(!e.initializer||Pm(e.initializer))}),function(e){return[e.initializer?function(){return yb(e.initializer)}:function(){return dE},e.symbol.escapedName]}),Pl,r)}function Om(t,r){var n=Mm(Rm(t,r),t,r);if(n){var i=lf(n,to,!0);if(1048576&i.flags){if(e.isObjectLiteralExpression(t))return wm(t,i);if(e.isJsxAttributes(t))return Im(t,i)}return i}}function Mm(t,r,n){if(t&&Ph(t,63176704)){var i=Bm(r);if(i&&e.some(i.inferences,lb)){if(n&&1&n)return Lm(t,i.nonFixingMapper);if(i.returnMapper)return Lm(t,i.returnMapper)}}return t}function Lm(t,r){return 63176704&t.flags?gl(t,r):1048576&t.flags?Dc(e.map(t.types,function(e){return Lm(e,r)}),0):2097152&t.flags?Ic(e.map(t.types,function(e){return Lm(e,r)})):t}function Rm(t,r){if(8388608&t.flags)return void 0;if(t.contextualType)return t.contextualType;var n=t.parent;switch(n.kind){case 238:case 152:case 155:case 154:case 187:return _m(t);case 198:case 231:return dm(t);case 208:return fm(n);case 202:return pm(n);case 192:case 193:return vm(n,t);case 195:case 213:return e.isConstTypeReference(n.type)?void 0:ju(n.type);case 205:return bm(t,r);case 276:case 277:return km(n,r);case 278:return Om(n.parent,r);case 188:var i=n,a=Om(i,r);return Tm(a,e.indexOfNode(i.elements,t));case 206:return Em(t,r);case 217:return e.Debug.assert(207===n.parent.kind),hm(n.parent,t);case 196:var o=e.isInJSFile(n)?e.getJSDocTypeTag(n):void 0;return o?ju(o.typeExpression.type):Rm(n,r);case 271:return Am(n);case 268:case 270:return Fm(n);case 263:case 262:return jm(n)}return void 0}function Bm(t){var r=e.findAncestor(t,function(e){return!!e.inferenceContext});return r&&r.inferenceContext}function jm(t){return e.isJsxOpeningElement(t)&&t.parent.contextualType?t.parent.contextualType:ym(t,0)}function Jm(e,t){return 0!==Jv(t)?zm(e,t):qm(e,t)}function zm(e,t){var r=Zy(e,rE);r=Km(t,Sg(t),r);var n=xg(f.IntrinsicAttributes,t);return n!==tE&&(r=aa(n,r)),r}function Vm(e,t){if(e.unionSignatures){for(var r=[],n=0,i=e.unionSignatures;n<i.length;n++){var a=i[n],o=Mo(a);if(Qr(o))return o;var s=Hr(o,t);if(!s)return;r.push(s)}return Ic(r)}var c=Mo(e);return Qr(c)?c:Hr(c,t)}function Um(e){if(gg(e.tagName)){var t=Pg(e),r=vy(e,t);return Qo(r)}var n=eb(e.tagName);if(128&n.flags){var t=Ag(n,e);if(!t)return tE;var r=vy(e,t);return Qo(r)}return n}function Km(t,r,n){var i=kg(r);if(i){var a=bi(i),o=Um(t);if(e.length(a.typeParameters)>=2){var s=So([o,n],a.typeParameters,2,e.isInJSFile(t));return os(a,s)}if(e.length(a.aliasTypeArguments)>=2){var s=So([o,n],a.aliasTypeArguments,2,e.isInJSFile(t));return ls(a.aliasSymbol,s)}}return n}function qm(t,r){var n=Sg(r),i=Tg(n),a=void 0===i?Zy(t,rE):""===i?Mo(t):Vm(t,i);if(!a)return i&&e.length(r.attributes.properties)&&y(r,e.Diagnostics.JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property,e.unescapeLeadingUnderscores(i)),rE;if(a=Km(r,n,a),Qr(a))return a;var o=a,s=xg(f.IntrinsicClassAttributes,r);if(s!==tE){var c=Xn(s.symbol),u=Mo(t);o=aa(c?os(s,So([u],c,Do(c),e.isInJSFile(r))):s,o)}var l=xg(f.IntrinsicAttributes,r);return l!==tE&&(o=aa(l,o)),o}function Wm(e,t){var r=so(e,0);if(1===r.length){var n=r[0];if(!Hm(n,t))return n}}function Hm(t,r){for(var n=0;n<r.parameters.length;n++){var i=r.parameters[n];if(i.initializer||i.questionToken||i.dotDotDotToken||go(i))break}return r.parameters.length&&e.parameterIsThisKeyword(r.parameters[0])&&n--,!Gy(t)&&Wy(t)<n}function Gm(e){return 197===e.kind||198===e.kind}function Qm(t){return Gm(t)||e.isObjectLiteralMethod(t)?Xm(t):void 0}function Xm(t){e.Debug.assert(157!==t.kind||e.isObjectLiteralMethod(t));var r=To(t);if(r)return r;var n=e.isObjectLiteralMethod(t)?Cm(t,1):Om(t,1);if(!n)return void 0;if(!(1048576&n.flags))return Wm(n,t);for(var i,a=n.types,o=0,s=a;o<s.length;o++){var c=s[o],u=Wm(c,t);if(u)if(i){if(!O_(i[0],u,!1,!0,!0,El))return void 0;i.push(u)}else i=[u]}return i&&Gi(i[0],i)}function Ym(e,t){2>DT&&xT.downlevelIteration&&KC(e,1536);var r=yb(e.expression,t);return pD(r,e.expression,!1,!1)}function Zm(e){return 187===e.kind&&!!e.initializer||205===e.kind&&60===e.operatorToken.kind}function $m(t,r,n){for(var i=t.elements,a=i.length,o=!1,s=[],c=e.isAssignmentTarget(t),u=Om(t),l=ib(t),_=0;a>_;_++){var d=i[_];if(c&&209===d.kind){var p=yb(d.expression,r,n),f=_o(p,1)||fD(p,void 0,!1,!1,!1);f&&s.push(f)}else{var m=Tm(u,_),g=ab(d,r,m,n);s.push(g)}a-1>_&&209===d.kind&&(o=!0)}if(!o){var v=a>0&&209===i[a-1].kind,y=a-(v?1:0),h=void 0;if(c&&y>0){var g=ss(uc(s,y,v));return g.pattern=t,g}if(h=eg(s,u,v,a,l))return h;if(n)return uc(s,y,v)}return ic(s.length?Dc(s,2):kT?bE:iE,l)}function eg(t,r,n,i,a){if(void 0===i&&(i=t.length),void 0===a&&(a=!1),a||r&&of(r,q_)){var o=i-(n?1:0),s=r&&r.pattern;if(!n&&s&&(186===s.kind||188===s.kind))for(var c=s.elements,u=i;u<c.length;u++){var l=c[u];Zm(l)?t.push(r.typeArguments[u]):(u<c.length-1||!(187===l.kind&&l.dotDotDotToken||209===l.kind))&&(211!==l.kind&&y(l,e.Diagnostics.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value),t.push(kT?bE:iE))}return uc(t,o,n,a)}}function tg(e){switch(e.kind){case 150:return rg(e);case 73:return ig(e.escapedText);case 8:case 10:return ig(e.text);default:return!1}}function rg(e){return wh(ag(e),296)}function ng(e){return"Infinity"===e||"-Infinity"===e||"NaN"===e}function ig(e){return(+e).toString()===e}function ag(t){var r=O(t.expression);return r.resolvedType||(r.resolvedType=yb(t.expression),98304&r.resolvedType.flags||!wh(r.resolvedType,12716)&&!Pl(r.resolvedType,DE)?y(t,e.Diagnostics.A_computed_property_name_must_be_of_type_string_number_symbol_or_any):xv(t.expression,r.resolvedType,!0)),r.resolvedType}function og(e,t,r,n){for(var i=[],a=0;a<r.length;a++)(0===n||tg(e.properties[a+t].name))&&i.push(Un(r[a]));var o=i.length?Dc(i,2):nE;return Zo(o,ib(e))}function sg(t){e.Debug.assert(0!==(2097152&t.flags),"Should only get Alias here.");var r=I(t);if(!r.immediateTarget){var n=rt(t);if(!n)return e.Debug.fail();r.immediateTarget=vt(n,!0)}return r.immediateTarget}function cg(t,r){function n(){var r=v?og(t,b,o,0):void 0,n=h?og(t,b,o,1):void 0,s=lr(t.symbol,a,e.emptyArray,e.emptyArray,r,n);return s.objectFlags|=128|m|262144,f&&(s.objectFlags|=16384),g&&(s.objectFlags|=512),i&&(s.pattern=t),s}var i=e.isAssignmentTarget(t);Dk(t,i);var a,o=[],s=kE,c=Om(t),u=c&&c.pattern&&(185===c.pattern.kind||189===c.pattern.kind),l=ib(t),_=l?8:0,d=e.isInJSFile(t)&&!e.isInJsonFile(t),p=e.getJSDocEnumTag(t),f=!c&&d&&!p,m=wT,g=!1,v=!1,h=!1;a=e.createSymbolTable();for(var b=0,D=0;D<t.properties.length;D++){var S=t.properties[D],C=Ht(S),k=S.name&&150===S.name.kind&&!e.isWellKnownSymbolSyntactically(S.name.expression)?ag(S.name):void 0;if(276===S.kind||277===S.kind||e.isObjectLiteralMethod(S)){var T=276===S.kind?ob(S,r):277===S.kind?ab(S.name,r):sb(S,r);if(d){var E=on(S);E?(Ml(T,E,S),T=E):p&&p.typeExpression&&Ml(T,ju(p.typeExpression),S)}m|=917504&e.getObjectFlags(T);var N=k&&Fi(k)?k:void 0,A=N?x(4|C.flags,Li(N),4096|_):x(4|C.flags,C.escapedName,_);if(N&&(A.nameType=N),i){var F=276===S.kind&&Zm(S.initializer)||277===S.kind&&S.objectAssignmentInitializer;F&&(A.flags|=16777216)}else if(u&&!(512&e.getObjectFlags(c))){var P=ao(c,C.escapedName);P?A.flags|=16777216&P.flags:xT.suppressExcessPropertyErrors||lo(c,0)||y(S.name,e.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1,kr(C),Er(c))}A.declarations=C.declarations,A.parent=C.parent,C.valueDeclaration&&(A.valueDeclaration=C.valueDeclaration),A.type=T,A.target=C,C=A}else{if(278===S.kind){2>DT&&KC(S,2),o.length>0&&(s=ku(s,n(),t.symbol,m,l),o=[],a=e.createSymbolTable(),v=!1,h=!1);var T=yb(S.expression);if(!ug(T))return y(S,e.Diagnostics.Spread_types_may_only_be_created_from_object_types),tE;s=ku(s,T,t.symbol,m,l),b=D+1;continue}e.Debug.assert(159===S.kind||160===S.kind),SS(S)}!k||8576&k.flags?a.set(C.escapedName,C):Pl(k,DE)&&(Pl(k,cE)?h=!0:v=!0,i&&(g=!0)),o.push(C)}if(u)for(var w=0,I=Pa(c);w<I.length;w++){var A=I[w];a.get(A.escapedName)||s&&ao(s,A.escapedName)||(16777216&A.flags||y(A.valueDeclaration||A.bindingElement,e.Diagnostics.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value),a.set(A.escapedName,A),o.push(A))}return s!==kE?(o.length>0&&(s=ku(s,n(),t.symbol,m,l)),s):n()}function ug(t){return!!(126615555&t.flags||117632&sd(t)&&ug(cd(t))||3145728&t.flags&&e.every(t.types,ug))}function lg(e){Rg(e)}function _g(e){return SS(e),Ig(e)||ZT}function dg(e){Rg(e.openingElement),gg(e.closingElement.tagName)?Dg(e.closingElement):yb(e.closingElement.tagName),hg(e)}function pg(e){return SS(e),Ig(e)||ZT}function fg(t){return Rg(t.openingFragment),2===xT.jsx&&(xT.jsxFactory||e.getSourceFileOfNode(t).pragmas.has("jsx"))&&y(t,xT.jsxFactory?e.Diagnostics.JSX_fragment_is_not_supported_when_using_jsxFactory:e.Diagnostics.JSX_fragment_is_not_supported_when_using_an_inline_JSX_factory_pragma),hg(t),Ig(t)||ZT}function mg(t){return!e.stringContains(t,"-")}function gg(t){return 73===t.kind&&e.isIntrinsicJsxName(t.escapedText)}function vg(e,t){return e.initializer?ab(e.initializer,t):dE}function yg(t,r){function n(){l|=wT;var t=lr(a.symbol,o,e.emptyArray,e.emptyArray,void 0,void 0);return t.objectFlags|=128|l|262144,t}for(var i,a=t.attributes,o=e.createSymbolTable(),s=TE,c=!1,u=!1,l=4096,_=Eg(Sg(t)),d=0,p=a.properties;d<p.length;d++){var f=p[d],m=f.symbol;if(e.isJsxAttribute(f)){var g=vg(f,r);l|=917504&e.getObjectFlags(g);var v=x(33554436|m.flags,m.escapedName);v.declarations=m.declarations,v.parent=m.parent,m.valueDeclaration&&(v.valueDeclaration=m.valueDeclaration),v.type=g,v.target=m,o.set(v.escapedName,v),f.name.escapedText===_&&(u=!0)}else{e.Debug.assert(270===f.kind),o.size>0&&(s=ku(s,n(),a.symbol,l,!1),o=e.createSymbolTable());var g=eb(f.expression,r);Qr(g)&&(c=!0),ug(g)?s=ku(s,g,a.symbol,l,!1):i=i?Ic([i,g]):g}}c||o.size>0&&(s=ku(s,n(),a.symbol,l,!1));var h=261===t.parent.kind?t.parent:void 0;if(h&&h.openingElement===t&&h.children.length>0){var b=hg(h,r);if(!c&&_&&""!==_){u&&y(a,e.Diagnostics._0_are_specified_twice_The_attribute_named_0_will_be_overwritten,e.unescapeLeadingUnderscores(_));var D=Om(t.attributes),S=D&&Dm(D,_),C=x(33554436,_);C.type=1===b.length?b[0]:eg(b,S,!1)||ic(Dc(b)),C.valueDeclaration=e.createPropertySignature(void 0,e.unescapeLeadingUnderscores(_),void 0,void 0,void 0),C.valueDeclaration.parent=a,C.valueDeclaration.symbol=C;var k=e.createSymbolTable();k.set(_,C),s=ku(s,lr(a.symbol,k,e.emptyArray,e.emptyArray,void 0,void 0),a.symbol,l,!1)}}return c?ZT:i&&s!==TE?Ic([i,s]):i||(s===TE?n():s)}function hg(e,t){for(var r=[],n=0,i=e.children;n<i.length;n++){var a=i[n];11===a.kind?a.containsOnlyTriviaWhiteSpaces||r.push(sE):r.push(ab(a,t))}return r}function bg(e,t){return yg(e.parent,t)}function xg(e,t){var r=Sg(t),n=r&&Vt(r),i=n&&L(n,e,67897832);return i?bi(i):tE}function Dg(t){var r=O(t);if(!r.resolvedSymbol){var n=xg(f.IntrinsicElements,t);if(n!==tE){if(!e.isIdentifier(t.tagName))return e.Debug.fail();var i=ao(n,t.tagName.escapedText);if(i)return r.jsxFlags|=1,r.resolvedSymbol=i;var a=_o(n,0);return a?(r.jsxFlags|=2,r.resolvedSymbol=n.symbol):(y(t,e.Diagnostics.Property_0_does_not_exist_on_type_1,e.idText(t.tagName),"JSX."+f.IntrinsicElements),r.resolvedSymbol=XT)}return AT&&y(t,e.Diagnostics.JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists,e.unescapeLeadingUnderscores(f.IntrinsicElements)),r.resolvedSymbol=XT}return r.resolvedSymbol}function Sg(e){var t=e&&O(e);if(t&&t.jsxNamespace)return t.jsxNamespace;if(!t||t.jsxNamespace!==!1){var r=m(e),n=j(e,r,1920,void 0,r,!1);if(n){var i=ht(L(Vt(ht(n)),f.JSX,1920));if(i)return t&&(t.jsxNamespace=i),i;t&&(t.jsxNamespace=!1)}}return Ps(f.JSX,1920,void 0)}function Cg(t,r){var n=r&&L(r.exports,t,67897832),i=n&&bi(n),a=i&&Pa(i);if(a){if(0===a.length)return"";if(1===a.length)return a[0].escapedName;a.length>1&&y(n.declarations[0],e.Diagnostics.The_global_type_JSX_0_may_not_have_more_than_one_property,e.unescapeLeadingUnderscores(t))}return void 0}function kg(e){return e&&L(e.exports,f.LibraryManagedAttributes,67897832)}function Tg(e){return Cg(f.ElementAttributesPropertyNameContainer,e)}function Eg(e){return Cg(f.ElementChildrenAttributeNameContainer,e)}function Ng(t,r){if(4&t.flags)return[DN];if(128&t.flags){var n=Ag(t,r);if(n){var i=vy(r,n);return[i]}return y(r,e.Diagnostics.Property_0_does_not_exist_on_type_1,t.value,"JSX."+f.IntrinsicElements),e.emptyArray}var a=to(t),o=so(a,1);return 0===o.length&&(o=so(a,0)),0===o.length&&1048576&a.flags&&(o=$i(e.map(a.types,function(e){return Ng(e,r)}))),o}function Ag(t,r){var n=xg(f.IntrinsicElements,r);if(n!==tE){var i=t.value,a=ao(n,e.escapeLeadingUnderscores(i));if(a)return Un(a);var o=_o(n,0);return o?o:void 0}return ZT}function Fg(t,r,n){if(1===t){var i=Og(n);i&&d_(r,i,dA,n,e.Diagnostics.JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements)}else if(0===t){var a=wg(n);a&&d_(r,a,dA,n,e.Diagnostics.JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements)}else{var i=Og(n),a=wg(n);if(!i||!a)return;var o=Dc([i,a]);d_(r,o,dA,n,e.Diagnostics.JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements)}}function Pg(t){e.Debug.assert(gg(t.tagName));var r=O(t);if(!r.resolvedJsxElementAttributesType){var n=Dg(t);return r.resolvedJsxElementAttributesType=1&r.jsxFlags?Un(n):2&r.jsxFlags?$o(n,0).type:tE}return r.resolvedJsxElementAttributesType}function wg(e){var t=xg(f.ElementClass,e);return t===tE?void 0:t}function Ig(e){return xg(f.Element,e)}function Og(e){var t=Ig(e);return t?Dc([t,aE]):void 0}function Mg(t){var r=xg(f.IntrinsicElements,t);return r?Pa(r):e.emptyArray}function Lg(t){0===(xT.jsx||0)&&y(t,e.Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided),void 0===Ig(t)&&AT&&y(t,e.Diagnostics.JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist)}function Rg(t){var r=e.isJsxOpeningLikeElement(t);r&&Sk(t),Lg(t);var n=tA&&2===xT.jsx?e.Diagnostics.Cannot_find_name_0:void 0,i=m(t),a=r?t.tagName:t,o=j(a,i,67220415,n,i,!0);if(o&&(o.isReferenced=67108863,2097152&o.flags&&!hC(bt(o))&&Dt(o)),r){var s=xy(t);Fg(Jv(t),Mo(s),t)}}function Bg(e,t,r){if(524288&e.flags){var n=Ta(e);if(n.stringIndexInfo||n.numberIndexInfo&&ig(t)||Na(e,t)||r&&!mg(t))return!0}else if(3145728&e.flags&&jg(e))for(var i=0,a=e.types;i<a.length;i++){var o=a[i];if(Bg(o,t,r))return!0}return!1}function jg(t){return!!(524288&t.flags&&!(512&e.getObjectFlags(t))||67108864&t.flags||1048576&t.flags&&e.some(t.types,jg)||2097152&t.flags&&e.every(t.types,jg))}function Jg(t,r){if(t.expression){var n=yb(t.expression,r);return t.dotDotDotToken&&n!==ZT&&!J_(n)&&y(t,e.Diagnostics.JSX_spread_child_must_be_an_array_type),n}return tE}function zg(t){return t.valueDeclaration?e.getCombinedNodeFlags(t.valueDeclaration):0}function Vg(t){if(8192&t.flags||4&e.getCheckFlags(t))return!0;if(e.isInJSFile(t.valueDeclaration)){var r=t.valueDeclaration.parent;return r&&e.isBinaryExpression(r)&&3===e.getAssignmentDeclarationKind(r)}}function Ug(t,r,n,i){var a=e.getDeclarationModifierFlagsFromSymbol(i),o=149===t.kind?t.right:184===t.kind?t:t.name;if(1024&e.getCheckFlags(i))return y(o,e.Diagnostics.Property_0_has_conflicting_declarations_and_is_inaccessible_in_type_1,kr(i),Er(n)),!1;if(r){if(2>DT&&qg(i))return y(o,e.Diagnostics.Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword),!1;if(128&a)return y(o,e.Diagnostics.Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression,kr(i),Er(T_(i))),!1}if(128&a&&e.isThisProperty(t)&&qg(i)){var s=e.getClassLikeDeclarationOfSymbol(Gt(i));if(s&&JS(t))return y(o,e.Diagnostics.Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor,kr(i),e.getTextOfIdentifierOrLiteral(s.name)),!1}if(!(24&a))return!0;if(8&a){var s=e.getClassLikeDeclarationOfSymbol(Gt(i));return zS(t,s)?!0:(y(o,e.Diagnostics.Property_0_is_private_and_only_accessible_within_class_1,kr(i),Er(T_(i))),!1)}if(r)return!0;var c=jS(t,function(e){var t=bi(Ht(e));return A_(t,i)?t:void 0});if(!c){var u=void 0;if(32&a||!(u=Kg(t))||!u.type)return y(o,e.Diagnostics.Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses,kr(i),Er(T_(i)||n)),!1;var l=ju(u.type);c=262144&l.flags?Ma(l):l}return 32&a?!0:(262144&n.flags&&(n=n.isThisType?Ma(n):Ka(n)),n&&Wn(n,c)?!0:(y(o,e.Diagnostics.Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1,kr(i),Er(c)),!1))}function Kg(t){var r=e.getThisContainer(t,!1);return r&&e.isFunctionLike(r)?e.getThisParameter(r):void 0}function qg(e){return!!k_(e,function(e){return!(8192&e.flags)})}function Wg(e,t,r,n){return Gg(yb(e),e,t,r,n)}function Hg(e){var t=98304&(kT?sd(e):e.flags);return t?fd(e):e}function Gg(t,r,n,i,a){if(kT&&2&t.flags)return y(r,e.Diagnostics.Object_is_of_type_unknown),tE;var o=98304&(kT?sd(t):t.flags);if(o){y(r,32768&o?65536&o?a||e.Diagnostics.Object_is_possibly_null_or_undefined:i||e.Diagnostics.Object_is_possibly_undefined:n||e.Diagnostics.Object_is_possibly_null);var s=fd(t);return 229376&s.flags?tE:s}return t}function Qg(t,r){var n=Gg(t,r);return n!==tE&&16384&n.flags&&y(r,e.Diagnostics.Object_is_possibly_undefined),n}function Xg(e){return Zg(e,e.expression,e.name)}function Yg(e){return Zg(e,e.left,e.right)}function Zg(t,r,n){var i,a=Wg(r),o=O(r).resolvedSymbol,s=to(Td(a));if(Qr(s)||s===yE)return e.isIdentifier(r)&&o&&Jf(o,t),s;var c=e.getAssignmentTargetKind(t),u=ao(s,n.escapedText);if(!e.isIdentifier(r)||!o||u&&hC(u)||Jf(o,t),u){if($g(u,t,n),pv(u,t,101===r.kind),O(t).resolvedSymbol=u,Ug(t,99===r.kind,s,u),c&&(xh(t,u)||Dh(t)))return y(n,e.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property,e.idText(n)),tE;i=jf(Un(u),t)}else{var l=0!==c&&Xc(a)?void 0:lo(s,0);if(!l||!l.type)return Hc(a)?ZT:a.symbol===RT?(RT.exports.has(n.escapedText)&&418&RT.exports.get(n.escapedText).flags?y(n,e.Diagnostics.Property_0_does_not_exist_on_type_1,e.unescapeLeadingUnderscores(n.escapedText),Er(a)):AT&&y(n,e.Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature,Er(a)),ZT):(n.escapedText&&!W(t)&&nv(n,Zc(a)?s:a),tE);l.isReadonly&&(e.isAssignmentTarget(t)||e.isDeleteTarget(t))&&y(t,e.Diagnostics.Index_signature_in_type_0_only_permits_reading,Er(s)),i=l.type}if(190!==t.kind||1===c||u&&!(98311&u.flags)&&!(8192&u.flags&&1048576&i.flags))return i;var _=!1;if(kT&&NT&&101===r.kind){var d=u&&u.valueDeclaration;if(d&&qD(d)){var p=Pf(t);158===p.kind&&p.parent===d.parent&&(_=!0)}}else kT&&u&&u.valueDeclaration&&e.isPropertyAccessExpression(u.valueDeclaration)&&e.getAssignmentDeclarationPropertyAccessKind(u.valueDeclaration)&&Pf(t)===Pf(u.valueDeclaration)&&(_=!0);var f=Af(t,i,_?dd(i):i);return _&&!(32768&sd(i))&&32768&sd(f)?(y(n,e.Diagnostics.Property_0_is_used_before_being_assigned,kr(u)),i):c?Y_(f):f}function $g(t,r,n){var i=t.valueDeclaration;if(i){var a,o=e.idText(n);!ev(r)||B(i,n)||tv(t)?241!==i.kind||165===r.parent.kind||4194304&i.flags||B(i,n)||(a=y(n,e.Diagnostics.Class_0_used_before_its_declaration,o)):a=y(n,e.Diagnostics.Property_0_is_used_before_its_initialization,o),a&&e.addRelatedInfo(a,e.createDiagnosticForNode(i,e.Diagnostics._0_is_declared_here,o))}}function ev(t){return!!e.findAncestor(t,function(t){switch(t.kind){case 155:return!0;case 276:case 157:case 159:case 160:case 278:case 150:case 217:case 271:case 268:case 269:case 270:case 263:case 212:case 274:return!1;default:return e.isExpressionNode(t)?!1:"quit"}})}function tv(e){if(!(32&e.parent.flags))return!1;for(var t=Un(e.parent);;){if(t=t.symbol&&rv(t),!t)return!1;var r=ao(t,e.escapedName);if(r&&r.valueDeclaration)return!0}}function rv(e){var t=ii(e);return 0===t.length?void 0:Ic(t)}function nv(t,r){var n,i;
if(1048576&r.flags&&!(131068&r.flags))for(var a=0,o=r.types;a<o.length;a++){var s=o[a];if(!ao(s,t.escapedText)){n=e.chainDiagnosticMessages(n,e.Diagnostics.Property_0_does_not_exist_on_type_1,e.declarationNameToString(t),Er(s));break}}if(iv(t.escapedText,r))n=e.chainDiagnosticMessages(n,e.Diagnostics.Property_0_is_a_static_member_of_type_1,e.declarationNameToString(t),Er(r));else{var c=sx(r);if(c&&ao(c,t.escapedText))n=e.chainDiagnosticMessages(n,e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_forget_to_use_await,e.declarationNameToString(t),Er(r));else{var u=av(t,r);if(void 0!==u){var l=e.symbolName(u);n=e.chainDiagnosticMessages(n,e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2,e.declarationNameToString(t),Er(r),l),i=u.valueDeclaration&&e.createDiagnosticForNode(u.valueDeclaration,e.Diagnostics._0_is_declared_here,l)}else n=e.chainDiagnosticMessages(n,e.Diagnostics.Property_0_does_not_exist_on_type_1,e.declarationNameToString(t),Er(r))}}var _=e.createDiagnosticForNodeFromMessageChain(t,n);i&&e.addRelatedInfo(_,i),tA.add(_)}function iv(t,r){var n=r.symbol&&ao(Un(r.symbol),t);return void 0!==n&&n.valueDeclaration&&e.hasModifier(n.valueDeclaration,32)}function av(t,r){return dv(e.isString(t)?t:e.idText(t),Pa(r),67220415)}function ov(t,r){var n=av(t,r);return n&&e.symbolName(n)}function sv(t,r,n){e.Debug.assert(void 0!==r,"outername should always be defined");var i=J(t,r,n,void 0,r,!1,!1,function(t,n,i){e.Debug.assertEqual(r,n,"name should equal outerName");var a=L(t,n,i);return a||dv(e.unescapeLeadingUnderscores(n),e.arrayFrom(t.values()),i)});return i}function cv(t,r,n){var i=sv(t,r,n);return i&&e.symbolName(i)}function uv(t,r){return r.exports&&dv(e.idText(t),Bt(r),2623475)}function lv(t,r){var n=uv(t,r);return n&&e.symbolName(n)}function _v(t,r){var n=function(e,r){void 0===r&&(r=1);var n=Na(t,e);if(n){var i=Pv(Un(n));if(i&&Hy(i)===r&&"string"===Er(Uy(i,0)))return!0}return!1},i=e.isAssignmentTarget(r)?"set":"get";if(!n(i))return void 0;var a=e.tryGetPropertyAccessOrIdentifierToString(r);return void 0===a?a=i:a+="."+i,a}function dv(t,r,n){function i(t){var r=e.symbolName(t);return!e.startsWith(r,'"')&&t.flags&n?r:void 0}return e.getSpellingSuggestion(t,r,i)}function pv(t,r,n){if(t&&106500&t.flags&&t.valueDeclaration&&e.hasModifier(t.valueDeclaration,8)&&(!r||!e.isWriteOnlyAccess(r)||65536&t.flags&&!(32768&t.flags))){if(n){var i=e.findAncestor(r,e.isFunctionLikeDeclaration);if(i&&i.symbol===t)return}(1&e.getCheckFlags(t)?I(t).target:t).isReferenced=67108863}}function fv(e,t){switch(e.kind){case 190:return gv(e,99===e.expression.kind,t,Td(yb(e.expression)));case 149:return gv(e,!1,t,Td(yb(e.left)));case 184:return gv(e,!1,t,ju(e))}}function mv(e,t,r){return gv(e,190===e.kind&&99===e.expression.kind,r.escapedName,t)}function gv(t,r,n,i){if(i===tE||Qr(i))return!0;var a=ao(i,n);return a?Ug(t,r,i,a):e.isInJSFile(t)&&0!==(1048576&i.flags)&&i.types.some(function(e){return gv(t,r,n,e)})}function vv(t){var r=t.initializer;if(239===r.kind){var n=r.declarations[0];if(n&&!e.isBindingPattern(n.name))return Ht(n)}else if(73===r.kind)return pp(r);return void 0}function yv(e){return _o(e,1)&&!_o(e,0)}function hv(t){var r=e.skipParentheses(t);if(73===r.kind){var n=pp(r);if(3&n.flags)for(var i=t,a=t.parent;a;){if(227===a.kind&&i===a.statement&&vv(a)===n&&yv(gb(a.expression)))return!0;i=a,a=a.parent}}return!1}function bv(t){var r=Wg(t.expression),n=t.argumentExpression;if(!n){var i=e.getSourceFileOfNode(t);if(193===t.parent.kind&&t.parent.expression===t){var a=e.skipTrivia(i.text,t.expression.end),o=t.end;Wk(i,a,o-a,e.Diagnostics.new_T_cannot_be_used_to_create_an_array_Use_new_Array_T_instead)}else{var a=t.end-"]".length,o=t.end;Wk(i,a,o-a,e.Diagnostics.Expression_expected)}return tE}var s=yb(n);if(r===tE||r===yE)return r;if(Oh(r)&&10!==n.kind)return y(n,e.Diagnostics.A_const_enum_member_can_only_be_accessed_using_a_string_literal),tE;var c=hv(n)?cE:s,u=e.isAssignmentTarget(t)?2|(Xc(r)&&!Zc(r)?1:0):0,l=su(r,c,t,u)||tE;return Gb(l,t)}function xv(t,r,n){if(r===tE)return!1;if(!e.isWellKnownSymbolSyntactically(t))return!1;if(0===(12288&r.flags))return n&&y(t,e.Diagnostics.A_computed_property_name_of_the_form_0_must_be_of_type_symbol,e.getTextOfNode(t)),!1;var i=t.expression,a=pp(i);if(!a)return!1;var o=Ls(!0);return o?a!==o?(n&&y(i,e.Diagnostics.Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object),!1):!0:!1}function Dv(t){return e.isCallOrNewExpression(t)||e.isTaggedTemplateExpression(t)||e.isJsxOpeningLikeElement(t)}function Sv(t){return Dv(t)&&e.forEach(t.typeArguments,yS),194===t.kind?yb(t.template):e.isJsxOpeningLikeElement(t)?yb(t.attributes):153!==t.kind&&e.forEach(t.arguments,function(e){yb(e)}),DN}function Cv(e){return Sv(e),SN}function kv(t,r){var n,i,a,o,s=0,c=-1;e.Debug.assert(!r.length);for(var u=0,l=t;u<l.length;u++){var _=l[u],d=_.declaration&&Ht(_.declaration),p=_.declaration&&_.declaration.parent;i&&d!==i?(a=s=r.length,n=p):n&&p===n?a+=1:(n=p,a=s),i=d,_.hasLiteralTypes?(c++,o=c,s++):o=a,r.splice(o,0,_)}}function Tv(e){return!!e&&(209===e.kind||216===e.kind&&e.isSpread)}function Ev(t){return e.findIndex(t,Tv)}function Nv(e){return!!(16384&e.flags)}function Av(t,r,n,i){void 0===i&&(i=!1);var a,o=!1,s=Wy(n),c=Hy(n);if(194===t.kind)if(a=r.length,207===t.template.kind){var u=e.last(t.template.templateSpans);o=e.nodeIsMissing(u.literal)||!!u.literal.isUnterminated}else{var l=t.template;e.Debug.assert(14===l.kind),o=!!l.isUnterminated}else if(153===t.kind)a=Hv(t,n);else if(e.isJsxOpeningLikeElement(t)){if(o=t.attributes.end===t.end)return!0;a=0===c?r.length:1,s=0===r.length?s:1,c=Math.min(c,1)}else{if(!t.arguments)return e.Debug.assert(193===t.kind),0===Hy(n);a=i?r.length+1:r.length,o=t.arguments.end===t.end;var _=Ev(r);if(_>=0)return _>=Hy(n)&&(Gy(n)||_<Wy(n))}if(!Gy(n)&&a>s)return!1;if(o||a>=c)return!0;for(var d=a;c>d;d++){var p=Uy(n,d);if(131072&cf(p,Nv).flags)return!1}return!0}function Fv(t,r){var n=e.length(t.typeParameters),i=Do(t.typeParameters);return!r||r.length>=i&&r.length<=n}function Pv(e){return Iv(e,0,!1)}function wv(e){return Iv(e,0,!1)||Iv(e,1,!1)}function Iv(e,t,r){if(524288&e.flags){var n=Ta(e);if(r||0===n.properties.length&&!n.stringIndexInfo&&!n.numberIndexInfo){if(0===t&&1===n.callSignatures.length&&0===n.constructSignatures.length)return n.callSignatures[0];if(1===t&&1===n.constructSignatures.length&&0===n.callSignatures.length)return n.constructSignatures[0]}}return void 0}function Ov(t,r,n,i){var a=Id(t.typeParameters,t,0,i),o=Qy(r),s=n&&(o&&262144&o.flags?n.nonFixingMapper:n.mapper),c=s?rl(r,s):r;return Pd(c,t,function(e,t){tp(a.inferences,e,t)}),n||wd(r,t,function(e,t){tp(a.inferences,e,t,16)}),Jo(t,_p(a),e.isInJSFile(r.declaration))}function Mv(e,t,r,n){var i=Jm(t,e),a=$h(e.attributes,i,n,r);return tp(n.inferences,a,i),_p(n)}function Lv(t,r,n,i,a){if(e.isJsxOpeningLikeElement(t))return Mv(t,r,i,a);if(153!==t.kind){var o=Rm(t);if(o){var s=Jd(Od(Bm(t),1)),c=gl(o,s),u=Pv(c),l=u&&u.typeParameters?Qo(zo(u,u.typeParameters)):c,_=Mo(r);tp(a.inferences,l,_,16),a.returnMapper=Jd(Md(a))}}var d=Po(r);if(d){var p=Uv(t),f=p?yb(p):gE;tp(a.inferences,f,d)}for(var m=Xy(r),g=m?Math.min(Wy(r)-1,n.length):n.length,v=0;g>v;v++){var y=n[v];if(211!==y.kind){var h=Uy(r,v),b=$h(y,h,a,i);tp(a.inferences,b,h)}}if(m){var x=Bv(n,g,n.length,m,a);tp(a.inferences,x,m)}return _p(a)}function Rv(e){return of(e,function(e){return!(63176705&e.flags||J_(e)||td(e))})?ic(ou(e,cE)):e}function Bv(t,r,n,i,a){if(r>=n-1){var o=t[n-1];if(Tv(o))return 216===o.kind?ic(o.type):Rv($h(o.expression,i,a,0))}for(var s=[],c=-1,u=r;n>u;u++){var l=ou(i,Iu(u-r)),_=$h(t[u],l,a,0);0>c&&Tv(t[u])&&(c=u-r);var d=Ph(l,4325372);s.push(d?Pu(_):Z_(_))}return 0>c?uc(s):uc(e.append(s.slice(0,c),Dc(s.slice(c))),c,!0)}function jv(t,r,n,i){for(var a,o=e.isInJSFile(t.declaration),s=t.typeParameters,c=So(e.map(r,ju),s,Do(s),o),u=0;u<r.length;u++){e.Debug.assert(void 0!==s[u],"Should not call checkTypeArguments with too many type arguments");var l=Ma(s[u]);if(l){var _=n&&i?function(){return e.chainDiagnosticMessages(void 0,e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1)}:void 0,d=i||e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1;a||(a=Wu(s,c));var p=c[u];if(!Ml(p,Vi(gl(l,a),p),n?r[u]:void 0,d,_))return void 0}}return c}function Jv(t){if(gg(t.tagName))return 2;var r=to(yb(t.tagName));return e.length(so(r,1))?0:e.length(so(r,0))?1:2}function zv(e,t,r,n,i){var a=Jm(t,e),o=$h(e.attributes,a,void 0,n);return Rl(o,a,r,i?e.tagName:void 0,e.attributes)}function Vv(t,r,n,i,a,o){if(e.isJsxOpeningLikeElement(t))return zv(t,n,i,a,o);var s=Po(n);if(s&&s!==gE&&193!==t.kind){var c=Uv(t),u=c?yb(c):gE,l=o?c||t:void 0,_=e.Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1;if(!d_(u,s,i,l,_))return!1}for(var d=e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1,p=Xy(n),f=p?Math.min(Wy(n)-1,r.length):r.length,m=0;f>m;m++){var g=r[m];if(211!==g.kind){var v=Uy(n,m),y=$h(g,v,void 0,a),h=4&a?hd(y):y;if(!Rl(h,v,i,o?g:void 0,g,d))return!1}}if(p){var b=Bv(r,f,r.length,p,void 0),l=o?f<r.length?r[f]:t:void 0;return d_(b,p,i,l,d)}return!0}function Uv(t){if(192===t.kind){var r=e.skipOuterExpressions(t.expression);if(190===r.kind||191===r.kind)return r.expression}}function Kv(t,r,n){var i=e.createNode(216,t.pos,t.end);return i.parent=t,i.type=r,i.isSpread=n||!1,i}function qv(t){if(194===t.kind){var r=t.template,n=[Kv(r,Os())];return 207===r.kind&&e.forEach(r.templateSpans,function(e){n.push(e.expression)}),n}if(153===t.kind)return Wv(t);if(e.isJsxOpeningLikeElement(t))return t.attributes.properties.length>0||e.isJsxOpeningElement(t)&&t.parent.children.length>0?[t.attributes]:e.emptyArray;var i=t.arguments||e.emptyArray,a=i.length;if(a&&Tv(i[a-1])&&Ev(i)===a-1){var o=i[a-1],s=FN?yb(o.expression):eb(o.expression);if(td(s)){var c=s.typeArguments||e.emptyArray,u=s.target.hasRestElement?c.length-1:-1,l=e.map(c,function(e,t){return Kv(o,e,t===u)});return e.concatenate(i.slice(0,a-1),l)}}return i}function Wv(t){var r=t.parent,n=t.expression;switch(r.kind){case 241:case 210:return[Kv(n,Un(Ht(r)))];case 152:var i=r.parent;return[Kv(n,158===r.parent.kind?Un(Ht(i)):tE),Kv(n,ZT),Kv(n,cE)];case 155:case 157:case 159:case 160:var a=155!==r.kind&&0!==DT;return[Kv(n,eC(r)),Kv(n,tC(r)),Kv(n,a?$s(XS(r)):ZT)]}return e.Debug.fail()}function Hv(t,r){switch(t.parent.kind){case 241:case 210:return 1;case 155:return 2;case 157:case 159:case 160:return 0===DT||r.parameters.length<=2?2:3;case 152:return 3;default:return e.Debug.fail()}}function Gv(t,r,n){for(var i,a=Number.POSITIVE_INFINITY,o=Number.NEGATIVE_INFINITY,s=Number.NEGATIVE_INFINITY,c=Number.POSITIVE_INFINITY,u=n.length,l=0,_=r;l<_.length;l++){var d=_[l],p=Hy(d),f=Wy(d);u>p&&p>s&&(s=p),f>u&&c>f&&(c=f),a>p&&(a=p,i=d),o=Math.max(o,f)}var m=e.some(r,Gy),g=m?a:o>a?a+"-"+o:a,v=Ev(n)>-1;o>=u&&v&&u--;var y,h,b=m||v?m&&v?e.Diagnostics.Expected_at_least_0_arguments_but_got_1_or_more:m?e.Diagnostics.Expected_at_least_0_arguments_but_got_1:e.Diagnostics.Expected_0_arguments_but_got_1_or_more:e.Diagnostics.Expected_0_arguments_but_got_1;if(i&&Hy(i)>u&&i.declaration){var x=i.declaration.parameters[i.thisParameter?u+1:u];x&&(h=e.createDiagnosticForNode(x,e.isBindingPattern(x.name)?e.Diagnostics.An_argument_matching_this_binding_pattern_was_not_provided:e.Diagnostics.An_argument_for_0_was_not_provided,x.name?e.isBindingPattern(x.name)?void 0:e.idText(iS(x.name)):u))}if(u>a&&o>u)return e.createDiagnosticForNode(t,e.Diagnostics.No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments,u,s,c);if(!v&&a>u){var D=e.createDiagnosticForNode(t,b,g,u);return h?e.addRelatedInfo(D,h):D}if(m||v){if(y=e.createNodeArray(n),v&&u){var S=e.elementAt(n,Ev(n)+1)||void 0;y=e.createNodeArray(n.slice(o>u&&S?n.indexOf(S):Math.min(o,n.length-1)))}}else y=e.createNodeArray(n.slice(o));y.pos=e.first(y).pos,y.end=e.last(y).end,y.end===y.pos&&y.end++;var C=e.createDiagnosticForNodeArray(e.getSourceFileOfNode(t),y,b,g,u);return h?e.addRelatedInfo(C,h):C}function Qv(t,r,n){var i=n.length;if(1===r.length){var a=r[0],o=Do(a.typeParameters),s=e.length(a.typeParameters);return e.createDiagnosticForNodeArray(e.getSourceFileOfNode(t),n,e.Diagnostics.Expected_0_type_arguments_but_got_1,s>o?o+"-"+s:o,i)}for(var c=-1/0,u=1/0,l=0,_=r;l<_.length;l++){var a=_[l],d=Do(a.typeParameters),s=e.length(a.typeParameters);d>i?u=Math.min(u,d):i>s&&(c=Math.max(c,s))}return c!==-1/0&&1/0!==u?e.createDiagnosticForNodeArray(e.getSourceFileOfNode(t),n,e.Diagnostics.No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments,i,c,u):e.createDiagnosticForNodeArray(e.getSourceFileOfNode(t),n,e.Diagnostics.Expected_0_type_arguments_but_got_1,c===-1/0?u:c,i)}function Xv(t,r,n,i,a){function o(r,n,i){if(void 0===i&&(i=!1),f=void 0,m=void 0,g=void 0,h){var a=r[0];return s||!Av(t,y,a,i)?void 0:Vv(t,y,a,n,0,!1)?a:void(f=a)}for(var o=0;o<r.length;o++){var a=r[o];if(Fv(a,s)&&Av(t,y,a,i)){var c=void 0,u=void 0;if(a.typeParameters){var l=void 0;if(s){if(l=jv(a,s,!1),!l){g=a;continue}}else u=Id(a.typeParameters,a,e.isInJSFile(t)?2:0),l=Lv(t,a,y,8|b,u),b|=4&u.flags?8:0;if(c=Jo(a,l,e.isInJSFile(a.declaration),u&&u.inferredTypeParameters),Xy(a)&&!Av(t,y,c,i)){m=c;continue}}else c=a;if(Vv(t,y,c,n,b,!1)){if(b){if(b=0,u){var l=Lv(t,a,y,b,u);if(c=Jo(a,l,e.isInJSFile(a.declaration),u&&u.inferredTypeParameters),Xy(a)&&!Av(t,y,c,i)){m=c;continue}}if(!Vv(t,y,c,n,b,!1)){f&&!Qy(f)&&Qy(c)||(f=c);continue}}return r[o]=c,c}f&&!Qy(f)&&Qy(c)||(f=c)}}return void 0}var s,c=194===t.kind,u=153===t.kind,_=e.isJsxOpeningLikeElement(t),d=!n;u||(s=t.typeArguments,(c||_||99!==t.expression.kind)&&e.forEach(s,yS));var p=n||[];if(kv(r,p),!p.length)return d&&tA.add(e.createDiagnosticForNode(t,e.Diagnostics.Call_target_does_not_contain_any_signatures)),Cv(t);var f,m,g,v,y=qv(t),h=1===p.length&&!p[0].typeParameters,b=u||h||!e.some(y,xl)?0:4,x=!!(16&i)&&192===t.kind&&t.arguments.hasTrailingComma;if(p.length>1&&(v=o(p,_A,x)),v||(v=o(p,dA,x)),v)return v;if(d)if(f)Vv(t,y,f,dA,0,!0);else if(m)tA.add(Gv(t,[m],y));else if(g)jv(g,t.typeArguments,!0,a);else{var D=e.filter(r,function(e){return Fv(e,s)});0===D.length?tA.add(Qv(t,r,s)):u?a&&tA.add(e.createDiagnosticForNode(t,a)):tA.add(Gv(t,D,y))}return l||!y?Cv(t):Yv(t,p,y,!!n)}function Yv(t,r,n,i){return e.Debug.assert(r.length>0),i||1===r.length||r.some(function(e){return!!e.typeParameters})?ry(t,r,n):Zv(r)}function Zv(t){var r,n=e.mapDefined(t,function(e){return e.thisParameter});n.length&&(r=ey(n,n.map(zy)));for(var i=e.minAndMax(t,$v),a=i.min,o=i.max,s=[],c=function(r){var n=e.mapDefined(t,function(t){var n=t.parameters,i=t.hasRestParameter;return i?r<n.length-1?n[r]:e.last(n):r<n.length?n[r]:void 0});e.Debug.assert(0!==n.length),s.push(ey(n,e.mapDefined(t,function(e){return Ky(e,r)})))},u=0;o>u;u++)c(u);var l=e.mapDefined(t,function(t){return t.hasRestParameter?e.last(t.parameters):void 0}),_=0!==l.length;if(_){var d=ic(Dc(e.mapDefined(t,jo),2));s.push(ty(l,d))}return Wi(t[0].declaration,void 0,r,s,Ic(t.map(Mo)),void 0,a,_,t.some(function(e){return e.hasLiteralTypes}))}function $v(e){var t=e.parameters.length;return e.hasRestParameter?t-1:t}function ey(e,t){return ty(e,Dc(t,2))}function ty(t,r){return vd(e.first(t),r)}function ry(t,r,n){var i=ay(r,void 0===BT?n.length:BT),a=r[i],o=a.typeParameters;if(!o)return a;var s=Dv(t)?t.typeArguments:void 0,c=s?Vo(a,ny(s,o,e.isInJSFile(t))):iy(t,o,a,n);return r[i]=c,c}function ny(e,t,r){for(var n=e.map(XS);n.length>t.length;)n.pop();for(;n.length<t.length;)n.push(Ma(t[n.length])||lp(r));return n}function iy(t,r,n,i){var a=Id(r,n,e.isInJSFile(t)?2:0),o=Lv(t,n,i,12,a);return Vo(n,o)}function ay(e,t){for(var r=-1,n=-1,i=0;i<e.length;i++){var a=e[i],o=Wy(a);if(Gy(a)||o>=t)return i;o>n&&(n=o,r=i)}return r}function oy(t,r,n){if(99===t.expression.kind){var i=nm(t.expression);if(Qr(i)){for(var a=0,o=t.arguments;a<o.length;a++){var s=o[a];yb(s)}return DN}if(i!==tE){var c=e.getEffectiveBaseTypeNode(e.getContainingClass(t));if(c){var u=ri(i,c.typeArguments,c);return Xv(t,u,r,n)}}return Sv(t)}var l=Wg(t.expression,e.Diagnostics.Cannot_invoke_an_object_which_is_possibly_null,e.Diagnostics.Cannot_invoke_an_object_which_is_possibly_undefined,e.Diagnostics.Cannot_invoke_an_object_which_is_possibly_null_or_undefined);if(l===yE)return kN;var _=to(l);if(_===tE)return Cv(t);var d=so(_,0),p=so(_,1).length;if(cy(l,_,d.length,p))return l!==tE&&t.typeArguments&&y(t,e.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments),Sv(t);if(!d.length){if(p)y(t,e.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new,Er(l));else{var f=void 0;if(1===t.arguments.length){var m=e.getSourceFileOfNode(t).text;e.isLineBreak(m.charCodeAt(e.skipTrivia(m,t.expression.end,!0)-1))&&(f=e.createDiagnosticForNode(t.expression,e.Diagnostics.It_is_highly_likely_that_you_are_missing_a_semicolon))}dy(t,_,0,f)}return Cv(t)}return 8&n&&!t.typeArguments&&d.some(sy)?(ub(t,n),CN):d.some(function(t){return e.isInJSFile(t.declaration)&&!!e.getJSDocClassTag(t.declaration)})?(y(t,e.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new,Er(l)),Cv(t)):Xv(t,d,r,n)}function sy(e){return!(!e.typeParameters||!FC(Mo(e)))}function cy(e,t,r,n){return Qr(e)||Qr(t)&&!!(262144&e.flags)||!r&&!n&&!(1179648&t.flags)&&Pl(e,zE)}function uy(t,r,n){if(t.arguments&&1>DT){var i=Ev(t.arguments);i>=0&&y(t.arguments[i],e.Diagnostics.Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher)}var a=Wg(t.expression);if(a===yE)return kN;if(a=to(a),a===tE)return Cv(t);if(Qr(a))return t.typeArguments&&y(t,e.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments),Sv(t);var o=so(a,1);if(o.length){if(!_y(t,o[0]))return Cv(t);var s=a.symbol&&e.getClassLikeDeclarationOfSymbol(a.symbol);return s&&e.hasModifier(s,128)?(y(t,e.Diagnostics.Cannot_create_an_instance_of_an_abstract_class),Cv(t)):Xv(t,o,r,n)}var c=so(a,0);if(c.length){var u=Xv(t,c,r,n);return AT||(u.declaration&&!Dy(u.declaration)&&Mo(u)!==gE&&y(t,e.Diagnostics.Only_a_void_function_can_be_called_with_the_new_keyword),Po(u)===gE&&y(t,e.Diagnostics.A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void)),u}return dy(t,a,1),Cv(t)}function ly(t,r){var n=ii(r);if(!e.length(n))return!1;var i=n[0];if(2097152&i.flags){for(var a=i.types,o=ca(a),s=0,c=0,u=i.types;c<u.length;c++){var l=u[c];if(!o[s]&&3&e.getObjectFlags(l)){if(l.symbol===t)return!0;if(ly(t,l))return!0}s++}return!1}return i.symbol===t?!0:ly(t,i)}function _y(t,r){if(!r||!r.declaration)return!0;var n=r.declaration,i=e.getSelectedModifierFlags(n,24);if(!i)return!0;var a=e.getClassLikeDeclarationOfSymbol(n.parent.symbol),o=bi(n.parent.symbol);if(!zS(t,a)){var s=e.getContainingClass(t);if(s&&16&i){var c=XS(s);if(ly(n.parent.symbol,c))return!0}return 8&i&&y(t,e.Diagnostics.Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration,Er(o)),16&i&&y(t,e.Diagnostics.Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration,Er(o)),!1}return!0}function dy(t,r,n,i){var a=y(t,0===n?e.Diagnostics.Cannot_invoke_an_expression_whose_type_lacks_a_call_signature_Type_0_has_no_compatible_call_signatures:e.Diagnostics.Cannot_use_new_with_an_expression_whose_type_lacks_a_call_or_construct_signature,Er(r));py(r,n,i?e.addRelatedInfo(a,i):a)}function py(t,r,n){if(t.symbol){var i=I(t.symbol).originatingImport;if(i&&!e.isImportCall(i)){var a=so(Un(I(t.symbol).target),r);if(!a||!a.length)return;e.addRelatedInfo(n,e.createDiagnosticForNode(i,e.Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead))}}}function fy(e,t,r){var n=yb(e.tag),i=to(n);if(i===tE)return Cv(e);var a=so(i,0),o=so(i,1).length;return cy(n,i,a.length,o)?Sv(e):a.length?Xv(e,a,t,r):(dy(e,i,0),Cv(e))}function my(t){switch(t.parent.kind){case 241:case 210:return e.Diagnostics.Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression;case 152:return e.Diagnostics.Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression;case 155:return e.Diagnostics.Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression;case 157:case 159:case 160:return e.Diagnostics.Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression;default:return e.Debug.fail()}}function gy(t,r,n){var i=yb(t.expression),a=to(i);if(a===tE)return Cv(t);var o=so(a,0),s=so(a,1).length;if(cy(i,a,o.length,s))return Sv(t);if(hy(t,o)){var c=e.getTextOfNode(t.expression,!1);return y(t,e.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0,c),Cv(t)}var u=my(t);if(!o.length){var l=e.chainDiagnosticMessages(void 0,e.Diagnostics.Cannot_invoke_an_expression_whose_type_lacks_a_call_signature_Type_0_has_no_compatible_call_signatures,Er(a));l=e.chainDiagnosticMessages(l,u);var _=e.createDiagnosticForNodeFromMessageChain(t,l);return tA.add(_),py(a,0,_),Cv(t)}return Xv(t,o,r,n,u)}function vy(t,r){var n=Sg(t),i=n&&Vt(n),a=i&&L(i,f.Element,67897832),o=a&&OT.symbolToEntityName(a,67897832,t),s=e.createFunctionTypeNode(void 0,[e.createParameter(void 0,void 0,void 0,"props",void 0,OT.typeToTypeNode(r,t))],o?e.createTypeReferenceNode(o,void 0):e.createKeywordTypeNode(121)),c=x(1,"props");return c.type=r,Wi(s,void 0,void 0,[c],a?bi(a):tE,void 0,1,!1,!1)}function yy(t,r,n){if(gg(t.tagName)){var i=Pg(t),a=vy(t,i);return Ll($h(t.attributes,Jm(a,t),void 0,0),i,t.tagName,t.attributes),a}var o=yb(t.tagName),s=to(o);if(s===tE)return Cv(t);var c=Ng(o,t);return cy(o,s,c.length,0)?Sv(t):0===c.length?(y(t.tagName,e.Diagnostics.JSX_element_type_0_does_not_have_any_construct_or_call_signatures,e.getTextOfNode(t.tagName)),Cv(t)):Xv(t,c,r,n)}function hy(t,r){return r.length&&e.every(r,function(e){return 0===e.minArgumentCount&&!e.hasRestParameter&&e.parameters.length<Hv(t,e)})}function by(t,r,n){switch(t.kind){case 192:return oy(t,r,n);case 193:return uy(t,r,n);case 194:return fy(t,r,n);case 153:return gy(t,r,n);case 263:case 262:return yy(t,r,n)}throw e.Debug.assertNever(t,"Branch in 'resolveSignature' should be unreachable.")}function xy(e,t,r){var n=O(e),i=n.resolvedSignature;if(i&&i!==CN&&!t)return i;n.resolvedSignature=CN;var a=by(e,t,r||0);return a!==CN&&(n.resolvedSignature=AN===FN?a:i),a}function Dy(t){if(!t||!e.isInJSFile(t))return!1;var r=e.isFunctionDeclaration(t)||e.isFunctionExpression(t)?t:e.isVariableDeclaration(t)&&t.initializer&&e.isFunctionExpression(t.initializer)?t.initializer:void 0;if(r){if(e.getJSDocClassTag(t))return!0;var n=Ht(r);return!!n&&(void 0!==n.members||void 0!==n.exports&&void 0!==n.exports.get("prototype"))}return!1}function Sy(e){if(524288&e.flags){var t=Ta(e);return 1===t.callSignatures.length&&Dy(t.callSignatures[0].declaration)}return!1}function Cy(e){var t;Dy(e.valueDeclaration)&&(t=Ey(e));var r=ky(e);return r&&t?Ic([t,r]):r||t}function ky(t){var r=t.valueDeclaration,n=r&&r.parent&&(e.isFunctionDeclaration(r)&&Ht(r)||e.isBinaryExpression(r.parent)&&Ht(r.parent.left)||e.isVariableDeclaration(r.parent)&&Ht(r.parent)),i=n&&n.exports&&n.exports.get("prototype"),a=i&&i.valueDeclaration&&Ty(i.valueDeclaration);return a?yb(a):void 0}function Ty(t){if(!t.parent)return!1;for(var r=t.parent;r&&190===r.kind;)r=r.parent;if(r&&e.isBinaryExpression(r)&&e.isPrototypeAccess(r.left)&&60===r.operatorToken.kind){var n=e.getInitializerOfBinaryExpression(r);return e.isObjectLiteralExpression(n)&&n}}function Ey(t){var r=I(t);return r.inferredClassType||(r.inferredClassType=lr(t,Ji(t)||hT,e.emptyArray,e.emptyArray,void 0,void 0)),r.inferredClassType}function Ny(t,r){_k(t,t.typeArguments)||pk(t.arguments);var n=xy(t,void 0,r);if(n===CN)return hE;if(99===t.expression.kind)return gE;if(193===t.kind){var i=n.declaration;if(i&&158!==i.kind&&162!==i.kind&&167!==i.kind&&!e.isJSDocConstructSignature(i)&&!Dy(i))return AT&&y(t,e.Diagnostics.new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type),ZT}if(e.isInJSFile(t)&&wy(t))return Fo(t.arguments[0]);var a=Mo(n);if(12288&a.flags&&Ay(t))return Lu(e.walkUpParenthesizedExpressions(t.parent));var o;if(e.isInJSFile(t)){var s=e.getDeclarationOfExpando(t);if(s){var c=Ht(s);c&&e.hasEntries(c.exports)&&(o=lr(c,c.exports,e.emptyArray,e.emptyArray,void 0,void 0),o.objectFlags|=16384)}}return o?Ic([a,o]):a}function Ay(t){if(!e.isCallExpression(t))return!1;var r=t.expression;if(e.isPropertyAccessExpression(r)&&"for"===r.name.escapedText&&(r=r.expression),!e.isIdentifier(r)||"Symbol"!==r.escapedText)return!1;var n=Ls(!1);return n?n===j(r,"Symbol",67220415,void 0,void 0,!1):!1}function Fy(t){if(pk(t.arguments)||aT(t),0===t.arguments.length)return ah(t,ZT);for(var r=t.arguments[0],n=eb(r),i=1;i<t.arguments.length;++i)eb(t.arguments[i]);(32768&n.flags||65536&n.flags||!Pl(n,sE))&&y(r,e.Diagnostics.Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0,Er(n));var a=At(t,r);if(a){var o=Lt(a,r,!0);if(o)return ah(t,Py(Un(o),o,a))}return ah(t,ZT)}function Py(t,r,n){if(CT&&t&&t!==tE){var i=t;if(!i.syntheticType){var a=e.find(n.declarations,e.isSourceFile),o=ot(a,n,!1);if(o){var s=e.createSymbolTable(),c=x(2097152,"default");c.nameType=Iu("default"),c.target=ht(r),s.set("default",c);var u=x(2048,"__type"),l=lr(u,s,e.emptyArray,e.emptyArray,void 0,void 0);u.type=l,i.syntheticType=ug(t)?ku(t,l,u,0,!1):l}else i.syntheticType=t}return i.syntheticType}return t}function wy(t){if(!e.isRequireCall(t,!0))return!1;if(!e.isIdentifier(t.expression))return e.Debug.fail();var r=j(t.expression,t.expression.escapedText,67220415,void 0,void 0,!0);if(r===JT)return!0;if(2097152&r.flags)return!1;var n=16&r.flags?240:3&r.flags?238:0;if(0!==n){var i=e.getDeclarationOfKind(r,n);return!!i&&!!(4194304&i.flags)}return!1}function Iy(e){return _k(e,e.typeArguments),2>DT&&KC(e,65536),Mo(xy(e))}function Oy(e){return Ly(e,e.type,e.expression)}function My(t){switch(t.kind){case 10:case 14:case 8:case 9:case 103:case 88:case 188:case 189:return!0;case 196:return My(t.expression);case 203:var r=t.operator,n=t.operand;return 39===r&&(8===n.kind||9===n.kind)||38===r&&8===n.kind;case 190:case 191:var i=t.expression;if(e.isIdentifier(i)){var a=HS(i);return!!(a&&384&a.flags&&1===fi(a))}}return!1}function Ly(t,r,n,i){var a=yb(n,i);if(e.isConstTypeReference(r))return My(n)||y(n,e.Diagnostics.A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals),Pu(a);yS(r),a=hd(Y_(a));var o=ju(r);if(l&&o!==tE){var s=Td(a);Il(o,s)||Zl(a,o,t,e.Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first)}return o}function Ry(e){return fd(yb(e.expression))}function By(t){return Uk(t),96===t.keywordToken?jy(t):93===t.keywordToken?Jy(t):e.Debug.assertNever(t.keywordToken)}function jy(t){var r=e.getNewTargetContainer(t);if(r){if(158===r.kind){var n=Ht(r.parent);return Un(n)}var n=Ht(r);return Un(n)}return y(t,e.Diagnostics.Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor,"new.target"),tE}function Jy(t){(8>DT||ST<e.ModuleKind.ESNext)&&y(t,e.Diagnostics.The_import_meta_meta_property_is_only_allowed_using_ESNext_for_the_target_and_module_compiler_options);var r=e.getSourceFileOfNode(t);return e.Debug.assert(!!(1048576&r.flags),"Containing file is missing import meta node flag."),e.Debug.assert(!!r.externalModuleIndicator,"Containing file should be a module."),"meta"===t.name.escapedText?Ms():tE}function zy(t){var r=Un(t);if(kT){var n=t.valueDeclaration;if(n&&e.hasInitializer(n))return dd(r)}return r}function Vy(e,t){var r=e.parameters.length-(e.hasRestParameter?1:0);if(r>t)return e.parameters[t].escapedName;var n=e.parameters[r]||XT,i=Un(n);if(td(i)){var a=i.target.associatedNames,o=t-r;return a&&a[o]||n.escapedName+"_"+o}return n.escapedName}function Uy(e,t){return Ky(e,t)||ZT}function Ky(t,r){var n=t.parameters.length-(t.hasRestParameter?1:0);if(n>r)return zy(t.parameters[r]);if(t.hasRestParameter){var i=Un(t.parameters[n]),a=r-n;if(!td(i)||i.target.hasRestElement||a<(i.typeArguments||e.emptyArray).length)return ou(i,Iu(a))}return void 0}function qy(e,t){var r=Wy(e),n=Qy(e),i=r-(n?1:0);if(n&&t===i)return n;for(var a=[],o=[],s=t;i>s;s++)a.push(Uy(e,s)),o.push(Vy(e,s));n&&(a.push(ou(n,cE)),o.push(Vy(e,i)));var c=Hy(e),u=t>c?0:c-t;return uc(a,u,!!n,!1,o)}function Wy(t){var r=t.parameters.length;if(t.hasRestParameter){var n=Un(t.parameters[r-1]);if(td(n))return r+(n.typeArguments||e.emptyArray).length-1}return r}function Hy(e){if(e.hasRestParameter){var t=Un(e.parameters[e.parameters.length-1]);if(td(t)){var r=t.target.minLength;if(r>0)return e.parameters.length-1+r}}return e.minArgumentCount}function Gy(e){if(e.hasRestParameter){var t=Un(e.parameters[e.parameters.length-1]);return!td(t)||t.target.hasRestElement}return!1}function Qy(e){if(e.hasRestParameter){var t=Un(e.parameters[e.parameters.length-1]);return td(t)?nd(t):t}return void 0}function Xy(e){var t=Qy(e);return!t||J_(t)||Qr(t)?void 0:t}function Yy(e){return Zy(e,vE)}function Zy(e,t){return e.parameters.length>0?Uy(e,0):t}function $y(t,r,n){for(var i=t.parameters.length-(t.hasRestParameter?1:0),a=0;i>a;a++){var o=t.parameters[a].valueDeclaration;if(o.type){var s=e.getEffectiveTypeAnnotationNode(o);s&&tp(n.inferences,ju(s),Uy(r,a))}}var c=Qy(r);if(c&&262144&c.flags){var u=rl(r,n.nonFixingMapper);eh(t,u);var l=Wy(r)-1;tp(n.inferences,qy(t,l),c)}}function eh(t,r){if(t.typeParameters=r.typeParameters,r.thisParameter){var n=t.thisParameter;(!n||n.valueDeclaration&&!n.valueDeclaration.type)&&(n||(t.thisParameter=vd(r.thisParameter,void 0)),rh(t.thisParameter,Un(r.thisParameter)))}for(var i=t.parameters.length-(t.hasRestParameter?1:0),a=0;i>a;a++){var n=t.parameters[a];if(!e.getEffectiveTypeAnnotationNode(n.valueDeclaration)){var o=Uy(r,a);rh(n,o)}}if(t.hasRestParameter){var n=e.last(t.parameters);if(D(n)||!e.getEffectiveTypeAnnotationNode(n.valueDeclaration)){var o=qy(r,i);rh(n,o)}}}function th(t){for(var r=0,n=t.elements;r<n.length;r++){var i=n[r];e.isOmittedExpression(i)||(73===i.name.kind?I(Ht(i)).type=an(i):th(i.name))}}function rh(e,t){var r=I(e);if(!r.type){r.type=t;var n=e.valueDeclaration;73!==n.name.kind&&(r.type===rE&&(r.type=Dn(n.name)),th(n.name))}}function nh(e){var t=Bs(!0);return t!==AE?(e=ux(e)||rE,os(t,[e])):rE}function ih(e){var t=js(!0);return t!==AE?(e=ux(e)||rE,os(t,[e])):rE}function ah(t,r){var n=nh(r);return n===rE?(y(t,e.isImportCall(t)?e.Diagnostics.A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option:e.Diagnostics.An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option),tE):(Js(!0)||y(t,e.isImportCall(t)?e.Diagnostics.A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option:e.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option),n)}function oh(t,r){if(!t.body)return tE;var n,i=e.getFunctionFlags(t);if(219!==t.body.kind)n=eb(t.body,r&&-9&r),2&i&&(n=cx(n,t,e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member));else{var a=dh(t,r);if(1&i){if(a=e.concatenate(sh(t,r),a),!a||0===a.length){var o=2&i?tc(ZT):nc(ZT);return AT&&y(t.asteriskToken,e.Diagnostics.Generator_implicitly_has_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type,Er(o)),o}}else{if(!a)return 2&i?ah(t,vE):vE;if(0===a.length)return 2&i?ah(t,gE):gE}n=Dc(a,2)}var s=Qm(t);if(s||Fd(t,n),Q_(n)){var c=s?s===Co(t)?n:Mo(s):void 0;
if(c)switch(3&i){case 3:c=yD(c,!0);break;case 1:c=yD(c,!1);break;case 2:c=sx(c)}n=ed(n,c)}var u=Td(n);switch(3&i){case 3:return tc(u);case 1:return nc(u);case 2:return nh(u);default:return u}}function sh(t,r){var n=[],i=0!==(2&e.getFunctionFlags(t));return e.forEachYieldExpression(t.body,function(t){e.pushIfUnique(n,ch(t,i,r))}),n}function ch(t,r,n){var i=t.expression||t,a=t.expression?yb(t.expression,n):iE,o=t.asteriskToken?pD(a,i,!1,r):a;return r?ux(o,i,t.asteriskToken?e.Diagnostics.Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:e.Diagnostics.Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member):o}function uh(e,t,r,n){var i=0;if(n){for(var a=t;a<r.length;a++)i|=cA.get(r[a])||32768;for(var a=e;t>a;a++)i&=~(cA.get(r[a])||0);for(var a=0;e>a;a++)i|=cA.get(r[a])||32768}else{for(var a=e;t>a;a++)i|=sA.get(r[a])||128;for(var a=0;e>a;a++)i&=~(sA.get(r[a])||0)}return i}function lh(t){if(!t.possiblyExhaustive)return!1;if(200===t.expression.kind){var r=gb(t.expression.expression),n=tf(t),i=uh(0,0,n,!0),a=Ka(r)||r;return!!(131072&cf(a,function(e){return(wp(e)&i)===i}).flags)}var o=gb(t.expression);if(!X_(o))return!1;var s=ef(t);return!s.length||e.some(s,G_)?!1:rf(lf(o,Pu),s)}function _h(t){return 128&t.flags?e.some(t.body.statements,function(e){return 233===e.kind&&lh(e)})?!1:!0:!1}function dh(t,r){var n=e.getFunctionFlags(t),i=[],a=_h(t),o=!1;return e.forEachReturnStatement(t.body,function(s){var c=s.expression;if(c){var u=eb(c,r&&-9&r);2&n&&(u=cx(u,t,e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member)),131072&u.flags&&(o=!0),e.pushIfUnique(i,u)}else a=!0}),0!==i.length||a||!o&&!ph(t)?(!(kT&&i.length&&a)||Dy(t)&&i.some(function(e){return e.symbol===t.symbol})||e.pushIfUnique(i,nE),i):void 0}function ph(e){switch(e.kind){case 197:case 198:return!0;case 157:return 189===e.parent.kind;default:return!1}}function fh(t,r){if(l&&!(r&&Ph(r,16385)||156===t.kind||e.nodeIsMissing(t.body)||219!==t.body.kind||!_h(t))){var n=256&t.flags;if(r&&131072&r.flags)y(e.getEffectiveReturnTypeNode(t),e.Diagnostics.A_function_returning_never_cannot_have_a_reachable_end_point);else if(r&&!n)y(e.getEffectiveReturnTypeNode(t),e.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value);else if(r&&kT&&!Pl(nE,r))y(e.getEffectiveReturnTypeNode(t),e.Diagnostics.Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined);else if(xT.noImplicitReturns){if(!r){if(!n)return;var i=Mo(Co(t));if(bD(t,i))return}y(e.getEffectiveReturnTypeNode(t)||t,e.Diagnostics.Not_all_code_paths_return_a_value)}}}function mh(t,r){if(e.Debug.assert(157!==t.kind||e.isObjectLiteralMethod(t)),SS(t),r&&4&r&&xl(t)){if(!e.getEffectiveReturnTypeNode(t)&&Sl(t)){var n=O(t);if(n.contextFreeType)return n.contextFreeType;var i=oh(t,r),a=Wi(void 0,void 0,void 0,e.emptyArray,i,void 0,0,!1,!1),o=lr(t.symbol,hT,[a],e.emptyArray,void 0,void 0);return o.objectFlags|=524288,n.contextFreeType=o}return FE}var s=ak(t);s||197!==t.kind||hk(t);var c=O(t),u=Un(Wt(t.symbol));if(Qr(u))return u;if(!(1024&c.flags)){var l=Xm(t);if(!(1024&c.flags)){if(c.flags|=1024,l){var _=so(u,0)[0];if(xl(t)){var d=Bm(t);r&&2&r&&$y(_,l,d);var p=d?rl(l,d.mapper):l;eh(_,p)}if(!Lo(t)&&!_.resolvedReturnType){var i=oh(t,r);_.resolvedReturnType||(_.resolvedReturnType=i)}}Eb(t)}}return u}function gh(e,t){var r=Lo(e);return r&&2===(3&t)?ux(r)||tE:r}function vh(t){e.Debug.assert(157!==t.kind||e.isObjectLiteralMethod(t));var r=e.getFunctionFlags(t),n=gh(t,r);if(0===(1&r)&&fh(t,n),t.body)if(e.getEffectiveReturnTypeNode(t)||Mo(Co(t)),219===t.body.kind)yS(t.body);else{var i=yb(t.body);if(n)if(2===(3&r)){var a=cx(i,t.body,e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);Ll(a,n,t.body,t.body)}else Ll(i,n,t.body,t.body)}}function yh(e,t,r){return Pl(t,CE)?!0:(y(e,r),!1)}function hh(t){if(!e.isCallExpression(t))return!1;if(!e.isBindableObjectDefinePropertyCall(t))return!1;var r=eb(t.arguments[2]),n=Hr(r,"value");if(n){var i=ao(r,"writable"),a=i&&Un(i);if(!a||a===lE||a===_E)return!0;if(i&&i.valueDeclaration&&e.isPropertyAssignment(i.valueDeclaration)){var o=i.valueDeclaration.initializer,s=yb(o);if(s===lE||s===_E)return!0}return!1}var c=ao(r,"set");return!c}function bh(t){return!!(8&e.getCheckFlags(t)||4&t.flags&&64&e.getDeclarationModifierFlagsFromSymbol(t)||3&t.flags&&2&zg(t)||98304&t.flags&&!(65536&t.flags)||8&t.flags||e.some(t.declarations,hh))}function xh(t,r){if(bh(r)){if(4&r.flags&&(190===t.kind||191===t.kind)&&101===t.expression.kind){var n=e.getContainingFunction(t);return n&&158===n.kind?!r.valueDeclaration||!(n.parent===r.valueDeclaration.parent||n===r.valueDeclaration.parent):!0}return!0}return!1}function Dh(t){if(190===t.kind||191===t.kind){var r=e.skipParentheses(t.expression);if(73===r.kind){var n=O(r).resolvedSymbol;if(2097152&n.flags){var i=rt(n);return!!i&&252===i.kind}}}return!1}function Sh(t,r){var n=e.skipOuterExpressions(t,3);return 73!==n.kind&&190!==n.kind&&191!==n.kind?(y(t,r),!1):!0}function Ch(t){yb(t.expression);var r=e.skipParentheses(t.expression);if(190!==r.kind&&191!==r.kind)return y(r,e.Diagnostics.The_operand_of_a_delete_operator_must_be_a_property_reference),fE;var n=O(r),i=Zt(n.resolvedSymbol);return i&&bh(i)&&y(r,e.Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_read_only_property),fE}function kh(e){return yb(e.expression),lA}function Th(e){return yb(e.expression),iE}function Eh(t){if(l){if(!(16384&t.flags)){var r=e.getSourceFileOfNode(t);if(!Kk(r)){var n=e.getSpanOfTokenAtPosition(r,t.pos),i=e.createFileDiagnostic(r,n.start,n.length,e.Diagnostics.await_expression_is_only_allowed_within_an_async_function),a=e.getContainingFunction(t);if(a&&158!==a.kind){e.Debug.assert(0===(2&e.getFunctionFlags(a)),"Enclosing function should never be an async function.");var o=e.createDiagnosticForNode(a,e.Diagnostics.Did_you_mean_to_mark_this_function_as_async);e.addRelatedInfo(i,o)}tA.add(i)}}mm(t)&&y(t,e.Diagnostics.await_expressions_cannot_be_used_in_a_parameter_initializer)}var s=yb(t.expression);return cx(s,t,e.Diagnostics.Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member)}function Nh(t){var r=yb(t.operand);if(r===yE)return yE;switch(t.operand.kind){case 8:switch(t.operator){case 39:return Fu(Iu(-t.operand.text));case 38:return Fu(Iu(+t.operand.text))}break;case 9:if(39===t.operator)return Fu(Iu({negative:!0,base10Value:e.parsePseudoBigInt(t.operand.text)}))}switch(t.operator){case 38:case 39:case 53:return Gg(r,t.operand),Ph(r,12288)&&y(t.operand,e.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol,e.tokenToString(t.operator)),38===t.operator?(Ph(r,2112)&&y(t.operand,e.Diagnostics.Operator_0_cannot_be_applied_to_type_1,e.tokenToString(t.operator),Er(r)),cE):Fh(r);case 52:sD(t.operand);var n=12582912&wp(r);return 4194304===n?lE:8388608===n?dE:fE;case 44:case 45:var i=yh(t.operand,Gg(r,t.operand),e.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type);return i&&Sh(t.operand,e.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access),Fh(r)}return tE}function Ah(t){var r=yb(t.operand);if(r===yE)return yE;var n=yh(t.operand,Gg(r,t.operand),e.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type);return n&&Sh(t.operand,e.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access),Fh(r)}function Fh(e){return Ph(e,2112)?wh(e,3)||Ph(e,296)?CE:uE:cE}function Ph(e,t){if(e.flags&t&-131073||131072&t&&ka(e))return!0;if(3145728&e.flags)for(var r=e.types,n=0,i=r;n<i.length;n++){var a=i[n];if(Ph(a,t))return!0}return!1}function wh(e,t,r){return e.flags&t?!0:r&&114691&e.flags?!1:!!(296&t)&&Pl(e,cE)||!!(2112&t)&&Pl(e,uE)||!!(132&t)&&Pl(e,sE)||!!(528&t)&&Pl(e,fE)||!!(16384&t)&&Pl(e,gE)||!!(131072&t)&&Pl(e,vE)||!!(65536&t)&&Pl(e,aE)||!!(32768&t)&&Pl(e,nE)||!!(4096&t)&&Pl(e,mE)||!!(67108864&t)&&Pl(e,xE)}function Ih(t,r,n){return 1048576&t.flags?e.every(t.types,function(e){return Ih(e,r,n)}):wh(t,r,n)}function Oh(t){return!!(16&e.getObjectFlags(t))&&!!t.symbol&&Mh(t.symbol)}function Mh(e){return 0!==(128&e.flags)}function Lh(t,r,n,i){return n===yE||i===yE?yE:(!Qr(n)&&Ih(n,131068)&&y(t,e.Diagnostics.The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter),Qr(i)||nC(i)||Fl(i,zE)||y(r,e.Diagnostics.The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type),fE)}function Rh(t,r,n,i){return n===yE||i===yE?yE:(n=Gg(n,t),i=Gg(i,r),Il(n,sE)||wh(n,12584)||y(t,e.Diagnostics.The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol),Ih(i,126091264)||y(r,e.Diagnostics.The_right_hand_side_of_an_in_expression_must_be_of_type_any_an_object_type_or_a_type_parameter),fE)}function Bh(e,t,r){var n=e.properties;if(kT&&0===n.length)return Gg(t,e);for(var i=0;i<n.length;i++)jh(e,t,i,n,r);return t}function jh(t,r,n,i,a){void 0===a&&(a=!1);var o=t.properties,s=o[n];if(276===s.kind||277===s.kind){var c=s.name,u=Rc(c);if(Fi(u)){var l=Li(u),_=ao(r,l);_&&(pv(_,s,a),Ug(s,!1,r,_))}var d=ou(r,u,c),p=$r(s,d);return Vh(277===s.kind?s:s.initializer,p)}if(278===s.kind){if(!(n<o.length-1)){8>DT&&KC(s,4);var f=[];if(i)for(var m=0,g=i;m<g.length;m++){var v=g[m];e.isSpreadAssignment(v)||f.push(v.name)}var p=Zr(r,f,r.symbol);return ek(i,e.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma),Vh(s.expression,p)}y(s,e.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern)}else y(s,e.Diagnostics.Property_assignment_expected)}function Jh(e,t,r){var n=e.elements;2>DT&&xT.downlevelIteration&&KC(e,512);for(var i=pD(t,e,!1,!1)||tE,a=0;a<n.length;a++)zh(e,t,a,i,r);return t}function zh(t,r,n,i,a){var o=t.elements,s=o[n];if(211!==s.kind){if(209!==s.kind){var c=Iu(n);if(U_(r)){var u=ou(r,c,Kv(s,c)),l=$r(s,u);return Vh(s,l,a)}return Vh(s,i,a)}if(n<o.length-1)y(s,e.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);else{var _=s.expression;if(205!==_.kind||60!==_.operatorToken.kind){ek(t.elements,e.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);var l=sf(r,td)?lf(r,function(e){return _c(e,n)}):ic(i);return Vh(_,l,a)}y(_.operatorToken,e.Diagnostics.A_rest_element_cannot_have_an_initializer)}}return void 0}function Vh(e,t,r,n){var i;if(277===e.kind){var a=e;a.objectAssignmentInitializer&&(!kT||32768&sd(yb(a.objectAssignmentInitializer))||(t=Ip(t,524288)),Hh(a.name,a.equalsToken,a.objectAssignmentInitializer,r)),i=e.name}else i=e;return 205===i.kind&&60===i.operatorToken.kind&&(Wh(i,r),i=i.left),189===i.kind?Bh(i,t,n):188===i.kind?Jh(i,t,r):Uh(i,t,r)}function Uh(t,r,n){var i=yb(t,n),a=278===t.parent.kind?e.Diagnostics.The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access:e.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access;return Sh(t,a)&&Ll(r,i,t,t),r}function Kh(t){switch(t=e.skipParentheses(t),t.kind){case 73:case 10:case 13:case 194:case 207:case 14:case 8:case 9:case 103:case 88:case 97:case 142:case 197:case 210:case 198:case 188:case 189:case 200:case 214:case 262:case 261:return!0;case 206:return Kh(t.whenTrue)&&Kh(t.whenFalse);case 205:return e.isAssignmentOperator(t.operatorToken.kind)?!1:Kh(t.left)&&Kh(t.right);case 203:case 204:switch(t.operator){case 52:case 38:case 39:case 53:return!0}return!1;case 201:case 195:case 213:default:return!1}}function qh(e,t){return 0!==(98304&t.flags)||Il(e,t)}function Wh(t,r){return e.isInJSFile(t)&&e.getAssignedExpandoInitializer(t)?yb(t.right,r):Hh(t.left,t.operatorToken,t.right,r,t)}function Hh(t,r,n,i,a){function o(t,r){if(2===t)for(var n=0,i=Ea(r);n<i.length;n++){var a=i[n],o=Un(a);if(o.symbol&&32&o.symbol.flags){var s=a.escapedName,c=j(a.valueDeclaration,s,67897832,void 0,s,!1);if(c&&c.declarations.some(e.isJSDocTypedefTag))return Hk(c.declarations[0],e.Diagnostics.Duplicate_identifier_0,e.unescapeLeadingUnderscores(s)),Hk(a.valueDeclaration,e.Diagnostics.Duplicate_identifier_0,e.unescapeLeadingUnderscores(s))}}}function s(e){return 73===e.kind&&"eval"===e.escapedText}function c(r){var i=Ph(g,12288)?t:Ph(v,12288)?n:void 0;return i?(y(i,e.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol,e.tokenToString(r)),!1):!0}function u(e){switch(e){case 50:case 71:return 55;case 51:case 72:return 36;case 49:case 70:return 54;default:return void 0}}function _(r){l&&e.isAssignmentOperator(m)&&(!Sh(t,e.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access)||e.isIdentifier(t)&&"exports"===e.unescapeLeadingUnderscores(t.escapedText)||Ll(r,g,t,n))}function d(r){switch(r){case 2:return!0;case 1:case 5:case 6:case 3:case 4:var i=Ht(t),a=e.getAssignedExpandoInitializer(n);return a&&e.isObjectLiteralExpression(a)&&i&&e.hasEntries(i.exports);default:return!1}}function p(){var t=Nr(g,v),n=t[0],i=t[1],o=a||r;f(o,n,i)||y(o,e.Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2,e.tokenToString(r.kind),n,i)}function f(t,n,i){switch(r.kind){case 35:case 33:return y(t,e.Diagnostics.This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap,"false",n,i);case 36:case 34:return y(t,e.Diagnostics.This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap,"true",n,i)}return void 0}var m=r.kind;if(60===m&&(189===t.kind||188===t.kind))return Vh(t,yb(n,i),i,101===n.kind);var g;g=54===m||55===m?sD(t,i):yb(t,i);var v=yb(n,i);switch(m){case 40:case 41:case 63:case 64:case 42:case 65:case 43:case 66:case 39:case 62:case 46:case 67:case 47:case 68:case 48:case 69:case 50:case 71:case 51:case 72:case 49:case 70:if(g===yE||v===yE)return yE;g=Gg(g,t),v=Gg(v,n);var h=void 0;if(528&g.flags&&528&v.flags&&void 0!==(h=u(r.kind)))return y(a||r,e.Diagnostics.The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead,e.tokenToString(r.kind),e.tokenToString(h)),cE;var b,x=yh(t,g,e.Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type),D=yh(n,v,e.Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type);if(wh(g,3)&&wh(v,3)||!Ph(g,2112)&&!Ph(v,2112))b=cE;else if(wh(g,2112)&&wh(v,2112)){switch(m){case 48:case 69:p()}b=uE}else p(),b=tE;return x&&D&&_(b),b;case 38:case 61:if(g===yE||v===yE)return yE;wh(g,132)||wh(v,132)||(g=Gg(g,t),v=Gg(v,n));var S=void 0;return wh(g,296,!0)&&wh(v,296,!0)?S=cE:wh(g,2112,!0)&&wh(v,2112,!0)?S=uE:wh(g,132,!0)||wh(v,132,!0)?S=sE:(Qr(g)||Qr(v))&&(S=g===tE||v===tE?tE:ZT),S&&!c(m)?S:S?(61===m&&_(S),S):(p(),ZT);case 28:case 30:case 31:case 32:return c(m)&&(g=Y_(Gg(g,t)),v=Y_(Gg(v,n)),Il(g,v)||Il(v,g)||Pl(g,CE)&&Pl(v,CE)||p()),fE;case 33:case 34:case 35:case 36:return qh(g,v)||qh(v,g)||p(),fE;case 95:return Lh(t,n,g,v);case 94:return Rh(t,n,g,v);case 54:return 4194304&wp(g)?Dc([ud(kT?g:Y_(v)),v]):g;case 55:return 8388608&wp(g)?Dc([cd(g),v],2):g;case 60:var C=e.isBinaryExpression(t.parent)?e.getAssignmentDeclarationKind(t.parent):0;return o(C,v),d(C)?(524288&v.flags&&(2===C||6===C||a_(v)||Pp(v)||1&e.getObjectFlags(v))||_(v),g):(_(v),hd(v));case 27:return xT.allowUnreachableCode||!Kh(t)||s(n)||y(t,e.Diagnostics.Left_side_of_comma_operator_is_unused_and_has_no_side_effects),v;default:return e.Debug.fail()}}function Gh(t){for(var r=t,n=t.parent;n;){if(e.isFunctionLike(n)&&r===n.body)return!1;if(e.isClassLike(r))return!0;r=n,n=n.parent}return!1}function Qh(t){l&&(4096&t.flags&&!Gh(t)||qk(t,e.Diagnostics.A_yield_expression_is_only_allowed_in_a_generator_body),mm(t)&&y(t,e.Diagnostics.yield_expressions_cannot_be_used_in_a_parameter_initializer));var r=e.getContainingFunction(t);if(!r)return ZT;var n=e.getFunctionFlags(r);if(!(1&n))return ZT;t.asteriskToken&&(3===(3&n)&&8>DT&&KC(t,26624),1===(3&n)&&2>DT&&xT.downlevelIteration&&KC(t,256));var i=0!==(2&n),a=ch(t,i),o=Lo(r);if(o){var s=yD(o,i)||ZT;Ll(a,s,t.expression||t,t.expression)}return ZT}function Xh(e,t){sD(e.condition);var r=yb(e.whenTrue,t),n=yb(e.whenFalse,t);return Dc([r,n],2)}function Yh(t){return e.forEach(t.templateSpans,function(t){Ph(yb(t.expression),12288)&&y(t.expression,e.Diagnostics.Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String)}),sE}function Zh(t){return 269!==t.kind||e.isJsxSelfClosingElement(t.parent)?t:t.parent.parent}function $h(e,t,r,n){var i=Zh(e),a=i.contextualType,o=i.inferenceContext;i.contextualType=t,i.inferenceContext=r;var s=yb(e,1|n|(r?2:0)),c=Ph(s,2944)&&nb(s,Mm(t,e))?Pu(s):s;return i.contextualType=a,i.inferenceContext=o,c}function eb(e,t){var r=O(e);if(!r.resolvedType){if(t&&0!==t)return yb(e,t);var n=AN;AN=FN,r.resolvedType=yb(e,t),AN=n}return r.resolvedType}function tb(t){return t=e.skipParentheses(t),195===t.kind||213===t.kind}function rb(t){var r=e.getEffectiveInitializer(t),n=gb(r,!0),i=2&e.getCombinedNodeFlags(t)||e.isDeclarationReadonly(t)||tb(r)||nb(n,Rm(r))?n:Z_(n);if(e.isInJSFile(t)){if(98304&i.flags)return Ad(t,ZT),ZT;if(K_(i))return Ad(t,YE),YE}return i}function nb(t,r){if(r){if(3145728&r.flags){var n=r.types;return e.some(n,function(e){return nb(t,e)})}if(58982400&r.flags){var i=Ka(r)||rE;return Ph(i,4)&&Ph(t,128)||Ph(i,8)&&Ph(t,256)||Ph(i,64)&&Ph(t,2048)||Ph(i,4096)&&Ph(t,8192)||nb(t,i)}return!!(4194432&r.flags&&Ph(t,128)||256&r.flags&&Ph(t,256)||2048&r.flags&&Ph(t,2048)||512&r.flags&&Ph(t,512)||8192&r.flags&&Ph(t,8192))}return!1}function ib(t){var r=t.parent;return e.isAssertionExpression(r)&&e.isConstTypeReference(r.type)||(e.isParenthesizedExpression(r)||e.isArrayLiteralExpression(r)||e.isSpreadElement(r))&&ib(r)||(e.isPropertyAssignment(r)||e.isShorthandPropertyAssignment(r))&&ib(r.parent)}function ab(e,t,r,n){var i=yb(e,t,n);return ib(e)?Pu(i):tb(e)?i:ed(i,Mm(2===arguments.length?Rm(e):r,e))}function ob(e,t){return 150===e.name.kind&&ag(e.name),ab(e.initializer,t)}function sb(e,t){Fk(e),150===e.name.kind&&ag(e.name);var r=mh(e,t);return cb(e,r,t)}function cb(t,r,n){if(n&&10&n){var i=Iv(r,0,!0),a=Iv(r,1,!0),o=i||a;if(o&&o.typeParameters){var s=Om(t);if(s&&!Zn(s)){var c=Iv(fd(s),i?0:1,!1);if(c&&!c.typeParameters){if(8&n)return ub(t,n),FE;var u=Bm(t),l=u.signature&&Mo(u.signature),_=l&&wv(l);if(_&&!_.typeParameters&&!e.every(u.inferences,lb)){var d=pb(u,o.typeParameters),p=zo(o,d),f=e.map(u.inferences,function(e){return Bd(e.typeParameter)});if(Pd(p,c,function(e,t){tp(f,e,t,0,!0)}),e.some(f,lb)&&(wd(p,c,function(e,t){tp(f,e,t)}),!_b(u.inferences,f)))return db(u.inferences,f),u.inferredTypeParameters=e.concatenate(u.inferredTypeParameters,d),Qo(p)}return Qo(Ov(o,c,u))}}}}return r}function ub(e,t){if(2&t){var r=Bm(e);r.flags|=4}}function lb(e){return!(!e.candidates&&!e.contraCandidates)}function _b(e,t){for(var r=0;r<e.length;r++)if(lb(e[r])&&lb(t[r]))return!0;return!1}function db(e,t){for(var r=0;r<e.length;r++)!lb(e[r])&&lb(t[r])&&(e[r]=t[r])}function pb(t,r){for(var n,i,a=[],o=0,s=r;o<s.length;o++){var c=s[o],u=c.symbol.escapedName;if(fb(t.inferredTypeParameters,u)||fb(a,u)){var l=mb(e.concatenate(t.inferredTypeParameters,a),u),_=x(262144,l),d=or(_);d.target=c,n=e.append(n,c),i=e.append(i,d),a.push(d)}else a.push(c)}if(i)for(var p=Wu(n,i),f=0,m=i;f<m.length;f++){var c=m[f];c.mapper=p}return a}function fb(t,r){return e.some(t,function(e){return e.symbol.escapedName===r})}function mb(e,t){for(var r=t.length;r>1&&t.charCodeAt(r-1)>=48&&t.charCodeAt(r-1)<=57;)r--;for(var n=t.slice(0,r),i=1;!0;i++){var a=n+i;if(!fb(e,a))return a}}function gb(t,r){var n=e.skipParentheses(t);if(192!==n.kind||99===n.expression.kind||e.isRequireCall(n,!0)||Ay(n)){if(e.isAssertionExpression(n)&&!e.isConstTypeReference(n.type))return ju(n.type)}else{var i=Wg(n.expression),a=Pv(i);if(a&&!a.typeParameters)return Mo(a)}return r?eb(t):yb(t)}function vb(e){var t=O(e);if(t.contextFreeType)return t.contextFreeType;var r=e.contextualType;e.contextualType=ZT;var n=t.contextFreeType=yb(e,4);return e.contextualType=r,n}function yb(e,t,r){var n=uT;uT=e;var i=xb(e,t,r),a=cb(e,i,t);return Oh(a)&&hb(e,a),uT=n,a}function hb(t,r){var n=190===t.parent.kind&&t.parent.expression===t||191===t.parent.kind&&t.parent.expression===t||(73===t.kind||149===t.kind)&&US(t)||168===t.parent.kind&&t.parent.exprName===t;if(n||y(t,e.Diagnostics.const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query),xT.isolatedModules){e.Debug.assert(!!(128&r.symbol.flags));var i=r.symbol.valueDeclaration;4194304&i.flags&&y(t,e.Diagnostics.Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided)}}function bb(t,r){var n=e.isInJSFile(t)?e.getJSDocTypeTag(t):void 0;return n?Ly(n,n.typeExpression.type,t.expression,r):yb(t.expression,r)}function xb(t,r,n){switch(t.kind){case 73:return zf(t);case 101:return Zf(t);case 99:return nm(t);case 97:return oE;case 14:case 10:return Fu(Iu(t.text));case 8:return tT(t),Fu(Iu(+t.text));case 9:return rT(t),Fu(Bc(t));case 103:return dE;case 88:return lE;case 207:return Yh(t);case 13:return QE;case 188:return $m(t,r,n);case 189:return cg(t,r);case 190:return Xg(t);case 149:return Yg(t);case 191:return bv(t);case 192:if(93===t.expression.kind)return Fy(t);case 193:return Ny(t,r);case 194:return Iy(t);case 196:return bb(t,r);case 210:return OD(t);case 197:case 198:return mh(t,r);case 200:return kh(t);case 195:case 213:return Oy(t);case 214:return Ry(t);case 215:return By(t);case 199:return Ch(t);case 201:return Th(t);case 202:return Eh(t);case 203:return Nh(t);case 204:return Ah(t);case 205:return Wh(t,r);case 206:return Xh(t,r);case 209:return Ym(t,r);case 211:return iE;case 208:return Qh(t);case 216:return t.type;case 271:return Jg(t,r);case 261:return pg(t,r);case 262:return _g(t,r);case 265:return fg(t);case 269:return bg(t,r);case 263:e.Debug.fail("Shouldn't ever directly check a JsxOpeningElement")}return tE}function Db(t){t.expression&&qk(t.expression,e.Diagnostics.Type_expected),yS(t.constraint),yS(t.default);var r=yi(Ht(t));Ka(r),Ya(r)||y(t.default,e.Diagnostics.Type_parameter_0_has_a_circular_default,Er(r));var n=Ma(r),i=Xa(r);n&&i&&Ml(i,Vi(gl(n,Uu(r,i)),i),t.default,e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1),l&&ND(t.name,e.Diagnostics.Type_parameter_name_cannot_be_0)}function Sb(t){HC(t),Yx(t);var r=e.getContainingFunction(t);e.hasModifier(t,92)&&(158===r.kind&&e.nodeIsPresent(r.body)||y(t,e.Diagnostics.A_parameter_property_is_only_allowed_in_a_constructor_implementation)),t.questionToken&&e.isBindingPattern(t.name)&&r.body&&y(t,e.Diagnostics.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature),t.name&&e.isIdentifier(t.name)&&("this"===t.name.escapedText||"new"===t.name.escapedText)&&(0!==r.parameters.indexOf(t)&&y(t,e.Diagnostics.A_0_parameter_must_be_the_first_parameter,t.name.escapedText),(158===r.kind||162===r.kind||167===r.kind)&&y(t,e.Diagnostics.A_constructor_cannot_have_a_this_parameter),198===r.kind&&y(t,e.Diagnostics.An_arrow_function_cannot_have_a_this_parameter)),!t.dotDotDotToken||e.isBindingPattern(t.name)||Pl(Un(t.symbol),$E)||y(t,e.Diagnostics.A_rest_parameter_must_be_of_an_array_type)}function Cb(t){var r=kb(t);if(!r)return void y(t,e.Diagnostics.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);var n=Co(r),i=Io(n);if(i){yS(t.type);var a=t.parameterName;if(e.isThisTypePredicate(i))Bu(a);else if(i.parameterIndex>=0)if(n.hasRestParameter&&i.parameterIndex===n.parameters.length-1)y(a,e.Diagnostics.A_type_predicate_cannot_reference_a_rest_parameter);else{var o=function(){return e.chainDiagnosticMessages(void 0,e.Diagnostics.A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type)};Ml(i.type,Un(n.parameters[i.parameterIndex]),t.type,void 0,o)}else if(a){for(var s=!1,c=0,u=r.parameters;c<u.length;c++){var l=u[c].name;if(e.isBindingPattern(l)&&Tb(l,a,i.parameterName)){s=!0;break}}s||y(t.parameterName,e.Diagnostics.Cannot_find_parameter_0,i.parameterName)}}}function kb(e){switch(e.parent.kind){case 198:case 161:case 240:case 197:case 166:case 157:case 156:var t=e.parent;if(e===t.type)return t}}function Tb(t,r,n){for(var i=0,a=t.elements;i<a.length;i++){var o=a[i];if(!e.isOmittedExpression(o)){var s=o.name;if(73===s.kind&&s.escapedText===n)return y(r,e.Diagnostics.A_type_predicate_cannot_reference_element_0_in_a_binding_pattern,n),!0;if((186===s.kind||185===s.kind)&&Tb(s,r,n))return!0}}}function Eb(t){163===t.kind?uk(t):(166===t.kind||240===t.kind||167===t.kind||161===t.kind||158===t.kind||162===t.kind)&&ak(t);var r=e.getFunctionFlags(t);if(4&r||(3===(3&r)&&8>DT&&KC(t,6144),2===(3&r)&&4>DT&&KC(t,64),0!==(3&r)&&2>DT&&KC(t,128)),FD(t.typeParameters),e.forEach(t.parameters,Sb),t.type&&yS(t.type),l){Ux(t);var n=e.getEffectiveReturnTypeNode(t);if(AT&&!n)switch(t.kind){case 162:y(t,e.Diagnostics.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);break;case 161:y(t,e.Diagnostics.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type)}if(n){var i=e.getFunctionFlags(t);if(1===(5&i)){var a=ju(n);if(a===gE)y(n,e.Diagnostics.A_generator_cannot_have_a_void_type_annotation);else{var o=yD(a,0!==(2&i))||ZT,s=2&i?tc(o):nc(o);Ml(s,a,n)}}else 2===(3&i)&&lx(t,n)}163!==t.kind&&295!==t.kind&&Nx(t)}}function Nb(t){function r(t,r,n,i){var a=t.get(n);a?4&a?4!==i&&y(r,e.Diagnostics.Duplicate_identifier_0,e.getTextOfNode(r)):a&i?y(r,e.Diagnostics.Duplicate_identifier_0,e.getTextOfNode(r)):t.set(n,a|i):t.set(n,i)}var n;!function(e){e[e.Getter=1]="Getter",e[e.Setter=2]="Setter",e[e.Method=4]="Method",e[e.Property=3]="Property"}(n||(n={}));for(var i=e.createUnderscoreEscapedMap(),a=e.createUnderscoreEscapedMap(),o=0,s=t.members;o<s.length;o++){var c=s[o];if(158===c.kind)for(var u=0,l=c.parameters;u<l.length;u++){var _=l[u];e.isParameterPropertyDeclaration(_)&&!e.isBindingPattern(_.name)&&r(i,_.name,_.name.escapedText,3)}else{var d=e.hasModifier(c,32),p=d?a:i,f=c.name,m=f&&e.getPropertyNameForPropertyNameNode(f);if(f&&m)switch(c.kind){case 159:r(p,f,m,1);break;case 160:r(p,f,m,2);break;case 155:r(p,f,m,3);break;case 157:r(p,f,m,4)}}}}function Ab(t){for(var r=0,n=t.members;r<n.length;r++){var i=n[r],a=i.name,o=e.hasModifier(i,32);if(o&&a){var s=e.getPropertyNameForPropertyNameNode(a);switch(s){case"name":case"length":case"caller":case"arguments":case"prototype":var c=e.Diagnostics.Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1,u=Br(Ht(t));y(a,c,s,u)}}}}function Fb(t){for(var r=e.createMap(),n=0,i=t.members;n<i.length;n++){var a=i[n];if(154===a.kind){var o=void 0,s=a.name;switch(s.kind){case 10:case 8:o=s.text;break;case 73:o=e.idText(s);break;default:continue}r.get(o)?(y(e.getNameOfDeclaration(a.symbol.valueDeclaration),e.Diagnostics.Duplicate_identifier_0,o),y(a.name,e.Diagnostics.Duplicate_identifier_0,o)):r.set(o,!0)}}}function Pb(t){if(242===t.kind){var r=Ht(t);if(r.declarations.length>0&&r.declarations[0]!==t)return}var n=Xo(Ht(t));if(n)for(var i=!1,a=!1,o=0,s=n.declarations;o<s.length;o++){var c=s[o],u=c;if(1===u.parameters.length&&u.parameters[0].type)switch(u.parameters[0].type.kind){case 139:a?y(u,e.Diagnostics.Duplicate_string_index_signature):a=!0;break;case 136:i?y(u,e.Diagnostics.Duplicate_number_index_signature):i=!0}}}function wb(e){HC(e)||Xk(e)||yk(e.name),Yx(e)}function Ib(t){Fk(t)||yk(t.name),Ex(t),e.hasModifier(t,128)&&157===t.kind&&t.body&&y(t,e.Diagnostics.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract,e.declarationNameToString(t.name))}function Ob(t){function r(t){return 155===t.kind&&!e.hasModifier(t,32)&&!!t.initializer}Eb(t),Gk(t)||Qk(t),yS(t.body);var n=Ht(t),i=e.getDeclarationOfKind(n,t.kind);if(t===i&&ix(n),!e.nodeIsMissing(t.body)&&l){var a=t.parent;if(e.getClassExtendsHeritageElement(a)){Hf(t.parent,a);var o=Xf(a),s=Qf(t);if(s){o&&y(s,e.Diagnostics.A_constructor_cannot_contain_a_super_call_when_its_class_extends_null);var c=e.some(t.parent.members,r)||e.some(t.parameters,function(t){return e.hasModifier(t,92)});if(c){for(var u=t.body.statements,_=void 0,d=0,p=u;d<p.length;d++){var f=p[d];if(222===f.kind&&e.isSuperCall(f.expression)){_=f;break}if(!e.isPrologueDirective(f))break}_||y(t,e.Diagnostics.A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_properties_or_has_parameter_properties)}}else o||y(t,e.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call)}}}function Mb(t){if(l){if(ak(t)||kk(t)||yk(t.name),yx(t),Eb(t),159===t.kind&&!(4194304&t.flags)&&e.nodeIsPresent(t.body)&&128&t.flags&&(256&t.flags||y(t.name,e.Diagnostics.A_get_accessor_must_return_a_value)),150===t.name.kind&&ag(t.name),!Oi(t)){var r=159===t.kind?160:159,n=e.getDeclarationOfKind(Ht(t),r);if(n){var i=e.getModifierFlags(t),a=e.getModifierFlags(n);(28&i)!==(28&a)&&y(t.name,e.Diagnostics.Getter_and_setter_accessors_do_not_agree_in_visibility),(128&i)!==(128&a)&&y(t.name,e.Diagnostics.Accessors_must_both_be_abstract_or_non_abstract),Lb(t,n,Fn,e.Diagnostics.get_and_set_accessor_must_have_the_same_type),Lb(t,n,wn,e.Diagnostics.get_and_set_accessor_must_have_the_same_this_type)}}var o=In(Ht(t));159===t.kind&&fh(t,o)}yS(t.body)}function Lb(e,t,r,n){var i=r(e),a=r(t);i&&a&&!Tl(i,a)&&y(e,n)}function Rb(e){yx(e)}function Bb(t,r){return So(e.map(t.typeArguments,ju),r,Do(r),e.isInJSFile(t))}function jb(t,r){for(var n,i,a=!0,o=0;o<r.length;o++){var s=Ma(r[o]);s&&(n||(n=Bb(t,r),i=Wu(r,n)),a=a&&Ml(n[o],gl(s,i),t.typeArguments[o],e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1))}return a}function Jb(t){var r=ks(t);if(r!==tE){var n=O(t).resolvedSymbol;if(n)return 524288&n.flags&&I(n).typeParameters||(4&e.getObjectFlags(r)?r.target.localTypeParameters:void 0)}return void 0}function zb(t){_k(t,t.typeArguments),165!==t.kind||void 0===t.typeName.jsdocDotPos||e.isInJSFile(t)||e.isInJSDoc(t)||Wk(t,t.typeName.jsdocDotPos,1,e.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments);var r=ks(t);if(r!==tE){if(t.typeArguments&&(e.forEach(t.typeArguments,yS),l)){var n=Jb(t);n&&jb(t,n)}32&r.flags&&8&O(t).resolvedSymbol.flags&&y(t,e.Diagnostics.Enum_type_0_has_members_with_initializers_that_are_not_literals,Er(r))}}function Vb(t){var r=e.tryCast(t.parent,e.isTypeReferenceType);if(!r)return void 0;var n=Jb(r),i=Ma(n[r.typeArguments.indexOf(t)]);return i&&gl(i,Wu(n,Bb(r,n)))}function Ub(e){Es(e)}function Kb(t){if(e.forEach(t.members,yS),l){var r=xu(t);ED(r),Pb(t),Fb(t)}}function qb(e){yS(e.elementType)}function Wb(t){for(var r=t.elementTypes,n=!1,i=0;i<r.length;i++){var a=r[i];if(173===a.kind){if(i!==r.length-1){Hk(a,e.Diagnostics.A_rest_element_must_be_last_in_a_tuple_type);break}J_(ju(a))||y(a,e.Diagnostics.A_rest_element_type_must_be_an_array_type)}else if(172===a.kind)n=!0;else if(n){Hk(a,e.Diagnostics.A_required_element_cannot_follow_an_optional_element);break}}e.forEach(t.elementTypes,yS)}function Hb(t){e.forEach(t.types,yS)}function Gb(t,r){if(!(8388608&t.flags))return t;var n=t.objectType,i=t.indexType;return Pl(i,Vc(n,!1))?(191===r.kind&&e.isAssignmentTarget(r)&&32&e.getObjectFlags(n)&&1&xa(n)&&y(r,e.Diagnostics.Index_signature_in_type_0_only_permits_reading,Er(n)),t):lo(to(n),1)&&wh(i,296)?t:(y(r,e.Diagnostics.Type_0_cannot_be_used_to_index_type_1,Er(i),Er(n)),tE)}function Qb(e){yS(e.objectType),yS(e.indexType),Gb(cu(e),e)}function Xb(t){yS(t.typeParameter),yS(t.type),t.type||Ad(t,ZT);var r=uu(t),n=ga(r);Ml(n,SE,e.getEffectiveConstraintOfTypeParameter(t.typeParameter))}function Yb(e){Bu(e)}function Zb(e){Nk(e),yS(e.type)}function $b(t){e.forEachChild(t,yS)}function ex(t){e.findAncestor(t,function(e){return e.parent&&176===e.parent.kind&&e.parent.extendsType===e})||Hk(t,e.Diagnostics.infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type),yS(t.typeParameter),Nx(t)
}function tx(e){yS(e.argument),ju(e)}function rx(t){return e.hasModifier(t,8)&&!!(4194304&t.flags)}function nx(t,r){var n=e.getCombinedModifierFlags(t);return 242!==t.parent.kind&&241!==t.parent.kind&&210!==t.parent.kind&&4194304&t.flags&&(2&n||e.isModuleBlock(t.parent)&&e.isModuleDeclaration(t.parent.parent)&&e.isGlobalScopeAugmentation(t.parent.parent)||(n|=1),n|=2),n&r}function ix(t){function r(e,t){var r=void 0!==t&&t.parent===e[0].parent;return r?t:e[0]}function n(t,n,i,a,o){var s=a^o;if(0!==s){var c=nx(r(t,n),i);e.forEach(t,function(t){var r=nx(t,i)^c;1&r?y(e.getNameOfDeclaration(t),e.Diagnostics.Overload_signatures_must_all_be_exported_or_non_exported):2&r?y(e.getNameOfDeclaration(t),e.Diagnostics.Overload_signatures_must_all_be_ambient_or_non_ambient):24&r?y(e.getNameOfDeclaration(t)||t,e.Diagnostics.Overload_signatures_must_all_be_public_private_or_protected):128&r&&y(e.getNameOfDeclaration(t),e.Diagnostics.Overload_signatures_must_all_be_abstract_or_non_abstract)})}}function i(t,n,i,a){if(i!==a){var o=e.hasQuestionToken(r(t,n));e.forEach(t,function(t){var r=e.hasQuestionToken(t)!==o;r&&y(e.getNameOfDeclaration(t),e.Diagnostics.Overload_signatures_must_all_be_optional_or_required)})}}function a(t){if(!t.name||!e.nodeIsMissing(t.name)){var r=!1,n=e.forEachChild(t.parent,function(e){return r?e:void(r=e===t)});if(n&&n.pos===t.end&&n.kind===t.kind){var i=n.name||n,a=n.name;if(t.name&&a&&(e.isComputedPropertyName(t.name)&&e.isComputedPropertyName(a)||!e.isComputedPropertyName(t.name)&&!e.isComputedPropertyName(a)&&e.getEscapedTextOfIdentifierOrLiteral(t.name)===e.getEscapedTextOfIdentifierOrLiteral(a))){var o=(157===t.kind||156===t.kind)&&e.hasModifier(t,32)!==e.hasModifier(n,32);if(o){var s=e.hasModifier(t,32)?e.Diagnostics.Function_overload_must_be_static:e.Diagnostics.Function_overload_must_not_be_static;y(i,s)}return}if(e.nodeIsPresent(n.body))return void y(i,e.Diagnostics.Function_implementation_name_must_be_0,e.declarationNameToString(t.name))}var c=t.name||t;v?y(c,e.Diagnostics.Constructor_implementation_is_missing):e.hasModifier(t,128)?y(c,e.Diagnostics.All_declarations_of_an_abstract_method_must_be_consecutive):y(c,e.Diagnostics.Function_implementation_is_missing_or_not_immediately_following_the_declaration)}}if(l){for(var o,s,c,u=155,_=0,d=u,p=!1,f=!0,m=!1,g=t.declarations,v=0!==(16384&t.flags),h=!1,b=!1,x=0,D=g;x<D.length;x++){var S=D[x],C=S,k=4194304&C.flags,T=242===C.parent.kind||169===C.parent.kind||k;if(T&&(c=void 0),240===C.kind||157===C.kind||156===C.kind||158===C.kind){var E=nx(C,u);_|=E,d&=E,p=p||e.hasQuestionToken(C),f=f&&e.hasQuestionToken(C),e.nodeIsPresent(C.body)&&o?v?b=!0:h=!0:c&&c.parent===C.parent&&c.end!==C.pos&&a(c),e.nodeIsPresent(C.body)?o||(o=C):m=!0,c=C,T||(s=C)}}if(b&&e.forEach(g,function(t){y(t,e.Diagnostics.Multiple_constructor_implementations_are_not_allowed)}),h&&e.forEach(g,function(t){y(e.getNameOfDeclaration(t),e.Diagnostics.Duplicate_function_implementation)}),!s||s.body||e.hasModifier(s,128)||s.questionToken||a(s),m&&(n(g,o,u,_,d),i(g,o,p,f),o))for(var N=Ao(t),A=Co(o),F=0,P=N;F<P.length;F++){var w=P[F];if(!n_(A,w)){e.addRelatedInfo(y(w.declaration,e.Diagnostics.This_overload_signature_is_not_compatible_with_its_implementation_signature),e.createDiagnosticForNode(o,e.Diagnostics.The_implementation_signature_is_declared_here));break}}}}function ax(t){function r(t){var n=t;switch(n.kind){case 242:case 243:case 310:case 303:return 2;case 245:return e.isAmbientModule(n)||0!==e.getModuleInstanceState(n)?5:4;case 241:case 244:return 3;case 285:return 7;case 255:if(!e.isEntityNameExpression(n.expression))return 1;n=n.expression;case 249:case 252:case 251:var i=0,a=bt(Ht(n));return e.forEach(a.declarations,function(e){i|=r(e)}),i;case 238:case 187:case 240:case 254:return 1;default:return e.Debug.failBadSyntaxKind(n)}}if(l){var n=t.localSymbol;if((n||(n=Ht(t),n.exportSymbol))&&e.getDeclarationOfKind(n,t.kind)===t){for(var i=0,a=0,o=0,s=0,c=n.declarations;s<c.length;s++){var u=c[s],_=r(u),d=nx(u,513);1&d?512&d?o|=_:i|=_:a|=_}var p=i|a,f=i&a,m=o&p;if(f||m)for(var g=0,v=n.declarations;g<v.length;g++){var u=v[g],_=r(u),h=e.getNameOfDeclaration(u);_&m?y(h,e.Diagnostics.Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead,e.declarationNameToString(h)):_&f&&y(h,e.Diagnostics.Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local,e.declarationNameToString(h))}}}}function ox(e,t,r){var n=sx(e,t);return n&&ux(n,t,r)}function sx(t,r){if(Qr(t))return void 0;var n=t;if(n.promisedTypeOfPromise)return n.promisedTypeOfPromise;if(Kn(t,Bs(!1)))return n.promisedTypeOfPromise=t.typeArguments[0];var i=Hr(t,"then");if(Qr(i))return void 0;var a=i?so(i,0):e.emptyArray;if(0===a.length)return void(r&&y(r,e.Diagnostics.A_promise_must_have_a_then_method));var o=Ip(Dc(e.map(a,Yy)),2097152);if(Qr(o))return void 0;var s=so(o,0);return 0===s.length?void(r&&y(r,e.Diagnostics.The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback)):n.promisedTypeOfPromise=Dc(e.map(s,Yy),2)}function cx(e,t,r){return ux(e,t,r)||tE}function ux(t,r,n){var i=t;if(i.awaitedTypeOfType)return i.awaitedTypeOfType;if(Qr(t))return i.awaitedTypeOfType=t;if(1048576&t.flags){for(var a=void 0,o=0,s=t.types;o<s.length;o++){var c=s[o];a=e.append(a,ux(c,r,n))}return a?i.awaitedTypeOfType=Dc(a):void 0}var u=sx(t);if(u){if(t.id===u.id||eA.indexOf(u.id)>=0)return void(r&&y(r,e.Diagnostics.Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method));eA.push(t.id);var l=ux(u,r,n);return eA.pop(),l?i.awaitedTypeOfType=l:void 0}var _=Hr(t,"then");if(_&&so(_,0).length>0){if(r){if(!n)return e.Debug.fail();y(r,n)}return void 0}return i.awaitedTypeOfType=t}function lx(t,r){var n=ju(r);if(DT>=2){if(n===tE)return;var i=Bs(!0);if(i!==AE&&!Kn(n,i))return void y(r,e.Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type)}else{if(dx(r),n===tE)return;var a=e.getEntityNameFromTypeNode(r);if(void 0===a)return void y(r,e.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value,Er(n));var o=kt(a,67220415,!0),s=o?Un(o):tE;if(s===tE)return void(73===a.kind&&"Promise"===a.escapedText&&qn(n)===Bs(!1)?y(r,e.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option):y(r,e.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value,e.entityNameToString(a)));var c=zs(!0);if(c===kE)return void y(r,e.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value,e.entityNameToString(a));if(!Ml(s,c,r,e.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value))return;var u=a&&iS(a),l=L(t.locals,u.escapedText,67220415);if(l)return void y(l.valueDeclaration,e.Diagnostics.Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions,e.idText(u),e.entityNameToString(a))}cx(n,t,e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member)}function _x(t){var r=xy(t),n=Mo(r);if(!(1&n.flags)){var i,a,o=my(t);switch(t.parent.kind){case 241:var s=Ht(t.parent),c=Un(s);i=Dc([c,gE]);break;case 152:i=gE,a=e.chainDiagnosticMessages(void 0,e.Diagnostics.The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any);break;case 155:i=gE,a=e.chainDiagnosticMessages(void 0,e.Diagnostics.The_return_type_of_a_property_decorator_function_must_be_either_void_or_any);break;case 157:case 159:case 160:var u=XS(t.parent),l=$s(u);i=Dc([l,gE]);break;default:return e.Debug.fail()}Ml(n,i,t,o,function(){return a})}}function dx(t){px(t&&e.getEntityNameFromTypeNode(t))}function px(e){if(e){var t=iS(e),r=2097152|(73===e.kind?67897832:1920),n=j(t,t.escapedText,r,void 0,void 0,!0);n&&2097152&n.flags&&$t(n)&&!hC(bt(n))&&Dt(n)}}function fx(t){var r=mx(t);r&&e.isEntityName(r)&&px(r)}function mx(e){if(e)switch(e.kind){case 175:case 174:return gx(e.types);case 176:return gx([e.trueType,e.falseType]);case 178:return mx(e.type);case 165:return e.typeName}}function gx(t){for(var r,n=0,i=t;n<i.length;n++){for(var a=i[n];178===a.kind;)a=a.type;if(133!==a.kind&&(kT||97!==a.kind&&142!==a.kind)){var o=mx(a);if(!o)return void 0;if(r){if(!e.isIdentifier(r)||!e.isIdentifier(o)||r.escapedText!==o.escapedText)return void 0}else r=o}}return r}function vx(t){var r=e.getEffectiveTypeAnnotationNode(t);return e.isRestParameter(t)?e.getRestParameterElementType(r):r}function yx(t){if(t.decorators&&e.nodeCanBeDecorated(t,t.parent,t.parent.parent)){xT.experimentalDecorators||y(t,e.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning);var r=t.decorators[0];if(KC(r,8),152===t.kind&&KC(r,32),xT.emitDecoratorMetadata)switch(KC(r,16),t.kind){case 241:var n=e.getFirstConstructorWithBody(t);if(n)for(var i=0,a=n.parameters;i<a.length;i++){var o=a[i];fx(vx(o))}break;case 159:case 160:var s=159===t.kind?160:159,c=e.getDeclarationOfKind(Ht(t),s);fx(An(t)||c&&An(c));break;case 157:for(var u=0,l=t.parameters;u<l.length;u++){var o=l[u];fx(vx(o))}fx(e.getEffectiveReturnTypeNode(t));break;case 155:fx(e.getEffectiveTypeAnnotationNode(t));break;case 152:fx(vx(t));for(var _=t.parent,d=0,p=_.parameters;d<p.length;d++){var o=p[d];fx(vx(o))}}e.forEach(t.decorators,_x)}}function hx(e){l&&(Ex(e),hk(e),Hx(e,e.name),Gx(e,e.name))}function bx(t){t.typeExpression||y(t.name,e.Diagnostics.JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags),t.name&&ND(t.name,e.Diagnostics.Type_alias_name_cannot_be_0),yS(t.typeExpression)}function xx(e){yS(e.constraint);for(var t=0,r=e.typeParameters;t<r.length;t++){var n=r[t];yS(n)}}function Dx(e){yS(e.typeExpression)}function Sx(t){if(yS(t.typeExpression),!e.getParameterSymbolFromJSDoc(t)){var r=e.getHostSignatureFromJSDoc(t);if(r){var n=e.getJSDocTags(r).filter(e.isJSDocParameterTag).indexOf(t);if(n>-1&&n<r.parameters.length&&e.isBindingPattern(r.parameters[n].name))return;No(r)?e.findLast(e.getJSDocTags(r),e.isJSDocParameterTag)===t&&t.typeExpression&&t.typeExpression.type&&!J_(ju(t.typeExpression.type))&&y(t.name,e.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type,e.idText(149===t.name.kind?t.name.right:t.name)):e.isQualifiedName(t.name)?y(t.name,e.Diagnostics.Qualified_name_0_is_not_allowed_without_a_leading_param_object_1,e.entityNameToString(t.name),e.entityNameToString(t.name.left)):y(t.name,e.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name,e.idText(t.name))}}}function Cx(t){!l||t.type||e.isJSDocConstructSignature(t)||Ad(t,ZT),Eb(t)}function kx(t){var r=e.getJSDocHost(t);if(!e.isClassDeclaration(r)&&!e.isClassExpression(r))return void y(r,e.Diagnostics.JSDoc_0_is_not_attached_to_a_class,e.idText(t.tagName));var n=e.getJSDocTags(r).filter(e.isJSDocAugmentsTag);e.Debug.assert(n.length>0),n.length>1&&y(n[1],e.Diagnostics.Class_declarations_cannot_have_more_than_one_augments_or_extends_tag);var i=Tx(t.class.expression),a=e.getClassExtendsHeritageElement(r);if(a){var o=Tx(a.expression);o&&i.escapedText!==o.escapedText&&y(i,e.Diagnostics.JSDoc_0_1_does_not_match_the_extends_2_clause,e.idText(t.tagName),e.idText(i),e.idText(o))}}function Tx(e){switch(e.kind){case 73:return e;case 190:return e.name;default:return void 0}}function Ex(t){yx(t),Eb(t);var r=e.getFunctionFlags(t);if(t.name&&150===t.name.kind&&ag(t.name),!Oi(t)){var n=Ht(t),i=t.localSymbol||n,a=e.find(i.declarations,function(e){return e.kind===t.kind&&!(65536&e.flags)});t===a&&ix(i),n.parent&&e.getDeclarationOfKind(n,t.kind)===t&&ix(n)}var o=156===t.kind?void 0:t.body;if(yS(o),0===(1&r)){var s=gh(t,r);fh(t,s)}if(l&&!e.getEffectiveReturnTypeNode(t)&&(e.nodeIsMissing(o)&&!rx(t)&&Ad(t,ZT),1&r&&e.nodeIsPresent(o)&&Mo(Co(t))),e.isInJSFile(t)){var c=e.getJSDocTypeTag(t);c&&c.typeExpression&&!Wm(ju(c.typeExpression),t)&&y(c,e.Diagnostics.The_type_of_a_function_declaration_must_match_the_function_s_signature)}}function Nx(t){if(l&&!(4194304&t.flags)){var r=e.getSourceFileOfNode(t),n=NN.get(r.path);n||(n=[],NN.set(r.path,n)),n.push(t)}}function Ax(t,r){for(var n=0,i=t;n<i.length;n++){var a=i[n];switch(a.kind){case 241:case 210:wx(a,r),Ox(a,r);break;case 285:case 245:case 219:case 247:case 226:case 227:case 228:Bx(a,r);break;case 158:case 197:case 240:case 198:case 157:case 159:case 160:a.body&&Bx(a,r),Ox(a,r);break;case 156:case 161:case 162:case 166:case 167:case 243:case 242:Ox(a,r);break;case 177:Ix(a,r);break;default:e.Debug.assertNever(a,"Node should not have been registered for unused identifiers check")}}}function Fx(t,r,n){var i=e.getNameOfDeclaration(t)||t,a=LS(t)?e.Diagnostics._0_is_declared_but_never_used:e.Diagnostics._0_is_declared_but_its_value_is_never_read;n(t,0,e.createDiagnosticForNode(i,a,r))}function Px(t){return e.isIdentifier(t)&&95===e.idText(t).charCodeAt(0)}function wx(t,r){for(var n=0,i=t.members;n<i.length;n++){var a=i[n];switch(a.kind){case 157:case 155:case 159:case 160:if(160===a.kind&&32768&a.symbol.flags)break;var o=Ht(a);!o.isReferenced&&e.hasModifier(a,8)&&r(a,0,e.createDiagnosticForNode(a.name,e.Diagnostics._0_is_declared_but_its_value_is_never_read,kr(o)));break;case 158:for(var s=0,c=a.parameters;s<c.length;s++){var u=c[s];!u.symbol.isReferenced&&e.hasModifier(u,8)&&r(u,0,e.createDiagnosticForNode(u.name,e.Diagnostics.Property_0_is_declared_but_its_value_is_never_read,e.symbolName(u.symbol)))}break;case 163:case 218:break;default:e.Debug.fail()}}}function Ix(t,r){var n=t.typeParameter;Mx(n)&&r(t,1,e.createDiagnosticForNode(t,e.Diagnostics._0_is_declared_but_its_value_is_never_read,e.idText(n.name)))}function Ox(t,r){if(e.last(Ht(t).declarations)===t)for(var n=e.getEffectiveTypeParameterDeclarations(t),i=new e.NodeSet,a=0,o=n;a<o.length;a++){var s=o[a];if(Mx(s)){var c=e.idText(s.name),u=s.parent;if(177!==u.kind&&u.typeParameters.every(Mx)){if(i.tryAdd(u)){var l=e.isJSDocTemplateTag(u)?e.rangeOfNode(u):e.rangeOfTypeParameters(u.typeParameters),_=1===n.length,d=_?e.Diagnostics._0_is_declared_but_its_value_is_never_read:e.Diagnostics.All_type_parameters_are_unused,p=_?c:void 0;r(s,1,e.createFileDiagnostic(e.getSourceFileOfNode(u),l.pos,l.end-l.pos,d,p))}}else r(s,1,e.createDiagnosticForNode(s,e.Diagnostics._0_is_declared_but_its_value_is_never_read,c))}}}function Mx(e){return!(262144&Wt(e.symbol).isReferenced||Px(e.name))}function Lx(e,t,r,n){var i=String(n(t)),a=e.get(i);a?a[1].push(r):e.set(i,[t,[r]])}function Rx(t){return e.tryCast(e.getRootDeclaration(t),e.isParameter)}function Bx(r,n){if(!(4194304&r.flags)){var i=e.createMap(),a=e.createMap(),o=e.createMap();r.locals.forEach(function(r){if(262144&r.flags?3&r.flags&&!(3&r.isReferenced):!r.isReferenced&&!r.exportSymbol)for(var s=0,c=r.declarations;s<c.length;s++){var u=c[s];if(!(e.isAmbientModule(u)||(e.isVariableDeclaration(u)&&e.isForInOrOfStatement(u.parent.parent)||Jx(u))&&Px(u.name)))if(Jx(u))Lx(i,zx(u),u,t);else if(e.isBindingElement(u)&&e.isObjectBindingPattern(u.parent)){var l=e.last(u.parent.elements);u!==l&&e.last(u.parent.elements).dotDotDotToken||Lx(a,u.parent,u,t)}else if(e.isVariableDeclaration(u))Lx(o,u.parent,u,t);else{var _=r.valueDeclaration&&Rx(r.valueDeclaration),d=r.valueDeclaration&&e.getNameOfDeclaration(r.valueDeclaration);_&&d?e.isParameterPropertyDeclaration(_)||e.parameterIsThisKeyword(_)||Px(d)||n(_,1,e.createDiagnosticForNode(d,e.Diagnostics._0_is_declared_but_its_value_is_never_read,e.symbolName(r))):Fx(u,e.symbolName(r),n)}}}),i.forEach(function(t){var r=t[0],i=t[1],a=r.parent,o=(r.name?1:0)+(r.namedBindings?252===r.namedBindings.kind?1:r.namedBindings.elements.length:0);if(o===i.length)n(a,0,1===i.length?e.createDiagnosticForNode(a,e.Diagnostics._0_is_declared_but_its_value_is_never_read,e.idText(e.first(i).name)):e.createDiagnosticForNode(a,e.Diagnostics.All_imports_in_import_declaration_are_unused));else for(var s=0,c=i;s<c.length;s++){var u=c[s];Fx(u,e.idText(u.name),n)}}),a.forEach(function(r){var i=r[0],a=r[1],s=Rx(i.parent)?1:0;if(i.elements.length===a.length)1===a.length&&238===i.parent.kind&&239===i.parent.parent.kind?Lx(o,i.parent.parent,i.parent,t):n(i,s,1===a.length?e.createDiagnosticForNode(i,e.Diagnostics._0_is_declared_but_its_value_is_never_read,jx(e.first(a).name)):e.createDiagnosticForNode(i,e.Diagnostics.All_destructured_elements_are_unused));else for(var c=0,u=a;c<u.length;c++){var l=u[c];n(l,s,e.createDiagnosticForNode(l,e.Diagnostics._0_is_declared_but_its_value_is_never_read,jx(l.name)))}}),o.forEach(function(t){var r=t[0],i=t[1];if(r.declarations.length===i.length)n(r,0,1===i.length?e.createDiagnosticForNode(e.first(i).name,e.Diagnostics._0_is_declared_but_its_value_is_never_read,jx(e.first(i).name)):e.createDiagnosticForNode(220===r.parent.kind?r.parent:r,e.Diagnostics.All_variables_are_unused));else for(var a=0,o=i;a<o.length;a++){var s=o[a];n(s,0,e.createDiagnosticForNode(s,e.Diagnostics._0_is_declared_but_its_value_is_never_read,jx(s.name)))}})}}function jx(t){switch(t.kind){case 73:return e.idText(t);case 186:case 185:return jx(e.cast(e.first(t.elements),e.isBindingElement).name);default:return e.Debug.assertNever(t)}}function Jx(e){return 251===e.kind||254===e.kind||252===e.kind}function zx(e){return 251===e.kind?e:252===e.kind?e.parent:e.parent.parent}function Vx(t){if(219===t.kind&&eT(t),e.isFunctionOrModuleBlock(t)){var r=wN;e.forEach(t.statements,yS),wN=r}else e.forEach(t.statements,yS);t.locals&&Nx(t)}function Ux(t){DT>=2||xT.noEmit||!e.hasRestParameter(t)||4194304&t.flags||e.nodeIsMissing(t.body)||e.forEach(t.parameters,function(t){t.name&&!e.isBindingPattern(t.name)&&t.name.escapedText===jT.escapedName&&y(t,e.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters)})}function Kx(t,r,n){if(!r||r.escapedText!==n)return!1;if(155===t.kind||154===t.kind||157===t.kind||156===t.kind||159===t.kind||160===t.kind)return!1;if(4194304&t.flags)return!1;var i=e.getRootDeclaration(t);return 152===i.kind&&e.nodeIsMissing(i.parent.body)?!1:!0}function qx(t){e.findAncestor(t,function(r){if(4&TC(r)){var n=73!==t.kind;return n?y(e.getNameOfDeclaration(t),e.Diagnostics.Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference):y(t,e.Diagnostics.Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference),!0}return!1})}function Wx(t){e.findAncestor(t,function(r){if(8&TC(r)){var n=73!==t.kind;return n?y(e.getNameOfDeclaration(t),e.Diagnostics.Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference):y(t,e.Diagnostics.Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference),!0}return!1})}function Hx(t,r){if(!(ST>=e.ModuleKind.ES2015||xT.noEmit||!Kx(t,r,"require")&&!Kx(t,r,"exports")||e.isModuleDeclaration(t)&&1!==e.getModuleInstanceState(t))){var n=qr(t);285===n.kind&&e.isExternalOrCommonJsModule(n)&&y(r,e.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module,e.declarationNameToString(r),e.declarationNameToString(r))}}function Gx(t,r){if(!(DT>=4||xT.noEmit||!Kx(t,r,"Promise")||e.isModuleDeclaration(t)&&1!==e.getModuleInstanceState(t))){var n=qr(t);285===n.kind&&e.isExternalOrCommonJsModule(n)&&1024&n.flags&&y(r,e.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions,e.declarationNameToString(r),e.declarationNameToString(r))}}function Qx(t){if(0===(3&e.getCombinedNodeFlags(t))&&!e.isParameterDeclaration(t)&&(238!==t.kind||t.initializer)){var r=Ht(t);if(1&r.flags){if(!e.isIdentifier(t.name))return e.Debug.fail();var n=j(t,t.name.escapedText,3,void 0,void 0,!1);if(n&&n!==r&&2&n.flags&&3&zg(n)){var i=e.getAncestor(n.valueDeclaration,239),a=220===i.parent.kind&&i.parent.parent?i.parent.parent:void 0,o=a&&(219===a.kind&&e.isFunctionLike(a.parent)||246===a.kind||245===a.kind||285===a.kind);if(!o){var s=kr(n);y(t,e.Diagnostics.Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1,s,s)}}}}}function Xx(e){return e===$T?ZT:e===ZE?YE:e}function Yx(t){if(yx(t),e.isBindingElement(t)||yS(t.type),t.name){if(150===t.name.kind&&(ag(t.name),t.initializer&&eb(t.initializer)),187===t.kind){185===t.parent.kind&&8>DT&&KC(t,4),t.propertyName&&150===t.propertyName.kind&&ag(t.propertyName);var r=t.parent.parent,n=Xr(r),i=t.propertyName||t.name;if(n&&!e.isBindingPattern(i)){var a=Rc(i);if(Fi(a)){var o=Li(a),s=ao(n,o);s&&(pv(s,void 0,!1),Ug(r,!!r.initializer&&99===r.initializer.kind,n,s))}}}if(e.isBindingPattern(t.name)&&(186===t.name.kind&&2>DT&&xT.downlevelIteration&&KC(t,512),e.forEach(t.name.elements,yS)),t.initializer&&152===e.getRootDeclaration(t).kind&&e.nodeIsMissing(e.getContainingFunction(t).body))return void y(t,e.Diagnostics.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation);if(e.isBindingPattern(t.name)){var c=t.initializer&&227!==t.parent.parent.kind,u=0===t.name.elements.length;if(c||u){var l=Sn(t);if(c){var _=eb(t.initializer);kT&&u?Qg(_,t):Ll(_,Sn(t),t,t.initializer)}u&&(e.isArrayBindingPattern(t.name)?pD(l,t,!1,!1):kT&&Qg(l,t))}}else{var d=Ht(t),p=Xx(Un(d));if(t===d.valueDeclaration){var f=e.getEffectiveInitializer(t);if(f){var m=e.isInJSFile(t)&&e.isObjectLiteralExpression(f)&&(0===f.properties.length||e.isPrototypeAccess(t.name))&&e.hasEntries(d.exports);m||227===t.parent.parent.kind||Ll(eb(f),p,t,f,void 0)}d.declarations.length>1&&e.some(d.declarations,function(r){return r!==t&&e.isVariableLike(r)&&!$x(r,t)})&&y(t.name,e.Diagnostics.All_declarations_of_0_must_have_identical_modifiers,e.declarationNameToString(t.name))}else{var g=Xx(Sn(t));p===tE||g===tE||Tl(p,g)||67108864&d.flags||Zx(d.valueDeclaration,p,t,g),t.initializer&&Ll(eb(t.initializer),g,t,t.initializer,void 0),$x(t,d.valueDeclaration)||y(t.name,e.Diagnostics.All_declarations_of_0_must_have_identical_modifiers,e.declarationNameToString(t.name))}155!==t.kind&&154!==t.kind&&(ax(t),(238===t.kind||187===t.kind)&&Qx(t),Hx(t,t.name),Gx(t,t.name))}}}function Zx(t,r,n,i){var a=e.getNameOfDeclaration(n),o=155===n.kind||154===n.kind?e.Diagnostics.Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2:e.Diagnostics.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2,s=e.declarationNameToString(a),c=y(a,o,s,Er(r),Er(i));t&&e.addRelatedInfo(c,e.createDiagnosticForNode(t,e.Diagnostics._0_was_also_declared_here,s))}function $x(t,r){if(152===t.kind&&238===r.kind||238===t.kind&&152===r.kind)return!0;if(e.hasQuestionToken(t)!==e.hasQuestionToken(r))return!1;var n=504;return e.getSelectedModifierFlags(t,n)===e.getSelectedModifierFlags(r,n)}function eD(e){return Rk(e),Yx(e)}function tD(e){return wk(e),Yx(e)}function rD(t){HC(t)||Jk(t.declarationList)||Vk(t),e.forEach(t.declarationList.declarations,yS)}function nD(e){eT(e),yb(e.expression)}function iD(t){eT(t),sD(t.expression),yS(t.thenStatement),221===t.thenStatement.kind&&y(t.thenStatement,e.Diagnostics.The_body_of_an_if_statement_cannot_be_the_empty_statement),yS(t.elseStatement)}function aD(e){eT(e),yS(e.statement),sD(e.expression)}function oD(e){eT(e),sD(e.expression),yS(e.statement)}function sD(t,r){var n=yb(t,r);return 16384&n.flags&&y(t,e.Diagnostics.An_expression_of_type_void_cannot_be_tested_for_truthiness),n}function cD(t){eT(t)||t.initializer&&239===t.initializer.kind&&Jk(t.initializer),t.initializer&&(239===t.initializer.kind?e.forEach(t.initializer.declarations,eD):yb(t.initializer)),t.condition&&sD(t.condition),t.incrementor&&yb(t.incrementor),yS(t.statement),t.locals&&Nx(t)}function uD(t){if(Ck(t),t.awaitModifier){var r=e.getFunctionFlags(e.getContainingFunction(t));2===(6&r)&&8>DT&&KC(t,16384)}else xT.downlevelIteration&&2>DT&&KC(t,256);if(239===t.initializer.kind)_D(t);else{var n=t.initializer,i=dD(t.expression,t.awaitModifier);if(188===n.kind||189===n.kind)Vh(n,i||tE);else{var a=yb(n);Sh(n,e.Diagnostics.The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access),i&&Ll(i,a,n,t.expression)}}yS(t.statement),t.locals&&Nx(t)}function lD(t){Ck(t);var r=Hg(yb(t.expression));if(239===t.initializer.kind){var n=t.initializer.declarations[0];n&&e.isBindingPattern(n.name)&&y(n.name,e.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern),_D(t)}else{var i=t.initializer,a=yb(i);188===i.kind||189===i.kind?y(i,e.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern):Pl(Kc(r),a)?Sh(i,e.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access):y(i,e.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any)}r!==vE&&wh(r,126091264)||y(t.expression,e.Diagnostics.The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0,Er(r)),yS(t.statement),t.locals&&Nx(t)}function _D(e){var t=e.initializer;if(t.declarations.length>=1){var r=t.declarations[0];eD(r)}}function dD(e,t){var r=Wg(e);return pD(r,e,!0,void 0!==t)}function pD(e,t,r,n){return Qr(e)?e:fD(e,t,r,n,!0)||ZT}function fD(t,r,n,i,a){if(t===vE)return void gD(r,t,i);var o=DT>=2,s=!o&&xT.downlevelIteration;if(o||s||i){var c=mD(t,o?r:void 0,i,!0,a);if(c||o)return c}var u=t,l=!1,_=!1;if(n){if(1048576&u.flags){var d=t.types,p=e.filter(d,function(e){return!(132&e.flags)});p!==d&&(u=Dc(p,2))}else 132&u.flags&&(u=vE);if(_=u!==t,_&&(1>DT&&r&&(y(r,e.Diagnostics.Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher),l=!0),131072&u.flags))return sE}if(!U_(u)){if(r&&!l){var f=!!mD(t,void 0,i,!0,a),m=!n||_?s?e.Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator:f?e.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_Use_compiler_option_downlevelIteration_to_allow_iterating_of_iterators:e.Diagnostics.Type_0_is_not_an_array_type:s?e.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator:f?e.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_Use_compiler_option_downlevelIteration_to_allow_iterating_of_iterators:e.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type;y(r,m,Er(u))}return _?sE:void 0}var g=_o(u,1);return _&&g?132&g.flags?sE:Dc([g,sE],2):g}function mD(t,r,n,i,a){function o(t){var o=t;if(n){if(o.iteratedTypeOfAsyncIterable)return o.iteratedTypeOfAsyncIterable;if(Kn(t,Vs(!1))||Kn(t,Ks(!1)))return o.iteratedTypeOfAsyncIterable=t.typeArguments[0]}if(i){if(o.iteratedTypeOfIterable)return n?o.iteratedTypeOfAsyncIterable=ux(o.iteratedTypeOfIterable):o.iteratedTypeOfIterable;if(Kn(t,qs(!1))||Kn(t,Hs(!1)))return n?o.iteratedTypeOfAsyncIterable=ux(t.typeArguments[0]):o.iteratedTypeOfIterable=t.typeArguments[0]}var s=n&&Hr(t,e.getPropertyNameForKnownSymbolName("asyncIterator")),c=s||(i?Hr(t,e.getPropertyNameForKnownSymbolName("iterator")):void 0);if(Qr(c))return void 0;var u=c?so(c,0):void 0;if(!e.some(u))return void(r&&(gD(r,t,n),r=void 0));var l=Dc(e.map(u,Mo),2),_=vD(l,r,!!s);return a&&r&&_&&Ml(t,s?ec(_):rc(_),r),_?n?o.iteratedTypeOfAsyncIterable=s?_:ux(_):o.iteratedTypeOfIterable=_:void 0}return Qr(t)?void 0:lf(t,o)}function gD(t,r,n){y(t,n?e.Diagnostics.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator:e.Diagnostics.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator,Er(r))}function vD(t,r,n){if(Qr(t))return void 0;var i=t;if(n?i.iteratedTypeOfAsyncIterator:i.iteratedTypeOfIterator)return n?i.iteratedTypeOfAsyncIterator:i.iteratedTypeOfIterator;var a=n?Us:Ws;if(Kn(t,a(!1)))return n?i.iteratedTypeOfAsyncIterator=t.typeArguments[0]:i.iteratedTypeOfIterator=t.typeArguments[0];var o=Hr(t,"next");if(Qr(o))return void 0;var s=o?so(o,0):e.emptyArray;if(0===s.length)return void(r&&y(r,n?e.Diagnostics.An_async_iterator_must_have_a_next_method:e.Diagnostics.An_iterator_must_have_a_next_method));var c=Dc(e.map(s,Mo),2);if(Qr(c))return void 0;if(n&&(c=ox(c,r,e.Diagnostics.The_type_returned_by_the_next_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property),Qr(c)))return void 0;var u=c&&Hr(c,"value");return u?n?i.iteratedTypeOfAsyncIterator=u:i.iteratedTypeOfIterator=u:void(r&&y(r,n?e.Diagnostics.The_type_returned_by_the_next_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property:e.Diagnostics.The_type_returned_by_the_next_method_of_an_iterator_must_have_a_value_property))}function yD(e,t){return Qr(e)?void 0:mD(e,void 0,t,!t,!1)||vD(e,void 0,t)}function hD(e){eT(e)||Pk(e)}function bD(t,r){var n=2===(3&e.getFunctionFlags(t))?sx(r):r;return!!n&&Ph(n,16387)}function xD(t){if(!eT(t)){var r=e.getContainingFunction(t);if(!r)return void qk(t,e.Diagnostics.A_return_statement_can_only_be_used_within_a_function_body);var n=Co(r),i=Mo(n),a=e.getFunctionFlags(r),o=1&a;if(kT||t.expression||131072&i.flags){var s=t.expression?eb(t.expression):nE;if(o)return;if(160===r.kind)t.expression&&y(t,e.Diagnostics.Setters_cannot_return_a_value);else if(158===r.kind)t.expression&&!Ll(s,i,t,t.expression)&&y(t,e.Diagnostics.Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class);else if(Lo(r))if(2&a){var c=sx(i),u=cx(s,t,e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);c&&Ll(u,c,t,t.expression)}else Ll(s,i,t,t.expression)}else 158===r.kind||!xT.noImplicitReturns||bD(r,i)||o||y(t,e.Diagnostics.Not_all_code_paths_return_a_value)}}function DD(t){eT(t)||16384&t.flags&&qk(t,e.Diagnostics.with_statements_are_not_allowed_in_an_async_function_block),yb(t.expression);var r=e.getSourceFileOfNode(t);if(!Kk(r)){var n=e.getSpanOfTokenAtPosition(r,t.pos).start,i=t.statement.pos;Wk(r,n,i-n,e.Diagnostics.The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any)}}function SD(t){eT(t);var r,n=!1,i=yb(t.expression),a=X_(i);e.forEach(t.caseBlock.clauses,function(o){if(273===o.kind&&!n)if(void 0===r)r=o;else{var s=e.getSourceFileOfNode(t),c=e.skipTrivia(s.text,o.pos),u=o.statements.length>0?o.statements[0].pos:o.end;Wk(s,c,u-c,e.Diagnostics.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement),n=!0}if(l&&272===o.kind){var _=yb(o.expression),d=X_(_),p=i;d&&a||(_=d?Y_(_):_,p=Y_(i)),qh(p,_)||Zl(_,p,o.expression,void 0)}e.forEach(o.statements,yS)}),t.caseBlock.locals&&Nx(t.caseBlock)}function CD(t){eT(t)||e.findAncestor(t.parent,function(r){return e.isFunctionLike(r)?"quit":234===r.kind&&r.label.escapedText===t.label.escapedText?(Hk(t.label,e.Diagnostics.Duplicate_label_0,e.getTextOfNode(t.label)),!0):!1}),yS(t.statement)}function kD(t){eT(t)||void 0===t.expression&&nT(t,e.Diagnostics.Line_break_not_permitted_here),t.expression&&yb(t.expression)}function TD(t){eT(t),Vx(t.tryBlock);var r=t.catchClause;if(r){if(r.variableDeclaration)if(r.variableDeclaration.type)qk(r.variableDeclaration.type,e.Diagnostics.Catch_clause_variable_cannot_have_a_type_annotation);else if(r.variableDeclaration.initializer)qk(r.variableDeclaration.initializer,e.Diagnostics.Catch_clause_variable_cannot_have_an_initializer);else{var n=r.block.locals;n&&e.forEachKey(r.locals,function(t){var r=n.get(t);r&&0!==(2&r.flags)&&Hk(r.valueDeclaration,e.Diagnostics.Cannot_redeclare_identifier_0_in_catch_clause,t)})}Vx(r.block)}t.finallyBlock&&Vx(t.finallyBlock)
}function ED(t){function r(t,r,n,i,a,o){if(a&&!e.isKnownSymbol(t)){var s=t.valueDeclaration,c=s&&e.getNameOfDeclaration(s);if(1!==o||(c?tg(c):ig(t.escapedName))){var u;if(s&&c&&(205===s.kind||150===c.kind||t.parent===n.symbol))u=s;else if(i)u=i;else if(2&e.getObjectFlags(n)){var l=e.forEach(ii(n),function(e){return Na(e,t.escapedName)&&_o(e,o)});u=l?void 0:n.symbol.declarations[0]}if(u&&!Pl(r,a)){var _=0===o?e.Diagnostics.Property_0_of_type_1_is_not_assignable_to_string_index_type_2:e.Diagnostics.Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2;y(u,_,kr(t),Er(r),Er(a))}}}}var n=Yo(t.symbol,1),i=Yo(t.symbol,0),a=_o(t,0),o=_o(t,1);if(a||o){e.forEach(Ea(t),function(e){var s=Un(e);r(e,s,t,i,a,0),r(e,s,t,n,o,1)});var s=t.symbol.valueDeclaration;if(1&e.getObjectFlags(t)&&e.isClassLike(s))for(var c=0,u=s.members;c<u.length;c++){var l=u[c];if(!e.hasModifier(l,32)&&Oi(l)){var _=Ht(l),d=Un(_);r(_,d,t,i,a,0),r(_,d,t,n,o,1)}}}var p;if(a&&o&&(p=n||i,!p&&2&e.getObjectFlags(t))){var f=e.forEach(ii(t),function(e){return _o(e,0)&&_o(e,1)});p=f?void 0:t.symbol.declarations[0]}p&&!Pl(o,a)&&y(p,e.Diagnostics.Numeric_index_type_0_is_not_assignable_to_string_index_type_1,Er(o),Er(a))}function ND(e,t){switch(e.escapedText){case"any":case"unknown":case"number":case"bigint":case"boolean":case"string":case"symbol":case"void":case"object":y(e,t,e.escapedText)}}function AD(t){1===DT&&"Object"===t.escapedText&&ST!==e.ModuleKind.ES2015&&ST!==e.ModuleKind.ESNext&&y(t,e.Diagnostics.Class_name_cannot_be_Object_when_targeting_ES5_with_module_0,e.ModuleKind[ST])}function FD(t){if(t)for(var r=!1,n=0;n<t.length;n++){var i=t[n];if(Db(i),l){i.default?(r=!0,PD(i.default,t,n)):r&&y(i,e.Diagnostics.Required_type_parameters_may_not_follow_optional_type_parameters);for(var a=0;n>a;a++)t[a].symbol===i.symbol&&y(i.name,e.Diagnostics.Duplicate_identifier_0,e.declarationNameToString(i.name))}}}function PD(t,r,n){function i(t){if(165===t.kind){var a=ks(t);if(262144&a.flags)for(var o=n;o<r.length;o++)a.symbol===Ht(r[o])&&y(t,e.Diagnostics.Type_parameter_defaults_can_only_reference_previously_declared_type_parameters)}e.forEachChild(t,i)}i(t)}function wD(t){if(1!==t.declarations.length){var r=I(t);if(!r.typeParametersChecked){r.typeParametersChecked=!0;var n=zD(t);if(n.length<=1)return;var i=bi(t);if(!ID(n,i.localTypeParameters))for(var a=kr(t),o=0,s=n;o<s.length;o++){var c=s[o];y(c.name,e.Diagnostics.All_declarations_of_0_must_have_identical_type_parameters,a)}}}}function ID(t,r){for(var n=e.length(r),i=Do(r),a=0,o=t;a<o.length;a++){var s=o[a],c=e.getEffectiveTypeParameterDeclarations(s),u=c.length;if(i>u||u>n)return!1;for(var l=0;u>l;l++){var _=c[l],d=r[l];if(_.name.escapedText!==d.symbol.escapedName)return!1;var p=e.getEffectiveConstraintOfTypeParameter(_),f=p&&ju(p),m=Ma(d);if(f&&(!m||!Tl(f,m)))return!1;var g=_.default&&ju(_.default),v=Xa(d);if(g&&v&&!Tl(g,v))return!1}}return!0}function OD(e){return RD(e),SS(e),Un(Ht(e))}function MD(t){e.forEach(t.members,yS),Nx(t)}function LD(t){t.name||e.hasModifier(t,512)||qk(t,e.Diagnostics.A_class_declaration_without_the_default_modifier_must_have_a_name),RD(t),e.forEach(t.members,yS),Nx(t)}function RD(t){ok(t),yx(t),t.name&&(ND(t.name,e.Diagnostics.Class_name_cannot_be_0),Hx(t,t.name),Gx(t,t.name),4194304&t.flags||AD(t.name)),FD(e.getEffectiveTypeParameterDeclarations(t)),ax(t);var r=Ht(t),n=bi(r),i=Vi(n),a=Un(r);wD(r),Nb(t),4194304&t.flags||Ab(t);var o=e.getEffectiveBaseTypeNode(t);if(o){2>DT&&KC(o.parent,1);var s=e.getClassExtendsHeritageElement(t);s&&s!==o&&yb(s.expression);var c=ii(n);if(c.length&&l){var u=c[0],_=ni(n),d=to(_);if(jD(d,o),yS(o.expression),e.some(o.typeArguments)){e.forEach(o.typeArguments,yS);for(var p=0,f=ti(d,o.typeArguments,o);p<f.length;p++){var m=f[p];if(!jb(o,m.typeParameters))break}}var g=Vi(u,n.thisType);if(Ml(i,g,void 0)?Ml(a,kl(d),t.name||t,e.Diagnostics.Class_static_side_0_incorrectly_extends_base_class_static_side_1):BD(t,i,g,e.Diagnostics.Class_0_incorrectly_extends_base_class_1),8650752&_.flags&&!Zn(a)&&y(t.name||t,e.Diagnostics.A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any),!(d.symbol&&32&d.symbol.flags||8650752&_.flags)){var v=ri(d,o.typeArguments,o);e.forEach(v,function(e){return!Dy(e.declaration)&&Mo(e)!==u})&&y(o.expression,e.Diagnostics.Base_constructors_must_all_have_the_same_return_type)}VD(n,u)}}var h=e.getClassImplementsHeritageClauseElements(t);if(h)for(var b=0,x=h;b<x.length;b++){var D=x[b];if(e.isEntityNameExpression(D.expression)||y(D.expression,e.Diagnostics.A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments),zb(D),l){var S=ju(D);if(S!==tE)if(si(S)){var C=S.symbol&&32&S.symbol.flags?e.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass:e.Diagnostics.Class_0_incorrectly_implements_interface_1,g=Vi(S,n.thisType);Ml(i,g,void 0)||BD(t,i,g,C)}else y(D,e.Diagnostics.A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members)}}l&&(ED(n),Pb(t),KD(t))}function BD(t,r,n,i){for(var a=!1,o=function(t){if(e.hasStaticModifier(t))return"continue";var i=t.name&&HS(t.name)||HS(t);if(i){var o=ao(r,i.escapedName),s=ao(n,i.escapedName);if(o&&s){var c=function(){return e.chainDiagnosticMessages(void 0,e.Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2,kr(i),Er(r),Er(n))};Ml(Un(o),Un(s),t.name||t,void 0,c)||(a=!0)}}},s=0,c=t.members;s<c.length;s++){var u=c[s];o(u)}a||Ml(r,n,t.name||t,i)}function jD(t,r){var n=so(t,1);if(n.length){var i=n[0].declaration;if(i&&e.hasModifier(i,8)){var a=e.getClassLikeDeclarationOfSymbol(t.symbol);zS(r,a)||y(r,e.Diagnostics.Cannot_extend_a_class_0_Class_constructor_is_marked_as_private,Ct(t.symbol))}}}function JD(t){return 1&e.getCheckFlags(t)?t.target:t}function zD(t){return e.filter(t.declarations,function(e){return 241===e.kind||242===e.kind})}function VD(t,r){for(var n=Pa(r),i=0,a=n;i<a.length;i++){var o=a[i],s=JD(o);if(!(4194304&s.flags)){var c=JD(Na(t,s.escapedName)),u=e.getDeclarationModifierFlagsFromSymbol(s);if(e.Debug.assert(!!c,"derived should point to something, even if it is the base class' declaration."),c)if(c===s){var l=e.getClassLikeDeclarationOfSymbol(t.symbol);!(128&u)||l&&e.hasModifier(l,128)||(210===l.kind?y(l,e.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1,kr(o),Er(r)):y(l,e.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2,Er(t),kr(o),Er(r)))}else{var _=e.getDeclarationModifierFlagsFromSymbol(c);if(8&u||8&_)continue;if(Vg(s)||98308&s.flags&&98308&c.flags)continue;var d=void 0;d=Vg(s)?98304&c.flags?e.Diagnostics.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor:e.Diagnostics.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_property:98304&s.flags?e.Diagnostics.Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function:e.Diagnostics.Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function,y(e.getNameOfDeclaration(c.valueDeclaration)||c.valueDeclaration,d,Er(r),kr(s),Er(t))}}}}function UD(t,r){var n=ii(t);if(n.length<2)return!0;var i=e.createUnderscoreEscapedMap();e.forEach(Ai(t).declaredProperties,function(e){i.set(e.escapedName,{prop:e,containingType:t})});for(var a=!0,o=0,s=n;o<s.length;o++)for(var c=s[o],u=Pa(Vi(c,t.thisType)),l=0,_=u;l<_.length;l++){var d=_[l],p=i.get(d.escapedName);if(p){var f=p.containingType!==t;if(f&&!P_(p.prop,d)){a=!1;var m=Er(p.containingType),g=Er(c),v=e.chainDiagnosticMessages(void 0,e.Diagnostics.Named_property_0_of_types_1_and_2_are_not_identical,kr(d),m,g);v=e.chainDiagnosticMessages(v,e.Diagnostics.Interface_0_cannot_simultaneously_extend_types_1_and_2,Er(t),m,g),tA.add(e.createDiagnosticForNodeFromMessageChain(r,v))}}else i.set(d.escapedName,{prop:d,containingType:c})}return a}function KD(t){if(kT&&NT&&!(4194304&t.flags))for(var r=er(t),n=0,i=t.members;n<i.length;n++){var a=i[n];if(qD(a)){var o=a.name;if(e.isIdentifier(o)){var s=Un(Ht(a));3&s.flags||32768&sd(s)||r&&WD(o,s,r)||y(a.name,e.Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor,e.declarationNameToString(o))}}}}function qD(t){return 155===t.kind&&!e.hasModifier(t,160)&&!t.exclamationToken&&!t.initializer}function WD(t,r,n){var i=e.createPropertyAccess(e.createThis(),t);i.expression.parent=i,i.parent=n,i.flowNode=n.returnFlowNode;var a=Af(i,r,dd(r));return!(32768&sd(a))}function HD(t){if(HC(t)||vk(t),FD(t.typeParameters),l){ND(t.name,e.Diagnostics.Interface_name_cannot_be_0),ax(t);var r=Ht(t);wD(r);var n=e.getDeclarationOfKind(r,242);if(t===n){var i=bi(r),a=Vi(i);if(UD(i,t.name)){for(var o=0,s=ii(i);o<s.length;o++){var c=s[o];Ml(a,Vi(c,i.thisType),t.name,e.Diagnostics.Interface_0_incorrectly_extends_interface_1)}ED(i)}}Fb(t)}e.forEach(e.getInterfaceBaseTypeNodes(t),function(t){e.isEntityNameExpression(t.expression)||y(t.expression,e.Diagnostics.An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments),zb(t)}),e.forEach(t.members,yS),l&&(Pb(t),Nx(t))}function GD(t){HC(t),ND(t.name,e.Diagnostics.Type_alias_name_cannot_be_0),FD(t.typeParameters),yS(t.type),Nx(t)}function QD(e){var t=O(e);if(!(16384&t.flags)){t.flags|=16384;for(var r=0,n=0,i=e.members;n<i.length;n++){var a=i[n],o=XD(a,r);O(a).enumMemberValue=o,r="number"==typeof o?o+1:void 0}}}function XD(t,r){if(Yr(t.name))y(t.name,e.Diagnostics.Computed_property_names_are_not_allowed_in_enums);else{var n=e.getTextOfPropertyName(t.name);ig(n)&&!ng(n)&&y(t.name,e.Diagnostics.An_enum_member_cannot_have_a_numeric_name)}return t.initializer?YD(t):4194304&t.parent.flags&&!e.isEnumConst(t.parent)?void 0:void 0!==r?r:void y(t.name,e.Diagnostics.Enum_member_must_have_initializer)}function YD(t){function r(i){switch(i.kind){case 203:var a=r(i.operand);if("number"==typeof a)switch(i.operator){case 38:return a;case 39:return-a;case 53:return~a}break;case 205:var o=r(i.left),s=r(i.right);if("number"==typeof o&&"number"==typeof s)switch(i.operatorToken.kind){case 50:return o|s;case 49:return o&s;case 47:return o>>s;case 48:return o>>>s;case 46:return o<<s;case 51:return o^s;case 40:return o*s;case 42:return o/s;case 38:return o+s;case 39:return o-s;case 43:return o%s;case 41:return Math.pow(o,s)}else if("string"==typeof o&&"string"==typeof s&&38===i.operatorToken.kind)return o+s;break;case 10:return i.text;case 8:return tT(i),+i.text;case 196:return r(i.expression);case 73:var c=i;return ng(c.escapedText)?+c.escapedText:e.nodeIsMissing(i)?0:n(i,Ht(t.parent),c.escapedText);case 191:case 190:var u=i;if(ZD(u)){var l=gb(u.expression);if(l.symbol&&384&l.symbol.flags){var _=void 0;if(190===u.kind)_=u.name.escapedText;else{var d=u.argumentExpression;e.Debug.assert(e.isLiteralExpression(d)),_=e.escapeLeadingUnderscores(d.text)}return n(i,l.symbol,_)}}}return void 0}function n(r,n,i){var a=n.exports.get(i);if(a){var o=a.valueDeclaration;if(o!==t)return B(o,t)?EC(o):(y(r,e.Diagnostics.A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums),0)}return void 0}var i=fi(Ht(t.parent)),a=e.isEnumConst(t.parent),o=t.initializer,s=1!==i||pi(t)?r(o):void 0;if(void 0!==s)a&&"number"==typeof s&&!isFinite(s)&&y(o,isNaN(s)?e.Diagnostics.const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN:e.Diagnostics.const_enum_member_initializer_was_evaluated_to_a_non_finite_value);else{if(1===i)return y(o,e.Diagnostics.Computed_values_are_not_permitted_in_an_enum_with_string_valued_members),0;a?y(o,e.Diagnostics.const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values):4194304&t.parent.flags?y(o,e.Diagnostics.In_ambient_enum_declarations_member_initializer_must_be_constant_expression):Ml(yb(o),bi(Ht(t.parent)),o,void 0)}return s}function ZD(e){return 73===e.kind||190===e.kind&&ZD(e.expression)||191===e.kind&&ZD(e.expression)&&10===e.argumentExpression.kind}function $D(t){if(l){HC(t),ND(t.name,e.Diagnostics.Enum_name_cannot_be_0),Hx(t,t.name),Gx(t,t.name),ax(t),QD(t);var r=Ht(t),n=e.getDeclarationOfKind(r,t.kind);if(t===n){if(r.declarations.length>1){var i=e.isEnumConst(t);e.forEach(r.declarations,function(t){e.isEnumDeclaration(t)&&e.isEnumConst(t)!==i&&y(e.getNameOfDeclaration(t),e.Diagnostics.Enum_declarations_must_all_be_const_or_non_const)})}var a=!1;e.forEach(r.declarations,function(t){if(244!==t.kind)return!1;var r=t;if(!r.members.length)return!1;var n=r.members[0];n.initializer||(a?y(n.name,e.Diagnostics.In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element):a=!0)})}}}function eS(t){for(var r=t.declarations,n=0,i=r;n<i.length;n++){var a=i[n];if((241===a.kind||240===a.kind&&e.nodeIsPresent(a.body))&&!(4194304&a.flags))return a}return void 0}function tS(t,r){var n=e.getEnclosingBlockScopeContainer(t),i=e.getEnclosingBlockScopeContainer(r);return M(n)?M(i):M(i)?!1:n===i}function rS(t){if(l){var r=e.isGlobalScopeAugmentation(t),i=4194304&t.flags;r&&!i&&y(t.name,e.Diagnostics.Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context);var a=e.isAmbientModule(t),o=a?e.Diagnostics.An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file:e.Diagnostics.A_namespace_declaration_is_only_allowed_in_a_namespace_or_module;if(_S(t,o))return;HC(t)||i||10!==t.name.kind||Hk(t.name,e.Diagnostics.Only_ambient_modules_can_use_quoted_names),e.isIdentifier(t.name)&&(Hx(t,t.name),Gx(t,t.name)),ax(t);var s=Ht(t);if(512&s.flags&&!i&&s.declarations.length>1&&n(t,!!xT.preserveConstEnums||!!xT.isolatedModules)){var c=eS(s);c&&(e.getSourceFileOfNode(t)!==e.getSourceFileOfNode(c)?y(t.name,e.Diagnostics.A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged):t.pos<c.pos&&y(t.name,e.Diagnostics.A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged));var u=e.getDeclarationOfKind(s,241);u&&tS(t,u)&&(O(t).flags|=32768)}if(a)if(e.isExternalModuleAugmentation(t)){var _=r||33554432&Ht(t).flags;if(_&&t.body)for(var d=0,p=t.body.statements;d<p.length;d++){var f=p[d];nS(f,r)}}else M(t.parent)?r?y(t.name,e.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations):e.isExternalModuleNameRelative(e.getTextOfIdentifierOrLiteral(t.name))&&y(t.name,e.Diagnostics.Ambient_module_declaration_cannot_specify_relative_module_name):r?y(t.name,e.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations):y(t.name,e.Diagnostics.Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces)}t.body&&(yS(t.body),e.isGlobalScopeAugmentation(t)||Nx(t))}function nS(t,r){switch(t.kind){case 220:for(var n=0,i=t.declarationList.declarations;n<i.length;n++){var a=i[n];nS(a,r)}break;case 255:case 256:qk(t,e.Diagnostics.Exports_and_export_assignments_are_not_permitted_in_module_augmentations);break;case 249:case 250:qk(t,e.Diagnostics.Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module);break;case 187:case 238:var o=t.name;if(e.isBindingPattern(o)){for(var s=0,c=o.elements;s<c.length;s++){var u=c[s];nS(u,r)}break}case 241:case 244:case 240:case 242:case 245:case 243:if(r)return;var l=Ht(t);if(l){var _=!(33554432&l.flags);_||(_=!!l.parent&&e.isExternalModuleAugmentation(l.parent.declarations[0]))}}}function iS(e){switch(e.kind){case 73:return e;case 149:do e=e.left;while(73!==e.kind);return e;case 190:do e=e.expression;while(73!==e.kind);return e}}function aS(t){var r=e.getExternalModuleName(t);if(!r||e.nodeIsMissing(r))return!1;if(!e.isStringLiteral(r))return y(r,e.Diagnostics.String_literal_expected),!1;var n=246===t.parent.kind&&e.isAmbientModule(t.parent.parent);return 285===t.parent.kind||n?n&&e.isExternalModuleNameRelative(r.text)&&!Mr(t)?(y(t,e.Diagnostics.Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name),!1):!0:(y(r,256===t.kind?e.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace:e.Diagnostics.Import_declarations_in_a_namespace_cannot_reference_a_module),!1)}function oS(t){var r=Ht(t),n=bt(r);if(n!==XT){var i=(68268991&r.flags?67220415:0)|(67897832&r.flags?67897832:0)|(1920&r.flags?1920:0);if(n.flags&i){var a=258===t.kind?e.Diagnostics.Export_declaration_conflicts_with_exported_declaration_of_0:e.Diagnostics.Import_declaration_conflicts_with_local_declaration_of_0;y(t,a,kr(r))}!xT.isolatedModules||258!==t.kind||67220415&n.flags||4194304&t.flags||y(t,e.Diagnostics.Cannot_re_export_a_type_when_the_isolatedModules_flag_is_provided)}}function sS(e){Hx(e,e.name),Gx(e,e.name),oS(e)}function cS(t){if(!_S(t,e.Diagnostics.An_import_declaration_can_only_be_used_in_a_namespace_or_module)&&(!HC(t)&&e.hasModifiers(t)&&qk(t,e.Diagnostics.An_import_declaration_cannot_have_modifiers),aS(t))){var r=t.importClause;if(r&&(r.name&&sS(r),r.namedBindings))if(252===r.namedBindings.kind)sS(r.namedBindings);else{var n=At(t,t.moduleSpecifier);n&&e.forEach(r.namedBindings.elements,sS)}}}function uS(t){if(!_S(t,e.Diagnostics.An_import_declaration_can_only_be_used_in_a_namespace_or_module)&&(HC(t),e.isInternalModuleImportEqualsDeclaration(t)||aS(t)))if(sS(t),e.hasModifier(t,1)&&xt(t),260!==t.moduleReference.kind){var r=bt(Ht(t));if(r!==XT){if(67220415&r.flags){var n=iS(t.moduleReference);1920&kt(n,67221439).flags||y(n,e.Diagnostics.Module_0_is_hidden_by_a_local_declaration_with_the_same_name,e.declarationNameToString(n))}67897832&r.flags&&ND(t.name,e.Diagnostics.Import_name_cannot_be_0)}}else ST>=e.ModuleKind.ES2015&&!(4194304&t.flags)&&Hk(t,e.Diagnostics.Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead)}function lS(t){if(!_S(t,e.Diagnostics.An_export_declaration_can_only_be_used_in_a_module)&&(!HC(t)&&e.hasModifiers(t)&&qk(t,e.Diagnostics.An_export_declaration_cannot_have_modifiers),!t.moduleSpecifier||aS(t)))if(t.exportClause){e.forEach(t.exportClause.elements,dS);var r=246===t.parent.kind&&e.isAmbientModule(t.parent.parent),n=!r&&246===t.parent.kind&&!t.moduleSpecifier&&4194304&t.flags;285===t.parent.kind||r||n||y(t,e.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace)}else{var i=At(t,t.moduleSpecifier);i&&Rt(i)&&y(t.moduleSpecifier,e.Diagnostics.Module_0_uses_export_and_cannot_be_used_with_export_Asterisk,kr(i)),ST!==e.ModuleKind.System&&ST!==e.ModuleKind.ES2015&&ST!==e.ModuleKind.ESNext&&KC(t,32768)}}function _S(e,t){var r=285===e.parent.kind||246===e.parent.kind||245===e.parent.kind;return r||qk(e,t),!r}function dS(t){if(oS(t),e.getEmitDeclarations(xT)&&Jr(t.propertyName||t.name,!0),!t.parent.parent.moduleSpecifier){var r=t.propertyName||t.name,n=j(r,r.escapedText,70107135,void 0,void 0,!0);n&&(n===LT||M(qr(n.declarations[0])))?y(r,e.Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module,e.idText(r)):xt(t)}}function pS(t){if(!_S(t,e.Diagnostics.An_export_assignment_can_only_be_used_in_a_module)){var r=285===t.parent.kind?t.parent:t.parent.parent;if(245===r.kind&&!e.isAmbientModule(r))return void(t.isExportEquals?y(t,e.Diagnostics.An_export_assignment_cannot_be_used_in_a_namespace):y(t,e.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module));!HC(t)&&e.hasModifiers(t)&&qk(t,e.Diagnostics.An_export_assignment_cannot_have_modifiers),73===t.expression.kind?(xt(t),e.getEmitDeclarations(xT)&&Jr(t.expression,!0)):eb(t.expression),mS(r),4194304&t.flags&&!e.isEntityNameExpression(t.expression)&&Hk(t.expression,e.Diagnostics.The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context),!t.isExportEquals||4194304&t.flags||(ST>=e.ModuleKind.ES2015?Hk(t,e.Diagnostics.Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead):ST===e.ModuleKind.System&&Hk(t,e.Diagnostics.Export_assignment_is_not_supported_when_module_flag_is_system))}}function fS(t){return e.forEachEntry(t.exports,function(e,t){return"export="!==t})}function mS(t){var r=Ht(t),n=I(r);if(!n.exportsChecked){var i=r.exports.get("export=");if(i&&fS(r)){var a=rt(i)||i.valueDeclaration;Mr(a)||e.isInJSFile(a)||y(a,e.Diagnostics.An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements)}var o=Ut(r);o&&o.forEach(function(t,r){var n=t.declarations,i=t.flags;if("__export"!==r&&!(1984&i)){var a=e.countWhere(n,kA);if(!(524288&i&&2>=a)&&a>1)for(var o=0,s=n;o<s.length;o++){var c=s[o];vS(c)&&tA.add(e.createDiagnosticForNode(c,e.Diagnostics.Cannot_redeclare_exported_variable_0,e.unescapeLeadingUnderscores(r)))}}}),n.exportsChecked=!0}}function gS(t){return!e.isAccessor(t)}function vS(e){return 240!==e.kind&&157!==e.kind||!!e.body}function yS(e){if(e){var t=uT;uT=e,hS(e),uT=t}}function hS(t){e.isInJSFile(t)&&e.forEach(t.jsDoc,function(t){var r=t.tags;return e.forEach(r,yS)});var r=t.kind;if(oT)switch(r){case 245:case 241:case 242:case 240:oT.throwIfCancellationRequested()}switch(r){case 151:return Db(t);case 152:return Sb(t);case 155:case 154:return wb(t);case 166:case 167:case 161:case 162:case 163:return Eb(t);case 157:case 156:return Ib(t);case 158:return Ob(t);case 159:case 160:return Mb(t);case 165:return zb(t);case 164:return Cb(t);case 168:return Ub(t);case 169:return Kb(t);case 170:return qb(t);case 171:return Wb(t);case 174:case 175:return Hb(t);case 178:case 172:case 173:return yS(t.type);case 179:return Yb(t);case 180:return Zb(t);case 176:return $b(t);case 177:return ex(t);case 184:return tx(t);case 301:return kx(t);case 310:case 303:return bx(t);case 309:return xx(t);case 308:return Dx(t);case 305:return Sx(t);case 295:Cx(t);case 293:case 292:case 290:case 291:case 298:return bS(t),void e.forEachChild(t,yS);case 296:return void xS(t);case 289:return yS(t.type);case 181:return Qb(t);case 182:return Xb(t);case 240:return hx(t);case 219:case 246:return Vx(t);case 220:return rD(t);case 222:return nD(t);case 223:return iD(t);case 224:return aD(t);case 225:return oD(t);case 226:return cD(t);case 227:return lD(t);case 228:return uD(t);case 229:case 230:return hD(t);case 231:return xD(t);case 232:return DD(t);case 233:return SD(t);case 234:return CD(t);case 235:return kD(t);case 236:return TD(t);case 238:return eD(t);case 187:return tD(t);case 241:return LD(t);case 242:return HD(t);case 243:return GD(t);case 244:return $D(t);case 245:return rS(t);case 250:return cS(t);case 249:return uS(t);case 256:return lS(t);case 255:return pS(t);case 221:case 237:return void eT(t);case 259:return Rb(t)}}function bS(t){e.isInJSFile(t)||Hk(t,e.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments)}function xS(t){bS(t),yS(t.type);var r=t.parent;if(e.isParameter(r)&&e.isJSDocFunctionType(r.parent))return void(e.last(r.parent.parameters)!==r&&y(t,e.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list));e.isJSDocTypeExpression(r)||y(t,e.Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);var n=t.parent.parent;if(!e.isJSDocParameterTag(n))return void y(t,e.Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);var i=e.getParameterSymbolFromJSDoc(n);if(i){var a=e.getHostSignatureFromJSDoc(n);a&&e.last(a.parameters).symbol===i||y(t,e.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list)}}function DS(t){var r=ju(t.type),n=t.parent,i=t.parent.parent;if(e.isJSDocTypeExpression(t.parent)&&e.isJSDocParameterTag(i)){var a=e.getHostSignatureFromJSDoc(i);if(a){var o=e.lastOrUndefined(a.parameters),s=e.getParameterSymbolFromJSDoc(i);if(!o||s&&o.symbol===s&&e.isRestParameter(o))return ic(r)}}return e.isParameter(n)&&e.isJSDocFunctionType(n.parent)?ic(r):un(r)}function SS(r){var n=e.getSourceFileOfNode(r),i=O(n);if(!(1&i.flags)){i.deferredNodes=i.deferredNodes||e.createMap();var a=""+t(r);i.deferredNodes.set(a,r)}}function CS(e){var t=O(e);t.deferredNodes&&t.deferredNodes.forEach(kS)}function kS(e){var t=uT;switch(uT=e,e.kind){case 197:case 198:case 157:case 156:vh(e);break;case 159:case 160:Mb(e);break;case 210:MD(e);break;case 262:lg(e);break;case 261:dg(e)}uT=t}function TS(t){e.performance.mark("beforeCheck"),AS(t),e.performance.mark("afterCheck"),e.performance.measure("Check","beforeCheck","afterCheck")}function ES(t){switch(t){case 0:return!!xT.noUnusedLocals;case 1:return!!xT.noUnusedParameters;default:return e.Debug.assertNever(t)}}function NS(t){return NN.get(t.path)||e.emptyArray}function AS(t){var r=O(t);if(!(1&r.flags)){if(e.skipTypeChecking(t,xT))return;$k(t),e.clear(ZN),e.clear($N),e.forEach(t.statements,yS),yS(t.endOfFileToken),CS(t),e.isExternalOrCommonJsModule(t)&&Nx(t),t.isDeclarationFile||!xT.noUnusedLocals&&!xT.noUnusedParameters||Ax(NS(t),function(t,r,n){!e.containsParseError(t)&&ES(r)&&tA.add(n)}),e.isExternalOrCommonJsModule(t)&&mS(t),ZN.length&&(e.forEach(ZN,qx),e.clear(ZN)),$N.length&&(e.forEach($N,Wx),e.clear($N)),r.flags|=1}}function FS(e,t){try{return oT=t,PS(e)}finally{oT=void 0}}function PS(t){if(IS(),t){var r=tA.getGlobalDiagnostics(),n=r.length;TS(t);var i=tA.getDiagnostics(t.fileName),a=tA.getGlobalDiagnostics();if(a!==r){var s=e.relativeComplement(r,a,e.compareDiagnostics);return e.concatenate(s,i)}return 0===n&&a.length>0?e.concatenate(a,i):i}return e.forEach(o.getSourceFiles(),TS),tA.getDiagnostics()}function wS(){return IS(),tA.getGlobalDiagnostics()}function IS(){if(!l)throw new Error("Trying to get diagnostics from a type checker that does not produce them.")}function OS(t,r){function n(){for(;t;){switch(t.locals&&!M(t)&&a(t.locals,r),t.kind){case 285:if(!e.isExternalOrCommonJsModule(t))break;case 245:a(Ht(t).exports,2623475&r);break;case 244:a(Ht(t).exports,8&r);break;case 210:var n=t.name;n&&i(t.symbol,r);case 241:case 242:s||a(Ji(Ht(t)),67897832&r);break;case 197:var o=t.name;o&&i(t.symbol,r)}e.introducesArgumentsExoticObject(t)&&i(jT,r),s=e.hasModifier(t,32),t=t.parent}a(MT,r)}function i(t,r){if(e.getCombinedLocalAndExportSymbolFlags(t)&r){var n=t.escapedName;o.has(n)||o.set(n,t)}}function a(e,t){t&&e.forEach(function(e){i(e,t)})}if(8388608&t.flags)return[];var o=e.createSymbolTable(),s=!1;return n(),o.delete("this"),mo(o)}function MS(e){return 73===e.kind&&LS(e.parent)&&e.parent.name===e}function LS(e){switch(e.kind){case 151:case 241:case 242:case 243:case 244:return!0;default:return!1}}function RS(e){for(;149===e.parent.kind;)e=e.parent;return 165===e.parent.kind}function BS(e){for(;190===e.parent.kind;)e=e.parent;return 212===e.parent.kind}function jS(t,r){for(var n;;){if(t=e.getContainingClass(t),!t)break;if(n=r(t))break}return n}function JS(t){return!!e.findAncestor(t,function(t){return e.isConstructorDeclaration(t)&&e.nodeIsPresent(t.body)||e.isPropertyDeclaration(t)?!0:e.isClassLike(t)||e.isFunctionLikeDeclaration(t)?"quit":!1})}function zS(e,t){return!!jS(e,function(e){return e===t})}function VS(e){for(;149===e.parent.kind;)e=e.parent;return 249===e.parent.kind?e.parent.moduleReference===e?e.parent:void 0:255===e.parent.kind&&e.parent.expression===e?e.parent:void 0}function US(e){return void 0!==VS(e)}function KS(t){var r=e.getAssignmentDeclarationKind(t.parent.parent);switch(r){case 1:case 3:return Ht(t.parent);case 4:case 2:case 5:return Ht(t.parent.parent)}}function qS(t){for(var r=t.parent;e.isQualifiedName(r);)t=r,r=r.parent;return r&&184===r.kind&&r.qualifier===t?r:void 0}function WS(t){if(e.isDeclarationName(t))return Ht(t.parent);if(e.isInJSFile(t)&&190===t.parent.kind&&t.parent===t.parent.parent.left){var r=KS(t);if(r)return r}if(255===t.parent.kind&&e.isEntityNameExpression(t)){var n=kt(t,70107135,!0);if(n&&n!==XT)return n}else if(!e.isPropertyAccessExpression(t)&&US(t)){var i=e.getAncestor(t,249);return e.Debug.assert(void 0!==i),St(t,!0)}if(!e.isPropertyAccessExpression(t)){var a=qS(t);if(a){ju(a);var o=O(t).resolvedSymbol;return o===XT?void 0:o}}for(;e.isRightSideOfQualifiedNameOrPropertyAccess(t);)t=t.parent;if(BS(t)){var s=0;212===t.parent.kind?(s=67897832,e.isExpressionWithTypeArgumentsInClassExtendsClause(t.parent)&&(s|=67220415)):s=1920,s|=2097152;var c=e.isEntityNameExpression(t)?kt(t,s):void 0;if(c)return c}if(305===t.parent.kind)return e.getParameterSymbolFromJSDoc(t.parent);if(151===t.parent.kind&&309===t.parent.parent.kind){e.Debug.assert(!e.isInJSFile(t));var u=e.getTypeParameterFromJsDoc(t.parent);return u&&u.symbol}if(e.isExpressionNode(t)){if(e.nodeIsMissing(t))return void 0;if(73===t.kind){if(e.isJSXTagName(t)&&gg(t)){var l=Dg(t.parent);return l===XT?void 0:l}return kt(t,67220415,!1,!0)}if(190===t.kind||149===t.kind){var _=O(t);return _.resolvedSymbol?_.resolvedSymbol:(190===t.kind?Xg(t):Yg(t),_.resolvedSymbol)}}else if(RS(t)){var s=165===t.parent.kind?67897832:1920;return kt(t,s,!1,!0)}return 164===t.parent.kind?kt(t,1):void 0}function HS(t){if(285===t.kind)return e.isExternalModule(t)?Wt(t.symbol):void 0;var r=t.parent,n=r.parent;if(8388608&t.flags)return void 0;if(s(t)){var i=Ht(r);return e.isImportOrExportSpecifier(t.parent)&&t.parent.propertyName===t?sg(i):i}if(e.isLiteralComputedPropertyDeclarationName(t))return Ht(r.parent);if(73===t.kind){if(US(t))return WS(t);if(187===r.kind&&185===n.kind&&t===r.propertyName){var a=XS(n),o=ao(a,t.escapedText);if(o)return o}}switch(t.kind){case 73:case 190:case 149:return WS(t);case 101:var c=e.getThisContainer(t,!1);if(e.isFunctionLike(c)){var u=Co(c);if(u.thisParameter)return u.thisParameter}if(e.isInExpressionContext(t))return yb(t).symbol;case 179:return Bu(t).symbol;case 99:return yb(t).symbol;case 125:var l=t.parent;return l&&158===l.kind?l.parent.symbol:void 0;case 10:case 14:if(e.isExternalModuleImportEqualsDeclaration(t.parent.parent)&&e.getExternalModuleImportEqualsDeclarationExpression(t.parent.parent)===t||(250===t.parent.kind||256===t.parent.kind)&&t.parent.moduleSpecifier===t||e.isInJSFile(t)&&e.isRequireCall(t.parent,!1)||e.isImportCall(t.parent)||e.isLiteralTypeNode(t.parent)&&e.isLiteralImportTypeNode(t.parent.parent)&&t.parent.parent.argument===t.parent)return At(t,t);if(e.isCallExpression(r)&&e.isBindableObjectDefinePropertyCall(r)&&r.arguments[1]===t)return Ht(r);case 8:var _=e.isElementAccessExpression(r)?r.argumentExpression===t?gb(r.expression):void 0:e.isLiteralTypeNode(r)&&e.isIndexedAccessTypeNode(n)?ju(n.objectType):void 0;return _&&ao(_,e.escapeLeadingUnderscores(t.text));case 81:case 91:case 37:case 77:return Ht(t.parent);case 184:return e.isLiteralImportTypeNode(t)?HS(t.argument.literal):void 0;case 86:return e.isExportAssignment(t.parent)?e.Debug.assertDefined(t.parent.symbol):void 0;default:return void 0}}function GS(e){return e&&277===e.kind?kt(e.name,69317567):void 0}function QS(e){return e.parent.parent.moduleSpecifier?dt(e.parent.parent,e):kt(e.propertyName||e.name,70107135)}function XS(t){if(8388608&t.flags)return tE;var r=e.tryGetClassImplementingOrExtendingExpressionWithTypeArguments(t),n=r&&li(Ht(r.class));if(e.isPartOfTypeNode(t)){var i=ju(t);return n?Vi(i,n.thisType):i}if(e.isExpressionNode(t))return $S(t);if(n&&!r.isImplements){var a=e.firstOrUndefined(ii(n));return a?Vi(a,n.thisType):tE}if(LS(t)){var o=Ht(t);return bi(o)}if(MS(t)){var o=HS(t);return o?bi(o):tE}if(e.isDeclaration(t)){var o=Ht(t);return Un(o)}if(s(t)){var o=HS(t);return o?Un(o):tE}if(e.isBindingPattern(t))return _n(t.parent,!0)||tE;if(US(t)){var o=HS(t);if(o){var c=bi(o);return c!==tE?c:Un(o)}}return tE}function YS(t){if(e.Debug.assert(189===t.kind||188===t.kind),228===t.parent.kind){var r=dD(t.parent.expression,t.parent.awaitModifier);return Vh(t,r||tE)}if(205===t.parent.kind){var r=gb(t.parent.right);return Vh(t,r||tE)}if(276===t.parent.kind){var n=e.cast(t.parent.parent,e.isObjectLiteralExpression),i=YS(n)||tE,a=e.indexOfNode(n.properties,t.parent);
return jh(n,i,a)}var o=e.cast(t.parent,e.isArrayLiteralExpression),s=YS(o)||tE,c=pD(s,t.parent,!1,!1)||tE;return zh(o,s,o.elements.indexOf(t),c)}function ZS(t){var r=YS(e.cast(t.parent.parent,e.isAssignmentPattern));return r&&ao(r,t.escapedText)}function $S(t){return e.isRightSideOfQualifiedNameOrPropertyAccess(t)&&(t=t.parent),Pu(gb(t))}function eC(t){var r=Ht(t.parent);return e.hasModifier(t,32)?Un(r):bi(r)}function tC(t){var r=t.name;switch(r.kind){case 73:return Iu(e.idText(r));case 8:case 10:return Iu(r.text);case 150:var n=ag(r);return wh(n,12288)?n:sE;default:return e.Debug.fail("Unsupported property name."),tE}}function rC(t){t=to(t);var r=e.createSymbolTable(Pa(t)),n=so(t,0).length?VE:so(t,1).length?UE:void 0;return n&&e.forEach(Pa(n),function(e){r.has(e.escapedName)||r.set(e.escapedName,e)}),cr(r)}function nC(t){return e.typeHasCallOrConstructSignatures(t,zT)}function iC(t){var r=aC(t);return r?e.flatMap(r,iC):[t]}function aC(t){if(6&e.getCheckFlags(t))return e.mapDefined(I(t).containingType.types,function(e){return ao(e,t.escapedName)});if(33554432&t.flags){var r=t,n=r.leftSpread,i=r.rightSpread,a=r.syntheticOrigin;return n?[n,i]:a?[a]:e.singleElementArray(oC(t))}return void 0}function oC(e){for(var t,r=e;r=I(r).target;)t=r;return t}function sC(t){if(!e.isGeneratedIdentifier(t)){var r=e.getParseTreeNode(t,e.isIdentifier);if(r){var n=190===r.parent.kind&&r.parent.name===r;return!n&&LC(r)===jT}}return!1}function cC(t){function r(e){return e=ht(e),e&&!!(67220415&e.flags)}var n=At(t.parent,t);if(!n||e.isShorthandAmbientModuleSymbol(n))return!0;var i=Rt(n);n=Ot(n);var a=I(n);return void 0===a.exportsSomeValue&&(a.exportsSomeValue=i?!!(67220415&n.flags):e.forEachEntry(Ut(n),r)),a.exportsSomeValue}function uC(t){return e.isModuleOrEnumDeclaration(t.parent)&&t===t.parent.name}function lC(t,r){var n=e.getParseTreeNode(t,e.isIdentifier);if(n){var i=LC(n,uC(n));if(i){if(1048576&i.flags){var a=Wt(i.exportSymbol);if(!r&&944&a.flags&&!(3&a.flags))return void 0;i=a}var o=Gt(i);if(o){if(512&o.flags&&285===o.valueDeclaration.kind){var s=o.valueDeclaration,c=e.getSourceFileOfNode(n),u=s!==c;return u?void 0:s}return e.findAncestor(n.parent,function(t){return e.isModuleOrEnumDeclaration(t)&&Ht(t)===o})}}}}function _C(t){var r=e.getParseTreeNode(t,e.isIdentifier);if(r){var n=LC(r);if(yt(n,67220415))return rt(n)}return void 0}function dC(t){return e.isBindingElement(t.valueDeclaration)&&275===e.walkUpBindingElementsAndPatterns(t.valueDeclaration).parent.kind}function pC(t){if(418&t.flags&&!e.isSourceFile(t.valueDeclaration)){var r=I(t);if(void 0===r.isDeclarationWithCollidingName){var n=e.getEnclosingBlockScopeContainer(t.valueDeclaration);if(e.isStatementWithLocals(n)||dC(t)){var i=O(t.valueDeclaration);if(j(n.parent,t.escapedName,67220415,void 0,void 0,!1))r.isDeclarationWithCollidingName=!0;else if(262144&i.flags){var a=524288&i.flags,o=e.isIterationStatement(n,!1),s=219===n.kind&&e.isIterationStatement(n.parent,!1);r.isDeclarationWithCollidingName=!(e.isBlockScopedContainerTopLevel(n)||a&&(o||s))}else r.isDeclarationWithCollidingName=!1}}return r.isDeclarationWithCollidingName}return!1}function fC(t){if(!e.isGeneratedIdentifier(t)){var r=e.getParseTreeNode(t,e.isIdentifier);if(r){var n=LC(r);if(n&&pC(n))return n.valueDeclaration}}return void 0}function mC(t){var r=e.getParseTreeNode(t,e.isDeclaration);if(r){var n=Ht(r);if(n)return pC(n)}return!1}function gC(t){switch(t.kind){case 249:case 251:case 252:case 254:case 258:return yC(Ht(t)||XT);case 256:var r=t.exportClause;return!!r&&e.some(r.elements,gC);case 255:return t.expression&&73===t.expression.kind?yC(Ht(t)||XT):!0}return!1}function vC(t){var r=e.getParseTreeNode(t,e.isImportEqualsDeclaration);if(void 0===r||285!==r.parent.kind||!e.isInternalModuleImportEqualsDeclaration(r))return!1;var n=yC(Ht(r));return n&&r.moduleReference&&!e.nodeIsMissing(r.moduleReference)}function yC(e){var t=bt(e);return t===XT?!0:!!(67220415&t.flags)&&(xT.preserveConstEnums||!hC(t))}function hC(e){return Mh(e)||!!e.constEnumOnlyModule}function bC(t,r){if(e.isAliasSymbolDeclaration(t)){var n=Ht(t);if(n&&I(n).referenced)return!0;var i=I(n).target;if(i&&1&e.getModifierFlags(t)&&67220415&i.flags&&(xT.preserveConstEnums||!hC(i)))return!0}return r?!!e.forEachChild(t,function(e){return bC(e,r)}):!1}function xC(t){if(e.nodeIsPresent(t.body)){if(e.isGetAccessor(t)||e.isSetAccessor(t))return!1;var r=Ht(t),n=Ao(r);return n.length>1||1===n.length&&n[0].declaration!==t}return!1}function DC(t){return!(!kT||yo(t)||e.isJSDocParameterTag(t)||!t.initializer||e.hasModifier(t,92))}function SC(t){return kT&&yo(t)&&!t.initializer&&e.hasModifier(t,92)}function CC(t){var r=e.getParseTreeNode(t,e.isFunctionDeclaration);if(!r)return!1;var n=Ht(r);return n&&16&n.flags?!!e.forEachEntry(Vt(n),function(t){return 67220415&t.flags&&e.isPropertyAccessExpression(t.valueDeclaration)}):!1}function kC(t){var r=e.getParseTreeNode(t,e.isFunctionDeclaration);if(!r)return e.emptyArray;var n=Ht(r);return n&&Pa(Un(n))||e.emptyArray}function TC(e){return O(e).flags||0}function EC(e){return QD(e.parent),O(e).enumMemberValue}function NC(e){switch(e.kind){case 279:case 190:case 191:return!0}return!1}function AC(t){if(279===t.kind)return EC(t);var r=O(t).resolvedSymbol;if(r&&8&r.flags){var n=r.valueDeclaration;if(e.isEnumConst(n.parent))return EC(n)}return void 0}function FC(e){return!!(524288&e.flags)&&so(e,0).length>0}function PC(t,r){var n=e.getParseTreeNode(t,e.isEntityName);if(!n)return e.TypeReferenceSerializationKind.Unknown;if(r&&(r=e.getParseTreeNode(r),!r))return e.TypeReferenceSerializationKind.Unknown;var i=kt(n,67220415,!0,!1,r),a=kt(n,67897832,!0,!1,r);if(i&&i===a){var o=Js(!1);if(o&&i===o)return e.TypeReferenceSerializationKind.Promise;var s=Un(i);if(s&&$n(s))return e.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue}if(!a)return e.TypeReferenceSerializationKind.Unknown;var c=bi(a);return c===tE?e.TypeReferenceSerializationKind.Unknown:3&c.flags?e.TypeReferenceSerializationKind.ObjectType:wh(c,245760)?e.TypeReferenceSerializationKind.VoidNullableOrNeverType:wh(c,528)?e.TypeReferenceSerializationKind.BooleanType:wh(c,296)?e.TypeReferenceSerializationKind.NumberLikeType:wh(c,2112)?e.TypeReferenceSerializationKind.BigIntLikeType:wh(c,132)?e.TypeReferenceSerializationKind.StringLikeType:td(c)?e.TypeReferenceSerializationKind.ArrayLikeType:wh(c,12288)?e.TypeReferenceSerializationKind.ESSymbolType:FC(c)?e.TypeReferenceSerializationKind.TypeWithCallSignature:J_(c)?e.TypeReferenceSerializationKind.ArrayLikeType:e.TypeReferenceSerializationKind.ObjectType}function wC(t,r,n,i,a){var o=e.getParseTreeNode(t,e.isVariableLikeOrAccessor);if(!o)return e.createToken(121);var s=Ht(o),c=!s||133120&s.flags?tE:Z_(Un(s));return 8192&c.flags&&c.symbol===s&&(n|=1048576),a&&(c=dd(c)),OT.typeToTypeNode(c,r,1024|n,i)}function IC(t,r,n,i){var a=e.getParseTreeNode(t,e.isFunctionLike);if(!a)return e.createToken(121);var o=Co(a);return OT.typeToTypeNode(Mo(o),r,1024|n,i)}function OC(t,r,n,i){var a=e.getParseTreeNode(t,e.isExpression);if(!a)return e.createToken(121);var o=Td($S(a));return OT.typeToTypeNode(o,r,1024|n,i)}function MC(t){return MT.has(e.escapeLeadingUnderscores(t))}function LC(t,r){var n=O(t).resolvedSymbol;if(n)return n;var i=t;if(r){var a=t.parent;e.isDeclaration(a)&&t===a.name&&(i=qr(a))}return j(i,t.escapedText,70366143,void 0,void 0,!0)}function RC(t){if(!e.isGeneratedIdentifier(t)){var r=e.getParseTreeNode(t,e.isIdentifier);if(r){var n=LC(r);if(n)return Zt(n).valueDeclaration}}return void 0}function BC(t){return e.isDeclarationReadonly(t)||e.isVariableDeclaration(t)&&e.isVarConst(t)?wu(Un(Ht(t))):!1}function jC(t,r,n){var i=1024&t.flags?OT.symbolToExpression(t.symbol,67220415,r,void 0,n):t===dE?e.createTrue():t===lE&&e.createFalse();return i||e.createLiteral(t.value)}function JC(e,t){var r=Un(Ht(e));return jC(r,e,t)}function zC(){function t(e){return e.parent&&212===e.parent.kind&&e.parent.parent&&274===e.parent.parent.kind}function r(e){if(!s)return void 0;var r=67899368;(73===e.kind&&fp(e)||190===e.kind&&!t(e))&&(r=68268991);var i=kt(e,r,!0);return i&&i!==XT?n(i,r):void 0}function n(t,r){if(!s)return void 0;if(!i(t))return void 0;for(var n,a=0,o=t.declarations;a<o.length;a++){var c=o[a];if(c.symbol&&c.symbol.flags&r){var u=e.getSourceFileOfNode(c),l=s.get(u.path);if(!l)return void 0;(n||(n=[])).push(l)}}return n}function i(t){if(!t.declarations)return!1;for(var r=t;;){var n=Gt(r);if(!n)break;r=n}if(r.valueDeclaration&&285===r.valueDeclaration.kind&&512&r.flags)return!1;for(var i=0,a=t.declarations;i<a.length;i++){var o=a[i],c=e.getSourceFileOfNode(o);if(s.has(c.path))return!0}return!1}function a(t,r){if(!s.has(t.path)){s.set(t.path,r);for(var n=0,i=t.referencedFiles;n<i.length;n++){var c=i[n].fileName,u=e.resolveTripleslashReference(c,t.originalFileName),l=o.getSourceFile(u);l&&a(l,r)}}}var s,c=o.getResolvedTypeReferenceDirectives();return c&&(s=e.createMap(),c.forEach(function(e,t){if(e&&e.resolvedFileName){var r=o.getSourceFile(e.resolvedFileName);a(r,t)}})),{getReferencedExportContainer:lC,getReferencedImportDeclaration:_C,getReferencedDeclarationWithCollidingName:fC,isDeclarationWithCollidingName:mC,isValueAliasDeclaration:function(t){return t=e.getParseTreeNode(t),t?gC(t):!0},hasGlobalName:MC,isReferencedAliasDeclaration:function(t,r){return t=e.getParseTreeNode(t),t?bC(t,r):!0},getNodeCheckFlags:function(t){return t=e.getParseTreeNode(t),t?TC(t):0},isTopLevelValueImportEqualsWithEntityName:vC,isDeclarationVisible:jr,isImplementationOfOverload:xC,isRequiredInitializedParameter:DC,isOptionalUninitializedParameterProperty:SC,isExpandoFunctionDeclaration:CC,getPropertiesOfContainerFunction:kC,createTypeOfDeclaration:wC,createReturnTypeOfSignatureDeclaration:IC,createTypeOfExpression:OC,createLiteralConstValue:JC,isSymbolAccessible:hr,isEntityNameVisible:Cr,getConstantValue:function(t){var r=e.getParseTreeNode(t,NC);return r?AC(r):void 0},collectLinkedAliases:Jr,getReferencedValueDeclaration:RC,getTypeReferenceSerializationKind:PC,isOptionalParameter:yo,moduleExportsSomeValue:cC,isArgumentsLocalBinding:sC,getExternalModuleFileFromDeclaration:VC,getTypeReferenceDirectivesForEntityName:r,getTypeReferenceDirectivesForSymbol:n,isLiteralConstDeclaration:BC,isLateBound:function(t){var r=e.getParseTreeNode(t,e.isDeclaration),n=r&&Ht(r);return!!(n&&4096&e.getCheckFlags(n))},getJsxFactoryEntity:function(t){return t?(m(t),e.getSourceFileOfNode(t).localJsxFactory||iA):iA},getAllAccessorDeclarations:function(t){t=e.getParseTreeNode(t,e.isGetOrSetAccessorDeclaration);var r=160===t.kind?159:160,n=e.getDeclarationOfKind(Ht(t),r),i=n&&n.pos<t.pos?n:t,a=n&&n.pos<t.pos?t:n,o=160===t.kind?t:n,s=159===t.kind?t:n;return{firstAccessor:i,secondAccessor:a,setAccessor:o,getAccessor:s}},getSymbolOfExternalModuleSpecifier:function(e){return Ft(e,e,void 0)},isBindingCapturedByNode:function(t,r){var n=e.getParseTreeNode(t),i=e.getParseTreeNode(r);return!!n&&!!i&&(e.isVariableDeclaration(i)||e.isBindingElement(i))&&qf(n,i)}}}function VC(t){var r=245===t.kind?e.tryCast(t.name,e.isStringLiteral):e.getExternalModuleName(t),n=Ft(r,r,void 0);return n?e.getDeclarationOfKind(n,285):void 0}function UC(){for(var t=0,r=o.getSourceFiles();t<r.length;t++){var n=r[t];e.bindSourceFile(n,xT)}LE=e.createMap();for(var i,a=0,s=o.getSourceFiles();a<s.length;a++){var n=s[a];if(!n.redirectInfo){if(!e.isExternalOrCommonJsModule(n)){var c=n.locals.get("globalThis");if(c)for(var u=0,l=c.declarations;u<l.length;u++){var _=l[u];tA.add(e.createDiagnosticForNode(_,e.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0,"globalThis"))}F(MT,n.locals)}if(n.jsGlobalAugmentations&&F(MT,n.jsGlobalAugmentations),n.patternAmbientModules&&n.patternAmbientModules.length&&(BE=e.concatenate(BE,n.patternAmbientModules)),n.moduleAugmentations.length&&(i||(i=[])).push(n.moduleAugmentations),n.symbol&&n.symbol.globalExports){var d=n.symbol.globalExports;d.forEach(function(e,t){MT.has(t)||MT.set(t,e)})}}}if(i)for(var p=0,f=i;p<f.length;p++)for(var m=f[p],g=0,v=m;g<v.length;g++){var y=v[g];e.isGlobalScopeAugmentation(y.parent)&&P(y)}if(w(MT,CA,e.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0),I(LT).type=iE,I(jT).type=ws("IArguments",0,!0),I(XT).type=tE,I(RT).type=ir(16,RT),KE=ws("Array",1,!0),JE=ws("Object",0,!0),zE=ws("Function",0,!0),VE=ET&&ws("CallableFunction",0,!0)||zE,UE=ET&&ws("NewableFunction",0,!0)||zE,WE=ws("String",0,!0),HE=ws("Number",0,!0),GE=ws("Boolean",0,!0),QE=ws("RegExp",0,!0),YE=ic(ZT),ZE=ic($T),ZE===kE&&(ZE=lr(void 0,hT,e.emptyArray,e.emptyArray,void 0,void 0)),qE=Gs("ReadonlyArray",1)||KE,$E=qE?Zs(qE,[ZT]):YE,XE=Gs("ThisType",1),i)for(var h=0,b=i;h<b.length;h++)for(var m=b[h],x=0,D=m;x<D.length;x++){var y=D[x];e.isGlobalScopeAugmentation(y.parent)||P(y)}LE.forEach(function(t){var r=t.firstFile,n=t.secondFile,i=t.conflictingSymbols;if(i.size<8)i.forEach(function(t,r){for(var n=t.isBlockScoped,i=t.firstFileLocations,a=t.secondFileLocations,o=n?e.Diagnostics.Cannot_redeclare_block_scoped_variable_0:e.Diagnostics.Duplicate_identifier_0,s=0,c=i;s<c.length;s++){var u=c[s];N(u,o,r,a)}for(var l=0,_=a;l<_.length;l++){var u=_[l];N(u,o,r,i)}});else{var a=e.arrayFrom(i.keys()).join(", ");tA.add(e.addRelatedInfo(e.createDiagnosticForNode(r,e.Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0,a),e.createDiagnosticForNode(n,e.Diagnostics.Conflicts_are_in_this_file))),tA.add(e.addRelatedInfo(e.createDiagnosticForNode(n,e.Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0,a),e.createDiagnosticForNode(r,e.Diagnostics.Conflicts_are_in_this_file)))}}),LE=void 0}function KC(t,r){if((sT&r)!==r&&xT.importHelpers){var n=e.getSourceFileOfNode(t);if(e.isEffectiveExternalModule(n,xT)&&!(4194304&t.flags)){var i=WC(n,t);if(i!==XT)for(var a=r&~sT,o=1;65536>=o;o<<=1)if(a&o){var s=qC(o),c=L(i.exports,e.escapeLeadingUnderscores(s),67220415);c||y(t,e.Diagnostics.This_syntax_requires_an_imported_helper_named_1_but_module_0_has_no_exported_member_1,e.externalHelpersModuleNameText,s)}sT|=r}}}function qC(t){switch(t){case 1:return"__extends";case 2:return"__assign";case 4:return"__rest";case 8:return"__decorate";case 16:return"__metadata";case 32:return"__param";case 64:return"__awaiter";case 128:return"__generator";case 256:return"__values";case 512:return"__read";case 1024:return"__spread";case 2048:return"__await";case 4096:return"__asyncGenerator";case 8192:return"__asyncDelegator";case 16384:return"__asyncValues";case 32768:return"__exportStar";case 65536:return"__makeTemplateObject";default:return e.Debug.fail("Unrecognized helper")}}function WC(t,r){return cT||(cT=Pt(t,e.externalHelpersModuleNameText,e.Diagnostics.This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found,r)||XT),cT}function HC(e){return GC(e)||QC(e)}function GC(t){if(!t.decorators)return!1;if(!e.nodeCanBeDecorated(t,t.parent,t.parent.parent))return 157!==t.kind||e.nodeIsPresent(t.body)?qk(t,e.Diagnostics.Decorators_are_not_valid_here):qk(t,e.Diagnostics.A_decorator_can_only_decorate_a_method_implementation_not_an_overload);if(159===t.kind||160===t.kind){var r=e.getAllAccessorDeclarations(t.parent.members,t);if(r.firstAccessor.decorators&&t===r.secondAccessor)return qk(t,e.Diagnostics.Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name)}return!1}function QC(t){var r=XC(t);if(void 0!==r)return r;for(var n,i,a,o,s=0,c=0,u=t.modifiers;c<u.length;c++){var l=u[c];if(134!==l.kind){if(154===t.kind||156===t.kind)return Hk(l,e.Diagnostics._0_modifier_cannot_appear_on_a_type_member,e.tokenToString(l.kind));if(163===t.kind)return Hk(l,e.Diagnostics._0_modifier_cannot_appear_on_an_index_signature,e.tokenToString(l.kind))}switch(l.kind){case 78:if(244!==t.kind)return Hk(t,e.Diagnostics.A_class_member_cannot_have_the_0_keyword,e.tokenToString(78));break;case 116:case 115:case 114:var _=Ir(e.modifierToFlag(l.kind));if(28&s)return Hk(l,e.Diagnostics.Accessibility_modifier_already_seen);if(32&s)return Hk(l,e.Diagnostics._0_modifier_must_precede_1_modifier,_,"static");if(64&s)return Hk(l,e.Diagnostics._0_modifier_must_precede_1_modifier,_,"readonly");if(256&s)return Hk(l,e.Diagnostics._0_modifier_must_precede_1_modifier,_,"async");if(246===t.parent.kind||285===t.parent.kind)return Hk(l,e.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element,_);if(128&s)return 114===l.kind?Hk(l,e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier,_,"abstract"):Hk(l,e.Diagnostics._0_modifier_must_precede_1_modifier,_,"abstract");s|=e.modifierToFlag(l.kind);break;case 117:if(32&s)return Hk(l,e.Diagnostics._0_modifier_already_seen,"static");if(64&s)return Hk(l,e.Diagnostics._0_modifier_must_precede_1_modifier,"static","readonly");if(256&s)return Hk(l,e.Diagnostics._0_modifier_must_precede_1_modifier,"static","async");if(246===t.parent.kind||285===t.parent.kind)return Hk(l,e.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element,"static");if(152===t.kind)return Hk(l,e.Diagnostics._0_modifier_cannot_appear_on_a_parameter,"static");if(128&s)return Hk(l,e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier,"static","abstract");s|=32,n=l;break;case 134:if(64&s)return Hk(l,e.Diagnostics._0_modifier_already_seen,"readonly");if(155!==t.kind&&154!==t.kind&&163!==t.kind&&152!==t.kind)return Hk(l,e.Diagnostics.readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature);s|=64,o=l;break;case 86:if(1&s)return Hk(l,e.Diagnostics._0_modifier_already_seen,"export");if(2&s)return Hk(l,e.Diagnostics._0_modifier_must_precede_1_modifier,"export","declare");if(128&s)return Hk(l,e.Diagnostics._0_modifier_must_precede_1_modifier,"export","abstract");if(256&s)return Hk(l,e.Diagnostics._0_modifier_must_precede_1_modifier,"export","async");if(241===t.parent.kind)return Hk(l,e.Diagnostics._0_modifier_cannot_appear_on_a_class_element,"export");if(152===t.kind)return Hk(l,e.Diagnostics._0_modifier_cannot_appear_on_a_parameter,"export");s|=1;break;case 81:var d=285===t.parent.kind?t.parent:t.parent.parent;if(245===d.kind&&!e.isAmbientModule(d))return Hk(l,e.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);s|=512;break;case 126:if(2&s)return Hk(l,e.Diagnostics._0_modifier_already_seen,"declare");if(256&s)return Hk(l,e.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context,"async");if(241===t.parent.kind)return Hk(l,e.Diagnostics._0_modifier_cannot_appear_on_a_class_element,"declare");if(152===t.kind)return Hk(l,e.Diagnostics._0_modifier_cannot_appear_on_a_parameter,"declare");if(4194304&t.parent.flags&&246===t.parent.kind)return Hk(l,e.Diagnostics.A_declare_modifier_cannot_be_used_in_an_already_ambient_context);s|=2,i=l;break;case 119:if(128&s)return Hk(l,e.Diagnostics._0_modifier_already_seen,"abstract");if(241!==t.kind){if(157!==t.kind&&155!==t.kind&&159!==t.kind&&160!==t.kind)return Hk(l,e.Diagnostics.abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration);if(241!==t.parent.kind||!e.hasModifier(t.parent,128))return Hk(l,e.Diagnostics.Abstract_methods_can_only_appear_within_an_abstract_class);if(32&s)return Hk(l,e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier,"static","abstract");if(8&s)return Hk(l,e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier,"private","abstract")}s|=128;break;case 122:if(256&s)return Hk(l,e.Diagnostics._0_modifier_already_seen,"async");if(2&s||4194304&t.parent.flags)return Hk(l,e.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context,"async");if(152===t.kind)return Hk(l,e.Diagnostics._0_modifier_cannot_appear_on_a_parameter,"async");s|=256,a=l}}return 158===t.kind?32&s?Hk(n,e.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration,"static"):128&s?Hk(n,e.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration,"abstract"):256&s?Hk(a,e.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration,"async"):64&s?Hk(o,e.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration,"readonly"):!1:(250===t.kind||249===t.kind)&&2&s?Hk(i,e.Diagnostics.A_0_modifier_cannot_be_used_with_an_import_declaration,"declare"):152===t.kind&&92&s&&e.isBindingPattern(t.name)?Hk(t,e.Diagnostics.A_parameter_property_may_not_be_declared_using_a_binding_pattern):152===t.kind&&92&s&&t.dotDotDotToken?Hk(t,e.Diagnostics.A_parameter_property_cannot_be_declared_using_a_rest_parameter):256&s?$C(t,a):!1}function XC(t){return t.modifiers?YC(t)?qk(t,e.Diagnostics.Modifiers_cannot_appear_here):void 0:!1}function YC(t){switch(t.kind){case 159:case 160:case 158:case 155:case 154:case 157:case 156:case 163:case 245:case 250:case 249:case 256:case 255:case 197:case 198:case 152:return!1;default:if(246===t.parent.kind||285===t.parent.kind)return!1;switch(t.kind){case 240:return ZC(t,122);case 241:return ZC(t,119);case 242:case 220:case 243:return!0;case 244:return ZC(t,78);default:return e.Debug.fail(),!1}}}function ZC(e,t){return e.modifiers.length>1||e.modifiers[0].kind!==t}function $C(t,r){switch(t.kind){case 157:case 240:case 197:case 198:return!1}return Hk(r,e.Diagnostics._0_modifier_cannot_be_used_here,"async")}function ek(t,r){return void 0===r&&(r=e.Diagnostics.Trailing_comma_not_allowed),t&&t.hasTrailingComma?Wk(t[0],t.end-",".length,",".length,r):!1}function tk(t,r){if(t&&0===t.length){var n=t.pos-"<".length,i=e.skipTrivia(r.text,t.end)+">".length;return Wk(r,n,i-n,e.Diagnostics.Type_parameter_list_cannot_be_empty)}return!1}function rk(t){for(var r=!1,n=t.length,i=0;n>i;i++){var a=t[i];if(a.dotDotDotToken){if(i!==n-1)return Hk(a.dotDotDotToken,e.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);if(4194304&a.flags||ek(t,e.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma),a.questionToken)return Hk(a.questionToken,e.Diagnostics.A_rest_parameter_cannot_be_optional);if(a.initializer)return Hk(a.name,e.Diagnostics.A_rest_parameter_cannot_have_an_initializer)}else if(a.questionToken){if(r=!0,a.initializer)return Hk(a.name,e.Diagnostics.Parameter_cannot_have_question_mark_and_initializer)}else if(r&&!a.initializer)return Hk(a.name,e.Diagnostics.A_required_parameter_cannot_follow_an_optional_parameter)}}function nk(t){return e.filter(t,function(t){return!!t.initializer||e.isBindingPattern(t.name)||e.isRestParameter(t)})}function ik(t){if(DT>=3){var r=t.body&&e.isBlock(t.body)&&e.findUseStrictPrologue(t.body.statements);if(r){var n=nk(t.parameters);if(e.length(n)){e.forEach(n,function(t){e.addRelatedInfo(y(t,e.Diagnostics.This_parameter_is_not_allowed_with_use_strict_directive),e.createDiagnosticForNode(r,e.Diagnostics.use_strict_directive_used_here))});var i=n.map(function(t,r){return 0===r?e.createDiagnosticForNode(t,e.Diagnostics.Non_simple_parameter_declared_here):e.createDiagnosticForNode(t,e.Diagnostics.and_here)});return e.addRelatedInfo.apply(void 0,[y(r,e.Diagnostics.use_strict_directive_cannot_be_used_with_non_simple_parameter_list)].concat(i)),!0}}}return!1}function ak(t){var r=e.getSourceFileOfNode(t);return HC(t)||tk(t.typeParameters,r)||rk(t.parameters)||sk(t,r)||e.isFunctionLikeDeclaration(t)&&ik(t)}function ok(t){var r=e.getSourceFileOfNode(t);return gk(t)||tk(t.typeParameters,r)}function sk(t,r){if(!e.isArrowFunction(t))return!1;var n=t.equalsGreaterThanToken,i=e.getLineAndCharacterOfPosition(r,n.pos).line,a=e.getLineAndCharacterOfPosition(r,n.end).line;return i!==a&&Hk(n,e.Diagnostics.Line_terminator_not_permitted_before_arrow)}function ck(t){var r=t.parameters[0];if(1!==t.parameters.length)return r?Hk(r.name,e.Diagnostics.An_index_signature_must_have_exactly_one_parameter):Hk(t,e.Diagnostics.An_index_signature_must_have_exactly_one_parameter);if(r.dotDotDotToken)return Hk(r.dotDotDotToken,e.Diagnostics.An_index_signature_cannot_have_a_rest_parameter);if(e.hasModifiers(r))return Hk(r.name,e.Diagnostics.An_index_signature_parameter_cannot_have_an_accessibility_modifier);if(r.questionToken)return Hk(r.questionToken,e.Diagnostics.An_index_signature_parameter_cannot_have_a_question_mark);if(r.initializer)return Hk(r.name,e.Diagnostics.An_index_signature_parameter_cannot_have_an_initializer);if(!r.type)return Hk(r.name,e.Diagnostics.An_index_signature_parameter_must_have_a_type_annotation);if(139!==r.type.kind&&136!==r.type.kind){var n=ju(r.type);return 4&n.flags||8&n.flags?Hk(r.name,e.Diagnostics.An_index_signature_parameter_type_cannot_be_a_type_alias_Consider_writing_0_Colon_1_Colon_2_instead,e.getTextOfNode(r.name),Er(n),Er(t.type?ju(t.type):ZT)):1048576&n.flags&&Ih(n,128,!0)?Hk(r.name,e.Diagnostics.An_index_signature_parameter_type_cannot_be_a_union_type_Consider_using_a_mapped_object_type_instead):Hk(r.name,e.Diagnostics.An_index_signature_parameter_type_must_be_string_or_number)}return t.type?!1:Hk(t,e.Diagnostics.An_index_signature_must_have_a_type_annotation)}function uk(e){return HC(e)||ck(e)}function lk(t,r){if(r&&0===r.length){var n=e.getSourceFileOfNode(t),i=r.pos-"<".length,a=e.skipTrivia(n.text,r.end)+">".length;return Wk(n,i,a-i,e.Diagnostics.Type_argument_list_cannot_be_empty)}return!1}function _k(e,t){return ek(t)||lk(e,t)}function dk(t){if(t)for(var r=0,n=t;r<n.length;r++){var i=n[r];if(211===i.kind)return Wk(i,i.pos,0,e.Diagnostics.Argument_expression_expected)}return!1}function pk(e){return dk(e)}function fk(t){var r=t.types;if(ek(r))return!0;if(r&&0===r.length){var n=e.tokenToString(t.token);return Wk(t,r.pos,0,e.Diagnostics._0_list_cannot_be_empty,n)}return e.some(r,mk)}function mk(e){return _k(e,e.typeArguments)}function gk(t){var r=!1,n=!1;if(!HC(t)&&t.heritageClauses)for(var i=0,a=t.heritageClauses;i<a.length;i++){var o=a[i];if(87===o.token){if(r)return qk(o,e.Diagnostics.extends_clause_already_seen);if(n)return qk(o,e.Diagnostics.extends_clause_must_precede_implements_clause);if(o.types.length>1)return qk(o.types[1],e.Diagnostics.Classes_can_only_extend_a_single_class);r=!0}else{if(e.Debug.assert(110===o.token),n)return qk(o,e.Diagnostics.implements_clause_already_seen);n=!0}fk(o)}}function vk(t){var r=!1;if(t.heritageClauses)for(var n=0,i=t.heritageClauses;n<i.length;n++){var a=i[n];if(87!==a.token)return e.Debug.assert(110===a.token),qk(a,e.Diagnostics.Interface_declaration_cannot_have_implements_clause);if(r)return qk(a,e.Diagnostics.extends_clause_already_seen);r=!0,fk(a)}return!1}function yk(t){if(150!==t.kind)return!1;var r=t;return 205===r.expression.kind&&27===r.expression.operatorToken.kind?Hk(r.expression,e.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name):!1}function hk(t){if(t.asteriskToken){if(e.Debug.assert(240===t.kind||197===t.kind||157===t.kind),4194304&t.flags)return Hk(t.asteriskToken,e.Diagnostics.Generators_are_not_allowed_in_an_ambient_context);if(!t.body)return Hk(t.asteriskToken,e.Diagnostics.An_overload_signature_cannot_be_declared_as_a_generator)}}function bk(e,t){return!!e&&Hk(e,t)}function xk(e,t){return!!e&&Hk(e,t)}function Dk(t,r){var n;!function(e){e[e.Property=1]="Property",e[e.GetAccessor=2]="GetAccessor",e[e.SetAccessor=4]="SetAccessor",e[e.GetOrSetAccessor=6]="GetOrSetAccessor"}(n||(n={}));for(var i=e.createUnderscoreEscapedMap(),a=0,o=t.properties;a<o.length;a++){var s=o[a];if(278!==s.kind){var c=s.name;if(150===c.kind&&yk(c),277===s.kind&&!r&&s.objectAssignmentInitializer)return Hk(s.equalsToken,e.Diagnostics.can_only_be_used_in_an_object_literal_property_inside_a_destructuring_assignment);if(s.modifiers)for(var u=0,l=s.modifiers;u<l.length;u++){var _=l[u];(122!==_.kind||157!==s.kind)&&Hk(_,e.Diagnostics._0_modifier_cannot_be_used_here,e.getTextOfNode(_))}var d=void 0;switch(s.kind){case 277:xk(s.exclamationToken,e.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context);case 276:bk(s.questionToken,e.Diagnostics.An_object_member_cannot_be_declared_optional),8===c.kind&&tT(c);case 157:d=1;break;case 159:d=2;break;case 160:d=4;break;default:throw e.Debug.assertNever(s,"Unexpected syntax kind:"+s.kind)}var p=e.getPropertyNameForPropertyNameNode(c);if(void 0!==p){var f=i.get(p);if(f)if(1===d&&1===f)Hk(c,e.Diagnostics.Duplicate_identifier_0,e.getTextOfNode(c));else{if(!(6&d&&6&f))return Hk(c,e.Diagnostics.An_object_literal_cannot_have_property_and_accessor_with_the_same_name);if(6===f||d===f)return Hk(c,e.Diagnostics.An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name);i.set(p,d|f)}else i.set(p,d)}}else if(r){var m=e.skipParentheses(s.expression);if(e.isArrayLiteralExpression(m)||e.isObjectLiteralExpression(m))return Hk(s.expression,e.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern)}}}function Sk(t){_k(t,t.typeArguments);for(var r=e.createUnderscoreEscapedMap(),n=0,i=t.attributes.properties;n<i.length;n++){var a=i[n];if(270!==a.kind){var o=a.name,s=a.initializer;if(r.get(o.escapedText))return Hk(o,e.Diagnostics.JSX_elements_cannot_have_multiple_attributes_with_the_same_name);if(r.set(o.escapedText,!0),s&&271===s.kind&&!s.expression)return Hk(s,e.Diagnostics.JSX_attributes_must_only_be_assigned_a_non_empty_expression)}}}function Ck(t){if(eT(t))return!0;if(228===t.kind&&t.awaitModifier&&0===(16384&t.flags)){var r=e.getSourceFileOfNode(t);if(!Kk(r)){var n=e.createDiagnosticForNode(t.awaitModifier,e.Diagnostics.A_for_await_of_statement_is_only_allowed_within_an_async_function_or_async_generator),i=e.getContainingFunction(t);if(i&&158!==i.kind){e.Debug.assert(0===(2&e.getFunctionFlags(i)),"Enclosing function should never be an async function.");var a=e.createDiagnosticForNode(i,e.Diagnostics.Did_you_mean_to_mark_this_function_as_async);e.addRelatedInfo(n,a)}return tA.add(n),!0}return!1}if(239===t.initializer.kind){var o=t.initializer;if(!Jk(o)){var s=o.declarations;if(!s.length)return!1;if(s.length>1){var n=227===t.kind?e.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement:e.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement;return qk(o.declarations[1],n)}var c=s[0];if(c.initializer){var n=227===t.kind?e.Diagnostics.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer:e.Diagnostics.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer;return Hk(c.name,n)}if(c.type){var n=227===t.kind?e.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation:e.Diagnostics.The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation;return Hk(c,n)}}}return!1}function kk(t){var r=t.kind;if(1>DT)return Hk(t.name,e.Diagnostics.Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher);if(4194304&t.flags)return Hk(t.name,e.Diagnostics.An_accessor_cannot_be_declared_in_an_ambient_context);if(void 0===t.body&&!e.hasModifier(t,128))return Wk(t,t.end-1,";".length,e.Diagnostics._0_expected,"{");if(t.body&&e.hasModifier(t,128))return Hk(t,e.Diagnostics.An_abstract_accessor_cannot_have_an_implementation);if(t.typeParameters)return Hk(t.name,e.Diagnostics.An_accessor_cannot_have_type_parameters);if(!Tk(t))return Hk(t.name,159===r?e.Diagnostics.A_get_accessor_cannot_have_parameters:e.Diagnostics.A_set_accessor_must_have_exactly_one_parameter);if(160===r){if(t.type)return Hk(t.name,e.Diagnostics.A_set_accessor_cannot_have_a_return_type_annotation);var n=t.parameters[0];if(n.dotDotDotToken)return Hk(n.dotDotDotToken,e.Diagnostics.A_set_accessor_cannot_have_rest_parameter);if(n.questionToken)return Hk(n.questionToken,e.Diagnostics.A_set_accessor_cannot_have_an_optional_parameter);if(n.initializer)return Hk(t.name,e.Diagnostics.A_set_accessor_parameter_cannot_have_an_initializer)}return!1}function Tk(e){return Ek(e)||e.parameters.length===(159===e.kind?0:1)}function Ek(t){return t.parameters.length===(159===t.kind?1:2)?e.getThisParameter(t):void 0}function Nk(t){if(143===t.operator){if(140!==t.type.kind)return Hk(t.type,e.Diagnostics._0_expected,e.tokenToString(140));var r=e.walkUpParenthesizedTypes(t.parent);switch(r.kind){case 238:var n=r;if(73!==n.name.kind)return Hk(t,e.Diagnostics.unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name);
if(!e.isVariableDeclarationInVariableStatement(n))return Hk(t,e.Diagnostics.unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement);if(!(2&n.parent.flags))return Hk(r.name,e.Diagnostics.A_variable_whose_type_is_a_unique_symbol_type_must_be_const);break;case 155:if(!e.hasModifier(r,32)||!e.hasModifier(r,64))return Hk(r.name,e.Diagnostics.A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly);break;case 154:if(!e.hasModifier(r,64))return Hk(r.name,e.Diagnostics.A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly);break;default:return Hk(t,e.Diagnostics.unique_symbol_types_are_not_allowed_here)}}else if(134===t.operator&&170!==t.type.kind&&171!==t.type.kind)return qk(t,e.Diagnostics.readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types,e.tokenToString(140))}function Ak(e,t){return Mi(e)?Hk(e,t):void 0}function Fk(t){if(ak(t))return!0;if(157===t.kind){if(189===t.parent.kind){if(t.modifiers&&(1!==t.modifiers.length||122!==e.first(t.modifiers).kind))return qk(t,e.Diagnostics.Modifiers_cannot_appear_here);if(bk(t.questionToken,e.Diagnostics.An_object_member_cannot_be_declared_optional))return!0;if(xk(t.exclamationToken,e.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context))return!0;if(void 0===t.body)return Wk(t,t.end-1,";".length,e.Diagnostics._0_expected,"{")}else if(e.isClassLike(t.parent)&&e.isStringLiteral(t.name)&&"constructor"===t.name.text&&(!xT.target||xT.target<1))return Hk(t.name,e.Diagnostics.Quoted_constructors_have_previously_been_interpreted_as_methods_which_is_incorrect_In_TypeScript_3_6_they_will_be_correctly_parsed_as_constructors_In_the_meantime_consider_using_constructor_to_write_a_constructor_or_constructor_to_write_a_method);if(hk(t))return!0}if(e.isClassLike(t.parent)){if(4194304&t.flags)return Ak(t.name,e.Diagnostics.A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);if(157===t.kind&&!t.body)return Ak(t.name,e.Diagnostics.A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)}else{if(242===t.parent.kind)return Ak(t.name,e.Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);if(169===t.parent.kind)return Ak(t.name,e.Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)}}function Pk(t){for(var r=t;r;){if(e.isFunctionLike(r))return Hk(t,e.Diagnostics.Jump_target_cannot_cross_function_boundary);switch(r.kind){case 234:if(t.label&&r.label.escapedText===t.label.escapedText){var n=229===t.kind&&!e.isIterationStatement(r.statement,!0);return n?Hk(t,e.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement):!1}break;case 233:if(230===t.kind&&!t.label)return!1;break;default:if(e.isIterationStatement(r,!1)&&!t.label)return!1}r=r.parent}if(t.label){var i=230===t.kind?e.Diagnostics.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement:e.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement;return Hk(t,i)}var i=230===t.kind?e.Diagnostics.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement:e.Diagnostics.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement;return Hk(t,i)}function wk(t){if(t.dotDotDotToken){var r=t.parent.elements;if(t!==e.last(r))return Hk(t,e.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);if(ek(r,e.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma),t.propertyName)return Hk(t.name,e.Diagnostics.A_rest_element_cannot_have_a_property_name);if(t.initializer)return Wk(t,t.initializer.pos-1,1,e.Diagnostics.A_rest_element_cannot_have_an_initializer)}}function Ik(e){return 10===e.kind||8===e.kind||203===e.kind&&39===e.operator&&8===e.operand.kind}function Ok(e){return 9===e.kind||203===e.kind&&39===e.operator&&9===e.operand.kind}function Mk(t){return(e.isPropertyAccessExpression(t)||e.isElementAccessExpression(t)&&Ik(t.argumentExpression))&&e.isEntityNameExpression(t.expression)?!!(1024&eb(t).flags):void 0}function Lk(t){var r=t.initializer;if(r){var n=!(Ik(r)||Mk(r)||103===r.kind||88===r.kind||Ok(r)),i=e.isDeclarationReadonly(t)||e.isVariableDeclaration(t)&&e.isVarConst(t);if(!i||t.type)return Hk(r,e.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);if(n)return Hk(r,e.Diagnostics.A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference);if(!i||n)return Hk(r,e.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts)}}function Rk(t){if(227!==t.parent.parent.kind&&228!==t.parent.parent.kind)if(4194304&t.flags)Lk(t);else if(!t.initializer){if(e.isBindingPattern(t.name)&&!e.isBindingPattern(t.parent))return Hk(t,e.Diagnostics.A_destructuring_declaration_must_have_an_initializer);if(e.isVarConst(t))return Hk(t,e.Diagnostics.const_declarations_must_be_initialized)}if(t.exclamationToken&&(220!==t.parent.parent.kind||!t.type||t.initializer||4194304&t.flags))return Hk(t.exclamationToken,e.Diagnostics.Definite_assignment_assertions_can_only_be_used_along_with_a_type_annotation);xT.module===e.ModuleKind.ES2015||xT.module===e.ModuleKind.ESNext||xT.module===e.ModuleKind.System||xT.noEmit||4194304&t.parent.parent.flags||!e.hasModifier(t.parent.parent,1)||Bk(t.name);var r=e.isLet(t)||e.isVarConst(t);return r&&jk(t.name)}function Bk(t){if(73===t.kind){if("__esModule"===e.idText(t))return Hk(t,e.Diagnostics.Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules)}else for(var r=t.elements,n=0,i=r;n<i.length;n++){var a=i[n];if(!e.isOmittedExpression(a))return Bk(a.name)}return!1}function jk(t){if(73===t.kind){if(112===t.originalKeywordKind)return Hk(t,e.Diagnostics.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations)}else for(var r=t.elements,n=0,i=r;n<i.length;n++){var a=i[n];e.isOmittedExpression(a)||jk(a.name)}return!1}function Jk(t){var r=t.declarations;return ek(t.declarations)?!0:t.declarations.length?!1:Wk(t,r.pos,r.end-r.pos,e.Diagnostics.Variable_declaration_list_cannot_be_empty)}function zk(e){switch(e.kind){case 223:case 224:case 225:case 232:case 226:case 227:case 228:return!1;case 234:return zk(e.parent)}return!0}function Vk(t){if(!zk(t.parent)){if(e.isLet(t.declarationList))return Hk(t,e.Diagnostics.let_declarations_can_only_be_declared_inside_a_block);if(e.isVarConst(t.declarationList))return Hk(t,e.Diagnostics.const_declarations_can_only_be_declared_inside_a_block)}}function Uk(t){var r=t.name.escapedText;switch(t.keywordToken){case 96:if("target"!==r)return Hk(t.name,e.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2,t.name.escapedText,e.tokenToString(t.keywordToken),"target");break;case 93:if("meta"!==r)return Hk(t.name,e.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2,t.name.escapedText,e.tokenToString(t.keywordToken),"meta")}}function Kk(e){return e.parseDiagnostics.length>0}function qk(t,r,n,i,a){var o=e.getSourceFileOfNode(t);if(!Kk(o)){var s=e.getSpanOfTokenAtPosition(o,t.pos);return tA.add(e.createFileDiagnostic(o,s.start,s.length,r,n,i,a)),!0}return!1}function Wk(t,r,n,i,a,o,s){var c=e.getSourceFileOfNode(t);return Kk(c)?!1:(tA.add(e.createFileDiagnostic(c,r,n,i,a,o,s)),!0)}function Hk(t,r,n,i,a){var o=e.getSourceFileOfNode(t);return Kk(o)?!1:(tA.add(e.createDiagnosticForNode(t,r,n,i,a)),!0)}function Gk(t){var r=e.isInJSFile(t)?e.getJSDocTypeParameterDeclarations(t):void 0,n=t.typeParameters||r&&e.firstOrUndefined(r);if(n){var i=n.pos===n.end?n.pos:e.skipTrivia(e.getSourceFileOfNode(t).text,n.pos);return Wk(t,i,n.end-i,e.Diagnostics.Type_parameters_cannot_appear_on_a_constructor_declaration)}}function Qk(t){var r=e.getEffectiveReturnTypeNode(t);return r?Hk(r,e.Diagnostics.Type_annotation_cannot_appear_on_a_constructor_declaration):void 0}function Xk(t){if(e.isClassLike(t.parent)){if(e.isStringLiteral(t.name)&&"constructor"===t.name.text)return Hk(t.name,e.Diagnostics.Classes_may_not_have_a_field_named_constructor);if(Ak(t.name,e.Diagnostics.A_computed_property_name_in_a_class_property_declaration_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type))return!0}else if(242===t.parent.kind){if(Ak(t.name,e.Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type))return!0;if(t.initializer)return Hk(t.initializer,e.Diagnostics.An_interface_property_cannot_have_an_initializer)}else if(169===t.parent.kind){if(Ak(t.name,e.Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type))return!0;if(t.initializer)return Hk(t.initializer,e.Diagnostics.A_type_literal_property_cannot_have_an_initializer)}return 4194304&t.flags&&Lk(t),e.isPropertyDeclaration(t)&&t.exclamationToken&&(!e.isClassLike(t.parent)||!t.type||t.initializer||4194304&t.flags||e.hasModifier(t,160))?Hk(t.exclamationToken,e.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context):void 0}function Yk(t){return 242===t.kind||243===t.kind||250===t.kind||249===t.kind||256===t.kind||255===t.kind||248===t.kind||e.hasModifier(t,515)?!1:qk(t,e.Diagnostics.Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier)}function Zk(t){for(var r=0,n=t.statements;r<n.length;r++){var i=n[r];if((e.isDeclaration(i)||220===i.kind)&&Yk(i))return!0}return!1}function $k(e){return!!(4194304&e.flags)&&Zk(e)}function eT(t){if(4194304&t.flags){if(e.isAccessor(t.parent))return O(t).hasReportedStatementInAmbientContext=!0;var r=O(t);if(!r.hasReportedStatementInAmbientContext&&e.isFunctionLike(t.parent))return O(t).hasReportedStatementInAmbientContext=qk(t,e.Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);if(219===t.parent.kind||246===t.parent.kind||285===t.parent.kind){var n=O(t.parent);if(!n.hasReportedStatementInAmbientContext)return n.hasReportedStatementInAmbientContext=qk(t,e.Diagnostics.Statements_are_not_allowed_in_ambient_contexts)}}return!1}function tT(t){if(32&t.numericLiteralFlags){var r=void 0;if(DT>=1?r=e.Diagnostics.Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0:e.isChildOfNodeWithKind(t,183)?r=e.Diagnostics.Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0:e.isChildOfNodeWithKind(t,279)&&(r=e.Diagnostics.Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0),r){var n=e.isPrefixUnaryExpression(t.parent)&&39===t.parent.operator,i=(n?"-":"")+"0o"+t.text;return Hk(n?t.parent:t,r,i)}}return!1}function rT(t){var r=e.isLiteralTypeNode(t.parent)||e.isPrefixUnaryExpression(t.parent)&&e.isLiteralTypeNode(t.parent.parent);return!r&&8>DT&&Hk(t,e.Diagnostics.BigInt_literals_are_not_available_when_targeting_lower_than_ESNext)?!0:!1}function nT(t,r,n,i,a){var o=e.getSourceFileOfNode(t);if(!Kk(o)){var s=e.getSpanOfTokenAtPosition(o,t.pos);return tA.add(e.createFileDiagnostic(o,e.textSpanEnd(s),0,r,n,i,a)),!0}return!1}function iT(){return RE||(RE=[],MT.forEach(function(e,t){u.test(t)&&RE.push(e)})),RE}function aT(t){if(ST===e.ModuleKind.ES2015)return Hk(t,e.Diagnostics.Dynamic_import_is_only_supported_when_module_flag_is_commonjs_or_esNext);if(t.typeArguments)return Hk(t,e.Diagnostics.Dynamic_import_cannot_have_type_arguments);var r=t.arguments;return 1!==r.length?Hk(t,e.Diagnostics.Dynamic_import_must_have_one_specifier_as_an_argument):(ek(r),e.isSpreadElement(r[0])?Hk(r[0],e.Diagnostics.Specifier_of_dynamic_import_cannot_be_spread_element):!1)}var oT,sT,cT,uT,lT=e.memoize(function(){var t=e.createMap();return o.getSourceFiles().forEach(function(r){r.resolvedModules&&e.forEachEntry(r.resolvedModules,function(e){e&&e.packageId&&t.set(e.packageId.name,!0)})}),t}),_T=e.objectAllocator.getSymbolConstructor(),dT=e.objectAllocator.getTypeConstructor(),pT=e.objectAllocator.getSignatureConstructor(),fT=0,mT=0,gT=0,vT=0,yT=0,hT=e.createSymbolTable(),bT=e.identity,xT=o.getCompilerOptions(),DT=e.getEmitScriptTarget(xT),ST=e.getEmitModuleKind(xT),CT=e.getAllowSyntheticDefaultImports(xT),kT=e.getStrictOptionValue(xT,"strictNullChecks"),TT=e.getStrictOptionValue(xT,"strictFunctionTypes"),ET=e.getStrictOptionValue(xT,"strictBindCallApply"),NT=e.getStrictOptionValue(xT,"strictPropertyInitialization"),AT=e.getStrictOptionValue(xT,"noImplicitAny"),FT=e.getStrictOptionValue(xT,"noImplicitThis"),PT=!!xT.keyofStringsOnly,wT=xT.suppressExcessPropertyErrors?0:32768,IT=zC(),OT=Fr(),MT=e.createSymbolTable(),LT=x(4,"undefined");LT.declarations=[];var RT=x(1536,"globalThis",8);RT.exports=MT,MT.set(RT.escapedName,RT);var BT,jT=x(4,"arguments"),JT=x(4,"require"),zT={getNodeCount:function(){return e.sum(o.getSourceFiles(),"nodeCount")},getIdentifierCount:function(){return e.sum(o.getSourceFiles(),"identifierCount")},getSymbolCount:function(){return e.sum(o.getSourceFiles(),"symbolCount")+mT},getTypeCount:function(){return fT},getRelationCacheSizes:function(){return{assignable:dA.size,identity:fA.size,subtype:_A.size}},isUndefinedSymbol:function(e){return e===LT},isArgumentsSymbol:function(e){return e===jT},isUnknownSymbol:function(e){return e===XT},getMergedSymbol:Wt,getDiagnostics:FS,getGlobalDiagnostics:wS,getTypeOfSymbolAtLocation:function(t,r){return r=e.getParseTreeNode(r),r?Ff(t,r):tE},getSymbolsOfParameterPropertyDeclaration:function(t,r){var n=e.getParseTreeNode(t,e.isParameter);return void 0===n?e.Debug.fail("Cannot get symbols of a synthetic parameter that cannot be resolved to a parse-tree node."):R(n,e.escapeLeadingUnderscores(r))},getDeclaredTypeOfSymbol:bi,getPropertiesOfType:Pa,getPropertyOfType:function(t,r){return ao(t,e.escapeLeadingUnderscores(r))},getTypeOfPropertyOfType:function(t,r){return Hr(t,e.escapeLeadingUnderscores(r))},getIndexInfoOfType:lo,getSignaturesOfType:so,getIndexTypeOfType:_o,getBaseTypes:ii,getBaseTypeOfLiteralType:Y_,getWidenedType:Td,getTypeFromTypeNode:function(t){var r=e.getParseTreeNode(t,e.isTypeNode);return r?ju(r):tE},getParameterType:Uy,getPromisedTypeOfPromise:sx,getReturnTypeOfSignature:Mo,getNullableType:_d,getNonNullableType:fd,typeToTypeNode:OT.typeToTypeNode,indexInfoToIndexSignatureDeclaration:OT.indexInfoToIndexSignatureDeclaration,signatureToSignatureDeclaration:OT.signatureToSignatureDeclaration,symbolToEntityName:OT.symbolToEntityName,symbolToExpression:OT.symbolToExpression,symbolToTypeParameterDeclarations:OT.symbolToTypeParameterDeclarations,symbolToParameterDeclaration:OT.symbolToParameterDeclaration,typeParameterToDeclaration:OT.typeParameterToDeclaration,getSymbolsInScope:function(t,r){return t=e.getParseTreeNode(t),t?OS(t,r):[]},getSymbolAtLocation:function(t){return t=e.getParseTreeNode(t),t?HS(t):void 0},getShorthandAssignmentValueSymbol:function(t){return t=e.getParseTreeNode(t),t?GS(t):void 0},getExportSpecifierLocalTargetSymbol:function(t){var r=e.getParseTreeNode(t,e.isExportSpecifier);return r?QS(r):void 0},getExportSymbolOfSymbol:function(e){return Wt(e.exportSymbol||e)},getTypeAtLocation:function(t){return t=e.getParseTreeNode(t),t?XS(t):tE},getTypeOfAssignmentPattern:function(t){var r=e.getParseTreeNode(t,e.isAssignmentPattern);return r&&YS(r)||tE},getPropertySymbolOfDestructuringAssignment:function(t){var r=e.getParseTreeNode(t,e.isIdentifier);return r?ZS(r):void 0},signatureToString:function(t,r,n,i){return Tr(t,e.getParseTreeNode(r),n,i)},typeToString:function(t,r,n){return Er(t,e.getParseTreeNode(r),n)},symbolToString:function(t,r,n,i){return kr(t,e.getParseTreeNode(r),n,i)},typePredicateToString:function(t,r,n){return Pr(t,e.getParseTreeNode(r),n)},writeSignature:function(t,r,n,i,a){return Tr(t,e.getParseTreeNode(r),n,i,a)},writeType:function(t,r,n,i){return Er(t,e.getParseTreeNode(r),n,i)},writeSymbol:function(t,r,n,i,a){return kr(t,e.getParseTreeNode(r),n,i,a)},writeTypePredicate:function(t,r,n,i){return Pr(t,e.getParseTreeNode(r),n,i)},getAugmentedPropertiesOfType:rC,getRootSymbols:iC,getContextualType:function(t){var r=e.getParseTreeNode(t,e.isExpression);return r?Rm(r):void 0},getContextualTypeForObjectLiteralElement:function(t){var r=e.getParseTreeNode(t,e.isObjectLiteralElementLike);return r?km(r):void 0},getContextualTypeForArgumentAtIndex:function(t,r){var n=e.getParseTreeNode(t,e.isCallLikeExpression);return n&&ym(n,r)},getContextualTypeForJsxAttribute:function(t){var r=e.getParseTreeNode(t,e.isJsxAttributeLike);return r&&Fm(r)},isContextSensitive:xl,getFullyQualifiedName:Ct,getResolvedSignature:function(e,t,r){return _(e,t,r,0)},getResolvedSignatureForSignatureHelp:function(e,t,r){return _(e,t,r,16)},getExpandedParameters:Qi,hasEffectiveRestParameter:Gy,getConstantValue:function(t){var r=e.getParseTreeNode(t,NC);return r?AC(r):void 0},isValidPropertyAccess:function(t,r){var n=e.getParseTreeNode(t,e.isPropertyAccessOrQualifiedNameOrImportTypeNode);return!!n&&fv(n,e.escapeLeadingUnderscores(r))},isValidPropertyAccessForCompletions:function(t,r,n){var i=e.getParseTreeNode(t,e.isPropertyAccessExpression);return!!i&&mv(i,r,n)},getSignatureFromDeclaration:function(t){var r=e.getParseTreeNode(t,e.isFunctionLike);return r?Co(r):void 0},isImplementationOfOverload:function(t){var r=e.getParseTreeNode(t,e.isFunctionLike);return r?xC(r):void 0},getImmediateAliasedSymbol:sg,getAliasedSymbol:bt,getEmitResolver:g,getExportsOfModule:Bt,getExportsAndPropertiesOfModule:jt,getSymbolWalker:e.createGetSymbolWalker(Bo,Io,Mo,ii,Ta,Un,pp,uo,Ma,iS),getAmbientModules:iT,getJsxIntrinsicTagNamesAt:Mg,isOptionalParameter:function(t){var r=e.getParseTreeNode(t,e.isParameter);return r?yo(r):!1},tryGetMemberInModuleExports:function(t,r){return Jt(e.escapeLeadingUnderscores(t),r)},tryGetMemberInModuleExportsAndProperties:function(t,r){return zt(e.escapeLeadingUnderscores(t),r)},tryFindAmbientModuleWithoutAugmentations:function(e){return vo(e,!1)},getApparentType:to,getUnionType:Dc,createAnonymousType:lr,createSignature:Wi,createSymbol:x,createIndexInfo:Zo,getAnyType:function(){return ZT},getStringType:function(){return sE},getNumberType:function(){return cE},createPromiseType:nh,createArrayType:ic,getElementTypeOfArrayType:V_,getBooleanType:function(){return fE},getFalseType:function(e){return e?lE:_E},getTrueType:function(e){return e?dE:pE},getVoidType:function(){return gE},getUndefinedType:function(){return nE},getNullType:function(){return aE},getESSymbolType:function(){return mE},getNeverType:function(){return vE},isSymbolAccessible:hr,getObjectFlags:e.getObjectFlags,isArrayType:J_,isTupleType:td,isArrayLikeType:U_,isTypeInvalidDueToUnionDiscriminant:wa,getAllPossiblePropertiesOfTypes:Ia,getSuggestionForNonexistentProperty:function(e,t){return ov(e,t)},getSuggestionForNonexistentSymbol:function(t,r,n){return cv(t,e.escapeLeadingUnderscores(r),n)},getSuggestionForNonexistentExport:function(e,t){return lv(e,t)},getBaseConstraintOfType:Ka,getDefaultFromTypeParameter:function(e){return e&&262144&e.flags?Xa(e):void 0},resolveName:function(t,r,n,i){return j(r,e.escapeLeadingUnderscores(t),n,void 0,void 0,!1,i)},getJsxNamespace:function(t){return e.unescapeLeadingUnderscores(m(t))},getAccessibleSymbolChain:pr,getTypePredicateOfSignature:Io,resolveExternalModuleSymbol:Ot,tryGetThisTypeAt:function(t,r){return t=e.getParseTreeNode(t),t&&$f(t,r)},getTypeArgumentConstraint:function(t){var r=e.getParseTreeNode(t,e.isTypeNode);return r&&Vb(r)},getSuggestionDiagnostics:function(t,r){function n(){Ax(NS(t),function(t,r,n){e.containsParseError(t)||ES(r)||(a||(a=[])).push(i({},n,{category:e.DiagnosticCategory.Suggestion}))})}if(e.skipTypeChecking(t,xT))return e.emptyArray;var a;try{return oT=r,TS(t),e.Debug.assert(!!(1&O(t).flags)),a=e.addRange(a,rA.get(t.fileName)),t.isDeclarationFile||ES(0)&&ES(1)||n(),a||e.emptyArray}finally{oT=void 0}},runWithCancellationToken:function(e,t){try{return oT=e,t(zT)}finally{oT=void 0}},getLocalTypeParametersOfClassOrInterfaceOrTypeAlias:Xn},VT=e.createMap(),UT=e.createMap(),KT=e.createMap(),qT=e.createMap(),WT=e.createMap(),HT=e.createMap(),GT=[],QT=e.createMap(),XT=x(4,"unknown"),YT=x(0,"__resolving__"),ZT=rr(1,"any"),$T=rr(1,"any"),eE=rr(1,"any"),tE=rr(1,"error"),rE=rr(2,"unknown"),nE=rr(32768,"undefined"),iE=kT?nE:rr(32768,"undefined",131072),aE=rr(65536,"null"),oE=kT?aE:rr(65536,"null",131072),sE=rr(4,"string"),cE=rr(8,"number"),uE=rr(64,"bigint"),lE=rr(512,"false"),_E=rr(512,"false"),dE=rr(512,"true"),pE=rr(512,"true");dE.regularType=pE,dE.freshType=dE,pE.regularType=pE,pE.freshType=dE,lE.regularType=_E,lE.freshType=lE,_E.regularType=_E,_E.freshType=lE;var fE=nr([_E,pE]);nr([_E,dE]),nr([lE,pE]),nr([lE,dE]);var mE=rr(4096,"symbol"),gE=rr(16384,"void"),vE=rr(131072,"never"),yE=rr(131072,"never"),hE=rr(131072,"never",524288),bE=rr(131072,"never"),xE=rr(67108864,"object"),DE=Dc([sE,cE,mE]),SE=PT?sE:DE,CE=Dc([cE,uE]),kE=lr(void 0,hT,e.emptyArray,e.emptyArray,void 0,void 0),TE=lr(void 0,hT,e.emptyArray,e.emptyArray,void 0,void 0);TE.objectFlags|=4096;var EE=x(2048,"__type");EE.members=e.createSymbolTable();var NE=lr(EE,hT,e.emptyArray,e.emptyArray,void 0,void 0),AE=lr(void 0,hT,e.emptyArray,e.emptyArray,void 0,void 0);AE.instantiations=e.createMap();var FE=lr(void 0,hT,e.emptyArray,e.emptyArray,void 0,void 0);FE.objectFlags|=524288;var PE=lr(void 0,hT,e.emptyArray,e.emptyArray,void 0,void 0),wE=lr(void 0,hT,e.emptyArray,e.emptyArray,void 0,void 0),IE=lr(void 0,hT,e.emptyArray,e.emptyArray,void 0,void 0),OE=or(),ME=or();ME.constraint=OE;var LE,RE,BE,jE,JE,zE,VE,UE,KE,qE,WE,HE,GE,QE,XE,YE,ZE,$E,eN,tN,rN,nN,iN,aN,oN,sN,cN,uN,lN,_N,dN,pN,fN,mN,gN,vN,yN,hN,bN=or(),xN=bo("<<unresolved>>",0,ZT),DN=Wi(void 0,void 0,void 0,e.emptyArray,ZT,void 0,0,!1,!1),SN=Wi(void 0,void 0,void 0,e.emptyArray,tE,void 0,0,!1,!1),CN=Wi(void 0,void 0,void 0,e.emptyArray,ZT,void 0,0,!1,!1),kN=Wi(void 0,void 0,void 0,e.emptyArray,yE,void 0,0,!1,!1),TN=Zo(sE,!0),EN=e.createMap(),NN=e.createMap(),AN=0,FN=0,PN=0,wN=!1,IN=Iu(""),ON=Iu(0),MN=Iu({negative:!1,base10Value:"0"}),LN=[],RN=[],BN=[],jN=0,JN=10,zN=[],VN=[],UN=[],KN=[],qN=[],WN=[],HN=[],GN=[],QN=[],XN=[],YN=[],ZN=[],$N=[],eA=[],tA=e.createDiagnosticCollection(),rA=e.createMultiMap();!function(e){e[e.None=0]="None",e[e.TypeofEQString=1]="TypeofEQString",e[e.TypeofEQNumber=2]="TypeofEQNumber",e[e.TypeofEQBigInt=4]="TypeofEQBigInt",e[e.TypeofEQBoolean=8]="TypeofEQBoolean",e[e.TypeofEQSymbol=16]="TypeofEQSymbol",e[e.TypeofEQObject=32]="TypeofEQObject",e[e.TypeofEQFunction=64]="TypeofEQFunction",e[e.TypeofEQHostObject=128]="TypeofEQHostObject",e[e.TypeofNEString=256]="TypeofNEString",e[e.TypeofNENumber=512]="TypeofNENumber",e[e.TypeofNEBigInt=1024]="TypeofNEBigInt",e[e.TypeofNEBoolean=2048]="TypeofNEBoolean",e[e.TypeofNESymbol=4096]="TypeofNESymbol",e[e.TypeofNEObject=8192]="TypeofNEObject",e[e.TypeofNEFunction=16384]="TypeofNEFunction",e[e.TypeofNEHostObject=32768]="TypeofNEHostObject",e[e.EQUndefined=65536]="EQUndefined",e[e.EQNull=131072]="EQNull",e[e.EQUndefinedOrNull=262144]="EQUndefinedOrNull",e[e.NEUndefined=524288]="NEUndefined",e[e.NENull=1048576]="NENull",e[e.NEUndefinedOrNull=2097152]="NEUndefinedOrNull",e[e.Truthy=4194304]="Truthy",e[e.Falsy=8388608]="Falsy",e[e.All=16777215]="All",e[e.BaseStringStrictFacts=3735041]="BaseStringStrictFacts",e[e.BaseStringFacts=12582401]="BaseStringFacts",e[e.StringStrictFacts=16317953]="StringStrictFacts",e[e.StringFacts=16776705]="StringFacts",e[e.EmptyStringStrictFacts=12123649]="EmptyStringStrictFacts",e[e.EmptyStringFacts=12582401]="EmptyStringFacts",e[e.NonEmptyStringStrictFacts=7929345]="NonEmptyStringStrictFacts",e[e.NonEmptyStringFacts=16776705]="NonEmptyStringFacts",e[e.BaseNumberStrictFacts=3734786]="BaseNumberStrictFacts",e[e.BaseNumberFacts=12582146]="BaseNumberFacts",e[e.NumberStrictFacts=16317698]="NumberStrictFacts",e[e.NumberFacts=16776450]="NumberFacts",e[e.ZeroNumberStrictFacts=12123394]="ZeroNumberStrictFacts",e[e.ZeroNumberFacts=12582146]="ZeroNumberFacts",e[e.NonZeroNumberStrictFacts=7929090]="NonZeroNumberStrictFacts",e[e.NonZeroNumberFacts=16776450]="NonZeroNumberFacts",e[e.BaseBigIntStrictFacts=3734276]="BaseBigIntStrictFacts",e[e.BaseBigIntFacts=12581636]="BaseBigIntFacts",e[e.BigIntStrictFacts=16317188]="BigIntStrictFacts",e[e.BigIntFacts=16775940]="BigIntFacts",e[e.ZeroBigIntStrictFacts=12122884]="ZeroBigIntStrictFacts",e[e.ZeroBigIntFacts=12581636]="ZeroBigIntFacts",e[e.NonZeroBigIntStrictFacts=7928580]="NonZeroBigIntStrictFacts",e[e.NonZeroBigIntFacts=16775940]="NonZeroBigIntFacts",e[e.BaseBooleanStrictFacts=3733256]="BaseBooleanStrictFacts",e[e.BaseBooleanFacts=12580616]="BaseBooleanFacts",e[e.BooleanStrictFacts=16316168]="BooleanStrictFacts",e[e.BooleanFacts=16774920]="BooleanFacts",e[e.FalseStrictFacts=12121864]="FalseStrictFacts",e[e.FalseFacts=12580616]="FalseFacts",e[e.TrueStrictFacts=7927560]="TrueStrictFacts",e[e.TrueFacts=16774920]="TrueFacts",e[e.SymbolStrictFacts=7925520]="SymbolStrictFacts",e[e.SymbolFacts=16772880]="SymbolFacts",e[e.ObjectStrictFacts=7888800]="ObjectStrictFacts",e[e.ObjectFacts=16736160]="ObjectFacts",e[e.FunctionStrictFacts=7880640]="FunctionStrictFacts",e[e.FunctionFacts=16728e3]="FunctionFacts",e[e.UndefinedFacts=9830144]="UndefinedFacts",e[e.NullFacts=9363232]="NullFacts",e[e.EmptyObjectStrictFacts=16318463]="EmptyObjectStrictFacts",e[e.EmptyObjectFacts=16777215]="EmptyObjectFacts"}(hN||(hN={}));var nA,iA,aA,oA,sA=e.createMapFromTemplate({string:1,number:2,bigint:4,"boolean":8,symbol:16,undefined:65536,object:32,"function":64}),cA=e.createMapFromTemplate({string:256,number:512,bigint:1024,"boolean":2048,symbol:4096,undefined:524288,object:8192,"function":16384}),uA=e.createMapFromTemplate({string:sE,number:cE,bigint:uE,"boolean":fE,symbol:mE,undefined:nE}),lA=ar(),_A=e.createMap(),dA=e.createMap(),pA=e.createMap(),fA=e.createMap(),mA=e.createMap();!function(e){e[e.Type=0]="Type",e[e.ResolvedBaseConstructorType=1]="ResolvedBaseConstructorType",e[e.DeclaredType=2]="DeclaredType",e[e.ResolvedReturnType=3]="ResolvedReturnType",e[e.ImmediateBaseConstraint=4]="ImmediateBaseConstraint",e[e.EnumTagType=5]="EnumTagType",e[e.JSDocTypeReference=6]="JSDocTypeReference"}(oA||(oA={}));var gA;!function(e){e[e.Normal=0]="Normal",e[e.Contextual=1]="Contextual",e[e.Inferential=2]="Inferential",e[e.SkipContextSensitive=4]="SkipContextSensitive",e[e.SkipGenericFunctions=8]="SkipGenericFunctions",e[e.IsForSignatureHelp=16]="IsForSignatureHelp"}(gA||(gA={}));var vA;!function(e){e[e.None=0]="None",e[e.Signature=1]="Signature"}(vA||(vA={}));var yA;!function(e){e[e.None=0]="None",e[e.NoIndexSignatures=1]="NoIndexSignatures",e[e.Writing=2]="Writing",e[e.CacheSymbol=4]="CacheSymbol"}(yA||(yA={}));var hA;!function(e){e[e.None=0]="None",e[e.Bivariant=1]="Bivariant",e[e.Strict=2]="Strict"}(hA||(hA={}));var bA;!function(e){e[e.IncludeReadonly=1]="IncludeReadonly",e[e.ExcludeReadonly=2]="ExcludeReadonly",e[e.IncludeOptional=4]="IncludeOptional",e[e.ExcludeOptional=8]="ExcludeOptional"}(bA||(bA={}));var xA;!function(e){e[e.None=0]="None",e[e.Source=1]="Source",e[e.Target=2]="Target",e[e.Both=3]="Both"}(xA||(xA={}));var DA;!function(e){e.resolvedExports="resolvedExports",e.resolvedMembers="resolvedMembers"}(DA||(DA={}));var SA;!function(e){e[e.Local=0]="Local",e[e.Parameter=1]="Parameter"}(SA||(SA={}));var CA=e.createSymbolTable();CA.set(LT.escapedName,LT);var kA=e.and(vS,gS);return UC(),zT}function s(t){switch(t.parent.kind){case 254:case 258:return e.isIdentifier(t);default:return e.isDeclarationName(t)}}function c(e){switch(e.kind){case 251:case 249:case 252:case 254:return!0;case 73:return 254===e.parent.kind;default:return!1}}var u=/^".+"$/,l=1,_=1,d=1,p=1;e.getNodeId=t,e.getSymbolId=r,e.isInstantiatedModule=n,e.createTypeChecker=o;var f;!function(e){e.JSX="JSX",e.IntrinsicElements="IntrinsicElements",e.ElementClass="ElementClass",e.ElementAttributesPropertyNameContainer="ElementAttributesProperty",e.ElementChildrenAttributeNameContainer="ElementChildrenAttribute",e.Element="Element",e.IntrinsicAttributes="IntrinsicAttributes",e.IntrinsicClassAttributes="IntrinsicClassAttributes",e.LibraryManagedAttributes="LibraryManagedAttributes"}(f||(f={}))}(n||(n={}));var n;!function(e){function t(t){var r=e.createNode(t,-1,-1);return r.flags|=8,r}function r(t,r){return t!==r&&(Ko(t,r),vo(t,r),e.aggregateTransformFlags(t)),t}function n(t,r){if(t&&t!==e.emptyArray){if(e.isNodeArray(t))return t}else t=[];var n=t;return n.pos=-1,n.end=-1,n.hasTrailingComma=r,n}function i(e){if(void 0===e)return e;var r=t(e.kind);r.flags|=e.flags,Ko(r,e);for(var n in e)!r.hasOwnProperty(n)&&e.hasOwnProperty(n)&&(r[n]=e[n]);return r}function a(t,r){if("number"==typeof t)return o(t+"");if("object"==typeof t&&"base10Value"in t)return s(e.pseudoBigIntToString(t)+"n");if("boolean"==typeof t)return t?S():C();if(e.isString(t)){var n=c(t);return r&&(n.singleQuote=!0),n}return l(t)}function o(e,r){void 0===r&&(r=0);var n=t(8);return n.text=e,n.numericLiteralFlags=r,n}function s(e){var r=t(9);return r.text=e,r}function c(e){var r=t(10);return r.text=e,r}function u(e){var r=t(13);return r.text=e,r}function l(t){var r=c(e.getTextOfIdentifierOrLiteral(t));return r.textSourceNode=t,r}function _(r,i){var a=t(73);return a.escapedText=e.escapeLeadingUnderscores(r),a.originalKeywordKind=r?e.stringToToken(r):0,a.autoGenerateFlags=0,a.autoGenerateId=0,i&&(a.typeArguments=n(i)),a}function d(t,n){return t.typeArguments!==n?r(_(e.idText(t),n),t):t}function p(e,t){var r=_("");return r.autoGenerateFlags=1,r.autoGenerateId=Ho,Ho++,e&&e(r),t&&(r.autoGenerateFlags|=8),r}function f(){var e=_("");return e.autoGenerateFlags=2,e.autoGenerateId=Ho,Ho++,e}function m(e){var t=_(e);return t.autoGenerateFlags=3,t.autoGenerateId=Ho,Ho++,t}function g(e){var t=_(e);return t.autoGenerateFlags=19,t.autoGenerateId=Ho,Ho++,t}function v(e){var t=g(e);return t.autoGenerateFlags|=32,t}function y(t,r){var n=_(t&&e.isIdentifier(t)?e.idText(t):"");return n.autoGenerateFlags=4|r,n.autoGenerateId=Ho,n.original=t,Ho++,n}function h(e){return t(e)}function b(){return t(99)}function x(){return t(101)}function D(){return t(97)}function S(){return t(103)}function C(){return t(88)}function k(e){return h(e)}function T(e){var t=[];return 1&e&&t.push(k(86)),2&e&&t.push(k(126)),512&e&&t.push(k(81)),2048&e&&t.push(k(78)),4&e&&t.push(k(116)),8&e&&t.push(k(114)),16&e&&t.push(k(115)),128&e&&t.push(k(119)),32&e&&t.push(k(117)),64&e&&t.push(k(134)),256&e&&t.push(k(122)),t}function E(e,r){var n=t(149);return n.left=e,n.right=lo(r),n}function N(e,t,n){return e.left!==t||e.right!==n?r(E(t,n),e):e}function A(t){return e.isCommaSequence(t)?yr(t):t}function F(e){var r=t(150);return r.expression=A(e),r}function P(e,t){return e.expression!==t?r(F(t),e):e}function w(e,r,n){var i=t(151);return i.name=lo(e),i.constraint=r,i.default=n,i}function I(e,t,n,i){return e.name!==t||e.constraint!==n||e.default!==i?r(w(t,n,i),e):e}function O(r,n,i,a,o,s,c){var u=t(152);return u.decorators=po(r),u.modifiers=po(n),u.dotDotDotToken=i,u.name=lo(a),u.questionToken=o,u.type=s,u.initializer=c?e.parenthesizeExpressionForList(c):void 0,u}function M(e,t,n,i,a,o,s,c){return e.decorators!==t||e.modifiers!==n||e.dotDotDotToken!==i||e.name!==a||e.questionToken!==o||e.type!==s||e.initializer!==c?r(O(t,n,i,a,o,s,c),e):e}function L(r){var n=t(153);return n.expression=e.parenthesizeForAccess(r),n}function R(e,t){return e.expression!==t?r(L(t),e):e}function B(e,r,n,i,a){var o=t(154);return o.modifiers=po(e),o.name=lo(r),o.questionToken=n,o.type=i,o.initializer=a,o}function j(e,t,n,i,a,o){return e.modifiers!==t||e.name!==n||e.questionToken!==i||e.type!==a||e.initializer!==o?r(B(t,n,i,a,o),e):e}function J(e,r,n,i,a,o){var s=t(155);return s.decorators=po(e),s.modifiers=po(r),s.name=lo(n),s.questionToken=void 0!==i&&56===i.kind?i:void 0,s.exclamationToken=void 0!==i&&52===i.kind?i:void 0,s.type=a,s.initializer=o,s
}function z(e,t,n,i,a,o,s){return e.decorators!==t||e.modifiers!==n||e.name!==i||e.questionToken!==(void 0!==a&&56===a.kind?a:void 0)||e.exclamationToken!==(void 0!==a&&52===a.kind?a:void 0)||e.type!==o||e.initializer!==s?r(J(t,n,i,a,o,s),e):e}function V(e,t,r,n,i){var a=it(156,e,t,r);return a.name=lo(n),a.questionToken=i,a}function U(e,t,n,i,a,o){return e.typeParameters!==t||e.parameters!==n||e.type!==i||e.name!==a||e.questionToken!==o?r(V(t,n,i,a,o),e):e}function K(e,r,i,a,o,s,c,u,l){var _=t(157);return _.decorators=po(e),_.modifiers=po(r),_.asteriskToken=i,_.name=lo(a),_.questionToken=o,_.typeParameters=po(s),_.parameters=n(c),_.type=u,_.body=l,_}function q(e,t,n,i,a,o,s,c,u,l){return e.decorators!==t||e.modifiers!==n||e.asteriskToken!==i||e.name!==a||e.questionToken!==o||e.typeParameters!==s||e.parameters!==c||e.type!==u||e.body!==l?r(K(t,n,i,a,o,s,c,u,l),e):e}function W(e,r,i,a){var o=t(158);return o.decorators=po(e),o.modifiers=po(r),o.typeParameters=void 0,o.parameters=n(i),o.type=void 0,o.body=a,o}function H(e,t,n,i,a){return e.decorators!==t||e.modifiers!==n||e.parameters!==i||e.body!==a?r(W(t,n,i,a),e):e}function G(e,r,i,a,o,s){var c=t(159);return c.decorators=po(e),c.modifiers=po(r),c.name=lo(i),c.typeParameters=void 0,c.parameters=n(a),c.type=o,c.body=s,c}function Q(e,t,n,i,a,o,s){return e.decorators!==t||e.modifiers!==n||e.name!==i||e.parameters!==a||e.type!==o||e.body!==s?r(G(t,n,i,a,o,s),e):e}function X(e,r,i,a,o){var s=t(160);return s.decorators=po(e),s.modifiers=po(r),s.name=lo(i),s.typeParameters=void 0,s.parameters=n(a),s.body=o,s}function Y(e,t,n,i,a,o){return e.decorators!==t||e.modifiers!==n||e.name!==i||e.parameters!==a||e.body!==o?r(X(t,n,i,a,o),e):e}function Z(e,t,r){return it(161,e,t,r)}function $(e,t,r,n){return at(e,t,r,n)}function et(e,t,r){return it(162,e,t,r)}function tt(e,t,r,n){return at(e,t,r,n)}function rt(e,r,i,a){var o=t(163);return o.decorators=po(e),o.modifiers=po(r),o.parameters=n(i),o.type=a,o}function nt(e,t,n,i,a){return e.parameters!==i||e.type!==a||e.decorators!==t||e.modifiers!==n?r(rt(t,n,i,a),e):e}function it(e,r,n,i,a){var o=t(e);return o.typeParameters=po(r),o.parameters=po(n),o.type=i,o.typeArguments=po(a),o}function at(e,t,n,i){return e.typeParameters!==t||e.parameters!==n||e.type!==i?r(it(e.kind,t,n,i),e):e}function ot(e){return t(e)}function st(e,r){var n=t(164);return n.parameterName=lo(e),n.type=r,n}function ct(e,t,n){return e.parameterName!==t||e.type!==n?r(st(t,n),e):e}function ut(r,n){var i=t(165);return i.typeName=lo(r),i.typeArguments=n&&e.parenthesizeTypeParameters(n),i}function lt(e,t,n){return e.typeName!==t||e.typeArguments!==n?r(ut(t,n),e):e}function _t(e,t,r){return it(166,e,t,r)}function dt(e,t,r,n){return at(e,t,r,n)}function pt(e,t,r){return it(167,e,t,r)}function ft(e,t,r,n){return at(e,t,r,n)}function mt(e){var r=t(168);return r.exprName=e,r}function gt(e,t){return e.exprName!==t?r(mt(t),e):e}function vt(e){var r=t(169);return r.members=n(e),r}function yt(e,t){return e.members!==t?r(vt(t),e):e}function ht(r){var n=t(170);return n.elementType=e.parenthesizeArrayTypeMember(r),n}function bt(e,t){return e.elementType!==t?r(ht(t),e):e}function xt(e){var r=t(171);return r.elementTypes=n(e),r}function Dt(e,t){return e.elementTypes!==t?r(xt(t),e):e}function St(r){var n=t(172);return n.type=e.parenthesizeArrayTypeMember(r),n}function Ct(e,t){return e.type!==t?r(St(t),e):e}function kt(e){var r=t(173);return r.type=e,r}function Tt(e,t){return e.type!==t?r(kt(t),e):e}function Et(e){return Pt(174,e)}function Nt(e,t){return wt(e,t)}function At(e){return Pt(175,e)}function Ft(e,t){return wt(e,t)}function Pt(r,n){var i=t(r);return i.types=e.parenthesizeElementTypeMembers(n),i}function wt(e,t){return e.types!==t?r(Pt(e.kind,t),e):e}function It(r,n,i,a){var o=t(176);return o.checkType=e.parenthesizeConditionalTypeMember(r),o.extendsType=e.parenthesizeConditionalTypeMember(n),o.trueType=i,o.falseType=a,o}function Ot(e,t,n,i,a){return e.checkType!==t||e.extendsType!==n||e.trueType!==i||e.falseType!==a?r(It(t,n,i,a),e):e}function Mt(e){var r=t(177);return r.typeParameter=e,r}function Lt(e,t){return e.typeParameter!==t?r(Mt(t),e):e}function Rt(r,n,i,a){var o=t(184);return o.argument=r,o.qualifier=n,o.typeArguments=e.parenthesizeTypeParameters(i),o.isTypeOf=a,o}function Bt(e,t,n,i,a){return e.argument!==t||e.qualifier!==n||e.typeArguments!==i||e.isTypeOf!==a?r(Rt(t,n,i,a),e):e}function jt(e){var r=t(178);return r.type=e,r}function Jt(e,t){return e.type!==t?r(jt(t),e):e}function zt(){return t(179)}function Vt(r,n){var i=t(180);return i.operator="number"==typeof r?r:130,i.type=e.parenthesizeElementTypeMember("number"==typeof r?n:r),i}function Ut(e,t){return e.type!==t?r(Vt(e.operator,t),e):e}function Kt(r,n){var i=t(181);return i.objectType=e.parenthesizeElementTypeMember(r),i.indexType=n,i}function qt(e,t,n){return e.objectType!==t||e.indexType!==n?r(Kt(t,n),e):e}function Wt(e,r,n,i){var a=t(182);return a.readonlyToken=e,a.typeParameter=r,a.questionToken=n,a.type=i,a}function Ht(e,t,n,i,a){return e.readonlyToken!==t||e.typeParameter!==n||e.questionToken!==i||e.type!==a?r(Wt(t,n,i,a),e):e}function Gt(e){var r=t(183);return r.literal=e,r}function Qt(e,t){return e.literal!==t?r(Gt(t),e):e}function Xt(e){var r=t(185);return r.elements=n(e),r}function Yt(e,t){return e.elements!==t?r(Xt(t),e):e}function Zt(e){var r=t(186);return r.elements=n(e),r}function $t(e,t){return e.elements!==t?r(Zt(t),e):e}function er(e,r,n,i){var a=t(187);return a.dotDotDotToken=e,a.propertyName=lo(r),a.name=lo(n),a.initializer=i,a}function tr(e,t,n,i,a){return e.propertyName!==n||e.dotDotDotToken!==t||e.name!==i||e.initializer!==a?r(er(t,n,i,a),e):e}function rr(r,i){var a=t(188);return a.elements=e.parenthesizeListElements(n(r)),i&&(a.multiLine=!0),a}function nr(e,t){return e.elements!==t?r(rr(t,e.multiLine),e):e}function ir(e,r){var i=t(189);return i.properties=n(e),r&&(i.multiLine=!0),i}function ar(e,t){return e.properties!==t?r(ir(t,e.multiLine),e):e}function or(r,n){var i=t(190);return i.expression=e.parenthesizeForAccess(r),i.name=lo(n),yo(i,131072),i}function sr(t,n,i){return t.expression!==n||t.name!==i?r(yo(or(n,i),e.getEmitFlags(t)),t):t}function cr(r,n){var i=t(191);return i.expression=e.parenthesizeForAccess(r),i.argumentExpression=_o(n),i}function ur(e,t,n){return e.expression!==t||e.argumentExpression!==n?r(cr(t,n),e):e}function lr(r,i,a){var o=t(192);return o.expression=e.parenthesizeForAccess(r),o.typeArguments=po(i),o.arguments=e.parenthesizeListElements(n(a)),o}function _r(e,t,n,i){return e.expression!==t||e.typeArguments!==n||e.arguments!==i?r(lr(t,n,i),e):e}function dr(r,i,a){var o=t(193);return o.expression=e.parenthesizeForNew(r),o.typeArguments=po(i),o.arguments=a?e.parenthesizeListElements(n(a)):void 0,o}function pr(e,t,n,i){return e.expression!==t||e.typeArguments!==n||e.arguments!==i?r(dr(t,n,i),e):e}function fr(r,n,i){var a=t(194);return a.tag=e.parenthesizeForAccess(r),i?(a.typeArguments=po(n),a.template=i):(a.typeArguments=void 0,a.template=n),a}function mr(e,t,n,i){return e.tag!==t||(i?e.typeArguments!==n||e.template!==i:void 0!==e.typeArguments||e.template!==n)?r(fr(t,n,i),e):e}function gr(r,n){var i=t(195);return i.type=r,i.expression=e.parenthesizePrefixOperand(n),i}function vr(e,t,n){return e.type!==t||e.expression!==n?r(gr(t,n),e):e}function yr(e){var r=t(196);return r.expression=e,r}function hr(e,t){return e.expression!==t?r(yr(t),e):e}function br(e,r,i,a,o,s,c){var u=t(197);return u.modifiers=po(e),u.asteriskToken=r,u.name=lo(i),u.typeParameters=po(a),u.parameters=n(o),u.type=s,u.body=c,u}function xr(e,t,n,i,a,o,s,c){return e.name!==i||e.modifiers!==t||e.asteriskToken!==n||e.typeParameters!==a||e.parameters!==o||e.type!==s||e.body!==c?r(br(t,n,i,a,o,s,c),e):e}function Dr(r,i,a,o,s,c){var u=t(198);return u.modifiers=po(r),u.typeParameters=po(i),u.parameters=n(a),u.type=o,u.equalsGreaterThanToken=s||h(37),u.body=e.parenthesizeConciseBody(c),u}function Sr(e,t,n,i,a,o,s){return e.modifiers!==t||e.typeParameters!==n||e.parameters!==i||e.type!==a||e.equalsGreaterThanToken!==o||e.body!==s?r(Dr(t,n,i,a,o,s),e):e}function Cr(r){var n=t(199);return n.expression=e.parenthesizePrefixOperand(r),n}function kr(e,t){return e.expression!==t?r(Cr(t),e):e}function Tr(r){var n=t(200);return n.expression=e.parenthesizePrefixOperand(r),n}function Er(e,t){return e.expression!==t?r(Tr(t),e):e}function Nr(r){var n=t(201);return n.expression=e.parenthesizePrefixOperand(r),n}function Ar(e,t){return e.expression!==t?r(Nr(t),e):e}function Fr(r){var n=t(202);return n.expression=e.parenthesizePrefixOperand(r),n}function Pr(e,t){return e.expression!==t?r(Fr(t),e):e}function wr(r,n){var i=t(203);return i.operator=r,i.operand=e.parenthesizePrefixOperand(n),i}function Ir(e,t){return e.operand!==t?r(wr(e.operator,t),e):e}function Or(r,n){var i=t(204);return i.operand=e.parenthesizePostfixOperand(r),i.operator=n,i}function Mr(e,t){return e.operand!==t?r(Or(t,e.operator),e):e}function Lr(r,n,i){var a=t(205),o=fo(n),s=o.kind;return a.left=e.parenthesizeBinaryOperand(s,r,!0,void 0),a.operatorToken=o,a.right=e.parenthesizeBinaryOperand(s,i,!1,a.left),a}function Rr(e,t,n,i){return e.left!==t||e.right!==n?r(Lr(t,i||e.operatorToken,n),e):e}function Br(r,n,i,a,o){var s=t(206);return s.condition=e.parenthesizeForConditionalHead(r),s.questionToken=o?n:h(56),s.whenTrue=e.parenthesizeSubexpressionOfConditionalExpression(o?i:n),s.colonToken=o?a:h(57),s.whenFalse=e.parenthesizeSubexpressionOfConditionalExpression(o?o:i),s}function jr(e,t,n,i,a,o){return e.condition!==t||e.questionToken!==n||e.whenTrue!==i||e.colonToken!==a||e.whenFalse!==o?r(Br(t,n,i,a,o),e):e}function Jr(e,r){var i=t(207);return i.head=e,i.templateSpans=n(r),i}function zr(e,t,n){return e.head!==t||e.templateSpans!==n?r(Jr(t,n),e):e}function Vr(e){var r=t(15);return r.text=e,r}function Ur(e){var r=t(16);return r.text=e,r}function Kr(e){var r=t(17);return r.text=e,r}function qr(e){var r=t(14);return r.text=e,r}function Wr(e,r){var n=t(208);return n.asteriskToken=e&&40===e.kind?e:void 0,n.expression=e&&40!==e.kind?e:r,n}function Hr(e,t,n){return e.expression!==n||e.asteriskToken!==t?r(Wr(t,n),e):e}function Gr(r){var n=t(209);return n.expression=e.parenthesizeExpressionForList(r),n}function Qr(e,t){return e.expression!==t?r(Gr(t),e):e}function Xr(e,r,i,a,o){var s=t(210);return s.decorators=void 0,s.modifiers=po(e),s.name=lo(r),s.typeParameters=po(i),s.heritageClauses=po(a),s.members=n(o),s}function Yr(e,t,n,i,a,o){return e.modifiers!==t||e.name!==n||e.typeParameters!==i||e.heritageClauses!==a||e.members!==o?r(Xr(t,n,i,a,o),e):e}function Zr(){return t(211)}function $r(r,n){var i=t(212);return i.expression=e.parenthesizeForAccess(n),i.typeArguments=po(r),i}function en(e,t,n){return e.typeArguments!==t||e.expression!==n?r($r(t,n),e):e}function tn(e,r){var n=t(213);return n.expression=e,n.type=r,n}function rn(e,t,n){return e.expression!==t||e.type!==n?r(tn(t,n),e):e}function nn(r){var n=t(214);return n.expression=e.parenthesizeForAccess(r),n}function an(e,t){return e.expression!==t?r(nn(t),e):e}function on(e,r){var n=t(215);return n.keywordToken=e,n.name=r,n}function sn(e,t){return e.name!==t?r(on(e.keywordToken,t),e):e}function cn(e,r){var n=t(217);return n.expression=e,n.literal=r,n}function un(e,t,n){return e.expression!==t||e.literal!==n?r(cn(t,n),e):e}function ln(){return t(218)}function _n(e,r){var i=t(219);return i.statements=n(e),r&&(i.multiLine=r),i}function dn(e,t){return e.statements!==t?r(_n(t,e.multiLine),e):e}function pn(r,n){var i=t(220);return i.decorators=void 0,i.modifiers=po(r),i.declarationList=e.isArray(n)?Qn(n):n,i}function fn(e,t,n){return e.modifiers!==t||e.declarationList!==n?r(pn(t,n),e):e}function mn(){return t(221)}function gn(r){var n=t(222);return n.expression=e.parenthesizeExpressionForExpressionStatement(r),n}function vn(e,t){return e.expression!==t?r(gn(t),e):e}function yn(e,r,n){var i=t(223);return i.expression=e,i.thenStatement=r,i.elseStatement=n,i}function hn(e,t,n,i){return e.expression!==t||e.thenStatement!==n||e.elseStatement!==i?r(yn(t,n,i),e):e}function bn(e,r){var n=t(224);return n.statement=e,n.expression=r,n}function xn(e,t,n){return e.statement!==t||e.expression!==n?r(bn(t,n),e):e}function Dn(e,r){var n=t(225);return n.expression=e,n.statement=r,n}function Sn(e,t,n){return e.expression!==t||e.statement!==n?r(Dn(t,n),e):e}function Cn(e,r,n,i){var a=t(226);return a.initializer=e,a.condition=r,a.incrementor=n,a.statement=i,a}function kn(e,t,n,i,a){return e.initializer!==t||e.condition!==n||e.incrementor!==i||e.statement!==a?r(Cn(t,n,i,a),e):e}function Tn(e,r,n){var i=t(227);return i.initializer=e,i.expression=r,i.statement=n,i}function En(e,t,n,i){return e.initializer!==t||e.expression!==n||e.statement!==i?r(Tn(t,n,i),e):e}function Nn(e,r,n,i){var a=t(228);return a.awaitModifier=e,a.initializer=r,a.expression=n,a.statement=i,a}function An(e,t,n,i,a){return e.awaitModifier!==t||e.initializer!==n||e.expression!==i||e.statement!==a?r(Nn(t,n,i,a),e):e}function Fn(e){var r=t(229);return r.label=lo(e),r}function Pn(e,t){return e.label!==t?r(Fn(t),e):e}function wn(e){var r=t(230);return r.label=lo(e),r}function In(e,t){return e.label!==t?r(wn(t),e):e}function On(e){var r=t(231);return r.expression=e,r}function Mn(e,t){return e.expression!==t?r(On(t),e):e}function Ln(e,r){var n=t(232);return n.expression=e,n.statement=r,n}function Rn(e,t,n){return e.expression!==t||e.statement!==n?r(Ln(t,n),e):e}function Bn(r,n){var i=t(233);return i.expression=e.parenthesizeExpressionForList(r),i.caseBlock=n,i}function jn(e,t,n){return e.expression!==t||e.caseBlock!==n?r(Bn(t,n),e):e}function Jn(e,r){var n=t(234);return n.label=lo(e),n.statement=r,n}function zn(e,t,n){return e.label!==t||e.statement!==n?r(Jn(t,n),e):e}function Vn(e){var r=t(235);return r.expression=e,r}function Un(e,t){return e.expression!==t?r(Vn(t),e):e}function Kn(e,r,n){var i=t(236);return i.tryBlock=e,i.catchClause=r,i.finallyBlock=n,i}function qn(e,t,n,i){return e.tryBlock!==t||e.catchClause!==n||e.finallyBlock!==i?r(Kn(t,n,i),e):e}function Wn(){return t(237)}function Hn(r,n,i){var a=t(238);return a.name=lo(r),a.type=n,a.initializer=void 0!==i?e.parenthesizeExpressionForList(i):void 0,a}function Gn(e,t,n,i){return e.name!==t||e.type!==n||e.initializer!==i?r(Hn(t,n,i),e):e}function Qn(e,r){void 0===r&&(r=0);var i=t(239);return i.flags|=3&r,i.declarations=n(e),i}function Xn(e,t){return e.declarations!==t?r(Qn(t,e.flags),e):e}function Yn(e,r,i,a,o,s,c,u){var l=t(240);return l.decorators=po(e),l.modifiers=po(r),l.asteriskToken=i,l.name=lo(a),l.typeParameters=po(o),l.parameters=n(s),l.type=c,l.body=u,l}function Zn(e,t,n,i,a,o,s,c,u){return e.decorators!==t||e.modifiers!==n||e.asteriskToken!==i||e.name!==a||e.typeParameters!==o||e.parameters!==s||e.type!==c||e.body!==u?r(Yn(t,n,i,a,o,s,c,u),e):e}function $n(e,r,i,a,o,s){var c=t(241);return c.decorators=po(e),c.modifiers=po(r),c.name=lo(i),c.typeParameters=po(a),c.heritageClauses=po(o),c.members=n(s),c}function ei(e,t,n,i,a,o,s){return e.decorators!==t||e.modifiers!==n||e.name!==i||e.typeParameters!==a||e.heritageClauses!==o||e.members!==s?r($n(t,n,i,a,o,s),e):e}function ti(e,r,i,a,o,s){var c=t(242);return c.decorators=po(e),c.modifiers=po(r),c.name=lo(i),c.typeParameters=po(a),c.heritageClauses=po(o),c.members=n(s),c}function ri(e,t,n,i,a,o,s){return e.decorators!==t||e.modifiers!==n||e.name!==i||e.typeParameters!==a||e.heritageClauses!==o||e.members!==s?r(ti(t,n,i,a,o,s),e):e}function ni(e,r,n,i,a){var o=t(243);return o.decorators=po(e),o.modifiers=po(r),o.name=lo(n),o.typeParameters=po(i),o.type=a,o}function ii(e,t,n,i,a,o){return e.decorators!==t||e.modifiers!==n||e.name!==i||e.typeParameters!==a||e.type!==o?r(ni(t,n,i,a,o),e):e}function ai(e,r,i,a){var o=t(244);return o.decorators=po(e),o.modifiers=po(r),o.name=lo(i),o.members=n(a),o}function oi(e,t,n,i,a){return e.decorators!==t||e.modifiers!==n||e.name!==i||e.members!==a?r(ai(t,n,i,a),e):e}function si(e,r,n,i,a){void 0===a&&(a=0);var o=t(245);return o.flags|=532&a,o.decorators=po(e),o.modifiers=po(r),o.name=n,o.body=i,o}function ci(e,t,n,i,a){return e.decorators!==t||e.modifiers!==n||e.name!==i||e.body!==a?r(si(t,n,i,a,e.flags),e):e}function ui(e){var r=t(246);return r.statements=n(e),r}function li(e,t){return e.statements!==t?r(ui(t),e):e}function _i(e){var r=t(247);return r.clauses=n(e),r}function di(e,t){return e.clauses!==t?r(_i(t),e):e}function pi(e){var r=t(248);return r.name=lo(e),r}function fi(e,t){return e.name!==t?r(pi(t),e):e}function mi(e,r,n,i){var a=t(249);return a.decorators=po(e),a.modifiers=po(r),a.name=lo(n),a.moduleReference=i,a}function gi(e,t,n,i,a){return e.decorators!==t||e.modifiers!==n||e.name!==i||e.moduleReference!==a?r(mi(t,n,i,a),e):e}function vi(e,r,n,i){var a=t(250);return a.decorators=po(e),a.modifiers=po(r),a.importClause=n,a.moduleSpecifier=i,a}function yi(e,t,n,i,a){return e.decorators!==t||e.modifiers!==n||e.importClause!==i||e.moduleSpecifier!==a?r(vi(t,n,i,a),e):e}function hi(e,r){var n=t(251);return n.name=e,n.namedBindings=r,n}function bi(e,t,n){return e.name!==t||e.namedBindings!==n?r(hi(t,n),e):e}function xi(e){var r=t(252);return r.name=e,r}function Di(e,t){return e.name!==t?r(xi(t),e):e}function Si(e){var r=t(253);return r.elements=n(e),r}function Ci(e,t){return e.elements!==t?r(Si(t),e):e}function ki(e,r){var n=t(254);return n.propertyName=e,n.name=r,n}function Ti(e,t,n){return e.propertyName!==t||e.name!==n?r(ki(t,n),e):e}function Ei(r,n,i,a){var o=t(255);return o.decorators=po(r),o.modifiers=po(n),o.isExportEquals=i,o.expression=i?e.parenthesizeBinaryOperand(60,a,!1,void 0):e.parenthesizeDefaultExpression(a),o}function Ni(e,t,n,i){return e.decorators!==t||e.modifiers!==n||e.expression!==i?r(Ei(t,n,e.isExportEquals,i),e):e}function Ai(e,r,n,i){var a=t(256);return a.decorators=po(e),a.modifiers=po(r),a.exportClause=n,a.moduleSpecifier=i,a}function Fi(e,t,n,i,a){return e.decorators!==t||e.modifiers!==n||e.exportClause!==i||e.moduleSpecifier!==a?r(Ai(t,n,i,a),e):e}function Pi(e){var r=t(257);return r.elements=n(e),r}function wi(e,t){return e.elements!==t?r(Pi(t),e):e}function Ii(e,r){var n=t(258);return n.propertyName=lo(e),n.name=lo(r),n}function Oi(e,t,n){return e.propertyName!==t||e.name!==n?r(Ii(t,n),e):e}function Mi(e){var r=t(260);return r.expression=e,r}function Li(e,t){return e.expression!==t?r(Mi(t),e):e}function Ri(e){var r=t(289);return r.type=e,r}function Bi(e,t){var r=Vi(308,"type");return r.typeExpression=e,r.comment=t,r}function ji(e,t){var r=Vi(306,"returns");return r.typeExpression=e,r.comment=t,r}function Ji(e,t,r,n){var i=Vi(305,"param");return i.typeExpression=r,i.name=e,i.isBracketed=t,i.comment=n,i}function zi(e,r){var n=t(297);return n.comment=e,n.tags=r,n}function Vi(e,r){var n=t(e);return n.tagName=_(r),n}function Ui(e,r,i){var a=t(261);return a.openingElement=e,a.children=n(r),a.closingElement=i,a}function Ki(e,t,n,i){return e.openingElement!==t||e.children!==n||e.closingElement!==i?r(Ui(t,n,i),e):e}function qi(e,r,n){var i=t(262);return i.tagName=e,i.typeArguments=po(r),i.attributes=n,i}function Wi(e,t,n,i){return e.tagName!==t||e.typeArguments!==n||e.attributes!==i?r(qi(t,n,i),e):e}function Hi(e,r,n){var i=t(263);return i.tagName=e,i.typeArguments=po(r),i.attributes=n,i}function Gi(e,t,n,i){return e.tagName!==t||e.typeArguments!==n||e.attributes!==i?r(Hi(t,n,i),e):e}function Qi(e){var r=t(264);return r.tagName=e,r}function Xi(e,t){return e.tagName!==t?r(Qi(t),e):e}function Yi(e,r,i){var a=t(265);return a.openingFragment=e,a.children=n(r),a.closingFragment=i,a}function Zi(e,r){var n=t(11);return n.text=e,n.containsOnlyTriviaWhiteSpaces=!!r,n}function $i(e,t,n){return e.text!==t||e.containsOnlyTriviaWhiteSpaces!==n?r(Zi(t,n),e):e}function ea(){return t(266)}function ta(){return t(267)}function ra(e,t,n,i){return e.openingFragment!==t||e.children!==n||e.closingFragment!==i?r(Yi(t,n,i),e):e}function na(e,r){var n=t(268);return n.name=e,n.initializer=r,n}function ia(e,t,n){return e.name!==t||e.initializer!==n?r(na(t,n),e):e}function aa(e){var r=t(269);return r.properties=n(e),r}function oa(e,t){return e.properties!==t?r(aa(t),e):e}function sa(e){var r=t(270);return r.expression=e,r}function ca(e,t){return e.expression!==t?r(sa(t),e):e}function ua(e,r){var n=t(271);return n.dotDotDotToken=e,n.expression=r,n}function la(e,t){return e.expression!==t?r(ua(e.dotDotDotToken,t),e):e}function _a(r,i){var a=t(272);return a.expression=e.parenthesizeExpressionForList(r),a.statements=n(i),a}function da(e,t,n){return e.expression!==t||e.statements!==n?r(_a(t,n),e):e}function pa(e){var r=t(273);return r.statements=n(e),r}function fa(e,t){return e.statements!==t?r(pa(t),e):e}function ma(e,r){var i=t(274);return i.token=e,i.types=n(r),i}function ga(e,t){return e.types!==t?r(ma(e.token,t),e):e}function va(r,n){var i=t(275);return i.variableDeclaration=e.isString(r)?Hn(r):r,i.block=n,i}function ya(e,t,n){return e.variableDeclaration!==t||e.block!==n?r(va(t,n),e):e}function ha(r,n){var i=t(276);return i.name=lo(r),i.questionToken=void 0,i.initializer=e.parenthesizeExpressionForList(n),i}function ba(e,t,n){return e.name!==t||e.initializer!==n?r(ha(t,n),e):e}function xa(r,n){var i=t(277);return i.name=lo(r),i.objectAssignmentInitializer=void 0!==n?e.parenthesizeExpressionForList(n):void 0,i}function Da(e,t,n){return e.name!==t||e.objectAssignmentInitializer!==n?r(xa(t,n),e):e}function Sa(r){var n=t(278);return n.expression=e.parenthesizeExpressionForList(r),n}function Ca(e,t){return e.expression!==t?r(Sa(t),e):e}function ka(r,n){var i=t(279);return i.name=lo(r),i.initializer=n&&e.parenthesizeExpressionForList(n),i}function Ta(e,t,n){return e.name!==t||e.initializer!==n?r(ka(t,n),e):e}function Ea(e,i,a,o,s,c,u){if(e.statements!==i||void 0!==a&&e.isDeclarationFile!==a||void 0!==o&&e.referencedFiles!==o||void 0!==s&&e.typeReferenceDirectives!==s||void 0!==u&&e.libReferenceDirectives!==u||void 0!==c&&e.hasNoDefaultLib!==c){var l=t(285);return l.flags|=e.flags,l.statements=n(i),l.endOfFileToken=e.endOfFileToken,l.fileName=e.fileName,l.path=e.path,l.text=e.text,l.isDeclarationFile=void 0===a?e.isDeclarationFile:a,l.referencedFiles=void 0===o?e.referencedFiles:o,l.typeReferenceDirectives=void 0===s?e.typeReferenceDirectives:s,l.hasNoDefaultLib=void 0===c?e.hasNoDefaultLib:c,l.libReferenceDirectives=void 0===u?e.libReferenceDirectives:u,void 0!==e.amdDependencies&&(l.amdDependencies=e.amdDependencies),void 0!==e.moduleName&&(l.moduleName=e.moduleName),void 0!==e.languageVariant&&(l.languageVariant=e.languageVariant),void 0!==e.renamedDependencies&&(l.renamedDependencies=e.renamedDependencies),void 0!==e.languageVersion&&(l.languageVersion=e.languageVersion),void 0!==e.scriptKind&&(l.scriptKind=e.scriptKind),void 0!==e.externalModuleIndicator&&(l.externalModuleIndicator=e.externalModuleIndicator),void 0!==e.commonJsModuleIndicator&&(l.commonJsModuleIndicator=e.commonJsModuleIndicator),void 0!==e.identifiers&&(l.identifiers=e.identifiers),void 0!==e.nodeCount&&(l.nodeCount=e.nodeCount),void 0!==e.identifierCount&&(l.identifierCount=e.identifierCount),void 0!==e.symbolCount&&(l.symbolCount=e.symbolCount),void 0!==e.parseDiagnostics&&(l.parseDiagnostics=e.parseDiagnostics),void 0!==e.bindDiagnostics&&(l.bindDiagnostics=e.bindDiagnostics),void 0!==e.bindSuggestionDiagnostics&&(l.bindSuggestionDiagnostics=e.bindSuggestionDiagnostics),void 0!==e.lineMap&&(l.lineMap=e.lineMap),void 0!==e.classifiableNames&&(l.classifiableNames=e.classifiableNames),void 0!==e.resolvedModules&&(l.resolvedModules=e.resolvedModules),void 0!==e.resolvedTypeReferenceDirectiveNames&&(l.resolvedTypeReferenceDirectiveNames=e.resolvedTypeReferenceDirectiveNames),void 0!==e.imports&&(l.imports=e.imports),void 0!==e.moduleAugmentations&&(l.moduleAugmentations=e.moduleAugmentations),void 0!==e.pragmas&&(l.pragmas=e.pragmas),void 0!==e.localJsxFactory&&(l.localJsxFactory=e.localJsxFactory),void 0!==e.localJsxNamespace&&(l.localJsxNamespace=e.localJsxNamespace),r(l,e)}return e}function Na(e){var t=i(e);return t.pos=e.pos,t.end=e.end,t.parent=e.parent,t}function Aa(e){var r=t(313);return r.original=e,vo(r,e),r}function Fa(e){var r=t(317);return r.emitNode={},r.original=e,r}function Pa(e){var r=t(316);return r.emitNode={},r.original=e,r}function wa(e,r){var n=t(314);return n.expression=e,n.original=r,vo(n,r),n}function Ia(e,t){return e.expression!==t?r(wa(t,e.original),e):e}function Oa(t){if(e.nodeIsSynthesized(t)&&!e.isParseTreeNode(t)&&!t.original&&!t.emitNode&&!t.id){if(315===t.kind)return t.elements;if(e.isBinaryExpression(t)&&27===t.operatorToken.kind)return[t.left,t.right]}return t}function Ma(r){var i=t(315);return i.elements=n(e.sameFlatMap(r,Oa)),i}function La(e,t){return e.elements!==t?r(Ma(t),e):e}function Ra(t,r){void 0===r&&(r=e.emptyArray);var n=e.createNode(286);return n.prepends=r,n.sourceFiles=t,n}function Ba(){return Go||(Go=e.arrayToMap([e.valuesHelper,e.readHelper,e.spreadHelper,e.restHelper,e.decorateHelper,e.metadataHelper,e.paramHelper,e.awaiterHelper,e.assignHelper,e.awaitHelper,e.asyncGeneratorHelper,e.asyncDelegator,e.asyncValues,e.extendsHelper,e.templateObjectHelper,e.generatorHelper,e.importStarHelper,e.importDefaultHelper],function(e){return e.name}))}function ja(){var t=e.createNode(287);return t.prologues=e.emptyArray,t.referencedFiles=e.emptyArray,t.libReferenceDirectives=e.emptyArray,t.getLineAndCharacterOfPosition=function(r){return e.getLineAndCharacterOfPosition(t,r)},t}function Ja(t,r,n){var i,a,o=ja();if(e.isString(t))o.fileName="",o.text=t,o.sourceMapPath=r,o.sourceMapText=n;else if(e.Debug.assert("js"===r||"dts"===r),o.fileName=("js"===r?t.javascriptPath:t.declarationPath)||"",o.sourceMapPath="js"===r?t.javascriptMapPath:t.declarationMapPath,Object.defineProperties(o,{text:{get:function(){return"js"===r?t.javascriptText:t.declarationText}},sourceMapText:{get:function(){return"js"===r?t.javascriptMapText:t.declarationMapText}}}),t.buildInfo&&t.buildInfo.bundle&&(o.oldFileOfCurrentEmit=t.oldFileOfCurrentEmit,e.Debug.assert(void 0===n||"boolean"==typeof n),i=n,a="js"===r?t.buildInfo.bundle.js:t.buildInfo.bundle.dts,o.oldFileOfCurrentEmit))return Va(o,e.Debug.assertDefined(a)),o;return e.Debug.assert(!o.oldFileOfCurrentEmit),za(o,a,i),o}function za(t,r,n){for(var i,a,o,s,c,u,l=0,_=r?r.sections:e.emptyArray;l<_.length;l++){var d=_[l];switch(d.kind){case"prologue":(i||(i=[])).push(Ka(d,t));break;case"emitHelpers":(a||(a=[])).push(Ba().get(d.data));break;case"no-default-lib":t.hasNoDefaultLib=!0;break;case"reference":(o||(o=[])).push({pos:-1,end:-1,fileName:d.data});break;case"type":(s||(s=[])).push(d.data);break;case"lib":(c||(c=[])).push({pos:-1,end:-1,fileName:d.data});break;case"prepend":for(var p=Ka(d,t),f=void 0,m=0,g=d.texts;m<g.length;m++){var v=g[m];n&&"internal"===v.kind||(f||(f=[])).push(Ka(v,t))}p.texts=f||e.emptyArray,(u||(u=[])).push(p);break;case"internal":if(n)break;case"text":(u||(u=[])).push(Ka(d,t));break;default:e.Debug.assertNever(d)}}t.prologues=i||e.emptyArray,t.helpers=a,t.referencedFiles=o||e.emptyArray,t.typeReferenceDirectives=s,t.libReferenceDirectives=c||e.emptyArray,t.texts=u||[Ka({kind:"text",pos:0,end:t.text.length},t)]}function Va(t,r){e.Debug.assert(!!t.oldFileOfCurrentEmit);for(var n,i,a=0,o=r.sections;a<o.length;a++){var s=o[a];switch(s.kind){case"internal":case"text":(n||(n=[])).push(Ka(s,t));break;case"no-default-lib":case"reference":case"type":case"lib":(i||(i=[])).push(qa(s,t));break;case"prologue":case"emitHelpers":case"prepend":break;default:e.Debug.assertNever(s)}}return t.texts=n||e.emptyArray,t.helpers=e.map(r.sources&&r.sources.helpers,function(e){return Ba().get(e)}),t.syntheticReferences=i,t}function Ua(t){switch(t){case"prologue":return 280;case"prepend":return 281;case"internal":return 283;case"text":return 282;case"emitHelpers":case"no-default-lib":case"reference":case"type":case"lib":return e.Debug.fail("BundleFileSectionKind: "+t+" not yet mapped to SyntaxKind");default:return e.Debug.assertNever(t)}}function Ka(t,r){var n=e.createNode(Ua(t.kind),t.pos,t.end);return n.parent=r,n.data=t.data,n}function qa(t,r){var n=e.createNode(284,t.pos,t.end);return n.parent=r,n.data=t.data,n.section=t,n}function Wa(t,r,n,i,a,o,s,c,u,l,_){var d=e.createNode(288);if(e.isString(t))d.javascriptText=t,d.javascriptMapPath=n,d.javascriptMapText=i,d.declarationText=r,d.declarationMapPath=a,d.declarationMapText=o,d.javascriptPath=s,d.declarationPath=c,d.buildInfoPath=u,d.buildInfo=l,d.oldFileOfCurrentEmit=_;else{var p,f=e.createMap(),m=function(e){if(void 0===e)return void 0;var r=f.get(e);return void 0===r&&(r=t(e),f.set(e,void 0!==r?r:!1)),r!==!1?r:void 0},g=function(e){var t=m(e);return void 0!==t?t:"/* Input file "+e+" was missing */\r\n"},v=function(t){if(void 0===p){var r=t();p=void 0!==r?e.getBuildInfo(r):!1}return p||void 0};d.javascriptPath=r,d.javascriptMapPath=n,d.declarationPath=e.Debug.assertDefined(i),d.declarationMapPath=a,d.buildInfoPath=o,Object.defineProperties(d,{javascriptText:{get:function(){return g(r)}},javascriptMapText:{get:function(){return m(n)}},declarationText:{get:function(){return g(e.Debug.assertDefined(i))}},declarationMapText:{get:function(){return m(a)}},buildInfo:{get:function(){return v(function(){return m(o)})}}})}return d}function Ha(t,r,n){return void 0===n&&(n=e.emptyArray),t.sourceFiles!==r||t.prepends!==n?Ra(r,n):t}function Ga(e,t,r){return lr(br(void 0,void 0,void 0,void 0,t?[t]:[],void 0,_n(e,!0)),void 0,r?[r]:[])}function Qa(e,t,r){return lr(Dr(void 0,void 0,t?[t]:[],void 0,void 0,_n(e,!0)),void 0,r?[r]:[])}function Xa(e,t){return Lr(e,27,t)}function Ya(e,t){return Lr(e,28,t)}function Za(e,t){return Lr(e,60,t)}function $a(e,t){return Lr(e,35,t)}function eo(e,t){return Lr(e,36,t)}function to(e,t){return Lr(e,38,t)}function ro(e,t){return Lr(e,39,t)}function no(e){return Or(e,44)}function io(e,t){return Lr(e,54,t)}function ao(e,t){return Lr(e,55,t)}function oo(e){return wr(52,e)}function so(){return Nr(a(0))}function co(e){return Ei(void 0,void 0,!1,e)}function uo(e){return Ai(void 0,void 0,Pi([Ii(void 0,e)]))}function lo(t){return e.isString(t)?_(t):t}function _o(t){return e.isString(t)||"number"==typeof t?a(t):t}function po(e){return e?n(e):void 0}function fo(e){return"number"==typeof e?h(e):e}function mo(t){t=e.getSourceFileOfNode(e.getParseTreeNode(t));var r=t&&t.emitNode,n=r&&r.annotatedNodes;if(n)for(var i=0,a=n;i<a.length;i++){var o=a[i];o.emitNode=void 0}}function go(t){if(!t.emitNode){if(e.isParseTreeNode(t)){if(285===t.kind)return t.emitNode={annotatedNodes:[t]};var r=e.getSourceFileOfNode(e.getParseTreeNode(e.getSourceFileOfNode(t)));go(r).annotatedNodes.push(t)}t.emitNode={}}return t.emitNode}function vo(e,t){return t&&(e.pos=t.pos,e.end=t.end),e}function yo(e,t){return go(e).flags=t,e}function ho(e,t){var r=go(e);return r.flags=r.flags|t,e}function bo(e){var t=e.emitNode;return t&&t.sourceMapRange||e}function xo(e,t){return go(e).sourceMapRange=t,e}function Do(t,r,n){return new(Qo||(Qo=e.objectAllocator.getSourceMapSourceConstructor()))(t,r,n)}function So(e,t){var r=e.emitNode,n=r&&r.tokenSourceMapRanges;return n&&n[t]}function Co(e,t,r){var n=go(e),i=n.tokenSourceMapRanges||(n.tokenSourceMapRanges=[]);return i[t]=r,e}function ko(e){var t=e.emitNode;return t&&t.startsOnNewLine}function To(e,t){return go(e).startsOnNewLine=t,e}function Eo(e){var t=e.emitNode;return t&&t.commentRange||e}function No(e,t){return go(e).commentRange=t,e}function Ao(e){var t=e.emitNode;return t&&t.leadingComments}function Fo(e,t){return go(e).leadingComments=t,e}function Po(t,r,n,i){return Fo(t,e.append(Ao(t),{kind:r,pos:-1,end:-1,hasTrailingNewLine:i,text:n}))}function wo(e){var t=e.emitNode;return t&&t.trailingComments}function Io(e,t){return go(e).trailingComments=t,e}function Oo(t,r,n,i){return Io(t,e.append(wo(t),{kind:r,pos:-1,end:-1,hasTrailingNewLine:i,text:n}))}function Mo(e,t){Fo(e,Ao(t)),Io(e,wo(t));var r=go(t);return r.leadingComments=void 0,r.trailingComments=void 0,e}function Lo(e){var t=e.emitNode;return t&&t.constantValue
}function Ro(e,t){var r=go(e);return r.constantValue=t,e}function Bo(t,r){var n=go(t);return n.helpers=e.append(n.helpers,r),t}function jo(t,r){if(e.some(r))for(var n=go(t),i=0,a=r;i<a.length;i++){var o=a[i];n.helpers=e.appendIfUnique(n.helpers,o)}return t}function Jo(t,r){var n=t.emitNode;if(n){var i=n.helpers;if(i)return e.orderedRemoveItem(i,r)}return!1}function zo(e){var t=e.emitNode;return t&&t.helpers}function Vo(t,r,n){var i=t.emitNode,a=i&&i.helpers;if(e.some(a)){for(var o=go(r),s=0,c=0;c<a.length;c++){var u=a[c];n(u)?(s++,o.helpers=e.appendIfUnique(o.helpers,u)):s>0&&(a[c-s]=u)}s>0&&(a.length-=s)}}function Uo(t,r){return t===r?0:t.priority===r.priority?0:void 0===t.priority?1:void 0===r.priority?-1:e.compareValues(t.priority,r.priority)}function Ko(e,t){if(e.original=t,t){var r=t.emitNode;r&&(e.emitNode=qo(r,e.emitNode))}return e}function qo(t,r){var n=t.flags,i=t.leadingComments,a=t.trailingComments,o=t.commentRange,s=t.sourceMapRange,c=t.tokenSourceMapRanges,u=t.constantValue,l=t.helpers,_=t.startsOnNewLine;return r||(r={}),i&&(r.leadingComments=e.addRange(i.slice(),r.leadingComments)),a&&(r.trailingComments=e.addRange(a.slice(),r.trailingComments)),n&&(r.flags=n),o&&(r.commentRange=o),s&&(r.sourceMapRange=s),c&&(r.tokenSourceMapRanges=Wo(c,r.tokenSourceMapRanges)),void 0!==u&&(r.constantValue=u),l&&(r.helpers=e.addRange(r.helpers,l)),void 0!==_&&(r.startsOnNewLine=_),r}function Wo(e,t){t||(t=[]);for(var r in e)t[r]=e[r];return t}e.updateNode=r,e.createNodeArray=n,e.getSynthesizedClone=i,e.createLiteral=a,e.createNumericLiteral=o,e.createBigIntLiteral=s,e.createStringLiteral=c,e.createRegularExpressionLiteral=u,e.createIdentifier=_,e.updateIdentifier=d;var Ho=0;e.createTempVariable=p,e.createLoopVariable=f,e.createUniqueName=m,e.createOptimisticUniqueName=g,e.createFileLevelUniqueName=v,e.getGeneratedNameForNode=y,e.createToken=h,e.createSuper=b,e.createThis=x,e.createNull=D,e.createTrue=S,e.createFalse=C,e.createModifier=k,e.createModifiersFromModifierFlags=T,e.createQualifiedName=E,e.updateQualifiedName=N,e.createComputedPropertyName=F,e.updateComputedPropertyName=P,e.createTypeParameterDeclaration=w,e.updateTypeParameterDeclaration=I,e.createParameter=O,e.updateParameter=M,e.createDecorator=L,e.updateDecorator=R,e.createPropertySignature=B,e.updatePropertySignature=j,e.createProperty=J,e.updateProperty=z,e.createMethodSignature=V,e.updateMethodSignature=U,e.createMethod=K,e.updateMethod=q,e.createConstructor=W,e.updateConstructor=H,e.createGetAccessor=G,e.updateGetAccessor=Q,e.createSetAccessor=X,e.updateSetAccessor=Y,e.createCallSignature=Z,e.updateCallSignature=$,e.createConstructSignature=et,e.updateConstructSignature=tt,e.createIndexSignature=rt,e.updateIndexSignature=nt,e.createSignatureDeclaration=it,e.createKeywordTypeNode=ot,e.createTypePredicateNode=st,e.updateTypePredicateNode=ct,e.createTypeReferenceNode=ut,e.updateTypeReferenceNode=lt,e.createFunctionTypeNode=_t,e.updateFunctionTypeNode=dt,e.createConstructorTypeNode=pt,e.updateConstructorTypeNode=ft,e.createTypeQueryNode=mt,e.updateTypeQueryNode=gt,e.createTypeLiteralNode=vt,e.updateTypeLiteralNode=yt,e.createArrayTypeNode=ht,e.updateArrayTypeNode=bt,e.createTupleTypeNode=xt,e.updateTupleTypeNode=Dt,e.createOptionalTypeNode=St,e.updateOptionalTypeNode=Ct,e.createRestTypeNode=kt,e.updateRestTypeNode=Tt,e.createUnionTypeNode=Et,e.updateUnionTypeNode=Nt,e.createIntersectionTypeNode=At,e.updateIntersectionTypeNode=Ft,e.createUnionOrIntersectionTypeNode=Pt,e.createConditionalTypeNode=It,e.updateConditionalTypeNode=Ot,e.createInferTypeNode=Mt,e.updateInferTypeNode=Lt,e.createImportTypeNode=Rt,e.updateImportTypeNode=Bt,e.createParenthesizedType=jt,e.updateParenthesizedType=Jt,e.createThisTypeNode=zt,e.createTypeOperatorNode=Vt,e.updateTypeOperatorNode=Ut,e.createIndexedAccessTypeNode=Kt,e.updateIndexedAccessTypeNode=qt,e.createMappedTypeNode=Wt,e.updateMappedTypeNode=Ht,e.createLiteralTypeNode=Gt,e.updateLiteralTypeNode=Qt,e.createObjectBindingPattern=Xt,e.updateObjectBindingPattern=Yt,e.createArrayBindingPattern=Zt,e.updateArrayBindingPattern=$t,e.createBindingElement=er,e.updateBindingElement=tr,e.createArrayLiteral=rr,e.updateArrayLiteral=nr,e.createObjectLiteral=ir,e.updateObjectLiteral=ar,e.createPropertyAccess=or,e.updatePropertyAccess=sr,e.createElementAccess=cr,e.updateElementAccess=ur,e.createCall=lr,e.updateCall=_r,e.createNew=dr,e.updateNew=pr,e.createTaggedTemplate=fr,e.updateTaggedTemplate=mr,e.createTypeAssertion=gr,e.updateTypeAssertion=vr,e.createParen=yr,e.updateParen=hr,e.createFunctionExpression=br,e.updateFunctionExpression=xr,e.createArrowFunction=Dr,e.updateArrowFunction=Sr,e.createDelete=Cr,e.updateDelete=kr,e.createTypeOf=Tr,e.updateTypeOf=Er,e.createVoid=Nr,e.updateVoid=Ar,e.createAwait=Fr,e.updateAwait=Pr,e.createPrefix=wr,e.updatePrefix=Ir,e.createPostfix=Or,e.updatePostfix=Mr,e.createBinary=Lr,e.updateBinary=Rr,e.createConditional=Br,e.updateConditional=jr,e.createTemplateExpression=Jr,e.updateTemplateExpression=zr,e.createTemplateHead=Vr,e.createTemplateMiddle=Ur,e.createTemplateTail=Kr,e.createNoSubstitutionTemplateLiteral=qr,e.createYield=Wr,e.updateYield=Hr,e.createSpread=Gr,e.updateSpread=Qr,e.createClassExpression=Xr,e.updateClassExpression=Yr,e.createOmittedExpression=Zr,e.createExpressionWithTypeArguments=$r,e.updateExpressionWithTypeArguments=en,e.createAsExpression=tn,e.updateAsExpression=rn,e.createNonNullExpression=nn,e.updateNonNullExpression=an,e.createMetaProperty=on,e.updateMetaProperty=sn,e.createTemplateSpan=cn,e.updateTemplateSpan=un,e.createSemicolonClassElement=ln,e.createBlock=_n,e.updateBlock=dn,e.createVariableStatement=pn,e.updateVariableStatement=fn,e.createEmptyStatement=mn,e.createExpressionStatement=gn,e.updateExpressionStatement=vn,e.createStatement=gn,e.updateStatement=vn,e.createIf=yn,e.updateIf=hn,e.createDo=bn,e.updateDo=xn,e.createWhile=Dn,e.updateWhile=Sn,e.createFor=Cn,e.updateFor=kn,e.createForIn=Tn,e.updateForIn=En,e.createForOf=Nn,e.updateForOf=An,e.createContinue=Fn,e.updateContinue=Pn,e.createBreak=wn,e.updateBreak=In,e.createReturn=On,e.updateReturn=Mn,e.createWith=Ln,e.updateWith=Rn,e.createSwitch=Bn,e.updateSwitch=jn,e.createLabel=Jn,e.updateLabel=zn,e.createThrow=Vn,e.updateThrow=Un,e.createTry=Kn,e.updateTry=qn,e.createDebuggerStatement=Wn,e.createVariableDeclaration=Hn,e.updateVariableDeclaration=Gn,e.createVariableDeclarationList=Qn,e.updateVariableDeclarationList=Xn,e.createFunctionDeclaration=Yn,e.updateFunctionDeclaration=Zn,e.createClassDeclaration=$n,e.updateClassDeclaration=ei,e.createInterfaceDeclaration=ti,e.updateInterfaceDeclaration=ri,e.createTypeAliasDeclaration=ni,e.updateTypeAliasDeclaration=ii,e.createEnumDeclaration=ai,e.updateEnumDeclaration=oi,e.createModuleDeclaration=si,e.updateModuleDeclaration=ci,e.createModuleBlock=ui,e.updateModuleBlock=li,e.createCaseBlock=_i,e.updateCaseBlock=di,e.createNamespaceExportDeclaration=pi,e.updateNamespaceExportDeclaration=fi,e.createImportEqualsDeclaration=mi,e.updateImportEqualsDeclaration=gi,e.createImportDeclaration=vi,e.updateImportDeclaration=yi,e.createImportClause=hi,e.updateImportClause=bi,e.createNamespaceImport=xi,e.updateNamespaceImport=Di,e.createNamedImports=Si,e.updateNamedImports=Ci,e.createImportSpecifier=ki,e.updateImportSpecifier=Ti,e.createExportAssignment=Ei,e.updateExportAssignment=Ni,e.createExportDeclaration=Ai,e.updateExportDeclaration=Fi,e.createNamedExports=Pi,e.updateNamedExports=wi,e.createExportSpecifier=Ii,e.updateExportSpecifier=Oi,e.createExternalModuleReference=Mi,e.updateExternalModuleReference=Li,e.createJSDocTypeExpression=Ri,e.createJSDocTypeTag=Bi,e.createJSDocReturnTag=ji,e.createJSDocParamTag=Ji,e.createJSDocComment=zi,e.createJsxElement=Ui,e.updateJsxElement=Ki,e.createJsxSelfClosingElement=qi,e.updateJsxSelfClosingElement=Wi,e.createJsxOpeningElement=Hi,e.updateJsxOpeningElement=Gi,e.createJsxClosingElement=Qi,e.updateJsxClosingElement=Xi,e.createJsxFragment=Yi,e.createJsxText=Zi,e.updateJsxText=$i,e.createJsxOpeningFragment=ea,e.createJsxJsxClosingFragment=ta,e.updateJsxFragment=ra,e.createJsxAttribute=na,e.updateJsxAttribute=ia,e.createJsxAttributes=aa,e.updateJsxAttributes=oa,e.createJsxSpreadAttribute=sa,e.updateJsxSpreadAttribute=ca,e.createJsxExpression=ua,e.updateJsxExpression=la,e.createCaseClause=_a,e.updateCaseClause=da,e.createDefaultClause=pa,e.updateDefaultClause=fa,e.createHeritageClause=ma,e.updateHeritageClause=ga,e.createCatchClause=va,e.updateCatchClause=ya,e.createPropertyAssignment=ha,e.updatePropertyAssignment=ba,e.createShorthandPropertyAssignment=xa,e.updateShorthandPropertyAssignment=Da,e.createSpreadAssignment=Sa,e.updateSpreadAssignment=Ca,e.createEnumMember=ka,e.updateEnumMember=Ta,e.updateSourceFileNode=Ea,e.getMutableClone=Na,e.createNotEmittedStatement=Aa,e.createEndOfDeclarationMarker=Fa,e.createMergeDeclarationMarker=Pa,e.createPartiallyEmittedExpression=wa,e.updatePartiallyEmittedExpression=Ia,e.createCommaList=Ma,e.updateCommaList=La,e.createBundle=Ra;var Go;e.createUnparsedSourceFile=Ja,e.createInputFiles=Wa,e.updateBundle=Ha,e.createImmediatelyInvokedFunctionExpression=Ga,e.createImmediatelyInvokedArrowFunction=Qa,e.createComma=Xa,e.createLessThan=Ya,e.createAssignment=Za,e.createStrictEquality=$a,e.createStrictInequality=eo,e.createAdd=to,e.createSubtract=ro,e.createPostfixIncrement=no,e.createLogicalAnd=io,e.createLogicalOr=ao,e.createLogicalNot=oo,e.createVoidZero=so,e.createExportDefault=co,e.createExternalModuleExport=uo,e.disposeEmitNodes=mo,e.getOrCreateEmitNode=go,e.setTextRange=vo,e.setEmitFlags=yo,e.addEmitFlags=ho,e.getSourceMapRange=bo,e.setSourceMapRange=xo;var Qo;e.createSourceMapSource=Do,e.getTokenSourceMapRange=So,e.setTokenSourceMapRange=Co,e.getStartsOnNewLine=ko,e.setStartsOnNewLine=To,e.getCommentRange=Eo,e.setCommentRange=No,e.getSyntheticLeadingComments=Ao,e.setSyntheticLeadingComments=Fo,e.addSyntheticLeadingComment=Po,e.getSyntheticTrailingComments=wo,e.setSyntheticTrailingComments=Io,e.addSyntheticTrailingComment=Oo,e.moveSyntheticComments=Mo,e.getConstantValue=Lo,e.setConstantValue=Ro,e.addEmitHelper=Bo,e.addEmitHelpers=jo,e.removeEmitHelper=Jo,e.getEmitHelpers=zo,e.moveEmitHelpers=Vo,e.compareEmitHelpers=Uo,e.setOriginalNode=Ko}(n||(n={})),function(e){function t(t,r){return"undefined"===r?e.createStrictEquality(t,e.createVoidZero()):e.createStrictEquality(e.createTypeOf(t),e.createLiteral(r))}function r(t,r,n){if(e.isComputedPropertyName(r))return e.setTextRange(e.createElementAccess(t,r.expression),n);var i=e.setTextRange(e.isIdentifier(r)?e.createPropertyAccess(t,r):e.createElementAccess(t,r),r);return e.getOrCreateEmitNode(i).flags|=64,i}function n(t,r,n,i){return e.setTextRange(e.createCall(e.createPropertyAccess(t,"call"),void 0,[r].concat(n)),i)}function i(t,r,n,i){return e.setTextRange(e.createCall(e.createPropertyAccess(t,"apply"),void 0,[r,n]),i)}function a(t,r){var n=[];return void 0!==r&&n.push("number"==typeof r?e.createLiteral(r):r),e.createCall(e.createPropertyAccess(t,"slice"),void 0,n)}function o(t,r){return e.createCall(e.createPropertyAccess(t,"concat"),void 0,r)}function s(t,r,n){return e.setTextRange(e.createCall(e.createPropertyAccess(e.createIdentifier("Math"),"pow"),void 0,[t,r]),n)}function c(t,r){var n=e.createIdentifier(t||"React");return n.flags&=-9,n.parent=e.getParseTreeNode(r),n}function u(t,r){if(e.isQualifiedName(t)){var n=u(t.left,r),i=e.createIdentifier(e.idText(t.right));return i.escapedText=t.right.escapedText,e.createPropertyAccess(n,i)}return c(e.idText(t),r)}function l(t,r,n){return t?u(t,n):e.createPropertyAccess(c(r,n),"createElement")}function _(t,r,n,i,a,o,s){var c=[n];if(i&&c.push(i),a&&a.length>0)if(i||c.push(e.createNull()),a.length>1)for(var u=0,_=a;u<_.length;u++){var d=_[u];St(d),c.push(d)}else c.push(a[0]);return e.setTextRange(e.createCall(l(t,r,o),void 0,c),s)}function d(t,r,n,i,a){var o=e.createPropertyAccess(c(r,i),"Fragment"),s=[o];if(s.push(e.createNull()),n&&n.length>0)if(n.length>1)for(var u=0,_=n;u<_.length;u++){var d=_[u];St(d),s.push(d)}else s.push(n[0]);return e.setTextRange(e.createCall(l(t,r,i),void 0,s),a)}function p(t){return e.setEmitFlags(e.createIdentifier(t),4098)}function f(t,r,n){return t.requestEmitHelper(e.valuesHelper),e.setTextRange(e.createCall(p("__values"),void 0,[r]),n)}function m(t,r,n,i){return t.requestEmitHelper(e.readHelper),e.setTextRange(e.createCall(p("__read"),void 0,void 0!==n?[r,e.createLiteral(n)]:[r]),i)}function g(t,r,n){return t.requestEmitHelper(e.readHelper),t.requestEmitHelper(e.spreadHelper),e.setTextRange(e.createCall(p("__spread"),void 0,r),n)}function v(t,r){if(e.isVariableDeclarationList(t)){var n=e.first(t.declarations),i=e.updateVariableDeclaration(n,n.name,void 0,r);return e.setTextRange(e.createVariableStatement(void 0,e.updateVariableDeclarationList(t,[i])),t)}var a=e.setTextRange(e.createAssignment(t,r),t);return e.setTextRange(e.createStatement(a),t)}function y(t,r){return e.isBlock(t)?e.updateBlock(t,e.setTextRange(e.createNodeArray([r].concat(t.statements)),t.statements)):e.createBlock(e.createNodeArray([t,r]),!0)}function h(t,r,n){if(!r)return t;var i=e.updateLabel(r,r.label,234===r.statement.kind?h(t,r.statement):t);return n&&n(r),i}function b(t,r){var n=e.skipParentheses(t);switch(n.kind){case 73:return r;case 101:case 8:case 9:case 10:return!1;case 188:var i=n.elements;return 0===i.length?!1:!0;case 189:return n.properties.length>0;default:return!0}}function x(t,r,n,i){void 0===i&&(i=!1);var a,o,s=yt(t,7);if(e.isSuperProperty(s))a=e.createThis(),o=s;else if(99===s.kind)a=e.createThis(),o=2>n?e.setTextRange(e.createIdentifier("_super"),s):s;else if(4096&e.getEmitFlags(s))a=e.createVoidZero(),o=nt(s);else switch(s.kind){case 190:b(s.expression,i)?(a=e.createTempVariable(r),o=e.createPropertyAccess(e.setTextRange(e.createAssignment(a,s.expression),s.expression),s.name),e.setTextRange(o,s)):(a=s.expression,o=s);break;case 191:b(s.expression,i)?(a=e.createTempVariable(r),o=e.createElementAccess(e.setTextRange(e.createAssignment(a,s.expression),s.expression),s.argumentExpression),e.setTextRange(o,s)):(a=s.expression,o=s);break;default:a=e.createVoidZero(),o=nt(t)}return{target:o,thisArg:a}}function D(t){return t.length>10?e.createCommaList(t):e.reduceLeft(t,e.createComma)}function S(t){if(e.isQualifiedName(t)){var r=S(t.left),n=e.getMutableClone(t.right);return e.setTextRange(e.createPropertyAccess(r,n),t)}return e.getMutableClone(t)}function C(t){return e.isIdentifier(t)?e.createLiteral(t):e.getMutableClone(e.isComputedPropertyName(t)?t.expression:t)}function k(e,t,r){switch(t.kind){case 159:case 160:return T(e.properties,t,r,!!e.multiLine);case 276:return E(t,r);case 277:return N(t,r);case 157:return A(t,r)}}function T(t,r,n,i){var a=e.getAllAccessorDeclarations(t,r),o=a.firstAccessor,s=a.getAccessor,c=a.setAccessor;if(r===o){var u=[];if(s){var l=e.createFunctionExpression(s.modifiers,void 0,void 0,void 0,s.parameters,void 0,s.body);e.setTextRange(l,s),e.setOriginalNode(l,s);var _=e.createPropertyAssignment("get",l);u.push(_)}if(c){var d=e.createFunctionExpression(c.modifiers,void 0,void 0,void 0,c.parameters,void 0,c.body);e.setTextRange(d,c),e.setOriginalNode(d,c);var p=e.createPropertyAssignment("set",d);u.push(p)}u.push(e.createPropertyAssignment("enumerable",e.createTrue())),u.push(e.createPropertyAssignment("configurable",e.createTrue()));var f=e.setTextRange(e.createCall(e.createPropertyAccess(e.createIdentifier("Object"),"defineProperty"),void 0,[n,C(r.name),e.createObjectLiteral(u,i)]),o);return e.aggregateTransformFlags(f)}return void 0}function E(t,n){return e.aggregateTransformFlags(e.setOriginalNode(e.setTextRange(e.createAssignment(r(n,t.name,t.name),t.initializer),t),t))}function N(t,n){return e.aggregateTransformFlags(e.setOriginalNode(e.setTextRange(e.createAssignment(r(n,t.name,t.name),e.getSynthesizedClone(t.name)),t),t))}function A(t,n){return e.aggregateTransformFlags(e.setOriginalNode(e.setTextRange(e.createAssignment(r(n,t.name,t.name),e.setOriginalNode(e.setTextRange(e.createFunctionExpression(t.modifiers,t.asteriskToken,void 0,void 0,t.parameters,void 0,t.body),t),t)),t),t))}function F(e,t,r){return R(e,t,r,49152)}function P(t){return 0!==(32768&e.getEmitFlags(t))}function w(e,t,r){return R(e,t,r,16384)}function I(t){return 0!==(16384&e.getEmitFlags(t))}function O(e,t,r){return R(e,t,r,8192)}function M(t){return 0!==(8192&e.getEmitFlags(t))}function L(e,t,r){return R(e,t,r)}function R(t,r,n,i){void 0===i&&(i=0);var a=e.getNameOfDeclaration(t);if(a&&e.isIdentifier(a)&&!e.isGeneratedIdentifier(a)){var o=e.getMutableClone(a);return i|=e.getEmitFlags(a),n||(i|=48),r||(i|=1536),i&&e.setEmitFlags(o,i),o}return e.getGeneratedNameForNode(t)}function B(t,r,n,i){return t&&e.hasModifier(r,1)?j(t,R(r),n,i):O(r,n,i)}function j(t,r,n,i){var a=e.createPropertyAccess(t,e.nodeIsSynthesized(r)?r:e.getSynthesizedClone(r));e.setTextRange(a,r);var o=0;return i||(o|=48),n||(o|=1536),o&&e.setEmitFlags(a,o),a}function J(t,r){return e.isBlock(t)?t:e.setTextRange(e.createBlock([e.setTextRange(e.createReturn(t),t)],r),t)}function z(t){if(!t.body)return e.Debug.fail();var r=e.createFunctionExpression(t.modifiers,t.asteriskToken,t.name,t.typeParameters,t.parameters,t.type,t.body);return e.setOriginalNode(r,t),e.setTextRange(r,t),e.getStartsOnNewLine(t)&&e.setStartsOnNewLine(r,!0),e.aggregateTransformFlags(r),r}function V(t){return e.isStringLiteral(t.expression)&&"use strict"===t.expression.text}function U(e,t,r,n){var i=K(e,t,r);return q(e,t,i,n)}function K(t,r,n){e.Debug.assert(0===t.length,"Prologue directives should be at the first statement in the target statements array");for(var i=!1,a=0,o=r.length;o>a;){var s=r[a];if(!e.isPrologueDirective(s))break;V(s)&&(i=!0),t.push(s),a++}return n&&!i&&t.push(St(e.createStatement(e.createLiteral("use strict")))),a}function q(t,r,n,i){for(var a=r.length;void 0!==n&&a>n;){var o=r[n];if(!(1048576&e.getEmitFlags(o)))break;e.append(t,i?e.visitNode(o,i,e.isStatement):o),n++}return n}function W(t){for(var r=0,n=t;r<n.length;r++){var i=n[r];if(!e.isPrologueDirective(i))break;if(V(i))return i}return void 0}function H(t){var r=e.firstOrUndefined(t);return void 0!==r&&e.isPrologueDirective(r)&&V(r)}function G(t){var r=W(t);return r?t:e.setTextRange(e.createNodeArray([St(e.createStatement(e.createLiteral("use strict")))].concat(t)),t)}function Q(t,r,n,i){var a=e.skipPartiallyEmittedExpressions(r);return 196===a.kind?r:X(t,r,n,i)?e.createParen(r):r}function X(t,r,n,i){var a=e.getOperatorPrecedence(205,t),o=e.getOperatorAssociativity(205,t),s=e.skipPartiallyEmittedExpressions(r);if(!n&&198===r.kind&&a>4)return!0;var c=e.getExpressionPrecedence(s);switch(e.compareValues(c,a)){case-1:return n||1!==o||208!==r.kind?!0:!1;case 1:return!1;case 0:if(n)return 1===o;if(e.isBinaryExpression(s)&&s.operatorToken.kind===t){if(Y(t))return!1;if(38===t){var u=i?Z(i):0;if(e.isLiteralKind(u)&&u===Z(s))return!1}}var l=e.getExpressionAssociativity(s);return 0===l}}function Y(e){return 40===e||50===e||49===e||51===e}function Z(t){if(t=e.skipPartiallyEmittedExpressions(t),e.isLiteralKind(t.kind))return t.kind;if(205===t.kind&&38===t.operatorToken.kind){if(void 0!==t.cachedLiteralKind)return t.cachedLiteralKind;var r=Z(t.left),n=e.isLiteralKind(r)&&r===Z(t.right)?r:0;return t.cachedLiteralKind=n,n}return 0}function $(t){var r=e.getOperatorPrecedence(206,56),n=e.skipPartiallyEmittedExpressions(t),i=e.getExpressionPrecedence(n);return-1===e.compareValues(i,r)?e.createParen(t):t}function et(t){var r=e.skipPartiallyEmittedExpressions(t);return gt(r)?e.createParen(t):t}function tt(t){var r=e.skipPartiallyEmittedExpressions(t),n=gt(r);if(!n)switch(ft(r,!1).kind){case 210:case 197:n=!0}return n?e.createParen(t):t}function rt(t){var r=ft(t,!0);switch(r.kind){case 192:return e.createParen(t);case 193:return r.arguments?t:e.createParen(t)}return nt(t)}function nt(t){var r=e.skipPartiallyEmittedExpressions(t);return e.isLeftHandSideExpression(r)&&(193!==r.kind||r.arguments)?t:e.setTextRange(e.createParen(t),t)}function it(t){return e.isLeftHandSideExpression(t)?t:e.setTextRange(e.createParen(t),t)}function at(t){return e.isUnaryExpression(t)?t:e.setTextRange(e.createParen(t),t)}function ot(t){for(var r,n=0;n<t.length;n++){var i=st(t[n]);(void 0!==r||i!==t[n])&&(void 0===r&&(r=t.slice(0,n)),r.push(i))}return void 0!==r?e.setTextRange(e.createNodeArray(r,t.hasTrailingComma),t):t}function st(t){var r=e.skipPartiallyEmittedExpressions(t),n=e.getExpressionPrecedence(r),i=e.getOperatorPrecedence(205,27);return n>i?t:e.setTextRange(e.createParen(t),t)}function ct(t){var r=e.skipPartiallyEmittedExpressions(t);if(e.isCallExpression(r)){var n=r.expression,i=e.skipPartiallyEmittedExpressions(n).kind;if(197===i||198===i){var a=e.getMutableClone(r);return a.expression=e.setTextRange(e.createParen(n),n),Dt(t,a,4)}}var o=ft(r,!1).kind;return 189===o||197===o?e.setTextRange(e.createParen(t),t):t}function ut(t){return 176===t.kind?e.createParenthesizedType(t):t}function lt(t){switch(t.kind){case 174:case 175:case 166:case 167:return e.createParenthesizedType(t)}return ut(t)}function _t(t){switch(t.kind){case 168:case 180:case 177:return e.createParenthesizedType(t)}return lt(t)}function dt(t){return e.createNodeArray(e.sameMap(t,lt))}function pt(t){if(e.some(t)){for(var r=[],n=0;n<t.length;++n){var i=t[n];r.push(0===n&&e.isFunctionOrConstructorTypeNode(i)&&i.typeParameters?e.createParenthesizedType(i):i)}return e.createNodeArray(r)}}function ft(e,t){for(;;){switch(e.kind){case 204:e=e.operand;continue;case 205:e=e.left;continue;case 206:e=e.condition;continue;case 194:e=e.tag;continue;case 192:if(t)return e;case 213:case 191:case 190:case 214:case 314:e=e.expression;continue}return e}}function mt(t){return e.isBlock(t)||!gt(t)&&189!==ft(t,!1).kind?t:e.setTextRange(e.createParen(t),t)}function gt(e){return 205===e.kind&&27===e.operatorToken.kind||315===e.kind}function vt(e,t){switch(void 0===t&&(t=7),e.kind){case 196:return 0!==(1&t);case 195:case 213:case 214:return 0!==(2&t);case 314:return 0!==(4&t)}return!1}function yt(t,r){void 0===r&&(r=7);var n;do n=t,1&r&&(t=e.skipParentheses(t)),2&r&&(t=ht(t)),4&r&&(t=e.skipPartiallyEmittedExpressions(t));while(n!==t);return t}function ht(t){for(;e.isAssertionExpression(t)||214===t.kind;)t=t.expression;return t}function bt(t,r){switch(t.kind){case 196:return e.updateParen(t,r);case 195:return e.updateTypeAssertion(t,t.type,r);case 213:return e.updateAsExpression(t,r,t.type);case 214:return e.updateNonNullExpression(t,r);case 314:return e.updatePartiallyEmittedExpression(t,r)}}function xt(t){return 196===t.kind&&e.nodeIsSynthesized(t)&&e.nodeIsSynthesized(e.getSourceMapRange(t))&&e.nodeIsSynthesized(e.getCommentRange(t))&&!e.some(e.getSyntheticLeadingComments(t))&&!e.some(e.getSyntheticTrailingComments(t))}function Dt(e,t,r){return void 0===r&&(r=7),e&&vt(e,r)&&!xt(e)?bt(e,Dt(e.expression,t)):t}function St(t){return e.setStartsOnNewLine(t,!0)}function Ct(t){var r=e.getOriginalNode(t,e.isSourceFile),n=r&&r.emitNode;return n&&n.externalHelpersModuleName}function kt(t,r,n,i){if(r.importHelpers&&e.isEffectiveExternalModule(t,r)){var a=Ct(t);if(a)return a;var o=e.getEmitModuleKind(r),s=(n||r.esModuleInterop&&i)&&o!==e.ModuleKind.System&&o!==e.ModuleKind.ES2015&&o!==e.ModuleKind.ESNext;if(!s){var c=e.getEmitHelpers(t);if(c)for(var u=0,l=c;u<l.length;u++){var _=l[u];if(!_.scoped){s=!0;break}}}if(s){var d=e.getOriginalNode(t,e.isSourceFile),p=e.getOrCreateEmitNode(d);return p.externalHelpersModuleName||(p.externalHelpersModuleName=e.createUniqueName(e.externalHelpersModuleNameText))}}}function Tt(t,r){var n=e.getNamespaceDeclarationNode(t);if(n&&!e.isDefaultImport(t)){var i=n.name;return e.isGeneratedIdentifier(i)?i:e.createIdentifier(e.getSourceTextOfNodeFromSourceFile(r,i)||e.idText(i))}return 250===t.kind&&t.importClause?e.getGeneratedNameForNode(t):256===t.kind&&t.moduleSpecifier?e.getGeneratedNameForNode(t):void 0}function Et(t,r,n,i,a){var o=e.getExternalModuleName(t);return 10===o.kind?Ft(t,n,i,a)||Nt(o,r)||e.getSynthesizedClone(o):void 0}function Nt(t,r){var n=r.renamedDependencies&&r.renamedDependencies.get(t.text);return n&&e.createLiteral(n)}function At(t,r,n){return t?t.moduleName?e.createLiteral(t.moduleName):t.isDeclarationFile||!n.out&&!n.outFile?void 0:e.createLiteral(e.getExternalModuleNameFromPath(r,t.fileName)):void 0}function Ft(e,t,r,n){return At(r.getExternalModuleFileFromDeclaration(e),t,n)}function Pt(t){if(e.isDeclarationBindingElement(t))return t.initializer;if(e.isPropertyAssignment(t)){var r=t.initializer;return e.isAssignmentExpression(r,!0)?r.right:void 0}return e.isShorthandPropertyAssignment(t)?t.objectAssignmentInitializer:e.isAssignmentExpression(t,!0)?t.right:e.isSpreadElement(t)?Pt(t.expression):void 0}function wt(t){if(e.isDeclarationBindingElement(t))return t.name;if(e.isObjectLiteralElementLike(t)){switch(t.kind){case 276:return wt(t.initializer);case 277:return t.name;case 278:return wt(t.expression)}return void 0}return e.isAssignmentExpression(t,!0)?wt(t.left):e.isSpreadElement(t)?wt(t.expression):t}function It(e){switch(e.kind){case 152:case 187:return e.dotDotDotToken;case 209:case 278:return e}return void 0}function Ot(t){switch(t.kind){case 187:if(t.propertyName){var r=t.propertyName;return e.isComputedPropertyName(r)&&Mt(r.expression)?r.expression:r}break;case 276:if(t.name){var r=t.name;return e.isComputedPropertyName(r)&&Mt(r.expression)?r.expression:r}break;case 278:return t.name}var n=wt(t);return n&&e.isPropertyName(n)?e.isComputedPropertyName(n)&&Mt(n.expression)?n.expression:n:void e.Debug.fail("Invalid property name for binding element.")}function Mt(e){var t=e.kind;return 10===t||8===t}function Lt(e){switch(e.kind){case 185:case 186:case 188:return e.elements;case 189:return e.properties}}function Rt(t){if(e.isBindingElement(t)){if(t.dotDotDotToken)return e.Debug.assertNode(t.name,e.isIdentifier),e.setOriginalNode(e.setTextRange(e.createSpread(t.name),t),t);var r=Vt(t.name);return t.initializer?e.setOriginalNode(e.setTextRange(e.createAssignment(r,t.initializer),t),t):r}return e.Debug.assertNode(t,e.isExpression),t}function Bt(t){if(e.isBindingElement(t)){if(t.dotDotDotToken)return e.Debug.assertNode(t.name,e.isIdentifier),e.setOriginalNode(e.setTextRange(e.createSpreadAssignment(t.name),t),t);if(t.propertyName){var r=Vt(t.name);return e.setOriginalNode(e.setTextRange(e.createPropertyAssignment(t.propertyName,t.initializer?e.createAssignment(r,t.initializer):r),t),t)}return e.Debug.assertNode(t.name,e.isIdentifier),e.setOriginalNode(e.setTextRange(e.createShorthandPropertyAssignment(t.name,t.initializer),t),t)}return e.Debug.assertNode(t,e.isObjectLiteralElementLike),t}function jt(e){switch(e.kind){case 186:case 188:return zt(e);case 185:case 189:return Jt(e)}}function Jt(t){return e.isObjectBindingPattern(t)?e.setOriginalNode(e.setTextRange(e.createObjectLiteral(e.map(t.elements,Bt)),t),t):(e.Debug.assertNode(t,e.isObjectLiteralExpression),t)}function zt(t){return e.isArrayBindingPattern(t)?e.setOriginalNode(e.setTextRange(e.createArrayLiteral(e.map(t.elements,Rt)),t),t):(e.Debug.assertNode(t,e.isArrayLiteralExpression),t)}function Vt(t){return e.isBindingPattern(t)?jt(t):(e.Debug.assertNode(t,e.isExpression),t)}e.nullTransformationContext={enableEmitNotification:e.noop,enableSubstitution:e.noop,endLexicalEnvironment:e.returnUndefined,getCompilerOptions:e.notImplemented,getEmitHost:e.notImplemented,getEmitResolver:e.notImplemented,hoistFunctionDeclaration:e.noop,hoistVariableDeclaration:e.noop,isEmitNotificationEnabled:e.notImplemented,isSubstitutionEnabled:e.notImplemented,onEmitNode:e.noop,onSubstituteNode:e.notImplemented,readEmitHelpers:e.notImplemented,requestEmitHelper:e.noop,resumeLexicalEnvironment:e.noop,startLexicalEnvironment:e.noop,suspendLexicalEnvironment:e.noop,addDiagnostic:e.noop},e.createTypeCheck=t,e.createMemberAccessForPropertyName=r,e.createFunctionCall=n,e.createFunctionApply=i,e.createArraySlice=a,e.createArrayConcat=o,e.createMathPow=s,e.createExpressionForJsxElement=_,e.createExpressionForJsxFragment=d,e.getHelperName=p,e.valuesHelper={name:"typescript:values",scoped:!1,text:'\n            var __values = (this && this.__values) || function (o) {\n                var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;\n                if (m) return m.call(o);\n                return {\n                    next: function () {\n                        if (o && i >= o.length) o = void 0;\n                        return { value: o && o[i++], done: !o };\n                    }\n                };\n            };'},e.createValuesHelper=f,e.readHelper={name:"typescript:read",scoped:!1,text:'\n            var __read = (this && this.__read) || function (o, n) {\n                var m = typeof Symbol === "function" && o[Symbol.iterator];\n                if (!m) return o;\n                var i = m.call(o), r, ar = [], e;\n                try {\n                    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);\n                }\n                catch (error) { e = { error: error }; }\n                finally {\n                    try {\n                        if (r && !r.done && (m = i["return"])) m.call(i);\n                    }\n                    finally { if (e) throw e.error; }\n                }\n                return ar;\n            };'},e.createReadHelper=m,e.spreadHelper={name:"typescript:spread",scoped:!1,text:"\n            var __spread = (this && this.__spread) || function () {\n                for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));\n                return ar;\n            };"},e.createSpreadHelper=g,e.createForOfBindingStatement=v,e.insertLeadingStatement=y,e.restoreEnclosingLabel=h,e.createCallBinding=x,e.inlineExpressions=D,e.createExpressionFromEntityName=S,e.createExpressionForPropertyName=C,e.createExpressionForObjectLiteralElementLike=k,e.getInternalName=F,e.isInternalName=P,e.getLocalName=w,e.isLocalName=I,e.getExportName=O,e.isExportName=M,e.getDeclarationName=L,e.getExternalModuleOrNamespaceExportName=B,e.getNamespaceMemberName=j,e.convertToFunctionBody=J,e.convertFunctionDeclarationToExpression=z,e.addPrologue=U,e.addStandardPrologue=K,e.addCustomPrologue=q,e.findUseStrictPrologue=W,e.startsWithUseStrict=H,e.ensureUseStrict=G,e.parenthesizeBinaryOperand=Q,e.parenthesizeForConditionalHead=$,e.parenthesizeSubexpressionOfConditionalExpression=et,e.parenthesizeDefaultExpression=tt,e.parenthesizeForNew=rt,e.parenthesizeForAccess=nt,e.parenthesizePostfixOperand=it,e.parenthesizePrefixOperand=at,e.parenthesizeListElements=ot,e.parenthesizeExpressionForList=st,e.parenthesizeExpressionForExpressionStatement=ct,e.parenthesizeConditionalTypeMember=ut,e.parenthesizeElementTypeMember=lt,e.parenthesizeArrayTypeMember=_t,e.parenthesizeElementTypeMembers=dt,e.parenthesizeTypeParameters=pt,e.parenthesizeConciseBody=mt,e.isCommaSequence=gt;var Ut;!function(e){e[e.Parentheses=1]="Parentheses",e[e.Assertions=2]="Assertions",e[e.PartiallyEmittedExpressions=4]="PartiallyEmittedExpressions",e[e.All=7]="All"}(Ut=e.OuterExpressionKinds||(e.OuterExpressionKinds={})),e.isOuterExpression=vt,e.skipOuterExpressions=yt,e.skipAssertions=ht,e.recreateOuterExpressions=Dt,e.startOnNewLine=St,e.getExternalHelpersModuleName=Ct,e.getOrCreateExternalHelpersModuleNameIfNeeded=kt,e.getLocalNameForExternalImport=Tt,e.getExternalModuleNameLiteral=Et,e.tryGetModuleNameFromFile=At,e.getInitializerOfBindingOrAssignmentElement=Pt,e.getTargetOfBindingOrAssignmentElement=wt,e.getRestIndicatorOfBindingOrAssignmentElement=It,e.getPropertyNameOfBindingOrAssignmentElement=Ot,e.getElementsOfBindingOrAssignmentPattern=Lt,e.convertToArrayAssignmentElement=Rt,e.convertToObjectAssignmentElement=Bt,e.convertToAssignmentPattern=jt,e.convertToObjectAssignmentPattern=Jt,e.convertToArrayAssignmentPattern=zt,e.convertToAssignmentElementTarget=Vt}(n||(n={}));var n;!function(e){function t(t,r,n,i){if(void 0===t||void 0===r)return t;
e.aggregateTransformFlags(t);var a=r(t);if(a===t)return t;var o;return void 0===a?void 0:(o=e.isArray(a)?(i||s)(a):a,e.Debug.assertNode(o,n),e.aggregateTransformFlags(o),o)}function r(t,r,n,i,a){if(void 0===t||void 0===r)return t;var o,s=t.length;(void 0===i||0>i)&&(i=0),(void 0===a||a>s-i)&&(a=s-i),(i>0||s>a)&&(o=e.createNodeArray([],t.hasTrailingComma&&i+a===s));for(var c=0;a>c;c++){var u=t[c+i];e.aggregateTransformFlags(u);var l=void 0!==u?r(u):void 0;if((void 0!==o||void 0===l||l!==u)&&(void 0===o&&(o=e.createNodeArray(t.slice(0,c),t.hasTrailingComma),e.setTextRange(o,t)),l))if(e.isArray(l))for(var _=0,d=l;_<d.length;_++){var p=d[_];e.Debug.assertNode(p,n),e.aggregateTransformFlags(p),o.push(p)}else e.Debug.assertNode(l,n),e.aggregateTransformFlags(l),o.push(l)}return o||t}function n(t,n,i,a,o){i.startLexicalEnvironment(),t=r(t,n,e.isStatement,a),o&&!e.startsWithUseStrict(t)&&(t=e.setTextRange(e.createNodeArray([e.createExpressionStatement(e.createLiteral("use strict"))].concat(t)),t));var s=i.endLexicalEnvironment();return e.setTextRange(e.createNodeArray(e.concatenate(s,t)),t)}function i(t,n,i,a){void 0===a&&(a=r),i.startLexicalEnvironment();var o=a(t,n,e.isParameterDeclaration);return i.suspendLexicalEnvironment(),o}function a(r,n,i){i.resumeLexicalEnvironment();var a=t(r,n,e.isConciseBody),o=i.endLexicalEnvironment();if(e.some(o)){var s=e.convertToFunctionBody(a),c=e.mergeLexicalEnvironment(s.statements,o);return e.updateBlock(s,c)}return a}function o(o,s,u,l,_){if(void 0===l&&(l=r),void 0===o)return void 0;var d=o.kind;if(d>0&&148>=d||179===d)return o;switch(d){case 73:return e.updateIdentifier(o,l(o.typeArguments,s,c));case 149:return e.updateQualifiedName(o,t(o.left,s,e.isEntityName),t(o.right,s,e.isIdentifier));case 150:return e.updateComputedPropertyName(o,t(o.expression,s,e.isExpression));case 151:return e.updateTypeParameterDeclaration(o,t(o.name,s,e.isIdentifier),t(o.constraint,s,e.isTypeNode),t(o.default,s,e.isTypeNode));case 152:return e.updateParameter(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.dotDotDotToken,_,e.isToken),t(o.name,s,e.isBindingName),t(o.questionToken,_,e.isToken),t(o.type,s,e.isTypeNode),t(o.initializer,s,e.isExpression));case 153:return e.updateDecorator(o,t(o.expression,s,e.isExpression));case 154:return e.updatePropertySignature(o,l(o.modifiers,s,e.isToken),t(o.name,s,e.isPropertyName),t(o.questionToken,_,e.isToken),t(o.type,s,e.isTypeNode),t(o.initializer,s,e.isExpression));case 155:return e.updateProperty(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.name,s,e.isPropertyName),t(o.questionToken||o.exclamationToken,_,e.isToken),t(o.type,s,e.isTypeNode),t(o.initializer,s,e.isExpression));case 156:return e.updateMethodSignature(o,l(o.typeParameters,s,e.isTypeParameterDeclaration),l(o.parameters,s,e.isParameterDeclaration),t(o.type,s,e.isTypeNode),t(o.name,s,e.isPropertyName),t(o.questionToken,_,e.isToken));case 157:return e.updateMethod(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.asteriskToken,_,e.isToken),t(o.name,s,e.isPropertyName),t(o.questionToken,_,e.isToken),l(o.typeParameters,s,e.isTypeParameterDeclaration),i(o.parameters,s,u,l),t(o.type,s,e.isTypeNode),a(o.body,s,u));case 158:return e.updateConstructor(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),i(o.parameters,s,u,l),a(o.body,s,u));case 159:return e.updateGetAccessor(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.name,s,e.isPropertyName),i(o.parameters,s,u,l),t(o.type,s,e.isTypeNode),a(o.body,s,u));case 160:return e.updateSetAccessor(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.name,s,e.isPropertyName),i(o.parameters,s,u,l),a(o.body,s,u));case 161:return e.updateCallSignature(o,l(o.typeParameters,s,e.isTypeParameterDeclaration),l(o.parameters,s,e.isParameterDeclaration),t(o.type,s,e.isTypeNode));case 162:return e.updateConstructSignature(o,l(o.typeParameters,s,e.isTypeParameterDeclaration),l(o.parameters,s,e.isParameterDeclaration),t(o.type,s,e.isTypeNode));case 163:return e.updateIndexSignature(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),l(o.parameters,s,e.isParameterDeclaration),t(o.type,s,e.isTypeNode));case 164:return e.updateTypePredicateNode(o,t(o.parameterName,s),t(o.type,s,e.isTypeNode));case 165:return e.updateTypeReferenceNode(o,t(o.typeName,s,e.isEntityName),l(o.typeArguments,s,e.isTypeNode));case 166:return e.updateFunctionTypeNode(o,l(o.typeParameters,s,e.isTypeParameterDeclaration),l(o.parameters,s,e.isParameterDeclaration),t(o.type,s,e.isTypeNode));case 167:return e.updateConstructorTypeNode(o,l(o.typeParameters,s,e.isTypeParameterDeclaration),l(o.parameters,s,e.isParameterDeclaration),t(o.type,s,e.isTypeNode));case 168:return e.updateTypeQueryNode(o,t(o.exprName,s,e.isEntityName));case 169:return e.updateTypeLiteralNode(o,l(o.members,s,e.isTypeElement));case 170:return e.updateArrayTypeNode(o,t(o.elementType,s,e.isTypeNode));case 171:return e.updateTupleTypeNode(o,l(o.elementTypes,s,e.isTypeNode));case 172:return e.updateOptionalTypeNode(o,t(o.type,s,e.isTypeNode));case 173:return e.updateRestTypeNode(o,t(o.type,s,e.isTypeNode));case 174:return e.updateUnionTypeNode(o,l(o.types,s,e.isTypeNode));case 175:return e.updateIntersectionTypeNode(o,l(o.types,s,e.isTypeNode));case 176:return e.updateConditionalTypeNode(o,t(o.checkType,s,e.isTypeNode),t(o.extendsType,s,e.isTypeNode),t(o.trueType,s,e.isTypeNode),t(o.falseType,s,e.isTypeNode));case 177:return e.updateInferTypeNode(o,t(o.typeParameter,s,e.isTypeParameterDeclaration));case 184:return e.updateImportTypeNode(o,t(o.argument,s,e.isTypeNode),t(o.qualifier,s,e.isEntityName),r(o.typeArguments,s,e.isTypeNode),o.isTypeOf);case 178:return e.updateParenthesizedType(o,t(o.type,s,e.isTypeNode));case 180:return e.updateTypeOperatorNode(o,t(o.type,s,e.isTypeNode));case 181:return e.updateIndexedAccessTypeNode(o,t(o.objectType,s,e.isTypeNode),t(o.indexType,s,e.isTypeNode));case 182:return e.updateMappedTypeNode(o,t(o.readonlyToken,_,e.isToken),t(o.typeParameter,s,e.isTypeParameterDeclaration),t(o.questionToken,_,e.isToken),t(o.type,s,e.isTypeNode));case 183:return e.updateLiteralTypeNode(o,t(o.literal,s,e.isExpression));case 185:return e.updateObjectBindingPattern(o,l(o.elements,s,e.isBindingElement));case 186:return e.updateArrayBindingPattern(o,l(o.elements,s,e.isArrayBindingElement));case 187:return e.updateBindingElement(o,t(o.dotDotDotToken,_,e.isToken),t(o.propertyName,s,e.isPropertyName),t(o.name,s,e.isBindingName),t(o.initializer,s,e.isExpression));case 188:return e.updateArrayLiteral(o,l(o.elements,s,e.isExpression));case 189:return e.updateObjectLiteral(o,l(o.properties,s,e.isObjectLiteralElementLike));case 190:return e.updatePropertyAccess(o,t(o.expression,s,e.isExpression),t(o.name,s,e.isIdentifier));case 191:return e.updateElementAccess(o,t(o.expression,s,e.isExpression),t(o.argumentExpression,s,e.isExpression));case 192:return e.updateCall(o,t(o.expression,s,e.isExpression),l(o.typeArguments,s,e.isTypeNode),l(o.arguments,s,e.isExpression));case 193:return e.updateNew(o,t(o.expression,s,e.isExpression),l(o.typeArguments,s,e.isTypeNode),l(o.arguments,s,e.isExpression));case 194:return e.updateTaggedTemplate(o,t(o.tag,s,e.isExpression),r(o.typeArguments,s,e.isExpression),t(o.template,s,e.isTemplateLiteral));case 195:return e.updateTypeAssertion(o,t(o.type,s,e.isTypeNode),t(o.expression,s,e.isExpression));case 196:return e.updateParen(o,t(o.expression,s,e.isExpression));case 197:return e.updateFunctionExpression(o,l(o.modifiers,s,e.isModifier),t(o.asteriskToken,_,e.isToken),t(o.name,s,e.isIdentifier),l(o.typeParameters,s,e.isTypeParameterDeclaration),i(o.parameters,s,u,l),t(o.type,s,e.isTypeNode),a(o.body,s,u));case 198:return e.updateArrowFunction(o,l(o.modifiers,s,e.isModifier),l(o.typeParameters,s,e.isTypeParameterDeclaration),i(o.parameters,s,u,l),t(o.type,s,e.isTypeNode),t(o.equalsGreaterThanToken,s,e.isToken),a(o.body,s,u));case 199:return e.updateDelete(o,t(o.expression,s,e.isExpression));case 200:return e.updateTypeOf(o,t(o.expression,s,e.isExpression));case 201:return e.updateVoid(o,t(o.expression,s,e.isExpression));case 202:return e.updateAwait(o,t(o.expression,s,e.isExpression));case 203:return e.updatePrefix(o,t(o.operand,s,e.isExpression));case 204:return e.updatePostfix(o,t(o.operand,s,e.isExpression));case 205:return e.updateBinary(o,t(o.left,s,e.isExpression),t(o.right,s,e.isExpression),t(o.operatorToken,s,e.isToken));case 206:return e.updateConditional(o,t(o.condition,s,e.isExpression),t(o.questionToken,s,e.isToken),t(o.whenTrue,s,e.isExpression),t(o.colonToken,s,e.isToken),t(o.whenFalse,s,e.isExpression));case 207:return e.updateTemplateExpression(o,t(o.head,s,e.isTemplateHead),l(o.templateSpans,s,e.isTemplateSpan));case 208:return e.updateYield(o,t(o.asteriskToken,_,e.isToken),t(o.expression,s,e.isExpression));case 209:return e.updateSpread(o,t(o.expression,s,e.isExpression));case 210:return e.updateClassExpression(o,l(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),l(o.typeParameters,s,e.isTypeParameterDeclaration),l(o.heritageClauses,s,e.isHeritageClause),l(o.members,s,e.isClassElement));case 212:return e.updateExpressionWithTypeArguments(o,l(o.typeArguments,s,e.isTypeNode),t(o.expression,s,e.isExpression));case 213:return e.updateAsExpression(o,t(o.expression,s,e.isExpression),t(o.type,s,e.isTypeNode));case 214:return e.updateNonNullExpression(o,t(o.expression,s,e.isExpression));case 215:return e.updateMetaProperty(o,t(o.name,s,e.isIdentifier));case 217:return e.updateTemplateSpan(o,t(o.expression,s,e.isExpression),t(o.literal,s,e.isTemplateMiddleOrTemplateTail));case 219:return e.updateBlock(o,l(o.statements,s,e.isStatement));case 220:return e.updateVariableStatement(o,l(o.modifiers,s,e.isModifier),t(o.declarationList,s,e.isVariableDeclarationList));case 222:return e.updateExpressionStatement(o,t(o.expression,s,e.isExpression));case 223:return e.updateIf(o,t(o.expression,s,e.isExpression),t(o.thenStatement,s,e.isStatement,e.liftToBlock),t(o.elseStatement,s,e.isStatement,e.liftToBlock));case 224:return e.updateDo(o,t(o.statement,s,e.isStatement,e.liftToBlock),t(o.expression,s,e.isExpression));case 225:return e.updateWhile(o,t(o.expression,s,e.isExpression),t(o.statement,s,e.isStatement,e.liftToBlock));case 226:return e.updateFor(o,t(o.initializer,s,e.isForInitializer),t(o.condition,s,e.isExpression),t(o.incrementor,s,e.isExpression),t(o.statement,s,e.isStatement,e.liftToBlock));case 227:return e.updateForIn(o,t(o.initializer,s,e.isForInitializer),t(o.expression,s,e.isExpression),t(o.statement,s,e.isStatement,e.liftToBlock));case 228:return e.updateForOf(o,t(o.awaitModifier,s,e.isToken),t(o.initializer,s,e.isForInitializer),t(o.expression,s,e.isExpression),t(o.statement,s,e.isStatement,e.liftToBlock));case 229:return e.updateContinue(o,t(o.label,s,e.isIdentifier));case 230:return e.updateBreak(o,t(o.label,s,e.isIdentifier));case 231:return e.updateReturn(o,t(o.expression,s,e.isExpression));case 232:return e.updateWith(o,t(o.expression,s,e.isExpression),t(o.statement,s,e.isStatement,e.liftToBlock));case 233:return e.updateSwitch(o,t(o.expression,s,e.isExpression),t(o.caseBlock,s,e.isCaseBlock));case 234:return e.updateLabel(o,t(o.label,s,e.isIdentifier),t(o.statement,s,e.isStatement,e.liftToBlock));case 235:return e.updateThrow(o,t(o.expression,s,e.isExpression));case 236:return e.updateTry(o,t(o.tryBlock,s,e.isBlock),t(o.catchClause,s,e.isCatchClause),t(o.finallyBlock,s,e.isBlock));case 238:return e.updateVariableDeclaration(o,t(o.name,s,e.isBindingName),t(o.type,s,e.isTypeNode),t(o.initializer,s,e.isExpression));case 239:return e.updateVariableDeclarationList(o,l(o.declarations,s,e.isVariableDeclaration));case 240:return e.updateFunctionDeclaration(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.asteriskToken,_,e.isToken),t(o.name,s,e.isIdentifier),l(o.typeParameters,s,e.isTypeParameterDeclaration),i(o.parameters,s,u,l),t(o.type,s,e.isTypeNode),a(o.body,s,u));case 241:return e.updateClassDeclaration(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),l(o.typeParameters,s,e.isTypeParameterDeclaration),l(o.heritageClauses,s,e.isHeritageClause),l(o.members,s,e.isClassElement));case 242:return e.updateInterfaceDeclaration(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),l(o.typeParameters,s,e.isTypeParameterDeclaration),l(o.heritageClauses,s,e.isHeritageClause),l(o.members,s,e.isTypeElement));case 243:return e.updateTypeAliasDeclaration(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),l(o.typeParameters,s,e.isTypeParameterDeclaration),t(o.type,s,e.isTypeNode));case 244:return e.updateEnumDeclaration(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),l(o.members,s,e.isEnumMember));case 245:return e.updateModuleDeclaration(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),t(o.body,s,e.isModuleBody));case 246:return e.updateModuleBlock(o,l(o.statements,s,e.isStatement));case 247:return e.updateCaseBlock(o,l(o.clauses,s,e.isCaseOrDefaultClause));case 248:return e.updateNamespaceExportDeclaration(o,t(o.name,s,e.isIdentifier));case 249:return e.updateImportEqualsDeclaration(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),t(o.moduleReference,s,e.isModuleReference));case 250:return e.updateImportDeclaration(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.importClause,s,e.isImportClause),t(o.moduleSpecifier,s,e.isExpression));case 251:return e.updateImportClause(o,t(o.name,s,e.isIdentifier),t(o.namedBindings,s,e.isNamedImportBindings));case 252:return e.updateNamespaceImport(o,t(o.name,s,e.isIdentifier));case 253:return e.updateNamedImports(o,l(o.elements,s,e.isImportSpecifier));case 254:return e.updateImportSpecifier(o,t(o.propertyName,s,e.isIdentifier),t(o.name,s,e.isIdentifier));case 255:return e.updateExportAssignment(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.expression,s,e.isExpression));case 256:return e.updateExportDeclaration(o,l(o.decorators,s,e.isDecorator),l(o.modifiers,s,e.isModifier),t(o.exportClause,s,e.isNamedExports),t(o.moduleSpecifier,s,e.isExpression));case 257:return e.updateNamedExports(o,l(o.elements,s,e.isExportSpecifier));case 258:return e.updateExportSpecifier(o,t(o.propertyName,s,e.isIdentifier),t(o.name,s,e.isIdentifier));case 260:return e.updateExternalModuleReference(o,t(o.expression,s,e.isExpression));case 261:return e.updateJsxElement(o,t(o.openingElement,s,e.isJsxOpeningElement),l(o.children,s,e.isJsxChild),t(o.closingElement,s,e.isJsxClosingElement));case 262:return e.updateJsxSelfClosingElement(o,t(o.tagName,s,e.isJsxTagNameExpression),l(o.typeArguments,s,e.isTypeNode),t(o.attributes,s,e.isJsxAttributes));case 263:return e.updateJsxOpeningElement(o,t(o.tagName,s,e.isJsxTagNameExpression),l(o.typeArguments,s,e.isTypeNode),t(o.attributes,s,e.isJsxAttributes));case 264:return e.updateJsxClosingElement(o,t(o.tagName,s,e.isJsxTagNameExpression));case 265:return e.updateJsxFragment(o,t(o.openingFragment,s,e.isJsxOpeningFragment),l(o.children,s,e.isJsxChild),t(o.closingFragment,s,e.isJsxClosingFragment));case 268:return e.updateJsxAttribute(o,t(o.name,s,e.isIdentifier),t(o.initializer,s,e.isStringLiteralOrJsxExpression));case 269:return e.updateJsxAttributes(o,l(o.properties,s,e.isJsxAttributeLike));case 270:return e.updateJsxSpreadAttribute(o,t(o.expression,s,e.isExpression));case 271:return e.updateJsxExpression(o,t(o.expression,s,e.isExpression));case 272:return e.updateCaseClause(o,t(o.expression,s,e.isExpression),l(o.statements,s,e.isStatement));case 273:return e.updateDefaultClause(o,l(o.statements,s,e.isStatement));case 274:return e.updateHeritageClause(o,l(o.types,s,e.isExpressionWithTypeArguments));case 275:return e.updateCatchClause(o,t(o.variableDeclaration,s,e.isVariableDeclaration),t(o.block,s,e.isBlock));case 276:return e.updatePropertyAssignment(o,t(o.name,s,e.isPropertyName),t(o.initializer,s,e.isExpression));case 277:return e.updateShorthandPropertyAssignment(o,t(o.name,s,e.isIdentifier),t(o.objectAssignmentInitializer,s,e.isExpression));case 278:return e.updateSpreadAssignment(o,t(o.expression,s,e.isExpression));case 279:return e.updateEnumMember(o,t(o.name,s,e.isPropertyName),t(o.initializer,s,e.isExpression));case 285:return e.updateSourceFileNode(o,n(o.statements,s,u));case 314:return e.updatePartiallyEmittedExpression(o,t(o.expression,s,e.isExpression));case 315:return e.updateCommaList(o,l(o.elements,s,e.isExpression));default:return o}}function s(t){return e.Debug.assert(t.length<=1,"Too many nodes written to output."),e.singleOrUndefined(t)}var c=e.or(e.isTypeNode,e.isTypeParameterDeclaration);e.visitNode=t,e.visitNodes=r,e.visitLexicalEnvironment=n,e.visitParameterList=i,e.visitFunctionBody=a,e.visitEachChild=o}(n||(n={})),function(e){function t(e,t,r){return e?t(r,e):r}function r(e,t,r){return e?t(r,e):r}function n(n,i,a,o){if(void 0===n)return i;var s=o?r:e.reduceLeft,c=o||a,u=n.kind;if(u>0&&148>=u)return i;if(u>=164&&183>=u)return i;var l=i;switch(n.kind){case 218:case 221:case 211:case 237:case 313:break;case 149:l=t(n.left,a,l),l=t(n.right,a,l);break;case 150:l=t(n.expression,a,l);break;case 152:l=s(n.decorators,c,l),l=s(n.modifiers,c,l),l=t(n.name,a,l),l=t(n.type,a,l),l=t(n.initializer,a,l);break;case 153:l=t(n.expression,a,l);break;case 154:l=s(n.modifiers,c,l),l=t(n.name,a,l),l=t(n.questionToken,a,l),l=t(n.type,a,l),l=t(n.initializer,a,l);break;case 155:l=s(n.decorators,c,l),l=s(n.modifiers,c,l),l=t(n.name,a,l),l=t(n.type,a,l),l=t(n.initializer,a,l);break;case 157:l=s(n.decorators,c,l),l=s(n.modifiers,c,l),l=t(n.name,a,l),l=s(n.typeParameters,c,l),l=s(n.parameters,c,l),l=t(n.type,a,l),l=t(n.body,a,l);break;case 158:l=s(n.modifiers,c,l),l=s(n.parameters,c,l),l=t(n.body,a,l);break;case 159:l=s(n.decorators,c,l),l=s(n.modifiers,c,l),l=t(n.name,a,l),l=s(n.parameters,c,l),l=t(n.type,a,l),l=t(n.body,a,l);break;case 160:l=s(n.decorators,c,l),l=s(n.modifiers,c,l),l=t(n.name,a,l),l=s(n.parameters,c,l),l=t(n.body,a,l);break;case 185:case 186:l=s(n.elements,c,l);break;case 187:l=t(n.propertyName,a,l),l=t(n.name,a,l),l=t(n.initializer,a,l);break;case 188:l=s(n.elements,c,l);break;case 189:l=s(n.properties,c,l);break;case 190:l=t(n.expression,a,l),l=t(n.name,a,l);break;case 191:l=t(n.expression,a,l),l=t(n.argumentExpression,a,l);break;case 192:l=t(n.expression,a,l),l=s(n.typeArguments,c,l),l=s(n.arguments,c,l);break;case 193:l=t(n.expression,a,l),l=s(n.typeArguments,c,l),l=s(n.arguments,c,l);break;case 194:l=t(n.tag,a,l),l=s(n.typeArguments,c,l),l=t(n.template,a,l);break;case 195:l=t(n.type,a,l),l=t(n.expression,a,l);break;case 197:l=s(n.modifiers,c,l),l=t(n.name,a,l),l=s(n.typeParameters,c,l),l=s(n.parameters,c,l),l=t(n.type,a,l),l=t(n.body,a,l);break;case 198:l=s(n.modifiers,c,l),l=s(n.typeParameters,c,l),l=s(n.parameters,c,l),l=t(n.type,a,l),l=t(n.body,a,l);break;case 196:case 199:case 200:case 201:case 202:case 208:case 209:case 214:l=t(n.expression,a,l);break;case 203:case 204:l=t(n.operand,a,l);break;case 205:l=t(n.left,a,l),l=t(n.right,a,l);break;case 206:l=t(n.condition,a,l),l=t(n.whenTrue,a,l),l=t(n.whenFalse,a,l);break;case 207:l=t(n.head,a,l),l=s(n.templateSpans,c,l);break;case 210:l=s(n.modifiers,c,l),l=t(n.name,a,l),l=s(n.typeParameters,c,l),l=s(n.heritageClauses,c,l),l=s(n.members,c,l);break;case 212:l=t(n.expression,a,l),l=s(n.typeArguments,c,l);break;case 213:l=t(n.expression,a,l),l=t(n.type,a,l);break;case 217:l=t(n.expression,a,l),l=t(n.literal,a,l);break;case 219:l=s(n.statements,c,l);break;case 220:l=s(n.modifiers,c,l),l=t(n.declarationList,a,l);break;case 222:l=t(n.expression,a,l);break;case 223:l=t(n.expression,a,l),l=t(n.thenStatement,a,l),l=t(n.elseStatement,a,l);break;case 224:l=t(n.statement,a,l),l=t(n.expression,a,l);break;case 225:case 232:l=t(n.expression,a,l),l=t(n.statement,a,l);break;case 226:l=t(n.initializer,a,l),l=t(n.condition,a,l),l=t(n.incrementor,a,l),l=t(n.statement,a,l);break;case 227:case 228:l=t(n.initializer,a,l),l=t(n.expression,a,l),l=t(n.statement,a,l);break;case 231:case 235:l=t(n.expression,a,l);break;case 233:l=t(n.expression,a,l),l=t(n.caseBlock,a,l);break;case 234:l=t(n.label,a,l),l=t(n.statement,a,l);break;case 236:l=t(n.tryBlock,a,l),l=t(n.catchClause,a,l),l=t(n.finallyBlock,a,l);break;case 238:l=t(n.name,a,l),l=t(n.type,a,l),l=t(n.initializer,a,l);break;case 239:l=s(n.declarations,c,l);break;case 240:l=s(n.decorators,c,l),l=s(n.modifiers,c,l),l=t(n.name,a,l),l=s(n.typeParameters,c,l),l=s(n.parameters,c,l),l=t(n.type,a,l),l=t(n.body,a,l);break;case 241:l=s(n.decorators,c,l),l=s(n.modifiers,c,l),l=t(n.name,a,l),l=s(n.typeParameters,c,l),l=s(n.heritageClauses,c,l),l=s(n.members,c,l);break;case 244:l=s(n.decorators,c,l),l=s(n.modifiers,c,l),l=t(n.name,a,l),l=s(n.members,c,l);break;case 245:l=s(n.decorators,c,l),l=s(n.modifiers,c,l),l=t(n.name,a,l),l=t(n.body,a,l);break;case 246:l=s(n.statements,c,l);break;case 247:l=s(n.clauses,c,l);break;case 249:l=s(n.decorators,c,l),l=s(n.modifiers,c,l),l=t(n.name,a,l),l=t(n.moduleReference,a,l);break;case 250:l=s(n.decorators,c,l),l=s(n.modifiers,c,l),l=t(n.importClause,a,l),l=t(n.moduleSpecifier,a,l);break;case 251:l=t(n.name,a,l),l=t(n.namedBindings,a,l);break;case 252:l=t(n.name,a,l);break;case 253:case 257:l=s(n.elements,c,l);break;case 254:case 258:l=t(n.propertyName,a,l),l=t(n.name,a,l);break;case 255:l=e.reduceLeft(n.decorators,a,l),l=e.reduceLeft(n.modifiers,a,l),l=t(n.expression,a,l);break;case 256:l=e.reduceLeft(n.decorators,a,l),l=e.reduceLeft(n.modifiers,a,l),l=t(n.exportClause,a,l),l=t(n.moduleSpecifier,a,l);break;case 260:l=t(n.expression,a,l);break;case 261:l=t(n.openingElement,a,l),l=e.reduceLeft(n.children,a,l),l=t(n.closingElement,a,l);break;case 265:l=t(n.openingFragment,a,l),l=e.reduceLeft(n.children,a,l),l=t(n.closingFragment,a,l);break;case 262:case 263:l=t(n.tagName,a,l),l=s(n.typeArguments,a,l),l=t(n.attributes,a,l);break;case 269:l=s(n.properties,c,l);break;case 264:l=t(n.tagName,a,l);break;case 268:l=t(n.name,a,l),l=t(n.initializer,a,l);break;case 270:l=t(n.expression,a,l);break;case 271:l=t(n.expression,a,l);break;case 272:l=t(n.expression,a,l);case 273:l=s(n.statements,c,l);break;case 274:l=s(n.types,c,l);break;case 275:l=t(n.variableDeclaration,a,l),l=t(n.block,a,l);break;case 276:l=t(n.name,a,l),l=t(n.initializer,a,l);break;case 277:l=t(n.name,a,l),l=t(n.objectAssignmentInitializer,a,l);break;case 278:l=t(n.expression,a,l);break;case 279:l=t(n.name,a,l),l=t(n.initializer,a,l);break;case 285:l=s(n.statements,c,l);break;case 314:l=t(n.expression,a,l);break;case 315:l=s(n.elements,c,l)}return l}function i(t,r){return e.some(r)?e.isNodeArray(t)?e.setTextRange(e.createNodeArray(e.insertStatementsAfterStandardPrologue(t.slice(),r)),t):e.insertStatementsAfterStandardPrologue(t,r):t}function a(t){return e.Debug.assert(e.every(t,e.isStatement),"Cannot lift nodes to a Block."),e.singleOrUndefined(t)||e.createBlock(t)}function o(e){return s(e),e}function s(t){if(void 0===t)return 0;if(536870912&t.transformFlags)return t.transformFlags&~e.getTransformFlagsSubtreeExclusions(t.kind);var r=u(t);return e.computeTransformFlagsForNode(t,r)}function c(e){if(void 0===e)return 0;for(var t=0,r=0,n=0,i=e;n<i.length;n++){var a=i[n];t|=s(a),r|=-536870913&a.transformFlags}return e.transformFlags=536870912|r,t}function u(t){return e.hasModifier(t,2)||e.isTypeNode(t)&&212!==t.kind?0:n(t,0,l,_)}function l(e,t){return e|s(t)}function _(e,t){return e|c(t)}e.reduceEachChild=n,e.mergeLexicalEnvironment=i,e.liftToBlock=a,e.aggregateTransformFlags=o}(n||(n={}));var n;!function(e){function t(t,r,n,i,a){function o(r){x();var n=e.getRelativePathToDirectoryOrUrl(i,r,t.getCurrentDirectory(),t.getCanonicalFileName,!0),a=k.get(n);return void 0===a&&(a=C.length,C.push(n),S.push(r),k.set(n,a)),D(),a}function c(e,t){if(x(),null!==t){for(y||(y=[]);y.length<e;)y.push(null);y[e]=t}D()}function u(t){x(),h||(h=e.createMap());var r=h.get(t);return void 0===r&&(r=T.length,T.push(t),h.set(t,r)),D(),r}function l(e,t){return!z||M!==e||L!==t}function _(e,t,r){return void 0!==e&&void 0!==t&&void 0!==r&&R===e&&(B>t||B===t&&j>r)}function p(t,r,n,i,a,o){e.Debug.assert(t>=M,"generatedLine cannot backtrack"),e.Debug.assert(r>=0,"generatedCharacter cannot be negative"),e.Debug.assert(void 0===n||n>=0,"sourceIndex cannot be negative"),e.Debug.assert(void 0===i||i>=0,"sourceLine cannot be negative"),e.Debug.assert(void 0===a||a>=0,"sourceCharacter cannot be negative"),x(),(l(t,r)||_(n,i,a))&&(g(),M=t,L=r,V=!1,U=!1,z=!0),void 0!==n&&void 0!==i&&void 0!==a&&(R=n,B=i,j=a,V=!0,void 0!==o&&(J=o,U=!0)),D()}function f(t,r,n,i,a,l){var _;e.Debug.assert(t>=M,"generatedLine cannot backtrack"),e.Debug.assert(r>=0,"generatedCharacter cannot be negative"),x();for(var d,f=[],m=s(n.mappings),g=m.next(),v=g.value,y=g.done;!y&&(!l||!(v.generatedLine>l.line||v.generatedLine===l.line&&v.generatedCharacter>l.character));_=m.next(),v=_.value,y=_.done,_)if(!a||!(v.generatedLine<a.line||a.line===v.generatedLine&&v.generatedCharacter<a.character)){var h=void 0,b=void 0,S=void 0,C=void 0;if(void 0!==v.sourceIndex){if(h=f[v.sourceIndex],void 0===h){var k=n.sources[v.sourceIndex],T=n.sourceRoot?e.combinePaths(n.sourceRoot,k):k,E=e.combinePaths(e.getDirectoryPath(i),T);f[v.sourceIndex]=h=o(E),n.sourcesContent&&"string"==typeof n.sourcesContent[v.sourceIndex]&&c(h,n.sourcesContent[v.sourceIndex])}b=v.sourceLine,S=v.sourceCharacter,n.names&&void 0!==v.nameIndex&&(d||(d=[]),C=d[v.nameIndex],void 0===C&&(d[v.nameIndex]=C=u(n.names[v.nameIndex])))}var N=v.generatedLine-(a?a.line:0),A=N+t,F=a&&a.line===v.generatedLine?v.generatedCharacter-a.character:v.generatedCharacter,P=0===N?F+r:F;p(A,P,h,b,S,C)}D()}function m(){return!O||N!==M||A!==L||F!==R||P!==B||w!==j||I!==J}function g(){if(z&&m()){if(x(),M>N){do E+=";",N++,A=0;while(M>N)}else e.Debug.assertEqual(N,M,"generatedLine cannot backtrack"),O&&(E+=",");E+=d(L-A),A=L,V&&(E+=d(R-F),F=R,E+=d(B-P),P=B,E+=d(j-w),w=j,U&&(E+=d(J-I),I=J)),O=!0,D()}}function v(){return g(),{version:3,file:r,sourceRoot:n,sources:C,names:T,mappings:E,sourcesContent:y}}var y,h,b=a.extendedDiagnostics?e.performance.createTimer("Source Map","beforeSourcemap","afterSourcemap"):e.performance.nullTimer,x=b.enter,D=b.exit,S=[],C=[],k=e.createMap(),T=[],E="",N=0,A=0,F=0,P=0,w=0,I=0,O=!1,M=0,L=0,R=0,B=0,j=0,J=0,z=!1,V=!1,U=!1;return{getSources:function(){return S},addSource:o,setSourceContent:c,addName:u,addMapping:p,appendSourceMap:f,toJSON:v,toString:function(){return JSON.stringify(v())}}}function r(e,t){return{getLineCount:function(){return t.length},getLineText:function(r){return e.substring(t[r],t[r+1])}}}function n(e){for(var t=e.getLineCount()-1;t>=0;t--){var r=e.getLineText(t),n=b.exec(r);if(n)return n[1];if(!r.match(x))break}}function i(e){return"string"==typeof e||null===e}function a(t){return null!==t&&"object"==typeof t&&3===t.version&&"string"==typeof t.file&&"string"==typeof t.mappings&&e.isArray(t.sources)&&e.every(t.sources,e.isString)&&(void 0===t.sourceRoot||null===t.sourceRoot||"string"==typeof t.sourceRoot)&&(void 0===t.sourcesContent||null===t.sourcesContent||e.isArray(t.sourcesContent)&&e.every(t.sourcesContent,i))&&(void 0===t.names||null===t.names||e.isArray(t.names)&&e.every(t.names,e.isString))}function o(e){try{var t=JSON.parse(e);if(a(t))return t}catch(r){}return void 0}function s(e){function t(e,t){return{generatedLine:d,generatedCharacter:p,sourceIndex:e?f:void 0,sourceLine:e?m:void 0,sourceCharacter:e?g:void 0,nameIndex:t?v:void 0}}function r(){return u=!0,{value:void 0,done:!0}}function n(e){void 0===c&&(c=e)}function i(e){return n(e),r()}function a(){return void 0!==c}function o(){return l===e.length||44===e.charCodeAt(l)||59===e.charCodeAt(l)}function s(){for(var t=!0,r=0,i=0;t;l++){if(l>=e.length)return n("Error in decoding base64VLQFormatDecode, past the mapping string"),-1;var a=_(e.charCodeAt(l));if(-1===a)return n("Invalid character in VLQ"),-1;t=0!==(32&a),i|=(31&a)<<r,r+=5}return 0===(1&i)?i>>=1:(i>>=1,i=-i),i}var c,u=!1,l=0,d=0,p=0,f=0,m=0,g=0,v=0;return{get pos(){return l},get error(){return c},get state(){return t(!0,!0)},next:function(){for(;!u&&l<e.length;){var n=e.charCodeAt(l);if(59!==n){if(44!==n){var c=!1,_=!1;if(p+=s(),a())return r();if(0>p)return i("Invalid generatedCharacter found");if(!o()){if(c=!0,f+=s(),a())return r();if(0>f)return i("Invalid sourceIndex found");if(o())return i("Unsupported Format: No entries after sourceIndex");if(m+=s(),a())return r();if(0>m)return i("Invalid sourceLine found");if(o())return i("Unsupported Format: No entries after sourceLine");if(g+=s(),a())return r();if(0>g)return i("Invalid sourceCharacter found");if(!o()){if(_=!0,v+=s(),a())return r();if(0>v)return i("Invalid nameIndex found");if(!o())return i("Unsupported Error Format: Entries after nameIndex")}}return{value:t(c,_),done:u}}l++}else d++,p=0,l++}return r()}}}function c(e,t){return e===t||e.generatedLine===t.generatedLine&&e.generatedCharacter===t.generatedCharacter&&e.sourceIndex===t.sourceIndex&&e.sourceLine===t.sourceLine&&e.sourceCharacter===t.sourceCharacter&&e.nameIndex===t.nameIndex}function u(e){return void 0!==e.sourceIndex&&void 0!==e.sourceLine&&void 0!==e.sourceCharacter}function l(t){return t>=0&&26>t?65+t:t>=26&&52>t?97+t-26:t>=52&&62>t?48+t-52:62===t?43:63===t?47:e.Debug.fail(t+": not a base64 value")}function _(e){return e>=65&&90>=e?e-65:e>=97&&122>=e?e-97+26:e>=48&&57>=e?e-48+52:43===e?62:47===e?63:-1}function d(e){0>e?e=(-e<<1)+1:e<<=1;var t="";do{var r=31&e;e>>=5,e>0&&(r=32|r),t+=String.fromCharCode(l(r))}while(e>0);return t}function p(e){return void 0!==e.sourceIndex&&void 0!==e.sourcePosition}function f(e,t){return e.generatedPosition===t.generatedPosition&&e.sourceIndex===t.sourceIndex&&e.sourcePosition===t.sourcePosition}function m(t,r){return e.Debug.assert(t.sourceIndex===r.sourceIndex),e.compareValues(t.sourcePosition,r.sourcePosition)}function g(t,r){return e.compareValues(t.generatedPosition,r.generatedPosition)}function v(e){return e.sourcePosition}function y(e){return e.generatedPosition}function h(t,r,n){function i(n){var i,a,o=void 0!==C?e.getPositionOfLineAndCharacter(C,n.generatedLine,n.generatedCharacter,!0):-1;if(u(n)){var s=t.getSourceFileLike(k[n.sourceIndex]);i=r.sources[n.sourceIndex],a=void 0!==s?e.getPositionOfLineAndCharacter(s,n.sourceLine,n.sourceCharacter,!0):-1}return{generatedPosition:o,source:i,sourceIndex:n.sourceIndex,sourcePosition:a,nameIndex:n.nameIndex}}function a(){if(void 0===d){var n=s(r.mappings),a=e.arrayFrom(n,i);void 0!==n.error?(t.log&&t.log("Encountered error while decoding sourcemap: "+n.error),d=e.emptyArray):d=a}return d}function o(t){if(void 0===b){for(var r=[],n=0,i=a();n<i.length;n++){var o=i[n];if(p(o)){var s=r[o.sourceIndex];s||(r[o.sourceIndex]=s=[]),s.push(o)}}b=r.map(function(t){return e.sortAndDeduplicate(t,m,f)})}return b[t]}function c(){if(void 0===h){for(var t=[],r=0,n=a();r<n.length;r++){var i=n[r];t.push(i)}h=e.sortAndDeduplicate(t,g,f)}return h}function l(r){var n=T.get(t.getCanonicalFileName(r.fileName));if(void 0===n)return r;var i=o(n);if(!e.some(i))return r;var a=e.binarySearchKey(i,r.pos,v,e.compareValues);0>a&&(a=~a);var s=i[a];return void 0===s||s.sourceIndex!==n?r:{fileName:S,pos:s.generatedPosition}}function _(t){var r=c();if(!e.some(r))return t;var n=e.binarySearchKey(r,t.pos,y,e.compareValues);0>n&&(n=~n);var i=r[n];return void 0!==i&&p(i)?{fileName:k[i.sourceIndex],pos:i.sourcePosition}:t}var d,h,b,x=e.getDirectoryPath(n),D=r.sourceRoot?e.getNormalizedAbsolutePath(r.sourceRoot,x):x,S=e.getNormalizedAbsolutePath(r.file,x),C=t.getSourceFileLike(S),k=r.sources.map(function(t){return e.getNormalizedAbsolutePath(t,D)}),T=e.createMapFromEntries(k.map(function(e,r){return[t.getCanonicalFileName(e),r]}));return{getSourcePosition:_,getGeneratedPosition:l}
}e.createSourceMapGenerator=t;var b=/^\/\/[@#] source[M]appingURL=(.+)\s*$/,x=/^\s*(\/\/[@#] .*)?$/;e.getLineInfo=r,e.tryGetSourceMappingURL=n,e.isRawSourceMap=a,e.tryParseRawSourceMap=o,e.decodeMappings=s,e.sameMapping=c,e.isSourceMapping=u,e.createDocumentPositionMapper=h,e.identitySourceMapConsumer={getSourcePosition:e.identity,getGeneratedPosition:e.identity}}(n||(n={}));var n;!function(e){function t(t){return t=e.getOriginalNode(t),t?e.getNodeId(t):0}function r(t){return t&&e.isNamedImports(t)?e.some(t.elements,n):!1}function n(e){return void 0!==e.propertyName&&"default"===e.propertyName.escapedText}function i(t){function r(e){return 285===e.kind?t(e):n(e)}function n(r){return e.createBundle(e.map(r.sourceFiles,t),r.prepends)}return r}function a(t){if(e.getNamespaceDeclarationNode(t))return!0;var r=t.importClause&&t.importClause.namedBindings;if(!r)return!1;if(!e.isNamedImports(r))return!1;for(var i=0,a=0,o=r.elements;a<o.length;a++){var s=o[a];n(s)&&i++}return i>0&&i!==r.elements.length||!!(r.elements.length-i)&&e.isDefaultImport(t)}function o(t){return!a(t)&&(e.isDefaultImport(t)||!!t.importClause&&e.isNamedImports(t.importClause.namedBindings)&&r(t.importClause.namedBindings))}function s(r,n,i){for(var s,l,_=[],d=e.createMultiMap(),p=[],f=e.createMap(),m=!1,g=!1,v=!1,y=0,h=r.statements;y<h.length;y++){var b=h[y];switch(b.kind){case 250:_.push(b),v=v||a(b)||o(b);break;case 249:260===b.moduleReference.kind&&_.push(b);break;case 256:if(b.moduleSpecifier)b.exportClause?_.push(b):(_.push(b),g=!0);else for(var x=0,D=b.exportClause.elements;x<D.length;x++){var S=D[x];if(!f.get(e.idText(S.name))){var C=S.propertyName||S.name;d.add(e.idText(C),S);var k=n.getReferencedImportDeclaration(C)||n.getReferencedValueDeclaration(C);k&&u(p,t(k),S.name),f.set(e.idText(S.name),!0),s=e.append(s,S.name)}}break;case 255:b.isExportEquals&&!l&&(l=b);break;case 220:if(e.hasModifier(b,1))for(var T=0,E=b.declarationList.declarations;T<E.length;T++){var k=E[T];s=c(k,f,s)}break;case 240:if(e.hasModifier(b,1))if(e.hasModifier(b,512))m||(u(p,t(b),e.getDeclarationName(b)),m=!0);else{var C=b.name;f.get(e.idText(C))||(u(p,t(b),C),f.set(e.idText(C),!0),s=e.append(s,C))}break;case 241:if(e.hasModifier(b,1))if(e.hasModifier(b,512))m||(u(p,t(b),e.getDeclarationName(b)),m=!0);else{var C=b.name;C&&!f.get(e.idText(C))&&(u(p,t(b),C),f.set(e.idText(C),!0),s=e.append(s,C))}}}var N=e.getOrCreateExternalHelpersModuleNameIfNeeded(r,i,g,v),A=N&&e.createImportDeclaration(void 0,void 0,e.createImportClause(void 0,e.createNamespaceImport(N)),e.createLiteral(e.externalHelpersModuleNameText));return A&&(e.addEmitFlags(A,67108864),_.unshift(A)),{externalImports:_,exportSpecifiers:d,exportEquals:l,hasExportStarsToExportValues:g,exportedBindings:p,exportedNames:s,externalHelpersImportDeclaration:A}}function c(t,r,n){if(e.isBindingPattern(t.name))for(var i=0,a=t.name.elements;i<a.length;i++){var o=a[i];e.isOmittedExpression(o)||(n=c(o,r,n))}else if(!e.isGeneratedIdentifier(t.name)){var s=e.idText(t.name);r.get(s)||(r.set(s,!0),n=e.append(n,t.name))}return n}function u(e,t,r){var n=e[t];return n?n.push(r):e[t]=n=[r],n}function l(t){return e.isStringLiteralLike(t)||8===t.kind||e.isKeyword(t.kind)||e.isIdentifier(t)}function _(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];return function(r){for(var n="",i=0;i<t.length;i++)n+=e[i],n+=r(t[i]);return n+=e[e.length-1]}}e.getOriginalNodeId=t,e.chainBundle=i,e.getImportNeedsImportStarHelper=a,e.getImportNeedsImportDefaultHelper=o,e.collectExternalModuleInfo=s,e.isSimpleCopiableExpression=l,e.helperString=_}(n||(n={}));var n;!function(e){function t(t,n,i,o,s,c){function u(t){e.setEmitFlags(t,64),e.aggregateTransformFlags(t),v=e.append(v,t)}function _(t,r,i,a){e.Debug.assertNode(t,c?e.isIdentifier:e.isExpression);var o=c?c(t,r,i):e.setTextRange(e.createAssignment(e.visitNode(t,n,e.isExpression),r),i);o.original=a,u(o)}var p,m=t;if(e.isDestructuringAssignment(t))for(p=t.right;e.isEmptyArrayLiteral(t.left)||e.isEmptyObjectLiteral(t.left);){if(!e.isDestructuringAssignment(p))return e.visitNode(p,n,e.isExpression);m=t=p,p=t.right}var v,y={context:i,level:o,downlevelIteration:!!i.getCompilerOptions().downlevelIteration,hoistTempVariables:!0,emitExpression:u,emitBindingOrAssignment:_,createArrayBindingOrAssignmentPattern:d,createObjectBindingOrAssignmentPattern:f,createArrayBindingOrAssignmentElement:g,visitor:n};if(p&&(p=e.visitNode(p,n,e.isExpression),e.isIdentifier(p)&&r(t,p.escapedText)?p=l(y,p,!1,m):s?p=l(y,p,!0,m):e.nodeIsSynthesized(t)&&(m=p)),a(y,t,p,m,e.isDestructuringAssignment(t)),p&&s){if(!e.some(v))return p;v.push(p)}return e.aggregateTransformFlags(e.inlineExpressions(v))||e.createOmittedExpression()}function r(t,r){var i=e.getTargetOfBindingOrAssignmentElement(t);return e.isBindingOrAssignmentPattern(i)?n(i,r):e.isIdentifier(i)?i.escapedText===r:!1}function n(t,n){for(var i=e.getElementsOfBindingOrAssignmentPattern(t),a=0,o=i;a<o.length;a++){var s=o[a];if(r(s,n))return!0}return!1}function i(t,n,i,o,s,c,u){function d(t){g=e.append(g,t)}function f(t,r,n,i){e.Debug.assertNode(t,e.isBindingName),g&&(r=e.inlineExpressions(e.append(g,r)),g=void 0),v.push({pendingExpressions:g,name:t,value:r,location:n,original:i})}void 0===c&&(c=!1);var g,v=[],y=[],h={context:i,level:o,downlevelIteration:!!i.getCompilerOptions().downlevelIteration,hoistTempVariables:c,emitExpression:d,emitBindingOrAssignment:f,createArrayBindingOrAssignmentPattern:_,createObjectBindingOrAssignmentPattern:p,createArrayBindingOrAssignmentElement:m,visitor:n};if(e.isVariableDeclaration(t)){var b=e.getInitializerOfBindingOrAssignmentElement(t);b&&e.isIdentifier(b)&&r(t,b.escapedText)&&(b=l(h,b,!1,b),t=e.updateVariableDeclaration(t,t.name,t.type,b))}if(a(h,t,s,t,u),g){var x=e.createTempVariable(void 0);if(c){var D=e.inlineExpressions(g);g=void 0,f(x,D,void 0,void 0)}else{i.hoistVariableDeclaration(x);var S=e.last(v);S.pendingExpressions=e.append(S.pendingExpressions,e.createAssignment(x,S.value)),e.addRange(S.pendingExpressions,g),S.value=x}}for(var C=0,k=v;C<k.length;C++){var T=k[C],E=T.pendingExpressions,N=T.name,D=T.value,A=T.location,F=T.original,P=e.createVariableDeclaration(N,void 0,E?e.inlineExpressions(e.append(E,D)):D);P.original=F,e.setTextRange(P,A),e.isIdentifier(N)&&e.setEmitFlags(P,64),e.aggregateTransformFlags(P),y.push(P)}return y}function a(t,r,n,i,a){if(!a){var u=e.visitNode(e.getInitializerOfBindingOrAssignmentElement(r),t.visitor,e.isExpression);u?n=n?c(t,n,u,i):u:n||(n=e.createVoidZero())}var l=e.getTargetOfBindingOrAssignmentElement(r);e.isObjectBindingOrAssignmentPattern(l)?o(t,r,l,n,i):e.isArrayBindingOrAssignmentPattern(l)?s(t,r,l,n,i):t.emitBindingOrAssignment(l,n,i,r)}function o(t,r,n,i,o){var s=e.getElementsOfBindingOrAssignmentPattern(n),c=s.length;if(1!==c){var _=!e.isDeclarationBindingElement(r)||0!==c;i=l(t,i,_,o)}for(var d,p,f=0;c>f;f++){var m=s[f];if(e.getRestIndicatorOfBindingOrAssignmentElement(m)){if(f===c-1){d&&(t.emitBindingOrAssignment(t.createObjectBindingOrAssignmentPattern(d),i,o,n),d=void 0);var g=v(t.context,i,s,p,n);a(t,m,g,m)}}else{var y=e.getPropertyNameOfBindingOrAssignmentElement(m);if(!(t.level>=1)||12288&m.transformFlags||12288&e.getTargetOfBindingOrAssignmentElement(m).transformFlags||e.isComputedPropertyName(y)){d&&(t.emitBindingOrAssignment(t.createObjectBindingOrAssignmentPattern(d),i,o,n),d=void 0);var g=u(t,i,y);e.isComputedPropertyName(y)&&(p=e.append(p,g.argumentExpression)),a(t,m,g,m)}else d=e.append(d,m)}}d&&t.emitBindingOrAssignment(t.createObjectBindingOrAssignmentPattern(d),i,o,n)}function s(t,r,n,i,o){var s=e.getElementsOfBindingOrAssignmentPattern(n),c=s.length;if(t.level<1&&t.downlevelIteration)i=l(t,e.createReadHelper(t.context,i,c>0&&e.getRestIndicatorOfBindingOrAssignmentElement(s[c-1])?void 0:c,o),!1,o);else if(1!==c&&(t.level<1||0===c)||e.every(s,e.isOmittedExpression)){var u=!e.isDeclarationBindingElement(r)||0!==c;i=l(t,i,u,o)}for(var _,d,p=0;c>p;p++){var f=s[p];if(t.level>=1)if(8192&f.transformFlags){var m=e.createTempVariable(void 0);t.hoistTempVariables&&t.context.hoistVariableDeclaration(m),d=e.append(d,[m,f]),_=e.append(_,t.createArrayBindingOrAssignmentElement(m))}else _=e.append(_,f);else{if(e.isOmittedExpression(f))continue;if(e.getRestIndicatorOfBindingOrAssignmentElement(f)){if(p===c-1){var g=e.createArraySlice(i,p);a(t,f,g,f)}}else{var g=e.createElementAccess(i,p);a(t,f,g,f)}}}if(_&&t.emitBindingOrAssignment(t.createArrayBindingOrAssignmentPattern(_),i,o,n),d)for(var v=0,y=d;v<y.length;v++){var h=y[v],b=h[0],f=h[1];a(t,f,b,f)}}function c(t,r,n,i){return r=l(t,r,!0,i),e.createConditional(e.createTypeCheck(r,"undefined"),n,r)}function u(t,r,n){if(e.isComputedPropertyName(n)){var i=l(t,e.visitNode(n.expression,t.visitor),!1,n);return e.createElementAccess(r,i)}if(e.isStringOrNumericLiteralLike(n)){var i=e.getSynthesizedClone(n);return i.text=i.text,e.createElementAccess(r,i)}var a=e.createIdentifier(e.idText(n));return e.createPropertyAccess(r,a)}function l(t,r,n,i){if(e.isIdentifier(r)&&n)return r;var a=e.createTempVariable(void 0);return t.hoistTempVariables?(t.context.hoistVariableDeclaration(a),t.emitExpression(e.setTextRange(e.createAssignment(a,r),i))):t.emitBindingOrAssignment(a,r,i,void 0),a}function _(t){return e.Debug.assertEachNode(t,e.isArrayBindingElement),e.createArrayBindingPattern(t)}function d(t){return e.createArrayLiteral(e.map(t,e.convertToArrayAssignmentElement))}function p(t){return e.Debug.assertEachNode(t,e.isBindingElement),e.createObjectBindingPattern(t)}function f(t){return e.createObjectLiteral(e.map(t,e.convertToObjectAssignmentElement))}function m(t){return e.createBindingElement(void 0,void 0,t)}function g(e){return e}function v(t,r,n,i,a){t.requestEmitHelper(e.restHelper);for(var o=[],s=0,c=0;c<n.length-1;c++){var u=e.getPropertyNameOfBindingOrAssignmentElement(n[c]);if(u)if(e.isComputedPropertyName(u)){var l=i[s];s++,o.push(e.createConditional(e.createTypeCheck(l,"symbol"),l,e.createAdd(l,e.createLiteral(""))))}else o.push(e.createLiteral(u))}return e.createCall(e.getHelperName("__rest"),void 0,[r,e.setTextRange(e.createArrayLiteral(o),a)])}var y;!function(e){e[e.All=0]="All",e[e.ObjectRest=1]="ObjectRest"}(y=e.FlattenLevel||(e.FlattenLevel={})),e.flattenDestructuringAssignment=t,e.flattenDestructuringBinding=i,e.restHelper={name:"typescript:rest",scoped:!1,text:'\n            var __rest = (this && this.__rest) || function (s, e) {\n                var t = {};\n                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)\n                    t[p] = s[p];\n                if (s != null && typeof Object.getOwnPropertySymbols === "function")\n                    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {\n                        if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))\n                            t[p[i]] = s[p[i]];\n                    }\n                return t;\n            };'}}(n||(n={}));var n;!function(e){function t(t){function a(e){return 286===e.kind?s(e):c(e)}function s(t){return e.createBundle(t.sourceFiles.map(c),e.mapDefined(t.prepends,function(t){return 288===t.kind?e.createUnparsedSourceFile(t,"js"):t}))}function c(r){if(r.isDeclarationFile)return r;mn=r;var n=u(r,D);return e.addEmitHelpers(n,t.readEmitHelpers()),mn=void 0,n}function u(e,t){var r=yn,n=hn,i=bn;l(e);var a=t(e);return yn!==r&&(bn=i),yn=r,hn=n,a}function l(t){switch(t.kind){case 285:case 247:case 246:case 219:yn=t,hn=void 0,bn=void 0;break;case 241:case 240:if(e.hasModifier(t,2))break;t.name?lr(t):e.Debug.assert(241===t.kind||e.hasModifier(t,512)),e.isClassDeclaration(t)&&(hn=t)}}function _(e){return u(e,d)}function d(e){return 1&e.transformFlags?x(e):e}function p(e){return u(e,f)}function f(e){switch(e.kind){case 250:case 249:case 255:case 256:return m(e);default:return d(e)}}function m(r){var n=e.getParseTreeNode(r);if(n!==r)return 1&r.transformFlags?e.visitEachChild(r,_,t):r;switch(r.kind){case 250:return vr(r);case 249:return Tr(r);case 255:return xr(r);case 256:return Dr(r);default:e.Debug.fail("Unhandled ellided statement")}}function g(e){return u(e,v)}function v(t){return 256===t.kind||250===t.kind||251===t.kind||249===t.kind&&260===t.moduleReference.kind?void 0:1&t.transformFlags||e.hasModifier(t,1)?x(t):t}function y(e){return u(e,h)}function h(t){switch(t.kind){case 158:return void 0;case 155:case 163:case 159:case 160:case 157:return d(t);case 218:return t;default:return e.Debug.failBadSyntaxKind(t)}}function b(t){return 2270&e.modifierToFlag(t.kind)?void 0:gn&&86===t.kind?void 0:t}function x(r){if(e.isStatement(r)&&e.hasModifier(r,2))return e.createNotEmittedStatement(r);switch(r.kind){case 86:case 81:return gn?void 0:r;case 116:case 114:case 115:case 119:case 78:case 126:case 134:case 170:case 171:case 172:case 173:case 169:case 164:case 151:case 121:case 144:case 124:case 139:case 136:case 133:case 107:case 140:case 167:case 166:case 168:case 165:case 174:case 175:case 176:case 178:case 179:case 180:case 181:case 182:case 183:case 163:case 153:case 243:return void 0;case 155:return Bt(r);case 248:return void 0;case 158:return jt(r);case 242:return e.createNotEmittedStatement(r);case 241:return N(r);case 210:return P(r);case 274:return Mt(r);case 212:return Lt(r);case 157:return Jt(r);case 159:return Vt(r);case 160:return Ut(r);case 240:return Kt(r);case 197:return qt(r);case 198:return Wt(r);case 152:return Ht(r);case 196:return Yt(r);case 195:case 213:return Zt(r);case 192:return er(r);case 193:return tr(r);case 194:return rr(r);case 214:return $t(r);case 244:return ir(r);case 220:return Gt(r);case 238:return Xt(r);case 245:return fr(r);case 249:return Tr(r);default:return e.visitEachChild(r,_,t)}}function D(r){var n=e.getStrictOptionValue(un,"alwaysStrict")&&!(e.isExternalModule(r)&&dn>=e.ModuleKind.ES2015)&&!e.isJsonSourceFile(r);return e.updateSourceFileNode(r,e.visitLexicalEnvironment(r.statements,p,t,0,n))}function S(t){if(t.decorators&&t.decorators.length>0)return!0;var r=e.getFirstConstructorWithBody(t);return r?e.forEach(r.parameters,C):!1}function C(e){return void 0!==e.decorators&&e.decorators.length>0}function k(t,r){var n=0;e.some(r)&&(n|=1);var i=e.getEffectiveBaseTypeNode(t);return i&&97!==e.skipOuterExpressions(i.expression).kind&&(n|=64),S(t)&&(n|=2),e.childIsDecorated(t)&&(n|=4),Er(t)?n|=8:Fr(t)?n|=32:Ar(t)&&(n|=16),1>=_n&&7&n&&(n|=128),n}function T(e){return!!(1024&e.transformFlags)}function E(t){return e.some(t.decorators)||e.some(t.typeParameters)||e.some(t.heritageClauses,T)||e.some(t.members,T)}function N(r){if(!(E(r)||gn&&e.hasModifier(r,1)))return e.visitEachChild(r,_,t);var n=Cn;Cn=void 0;var i=J(r,!0),a=k(r,i);128&a&&t.startLexicalEnvironment();var o=r.name||(5&a?e.getGeneratedNameForNode(r):void 0),s=2&a?F(r,o,a):A(r,o,a),c=[s];if(e.some(Cn)&&c.push(e.createExpressionStatement(e.inlineExpressions(Cn))),Cn=n,1&a&&K(c,i,128&a?e.getInternalName(r):e.getLocalName(r)),it(c,r,!1),it(c,r,!0),st(c,r),128&a){var u=e.createTokenRange(e.skipTrivia(mn.text,r.members.end),19),l=e.getInternalName(r),d=e.createPartiallyEmittedExpression(l);d.end=u.end,e.setEmitFlags(d,1536);var p=e.createReturn(d);p.pos=u.pos,e.setEmitFlags(p,1920),c.push(p),e.insertStatementsAfterStandardPrologue(c,t.endLexicalEnvironment());var f=e.createImmediatelyInvokedArrowFunction(c);e.setEmitFlags(f,33554432);var m=e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.getLocalName(r,!1,!1),void 0,f)]));e.setOriginalNode(m,r),e.setCommentRange(m,r),e.setSourceMapRange(m,e.moveRangePastDecorators(r)),e.startOnNewLine(m),c=[m]}return 8&a?wr(c,r):(128&a||2&a)&&(32&a?c.push(e.createExportDefault(e.getLocalName(r,!1,!0))):16&a&&c.push(e.createExternalModuleExport(e.getLocalName(r,!1,!0)))),c.length>1&&(c.push(e.createEndOfDeclarationMarker(r)),e.setEmitFlags(s,4194304|e.getEmitFlags(s))),e.singleOrMany(c)}function A(t,r,n){var i=128&n?void 0:e.visitNodes(t.modifiers,b,e.isModifier),a=e.createClassDeclaration(void 0,i,r,void 0,e.visitNodes(t.heritageClauses,_,e.isHeritageClause),w(t,0!==(64&n))),o=e.getEmitFlags(t);return 1&n&&(o|=32),e.setTextRange(a,t),e.setOriginalNode(a,t),e.setEmitFlags(a,o),a}function F(t,r,n){var i=e.moveRangePastDecorators(t),a=Br(t),o=e.getLocalName(t,!1,!0),s=e.visitNodes(t.heritageClauses,_,e.isHeritageClause),c=w(t,0!==(64&n)),u=e.createClassExpression(void 0,r,void 0,s,c);e.setOriginalNode(u,t),e.setTextRange(u,i);var l=e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(o,void 0,a?e.createAssignment(a,u):u)],1));return e.setOriginalNode(l,t),e.setTextRange(l,i),e.setCommentRange(l,t),l}function P(r){if(!E(r))return e.visitEachChild(r,_,t);var n=Cn;Cn=void 0;var i=J(r,!0),a=e.visitNodes(r.heritageClauses,_,e.isHeritageClause),o=w(r,e.some(a,function(e){return 87===e.token})),s=e.createClassExpression(void 0,r.name,void 0,a,o);if(e.setOriginalNode(s,r),e.setTextRange(s,r),e.some(i)||e.some(Cn)){var c=[],u=16777216&cn.getNodeCheckFlags(r),l=e.createTempVariable(sn,!!u);if(u){Vr();var d=e.getSynthesizedClone(l);d.autoGenerateFlags&=-9,Dn[e.getOriginalNodeId(r)]=d}return e.setEmitFlags(s,65536|e.getEmitFlags(s)),c.push(e.startOnNewLine(e.createAssignment(l,s))),e.addRange(c,e.map(Cn,e.startOnNewLine)),Cn=n,e.addRange(c,q(i,l)),c.push(e.startOnNewLine(l)),e.inlineExpressions(c)}return Cn=n,s}function w(t,r){var n=[],i=I(t,r);return i&&n.push(i),e.addRange(n,e.visitNodes(t.members,y,e.isClassElement)),e.setTextRange(e.createNodeArray(n),t.members)}function I(r,n){var i=e.getFirstConstructorWithBody(r),a=e.forEach(r.members,V),o=i&&1024&i.transformFlags&&e.forEach(i.parameters,B);if(!a&&!o)return e.visitEachChild(i,_,t);var s=O(i),c=M(r,i,n);return e.startOnNewLine(e.setOriginalNode(e.setTextRange(e.createConstructor(void 0,void 0,s,c),i||r),i))}function O(r){return e.visitParameterList(r&&r.parameters,_,t)||[]}function M(t,r,n){var i=[],a=0;if(an(),r){a=L(r,i);var o=R(r);e.addRange(i,e.map(o,j))}else n&&i.push(e.createExpressionStatement(e.createCall(e.createSuper(),void 0,[e.createSpread(e.createIdentifier("arguments"))])));var s=J(t,!1);return K(i,s,e.createThis()),r&&e.addRange(i,e.visitNodes(r.body.statements,_,e.isStatement,a)),i=e.mergeLexicalEnvironment(i,on()),e.setTextRange(e.createBlock(e.setTextRange(e.createNodeArray(i),r?r.body.statements:t.members),!0),r?r.body:void 0)}function L(t,r){if(t.body){var n=t.body.statements,i=e.addPrologue(r,n,!1,_);if(i===n.length)return i;var a=n[i];return 222===a.kind&&e.isSuperCall(a.expression)?(r.push(e.visitNode(a,_,e.isStatement)),i+1):i}return 0}function R(t){return e.filter(t.parameters,B)}function B(t){return e.hasModifier(t,92)&&e.isIdentifier(t.name)}function j(t){e.Debug.assert(e.isIdentifier(t.name));var r=t.name,n=e.getMutableClone(r);e.setEmitFlags(n,1584);var i=e.getMutableClone(r);return e.setEmitFlags(i,1536),e.startOnNewLine(e.setEmitFlags(e.setTextRange(e.createExpressionStatement(e.createAssignment(e.setTextRange(e.createPropertyAccess(e.createThis(),n),t.name),i)),e.moveRangePos(t,-1)),1536))}function J(t,r){return e.filter(t.members,r?z:V)}function z(e){return U(e,!0)}function V(e){return U(e,!1)}function U(t,r){return 155===t.kind&&r===e.hasModifier(t,32)&&void 0!==t.initializer}function K(t,r,n){for(var i=0,a=r;i<a.length;i++){var o=a[i],s=e.createExpressionStatement(W(o,n));e.setSourceMapRange(s,e.moveRangePastModifiers(o)),e.setCommentRange(s,o),e.setOriginalNode(s,o),t.push(s)}}function q(t,r){for(var n=[],i=0,a=t;i<a.length;i++){var o=a[i],s=W(o,r);e.startOnNewLine(s),e.setSourceMapRange(s,e.moveRangePastModifiers(o)),e.setCommentRange(s,o),e.setOriginalNode(s,o),n.push(s)}return n}function W(t,r){var n=e.isComputedPropertyName(t.name)&&!Pt(t.name.expression)?e.updateComputedPropertyName(t.name,e.getGeneratedNameForNode(t.name)):t.name,i=e.visitNode(t.initializer,_,e.isExpression),a=e.createMemberAccessForPropertyName(r,n,n);return e.createAssignment(a,i)}function H(t,r){return e.filter(t.members,r?function(e){return G(e,t)}:function(e){return Q(e,t)})}function G(e,t){return X(e,!0,t)}function Q(e,t){return X(e,!1,t)}function X(t,r,n){return e.nodeOrChildIsDecorated(t,n)&&r===e.hasModifier(t,32)}function Y(t){var r;if(t)for(var n=t.parameters,i=n.length>0&&e.parameterIsThisKeyword(n[0]),a=i?1:0,o=i?n.length-1:n.length,s=0;o>s;s++){var c=n[s+a];(r||c.decorators)&&(r||(r=new Array(o)),r[s]=c.decorators)}return r}function Z(t){var r=t.decorators,n=Y(e.getFirstConstructorWithBody(t));return r||n?{decorators:r,parameters:n}:void 0}function $(e,t){switch(t.kind){case 159:case 160:return et(e,t);case 157:return tt(t);case 155:return rt(t);default:return void 0}}function et(t,r){if(!r.body)return void 0;var n=e.getAllAccessorDeclarations(t.members,r),i=n.firstAccessor,a=n.secondAccessor,o=n.setAccessor,s=i.decorators?i:a&&a.decorators?a:void 0;if(!s||r!==s)return void 0;var c=s.decorators,u=Y(o);return c||u?{decorators:c,parameters:u}:void 0}function tt(e){if(!e.body)return void 0;var t=e.decorators,r=Y(e);return t||r?{decorators:t,parameters:r}:void 0}function rt(e){var t=e.decorators;return t?{decorators:t}:void 0}function nt(t,r,n){if(!n)return void 0;var i=[];return e.addRange(i,e.map(n.decorators,ut)),e.addRange(i,e.flatMap(n.parameters,lt)),_t(t,r,i),i}function it(t,r,n){e.addRange(t,e.map(at(r,n),Pr))}function at(e,t){for(var r,n=H(e,t),i=0,a=n;i<a.length;i++){var o=a[i],s=ot(e,o);s&&(r?r.push(s):r=[s])}return r}function ot(n,i){var a=$(n,i),o=nt(i,n,a);if(!o)return void 0;var s=Jr(n,i),c=wt(i,!0),u=_n>0?155===i.kind?e.createVoidZero():e.createNull():void 0,l=r(t,o,s,c,u,e.moveRangePastDecorators(i));return e.setEmitFlags(l,1536),l}function st(t,r){var n=ct(r);n&&t.push(e.setOriginalNode(e.createExpressionStatement(n),r))}function ct(n){var i=Z(n),a=nt(n,n,i);if(!a)return void 0;var o=Dn&&Dn[e.getOriginalNodeId(n)],s=e.getLocalName(n,!1,!0),c=r(t,a,s),u=e.createAssignment(s,o?e.createAssignment(o,c):c);return e.setEmitFlags(u,1536),e.setSourceMapRange(u,e.moveRangePastDecorators(n)),u}function ut(t){return e.visitNode(t.expression,_,e.isExpression)}function lt(r,n){var a;if(r){a=[];for(var o=0,s=r;o<s.length;o++){var c=s[o],u=i(t,ut(c),n,c.expression);e.setEmitFlags(u,1536),a.push(u)}}return a}function _t(e,t,r){o?pt(e,t,r):dt(e,t,r)}function dt(e,r,i){un.emitDecoratorMetadata&&(ft(e)&&i.push(n(t,"design:type",yt(e))),gt(e)&&i.push(n(t,"design:paramtypes",ht(e,r))),mt(e)&&i.push(n(t,"design:returntype",xt(e))))}function pt(r,i,a){if(un.emitDecoratorMetadata){var o=void 0;ft(r)&&(o||(o=[])).push(e.createPropertyAssignment("type",e.createArrowFunction(void 0,void 0,[],void 0,e.createToken(37),yt(r)))),gt(r)&&(o||(o=[])).push(e.createPropertyAssignment("paramTypes",e.createArrowFunction(void 0,void 0,[],void 0,e.createToken(37),ht(r,i)))),mt(r)&&(o||(o=[])).push(e.createPropertyAssignment("returnType",e.createArrowFunction(void 0,void 0,[],void 0,e.createToken(37),xt(r)))),o&&a.push(n(t,"design:typeinfo",e.createObjectLiteral(o,!0)))}}function ft(e){var t=e.kind;return 157===t||159===t||160===t||155===t}function mt(e){return 157===e.kind}function gt(t){switch(t.kind){case 241:case 210:return void 0!==e.getFirstConstructorWithBody(t);case 157:case 159:case 160:return!0}return!1}function vt(t){var r=cn.getAllAccessorDeclarations(t);return r.setAccessor&&e.getSetAccessorTypeAnnotationNode(r.setAccessor)||r.getAccessor&&e.getEffectiveReturnTypeNode(r.getAccessor)}function yt(t){switch(t.kind){case 155:case 152:return Dt(t.type);case 160:case 159:return Dt(vt(t));case 241:case 210:case 157:return e.createIdentifier("Function");default:return e.createVoidZero()}}function ht(t,r){var n=e.isClassLike(t)?e.getFirstConstructorWithBody(t):e.isFunctionLike(t)&&e.nodeIsPresent(t.body)?t:void 0,i=[];if(n)for(var a=bt(n,r),o=a.length,s=0;o>s;s++){var c=a[s];0===s&&e.isIdentifier(c.name)&&"this"===c.name.escapedText||i.push(c.dotDotDotToken?Dt(e.getRestParameterElementType(c.type)):yt(c))}return e.createArrayLiteral(i)}function bt(t,r){if(r&&159===t.kind){var n=e.getAllAccessorDeclarations(r.members,t).setAccessor;if(n)return n.parameters}return t.parameters}function xt(t){return e.isFunctionLike(t)&&t.type?Dt(t.type):e.isAsyncFunction(t)?e.createIdentifier("Promise"):e.createVoidZero()}function Dt(t){if(void 0===t)return e.createIdentifier("Object");switch(t.kind){case 107:case 142:case 97:case 133:return e.createVoidZero();case 178:return Dt(t.type);case 166:case 167:return e.createIdentifier("Function");case 170:case 171:return e.createIdentifier("Array");case 164:case 124:return e.createIdentifier("Boolean");case 139:return e.createIdentifier("String");case 137:return e.createIdentifier("Object");case 183:switch(t.literal.kind){case 10:return e.createIdentifier("String");case 203:case 8:return e.createIdentifier("Number");case 9:return Ft();case 103:case 88:return e.createIdentifier("Boolean");default:return e.Debug.failBadSyntaxKind(t.literal)}case 136:return e.createIdentifier("Number");case 147:return Ft();case 140:return 2>_n?At():e.createIdentifier("Symbol");case 165:return Ct(t);case 175:case 174:return St(t.types);case 176:return St([t.trueType,t.falseType]);case 180:if(134===t.operator)return Dt(t.type);break;case 168:case 181:case 182:case 169:case 121:case 144:case 179:case 184:break;default:return e.Debug.failBadSyntaxKind(t)}return e.createIdentifier("Object")}function St(t){for(var r,n=0,i=t;n<i.length;n++){for(var a=i[n];178===a.kind;)a=a.type;if(133!==a.kind&&(ln||97!==a.kind&&142!==a.kind)){var o=Dt(a);if(e.isIdentifier(o)&&"Object"===o.escapedText)return o;if(r){if(!e.isIdentifier(r)||!e.isIdentifier(o)||r.escapedText!==o.escapedText)return e.createIdentifier("Object")}else r=o}}return r||e.createVoidZero()}function Ct(t){var r=cn.getTypeReferenceSerializationKind(t.typeName,hn||yn);switch(r){case e.TypeReferenceSerializationKind.Unknown:if(e.findAncestor(t,function(t){return t.parent&&e.isConditionalTypeNode(t.parent)&&(t.parent.trueType===t||t.parent.falseType===t)}))return e.createIdentifier("Object");var n=Tt(t.typeName),i=e.createTempVariable(sn);return e.createConditional(e.createTypeCheck(e.createAssignment(i,n),"function"),i,e.createIdentifier("Object"));case e.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue:return Et(t.typeName);case e.TypeReferenceSerializationKind.VoidNullableOrNeverType:return e.createVoidZero();case e.TypeReferenceSerializationKind.BigIntLikeType:return Ft();case e.TypeReferenceSerializationKind.BooleanType:return e.createIdentifier("Boolean");case e.TypeReferenceSerializationKind.NumberLikeType:return e.createIdentifier("Number");case e.TypeReferenceSerializationKind.StringLikeType:return e.createIdentifier("String");case e.TypeReferenceSerializationKind.ArrayLikeType:return e.createIdentifier("Array");case e.TypeReferenceSerializationKind.ESSymbolType:return 2>_n?At():e.createIdentifier("Symbol");case e.TypeReferenceSerializationKind.TypeWithCallSignature:return e.createIdentifier("Function");case e.TypeReferenceSerializationKind.Promise:return e.createIdentifier("Promise");case e.TypeReferenceSerializationKind.ObjectType:return e.createIdentifier("Object");default:return e.Debug.assertNever(r)}}function kt(t,r){return e.createLogicalAnd(e.createStrictInequality(e.createTypeOf(t),e.createLiteral("undefined")),r)}function Tt(t){if(73===t.kind){var r=Et(t);return kt(r,r)}if(73===t.left.kind)return kt(Et(t.left),Et(t));var n=Tt(t.left),i=e.createTempVariable(sn);return e.createLogicalAnd(e.createLogicalAnd(n.left,e.createStrictInequality(e.createAssignment(i,n.right),e.createVoidZero())),e.createPropertyAccess(i,t.right))}function Et(t){switch(t.kind){case 73:var r=e.getMutableClone(t);return r.flags&=-9,r.original=void 0,r.parent=e.getParseTreeNode(yn),r;case 149:return Nt(t)}}function Nt(t){return e.createPropertyAccess(Et(t.left),t.right)}function At(){return e.createConditional(e.createTypeCheck(e.createIdentifier("Symbol"),"function"),e.createIdentifier("Symbol"),e.createIdentifier("Object"))}function Ft(){return 8>_n?e.createConditional(e.createTypeCheck(e.createIdentifier("BigInt"),"function"),e.createIdentifier("BigInt"),e.createIdentifier("Object")):e.createIdentifier("BigInt")}function Pt(t){return!e.isIdentifier(t)&&e.isSimpleCopiableExpression(t)||e.isWellKnownSymbolSyntactically(t)}function wt(t,r){var n=t.name;return e.isComputedPropertyName(n)?r&&!Pt(n.expression)?e.getGeneratedNameForNode(n):n.expression:e.isIdentifier(n)?e.createLiteral(e.idText(n)):e.getSynthesizedClone(n)}function It(t,r,n){if(e.isComputedPropertyName(t)){var i=e.visitNode(t.expression,_,e.isExpression),a=e.skipPartiallyEmittedExpressions(i),o=Pt(a);if(!o&&r){var s=e.getGeneratedNameForNode(t);return sn(s),e.createAssignment(s,i)}return n&&(o||e.isIdentifier(a))?void 0:i}}function Ot(t){var r=t.name,n=It(r,e.some(t.decorators),!1);return n?(e.some(Cn)&&(n=e.inlineExpressions(Cn.concat([n])),Cn.length=0),e.updateComputedPropertyName(r,n)):r}function Mt(r){return 110===r.token?void 0:e.visitEachChild(r,_,t)}function Lt(t){return e.updateExpressionWithTypeArguments(t,void 0,e.visitNode(t.expression,_,e.isLeftHandSideExpression))}function Rt(t){return!e.nodeIsMissing(t.body)}function Bt(t){var r=It(t.name,e.some(t.decorators)||!!t.initializer,!0);return void(r&&!Pt(r)&&(Cn||(Cn=[])).push(r))}function jt(r){return Rt(r)?e.updateConstructor(r,e.visitNodes(r.decorators,_,e.isDecorator),e.visitNodes(r.modifiers,_,e.isModifier),e.visitParameterList(r.parameters,_,t),e.visitFunctionBody(r.body,_,t)):void 0}function Jt(r){if(!Rt(r))return void 0;var n=e.updateMethod(r,void 0,e.visitNodes(r.modifiers,b,e.isModifier),r.asteriskToken,Ot(r),void 0,void 0,e.visitParameterList(r.parameters,_,t),void 0,e.visitFunctionBody(r.body,_,t));return n!==r&&(e.setCommentRange(n,r),e.setSourceMapRange(n,e.moveRangePastDecorators(r))),n}function zt(t){return!(e.nodeIsMissing(t.body)&&e.hasModifier(t,128))}function Vt(r){if(!zt(r))return void 0;var n=e.updateGetAccessor(r,void 0,e.visitNodes(r.modifiers,b,e.isModifier),Ot(r),e.visitParameterList(r.parameters,_,t),void 0,e.visitFunctionBody(r.body,_,t)||e.createBlock([]));return n!==r&&(e.setCommentRange(n,r),e.setSourceMapRange(n,e.moveRangePastDecorators(r))),n}function Ut(r){if(!zt(r))return void 0;var n=e.updateSetAccessor(r,void 0,e.visitNodes(r.modifiers,b,e.isModifier),Ot(r),e.visitParameterList(r.parameters,_,t),e.visitFunctionBody(r.body,_,t)||e.createBlock([]));return n!==r&&(e.setCommentRange(n,r),e.setSourceMapRange(n,e.moveRangePastDecorators(r))),n}function Kt(r){if(!Rt(r))return e.createNotEmittedStatement(r);var n=e.updateFunctionDeclaration(r,void 0,e.visitNodes(r.modifiers,b,e.isModifier),r.asteriskToken,r.name,void 0,e.visitParameterList(r.parameters,_,t),void 0,e.visitFunctionBody(r.body,_,t)||e.createBlock([]));if(Er(r)){var i=[n];return wr(i,r),i}return n}function qt(r){if(!Rt(r))return e.createOmittedExpression();var n=e.updateFunctionExpression(r,e.visitNodes(r.modifiers,b,e.isModifier),r.asteriskToken,r.name,void 0,e.visitParameterList(r.parameters,_,t),void 0,e.visitFunctionBody(r.body,_,t)||e.createBlock([]));return n}function Wt(r){var n=e.updateArrowFunction(r,e.visitNodes(r.modifiers,b,e.isModifier),void 0,e.visitParameterList(r.parameters,_,t),void 0,r.equalsGreaterThanToken,e.visitFunctionBody(r.body,_,t));return n}function Ht(t){if(e.parameterIsThisKeyword(t))return void 0;var r=e.updateParameter(t,void 0,void 0,t.dotDotDotToken,e.visitNode(t.name,_,e.isBindingName),void 0,void 0,e.visitNode(t.initializer,_,e.isExpression));return r!==t&&(e.setCommentRange(r,t),e.setTextRange(r,e.moveRangePastModifiers(t)),e.setSourceMapRange(r,e.moveRangePastModifiers(t)),e.setEmitFlags(r.name,32)),r}function Gt(r){if(Er(r)){var n=e.getInitializedVariables(r.declarationList);return 0===n.length?void 0:e.setTextRange(e.createExpressionStatement(e.inlineExpressions(e.map(n,Qt))),r)}return e.visitEachChild(r,_,t)}function Qt(r){var n=r.name;return e.isBindingPattern(n)?e.flattenDestructuringAssignment(r,_,t,0,!1,Or):e.setTextRange(e.createAssignment(Mr(n),e.visitNode(r.initializer,_,e.isExpression)),r)
}function Xt(t){return e.updateVariableDeclaration(t,e.visitNode(t.name,_,e.isBindingName),void 0,e.visitNode(t.initializer,_,e.isExpression))}function Yt(r){var n=e.skipOuterExpressions(r.expression,-3);if(e.isAssertionExpression(n)){var i=e.visitNode(r.expression,_,e.isExpression);return e.length(e.getLeadingCommentRangesOfNode(i,mn))?e.updateParen(r,i):e.createPartiallyEmittedExpression(i,r)}return e.visitEachChild(r,_,t)}function Zt(t){var r=e.visitNode(t.expression,_,e.isExpression);return e.createPartiallyEmittedExpression(r,t)}function $t(t){var r=e.visitNode(t.expression,_,e.isLeftHandSideExpression);return e.createPartiallyEmittedExpression(r,t)}function er(t){return e.updateCall(t,e.visitNode(t.expression,_,e.isExpression),void 0,e.visitNodes(t.arguments,_,e.isExpression))}function tr(t){return e.updateNew(t,e.visitNode(t.expression,_,e.isExpression),void 0,e.visitNodes(t.arguments,_,e.isExpression))}function rr(t){return e.updateTaggedTemplate(t,e.visitNode(t.tag,_,e.isExpression),void 0,e.visitNode(t.template,_,e.isExpression))}function nr(t){return!e.isEnumConst(t)||un.preserveConstEnums||un.isolatedModules}function ir(t){if(!nr(t))return e.createNotEmittedStatement(t);var r=[],n=2,i=pr(r,t);i&&(dn!==e.ModuleKind.System||yn!==mn)&&(n|=512);var a=Lr(t),o=Rr(t),s=e.hasModifier(t,1)?e.getExternalModuleOrNamespaceExportName(vn,t,!1,!0):e.getLocalName(t,!1,!0),c=e.createLogicalOr(s,e.createAssignment(s,e.createObjectLiteral()));if(ur(t)){var u=e.getLocalName(t,!1,!0);c=e.createAssignment(u,c)}var l=e.createExpressionStatement(e.createCall(e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,a)],void 0,ar(t,o)),void 0,[c]));return e.setOriginalNode(l,t),i&&(e.setSyntheticLeadingComments(l,void 0),e.setSyntheticTrailingComments(l,void 0)),e.setTextRange(l,t),e.addEmitFlags(l,n),r.push(l),r.push(e.createEndOfDeclarationMarker(t)),r}function ar(t,r){var n=vn;vn=r;var i=[];nn();var a=e.map(t.members,or);return e.insertStatementsAfterStandardPrologue(i,on()),e.addRange(i,a),vn=n,e.createBlock(e.setTextRange(e.createNodeArray(i),t.members),!0)}function or(t){var r=wt(t,!1),n=sr(t),i=e.createAssignment(e.createElementAccess(vn,r),n),a=10===n.kind?i:e.createAssignment(e.createElementAccess(vn,i),r);return e.setTextRange(e.createExpressionStatement(e.setTextRange(a,t)),t)}function sr(t){var r=cn.getConstantValue(t);return void 0!==r?e.createLiteral(r):(zr(),t.initializer?e.visitNode(t.initializer,_,e.isExpression):e.createVoidZero())}function cr(t){return e.isInstantiatedModule(t,!!un.preserveConstEnums||!!un.isolatedModules)}function ur(t){return Er(t)||Nr(t)&&dn!==e.ModuleKind.ES2015&&dn!==e.ModuleKind.ESNext&&dn!==e.ModuleKind.System}function lr(t){bn||(bn=e.createUnderscoreEscapedMap());var r=dr(t);bn.has(r)||bn.set(r,t)}function _r(e){if(bn){var t=dr(e);return bn.get(t)===e}return!0}function dr(t){return e.Debug.assertNode(t.name,e.isIdentifier),t.name.escapedText}function pr(t,r){var n=e.createVariableStatement(e.visitNodes(r.modifiers,b,e.isModifier),e.createVariableDeclarationList([e.createVariableDeclaration(e.getLocalName(r,!1,!0))],285===yn.kind?0:1));if(e.setOriginalNode(n,r),lr(r),_r(r))return 244===r.kind?e.setSourceMapRange(n.declarationList,r):e.setSourceMapRange(n,r),e.setCommentRange(n,r),e.addEmitFlags(n,4195328),t.push(n),!0;var i=e.createMergeDeclarationMarker(n);return e.setEmitFlags(i,4195840),t.push(i),!1}function fr(t){if(!cr(t))return e.createNotEmittedStatement(t);e.Debug.assertNode(t.name,e.isIdentifier,"A TypeScript namespace should have an Identifier name."),Ur();var r=[],n=2,i=pr(r,t);i&&(dn!==e.ModuleKind.System||yn!==mn)&&(n|=512);var a=Lr(t),o=Rr(t),s=e.hasModifier(t,1)?e.getExternalModuleOrNamespaceExportName(vn,t,!1,!0):e.getLocalName(t,!1,!0),c=e.createLogicalOr(s,e.createAssignment(s,e.createObjectLiteral()));if(ur(t)){var u=e.getLocalName(t,!1,!0);c=e.createAssignment(u,c)}var l=e.createExpressionStatement(e.createCall(e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,a)],void 0,mr(t,o)),void 0,[c]));return e.setOriginalNode(l,t),i&&(e.setSyntheticLeadingComments(l,void 0),e.setSyntheticTrailingComments(l,void 0)),e.setTextRange(l,t),e.addEmitFlags(l,n),r.push(l),r.push(e.createEndOfDeclarationMarker(t)),r}function mr(t,r){var n=vn,i=gn,a=bn;vn=r,gn=t,bn=void 0;var o=[];nn();var s,c,l=t.body;if(246===l.kind)u(l,function(t){return e.addRange(o,e.visitNodes(t.statements,g,e.isStatement))}),s=l.statements,c=l;else{var _=fr(l);_&&(e.isArray(_)?e.addRange(o,_):o.push(_));var d=gr(t).body;s=e.moveRangePos(d.statements,-1)}e.insertStatementsAfterStandardPrologue(o,on()),vn=n,gn=i,bn=a;var p=e.createBlock(e.setTextRange(e.createNodeArray(o),s),!0);return e.setTextRange(p,c),246!==l.kind&&e.setEmitFlags(p,1536|e.getEmitFlags(p)),p}function gr(e){if(245===e.body.kind){var t=gr(e.body);return t||e.body}}function vr(t){if(!t.importClause)return t;var r=e.visitNode(t.importClause,yr,e.isImportClause);return r?e.updateImportDeclaration(t,void 0,void 0,r,t.moduleSpecifier):void 0}function yr(t){var r=cn.isReferencedAliasDeclaration(t)?t.name:void 0,n=e.visitNode(t.namedBindings,hr,e.isNamedImportBindings);return r||n?e.updateImportClause(t,r,n):void 0}function hr(t){if(252===t.kind)return cn.isReferencedAliasDeclaration(t)?t:void 0;var r=e.visitNodes(t.elements,br,e.isImportSpecifier);return e.some(r)?e.updateNamedImports(t,r):void 0}function br(e){return cn.isReferencedAliasDeclaration(e)?e:void 0}function xr(r){return cn.isValueAliasDeclaration(r)?e.visitEachChild(r,_,t):void 0}function Dr(t){if(!t.exportClause)return un.isolatedModules||cn.moduleExportsSomeValue(t.moduleSpecifier)?t:void 0;if(!cn.isValueAliasDeclaration(t))return void 0;var r=e.visitNode(t.exportClause,Sr,e.isNamedExports);return r?e.updateExportDeclaration(t,void 0,void 0,r,t.moduleSpecifier):void 0}function Sr(t){var r=e.visitNodes(t.elements,Cr,e.isExportSpecifier);return e.some(r)?e.updateNamedExports(t,r):void 0}function Cr(e){return cn.isValueAliasDeclaration(e)?e:void 0}function kr(t){return cn.isReferencedAliasDeclaration(t)||!e.isExternalModule(mn)&&cn.isTopLevelValueImportEqualsWithEntityName(t)}function Tr(r){if(e.isExternalModuleImportEqualsDeclaration(r))return cn.isReferencedAliasDeclaration(r)?e.visitEachChild(r,_,t):void 0;if(!kr(r))return void 0;var n=e.createExpressionFromEntityName(r.moduleReference);return e.setEmitFlags(n,3584),Ar(r)||!Er(r)?e.setOriginalNode(e.setTextRange(e.createVariableStatement(e.visitNodes(r.modifiers,b,e.isModifier),e.createVariableDeclarationList([e.setOriginalNode(e.createVariableDeclaration(r.name,void 0,n),r)])),r),r):e.setOriginalNode(Ir(r.name,n,r),r)}function Er(t){return void 0!==gn&&e.hasModifier(t,1)}function Nr(t){return void 0===gn&&e.hasModifier(t,1)}function Ar(t){return Nr(t)&&!e.hasModifier(t,512)}function Fr(t){return Nr(t)&&e.hasModifier(t,512)}function Pr(t){return e.createExpressionStatement(t)}function wr(t,r){var n=e.createAssignment(e.getExternalModuleOrNamespaceExportName(vn,r,!1,!0),e.getLocalName(r));e.setSourceMapRange(n,e.createRange(r.name?r.name.pos:r.pos,r.end));var i=e.createExpressionStatement(n);e.setSourceMapRange(i,e.createRange(-1,r.end)),t.push(i)}function Ir(t,r,n){return e.setTextRange(e.createExpressionStatement(e.createAssignment(e.getNamespaceMemberName(vn,t,!1,!0),r)),n)}function Or(t,r,n){return e.setTextRange(e.createAssignment(Mr(t),r),n)}function Mr(t){return e.getNamespaceMemberName(vn,t,!1,!0)}function Lr(t){var r=e.getGeneratedNameForNode(t);return e.setSourceMapRange(r,t.name),r}function Rr(t){return e.getGeneratedNameForNode(t)}function Br(t){if(16777216&cn.getNodeCheckFlags(t)){Vr();var r=e.createUniqueName(t.name&&!e.isGeneratedIdentifier(t.name)?e.idText(t.name):"default");return Dn[e.getOriginalNodeId(t)]=r,sn(r),r}}function jr(t){return e.createPropertyAccess(e.getDeclarationName(t),"prototype")}function Jr(t,r){return e.hasModifier(r,32)?e.getDeclarationName(t):jr(t)}function zr(){0===(8&xn)&&(xn|=8,t.enableSubstitution(73))}function Vr(){0===(1&xn)&&(xn|=1,t.enableSubstitution(73),Dn=[])}function Ur(){0===(2&xn)&&(xn|=2,t.enableSubstitution(73),t.enableSubstitution(277),t.enableEmitNotification(245))}function Kr(t){return 245===e.getOriginalNode(t).kind}function qr(t){return 244===e.getOriginalNode(t).kind}function Wr(t,r,n){var i=Sn,a=mn;e.isSourceFile(r)&&(mn=r),2&xn&&Kr(r)&&(Sn|=2),8&xn&&qr(r)&&(Sn|=8),pn(t,r,n),Sn=i,mn=a}function Hr(t,r){return r=fn(t,r),1===t?Qr(r):e.isShorthandPropertyAssignment(r)?Gr(r):r}function Gr(t){if(2&xn){var r=t.name,n=Zr(r);if(n){if(t.objectAssignmentInitializer){var i=e.createAssignment(n,t.objectAssignmentInitializer);return e.setTextRange(e.createPropertyAssignment(r,i),t)}return e.setTextRange(e.createPropertyAssignment(r,n),t)}}return t}function Qr(e){switch(e.kind){case 73:return Xr(e);case 190:return $r(e);case 191:return en(e)}return e}function Xr(e){return Yr(e)||Zr(e)||e}function Yr(t){if(1&xn&&33554432&cn.getNodeCheckFlags(t)){var r=cn.getReferencedValueDeclaration(t);if(r){var n=Dn[r.id];if(n){var i=e.getSynthesizedClone(n);return e.setSourceMapRange(i,t),e.setCommentRange(i,t),i}}}return void 0}function Zr(t){if(xn&Sn&&!e.isGeneratedIdentifier(t)&&!e.isLocalName(t)){var r=cn.getReferencedExportContainer(t,!1);if(r&&285!==r.kind){var n=2&Sn&&245===r.kind||8&Sn&&244===r.kind;if(n)return e.setTextRange(e.createPropertyAccess(e.getGeneratedNameForNode(r),t),t)}}return void 0}function $r(e){return tn(e)}function en(e){return tn(e)}function tn(t){var r=rn(t);if(void 0!==r){e.setConstantValue(t,r);var n=e.createLiteral(r);if(!un.removeComments){var i=e.isPropertyAccessExpression(t)?e.declarationNameToString(t.name):e.getTextOfNode(t.argumentExpression);e.addSyntheticTrailingComment(n,3," "+i+" ")}return n}return t}function rn(t){return un.isolatedModules?void 0:e.isPropertyAccessExpression(t)||e.isElementAccessExpression(t)?cn.getConstantValue(t):void 0}var nn=t.startLexicalEnvironment,an=t.resumeLexicalEnvironment,on=t.endLexicalEnvironment,sn=t.hoistVariableDeclaration,cn=t.getEmitResolver(),un=t.getCompilerOptions(),ln=e.getStrictOptionValue(un,"strictNullChecks"),_n=e.getEmitScriptTarget(un),dn=e.getEmitModuleKind(un),pn=t.onEmitNode,fn=t.onSubstituteNode;t.onEmitNode=Wr,t.onSubstituteNode=Hr,t.enableSubstitution(190),t.enableSubstitution(191);var mn,gn,vn,yn,hn,bn,xn,Dn,Sn,Cn;return a}function r(t,r,n,i,a,o){var s=[];return s.push(e.createArrayLiteral(r,!0)),s.push(n),i&&(s.push(i),a&&s.push(a)),t.requestEmitHelper(e.decorateHelper),e.setTextRange(e.createCall(e.getHelperName("__decorate"),void 0,s),o)}function n(t,r,n){return t.requestEmitHelper(e.metadataHelper),e.createCall(e.getHelperName("__metadata"),void 0,[e.createLiteral(r),n])}function i(t,r,n,i){return t.requestEmitHelper(e.paramHelper),e.setTextRange(e.createCall(e.getHelperName("__param"),void 0,[e.createLiteral(n),r]),i)}var a,o=!1;!function(e){e[e.ClassAliases=1]="ClassAliases",e[e.NamespaceExports=2]="NamespaceExports",e[e.NonQualifiedEnumMembers=8]="NonQualifiedEnumMembers"}(a||(a={}));var s;!function(e){e[e.None=0]="None",e[e.HasStaticInitializedProperties=1]="HasStaticInitializedProperties",e[e.HasConstructorDecorators=2]="HasConstructorDecorators",e[e.HasMemberDecorators=4]="HasMemberDecorators",e[e.IsExportOfNamespace=8]="IsExportOfNamespace",e[e.IsNamedExternalExport=16]="IsNamedExternalExport",e[e.IsDefaultExternalExport=32]="IsDefaultExternalExport",e[e.IsDerivedClass=64]="IsDerivedClass",e[e.UseImmediatelyInvokedFunctionExpression=128]="UseImmediatelyInvokedFunctionExpression",e[e.HasAnyDecorators=6]="HasAnyDecorators",e[e.NeedsName=5]="NeedsName",e[e.MayNeedImmediatelyInvokedFunctionExpression=7]="MayNeedImmediatelyInvokedFunctionExpression",e[e.IsExported=56]="IsExported"}(s||(s={})),e.transformTypeScript=t,e.decorateHelper={name:"typescript:decorate",scoped:!1,priority:2,text:'\n            var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {\n                var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;\n                if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);\n                else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;\n                return c > 3 && r && Object.defineProperty(target, key, r), r;\n            };'},e.metadataHelper={name:"typescript:metadata",scoped:!1,priority:3,text:'\n            var __metadata = (this && this.__metadata) || function (k, v) {\n                if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);\n            };'},e.paramHelper={name:"typescript:param",scoped:!1,priority:4,text:"\n            var __param = (this && this.__param) || function (paramIndex, decorator) {\n                return function (target, key) { decorator(target, key, paramIndex); }\n            };"}}(n||(n={}));var n;!function(e){function t(t){function i(r){if(r.isDeclarationFile)return r;var n=e.visitEachChild(r,a,t);return e.addEmitHelpers(n,t.readEmitHelpers()),n}function a(r){if(0===(32&r.transformFlags))return r;switch(r.kind){case 122:return void 0;case 202:return d(r);case 157:return p(r);case 240:return f(r);case 197:return m(r);case 198:return g(r);case 190:return B&&e.isPropertyAccessExpression(r)&&99===r.expression.kind&&B.set(r.name.escapedText,!0),e.visitEachChild(r,a,t);case 191:return B&&99===r.expression.kind&&(j=!0),e.visitEachChild(r,a,t);default:return e.visitEachChild(r,a,t)}}function o(r){if(e.isNodeWithPossibleHoistedDeclaration(r))switch(r.kind){case 220:return c(r);case 226:return _(r);case 227:return u(r);case 228:return l(r);case 275:return s(r);case 219:case 233:case 247:case 272:case 273:case 236:case 224:case 225:case 223:case 232:case 234:return e.visitEachChild(r,o,t);default:return e.Debug.assertNever(r,"Unhandled node.")}return a(r)}function s(r){var n=e.createUnderscoreEscapedMap();v(r.variableDeclaration,n);var i;if(n.forEach(function(t,r){R.has(r)&&(i||(i=e.cloneMap(R)),i.delete(r))}),i){var a=R;R=i;var s=e.visitEachChild(r,o,t);return R=a,s}return e.visitEachChild(r,o,t)}function c(r){if(y(r.declarationList)){var n=h(r.declarationList,!1);return n?e.createExpressionStatement(n):void 0}return e.visitEachChild(r,a,t)}function u(t){return e.updateForIn(t,y(t.initializer)?h(t.initializer,!0):e.visitNode(t.initializer,a,e.isForInitializer),e.visitNode(t.expression,a,e.isExpression),e.visitNode(t.statement,o,e.isStatement,e.liftToBlock))}function l(t){return e.updateForOf(t,e.visitNode(t.awaitModifier,a,e.isToken),y(t.initializer)?h(t.initializer,!0):e.visitNode(t.initializer,a,e.isForInitializer),e.visitNode(t.expression,a,e.isExpression),e.visitNode(t.statement,o,e.isStatement,e.liftToBlock))}function _(t){var r=t.initializer;return e.updateFor(t,y(r)?h(r,!1):e.visitNode(t.initializer,a,e.isForInitializer),e.visitNode(t.condition,a,e.isExpression),e.visitNode(t.incrementor,a,e.isExpression),e.visitNode(t.statement,o,e.isStatement,e.liftToBlock))}function d(t){return e.setOriginalNode(e.setTextRange(e.createYield(void 0,e.visitNode(t.expression,a,e.isExpression)),t),t)}function p(r){return e.updateMethod(r,void 0,e.visitNodes(r.modifiers,a,e.isModifier),r.asteriskToken,r.name,void 0,void 0,e.visitParameterList(r.parameters,a,t),void 0,2&e.getFunctionFlags(r)?C(r):e.visitFunctionBody(r.body,a,t))}function f(r){return e.updateFunctionDeclaration(r,void 0,e.visitNodes(r.modifiers,a,e.isModifier),r.asteriskToken,r.name,void 0,e.visitParameterList(r.parameters,a,t),void 0,2&e.getFunctionFlags(r)?C(r):e.visitFunctionBody(r.body,a,t))}function m(r){return e.updateFunctionExpression(r,e.visitNodes(r.modifiers,a,e.isModifier),r.asteriskToken,r.name,void 0,e.visitParameterList(r.parameters,a,t),void 0,2&e.getFunctionFlags(r)?C(r):e.visitFunctionBody(r.body,a,t))}function g(r){return e.updateArrowFunction(r,e.visitNodes(r.modifiers,a,e.isModifier),void 0,e.visitParameterList(r.parameters,a,t),void 0,r.equalsGreaterThanToken,2&e.getFunctionFlags(r)?C(r):e.visitFunctionBody(r.body,a,t))}function v(t,r){var n=t.name;if(e.isIdentifier(n))r.set(n.escapedText,!0);else for(var i=0,a=n.elements;i<a.length;i++){var o=a[i];e.isOmittedExpression(o)||v(o,r)}}function y(t){return!!t&&e.isVariableDeclarationList(t)&&!(3&t.flags)&&t.declarations.some(S)}function h(t,r){b(t);var n=e.getInitializedVariables(t);return 0===n.length?r?e.visitNode(e.convertToAssignmentElementTarget(t.declarations[0].name),a,e.isExpression):void 0:e.inlineExpressions(e.map(n,D))}function b(t){e.forEach(t.declarations,x)}function x(t){var r=t.name;if(e.isIdentifier(r))V(r);else for(var n=0,i=r.elements;n<i.length;n++){var a=i[n];e.isOmittedExpression(a)||x(a)}}function D(t){var r=e.setSourceMapRange(e.createAssignment(e.convertToAssignmentElementTarget(t.name),t.initializer),t);return e.visitNode(r,a,e.isExpression)}function S(t){var r=t.name;if(e.isIdentifier(r))return R.has(r.escapedText);for(var n=0,i=r.elements;n<i.length;n++){var a=i[n];if(!e.isOmittedExpression(a)&&S(a))return!0}return!1}function C(i){J();var o=e.getOriginalNode(i,e.isFunctionLike),s=o.type,c=2>q?T(s):void 0,u=198===i.kind,l=0!==(8192&U.getNodeCheckFlags(i)),_=R;R=e.createUnderscoreEscapedMap();for(var d=0,p=i.parameters;d<p.length;d++){var f=p[d];v(f,R)}var m=B,g=j;u||(B=e.createUnderscoreEscapedMap(),j=!1);var y;if(u){var h=n(t,l,c,k(i.body)),b=z();if(e.some(b)){var x=e.convertToFunctionBody(h);y=e.updateBlock(x,e.setTextRange(e.createNodeArray(e.concatenate(b,x.statements)),x.statements))}else y=h}else{var D=[],S=e.addPrologue(D,i.body.statements,!1,a);D.push(e.createReturn(n(t,l,c,k(i.body,S)))),e.insertStatementsAfterStandardPrologue(D,z());var C=q>=2&&6144&U.getNodeCheckFlags(i);if(C&&(E(),e.hasEntries(B))){var N=r(U,i,B);H[e.getNodeId(N)]=!0,e.insertStatementsAfterStandardPrologue(D,[N])}var x=e.createBlock(D,!0);e.setTextRange(x,i.body),C&&j&&(4096&U.getNodeCheckFlags(i)?e.addEmitHelper(x,e.advancedAsyncSuperHelper):2048&U.getNodeCheckFlags(i)&&e.addEmitHelper(x,e.asyncSuperHelper)),y=x}return R=_,u||(B=m,j=g),y}function k(t,r){return e.isBlock(t)?e.updateBlock(t,e.visitNodes(t.statements,o,e.isStatement,r)):e.convertToFunctionBody(e.visitNode(t,o,e.isConciseBody))}function T(t){var r=t&&e.getEntityNameFromTypeNode(t);if(r&&e.isEntityName(r)){var n=U.getTypeReferenceSerializationKind(r);if(n===e.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue||n===e.TypeReferenceSerializationKind.Unknown)return r}return void 0}function E(){0===(1&L)&&(L|=1,t.enableSubstitution(192),t.enableSubstitution(190),t.enableSubstitution(191),t.enableEmitNotification(241),t.enableEmitNotification(157),t.enableEmitNotification(159),t.enableEmitNotification(160),t.enableEmitNotification(158),t.enableEmitNotification(220))}function N(t,r,n){if(1&L&&O(r)){var i=6144&U.getNodeCheckFlags(r);if(i!==W){var a=W;return W=i,G(t,r,n),void(W=a)}}else if(L&&H[e.getNodeId(r)]){var a=W;return W=0,G(t,r,n),void(W=a)}G(t,r,n)}function A(e,t){return t=Q(e,t),1===e&&W?F(t):t}function F(e){switch(e.kind){case 190:return P(e);case 191:return w(e);case 192:return I(e)}return e}function P(t){return 99===t.expression.kind?e.setTextRange(e.createPropertyAccess(e.createFileLevelUniqueName("_super"),t.name),t):t}function w(e){return 99===e.expression.kind?M(e.argumentExpression,e):e}function I(t){var r=t.expression;if(e.isSuperProperty(r)){var n=e.isPropertyAccessExpression(r)?P(r):w(r);return e.createCall(e.createPropertyAccess(n,"call"),void 0,[e.createThis()].concat(t.arguments))}return t}function O(e){var t=e.kind;return 241===t||158===t||157===t||159===t||160===t}function M(t,r){return 4096&W?e.setTextRange(e.createPropertyAccess(e.createCall(e.createFileLevelUniqueName("_superIndex"),void 0,[t]),"value"),r):e.setTextRange(e.createCall(e.createFileLevelUniqueName("_superIndex"),void 0,[t]),r)}var L,R,B,j,J=t.resumeLexicalEnvironment,z=t.endLexicalEnvironment,V=t.hoistVariableDeclaration,U=t.getEmitResolver(),K=t.getCompilerOptions(),q=e.getEmitScriptTarget(K),W=0,H=[],G=t.onEmitNode,Q=t.onSubstituteNode;return t.onEmitNode=N,t.onSubstituteNode=A,e.chainBundle(i)}function r(t,r,n){var i=0!==(4096&t.getNodeCheckFlags(r)),a=[];return n.forEach(function(t,r){var n=e.unescapeLeadingUnderscores(r),o=[];o.push(e.createPropertyAssignment("get",e.createArrowFunction(void 0,void 0,[],void 0,void 0,e.setEmitFlags(e.createPropertyAccess(e.setEmitFlags(e.createSuper(),4),n),4)))),i&&o.push(e.createPropertyAssignment("set",e.createArrowFunction(void 0,void 0,[e.createParameter(void 0,void 0,void 0,"v",void 0,void 0,void 0)],void 0,void 0,e.createAssignment(e.setEmitFlags(e.createPropertyAccess(e.setEmitFlags(e.createSuper(),4),n),4),e.createIdentifier("v"))))),a.push(e.createPropertyAssignment(n,e.createObjectLiteral(o)))}),e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.createFileLevelUniqueName("_super"),void 0,e.createCall(e.createPropertyAccess(e.createIdentifier("Object"),"create"),void 0,[e.createNull(),e.createObjectLiteral(a,!0)]))],2))}function n(t,r,n,i){t.requestEmitHelper(e.awaiterHelper);var a=e.createFunctionExpression(void 0,e.createToken(40),void 0,void 0,[],void 0,i);return(a.emitNode||(a.emitNode={})).flags|=786432,e.createCall(e.getHelperName("__awaiter"),void 0,[e.createThis(),r?e.createIdentifier("arguments"):e.createVoidZero(),n?e.createExpressionFromEntityName(n):e.createVoidZero(),a])}var i;!function(e){e[e.AsyncMethodsWithSuper=1]="AsyncMethodsWithSuper"}(i||(i={})),e.transformES2017=t,e.createSuperAccessVariableStatement=r,e.awaiterHelper={name:"typescript:awaiter",scoped:!1,priority:5,text:'\n            var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {\n                return new (P || (P = Promise))(function (resolve, reject) {\n                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }\n                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }\n                    function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }\n                    step((generator = generator.apply(thisArg, _arguments || [])).next());\n                });\n            };'},e.asyncSuperHelper={name:"typescript:async-super",scoped:!0,text:e.helperString(o(["\n            const "," = name => super[name];"],["\n            const "," = name => super[name];"]),"_superIndex")},e.advancedAsyncSuperHelper={name:"typescript:advanced-async-super",scoped:!0,text:e.helperString(o(["\n            const "," = (function (geti, seti) {\n                const cache = Object.create(null);\n                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });\n            })(name => super[name], (name, value) => super[name] = value);"],["\n            const "," = (function (geti, seti) {\n                const cache = Object.create(null);\n                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });\n            })(name => super[name], (name, value) => super[name] = value);"]),"_superIndex")}}(n||(n={}));var n;!function(e){function t(t){function s(r){if(r.isDeclarationFile)return r;var n=e.visitEachChild(r,c,t);return e.addEmitHelpers(n,t.readEmitHelpers()),n}function c(e){return _(e,!1)}function u(e){return _(e,!0)}function l(e){return 122===e.kind?void 0:e}function _(r,n){if(0===(16&r.transformFlags))return r;switch(r.kind){case 202:return d(r);case 208:return p(r);case 231:return f(r);case 234:return m(r);case 189:return v(r);case 205:return b(r,n);case 275:return x(r);case 238:return D(r);case 228:return k(r,void 0);case 226:return S(r);case 201:return C(r);case 158:return P(r);case 157:return O(r);case 159:return w(r);case 160:return I(r);case 240:return M(r);case 197:return R(r);case 198:return L(r);case 152:return F(r);case 222:return y(r);case 196:return h(r,n);case 190:return ot&&e.isPropertyAccessExpression(r)&&99===r.expression.kind&&ot.set(r.name.escapedText,!0),e.visitEachChild(r,c,t);case 191:return ot&&99===r.expression.kind&&(st=!0),e.visitEachChild(r,c,t);default:return e.visitEachChild(r,c,t)}}function d(r){return 2&at&&1&at?e.setOriginalNode(e.setTextRange(e.createYield(n(t,e.visitNode(r.expression,c,e.isExpression))),r),r):e.visitEachChild(r,c,t)}function p(r){if(2&at&&1&at){if(r.asteriskToken){var i=e.visitNode(r.expression,c,e.isExpression);return e.setOriginalNode(e.setTextRange(e.createYield(n(t,e.updateYield(r,r.asteriskToken,a(t,o(t,i,i),i)))),r),r)}return e.setOriginalNode(e.setTextRange(e.createYield(N(r.expression?e.visitNode(r.expression,c,e.isExpression):e.createVoidZero())),r),r)}return e.visitEachChild(r,c,t)}function f(r){return 2&at&&1&at?e.updateReturn(r,N(r.expression?e.visitNode(r.expression,c,e.isExpression):e.createVoidZero())):e.visitEachChild(r,c,t)}function m(r){if(2&at){var n=e.unwrapInnermostStatementOfLabel(r);return 228===n.kind&&n.awaitModifier?k(n,r):e.restoreEnclosingLabel(e.visitEachChild(n,c,t),r)}return e.visitEachChild(r,c,t)}function g(t){for(var r,n=[],i=0,a=t;i<a.length;i++){var o=a[i];if(278===o.kind){r&&(n.push(e.createObjectLiteral(r)),r=void 0);var s=o.expression;n.push(e.visitNode(s,c,e.isExpression))}else r=e.append(r,276===o.kind?e.createPropertyAssignment(o.name,e.visitNode(o.initializer,c,e.isExpression)):e.visitNode(o,c,e.isObjectLiteralElementLike))}return r&&n.push(e.createObjectLiteral(r)),n}function v(n){if(8192&n.transformFlags){var i=g(n.properties);return i.length&&189!==i[0].kind&&i.unshift(e.createObjectLiteral()),r(t,i)}return e.visitEachChild(n,c,t)}function y(r){return e.visitEachChild(r,u,t)}function h(r,n){return e.visitEachChild(r,n?u:c,t)}function b(r,n){return e.isDestructuringAssignment(r)&&8192&r.left.transformFlags?e.flattenDestructuringAssignment(r,c,t,1,!n):27===r.operatorToken.kind?e.updateBinary(r,e.visitNode(r.left,u,e.isExpression),e.visitNode(r.right,n?u:c,e.isExpression)):e.visitEachChild(r,c,t)}function x(r){if(r.variableDeclaration&&e.isBindingPattern(r.variableDeclaration.name)&&8192&r.variableDeclaration.name.transformFlags){var n=e.getGeneratedNameForNode(r.variableDeclaration.name),i=e.updateVariableDeclaration(r.variableDeclaration,r.variableDeclaration.name,void 0,n),a=e.flattenDestructuringBinding(i,c,t,1),o=e.visitNode(r.block,c,e.isBlock);return e.some(a)&&(o=e.updateBlock(o,[e.createVariableStatement(void 0,a)].concat(o.statements))),e.updateCatchClause(r,e.updateVariableDeclaration(r.variableDeclaration,n,void 0,void 0),o)}return e.visitEachChild(r,c,t)}function D(r){return e.isBindingPattern(r.name)&&8192&r.name.transformFlags?e.flattenDestructuringBinding(r,c,t,1):e.visitEachChild(r,c,t)}function S(t){return e.updateFor(t,e.visitNode(t.initializer,u,e.isForInitializer),e.visitNode(t.condition,c,e.isExpression),e.visitNode(t.incrementor,c,e.isExpression),e.visitNode(t.statement,c,e.isStatement))}function C(r){return e.visitEachChild(r,u,t)}function k(r,n){return 8192&r.initializer.transformFlags&&(r=T(r)),r.awaitModifier?A(r,n):e.restoreEnclosingLabel(e.visitEachChild(r,c,t),n)}function T(t){var r=e.skipParentheses(t.initializer);if(e.isVariableDeclarationList(r)||e.isAssignmentPattern(r)){var n=void 0,i=void 0,a=e.createTempVariable(void 0),o=[e.createForOfBindingStatement(r,a)];return e.isBlock(t.statement)?(e.addRange(o,t.statement.statements),n=t.statement,i=t.statement.statements):t.statement&&(e.append(o,t.statement),n=t.statement,i=t.statement),e.updateForOf(t,t.awaitModifier,e.setTextRange(e.createVariableDeclarationList([e.setTextRange(e.createVariableDeclaration(a),t.initializer)],1),t.initializer),t.expression,e.setTextRange(e.createBlock(e.setTextRange(e.createNodeArray(o),i),!0),n))}return t}function E(t,r){var n,i,a=e.createForOfBindingStatement(t.initializer,r),o=[e.visitNode(a,c,e.isStatement)],s=e.visitNode(t.statement,c,e.isStatement);return e.isBlock(s)?(e.addRange(o,s.statements),n=s,i=s.statements):o.push(s),e.setEmitFlags(e.setTextRange(e.createBlock(e.setTextRange(e.createNodeArray(o),i),!0),n),432)}function N(r){return 1&at?e.createYield(void 0,n(t,r)):e.createAwait(r)}function A(r,n){var i=e.visitNode(r.expression,c,e.isExpression),a=e.isIdentifier(i)?e.getGeneratedNameForNode(i):e.createTempVariable(void 0),s=e.isIdentifier(i)?e.getGeneratedNameForNode(a):e.createTempVariable(void 0),u=e.createUniqueName("e"),l=e.getGeneratedNameForNode(u),_=e.createTempVariable(void 0),d=o(t,i,r.expression),p=e.createCall(e.createPropertyAccess(a,"next"),void 0,[]),f=e.createPropertyAccess(s,"done"),m=e.createPropertyAccess(s,"value"),g=e.createFunctionCall(_,a,[]);Z(u),Z(_);var v=e.setEmitFlags(e.setTextRange(e.createFor(e.setEmitFlags(e.setTextRange(e.createVariableDeclarationList([e.setTextRange(e.createVariableDeclaration(a,void 0,d),r.expression),e.createVariableDeclaration(s)]),r.expression),2097152),e.createComma(e.createAssignment(s,N(p)),e.createLogicalNot(f)),void 0,E(r,m)),r),256);return e.createTry(e.createBlock([e.restoreEnclosingLabel(v,n)]),e.createCatchClause(e.createVariableDeclaration(l),e.setEmitFlags(e.createBlock([e.createExpressionStatement(e.createAssignment(u,e.createObjectLiteral([e.createPropertyAssignment("error",l)])))]),1)),e.createBlock([e.createTry(e.createBlock([e.setEmitFlags(e.createIf(e.createLogicalAnd(e.createLogicalAnd(s,e.createLogicalNot(f)),e.createAssignment(_,e.createPropertyAccess(a,"return"))),e.createExpressionStatement(N(g))),1)]),void 0,e.setEmitFlags(e.createBlock([e.setEmitFlags(e.createIf(u,e.createThrow(e.createPropertyAccess(u,"error"))),1)]),1))]))}function F(r){return 8192&r.transformFlags?e.updateParameter(r,void 0,void 0,r.dotDotDotToken,e.getGeneratedNameForNode(r),void 0,void 0,e.visitNode(r.initializer,c,e.isExpression)):e.visitEachChild(r,c,t)}function P(r){var n=at;at=0;var i=e.updateConstructor(r,void 0,r.modifiers,e.visitParameterList(r.parameters,c,t),j(r));return at=n,i}function w(r){var n=at;at=0;var i=e.updateGetAccessor(r,void 0,r.modifiers,e.visitNode(r.name,c,e.isPropertyName),e.visitParameterList(r.parameters,c,t),void 0,j(r));return at=n,i}function I(r){var n=at;at=0;var i=e.updateSetAccessor(r,void 0,r.modifiers,e.visitNode(r.name,c,e.isPropertyName),e.visitParameterList(r.parameters,c,t),j(r));return at=n,i}function O(r){var n=at;at=e.getFunctionFlags(r);var i=e.updateMethod(r,void 0,1&at?e.visitNodes(r.modifiers,l,e.isModifier):r.modifiers,2&at?void 0:r.asteriskToken,e.visitNode(r.name,c,e.isPropertyName),e.visitNode(void 0,c,e.isToken),void 0,e.visitParameterList(r.parameters,c,t),void 0,2&at&&1&at?B(r):j(r));return at=n,i}function M(r){var n=at;at=e.getFunctionFlags(r);var i=e.updateFunctionDeclaration(r,void 0,1&at?e.visitNodes(r.modifiers,l,e.isModifier):r.modifiers,2&at?void 0:r.asteriskToken,r.name,void 0,e.visitParameterList(r.parameters,c,t),void 0,2&at&&1&at?B(r):j(r));return at=n,i}function L(r){var n=at;at=e.getFunctionFlags(r);var i=e.updateArrowFunction(r,r.modifiers,void 0,e.visitParameterList(r.parameters,c,t),void 0,r.equalsGreaterThanToken,j(r));return at=n,i}function R(r){var n=at;at=e.getFunctionFlags(r);var i=e.updateFunctionExpression(r,1&at?e.visitNodes(r.modifiers,l,e.isModifier):r.modifiers,2&at?void 0:r.asteriskToken,r.name,void 0,e.visitParameterList(r.parameters,c,t),void 0,2&at&&1&at?B(r):j(r));return at=n,i}function B(r){X();var n=[],a=e.addPrologue(n,r.body.statements,!1,c);J(n,r);var o=ot,s=st;ot=e.createUnderscoreEscapedMap(),st=!1;var u=e.createReturn(i(t,e.createFunctionExpression(void 0,e.createToken(40),r.name&&e.getGeneratedNameForNode(r.name),void 0,[],void 0,e.updateBlock(r.body,e.visitLexicalEnvironment(r.body.statements,c,t,a))))),l=tt>=2&&6144&$.getNodeCheckFlags(r);
if(l){z();var _=e.createSuperAccessVariableStatement($,r,ot);ut[e.getNodeId(_)]=!0,e.insertStatementsAfterStandardPrologue(n,[_])}n.push(u),e.insertStatementsAfterStandardPrologue(n,Y());var d=e.updateBlock(r.body,n);return l&&st&&(4096&$.getNodeCheckFlags(r)?e.addEmitHelper(d,e.advancedAsyncSuperHelper):2048&$.getNodeCheckFlags(r)&&e.addEmitHelper(d,e.asyncSuperHelper)),ot=o,st=s,d}function j(t){X();var r=0,n=[],i=e.visitNode(t.body,c,e.isConciseBody);e.isBlock(i)&&(r=e.addPrologue(n,i.statements,!1,c)),e.addRange(n,J(void 0,t));var a=Y();if(r>0||e.some(n)||e.some(a)){var o=e.convertToFunctionBody(i,!0);return e.insertStatementsAfterStandardPrologue(n,a),e.addRange(n,o.statements.slice(r)),e.updateBlock(o,e.setTextRange(e.createNodeArray(n),o.statements))}return i}function J(r,n){for(var i=0,a=n.parameters;i<a.length;i++){var o=a[i];if(8192&o.transformFlags){var s=e.getGeneratedNameForNode(o),u=e.flattenDestructuringBinding(o,c,t,1,s,!1,!0);if(e.some(u)){var l=e.createVariableStatement(void 0,e.createVariableDeclarationList(u));e.setEmitFlags(l,1048576),r=e.append(r,l)}}}return r}function z(){0===(1&it)&&(it|=1,t.enableSubstitution(192),t.enableSubstitution(190),t.enableSubstitution(191),t.enableEmitNotification(241),t.enableEmitNotification(157),t.enableEmitNotification(159),t.enableEmitNotification(160),t.enableEmitNotification(158),t.enableEmitNotification(220))}function V(t,r,n){if(1&it&&G(r)){var i=6144&$.getNodeCheckFlags(r);if(i!==ct){var a=ct;return ct=i,rt(t,r,n),void(ct=a)}}else if(it&&ut[e.getNodeId(r)]){var a=ct;return ct=0,rt(t,r,n),void(ct=a)}rt(t,r,n)}function U(e,t){return t=nt(e,t),1===e&&ct?K(t):t}function K(e){switch(e.kind){case 190:return q(e);case 191:return W(e);case 192:return H(e)}return e}function q(t){return 99===t.expression.kind?e.setTextRange(e.createPropertyAccess(e.createFileLevelUniqueName("_super"),t.name),t):t}function W(e){return 99===e.expression.kind?Q(e.argumentExpression,e):e}function H(t){var r=t.expression;if(e.isSuperProperty(r)){var n=e.isPropertyAccessExpression(r)?q(r):W(r);return e.createCall(e.createPropertyAccess(n,"call"),void 0,[e.createThis()].concat(t.arguments))}return t}function G(e){var t=e.kind;return 241===t||158===t||157===t||159===t||160===t}function Q(t,r){return 4096&ct?e.setTextRange(e.createPropertyAccess(e.createCall(e.createIdentifier("_superIndex"),void 0,[t]),"value"),r):e.setTextRange(e.createCall(e.createIdentifier("_superIndex"),void 0,[t]),r)}var X=t.resumeLexicalEnvironment,Y=t.endLexicalEnvironment,Z=t.hoistVariableDeclaration,$=t.getEmitResolver(),et=t.getCompilerOptions(),tt=e.getEmitScriptTarget(et),rt=t.onEmitNode;t.onEmitNode=V;var nt=t.onSubstituteNode;t.onSubstituteNode=U;var it,at,ot,st,ct=0,ut=[];return e.chainBundle(s)}function r(t,r){return t.getCompilerOptions().target>=2?e.createCall(e.createPropertyAccess(e.createIdentifier("Object"),"assign"),void 0,r):(t.requestEmitHelper(e.assignHelper),e.createCall(e.getHelperName("__assign"),void 0,r))}function n(t,r){return t.requestEmitHelper(e.awaitHelper),e.createCall(e.getHelperName("__await"),void 0,[r])}function i(t,r){return t.requestEmitHelper(e.awaitHelper),t.requestEmitHelper(e.asyncGeneratorHelper),(r.emitNode||(r.emitNode={})).flags|=262144,e.createCall(e.getHelperName("__asyncGenerator"),void 0,[e.createThis(),e.createIdentifier("arguments"),r])}function a(t,r,n){return t.requestEmitHelper(e.awaitHelper),t.requestEmitHelper(e.asyncDelegator),e.setTextRange(e.createCall(e.getHelperName("__asyncDelegator"),void 0,[r]),n)}function o(t,r,n){return t.requestEmitHelper(e.asyncValues),e.setTextRange(e.createCall(e.getHelperName("__asyncValues"),void 0,[r]),n)}var s;!function(e){e[e.AsyncMethodsWithSuper=1]="AsyncMethodsWithSuper"}(s||(s={})),e.transformES2018=t,e.assignHelper={name:"typescript:assign",scoped:!1,priority:1,text:"\n            var __assign = (this && this.__assign) || function () {\n                __assign = Object.assign || function(t) {\n                    for (var s, i = 1, n = arguments.length; i < n; i++) {\n                        s = arguments[i];\n                        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))\n                            t[p] = s[p];\n                    }\n                    return t;\n                };\n                return __assign.apply(this, arguments);\n            };"},e.createAssignHelper=r,e.awaitHelper={name:"typescript:await",scoped:!1,text:"\n            var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }"},e.asyncGeneratorHelper={name:"typescript:asyncGenerator",scoped:!1,text:'\n            var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {\n                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");\n                var g = generator.apply(thisArg, _arguments || []), i, q = [];\n                return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;\n                function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }\n                function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }\n                function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }\n                function fulfill(value) { resume("next", value); }\n                function reject(value) { resume("throw", value); }\n                function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }\n            };'},e.asyncDelegator={name:"typescript:asyncDelegator",scoped:!1,text:'\n            var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {\n                var i, p;\n                return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;\n                function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }\n            };'},e.asyncValues={name:"typescript:asyncValues",scoped:!1,text:'\n            var __asyncValues = (this && this.__asyncValues) || function (o) {\n                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");\n                var m = o[Symbol.asyncIterator], i;\n                return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);\n                function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }\n                function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }\n            };'}}(n||(n={}));var n;!function(e){function t(t){function r(r){return r.isDeclarationFile?r:e.visitEachChild(r,n,t)}function n(r){if(0===(8&r.transformFlags))return r;switch(r.kind){case 275:return i(r);default:return e.visitEachChild(r,n,t)}}function i(r){return r.variableDeclaration?e.visitEachChild(r,n,t):e.updateCatchClause(r,e.createVariableDeclaration(e.createTempVariable(void 0)),e.visitNode(r.block,n,e.isBlock))}return e.chainBundle(r)}e.transformES2019=t}(n||(n={}));var n;!function(e){function t(t){function r(r){return r.isDeclarationFile?r:e.visitEachChild(r,n,t)}function n(r){if(0===(4&r.transformFlags))return r;switch(r.kind){default:return e.visitEachChild(r,n,t)}}return e.chainBundle(r)}e.transformESNext=t}(n||(n={}));var n;!function(e){function t(t){function n(r){if(r.isDeclarationFile)return r;S=r;var n=e.visitEachChild(r,i,t);return e.addEmitHelpers(n,t.readEmitHelpers()),n}function i(e){return 2&e.transformFlags?a(e):e}function a(r){switch(r.kind){case 261:return s(r,!1);case 262:return c(r,!1);case 265:return u(r,!1);case 271:return D(r);default:return e.visitEachChild(r,i,t)}}function o(t){switch(t.kind){case 11:return m(t);case 271:return D(t);case 261:return s(t,!0);case 262:return c(t,!0);case 265:return u(t,!0);default:return e.Debug.failBadSyntaxKind(t)}}function s(e,t){return l(e.openingElement,e.children,t,e)}function c(e,t){return l(e,void 0,t,e)}function u(e,t){return _(e.openingFragment,e.children,t,e)}function l(r,n,i,a){var s,c=b(r),u=r.attributes.properties;if(0===u.length)s=e.createNull();else{var l=e.flatten(e.spanMap(u,e.isJsxSpreadAttribute,function(t,r){return r?e.map(t,d):e.createObjectLiteral(e.map(t,p))}));e.isJsxSpreadAttribute(u[0])&&l.unshift(e.createObjectLiteral()),s=e.singleOrUndefined(l),s||(s=e.createAssignHelper(t,l))}var _=e.createExpressionForJsxElement(t.getEmitResolver().getJsxFactoryEntity(S),C.reactNamespace,c,s,e.mapDefined(n,o),r,a);return i&&e.startOnNewLine(_),_}function _(r,n,i,a){var s=e.createExpressionForJsxFragment(t.getEmitResolver().getJsxFactoryEntity(S),C.reactNamespace,e.mapDefined(n,o),r,a);return i&&e.startOnNewLine(s),s}function d(t){return e.visitNode(t.expression,i,e.isExpression)}function p(t){var r=x(t),n=f(t.initializer);return e.createPropertyAssignment(r,n)}function f(t){if(void 0===t)return e.createTrue();if(10===t.kind){var r=e.createLiteral(h(t.text)||t.text);return r.singleQuote=void 0!==t.singleQuote?t.singleQuote:!e.isStringDoubleQuoted(t,S),e.setTextRange(r,t)}return 271===t.kind?void 0===t.expression?e.createTrue():D(t):e.Debug.failBadSyntaxKind(t)}function m(t){var r=g(t.text);return void 0===r?void 0:e.createLiteral(r)}function g(t){for(var r,n=0,i=-1,a=0;a<t.length;a++){var o=t.charCodeAt(a);e.isLineBreak(o)?(-1!==n&&-1!==i&&(r=v(r,t.substr(n,i-n+1))),n=-1):e.isWhiteSpaceSingleLine(o)||(i=a,-1===n&&(n=a))}return-1!==n?v(r,t.substr(n)):r}function v(e,t){var r=y(t);return void 0===e?r:e+" "+r}function y(e){return e.replace(/&((#((\d+)|x([\da-fA-F]+)))|(\w+));/g,function(e,t,n,i,a,o,s){if(a)return String.fromCharCode(parseInt(a,10));if(o)return String.fromCharCode(parseInt(o,16));var c=r.get(s);return c?String.fromCharCode(c):e})}function h(e){var t=y(e);return t===e?void 0:t}function b(t){if(261===t.kind)return b(t.openingElement);var r=t.tagName;return e.isIdentifier(r)&&e.isIntrinsicJsxName(r.escapedText)?e.createLiteral(e.idText(r)):e.createExpressionFromEntityName(r)}function x(t){var r=t.name,n=e.idText(r);return/^[A-Za-z_]\w*$/.test(n)?r:e.createLiteral(n)}function D(t){return e.visitNode(t.expression,i,e.isExpression)}var S,C=t.getCompilerOptions();return e.chainBundle(n)}e.transformJsx=t;var r=e.createMapFromTemplate({quot:34,amp:38,apos:39,lt:60,gt:62,nbsp:160,iexcl:161,cent:162,pound:163,curren:164,yen:165,brvbar:166,sect:167,uml:168,copy:169,ordf:170,laquo:171,not:172,shy:173,reg:174,macr:175,deg:176,plusmn:177,sup2:178,sup3:179,acute:180,micro:181,para:182,middot:183,cedil:184,sup1:185,ordm:186,raquo:187,frac14:188,frac12:189,frac34:190,iquest:191,Agrave:192,Aacute:193,Acirc:194,Atilde:195,Auml:196,Aring:197,AElig:198,Ccedil:199,Egrave:200,Eacute:201,Ecirc:202,Euml:203,Igrave:204,Iacute:205,Icirc:206,Iuml:207,ETH:208,Ntilde:209,Ograve:210,Oacute:211,Ocirc:212,Otilde:213,Ouml:214,times:215,Oslash:216,Ugrave:217,Uacute:218,Ucirc:219,Uuml:220,Yacute:221,THORN:222,szlig:223,agrave:224,aacute:225,acirc:226,atilde:227,auml:228,aring:229,aelig:230,ccedil:231,egrave:232,eacute:233,ecirc:234,euml:235,igrave:236,iacute:237,icirc:238,iuml:239,eth:240,ntilde:241,ograve:242,oacute:243,ocirc:244,otilde:245,ouml:246,divide:247,oslash:248,ugrave:249,uacute:250,ucirc:251,uuml:252,yacute:253,thorn:254,yuml:255,OElig:338,oelig:339,Scaron:352,scaron:353,Yuml:376,fnof:402,circ:710,tilde:732,Alpha:913,Beta:914,Gamma:915,Delta:916,Epsilon:917,Zeta:918,Eta:919,Theta:920,Iota:921,Kappa:922,Lambda:923,Mu:924,Nu:925,Xi:926,Omicron:927,Pi:928,Rho:929,Sigma:931,Tau:932,Upsilon:933,Phi:934,Chi:935,Psi:936,Omega:937,alpha:945,beta:946,gamma:947,delta:948,epsilon:949,zeta:950,eta:951,theta:952,iota:953,kappa:954,lambda:955,mu:956,nu:957,xi:958,omicron:959,pi:960,rho:961,sigmaf:962,sigma:963,tau:964,upsilon:965,phi:966,chi:967,psi:968,omega:969,thetasym:977,upsih:978,piv:982,ensp:8194,emsp:8195,thinsp:8201,zwnj:8204,zwj:8205,lrm:8206,rlm:8207,ndash:8211,mdash:8212,lsquo:8216,rsquo:8217,sbquo:8218,ldquo:8220,rdquo:8221,bdquo:8222,dagger:8224,Dagger:8225,bull:8226,hellip:8230,permil:8240,prime:8242,Prime:8243,lsaquo:8249,rsaquo:8250,oline:8254,frasl:8260,euro:8364,image:8465,weierp:8472,real:8476,trade:8482,alefsym:8501,larr:8592,uarr:8593,rarr:8594,darr:8595,harr:8596,crarr:8629,lArr:8656,uArr:8657,rArr:8658,dArr:8659,hArr:8660,forall:8704,part:8706,exist:8707,empty:8709,nabla:8711,isin:8712,notin:8713,ni:8715,prod:8719,sum:8721,minus:8722,lowast:8727,radic:8730,prop:8733,infin:8734,ang:8736,and:8743,or:8744,cap:8745,cup:8746,"int":8747,there4:8756,sim:8764,cong:8773,asymp:8776,ne:8800,equiv:8801,le:8804,ge:8805,sub:8834,sup:8835,nsub:8836,sube:8838,supe:8839,oplus:8853,otimes:8855,perp:8869,sdot:8901,lceil:8968,rceil:8969,lfloor:8970,rfloor:8971,lang:9001,rang:9002,loz:9674,spades:9824,clubs:9827,hearts:9829,diams:9830})}(n||(n={}));var n;!function(e){function t(t){function r(r){return r.isDeclarationFile?r:e.visitEachChild(r,n,t)}function n(r){if(0===(64&r.transformFlags))return r;switch(r.kind){case 205:return i(r);default:return e.visitEachChild(r,n,t)}}function i(r){switch(r.operatorToken.kind){case 64:return a(r);case 41:return o(r);default:return e.visitEachChild(r,n,t)}}function a(t){var r,i,a=e.visitNode(t.left,n,e.isExpression),o=e.visitNode(t.right,n,e.isExpression);if(e.isElementAccessExpression(a)){var c=e.createTempVariable(s),u=e.createTempVariable(s);r=e.setTextRange(e.createElementAccess(e.setTextRange(e.createAssignment(c,a.expression),a.expression),e.setTextRange(e.createAssignment(u,a.argumentExpression),a.argumentExpression)),a),i=e.setTextRange(e.createElementAccess(c,u),a)}else if(e.isPropertyAccessExpression(a)){var c=e.createTempVariable(s);r=e.setTextRange(e.createPropertyAccess(e.setTextRange(e.createAssignment(c,a.expression),a.expression),a.name),a),i=e.setTextRange(e.createPropertyAccess(c,a.name),a)}else r=a,i=a;return e.setTextRange(e.createAssignment(r,e.createMathPow(i,o,t)),t)}function o(t){var r=e.visitNode(t.left,n,e.isExpression),i=e.visitNode(t.right,n,e.isExpression);return e.createMathPow(r,i,t)}var s=t.hoistVariableDeclaration;return e.chainBundle(r)}e.transformES2016=t}(n||(n={}));var n;!function(e){function t(t){function i(t){Zr=e.append(Zr,e.createVariableDeclaration(t))}function a(r){if(r.isDeclarationFile)return r;Qr=r,Xr=r.text;var n=p(r);return e.addEmitHelpers(n,t.readEmitHelpers()),Qr=void 0,Xr=void 0,Zr=void 0,Yr=0,n}function o(e,t){var r=Yr;return Yr=16383&(Yr&~e|t),r}function s(e,t,r){Yr=-16384&(Yr&~t|r)|e}function c(e){return 0!==(8192&Yr)&&231===e.kind&&!e.expression}function u(t){return 0!==(128&t.transformFlags)||void 0!==$r||8192&Yr&&(e.isStatement(t)||219===t.kind)||e.isIterationStatement(t,!1)&&Et(t)||0!==(33554432&e.getEmitFlags(t))}function l(e){return u(e)?d(e):e}function _(e){return 99===e.kind?Er(!0):l(e)}function d(r){switch(r.kind){case 117:return void 0;case 241:return x(r);case 210:return D(r);case 152:return I(r);case 240:return X(r);case 198:return G(r);case 197:return Q(r);case 238:return ct(r);case 73:return h(r);case 239:return it(r);case 233:return f(r);case 247:return m(r);case 219:return $(r,!1);case 230:case 229:return b(r);case 234:return _t(r);case 224:case 225:return ft(r,void 0);case 226:return mt(r,void 0);case 227:return gt(r,void 0);case 228:return vt(r,void 0);case 222:return et(r);case 189:return Dt(r);case 275:return $t(r);case 277:return nr(r);case 150:return ir(r);case 188:return or(r);case 192:return sr(r);case 193:return _r(r);case 196:return tt(r,!0);case 205:return rt(r,!0);case 14:case 15:case 16:case 17:return yr(r);case 10:return hr(r);case 8:return br(r);case 194:return xr(r);case 207:return Sr(r);case 208:return ar(r);case 209:return gr(r);case 99:return Er(!1);case 101:return y(r);case 215:return Nr(r);case 157:return tr(r);case 159:case 160:return rr(r);case 220:return nt(r);case 231:return v(r);default:return e.visitEachChild(r,l,t)}}function p(t){var r=o(8064,64),n=[],i=[];zr();var a=e.addStandardPrologue(n,t.statements,!1);return a=e.addCustomPrologue(n,t.statements,a,l),e.addRange(i,e.visitNodes(t.statements,l,e.isStatement,a)),Zr&&i.push(e.createVariableStatement(void 0,e.createVariableDeclarationList(Zr))),e.mergeLexicalEnvironment(n,Ur()),J(n,t),s(r,0,0),e.updateSourceFileNode(t,e.setTextRange(e.createNodeArray(e.concatenate(n,i)),t.statements))}function f(r){if(void 0!==$r){var n=$r.allowedNonLabeledJumps;$r.allowedNonLabeledJumps|=2;var i=e.visitEachChild(r,l,t);return $r.allowedNonLabeledJumps=n,i}return e.visitEachChild(r,l,t)}function m(r){var n=o(7104,0),i=e.visitEachChild(r,l,t);return s(n,0,0),i}function g(t){return e.setOriginalNode(e.createReturn(e.createFileLevelUniqueName("_this")),t)}function v(r){return $r?($r.nonLocalJumps|=8,c(r)&&(r=g(r)),e.createReturn(e.createObjectLiteral([e.createPropertyAssignment(e.createIdentifier("value"),r.expression?e.visitNode(r.expression,l,e.isExpression):e.createVoidZero())]))):c(r)?g(r):e.visitEachChild(r,l,t)}function y(t){return 2&Yr&&(Yr|=32768),$r?2&Yr?($r.containsLexicalThis=!0,t):$r.thisName||($r.thisName=e.createUniqueName("this")):t}function h(t){return $r?e.isGeneratedIdentifier(t)?t:"arguments"===t.escapedText&&Wr.isArgumentsLocalBinding(t)?$r.argumentsName||($r.argumentsName=e.createUniqueName("arguments")):t:t}function b(r){if($r){var n=230===r.kind?2:4,i=r.label&&$r.labels&&$r.labels.get(e.idText(r.label))||!r.label&&$r.allowedNonLabeledJumps&n;if(!i){var a=void 0,o=r.label;o?230===r.kind?(a="break-"+o.escapedText,Wt($r,!0,e.idText(o),a)):(a="continue-"+o.escapedText,Wt($r,!1,e.idText(o),a)):230===r.kind?($r.nonLocalJumps|=2,a="break"):($r.nonLocalJumps|=4,a="continue");var s=e.createLiteral(a);if($r.loopOutParameters.length){for(var c=$r.loopOutParameters,u=void 0,_=0;_<c.length;_++){var d=Vt(c[_],1);u=0===_?d:e.createBinary(u,27,d)}s=e.createBinary(u,27,s)}return e.createReturn(s)}}return e.visitEachChild(r,l,t)}function x(t){var r=e.createVariableDeclaration(e.getLocalName(t,!0),void 0,S(t));e.setOriginalNode(r,t);var n=[],i=e.createVariableStatement(void 0,e.createVariableDeclarationList([r]));if(e.setOriginalNode(i,t),e.setTextRange(i,t),e.startOnNewLine(i),n.push(i),e.hasModifier(t,1)){var a=e.hasModifier(t,512)?e.createExportDefault(e.getLocalName(t)):e.createExternalModuleExport(e.getLocalName(t));e.setOriginalNode(a,i),n.push(a)}var o=e.getEmitFlags(t);return 0===(4194304&o)&&(n.push(e.createEndOfDeclarationMarker(t)),e.setEmitFlags(i,4194304|o)),e.singleOrMany(n)}function D(e){return S(e)}function S(t){t.name&&Fr();var r=e.getClassExtendsHeritageElement(t),n=e.createFunctionExpression(void 0,void 0,void 0,void 0,r?[e.createParameter(void 0,void 0,void 0,e.createFileLevelUniqueName("_super"))]:[],void 0,C(t,r));e.setEmitFlags(n,65536&e.getEmitFlags(t)|524288);var i=e.createPartiallyEmittedExpression(n);i.end=t.end,e.setEmitFlags(i,1536);var a=e.createPartiallyEmittedExpression(i);a.end=e.skipTrivia(Xr,t.pos),e.setEmitFlags(a,1536);var o=e.createParen(e.createCall(a,void 0,r?[e.visitNode(r.expression,l,e.isExpression)]:[]));return e.addSyntheticLeadingComment(o,3,"* @class "),o}function C(t,r){var n=[];zr(),k(n,t,r),T(n,t,r),U(n,t);var i=e.createTokenRange(e.skipTrivia(Xr,t.members.end),19),a=e.getInternalName(t),o=e.createPartiallyEmittedExpression(a);o.end=i.end,e.setEmitFlags(o,1536);var s=e.createReturn(o);s.pos=i.pos,e.setEmitFlags(s,1920),n.push(s),e.insertStatementsAfterStandardPrologue(n,Ur());var c=e.createBlock(e.setTextRange(e.createNodeArray(n),t.members),!0);return e.setEmitFlags(c,1536),c}function k(n,i,a){a&&n.push(e.setTextRange(e.createExpressionStatement(r(t,e.getInternalName(i))),a))}function T(t,r,n){var i=$r;$r=void 0;var a=o(16278,73),c=e.getFirstConstructorWithBody(r),u=Jr(c,void 0!==n),l=e.createFunctionDeclaration(void 0,void 0,void 0,e.getInternalName(r),void 0,E(c,u),void 0,A(c,r,n,u));e.setTextRange(l,c||r),n&&e.setEmitFlags(l,8),t.push(l),s(a,49152,0),$r=i}function E(r,n){return e.visitParameterList(r&&!n?r.parameters:void 0,l,t)||[]}function N(t,r){var n=[];Vr(),e.mergeLexicalEnvironment(n,Ur()),r&&n.push(e.createReturn(w()));var i=e.createNodeArray(n);e.setTextRange(i,t.members);var a=e.createBlock(i,!0);return e.setTextRange(a,t),e.setEmitFlags(a,1536),a}function A(t,r,n,i){var a=!!n&&97!==e.skipOuterExpressions(n.expression).kind;if(!t)return N(r,a);var o=[],s=[];Vr();var c=0;i||(c=e.addStandardPrologue(o,t.body.statements,!1)),M(s,t),j(s,t,i),i||(c=e.addCustomPrologue(s,t.body.statements,c,l));var u;if(i)u=w();else if(a&&c<t.body.statements.length){var _=t.body.statements[c];e.isExpressionStatement(_)&&e.isSuperCall(_.expression)&&(u=ur(_.expression))}if(u&&(Yr|=8192,c++),e.addRange(s,e.visitNodes(t.body.statements,l,e.isStatement,c)),e.mergeLexicalEnvironment(o,Ur()),V(o,t,!1),a)if(!u||c!==t.body.statements.length||2048&t.body.transformFlags)z(s,t,u||P()),F(t.body)||s.push(e.createReturn(e.createFileLevelUniqueName("_this")));else{var d=e.cast(e.cast(u,e.isBinaryExpression).left,e.isCallExpression),p=e.createReturn(u);e.setCommentRange(p,e.getCommentRange(d)),e.setEmitFlags(d,1536),s.push(p)}else J(o,t);var f=e.createBlock(e.setTextRange(e.createNodeArray(e.concatenate(o,s)),t.body.statements),!0);return e.setTextRange(f,t.body),f}function F(t){if(231===t.kind)return!0;if(223===t.kind){var r=t;if(r.elseStatement)return F(r.thenStatement)&&F(r.elseStatement)}else if(219===t.kind){var n=e.lastOrUndefined(t.statements);if(n&&F(n))return!0}return!1}function P(){return e.setEmitFlags(e.createThis(),4)}function w(){return e.createLogicalOr(e.createLogicalAnd(e.createStrictInequality(e.createFileLevelUniqueName("_super"),e.createNull()),e.createFunctionApply(e.createFileLevelUniqueName("_super"),P(),e.createIdentifier("arguments"))),P())}function I(t){return t.dotDotDotToken?void 0:e.isBindingPattern(t.name)?e.setOriginalNode(e.setTextRange(e.createParameter(void 0,void 0,void 0,e.getGeneratedNameForNode(t),void 0,void 0,void 0),t),t):t.initializer?e.setOriginalNode(e.setTextRange(e.createParameter(void 0,void 0,void 0,t.name,void 0,void 0,void 0),t),t):t}function O(t){return void 0!==t.initializer||e.isBindingPattern(t.name)}function M(t,r){if(!e.some(r.parameters,O))return!1;for(var n=!1,i=0,a=r.parameters;i<a.length;i++){var o=a[i],s=o.name,c=o.initializer,u=o.dotDotDotToken;u||(e.isBindingPattern(s)?n=L(t,o,s,c)||n:c&&(R(t,o,s,c),n=!0))}return n}function L(r,n,i,a){return i.elements.length>0?(e.insertStatementAfterCustomPrologue(r,e.setEmitFlags(e.createVariableStatement(void 0,e.createVariableDeclarationList(e.flattenDestructuringBinding(n,l,t,0,e.getGeneratedNameForNode(n)))),1048576)),!0):a?(e.insertStatementAfterCustomPrologue(r,e.setEmitFlags(e.createExpressionStatement(e.createAssignment(e.getGeneratedNameForNode(n),e.visitNode(a,l,e.isExpression))),1048576)),!0):!1}function R(t,r,n,i){i=e.visitNode(i,l,e.isExpression);var a=e.createIf(e.createTypeCheck(e.getSynthesizedClone(n),"undefined"),e.setEmitFlags(e.setTextRange(e.createBlock([e.createExpressionStatement(e.setEmitFlags(e.setTextRange(e.createAssignment(e.setEmitFlags(e.getMutableClone(n),48),e.setEmitFlags(i,48|e.getEmitFlags(i)|1536)),r),1536))]),r),1953));e.startOnNewLine(a),e.setTextRange(a,r),e.setEmitFlags(a,1050528),e.insertStatementAfterCustomPrologue(t,a)}function B(e,t){return!(!e||!e.dotDotDotToken||t)}function j(r,n,i){var a=[],o=e.lastOrUndefined(n.parameters);if(!B(o,i))return!1;var s=73===o.name.kind?e.getMutableClone(o.name):e.createTempVariable(void 0);e.setEmitFlags(s,48);var c=73===o.name.kind?e.getSynthesizedClone(o.name):s,u=n.parameters.length-1,_=e.createLoopVariable();a.push(e.setEmitFlags(e.setTextRange(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(s,void 0,e.createArrayLiteral([]))])),o),1048576));var d=e.createFor(e.setTextRange(e.createVariableDeclarationList([e.createVariableDeclaration(_,void 0,e.createLiteral(u))]),o),e.setTextRange(e.createLessThan(_,e.createPropertyAccess(e.createIdentifier("arguments"),"length")),o),e.setTextRange(e.createPostfixIncrement(_),o),e.createBlock([e.startOnNewLine(e.setTextRange(e.createExpressionStatement(e.createAssignment(e.createElementAccess(c,0===u?_:e.createSubtract(_,e.createLiteral(u))),e.createElementAccess(e.createIdentifier("arguments"),_))),o))]));return e.setEmitFlags(d,1048576),e.startOnNewLine(d),a.push(d),73!==o.name.kind&&a.push(e.setEmitFlags(e.setTextRange(e.createVariableStatement(void 0,e.createVariableDeclarationList(e.flattenDestructuringBinding(o,l,t,0,c))),o),1048576)),e.insertStatementsAfterCustomPrologue(r,a),!0}function J(t,r){return 32768&Yr&&198!==r.kind?(z(t,r,e.createThis()),!0):!1}function z(t,r,n){Pr();var i=e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.createFileLevelUniqueName("_this"),void 0,n)]));e.setEmitFlags(i,1050112),e.setSourceMapRange(i,r),e.insertStatementAfterCustomPrologue(t,i)}function V(t,r,n){if(16384&Yr){var i=void 0;switch(r.kind){case 198:return t;case 157:case 159:case 160:i=e.createVoidZero();break;case 158:i=e.createPropertyAccess(e.setEmitFlags(e.createThis(),4),"constructor");break;case 240:case 197:i=e.createConditional(e.createLogicalAnd(e.setEmitFlags(e.createThis(),4),e.createBinary(e.setEmitFlags(e.createThis(),4),95,e.getLocalName(r))),e.createPropertyAccess(e.setEmitFlags(e.createThis(),4),"constructor"),e.createVoidZero());break;default:return e.Debug.failBadSyntaxKind(r)}var a=e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.createFileLevelUniqueName("_newTarget"),void 0,i)]));e.setEmitFlags(a,1050112),n&&(t=t.slice()),e.insertStatementAfterCustomPrologue(t,a)}return t}function U(t,r){for(var n=0,i=r.members;n<i.length;n++){var a=i[n];switch(a.kind){case 218:t.push(K(a));break;case 157:t.push(q(jr(r,a),a,r));break;case 159:case 160:var o=e.getAllAccessorDeclarations(r.members,a);a===o.firstAccessor&&t.push(W(jr(r,a),o,r));break;case 158:break;default:e.Debug.failBadSyntaxKind(r)}}}function K(t){return e.setTextRange(e.createEmptyStatement(),t)}function q(t,r,n){var i=e.getCommentRange(r),a=e.getSourceMapRange(r),o=e.createMemberAccessForPropertyName(t,e.visitNode(r.name,l,e.isPropertyName),r.name),s=Y(r,r,void 0,n);e.setEmitFlags(s,1536),e.setSourceMapRange(s,a);var c=e.setTextRange(e.createExpressionStatement(e.createAssignment(o,s)),r);return e.setOriginalNode(c,r),e.setCommentRange(c,i),e.setEmitFlags(c,48),c}function W(t,r,n){var i=e.createExpressionStatement(H(t,r,n,!1));return e.setEmitFlags(i,1536),e.setSourceMapRange(i,e.getSourceMapRange(r.firstAccessor)),i}function H(t,r,n,i){var a=r.firstAccessor,o=r.getAccessor,s=r.setAccessor,c=e.getMutableClone(t);e.setEmitFlags(c,1568),e.setSourceMapRange(c,a.name);var u=e.createExpressionForPropertyName(e.visitNode(a.name,l,e.isPropertyName));e.setEmitFlags(u,1552),e.setSourceMapRange(u,a.name);var _=[];if(o){var d=Y(o,void 0,void 0,n);e.setSourceMapRange(d,e.getSourceMapRange(o)),e.setEmitFlags(d,512);var p=e.createPropertyAssignment("get",d);e.setCommentRange(p,e.getCommentRange(o)),_.push(p)}if(s){var f=Y(s,void 0,void 0,n);e.setSourceMapRange(f,e.getSourceMapRange(s)),e.setEmitFlags(f,512);var m=e.createPropertyAssignment("set",f);e.setCommentRange(m,e.getCommentRange(s)),_.push(m)}_.push(e.createPropertyAssignment("enumerable",e.createTrue()),e.createPropertyAssignment("configurable",e.createTrue()));var g=e.createCall(e.createPropertyAccess(e.createIdentifier("Object"),"defineProperty"),void 0,[c,u,e.createObjectLiteral(_,!0)]);return i&&e.startOnNewLine(g),g}function G(r){2048&r.transformFlags&&(Yr|=32768);var n=$r;$r=void 0;var i=o(15232,66),a=e.createFunctionExpression(void 0,void 0,void 0,void 0,e.visitParameterList(r.parameters,l,t),void 0,Z(r));return e.setTextRange(a,r),e.setOriginalNode(a,r),e.setEmitFlags(a,8),32768&Yr&&Pr(),s(i,0,0),$r=n,a}function Q(r){var n=262144&e.getEmitFlags(r)?o(16278,69):o(16286,65),i=$r;$r=void 0;var a=e.visitParameterList(r.parameters,l,t),c=Z(r),u=16384&Yr?e.getLocalName(r):r.name;return s(n,49152,0),$r=i,e.updateFunctionExpression(r,void 0,r.asteriskToken,u,void 0,a,void 0,c)}function X(r){var n=$r;$r=void 0;var i=o(16286,65),a=e.visitParameterList(r.parameters,l,t),c=Z(r),u=16384&Yr?e.getLocalName(r):r.name;return s(i,49152,0),$r=n,e.updateFunctionDeclaration(r,void 0,e.visitNodes(r.modifiers,l,e.isModifier),r.asteriskToken,u,void 0,a,void 0,c)}function Y(r,n,i,a){var c=$r;$r=void 0;var u=a&&e.isClassLike(a)&&!e.hasModifier(r,32)?o(16286,73):o(16286,65),_=e.visitParameterList(r.parameters,l,t),d=Z(r);return 16384&Yr&&!i&&(240===r.kind||197===r.kind)&&(i=e.getGeneratedNameForNode(r)),s(u,49152,0),$r=c,e.setOriginalNode(e.setTextRange(e.createFunctionExpression(void 0,r.asteriskToken,i,void 0,_,void 0,d),n),r)}function Z(t){var r,n,i,a=!1,o=!1,s=[],c=[],u=t.body;if(Vr(),e.isBlock(u)&&(i=e.addStandardPrologue(s,u.statements,!1)),a=M(c,t)||a,a=j(c,t,!1)||a,e.isBlock(u))i=e.addCustomPrologue(c,u.statements,i,l),r=u.statements,e.addRange(c,e.visitNodes(u.statements,l,e.isStatement,i)),!a&&u.multiLine&&(a=!0);else{e.Debug.assert(198===t.kind),r=e.moveRangeEnd(u,-1);var _=t.equalsGreaterThanToken;e.nodeIsSynthesized(_)||e.nodeIsSynthesized(u)||(e.rangeEndIsOnSameLineAsRangeStart(_,u,Qr)?o=!0:a=!0);var d=e.visitNode(u,l,e.isExpression),p=e.createReturn(d);e.setTextRange(p,u),e.moveSyntheticComments(p,u),e.setEmitFlags(p,1440),c.push(p),n=u}if(e.mergeLexicalEnvironment(s,Ur()),V(s,t,!1),J(s,t),e.some(s)&&(a=!0),c.unshift.apply(c,s),e.isBlock(u)&&e.arrayIsEqualTo(c,u.statements))return u;var f=e.createBlock(e.setTextRange(e.createNodeArray(c),r),a);return e.setTextRange(f,t.body),!a&&o&&e.setEmitFlags(f,1),n&&e.setTokenSourceMapRange(f,19,n),e.setOriginalNode(f,t.body),f}function $(r,n){if(n)return e.visitEachChild(r,l,t);var i=256&Yr?o(7104,512):o(6976,128),a=e.visitEachChild(r,l,t);return s(i,0,0),a}function et(r){switch(r.expression.kind){case 196:return e.updateExpressionStatement(r,tt(r.expression,!1));case 205:return e.updateExpressionStatement(r,rt(r.expression,!1))}return e.visitEachChild(r,l,t)}function tt(r,n){if(!n)switch(r.expression.kind){case 196:return e.updateParen(r,tt(r.expression,!1));case 205:return e.updateParen(r,rt(r.expression,!1))}return e.visitEachChild(r,l,t)}function rt(r,n){return e.isDestructuringAssignment(r)?e.flattenDestructuringAssignment(r,l,t,0,n):e.visitEachChild(r,l,t)}function nt(r){var n,i=o(0,e.hasModifier(r,1)?32:0);if($r&&0===(3&r.declarationList.flags)){for(var a=void 0,c=0,u=r.declarationList.declarations;c<u.length;c++){var _=u[c];if(At($r,_),_.initializer){var d=void 0;e.isBindingPattern(_.name)?d=e.flattenDestructuringAssignment(_,l,t,0):(d=e.createBinary(_.name,60,e.visitNode(_.initializer,l,e.isExpression)),e.setTextRange(d,_)),a=e.append(a,d)}}n=a?e.setTextRange(e.createExpressionStatement(e.inlineExpressions(a)),r):void 0}else n=e.visitEachChild(r,l,t);return s(i,0,0),n}function it(r){if(3&r.flags||65536&r.transformFlags){3&r.flags&&Fr();var n=e.flatMap(r.declarations,1&r.flags?st:ct),i=e.createVariableDeclarationList(n);return e.setOriginalNode(i,r),e.setTextRange(i,r),e.setCommentRange(i,r),65536&r.transformFlags&&(e.isBindingPattern(r.declarations[0].name)||e.isBindingPattern(e.last(r.declarations).name))&&e.setSourceMapRange(i,at(n)),i}return e.visitEachChild(r,l,t)}function at(t){for(var r=-1,n=-1,i=0,a=t;i<a.length;i++){var o=a[i];r=-1===r?o.pos:-1===o.pos?r:Math.min(r,o.pos),n=Math.max(n,o.end)}return e.createRange(r,n)}function ot(e){var t=Wr.getNodeCheckFlags(e),r=262144&t,n=524288&t,i=0!==(64&Yr)||r&&n&&0!==(512&Yr),a=!i&&0===(4096&Yr)&&(!Wr.isDeclarationWithCollidingName(e)||n&&!r&&0===(6144&Yr));
return a}function st(r){var n=r.name;if(e.isBindingPattern(n))return ct(r);if(!r.initializer&&ot(r)){var i=e.getMutableClone(r);return i.initializer=e.createVoidZero(),i}return e.visitEachChild(r,l,t)}function ct(r){var n,i=o(32,0);return n=e.isBindingPattern(r.name)?e.flattenDestructuringBinding(r,l,t,0,void 0,0!==(32&i)):e.visitEachChild(r,l,t),s(i,0,0),n}function ut(t){$r.labels.set(e.idText(t.label),!0)}function lt(t){$r.labels.set(e.idText(t.label),!1)}function _t(t){$r&&!$r.labels&&($r.labels=e.createMap());var r=e.unwrapInnermostStatementOfLabel(t,$r&&ut);return e.isIterationStatement(r,!1)?dt(r,t):e.restoreEnclosingLabel(e.visitNode(r,l,e.isStatement,e.liftToBlock),t,$r&&lt)}function dt(e,t){switch(e.kind){case 224:case 225:return ft(e,t);case 226:return mt(e,t);case 227:return gt(e,t);case 228:return vt(e,t)}}function pt(e,t,r,n,i){var a=o(e,t),c=Ft(r,n,a,i);return s(a,0,0),c}function ft(e,t){return pt(0,1280,e,t)}function mt(e,t){return pt(5056,3328,e,t)}function gt(e,t){return pt(3008,5376,e,t)}function vt(e,t){return pt(3008,5376,e,t,qr.downlevelIteration?xt:bt)}function yt(r,n,i){var a=[],o=r.initializer;if(e.isVariableDeclarationList(o)){3&r.initializer.flags&&Fr();var s=e.firstOrUndefined(o.declarations);if(s&&e.isBindingPattern(s.name)){var c=e.flattenDestructuringBinding(s,l,t,0,n),u=e.setTextRange(e.createVariableDeclarationList(c),r.initializer);e.setOriginalNode(u,r.initializer),e.setSourceMapRange(u,e.createRange(c[0].pos,e.last(c).end)),a.push(e.createVariableStatement(void 0,u))}else a.push(e.setTextRange(e.createVariableStatement(void 0,e.setOriginalNode(e.setTextRange(e.createVariableDeclarationList([e.createVariableDeclaration(s?s.name:e.createTempVariable(void 0),void 0,n)]),e.moveRangePos(o,-1)),o)),e.moveRangeEnd(o,-1)))}else{var _=e.createAssignment(o,n);e.isDestructuringAssignment(_)?(e.aggregateTransformFlags(_),a.push(e.createExpressionStatement(rt(_,!1)))):(_.end=o.end,a.push(e.setTextRange(e.createExpressionStatement(e.visitNode(_,l,e.isExpression)),e.moveRangeEnd(o,-1))))}if(i)return ht(e.addRange(a,i));var d=e.visitNode(r.statement,l,e.isStatement,e.liftToBlock);return e.isBlock(d)?e.updateBlock(d,e.setTextRange(e.createNodeArray(e.concatenate(a,d.statements)),d.statements)):(a.push(d),ht(a))}function ht(t){return e.setEmitFlags(e.createBlock(e.createNodeArray(t),!0),432)}function bt(t,r,n){var i=e.visitNode(t.expression,l,e.isExpression),a=e.createLoopVariable(),o=e.isIdentifier(i)?e.getGeneratedNameForNode(i):e.createTempVariable(void 0);e.setEmitFlags(i,48|e.getEmitFlags(i));var s=e.setTextRange(e.createFor(e.setEmitFlags(e.setTextRange(e.createVariableDeclarationList([e.setTextRange(e.createVariableDeclaration(a,void 0,e.createLiteral(0)),e.moveRangePos(t.expression,-1)),e.setTextRange(e.createVariableDeclaration(o,void 0,i),t.expression)]),t.expression),2097152),e.setTextRange(e.createLessThan(a,e.createPropertyAccess(o,"length")),t.expression),e.setTextRange(e.createPostfixIncrement(a),t.expression),yt(t,e.createElementAccess(o,a),n)),t);return e.setEmitFlags(s,256),e.setTextRange(s,t),e.restoreEnclosingLabel(s,r,$r&&lt)}function xt(r,n,i,a){var o=e.visitNode(r.expression,l,e.isExpression),s=e.isIdentifier(o)?e.getGeneratedNameForNode(o):e.createTempVariable(void 0),c=e.isIdentifier(o)?e.getGeneratedNameForNode(s):e.createTempVariable(void 0),u=e.createUniqueName("e"),_=e.getGeneratedNameForNode(u),d=e.createTempVariable(void 0),p=e.createValuesHelper(t,o,r.expression),f=e.createCall(e.createPropertyAccess(s,"next"),void 0,[]);Kr(u),Kr(d);var m=1024&a?e.inlineExpressions([e.createAssignment(u,e.createVoidZero()),p]):p,g=e.setEmitFlags(e.setTextRange(e.createFor(e.setEmitFlags(e.setTextRange(e.createVariableDeclarationList([e.setTextRange(e.createVariableDeclaration(s,void 0,m),r.expression),e.createVariableDeclaration(c,void 0,f)]),r.expression),2097152),e.createLogicalNot(e.createPropertyAccess(c,"done")),e.createAssignment(c,f),yt(r,e.createPropertyAccess(c,"value"),i)),r),256);return e.createTry(e.createBlock([e.restoreEnclosingLabel(g,n,$r&&lt)]),e.createCatchClause(e.createVariableDeclaration(_),e.setEmitFlags(e.createBlock([e.createExpressionStatement(e.createAssignment(u,e.createObjectLiteral([e.createPropertyAssignment("error",_)])))]),1)),e.createBlock([e.createTry(e.createBlock([e.setEmitFlags(e.createIf(e.createLogicalAnd(e.createLogicalAnd(c,e.createLogicalNot(e.createPropertyAccess(c,"done"))),e.createAssignment(d,e.createPropertyAccess(s,"return"))),e.createExpressionStatement(e.createFunctionCall(d,s,[]))),1)]),void 0,e.setEmitFlags(e.createBlock([e.setEmitFlags(e.createIf(u,e.createThrow(e.createPropertyAccess(u,"error"))),1)]),1))]))}function Dt(r){for(var n=r.properties,i=n.length,a=i,o=i,s=0;i>s;s++){var c=n[s];if(131072&c.transformFlags&&4&Yr&&o>s&&(o=s),150===c.name.kind){a=s;break}}if(a!==i){a>o&&(a=o);var u=e.createTempVariable(Kr),_=[],d=e.createAssignment(u,e.setEmitFlags(e.createObjectLiteral(e.visitNodes(n,l,e.isObjectLiteralElementLike,0,a),r.multiLine),65536));return r.multiLine&&e.startOnNewLine(d),_.push(d),Qt(_,r,u,a),_.push(r.multiLine?e.startOnNewLine(e.getMutableClone(u)):u),e.inlineExpressions(_)}return e.visitEachChild(r,l,t)}function St(e){return 0!==(131072&Wr.getNodeCheckFlags(e))}function Ct(t){return e.isForStatement(t)&&!!t.initializer&&St(t.initializer)}function kt(t){return e.isForStatement(t)&&!!t.condition&&St(t.condition)}function Tt(t){return e.isForStatement(t)&&!!t.incrementor&&St(t.incrementor)}function Et(e){return Nt(e)||Ct(e)}function Nt(e){return 0!==(65536&Wr.getNodeCheckFlags(e))}function At(t,r){function n(r){if(73===r.kind)t.hoistedLocalVariables.push(r);else for(var i=0,a=r.elements;i<a.length;i++){var o=a[i];e.isOmittedExpression(o)||n(o.name)}}t.hoistedLocalVariables||(t.hoistedLocalVariables=[]),n(r.name)}function Ft(r,n,i,a){if(!Et(r)){var o=void 0;$r&&(o=$r.allowedNonLabeledJumps,$r.allowedNonLabeledJumps=6);var s=a?a(r,n,void 0,i):e.restoreEnclosingLabel(e.visitEachChild(r,l,t),n,$r&&lt);return $r&&($r.allowedNonLabeledJumps=o),s}var c=Rt(r),u=[],_=$r;$r=c;var d=Ct(r)?Jt(r,c):void 0,p=Nt(r)?zt(r,c,_):void 0;$r=_,d&&u.push(d.functionDeclaration),p&&u.push(p.functionDeclaration),Bt(u,c,_),d&&u.push(Kt(d.functionName,d.containsYield));var f;if(p)if(a)f=a(r,n,p.part,i);else{var m=Pt(r,d,e.createBlock(p.part,!0));e.aggregateTransformFlags(m),f=e.restoreEnclosingLabel(m,n,$r&&lt)}else{var g=Pt(r,d,e.visitNode(r.statement,l,e.isStatement,e.liftToBlock));e.aggregateTransformFlags(g),f=e.restoreEnclosingLabel(g,n,$r&&lt)}return u.push(f),u}function Pt(t,r,n){switch(t.kind){case 226:return wt(t,r,n);case 227:return Ot(t,n);case 228:return It(t,n);case 224:return Mt(t,n);case 225:return Lt(t,n);default:return e.Debug.failBadSyntaxKind(t,"IterationStatement expected")}}function wt(t,r,n){var i=t.condition&&St(t.condition),a=i||t.incrementor&&St(t.incrementor);return e.updateFor(t,e.visitNode(r?r.part:t.initializer,l,e.isForInitializer),e.visitNode(i?void 0:t.condition,l,e.isExpression),e.visitNode(a?void 0:t.incrementor,l,e.isExpression),n)}function It(t,r){return e.updateForOf(t,void 0,e.visitNode(t.initializer,l,e.isForInitializer),e.visitNode(t.expression,l,e.isExpression),r)}function Ot(t,r){return e.updateForIn(t,e.visitNode(t.initializer,l,e.isForInitializer),e.visitNode(t.expression,l,e.isExpression),r)}function Mt(t,r){return e.updateDo(t,r,e.visitNode(t.expression,l,e.isExpression))}function Lt(t,r){return e.updateWhile(t,e.visitNode(t.expression,l,e.isExpression),r)}function Rt(t){var r;switch(t.kind){case 226:case 227:case 228:var n=t.initializer;n&&239===n.kind&&(r=n)}var i=[],a=[];if(r&&3&e.getCombinedNodeFlags(r))for(var o=Ct(t),s=0,c=r.declarations;s<c.length;s++){var u=c[s];Gt(t,u,i,a,o)}var l={loopParameters:i,loopOutParameters:a};return $r&&($r.argumentsName&&(l.argumentsName=$r.argumentsName),$r.thisName&&(l.thisName=$r.thisName),$r.hoistedLocalVariables&&(l.hoistedLocalVariables=$r.hoistedLocalVariables)),l}function Bt(t,r,n){var i;if(r.argumentsName&&(n?n.argumentsName=r.argumentsName:(i||(i=[])).push(e.createVariableDeclaration(r.argumentsName,void 0,e.createIdentifier("arguments")))),r.thisName&&(n?n.thisName=r.thisName:(i||(i=[])).push(e.createVariableDeclaration(r.thisName,void 0,e.createIdentifier("this")))),r.hoistedLocalVariables)if(n)n.hoistedLocalVariables=r.hoistedLocalVariables;else{i||(i=[]);for(var a=0,o=r.hoistedLocalVariables;a<o.length;a++){var s=o[a];i.push(e.createVariableDeclaration(s))}}if(r.loopOutParameters.length){i||(i=[]);for(var c=0,u=r.loopOutParameters;c<u.length;c++){var l=u[c];i.push(e.createVariableDeclaration(l.outParamName))}}r.conditionVariable&&(i||(i=[]),i.push(e.createVariableDeclaration(r.conditionVariable,void 0,e.createFalse()))),i&&t.push(e.createVariableStatement(void 0,e.createVariableDeclarationList(i)))}function jt(t){return e.createVariableDeclaration(t.originalName,void 0,t.outParamName)}function Jt(t,r){var n=e.createUniqueName("_loop_init"),i=0!==(131072&t.initializer.transformFlags),a=0;r.containsLexicalThis&&(a|=8),i&&4&Yr&&(a|=262144);var o=[];o.push(e.createVariableStatement(void 0,t.initializer)),Ut(r.loopOutParameters,2,1,o);var s=e.createVariableStatement(void 0,e.setEmitFlags(e.createVariableDeclarationList([e.createVariableDeclaration(n,void 0,e.setEmitFlags(e.createFunctionExpression(void 0,i?e.createToken(40):void 0,void 0,void 0,void 0,void 0,e.visitNode(e.createBlock(o,!0),l,e.isBlock)),a))]),2097152)),c=e.createVariableDeclarationList(e.map(r.loopOutParameters,jt));return{functionName:n,containsYield:i,functionDeclaration:s,part:c}}function zt(t,r,n){var i=e.createUniqueName("_loop");zr();var a=e.visitNode(t.statement,l,e.isStatement,e.liftToBlock),o=Ur(),s=[];(kt(t)||Tt(t))&&(r.conditionVariable=e.createUniqueName("inc"),s.push(e.createIf(r.conditionVariable,e.createStatement(e.visitNode(t.incrementor,l,e.isExpression)),e.createStatement(e.createAssignment(r.conditionVariable,e.createTrue())))),kt(t)&&s.push(e.createIf(e.createPrefix(52,e.visitNode(t.condition,l,e.isExpression)),e.visitNode(e.createBreak(),l,e.isStatement)))),e.isBlock(a)?e.addRange(s,a.statements):s.push(a),Ut(r.loopOutParameters,1,1,s),e.insertStatementsAfterStandardPrologue(s,o);var c=e.createBlock(s,!0);e.isBlock(a)&&e.setOriginalNode(c,a);var u=0!==(131072&t.statement.transformFlags),_=0;r.containsLexicalThis&&(_|=8),u&&0!==(4&Yr)&&(_|=262144);var d=e.createVariableStatement(void 0,e.setEmitFlags(e.createVariableDeclarationList([e.createVariableDeclaration(i,void 0,e.setEmitFlags(e.createFunctionExpression(void 0,u?e.createToken(40):void 0,void 0,void 0,r.loopParameters,void 0,c),_))]),2097152)),p=qt(i,r,n,u);return{functionName:i,containsYield:u,functionDeclaration:d,part:p}}function Vt(t,r){var n=0===r?t.outParamName:t.originalName,i=0===r?t.originalName:t.outParamName;return e.createBinary(i,60,n)}function Ut(t,r,n,i){for(var a=0,o=t;a<o.length;a++){var s=o[a];s.flags&r&&i.push(e.createExpressionStatement(Vt(s,n)))}}function Kt(t,r){var n=e.createCall(t,void 0,[]),i=r?e.createYield(e.createToken(40),e.setEmitFlags(n,8388608)):n;return e.createStatement(i)}function qt(t,r,n,i){var a=[],o=!(-5&r.nonLocalJumps||r.labeledNonLocalBreaks||r.labeledNonLocalContinues),s=e.createCall(t,void 0,e.map(r.loopParameters,function(e){return e.name})),c=i?e.createYield(e.createToken(40),e.setEmitFlags(s,8388608)):s;if(o)a.push(e.createExpressionStatement(c)),Ut(r.loopOutParameters,1,0,a);else{var u=e.createUniqueName("state"),l=e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(u,void 0,c)]));if(a.push(l),Ut(r.loopOutParameters,1,0,a),8&r.nonLocalJumps){var _=void 0;n?(n.nonLocalJumps|=8,_=e.createReturn(u)):_=e.createReturn(e.createPropertyAccess(u,"value")),a.push(e.createIf(e.createBinary(e.createTypeOf(u),35,e.createLiteral("object")),_))}if(2&r.nonLocalJumps&&a.push(e.createIf(e.createBinary(u,35,e.createLiteral("break")),e.createBreak())),r.labeledNonLocalBreaks||r.labeledNonLocalContinues){var d=[];Ht(r.labeledNonLocalBreaks,!0,u,n,d),Ht(r.labeledNonLocalContinues,!1,u,n,d),a.push(e.createSwitch(u,e.createCaseBlock(d)))}}return a}function Wt(t,r,n,i){r?(t.labeledNonLocalBreaks||(t.labeledNonLocalBreaks=e.createMap()),t.labeledNonLocalBreaks.set(n,i)):(t.labeledNonLocalContinues||(t.labeledNonLocalContinues=e.createMap()),t.labeledNonLocalContinues.set(n,i))}function Ht(t,r,n,i,a){t&&t.forEach(function(t,o){var s=[];if(!i||i.labels&&i.labels.get(o)){var c=e.createIdentifier(o);s.push(r?e.createBreak(c):e.createContinue(c))}else Wt(i,r,o,t),s.push(e.createReturn(n));a.push(e.createCaseClause(e.createLiteral(t),s))})}function Gt(t,r,n,i,a){var o=r.name;if(e.isBindingPattern(o))for(var s=0,c=o.elements;s<c.length;s++){var u=c[s];e.isOmittedExpression(u)||Gt(t,u,n,i,a)}else{n.push(e.createParameter(void 0,void 0,void 0,o));var l=Wr.getNodeCheckFlags(r);if(4194304&l||a){var _=e.createUniqueName("out_"+e.idText(o)),d=0;4194304&l&&(d|=1),e.isForStatement(t)&&t.initializer&&Wr.isBindingCapturedByNode(t.initializer,r)&&(d|=2),i.push({flags:d,originalName:o,outParamName:_})}}}function Qt(t,r,n,i){for(var a=r.properties,o=a.length,s=i;o>s;s++){var c=a[s];switch(c.kind){case 159:case 160:var u=e.getAllAccessorDeclarations(r.properties,c);c===u.firstAccessor&&t.push(H(n,u,r,!!r.multiLine));break;case 157:t.push(Zt(c,n,r,r.multiLine));break;case 276:t.push(Xt(c,n,r.multiLine));break;case 277:t.push(Yt(c,n,r.multiLine));break;default:e.Debug.failBadSyntaxKind(r)}}}function Xt(t,r,n){var i=e.createAssignment(e.createMemberAccessForPropertyName(r,e.visitNode(t.name,l,e.isPropertyName)),e.visitNode(t.initializer,l,e.isExpression));return e.setTextRange(i,t),n&&e.startOnNewLine(i),i}function Yt(t,r,n){var i=e.createAssignment(e.createMemberAccessForPropertyName(r,e.visitNode(t.name,l,e.isPropertyName)),e.getSynthesizedClone(t.name));return e.setTextRange(i,t),n&&e.startOnNewLine(i),i}function Zt(t,r,n,i){var a=e.createAssignment(e.createMemberAccessForPropertyName(r,e.visitNode(t.name,l,e.isPropertyName)),Y(t,t,void 0,n));return e.setTextRange(a,t),i&&e.startOnNewLine(a),a}function $t(r){var n,i=o(7104,0);if(e.Debug.assert(!!r.variableDeclaration,"Catch clause variable should always be present when downleveling ES2015."),e.isBindingPattern(r.variableDeclaration.name)){var a=e.createTempVariable(void 0),c=e.createVariableDeclaration(a);e.setTextRange(c,r.variableDeclaration);var u=e.flattenDestructuringBinding(r.variableDeclaration,l,t,0,a),_=e.createVariableDeclarationList(u);e.setTextRange(_,r.variableDeclaration);var d=e.createVariableStatement(void 0,_);n=e.updateCatchClause(r,c,er(r.block,d))}else n=e.visitEachChild(r,l,t);return s(i,0,0),n}function er(t,r){var n=e.visitNodes(t.statements,l,e.isStatement);return e.updateBlock(t,[r].concat(n))}function tr(t){e.Debug.assert(!e.isComputedPropertyName(t.name));var r=Y(t,e.moveRangePos(t,-1),void 0,void 0);return e.setEmitFlags(r,512|e.getEmitFlags(r)),e.setTextRange(e.createPropertyAssignment(t.name,r),t)}function rr(r){e.Debug.assert(!e.isComputedPropertyName(r.name));var n=$r;$r=void 0;var i,a=o(16286,65),c=e.visitParameterList(r.parameters,l,t),u=Z(r);return i=159===r.kind?e.updateGetAccessor(r,r.decorators,r.modifiers,r.name,c,r.type,u):e.updateSetAccessor(r,r.decorators,r.modifiers,r.name,c,u),s(a,49152,0),$r=n,i}function nr(t){return e.setTextRange(e.createPropertyAssignment(t.name,e.getSynthesizedClone(t.name)),t)}function ir(r){return e.visitEachChild(r,l,t)}function ar(r){return e.visitEachChild(r,l,t)}function or(r){return e.some(r.elements,e.isSpreadElement)?dr(r.elements,!0,!!r.multiLine,!!r.elements.hasTrailingComma):e.visitEachChild(r,l,t)}function sr(t){if(33554432&e.getEmitFlags(t))return cr(t);var r=e.skipOuterExpressions(t.expression);return 99===r.kind||e.isSuperProperty(r)||e.some(t.arguments,e.isSpreadElement)?lr(t,!0):e.updateCall(t,e.visitNode(t.expression,_,e.isExpression),void 0,e.visitNodes(t.arguments,l,e.isExpression))}function cr(t){var r=e.cast(e.cast(e.skipOuterExpressions(t.expression),e.isArrowFunction).body,e.isBlock),n=function(t){return e.isVariableStatement(t)&&!!e.first(t.declarationList.declarations).initializer},i=e.visitNodes(r.statements,l,e.isStatement),a=e.filter(i,n),o=e.filter(i,function(e){return!n(e)}),s=e.cast(e.first(a),e.isVariableStatement),c=s.declarationList.declarations[0],u=e.skipOuterExpressions(c.initializer),_=e.tryCast(u,e.isAssignmentExpression),d=e.cast(_?e.skipOuterExpressions(_.right):u,e.isCallExpression),p=e.cast(e.skipOuterExpressions(d.expression),e.isFunctionExpression),f=p.body.statements,m=0,g=-1,v=[];if(_){var y=e.tryCast(f[m],e.isExpressionStatement);y&&(v.push(y),m++),v.push(f[m]),m++,v.push(e.createExpressionStatement(e.createAssignment(_.left,e.cast(c.name,e.isIdentifier))))}for(;!e.isReturnStatement(e.elementAt(f,g));)g--;return e.addRange(v,f,m,g),-1>g&&e.addRange(v,f,g+1),e.addRange(v,o),e.addRange(v,a,1),e.recreateOuterExpressions(t.expression,e.recreateOuterExpressions(c.initializer,e.recreateOuterExpressions(_&&_.right,e.updateCall(d,e.recreateOuterExpressions(d.expression,e.updateFunctionExpression(p,void 0,void 0,void 0,void 0,p.parameters,void 0,e.updateBlock(p.body,v))),void 0,d.arguments))))}function ur(e){return lr(e,!1)}function lr(r,n){if(4096&r.transformFlags||99===r.expression.kind||e.isSuperProperty(e.skipOuterExpressions(r.expression))){var i=e.createCallBinding(r.expression,Kr),a=i.target,o=i.thisArg;99===r.expression.kind&&e.setEmitFlags(o,4);var s=void 0;if(s=4096&r.transformFlags?e.createFunctionApply(e.visitNode(a,_,e.isExpression),99===r.expression.kind?o:e.visitNode(o,l,e.isExpression),dr(r.arguments,!1,!1,!1)):e.createFunctionCall(e.visitNode(a,_,e.isExpression),99===r.expression.kind?o:e.visitNode(o,l,e.isExpression),e.visitNodes(r.arguments,l,e.isExpression),r),99===r.expression.kind){var c=e.createLogicalOr(s,P());s=n?e.createAssignment(e.createFileLevelUniqueName("_this"),c):c}return e.setOriginalNode(s,r)}return e.visitEachChild(r,l,t)}function _r(r){if(e.some(r.arguments,e.isSpreadElement)){var n=e.createCallBinding(e.createPropertyAccess(r.expression,"bind"),Kr),i=n.target,a=n.thisArg;return e.createNew(e.createFunctionApply(e.visitNode(i,l,e.isExpression),a,dr(e.createNodeArray([e.createVoidZero()].concat(r.arguments)),!1,!1,!1)),void 0,[])}return e.visitEachChild(r,l,t)}function dr(r,n,i,a){var o=r.length,s=e.flatten(e.spanMap(r,pr,function(e,t,r,n){return t(e,i,a&&n===o)}));if(qr.downlevelIteration){if(1===s.length){var c=s[0];if(e.isCallExpression(c)&&e.isIdentifier(c.expression)&&4096&e.getEmitFlags(c.expression)&&"___spread"===c.expression.escapedText)return s[0]}return e.createSpreadHelper(t,s)}if(1===s.length){var u=r[0];return n&&e.isSpreadElement(u)&&188!==u.expression.kind?e.createArraySlice(s[0]):s[0]}return e.createArrayConcat(s.shift(),s)}function pr(t){return e.isSpreadElement(t)?fr:mr}function fr(t){return e.map(t,vr)}function mr(t,r,n){return e.createArrayLiteral(e.visitNodes(e.createNodeArray(t,n),l,e.isExpression),r)}function gr(t){return e.visitNode(t.expression,l,e.isExpression)}function vr(t){return e.visitNode(t.expression,l,e.isExpression)}function yr(t){return e.setTextRange(e.createLiteral(t.text),t)}function hr(t){return t.hasExtendedUnicodeEscape?e.setTextRange(e.createLiteral(t.text),t):t}function br(t){return 384&t.numericLiteralFlags?e.setTextRange(e.createNumericLiteral(t.text),t):t}function xr(r){var a=e.visitNode(r.tag,l,e.isExpression),o=[void 0],s=[],c=[],u=r.template;if(e.isNoSubstitutionTemplateLiteral(u))s.push(e.createLiteral(u.text)),c.push(Dr(u));else{s.push(e.createLiteral(u.head.text)),c.push(Dr(u.head));for(var _=0,d=u.templateSpans;_<d.length;_++){var p=d[_];s.push(e.createLiteral(p.literal.text)),c.push(Dr(p.literal)),o.push(e.visitNode(p.expression,l,e.isExpression))}}var f=n(t,e.createArrayLiteral(s),e.createArrayLiteral(c));if(e.isExternalModule(Qr)){var m=e.createUniqueName("templateObject");i(m),o[0]=e.createLogicalOr(m,e.createAssignment(m,f))}else o[0]=f;return e.createCall(a,void 0,o)}function Dr(t){var r=e.getSourceTextOfNodeFromSourceFile(Qr,t),n=14===t.kind||17===t.kind;return r=r.substring(1,r.length-(n?1:2)),r=r.replace(/\r\n?/g,"\n"),e.setTextRange(e.createLiteral(r),t)}function Sr(t){var r=[];kr(r,t),Tr(r,t);var n=e.reduceLeft(r,e.createAdd);return e.nodeIsSynthesized(n)&&(n.pos=t.pos,n.end=t.end),n}function Cr(t){return e.Debug.assert(0!==t.templateSpans.length),0!==t.head.text.length||0===t.templateSpans[0].literal.text.length}function kr(t,r){Cr(r)&&t.push(e.createLiteral(r.head.text))}function Tr(t,r){for(var n=0,i=r.templateSpans;n<i.length;n++){var a=i[n];t.push(e.visitNode(a.expression,l,e.isExpression)),0!==a.literal.text.length&&t.push(e.createLiteral(a.literal.text))}}function Er(t){return 8&Yr&&!t?e.createPropertyAccess(e.createFileLevelUniqueName("_super"),"prototype"):e.createFileLevelUniqueName("_super")}function Nr(t){return 96===t.keywordToken&&"target"===t.name.escapedText?(Yr|=16384,e.createFileLevelUniqueName("_newTarget")):t}function Ar(t,r,n){if(1&en&&e.isFunctionLike(r)){var i=o(16286,8&e.getEmitFlags(r)?81:65);return Gr(t,r,n),void s(i,0,0)}Gr(t,r,n)}function Fr(){0===(2&en)&&(en|=2,t.enableSubstitution(73))}function Pr(){0===(1&en)&&(en|=1,t.enableSubstitution(101),t.enableEmitNotification(158),t.enableEmitNotification(157),t.enableEmitNotification(159),t.enableEmitNotification(160),t.enableEmitNotification(198),t.enableEmitNotification(197),t.enableEmitNotification(240))}function wr(t,r){return r=Hr(t,r),1===t?Mr(r):e.isIdentifier(r)?Ir(r):r}function Ir(t){if(2&en&&!e.isInternalName(t)){var r=e.getParseTreeNode(t,e.isIdentifier);if(r&&Or(r))return e.setTextRange(e.getGeneratedNameForNode(r),t)}return t}function Or(e){switch(e.parent.kind){case 187:case 241:case 244:case 238:return e.parent.name===e&&Wr.isDeclarationWithCollidingName(e.parent)}return!1}function Mr(e){switch(e.kind){case 73:return Lr(e);case 101:return Br(e)}return e}function Lr(t){if(2&en&&!e.isInternalName(t)){var r=Wr.getReferencedDeclarationWithCollidingName(t);if(r&&(!e.isClassLike(r)||!Rr(r,t)))return e.setTextRange(e.getGeneratedNameForNode(e.getNameOfDeclaration(r)),t)}return t}function Rr(t,r){var n=e.getParseTreeNode(r);if(!n||n===t||n.end<=t.pos||n.pos>=t.end)return!1;for(var i=e.getEnclosingBlockScopeContainer(t);n;){if(n===i||n===t)return!1;if(e.isClassElement(n)&&n.parent===t)return!0;n=n.parent}return!1}function Br(t){return 1&en&&16&Yr?e.setTextRange(e.createFileLevelUniqueName("_this"),t):t}function jr(t,r){return e.hasModifier(r,32)?e.getInternalName(t):e.createPropertyAccess(e.getInternalName(t),"prototype")}function Jr(t,r){if(!t||!r)return!1;if(e.some(t.parameters))return!1;var n=e.firstOrUndefined(t.body.statements);if(!n||!e.nodeIsSynthesized(n)||222!==n.kind)return!1;var i=n.expression;if(!e.nodeIsSynthesized(i)||192!==i.kind)return!1;var a=i.expression;if(!e.nodeIsSynthesized(a)||99!==a.kind)return!1;var o=e.singleOrUndefined(i.arguments);if(!o||!e.nodeIsSynthesized(o)||209!==o.kind)return!1;var s=o.expression;return e.isIdentifier(s)&&"arguments"===s.escapedText}var zr=t.startLexicalEnvironment,Vr=t.resumeLexicalEnvironment,Ur=t.endLexicalEnvironment,Kr=t.hoistVariableDeclaration,qr=t.getCompilerOptions(),Wr=t.getEmitResolver(),Hr=t.onSubstituteNode,Gr=t.onEmitNode;t.onEmitNode=Ar,t.onSubstituteNode=wr;var Qr,Xr,Yr,Zr,$r,en;return e.chainBundle(a)}function r(t,r){return t.requestEmitHelper(e.extendsHelper),e.createCall(e.getHelperName("__extends"),void 0,[r,e.createFileLevelUniqueName("_super")])}function n(t,r,n){return t.requestEmitHelper(e.templateObjectHelper),e.createCall(e.getHelperName("__makeTemplateObject"),void 0,[r,n])}var i;!function(e){e[e.CapturedThis=1]="CapturedThis",e[e.BlockScopedBindings=2]="BlockScopedBindings"}(i||(i={}));var a;!function(e){e[e.Body=1]="Body",e[e.Initializer=2]="Initializer"}(a||(a={}));var o;!function(e){e[e.ToOriginal=0]="ToOriginal",e[e.ToOutParameter=1]="ToOutParameter"}(o||(o={}));var s;!function(e){e[e.Break=2]="Break",e[e.Continue=4]="Continue",e[e.Return=8]="Return"}(s||(s={}));var c;!function(e){e[e.None=0]="None",e[e.Function=1]="Function",e[e.ArrowFunction=2]="ArrowFunction",e[e.AsyncFunctionBody=4]="AsyncFunctionBody",e[e.NonStaticClassElement=8]="NonStaticClassElement",e[e.CapturesThis=16]="CapturesThis",e[e.ExportedVariableStatement=32]="ExportedVariableStatement",e[e.TopLevel=64]="TopLevel",e[e.Block=128]="Block",e[e.IterationStatement=256]="IterationStatement",e[e.IterationStatementBlock=512]="IterationStatementBlock",e[e.IterationContainer=1024]="IterationContainer",e[e.ForStatement=2048]="ForStatement",e[e.ForInOrForOfStatement=4096]="ForInOrForOfStatement",e[e.ConstructorWithCapturedSuper=8192]="ConstructorWithCapturedSuper",e[e.AncestorFactsMask=16383]="AncestorFactsMask",e[e.BlockScopeIncludes=0]="BlockScopeIncludes",e[e.BlockScopeExcludes=7104]="BlockScopeExcludes",e[e.SourceFileIncludes=64]="SourceFileIncludes",e[e.SourceFileExcludes=8064]="SourceFileExcludes",e[e.FunctionIncludes=65]="FunctionIncludes",e[e.FunctionExcludes=16286]="FunctionExcludes",e[e.AsyncFunctionBodyIncludes=69]="AsyncFunctionBodyIncludes",e[e.AsyncFunctionBodyExcludes=16278]="AsyncFunctionBodyExcludes",e[e.ArrowFunctionIncludes=66]="ArrowFunctionIncludes",e[e.ArrowFunctionExcludes=15232]="ArrowFunctionExcludes",e[e.ConstructorIncludes=73]="ConstructorIncludes",e[e.ConstructorExcludes=16278]="ConstructorExcludes",e[e.DoOrWhileStatementIncludes=1280]="DoOrWhileStatementIncludes",e[e.DoOrWhileStatementExcludes=0]="DoOrWhileStatementExcludes",e[e.ForStatementIncludes=3328]="ForStatementIncludes",e[e.ForStatementExcludes=5056]="ForStatementExcludes",e[e.ForInOrForOfStatementIncludes=5376]="ForInOrForOfStatementIncludes",e[e.ForInOrForOfStatementExcludes=3008]="ForInOrForOfStatementExcludes",e[e.BlockIncludes=128]="BlockIncludes",e[e.BlockExcludes=6976]="BlockExcludes",e[e.IterationStatementBlockIncludes=512]="IterationStatementBlockIncludes",e[e.IterationStatementBlockExcludes=7104]="IterationStatementBlockExcludes",e[e.NewTarget=16384]="NewTarget",e[e.CapturedLexicalThis=32768]="CapturedLexicalThis",e[e.SubtreeFactsMask=-16384]="SubtreeFactsMask",e[e.ArrowFunctionSubtreeExcludes=0]="ArrowFunctionSubtreeExcludes",e[e.FunctionSubtreeExcludes=49152]="FunctionSubtreeExcludes"}(c||(c={})),e.transformES2015=t,e.extendsHelper={name:"typescript:extends",scoped:!1,priority:0,text:"\n            var __extends = (this && this.__extends) || (function () {\n                var extendStatics = function (d, b) {\n                    extendStatics = Object.setPrototypeOf ||\n                        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||\n                        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };\n                    return extendStatics(d, b);\n                };\n\n                return function (d, b) {\n                    extendStatics(d, b);\n                    function __() { this.constructor = d; }\n                    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());\n                };\n            })();"},e.templateObjectHelper={name:"typescript:makeTemplateObject",scoped:!1,priority:0,text:'\n            var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {\n                if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }\n                return cooked;\n            };'}}(n||(n={}));var n;!function(e){function t(t){function r(e){return e}function n(t,r,n){switch(r.kind){case 263:case 264:case 262:var i=r.tagName;u[e.getOriginalNodeId(i)]=!0}c(t,r,n)}function i(t,r){return r.id&&u&&u[r.id]?_(t,r):(r=_(t,r),e.isPropertyAccessExpression(r)?a(r):e.isPropertyAssignment(r)?o(r):r)}function a(t){var r=s(t.name);return r?e.setTextRange(e.createElementAccess(t.expression,r),t):t}function o(t){var r=e.isIdentifier(t.name)&&s(t.name);return r?e.updatePropertyAssignment(t,r,t.initializer):t}function s(t){var r=t.originalKeywordKind||(e.nodeIsSynthesized(t)?e.stringToToken(e.idText(t)):void 0);return void 0!==r&&r>=74&&109>=r?e.setTextRange(e.createLiteral(t),t):void 0}var c,u,l=t.getCompilerOptions();(1===l.jsx||3===l.jsx)&&(c=t.onEmitNode,t.onEmitNode=n,t.enableEmitNotification(263),t.enableEmitNotification(264),t.enableEmitNotification(262),u=[]);var _=t.onSubstituteNode;return t.onSubstituteNode=i,t.enableSubstitution(190),t.enableSubstitution(276),e.chainBundle(r)}e.transformES5=t}(n||(n={}));var n;!function(e){function t(e){switch(e){case 2:return"return";case 3:return"break";case 4:return"yield";case 5:return"yield*";case 7:return"endfinally";default:return void 0}}function r(r){function i(t){if(t.isDeclarationFile||0===(256&t.transformFlags))return t;var n=e.visitEachChild(t,a,r);return e.addEmitHelpers(n,r.readEmitHelpers()),n}function a(t){var n=t.transformFlags;return Or?o(t):Ir?s(t):e.isFunctionLikeDeclaration(t)&&t.asteriskToken?u(t):256&n?e.visitEachChild(t,a,r):t}function o(e){switch(e.kind){case 224:return J(e);case 225:return V(e);case 233:return tt(e);case 234:return nt(e);default:return s(e)}}function s(t){switch(t.kind){case 240:return l(t);case 197:return _(t);case 159:case 160:return d(t);case 220:return f(t);case 226:return K(t);case 227:return W(t);case 230:return X(t);case 229:return G(t);case 231:return Z(t);default:return 131072&t.transformFlags?c(t):262400&t.transformFlags?e.visitEachChild(t,a,r):t}}function c(t){switch(t.kind){case 205:return m(t);case 206:return D(t);case 208:return S(t);case 188:return C(t);case 189:return T(t);case 191:return E(t);case 192:return N(t);case 193:return A(t);default:return e.visitEachChild(t,a,r)}}function u(t){switch(t.kind){case 240:return l(t);case 197:return _(t);default:return e.Debug.failBadSyntaxKind(t)}}function l(t){if(t.asteriskToken)t=e.setOriginalNode(e.setTextRange(e.createFunctionDeclaration(void 0,t.modifiers,void 0,t.name,void 0,e.visitParameterList(t.parameters,a,r),void 0,p(t.body)),t),t);else{var n=Ir,i=Or;Ir=!1,Or=!1,t=e.visitEachChild(t,a,r),Ir=n,Or=i}return Ir?void kr(t):t}function _(t){if(t.asteriskToken)t=e.setOriginalNode(e.setTextRange(e.createFunctionExpression(void 0,void 0,t.name,void 0,e.visitParameterList(t.parameters,a,r),void 0,p(t.body)),t),t);else{var n=Ir,i=Or;Ir=!1,Or=!1,t=e.visitEachChild(t,a,r),Ir=n,Or=i}return t}function d(t){var n=Ir,i=Or;return Ir=!1,Or=!1,t=e.visitEachChild(t,a,r),Ir=n,Or=i,t}function p(t){var r=[],n=Ir,i=Or,o=Mr,s=Lr,c=Rr,u=Br,l=jr,_=Jr,d=$r,p=zr,f=Vr,m=Ur,g=Kr;Ir=!0,Or=!1,Mr=void 0,Lr=void 0,Rr=void 0,Br=void 0,jr=void 0,Jr=void 0,$r=1,zr=void 0,Vr=void 0,Ur=void 0,Kr=e.createTempVariable(void 0),Sr();var v=e.addPrologue(r,t.statements,!1,a);F(t.statements,v);var y=nr();return e.insertStatementsAfterStandardPrologue(r,Cr()),r.push(e.createReturn(y)),Ir=n,Or=i,Mr=o,Lr=s,Rr=c,Br=u,jr=l,Jr=_,$r=d,zr=p,Vr=f,Ur=m,Kr=g,e.setTextRange(e.createBlock(r,t.multiLine),t)}function f(t){if(131072&t.transformFlags)return void L(t.declarationList);if(1048576&e.getEmitFlags(t))return t;for(var r=0,n=t.declarationList.declarations;r<n.length;r++){var i=n[r];Tr(i.name)}var a=e.getInitializedVariables(t.declarationList);return 0===a.length?void 0:e.setSourceMapRange(e.createExpressionStatement(e.inlineExpressions(e.map(a,R))),t)}function m(t){var r=e.getExpressionAssociativity(t);switch(r){case 0:return h(t);case 1:return y(t);default:return e.Debug.assertNever(r)}}function g(e){return e>=61&&72>=e}function v(e){switch(e){case 61:return 38;case 62:return 39;case 63:return 40;case 64:return 41;case 65:return 42;case 66:return 43;case 67:return 46;case 68:return 47;case 69:return 48;case 70:return 49;case 71:return 50;case 72:return 51}}function y(t){var n=t.left,i=t.right;if(ot(i)){var o=void 0;switch(n.kind){case 190:o=e.updatePropertyAccess(n,_t(e.visitNode(n.expression,a,e.isLeftHandSideExpression)),n.name);break;case 191:o=e.updateElementAccess(n,_t(e.visitNode(n.expression,a,e.isLeftHandSideExpression)),_t(e.visitNode(n.argumentExpression,a,e.isExpression)));
break;default:o=e.visitNode(n,a,e.isExpression)}var s=t.operatorToken.kind;return g(s)?e.setTextRange(e.createAssignment(o,e.setTextRange(e.createBinary(_t(o),v(s),e.visitNode(i,a,e.isExpression)),t)),t):e.updateBinary(t,o,e.visitNode(i,a,e.isExpression))}return e.visitEachChild(t,a,r)}function h(t){if(ot(t.right)){if(e.isLogicalOperator(t.operatorToken.kind))return b(t);if(27===t.operatorToken.kind)return x(t);var n=e.getMutableClone(t);return n.left=_t(e.visitNode(t.left,a,e.isExpression)),n.right=e.visitNode(t.right,a,e.isExpression),n}return e.visitEachChild(t,a,r)}function b(t){var r=pt(),n=dt();return Ht(n,e.visitNode(t.left,a,e.isExpression),t.left),54===t.operatorToken.kind?Xt(r,n,t.left):Qt(r,n,t.left),Ht(n,e.visitNode(t.right,a,e.isExpression),t.right),ft(r),n}function x(t){function r(t){e.isBinaryExpression(t)&&27===t.operatorToken.kind?(r(t.left),r(t.right)):(ot(t)&&n.length>0&&(rr(1,[e.createExpressionStatement(e.inlineExpressions(n))]),n=[]),n.push(e.visitNode(t,a,e.isExpression)))}var n=[];return r(t.left),r(t.right),e.inlineExpressions(n)}function D(t){if(ot(t.whenTrue)||ot(t.whenFalse)){var n=pt(),i=pt(),o=dt();return Xt(n,e.visitNode(t.condition,a,e.isExpression),t.condition),Ht(o,e.visitNode(t.whenTrue,a,e.isExpression),t.whenTrue),Gt(i),ft(n),Ht(o,e.visitNode(t.whenFalse,a,e.isExpression),t.whenFalse),ft(i),o}return e.visitEachChild(t,a,r)}function S(t){var n=pt(),i=e.visitNode(t.expression,a,e.isExpression);if(t.asteriskToken){var o=0===(8388608&e.getEmitFlags(t.expression))?e.createValuesHelper(r,i,t):i;Yt(o,t)}else Zt(i,t);return ft(n),Kt(t)}function C(e){return k(e.elements,void 0,void 0,e.multiLine)}function k(t,r,n,i){function o(t,n){if(ot(n)&&t.length>0){var o=void 0!==s;s||(s=dt()),Ht(s,o?e.createArrayConcat(s,[e.createArrayLiteral(t,i)]):e.createArrayLiteral(r?[r].concat(t):t,i)),r=void 0,t=[]}return t.push(e.visitNode(n,a,e.isExpression)),t}var s,c=st(t);if(c>0){s=dt();var u=e.visitNodes(t,a,e.isExpression,0,c);Ht(s,e.createArrayLiteral(r?[r].concat(u):u)),r=void 0}var l=e.reduceLeft(t,o,[],c);return s?e.createArrayConcat(s,[e.createArrayLiteral(l,i)]):e.setTextRange(e.createArrayLiteral(r?[r].concat(l):l,i),n)}function T(t){function r(r,n){ot(n)&&r.length>0&&(Wt(e.createExpressionStatement(e.inlineExpressions(r))),r=[]);var o=e.createExpressionForObjectLiteralElementLike(t,n,s),c=e.visitNode(o,a,e.isExpression);return c&&(i&&e.startOnNewLine(c),r.push(c)),r}var n=t.properties,i=t.multiLine,o=st(n),s=dt();Ht(s,e.createObjectLiteral(e.visitNodes(n,a,e.isObjectLiteralElementLike,0,o),i));var c=e.reduceLeft(n,r,[],o);return c.push(i?e.startOnNewLine(e.getMutableClone(s)):s),e.inlineExpressions(c)}function E(t){if(ot(t.argumentExpression)){var n=e.getMutableClone(t);return n.expression=_t(e.visitNode(t.expression,a,e.isLeftHandSideExpression)),n.argumentExpression=e.visitNode(t.argumentExpression,a,e.isExpression),n}return e.visitEachChild(t,a,r)}function N(t){if(!e.isImportCall(t)&&e.forEach(t.arguments,ot)){var n=e.createCallBinding(t.expression,Tr,Nr,!0),i=n.target,o=n.thisArg;return e.setOriginalNode(e.createFunctionApply(_t(e.visitNode(i,a,e.isLeftHandSideExpression)),o,k(t.arguments),t),t)}return e.visitEachChild(t,a,r)}function A(t){if(e.forEach(t.arguments,ot)){var n=e.createCallBinding(e.createPropertyAccess(t.expression,"bind"),Tr),i=n.target,o=n.thisArg;return e.setOriginalNode(e.setTextRange(e.createNew(e.createFunctionApply(_t(e.visitNode(i,a,e.isExpression)),o,k(t.arguments,e.createVoidZero())),void 0,[]),t),t)}return e.visitEachChild(t,a,r)}function F(e,t){void 0===t&&(t=0);for(var r=e.length,n=t;r>n;n++)w(e[n])}function P(t){e.isBlock(t)?F(t.statements):w(t)}function w(e){var t=Or;Or||(Or=ot(e)),I(e),Or=t}function I(t){switch(t.kind){case 219:return O(t);case 222:return M(t);case 223:return B(t);case 224:return j(t);case 225:return z(t);case 226:return U(t);case 227:return q(t);case 229:return H(t);case 230:return Q(t);case 231:return Y(t);case 232:return $(t);case 233:return et(t);case 234:return rt(t);case 235:return it(t);case 236:return at(t);default:return Wt(e.visitNode(t,a,e.isStatement))}}function O(t){ot(t)?F(t.statements):Wt(e.visitNode(t,a,e.isStatement))}function M(t){Wt(e.visitNode(t,a,e.isStatement))}function L(t){for(var r=0,n=t.declarations;r<n.length;r++){var i=n[r],a=e.getSynthesizedClone(i.name);e.setCommentRange(a,i.name),Tr(a)}for(var o=e.getInitializedVariables(t),s=o.length,c=0,u=[];s>c;){for(var l=c;s>l;l++){var i=o[l];if(ot(i.initializer)&&u.length>0)break;u.push(R(i))}u.length&&(Wt(e.createExpressionStatement(e.inlineExpressions(u))),c+=u.length,u=[])}return void 0}function R(t){return e.setSourceMapRange(e.createAssignment(e.setSourceMapRange(e.getSynthesizedClone(t.name),t.name),e.visitNode(t.initializer,a,e.isExpression)),t)}function B(t){if(ot(t))if(ot(t.thenStatement)||ot(t.elseStatement)){var r=pt(),n=t.elseStatement?pt():void 0;Xt(t.elseStatement?n:r,e.visitNode(t.expression,a,e.isExpression),t.expression),P(t.thenStatement),t.elseStatement&&(Gt(r),ft(n),P(t.elseStatement)),ft(r)}else Wt(e.visitNode(t,a,e.isStatement));else Wt(e.visitNode(t,a,e.isStatement))}function j(t){if(ot(t)){var r=pt(),n=pt();Tt(r),ft(n),P(t.statement),ft(r),Qt(n,e.visitNode(t.expression,a,e.isExpression)),Et()}else Wt(e.visitNode(t,a,e.isStatement))}function J(t){return Or?(kt(),t=e.visitEachChild(t,a,r),Et(),t):e.visitEachChild(t,a,r)}function z(t){if(ot(t)){var r=pt(),n=Tt(r);ft(r),Xt(n,e.visitNode(t.expression,a,e.isExpression)),P(t.statement),Gt(r),Et()}else Wt(e.visitNode(t,a,e.isStatement))}function V(t){return Or?(kt(),t=e.visitEachChild(t,a,r),Et(),t):e.visitEachChild(t,a,r)}function U(t){if(ot(t)){var r=pt(),n=pt(),i=Tt(n);if(t.initializer){var o=t.initializer;e.isVariableDeclarationList(o)?L(o):Wt(e.setTextRange(e.createExpressionStatement(e.visitNode(o,a,e.isExpression)),o))}ft(r),t.condition&&Xt(i,e.visitNode(t.condition,a,e.isExpression)),P(t.statement),ft(n),t.incrementor&&Wt(e.setTextRange(e.createExpressionStatement(e.visitNode(t.incrementor,a,e.isExpression)),t.incrementor)),Gt(r),Et()}else Wt(e.visitNode(t,a,e.isStatement))}function K(t){Or&&kt();var n=t.initializer;if(n&&e.isVariableDeclarationList(n)){for(var i=0,o=n.declarations;i<o.length;i++){var s=o[i];Tr(s.name)}var c=e.getInitializedVariables(n);t=e.updateFor(t,c.length>0?e.inlineExpressions(e.map(c,R)):void 0,e.visitNode(t.condition,a,e.isExpression),e.visitNode(t.incrementor,a,e.isExpression),e.visitNode(t.statement,a,e.isStatement,e.liftToBlock))}else t=e.visitEachChild(t,a,r);return Or&&Et(),t}function q(t){if(ot(t)){var r=dt(),n=dt(),i=e.createLoopVariable(),o=t.initializer;Tr(i),Ht(r,e.createArrayLiteral()),Wt(e.createForIn(n,e.visitNode(t.expression,a,e.isExpression),e.createExpressionStatement(e.createCall(e.createPropertyAccess(r,"push"),void 0,[n])))),Ht(i,e.createLiteral(0));var s=pt(),c=pt(),u=Tt(c);ft(s),Xt(u,e.createLessThan(i,e.createPropertyAccess(r,"length")));var l=void 0;if(e.isVariableDeclarationList(o)){for(var _=0,d=o.declarations;_<d.length;_++){var p=d[_];Tr(p.name)}l=e.getSynthesizedClone(o.declarations[0].name)}else l=e.visitNode(o,a,e.isExpression),e.Debug.assert(e.isLeftHandSideExpression(l));Ht(l,e.createElementAccess(r,i)),P(t.statement),ft(c),Wt(e.createExpressionStatement(e.createPostfixIncrement(i))),Gt(s),Et()}else Wt(e.visitNode(t,a,e.isStatement))}function W(t){Or&&kt();var n=t.initializer;if(e.isVariableDeclarationList(n)){for(var i=0,o=n.declarations;i<o.length;i++){var s=o[i];Tr(s.name)}t=e.updateForIn(t,n.declarations[0].name,e.visitNode(t.expression,a,e.isExpression),e.visitNode(t.statement,a,e.isStatement,e.liftToBlock))}else t=e.visitEachChild(t,a,r);return Or&&Et(),t}function H(t){var r=jt(t.label?e.idText(t.label):void 0);r>0?Gt(r,t):Wt(t)}function G(t){if(Or){var n=jt(t.label&&e.idText(t.label));if(n>0)return Vt(n,t)}return e.visitEachChild(t,a,r)}function Q(t){var r=Bt(t.label?e.idText(t.label):void 0);r>0?Gt(r,t):Wt(t)}function X(t){if(Or){var n=Bt(t.label&&e.idText(t.label));if(n>0)return Vt(n,t)}return e.visitEachChild(t,a,r)}function Y(t){$t(e.visitNode(t.expression,a,e.isExpression),t)}function Z(t){return Ut(e.visitNode(t.expression,a,e.isExpression),t)}function $(t){ot(t)?(ht(_t(e.visitNode(t.expression,a,e.isExpression))),P(t.statement),bt()):Wt(e.visitNode(t,a,e.isStatement))}function et(t){if(ot(t.caseBlock)){for(var r=t.caseBlock,n=r.clauses.length,i=At(),o=_t(e.visitNode(t.expression,a,e.isExpression)),s=[],c=-1,u=0;n>u;u++){var l=r.clauses[u];s.push(pt()),273===l.kind&&-1===c&&(c=u)}for(var _=0,d=[];n>_;){for(var p=0,u=_;n>u;u++){var l=r.clauses[u];if(272===l.kind){if(ot(l.expression)&&d.length>0)break;d.push(e.createCaseClause(e.visitNode(l.expression,a,e.isExpression),[Vt(s[u],l.expression)]))}else p++}d.length&&(Wt(e.createSwitch(o,e.createCaseBlock(d))),_+=d.length,d=[]),p>0&&(_+=p,p=0)}Gt(c>=0?s[c]:i);for(var u=0;n>u;u++)ft(s[u]),F(r.clauses[u].statements);Ft()}else Wt(e.visitNode(t,a,e.isStatement))}function tt(t){return Or&&Nt(),t=e.visitEachChild(t,a,r),Or&&Ft(),t}function rt(t){ot(t)?(wt(e.idText(t.label)),P(t.statement),It()):Wt(e.visitNode(t,a,e.isStatement))}function nt(t){return Or&&Pt(e.idText(t.label)),t=e.visitEachChild(t,a,r),Or&&It(),t}function it(t){er(e.visitNode(t.expression,a,e.isExpression),t)}function at(t){ot(t)?(xt(),P(t.tryBlock),t.catchClause&&(Dt(t.catchClause.variableDeclaration),P(t.catchClause.block)),t.finallyBlock&&(St(),P(t.finallyBlock)),Ct()):Wt(e.visitEachChild(t,a,r))}function ot(e){return!!e&&0!==(131072&e.transformFlags)}function st(e){for(var t=e.length,r=0;t>r;r++)if(ot(e[r]))return r;return-1}function ct(e,t){return t=Fr(e,t),1===e?ut(t):t}function ut(t){return e.isIdentifier(t)?lt(t):t}function lt(t){if(!e.isGeneratedIdentifier(t)&&Pr&&Pr.has(e.idText(t))){var r=e.getOriginalNode(t);if(e.isIdentifier(r)&&r.parent){var n=Ar.getReferencedValueDeclaration(r);if(n){var i=wr[e.getOriginalNodeId(n)];if(i){var a=e.getMutableClone(i);return e.setSourceMapRange(a,t),e.setCommentRange(a,t),a}}}}return t}function _t(t){var r;return e.isGeneratedIdentifier(t)||4096&e.getEmitFlags(t)?t:(r=e.createTempVariable(Tr),Ht(r,t,t),r)}function dt(t){var r=t?e.createUniqueName(t):e.createTempVariable(void 0);return Tr(r),r}function pt(){jr||(jr=[]);var e=$r;return $r++,jr[e]=-1,e}function ft(t){e.Debug.assert(void 0!==jr,"No labels were defined."),jr[t]=zr?zr.length:0}function mt(e){Mr||(Mr=[],Rr=[],Lr=[],Br=[]);var t=Rr.length;return Rr[t]=0,Lr[t]=zr?zr.length:0,Mr[t]=e,Br.push(e),t}function gt(){var t=vt();if(void 0===t)return e.Debug.fail("beginBlock was never called.");var r=Rr.length;return Rr[r]=1,Lr[r]=zr?zr.length:0,Mr[r]=t,Br.pop(),t}function vt(){return e.lastOrUndefined(Br)}function yt(){var e=vt();return e&&e.kind}function ht(e){var t=pt(),r=pt();ft(t),mt({kind:1,expression:e,startLabel:t,endLabel:r})}function bt(){e.Debug.assert(1===yt());var t=gt();ft(t.endLabel)}function xt(){var e=pt(),t=pt();return ft(e),mt({kind:0,state:0,startLabel:e,endLabel:t}),qt(),t}function Dt(t){e.Debug.assert(0===yt());var n;if(e.isGeneratedIdentifier(t.name))n=t.name,Tr(t.name);else{var i=e.idText(t.name);n=dt(i),Pr||(Pr=e.createMap(),wr=[],r.enableSubstitution(73)),Pr.set(i,!0),wr[e.getOriginalNodeId(t)]=n}var a=vt();e.Debug.assert(a.state<1);var o=a.endLabel;Gt(o);var s=pt();ft(s),a.state=1,a.catchVariable=n,a.catchLabel=s,Ht(n,e.createCall(e.createPropertyAccess(Kr,"sent"),void 0,[])),qt()}function St(){e.Debug.assert(0===yt());var t=vt();e.Debug.assert(t.state<2);var r=t.endLabel;Gt(r);var n=pt();ft(n),t.state=2,t.finallyLabel=n}function Ct(){e.Debug.assert(0===yt());var t=gt(),r=t.state;2>r?Gt(t.endLabel):tr(),ft(t.endLabel),qt(),t.state=3}function kt(){mt({kind:3,isScript:!0,breakLabel:-1,continueLabel:-1})}function Tt(e){var t=pt();return mt({kind:3,isScript:!1,breakLabel:t,continueLabel:e}),t}function Et(){e.Debug.assert(3===yt());var t=gt(),r=t.breakLabel;t.isScript||ft(r)}function Nt(){mt({kind:2,isScript:!0,breakLabel:-1})}function At(){var e=pt();return mt({kind:2,isScript:!1,breakLabel:e}),e}function Ft(){e.Debug.assert(2===yt());var t=gt(),r=t.breakLabel;t.isScript||ft(r)}function Pt(e){mt({kind:4,isScript:!0,labelText:e,breakLabel:-1})}function wt(e){var t=pt();mt({kind:4,isScript:!1,labelText:e,breakLabel:t})}function It(){e.Debug.assert(4===yt());var t=gt();t.isScript||ft(t.breakLabel)}function Ot(e){return 2===e.kind||3===e.kind}function Mt(e){return 4===e.kind}function Lt(e){return 3===e.kind}function Rt(e,t){for(var r=t;r>=0;r--){var n=Br[r];if(!Mt(n))break;if(n.labelText===e)return!0}return!1}function Bt(e){if(Br)if(e)for(var t=Br.length-1;t>=0;t--){var r=Br[t];if(Mt(r)&&r.labelText===e)return r.breakLabel;if(Ot(r)&&Rt(e,t-1))return r.breakLabel}else for(var t=Br.length-1;t>=0;t--){var r=Br[t];if(Ot(r))return r.breakLabel}return 0}function jt(e){if(Br)if(e)for(var t=Br.length-1;t>=0;t--){var r=Br[t];if(Lt(r)&&Rt(e,t-1))return r.continueLabel}else for(var t=Br.length-1;t>=0;t--){var r=Br[t];if(Lt(r))return r.continueLabel}return 0}function Jt(t){if(void 0!==t&&t>0){void 0===Jr&&(Jr=[]);var r=e.createLiteral(-1);return void 0===Jr[t]?Jr[t]=[r]:Jr[t].push(r),r}return e.createOmittedExpression()}function zt(r){var n=e.createLiteral(r);return e.addSyntheticTrailingComment(n,3,t(r)),n}function Vt(t,r){return e.Debug.assertLessThan(0,t,"Invalid label"),e.setTextRange(e.createReturn(e.createArrayLiteral([zt(3),Jt(t)])),r)}function Ut(t,r){return e.setTextRange(e.createReturn(e.createArrayLiteral(t?[zt(2),t]:[zt(2)])),r)}function Kt(t){return e.setTextRange(e.createCall(e.createPropertyAccess(Kr,"sent"),void 0,[]),t)}function qt(){rr(0)}function Wt(e){e?rr(1,[e]):qt()}function Ht(e,t,r){rr(2,[e,t],r)}function Gt(e,t){rr(3,[e],t)}function Qt(e,t,r){rr(4,[e,t],r)}function Xt(e,t,r){rr(5,[e,t],r)}function Yt(e,t){rr(7,[e],t)}function Zt(e,t){rr(6,[e],t)}function $t(e,t){rr(8,[e],t)}function er(e,t){rr(9,[e],t)}function tr(){rr(10)}function rr(e,t,r){void 0===zr&&(zr=[],Vr=[],Ur=[]),void 0===jr&&ft(pt());var n=zr.length;zr[n]=e,Vr[n]=t,Ur[n]=r}function nr(){en=0,tn=0,qr=void 0,Wr=!1,Hr=!1,Gr=void 0,Qr=void 0,Xr=void 0,Yr=void 0,Zr=void 0;var t=ir();return n(r,e.setEmitFlags(e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,Kr)],void 0,e.createBlock(t,t.length>0)),524288))}function ir(){if(zr){for(var t=0;t<zr.length;t++)dr(t);or(zr.length)}else or(0);if(Gr){var r=e.createPropertyAccess(Kr,"label"),n=e.createSwitch(r,e.createCaseBlock(Gr));return[e.startOnNewLine(n)]}return Qr?Qr:[]}function ar(){Qr&&(cr(!Wr),Wr=!1,Hr=!1,tn++)}function or(e){sr(e)&&(ur(e),Zr=void 0,gr(void 0,void 0)),Qr&&Gr&&cr(!1),lr()}function sr(e){if(!Hr)return!0;if(!jr||!Jr)return!1;for(var t=0;t<jr.length;t++)if(jr[t]===e&&Jr[t])return!0;return!1}function cr(t){if(Gr||(Gr=[]),Qr){if(Zr)for(var r=Zr.length-1;r>=0;r--){var n=Zr[r];Qr=[e.createWith(n.expression,e.createBlock(Qr))]}if(Yr){var i=Yr.startLabel,a=Yr.catchLabel,o=Yr.finallyLabel,s=Yr.endLabel;Qr.unshift(e.createExpressionStatement(e.createCall(e.createPropertyAccess(e.createPropertyAccess(Kr,"trys"),"push"),void 0,[e.createArrayLiteral([Jt(i),Jt(a),Jt(o),Jt(s)])]))),Yr=void 0}t&&Qr.push(e.createExpressionStatement(e.createAssignment(e.createPropertyAccess(Kr,"label"),e.createLiteral(tn+1))))}Gr.push(e.createCaseClause(e.createLiteral(tn),Qr||[])),Qr=void 0}function ur(e){if(jr)for(var t=0;t<jr.length;t++)jr[t]===e&&(ar(),void 0===qr&&(qr=[]),void 0===qr[tn]?qr[tn]=[t]:qr[tn].push(t))}function lr(){if(void 0!==Jr&&void 0!==qr)for(var e=0;e<qr.length;e++){var t=qr[e];if(void 0!==t)for(var r=0,n=t;r<n.length;r++){var i=n[r],a=Jr[i];if(void 0!==a)for(var o=0,s=a;o<s.length;o++){var c=s[o];c.text=String(e)}}}}function _r(e){if(Mr)for(;en<Rr.length&&Lr[en]<=e;en++){var t=Mr[en],r=Rr[en];switch(t.kind){case 0:0===r?(Xr||(Xr=[]),Qr||(Qr=[]),Xr.push(Yr),Yr=t):1===r&&(Yr=Xr.pop());break;case 1:0===r?(Zr||(Zr=[]),Zr.push(t)):1===r&&Zr.pop()}}}function dr(e){if(ur(e),_r(e),!Wr){Wr=!1,Hr=!1;var t=zr[e];if(0!==t){if(10===t)return Dr();var r=Vr[e];if(1===t)return pr(r[0]);var n=Ur[e];switch(t){case 2:return fr(r[0],r[1],n);case 3:return vr(r[0],n);case 4:return yr(r[0],r[1],n);case 5:return hr(r[0],r[1],n);case 6:return br(r[0],n);case 7:return xr(r[0],n);case 8:return gr(r[0],n);case 9:return mr(r[0],n)}}}}function pr(e){e&&(Qr?Qr.push(e):Qr=[e])}function fr(t,r,n){pr(e.setTextRange(e.createExpressionStatement(e.createAssignment(t,r)),n))}function mr(t,r){Wr=!0,Hr=!0,pr(e.setTextRange(e.createThrow(t),r))}function gr(t,r){Wr=!0,Hr=!0,pr(e.setEmitFlags(e.setTextRange(e.createReturn(e.createArrayLiteral(t?[zt(2),t]:[zt(2)])),r),384))}function vr(t,r){Wr=!0,pr(e.setEmitFlags(e.setTextRange(e.createReturn(e.createArrayLiteral([zt(3),Jt(t)])),r),384))}function yr(t,r,n){pr(e.setEmitFlags(e.createIf(r,e.setEmitFlags(e.setTextRange(e.createReturn(e.createArrayLiteral([zt(3),Jt(t)])),n),384)),1))}function hr(t,r,n){pr(e.setEmitFlags(e.createIf(e.createLogicalNot(r),e.setEmitFlags(e.setTextRange(e.createReturn(e.createArrayLiteral([zt(3),Jt(t)])),n),384)),1))}function br(t,r){Wr=!0,pr(e.setEmitFlags(e.setTextRange(e.createReturn(e.createArrayLiteral(t?[zt(4),t]:[zt(4)])),r),384))}function xr(t,r){Wr=!0,pr(e.setEmitFlags(e.setTextRange(e.createReturn(e.createArrayLiteral([zt(5),t])),r),384))}function Dr(){Wr=!0,pr(e.createReturn(e.createArrayLiteral([zt(7)])))}var Sr=r.resumeLexicalEnvironment,Cr=r.endLexicalEnvironment,kr=r.hoistFunctionDeclaration,Tr=r.hoistVariableDeclaration,Er=r.getCompilerOptions(),Nr=e.getEmitScriptTarget(Er),Ar=r.getEmitResolver(),Fr=r.onSubstituteNode;r.onSubstituteNode=ct;var Pr,wr,Ir,Or,Mr,Lr,Rr,Br,jr,Jr,zr,Vr,Ur,Kr,qr,Wr,Hr,Gr,Qr,Xr,Yr,Zr,$r=1,en=0,tn=0;return e.chainBundle(i)}function n(t,r){return t.requestEmitHelper(e.generatorHelper),e.createCall(e.getHelperName("__generator"),void 0,[e.createThis(),r])}var i;!function(e){e[e.Nop=0]="Nop",e[e.Statement=1]="Statement",e[e.Assign=2]="Assign",e[e.Break=3]="Break",e[e.BreakWhenTrue=4]="BreakWhenTrue",e[e.BreakWhenFalse=5]="BreakWhenFalse",e[e.Yield=6]="Yield",e[e.YieldStar=7]="YieldStar",e[e.Return=8]="Return",e[e.Throw=9]="Throw",e[e.Endfinally=10]="Endfinally"}(i||(i={}));var a;!function(e){e[e.Open=0]="Open",e[e.Close=1]="Close"}(a||(a={}));var o;!function(e){e[e.Exception=0]="Exception",e[e.With=1]="With",e[e.Switch=2]="Switch",e[e.Loop=3]="Loop",e[e.Labeled=4]="Labeled"}(o||(o={}));var s;!function(e){e[e.Try=0]="Try",e[e.Catch=1]="Catch",e[e.Finally=2]="Finally",e[e.Done=3]="Done"}(s||(s={}));var c;!function(e){e[e.Next=0]="Next",e[e.Throw=1]="Throw",e[e.Return=2]="Return",e[e.Break=3]="Break",e[e.Yield=4]="Yield",e[e.YieldStar=5]="YieldStar",e[e.Catch=6]="Catch",e[e.Endfinally=7]="Endfinally"}(c||(c={})),e.transformGenerators=r,e.generatorHelper={name:"typescript:generator",scoped:!1,priority:6,text:'\n            var __generator = (this && this.__generator) || function (thisArg, body) {\n                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;\n                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;\n                function verb(n) { return function (v) { return step([n, v]); }; }\n                function step(op) {\n                    if (f) throw new TypeError("Generator is already executing.");\n                    while (_) try {\n                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;\n                        if (y = 0, t) op = [op[0] & 2, t.value];\n                        switch (op[0]) {\n                            case 0: case 1: t = op; break;\n                            case 4: _.label++; return { value: op[1], done: false };\n                            case 5: _.label++; y = op[1]; op = [0]; continue;\n                            case 7: op = _.ops.pop(); _.trys.pop(); continue;\n                            default:\n                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }\n                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }\n                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }\n                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }\n                                if (t[2]) _.ops.pop();\n                                _.trys.pop(); continue;\n                        }\n                        op = body.call(thisArg, _);\n                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }\n                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };\n                }\n            };'}}(n||(n={}));var n;!function(e){function t(t){function a(t){switch(t){case e.ModuleKind.AMD:return u;case e.ModuleKind.UMD:return l;default:return c}}function o(t){if(t.isDeclarationFile||!(e.isEffectiveExternalModule(t,at)||524288&t.transformFlags||e.isJsonSourceFile(t)&&e.hasJsonModuleEmitEnabled(at)&&(at.out||at.outFile)))return t;dt=t,pt=e.collectExternalModuleInfo(t,ot,at),gt[e.getOriginalNodeId(t)]=pt;var r=a(ut),n=r(t);return dt=void 0,pt=void 0,mt=!1,e.aggregateTransformFlags(n)}function s(){return!pt.exportEquals&&e.isExternalModule(dt)?!0:!1}function c(r){rt();var i=[],a=e.getStrictOptionValue(at,"alwaysStrict")||!at.noImplicitUseStrict&&e.isExternalModule(dt),o=e.addPrologue(i,r.statements,a,m);s()&&e.append(i,K()),e.append(i,e.visitNode(pt.externalHelpersImportDeclaration,m,e.isStatement)),e.addRange(i,e.visitNodes(r.statements,m,e.isStatement,o)),f(i,!1),e.insertStatementsAfterStandardPrologue(i,nt());var c=e.updateSourceFileNode(r,e.setTextRange(e.createNodeArray(i),r.statements));return pt.hasExportStarsToExportValues&&!at.importHelpers&&e.addEmitHelper(c,n),e.addEmitHelpers(c,t.readEmitHelpers()),c}function u(r){var n=e.createIdentifier("define"),i=e.tryGetModuleNameFromFile(r,st,at),a=e.isJsonSourceFile(r)&&r,o=_(r,!0),s=o.aliasedModuleNames,c=o.unaliasedModuleNames,u=o.importAliasNames,l=e.updateSourceFileNode(r,e.setTextRange(e.createNodeArray([e.createExpressionStatement(e.createCall(n,void 0,(i?[i]:[]).concat([e.createArrayLiteral(a?e.emptyArray:[e.createLiteral("require"),e.createLiteral("exports")].concat(s,c)),a?a.statements.length?a.statements[0].expression:e.createObjectLiteral():e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,"require"),e.createParameter(void 0,void 0,void 0,"exports")].concat(u),void 0,p(r))])))]),r.statements));return e.addEmitHelpers(l,t.readEmitHelpers()),l}function l(r){var n=_(r,!1),i=n.aliasedModuleNames,a=n.unaliasedModuleNames,o=n.importAliasNames,s=e.tryGetModuleNameFromFile(r,st,at),c=e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,"factory")],void 0,e.setTextRange(e.createBlock([e.createIf(e.createLogicalAnd(e.createTypeCheck(e.createIdentifier("module"),"object"),e.createTypeCheck(e.createPropertyAccess(e.createIdentifier("module"),"exports"),"object")),e.createBlock([e.createVariableStatement(void 0,[e.createVariableDeclaration("v",void 0,e.createCall(e.createIdentifier("factory"),void 0,[e.createIdentifier("require"),e.createIdentifier("exports")]))]),e.setEmitFlags(e.createIf(e.createStrictInequality(e.createIdentifier("v"),e.createIdentifier("undefined")),e.createExpressionStatement(e.createAssignment(e.createPropertyAccess(e.createIdentifier("module"),"exports"),e.createIdentifier("v")))),1)]),e.createIf(e.createLogicalAnd(e.createTypeCheck(e.createIdentifier("define"),"function"),e.createPropertyAccess(e.createIdentifier("define"),"amd")),e.createBlock([e.createExpressionStatement(e.createCall(e.createIdentifier("define"),void 0,(s?[s]:[]).concat([e.createArrayLiteral([e.createLiteral("require"),e.createLiteral("exports")].concat(i,a)),e.createIdentifier("factory")])))])))],!0),void 0)),u=e.updateSourceFileNode(r,e.setTextRange(e.createNodeArray([e.createExpressionStatement(e.createCall(c,void 0,[e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,"require"),e.createParameter(void 0,void 0,void 0,"exports")].concat(o),void 0,p(r))]))]),r.statements));return e.addEmitHelpers(u,t.readEmitHelpers()),u}function _(t,r){for(var n=[],i=[],a=[],o=0,s=t.amdDependencies;o<s.length;o++){var c=s[o];c.name?(n.push(e.createLiteral(c.path)),a.push(e.createParameter(void 0,void 0,void 0,c.name))):i.push(e.createLiteral(c.path))}for(var u=0,l=pt.externalImports;u<l.length;u++){var _=l[u],d=e.getExternalModuleNameLiteral(_,dt,st,ot,at),p=e.getLocalNameForExternalImport(_,dt);d&&(r&&p?(e.setEmitFlags(p,4),n.push(d),a.push(e.createParameter(void 0,void 0,void 0,p))):i.push(d))}return{aliasedModuleNames:n,unaliasedModuleNames:i,importAliasNames:a}}function d(t){if(e.isImportEqualsDeclaration(t)||e.isExportDeclaration(t)||!e.getExternalModuleNameLiteral(t,dt,st,ot,at))return void 0;var r=e.getLocalNameForExternalImport(t,dt),n=S(t,r);return n===r?void 0:e.createExpressionStatement(e.createAssignment(r,n))}function p(t){rt();var r=[],a=e.addPrologue(r,t.statements,!at.noImplicitUseStrict,m);s()&&e.append(r,K()),e.append(r,e.visitNode(pt.externalHelpersImportDeclaration,m,e.isStatement)),ut===e.ModuleKind.AMD&&e.addRange(r,e.mapDefined(pt.externalImports,d)),e.addRange(r,e.visitNodes(t.statements,m,e.isStatement,a)),f(r,!0),e.insertStatementsAfterStandardPrologue(r,nt());var o=e.createBlock(r,!0);return pt.hasExportStarsToExportValues&&!at.importHelpers&&e.addEmitHelper(o,n),mt&&e.addEmitHelper(o,i),o}function f(t,r){if(pt.exportEquals){var n=e.visitNode(pt.exportEquals.expression,g);if(n)if(r){var i=e.createReturn(n);e.setTextRange(i,pt.exportEquals),e.setEmitFlags(i,1920),t.push(i)}else{var i=e.createExpressionStatement(e.createAssignment(e.createPropertyAccess(e.createIdentifier("module"),"exports"),n));e.setTextRange(i,pt.exportEquals),e.setEmitFlags(i,1536),t.push(i)}}}function m(r){switch(r.kind){case 250:return C(r);case 249:return T(r);case 256:return E(r);case 255:return N(r);case 220:return P(r);case 240:return A(r);case 241:return F(r);case 316:return O(r);case 317:return L(r);default:return e.visitEachChild(r,g,t)}}function g(r){return 524288&r.transformFlags||512&r.transformFlags?e.isImportCall(r)?h(r):e.isDestructuringAssignment(r)?y(r):e.visitEachChild(r,g,t):r}function v(t){if(e.isObjectLiteralExpression(t))for(var r=0,n=t.properties;r<n.length;r++){var i=n[r];switch(i.kind){case 276:if(v(i.initializer))return!0;break;case 277:if(v(i.name))return!0;break;case 278:if(v(i.expression))return!0;break;case 157:case 159:case 160:return!1;default:e.Debug.assertNever(i,"Unhandled object member kind")}}else if(e.isArrayLiteralExpression(t))for(var a=0,o=t.elements;a<o.length;a++){var i=o[a];if(e.isSpreadElement(i)){if(v(i.expression))return!0}else if(v(i))return!0}else if(e.isIdentifier(t))return e.length(tt(t))>(e.isExportName(t)?1:0);return!1}function y(r){return v(r.left)?e.flattenDestructuringAssignment(r,g,t,0,!1,w):e.visitEachChild(r,g,t)}function h(t){var r=e.visitNode(e.firstOrUndefined(t.arguments),g),n=!!(2048&t.transformFlags);switch(at.module){case e.ModuleKind.AMD:return x(r,n);case e.ModuleKind.UMD:return b(r,n);case e.ModuleKind.CommonJS:default:return D(r,n)}}function b(t,r){if(mt=!0,e.isSimpleCopiableExpression(t)){var n=e.isGeneratedIdentifier(t)?t:e.isStringLiteral(t)?e.createLiteral(t):e.setEmitFlags(e.setTextRange(e.getSynthesizedClone(t),t),1536);return e.createConditional(e.createIdentifier("__syncRequire"),D(t,r),x(n,r))}var i=e.createTempVariable(it);return e.createComma(e.createAssignment(i,t),e.createConditional(e.createIdentifier("__syncRequire"),D(i,r),x(i,r)))}function x(r,n){var i,a=e.createUniqueName("resolve"),o=e.createUniqueName("reject"),s=[e.createParameter(void 0,void 0,void 0,a),e.createParameter(void 0,void 0,void 0,o)],c=e.createBlock([e.createExpressionStatement(e.createCall(e.createIdentifier("require"),void 0,[e.createArrayLiteral([r||e.createOmittedExpression()]),a,o]))]);ct>=2?i=e.createArrowFunction(void 0,void 0,s,void 0,void 0,c):(i=e.createFunctionExpression(void 0,void 0,void 0,void 0,s,void 0,c),n&&e.setEmitFlags(i,8));var u=e.createNew(e.createIdentifier("Promise"),void 0,[i]);return at.esModuleInterop?(t.requestEmitHelper(e.importStarHelper),e.createCall(e.createPropertyAccess(u,e.createIdentifier("then")),void 0,[e.getHelperName("__importStar")])):u}function D(r,n){var i=e.createCall(e.createPropertyAccess(e.createIdentifier("Promise"),"resolve"),void 0,[]),a=e.createCall(e.createIdentifier("require"),void 0,r?[r]:[]);at.esModuleInterop&&(t.requestEmitHelper(e.importStarHelper),a=e.createCall(e.getHelperName("__importStar"),void 0,[a]));var o;return ct>=2?o=e.createArrowFunction(void 0,void 0,[],void 0,void 0,a):(o=e.createFunctionExpression(void 0,void 0,void 0,void 0,[],void 0,e.createBlock([e.createReturn(a)])),n&&e.setEmitFlags(o,8)),e.createCall(e.createPropertyAccess(i,"then"),void 0,[o])}function S(r,n){return!at.esModuleInterop||67108864&e.getEmitFlags(r)?n:e.getImportNeedsImportStarHelper(r)?(t.requestEmitHelper(e.importStarHelper),e.createCall(e.getHelperName("__importStar"),void 0,[n])):e.getImportNeedsImportDefaultHelper(r)?(t.requestEmitHelper(e.importDefaultHelper),e.createCall(e.getHelperName("__importDefault"),void 0,[n])):n}function C(t){var r,n=e.getNamespaceDeclarationNode(t);if(ut!==e.ModuleKind.AMD){if(!t.importClause)return e.setOriginalNode(e.setTextRange(e.createExpressionStatement(k(t)),t),t);var i=[];n&&!e.isDefaultImport(t)?i.push(e.createVariableDeclaration(e.getSynthesizedClone(n.name),void 0,S(t,k(t)))):(i.push(e.createVariableDeclaration(e.getGeneratedNameForNode(t),void 0,S(t,k(t)))),n&&e.isDefaultImport(t)&&i.push(e.createVariableDeclaration(e.getSynthesizedClone(n.name),void 0,e.getGeneratedNameForNode(t)))),r=e.append(r,e.setOriginalNode(e.setTextRange(e.createVariableStatement(void 0,e.createVariableDeclarationList(i,ct>=2?2:0)),t),t))}else n&&e.isDefaultImport(t)&&(r=e.append(r,e.createVariableStatement(void 0,e.createVariableDeclarationList([e.setOriginalNode(e.setTextRange(e.createVariableDeclaration(e.getSynthesizedClone(n.name),void 0,e.getGeneratedNameForNode(t)),t),t)],ct>=2?2:0))));if(M(t)){var a=e.getOriginalNodeId(t);vt[a]=R(vt[a],t)}else r=R(r,t);return e.singleOrMany(r)}function k(t){var r=e.getExternalModuleNameLiteral(t,dt,st,ot,at),n=[];return r&&n.push(r),e.createCall(e.createIdentifier("require"),void 0,n)}function T(t){e.Debug.assert(e.isExternalModuleImportEqualsDeclaration(t),"import= for internal module references should be handled in an earlier transformer.");var r;if(ut!==e.ModuleKind.AMD?r=e.hasModifier(t,1)?e.append(r,e.setOriginalNode(e.setTextRange(e.createExpressionStatement(W(t.name,k(t))),t),t)):e.append(r,e.setOriginalNode(e.setTextRange(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.getSynthesizedClone(t.name),void 0,k(t))],ct>=2?2:0)),t),t)):e.hasModifier(t,1)&&(r=e.append(r,e.setOriginalNode(e.setTextRange(e.createExpressionStatement(W(e.getExportName(t),e.getLocalName(t))),t),t))),M(t)){var n=e.getOriginalNodeId(t);vt[n]=B(vt[n],t)}else r=B(r,t);return e.singleOrMany(r)}function E(n){if(!n.moduleSpecifier)return void 0;var i=e.getGeneratedNameForNode(n);if(n.exportClause){var a=[];ut!==e.ModuleKind.AMD&&a.push(e.setOriginalNode(e.setTextRange(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(i,void 0,k(n))])),n),n));for(var o=0,s=n.exportClause.elements;o<s.length;o++){var c=s[o],u=e.createPropertyAccess(i,c.propertyName||c.name);a.push(e.setOriginalNode(e.setTextRange(e.createExpressionStatement(W(e.getExportName(c),u)),c),c))}return e.singleOrMany(a)
}return e.setOriginalNode(e.setTextRange(e.createExpressionStatement(r(t,ut!==e.ModuleKind.AMD?k(n):i)),n),n)}function N(t){if(t.isExportEquals)return void 0;var r,n=t.original;if(n&&M(n)){var i=e.getOriginalNodeId(t);vt[i]=U(vt[i],e.createIdentifier("default"),e.visitNode(t.expression,g),t,!0)}else r=U(r,e.createIdentifier("default"),e.visitNode(t.expression,g),t,!0);return e.singleOrMany(r)}function A(r){var n;if(n=e.hasModifier(r,1)?e.append(n,e.setOriginalNode(e.setTextRange(e.createFunctionDeclaration(void 0,e.visitNodes(r.modifiers,H,e.isModifier),r.asteriskToken,e.getDeclarationName(r,!0,!0),void 0,e.visitNodes(r.parameters,g),void 0,e.visitEachChild(r.body,g,t)),r),r)):e.append(n,e.visitEachChild(r,g,t)),M(r)){var i=e.getOriginalNodeId(r);vt[i]=z(vt[i],r)}else n=z(n,r);return e.singleOrMany(n)}function F(r){var n;if(n=e.hasModifier(r,1)?e.append(n,e.setOriginalNode(e.setTextRange(e.createClassDeclaration(void 0,e.visitNodes(r.modifiers,H,e.isModifier),e.getDeclarationName(r,!0,!0),void 0,e.visitNodes(r.heritageClauses,g),e.visitNodes(r.members,g)),r),r)):e.append(n,e.visitEachChild(r,g,t)),M(r)){var i=e.getOriginalNodeId(r);vt[i]=z(vt[i],r)}else n=z(n,r);return e.singleOrMany(n)}function P(r){var n,i,a;if(e.hasModifier(r,1)){for(var o=void 0,s=0,c=r.declarationList.declarations;s<c.length;s++){var u=c[s];e.isIdentifier(u.name)&&e.isLocalName(u.name)?(o||(o=e.visitNodes(r.modifiers,H,e.isModifier)),i=e.append(i,u)):u.initializer&&(a=e.append(a,I(u)))}i&&(n=e.append(n,e.updateVariableStatement(r,o,e.updateVariableDeclarationList(r.declarationList,i)))),a&&(n=e.append(n,e.setOriginalNode(e.setTextRange(e.createExpressionStatement(e.inlineExpressions(a)),r),r)))}else n=e.append(n,e.visitEachChild(r,g,t));if(M(r)){var l=e.getOriginalNodeId(r);vt[l]=j(vt[l],r)}else n=j(n,r);return e.singleOrMany(n)}function w(t,r,n){var i=tt(t);if(i){for(var a=e.isExportName(t)?r:e.createAssignment(t,r),o=0,s=i;o<s.length;o++){var c=s[o];e.setEmitFlags(a,4),a=W(c,a,n)}return a}return e.createAssignment(t,r)}function I(r){return e.isBindingPattern(r.name)?e.flattenDestructuringAssignment(e.visitNode(r,g),void 0,t,0,!1,w):e.createAssignment(e.setTextRange(e.createPropertyAccess(e.createIdentifier("exports"),r.name),r.name),e.visitNode(r.initializer,g))}function O(t){if(M(t)&&220===t.original.kind){var r=e.getOriginalNodeId(t);vt[r]=j(vt[r],t.original)}return t}function M(t){return 0!==(4194304&e.getEmitFlags(t))}function L(t){var r=e.getOriginalNodeId(t),n=vt[r];return n?(delete vt[r],e.append(n,t)):t}function R(e,t){if(pt.exportEquals)return e;var r=t.importClause;if(!r)return e;r.name&&(e=V(e,r));var n=r.namedBindings;if(n)switch(n.kind){case 252:e=V(e,n);break;case 253:for(var i=0,a=n.elements;i<a.length;i++){var o=a[i];e=V(e,o)}}return e}function B(e,t){return pt.exportEquals?e:V(e,t)}function j(e,t){if(pt.exportEquals)return e;for(var r=0,n=t.declarationList.declarations;r<n.length;r++){var i=n[r];e=J(e,i)}return e}function J(t,r){if(pt.exportEquals)return t;if(e.isBindingPattern(r.name))for(var n=0,i=r.name.elements;n<i.length;n++){var a=i[n];e.isOmittedExpression(a)||(t=J(t,a))}else e.isGeneratedIdentifier(r.name)||(t=V(t,r));return t}function z(t,r){if(pt.exportEquals)return t;if(e.hasModifier(r,1)){var n=e.hasModifier(r,512)?e.createIdentifier("default"):e.getDeclarationName(r);t=U(t,n,e.getLocalName(r),r)}return r.name&&(t=V(t,r)),t}function V(t,r){var n=e.getDeclarationName(r),i=pt.exportSpecifiers.get(e.idText(n));if(i)for(var a=0,o=i;a<o.length;a++){var s=o[a];t=U(t,s.name,n,s.name)}return t}function U(t,r,n,i,a){return t=e.append(t,q(r,n,i,a))}function K(){var t;return t=e.createExpressionStatement(0===ct?W(e.createIdentifier("__esModule"),e.createLiteral(!0)):e.createCall(e.createPropertyAccess(e.createIdentifier("Object"),"defineProperty"),void 0,[e.createIdentifier("exports"),e.createLiteral("__esModule"),e.createObjectLiteral([e.createPropertyAssignment("value",e.createLiteral(!0))])])),e.setEmitFlags(t,1048576),t}function q(t,r,n,i){var a=e.setTextRange(e.createExpressionStatement(W(t,r)),n);return e.startOnNewLine(a),i||e.setEmitFlags(a,1536),a}function W(t,r,n){return e.setTextRange(e.createAssignment(e.createPropertyAccess(e.createIdentifier("exports"),e.getSynthesizedClone(t)),r),n)}function H(e){switch(e.kind){case 86:case 81:return void 0}return e}function G(t,r,n){285===r.kind?(dt=r,pt=gt[e.getOriginalNodeId(dt)],ft=[],_t(t,r,n),dt=void 0,pt=void 0,ft=void 0):_t(t,r,n)}function Q(t,r){return r=lt(t,r),r.id&&ft[r.id]?r:1===t?Y(r):e.isShorthandPropertyAssignment(r)?X(r):r}function X(t){var r=t.name,n=Z(r);if(n!==r){if(t.objectAssignmentInitializer){var i=e.createAssignment(n,t.objectAssignmentInitializer);return e.setTextRange(e.createPropertyAssignment(r,i),t)}return e.setTextRange(e.createPropertyAssignment(r,n),t)}return t}function Y(e){switch(e.kind){case 73:return Z(e);case 205:return $(e);case 204:case 203:return et(e)}return e}function Z(t){if(4096&e.getEmitFlags(t)){var r=e.getExternalHelpersModuleName(dt);return r?e.createPropertyAccess(r,t):t}if(!e.isGeneratedIdentifier(t)&&!e.isLocalName(t)){var n=ot.getReferencedExportContainer(t,e.isExportName(t));if(n&&285===n.kind)return e.setTextRange(e.createPropertyAccess(e.createIdentifier("exports"),e.getSynthesizedClone(t)),t);var i=ot.getReferencedImportDeclaration(t);if(i){if(e.isImportClause(i))return e.setTextRange(e.createPropertyAccess(e.getGeneratedNameForNode(i.parent),e.createIdentifier("default")),t);if(e.isImportSpecifier(i)){var a=i.propertyName||i.name;return e.setTextRange(e.createPropertyAccess(e.getGeneratedNameForNode(i.parent.parent.parent),e.getSynthesizedClone(a)),t)}}}return t}function $(t){if(e.isAssignmentOperator(t.operatorToken.kind)&&e.isIdentifier(t.left)&&!e.isGeneratedIdentifier(t.left)&&!e.isLocalName(t.left)&&!e.isDeclarationNameOfEnumOrNamespace(t.left)){var r=tt(t.left);if(r){for(var n=t,i=0,a=r;i<a.length;i++){var o=a[i];ft[e.getNodeId(n)]=!0,n=W(o,n,t)}return n}}return t}function et(t){if(!(44!==t.operator&&45!==t.operator||!e.isIdentifier(t.operand)||e.isGeneratedIdentifier(t.operand)||e.isLocalName(t.operand)||e.isDeclarationNameOfEnumOrNamespace(t.operand))){var r=tt(t.operand);if(r){for(var n=204===t.kind?e.setTextRange(e.createBinary(t.operand,e.createToken(44===t.operator?61:62),e.createLiteral(1)),t):t,i=0,a=r;i<a.length;i++){var o=a[i];ft[e.getNodeId(n)]=!0,n=W(o,n)}return n}}return t}function tt(t){if(!e.isGeneratedIdentifier(t)){var r=ot.getReferencedImportDeclaration(t)||ot.getReferencedValueDeclaration(t);if(r)return pt&&pt.exportedBindings[e.getOriginalNodeId(r)]}}var rt=t.startLexicalEnvironment,nt=t.endLexicalEnvironment,it=t.hoistVariableDeclaration,at=t.getCompilerOptions(),ot=t.getEmitResolver(),st=t.getEmitHost(),ct=e.getEmitScriptTarget(at),ut=e.getEmitModuleKind(at),lt=t.onSubstituteNode,_t=t.onEmitNode;t.onSubstituteNode=Q,t.onEmitNode=G,t.enableSubstitution(73),t.enableSubstitution(205),t.enableSubstitution(203),t.enableSubstitution(204),t.enableSubstitution(277),t.enableEmitNotification(285);var dt,pt,ft,mt,gt=[],vt=[];return e.chainBundle(o)}function r(t,r){var n=t.getCompilerOptions();return n.importHelpers?e.createCall(e.getHelperName("__exportStar"),void 0,[r,e.createIdentifier("exports")]):e.createCall(e.createIdentifier("__export"),void 0,[r])}e.transformModule=t;var n={name:"typescript:export-star",scoped:!0,text:"\n            function __export(m) {\n                for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];\n            }"},i={name:"typescript:dynamicimport-sync-require",scoped:!0,text:'\n            var __syncRequire = typeof module === "object" && typeof module.exports === "object";'};e.importStarHelper={name:"typescript:commonjsimportstar",scoped:!1,text:'\nvar __importStar = (this && this.__importStar) || function (mod) {\n    if (mod && mod.__esModule) return mod;\n    var result = {};\n    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];\n    result["default"] = mod;\n    return result;\n};'},e.importDefaultHelper={name:"typescript:commonjsimportdefault",scoped:!1,text:'\nvar __importDefault = (this && this.__importDefault) || function (mod) {\n    return (mod && mod.__esModule) ? mod : { "default": mod };\n};'}}(n||(n={}));var n;!function(e){function t(t){function r(t){if(t.isDeclarationFile||!(e.isEffectiveExternalModule(t,mt)||524288&t.transformFlags))return t;var r=e.getOriginalNodeId(t);bt=t,kt=t,xt=Et[r]=e.collectExternalModuleInfo(t,gt,mt),Dt=e.createUniqueName("exports"),At[r]=Dt,St=e.createUniqueName("context");var a=n(xt.externalImports),o=i(t,a),s=e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,Dt),e.createParameter(void 0,void 0,void 0,St)],void 0,o),c=e.tryGetModuleNameFromFile(t,vt,mt),u=e.createArrayLiteral(e.map(a,function(e){return e.name})),l=e.setEmitFlags(e.updateSourceFileNode(t,e.setTextRange(e.createNodeArray([e.createExpressionStatement(e.createCall(e.createPropertyAccess(e.createIdentifier("System"),"register"),void 0,c?[c,u,s]:[u,s]))]),t.statements)),1024);return mt.outFile||mt.out||e.moveEmitHelpers(l,o,function(e){return!e.scoped}),Tt&&(Ft[r]=Tt,Tt=void 0),bt=void 0,xt=void 0,Dt=void 0,St=void 0,Ct=void 0,kt=void 0,e.aggregateTransformFlags(l)}function n(t){for(var r=e.createMap(),n=[],i=0,a=t;i<a.length;i++){var o=a[i],s=e.getExternalModuleNameLiteral(o,bt,vt,gt,mt);if(s){var c=s.text,u=r.get(c);void 0!==u?n[u].externalImports.push(o):(r.set(c,n.length),n.push({name:s,externalImports:[o]}))}}return n}function i(t,r){var n=[];dt();var i=e.getStrictOptionValue(mt,"alwaysStrict")||!mt.noImplicitUseStrict&&e.isExternalModule(bt),o=e.addPrologue(n,t.statements,i,c);n.push(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration("__moduleName",void 0,e.createLogicalAnd(St,e.createPropertyAccess(St,"id")))]))),e.visitNode(xt.externalHelpersImportDeclaration,c,e.isStatement);var u=e.visitNodes(t.statements,c,e.isStatement,o);e.addRange(n,Ct),e.insertStatementsAfterStandardPrologue(n,pt());var l=a(n),_=e.createObjectLiteral([e.createPropertyAssignment("setters",s(l,r)),e.createPropertyAssignment("execute",e.createFunctionExpression(void 0,void 0,void 0,void 0,[],void 0,e.createBlock(u,!0)))]);return _.multiLine=!0,n.push(e.createReturn(_)),e.createBlock(n,!0)}function a(t){if(xt.hasExportStarsToExportValues){if(!xt.exportedNames&&0===xt.exportSpecifiers.size){for(var r=!1,n=0,i=xt.externalImports;n<i.length;n++){var a=i[n];if(256===a.kind&&a.exportClause){r=!0;break}}if(!r){var s=o(void 0);return t.push(s),s.name}}var c=[];if(xt.exportedNames)for(var u=0,l=xt.exportedNames;u<l.length;u++){var _=l[u];"default"!==_.escapedText&&c.push(e.createPropertyAssignment(e.createLiteral(_),e.createTrue()))}for(var d=0,p=xt.externalImports;d<p.length;d++){var a=p[d];if(256===a.kind&&a.exportClause)for(var f=0,m=a.exportClause.elements;f<m.length;f++){var g=m[f];c.push(e.createPropertyAssignment(e.createLiteral(e.idText(g.name||g.propertyName)),e.createTrue()))}}var v=e.createUniqueName("exportedNames");t.push(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(v,void 0,e.createObjectLiteral(c,!0))])));var y=o(v);return t.push(y),y.name}}function o(t){var r=e.createUniqueName("exportStar"),n=e.createIdentifier("m"),i=e.createIdentifier("n"),a=e.createIdentifier("exports"),o=e.createStrictInequality(i,e.createLiteral("default"));return t&&(o=e.createLogicalAnd(o,e.createLogicalNot(e.createCall(e.createPropertyAccess(t,"hasOwnProperty"),void 0,[i])))),e.createFunctionDeclaration(void 0,void 0,void 0,r,void 0,[e.createParameter(void 0,void 0,void 0,n)],void 0,e.createBlock([e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(a,void 0,e.createObjectLiteral([]))])),e.createForIn(e.createVariableDeclarationList([e.createVariableDeclaration(i,void 0)]),n,e.createBlock([e.setEmitFlags(e.createIf(o,e.createExpressionStatement(e.createAssignment(e.createElementAccess(a,i),e.createElementAccess(n,i)))),1)])),e.createExpressionStatement(e.createCall(Dt,void 0,[a]))],!0))}function s(t,r){for(var n=[],i=0,a=r;i<a.length;i++){for(var o=a[i],s=e.forEach(o.externalImports,function(t){return e.getLocalNameForExternalImport(t,bt)}),c=s?e.getGeneratedNameForNode(s):e.createUniqueName(""),u=[],l=0,_=o.externalImports;l<_.length;l++){var d=_[l],p=e.getLocalNameForExternalImport(d,bt);switch(d.kind){case 250:if(!d.importClause)break;case 249:e.Debug.assert(void 0!==p),u.push(e.createExpressionStatement(e.createAssignment(p,c)));break;case 256:if(e.Debug.assert(void 0!==p),d.exportClause){for(var f=[],m=0,g=d.exportClause.elements;m<g.length;m++){var v=g[m];f.push(e.createPropertyAssignment(e.createLiteral(e.idText(v.name)),e.createElementAccess(c,e.createLiteral(e.idText(v.propertyName||v.name)))))}u.push(e.createExpressionStatement(e.createCall(Dt,void 0,[e.createObjectLiteral(f,!0)])))}else u.push(e.createExpressionStatement(e.createCall(t,void 0,[c])))}}n.push(e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,c)],void 0,e.createBlock(u,!0)))}return e.createArrayLiteral(n,!0)}function c(e){switch(e.kind){case 250:return u(e);case 249:return l(e);case 256:return void 0;case 255:return _(e);default:return I(e)}}function u(t){var r;if(t.importClause&&ft(e.getLocalNameForExternalImport(t,bt)),D(t)){var n=e.getOriginalNodeId(t);Nt[n]=C(Nt[n],t)}else r=C(r,t);return e.singleOrMany(r)}function l(t){e.Debug.assert(e.isExternalModuleImportEqualsDeclaration(t),"import= for internal module references should be handled in an earlier transformer.");var r;if(ft(e.getLocalNameForExternalImport(t,bt)),D(t)){var n=e.getOriginalNodeId(t);Nt[n]=k(Nt[n],t)}else r=k(r,t);return e.singleOrMany(r)}function _(t){if(t.isExportEquals)return void 0;var r=e.visitNode(t.expression,X,e.isExpression),n=t.original;if(!n||!D(n))return P(e.createIdentifier("default"),r,!0);var i=e.getOriginalNodeId(t);Nt[i]=F(Nt[i],e.createIdentifier("default"),r,!0)}function d(r){if(Ct=e.hasModifier(r,1)?e.append(Ct,e.updateFunctionDeclaration(r,r.decorators,e.visitNodes(r.modifiers,et,e.isModifier),r.asteriskToken,e.getDeclarationName(r,!0,!0),void 0,e.visitNodes(r.parameters,X,e.isParameterDeclaration),void 0,e.visitNode(r.body,X,e.isBlock))):e.append(Ct,e.visitEachChild(r,X,t)),D(r)){var n=e.getOriginalNodeId(r);Nt[n]=N(Nt[n],r)}else Ct=N(Ct,r);return void 0}function p(t){var r,n=e.getLocalName(t);if(ft(n),r=e.append(r,e.setTextRange(e.createExpressionStatement(e.createAssignment(n,e.setTextRange(e.createClassExpression(void 0,t.name,void 0,e.visitNodes(t.heritageClauses,X,e.isHeritageClause),e.visitNodes(t.members,X,e.isClassElement)),t))),t)),D(t)){var i=e.getOriginalNodeId(t);Nt[i]=N(Nt[i],t)}else r=N(r,t);return e.singleOrMany(r)}function f(t){if(!g(t.declarationList))return e.visitNode(t,X,e.isStatement);for(var r,n=e.hasModifier(t,1),i=D(t),a=0,o=t.declarationList.declarations;a<o.length;a++){var s=o[a];s.initializer?r=e.append(r,v(s,n&&!i)):m(s)}var c;if(r&&(c=e.append(c,e.setTextRange(e.createExpressionStatement(e.inlineExpressions(r)),t))),i){var u=e.getOriginalNodeId(t);Nt[u]=T(Nt[u],t,n)}else c=T(c,t,!1);return e.singleOrMany(c)}function m(t){if(e.isBindingPattern(t.name))for(var r=0,n=t.name.elements;r<n.length;r++){var i=n[r];e.isOmittedExpression(i)||m(i)}else ft(e.getSynthesizedClone(t.name))}function g(t){return 0===(2097152&e.getEmitFlags(t))&&(285===kt.kind||0===(3&e.getOriginalNode(t).flags))}function v(r,n){var i=n?y:h;return e.isBindingPattern(r.name)?e.flattenDestructuringAssignment(r,X,t,0,!1,i):r.initializer?i(r.name,e.visitNode(r.initializer,X,e.isExpression)):r.name}function y(e,t,r){return b(e,t,r,!0)}function h(e,t,r){return b(e,t,r,!1)}function b(t,r,n,i){return ft(e.getSynthesizedClone(t)),i?w(t,lt(e.setTextRange(e.createAssignment(t,r),n))):lt(e.setTextRange(e.createAssignment(t,r),n))}function x(t){if(D(t)&&220===t.original.kind){var r=e.getOriginalNodeId(t),n=e.hasModifier(t.original,1);Nt[r]=T(Nt[r],t.original,n)}return t}function D(t){return 0!==(4194304&e.getEmitFlags(t))}function S(t){var r=e.getOriginalNodeId(t),n=Nt[r];if(n)return delete Nt[r],e.append(n,t);var i=e.getOriginalNode(t);return e.isModuleOrEnumDeclaration(i)?e.append(A(n,i),t):t}function C(e,t){if(xt.exportEquals)return e;var r=t.importClause;if(!r)return e;r.name&&(e=A(e,r));var n=r.namedBindings;if(n)switch(n.kind){case 252:e=A(e,n);break;case 253:for(var i=0,a=n.elements;i<a.length;i++){var o=a[i];e=A(e,o)}}return e}function k(e,t){return xt.exportEquals?e:A(e,t)}function T(e,t,r){if(xt.exportEquals)return e;for(var n=0,i=t.declarationList.declarations;n<i.length;n++){var a=i[n];(a.initializer||r)&&(e=E(e,a,r))}return e}function E(t,r,n){if(xt.exportEquals)return t;if(e.isBindingPattern(r.name))for(var i=0,a=r.name.elements;i<a.length;i++){var o=a[i];e.isOmittedExpression(o)||(t=E(t,o,n))}else if(!e.isGeneratedIdentifier(r.name)){var s=void 0;n&&(t=F(t,r.name,e.getLocalName(r)),s=e.idText(r.name)),t=A(t,r,s)}return t}function N(t,r){if(xt.exportEquals)return t;var n;if(e.hasModifier(r,1)){var i=e.hasModifier(r,512)?e.createLiteral("default"):r.name;t=F(t,i,e.getLocalName(r)),n=e.getTextOfIdentifierOrLiteral(i)}return r.name&&(t=A(t,r,n)),t}function A(t,r,n){if(xt.exportEquals)return t;var i=e.getDeclarationName(r),a=xt.exportSpecifiers.get(e.idText(i));if(a)for(var o=0,s=a;o<s.length;o++){var c=s[o];c.name.escapedText!==n&&(t=F(t,c.name,i))}return t}function F(t,r,n,i){return t=e.append(t,P(r,n,i))}function P(t,r,n){var i=e.createExpressionStatement(w(t,r));return e.startOnNewLine(i),n||e.setEmitFlags(i,1536),i}function w(t,r){var n=e.isIdentifier(t)?e.createLiteral(t):t;return e.setEmitFlags(r,1536|e.getEmitFlags(r)),e.setCommentRange(e.createCall(Dt,void 0,[n,r]),r)}function I(e){switch(e.kind){case 220:return f(e);case 240:return d(e);case 241:return p(e);case 226:return O(e);case 227:return M(e);case 228:return L(e);case 224:return j(e);case 225:return J(e);case 234:return z(e);case 232:return V(e);case 233:return U(e);case 247:return K(e);case 272:return q(e);case 273:return W(e);case 236:return H(e);case 275:return G(e);case 219:return Q(e);case 316:return x(e);case 317:return S(e);default:return X(e)}}function O(t){var r=kt;return kt=t,t=e.updateFor(t,t.initializer&&B(t.initializer),e.visitNode(t.condition,X,e.isExpression),e.visitNode(t.incrementor,X,e.isExpression),e.visitNode(t.statement,I,e.isStatement)),kt=r,t}function M(t){var r=kt;return kt=t,t=e.updateForIn(t,B(t.initializer),e.visitNode(t.expression,X,e.isExpression),e.visitNode(t.statement,I,e.isStatement,e.liftToBlock)),kt=r,t}function L(t){var r=kt;return kt=t,t=e.updateForOf(t,t.awaitModifier,B(t.initializer),e.visitNode(t.expression,X,e.isExpression),e.visitNode(t.statement,I,e.isStatement,e.liftToBlock)),kt=r,t}function R(t){return e.isVariableDeclarationList(t)&&g(t)}function B(r){if(R(r)){for(var n=void 0,i=0,a=r.declarations;i<a.length;i++){var o=a[i];n=e.append(n,v(o,!1)),o.initializer||m(o)}return n?e.inlineExpressions(n):e.createOmittedExpression()}return e.visitEachChild(r,I,t)}function j(t){return e.updateDo(t,e.visitNode(t.statement,I,e.isStatement,e.liftToBlock),e.visitNode(t.expression,X,e.isExpression))}function J(t){return e.updateWhile(t,e.visitNode(t.expression,X,e.isExpression),e.visitNode(t.statement,I,e.isStatement,e.liftToBlock))}function z(t){return e.updateLabel(t,t.label,e.visitNode(t.statement,I,e.isStatement,e.liftToBlock))}function V(t){return e.updateWith(t,e.visitNode(t.expression,X,e.isExpression),e.visitNode(t.statement,I,e.isStatement,e.liftToBlock))}function U(t){return e.updateSwitch(t,e.visitNode(t.expression,X,e.isExpression),e.visitNode(t.caseBlock,I,e.isCaseBlock))}function K(t){var r=kt;return kt=t,t=e.updateCaseBlock(t,e.visitNodes(t.clauses,I,e.isCaseOrDefaultClause)),kt=r,t}function q(t){return e.updateCaseClause(t,e.visitNode(t.expression,X,e.isExpression),e.visitNodes(t.statements,I,e.isStatement))}function W(r){return e.visitEachChild(r,I,t)}function H(r){return e.visitEachChild(r,I,t)}function G(t){var r=kt;return kt=t,t=e.updateCatchClause(t,t.variableDeclaration,e.visitNode(t.block,I,e.isBlock)),kt=r,t}function Q(r){var n=kt;return kt=r,r=e.visitEachChild(r,I,t),kt=n,r}function X(r){return e.isDestructuringAssignment(r)?Z(r):e.isImportCall(r)?Y(r):512&r.transformFlags||524288&r.transformFlags?e.visitEachChild(r,X,t):r}function Y(t){return e.createCall(e.createPropertyAccess(St,e.createIdentifier("import")),void 0,e.some(t.arguments)?[e.visitNode(t.arguments[0],X)]:[])}function Z(r){return $(r.left)?e.flattenDestructuringAssignment(r,X,t,0,!0):e.visitEachChild(r,X,t)}function $(t){if(e.isAssignmentExpression(t,!0))return $(t.left);if(e.isSpreadElement(t))return $(t.expression);if(e.isObjectLiteralExpression(t))return e.some(t.properties,$);if(e.isArrayLiteralExpression(t))return e.some(t.elements,$);if(e.isShorthandPropertyAssignment(t))return $(t.name);if(e.isPropertyAssignment(t))return $(t.initializer);if(e.isIdentifier(t)){var r=gt.getReferencedExportContainer(t);return void 0!==r&&285===r.kind}return!1}function et(e){switch(e.kind){case 86:case 81:return void 0}return e}function tt(t,r,n){if(285===r.kind){var i=e.getOriginalNodeId(r);bt=r,xt=Et[i],Dt=At[i],Tt=Ft[i],Tt&&delete Ft[i],ht(t,r,n),bt=void 0,xt=void 0,Dt=void 0,Tt=void 0}else ht(t,r,n)}function rt(e,t){return t=yt(e,t),_t(t)?t:1===e?at(t):4===e?nt(t):t}function nt(e){switch(e.kind){case 277:return it(e)}return e}function it(t){var r=t.name;if(!e.isGeneratedIdentifier(r)&&!e.isLocalName(r)){var n=gt.getReferencedImportDeclaration(r);if(n){if(e.isImportClause(n))return e.setTextRange(e.createPropertyAssignment(e.getSynthesizedClone(r),e.createPropertyAccess(e.getGeneratedNameForNode(n.parent),e.createIdentifier("default"))),t);if(e.isImportSpecifier(n))return e.setTextRange(e.createPropertyAssignment(e.getSynthesizedClone(r),e.createPropertyAccess(e.getGeneratedNameForNode(n.parent.parent.parent),e.getSynthesizedClone(n.propertyName||n.name))),t)}}return t}function at(e){switch(e.kind){case 73:return ot(e);case 205:return st(e);case 203:case 204:return ct(e)}return e}function ot(t){if(4096&e.getEmitFlags(t)){var r=e.getExternalHelpersModuleName(bt);return r?e.createPropertyAccess(r,t):t}if(!e.isGeneratedIdentifier(t)&&!e.isLocalName(t)){var n=gt.getReferencedImportDeclaration(t);if(n){if(e.isImportClause(n))return e.setTextRange(e.createPropertyAccess(e.getGeneratedNameForNode(n.parent),e.createIdentifier("default")),t);if(e.isImportSpecifier(n))return e.setTextRange(e.createPropertyAccess(e.getGeneratedNameForNode(n.parent.parent.parent),e.getSynthesizedClone(n.propertyName||n.name)),t)}}return t}function st(t){if(e.isAssignmentOperator(t.operatorToken.kind)&&e.isIdentifier(t.left)&&!e.isGeneratedIdentifier(t.left)&&!e.isLocalName(t.left)&&!e.isDeclarationNameOfEnumOrNamespace(t.left)){var r=ut(t.left);if(r){for(var n=t,i=0,a=r;i<a.length;i++){var o=a[i];n=w(o,lt(n))}return n}}return t}function ct(t){if(!(44!==t.operator&&45!==t.operator||!e.isIdentifier(t.operand)||e.isGeneratedIdentifier(t.operand)||e.isLocalName(t.operand)||e.isDeclarationNameOfEnumOrNamespace(t.operand))){var r=ut(t.operand);if(r){for(var n=204===t.kind?e.setTextRange(e.createPrefix(t.operator,t.operand),t):t,i=0,a=r;i<a.length;i++){var o=a[i];n=w(o,lt(n))}return 204===t.kind&&(n=44===t.operator?e.createSubtract(lt(n),e.createLiteral(1)):e.createAdd(lt(n),e.createLiteral(1))),n}}return t}function ut(t){var r;if(!e.isGeneratedIdentifier(t)){var n=gt.getReferencedImportDeclaration(t)||gt.getReferencedValueDeclaration(t);if(n){var i=gt.getReferencedExportContainer(t,!1);i&&285===i.kind&&(r=e.append(r,e.getDeclarationName(n))),r=e.addRange(r,xt&&xt.exportedBindings[e.getOriginalNodeId(n)])}}return r}function lt(t){return void 0===Tt&&(Tt=[]),Tt[e.getNodeId(t)]=!0,t}function _t(e){return Tt&&e.id&&Tt[e.id]}var dt=t.startLexicalEnvironment,pt=t.endLexicalEnvironment,ft=t.hoistVariableDeclaration,mt=t.getCompilerOptions(),gt=t.getEmitResolver(),vt=t.getEmitHost(),yt=t.onSubstituteNode,ht=t.onEmitNode;t.onSubstituteNode=rt,t.onEmitNode=tt,t.enableSubstitution(73),t.enableSubstitution(277),t.enableSubstitution(205),t.enableSubstitution(203),t.enableSubstitution(204),t.enableEmitNotification(285);var bt,xt,Dt,St,Ct,kt,Tt,Et=[],Nt=[],At=[],Ft=[];return e.chainBundle(r)}e.transformSystemModule=t}(n||(n={}));var n;!function(e){function t(t){function r(r){if(r.isDeclarationFile)return r;if(e.isExternalModule(r)||c.isolatedModules){var i=e.getOrCreateExternalHelpersModuleNameIfNeeded(r,c);if(i){var a=[],o=e.addPrologue(a,r.statements),s=e.createImportDeclaration(void 0,void 0,e.createImportClause(void 0,e.createNamespaceImport(i)),e.createLiteral(e.externalHelpersModuleNameText));return e.addEmitFlags(s,67108864),e.append(a,s),e.addRange(a,e.visitNodes(r.statements,n,e.isStatement,o)),e.updateSourceFileNode(r,e.setTextRange(e.createNodeArray(a),r.statements))}return e.visitEachChild(r,n,t)}return r}function n(e){switch(e.kind){case 249:return void 0;case 255:return i(e)}return e}function i(e){return e.isExportEquals?void 0:e}function a(t,r,n){e.isSourceFile(r)?(_=r,u(t,r,n),_=void 0):u(t,r,n)}function o(t,r){return r=l(t,r),e.isIdentifier(r)&&1===t?s(r):r}function s(t){if(4096&e.getEmitFlags(t)){var r=e.getExternalHelpersModuleName(_);if(r)return e.createPropertyAccess(r,t)}return t}var c=t.getCompilerOptions(),u=t.onEmitNode,l=t.onSubstituteNode;t.onEmitNode=a,t.onSubstituteNode=o,t.enableEmitNotification(285),t.enableSubstitution(73);var _;return e.chainBundle(r)}e.transformES2015Module=t}(n||(n={}));var n;!function(e){function t(t){return e.isVariableDeclaration(t)||e.isPropertyDeclaration(t)||e.isPropertySignature(t)||e.isBindingElement(t)||e.isSetAccessor(t)||e.isGetAccessor(t)||e.isConstructSignatureDeclaration(t)||e.isCallSignatureDeclaration(t)||e.isMethodDeclaration(t)||e.isMethodSignature(t)||e.isFunctionDeclaration(t)||e.isParameter(t)||e.isTypeParameterDeclaration(t)||e.isExpressionWithTypeArguments(t)||e.isImportEqualsDeclaration(t)||e.isTypeAliasDeclaration(t)||e.isConstructorDeclaration(t)||e.isIndexSignatureDeclaration(t)||e.isPropertyAccessExpression(t)}function r(t){function r(e){var r=i(e);return void 0!==r?{diagnosticMessage:r,errorNode:t,typeName:t.name}:void 0}function i(r){return e.hasModifier(t,32)?r.errorModuleName?2===r.accessibility?e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1:241===t.parent.kind?r.errorModuleName?2===r.accessibility?e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1:r.errorModuleName?e.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1}function a(e){var r=o(e);return void 0!==r?{diagnosticMessage:r,errorNode:t,typeName:t.name}:void 0}function o(r){return e.hasModifier(t,32)?r.errorModuleName?2===r.accessibility?e.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_private_name_1:241===t.parent.kind?r.errorModuleName?2===r.accessibility?e.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_private_name_1:r.errorModuleName?e.Diagnostics.Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Method_0_of_exported_interface_has_or_is_using_private_name_1}return e.isSetAccessor(t)||e.isGetAccessor(t)?r:e.isMethodSignature(t)||e.isMethodDeclaration(t)?a:n(t)}function n(t){function r(r){return 238===t.kind||187===t.kind?r.errorModuleName?2===r.accessibility?e.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Exported_variable_0_has_or_is_using_private_name_1:155===t.kind||190===t.kind||154===t.kind||152===t.kind&&e.hasModifier(t.parent,8)?e.hasModifier(t,32)?r.errorModuleName?2===r.accessibility?e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1:241===t.parent.kind||152===t.kind?r.errorModuleName?2===r.accessibility?e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1:r.errorModuleName?e.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1:void 0}function n(e){var n=r(e);return void 0!==n?{diagnosticMessage:n,errorNode:t,typeName:t.name}:void 0}function i(r){var n;return n=160===t.kind?e.hasModifier(t,32)?r.errorModuleName?e.Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1:r.errorModuleName?e.Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1:e.hasModifier(t,32)?r.errorModuleName?2===r.accessibility?e.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1:r.errorModuleName?2===r.accessibility?e.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1,{diagnosticMessage:n,errorNode:t.name,typeName:t.name}}function a(r){var n;switch(t.kind){case 162:n=r.errorModuleName?e.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 161:n=r.errorModuleName?e.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 163:n=r.errorModuleName?e.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0;
break;case 157:case 156:n=e.hasModifier(t,32)?r.errorModuleName?2===r.accessibility?e.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:e.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0:241===t.parent.kind?r.errorModuleName?2===r.accessibility?e.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:e.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0:r.errorModuleName?e.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0;break;case 240:n=r.errorModuleName?2===r.accessibility?e.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:e.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_exported_function_has_or_is_using_private_name_0;break;default:return e.Debug.fail("This is unknown kind for signature: "+t.kind)}return{diagnosticMessage:n,errorNode:t.name||t}}function o(e){var r=s(e);return void 0!==r?{diagnosticMessage:r,errorNode:t,typeName:t.name}:void 0}function s(r){switch(t.parent.kind){case 158:return r.errorModuleName?2===r.accessibility?e.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1;case 162:case 167:return r.errorModuleName?e.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;case 161:return r.errorModuleName?e.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;case 163:return r.errorModuleName?e.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1;case 157:case 156:return e.hasModifier(t.parent,32)?r.errorModuleName?2===r.accessibility?e.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:241===t.parent.parent.kind?r.errorModuleName?2===r.accessibility?e.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:r.errorModuleName?e.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;case 240:case 166:return r.errorModuleName?2===r.accessibility?e.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_private_name_1;default:return e.Debug.fail("Unknown parent for parameter: "+e.SyntaxKind[t.parent.kind])}}function c(){var r;switch(t.parent.kind){case 241:r=e.Diagnostics.Type_parameter_0_of_exported_class_has_or_is_using_private_name_1;break;case 242:r=e.Diagnostics.Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1;break;case 182:r=e.Diagnostics.Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1;break;case 167:case 162:r=e.Diagnostics.Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;break;case 161:r=e.Diagnostics.Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;break;case 157:case 156:r=e.hasModifier(t.parent,32)?e.Diagnostics.Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:241===t.parent.parent.kind?e.Diagnostics.Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:e.Diagnostics.Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;break;case 166:case 240:r=e.Diagnostics.Type_parameter_0_of_exported_function_has_or_is_using_private_name_1;break;case 243:r=e.Diagnostics.Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1;break;default:return e.Debug.fail("This is unknown parent for type parameter: "+t.parent.kind)}return{diagnosticMessage:r,errorNode:t,typeName:t.name}}function u(){var r;return r=241===t.parent.parent.kind?e.isHeritageClause(t.parent)&&110===t.parent.token?e.Diagnostics.Implements_clause_of_exported_class_0_has_or_is_using_private_name_1:e.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1:e.Diagnostics.extends_clause_of_exported_interface_0_has_or_is_using_private_name_1,{diagnosticMessage:r,errorNode:t,typeName:e.getNameOfDeclaration(t.parent.parent)}}function l(){return{diagnosticMessage:e.Diagnostics.Import_declaration_0_is_using_private_name_1,errorNode:t,typeName:t.name}}function _(){return{diagnosticMessage:e.Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1,errorNode:t.type,typeName:t.name}}return e.isVariableDeclaration(t)||e.isPropertyDeclaration(t)||e.isPropertySignature(t)||e.isPropertyAccessExpression(t)||e.isBindingElement(t)||e.isConstructorDeclaration(t)?n:e.isSetAccessor(t)||e.isGetAccessor(t)?i:e.isConstructSignatureDeclaration(t)||e.isCallSignatureDeclaration(t)||e.isMethodDeclaration(t)||e.isMethodSignature(t)||e.isFunctionDeclaration(t)||e.isIndexSignatureDeclaration(t)?a:e.isParameter(t)?e.isParameterPropertyDeclaration(t)&&e.hasModifier(t.parent,8)?n:o:e.isTypeParameterDeclaration(t)?c:e.isExpressionWithTypeArguments(t)?u:e.isImportEqualsDeclaration(t)?l:e.isTypeAliasDeclaration(t)?_:e.Debug.assertNever(t,"Attempted to set a declaration diagnostic context for unhandled node kind: "+e.SyntaxKind[t.kind])}e.canProduceDiagnostics=t,e.createGetSymbolAccessibilityDiagnosticForNodeName=r,e.createGetSymbolAccessibilityDiagnosticForNode=n}(n||(n={}));var n;!function(e){function t(t,r,n){if(n&&e.isSourceFileJS(n))return[];var a=t.getCompilerOptions(),o=e.transformNodes(r,t,a,n?[n]:e.filter(t.getSourceFiles(),e.isSourceFileNotJS),[i],!1);return o.diagnostics}function r(t,r){var n=r.text.substring(t.pos,t.end);return e.stringContains(n,"@internal")}function n(t,n){var i=e.getParseTreeNode(t);if(i&&152===i.kind){var a=i.parent.parameters.indexOf(i),o=a>0?i.parent.parameters[a-1]:void 0,s=n.text,c=o?e.concatenate(e.getTrailingCommentRanges(s,e.skipTrivia(s,o.end+1,!1,!0)),e.getLeadingCommentRanges(s,t.pos)):e.getTrailingCommentRanges(s,e.skipTrivia(s,t.pos,!1,!0));return c&&c.length&&r(e.last(c),n)}var u=i&&e.getLeadingCommentRangesOfNode(i,n);return!!e.forEach(u,function(e){return r(e,n)})}function i(t){function r(t){if(t){nt=nt||e.createMap();for(var r=0,n=t;r<n.length;r++){var i=n[r];nt.set(i,!0)}}}function i(t,n){var i=xt.getTypeReferenceDirectivesForSymbol(n,67108863);if(e.length(i))return r(i);var a=e.getSourceFileOfNode(t);lt.set(""+e.getOriginalNodeId(a),a)}function p(r){if(0===r.accessibility){if(r&&r.aliasesToMakeVisible)if(it)for(var n=0,i=r.aliasesToMakeVisible;n<i.length;n++){var a=i[n];e.pushIfUnique(it,a)}else it=r.aliasesToMakeVisible}else{var o=pt(r);o&&t.addDiagnostic(o.typeName?e.createDiagnosticForNode(r.errorNode||o.errorNode,o.diagnosticMessage,e.getTextOfNode(o.typeName),r.errorSymbolName,r.errorModuleName):e.createDiagnosticForNode(r.errorNode||o.errorNode,o.diagnosticMessage,r.errorSymbolName,r.errorModuleName))}}function f(e){mt||(st||(st=[])).push(e)}function m(e,t,n){262144&e.flags||(p(xt.isSymbolAccessible(e,t,n,!0)),r(xt.getTypeReferenceDirectivesForSymbol(e,n)))}function g(r){ct&&t.addDiagnostic(e.createDiagnosticForNode(ct,e.Diagnostics.Property_0_of_exported_class_expression_may_not_be_private_or_protected,r))}function v(){ct&&t.addDiagnostic(e.createDiagnosticForNode(ct,e.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary,e.declarationNameToString(ct),"unique symbol"))}function y(){ct&&t.addDiagnostic(e.createDiagnosticForNode(ct,e.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary,e.declarationNameToString(ct),"this"))}function h(r){ct&&t.addDiagnostic(e.createDiagnosticForNode(ct,e.Diagnostics.The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary,e.declarationNameToString(ct),r))}function b(n){function i(){return e.map(e.arrayFrom(_t.keys()),function(e){return{fileName:e,pos:-1,end:-1}})}function a(){return nt?e.mapDefined(e.arrayFrom(nt.keys()),o):[]}function o(t){if(v)for(var r=0,n=v;r<n.length;r++){var i=n[r];if(e.isImportEqualsDeclaration(i)&&e.isExternalModuleReference(i.moduleReference)){var a=i.moduleReference.expression;if(e.isStringLiteralLike(a)&&a.text===t)return void 0}else if(e.isImportDeclaration(i)&&e.isStringLiteral(i.moduleSpecifier)&&i.moduleSpecifier.text===t)return void 0}return{fileName:t,pos:-1,end:-1}}function s(t,r){return function(i){var a;if(i.isDeclarationFile)a=i.fileName;else{if(mt&&e.contains(n.sourceFiles,i))return;var o=e.getOutputPathsFor(i,ht,!0);a=o.declarationFilePath||o.jsFilePath||i.fileName}if(a){var s=e.getRelativePathToDirectoryOrUrl(r,a,ht.getCurrentDirectory(),ht.getCanonicalFileName,!1);if(e.startsWith(s,"./")&&e.hasExtension(s)&&(s=s.substring(2)),e.startsWith(s,"node_modules/")||-1!==s.indexOf("/node_modules/"))return;t.push({pos:-1,end:-1,fileName:s})}}}if(285===n.kind&&(n.isDeclarationFile||e.isSourceFileJS(n)))return n;if(286===n.kind){mt=!0,lt=e.createMap(),_t=e.createMap();var c=!1,u=e.createBundle(e.map(n.sourceFiles,function(r){if(r.isDeclarationFile||e.isSourceFileJS(r))return void 0;if(c=c||r.hasNoDefaultLib,ut=r,rt=r,it=void 0,ot=!1,at=e.createMap(),pt=dt,vt=!1,yt=!1,x(r,lt),D(r,_t),e.isExternalModule(r)){gt=!1,ft=!1;var n=e.visitNodes(r.statements,U),i=e.updateSourceFileNode(r,[e.createModuleDeclaration([],[e.createModifier(126)],e.createLiteral(e.getResolvedExternalModuleName(t.getEmitHost(),r)),e.createModuleBlock(e.setTextRange(e.createNodeArray(B(n)),r.statements)))],!0,[],[],!1,[]);return i}ft=!0;var a=e.visitNodes(r.statements,U);return e.updateSourceFileNode(r,B(a),!0,[],[],!1,[])}),e.mapDefined(n.prepends,function(t){if(288===t.kind){var n=e.createUnparsedSourceFile(t,"dts",kt);return c=c||!!n.hasNoDefaultLib,x(n,lt),r(n.typeReferenceDirectives),D(n,_t),n}return t}));u.syntheticFileReferences=[],u.syntheticTypeReferences=a(),u.syntheticLibReferences=i(),u.hasNoDefaultLib=c;var l=e.getDirectoryPath(e.normalizeSlashes(e.getOutputPathsFor(n,ht,!0).declarationFilePath)),_=s(u.syntheticFileReferences,l);return lt.forEach(_),u}ft=!0,vt=!1,yt=!1,rt=n,ut=n,pt=dt,mt=!1,gt=!1,ot=!1,it=void 0,at=e.createMap(),nt=void 0,lt=x(ut,e.createMap()),_t=D(ut,e.createMap());var d=[],p=e.getDirectoryPath(e.normalizeSlashes(e.getOutputPathsFor(n,ht,!0).declarationFilePath)),f=s(d,p),m=e.visitNodes(n.statements,U),g=e.setTextRange(e.createNodeArray(B(m)),n.statements);lt.forEach(f);var v=e.filter(g,e.isAnyImportSyntax);e.isExternalModule(n)&&(!gt||vt&&!yt)&&(g=e.setTextRange(e.createNodeArray(g.concat([e.createExportDeclaration(void 0,void 0,e.createNamedExports([]),void 0)])),g));var y=e.updateSourceFileNode(n,g,!0,d,a(),n.hasNoDefaultLib,i());return y.exportedModulesFromDeclarationEmit=st,y}function x(t,r){return Ct||!e.isUnparsedSource(t)&&e.isSourceFileJS(t)?r:(e.forEach(t.referencedFiles,function(n){var i=e.tryResolveScriptReference(ht,t,n);i&&r.set(""+e.getOriginalNodeId(i),i)}),r)}function D(t,r){return e.forEach(t.libReferenceDirectives,function(e){var t=ht.getLibFileFromReference(e);t&&r.set(e.fileName.toLocaleLowerCase(),!0)}),r}function S(t){function r(t){return 211===t.kind?t:e.updateBindingElement(t,t.dotDotDotToken,t.propertyName,S(t.name),k(t)?t.initializer:void 0)}return 73===t.kind?t:186===t.kind?e.updateArrayBindingPattern(t,e.visitNodes(t.elements,r)):e.updateObjectBindingPattern(t,e.visitNodes(t.elements,r))}function C(t,r){var n;ot||(n=pt,pt=e.createGetSymbolAccessibilityDiagnosticForNode(t));var i=e.updateParameter(t,void 0,o(t,r),t.dotDotDotToken,S(t.name),xt.isOptionalParameter(t)?t.questionToken||e.createToken(56):void 0,E(t,t.type,!0),T(t));return ot||(pt=n),i}function k(t){return u(t)&&xt.isLiteralConstDeclaration(e.getParseTreeNode(t))}function T(t){return k(t)?xt.createLiteralConstValue(e.getParseTreeNode(t),bt):void 0}function E(t,r,n){function i(t){return ct=void 0,ot||(pt=o),t||e.createKeywordTypeNode(121)}if((n||!e.hasModifier(t,8))&&!k(t)){var a=152===t.kind&&(xt.isRequiredInitializedParameter(t)||xt.isOptionalUninitializedParameterProperty(t));if(r&&!a)return e.visitNode(r,z);if(!e.getParseTreeNode(t))return r?e.visitNode(r,z):e.createKeywordTypeNode(121);if(160===t.kind)return e.createKeywordTypeNode(121);ct=t.name;var o;return ot||(o=pt,pt=e.createGetSymbolAccessibilityDiagnosticForNode(t)),i(238===t.kind||187===t.kind?xt.createTypeOfDeclaration(t,rt,d,bt):152===t.kind||155===t.kind||154===t.kind?t.initializer?xt.createTypeOfDeclaration(t,rt,d,bt,a)||xt.createTypeOfExpression(t.initializer,rt,d,bt):xt.createTypeOfDeclaration(t,rt,d,bt,a):xt.createReturnTypeOfSignatureDeclaration(t,rt,d,bt))}}function N(t){switch(t=e.getParseTreeNode(t),t.kind){case 240:case 245:case 242:case 241:case 243:case 244:return!xt.isDeclarationVisible(t);case 238:return!A(t);case 249:case 250:case 256:case 255:return!1}return!1}function A(t){return e.isOmittedExpression(t)?!1:e.isBindingPattern(t.name)?e.some(t.name.elements,A):xt.isDeclarationVisible(t)}function F(t,r,n){if(e.hasModifier(t,8))return void 0;var i=e.map(r,function(e){return C(e,n)});return i?e.createNodeArray(i,r.hasTrailingComma):void 0}function P(t,r){return e.hasModifier(t,8)?void 0:e.visitNodes(r,z)}function w(t){return e.isSourceFile(t)||e.isTypeAliasDeclaration(t)||e.isModuleDeclaration(t)||e.isClassDeclaration(t)||e.isInterfaceDeclaration(t)||e.isFunctionLike(t)||e.isIndexSignatureDeclaration(t)||e.isMappedTypeNode(t)}function I(e,t){var n=xt.isEntityNameVisible(e,t);p(n),r(xt.getTypeReferenceDirectivesForEntityName(e))}function O(t,r){return e.hasJSDocNodes(t)&&e.hasJSDocNodes(r)&&(t.jsDoc=r.jsDoc),e.setCommentRange(t,e.getCommentRange(r))}function M(r,n){if(!n)return void 0;if(gt=gt||245!==r.kind&&184!==r.kind,e.isStringLiteralLike(n))if(mt){var i=e.getExternalModuleNameFromDeclaration(t.getEmitHost(),xt,r);if(i)return e.createLiteral(i)}else{var a=xt.getSymbolOfExternalModuleSpecifier(n);a&&(st||(st=[])).push(a)}return n}function L(t){if(xt.isDeclarationVisible(t)){if(260===t.moduleReference.kind){var r=e.getExternalModuleImportEqualsDeclarationExpression(t);return e.updateImportEqualsDeclaration(t,void 0,t.modifiers,t.name,e.updateExternalModuleReference(t.moduleReference,M(t,r)))}var n=pt;return pt=e.createGetSymbolAccessibilityDiagnosticForNode(t),I(t.moduleReference,rt),pt=n,t}}function R(t){if(!t.importClause)return e.updateImportDeclaration(t,void 0,t.modifiers,t.importClause,M(t,t.moduleSpecifier));var r=t.importClause&&t.importClause.name&&xt.isDeclarationVisible(t.importClause)?t.importClause.name:void 0;if(!t.importClause.namedBindings)return r&&e.updateImportDeclaration(t,void 0,t.modifiers,e.updateImportClause(t.importClause,r,void 0),M(t,t.moduleSpecifier));if(252===t.importClause.namedBindings.kind){var n=xt.isDeclarationVisible(t.importClause.namedBindings)?t.importClause.namedBindings:void 0;return r||n?e.updateImportDeclaration(t,void 0,t.modifiers,e.updateImportClause(t.importClause,r,n),M(t,t.moduleSpecifier)):void 0}var i=e.mapDefined(t.importClause.namedBindings.elements,function(e){return xt.isDeclarationVisible(e)?e:void 0});return i&&i.length||r?e.updateImportDeclaration(t,void 0,t.modifiers,e.updateImportClause(t.importClause,r,i&&i.length?e.updateNamedImports(t.importClause.namedBindings,i):void 0),M(t,t.moduleSpecifier)):void 0}function B(t){function r(t){if(e.isLateVisibilityPaintedStatement(t)){var r=""+e.getOriginalNodeId(t);if(at.has(r)){var n=at.get(r);return at.delete(r),n&&e.isSourceFile(t.parent)&&((e.isArray(n)?e.some(n,J):J(n))&&(vt=!0),(e.isArray(n)?e.some(n,j):j(n))&&(gt=!0)),n}}return t}for(;e.length(it);){var n=it.shift();if(!e.isLateVisibilityPaintedStatement(n))return e.Debug.fail("Late replaced statement was found which is not handled by the declaration transformer!: "+(e.SyntaxKind?e.SyntaxKind[n.kind]:n.kind));var i=ft;ft=n.parent&&e.isSourceFile(n.parent)&&!(e.isExternalModule(n.parent)&&mt);var a=K(n,!0);ft=i,at.set(""+e.getOriginalNodeId(n),a)}return e.visitNodes(t,r)}function j(t){return e.isAnyImportOrReExport(t)||e.isExportAssignment(t)||e.hasModifier(t,1)}function J(t){return!(e.isAnyImportOrReExport(t)||e.isExportAssignment(t)||e.hasModifier(t,1)||e.isAmbientModule(t))}function z(r){function n(t){return t&&o&&e.hasDynamicName(r)&&G(r),w(r)&&(rt=i),o&&!ot&&(pt=a),c&&(ot=s),t===r?t:t&&e.setOriginalNode(O(t,r),r)}if(!Q(r)){if(e.isDeclaration(r)){if(N(r))return;if(e.hasDynamicName(r)&&!xt.isLateBound(e.getParseTreeNode(r)))return}if(!(e.isFunctionLike(r)&&xt.isImplementationOfOverload(r)||e.isSemicolonClassElement(r))){var i;w(r)&&(i=rt,rt=r);var a=pt;if((e.isMethodDeclaration(r)||e.isMethodSignature(r))&&e.hasModifier(r,8)){if(r.symbol&&r.symbol.declarations&&r.symbol.declarations[0]!==r)return;return n(e.createProperty(void 0,Z(r),r.name,void 0,void 0,void 0))}var o=e.canProduceDiagnostics(r);o&&!ot&&(pt=e.createGetSymbolAccessibilityDiagnosticForNode(r)),e.isTypeQueryNode(r)&&I(r.exprName,rt);var s=ot,c=(169===r.kind||182===r.kind)&&243!==r.parent.kind;if(c&&(ot=!0),_(r))switch(r.kind){case 212:(e.isEntityName(r.expression)||e.isEntityNameExpression(r.expression))&&I(r.expression,rt);var u=e.visitEachChild(r,z,t);return n(e.updateExpressionWithTypeArguments(u,e.parenthesizeTypeParameters(u.typeArguments),u.expression));case 165:I(r.typeName,rt);var u=e.visitEachChild(r,z,t);return n(e.updateTypeReferenceNode(u,u.typeName,e.parenthesizeTypeParameters(u.typeArguments)));case 162:return n(e.updateConstructSignature(r,P(r,r.typeParameters),F(r,r.parameters),E(r,r.type)));case 158:var l=e.hasModifier(r,8),d=e.createSignatureDeclaration(158,l?void 0:P(r,r.typeParameters),l?void 0:F(r,r.parameters,0),void 0);return d.modifiers=e.createNodeArray(Z(r)),n(d);case 157:var p=e.createSignatureDeclaration(156,P(r,r.typeParameters),F(r,r.parameters),E(r,r.type));return p.name=r.name,p.modifiers=e.createNodeArray(Z(r)),p.questionToken=r.questionToken,n(p);case 159:var f=et(r);return n(f);case 160:var f=et(r);return n(f);case 155:return n(e.updateProperty(r,void 0,Z(r),r.name,r.questionToken,e.hasModifier(r,8)?void 0:E(r,r.type),T(r)));case 154:return n(e.updatePropertySignature(r,Z(r),r.name,r.questionToken,e.hasModifier(r,8)?void 0:E(r,r.type),T(r)));case 156:return n(e.updateMethodSignature(r,P(r,r.typeParameters),F(r,r.parameters),E(r,r.type),r.name,r.questionToken));case 161:return n(e.updateCallSignature(r,P(r,r.typeParameters),F(r,r.parameters),E(r,r.type)));case 163:return n(e.updateIndexSignature(r,void 0,Z(r),F(r,r.parameters),e.visitNode(r.type,z)||e.createKeywordTypeNode(121)));case 238:return e.isBindingPattern(r.name)?W(r.name):(c=!0,ot=!0,n(e.updateVariableDeclaration(r,r.name,E(r,r.type),T(r))));case 151:return n(V(r)&&(r.default||r.constraint)?e.updateTypeParameterDeclaration(r,r.name,void 0,void 0):e.visitEachChild(r,z,t));case 176:var m=e.visitNode(r.checkType,z),g=e.visitNode(r.extendsType,z),v=rt;rt=r.trueType;var y=e.visitNode(r.trueType,z);rt=v;var h=e.visitNode(r.falseType,z);return n(e.updateConditionalTypeNode(r,m,g,y,h));case 166:return n(e.updateFunctionTypeNode(r,e.visitNodes(r.typeParameters,z),F(r,r.parameters),e.visitNode(r.type,z)));case 167:return n(e.updateConstructorTypeNode(r,e.visitNodes(r.typeParameters,z),F(r,r.parameters),e.visitNode(r.type,z)));case 184:return n(e.isLiteralImportTypeNode(r)?e.updateImportTypeNode(r,e.updateLiteralTypeNode(r.argument,M(r,r.argument.literal)),r.qualifier,e.visitNodes(r.typeArguments,z,e.isTypeNode),r.isTypeOf):r);default:e.Debug.assertNever(r,"Attempted to process unhandled node kind: "+e.SyntaxKind[r.kind])}return n(e.visitEachChild(r,z,t))}}}function V(t){return 157===t.parent.kind&&e.hasModifier(t.parent,8)}function U(t){if(l(t)&&!Q(t)){switch(t.kind){case 256:return e.isSourceFile(t.parent)&&(gt=!0,yt=!0),e.updateExportDeclaration(t,void 0,t.modifiers,t.exportClause,M(t,t.moduleSpecifier));case 255:if(e.isSourceFile(t.parent)&&(gt=!0,yt=!0),73===t.expression.kind)return t;var r=e.createOptimisticUniqueName("_default");pt=function(){return{diagnosticMessage:e.Diagnostics.Default_export_of_the_module_has_or_is_using_private_name_0,errorNode:t}};var n=e.createVariableDeclaration(r,xt.createTypeOfExpression(t.expression,t,d,bt),void 0),i=e.createVariableStatement(ft?[e.createModifier(126)]:[],e.createVariableDeclarationList([n],2));return[i,e.updateExportAssignment(t,t.decorators,t.modifiers,r)]}var a=K(t);return at.set(""+e.getOriginalNodeId(t),a),t}}function K(t,r){function n(r){return w(t)&&(rt=i),a&&(pt=o),245===t.kind&&(ft=s),r===t?r:r&&e.setOriginalNode(O(r,t),t)}if(!Q(t)){switch(t.kind){case 249:return L(t);case 250:return R(t)}if(!(e.isDeclaration(t)&&N(t)||e.isFunctionLike(t)&&xt.isImplementationOfOverload(t))){var i;w(t)&&(i=rt,rt=t);var a=e.canProduceDiagnostics(t),o=pt;a&&(pt=e.createGetSymbolAccessibilityDiagnosticForNode(t));var s=ft;switch(t.kind){case 243:return n(e.updateTypeAliasDeclaration(t,void 0,Z(t,r),t.name,e.visitNodes(t.typeParameters,z,e.isTypeParameterDeclaration),e.visitNode(t.type,z,e.isTypeNode)));case 242:return n(e.updateInterfaceDeclaration(t,void 0,Z(t,r),t.name,P(t,t.typeParameters),tt(t.heritageClauses),e.visitNodes(t.members,z)));case 240:var c=n(e.updateFunctionDeclaration(t,void 0,Z(t,r),void 0,t.name,P(t,t.typeParameters),F(t,t.parameters),E(t,t.type),void 0));if(c&&xt.isExpandoFunctionDeclaration(t)){var u=e.mapDefined(xt.getPropertiesOfContainerFunction(t),function(t){if(!e.isPropertyAccessExpression(t.valueDeclaration))return void 0;pt=e.createGetSymbolAccessibilityDiagnosticForNode(t.valueDeclaration);var r=xt.createTypeOfDeclaration(t.valueDeclaration,rt,d,bt);pt=o;var n=e.createVariableDeclaration(e.unescapeLeadingUnderscores(t.escapedName),r,void 0);return e.createVariableStatement(void 0,e.createVariableDeclarationList([n]))}),l=e.createModuleDeclaration(void 0,Z(t,r),t.name,e.createModuleBlock(u),16);if(!e.hasModifier(c,513))return[c,l];var _=e.createModifiersFromModifierFlags(-514&e.getModifierFlags(c)|2),p=e.updateFunctionDeclaration(c,void 0,_,void 0,c.name,c.typeParameters,c.parameters,c.type,void 0),f=e.updateModuleDeclaration(l,void 0,_,l.name,l.body),m=e.createExportAssignment(void 0,void 0,!1,l.name);return gt=!0,yt=!0,[p,f,m]}return c;case 245:ft=!1;var g=t.body;if(g&&246===g.kind){var v=e.visitNodes(g.statements,U),y=e.updateModuleBlock(g,B(v));ft=s;var h=Z(t,r);return n(e.updateModuleDeclaration(t,void 0,h,e.isExternalModuleAugmentation(t)?M(t,t.name):t.name,y))}ft=s;var h=Z(t,r);ft=!1,e.visitNode(g,U);var b=""+e.getOriginalNodeId(g),y=at.get(b);return at.delete(b),n(e.updateModuleDeclaration(t,void 0,h,t.name,y));case 241:var _=e.createNodeArray(Z(t,r)),x=P(t,t.typeParameters),D=e.getFirstConstructorWithBody(t),S=void 0;if(D){var C=pt;S=e.compact(e.flatMap(D.parameters,function(t){function r(n){for(var i,a=0,o=n.elements;a<o.length;a++){var s=o[a];e.isOmittedExpression(s)||(e.isBindingPattern(s.name)&&(i=e.concatenate(i,r(s.name))),i=i||[],i.push(e.createProperty(void 0,Z(t),s.name,void 0,E(s,void 0),void 0)))}return i}if(e.hasModifier(t,92)&&!Q(t))return pt=e.createGetSymbolAccessibilityDiagnosticForNode(t),73===t.name.kind?O(e.createProperty(void 0,Z(t),t.name,t.questionToken,E(t,t.type),T(t)),t):r(t.name)})),pt=C}var k=e.createNodeArray(e.concatenate(S,e.visitNodes(t.members,z))),A=e.getEffectiveBaseTypeNode(t);if(A&&!e.isEntityNameExpression(A.expression)&&97!==A.expression.kind){var I=t.name?e.unescapeLeadingUnderscores(t.name.escapedText):"default",j=e.createOptimisticUniqueName(I+"_base");pt=function(){return{diagnosticMessage:e.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1,errorNode:A,typeName:t.name}};var J=e.createVariableDeclaration(j,xt.createTypeOfExpression(A.expression,t,d,bt),void 0),V=e.createVariableStatement(ft?[e.createModifier(126)]:[],e.createVariableDeclarationList([J],2)),K=e.createNodeArray(e.map(t.heritageClauses,function(t){if(87===t.token){var r=pt;pt=e.createGetSymbolAccessibilityDiagnosticForNode(t.types[0]);var n=e.updateHeritageClause(t,e.map(t.types,function(t){return e.updateExpressionWithTypeArguments(t,e.visitNodes(t.typeArguments,z),j)}));return pt=r,n}return e.updateHeritageClause(t,e.visitNodes(e.createNodeArray(e.filter(t.types,function(t){return e.isEntityNameExpression(t.expression)||97===t.expression.kind})),z))}));return[V,n(e.updateClassDeclaration(t,void 0,_,t.name,x,K,k))]}var K=tt(t.heritageClauses);return n(e.updateClassDeclaration(t,void 0,_,t.name,x,K,k));case 220:return n(q(t,r));case 244:return n(e.updateEnumDeclaration(t,void 0,e.createNodeArray(Z(t,r)),t.name,e.createNodeArray(e.mapDefined(t.members,function(t){if(!Q(t)){var r=xt.getConstantValue(t);return O(e.updateEnumMember(t,t.name,void 0!==r?e.createLiteral(r):void 0),t)}}))))}return e.Debug.assertNever(t,"Unhandled top-level node in declaration emit: "+e.SyntaxKind[t.kind])}}}function q(t,r){if(e.forEach(t.declarationList.declarations,A)){var n=e.visitNodes(t.declarationList.declarations,z);if(e.length(n))return e.updateVariableStatement(t,e.createNodeArray(Z(t,r)),e.updateVariableDeclarationList(t.declarationList,n))}}function W(t){return e.flatten(e.mapDefined(t.elements,function(e){return H(e)}))}function H(t){if(211!==t.kind&&t.name){if(!A(t))return;return e.isBindingPattern(t.name)?W(t.name):e.createVariableDeclaration(t.name,E(t,void 0),void 0)}}function G(t){var r;ot||(r=pt,pt=e.createGetSymbolAccessibilityDiagnosticForNodeName(t)),ct=t.name,e.Debug.assert(xt.isLateBound(e.getParseTreeNode(t)));var n=t,i=n.name.expression;I(i,rt),ot||(pt=r),ct=void 0}function Q(e){return!!kt&&!!e&&n(e,ut)}function X(t){return e.isExportAssignment(t)||e.isExportDeclaration(t)}function Y(t){return e.isModuleBlock(t)?e.some(t.statements,X):!1}function Z(t,r){var n=e.getModifierFlags(t),i=$(t,r);return n===i?t.modifiers:e.createModifiersFromModifierFlags(i)}function $(t,r){var n=2811,i=ft&&!a(t)?2:0,o=285===t.parent.kind;return(!o||mt&&o&&e.isExternalModule(t.parent))&&(n^=2|(r||mt&&o||Y(t.parent)?0:1),i=0),s(t,n,i)}function et(t){var r=xt.getAllAccessorDeclarations(t);if(t.kind===r.firstAccessor.kind){var n=c(t);!n&&r.secondAccessor&&(n=c(r.secondAccessor),pt=e.createGetSymbolAccessibilityDiagnosticForNode(r.secondAccessor));var i=e.createProperty(void 0,o(t,void 0,r.setAccessor?0:64),t.name,t.questionToken,E(t,n),void 0),a=r.secondAccessor&&e.getLeadingCommentRangesOfNode(r.secondAccessor,ut);if(a)for(var s=function(t){if(3===t.kind){var r=ut.text.slice(t.pos+2,t.end-2),n=r.split(/\r\n?|\n/g);if(n.length>1){var a=n.slice(1),o=e.guessIndentation(a);r=[n[0]].concat(e.map(a,function(e){return e.slice(o)})).join(St)}e.addSyntheticLeadingComment(i,t.kind,r,t.hasTrailingNewLine)}},u=0,l=a;u<l.length;u++){var _=l[u];s(_)}return i}}function tt(t){return e.createNodeArray(e.filter(e.map(t,function(t){return e.updateHeritageClause(t,e.visitNodes(e.createNodeArray(e.filter(t.types,function(r){return e.isEntityNameExpression(r.expression)||87===t.token&&97===r.expression.kind})),z))}),function(e){return e.types&&!!e.types.length}))}var rt,nt,it,at,ot,st,ct,ut,lt,_t,dt=function(){return e.Debug.fail("Diagnostic emitted without context")},pt=dt,ft=!0,mt=!1,gt=!1,vt=!1,yt=!1,ht=t.getEmitHost(),bt={trackSymbol:m,reportInaccessibleThisError:y,reportInaccessibleUniqueSymbolError:v,reportPrivateInBaseOfClassExpression:g,reportLikelyUnsafeImportRequiredError:h,moduleResolverHost:ht,trackReferencedAmbientModule:i,trackExternalModuleSymbolOfImportTypeNode:f},xt=t.getEmitResolver(),Dt=t.getCompilerOptions(),St=e.getNewLineCharacter(Dt),Ct=Dt.noResolve,kt=Dt.stripInternal;return b}function a(e){return 242===e.kind?!0:!1}function o(t,r,n){return e.createModifiersFromModifierFlags(s(t,r,n))}function s(t,r,n){void 0===r&&(r=3067),void 0===n&&(n=0);var i=e.getModifierFlags(t)&r|n;return 512&i&&!(1&i)&&(i^=1),512&i&&2&i&&(i^=2),i}function c(e){return e?159===e.kind?e.type:e.parameters.length>0?e.parameters[0].type:void 0:void 0}function u(t){switch(t.kind){case 155:case 154:return!e.hasModifier(t,8);case 152:case 238:return!0}return!1}function l(e){switch(e.kind){case 240:case 245:case 249:case 242:case 241:case 243:case 244:case 220:case 250:case 256:case 255:return!0}return!1}function _(e){switch(e.kind){case 162:case 158:case 157:case 159:case 160:case 155:case 154:case 156:case 161:case 163:case 238:case 151:case 212:case 165:case 176:case 166:case 167:case 184:return!0}return!1}e.getDeclarationDiagnostics=t,e.isInternalDeclaration=n;var d=531469;e.transformDeclarations=i}(n||(n={}));var n;!function(e){function t(t){switch(t){case e.ModuleKind.ESNext:case e.ModuleKind.ES2015:return e.transformES2015Module;case e.ModuleKind.System:return e.transformSystemModule;default:return e.transformModule}}function r(e,t,r){return{scriptTransformers:n(e,t,r),declarationTransformers:i(t)}}function n(r,n,i){if(i)return e.emptyArray;var a=r.jsx,o=e.getEmitScriptTarget(r),c=e.getEmitModuleKind(r),u=[];return e.addRange(u,n&&e.map(n.before,s)),u.push(e.transformTypeScript),2===a&&u.push(e.transformJsx),8>o&&u.push(e.transformESNext),6>o&&u.push(e.transformES2019),5>o&&u.push(e.transformES2018),4>o&&u.push(e.transformES2017),3>o&&u.push(e.transformES2016),2>o&&(u.push(e.transformES2015),u.push(e.transformGenerators)),u.push(t(c)),1>o&&u.push(e.transformES5),e.addRange(u,n&&e.map(n.after,s)),u}function i(t){var r=[];return r.push(e.transformDeclarations),e.addRange(r,t&&e.map(t.afterDeclarations,c)),r}function a(t){return function(r){return e.isBundle(r)?t.transformBundle(r):t.transformSourceFile(r)}}function o(e,t){return function(r){var n=e(r);return"function"==typeof n?t(n):a(n)}}function s(t){return o(t,e.chainBundle)}function c(t){return o(t,e.identity)}function u(e,t){return t}function l(e,t,r){r(e,t)}function _(t,r,n,i,a,o){function s(t){return!t||e.isSourceFile(t)&&t.isDeclarationFile?t:V(t)}function c(t){e.Debug.assert(2>M,"Cannot modify the transformation context after transformation has completed."),N[t]|=1}function _(t){return 0!==(1&N[t.kind])&&0===(4&e.getEmitFlags(t))}function d(t,r){return e.Debug.assert(3>M,"Cannot substitute a node after the result is disposed."),r&&_(r)&&I(t,r)||r}function p(t){e.Debug.assert(2>M,"Cannot modify the transformation context after transformation has completed."),N[t]|=2
}function f(t){return 0!==(2&N[t.kind])||0!==(2&e.getEmitFlags(t))}function m(t,r,n){e.Debug.assert(3>M,"Cannot invoke TransformationResult callbacks after the result is disposed."),r&&(f(r)?O(t,r,n):n(t,r))}function g(t){e.Debug.assert(M>0,"Cannot modify the lexical environment during initialization."),e.Debug.assert(2>M,"Cannot modify the lexical environment after transformation has completed.");var r=e.setEmitFlags(e.createVariableDeclaration(t),64);k?k.push(r):k=[r]}function v(t){e.Debug.assert(M>0,"Cannot modify the lexical environment during initialization."),e.Debug.assert(2>M,"Cannot modify the lexical environment after transformation has completed."),T?T.push(t):T=[t]}function y(){e.Debug.assert(M>0,"Cannot modify the lexical environment during initialization."),e.Debug.assert(2>M,"Cannot modify the lexical environment after transformation has completed."),e.Debug.assert(!w,"Lexical environment is suspended."),A[P]=k,F[P]=T,P++,k=void 0,T=void 0}function h(){e.Debug.assert(M>0,"Cannot modify the lexical environment during initialization."),e.Debug.assert(2>M,"Cannot modify the lexical environment after transformation has completed."),e.Debug.assert(!w,"Lexical environment is already suspended."),w=!0}function b(){e.Debug.assert(M>0,"Cannot modify the lexical environment during initialization."),e.Debug.assert(2>M,"Cannot modify the lexical environment after transformation has completed."),e.Debug.assert(w,"Lexical environment is not suspended."),w=!1}function x(){e.Debug.assert(M>0,"Cannot modify the lexical environment during initialization."),e.Debug.assert(2>M,"Cannot modify the lexical environment after transformation has completed."),e.Debug.assert(!w,"Lexical environment is suspended.");var t;if((k||T)&&(T&&(t=T.slice()),k)){var r=e.createVariableStatement(void 0,e.createVariableDeclarationList(k));e.setEmitFlags(r,1048576),t?t.push(r):t=[r]}return P--,k=A[P],T=F[P],0===P&&(A=[],F=[]),t}function D(t){e.Debug.assert(M>0,"Cannot modify the transformation context during initialization."),e.Debug.assert(2>M,"Cannot modify the transformation context after transformation has completed."),e.Debug.assert(!t.scoped,"Cannot request a scoped emit helper."),E=e.append(E,t)}function S(){e.Debug.assert(M>0,"Cannot modify the transformation context during initialization."),e.Debug.assert(2>M,"Cannot modify the transformation context after transformation has completed.");var t=E;return E=void 0,t}function C(){if(3>M){for(var t=0,r=i;t<r.length;t++){var n=r[t];e.disposeEmitNodes(e.getSourceFileOfNode(e.getParseTreeNode(n)))}k=void 0,A=void 0,T=void 0,F=void 0,I=void 0,O=void 0,E=void 0,M=3}}for(var k,T,E,N=new Array(318),A=[],F=[],P=0,w=!1,I=u,O=l,M=0,L=[],R={getCompilerOptions:function(){return n},getEmitResolver:function(){return t},getEmitHost:function(){return r},startLexicalEnvironment:y,suspendLexicalEnvironment:h,resumeLexicalEnvironment:b,endLexicalEnvironment:x,hoistVariableDeclaration:g,hoistFunctionDeclaration:v,requestEmitHelper:D,readEmitHelpers:S,enableSubstitution:c,enableEmitNotification:p,isSubstitutionEnabled:_,isEmitNotificationEnabled:f,get onSubstituteNode(){return I},set onSubstituteNode(t){e.Debug.assert(1>M,"Cannot modify transformation hooks after initialization has completed."),e.Debug.assert(void 0!==t,"Value must not be 'undefined'"),I=t},get onEmitNode(){return O},set onEmitNode(t){e.Debug.assert(1>M,"Cannot modify transformation hooks after initialization has completed."),e.Debug.assert(void 0!==t,"Value must not be 'undefined'"),O=t},addDiagnostic:function(e){L.push(e)}},B=0,j=i;B<j.length;B++){var J=j[B];e.disposeEmitNodes(e.getSourceFileOfNode(e.getParseTreeNode(J)))}e.performance.mark("beforeTransform");var z=a.map(function(e){return e(R)}),V=function(e){for(var t=0,r=z;t<r.length;t++){var n=r[t];e=n(e)}return e};M=1;var U=e.map(i,o?V:s);return M=2,e.performance.mark("afterTransform"),e.performance.measure("transformTime","beforeTransform","afterTransform"),{transformed:U,substituteNode:d,emitNodeWithNotification:m,dispose:C,diagnostics:L}}var d;!function(e){e[e.Uninitialized=0]="Uninitialized",e[e.Initialized=1]="Initialized",e[e.Completed=2]="Completed",e[e.Disposed=3]="Disposed"}(d||(d={}));var p;!function(e){e[e.Substitution=1]="Substitution",e[e.EmitNotifications=2]="EmitNotifications"}(p||(p={})),e.noTransformers={scriptTransformers:e.emptyArray,declarationTransformers:e.emptyArray},e.getTransformers=r,e.noEmitSubstitution=u,e.noEmitNotification=l,e.transformNodes=_}(n||(n={}));var n;!function(e){function t(t){return e.fileExtensionIs(t,".tsbuildinfo")}function r(t,r,i,o,s,c){void 0===o&&(o=!1);var u=e.isArray(i)?i:e.getSourceFilesToEmit(t,i),l=t.getCompilerOptions();if(l.outFile||l.out){var _=t.getPrependNodes();if(u.length||_.length){var d=e.createBundle(u,_),p=r(a(d,t,o),d);if(p)return p}}else{if(!s)for(var f=0,m=u;f<m.length;f++){var g=m[f],p=r(a(g,t,o),g);if(p)return p}if(c){var v=n(t.getCompilerOptions());if(v)return r({buildInfoPath:v},void 0)}}}function n(t){var r=t.configFilePath;if(!e.isIncrementalCompilation(t))return void 0;if(t.tsBuildInfoFile)return t.tsBuildInfoFile;var n,i=t.outFile||t.out;if(i)n=e.removeFileExtension(i);else{if(!r)return void 0;var a=e.removeFileExtension(r);n=t.outDir?t.rootDir?e.resolvePath(t.outDir,e.getRelativePathFromDirectory(t.rootDir,a,!0)):e.combinePaths(t.outDir,e.getBaseFileName(a)):a}return n+".tsbuildinfo"}function i(t,r){var i=t.outFile||t.out,a=t.emitDeclarationOnly?void 0:i,s=a&&o(a,t),c=r||e.getEmitDeclarations(t)?e.removeFileExtension(i)+".d.ts":void 0,u=c&&e.getAreDeclarationMapsEnabled(t)?c+".map":void 0,l=n(t);return{jsFilePath:a,sourceMapFilePath:s,declarationFilePath:c,declarationMapPath:u,buildInfoPath:l}}function a(t,r,n){var a=r.getCompilerOptions();if(286===t.kind)return i(a,n);var c=e.getOwnEmitOutputFilePath(t.fileName,r,s(t,a)),u=e.isJsonSourceFile(t)&&0===e.comparePaths(t.fileName,c,r.getCurrentDirectory(),!r.useCaseSensitiveFileNames()),l=a.emitDeclarationOnly||u?void 0:c,_=!l||e.isJsonSourceFile(t)?void 0:o(l,a),d=e.isSourceFileJS(t),p=!n&&!e.getEmitDeclarations(a)||d?void 0:e.getDeclarationEmitOutputFilePath(t.fileName,r),f=p&&e.getAreDeclarationMapsEnabled(a)?p+".map":void 0;return{jsFilePath:l,sourceMapFilePath:_,declarationFilePath:p,declarationMapPath:f,buildInfoPath:void 0}}function o(e,t){return t.sourceMap&&!t.inlineSourceMap?e+".map":void 0}function s(t,r){if(e.isJsonSourceFile(t))return".json";if(1===r.jsx)if(e.isSourceFileJS(t)){if(e.fileExtensionIs(t.fileName,".jsx"))return".jsx"}else if(1===t.languageVariant)return".jsx";return".js"}function c(t){return t.options.rootDir||e.getDirectoryPath(e.Debug.assertDefined(t.options.configFilePath))}function u(t,r,n,i){return i?e.resolvePath(i,e.getRelativePathFromDirectory(c(r),t,n)):t}function l(t,r,n){return e.Debug.assert(!e.fileExtensionIs(t,".d.ts")&&e.hasTSFileExtension(t)),e.changeExtension(u(t,r,n,r.options.declarationDir||r.options.outDir),".d.ts")}function _(t,r,n){var i=e.fileExtensionIs(t,".json"),a=e.changeExtension(u(t,r,n,r.options.outDir),i?".json":e.fileExtensionIs(t,".tsx")&&1===r.options.jsx?".jsx":".js");return i&&0===e.comparePaths(t,a,e.Debug.assertDefined(r.options.configFilePath),n)?void 0:a}function d(t,r){var a,o=function(e){return e&&(a||(a=[])).push(e)};if(t.options.outFile||t.options.out){var s=i(t.options,!1),c=s.jsFilePath,u=s.sourceMapFilePath,d=s.declarationFilePath,p=s.declarationMapPath,f=s.buildInfoPath;o(c),o(u),o(d),o(p),o(f)}else{for(var m=0,g=t.fileNames;m<g.length;m++){var v=g[m];if(!e.fileExtensionIs(v,".d.ts")){var y=_(v,t,r);if(o(y),!e.fileExtensionIs(v,".json")&&(t.options.sourceMap&&o(y+".map"),e.getEmitDeclarations(t.options)&&e.hasTSFileExtension(v))){var h=l(v,t,r);o(h),t.options.declarationMap&&o(h+".map")}}}o(n(t.options))}return a||e.emptyArray}function p(t,r){if(t.options.outFile||t.options.out){var a=i(t.options,!1).jsFilePath;return e.Debug.assertDefined(a,"project "+t.options.configFilePath+" expected to have at least one output")}for(var o=0,s=t.fileNames;o<s.length;o++){var c=s[o];if(!e.fileExtensionIs(c,".d.ts")){var a=_(c,t,r);if(a)return a}}var u=n(t.options);return u?u:e.Debug.fail("project "+t.options.configFilePath+" expected to have at least one output")}function f(t,n,i,a,o,s){function c(t,r){var i=t.jsFilePath,a=t.sourceMapFilePath,s=t.declarationFilePath,c=t.declarationMapPath,d=t.buildInfoPath;d&&r&&e.isBundle(r)&&(b={commonSourceDirectory:n.getCommonSourceDirectory(),sourceFiles:r.sourceFiles.map(function(e){return e.fileName})}),l(r,i,a),_(r,s,c),u(b,d),!I&&T&&(o||(i&&T.push(i),a&&T.push(a),d&&T.push(d)),s&&T.push(s),c&&T.push(c))}function u(t,r){if(r&&!i&&!I){var a=n.getProgramBuildInfo();if(t||a)return n.isEmitBlocked(r)||C.noEmit?void(I=!0):void e.writeFile(n,E,r,m({bundle:t,program:a,version:e.version}),!1)}}function l(r,i,a){if(r&&!o&&i){if(i&&n.isEmitBlocked(i)||C.noEmit)return void(I=!0);var s=e.transformNodes(t,n,C,[r],D,!1),c={removeComments:C.removeComments,newLine:C.newLine,noEmitHelpers:C.noEmitHelpers,module:C.module,target:C.target,sourceMap:C.sourceMap,inlineSourceMap:C.inlineSourceMap,inlineSources:C.inlineSources,extendedDiagnostics:C.extendedDiagnostics,writeBundleFileInfo:!!b},u=h(c,{hasGlobalName:t.hasGlobalName,onEmitNode:s.emitNodeWithNotification,substituteNode:s.substituteNode});e.Debug.assert(1===s.transformed.length,"Should only see one output from the transform"),p(i,a,s.transformed[0],u,C),s.dispose(),b&&(b.js=u.bundleFileInfo)}}function _(r,i,a){if(r&&i&&!e.isInJSFile(r)){var s=e.isSourceFile(r)?[r]:r.sourceFiles,c=e.filter(s,e.isSourceFileNotJS),u=C.outFile||C.out?[e.createBundle(c,e.isSourceFile(r)?void 0:r.prepends)]:c;o&&!e.getEmitDeclarations(C)&&c.forEach(d);var l=e.transformNodes(t,n,C,u,S,!1);if(e.length(l.diagnostics))for(var _=0,f=l.diagnostics;_<f.length;_++){var m=f[_];E.add(m)}var g={removeComments:C.removeComments,newLine:C.newLine,noEmitHelpers:!0,module:C.module,target:C.target,sourceMap:C.sourceMap,inlineSourceMap:C.inlineSourceMap,extendedDiagnostics:C.extendedDiagnostics,onlyPrintJsDocStyle:!0,writeBundleFileInfo:!!b,recordInternalSection:!!b},v=h(g,{hasGlobalName:t.hasGlobalName,onEmitNode:l.emitNodeWithNotification,substituteNode:l.substituteNode}),y=!!l.diagnostics&&!!l.diagnostics.length||!!n.isEmitBlocked(i)||!!C.noEmit;if(I=I||y,(!y||o)&&(e.Debug.assert(1===l.transformed.length,"Should only see one output from the decl transform"),p(i,a,l.transformed[0],v,{sourceMap:C.declarationMap,sourceRoot:C.sourceRoot,mapRoot:C.mapRoot,extendedDiagnostics:C.extendedDiagnostics}),o&&285===l.transformed[0].kind)){var D=l.transformed[0];x=D.exportedModulesFromDeclarationEmit}l.dispose(),b&&(b.dts=v.bundleFileInfo)}}function d(r){return e.isExportAssignment(r)?void(73===r.expression.kind&&t.collectLinkedAliases(r.expression,!0)):e.isExportSpecifier(r)?void t.collectLinkedAliases(r.propertyName||r.name,!0):void e.forEachChild(r,d)}function p(t,r,i,a,o){var s,c=286===i.kind?i:void 0,u=285===i.kind?i:void 0,l=c?c.sourceFiles:[u];if(f(o,i)&&(s=e.createSourceMapGenerator(n,e.getBaseFileName(e.normalizeSlashes(t)),g(o),v(o,t,u),o)),c?a.writeBundle(c,A,s):a.writeFile(u,A,s),s){k&&k.push({inputSourceFileNames:s.getSources(),sourceMap:s.toJSON()});var _=y(o,s,t,r,u);if(_&&(A.isAtStartOfLine()||A.rawWrite(N),A.writeComment("//# sourceMappingURL="+_)),r){var d=s.toString();e.writeFile(n,E,r,d,!1,l)}}else A.writeLine();e.writeFile(n,E,t,A.getText(),!!C.emitBOM,l),A.clear()}function f(t,r){return(t.sourceMap||t.inlineSourceMap)&&(285!==r.kind||!e.fileExtensionIs(r.fileName,".json"))}function g(t){var r=e.normalizeSlashes(t.sourceRoot||"");return r?e.ensureTrailingDirectorySeparator(r):r}function v(t,r,i){if(t.sourceRoot)return n.getCommonSourceDirectory();if(t.mapRoot){var a=e.normalizeSlashes(t.mapRoot);return i&&(a=e.getDirectoryPath(e.getSourceFilePathInNewDir(i.fileName,n,a))),0===e.getRootLength(a)&&(a=e.combinePaths(n.getCommonSourceDirectory(),a)),a}return e.getDirectoryPath(e.normalizePath(r))}function y(t,r,i,a,o){if(t.inlineSourceMap){var s=r.toString(),c=e.base64encode(e.sys,s);return"data:application/json;base64,"+c}var u=e.getBaseFileName(e.normalizeSlashes(e.Debug.assertDefined(a)));if(t.mapRoot){var l=e.normalizeSlashes(t.mapRoot);return o&&(l=e.getDirectoryPath(e.getSourceFilePathInNewDir(o.fileName,n,l))),0===e.getRootLength(l)?(l=e.combinePaths(n.getCommonSourceDirectory(),l),e.getRelativePathToDirectoryOrUrl(e.getDirectoryPath(e.normalizePath(i)),e.combinePaths(l,u),n.getCurrentDirectory(),n.getCanonicalFileName,!0)):e.combinePaths(l,u)}return u}var b,x,D=a.scriptTransformers,S=a.declarationTransformers,C=n.getCompilerOptions(),k=C.sourceMap||C.inlineSourceMap||e.getAreDeclarationMapsEnabled(C)?[]:void 0,T=C.listEmittedFiles?[]:void 0,E=e.createDiagnosticCollection(),N=e.getNewLineCharacter(C,function(){return n.getNewLine()}),A=e.createTextWriter(N),F=e.performance.createTimer("printTime","beforePrint","afterPrint"),P=F.enter,w=F.exit,I=!1;return P(),r(n,c,e.getSourceFilesToEmit(n,i),o,s,!i),w(),{emitSkipped:I,diagnostics:E.getDiagnostics(),emittedFiles:T,sourceMaps:k,exportedModulesFromDeclarationEmit:x}}function m(e){return JSON.stringify(e,void 0,2)}function g(e){return JSON.parse(e)}function v(t){var r=t.sourceFiles.map(function(t){var r=e.createNode(285,0,0);return r.fileName=t,r.text="",r.statements=e.createNodeArray(),r}),n=e.Debug.assertDefined(t.js);return e.forEach(n.sources&&n.sources.prologues,function(t){var n=r[t.file];n.text=t.text,n.end=t.text.length,n.statements=e.createNodeArray(t.directives.map(function(t){var r=e.createNode(222,t.pos,t.end);return r.expression=e.createNode(10,t.expression.pos,t.expression.end),r.expression.text=t.expression.text,r}))}),r}function y(t,r,n){var a=i(t.options,!1),o=a.buildInfoPath,s=a.jsFilePath,c=a.sourceMapFilePath,u=a.declarationFilePath,l=a.declarationMapPath,_=r.readFile(e.Debug.assertDefined(o));if(!_)return o;var d=r.readFile(e.Debug.assertDefined(s));if(!d)return s;var p=c&&r.readFile(c);if(c&&!p||t.options.inlineSourceMap)return c||"inline sourcemap decoding";var y=u&&r.readFile(u);if(u&&!y)return u;var h=l&&r.readFile(l);if(l&&!h||t.options.inlineSourceMap)return l||"inline sourcemap decoding";var b=g(_);if(!b.bundle||!b.bundle.js||y&&!b.bundle.dts)return o;var x=e.createInputFiles(d,y,c,p,l,h,s,u,o,b,!0),D=[],S=e.createPrependNodes(t.projectReferences,n,function(e){return r.readFile(e)}),C=v(b.bundle),k={getPrependNodes:e.memoize(function(){return S.concat([x])}),getCanonicalFileName:r.getCanonicalFileName,getCommonSourceDirectory:function(){return b.bundle.commonSourceDirectory},getCompilerOptions:function(){return t.options},getCurrentDirectory:function(){return r.getCurrentDirectory()},getNewLine:function(){return r.getNewLine()},getSourceFile:e.returnUndefined,getSourceFileByPath:e.returnUndefined,getSourceFiles:function(){return C},getLibFileFromReference:e.notImplemented,isSourceFileFromExternalLibrary:e.returnFalse,getResolvedProjectReferenceToRedirect:e.returnUndefined,writeFile:function(t,r,n){switch(t){case s:if(d===r)return;break;case c:if(p===r)return;break;case o:var i=g(r);i.program=b.program;var a=b.bundle,_=a.js,f=a.dts,v=a.sourceFiles;return i.bundle.js.sources=_.sources,f&&(i.bundle.dts.sources=f.sources),i.bundle.sourceFiles=v,void D.push({name:t,text:m(i),writeByteOrderMark:n});case u:if(y===r)return;break;case l:if(h===r)return;break;default:e.Debug.fail("Unexpected path: "+t)}D.push({name:t,text:r,writeByteOrderMark:n})},isEmitBlocked:e.returnFalse,readFile:function(e){return r.readFile(e)},fileExists:function(e){return r.fileExists(e)},directoryExists:r.directoryExists&&function(e){return r.directoryExists(e)},useCaseSensitiveFileNames:function(){return r.useCaseSensitiveFileNames()},getProgramBuildInfo:e.returnUndefined};return f(e.notImplementedResolver,k,void 0,e.getTransformers(t.options),!1),D}function h(t,r){function n(t,r,n){switch(t){case 0:e.Debug.assert(e.isSourceFile(r),"Expected a SourceFile node.");break;case 2:e.Debug.assert(e.isIdentifier(r),"Expected an Identifier node.");break;case 1:e.Debug.assert(e.isExpression(r),"Expected an Expression node.")}switch(r.kind){case 285:return o(r);case 286:return a(r);case 287:return s(r)}return c(t,r,n,y()),h()}function i(e,t,r){return u(e,t,r,y()),h()}function a(e){return m(e,y(),void 0),h()}function o(e){return v(e,y(),void 0),h()}function s(e){return g(e,y()),h()}function c(e,t,r,n){var i=po;k(n,void 0),b(e,t,r),T(),po=i}function u(e,t,r,n){var i=po;k(n,void 0),r&&S(r),ki(C,t,e),T(),po=i}function l(){return po.getTextPosWithWriteLine?po.getTextPosWithWriteLine():po.getTextPos()}function _(t,r,n){var i=e.lastOrUndefined(Oo.sections);i&&i.kind===n?i.end=r:Oo.sections.push({pos:t,end:r,kind:n})}function d(t){if(Mo&&Oo&&io&&(e.isDeclaration(t)||e.isVariableStatement(t))&&e.isInternalDeclaration(t,io)&&"internal"!==Ro){var r=Ro;return f(po.getTextPos()),Lo=l(),Ro="internal",r}return void 0}function p(e){e&&(f(po.getTextPos()),Lo=l(),Ro=e)}function f(e){return e>Lo?(_(Lo,e,Ro),!0):!1}function m(t,r,n){var i;mo=!1;var a=po;k(r,n),ci(t),oi(t),B(t),Zn(t);for(var o=0,s=t.prepends;o<s.length;o++){var c=s[o];zi();var u=po.getTextPos(),_=Oo&&Oo.sections;if(_&&(Oo.sections=[]),b(4,c,void 0),Oo){var d=Oo.sections;Oo.sections=_,c.oldFileOfCurrentEmit?(i=Oo.sections).push.apply(i,d):(d.forEach(function(t){return e.Debug.assert(e.isBundleFileTextLike(t))}),Oo.sections.push({pos:u,end:po.getTextPos(),kind:"prepend",data:c.fileName,texts:d}))}}Lo=l();for(var p=0,m=t.sourceFiles;p<m.length;p++){var g=m[p];b(0,g,g)}if(Oo&&t.sourceFiles.length){var v=po.getTextPos();if(f(v)){var y=si(t);y&&(Oo.sources||(Oo.sources={}),Oo.sources.prologues=y);var h=R(t);h&&(Oo.sources||(Oo.sources={}),Oo.sources.helpers=h)}}T(),po=a}function g(e,t){var r=po;k(t,void 0),b(4,e,void 0),T(),po=r}function v(e,t,r){mo=!0;var n=po;k(t,r),ci(e),oi(e),b(0,e,e),T(),po=n}function y(){return fo||(fo=e.createTextWriter(Fo))}function h(){var e=fo.getText();return fo.clear(),e}function b(e,t,r){r&&S(r);var n=P(0,t);n(e,t)}function S(e){io=e,yo=void 0,ho=void 0,e&&ro(e)}function k(r,n){r&&t.omitTrailingSemicolon&&(r=e.getTrailingSemicolonOmittingWriter(r)),po=r,go=n,Bo=!po||!go}function T(){ao=[],oo=[],so=e.createMap(),co=[],uo=0,lo=[],io=void 0,yo=void 0,ho=void 0,k(void 0,void 0)}function E(){return yo||(yo=e.getLineStarts(io))}function N(e){if(void 0!==e){var t=d(e),r=P(0,e);r(4,e),p(t)}}function A(e){if(void 0!==e){var t=P(0,e);t(2,e)}}function F(e){if(void 0!==e){var t=P(0,e);t(1,e)}}function P(t,r){switch(t){case 0:if(Do!==e.noEmitNotification)return I;case 1:if(Co!==e.noEmitSubstitution)return L;case 2:if(!Ko&&285!==r.kind)return Na;case 3:if(!Bo&&285!==r.kind&&!e.isInJsonFile(r))return Ya;case 4:return O;default:return e.Debug.assertNever(t)}}function w(e,t){return P(e+1,t)}function I(e,t){var r=w(0,t);Do(e,t,r)}function O(t,r){if(0===t)return Yn(e.cast(r,e.isSourceFile));if(2===t)return W(e.cast(r,e.isIdentifier));if(3===t)return M(e.cast(r,e.isTypeParameterDeclaration));if(5===t)return e.Debug.assertNode(r,e.isEmptyStatement),vr(!0);if(4===t){if(e.isKeyword(r.kind))return qi(r,Mi);switch(r.kind){case 15:case 16:case 17:return z(r);case 287:case 281:return V(r);case 280:return U(r);case 282:case 283:return K(r);case 284:return q(r);case 73:return W(r);case 149:return H(r);case 150:return Q(r);case 151:return X(r);case 152:return Y(r);case 153:return Z(r);case 154:return $(r);case 155:return et(r);case 156:return tt(r);case 157:return rt(r);case 158:return nt(r);case 159:case 160:return it(r);case 161:return at(r);case 162:return ot(r);case 163:return st(r);case 164:return ut(r);case 165:return lt(r);case 166:return _t(r);case 295:return dt(r);case 167:return gt(r);case 168:return vt(r);case 169:return yt(r);case 170:return ht(r);case 171:return xt(r);case 172:return Dt(r);case 174:return St(r);case 175:return Ct(r);case 176:return kt(r);case 177:return Tt(r);case 178:return Et(r);case 212:return ur(r);case 179:return Nt();case 180:return At(r);case 181:return Ft(r);case 182:return Pt(r);case 183:return wt(r);case 184:return It(r);case 290:return void Ii("*");case 291:return void Ii("?");case 292:return pt(r);case 293:return ft(r);case 294:return mt(r);case 173:case 296:return bt(r);case 185:return Ot(r);case 186:return Mt(r);case 187:return Lt(r);case 217:return pr(r);case 218:return ct();case 219:return fr(r);case 220:return gr(r);case 221:return vr(!1);case 222:return yr(r);case 223:return hr(r);case 224:return xr(r);case 225:return Dr(r);case 226:return Sr(r);case 227:return Cr(r);case 228:return kr(r);case 229:return Er(r);case 230:return Nr(r);case 231:return Fr(r);case 232:return Pr(r);case 233:return wr(r);case 234:return Ir(r);case 235:return Or(r);case 236:return Mr(r);case 237:return Lr(r);case 238:return Rr(r);case 239:return Br(r);case 240:return jr(r);case 241:return Gr(r);case 242:return Xr(r);case 243:return Yr(r);case 244:return Zr(r);case 245:return $r(r);case 246:return en(r);case 247:return tn(r);case 248:return dn(r);case 249:return rn(r);case 250:return an(r);case 251:return on(r);case 252:return sn(r);case 253:return cn(r);case 254:return un(r);case 255:return ln(r);case 256:return _n(r);case 257:return pn(r);case 258:return fn(r);case 259:return;case 260:return vn(r);case 11:return Dn(r);case 263:case 266:return xn(r);case 264:case 267:return Sn(r);case 268:return kn(r);case 269:return Cn(r);case 270:return Tn(r);case 271:return En(r);case 272:return An(r);case 273:return Fn(r);case 274:return wn(r);case 275:return In(r);case 276:return On(r);case 277:return Mn(r);case 278:return Ln(r);case 279:return Rn(r);case 305:case 311:return Hn(r);case 306:case 308:case 307:case 304:return jn(r);case 301:return Jn(r);case 309:return zn(r);case 310:return Vn(r);case 303:return Un(r);case 299:return Wn(r);case 298:return qn(r);case 302:case 300:return Kn(r);case 297:return Bn(r)}if(e.isExpression(r))t=1,Co!==e.noEmitSubstitution&&(r=Co(t,r));else if(e.isToken(r))return qi(r,Ii)}if(1===t)switch(r.kind){case 8:case 9:return J(r);case 10:case 13:case 14:return z(r);case 73:return W(r);case 88:case 97:case 99:case 103:case 101:case 93:return void qi(r,Mi);case 188:return Rt(r);case 189:return Bt(r);case 190:return jt(r);case 191:return zt(r);case 192:return Vt(r);case 193:return Ut(r);case 194:return Kt(r);case 195:return qt(r);case 196:return Wt(r);case 197:return Ht(r);case 198:return Gt(r);case 199:return Xt(r);case 200:return Yt(r);case 201:return Zt(r);case 202:return $t(r);case 203:return er(r);case 204:return rr(r);case 205:return nr(r);case 206:return ir(r);case 207:return ar(r);case 208:return or(r);case 209:return sr(r);case 210:return cr(r);case 211:return;case 213:return lr(r);case 214:return _r(r);case 215:return dr(r);case 261:return yn(r);case 262:return hn(r);case 265:return bn(r);case 314:return ri(r);case 315:return ni(r)}}function M(e){N(e.name),ji(),Mi("in"),ji(),N(e.constraint)}function L(e,t){var r=w(1,t);r(e,Co(e,t))}function R(r){var n;if(Po===e.ModuleKind.None||t.noEmitHelpers)return void 0;for(var i=e.createMap(),a=0,o=r.sourceFiles;a<o.length;a++){var s=o[a],c=void 0!==e.getExternalHelpersModuleName(s),u=j(s);if(u)for(var l=0,_=u;l<_.length;l++){var d=_[l];d.scoped||c||i.get(d.name)||(i.set(d.name,!0),(n||(n=[])).push(d.name))}}return n}function B(r){var n=!1,i=286===r.kind?r:void 0;if(!i||Po!==e.ModuleKind.None){for(var a=i?i.prepends.length:0,o=i?i.sourceFiles.length+a:1,s=0;o>s;s++){var c=i?a>s?i.prepends[s]:i.sourceFiles[s-a]:r,u=e.isSourceFile(c)?c:e.isUnparsedSource(c)?void 0:io,_=t.noEmitHelpers||!!u&&void 0!==e.getExternalHelpersModuleName(u),d=(e.isSourceFile(c)||e.isUnparsedSource(c))&&!mo,p=e.isUnparsedSource(c)?c.helpers:j(c);if(p)for(var f=0,m=p;f<m.length;f++){var g=m[f];if(g.scoped){if(i)continue}else{if(_)continue;if(d){if(wo.get(g.name))continue;wo.set(g.name,!0)}}var v=l();Gi("string"==typeof g.text?g.text:g.text(ha)),Oo&&Oo.sections.push({pos:v,end:po.getTextPos(),kind:"emitHelpers",data:g.name}),n=!0}}return n}}function j(t){var r=e.getEmitHelpers(t);return r&&e.stableSort(r,e.compareEmitHelpers)}function J(e){z(e)}function z(r){var n=aa(r,t.neverAsciiEscape);!t.sourceMap&&!t.inlineSourceMap||10!==r.kind&&!e.isTemplateLiteralKind(r.kind)?Fi(n):Ai(n)}function V(e){for(var t=0,r=e.texts;t<r.length;t++){var n=r[t];zi(),N(n)}}function U(e){po.rawWrite(e.parent.text.substring(e.pos,e.end))}function K(e){var t=l();U(e),Oo&&_(t,po.getTextPos(),282===e.kind?"text":"internal")}function q(t){var r=l();if(U(t),Oo){var n=e.clone(t.section);n.pos=r,n.end=po.getTextPos(),Oo.sections.push(n)}}function W(e){var t=e.symbol?wi:Io;t(ia(e,!1),e.symbol),ki(e,e.typeArguments,53776)}function H(e){G(e.left),Ii("."),N(e.right)}function G(e){73===e.kind?F(e):N(e)}function Q(e){Ii("["),F(e.expression),Ii("]")}function X(e){N(e.name),e.constraint&&(ji(),Mi("extends"),ji(),N(e.constraint)),e.default&&(ji(),Li("="),ji(),N(e.default))}function Y(e){yi(e,e.decorators),li(e,e.modifiers),N(e.dotDotDotToken),ui(e.name,Ri),N(e.questionToken),e.parent&&295===e.parent.kind&&!e.name?N(e.type):_i(e.type),di(e.initializer,e.type?e.type.end:e.questionToken?e.questionToken.end:e.name?e.name.end:e.modifiers?e.modifiers.end:e.decorators?e.decorators.end:e.pos,e)}function Z(e){Ii("@"),F(e.expression)}function $(e){yi(e,e.decorators),li(e,e.modifiers),ui(e.name,Ji),N(e.questionToken),_i(e.type),Oi()}function et(e){yi(e,e.decorators),li(e,e.modifiers),N(e.name),N(e.questionToken),N(e.exclamationToken),_i(e.type),di(e.initializer,e.type?e.type.end:e.questionToken?e.questionToken.end:e.name.end,e),Oi()}function tt(e){oa(e),yi(e,e.decorators),li(e,e.modifiers),N(e.name),N(e.questionToken),bi(e,e.typeParameters),xi(e,e.parameters),_i(e.type),Oi(),sa(e)}function rt(e){yi(e,e.decorators),li(e,e.modifiers),N(e.asteriskToken),N(e.name),N(e.questionToken),Vr(e,Ur)}function nt(e){li(e,e.modifiers),Mi("constructor"),Vr(e,Ur)}function it(e){yi(e,e.decorators),li(e,e.modifiers),Mi(159===e.kind?"get":"set"),ji(),N(e.name),Vr(e,Ur)}function at(e){oa(e),yi(e,e.decorators),li(e,e.modifiers),bi(e,e.typeParameters),xi(e,e.parameters),_i(e.type),Oi(),sa(e)}function ot(e){oa(e),yi(e,e.decorators),li(e,e.modifiers),Mi("new"),ji(),bi(e,e.typeParameters),xi(e,e.parameters),_i(e.type),Oi(),sa(e)}function st(e){yi(e,e.decorators),li(e,e.modifiers),Ci(e,e.parameters),_i(e.type),Oi()}function ct(){Oi()}function ut(e){N(e.parameterName),ji(),Mi("is"),ji(),N(e.type)}function lt(e){N(e.typeName),hi(e,e.typeArguments)}function _t(e){oa(e),bi(e,e.typeParameters),Si(e,e.parameters),ji(),Ii("=>"),ji(),N(e.type),sa(e)}function dt(e){Mi("function"),xi(e,e.parameters),Ii(":"),N(e.type)}function pt(e){Ii("?"),N(e.type)}function ft(e){Ii("!"),N(e.type)}function mt(e){N(e.type),Ii("=")}function gt(e){oa(e),Mi("new"),ji(),bi(e,e.typeParameters),xi(e,e.parameters),ji(),Ii("=>"),ji(),N(e.type),sa(e)}function vt(e){Mi("typeof"),ji(),N(e.exprName)}function yt(t){Ii("{");var r=1&e.getEmitFlags(t)?768:32897;ki(t,t.members,524288|r),Ii("}")}function ht(e){N(e.elementType),Ii("["),Ii("]")}function bt(e){Ii("..."),N(e.type)}function xt(e){Ii("["),ki(e,e.elementTypes,528),Ii("]")}function Dt(e){N(e.type),Ii("?")}function St(e){ki(e,e.types,516)}function Ct(e){ki(e,e.types,520)}function kt(e){N(e.checkType),ji(),Mi("extends"),ji(),N(e.extendsType),ji(),Ii("?"),ji(),N(e.trueType),ji(),Ii(":"),ji(),N(e.falseType)}function Tt(e){Mi("infer"),ji(),N(e.typeParameter)}function Et(e){Ii("("),N(e.type),Ii(")")}function Nt(){Mi("this")}function At(e){Wi(e.operator,Mi),ji(),N(e.type)}function Ft(e){N(e.objectType),Ii("["),N(e.indexType),Ii("]")}function Pt(t){var r=e.getEmitFlags(t);Ii("{"),1&r?ji():(zi(),Vi()),t.readonlyToken&&(N(t.readonlyToken),134!==t.readonlyToken.kind&&Mi("readonly"),ji()),Ii("[");var n=P(0,t.typeParameter);n(3,t.typeParameter),Ii("]"),t.questionToken&&(N(t.questionToken),56!==t.questionToken.kind&&Ii("?")),Ii(":"),ji(),N(t.type),Oi(),1&r?ji():(zi(),Ui()),Ii("}")}function wt(e){F(e.literal)}function It(e){e.isTypeOf&&(Mi("typeof"),ji()),Mi("import"),Ii("("),N(e.argument),Ii(")"),e.qualifier&&(Ii("."),N(e.qualifier)),hi(e,e.typeArguments)}function Ot(e){Ii("{"),ki(e,e.elements,525136),Ii("}")}function Mt(e){Ii("["),ki(e,e.elements,524880),Ii("]")}function Lt(e){N(e.dotDotDotToken),e.propertyName&&(N(e.propertyName),Ii(":"),ji()),N(e.name),di(e.initializer,e.name.end,e)}function Rt(e){var t=e.elements,r=e.multiLine?65536:0;Ti(e,t,8914|r)}function Bt(t){e.forEach(t.properties,la);var r=65536&e.getEmitFlags(t);r&&Vi();var n=t.multiLine?65536:0,i=io.languageVersion>=1&&!e.isJsonSourceFile(io)?64:0;ki(t,t.properties,526226|i|n),r&&Ui()}function jt(t){var r=!1,n=!1,i=e.skipTrivia(io.text,t.expression.end,!1,!0),a=e.skipTrivia(io.text,i),o=a+1;if(!(131072&e.getEmitFlags(t))){var s=e.createToken(24);s.pos=t.expression.end,s.end=o,r=ta(t,t.expression,s),n=ta(t,s,t.name)}F(t.expression),Qi(r,!1);var c=i!==a,u=!r&&Jt(t.expression,c);u&&Ii("."),Ar(24,t.expression.end,Ii,t),Qi(n,!1),N(t.name),Xi(r,n)}function Jt(r,n){if(r=e.skipPartiallyEmittedExpressions(r),e.isNumericLiteral(r)){var i=aa(r,!0);return!(r.numericLiteralFlags||e.stringContains(i,e.tokenToString(24))||n&&!t.removeComments)}if(e.isPropertyAccessExpression(r)||e.isElementAccessExpression(r)){var a=e.getConstantValue(r);return"number"==typeof a&&isFinite(a)&&Math.floor(a)===a&&t.removeComments}}function zt(e){F(e.expression),Ar(22,e.expression.end,Ii,e),F(e.argumentExpression),Ar(23,e.argumentExpression.end,Ii,e)}function Vt(e){F(e.expression),hi(e,e.typeArguments),Ti(e,e.arguments,2576)}function Ut(e){Ar(96,e.pos,Mi,e),ji(),F(e.expression),hi(e,e.typeArguments),Ti(e,e.arguments,18960)}function Kt(e){F(e.tag),hi(e,e.typeArguments),ji(),F(e.template)}function qt(e){Ii("<"),N(e.type),Ii(">"),F(e.expression)}function Wt(e){var t=Ar(20,e.pos,Ii,e);F(e.expression),Ar(21,e.expression?e.expression.end:t,Ii,e)}function Ht(e){_a(e.name),Jr(e)}function Gt(e){yi(e,e.decorators),li(e,e.modifiers),Vr(e,Qt)}function Qt(e){bi(e,e.typeParameters),Si(e,e.parameters),_i(e.type),ji(),N(e.equalsGreaterThanToken)}function Xt(e){Ar(82,e.pos,Mi,e),ji(),F(e.expression)}function Yt(e){Ar(105,e.pos,Mi,e),ji(),F(e.expression)}function Zt(e){Ar(107,e.pos,Mi,e),ji(),F(e.expression)}function $t(e){Ar(123,e.pos,Mi,e),ji(),F(e.expression)}function er(e){Wi(e.operator,Li),tr(e)&&ji(),F(e.operand)}function tr(e){var t=e.operand;return 203===t.kind&&(38===e.operator&&(38===t.operator||44===t.operator)||39===e.operator&&(39===t.operator||45===t.operator))}function rr(e){F(e.operand),Wi(e.operator,Li)}function nr(e){var t=27!==e.operatorToken.kind,r=ta(e,e.left,e.operatorToken),n=ta(e,e.operatorToken,e.right);F(e.left),Qi(r,t),Ba(e.operatorToken.pos),qi(e.operatorToken,94===e.operatorToken.kind?Mi:Li),za(e.operatorToken.end,!0),Qi(n,!0),F(e.right),Xi(r,n)}function ir(e){var t=ta(e,e.condition,e.questionToken),r=ta(e,e.questionToken,e.whenTrue),n=ta(e,e.whenTrue,e.colonToken),i=ta(e,e.colonToken,e.whenFalse);F(e.condition),Qi(t,!0),N(e.questionToken),Qi(r,!0),F(e.whenTrue),Xi(t,r),Qi(n,!0),N(e.colonToken),Qi(i,!0),F(e.whenFalse),Xi(n,i)}function ar(e){N(e.head),ki(e,e.templateSpans,262144)}function or(e){Ar(118,e.pos,Mi,e),N(e.asteriskToken),mi(e.expression)}function sr(e){Ar(25,e.pos,Ii,e),F(e.expression)}function cr(e){_a(e.name),Qr(e)}function ur(e){F(e.expression),hi(e,e.typeArguments)}function lr(e){F(e.expression),e.type&&(ji(),Mi("as"),ji(),N(e.type))}function _r(e){F(e.expression),Li("!")}function dr(e){Ki(e.keywordToken,e.pos,Ii),Ii("."),N(e.name)}function pr(e){F(e.expression),N(e.literal)}function fr(e){mr(e,!e.multiLine&&ra(e))}function mr(t,r){Ar(18,t.pos,Ii,t);var n=r||1&e.getEmitFlags(t)?768:129;ki(t,t.statements,n),Ar(19,t.statements.end,Ii,t,!!(1&n))}function gr(e){li(e,e.modifiers),N(e.declarationList),Oi()}function vr(e){e?Ii(";"):Oi()}function yr(t){F(t.expression),(!e.isJsonSourceFile(io)||e.nodeIsSynthesized(t.expression))&&Oi()}function hr(e){var t=Ar(92,e.pos,Mi,e);ji(),Ar(20,t,Ii,e),F(e.expression),Ar(21,e.expression.end,Ii,e),vi(e,e.thenStatement),e.elseStatement&&(Hi(e),Ar(84,e.thenStatement.end,Mi,e),223===e.elseStatement.kind?(ji(),N(e.elseStatement)):vi(e,e.elseStatement))
}function br(e,t){var r=Ar(108,t,Mi,e);ji(),Ar(20,r,Ii,e),F(e.expression),Ar(21,e.expression.end,Ii,e)}function xr(t){Ar(83,t.pos,Mi,t),vi(t,t.statement),e.isBlock(t.statement)?ji():Hi(t),br(t,t.statement.end),Ii(";")}function Dr(e){br(e,e.pos),vi(e,e.statement)}function Sr(e){var t=Ar(90,e.pos,Mi,e);ji();var r=Ar(20,t,Ii,e);Tr(e.initializer),r=Ar(26,e.initializer?e.initializer.end:r,Ii,e),mi(e.condition),r=Ar(26,e.condition?e.condition.end:r,Ii,e),mi(e.incrementor),Ar(21,e.incrementor?e.incrementor.end:r,Ii,e),vi(e,e.statement)}function Cr(e){var t=Ar(90,e.pos,Mi,e);ji(),Ar(20,t,Ii,e),Tr(e.initializer),ji(),Ar(94,e.initializer.end,Mi,e),ji(),F(e.expression),Ar(21,e.expression.end,Ii,e),vi(e,e.statement)}function kr(e){var t=Ar(90,e.pos,Mi,e);ji(),gi(e.awaitModifier),Ar(20,t,Ii,e),Tr(e.initializer),ji(),Ar(148,e.initializer.end,Mi,e),ji(),F(e.expression),Ar(21,e.expression.end,Ii,e),vi(e,e.statement)}function Tr(e){void 0!==e&&(239===e.kind?N(e):F(e))}function Er(e){Ar(79,e.pos,Mi,e),fi(e.label),Oi()}function Nr(e){Ar(74,e.pos,Mi,e),fi(e.label),Oi()}function Ar(t,r,n,i,a){var o=e.getParseTreeNode(i),s=o&&o.kind===i.kind,c=r;if(s&&(r=e.skipTrivia(io.text,r)),Ba&&s&&i.pos!==c){var u=a&&!e.positionsAreOnSameLine(c,r,io);u&&Vi(),Ba(c),u&&Ui()}return r=Wi(t,n,r),za&&s&&i.end!==r&&za(r,!0),r}function Fr(e){Ar(98,e.pos,Mi,e),mi(e.expression),Oi()}function Pr(e){var t=Ar(109,e.pos,Mi,e);ji(),Ar(20,t,Ii,e),F(e.expression),Ar(21,e.expression.end,Ii,e),vi(e,e.statement)}function wr(e){var t=Ar(100,e.pos,Mi,e);ji(),Ar(20,t,Ii,e),F(e.expression),Ar(21,e.expression.end,Ii,e),ji(),N(e.caseBlock)}function Ir(e){N(e.label),Ar(57,e.label.end,Ii,e),ji(),N(e.statement)}function Or(e){Ar(102,e.pos,Mi,e),mi(e.expression),Oi()}function Mr(e){Ar(104,e.pos,Mi,e),ji(),N(e.tryBlock),e.catchClause&&(Hi(e),N(e.catchClause)),e.finallyBlock&&(Hi(e),Ar(89,(e.catchClause||e.tryBlock).end,Mi,e),ji(),N(e.finallyBlock))}function Lr(e){Ki(80,e.pos,Mi),Oi()}function Rr(e){N(e.name),_i(e.type),di(e.initializer,e.type?e.type.end:e.name.end,e)}function Br(t){Mi(e.isLet(t)?"let":e.isVarConst(t)?"const":"var"),ji(),ki(t,t.declarations,528)}function jr(e){Jr(e)}function Jr(e){yi(e,e.decorators),li(e,e.modifiers),Mi("function"),N(e.asteriskToken),ji(),A(e.name),Vr(e,Ur)}function zr(e,t){qr(t)}function Vr(t,r){var n=t.body;if(n)if(e.isBlock(n)){var i=65536&e.getEmitFlags(t);i&&Vi(),oa(t),e.forEach(t.parameters,ua),ua(t.body),r(t),Do?Do(4,n,zr):qr(n),sa(t),i&&Ui()}else r(t),ji(),F(n);else r(t),Oi()}function Ur(e){bi(e,e.typeParameters),xi(e,e.parameters),_i(e.type)}function Kr(t){if(1&e.getEmitFlags(t))return!0;if(t.multiLine)return!1;if(!e.nodeIsSynthesized(t)&&!e.rangeIsOnSingleLine(t,io))return!1;if(Yi(t,t.statements,2)||$i(t,t.statements,2))return!1;for(var r,n=0,i=t.statements;n<i.length;n++){var a=i[n];if(Zi(r,a,2))return!1;r=a}return!0}function qr(e){ji(),Ii("{"),Vi();var t=Kr(e)?Wr:Hr;Ia?Ia(e,e.statements,t):t(e),Ui(),Ki(19,e.statements.end,Ii,e)}function Wr(e){Hr(e,!0)}function Hr(e,t){var r=ii(e.statements),n=po.getTextPos();B(e),0===r&&n===po.getTextPos()&&t?(Ui(),ki(e,e.statements,768),Vi()):ki(e,e.statements,1,r)}function Gr(e){Qr(e)}function Qr(t){e.forEach(t.members,la),yi(t,t.decorators),li(t,t.modifiers),Mi("class"),t.name&&(ji(),A(t.name));var r=65536&e.getEmitFlags(t);r&&Vi(),bi(t,t.typeParameters),ki(t,t.heritageClauses,0),ji(),Ii("{"),ki(t,t.members,129),Ii("}"),r&&Ui()}function Xr(e){yi(e,e.decorators),li(e,e.modifiers),Mi("interface"),ji(),N(e.name),bi(e,e.typeParameters),ki(e,e.heritageClauses,512),ji(),Ii("{"),ki(e,e.members,129),Ii("}")}function Yr(e){yi(e,e.decorators),li(e,e.modifiers),Mi("type"),ji(),N(e.name),bi(e,e.typeParameters),ji(),Ii("="),ji(),N(e.type),Oi()}function Zr(e){li(e,e.modifiers),Mi("enum"),ji(),N(e.name),ji(),Ii("{"),ki(e,e.members,145),Ii("}")}function $r(e){li(e,e.modifiers),512&~e.flags&&(Mi(16&e.flags?"namespace":"module"),ji()),N(e.name);var t=e.body;if(!t)return Oi();for(;245===t.kind;)Ii("."),N(t.name),t=t.body;ji(),N(t)}function en(t){oa(t),e.forEach(t.statements,ua),mr(t,ra(t)),sa(t)}function tn(e){Ar(18,e.pos,Ii,e),ki(e,e.clauses,129),Ar(19,e.clauses.end,Ii,e,!0)}function rn(e){li(e,e.modifiers),Ar(93,e.modifiers?e.modifiers.end:e.pos,Mi,e),ji(),N(e.name),ji(),Ar(60,e.name.end,Ii,e),ji(),nn(e.moduleReference),Oi()}function nn(e){73===e.kind?F(e):N(e)}function an(e){li(e,e.modifiers),Ar(93,e.modifiers?e.modifiers.end:e.pos,Mi,e),ji(),e.importClause&&(N(e.importClause),ji(),Ar(145,e.importClause.end,Mi,e),ji()),F(e.moduleSpecifier),Oi()}function on(e){N(e.name),e.name&&e.namedBindings&&(Ar(27,e.name.end,Ii,e),ji()),N(e.namedBindings)}function sn(e){var t=Ar(40,e.pos,Ii,e);ji(),Ar(120,t,Mi,e),ji(),N(e.name)}function cn(e){mn(e)}function un(e){gn(e)}function ln(e){var t=Ar(86,e.pos,Mi,e);ji(),e.isExportEquals?Ar(60,t,Li,e):Ar(81,t,Mi,e),ji(),F(e.expression),Oi()}function _n(e){var t=Ar(86,e.pos,Mi,e);if(ji(),e.exportClause?N(e.exportClause):t=Ar(40,t,Ii,e),e.moduleSpecifier){ji();var r=e.exportClause?e.exportClause.end:t;Ar(145,r,Mi,e),ji(),F(e.moduleSpecifier)}Oi()}function dn(e){var t=Ar(86,e.pos,Mi,e);ji(),t=Ar(120,t,Mi,e),ji(),t=Ar(132,t,Mi,e),ji(),N(e.name),Oi()}function pn(e){mn(e)}function fn(e){gn(e)}function mn(e){Ii("{"),ki(e,e.elements,525136),Ii("}")}function gn(e){e.propertyName&&(N(e.propertyName),ji(),Ar(120,e.propertyName.end,Mi,e),ji()),N(e.name)}function vn(e){Mi("require"),Ii("("),F(e.expression),Ii(")")}function yn(e){N(e.openingElement),ki(e,e.children,262144),N(e.closingElement)}function hn(e){Ii("<"),Nn(e.tagName),hi(e,e.typeArguments),ji(),N(e.attributes),Ii("/>")}function bn(e){N(e.openingFragment),ki(e,e.children,262144),N(e.closingFragment)}function xn(t){Ii("<"),e.isJsxOpeningElement(t)&&(Nn(t.tagName),hi(t,t.typeArguments),t.attributes.properties&&t.attributes.properties.length>0&&ji(),N(t.attributes)),Ii(">")}function Dn(e){po.writeLiteral(e.text)}function Sn(t){Ii("</"),e.isJsxClosingElement(t)&&Nn(t.tagName),Ii(">")}function Cn(e){ki(e,e.properties,262656)}function kn(e){N(e.name),pi("=",Ii,e.initializer,N)}function Tn(e){Ii("{..."),F(e.expression),Ii("}")}function En(e){e.expression&&(Ii("{"),N(e.dotDotDotToken),F(e.expression),Ii("}"))}function Nn(e){73===e.kind?F(e):N(e)}function An(e){Ar(75,e.pos,Mi,e),ji(),F(e.expression),Pn(e,e.statements,e.expression.end)}function Fn(e){var t=Ar(81,e.pos,Mi,e);Pn(e,e.statements,t)}function Pn(t,r,n){var i=1===r.length&&(e.nodeIsSynthesized(t)||e.nodeIsSynthesized(r[0])||e.rangeStartPositionsAreOnSameLine(t,r[0],io)),a=163969;i?(Ki(57,n,Ii,t),ji(),a&=-130):Ar(57,n,Ii,t),ki(t,r,a)}function wn(e){ji(),Wi(e.token,Mi),ji(),ki(e,e.types,528)}function In(e){var t=Ar(76,e.pos,Mi,e);ji(),e.variableDeclaration&&(Ar(20,t,Ii,e),N(e.variableDeclaration),Ar(21,e.variableDeclaration.end,Ii,e),ji()),N(e.block)}function On(t){N(t.name),Ii(":"),ji();var r=t.initializer;if(za&&0===(512&e.getEmitFlags(r))){var n=e.getCommentRange(r);za(n.pos)}F(r)}function Mn(e){N(e.name),e.objectAssignmentInitializer&&(ji(),Ii("="),ji(),F(e.objectAssignmentInitializer))}function Ln(e){e.expression&&(Ar(25,e.pos,Ii,e),F(e.expression))}function Rn(e){N(e.name),di(e.initializer,e.name.end,e)}function Bn(e){if(Io("/**"),e.comment)for(var t=e.comment.split(/\r\n?|\n/g),r=0,n=t;r<n.length;r++){var i=n[r];zi(),ji(),Ii("*"),ji(),Io(i)}e.tags&&(1!==e.tags.length||308!==e.tags[0].kind||e.comment?ki(e,e.tags,33):(ji(),N(e.tags[0]))),ji(),Io("*/")}function jn(e){Gn(e.tagName),Xn(e.typeExpression),Qn(e.comment)}function Jn(e){Gn(e.tagName),ji(),Ii("{"),N(e.class),Ii("}"),Qn(e.comment)}function zn(e){Gn(e.tagName),Xn(e.constraint),ji(),ki(e,e.typeParameters,528),Qn(e.comment)}function Vn(e){Gn(e.tagName),e.typeExpression&&(289===e.typeExpression.kind?Xn(e.typeExpression):(ji(),Ii("{"),Io("Object"),e.typeExpression.isArrayType&&(Ii("["),Ii("]")),Ii("}"))),e.fullName&&(ji(),N(e.fullName)),Qn(e.comment),e.typeExpression&&298===e.typeExpression.kind&&qn(e.typeExpression)}function Un(e){Gn(e.tagName),e.name&&(ji(),N(e.name)),Qn(e.comment),Wn(e.typeExpression)}function Kn(e){Gn(e.tagName),Qn(e.comment)}function qn(t){ki(t,e.createNodeArray(t.jsDocPropertyTags),33)}function Wn(t){t.typeParameters&&ki(t,e.createNodeArray(t.typeParameters),33),t.parameters&&ki(t,e.createNodeArray(t.parameters),33),t.type&&(zi(),ji(),Ii("*"),ji(),N(t.type))}function Hn(e){Gn(e.tagName),Xn(e.typeExpression),ji(),e.isBracketed&&Ii("["),N(e.name),e.isBracketed&&Ii("]"),Qn(e.comment)}function Gn(e){Ii("@"),N(e)}function Qn(e){e&&(ji(),Io(e))}function Xn(e){e&&(ji(),Ii("{"),N(e.type),Ii("}"))}function Yn(t){zi();var r=t.statements;if(Ia){var n=0===r.length||!e.isPrologueDirective(r[0])||e.nodeIsSynthesized(r[0]);if(n)return void Ia(t,r,ti)}ti(t)}function Zn(t){ei(!!t.hasNoDefaultLib,t.syntheticFileReferences||[],t.syntheticTypeReferences||[],t.syntheticLibReferences||[]);for(var r=0,n=t.prepends;r<n.length;r++){var i=n[r];if(e.isUnparsedSource(i)&&i.syntheticReferences)for(var a=0,o=i.syntheticReferences;a<o.length;a++){var s=o[a];N(s),zi()}}}function $n(e){e.isDeclarationFile&&ei(e.hasNoDefaultLib,e.referencedFiles,e.typeReferenceDirectives,e.libReferenceDirectives)}function ei(e,t,r,n){if(e){var i=po.getTextPos();Bi('/// <reference no-default-lib="true"/>'),Oo&&Oo.sections.push({pos:i,end:po.getTextPos(),kind:"no-default-lib"}),zi()}if(io&&io.moduleName&&(Bi('/// <amd-module name="'+io.moduleName+'" />'),zi()),io&&io.amdDependencies)for(var a=0,o=io.amdDependencies;a<o.length;a++){var s=o[a];Bi(s.name?'/// <amd-dependency name="'+s.name+'" path="'+s.path+'" />':'/// <amd-dependency path="'+s.path+'" />'),zi()}for(var c=0,u=t;c<u.length;c++){var l=u[c],i=po.getTextPos();Bi('/// <reference path="'+l.fileName+'" />'),Oo&&Oo.sections.push({pos:i,end:po.getTextPos(),kind:"reference",data:l.fileName}),zi()}for(var _=0,d=r;_<d.length;_++){var l=d[_],i=po.getTextPos();Bi('/// <reference types="'+l.fileName+'" />'),Oo&&Oo.sections.push({pos:i,end:po.getTextPos(),kind:"type",data:l.fileName}),zi()}for(var p=0,f=n;p<f.length;p++){var l=f[p],i=po.getTextPos();Bi('/// <reference lib="'+l.fileName+'" />'),Oo&&Oo.sections.push({pos:i,end:po.getTextPos(),kind:"lib",data:l.fileName}),zi()}}function ti(t){var r=t.statements;oa(t),e.forEach(t.statements,ua),B(t);var n=e.findIndex(r,function(t){return!e.isPrologueDirective(t)});$n(t),ki(t,r,1,-1===n?r.length:n),sa(t)}function ri(e){F(e.expression)}function ni(e){Ti(e,e.elements,528)}function ii(t,r,n,i){for(var a=!!r,o=0;o<t.length;o++){var s=t[o];if(!e.isPrologueDirective(s))return o;var c=n?!n.has(s.expression.text):!0;if(c){a&&(a=!1,S(r)),zi();var u=po.getTextPos();N(s),i&&Oo&&Oo.sections.push({pos:u,end:po.getTextPos(),kind:"prologue",data:s.expression.text}),n&&n.set(s.expression.text,!0)}}return t.length}function ai(e,t){for(var r=0,n=e;r<n.length;r++){var i=n[r];if(!t.has(i.data)){zi();var a=po.getTextPos();N(i),Oo&&Oo.sections.push({pos:a,end:po.getTextPos(),kind:"prologue",data:i.data}),t&&t.set(i.data,!0)}}}function oi(t){if(e.isSourceFile(t))ii(t.statements,t);else{for(var r=e.createMap(),n=0,i=t.prepends;n<i.length;n++){var a=i[n];ai(a.prologues,r)}for(var o=0,s=t.sourceFiles;o<s.length;o++){var c=s[o];ii(c.statements,c,r,!0)}S(void 0)}}function si(t){for(var r,n=e.createMap(),i=0;i<t.sourceFiles.length;i++){for(var a=t.sourceFiles[i],o=void 0,s=0,c=0,u=a.statements;c<u.length;c++){var l=u[c];if(!e.isPrologueDirective(l))break;n.has(l.expression.text)||(n.set(l.expression.text,!0),(o||(o=[])).push({pos:l.pos,end:l.end,expression:{pos:l.expression.pos,end:l.expression.end,text:l.expression.text}}),s=s<l.end?l.end:s)}o&&(r||(r=[])).push({file:i,text:a.text.substring(0,s),directives:o})}return r}function ci(t){if(e.isSourceFile(t)||e.isUnparsedSource(t)){var r=e.getShebang(t.text);if(r)return Bi(r),zi(),!0}else{for(var n=0,i=t.prepends;n<i.length;n++){var a=i[n];if(e.Debug.assertNode(a,e.isUnparsedSource),ci(a))return!0}for(var o=0,s=t.sourceFiles;o<s.length;o++){var c=s[o];if(ci(c))return!0}}}function ui(e,t){if(e){var r=Io;Io=t,N(e),Io=r}}function li(e,t){t&&t.length&&(ki(e,t,262656),ji())}function _i(e){e&&(Ii(":"),ji(),N(e))}function di(e,t,r){e&&(ji(),Ar(60,t,Li,r),ji(),F(e))}function pi(e,t,r,n){r&&(t(e),n(r))}function fi(e){e&&(ji(),N(e))}function mi(e){e&&(ji(),F(e))}function gi(e){e&&(N(e),ji())}function vi(t,r){if(e.isBlock(r)||1&e.getEmitFlags(t))ji(),N(r);else{if(zi(),Vi(),e.isEmptyStatement(r)){var n=P(0,r);n(5,r)}else N(r);Ui()}}function yi(e,t){ki(e,t,49153)}function hi(e,t){ki(e,t,53776)}function bi(t,r){return e.isFunctionLike(t)&&t.typeArguments?hi(t,t.typeArguments):void ki(t,r,53776)}function xi(e,t){ki(e,t,2576)}function Di(t,r){var n=e.singleOrUndefined(r);return!(!n||n.pos!==t.pos||!e.isArrowFunction(t)||t.type||e.some(t.decorators)||e.some(t.modifiers)||e.some(t.typeParameters)||e.some(n.decorators)||e.some(n.modifiers)||n.dotDotDotToken||n.questionToken||n.type||n.initializer||!e.isIdentifier(n.name))}function Si(e,t){Di(e,t)?ki(e,t,528):xi(e,t)}function Ci(e,t){ki(e,t,8848)}function ki(e,t,r,n,i){Ni(N,e,t,r,n,i)}function Ti(e,t,r,n,i){Ni(F,e,t,r,n,i)}function Ei(e){switch(60&e){case 0:break;case 16:Ii(",");break;case 4:ji(),Ii("|");break;case 32:ji(),Ii("*"),ji();break;case 8:ji(),Ii("&")}}function Ni(t,r,n,i,a,o){void 0===a&&(a=0),void 0===o&&(o=n?n.length-a:0);var s=void 0===n;if(!(s&&16384&i)){var c=void 0===n||a>=n.length||0===o;if(c&&32768&i)return ko&&ko(n),void(To&&To(n));if(15360&i&&(Ii(x(i)),c&&!s&&za(n.pos,!0)),ko&&ko(n),c)1&i?zi():256&i&&!(524288&i)&&ji();else{var u=0===(262144&i),l=u;Yi(r,n,i)?(zi(),l=!1):256&i&&ji(),128&i&&Vi();for(var _=void 0,f=void 0,m=!1,g=0;o>g;g++){var v=n[a+g];if(32&i?(zi(),Ei(i)):_&&(60&i&&_.end!==r.end&&Ba(_.end),Ei(i),p(f),Zi(_,v,i)?(0===(131&i)&&(Vi(),m=!0),zi(),l=!1):_&&512&i&&ji()),f=d(v),l){if(za){var y=e.getCommentRange(v);za(y.pos)}}else l=u;t(v),m&&(Ui(),m=!1),_=v}var h=64&i&&n.hasTrailingComma;16&i&&h&&Ii(","),_&&60&i&&_.end!==r.end&&!(1024&e.getEmitFlags(_))&&Ba(_.end),128&i&&Ui(),p(f),$i(r,n,i)?zi():256&i&&ji()}To&&To(n),15360&i&&(c&&!s&&Ba(n.end),Ii(D(i)))}}function Ai(e){po.writeLiteral(e)}function Fi(e){po.writeStringLiteral(e)}function Pi(e){po.write(e)}function wi(e,t){po.writeSymbol(e,t)}function Ii(e){po.writePunctuation(e)}function Oi(){po.writeTrailingSemicolon(";")}function Mi(e){po.writeKeyword(e)}function Li(e){po.writeOperator(e)}function Ri(e){po.writeParameter(e)}function Bi(e){po.writeComment(e)}function ji(){po.writeSpace(" ")}function Ji(e){po.writeProperty(e)}function zi(){po.writeLine()}function Vi(){po.increaseIndent()}function Ui(){po.decreaseIndent()}function Ki(e,t,r,n){return Bo?Wi(e,r,t):to(n,e,r,t,Wi)}function qi(t,r){Eo&&Eo(t),r(e.tokenToString(t.kind)),No&&No(t)}function Wi(t,r,n){var i=e.tokenToString(t);return r(i),0>n?n:n+i.length}function Hi(t){1&e.getEmitFlags(t)?ji():zi()}function Gi(t){for(var r=t.split(/\r\n?|\n/g),n=e.guessIndentation(r),i=0,a=r;i<a.length;i++){var o=a[i],s=n?o.slice(n):o;s.length&&(zi(),Io(s))}}function Qi(e,t){e?(Vi(),zi()):t&&ji()}function Xi(e,t){e&&Ui(),t&&Ui()}function Yi(t,r,n){if(1&n)return!0;if(2&n){if(65536&n)return!0;var i=r[0];return void 0===i?!e.rangeIsOnSingleLine(t,io):e.positionIsSynthesized(t.pos)||e.nodeIsSynthesized(i)?ea(i,n):!e.rangeStartPositionsAreOnSameLine(t,i,io)}return!1}function Zi(t,r,n){return 1&n?!0:2&n?void 0===t||void 0===r?!1:e.nodeIsSynthesized(t)||e.nodeIsSynthesized(r)?ea(t,n)||ea(r,n):!e.rangeEndIsOnSameLineAsRangeStart(t,r,io):e.getStartsOnNewLine(r)}function $i(t,r,n){if(1&n)return 0===(131072&n);if(2&n){if(65536&n)return!0;var i=e.lastOrUndefined(r);return void 0===i?!e.rangeIsOnSingleLine(t,io):e.positionIsSynthesized(t.pos)||e.nodeIsSynthesized(i)?ea(i,n):!e.rangeEndPositionsAreOnSameLine(t,i,io)}return!1}function ea(t,r){if(e.nodeIsSynthesized(t)){var n=e.getStartsOnNewLine(t);return void 0===n?0!==(65536&r):n}return 0!==(65536&r)}function ta(t,r,n){return t=na(t),r=na(r),n=na(n),e.getStartsOnNewLine(n)?!0:!(e.nodeIsSynthesized(t)||e.nodeIsSynthesized(r)||e.nodeIsSynthesized(n)||e.rangeEndIsOnSameLineAsRangeStart(r,n,io))}function ra(t){return 0===t.statements.length&&e.rangeEndIsOnSameLineAsRangeStart(t,t,io)}function na(t){for(;196===t.kind&&e.nodeIsSynthesized(t);)t=t.expression;return t}function ia(t,r){return e.isGeneratedIdentifier(t)?da(t):e.isIdentifier(t)&&(e.nodeIsSynthesized(t)||!t.parent||!io||t.parent&&io&&e.getSourceFileOfNode(t)!==e.getOriginalNode(io))?e.idText(t):10===t.kind&&t.textSourceNode?ia(t.textSourceNode,r):!e.isLiteralExpression(t)||!e.nodeIsSynthesized(t)&&t.parent?e.getSourceTextOfNodeFromSourceFile(io,t,r):t.text}function aa(t,r){if(10===t.kind&&t.textSourceNode){var n=t.textSourceNode;return e.isIdentifier(n)?r||16777216&e.getEmitFlags(t)?'"'+e.escapeString(ia(n))+'"':'"'+e.escapeNonAsciiString(ia(n))+'"':aa(n,r)}return e.getLiteralText(t,io,r)}function oa(t){t&&524288&e.getEmitFlags(t)||(co.push(uo),uo=0,lo.push(_o))}function sa(t){t&&524288&e.getEmitFlags(t)||(uo=co.pop(),_o=lo.pop())}function ca(t){_o&&_o!==e.lastOrUndefined(lo)||(_o=e.createMap()),_o.set(t,!0)}function ua(t){if(t)switch(t.kind){case 219:e.forEach(t.statements,ua);break;case 234:case 232:case 224:case 225:ua(t.statement);break;case 223:ua(t.thenStatement),ua(t.elseStatement);break;case 226:case 228:case 227:ua(t.initializer),ua(t.statement);break;case 233:ua(t.caseBlock);break;case 247:e.forEach(t.clauses,ua);break;case 272:case 273:e.forEach(t.statements,ua);break;case 236:ua(t.tryBlock),ua(t.catchClause),ua(t.finallyBlock);break;case 275:ua(t.variableDeclaration),ua(t.block);break;case 220:ua(t.declarationList);break;case 239:e.forEach(t.declarations,ua);break;case 238:case 152:case 187:case 241:_a(t.name);break;case 240:_a(t.name),524288&e.getEmitFlags(t)&&(e.forEach(t.parameters,ua),ua(t.body));break;case 185:case 186:e.forEach(t.elements,ua);break;case 250:ua(t.importClause);break;case 251:_a(t.name),ua(t.namedBindings);break;case 252:_a(t.name);break;case 253:e.forEach(t.elements,ua);break;case 254:_a(t.propertyName||t.name)}}function la(e){if(e)switch(e.kind){case 276:case 277:case 155:case 157:case 159:case 160:_a(e.name)}}function _a(t){t&&(e.isGeneratedIdentifier(t)?da(t):e.isBindingPattern(t)&&ua(t))}function da(e){if(4===(7&e.autoGenerateFlags))return pa(Ea(e),e.autoGenerateFlags);var t=e.autoGenerateId;return oo[t]||(oo[t]=Ta(e))}function pa(t,r){var n=e.getNodeId(t);return ao[n]||(ao[n]=ka(t,r))}function fa(e){return ma(e)&&!so.has(e)&&!(_o&&_o.has(e))}function ma(t){return io?e.isFileLevelUniqueName(io,t,bo):!0}function ga(t,r){for(var n=r;e.isNodeDescendantOf(n,r);n=n.nextContainer)if(n.locals){var i=n.locals.get(e.escapeLeadingUnderscores(t));if(i&&70366143&i.flags)return!1}return!0}function va(e,t){if(e&&!(uo&e)){var r=268435456===e?"_i":"_n";if(fa(r))return uo|=e,t&&ca(r),r}for(;;){var n=268435455&uo;if(uo++,8!==n&&13!==n){var r=26>n?"_"+String.fromCharCode(97+n):"_"+(n-26);if(fa(r))return t&&ca(r),r}}}function ya(e,t,r,n){if(void 0===t&&(t=fa),r&&t(e))return n?ca(e):so.set(e,!0),e;95!==e.charCodeAt(e.length-1)&&(e+="_");for(var i=1;;){var a=e+i;if(t(a))return n?ca(a):so.set(a,!0),a;i++}}function ha(e){return ya(e,ma,!0)}function ba(e){var t=ia(e.name);return ga(t,e)?t:ya(t)}function xa(t){var r=e.getExternalModuleName(t),n=e.isStringLiteral(r)?e.makeIdentifierFromModuleName(r.text):"module";return ya(n)}function Da(){return ya("default")}function Sa(){return ya("class")}function Ca(t){return e.isIdentifier(t.name)?pa(t.name):va(0)}function ka(e,t){switch(e.kind){case 73:return ya(ia(e),fa,!!(16&t),!!(8&t));case 245:case 244:return ba(e);case 250:case 256:return xa(e);case 240:case 241:case 255:return Da();case 210:return Sa();case 157:case 159:case 160:return Ca(e);case 150:return va(0,!0);default:return va(0)}}function Ta(t){switch(7&t.autoGenerateFlags){case 1:return va(0,!!(8&t.autoGenerateFlags));case 2:return va(268435456,!!(8&t.autoGenerateFlags));case 3:return ya(e.idText(t),32&t.autoGenerateFlags?ma:fa,!!(16&t.autoGenerateFlags),!!(8&t.autoGenerateFlags))}return e.Debug.fail("Unsupported GeneratedIdentifierKind.")}function Ea(t){for(var r=t.autoGenerateId,n=t,i=n.original;i&&(n=i,!(e.isIdentifier(n)&&4&n.autoGenerateFlags&&n.autoGenerateId!==r));)i=n.original;return n}function Na(t,r){Wo(),Uo=!1;var n=e.getEmitFlags(r),i=e.getCommentRange(r),a=i.pos,o=i.end,s=313!==r.kind,c=0>a||0!==(512&n)||11===r.kind,u=0>o||0!==(1024&n)||11===r.kind,l=Jo,_=zo,d=Vo;(a>0||o>0)&&a!==o&&(c||Oa(a,s),(!c||a>=0&&0!==(512&n))&&(Jo=a),(!u||o>=0&&0!==(1024&n))&&(zo=o,239===r.kind&&(Vo=o))),e.forEach(e.getSyntheticLeadingComments(r),Aa),Ho();var p=w(2,r);2048&n?(Ko=!0,p(t,r),Ko=!1):p(t,r),Wo(),e.forEach(e.getSyntheticTrailingComments(r),Fa),(a>0||o>0)&&a!==o&&(Jo=l,zo=_,Vo=d,!u&&s&&ja(o)),Ho()}function Aa(e){2===e.kind&&po.writeLine(),Pa(e),e.hasTrailingNewLine||2===e.kind?po.writeLine():po.writeSpace(" ")}function Fa(e){po.isAtStartOfLine()||po.writeSpace(" "),Pa(e),e.hasTrailingNewLine&&po.writeLine()}function Pa(t){var r=wa(t),n=3===t.kind?e.computeLineStarts(r):void 0;e.writeCommentRange(r,n,po,0,r.length,Fo)}function wa(e){return 3===e.kind?"/*"+e.text+"*/":"//"+e.text}function Ia(t,r,n){Wo();var i=r.pos,a=r.end,o=e.getEmitFlags(t),s=0>i||0!==(512&o),c=Ko||0>a||0!==(1024&o);s||Ha(r),Ho(),2048&o&&!Ko?(Ko=!0,n(t),Ko=!1):n(t),Wo(),c||(Oa(r.end,!0),Uo&&!po.isAtStartOfLine()&&po.writeLine()),Ho()}function Oa(e,t){Uo=!1,t?Ua(e,Ra):0===e&&Ua(e,Ma)}function Ma(e,t,r,n,i){Qa(e,t)&&Ra(e,t,r,n,i)}function La(r,n){return t.onlyPrintJsDocStyle?e.isJSDocLikeText(r,n)||e.isPinnedComment(r,n):!0}function Ra(t,r,n,i,a){La(io.text,t)&&(Uo||(e.emitNewLineBeforeLeadingCommentOfPosition(E(),po,a,t),Uo=!0),$a(t),e.writeCommentRange(io.text,E(),po,t,r,Fo),$a(r),i?po.writeLine():3===n&&po.writeSpace(" "))}function Ba(e){Ko||-1===e||Oa(e,!0)}function ja(e){Ka(e,Ja)}function Ja(t,r,n,i){La(io.text,t)&&(po.isAtStartOfLine()||po.writeSpace(" "),$a(t),e.writeCommentRange(io.text,E(),po,t,r,Fo),$a(r),i&&po.writeLine())}function za(e,t){Ko||(Wo(),Ka(e,t?Ja:Va),Ho())}function Va(t,r,n,i){$a(t),e.writeCommentRange(io.text,E(),po,t,r,Fo),$a(r),i?po.writeLine():po.writeSpace(" ")}function Ua(t,r){!io||-1!==Jo&&t===Jo||(qa(t)?Wa(r):e.forEachLeadingCommentRange(io.text,t,r,t))}function Ka(t,r){io&&(-1===zo||t!==zo&&t!==Vo)&&e.forEachTrailingCommentRange(io.text,t,r)}function qa(t){return void 0!==ho&&e.last(ho).nodePos===t}function Wa(t){var r=e.last(ho).detachedCommentEndPos;ho.length-1?ho.pop():ho=void 0,e.forEachLeadingCommentRange(io.text,r,t,r)}function Ha(t){var r=e.emitDetachedComments(io.text,E(),po,Ga,t,Fo,Ko);r&&(ho?ho.push(r):ho=[r])}function Ga(t,r,n,i,a,o){La(io.text,i)&&($a(i),e.writeCommentRange(t,r,n,i,a,o),$a(a))}function Qa(t,r){return e.isRecognizedTripleSlashComment(io.text,t,r)}function Xa(t){return void 0===t.parsedSourceMap&&void 0!==t.sourceMapText&&(t.parsedSourceMap=e.tryParseRawSourceMap(t.sourceMapText)||!1),t.parsedSourceMap||void 0}function Ya(t,r){var n=w(3,r);if(e.isUnparsedSource(r)||e.isUnparsedPrepend(r))n(t,r);else if(e.isUnparsedNode(r)){var i=Xa(r.parent);i&&go&&go.appendSourceMap(po.getLine(),po.getColumn(),i,r.parent.sourceMapPath,r.parent.getLineAndCharacterOfPosition(r.pos),r.parent.getLineAndCharacterOfPosition(r.end)),n(t,r)}else{var a=e.getSourceMapRange(r),o=a.pos,s=a.end,c=a.source,u=void 0===c?vo:c,l=e.getEmitFlags(r);313!==r.kind&&0===(16&l)&&o>=0&&eo(u,Za(u,o)),64&l?(Bo=!0,n(t,r),Bo=!1):n(t,r),313!==r.kind&&0===(32&l)&&s>=0&&eo(u,s)}}function Za(t,r){return t.skipTrivia?t.skipTrivia(r):e.skipTrivia(t.text,r)}function $a(t){if(!(Bo||e.positionIsSynthesized(t)||no(vo))){var r=e.getLineAndCharacterOfPosition(vo,t),n=r.line,i=r.character;go.addMapping(po.getLine(),po.getColumn(),jo,n,i,void 0)}}function eo(e,t){if(e!==vo){var r=vo;ro(e),$a(t),ro(r)}else $a(t)}function to(t,r,n,i,a){if(Bo||t&&e.isInJsonFile(t))return a(r,n,i);var o=t&&t.emitNode,s=o&&o.flags||0,c=o&&o.tokenSourceMapRanges&&o.tokenSourceMapRanges[r],u=c&&c.source||vo;return i=Za(u,c?c.pos:i),0===(128&s)&&i>=0&&eo(u,i),i=a(r,n,i),c&&(i=c.end),0===(256&s)&&i>=0&&eo(u,i),i}function ro(e){Bo||(vo=e,no(e)||(jo=go.addSource(e.fileName),t.inlineSources&&go.setSourceContent(jo,e.text)))}function no(t){return e.fileExtensionIs(t.fileName,".json")}void 0===t&&(t={}),void 0===r&&(r={});var io,ao,oo,so,co,uo,lo,_o,po,fo,mo,go,vo,yo,ho,bo=r.hasGlobalName,xo=r.onEmitNode,Do=void 0===xo?e.noEmitNotification:xo,So=r.substituteNode,Co=void 0===So?e.noEmitSubstitution:So,ko=r.onBeforeEmitNodeArray,To=r.onAfterEmitNodeArray,Eo=r.onBeforeEmitToken,No=r.onAfterEmitToken,Ao=!!t.extendedDiagnostics,Fo=e.getNewLineCharacter(t),Po=e.getEmitModuleKind(t),wo=e.createMap(),Io=Pi,Oo=t.writeBundleFileInfo?{sections:[]}:void 0,Mo=t.recordInternalSection,Lo=0,Ro="text",Bo=!0,jo=-1,Jo=-1,zo=-1,Vo=-1,Uo=!1,Ko=!!t.removeComments,qo=e.performance.createTimerIf(Ao,"commentTime","beforeComment","afterComment"),Wo=qo.enter,Ho=qo.exit;return T(),{printNode:n,printList:i,printFile:o,printBundle:a,writeNode:c,writeList:u,writeFile:v,writeBundle:m,bundleFileInfo:Oo}}function b(){var e=[];return e[1024]=["{","}"],e[2048]=["(",")"],e[4096]=["<",">"],e[8192]=["[","]"],e}function x(e){return S[15360&e][0]}function D(e){return S[15360&e][1]}var S=b(),C={pos:-1,end:-1};e.isBuildInfoFile=t,e.forEachEmittedFile=r,e.getOutputPathForBuildInfo=n,e.getOutputPathsForBundle=i,e.getOutputPathsFor=a,e.getOutputExtension=s,e.getOutputDeclarationFileName=l,e.getAllProjectOutputs=d,e.getFirstProjectOutput=p,e.emitFiles=f,e.getBuildInfoText=m,e.getBuildInfo=g,e.notImplementedResolver={hasGlobalName:e.notImplemented,getReferencedExportContainer:e.notImplemented,getReferencedImportDeclaration:e.notImplemented,getReferencedDeclarationWithCollidingName:e.notImplemented,isDeclarationWithCollidingName:e.notImplemented,isValueAliasDeclaration:e.notImplemented,isReferencedAliasDeclaration:e.notImplemented,isTopLevelValueImportEqualsWithEntityName:e.notImplemented,getNodeCheckFlags:e.notImplemented,isDeclarationVisible:e.notImplemented,isLateBound:function(){return!1},collectLinkedAliases:e.notImplemented,isImplementationOfOverload:e.notImplemented,isRequiredInitializedParameter:e.notImplemented,isOptionalUninitializedParameterProperty:e.notImplemented,isExpandoFunctionDeclaration:e.notImplemented,getPropertiesOfContainerFunction:e.notImplemented,createTypeOfDeclaration:e.notImplemented,createReturnTypeOfSignatureDeclaration:e.notImplemented,createTypeOfExpression:e.notImplemented,createLiteralConstValue:e.notImplemented,isSymbolAccessible:e.notImplemented,isEntityNameVisible:e.notImplemented,getConstantValue:e.notImplemented,getReferencedValueDeclaration:e.notImplemented,getTypeReferenceSerializationKind:e.notImplemented,isOptionalParameter:e.notImplemented,moduleExportsSomeValue:e.notImplemented,isArgumentsLocalBinding:e.notImplemented,getExternalModuleFileFromDeclaration:e.notImplemented,getTypeReferenceDirectivesForEntityName:e.notImplemented,getTypeReferenceDirectivesForSymbol:e.notImplemented,isLiteralConstDeclaration:e.notImplemented,getJsxFactoryEntity:e.notImplemented,getAllAccessorDeclarations:e.notImplemented,getSymbolOfExternalModuleSpecifier:e.notImplemented,isBindingCapturedByNode:e.notImplemented},e.emitUsingBuildInfo=y;var k;!function(e){e[e.Notification=0]="Notification",e[e.Substitution=1]="Substitution",e[e.Comments=2]="Comments",e[e.SourceMaps=3]="SourceMaps",e[e.Emit=4]="Emit"}(k||(k={})),e.createPrinter=h;var T;!function(e){e[e.Auto=0]="Auto",e[e.CountMask=268435455]="CountMask",e[e._i=268435456]="_i"}(T||(T={}))}(n||(n={}));var n;!function(e){function t(t,r,n){function i(t){return e.toPath(t,r,k)}function a(t){return C.get(e.ensureTrailingDirectorySeparator(t))}function o(t){return a(e.getDirectoryPath(t))}function s(t){return e.getBaseFileName(e.normalizePath(t))}function c(r,n){var i={files:e.map(t.readDirectory(r,void 0,void 0,["*.*"]),s)||[],directories:t.getDirectories(r)||[]};return C.set(e.ensureTrailingDirectorySeparator(n),i),i}function u(t,r){r=e.ensureTrailingDirectorySeparator(r);var n=a(r);if(n)return n;try{return c(t,r)}catch(i){return void e.Debug.assert(!C.has(e.ensureTrailingDirectorySeparator(r)))}}function l(e,t){return k(e)===k(t)}function _(t,r){return e.some(t,function(e){return l(e,r)})}function d(t,r,n){if(_(t,r)){if(!n)return e.filterMutate(t,function(e){return!l(e,r)})}else if(n)return t.push(r)}function p(e,r,n){var a=i(e),c=o(a);return c&&D(c,s(e),!0),t.writeFile(e,r,n)}function f(e){var r=i(e),n=o(r);return n&&_(n.files,s(e))||t.fileExists(e)}function m(r){var n=i(r);return C.has(e.ensureTrailingDirectorySeparator(n))||t.directoryExists(r)}function g(e){var r=i(e),n=o(r),a=s(e);n&&d(n.directories,a,!0),t.createDirectory(e)}function v(e){var r=i(e),n=u(e,r);return n?n.directories.slice():t.getDirectories(e)}function y(a,o,s,c,l){function _(t){var r=i(t);return r===d?p:u(t,r)||e.emptyFileSystemEntries}var d=i(a),p=u(a,d);return p?e.matchFiles(a,o,s,c,n,r,l,_,h):t.readDirectory(a,o,s,c,l)}function h(e){return t.realpath?t.realpath(e):e}function b(e,r){var n=a(r);if(n)return void S();var i=o(r);if(!i)return void 0;if(!t.directoryExists)return void S();var c=s(e),u={fileExists:t.fileExists(r),directoryExists:t.directoryExists(r)};return u.directoryExists||_(i.directories,c)?S():D(i,c,u.fileExists),u}function x(t,r,n){if(n!==e.FileWatcherEventKind.Changed){var i=o(r);i&&D(i,s(t),n===e.FileWatcherEventKind.Created)}}function D(e,t,r){d(e.files,t,r)}function S(){C.clear()}if(!t.getDirectories||!t.readDirectory)return void 0;var C=e.createMap(),k=e.createGetCanonicalFileName(n);return{useCaseSensitiveFileNames:n,fileExists:f,readFile:function(e,r){return t.readFile(e,r)},directoryExists:t.directoryExists&&m,getDirectories:v,readDirectory:y,createDirectory:t.createDirectory&&g,writeFile:t.writeFile&&p,addOrDeleteFileOrDirectory:b,addOrDeleteFile:x,clearCache:S,realpath:t.realpath&&h}}function r(t,r,n){var i=t.getMissingFilePaths(),a=e.arrayToSet(i);e.mutateMap(r,a,{createNewValue:n,onDeleteValue:e.closeFileWatcher})}function n(t,r,n){function i(e,t){return{watcher:n(e,t),flags:t}}function a(e,r,n){e.flags!==r&&(e.watcher.close(),t.set(n,i(n,r)))}e.mutateMap(t,r,{createNewValue:i,onDeleteValue:f,onExistingValue:a})}function i(e,t){return e?e.isEmittedFile(t):!1}function a(e,t,r){return o(e,t,r,s,c)}function o(e,t,r,n,i){function a(e,t,r,i,a){return n(e,t,function(e,t){return r(e,t,a)},i)}var o=u(e,n),s=e===g.None?a:o,c=u(e,i);return{watchFile:function(e,i,a,s,c,u){return o(e,i,a,s,void 0,c,u,n,t,"FileWatcher",r)},watchFilePath:function(e,i,a,o,c,u,l){return s(e,i,a,o,c,u,l,n,t,"FileWatcher",r)},watchDirectory:function(e,n,a,o,s,u){return c(e,n,a,o,void 0,s,u,i,t,"DirectoryWatcher",r)}}}function s(e,t,r,n){return e.watchFile(t,r,n)}function c(e,t,r,n){return e.watchDirectory(t,r,0!==(1&n))}function u(e,t){switch(e){case g.None:return t;case g.TriggerOnly:return d;case g.Verbose:return t===c?_:l}}function l(e,t,r,n,i,a,o,s,c,u,l){c(u+":: Added:: "+p(t,n,a,o,l));var _=d(e,t,r,n,i,a,o,s,c,u,l);return{close:function(){c(u+":: Close:: "+p(t,n,a,o,l)),_.close()}}}function _(t,r,n,i,a,o,s,c,u,l,_){var f=l+":: Added:: "+p(r,i,o,s,_);u(f);var m=e.timestamp(),g=d(t,r,n,i,a,o,s,c,u,l,_),v=e.timestamp()-m;return u("Elapsed:: "+v+"ms "+f),{close:function(){var t=l+":: Close:: "+p(r,i,o,s,_);u(t);var n=e.timestamp();g.close();var a=e.timestamp()-n;u("Elapsed:: "+a+"ms "+t)}}}function d(t,r,n,i,a,o,s,c,u,l,_){return c(t,r,function(t,c){var d=l+":: Triggered with "+t+" "+(void 0!==c?c:"")+":: "+p(r,i,o,s,_);u(d);var f=e.timestamp();n(t,c,a);var m=e.timestamp()-f;u("Elapsed:: "+m+"ms "+d)},i)}function p(e,t,r,n,i){return"WatchInfo: "+e+" "+t+" "+(i?i(r,n):void 0===n?r:r+" "+n)}function f(e){e.watcher.close()}e.createCachedDirectoryStructureHost=t;var m;!function(e){e[e.None=0]="None",e[e.Partial=1]="Partial",e[e.Full=2]="Full"}(m=e.ConfigFileProgramReloadLevel||(e.ConfigFileProgramReloadLevel={})),e.updateMissingFilePathsWatch=r,e.updateWatchingWildcardDirectories=n,e.isEmittedFileOfProgram=i;var g;!function(e){e[e.None=0]="None",e[e.TriggerOnly=1]="TriggerOnly",e[e.Verbose=2]="Verbose"
}(g=e.WatchLogLevel||(e.WatchLogLevel={})),e.getWatchFactory=a,e.closeFileWatcherOf=f}(n||(n={}));var n;!function(e){function t(t,r,n){return void 0===n&&(n="tsconfig.json"),e.forEachAncestorDirectory(t,function(t){var i=e.combinePaths(t,n);return r(i)?i:void 0})}function r(t,r){var n=e.getDirectoryPath(r),i=e.isRootedDiskPath(t)?t:e.combinePaths(n,t);return e.normalizePath(i)}function n(t,r,n){var i,a=e.forEach(t,function(t){var a=e.getNormalizedPathComponents(t,r);if(a.pop(),!i)return void(i=a);for(var o=Math.min(i.length,a.length),s=0;o>s;s++)if(n(i[s])!==n(a[s])){if(0===s)return!0;i.length=s;break}a.length<i.length&&(i.length=a.length)});return a?"":i?e.getPathFromPathComponents(i):r}function a(e,t){return o(e,t)}function o(t,r,n){function i(t,n,i){var a;try{e.performance.mark("beforeIORead"),a=m.readFile(t),e.performance.mark("afterIORead"),e.performance.measure("I/O Read","beforeIORead","afterIORead")}catch(o){i&&i(o.message),a=""}return void 0!==a?e.createSourceFile(t,a,n,r):void 0}function a(e){return _.has(e)?!0:n.directoryExists(e)?(_.set(e,!0),!0):!1}function o(t){if(t.length>e.getRootLength(t)&&!a(t)){var r=e.getDirectoryPath(t);o(r),m.createDirectory?m.createDirectory(t):n.createDirectory(t)}}function s(t,r,i){l||(l=e.createMap());var a=n.createHash(r),o=n.getModifiedTime(t);if(o){var s=l.get(t);if(s&&s.byteOrderMark===i&&s.hash===a&&s.mtime.getTime()===o.getTime())return}n.writeFile(t,r,i);var c=n.getModifiedTime(t)||e.missingFileModifiedTime;l.set(t,{hash:a,byteOrderMark:i,mtime:c})}function c(r,i,a,c){try{e.performance.mark("beforeIOWrite"),o(e.getDirectoryPath(e.normalizePath(r))),e.isWatchSet(t)&&n.createHash&&n.getModifiedTime?s(r,i,a):n.writeFile(r,i,a),e.performance.mark("afterIOWrite"),e.performance.measure("I/O Write","beforeIOWrite","afterIOWrite")}catch(u){c&&c(u.message)}}function u(){return e.getDirectoryPath(e.normalizePath(n.getExecutingFilePath()))}void 0===n&&(n=e.sys);var l,_=e.createMap(),d=e.createGetCanonicalFileName(n.useCaseSensitiveFileNames),p=e.getNewLineCharacter(t,function(){return n.newLine}),f=n.realpath&&function(e){return n.realpath(e)},m={getSourceFile:i,getDefaultLibLocation:u,getDefaultLibFileName:function(t){return e.combinePaths(u(),e.getDefaultLibFileName(t))},writeFile:c,getCurrentDirectory:e.memoize(function(){return n.getCurrentDirectory()}),useCaseSensitiveFileNames:function(){return n.useCaseSensitiveFileNames},getCanonicalFileName:d,getNewLine:function(){return p},fileExists:function(e){return n.fileExists(e)},readFile:function(e){return n.readFile(e)},trace:function(e){return n.write(e+p)},directoryExists:function(e){return n.directoryExists(e)},getEnvironmentVariable:function(e){return n.getEnvironmentVariable?n.getEnvironmentVariable(e):""},getDirectories:function(e){return n.getDirectories(e)},realpath:f,readDirectory:function(e,t,r,i,a){return n.readDirectory(e,t,r,i,a)},createDirectory:function(e){return n.createDirectory(e)},createHash:e.maybeBind(n,n.createHash)};return m}function s(t,r,n){var i=t.readFile,a=t.fileExists,o=t.directoryExists,s=t.createDirectory,c=t.writeFile,u=e.createMap(),l=e.createMap(),_=e.createMap(),d=e.createMap(),p=function(e){var t=r(e),n=u.get(t);return void 0!==n?n!==!1?n:void 0:f(t,e)},f=function(e,r){var n=i.call(t,r);return u.set(e,void 0!==n?n:!1),n};t.readFile=function(n){var a=r(n),o=u.get(a);return void 0!==o?o!==!1?o:void 0:e.fileExtensionIs(n,".json")||e.isBuildInfoFile(n)?f(a,n):i.call(t,n)};var m=n?function(t,i,a,o){var s=r(t),c=d.get(s);if(c)return c;var u=n(t,i,a,o);return u&&(e.isDeclarationFileName(t)||e.fileExtensionIs(t,".json"))&&d.set(s,u),u}:void 0;return t.fileExists=function(e){var n=r(e),i=l.get(n);if(void 0!==i)return i;var o=a.call(t,e);return l.set(n,!!o),o},c&&(t.writeFile=function(e,n,i,a,o){var s=r(e);l.delete(s);var _=u.get(s);if(void 0!==_&&_!==n)u.delete(s),d.delete(s);else if(m){var p=d.get(s);p&&p.text!==n&&d.delete(s)}c.call(t,e,n,i,a,o)}),o&&s&&(t.directoryExists=function(e){var n=r(e),i=_.get(n);if(void 0!==i)return i;var a=o.call(t,e);return _.set(n,!!a),a},t.createDirectory=function(e){var n=r(e);_.delete(n),s.call(t,e)}),{originalReadFile:i,originalFileExists:a,originalDirectoryExists:o,originalCreateDirectory:s,originalWriteFile:c,getSourceFileWithCache:m,readFileWithCache:p}}function c(t,r,n){var i=t.getConfigFileParsingDiagnostics().concat(t.getOptionsDiagnostics(n),t.getSyntacticDiagnostics(r,n),t.getGlobalDiagnostics(n),t.getSemanticDiagnostics(r,n));return e.getEmitDeclarations(t.getCompilerOptions())&&e.addRange(i,t.getDeclarationDiagnostics(r,n)),e.sortAndDeduplicateDiagnostics(i)}function u(e,t){for(var r="",n=0,i=e;n<i.length;n++){var a=i[n];r+=l(a,t)}return r}function l(t,r){var n=e.diagnosticCategoryName(t)+" TS"+t.code+": "+v(t.messageText,r.getNewLine())+r.getNewLine();if(t.file){var i=e.getLineAndCharacterOfPosition(t.file,t.start),a=i.line,o=i.character,s=t.file.fileName,c=e.convertToRelativePath(s,r.getCurrentDirectory(),function(e){return r.getCanonicalFileName(e)});return c+"("+(a+1)+","+(o+1)+"): "+n}return n}function _(t){switch(t){case e.DiagnosticCategory.Error:return P.Red;case e.DiagnosticCategory.Warning:return P.Yellow;case e.DiagnosticCategory.Suggestion:return e.Debug.fail("Should never get an Info diagnostic on the command line.");case e.DiagnosticCategory.Message:return P.Blue}}function d(e,t){return t+e+O}function p(e,t){for(;e.length<t;)e=" "+e;return e}function f(t,r,n,i,a,o){var s=e.getLineAndCharacterOfPosition(t,r),c=s.line,u=s.character,l=e.getLineAndCharacterOfPosition(t,r+n),_=l.line,f=l.character,m=e.getLineAndCharacterOfPosition(t,t.text.length).line,g=_-c>=4,v=(_+1+"").length;g&&(v=Math.max(M.length,v));for(var y="",h=c;_>=h;h++){y+=o.getNewLine(),g&&h>c+1&&_-1>h&&(y+=i+d(p(M,v),w)+I+o.getNewLine(),h=_-1);var b=e.getPositionOfLineAndCharacter(t,h,0),x=m>h?e.getPositionOfLineAndCharacter(t,h+1,0):t.text.length,D=t.text.slice(b,x);if(D=D.replace(/\s+$/g,""),D=D.replace("	"," "),y+=i+d(p(h+1+"",v),w)+I,y+=D+o.getNewLine(),y+=i+d(p("",v),w)+I,y+=a,h===c){var S=h===_?f:void 0;y+=D.slice(0,u).replace(/\S/g," "),y+=D.slice(u,S).replace(/./g,"~")}else y+=h===_?D.slice(0,f).replace(/./g,"~"):D.replace(/./g,"~");y+=O}return y}function m(t,r,n,i){void 0===i&&(i=d);var a=e.getLineAndCharacterOfPosition(t,r),o=a.line,s=a.character,c=n?e.convertToRelativePath(t.fileName,n.getCurrentDirectory(),function(e){return n.getCanonicalFileName(e)}):t.fileName,u="";return u+=i(c,P.Cyan),u+=":",u+=i(""+(o+1),P.Yellow),u+=":",u+=i(""+(s+1),P.Yellow)}function g(t,r){for(var n="",i=0,a=t;i<a.length;i++){var o=a[i];if(o.file){var s=o.file,c=o.start;n+=m(s,c,r),n+=" - "}if(n+=d(e.diagnosticCategoryName(o),_(o.category)),n+=d(" TS"+o.code+": ",P.Grey),n+=v(o.messageText,r.getNewLine()),o.file&&(n+=r.getNewLine(),n+=f(o.file,o.start,o.length,"",_(o.category),r),o.relatedInformation)){n+=r.getNewLine();for(var u=0,l=o.relatedInformation;u<l.length;u++){var p=l[u],s=p.file,c=p.start,g=p.length,y=p.messageText;s&&(n+=r.getNewLine(),n+=L+m(s,c,r),n+=f(s,c,g,R,P.Cyan,r)),n+=r.getNewLine(),n+=R+v(y,r.getNewLine())}}n+=r.getNewLine()}return n}function v(t,r){if(e.isString(t))return t;for(var n=t,i="",a=0;n;){if(a){i+=r;for(var o=0;a>o;o++)i+="  "}i+=n.messageText,a++,n=n.next}return i}function y(t,r,n,i){if(0===t.length)return[];for(var a=[],o=e.createMap(),s=0,c=t;s<c.length;s++){var u=c[s],l=void 0;o.has(u)?l=o.get(u):o.set(u,l=i(u,r,n)),a.push(l)}return a}function h(t,r,n,i,a,o,s,c){function u(e){return!l(e)||o(e.path)}function l(e){return e.version===i(e.resolvedPath)}function _(r,n,i){return e.projectReferenceIsEqualTo(r,n)?d(t.getResolvedProjectReferences()[i],r):!1}function d(t,r){return t?e.contains(p,t)?!0:l(t.sourceFile)?((p||(p=[])).push(t),!e.forEach(t.references,function(e,r){return!d(e,t.commandLine.projectReferences[r])})):!1:!a(T(r))}if(!t||s)return!1;if(t.getRootFileNames().length!==r.length)return!1;var p;if(!e.arrayIsEqualTo(t.getProjectReferences(),c,_))return!1;if(t.getSourceFiles().some(u))return!1;if(t.getMissingFilePaths().some(a))return!1;var f=t.getCompilerOptions();return e.compareDataObjects(f,n)?f.configFile&&n.configFile?f.configFile.text===n.configFile.text:!0:!1}function b(e){return e.options.configFile?e.options.configFile.parseDiagnostics.concat(e.errors):e.errors}function x(t,r){if(!t)return!1;var n=t.getCompilerOptions();return!!e.sourceFileAffectingCompilerOptions.some(function(t){return!e.isJsonEqual(e.getCompilerOptionValue(n,t),e.getCompilerOptionValue(r,t))})}function D(e,t,r,n,i){return{rootNames:e,options:t,host:r,oldProgram:n,configFileParsingDiagnostics:i}}function S(t,o,s,c,u){function l(t,r){return e.compareValues(_(t),_(r))}function _(t){if(e.containsPath(Ar,t.fileName,!1)){var r=e.getBaseFileName(t.fileName);if("lib.d.ts"===r||"lib.es6.d.ts"===r)return 0;var n=e.removeSuffix(e.removePrefix(r,"lib."),".d.ts"),i=e.libs.indexOf(n);if(-1!==i)return i+1}return e.libs.length+2}function d(t,r){return Sr&&e.resolveModuleNameFromCache(t,r,Sr)}function p(t){return e.toPath(t,Pr,It)}function f(){if(void 0===nr){var t=e.filter(rr,function(t){return e.sourceFileMayBeEmitted(t,ur,O,Ct)});ur.rootDir&&Lt(t,ur.rootDir)?nr=e.getNormalizedAbsolutePath(ur.rootDir,Pr):ur.composite&&ur.configFilePath?(nr=e.getDirectoryPath(e.normalizeSlashes(ur.configFilePath)),Lt(t,nr)):nr=Mt(t),nr&&nr[nr.length-1]!==e.directorySeparator&&(nr+=e.directorySeparator)}return nr}function m(){if(!or){B(),or=e.createUnderscoreEscapedMap();for(var t=0,r=rr;t<r.length;t++){var n=r[t];e.copyEntries(n.classifiableNames,or)}}return or}function g(t,r,n){function i(t){var r=e.getResolvedModule(a,t),n=r&&dr.getSourceFile(r.resolvedFileName);if(r&&n)return!1;var i=pr.get(t);return i?(e.isTraceEnabled(ur,kr)&&e.trace(kr,e.Diagnostics.Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified,t,i),!0):!1}if(0===Qr&&!n.ambientModuleNames.length)return Cr(t,r,void 0,Ct(n.originalFileName));var a=dr&&dr.getSourceFile(r);if(a!==n&&n.resolvedModules){for(var o=[],s=0,c=t;s<c.length;s++){var u=c[s],l=n.resolvedModules.get(u);o.push(l)}return o}for(var _,d,p,f={},m=0;m<t.length;m++){var u=t[m];if(n===a&&!Mr(a.path)){var g=a&&a.resolvedModules.get(u);if(g){e.isTraceEnabled(ur,kr)&&e.trace(kr,e.Diagnostics.Reusing_resolution_of_module_0_to_file_1_from_old_program,u,r),(d||(d=new Array(t.length)))[m]=g,(p||(p=[])).push(u);continue}}var v=!1;e.contains(n.ambientModuleNames,u)?(v=!0,e.isTraceEnabled(ur,kr)&&e.trace(kr,e.Diagnostics.Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1,u,r)):v=i(u),v?(d||(d=new Array(t.length)))[m]=f:(_||(_=[])).push(u)}var y=_&&_.length?Cr(_,r,p,Ct(n.originalFileName)):e.emptyArray;if(!d)return e.Debug.assert(y.length===t.length),y;for(var h=0,m=0;m<d.length;m++)d[m]?d[m]===f&&(d[m]=void 0):(d[m]=y[h],h++);return e.Debug.assert(h===y.length),d}function v(){return!Tt(dr.getProjectReferences(),dr.getResolvedProjectReferences(),function(e,t,r){var n=(r?r.commandLine.projectReferences:_r)[t],i=Rt(n);return e?!i||i.sourceFile!==e.sourceFile:void 0!==i},function(t,r){var n=r?Et(r.sourceFile.path).commandLine.projectReferences:_r;return!e.arrayIsEqualTo(t,n,e.projectReferenceIsEqualTo)})}function h(){if(!dr)return 0;var t=dr.getCompilerOptions();if(e.changesAffectModuleResolution(t,ur))return dr.structureIsReused=0;e.Debug.assert(!(3&dr.structureIsReused));var r=dr.getRootFileNames();if(!e.arrayIsEqualTo(r,cr))return dr.structureIsReused=0;if(!e.arrayIsEqualTo(ur.types,t.types))return dr.structureIsReused=0;if(!v())return dr.structureIsReused=0;_r&&(Jr=_r.map(Rt));var n=[],i=[];if(dr.structureIsReused=2,dr.getMissingFilePaths().some(function(e){return kr.fileExists(e)}))return dr.structureIsReused=0;var a,o=dr.getSourceFiles();!function(e){e[e.Exists=0]="Exists",e[e.Modified=1]="Modified"}(a||(a={}));for(var s=e.createMap(),c=0,u=o;c<u.length;c++){var l=u[c],_=kr.getSourceFileByPath?kr.getSourceFileByPath(l.fileName,l.resolvedPath,ur.target,void 0,Gr):kr.getSourceFile(l.fileName,ur.target,void 0,Gr);if(!_)return dr.structureIsReused=0;e.Debug.assert(!_.redirectInfo,"Host should not return a redirect source file from `getSourceFile`");var d=void 0;if(l.redirectInfo){if(_!==l.redirectInfo.unredirected)return dr.structureIsReused=0;d=!1,_=l}else if(dr.redirectTargetsMap.has(l.path)){if(_!==l)return dr.structureIsReused=0;d=!1}else d=_!==l;_.path=l.path,_.originalFileName=l.originalFileName,_.resolvedPath=l.resolvedPath,_.fileName=l.fileName;var p=dr.sourceFileToPackageName.get(l.path);if(void 0!==p){var f=s.get(p),m=d?1:0;if(void 0!==f&&1===m||1===f)return dr.structureIsReused=0;s.set(p,m)}if(d){if(!e.arrayIsEqualTo(l.libReferenceDirectives,_.libReferenceDirectives,lt))return dr.structureIsReused=0;l.hasNoDefaultLib!==_.hasNoDefaultLib&&(dr.structureIsReused=1),e.arrayIsEqualTo(l.referencedFiles,_.referencedFiles,lt)||(dr.structureIsReused=1),dt(_),e.arrayIsEqualTo(l.imports,_.imports,_t)||(dr.structureIsReused=1),e.arrayIsEqualTo(l.moduleAugmentations,_.moduleAugmentations,_t)||(dr.structureIsReused=1),(1572864&l.flags)!==(1572864&_.flags)&&(dr.structureIsReused=1),e.arrayIsEqualTo(l.typeReferenceDirectives,_.typeReferenceDirectives,lt)||(dr.structureIsReused=1),i.push({oldFile:l,newFile:_})}else Mr(l.path)&&(dr.structureIsReused=1,i.push({oldFile:l,newFile:_}));n.push(_)}if(2!==dr.structureIsReused)return dr.structureIsReused;for(var y=i.map(function(e){return e.oldFile}),h=0,b=o;h<b.length;h++){var x=b[h];if(!e.contains(y,x))for(var D=0,S=x.ambientModuleNames;D<S.length;D++){var C=S[D];pr.set(C,x.fileName)}}for(var k=0,T=i;k<T.length;k++){var E=T[k],l=E.oldFile,_=E.newFile,N=e.getNormalizedAbsolutePath(_.originalFileName,Pr);if(Cr){var F=A(_),P=g(F,N,_),w=e.hasChangesInResolutions(F,P,l.resolvedModules,e.moduleResolutionIsEqualTo);w?(dr.structureIsReused=1,_.resolvedModules=e.zipToMap(F,P)):_.resolvedModules=l.resolvedModules}if(Rr){var I=e.map(_.typeReferenceDirectives,function(e){return e.fileName.toLocaleLowerCase()}),P=Rr(I,N,Ct(_.originalFileName)),w=e.hasChangesInResolutions(I,P,l.resolvedTypeReferenceDirectiveNames,e.typeDirectiveIsEqualTo);w?(dr.structureIsReused=1,_.resolvedTypeReferenceDirectiveNames=e.zipToMap(I,P)):_.resolvedTypeReferenceDirectiveNames=l.resolvedTypeReferenceDirectiveNames}}if(2!==dr.structureIsReused)return dr.structureIsReused;if(kr.hasChangedAutomaticTypeDirectiveNames)return dr.structureIsReused=1;jr=dr.getMissingFilePaths();for(var O=0,M=n;O<M.length;O++){var _=M[O],L=_.path;bt(_,L,_.resolvedPath),dr.isSourceFileFromExternalLibrary(dr.getSourceFileByPath(L))&&xr.set(L,!0)}rr=n,vr=dr.getFileProcessingDiagnostics();for(var R=0,B=i;R<B.length;R++){var j=B[R];vr.reattachFileDiagnostics(j.newFile)}return gr=dr.getResolvedTypeReferenceDirectives(),Kr=dr.sourceFileToPackageName,qr=dr.redirectTargetsMap,dr.structureIsReused=2}function b(t){return i({getPrependNodes:I,getCanonicalFileName:It,getCommonSourceDirectory:$t.getCommonSourceDirectory,getCompilerOptions:$t.getCompilerOptions,getCurrentDirectory:function(){return Pr},getNewLine:function(){return kr.getNewLine()},getSourceFile:$t.getSourceFile,getSourceFileByPath:$t.getSourceFileByPath,getSourceFiles:$t.getSourceFiles,getLibFileFromReference:$t.getLibFileFromReference,isSourceFileFromExternalLibrary:O,getResolvedProjectReferenceToRedirect:Ct,writeFile:t||function(e,t,r,n,i){return kr.writeFile(e,t,r,n,i)},isEmitBlocked:J,readFile:function(e){return kr.readFile(e)},fileExists:function(t){var r=p(t);return U(r)?!0:e.contains(jr,r)?!1:kr.fileExists(t)}},kr.directoryExists?{directoryExists:function(e){return kr.directoryExists(e)}}:{},{useCaseSensitiveFileNames:function(){return kr.useCaseSensitiveFileNames()},getProgramBuildInfo:function(){return $t.getProgramBuildInfo&&$t.getProgramBuildInfo()}})}function S(t){e.Debug.assert(!ur.out&&!ur.outFile),e.performance.mark("beforeEmit");var r=e.emitFiles(e.notImplementedResolver,b(t),void 0,e.noTransformers,!1,!0);return e.performance.mark("afterEmit"),e.performance.measure("Emit","beforeEmit","afterEmit"),r}function P(){return Jr}function w(){return _r}function I(){return k(_r,function(e,t){return Jr[t].commandLine},function(e){var t=p(e),r=U(t);return r?r.text:Wr.has(t)?void 0:kr.readFile(t)})}function O(e){return!!xr.get(e.path)}function M(t){if(t.hasNoDefaultLib)return!0;if(!ur.noLib)return!1;var r=kr.useCaseSensitiveFileNames()?e.equateStringsCaseSensitive:e.equateStringsCaseInsensitive;return ur.lib?e.some(ur.lib,function(n){return r(t.fileName,e.combinePaths(Ar,n))}):r(t.fileName,Nr())}function L(){return ir||(ir=e.createTypeChecker($t,!0))}function R(){ir=void 0}function B(){return ar||(ar=e.createTypeChecker($t,!1))}function j(e,t,r,n,i){return Q(function(){return z($t,e,t,r,n,i)})}function J(e){return Or.has(p(e))}function z(t,r,n,i,a,o){var s=[];if(!a){if(ur.noEmit)return{diagnostics:s,sourceMaps:void 0,emittedFiles:void 0,emitSkipped:!0};if(ur.noEmitOnError){var c=t.getOptionsDiagnostics(i).concat(t.getSyntacticDiagnostics(r,i),t.getGlobalDiagnostics(i),t.getSemanticDiagnostics(r,i));if(0===c.length&&e.getEmitDeclarations(t.getCompilerOptions())&&(s=t.getDeclarationDiagnostics(void 0,i)),c.length>0||s.length>0)return{diagnostics:e.concatenate(c,s),sourceMaps:void 0,emittedFiles:void 0,emitSkipped:!0}}}var u=L().getEmitResolver(ur.outFile||ur.out?void 0:r,i);e.performance.mark("beforeEmit");var l=e.emitFiles(u,b(n),r,e.getTransformers(ur,o,a),a);return e.performance.mark("afterEmit"),e.performance.measure("Emit","beforeEmit","afterEmit"),l}function V(e){return U(p(e))}function U(e){return Wr.get(e)||void 0}function K(t,r,n){return t?r(t,n):e.sortAndDeduplicateDiagnostics(e.flatMap($t.getSourceFiles(),function(e){return n&&n.throwIfCancellationRequested(),r(e,n)}))}function q(e,t){return K(e,G,t)}function W(e,t){return K(e,X,t)}function H(e,t){var r=$t.getCompilerOptions();return!e||r.out||r.outFile?tt(e,t):K(e,it,t)}function G(t){return e.isSourceFileJS(t)?(t.additionalSyntacticDiagnostics||(t.additionalSyntacticDiagnostics=et(t)),e.concatenate(t.additionalSyntacticDiagnostics,t.parseDiagnostics)):t.parseDiagnostics}function Q(t){try{return t()}catch(r){throw r instanceof e.OperationCanceledException&&(ar=void 0,ir=void 0),r}}function X(e,t){return nt(e,t,fr,Y)}function Y(t,r){return Q(function(){if(e.skipTypeChecking(t,ur))return e.emptyArray;var n=L();e.Debug.assert(!!t.bindDiagnostics);for(var i,a=e.isCheckJsEnabledForFile(t,ur),o=3===t.scriptKind||4===t.scriptKind||5===t.scriptKind||a||7===t.scriptKind,s=o?t.bindDiagnostics:e.emptyArray,c=o?n.getDiagnostics(t,r):e.emptyArray,u=vr.getDiagnostics(t.fileName),l=Fr.getDiagnostics(t.fileName),_=0,d=[s,c,u,l,a?t.jsDocDiagnostics:void 0];_<d.length;_++){var p=d[_];if(p)for(var f=0,m=p;f<m.length;f++){var g=m[f];$(g)&&(i=e.append(i,g))}}return i})}function Z(e,t){return Q(function(){return L().getSuggestionDiagnostics(e,t)})}function $(t){var r=t.file,n=t.start;if(r)for(var i=e.getLineStarts(r),a=e.computeLineAndCharacterOfPosition(i,n).line;a>0;){var o=r.text.slice(i[a-1],i[a]),s=F.exec(o);if(!s)return!0;if(s[3])return!1;a--}return!0}function et(t){return Q(function(){function r(t){switch(c.kind){case 152:case 155:if(c.questionToken===t)return void s.push(o(t,e.Diagnostics._0_can_only_be_used_in_a_ts_file,"?"));case 157:case 156:case 158:case 159:case 160:case 197:case 240:case 198:case 238:if(c.type===t)return void s.push(o(t,e.Diagnostics.types_can_only_be_used_in_a_ts_file))}switch(t.kind){case 249:return void s.push(o(t,e.Diagnostics.import_can_only_be_used_in_a_ts_file));case 255:if(t.isExportEquals)return void s.push(o(t,e.Diagnostics.export_can_only_be_used_in_a_ts_file));break;case 274:var i=t;if(110===i.token)return void s.push(o(t,e.Diagnostics.implements_clauses_can_only_be_used_in_a_ts_file));break;case 242:return void s.push(o(t,e.Diagnostics.interface_declarations_can_only_be_used_in_a_ts_file));case 245:return void s.push(o(t,e.Diagnostics.module_declarations_can_only_be_used_in_a_ts_file));case 243:return void s.push(o(t,e.Diagnostics.type_aliases_can_only_be_used_in_a_ts_file));case 244:return void s.push(o(t,e.Diagnostics.enum_declarations_can_only_be_used_in_a_ts_file));case 214:return void s.push(o(t,e.Diagnostics.non_null_assertions_can_only_be_used_in_a_ts_file));case 213:return void s.push(o(t.type,e.Diagnostics.type_assertion_expressions_can_only_be_used_in_a_ts_file));case 195:e.Debug.fail()}var a=c;c=t,e.forEachChild(t,r,n),c=a}function n(t){switch(c.decorators!==t||ur.experimentalDecorators||s.push(o(c,e.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning)),c.kind){case 241:case 157:case 156:case 158:case 159:case 160:case 197:case 240:case 198:if(t===c.typeParameters)return void s.push(a(t,e.Diagnostics.type_parameter_declarations_can_only_be_used_in_a_ts_file));case 220:if(t===c.modifiers)return i(t,220===c.kind);break;case 155:if(t===c.modifiers){for(var n=0,u=t;n<u.length;n++){var l=u[n];117!==l.kind&&s.push(o(l,e.Diagnostics._0_can_only_be_used_in_a_ts_file,e.tokenToString(l.kind)))}return}break;case 152:if(t===c.modifiers)return void s.push(a(t,e.Diagnostics.parameter_modifiers_can_only_be_used_in_a_ts_file));break;case 192:case 193:case 212:case 262:case 263:if(t===c.typeArguments)return void s.push(a(t,e.Diagnostics.type_arguments_can_only_be_used_in_a_ts_file))}for(var _=0,d=t;_<d.length;_++){var p=d[_];r(p)}}function i(t,r){for(var n=0,i=t;n<i.length;n++){var a=i[n];switch(a.kind){case 78:if(r)continue;case 116:case 114:case 115:case 134:case 126:case 119:s.push(o(a,e.Diagnostics._0_can_only_be_used_in_a_ts_file,e.tokenToString(a.kind)));break;case 117:case 86:case 81:}}}function a(r,n,i,a,o){var s=r.pos;return e.createFileDiagnostic(t,s,r.end-s,n,i,a,o)}function o(r,n,i,a,o){return e.createDiagnosticForNodeInSourceFile(t,r,n,i,a,o)}var s=[],c=t;return r(t),s})}function tt(e,t){return nt(e,t,mr,rt)}function rt(t,r){return Q(function(){var n=L().getEmitResolver(t,r);return e.getDeclarationDiagnostics(b(e.noop),n,t)})}function nt(t,r,n,i){var a=t?n.perFile&&n.perFile.get(t.path):n.allDiagnostics;if(a)return a;var o=i(t,r)||e.emptyArray;return t?(n.perFile||(n.perFile=e.createMap()),n.perFile.set(t.path,o)):n.allDiagnostics=o,o}function it(e,t){return e.isDeclarationFile?[]:tt(e,t)}function at(){return e.sortAndDeduplicateDiagnostics(e.concatenate(vr.getGlobalDiagnostics(),e.concatenate(Fr.getGlobalDiagnostics(),ot())))}function ot(){if(!ur.configFile)return e.emptyArray;var t=Fr.getDiagnostics(ur.configFile.fileName);return kt(function(r){r&&(t=e.concatenate(t,Fr.getDiagnostics(r.sourceFile.fileName)))}),t}function st(){return cr.length?e.sortAndDeduplicateDiagnostics(L().getGlobalDiagnostics().slice()):e.emptyArray}function ct(){return lr||e.emptyArray}function ut(t,r,n){gt(e.normalizePath(t),r,n,void 0)}function lt(e,t){return e.fileName===t.fileName}function _t(e,t){return 73===e.kind?73===t.kind&&e.escapedText===t.escapedText:10===t.kind&&e.text===t.text}function dt(t){function r(n,i){if(e.isAnyImportOrReExport(n)){var c=e.getExternalModuleName(n);!(c&&e.isStringLiteral(c)&&c.text)||i&&e.isExternalModuleNameRelative(c.text)||(a=e.append(a,c))}else if(e.isModuleDeclaration(n)&&e.isAmbientModule(n)&&(i||e.hasModifier(n,2)||t.isDeclarationFile)){var l=e.getTextOfIdentifierOrLiteral(n.name);if(u||i&&!e.isExternalModuleNameRelative(l))(o||(o=[])).push(n.name);else if(!i){t.isDeclarationFile&&(s||(s=[])).push(l);var _=n.body;if(_)for(var d=0,p=_.statements;d<p.length;d++){var f=p[d];r(f,!0)}}}}function n(t){for(var r=/import|require/g;null!==r.exec(t.text);){var n=i(t,r.lastIndex);e.isRequireCall(n,!0)?a=e.append(a,n.arguments[0]):e.isImportCall(n)&&1===n.arguments.length&&e.isStringLiteralLike(n.arguments[0])?a=e.append(a,n.arguments[0]):e.isLiteralImportTypeNode(n)&&(a=e.append(a,n.argument.literal))}}function i(t,r){for(var n=t,i=function(e){return e.pos<=r&&(r<e.end||r===e.end&&1===e.kind)?e:void 0};;){var a=c&&e.hasJSDocNodes(n)&&e.forEach(n.jsDoc,i)||e.forEachChild(n,i);if(!a)return n;n=a}}if(!t.imports){var a,o,s,c=e.isSourceFileJS(t),u=e.isExternalModule(t);if(ur.importHelpers&&(ur.isolatedModules||u)&&!t.isDeclarationFile){var l=e.createLiteral(e.externalHelpersModuleNameText),_=e.createImportDeclaration(void 0,void 0,void 0,l);e.addEmitFlags(_,67108864),l.parent=_,_.parent=t,a=[l]}for(var d=0,p=t.statements;d<p.length;d++){var f=p[d];r(f,!1)}(524288&t.flags||c)&&n(t),t.imports=a||e.emptyArray,t.moduleAugmentations=o||e.emptyArray,t.ambientModuleNames=s||e.emptyArray}}function pt(t){var r=t.fileName.toLocaleLowerCase(),n=e.libMap.get(r);return n?V(e.combinePaths(Ar,n)):void 0}function ft(e,t){return mt(r(t.fileName,e.fileName),function(e){return Wr.get(p(e))||void 0})}function mt(t,r,n,i){if(e.hasExtension(t)){if(!ur.allowNonTsExtensions&&!e.forEach(Ir,function(r){return e.fileExtensionIs(kr.getCanonicalFileName(t),r)}))return void(n&&n(e.Diagnostics.File_0_has_unsupported_extension_The_only_supported_extensions_are_1,t,"'"+wr.join("', '")+"'"));var a=r(t);if(n)if(a)i&&kr.getCanonicalFileName(t)===kr.getCanonicalFileName(i.fileName)&&n(e.Diagnostics.A_file_cannot_have_a_reference_to_itself);else{var o=xt(t);o?n(e.Diagnostics.Output_file_0_has_not_been_built_from_source_file_1,o,t):n(e.Diagnostics.File_0_not_found,t)}return a}var s=ur.allowNonTsExtensions&&r(t);if(s)return s;if(n&&ur.allowNonTsExtensions)return void n(e.Diagnostics.File_0_not_found,t);var c=e.forEach(wr,function(e){return r(t+e)});return n&&!c&&n(e.Diagnostics.File_0_not_found,t+".ts"),c}function gt(t,r,n,i,a,o,s){mt(t,function(e){return ht(e,p(e),r,n,a,o,s,i)},function(t){for(var r=[],n=1;n<arguments.length;n++)r[n-1]=arguments[n];vr.add(void 0!==a&&void 0!==s&&void 0!==o?e.createFileDiagnostic.apply(void 0,[a,o,s-o,t].concat(r)):e.createCompilerDiagnostic.apply(void 0,[t].concat(r)))},a)}function vt(t,r,n,i,a){vr.add(void 0!==n&&void 0!==i&&void 0!==a?e.createFileDiagnostic(n,i,a-i,e.Diagnostics.File_name_0_differs_from_already_included_file_name_1_only_in_casing,t,r):e.createCompilerDiagnostic(e.Diagnostics.File_name_0_differs_from_already_included_file_name_1_only_in_casing,t,r))}function yt(e,t,r,n,i,a){var o=Object.create(e);return o.fileName=r,o.path=n,o.resolvedPath=i,o.originalFileName=a,o.redirectInfo={redirectTarget:e,unredirected:t},xr.set(n,hr>0),Object.defineProperties(o,{id:{get:function(){return this.redirectInfo.redirectTarget.id},set:function(e){this.redirectInfo.redirectTarget.id=e}},symbol:{get:function(){return this.redirectInfo.redirectTarget.symbol},set:function(e){this.redirectInfo.redirectTarget.symbol=e}}}),o}function ht(t,r,n,i,a,o,s,c){var u=t;if(Wr.has(r)){var l=Wr.get(r);if(l&&ur.forceConsistentCasingInFileNames){var _=t,d=l.fileName,f=p(d)!==p(_);f&&(_=xt(t)||t);var m=e.getNormalizedAbsolutePathWithoutRoot(d,Pr),g=e.getNormalizedAbsolutePathWithoutRoot(_,Pr);m!==g&&vt(_,d,a,o,s)}return l&&xr.get(l.path)&&0===hr?(xr.set(l.path,!1),ur.noResolve||(Nt(l,n),At(l)),ur.noLib||Pt(l),br.set(l.path,!1),Ot(l)):l&&br.get(l.path)&&yr>hr&&(br.set(l.path,!1),Ot(l)),l||void 0}var v;if(a){var y=Dt(t);if(y){if(y.commandLine.options.outFile||y.commandLine.options.out)return void 0;var h=St(y,t);t=h,v=p(h)}}var b=kr.getSourceFile(t,ur.target,function(r){vr.add(void 0!==a&&void 0!==o&&void 0!==s?e.createFileDiagnostic(a,o,s-o,e.Diagnostics.Cannot_read_file_0_Colon_1,t,r):e.createCompilerDiagnostic(e.Diagnostics.Cannot_read_file_0_Colon_1,t,r))},Gr);if(c){var x=e.packageIdToString(c),D=Ur.get(x);if(D){var S=yt(D,b,t,r,p(t),u);return qr.add(D.path,t),bt(S,r,v),Kr.set(r,c.name),tr.push(S),S}b&&(Ur.set(x,b),Kr.set(r,c.name))}if(bt(b,r,v),b){if(xr.set(r,hr>0),b.path=r,b.resolvedPath=p(t),b.originalFileName=u,kr.useCaseSensitiveFileNames()){var C=r.toLowerCase(),k=Hr.get(C);k?vt(t,k.fileName,a,o,s):Hr.set(C,b)}Er=Er||b.hasNoDefaultLib&&!i,ur.noResolve||(Nt(b,n),At(b)),ur.noLib||Pt(b),Ot(b),n?er.push(b):tr.push(b)}return b}function bt(e,t,r){r?(Wr.set(r,e),Wr.set(t,e||!1)):Wr.set(t,e)}function xt(e){var t=Dt(e);return t&&St(t,e)}function Dt(t){return Jr&&Jr.length&&!e.fileExtensionIs(t,".d.ts")&&e.fileExtensionIsOneOf(t,e.supportedTSExtensions)?Ct(t):void 0}function St(t,r){var n=t.commandLine.options.outFile||t.commandLine.options.out;return n?e.changeExtension(n,".d.ts"):e.getOutputDeclarationFileName(r,t.commandLine,!kr.useCaseSensitiveFileNames())}function Ct(t){void 0===Vr&&(Vr=e.createMap(),kt(function(e,t){e&&p(ur.configFilePath)!==t&&e.commandLine.fileNames.forEach(function(e){return Vr.set(p(e),t)})}));var r=Vr.get(p(t));return r&&Et(r)}function kt(e){return Tt(_r,Jr,function(t,r,n){var i=(n?n.commandLine.projectReferences:_r)[r],a=p(T(i));return e(t,a)})}function Tt(t,r,n,i){function a(t,r,n,i,s){if(s){var c=s(t,n);if(c)return c}return e.forEach(r,function(t,r){if(e.contains(o,t))return void 0;var c=i(t,r,n);return c?c:t?((o||(o=[])).push(t),a(t.commandLine.projectReferences,t.references,t,i,s)):void 0})}var o;return a(t,r,void 0,n,i)}function Et(e){return zr?zr.get(e)||void 0:void 0}function Nt(t,n){e.forEach(t.referencedFiles,function(e){var i=r(e.fileName,t.originalFileName);gt(i,n,!1,void 0,t,e.pos,e.end)})}function At(t){var r=e.map(t.typeReferenceDirectives,function(e){return e.fileName.toLocaleLowerCase()});if(r)for(var n=Rr(r,t.originalFileName,Ct(t.originalFileName)),i=0;i<r.length;i++){var a=t.typeReferenceDirectives[i],o=n[i],s=a.fileName.toLocaleLowerCase();e.setResolvedTypeReferenceDirective(t,s,o),Ft(s,o,t,a.pos,a.end)}}function Ft(t,r,n,i,a){var o=gr.get(t);if(!o||!o.primary){var s=!0;if(r){if(r.isExternalLibraryImport&&hr++,r.primary)gt(r.resolvedFileName,!1,!1,r.packageId,n,i,a);else if(o){if(r.resolvedFileName!==o.resolvedFileName){var c=kr.readFile(r.resolvedFileName);c!==V(o.resolvedFileName).text&&vr.add(wt(n,i,a,e.Diagnostics.Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict,t,r.resolvedFileName,o.resolvedFileName))}s=!1}else gt(r.resolvedFileName,!1,!1,r.packageId,n,i,a);r.isExternalLibraryImport&&hr--}else vr.add(wt(n,i,a,e.Diagnostics.Cannot_find_type_definition_file_for_0,t));s&&gr.set(t,r)}}function Pt(t){e.forEach(t.libReferenceDirectives,function(r){var n=r.fileName.toLocaleLowerCase(),i=e.libMap.get(n);if(i)ut(e.combinePaths(Ar,i),!0,!0);else{var a=e.removeSuffix(e.removePrefix(n,"lib."),".d.ts"),o=e.getSpellingSuggestion(a,e.libs,e.identity),s=o?e.Diagnostics.Cannot_find_lib_definition_for_0_Did_you_mean_1:e.Diagnostics.Cannot_find_lib_definition_for_0;vr.add(wt(t,r.pos,r.end,s,n,o))}})}function wt(t,r,n,i){for(var a=[],o=4;o<arguments.length;o++)a[o-4]=arguments[o];return void 0===t||void 0===r||void 0===n?e.createCompilerDiagnostic.apply(void 0,[i].concat(a)):e.createFileDiagnostic.apply(void 0,[t,r,n-r,i].concat(a))}function It(e){return kr.getCanonicalFileName(e)}function Ot(t){if(dt(t),t.imports.length||t.moduleAugmentations.length){var r=A(t),n=g(r,e.getNormalizedAbsolutePath(t.originalFileName,Pr),t);e.Debug.assert(n.length===r.length);for(var i=0;i<r.length;i++){var a=n[i];if(e.setResolvedModule(t,r[i],a),a){var o=a.isExternalLibraryImport,s=!e.resolutionExtensionIsTSOrJson(a.extension),c=o&&s,u=a.resolvedFileName;o&&hr++;var l=c&&hr>yr,_=!(!u||N(ur,a)||ur.noResolve||!(i<t.imports.length)||l||s&&!ur.allowJs||!e.isInJSFile(t.imports[i])&&2097152&t.imports[i].flags);if(l)br.set(t.path,!0);else if(_){var d=p(u),f=e.skipTrivia(t.text,t.imports[i].pos);ht(u,d,!1,!1,t,f,t.imports[i].end,a.packageId)}o&&hr--}}}else t.resolvedModules=void 0}function Mt(t){var r=e.mapDefined(t,function(e){return e.isDeclarationFile?void 0:e.fileName});return n(r,Pr,It)}function Lt(t,r){for(var n=!0,i=kr.getCanonicalFileName(e.getNormalizedAbsolutePath(r,Pr)),a=0,o=t;a<o.length;a++){var s=o[a];if(!s.isDeclarationFile){var c=kr.getCanonicalFileName(e.getNormalizedAbsolutePath(s.fileName,Pr));0!==c.indexOf(i)&&(Fr.add(e.createCompilerDiagnostic(e.Diagnostics.File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files,s.fileName,r)),n=!1)
}}return n}function Rt(t){zr||(zr=e.createMap());var r=T(t),n=p(r),i=zr.get(n);if(void 0!==i)return i||void 0;var a,o;if(kr.getParsedCommandLine){if(a=kr.getParsedCommandLine(r),!a)return bt(void 0,n,void 0),void zr.set(n,!1);o=e.Debug.assertDefined(a.options.configFile),e.Debug.assert(!o.path||o.path===n),bt(o,n,void 0)}else{var s=e.getNormalizedAbsolutePath(e.getDirectoryPath(r),kr.getCurrentDirectory());if(o=kr.getSourceFile(r,100),bt(o,n,void 0),void 0===o)return void zr.set(n,!1);a=e.parseJsonSourceFileConfigFileContent(o,Tr,s,void 0,r)}o.path=n,o.resolvedPath=n,o.originalFileName=r;var c={commandLine:a,sourceFile:o};return zr.set(n,c),a.projectReferences&&(c.references=a.projectReferences.map(Rt)),c}function Bt(){function t(t,r){if(t){var n=p(t);if(Wr.has(n)){var i=void 0;ur.configFilePath||(i=e.chainDiagnosticMessages(void 0,e.Diagnostics.Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig)),i=e.chainDiagnosticMessages(i,e.Diagnostics.Cannot_write_file_0_because_it_would_overwrite_input_file,t),Xt(t,e.createCompilerDiagnosticFromMessageChain(i))}var a=kr.useCaseSensitiveFileNames()?n:n.toLocaleLowerCase();r.has(a)?Xt(t,e.createCompilerDiagnostic(e.Diagnostics.Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files,t)):r.set(a,!0)}}if(ur.strictPropertyInitialization&&!e.getStrictOptionValue(ur,"strictNullChecks")&&Kt(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1,"strictPropertyInitialization","strictNullChecks"),ur.isolatedModules&&(e.getEmitDeclarations(ur)&&Kt(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,E(ur),"isolatedModules"),ur.out&&Kt(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"out","isolatedModules"),ur.outFile&&Kt(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"outFile","isolatedModules")),ur.inlineSourceMap&&(ur.sourceMap&&Kt(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"sourceMap","inlineSourceMap"),ur.mapRoot&&Kt(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"mapRoot","inlineSourceMap")),ur.paths&&void 0===ur.baseUrl&&Kt(e.Diagnostics.Option_paths_cannot_be_used_without_specifying_baseUrl_option,"paths"),ur.composite&&(ur.declaration===!1&&Kt(e.Diagnostics.Composite_projects_may_not_disable_declaration_emit,"declaration"),ur.incremental===!1&&Kt(e.Diagnostics.Composite_projects_may_not_disable_incremental_compilation,"declaration")),ur.tsBuildInfoFile?e.isIncrementalCompilation(ur)||Kt(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"tsBuildInfoFile","incremental","composite"):!ur.incremental||ur.outFile||ur.out||ur.configFilePath||Fr.add(e.createCompilerDiagnostic(e.Diagnostics.Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified)),jt(),ur.composite)for(var r=cr.map(p),n=0,i=rr;n<i.length;n++){var a=i[n];e.sourceFileMayBeEmitted(a,ur,O,Ct)&&-1===r.indexOf(a.path)&&Fr.add(e.createCompilerDiagnostic(e.Diagnostics.File_0_is_not_in_project_file_list_Projects_must_list_all_files_or_use_an_include_pattern,a.fileName))}if(ur.paths)for(var o in ur.paths)if(e.hasProperty(ur.paths,o))if(e.hasZeroOrOneAsteriskCharacter(o)||zt(!0,o,e.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character,o),e.isArray(ur.paths[o])){var s=ur.paths[o].length;0===s&&zt(!1,o,e.Diagnostics.Substitutions_for_pattern_0_shouldn_t_be_an_empty_array,o);for(var c=0;s>c;c++){var u=ur.paths[o][c],l=typeof u;"string"===l?e.hasZeroOrOneAsteriskCharacter(u)||Jt(o,c,e.Diagnostics.Substitution_0_in_pattern_1_in_can_have_at_most_one_Asterisk_character,u,o):Jt(o,c,e.Diagnostics.Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2,u,o,l)}}else zt(!1,o,e.Diagnostics.Substitutions_for_pattern_0_should_be_an_array,o);ur.sourceMap||ur.inlineSourceMap||(ur.inlineSources&&Kt(e.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided,"inlineSources"),ur.sourceRoot&&Kt(e.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided,"sourceRoot")),ur.out&&ur.outFile&&Kt(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"out","outFile"),!ur.mapRoot||ur.sourceMap||ur.declarationMap||Kt(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"mapRoot","sourceMap","declarationMap"),ur.declarationDir&&(e.getEmitDeclarations(ur)||Kt(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"declarationDir","declaration","composite"),(ur.out||ur.outFile)&&Kt(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"declarationDir",ur.out?"out":"outFile")),ur.declarationMap&&!e.getEmitDeclarations(ur)&&Kt(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"declarationMap","declaration","composite"),ur.lib&&ur.noLib&&Kt(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"lib","noLib"),ur.noImplicitUseStrict&&e.getStrictOptionValue(ur,"alwaysStrict")&&Kt(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"noImplicitUseStrict","alwaysStrict");var _=ur.target||0,d=ur.outFile||ur.out,m=e.find(rr,function(t){return e.isExternalModule(t)&&!t.isDeclarationFile});if(ur.isolatedModules){ur.module===e.ModuleKind.None&&2>_&&Kt(e.Diagnostics.Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher,"isolatedModules","target");var g=e.find(rr,function(t){return!e.isExternalModule(t)&&!e.isSourceFileJS(t)&&!t.isDeclarationFile&&6!==t.scriptKind});if(g){var v=e.getErrorSpanForNode(g,g);Fr.add(e.createFileDiagnostic(g,v.start,v.length,e.Diagnostics.All_files_must_be_modules_when_the_isolatedModules_flag_is_provided))}}else if(m&&2>_&&ur.module===e.ModuleKind.None){var v=e.getErrorSpanForNode(m,m.externalModuleIndicator);Fr.add(e.createFileDiagnostic(m,v.start,v.length,e.Diagnostics.Cannot_use_imports_exports_or_module_augmentations_when_module_is_none))}if(d&&!ur.emitDeclarationOnly)if(ur.module&&ur.module!==e.ModuleKind.AMD&&ur.module!==e.ModuleKind.System)Kt(e.Diagnostics.Only_amd_and_system_modules_are_supported_alongside_0,ur.out?"out":"outFile","module");else if(void 0===ur.module&&m){var v=e.getErrorSpanForNode(m,m.externalModuleIndicator);Fr.add(e.createFileDiagnostic(m,v.start,v.length,e.Diagnostics.Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system,ur.out?"out":"outFile"))}if(ur.resolveJsonModule&&(e.getEmitModuleResolutionKind(ur)!==e.ModuleResolutionKind.NodeJs?Kt(e.Diagnostics.Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy,"resolveJsonModule"):e.hasJsonModuleEmitEnabled(ur)||Kt(e.Diagnostics.Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_esNext,"resolveJsonModule","module")),ur.outDir||ur.sourceRoot||ur.mapRoot){var y=f();ur.outDir&&""===y&&rr.some(function(t){return e.getRootLength(t.fileName)>1})&&Kt(e.Diagnostics.Cannot_find_the_common_subdirectory_path_for_the_input_files,"outDir")}if(!ur.noEmit&&ur.allowJs&&e.getEmitDeclarations(ur)&&Kt(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"allowJs",E(ur)),ur.checkJs&&!ur.allowJs&&Fr.add(e.createCompilerDiagnostic(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1,"checkJs","allowJs")),ur.emitDeclarationOnly&&(e.getEmitDeclarations(ur)||Kt(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"emitDeclarationOnly","declaration","composite"),ur.noEmit&&Kt(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"emitDeclarationOnly","noEmit")),ur.emitDecoratorMetadata&&!ur.experimentalDecorators&&Kt(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1,"emitDecoratorMetadata","experimentalDecorators"),ur.jsxFactory?(ur.reactNamespace&&Kt(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"reactNamespace","jsxFactory"),e.parseIsolatedEntityName(ur.jsxFactory,_)||qt("jsxFactory",e.Diagnostics.Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name,ur.jsxFactory)):ur.reactNamespace&&!e.isIdentifierText(ur.reactNamespace,_)&&qt("reactNamespace",e.Diagnostics.Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier,ur.reactNamespace),!ur.noEmit&&!ur.suppressOutputPathCheck){var h=b(),x=e.createMap();e.forEachEmittedFile(h,function(e){ur.emitDeclarationOnly||t(e.jsFilePath,x),t(e.declarationFilePath,x)})}}function jt(){var t=ur.noEmit||ur.suppressOutputPathCheck?void 0:e.getOutputPathForBuildInfo(ur);Tt(_r,Jr,function(r,n,i){var a=(i?i.commandLine.projectReferences:_r)[n],o=i&&i.sourceFile;if(!r)return void Wt(o,n,e.Diagnostics.File_0_not_found,a.path);var s=r.commandLine.options;if(!s.composite){var c=i?i.commandLine.fileNames:cr;c.length&&Wt(o,n,e.Diagnostics.Referenced_project_0_must_have_setting_composite_Colon_true,a.path)}if(a.prepend){var u=s.outFile||s.out;u?kr.fileExists(u)||Wt(o,n,e.Diagnostics.Output_file_0_from_project_1_does_not_exist,u,a.path):Wt(o,n,e.Diagnostics.Cannot_prepend_project_0_because_it_does_not_have_outFile_set,a.path)}!i&&t&&t===e.getOutputPathForBuildInfo(s)&&(Wt(o,n,e.Diagnostics.Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1,t,a.path),Or.set(p(t),!0))})}function Jt(t,r,n,i,a,o){for(var s=!0,c=Ut(),u=0,l=c;u<l.length;u++){var _=l[u];if(e.isObjectLiteralExpression(_.initializer))for(var d=0,p=e.getPropertyAssignment(_.initializer,t);d<p.length;d++){var f=p[d],m=f.initializer;e.isArrayLiteralExpression(m)&&m.elements.length>r&&(Fr.add(e.createDiagnosticForNodeInSourceFile(ur.configFile,m.elements[r],n,i,a,o)),s=!1)}}s&&Fr.add(e.createCompilerDiagnostic(n,i,a,o))}function zt(t,r,n,i){for(var a=!0,o=Ut(),s=0,c=o;s<c.length;s++){var u=c[s];e.isObjectLiteralExpression(u.initializer)&&Qt(u.initializer,t,r,void 0,n,i)&&(a=!1)}a&&Fr.add(e.createCompilerDiagnostic(n,i))}function Vt(t){var r=Gt();return r?e.getPropertyAssignment(r,t):void 0}function Ut(){return Vt("paths")||e.emptyArray}function Kt(e,t,r,n){Ht(!0,t,r,e,t,r,n)}function qt(e,t,r){Ht(!1,e,void 0,t,r)}function Wt(t,r,n,i,a){var o=e.firstDefined(e.getTsConfigPropArray(t||ur.configFile,"references"),function(t){return e.isArrayLiteralExpression(t.initializer)?t.initializer:void 0});Fr.add(o&&o.elements.length>r?e.createDiagnosticForNodeInSourceFile(t||ur.configFile,o.elements[r],n,i,a):e.createCompilerDiagnostic(n,i,a))}function Ht(t,r,n,i,a,o,s){var c=Gt(),u=!c||!Qt(c,t,r,n,i,a,o,s);u&&Fr.add(e.createCompilerDiagnostic(i,a,o,s))}function Gt(){if(void 0===Dr){Dr=null;var t=e.getTsConfigObjectLiteralExpression(ur.configFile);if(t)for(var r=0,n=e.getPropertyAssignment(t,"compilerOptions");r<n.length;r++){var i=n[r];if(e.isObjectLiteralExpression(i.initializer)){Dr=i.initializer;break}}}return Dr}function Qt(t,r,n,i,a,o,s,c){for(var u=e.getPropertyAssignment(t,n,i),l=0,_=u;l<_.length;l++){var d=_[l];Fr.add(e.createDiagnosticForNodeInSourceFile(ur.configFile,r?d.name:d.initializer,a,o,s,c))}return!!u.length}function Xt(e,t){Or.set(p(e),!0),Fr.add(t)}function Yt(t){if(ur.noEmit)return!1;var r=p(t);if(U(r))return!1;var n=ur.outFile||ur.out;if(n)return Zt(r,n)||Zt(r,e.removeFileExtension(n)+".d.ts");if(ur.declarationDir&&e.containsPath(ur.declarationDir,r,Pr,!kr.useCaseSensitiveFileNames()))return!0;if(ur.outDir)return e.containsPath(ur.outDir,r,Pr,!kr.useCaseSensitiveFileNames());if(e.fileExtensionIsOneOf(r,e.supportedJSExtensions)||e.fileExtensionIs(r,".d.ts")){var i=e.removeFileExtension(r);return!!U(i+".ts")||!!U(i+".tsx")}return!1}function Zt(t,r){return 0===e.comparePaths(t,r,Pr,!kr.useCaseSensitiveFileNames())}var $t,er,tr,rr,nr,ir,ar,or,sr=e.isArray(t)?D(t,o,s,c,u):t,cr=sr.rootNames,ur=sr.options,lr=sr.configFileParsingDiagnostics,_r=sr.projectReferences,dr=sr.oldProgram,pr=e.createMap(),fr={},mr={},gr=e.createMap(),vr=e.createDiagnosticCollection(),yr="number"==typeof ur.maxNodeModuleJsDepth?ur.maxNodeModuleJsDepth:0,hr=0,br=e.createMap(),xr=e.createMap();e.performance.mark("beforeProgram");var Dr,Sr,Cr,kr=sr.host||a(ur),Tr=C(kr),Er=ur.noLib,Nr=e.memoize(function(){return kr.getDefaultLibFileName(ur)}),Ar=kr.getDefaultLibLocation?kr.getDefaultLibLocation():e.getDirectoryPath(Nr()),Fr=e.createDiagnosticCollection(),Pr=kr.getCurrentDirectory(),wr=e.getSupportedExtensions(ur),Ir=e.getSuppoertedExtensionsWithJsonIfResolveJsonModule(ur,wr),Or=e.createMap(),Mr=kr.hasInvalidatedResolution||e.returnFalse;if(kr.resolveModuleNames)Cr=function(t,r,n,i){return kr.resolveModuleNames(e.Debug.assertEachDefined(t),r,n,i).map(function(t){if(!t||void 0!==t.extension)return t;var r=e.clone(t);return r.extension=e.extensionFromPath(t.resolvedFileName),r})};else{Sr=e.createModuleResolutionCache(Pr,function(e){return kr.getCanonicalFileName(e)},ur);var Lr=function(t,r,n){return e.resolveModuleName(t,r,ur,kr,Sr,n).resolvedModule};Cr=function(t,r,n,i){return y(e.Debug.assertEachDefined(t),r,i,Lr)}}var Rr;if(kr.resolveTypeReferenceDirectives)Rr=function(t,r,n){return kr.resolveTypeReferenceDirectives(e.Debug.assertEachDefined(t),r,n)};else{var Br=function(t,r,n){return e.resolveTypeReferenceDirective(t,r,ur,kr,n).resolvedTypeReferenceDirective};Rr=function(t,r,n){return y(e.Debug.assertEachDefined(t),r,n,Br)}}var jr,Jr,zr,Vr,Ur=e.createMap(),Kr=e.createMap(),qr=e.createMultiMap(),Wr=e.createMap(),Hr=kr.useCaseSensitiveFileNames()?e.createMap():void 0,Gr=x(dr,ur),Qr=h();if(2!==Qr){if(er=[],tr=[],_r&&(Jr||(Jr=_r.map(Rt)),cr.length))for(var Xr=0,Yr=Jr;Xr<Yr.length;Xr++){var Zr=Yr[Xr];if(Zr){var $r=Zr.commandLine.options.outFile||Zr.commandLine.options.out;if($r)gt(e.changeExtension($r,".d.ts"),!1,!1,void 0);else if(e.getEmitModuleKind(Zr.commandLine.options)===e.ModuleKind.None)for(var en=0,tn=Zr.commandLine.fileNames;en<tn.length;en++){var rn=tn[en];!e.fileExtensionIs(rn,".d.ts")&&e.hasTSFileExtension(rn)&&gt(e.getOutputDeclarationFileName(rn,Zr.commandLine,!kr.useCaseSensitiveFileNames()),!1,!1,void 0)}}}e.forEach(cr,function(e){return ut(e,!1,!1)});var nn=cr.length?e.getAutomaticTypeDirectiveNames(ur,kr):e.emptyArray;if(nn.length)for(var an=ur.configFilePath?e.getDirectoryPath(ur.configFilePath):kr.getCurrentDirectory(),on=e.combinePaths(an,"__inferred type names__.ts"),sn=Rr(nn,on),cn=0;cn<nn.length;cn++)Ft(nn[cn],sn[cn]);if(cr.length&&!Er){var un=Nr();!ur.lib&&un?ut(un,!0,!1):e.forEach(ur.lib,function(t){ut(e.combinePaths(Ar,t),!0,!1)})}jr=e.arrayFrom(e.mapDefinedIterator(Wr.entries(),function(e){var t=e[0],r=e[1];return void 0===r?t:void 0})),rr=e.stableSort(er,l).concat(tr),er=void 0,tr=void 0}if(e.Debug.assert(!!jr),dr&&kr.onReleaseOldSourceFile){for(var ln=dr.getSourceFiles(),_n=0,dn=ln;_n<dn.length;_n++){var pn=dn[_n],fn=U(pn.resolvedPath);(Gr||!fn||pn.resolvedPath===pn.path&&fn.resolvedPath!==pn.path)&&kr.onReleaseOldSourceFile(pn,dr.getCompilerOptions(),!!U(pn.path))}dr.forEachResolvedProjectReference(function(e,t){e&&!Et(t)&&kr.onReleaseOldSourceFile(e.sourceFile,dr.getCompilerOptions(),!1)})}return dr=void 0,$t={getRootFileNames:function(){return cr},getSourceFile:V,getSourceFileByPath:U,getSourceFiles:function(){return rr},getMissingFilePaths:function(){return jr},getCompilerOptions:function(){return ur},getSyntacticDiagnostics:q,getOptionsDiagnostics:at,getGlobalDiagnostics:st,getSemanticDiagnostics:W,getSuggestionDiagnostics:Z,getDeclarationDiagnostics:H,getTypeChecker:B,getClassifiableNames:m,getDiagnosticsProducingTypeChecker:L,getCommonSourceDirectory:f,emit:j,getCurrentDirectory:function(){return Pr},getNodeCount:function(){return L().getNodeCount()},getIdentifierCount:function(){return L().getIdentifierCount()},getSymbolCount:function(){return L().getSymbolCount()},getTypeCount:function(){return L().getTypeCount()},getRelationCacheSizes:function(){return L().getRelationCacheSizes()},getFileProcessingDiagnostics:function(){return vr},getResolvedTypeReferenceDirectives:function(){return gr},isSourceFileFromExternalLibrary:O,isSourceFileDefaultLibrary:M,dropDiagnosticsProducingTypeChecker:R,getSourceFileFromReference:ft,getLibFileFromReference:pt,sourceFileToPackageName:Kr,redirectTargetsMap:qr,isEmittedFile:Yt,getConfigFileParsingDiagnostics:ct,getResolvedModuleWithFailedLookupLocationsFromCache:d,getProjectReferences:w,getResolvedProjectReferences:P,getProjectReferenceRedirect:xt,getResolvedProjectReferenceToRedirect:Ct,getResolvedProjectReferenceByPath:Et,forEachResolvedProjectReference:kt,emitBuildInfo:S},Bt(),e.performance.mark("afterProgram"),e.performance.measure("Program","beforeProgram","afterProgram"),$t}function C(t,r){return void 0===r&&(r=t),{fileExists:function(e){return r.fileExists(e)},readDirectory:function(t,n,i,a,o){return e.Debug.assertDefined(r.readDirectory,"'CompilerHost.readDirectory' must be implemented to correctly process 'projectReferences'"),r.readDirectory(t,n,i,a,o)},readFile:function(e){return r.readFile(e)},useCaseSensitiveFileNames:t.useCaseSensitiveFileNames(),getCurrentDirectory:function(){return t.getCurrentDirectory()},onUnRecoverableConfigFileDiagnostic:t.onUnRecoverableConfigFileDiagnostic||e.returnUndefined,trace:t.trace?function(e){return t.trace(e)}:void 0}}function k(t,r,n){if(!t)return e.emptyArray;for(var i,a=0;a<t.length;a++){var o=t[a],s=r(o,a);if(o.prepend&&s&&s.options){var c=s.options.outFile||s.options.out;if(!c)continue;var u=e.getOutputPathsForBundle(s.options,!0),l=u.jsFilePath,_=u.sourceMapFilePath,d=u.declarationFilePath,p=u.declarationMapPath,f=u.buildInfoPath,m=e.createInputFiles(n,l,_,d,p,f);(i||(i=[])).push(m)}}return i||e.emptyArray}function T(t,r){var n=r?r:t;return e.resolveConfigFileProjectName(n.path)}function E(e){return e.declaration?"declaration":"composite"}function N(t,r){function n(){return t.jsx?void 0:e.Diagnostics.Module_0_was_resolved_to_1_but_jsx_is_not_set}function i(){return t.allowJs||!e.getStrictOptionValue(t,"noImplicitAny")?void 0:e.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type}function a(){return t.resolveJsonModule?void 0:e.Diagnostics.Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used}var o=r.extension;switch(o){case".ts":case".d.ts":return void 0;case".tsx":return n();case".jsx":return n()||i();case".js":return i();case".json":return a()}}function A(e){for(var t=e.imports,r=e.moduleAugmentations,n=t.map(function(e){return e.text}),i=0,a=r;i<a.length;i++){var o=a[i];10===o.kind&&n.push(o.text)}return n}var F=/(^\s*$)|(^\s*\/\/\/?\s*(@ts-ignore)?)/;e.findConfigFile=t,e.resolveTripleslashReference=r,e.computeCommonSourceDirectoryOfFilenames=n,e.createCompilerHost=a,e.createCompilerHostWorker=o,e.changeCompilerHostLikeToUseCache=s,e.getPreEmitDiagnostics=c,e.formatDiagnostics=u,e.formatDiagnostic=l;var P;!function(e){e.Grey="[90m",e.Red="[91m",e.Yellow="[93m",e.Blue="[94m",e.Cyan="[96m"}(P=e.ForegroundColorEscapeSequences||(e.ForegroundColorEscapeSequences={}));var w="[7m",I=" ",O="[0m",M="...",L="  ",R="    ";e.formatColorAndReset=d,e.formatLocation=m,e.formatDiagnosticsWithColorAndContext=g,e.flattenDiagnosticMessageText=v,e.loadWithLocalCache=y,e.isProgramUptoDate=h,e.getConfigFileParsingDiagnostics=b,e.createProgram=S,e.parseConfigHostFromCompilerHostLike=C,e.createPrependNodes=k,e.resolveProjectReferencePath=T,e.getResolutionDiagnostic=N}(n||(n={}));var n;!function(e){function t(e,t,r,n,i){function a(e,t,r){o.push({name:e,writeByteOrderMark:r,text:t})}var o=[],s=e.emit(t,a,n,r,i);return{outputFiles:o,emitSkipped:s.emitSkipped,exportedModulesFromDeclarationEmit:s.exportedModulesFromDeclarationEmit}}function r(t){return t?e.cloneMap(t):void 0}e.getFileEmitOutput=t,e.cloneMapOrUndefined=r}(n||(n={})),function(e){var t;!function(t){function r(t){if(t.declarations&&t.declarations[0]){var r=e.getSourceFileOfNode(t.declarations[0]);return r&&r.resolvedPath}}function n(e,t){var n=e.getSymbolAtLocation(t);return n&&r(n)}function a(t,r,n,i){return e.toPath(t.getProjectReferenceRedirect(r)||r,n,i)}function o(t,r,i){function o(t){for(var n=0,i=t.declarations;n<i.length;n++){var a=i[n],o=e.getSourceFileOfNode(a);o&&o!==r&&s(o.resolvedPath)}}function s(t){c||(c=e.createMap()),c.set(t,!0)}var c;if(r.imports&&r.imports.length>0)for(var u=t.getTypeChecker(),l=0,_=r.imports;l<_.length;l++){var d=_[l],p=n(u,d);p&&s(p)}var f=e.getDirectoryPath(r.path);if(r.referencedFiles&&r.referencedFiles.length>0)for(var m=0,g=r.referencedFiles;m<g.length;m++){var v=g[m],y=a(t,v.fileName,f,i);s(y)}if(r.resolvedTypeReferenceDirectiveNames&&r.resolvedTypeReferenceDirectiveNames.forEach(function(e){if(e){var r=e.resolvedFileName,n=a(t,r,f,i);s(n)}}),r.moduleAugmentations.length)for(var u=t.getTypeChecker(),h=0,b=r.moduleAugmentations;h<b.length;h++){var x=b[h];if(e.isStringLiteral(x)){var D=u.getSymbolAtLocation(x);D&&o(D)}}for(var S=0,C=t.getTypeChecker().getAmbientModules();S<C.length;S++){var k=C[S];k.declarations.length>1&&o(k)}return c}function s(e,t){return t&&!t.referencedMap==!e}function c(t,r,n){for(var i=e.createMap(),a=t.getCompilerOptions().module!==e.ModuleKind.None?e.createMap():void 0,c=a?e.createMap():void 0,u=e.createMap(),l=s(a,n),_=0,d=t.getSourceFiles();_<d.length;_++){var p=d[_],f=e.Debug.assertDefined(p.version,"Program intended to be used with Builder should have source files with versions set"),m=l?n.fileInfos.get(p.path):void 0;if(a){var g=o(t,p,r);if(g&&a.set(p.path,g),l){var v=n.exportedModulesMap.get(p.path);v&&c.set(p.path,v)}}i.set(p.path,{version:f,signature:m&&m.signature})}return{fileInfos:i,referencedMap:a,exportedModulesMap:c,hasCalledUpdateShapeSignature:u}}function u(e){e.allFilesExcludingDefaultLibraryFile=void 0,e.allFileNames=void 0}function l(t){var r=e.createMap();return t.fileInfos.forEach(function(e,t){r.set(t,i({},e))}),{fileInfos:r,referencedMap:e.cloneMapOrUndefined(t.referencedMap),exportedModulesMap:e.cloneMapOrUndefined(t.exportedModulesMap),hasCalledUpdateShapeSignature:e.cloneMap(t.hasCalledUpdateShapeSignature)}}function _(t,r,n,i,a,o,s){var c=o||e.createMap(),u=r.getSourceFileByPath(n);if(!u)return e.emptyArray;if(!p(t,r,u,c,i,a,s))return[u];var l=(t.referencedMap?C:S)(t,r,u,c,i,a,s);return o||d(t,c),l}function d(e,t){t.forEach(function(t,r){e.fileInfos.get(r).signature=t,e.hasCalledUpdateShapeSignature.set(r,!0)})}function p(t,r,n,i,a,o,s){if(e.Debug.assert(!!n),e.Debug.assert(!s||!!t.exportedModulesMap,"Compute visible to outside map only if visibleToOutsideReferencedMap present in the state"),t.hasCalledUpdateShapeSignature.has(n.path)||i.has(n.path))return!1;var c=t.fileInfos.get(n.path);if(!c)return e.Debug.fail();var u,l=c.signature;if(n.isDeclarationFile){if(u=n.version,s&&u!==l){var _=t.referencedMap?t.referencedMap.get(n.path):void 0;s.set(n.path,_||!1)}}else{var d=e.getFileEmitOutput(r,n,!0,a);d.outputFiles&&d.outputFiles.length>0?(u=o(d.outputFiles[0].text),s&&u!==l&&f(n,d.exportedModulesFromDeclarationEmit,s)):u=l}return i.set(n.path,u),!l||u!==l}function f(t,n,i){function a(t){t&&(o||(o=e.createMap()),o.set(t,!0))}if(!n)return void i.set(t.path,!1);var o;n.forEach(function(e){return a(r(e))}),i.set(t.path,o||!1)}function m(t,r){r&&(e.Debug.assert(!!t.exportedModulesMap),r.forEach(function(e,r){e?t.exportedModulesMap.set(r,e):t.exportedModulesMap.delete(r)}))}function g(t,r,n){var i,a=r.getCompilerOptions();if(a.outFile||a.out)return v(t,r);if(!t.referencedMap||x(n))return v(t,r);for(var o=e.createMap(),s=[n.path];s.length;){var c=s.pop();if(!o.has(c)){o.set(c,!0);var u=t.referencedMap.get(c);if(u)for(var l=u.keys(),_=l.next(),d=_.value,p=_.done;!p;i=l.next(),d=i.value,p=i.done,i)s.push(d)}}return e.arrayFrom(e.mapDefinedIterator(o.keys(),function(e){var t=r.getSourceFileByPath(e);return t?t.fileName:e}))}function v(t,r){if(!t.allFileNames){var n=r.getSourceFiles();t.allFileNames=n===e.emptyArray?e.emptyArray:n.map(function(e){return e.fileName})}return t.allFileNames}function y(t,r){return e.arrayFrom(e.mapDefinedIterator(t.referencedMap.entries(),function(e){var t=e[0],n=e[1];return n.has(r)?t:void 0}))}function h(t){for(var r=0,n=t.statements;r<n.length;r++){var i=n[r];if(!e.isModuleWithStringLiteralName(i))return!1}return!0}function b(t){return e.some(t.moduleAugmentations,function(t){return e.isGlobalScopeAugmentation(t.parent)})}function x(t){return b(t)||!e.isExternalModule(t)&&!h(t)}function D(t,r,n){function i(e){r.isSourceFileDefaultLibrary(e)||(a||(a=[])).push(e)}if(t.allFilesExcludingDefaultLibraryFile)return t.allFilesExcludingDefaultLibraryFile;var a;i(n);for(var o=0,s=r.getSourceFiles();o<s.length;o++){var c=s[o];c!==n&&i(c)}return t.allFilesExcludingDefaultLibraryFile=a||e.emptyArray,t.allFilesExcludingDefaultLibraryFile}function S(e,t,r){var n=t.getCompilerOptions();return n&&(n.out||n.outFile)?[r]:D(e,t,r)}function C(t,r,n,i,a,o,s){if(x(n))return D(t,r,n);var c=r.getCompilerOptions();if(c&&(c.isolatedModules||c.out||c.outFile))return[n];var u=e.createMap();u.set(n.path,n);for(var l=y(t,n.resolvedPath);l.length>0;){var _=l.pop();if(!u.has(_)){var d=r.getSourceFileByPath(_);u.set(_,d),d&&p(t,r,d,i,a,o,s)&&l.push.apply(l,y(t,d.resolvedPath))}}return e.arrayFrom(e.mapDefinedIterator(u.values(),function(e){return e}))}t.canReuseOldState=s,t.create=c,t.releaseCache=u,t.clone=l,t.getFilesAffectedBy=_,t.updateSignaturesFromCache=d,t.updateShapeSignature=p,t.updateExportedFilesMapFromCache=m,t.getAllDependencies=g}(t=e.BuilderState||(e.BuilderState={}))}(n||(n={}));var n;!function(e){function t(t,r){return t===r||void 0!==t&&void 0!==r&&t.size===r.size&&!e.forEachKey(t,function(e){return!r.has(e)})}function r(r,i,a){var o=e.BuilderState.create(r,i,a);o.program=r;var s=r.getCompilerOptions();o.compilerOptions=s,s.outFile||s.out||s.isolatedModules||(o.semanticDiagnosticsPerFile=e.createMap()),o.changedFilesSet=e.createMap();var c=e.BuilderState.canReuseOldState(o.referencedMap,a),u=c?a.compilerOptions:void 0,l=c&&a.semanticDiagnosticsPerFile&&!!o.semanticDiagnosticsPerFile&&!e.compilerOptionsAffectSemanticDiagnostics(s,u);if(c){if(!a.currentChangedFilePath){var _=a.currentAffectedFilesSignatures;e.Debug.assert(!(a.affectedFiles||_&&_.size),"Cannot reuse if only few affected files of currentChangedFile were iterated")}var d=a.changedFilesSet;l&&e.Debug.assert(!d||!e.forEachKey(d,function(e){return a.semanticDiagnosticsPerFile.has(e)}),"Semantic diagnostics shouldnt be available for changed files"),d&&e.copyEntries(d,o.changedFilesSet),s.outFile||s.out||!a.affectedFilesPendingEmit||(o.affectedFilesPendingEmit=a.affectedFilesPendingEmit,o.affectedFilesPendingEmitIndex=a.affectedFilesPendingEmitIndex)}var p=o.referencedMap,f=c?a.referencedMap:void 0,m=l&&!s.skipLibCheck==!u.skipLibCheck,g=m&&!s.skipDefaultLibCheck==!u.skipDefaultLibCheck;return o.fileInfos.forEach(function(i,s){var u,_;if(!c||!(u=a.fileInfos.get(s))||u.version!==i.version||!t(_=p&&p.get(s),f&&f.get(s))||_&&e.forEachKey(_,function(e){return!o.fileInfos.has(e)&&a.fileInfos.has(e)}))o.changedFilesSet.set(s,!0);else if(l){var d=r.getSourceFileByPath(s);if(d.isDeclarationFile&&!m)return;if(d.hasNoDefaultLib&&!g)return;var v=a.semanticDiagnosticsPerFile.get(s);v&&(o.semanticDiagnosticsPerFile.set(s,a.hasReusableDiagnostic?n(v,r):v),o.semanticDiagnosticsFromOldState||(o.semanticDiagnosticsFromOldState=e.createMap()),o.semanticDiagnosticsFromOldState.set(s,!0))}}),u&&e.compilerOptionsAffectEmit(s,u)&&(E(o,r.getSourceFiles().map(function(e){return e.path})),e.Debug.assert(void 0===o.seenAffectedFiles),o.seenAffectedFiles=e.createMap()),o}function n(t,r){return t.length?t.map(function(t){var n=a(t,r);n.reportsUnnecessary=t.reportsUnnecessary,n.source=t.source;var i=t.relatedInformation;return n.relatedInformation=i?i.length?i.map(function(e){return a(e,r)}):e.emptyArray:void 0,n}):e.emptyArray}function a(t,r){var n=t.file,a=t.messageText;return i({},t,{file:n&&r.getSourceFileByPath(n),messageText:void 0===a||e.isString(a)?a:o(a,r)})}function o(e,t){return i({},e,{next:e.next&&o(e.next,t)})}function s(t){e.BuilderState.releaseCache(t),t.program=void 0}function c(t){var r=e.BuilderState.clone(t);return r.semanticDiagnosticsPerFile=e.cloneMapOrUndefined(t.semanticDiagnosticsPerFile),r.changedFilesSet=e.cloneMap(t.changedFilesSet),r.affectedFiles=t.affectedFiles,r.affectedFilesIndex=t.affectedFilesIndex,r.currentChangedFilePath=t.currentChangedFilePath,r.currentAffectedFilesSignatures=e.cloneMapOrUndefined(t.currentAffectedFilesSignatures),r.currentAffectedFilesExportedModulesMap=e.cloneMapOrUndefined(t.currentAffectedFilesExportedModulesMap),r.seenAffectedFiles=e.cloneMapOrUndefined(t.seenAffectedFiles),r.cleanedDiagnosticsOfLibFiles=t.cleanedDiagnosticsOfLibFiles,r.semanticDiagnosticsFromOldState=e.cloneMapOrUndefined(t.semanticDiagnosticsFromOldState),r.program=t.program,r.compilerOptions=t.compilerOptions,r.affectedFilesPendingEmit=t.affectedFilesPendingEmit,r.affectedFilesPendingEmitIndex=t.affectedFilesPendingEmitIndex,r.seenEmittedFiles=e.cloneMapOrUndefined(t.seenEmittedFiles),r.programEmitComplete=t.programEmitComplete,r}function u(t,r){e.Debug.assert(!r||!t.affectedFiles||t.affectedFiles[t.affectedFilesIndex-1]!==r||!t.semanticDiagnosticsPerFile.has(r.path))}function l(t,r,n){for(;;){var i=t.affectedFiles;if(i){for(var a=t.seenAffectedFiles,o=t.affectedFilesIndex;o<i.length;){var s=i[o];if(!a.has(s.path))return t.affectedFilesIndex=o,d(t,s,r,n),s;a.set(s.path,!0),o++}t.changedFilesSet.delete(t.currentChangedFilePath),t.currentChangedFilePath=void 0,e.BuilderState.updateSignaturesFromCache(t,t.currentAffectedFilesSignatures),t.currentAffectedFilesSignatures.clear(),e.BuilderState.updateExportedFilesMapFromCache(t,t.currentAffectedFilesExportedModulesMap),t.affectedFiles=void 0}var c=t.changedFilesSet.keys().next();if(c.done)return void 0;var u=e.Debug.assertDefined(t.program),l=u.getCompilerOptions();if(l.outFile||l.out)return e.Debug.assert(!t.semanticDiagnosticsPerFile),u;t.currentAffectedFilesSignatures=t.currentAffectedFilesSignatures||e.createMap(),t.exportedModulesMap&&(t.currentAffectedFilesExportedModulesMap=t.currentAffectedFilesExportedModulesMap||e.createMap()),t.affectedFiles=e.BuilderState.getFilesAffectedBy(t,u,c.value,r,n,t.currentAffectedFilesSignatures,t.currentAffectedFilesExportedModulesMap),t.currentChangedFilePath=c.value,t.affectedFilesIndex=0,t.seenAffectedFiles=t.seenAffectedFiles||e.createMap()}}function _(t){var r=t.affectedFilesPendingEmit;if(r){for(var n=t.seenEmittedFiles||(t.seenEmittedFiles=e.createMap()),i=t.affectedFilesPendingEmitIndex;i<r.length;i++){var a=e.Debug.assertDefined(t.program).getSourceFileByPath(r[i]);if(a&&!n.has(a.path))return t.affectedFilesPendingEmitIndex=i,a}t.affectedFilesPendingEmit=void 0,t.affectedFilesPendingEmitIndex=void 0}return void 0}function d(t,r,n,i){if(f(t,r.path),t.allFilesExcludingDefaultLibraryFile!==t.affectedFiles)m(t,r,function(e,t){return p(e,t,n,i)});else if(!t.cleanedDiagnosticsOfLibFiles){t.cleanedDiagnosticsOfLibFiles=!0;var a=e.Debug.assertDefined(t.program),o=a.getCompilerOptions();e.forEach(a.getSourceFiles(),function(r){return a.isSourceFileDefaultLibrary(r)&&!e.skipTypeChecking(r,o)&&f(t,r.path)})}}function p(t,r,n,i){if(f(t,r),!t.changedFilesSet.has(r)){var a=e.Debug.assertDefined(t.program),o=a.getSourceFileByPath(r);o&&(e.BuilderState.updateShapeSignature(t,a,o,e.Debug.assertDefined(t.currentAffectedFilesSignatures),n,i,t.currentAffectedFilesExportedModulesMap),e.getEmitDeclarations(t.compilerOptions)&&E(t,[r]))}return!1}function f(e,t){return e.semanticDiagnosticsFromOldState?(e.semanticDiagnosticsFromOldState.delete(t),e.semanticDiagnosticsPerFile.delete(t),!e.semanticDiagnosticsFromOldState.size):!0}function m(t,r,n){if(t.exportedModulesMap&&1!==t.affectedFiles.length&&t.changedFilesSet.has(r.path)){e.Debug.assert(!!t.currentAffectedFilesExportedModulesMap);var i=e.createMap();e.forEachEntry(t.currentAffectedFilesExportedModulesMap,function(e,a){return e&&e.has(r.path)&&g(t,a,i,n)})||e.forEachEntry(t.exportedModulesMap,function(e,a){return!t.currentAffectedFilesExportedModulesMap.has(a)&&e.has(r.path)&&g(t,a,i,n)
})}}function g(t,r,n,i){return e.forEachEntry(t.referencedMap,function(e,a){return e.has(r)&&v(t,a,n,i)})}function v(t,r,n,i){return e.addToSeen(n,r)?i(t,r)?!0:(e.Debug.assert(!!t.currentAffectedFilesExportedModulesMap),e.forEachEntry(t.currentAffectedFilesExportedModulesMap,function(e,a){return e&&e.has(r)&&v(t,a,n,i)})?!0:e.forEachEntry(t.exportedModulesMap,function(e,a){return!t.currentAffectedFilesExportedModulesMap.has(a)&&e.has(r)&&v(t,a,n,i)})?!0:!!e.forEachEntry(t.referencedMap,function(e,a){return e.has(r)&&!n.has(a)&&i(t,a)})):!1}function y(e,t,r,n){n?e.emittedBuildInfo=!0:t===e.program?(e.changedFilesSet.clear(),e.programEmitComplete=!0):(e.seenAffectedFiles.set(t.path,!0),r?e.affectedFilesPendingEmitIndex++:e.affectedFilesIndex++)}function h(e,t,r,n,i){return y(e,r,n,i),{result:t,affected:r}}function b(t,r,n){var i=r.path;if(t.semanticDiagnosticsPerFile){var a=t.semanticDiagnosticsPerFile.get(i);if(a)return a}var o=e.Debug.assertDefined(t.program).getSemanticDiagnostics(r,n);return t.semanticDiagnosticsPerFile&&t.semanticDiagnosticsPerFile.set(i,o),o}function x(t){if(t.compilerOptions.outFile||t.compilerOptions.out)return void 0;var r={};t.fileInfos.forEach(function(e,n){var i=t.currentAffectedFilesSignatures&&t.currentAffectedFilesSignatures.get(n);r[n]=void 0===i?e:{version:e.version,signature:i}});var n={fileInfos:r,options:t.compilerOptions};if(t.referencedMap){var i={};t.referencedMap.forEach(function(t,r){i[r]=e.arrayFrom(t.keys())}),n.referencedMap=i}if(t.exportedModulesMap){var a={};t.exportedModulesMap.forEach(function(r,n){var i=t.currentAffectedFilesExportedModulesMap&&t.currentAffectedFilesExportedModulesMap.get(n);void 0===i?a[n]=e.arrayFrom(r.keys()):i&&(a[n]=e.arrayFrom(i.keys()))}),n.exportedModulesMap=a}if(t.semanticDiagnosticsPerFile){var o=[];t.semanticDiagnosticsPerFile.forEach(function(e,r){return o.push(e.length?[r,t.hasReusableDiagnostic?e:D(e)]:r)}),n.semanticDiagnosticsPerFile=o}return n}function D(t){return e.Debug.assert(!!t.length),t.map(function(t){var r=S(t);r.reportsUnnecessary=t.reportsUnnecessary,r.source=t.source;var n=t.relatedInformation;return r.relatedInformation=n?n.length?n.map(function(e){return S(e)}):e.emptyArray:void 0,r})}function S(t){var r=t.file,n=t.messageText;return i({},t,{file:r&&r.path,messageText:void 0===n||e.isString(n)?n:C(n)})}function C(e){return i({},e,{next:e.next&&C(e.next)})}function k(t,r,n,i,a,o){var s,c,u;return void 0===t?(e.Debug.assert(void 0===r),s=n,u=i,e.Debug.assert(!!u),c=u.getProgram()):e.isArray(t)?(u=i,c=e.createProgram({rootNames:t,options:r,host:n,oldProgram:u&&u.getProgramOrUndefined(),configFileParsingDiagnostics:a,projectReferences:o}),s=n):(c=t,s=r,u=n,a=i),{host:s,newProgram:c,oldProgram:u,configFileParsingDiagnostics:a||e.emptyArray}}function T(t,n){function i(t,r,n,i){var a=l(k,r,C),o=!1;if(!a)if(k.compilerOptions.out||k.compilerOptions.outFile){var s=e.Debug.assertDefined(k.program);if(k.programEmitComplete||!e.some(s.getProjectReferences(),function(e){return!!e.prepend}))return void(k.programEmitComplete=!0);a=s}else{if(a=_(k),!a){if(k.emittedBuildInfo)return void 0;var c=e.Debug.assertDefined(k.program);return h(k,c.emitBuildInfo(t||e.maybeBind(f,f.writeFile),r),c,!1,!0)}o=!0}return h(k,e.Debug.assertDefined(k.program).emit(a===k.program?void 0:a,t||e.maybeBind(f,f.writeFile),r,n,i),a,o)}function a(r,n,a,o,s){if(t===P.EmitAndSemanticDiagnosticsBuilderProgram&&(u(k,r),!r)){for(var c=[],l=!1,_=void 0,d=[],p=void 0;p=i(n,a,o,s);)l=l||p.result.emitSkipped,_=e.addRange(_,p.result.diagnostics),d=e.addRange(d,p.result.emittedFiles),c=e.addRange(c,p.result.sourceMaps);return{emitSkipped:l,diagnostics:_||e.emptyArray,emittedFiles:d,sourceMaps:c}}return e.Debug.assertDefined(k.program).emit(r,n||e.maybeBind(f,f.writeFile),a,o,s)}function o(e,t){for(;;){var r=l(k,e,C);if(!r)return void 0;if(r===k.program)return h(k,k.program.getSemanticDiagnostics(void 0,e),r);{if(!t||!t(r))return h(k,b(k,r,e),r);y(k,r)}}}function d(r,n){u(k,r);var i=e.Debug.assertDefined(k.program).getCompilerOptions();if(i.outFile||i.out)return e.Debug.assert(!k.semanticDiagnosticsPerFile),e.Debug.assertDefined(k.program).getSemanticDiagnostics(r,n);if(r)return b(k,r,n);for(var a,o;a=l(k,n,C);)a!==k.program&&t===P.EmitAndSemanticDiagnosticsBuilderProgram&&(o||(o=[])).push(a.path),y(k,a);o&&E(k,o);for(var s,c=0,_=e.Debug.assertDefined(k.program).getSourceFiles();c<_.length;c++){var d=_[c];s=e.addRange(s,b(k,d,n))}return s||e.emptyArray}var p=n.newProgram,f=n.host,m=n.oldProgram,g=n.configFileParsingDiagnostics,v=m&&m.getState();if(v&&p===v.program&&g===p.getConfigFileParsingDiagnostics())return p=void 0,v=void 0,m;var D,S=e.createGetCanonicalFileName(f.useCaseSensitiveFileNames()),C=f.createHash||e.generateDjb2Hash,k=r(p,S,v);p.getProgramBuildInfo=function(){return x(k)},p=void 0,m=void 0,v=void 0;var T=F(k,g);return T.getState=function(){return k},T.backupState=function(){e.Debug.assert(void 0===D),D=c(k)},T.restoreState=function(){k=e.Debug.assertDefined(D),D=void 0},T.getAllDependencies=function(t){return e.BuilderState.getAllDependencies(k,e.Debug.assertDefined(k.program),t)},T.getSemanticDiagnostics=d,T.emit=a,T.releaseProgram=function(){s(k),D=void 0},t===P.SemanticDiagnosticsBuilderProgram?T.getSemanticDiagnosticsOfNextAffectedFile=o:t===P.EmitAndSemanticDiagnosticsBuilderProgram?T.emitNextAffectedFile=i:e.notImplemented(),T}function E(t,r){t.affectedFilesPendingEmit=e.concatenate(t.affectedFilesPendingEmit,r),void 0===t.affectedFilesPendingEmitIndex&&(t.affectedFilesPendingEmitIndex=0)}function N(t){if(!t)return void 0;var r=e.createMap();for(var n in t)e.hasProperty(t,n)&&r.set(n,e.arrayToSet(t[n]));return r}function A(t){var r=e.createMapFromTemplate(t.fileInfos),n={fileInfos:r,compilerOptions:t.options,referencedMap:N(t.referencedMap),exportedModulesMap:N(t.exportedModulesMap),semanticDiagnosticsPerFile:t.semanticDiagnosticsPerFile&&e.arrayToMap(t.semanticDiagnosticsPerFile,function(t){return e.isString(t)?t:t[0]},function(t){return e.isString(t)?e.emptyArray:t[1]}),hasReusableDiagnostic:!0};return{getState:function(){return n},backupState:e.noop,restoreState:e.noop,getProgram:e.notImplemented,getProgramOrUndefined:e.returnUndefined,releaseProgram:e.noop,getCompilerOptions:function(){return n.compilerOptions},getSourceFile:e.notImplemented,getSourceFiles:e.notImplemented,getOptionsDiagnostics:e.notImplemented,getGlobalDiagnostics:e.notImplemented,getConfigFileParsingDiagnostics:e.notImplemented,getSyntacticDiagnostics:e.notImplemented,getDeclarationDiagnostics:e.notImplemented,getSemanticDiagnostics:e.notImplemented,emit:e.notImplemented,getAllDependencies:e.notImplemented,getCurrentDirectory:e.notImplemented,emitNextAffectedFile:e.notImplemented,getSemanticDiagnosticsOfNextAffectedFile:e.notImplemented}}function F(t,r){function n(){return e.Debug.assertDefined(t.program)}return{getState:e.notImplemented,backupState:e.noop,restoreState:e.noop,getProgram:n,getProgramOrUndefined:function(){return t.program},releaseProgram:function(){return t.program=void 0},getCompilerOptions:function(){return t.compilerOptions},getSourceFile:function(e){return n().getSourceFile(e)},getSourceFiles:function(){return n().getSourceFiles()},getOptionsDiagnostics:function(e){return n().getOptionsDiagnostics(e)},getGlobalDiagnostics:function(e){return n().getGlobalDiagnostics(e)},getConfigFileParsingDiagnostics:function(){return r},getSyntacticDiagnostics:function(e,t){return n().getSyntacticDiagnostics(e,t)},getDeclarationDiagnostics:function(e,t){return n().getDeclarationDiagnostics(e,t)},getSemanticDiagnostics:function(e,t){return n().getSemanticDiagnostics(e,t)},emit:function(e,t,r,i,a){return n().emit(e,t,r,i,a)},getAllDependencies:e.notImplemented,getCurrentDirectory:function(){return n().getCurrentDirectory()}}}var P;!function(e){e[e.SemanticDiagnosticsBuilderProgram=0]="SemanticDiagnosticsBuilderProgram",e[e.EmitAndSemanticDiagnosticsBuilderProgram=1]="EmitAndSemanticDiagnosticsBuilderProgram"}(P=e.BuilderProgramKind||(e.BuilderProgramKind={})),e.getBuilderCreationParameters=k,e.createBuilderProgram=T,e.createBuildProgramUsingProgramBuildInfo=A,e.createRedirectedBuilderProgram=F}(n||(n={})),function(e){function t(t,r,n,i,a,o){return e.createBuilderProgram(e.BuilderProgramKind.SemanticDiagnosticsBuilderProgram,e.getBuilderCreationParameters(t,r,n,i,a,o))}function r(t,r,n,i,a,o){return e.createBuilderProgram(e.BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram,e.getBuilderCreationParameters(t,r,n,i,a,o))}function n(t,r,n,i,a,o){var s=e.getBuilderCreationParameters(t,r,n,i,a,o),c=s.newProgram,u=s.configFileParsingDiagnostics;return e.createRedirectedBuilderProgram({program:c,compilerOptions:c.getCompilerOptions()},u)}e.createSemanticDiagnosticsBuilderProgram=t,e.createEmitAndSemanticDiagnosticsBuilderProgram=r,e.createAbstractBuilder=n}(n||(n={}));var n;!function(e){function t(t){return e.some(e.ignoredPaths,function(r){return e.stringContains(t,r)})}function r(r,n,i){function a(e){return e.resolvedModule}function o(e){return e.resolvedTypeReferenceDirective}function s(t,r){return void 0===t||r.length<=t.length?!1:e.startsWith(r,t)&&r[t.length]===e.directorySeparator}function c(){e.clearMap(ut,e.closeFileWatcherOf),ct.clear(),Z.clear(),U(),tt.clear(),at.clear(),Y=!1,p()}function u(){G=[]}function l(){var e=G;return G=void 0,e}function _(e){if(!X)return!1;var t=X.get(e);return!!t&&!!t.length}function d(t){if(Y||t)return Q=void 0,e.returnTrue;var r=Q;return Q=void 0,function(e){return!!r&&r.has(e)||_(e)}}function p(){rt.clear(),nt.clear(),ot.clear(),Z.forEach(A),Z.clear()}function f(){Y=!1,X=void 0,p(),ut.forEach(function(e,t){0===e.refCount&&(ut.delete(t),e.watcher.close())})}function m(t,n,i,a,o){var s=e.resolveModuleName(t,n,i,a,it,o);if(!r.getGlobalCache)return s;var c=r.getGlobalCache();if(!(void 0===c||e.isExternalModuleNameRelative(t)||s.resolvedModule&&e.extensionIsTS(s.resolvedModule.extension))){var u=e.loadModuleFromGlobalCache(t,r.projectName,i,a,c),l=u.resolvedModule,_=u.failedLookupLocations;if(l)return{resolvedModule:l,failedLookupLocations:e.addRange(s.failedLookupLocations,_)}}return s}function g(t,n,i,a,o,s,c,u,l,d){function p(e,t){if(e===t)return!0;if(!e||!t)return!1;var r=c(e),n=c(t);return r===n?!0:r&&n?r.resolvedFileName===n.resolvedFileName:!1}var f=r.toPath(n),m=a.get(f)||a.set(f,e.createMap()).get(f),g=e.getDirectoryPath(f),v=o.getOrCreateMapOfCacheRedirects(i),y=v.get(g);y||(y=e.createMap(),v.set(g,y));for(var h=[],b=r.getCompilationSettings(),x=d&&_(f),D=r.getCurrentProgram(),S=D&&D.getResolvedProjectReferenceToRedirect(n),C=S?!i||i.sourceFile.path!==S.sourceFile.path:!!i,k=e.createMap(),E=0,N=t;E<N.length;E++){var A=N[E],F=m.get(A);if(!k.has(A)&&Y||C||!F||F.isInvalidated||x&&!e.isExternalModuleNameRelative(A)&&u(F)){var w=F,I=y.get(A);I?F=I:(F=s(A,n,b,r,i),y.set(A,F)),m.set(A,F),T(A,F),w&&P(w),d&&G&&!p(w,F)&&(G.push(f),d=!1)}e.Debug.assert(void 0!==F&&!F.isInvalidated),k.set(A,!0),h.push(c(F))}return m.forEach(function(t,r){k.has(r)||e.contains(l,r)||(P(t),m.delete(r))}),h}function v(t,r,n){return g(t,r,n,at,ot,e.resolveTypeReferenceDirective,o,function(e){return void 0===e.resolvedTypeReferenceDirective},void 0,!1)}function y(t,r,n,o){return g(t,r,o,tt,rt,m,a,function(t){return!t.resolvedModule||!e.resolutionExtensionIsTSOrJson(t.resolvedModule.extension)},n,i)}function h(e,t){var n=tt.get(r.toPath(t));return n&&n.get(e)}function b(t){return e.endsWith(t,"/node_modules")}function x(t){return e.endsWith(t,"/node_modules/@types")}function D(t){var r=e.getRootLength(t);if(t.length===r)return!1;var n=t.indexOf(e.directorySeparator,r);if(-1===n)return!1;if(47!==t.charCodeAt(0)&&-1===t.substr(r,n).search(/users/i))return!0;for(var i=n+1,a=2;a>0;a--)if(i=t.indexOf(e.directorySeparator,i)+1,0===i)return!1;return!0}function S(t,r){if(s(_t,r)){t=e.isRootedDiskPath(t)?e.normalizePath(t):e.getNormalizedAbsolutePath(t,$()),e.Debug.assert(t.length===r.length,"FailedLookup: "+t+" failedLookupLocationPath: "+r);var n=r.indexOf(e.directorySeparator,_t.length+1);return-1!==n?{dir:t.substr(0,n),dirPath:r.substr(0,n)}:{dir:lt,dirPath:_t,nonRecursive:!1}}return C(e.getDirectoryPath(e.getNormalizedAbsolutePath(t,$())),e.getDirectoryPath(r))}function C(t,r){for(;e.pathContainsNodeModules(r);)t=e.getDirectoryPath(t),r=e.getDirectoryPath(r);if(b(r))return D(e.getDirectoryPath(r))?{dir:t,dirPath:r}:void 0;var n,i,a=!0;if(void 0!==_t)for(;!s(r,_t);){var o=e.getDirectoryPath(r);if(o===r)break;a=!1,n=r,i=t,r=o,t=e.getDirectoryPath(t)}return D(r)?{dir:i||t,dirPath:n||r,nonRecursive:a}:void 0}function k(t){return e.fileExtensionIsOneOf(t,st)}function T(t,r){r.failedLookupLocations&&r.failedLookupLocations.length&&(r.refCount?r.refCount++:(r.refCount=1,e.isExternalModuleNameRelative(t)?E(r):Z.add(t,r)))}function E(t){e.Debug.assert(!!t.refCount);for(var n=t.failedLookupLocations,i=!1,a=0,o=n;a<o.length;a++){var s=o[a],c=r.toPath(s),u=S(s,c);if(u){var l=u.dir,_=u.dirPath,d=u.nonRecursive;if(!k(c)){var p=ct.get(c)||0;ct.set(c,p+1)}_===_t?(e.Debug.assert(!d),i=!0):F(l,_,d)}}i&&F(lt,_t,!0)}function N(e){e.refCount=void 0}function A(e,t){var n=r.getCurrentProgram(),i=n&&n.getTypeChecker().tryFindAmbientModuleWithoutAugmentations(t)?N:E;e.forEach(i)}function F(t,r,n){var i=ut.get(r);i?(e.Debug.assert(!!n==!!i.nonRecursive),i.refCount++):ut.set(r,{watcher:I(t,r,n),refCount:1,nonRecursive:n})}function P(t){if(t.refCount&&(t.refCount--,!t.refCount)){for(var n=t.failedLookupLocations,i=!1,a=0,o=n;a<o.length;a++){var s=o[a],c=r.toPath(s),u=S(s,c);if(u){var l=u.dirPath,_=ct.get(c);_&&(1===_?ct.delete(c):(e.Debug.assert(_>1),ct.set(c,_-1))),l===_t?i=!0:w(l)}}i&&w(_t)}}function w(e){var t=ut.get(e);t.refCount--}function I(e,t,n){return r.watchDirectoryOfFailedLookupLocation(e,function(e){var n=r.toPath(e);et&&et.addOrDeleteFileOrDirectory(e,n),!Y&&V(n,t===n)&&r.onInvalidatedResolution()},n?0:1)}function O(e,t){var r=e.get(t);r&&(r.forEach(P),e.delete(t))}function M(t){if(e.fileExtensionIs(t,".json")){var n=r.getCurrentProgram();if(n){var i=n.getResolvedProjectReferenceByPath(t);i&&i.commandLine.fileNames.forEach(function(e){return L(r.toPath(e))})}}}function L(e){O(tt,e),O(at,e)}function R(t,r,n){var i=e.createMap();t.forEach(function(t,a){var o=e.getDirectoryPath(a),s=i.get(o);s||(s=e.createMap(),i.set(o,s)),t.forEach(function(t,i){s.has(i)||(s.set(i,!0),!t.isInvalidated&&r(t,n)&&(t.isInvalidated=!0,(Q||(Q=e.createMap())).set(a,!0)))})})}function B(){var t=r.maxNumberOfFilesToIterateForInvalidation||e.maxNumberOfFilesToIterateForInvalidation;return tt.size>t||at.size>t}function j(e){return B()?void(Y=!0):(R(tt,e,a),void R(at,e,o))}function J(e){L(e),j(function(t,n){var i=n(t);return!!i&&r.toPath(i.resolvedFileName)===e})}function z(t){e.Debug.assert(X===t||void 0===X),X=t}function V(n,i){var a;if(i)a=function(e){return s(n,r.toPath(e))};else{if(t(n))return!1;var o=e.getDirectoryPath(n);if(x(n)||b(n)||x(o)||b(o))a=function(t){var i=r.toPath(t);return i===n||e.startsWith(r.toPath(t),n)};else{if(!k(n)&&!ct.has(n))return!1;if(e.isEmittedFileOfProgram(r.getCurrentProgram(),n))return!1;a=function(e){return r.toPath(e)===n}}}var c=function(t){return e.some(t.failedLookupLocations,a)},u=Q&&Q.size;return j(c),Y||Q&&Q.size!==u}function U(){e.clearMap(dt,e.closeFileWatcher)}function K(e,t){if(Y)return void 0;if(s(_t,t))return _t;var r=C(e,t);return r&&ut.has(r.dirPath)?r.dirPath:void 0}function q(e,t){return r.watchTypeRootsDirectory(t,function(n){var i=r.toPath(n);et&&et.addOrDeleteFileOrDirectory(n,i),r.onChangedAutomaticTypeDirectiveNames();var a=K(t,e);a&&V(i,a===i)&&r.onInvalidatedResolution()},1)}function W(){var t=r.getCompilationSettings();if(t.types)return void U();var n=e.getEffectiveTypeRoots(t,{directoryExists:H,getCurrentDirectory:$});n?e.mutateMap(dt,e.arrayToMap(n,function(e){return r.toPath(e)}),{createNewValue:q,onDeleteValue:e.closeFileWatcher}):U()}function H(t){var n=e.getDirectoryPath(e.getDirectoryPath(t)),i=r.toPath(n);return i===_t||D(i)}var G,Q,X,Y=!1,Z=e.createMultiMap(),$=e.memoize(function(){return r.getCurrentDirectory()}),et=r.getCachedDirectoryStructureHost(),tt=e.createMap(),rt=e.createCacheWithRedirects(),nt=e.createCacheWithRedirects(),it=e.createModuleResolutionCacheWithMaps(rt,nt,$(),r.getCanonicalFileName),at=e.createMap(),ot=e.createCacheWithRedirects(),st=[".ts",".tsx",".js",".jsx",".json"],ct=e.createMap(),ut=e.createMap(),lt=n&&e.removeTrailingDirectorySeparator(e.getNormalizedAbsolutePath(n,$())),_t=lt&&r.toPath(lt),dt=e.createMap();return{startRecordingFilesWithChangedResolutions:u,finishRecordingFilesWithChangedResolutions:l,startCachingPerDirectoryResolution:p,finishCachingPerDirectoryResolution:f,resolveModuleNames:y,getResolvedModuleWithFailedLookupLocationsFromCache:h,resolveTypeReferenceDirectives:v,removeResolutionsFromProjectReferenceRedirects:M,removeResolutionsOfFile:L,invalidateResolutionOfFile:J,setFilesWithInvalidatedNonRelativeUnresolvedImports:z,createHasInvalidatedResolution:d,updateTypeRootsWatch:W,closeTypeRootsWatch:U,clear:c}}e.isPathIgnored=t,e.maxNumberOfFilesToIterateForInvalidation=256,e.createResolutionCache=r}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,n){function i(){switch(o){case"minimal":return 0;case"index":return 1;case"js":return 2;default:return _(n)?2:e.getEmitModuleResolutionKind(r)!==e.ModuleResolutionKind.NodeJs?1:0}}var a=t.importModuleSpecifierPreference,o=t.importModuleSpecifierEnding;return{relativePreference:"relative"===a?0:"non-relative"===a?1:2,ending:i()}}function n(t,r){return{relativePreference:e.isExternalModuleNameRelative(r)?0:1,ending:e.hasJSOrJsonFileExtension(r)?2:e.getEmitModuleResolutionKind(t)!==e.ModuleResolutionKind.NodeJs||e.endsWith(r,"index")?1:0}}function i(e,t,r,i,a,s,c){var u=o(e,t,r,i,a,s,n(e,c));return u===c?void 0:u}function a(e,t,n,i,a,s,c,u){return void 0===c&&(c={}),o(e,n,i,a,s,u,r(c,e,t))}function o(t,r,n,i,a,o,s){var l=c(r,i),_=g(a,r,n,l.getCanonicalFileName,i,o);return e.firstDefined(_,function(e){return b(e,l,i,t)})||u(n,l,t,s)}function s(t,n,i,a,o,s,l){var _=v(t);if(_)return[_];var d=c(i.path,a),p=e.getSourceFileOfNode(t.valueDeclaration||e.getNonAugmentationDeclaration(t)),f=g(o,i.path,p.fileName,d.getCanonicalFileName,a,l),m=r(s,n,i),y=e.mapDefined(f,function(e){return b(e,d,a,n)});return y.length?y:f.map(function(e){return u(e,d,n,m)})}function c(t,r){var n=e.createGetCanonicalFileName(r.useCaseSensitiveFileNames?r.useCaseSensitiveFileNames():!0),i=e.getDirectoryPath(t);return{getCanonicalFileName:n,sourceDirectory:i}}function u(t,r,n,i){var a=r.getCanonicalFileName,o=r.sourceDirectory,s=i.ending,c=i.relativePreference,u=n.baseUrl,_=n.paths,d=n.rootDirs,p=d&&h(d,t,o,a)||C(e.ensurePathIsNonModuleName(e.getRelativePathFromDirectory(o,t,a)),s,n);if(!u||0===c)return p;var f=T(t,u,a);if(!f)return p;var m=C(f,s,n),g=_&&y(e.removeFileExtension(f),m,_),v=void 0===g?m:g;return 1===c?v:(2!==c&&e.Debug.assertNever(c),E(v)||l(p)<l(v)?p:v)}function l(t){for(var r=0,n=e.startsWith(t,"./")?2:0;n<t.length;n++)47===t.charCodeAt(n)&&r++;return r}function _(t){var r=t.imports;return e.firstDefined(r,function(t){var r=t.text;return e.pathIsRelative(r)?e.hasJSOrJsonFileExtension(r):void 0})||!1}function d(e,t,r){return r(e)===r(t)}function p(t,r){return"node_modules"===r(t)||e.startsWith(t,"@")}function f(t,r,n,i){for(var a=e.getPathComponents(e.toPath(t,n,i)),o=e.getPathComponents(e.toPath(r,n,i));!p(a[a.length-2],i)&&!p(o[o.length-2],i)&&d(a[a.length-1],o[o.length-1],i);)a.pop(),o.pop();return[e.getPathFromPathComponents(a),e.getPathFromPathComponents(o)]}function m(t,r,n){for(var i=e.createMap(),a=e.flatten(e.mapDefined(t,function(t){return t.resolvedModules&&e.compact(e.arrayFrom(e.mapIterator(t.resolvedModules.values(),function(e){return e&&e.originalPath&&e.resolvedFileName!==e.originalPath?[e.resolvedFileName,e.originalPath]:void 0})))})),o=0,s=a;o<s.length;o++){var c=s[o],u=c[0],l=c[1],_=f(u,l,n,r),d=_[0],p=_[1];i.set(p,d)}return i}function g(t,r,n,i,a,o){var s=o.get(n),c=s?s.concat([n]):[n],u=a.getCurrentDirectory?a.getCurrentDirectory():"",l=c.map(function(t){return e.getNormalizedAbsolutePath(t,u)}),_=m(t,i,u),d=[],p=!a.useCaseSensitiveFileNames||a.useCaseSensitiveFileNames()?e.compareStringsCaseSensitive:e.compareStringsCaseInsensitive;return _.forEach(function(t,n){if(!e.startsWithDirectory(r,t,i)){var o=e.find(l,function(e){return 0===p(e.slice(0,t.length+1),t+"/")});if(void 0!==o){var s=e.getRelativePathFromDirectory(t,o,i),c=e.resolvePath(n,s);(!a.fileExists||a.fileExists(c))&&d.push(c)}}}),d.push.apply(d,l),d}function v(t){var r=e.find(t.declarations,function(t){return e.isNonGlobalAmbientModule(t)&&(!e.isExternalModuleAugmentation(t)||!e.isExternalModuleNameRelative(e.getTextOfIdentifierOrLiteral(t.name)))});return r?r.name.text:void 0}function y(t,r,n){for(var i in n)for(var a=0,o=n[i];a<o.length;a++){var s=o[a],c=e.removeFileExtension(e.normalizePath(s)),u=c.indexOf("*");if(-1!==u){var l=c.substr(0,u),_=c.substr(u+1);if(r.length>=l.length+_.length&&e.startsWith(r,l)&&e.endsWith(r,_)||!_&&r===e.removeTrailingDirectorySeparator(l)){var d=r.substr(l.length,r.length-_.length);return i.replace("*",d)}}else if(c===r||c===t)return i}}function h(t,r,n,i){var a=S(r,t,i);if(void 0===a)return void 0;var o=S(n,t,i),s=void 0!==o?e.ensurePathIsNonModuleName(e.getRelativePathFromDirectory(o,a,i)):a;return e.removeFileExtension(s)}function b(t,r,n,i){function a(t){if(_){var r=_.typings||_.types||_.main;if(r){var i=e.toPath(r,u,o);if(e.removeFileExtension(i)===e.removeFileExtension(o(t)))return u}}var a=e.removeFileExtension(t);return"/index"!==o(a.substring(c.fileNameIndex))||x(n,a.substring(0,c.fileNameIndex))?a:a.substring(0,c.fileNameIndex)}var o=r.getCanonicalFileName,s=r.sourceDirectory;if(!n.fileExists||!n.readFile)return void 0;var c=D(t);if(!c)return void 0;var u=t.substring(0,c.packageRootIndex),l=e.combinePaths(u,"package.json"),_=n.fileExists(l)?JSON.parse(n.readFile(l)):void 0,d=_&&_.typesVersions?e.getPackageJsonTypesVersionsPaths(_.typesVersions):void 0;if(d){var p=t.slice(c.packageRootIndex+1),f=y(e.removeFileExtension(p),C(p,0,i),d.paths);void 0!==f&&(t=e.combinePaths(t.slice(0,c.packageRootIndex),f))}var m=a(t);if(!e.startsWith(s,o(m.substring(0,c.topLevelNodeModulesIndex))))return void 0;var g=m.substring(c.topLevelPackageNameIndex+1),v=e.getPackageNameFromTypesPackageName(g);return e.getEmitModuleResolutionKind(i)!==e.ModuleResolutionKind.NodeJs&&v===g?void 0:v}function x(t,r){if(t.fileExists)for(var n=e.getSupportedExtensions({allowJs:!0},[{extension:"node",isMixedContent:!1},{extension:"json",isMixedContent:!1,scriptKind:6}]),i=0,a=n;i<a.length;i++){var o=a[i],s=r+o;if(t.fileExists(s))return s}}function D(t){var r,n=0,i=0,a=0,o=0;!function(e){e[e.BeforeNodeModules=0]="BeforeNodeModules",e[e.NodeModules=1]="NodeModules",e[e.Scope=2]="Scope",e[e.PackageContent=3]="PackageContent"}(r||(r={}));for(var s=0,c=0,u=0;c>=0;)switch(s=c,c=t.indexOf("/",s+1),u){case 0:t.indexOf(e.nodeModulesPathPart,s)===s&&(n=s,i=c,u=1);break;case 1:case 2:1===u&&"@"===t.charAt(s+1)?u=2:(a=c,u=3);break;case 3:u=t.indexOf(e.nodeModulesPathPart,s)===s?1:3}return o=s,u>1?{topLevelNodeModulesIndex:n,topLevelPackageNameIndex:i,packageRootIndex:a,fileNameIndex:o}:void 0}function S(t,r,n){return e.firstDefined(r,function(e){var r=T(t,e,n);return E(r)?void 0:r})}function C(t,r,n){if(e.fileExtensionIs(t,".json"))return t;var i=e.removeFileExtension(t);switch(r){case 0:return e.removeSuffix(i,"/index");case 1:return i;case 2:return i+k(t,n);default:return e.Debug.assertNever(r)}}function k(t,r){var n=e.extensionFromPath(t);switch(n){case".ts":case".d.ts":return".js";case".tsx":return 1===r.jsx?".jsx":".js";case".js":case".jsx":case".json":return n;case".tsbuildinfo":return e.Debug.fail("Extension .tsbuildinfo is unsupported:: FileName:: "+t);default:return e.Debug.assertNever(n)}}function T(t,r,n){var i=e.getRelativePathToDirectoryOrUrl(r,t,r,n,!1);return e.isRootedDiskPath(i)?void 0:i}function E(t){return e.startsWith(t,"..")}var N;!function(e){e[e.Relative=0]="Relative",e[e.NonRelative=1]="NonRelative",e[e.Auto=2]="Auto"}(N||(N={}));var A;!function(e){e[e.Minimal=0]="Minimal",e[e.Index=1]="Index",e[e.JsExtension=2]="JsExtension"}(A||(A={})),t.updateModuleSpecifier=i,t.getModuleSpecifier=a,t.getModuleSpecifiers=s,t.countPathComponents=l}(t=e.moduleSpecifiers||(e.moduleSpecifiers={}))}(n||(n={}));var n;!function(e){function t(t,r){var n=t===e.sys?C:{getCurrentDirectory:function(){return t.getCurrentDirectory()},getNewLine:function(){return t.newLine},getCanonicalFileName:e.createGetCanonicalFileName(t.useCaseSensitiveFileNames)};if(!r)return function(r){return t.write(e.formatDiagnostic(r,n))};var i=new Array(1);return function(r){i[0]=r,t.write(e.formatDiagnosticsWithColorAndContext(i,n)+n.getNewLine()),i[0]=void 0}}function r(t,r,n){return!t.clearScreen||n.preserveWatchOutput||n.extendedDiagnostics||n.diagnostics||!e.contains(e.screenStartingMessageCodes,r.code)?!1:(t.clearScreen(),!0)}function n(t,r){return e.contains(e.screenStartingMessageCodes,t.code)?r+r:r}function i(t,i){return i?function(n,i,a){r(t,n,a);var o="["+e.formatColorAndReset((new Date).toLocaleTimeString(),e.ForegroundColorEscapeSequences.Grey)+"] ";o+=""+e.flattenDiagnosticMessageText(n.messageText,t.newLine)+(i+i),t.write(o)}:function(i,a,o){var s="";r(t,i,o)||(s+=a),s+=(new Date).toLocaleTimeString()+" - ",s+=""+e.flattenDiagnosticMessageText(i.messageText,t.newLine)+n(i,a),t.write(s)}}function a(t,r,n,i){var a=n;a.onUnRecoverableConfigFileDiagnostic=function(t){return v(e.sys,i,t)};var o=e.getParsedCommandLineOfConfigFile(t,r,a);return a.onUnRecoverableConfigFileDiagnostic=void 0,o}function o(t){return e.countWhere(t,function(t){return t.category===e.DiagnosticCategory.Error})}function s(t){return 1===t?e.Diagnostics.Found_1_error_Watching_for_file_changes:e.Diagnostics.Found_0_errors_Watching_for_file_changes}function c(t,r){if(0===t)return"";var n=e.createCompilerDiagnostic(1===t?e.Diagnostics.Found_1_error:e.Diagnostics.Found_0_errors,t);return""+r+e.flattenDiagnosticMessageText(n.messageText,r)+r+r}function u(t,r){t.getCompilerOptions().listFiles&&e.forEach(t.getSourceFiles(),function(e){r(e.fileName)})}function l(t,r,n,i,a){var s=t.getConfigFileParsingDiagnostics().slice(),c=s.length;e.addRange(s,t.getSyntacticDiagnostics()),s.length===c&&(e.addRange(s,t.getOptionsDiagnostics()),e.addRange(s,t.getGlobalDiagnostics()),s.length===c&&e.addRange(s,t.getSemanticDiagnostics()));var l=t.emit(void 0,a),_=l.emittedFiles,d=l.emitSkipped,p=l.diagnostics;if(e.addRange(s,p),e.sortAndDeduplicateDiagnostics(s).forEach(r),n){var f=t.getCurrentDirectory();e.forEach(_,function(t){var r=e.getNormalizedAbsolutePath(t,f);n("TSFILE: "+r)}),u(t,n)}return i&&i(o(s)),d&&s.length>0?e.ExitStatus.DiagnosticsPresent_OutputsSkipped:s.length>0?e.ExitStatus.DiagnosticsPresent_OutputsGenerated:e.ExitStatus.Success}function _(t,r){void 0===t&&(t=e.sys);var n=r||i(t);return{onWatchStatusChange:n,watchFile:e.maybeBind(t,t.watchFile)||function(){return k},watchDirectory:e.maybeBind(t,t.watchDirectory)||function(){return k},setTimeout:e.maybeBind(t,t.setTimeout)||e.noop,clearTimeout:e.maybeBind(t,t.clearTimeout)||e.noop}}function d(t,r){var n=t.trace?r.extendedDiagnostics?e.WatchLogLevel.Verbose:r.diagnostics?e.WatchLogLevel.TriggerOnly:e.WatchLogLevel.None:e.WatchLogLevel.None,i=n!==e.WatchLogLevel.None?function(e){return t.trace(e)}:e.noop,a=e.getWatchFactory(n,i);return a.writeLog=i,a}function p(t,r,n){function i(r){if(r.length>e.getRootLength(r)&&!t.directoryExists(r)){var n=e.getDirectoryPath(r);i(n),t.createDirectory&&t.createDirectory(r)}}function a(r,n,a,o){try{e.performance.mark("beforeIOWrite"),i(e.getDirectoryPath(e.normalizePath(r))),t.writeFile(r,n,a),e.performance.mark("afterIOWrite"),e.performance.measure("I/O Write","beforeIOWrite","afterIOWrite")}catch(s){o&&o(s.message)}}void 0===n&&(n=t);var o=t.useCaseSensitiveFileNames(),s=e.memoize(function(){return t.getNewLine()});return{getSourceFile:function(n,i,a){var o;try{e.performance.mark("beforeIORead"),o=t.readFile(n,r().charset),e.performance.mark("afterIORead"),e.performance.measure("I/O Read","beforeIORead","afterIORead")}catch(s){a&&a(s.message),o=""}return void 0!==o?e.createSourceFile(n,o,i):void 0},getDefaultLibLocation:e.maybeBind(t,t.getDefaultLibLocation),getDefaultLibFileName:function(e){return t.getDefaultLibFileName(e)},writeFile:a,getCurrentDirectory:e.memoize(function(){return t.getCurrentDirectory()}),useCaseSensitiveFileNames:function(){return o},getCanonicalFileName:e.createGetCanonicalFileName(o),getNewLine:function(){return e.getNewLineCharacter(r(),s)},fileExists:function(e){return t.fileExists(e)},readFile:function(e){return t.readFile(e)},trace:e.maybeBind(t,t.trace),directoryExists:e.maybeBind(n,n.directoryExists),getDirectories:e.maybeBind(n,n.getDirectories),realpath:e.maybeBind(t,t.realpath),getEnvironmentVariable:e.maybeBind(t,t.getEnvironmentVariable)||function(){return""},createHash:e.maybeBind(t,t.createHash),readDirectory:e.maybeBind(t,t.readDirectory)}}function f(t,r){var n=t.getSourceFile,i=r.createHash||e.generateDjb2Hash;t.getSourceFile=function(){for(var e=[],a=0;a<arguments.length;a++)e[a]=arguments[a];var o=n.call.apply(n,[t].concat(e));return o&&(o.version=i.call(r,o.text)),o}}function m(t,r){var n=e.memoize(function(){return e.getDirectoryPath(e.normalizePath(t.getExecutingFilePath()))}),i=t;return{useCaseSensitiveFileNames:function(){return t.useCaseSensitiveFileNames},getNewLine:function(){return t.newLine},getCurrentDirectory:e.memoize(function(){return t.getCurrentDirectory()}),getDefaultLibLocation:n,getDefaultLibFileName:function(t){return e.combinePaths(n(),e.getDefaultLibFileName(t))},fileExists:function(e){return t.fileExists(e)},readFile:function(e,r){return t.readFile(e,r)},directoryExists:function(e){return t.directoryExists(e)},getDirectories:function(e){return t.getDirectories(e)},readDirectory:function(e,r,n,i,a){return t.readDirectory(e,r,n,i,a)},realpath:e.maybeBind(t,t.realpath),getEnvironmentVariable:e.maybeBind(t,t.getEnvironmentVariable),trace:function(e){return t.write(e+t.newLine)},createDirectory:function(e){return t.createDirectory(e)},writeFile:function(e,r,n){return t.writeFile(e,r,n)},onCachedDirectoryStructureHostCreate:function(e){return i=e||t},createHash:e.maybeBind(t,t.createHash),createProgram:r||e.createEmitAndSemanticDiagnosticsBuilderProgram}}function g(t,r,n,i){void 0===t&&(t=e.sys);var a=function(e){return t.write(e+t.newLine)},o=m(t,r);return e.copyProperties(o,_(t,i)),o.afterProgramCreate=function(r){var i=r.getCompilerOptions(),c=e.getNewLineCharacter(i,function(){return t.newLine});l(r,n,a,function(t){return o.onWatchStatusChange(e.createCompilerDiagnostic(s(t),t),c,i)})},o}function v(t,r,n){r(n),t.exit(e.ExitStatus.DiagnosticsPresent_OutputsSkipped)}function y(e,r,n,i,a,o){var s=a||t(n),c=g(n,i,s,o);return c.onUnRecoverableConfigFileDiagnostic=function(e){return v(n,s,e)},c.configFileName=e,c.optionsToExtend=r,c}function h(e,r,n,i,a,o,s){var c=g(n,i,a||t(n),o);return c.rootFiles=e,c.options=r,c.projectReferences=s,c}function b(t,r){if(t.out||t.outFile)return void 0;var n=e.getOutputPathForBuildInfo(t);if(!n)return void 0;var i=r(n);if(!i)return void 0;var a=e.getBuildInfo(i);return a.version!==e.version?void 0:a.program?e.createBuildProgramUsingProgramBuildInfo(a.program):void 0}function x(t,r){void 0===r&&(r=e.sys);var n=e.createCompilerHostWorker(t,void 0,r);return n.createHash=e.maybeBind(r,r.createHash),f(n,r),e.changeCompilerHostLikeToUseCache(n,function(t){return e.toPath(t,n.getCurrentDirectory(),n.getCanonicalFileName)}),n}function D(t){var r=t.rootNames,n=t.options,i=t.configFileParsingDiagnostics,a=t.projectReferences,o=t.host,s=t.createProgram;o=o||x(n),s=s||e.createEmitAndSemanticDiagnosticsBuilderProgram;var c=b(n,function(e){return o.readFile(e)});return s(r,n,o,c,i,a)}function S(r){var n=r.system||e.sys,i=r.host||(r.host=x(r.options,n)),a=D(r),o=l(a,r.reportDiagnostic||t(n),function(e){return i.trace&&i.trace(e)
},r.reportErrorSummary||r.options.pretty?function(e){return n.write(c(e,n.newLine))}:void 0);return r.afterProgramEmitAndDiagnostics&&r.afterProgramEmitAndDiagnostics(a),o}var C=e.sys?{getCurrentDirectory:function(){return e.sys.getCurrentDirectory()},getNewLine:function(){return e.sys.newLine},getCanonicalFileName:e.createGetCanonicalFileName(e.sys.useCaseSensitiveFileNames)}:void 0;e.createDiagnosticReporter=t,e.screenStartingMessageCodes=[e.Diagnostics.Starting_compilation_in_watch_mode.code,e.Diagnostics.File_change_detected_Starting_incremental_compilation.code],e.createWatchStatusReporter=i,e.parseConfigFileWithSystem=a,e.getErrorCountForSummary=o,e.getWatchErrorSummaryDiagnosticMessage=s,e.getErrorSummaryText=c,e.listFiles=u,e.emitFilesAndReportErrors=l;var k={close:e.noop};e.createWatchHost=_;var T;!function(e){e.ConfigFile="Config file",e.SourceFile="Source file",e.MissingFile="Missing file",e.WildcardDirectory="Wild card directory",e.FailedLookupLocations="Failed Lookup Locations",e.TypeRoots="Type roots"}(T=e.WatchType||(e.WatchType={})),e.createWatchFactory=d,e.createCompilerHostFromProgramHost=p,e.setGetSourceFileAsHashVersioned=f,e.createProgramHost=m,e.createWatchCompilerHostOfConfigFile=y,e.createWatchCompilerHostOfFilesAndCompilerOptions=h,e.readBuilderProgram=b,e.createIncrementalCompilerHost=x,e.performIncrementalCompilation=S}(n||(n={})),function(e){function t(t,r,n,i,a,o,s){return e.isArray(t)?e.createWatchCompilerHostOfFilesAndCompilerOptions(t,r,n,i,a,o,s):e.createWatchCompilerHostOfConfigFile(t,r,n,i,a,o)}function r(t){function r(){dt.clear(),e.clearMap(j,function(e){e&&e.fileWatcher&&(e.fileWatcher.close(),e.fileWatcher=void 0)}),ut&&(ut.close(),ut=void 0),O&&(e.clearMap(O,e.closeFileWatcherOf),O=void 0),I&&(e.clearMap(I,e.closeFileWatcher),I=void 0)}function n(){return P}function i(){return P&&P.getProgramOrUndefined()}function a(){st("Synchronizing program");var r=n();J&&(rt=c(),r&&e.changesAffectModuleResolution(r.getCompilerOptions(),Q)&&dt.clear());var a=dt.createHasInvalidatedResolution(pt);return e.isProgramUptoDate(i(),G,Q,m,d,a,z,X)?Z&&(P=H(void 0,void 0,lt,P,B,X),Z=!1):o(a),t.afterProgramCreate&&t.afterProgramCreate(P),P}function o(t){st("CreatingProgramWith::"),st("  roots: "+JSON.stringify(G)),st("  options: "+JSON.stringify(Q));var r=J||!i();if(J=!1,Z=!1,dt.startCachingPerDirectoryResolution(),lt.hasInvalidatedResolution=t,lt.hasChangedAutomaticTypeDirectiveNames=z,P=H(G,Q,lt,P,B,X),dt.finishCachingPerDirectoryResolution(),e.updateMissingFilePathsWatch(P.getProgram(),I||(I=e.createMap()),E),r&&dt.updateTypeRootsWatch(),L){for(var n=0,a=L;n<a.length;n++){var o=a[n];I.has(o)||j.delete(o)}L=void 0}}function s(t){e.Debug.assert(!K,"Cannot update root file names with config file watch mode"),G=t,y()}function c(){return e.getNewLineCharacter(Q||W,function(){return t.getNewLine()})}function u(t){return e.toPath(t,U,ct)}function l(e){return"boolean"==typeof e}function _(e){return"boolean"==typeof e.version}function d(e){var t=u(e);return l(j.get(t))?!0:et.fileExists(e)}function p(r,n,i,a,o){var s=j.get(n);if(l(s))return void 0;if(void 0===s||o||_(s)){var c=_t(r,i,a);if(s)c?(s.sourceFile=c,s.version=c.version,s.fileWatcher||(s.fileWatcher=at(t,r,k,e.PollingInterval.Low,n,"Source file"))):(s.fileWatcher&&s.fileWatcher.close(),j.set(n,!1));else if(c){var u=at(t,r,k,e.PollingInterval.Low,n,"Source file");j.set(n,{sourceFile:c,version:c.version,fileWatcher:u})}else j.set(n,!1);return c}return s.sourceFile}function f(e){var t=j.get(e);void 0!==t&&(l(t)?j.set(e,{version:!1}):t.version=!1)}function m(e){var t=j.get(e);return t&&t.version?t.version:void 0}function g(e,t,r){var n=j.get(e.resolvedPath);void 0!==n&&(l(n)?(L||(L=[])).push(e.path):n.sourceFile===e&&(n.fileWatcher&&n.fileWatcher.close(),j.delete(e.resolvedPath),r||dt.removeResolutionsOfFile(e.path)))}function v(r){t.onWatchStatusChange&&t.onWatchStatusChange(e.createCompilerDiagnostic(r),rt,Q||W)}function y(){t.setTimeout&&t.clearTimeout&&(M&&t.clearTimeout(M),st("Scheduling update"),M=t.setTimeout(b,250))}function h(){e.Debug.assert(!!K),w=e.ConfigFileProgramReloadLevel.Full,y()}function b(){switch(M=void 0,v(e.Diagnostics.File_change_detected_Starting_incremental_compilation),w){case e.ConfigFileProgramReloadLevel.Partial:return x();case e.ConfigFileProgramReloadLevel.Full:return D();default:return void a()}}function x(){st("Reloading new file names and options");var t=e.getFileNamesFromConfigSpecs(R,e.getDirectoryPath(K),Q,tt);e.updateErrorForNoInputFiles(t,K,R,B,Y)&&(Z=!0),G=t.fileNames,a()}function D(){st("Reloading config file: "+K),w=e.ConfigFileProgramReloadLevel.None,$&&$.clearCache(),S(),J=!0,a(),A()}function S(){C(e.getParsedCommandLineOfConfigFile(K,W,tt))}function C(t){G=t.fileNames,Q=t.options,R=t.configFileSpecs,X=t.projectReferences,B=e.getConfigFileParsingDiagnostics(t).slice(),Y=e.canJsonReportNoInutFiles(t.raw),Z=!0}function k(t,r,n){T(t,n,r),r===e.FileWatcherEventKind.Deleted&&j.has(n)&&dt.invalidateResolutionOfFile(n),dt.removeResolutionsFromProjectReferenceRedirects(n),f(n),y()}function T(e,t,r){$&&$.addOrDeleteFile(e,t,r)}function E(r){return at(t,r,N,e.PollingInterval.Medium,r,"Missing file")}function N(t,r,n){T(t,n,r),r===e.FileWatcherEventKind.Created&&I.has(n)&&(I.get(n).close(),I.delete(n),f(n),y())}function A(){R?e.updateWatchingWildcardDirectories(O||(O=e.createMap()),e.createMapFromTemplate(R.wildcardDirectories),F):O&&e.clearMap(O,e.closeFileWatcherOf)}function F(r,n){return ot(t,r,function(t){e.Debug.assert(!!K);var n=u(t);return $&&$.addOrDeleteFileOrDirectory(t,n),f(n),e.isPathIgnored(n)?void 0:n!==r&&e.hasExtension(n)&&!e.isSupportedSourceFileName(t,Q)?void st("Project: "+K+" Detected file add/remove of non supported extension: "+t):void(w!==e.ConfigFileProgramReloadLevel.Full&&(w=e.ConfigFileProgramReloadLevel.Partial,y()))},n,"Wild card directory")}var P,w,I,O,M,L,R,B,j=e.createMap(),J=!1,z=!1,V=t.useCaseSensitiveFileNames(),U=t.getCurrentDirectory(),K=t.configFileName,q=t.optionsToExtend,W=void 0===q?{}:q,H=t.createProgram,G=t.rootFiles,Q=t.options,X=t.projectReferences,Y=!1,Z=!1,$=void 0===K?void 0:e.createCachedDirectoryStructureHost(t,U,V);$&&t.onCachedDirectoryStructureHostCreate&&t.onCachedDirectoryStructureHostCreate($);var et=$||t,tt=e.parseConfigHostFromCompilerHostLike(t,et),rt=c();K&&t.configFileParsingResult&&(C(t.configFileParsingResult),rt=c()),v(e.Diagnostics.Starting_compilation_in_watch_mode),K&&!t.configFileParsingResult&&(rt=e.getNewLineCharacter(W,function(){return t.getNewLine()}),e.Debug.assert(!G),S(),rt=c());var nt=e.createWatchFactory(t,Q),it=nt.watchFile,at=nt.watchFilePath,ot=nt.watchDirectory,st=nt.writeLog,ct=e.createGetCanonicalFileName(V);st("Current directory: "+U+" CaseSensitiveFileNames: "+V);var ut;K&&(ut=it(t,K,h,e.PollingInterval.High,"Config file"));var lt=e.createCompilerHostFromProgramHost(t,function(){return Q},et);e.setGetSourceFileAsHashVersioned(lt,t);var _t=lt.getSourceFile;lt.getSourceFile=function(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];return p.apply(void 0,[e,u(e)].concat(t))},lt.getSourceFileByPath=p,lt.getNewLine=function(){return rt},lt.fileExists=d,lt.onReleaseOldSourceFile=g,lt.toPath=u,lt.getCompilationSettings=function(){return Q},lt.watchDirectoryOfFailedLookupLocation=function(e,r,n){return ot(t,e,r,n,"Failed Lookup Locations")},lt.watchTypeRootsDirectory=function(e,r,n){return ot(t,e,r,n,"Type roots")},lt.getCachedDirectoryStructureHost=function(){return $},lt.onInvalidatedResolution=y,lt.onChangedAutomaticTypeDirectiveNames=function(){z=!0,y()},lt.maxNumberOfFilesToIterateForInvalidation=t.maxNumberOfFilesToIterateForInvalidation,lt.getCurrentProgram=i,lt.writeLog=st;var dt=e.createResolutionCache(lt,K?e.getDirectoryPath(e.getNormalizedAbsolutePath(K,U)):U,!1);lt.resolveModuleNames=t.resolveModuleNames?function(e,r,n,i){return t.resolveModuleNames(e,r,n,i)}:function(e,t,r,n){return dt.resolveModuleNames(e,t,r,n)},lt.resolveTypeReferenceDirectives=t.resolveTypeReferenceDirectives?function(e,r,n){return t.resolveTypeReferenceDirectives(e,r,n)}:function(e,t,r){return dt.resolveTypeReferenceDirectives(e,t,r)};var pt=!!t.resolveModuleNames||!!t.resolveTypeReferenceDirectives;return P=e.readBuilderProgram(Q,function(e){return lt.readFile(e)}),a(),A(),K?{getCurrentProgram:n,getProgram:a,close:r}:{getCurrentProgram:n,getProgram:a,updateRootFileNames:s,close:r}}e.createWatchCompilerHost=t,e.createWatchProgram=r}(n||(n={}));var n;!function(e){function t(t){function r(e){u.forEach(e)}function n(e){return u.has(t(e))}function i(e){u.delete(t(e))}function a(e,r){u.set(t(e),r)}function o(e){return u.get(t(e))}function s(){return u.size}function c(){u.clear()}var u=e.createMap();return{setValue:a,getValue:o,removeKey:i,forEach:r,hasKey:n,getSize:s,clear:c}}function r(e,t,r){var n,i=e.getValue(t);return i||(n=r(),e.setValue(t,n)),i||n}function n(t,n){return r(t,n,e.createMap)}function i(e,t){return t>e?t:e}function a(t){return e.fileExtensionIs(t,".d.ts")}function o(t,r){return function(n){var i=r?"["+e.formatColorAndReset((new Date).toLocaleTimeString(),e.ForegroundColorEscapeSequences.Grey)+"] ":(new Date).toLocaleTimeString()+" - ";i+=""+e.flattenDiagnosticMessageText(n.messageText,t.newLine)+(t.newLine+t.newLine),t.write(i)}}function s(t,r,n,i){var a=e.createProgramHost(t,r);return a.getModifiedTime=t.getModifiedTime?function(e){return t.getModifiedTime(e)}:e.returnUndefined,a.setModifiedTime=t.setModifiedTime?function(e,r){return t.setModifiedTime(e,r)}:e.noop,a.deleteFile=t.deleteFile?function(e){return t.deleteFile(e)}:e.noop,a.reportDiagnostic=n||e.createDiagnosticReporter(t),a.reportSolutionBuilderStatus=i||o(t),a}function c(t,r,n,i,a){void 0===t&&(t=e.sys);var o=s(t,r,n,i);return o.reportErrorSummary=a,o}function u(t,r,n,i,a){void 0===t&&(t=e.sys);var o=s(t,r,n,i),c=e.createWatchHost(t,a);return e.copyProperties(o,c),o}function l(t){var r={};return e.commonOptionsWithBuild.forEach(function(n){e.hasProperty(t,n.name)&&(r[n.name]=t[n.name])}),r}function _(o,s,c){function u(t){return e.toPath(t,ft,mt)}function _(t){void 0===t&&(t=c),vt=t,yt=l(vt),ht.clear(),bt.clear(),xt.clear(),Dt.clear(),dt=void 0,Ft.clear(),It.clear(),Ot.clear(),Mt.clear(),Lt.length=0,Rt=0,Nt&&(clearTimeout(Nt),Nt=void 0),Bt=!1,e.clearMap(Kt,function(t){return e.clearMap(t,e.closeFileWatcherOf)}),e.clearMap(qt,function(t){return e.clearMap(t,e.closeFileWatcher)}),e.clearMap(Wt,e.closeFileWatcher),wt.clear()}function y(e){return!!e.options}function h(t){var r=ht.getValue(t);if(r)return y(r)?r:void 0;var n;gt.onUnRecoverableConfigFileDiagnostic=function(e){return n=e};var i=e.getParsedCommandLineOfConfigFile(t,yt,gt,Pt);return gt.onUnRecoverableConfigFileDiagnostic=e.noop,ht.setValue(t,i||n),i}function b(t){for(var r=[],n=1;n<arguments.length;n++)r[n-1]=arguments[n];o.reportSolutionBuilderStatus(e.createCompilerDiagnostic.apply(void 0,[t].concat(r)))}function x(t){for(var r=[],n=1;n<arguments.length;n++)r[n-1]=arguments[n];pt.onWatchStatusChange&&pt.onWatchStatusChange(e.createCompilerDiagnostic.apply(void 0,[t].concat(r)),o.getNewLine(),yt)}function D(){for(var e=P(),t=0,r=e.buildQueue;t<r.length;t++){var n=r[t];S(n);var i=h(n);i&&(C(n,i),k(n,i))}}function S(t){vt.watch&&!Wt.hasKey(t)&&Wt.setValue(t,Jt(pt,t,function(){N(t,e.ConfigFileProgramReloadLevel.Full)},e.PollingInterval.High,"Config file",t))}function C(t,r){vt.watch&&e.updateWatchingWildcardDirectories(n(Kt,t),e.createMapFromTemplate(r.configFileSpecs.wildcardDirectories),function(n,i){return Vt(pt,n,function(i){var a=u(i);return a!==u(n)&&e.hasExtension(a)&&!e.isSupportedSourceFileName(i,r.options)?void Ut("Project: "+t+" Detected file add/remove of non supported extension: "+i):T(i,r)?void Ut(i+" is output file"):void N(t,e.ConfigFileProgramReloadLevel.Partial)},i,"Wild card directory",t)})}function k(t,r){vt.watch&&e.mutateMap(n(qt,t),e.arrayToMap(r.fileNames,u),{createNewValue:function(r,n){return zt(pt,n,function(){return N(t,e.ConfigFileProgramReloadLevel.None)},e.PollingInterval.Low,r,"Source file",t)},onDeleteValue:e.closeFileWatcher})}function T(t,r){if(r.options.noEmit)return!1;if(!e.fileExtensionIs(t,".d.ts")&&(e.fileExtensionIs(t,".ts")||e.fileExtensionIs(t,".tsx")))return!1;var n=r.options.outFile||r.options.out;return n&&(E(t,n)||E(t,e.removeFileExtension(n)+".d.ts"))?!0:r.options.declarationDir&&e.containsPath(r.options.declarationDir,t,ft,!o.useCaseSensitiveFileNames())?!0:r.options.outDir&&e.containsPath(r.options.outDir,t,ft,!o.useCaseSensitiveFileNames())?!0:!e.forEach(r.fileNames,function(e){return E(t,e)})}function E(t,r){return 0===e.comparePaths(t,r,ft,!o.useCaseSensitiveFileNames())}function N(e,t){Bt=!0,L(e,t),J()}function A(e){return w(h(e))}function F(e){return K(tt(e))}function P(){return dt||(dt=F(s))}function w(e){if(void 0===e)return{type:v.Unbuildable,reason:"File deleted mid-build"};var t=xt.getValue(e.options.configFilePath);if(void 0!==t)return t;var r=I(e);return xt.setValue(e.options.configFilePath,r),r}function I(t){for(var r=void 0,n=m,s=0,c=t.fileNames;s<c.length;s++){var u=c[s];if(!o.fileExists(u))return{type:v.Unbuildable,reason:u+" does not exist"};var l=o.getModifiedTime(u)||e.missingFileModifiedTime;l>n&&(r=u,n=l)}if(!t.fileNames.length&&!e.canJsonReportNoInutFiles(t.raw))return{type:v.ContainerOnly};for(var _,d=e.getAllProjectOutputs(t,!o.useCaseSensitiveFileNames()),p="(none)",f=g,y="(none)",b=m,x=m,D=!1,S=0,C=d;S<C.length;S++){var k=C[S];if(!o.fileExists(k)){_=k;break}var T=o.getModifiedTime(k)||e.missingFileModifiedTime;if(f>T&&(f=T,p=k),n>T){D=!0;break}if(T>b&&(b=T,y=k),a(k)){var E=bt.getValue(k);if(void 0!==E)x=i(E,x);else{var N=o.getModifiedTime(k)||e.missingFileModifiedTime;x=i(x,N)}}}var A,F=!1,P=!1;if(t.projectReferences){xt.setValue(t.options.configFilePath,{type:v.ComputingUpstream});for(var I=0,M=t.projectReferences;I<M.length;I++){var L=M[I];P=P||!!L.prepend;var R=e.resolveProjectReferencePath(L),B=w(h(R));if(B.type!==v.ComputingUpstream){if(B.type===v.Unbuildable)return{type:v.UpstreamBlocked,upstreamProjectName:L.path};if(B.type!==v.UpToDate)return{type:v.UpstreamOutOfDate,upstreamProjectName:L.path};if(!_){if(B.newestInputFileTime&&B.newestInputFileTime<=f)continue;if(B.newestDeclarationFileContentChangedTime&&B.newestDeclarationFileContentChangedTime<=f){F=!0,A=L.path;continue}return e.Debug.assert(void 0!==p,"Should have an oldest output filename here"),{type:v.OutOfDateWithUpstream,outOfDateOutputFileName:p,newerProjectName:L.path}}}}}if(void 0!==_)return{type:v.OutputMissing,missingOutputFileName:_};if(D)return{type:v.OutOfDateWithSelf,outOfDateOutputFileName:p,newerInputFileName:r};var j=O(t.options.configFilePath,f,p);if(j)return j;var J=e.forEach(t.options.configFile.extendedSourceFiles||e.emptyArray,function(e){return O(e,f,p)});if(J)return J;if(!Ft.hasKey(t.options.configFilePath)){Ft.setValue(t.options.configFilePath,!0);var z=e.getOutputPathForBuildInfo(t.options);if(z){var V=Ct(z),U=V&&e.getBuildInfo(V);if(U&&U.version!==e.version)return{type:v.TsVersionOutputOfDate,version:U.version}}}return P&&F?{type:v.OutOfDateWithPrepend,outOfDateOutputFileName:p,newerProjectName:A}:{type:F?v.UpToDateWithUpstreamTypes:v.UpToDate,newestDeclarationFileContentChangedTime:x,newestInputFileTime:n,newestOutputFileTime:b,newestInputFileName:r,newestOutputFileName:y,oldestOutputFileName:p}}function O(t,r,n){var i=o.getModifiedTime(t)||e.missingFileModifiedTime;return i>r?{type:v.OutOfDateWithSelf,outOfDateOutputFileName:n,newerInputFileName:t}:void 0}function M(e,t){L(et(e),t)}function L(t,r){r===e.ConfigFileProgramReloadLevel.Full&&(ht.removeKey(t),dt=void 0),xt.removeKey(t),It.removeKey(t),R(t,r),rt()}function R(t,r){var n=Ot.getValue(t);void 0===n?(Ot.setValue(t,r||e.ConfigFileProgramReloadLevel.None),Lt.push(t)):n<(r||e.ConfigFileProgramReloadLevel.None)&&Ot.setValue(t,r||e.ConfigFileProgramReloadLevel.None)}function B(){if(Rt<Lt.length){var e=Lt[Rt];Rt++;var t=Ot.getValue(e);return Ot.removeKey(e),Ot.getSize()||(Lt.length=0,Rt=0),{project:e,reloadLevel:t}}}function j(){return!!Ot.getSize()}function J(){pt.setTimeout&&pt.clearTimeout&&(Nt&&pt.clearTimeout(Nt),Nt=pt.setTimeout(z,250))}function z(){Nt=void 0,Bt&&(Bt=!1,Mt.clear(),x(e.Diagnostics.File_change_detected_Starting_incremental_compilation));var t=B();t&&(U(t.project,t.reloadLevel),j()?vt.watch&&!Nt&&J():(nt(),V()))}function V(){if(vt.watch||o.reportErrorSummary){P().buildQueue.forEach(function(t){Mt.hasKey(t)||ct(It.getValue(t)||e.emptyArray)});var t=0;It.forEach(function(r){return t+=e.getErrorCountForSummary(r)}),vt.watch?x(e.getWatchErrorSummaryDiagnosticMessage(t),t):o.reportErrorSummary(t)}}function U(t,r){var n=h(t);if(!n)return void ot(t);if(r===e.ConfigFileProgramReloadLevel.Full)S(t),C(t,n),k(t,n);else if(r===e.ConfigFileProgramReloadLevel.Partial){var i=e.getFileNamesFromConfigSpecs(n.configFileSpecs,e.getDirectoryPath(t),n.options,gt);e.updateErrorForNoInputFiles(i,t,n.configFileSpecs,n.errors,e.canJsonReportNoInutFiles(n.raw)),n.fileNames=i.fileNames,k(t,n)}var a=w(n);if(_t(t,a),a.type===v.UpstreamBlocked)return void(vt.verbose&&b(e.Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_has_errors,t,a.upstreamProjectName));if(a.type===v.UpToDateWithUpstreamTypes)return void X(n);var o=at(a,t)?q(t):Q(t);if(!(o&f.AnyErrors)){var s=P(),c=s.referencingProjectsMap,u=s.buildQueue,l=c.getValue(t);if(l)for(var _=u.indexOf(t)+1;_<u.length;_++){var d=u[_],p=l.getValue(d);if(void 0!==p){var m=xt.getValue(d);o&f.DeclarationOutputUnchanged?m&&m.type===v.UpToDate&&(p?xt.setValue(d,{type:v.OutOfDateWithPrepend,outOfDateOutputFileName:m.oldestOutputFileName,newerProjectName:t}):m.type=v.UpToDateWithUpstreamTypes):!m||m.type!==v.UpToDate&&m.type!==v.UpToDateWithUpstreamTypes&&m.type!==v.OutOfDateWithPrepend||xt.setValue(d,{type:v.OutOfDateWithUpstream,outOfDateOutputFileName:m.type===v.OutOfDateWithPrepend?m.outOfDateOutputFileName:m.oldestOutputFileName,newerProjectName:t}),R(d)}}}}function K(n){function i(n,_){if(!o.hasKey(n)){if(a.hasKey(n))return void(_||b(e.Diagnostics.Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0,s.join("\r\n")));a.setValue(n,!0),s.push(n);var d=h(n);if(d&&d.projectReferences)for(var p=0,f=d.projectReferences;p<f.length;p++){var m=f[p],g=et(m.path);i(g,_||m.circular);var v=r(l,g,function(){return t(u)});v.setValue(n,!!m.prepend)}s.pop(),o.setValue(n,!0),c.push(n)}}for(var a=t(u),o=t(u),s=[],c=[],l=t(u),_=0,d=n;_<d.length;_++){var p=d[_];i(p)}return{buildQueue:c,referencingProjectsMap:l}}function q(r){function n(t,n,i){return s|=n,st(r,t),St&&e.listFiles(d,St),xt.setValue(r,{type:v.Unbuildable,reason:i+" errors"}),H(r,d),kt=yt,s}if(vt.dry)return b(e.Diagnostics.A_non_dry_build_would_build_project_0,r),f.Success;vt.verbose&&b(e.Diagnostics.Building_project_0,r);var s=f.DeclarationOutputUnchanged,c=h(r);if(!c)return s|=f.ConfigFileErrors,ot(r),xt.setValue(r,{type:v.Unbuildable,reason:"Config file errors"}),s;if(0===c.fileNames.length)return st(r,c.errors),f.None;if(kt=c.options,At){var l=u(r);if(0===At.directoryToModuleNameMap.redirectsMap.size)e.Debug.assert(0===At.moduleNameToDirectoryMap.redirectsMap.size),At.directoryToModuleNameMap.redirectsMap.set(l,At.directoryToModuleNameMap.ownMap),At.moduleNameToDirectoryMap.redirectsMap.set(l,At.moduleNameToDirectoryMap.ownMap);else{e.Debug.assert(At.moduleNameToDirectoryMap.redirectsMap.size>0);var _={sourceFile:kt.configFile,commandLine:c};At.directoryToModuleNameMap.setOwnMap(At.directoryToModuleNameMap.getOrCreateMapOfCacheRedirects(_)),At.moduleNameToDirectoryMap.setOwnMap(At.moduleNameToDirectoryMap.getOrCreateMapOfCacheRedirects(_))}At.directoryToModuleNameMap.setOwnOptions(kt),At.moduleNameToDirectoryMap.setOwnOptions(kt)}var d=o.createProgram(c.fileNames,c.options,Tt,G(r,c),c.errors,c.projectReferences),p=d.getConfigFileParsingDiagnostics().concat(d.getOptionsDiagnostics(),d.getGlobalDiagnostics(),d.getSyntacticDiagnostics());if(p.length)return n(p,f.SyntaxErrors,"Syntactic");var y=d.getSemanticDiagnostics();if(y.length)return n(y,f.TypeErrors,"Semantic");d.backupState();var x,D=m,S=!1,C=function(e){return(x||(x=[])).push(e)},k=[];if(e.emitFilesAndReportErrors(d,C,void 0,void 0,function(e,t,r){return k.push({name:e,text:t,writeByteOrderMark:r})}),x)return d.restoreState(),n(x,f.DeclarationEmitErrors,"Declaration file");var T=e.createDiagnosticCollection(),E=t(u);k.forEach(function(t){var r,n=t.name,c=t.text,u=t.writeByteOrderMark;!S&&a(n)&&(o.fileExists(n)&&Ct(n)===c?r=o.getModifiedTime(n):(s&=~f.DeclarationOutputUnchanged,S=!0)),E.setValue(n,n),e.writeFile(Tt,T,n,c,u),void 0!==r&&(D=i(r,D),bt.setValue(n,r))});var N=T.getDiagnostics();if(N.length)return n(N,f.EmitErrors,"Emit");St&&(E.forEach(function(e){return W(c,e)}),e.listFiles(d,St)),D=Y(c,D,e.Diagnostics.Updating_unchanged_output_timestamps_of_project_0,E);var A={type:v.UpToDate,newestDeclarationFileContentChangedTime:S?g:D,oldestOutputFileName:k.length?k[0].name:e.getFirstProjectOutput(c,!o.useCaseSensitiveFileNames())};return It.removeKey(r),xt.setValue(r,A),H(r,d),kt=yt,s}function W(e,t){St&&e.options.listEmittedFiles&&St("TSFILE: "+t)}function H(e,t){o.afterProgramEmitAndDiagnostics&&o.afterProgramEmitAndDiagnostics(t),vt.watch&&(t.releaseProgram(),wt.setValue(e,t))}function G(t,r){if(vt.force)return void 0;var n=wt.getValue(t);return n?n:e.readBuilderProgram(r.options,Ct)}function Q(r){if(vt.dry)return b(e.Diagnostics.A_non_dry_build_would_update_output_of_project_0,r),f.Success;vt.verbose&&b(e.Diagnostics.Updating_output_of_project_0,r);var n=e.Debug.assertDefined(h(r));kt=n.options;var i=e.emitUsingBuildInfo(n,Tt,function(e){return h(et(e.path))});if(e.isString(i))return b(e.Diagnostics.Cannot_update_output_of_project_0_because_there_was_error_reading_file_1,r,lt(i)),q(r);e.Debug.assert(!!i.length);var a=e.createDiagnosticCollection(),o=t(u);i.forEach(function(t){var r=t.name,n=t.text,i=t.writeByteOrderMark;o.setValue(r,r),e.writeFile(Tt,a,r,n,i)});var s=a.getDiagnostics();if(s.length)return st(r,s),xt.setValue(r,{type:v.Unbuildable,reason:"Emit errors"}),kt=yt,f.DeclarationOutputUnchanged|f.EmitErrors;St&&o.forEach(function(e){return W(n,e)});var c=Y(n,m,e.Diagnostics.Updating_unchanged_output_timestamps_of_project_0,o),l={type:v.UpToDate,newestDeclarationFileContentChangedTime:c,oldestOutputFileName:i[0].name};return It.removeKey(r),xt.setValue(r,l),kt=yt,f.DeclarationOutputUnchanged}function X(t){if(vt.dry)return b(e.Diagnostics.A_non_dry_build_would_update_timestamps_for_output_of_project_0,t.options.configFilePath);var r=Y(t,m,e.Diagnostics.Updating_output_timestamps_of_project_0),n={type:v.UpToDate,newestDeclarationFileContentChangedTime:r,oldestOutputFileName:e.getFirstProjectOutput(t,!o.useCaseSensitiveFileNames())};xt.setValue(t.options.configFilePath,n)}function Y(t,r,n,s){var c=e.getAllProjectOutputs(t,!o.useCaseSensitiveFileNames());if(!s||c.length!==s.getSize()){vt.verbose&&b(n,t.options.configFilePath);for(var u=o.now?o.now():new Date,l=0,_=c;l<_.length;l++){var d=_[l];s&&s.hasKey(d)||(a(d)&&(r=i(r,o.getModifiedTime(d)||e.missingFileModifiedTime)),o.setModifiedTime(d,u),W(t,d))}}return r}function Z(){for(var t=P(),r=[],n=0,i=t.buildQueue;n<i.length;n++){var a=i[n],s=h(a);if(void 0!==s)for(var c=e.getAllProjectOutputs(s,!o.useCaseSensitiveFileNames()),u=0,l=c;u<l.length;u++){var _=l[u];o.fileExists(_)&&r.push(_)}else ot(a)}return r}function $(){var t=Z();if(vt.dry)return b(e.Diagnostics.A_non_dry_build_would_delete_the_following_files_Colon_0,t.map(function(e){return"\r\n * "+e}).join("")),e.ExitStatus.Success;for(var r=0,n=t;r<n.length;r++){var i=n[r];o.deleteFile(i)}return e.ExitStatus.Success}function et(t){return d(e.resolvePath(o.getCurrentDirectory(),t))}function tt(e){return e.map(et)}function rt(){Et&&nt();var t=Ct,r=Tt.getSourceFile,n=e.changeCompilerHostLikeToUseCache(o,u,function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return r.call.apply(r,[Tt].concat(e))}),i=n.originalReadFile,a=n.originalFileExists,s=n.originalDirectoryExists,c=n.originalCreateDirectory,l=n.originalWriteFile,_=n.getSourceFileWithCache,d=n.readFileWithCache;Ct=d,Tt.getSourceFile=_;var p=Tt.resolveModuleNames;if(!Tt.resolveModuleNames){var f=function(t,r,n){return e.resolveModuleName(t,r,kt,Tt,At,n).resolvedModule};Tt.resolveModuleNames=function(t,r,n,i){return e.loadWithLocalCache(e.Debug.assertEachDefined(t),r,i,f)}}Et={originalReadFile:i,originalFileExists:a,originalDirectoryExists:s,originalCreateDirectory:c,originalWriteFile:l,originalReadFileWithCache:t,originalGetSourceFile:r,originalResolveModuleNames:p}}function nt(){Et&&(o.readFile=Et.originalReadFile,o.fileExists=Et.originalFileExists,o.directoryExists=Et.originalDirectoryExists,o.createDirectory=Et.originalCreateDirectory,o.writeFile=Et.originalWriteFile,Tt.getSourceFile=Et.originalGetSourceFile,Ct=Et.originalReadFileWithCache,Tt.resolveModuleNames=Et.originalResolveModuleNames,Pt.clear(),At&&(At.directoryToModuleNameMap.clear(),At.moduleNameToDirectoryMap.clear()),Et=void 0)}function it(){vt.watch&&x(e.Diagnostics.Starting_compilation_in_watch_mode),rt();var t=P();ut(t);for(var r=!1,n=0,i=t.buildQueue;n<i.length;n++){var a=i[n],o=h(a);if(void 0===o){ot(a),r=!0;break}var s=o.errors,u=w(o);_t(a,u);var l=o.options.configFilePath;if(u.type!==v.UpToDate||vt.force)if(u.type!==v.UpToDateWithUpstreamTypes||vt.force)if(u.type!==v.UpstreamBlocked)if(u.type!==v.ContainerOnly){var _=at(u,a)?q(a):Q(a);r=r||!!(_&f.AnyErrors)}else st(a,s);else st(a,s),vt.verbose&&b(e.Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_has_errors,l,u.upstreamProjectName);else st(a,s),X(o);else st(a,s),c.dry&&b(e.Diagnostics.Project_0_is_up_to_date,l)}return V(),nt(),r?e.ExitStatus.DiagnosticsPresent_OutputsSkipped:e.ExitStatus.Success}function at(t,r){if(t.type!==v.OutOfDateWithPrepend||vt.force)return!0;var n=h(r);return!n||0===n.fileNames.length||!!n.errors.length||!e.isIncrementalCompilation(n.options)}function ot(e){st(e,[ht.getValue(e)])}function st(e,t){ct(t),Mt.setValue(e,!0),It.setValue(e,t)}function ct(e){e.forEach(function(e){return o.reportDiagnostic(e)})}function ut(t){vt.verbose&&b(e.Diagnostics.Projects_in_this_build_Colon_0,t.buildQueue.map(function(e){return"\r\n    * "+lt(e)}).join(""))}function lt(t){return e.convertToRelativePath(t,o.getCurrentDirectory(),function(e){return Tt.getCanonicalFileName(e)})}function _t(e,t){return vt.verbose?p(e,t,lt,b):void 0}var dt,pt=o,ft=o.getCurrentDirectory(),mt=e.createGetCanonicalFileName(o.useCaseSensitiveFileNames()),gt=e.parseConfigHostFromCompilerHostLike(o),vt=c,yt=l(vt),ht=t(u),bt=t(u),xt=t(u),Dt=e.createMap(),St=o.trace?function(e){return o.trace(e)}:void 0,Ct=function(e){return o.readFile(e)},kt=yt,Tt=e.createCompilerHostFromProgramHost(o,function(){return kt});e.setGetSourceFileAsHashVersioned(Tt,o),Tt.getParsedCommandLine=h,Tt.resolveModuleNames=e.maybeBind(o,o.resolveModuleNames),Tt.resolveTypeReferenceDirectives=e.maybeBind(o,o.resolveTypeReferenceDirectives);var Et,Nt,At=Tt.resolveModuleNames?void 0:e.createModuleResolutionCache(ft,mt),Ft=t(u),Pt=e.createMap(),wt=t(u),It=t(u),Ot=t(u),Mt=t(u),Lt=[],Rt=0,Bt=!1,jt=e.createWatchFactory(o,vt),Jt=jt.watchFile,zt=jt.watchFilePath,Vt=jt.watchDirectory,Ut=jt.writeLog,Kt=t(u),qt=t(u),Wt=t(u);return{buildAllProjects:it,getUpToDateStatusOfFile:A,cleanAllProjects:$,resetBuildContext:_,getBuildGraph:F,invalidateProject:M,buildInvalidatedProject:z,resolveProjectName:et,startWatching:D}}function d(t){return e.fileExtensionIs(t,".json")?t:e.combinePaths(t,"tsconfig.json")}function p(t,r,n,i){switch(r.type){case v.OutOfDateWithSelf:return i(e.Diagnostics.Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2,n(t),n(r.outOfDateOutputFileName),n(r.newerInputFileName));case v.OutOfDateWithUpstream:return i(e.Diagnostics.Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2,n(t),n(r.outOfDateOutputFileName),n(r.newerProjectName));case v.OutputMissing:return i(e.Diagnostics.Project_0_is_out_of_date_because_output_file_1_does_not_exist,n(t),n(r.missingOutputFileName));case v.UpToDate:if(void 0!==r.newestInputFileTime)return i(e.Diagnostics.Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2,n(t),n(r.newestInputFileName||""),n(r.oldestOutputFileName||""));break;case v.OutOfDateWithPrepend:return i(e.Diagnostics.Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed,n(t),n(r.newerProjectName));case v.UpToDateWithUpstreamTypes:return i(e.Diagnostics.Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies,n(t));case v.UpstreamOutOfDate:return i(e.Diagnostics.Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date,n(t),n(r.upstreamProjectName));case v.UpstreamBlocked:return i(e.Diagnostics.Project_0_can_t_be_built_because_its_dependency_1_has_errors,n(t),n(r.upstreamProjectName));case v.Unbuildable:return i(e.Diagnostics.Failed_to_parse_file_0_Colon_1,n(t),r.reason);case v.TsVersionOutputOfDate:return i(e.Diagnostics.Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2,n(t),r.version,e.version);case v.ContainerOnly:case v.ComputingUpstream:break;default:e.assertType(r)}}var f,m=new Date(-864e13),g=new Date(864e13);!function(e){e[e.None=0]="None",e[e.Success=1]="Success",e[e.DeclarationOutputUnchanged=2]="DeclarationOutputUnchanged",e[e.ConfigFileErrors=4]="ConfigFileErrors",e[e.SyntaxErrors=8]="SyntaxErrors",e[e.TypeErrors=16]="TypeErrors",e[e.DeclarationEmitErrors=32]="DeclarationEmitErrors",e[e.EmitErrors=64]="EmitErrors",e[e.AnyErrors=124]="AnyErrors"}(f||(f={}));var v;!function(e){e[e.Unbuildable=0]="Unbuildable",e[e.UpToDate=1]="UpToDate",e[e.UpToDateWithUpstreamTypes=2]="UpToDateWithUpstreamTypes",e[e.OutOfDateWithPrepend=3]="OutOfDateWithPrepend",e[e.OutputMissing=4]="OutputMissing",e[e.OutOfDateWithSelf=5]="OutOfDateWithSelf",e[e.OutOfDateWithUpstream=6]="OutOfDateWithUpstream",e[e.UpstreamOutOfDate=7]="UpstreamOutOfDate",e[e.UpstreamBlocked=8]="UpstreamBlocked",e[e.ComputingUpstream=9]="ComputingUpstream",e[e.TsVersionOutputOfDate=10]="TsVersionOutputOfDate",e[e.ContainerOnly=11]="ContainerOnly"}(v=e.UpToDateStatusType||(e.UpToDateStatusType={})),e.createBuilderStatusReporter=o,e.createSolutionBuilderHost=c,e.createSolutionBuilderWithWatchHost=u,e.createSolutionBuilder=_,e.resolveConfigFileProjectName=d,e.formatUpToDateStatus=p}(n||(n={}));var n;!function(e){var t;!function(t){function r(t){return e.sys.args.indexOf(t)>=0}function n(t){var r=e.sys.args.indexOf(t);return r>=0&&r<e.sys.args.length-1?e.sys.args[r+1]:void 0}function i(){var e=new Date;return e.getHours()+":"+e.getMinutes()+":"+e.getSeconds()+"."+e.getMilliseconds()}t.ActionSet="action::set",t.ActionInvalidate="action::invalidate",t.ActionPackageInstalled="action::packageInstalled",t.EventTypesRegistry="event::typesRegistry",t.EventBeginInstallTypes="event::beginInstallTypes",t.EventEndInstallTypes="event::endInstallTypes",t.EventInitializationFailed="event::initializationFailed";var a;!function(e){e.GlobalCacheLocation="--globalTypingsCacheLocation",e.LogFile="--logFile",e.EnableTelemetry="--enableTelemetry",e.TypingSafeListLocation="--typingSafeListLocation",e.TypesMapLocation="--typesMapLocation",e.NpmLocation="--npmLocation",e.ValidateDefaultNpmLocation="--validateDefaultNpmLocation"}(a=t.Arguments||(t.Arguments={})),t.hasArgument=r,t.findArgument=n,t.nowString=i}(t=e.server||(e.server={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){var n=new e.Version(e.getProperty(r,"ts"+e.versionMajorMinor)||e.getProperty(r,"latest"));return n.compareTo(t.version)<=0}function n(t,r){var n=e.readConfigFile(r,function(e){return t.readFile(e)});return e.createMapFromTemplate(n.config)}function i(t,r){var n=e.readConfigFile(r,function(e){return t.readFile(e)});return n.config?e.createMapFromTemplate(n.config.simpleMap):void 0}function a(n,i,a,o,s,c,u,l,_){function d(e){v.has(e)||v.set(e,void 0)}function p(t,r){i&&i(r+": "+JSON.stringify(t)),e.forEach(t,d)
}function f(t,r){if(n.fileExists(t)){r.push(t);var i=e.readConfigFile(t,function(e){return n.readFile(e)}).config,a=e.flatMap([i.dependencies,i.devDependencies,i.optionalDependencies,i.peerDependencies],e.getOwnKeys);p(a,"Typing names in '"+t+"' dependencies")}}function m(t){var r=e.mapDefined(t,function(t){if(!e.hasJSFileExtension(t))return void 0;var r=e.removeFileExtension(e.getBaseFileName(t.toLowerCase())),n=e.removeMinAndVersionNumbers(r);return s.get(n)});r.length&&p(r,"Inferred typings from file names");var n=e.some(t,function(t){return e.fileExtensionIs(t,".jsx")});n&&(i&&i("Inferred 'react' typings due to presence of '.jsx' extension"),d("react"))}function g(t,r){if(r.push(t),n.directoryExists(t)){var a=n.readDirectory(t,[".json"],void 0,void 0,2);i&&i("Searching for typing names in "+t+"; all files: "+JSON.stringify(a));for(var o=[],s=0,c=a;s<c.length;s++){var u=c[s],l=e.normalizePath(u),_=e.getBaseFileName(l);if("package.json"===_||"bower.json"===_){var d=e.readConfigFile(l,function(e){return n.readFile(e)}),f=d.config;if(("package.json"!==_||!f._requiredBy||0!==e.filter(f._requiredBy,function(e){return"#"===e[0]||"/"===e}).length)&&f.name){var m=f.types||f.typings;if(m){var g=e.getNormalizedAbsolutePath(m,e.getDirectoryPath(l));i&&i("    Package '"+f.name+"' provides its own types."),v.set(f.name,g)}else o.push(f.name)}}}p(o,"    Found package names")}}if(!u||!u.enable)return{cachedTypingPaths:[],newTypingNames:[],filesToWatch:[]};var v=e.createMap();a=e.mapDefined(a,function(t){var r=e.normalizePath(t);return e.hasJSFileExtension(r)?r:void 0});var y=[];u.include&&p(u.include,"Explicitly included types");var h=u.exclude||[],b=e.arrayToSet(a,e.getDirectoryPath);if(b.set(o,!0),b.forEach(function(t,r){var n=e.combinePaths(r,"package.json");f(n,y);var i=e.combinePaths(r,"bower.json");f(i,y);var a=e.combinePaths(r,"bower_components");g(a,y);var o=e.combinePaths(r,"node_modules");g(o,y)}),m(a),l){var x=e.deduplicate(l.map(function(e){return t.nodeCoreModules.has(e)?"node":e}),e.equateStringsCaseSensitive,e.compareStringsCaseSensitive);p(x,"Inferred typings from unresolved imports")}c.forEach(function(e,t){var n=_.get(t);v.has(t)&&void 0===v.get(t)&&void 0!==n&&r(e,n)&&v.set(t,e.typingLocation)});for(var D=0,S=h;D<S.length;D++){var C=S[D],k=v.delete(C);k&&i&&i("Typing for "+C+" is in exclude list, will be ignored.")}var T=[],E=[];v.forEach(function(e,t){void 0!==e?E.push(e):T.push(t)});var N={cachedTypingPaths:E,newTypingNames:T,filesToWatch:y};return i&&i("Result: "+JSON.stringify(N)),N}function o(e){return e?e.length>u?3:46===e.charCodeAt(0)?4:95===e.charCodeAt(0)?5:/^@[^\/]+\/[^\/]+$/.test(e)?1:encodeURIComponent(e)!==e?6:0:2}function s(t,r){switch(t){case 2:return"Package name '"+r+"' cannot be empty";case 3:return"Package name '"+r+"' should be less than "+u+" characters";case 4:return"Package name '"+r+"' cannot start with '.'";case 5:return"Package name '"+r+"' cannot start with '_'";case 1:return"Package '"+r+"' is scoped and currently is not supported";case 6:return"Package name '"+r+"' contains non URI safe characters";case 0:return e.Debug.fail();default:throw e.Debug.assertNever(t)}}t.isTypingUpToDate=r,t.nodeCoreModuleList=["assert","async_hooks","buffer","child_process","cluster","console","constants","crypto","dgram","dns","domain","events","fs","http","https","http2","inspector","net","os","path","perf_hooks","process","punycode","querystring","readline","repl","stream","string_decoder","timers","tls","tty","url","util","v8","vm","zlib"],t.nodeCoreModules=e.arrayToSet(t.nodeCoreModuleList),t.loadSafeList=n,t.loadTypesMap=i,t.discoverTypings=a;var c;!function(e){e[e.Ok=0]="Ok",e[e.ScopedPackagesNotSupported=1]="ScopedPackagesNotSupported",e[e.EmptyName=2]="EmptyName",e[e.NameTooLong=3]="NameTooLong",e[e.NameStartsWithDot=4]="NameStartsWithDot",e[e.NameStartsWithUnderscore=5]="NameStartsWithUnderscore",e[e.NameContainsNonURISafeCharacters=6]="NameContainsNonURISafeCharacters"}(c=t.PackageNameValidationResult||(t.PackageNameValidationResult={}));var u=214;t.validatePackageName=o,t.renderPackageNameValidationFailure=s}(t=e.JsTyping||(e.JsTyping={}))}(n||(n={}));var n;!function(e){function t(e){return{indentSize:4,tabSize:4,newLineCharacter:e||"\n",convertTabsToSpaces:!0,indentStyle:i.Smart,insertSpaceAfterConstructor:!1,insertSpaceAfterCommaDelimiter:!0,insertSpaceAfterSemicolonInForStatements:!0,insertSpaceBeforeAndAfterBinaryOperators:!0,insertSpaceAfterKeywordsInControlFlowStatements:!0,insertSpaceAfterFunctionKeywordForAnonymousFunctions:!1,insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis:!1,insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets:!1,insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces:!0,insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces:!1,insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces:!1,insertSpaceBeforeFunctionParenthesis:!1,placeOpenBraceOnNewLineForFunctions:!1,placeOpenBraceOnNewLineForControlBlocks:!1}}var r;!function(e){function t(e){return new r(e)}var r=function(){function e(e){this.text=e}return e.prototype.getText=function(e,t){return 0===e&&t===this.text.length?this.text:this.text.substring(e,t)},e.prototype.getLength=function(){return this.text.length},e.prototype.getChangeRange=function(){return void 0},e}();e.fromString=t}(r=e.ScriptSnapshot||(e.ScriptSnapshot={})),e.emptyOptions={};var n;!function(e){e.none="none",e.definition="definition",e.reference="reference",e.writtenReference="writtenReference"}(n=e.HighlightSpanKind||(e.HighlightSpanKind={}));var i;!function(e){e[e.None=0]="None",e[e.Block=1]="Block",e[e.Smart=2]="Smart"}(i=e.IndentStyle||(e.IndentStyle={})),e.getDefaultFormatCodeSettings=t,e.testFormatSettings=t("\n");var a;!function(e){e[e.aliasName=0]="aliasName",e[e.className=1]="className",e[e.enumName=2]="enumName",e[e.fieldName=3]="fieldName",e[e.interfaceName=4]="interfaceName",e[e.keyword=5]="keyword",e[e.lineBreak=6]="lineBreak",e[e.numericLiteral=7]="numericLiteral",e[e.stringLiteral=8]="stringLiteral",e[e.localName=9]="localName",e[e.methodName=10]="methodName",e[e.moduleName=11]="moduleName",e[e.operator=12]="operator",e[e.parameterName=13]="parameterName",e[e.propertyName=14]="propertyName",e[e.punctuation=15]="punctuation",e[e.space=16]="space",e[e.text=17]="text",e[e.typeParameterName=18]="typeParameterName",e[e.enumMemberName=19]="enumMemberName",e[e.functionName=20]="functionName",e[e.regularExpressionLiteral=21]="regularExpressionLiteral"}(a=e.SymbolDisplayPartKind||(e.SymbolDisplayPartKind={}));var o;!function(e){e.Comment="comment",e.Region="region",e.Code="code",e.Imports="imports"}(o=e.OutliningSpanKind||(e.OutliningSpanKind={}));var s;!function(e){e[e.JavaScript=0]="JavaScript",e[e.SourceMap=1]="SourceMap",e[e.Declaration=2]="Declaration"}(s=e.OutputFileType||(e.OutputFileType={}));var c;!function(e){e[e.None=0]="None",e[e.InMultiLineCommentTrivia=1]="InMultiLineCommentTrivia",e[e.InSingleQuoteStringLiteral=2]="InSingleQuoteStringLiteral",e[e.InDoubleQuoteStringLiteral=3]="InDoubleQuoteStringLiteral",e[e.InTemplateHeadOrNoSubstitutionTemplate=4]="InTemplateHeadOrNoSubstitutionTemplate",e[e.InTemplateMiddleOrTail=5]="InTemplateMiddleOrTail",e[e.InTemplateSubstitutionPosition=6]="InTemplateSubstitutionPosition"}(c=e.EndOfLineState||(e.EndOfLineState={}));var u;!function(e){e[e.Punctuation=0]="Punctuation",e[e.Keyword=1]="Keyword",e[e.Operator=2]="Operator",e[e.Comment=3]="Comment",e[e.Whitespace=4]="Whitespace",e[e.Identifier=5]="Identifier",e[e.NumberLiteral=6]="NumberLiteral",e[e.BigIntLiteral=7]="BigIntLiteral",e[e.StringLiteral=8]="StringLiteral",e[e.RegExpLiteral=9]="RegExpLiteral"}(u=e.TokenClass||(e.TokenClass={}));var l;!function(e){e.unknown="",e.warning="warning",e.keyword="keyword",e.scriptElement="script",e.moduleElement="module",e.classElement="class",e.localClassElement="local class",e.interfaceElement="interface",e.typeElement="type",e.enumElement="enum",e.enumMemberElement="enum member",e.variableElement="var",e.localVariableElement="local var",e.functionElement="function",e.localFunctionElement="local function",e.memberFunctionElement="method",e.memberGetAccessorElement="getter",e.memberSetAccessorElement="setter",e.memberVariableElement="property",e.constructorImplementationElement="constructor",e.callSignatureElement="call",e.indexSignatureElement="index",e.constructSignatureElement="construct",e.parameterElement="parameter",e.typeParameterElement="type parameter",e.primitiveType="primitive type",e.label="label",e.alias="alias",e.constElement="const",e.letElement="let",e.directory="directory",e.externalModuleName="external module name",e.jsxAttribute="JSX attribute",e.string="string"}(l=e.ScriptElementKind||(e.ScriptElementKind={}));var _;!function(e){e.none="",e.publicMemberModifier="public",e.privateMemberModifier="private",e.protectedMemberModifier="protected",e.exportedModifier="export",e.ambientModifier="declare",e.staticModifier="static",e.abstractModifier="abstract",e.optionalModifier="optional",e.dtsModifier=".d.ts",e.tsModifier=".ts",e.tsxModifier=".tsx",e.jsModifier=".js",e.jsxModifier=".jsx",e.jsonModifier=".json"}(_=e.ScriptElementKindModifier||(e.ScriptElementKindModifier={}));var d;!function(e){e.comment="comment",e.identifier="identifier",e.keyword="keyword",e.numericLiteral="number",e.bigintLiteral="bigint",e.operator="operator",e.stringLiteral="string",e.whiteSpace="whitespace",e.text="text",e.punctuation="punctuation",e.className="class name",e.enumName="enum name",e.interfaceName="interface name",e.moduleName="module name",e.typeParameterName="type parameter name",e.typeAliasName="type alias name",e.parameterName="parameter name",e.docCommentTagName="doc comment tag name",e.jsxOpenTagName="jsx open tag name",e.jsxCloseTagName="jsx close tag name",e.jsxSelfClosingTagName="jsx self closing tag name",e.jsxAttribute="jsx attribute",e.jsxText="jsx text",e.jsxAttributeStringLiteralValue="jsx attribute string literal value"}(d=e.ClassificationTypeNames||(e.ClassificationTypeNames={}));var p;!function(e){e[e.comment=1]="comment",e[e.identifier=2]="identifier",e[e.keyword=3]="keyword",e[e.numericLiteral=4]="numericLiteral",e[e.operator=5]="operator",e[e.stringLiteral=6]="stringLiteral",e[e.regularExpressionLiteral=7]="regularExpressionLiteral",e[e.whiteSpace=8]="whiteSpace",e[e.text=9]="text",e[e.punctuation=10]="punctuation",e[e.className=11]="className",e[e.enumName=12]="enumName",e[e.interfaceName=13]="interfaceName",e[e.moduleName=14]="moduleName",e[e.typeParameterName=15]="typeParameterName",e[e.typeAliasName=16]="typeAliasName",e[e.parameterName=17]="parameterName",e[e.docCommentTagName=18]="docCommentTagName",e[e.jsxOpenTagName=19]="jsxOpenTagName",e[e.jsxCloseTagName=20]="jsxCloseTagName",e[e.jsxSelfClosingTagName=21]="jsxSelfClosingTagName",e[e.jsxAttribute=22]="jsxAttribute",e[e.jsxText=23]="jsxText",e[e.jsxAttributeStringLiteralValue=24]="jsxAttributeStringLiteralValue",e[e.bigintLiteral=25]="bigintLiteral"}(p=e.ClassificationType||(e.ClassificationType={}))}(n||(n={}));var n;!function(e){function t(t){switch(t.kind){case 238:return e.isInJSFile(t)&&e.getJSDocEnumTag(t)?7:1;case 152:case 187:case 155:case 154:case 276:case 277:case 157:case 156:case 158:case 159:case 160:case 240:case 197:case 198:case 275:case 268:return 1;case 151:case 242:case 243:case 169:return 2;case 310:return void 0===t.name?3:2;case 279:case 241:return 3;case 245:return e.isAmbientModule(t)?5:1===e.getModuleInstanceState(t)?5:4;case 244:case 253:case 254:case 249:case 250:case 255:case 256:return 7;case 285:return 5}return 7}function r(r){return 285===r.kind?1:255===r.parent.kind||260===r.parent.kind?7:i(r)?n(r):e.isDeclarationName(r)?t(r.parent):c(r)?2:a(r)?4:e.isTypeParameterDeclaration(r.parent)?(e.Debug.assert(e.isJSDocTemplateTag(r.parent.parent)),2):e.isLiteralTypeNode(r.parent)?3:1}function n(t){var r=149===t.kind?t:e.isQualifiedName(t.parent)&&t.parent.right===t?t.parent:void 0;return r&&249===r.parent.kind?7:4}function i(t){for(;149===t.parent.kind;)t=t.parent;return e.isInternalModuleImportEqualsDeclaration(t.parent)&&t.parent.moduleReference===t}function a(e){return o(e)||s(e)}function o(e){var t=e,r=!0;if(149===t.parent.kind){for(;t.parent&&149===t.parent.kind;)t=t.parent;r=t.right===e}return 165===t.parent.kind&&!r}function s(e){var t=e,r=!0;if(190===t.parent.kind){for(;t.parent&&190===t.parent.kind;)t=t.parent;r=t.name===e}if(!r&&212===t.parent.kind&&274===t.parent.parent.kind){var n=t.parent.parent.parent;return 241===n.kind&&110===t.parent.parent.token||242===n.kind&&87===t.parent.parent.token}return!1}function c(t){switch(e.isRightSideOfQualifiedNameOrPropertyAccess(t)&&(t=t.parent),t.kind){case 101:return!e.isExpressionNode(t);case 179:return!0}switch(t.parent.kind){case 165:return!0;case 184:return!t.parent.isTypeOf;case 212:return!e.isExpressionWithTypeArgumentsInClassExtendsClause(t.parent)}return!1}function u(t){return d(t,e.isCallExpression)}function l(t){return d(t,e.isNewExpression)}function _(t){return d(t,e.isCallOrNewExpression)}function d(e,t){var r=p(e);return!!r&&!!r.parent&&t(r.parent)&&r.parent.expression===r}function p(e){return x(e)?e.parent:e}function f(e,t){for(;e;){if(234===e.kind&&e.label.escapedText===t)return e.label;e=e.parent}return void 0}function m(t,r){return e.isPropertyAccessExpression(t.expression)?t.expression.name.text===r:!1}function g(t){return 73===t.kind&&e.isBreakOrContinueStatement(t.parent)&&t.parent.label===t}function v(t){return 73===t.kind&&e.isLabeledStatement(t.parent)&&t.parent.label===t}function y(e){return v(e)||g(e)}function h(t){return e.isJSDocTag(t.parent)&&t.parent.tagName===t}function b(e){return 149===e.parent.kind&&e.parent.right===e}function x(e){return e&&e.parent&&190===e.parent.kind&&e.parent.name===e}function D(e){return 245===e.parent.kind&&e.parent.name===e}function S(t){return 73===t.kind&&e.isFunctionLike(t.parent)&&t.parent.name===t}function C(t){switch(t.parent.kind){case 155:case 154:case 276:case 279:case 157:case 156:case 159:case 160:case 245:return e.getNameOfDeclaration(t.parent)===t;case 191:return t.parent.argumentExpression===t;case 150:return!0;case 183:return 181===t.parent.parent.kind;default:return!1}}function k(t){return e.isExternalModuleImportEqualsDeclaration(t.parent.parent)&&e.getExternalModuleImportEqualsDeclarationExpression(t.parent.parent)===t}function T(t){for(e.isJSDocTypeAlias(t)&&(t=t.parent.parent);;){if(t=t.parent,!t)return void 0;switch(t.kind){case 285:case 157:case 156:case 240:case 197:case 159:case 160:case 241:case 242:case 244:case 245:return t}}}function E(t){function r(t){return e.isVarConst(t)?"const":e.isLet(t)?"let":"var"}switch(t.kind){case 285:return e.isExternalModule(t)?"module":"script";case 245:return"module";case 241:case 210:return"class";case 242:return"interface";case 243:case 303:case 310:return"type";case 244:return"enum";case 238:return r(t);case 187:return r(e.getRootDeclaration(t));case 198:case 240:case 197:return"function";case 159:return"getter";case 160:return"setter";case 157:case 156:return"method";case 155:case 154:return"property";case 163:return"index";case 162:return"construct";case 161:return"call";case 158:return"constructor";case 151:return"type parameter";case 279:return"enum member";case 152:return e.hasModifier(t,92)?"property":"parameter";case 249:case 254:case 258:case 252:return"alias";case 205:var n=e.getAssignmentDeclarationKind(t),i=t.right;switch(n){case 7:case 8:case 9:case 0:return"";case 1:case 2:var a=E(i);return""===a?"const":a;case 3:return e.isFunctionExpression(i)?"method":"property";case 4:return"property";case 5:return e.isFunctionExpression(i)?"method":"property";case 6:return"local class";default:return e.assertType(n),""}case 73:return e.isImportClause(t.parent)?"alias":"";default:return""}}function N(t){switch(t.kind){case 101:return!0;case 73:return e.identifierIsThisKeyword(t)&&152===t.parent.kind;default:return!1}}function A(t,r){var n=e.getLineStarts(r),i=r.getLineAndCharacterOfPosition(t).line;return n[i]}function F(e,t){return O(e.pos,e.end,t)}function P(e,t){return I(e,t.pos)&&I(e,t.end)}function w(e,t){return e.pos<=t&&t<=e.end}function I(e,t){return e.pos<t&&t<e.end}function O(e,t,r){return e<=r.pos&&t>=r.end}function M(e,t,r){return e.pos<=t&&e.end>=r}function L(e,t,r){return B(e.pos,e.end,t,r)}function R(e,t,r,n){return B(e.getStart(t),e.end,r,n)}function B(e,t,r,n){var i=Math.max(e,r),a=Math.min(t,n);return a>i}function j(t,r,n){return e.Debug.assert(t.pos<=r),r<t.end||!J(t,n)}function J(t,r){if(void 0===t||e.nodeIsMissing(t))return!1;switch(t.kind){case 241:case 242:case 244:case 189:case 185:case 169:case 219:case 246:case 247:case 253:case 257:return z(t,19,r);case 275:return J(t.block,r);case 193:if(!t.arguments)return!0;case 192:case 196:case 178:return z(t,21,r);case 166:case 167:return J(t.type,r);case 158:case 159:case 160:case 240:case 197:case 157:case 156:case 162:case 161:case 198:return t.body?J(t.body,r):t.type?J(t.type,r):U(t,21,r);case 245:return!!t.body&&J(t.body,r);case 223:return t.elseStatement?J(t.elseStatement,r):J(t.thenStatement,r);case 222:return J(t.expression,r)||U(t,26,r);case 188:case 186:case 191:case 150:case 171:return z(t,23,r);case 163:return t.type?J(t.type,r):U(t,23,r);case 272:case 273:return!1;case 226:case 227:case 228:case 225:return J(t.statement,r);case 224:return U(t,108,r)?z(t,21,r):J(t.statement,r);case 168:return J(t.exprName,r);case 200:case 199:case 201:case 208:case 209:var n=t;return J(n.expression,r);case 194:return J(t.template,r);case 207:var i=e.lastOrUndefined(t.templateSpans);return J(i,r);case 217:return e.nodeIsPresent(t.literal);case 256:case 250:return e.nodeIsPresent(t.moduleSpecifier);case 203:return J(t.operand,r);case 205:return J(t.right,r);case 206:return J(t.whenFalse,r);default:return!0}}function z(t,r,n){var i=t.getChildren(n);if(i.length){var a=e.last(i);if(a.kind===r)return!0;if(26===a.kind&&1!==i.length)return i[i.length-2].kind===r}return!1}function V(t){var r=q(t);if(!r)return void 0;var n=r.getChildren(),i=e.indexOfNode(n,t);return{listItemIndex:i,list:r}}function U(e,t,r){return!!K(e,t,r)}function K(t,r,n){return e.find(t.getChildren(n),function(e){return e.kind===r})}function q(t){var r=e.find(t.parent.getChildren(),function(r){return e.isSyntaxList(r)&&F(r,t)});return e.Debug.assert(!r||e.contains(r.getChildren(),t)),r}function W(t,r){return H(t,r,function(t){return e.isPropertyNameLiteral(t)||e.isKeyword(t.kind)})}function H(e,t,r){return Q(e,t,!1,r,!1)}function G(e,t){return Q(e,t,!0,void 0,!1)}function Q(e,t,r,n,i){var a=e;e:for(;;){for(var o=0,s=a.getChildren(e);o<s.length;o++){var c=s[o],u=r?c.getFullStart():c.getStart(e,!0);if(u>t)break;var l=c.getEnd();if(l>t||t===l&&(1===c.kind||i)){a=c;continue e}if(n&&l===t){var _=Z(t,e,c);if(_&&n(_))return _}}return a}}function X(t,r){var n=G(t,r);return e.isToken(n)&&r>n.getStart(t)&&r<n.getEnd()?n:Z(r,t)}function Y(t,r,n){function i(r){return e.isToken(r)&&r.pos===t.end?r:e.firstDefined(r.getChildren(),function(e){var r=e.pos<=t.pos&&e.end>t.end||e.pos===t.end;return r&&pt(e,n)?i(e):void 0})}return i(r)}function Z(t,r,n,i){function a(o){if($(o)&&1!==o.kind)return o;for(var s=o.getChildren(r),c=0;c<s.length;c++){var u=s[c];if(t<u.end){var l=u.getStart(r,!i),_=l>=t||!pt(u,r)||it(u);if(_){var d=tt(s,c,r);return d&&et(d,r)}return a(u)}}e.Debug.assert(void 0!==n||285===o.kind||1===o.kind||e.isJSDocCommentContainingNode(o));var p=tt(s,s.length,r);return p&&et(p,r)}var o=a(n||r);return e.Debug.assert(!(o&&it(o))),o}function $(t){return e.isToken(t)&&!it(t)}function et(e,t){if($(e))return e;var r=e.getChildren(t),n=tt(r,r.length,t);return n&&et(n,t)}function tt(t,r,n){for(var i=r-1;i>=0;i--){var a=t[i];if(it(a))e.Debug.assert(i>0,"`JsxText` tokens should not be the first child of `JsxElement | JsxSelfClosingElement`");else if(pt(t[i],n))return t[i]}}function rt(t,r,n){if(void 0===n&&(n=Z(r,t)),n&&e.isStringTextContainingNode(n)){var i=n.getStart(t),a=n.getEnd();if(r>i&&a>r)return!0;if(r===a)return!!n.isUnterminated}return!1}function nt(e,t){var r=G(e,t);return r?11===r.kind?!0:28===r.kind&&11===r.parent.kind?!0:28===r.kind&&271===r.parent.kind?!0:r&&19===r.kind&&271===r.parent.kind?!0:28===r.kind&&264===r.parent.kind?!0:!1:!1}function it(t){return e.isJsxText(t)&&t.containsOnlyTriviaWhiteSpaces}function at(t,r){var n=G(t,r);return e.isTemplateLiteralKind(n.kind)&&r>n.getStart(t)}function ot(t,r){var n=G(t,r);return e.isJsxText(n)?!0:18===n.kind&&e.isJsxExpression(n.parent)&&e.isJsxElement(n.parent.parent)?!0:28===n.kind&&e.isJsxOpeningLikeElement(n.parent)&&e.isJsxElement(n.parent.parent)?!0:!1}function st(e,t,r){for(var n=e.kind,i=0;;){var a=Z(e.getFullStart(),r);if(!a)return void 0;if(e=a,e.kind===t){if(0===i)return e;i--}else e.kind===n&&i++}}function ct(t,r,n){var i=lt(t,r);return void 0!==i&&(e.isPartOfTypeNode(i.called)||0!==ut(i.called,i.nTypeArguments,n).length||ct(i.called,r,n))}function ut(t,r,n){var i=n.getTypeAtLocation(t),a=e.isNewExpression(t.parent)?i.getConstructSignatures():i.getCallSignatures();return a.filter(function(e){return!!e.typeParameters&&e.typeParameters.length>=r})}function lt(t,r){for(var n=t,i=0,a=0;n;){switch(n.kind){case 28:if(n=Z(n.getFullStart(),r),!n||!e.isIdentifier(n))return void 0;if(!i)return e.isDeclarationName(n)?void 0:{called:n,nTypeArguments:a};i--;break;case 48:i=3;break;case 47:i=2;break;case 30:i++;break;case 19:if(n=st(n,18,r),!n)return void 0;break;case 21:if(n=st(n,20,r),!n)return void 0;break;case 23:if(n=st(n,22,r),!n)return void 0;break;case 27:a++;break;case 37:case 73:case 10:case 8:case 9:case 103:case 88:case 105:case 87:case 130:case 24:case 50:case 56:case 57:break;default:if(e.isTypeNode(n))break;return void 0}n=Z(n.getFullStart(),r)}return void 0}function _t(t,r,n){return e.formatting.getRangeOfEnclosingComment(t,r,void 0,n)}function dt(t,r){var n=G(t,r);return!!e.findAncestor(n,e.isJSDoc)}function pt(e,t){return 1===e.kind?!!e.jsDoc:0!==e.getWidth(t)}function ft(t){var r=e.isDeclaration(t)?e.getCombinedModifierFlags(t):0,n=[];return 8&r&&n.push("private"),16&r&&n.push("protected"),4&r&&n.push("public"),32&r&&n.push("static"),128&r&&n.push("abstract"),1&r&&n.push("export"),4194304&t.flags&&n.push("declare"),n.length>0?n.join(","):""}function mt(t){return 165===t.kind||192===t.kind?t.typeArguments:e.isFunctionLike(t)||241===t.kind||242===t.kind?t.typeParameters:void 0}function gt(e){return 2===e||3===e}function vt(t){return 10===t||13===t||e.isTemplateLiteralKind(t)?!0:!1}function yt(e){return e>=18&&72>=e}function ht(t,r,n){return e.isTemplateLiteralKind(t.kind)&&t.getStart(n)<r&&r<t.end||!!t.isUnterminated&&r===t.end}function bt(e){switch(e){case 116:case 114:case 115:return!0}return!1}function xt(t){var r=e.clone(t);return e.setConfigFileInOptions(r,t&&t.configFile),r}function Dt(e){if(188===e.kind||189===e.kind){if(205===e.parent.kind&&e.parent.left===e&&60===e.parent.operatorToken.kind)return!0;if(228===e.parent.kind&&e.parent.initializer===e)return!0;if(Dt(276===e.parent.kind?e.parent.parent:e.parent))return!0}return!1}function St(e,t){return kt(e,t,!0)}function Ct(e,t){return kt(e,t,!1)}function kt(e,t,r){var n=_t(e,t,void 0);return!!n&&r===cr.test(e.text.substring(n.pos,n.end))}function Tt(t,r){return e.createTextSpanFromBounds(t.getStart(r),t.getEnd())}function Et(t,r){return e.createRange(t.getStart(r),t.end)}function Nt(t){return e.createTextSpanFromBounds(t.pos,t.end)}function At(t){return e.createRange(t.start,t.start+t.length)}function Ft(t,r,n){return Pt(e.createTextSpan(t,r),n)}function Pt(e,t){return{span:e,newText:t}}function wt(t){return e.contains(e.typeKeywords,t)}function It(e){return!!(1536&e.flags)&&34===e.name.charCodeAt(0)}function Ot(){var t=[];return function(r){var n=e.getNodeId(r);return!t[n]&&(t[n]=!0)}}function Mt(e){return e.getText(0,e.getLength())}function Lt(e,t){for(var r="",n=0;t>n;n++)r+=e;return r}function Rt(e){return e.isTypeParameter()?e.getConstraint()||e:e}function Bt(t){return 150===t.kind?e.isStringOrNumericLiteralLike(t.expression)?t.expression.text:void 0:e.getTextOfIdentifierOrLiteral(t)}function jt(e){return e.getSourceFiles().some(function(t){return!t.isDeclarationFile&&!e.isSourceFileFromExternalLibrary(t)&&!!t.externalModuleIndicator})}function Jt(e){return!!e.module||e.target>=2||!!e.noEmit}function zt(e){return e.useCaseSensitiveFileNames?e.useCaseSensitiveFileNames():!1}function Vt(t){return e.createGetCanonicalFileName(zt(t))}function Ut(e,t,r,n){return e||t&&t.length?Kt(e,t,r,n):void 0}function Kt(t,r,n,i){return e.createImportDeclaration(void 0,void 0,t||r?e.createImportClause(t,r&&r.length?e.createNamedImports(r):void 0):void 0,"string"==typeof n?qt(n,i):n)}function qt(t,r){return e.createLiteral(t,0===r)}function Wt(t,r){return e.isStringDoubleQuoted(t,r)?1:0}function Ht(t,r){if(r.quotePreference&&"auto"!==r.quotePreference)return"single"===r.quotePreference?0:1;var n=t.imports&&e.find(t.imports,e.isStringLiteral);return n?Wt(n,t):1}function Gt(t){switch(t){case 0:return"'";case 1:return'"';default:return e.Debug.assertNever(t)}}function Qt(t){var r=Xt(t);return void 0===r?void 0:e.unescapeLeadingUnderscores(r)}function Xt(t){return"default"!==t.escapedName?t.escapedName:e.firstDefined(t.declarations,function(t){var r=e.getNameOfDeclaration(t);return r&&73===r.kind?r.escapedText:void 0})}function Yt(t){return e.isBindingElement(t)&&e.isObjectBindingPattern(t.parent)&&e.isIdentifier(t.name)&&!t.propertyName}function Zt(e,t){var r=e.getTypeAtLocation(t.parent);return r&&e.getPropertyOfType(r,t.name.text)}function $t(t,r,n,i){function a(t){return 96&t.flags&&e.addToSeen(o,e.getSymbolId(t))?e.firstDefined(t.declarations,function(t){return e.firstDefined(e.getAllSuperTypeNodes(t),function(t){var o=n.getTypeAtLocation(t),s=o&&o.symbol&&n.getPropertyOfType(o,r);return o&&s&&(e.firstDefined(n.getRootSymbols(s),i)||a(o.symbol))})}):void 0}var o=e.createMap();return a(t)}function er(e,t){return $t(e.parent,e.name,t,function(){return!0})||!1}function tr(t,r,n){if(!t)return void 0;for(;t.parent;){if(e.isSourceFile(t.parent)||!rr(n,t.parent,r))return t;t=t.parent}}function rr(t,r,n){return e.textSpanContainsPosition(t,r.getStart(n))&&r.getEnd()<=e.textSpanEnd(t)}function nr(t,r){return t.modifiers&&e.find(t.modifiers,function(e){return e.kind===r})}function ir(t,r,n){var i=e.findLast(r.statements,e.isAnyImportSyntax);i?t.insertNodeAfter(r,i,n):t.insertNodeAtTopOfFile(r,n,!0)}function ar(e,t){return!!e&&!!t&&e.start===t.start&&e.length===t.length}function or(e,t){return e.fileName===t.fileName&&ar(e.textSpan,t.textSpan)}e.scanner=e.createScanner(8,!0);var sr;!function(e){e[e.None=0]="None",e[e.Value=1]="Value",e[e.Type=2]="Type",e[e.Namespace=4]="Namespace",e[e.All=7]="All"}(sr=e.SemanticMeaning||(e.SemanticMeaning={})),e.getMeaningFromDeclaration=t,e.getMeaningFromLocation=r,e.isInRightSideOfInternalImportEqualsDeclaration=i,e.isCallExpressionTarget=u,e.isNewExpressionTarget=l,e.isCallOrNewExpressionTarget=_,e.climbPastPropertyAccess=p,e.getTargetLabel=f,e.hasPropertyAccessExpressionWithName=m,e.isJumpStatementTarget=g,e.isLabelOfLabeledStatement=v,e.isLabelName=y,e.isTagName=h,e.isRightSideOfQualifiedName=b,e.isRightSideOfPropertyAccess=x,e.isNameOfModuleDeclaration=D,e.isNameOfFunctionDeclaration=S,e.isLiteralNameOfPropertyDeclarationOrIndexAccess=C,e.isExpressionOfExternalModuleImportEqualsDeclaration=k,e.getContainerNode=T,e.getNodeKind=E,e.isThis=N;var cr=/^\/\/\/\s*</;e.getLineStartPositionForPosition=A,e.rangeContainsRange=F,e.rangeContainsRangeExclusive=P,e.rangeContainsPosition=w,e.rangeContainsPositionExclusive=I,e.startEndContainsRange=O,e.rangeContainsStartEnd=M,e.rangeOverlapsWithStartEnd=L,e.nodeOverlapsWithStartEnd=R,e.startEndOverlapsWithStartEnd=B,e.positionBelongsToNode=j,e.findListItemInfo=V,e.hasChildOfKind=U,e.findChildOfKind=K,e.findContainingList=q,e.getTouchingPropertyName=W,e.getTouchingToken=H,e.getTokenAtPosition=G,e.findTokenOnLeftOfPosition=X,e.findNextToken=Y,e.findPrecedingToken=Z,e.isInString=rt,e.isInsideJsxElementOrAttribute=nt,e.isInTemplateString=at,e.isInJSXText=ot,e.findPrecedingMatchingToken=st,e.isPossiblyTypeArgumentPosition=ct,e.getPossibleGenericSignatures=ut,e.getPossibleTypeArgumentsInfo=lt,e.isInComment=_t,e.hasDocComment=dt,e.getNodeModifiers=ft,e.getTypeArgumentOrTypeParameterList=mt,e.isComment=gt,e.isStringOrRegularExpressionOrTemplateLiteral=vt,e.isPunctuation=yt,e.isInsideTemplateLiteral=ht,e.isAccessibilityModifier=bt,e.cloneCompilerOptions=xt,e.isArrayLiteralOrObjectLiteralDestructuringPattern=Dt,e.isInReferenceComment=St,e.isInNonReferenceComment=Ct,e.createTextSpanFromNode=Tt,e.createTextRangeFromNode=Et,e.createTextSpanFromRange=Nt,e.createTextRangeFromSpan=At,e.createTextChangeFromStartLength=Ft,e.createTextChange=Pt,e.typeKeywords=[121,147,124,88,130,133,97,136,137,139,140,103,107,142,143,144],e.isTypeKeyword=wt,e.isExternalModuleSymbol=It,e.nodeSeenTracker=Ot,e.getSnapshotText=Mt,e.repeatString=Lt,e.skipConstraint=Rt,e.getNameFromPropertyName=Bt,e.programContainsEs6Modules=jt,e.compilerOptionsIndicateEs6Modules=Jt,e.hostUsesCaseSensitiveFileNames=zt,e.hostGetCanonicalFileName=Vt,e.makeImportIfNecessary=Ut,e.makeImport=Kt,e.makeStringLiteral=qt;var ur;!function(e){e[e.Single=0]="Single",e[e.Double=1]="Double"}(ur=e.QuotePreference||(e.QuotePreference={})),e.quotePreferenceFromString=Wt,e.getQuotePreference=Ht,e.getQuoteFromPreference=Gt,e.symbolNameNoDefault=Qt,e.symbolEscapedNameNoDefault=Xt,e.isObjectBindingElementWithoutPropertyName=Yt,e.getPropertySymbolFromBindingElement=Zt,e.getPropertySymbolsFromBaseTypes=$t,e.isMemberSymbolInBaseType=er,e.getParentNodeInSpan=tr,e.findModifier=nr,e.insertImport=ir,e.textSpansEqual=ar,e.documentSpansEqual=or}(n||(n={})),function(e){function t(e){return e.declarations&&e.declarations.length>0&&152===e.declarations[0].kind}function r(){function t(){if(!(_>p)&&u){var t=e.getIndentString(l);t&&(_+=t.length,c.push(i(t,e.SymbolDisplayPartKind.space))),u=!1}}function r(e,r){_>p||(t(),_+=e.length,c.push(i(e,r)))}function a(e,r){_>p||(t(),_+=e.length,c.push(n(e,r)))}function o(){_>p||(_+=1,c.push(d()),u=!0)}function s(){c=[],u=!0,l=0,_=0}var c,u,l,_,p=10*e.defaultMaximumTruncationLength;s();var f=function(t){return r(t,e.SymbolDisplayPartKind.text)};return{displayParts:function(){var t=c.length&&c[c.length-1].text;return _>p&&t&&"..."!==t&&(e.isWhiteSpaceLike(t.charCodeAt(t.length-1))||c.push(i(" ",e.SymbolDisplayPartKind.space)),c.push(i("...",e.SymbolDisplayPartKind.punctuation))),c},writeKeyword:function(t){return r(t,e.SymbolDisplayPartKind.keyword)},writeOperator:function(t){return r(t,e.SymbolDisplayPartKind.operator)},writePunctuation:function(t){return r(t,e.SymbolDisplayPartKind.punctuation)},writeTrailingSemicolon:function(t){return r(t,e.SymbolDisplayPartKind.punctuation)},writeSpace:function(t){return r(t,e.SymbolDisplayPartKind.space)},writeStringLiteral:function(t){return r(t,e.SymbolDisplayPartKind.stringLiteral)},writeParameter:function(t){return r(t,e.SymbolDisplayPartKind.parameterName)},writeProperty:function(t){return r(t,e.SymbolDisplayPartKind.propertyName)},writeLiteral:function(t){return r(t,e.SymbolDisplayPartKind.stringLiteral)},writeSymbol:a,writeLine:o,write:f,writeComment:f,getText:function(){return""},getTextPos:function(){return 0},getColumn:function(){return 0},getLine:function(){return 0},isAtStartOfLine:function(){return!1},rawWrite:e.notImplemented,getIndent:function(){return l},increaseIndent:function(){l++},decreaseIndent:function(){l--},clear:s,trackSymbol:e.noop,reportInaccessibleThisError:e.noop,reportInaccessibleUniqueSymbolError:e.noop,reportPrivateInBaseOfClassExpression:e.noop}}function n(r,n){function a(r){var n=r.flags;return 3&n?t(r)?e.SymbolDisplayPartKind.parameterName:e.SymbolDisplayPartKind.localName:4&n?e.SymbolDisplayPartKind.propertyName:32768&n?e.SymbolDisplayPartKind.propertyName:65536&n?e.SymbolDisplayPartKind.propertyName:8&n?e.SymbolDisplayPartKind.enumMemberName:16&n?e.SymbolDisplayPartKind.functionName:32&n?e.SymbolDisplayPartKind.className:64&n?e.SymbolDisplayPartKind.interfaceName:384&n?e.SymbolDisplayPartKind.enumName:1536&n?e.SymbolDisplayPartKind.moduleName:8192&n?e.SymbolDisplayPartKind.methodName:262144&n?e.SymbolDisplayPartKind.typeParameterName:524288&n?e.SymbolDisplayPartKind.aliasName:2097152&n?e.SymbolDisplayPartKind.aliasName:e.SymbolDisplayPartKind.text
}return i(r,a(n))}function i(t,r){return{text:t,kind:e.SymbolDisplayPartKind[r]}}function a(){return i(" ",e.SymbolDisplayPartKind.space)}function o(t){return i(e.tokenToString(t),e.SymbolDisplayPartKind.keyword)}function s(t){return i(e.tokenToString(t),e.SymbolDisplayPartKind.punctuation)}function c(t){return i(e.tokenToString(t),e.SymbolDisplayPartKind.operator)}function u(t){var r=e.stringToToken(t);return void 0===r?l(t):o(r)}function l(t){return i(t,e.SymbolDisplayPartKind.text)}function _(e,t){return t&&t.newLineCharacter||e.getNewLine&&e.getNewLine()||Z}function d(){return i("\n",e.SymbolDisplayPartKind.lineBreak)}function p(e){try{return e(Y),Y.displayParts()}finally{Y.clear()}}function f(e,t,r,n){return void 0===n&&(n=0),p(function(i){e.writeType(t,r,1024|n|16384,i)})}function m(e,t,r,n,i){return void 0===i&&(i=0),p(function(a){e.writeSymbol(t,r,n,8|i,a)})}function g(e,t,r,n){return void 0===n&&(n=0),n|=25632,p(function(i){e.writeSignature(t,r,n,void 0,i)})}function v(t){return!!t.parent&&e.isImportOrExportSpecifier(t.parent)&&t.parent.propertyName===t}function y(e){var t=e.length;return t>=2&&e.charCodeAt(0)===e.charCodeAt(t-1)&&h(e)?e.substring(1,t-1):e}function h(t){return e.isSingleOrDoubleQuote(t.charCodeAt(0))}function b(t,r){for(var n=[],i=2;i<arguments.length;i++)n[i-2]=arguments[i];var a=x(t,r);return e.some(n,function(e){return e===a})}function x(t,r){return e.ensureScriptKind(t,r&&r.getScriptKind&&r.getScriptKind(t))}function D(t,r){for(var n=t;C(n)||S(n)&&n.target;)n=S(n)&&n.target?n.target:e.skipAlias(n,r);return n}function S(e){return 0!==(33554432&e.flags)}function C(e){return 0!==(2097152&e.flags)}function k(t,r){return e.getSymbolId(e.skipAlias(t,r))}function T(t,r){for(;e.isWhiteSpaceLike(t.charCodeAt(r));)r+=1;return r}function E(t,r){for(;r>-1&&e.isWhiteSpaceSingleLine(t.charCodeAt(r));)r-=1;return r+1}function N(e,t){void 0===t&&(t=!0);var r=e&&F(e);return r&&!t&&w(r),r}function A(t,r,n,i,a){void 0===r&&(r=!0);var o;if(n&&i&&e.isBindingElement(t)&&e.isIdentifier(t.name)&&e.isObjectBindingPattern(t.parent)){var s=i.getSymbolAtLocation(t.name),c=s&&n.get(String(e.getSymbolId(s)));c&&c.text!==(t.name||t.propertyName).getText()&&(o=e.createBindingElement(t.dotDotDotToken,t.propertyName||t.name,c,t.initializer))}else if(n&&i&&e.isIdentifier(t)){var s=i.getSymbolAtLocation(t),c=s&&n.get(String(e.getSymbolId(s)));c&&(o=e.createIdentifier(c.text))}return o||(o=F(t,n,i,a)),o&&!r&&w(o),a&&o&&a(t,o),o}function F(t,r,n,i){function a(e){return A(e,!0,r,n,i)}var o=r||n||i?e.visitEachChild(t,a,e.nullTransformationContext):e.visitEachChild(t,N,e.nullTransformationContext);if(o===t){var s=e.getSynthesizedClone(t);return e.isStringLiteral(s)?s.textSourceNode=t:e.isNumericLiteral(s)&&(s.numericLiteralFlags=t.numericLiteralFlags),e.setTextRange(s,t)}return o.parent=void 0,o}function P(t,r){return void 0===r&&(r=!0),t&&e.createNodeArray(t.map(function(e){return N(e,r)}),t.hasTrailingComma)}function w(e){I(e),O(e)}function I(e){M(e,512,L)}function O(t){M(t,1024,e.getLastChild)}function M(t,r,n){e.addEmitFlags(t,r);var i=n(t);i&&M(i,r,n)}function L(e){return e.forEachChild(function(e){return e})}function R(t,r){for(var n=t,i=1;!e.isFileLevelUniqueName(r,n);i++)n=t+"_"+i;return n}function B(t,r,n,i){for(var a=0,o=-1,s=0,c=t;s<c.length;s++){var u=c[s],l=u.fileName,_=u.textChanges;e.Debug.assert(l===r);for(var d=0,p=_;d<p.length;d++){var f=p[d],m=f.span,g=f.newText,v=U(g,n);if(-1!==v&&(o=m.start+a+v,!i))return o;a+=g.length-m.length}}return e.Debug.assert(i),e.Debug.assert(o>=0),o}function j(t,r,n,i,a){e.forEachLeadingCommentRange(n.text,t.pos,V(r,n,i,a,e.addSyntheticLeadingComment))}function J(t,r,n,i,a){e.forEachTrailingCommentRange(n.text,t.end,V(r,n,i,a,e.addSyntheticTrailingComment))}function z(t,r,n,i,a){e.forEachTrailingCommentRange(n.text,t.pos,V(r,n,i,a,e.addSyntheticLeadingComment))}function V(e,t,r,n,i){return function(a,o,s,c){3===s?(a+=2,o-=2):a+=2,i(e,r||s,t.text.slice(a,o),void 0!==n?n:c)}}function U(t,r){if(e.startsWith(t,r))return 0;var n=t.indexOf(" "+r);return-1===n&&(n=t.indexOf("."+r)),-1===n&&(n=t.indexOf('"'+r)),-1===n?-1:n+1}function K(e,t){var r=e.parent;switch(r.kind){case 193:return t.getContextualType(r);case 205:var n=r,i=n.left,a=n.operatorToken,o=n.right;return W(a.kind)?t.getTypeAtLocation(e===o?i:o):t.getContextualType(e);case 272:return r.expression===e?Q(r,t):void 0;default:return t.getContextualType(e)}}function q(t,r){if(/^\d+$/.test(t))return t;var n=r.quotePreference||"auto",i=JSON.stringify(t);switch(n){case"auto":case"double":return i;case"single":return"'"+y(i).replace("'","\\'").replace('\\"','"')+"'";default:return e.Debug.assertNever(n)}}function W(e){switch(e){case 35:case 33:case 36:case 34:return!0;default:return!1}}function H(e){switch(e.kind){case 10:case 14:case 207:case 194:return!0;default:return!1}}function G(e){return!!e.getStringIndexType()||!!e.getNumberIndexType()}function Q(e,t){return t.getTypeAtLocation(e.parent.parent.expression)}function X(e,t,r,n){var i=r.getTypeChecker(),a=!0,o=function(){a=!1},s=i.typeToTypeNode(e,t,void 0,{trackSymbol:function(e,t,r){a=a&&0===i.isSymbolAccessible(e,t,r,!1).accessibility},reportInaccessibleThisError:o,reportPrivateInBaseOfClassExpression:o,reportInaccessibleUniqueSymbolError:o,moduleResolverHost:{readFile:n.readFile,fileExists:n.fileExists,directoryExists:n.directoryExists,getSourceFiles:r.getSourceFiles,getCurrentDirectory:r.getCurrentDirectory,getCommonSourceDirectory:r.getCommonSourceDirectory}});return a?s:void 0}e.isFirstDeclarationOfSymbolParameter=t;var Y=r();e.symbolPart=n,e.displayPart=i,e.spacePart=a,e.keywordPart=o,e.punctuationPart=s,e.operatorPart=c,e.textOrKeywordPart=u,e.textPart=l;var Z="\r\n";e.getNewLineOrDefaultFromHost=_,e.lineBreakPart=d,e.mapToDisplayParts=p,e.typeToDisplayParts=f,e.symbolToDisplayParts=m,e.signatureToDisplayParts=g,e.isImportOrExportSpecifierName=v,e.stripQuotes=y,e.startsWithQuote=h,e.scriptKindIs=b,e.getScriptKind=x,e.getSymbolTarget=D,e.getUniqueSymbolId=k,e.getFirstNonSpaceCharacterPosition=T,e.getPrecedingNonSpaceCharacterPosition=E,e.getSynthesizedDeepClone=N,e.getSynthesizedDeepCloneWithRenames=A,e.getSynthesizedDeepClones=P,e.suppressLeadingAndTrailingTrivia=w,e.suppressLeadingTrivia=I,e.suppressTrailingTrivia=O,e.getUniqueName=R,e.getRenameLocation=B,e.copyLeadingComments=j,e.copyTrailingComments=J,e.copyTrailingAsLeadingComments=z,e.getContextualTypeFromParent=K,e.quote=q,e.isEqualityOperatorKind=W,e.isStringLiteralOrTemplate=H,e.hasIndexSignature=G,e.getSwitchedType=Q,e.getTypeNodeIfAccessible=X}(n||(n={}));var n;!function(e){function t(){function t(e,t,r){return i(a(e,t,r),e)}function a(t,i,a){function u(){switch(_){case 42:case 65:b[d]||13!==c.reScanSlashToken()||(_=13);break;case 28:73===d&&x++;break;case 30:x>0&&x--;break;case 121:case 139:case 136:case 124:case 140:x>0&&!a&&(_=73);break;case 15:p.push(_);break;case 18:p.length>0&&p.push(_);break;case 19:if(p.length>0){var t=e.lastOrUndefined(p);15===t?(_=c.reScanTemplateToken(),17===_?p.pop():e.Debug.assertEqual(_,16,"Should have been a template middle.")):(e.Debug.assertEqual(t,18,"Should have been an open brace"),p.pop())}break;default:if(!e.isKeyword(_))break;24===d?_=73:e.isKeyword(d)&&e.isKeyword(_)&&!o(d,_)&&(_=73)}}var _=0,d=0,p=[],f=s(i),m=f.prefix,g=f.pushTemplate;t=m+t;var v=m.length;g&&p.push(15),c.setText(t);var y=0,h=[],x=0;do{_=c.scan(),e.isTrivia(_)||(u(),d=_);var D=c.getTextPos();if(n(c.getTokenPos(),D,v,l(_),h),D>=t.length){var S=r(c,_,e.lastOrUndefined(p));void 0!==S&&(y=S)}}while(1!==_);return{endOfLineState:y,spans:h}}var c=e.createScanner(8,!1);return{getClassificationsForLine:t,getEncodedLexicalClassifications:a}}function r(t,r,n){switch(r){case 10:if(!t.isUnterminated())return void 0;for(var i=t.getTokenText(),a=i.length-1,o=0;92===i.charCodeAt(a-o);)o++;return 0===(1&o)?void 0:34===i.charCodeAt(0)?3:2;case 3:return t.isUnterminated()?1:void 0;default:if(e.isTemplateLiteralKind(r)){if(!t.isUnterminated())return void 0;switch(r){case 17:return 5;case 14:return 4;default:return e.Debug.fail("Only 'NoSubstitutionTemplateLiteral's and 'TemplateTail's can be unterminated; got SyntaxKind #"+r)}}return 15===n?6:void 0}}function n(e,t,r,n,i){if(8!==n){0===e&&r>0&&(e+=r);var a=t-e;a>0&&i.push(e-r,a,n)}}function i(t,r){for(var n=[],i=t.spans,o=0,s=0;s<i.length;s+=3){var c=i[s],u=i[s+1],l=i[s+2];if(o>=0){var _=c-o;_>0&&n.push({length:_,classification:e.TokenClass.Whitespace})}n.push({length:u,classification:a(l)}),o=c+u}var d=r.length-o;return d>0&&n.push({length:d,classification:e.TokenClass.Whitespace}),{entries:n,finalLexState:t.endOfLineState}}function a(t){switch(t){case 1:return e.TokenClass.Comment;case 3:return e.TokenClass.Keyword;case 4:return e.TokenClass.NumberLiteral;case 25:return e.TokenClass.BigIntLiteral;case 5:return e.TokenClass.Operator;case 6:return e.TokenClass.StringLiteral;case 8:return e.TokenClass.Whitespace;case 10:return e.TokenClass.Punctuation;case 2:case 11:case 12:case 13:case 14:case 15:case 16:case 9:case 17:return e.TokenClass.Identifier;default:return void 0}}function o(t,r){if(!e.isAccessibilityModifier(t))return!0;switch(r){case 127:case 138:case 125:case 117:return!0;default:return!1}}function s(t){switch(t){case 3:return{prefix:'"\\\n'};case 2:return{prefix:"'\\\n"};case 1:return{prefix:"/*\n"};case 4:return{prefix:"`\n"};case 5:return{prefix:"}\n",pushTemplate:!0};case 6:return{prefix:"",pushTemplate:!0};case 0:return{prefix:""};default:return e.Debug.assertNever(t)}}function c(e){switch(e){case 40:case 42:case 43:case 38:case 39:case 46:case 47:case 48:case 28:case 30:case 31:case 32:case 95:case 94:case 120:case 33:case 34:case 35:case 36:case 49:case 51:case 50:case 54:case 55:case 71:case 70:case 72:case 67:case 68:case 69:case 61:case 62:case 63:case 65:case 66:case 60:case 27:return!0;default:return!1}}function u(e){switch(e){case 38:case 39:case 53:case 52:case 44:case 45:return!0;default:return!1}}function l(t){if(e.isKeyword(t))return 3;if(c(t)||u(t))return 5;if(t>=18&&72>=t)return 10;switch(t){case 8:return 4;case 9:return 25;case 10:return 6;case 13:return 7;case 7:case 3:case 2:return 1;case 5:case 4:return 8;case 73:default:return e.isTemplateLiteralKind(t)?6:2}}function _(e,t,r,n,i){return v(p(e,t,r,n,i))}function d(e,t){switch(t){case 245:case 241:case 242:case 240:e.throwIfCancellationRequested()}}function p(t,r,n,i,a){function o(e,t,r){s.push(e),s.push(t-e),s.push(r)}var s=[];return n.forEachChild(function c(s){if(s&&e.textSpanIntersectsWith(a,s.pos,s.getFullWidth())){if(d(r,s.kind),e.isIdentifier(s)&&!e.nodeIsMissing(s)&&i.has(s.escapedText)){var u=t.getSymbolAtLocation(s),l=u&&f(u,e.getMeaningFromLocation(s),t);l&&o(s.getStart(n),s.getEnd(),l)}s.forEachChild(c)}}),{spans:s,endOfLineState:0}}function f(e,t,r){var n=e.getFlags();return 0===(2885600&n)?void 0:32&n?11:384&n?12:524288&n?16:1536&n?4&t||1&t&&m(e)?14:void 0:2097152&n?f(r.getAliasedSymbol(e),t,r):2&t?64&n?13:262144&n?15:void 0:void 0}function m(t){return e.some(t.declarations,function(t){return e.isModuleDeclaration(t)&&1===e.getModuleInstanceState(t)})}function g(e){switch(e){case 1:return"comment";case 2:return"identifier";case 3:return"keyword";case 4:return"number";case 25:return"bigint";case 5:return"operator";case 6:return"string";case 8:return"whitespace";case 9:return"text";case 10:return"punctuation";case 11:return"class name";case 12:return"enum name";case 13:return"interface name";case 14:return"module name";case 15:return"type parameter name";case 16:return"type alias name";case 17:return"parameter name";case 18:return"doc comment tag name";case 19:return"jsx open tag name";case 20:return"jsx close tag name";case 21:return"jsx self closing tag name";case 22:return"jsx attribute";case 23:return"jsx text";case 24:return"jsx attribute string literal value";default:return void 0}}function v(t){e.Debug.assert(t.spans.length%3===0);for(var r=t.spans,n=[],i=0;i<r.length;i+=3)n.push({textSpan:e.createTextSpan(r[i],r[i+1]),classificationType:g(r[i+2])});return n}function y(e,t,r){return v(h(e,t,r))}function h(t,r,n){function i(e,t,r){x.push(e),x.push(t),x.push(r)}function a(t){for(h.setTextPos(t.pos);;){var n=h.getTextPos();if(!e.couldStartTrivia(r.text,n))return n;var a=h.scan(),s=h.getTextPos(),c=s-n;if(!e.isTrivia(a))return n;switch(a){case 4:case 5:continue;case 2:case 3:o(t,a,n,c),h.setTextPos(s);continue;case 7:var u=r.text,_=u.charCodeAt(n);if(60===_||62===_){i(n,c,1);continue}e.Debug.assert(124===_||61===_),l(u,n,s);break;case 6:break;default:e.Debug.assertNever(a)}}}function o(t,n,i,a){if(3===n){var o=e.parseIsolatedJSDocComment(r.text,i,a);if(o&&o.jsDoc)return o.jsDoc.parent=t,void c(o.jsDoc)}s(i,a)}function s(e,t){i(e,t,1)}function c(e){function t(e){e.isNameFirst&&(s(r,e.name.pos-r),i(e.name.pos,e.name.end-e.name.pos,17),r=e.name.end),e.typeExpression&&(s(r,e.typeExpression.pos-r),g(e.typeExpression),r=e.typeExpression.end),e.isNameFirst||(s(r,e.name.pos-r),i(e.name.pos,e.name.end-e.name.pos,17),r=e.name.end)}var r=e.pos;if(e.tags)for(var n=0,a=e.tags;n<a.length;n++){var o=a[n];switch(o.pos!==r&&s(r,o.pos-r),i(o.pos,1,10),i(o.tagName.pos,o.tagName.end-o.tagName.pos,18),r=o.tagName.end,o.kind){case 305:t(o);break;case 309:u(o),r=o.end;break;case 308:g(o.typeExpression),r=o.end;break;case 306:g(o.typeExpression),r=o.end}}r!==e.end&&s(r,e.end-r)}function u(e){for(var t=0,r=e.getChildren();t<r.length;t++){var n=r[t];g(n)}}function l(t,r,n){var a;for(a=r;n>a&&!e.isLineBreak(t.charCodeAt(a));a++);for(i(r,a-r,1),b.setTextPos(a);b.getTextPos()<n;)_()}function _(){var e=b.getTextPos(),t=b.scan(),r=b.getTextPos(),n=m(t);n&&i(e,r-e,n)}function p(t){if(e.isJSDoc(t))return!0;if(e.nodeIsMissing(t))return!0;var r=f(t);if(!e.isToken(t)&&11!==t.kind&&void 0===r)return!1;var n=11===t.kind?t.pos:a(t),o=t.end-n;if(e.Debug.assert(o>=0),o>0){var s=r||m(t.kind,t);s&&i(n,o,s)}return!0}function f(e){switch(e.parent&&e.parent.kind){case 263:if(e.parent.tagName===e)return 19;break;case 264:if(e.parent.tagName===e)return 20;break;case 262:if(e.parent.tagName===e)return 21;break;case 268:if(e.parent.name===e)return 22}return void 0}function m(t,r){if(e.isKeyword(t))return 3;if((28===t||30===t)&&r&&e.getTypeArgumentOrTypeParameterList(r.parent))return 10;if(e.isPunctuation(t)){if(r){var n=r.parent;if(60===t&&(238===n.kind||155===n.kind||152===n.kind||268===n.kind))return 5;if(205===n.kind||203===n.kind||204===n.kind||206===n.kind)return 5}return 10}if(8===t)return 4;if(9===t)return 25;if(10===t)return 268===r.parent.kind?24:6;if(13===t)return 6;if(e.isTemplateLiteralKind(t))return 6;if(11===t)return 23;if(73===t){if(r)switch(r.parent.kind){case 241:if(r.parent.name===r)return 11;return;case 151:if(r.parent.name===r)return 15;return;case 242:if(r.parent.name===r)return 13;return;case 244:if(r.parent.name===r)return 12;return;case 245:if(r.parent.name===r)return 14;return;case 152:if(r.parent.name===r)return e.isThisIdentifier(r)?3:17;return}return 2}}function g(n){if(n&&e.decodedTextSpanIntersectsWith(v,y,n.pos,n.getFullWidth())){d(t,n.kind);for(var i=0,a=n.getChildren(r);i<a.length;i++){var o=a[i];p(o)||g(o)}}}var v=n.start,y=n.length,h=e.createScanner(8,!1,r.languageVariant,r.text),b=e.createScanner(8,!1,r.languageVariant,r.text),x=[];return g(r),{spans:x,endOfLineState:0}}e.createClassifier=t;var b=e.arrayToNumericMap([73,10,8,9,13,101,44,45,21,23,19,103,88],function(e){return e},function(){return!0});e.getSemanticClassifications=_,e.getEncodedSemanticClassifications=p,e.getSyntacticClassifications=y,e.getEncodedSyntacticClassifications=h}(n||(n={}));var n;!function(e){var t;!function(t){var r;!function(r){function n(t,r,n,a,o,c,l,_){if(e.isInReferenceComment(t,r)){var d=I(t,r,o,c);return d&&s(d)}return e.isInString(t,r,n)&&n&&e.isStringLiteralLike(n)?i(u(t,n,r,a,o,c),t,a,l,_):void 0}function i(r,n,i,a,o){if(void 0===r)return void 0;switch(r.kind){case 0:return s(r.paths);case 1:var c=[];return t.getCompletionEntriesFromSymbols(r.symbols,c,n,n,i,8,a,4,o),{isGlobalCompletion:!1,isMemberCompletion:!0,isNewIdentifierLocation:r.hasIndexSignature,entries:c};case 2:var c=r.types.map(function(e){return{name:e.value,kindModifiers:"",kind:"string",sortText:"0"}});return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:r.isNewIdentifier,entries:c};default:return e.Debug.assertNever(r)}}function a(t,r,n,i,a,s,c,l){if(!i||!e.isStringLiteralLike(i))return void 0;var _=u(r,i,n,a,s,c);return _&&o(t,i,_,r,a,l)}function o(r,n,i,a,o,s){switch(i.kind){case 0:var u=e.find(i.paths,function(e){return e.name===r});return u&&t.createCompletionDetails(r,c(u.extension),u.kind,[e.textPart(r)]);case 1:var u=e.find(i.symbols,function(e){return e.name===r});return u&&t.createCompletionDetailsForSymbol(u,o,a,n,s);case 2:return e.find(i.types,function(e){return e.value===r})?t.createCompletionDetails(r,"","type",[e.textPart(r)]):void 0;default:return e.Debug.assertNever(i)}}function s(e){var r=!1,n=!0,i=e.map(function(e){var r=e.name,n=e.kind,i=e.span,a=e.extension;return{name:r,kind:n,kindModifiers:c(a),sortText:t.SortText.LocationPriority,replacementSpan:i}});return{isGlobalCompletion:r,isMemberCompletion:!1,isNewIdentifierLocation:n,entries:i}}function c(t){switch(t){case".d.ts":return".d.ts";case".js":return".js";case".json":return".json";case".jsx":return".jsx";case".ts":return".ts";case".tsx":return".tsx";case".tsbuildinfo":return e.Debug.fail("Extension .tsbuildinfo is unsupported.");case void 0:return"";default:return e.Debug.assertNever(t)}}function u(t,r,n,i,a,o){function s(){return{kind:2,types:p(e.getContextualTypeFromParent(r,i)),isNewIdentifier:!1}}var c=r.parent;switch(c.kind){case 183:switch(c.parent.kind){case 165:return{kind:2,types:p(i.getTypeArgumentConstraint(c)),isNewIdentifier:!1};case 181:return d(i.getTypeFromTypeNode(c.parent.objectType));case 184:return{kind:0,paths:v(t,r,a,o,i)};case 174:if(!e.isTypeReferenceNode(c.parent.parent))return void 0;var u=l(c.parent,c),f=p(i.getTypeArgumentConstraint(c.parent)).filter(function(t){return!e.contains(u,t.value)});return{kind:2,types:f,isNewIdentifier:!1};default:return void 0}case 276:return e.isObjectLiteralExpression(c.parent)&&c.name===r?d(i.getContextualType(c.parent)):s();case 191:var m=c,g=m.expression,y=m.argumentExpression;return r===y?d(i.getTypeAtLocation(g)):void 0;case 192:case 193:if(!e.isRequireCall(c,!1)&&!e.isImportCall(c)){var h=e.SignatureHelp.getArgumentInfoForCompletions(r,n,t);return h?_(h,i):s()}case 250:case 256:case 260:return{kind:0,paths:v(t,r,a,o,i)};default:return s()}}function l(t,r){return e.mapDefined(t.types,function(t){return t!==r&&e.isLiteralTypeNode(t)&&e.isStringLiteral(t.literal)?t.literal.text:void 0})}function _(t,r){var n=!1,i=e.createMap(),a=[];r.getResolvedSignature(t.invocation,a,t.argumentCount);var o=e.flatMap(a,function(e){if(e.hasRestParameter||!(t.argumentCount>e.parameters.length)){var a=r.getParameterType(e,t.argumentIndex);return n=n||!!(4&a.flags),p(a,i)}});return{kind:2,types:o,isNewIdentifier:n}}function d(t){return t&&{kind:1,symbols:t.getApparentProperties(),hasIndexSignature:e.hasIndexSignature(t)}}function p(t,r){return void 0===r&&(r=e.createMap()),t?(t=e.skipConstraint(t),t.isUnion()?e.flatMap(t.types,function(e){return p(e,r)}):!t.isStringLiteral()||1024&t.flags||!e.addToSeen(r,t.value)?e.emptyArray:[t]):e.emptyArray}function f(e,t,r){return{name:e,kind:t,extension:r}}function m(e){return f(e,"directory",void 0)}function g(e,t,r){var n=B(e,t);return r.map(function(e){var t=e.name,r=e.kind,i=e.extension;return{name:t,kind:r,extension:i,span:n}})}function v(e,t,r,n,i){return g(t.text,t.getStart(e)+1,y(e,t,r,n,i))}function y(t,r,n,i,a){var o=e.normalizeSlashes(r.text),s=t.path,c=e.getDirectoryPath(s);return j(o)||!n.baseUrl&&(e.isRootedDiskPath(o)||e.isUrl(o))?b(o,c,n,i,s):T(o,c,n,i,a)}function h(e,t){return void 0===t&&(t=!1),{extensions:x(e),includeExtensions:t}}function b(e,t,r,n,i){var a=h(r);return r.rootDirs?S(r.rootDirs,e,t,a,r,n,i):C(e,t,a,n,i)}function x(t){var r=e.getSupportedExtensions(t);return t.resolveJsonModule&&e.getEmitModuleResolutionKind(t)===e.ModuleResolutionKind.NodeJs?r.concat(".json"):r}function D(t,r,n,i){t=t.map(function(t){return e.normalizePath(e.isRootedDiskPath(t)?t:e.combinePaths(r,t))});var a=e.firstDefined(t,function(t){return e.containsPath(t,n,r,i)?n.substr(t.length):void 0});return e.deduplicate(t.map(function(t){return e.combinePaths(t,a)}).concat([n]),e.equateStringsCaseSensitive,e.compareStringsCaseSensitive)}function S(t,r,n,i,a,o,s){var c=a.project||o.getCurrentDirectory(),u=!(o.useCaseSensitiveFileNames&&o.useCaseSensitiveFileNames()),l=D(t,c,n,u);return e.flatMap(l,function(e){return C(r,e,i,o,s)})}function C(t,r,n,i,a,o){var s=n.extensions,c=n.includeExtensions;void 0===o&&(o=[]),void 0===t&&(t=""),t=e.normalizeSlashes(t),e.hasTrailingDirectorySeparator(t)||(t=e.getDirectoryPath(t)),""===t&&(t="."+e.directorySeparator),t=e.ensureTrailingDirectorySeparator(t);var u=e.resolvePath(r,t),l=e.hasTrailingDirectorySeparator(u)?u:e.getDirectoryPath(u),_=!(i.useCaseSensitiveFileNames&&i.useCaseSensitiveFileNames());if(!U(i,l))return o;var d=z(i,l,s,void 0,["./*"]);if(d){for(var p=e.createMap(),g=0,v=d;g<v.length;g++){var y=v[g];if(y=e.normalizePath(y),!a||0!==e.comparePaths(y,a,r,_)){var h=c||e.fileExtensionIs(y,".json")?e.getBaseFileName(y):e.removeFileExtension(e.getBaseFileName(y));p.set(h,e.tryGetExtensionFromPath(y))}}p.forEach(function(e,t){o.push(f(t,"script",e))})}var b=J(i,l);if(b)for(var x=0,D=b;x<D.length;x++){var S=D[x],C=e.getBaseFileName(e.normalizePath(S));"@types"!==C&&o.push(m(C))}var T=L(l,i);if(T){var E=e.readJson(T,i),N=E.typesVersions;if("object"==typeof N){var A=e.getPackageJsonTypesVersionsPaths(N),F=A&&A.paths,P=u.slice(e.ensureTrailingDirectorySeparator(l).length);F&&k(o,P,l,s,F,i)}}return o}function k(t,r,n,i,a,o){for(var s in a)if(e.hasProperty(a,s)){var c=a[s];if(c)for(var u=function(e,r,n){t.some(function(t){return t.name===e})||t.push(f(e,r,n))},l=0,_=N(s,c,r,n,i,o);l<_.length;l++){var d=_[l],p=d.name,m=d.kind,g=d.extension;u(p,m,g)}}}function T(t,r,n,i,a){var o=n.baseUrl,s=n.paths,c=[],u=h(n);if(o){var l=n.project||i.getCurrentDirectory(),_=e.normalizePath(e.combinePaths(l,o));C(t,_,u,i,void 0,c),s&&k(c,t,_,u.extensions,s,i)}for(var d=E(t),p=0,m=w(t,d,a);p<m.length;p++){var g=m[p];c.push(f(g,"external module name",void 0))}if(O(i,n,r,d,u,c),e.getEmitModuleResolutionKind(n)===e.ModuleResolutionKind.NodeJs){var v=!1;if(void 0===d)for(var y=function(e){c.some(function(t){return t.name===e})||(v=!0,c.push(f(e,"external module name",void 0)))},b=0,x=R(i,r);b<x.length;b++){var D=x[b];y(D)}v||e.forEachAncestorDirectory(r,function(r){var n=e.combinePaths(r,"node_modules");U(i,n)&&C(t,n,u,i,void 0,c)})}return c}function E(t){return W(t)?e.hasTrailingDirectorySeparator(t)?t:e.getDirectoryPath(t):void 0}function N(t,r,n,i,a,o){function s(t){return e.startsWith(t,n)?[m(t)]:e.emptyArray}if(!e.endsWith(t,"*"))return e.stringContains(t,"*")?e.emptyArray:s(t);var c=t.slice(0,t.length-1),u=e.tryRemovePrefix(n,c);return void 0===u?s(c):e.flatMap(r,function(e){return A(u,i,e,a,o)})}function A(t,r,n,i,a){function o(t){var r=F(e.normalizePath(t),y,g);return void 0===r?void 0:P(r)}if(!a.readDirectory)return void 0;var s=e.hasZeroOrOneAsteriskCharacter(n)?e.tryParsePattern(n):void 0;if(!s)return void 0;var c=e.resolvePath(s.prefix),u=e.hasTrailingDirectorySeparator(s.prefix)?c:e.getDirectoryPath(c),l=e.hasTrailingDirectorySeparator(s.prefix)?"":e.getBaseFileName(c),_=W(t),d=_?e.hasTrailingDirectorySeparator(t)?t:e.getDirectoryPath(t):void 0,p=_?e.combinePaths(u,l+d):u,g=e.normalizePath(s.suffix),v=e.normalizePath(e.combinePaths(r,p)),y=_?v:e.ensureTrailingDirectorySeparator(v)+l,h=g?"**/*":"./*",b=e.mapDefined(z(a,v,i,void 0,[h]),function(t){var r=e.tryGetExtensionFromPath(t),n=o(t);return void 0===n?void 0:f(e.removeFileExtension(n),"script",r)}),x=e.mapDefined(J(a,v).map(function(t){return e.combinePaths(v,t)}),function(e){var t=o(e);return void 0===t?void 0:m(t)});return b.concat(x)}function F(t,r,n){return e.startsWith(t,r)&&e.endsWith(t,n)?t.slice(r.length,t.length-n.length):void 0}function P(t){return t[0]===e.directorySeparator?t.slice(1):t}function w(t,r,n){var i=n.getAmbientModules().map(function(t){return e.stripQuotes(t.name)}),a=i.filter(function(r){return e.startsWith(r,t)});if(void 0!==r){var o=e.ensureTrailingDirectorySeparator(r);return a.map(function(t){return e.removePrefix(t,o)})}return a}function I(t,r,n,i){var a=e.getTokenAtPosition(t,r),o=e.getLeadingCommentRanges(t.text,a.pos),s=o&&e.find(o,function(e){return r>=e.pos&&r<=e.end});if(!s)return void 0;var c=t.text.slice(s.pos,r),u=G.exec(c);if(!u)return void 0;var l=u[1],_=u[2],d=u[3],p=e.getDirectoryPath(t.path),f="path"===_?C(d,p,h(n,!0),i,t.path):"types"===_?O(i,n,p,E(d),h(n)):e.Debug.fail();return g(d,s.pos+l.length,f)}function O(t,r,n,i,a,o){function s(n){if(U(t,n))for(var s=0,u=J(t,n);s<u.length;s++){var l=u[s],_=e.unmangleScopedPackageName(l);if(!r.types||e.contains(r.types,_))if(void 0===i)c.has(_)||(o.push(f(_,"external module name",void 0)),c.set(_,!0));else{var d=e.combinePaths(n,l),p=e.tryRemoveDirectoryPrefix(i,_,e.hostGetCanonicalFileName(t));void 0!==p&&C(p,d,a,t,void 0,o)}}}void 0===o&&(o=[]);for(var c=e.createMap(),u=q(function(){return e.getEffectiveTypeRoots(r,t)})||e.emptyArray,l=0,_=u;l<_.length;l++){var d=_[l];s(d)}for(var p=0,m=M(n,t);p<m.length;p++){var g=m[p],v=e.combinePaths(e.getDirectoryPath(g),"node_modules/@types");s(v)}return o}function M(t,r){var n=[];return e.forEachAncestorDirectory(t,function(t){var i=e.findConfigFile(t,function(e){return V(r,e)},"package.json");return i?void n.push(i):!0}),n}function L(t,r){var n;return e.forEachAncestorDirectory(t,function(t){return"node_modules"===t?!0:(n=e.findConfigFile(t,function(e){return V(r,e)},"package.json"),n?!0:void 0)}),n}function R(t,r){if(!t.readFile||!t.fileExists)return e.emptyArray;for(var n=[],i=0,a=M(r,t);i<a.length;i++)for(var o=a[i],s=e.readJson(o,t),c=0,u=Q;c<u.length;c++){var l=u[c],_=s[l];if(_)for(var d in _)_.hasOwnProperty(d)&&!e.startsWith(d,"@types/")&&n.push(d)}return n}function B(t,r){var n=Math.max(t.lastIndexOf(e.directorySeparator),t.lastIndexOf("\\")),i=-1!==n?n+1:0,a=t.length-i;return 0===a||e.isIdentifierText(t.substr(i,a),8)?void 0:e.createTextSpan(r+i,a)}function j(e){if(e&&e.length>=2&&46===e.charCodeAt(0)){var t=e.length>=3&&46===e.charCodeAt(1)?2:1,r=e.charCodeAt(t);return 47===r||92===r}return!1}function J(e,t){return K(e,e.getDirectories,t)||[]}function z(t,r,n,i,a){return K(t,t.readDirectory,r,n,i,a)||e.emptyArray}function V(e,t){return K(e,e.fileExists,t)}function U(t,r){return q(function(){return e.directoryProbablyExists(r,t)})||!1}function K(e,t){for(var r=[],n=2;n<arguments.length;n++)r[n-2]=arguments[n];return q(function(){return t&&t.apply(e,r)})}function q(e){try{return e()}catch(t){return void 0}}function W(t){return e.stringContains(t,e.directorySeparator)}r.getStringLiteralCompletions=n,r.getStringLiteralCompletionDetails=a;var H;!function(e){e[e.Paths=0]="Paths",e[e.Properties=1]="Properties",e[e.Types=2]="Types"}(H||(H={}));var G=/^(\/\/\/\s*<reference\s+(path|types)\s*=\s*(?:'|"))([^\3"]*)$/,Q=["dependencies","devDependencies","peerDependencies","optionalDependencies"]}(r=t.StringCompletions||(t.StringCompletions={}))}(t=e.Completions||(e.Completions={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(e){return 2===e.kind||1===e.kind}function n(e){return 2===e.kind||3===e.kind}function i(r,n,i,c,u,l,_){var d=n.getTypeChecker(),p=n.getCompilerOptions(),f=e.findPrecedingToken(u,c);if(_&&!e.isInString(c,u,f)&&!K(c,_,f,u))return void 0;var m=t.StringCompletions.getStringLiteralCompletions(c,u,f,d,p,r,i,l);if(m)return m;if(f&&e.isBreakOrContinueStatement(f.parent)&&(74===f.kind||79===f.kind||73===f.kind))return g(f.parent);var v=F(n,i,c,s(c,p),u,l,void 0);if(!v)return void 0;switch(v.kind){case 0:return o(c,d,p,i,v,l);case 1:return a(e.JsDoc.getJSDocTagNameCompletions());case 2:return a(e.JsDoc.getJSDocTagCompletions());case 3:return a(e.JsDoc.getJSDocParameterNameCompletions(v.tag));default:return e.Debug.assertNever(v)}}function a(e){return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:!1,entries:e}}function o(t,r,n,i,a,o){var _=a.symbols,d=a.completionKind,p=a.isInSnippetScope,f=a.isNewIdentifierLocation,g=a.location,v=a.propertyAccessToConvert,y=a.keywordFilters,h=a.literals,b=a.symbolToOriginInfoMap,x=a.recommendedCompletion,D=a.isJsxInitializer,S=a.insideJsDocTagTypeExpression,C=a.symbolToSortTextMap;if(g&&g.parent&&e.isJsxClosingElement(g.parent)){var k=g.parent.parent.openingElement.tagName,T=!!e.findChildOfKind(g.parent,30,t),E={name:k.getFullText(t)+(T?"":">"),kind:"class",kindModifiers:void 0,sortText:W.LocationPriority};return{isGlobalCompletion:!1,isMemberCompletion:!0,isNewIdentifierLocation:!1,entries:[E]}}var N=[];if(s(t,n)){var A=m(_,N,g,t,r,n.target,i,d,o,v,D,x,b,C);u(t,g.pos,A,n.target,N)}else{if(!(f||_&&0!==_.length||0!==y))return void 0;m(_,N,g,t,r,n.target,i,d,o,v,D,x,b,C)}if(0!==y)for(var F=e.arrayToSet(N,function(e){return e.name}),P=0,I=w(y,!S&&e.isSourceFileJS(t));P<I.length;P++){var O=I[P];F.has(O.name)||N.push(O)}for(var M=0,L=h;M<L.length;M++){var R=L[M];N.push(l(R))}return{isGlobalCompletion:p,isMemberCompletion:c(d),isNewIdentifierLocation:f,entries:N}}function s(t,r){return e.isSourceFileJS(t)&&!e.isCheckJsEnabledForFile(t,r)}function c(e){switch(e){case 0:case 3:case 2:return!0;default:return!1}}function u(t,r,n,i,a){e.getNameTable(t).forEach(function(t,o){if(t!==r){var s=e.unescapeLeadingUnderscores(o);e.addToSeen(n,s)&&e.isIdentifierText(s,i)&&a.push({name:s,kind:"warning",kindModifiers:"",sortText:W.JavascriptIdentifiers})}})}function l(e){return{name:X(e),kind:"string",kindModifiers:"",sortText:W.LocationPriority}}function _(t,i,a,o,s,c,u,l,_,m,g,v){var y,h;if(l&&0===l.kind)y=u?"this["+e.quote(c,v)+"]":"this."+c;else if((l&&r(l)||u)&&m){y=u?"["+e.quote(c,v)+"]":"["+c+"]";var b=e.findChildOfKind(m,24,o),x=e.startsWith(c,m.name.text)?m.name.end:b.end;h=e.createTextSpanFromBounds(b.getStart(o),x)}return g&&(void 0===y&&(y=c),y="{"+y+"}","boolean"!=typeof g&&(h=e.createTextSpanFromNode(g,o))),void 0===y||v.includeCompletionsWithInsertText?{name:c,kind:e.SymbolDisplay.getSymbolKind(s,t,a),kindModifiers:e.SymbolDisplay.getSymbolModifiers(t),sortText:i,source:f(l),hasAction:p(!!l&&n(l)),isRecommended:p(d(t,_,s)),insertText:y,replacementSpan:h}:void 0}function d(e,t,r){return e===t||!!(1048576&e.flags)&&r.getExportSymbolOfSymbol(e)===t}function p(e){return e?!0:void 0}function f(t){return t&&n(t)?e.stripQuotes(t.moduleSymbol.name):void 0}function m(t,r,n,i,a,o,s,c,u,l,d,p,f,m){for(var g=e.timestamp(),v=e.createMap(),y=0,h=t;y<h.length;y++){var b=h[y],x=f?f[e.getSymbolId(b)]:void 0,D=P(b,o,x,c);if(D){var S=D.name,C=D.needsConvertPropertyAccess;if(!v.has(S)){var k=_(b,m&&m[e.getSymbolId(b)]||W.LocationPriority,n,i,a,S,C,x,p,l,d,u);k&&(x||void 0===b.parent&&!e.some(b.declarations,function(e){return e.getSourceFile()===n.getSourceFile()})||v.set(S,!0),r.push(k))}}}return s("getCompletionsAtPosition: getCompletionEntriesFromSymbols: "+(e.timestamp()-g)),v}function g(e){var t=v(e);return t.length?{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:!1,entries:t}:void 0}function v(t){for(var r=[],n=e.createMap(),i=t;i&&!e.isFunctionLike(i);){if(e.isLabeledStatement(i)){var a=i.label.text;n.has(a)||(n.set(a,!0),r.push({name:a,kindModifiers:"",kind:"label",sortText:W.LocationPriority}))}i=i.parent}return r}function y(t,r,n,i,a){var o=t.getCompilerOptions(),c=F(t,r,n,s(n,o),i,{includeCompletionsForModuleExports:!0,includeCompletionsWithInsertText:!0},a);if(!c)return{type:"none"};if(0!==c.kind)return{type:"request",request:c};var u=c.symbols,l=c.literals,_=c.location,d=c.completionKind,p=c.symbolToOriginInfoMap,m=c.previousToken,g=c.isJsxInitializer,v=e.find(l,function(e){return X(e)===a.name});return void 0!==v?{type:"literal",literal:v}:e.firstDefined(u,function(t){var r=p[e.getSymbolId(t)],n=P(t,o.target,r,d);
return n&&n.name===a.name&&f(r)===a.source?{type:"symbol",symbol:t,location:_,symbolToOriginInfoMap:p,previousToken:m,isJsxInitializer:g}:void 0})||{type:"none"}}function h(t,r,i){return r&&n(r)&&(r.isDefaultExport&&"default"===t.escapedName||"export="===t.escapedName)?e.firstDefined(t.declarations,function(t){return e.isExportAssignment(t)&&e.isIdentifier(t.expression)?t.expression.text:void 0})||e.codefix.moduleSymbolToValidIdentifier(r.moduleSymbol,i):t.name}function b(r,n,i,a,o,s,c,u,l){var _=r.getTypeChecker(),d=r.getCompilerOptions(),p=o.name,f=e.findPrecedingToken(a,i);if(e.isInString(i,a,f))return t.StringCompletions.getStringLiteralCompletionDetails(p,i,a,f,_,d,s,l);var m=y(r,n,i,a,o);switch(m.type){case"request":var g=m.request;switch(g.kind){case 1:return e.JsDoc.getJSDocTagNameCompletionDetails(p);case 2:return e.JsDoc.getJSDocTagCompletionDetails(p);case 3:return e.JsDoc.getJSDocParameterNameCompletionDetails(p);default:return e.Debug.assertNever(g)}case"symbol":var v=m.symbol,h=m.location,b=m.symbolToOriginInfoMap,S=m.previousToken,k=C(b,v,r,_,s,d,i,a,S,c,u),T=k.codeActions,E=k.sourceDisplay;return D(v,_,i,h,l,T,E);case"literal":var N=m.literal;return x(X(N),"string","string"==typeof N?e.SymbolDisplayPartKind.stringLiteral:e.SymbolDisplayPartKind.numericLiteral);case"none":return et().some(function(e){return e.name===p})?x(p,"keyword",e.SymbolDisplayPartKind.keyword):void 0;default:e.Debug.assertNever(m)}}function x(t,r,n){return S(t,"",r,[e.displayPart(t,n)])}function D(t,r,n,i,a,o,s){var c=r.runWithCancellationToken(a,function(r){return e.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(r,t,n,i,i,7)}),u=c.displayParts,l=c.documentation,_=c.symbolKind,d=c.tags;return S(t.name,e.SymbolDisplay.getSymbolModifiers(t),_,u,l,d,o,s)}function S(e,t,r,n,i,a,o,s){return{name:e,kindModifiers:t,kind:r,displayParts:n,documentation:i,tags:a,codeActions:o,source:s}}function C(t,r,i,a,o,s,c,u,l,_,d){var p=t[e.getSymbolId(r)];if(!p||!n(p))return{codeActions:void 0,sourceDisplay:void 0};var f=p.moduleSymbol,m=a.getMergedSymbol(e.skipAlias(r.exportSymbol||r,a)),g=e.codefix.getImportCompletionAction(m,f,c,h(r,p,s.target),o,i,_,l&&e.isIdentifier(l)?l.getStart(c):u,d),v=g.moduleSpecifier,y=g.codeAction;return{sourceDisplay:[e.textPart(v)],codeActions:[y]}}function k(e,t,r,n,i){var a=y(e,t,r,n,i);return"symbol"===a.type?a.symbol:void 0}function T(t,r,n){return e.firstDefined(r&&(r.isUnion()?r.types:[r]),function(r){var i=r&&r.symbol;return i&&424&i.flags&&!e.isAbstractConstructorSymbol(i)?N(i,t,n):void 0})}function E(t,r,n,i){var a=t.parent;switch(t.kind){case 73:return e.getContextualTypeFromParent(t,i);case 60:switch(a.kind){case 238:return i.getContextualType(a.initializer);case 205:return i.getTypeAtLocation(a.left);case 268:return i.getContextualTypeForJsxAttribute(a);default:return void 0}case 96:return i.getContextualType(a);case 75:return e.getSwitchedType(e.cast(a,e.isCaseClause),i);case 18:return e.isJsxExpression(a)&&261!==a.parent.kind?i.getContextualTypeForJsxAttribute(a.parent):void 0;default:var o=e.SignatureHelp.getArgumentInfoForCompletions(t,r,n);return o?i.getContextualTypeForArgumentAtIndex(o.invocation,o.argumentIndex+(27===t.kind?1:0)):e.isEqualityOperatorKind(t.kind)&&e.isBinaryExpression(a)&&e.isEqualityOperatorKind(a.operatorToken.kind)?i.getTypeAtLocation(a.left):i.getContextualType(t)}}function N(t,r,n){var i=n.getAccessibleSymbolChain(t,r,67108863,!1);return i?e.first(i):t.parent&&(A(t.parent)?t:N(t.parent,r,n))}function A(e){return e.declarations.some(function(e){return 285===e.kind})}function F(t,r,n,i,a,o,s){function c(e){switch(e.kind){case 305:case 311:case 306:case 308:case 310:return!0;default:return!1}}function u(){kt=2;var t=e.isLiteralImportTypeNode(vt),r=ut||t&&!vt.isTypeOf||e.isPartOfTypeNode(vt.parent),i=e.isInRightSideOfInternalImportEqualsDeclaration(vt),a=i||!r&&e.isPossiblyTypeArgumentPosition(ft,n,at);if(e.isEntityName(vt)||t){var o=e.isModuleDeclaration(vt.parent);o&&(Tt=!0);var s=at.getSymbolAtLocation(vt);if(s&&(s=e.skipAlias(s,at),1920&s.flags)){for(var c=e.Debug.assertEachDefined(at.getExportsOfModule(s),"getExportsOfModule() should all be defined"),u=function(e){return at.isValidPropertyAccess(t?vt:vt.parent,e.name)},_=function(e){return C(e)},d=o?function(e){return!!(1920&e.flags)&&!e.declarations.every(function(e){return e.parent===vt.parent})}:a?function(e){return _(e)||u(e)}:r?_:u,p=0,f=c;p<f.length;p++){var m=f[p];d(m)&&Nt.push(m)}return void(!r&&s.declarations&&s.declarations.some(function(e){return 285!==e.kind&&245!==e.kind&&244!==e.kind})&&l(at.getTypeOfSymbolAtLocation(s,vt)))}}if(e.isMetaProperty(vt)&&(96===vt.keywordToken||93===vt.keywordToken)){var g=96===vt.keywordToken?"target":"meta";return void Nt.push(at.createSymbol(4,e.escapeLeadingUnderscores(g)))}r||l(at.getTypeAtLocation(vt))}function l(e){if(Tt=!!e.getStringIndexType(),i)Nt.push.apply(Nt,z(e,at));else for(var t=0,r=e.getApparentProperties();t<r.length;t++){var n=r[t];at.isValidPropertyAccessForCompletions(184===vt.kind?vt:vt.parent,e,n)&&_(n)}}function _(t){var r=e.firstDefined(t.declarations,function(t){return e.tryCast(e.getNameOfDeclaration(t),e.isComputedPropertyName)});if(r){var n=d(r.expression),i=n&&at.getSymbolAtLocation(n),a=i&&N(i,ft,at);if(a&&!At[e.getSymbolId(a)]){Nt.push(a);var o=a.parent;At[e.getSymbolId(a)]=o&&e.isExternalModuleSymbol(o)?{kind:2,moduleSymbol:o,isDefaultExport:!1}:{kind:1}}}else Nt.push(t)}function d(t){return e.isIdentifier(t)?t:e.isPropertyAccessExpression(t)?d(t.expression):void 0}function p(){var e=M()||R()||f()||K()||m()||(g(),1);return 1===e}function f(){return Q(ft)?(kt=5,Tt=!0,Et=4,1):0}function m(){var e=Y(ft),t=e&&at.getContextualType(e.attributes);return t?(Nt=nt(J(t,e.attributes,at),e.attributes.properties),kt=3,Tt=!1,1):0}function g(){Et=X(ft)?5:1,kt=1,Tt=I(ft),pt!==ft&&e.Debug.assert(!!pt,"Expected 'contextToken' to be defined when different from 'previousToken'.");var r=pt!==ft?pt.getStart():a,i=F(ft,r,n)||n;lt=y(i);var s=x(),c=67897832|(s?0:67220415)|1920|2097152;Nt=e.Debug.assertEachDefined(at.getSymbolsInScope(i,c),"getSymbolsInScope() should all be defined");for(var u=0,l=Nt;u<l.length;u++){var _=l[u];at.isArgumentsSymbol(_)||e.some(_.declarations,function(e){return e.getSourceFile()===n})||(Ft[e.getSymbolId(_)]=W.GlobalsOrKeywords)}if(o.includeCompletionsWithInsertText&&285!==i.kind){var d=at.tryGetThisTypeAt(i,!1);if(d)for(var p=0,f=z(d,at);p<f.length;p++){var _=f[p];At[e.getSymbolId(_)]={kind:0},Nt.push(_),Ft[e.getSymbolId(_)]=W.SuggestedClassMembers}}v()&&k(Nt,pt&&e.isIdentifier(pt)?pt.text:"",t.getCompilerOptions().target),b(Nt)}function v(){return o.includeCompletionsForModuleExports?n.externalModuleIndicator?!0:n.commonJsModuleIndicator?!1:e.compilerOptionsIndicateEs6Modules(t.getCompilerOptions())?!0:e.programContainsEs6Modules(t):!1}function y(t){switch(t.kind){case 285:case 207:case 271:case 219:return!0;default:return e.isStatement(t)}}function b(t){var r=x(),i=r||!D(ft)&&e.isPossiblyTypeArgumentPosition(ft,n,at);r&&(Et=6),e.filterMutate(t,function(t){if(!e.isSourceFile(Dt)){if(e.isExportAssignment(Dt.parent))return!0;if(t=e.skipAlias(t,at),e.isInRightSideOfInternalImportEqualsDeclaration(Dt))return!!(1920&t.flags);if(i){var n=C(t);if(n||r)return n}}return!!(67220415&e.getCombinedLocalAndExportSymbolFlags(t))})}function x(){return ut||!D(ft)&&(e.isPartOfTypeNode(Dt)||S(ft))}function D(t){return t&&105===t.kind&&(168===t.parent.kind||e.isTypeOfExpression(t.parent))}function S(t){if(t){var r=t.parent.kind;switch(t.kind){case 57:return 155===r||154===r||152===r||238===r||e.isFunctionLikeKind(r);case 60:return 243===r;case 120:return 213===r;case 87:return 151===r}}return!1}function C(t,r){void 0===r&&(r=e.createMap());var n=e.skipAlias(t.exportSymbol||t,at);return!!(67897832&n.flags)||!!(1536&n.flags)&&e.addToSeen(r,e.getSymbolId(n))&&at.getExportsOfModule(n).some(function(e){return C(e,r)})}function k(r,i,a){var o=i.toLowerCase(),c=e.createMap();e.codefix.forEachExternalModuleToImportFrom(at,n,t.getSourceFiles(),function(t){if(!s||!s.source||e.stripQuotes(t.name)===s.source){var n=at.resolveExternalModuleSymbol(t);if(e.addToSeen(c,e.getSymbolId(n))){n!==t&&e.some(n.declarations,function(e){return!!e.getSourceFile().externalModuleIndicator})&&(r.push(n),Ft[e.getSymbolId(n)]=W.AutoImportSuggestions,At[e.getSymbolId(n)]={kind:3,moduleSymbol:t,isDefaultExport:!1});for(var i=0,u=at.getExportsOfModule(t);i<u.length;i++){var l=u[i];if(at.getMergedSymbol(l.parent)===n&&!e.some(l.declarations,function(t){return e.isExportSpecifier(t)&&(t.propertyName?e.isIdentifierANonContextualKeyword(t.name):!!t.parent.parent.moduleSpecifier)})){var _="default"===l.escapedName;_&&(l=e.getLocalSymbolForExportDefault(l)||l);var d={kind:3,moduleSymbol:t,isDefaultExport:_};(s||A(h(l,d,a).toLowerCase(),o))&&(r.push(l),Ft[e.getSymbolId(l)]=W.AutoImportSuggestions,At[e.getSymbolId(l)]=d)}}}}})}function A(e,t){if(0===t.length)return!0;for(var r=0,n=0;n<e.length;n++)if(e.charCodeAt(n)===t.charCodeAt(r)&&(r++,r===t.length))return!0;return!1}function F(t,r,n){for(var i=t;i&&!e.positionBelongsToNode(i,r,n);)i=i.parent;return i}function P(t){var n=e.timestamp(),i=O(t)||Z(t)||et(t)||w(t);return r("getCompletionsAtPosition: isCompletionListBlocker: "+(e.timestamp()-n)),i}function w(e){if(11===e.kind)return!0;if(30===e.kind&&e.parent){if(263===e.parent.kind)return!0;if(264===e.parent.kind||262===e.parent.kind)return!!e.parent.parent&&261===e.parent.parent.kind}return!1}function I(e){if(e){var t=e.parent.kind;switch(B(e)){case 27:return 192===t||158===t||193===t||188===t||205===t||166===t;case 20:return 192===t||158===t||193===t||196===t||178===t;case 22:return 188===t||163===t||150===t;case 131:case 132:return!0;case 24:return 245===t;case 18:return 241===t;case 60:return 238===t||205===t;case 15:return 207===t;case 16:return 217===t;case 116:case 114:case 115:return 155===t}}return!1}function O(t){return(e.isRegularExpressionLiteral(t)||e.isStringTextContainingNode(t))&&(e.rangeContainsPositionExclusive(e.createTextRangeFromSpan(e.createTextSpanFromNode(t)),a)||a===t.end&&(!!t.isUnterminated||e.isRegularExpressionLiteral(t)))}function M(){var t=H(ft);if(!t)return 0;kt=0;var r,n;if(189===t.kind){var i=at.getContextualType(t);if(!i)return 2;Tt=e.hasIndexSignature(i),r=J(i,t,at),n=t.properties}else{e.Debug.assert(185===t.kind),Tt=!1;var a=e.getRootDeclaration(t.parent);if(!e.isVariableLike(a))return e.Debug.fail("Root declaration is not variable-like.");var o=e.hasInitializer(a)||e.hasType(a)||228===a.parent.parent.kind;if(o||152!==a.kind||(e.isExpression(a.parent)?o=!!at.getContextualType(a.parent):(157===a.parent.kind||160===a.parent.kind)&&(o=e.isExpression(a.parent.parent)&&!!at.getContextualType(a.parent.parent))),o){var i=at.getTypeAtLocation(t);if(!i)return 2;r=at.getPropertiesOfType(i).filter(function(t){return!(24&e.getDeclarationModifierFlagsFromSymbol(t))}),n=t.elements}}return r&&r.length>0&&(Nt=tt(r,e.Debug.assertDefined(n))),1}function R(){var t=!ft||18!==ft.kind&&27!==ft.kind?void 0:e.tryCast(ft.parent,e.isNamedImportsOrExports);if(!t)return 0;var r=(253===t.kind?t.parent.parent:t.parent).moduleSpecifier,n=at.getSymbolAtLocation(r);if(!n)return 2;kt=3,Tt=!1;var i=at.getExportsAndPropertiesOfModule(n),a=e.arrayToSet(t.elements,function(e){return it(e)?void 0:(e.propertyName||e.name).escapedText});return Nt=i.filter(function(e){return"default"!==e.escapedName&&!a.get(e.escapedName)}),1}function K(){var t=V(n,ft,Dt);if(!t)return 0;if(kt=3,Tt=!0,Et=40===ft.kind?0:e.isClassLike(t)?2:3,!e.isClassLike(t))return 1;var r=ft.parent,i=e.isClassElement(r)?e.getModifierFlags(r):0;if(73===ft.kind&&!it(ft))switch(ft.getText()){case"private":i=8|i;break;case"static":i=32|i}if(!(8&i)){var a=e.flatMap(e.getAllSuperTypeNodes(t),function(e){var r=at.getTypeAtLocation(e);return r&&at.getPropertiesOfType(32&i?at.getTypeOfSymbolAtLocation(r.symbol,t):r)});Nt=rt(a,t.members,i)}return 1}function H(t){if(t){var r=t.parent;switch(t.kind){case 18:case 27:if(e.isObjectLiteralExpression(r)||e.isObjectBindingPattern(r))return r;break;case 40:return e.isMethodDeclaration(r)?e.tryCast(r.parent,e.isObjectLiteralExpression):void 0;case 73:return"async"===t.text&&e.isShorthandPropertyAssignment(t.parent)?t.parent.parent:void 0}}return void 0}function G(t){return!!t.parent&&e.isParameter(t.parent)&&e.isConstructorDeclaration(t.parent.parent)&&(e.isParameterPropertyModifier(t.kind)||e.isDeclarationName(t))}function Q(t){if(t){var r=t.parent;switch(t.kind){case 20:case 27:return e.isConstructorDeclaration(t.parent)?t.parent:void 0;default:if(G(t))return r.parent}}return void 0}function X(t){if(t){var r,n=e.findAncestor(t.parent,function(t){return e.isClassLike(t)?"quit":e.isFunctionLikeDeclaration(t)&&r===t.body?!0:(r=t,!1)});return n&&n}}function Y(t){if(t){var r=t.parent;switch(t.kind){case 30:case 29:case 42:case 73:case 190:case 269:case 268:case 270:if(r&&(262===r.kind||263===r.kind)){if(30===t.kind){var i=e.findPrecedingToken(t.pos,n,void 0);if(!r.typeArguments||i&&42===i.kind)break}return r}if(268===r.kind)return r.parent.parent;break;case 10:if(r&&(268===r.kind||270===r.kind))return r.parent.parent;break;case 19:if(r&&271===r.kind&&r.parent&&268===r.parent.kind)return r.parent.parent.parent;if(r&&270===r.kind)return r.parent.parent}}return void 0}function Z(t){var r=t.parent,n=r.kind;switch(t.kind){case 27:return 238===n||239===n||220===n||244===n||$(n)||242===n||186===n||243===n||e.isClassLike(r)&&!!r.typeParameters&&r.typeParameters.end>=t.pos;case 24:return 186===n;case 57:return 187===n;case 22:return 186===n;case 20:return 275===n||$(n);case 18:return 244===n;case 28:return 241===n||210===n||242===n||243===n||e.isFunctionLikeKind(n);case 117:return 155===n&&!e.isClassLike(r.parent);case 25:return 152===n||!!r.parent&&186===r.parent.kind;case 116:case 114:case 115:return 152===n&&!e.isConstructorDeclaration(r.parent);case 120:return 254===n||258===n||252===n;case 127:case 138:return!U(t);case 77:case 85:case 111:case 91:case 106:case 93:case 112:case 78:case 118:case 141:return!0;case 40:return e.isFunctionLike(t.parent)&&!e.isMethodDeclaration(t.parent)}if(L(B(t))&&U(t))return!1;if(G(t)&&(!e.isIdentifier(t)||e.isParameterPropertyModifier(B(t))||it(t)))return!1;switch(B(t)){case 119:case 77:case 78:case 126:case 85:case 91:case 111:case 112:case 114:case 115:case 116:case 117:case 106:case 118:return!0;case 122:return e.isPropertyDeclaration(t.parent)}return e.isDeclarationName(t)&&!e.isJsxAttribute(t.parent)&&!(e.isClassLike(t.parent)&&(t!==pt||a>pt.end))}function $(t){return e.isFunctionLikeKind(t)&&158!==t}function et(e){if(8===e.kind){var t=e.getFullText();return"."===t.charAt(t.length-1)}return!1}function tt(t,r){if(0===r.length)return t;for(var n=e.createUnderscoreEscapedMap(),i=0,a=r;i<a.length;i++){var o=a[i];if((276===o.kind||277===o.kind||187===o.kind||157===o.kind||159===o.kind||160===o.kind)&&!it(o)){var s=void 0;if(e.isBindingElement(o)&&o.propertyName)73===o.propertyName.kind&&(s=o.propertyName.escapedText);else{var c=e.getNameOfDeclaration(o);s=c&&e.isPropertyNameLiteral(c)?e.getEscapedTextOfIdentifierOrLiteral(c):void 0}n.set(s,!0)}}return t.filter(function(e){return!n.get(e.escapedName)})}function rt(t,r,n){for(var i=e.createUnderscoreEscapedMap(),a=0,o=r;a<o.length;a++){var s=o[a];if(!(155!==s.kind&&157!==s.kind&&159!==s.kind&&160!==s.kind||it(s)||e.hasModifier(s,8)||e.hasModifier(s,32)!==!!(32&n))){var c=e.getPropertyNameForPropertyNameNode(s.name);c&&i.set(c,!0)}}return t.filter(function(t){return!(i.has(t.escapedName)||!t.declarations||8&e.getDeclarationModifierFlagsFromSymbol(t))})}function nt(t,r){for(var n=e.createUnderscoreEscapedMap(),i=0,a=r;i<a.length;i++){var o=a[i];it(o)||268===o.kind&&n.set(o.name.escapedText,!0)}return t.filter(function(e){return!n.get(e.escapedName)})}function it(e){return e.getStart(n)<=a&&a<=e.getEnd()}var at=t.getTypeChecker(),ot=e.timestamp(),st=e.getTokenAtPosition(n,a);r("getCompletionData: Get current token: "+(e.timestamp()-ot)),ot=e.timestamp();var ct=e.isInComment(n,a,st);r("getCompletionData: Is inside comment: "+(e.timestamp()-ot));var ut=!1,lt=!1;if(ct){if(e.hasDocComment(n,a)){if(64===n.text.charCodeAt(a-1))return{kind:1};var _t=e.getLineStartPositionForPosition(a,n);if(!n.text.substring(_t,a).match(/[^\*|\s|(\/\*\*)]/))return{kind:2}}var dt=j(st,a);if(dt){if(dt.tagName.pos<=a&&a<=dt.tagName.end)return{kind:1};if(c(dt)&&dt.typeExpression&&289===dt.typeExpression.kind&&(st=e.getTokenAtPosition(n,a),st&&(e.isDeclarationName(st)||311===st.parent.kind&&st.parent.name===st)||(ut=it(dt.typeExpression))),e.isJSDocParameterTag(dt)&&(e.nodeIsMissing(dt.name)||dt.name.pos<=a&&a<=dt.name.end))return{kind:3,tag:dt}}if(!ut)return void r("Returning an empty list because completion was inside a regular comment or plain text part of a JsDoc comment.")}ot=e.timestamp();var pt=e.findPrecedingToken(a,n,void 0);r("getCompletionData: Get previous token 1: "+(e.timestamp()-ot));var ft=pt;if(ft&&a<=ft.end&&(e.isIdentifier(ft)||e.isKeyword(ft.kind))){var mt=e.timestamp();ft=e.findPrecedingToken(ft.getFullStart(),n,void 0),r("getCompletionData: Get previous token 2: "+(e.timestamp()-mt))}var gt,vt=st,yt=!1,ht=!1,bt=!1,xt=!1,Dt=e.getTouchingPropertyName(n,a);if(ft){if(P(ft))return void r("Returning an empty list because completion was requested in an invalid position.");var St=ft.parent;if(24===ft.kind)switch(yt=!0,St.kind){case 190:if(gt=St,vt=gt.expression,vt.end===ft.pos&&e.isCallExpression(vt)&&vt.getChildCount(n)&&21!==e.last(vt.getChildren(n)).kind)return void 0;break;case 149:vt=St.left;break;case 245:vt=St.name;break;case 184:case 215:vt=St;break;default:return void 0}else if(1===n.languageVariant){if(St&&190===St.kind&&(ft=St,St=St.parent),st.parent===Dt)switch(st.kind){case 30:(261===st.parent.kind||263===st.parent.kind)&&(Dt=st);break;case 42:262===st.parent.kind&&(Dt=st)}switch(St.kind){case 264:42===ft.kind&&(bt=!0,Dt=ft);break;case 205:if(!q(St))break;case 262:case 261:case 263:28===ft.kind&&(ht=!0,Dt=ft);break;case 268:switch(pt.kind){case 60:xt=!0;break;case 73:St!==pt.parent&&!St.initializer&&e.findChildOfKind(St,60,n)&&(xt=pt)}}}}var Ct=e.timestamp(),kt=5,Tt=!1,Et=0,Nt=[],At=[],Ft=[];if(yt)u();else if(ht){var Pt=e.Debug.assertEachDefined(at.getJsxIntrinsicTagNamesAt(Dt),"getJsxIntrinsicTagNames() should all be defined");p(),Nt=Pt.concat(Nt),kt=3,Et=0}else if(bt){var wt=ft.parent.parent.openingElement.tagName,It=at.getSymbolAtLocation(wt);It&&(Nt=[It]),kt=3,Et=0}else if(!p())return void 0;r("getCompletionData: Semantic work: "+(e.timestamp()-Ct));var Ot=pt&&E(pt,a,n,at),Mt=e.mapDefined(Ot&&(Ot.isUnion()?Ot.types:[Ot]),function(e){return e.isLiteral()?e.value:void 0}),Lt=pt&&Ot&&T(pt,Ot,at);return{kind:0,symbols:Nt,completionKind:kt,isInSnippetScope:lt,propertyAccessToConvert:gt,isNewIdentifierLocation:Tt,location:Dt,keywordFilters:Et,literals:Mt,symbolToOriginInfoMap:At,recommendedCompletion:Lt,previousToken:pt,isJsxInitializer:xt,insideJsDocTagTypeExpression:ut,symbolToSortTextMap:Ft}}function P(t,r,n,i){var a=h(t,n,r);if(void 0===a||1536&t.flags&&e.startsWithQuote(a)||e.isKnownSymbol(t))return void 0;var o={name:a,needsConvertPropertyAccess:!1};if(e.isIdentifierText(a,r))return o;switch(i){case 3:return void 0;case 0:return{name:JSON.stringify(a),needsConvertPropertyAccess:!1};case 2:case 1:return 32===a.charCodeAt(0)?void 0:{name:a,needsConvertPropertyAccess:!0};case 5:case 4:return o;default:e.Debug.assertNever(i)}}function w(t,r){if(!r)return I(t);var n=t+6+1;return $[n]||($[n]=I(t).filter(function(t){return!O(e.stringToToken(t.name))}))}function I(t){return $[t]||($[t]=et().filter(function(r){var n=e.stringToToken(r.name);switch(t){case 0:return!1;case 1:return 122===n||123||!e.isContextualKeyword(n)&&!L(n)||126===n||131===n||e.isTypeKeyword(n)&&142!==n;case 2:return L(n);case 3:return M(n);case 4:return e.isParameterPropertyModifier(n);case 5:return R(n);case 6:return e.isTypeKeyword(n);default:return e.Debug.assertNever(t)}}))}function O(e){switch(e){case 119:case 121:case 147:case 124:case 126:case 85:case 146:case 110:case 128:case 111:case 129:case 130:case 131:case 132:case 133:case 136:case 137:case 114:case 115:case 116:case 134:case 139:case 140:case 141:case 143:case 144:return!0;default:return!1}}function M(e){return 134===e}function L(t){switch(t){case 119:case 125:case 127:case 138:case 122:return!0;default:return e.isClassMemberModifier(t)}}function R(t){return 122===t||123===t||!e.isContextualKeyword(t)&&!L(t)}function B(t){return e.isIdentifier(t)?t.originalKeywordKind||0:t.kind}function j(t,r){var n=e.findAncestor(t,e.isJSDoc);return n&&n.tags&&(e.rangeContainsPosition(n,r)?e.findLast(n.tags,function(e){return e.pos<r}):void 0)}function J(t,r,n){return t.isUnion()?n.getAllPossiblePropertiesOfTypes(t.types.filter(function(t){return!(131068&t.flags||n.isArrayLikeType(t)||e.typeHasCallOrConstructSignatures(t,n)||n.isTypeInvalidDueToUnionDiscriminant(t,r))})):t.getApparentProperties()}function z(t,r){return t.isUnion()?e.Debug.assertEachDefined(r.getAllPossiblePropertiesOfTypes(t.types),"getAllPossiblePropertiesOfTypes() should all be defined"):e.Debug.assertEachDefined(t.getApparentProperties(),"getApparentProperties() should all be defined")}function V(t,r,n){switch(n.kind){case 312:return e.tryCast(n.parent,e.isObjectTypeDeclaration);case 1:var i=e.tryCast(e.lastOrUndefined(e.cast(n.parent,e.isSourceFile).statements),e.isObjectTypeDeclaration);if(i&&!e.findChildOfKind(i,19,t))return i}if(!r)return void 0;switch(r.kind){case 26:case 19:return U(n)&&n.parent.name===n?n.parent.parent:e.tryCast(n,e.isObjectTypeDeclaration);case 18:case 27:return e.tryCast(r.parent,e.isObjectTypeDeclaration);default:if(!U(r))return void 0;var a=e.isClassLike(r.parent.parent)?L:M;return a(r.kind)||40===r.kind||e.isIdentifier(r)&&a(e.stringToToken(r.text))?r.parent.parent:void 0}}function U(t){return t.parent&&e.isClassOrTypeElement(t.parent)&&e.isObjectTypeDeclaration(t.parent.parent)}function K(t,r,n,i){switch(r){case".":case"@":return!0;case'"':case"'":case"`":return!!n&&e.isStringLiteralOrTemplate(n)&&i===n.getStart(t)+1;case"<":return!!n&&28===n.kind&&(!e.isBinaryExpression(n.parent)||q(n.parent));case"/":return!!n&&(e.isStringLiteralLike(n)?!!e.tryGetImportFromModuleSpecifier(n):42===n.kind&&e.isJsxClosingElement(n.parent));default:return e.Debug.assertNever(r)}}function q(t){var r=t.left;return e.nodeIsMissing(r)}var W;!function(e){e.LocationPriority="0",e.SuggestedClassMembers="1",e.GlobalsOrKeywords="2",e.AutoImportSuggestions="3",e.JavascriptIdentifiers="4"}(W=t.SortText||(t.SortText={}));var H;!function(e){e[e.ThisType=0]="ThisType",e[e.SymbolMemberNoExport=1]="SymbolMemberNoExport",e[e.SymbolMemberExport=2]="SymbolMemberExport",e[e.Export=3]="Export"}(H||(H={}));var G;!function(e){e[e.None=0]="None",e[e.All=1]="All",e[e.ClassElementKeywords=2]="ClassElementKeywords",e[e.InterfaceElementKeywords=3]="InterfaceElementKeywords",e[e.ConstructorParameterKeywords=4]="ConstructorParameterKeywords",e[e.FunctionLikeBodyKeywords=5]="FunctionLikeBodyKeywords",e[e.TypeKeywords=6]="TypeKeywords",e[e.Last=6]="Last"}(G||(G={}));var Q;!function(e){e[e.Continue=0]="Continue",e[e.Success=1]="Success",e[e.Fail=2]="Fail"}(Q||(Q={})),t.getCompletionsAtPosition=i;var X=function(t){return"object"==typeof t?e.pseudoBigIntToString(t)+"n":JSON.stringify(t)};t.getCompletionEntriesFromSymbols=m,t.getCompletionEntryDetails=b,t.createCompletionDetailsForSymbol=D,t.createCompletionDetails=S,t.getCompletionEntrySymbol=k;var Y;!function(e){e[e.Data=0]="Data",e[e.JsDocTagName=1]="JsDocTagName",e[e.JsDocTag=2]="JsDocTag",e[e.JsDocParameterName=3]="JsDocParameterName"}(Y||(Y={}));var Z;!function(e){e[e.ObjectPropertyDeclaration=0]="ObjectPropertyDeclaration",e[e.Global=1]="Global",e[e.PropertyAccess=2]="PropertyAccess",e[e.MemberLike=3]="MemberLike",e[e.String=4]="String",e[e.None=5]="None"}(Z=t.CompletionKind||(t.CompletionKind={}));var $=[],et=e.memoize(function(){for(var t=[],r=74;148>=r;r++)t.push({name:e.tokenToString(r),kind:"keyword",kindModifiers:"",sortText:W.GlobalsOrKeywords});return t})}(t=e.Completions||(e.Completions={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,o,s,c){var u=e.getTouchingPropertyName(o,s);if(u.parent&&(e.isJsxOpeningElement(u.parent)&&u.parent.tagName===u||e.isJsxClosingElement(u.parent))){var l=u.parent.parent,_=l.openingElement,d=l.closingElement,p=[_,d].map(function(e){var t=e.tagName;return n(t,o)});return[{fileName:o.fileName,highlightSpans:p}]}return i(s,u,t,r,c)||a(u,o)}function n(t,r){return{fileName:r.fileName,textSpan:e.createTextSpanFromNode(t,r),kind:"none"}}function i(t,r,n,i,a){var o=e.arrayToSet(a,function(e){return e.fileName}),s=e.FindAllReferences.getReferenceEntriesForNode(t,r,n,a,i,void 0,o);if(!s)return void 0;var c=e.arrayToMultiMap(s.map(e.FindAllReferences.toHighlightSpan),function(e){return e.fileName},function(e){return e.span});return e.arrayFrom(c.entries(),function(t){var r=t[0],i=t[1];if(!o.has(r)){e.Debug.assert(n.redirectTargetsMap.has(r));var s=n.getSourceFile(r),c=e.find(a,function(e){return!!e.redirectInfo&&e.redirectInfo.redirectTarget===s});r=c.fileName,e.Debug.assert(o.has(r))}return{fileName:r,highlightSpans:i}})}function a(e,t){var r=o(e,t);return r&&[{fileName:t.fileName,highlightSpans:r}]}function o(t,r){function i(n,i){return a(t.parent,n,function(t){return e.mapDefined(t.symbol.declarations,function(t){return n(t)?e.find(t.getChildren(r),function(t){return e.contains(i,t.kind)}):void 0})})}function a(e,t,n){return t(e)?o(n(e,r)):void 0}function o(e){return e&&e.map(function(e){return n(e,r)})}switch(t.kind){case 92:case 84:return e.isIfStatement(t.parent)?k(t.parent,r):void 0;case 98:return a(t.parent,e.isReturnStatement,x);case 102:return a(t.parent,e.isThrowStatement,b);case 104:case 76:case 89:var s=76===t.kind?t.parent.parent:t.parent;return a(s,e.isTryStatement,h);case 100:return a(t.parent,e.isSwitchStatement,y);case 75:case 81:return a(t.parent.parent.parent,e.isSwitchStatement,y);case 74:case 79:return a(t.parent,e.isBreakOrContinueStatement,v);case 90:case 108:case 83:return a(t.parent,function(t){return e.isIterationStatement(t,!0)},g);case 125:return i(e.isConstructorDeclaration,[125]);case 127:case 138:return i(e.isAccessor,[127,138]);case 123:return a(t.parent,e.isAwaitExpression,D);case 122:return o(D(t));case 118:return o(S(t));default:return e.isModifierKind(t.kind)&&(e.isDeclaration(t.parent)||e.isVariableStatement(t.parent))?o(p(t.kind,t.parent)):void 0}}function s(t){return e.isThrowStatement(t)?[t]:e.isTryStatement(t)?e.concatenate(t.catchClause?s(t.catchClause):t.tryBlock&&s(t.tryBlock),t.finallyBlock&&s(t.finallyBlock)):e.isFunctionLike(t)?void 0:l(t,s)}function c(t){for(var r=t;r.parent;){var n=r.parent;if(e.isFunctionBlock(n)||285===n.kind)return n;if(e.isTryStatement(n)&&n.tryBlock===r&&n.catchClause)return r;r=n}return void 0}function u(t){return e.isBreakOrContinueStatement(t)?[t]:e.isFunctionLike(t)?void 0:l(t,u)}function l(t,r){var n=[];return t.forEachChild(function(t){var i=r(t);void 0!==i&&n.push.apply(n,e.toArray(i))}),n}function _(e,t){var r=d(t);return!!r&&r===e}function d(t){return e.findAncestor(t,function(r){switch(r.kind){case 233:if(229===t.kind)return!1;case 226:case 227:case 228:case 225:case 224:return!t.label||E(r,t.label.escapedText);default:return e.isFunctionLike(r)&&"quit"}})}function p(t,r){return e.mapDefined(f(r,e.modifierToFlag(t)),function(r){return e.findModifier(r,t)})}function f(t,r){var n=t.parent;switch(n.kind){case 246:case 285:case 219:case 272:case 273:return 128&r&&e.isClassDeclaration(t)?t.members.concat([t]):n.statements;case 158:case 157:case 240:return n.parameters.concat(e.isClassLike(n.parent)?n.parent.members:[]);case 241:case 210:var i=n.members;if(28&r){var a=e.find(n.members,e.isConstructorDeclaration);if(a)return i.concat(a.parameters)}else if(128&r)return i.concat([n]);return i;default:e.Debug.assertNever(n,"Invalid container kind.")}}function m(t,r){for(var n=[],i=2;i<arguments.length;i++)n[i-2]=arguments[i];return r&&e.contains(n,r.kind)?(t.push(r),!0):!1}function g(t){var r=[];if(m(r,t.getFirstToken(),90,108,83)&&224===t.kind)for(var n=t.getChildren(),i=n.length-1;i>=0&&!m(r,n[i],108);i--);return e.forEach(u(t.statement),function(e){_(t,e)&&m(r,e.getFirstToken(),74,79)}),r}function v(e){var t=d(e);if(t)switch(t.kind){case 226:case 227:case 228:case 224:case 225:return g(t);case 233:return y(t)}return void 0}function y(t){var r=[];return m(r,t.getFirstToken(),100),e.forEach(t.caseBlock.clauses,function(n){m(r,n.getFirstToken(),75,81),e.forEach(u(n),function(e){_(t,e)&&m(r,e.getFirstToken(),74)})}),r}function h(t,r){var n=[];if(m(n,t.getFirstToken(),104),t.catchClause&&m(n,t.catchClause.getFirstToken(),76),t.finallyBlock){var i=e.findChildOfKind(t,89,r);m(n,i,89)}return n}function b(t,r){var n=c(t);if(!n)return void 0;var i=[];return e.forEach(s(n),function(t){i.push(e.findChildOfKind(t,102,r))}),e.isFunctionBlock(n)&&e.forEachReturnStatement(n,function(t){i.push(e.findChildOfKind(t,98,r))}),i}function x(t,r){var n=e.getContainingFunction(t);if(!n)return void 0;var i=[];return e.forEachReturnStatement(e.cast(n.body,e.isBlock),function(t){i.push(e.findChildOfKind(t,98,r))}),e.forEach(s(n.body),function(t){i.push(e.findChildOfKind(t,102,r))}),i}function D(t){var r=e.getContainingFunction(t);if(!r)return void 0;var n=[];return r.modifiers&&r.modifiers.forEach(function(e){m(n,e,122)}),e.forEachChild(r,function(t){C(t,function(t){e.isAwaitExpression(t)&&m(n,t.getFirstToken(),123)})}),n}function S(t){var r=e.getContainingFunction(t);if(!r)return void 0;var n=[];return e.forEachChild(r,function(t){C(t,function(t){e.isYieldExpression(t)&&m(n,t.getFirstToken(),118)})}),n}function C(t,r){r(t),e.isFunctionLike(t)||e.isClassLike(t)||e.isInterfaceDeclaration(t)||e.isModuleDeclaration(t)||e.isTypeAliasDeclaration(t)||e.isTypeNode(t)||e.forEachChild(t,function(e){return C(e,r)})}function k(t,r){for(var i=T(t,r),a=[],o=0;o<i.length;o++){if(84===i[o].kind&&o<i.length-1){for(var s=i[o],c=i[o+1],u=!0,l=c.getStart(r)-1;l>=s.end;l--)if(!e.isWhiteSpaceSingleLine(r.text.charCodeAt(l))){u=!1;break}if(u){a.push({fileName:r.fileName,textSpan:e.createTextSpanFromBounds(s.getStart(),c.end),kind:"reference"}),o++;continue}}a.push(n(i[o],r))}return a}function T(t,r){for(var n=[];e.isIfStatement(t.parent)&&t.parent.elseStatement===t;)t=t.parent;for(;;){var i=t.getChildren(r);m(n,i[0],92);for(var a=i.length-1;a>=0&&!m(n,i[a],84);a--);if(!t.elseStatement||!e.isIfStatement(t.elseStatement))break;t=t.elseStatement}return n}function E(t,r){return!!e.findAncestor(t.parent,function(t){return e.isLabeledStatement(t)?t.label.escapedText===r:"quit"})}t.getDocumentHighlights=r}(t=e.DocumentHighlights||(e.DocumentHighlights={}))}(n||(n={}));var n;!function(e){function t(e,t){return r(e,t)}function r(t,r,i){function a(){var t=e.arrayFrom(f.keys()).filter(function(e){return e&&"_"===e.charAt(0)}).map(function(e){var t=f.get(e),r=[];return t.forEach(function(e,t){r.push({name:t,refCount:e.languageServiceRefCount})}),r.sort(function(e,t){return t.refCount-e.refCount}),{bucket:e,sourceFiles:r}});return JSON.stringify(t,void 0,2)}function o(t,i,a,o,c){var u=e.toPath(t,r,m),l=n(i);return s(t,u,i,l,a,o,c)}function s(e,t,r,n,i,a,o){return l(e,t,r,n,i,a,!0,o)}function c(t,i,a,o,s){var c=e.toPath(t,r,m),l=n(i);return u(t,c,i,l,a,o,s)}function u(e,t,r,n,i,a,o){return l(e,t,r,n,i,a,!1,o)}function l(t,r,n,a,o,s,c,u){var l=e.getOrUpdate(f,a,e.createMap),_=l.get(r),d=6===u?100:n.target||1;if(!_&&i){var p=i.getDocument(a,r);p&&(e.Debug.assert(c),_={sourceFile:p,languageServiceRefCount:0},l.set(r,_))}if(_)_.sourceFile.version!==s&&(_.sourceFile=e.updateLanguageServiceSourceFile(_.sourceFile,o,s,o.getChangeRange(_.sourceFile.scriptSnapshot)),i&&i.setDocument(a,r,_.sourceFile)),c&&_.languageServiceRefCount++;else{var p=e.createLanguageServiceSourceFile(t,o,d,s,!1,u);i&&i.setDocument(a,r,p),_={sourceFile:p,languageServiceRefCount:1},l.set(r,_)
}return e.Debug.assert(0!==_.languageServiceRefCount),_.sourceFile}function _(t,i){var a=e.toPath(t,r,m),o=n(i);return d(a,o)}function d(t,r){var n=e.Debug.assertDefined(f.get(r)),i=n.get(t);i.languageServiceRefCount--,e.Debug.assert(i.languageServiceRefCount>=0),0===i.languageServiceRefCount&&n.delete(t)}function p(t){return e.arrayFrom(f.entries(),function(e){var r=e[0],n=e[1],i=n.get(t);return[r,i&&i.languageServiceRefCount]})}void 0===r&&(r="");var f=e.createMap(),m=e.createGetCanonicalFileName(!!t);return{acquireDocument:o,acquireDocumentWithKey:s,updateDocument:c,updateDocumentWithKey:u,releaseDocument:_,releaseDocumentWithKey:d,getLanguageServiceRefCounts:p,reportStats:a,getKeyForCompilationSettings:n}}function n(t){return e.sourceFileAffectingCompilerOptions.map(function(r){return e.getCompilerOptionValue(t,r)}).join("|")}e.createDocumentRegistry=t,e.createDocumentRegistryInternal=r}(n||(n={}));var n;!function(e){var t;!function(t){function r(e,t,r,o){var s=c(e,r,o);return function(c,u,l){var _=n(e,t,s,u,r,o),d=_.directImports,p=_.indirectUsers;return i({indirectUsers:p},a(d,c,u.exportKind,r,l))}}function n(t,r,n,i,a,s){function c(){if(x)return t;for(var n=0,i=f.declarations;n<i.length;n++){var a=i[n];e.isExternalModuleAugmentation(a)&&r.has(a.getSourceFile().fileName)&&_(a)}return D.map(e.getSourceFileOfNode)}function u(t){var r=p(t);if(r)for(var n=0,i=r;n<i.length;n++){var o=i[n];if(g(o))switch(s&&s.throwIfCancellationRequested(),o.kind){case 192:if(!x){var c=o.parent;if(2===m&&238===c.kind){var d=c.name;if(73===d.kind){b.push(d);break}}_(o.getSourceFile())}break;case 73:break;case 249:l(o,o.name,e.hasModifier(o,1),!1);break;case 250:b.push(o);var f=o.importClause&&o.importClause.namedBindings;f&&252===f.kind?l(o,f.name,!1,!0):!x&&e.isDefaultImport(o)&&_(y(o));break;case 256:o.exportClause?b.push(o):u(v(o,a));break;case 184:b.push(o);break;default:e.Debug.failBadSyntaxKind(o,"Unexpected import kind.")}}}function l(t,r,n,i){if(2===m)i||b.push(t);else if(!x){var s=y(t);e.Debug.assert(285===s.kind||245===s.kind),n||o(s,r,a)?d(s):_(s)}}function _(t){e.Debug.assert(!x);var r=h(t);return r&&D.push(t),r}function d(t){if(_(t)){var r=a.getMergedSymbol(t.symbol);e.Debug.assert(!!(1536&r.flags));var n=p(r);if(n)for(var i=0,o=n;i<o.length;i++){var s=o[i];d(y(s))}}}function p(t){return n.get(e.getSymbolId(t).toString())}var f=i.exportingModuleSymbol,m=i.exportKind,g=e.nodeSeenTracker(),h=e.nodeSeenTracker(),b=[],x=!!f.globalExports,D=x?void 0:[];return u(f),{directImports:b,indirectUsers:c()}}function a(t,r,n,i,a){function o(e,t){_.push([e,t])}function s(t){if(249===t.kind)return void(b(t)&&c(t.name));if(73===t.kind)return void c(t);if(184===t.kind)return void(t.qualifier?e.isIdentifier(t.qualifier)&&t.qualifier.escapedText===e.symbolName(r)&&d.push(t.qualifier):2===n&&d.push(t.argument.literal));if(10===t.moduleSpecifier.kind){if(256===t.kind)return void u(t.exportClause);var s=t.importClause||{name:void 0,namedBindings:void 0},l=s.name,_=s.namedBindings;if(_)switch(_.kind){case 252:c(_.name);break;case 253:(0===n||1===n)&&u(_);break;default:e.Debug.assertNever(_)}if(!(!l||1!==n&&2!==n||a&&l.escapedText!==e.symbolEscapedNameNoDefault(r))){var p=i.getSymbolAtLocation(l);o(l,p)}}}function c(e){2!==n||a&&!l(e.escapedText)||o(e,i.getSymbolAtLocation(e))}function u(e){if(e)for(var t=0,n=e.elements;t<n.length;t++){var s=n[t],c=s.name,u=s.propertyName;if(l((u||c).escapedText))if(u)d.push(u),a&&c.escapedText!==r.escapedName||o(c,i.getSymbolAtLocation(c));else{var _=258===s.kind&&s.propertyName?i.getExportSpecifierLocalTargetSymbol(s):i.getSymbolAtLocation(c);o(c,_)}}}function l(e){return e===r.escapedName||0!==n&&"default"===e}var _=[],d=[];if(t)for(var p=0,f=t;p<f.length;p++){var m=f[p];s(m)}return{importSearches:_,singleReferences:d}}function o(t,r,n){var i=n.getSymbolAtLocation(r);return!!u(t,function(t){if(e.isExportDeclaration(t)){var r=t.exportClause,a=t.moduleSpecifier;return!a&&r&&r.elements.some(function(e){return n.getExportSpecifierLocalTargetSymbol(e)===i})}})}function s(e,t,r){for(var n=[],i=e.getTypeChecker(),a=0,o=t;a<o.length;a++){var s=o[a],c=r.valueDeclaration;if(285===c.kind){for(var u=0,_=s.referencedFiles;u<_.length;u++){var d=_[u];e.getSourceFileFromReference(s,d)===c&&n.push({kind:"reference",referencingFile:s,ref:d})}for(var p=0,f=s.typeReferenceDirectives;p<f.length;p++){var d=f[p],m=e.getResolvedTypeReferenceDirectives().get(d.fileName);void 0!==m&&m.resolvedFileName===c.fileName&&n.push({kind:"reference",referencingFile:s,ref:d})}}l(s,function(e,t){var a=i.getSymbolAtLocation(t);a===r&&n.push({kind:"import",literal:t})})}return n}function c(t,r,n){for(var i=e.createMap(),a=0,o=t;a<o.length;a++){var s=o[a];n&&n.throwIfCancellationRequested(),l(s,function(t,n){var a=r.getSymbolAtLocation(n);if(a){var o=e.getSymbolId(a).toString(),s=i.get(o);s||i.set(o,s=[]),s.push(t)}})}return i}function u(t,r){return e.forEach(285===t.kind?t.statements:t.body.statements,function(t){return r(t)||h(t)&&e.forEach(t.body&&t.body.statements,r)})}function l(t,r){if(t.externalModuleIndicator||void 0!==t.imports)for(var n=0,i=t.imports;n<i.length;n++){var a=i[n];r(e.importFromModuleSpecifier(a),a)}else u(t,function(t){switch(t.kind){case 256:case 250:var n=t;n.moduleSpecifier&&e.isStringLiteral(n.moduleSpecifier)&&r(n,n.moduleSpecifier);break;case 249:var n=t;b(n)&&r(n,n.moduleReference.expression)}})}function _(t,r,n,i){function a(){function a(t){var n=e.Debug.assertDefined(t.symbol.parent,"Expected export symbol to have a parent"),i=t.isExportEquals?2:1;return{kind:1,symbol:r,exportInfo:{exportingModuleSymbol:n,exportKind:i}}}function o(t,i){var a;switch(e.getAssignmentDeclarationKind(t)){case 1:a=0;break;case 2:a=2;break;default:return void 0}var o=i?n.getSymbolAtLocation(e.cast(t.left,e.isPropertyAccessExpression).name):r;return!o||1536&n.getMergedSymbol(o.parent).flags||e.Debug.fail("Special property assignment kind does not have a module as its parent. Assignment is "+e.Debug.formatSymbol(o)+", parent is "+e.Debug.formatSymbol(o.parent)),o&&s(o,a)}var u=t.parent,l=u.parent;if(r.exportSymbol)return 190===u.kind?r.declarations.some(function(e){return e===u})&&e.isBinaryExpression(l)?o(l,!1):void 0:s(r.exportSymbol,c(u));var _=p(u,t);if(_&&e.hasModifier(_,1)){if(e.isImportEqualsDeclaration(_)&&_.moduleReference===t){if(i)return void 0;var d=n.getSymbolAtLocation(_.name);return{kind:0,symbol:d}}return s(r,c(_))}return e.isExportAssignment(u)?a(u):e.isExportAssignment(l)?a(l):e.isBinaryExpression(u)?o(u,!0):e.isBinaryExpression(l)?o(l,!0):e.isJSDocTypedefTag(u)?s(r,0):void 0}function o(){var i=f(t);if(!i)return void 0;var a=n.getImmediateAliasedSymbol(r);if(!a)return void 0;a=g(a,n),"export="===a.escapedName&&(a=d(a,n));var o=e.symbolEscapedNameNoDefault(a);return void 0===o||"default"===o||o===r.escapedName?{kind:0,symbol:a}:void 0}function s(e,t){var r=m(e,t,n);return r&&{kind:1,symbol:e,exportInfo:r}}function c(t){return e.hasModifier(t,512)?1:0}return i?a():a()||o()}function d(t,r){if(2097152&t.flags)return e.Debug.assertDefined(r.getImmediateAliasedSymbol(t));var n=t.valueDeclaration;return e.isExportAssignment(n)?e.Debug.assertDefined(n.expression.symbol):e.isBinaryExpression(n)?e.Debug.assertDefined(n.right.symbol):e.isSourceFile(n)?e.Debug.assertDefined(n.symbol):e.Debug.fail()}function p(e,t){if(238===e.kind){var r=e;return r.name!==t?void 0:275===r.parent.kind?void 0:220===r.parent.parent.kind?r.parent.parent:void 0}return e}function f(t){var r=t.parent;switch(r.kind){case 249:return r.name===t&&b(r);case 254:return!r.propertyName;case 251:case 252:return e.Debug.assert(r.name===t),!0;default:return!1}}function m(t,r,n){var i=t.parent;if(!i)return void 0;var a=n.getMergedSymbol(i);return e.isExternalModuleSymbol(a)?{exportingModuleSymbol:a,exportKind:r}:void 0}function g(t,r){if(t.declarations)for(var n=0,i=t.declarations;n<i.length;n++){var a=i[n];if(e.isExportSpecifier(a)&&!a.propertyName&&!a.parent.parent.moduleSpecifier)return r.getExportSpecifierLocalTargetSymbol(a)}return t}function v(e,t){return t.getMergedSymbol(y(e).symbol)}function y(t){if(192===t.kind)return t.getSourceFile();var r=t.parent;return 285===r.kind?r:(e.Debug.assert(246===r.kind),e.cast(r.parent,h))}function h(e){return 245===e.kind&&10===e.name.kind}function b(e){return 260===e.moduleReference.kind&&10===e.moduleReference.expression.kind}t.createImportTracker=r;var x;!function(e){e[e.Named=0]="Named",e[e.Default=1]="Default",e[e.ExportEquals=2]="ExportEquals"}(x=t.ExportKind||(t.ExportKind={}));var D;!function(e){e[e.Import=0]="Import",e[e.Export=1]="Export"}(D=t.ImportExport||(t.ImportExport={})),t.findModuleReferences=s,t.getImportOrExportSymbol=_,t.getExportInfo=m}(t=e.FindAllReferences||(e.FindAllReferences={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(e,t){return void 0===t&&(t=1),{kind:t,node:e.name||e}}function n(r,n,i,a,o){var s=e.getTouchingPropertyName(a,o),c=t.Core.getReferencedSymbolsForNode(o,s,r,i,n),u=r.getTypeChecker();return c&&c.length?e.mapDefined(c,function(e){var t=e.definition,r=e.references;return t&&{definition:u.runWithCancellationToken(n,function(e){return l(t,e,s)}),references:r.map(p)}}):void 0}function a(t,r,n,i,a){var s=e.getTouchingPropertyName(i,a),c=o(t,r,n,s,a),u=t.getTypeChecker();return e.map(c,function(e){return g(e,u)})}function o(n,i,a,o,s){if(285===o.kind)return void 0;var u=n.getTypeChecker();if(277===o.parent.kind){var l=[];return t.Core.getReferenceEntriesForShorthandPropertyAssignment(o,u,function(e){return l.push(r(e))}),l}if(99===o.kind||e.isSuperProperty(o.parent)){var _=u.getSymbolAtLocation(o);return _.valueDeclaration&&[r(_.valueDeclaration)]}return c(s,o,n,a,i,{implementations:!0})}function s(r,n,i,a,o,s,c){return e.map(u(t.Core.getReferencedSymbolsForNode(o,a,r,i,n,s)),function(e){return c(e,a,r.getTypeChecker())})}function c(r,n,i,a,o,s,c){return void 0===s&&(s={}),void 0===c&&(c=e.arrayToSet(a,function(e){return e.fileName})),u(t.Core.getReferencedSymbolsForNode(r,n,i,a,o,s,c))}function u(t){return t&&e.flatMap(t,function(e){return e.references})}function l(t,r,n){var i=function(){switch(t.type){case 0:var i=t.symbol,a=_(i,r,n),o=a.displayParts,s=a.kind,c=o.map(function(e){return e.text}).join("");return{node:i.declarations?e.getNameOfDeclaration(e.first(i.declarations))||e.first(i.declarations):n,name:c,kind:s,displayParts:o};case 1:var u=t.node;return{node:u,name:u.text,kind:"label",displayParts:[e.displayPart(u.text,e.SymbolDisplayPartKind.text)]};case 2:var l=t.node,d=e.tokenToString(l.kind);return{node:l,name:d,kind:"keyword",displayParts:[{text:d,kind:"keyword"}]};case 3:var p=t.node,i=r.getSymbolAtLocation(p),f=i&&e.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(r,i,p.getSourceFile(),e.getContainerNode(p),p).displayParts||[e.textPart("this")];return{node:p,name:"this",kind:"var",displayParts:f};case 4:var m=t.node;return{node:m,name:m.text,kind:"var",displayParts:[e.displayPart(e.getTextOfNode(m),e.SymbolDisplayPartKind.stringLiteral)]};default:return e.Debug.assertNever(t)}}(),a=i.node,o=i.name,s=i.kind,c=i.displayParts,u=a.getSourceFile();return{containerKind:"",containerName:"",fileName:u.fileName,kind:s,name:o,textSpan:h(e.isComputedPropertyName(a)?a.expression:a,u),displayParts:c}}function _(r,n,i){var a=t.Core.getIntersectingMeaningFromDeclarations(i,r),o=r.declarations&&e.firstOrUndefined(r.declarations)||i,s=e.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(n,r,o.getSourceFile(),o,o,a),c=s.displayParts,u=s.symbolKind;return{displayParts:c,kind:u}}function d(e,t,r,n){return i({},f(e),n&&m(e,t,r))}function p(t){var r=f(t),n=r.textSpan,i=r.fileName;if(0===t.kind)return{textSpan:n,fileName:i,isWriteAccess:!1,isDefinition:!1};var a=t.kind,o=t.node;return{textSpan:n,fileName:i,isWriteAccess:x(o),isDefinition:81===o.kind||!!e.getDeclarationFromName(o)||e.isLiteralComputedPropertyDeclarationName(o),isInString:2===a?!0:void 0}}function f(e){if(0===e.kind)return{textSpan:e.textSpan,fileName:e.fileName};var t=e.node.getSourceFile();return{textSpan:h(e.node,t),fileName:t.fileName}}function m(t,r,n){if(0!==t.kind&&e.isIdentifier(r)){var i=t.node,a=t.kind,o=r.text,s=e.isShorthandPropertyAssignment(i.parent);if(s||e.isObjectBindingElementWithoutPropertyName(i.parent)){var c={prefixText:o+": "},u={suffixText:": "+o};return 3===a?c:4===a?u:s?u:c}if(e.isImportSpecifier(t.node.parent)&&!t.node.parent.propertyName){var l=e.isExportSpecifier(r.parent)?n.getExportSpecifierLocalTargetSymbol(r.parent):n.getSymbolAtLocation(r);return e.contains(l.declarations,t.node.parent)?{prefixText:o+" as "}:e.emptyOptions}if(e.isExportSpecifier(t.node.parent)&&!t.node.parent.propertyName)return r===t.node?{prefixText:o+" as "}:{suffixText:" as "+o}}return e.emptyOptions}function g(e,t){if(0!==e.kind){var r=e.node,n=r.getSourceFile();return i({textSpan:h(r,n),fileName:n.fileName},v(r,t))}var a=e.textSpan,o=e.fileName;return{textSpan:a,fileName:o,kind:"",displayParts:[]}}function v(t,r){var n=r.getSymbolAtLocation(e.isDeclaration(t)&&t.name?t.name:t);return n?_(n,r,t):189===t.kind?{kind:"interface",displayParts:[e.punctuationPart(20),e.textPart("object literal"),e.punctuationPart(21)]}:210===t.kind?{kind:"local class",displayParts:[e.punctuationPart(20),e.textPart("anonymous local class"),e.punctuationPart(21)]}:{kind:e.getNodeKind(t),displayParts:[]}}function y(e){if(0===e.kind){var t=e.fileName,r=e.textSpan;return{fileName:t,span:{textSpan:r,kind:"reference"}}}var n=e.node,i=e.kind,a=n.getSourceFile(),o=x(n),s={textSpan:h(n,a),kind:o?"writtenReference":"reference",isInString:2===i?!0:void 0};return{fileName:a.fileName,span:s}}function h(t,r){var n=t.getStart(r),i=t.getEnd();return 10===t.kind&&(n+=1,i-=1),e.createTextSpanFromBounds(n,i)}function b(e){return 0===e.kind?e.textSpan:h(e.node,e.node.getSourceFile())}function x(t){var r=e.getDeclarationFromName(t);return!!r&&D(r)||81===t.kind||e.isWriteAccess(t)}function D(t){if(4194304&t.flags)return!0;switch(t.kind){case 205:case 187:case 241:case 210:case 81:case 244:case 279:case 258:case 251:case 249:case 254:case 242:case 303:case 310:case 268:case 245:case 248:case 252:case 152:case 277:case 243:case 151:return!0;case 276:return!e.isArrayLiteralOrObjectLiteralDestructuringPattern(t.parent);case 240:case 197:case 158:case 157:case 159:case 160:return!!t.body;case 238:case 155:return!!t.initializer||e.isCatchClause(t.parent);case 156:case 154:case 311:case 305:return!1;default:return e.Debug.failBadSyntaxKind(t)}}var S;!function(e){e[e.Symbol=0]="Symbol",e[e.Label=1]="Label",e[e.Keyword=2]="Keyword",e[e.This=3]="This",e[e.String=4]="String"}(S=t.DefinitionKind||(t.DefinitionKind={}));var C;!function(e){e[e.Span=0]="Span",e[e.Node=1]="Node",e[e.StringLiteral=2]="StringLiteral",e[e.SearchedLocalFoundProperty=3]="SearchedLocalFoundProperty",e[e.SearchedPropertyFoundLocal=4]="SearchedPropertyFoundLocal"}(C=t.EntryKind||(t.EntryKind={})),t.nodeEntry=r,t.findReferencedSymbols=n,t.getImplementationsAtPosition=a,t.findReferenceOrRenameEntries=s,t.getReferenceEntriesForNode=c,t.toRenameLocation=d,t.toReferenceEntry=p,t.toHighlightSpan=y,t.getTextSpanOfEntry=b}(t=e.FindAllReferences||(e.FindAllReferences={}))}(n||(n={})),function(e){var t;!function(t){var r;!function(r){function n(t,r,n,s,_,d,p){if(void 0===d&&(d={}),void 0===p&&(p=e.arrayToSet(s,function(e){return e.fileName})),e.isSourceFile(r)){var f=e.GoToDefinition.getReferenceAtPosition(r,t,n),m=f&&n.getTypeChecker().getMergedSymbol(f.file.symbol);return m&&c(n,m,!1,s,p)}if(!d.implementations){var g=u(r,s,_);if(g)return g}var v=n.getTypeChecker(),y=v.getSymbolAtLocation(r);if(!y)return!d.implementations&&e.isStringLiteral(r)?et(r,s,_):void 0;if("export="===y.escapedName)return c(n,y.parent,!1,s,p);var h=a(y,n,s,_,d,p);if(h&&!(33554432&y.flags))return h;var b=i(r,y,v),x=b&&a(b,n,s,_,d,p),D=l(y,r,s,p,v,_,d);return o(n,h,D,x)}function i(t,r,n){if(t.parent&&e.isNamespaceExportDeclaration(t.parent)){var i=n.getAliasedSymbol(r),a=n.getMergedSymbol(i);if(i!==a)return a}return void 0}function a(t,r,n,i,a,s){var u=1536&t.flags?e.find(t.declarations,e.isSourceFile):void 0;if(!u)return void 0;var _=t.exports.get("export="),d=c(r,t,!!_,n,s);if(!_||!s.has(u.fileName))return d;var p=r.getTypeChecker();return t=e.skipAlias(_,p),o(r,d,l(t,void 0,n,s,p,i,a))}function o(r){for(var n=[],i=1;i<arguments.length;i++)n[i-1]=arguments[i];for(var a,o=0,c=n;o<c.length;o++){var u=c[o];if(u&&u.length)if(a)for(var l=function(n){if(!n.definition||0!==n.definition.type)return a.push(n),"continue";var i=n.definition.symbol,o=e.findIndex(a,function(e){return!!e.definition&&0===e.definition.type&&e.definition.symbol===i});if(-1===o)return a.push(n),"continue";var c=a[o];a[o]={definition:c.definition,references:c.references.concat(n.references).sort(function(n,i){var a=s(r,n),o=s(r,i);if(a!==o)return e.compareValues(a,o);var c=t.getTextSpanOfEntry(n),u=t.getTextSpanOfEntry(i);return c.start!==u.start?e.compareValues(c.start,u.start):e.compareValues(c.length,u.length)})}},_=0,d=u;_<d.length;_++){var p=d[_];l(p)}else a=u}return a}function s(e,t){var r=0===t.kind?e.getSourceFile(t.fileName):t.node.getSourceFile();return e.getSourceFiles().indexOf(r)}function c(r,n,i,a,o){e.Debug.assert(!!n.valueDeclaration);for(var s=e.mapDefined(t.findModuleReferences(r,a,n),function(r){if("import"===r.kind){var n=r.literal.parent;if(e.isLiteralTypeNode(n)){var a=e.cast(n.parent,e.isImportTypeNode);if(i&&!a.qualifier)return void 0}return t.nodeEntry(r.literal)}return{kind:0,fileName:r.referencingFile.fileName,textSpan:e.createTextSpanFromRange(r.ref)}}),c=0,u=n.declarations;c<u.length;c++){var l=u[c];switch(l.kind){case 285:break;case 245:o.has(l.getSourceFile().fileName)&&s.push(t.nodeEntry(l.name));break;default:e.Debug.assert(!!(33554432&n.flags),"Expected a module symbol to be declared by a SourceFile or ModuleDeclaration.")}}var _=n.exports.get("export=");if(_)for(var d=0,p=_.declarations;d<p.length;d++){var l=p[d],f=l.getSourceFile();if(o.has(f.fileName)){var m=e.isBinaryExpression(l)&&e.isPropertyAccessExpression(l.left)?l.left.expression:e.isExportAssignment(l)?e.Debug.assertDefined(e.findChildOfKind(l,86,f)):e.getNameOfDeclaration(l)||l;s.push(t.nodeEntry(m))}}return s.length?[{definition:{type:0,symbol:n},references:s}]:e.emptyArray}function u(t,r,n){if(e.isTypeKeyword(t.kind))return A(r,t.kind,n);if(e.isJumpStatementTarget(t)){var i=e.getTargetLabel(t.parent,t.text);return i&&E(i.parent,i)}return e.isLabelOfLabeledStatement(t)?E(t.parent,t):e.isThis(t)?$(t,r,n):99===t.kind?Y(t):void 0}function l(t,r,n,i,a,o,s){var c=r&&p(t,r,a,!lt(s))||t,u=r?it(r,c):7,l=[],f=new dt(n,i,r?d(r):0,a,o,u,s,l),g=lt(s)?e.find(c.declarations,e.isExportSpecifier):void 0;if(g)O(g.name,c,g,f.createSearch(r,t,void 0),f,!0,!0);else if(r&&81===r.kind)j(r,c,f),m(r,c,{exportingModuleSymbol:e.Debug.assertDefined(c.parent,"Expected export symbol to have a parent"),exportKind:1},f);else{var v=f.createSearch(r,c,void 0,{allSearchSymbols:r?tt(c,r,a,!!s.isForRename,!!s.providePrefixAndSuffixTextForRename,!!s.implementations):[c]});_(c,f,v)}return l}function _(t,r,n){var i=x(t);if(i)P(i,i.getSourceFile(),n,r,!(e.isSourceFile(i)&&!e.contains(r.sourceFiles,i)));else for(var a=0,o=r.sourceFiles;a<o.length;a++){var s=o[a];r.cancellationToken.throwIfCancellationRequested(),h(s,n,r)}}function d(t){switch(t.kind){case 125:return 1;case 73:if(e.isClassLike(t.parent))return e.Debug.assert(t.parent.name===t),2;default:return 0}}function p(t,r,n,i){var a=r.parent;return e.isExportSpecifier(a)&&i?M(r,t,a,n):e.firstDefined(t.declarations,function(i){if(!i.parent){if(33554432&t.flags)return void 0;e.Debug.fail("Unexpected symbol at "+e.Debug.formatSyntaxKind(r.kind)+": "+e.Debug.formatSymbol(t))}return e.isTypeLiteralNode(i.parent)&&e.isUnionTypeNode(i.parent.parent)?n.getPropertyOfType(n.getTypeFromTypeNode(i.parent.parent),t.name):void 0})}function f(t){if(!(33555968&t.flags))return void 0;var r=t.declarations&&e.find(t.declarations,function(t){return!e.isSourceFile(t)&&!e.isModuleDeclaration(t)});return r&&r.symbol}function m(e,t,r,n){var i=n.getImportSearches(t,r),a=i.importSearches,o=i.singleReferences,s=i.indirectUsers;if(o.length)for(var c=n.referenceAdder(t),u=0,l=o;u<l.length;u++){var _=l[u];v(_,n)&&c(_)}for(var d=0,p=a;d<p.length;d++){var f=p[d],m=f[0],g=f[1];F(m.getSourceFile(),n.createSearch(m,g,1),n)}if(s.length){var y=void 0;switch(r.exportKind){case 0:y=n.createSearch(e,t,1);break;case 1:y=n.options.isForRename?void 0:n.createSearch(e,t,1,{text:"default"});break;case 2:}if(y)for(var b=0,x=s;b<x.length;b++){var D=x[b];h(D,y,n)}}}function g(r,n,i,a,o,s,c,u){for(var l=t.createImportTracker(r,e.arrayToSet(r,function(e){return e.fileName}),n,i),_=l(a,{exportKind:c?1:0,exportingModuleSymbol:o},!1),d=_.importSearches,p=_.indirectUsers,f=0,m=d;f<m.length;f++){var g=m[f][0];u(g)}for(var v=0,y=p;v<y.length;v++)for(var h=y[v],b=0,x=k(h,c?"default":s);b<x.length;b++){var D=x[b];e.isIdentifier(D)&&!e.isImportOrExportSpecifier(D.parent)&&n.getSymbolAtLocation(D)===a&&u(D)}}function v(t,r){return w(t,r)?r.options.isForRename?e.isIdentifier(t)?!(e.isImportOrExportSpecifier(t.parent)&&"default"===t.escapedText):!1:!0:!1}function y(e,t){for(var r=0,n=e.declarations;r<n.length;r++){var i=n[r],a=i.getSourceFile();F(a,t.createSearch(i,e,0),t,t.includesSourceFile(a))}}function h(t,r,n){void 0!==e.getNameTable(t).get(r.escapedText)&&F(t,r,n)}function b(t,r){return e.isArrayLiteralOrObjectLiteralDestructuringPattern(t.parent.parent)?r.getPropertySymbolOfDestructuringAssignment(t):void 0}function x(t){var r=t.declarations,n=t.flags,i=t.parent,a=t.valueDeclaration;if(a&&(197===a.kind||210===a.kind))return a;if(!r)return void 0;if(8196&n){var o=e.find(r,function(t){return e.hasModifier(t,8)});return o?e.getAncestor(o,241):void 0}if(r.some(e.isObjectBindingElementWithoutPropertyName))return void 0;var s=i&&!(262144&t.flags);if(s&&(!e.isExternalModuleSymbol(i)||i.globalExports))return void 0;for(var c,u=0,l=r;u<l.length;u++){var _=l[u],d=e.getContainerNode(_);if(c&&c!==d)return void 0;if(!d||285===d.kind&&!e.isExternalOrCommonJsModule(d))return void 0;c=d}return s?c.getSourceFile():c}function D(e,t,r){return S(e,t,r,function(){return!0})||!1}function S(t,r,n,i){var a=e.isParameterPropertyDeclaration(t.parent)?e.first(r.getSymbolsOfParameterPropertyDeclaration(t.parent,t.text)):r.getSymbolAtLocation(t);if(!a)return void 0;for(var o=0,s=k(n,a.name);o<s.length;o++){var c=s[o];if(e.isIdentifier(c)&&c!==t&&c.escapedText===t.escapedText){var u=r.getSymbolAtLocation(c);if(u===a||r.getShorthandAssignmentValueSymbol(c.parent)===a||e.isExportSpecifier(c.parent)&&M(c,u,c.parent,r)===a){var l=i(c);if(l)return l}}}}function C(t,r,n,i){if(t.name&&e.isIdentifier(t.name))for(var a=e.Debug.assertDefined(n.getSymbolAtLocation(t.name)),o=0,s=r;o<s.length;o++)for(var c=s[o],u=0,l=k(c,a.name);u<l.length;u++){var _=l[u];if(e.isIdentifier(_)&&_!==t.name&&_.escapedText===t.name.escapedText){var d=e.climbPastPropertyAccess(_),p=d.parent;if(e.isCallExpression(p)&&p.expression===d){var f=n.getSymbolAtLocation(_);f&&n.getRootSymbols(f).some(function(e){return e===a})&&i(p)}}}}function k(t,r,n){return void 0===n&&(n=t),T(t,r,n).map(function(r){return e.getTouchingPropertyName(t,r)})}function T(t,r,n){void 0===n&&(n=t);var i=[];if(!r||!r.length)return i;for(var a=t.text,o=a.length,s=r.length,c=a.indexOf(r,n.pos);c>=0&&!(c>n.end);){var u=c+s;0!==c&&e.isIdentifierPart(a.charCodeAt(c-1),8)||u!==o&&e.isIdentifierPart(a.charCodeAt(u),8)||i.push(c),c=a.indexOf(r,c+s+1)}return i}function E(r,n){var i=r.getSourceFile(),a=n.text,o=e.mapDefined(k(i,a,r),function(r){return r===n||e.isJumpStatementTarget(r)&&e.getTargetLabel(r,a)===n?t.nodeEntry(r):void 0});return[{definition:{type:1,node:n},references:o}]}function N(t,r){switch(t.kind){case 73:return t.text.length===r.length;case 10:var n=t;return(e.isLiteralNameOfPropertyDeclarationOrIndexAccess(n)||e.isNameOfModuleDeclaration(t)||e.isExpressionOfExternalModuleImportEqualsDeclaration(t)||e.isCallExpression(t.parent)&&e.isBindableObjectDefinePropertyCall(t.parent)&&t.parent.arguments[1]===t)&&n.text.length===r.length;case 8:return e.isLiteralNameOfPropertyDeclarationOrIndexAccess(t)&&t.text.length===r.length;case 81:return"default".length===r.length;default:return!1}}function A(r,n,i){var a=e.flatMap(r,function(r){return i.throwIfCancellationRequested(),e.mapDefined(k(r,e.tokenToString(n),r),function(e){return e.kind===n?t.nodeEntry(e):void 0})});return a.length?[{definition:{type:2,node:a[0].node},references:a}]:void 0}function F(e,t,r,n){return void 0===n&&(n=!0),r.cancellationToken.throwIfCancellationRequested(),P(e,e,t,r,n)}function P(e,t,r,n,i){if(n.markSearchedSymbols(t,r.allSearchSymbols))for(var a=0,o=T(t,r.text,e);a<o.length;a++){var s=o[a];I(t,s,r,n,i)}}function w(t,r){return!!(e.getMeaningFromLocation(t)&r.searchMeaning)}function I(t,r,n,i,a){var o=e.getTouchingPropertyName(t,r);if(!N(o,n.text))return void(!i.options.implementations&&(i.options.findInStrings&&e.isInString(t,r)||i.options.findInComments&&e.isInNonReferenceComment(t,r))&&i.addStringOrCommentReference(t.fileName,e.createTextSpan(r,n.text.length)));if(w(o,i)){var s=i.checker.getSymbolAtLocation(o);if(s){var c=o.parent;if(!e.isImportSpecifier(c)||c.propertyName!==o){if(e.isExportSpecifier(c))return e.Debug.assert(73===o.kind),void O(o,s,c,n,i,a);var u=nt(n,s,o,i);if(!u)return void B(s,n,i);switch(i.specialSearchKind){case 0:a&&j(o,u,i);break;case 1:J(o,t,n,i);break;case 2:z(o,n,i);break;default:e.Debug.assertNever(i.specialSearchKind)}R(o,s,n,i)}}}}function O(r,n,i,a,o,s,c){function u(){s&&j(r,f,o)}e.Debug.assert(!c||!!o.options.providePrefixAndSuffixTextForRename,"If alwaysGetReferences is true, then prefix/suffix text must be enabled");var l=i.parent,_=i.propertyName,d=i.name,p=l.parent,f=M(r,n,i,o.checker);if(c||a.includes(f)){if(_?r===_?(p.moduleSpecifier||u(),s&&!o.options.isForRename&&o.markSeenReExportRHS(d)&&j(d,e.Debug.assertDefined(i.symbol),o)):o.markSeenReExportRHS(r)&&u():o.options.isForRename&&"default"===d.escapedText||u(),!lt(o.options)||c){var g=81===r.originalKeywordKind||81===i.name.originalKeywordKind,v=g?1:0,h=e.Debug.assertDefined(i.symbol),b=e.Debug.assertDefined(t.getExportInfo(h,v,o.checker));m(r,h,b,o)}if(1!==a.comingFrom&&p.moduleSpecifier&&!_&&!lt(o.options)){var x=o.checker.getExportSpecifierLocalTargetSymbol(i);x&&y(x,o)}}}function M(e,t,r,n){return L(e,r)&&n.getExportSpecifierLocalTargetSymbol(r)||t}function L(t,r){var n=r.parent,i=r.propertyName,a=r.name;return e.Debug.assert(i===t||a===t),i?i===t:!n.parent.moduleSpecifier}function R(e,r,n,i){var a=t.getImportOrExportSymbol(e,r,i.checker,1===n.comingFrom);if(a){var o=a.symbol;0===a.kind?lt(i.options)||y(o,i):m(e,o,a.exportInfo,i)}}function B(t,r,n){var i=t.flags,a=t.valueDeclaration,o=n.checker.getShorthandAssignmentValueSymbol(a),s=a&&e.getNameOfDeclaration(a);33554432&i||!s||!r.includes(o)||j(s,o,n)}function j(e,t,r){var n="kind"in t?t:{kind:void 0,symbol:t},i=n.kind,a=n.symbol,o=r.referenceAdder(a);r.options.implementations?H(e,o,r):o(e,i)}function J(t,r,n,i){e.isNewExpressionTarget(t)&&j(t,n.symbol,i);var a=function(){return i.referenceAdder(n.symbol)};if(e.isClassLike(t.parent))e.Debug.assert(81===t.kind||t.parent.name===t),V(n.symbol,r,a());else{var o=ct(t);o&&(K(o,a()),W(o,i))}}function z(t,r,n){j(t,r.symbol,n);var i=t.parent;if(!n.options.isForRename&&e.isClassLike(i)){e.Debug.assert(i.name===t);for(var a=n.referenceAdder(r.symbol),o=0,s=i.members;o<s.length;o++){var c=s[o];e.isMethodOrAccessor(c)&&e.hasModifier(c,32)&&c.body&&c.body.forEachChild(function u(t){101===t.kind?a(t):e.isFunctionLike(t)||e.isClassLike(t)||t.forEachChild(u)})}}}function V(t,r,n){var i=U(t);if(i)for(var a=0,o=i.declarations;a<o.length;a++){var s=o[a],c=e.findChildOfKind(s,125,r);e.Debug.assert(158===s.kind&&!!c),n(c)}t.exports&&t.exports.forEach(function(t){var r=t.valueDeclaration;if(r&&157===r.kind){var i=r.body;i&&st(i,101,function(t){e.isNewExpressionTarget(t)&&n(t)})}})}function U(e){return e.members&&e.members.get("__constructor")}function K(t,r){var n=U(t.symbol);if(n)for(var i=0,a=n.declarations;i<a.length;i++){var o=a[i];e.Debug.assert(158===o.kind);var s=o.body;s&&st(s,99,function(t){e.isCallExpressionTarget(t)&&r(t)})}}function q(e){return!!U(e.symbol)}function W(e,t){if(!q(e)){var r=e.symbol,n=t.createSearch(void 0,r,void 0);_(r,t,n)}}function H(t,r,n){function i(e){Q(e)&&r(e)}if(e.isDeclarationName(t)&&at(t.parent))return void r(t);if(73===t.kind){277===t.parent.kind&&ot(t,n.checker,r);var a=G(t);if(a)return void r(a);var o=e.findAncestor(t,function(t){return!e.isQualifiedName(t.parent)&&!e.isTypeNode(t.parent)&&!e.isTypeElement(t.parent)}),s=o.parent;if(e.hasType(s)&&s.type===o&&n.markSeenContainingTypeReference(s))if(e.hasInitializer(s))i(s.initializer);else if(e.isFunctionLike(s)&&s.body){var c=s.body;219===c.kind?e.forEachReturnStatement(c,function(e){e.expression&&i(e.expression)}):i(c)}else e.isAssertionExpression(s)&&i(s.expression)}}function G(t){return e.isIdentifier(t)||e.isPropertyAccessExpression(t)?G(t.parent):e.isExpressionWithTypeArguments(t)?e.tryCast(t.parent.parent,e.isClassLike):void 0}function Q(e){switch(e.kind){case 196:return Q(e.expression);case 198:case 197:case 189:case 210:case 188:return!0;default:return!1}}function X(t,r,n,i){if(t===r)return!0;var a=e.getSymbolId(t)+","+e.getSymbolId(r),o=n.get(a);if(void 0!==o)return o;n.set(a,!1);var s=t.declarations.some(function(t){return e.getAllSuperTypeNodes(t).some(function(e){var t=i.getTypeAtLocation(e);return!!t&&!!t.symbol&&X(t.symbol,r,n,i)})});return n.set(a,s),s}function Y(r){var n=e.getSuperContainer(r,!1);if(!n)return void 0;var i=32;switch(n.kind){case 155:case 154:case 157:case 156:case 158:case 159:case 160:i&=e.getModifierFlags(n),n=n.parent;break;default:return void 0}var a=n.getSourceFile(),o=e.mapDefined(k(a,"super",n),function(r){if(99===r.kind){var a=e.getSuperContainer(r,!1);return a&&(32&e.getModifierFlags(a))===i&&a.parent.symbol===n.symbol?t.nodeEntry(r):void 0}});return[{definition:{type:0,symbol:n.symbol},references:o}]}function Z(e){return 73===e.kind&&152===e.parent.kind&&e.parent.name===e}function $(r,n,i){var a=e.getThisContainer(r,!1),o=32;switch(a.kind){case 157:case 156:if(e.isObjectLiteralMethod(a))break;case 155:case 154:case 158:case 159:case 160:o&=e.getModifierFlags(a),a=a.parent;break;case 285:if(e.isExternalModule(a)||Z(r))return void 0;case 240:case 197:break;default:return void 0}var s=e.flatMap(285===a.kind?n:[a.getSourceFile()],function(t){return i.throwIfCancellationRequested(),k(t,"this",e.isSourceFile(a)?t:a).filter(function(t){if(!e.isThis(t))return!1;var r=e.getThisContainer(t,!1);switch(a.kind){case 197:case 240:return a.symbol===r.symbol;case 157:case 156:return e.isObjectLiteralMethod(a)&&a.symbol===r.symbol;case 210:case 241:return r.parent&&a.symbol===r.parent.symbol&&(32&e.getModifierFlags(r))===o;case 285:return 285===r.kind&&!e.isExternalModule(r)&&!Z(t)}})}).map(function(e){return t.nodeEntry(e)}),c=e.firstDefined(s,function(t){return e.isParameter(t.node.parent)?t.node:void 0});return[{definition:{type:3,node:c||r},references:s}]}function et(r,n,i){var a=e.flatMap(n,function(n){return i.throwIfCancellationRequested(),e.mapDefined(k(n,r.text),function(n){return e.isStringLiteral(n)&&n.text===r.text?t.nodeEntry(n,2):void 0})});return[{definition:{type:4,node:r},references:a}]}function tt(e,t,r,n,i,a){var o=[];return rt(e,t,r,n,!(n&&i),function(e,t,r){o.push(r||t||e)},function(){return!a}),o}function rt(t,r,n,a,o,s,c){function u(t,r){return e.firstDefined(n.getRootSymbols(t),function(i){return s(t,i,void 0,r)||(i.parent&&96&i.parent.flags&&c(i)?e.getPropertySymbolsFromBaseTypes(i.parent,i.name,n,function(e){return s(t,i,e,r)}):void 0)})}function l(t,r){var n=e.getDeclarationOfKind(t,187);return n&&e.isObjectBindingElementWithoutPropertyName(n)?e.getPropertySymbolFromBindingElement(r,n):void 0}var _=e.getContainingObjectLiteralElement(r);if(_){var d=n.getShorthandAssignmentValueSymbol(r.parent);
if(d&&a)return s(d,void 0,void 0,3);var p=n.getContextualType(_.parent),f=p&&e.firstDefined(e.getPropertySymbolsFromContextualType(_,n,p,!0),function(e){return u(e,4)});if(f)return f;var m=b(r,n),g=m&&s(m,void 0,void 0,4);if(g)return g;var v=d&&s(d,void 0,void 0,3);if(v)return v}var y=i(r,t,n);if(y){var h=s(y,void 0,void 0,1);if(h)return h}var x=u(t);if(x)return x;if(t.valueDeclaration&&e.isParameterPropertyDeclaration(t.valueDeclaration)){var D=n.getSymbolsOfParameterPropertyDeclaration(e.cast(t.valueDeclaration,e.isParameter),t.name);return e.Debug.assert(2===D.length&&!!(1&D[0].flags)&&!!(4&D[1].flags)),u(1&t.flags?D[1]:D[0])}if(!a){var S=void 0;return S=o?e.isObjectBindingElementWithoutPropertyName(r.parent)?e.getPropertySymbolFromBindingElement(n,r.parent):void 0:l(t,n),S&&u(S,4)}e.Debug.assert(a);var C=o;if(C){var S=l(t,n);return S&&u(S,4)}}function nt(t,r,n,i){var a=i.checker;return rt(r,n,a,!1,!i.options.isForRename||!!i.options.providePrefixAndSuffixTextForRename,function(r,n,i,a){return t.includes(i||n||r)?{symbol:!n||6&e.getCheckFlags(r)?r:n,kind:a}:void 0},function(e){return!(t.parents&&!t.parents.some(function(t){return X(e.parent,t,i.inheritsFromCache,a)}))})}function it(t,r){var n=e.getMeaningFromLocation(t),i=r.declarations;if(i){var a=void 0;do{a=n;for(var o=0,s=i;o<s.length;o++){var c=s[o],u=e.getMeaningFromDeclaration(c);u&n&&(n|=u)}}while(n!==a)}return n}function at(t){return 4194304&t.flags?!(e.isInterfaceDeclaration(t)||e.isTypeAliasDeclaration(t)):e.isVariableLike(t)?e.hasInitializer(t):e.isFunctionLikeDeclaration(t)?!!t.body:e.isClassLike(t)||e.isModuleOrEnumDeclaration(t)}function ot(t,r,n){var i=r.getSymbolAtLocation(t),a=r.getShorthandAssignmentValueSymbol(i.valueDeclaration);if(a)for(var o=0,s=a.getDeclarations();o<s.length;o++){var c=s[o];1&e.getMeaningFromDeclaration(c)&&n(c)}}function st(t,r,n){e.forEachChild(t,function(e){e.kind===r&&n(e),st(e,r,n)})}function ct(t){return e.tryGetClassExtendingExpressionWithTypeArguments(e.climbPastPropertyAccess(t).parent)}function ut(t,r,n){var i=e.isRightSideOfPropertyAccess(t)?t.parent:void 0,a=i&&n.getTypeAtLocation(i.expression),o=e.mapDefined(a&&(a.isUnionOrIntersection()?a.types:a.symbol===r.parent?void 0:[a]),function(e){return e.symbol&&96&e.symbol.flags?e.symbol:void 0});return 0===o.length?void 0:o}function lt(e){return e.isForRename&&e.providePrefixAndSuffixTextForRename}r.getReferencedSymbolsForNode=n;var _t;!function(e){e[e.None=0]="None",e[e.Constructor=1]="Constructor",e[e.Class=2]="Class"}(_t||(_t={}));var dt=function(){function r(t,r,n,i,a,o,s,c){this.sourceFiles=t,this.sourceFilesSet=r,this.specialSearchKind=n,this.checker=i,this.cancellationToken=a,this.searchMeaning=o,this.options=s,this.result=c,this.inheritsFromCache=e.createMap(),this.markSeenContainingTypeReference=e.nodeSeenTracker(),this.markSeenReExportRHS=e.nodeSeenTracker(),this.symbolIdToReferences=[],this.sourceFileToSeenSymbols=[]}return r.prototype.includesSourceFile=function(e){return this.sourceFilesSet.has(e.fileName)},r.prototype.getImportSearches=function(e,r){return this.importTracker||(this.importTracker=t.createImportTracker(this.sourceFiles,this.sourceFilesSet,this.checker,this.cancellationToken)),this.importTracker(e,r,!!this.options.isForRename)},r.prototype.createSearch=function(t,r,n,i){void 0===i&&(i={});var a=i.text,o=void 0===a?e.stripQuotes(e.unescapeLeadingUnderscores((e.getLocalSymbolForExportDefault(r)||f(r)||r).escapedName)):a,s=i.allSearchSymbols,c=void 0===s?[r]:s,u=e.escapeLeadingUnderscores(o),l=this.options.implementations&&t?ut(t,r,this.checker):void 0;return{symbol:r,comingFrom:n,text:o,escapedText:u,parents:l,allSearchSymbols:c,includes:function(t){return e.contains(c,t)}}},r.prototype.referenceAdder=function(r){var n=e.getSymbolId(r),i=this.symbolIdToReferences[n];return i||(i=this.symbolIdToReferences[n]=[],this.result.push({definition:{type:0,symbol:r},references:i})),function(e,r){return i.push(t.nodeEntry(e,r))}},r.prototype.addStringOrCommentReference=function(e,t){this.result.push({definition:void 0,references:[{kind:0,fileName:e,textSpan:t}]})},r.prototype.markSearchedSymbols=function(t,r){for(var n=e.getNodeId(t),i=this.sourceFileToSeenSymbols[n]||(this.sourceFileToSeenSymbols[n]=e.createMap()),a=!1,o=0,s=r;o<s.length;o++){var c=s[o];a=e.addToSeen(i,e.getSymbolId(c))||a}return a},r}();r.eachExportReference=g,r.isSymbolReferencedInFile=D,r.eachSymbolReferenceInFile=S,r.eachSignatureCall=C,r.getIntersectingMeaningFromDeclarations=it,r.getReferenceEntriesForShorthandPropertyAssignment=ot}(r=t.Core||(t.Core={}))}(t=e.FindAllReferences||(e.FindAllReferences={}))}(n||(n={}));var n;!function(e){function t(t,n,o,s,c,u,l){var _=e.hostUsesCaseSensitiveFileNames(s),d=e.createGetCanonicalFileName(_),p=r(n,o,d,l),f=r(o,n,d,l);return e.textChanges.ChangeTracker.with({host:s,formatContext:c},function(e){i(t,e,p,n,o,s.getCurrentDirectory(),_),a(t,e,p,f,s,d)})}function r(t,r,i,a){function o(t){if(i(t)===s)return r;var n=e.tryRemoveDirectoryPrefix(t,s,i);return void 0===n?void 0:r+"/"+n}var s=i(t);return function(e){var t=a&&a.tryGetSourcePosition({fileName:e,pos:0}),r=o(t?t.fileName:e);return t?void 0===r?void 0:n(t.fileName,r,e,i):r}}function n(t,r,n,i){var a=e.getRelativePathFromFile(t,r,i);return s(e.getDirectoryPath(n),a)}function i(t,r,n,i,a,o,c){function u(t){for(var r=e.isArrayLiteralExpression(t.initializer)?t.initializer.elements:[t.initializer],n=!1,i=0,a=r;i<a.length;i++){var o=a[i];n=l(o)||n}return n}function l(t){if(!e.isStringLiteral(t))return!1;var i=s(m,t.text),a=n(i);return void 0!==a?(r.replaceRangeWithText(f,_(t,f),p(a)),!0):!1}function p(t){return e.getRelativePathFromDirectory(m,t,!c)}var f=t.getCompilerOptions().configFile;if(f){var m=e.getDirectoryPath(f.fileName),g=e.getTsConfigObjectLiteralExpression(f);g&&d(g,function(t,n){switch(n){case"files":case"include":case"exclude":var s=u(t);if(!s&&"include"===n&&e.isArrayLiteralExpression(t.initializer)){var _=e.mapDefined(t.initializer.elements,function(t){return e.isStringLiteral(t)?t.text:void 0}),g=e.getFileMatcherPatterns(m,[],_,c,o);e.getRegexFromPattern(e.Debug.assertDefined(g.includeFilePattern),c).test(i)&&!e.getRegexFromPattern(e.Debug.assertDefined(g.includeFilePattern),c).test(a)&&r.insertNodeAfter(f,e.last(t.initializer.elements),e.createStringLiteral(p(a)))}break;case"compilerOptions":d(t.initializer,function(t,r){var n=e.getOptionFromName(r);n&&(n.isFilePath||"list"===n.type&&n.element.isFilePath)?u(t):"paths"===r&&d(t.initializer,function(t){if(e.isArrayLiteralExpression(t.initializer))for(var r=0,n=t.initializer.elements;r<n.length;r++){var i=n[r];l(i)}})})}})}}function a(t,r,n,i,a,o){for(var _=t.getSourceFiles(),d=function(d){var p=n(d.path),f=void 0!==p?p:d.path,m=e.getDirectoryPath(f),g=i(d.fileName),v=g||d.fileName,y=e.getDirectoryPath(v),h=void 0!==p||void 0!==g;l(d,r,function(t){if(!e.pathIsRelative(t))return void 0;var r=s(y,t),i=n(r);return void 0===i?void 0:e.ensurePathIsNonModuleName(e.getRelativePathFromDirectory(m,i,o))},function(r){var i=t.getTypeChecker().getSymbolAtLocation(r);if(i&&i.declarations.some(function(t){return e.isAmbientModule(t)}))return void 0;var o=void 0!==g?u(e.resolveModuleName(r.text,v,t.getCompilerOptions(),a),n):c(i,r,d,t,a,n);return void 0!==o&&(o.updated||h&&e.pathIsRelative(r.text))?e.moduleSpecifiers.updateModuleSpecifier(t.getCompilerOptions(),f,o.newFileName,a,_,t.redirectTargetsMap,r.text):void 0})},p=0,f=_;p<f.length;p++){var m=f[p];d(m)}}function o(t,r){return e.normalizePath(e.combinePaths(t,r))}function s(t,r){return e.ensurePathIsNonModuleName(o(t,r))}function c(t,r,n,i,a,o){if(t){var s=e.find(t.declarations,e.isSourceFile).fileName,c=o(s);return void 0===c?{newFileName:s,updated:!1}:{newFileName:c,updated:!0}}var l=a.resolveModuleNames?a.getResolvedModuleWithFailedLookupLocationsFromCache&&a.getResolvedModuleWithFailedLookupLocationsFromCache(r.text,n.fileName):i.getResolvedModuleWithFailedLookupLocationsFromCache(r.text,n.fileName);return u(l,o)}function u(t,r){function n(t){return e.endsWith(t,"/package.json")?void 0:i(t)}function i(e){var t=r(e);return t&&{newFileName:t,updated:!0}}if(!t)return void 0;if(t.resolvedModule){var a=i(t.resolvedModule.resolvedFileName);if(a)return a}var o=e.forEach(t.failedLookupLocations,n);return o?o:t.resolvedModule&&{newFileName:t.resolvedModule.resolvedFileName,updated:!1}}function l(t,r,n,i){for(var a=0,o=t.referencedFiles||e.emptyArray;a<o.length;a++){var s=o[a],c=n(s.fileName);void 0!==c&&c!==t.text.slice(s.pos,s.end)&&r.replaceRangeWithText(t,s,c)}for(var u=0,l=t.imports;u<l.length;u++){var d=l[u],c=i(d);void 0!==c&&c!==d.text&&r.replaceRangeWithText(t,_(d,t),c)}}function _(t,r){return e.createRange(t.getStart(r)+1,t.end-1)}function d(t,r){if(e.isObjectLiteralExpression(t))for(var n=0,i=t.properties;n<i.length;n++){var a=i[n];e.isPropertyAssignment(a)&&e.isStringLiteral(a.name)&&r(a,a.name.text)}}e.getEditsForFileRename=t,e.getPathUpdater=r}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,a){var o=i(r,a,t);if(o)return[v(o.fileName,o.file.fileName)];var s=e.getTouchingPropertyName(r,a);if(s===r)return void 0;var c=s.parent;if(e.isJumpStatementTarget(s)){var _=e.getTargetLabel(s.parent,s.text);return _?[f(_,"label",s.text,void 0)]:void 0}var g=t.getTypeChecker(),y=l(s,g);if(!y)return u(s,g);var h=b(g,s);if(h&&(!e.isJsxOpeningLikeElement(s.parent)||!x(h))){var D=m(g,h);if(g.getRootSymbols(y).some(function(e){return n(e,h)})||y.declarations&&y.declarations.some(function(t){return e.isVariableDeclaration(t)&&!!t.initializer&&e.isRequireCall(t.initializer,!1)}))return[D];var S=d(g,y,s)||e.emptyArray;return 99===s.kind?[D].concat(S):S.concat([D])}if(277===s.parent.kind){var C=g.getShorthandAssignmentValueSymbol(y.valueDeclaration);return C?C.declarations.map(function(e){return p(e,g,C,s)}):[]}if(e.isPropertyName(s)&&e.isBindingElement(c)&&e.isObjectBindingPattern(c.parent)&&s===(c.propertyName||c.name)){var k=e.getNameFromPropertyName(s),T=g.getTypeAtLocation(c.parent);return void 0===k?e.emptyArray:e.flatMap(T.isUnion()?T.types:[T],function(e){var t=e.getProperty(k);return t&&d(g,t,s)})}var E=e.getContainingObjectLiteralElement(s);if(E){var N=E&&g.getContextualType(E.parent);if(N)return e.flatMap(e.getPropertySymbolsFromContextualType(E,g,N,!1),function(e){return d(g,e,s)})}return d(g,y,s)}function n(t,r){return t===r.symbol||t===r.symbol.parent||!e.isCallLikeExpression(r.parent)&&t===r.parent.symbol}function i(t,r,n){var i=g(t.referencedFiles,r);if(i){var a=e.tryResolveScriptReference(n,t,i);return a&&{fileName:i.fileName,file:a}}var o=g(t.typeReferenceDirectives,r);if(o){var s=n.getResolvedTypeReferenceDirectives().get(o.fileName),a=s&&n.getSourceFile(s.resolvedFileName);return a&&{fileName:o.fileName,file:a}}var c=g(t.libReferenceDirectives,r);if(c){var a=n.getLibFileFromReference(c);return a&&{fileName:c.fileName,file:a}}return void 0}function a(t,r,n){var i=e.getTouchingPropertyName(r,n);if(i===r)return void 0;var a=t.getSymbolAtLocation(i);if(!a)return void 0;var c=t.getTypeOfSymbolAtLocation(a,i),u=s(a,c,t),l=u&&o(u,t,i);return l&&0!==l.length?l:o(c,t,i)}function o(t,r,n){return e.flatMap(!t.isUnion()||32&t.flags?[t]:t.types,function(e){return e.symbol&&d(r,e.symbol,n)})}function s(t,r,n){if(r.symbol===t||t.valueDeclaration&&r.symbol&&e.isVariableDeclaration(t.valueDeclaration)&&t.valueDeclaration.initializer===r.symbol.valueDeclaration){var i=r.getCallSignatures();if(1===i.length)return n.getReturnTypeOfSignature(e.first(i))}return void 0}function c(t,n,i){var a=r(t,n,i);if(!a||0===a.length)return void 0;var o=g(n.referencedFiles,i)||g(n.typeReferenceDirectives,i)||g(n.libReferenceDirectives,i);if(o)return{definitions:a,textSpan:e.createTextSpanFromRange(o)};var s=e.getTouchingPropertyName(n,i),c=e.createTextSpan(s.getStart(),s.getWidth());return{definitions:a,textSpan:c}}function u(t,r){if(e.isPropertyAccessExpression(t.parent)&&t.parent.name===t){var n=r.getTypeAtLocation(t.parent.expression);return e.mapDefined(n.isUnionOrIntersection()?n.types:[n],function(e){var t=r.getIndexInfoOfType(e,0);return t&&t.declaration&&m(r,t.declaration)})}}function l(e,t){var r=t.getSymbolAtLocation(e);if(r&&2097152&r.flags&&_(e,r.declarations[0])){var n=t.getAliasedSymbol(r);if(n.declarations)return n}return r}function _(e,t){if(73!==e.kind)return!1;if(e.parent===t)return!0;switch(t.kind){case 251:case 249:return!0;case 254:return 253===t.parent.kind;default:return!1}}function d(t,r,n){function i(){if(32&r.flags&&(e.isNewExpressionTarget(n)||125===n.kind)){var t=e.find(r.declarations,e.isClassLike)||e.Debug.fail("Expected declaration to have at least one class-like declaration");return o(t.members,!0)}}function a(){return e.isCallOrNewExpressionTarget(n)||e.isNameOfFunctionDeclaration(n)?o(r.declarations,!1):void 0}function o(i,a){if(!i)return void 0;var o=i.filter(a?e.isConstructorDeclaration:e.isFunctionLike);return o.length?[p(e.find(o,function(e){return!!e.body})||e.last(o),t,r,n)]:void 0}return i()||a()||e.map(r.declarations,function(e){return p(e,t,r,n)})}function p(t,r,n,i){var a=r.symbolToString(n),o=e.SymbolDisplay.getSymbolKind(r,n,i),s=n.parent?r.symbolToString(n.parent,i):"";return f(t,o,a,s)}function f(t,r,n,i){var a=e.getNameOfDeclaration(t)||t,o=a.getSourceFile();return{fileName:o.fileName,textSpan:e.createTextSpanFromNode(a,o),kind:r,name:n,containerKind:void 0,containerName:i}}function m(e,t){return p(t,e,t.symbol,t)}function g(t,r){return e.find(t,function(t){return e.textRangeContainsPositionInclusive(t,r)})}function v(t,r){return{fileName:r,textSpan:e.createTextSpanFromBounds(0,0),kind:"script",name:t,containerName:void 0,containerKind:void 0}}function y(t){var r=h(t),n=r.parent;return n&&e.isCallLikeExpression(n)&&e.getInvokedExpression(n)===r?n:void 0}function h(t){return e.isRightSideOfPropertyAccess(t)?h(t.parent):t}function b(t,r){var n=y(r),i=n&&t.getResolvedSignature(n);return e.tryCast(i&&i.declaration,function(t){return e.isFunctionLike(t)&&!e.isFunctionTypeNode(t)})}function x(e){switch(e.kind){case 158:case 167:case 162:return!0;default:return!1}}t.getDefinitionAtPosition=r,t.getReferenceAtPosition=i,t.getTypeDefinitionAtPosition=a,t.getDefinitionAndBoundSpan=c,t.findReferenceInPosition=g}(t=e.GoToDefinition||(e.GoToDefinition={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t){var r=[];return o(t,function(t){for(var i=0,a=n(t);i<a.length;i++){var o=a[i].comment;void 0!==o&&(r.length&&r.push(e.lineBreakPart()),r.push(e.textPart(o)))}}),r}function n(t){switch(t.kind){case 305:case 311:return[t];case 303:case 310:return[t,t.parent];default:return e.getJSDocCommentsAndTags(t)}}function i(t){var r=[];return o(t,function(t){for(var n=0,i=e.getJSDocTags(t);n<i.length;n++){var o=i[n];r.push({name:o.tagName.text,text:a(o)})}}),r}function a(e){function t(e){return n(e.getText())}function r(e){return n(e.map(function(e){return e.getText()}).join(", "))}function n(e){return void 0===i?e:e+" "+i}var i=e.comment;switch(e.kind){case 301:return t(e.class);case 309:return r(e.typeParameters);case 308:return t(e.typeExpression);case 310:case 303:case 311:case 305:var a=e.name;return a?t(a):i;default:return i}}function o(e,t){if(e)for(var r=0;r<e.length;r++)if(e.indexOf(e[r])===r){var n=t(e[r],r);if(n)return n}return void 0}function s(){return y||(y=e.map(b,function(e){return{name:e,kind:"keyword",kindModifiers:"",sortText:"0"}}))}function c(){return h||(h=e.map(b,function(e){return{name:"@"+e,kind:"keyword",kindModifiers:"",sortText:"0"}}))}function u(t){return{name:t,kind:"",kindModifiers:"",displayParts:[e.textPart(t)],documentation:e.emptyArray,tags:void 0,codeActions:void 0}}function l(t){if(!e.isIdentifier(t.name))return e.emptyArray;var r=t.name.text,n=t.parent,i=n.parent;return e.isFunctionLike(i)?e.mapDefined(i.parameters,function(i){if(!e.isIdentifier(i.name))return void 0;var a=i.name.text;return n.tags.some(function(r){return r!==t&&e.isJSDocParameterTag(r)&&e.isIdentifier(r.name)&&r.name.escapedText===a})||void 0!==r&&!e.startsWith(a,r)?void 0:{name:a,kind:"parameter",kindModifiers:"",sortText:"0"}}):[]}function _(t){return{name:t,kind:"parameter",kindModifiers:"",displayParts:[e.textPart(t)],documentation:e.emptyArray,tags:void 0,codeActions:void 0}}function d(t,r,n){var i=e.getTokenAtPosition(r,n),a=e.findAncestor(i,e.isJSDoc);if(a&&(void 0!==a.comment||e.length(a.tags)))return void 0;var o=i.getStart(r);if(!a&&n>o)return void 0;var s=m(i);if(!s)return void 0;var c=s.commentOwner,u=s.parameters;if(c.getStart(r)<n)return void 0;if(!u||0===u.length){var l="/** */";return{newText:l,caretOffset:3}}var _=p(r,n),d="/**"+t+_+" * ",g=d+t+f(u,e.hasJSFileExtension(r.fileName),_,t)+_+" */"+(o===n?t+_:"");return{newText:g,caretOffset:d.length}}function p(t,r){for(var n=t.text,i=e.getLineStartPositionForPosition(r,t),a=i;r>=a&&e.isWhiteSpaceSingleLine(n.charCodeAt(a));a++);return n.slice(i,a)}function f(e,t,r,n){return e.map(function(e,i){var a=e.name,o=e.dotDotDotToken,s=73===a.kind?a.text:"param"+i,c=t?o?"{...any} ":"{any} ":"";return r+" * @param "+c+s+n}).join("")}function m(t){return e.forEachAncestor(t,g)}function g(t){switch(t.kind){case 240:case 197:case 157:case 158:case 156:var r=t.parameters;return{commentOwner:t,parameters:r};case 276:return g(t.initializer);case 241:case 242:case 154:case 244:case 279:case 243:return{commentOwner:t};case 220:var n=t,i=n.declarationList.declarations,a=1===i.length&&i[0].initializer?v(i[0].initializer):void 0;return{commentOwner:t,parameters:a};case 285:return"quit";case 245:return 245===t.parent.kind?void 0:{commentOwner:t};case 205:var o=t;if(0===e.getAssignmentDeclarationKind(o))return"quit";var s=e.isFunctionLike(o.right)?o.right.parameters:e.emptyArray;return{commentOwner:t,parameters:s}}}function v(t){for(;196===t.kind;)t=t.expression;switch(t.kind){case 197:case 198:return t.parameters;case 210:var r=e.find(t.members,e.isConstructorDeclaration);return r?r.parameters:e.emptyArray}return e.emptyArray}var y,h,b=["abstract","access","alias","argument","async","augments","author","borrows","callback","class","classdesc","constant","constructor","constructs","copyright","default","deprecated","description","emits","enum","event","example","exports","extends","external","field","file","fileoverview","fires","function","generator","global","hideconstructor","host","ignore","implements","inheritdoc","inner","instance","interface","kind","lends","license","listens","member","memberof","method","mixes","module","name","namespace","override","package","param","private","property","protected","public","readonly","requires","returns","see","since","static","summary","template","this","throws","todo","tutorial","type","typedef","var","variation","version","virtual","yields"];t.getJsDocCommentsFromDeclarations=r,t.getJsDocTagsFromDeclarations=i,t.getJSDocTagNameCompletions=s,t.getJSDocTagNameCompletionDetails=u,t.getJSDocTagCompletions=c,t.getJSDocTagCompletionDetails=u,t.getJSDocParameterNameCompletions=l,t.getJSDocParameterNameCompletionDetails=_,t.getDocCommentTemplateAtPosition=d}(t=e.JsDoc||(e.JsDoc={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,i,a,o,s){var c=e.createPatternMatcher(a);if(!c)return e.emptyArray;for(var _=[],d=function(e){return i.throwIfCancellationRequested(),s&&e.isDeclarationFile?"continue":void e.getNamedDeclarations().forEach(function(t,i){n(c,i,t,r,e.fileName,_)})},p=0,f=t;p<f.length;p++){var m=f[p];d(m)}return _.sort(u),(void 0===o?_:_.slice(0,o)).map(l)}function n(e,t,r,n,a,o){var s=e.getMatchForLastSegmentOfPattern(t);if(s)for(var u=0,l=r;u<l.length;u++){var _=l[u];if(i(_,n))if(e.patternContainsDots){var d=e.getFullMatch(c(_),t);d&&o.push({name:t,fileName:a,matchKind:d.kind,isCaseSensitive:d.isCaseSensitive,declaration:_})}else o.push({name:t,fileName:a,matchKind:s.kind,isCaseSensitive:s.isCaseSensitive,declaration:_})}}function i(e,t){switch(e.kind){case 251:case 254:case 249:var r=t.getSymbolAtLocation(e.name),n=t.getAliasedSymbol(r);return r.escapedName!==n.escapedName;default:return!0}}function a(t,r){var n=e.getNameOfDeclaration(t);return!!n&&(s(n,r)||150===n.kind&&o(n.expression,r))}function o(t,r){return s(t,r)||e.isPropertyAccessExpression(t)&&(r.push(t.name.text),!0)&&o(t.expression,r)}function s(t,r){return e.isPropertyNameLiteral(t)&&(r.push(e.getTextOfIdentifierOrLiteral(t)),!0)}function c(t){var r=[],n=e.getNameOfDeclaration(t);if(n&&150===n.kind&&!o(n.expression,r))return e.emptyArray;r.shift();for(var i=e.getContainerNode(t);i;){if(!a(i,r))return e.emptyArray;i=e.getContainerNode(i)}return r.reverse()}function u(t,r){return e.compareValues(t.matchKind,r.matchKind)||e.compareStringsCaseSensitiveUI(t.name,r.name)}function l(t){var r=t.declaration,n=e.getContainerNode(r),i=n&&e.getNameOfDeclaration(n);return{name:t.name,kind:e.getNodeKind(r),kindModifiers:e.getNodeModifiers(r),matchKind:e.PatternMatchKind[t.matchKind],isCaseSensitive:t.isCaseSensitive,fileName:t.fileName,textSpan:e.createTextSpanFromNode(r),containerName:i?i.text:"",containerKind:i?e.getNodeKind(n):""}}t.getNavigateToItems=r}(t=e.NavigateTo||(e.NavigateTo={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){R=r,B=t;try{return e.map(k(c(t)),E)}finally{i()}}function n(e,t){R=t,B=e;try{return T(c(e))}finally{i()}}function i(){B=void 0,R=void 0,z=[],j=void 0,V=[]}function a(e){return e.getText(B)}function o(e){return e.node.kind}function s(e,t){e.children?e.children.push(t):e.children=[t]}function c(t){e.Debug.assert(!z.length);var r={node:t,name:void 0,additionalNodes:void 0,parent:void 0,children:void 0,indent:0};j=r;for(var n=0,i=t.statements;n<i.length;n++){var a=i[n];f(a)}return d(),e.Debug.assert(!j&&!z.length),r}function u(e){s(j,l(e))}function l(t){return{node:t,name:e.isDeclaration(t)||e.isExpression(t)?e.getNameOfDeclaration(t):void 0,additionalNodes:void 0,parent:j,children:void 0,indent:j.indent+1}}function _(e){var t=l(e);s(j,t),z.push(j),j=t}function d(){j.children&&(m(j.children,j),x(j.children)),j=z.pop()}function p(e,t){_(e),f(t),d()}function f(t){if(R.throwIfCancellationRequested(),t&&!e.isToken(t))switch(t.kind){case 158:var r=t;p(r,r.body);for(var n=0,i=r.parameters;n<i.length;n++){var a=i[n];e.isParameterPropertyDeclaration(a)&&u(a)}break;case 157:case 159:case 160:case 156:e.hasDynamicName(t)||p(t,t.body);break;case 155:case 154:e.hasDynamicName(t)||u(t);break;case 251:var o=t;o.name&&u(o.name);var s=o.namedBindings;if(s)if(252===s.kind)u(s);else for(var c=0,l=s.elements;c<l.length;c++){var m=l[c];u(m)}break;case 187:case 238:var g=t,v=g.name,y=g.initializer;e.isBindingPattern(v)?f(v):y&&L(y)?y.name?f(y):(_(t),e.forEachChild(y,f),d()):p(t,y);break;case 198:case 240:case 197:p(t,t.body);break;case 244:_(t);for(var h=0,b=t.members;h<b.length;h++){var x=b[h];P(x)||u(x)}d();break;case 241:case 210:case 242:_(t);for(var D=0,S=t.members;D<S.length;D++){var x=S[D];f(x)}d();break;case 245:p(t,F(t).body);break;case 258:case 249:case 163:case 161:case 162:case 243:u(t);break;case 205:var C=e.getAssignmentDeclarationKind(t);switch(C){case 1:case 2:case 3:case 6:return void p(t,t.right);case 4:case 5:case 0:case 7:case 8:case 9:break;default:e.Debug.assertNever(C)}default:e.hasJSDocNodes(t)&&e.forEach(t.jsDoc,function(t){e.forEach(t.tags,function(t){e.isJSDocTypeAlias(t)&&u(t)})}),e.forEachChild(t,f)}}function m(t,r){var n=e.createMap();e.filterMutate(t,function(t){var i=e.getNameOfDeclaration(t.node),o=i&&a(i);if(!o)return!0;var s=n.get(o);if(!s)return n.set(o,t),!0;if(s instanceof Array){for(var c=0,u=s;c<u.length;c++){var l=u[c];if(g(l,t,r))return!1}return s.push(t),!0}var l=s;return g(l,t,r)?!1:(n.set(o,[l,t]),!0)})}function g(e,t,r){return v(e.node,t.node,r)?(b(e,t),!0):!1}function v(t,r,n){if(t.kind!==r.kind||t.parent!==r.parent&&(!y(t,n)||!y(r,n)))return!1;switch(t.kind){case 155:case 157:case 159:case 160:return e.hasModifier(t,32)===e.hasModifier(r,32);case 245:return h(t,r);default:return!0}}function y(t,r){var n=e.isModuleBlock(t.parent)?t.parent.parent:t.parent;return n===r.node||e.contains(r.additionalNodes,n)}function h(e,t){return e.body.kind===t.body.kind&&(245!==e.body.kind||h(e.body,t.body))}function b(t,r){var n;t.additionalNodes=t.additionalNodes||[],t.additionalNodes.push(r.node),r.additionalNodes&&(n=t.additionalNodes).push.apply(n,r.additionalNodes),t.children=e.concatenate(t.children,r.children),t.children&&(m(t.children,t),x(t.children))}function x(e){e.sort(D)}function D(t,r){return e.compareStringsCaseSensitiveUI(S(t.node),S(r.node))||e.compareValues(o(t),o(r))}function S(t){if(245===t.kind)return A(t);var r=e.getNameOfDeclaration(t);if(r&&e.isPropertyName(r))return e.unescapeLeadingUnderscores(e.getPropertyNameForPropertyNameNode(r));switch(t.kind){case 197:case 198:case 210:return O(t);default:return void 0}}function C(t,r){if(245===t.kind)return A(t);if(r){var n=a(r);if(n.length>0)return n}switch(t.kind){case 285:var i=t;return e.isExternalModule(i)?'"'+e.escapeString(e.getBaseFileName(e.removeFileExtension(e.normalizePath(i.fileName))))+'"':"<global>";case 198:case 240:case 197:case 241:case 210:return 512&e.getModifierFlags(t)?"default":O(t);case 158:return"constructor";case 162:return"new()";case 161:return"()";case 163:return"[]";default:return"<unknown>"}}function k(t){function r(e){if(n(e)&&(i.push(e),e.children))for(var t=0,a=e.children;t<a.length;t++){var o=a[t];r(o)}}function n(t){function r(e){if(!e.node.body)return!1;switch(o(e.parent)){case 246:case 285:case 157:case 158:return!0;default:return n(e)}}function n(t){return e.some(t.children,function(e){var t=o(e);return 238!==t&&187!==t})}switch(o(t)){case 241:case 210:case 244:case 242:case 245:case 285:case 243:case 310:case 303:return!0;case 158:case 157:case 159:case 160:case 238:return n(t);case 198:case 240:case 197:return r(t);default:return!1}}var i=[];return r(t),i}function T(t){return{text:C(t.node,t.name),kind:e.getNodeKind(t.node),kindModifiers:I(t.node),spans:N(t),nameSpan:t.name&&w(t.name),childItems:e.map(t.children,T)}}function E(t){function r(t){return{text:C(t.node,t.name),kind:e.getNodeKind(t.node),kindModifiers:e.getNodeModifiers(t.node),spans:N(t),childItems:V,indent:0,bolded:!1,grayed:!1}}return{text:C(t.node,t.name),kind:e.getNodeKind(t.node),kindModifiers:I(t.node),spans:N(t),childItems:e.map(t.children,r)||V,indent:t.indent,bolded:!1,grayed:!1}}function N(e){var t=[w(e.node)];if(e.additionalNodes)for(var r=0,n=e.additionalNodes;r<n.length;r++){var i=n[r];t.push(w(i))}return t}function A(t){if(e.isAmbientModule(t))return e.getTextOfNode(t.name);var r=[];for(r.push(e.getTextOfIdentifierOrLiteral(t.name));t.body&&245===t.body.kind;)t=t.body,r.push(e.getTextOfIdentifierOrLiteral(t.name));return r.join(".")}function F(t){return t.body&&e.isModuleDeclaration(t.body)?F(t.body):t}function P(e){return!e.name||150===e.name.kind}function w(t){return 285===t.kind?e.createTextSpanFromRange(t):e.createTextSpanFromNode(t,B)}function I(t){return t.parent&&238===t.parent.kind&&(t=t.parent),e.getNodeModifiers(t)}function O(t){var r=t.parent;if(t.name&&e.getFullWidth(t.name)>0)return e.declarationNameToString(t.name);if(e.isVariableDeclaration(r))return e.declarationNameToString(r.name);if(e.isBinaryExpression(r)&&60===r.operatorToken.kind)return a(r.left).replace(J,"");if(e.isPropertyAssignment(r))return a(r.name);if(512&e.getModifierFlags(t))return"default";if(e.isClassLike(t))return"<class>";if(e.isCallExpression(r)){var n=M(r.expression);if(void 0!==n){var i=e.mapDefined(r.arguments,function(t){return e.isStringLiteralLike(t)?t.getText(B):void 0}).join(", ");return n+"("+i+") callback"}}return"<function>"}function M(t){if(e.isIdentifier(t))return t.text;if(e.isPropertyAccessExpression(t)){var r=M(t.expression),n=t.name.text;return void 0===r?n:r+"."+n}return void 0}function L(e){switch(e.kind){case 198:case 197:case 210:return!0;default:return!1}}var R,B,j,J=/\s+/g,z=[],V=[];t.getNavigationBarItems=r,t.getNavigationTree=n}(t=e.NavigationBar||(e.NavigationBar={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,s,c){function l(n,a){if(0!==e.length(n)){e.suppressLeadingTrivia(n[0]);var o=e.group(n,function(e){return i(e.moduleSpecifier)}),c=e.stableSort(o,function(e,t){return u(e[0].moduleSpecifier,t[0].moduleSpecifier)}),l=e.flatMap(c,function(e){return i(e[0].moduleSpecifier)?a(e):e});0===l.length?_.delete(t,n[0]):_.replaceNodeWithNodes(t,n[0],l,{leadingTriviaOption:e.textChanges.LeadingTriviaOption.Exclude,trailingTriviaOption:e.textChanges.TrailingTriviaOption.Include,suffix:e.getNewLineOrDefaultFromHost(s,r.options)});for(var d=1;d<n.length;d++)_.delete(t,n[d])}}var _=e.textChanges.ChangeTracker.fromContext({host:s,formatContext:r}),d=function(e){return a(n(e,t,c))},p=t.statements.filter(e.isImportDeclaration);l(p,d);var f=t.statements.filter(e.isExportDeclaration);l(f,o);for(var m=0,g=t.statements.filter(e.isAmbientModule);m<g.length;m++){var v=g[m];if(v.body){var y=v.body.statements.filter(e.isImportDeclaration);l(y,d);var h=v.body.statements.filter(e.isExportDeclaration);l(h,o)}}return _.getChanges()}function n(t,r,n){function i(t){return c&&t.text===o||e.FindAllReferences.Core.isSymbolReferencedInFile(t,a,r)}for(var a=n.getTypeChecker(),o=a.getJsxNamespace(r),c=!!(2&r.transformFlags),u=[],l=0,_=t;l<_.length;l++){var d=_[l],p=d.importClause;if(p){var f=p.name,m=p.namedBindings;if(f&&!i(f)&&(f=void 0),m)if(e.isNamespaceImport(m))i(m.name)||(m=void 0);else{var g=m.elements.filter(function(e){return i(e.name)});g.length<m.elements.length&&(m=g.length?e.updateNamedImports(m,g):void 0)}(f||m)&&u.push(s(d,f,m))}else u.push(d)}return u}function i(t){return void 0!==t&&e.isStringLiteralLike(t)?t.text:void 0}function a(t){function r(t){for(var r,n=[],i=[],a=[],o=0,s=t;o<s.length;o++){var c=s[o];if(void 0!==c.importClause){var u=c.importClause,l=u.name,_=u.namedBindings;l&&n.push(c),_&&(e.isNamespaceImport(_)?i.push(c):a.push(c))}else r=r||c}return{importWithoutClause:r,defaultImports:n,namespaceImports:i,namedImports:a}}if(0===t.length)return t;var n=r(t),i=n.importWithoutClause,a=n.defaultImports,o=n.namespaceImports,u=n.namedImports,_=[];if(i&&_.push(i),1===a.length&&1===o.length&&0===u.length){var d=a[0];return _.push(s(d,d.importClause.name,o[0].importClause.namedBindings)),_}for(var p=e.stableSort(o,function(e,t){return l(e.importClause.namedBindings.name,t.importClause.namedBindings.name)}),f=0,m=p;f<m.length;f++){var g=m[f];_.push(s(g,void 0,g.importClause.namedBindings))}if(0===a.length&&0===u.length)return _;var v,y=[];if(1===a.length)v=a[0].importClause.name;else for(var h=0,b=a;h<b.length;h++){var d=b[h];y.push(e.createImportSpecifier(e.createIdentifier("default"),d.importClause.name))}y.push.apply(y,e.flatMap(u,function(e){return e.importClause.namedBindings.elements}));var x=c(y),D=a.length>0?a[0]:u[0],S=0===x.length?v?void 0:e.createNamedImports(e.emptyArray):0===u.length?e.createNamedImports(x):e.updateNamedImports(u[0].importClause.namedBindings,x);return _.push(s(D,v,S)),_}function o(t){function r(e){for(var t,r=[],n=0,i=e;n<i.length;n++){var a=i[n];void 0===a.exportClause?t=t||a:r.push(a)}return{exportWithoutClause:t,namedExports:r}}if(0===t.length)return t;var n=r(t),i=n.exportWithoutClause,a=n.namedExports,o=[];if(i&&o.push(i),0===a.length)return o;var s=[];s.push.apply(s,e.flatMap(a,function(e){return e.exportClause.elements}));var u=c(s),l=a[0];return o.push(e.updateExportDeclaration(l,l.decorators,l.modifiers,e.updateNamedExports(l.exportClause,u),l.moduleSpecifier)),o}function s(t,r,n){return e.updateImportDeclaration(t,t.decorators,t.modifiers,e.updateImportClause(t.importClause,r,n),t.moduleSpecifier)}function c(t){return e.stableSort(t,function(e,t){return l(e.propertyName||e.name,t.propertyName||t.name)||l(e.name,t.name)})}function u(t,r){var n=i(t),a=i(r);return e.compareBooleans(void 0===n,void 0===a)||e.compareBooleans(e.isExternalModuleNameRelative(n),e.isExternalModuleNameRelative(a))||e.compareStringsCaseInsensitive(n,a)}function l(t,r){return e.compareStringsCaseInsensitive(t.text,r.text)
}t.organizeImports=r,t.coalesceImports=a,t.coalesceExports=o,t.compareModuleSpecifiers=u}(t=e.OrganizeImports||(e.OrganizeImports={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(e,t){var r=[];return n(e,t,r),i(e,r),r.sort(function(e,t){return e.textSpan.start-t.textSpan.start})}function n(t,r,n){function i(s){if(0!==u){r.throwIfCancellationRequested(),e.isDeclaration(s)&&o(s,t,r,n),a(s)&&o(s.parent.parent.parent,t,r,n);var l=c(s,t);l&&n.push(l),u--,e.isIfStatement(s)&&s.elseStatement&&e.isIfStatement(s.elseStatement)?(i(s.expression),i(s.thenStatement),u++,i(s.elseStatement),u--):s.forEachChild(i),u++}}function a(t){if(!e.isFunctionExpression(t)&&!e.isArrowFunction(t))return!1;var r=e.findAncestor(t,e.isVariableStatement);return!!r&&e.getSingleInitializerOfVariableStatementOrPropertyDeclaration(r)===t}for(var u=40,l=0,_=t.statements,d=_.length;d>l;){for(;d>l&&!e.isAnyImportSyntax(_[l]);)i(_[l]),l++;if(l===d)break;for(var p=l;d>l&&e.isAnyImportSyntax(_[l]);)o(_[l],t,r,n),l++;var f=l-1;f!==p&&n.push(s(e.findChildOfKind(_[p],93,t).getStart(t),_[f].getEnd(),"imports"))}}function i(t,r){for(var n=[],i=t.getLineStarts(),o=0;o<i.length;o++){var s=i[o],c=o+1===i.length?t.getEnd():i[o+1]-1,u=t.text.substring(s,c),l=a(u);if(l&&!e.isInComment(t,s))if(l[1]){var d=n.pop();d&&(d.textSpan.length=c-d.textSpan.start,d.hintSpan.length=c-d.textSpan.start,r.push(d))}else{var p=e.createTextSpanFromBounds(t.text.indexOf("//",s),c);n.push(_(p,"region",p,!1,l[2]||"#region"))}}}function a(e){return d.exec(e)}function o(t,r,n,i){function o(){_>1&&i.push(s(u,l,"comment"))}var c=e.getLeadingCommentRangesOfNode(t,r);if(c){for(var u=-1,l=-1,_=0,d=r.getFullText(),p=0,f=c;p<f.length;p++){var m=f[p],g=m.kind,v=m.pos,y=m.end;switch(n.throwIfCancellationRequested(),g){case 2:var h=d.slice(v,y);if(a(h)){o(),_=0;break}0===_&&(u=v),l=y,_++;break;case 3:o(),i.push(s(v,y,"comment")),_=0;break;default:e.Debug.assertNever(g)}}o()}}function s(t,r,n){return _(e.createTextSpanFromBounds(t,r),n)}function c(t,r){function n(t){var n=e.createTextSpanFromBounds(t.openingElement.getStart(r),t.closingElement.getEnd()),i=t.openingElement.tagName.getText(r),a="<"+i+">...</"+i+">";return _(n,"code",n,!1,a)}function i(e){return 0===e.properties.length?void 0:s(e.getStart(r),e.getEnd(),"code")}function a(t,r){return void 0===r&&(r=18),o(t,!1,!e.isArrayLiteralExpression(t.parent)&&!e.isCallExpression(t.parent),r)}function o(n,i,a,o,s){void 0===i&&(i=!1),void 0===a&&(a=!0),void 0===o&&(o=18),void 0===s&&(s=18===o?19:23);var c=e.findChildOfKind(t,o,r),u=e.findChildOfKind(t,s,r);return c&&u&&l(c,u,n,r,i,a)}switch(t.kind){case 219:if(e.isFunctionLike(t.parent))return u(t.parent,t,r);switch(t.parent.kind){case 224:case 227:case 228:case 226:case 223:case 225:case 232:case 275:return o(t.parent);case 236:var c=t.parent;if(c.tryBlock===t)return o(t.parent);if(c.finallyBlock===t)return o(e.findChildOfKind(c,89,r));default:return _(e.createTextSpanFromNode(t,r),"code")}case 246:return o(t.parent);case 241:case 210:case 242:case 244:case 247:return o(t);case 189:return a(t);case 188:return a(t,22);case 261:return n(t);case 262:case 263:return i(t.attributes)}}function u(t,r,n){var i=e.isNodeArrayMultiLine(t.parameters,n)?e.findChildOfKind(t,20,n):e.findChildOfKind(r,18,n),a=e.findChildOfKind(r,19,n);return i&&a&&l(i,a,t.parent,n,198!==t.parent.kind)}function l(t,r,n,i,a,o){void 0===a&&(a=!1),void 0===o&&(o=!0);var s=e.createTextSpanFromBounds(o?t.getFullStart():t.getStart(i),r.getEnd());return _(s,"code",e.createTextSpanFromNode(n,i),a)}function _(e,t,r,n,i){return void 0===r&&(r=e),void 0===n&&(n=!1),void 0===i&&(i="..."),{textSpan:e,kind:t,hintSpan:r,bannerText:i,autoCollapse:n}}t.collectElements=r;var d=/^\s*\/\/\s*#(end)?region(?:\s+(.*))?(?:\r)?$/}(t=e.OutliningElementsCollector||(e.OutliningElementsCollector={}))}(n||(n={}));var n;!function(e){function t(e,t){return{kind:e,isCaseSensitive:t}}function r(t){var r=e.createMap(),i=t.trim().split(".").map(function(e){return d(e.trim())});return i.some(function(e){return!e.subWordTextChunks.length})?void 0:{getFullMatch:function(e,t){return n(e,t,i,r)},getMatchForLastSegmentOfPattern:function(t){return o(t,e.last(i),r)},patternContainsDots:i.length>1}}function n(t,r,n,i){var a=o(r,e.last(n),i);if(!a)return void 0;if(n.length-1>t.length)return void 0;for(var c,u=n.length-2,l=t.length-1;u>=0;u-=1,l-=1)c=s(c,o(t[l],n[u],i));return c}function i(e,t){var r=t.get(e);return r||t.set(e,r=D(e)),r}function a(r,n,a){var o=m(r,n.textLowerCase);if(0===o)return t(n.text.length===r.length?F.exact:F.prefix,e.startsWith(r,n.text));if(n.isLowerCase){if(-1===o)return void 0;for(var s=i(r,a),c=0,l=s;c<l.length;c++){var d=l[c];if(u(r,d,n.text,!0))return t(F.substring,u(r,d,n.text,!1))}if(n.text.length<r.length&&p(r.charCodeAt(o)))return t(F.substring,!1)}else{if(r.indexOf(n.text)>0)return t(F.substring,!0);if(n.characterSpans.length>0){var f=i(r,a),g=_(r,f,n,!1)?!0:_(r,f,n,!0)?!1:void 0;if(void 0!==g)return t(F.camelCase,g)}}}function o(e,t,r){if(A(t.totalTextChunk.text,function(e){return 32!==e&&42!==e})){var n=a(e,t.totalTextChunk,r);if(n)return n}for(var i,o=t.subWordTextChunks,c=0,u=o;c<u.length;c++){var l=u[c];i=s(i,a(e,l,r))}return i}function s(t,r){return e.min(t,r,c)}function c(t,r){return void 0===t?1:void 0===r?-1:e.compareValues(t.kind,r.kind)||e.compareBooleans(!t.isCaseSensitive,!r.isCaseSensitive)}function u(e,t,r,n,i){return void 0===i&&(i={start:0,length:r.length}),i.length<=t.length&&N(0,i.length,function(a){return l(r.charCodeAt(i.start+a),e.charCodeAt(t.start+a),n)})}function l(e,t,r){return r?g(e)===g(t):e===t}function _(t,r,n,i){for(var a,o,s=n.characterSpans,c=0,l=0;;){if(l===s.length)return!0;if(c===r.length)return!1;for(var _=r[c],d=!1;l<s.length;l++){var f=s[l];if(d&&(!p(n.text.charCodeAt(s[l-1].start))||!p(n.text.charCodeAt(s[l].start))))break;if(!u(t,_,n.text,i,f))break;d=!0,a=void 0===a?c:a,o=void 0===o?!0:o,_=e.createTextSpan(_.start+f.length,_.length-f.length)}d||void 0===o||(o=!1),c++}}function d(e){return{totalTextChunk:b(e),subWordTextChunks:h(e)}}function p(t){if(t>=65&&90>=t)return!0;if(127>t||!e.isUnicodeIdentifierStart(t,8))return!1;var r=String.fromCharCode(t);return r===r.toUpperCase()}function f(t){if(t>=97&&122>=t)return!0;if(127>t||!e.isUnicodeIdentifierStart(t,8))return!1;var r=String.fromCharCode(t);return r===r.toLowerCase()}function m(e,t){for(var r=e.length-t.length,n=function(r){return A(t,function(t,n){return g(e.charCodeAt(n+r))===t})?{value:r}:void 0},i=0;r>=i;i++){var a=n(i);if("object"==typeof a)return a.value}return-1}function g(e){return e>=65&&90>=e?97+(e-65):127>e?e:String.fromCharCode(e).toLowerCase().charCodeAt(0)}function v(e){return e>=48&&57>=e}function y(e){return p(e)||f(e)||v(e)||95===e||36===e}function h(e){for(var t=[],r=0,n=0,i=0;i<e.length;i++){var a=e.charCodeAt(i);y(a)?(0===n&&(r=i),n++):n>0&&(t.push(b(e.substr(r,n))),n=0)}return n>0&&t.push(b(e.substr(r,n))),t}function b(e){var t=e.toLowerCase();return{text:e,textLowerCase:t,isLowerCase:e===t,characterSpans:x(e)}}function x(e){return S(e,!1)}function D(e){return S(e,!0)}function S(t,r){for(var n=[],i=0,a=1;a<t.length;a++){var o=v(t.charCodeAt(a-1)),s=v(t.charCodeAt(a)),c=E(t,r,a),u=r&&T(t,a,i);(C(t.charCodeAt(a-1))||C(t.charCodeAt(a))||o!==s||c||u)&&(k(t,i,a)||n.push(e.createTextSpan(i,a-i)),i=a)}return k(t,i,t.length)||n.push(e.createTextSpan(i,t.length-i)),n}function C(e){switch(e){case 33:case 34:case 35:case 37:case 38:case 39:case 40:case 41:case 42:case 44:case 45:case 46:case 47:case 58:case 59:case 63:case 64:case 91:case 92:case 93:case 95:case 123:case 125:return!0}return!1}function k(e,t,r){return A(e,function(e){return C(e)&&95!==e},t,r)}function T(e,t,r){return t!==r&&t+1<e.length&&p(e.charCodeAt(t))&&f(e.charCodeAt(t+1))&&A(e,p,r,t)}function E(e,t,r){var n=p(e.charCodeAt(r-1)),i=p(e.charCodeAt(r));return i&&(!t||!n)}function N(e,t,r){for(var n=e;t>n;n++)if(!r(n))return!1;return!0}function A(e,t,r,n){return void 0===r&&(r=0),void 0===n&&(n=e.length),N(r,n,function(r){return t(e.charCodeAt(r),r)})}var F;!function(e){e[e.exact=0]="exact",e[e.prefix=1]="prefix",e[e.substring=2]="substring",e[e.camelCase=3]="camelCase"}(F=e.PatternMatchKind||(e.PatternMatchKind={})),e.createPatternMatcher=r,e.breakIntoCharacterSpans=x,e.breakIntoWordSpans=D}(n||(n={}));var n;!function(e){function t(t,r,n){function i(){return g=v,v=e.scanner.scan(),18===v?b++:19===v&&b--,v}function a(){var t=e.scanner.getTokenValue(),r=e.scanner.getTokenPos();return{fileName:t,pos:r,end:r+t.length}}function o(){m||(m=[]),m.push({ref:a(),depth:b})}function s(){h.push(a()),c()}function c(){0===b&&(x=!0)}function u(){var t=e.scanner.getToken();return 126===t?(t=i(),131===t&&(t=i(),10===t&&o()),!0):!1}function l(){if(24===g)return!1;var t=e.scanner.getToken();if(93===t){if(t=i(),20===t){if(t=i(),10===t)return s(),!0}else{if(10===t)return s(),!0;if(73===t||e.isKeyword(t))if(t=i(),145===t){if(t=i(),10===t)return s(),!0}else if(60===t){if(d(!0))return!0}else{if(27!==t)return!0;t=i()}if(18===t){for(t=i();19!==t&&1!==t;)t=i();19===t&&(t=i(),145===t&&(t=i(),10===t&&s()))}else 40===t&&(t=i(),120===t&&(t=i(),(73===t||e.isKeyword(t))&&(t=i(),145===t&&(t=i(),10===t&&s()))))}return!0}return!1}function _(){var t=e.scanner.getToken();if(86===t){if(c(),t=i(),18===t){for(t=i();19!==t&&1!==t;)t=i();19===t&&(t=i(),145===t&&(t=i(),10===t&&s()))}else if(40===t)t=i(),145===t&&(t=i(),10===t&&s());else if(93===t&&(t=i(),(73===t||e.isKeyword(t))&&(t=i(),60===t&&d(!0))))return!0;return!0}return!1}function d(t){var r=t?i():e.scanner.getToken();return 135===r?(r=i(),20===r&&(r=i(),10===r&&s()),!0):!1}function p(){var t=e.scanner.getToken();if(73===t&&"define"===e.scanner.getTokenValue()){if(t=i(),20!==t)return!0;if(t=i(),10===t){if(t=i(),27!==t)return!0;t=i()}if(22!==t)return!0;for(t=i();23!==t&&1!==t;)10===t&&s(),t=i();return!0}return!1}function f(){for(e.scanner.setText(t),i();;){if(1===e.scanner.getToken())break;u()||l()||_()||n&&(d(!1)||p())||i()}e.scanner.setText(void 0)}void 0===r&&(r=!0),void 0===n&&(n=!1);var m,g,v,y={languageVersion:1,pragmas:void 0,checkJsDirective:void 0,referencedFiles:[],typeReferenceDirectives:[],libReferenceDirectives:[],amdDependencies:[],hasNoDefaultLib:void 0,moduleName:void 0},h=[],b=0,x=!1;if(r&&f(),e.processCommentPragmas(y,t),e.processPragmasIntoFields(y,e.noop),x){if(m)for(var D=0,S=m;D<S.length;D++){var C=S[D];h.push(C.ref)}return{referencedFiles:y.referencedFiles,typeReferenceDirectives:y.typeReferenceDirectives,libReferenceDirectives:y.libReferenceDirectives,importedFiles:h,isLibFile:!!y.hasNoDefaultLib,ambientExternalModules:void 0}}var k=void 0;if(m)for(var T=0,E=m;T<E.length;T++){var C=E[T];0===C.depth?(k||(k=[]),k.push(C.ref.fileName)):h.push(C.ref)}return{referencedFiles:y.referencedFiles,typeReferenceDirectives:y.typeReferenceDirectives,libReferenceDirectives:y.libReferenceDirectives,importedFiles:h,isLibFile:!!y.hasNoDefaultLib,ambientExternalModules:k}}e.preProcessFile=t}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,i,a){var s=e.getTouchingPropertyName(r,i),u=s&&c(s)?n(s,t.getTypeChecker(),r,function(e){return t.isSourceFileDefaultLibrary(e.getSourceFile())},a):void 0;return u||o(e.Diagnostics.You_cannot_rename_this_element)}function n(t,r,n,s,c){var u=r.getSymbolAtLocation(t);if(u){var l=u.declarations;if(l&&0!==l.length){if(l.some(s))return o(e.Diagnostics.You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library);if(e.isIdentifier(t)&&81===t.originalKeywordKind&&1536&u.parent.flags)return void 0;if(e.isStringLiteralLike(t)&&e.tryGetImportFromModuleSpecifier(t))return c&&c.allowRenameOfImportPath?i(t,n,u):void 0;var _=e.SymbolDisplay.getSymbolKind(r,u,t),d=e.isImportOrExportSpecifierName(t)||e.isStringOrNumericLiteralLike(t)&&150===t.parent.kind?e.stripQuotes(e.getTextOfIdentifierOrLiteral(t)):void 0,p=d||r.symbolToString(u),f=d||r.getFullyQualifiedName(u);return a(p,f,_,e.SymbolDisplay.getSymbolModifiers(u),t,n)}}}function i(t,r,n){if(!e.isExternalModuleNameRelative(t.text))return o(e.Diagnostics.You_cannot_rename_a_module_via_a_global_import);var i=e.find(n.declarations,e.isSourceFile);if(!i)return void 0;var a=e.endsWith(t.text,"/index")||e.endsWith(t.text,"/index.js")?void 0:e.tryRemoveSuffix(e.removeFileExtension(i.fileName),"/index"),s=void 0===a?i.fileName:a,c=void 0===a?"module":"directory",u=t.text.lastIndexOf("/")+1,l=e.createTextSpan(t.getStart(r)+1+u,t.text.length-u);return{canRename:!0,fileToRename:s,kind:c,displayName:s,fullDisplayName:s,kindModifiers:"",triggerSpan:l}}function a(e,t,r,n,i,a){return{canRename:!0,fileToRename:void 0,kind:r,displayName:e,fullDisplayName:t,kindModifiers:n,triggerSpan:s(i,a)}}function o(t){return{canRename:!1,localizedErrorMessage:e.getLocaleSpecificMessage(t)}}function s(t,r){var n=t.getStart(r),i=t.getWidth(r);return 10===t.kind&&(n+=1,i-=2),e.createTextSpan(n,i)}function c(t){switch(t.kind){case 73:case 10:case 101:return!0;case 8:return e.isLiteralNameOfPropertyDeclarationOrIndexAccess(t);default:return!1}}t.getRenameInfo=r}(t=e.Rename||(e.Rename={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){function o(t,r){if(t!==r){var n=e.createTextSpanFromBounds(t,r);s&&e.textSpansEqual(n,s.textSpan)||(s=i({textSpan:n},s&&{parent:s}))}}var s={textSpan:e.createTextSpanFromBounds(r.getFullStart(),r.getEnd())},c=r;e:for(;;){var _=a(c);if(!_.length)break;for(var d=0;d<_.length;d++){var p=_[d-1],f=_[d],m=_[d+1];if(f.getStart(r)>t)break e;if(n(t,f,m)){if(e.isBlock(f)||e.isTemplateSpan(f)||e.isTemplateHead(f)||p&&e.isTemplateHead(p)||e.isVariableDeclarationList(f)&&e.isVariableStatement(c)||e.isSyntaxList(f)&&e.isVariableDeclarationList(c)||e.isVariableDeclaration(f)&&e.isSyntaxList(c)&&1===_.length){c=f;break}if(e.isTemplateSpan(c)&&m&&e.isTemplateMiddleOrTemplateTail(m)){var g=f.getFullStart()-"${".length,v=m.getStart()+"}".length;o(g,v)}var y=e.isSyntaxList(f)&&u(p)&&l(m)&&!e.positionsAreOnSameLine(p.getStart(),m.getStart(),r),h=e.hasJSDocNodes(f)&&f.jsDoc[0].getStart(),b=y?p.getEnd():f.getStart(),x=y?m.getStart():f.getEnd();e.isNumber(h)&&o(h,x),o(b,x),(e.isStringLiteral(f)||e.isTemplateLiteral(f))&&o(b+1,x-1),c=f;break}}}return s}function n(t,r,n){if(e.Debug.assert(r.pos<=t),t<r.end)return!0;var i=r.getEnd(),a=n&&n.getStart();return i===t?t!==a:!1}function a(t){if(e.isSourceFile(t))return o(t.getChildAt(0).getChildren(),_);if(e.isMappedTypeNode(t)){var r=t.getChildren(),n=r[0],i=r.slice(1),a=e.Debug.assertDefined(i.pop());e.Debug.assertEqual(n.kind,18),e.Debug.assertEqual(a.kind,19);var u=o(i,function(e){return e===t.readonlyToken||134===e.kind||e===t.questionToken||56===e.kind}),l=o(u,function(e){var t=e.kind;return 22===t||151===t||23===t});return[n,c(s(l,function(e){var t=e.kind;return 57===t})),a]}if(e.isPropertySignature(t)){var i=o(t.getChildren(),function(r){return r===t.name||e.contains(t.modifiers,r)});return s(i,function(e){var t=e.kind;return 57===t})}if(e.isParameter(t)){var d=o(t.getChildren(),function(e){return e===t.dotDotDotToken||e===t.name}),p=o(d,function(e){return e===d[0]||e===t.questionToken});return s(p,function(e){var t=e.kind;return 60===t})}return e.isBindingElement(t)?s(t.getChildren(),function(e){var t=e.kind;return 60===t}):t.getChildren()}function o(e,t){for(var r,n=[],i=0,a=e;i<a.length;i++){var o=a[i];t(o)?(r=r||[],r.push(o)):(r&&(n.push(c(r)),r=void 0),n.push(o))}return r&&n.push(c(r)),n}function s(t,r,n){if(void 0===n&&(n=!0),t.length<2)return t;var i=e.findIndex(t,r);if(-1===i)return t;var a=t.slice(0,i),o=t[i],s=e.last(t),u=n&&26===s.kind,l=t.slice(i+1,u?t.length-1:void 0),_=e.compact([a.length?c(a):void 0,o,l.length?c(l):void 0]);return u?_.concat(s):_}function c(t){e.Debug.assertGreaterThanOrEqual(t.length,1);var r=e.createNode(312,t[0].pos,e.last(t).end);return r._children=t,r}function u(e){var t=e&&e.kind;return 18===t||22===t||20===t||263===t}function l(e){var t=e&&e.kind;return 19===t||23===t||21===t||264===t}t.getSmartSelectionRange=r;var _=e.or(e.isImportDeclaration,e.isImportEqualsDeclaration)}(t=e.SmartSelectionRange||(e.SmartSelectionRange={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,i,o,s){var c=t.getTypeChecker(),u=e.findTokenOnLeftOfPosition(r,i);if(!u)return void 0;var l=!!o&&"characterTyped"===o.kind;if(l&&(e.isInString(r,i,u)||e.isInComment(r,i)))return void 0;var _=!!o&&"invoked"===o.kind,d=S(u,i,r,c,_);if(!d)return void 0;s.throwIfCancellationRequested();var p=n(d,c,r,u,l);return s.throwIfCancellationRequested(),p?c.runWithCancellationToken(s,function(e){return 0===p.kind?E(p.candidates,p.resolvedSignature,d,r,e):N(p.symbol,d,r,e)}):e.isSourceFileJS(r)?a(d,t,s):void 0}function n(t,r,n,a,s){var c=t.invocation,u=t.argumentCount;switch(c.kind){case 0:if(s&&!i(a,c.node,n))return void 0;var l=[],_=r.getResolvedSignatureForSignatureHelp(c.node,l,u);return 0===l.length?void 0:{kind:0,candidates:l,resolvedSignature:_};case 1:var d=c.called;if(s&&!o(a,n,e.isIdentifier(d)?d.parent:d))return void 0;var l=e.getPossibleGenericSignatures(d,u,r);if(0!==l.length)return{kind:0,candidates:l,resolvedSignature:e.first(l)};var p=r.getSymbolAtLocation(d);return p&&{kind:1,symbol:p};case 2:return{kind:0,candidates:[c.signature],resolvedSignature:c.signature};default:return e.Debug.assertNever(c)}}function i(t,r,n){if(!e.isCallOrNewExpression(r))return!1;var i=r.getChildren(n);switch(t.kind){case 20:return e.contains(i,t);case 27:var a=e.findContainingList(t);return!!a&&e.contains(i,a);case 28:return o(t,n,r.expression);default:return!1}}function a(t,r,n){if(2===t.invocation.kind)return void 0;var i=k(t.invocation),a=e.isIdentifier(i)?i.text:e.isPropertyAccessExpression(i)?i.name.text:void 0,o=r.getTypeChecker();return void 0===a?void 0:e.firstDefined(r.getSourceFiles(),function(r){return e.firstDefined(r.getNamedDeclarations().get(a),function(e){var i=e.symbol&&o.getTypeOfSymbolAtLocation(e.symbol,e),a=i&&i.getCallSignatures();return a&&a.length?o.runWithCancellationToken(n,function(e){return E(a,a[0],t,r,e)}):void 0})})}function o(t,r,n){for(var i=t.getFullStart(),a=t.parent;a;){var o=e.findPrecedingToken(i,r,a,!0);if(o)return e.rangeContainsRange(n,o);a=a.parent}return e.Debug.fail("Could not find preceding token")}function s(e,t,r){var n=l(e,t,r);return!n||n.isTypeParameterList||0!==n.invocation.kind?void 0:{invocation:n.invocation.node,argumentCount:n.argumentCount,argumentIndex:n.argumentIndex}}function c(t,r){var n=u(t,r);if(!n)return void 0;var i=n.list,a=n.argumentIndex,o=y(i);0!==a&&e.Debug.assertLessThan(a,o);var s=x(i,r);return{list:i,argumentIndex:a,argumentCount:o,argumentsSpan:s}}function u(t,r){if(28===t.kind||20===t.kind)return{list:C(t.parent,t,r),argumentIndex:0};var n=e.findContainingList(t);return n&&{list:n,argumentIndex:v(n,t)}}function l(t,r,n){var i=t.parent;if(e.isCallOrNewExpression(i)){var a=i,o=c(t,n);if(!o)return void 0;var s=o.list,u=o.argumentIndex,l=o.argumentCount,_=o.argumentsSpan,d=!!i.typeArguments&&i.typeArguments.pos===s.pos;return{isTypeParameterList:d,invocation:{kind:0,node:a},argumentsSpan:_,argumentIndex:u,argumentCount:l}}if(e.isNoSubstitutionTemplateLiteral(t)&&e.isTaggedTemplateExpression(i))return e.isInsideTemplateLiteral(t,r,n)?b(i,0,n):void 0;if(e.isTemplateHead(t)&&194===i.parent.kind){var p=i,f=p.parent;e.Debug.assert(207===p.kind);var u=e.isInsideTemplateLiteral(t,r,n)?0:1;return b(f,u,n)}if(e.isTemplateSpan(i)&&e.isTaggedTemplateExpression(i.parent.parent)){var m=i,f=i.parent.parent;if(e.isTemplateTail(t)&&!e.isInsideTemplateLiteral(t,r,n))return void 0;var g=m.parent.templateSpans.indexOf(m),u=h(g,t,r,n);return b(f,u,n)}if(e.isJsxOpeningLikeElement(i)){var v=i.attributes.pos,y=e.skipTrivia(n.text,i.attributes.end,!1);return{isTypeParameterList:!1,invocation:{kind:0,node:i},argumentsSpan:e.createTextSpan(v,y-v),argumentIndex:0,argumentCount:1}}var x=e.getPossibleTypeArgumentsInfo(t,n);if(x){var D=x.called,S=x.nTypeArguments,a={kind:1,called:D},_=e.createTextSpanFromBounds(D.getStart(n),t.end);return{isTypeParameterList:!0,invocation:a,argumentsSpan:_,argumentIndex:S,argumentCount:S+1}}return void 0}function _(e,t,r,n){return f(e,t,r,n)||l(e,t,r)}function d(t){return e.isBinaryExpression(t.parent)?d(t.parent):t}function p(t){return e.isBinaryExpression(t.left)?p(t.left)+1:2}function f(t,r,n,i){var a=m(t,n,i);if(!a)return void 0;var o=a.contextualType,s=a.argumentIndex,c=a.argumentCount,u=a.argumentsSpan,l=o.getCallSignatures();if(1!==l.length)return void 0;var _={kind:2,signature:e.first(l),node:t,symbol:g(o.symbol)};return{isTypeParameterList:!1,invocation:_,argumentsSpan:u,argumentIndex:s,argumentCount:c}}function m(t,r,n){if(20!==t.kind&&27!==t.kind)return void 0;var i=t.parent;switch(i.kind){case 196:case 157:case 197:case 198:var a=c(t,r);if(!a)return void 0;var o=a.argumentIndex,s=a.argumentCount,u=a.argumentsSpan,l=e.isMethodDeclaration(i)?n.getContextualTypeForObjectLiteralElement(i):n.getContextualType(i);return l&&{contextualType:l,argumentIndex:o,argumentCount:s,argumentsSpan:u};case 205:var _=d(i),f=n.getContextualType(_),m=20===t.kind?0:p(i)-1,g=p(_);return f&&{contextualType:f,argumentIndex:m,argumentCount:g,argumentsSpan:e.createTextSpanFromNode(i)};default:return void 0}}function g(t){return"__type"===t.name?e.firstDefined(t.declarations,function(t){return e.isFunctionTypeNode(t)?t.parent.symbol:void 0})||t:t}function v(e,t){for(var r=0,n=0,i=e.getChildren();n<i.length;n++){var a=i[n];if(a===t)break;27!==a.kind&&r++}return r}function y(t){var r=t.getChildren(),n=e.countWhere(r,function(e){return 27!==e.kind});return r.length>0&&27===e.last(r).kind&&n++,n}function h(t,r,n,i){return e.Debug.assert(n>=r.getStart(),"Assumed 'position' could not occur before node."),e.isTemplateLiteralToken(r)?e.isInsideTemplateLiteral(r,n,i)?0:t+2:t+1}function b(t,r,n){var i=e.isNoSubstitutionTemplateLiteral(t.template)?1:t.template.templateSpans.length+1;return 0!==r&&e.Debug.assertLessThan(r,i),{isTypeParameterList:!1,invocation:{kind:0,node:t},argumentsSpan:D(t,n),argumentIndex:r,argumentCount:i}}function x(t,r){var n=t.getFullStart(),i=e.skipTrivia(r.text,t.getEnd(),!1);return e.createTextSpan(n,i-n)}function D(t,r){var n=t.template,i=n.getStart(),a=n.getEnd();if(207===n.kind){var o=e.last(n.templateSpans);0===o.literal.getFullWidth()&&(a=e.skipTrivia(r.text,a,!1))}return e.createTextSpan(i,a-i)}function S(t,r,n,i,a){for(var o=function(t){e.Debug.assert(e.rangeContainsRange(t.parent,t),"Not a subspan",function(){return"Child: "+e.Debug.formatSyntaxKind(t.kind)+", parent: "+e.Debug.formatSyntaxKind(t.parent.kind)});var a=_(t,r,n,i);return a?{value:a}:void 0},s=t;!e.isSourceFile(s)&&(a||!e.isBlock(s));s=s.parent){var c=o(s);if("object"==typeof c)return c.value}return void 0}function C(t,r,n){var i=t.getChildren(n),a=i.indexOf(r);return e.Debug.assert(a>=0&&i.length>a+1),i[a+1]}function k(t){return 0===t.kind?e.getInvokedExpression(t.node):t.called}function T(e){return 0===e.kind?e.node:1===e.kind?e.called:e.node}function E(t,r,n,i,a){var o=n.isTypeParameterList,s=n.argumentCount,c=n.argumentsSpan,u=n.invocation,l=n.argumentIndex,_=T(u),d=2===u.kind?u.symbol:a.getSymbolAtLocation(k(u)),p=d?e.symbolToDisplayParts(a,d,void 0,void 0):e.emptyArray,f=t.map(function(e){return F(e,p,o,a,_,i)});0!==l&&e.Debug.assertLessThan(l,s);var m=t.indexOf(r);return e.Debug.assert(-1!==m),{items:f,applicableSpan:c,selectedItemIndex:m,argumentIndex:l,argumentCount:s}}function N(e,t,r,n){var i=t.argumentCount,a=t.argumentsSpan,o=t.invocation,s=t.argumentIndex,c=n.getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(e);if(!c)return void 0;var u=[A(e,c,n,T(o),r)];return{items:u,applicableSpan:a,selectedItemIndex:0,argumentIndex:s,argumentCount:i}}function A(t,r,n,i,a){var o=e.symbolToDisplayParts(n,t),s=e.createPrinter({removeComments:!0}),c=r.map(function(e){return M(e,n,i,a,s)}),u=t.getDocumentationComment(n),l=t.getJsDocTags(),_=o.concat([e.punctuationPart(28)]);return{isVariadic:!1,prefixDisplayParts:_,suffixDisplayParts:[e.punctuationPart(30)],separatorDisplayParts:j,parameters:c,documentation:u,tags:l}}function F(e,t,r,n,i,a){var o=(r?w:I)(e,n,i,a),s=o.isVariadic,c=o.parameters,u=o.prefix,l=o.suffix,_=t.concat(u),d=l.concat(P(e,i,n)),p=e.getDocumentationComment(n),f=e.getJsDocTags();return{isVariadic:s,prefixDisplayParts:_,suffixDisplayParts:d,separatorDisplayParts:j,parameters:c,documentation:p,tags:f}}function P(t,r,n){return e.mapToDisplayParts(function(e){e.writePunctuation(":"),e.writeSpace(" ");var i=n.getTypePredicateOfSignature(t);i?n.writeTypePredicate(i,r,void 0,e):n.writeType(n.getReturnTypeOfSignature(t),r,void 0,e)})}function w(t,r,n,i){var a=(t.target||t).typeParameters,o=e.createPrinter({removeComments:!0}),s=(a||e.emptyArray).map(function(e){return M(e,r,n,i,o)}),c=e.mapToDisplayParts(function(a){var s=t.thisParameter?[r.symbolToParameterDeclaration(t.thisParameter,n,B)]:[],c=e.createNodeArray(s.concat(r.getExpandedParameters(t).map(function(e){return r.symbolToParameterDeclaration(e,n,B)})));o.writeList(2576,c,i,a)});return{isVariadic:!1,parameters:s,prefix:[e.punctuationPart(28)],suffix:[e.punctuationPart(30)].concat(c)}}function I(t,r,n,i){var a=r.hasEffectiveRestParameter(t),o=e.createPrinter({removeComments:!0}),s=e.mapToDisplayParts(function(a){if(t.typeParameters&&t.typeParameters.length){var s=e.createNodeArray(t.typeParameters.map(function(e){return r.typeParameterToDeclaration(e,n)}));o.writeList(53776,s,i,a)}}),c=r.getExpandedParameters(t).map(function(e){return O(e,r,n,i,o)});return{isVariadic:a,parameters:c,prefix:s.concat([e.punctuationPart(20)]),suffix:[e.punctuationPart(21)]}}function O(t,r,n,i,a){var o=e.mapToDisplayParts(function(e){var o=r.symbolToParameterDeclaration(t,n,B);a.writeNode(4,o,i,e)}),s=r.isOptionalParameter(t.valueDeclaration);return{name:t.name,documentation:t.getDocumentationComment(r),displayParts:o,isOptional:s}}function M(t,r,n,i,a){var o=e.mapToDisplayParts(function(e){var o=r.typeParameterToDeclaration(t,n);a.writeNode(4,o,i,e)});return{name:t.symbol.name,documentation:t.symbol.getDocumentationComment(r),displayParts:o,isOptional:!1}}var L;!function(e){e[e.Call=0]="Call",e[e.TypeArgs=1]="TypeArgs",e[e.Contextual=2]="Contextual"}(L||(L={})),t.getSignatureHelpItems=r;var R;!function(e){e[e.Candidate=0]="Candidate",e[e.Type=1]="Type"}(R||(R={})),t.getArgumentInfoForCompletions=s;var B=70246400,j=[e.punctuationPart(27),e.spacePart()]}(t=e.SignatureHelp||(e.SignatureHelp={}))}(n||(n={}));var n;!function(e){function t(t){function r(t){return e.toPath(t,p,d)}function n(n,i){var a=r(n),o=m.get(a);if(o)return o;var s;if(t.getDocumentPositionMapper)s=t.getDocumentPositionMapper(n,i);else if(t.readFile){var c=u(n);s=c&&e.getDocumentPositionMapper({getSourceFileLike:u,getCanonicalFileName:d,log:function(e){return t.log(e)}},n,e.getLineInfo(c.text,e.getLineStarts(c)),function(e){return!t.fileExists||t.fileExists(e)?t.readFile(e):void 0})}return m.set(a,s||e.identitySourceMapConsumer),s||e.identitySourceMapConsumer}function a(t){if(!e.isDeclarationFileName(t.fileName))return void 0;var r=s(t.fileName);if(!r)return void 0;var i=n(t.fileName).getSourcePosition(t);return i&&i!==t?a(i)||i:void 0}function o(r){if(e.isDeclarationFileName(r.fileName))return void 0;var i=s(r.fileName);if(!i)return void 0;var a=t.getProgram(),o=a.getCompilerOptions(),c=o.outFile||o.out,u=c?e.removeFileExtension(c)+".d.ts":e.getDeclarationEmitOutputFilePathWorker(r.fileName,a.getCompilerOptions(),p,a.getCommonSourceDirectory(),d);if(void 0===u)return void 0;var l=n(u,r.fileName).getGeneratedPosition(r);return l===r?void 0:l}function s(e){var n=t.getProgram();if(!n)return void 0;var i=r(e),a=n.getSourceFileByPath(i);return a&&a.resolvedPath===i?a:void 0}function c(e){var n=r(e),a=f.get(n);if(void 0!==a)return a?a:void 0;if(!t.readFile||t.fileExists&&!t.fileExists(n))return void f.set(n,!1);var o=t.readFile(n),s=o?i(o):!1;return f.set(n,s),s?s:void 0}function u(e){return t.getSourceFileLike?t.getSourceFileLike(e):s(e)||c(e)}function l(e,t){var r=u(e);return r.getLineAndCharacterOfPosition(t)}function _(){f.clear(),m.clear()}var d=e.createGetCanonicalFileName(t.useCaseSensitiveFileNames()),p=t.getCurrentDirectory(),f=e.createMap(),m=e.createMap();return{tryGetSourcePosition:a,tryGetGeneratedPosition:o,toLineColumnOffset:l,clearCache:_}}function r(t,r,i,o){var s=e.tryGetSourceMappingURL(i);if(s){var c=a.exec(s);if(c){if(c[1]){var u=c[1];return n(t,e.base64decode(e.sys,u),r)}s=void 0}}var l=[];s&&l.push(s),l.push(r+".map");for(var _=s&&e.getNormalizedAbsolutePath(s,e.getDirectoryPath(r)),d=0,p=l;d<p.length;d++){var f=p[d],m=e.getNormalizedAbsolutePath(f,e.getDirectoryPath(r)),g=o(m,_);if(e.isString(g))return n(t,g,m);if(void 0!==g)return g||void 0}return void 0}function n(t,r,n){var i=e.tryParseRawSourceMap(r);return i&&i.sources&&i.file&&i.mappings?e.createDocumentPositionMapper(t,i,n):void 0}function i(t,r){return{text:t,lineMap:r,getLineAndCharacterOfPosition:function(t){return e.computeLineAndCharacterOfPosition(e.getLineStarts(this),t)}}}var a=/^data:(?:application\/json(?:;charset=[uU][tT][fF]-8);base64,([A-Za-z0-9+\/=]+)$)?/;e.getSourceMapper=t,e.getDocumentPositionMapper=r}(n||(n={}));var n;!function(e){function t(t,n,o){function s(r){if(_)switch(r.kind){case 197:var n=e.getDeclarationOfExpando(r);if(n){var i=n.symbol;if(i&&(i.exports&&i.exports.size||i.members&&i.members.size)){u.push(e.createDiagnosticForNode(e.isVariableDeclaration(r.parent)?r.parent.name:r,e.Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration));break}}case 240:var o=r.symbol;o.members&&o.members.size>0&&u.push(e.createDiagnosticForNode(e.isVariableDeclaration(r.parent)?r.parent.name:r,e.Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration))}else{if(e.isVariableStatement(r)&&r.parent===t&&2&r.declarationList.flags&&1===r.declarationList.declarations.length){var c=r.declarationList.declarations[0].initializer;c&&e.isRequireCall(c,!0)&&u.push(e.createDiagnosticForNode(c,e.Diagnostics.require_call_may_be_converted_to_an_import))}e.codefix.parameterShouldGetTypeFromJSDoc(r)&&u.push(e.createDiagnosticForNode(r.name||r,e.Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types))}e.isFunctionLikeDeclaration(r)&&a(r,l,u),r.forEachChild(s)}n.getSemanticDiagnostics(t,o);var u=[],l=n.getTypeChecker();t.commonJsModuleIndicator&&(e.programContainsEs6Modules(n)||e.compilerOptionsIndicateEs6Modules(n.getCompilerOptions()))&&r(t)&&u.push(e.createDiagnosticForNode(c(t.commonJsModuleIndicator),e.Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES6_module));var _=e.isSourceFileJS(t);if(m.clear(),s(t),e.getAllowSyntheticDefaultImports(n.getCompilerOptions()))for(var d=0,p=t.imports;d<p.length;d++){var f=p[d],g=e.importFromModuleSpecifier(f),v=i(g);if(v){var y=e.getResolvedModule(t,f.text),h=y&&n.getSourceFile(y.resolvedFileName);h&&h.externalModuleIndicator&&e.isExportAssignment(h.externalModuleIndicator)&&h.externalModuleIndicator.isExportEquals&&u.push(e.createDiagnosticForNode(v,e.Diagnostics.Import_may_be_converted_to_a_default_import))}}return e.addRange(u,t.bindSuggestionDiagnostics),e.addRange(u,n.getSuggestionDiagnostics(t,o)),u.sort(function(e,t){return e.start-t.start})}function r(t){return t.statements.some(function(t){switch(t.kind){case 220:return t.declarationList.declarations.some(function(t){return!!t.initializer&&e.isRequireCall(n(t.initializer),!0)});case 222:var r=t.expression;if(!e.isBinaryExpression(r))return e.isRequireCall(r,!0);var i=e.getAssignmentDeclarationKind(r);return 1===i||2===i;default:return!1}})}function n(t){return e.isPropertyAccessExpression(t)?n(t.expression):t}function i(t){switch(t.kind){case 250:var r=t.importClause,n=t.moduleSpecifier;return r&&!r.name&&r.namedBindings&&252===r.namedBindings.kind&&e.isStringLiteral(n)?r.namedBindings.name:void 0;case 249:return t.name;default:return void 0}}function a(t,r,n){o(t,r)&&!m.has(f(t))&&n.push(e.createDiagnosticForNode(!t.name&&e.isVariableDeclaration(t.parent)&&e.isIdentifier(t.parent.name)?t.parent.name:t,e.Diagnostics.This_may_be_converted_to_an_async_function))
}function o(t,r){return!e.isAsyncFunction(t)&&t.body&&e.isBlock(t.body)&&u(t.body)&&s(t,r)}function s(e,t){var r=t.getTypeAtLocation(e),n=t.getSignaturesOfType(r,0),i=n.length?t.getReturnTypeOfSignature(n[0]):void 0;return!!i&&!!t.getPromisedTypeOfPromise(i)}function c(t){return e.isBinaryExpression(t)?t.left:t}function u(t){return!!e.forEachReturnStatement(t,l)}function l(t){return e.isReturnStatement(t)&&!!t.expression&&_(t.expression)}function _(t){if(!d(t)||!t.arguments.every(p))return!1;for(var r=t.expression;d(r)||e.isPropertyAccessExpression(r);){if(e.isCallExpression(r)&&!r.arguments.every(p))return!1;r=r.expression}return!0}function d(t){return e.isCallExpression(t)&&(e.hasPropertyAccessExpressionWithName(t,"then")||e.hasPropertyAccessExpressionWithName(t,"catch"))}function p(e){switch(e.kind){case 240:case 197:case 198:m.set(f(e),!0);case 97:case 73:return!0;default:return!1}}function f(e){return e.pos.toString()+":"+e.end.toString()}var m=e.createMap();e.computeSuggestionDiagnostics=t,e.isReturnStatementWithFixablePromiseHandler=l,e.isFixablePromiseHandler=_}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,i){var a=n(t,r,i);if(""!==a)return a;var o=e.getCombinedLocalAndExportSymbolFlags(r);return 32&o?e.getDeclarationOfKind(r,210)?"local class":"class":384&o?"enum":524288&o?"type":64&o?"interface":262144&o?"type parameter":262144&o?"type parameter":8&o?"enum member":2097152&o?"alias":1536&o?"module":a}function n(t,r,n){var i=t.getRootSymbols(r);if(1===i.length&&8192&e.first(i).flags&&0!==t.getTypeOfSymbolAtLocation(r,n).getNonNullableType().getCallSignatures().length)return"method";if(t.isUndefinedSymbol(r))return"var";if(t.isArgumentsSymbol(r))return"local var";if(101===n.kind&&e.isExpression(n))return"parameter";var a=e.getCombinedLocalAndExportSymbolFlags(r);if(3&a)return e.isFirstDeclarationOfSymbolParameter(r)?"parameter":r.valueDeclaration&&e.isVarConst(r.valueDeclaration)?"const":e.forEach(r.declarations,e.isLet)?"let":o(r)?"local var":"var";if(16&a)return o(r)?"local function":"function";if(32768&a)return"getter";if(65536&a)return"setter";if(8192&a)return"method";if(16384&a)return"constructor";if(4&a){if(33554432&a&&6&r.checkFlags){var s=e.forEach(t.getRootSymbols(r),function(t){var r=t.getFlags();return 98311&r?"property":void e.Debug.assert(!!(8208&r))});if(!s){var c=t.getTypeOfSymbolAtLocation(r,n);return c.getCallSignatures().length?"method":"property"}return s}switch(n.parent&&n.parent.kind){case 263:case 261:case 262:return 73===n.kind?"property":"JSX attribute";case 268:return"JSX attribute";default:return"property"}}return""}function i(t){var r=t&&t.declarations&&t.declarations.length>0?e.getNodeModifiers(t.declarations[0]):"",n=t&&16777216&t.flags?"optional":"";return r&&n?r+","+n:r||n}function a(t,i,o,s,c,u,l){function _(){return S||(S=e.createPrinter({removeComments:!0})),S}function d(){T.length&&T.push(e.lineBreakPart()),p()}function p(){l&&(v("alias"),T.push(e.spacePart()))}function f(){T.push(e.spacePart()),T.push(e.keywordPart(94)),T.push(e.spacePart())}function m(r,n){l&&r===i&&(r=l);var a=e.symbolToDisplayParts(t,r,n||o,void 0,7);e.addRange(T,a),16777216&i.flags&&T.push(e.punctuationPart(56))}function g(t,r){d(),r&&(v(r),t&&!e.some(t.declarations,function(t){return e.isArrowFunction(t)||(e.isFunctionExpression(t)||e.isClassExpression(t))&&!t.name})&&(T.push(e.spacePart()),m(t)))}function v(t){switch(t){case"var":case"function":case"let":case"const":case"constructor":return void T.push(e.textOrKeywordPart(t));default:return T.push(e.punctuationPart(20)),T.push(e.textOrKeywordPart(t)),void T.push(e.punctuationPart(21))}}function y(r,n,i){void 0===i&&(i=0),e.addRange(T,e.signatureToDisplayParts(t,r,s,32|i)),n.length>1&&(T.push(e.spacePart()),T.push(e.punctuationPart(20)),T.push(e.operatorPart(38)),T.push(e.displayPart((n.length-1).toString(),e.SymbolDisplayPartKind.numericLiteral)),T.push(e.spacePart()),T.push(e.textPart(2===n.length?"overload":"overloads")),T.push(e.punctuationPart(21)));var a=r.getDocumentationComment(t);b=0===a.length?void 0:a,x=r.getJsDocTags()}function h(r,n){var i=e.mapToDisplayParts(function(i){var a=t.symbolToTypeParameterDeclarations(r,n);_().writeList(53776,a,e.getSourceFileOfNode(e.getParseTreeNode(n)),i)});e.addRange(T,i)}void 0===u&&(u=e.getMeaningFromLocation(c));var b,x,D,S,C,k,T=[],E=e.getCombinedLocalAndExportSymbolFlags(i),N=1&u?n(t,i,c):"",A=!1,F=101===c.kind&&e.isInExpressionContext(c);if(101===c.kind&&!F)return{displayParts:[e.keywordPart(101)],documentation:[],symbolKind:"primitive type",tags:void 0};if(""!==N||32&E||2097152&E){("getter"===N||"setter"===N)&&(N="property");var P=void 0;if(D=F?t.getTypeAtLocation(c):t.getTypeOfSymbolAtLocation(i.exportSymbol||i,c),c.parent&&190===c.parent.kind){var w=c.parent.name;(w===c||w&&0===w.getFullWidth())&&(c=c.parent)}var I=void 0;if(e.isCallOrNewExpression(c)?I=c:e.isCallExpressionTarget(c)||e.isNewExpressionTarget(c)?I=c.parent:c.parent&&e.isJsxOpeningLikeElement(c.parent)&&e.isFunctionLike(i.valueDeclaration)&&(I=c.parent),I){P=t.getResolvedSignature(I);var O=193===I.kind||e.isCallExpression(I)&&99===I.expression.kind,M=O?D.getConstructSignatures():D.getCallSignatures();if(e.contains(M,P.target)||e.contains(M,P)||(P=M.length?M[0]:void 0),P){switch(O&&32&E?(N="constructor",g(D.symbol,N)):2097152&E?(N="alias",v(N),T.push(e.spacePart()),O&&(T.push(e.keywordPart(96)),T.push(e.spacePart())),m(i)):g(i,N),N){case"JSX attribute":case"property":case"var":case"const":case"let":case"parameter":case"local var":T.push(e.punctuationPart(57)),T.push(e.spacePart()),16&e.getObjectFlags(D)||!D.symbol||(e.addRange(T,e.symbolToDisplayParts(t,D.symbol,s,void 0,5)),T.push(e.lineBreakPart())),O&&(T.push(e.keywordPart(96)),T.push(e.spacePart())),y(P,M,262144);break;default:y(P,M)}A=!0}}else if(e.isNameOfFunctionDeclaration(c)&&!(98304&E)||125===c.kind&&158===c.parent.kind){var L=c.parent,R=e.find(i.declarations,function(e){return e===(125===c.kind?L.parent:L)});if(R){var M=158===L.kind?D.getNonNullableType().getConstructSignatures():D.getNonNullableType().getCallSignatures();P=t.isImplementationOfOverload(L)?M[0]:t.getSignatureFromDeclaration(L),158===L.kind?(N="constructor",g(D.symbol,N)):g(161!==L.kind||2048&D.symbol.flags||4096&D.symbol.flags?i:D.symbol,N),y(P,M),A=!0}}}if(32&E&&!A&&!F&&(p(),e.getDeclarationOfKind(i,210)?v("local class"):T.push(e.keywordPart(77)),T.push(e.spacePart()),m(i),h(i,o)),64&E&&2&u&&(d(),T.push(e.keywordPart(111)),T.push(e.spacePart()),m(i),h(i,o)),524288&E&&2&u&&(d(),T.push(e.keywordPart(141)),T.push(e.spacePart()),m(i),h(i,o),T.push(e.spacePart()),T.push(e.operatorPart(60)),T.push(e.spacePart()),e.addRange(T,e.typeToDisplayParts(t,t.getDeclaredTypeOfSymbol(i),s,8388608))),384&E&&(d(),e.some(i.declarations,function(t){return e.isEnumDeclaration(t)&&e.isEnumConst(t)})&&(T.push(e.keywordPart(78)),T.push(e.spacePart())),T.push(e.keywordPart(85)),T.push(e.spacePart()),m(i)),1536&E&&!F){d();var B=e.getDeclarationOfKind(i,245),j=B&&B.name&&73===B.name.kind;T.push(e.keywordPart(j?132:131)),T.push(e.spacePart()),m(i)}if(262144&E&&2&u)if(d(),T.push(e.punctuationPart(20)),T.push(e.textPart("type parameter")),T.push(e.punctuationPart(21)),T.push(e.spacePart()),m(i),i.parent)f(),m(i.parent,s),h(i.parent,s);else{var J=e.getDeclarationOfKind(i,151);if(void 0===J)return e.Debug.fail();var B=J.parent;if(B)if(e.isFunctionLikeKind(B.kind)){f();var P=t.getSignatureFromDeclaration(B);162===B.kind?(T.push(e.keywordPart(96)),T.push(e.spacePart())):161!==B.kind&&B.name&&m(B.symbol),e.addRange(T,e.signatureToDisplayParts(t,P,o,32))}else 243===B.kind&&(f(),T.push(e.keywordPart(141)),T.push(e.spacePart()),m(B.symbol),h(B.symbol,o))}if(8&E){N="enum member",g(i,"enum member");var B=i.declarations[0];if(279===B.kind){var z=t.getConstantValue(B);void 0!==z&&(T.push(e.spacePart()),T.push(e.operatorPart(60)),T.push(e.spacePart()),T.push(e.displayPart(e.getTextOfConstantValue(z),"number"==typeof z?e.SymbolDisplayPartKind.numericLiteral:e.SymbolDisplayPartKind.stringLiteral)))}}if(2097152&E){if(d(),!A){var V=t.getAliasedSymbol(i);if(V!==i&&V.declarations&&V.declarations.length>0){var U=V.declarations[0],K=e.getNameOfDeclaration(U);if(K){var q=e.isModuleWithStringLiteralName(U)&&e.hasModifier(U,2),W="default"!==i.name&&!q,H=a(t,V,e.getSourceFileOfNode(U),U,K,u,W?i:V);T.push.apply(T,H.displayParts),T.push(e.lineBreakPart()),C=H.documentation,k=H.tags}}}switch(i.declarations[0].kind){case 248:T.push(e.keywordPart(86)),T.push(e.spacePart()),T.push(e.keywordPart(132));break;case 255:T.push(e.keywordPart(86)),T.push(e.spacePart()),T.push(e.keywordPart(i.declarations[0].isExportEquals?60:81));break;case 258:T.push(e.keywordPart(86));break;default:T.push(e.keywordPart(93))}T.push(e.spacePart()),m(i),e.forEach(i.declarations,function(r){if(249===r.kind){var n=r;if(e.isExternalModuleImportEqualsDeclaration(n))T.push(e.spacePart()),T.push(e.operatorPart(60)),T.push(e.spacePart()),T.push(e.keywordPart(135)),T.push(e.punctuationPart(20)),T.push(e.displayPart(e.getTextOfNode(e.getExternalModuleImportEqualsDeclarationExpression(n)),e.SymbolDisplayPartKind.stringLiteral)),T.push(e.punctuationPart(21));else{var i=t.getSymbolAtLocation(n.moduleReference);i&&(T.push(e.spacePart()),T.push(e.operatorPart(60)),T.push(e.spacePart()),m(i,s))}return!0}})}if(!A)if(""!==N){if(D)if(F?(d(),T.push(e.keywordPart(101))):g(i,N),"property"===N||"JSX attribute"===N||3&E||"local var"===N||F)if(T.push(e.punctuationPart(57)),T.push(e.spacePart()),D.symbol&&262144&D.symbol.flags){var G=e.mapToDisplayParts(function(r){var n=t.typeParameterToDeclaration(D,s);_().writeNode(4,n,e.getSourceFileOfNode(e.getParseTreeNode(s)),r)});e.addRange(T,G)}else e.addRange(T,e.typeToDisplayParts(t,D,s));else if(16&E||8192&E||16384&E||131072&E||98304&E||"method"===N){var M=D.getNonNullableType().getCallSignatures();M.length&&y(M[0],M)}}else N=r(t,i,c);if(!b&&(b=i.getDocumentationComment(t),x=i.getJsDocTags(),0===b.length&&4&E&&i.parent&&e.forEach(i.parent.declarations,function(e){return 285===e.kind})))for(var Q=0,X=i.declarations;Q<X.length;Q++){var B=X[Q];if(B.parent&&205===B.parent.kind){var Y=t.getSymbolAtLocation(B.parent.right);if(Y&&(b=Y.getDocumentationComment(t),x=Y.getJsDocTags(),b.length>0))break}}return 0===b.length&&C&&(b=C),0===x.length&&k&&(x=k),{displayParts:T,documentation:b,symbolKind:N,tags:0===x.length?void 0:x}}function o(t){return t.parent?!1:e.forEach(t.declarations,function(t){if(197===t.kind)return!0;if(238!==t.kind&&240!==t.kind)return!1;for(var r=t.parent;!e.isFunctionBlock(r);r=r.parent)if(285===r.kind||246===r.kind)return!1;return!0})}t.getSymbolKind=r,t.getSymbolModifiers=i,t.getSymbolDisplayPartsDocumentationAndSymbolKind=a}(t=e.SymbolDisplay||(e.SymbolDisplay={}))}(n||(n={}));var n;!function(e){function t(t,r){var i=[],a=r.compilerOptions?n(r.compilerOptions,i):e.getDefaultCompilerOptions();a.isolatedModules=!0,a.suppressOutputPathCheck=!0,a.allowNonTsExtensions=!0,a.noLib=!0,a.lib=void 0,a.types=void 0,a.noEmit=void 0,a.noEmitOnError=void 0,a.paths=void 0,a.rootDirs=void 0,a.declaration=void 0,a.composite=void 0,a.declarationDir=void 0,a.out=void 0,a.outFile=void 0,a.noResolve=!0;var o=r.fileName||(a.jsx?"module.tsx":"module.ts"),s=e.createSourceFile(o,t,a.target);r.moduleName&&(s.moduleName=r.moduleName),r.renamedDependencies&&(s.renamedDependencies=e.createMapFromTemplate(r.renamedDependencies));var c,u,l=e.getNewLineCharacter(a),_={getSourceFile:function(t){return t===e.normalizePath(o)?s:void 0},writeFile:function(t,r){e.fileExtensionIs(t,".map")?(e.Debug.assertEqual(u,void 0,"Unexpected multiple source map outputs, file:",t),u=r):(e.Debug.assertEqual(c,void 0,"Unexpected multiple outputs, file:",t),c=r)},getDefaultLibFileName:function(){return"lib.d.ts"},useCaseSensitiveFileNames:function(){return!1},getCanonicalFileName:function(e){return e},getCurrentDirectory:function(){return""},getNewLine:function(){return l},fileExists:function(e){return e===o},readFile:function(){return""},directoryExists:function(){return!0},getDirectories:function(){return[]}},d=e.createProgram([o],a,_);return r.reportDiagnostics&&(e.addRange(i,d.getSyntacticDiagnostics(s)),e.addRange(i,d.getOptionsDiagnostics())),d.emit(void 0,void 0,void 0,void 0,r.transformers),void 0===c?e.Debug.fail("Output generation failed"):{outputText:c,diagnostics:i,sourceMapText:u}}function r(r,n,i,a,o){var s=t(r,{compilerOptions:n,fileName:i,reportDiagnostics:!!a,moduleName:o});return e.addRange(a,s.diagnostics),s.outputText}function n(t,r){i=i||e.filter(e.optionDeclarations,function(t){return"object"==typeof t.type&&!e.forEachEntry(t.type,function(e){return"number"!=typeof e})}),t=e.cloneCompilerOptions(t);for(var n=function(n){if(!e.hasProperty(t,n.name))return"continue";var i=t[n.name];e.isString(i)?t[n.name]=e.parseCustomTypeOption(n,i,r):e.forEachEntry(n.type,function(e){return e===i})||r.push(e.createCompilerDiagnosticForInvalidCustomType(n))},a=0,o=i;a<o.length;a++){var s=o[a];n(s)}return t}e.transpileModule=t,e.transpile=r;var i;e.fixupCompilerOptions=n}(n||(n={}));var n;!function(e){var t;!function(t){var r;!function(e){e[e.FormatDocument=0]="FormatDocument",e[e.FormatSelection=1]="FormatSelection",e[e.FormatOnEnter=2]="FormatOnEnter",e[e.FormatOnSemicolon=3]="FormatOnSemicolon",e[e.FormatOnOpeningCurlyBrace=4]="FormatOnOpeningCurlyBrace",e[e.FormatOnClosingCurlyBrace=5]="FormatOnClosingCurlyBrace"}(r=t.FormattingRequestKind||(t.FormattingRequestKind={}));var n=function(){function t(e,t,r){this.sourceFile=e,this.formattingRequestKind=t,this.options=r}return t.prototype.updateContext=function(t,r,n,i,a){this.currentTokenSpan=e.Debug.assertDefined(t),this.currentTokenParent=e.Debug.assertDefined(r),this.nextTokenSpan=e.Debug.assertDefined(n),this.nextTokenParent=e.Debug.assertDefined(i),this.contextNode=e.Debug.assertDefined(a),this.contextNodeAllOnSameLine=void 0,this.nextNodeAllOnSameLine=void 0,this.tokensAreOnSameLine=void 0,this.contextNodeBlockIsOnOneLine=void 0,this.nextNodeBlockIsOnOneLine=void 0},t.prototype.ContextNodeAllOnSameLine=function(){return void 0===this.contextNodeAllOnSameLine&&(this.contextNodeAllOnSameLine=this.NodeIsOnOneLine(this.contextNode)),this.contextNodeAllOnSameLine},t.prototype.NextNodeAllOnSameLine=function(){return void 0===this.nextNodeAllOnSameLine&&(this.nextNodeAllOnSameLine=this.NodeIsOnOneLine(this.nextTokenParent)),this.nextNodeAllOnSameLine},t.prototype.TokensAreOnSameLine=function(){if(void 0===this.tokensAreOnSameLine){var e=this.sourceFile.getLineAndCharacterOfPosition(this.currentTokenSpan.pos).line,t=this.sourceFile.getLineAndCharacterOfPosition(this.nextTokenSpan.pos).line;this.tokensAreOnSameLine=e===t}return this.tokensAreOnSameLine},t.prototype.ContextNodeBlockIsOnOneLine=function(){return void 0===this.contextNodeBlockIsOnOneLine&&(this.contextNodeBlockIsOnOneLine=this.BlockIsOnOneLine(this.contextNode)),this.contextNodeBlockIsOnOneLine},t.prototype.NextNodeBlockIsOnOneLine=function(){return void 0===this.nextNodeBlockIsOnOneLine&&(this.nextNodeBlockIsOnOneLine=this.BlockIsOnOneLine(this.nextTokenParent)),this.nextNodeBlockIsOnOneLine},t.prototype.NodeIsOnOneLine=function(e){var t=this.sourceFile.getLineAndCharacterOfPosition(e.getStart(this.sourceFile)).line,r=this.sourceFile.getLineAndCharacterOfPosition(e.getEnd()).line;return t===r},t.prototype.BlockIsOnOneLine=function(t){var r=e.findChildOfKind(t,18,this.sourceFile),n=e.findChildOfKind(t,19,this.sourceFile);if(r&&n){var i=this.sourceFile.getLineAndCharacterOfPosition(r.getEnd()).line,a=this.sourceFile.getLineAndCharacterOfPosition(n.getStart(this.sourceFile)).line;return i===a}return!1},t}();t.FormattingContext=n}(t=e.formatting||(e.formatting={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,n,o,s){function c(){k=void 0;var t=b.getStartPos()!==n;t?T=!!D&&4===e.last(D).kind:b.scan(),x=void 0,D=void 0;for(var r=b.getStartPos();o>r;){var i=b.getToken();if(!e.isTrivia(i))break;b.scan();var a={pos:r,end:b.getStartPos(),kind:i};r=b.getStartPos(),x=e.append(x,a)}S=b.getStartPos()}function u(e){switch(e.kind){case 32:case 68:case 69:case 48:case 47:return!0}return!1}function l(t){if(t.parent)switch(t.parent.kind){case 268:case 263:case 264:case 262:return e.isKeyword(t.kind)||73===t.kind}return!1}function _(e){return 11===e.kind}function d(e){return 13===e.kind}function p(e){return 16===e.kind||17===e.kind}function f(e){return 42===e||65===e}function m(t){e.Debug.assert(v());var r=u(t)?1:d(t)?2:p(t)?3:l(t)?4:_(t)?5:0;if(k&&r===C)return y(k,t);b.getStartPos()!==S&&(e.Debug.assert(void 0!==k),b.setTextPos(S),b.scan());var n=g(t,r),i={pos:b.getStartPos(),end:b.getTextPos(),kind:n};for(D&&(D=void 0);b.getStartPos()<o&&(n=b.scan(),e.isTrivia(n));){var a={pos:b.getStartPos(),end:b.getTextPos(),kind:n};if(D||(D=[]),D.push(a),4===n){b.scan();break}}return k={leadingTrivia:x,trailingTrivia:D,token:i},y(k,t)}function g(t,r){var n=b.getToken();switch(C=0,r){case 1:if(30===n){C=1;var i=b.reScanGreaterToken();return e.Debug.assert(t.kind===i),i}break;case 2:if(f(n)){C=2;var i=b.reScanSlashToken();return e.Debug.assert(t.kind===i),i}break;case 3:if(19===n)return C=3,b.reScanTemplateToken();break;case 4:return C=4,b.scanJsxIdentifier();case 5:return C=5,b.reScanJsxToken();case 0:break;default:e.Debug.assertNever(r)}return n}function v(){var t=k?k.token.kind:b.getToken(),r=k?k.token.pos:b.getStartPos();return o>r&&1!==t&&!e.isTrivia(t)}function y(t,r){return e.isToken(r)&&t.token.kind!==r.kind&&(t.token.kind=r.kind),t}function h(e){b.setTextPos(e.end),S=b.getStartPos(),C=void 0,k=void 0,T=!1,x=void 0,D=void 0}var b=1===r?a:i;b.setText(t),b.setTextPos(n);var x,D,S,C,k,T=!0,E=s({advance:c,readTokenInfo:m,isOnToken:v,getCurrentLeadingTrivia:function(){return x},lastTrailingTriviaWasNewLine:function(){return T},skipToEndOf:h});return k=void 0,b.setText(void 0),E}var n,i=e.createScanner(8,!1,0),a=e.createScanner(8,!1,1);!function(e){e[e.Scan=0]="Scan",e[e.RescanGreaterThanToken=1]="RescanGreaterThanToken",e[e.RescanSlashToken=2]="RescanSlashToken",e[e.RescanTemplateToken=3]="RescanTemplateToken",e[e.RescanJsxIdentifier=4]="RescanJsxIdentifier",e[e.RescanJsxText=5]="RescanJsxText"}(n||(n={})),t.getFormattingScanner=r}(t=e.formatting||(e.formatting={}))}(n||(n={}));var n;!function(e){var t;!function(t){t.anyContext=e.emptyArray;var r;!function(e){e[e.Ignore=1]="Ignore",e[e.Space=2]="Space",e[e.NewLine=4]="NewLine",e[e.Delete=8]="Delete"}(r=t.RuleAction||(t.RuleAction={}));var n;!function(e){e[e.None=0]="None",e[e.CanDeleteNewLines=1]="CanDeleteNewLines"}(n=t.RuleFlags||(t.RuleFlags={}))}(t=e.formatting||(e.formatting={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(){function r(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return{tokens:a.filter(function(t){return!e.some(function(e){return e===t})}),isSpecific:!1}}for(var a=[],S=0;148>=S;S++)a.push(S);var C={tokens:a,isSpecific:!1},T=i(a.concat([3])),P=o(74,148),M=o(28,72),L=[94,95,148,120,129],X=[44,45,53,52],rt=[8,9,73,20,22,18,101,96],ct=[73,20,101,96],ut=[73,21,23,96],lt=[73,20,101,96],_t=[73,21,23,96],dt=[2,3],pt=[73].concat(e.typeKeywords),ft=T,mt=i([73,3,77,86,93]),gt=i([21,3,83,104,89,84]),vt=[n("IgnoreBeforeComment",C,dt,t.anyContext,1),n("IgnoreAfterLineComment",2,C,t.anyContext,1),n("NotSpaceBeforeColon",C,57,[V,m,g],8),n("SpaceAfterColon",57,C,[V,m],2),n("NoSpaceBeforeQuestionMark",C,56,[V,m],8),n("SpaceAfterQuestionMarkInConditionalOperator",56,C,[V,y],2),n("NoSpaceAfterQuestionMark",56,C,[V],8),n("NoSpaceBeforeDot",C,24,[V],8),n("NoSpaceAfterDot",24,C,[V],8),n("NoSpaceBetweenImportParenInImportType",93,20,[V,z],8),n("NoSpaceAfterUnaryPrefixOperator",X,rt,[V,m],8),n("NoSpaceAfterUnaryPreincrementOperator",44,ct,[V],8),n("NoSpaceAfterUnaryPredecrementOperator",45,lt,[V],8),n("NoSpaceBeforeUnaryPostincrementOperator",ut,44,[V],8),n("NoSpaceBeforeUnaryPostdecrementOperator",_t,45,[V],8),n("SpaceAfterPostincrementWhenFollowedByAdd",44,38,[V,f],2),n("SpaceAfterAddWhenFollowedByUnaryPlus",38,38,[V,f],2),n("SpaceAfterAddWhenFollowedByPreincrement",38,44,[V,f],2),n("SpaceAfterPostdecrementWhenFollowedBySubtract",45,39,[V,f],2),n("SpaceAfterSubtractWhenFollowedByUnaryMinus",39,39,[V,f],2),n("SpaceAfterSubtractWhenFollowedByPredecrement",39,45,[V,f],2),n("NoSpaceAfterCloseBrace",19,[27,26],[V],8),n("NewLineBeforeCloseBraceInBlockContext",T,19,[D],4),n("SpaceAfterCloseBrace",19,r(21),[V,w],2),n("SpaceBetweenCloseBraceAndElse",19,84,[V],2),n("SpaceBetweenCloseBraceAndWhile",19,108,[V],2),n("NoSpaceBetweenEmptyBraceBrackets",18,19,[V,O],8),n("SpaceAfterConditionalClosingParen",21,22,[I],2),n("NoSpaceBetweenFunctionKeywordAndStar",91,40,[A],8),n("SpaceAfterStarInGeneratorDeclaration",40,73,[A],2),n("SpaceAfterFunctionInFuncDecl",91,C,[E],2),n("NewLineAfterOpenBraceInBlockContext",18,C,[D],4),n("SpaceAfterGetSetInMember",[127,138],73,[E],2),n("NoSpaceBetweenYieldKeywordAndStar",118,40,[V,ot],8),n("SpaceBetweenYieldOrYieldStarAndOperand",[118,40],C,[V,ot],2),n("NoSpaceBetweenReturnAndSemicolon",98,26,[V],8),n("SpaceAfterCertainKeywords",[106,102,96,82,98,105,123],C,[V],2),n("SpaceAfterLetConstInVariableDeclaration",[112,78],C,[V,Y],2),n("NoSpaceBeforeOpenParenInFuncCall",C,20,[V,R,B],8),n("SpaceBeforeBinaryKeywordOperator",C,L,[V,f],2),n("SpaceAfterBinaryKeywordOperator",L,C,[V,f],2),n("SpaceAfterVoidOperator",107,C,[V,at],2),n("SpaceBetweenAsyncAndOpenParen",122,20,[J,V],2),n("SpaceBetweenAsyncAndFunctionKeyword",122,91,[V],2),n("NoSpaceBetweenTagAndTemplateString",[73,21],[14,15],[V],8),n("SpaceBeforeJsxAttribute",C,73,[q,V],2),n("SpaceBeforeSlashInJsxOpeningElement",C,42,[H,V],2),n("NoSpaceBeforeGreaterThanTokenInJsxOpeningElement",42,30,[H,V],8),n("NoSpaceBeforeEqualInJsxAttribute",C,60,[W,V],8),n("NoSpaceAfterEqualInJsxAttribute",60,C,[W,V],8),n("NoSpaceAfterModuleImport",[131,135],20,[V],8),n("SpaceAfterCertainTypeScriptKeywords",[119,77,126,81,85,86,87,127,110,93,111,131,132,114,116,115,134,138,117,141,145,130,128],C,[V],2),n("SpaceBeforeCertainTypeScriptKeywords",C,[87,110,145],[V],2),n("SpaceAfterModuleName",10,18,[$],2),n("SpaceBeforeArrow",C,37,[V],2),n("SpaceAfterArrow",37,C,[V],2),n("NoSpaceAfterEllipsis",25,73,[V],8),n("NoSpaceAfterOptionalParameters",56,[21,27],[V,m],8),n("NoSpaceBetweenEmptyInterfaceBraceBrackets",18,19,[V,et],8),n("NoSpaceBeforeOpenAngularBracket",pt,28,[V,nt],8),n("NoSpaceBetweenCloseParenAndAngularBracket",21,28,[V,nt],8),n("NoSpaceAfterOpenAngularBracket",28,C,[V,nt],8),n("NoSpaceBeforeCloseAngularBracket",C,30,[V,nt],8),n("NoSpaceAfterCloseAngularBracket",30,[20,22,30,27],[V,nt,N],8),n("SpaceBeforeAt",[21,73],58,[V],2),n("NoSpaceAfterAt",58,C,[V],8),n("SpaceAfterDecorator",C,[119,73,86,81,77,117,116,114,115,127,138,22,40],[Q],2),n("NoSpaceBeforeNonNullAssertionOperator",C,52,[V,st],8),n("NoSpaceAfterNewKeywordOnConstructorSignature",96,20,[V,tt],8)],yt=[n("SpaceAfterConstructor",125,20,[s("insertSpaceAfterConstructor"),V],2),n("NoSpaceAfterConstructor",125,20,[u("insertSpaceAfterConstructor"),V],8),n("SpaceAfterComma",27,C,[s("insertSpaceAfterCommaDelimiter"),V,U,j],2),n("NoSpaceAfterComma",27,C,[u("insertSpaceAfterCommaDelimiter"),V,U],8),n("SpaceAfterAnonymousFunctionKeyword",[91,40],20,[s("insertSpaceAfterFunctionKeywordForAnonymousFunctions"),E],2),n("NoSpaceAfterAnonymousFunctionKeyword",[91,40],20,[u("insertSpaceAfterFunctionKeywordForAnonymousFunctions"),E],8),n("SpaceAfterKeywordInControl",P,20,[s("insertSpaceAfterKeywordsInControlFlowStatements"),I],2),n("NoSpaceAfterKeywordInControl",P,20,[u("insertSpaceAfterKeywordsInControlFlowStatements"),I],8),n("SpaceAfterOpenParen",20,C,[s("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),V],2),n("SpaceBeforeCloseParen",C,21,[s("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),V],2),n("SpaceBetweenOpenParens",20,20,[s("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),V],2),n("NoSpaceBetweenParens",20,21,[V],8),n("NoSpaceAfterOpenParen",20,C,[u("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),V],8),n("NoSpaceBeforeCloseParen",C,21,[u("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),V],8),n("SpaceAfterOpenBracket",22,C,[s("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),V],2),n("SpaceBeforeCloseBracket",C,23,[s("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),V],2),n("NoSpaceBetweenBrackets",22,23,[V],8),n("NoSpaceAfterOpenBracket",22,C,[u("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),V],8),n("NoSpaceBeforeCloseBracket",C,23,[u("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),V],8),n("SpaceAfterOpenBrace",18,C,[_("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),b],2),n("SpaceBeforeCloseBrace",C,19,[_("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),b],2),n("NoSpaceBetweenEmptyBraceBrackets",18,19,[V,O],8),n("NoSpaceAfterOpenBrace",18,C,[c("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),V],8),n("NoSpaceBeforeCloseBrace",C,19,[c("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),V],8),n("SpaceAfterTemplateHeadAndMiddle",[15,16],C,[s("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),V],2),n("SpaceBeforeTemplateMiddleAndTail",C,[16,17],[s("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),V],2),n("NoSpaceAfterTemplateHeadAndMiddle",[15,16],C,[u("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),V],8),n("NoSpaceBeforeTemplateMiddleAndTail",C,[16,17],[u("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),V],8),n("SpaceAfterOpenBraceInJsxExpression",18,C,[s("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),V,K],2),n("SpaceBeforeCloseBraceInJsxExpression",C,19,[s("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),V,K],2),n("NoSpaceAfterOpenBraceInJsxExpression",18,C,[u("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),V,K],8),n("NoSpaceBeforeCloseBraceInJsxExpression",C,19,[u("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),V,K],8),n("SpaceAfterSemicolonInFor",26,C,[s("insertSpaceAfterSemicolonInForStatements"),V,d],2),n("NoSpaceAfterSemicolonInFor",26,C,[u("insertSpaceAfterSemicolonInForStatements"),V,d],8),n("SpaceBeforeBinaryOperator",C,M,[s("insertSpaceBeforeAndAfterBinaryOperators"),V,f],2),n("SpaceAfterBinaryOperator",M,C,[s("insertSpaceBeforeAndAfterBinaryOperators"),V,f],2),n("NoSpaceBeforeBinaryOperator",C,M,[u("insertSpaceBeforeAndAfterBinaryOperators"),V,f],8),n("NoSpaceAfterBinaryOperator",M,C,[u("insertSpaceBeforeAndAfterBinaryOperators"),V,f],8),n("SpaceBeforeOpenParenInFuncDecl",C,20,[s("insertSpaceBeforeFunctionParenthesis"),V,E],2),n("NoSpaceBeforeOpenParenInFuncDecl",C,20,[u("insertSpaceBeforeFunctionParenthesis"),V,E],8),n("NewLineBeforeOpenBraceInControl",gt,18,[s("placeOpenBraceOnNewLineForControlBlocks"),I,x],4,1),n("NewLineBeforeOpenBraceInFunction",ft,18,[s("placeOpenBraceOnNewLineForFunctions"),E,x],4,1),n("NewLineBeforeOpenBraceInTypeScriptDeclWithBlock",mt,18,[s("placeOpenBraceOnNewLineForFunctions"),F,x],4,1),n("SpaceAfterTypeAssertion",30,C,[s("insertSpaceAfterTypeAssertion"),V,it],2),n("NoSpaceAfterTypeAssertion",30,C,[u("insertSpaceAfterTypeAssertion"),V,it],8),n("SpaceBeforeTypeAnnotation",C,57,[s("insertSpaceBeforeTypeAnnotation"),V,v],2),n("NoSpaceBeforeTypeAnnotation",C,57,[u("insertSpaceBeforeTypeAnnotation"),V,v],8)],ht=[n("NoSpaceBeforeSemicolon",C,26,[V],8),n("SpaceBeforeOpenBraceInControl",gt,18,[l("placeOpenBraceOnNewLineForControlBlocks"),I,Z,h],2,1),n("SpaceBeforeOpenBraceInFunction",ft,18,[l("placeOpenBraceOnNewLineForFunctions"),E,k,Z,h],2,1),n("SpaceBeforeOpenBraceInTypeScriptDeclWithBlock",mt,18,[l("placeOpenBraceOnNewLineForFunctions"),F,Z,h],2,1),n("NoSpaceBeforeComma",C,27,[V],8),n("NoSpaceBeforeOpenBracket",r(122,75),22,[V],8),n("NoSpaceAfterCloseBracket",23,C,[V,G],8),n("SpaceAfterSemicolon",26,C,[V],2),n("SpaceBetweenForAndAwaitKeyword",90,123,[V],2),n("SpaceBetweenStatements",[21,83,84,75],C,[V,U,p],2),n("SpaceAfterTryFinally",[104,89],18,[V],2)];return vt.concat(yt,ht)}function n(e,t,r,n,i,o){return void 0===o&&(o=0),{leftTokenRange:a(t),rightTokenRange:a(r),rule:{debugName:e,context:n,action:i,flags:o}}}function i(e){return{tokens:e,isSpecific:!0}}function a(t){return"number"==typeof t?i([t]):e.isArray(t)?i(t):t}function o(t,r,n){void 0===n&&(n=[]);for(var a=[],o=t;r>=o;o++)e.contains(n,o)||a.push(o);return i(a)}function s(e){return function(t){return t.options&&t.options.hasOwnProperty(e)&&!!t.options[e]}}function c(e){return function(t){return t.options&&t.options.hasOwnProperty(e)&&!t.options[e]}}function u(e){return function(t){return!t.options||!t.options.hasOwnProperty(e)||!t.options[e]}}function l(e){return function(t){return!t.options||!t.options.hasOwnProperty(e)||!t.options[e]||t.TokensAreOnSameLine()}}function _(e){return function(t){return!t.options||!t.options.hasOwnProperty(e)||!!t.options[e]}}function d(e){return 226===e.contextNode.kind}function p(e){return!d(e)}function f(e){switch(e.contextNode.kind){case 205:case 206:case 176:case 213:case 258:case 254:case 164:case 174:case 175:return!0;case 187:case 243:case 249:case 238:case 152:case 279:case 155:case 154:return 60===e.currentTokenSpan.kind||60===e.nextTokenSpan.kind;case 227:case 151:return 94===e.currentTokenSpan.kind||94===e.nextTokenSpan.kind||60===e.currentTokenSpan.kind||60===e.nextTokenSpan.kind;case 228:return 148===e.currentTokenSpan.kind||148===e.nextTokenSpan.kind}return!1}function m(e){return!f(e)}function g(e){return!v(e)}function v(t){var r=t.contextNode.kind;return 155===r||154===r||152===r||238===r||e.isFunctionLikeKind(r)}function y(e){return 206===e.contextNode.kind||176===e.contextNode.kind}function h(e){return e.TokensAreOnSameLine()||k(e)}function b(e){return 185===e.contextNode.kind||182===e.contextNode.kind||S(e)}function x(e){return k(e)&&!(e.NextNodeAllOnSameLine()||e.NextNodeBlockIsOnOneLine())}function D(e){return C(e)&&!(e.ContextNodeAllOnSameLine()||e.ContextNodeBlockIsOnOneLine())}function S(e){return C(e)&&(e.ContextNodeAllOnSameLine()||e.ContextNodeBlockIsOnOneLine())}function C(e){return T(e.contextNode)}function k(e){return T(e.nextTokenParent)}function T(e){if(P(e))return!0;switch(e.kind){case 219:case 247:case 189:case 246:return!0}return!1}function E(e){switch(e.contextNode.kind){case 240:case 157:case 156:case 159:case 160:case 161:case 197:case 158:case 198:case 242:return!0}return!1}function N(e){return!E(e)}function A(e){return 240===e.contextNode.kind||197===e.contextNode.kind}function F(e){return P(e.contextNode)}function P(e){switch(e.kind){case 241:case 210:case 242:case 244:case 169:case 245:case 256:case 257:case 250:case 253:return!0}return!1}function w(e){switch(e.currentTokenParent.kind){case 241:case 245:case 244:case 275:case 246:case 233:return!0;case 219:var t=e.currentTokenParent.parent;if(!t||198!==t.kind&&197!==t.kind)return!0}return!1}function I(e){switch(e.contextNode.kind){case 223:case 233:case 226:case 227:case 228:case 225:case 236:case 224:case 232:case 275:return!0;default:return!1}}function O(e){return 189===e.contextNode.kind}function M(e){return 192===e.contextNode.kind}function L(e){return 193===e.contextNode.kind}function R(e){return M(e)||L(e)}function B(e){return 27!==e.currentTokenSpan.kind}function j(e){return 23!==e.nextTokenSpan.kind}function J(e){return 198===e.contextNode.kind}function z(e){return 184===e.contextNode.kind}function V(e){return e.TokensAreOnSameLine()&&11!==e.contextNode.kind}function U(e){return 261!==e.contextNode.kind&&265!==e.contextNode.kind}function K(e){return 271===e.contextNode.kind||270===e.contextNode.kind}function q(e){return 268===e.nextTokenParent.kind}function W(e){return 268===e.contextNode.kind}function H(e){return 262===e.contextNode.kind}function G(e){return!E(e)&&!k(e)}function Q(e){return e.TokensAreOnSameLine()&&!!e.contextNode.decorators&&X(e.currentTokenParent)&&!X(e.nextTokenParent)}function X(t){for(;e.isExpressionNode(t);)t=t.parent;return 153===t.kind}function Y(e){return 239===e.currentTokenParent.kind&&e.currentTokenParent.getStart(e.sourceFile)===e.currentTokenSpan.pos
}function Z(e){return 2!==e.formattingRequestKind}function $(e){return 245===e.contextNode.kind}function et(e){return 169===e.contextNode.kind}function tt(e){return 162===e.contextNode.kind}function rt(e,t){if(28!==e.kind&&30!==e.kind)return!1;switch(t.kind){case 165:case 195:case 243:case 241:case 210:case 242:case 240:case 197:case 198:case 157:case 156:case 161:case 162:case 192:case 193:case 212:return!0;default:return!1}}function nt(e){return rt(e.currentTokenSpan,e.currentTokenParent)||rt(e.nextTokenSpan,e.nextTokenParent)}function it(e){return 195===e.contextNode.kind}function at(e){return 107===e.currentTokenSpan.kind&&201===e.currentTokenParent.kind}function ot(e){return 208===e.contextNode.kind&&void 0!==e.contextNode.expression}function st(e){return 214===e.contextNode.kind}t.getAllRules=r}(t=e.formatting||(e.formatting={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(e){return{options:e,getRule:n()}}function n(){return void 0===l&&(l=i(t.getAllRules())),l}function i(t){var r=a(t);return function(t){var n=r[o(t.currentTokenSpan.kind,t.nextTokenSpan.kind)];return n&&e.find(n,function(r){return e.every(r.context,function(e){return e(t)})})}}function a(e){for(var t=new Array(f*f),r=new Array(t.length),n=0,i=e;n<i.length;n++)for(var a=i[n],c=a.leftTokenRange.isSpecific&&a.rightTokenRange.isSpecific,u=0,l=a.leftTokenRange.tokens;u<l.length;u++)for(var _=l[u],d=0,p=a.rightTokenRange.tokens;d<p.length;d++){var m=p[d],g=o(_,m),v=t[g];void 0===v&&(v=t[g]=[]),s(v,a.rule,c,r,g)}return t}function o(t,r){return e.Debug.assert(148>=t&&148>=r,"Must compute formatting context from tokens"),t*f+r}function s(e,r,n,i,a){var o=1===r.action?n?_.IgnoreRulesSpecific:_.IgnoreRulesAny:r.context!==t.anyContext?n?_.ContextRulesSpecific:_.ContextRulesAny:n?_.NoContextRulesSpecific:_.NoContextRulesAny,s=i[a]||0;e.splice(c(s,o),0,r),i[a]=u(s,o)}function c(e,t){for(var r=0,n=0;t>=n;n+=d)r+=e&p,e>>=d;return r}function u(t,r){var n=(t>>r&p)+1;return e.Debug.assert((n&p)===n,"Adding more rules into the sub-bucket than allowed. Maximum allowed is 32 rules."),t&~(p<<r)|n<<r}t.getFormatContext=r;var l,_,d=5,p=31,f=149;!function(e){e[e.IgnoreRulesSpecific=0]="IgnoreRulesSpecific",e[e.IgnoreRulesAny=1*d]="IgnoreRulesAny",e[e.ContextRulesSpecific=2*d]="ContextRulesSpecific",e[e.ContextRulesAny=3*d]="ContextRulesAny",e[e.NoContextRulesSpecific=4*d]="NoContextRulesSpecific",e[e.NoContextRulesAny=5*d]="NoContextRulesAny"}(_||(_={}))}(t=e.formatting||(e.formatting={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,n){var i=r.getLineAndCharacterOfPosition(t).line;if(0===i)return[];for(var a=e.getEndLinePosition(i,r);e.isWhiteSpaceSingleLine(r.text.charCodeAt(a));)a--;e.isLineBreak(r.text.charCodeAt(a))&&a--;var o={pos:e.getStartPositionOfLine(i-1,r),end:a+1};return v(o,r,n,2)}function n(e,t,r){var n=c(e,26,t);return g(u(n),t,r,3)}function i(t,r,n){var i=c(t,18,r);if(!i)return[];var a=i.parent,o=u(a),s={pos:e.getLineStartPositionForPosition(o.getStart(r),r),end:t};return v(s,r,n,4)}function a(e,t,r){var n=c(e,19,t);return g(u(n),t,r,5)}function o(e,t){var r={pos:0,end:e.text.length};return v(r,e,t,0)}function s(t,r,n,i){var a={pos:e.getLineStartPositionForPosition(t,n),end:r};return v(a,n,i,1)}function c(t,r,n){var i=e.findPrecedingToken(t,n);return i&&i.kind===r&&t===i.getEnd()?i:void 0}function u(e){for(var t=e;t&&t.parent&&t.parent.end===e.end&&!l(t.parent,t);)t=t.parent;return t}function l(t,r){switch(t.kind){case 241:case 242:return e.rangeContainsRange(t.members,r);case 245:var n=t.body;return!!n&&246===n.kind&&e.rangeContainsRange(n.statements,r);case 285:case 219:case 246:return e.rangeContainsRange(t.statements,r);case 275:return e.rangeContainsRange(t.block.statements,r)}return!1}function _(t,r){function n(i){var a=e.forEachChild(i,function(n){return e.startEndContainsRange(n.getStart(r),n.end,t)&&n});if(a){var o=n(a);if(o)return o}return i}return n(r)}function d(t,r){function n(){return!1}if(!t.length)return n;var i=t.filter(function(t){return e.rangeOverlapsWithStartEnd(r,t.start,t.start+t.length)}).sort(function(e,t){return e.start-t.start});if(!i.length)return n;var a=0;return function(t){for(;;){if(a>=i.length)return!1;var r=i[a];if(t.end<=r.start)return!1;if(e.startEndOverlapsWithStartEnd(t.pos,t.end,r.start,r.start+r.length))return!0;a++}}}function p(t,r,n){var i=t.getStart(n);if(i===r.pos&&t.end===r.end)return i;var a=e.findPrecedingToken(r.pos,n);return a?a.end>=r.pos?t.pos:a.end:t.pos}function f(e,r,n){for(var i,a=-1;e;){var o=n.getLineAndCharacterOfPosition(e.getStart(n)).line;if(-1!==a&&o!==a)break;if(t.SmartIndenter.shouldIndentChildNode(r,e,i,n))return r.indentSize;a=o,i=e,e=e.parent}return 0}function m(e,r,n,i,a,o){var s={pos:0,end:r.text.length};return t.getFormattingScanner(r.text,n,s.pos,s.end,function(t){return y(s,e,i,a,t,o,1,function(){return!1},r)})}function g(t,r,n,i){if(!t)return[];var a={pos:e.getLineStartPositionForPosition(t.getStart(r),r),end:t.end};return v(a,r,n,i)}function v(e,r,n,i){var a=_(e,r);return t.getFormattingScanner(r.text,r.languageVariant,p(a,e,r),e.end,function(o){return y(e,a,t.SmartIndenter.getIndentationForNode(a,e,r,n.options),f(a,n.options,r),o,n,i,d(r.parseDiagnostics,e),r)})}function y(r,n,i,a,o,s,c,u,l){function _(r,n,i,a,o){if(e.rangeOverlapsWithStartEnd(a,r,n)||e.rangeContainsStartEnd(a,r,n)){if(-1!==o)return o}else{var s=l.getLineAndCharacterOfPosition(r).line,c=e.getLineStartPositionForPosition(r,l),u=t.SmartIndenter.findFirstNonWhitespaceColumn(c,r,l,R);if(s!==i||r===u){var _=t.SmartIndenter.getBaseIndentation(R);return _>u?_:u}}return-1}function d(e,r,n,i,a,o){var s=t.SmartIndenter.shouldIndentChildNode(R,e)?R.indentSize:0;return o===r?{indentation:r===L?J:a.getIndentation(),delta:Math.min(R.indentSize,a.getDelta(e)+s)}:-1===n?20===e.kind&&r===L?{indentation:J,delta:a.getDelta(e)}:t.SmartIndenter.childStartsOnTheSameLineWithElseInIfStatement(i,e,r,l)?{indentation:a.getIndentation(),delta:s}:{indentation:a.getIndentation()+a.getDelta(e),delta:s}:{indentation:n,delta:s}}function p(t){if(t.modifiers&&t.modifiers.length)return t.modifiers[0].kind;switch(t.kind){case 241:return 77;case 242:return 111;case 240:return 91;case 244:return 244;case 159:return 127;case 160:return 138;case 157:if(t.asteriskToken)return 40;case 155:case 152:var r=e.getNameOfDeclaration(t);if(r)return r.kind}}function f(e,r,n,i){function a(t,n,i){switch(n){case 18:case 19:case 21:case 84:case 108:case 58:return!1;case 42:case 30:switch(i.kind){case 263:case 264:case 262:return!1}break;case 22:case 23:if(182!==i.kind)return!1}return r!==t&&!(e.decorators&&n===p(e))}function o(r){return t.SmartIndenter.nodeWillIndentChild(R,e,r,l,!0)?i:0}return{getIndentationForComment:function(e,t,r){switch(e){case 19:case 23:case 21:return n+o(r)}return-1!==t?t:n},getIndentationForToken:function(e,t,r,i){return!i&&a(e,t,r)?n+o(r):n},getIndentation:function(){return n},getDelta:o,recomputeIndentation:function(r){e.parent&&t.SmartIndenter.shouldIndentChildNode(R,e.parent,e,l)&&(n+=r?R.indentSize:-R.indentSize,i=t.SmartIndenter.shouldIndentChildNode(R,e)?R.indentSize:0)}}}function m(n,i,a,s,c,p){function h(t,i,a,s,c,u,p,f){var g=t.getStart(l),v=l.getLineAndCharacterOfPosition(g).line,y=v;t.decorators&&(y=l.getLineAndCharacterOfPosition(e.getNonDecoratorTokenPosOfNode(t,l)).line);var h=-1;if(p&&e.rangeContainsRange(r,a)&&(h=_(g,t.end,c,r,i),-1!==h&&(i=h)),!e.rangeOverlapsWithStartEnd(r,t.pos,t.end))return t.end<r.pos&&o.skipToEndOf(t),i;if(0===t.getFullWidth())return i;for(;o.isOnToken();){var b=o.readTokenInfo(n);if(b.token.end>g)break;C(b,n,s,n)}if(!o.isOnToken())return i;if(e.isToken(t)&&11!==t.kind){var b=o.readTokenInfo(t);return e.Debug.assert(b.token.end===t.end,"Token end is child end"),C(b,n,s,t),i}var x=153===t.kind?v:u,D=d(t,v,h,n,s,x);if(m(t,E,v,y,D.indentation,D.delta),11===t.kind){var S={pos:t.getStart(),end:t.getEnd()};T(S,D.indentation,!0,!1)}return E=n,f&&188===a.kind&&-1===i&&(i=D.indentation),i}function D(r,i,a,s){e.Debug.assert(e.isNodeArray(r));var c=b(i,r),u=s,_=a;if(0!==c)for(;o.isOnToken();){var d=o.readTokenInfo(i);if(d.token.end>r.pos)break;if(d.token.kind===c){_=l.getLineAndCharacterOfPosition(d.token.pos).line,C(d,i,s,i);var p=void 0;if(-1!==J)p=J;else{var m=e.getLineStartPositionForPosition(d.token.pos,l);p=t.SmartIndenter.findFirstNonWhitespaceColumn(m,d.token.pos,l,R)}u=f(i,a,p,R.indentSize)}else C(d,i,s,i)}for(var g=-1,v=0;v<r.length;v++){var y=r[v];g=h(y,g,n,u,_,_,!0,0===v)}var D=x(c);if(0!==D&&o.isOnToken()){var d=o.readTokenInfo(i);27===d.token.kind&&e.isCallLikeExpression(i)&&(o.advance(),d=o.isOnToken()?o.readTokenInfo(i):void 0),d&&d.token.kind===D&&e.rangeContainsRange(i,d.token)&&C(d,i,u,i,!0)}}function C(t,n,i,a,s){e.Debug.assert(e.rangeContainsRange(n,t.token));var c=o.lastTrailingTriviaWasNewLine(),_=!1;t.leadingTrivia&&v(t.leadingTrivia,n,E,i);var d=0,p=e.rangeContainsRange(r,t.token),f=l.getLineAndCharacterOfPosition(t.token.pos);if(p){var m=u(t.token),h=I;if(d=y(t.token,f,n,E,i),!m)if(0===d){var b=h&&l.getLineAndCharacterOfPosition(h.end).line;_=c&&f.line!==b}else _=1===d}if(t.trailingTrivia&&v(t.trailingTrivia,n,E,i),_){var x=p&&!u(t.token)?i.getIndentationForToken(f.line,t.token.kind,a,!!s):-1,D=!0;if(t.leadingTrivia){var C=i.getIndentationForComment(t.token.kind,x,a);D=g(t.leadingTrivia,C,D,function(e){return S(e.pos,C,!1)})}-1!==x&&D&&(S(t.token.pos,x,1===d),L=f.line,J=x)}o.advance(),E=n}if(e.rangeOverlapsWithStartEnd(r,n.getStart(l),n.getEnd())){var k=f(n,a,c,p),E=i;for(e.forEachChild(n,function(e){h(e,-1,n,k,a,s,!1)},function(e){D(e,n,a,k)});o.isOnToken();){var N=o.readTokenInfo(n);if(N.token.end>n.end)break;C(N,n,k,n)}}}function g(t,n,i,a){for(var o=0,s=t;o<s.length;o++){var c=s[o],u=e.rangeContainsRange(r,c);switch(c.kind){case 3:u&&T(c,n,!i),i=!1;break;case 2:i&&u&&a(c),i=!1;break;case 4:i=!0}}return i}function v(t,n,i,a){for(var o=0,s=t;o<s.length;o++){var c=s[o];if(e.isComment(c.kind)&&e.rangeContainsRange(r,c)){var u=l.getLineAndCharacterOfPosition(c.pos);y(c,u,n,i,a)}}}function y(e,t,n,i,a){var o=u(e),s=0;if(!o)if(I)s=h(e,t.line,n,I,M,O,i,a);else{var c=l.getLineAndCharacterOfPosition(r.pos);E(c.line,t.line)}return I=e,O=n,M=t.line,s}function h(t,r,n,i,a,o,s,c){j.updateContext(i,o,t,n,s);var u,_=B(j),d=0;if(_){switch(d=w(_,i,a,t,r)){case 2:n.getStart(l)===t.pos&&c.recomputeIndentation(!1);break;case 1:n.getStart(l)===t.pos&&c.recomputeIndentation(!0);break;default:e.Debug.assert(0===d)}u=!(8&_.action)&&1!==_.flags}else u=!0;return r!==a&&u&&E(a,r,i),d}function S(t,r,n){var i=D(r,R);if(n)P(t,0,i);else{var a=l.getLineAndCharacterOfPosition(t),o=e.getStartPositionOfLine(a.line,l);(r!==C(o,a.character)||k(i,o))&&P(o,a.character,i)}}function C(e,t){for(var r=0,n=0;t>n;n++)9===l.text.charCodeAt(e+n)?r+=R.tabSize-r%R.tabSize:r++;return r}function k(e,t){return e!==l.text.substr(t,e.length)}function T(r,n,i,a){void 0===a&&(a=!0);var o=l.getLineAndCharacterOfPosition(r.pos).line,s=l.getLineAndCharacterOfPosition(r.end).line;if(o===s)return void(i||S(r.pos,n,!1));for(var c=[],u=r.pos,_=o;s>_;_++){var d=e.getEndLinePosition(_,l);c.push({pos:u,end:d}),u=e.getStartPositionOfLine(_+1,l)}if(a&&c.push({pos:u,end:r.end}),0!==c.length){var p=e.getStartPositionOfLine(o,l),f=t.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(p,c[0].pos,l,R);if(n!==f.column){var m=0;i&&(m=1,o++);for(var g=n-f.column,v=m;v<c.length;v++,o++){var y=e.getStartPositionOfLine(o,l),h=0===v?f:t.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(c[v].pos,c[v].end,l,R),b=h.column+g;if(b>0){var x=D(b,R);P(y,h.character,x)}else F(y,h.character)}}}}function E(t,r,n){for(var i=t;r>i;i++){var a=e.getStartPositionOfLine(i,l),o=e.getEndLinePosition(i,l);if(!(n&&(e.isComment(n.kind)||e.isStringOrRegularExpressionOrTemplateLiteral(n.kind))&&n.pos<=o&&n.end>o)){var s=N(a,o);-1!==s&&(e.Debug.assert(s===a||!e.isWhiteSpaceSingleLine(l.text.charCodeAt(s-1))),F(s,o+1-s))}}}function N(t,r){for(var n=r;n>=t&&e.isWhiteSpaceSingleLine(l.text.charCodeAt(n));)n--;return n!==r?n+1:-1}function A(){var e=I?I.end:r.pos,t=l.getLineAndCharacterOfPosition(e).line,n=l.getLineAndCharacterOfPosition(r.end).line;E(t,n+1,I)}function F(t,r){r&&z.push(e.createTextChangeFromStartLength(t,r,""))}function P(t,r,n){(r||n)&&z.push(e.createTextChangeFromStartLength(t,r,n))}function w(e,t,r,n,i){var a=i!==r;switch(e.action){case 1:return 0;case 8:if(t.end!==n.pos)return F(t.end,n.pos-t.end),a?2:0;break;case 4:if(1!==e.flags&&r!==i)return 0;var o=i-r;if(1!==o)return P(t.end,n.pos-t.end,R.newLineCharacter),a?0:1;break;case 2:if(1!==e.flags&&r!==i)return 0;var s=n.pos-t.end;if(1!==s||32!==l.text.charCodeAt(t.end))return P(t.end,n.pos-t.end," "),a?2:0}return 0}var I,O,M,L,R=s.options,B=s.getRule,j=new t.FormattingContext(l,c,R),J=-1,z=[];if(o.advance(),o.isOnToken()){var V=l.getLineAndCharacterOfPosition(n.getStart(l)).line,U=V;n.decorators&&(U=l.getLineAndCharacterOfPosition(e.getNonDecoratorTokenPosOfNode(n,l)).line),m(n,n,V,U,i,a)}if(!o.isOnToken()){var K=o.getCurrentLeadingTrivia();K&&(g(K,i,!1,function(e){return y(e,l.getLineAndCharacterOfPosition(e.pos),n,n,void 0)}),A())}return z}function h(t,r,n,i){void 0===i&&(i=e.getTokenAtPosition(t,r));var a=e.findAncestor(i,e.isJSDoc);a&&(i=a.parent);var o=i.getStart(t);if(r>=o&&r<i.getEnd())return void 0;n=null===n?void 0:void 0===n?e.findPrecedingToken(r,t):n;var s=n&&e.getTrailingCommentRanges(t.text,n.end),c=e.getLeadingCommentRangesOfNode(i,t),u=e.concatenate(s,c);return u&&e.find(u,function(n){return e.rangeContainsPositionExclusive(n,r)||r===n.end&&(2===n.kind||r===t.getFullWidth())})}function b(e,t){switch(e.kind){case 158:case 240:case 197:case 157:case 156:case 198:if(e.typeParameters===t)return 28;if(e.parameters===t)return 20;break;case 192:case 193:if(e.typeArguments===t)return 28;if(e.arguments===t)return 20;break;case 165:if(e.typeArguments===t)return 28;break;case 169:return 18}return 0}function x(e){switch(e){case 20:return 21;case 28:return 30;case 18:return 19}return 0}function D(t,r){var n=!k||k.tabSize!==r.tabSize||k.indentSize!==r.indentSize;if(n&&(k={tabSize:r.tabSize,indentSize:r.indentSize},T=E=void 0),r.convertTabsToSpaces){var i=void 0,a=Math.floor(t/r.indentSize),o=t%r.indentSize;return E||(E=[]),void 0===E[a]?(i=e.repeatString(" ",r.indentSize*a),E[a]=i):i=E[a],o?i+e.repeatString(" ",o):i}var s=Math.floor(t/r.tabSize),c=t-s*r.tabSize,u=void 0;return T||(T=[]),void 0===T[s]?T[s]=u=e.repeatString("	",s):u=T[s],c?u+e.repeatString(" ",c):u}var S;!function(e){e[e.Unknown=-1]="Unknown"}(S||(S={})),t.formatOnEnter=r,t.formatOnSemicolon=n,t.formatOnOpeningCurly=i,t.formatOnClosingCurly=a,t.formatDocument=o,t.formatSelection=s,t.formatNodeGivenIndentation=m;var C;!function(e){e[e.None=0]="None",e[e.LineAdded=1]="LineAdded",e[e.LineRemoved=2]="LineRemoved"}(C||(C={})),t.getRangeOfEnclosingComment=h;var k,T,E;t.getIndentationString=D}(t=e.formatting||(e.formatting={}))}(n||(n={}));var n;!function(e){var t;!function(t){var r;!function(r){function n(r,n,s,u){if(void 0===u&&(u=!1),r>n.text.length)return c(s);if(s.indentStyle===e.IndentStyle.None)return 0;var l=e.findPrecedingToken(r,n,void 0,!0),d=t.getRangeOfEnclosingComment(n,r,l||null);if(d&&3===d.kind)return i(n,r,s,d);if(!l)return c(s);var p=e.isStringOrRegularExpressionOrTemplateLiteral(l.kind);if(p&&l.getStart(n)<=r&&r<l.end)return 0;var f=n.getLineAndCharacterOfPosition(r).line;if(s.indentStyle===e.IndentStyle.Block)return a(n,r,s);if(27===l.kind&&205!==l.parent.kind){var m=_(l,n,s);if(-1!==m)return m}var g=y(r,l.parent,n);return g&&!e.rangeContainsRange(g,l)?x(g,n,s)+s.indentSize:o(n,r,l,f,u,s)}function i(t,r,n,i){var a=e.getLineAndCharacterOfPosition(t,r).line-1,o=e.getLineAndCharacterOfPosition(t,i.pos).line;if(e.Debug.assert(o>=0),o>=a)return T(e.getStartPositionOfLine(o,t),r,t,n);var s=e.getStartPositionOfLine(a,t),c=k(s,r,t,n),u=c.column,l=c.character;if(0===u)return u;var _=t.text.charCodeAt(s+l);return 42===_?u-1:u}function a(t,r,n){for(var i=r;i>0;){var a=t.text.charCodeAt(i);if(!e.isWhiteSpaceLike(a))break;i--}var o=e.getLineStartPositionForPosition(i,t);return T(o,i,t,n)}function o(t,r,n,i,a,o){for(var s,l=n;l;){if(e.positionBelongsToNode(l,r,t)&&A(o,l,s,t,!0)){var _=f(l,t),d=p(n,l,i,t),m=0!==d?a&&2===d?o.indentSize:0:i!==_.line?o.indentSize:0;return u(l,_,void 0,m,t,!0,o)}var g=D(l,t,o,!0);if(-1!==g)return g;s=l,l=l.parent}return c(o)}function s(e,t,r,n){var i=r.getLineAndCharacterOfPosition(e.getStart(r));return u(e,i,t,0,r,!1,n)}function c(e){return e.baseIndentSize||0}function u(e,t,r,n,i,a,o){for(var s=e.parent;s;){var u=!0;if(r){var _=e.getStart(i);u=_<r.pos||_>r.end}var p=l(s,e,i),f=p.line===t.line||g(s,e,t.line,i);if(u){var v=D(e,i,o,!f);if(-1!==v)return v+n;if(v=d(e,s,t,f,i,o),-1!==v)return v+n}A(o,s,e,i,a)&&!f&&(n+=o.indentSize);var y=m(s,e,t.line,i);e=s,s=e.parent,t=y?i.getLineAndCharacterOfPosition(e.getStart(i)):p}return n+c(o)}function l(e,t,r){var n=v(t,r),i=n?n.pos:e.getStart(r);return r.getLineAndCharacterOfPosition(i)}function _(t,r,n){var i=e.findListItemInfo(t);return i&&i.listItemIndex>0?S(i.list.getChildren(),i.listItemIndex-1,r,n):-1}function d(t,r,n,i,a,o){var s=(e.isDeclaration(t)||e.isStatementButNotDeclaration(t))&&(285===r.kind||!i);return s?C(n,a,o):-1}function p(t,r,n,i){var a=e.findNextToken(t,r,i);if(!a)return 0;if(18===a.kind)return 1;if(19===a.kind){var o=f(a,i).line;return n===o?2:0}return 0}function f(e,t){return t.getLineAndCharacterOfPosition(e.getStart(t))}function m(t,r,n,i){if(!e.isCallExpression(t)||!e.contains(t.arguments,r))return!1;var a=t.expression.getEnd(),o=e.getLineAndCharacterOfPosition(i,a).line;return o===n}function g(t,r,n,i){if(223===t.kind&&t.elseStatement===r){var a=e.findChildOfKind(t,84,i);e.Debug.assert(void 0!==a);var o=f(a,i).line;return o===n}return!1}function v(e,t){return e.parent&&h(e.getStart(t),e.getEnd(),e.parent,t)}function y(e,t,r){return t&&h(e,e,t,r)}function h(t,r,n,i){function a(a){return a&&e.rangeContainsStartEnd(b(n,a,i),t,r)?a:void 0}switch(n.kind){case 165:return a(n.typeArguments);case 189:return a(n.properties);case 188:return a(n.elements);case 169:return a(n.members);case 240:case 197:case 198:case 157:case 156:case 161:case 158:case 167:case 162:return a(n.typeParameters)||a(n.parameters);case 241:case 210:case 242:case 243:case 309:return a(n.typeParameters);case 193:case 192:return a(n.typeArguments)||a(n.arguments);case 239:return a(n.declarations);case 253:case 257:return a(n.elements);case 185:case 186:return a(n.elements)}}function b(e,t,r){for(var n=e.getChildren(r),i=1;i<n.length-1;i++)if(n[i].pos===t.pos&&n[i].end===t.end)return{pos:n[i-1].end,end:n[i+1].getStart(r)};return t}function x(e,t,r){return e?C(t.getLineAndCharacterOfPosition(e.pos),t,r):-1}function D(e,t,r,n){if(e.parent&&239===e.parent.kind)return-1;var i=v(e,t);if(i){var a=i.indexOf(e);if(-1!==a){var o=S(i,a,t,r);if(-1!==o)return o}return x(i,t,r)+(n?r.indentSize:0)}return-1}function S(t,r,n,i){e.Debug.assert(r>=0&&r<t.length);for(var a=t[r],o=f(a,n),s=r-1;s>=0;s--)if(27!==t[s].kind){var c=n.getLineAndCharacterOfPosition(t[s].end).line;if(c!==o.line)return C(o,n,i);o=f(t[s],n)}return-1}function C(e,t,r){var n=t.getPositionOfLineAndCharacter(e.line,0);return T(n,n+e.character,t,r)}function k(t,r,n,i){for(var a=0,o=0,s=t;r>s;s++){var c=n.text.charCodeAt(s);if(!e.isWhiteSpaceSingleLine(c))break;9===c?o+=i.tabSize+o%i.tabSize:o++,a++}return{column:o,character:a}}function T(e,t,r,n){return k(e,t,r,n).column}function E(e,t,r,n,i){var a=r?r.kind:0;switch(t.kind){case 222:case 241:case 210:case 242:case 244:case 243:case 188:case 219:case 246:case 189:case 169:case 182:case 171:case 247:case 273:case 272:case 196:case 190:case 192:case 193:case 220:case 255:case 231:case 206:case 186:case 185:case 263:case 266:case 262:case 271:case 156:case 161:case 162:case 152:case 166:case 167:case 178:case 194:case 202:case 257:case 253:case 258:case 254:case 155:return!0;case 238:case 276:return!e.indentMultiLineObjectLiteralBeginningOnBlankLine&&n&&189===a?F(n,r):!0;case 224:case 225:case 227:case 228:case 226:case 223:case 240:case 197:case 157:case 198:case 158:case 159:case 160:return 219!==a;case 256:return 257!==a;case 250:return 251!==a||!!r.namedBindings&&253!==r.namedBindings.kind;case 261:return 264!==a;case 265:return 267!==a;case 175:case 174:if(169===a)return!1}return i}function N(e,t){switch(e){case 231:case 235:case 229:case 230:return 219!==t.kind;default:return!1}}function A(e,t,r,n,i){return void 0===i&&(i=!1),E(e,t,r,n,!1)&&!(i&&r&&N(r.kind,t))}function F(t,r){var n=e.skipTrivia(t.text,r.pos),i=t.getLineAndCharacterOfPosition(n).line,a=t.getLineAndCharacterOfPosition(r.end).line;return i===a}var P;!function(e){e[e.Unknown=-1]="Unknown"}(P||(P={})),r.getIndentation=n,r.getIndentationForNode=s,r.getBaseIndentation=c;var w;!function(e){e[e.Unknown=0]="Unknown",e[e.OpenBrace=1]="OpenBrace",e[e.CloseBrace=2]="CloseBrace"}(w||(w={})),r.isArgumentAndStartLineOverlapsExpressionBeingCalled=m,r.childStartsOnTheSameLineWithElseInIfStatement=g,r.getContainingList=v,r.findFirstNonWhitespaceCharacterAndColumn=k,r.findFirstNonWhitespaceColumn=T,r.nodeWillIndentChild=E,r.shouldIndentChildNode=A}(r=t.SmartIndenter||(t.SmartIndenter={}))}(t=e.formatting||(e.formatting={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t){var r=t.__pos;return e.Debug.assert("number"==typeof r),r}function n(t,r){e.Debug.assert("number"==typeof r),t.__pos=r}function a(t){var r=t.__end;return e.Debug.assert("number"==typeof r),r}function o(t,r){e.Debug.assert("number"==typeof r),t.__end=r}function s(t,r){return e.skipTrivia(t,r,!1,!0)}function c(t,r){for(var n=r;n<t.length;){var i=t.charCodeAt(n);{if(!e.isWhiteSpaceSingleLine(i))return 47===i;n++}}return!1}function u(e,t,r,n){return{pos:l(e,t,n),end:_(e,r,n)}}function l(t,r,n){var i=n.leadingTriviaOption;if(i===E.Exclude)return r.getStart(t);var a=r.getFullStart(),o=r.getStart(t);if(a===o)return o;var c=e.getLineStartPositionForPosition(a,t),u=e.getLineStartPositionForPosition(o,t);if(u===c)return i===E.IncludeAll?a:o;var l=a>0?1:0,_=e.getStartPositionOfLine(e.getLineOfLocalPosition(t,c)+l,t);return _=s(t.text,_),e.getStartPositionOfLine(e.getLineOfLocalPosition(t,_),t)}function _(t,r,n){var i=r.end,a=n.trailingTriviaOption;if(a===N.Exclude||e.isExpression(r)&&a!==N.Include)return i;var o=e.skipTrivia(t.text,i,!0);return o===i||a!==N.Include&&!e.isLineBreak(t.text.charCodeAt(o-1))?i:o}function d(e,t){return!!t&&!!e.parent&&(27===t.kind||26===t.kind&&189===e.parent.kind)}function p(e){for(var t="",r=0;e>r;r++)t+=" ";return t}function f(t,r){return e.skipTrivia(t.text,l(t,r,{leadingTriviaOption:E.IncludeAll}),!1,!0)}function m(t,r){return[e.findChildOfKind(t,18,r).end,e.findChildOfKind(t,19,r).end]}function g(t){return e.isObjectLiteralExpression(t)?t.properties:t.members}function v(e,t,r,n){return w.newFileChangesWorker(void 0,t,e,r,n)}function y(t,r){for(var n=r.length-1;n>=0;n--){var i=r[n],a=i.span,o=i.newText;t=""+t.substring(0,a.start)+o+t.substring(e.textSpanEnd(a))}return t}function h(t){return e.skipTrivia(t,0)===t.length}function b(t){var n=e.visitEachChild(t,b,e.nullTransformationContext,x,b),i=e.nodeIsSynthesized(n)?n:Object.create(n);return i.pos=r(t),i.end=a(t),i}function x(t,n,i,o,s){var c=e.visitNodes(t,n,i,o,s);if(!c)return c;var u=c===t?e.createNodeArray(c.slice(0)):c;return u.pos=r(t),u.end=a(t),u}function D(t){function r(){if(s<c.length){var t=c.charCodeAt(s);e.isLineBreak(t)&&(s++,s<c.length&&13===t&&10===c.charCodeAt(s)&&s++)}}for(var n,i=0,a=t.statements;i<a.length;i++){var o=a[i];if(!e.isPrologueDirective(o))break;n=o}var s=0,c=t.text;if(n)return s=n.end,r(),s;var u=e.getShebang(c);void 0!==u&&(s=u.length,r());var l=e.getLeadingCommentRanges(c,s);if(!l)return s;l.length&&3===l[0].kind&&e.isPinnedComment(c,l[0].pos)&&(s=l[0].end,r(),l=l.slice(1));for(var _=0,d=l;_<d.length;_++){var p=d[_];{if(2!==p.kind||!e.isRecognizedTripleSlashComment(c,p.pos,p.end))break;s=p.end,r()}}return s}function S(t,r){return!(e.isInComment(t,r)||e.isInString(t,r)||e.isInTemplateString(t,r)||e.isInJSXText(t,r))}function C(t,r){return(e.isPropertySignature(t)||e.isPropertyDeclaration(t))&&e.isClassOrTypeElement(r)&&150===r.name.kind||e.isStatementButNotDeclaration(t)&&e.isStatementButNotDeclaration(r)}function k(e,t,r,n){void 0===n&&(n={leadingTriviaOption:E.IncludeAll});var i=l(t,r,n),a=_(t,r,n);e.deleteRange(t,{pos:i,end:a})}function T(t,r,n,i){var a=e.Debug.assertDefined(e.formatting.SmartIndenter.getContainingList(i,n)),o=e.indexOfNode(a,i);return e.Debug.assert(-1!==o),1===a.length?void k(t,n,i):(e.Debug.assert(!r.has(i),"Deleting a node twice"),r.add(i),void t.deleteRange(n,{pos:f(n,i),end:o===a.length-1?_(n,i,{}):f(n,a[o+1])}))}var E;!function(e){e[e.Exclude=0]="Exclude",e[e.IncludeAll=1]="IncludeAll"}(E=t.LeadingTriviaOption||(t.LeadingTriviaOption={}));var N;!function(e){e[e.Exclude=0]="Exclude",e[e.Include=1]="Include"}(N=t.TrailingTriviaOption||(t.TrailingTriviaOption={}));var A,F={leadingTriviaOption:E.Exclude,trailingTriviaOption:N.Exclude};!function(e){e[e.Remove=0]="Remove",e[e.ReplaceWithSingleNode=1]="ReplaceWithSingleNode",e[e.ReplaceWithMultipleNodes=2]="ReplaceWithMultipleNodes",e[e.Text=3]="Text"}(A||(A={}));var P=function(){function t(t,r){this.newLineCharacter=t,this.formatContext=r,this.changes=[],this.newFiles=[],this.classesWithNodesInsertedAtStart=e.createMap(),this.deletedNodes=[]}return t.fromContext=function(r){return new t(e.getNewLineOrDefaultFromHost(r.host,r.formatContext.options),r.formatContext)},t.with=function(e,r){var n=t.fromContext(e);return r(n),n.getChanges()},t.prototype.deleteRange=function(e,t){this.changes.push({kind:A.Remove,sourceFile:e,range:t})},t.prototype.delete=function(e,t){this.deletedNodes.push({sourceFile:e,node:t})},t.prototype.deleteModifier=function(t,r){this.deleteRange(t,{pos:r.getStart(t),end:e.skipTrivia(t.text,r.end,!0)})},t.prototype.deleteNodeRange=function(e,t,r,n){void 0===n&&(n={leadingTriviaOption:E.IncludeAll});var i=l(e,t,n),a=_(e,r,n);this.deleteRange(e,{pos:i,end:a})},t.prototype.deleteNodeRangeExcludingEnd=function(e,t,r,n){void 0===n&&(n={leadingTriviaOption:E.IncludeAll});var i=l(e,t,n),a=void 0===r?e.text.length:l(e,r,n);this.deleteRange(e,{pos:i,end:a})},t.prototype.replaceRange=function(e,t,r,n){void 0===n&&(n={}),this.changes.push({kind:A.ReplaceWithSingleNode,sourceFile:e,range:t,options:n,node:r})},t.prototype.replaceNode=function(e,t,r,n){void 0===n&&(n=F),this.replaceRange(e,u(e,t,t,n),r,n)},t.prototype.replaceNodeRange=function(e,t,r,n,i){void 0===i&&(i=F),this.replaceRange(e,u(e,t,r,i),n,i)},t.prototype.replaceRangeWithNodes=function(e,t,r,n){void 0===n&&(n={}),this.changes.push({kind:A.ReplaceWithMultipleNodes,sourceFile:e,range:t,options:n,nodes:r})},t.prototype.replaceNodeWithNodes=function(e,t,r,n){void 0===n&&(n=F),this.replaceRangeWithNodes(e,u(e,t,t,n),r,n)},t.prototype.replaceNodeWithText=function(e,t,r){this.replaceRangeWithText(e,u(e,t,t,F),r)},t.prototype.replaceNodeRangeWithNodes=function(e,t,r,n,i){void 0===i&&(i=F),this.replaceRangeWithNodes(e,u(e,t,r,i),n,i)},t.prototype.nextCommaToken=function(t,r){var n=e.findNextToken(r,r.parent,t);return n&&27===n.kind?n:void 0},t.prototype.replacePropertyAssignment=function(e,t,r){var n=this.nextCommaToken(e,t)?"":","+this.newLineCharacter;this.replaceNode(e,t,r,{suffix:n})},t.prototype.insertNodeAt=function(t,r,n,i){void 0===i&&(i={}),this.replaceRange(t,e.createRange(r),n,i)},t.prototype.insertNodesAt=function(t,r,n,i){void 0===i&&(i={}),this.replaceRangeWithNodes(t,e.createRange(r),n,i)},t.prototype.insertNodeAtTopOfFile=function(t,r,n){var i=D(t);this.insertNodeAt(t,i,r,{prefix:0===i?void 0:this.newLineCharacter,suffix:(e.isLineBreak(t.text.charCodeAt(i))?"":this.newLineCharacter)+(n?this.newLineCharacter:"")})},t.prototype.insertNodeBefore=function(e,t,r,n){void 0===n&&(n=!1),this.insertNodeAt(e,l(e,t,{}),r,this.getOptionsForInsertNodeBefore(t,n))},t.prototype.insertModifierBefore=function(t,r,n){var i=n.getStart(t);this.insertNodeAt(t,i,e.createToken(r),{suffix:" "})},t.prototype.insertLastModifierBefore=function(t,r,n){if(!n.modifiers)return void this.insertModifierBefore(t,r,n);var i=n.modifiers.end;this.insertNodeAt(t,i,e.createToken(r),{prefix:" "})},t.prototype.insertCommentBeforeLine=function(t,r,n,i){var a=e.getStartPositionOfLine(r,t),o=e.getFirstNonSpaceCharacterPosition(t.text,a),s=S(t,o),c=e.getTouchingToken(t,s?o:n),u=t.text.slice(a,o),l=(s?"":this.newLineCharacter)+"//"+i+this.newLineCharacter+u;this.insertText(t,c.getStart(t),l)},t.prototype.insertJsdocCommentBefore=function(t,r,n){var i=r.getStart(t);if(r.jsDoc)for(var a=0,o=r.jsDoc;a<o.length;a++){var s=o[a];this.deleteRange(t,{pos:e.getLineStartPositionForPosition(s.getStart(t),t),end:_(t,s,{})})}var c=e.getPrecedingNonSpaceCharacterPosition(t.text,i-1),u=t.text.slice(c,i);this.insertNodeAt(t,i,n,{preserveLeadingWhitespace:!1,suffix:this.newLineCharacter+u})},t.prototype.replaceRangeWithText=function(e,t,r){this.changes.push({kind:A.Text,sourceFile:e,range:t,text:r})},t.prototype.insertText=function(t,r,n){this.replaceRangeWithText(t,e.createRange(r),n)},t.prototype.tryInsertTypeAnnotation=function(t,r,n){var i;if(e.isFunctionLike(r)){if(i=e.findChildOfKind(r,21,t),!i){if(!e.isArrowFunction(r))return;i=e.first(r.parameters)}}else i=238!==r.kind&&r.questionToken?r.questionToken:r.name;this.insertNodeAt(t,i.end,n,{prefix:": "})},t.prototype.insertTypeParameters=function(t,r,n){var i=(e.findChildOfKind(r,20,t)||e.first(r.parameters)).getStart(t);this.insertNodesAt(t,i,n,{prefix:"<",suffix:">"})},t.prototype.getOptionsForInsertNodeBefore=function(t,r){return e.isStatement(t)||e.isClassElement(t)?{suffix:r?this.newLineCharacter+this.newLineCharacter:this.newLineCharacter}:e.isVariableDeclaration(t)?{suffix:", "}:e.isParameter(t)?{}:e.isStringLiteral(t)&&e.isImportDeclaration(t.parent)||e.isNamedImports(t)?{suffix:", "}:e.Debug.failBadSyntaxKind(t)},t.prototype.insertNodeAtConstructorStart=function(t,r,n){var i=e.firstOrUndefined(r.body.statements);i&&r.body.multiLine?this.insertNodeBefore(t,i,n):this.replaceConstructorBody(t,r,[n].concat(r.body.statements))},t.prototype.insertNodeAtConstructorEnd=function(t,r,n){var i=e.lastOrUndefined(r.body.statements);i&&r.body.multiLine?this.insertNodeAfter(t,i,n):this.replaceConstructorBody(t,r,r.body.statements.concat([n]))},t.prototype.replaceConstructorBody=function(t,r,n){this.replaceNode(t,r.body,e.createBlock(n,!0))},t.prototype.insertNodeAtEndOfScope=function(t,r,n){var i=l(t,r.getLastToken(),{});this.insertNodeAt(t,i,n,{prefix:e.isLineBreak(t.text.charCodeAt(r.getLastToken().pos))?this.newLineCharacter:this.newLineCharacter+this.newLineCharacter,suffix:this.newLineCharacter})},t.prototype.insertNodeAtClassStart=function(e,t,r){this.insertNodeAtStartWorker(e,t,r)},t.prototype.insertNodeAtObjectStart=function(e,t,r){this.insertNodeAtStartWorker(e,t,r)},t.prototype.insertNodeAtStartWorker=function(t,r,n){var a=r.getStart(t),o=e.formatting.SmartIndenter.findFirstNonWhitespaceColumn(e.getLineStartPositionForPosition(a,t),a,t,this.formatContext.options)+this.formatContext.options.indentSize;this.insertNodeAt(t,g(r).pos,n,i({indentation:o},this.getInsertNodeAtStartPrefixSuffix(t,r)))},t.prototype.getInsertNodeAtStartPrefixSuffix=function(t,r){var n=e.isObjectLiteralExpression(r)?",":"";if(0===g(r).length){if(e.addToSeen(this.classesWithNodesInsertedAtStart,e.getNodeId(r),{node:r,sourceFile:t})){var i=e.positionsAreOnSameLine.apply(void 0,m(r,t).concat([t]));return{prefix:this.newLineCharacter,suffix:n+(i?this.newLineCharacter:"")}}return{prefix:"",suffix:n+this.newLineCharacter}}return{prefix:this.newLineCharacter,suffix:n}},t.prototype.insertNodeAfterComma=function(e,t,r){var n=this.insertNodeAfterWorker(e,this.nextCommaToken(e,t)||t,r);this.insertNodeAt(e,n,r,this.getInsertNodeAfterOptions(e,t))},t.prototype.insertNodeAfter=function(e,t,r){var n=this.insertNodeAfterWorker(e,t,r);this.insertNodeAt(e,n,r,this.getInsertNodeAfterOptions(e,t))
},t.prototype.insertNodeAtEndOfList=function(e,t,r){this.insertNodeAt(e,t.end,r,{prefix:", "})},t.prototype.insertNodesAfter=function(t,r,n){var i=this.insertNodeAfterWorker(t,r,e.first(n));this.insertNodesAt(t,i,n,this.getInsertNodeAfterOptions(t,r))},t.prototype.insertNodeAfterWorker=function(t,r,n){C(r,n)&&59!==t.text.charCodeAt(r.end-1)&&this.replaceRange(t,e.createRange(r.end),e.createToken(26));var i=_(t,r,{});return i},t.prototype.getInsertNodeAfterOptions=function(t,r){var n=this.getInsertNodeAfterOptionsWorker(r);return i({},n,{prefix:r.end===t.end&&e.isStatement(r)?n.prefix?"\n"+n.prefix:"\n":n.prefix})},t.prototype.getInsertNodeAfterOptionsWorker=function(t){switch(t.kind){case 241:case 245:return{prefix:this.newLineCharacter,suffix:this.newLineCharacter};case 238:case 10:case 73:return{prefix:", "};case 276:return{suffix:","+this.newLineCharacter};case 86:return{prefix:" "};case 152:return{};default:return e.Debug.assert(e.isStatement(t)||e.isClassOrTypeElement(t)),{suffix:this.newLineCharacter}}},t.prototype.insertName=function(t,r,n){if(e.Debug.assert(!r.name),198===r.kind){var i=e.findChildOfKind(r,37,t),a=e.findChildOfKind(r,20,t);a?(this.insertNodesAt(t,a.getStart(t),[e.createToken(91),e.createIdentifier(n)],{joiner:" "}),k(this,t,i)):(this.insertText(t,e.first(r.parameters).getStart(t),"function "+n+"("),this.replaceRange(t,i,e.createToken(21))),219!==r.body.kind&&(this.insertNodesAt(t,r.body.getStart(t),[e.createToken(18),e.createToken(98)],{joiner:" ",suffix:" "}),this.insertNodesAt(t,r.body.end,[e.createToken(26),e.createToken(19)],{joiner:" "}))}else{var o=e.findChildOfKind(r,197===r.kind?91:77,t).end;this.insertNodeAt(t,o,e.createIdentifier(n),{prefix:" "})}},t.prototype.insertExportModifier=function(e,t){this.insertText(e,t.getStart(e),"export ")},t.prototype.insertNodeInListAfter=function(t,r,n,i){if(void 0===i&&(i=e.formatting.SmartIndenter.getContainingList(r,t)),!i)return void e.Debug.fail("node is not a list element");var a=e.indexOfNode(i,r);if(!(0>a)){var o=r.getEnd();if(a!==i.length-1){var u=e.getTokenAtPosition(t,r.end);if(u&&d(r,u)){var l=e.getLineAndCharacterOfPosition(t,s(t.text,i[a+1].getFullStart())),_=e.getLineAndCharacterOfPosition(t,u.end),f=void 0,m=void 0;_.line===l.line?(m=u.end,f=p(l.character-_.character)):m=e.getStartPositionOfLine(l.line,t);var g=""+e.tokenToString(u.kind)+t.text.substring(u.end,i[a+1].getStart(t));this.replaceRange(t,e.createRange(m,i[a+1].getStart(t)),n,{prefix:f,suffix:g})}}else{var v=r.getStart(t),y=e.getLineStartPositionForPosition(v,t),h=void 0,b=!1;if(1===i.length)h=27;else{var x=e.findPrecedingToken(r.pos,t);h=d(r,x)?x.kind:27;var D=e.getLineStartPositionForPosition(i[a-1].getStart(t),t);b=D!==y}if(c(t.text,r.end)&&(b=!0),b){this.replaceRange(t,e.createRange(o),e.createToken(h));var S=e.formatting.SmartIndenter.findFirstNonWhitespaceColumn(y,v,t,this.formatContext.options),C=e.skipTrivia(t.text,o,!0,!1);C!==o&&e.isLineBreak(t.text.charCodeAt(C-1))&&C--,this.replaceRange(t,e.createRange(C),n,{indentation:S,prefix:this.newLineCharacter})}else this.replaceRange(t,e.createRange(o),n,{prefix:e.tokenToString(h)+" "})}}},t.prototype.finishClassesWithNodesInsertedAtStart=function(){var t=this;this.classesWithNodesInsertedAtStart.forEach(function(r){var n=r.node,i=r.sourceFile,a=m(n,i),o=a[0],s=a[1];e.positionsAreOnSameLine(o,s,i)&&o!==s-1&&t.deleteRange(i,e.createRange(o,s-1))})},t.prototype.finishDeleteDeclarations=function(){for(var t=this,r=new e.NodeSet,n=function(t,n){i.deletedNodes.some(function(r){return r.sourceFile===t&&e.rangeContainsRangeExclusive(r.node,n)})||(e.isArray(n)?i.deleteRange(t,e.rangeOfTypeParameters(n)):O.deleteDeclaration(i,r,t,n))},i=this,a=0,o=this.deletedNodes;a<o.length;a++){var s=o[a],c=s.sourceFile,u=s.node;n(c,u)}r.forEach(function(n){var i=n.getSourceFile(),a=e.formatting.SmartIndenter.getContainingList(n,i);if(n===e.last(a)){var o=e.findLastIndex(a,function(e){return!r.has(e)},a.length-2);-1!==o&&t.deleteRange(i,{pos:a[o].end,end:f(i,a[o+1])})}})},t.prototype.getChanges=function(e){this.finishDeleteDeclarations(),this.finishClassesWithNodesInsertedAtStart();for(var t=w.getTextChangesFromChanges(this.changes,this.newLineCharacter,this.formatContext,e),r=0,n=this.newFiles;r<n.length;r++){var i=n[r],a=i.oldFile,o=i.fileName,s=i.statements;t.push(w.newFileChanges(a,o,s,this.newLineCharacter,this.formatContext))}return t},t.prototype.createNewFile=function(e,t,r){this.newFiles.push({oldFile:e,fileName:t,statements:r})},t}();t.ChangeTracker=P,t.getNewFileText=v;var w;!function(t){function r(t,r,n,i){return e.group(t,function(e){return e.sourceFile.path}).map(function(t){for(var o=t[0].sourceFile,s=e.stableSort(t,function(e,t){return e.range.pos-t.range.pos||e.range.end-t.range.end}),c=function(t){e.Debug.assert(s[t].range.end<=s[t+1].range.pos,"Changes overlap",function(){return JSON.stringify(s[t].range)+" and "+JSON.stringify(s[t+1].range)})},u=0;u<s.length-1;u++)c(u);var l=s.map(function(t){return e.createTextChange(e.createTextSpanFromRange(t.range),a(t,o,r,n,i))});return{fileName:o.fileName,textChanges:l}})}function n(t,r,n,a,o){var s=i(t,e.getScriptKindFromFileName(r),n,a,o);return{fileName:r,textChanges:[e.createTextChange(e.createTextSpan(0,0),s)],isNewFile:!0}}function i(t,r,n,i,a){var o=n.map(function(e){return s(e,t,i).text}).join(i),c=e.createSourceFile("any file name",o,8,!0,r),u=e.formatting.formatDocument(c,a);return y(o,u)+i}function a(t,r,n,i,a){if(t.kind===A.Remove)return"";if(t.kind===A.Text)return t.text;var s=t.options,c=void 0===s?{}:s,u=t.range.pos,l=function(e){return o(e,r,u,c,n,i,a)},_=t.kind===A.ReplaceWithMultipleNodes?t.nodes.map(function(t){return e.removeSuffix(l(t),n)}).join(t.options.joiner||n):l(t.node),d=c.preserveLeadingWhitespace||void 0!==c.indentation||e.getLineStartPositionForPosition(u,r)===u?_:_.replace(/^\s+/,"");return(c.prefix||"")+d+(c.suffix||"")}function o(t,r,n,i,a,o,c){var u=i.indentation,l=i.prefix,_=i.delta,d=s(t,r,a),p=d.node,f=d.text;c&&c(p,f);var m=o.options,g=void 0!==u?u:e.formatting.SmartIndenter.getIndentation(n,r,m,l===a||e.getLineStartPositionForPosition(n,r)===n);void 0===_&&(_=e.formatting.SmartIndenter.shouldIndentChildNode(o.options,t)?m.indentSize||0:0);var v={text:f,getLineAndCharacterOfPosition:function(t){return e.getLineAndCharacterOfPosition(this,t)}},h=e.formatting.formatNodeGivenIndentation(p,v,r.languageVariant,g,_,o);return y(f,h)}function s(t,r,n){var i=new I(n),a="\n"===n?1:0;return e.createPrinter({newLine:a,neverAsciiEscape:!0},i).writeNode(4,t,r,i),{text:i.getText(),node:b(t)}}t.getTextChangesFromChanges=r,t.newFileChanges=n,t.newFileChangesWorker=i,t.getNonformattedText=s}(w||(w={})),t.applyChanges=y;var I=function(){function t(t){var r=this;this.lastNonTriviaPosition=0,this.writer=e.createTextWriter(t),this.onEmitNode=function(e,t,i){t&&n(t,r.lastNonTriviaPosition),i(e,t),t&&o(t,r.lastNonTriviaPosition)},this.onBeforeEmitNodeArray=function(e){e&&n(e,r.lastNonTriviaPosition)},this.onAfterEmitNodeArray=function(e){e&&o(e,r.lastNonTriviaPosition)},this.onBeforeEmitToken=function(e){e&&n(e,r.lastNonTriviaPosition)},this.onAfterEmitToken=function(e){e&&o(e,r.lastNonTriviaPosition)}}return t.prototype.setLastNonTriviaPosition=function(t,r){if(r||!h(t)){this.lastNonTriviaPosition=this.writer.getTextPos();for(var n=0;e.isWhiteSpaceLike(t.charCodeAt(t.length-n-1));)n++;this.lastNonTriviaPosition-=n}},t.prototype.write=function(e){this.writer.write(e),this.setLastNonTriviaPosition(e,!1)},t.prototype.writeComment=function(e){this.writer.writeComment(e)},t.prototype.writeKeyword=function(e){this.writer.writeKeyword(e),this.setLastNonTriviaPosition(e,!1)},t.prototype.writeOperator=function(e){this.writer.writeOperator(e),this.setLastNonTriviaPosition(e,!1)},t.prototype.writePunctuation=function(e){this.writer.writePunctuation(e),this.setLastNonTriviaPosition(e,!1)},t.prototype.writeTrailingSemicolon=function(e){this.writer.writeTrailingSemicolon(e),this.setLastNonTriviaPosition(e,!1)},t.prototype.writeParameter=function(e){this.writer.writeParameter(e),this.setLastNonTriviaPosition(e,!1)},t.prototype.writeProperty=function(e){this.writer.writeProperty(e),this.setLastNonTriviaPosition(e,!1)},t.prototype.writeSpace=function(e){this.writer.writeSpace(e),this.setLastNonTriviaPosition(e,!1)},t.prototype.writeStringLiteral=function(e){this.writer.writeStringLiteral(e),this.setLastNonTriviaPosition(e,!1)},t.prototype.writeSymbol=function(e,t){this.writer.writeSymbol(e,t),this.setLastNonTriviaPosition(e,!1)},t.prototype.writeLine=function(){this.writer.writeLine()},t.prototype.increaseIndent=function(){this.writer.increaseIndent()},t.prototype.decreaseIndent=function(){this.writer.decreaseIndent()},t.prototype.getText=function(){return this.writer.getText()},t.prototype.rawWrite=function(e){this.writer.rawWrite(e),this.setLastNonTriviaPosition(e,!1)},t.prototype.writeLiteral=function(e){this.writer.writeLiteral(e),this.setLastNonTriviaPosition(e,!0)},t.prototype.getTextPos=function(){return this.writer.getTextPos()},t.prototype.getLine=function(){return this.writer.getLine()},t.prototype.getColumn=function(){return this.writer.getColumn()},t.prototype.getIndent=function(){return this.writer.getIndent()},t.prototype.isAtStartOfLine=function(){return this.writer.isAtStartOfLine()},t.prototype.clear=function(){this.writer.clear(),this.lastNonTriviaPosition=0},t}();t.isValidLocationToAddComment=S;var O;!function(t){function r(t,r,o,s){switch(s.kind){case 152:var c=s.parent;e.isArrowFunction(c)&&1===c.parameters.length&&!e.findChildOfKind(c,20,o)?t.replaceNodeWithText(o,s,"()"):T(t,r,o,s);break;case 250:k(t,o,s,s===o.imports[0].parent?{leadingTriviaOption:E.Exclude}:void 0);break;case 187:var u=s.parent,l=186===u.kind&&s!==e.last(u.elements);l?k(t,o,s):T(t,r,o,s);break;case 238:a(t,r,o,s);break;case 151:T(t,r,o,s);break;case 254:var _=s.parent;1===_.elements.length?i(t,o,_):T(t,r,o,s);break;case 252:i(t,o,s);break;default:e.isImportClause(s.parent)&&s.parent.name===s?n(t,o,s.parent):e.isCallLikeExpression(s.parent)?T(t,r,o,s):k(t,o,s,26===s.kind?{trailingTriviaOption:N.Exclude}:void 0)}}function n(t,r,n){if(n.namedBindings){var i=n.name.getStart(r),a=e.getTokenAtPosition(r,n.name.end);if(a&&27===a.kind){var o=e.skipTrivia(r.text,a.end,!1,!0);t.deleteRange(r,{pos:i,end:o})}else k(t,r,n.name)}else k(t,r,n.parent)}function i(t,r,n){if(n.parent.name){var i=e.Debug.assertDefined(e.getTokenAtPosition(r,n.pos-1));t.deleteRange(r,{pos:i.getStart(r),end:n.end})}else{var a=e.getAncestor(n,250);k(t,r,a)}}function a(t,r,n,i){var a=i.parent;if(275===a.kind)return void t.deleteNodeRange(n,e.findChildOfKind(a,20,n),e.findChildOfKind(a,21,n));if(1!==a.declarations.length)return void T(t,r,n,i);var o=a.parent;switch(o.kind){case 228:case 227:t.replaceNode(n,i,e.createObjectLiteral());break;case 226:k(t,n,a);break;case 220:k(t,n,o);break;default:e.Debug.assertNever(o)}}t.deleteDeclaration=r}(O||(O={})),t.deleteNode=k}(t=e.textChanges||(e.textChanges={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t){return e.isArray(t)?e.formatStringFromArgs(e.getLocaleSpecificMessage(t[0]),t.slice(1)):e.getLocaleSpecificMessage(t)}function n(e,t,n){return a(e,r(n),t,void 0,void 0)}function i(e,t,n,i,o,s){return a(e,r(n),t,i,r(o),s)}function a(e,t,r,n,i,a){return{fixName:e,description:t,changes:r,fixId:n,fixAllDescription:i,commands:a?[a]:void 0}}function o(t){for(var r=0,n=t.errorCodes;r<n.length;r++){var i=n[r];f.add(String(i),t)}if(t.fixIds)for(var a=0,o=t.fixIds;a<o.length;a++){var s=o[a];e.Debug.assert(!m.has(s)),m.set(s,t)}}function s(){return e.arrayFrom(f.keys())}function c(t){return e.flatMap(f.get(String(t.errorCode))||e.emptyArray,function(e){return e.getCodeActions(t)})}function u(t){return m.get(e.cast(t.fixId,e.isString)).getAllCodeActions(t)}function l(e,t){return{changes:e,commands:t}}function _(e,t){return{fileName:e,textChanges:t}}function d(t,r,n){var i=[],a=e.textChanges.ChangeTracker.with(t,function(e){return p(t,r,function(t){return n(e,t,i)})});return l(a,0===i.length?void 0:i)}function p(t,r,n){for(var i=t.program,a=t.sourceFile,o=t.cancellationToken,s=0,c=i.getSemanticDiagnostics(a,o).concat(e.computeSuggestionDiagnostics(a,i,o));s<c.length;s++){var u=c[s];e.contains(r,u.code)&&n(u)}}var f=e.createMultiMap(),m=e.createMap();t.createCodeFixActionNoFixId=n,t.createCodeFixAction=i,t.registerCodeFix=o,t.getSupportedErrorCodes=s,t.getFixes=c,t.getAllFixes=u,t.createCombinedCodeActions=l,t.createFileTextChanges=_,t.codeFixAll=d,t.eachDiagnostic=p}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){function t(t){var r=t.startPosition,n=t.endPosition;return e.createTextSpanFromBounds(r,void 0===n?r:n)}var r;!function(t){function r(e,t){a.set(e,t)}function n(t){return e.arrayFrom(e.flatMapIterator(a.values(),function(e){return t.cancellationToken&&t.cancellationToken.isCancellationRequested()?void 0:e.getAvailableActions(t)}))}function i(e,t,r){var n=a.get(t);return n&&n.getEditsForAction(e,r)}var a=e.createMap();t.registerRefactor=r,t.getApplicableRefactors=n,t.getEditsForRefactor=i}(r=e.refactor||(e.refactor={})),e.getRefactorContextSpan=t}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,n){var i=e.getTokenAtPosition(r,n),a=e.Debug.assertDefined(e.findAncestor(i,function(t){return e.isAsExpression(t)||e.isTypeAssertion(t)})),o=e.isAsExpression(a)?e.createAsExpression(a.expression,e.createKeywordTypeNode(144)):e.createTypeAssertion(e.createKeywordTypeNode(144),a.expression);t.replaceNode(r,a.expression,o)}var n="addConvertToUnknownForNonOverlappingTypes",i=[e.Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first.code];t.registerCodeFix({errorCodes:i,getCodeActions:function(i){var a=e.textChanges.ChangeTracker.with(i,function(e){return r(e,i.sourceFile,i.span.start)});return[t.createCodeFixAction(n,a,e.Diagnostics.Add_unknown_conversion_for_non_overlapping_types,n,e.Diagnostics.Add_unknown_to_all_conversions_of_non_overlapping_types)]},fixIds:[n],getAllCodeActions:function(e){return t.codeFixAll(e,i,function(e,t){return r(e,t.file,t.start)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,n){var i=e.getTokenAtPosition(r,n),a=e.findAncestor(i,e.isDecorator);e.Debug.assert(!!a,"Expected position to be owned by a decorator.");var o=e.createCall(a.expression,void 0,void 0);t.replaceNode(r,a.expression,o)}var n="addMissingInvocationForDecorator",i=[e.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0.code];t.registerCodeFix({errorCodes:i,getCodeActions:function(i){var a=e.textChanges.ChangeTracker.with(i,function(e){return r(e,i.sourceFile,i.span.start)});return[t.createCodeFixAction(n,a,e.Diagnostics.Call_decorator_expression,n,e.Diagnostics.Add_to_all_uncalled_decorators)]},fixIds:[n],getAllCodeActions:function(e){return t.codeFixAll(e,i,function(e,t){return r(e,t.file,t.start)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,n){var i=e.getTokenAtPosition(r,n);if(!e.isIdentifier(i))return e.Debug.fail("add-name-to-nameless-parameter operates on identifiers, but got a "+e.Debug.formatSyntaxKind(i.kind));var a=i.parent;if(!e.isParameter(a))return e.Debug.fail("Tried to add a parameter name to a non-parameter: "+e.Debug.formatSyntaxKind(i.kind));var o=a.parent.parameters.indexOf(a);e.Debug.assert(!a.type,"Tried to add a parameter name to a parameter that already had one."),e.Debug.assert(o>-1,"Parameter not found in parent parameter list.");var s=e.createParameter(void 0,a.modifiers,a.dotDotDotToken,"arg"+o,a.questionToken,e.createTypeReferenceNode(i,void 0),a.initializer);t.replaceNode(r,i,s)}var n="addNameToNamelessParameter",i=[e.Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1.code];t.registerCodeFix({errorCodes:i,getCodeActions:function(i){var a=e.textChanges.ChangeTracker.with(i,function(e){return r(e,i.sourceFile,i.span.start)});return[t.createCodeFixAction(n,a,e.Diagnostics.Add_parameter_name,n,e.Diagnostics.Add_names_to_all_parameters_without_names)]},fixIds:[n],getAllCodeActions:function(e){return t.codeFixAll(e,i,function(e,t){return r(e,t.file,t.start)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){var i=e.getTokenAtPosition(t,r);return e.tryCast(e.isParameter(i.parent)?i.parent.parent:i.parent,n)}function n(e){return o(e)&&i(e)}function i(t){return e.isFunctionLikeDeclaration(t)?t.parameters.some(i)||!t.type&&!!e.getJSDocReturnType(t):!t.type&&!!e.getJSDocType(t)}function a(t,r,n){if(e.isFunctionLikeDeclaration(n)&&(e.getJSDocReturnType(n)||n.parameters.some(function(t){return!!e.getJSDocType(t)}))){if(!n.typeParameters){var i=e.getJSDocTypeParameterDeclarations(n);i.length&&t.insertTypeParameters(r,n,i)}var a=e.isArrowFunction(n)&&!e.findChildOfKind(n,20,r);a&&t.insertNodeBefore(r,e.first(n.parameters),e.createToken(20));for(var o=0,c=n.parameters;o<c.length;o++){var u=c[o];if(!u.type){var l=e.getJSDocType(u);l&&t.tryInsertTypeAnnotation(r,u,s(l))}}if(a&&t.insertNodeAfter(r,e.last(n.parameters),e.createToken(21)),!n.type){var _=e.getJSDocReturnType(n);_&&t.tryInsertTypeAnnotation(r,n,s(_))}}else{var d=e.Debug.assertDefined(e.getJSDocType(n));e.Debug.assert(!n.type),t.tryInsertTypeAnnotation(r,n,s(d))}}function o(t){return e.isFunctionLikeDeclaration(t)||238===t.kind||154===t.kind||155===t.kind}function s(t){switch(t.kind){case 290:case 291:return e.createTypeReferenceNode("any",e.emptyArray);case 294:return c(t);case 293:return s(t.type);case 292:return u(t);case 296:return l(t);case 295:return _(t);case 165:return p(t);default:var r=e.visitEachChild(t,s,void 0);return e.setEmitFlags(r,1),r}}function c(t){return e.createUnionTypeNode([e.visitNode(t.type,s),e.createTypeReferenceNode("undefined",e.emptyArray)])}function u(t){return e.createUnionTypeNode([e.visitNode(t.type,s),e.createTypeReferenceNode("null",e.emptyArray)])}function l(t){return e.createArrayTypeNode(e.visitNode(t.type,s))}function _(t){return e.createFunctionTypeNode(e.emptyArray,t.parameters.map(d),t.type)}function d(t){var r=t.parent.parameters.indexOf(t),n=296===t.type.kind&&r===t.parent.parameters.length-1,i=t.name||(n?"rest":"arg"+r),a=n?e.createToken(25):t.dotDotDotToken;return e.createParameter(t.decorators,t.modifiers,a,i,t.questionToken,e.visitNode(t.type,s),t.initializer)}function p(t){var r=t.typeName,n=t.typeArguments;if(e.isIdentifier(t.typeName)){if(e.isJSDocIndexSignature(t))return f(t);var i=t.typeName.text;switch(t.typeName.text){case"String":case"Boolean":case"Object":case"Number":i=i.toLowerCase();break;case"array":case"date":case"promise":i=i[0].toUpperCase()+i.slice(1)}r=e.createIdentifier(i),n="Array"!==i&&"Promise"!==i||t.typeArguments?e.visitNodes(t.typeArguments,s):e.createNodeArray([e.createTypeReferenceNode("any",e.emptyArray)])}return e.createTypeReferenceNode(r,n)}function f(t){var r=e.createParameter(void 0,void 0,void 0,136===t.typeArguments[0].kind?"n":"s",void 0,e.createTypeReferenceNode(136===t.typeArguments[0].kind?"number":"string",[]),void 0),n=e.createTypeLiteralNode([e.createIndexSignature(void 0,void 0,[r],t.typeArguments[1])]);return e.setEmitFlags(n,1),n}var m="annotateWithTypeFromJSDoc",g=[e.Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types.code];t.registerCodeFix({errorCodes:g,getCodeActions:function(n){var i=r(n.sourceFile,n.span.start);if(i){var o=e.textChanges.ChangeTracker.with(n,function(e){return a(e,n.sourceFile,i)});return[t.createCodeFixAction(m,o,e.Diagnostics.Annotate_with_type_from_JSDoc,m,e.Diagnostics.Annotate_everything_with_types_from_JSDoc)]}},fixIds:[m],getAllCodeActions:function(e){return t.codeFixAll(e,g,function(e,t){var n=r(t.file,t.start);n&&a(e,t.file,n)})}}),t.parameterShouldGetTypeFromJSDoc=n}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){switch(t){case e.Diagnostics.Parameter_0_implicitly_has_an_1_type.code:case e.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:return e.isSetAccessorDeclaration(e.getContainingFunction(r))?e.Diagnostics.Infer_type_of_0_from_usage:e.Diagnostics.Infer_parameter_types_from_usage;case e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:case e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:return e.Diagnostics.Infer_parameter_types_from_usage;default:return e.Diagnostics.Infer_type_of_0_from_usage}}function n(t){switch(t){case e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code:return e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code;case e.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:return e.Diagnostics.Variable_0_implicitly_has_an_1_type.code;case e.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:return e.Diagnostics.Parameter_0_implicitly_has_an_1_type.code;case e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:return e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code;case e.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code:return e.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code;case e.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code:return e.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code;case e.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code:return e.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code;case e.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:return e.Diagnostics.Member_0_implicitly_has_an_1_type.code}return t}function i(t,r,i,u,_,d,p,m){if(!e.isParameterPropertyModifier(i.kind)&&73!==i.kind&&25!==i.kind&&101!==i.kind)return void 0;var g=i.parent;switch(u=n(u)){case e.Diagnostics.Member_0_implicitly_has_an_1_type.code:case e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code:if(e.isVariableDeclaration(g)&&p(g)||e.isPropertyDeclaration(g)||e.isPropertySignature(g))return a(t,r,g,_,m,d),g;if(e.isPropertyAccessExpression(g)){var v=f(g.name,_,d),y=e.getTypeNodeIfAccessible(v,g,_,m);if(y){var h=e.createJSDocTypeTag(e.createJSDocTypeExpression(y),"");l(t,r,e.cast(g.parent.parent,e.isExpressionStatement),[h])}return g}return void 0;case e.Diagnostics.Variable_0_implicitly_has_an_1_type.code:var b=_.getTypeChecker().getSymbolAtLocation(i);return b&&b.valueDeclaration&&e.isVariableDeclaration(b.valueDeclaration)&&p(b.valueDeclaration)?(a(t,r,b.valueDeclaration,_,m,d),b.valueDeclaration):void 0}var x=e.getContainingFunction(i);if(void 0===x)return void 0;switch(u){case e.Diagnostics.Parameter_0_implicitly_has_an_1_type.code:if(e.isSetAccessorDeclaration(x))return s(t,r,x,_,m,d),x;case e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:if(p(x)){var D=e.cast(g,e.isParameter);return o(t,r,D,x,_,m,d),D}return void 0;case e.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code:case e.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code:return e.isGetAccessorDeclaration(x)&&e.isIdentifier(x.name)?(c(t,r,x,f(x.name,_,d),_,m),x):void 0;case e.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code:return e.isSetAccessorDeclaration(x)?(s(t,r,x,_,m,d),x):void 0;default:return e.Debug.fail(String(u))}}function a(t,r,n,i,a,o){e.isIdentifier(n.name)&&c(t,r,n,f(n.name,i,o),i,a)}function o(t,r,n,i,a,o,s){if(e.isIdentifier(n.name)){var l=m(i,r,a,s)||i.parameters.map(function(t){return{declaration:t,type:e.isIdentifier(t.name)?f(t.name,a,s):a.getTypeChecker().getAnyType()}});if(e.Debug.assert(i.parameters.length===l.length),e.isInJSFile(i))u(t,r,l,a,o);else{var _=e.isArrowFunction(i)&&!e.findChildOfKind(i,20,r);_&&t.insertNodeBefore(r,e.first(i.parameters),e.createToken(20));for(var d=0,p=l;d<p.length;d++){var g=p[d],v=g.declaration,y=g.type;!v||v.type||v.initializer||c(t,r,v,y,a,o)}_&&t.insertNodeAfter(r,e.last(i.parameters),e.createToken(21))}}}function s(t,r,n,i,a,o){var s=e.firstOrUndefined(n.parameters);if(s&&e.isIdentifier(n.name)&&e.isIdentifier(s.name)){var l=f(n.name,i,o);l===i.getTypeChecker().getAnyType()&&(l=f(s.name,i,o)),e.isInJSFile(n)?u(t,r,[{declaration:s,type:l}],i,a):c(t,r,s,l,i,a)}}function c(t,r,n,i,a,o){var s=e.getTypeNodeIfAccessible(i,n,a,o);if(s)if(e.isInJSFile(r)&&154!==n.kind){var c=e.isVariableDeclaration(n)?e.tryCast(n.parent.parent,e.isVariableStatement):n;if(!c)return;var u=e.createJSDocTypeExpression(s),_=e.isGetAccessorDeclaration(n)?e.createJSDocReturnTag(u,""):e.createJSDocTypeTag(u,"");l(t,r,c,[_])}else t.tryInsertTypeAnnotation(r,n,s)}function u(t,r,n,i,a){var o=n.length&&n[0].declaration.parent;if(o){var s=e.mapDefined(n,function(t){var r=t.declaration;if(!r.initializer&&!e.getJSDocType(r)&&e.isIdentifier(r.name)){var n=t.type&&e.getTypeNodeIfAccessible(t.type,r,i,a),o=e.getSynthesizedClone(r.name);return e.setEmitFlags(o,3584),n&&e.createJSDocParamTag(o,!!t.isOptional,e.createJSDocTypeExpression(n),"")}});l(t,r,o,s)}}function l(t,r,n,i){var a=e.mapDefined(n.jsDoc,function(e){return e.comment}),o=e.flatMapToMutable(n.jsDoc,function(e){return e.tags}),s=i.filter(function(e){return!o||!o.some(function(t,r){var n=d(t,e);return n&&(o[r]=n),!!n})}),c=e.createJSDocComment(a.join("\n"),e.createNodeArray((o||e.emptyArray).concat(s))),u=198===n.kind?_(n):n;u.jsDoc=n.jsDoc,u.jsDocCache=n.jsDocCache,t.insertJsdocCommentBefore(r,u,c)}function _(e){return 155===e.parent.kind?e.parent:e.parent.parent}function d(t,r){if(t.kind!==r.kind)return void 0;switch(t.kind){case 305:var n=t,i=r;return e.isIdentifier(n.name)&&e.isIdentifier(i.name)&&n.name.escapedText===i.name.escapedText?e.createJSDocParamTag(i.name,i.isBracketed,i.typeExpression,n.comment):void 0;case 306:return e.createJSDocReturnTag(r.typeExpression,t.comment)}}function p(t,r,n){return e.mapDefined(e.FindAllReferences.getReferenceEntriesForNode(-1,t,r,r.getSourceFiles(),n),function(t){return 0!==t.kind?e.tryCast(t.node,e.isIdentifier):void 0})}function f(e,t,r){var n=p(e,t,r),i=t.getTypeChecker(),a=y.inferTypesFromReferences(n,i,r);return y.unifyFromContext(a,i)}function m(t,r,n,i){var a;switch(t.kind){case 158:a=e.findChildOfKind(t,125,r);break;case 198:case 197:var o=t.parent;a=e.isVariableDeclaration(o)&&e.isIdentifier(o.name)?o.name:t.name;break;case 240:case 157:a=t.name}return a?y.inferTypeForParametersFromReferences(p(a,n,i),t,n,i):void 0}var g="inferFromUsage",v=[e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code,e.Diagnostics.Variable_0_implicitly_has_an_1_type.code,e.Diagnostics.Parameter_0_implicitly_has_an_1_type.code,e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code,e.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code,e.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code,e.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code,e.Diagnostics.Member_0_implicitly_has_an_1_type.code,e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code,e.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,e.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code,e.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code,e.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code,e.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code,e.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code];t.registerCodeFix({errorCodes:v,getCodeActions:function(n){var a,o=n.sourceFile,s=n.program,c=n.span.start,u=n.errorCode,l=n.cancellationToken,_=n.host,d=e.getTokenAtPosition(o,c),p=e.textChanges.ChangeTracker.with(n,function(t){a=i(t,o,d,u,s,l,e.returnTrue,_)}),f=a&&e.getNameOfDeclaration(a);return f&&0!==p.length?[t.createCodeFixAction(g,p,[r(u,d),f.getText(o)],g,e.Diagnostics.Infer_all_types_from_usage)]:void 0},fixIds:[g],getAllCodeActions:function(r){var n=r.sourceFile,a=r.program,o=r.cancellationToken,s=r.host,c=e.nodeSeenTracker();return t.codeFixAll(r,v,function(t,r){i(t,n,e.getTokenAtPosition(r.file,r.start),r.code,a,o,c,s)})}});var y;!function(t){function r(e,t,r){for(var n={},a=0,o=e;a<o.length;a++){var s=o[a];r.throwIfCancellationRequested(),i(s,t,n)}return g(n,t)}function n(t,n,a,o){var s=a.getTypeChecker();if(0===t.length)return void 0;if(!n.parameters)return void 0;for(var c={},u=0,l=t;u<l.length;u++){var _=l[u];o.throwIfCancellationRequested(),i(_,s,c)}var d=(c.constructContexts||[]).concat(c.callContexts||[]);return n.parameters.map(function(t,i){for(var c=[],u=e.isRestParameter(t),l=!1,_=0,m=d;_<m.length;_++){var g=m[_];if(g.argumentTypes.length<=i)l=e.isInJSFile(n),c.push(s.getUndefinedType());else if(u)for(var v=i;v<g.argumentTypes.length;v++)c.push(s.getBaseTypeOfLiteralType(g.argumentTypes[v]));else c.push(s.getBaseTypeOfLiteralType(g.argumentTypes[i]))}if(e.isIdentifier(t.name)){var y=r(p(t.name,a,o),s,o);c.push.apply(c,u?e.mapDefined(y,s.getElementTypeOfArrayType):y)}var h=f(c,s);return{type:u?s.createArrayType(h):h,isOptional:l&&!u,declaration:t}})}function i(t,r,n){for(;e.isRightSideOfQualifiedNameOrPropertyAccess(t);)t=t.parent;switch(t.parent.kind){case 204:n.isNumber=!0;break;case 203:o(t.parent,n);break;case 205:s(t,t.parent,r,n);break;case 272:case 273:c(t.parent,r,n);break;case 192:case 193:t.parent.expression===t?u(t.parent,r,n):a(t,r,n);break;case 190:l(t.parent,r,n);break;case 191:_(t.parent,t,r,n);break;case 238:var i=t.parent,d=i.name,p=i.initializer;if(t===d){p&&h(n,r.getTypeAtLocation(p));break}default:return a(t,r,n)}}function a(t,r,n){e.isExpressionNode(t)&&h(n,r.getContextualType(t))}function o(e,t){switch(e.operator){case 44:case 45:case 39:case 53:t.isNumber=!0;break;case 38:t.isNumberOrString=!0}}function s(t,r,n,i){switch(r.operatorToken.kind){case 41:case 40:case 42:case 43:case 46:case 47:case 48:case 49:case 50:case 51:case 62:case 64:case 63:case 65:case 66:case 70:case 71:case 72:case 67:case 69:case 68:case 39:case 28:case 31:case 30:case 32:var a=n.getTypeAtLocation(r.left===t?r.right:r.left);1056&a.flags?h(i,a):i.isNumber=!0;break;case 61:case 38:var o=n.getTypeAtLocation(r.left===t?r.right:r.left);1056&o.flags?h(i,o):296&o.flags?i.isNumber=!0:132&o.flags?i.isString=!0:i.isNumberOrString=!0;break;case 60:case 33:case 35:case 36:case 34:h(i,n.getTypeAtLocation(r.left===t?r.right:r.left));break;case 94:t===r.left&&(i.isString=!0);break;case 55:t!==r.left||238!==t.parent.parent.kind&&!e.isAssignmentExpression(t.parent.parent,!0)||h(i,n.getTypeAtLocation(r.right));break;case 54:case 27:case 95:}}function c(e,t,r){h(r,t.getTypeAtLocation(e.parent.parent.expression))}function u(e,t,r){var n={argumentTypes:[],returnType:{}};if(e.arguments)for(var a=0,o=e.arguments;a<o.length;a++){var s=o[a];
n.argumentTypes.push(t.getTypeAtLocation(s))}i(e,t,n.returnType),192===e.kind?(r.callContexts||(r.callContexts=[])).push(n):(r.constructContexts||(r.constructContexts=[])).push(n)}function l(t,r,n){var a=e.escapeLeadingUnderscores(t.name.text);n.properties||(n.properties=e.createUnderscoreEscapedMap());var o=n.properties.get(a)||{};i(t,r,o),n.properties.set(a,o)}function _(e,t,r,n){if(t===e.argumentExpression)return void(n.isNumberOrString=!0);var a=r.getTypeAtLocation(e.argumentExpression),o={};i(e,r,o),296&a.flags?n.numberIndexContext=o:n.stringIndexContext=o}function d(t,r){for(var n=[],i=0,a=t;i<a.length;i++)for(var o=a[i],s=0,c=r;s<c.length;s++){var u=c[s],l=u.high,_=u.low;l(o)&&(e.Debug.assert(!_(o)),n.push(_))}return t.filter(function(e){return n.every(function(t){return!t(e)})})}function f(e,t,r){if(void 0===r&&(r=t.getAnyType()),!e.length)return r;var n=t.getUnionType([t.getStringType(),t.getNumberType()]),i=[{high:function(e){return e===t.getStringType()||e===t.getNumberType()},low:function(e){return e===n}},{high:function(e){return!(16385&e.flags)},low:function(e){return!!(16385&e.flags)}},{high:function(e){return!(114689&e.flags||16&t.getObjectFlags(e))},low:function(e){return!!(16&t.getObjectFlags(e))}}],a=d(e,i),o=a.filter(function(e){return 16&t.getObjectFlags(e)});return o.length&&(a=a.filter(function(e){return!(16&t.getObjectFlags(e))}),a.push(m(o,t))),t.getWidenedType(t.getUnionType(a))}function m(t,r){if(1===t.length)return t[0];for(var n=[],i=[],a=[],o=[],s=!1,c=!1,u=e.createMultiMap(),l=0,_=t;l<_.length;l++){for(var d=_[l],p=0,f=r.getPropertiesOfType(d);p<f.length;p++){var m=f[p];u.add(m.name,r.getTypeOfSymbolAtLocation(m,m.valueDeclaration))}n.push.apply(n,r.getSignaturesOfType(d,0)),i.push.apply(i,r.getSignaturesOfType(d,1)),d.stringIndexInfo&&(a.push(d.stringIndexInfo.type),s=s||d.stringIndexInfo.isReadonly),d.numberIndexInfo&&(o.push(d.numberIndexInfo.type),c=c||d.numberIndexInfo.isReadonly)}var g=e.mapEntries(u,function(e,n){var i=n.length<t.length?16777216:0,a=r.createSymbol(4|i,e);return a.type=r.getUnionType(n),[e,a]});return r.createAnonymousType(t[0].symbol,g,n,i,a.length?r.createIndexInfo(r.getUnionType(a),s):void 0,o.length?r.createIndexInfo(r.getUnionType(o),c):void 0)}function g(t,r){function n(e){return f(g(e,r),r)}var i=[];if(t.isNumber&&i.push(r.getNumberType()),t.isString&&i.push(r.getStringType()),t.isNumberOrString&&i.push(r.getUnionType([r.getStringType(),r.getNumberType()])),i.push.apply(i,(t.candidateTypes||[]).map(function(e){return r.getBaseTypeOfLiteralType(e)})),t.properties&&b(t.properties.get("then"))){var a=v(0,t.properties.get("then").callContexts,!1,r),o=a.getCallSignatures().map(function(e){return e.getReturnType()});o.push(r.createPromiseType(o.length?r.getUnionType(o,2):r.getAnyType()))}else t.properties&&b(t.properties.get("push"))&&i.push(r.createArrayType(v(0,t.properties.get("push").callContexts,!1,r)));if(t.numberIndexContext)i.push(r.createArrayType(n(t.numberIndexContext)));else if(t.properties||t.callContexts||t.constructContexts||t.stringIndexContext){var s=e.createUnderscoreEscapedMap(),c=[],u=[],l=void 0;if(t.properties&&t.properties.forEach(function(e,t){var i=r.createSymbol(4,t);i.type=n(e),s.set(t,i)}),t.callContexts)for(var _=0,d=t.callContexts;_<d.length;_++){var p=d[_];c.push(y(p,r))}if(t.constructContexts)for(var m=0,h=t.constructContexts;m<h.length;m++){var x=h[m];u.push(y(x,r))}t.stringIndexContext&&(l=r.createIndexInfo(n(t.stringIndexContext),!1)),i.push(r.createAnonymousType(void 0,s,c,u,l,void 0))}return i}function v(t,r,n,i){var a=[];if(r)for(var o=0,s=r;o<s.length;o++){var c=s[o];c.argumentTypes.length>t&&(n?a=e.concatenate(a,e.map(c.argumentTypes.slice(t),function(e){return i.getBaseTypeOfLiteralType(e)})):a.push(i.getBaseTypeOfLiteralType(c.argumentTypes[t])))}if(a.length){var u=i.getWidenedType(i.getUnionType(a,2));return n?i.createArrayType(u):u}return void 0}function y(t,r){for(var n=[],i=0;i<t.argumentTypes.length;i++){var a=r.createSymbol(1,e.escapeLeadingUnderscores("arg"+i));a.type=r.getWidenedType(r.getBaseTypeOfLiteralType(t.argumentTypes[i])),n.push(a)}var o=f(g(t.returnType,r),r,r.getVoidType());return r.createSignature(void 0,void 0,void 0,n,o,void 0,t.argumentTypes.length,!1,!1)}function h(e,t){!t||1&t.flags||131072&t.flags||(e.candidateTypes||(e.candidateTypes=[])).push(t)}function b(e){return!!e&&!!e.callContexts}t.inferTypesFromReferences=r,t.inferTypeForParametersFromReferences=n,t.unifyFromContext=f}(y||(y={}))}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,i,a){function o(i){function a(t,r){return e.isFunctionLike(r)}function o(i,o){if(8192&i.flags){var s=i.valueDeclaration,c=s.parent;if(a(s,c.right)){var u=c.parent&&222===c.parent.kind?c.parent:c;if(t.delete(r,u),!c.right)return e.createProperty([],o,i.name,void 0,void 0,void 0);switch(c.right.kind){case 197:var l=c.right,_=e.concatenate(o,n(l,122)),d=e.createMethod(void 0,_,void 0,s.name,void 0,void 0,l.parameters,void 0,l.body);return e.copyLeadingComments(c,d,r),d;case 198:var p=c.right,f=p.body,m=void 0;m=219===f.kind?f:e.createBlock([e.createReturn(f)]);var _=e.concatenate(o,n(p,122)),d=e.createMethod(void 0,_,void 0,s.name,void 0,void 0,p.parameters,void 0,m);return e.copyLeadingComments(c,d,r),d;default:if(e.isSourceFileJS(r))return;var g=e.createProperty(void 0,o,s.name,void 0,void 0,c.right);return e.copyLeadingComments(c.parent,g,r),g}}}}var s=[];return i.members&&i.members.forEach(function(e){var t=o(e,void 0);t&&s.push(t)}),i.exports&&i.exports.forEach(function(t){var r=o(t,[e.createToken(117)]);r&&s.push(r)}),s}function s(t){var r=t.initializer;if(!r||197!==r.kind)return void 0;if(73!==t.name.kind)return void 0;var i=o(t.symbol);r.body&&i.unshift(e.createConstructor(void 0,void 0,r.parameters,r.body));var a=n(l,86),s=e.createClassDeclaration(void 0,a,t.name,void 0,void 0,i);return s}function c(t){var r=o(u);t.body&&r.unshift(e.createConstructor(void 0,void 0,t.parameters,t.body));var i=n(t,86),a=e.createClassDeclaration(void 0,i,t.name,void 0,void 0,r);return a}var u=a.getSymbolAtLocation(e.getTokenAtPosition(r,i));if(!(u&&19&u.flags))return void 0;var l,_,d=u.valueDeclaration;switch(d.kind){case 240:l=d,t.delete(r,d),_=c(d);break;case 238:l=d.parent.parent,_=s(d),1===d.parent.declarations.length?(e.copyLeadingComments(l,_,r),t.delete(r,l)):t.delete(r,d)}return _?(e.copyLeadingComments(d,_,r),void t.insertNodeAfter(r,l,_)):void 0}function n(t,r){return e.filter(t.modifiers,function(e){return e.kind===r})}var i="convertFunctionToEs6Class",a=[e.Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration.code];t.registerCodeFix({errorCodes:a,getCodeActions:function(n){var a=e.textChanges.ChangeTracker.with(n,function(e){return r(e,n.sourceFile,n.span.start,n.program.getTypeChecker())});return[t.createCodeFixAction(i,a,e.Diagnostics.Convert_function_to_an_ES2015_class,i,e.Diagnostics.Convert_all_constructor_functions_to_classes)]},fixIds:[i],getAllCodeActions:function(e){return t.codeFixAll(e,a,function(t,n){return r(t,n.file,n.start,e.program.getTypeChecker())})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,o,s,u){function l(e,n){var i=_(e,D,e);t.replaceNodeWithNodes(r,n,i)}var d,p=e.getTokenAtPosition(r,o);if(d=e.isIdentifier(p)&&e.isVariableDeclaration(p.parent)&&p.parent.initializer&&e.isFunctionLikeDeclaration(p.parent.initializer)?p.parent.initializer:e.tryCast(e.getContainingFunction(e.getTokenAtPosition(r,o)),e.isFunctionLikeDeclaration)){var f=e.createMap(),m=e.createMap(),g=[],v=e.isInJSFile(d),y=a(d,s),h=c(d,s,f,u,y,m,g),b=i(f),x=h.body&&e.isBlock(h.body)?n(h.body):e.emptyArray,D={checker:s,synthNamesMap:f,allVarNames:g,setOfExpressionsToReturn:y,constIdentifiers:b,originalTypeMap:m,isInJSFile:v};if(x.length){t.insertLastModifierBefore(r,122,d);for(var S=function(t){e.forEachChild(t,function r(n){e.isCallExpression(n)?l(n,t):e.isFunctionLike(n)||e.forEachChild(n,r)})},C=0,k=x;C<k.length;C++){var T=k[C];S(T)}}}}function n(t){var r=[];return e.forEachReturnStatement(t,function(t){e.isReturnStatementWithFixablePromiseHandler(t)&&r.push(t)}),r}function i(e){var t=[];return e.forEach(function(e){0===e.numberOfAssignmentsOriginal&&t.push(e.identifier)}),t}function a(t,r){if(!t.body)return e.createMap();var n=e.createMap();return e.forEachChild(t.body,function i(t){o(t,r,"then")?(n.set(e.getNodeId(t).toString(),!0),e.forEach(t.arguments,i)):o(t,r,"catch")?(n.set(e.getNodeId(t).toString(),!0),e.forEachChild(t,i)):o(t,r)?n.set(e.getNodeId(t).toString(),!0):e.forEachChild(t,i)}),n}function o(t,r,n){var i=n?e.isCallExpression(t):e.isExpression(t),a=i&&(!n||e.hasPropertyAccessExpressionWithName(t,n)),o=a&&r.getTypeAtLocation(t);return!(!o||!r.getPromisedTypeOfPromise(o))}function s(e,t){return e.valueDeclaration&&e.valueDeclaration.getSourceFile()===t}function c(t,r,n,i,a,o,c){function _(t){var n=t.parent;if(e.isCallExpression(n)||e.isIdentifier(n)&&!a.get(e.getNodeId(n).toString())){var i=r.getTypeAtLocation(n),o=i&&r.getPromisedTypeOfPromise(i);return!!o}return!1}function d(t,i){if(e.isIdentifier(t)){var s=r.getSymbolAtLocation(t),c=s&&e.getSymbolId(s).toString(),u=s&&n.get(c);if(u){var l=r.getTypeAtLocation(t);o.set(e.getNodeId(i).toString(),l)}}var _=a.get(e.getNodeId(t).toString());void 0!==_&&(a.delete(e.getNodeId(t).toString()),a.set(e.getNodeId(i).toString(),_))}var p=e.createMap(),f=e.createMap();return e.forEachChild(t,function m(t){if(!e.isIdentifier(t))return void e.forEachChild(t,m);var a=r.getSymbolAtLocation(t),o=a&&s(a,i.sourceFile);if(a&&o){var d=r.getTypeAtLocation(t),g=b(d,r),v=e.getSymbolId(a).toString();if(!g||e.isFunctionLikeDeclaration(t.parent)||n.has(v)){if(t.parent&&(e.isParameter(t.parent)||e.isVariableDeclaration(t.parent)||e.isBindingElement(t.parent))){var y=t.text,h=f.get(y);if(h&&h.some(function(e){return e!==a})){var x=l(t,f);p.set(v,x.identifier),n.set(v,x),c.push({identifier:x.identifier,symbol:a}),u(f,y,a)}else{var D=e.getSynthesizedDeepClone(t);p.set(v,D),n.set(v,T(D,[],c.filter(function(e){return e.identifier.text===t.text}).length)),(e.isParameter(t.parent)&&_(t.parent.parent)||e.isVariableDeclaration(t.parent))&&(c.push({identifier:D,symbol:a}),u(f,y,a))}}}else{var S=e.firstOrUndefined(g.parameters),C=S&&e.isParameter(S.valueDeclaration)&&e.tryCast(S.valueDeclaration.name,e.isIdentifier)||e.createOptimisticUniqueName("result"),k=l(C,f);n.set(v,k),c.push({identifier:k.identifier,symbol:a}),u(f,C.text,a)}}}),e.getSynthesizedDeepCloneWithRenames(t,!0,p,r,d)}function u(e,t,r){e.has(t)?e.get(t).push(r):e.set(t,[r])}function l(t,r){var n=(r.get(t.text)||e.emptyArray).length,i=0,a=0===n?t:e.createIdentifier(t.text+"_"+n);return T(a,[],i)}function _(t,r,n,i){if(!t)return e.emptyArray;var a=e.isIdentifier(t)&&r.originalTypeMap.get(e.getNodeId(t).toString()),o=a||r.checker.getTypeAtLocation(t);return e.isCallExpression(t)&&e.hasPropertyAccessExpressionWithName(t,"then")&&o&&r.checker.getPromisedTypeOfPromise(o)?m(t,r,n,i):e.isCallExpression(t)&&e.hasPropertyAccessExpressionWithName(t,"catch")&&o&&r.checker.getPromisedTypeOfPromise(o)?d(t,r,i):e.isPropertyAccessExpression(t)?_(t.expression,r,n,i):o&&r.checker.getPromisedTypeOfPromise(o)?v(t,r,i):(w=!1,e.emptyArray)}function d(t,r,n){var i,a=t.arguments[0],o=S(a,r),s=r.setOfExpressionsToReturn.get(e.getNodeId(t).toString());n&&!s&&(N(n)?(i=n,r.synthNamesMap.forEach(function(e,t){if(e.identifier.text===n.identifier.text){var i=f(n);r.synthNamesMap.set(t,i)}})):i=T(e.createOptimisticUniqueName("result"),n.types),i.numberOfAssignmentsOriginal=2,r.constIdentifiers.some(function(e){return e.text===i.identifier.text})&&r.constIdentifiers.push(f(i).identifier));var c,u,l=e.createBlock(_(t.expression,r,t,i)),d=h(a,i,o,t,r),p=o?N(o)?o.identifier.text:o.bindingPattern:"e",m=e.createVariableDeclaration(p),g=e.createCatchClause(m,e.createBlock(d));if(i&&!s){u=e.getSynthesizedDeepClone(i.identifier);var v=i.types,y=r.checker.getUnionType(v,2),b=r.isInJSFile?void 0:r.checker.typeToTypeNode(y),x=[e.createVariableDeclaration(u,b)];c=e.createVariableStatement(void 0,e.createVariableDeclarationList(x,1))}var D=e.createTry(l,g,void 0),C=n&&u&&A(n)&&e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.getSynthesizedDeepCloneWithRenames(n.bindingPattern),void 0,u)],2));return e.compact([c,D,C])}function p(t){return e.isIdentifier(t)?[t.text]:e.flatMap(t.elements,function(t){return e.isOmittedExpression(t)?[]:p(t.name)})}function f(t){var r=e.createOptimisticUniqueName(t.identifier.text);return T(r)}function m(t,r,n,i){var a=t.arguments,o=a[0],s=a[1];if(!o)return _(t.expression,r,n);var c=S(o,r),u=h(o,i,c,t,r);if(s){var l=S(s,r),d=e.createBlock(_(t.expression,r,t,c).concat(u)),p=h(s,i,l,t,r),f=l?N(l)?l.identifier.text:l.bindingPattern:"e",m=e.createVariableDeclaration(f),g=e.createCatchClause(m,e.createBlock(p));return[e.createTry(d,g,void 0)]}return _(t.expression,r,t,c).concat(u)}function g(t,r){var n=p(k(t)),i=r.some(function(t){return e.contains(n,t.text)});return i?2:1}function v(t,r,n){var i=r.setOfExpressionsToReturn.get(e.getNodeId(t).toString()),a=t.original?t.original.parent:t.parent;return!n||i||a&&!e.isPropertyAccessExpression(a)?n||i||a&&!e.isPropertyAccessExpression(a)?[e.createReturn(e.getSynthesizedDeepClone(t))]:[e.createStatement(e.createAwait(t))]:y(n,e.createAwait(t),r)}function y(t,r,n){return!t||C(t)?[e.createStatement(r)]:N(t)&&t.types.length<t.numberOfAssignmentsOriginal?[e.createStatement(e.createAssignment(e.getSynthesizedDeepClone(t.identifier),r))]:[e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.getSynthesizedDeepClone(k(t)),void 0,r)],g(t,n.constIdentifiers)))]}function h(t,r,n,i,a){var o=a.setOfExpressionsToReturn.get(e.getNodeId(i).toString());switch(t.kind){case 97:break;case 73:if(!n)break;var s=e.createCall(e.getSynthesizedDeepClone(t),void 0,N(n)?[n.identifier]:[]);if(o)return[e.createReturn(s)];var c=a.originalTypeMap.get(e.getNodeId(t).toString())||a.checker.getTypeAtLocation(t),u=a.checker.getSignaturesOfType(c,0);if(!u.length){w=!1;break}var l=u[0].getReturnType(),_=y(r,e.createAwait(s),a);return r&&r.types.push(l),_;case 197:case 198:var d=t.body;if(e.isBlock(d)){for(var p=[],f=!1,m=0,g=d.statements;m<g.length;m++){var v=g[m];e.isReturnStatement(v)&&(f=!0),e.isReturnStatementWithFixablePromiseHandler(v)?p=p.concat(D(a,[v],r)):p.push(v)}return o?p.map(function(t){return e.getSynthesizedDeepClone(t)}):x(p,r,a,f)}var h=e.isFixablePromiseHandler(d)?[e.createReturn(d)]:e.emptyArray,S=D(a,h,r);if(S.length>0)return S;var C=a.checker.getTypeAtLocation(t),k=b(C,a.checker).getReturnType(),T=e.getSynthesizedDeepClone(d),E=a.checker.getPromisedTypeOfPromise(k)?e.createAwait(T):T;if(o)return[e.createReturn(E)];var A=y(r,E,a);return r&&r.types.push(k),A;default:w=!1}return e.emptyArray}function b(t,r){var n=r.getSignaturesOfType(t,0);return e.lastOrUndefined(n)}function x(t,r,n,i){for(var a=[],s=0,c=t;s<c.length;s++){var u=c[s];if(e.isReturnStatement(u)){if(u.expression){var l=o(u.expression,n.checker)?e.createAwait(u.expression):u.expression;a.push(void 0===r?e.createExpressionStatement(l):e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(k(r),void 0,l)],g(r,n.constIdentifiers))))}}else a.push(e.getSynthesizedDeepClone(u))}return i||void 0===r||a.push(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(k(r),void 0,e.createIdentifier("undefined"))],g(r,n.constIdentifiers)))),a}function D(t,r,n){for(var i=[],a=0,o=r;a<o.length;a++){var s=o[a];e.forEachChild(s,function c(r){if(e.isCallExpression(r)){var a=_(r,t,r,n);if(i=i.concat(a),i.length>0)return}else e.isFunctionLike(r)||e.forEachChild(r,c)})}return i}function S(t,r){function n(t){if(e.isIdentifier(t))return i(t);var r=e.flatMap(t.elements,function(t){return e.isOmittedExpression(t)?[]:[n(t.name)]});return E(t,r)}function i(t){var n=o(t),i=a(n);if(!i)return T(t,u,c);var s=r.synthNamesMap.get(e.getSymbolId(i).toString());return s||T(t,u,c)}function a(e){return e.symbol?e.symbol:r.checker.getSymbolAtLocation(e)}function o(e){return e.original?e.original:e}var s,c=0,u=[];if(e.isFunctionLikeDeclaration(t)){if(t.parameters.length>0){var l=t.parameters[0].name;s=n(l)}}else e.isIdentifier(t)&&(s=i(t));return!s||"identifier"in s&&"undefined"===s.identifier.text?void 0:s}function C(t){return t?N(t)?!t.identifier.text:e.every(t.elements,C):!0}function k(e){return N(e)?e.identifier:e.bindingPattern}function T(e,t,r){return void 0===t&&(t=[]),void 0===r&&(r=0),{kind:0,identifier:e,types:t,numberOfAssignmentsOriginal:r}}function E(t,r,n){return void 0===r&&(r=e.emptyArray),void 0===n&&(n=[]),{kind:1,bindingPattern:t,elements:r,types:n}}function N(e){return 0===e.kind}function A(e){return 1===e.kind}var F="convertToAsyncFunction",P=[e.Diagnostics.This_may_be_converted_to_an_async_function.code],w=!0;t.registerCodeFix({errorCodes:P,getCodeActions:function(n){w=!0;var i=e.textChanges.ChangeTracker.with(n,function(e){return r(e,n.sourceFile,n.span.start,n.program.getTypeChecker(),n)});return w?[t.createCodeFixAction(F,i,e.Diagnostics.Convert_to_async_function,F,e.Diagnostics.Convert_all_to_async_functions)]:[]},fixIds:[F],getAllCodeActions:function(e){return t.codeFixAll(e,P,function(t,n){return r(t,n.file,n.start,e.program.getTypeChecker(),e)})}});var I;!function(e){e[e.Identifier=0]="Identifier",e[e.BindingPattern=1]="BindingPattern"}(I||(I={}))}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,n,i){for(var a=0,o=t.imports;a<o.length;a++){var s=o[a],c=e.getResolvedModule(t,s.text);if(c&&c.resolvedFileName===r.fileName){var u=e.importFromModuleSpecifier(s);switch(u.kind){case 249:n.replaceNode(t,u,e.makeImport(u.name,void 0,s,i));break;case 192:e.isRequireCall(u,!1)&&n.replaceNode(t,u,e.createPropertyAccess(e.getSynthesizedDeepClone(u),"default"))}}}}function n(t,r,n,o,c){var u={original:x(t),additional:e.createMap()},l=i(t,r,u);a(t,l,n);for(var _=!1,d=0,p=t.statements;d<p.length;d++){var f=p[d],m=s(t,f,r,n,u,o,l,c);_=_||m}return _}function i(t,r,n){var i=e.createMap();return o(t,function(t){var a=t.name,o=a.text,s=a.originalKeywordKind;!i.has(o)&&(void 0!==s&&e.isNonContextualKeyword(s)||r.resolveName(t.name.text,t,67220415,!0))&&i.set(o,b("_"+o,n))}),i}function a(t,r,n){o(t,function(i,a){if(!a){var o=i.name.text;n.replaceNode(t,i,e.createIdentifier(r.get(o)||o))}})}function o(t,r){t.forEachChild(function n(i){if(e.isPropertyAccessExpression(i)&&e.isExportsOrModuleExportsOrAlias(t,i.expression)){var a=i.parent;r(i,e.isBinaryExpression(a)&&a.left===i&&60===a.operatorToken.kind)}i.forEachChild(n)})}function s(t,r,n,i,a,o,s,u){switch(r.kind){case 220:return c(t,r,i,n,a,o,u),!1;case 222:var _=r.expression;switch(_.kind){case 192:return e.isRequireCall(_,!0)&&i.replaceNode(t,r,e.makeImport(void 0,void 0,_.arguments[0],u)),!1;case 205:var d=_.operatorToken;return 60===d.kind&&l(t,n,_,i,s)}default:return!1}}function c(t,r,n,i,a,o,s){var c=r.declarationList,l=!1,_=e.flatMap(c.declarations,function(r){var _=r.name,d=r.initializer;if(d){if(e.isExportsOrModuleExportsOrAlias(t,d))return l=!0,[];if(e.isRequireCall(d,!0))return l=!0,y(t,_,d.arguments[0],n,i,a,o,s);if(e.isPropertyAccessExpression(d)&&e.isRequireCall(d.expression,!0))return l=!0,u(_,d.name.text,d.expression.arguments[0],a,s)}return e.createVariableStatement(void 0,e.createVariableDeclarationList([r],c.flags))});l&&n.replaceNodeWithNodes(t,r,_)}function u(t,r,n,i,a){switch(t.kind){case 185:case 186:var o=b(r,i);return[T(o,r,n,a),N(void 0,t,e.createIdentifier(o))];case 73:return[T(t.text,r,n,a)];default:return e.Debug.assertNever(t)}}function l(t,r,n,i,a){var o=n.left,s=n.right;if(!e.isPropertyAccessExpression(o))return!1;if(e.isExportsOrModuleExportsOrAlias(t,o)){if(!e.isExportsOrModuleExportsOrAlias(t,s)){var c=e.isObjectLiteralExpression(s)?_(s):e.isRequireCall(s,!0)?p(s.arguments[0],r):void 0;return c?(i.replaceNodeWithNodes(t,n.parent,c[0]),c[1]):(i.replaceRangeWithText(t,e.createRange(o.getStart(t),s.pos),"export default"),!0)}i.delete(t,n.parent)}else e.isExportsOrModuleExportsOrAlias(t,o.expression)&&d(t,n,i,a);return!1}function _(t){var r=e.mapAllOrFail(t.properties,function(t){switch(t.kind){case 159:case 160:case 277:case 278:return void 0;case 276:return e.isIdentifier(t.name)?v(t.name.text,t.initializer):void 0;case 157:return e.isIdentifier(t.name)?C(t.name.text,[e.createToken(86)],t):void 0;default:e.Debug.assertNever(t)}});return r&&[r,!1]}function d(t,r,n,i){var a=r.left.name.text,o=i.get(a);if(void 0!==o){var s=[N(void 0,o,r.right),A([e.createExportSpecifier(o,a)])];n.replaceNodeWithNodes(t,r.parent,s)}else g(r,t,n)}function p(t,r){var n=t.text,i=r.getSymbolAtLocation(t),a=i?i.exports:e.emptyUnderscoreEscapedMap;return a.has("export=")?[[m(n)],!0]:a.has("default")?a.size>1?[[f(n),m(n)],!0]:[[m(n)],!0]:[[f(n)],!1]}function f(e){return A(void 0,e)}function m(t){return A([e.createExportSpecifier(void 0,"default")],t)}function g(t,r,n){var i=t.left,a=t.right,o=t.parent,s=i.name.text;if(!(e.isFunctionExpression(a)||e.isArrowFunction(a)||e.isClassExpression(a))||a.name&&a.name.text!==s)n.replaceNodeRangeWithNodes(r,i.expression,e.findChildOfKind(i,24,r),[e.createToken(86),e.createToken(78)],{joiner:" ",suffix:" "});else{n.replaceRange(r,{pos:i.getStart(r),end:a.getStart(r)},e.createToken(86),{suffix:" "}),a.name||n.insertName(r,a,s);var c=e.findChildOfKind(o,26,r);c&&n.delete(r,c)}}function v(t,r){function n(){return N(i,e.createIdentifier(t),r)}var i=[e.createToken(86)];switch(r.kind){case 197:var a=r.name;if(a&&a.text!==t)return n();case 198:return C(t,i,r);case 210:return k(t,i,r);default:return n()}}function y(r,n,i,a,o,s,c,u){switch(n.kind){case 185:var l=e.mapAllOrFail(n.elements,function(t){return t.dotDotDotToken||t.initializer||t.propertyName&&!e.isIdentifier(t.propertyName)||!e.isIdentifier(t.name)?void 0:E(t.propertyName&&t.propertyName.text,t.name.text)});if(l)return[e.makeImport(void 0,l,i,u)];case 186:var _=b(t.moduleSpecifierToValidIdentifier(i.text,c),s);return[e.makeImport(e.createIdentifier(_),void 0,i,u),N(void 0,e.getSynthesizedDeepClone(n),e.createIdentifier(_))];case 73:return h(r,n,i,a,o,s,u);default:return e.Debug.assertNever(n)}}function h(t,r,n,i,a,o,s){for(var c=a.getSymbolAtLocation(r),u=e.createMap(),l=!1,_=0,d=o.original.get(r.text);_<d.length;_++){var p=d[_];if(a.getSymbolAtLocation(p)===c&&p!==r){var f=p.parent;if(e.isPropertyAccessExpression(f)){var m=f.expression,g=f.name.text;e.Debug.assert(m===p);var v=u.get(g);void 0===v&&(v=b(g,o),u.set(g,v)),i.replaceNode(t,f,e.createIdentifier(v))}else l=!0}}var y=0===u.size?void 0:e.arrayFrom(e.mapIterator(u.entries(),function(t){var r=t[0],n=t[1];return e.createImportSpecifier(r===n?void 0:e.createIdentifier(r),e.createIdentifier(n))}));return y||(l=!0),[e.makeImport(l?e.getSynthesizedDeepClone(r):void 0,y,n,s)]}function b(e,t){for(;t.original.has(e)||t.additional.has(e);)e="_"+e;return t.additional.set(e,!0),e}function x(t){var r=e.createMultiMap();return D(t,function(e){return r.add(e.text,e)}),r}function D(t,r){e.isIdentifier(t)&&S(t)&&r(t),t.forEachChild(function(e){return D(e,r)})}function S(e){var t=e.parent;switch(t.kind){case 190:return t.name!==e;case 187:return t.propertyName!==e;case 254:return t.propertyName!==e;default:return!0}}function C(t,r,n){return e.createFunctionDeclaration(e.getSynthesizedDeepClones(n.decorators),e.concatenate(r,e.getSynthesizedDeepClones(n.modifiers)),e.getSynthesizedDeepClone(n.asteriskToken),t,e.getSynthesizedDeepClones(n.typeParameters),e.getSynthesizedDeepClones(n.parameters),e.getSynthesizedDeepClone(n.type),e.convertToFunctionBody(e.getSynthesizedDeepClone(n.body)))}function k(t,r,n){return e.createClassDeclaration(e.getSynthesizedDeepClones(n.decorators),e.concatenate(r,e.getSynthesizedDeepClones(n.modifiers)),t,e.getSynthesizedDeepClones(n.typeParameters),e.getSynthesizedDeepClones(n.heritageClauses),e.getSynthesizedDeepClones(n.members))}function T(t,r,n,i){return"default"===r?e.makeImport(e.createIdentifier(t),void 0,n,i):e.makeImport(void 0,[E(r,t)],n,i)}function E(t,r){return e.createImportSpecifier(void 0!==t&&t!==r?e.createIdentifier(t):void 0,e.createIdentifier(r))}function N(t,r,n){return e.createVariableStatement(t,e.createVariableDeclarationList([e.createVariableDeclaration(r,void 0,n)],2))}function A(t,r){return e.createExportDeclaration(void 0,void 0,t&&e.createNamedExports(t),void 0===r?void 0:e.createLiteral(r))}t.registerCodeFix({errorCodes:[e.Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES6_module.code],getCodeActions:function(i){var a=i.sourceFile,o=i.program,s=i.preferences,c=e.textChanges.ChangeTracker.with(i,function(t){var i=n(a,o.getTypeChecker(),t,o.getCompilerOptions().target,e.getQuotePreference(a,s));if(i)for(var c=0,u=o.getSourceFiles();c<u.length;c++){var l=u[c];r(l,a,t,e.getQuotePreference(l,s))}});return[t.createCodeFixActionNoFixId("convertToEs6Module",c,e.Diagnostics.Convert_to_ES6_module)]}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){var n=e.findAncestor(e.getTokenAtPosition(t,r),e.isQualifiedName);return e.Debug.assert(!!n,"Expected position to be owned by a qualified name."),e.isIdentifier(n.left)?n:void 0}function n(t,r,n){var i=n.right.text,a=e.createIndexedAccessTypeNode(e.createTypeReferenceNode(n.left,void 0),e.createLiteralTypeNode(e.createLiteral(i)));t.replaceNode(r,n,a)}var i="correctQualifiedNameToIndexedAccessType",a=[e.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1.code];t.registerCodeFix({errorCodes:a,getCodeActions:function(a){var o=r(a.sourceFile,a.span.start);if(!o)return void 0;var s=e.textChanges.ChangeTracker.with(a,function(e){return n(e,a.sourceFile,o)}),c=o.left.text+'["'+o.right.text+'"]';return[t.createCodeFixAction(i,s,[e.Diagnostics.Rewrite_as_the_indexed_access_type_0,c],i,e.Diagnostics.Rewrite_all_as_indexed_access_types)]},fixIds:[i],getAllCodeActions:function(e){return t.codeFixAll(e,a,function(e,t){var i=r(t.file,t.start);i&&n(e,t.file,i)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){return e.Debug.assertDefined(e.getContainingClass(e.getTokenAtPosition(t,r)))}function n(t){return!(8&e.getModifierFlags(t.valueDeclaration))}function i(r,i,o,s,c,u){function l(e,n){var i=_.getIndexInfoOfType(e,n);i&&c.insertNodeAtClassStart(o,s,_.indexInfoToIndexSignatureDeclaration(i,n,s,void 0,t.getNoopSymbolTrackerWithResolver(r)))}var _=r.program.getTypeChecker(),d=a(s,_),p=_.getTypeAtLocation(i),f=_.getPropertiesOfType(p),m=f.filter(e.and(n,function(e){return!d.has(e.escapedName)})),g=_.getTypeAtLocation(s);g.getNumberIndexType()||l(p,1),g.getStringIndexType()||l(p,0),t.createMissingMemberNodes(s,m,r,u,function(e){return c.insertNodeAtClassStart(o,s,e)})}function a(t,r){var i=e.getEffectiveBaseTypeNode(t);if(!i)return e.createSymbolTable();var a=r.getTypeAtLocation(i),o=r.getPropertiesOfType(a);return e.createSymbolTable(o.filter(n))}var o=[e.Diagnostics.Class_0_incorrectly_implements_interface_1.code,e.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code],s="fixClassIncorrectlyImplementsInterface";t.registerCodeFix({errorCodes:o,getCodeActions:function(n){var a=n.sourceFile,o=n.span,c=r(a,o.start);return e.mapDefined(e.getClassImplementsHeritageClauseElements(c),function(r){var o=e.textChanges.ChangeTracker.with(n,function(e){return i(n,r,a,c,e,n.preferences)});return 0===o.length?void 0:t.createCodeFixAction(s,o,[e.Diagnostics.Implement_interface_0,r.getText(a)],s,e.Diagnostics.Implement_all_unimplemented_interfaces)})},fixIds:[s],getAllCodeActions:function(n){var a=e.createMap();return t.codeFixAll(n,o,function(t,o){var s=r(o.file,o.start);if(e.addToSeen(a,e.getNodeId(s)))for(var c=0,u=e.getClassImplementsHeritageClauseElements(s);c<u.length;c++){var l=u[c];i(n,l,o.file,s,t,n.preferences)}})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,i,o,c,u,l,_,p){var f=a(t,r,o,i,u.getCompilerOptions(),u.getTypeChecker(),u.getSourceFiles());e.Debug.assert(f.some(function(e){return e.moduleSymbol===r}));var m=e.first(d(u,i,_,f,c,p)).moduleSpecifier,g=e.first(s(f,o,_,u,i,c,p));return{moduleSpecifier:m,codeAction:n(k({host:c,formatContext:l},i,o,g,e.getQuotePreference(i,p)))}}function n(e){var t=e.description,r=e.changes,n=e.commands;return{description:t,changes:r,commands:n}}function a(t,r,n,i,a,s,c){var u=[];return O(s,c,function(c,l){if(!l||c===r||!e.startsWith(i.fileName,e.getDirectoryPath(l.fileName))){var _=x(c,s,a);_&&_.name===n&&e.skipAlias(_.symbol,s)===t&&u.push({moduleSymbol:c,importKind:_.kind,exportedSymbolIsTypeOnly:o(_.symbol,s)});for(var d=0,p=s.getExportsOfModule(c);d<p.length;d++){var f=p[d];f.name===n&&e.skipAlias(f,s)===t&&u.push({moduleSymbol:c,importKind:0,exportedSymbolIsTypeOnly:o(f,s)})}}}),u}function o(t,r){return!(67220415&e.skipAlias(t,r).flags)}function s(t,r,n,i,a,o,s){var l=i.getTypeChecker(),d=e.flatMap(t,function(e){return _(e,l,a)}),f=void 0===n?void 0:c(d,r,n,l),m=u(d),g=m?[m]:p(t,d,i,a,n,o,s);return(f?[f]:e.emptyArray).concat(g)}function c(t,r,n,i){return e.firstDefined(t,function(t){var a=t.declaration,o=l(a);if(o){var s=i.getAliasedSymbol(i.getSymbolAtLocation(o));if(s&&s.exports.has(e.escapeLeadingUnderscores(r)))return{kind:0,namespacePrefix:o.text,position:n}}})}function u(t){return e.firstDefined(t,function(e){var t=e.declaration,r=e.importKind;if(250!==t.kind)return void 0;var n=t.importClause;if(!n)return void 0;var i=n.name,a=n.namedBindings;return 1===r&&!i||0===r&&(!a||253===a.kind)?{kind:2,importClause:n,importKind:r}:void 0})}function l(t){if(250===t.kind){var r=t.importClause&&e.isImportClause(t.importClause)&&t.importClause.namedBindings;return r&&252===r.kind?r.name:void 0}return t.name}function _(t,r,n){var i=t.moduleSymbol,a=t.importKind,o=t.exportedSymbolIsTypeOnly;return o&&e.isSourceFileJS(n)?e.emptyArray:e.mapDefined(n.imports,function(t){var n=e.importFromModuleSpecifier(t);return 250!==n.kind&&249!==n.kind||r.getSymbolAtLocation(t)!==i?void 0:{declaration:n,importKind:a}})}function d(t,r,n,i,a,o){var s=e.isSourceFileJS(r),c=e.flatMap(i,function(i){var c=i.moduleSymbol,u=i.importKind,l=i.exportedSymbolIsTypeOnly;return e.moduleSpecifiers.getModuleSpecifiers(c,t.getCompilerOptions(),r,a,t.getSourceFiles(),o,t.redirectTargetsMap).map(function(t){return l&&s?{kind:1,moduleSpecifier:t,position:e.Debug.assertDefined(n)}:{kind:3,moduleSpecifier:t,importKind:u}})});return e.sort(c,function(e,t){return e.moduleSpecifier.length-t.moduleSpecifier.length})}function p(t,r,n,i,a,o,s){var c=e.firstDefined(r,f);return c?[c]:d(n,i,a,t,o,s)}function f(t){var r=t.declaration,n=t.importKind,i=250===r.kind?r.moduleSpecifier:260===r.moduleReference.kind?r.moduleReference.expression:void 0;return i&&e.isStringLiteral(i)?{kind:3,moduleSpecifier:i.text,importKind:n}:void 0}function m(t,r,n){var a=e.getTokenAtPosition(t.sourceFile,n),o=r===e.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code?g(t,a):e.isIdentifier(a)?h(t,a):void 0;return o&&i({},o,{fixes:e.sort(o.fixes,function(e,t){return e.kind-t.kind})})}function g(t,r){var n=t.sourceFile,i=t.program,a=t.host,o=t.preferences,c=i.getTypeChecker(),u=v(r,c);if(!u)return void 0;var l=c.getAliasedSymbol(u),_=u.name,d=[{moduleSymbol:l,importKind:y(i.getCompilerOptions()),exportedSymbolIsTypeOnly:!1}],p=s(d,_,e.isIdentifier(r)?r.getStart(n):void 0,i,n,a,o);return{fixes:p,symbolName:_}}function v(t,r){var n=e.isIdentifier(t)?r.getSymbolAtLocation(t):void 0;if(e.isUMDExportSymbol(n))return n;var i=t.parent;return e.isJsxOpeningLikeElement(i)&&i.tagName===t||e.isJsxOpeningFragment(i)?e.tryCast(r.resolveName(r.getJsxNamespace(i),e.isJsxOpeningLikeElement(i)?t:i,67220415,!1),e.isUMDExportSymbol):void 0
}function y(t){if(e.getAllowSyntheticDefaultImports(t))return 1;var r=e.getEmitModuleKind(t);switch(r){case e.ModuleKind.AMD:case e.ModuleKind.CommonJS:case e.ModuleKind.UMD:return 3;case e.ModuleKind.System:case e.ModuleKind.ES2015:case e.ModuleKind.ESNext:case e.ModuleKind.None:return 2;default:return e.Debug.assertNever(r)}}function h(t,r){var n=t.sourceFile,i=t.program,a=t.cancellationToken,o=t.host,c=t.preferences,u=i.getTypeChecker(),l=e.isJsxOpeningLikeElement(r.parent)&&r.parent.tagName===r&&(e.isIntrinsicJsxName(r.text)||u.resolveName(r.text,r,67108863,!1))?u.getJsxNamespace(n):r.text;e.Debug.assert("default"!==l);var _=e.arrayFrom(e.flatMapIterator(b(l,e.getMeaningFromLocation(r),a,n,u,i).entries(),function(e){var t=(e[0],e[1]);return s(t,l,r.getStart(n),i,n,o,c)}));return{fixes:_,symbolName:l}}function b(t,r,n,i,a,s){function c(t,r,n){u.add(e.getUniqueSymbolId(r,a).toString(),{moduleSymbol:t,importKind:n,exportedSymbolIsTypeOnly:o(r,a)})}var u=e.createMultiMap();return I(a,i,s.getSourceFiles(),function(e){n.throwIfCancellationRequested();var i=x(e,a,s.getCompilerOptions());i&&i.name===t&&w(i.symbolForMeaning,r)&&c(e,i.symbol,i.kind);var o=a.tryGetMemberInModuleExportsAndProperties(t,e);o&&w(o,r)&&c(e,o,0)}),u}function x(e,t,r){var n=D(e,t);if(!n)return void 0;var a=n.symbol,o=n.kind,s=S(a,e,t,r);return s&&i({symbol:a,kind:o},s)}function D(e,t){var r=t.tryGetMemberInModuleExports("default",e);if(r)return{symbol:r,kind:1};var n=t.resolveExternalModuleSymbol(e);return n===e?void 0:{symbol:n,kind:3}}function S(t,r,n,i){var a=e.getLocalSymbolForExportDefault(t);if(a)return{symbolForMeaning:a,name:a.name};var o=C(t);if(void 0!==o)return{symbolForMeaning:t,name:o};if(2097152&t.flags){var s=n.getImmediateAliasedSymbol(t);return s&&S(s,e.Debug.assertDefined(s.parent),n,i)}return{symbolForMeaning:t,name:L(r,i.target)}}function C(t){return t.declarations&&e.firstDefined(t.declarations,function(t){if(e.isExportAssignment(t)){if(e.isIdentifier(t.expression))return t.expression.text}else if(e.isExportSpecifier(t))return e.Debug.assert("default"===t.name.text),t.propertyName&&t.propertyName.text})}function k(r,n,i,a,o){var s,c=e.textChanges.ChangeTracker.with(r,function(e){s=T(e,n,i,a,o)});return t.createCodeFixAction("import",c,s,t.importFixId,e.Diagnostics.Add_all_missing_imports)}function T(t,r,n,i,a){switch(i.kind){case 0:return N(t,r,i),[e.Diagnostics.Change_0_to_1,n,i.namespacePrefix+"."+n];case 1:return A(t,r,i,a),[e.Diagnostics.Change_0_to_1,n,F(i.moduleSpecifier,a)+n];case 2:var o=i.importClause,s=i.importKind;E(t,r,o,1===s?n:void 0,0===s?[n]:e.emptyArray);var c=e.stripQuotes(o.parent.moduleSpecifier.getText());return[1===s?e.Diagnostics.Add_default_import_0_to_existing_import_declaration_from_1:e.Diagnostics.Add_0_to_existing_import_declaration_from_1,n,c];case 3:var s=i.importKind,u=i.moduleSpecifier;return P(t,r,u,a,1===s?{defaultImport:n,namedImports:e.emptyArray,namespaceLikeImport:void 0}:0===s?{defaultImport:void 0,namedImports:[n],namespaceLikeImport:void 0}:{defaultImport:void 0,namedImports:e.emptyArray,namespaceLikeImport:{importKind:s,name:n}}),[1===s?e.Diagnostics.Import_default_0_from_module_1:e.Diagnostics.Import_0_from_module_1,n,u];default:return e.Debug.assertNever(i)}}function E(t,r,n,i,a){if(i&&(e.Debug.assert(!n.name),t.insertNodeAt(r,n.getStart(r),e.createIdentifier(i),{suffix:", "})),a.length){var o=a.map(function(t){return e.createImportSpecifier(void 0,e.createIdentifier(t))});if(n.namedBindings&&e.cast(n.namedBindings,e.isNamedImports).elements.length)for(var s=0,c=o;s<c.length;s++){var u=c[s];t.insertNodeInListAfter(r,e.last(e.cast(n.namedBindings,e.isNamedImports).elements),u)}else if(o.length){var l=e.createNamedImports(o);n.namedBindings?t.replaceNode(r,n.namedBindings,l):t.insertNodeAfter(r,e.Debug.assertDefined(n.name),l)}}}function N(e,t,r){var n=r.namespacePrefix,i=r.position;e.insertText(t,i,n+".")}function A(e,t,r,n){var i=r.moduleSpecifier,a=r.position;e.insertText(t,a,F(i,n))}function F(t,r){var n=e.getQuoteFromPreference(r);return"import("+n+t+n+")."}function P(t,r,n,i,a){var o=a.defaultImport,s=a.namedImports,c=a.namespaceLikeImport,u=e.makeStringLiteral(n,i);(void 0!==o||s.length)&&e.insertImport(t,r,e.makeImport(void 0===o?void 0:e.createIdentifier(o),s.map(function(t){return e.createImportSpecifier(void 0,e.createIdentifier(t))}),n,i)),c&&e.insertImport(t,r,3===c.importKind?e.createImportEqualsDeclaration(void 0,void 0,e.createIdentifier(c.name),e.createExternalModuleReference(u)):e.createImportDeclaration(void 0,void 0,e.createImportClause(void 0,e.createNamespaceImport(e.createIdentifier(c.name))),u))}function w(t,r){var n=t.declarations;return e.some(n,function(t){return!!(e.getMeaningFromDeclaration(t)&r)})}function I(e,t,r,n){O(e,r,function(e,r){(void 0===r||r!==t&&M(t.fileName,r.fileName))&&n(e)})}function O(t,r,n){for(var i=0,a=t.getAmbientModules();i<a.length;i++){var o=a[i];n(o,void 0)}for(var s=0,c=r;s<c.length;s++){var u=c[s];e.isExternalOrCommonJsModule(u)&&n(t.getMergedSymbol(u.symbol),u)}}function M(t,r){var n=e.forEachAncestorDirectory(r,function(t){return"node_modules"===e.getBaseFileName(t)?t:void 0});return void 0===n||e.startsWith(t,e.getDirectoryPath(n))}function L(t,r){return R(e.removeFileExtension(e.stripQuotes(t.name)),r)}function R(t,r){var n=e.getBaseFileName(e.removeSuffix(t,"/index")),i="",a=!0,o=n.charCodeAt(0);e.isIdentifierStart(o,r)?i+=String.fromCharCode(o):a=!1;for(var s=1;s<n.length;s++){var c=n.charCodeAt(s),u=e.isIdentifierPart(c,r);if(u){var l=String.fromCharCode(c);a||(l=l.toUpperCase()),i+=l}a=u}return e.isStringANonContextualKeyword(i)?"_"+i:i||"_"}t.importFixId="fixMissingImport";var B=[e.Diagnostics.Cannot_find_name_0.code,e.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code,e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,e.Diagnostics.Cannot_find_namespace_0.code,e.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code,e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here.code];t.registerCodeFix({errorCodes:B,getCodeActions:function(t){var r=t.errorCode,n=t.preferences,i=t.sourceFile,a=t.span,o=m(t,r,a.start);if(!o)return void 0;var s=o.fixes,c=o.symbolName,u=e.getQuotePreference(i,n);return s.map(function(e){return k(t,i,c,e,u)})},fixIds:[t.importFixId],getAllCodeActions:function(r){var n=r.sourceFile,i=r.preferences,a=[],o=[],s=e.createMap(),c=e.createMap();return t.eachDiagnostic(r,B,function(t){var n=m(r,t.code,t.start);if(n&&n.fixes.length){var i=n.fixes,u=n.symbolName,l=e.first(i);switch(l.kind){case 0:a.push(l);break;case 1:o.push(l);break;case 2:var _=l.importClause,d=l.importKind,p=String(e.getNodeId(_)),f=s.get(p);f||s.set(p,f={importClause:_,defaultImport:void 0,namedImports:[]}),0===d?e.pushIfUnique(f.namedImports,u):(e.Debug.assert(void 0===f.defaultImport||f.defaultImport===u),f.defaultImport=u);break;case 3:var g=l.moduleSpecifier,d=l.importKind,f=c.get(g);switch(f||c.set(g,f={defaultImport:void 0,namedImports:[],namespaceLikeImport:void 0}),d){case 1:e.Debug.assert(void 0===f.defaultImport||f.defaultImport===u),f.defaultImport=u;break;case 0:e.pushIfUnique(f.namedImports,u);break;case 3:case 2:e.Debug.assert(void 0===f.namespaceLikeImport||f.namespaceLikeImport.name===u),f.namespaceLikeImport={importKind:d,name:u}}break;default:e.Debug.assertNever(l)}}}),t.createCombinedCodeActions(e.textChanges.ChangeTracker.with(r,function(t){for(var r=e.getQuotePreference(n,i),u=0,l=a;u<l.length;u++){var _=l[u];N(t,n,_)}for(var d=0,p=o;d<p.length;d++){var _=p[d];A(t,n,_,r)}s.forEach(function(e){var r=e.importClause,i=e.defaultImport,a=e.namedImports;E(t,n,r,i,a)}),c.forEach(function(e,i){P(t,n,i,r,e)})}))}});var j;!function(e){e[e.UseNamespace=0]="UseNamespace",e[e.ImportType=1]="ImportType",e[e.AddToExisting=2]="AddToExisting",e[e.AddNew=3]="AddNew"}(j||(j={}));var J;!function(e){e[e.Named=0]="Named",e[e.Default=1]="Default",e[e.Namespace=2]="Namespace",e[e.Equals=3]="Equals"}(J||(J={})),t.getImportCompletionAction=r,t.forEachExternalModuleToImportFrom=I,t.moduleSymbolToValidIdentifier=L,t.moduleSpecifierToValidIdentifier=R}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,n){var o,s=e.getTokenAtPosition(t,r),c=n.program.getTypeChecker();if(e.isPropertyAccessExpression(s.parent)&&s.parent.name===s){e.Debug.assert(73===s.kind);var u=c.getTypeAtLocation(s.parent.expression);o=c.getSuggestionForNonexistentProperty(s,u)}else if(e.isImportSpecifier(s.parent)&&s.parent.name===s){e.Debug.assert(73===s.kind);var l=e.findAncestor(s,e.isImportDeclaration),_=a(t,n,l);_&&_.symbol&&(o=c.getSuggestionForNonexistentExport(s,_.symbol))}else{var d=e.getMeaningFromLocation(s),p=e.getTextOfNode(s);e.Debug.assert(void 0!==p,"name should be defined"),o=c.getSuggestionForNonexistentSymbol(s,p,i(d))}return void 0===o?void 0:{node:s,suggestion:o}}function n(t,r,n,i,a){!e.isIdentifierText(i,a)&&e.isPropertyAccessExpression(n.parent)?t.replaceNode(r,n.parent,e.createElementAccess(n.parent.expression,e.createLiteral(i))):t.replaceNode(r,n,e.createIdentifier(i))}function i(e){var t=0;return 4&e&&(t|=1920),2&e&&(t|=67897832),1&e&&(t|=67220415),t}function a(t,r,n){if(!n||!e.isStringLiteralLike(n.moduleSpecifier))return void 0;var i=e.getResolvedModule(t,n.moduleSpecifier.text);return i?r.program.getSourceFile(i.resolvedFileName):void 0}var o="fixSpelling",s=[e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,e.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code,e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,e.Diagnostics.Module_0_has_no_exported_member_1_Did_you_mean_2.code];t.registerCodeFix({errorCodes:s,getCodeActions:function(i){var a=i.sourceFile,s=r(a,i.span.start,i);if(!s)return void 0;var c=s.node,u=s.suggestion,l=i.host.getCompilationSettings().target,_=e.textChanges.ChangeTracker.with(i,function(e){return n(e,a,c,u,l)});return[t.createCodeFixAction("spelling",_,[e.Diagnostics.Change_spelling_to_0,u],o,e.Diagnostics.Fix_all_detected_spelling_errors)]},fixIds:[o],getAllCodeActions:function(e){return t.codeFixAll(e,s,function(t,i){var a=r(i.file,i.start,e),o=e.host.getCompilationSettings().target;a&&n(t,e.sourceFile,a.node,a.suggestion,o)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){for(var n=[];t;){var i=e.getClassExtendsHeritageElement(t),a=i&&r.getSymbolAtLocation(i.expression),o=a&&e.find(a.declarations,e.isClassLike);o&&n.push(o),t=o}return n}function n(t,r,n,i){var a=e.getTokenAtPosition(t,r);if(!e.isIdentifier(a))return void 0;var o=a.parent;if(!e.isPropertyAccessExpression(o))return void 0;var s=e.skipConstraint(n.getTypeAtLocation(o.expression)),c=s.symbol;if(!c||!c.declarations)return void 0;var u=e.find(c.declarations,e.isClassLike)||e.find(c.declarations,e.isInterfaceDeclaration);if(u&&!i.isSourceFileFromExternalLibrary(u.getSourceFile())){var l=(s.target||s)!==n.getDeclaredTypeOfSymbol(c),_=u.getSourceFile(),d=e.isSourceFileJS(_),p=e.tryCast(o.parent,e.isCallExpression);return{kind:1,token:a,parentDeclaration:u,makeStatic:l,declSourceFile:_,inJs:d,call:p}}var f=e.find(c.declarations,e.isEnumDeclaration);return f&&!i.isSourceFileFromExternalLibrary(f.getSourceFile())?{kind:0,token:a,parentDeclaration:f}:void 0}function i(r,n,i,o,s){var c=e.textChanges.ChangeTracker.with(r,function(e){return a(e,n,i,o,s)});return 0===c.length?void 0:t.createCodeFixAction(g,c,[s?e.Diagnostics.Initialize_static_property_0:e.Diagnostics.Initialize_property_0_in_the_constructor,o],y,e.Diagnostics.Add_all_missing_members)}function a(t,r,n,i,a){if(a){if(210===n.kind)return;var s=n.name.getText(),c=o(e.createIdentifier(s),i);t.insertNodeAfter(r,n,c)}else{var u=e.getFirstConstructorWithBody(n);if(!u)return;var l=o(e.createThis(),i);t.insertNodeAtConstructorEnd(r,u,l)}}function o(t,r){return e.createStatement(e.createAssignment(e.createPropertyAccess(t,r),e.createIdentifier("undefined")))}function s(e,t,r,n,i){var a=c(e.program.getTypeChecker(),r,n),o=u(e,t,r,i,n.text,a);return i?[o]:[o,d(e,t,r,n.text,a)]}function c(t,r,n){var i;if(205===n.parent.parent.kind){var a=n.parent.parent,o=n.parent===a.left?a.right:a.left,s=t.getWidenedType(t.getBaseTypeOfLiteralType(t.getTypeAtLocation(o)));i=t.typeToTypeNode(s,r)}else{var c=t.getContextualType(n.parent);i=c?t.typeToTypeNode(c):void 0}return i||e.createKeywordTypeNode(121)}function u(r,n,i,a,o,s){var c=e.textChanges.ChangeTracker.with(r,function(e){return l(e,n,i,o,s,a)});return t.createCodeFixAction(g,c,[a?e.Diagnostics.Declare_static_property_0:e.Diagnostics.Declare_property_0,o],y,e.Diagnostics.Add_all_missing_members)}function l(t,r,n,i,a,o){var s=e.createProperty(void 0,o?[e.createToken(117)]:void 0,i,void 0,a,void 0),c=_(n);c?t.insertNodeAfter(r,c,s):t.insertNodeAtClassStart(r,n,s)}function _(t){for(var r,n=0,i=t.members;n<i.length;n++){var a=i[n];if(!e.isPropertyDeclaration(a))break;r=a}return r}function d(r,n,i,a,o){var s=e.createKeywordTypeNode(139),c=e.createParameter(void 0,void 0,void 0,"x",void 0,s,void 0),u=e.createIndexSignature(void 0,void 0,[c],o),l=e.textChanges.ChangeTracker.with(r,function(e){return e.insertNodeAtClassStart(n,i,u)});return t.createCodeFixActionNoFixId(g,l,[e.Diagnostics.Add_index_signature_for_property_0,a])}function p(r,n,i,a,o,s,c,u){var l=e.textChanges.ChangeTracker.with(r,function(e){return f(r,e,n,i,a,o,s,c,u)});return t.createCodeFixAction(g,l,[s?e.Diagnostics.Declare_static_method_0:e.Diagnostics.Declare_method_0,a.text],y,e.Diagnostics.Add_all_missing_members)}function f(r,n,i,a,o,s,c,u,l){var _=t.createMethodFromCallExpression(r,s,o.text,u,c,l,a),d=e.getAncestor(s,157);d&&d.parent===a?n.insertNodeAfter(i,d,_):n.insertNodeAtClassStart(i,a,_)}function m(t,r,n,i){var a=e.some(i.members,function(e){var t=r.getTypeAtLocation(e);return!!(t&&132&t.flags)}),o=e.createEnumMember(n,a?e.createStringLiteral(n.text):void 0);t.replaceNode(i.getSourceFile(),i,e.updateEnumDeclaration(i,i.decorators,i.modifiers,i.name,e.concatenate(i.members,e.singleElementArray(o))))}var g="addMissingMember",v=[e.Diagnostics.Property_0_does_not_exist_on_type_1.code,e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,e.Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2.code,e.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2.code,e.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more.code],y="addMissingMember";t.registerCodeFix({errorCodes:v,getCodeActions:function(r){var a=n(r.sourceFile,r.span.start,r.program.getTypeChecker(),r.program);if(!a)return void 0;if(0===a.kind){var o=a.token,c=a.parentDeclaration,u=e.textChanges.ChangeTracker.with(r,function(e){return m(e,r.program.getTypeChecker(),o,c)});return[t.createCodeFixAction(g,u,[e.Diagnostics.Add_missing_enum_member_0,o.text],y,e.Diagnostics.Add_all_missing_members)]}var l=a.parentDeclaration,_=a.declSourceFile,d=a.inJs,f=a.makeStatic,v=a.token,h=a.call,b=h&&p(r,_,l,v,h,f,d,r.preferences),x=d&&!e.isInterfaceDeclaration(l)?e.singleElementArray(i(r,_,l,v.text,f)):s(r,_,l,v,f);return e.concatenate(e.singleElementArray(b),x)},fixIds:[y],getAllCodeActions:function(i){var o=i.program,s=i.preferences,u=o.getTypeChecker(),_=e.createMap(),d=new e.NodeMap;return t.createCombinedCodeActions(e.textChanges.ChangeTracker.with(i,function(p){t.eachDiagnostic(i,v,function(t){var r=n(t.file,t.start,u,i.program);if(r&&e.addToSeen(_,e.getNodeId(r.parentDeclaration)+"#"+r.token.text))if(0===r.kind){var a=r.token,o=r.parentDeclaration;m(p,u,a,o)}else{var o=r.parentDeclaration,s=r.token,c=d.getOrUpdate(o,function(){return[]});c.some(function(e){return e.token.text===s.text})||c.push(r)}}),d.forEach(function(t,n){for(var _=r(n,u),m=function(t){if(_.some(function(e){var r=d.get(e);return!!r&&r.some(function(e){var r=e.token;return r.text===t.token.text})}))return"continue";var r=t.parentDeclaration,n=t.declSourceFile,u=t.inJs,m=t.makeStatic,g=t.token,v=t.call;if(v)f(i,p,n,r,g,v,m,u,s);else if(u&&!e.isInterfaceDeclaration(r))a(p,n,r,g.text,m);else{var y=c(o.getTypeChecker(),r,g);l(p,n,r,g.text,y,m)}},g=0,v=t;g<v.length;g++){var y=v[g];m(y)}})}))}});var h;!function(e){e[e.Enum=0]="Enum",e[e.ClassOrInterface=1]="ClassOrInterface"}(h||(h={}))}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,i){var a=e.cast(n(r,i),e.isCallExpression),o=e.createNew(a.expression,a.typeArguments,a.arguments);t.replaceNode(r,a,o)}function n(t,r){for(var n=e.getTokenAtPosition(t,r.start),i=e.textSpanEnd(r);n.end<i;)n=n.parent;return n}var i="addMissingNewOperator",a=[e.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new.code];t.registerCodeFix({errorCodes:a,getCodeActions:function(n){var a=n.sourceFile,o=n.span,s=e.textChanges.ChangeTracker.with(n,function(e){return r(e,a,o)});return[t.createCodeFixAction(i,s,e.Diagnostics.Add_missing_new_operator_to_call,i,e.Diagnostics.Add_missing_new_operator_to_all_calls)]},fixIds:[i],getAllCodeActions:function(e){return t.codeFixAll(e,a,function(t,n){return r(t,e.sourceFile,n)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(e,t){return{type:"install package",file:e,packageName:t}}function n(t,r){var n=e.cast(e.getTokenAtPosition(t,r),e.isStringLiteral).text,i=e.parsePackageName(n).packageName;return e.isExternalModuleNameRelative(i)?void 0:i}function i(t,r,n){return n===s?e.JsTyping.nodeCoreModules.has(t)?"@types/node":void 0:r.isKnownTypesPackageName(t)?e.getTypesPackageName(t):void 0}var a="fixCannotFindModule",o="installTypesPackage",s=e.Diagnostics.Cannot_find_module_0.code,c=[s,e.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type.code];t.registerCodeFix({errorCodes:c,getCodeActions:function(s){var c=s.host,u=s.sourceFile,l=s.span.start,_=n(u,l);if(void 0===_)return void 0;var d=i(_,c,s.errorCode);return void 0===d?[]:[t.createCodeFixAction(a,[],[e.Diagnostics.Install_0,d],o,e.Diagnostics.Install_all_missing_types_packages,r(u.fileName,d))]},fixIds:[o],getAllCodeActions:function(a){return t.codeFixAll(a,c,function(t,s,c){var u=n(s.file,s.start);if(void 0===u)return void 0;switch(a.fixId){case o:var l=i(u,a.host,s.code);l&&c.push(r(s.file.fileName,l));break;default:e.Debug.fail("Bad fixId: "+a.fixId)}})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){var n=e.getTokenAtPosition(t,r);return e.cast(n.parent,e.isClassLike)}function n(r,n,a,o,s){var c=e.getEffectiveBaseTypeNode(r),u=a.program.getTypeChecker(),l=u.getTypeAtLocation(c),_=u.getPropertiesOfType(l).filter(i);t.createMissingMemberNodes(r,_,a,s,function(e){return o.insertNodeAtClassStart(n,r,e)})}function i(t){var r=e.getModifierFlags(e.first(t.getDeclarations()));return!(8&r||!(128&r))}var a=[e.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2.code,e.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1.code],o="fixClassDoesntImplementInheritedAbstractMember";t.registerCodeFix({errorCodes:a,getCodeActions:function(i){var a=i.sourceFile,s=i.span,c=e.textChanges.ChangeTracker.with(i,function(e){return n(r(a,s.start),a,i,e,i.preferences)});return 0===c.length?void 0:[t.createCodeFixAction(o,c,e.Diagnostics.Implement_inherited_abstract_class,o,e.Diagnostics.Implement_all_inherited_abstract_classes)]},fixIds:[o],getAllCodeActions:function(i){var o=e.createMap();return t.codeFixAll(i,a,function(t,a){var s=r(a.file,a.start);e.addToSeen(o,e.getNodeId(s))&&n(s,i.sourceFile,i,t,i.preferences)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(e,t,r,n){e.insertNodeAtConstructorStart(t,r,n),e.delete(t,n)}function n(t,r){var n=e.getTokenAtPosition(t,r);if(101!==n.kind)return void 0;var a=e.getContainingFunction(n),o=i(a.body);return o&&!o.expression.arguments.some(function(t){return e.isPropertyAccessExpression(t)&&t.expression===n})?{constructor:a,superCall:o}:void 0}function i(t){return e.isExpressionStatement(t)&&e.isSuperCall(t.expression)?t:e.isFunctionLike(t)?void 0:e.forEachChild(t,i)}var a="classSuperMustPrecedeThisAccess",o=[e.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class.code];t.registerCodeFix({errorCodes:o,getCodeActions:function(i){var o=i.sourceFile,s=i.span,c=n(o,s.start);if(!c)return void 0;var u=c.constructor,l=c.superCall,_=e.textChanges.ChangeTracker.with(i,function(e){return r(e,o,u,l)});return[t.createCodeFixAction(a,_,e.Diagnostics.Make_super_call_the_first_statement_in_the_constructor,a,e.Diagnostics.Make_all_super_calls_the_first_statement_in_their_constructor)]},fixIds:[a],getAllCodeActions:function(i){var a=i.sourceFile,s=e.createMap();return t.codeFixAll(i,o,function(t,i){var o=n(i.file,i.start);if(o){var c=o.constructor,u=o.superCall;e.addToSeen(s,e.getNodeId(c.parent))&&r(t,a,c,u)}})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){var n=e.getTokenAtPosition(t,r);return e.Debug.assert(125===n.kind),n.parent}function n(t,r,n){var i=e.createStatement(e.createCall(e.createSuper(),void 0,e.emptyArray));t.insertNodeAtConstructorStart(r,n,i)}var i="constructorForDerivedNeedSuperCall",a=[e.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call.code];t.registerCodeFix({errorCodes:a,getCodeActions:function(a){var o=a.sourceFile,s=a.span,c=r(o,s.start),u=e.textChanges.ChangeTracker.with(a,function(e){return n(e,o,c)});return[t.createCodeFixAction(i,u,e.Diagnostics.Add_missing_super_call,i,e.Diagnostics.Add_all_missing_super_calls)]},fixIds:[i],getAllCodeActions:function(e){return t.codeFixAll(e,a,function(t,i){return n(t,e.sourceFile,r(i.file,i.start))})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(r,n){t.setJsonCompilerOptionValue(r,n,"experimentalDecorators",e.createTrue())}var n="enableExperimentalDecorators",i=[e.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning.code];t.registerCodeFix({errorCodes:i,getCodeActions:function(i){var a=i.program.getCompilerOptions().configFile;if(void 0===a)return void 0;var o=e.textChanges.ChangeTracker.with(i,function(e){return r(e,a)});return[t.createCodeFixActionNoFixId(n,o,e.Diagnostics.Enable_the_experimentalDecorators_option_in_your_configuration_file)]},fixIds:[n],getAllCodeActions:function(e){return t.codeFixAll(e,i,function(t){var n=e.program.getCompilerOptions().configFile;return void 0===n?void 0:void r(t,n)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){var n=e.getTokenAtPosition(t,r),i=e.getContainingClass(n).heritageClauses,a=i[0].getFirstToken();return 87===a.kind?{extendsToken:a,heritageClauses:i}:void 0}function n(t,r,n,i){if(t.replaceNode(r,n,e.createToken(110)),2===i.length&&87===i[0].token&&110===i[1].token){var a=i[1].getFirstToken(),o=a.getFullStart();t.replaceRange(r,{pos:o,end:o},e.createToken(27));for(var s=r.text,c=a.end;c<s.length&&e.isWhiteSpaceSingleLine(s.charCodeAt(c));)c++;t.deleteRange(r,{pos:a.getStart(),end:c})}}var i="extendsInterfaceBecomesImplements",a=[e.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements.code];t.registerCodeFix({errorCodes:a,getCodeActions:function(a){var o=a.sourceFile,s=r(o,a.span.start);if(!s)return void 0;var c=s.extendsToken,u=s.heritageClauses,l=e.textChanges.ChangeTracker.with(a,function(e){return n(e,o,c,u)});return[t.createCodeFixAction(i,l,e.Diagnostics.Change_extends_to_implements,i,e.Diagnostics.Change_all_extended_interfaces_to_implements)]},fixIds:[i],getAllCodeActions:function(e){return t.codeFixAll(e,a,function(e,t){var i=r(t.file,t.start);i&&n(e,t.file,i.extendsToken,i.heritageClauses)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,n){var i=e.getTokenAtPosition(t,r);return e.isIdentifier(i)?{node:i,className:n===a?e.getContainingClass(i).name.text:void 0}:void 0}function n(t,r,n){var i=n.node,a=n.className;e.suppressLeadingAndTrailingTrivia(i),t.replaceNode(r,i,e.createPropertyAccess(a?e.createIdentifier(a):e.createThis(),i))}var i="forgottenThisPropertyAccess",a=e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,o=[e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,a];t.registerCodeFix({errorCodes:o,getCodeActions:function(a){var o=a.sourceFile,s=r(o,a.span.start,a.errorCode);if(!s)return void 0;var c=e.textChanges.ChangeTracker.with(a,function(e){return n(e,o,s)});return[t.createCodeFixAction(i,c,[e.Diagnostics.Add_0_to_unresolved_variable,s.className||"this"],i,e.Diagnostics.Add_qualifier_to_all_unresolved_variables_matching_a_member_name)]},fixIds:[i],getAllCodeActions:function(e){return t.codeFixAll(e,o,function(t,i){var a=r(i.file,i.start,i.code);a&&n(t,e.sourceFile,a)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,n){t.replaceNode(r,n.parent,e.createKeywordTypeNode(144))}function n(r,n){return t.createCodeFixAction(g,r,n,y,e.Diagnostics.Delete_all_unused_declarations)}function i(t,r,n){t.delete(r,e.Debug.assertDefined(e.cast(n.parent,e.isDeclarationWithTypeParameterChildren).typeParameters))}function a(t){return 93===t.kind?e.tryCast(t.parent,e.isImportDeclaration):void 0}function o(t,r,n,i,a,o){if(18!==t.kind||!e.isObjectBindingPattern(t.parent))return!1;var s=t.parent.parent;return 152===s.kind?p(r,n,s,i,a,o):r.delete(n,s),!0}function s(t,r,n){var i=e.tryCast(r.parent,e.isVariableDeclarationList);return i&&i.getChildren(t)[0]===r?(n.delete(t,220===i.parent.kind?i.parent:i),!0):!1}function c(t,r,n,i){r!==e.Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code&&(128===i.kind&&(i=e.cast(i.parent,e.isInferTypeNode).typeParameter.name),e.isIdentifier(i)&&u(i)&&t.replaceNode(n,i,e.createIdentifier("_"+i.text)))}function u(e){switch(e.parent.kind){case 152:case 151:return!0;case 238:var t=e.parent;switch(t.parent.parent.kind){case 228:case 227:return!0}}return!1}function l(t,r,n,i,a,o){d(r,n,t,i,a,o),e.isIdentifier(r)&&_(n,t,r,i)}function _(t,r,n,i){e.FindAllReferences.Core.eachSymbolReferenceInFile(n,i,r,function(n){e.isPropertyAccessExpression(n.parent)&&n.parent.name===n&&(n=n.parent),e.isBinaryExpression(n.parent)&&e.isExpressionStatement(n.parent.parent)&&n.parent.left===n&&t.delete(r,n.parent.parent)})}function d(t,r,n,i,a,o){var s=t.parent;e.isParameter(s)?p(r,n,s,i,a,o):r.delete(n,e.isImportClause(s)?t:e.isComputedPropertyName(s)?s.parent:s)}function p(t,r,n,i,a,o){f(n,i,o)&&(n.modifiers&&n.modifiers.length>0&&(!e.isIdentifier(n.name)||e.FindAllReferences.Core.isSymbolReferencedInFile(n.name,i,r))?n.modifiers.forEach(function(e){t.deleteModifier(r,e)}):(t.delete(r,n),m(t,r,n,a,i)))}function f(t,r,n){var i=t.parent;switch(i.kind){case 157:var a=r.getSymbolAtLocation(i.name);if(e.isMemberSymbolInBaseType(a,r))return!1;case 158:case 240:return!0;case 197:case 198:var o=i.parameters,s=o.indexOf(t);return e.Debug.assert(-1!==s),n?o.slice(s+1).every(function(e){return 73===e.name.kind&&!e.symbol.isReferenced}):s===o.length-1;case 160:return!1;default:return e.Debug.failBadSyntaxKind(i)}}function m(t,r,n,i,a){e.FindAllReferences.Core.eachSignatureCall(n.parent,i,a,function(e){var i=n.parent.parameters.indexOf(n);e.arguments.length>i&&t.delete(r,e.arguments[i])})}var g="unusedIdentifier",v="unusedIdentifier_prefix",y="unusedIdentifier_delete",h="unusedIdentifier_infer",b=[e.Diagnostics._0_is_declared_but_its_value_is_never_read.code,e.Diagnostics._0_is_declared_but_never_used.code,e.Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code,e.Diagnostics.All_imports_in_import_declaration_are_unused.code,e.Diagnostics.All_destructured_elements_are_unused.code,e.Diagnostics.All_variables_are_unused.code,e.Diagnostics.All_type_parameters_are_unused.code];t.registerCodeFix({errorCodes:b,getCodeActions:function(u){var _=u.errorCode,d=u.sourceFile,p=u.program,f=p.getTypeChecker(),m=p.getSourceFiles(),y=e.getTokenAtPosition(d,u.span.start);if(e.isJSDocTemplateTag(y))return[n(e.textChanges.ChangeTracker.with(u,function(e){return e.delete(d,y)}),e.Diagnostics.Remove_template_tag)];if(28===y.kind){var b=e.textChanges.ChangeTracker.with(u,function(e){return i(e,d,y)});return[n(b,e.Diagnostics.Remove_type_parameters)]}var x=a(y);if(x){var b=e.textChanges.ChangeTracker.with(u,function(e){return e.delete(d,x)});return[n(b,[e.Diagnostics.Remove_import_from_0,e.showModuleSpecifier(x)])]}var D=e.textChanges.ChangeTracker.with(u,function(e){return o(y,e,d,f,m,!1)});if(D.length)return[n(D,e.Diagnostics.Remove_destructuring)];var S=e.textChanges.ChangeTracker.with(u,function(e){return s(d,y,e)});if(S.length)return[n(S,e.Diagnostics.Remove_variable_statement)];var C=[];if(128===y.kind){var b=e.textChanges.ChangeTracker.with(u,function(e){return r(e,d,y)}),k=e.cast(y.parent,e.isInferTypeNode).typeParameter.name.text;C.push(t.createCodeFixAction(g,b,[e.Diagnostics.Replace_infer_0_with_unknown,k],h,e.Diagnostics.Replace_all_unused_infer_with_unknown))}else{var T=e.textChanges.ChangeTracker.with(u,function(e){return l(d,y,e,f,m,!1)});if(T.length){var k=e.isComputedPropertyName(y.parent)?y.parent:y;C.push(n(T,[e.Diagnostics.Remove_declaration_for_Colon_0,k.getText(d)]))}}var E=e.textChanges.ChangeTracker.with(u,function(e){return c(e,_,d,y)});return E.length&&C.push(t.createCodeFixAction(g,E,[e.Diagnostics.Prefix_0_with_an_underscore,y.getText(d)],v,e.Diagnostics.Prefix_all_unused_declarations_with_where_possible)),C},fixIds:[v,y,h],getAllCodeActions:function(n){var u=n.sourceFile,_=n.program,d=_.getTypeChecker(),p=_.getSourceFiles();return t.codeFixAll(n,b,function(t,_){var f=e.getTokenAtPosition(u,_.start);switch(n.fixId){case v:c(t,_.code,u,f);break;case y:if(128===f.kind)break;var m=a(f);m?t.delete(u,m):e.isJSDocTemplateTag(f)?t.delete(u,f):28===f.kind?i(t,u,f):o(f,t,u,d,p,!0)||s(u,f,t)||l(u,f,t,d,p,!0);break;case h:128===f.kind&&r(t,u,f);break;default:e.Debug.fail(JSON.stringify(n.fixId))}})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,i,a){var o=e.getTokenAtPosition(r,i),s=e.findAncestor(o,e.isStatement);e.Debug.assert(s.getStart(r)===o.getStart(r));var c=(e.isBlock(s.parent)?s.parent:s).parent;if(!e.isBlock(s.parent)||s===e.first(s.parent.statements))switch(c.kind){case 223:if(c.elseStatement){if(e.isBlock(s.parent))break;return void t.replaceNode(r,s,e.createBlock(e.emptyArray))}case 225:case 226:return void t.delete(r,c)}if(e.isBlock(s.parent)){var u=i+a,l=e.Debug.assertDefined(n(e.sliceAfter(s.parent.statements,s),function(e){return e.pos<u}));t.deleteNodeRange(r,s,l)}else t.delete(r,s)}function n(e,t){for(var r,n=0,i=e;n<i.length;n++){var a=i[n];if(!t(a))break;r=a}return r}var i="fixUnreachableCode",a=[e.Diagnostics.Unreachable_code_detected.code];t.registerCodeFix({errorCodes:a,getCodeActions:function(n){var a=e.textChanges.ChangeTracker.with(n,function(e){return r(e,n.sourceFile,n.span.start,n.span.length)});return[t.createCodeFixAction(i,a,e.Diagnostics.Remove_unreachable_code,i,e.Diagnostics.Remove_all_unreachable_code)]},fixIds:[i],getAllCodeActions:function(e){return t.codeFixAll(e,a,function(e,t){return r(e,t.file,t.start,t.length)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,n){var i=e.getTokenAtPosition(r,n),a=e.cast(i.parent,e.isLabeledStatement),o=i.getStart(r),s=a.statement.getStart(r),c=e.positionsAreOnSameLine(o,s,r)?s:e.skipTrivia(r.text,e.findChildOfKind(a,57,r).end,!0);t.deleteRange(r,{pos:o,end:c})
}var n="fixUnusedLabel",i=[e.Diagnostics.Unused_label.code];t.registerCodeFix({errorCodes:i,getCodeActions:function(i){var a=e.textChanges.ChangeTracker.with(i,function(e){return r(e,i.sourceFile,i.span.start)});return[t.createCodeFixAction(n,a,e.Diagnostics.Remove_unused_label,n,e.Diagnostics.Remove_all_unused_labels)]},fixIds:[n],getAllCodeActions:function(e){return t.codeFixAll(e,i,function(e,t){return r(e,t.file,t.start)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(e,t,r,n,i){e.replaceNode(t,r,i.typeToTypeNode(n,r))}function n(t,r,n){var a=e.findAncestor(e.getTokenAtPosition(t,r),i),o=a&&a.type;return o&&{typeNode:o,type:n.getTypeFromTypeNode(o)}}function i(e){switch(e.kind){case 213:case 161:case 162:case 240:case 159:case 163:case 182:case 157:case 156:case 152:case 155:case 154:case 160:case 243:case 195:case 238:return!0;default:return!1}}var a="fixJSDocTypes_plain",o="fixJSDocTypes_nullable",s=[e.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments.code];t.registerCodeFix({errorCodes:s,getCodeActions:function(i){function s(n,a,o){var s=e.textChanges.ChangeTracker.with(i,function(e){return r(e,c,_,n,u)});return t.createCodeFixAction("jdocTypes",s,[e.Diagnostics.Change_0_to_1,p,u.typeToString(n)],a,o)}var c=i.sourceFile,u=i.program.getTypeChecker(),l=n(c,i.span.start,u);if(!l)return void 0;var _=l.typeNode,d=l.type,p=_.getText(c),f=[s(d,a,e.Diagnostics.Change_all_jsdoc_style_types_to_TypeScript)];return 292===_.kind&&f.push(s(u.getNullableType(d,32768),o,e.Diagnostics.Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types)),f},fixIds:[a,o],getAllCodeActions:function(e){var i=e.fixId,a=e.program,c=e.sourceFile,u=a.getTypeChecker();return t.codeFixAll(e,s,function(e,t){var a=n(t.file,t.start,u);if(a){var s=a.typeNode,l=a.type,_=292===s.kind&&i===o?u.getNullableType(l,32768):l;r(e,c,s,_,u)}})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t){return t.type?t.type:e.isVariableDeclaration(t.parent)&&t.parent.type&&e.isFunctionTypeNode(t.parent.type)?t.parent.type.type:void 0}function n(t,n){var i=e.getTokenAtPosition(t,n),a=e.getContainingFunction(i);if(a){var o;switch(a.kind){case 157:o=a.name;break;case 240:case 197:o=e.findChildOfKind(a,91,t);break;case 198:o=e.findChildOfKind(a,20,t)||e.first(a.parameters);break;default:return}return o&&{insertBefore:o,returnType:r(a)}}}function i(t,r,n){var i=n.insertBefore,a=n.returnType;if(a){var o=e.getEntityNameFromTypeNode(a);o&&73===o.kind&&"Promise"===o.text||t.replaceNode(r,a,e.createTypeReferenceNode("Promise",e.createNodeArray([a])))}t.insertModifierBefore(r,122,i)}var a="fixAwaitInSyncFunction",o=[e.Diagnostics.await_expression_is_only_allowed_within_an_async_function.code,e.Diagnostics.A_for_await_of_statement_is_only_allowed_within_an_async_function_or_async_generator.code];t.registerCodeFix({errorCodes:o,getCodeActions:function(r){var o=r.sourceFile,s=r.span,c=n(o,s.start);if(!c)return void 0;var u=e.textChanges.ChangeTracker.with(r,function(e){return i(e,o,c)});return[t.createCodeFixAction(a,u,e.Diagnostics.Add_async_modifier_to_containing_function,a,e.Diagnostics.Add_all_missing_async_modifiers)]},fixIds:[a],getAllCodeActions:function(e){return t.codeFixAll(e,o,function(t,r){var a=n(r.file,r.start);a&&i(t,e.sourceFile,a)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,n,i){var a=e.getLineAndCharacterOfPosition(r,n).line;(!i||e.addToSeen(i,a))&&t.insertCommentBeforeLine(r,a,n," @ts-ignore")}var n="disableJsDiagnostics",i="disableJsDiagnostics",a=e.mapDefined(Object.keys(e.Diagnostics),function(t){var r=e.Diagnostics[t];return r.category===e.DiagnosticCategory.Error?r.code:void 0});t.registerCodeFix({errorCodes:a,getCodeActions:function(a){var o=a.sourceFile,s=a.program,c=a.span,u=a.host,l=a.formatContext;if(!e.isInJSFile(o)||!e.isCheckJsEnabledForFile(o,s.getCompilerOptions()))return void 0;var _=[t.createCodeFixActionNoFixId(n,[t.createFileTextChanges(o.fileName,[e.createTextChange(o.checkJsDirective?e.createTextSpanFromBounds(o.checkJsDirective.pos,o.checkJsDirective.end):e.createTextSpan(0,0),"// @ts-nocheck"+e.getNewLineOrDefaultFromHost(u,l.options))])],e.Diagnostics.Disable_checking_for_this_file)];return e.textChanges.isValidLocationToAddComment(o,c.start)&&_.unshift(t.createCodeFixAction(n,e.textChanges.ChangeTracker.with(a,function(e){return r(e,o,c.start)}),e.Diagnostics.Ignore_this_error_message,i,e.Diagnostics.Add_ts_ignore_to_all_error_messages)),_},fixIds:[i],getAllCodeActions:function(n){var i=e.createMap();return t.codeFixAll(n,a,function(t,n){e.textChanges.isValidLocationToAddComment(n.file,n.start)&&r(t,n.file,n.start,i)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(e,t,r,n,i){for(var o=e.symbol.members,s=0,c=t;s<c.length;s++){var u=c[s];o.has(u.escapedName)||a(u,e,r,n,i)}}function n(e){return{directoryExists:e.host.directoryExists?function(t){return e.host.directoryExists(t)}:void 0,fileExists:e.host.fileExists?function(t){return e.host.fileExists(t)}:void 0,getCurrentDirectory:e.host.getCurrentDirectory?function(){return e.host.getCurrentDirectory()}:void 0,readFile:e.host.readFile?function(t){return e.host.readFile(t)}:void 0,useCaseSensitiveFileNames:e.host.useCaseSensitiveFileNames?function(){return e.host.useCaseSensitiveFileNames()}:void 0,getSourceFiles:function(){return e.program.getSourceFiles()},getCommonSourceDirectory:function(){return e.program.getCommonSourceDirectory()}}}function i(t){return{trackSymbol:e.noop,moduleResolverHost:n(t)}}function a(t,r,n,a,s){function c(e,t,i,a){var c=o(n,e,r,t,i,h,a);c&&s(c)}var l=t.getDeclarations();if(!l||!l.length)return void 0;var p=n.program.getTypeChecker(),f=l[0],m=e.getSynthesizedDeepClone(e.getNameOfDeclaration(f),!1),g=d(e.getModifierFlags(f)),v=g?e.createNodeArray([g]):void 0,y=p.getWidenedType(p.getTypeOfSymbolAtLocation(t,r)),h=!!(16777216&t.flags);switch(f.kind){case 159:case 160:case 154:case 155:var b=p.typeToTypeNode(y,r,void 0,i(n));s(e.createProperty(void 0,v,m,h?e.createToken(56):void 0,b,void 0));break;case 156:case 157:var x=p.getSignaturesOfType(y,0);if(!e.some(x))break;if(1===l.length){e.Debug.assert(1===x.length);var D=x[0];c(D,v,m,_(a));break}for(var S=0,C=x;S<C.length;S++){var D=C[S];c(D,e.getSynthesizedDeepClones(v,!1),e.getSynthesizedDeepClone(m,!1))}if(l.length>x.length){var D=p.getSignatureFromDeclaration(l[l.length-1]);c(D,v,m,_(a))}else e.Debug.assert(l.length===x.length),s(u(x,m,h,v,a))}}function o(t,r,n,a,o,s,c){var u=t.program,l=u.getTypeChecker().signatureToSignatureDeclaration(r,157,n,257,i(t));return l?(l.decorators=void 0,l.modifiers=a,l.name=o,l.questionToken=s?e.createToken(56):void 0,l.body=c,l):void 0}function s(t,r,n,a,o,s,u){var l=!e.isInterfaceDeclaration(u),d=r.typeArguments,p=r.arguments,f=r.parent,m=t.program.getTypeChecker(),g=i(t),v=e.map(p,function(e){return m.typeToTypeNode(m.getBaseTypeOfLiteralType(m.getTypeAtLocation(e)),u,void 0,g)}),y=e.map(p,function(t){return e.isIdentifier(t)?t.text:e.isPropertyAccessExpression(t)?t.name.text:void 0}),h=m.getContextualType(r),b=a||!h?void 0:m.typeToTypeNode(h,u,void 0,g);return e.createMethod(void 0,o?[e.createToken(117)]:void 0,e.isYieldExpression(f)?e.createToken(40):void 0,n,void 0,a?void 0:e.map(d,function(t,r){return e.createTypeParameterDeclaration(84+d.length-1<=90?String.fromCharCode(84+r):"T"+r)}),c(p.length,y,v,void 0,a),b,l?_(s):void 0)}function c(t,r,n,i,a){for(var o=[],s=0;t>s;s++){var c=e.createParameter(void 0,void 0,void 0,r&&r[s]||"arg"+s,void 0!==i&&s>=i?e.createToken(56):void 0,a?void 0:n&&n[s]||e.createKeywordTypeNode(121),void 0);o.push(c)}return o}function u(t,r,n,i,a){for(var o=t[0],s=t[0].minArgumentCount,u=!1,_=0,d=t;_<d.length;_++){var p=d[_];s=Math.min(p.minArgumentCount,s),p.hasRestParameter&&(u=!0),p.parameters.length>=o.parameters.length&&(!p.hasRestParameter||o.hasRestParameter)&&(o=p)}var f=o.parameters.length-(o.hasRestParameter?1:0),m=o.parameters.map(function(e){return e.name}),g=c(f,m,void 0,s,!1);if(u){var v=e.createArrayTypeNode(e.createKeywordTypeNode(121)),y=e.createParameter(void 0,void 0,e.createToken(25),m[f]||"rest",f>=s?e.createToken(56):void 0,v,void 0);g.push(y)}return l(i,r,n,void 0,g,void 0,a)}function l(t,r,n,i,a,o,s){return e.createMethod(void 0,t,void 0,r,n?e.createToken(56):void 0,i,a,o,_(s))}function _(t){return e.createBlock([e.createThrow(e.createNew(e.createIdentifier("Error"),void 0,[e.createLiteral("Method not implemented.","single"===t.quotePreference)]))],!0)}function d(t){return 4&t?e.createToken(116):16&t?e.createToken(115):void 0}function p(t,r,n,i){var a=e.getTsConfigObjectLiteralExpression(r);if(!a)return void 0;var o=m(a,"compilerOptions");if(void 0===o)return void t.insertNodeAtObjectStart(r,a,f("compilerOptions",e.createObjectLiteral([f(n,i)])));var s=o.initializer;if(e.isObjectLiteralExpression(s)){var c=m(s,n);void 0===c?t.insertNodeAtObjectStart(r,s,f(n,i)):t.replaceNode(r,c.initializer,i)}}function f(t,r){return e.createPropertyAssignment(e.createStringLiteral(t),r)}function m(t,r){return e.find(t.properties,function(t){return e.isPropertyAssignment(t)&&!!t.name&&e.isStringLiteral(t.name)&&t.name.text===r})}t.createMissingMemberNodes=r,t.getNoopSymbolTrackerWithResolver=i,t.createMethodFromCallExpression=s,t.setJsonCompilerOptionValue=p,t.createJsonPropertyAssignment=f,t.findJsonProperty=m}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){var i=e.getSourceFileOfNode(r),a=e.getNamespaceDeclarationNode(r),o=t.program.getCompilerOptions(),s=[];return s.push(n(t,i,r,e.makeImport(a.name,void 0,r.moduleSpecifier,e.getQuotePreference(i,t.preferences)))),e.getEmitModuleKind(o)===e.ModuleKind.CommonJS&&s.push(n(t,i,r,e.createImportEqualsDeclaration(void 0,void 0,a.name,e.createExternalModuleReference(r.moduleSpecifier)))),s}function n(r,n,i,a){var o=e.textChanges.ChangeTracker.with(r,function(e){return e.replaceNode(n,i,a)});return t.createCodeFixActionNoFixId(s,o,[e.Diagnostics.Replace_import_with_0,o[0].textChanges[0].newText])}function i(t){var r=t.sourceFile,n=e.Diagnostics.Cannot_invoke_an_expression_whose_type_lacks_a_call_signature_Type_0_has_no_compatible_call_signatures.code===t.errorCode?192:193,i=e.findAncestor(e.getTokenAtPosition(r,t.span.start),function(e){return e.kind===n&&e.getStart()===t.span.start&&e.getEnd()===t.span.start+t.span.length});if(!i)return[];var a=i.expression;return o(t,a)}function a(t){var r=t.sourceFile,n=e.findAncestor(e.getTokenAtPosition(r,t.span.start),function(e){return e.getStart()===t.span.start&&e.getEnd()===t.span.start+t.span.length});return n?o(t,n):[]}function o(n,i){var a=n.program.getTypeChecker().getTypeAtLocation(i);if(!a.symbol||!a.symbol.originatingImport)return[];var o=[],c=a.symbol.originatingImport;if(e.isImportCall(c)||e.addRange(o,r(n,c)),e.isExpression(i)&&(!e.isNamedDeclaration(i.parent)||i.parent.name!==i)){var u=n.sourceFile,l=e.textChanges.ChangeTracker.with(n,function(t){return t.replaceNode(u,i,e.createPropertyAccess(i,"default"),{})});o.push(t.createCodeFixActionNoFixId(s,l,e.Diagnostics.Use_synthetic_default_member))}return o}var s="invalidImportSyntax";t.registerCodeFix({errorCodes:[e.Diagnostics.Cannot_invoke_an_expression_whose_type_lacks_a_call_signature_Type_0_has_no_compatible_call_signatures.code,e.Diagnostics.Cannot_use_new_with_an_expression_whose_type_lacks_a_call_or_construct_signature.code],getCodeActions:i}),t.registerCodeFix({errorCodes:[e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1.code,e.Diagnostics.Type_0_is_not_assignable_to_type_1.code,e.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated.code,e.Diagnostics.Type_predicate_0_is_not_assignable_to_1.code,e.Diagnostics.Property_0_of_type_1_is_not_assignable_to_string_index_type_2.code,e.Diagnostics.Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2.code,e.Diagnostics.Numeric_index_type_0_is_not_assignable_to_string_index_type_1.code,e.Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2.code,e.Diagnostics.Property_0_in_type_1_is_not_assignable_to_type_2.code,e.Diagnostics.Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property.code,e.Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1.code],getCodeActions:a})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){var n=e.getTokenAtPosition(t,r);return e.isIdentifier(n)?e.cast(n.parent,e.isPropertyDeclaration):void 0}function n(r,n){var a=e.textChanges.ChangeTracker.with(r,function(e){return i(e,r.sourceFile,n)});return t.createCodeFixAction(_,a,[e.Diagnostics.Add_definite_assignment_assertion_to_property_0,n.getText()],d,e.Diagnostics.Add_definite_assignment_assertions_to_all_uninitialized_properties)}function i(t,r,n){var i=e.updateProperty(n,n.decorators,n.modifiers,n.name,e.createToken(52),n.type,n.initializer);t.replaceNode(r,n,i)}function a(r,n){var i=e.textChanges.ChangeTracker.with(r,function(e){return o(e,r.sourceFile,n)});return t.createCodeFixAction(_,i,[e.Diagnostics.Add_undefined_type_to_property_0,n.name.getText()],p,e.Diagnostics.Add_undefined_type_to_all_uninitialized_properties)}function o(t,r,n){var i=e.createKeywordTypeNode(142),a=n.type,o=e.isUnionTypeNode(a)?a.types.concat(i):[a,i];t.replaceNode(r,a,e.createUnionTypeNode(o))}function s(r,n){var i=r.program.getTypeChecker(),a=u(i,n);if(!a)return void 0;var o=e.textChanges.ChangeTracker.with(r,function(e){return c(e,r.sourceFile,n,a)});return t.createCodeFixAction(_,o,[e.Diagnostics.Add_initializer_to_property_0,n.name.getText()],f,e.Diagnostics.Add_initializers_to_all_uninitialized_properties)}function c(t,r,n,i){var a=e.updateProperty(n,n.decorators,n.modifiers,n.name,n.questionToken,n.type,i);t.replaceNode(r,n,a)}function u(e,t){return l(e,e.getTypeFromTypeNode(t.type))}function l(t,r){if(512&r.flags)return r===t.getFalseType()||r===t.getFalseType(!0)?e.createFalse():e.createTrue();if(r.isLiteral())return e.createLiteral(r.value);if(r.isUnion())return e.firstDefined(r.types,function(e){return l(t,e)});if(r.isClass()){var n=e.getClassLikeDeclarationOfSymbol(r.symbol);if(!n||e.hasModifier(n,128))return void 0;var i=e.getFirstConstructorWithBody(n);return i&&i.parameters.length?void 0:e.createNew(e.createIdentifier(r.symbol.name),void 0,void 0)}return t.isArrayLikeType(r)?e.createArrayLiteral():void 0}var _="strictClassInitialization",d="addMissingPropertyDefiniteAssignmentAssertions",p="addMissingPropertyUndefinedType",f="addMissingPropertyInitializer",m=[e.Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor.code];t.registerCodeFix({errorCodes:m,getCodeActions:function(t){var i=r(t.sourceFile,t.span.start);if(i){var o=[a(t,i),n(t,i)];return e.append(o,s(t,i)),o}},fixIds:[d,p,f],getAllCodeActions:function(n){return t.codeFixAll(n,m,function(t,a){var s=r(a.file,a.start);if(s)switch(n.fixId){case d:i(t,a.file,s);break;case p:o(t,a.file,s);break;case f:var l=n.program.getTypeChecker(),_=u(l,s);if(!_)return;c(t,a.file,s,_);break;default:e.Debug.fail(JSON.stringify(n.fixId))}})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r,i,a){var o=n(r,i),s=o.statement,c=o.name,u=o.required;t.replaceNode(r,s,e.getAllowSyntheticDefaultImports(a.getCompilerOptions())?e.createImportDeclaration(void 0,void 0,e.createImportClause(c,void 0),u):e.createImportEqualsDeclaration(void 0,void 0,c,e.createExternalModuleReference(u)))}function n(t,r){var n=e.getTokenAtPosition(t,r).parent;if(!e.isRequireCall(n,!0))throw e.Debug.failBadSyntaxKind(n);var i=e.cast(n.parent,e.isVariableDeclaration);return{statement:e.cast(i.parent.parent,e.isVariableStatement),name:e.cast(i.name,e.isIdentifier),required:n.arguments[0]}}var i="requireInTs",a=[e.Diagnostics.require_call_may_be_converted_to_an_import.code];t.registerCodeFix({errorCodes:a,getCodeActions:function(n){var a=e.textChanges.ChangeTracker.with(n,function(e){return r(e,n.sourceFile,n.span.start,n.program)});return[t.createCodeFixAction(i,a,e.Diagnostics.Convert_require_to_import,i,e.Diagnostics.Convert_all_require_to_import)]},fixIds:[i],getAllCodeActions:function(e){return t.codeFixAll(e,a,function(t,n){return r(t,n.file,n.start,e.program)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){var n=e.getTokenAtPosition(t,r);if(!e.isIdentifier(n))return void 0;var i=n.parent;if(e.isImportEqualsDeclaration(i)&&e.isExternalModuleReference(i.moduleReference))return{importNode:i,name:n,moduleSpecifier:i.moduleReference.expression};if(e.isNamespaceImport(i)){var a=i.parent.parent;return{importNode:a,name:n,moduleSpecifier:a.moduleSpecifier}}}function n(t,r,n,i){t.replaceNode(r,n.importNode,e.makeImport(n.name,void 0,n.moduleSpecifier,e.getQuotePreference(r,i)))}var i="useDefaultImport",a=[e.Diagnostics.Import_may_be_converted_to_a_default_import.code];t.registerCodeFix({errorCodes:a,getCodeActions:function(a){var o=a.sourceFile,s=a.span.start,c=r(o,s);if(!c)return void 0;var u=e.textChanges.ChangeTracker.with(a,function(e){return n(e,o,c,a.preferences)});return[t.createCodeFixAction(i,u,e.Diagnostics.Convert_to_default_import,i,e.Diagnostics.Convert_all_to_default_imports)]},fixIds:[i],getAllCodeActions:function(e){return t.codeFixAll(e,a,function(t,i){var a=r(i.file,i.start);a&&n(t,i.file,a,e.preferences)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){var n=e.getTokenAtPosition(t,r);return e.Debug.assert(93===n.kind),e.Debug.assert(184===n.parent.kind),n.parent}function n(t,r,n){var i=e.updateImportTypeNode(n,n.argument,n.qualifier,n.typeArguments,!0);t.replaceNode(r,n,i)}var i="fixAddModuleReferTypeMissingTypeof",a=i,o=[e.Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0.code];t.registerCodeFix({errorCodes:o,getCodeActions:function(i){var o=i.sourceFile,s=i.span,c=r(o,s.start),u=e.textChanges.ChangeTracker.with(i,function(e){return n(e,o,c)});return[t.createCodeFixAction(a,u,e.Diagnostics.Add_missing_typeof,a,e.Diagnostics.Add_missing_typeof)]},fixIds:[a],getAllCodeActions:function(e){return t.codeFixAll(e,o,function(t,i){return n(t,e.sourceFile,r(i.file,i.start))})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){var n=e.getTokenAtPosition(t,r),i=e.cast(n.parent.parent,e.isIndexSignatureDeclaration);if(e.isClassDeclaration(i.parent))return void 0;var a=e.isInterfaceDeclaration(i.parent)?i.parent:e.cast(i.parent.parent,e.isTypeAliasDeclaration);return{indexSignature:i,container:a}}function n(t,r){return e.createTypeAliasDeclaration(t.decorators,t.modifiers,t.name,t.typeParameters,r)}function i(t,r,i){var a=i.indexSignature,o=i.container,s=e.isInterfaceDeclaration(o)?o.members:o.type.members,c=s.filter(function(t){return!e.isIndexSignatureDeclaration(t)}),u=e.first(a.parameters),l=e.createTypeParameterDeclaration(e.cast(u.name,e.isIdentifier),u.type),_=e.createMappedTypeNode(e.hasReadonlyModifier(a)?e.createModifier(134):void 0,l,a.questionToken,a.type),d=e.createIntersectionTypeNode(e.getAllSuperTypeNodes(o).concat([_],c.length?[e.createTypeLiteralNode(c)]:e.emptyArray));t.replaceNode(r,o,n(o,d))}var a="fixConvertToMappedObjectType",o=a,s=[e.Diagnostics.An_index_signature_parameter_type_cannot_be_a_union_type_Consider_using_a_mapped_object_type_instead.code];t.registerCodeFix({errorCodes:s,getCodeActions:function(n){var a=n.sourceFile,s=n.span,c=r(a,s.start);if(!c)return void 0;var u=e.textChanges.ChangeTracker.with(n,function(e){return i(e,a,c)}),l=e.idText(c.container.name);return[t.createCodeFixAction(o,u,[e.Diagnostics.Convert_0_to_mapped_object_type,l],o,[e.Diagnostics.Convert_0_to_mapped_object_type,l])]},fixIds:[o],getAllCodeActions:function(e){return t.codeFixAll(e,s,function(e,t){var n=r(t.file,t.start);n&&i(e,t.file,n)})}})}(t=e.codefix||(e.codefix={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t){var r=t.file,n=e.getRefactorContextSpan(t),i=e.getTokenAtPosition(r,n.start),a=e.getParentNodeInSpan(i,r,n);if(!(a&&(e.isSourceFile(a.parent)||e.isModuleBlock(a.parent)&&e.isAmbientModule(a.parent.parent))))return void 0;var o=e.isSourceFile(a.parent)?a.parent.symbol:a.parent.parent.symbol,s=e.getModifierFlags(a),c=!!(512&s);if(!(1&s)||!c&&o.exports.has("default"))return void 0;switch(a.kind){case 240:case 241:case 242:case 244:case 243:case 245:var u=a;return u.name&&e.isIdentifier(u.name)?{exportNode:u,exportName:u.name,wasDefault:c,exportingModuleSymbol:o}:void 0;case 220:var l=a;if(!(2&l.declarationList.flags)||1!==l.declarationList.declarations.length)return void 0;var _=e.first(l.declarationList.declarations);return _.initializer?(e.Debug.assert(!c),e.isIdentifier(_.name)?{exportNode:l,exportName:_.name,wasDefault:c,exportingModuleSymbol:o}:void 0):void 0;default:return void 0}}function n(e,t,r,n,o){i(e,r,n,t.getTypeChecker()),a(t,r,n,o)}function i(t,r,n,i){var a=r.wasDefault,o=r.exportNode,s=r.exportName;if(a)n.delete(t,e.Debug.assertDefined(e.findModifier(o,81)));else{var c=e.Debug.assertDefined(e.findModifier(o,86));switch(o.kind){case 240:case 241:case 242:n.insertNodeAfter(t,c,e.createToken(81));break;case 220:if(!e.FindAllReferences.Core.isSymbolReferencedInFile(s,i,t)){n.replaceNode(t,o,e.createExportDefault(e.Debug.assertDefined(e.first(o.declarationList.declarations).initializer)));break}case 244:case 243:case 245:n.deleteModifier(t,c),n.insertNodeAfter(t,o,e.createExportDefault(e.createIdentifier(s.text)));break;default:e.Debug.assertNever(o)}}}function a(t,r,n,i){var a=r.wasDefault,c=r.exportName,u=r.exportingModuleSymbol,l=t.getTypeChecker(),_=e.Debug.assertDefined(l.getSymbolAtLocation(c));e.FindAllReferences.Core.eachExportReference(t.getSourceFiles(),l,i,_,u,c.text,a,function(e){var t=e.getSourceFile();a?o(t,e,n,c.text):s(t,e,n)})}function o(t,r,n,i){var a=r.parent;switch(a.kind){case 190:n.replaceNode(t,r,e.createIdentifier(i));break;case 254:case 258:var o=a;n.replaceNode(t,o,c(i,o.name.text));break;case 251:var s=a;e.Debug.assert(s.name===r);var o=c(i,r.text),u=s.namedBindings;if(u)if(252===u.kind){n.deleteRange(t,{pos:r.getStart(t),end:u.getStart(t)});var l=e.isStringLiteral(s.parent.moduleSpecifier)?e.quotePreferenceFromString(s.parent.moduleSpecifier,t):1,_=e.makeImport(void 0,[c(i,r.text)],s.parent.moduleSpecifier,l);n.insertNodeAfter(t,s.parent,_)}else n.delete(t,r),n.insertNodeAtEndOfList(t,u.elements,o);else n.replaceNode(t,r,e.createNamedImports([o]));break;default:e.Debug.failBadSyntaxKind(a)}}function s(t,r,n){var i=r.parent;switch(i.kind){case 190:n.replaceNode(t,r,e.createIdentifier("default"));break;case 254:var a=e.createIdentifier(i.name.text);1===i.parent.elements.length?n.replaceNode(t,i.parent,a):(n.delete(t,i),n.insertNodeBefore(t,i.parent,a));break;case 258:n.replaceNode(t,i,u("default",i.name.text));break;default:e.Debug.assertNever(i)}}function c(t,r){return e.createImportSpecifier(t===r?void 0:e.createIdentifier(t),e.createIdentifier(r))}function u(t,r){return e.createExportSpecifier(t===r?void 0:e.createIdentifier(t),e.createIdentifier(r))}var l="Convert export",_="Convert default export to named export",d="Convert named export to default export";t.registerRefactor(l,{getAvailableActions:function(t){var n=r(t);if(!n)return e.emptyArray;var i=n.wasDefault?e.Diagnostics.Convert_default_export_to_named_export.message:e.Diagnostics.Convert_named_export_to_default_export.message,a=n.wasDefault?_:d;return[{name:l,description:i,actions:[{name:a,description:i}]}]},getEditsForAction:function(t,i){e.Debug.assert(i===_||i===d);var a=e.textChanges.ChangeTracker.with(t,function(i){return n(t.file,t.program,e.Debug.assertDefined(r(t)),i,t.cancellationToken)});return{edits:a,renameFilename:void 0,renameLocation:void 0}}})}(t=e.refactor||(e.refactor={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t){var r=t.file,n=e.getRefactorContextSpan(t),i=e.getTokenAtPosition(r,n.start),a=e.getParentNodeInSpan(i,r,n);if(!a||!e.isImportDeclaration(a))return void 0;var o=a.importClause;return o&&o.namedBindings}function n(t,r,n,o){var s=r.getTypeChecker();252===o.kind?i(t,s,n,o,e.getAllowSyntheticDefaultImports(r.getCompilerOptions())):a(t,s,n,o)}function i(t,r,n,i,a){var s=!1,c=[],u=e.createMap();e.FindAllReferences.Core.eachSymbolReferenceInFile(i.name,r,t,function(t){if(e.isPropertyAccessExpression(t.parent)){var n=e.cast(t.parent,e.isPropertyAccessExpression),i=n.name.text;r.resolveName(i,t,67108863,!0)&&u.set(i,!0),e.Debug.assert(n.expression===t),c.push(n)}else s=!0});for(var l=e.createMap(),_=0,d=c;_<d.length;_++){var p=d[_],f=p.name.text,m=l.get(f);void 0===m&&l.set(f,m=u.has(f)?e.getUniqueName(f,t):f),n.replaceNode(t,p,e.createIdentifier(m))}var g=[];l.forEach(function(t,r){g.push(e.createImportSpecifier(t===r?void 0:e.createIdentifier(r),e.createIdentifier(t)))});var v=i.parent.parent;s&&!a?n.insertNodeAfter(t,v,o(v,void 0,g)):n.replaceNode(t,v,o(v,s?e.createIdentifier(i.name.text):void 0,g))}function a(t,r,n,i){for(var a=i.parent.parent,s=a.moduleSpecifier,c=s&&e.isStringLiteral(s)?e.codefix.moduleSpecifierToValidIdentifier(s.text,8):"module",u=i.elements.some(function(n){return e.FindAllReferences.Core.eachSymbolReferenceInFile(n.name,r,t,function(e){return!!r.resolveName(c,e,67108863,!0)})||!1}),l=u?e.getUniqueName(c,t):c,_=[],d=function(i){var a=(i.propertyName||i.name).text;e.FindAllReferences.Core.eachSymbolReferenceInFile(i.name,r,t,function(r){var o=e.createPropertyAccess(e.createIdentifier(l),a);e.isShorthandPropertyAssignment(r.parent)?n.replaceNode(t,r.parent,e.createPropertyAssignment(r.text,o)):e.isExportSpecifier(r.parent)&&!r.parent.propertyName?_.some(function(e){return e.name===i.name})||_.push(e.createImportSpecifier(i.propertyName&&e.createIdentifier(i.propertyName.text),e.createIdentifier(i.name.text))):n.replaceNode(t,r,o)})},p=0,f=i.elements;p<f.length;p++){var m=f[p];d(m)}n.replaceNode(t,i,e.createNamespaceImport(e.createIdentifier(l))),_.length&&n.insertNodeAfter(t,i.parent.parent,o(a,void 0,_))}function o(t,r,n){return e.createImportDeclaration(void 0,void 0,e.createImportClause(r,n&&n.length?e.createNamedImports(n):void 0),t.moduleSpecifier)}var s="Convert import",c="Convert namespace import to named imports",u="Convert named imports to namespace import";t.registerRefactor(s,{getAvailableActions:function(t){var n=r(t);if(!n)return e.emptyArray;var i=252===n.kind?e.Diagnostics.Convert_namespace_import_to_named_imports.message:e.Diagnostics.Convert_named_imports_to_namespace_import.message,a=252===n.kind?c:u;return[{name:s,description:i,actions:[{name:a,description:i}]}]},getEditsForAction:function(t,i){e.Debug.assert(i===c||i===u);var a=e.textChanges.ChangeTracker.with(t,function(i){return n(t.file,t.program,i,e.Debug.assertDefined(r(t)))});return{edits:a,renameFilename:void 0,renameLocation:void 0}}})}(t=e.refactor||(e.refactor={}))}(n||(n={}));var n;!function(e){var t;!function(t){var r;!function(r){function n(t){var r=a(t.file,e.getRefactorContextSpan(t)),n=r.targetRange;if(void 0===n)return e.emptyArray;var i=_(n,t);if(void 0===i)return e.emptyArray;for(var o=[],s=e.createMap(),c=[],u=e.createMap(),l=0,d=0,p=i;d<p.length;d++){var f=p[d],m=f.functionExtraction,g=f.constantExtraction;if(0===m.errors.length){var v=m.description;s.has(v)||(s.set(v,!0),o.push({description:v,name:"function_scope_"+l}))}if(0===g.errors.length){var v=g.description;u.has(v)||(u.set(v,!0),c.push({description:v,name:"constant_scope_"+l}))}l++}var y=[];return o.length&&y.push({name:L,description:e.getLocaleSpecificMessage(e.Diagnostics.Extract_function),actions:o}),c.length&&y.push({name:L,description:e.getLocaleSpecificMessage(e.Diagnostics.Extract_constant),actions:c}),y.length?y:e.emptyArray}function i(t,r){var n=a(t.file,e.getRefactorContextSpan(t)),i=n.targetRange,o=/^function_scope_(\d+)$/.exec(r);if(o){var s=+o[1];return e.Debug.assert(isFinite(s),"Expected to parse a finite number from the function scope index"),u(i,t,s)}var c=/^constant_scope_(\d+)$/.exec(r);if(c){var s=+c[1];return e.Debug.assert(isFinite(s),"Expected to parse a finite number from the constant scope index"),l(i,t,s)}e.Debug.fail("Unrecognized action name")}function a(t,r){function n(t){if(e.isReturnStatement(t)){if(t.expression)return t.expression}else if(e.isVariableStatement(t)){for(var r=0,n=void 0,i=0,a=t.declarationList.declarations;i<a.length;i++){var o=a[i];o.initializer&&(r++,n=o.initializer)}if(1===r)return n}else if(e.isVariableDeclaration(t)&&t.initializer)return t.initializer;return t}function i(t){return e.isIdentifier(e.isExpressionStatement(t)?t.expression:t)?[e.createDiagnosticForNode(t,R.cannotExtractIdentifier)]:void 0}function a(t,r){for(var n=t;n!==r;){if(155===n.kind){e.hasModifier(n,32)&&(d|=B.InStaticRegion);break}if(152===n.kind){var i=e.getContainingFunction(n);158===i.kind&&(d|=B.InStaticRegion);break}157===n.kind&&e.hasModifier(n,32)&&(d|=B.InStaticRegion),n=n.parent}}function s(t){function n(t){if(s)return!0;if(e.isDeclaration(t)){var i=238===t.kind?t.parent.parent:t;if(e.hasModifier(i,1))return(s||(s=[])).push(e.createDiagnosticForNode(t,R.cannotExtractExportedEntity)),!0;_.push(t.symbol)}switch(t.kind){case 250:return(s||(s=[])).push(e.createDiagnosticForNode(t,R.cannotExtractImport)),!0;case 99:if(192===t.parent.kind){var a=e.getContainingClass(t);if(a.pos<r.start||a.end>=r.start+r.length)return(s||(s=[])).push(e.createDiagnosticForNode(t,R.cannotExtractSuper)),!0}else d|=B.UsesThis}if(e.isFunctionLikeDeclaration(t)||e.isClassLike(t)){switch(t.kind){case 240:case 241:e.isSourceFile(t.parent)&&void 0===t.parent.externalModuleIndicator&&(s||(s=[])).push(e.createDiagnosticForNode(t,R.functionWillNotBeVisibleInTheNewScope))}return!1}var o=u;switch(t.kind){case 223:u=0;break;case 236:u=0;break;case 219:t.parent&&236===t.parent.kind&&t.parent.finallyBlock===t&&(u=4);break;case 272:u|=1;break;default:e.isIterationStatement(t,!1)&&(u|=3)}switch(t.kind){case 179:case 101:d|=B.UsesThis;break;case 234:var l=t.label;(c||(c=[])).push(l.escapedText),e.forEachChild(t,n),c.pop();break;case 230:case 229:var l=t.label;l?e.contains(c,l.escapedText)||(s||(s=[])).push(e.createDiagnosticForNode(t,R.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange)):u&(230===t.kind?1:2)||(s||(s=[])).push(e.createDiagnosticForNode(t,R.cannotExtractRangeContainingConditionalBreakOrContinueStatements));break;case 202:d|=B.IsAsyncFunction;break;case 208:d|=B.IsGenerator;break;case 231:4&u?d|=B.HasReturn:(s||(s=[])).push(e.createDiagnosticForNode(t,R.cannotExtractRangeContainingConditionalReturnStatement));break;default:e.forEachChild(t,n)}u=o}var i;if(function(e){e[e.None=0]="None",e[e.Break=1]="Break",e[e.Continue=2]="Continue",e[e.Return=4]="Return"}(i||(i={})),e.Debug.assert(t.pos<=t.end,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809"),e.Debug.assert(!e.positionIsSynthesized(t.pos),"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809"),!(e.isStatement(t)||e.isExpressionNode(t)&&O(t)))return[e.createDiagnosticForNode(t,R.statementOrExpressionExpected)];if(4194304&t.flags)return[e.createDiagnosticForNode(t,R.cannotExtractAmbientBlock)];var o=e.getContainingClass(t);o&&a(t,o);var s,c,u=4;return n(t),s}var c=r.length;if(0===c)return{errors:[e.createFileDiagnostic(t,r.start,c,R.cannotExtractEmpty)]};var u=e.getParentNodeInSpan(e.getTokenAtPosition(t,r.start),t,r),l=e.getParentNodeInSpan(e.findTokenOnLeftOfPosition(t,e.textSpanEnd(r)),t,r),_=[],d=B.None;if(!u||!l)return{errors:[e.createFileDiagnostic(t,r.start,c,R.cannotExtractRange)]};if(u.parent!==l.parent)return{errors:[e.createFileDiagnostic(t,r.start,c,R.cannotExtractRange)]};
if(u!==l){if(!M(u.parent))return{errors:[e.createFileDiagnostic(t,r.start,c,R.cannotExtractRange)]};for(var p=[],f=u,m=0,g=f.parent.statements;m<g.length;m++){var v=g[m];if(v===u||p.length){var y=s(v);if(y)return{errors:y};p.push(v)}if(v===l)break}return p.length?{targetRange:{range:p,facts:d,declarations:_}}:{errors:[e.createFileDiagnostic(t,r.start,c,R.cannotExtractRange)]}}if(e.isReturnStatement(u)&&!u.expression)return{errors:[e.createFileDiagnostic(t,r.start,c,R.cannotExtractRange)]};var h=n(u),b=i(h)||s(h);return b?{errors:b}:{targetRange:{range:o(h),facts:d,declarations:_}}}function o(t){return e.isStatement(t)?[t]:e.isExpressionNode(t)?e.isExpressionStatement(t.parent)?[t.parent]:t:void 0}function s(t){return e.isFunctionLikeDeclaration(t)||e.isSourceFile(t)||e.isModuleBlock(t)||e.isClassLike(t)}function c(t){var r=P(t.range)?e.first(t.range):t.range;if(t.facts&B.UsesThis){var n=e.getContainingClass(r);if(n){var i=e.findAncestor(r,e.isFunctionLikeDeclaration);return i?[i,n]:[n]}}for(var a=[];;)if(r=r.parent,152===r.kind&&(r=e.findAncestor(r,function(t){return e.isFunctionLikeDeclaration(t)}).parent),s(r)&&(a.push(r),285===r.kind))return a}function u(t,r,n){var i=d(t,r),a=i.scopes,o=i.readsAndWrites,s=o.target,c=o.usagesPerScope,u=o.functionErrorsPerScope,l=o.exposedVariableDeclarations;return e.Debug.assert(!u[n].length,"The extraction went missing? How?"),r.cancellationToken.throwIfCancellationRequested(),y(s,a[n],c[n],l,t,r)}function l(t,r,n){var i=d(t,r),a=i.scopes,o=i.readsAndWrites,s=o.target,c=o.usagesPerScope,u=o.constantErrorsPerScope,l=o.exposedVariableDeclarations;e.Debug.assert(!u[n].length,"The extraction went missing? How?"),e.Debug.assert(0===l.length,"Extract constant accepted a range containing a variable declaration?"),r.cancellationToken.throwIfCancellationRequested();var _=e.isExpression(s)?s:s.statements[0].expression;return h(_,a[n],c[n],t.facts,r)}function _(t,r){var n=d(t,r),i=n.scopes,a=n.readsAndWrites,o=a.functionErrorsPerScope,s=a.constantErrorsPerScope,c=i.map(function(t,r){var n,i,a=p(t),c=f(t),u=e.isFunctionLikeDeclaration(t)?m(t):e.isClassLike(t)?g(t):v(t);return 1===u?(n=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1_scope),[a,"global"]),i=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1_scope),[c,"global"])):0===u?(n=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1_scope),[a,"module"]),i=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1_scope),[c,"module"])):(n=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1),[a,u]),i=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1),[c,u])),0!==r||e.isClassLike(t)||(i=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_enclosing_scope),[c])),{functionExtraction:{description:n,errors:o[r]},constantExtraction:{description:i,errors:s[r]}}});return c}function d(e,t){var r=t.file,n=c(e),i=w(e,r),a=I(e,n,i,r,t.program.getTypeChecker(),t.cancellationToken);return{scopes:n,readsAndWrites:a}}function p(t){return e.isFunctionLikeDeclaration(t)?"inner function":e.isClassLike(t)?"method":"function"}function f(t){return e.isClassLike(t)?"readonly field":"constant"}function m(t){switch(t.kind){case 158:return"constructor";case 197:case 240:return t.name?"function '"+t.name.text+"'":"anonymous function";case 198:return"arrow function";case 157:return"method '"+t.name.getText()+"'";case 159:return"'get "+t.name.getText()+"'";case 160:return"'set "+t.name.getText()+"'";default:throw e.Debug.assertNever(t)}}function g(e){return 241===e.kind?e.name?"class '"+e.name.text+"'":"anonymous class declaration":e.name?"class expression '"+e.name.text+"'":"anonymous class expression"}function v(e){return 246===e.kind?"namespace '"+e.parent.name.getText()+"'":e.externalModuleIndicator?0:1}function y(t,r,n,i,a,o){function s(t){if(void 0===t)return void 0;for(var r=e.getSynthesizedDeepClone(t),n=r;e.isParenthesizedTypeNode(n);)n=n.type;return e.isUnionTypeNode(n)&&e.find(n.types,function(e){return 142===e.kind})?r:e.createUnionTypeNode([r,e.createKeywordTypeNode(142)])}var c,u,l=n.usages,_=n.typeParameterUsages,d=n.substitutions,p=o.program.getTypeChecker(),f=r.getSourceFile(),m=e.getUniqueName(e.isClassLike(r)?"newMethod":"newFunction",f),g=e.isInJSFile(r),v=e.createIdentifier(m),y=[],h=[];l.forEach(function(t,n){var i;if(!g){var a=p.getTypeOfSymbolAtLocation(t.symbol,t.node);a=p.getBaseTypeOfLiteralType(a),i=p.typeToTypeNode(a,r,1)}var o=e.createParameter(void 0,void 0,void 0,n,void 0,i);y.push(o),2===t.usage&&(u||(u=[])).push(t),h.push(e.createIdentifier(n))});var b=e.arrayFrom(_.values()).map(function(e){return{type:e,declaration:x(e)}}),k=b.sort(D),T=0===k.length?void 0:k.map(function(e){return e.declaration}),N=void 0!==T?T.map(function(t){return e.createTypeReferenceNode(t.name,void 0)}):void 0;if(e.isExpression(t)&&!g){var A=p.getContextualType(t);c=p.typeToTypeNode(A,r,1)}var w=C(t,i,u,d,!!(a.facts&B.HasReturn)),I=w.body,O=w.returnValueProperty;e.suppressLeadingAndTrailingTrivia(I);var M;if(e.isClassLike(r)){var L=g?[]:[e.createToken(114)];a.facts&B.InStaticRegion&&L.push(e.createToken(117)),a.facts&B.IsAsyncFunction&&L.push(e.createToken(122)),M=e.createMethod(void 0,L.length?L:void 0,a.facts&B.IsGenerator?e.createToken(40):void 0,v,void 0,T,y,c,I)}else M=e.createFunctionDeclaration(void 0,a.facts&B.IsAsyncFunction?[e.createToken(122)]:void 0,a.facts&B.IsGenerator?e.createToken(40):void 0,v,T,y,c,I);var R=e.textChanges.ChangeTracker.fromContext(o),j=(P(a.range)?e.last(a.range):a.range).end,J=E(j,r);J?R.insertNodeBefore(o.file,J,M,!0):R.insertNodeAtEndOfScope(o.file,r,M);var z=[],V=S(r,a,m),U=e.createCall(V,N,h);if(a.facts&B.IsGenerator&&(U=e.createYield(e.createToken(40),U)),a.facts&B.IsAsyncFunction&&(U=e.createAwait(U)),i.length&&!u)if(e.Debug.assert(!O),e.Debug.assert(!(a.facts&B.HasReturn)),1===i.length){var K=i[0];z.push(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.getSynthesizedDeepClone(K.name),e.getSynthesizedDeepClone(K.type),U)],K.parent.flags)))}else{for(var q=[],W=[],H=i[0].parent.flags,G=!1,Q=0,X=i;Q<X.length;Q++){var K=X[Q];q.push(e.createBindingElement(void 0,void 0,e.getSynthesizedDeepClone(K.name)));var Y=p.typeToTypeNode(p.getBaseTypeOfLiteralType(p.getTypeAtLocation(K)),r,1);W.push(e.createPropertySignature(void 0,K.symbol.name,void 0,Y,void 0)),G=G||void 0!==K.type,H&=K.parent.flags}var Z=G?e.createTypeLiteralNode(W):void 0;Z&&e.setEmitFlags(Z,1),z.push(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.createObjectBindingPattern(q),Z,U)],H)))}else if(i.length||u){if(i.length)for(var $=0,et=i;$<et.length;$++){var K=et[$],tt=K.parent.flags;2&tt&&(tt=-3&tt|1),z.push(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(K.symbol.name,s(K.type))],tt)))}O&&z.push(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(O,s(c))],1)));var rt=F(i,u);O&&rt.unshift(e.createShorthandPropertyAssignment(O)),1===rt.length?(e.Debug.assert(!O),z.push(e.createStatement(e.createAssignment(rt[0].name,U))),a.facts&B.HasReturn&&z.push(e.createReturn())):(z.push(e.createStatement(e.createAssignment(e.createObjectLiteral(rt),U))),O&&z.push(e.createReturn(e.createIdentifier(O))))}else z.push(a.facts&B.HasReturn?e.createReturn(U):P(a.range)?e.createStatement(U):U);P(a.range)?R.replaceNodeRangeWithNodes(o.file,e.first(a.range),e.last(a.range),z):R.replaceNodeWithNodes(o.file,a.range,z);var nt=R.getChanges(),it=P(a.range)?e.first(a.range):a.range,at=it.getSourceFile().fileName,ot=e.getRenameLocation(nt,at,m,!1);return{renameFilename:at,renameLocation:ot,edits:nt}}function h(t,r,n,i,a){var o=n.substitutions,c=a.program.getTypeChecker(),u=r.getSourceFile(),l=e.getUniqueName(e.isClassLike(r)?"newProperty":"newLocal",u),_=e.isInJSFile(r),d=_||!c.isContextSensitive(t)?void 0:c.typeToTypeNode(c.getContextualType(t),r,1),p=k(t,o);e.suppressLeadingAndTrailingTrivia(p);var f=e.textChanges.ChangeTracker.fromContext(a);if(e.isClassLike(r)){e.Debug.assert(!_);var m=[];m.push(e.createToken(114)),i&B.InStaticRegion&&m.push(e.createToken(117)),m.push(e.createToken(134));var g=e.createProperty(void 0,m,l,void 0,d,p),v=e.createPropertyAccess(i&B.InStaticRegion?e.createIdentifier(r.name.getText()):e.createThis(),e.createIdentifier(l)),y=t.pos,h=N(y,r);f.insertNodeBefore(a.file,h,g,!0),f.replaceNode(a.file,t,v)}else{var x=e.createVariableDeclaration(l,d,p),D=b(t,r);if(D){f.insertNodeBefore(a.file,D,x);var v=e.createIdentifier(l);f.replaceNode(a.file,t,v)}else if(222===t.parent.kind&&r===e.findAncestor(t,s)){var S=e.createVariableStatement(void 0,e.createVariableDeclarationList([x],2));f.replaceNode(a.file,t.parent,S)}else{var S=e.createVariableStatement(void 0,e.createVariableDeclarationList([x],2)),h=A(t,r);if(0===h.pos?f.insertNodeAtTopOfFile(a.file,S,!1):f.insertNodeBefore(a.file,h,S,!1),222===t.parent.kind)f.delete(a.file,t.parent);else{var v=e.createIdentifier(l);f.replaceNode(a.file,t,v)}}}var C=f.getChanges(),T=t.getSourceFile().fileName,E=e.getRenameLocation(C,T,l,!0);return{renameFilename:T,renameLocation:E,edits:C}}function b(t,r){for(var n;void 0!==t&&t!==r;){if(e.isVariableDeclaration(t)&&t.initializer===n&&e.isVariableDeclarationList(t.parent)&&t.parent.declarations.length>1)return t;n=t,t=t.parent}}function x(e){var t,r=e.symbol;if(r&&r.declarations)for(var n=0,i=r.declarations;n<i.length;n++){var a=i[n];(void 0===t||a.pos<t.pos)&&(t=a)}return t}function D(t,r){var n=t.type,i=t.declaration,a=r.type,o=r.declaration;return e.compareProperties(i,o,"pos",e.compareValues)||e.compareStringsCaseSensitive(n.symbol?n.symbol.getName():"",a.symbol?a.symbol.getName():"")||e.compareValues(n.id,a.id)}function S(t,r,n){var i=e.createIdentifier(n);if(e.isClassLike(t)){var a=r.facts&B.InStaticRegion?e.createIdentifier(t.name.text):e.createThis();return e.createPropertyAccess(a,i)}return i}function C(t,r,n,i,a){function o(t){if(!u&&231===t.kind&&s){var a=F(r,n);return t.expression&&(c||(c="__return"),a.unshift(e.createPropertyAssignment(c,e.visitNode(t.expression,o)))),e.createReturn(1===a.length?a[0].name:e.createObjectLiteral(a))}var l=u;u=u||e.isFunctionLikeDeclaration(t)||e.isClassLike(t);var _=i.get(e.getNodeId(t).toString()),d=_?e.getSynthesizedDeepClone(_):e.visitEachChild(t,o,e.nullTransformationContext);return u=l,d}var s=void 0!==n||r.length>0;if(e.isBlock(t)&&!s&&0===i.size)return{body:e.createBlock(t.statements,!0),returnValueProperty:void 0};var c,u=!1,l=e.createNodeArray(e.isBlock(t)?t.statements.slice(0):[e.isStatement(t)?t:e.createReturn(t)]);if(s||i.size){var _=e.visitNodes(l,o).slice();if(s&&!a&&e.isStatement(t)){var d=F(r,n);_.push(1===d.length?e.createReturn(d[0].name):e.createReturn(e.createObjectLiteral(d)))}return{body:e.createBlock(_,!0),returnValueProperty:c}}return{body:e.createBlock(l,!0),returnValueProperty:void 0}}function k(t,r){function n(t){var i=r.get(e.getNodeId(t).toString());return i?e.getSynthesizedDeepClone(i):e.visitEachChild(t,n,e.nullTransformationContext)}return r.size?n(t):t}function T(t){if(e.isFunctionLikeDeclaration(t)){var r=t.body;if(e.isBlock(r))return r.statements}else{if(e.isModuleBlock(t)||e.isSourceFile(t))return t.statements;if(e.isClassLike(t))return t.members;e.assertType(t)}return e.emptyArray}function E(t,r){return e.find(T(r),function(r){return r.pos>=t&&e.isFunctionLikeDeclaration(r)&&!e.isConstructorDeclaration(r)})}function N(t,r){var n=r.members;e.Debug.assert(n.length>0);for(var i,a=!0,o=0,s=n;o<s.length;o++){var c=s[o];if(c.pos>t)return i||n[0];if(a&&!e.isPropertyDeclaration(c)){if(void 0!==i)return c;a=!1}i=c}return void 0===i?e.Debug.fail():i}function A(t,r){e.Debug.assert(!e.isClassLike(r));for(var n,i=t;i!==r;i=i.parent)s(i)&&(n=i);for(var i=(n||t).parent;;i=i.parent){if(M(i)){for(var a=void 0,o=0,c=i.statements;o<c.length;o++){var u=c[o];if(u.pos>t.pos)break;a=u}return!a&&e.isCaseClause(i)?(e.Debug.assert(e.isSwitchStatement(i.parent.parent)),i.parent.parent):e.Debug.assertDefined(a)}e.Debug.assert(i!==r,"Didn't encounter a block-like before encountering scope")}}function F(t,r){var n=e.map(t,function(t){return e.createShorthandPropertyAssignment(t.symbol.name)}),i=e.map(r,function(t){return e.createShorthandPropertyAssignment(t.symbol.name)});return void 0===n?i:void 0===i?n:n.concat(i)}function P(t){return e.isArray(t)}function w(t,r){return P(t.range)?{pos:e.first(t.range).getStart(r),end:e.last(t.range).getEnd()}:t.range}function I(t,r,n,i,a,o){function s(t){return!!e.findAncestor(t,function(t){return e.isDeclarationWithTypeParameters(t)&&0!==e.getEffectiveTypeParameterDeclarations(t).length})}function c(e){for(var t=a.getSymbolWalker(function(){return o.throwIfCancellationRequested(),!0}),r=t.walkType(e).visitedTypes,n=0,i=r;n<i.length;n++){var s=i[n];s.isTypeParameter()&&v.set(s.id.toString(),s)}}function u(t,r){if(void 0===r&&(r=1),j){var n=a.getTypeAtLocation(t);c(n)}if(e.isDeclaration(t)&&t.symbol&&D.push(t),e.isAssignmentExpression(t))u(t.left,2),u(t.right);else if(e.isUnaryExpressionWithWrite(t))u(t.operand,2);else if(e.isPropertyAccessExpression(t)||e.isElementAccessExpression(t))e.forEachChild(t,u);else if(e.isIdentifier(t)){if(!t.parent)return;if(e.isQualifiedName(t.parent)&&t!==t.parent.left)return;if(e.isPropertyAccessExpression(t.parent)&&t!==t.parent.expression)return;l(t,r,e.isPartOfTypeNode(t))}else e.forEachChild(t,u)}function l(t,n,i){var a=_(t,n,i);if(a)for(var o=0;o<r.length;o++){var s=h[o].get(a);s&&y[o].substitutions.set(e.getNodeId(t).toString(),s)}}function _(o,s,c){var u=p(o);if(!u)return void 0;var l=e.getSymbolId(u).toString(),_=O.get(l);if(_&&_>=s)return l;if(O.set(l,s),_){for(var d=0,m=y;d<m.length;d++){var g=m[d],v=g.usages.get(o.text);v&&g.usages.set(o.text,{usage:s,symbol:u,node:o})}return l}var D=u.getDeclarations(),S=D&&e.find(D,function(e){return e.getSourceFile()===i});if(!S)return void 0;if(e.rangeContainsStartEnd(n,S.getStart(),S.end))return void 0;if(t.facts&B.IsGenerator&&2===s){for(var C=e.createDiagnosticForNode(o,R.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators),k=0,T=b;k<T.length;k++){var E=T[k];E.push(C)}for(var N=0,A=x;N<A.length;N++){var E=A[N];E.push(C)}}for(var F=0;F<r.length;F++){var P=r[F],w=a.resolveName(u.name,P,u.flags,!1);if(w!==u&&!h[F].has(l)){var I=f(u.exportSymbol||u,P,c);if(I)h[F].set(l,I);else if(c){if(!(262144&u.flags)){var C=e.createDiagnosticForNode(o,R.typeWillNotBeVisibleInTheNewScope);b[F].push(C),x[F].push(C)}}else y[F].usages.set(o.text,{usage:s,symbol:u,node:o})}}return l}function d(r){if(!(r===t.range||P(t.range)&&t.range.indexOf(r)>=0)){var n=e.isIdentifier(r)?p(r):a.getSymbolAtLocation(r);if(n){var i=e.find(D,function(e){return e.symbol===n});if(i)if(e.isVariableDeclaration(i)){var o=i.symbol.id.toString();S.has(o)||(C.push(i),S.set(o,!0))}else m=m||i}e.forEachChild(r,d)}}function p(t){return t.parent&&e.isShorthandPropertyAssignment(t.parent)&&t.parent.name===t?a.getShorthandAssignmentValueSymbol(t.parent):a.getSymbolAtLocation(t)}function f(t,r,n){if(!t)return void 0;var i=t.getDeclarations();if(i&&i.some(function(e){return e.parent===r}))return e.createIdentifier(t.name);var a=f(t.parent,r,n);return void 0===a?void 0:n?e.createQualifiedName(a,e.createIdentifier(t.name)):e.createPropertyAccess(a,t.name)}var m,g,v=e.createMap(),y=[],h=[],b=[],x=[],D=[],S=e.createMap(),C=[],k=P(t.range)?1===t.range.length&&e.isExpressionStatement(t.range[0])?t.range[0].expression:void 0:t.range;if(void 0===k){var T=t.range,E=e.first(T).getStart(),N=e.last(T).end;g=e.createFileDiagnostic(i,E,N-E,R.expressionExpected)}else 147456&a.getTypeAtLocation(k).flags&&(g=e.createDiagnosticForNode(k,R.uselessConstantType));for(var A=0,F=r;A<F.length;A++){var w=F[A];y.push({usages:e.createMap(),typeParameterUsages:e.createMap(),substitutions:e.createMap()}),h.push(e.createMap()),b.push(e.isFunctionLikeDeclaration(w)&&240!==w.kind?[e.createDiagnosticForNode(w,R.cannotExtractToOtherFunctionLike)]:[]);var I=[];g&&I.push(g),e.isClassLike(w)&&e.isInJSFile(w)&&I.push(e.createDiagnosticForNode(w,R.cannotExtractToJSClass)),e.isArrowFunction(w)&&!e.isBlock(w.body)&&I.push(e.createDiagnosticForNode(w,R.cannotExtractToExpressionArrowFunction)),x.push(I)}var O=e.createMap(),M=P(t.range)?e.createBlock(t.range):t.range,L=P(t.range)?e.first(t.range):t.range,j=s(L);if(u(M),j&&!P(t.range)){var J=a.getContextualType(t.range);c(J)}if(v.size>0){for(var z=e.createMap(),V=0,U=L;void 0!==U&&V<r.length;U=U.parent)if(U===r[V]&&(z.forEach(function(e,t){y[V].typeParameterUsages.set(t,e)}),V++),e.isDeclarationWithTypeParameters(U))for(var K=0,q=e.getEffectiveTypeParameterDeclarations(U);K<q.length;K++){var W=q[K],H=a.getTypeAtLocation(W);v.has(H.id.toString())&&z.set(H.id.toString(),H)}e.Debug.assert(V===r.length)}if(D.length){var G=e.isBlockScope(r[0],r[0].parent)?r[0]:e.getEnclosingBlockScopeContainer(r[0]);e.forEachChild(G,d)}for(var Q=function(r){var n=y[r];if(r>0&&(n.usages.size>0||n.typeParameterUsages.size>0)){var i=P(t.range)?t.range[0]:t.range;x[r].push(e.createDiagnosticForNode(i,R.cannotAccessVariablesFromNestedScopes))}var a,o=!1;if(y[r].usages.forEach(function(t){2===t.usage&&(o=!0,106500&t.symbol.flags&&t.symbol.valueDeclaration&&e.hasModifier(t.symbol.valueDeclaration,64)&&(a=t.symbol.valueDeclaration))}),e.Debug.assert(P(t.range)||0===C.length),o&&!P(t.range)){var s=e.createDiagnosticForNode(t.range,R.cannotWriteInExpression);b[r].push(s),x[r].push(s)}else if(a&&r>0){var s=e.createDiagnosticForNode(a,R.cannotExtractReadonlyPropertyInitializerOutsideConstructor);b[r].push(s),x[r].push(s)}else if(m){var s=e.createDiagnosticForNode(m,R.cannotExtractExportedEntity);b[r].push(s),x[r].push(s)}},X=0;X<r.length;X++)Q(X);return{target:M,usagesPerScope:y,functionErrorsPerScope:b,constantErrorsPerScope:x,exposedVariableDeclarations:C}}function O(e){var t=e.parent;switch(t.kind){case 279:return!1}switch(e.kind){case 10:return 250!==t.kind&&254!==t.kind;case 209:case 185:case 187:return!1;case 73:return 187!==t.kind&&254!==t.kind&&258!==t.kind}return!0}function M(e){switch(e.kind){case 219:case 285:case 246:case 272:return!0;default:return!1}}var L="Extract Symbol";t.registerRefactor(L,{getAvailableActions:n,getEditsForAction:i}),r.getAvailableActions=n,r.getEditsForAction=i;var R;!function(t){function r(t){return{message:t,code:0,category:e.DiagnosticCategory.Message,key:t}}t.cannotExtractRange=r("Cannot extract range."),t.cannotExtractImport=r("Cannot extract import statement."),t.cannotExtractSuper=r("Cannot extract super call."),t.cannotExtractEmpty=r("Cannot extract empty range."),t.expressionExpected=r("expression expected."),t.uselessConstantType=r("No reason to extract constant of type."),t.statementOrExpressionExpected=r("Statement or expression expected."),t.cannotExtractRangeContainingConditionalBreakOrContinueStatements=r("Cannot extract range containing conditional break or continue statements."),t.cannotExtractRangeContainingConditionalReturnStatement=r("Cannot extract range containing conditional return statement."),t.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange=r("Cannot extract range containing labeled break or continue with target outside of the range."),t.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators=r("Cannot extract range containing writes to references located outside of the target range in generators."),t.typeWillNotBeVisibleInTheNewScope=r("Type will not visible in the new scope."),t.functionWillNotBeVisibleInTheNewScope=r("Function will not visible in the new scope."),t.cannotExtractIdentifier=r("Select more than a single identifier."),t.cannotExtractExportedEntity=r("Cannot extract exported declaration"),t.cannotWriteInExpression=r("Cannot write back side-effects when extracting an expression"),t.cannotExtractReadonlyPropertyInitializerOutsideConstructor=r("Cannot move initialization of read-only class property outside of the constructor"),t.cannotExtractAmbientBlock=r("Cannot extract code from ambient contexts"),t.cannotAccessVariablesFromNestedScopes=r("Cannot access variables from nested scopes"),t.cannotExtractToOtherFunctionLike=r("Cannot extract method to a function-like scope that is not a function"),t.cannotExtractToJSClass=r("Cannot extract constant to a class scope in JS"),t.cannotExtractToExpressionArrowFunction=r("Cannot extract constant to an arrow function without a block")}(R=r.Messages||(r.Messages={}));var B;!function(e){e[e.None=0]="None",e[e.HasReturn=1]="HasReturn",e[e.IsGenerator=2]="IsGenerator",e[e.IsAsyncFunction=4]="IsAsyncFunction",e[e.UsesThis=8]="UsesThis",e[e.InStaticRegion=16]="InStaticRegion"}(B||(B={})),r.getRangeToExtract=a;var j;!function(e){e[e.Module=0]="Module",e[e.Global=1]="Global"}(j||(j={}));var J;!function(e){e[e.Read=1]="Read",e[e.Write=2]="Write"}(J||(J={}))}(r=t.extractSymbol||(t.extractSymbol={}))}(t=e.refactor||(e.refactor={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t){var r=t.file,o=t.startPosition,s=e.isSourceFileJS(r),c=e.getTokenAtPosition(r,o),u=e.createTextRangeFromSpan(e.getRefactorContextSpan(t)),l=e.findAncestor(c,function(e){return e.parent&&i(u,e,r)&&!i(u,e.parent,r)});if(!l||!e.isTypeNode(l))return void 0;var _=t.program.getTypeChecker(),d=e.Debug.assertDefined(s?e.findAncestor(l,n):e.findAncestor(l,e.isStatement)),p=a(_,l,d,r);return p?{isJS:s,selection:l,firstStatement:d,typeParameters:p}:void 0}function n(t){return e.isStatement(t)&&e.hasJSDocNodes(t)}function i(t,r,n){return e.rangeContainsStartEnd(t,e.skipTrivia(n.text,r.pos),r.end)}function a(t,r,n,a){function o(c){if(e.isTypeReferenceNode(c)){if(e.isIdentifier(c.typeName)){var u=t.resolveName(c.typeName.text,c.typeName,262144,!0);if(u){var l=e.cast(e.first(u.declarations),e.isTypeParameterDeclaration);i(n,l,a)&&!i(r,l,a)&&s.push(l)}}}else if(e.isInferTypeNode(c)){var _=e.findAncestor(c,function(t){return e.isConditionalTypeNode(t)&&i(t.extendsType,c,a)});if(!_||!i(r,_,a))return!0}else if(e.isTypePredicateNode(c)||e.isThisTypeNode(c)){var d=e.findAncestor(c.parent,e.isFunctionLike);if(d&&d.type&&i(d.type,c,a)&&!i(r,d,a))return!0}else if(e.isTypeQueryNode(c))if(e.isIdentifier(c.exprName)){var u=t.resolveName(c.exprName.text,c.exprName,67220415,!1);if(u&&i(n,u.valueDeclaration,a)&&!i(r,u.valueDeclaration,a))return!0}else if(e.isThisIdentifier(c.exprName.left)&&!i(r,c.parent,a))return!0;return e.forEachChild(c,o)}var s=[];return o(r)?void 0:s}function o(t,r,n,i,a,o){var s=e.createTypeAliasDeclaration(void 0,void 0,n,o.map(function(t){return e.updateTypeParameterDeclaration(t,t.name,t.constraint,void 0)}),a);t.insertNodeBefore(r,i,s,!0),t.replaceNode(r,a,e.createTypeReferenceNode(n,o.map(function(t){return e.createTypeReferenceNode(t.name,void 0)})))}function s(t,r,n,i,a,o){var s=e.createNode(310);s.tagName=e.createIdentifier("typedef"),s.fullName=e.createIdentifier(n),s.name=s.fullName,s.typeExpression=e.createJSDocTypeExpression(a);var c=[];e.forEach(o,function(t){var r=e.getEffectiveConstraintOfTypeParameter(t),n=e.createNode(309);n.tagName=e.createIdentifier("template"),n.constraint=r&&e.cast(r,e.isJSDocTypeExpression);var i=e.createNode(151);i.name=t.name,n.typeParameters=e.createNodeArray([i]),c.push(n)}),t.insertNodeBefore(r,i,e.createJSDocComment(void 0,e.createNodeArray(e.concatenate(c,[s]))),!0),t.replaceNode(r,a,e.createTypeReferenceNode(n,o.map(function(t){return e.createTypeReferenceNode(t.name,void 0)})))}var c="Extract type",u="Extract to type alias",l="Extract to typedef";t.registerRefactor(c,{getAvailableActions:function(t){var n=r(t);return n?[{name:c,description:e.getLocaleSpecificMessage(e.Diagnostics.Extract_type),actions:[n.isJS?{name:l,description:e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_typedef)}:{name:u,description:e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_type_alias)}]}]:e.emptyArray},getEditsForAction:function(t,n){e.Debug.assert(n===u||n===l);var i=t.file,a=e.Debug.assertDefined(r(t));e.Debug.assert(n===u&&!a.isJS||n===l&&a.isJS);var c=e.getUniqueName("NewType",i),_=e.textChanges.ChangeTracker.with(t,function(e){return a.isJS?s(e,i,c,a.firstStatement,a.selection,a.typeParameters):o(e,i,c,a.firstStatement,a.selection,a.typeParameters)}),d=i.fileName,p=e.getRenameLocation(_,d,c,!1);return{edits:_,renameFilename:d,renameLocation:p}}})}(t=e.refactor||(e.refactor={}))}(n||(n={}));var n;!function(e){var t;!function(t){var r;!function(){function r(t){return l(t)?[{name:y,description:h,actions:[{name:y,description:h}]}]:e.emptyArray}function n(t){var r=t.file,n=l(t);if(!n)return void 0;var i=e.isSourceFileJS(r),a=e.textChanges.ChangeTracker.fromContext(t),o=n.isStatic,s=n.isReadonly,u=n.fieldName,p=n.accessorName,f=n.originalName,y=n.type,h=n.container,b=n.declaration,x=n.renameAccessor;e.suppressLeadingAndTrailingTrivia(u),e.suppressLeadingAndTrailingTrivia(b),e.suppressLeadingAndTrailingTrivia(h);var D=e.isClassLike(h),S=-65&e.getModifierFlags(b),C=D?!S||8&S?c(i,o,116):e.createNodeArray(e.createModifiersFromModifierFlags(S)):void 0,k=D?c(i,o,114):void 0;m(a,r,b,u,k);var T=_(u,p,y,C,o,h);if(e.suppressLeadingAndTrailingTrivia(T),g(a,r,T,b,h),s){var E=e.getFirstConstructorWithBody(h);E&&v(a,r,E,u.text,f)}else{var N=d(u,p,y,C,o,h);e.suppressLeadingAndTrailingTrivia(N),g(a,r,N,b,h)}var A=a.getChanges(),F=r.fileName,P=x?p:u,w=e.isIdentifier(P)?0:-1,I=w+e.getRenameLocation(A,F,P.text,e.isParameter(b));return{renameFilename:F,renameLocation:I,edits:A}}function i(t){return e.isIdentifier(t)||e.isStringLiteral(t)}function a(t){return e.isParameterPropertyDeclaration(t)||e.isPropertyDeclaration(t)||e.isPropertyAssignment(t)}function o(t,r){return e.isIdentifier(r)?e.createIdentifier(t):e.createLiteral(t)}function s(t,r,n){var i=r?n.name:e.createThis();return e.isIdentifier(t)?e.createPropertyAccess(i,t):e.createElementAccess(i,e.createLiteral(t))}function c(t,r,n){var i=e.append(t?void 0:[e.createToken(n)],r?e.createToken(117):void 0);return i&&e.createNodeArray(i)}function u(e){return 95===e.charCodeAt(0)}function l(t){var r=t.file,n=t.startPosition,s=t.endPosition,c=e.getTokenAtPosition(r,n),l=e.findAncestor(c.parent,a),_=124;if(!l||!e.nodeOverlapsWithStartEnd(l.name,r,n,s)||!i(l.name)||(e.getModifierFlags(l)|_)!==_)return void 0;var d=l.name.text,p=u(d),f=o(p?d:e.getUniqueName("_"+d,r),l.name),m=o(p?e.getUniqueName(d.substring(1),r):d,l.name);return{isStatic:e.hasStaticModifier(l),isReadonly:e.hasReadonlyModifier(l),type:e.getTypeAnnotationNode(l),container:152===l.kind?l.parent.parent:l.parent,originalName:l.name.text,declaration:l,fieldName:f,accessorName:m,renameAccessor:p}}function _(t,r,n,i,a,o){return e.createGetAccessor(void 0,i,r,void 0,n,e.createBlock([e.createReturn(s(t,a,o))],!0))}function d(t,r,n,i,a,o){return e.createSetAccessor(void 0,i,r,[e.createParameter(void 0,void 0,void 0,e.createIdentifier("value"),void 0,n)],e.createBlock([e.createStatement(e.createAssignment(s(t,a,o),e.createIdentifier("value")))],!0))}function p(t,r,n,i,a){var o=e.updateProperty(n,n.decorators,a,i,n.questionToken||n.exclamationToken,n.type,n.initializer);t.replaceNode(r,n,o)}function f(t,r,n,i){var a=e.updatePropertyAssignment(n,i,n.initializer);t.replacePropertyAssignment(r,n,a)}function m(t,r,n,i,a){e.isPropertyDeclaration(n)?p(t,r,n,i,a):e.isPropertyAssignment(n)?f(t,r,n,i):t.replaceNode(r,n,e.updateParameter(n,n.decorators,a,n.dotDotDotToken,e.cast(i,e.isIdentifier),n.questionToken,n.type,n.initializer))}function g(t,r,n,i,a){e.isParameterPropertyDeclaration(i)?t.insertNodeAtClassStart(r,a,n):e.isPropertyAssignment(i)?t.insertNodeAfterComma(r,i,n):t.insertNodeAfter(r,i,n)}function v(t,r,n,i,a){n.body&&n.body.forEachChild(function o(n){e.isElementAccessExpression(n)&&101===n.expression.kind&&e.isStringLiteral(n.argumentExpression)&&n.argumentExpression.text===a&&e.isWriteAccess(n)&&t.replaceNode(r,n.argumentExpression,e.createStringLiteral(i)),e.isPropertyAccessExpression(n)&&101===n.expression.kind&&n.name.text===a&&e.isWriteAccess(n)&&t.replaceNode(r,n.name,e.createIdentifier(i)),e.isFunctionLike(n)||e.isClassLike(n)||n.forEachChild(o)})}var y="Generate 'get' and 'set' accessors",h=e.Diagnostics.Generate_get_and_set_accessors.message;t.registerRefactor(y,{getEditsForAction:n,getAvailableActions:r})}(r=t.generateGetAccessorAndSetAccessor||(t.generateGetAccessorAndSetAccessor={}))}(t=e.refactor||(e.refactor={}))}(n||(n={}));var n;!function(e){var t;!function(t){function r(t){var r=t.file,n=e.createTextRangeFromSpan(e.getRefactorContextSpan(t)),i=r.statements,a=e.findIndex(i,function(e){return e.end>n.pos});if(-1===a)return void 0;var o=i[a];if(e.isNamedDeclaration(o)&&o.name&&e.rangeContainsRange(o.name,n))return{toMove:[i[a]],afterLast:i[a+1]};if(n.pos>o.getStart(r))return void 0;var s=e.findIndex(i,function(e){return e.end>n.end},a);return-1!==s&&(0===s||i[s].getStart(r)<n.end)?void 0:{toMove:i.slice(a,-1===s?i.length:s),afterLast:-1===s?void 0:i[s]}}function n(t,r,n,i,a,c){var u=r.getTypeChecker(),l=E(t,n.all,u),_=e.getDirectoryPath(t.fileName),d=e.extensionFromPath(t.fileName),p=k(T(l.movedSymbols),d,_,a),f=p+d;i.createNewFile(t,e.combinePaths(_,f),s(t,l,i,n,r,p,c)),o(r,i,t.fileName,f,e.hostGetCanonicalFileName(a))}function i(t){var n=r(t);if(void 0===n)return void 0;var i=[],o=[],s=n.toMove,c=n.afterLast;return e.getRangesWhere(s,function(e){return!a(e)},function(e,t){for(var r=e;t>r;r++)i.push(s[r]);o.push({first:s[e],afterLast:c})}),0===i.length?void 0:{all:i,ranges:o}}function a(t){switch(t.kind){case 250:return!0;case 249:return!e.hasModifier(t,1);case 220:return t.declarationList.declarations.every(function(t){return!!t.initializer&&e.isRequireCall(t.initializer,!0)});default:return!1}}function o(t,r,n,i,a){var o=t.getCompilerOptions().configFile;if(o){var s=e.normalizePath(e.combinePaths(n,"..",i)),c=e.getRelativePathFromFile(o.fileName,s,a),u=o.statements[0]&&e.tryCast(o.statements[0].expression,e.isObjectLiteralExpression),l=u&&e.find(u.properties,function(t){return e.isPropertyAssignment(t)&&e.isStringLiteral(t.name)&&"files"===t.name.text});l&&e.isArrayLiteralExpression(l.initializer)&&r.insertNodeInListAfter(o,e.last(l.initializer.elements),e.createLiteral(c),l.initializer.elements)}}function s(t,r,n,i,a,o,s){var _=a.getTypeChecker();if(!t.externalModuleIndicator&&!t.commonJsModuleIndicator)return c(t,i.ranges,n),i.all;var d=!!t.externalModuleIndicator,p=e.getQuotePreference(t,s),f=g(r.oldFileImportsFromNewFile,o,d,p);return f&&e.insertImport(n,t,f),u(t,i.all,n,r.unusedImportsFromOldFile,_),c(t,i.ranges,n),l(n,a,t,r.movedSymbols,o),C(t,r.oldImportsNeededByNewFile,r.newFileImportsFromOldFile,n,_,d,p).concat(b(t,i.all,r.oldFileImportsFromNewFile,d))}function c(e,t,r){for(var n=0,i=t;n<i.length;n++){var a=i[n],o=a.first,s=a.afterLast;r.deleteNodeRangeExcludingEnd(e,o,s)}}function u(t,r,n,i,a){for(var o=0,s=t.statements;o<s.length;o++){var c=s[o];e.contains(r,c)||m(c,function(e){return x(t,e,n,function(e){return i.has(a.getSymbolAtLocation(e))})})}}function l(t,r,n,i,a){for(var o=r.getTypeChecker(),s=function(r){if(r===n)return"continue";for(var s=function(s){m(s,function(c){if(o.getSymbolAtLocation(f(c))===n.symbol){var u=function(t){var r=e.isBindingElement(t.parent)?e.getPropertySymbolFromBindingElement(o,t.parent):e.skipAlias(o.getSymbolAtLocation(t),o);return!!r&&i.has(r)};x(r,c,t,u);var l=e.combinePaths(e.getDirectoryPath(f(c).text),a),p=F(c,e.createLiteral(l),u);p&&t.insertNodeAfter(r,s,p);var m=_(c);m&&d(t,r,o,i,a,l,m,c)}})},c=0,u=r.statements;c<u.length;c++){var l=u[c];s(l)}},c=0,u=r.getSourceFiles();c<u.length;c++){var l=u[c];s(l)}}function _(t){switch(t.kind){case 250:return t.importClause&&t.importClause.namedBindings&&252===t.importClause.namedBindings.kind?t.importClause.namedBindings.name:void 0;case 249:return t.name;case 238:return e.tryCast(t.name,e.isIdentifier);
default:return e.Debug.assertNever(t)}}function d(t,r,n,i,a,o,s,c){var u=e.codefix.moduleSpecifierToValidIdentifier(a,8),l=!1,_=[];if(e.FindAllReferences.Core.eachSymbolReferenceInFile(s,n,r,function(t){e.isPropertyAccessExpression(t.parent)&&(l=l||!!n.resolveName(u,t,67108863,!0),i.has(n.getSymbolAtLocation(t.parent.name))&&_.push(t))}),_.length){for(var d=l?e.getUniqueName(u,r):u,f=0,m=_;f<m.length;f++){var g=m[f];t.replaceNode(r,g,e.createIdentifier(d))}t.insertNodeAfter(r,c,p(c,a,o))}}function p(t,r,n){var i=e.createIdentifier(r),a=e.createLiteral(n);switch(t.kind){case 250:return e.createImportDeclaration(void 0,void 0,e.createImportClause(void 0,e.createNamespaceImport(i)),a);case 249:return e.createImportEqualsDeclaration(void 0,void 0,i,e.createExternalModuleReference(a));case 238:return e.createVariableDeclaration(i,void 0,h(a));default:return e.Debug.assertNever(t)}}function f(e){return 250===e.kind?e.moduleSpecifier:249===e.kind?e.moduleReference.expression:e.initializer.arguments[0]}function m(t,r){if(e.isImportDeclaration(t))e.isStringLiteral(t.moduleSpecifier)&&r(t);else if(e.isImportEqualsDeclaration(t))e.isExternalModuleReference(t.moduleReference)&&e.isStringLiteralLike(t.moduleReference.expression)&&r(t);else if(e.isVariableStatement(t))for(var n=0,i=t.declarationList.declarations;n<i.length;n++){var a=i[n];a.initializer&&e.isRequireCall(a.initializer,!0)&&r(a)}}function g(t,r,n,i){var a,o=[];return t.forEach(function(t){"default"===t.escapedName?a=e.createIdentifier(e.symbolNameNoDefault(t)):o.push(t.name)}),v(a,o,r,n,i)}function v(t,r,n,i,a){if(n=e.ensurePathIsNonModuleName(n),i){var o=r.map(function(t){return e.createImportSpecifier(void 0,e.createIdentifier(t))});return e.makeImportIfNecessary(t,o,n,a)}e.Debug.assert(!t);var s=r.map(function(t){return e.createBindingElement(void 0,void 0,t)});return s.length?y(e.createObjectBindingPattern(s),void 0,h(e.createLiteral(n))):void 0}function y(t,r,n,i){return void 0===i&&(i=2),e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(t,r,n)],i))}function h(t){return e.createCall(e.createIdentifier("require"),void 0,[t])}function b(t,r,n,i){return e.flatMap(r,function(r){if(L(r)&&!U(t,r,i)&&B(r,function(t){return n.has(e.Debug.assertDefined(t.symbol))})){var a=K(r,i);if(a)return a}return r})}function x(t,r,n,i){switch(r.kind){case 250:D(t,r,n,i);break;case 249:i(r.name)&&n.delete(t,r);break;case 238:S(t,r,n,i);break;default:e.Debug.assertNever(r)}}function D(e,t,r,n){if(t.importClause){var i=t.importClause,a=i.name,o=i.namedBindings,s=!a||n(a),c=!o||(252===o.kind?n(o.name):0!==o.elements.length&&o.elements.every(function(e){return n(e.name)}));if(s&&c)r.delete(e,t);else if(a&&s&&r.delete(e,a),o)if(c)r.delete(e,o);else if(253===o.kind)for(var u=0,l=o.elements;u<l.length;u++){var _=l[u];n(_.name)&&r.delete(e,_)}}}function S(t,r,n,i){var a=r.name;switch(a.kind){case 73:i(a)&&n.delete(t,a);break;case 186:break;case 185:if(a.elements.every(function(t){return e.isIdentifier(t.name)&&i(t.name)}))n.delete(t,e.isVariableDeclarationList(r.parent)&&1===r.parent.declarations.length?r.parent.parent:r);else for(var o=0,s=a.elements;o<s.length;o++){var c=s[o];e.isIdentifier(c.name)&&i(c.name)&&n.delete(t,c.name)}}}function C(t,r,n,i,a,o,s){for(var c=[],u=0,l=t.statements;u<l.length;u++){var _=l[u];m(_,function(t){e.append(c,F(t,f(t),function(e){return r.has(a.getSymbolAtLocation(e))}))})}var d,p=[],g=e.nodeSeenTracker();return n.forEach(function(r){for(var n=0,a=r.declarations;n<a.length;n++){var s=a[n];if(O(s)){var c=J(s);if(c){var u=z(s);g(u)&&V(t,u,i,o),e.hasModifier(s,512)?d=c:p.push(c.text)}}}}),e.append(c,v(d,p,e.removeFileExtension(e.getBaseFileName(t.fileName)),o,s)),c}function k(t,r,n,i){for(var a=t,o=1;;o++){var s=e.combinePaths(n,a+r);if(!i.fileExists(s))return a;a=t+"."+o}}function T(t){return t.forEachEntry(e.symbolNameNoDefault)||"newFile"}function E(t,r,n){function i(t){if(void 0===t)return void 0;var r=n.getJsxNamespace(t),i=n.resolveName(r,t,1920,!0);return i&&e.some(i.declarations,N)?i:void 0}var a=new X,o=new X,s=new X,c=e.find(r,function(e){return!!(2&e.transformFlags)}),u=i(c);u&&o.add(u);for(var l=0,_=r;l<_.length;l++){var d=_[l];B(d,function(t){a.add(e.Debug.assertDefined(e.isExpressionStatement(t)?n.getSymbolAtLocation(t.expression.left):t.symbol))})}for(var p=0,f=r;p<f.length;p++){var d=f[p];I(d,n,function(e){if(e.declarations)for(var r=0,n=e.declarations;r<n.length;r++){var i=n[r];N(i)?o.add(e):O(i)&&M(i)===t&&!a.has(e)&&s.add(e)}})}for(var m=o.clone(),g=new X,v=0,y=t.statements;v<y.length;v++){var d=y[v];e.contains(r,d)||(u&&2&d.transformFlags&&m.delete(u),I(d,n,function(e){a.has(e)&&g.add(e),m.delete(e)}))}return{movedSymbols:a,newFileImportsFromOldFile:s,oldFileImportsFromNewFile:g,oldImportsNeededByNewFile:o,unusedImportsFromOldFile:m}}function N(t){switch(t.kind){case 249:case 254:case 251:return!0;case 238:return A(t);case 187:return e.isVariableDeclaration(t.parent.parent)&&A(t.parent.parent);default:return!1}}function A(t){return e.isSourceFile(t.parent.parent.parent)&&!!t.initializer&&e.isRequireCall(t.initializer,!0)}function F(t,r,n){switch(t.kind){case 250:var i=t.importClause;if(!i)return void 0;var a=i.name&&n(i.name)?i.name:void 0,o=i.namedBindings&&P(i.namedBindings,n);return a||o?e.createImportDeclaration(void 0,void 0,e.createImportClause(a,o),r):void 0;case 249:return n(t.name)?t:void 0;case 238:var s=w(t.name,n);return s?y(s,t.type,h(r),t.parent.flags):void 0;default:return e.Debug.assertNever(t)}}function P(t,r){if(252===t.kind)return r(t.name)?t:void 0;var n=t.elements.filter(function(e){return r(e.name)});return n.length?e.createNamedImports(n):void 0}function w(t,r){switch(t.kind){case 73:return r(t)?t:void 0;case 186:return t;case 185:var n=t.elements.filter(function(t){return t.propertyName||!e.isIdentifier(t.name)||r(t.name)});return n.length?e.createObjectBindingPattern(n):void 0}}function I(t,r,n){t.forEachChild(function i(t){if(e.isIdentifier(t)&&!e.isDeclarationName(t)){var a=r.getSymbolAtLocation(t);a&&n(a)}else t.forEachChild(i)})}function O(t){return R(t)&&e.isSourceFile(t.parent)||e.isVariableDeclaration(t)&&e.isSourceFile(t.parent.parent.parent)}function M(t){return e.isVariableDeclaration(t)?t.parent.parent.parent:t.parent}function L(t){return e.Debug.assert(e.isSourceFile(t.parent)),R(t)||e.isVariableStatement(t)}function R(e){switch(e.kind){case 240:case 241:case 245:case 244:case 243:case 242:case 249:return!0;default:return!1}}function B(t,r){switch(t.kind){case 240:case 241:case 245:case 244:case 243:case 242:case 249:return r(t);case 220:return e.firstDefined(t.declarationList.declarations,function(e){return j(e.name,r)});case 222:var n=t.expression;return e.isBinaryExpression(n)&&1===e.getAssignmentDeclarationKind(n)?r(t):void 0}}function j(t,r){switch(t.kind){case 73:return r(e.cast(t.parent,function(t){return e.isVariableDeclaration(t)||e.isBindingElement(t)}));case 186:case 185:return e.firstDefined(t.elements,function(t){return e.isOmittedExpression(t)?void 0:j(t.name,r)});default:return e.Debug.assertNever(t)}}function J(t){return e.isExpressionStatement(t)?t.expression.left.name:e.tryCast(t.name,e.isIdentifier)}function z(t){switch(t.kind){case 238:return t.parent.parent;case 187:return z(e.cast(t.parent.parent,function(t){return e.isVariableDeclaration(t)||e.isBindingElement(t)}));default:return t}}function V(t,r,n,i){if(!U(t,r,i))if(i)e.isExpressionStatement(r)||n.insertExportModifier(t,r);else{var a=H(r);0!==a.length&&n.insertNodesAfter(t,r,a.map(G))}}function U(t,r,n){return n?!e.isExpressionStatement(r)&&e.hasModifier(r,1):H(r).some(function(r){return t.symbol.exports.has(e.escapeLeadingUnderscores(r))})}function K(e,t){return t?[q(e)]:W(e)}function q(t){var r=e.concatenate([e.createModifier(86)],t.modifiers);switch(t.kind){case 240:return e.updateFunctionDeclaration(t,t.decorators,r,t.asteriskToken,t.name,t.typeParameters,t.parameters,t.type,t.body);case 241:return e.updateClassDeclaration(t,t.decorators,r,t.name,t.typeParameters,t.heritageClauses,t.members);case 220:return e.updateVariableStatement(t,r,t.declarationList);case 245:return e.updateModuleDeclaration(t,t.decorators,r,t.name,t.body);case 244:return e.updateEnumDeclaration(t,t.decorators,r,t.name,t.members);case 243:return e.updateTypeAliasDeclaration(t,t.decorators,r,t.name,t.typeParameters,t.type);case 242:return e.updateInterfaceDeclaration(t,t.decorators,r,t.name,t.typeParameters,t.heritageClauses,t.members);case 249:return e.updateImportEqualsDeclaration(t,t.decorators,r,t.name,t.moduleReference);case 222:return e.Debug.fail();default:return e.Debug.assertNever(t)}}function W(e){return[e].concat(H(e).map(G))}function H(t){switch(t.kind){case 240:case 241:return[t.name.text];case 220:return e.mapDefined(t.declarationList.declarations,function(t){return e.isIdentifier(t.name)?t.name.text:void 0});case 245:case 244:case 243:case 242:case 249:return e.emptyArray;case 222:return e.Debug.fail();default:return e.Debug.assertNever(t)}}function G(t){return e.createExpressionStatement(e.createBinary(e.createPropertyAccess(e.createIdentifier("exports"),e.createIdentifier(t)),60,e.createIdentifier(t)))}var Q="Move to a new file";t.registerRefactor(Q,{getAvailableActions:function(t){if(!t.preferences.allowTextChangesInNewFiles||void 0===i(t))return e.emptyArray;var r=e.getLocaleSpecificMessage(e.Diagnostics.Move_to_a_new_file);return[{name:Q,description:r,actions:[{name:Q,description:r}]}]},getEditsForAction:function(t,r){e.Debug.assert(r===Q);var a=e.Debug.assertDefined(i(t)),o=e.textChanges.ChangeTracker.with(t,function(e){return n(t.file,t.program,a,e,t.host,t.preferences)});return{edits:o,renameFilename:void 0,renameLocation:void 0}}});var X=function(){function t(){this.map=e.createMap()}return t.prototype.add=function(t){this.map.set(String(e.getSymbolId(t)),t)},t.prototype.has=function(t){return this.map.has(String(e.getSymbolId(t)))},t.prototype.delete=function(t){this.map.delete(String(e.getSymbolId(t)))},t.prototype.forEach=function(e){this.map.forEach(e)},t.prototype.forEachEntry=function(t){return e.forEachEntry(this.map,t)},t.prototype.clone=function(){var r=new t;return e.copyEntries(this.map,r.map),r},t}()}(t=e.refactor||(e.refactor={}))}(n||(n={}));var n;!function(e){var t;!function(t){var r;!function(){function r(t){var r=t.file,n=t.startPosition,i=a(r,n);return i?[{name:o,description:s,actions:[i.addBraces?{name:c,description:l}:{name:u,description:_}]}]:e.emptyArray}function n(t,r){var n=t.file,o=t.startPosition,s=a(n,o);if(!s)return void 0;var l,_=s.expression,d=s.returnStatement,p=s.func;if(r===c){var f=e.createReturn(_);l=e.createBlock([f],!0),e.suppressLeadingAndTrailingTrivia(l),e.copyLeadingComments(_,f,n,3,!0)}else if(r===u&&d){var m=_||e.createVoidZero();l=i(m)?e.createParen(m):m,e.suppressLeadingAndTrailingTrivia(l),e.copyLeadingComments(d,l,n,3,!1)}else e.Debug.fail("invalid action");var g=e.textChanges.ChangeTracker.with(t,function(e){return e.replaceNode(n,p.body,l)});return{renameFilename:void 0,renameLocation:void 0,edits:g}}function i(t){return e.isBinaryExpression(t)&&27===t.operatorToken.kind||e.isObjectLiteralExpression(t)}function a(t,r){var n=e.getTokenAtPosition(t,r),i=e.getContainingFunction(n);if(!i||!e.isArrowFunction(i)||!e.rangeContainsRange(i,n)||e.rangeContainsRange(i.body,n))return void 0;if(e.isExpression(i.body))return{func:i,addBraces:!0,expression:i.body};if(1===i.body.statements.length){var a=e.first(i.body.statements);if(e.isReturnStatement(a))return{func:i,addBraces:!1,expression:a.expression,returnStatement:a}}return void 0}var o="Add or remove braces in an arrow function",s=e.Diagnostics.Add_or_remove_braces_in_an_arrow_function.message,c="Add braces to arrow function",u="Remove braces from arrow function",l=e.Diagnostics.Add_braces_to_arrow_function.message,_=e.Diagnostics.Remove_braces_from_arrow_function.message;t.registerRefactor(o,{getEditsForAction:n,getAvailableActions:r})}(r=t.addOrRemoveBracesToArrowFunction||(t.addOrRemoveBracesToArrowFunction={}))}(t=e.refactor||(e.refactor={}))}(n||(n={}));var n;!function(e){var t;!function(t){var r;!function(){function r(t){var r=t.file,n=t.startPosition,i=e.isSourceFileJS(r);if(i)return e.emptyArray;var a=_(r,n,t.program.getTypeChecker());if(!a)return e.emptyArray;var o=e.getLocaleSpecificMessage(e.Diagnostics.Convert_parameters_to_destructured_object);return[{name:F,description:o,actions:[{name:F,description:o}]}]}function n(t,r){e.Debug.assert(r===F);var n=t.file,o=t.startPosition,s=t.program,c=t.cancellationToken,u=t.host,l=_(n,o,s.getTypeChecker());if(!l||!c)return void 0;var d=a(l,s,c);if(d.valid){var p=e.textChanges.ChangeTracker.with(t,function(e){return i(n,s,u,e,l,d)});return{renameFilename:void 0,renameLocation:void 0,edits:p}}return{edits:[]}}function i(t,r,n,i,a,o){var s=e.map(C(a,r,n),function(t){return e.getSynthesizedDeepClone(t)});i.replaceNodeRangeWithNodes(t,e.first(a.parameters),e.last(a.parameters),s,{joiner:", ",indentation:0,leadingTriviaOption:e.textChanges.LeadingTriviaOption.IncludeAll,trailingTriviaOption:e.textChanges.TrailingTriviaOption.Include});for(var c=e.sortAndDeduplicate(o.functionCalls,function(t,r){return e.compareValues(t.pos,r.pos)}),u=0,l=c;u<l.length;u++){var _=l[u];if(_.arguments&&_.arguments.length){var d=e.getSynthesizedDeepClone(S(a,_.arguments),!0);i.replaceNodeRange(e.getSourceFileOfNode(_),e.first(_.arguments),e.last(_.arguments),d,{leadingTriviaOption:e.textChanges.LeadingTriviaOption.IncludeAll,trailingTriviaOption:e.textChanges.TrailingTriviaOption.Include})}}}function a(t,r,n){function i(r){for(var n={accessExpressions:[],typeUsages:[]},i={functionCalls:[],declarations:[],classReferences:n,valid:!0},p=e.map(_,a),f=e.map(d,a),m=e.isConstructorDeclaration(t),g=0,v=r;g<v.length;g++){var y=v[g];if(1===y.kind){if(e.contains(p,a(y.node))||e.isNewExpressionTarget(y.node)){var h=o(y);if(h)continue;var b=s(y);if(b){i.declarations.push(b);continue}var x=c(y);if(x){i.functionCalls.push(x);continue}}if(m&&e.contains(f,a(y.node))){var h=o(y);if(h)continue;var b=s(y);if(b){i.declarations.push(b);continue}var D=u(y);if(D){n.accessExpressions.push(D);continue}if(e.isClassDeclaration(t.parent)){var S=l(y);if(S){n.typeUsages.push(S);continue}}}i.valid=!1}else i.valid=!1}return i}function a(t){var r=f.getSymbolAtLocation(t);return r&&e.getSymbolTarget(r,f)}var _=A(t),d=e.isConstructorDeclaration(t)?N(t):[],p=e.deduplicate(_.concat(d),e.equateValues),f=r.getTypeChecker(),m=e.flatMap(p,function(t){return e.FindAllReferences.getReferenceEntriesForNode(-1,t,r,r.getSourceFiles(),n)}),g=i(m);return e.every(g.declarations,function(t){return e.contains(p,t)})||(g.valid=!1),g}function o(t){var r=t.node;return e.isImportSpecifier(r.parent)||e.isImportClause(r.parent)||e.isImportEqualsDeclaration(r.parent)||e.isNamespaceImport(r.parent)?r:e.isExportSpecifier(r.parent)||e.isExportAssignment(r.parent)?r:void 0}function s(t){return e.isDeclaration(t.node.parent)?t.node:void 0}function c(t){if(t.node.parent){var r=t.node,n=r.parent;switch(n.kind){case 192:case 193:var i=e.tryCast(n,e.isCallOrNewExpression);if(i&&i.expression===r)return i;break;case 190:var a=e.tryCast(n,e.isPropertyAccessExpression);if(a&&a.parent&&a.name===r){var o=e.tryCast(a.parent,e.isCallOrNewExpression);if(o&&o.expression===a)return o}break;case 191:var s=e.tryCast(n,e.isElementAccessExpression);if(s&&s.parent&&s.argumentExpression===r){var c=e.tryCast(s.parent,e.isCallOrNewExpression);if(c&&c.expression===s)return c}}}return void 0}function u(t){if(t.node.parent){var r=t.node,n=r.parent;switch(n.kind){case 190:var i=e.tryCast(n,e.isPropertyAccessExpression);if(i&&i.expression===r)return i;break;case 191:var a=e.tryCast(n,e.isElementAccessExpression);if(a&&a.expression===r)return a}}return void 0}function l(t){var r=t.node;return 2===e.getMeaningFromLocation(r)||e.isExpressionWithTypeArgumentsInClassExtendsClause(r.parent)?r:void 0}function _(t,r,n){var i=e.getTouchingToken(t,r),a=e.getContainingFunctionDeclaration(i);return d(i)?void 0:!(a&&p(a,n)&&e.rangeContainsRange(a,i))||a.body&&e.rangeContainsRange(a.body,i)?void 0:a}function d(t){var r=e.findAncestor(t,e.isJSDocNode);if(r){var n=e.findAncestor(r,function(t){return!e.isJSDocNode(t)});return!!n&&e.isFunctionLikeDeclaration(n)}return!1}function p(t,r){if(!g(t.parameters,r))return!1;switch(t.kind){case 240:return m(t)&&f(t,r);case 157:return f(t,r);case 158:return e.isClassDeclaration(t.parent)?m(t.parent)&&f(t,r):y(t.parent.parent)&&f(t,r);case 197:case 198:return y(t.parent)}return!1}function f(e,t){return!!e.body&&!t.isImplementationOfOverload(e)}function m(t){if(!t.name){var r=e.findModifier(t,81);return!!r}return!0}function g(t,r){return b(t)>=P&&e.every(t,function(e){return v(e,r)})}function v(t,r){if(e.isRestParameter(t)){var n=r.getTypeAtLocation(t);if(!r.isArrayType(n)&&!r.isTupleType(n))return!1}return!t.modifiers&&!t.decorators&&e.isIdentifier(t.name)}function y(t){return e.isVariableDeclaration(t)&&e.isVarConst(t)&&e.isIdentifier(t.name)&&!t.type}function h(t){return t.length>0&&e.isThis(t[0].name)}function b(e){return h(e)?e.length-1:e.length}function x(t){return h(t)&&(t=e.createNodeArray(t.slice(1),t.hasTrailingComma)),t}function D(t,r){return e.isIdentifier(r)&&e.getTextOfIdentifierOrLiteral(r)===t?e.createShorthandPropertyAssignment(t):e.createPropertyAssignment(t,r)}function S(t,r){var n=x(t.parameters),i=e.isRestParameter(e.last(n)),a=i?r.slice(0,n.length-1):r,o=e.map(a,function(t,r){var i=E(n[r]),a=D(i,t);return e.suppressLeadingAndTrailingTrivia(a.name),e.isPropertyAssignment(a)&&e.suppressLeadingAndTrailingTrivia(a.initializer),k(t,a),a});if(i&&r.length>=n.length){var s=r.slice(n.length-1),c=e.createPropertyAssignment(E(e.last(n)),e.createArrayLiteral(s));o.push(c)}var u=e.createObjectLiteral(o,!1);return u}function C(t,r,n){function i(t){var r=e.createBindingElement(void 0,void 0,E(t),e.isRestParameter(t)&&c(t)?e.createArrayLiteral():t.initializer);return e.suppressLeadingAndTrailingTrivia(r),t.initializer&&r.initializer&&k(t.initializer,r.initializer),r}function a(t){var r=e.map(t,o),n=e.addEmitFlags(e.createTypeLiteralNode(r),1);return n}function o(t){var r=t.type;r||!t.initializer&&!e.isRestParameter(t)||(r=s(t));var n=e.createPropertySignature(void 0,E(t),c(t)?e.createToken(56):t.questionToken,r,void 0);return e.suppressLeadingAndTrailingTrivia(n),k(t.name,n.name),t.type&&n.type&&k(t.type,n.type),n}function s(t){var i=l.getTypeAtLocation(t);return e.getTypeNodeIfAccessible(i,t,r,n)}function c(t){if(e.isRestParameter(t)){var r=l.getTypeAtLocation(t);return!l.isTupleType(r)}return l.isOptionalParameter(t)}var u,l=r.getTypeChecker(),_=x(t.parameters),d=e.map(_,i),p=e.createObjectBindingPattern(d),f=a(_);e.every(_,c)&&(u=e.createObjectLiteral());var m=e.createParameter(void 0,void 0,void 0,p,void 0,f,u);if(h(t.parameters)){var g=t.parameters[0],v=e.createParameter(void 0,void 0,void 0,g.name,void 0,g.type);return e.suppressLeadingAndTrailingTrivia(v.name),k(g.name,v.name),g.type&&(e.suppressLeadingAndTrailingTrivia(v.type),k(g.type,v.type)),e.createNodeArray([v,m])}return e.createNodeArray([m])}function k(t,r){var n=t.getSourceFile(),i=n.text;T(t,i)?e.copyLeadingComments(t,r,n):e.copyTrailingAsLeadingComments(t,r,n),e.copyTrailingComments(t,r,n)}function T(e,t){for(var r=e.getFullStart(),n=e.getStart(),i=r;n>i;i++)if(10===t.charCodeAt(i))return!0;return!1}function E(t){return e.getTextOfIdentifierOrLiteral(t.name)}function N(t){switch(t.parent.kind){case 241:var r=t.parent;if(r.name)return[r.name];var n=e.Debug.assertDefined(e.findModifier(r,81),"Nameless class declaration should be a default export");return[n];case 210:var i=t.parent,a=t.parent.parent,o=i.name;return o?[o,a.name]:[a.name]}}function A(t){switch(t.kind){case 240:if(t.name)return[t.name];var r=e.Debug.assertDefined(e.findModifier(t,81),"Nameless function declaration should be a default export");return[r];case 157:return[t.name];case 158:var n=e.Debug.assertDefined(e.findChildOfKind(t,125,t.getSourceFile()),"Constructor declaration should have constructor keyword");if(210===t.parent.kind){var i=t.parent.parent;return[i.name,n]}return[n];case 198:return[t.parent.name];case 197:return t.name?[t.name,t.parent.name]:[t.parent.name];default:return e.Debug.assertNever(t)}}var F="Convert parameters to destructured object",P=2;t.registerRefactor(F,{getEditsForAction:n,getAvailableActions:r})}(r=t.convertParamsToDestructuredObject||(t.convertParamsToDestructuredObject={}))}(t=e.refactor||(e.refactor={}))}(n||(n={}));var n;!function(e){function t(t,r,n,i){var a=e.isNodeKind(t)?new A(t,r,n):73===t?new I(73,r,n):new w(t,r,n);return a.parent=i,a.flags=12679168&i.flags,a}function r(t,r){if(!e.isNodeKind(t.kind))return e.emptyArray;var i=[];if(e.isJSDocCommentContainingNode(t))return t.forEachChild(function(e){i.push(e)}),i;e.scanner.setText((r||t.getSourceFile()).text);var o=t.pos,s=function(e){n(i,o,e.pos,t),i.push(e),o=e.end},c=function(e){n(i,o,e.pos,t),i.push(a(e,t)),o=e.end};return e.forEach(t.jsDoc,s),o=t.pos,t.forEachChild(s,c),n(i,o,t.end,t),e.scanner.setText(void 0),i}function n(r,n,i,a){for(e.scanner.setTextPos(n);i>n;){var o=e.scanner.scan(),s=e.scanner.getTextPos();if(i>=s&&(73===o&&e.Debug.fail("Did not expect "+e.Debug.formatSyntaxKind(a.kind)+" to have an Identifier in its trivia"),r.push(t(o,n,s,a))),n=s,1===o)break}}function a(e,r){var i=t(312,e.pos,e.end,r);i._children=[];for(var a=e.pos,o=0,s=e;o<s.length;o++){var c=s[o];n(i._children,a,c.pos,r),i._children.push(c),a=c.end}return n(i._children,a,e.end,r),i}function o(t){return e.getJSDocTags(t).some(function(e){return"inheritDoc"===e.tagName.text})}function c(t,r){if(!t)return e.emptyArray;var n=e.JsDoc.getJsDocCommentsFromDeclarations(t);if(0===n.length||t.some(o))for(var i=0,a=t;i<a.length;i++){var s=a[i],c=u(s,s.symbol.name,r);c&&(n=0===n.length?c.slice():c.concat(e.lineBreakPart(),n))}return n}function u(t,r,n){return e.firstDefined(t.parent?e.getAllSuperTypeNodes(t.parent):e.emptyArray,function(e){var t=n.getTypeAtLocation(e),i=t&&n.getPropertyOfType(t,r),a=i&&i.getDocumentationComment(n);return a&&a.length?a:void 0})}function l(){return{getNodeConstructor:function(){return A},getTokenConstructor:function(){return w},getIdentifierConstructor:function(){return I},getSourceFileConstructor:function(){return L},getSymbolConstructor:function(){return P},getTypeConstructor:function(){return O},getSignatureConstructor:function(){return M},getSourceMapSourceConstructor:function(){return R}}}function _(t){var r=!0;for(var n in t)if(e.hasProperty(t,n)&&!d(n)){r=!1;break}if(r)return t;var i={};for(var n in t)if(e.hasProperty(t,n)){var a=d(n)?n:n.charAt(0).toLowerCase()+n.substr(1);i[a]=t[n]}return i}function d(e){return!e.length||e.charAt(0)===e.charAt(0).toLowerCase()}function p(t){return t?e.map(t,function(e){return e.text}).join(""):""}function f(){return{target:1,jsx:1}}function m(){return e.codefix.getSupportedErrorCodes()}function g(e,t,r){e.version=r,e.scriptSnapshot=t}function v(t,r,n,i,a,o){var s=e.createSourceFile(t,e.getSnapshotText(r),n,a,o);return g(s,r,i),s}function y(t,r,n,i,a){if(i&&n!==t.version&&!e.disableIncrementalParsing){var o=void 0,s=0!==i.span.start?t.text.substr(0,i.span.start):"",c=e.textSpanEnd(i.span)!==t.text.length?t.text.substr(e.textSpanEnd(i.span)):"";if(0===i.newLength)o=s&&c?s+c:s||c;else{var u=r.getText(i.span.start,i.span.start+i.newLength);o=s&&c?s+u+c:s?s+u:u+c}var l=e.updateSourceFile(t,o,i,a);return g(l,r,n),l.nameTable=void 0,t!==l&&t.scriptSnapshot&&(t.scriptSnapshot.dispose&&t.scriptSnapshot.dispose(),t.scriptSnapshot=void 0),l}return v(t.fileName,r,t.languageVersion,n,!0,t.scriptKind)}function h(t,r,n){function a(e){t.log&&t.log(e)}function o(e){var t=ht.getSourceFile(e);if(!t)throw new Error("Could not find sourceFile: '"+e+"' in "+(ht&&JSON.stringify(ht.getSourceFiles().map(function(e){return e.fileName})))+".");return t}function s(){function i(r){var n=e.toPath(r,Ct,Tt),i=d&&d.getEntryByPath(n);return i?!e.isString(i):!!t.fileExists&&t.fileExists(r)}function o(r){var n=e.toPath(r,Ct,Tt),i=d&&d.getEntryByPath(n);return i?e.isString(i)?void 0:e.getSnapshotText(i.scriptSnapshot):t.readFile&&t.readFile(r)}function s(e,t){var n=r.getKeyForCompilationSettings(t);r.releaseDocumentWithKey(e.resolvedPath,n)}function c(t,r,n,i){return u(t,e.toPath(t,Ct,Tt),r,n,i)}function u(t,n,i,a,o){e.Debug.assert(void 0!==d,"getOrCreateSourceFileByPath called after typical CompilerHost lifetime, check the callstack something with a reference to an old host.");var s=d&&d.getOrCreateEntryByPath(t,n);if(!s)return void 0;if(!o){var c=ht&&ht.getSourceFileByPath(n);if(c)return e.Debug.assertEqual(s.scriptKind,c.scriptKind,"Registered script kind should match new script kind.",n),r.updateDocumentWithKey(t,n,g,y,s.scriptSnapshot,s.version,s.scriptKind)}return r.acquireDocumentWithKey(t,n,g,y,s.scriptSnapshot,s.version,s.scriptKind)}if(e.Debug.assert(!n),t.getProjectVersion){var l=t.getProjectVersion();if(l){if(bt===l&&!t.hasChangedAutomaticTypeDirectiveNames)return;bt=l}}var _=t.getTypeRootsVersion?t.getTypeRootsVersion():0;Dt!==_&&(a("TypeRoots version has changed; provide new program"),ht=void 0,Dt=_);var d=new B(t,Tt),p=d.getRootFileNames(),f=t.hasInvalidatedResolution||e.returnFalse,m=d.getProjectReferences();if(!e.isProgramUptoDate(ht,p,d.compilationSettings(),function(e){return d.getVersion(e)},i,f,!!t.hasChangedAutomaticTypeDirectiveNames,m)){var g=d.compilationSettings(),v={getSourceFile:c,getSourceFileByPath:u,getCancellationToken:function(){return St},getCanonicalFileName:Tt,useCaseSensitiveFileNames:function(){return kt},getNewLine:function(){return e.getNewLineCharacter(g,function(){return e.getNewLineOrDefaultFromHost(t)})},getDefaultLibFileName:function(e){return t.getDefaultLibFileName(e)},writeFile:e.noop,getCurrentDirectory:function(){return Ct},fileExists:i,readFile:o,realpath:t.realpath&&function(e){return t.realpath(e)},directoryExists:function(r){return e.directoryProbablyExists(r,t)},getDirectories:function(e){return t.getDirectories?t.getDirectories(e):[]},readDirectory:function(r,n,i,a,o){return e.Debug.assertDefined(t.readDirectory,"'LanguageServiceHost.readDirectory' must be implemented to correctly process 'projectReferences'"),t.readDirectory(r,n,i,a,o)},onReleaseOldSourceFile:s,hasInvalidatedResolution:f,hasChangedAutomaticTypeDirectiveNames:t.hasChangedAutomaticTypeDirectiveNames};t.trace&&(v.trace=function(e){return t.trace(e)}),t.resolveModuleNames&&(v.resolveModuleNames=function(e,r,n,i){return t.resolveModuleNames(e,r,n,i)}),t.resolveTypeReferenceDirectives&&(v.resolveTypeReferenceDirectives=function(e,r,n){return t.resolveTypeReferenceDirectives(e,r,n)});var y=r.getKeyForCompilationSettings(g),h={rootNames:p,options:g,host:v,oldProgram:ht,projectReferences:m};ht=e.createProgram(h),d=void 0,Et.clearCache(),ht.getTypeChecker()}}function c(){return n?void e.Debug.assert(void 0===ht):(s(),ht)}function u(){ht=void 0}function l(){ht&&(e.forEach(ht.getSourceFiles(),function(e){return r.releaseDocument(e.fileName,ht.getCompilerOptions())}),ht=void 0),t=void 0}function d(e){return s(),ht.getSyntacticDiagnostics(o(e),St).slice()}function p(t){s();var r=o(t),n=ht.getSemanticDiagnostics(r,St);if(!e.getEmitDeclarations(ht.getCompilerOptions()))return n.slice();var i=ht.getDeclarationDiagnostics(r,St);return n.concat(i)}function f(t){return s(),e.computeSuggestionDiagnostics(o(t),ht,St)}function m(){return s(),ht.getOptionsDiagnostics(St).concat(ht.getGlobalDiagnostics(St))}function g(r,n,c){void 0===c&&(c=e.emptyOptions);var u=i({},e.identity(c),{includeCompletionsForModuleExports:c.includeCompletionsForModuleExports||c.includeExternalModuleExports,includeCompletionsWithInsertText:c.includeCompletionsWithInsertText||c.includeInsertTextCompletions});return s(),e.Completions.getCompletionsAtPosition(t,ht,a,o(r),n,u,c.triggerCharacter)}function v(r,n,i,c,u,l){return void 0===l&&(l=e.emptyOptions),s(),e.Completions.getCompletionEntryDetails(ht,a,o(r),n,{name:i,source:u},t,c&&e.formatting.getFormatContext(c),l,St)}function y(t,r,n,i){return s(),e.Completions.getCompletionEntrySymbol(ht,a,o(t),r,{name:n,source:i})}function h(t,r){s();var n=o(t),i=e.getTouchingPropertyName(n,r);if(i===n)return void 0;var a=ht.getTypeChecker(),c=b(i),u=k(c,a);if(!u||a.isUnknownSymbol(u)){var l=x(n,c,r)?a.getTypeAtLocation(c):void 0;return l&&{kind:"",kindModifiers:"",textSpan:e.createTextSpanFromNode(c,n),displayParts:a.runWithCancellationToken(St,function(t){return e.typeToDisplayParts(t,l,e.getContainerNode(c))}),documentation:l.symbol?l.symbol.getDocumentationComment(a):void 0,tags:l.symbol?l.symbol.getJsDocTags():void 0}}var _=a.runWithCancellationToken(St,function(t){return e.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(t,u,n,e.getContainerNode(c),c)}),d=_.symbolKind,p=_.displayParts,f=_.documentation,m=_.tags;return{kind:d,kindModifiers:e.SymbolDisplay.getSymbolModifiers(u),textSpan:e.createTextSpanFromNode(c,n),displayParts:p,documentation:f,tags:m}}function b(t){return e.isNewExpression(t.parent)&&t.pos===t.parent.pos?t.parent.expression:t}function x(t,r,n){switch(r.kind){case 73:return!e.isLabelName(r)&&!e.isTagName(r);case 190:case 149:return!e.isInComment(t,n);case 101:case 179:case 99:return!0;default:return!1}}function D(t,r){return s(),e.GoToDefinition.getDefinitionAtPosition(ht,o(t),r)}function S(t,r){return s(),e.GoToDefinition.getDefinitionAndBoundSpan(ht,o(t),r)}function C(t,r){return s(),e.GoToDefinition.getTypeDefinitionAtPosition(ht.getTypeChecker(),o(t),r)}function T(t,r){return s(),e.FindAllReferences.getImplementationsAtPosition(ht,St,ht.getSourceFiles(),o(t),r)}function E(t,r){return e.flatMap(N(t,r,[t]),function(e){return e.highlightSpans.map(function(t){return{fileName:e.fileName,textSpan:t.textSpan,isWriteAccess:"writtenReference"===t.kind,isDefinition:!1,isInString:t.isInString}})})}function N(t,r,n){var i=e.normalizePath(t);e.Debug.assert(n.some(function(t){return e.normalizePath(t)===i})),s();var a=n.map(o),c=o(t);return e.DocumentHighlights.getDocumentHighlights(ht,St,c,r,a)}function A(t,r,n,i,a){s();var c=o(t),u=e.getTouchingPropertyName(c,r);if(e.isIdentifier(u)&&(e.isJsxOpeningElement(u.parent)||e.isJsxClosingElement(u.parent))&&e.isIntrinsicJsxName(u.escapedText)){var l=u.parent.parent,_=l.openingElement,d=l.closingElement;return[_,d].map(function(t){return{fileName:c.fileName,textSpan:e.createTextSpanFromNode(t.tagName,c)}})}return P(u,r,{findInStrings:n,findInComments:i,providePrefixAndSuffixTextForRename:a,isForRename:!0},function(t,r,n){return e.FindAllReferences.toRenameLocation(t,r,n,a||!1)})}function F(t,r){return s(),P(e.getTouchingPropertyName(o(t),r),r,{},e.FindAllReferences.toReferenceEntry)}function P(t,r,n,i){s();var a=n&&n.isForRename?ht.getSourceFiles().filter(function(e){return!ht.isSourceFileDefaultLibrary(e)}):ht.getSourceFiles();return e.FindAllReferences.findReferenceOrRenameEntries(ht,St,a,t,r,n,i)}function w(t,r){return s(),e.FindAllReferences.findReferencedSymbols(ht,St,ht.getSourceFiles(),o(t),r)}function I(t,r,n,i){void 0===i&&(i=!1),s();var a=n?[o(n)]:ht.getSourceFiles();return e.NavigateTo.getNavigateToItems(a,ht.getTypeChecker(),St,t,r,i)}function O(r,n){void 0===n&&(n=!1),s();var i=o(r),a=t.getCustomTransformers&&t.getCustomTransformers();return e.getFileEmitOutput(ht,i,n,St,a)}function M(t,r,n){var i=(void 0===n?e.emptyOptions:n).triggerReason;s();var a=o(t);return e.SignatureHelp.getSignatureHelpItems(ht,a,r,i,St)}function L(e){return xt.getCurrentSourceFile(e)}function R(t,r){var n=xt.getCurrentSourceFile(t),i=e.getTouchingPropertyName(n,r);if(i===n)return void 0;switch(i.kind){case 190:case 149:case 10:case 88:case 103:case 97:case 99:case 101:case 179:case 73:break;default:return void 0}for(var a=i;;)if(e.isRightSideOfPropertyAccess(a)||e.isRightSideOfQualifiedName(a))a=a.parent;else{if(!e.isNameOfModuleDeclaration(a))break;if(245!==a.parent.parent.kind||a.parent.parent.body!==a.parent)break;
a=a.parent.parent.name}return e.createTextSpanFromBounds(a.getStart(),i.getEnd())}function z(t,r){var n=xt.getCurrentSourceFile(t);return e.BreakpointResolver.spanInSourceFileAtLocation(n,r)}function V(t){return e.NavigationBar.getNavigationBarItems(xt.getCurrentSourceFile(t),St)}function U(t){return e.NavigationBar.getNavigationTree(xt.getCurrentSourceFile(t),St)}function K(r){var n=e.getScriptKind(r,t);return 3===n||4===n}function q(t,r){return K(t)?(s(),e.getSemanticClassifications(ht.getTypeChecker(),St,o(t),ht.getClassifiableNames(),r)):[]}function W(t,r){return K(t)?(s(),e.getEncodedSemanticClassifications(ht.getTypeChecker(),St,o(t),ht.getClassifiableNames(),r)):{spans:[],endOfLineState:0}}function H(t,r){return e.getSyntacticClassifications(St,xt.getCurrentSourceFile(t),r)}function G(t,r){return e.getEncodedSyntacticClassifications(St,xt.getCurrentSourceFile(t),r)}function Q(t){var r=xt.getCurrentSourceFile(t);return e.OutliningElementsCollector.collectElements(r,St)}function X(t,r){var n=xt.getCurrentSourceFile(t),i=e.getTouchingToken(n,r),a=i.getStart(n)===r?Nt.get(i.kind.toString()):void 0,o=a&&e.findChildOfKind(i.parent,a,n);return o?[e.createTextSpanFromNode(i,n),e.createTextSpanFromNode(o,n)].sort(function(e,t){return e.start-t.start}):e.emptyArray}function Y(t,r,n){var i=e.timestamp(),o=_(n),s=xt.getCurrentSourceFile(t);a("getIndentationAtPosition: getCurrentSourceFile: "+(e.timestamp()-i)),i=e.timestamp();var c=e.formatting.SmartIndenter.getIndentation(r,s,o);return a("getIndentationAtPosition: computeIndentation  : "+(e.timestamp()-i)),c}function Z(t,r,n,i){var a=xt.getCurrentSourceFile(t);return e.formatting.formatSelection(r,n,a,e.formatting.getFormatContext(_(i)))}function $(t,r){return e.formatting.formatDocument(xt.getCurrentSourceFile(t),e.formatting.getFormatContext(_(r)))}function et(t,r,n,i){var a=xt.getCurrentSourceFile(t),o=e.formatting.getFormatContext(_(i));if(!e.isInComment(a,r))switch(n){case"{":return e.formatting.formatOnOpeningCurly(r,a,o);case"}":return e.formatting.formatOnClosingCurly(r,a,o);case";":return e.formatting.formatOnSemicolon(r,a,o);case"\n":return e.formatting.formatOnEnter(r,a,o)}return[]}function tt(r,n,i,a,c,u){void 0===u&&(u=e.emptyOptions),s();var l=o(r),_=e.createTextSpanFromBounds(n,i),d=e.formatting.getFormatContext(c);return e.flatMap(e.deduplicate(a,e.equateValues,e.compareValues),function(r){return St.throwIfCancellationRequested(),e.codefix.getFixes({errorCode:r,sourceFile:l,span:_,program:ht,host:t,cancellationToken:St,formatContext:d,preferences:u})})}function rt(r,n,i,a){void 0===a&&(a=e.emptyOptions),s(),e.Debug.assert("file"===r.type);var c=o(r.fileName),u=e.formatting.getFormatContext(i);return e.codefix.getAllFixes({fixId:n,sourceFile:c,program:ht,host:t,cancellationToken:St,formatContext:u,preferences:a})}function nt(r,n,i){void 0===i&&(i=e.emptyOptions),s(),e.Debug.assert("file"===r.type);var a=o(r.fileName),c=e.formatting.getFormatContext(n);return e.OrganizeImports.organizeImports(a,c,t,ht,i)}function it(r,n,i,a){return void 0===a&&(a=e.emptyOptions),e.getEditsForFileRename(c(),r,n,t,e.formatting.getFormatContext(i),a,Et)}function at(t,r){var n="string"==typeof t?r:t;return e.isArray(n)?Promise.all(n.map(function(e){return ot(e)})):ot(n)}function ot(r){var n=function(t){return e.toPath(t,Ct,Tt)};return e.Debug.assertEqual(r.type,"install package"),t.installPackage?t.installPackage({fileName:n(r.file),packageName:r.packageName}):Promise.reject("Host does not implement `installPackage`")}function st(r,n){return e.JsDoc.getDocCommentTemplateAtPosition(e.getNewLineOrDefaultFromHost(t),xt.getCurrentSourceFile(r),n)}function ct(t,r,n){if(60===n)return!1;var i=xt.getCurrentSourceFile(t);if(e.isInString(i,r))return!1;if(e.isInsideJsxElementOrAttribute(i,r))return 123===n;if(e.isInTemplateString(i,r))return!1;switch(n){case 39:case 34:case 96:return!e.isInComment(i,r)}return!0}function ut(t,r){var n=xt.getCurrentSourceFile(t),i=e.findPrecedingToken(r,n);if(!i)return void 0;var a=30===i.kind&&e.isJsxOpeningElement(i.parent)?i.parent.parent:e.isJsxText(i)?i.parent:void 0;return a&&lt(a)?{newText:"</"+a.openingElement.tagName.getText(n)+">"}:void 0}function lt(t){var r=t.openingElement,n=t.closingElement,i=t.parent;return!e.tagNamesAreEquivalent(r.tagName,n.tagName)||e.isJsxElement(i)&&e.tagNamesAreEquivalent(r.tagName,i.openingElement.tagName)&&lt(i)}function _t(t,r,n){var i=xt.getCurrentSourceFile(t),a=e.formatting.getRangeOfEnclosingComment(i,r);return!a||n&&3!==a.kind?void 0:e.createTextSpanFromRange(a)}function dt(t,r){function n(e){return e.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g,"\\$&")}function i(){var t=/(?:\/\/+\s*)/.source,i=/(?:\/\*+\s*)/.source,a=/(?:^(?:\s|\*)*)/.source,o="("+a+"|"+t+"|"+i+")",s="(?:"+e.map(r,function(e){return"("+n(e.text)+")"}).join("|")+")",c=/(?:$|\*\/)/.source,u=/(?:.*?)/.source,l="("+s+u+")",_=o+l+c;return new RegExp(_,"gim")}function a(e){return e>=97&&122>=e||e>=65&&90>=e||e>=48&&57>=e}function c(t){return e.stringContains(t,"/node_modules/")}s();var u=o(t);St.throwIfCancellationRequested();var l=u.text,_=[];if(r.length>0&&!c(u.fileName))for(var d=i(),p=void 0;p=d.exec(l);){St.throwIfCancellationRequested();var f=3;e.Debug.assert(p.length===r.length+f);var m=p[1],g=p.index+m.length;if(e.isInComment(u,g)){for(var v=void 0,y=0;y<r.length;y++)p[y+f]&&(v=r[y]);if(void 0===v)return e.Debug.fail();if(!a(l.charCodeAt(g+v.text.length))){var h=p[2];_.push({descriptor:v,message:h,position:g})}}}return _}function pt(t,r,n){return s(),e.Rename.getRenameInfo(ht,o(t),r,n)}function ft(r,n,i,a){var o="number"==typeof n?[n,void 0]:[n.pos,n.end],s=o[0],u=o[1];return{file:r,startPosition:s,endPosition:u,program:c(),host:t,formatContext:e.formatting.getFormatContext(a),cancellationToken:St,preferences:i}}function mt(t,r){return e.SmartSelectionRange.getSmartSelectionRange(r,xt.getCurrentSourceFile(t))}function gt(t,r,n){void 0===n&&(n=e.emptyOptions),s();var i=o(t);return e.refactor.getApplicableRefactors(ft(i,r,n))}function vt(t,r,n,i,a,c){void 0===c&&(c=e.emptyOptions),s();var u=o(t);return e.refactor.getEditsForRefactor(ft(u,n,c,r),i,a)}var yt;void 0===r&&(r=e.createDocumentRegistry(t.useCaseSensitiveFileNames&&t.useCaseSensitiveFileNames(),t.getCurrentDirectory())),void 0===n&&(n=!1);var ht,bt,xt=new j(t),Dt=0,St=new J(t.getCancellationToken&&t.getCancellationToken()),Ct=t.getCurrentDirectory();!e.localizedDiagnosticMessages&&t.getLocalizedDiagnosticMessages&&(e.localizedDiagnosticMessages=t.getLocalizedDiagnosticMessages());var kt=e.hostUsesCaseSensitiveFileNames(t),Tt=e.createGetCanonicalFileName(kt),Et=e.getSourceMapper({useCaseSensitiveFileNames:function(){return kt},getCurrentDirectory:function(){return Ct},getProgram:c,fileExists:t.fileExists&&function(e){return t.fileExists(e)},readFile:t.readFile&&function(e,r){return t.readFile(e,r)},getDocumentPositionMapper:t.getDocumentPositionMapper&&function(e,r){return t.getDocumentPositionMapper(e,r)},getSourceFileLike:t.getSourceFileLike&&function(e){return t.getSourceFileLike(e)},log:a}),Nt=e.createMapFromTemplate((yt={},yt[18]=19,yt[20]=21,yt[22]=23,yt[30]=28,yt));return Nt.forEach(function(e,t){return Nt.set(e.toString(),Number(t))}),{dispose:l,cleanupSemanticCache:u,getSyntacticDiagnostics:d,getSemanticDiagnostics:p,getSuggestionDiagnostics:f,getCompilerOptionsDiagnostics:m,getSyntacticClassifications:H,getSemanticClassifications:q,getEncodedSyntacticClassifications:G,getEncodedSemanticClassifications:W,getCompletionsAtPosition:g,getCompletionEntryDetails:v,getCompletionEntrySymbol:y,getSignatureHelpItems:M,getQuickInfoAtPosition:h,getDefinitionAtPosition:D,getDefinitionAndBoundSpan:S,getImplementationAtPosition:T,getTypeDefinitionAtPosition:C,getReferencesAtPosition:F,findReferences:w,getOccurrencesAtPosition:E,getDocumentHighlights:N,getNameOrDottedNameSpan:R,getBreakpointStatementAtPosition:z,getNavigateToItems:I,getRenameInfo:pt,getSmartSelectionRange:mt,findRenameLocations:A,getNavigationBarItems:V,getNavigationTree:U,getOutliningSpans:Q,getTodoComments:dt,getBraceMatchingAtPosition:X,getIndentationAtPosition:Y,getFormattingEditsForRange:Z,getFormattingEditsForDocument:$,getFormattingEditsAfterKeystroke:et,getDocCommentTemplateAtPosition:st,isValidBraceCompletionAtPosition:ct,getJsxClosingTagAtPosition:ut,getSpanOfEnclosingComment:_t,getCodeFixesAtPosition:tt,getCombinedCodeFix:rt,applyCodeActionCommand:at,organizeImports:nt,getEditsForFileRename:it,getEmitOutput:O,getNonBoundSourceFile:L,getProgram:c,getApplicableRefactors:gt,getEditsForRefactor:vt,toLineColumnOffset:Et.toLineColumnOffset,getSourceMapper:function(){return Et}}}function b(e){return e.nameTable||x(e),e.nameTable}function x(t){var r=t.nameTable=e.createUnderscoreEscapedMap();t.forEachChild(function n(t){if(e.isIdentifier(t)&&!e.isTagName(t)&&t.escapedText||e.isStringOrNumericLiteralLike(t)&&D(t)){var i=e.getEscapedTextOfIdentifierOrLiteral(t);r.set(i,void 0===r.get(i)?t.pos:-1)}if(e.forEachChild(t,n),e.hasJSDocNodes(t))for(var a=0,o=t.jsDoc;a<o.length;a++){var s=o[a];e.forEachChild(s,n)}})}function D(t){return e.isDeclarationName(t)||260===t.parent.kind||E(t)||e.isLiteralComputedPropertyDeclarationName(t)}function S(t){var r=C(t);return r&&(e.isObjectLiteralExpression(r.parent)||e.isJsxAttributes(r.parent))?r:void 0}function C(t){switch(t.kind){case 10:case 8:if(150===t.parent.kind)return e.isObjectLiteralElement(t.parent.parent)?t.parent.parent:void 0;case 73:return!e.isObjectLiteralElement(t.parent)||189!==t.parent.parent.kind&&269!==t.parent.parent.kind||t.parent.name!==t?void 0:t.parent}return void 0}function k(t,r){var n=S(t);if(n){var i=r.getContextualType(n.parent),a=i&&T(n,r,i,!1);if(a&&1===a.length)return e.first(a)}return r.getSymbolAtLocation(t)}function T(t,r,n,i){var a=e.getNameFromPropertyName(t.name);if(!a)return e.emptyArray;if(!n.isUnion()){var o=n.getProperty(a);return o?[o]:e.emptyArray}var s=e.mapDefined(n.types,function(n){return e.isObjectLiteralExpression(t.parent)&&r.isTypeInvalidDueToUnionDiscriminant(n,t.parent)?void 0:n.getProperty(a)});if(i&&(0===s.length||s.length===n.types.length)){var o=n.getProperty(a);if(o)return[o]}return 0===s.length?e.mapDefined(n.types,function(e){return e.getProperty(a)}):s}function E(e){return e&&e.parent&&191===e.parent.kind&&e.parent.argumentExpression===e}function N(t){return"/node_modules/monaco-editor/esm/vs/language/typescript/lib"+e.directorySeparator+e.getDefaultLibFileName(t)}e.servicesVersion="0.8";var A=function(){function t(e,t,r){this.pos=t,this.end=r,this.flags=0,this.modifierFlagsCache=0,this.transformFlags=0,this.parent=void 0,this.kind=e}return t.prototype.assertHasRealPosition=function(t){e.Debug.assert(!e.positionIsSynthesized(this.pos)&&!e.positionIsSynthesized(this.end),t||"Node must have a real position for this operation")},t.prototype.getSourceFile=function(){return e.getSourceFileOfNode(this)},t.prototype.getStart=function(t,r){return this.assertHasRealPosition(),e.getTokenPosOfNode(this,t,r)},t.prototype.getFullStart=function(){return this.assertHasRealPosition(),this.pos},t.prototype.getEnd=function(){return this.assertHasRealPosition(),this.end},t.prototype.getWidth=function(e){return this.assertHasRealPosition(),this.getEnd()-this.getStart(e)},t.prototype.getFullWidth=function(){return this.assertHasRealPosition(),this.end-this.pos},t.prototype.getLeadingTriviaWidth=function(e){return this.assertHasRealPosition(),this.getStart(e)-this.pos},t.prototype.getFullText=function(e){return this.assertHasRealPosition(),(e||this.getSourceFile()).text.substring(this.pos,this.end)},t.prototype.getText=function(e){return this.assertHasRealPosition(),e||(e=this.getSourceFile()),e.text.substring(this.getStart(e),this.getEnd())},t.prototype.getChildCount=function(e){return this.getChildren(e).length},t.prototype.getChildAt=function(e,t){return this.getChildren(t)[e]},t.prototype.getChildren=function(e){return this.assertHasRealPosition("Node without a real position cannot be scanned and thus has no token nodes - use forEachChild and collect the result if that's fine"),this._children||(this._children=r(this,e))},t.prototype.getFirstToken=function(t){this.assertHasRealPosition();var r=this.getChildren(t);if(!r.length)return void 0;var n=e.find(r,function(e){return e.kind<289||e.kind>311});return n.kind<149?n:n.getFirstToken(t)},t.prototype.getLastToken=function(t){this.assertHasRealPosition();var r=this.getChildren(t),n=e.lastOrUndefined(r);return n?n.kind<149?n:n.getLastToken(t):void 0},t.prototype.forEachChild=function(t,r){return e.forEachChild(this,t,r)},t}(),F=function(){function t(e,t){this.pos=e,this.end=t,this.flags=0,this.modifierFlagsCache=0,this.transformFlags=0,this.parent=void 0}return t.prototype.getSourceFile=function(){return e.getSourceFileOfNode(this)},t.prototype.getStart=function(t,r){return e.getTokenPosOfNode(this,t,r)},t.prototype.getFullStart=function(){return this.pos},t.prototype.getEnd=function(){return this.end},t.prototype.getWidth=function(e){return this.getEnd()-this.getStart(e)},t.prototype.getFullWidth=function(){return this.end-this.pos},t.prototype.getLeadingTriviaWidth=function(e){return this.getStart(e)-this.pos},t.prototype.getFullText=function(e){return(e||this.getSourceFile()).text.substring(this.pos,this.end)},t.prototype.getText=function(e){return e||(e=this.getSourceFile()),e.text.substring(this.getStart(e),this.getEnd())},t.prototype.getChildCount=function(){return 0},t.prototype.getChildAt=function(){return void 0},t.prototype.getChildren=function(){return 1===this.kind?this.jsDoc||e.emptyArray:e.emptyArray},t.prototype.getFirstToken=function(){return void 0},t.prototype.getLastToken=function(){return void 0},t.prototype.forEachChild=function(){return void 0},t}(),P=function(){function t(e,t){this.flags=e,this.escapedName=t}return t.prototype.getFlags=function(){return this.flags},Object.defineProperty(t.prototype,"name",{get:function(){return e.symbolName(this)},enumerable:!0,configurable:!0}),t.prototype.getEscapedName=function(){return this.escapedName},t.prototype.getName=function(){return this.name},t.prototype.getDeclarations=function(){return this.declarations},t.prototype.getDocumentationComment=function(t){return this.documentationComment||(this.documentationComment=e.emptyArray,this.documentationComment=c(this.declarations,t)),this.documentationComment},t.prototype.getJsDocTags=function(){return void 0===this.tags&&(this.tags=e.JsDoc.getJsDocTagsFromDeclarations(this.declarations)),this.tags},t}(),w=function(e){function t(t,r,n){var i=e.call(this,r,n)||this;return i.kind=t,i}return s(t,e),t}(F),I=function(t){function r(e,r,n){return t.call(this,r,n)||this}return s(r,t),Object.defineProperty(r.prototype,"text",{get:function(){return e.idText(this)},enumerable:!0,configurable:!0}),r}(F);I.prototype.kind=73;var O=function(){function t(e,t){this.checker=e,this.flags=t}return t.prototype.getFlags=function(){return this.flags},t.prototype.getSymbol=function(){return this.symbol},t.prototype.getProperties=function(){return this.checker.getPropertiesOfType(this)},t.prototype.getProperty=function(e){return this.checker.getPropertyOfType(this,e)},t.prototype.getApparentProperties=function(){return this.checker.getAugmentedPropertiesOfType(this)},t.prototype.getCallSignatures=function(){return this.checker.getSignaturesOfType(this,0)},t.prototype.getConstructSignatures=function(){return this.checker.getSignaturesOfType(this,1)},t.prototype.getStringIndexType=function(){return this.checker.getIndexTypeOfType(this,0)},t.prototype.getNumberIndexType=function(){return this.checker.getIndexTypeOfType(this,1)},t.prototype.getBaseTypes=function(){return this.isClassOrInterface()?this.checker.getBaseTypes(this):void 0},t.prototype.getNonNullableType=function(){return this.checker.getNonNullableType(this)},t.prototype.getConstraint=function(){return this.checker.getBaseConstraintOfType(this)},t.prototype.getDefault=function(){return this.checker.getDefaultFromTypeParameter(this)},t.prototype.isUnion=function(){return!!(1048576&this.flags)},t.prototype.isIntersection=function(){return!!(2097152&this.flags)},t.prototype.isUnionOrIntersection=function(){return!!(3145728&this.flags)},t.prototype.isLiteral=function(){return!!(384&this.flags)},t.prototype.isStringLiteral=function(){return!!(128&this.flags)},t.prototype.isNumberLiteral=function(){return!!(256&this.flags)},t.prototype.isTypeParameter=function(){return!!(262144&this.flags)},t.prototype.isClassOrInterface=function(){return!!(3&e.getObjectFlags(this))},t.prototype.isClass=function(){return!!(1&e.getObjectFlags(this))},t}(),M=function(){function t(e){this.checker=e}return t.prototype.getDeclaration=function(){return this.declaration},t.prototype.getTypeParameters=function(){return this.typeParameters},t.prototype.getParameters=function(){return this.parameters},t.prototype.getReturnType=function(){return this.checker.getReturnTypeOfSignature(this)},t.prototype.getDocumentationComment=function(){return this.documentationComment||(this.documentationComment=c(e.singleElementArray(this.declaration),this.checker))},t.prototype.getJsDocTags=function(){return void 0===this.jsDocTags&&(this.jsDocTags=this.declaration?e.JsDoc.getJsDocTagsFromDeclarations([this.declaration]):[]),this.jsDocTags},t}(),L=function(t){function r(e,r,n){return t.call(this,e,r,n)||this}return s(r,t),r.prototype.update=function(t,r){return e.updateSourceFile(this,t,r)},r.prototype.getLineAndCharacterOfPosition=function(t){return e.getLineAndCharacterOfPosition(this,t)},r.prototype.getLineStarts=function(){return e.getLineStarts(this)},r.prototype.getPositionOfLineAndCharacter=function(t,r,n){return e.computePositionOfLineAndCharacter(e.getLineStarts(this),t,r,this.text,n)},r.prototype.getLineEndOfPosition=function(e){var t,r=this.getLineAndCharacterOfPosition(e).line,n=this.getLineStarts();r+1>=n.length&&(t=this.getEnd()),t||(t=n[r+1]-1);var i=this.getFullText();return"\n"===i[t]&&"\r"===i[t-1]?t-1:t},r.prototype.getNamedDeclarations=function(){return this.namedDeclarations||(this.namedDeclarations=this.computeNamedDeclarations()),this.namedDeclarations},r.prototype.computeNamedDeclarations=function(){function t(e){var t=n(e);t&&a.add(t,e)}function r(e){var t=a.get(e);return t||a.set(e,t=[]),t}function n(t){var r=e.getNonAssignedNameOfDeclaration(t);return r&&(e.isComputedPropertyName(r)&&e.isPropertyAccessExpression(r.expression)?r.expression.name.text:e.isPropertyName(r)?e.getNameFromPropertyName(r):void 0)}function i(a){switch(a.kind){case 240:case 197:case 157:case 156:var o=a,s=n(o);if(s){var c=r(s),u=e.lastOrUndefined(c);u&&o.parent===u.parent&&o.symbol===u.symbol?o.body&&!u.body&&(c[c.length-1]=o):c.push(o)}e.forEachChild(a,i);break;case 241:case 210:case 242:case 243:case 244:case 245:case 249:case 258:case 254:case 251:case 252:case 159:case 160:case 169:t(a),e.forEachChild(a,i);break;case 152:if(!e.hasModifier(a,92))break;case 238:case 187:var l=a;if(e.isBindingPattern(l.name)){e.forEachChild(l.name,i);break}l.initializer&&i(l.initializer);case 279:case 155:case 154:t(a);break;case 256:a.exportClause&&e.forEach(a.exportClause.elements,i);break;case 250:var _=a.importClause;_&&(_.name&&t(_.name),_.namedBindings&&(252===_.namedBindings.kind?t(_.namedBindings):e.forEach(_.namedBindings.elements,i)));break;case 205:0!==e.getAssignmentDeclarationKind(a)&&t(a);default:e.forEachChild(a,i)}}var a=e.createMultiMap();return this.forEachChild(i),a},r}(A),R=function(){function t(e,t,r){this.fileName=e,this.text=t,this.skipTrivia=r}return t.prototype.getLineAndCharacterOfPosition=function(t){return e.getLineAndCharacterOfPosition(this,t)},t}();e.toEditorSettings=_,e.displayPartsToString=p,e.getDefaultCompilerOptions=f,e.getSupportedCodeFixes=m;var B=function(){function t(t,r){this.host=t,this.currentDirectory=t.getCurrentDirectory(),this.fileNameToEntry=e.createMap();for(var n=t.getScriptFileNames(),i=0,a=n;i<a.length;i++){var o=a[i];this.createEntry(o,e.toPath(o,this.currentDirectory,r))}this._compilationSettings=t.getCompilationSettings()||f()}return t.prototype.compilationSettings=function(){return this._compilationSettings},t.prototype.getProjectReferences=function(){return this.host.getProjectReferences&&this.host.getProjectReferences()},t.prototype.createEntry=function(t,r){var n,i=this.host.getScriptSnapshot(t);return n=i?{hostFileName:t,version:this.host.getScriptVersion(t),scriptSnapshot:i,scriptKind:e.getScriptKind(t,this.host)}:t,this.fileNameToEntry.set(r,n),n},t.prototype.getEntryByPath=function(e){return this.fileNameToEntry.get(e)},t.prototype.getHostFileInformation=function(t){var r=this.fileNameToEntry.get(t);return e.isString(r)?void 0:r},t.prototype.getOrCreateEntryByPath=function(t,r){var n=this.getEntryByPath(r)||this.createEntry(t,r);return e.isString(n)?void 0:n},t.prototype.getRootFileNames=function(){var t=[];return this.fileNameToEntry.forEach(function(r){e.isString(r)?t.push(r):6!==r.scriptKind&&t.push(r.hostFileName)}),t},t.prototype.getVersion=function(e){var t=this.getHostFileInformation(e);return t&&t.version},t.prototype.getScriptSnapshot=function(e){var t=this.getHostFileInformation(e);return t&&t.scriptSnapshot},t}(),j=function(){function t(e){this.host=e}return t.prototype.getCurrentSourceFile=function(t){var r=this.host.getScriptSnapshot(t);if(!r)throw new Error("Could not find file: '"+t+"'.");var n,i=e.getScriptKind(t,this.host),a=this.host.getScriptVersion(t);if(this.currentFileName!==t)n=v(t,r,8,a,!0,i);else if(this.currentFileVersion!==a){var o=r.getChangeRange(this.currentFileScriptSnapshot);n=y(this.currentSourceFile,r,a,o)}return n&&(this.currentFileVersion=a,this.currentFileName=t,this.currentFileScriptSnapshot=r,this.currentSourceFile=n),this.currentSourceFile},t}();e.createLanguageServiceSourceFile=v,e.disableIncrementalParsing=!1,e.updateLanguageServiceSourceFile=y;var J=function(){function t(e){this.cancellationToken=e}return t.prototype.isCancellationRequested=function(){return!!this.cancellationToken&&this.cancellationToken.isCancellationRequested()},t.prototype.throwIfCancellationRequested=function(){if(this.isCancellationRequested())throw new e.OperationCanceledException},t}(),z=function(){function t(e,t){void 0===t&&(t=20),this.hostCancellationToken=e,this.throttleWaitMilliseconds=t,this.lastCancellationCheckTime=0}return t.prototype.isCancellationRequested=function(){var t=e.timestamp(),r=Math.abs(t-this.lastCancellationCheckTime);return r>=this.throttleWaitMilliseconds?(this.lastCancellationCheckTime=t,this.hostCancellationToken.isCancellationRequested()):!1},t.prototype.throwIfCancellationRequested=function(){if(this.isCancellationRequested())throw new e.OperationCanceledException},t}();e.ThrottledCancellationToken=z,e.createLanguageService=h,e.getNameTable=b,e.getContainingObjectLiteralElement=S,e.getPropertySymbolsFromContextualType=T,e.getDefaultLibFilePath=N,e.objectAllocator=l()}(n||(n={}));var n;!function(e){var t;!function(t){function r(t,r){function n(r,n){var i=r.decorators?e.skipTrivia(t.text,r.decorators.end):r.getStart(t);return e.createTextSpanFromBounds(i,(n||r).getEnd())}function i(r,i){return n(r,e.findNextToken(i,i.parent,t))}function a(e,r){return u(e&&_===t.getLineAndCharacterOfPosition(e.getStart(t)).line?e:r)}function o(r){return e.createTextSpanFromBounds(e.skipTrivia(t.text,r.pos),r.end)}function s(r){return u(e.findPrecedingToken(r.pos,t))}function c(r){return u(e.findNextToken(r,r.parent,t))}function u(r){function l(r){return e.isVariableDeclarationList(r.parent)&&r.parent.declarations[0]===r?n(e.findPrecedingToken(r.pos,t,r.parent),r):n(r)}function _(r){if(227===r.parent.parent.kind)return u(r.parent.parent);var n=r.parent;return e.isBindingPattern(r.name)?b(r.name):r.initializer||e.hasModifier(r,1)||228===n.parent.kind?l(r):e.isVariableDeclarationList(r.parent)&&r.parent.declarations[0]!==r?u(e.findPrecedingToken(r.pos,t,r.parent)):void 0}function d(t){return!!t.initializer||void 0!==t.dotDotDotToken||e.hasModifier(t,12)}function p(t){if(e.isBindingPattern(t.name))return b(t.name);if(d(t))return n(t);var r=t.parent,i=r.parameters.indexOf(t);return e.Debug.assert(-1!==i),0!==i?p(r.parameters[i-1]):u(r.body)}function f(t){return e.hasModifier(t,1)||241===t.parent.kind&&158!==t.kind}function m(e){return e.body?f(e)?n(e):u(e.body):void 0}function g(e){var t=e.statements.length?e.statements[0]:e.getLastToken();return f(e.parent)?a(e.parent,t):u(t)}function v(r){switch(r.parent.kind){case 245:if(1!==e.getModuleInstanceState(r.parent))return void 0;case 225:case 223:case 227:return a(r.parent,r.statements[0]);case 226:case 228:return a(e.findPrecedingToken(r.pos,t,r.parent),r.statements[0])}return u(r.statements[0])}function y(e){if(239!==e.initializer.kind)return u(e.initializer);var t=e.initializer;return t.declarations.length>0?u(t.declarations[0]):void 0}function h(e){return e.initializer?y(e):e.condition?n(e.condition):e.incrementor?n(e.incrementor):void 0}function b(t){var r=e.forEach(t.elements,function(e){return 211!==e.kind?e:void 0});return r?u(r):187===t.parent.kind?n(t.parent):l(t.parent)}function x(t){e.Debug.assert(186!==t.kind&&185!==t.kind);var r=188===t.kind?t.elements:t.properties,i=e.forEach(r,function(e){return 211!==e.kind?e:void 0});return i?u(i):n(205===t.parent.kind?t.parent:t)}function D(r){switch(r.parent.kind){case 244:var n=r.parent;return a(e.findPrecedingToken(r.pos,t,r.parent),n.members.length?n.members[0]:n.getLastToken(t));case 241:var i=r.parent;return a(e.findPrecedingToken(r.pos,t,r.parent),i.members.length?i.members[0]:i.getLastToken(t));case 247:return a(r.parent.parent,r.parent.clauses[0])}return u(r.parent)}function S(t){switch(t.parent.kind){case 246:if(1!==e.getModuleInstanceState(t.parent.parent))return void 0;case 244:case 241:return n(t);case 219:if(e.isFunctionBlock(t.parent))return n(t);case 275:return u(e.lastOrUndefined(t.parent.statements));case 247:var r=t.parent,i=e.lastOrUndefined(r.clauses);return i?u(e.lastOrUndefined(i.statements)):void 0;case 185:var a=t.parent;return u(e.lastOrUndefined(a.elements)||a);default:if(e.isArrayLiteralOrObjectLiteralDestructuringPattern(t.parent)){var o=t.parent;return n(e.lastOrUndefined(o.properties)||o)}return u(t.parent)}}function C(t){switch(t.parent.kind){case 186:var r=t.parent;return n(e.lastOrUndefined(r.elements)||r);default:if(e.isArrayLiteralOrObjectLiteralDestructuringPattern(t.parent)){var i=t.parent;return n(e.lastOrUndefined(i.elements)||i)}return u(t.parent)}}function k(e){return 224===e.parent.kind||192===e.parent.kind||193===e.parent.kind?s(e):196===e.parent.kind?c(e):u(e.parent)}function T(e){switch(e.parent.kind){case 197:case 240:case 198:case 157:case 156:case 159:case 160:case 158:case 225:case 224:case 226:case 228:case 192:case 193:case 196:return s(e);default:return u(e.parent)}}function E(t){return e.isFunctionLike(t.parent)||276===t.parent.kind||152===t.parent.kind?s(t):u(t.parent)}function N(e){return 195===e.parent.kind?c(e):u(e.parent)}function A(e){return 224===e.parent.kind?i(e,e.parent.expression):u(e.parent)}function F(e){return 228===e.parent.kind?c(e):u(e.parent)}if(r){var P=r.parent;switch(r.kind){case 220:return _(r.declarationList.declarations[0]);case 238:case 155:case 154:return _(r);case 152:return p(r);case 240:case 157:case 156:case 159:case 160:case 158:case 197:case 198:return m(r);case 219:if(e.isFunctionBlock(r))return g(r);case 246:return v(r);case 275:return v(r.block);case 222:return n(r.expression);case 231:return n(r.getChildAt(0),r.expression);case 225:return i(r,r.expression);case 224:return u(r.statement);case 237:return n(r.getChildAt(0));case 223:return i(r,r.expression);case 234:return u(r.statement);case 230:case 229:return n(r.getChildAt(0),r.label);case 226:return h(r);case 227:return i(r,r.expression);case 228:return y(r);case 233:return i(r,r.expression);case 272:case 273:return u(r.statements[0]);case 236:return v(r.tryBlock);case 235:return n(r,r.expression);case 255:return n(r,r.expression);case 249:return n(r,r.moduleReference);case 250:return n(r,r.moduleSpecifier);case 256:return n(r,r.moduleSpecifier);case 245:if(1!==e.getModuleInstanceState(r))return void 0;case 241:case 244:case 279:case 187:return n(r);case 232:return u(r.statement);case 153:return o(P.decorators);case 185:case 186:return b(r);case 242:case 243:return void 0;case 26:case 1:return a(e.findPrecedingToken(r.pos,t));case 27:return s(r);case 18:return D(r);case 19:return S(r);case 23:return C(r);case 20:return k(r);case 21:return T(r);case 57:return E(r);case 30:case 28:return N(r);case 108:return A(r);case 84:case 76:case 89:return c(r);case 148:return F(r);default:if(e.isArrayLiteralOrObjectLiteralDestructuringPattern(r))return x(r);if((73===r.kind||209===r.kind||276===r.kind||277===r.kind)&&e.isArrayLiteralOrObjectLiteralDestructuringPattern(P))return n(r);if(205===r.kind){var w=r,I=w.left,O=w.operatorToken;if(e.isArrayLiteralOrObjectLiteralDestructuringPattern(I))return x(I);if(60===O.kind&&e.isArrayLiteralOrObjectLiteralDestructuringPattern(r.parent))return n(r);if(27===O.kind)return u(I)}if(e.isExpressionNode(r))switch(P.kind){case 224:return s(r);case 153:return u(r.parent);case 226:case 228:return n(r);case 205:if(27===r.parent.operatorToken.kind)return n(r);break;case 198:if(r.parent.body===r)return n(r)}switch(r.parent.kind){case 276:if(r.parent.name===r&&!e.isArrayLiteralOrObjectLiteralDestructuringPattern(r.parent.parent))return u(r.parent.initializer);break;case 195:if(r.parent.type===r)return c(r.parent.type);break;case 238:case 152:var M=r.parent,L=M.initializer,R=M.type;if(L===r||R===r||e.isAssignmentOperator(r.kind))return s(r);break;case 205:var I=r.parent.left;if(e.isArrayLiteralOrObjectLiteralDestructuringPattern(I)&&r!==I)return s(r);break;default:if(e.isFunctionLike(r.parent)&&r.parent.type===r)return s(r)}return u(r.parent)}}}if(t.isDeclarationFile)return void 0;var l=e.getTokenAtPosition(t,r),_=t.getLineAndCharacterOfPosition(r).line;if(t.getLineAndCharacterOfPosition(l.getStart(t)).line>_){var d=e.findPrecedingToken(l.pos,t);if(!d||t.getLineAndCharacterOfPosition(d.getEnd()).line!==_)return void 0;l=d}return 4194304&l.flags?void 0:u(l)}t.spanInSourceFileAtLocation=r}(t=e.BreakpointResolver||(e.BreakpointResolver={}))}(n||(n={}));var n;!function(e){function t(t,r,n){var i=[];n=e.fixupCompilerOptions(n,i);var a=e.isArray(t)?t:[t],o=e.transformNodes(void 0,void 0,n,a,r,!0);return o.diagnostics=e.concatenate(o.diagnostics,i),o}e.transform=t}(n||(n={}));var n,c=function(){return this}();!function(e){function t(e,t){e&&e.log("*INTERNAL ERROR* - Exception in typescript services: "+t.message)}function n(t,r,n,i){var a;i&&(t.log(r),a=e.timestamp());var o=n();if(i){var s=e.timestamp();if(t.log(r+" completed in "+(s-a)+" msec"),e.isString(o)){var c=o;c.length>128&&(c=c.substring(0,128)+"..."),t.log("  result.length="+c.length+", result='"+JSON.stringify(c)+"'")}}return o}function i(e,t,r,n){return a(e,t,!0,r,n)}function a(r,i,a,o,s){try{var c=n(r,i,o,s);return a?JSON.stringify({result:c}):c}catch(u){return u instanceof e.OperationCanceledException?JSON.stringify({canceled:!0}):(t(r,u),u.description=i,JSON.stringify({error:u}))}}function o(e,t){return e.map(function(e){return u(e,t)})}function u(t,r){return{message:e.flattenDiagnosticMessageText(t.messageText,r),start:t.start,length:t.length,category:e.diagnosticCategoryName(t),code:t.code,reportsUnnecessary:t.reportsUnnecessary}}function l(e){return{spans:e.spans.join(","),endOfLineState:e.endOfLineState}}var _=function(){function t(e){this.scriptSnapshotShim=e}return t.prototype.getText=function(e,t){return this.scriptSnapshotShim.getText(e,t)},t.prototype.getLength=function(){return this.scriptSnapshotShim.getLength()},t.prototype.getChangeRange=function(t){var r=t,n=this.scriptSnapshotShim.getChangeRange(r.scriptSnapshotShim);if(null===n)return null;var i=JSON.parse(n);return e.createTextChangeRange(e.createTextSpan(i.span.start,i.span.length),i.newLength)},t.prototype.dispose=function(){"dispose"in this.scriptSnapshotShim&&this.scriptSnapshotShim.dispose()
},t}(),d=function(){function t(t){var r=this;this.shimHost=t,this.loggingEnabled=!1,this.tracingEnabled=!1,"getModuleResolutionsForFile"in this.shimHost&&(this.resolveModuleNames=function(t,n){var i=JSON.parse(r.shimHost.getModuleResolutionsForFile(n));return e.map(t,function(t){var r=e.getProperty(i,t);return r?{resolvedFileName:r,extension:e.extensionFromPath(r),isExternalLibraryImport:!1}:void 0})}),"directoryExists"in this.shimHost&&(this.directoryExists=function(e){return r.shimHost.directoryExists(e)}),"getTypeReferenceDirectiveResolutionsForFile"in this.shimHost&&(this.resolveTypeReferenceDirectives=function(t,n){var i=JSON.parse(r.shimHost.getTypeReferenceDirectiveResolutionsForFile(n));return e.map(t,function(t){return e.getProperty(i,t)})})}return t.prototype.log=function(e){this.loggingEnabled&&this.shimHost.log(e)},t.prototype.trace=function(e){this.tracingEnabled&&this.shimHost.trace(e)},t.prototype.error=function(e){this.shimHost.error(e)},t.prototype.getProjectVersion=function(){return this.shimHost.getProjectVersion?this.shimHost.getProjectVersion():void 0},t.prototype.getTypeRootsVersion=function(){return this.shimHost.getTypeRootsVersion?this.shimHost.getTypeRootsVersion():0},t.prototype.useCaseSensitiveFileNames=function(){return this.shimHost.useCaseSensitiveFileNames?this.shimHost.useCaseSensitiveFileNames():!1},t.prototype.getCompilationSettings=function(){var e=this.shimHost.getCompilationSettings();if(null===e||""===e)throw Error("LanguageServiceShimHostAdapter.getCompilationSettings: empty compilationSettings");var t=JSON.parse(e);return t.allowNonTsExtensions=!0,t},t.prototype.getScriptFileNames=function(){var e=this.shimHost.getScriptFileNames();return JSON.parse(e)},t.prototype.getScriptSnapshot=function(e){var t=this.shimHost.getScriptSnapshot(e);return t&&new _(t)},t.prototype.getScriptKind=function(e){return"getScriptKind"in this.shimHost?this.shimHost.getScriptKind(e):0},t.prototype.getScriptVersion=function(e){return this.shimHost.getScriptVersion(e)},t.prototype.getLocalizedDiagnosticMessages=function(){var e=this.shimHost.getLocalizedDiagnosticMessages();if(null===e||""===e)return null;try{return JSON.parse(e)}catch(t){return this.log(t.description||"diagnosticMessages.generated.json has invalid JSON format"),null}},t.prototype.getCancellationToken=function(){var t=this.shimHost.getCancellationToken();return new e.ThrottledCancellationToken(t)},t.prototype.getCurrentDirectory=function(){return this.shimHost.getCurrentDirectory()},t.prototype.getDirectories=function(e){return JSON.parse(this.shimHost.getDirectories(e))},t.prototype.getDefaultLibFileName=function(e){return this.shimHost.getDefaultLibFileName(JSON.stringify(e))},t.prototype.readDirectory=function(t,r,n,i,a){var o=e.getFileMatcherPatterns(t,n,i,this.shimHost.useCaseSensitiveFileNames(),this.shimHost.getCurrentDirectory());return JSON.parse(this.shimHost.readDirectory(t,JSON.stringify(r),JSON.stringify(o.basePaths),o.excludePattern,o.includeFilePattern,o.includeDirectoryPattern,a))},t.prototype.readFile=function(e,t){return this.shimHost.readFile(e,t)},t.prototype.fileExists=function(e){return this.shimHost.fileExists(e)},t}();e.LanguageServiceShimHostAdapter=d;var p=function(){function t(e){var t=this;this.shimHost=e,this.useCaseSensitiveFileNames=this.shimHost.useCaseSensitiveFileNames?this.shimHost.useCaseSensitiveFileNames():!1,this.directoryExists="directoryExists"in this.shimHost?function(e){return t.shimHost.directoryExists(e)}:void 0,this.realpath="realpath"in this.shimHost?function(e){return t.shimHost.realpath(e)}:void 0}return t.prototype.readDirectory=function(t,r,n,i,a){var o=e.getFileMatcherPatterns(t,n,i,this.shimHost.useCaseSensitiveFileNames(),this.shimHost.getCurrentDirectory());return JSON.parse(this.shimHost.readDirectory(t,JSON.stringify(r),JSON.stringify(o.basePaths),o.excludePattern,o.includeFilePattern,o.includeDirectoryPattern,a))},t.prototype.fileExists=function(e){return this.shimHost.fileExists(e)},t.prototype.readFile=function(e){return this.shimHost.readFile(e)},t.prototype.getDirectories=function(e){return JSON.parse(this.shimHost.getDirectories(e))},t}();e.CoreServicesShimHostAdapter=p;var f=function(){function e(e){this.factory=e,e.registerShim(this)}return e.prototype.dispose=function(){this.factory.unregisterShim(this)},e}();e.realizeDiagnostics=o;var m=function(t){function r(e,r,n){var i=t.call(this,e)||this;return i.host=r,i.languageService=n,i.logPerformance=!1,i.logger=i.host,i}return s(r,t),r.prototype.forwardJSONCall=function(e,t){return i(this.logger,e,t,this.logPerformance)},r.prototype.dispose=function(e){this.logger.log("dispose()"),this.languageService.dispose(),this.languageService=null,c&&c.CollectGarbage&&(c.CollectGarbage(),this.logger.log("CollectGarbage()")),this.logger=null,t.prototype.dispose.call(this,e)},r.prototype.refresh=function(e){this.forwardJSONCall("refresh("+e+")",function(){return null})},r.prototype.cleanupSemanticCache=function(){var e=this;this.forwardJSONCall("cleanupSemanticCache()",function(){return e.languageService.cleanupSemanticCache(),null})},r.prototype.realizeDiagnostics=function(t){var r=e.getNewLineOrDefaultFromHost(this.host);return o(t,r)},r.prototype.getSyntacticClassifications=function(t,r,n){var i=this;return this.forwardJSONCall("getSyntacticClassifications('"+t+"', "+r+", "+n+")",function(){return i.languageService.getSyntacticClassifications(t,e.createTextSpan(r,n))})},r.prototype.getSemanticClassifications=function(t,r,n){var i=this;return this.forwardJSONCall("getSemanticClassifications('"+t+"', "+r+", "+n+")",function(){return i.languageService.getSemanticClassifications(t,e.createTextSpan(r,n))})},r.prototype.getEncodedSyntacticClassifications=function(t,r,n){var i=this;return this.forwardJSONCall("getEncodedSyntacticClassifications('"+t+"', "+r+", "+n+")",function(){return l(i.languageService.getEncodedSyntacticClassifications(t,e.createTextSpan(r,n)))})},r.prototype.getEncodedSemanticClassifications=function(t,r,n){var i=this;return this.forwardJSONCall("getEncodedSemanticClassifications('"+t+"', "+r+", "+n+")",function(){return l(i.languageService.getEncodedSemanticClassifications(t,e.createTextSpan(r,n)))})},r.prototype.getSyntacticDiagnostics=function(e){var t=this;return this.forwardJSONCall("getSyntacticDiagnostics('"+e+"')",function(){var r=t.languageService.getSyntacticDiagnostics(e);return t.realizeDiagnostics(r)})},r.prototype.getSemanticDiagnostics=function(e){var t=this;return this.forwardJSONCall("getSemanticDiagnostics('"+e+"')",function(){var r=t.languageService.getSemanticDiagnostics(e);return t.realizeDiagnostics(r)})},r.prototype.getSuggestionDiagnostics=function(e){var t=this;return this.forwardJSONCall("getSuggestionDiagnostics('"+e+"')",function(){return t.realizeDiagnostics(t.languageService.getSuggestionDiagnostics(e))})},r.prototype.getCompilerOptionsDiagnostics=function(){var e=this;return this.forwardJSONCall("getCompilerOptionsDiagnostics()",function(){var t=e.languageService.getCompilerOptionsDiagnostics();return e.realizeDiagnostics(t)})},r.prototype.getQuickInfoAtPosition=function(e,t){var r=this;return this.forwardJSONCall("getQuickInfoAtPosition('"+e+"', "+t+")",function(){return r.languageService.getQuickInfoAtPosition(e,t)})},r.prototype.getNameOrDottedNameSpan=function(e,t,r){var n=this;return this.forwardJSONCall("getNameOrDottedNameSpan('"+e+"', "+t+", "+r+")",function(){return n.languageService.getNameOrDottedNameSpan(e,t,r)})},r.prototype.getBreakpointStatementAtPosition=function(e,t){var r=this;return this.forwardJSONCall("getBreakpointStatementAtPosition('"+e+"', "+t+")",function(){return r.languageService.getBreakpointStatementAtPosition(e,t)})},r.prototype.getSignatureHelpItems=function(e,t,r){var n=this;return this.forwardJSONCall("getSignatureHelpItems('"+e+"', "+t+")",function(){return n.languageService.getSignatureHelpItems(e,t,r)})},r.prototype.getDefinitionAtPosition=function(e,t){var r=this;return this.forwardJSONCall("getDefinitionAtPosition('"+e+"', "+t+")",function(){return r.languageService.getDefinitionAtPosition(e,t)})},r.prototype.getDefinitionAndBoundSpan=function(e,t){var r=this;return this.forwardJSONCall("getDefinitionAndBoundSpan('"+e+"', "+t+")",function(){return r.languageService.getDefinitionAndBoundSpan(e,t)})},r.prototype.getTypeDefinitionAtPosition=function(e,t){var r=this;return this.forwardJSONCall("getTypeDefinitionAtPosition('"+e+"', "+t+")",function(){return r.languageService.getTypeDefinitionAtPosition(e,t)})},r.prototype.getImplementationAtPosition=function(e,t){var r=this;return this.forwardJSONCall("getImplementationAtPosition('"+e+"', "+t+")",function(){return r.languageService.getImplementationAtPosition(e,t)})},r.prototype.getRenameInfo=function(e,t,r){var n=this;return this.forwardJSONCall("getRenameInfo('"+e+"', "+t+")",function(){return n.languageService.getRenameInfo(e,t,r)})},r.prototype.getSmartSelectionRange=function(e,t){var r=this;return this.forwardJSONCall("getSmartSelectionRange('"+e+"', "+t+")",function(){return r.languageService.getSmartSelectionRange(e,t)})},r.prototype.findRenameLocations=function(e,t,r,n,i){var a=this;return this.forwardJSONCall("findRenameLocations('"+e+"', "+t+", "+r+", "+n+", "+i+")",function(){return a.languageService.findRenameLocations(e,t,r,n,i)})},r.prototype.getBraceMatchingAtPosition=function(e,t){var r=this;return this.forwardJSONCall("getBraceMatchingAtPosition('"+e+"', "+t+")",function(){return r.languageService.getBraceMatchingAtPosition(e,t)})},r.prototype.isValidBraceCompletionAtPosition=function(e,t,r){var n=this;return this.forwardJSONCall("isValidBraceCompletionAtPosition('"+e+"', "+t+", "+r+")",function(){return n.languageService.isValidBraceCompletionAtPosition(e,t,r)})},r.prototype.getSpanOfEnclosingComment=function(e,t,r){var n=this;return this.forwardJSONCall("getSpanOfEnclosingComment('"+e+"', "+t+")",function(){return n.languageService.getSpanOfEnclosingComment(e,t,r)})},r.prototype.getIndentationAtPosition=function(e,t,r){var n=this;return this.forwardJSONCall("getIndentationAtPosition('"+e+"', "+t+")",function(){var i=JSON.parse(r);return n.languageService.getIndentationAtPosition(e,t,i)})},r.prototype.getReferencesAtPosition=function(e,t){var r=this;return this.forwardJSONCall("getReferencesAtPosition('"+e+"', "+t+")",function(){return r.languageService.getReferencesAtPosition(e,t)})},r.prototype.findReferences=function(e,t){var r=this;return this.forwardJSONCall("findReferences('"+e+"', "+t+")",function(){return r.languageService.findReferences(e,t)})},r.prototype.getOccurrencesAtPosition=function(e,t){var r=this;return this.forwardJSONCall("getOccurrencesAtPosition('"+e+"', "+t+")",function(){return r.languageService.getOccurrencesAtPosition(e,t)})},r.prototype.getDocumentHighlights=function(t,r,n){var i=this;return this.forwardJSONCall("getDocumentHighlights('"+t+"', "+r+")",function(){var a=i.languageService.getDocumentHighlights(t,r,JSON.parse(n)),o=e.normalizeSlashes(t).toLowerCase();return e.filter(a,function(t){return e.normalizeSlashes(t.fileName).toLowerCase()===o})})},r.prototype.getCompletionsAtPosition=function(e,t,r){var n=this;return this.forwardJSONCall("getCompletionsAtPosition('"+e+"', "+t+", "+r+")",function(){return n.languageService.getCompletionsAtPosition(e,t,r)})},r.prototype.getCompletionEntryDetails=function(e,t,r,n,i,a){var o=this;return this.forwardJSONCall("getCompletionEntryDetails('"+e+"', "+t+", '"+r+"')",function(){var s=void 0===n?void 0:JSON.parse(n);return o.languageService.getCompletionEntryDetails(e,t,r,s,i,a)})},r.prototype.getFormattingEditsForRange=function(e,t,r,n){var i=this;return this.forwardJSONCall("getFormattingEditsForRange('"+e+"', "+t+", "+r+")",function(){var a=JSON.parse(n);return i.languageService.getFormattingEditsForRange(e,t,r,a)})},r.prototype.getFormattingEditsForDocument=function(e,t){var r=this;return this.forwardJSONCall("getFormattingEditsForDocument('"+e+"')",function(){var n=JSON.parse(t);return r.languageService.getFormattingEditsForDocument(e,n)})},r.prototype.getFormattingEditsAfterKeystroke=function(e,t,r,n){var i=this;return this.forwardJSONCall("getFormattingEditsAfterKeystroke('"+e+"', "+t+", '"+r+"')",function(){var a=JSON.parse(n);return i.languageService.getFormattingEditsAfterKeystroke(e,t,r,a)})},r.prototype.getDocCommentTemplateAtPosition=function(e,t){var r=this;return this.forwardJSONCall("getDocCommentTemplateAtPosition('"+e+"', "+t+")",function(){return r.languageService.getDocCommentTemplateAtPosition(e,t)})},r.prototype.getNavigateToItems=function(e,t,r){var n=this;return this.forwardJSONCall("getNavigateToItems('"+e+"', "+t+", "+r+")",function(){return n.languageService.getNavigateToItems(e,t,r)})},r.prototype.getNavigationBarItems=function(e){var t=this;return this.forwardJSONCall("getNavigationBarItems('"+e+"')",function(){return t.languageService.getNavigationBarItems(e)})},r.prototype.getNavigationTree=function(e){var t=this;return this.forwardJSONCall("getNavigationTree('"+e+"')",function(){return t.languageService.getNavigationTree(e)})},r.prototype.getOutliningSpans=function(e){var t=this;return this.forwardJSONCall("getOutliningSpans('"+e+"')",function(){return t.languageService.getOutliningSpans(e)})},r.prototype.getTodoComments=function(e,t){var r=this;return this.forwardJSONCall("getTodoComments('"+e+"')",function(){return r.languageService.getTodoComments(e,JSON.parse(t))})},r.prototype.getEmitOutput=function(e){var t=this;return this.forwardJSONCall("getEmitOutput('"+e+"')",function(){return t.languageService.getEmitOutput(e)})},r.prototype.getEmitOutputObject=function(e){var t=this;return a(this.logger,"getEmitOutput('"+e+"')",!1,function(){return t.languageService.getEmitOutput(e)},this.logPerformance)},r}(f),g=function(t){function r(r,n){var i=t.call(this,r)||this;return i.logger=n,i.logPerformance=!1,i.classifier=e.createClassifier(),i}return s(r,t),r.prototype.getEncodedLexicalClassifications=function(e,t,r){var n=this;return void 0===r&&(r=!1),i(this.logger,"getEncodedLexicalClassifications",function(){return l(n.classifier.getEncodedLexicalClassifications(e,t,r))},this.logPerformance)},r.prototype.getClassificationsForLine=function(e,t,r){void 0===r&&(r=!1);for(var n=this.classifier.getClassificationsForLine(e,t,r),i="",a=0,o=n.entries;a<o.length;a++){var s=o[a];i+=s.length+"\n",i+=s.classification+"\n"}return i+=n.finalLexState},r}(f),v=function(t){function r(e,r,n){var i=t.call(this,e)||this;return i.logger=r,i.host=n,i.logPerformance=!1,i}return s(r,t),r.prototype.forwardJSONCall=function(e,t){return i(this.logger,e,t,this.logPerformance)},r.prototype.resolveModuleName=function(t,r,n){var i=this;return this.forwardJSONCall("resolveModuleName('"+t+"')",function(){var a=JSON.parse(n),o=e.resolveModuleName(r,e.normalizeSlashes(t),a,i.host),s=o.resolvedModule?o.resolvedModule.resolvedFileName:void 0;return o.resolvedModule&&".ts"!==o.resolvedModule.extension&&".tsx"!==o.resolvedModule.extension&&".d.ts"!==o.resolvedModule.extension&&(s=void 0),{resolvedFileName:s,failedLookupLocations:o.failedLookupLocations}})},r.prototype.resolveTypeReferenceDirective=function(t,r,n){var i=this;return this.forwardJSONCall("resolveTypeReferenceDirective("+t+")",function(){var a=JSON.parse(n),o=e.resolveTypeReferenceDirective(r,e.normalizeSlashes(t),a,i.host);return{resolvedFileName:o.resolvedTypeReferenceDirective?o.resolvedTypeReferenceDirective.resolvedFileName:void 0,primary:o.resolvedTypeReferenceDirective?o.resolvedTypeReferenceDirective.primary:!0,failedLookupLocations:o.failedLookupLocations}})},r.prototype.getPreProcessedFileInfo=function(t,r){var n=this;return this.forwardJSONCall("getPreProcessedFileInfo('"+t+"')",function(){var t=e.preProcessFile(e.getSnapshotText(r),!0,!0);return{referencedFiles:n.convertFileReferences(t.referencedFiles),importedFiles:n.convertFileReferences(t.importedFiles),ambientExternalModules:t.ambientExternalModules,isLibFile:t.isLibFile,typeReferenceDirectives:n.convertFileReferences(t.typeReferenceDirectives),libReferenceDirectives:n.convertFileReferences(t.libReferenceDirectives)}})},r.prototype.getAutomaticTypeDirectiveNames=function(t){var r=this;return this.forwardJSONCall("getAutomaticTypeDirectiveNames('"+t+"')",function(){var n=JSON.parse(t);return e.getAutomaticTypeDirectiveNames(n,r.host)})},r.prototype.convertFileReferences=function(t){if(!t)return void 0;for(var r=[],n=0,i=t;n<i.length;n++){var a=i[n];r.push({path:e.normalizeSlashes(a.fileName),position:a.pos,length:a.end-a.pos})}return r},r.prototype.getTSConfigFileInfo=function(t,r){var n=this;return this.forwardJSONCall("getTSConfigFileInfo('"+t+"')",function(){var i=e.parseJsonText(t,e.getSnapshotText(r)),a=e.normalizeSlashes(t),s=e.parseJsonSourceFileConfigFileContent(i,n.host,e.getDirectoryPath(a),{},a);return{options:s.options,typeAcquisition:s.typeAcquisition,files:s.fileNames,raw:s.raw,errors:o(i.parseDiagnostics.concat(s.errors),"\r\n")}})},r.prototype.getDefaultCompilationSettings=function(){return this.forwardJSONCall("getDefaultCompilationSettings()",function(){return e.getDefaultCompilerOptions()})},r.prototype.discoverTypings=function(t){var r=this,n=e.createGetCanonicalFileName(!1);return this.forwardJSONCall("discoverTypings()",function(){var i=JSON.parse(t);return void 0===r.safeList&&(r.safeList=e.JsTyping.loadSafeList(r.host,e.toPath(i.safeListPath,i.safeListPath,n))),e.JsTyping.discoverTypings(r.host,function(e){return r.logger.log(e)},i.fileNames,e.toPath(i.projectRootPath,i.projectRootPath,n),r.safeList,i.packageNameToTypingLocation,i.typeAcquisition,i.unresolvedImports,i.typesRegistry)})},r}(f),y=function(){function r(){this._shims=[]}return r.prototype.getServicesVersion=function(){return e.servicesVersion},r.prototype.createLanguageServiceShim=function(r){try{void 0===this.documentRegistry&&(this.documentRegistry=e.createDocumentRegistry(r.useCaseSensitiveFileNames&&r.useCaseSensitiveFileNames(),r.getCurrentDirectory()));var n=new d(r),i=e.createLanguageService(n,this.documentRegistry,!1);return new m(this,r,i)}catch(a){throw t(r,a),a}},r.prototype.createClassifierShim=function(e){try{return new g(this,e)}catch(r){throw t(e,r),r}},r.prototype.createCoreServicesShim=function(e){try{var r=new p(e);return new v(this,e,r)}catch(n){throw t(e,n),n}},r.prototype.close=function(){e.clear(this._shims),this.documentRegistry=void 0},r.prototype.registerShim=function(e){this._shims.push(e)},r.prototype.unregisterShim=function(e){for(var t=0;t<this._shims.length;t++)if(this._shims[t]===e)return void delete this._shims[t];throw new Error("Invalid operation")},r}();e.TypeScriptServicesFactory=y,"undefined"!=typeof r&&r.exports&&(r.exports=e)}(n||(n={}));var u;!function(e){var t;!function(e){e.TypeScriptServicesFactory=n.TypeScriptServicesFactory}(t=e.Services||(e.Services={}))}(u||(u={}));n.versionMajorMinor;t.createClassifier=n.createClassifier,t.createLanguageService=n.createLanguageService,t.displayPartsToString=n.displayPartsToString,t.EndOfLineState=n.EndOfLineState,t.flattenDiagnosticMessageText=n.flattenDiagnosticMessageText,t.IndentStyle=n.IndentStyle,t.ScriptKind=n.ScriptKind,t.ScriptTarget=n.ScriptTarget,t.TokenClass=n.TokenClass});
/**! node_modules/monaco-editor/esm/vs/editor/common/services/editorSimpleWorker.js*/
define("0854f85",function(e,t){"use strict";function n(){return new y(null)}Object.defineProperty(t,"__esModule",{value:!0});var r=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}(),o=e("2e30c88"),i=e("e1c5605"),u=e("6ad26fe"),s=e("17c8d25"),l=e("50db2b4"),a=e("5ddf902"),m=e("4661130"),d=e("d327c41"),c=e("6250482"),f=e("3af5c49"),g=e("fabf684"),p=e("670df80"),h=e("4dc9450"),_=e("01fef85"),v=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),Object.defineProperty(t.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"version",{get:function(){return this._versionId},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"eol",{get:function(){return this._eol},enumerable:!0,configurable:!0}),t.prototype.getValue=function(){return this.getText()},t.prototype.getLinesContent=function(){return this._lines.slice(0)},t.prototype.getLineCount=function(){return this._lines.length},t.prototype.getLineContent=function(e){return this._lines[e-1]},t.prototype.getWordAtPosition=function(e,t){var n=f.getWordAtText(e.column,f.ensureValidWordDefinition(t),this._lines[e.lineNumber-1],0);return n?new m.Range(e.lineNumber,n.startColumn,e.lineNumber,n.endColumn):null},t.prototype.getWordUntilPosition=function(e,t){var n=this.getWordAtPosition(e,t);return n?{word:this._lines[e.lineNumber-1].substring(n.startColumn-1,e.column-1),startColumn:n.startColumn,endColumn:e.column}:{word:"",startColumn:e.column,endColumn:e.column}},t.prototype.createWordIterator=function(e){var t,n,r=this,o=0,i=0,s=[],l=function(){if(i<s.length){var a=n.substring(s[i].start,s[i].end);return i+=1,t?t.value=a:t={done:!1,value:a},t}return o>=r._lines.length?u.FIN:(n=r._lines[o],s=r._wordenize(n,e),i=0,o+=1,l())};return{next:l}},t.prototype.getLineWords=function(e,t){for(var n=this._lines[e-1],r=this._wordenize(n,t),o=[],i=0,u=r;i<u.length;i++){var s=u[i];o.push({word:n.substring(s.start,s.end),startColumn:s.start+1,endColumn:s.end+1})}return o},t.prototype._wordenize=function(e,t){var n,r=[];for(t.lastIndex=0;(n=t.exec(e))&&0!==n[0].length;)r.push({start:n.index,end:n.index+n[0].length});return r},t.prototype.getValueInRange=function(e){if(e=this._validateRange(e),e.startLineNumber===e.endLineNumber)return this._lines[e.startLineNumber-1].substring(e.startColumn-1,e.endColumn-1);var t=this._eol,n=e.startLineNumber-1,r=e.endLineNumber-1,o=[];o.push(this._lines[n].substring(e.startColumn-1));for(var i=n+1;r>i;i++)o.push(this._lines[i]);return o.push(this._lines[r].substring(0,e.endColumn-1)),o.join(t)},t.prototype.offsetAt=function(e){return e=this._validatePosition(e),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(e.lineNumber-2)+(e.column-1)},t.prototype.positionAt=function(e){e=Math.floor(e),e=Math.max(0,e),this._ensureLineStarts();var t=this._lineStarts.getIndexOf(e),n=this._lines[t.index].length;return{lineNumber:1+t.index,column:1+Math.min(t.remainder,n)}},t.prototype._validateRange=function(e){var t=this._validatePosition({lineNumber:e.startLineNumber,column:e.startColumn}),n=this._validatePosition({lineNumber:e.endLineNumber,column:e.endColumn});return t.lineNumber!==e.startLineNumber||t.column!==e.startColumn||n.lineNumber!==e.endLineNumber||n.column!==e.endColumn?{startLineNumber:t.lineNumber,startColumn:t.column,endLineNumber:n.lineNumber,endColumn:n.column}:e},t.prototype._validatePosition=function(e){if(!a.Position.isIPosition(e))throw new Error("bad position");var t=e.lineNumber,n=e.column,r=!1;if(1>t)t=1,n=1,r=!0;else if(t>this._lines.length)t=this._lines.length,n=this._lines[t-1].length+1,r=!0;else{var o=this._lines[t-1].length+1;1>n?(n=1,r=!0):n>o&&(n=o,r=!0)}return r?{lineNumber:t,column:n}:e},t}(c.MirrorTextModel),b=function(){function e(e){this._foreignModuleFactory=e,this._foreignModule=null}return e.prototype.computeDiff=function(e,t,n){var r=this._getModel(e),o=this._getModel(t);if(!r||!o)return Promise.resolve(null);var i=r.getLinesContent(),u=o.getLinesContent(),s=new d.DiffComputer(i,u,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:n,shouldMakePrettyDiff:!0}),l=s.computeDiff(),a=l.length>0?!1:this._modelsAreIdentical(r,o);return Promise.resolve({identical:a,changes:l})},e.prototype._modelsAreIdentical=function(e,t){var n=e.getLineCount(),r=t.getLineCount();if(n!==r)return!1;for(var o=1;n>=o;o++){var i=e.getLineContent(o),u=t.getLineContent(o);if(i!==u)return!1}return!0},e.prototype.computeMoreMinimalEdits=function(t,n){var r=this._getModel(t);if(!r)return Promise.resolve(n);var u=[],s=void 0;n=o.mergeSort(n,function(e,t){if(e.range&&t.range)return m.Range.compareRangesUsingStarts(e.range,t.range);var n=e.range?0:1,r=t.range?0:1;return n-r});for(var l=0,a=n;l<a.length;l++){var d=a[l],c=d.range,f=d.text,g=d.eol;if("number"==typeof g&&(s=g),!m.Range.isEmpty(c)||f){var p=r.getValueInRange(c);if(f=f.replace(/\r\n|\n|\r/g,r.eol),p!==f)if(Math.max(f.length,p.length)>e._diffLimit)u.push({range:c,text:f});else for(var h=i.stringDiff(p,f,!1),_=r.offsetAt(m.Range.lift(c).getStartPosition()),v=0,b=h;v<b.length;v++){var y=b[v],C=r.positionAt(_+y.originalStart),N=r.positionAt(_+y.originalStart+y.originalLength),L={text:f.substr(y.modifiedStart,y.modifiedLength),range:{startLineNumber:C.lineNumber,startColumn:C.column,endLineNumber:N.lineNumber,endColumn:N.column}};r.getValueInRange(L.range)!==L.text&&u.push(L)}}}return"number"==typeof s&&u.push({eol:s,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),Promise.resolve(u)},e.prototype.computeLinks=function(e){var t=this._getModel(e);return Promise.resolve(t?g.computeLinks(t):null)},e.prototype.textualSuggest=function(t,n,r,o){var i=this._getModel(t);if(!i)return Promise.resolve(null);var u=Object.create(null),s=[],l=new RegExp(r,o),a=i.getWordUntilPosition(n,l),m=i.getWordAtPosition(n,l);m&&(u[i.getValueInRange(m)]=!0);for(var d=i.createWordIterator(l),c=d.next();!c.done&&s.length<=e._suggestionsLimit;c=d.next()){var f=c.value;u[f]||(u[f]=!0,isNaN(Number(f))&&s.push({kind:18,label:f,insertText:f,range:{startLineNumber:n.lineNumber,startColumn:a.startColumn,endLineNumber:n.lineNumber,endColumn:a.endColumn}}))}return Promise.resolve({suggestions:s})},e.prototype.computeWordRanges=function(e,t,n,r){var o=this._getModel(e);if(!o)return Promise.resolve(Object.create(null));for(var i=new RegExp(n,r),u=Object.create(null),s=t.startLineNumber;s<t.endLineNumber;s++)for(var l=o.getLineWords(s,i),a=0,m=l;a<m.length;a++){var d=m[a];if(isNaN(Number(d.word))){var c=u[d.word];c||(c=[],u[d.word]=c),c.push({startLineNumber:s,startColumn:d.startColumn,endLineNumber:s,endColumn:d.endColumn})}}return Promise.resolve(u)},e.prototype.navigateValueSet=function(e,t,n,r,o){var i=this._getModel(e);if(!i)return Promise.resolve(null);var u=new RegExp(r,o);t.startColumn===t.endColumn&&(t={startLineNumber:t.startLineNumber,startColumn:t.startColumn,endLineNumber:t.endLineNumber,endColumn:t.endColumn+1});var s=i.getValueInRange(t),l=i.getWordAtPosition({lineNumber:t.startLineNumber,column:t.startColumn},u);if(!l)return Promise.resolve(null);var a=i.getValueInRange(l),m=p.BasicInplaceReplace.INSTANCE.navigateValueSet(t,s,l,a,n);return Promise.resolve(m)},e.prototype.loadForeignModule=function(e,t){var n=this,r={getMirrorModels:function(){return n._getModels()}};if(this._foreignModuleFactory){this._foreignModule=this._foreignModuleFactory(r,t);for(var o=[],i=0,u=_.getAllPropertyNames(this._foreignModule);i<u.length;i++){var s=u[i];"function"==typeof this._foreignModule[s]&&o.push(s)}return Promise.resolve(o)}return Promise.reject(new Error("Unexpected usage"))},e.prototype.fmr=function(e,t){if(!this._foreignModule||"function"!=typeof this._foreignModule[e])return Promise.reject(new Error("Missing requestHandler or method: "+e));try{return Promise.resolve(this._foreignModule[e].apply(this._foreignModule,t))}catch(n){return Promise.reject(n)}},e._diffLimit=1e5,e._suggestionsLimit=1e4,e}();t.BaseEditorSimpleWorker=b;var y=function(e){function t(t){var n=e.call(this,t)||this;return n._models=Object.create(null),n}return r(t,e),t.prototype.dispose=function(){this._models=Object.create(null)},t.prototype._getModel=function(e){return this._models[e]},t.prototype._getModels=function(){var e=this,t=[];return Object.keys(this._models).forEach(function(n){return t.push(e._models[n])}),t},t.prototype.acceptNewModel=function(e){this._models[e.url]=new v(l.URI.parse(e.url),e.lines,e.EOL,e.versionId)},t.prototype.acceptModelChanged=function(e,t){if(this._models[e]){var n=this._models[e];n.onEvents(t)}},t.prototype.acceptRemovedModel=function(e){this._models[e]&&delete this._models[e]},t}(b);t.EditorSimpleWorkerImpl=y,t.create=n,"function"==typeof importScripts&&(s.globals.monaco=h.createMonacoBaseAPI())});
/**! node_modules/monaco-editor/esm/vs/base/common/worker/simpleWorker.js*/
define("e9bd7e4",function(e,r){"use strict";function t(e){a.isWeb&&(c||(c=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/Microsoft/monaco-editor#faq")),console.warn(e.message))}function n(e){return new p(e,null)}Object.defineProperty(r,"__esModule",{value:!0});var o=this&&this.__extends||function(){var e=function(r,t){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,r){e.__proto__=r}||function(e,r){for(var t in r)r.hasOwnProperty(t)&&(e[t]=r[t])})(r,t)};return function(r,t){function n(){this.constructor=r}e(r,t),r.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}}(),s=e("22e50b6"),i=e("a0b8cca"),a=e("17c8d25"),u=e("01fef85"),l="$initialize",c=!1;r.logOnceWebWorkerWarning=t;var d=function(){function e(e){this._workerId=-1,this._handler=e,this._lastSentReq=0,this._pendingReplies=Object.create(null)}return e.prototype.setWorkerId=function(e){this._workerId=e},e.prototype.sendMessage=function(e,r){var t=this,n=String(++this._lastSentReq);return new Promise(function(o,s){t._pendingReplies[n]={resolve:o,reject:s},t._send({vsWorker:t._workerId,req:n,method:e,args:r})})},e.prototype.handleMessage=function(e){var r;try{r=JSON.parse(e)}catch(t){return}r&&r.vsWorker&&(-1===this._workerId||r.vsWorker===this._workerId)&&this._handleMessage(r)},e.prototype._handleMessage=function(e){var r=this;if(e.seq){var t=e;if(!this._pendingReplies[t.seq])return void console.warn("Got reply to unknown seq");var n=this._pendingReplies[t.seq];if(delete this._pendingReplies[t.seq],t.err){var o=t.err;return t.err.$isError&&(o=new Error,o.name=t.err.name,o.message=t.err.message,o.stack=t.err.stack),void n.reject(o)}return void n.resolve(t.res)}var i=e,a=i.req,u=this._handler.handleMessage(i.method,i.args);u.then(function(e){r._send({vsWorker:r._workerId,seq:a,res:e,err:void 0})},function(e){e.detail instanceof Error&&(e.detail=s.transformErrorForSerialization(e.detail)),r._send({vsWorker:r._workerId,seq:a,res:void 0,err:s.transformErrorForSerialization(e)})})},e.prototype._send=function(e){var r=JSON.stringify(e);this._handler.sendMessage(r)},e}(),f=function(e){function r(r,t){var n=e.call(this)||this,o=null;n._worker=n._register(r.create("vs/base/common/worker/simpleWorker",function(e){n._protocol.handleMessage(e)},function(e){o&&o(e)})),n._protocol=new d({sendMessage:function(e){n._worker.postMessage(e)},handleMessage:function(){return Promise.resolve(null)}}),n._protocol.setWorkerId(n._worker.getId());var s=null;"undefined"!=typeof self.require&&"function"==typeof self.require.getConfig?s=self.require.getConfig():"undefined"!=typeof self.requirejs&&(s=self.requirejs.s.contexts._.config),n._onModuleLoaded=n._protocol.sendMessage(l,[n._worker.getId(),t,s]),n._lazyProxy=new Promise(function(e,r){o=r,n._onModuleLoaded.then(function(r){for(var t={},n=0,o=r;n<o.length;n++){var s=o[n];t[s]=a(s,i)}e(t)},function(e){r(e),n._onError("Worker failed to load "+t,e)})});var i=function(e,r){return n._request(e,r)},a=function(e,r){return function(){var t=Array.prototype.slice.call(arguments,0);return r(e,t)}};return n}return o(r,e),r.prototype.getProxyObject=function(){return this._lazyProxy},r.prototype._request=function(e,r){var t=this;return new Promise(function(n,o){t._onModuleLoaded.then(function(){t._protocol.sendMessage(e,r).then(n,o)},o)})},r.prototype._onError=function(e,r){console.error(e),console.info(r)},r}(i.Disposable);r.SimpleWorkerClient=f;var p=function(){function e(e,r){var t=this;this._requestHandler=r,this._protocol=new d({sendMessage:function(r){e(r)},handleMessage:function(e,r){return t._handleMessage(e,r)}})}return e.prototype.onmessage=function(e){this._protocol.handleMessage(e)},e.prototype._handleMessage=function(e,r){if(e===l)return this.initialize(r[0],r[1],r[2]);if(!this._requestHandler||"function"!=typeof this._requestHandler[e])return Promise.reject(new Error("Missing requestHandler or method: "+e));try{return Promise.resolve(this._requestHandler[e].apply(this._requestHandler,r))}catch(t){return Promise.reject(t)}},e.prototype.initialize=function(e,r,t){var n=this;if(this._protocol.setWorkerId(e),this._requestHandler){for(var o=[],s=0,i=u.getAllPropertyNames(this._requestHandler);s<i.length;s++){var a=i[s];"function"==typeof this._requestHandler[a]&&o.push(a)}return Promise.resolve(o)}return t&&("undefined"!=typeof t.baseUrl&&delete t.baseUrl,"undefined"!=typeof t.paths&&"undefined"!=typeof t.paths.vs&&delete t.paths.vs,t.catchError=!0,self.require.config(t)),new Promise(function(e,t){self.require([r],function(){for(var r=[],o=0;o<arguments.length;o++)r[o]=arguments[o];var s=r[0];if(n._requestHandler=s.create(),!n._requestHandler)return void t(new Error("No RequestHandler!"));for(var i=[],a=0,l=u.getAllPropertyNames(n._requestHandler);a<l.length;a++){var c=l[a];"function"==typeof n._requestHandler[c]&&i.push(c)}e(i)},t)})},e}();r.SimpleWorkerServer=p,r.create=n});
/**! node_modules/monaco-editor/esm/vs/language/typescript/tsWorker.js*/
define("725fcec",function(t,e){"use strict";function i(t,e){return new u(t,e)}Object.defineProperty(e,"__esModule",{value:!0});var r=t("11ed2ab"),o=r.__importStar(t("03ff426")),n=t("ba73a73"),s={NAME:"defaultLib:lib.d.ts",CONTENTS:n.lib_dts},a={NAME:"defaultLib:lib.es6.d.ts",CONTENTS:n.lib_es6_dts},u=function(){function t(t,e){this._extraLibs=Object.create(null),this._languageService=o.createLanguageService(this),this._ctx=t,this._compilerOptions=e.compilerOptions,this._extraLibs=e.extraLibs}return t.prototype.getCompilationSettings=function(){return this._compilerOptions},t.prototype.getScriptFileNames=function(){var t=this._ctx.getMirrorModels().map(function(t){return t.uri.toString()});return t.concat(Object.keys(this._extraLibs))},t.prototype._getModel=function(t){for(var e=this._ctx.getMirrorModels(),i=0;i<e.length;i++)if(e[i].uri.toString()===t)return e[i];return null},t.prototype.getScriptVersion=function(t){var e=this._getModel(t);return e?e.version.toString():this.isDefaultLibFileName(t)?"1":t in this._extraLibs?String(this._extraLibs[t].version):void 0},t.prototype.getScriptSnapshot=function(t){var e,i=this._getModel(t);if(i)e=i.getValue();else if(t in this._extraLibs)e=this._extraLibs[t].content;else if(t===s.NAME)e=s.CONTENTS;else{if(t!==a.NAME)return;e=a.CONTENTS}return{getText:function(t,i){return e.substring(t,i)},getLength:function(){return e.length},getChangeRange:function(){return void 0}}},t.prototype.getScriptKind=function(t){var e=t.substr(t.lastIndexOf(".")+1);switch(e){case"ts":return o.ScriptKind.TS;case"tsx":return o.ScriptKind.TSX;case"js":return o.ScriptKind.JS;case"jsx":return o.ScriptKind.JSX;default:return this.getCompilationSettings().allowJs?o.ScriptKind.JS:o.ScriptKind.TS}},t.prototype.getCurrentDirectory=function(){return""},t.prototype.getDefaultLibFileName=function(t){return t.target<=o.ScriptTarget.ES5?s.NAME:a.NAME},t.prototype.isDefaultLibFileName=function(t){return t===this.getDefaultLibFileName(this._compilerOptions)},t.clearFiles=function(t){t.forEach(function(t){t.file=void 0;var e=t.relatedInformation;e&&e.forEach(function(t){return t.file=void 0})})},t.prototype.getSyntacticDiagnostics=function(e){var i=this._languageService.getSyntacticDiagnostics(e);return t.clearFiles(i),Promise.resolve(i)},t.prototype.getSemanticDiagnostics=function(e){var i=this._languageService.getSemanticDiagnostics(e);return t.clearFiles(i),Promise.resolve(i)},t.prototype.getCompilerOptionsDiagnostics=function(){var e=this._languageService.getCompilerOptionsDiagnostics();return t.clearFiles(e),Promise.resolve(e)},t.prototype.getCompletionsAtPosition=function(t,e){return Promise.resolve(this._languageService.getCompletionsAtPosition(t,e,void 0))},t.prototype.getCompletionEntryDetails=function(t,e,i){return Promise.resolve(this._languageService.getCompletionEntryDetails(t,e,i,void 0,void 0,void 0))},t.prototype.getSignatureHelpItems=function(t,e){return Promise.resolve(this._languageService.getSignatureHelpItems(t,e,void 0))},t.prototype.getQuickInfoAtPosition=function(t,e){return Promise.resolve(this._languageService.getQuickInfoAtPosition(t,e))},t.prototype.getOccurrencesAtPosition=function(t,e){return Promise.resolve(this._languageService.getOccurrencesAtPosition(t,e))},t.prototype.getDefinitionAtPosition=function(t,e){return Promise.resolve(this._languageService.getDefinitionAtPosition(t,e))},t.prototype.getReferencesAtPosition=function(t,e){return Promise.resolve(this._languageService.getReferencesAtPosition(t,e))},t.prototype.getNavigationBarItems=function(t){return Promise.resolve(this._languageService.getNavigationBarItems(t))},t.prototype.getFormattingEditsForDocument=function(t,e){return Promise.resolve(this._languageService.getFormattingEditsForDocument(t,e))},t.prototype.getFormattingEditsForRange=function(t,e,i,r){return Promise.resolve(this._languageService.getFormattingEditsForRange(t,e,i,r))},t.prototype.getFormattingEditsAfterKeystroke=function(t,e,i,r){return Promise.resolve(this._languageService.getFormattingEditsAfterKeystroke(t,e,i,r))},t.prototype.getEmitOutput=function(t){return Promise.resolve(this._languageService.getEmitOutput(t))},t.prototype.updateExtraLibs=function(t){this._extraLibs=t},t}();e.TypeScriptWorker=u,e.create=i});
/**! node_modules/monaco-editor/esm/vs/editor/editor.worker.js*/
define("ca932bd",function(e,n){"use strict";function i(e){if(!t){t=!0;var n=new o.EditorSimpleWorkerImpl(e),i=new s.SimpleWorkerServer(function(e){self.postMessage(e)},n);self.onmessage=function(e){i.onmessage(e.data)}}}Object.defineProperty(n,"__esModule",{value:!0});var s=e("e9bd7e4"),o=e("0854f85"),t=!1;n.initialize=i,self.onmessage=function(){t||i(null)}});
/**! node_modules/tslib/tslib.js*/
define("11ed2ab",function(t,e,n,r){var o,a,u,c,i,f,l,s,y,p,b,_,h,v,d,m,w,g,O,j;!function(t){function e(t,e){return t!==o&&("function"==typeof Object.create?Object.defineProperty(t,"__esModule",{value:!0}):t.__esModule=!0),function(n,r){return t[n]=e?e(n,r):r}}var o="object"==typeof global?global:"object"==typeof self?self:"object"==typeof this?this:{};"function"==typeof r&&r.amd?r("tslib",["exports"],function(n){t(e(o,e(n)))}):t("object"==typeof n&&"object"==typeof n.exports?e(o,e(n.exports)):e(o))}(function(t){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])};o=function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)},a=Object.assign||function(t){for(var e,n=1,r=arguments.length;r>n;n++){e=arguments[n];for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&(t[o]=e[o])}return t},u=function(t,e){var n={};for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&e.indexOf(r)<0&&(n[r]=t[r]);if(null!=t&&"function"==typeof Object.getOwnPropertySymbols)for(var o=0,r=Object.getOwnPropertySymbols(t);o<r.length;o++)e.indexOf(r[o])<0&&Object.prototype.propertyIsEnumerable.call(t,r[o])&&(n[r[o]]=t[r[o]]);return n},c=function(t,e,n,r){var o,a=arguments.length,u=3>a?e:null===r?r=Object.getOwnPropertyDescriptor(e,n):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)u=Reflect.decorate(t,e,n,r);else for(var c=t.length-1;c>=0;c--)(o=t[c])&&(u=(3>a?o(u):a>3?o(e,n,u):o(e,n))||u);return a>3&&u&&Object.defineProperty(e,n,u),u},i=function(t,e){return function(n,r){e(n,r,t)}},f=function(t,e){return"object"==typeof Reflect&&"function"==typeof Reflect.metadata?Reflect.metadata(t,e):void 0},l=function(t,e,n,r){return new(n||(n=Promise))(function(o,a){function u(t){try{i(r.next(t))}catch(e){a(e)}}function c(t){try{i(r["throw"](t))}catch(e){a(e)}}function i(t){t.done?o(t.value):new n(function(e){e(t.value)}).then(u,c)}i((r=r.apply(t,e||[])).next())})},s=function(t,e){function n(t){return function(e){return r([t,e])}}function r(n){if(o)throw new TypeError("Generator is already executing.");for(;i;)try{if(o=1,a&&(u=2&n[0]?a["return"]:n[0]?a["throw"]||((u=a["return"])&&u.call(a),0):a.next)&&!(u=u.call(a,n[1])).done)return u;switch(a=0,u&&(n=[2&n[0],u.value]),n[0]){case 0:case 1:u=n;break;case 4:return i.label++,{value:n[1],done:!1};case 5:i.label++,a=n[1],n=[0];continue;case 7:n=i.ops.pop(),i.trys.pop();continue;default:if(u=i.trys,!(u=u.length>0&&u[u.length-1])&&(6===n[0]||2===n[0])){i=0;continue}if(3===n[0]&&(!u||n[1]>u[0]&&n[1]<u[3])){i.label=n[1];break}if(6===n[0]&&i.label<u[1]){i.label=u[1],u=n;break}if(u&&i.label<u[2]){i.label=u[2],i.ops.push(n);break}u[2]&&i.ops.pop(),i.trys.pop();continue}n=e.call(t,i)}catch(r){n=[6,r],a=0}finally{o=u=0}if(5&n[0])throw n[1];return{value:n[0]?n[1]:void 0,done:!0}}var o,a,u,c,i={label:0,sent:function(){if(1&u[0])throw u[1];return u[1]},trys:[],ops:[]};return c={next:n(0),"throw":n(1),"return":n(2)},"function"==typeof Symbol&&(c[Symbol.iterator]=function(){return this}),c},y=function(t,e){for(var n in t)e.hasOwnProperty(n)||(e[n]=t[n])},p=function(t){var e="function"==typeof Symbol&&t[Symbol.iterator],n=0;return e?e.call(t):{next:function(){return t&&n>=t.length&&(t=void 0),{value:t&&t[n++],done:!t}}}},b=function(t,e){var n="function"==typeof Symbol&&t[Symbol.iterator];if(!n)return t;var r,o,a=n.call(t),u=[];try{for(;(void 0===e||e-->0)&&!(r=a.next()).done;)u.push(r.value)}catch(c){o={error:c}}finally{try{r&&!r.done&&(n=a["return"])&&n.call(a)}finally{if(o)throw o.error}}return u},_=function(){for(var t=[],e=0;e<arguments.length;e++)t=t.concat(b(arguments[e]));return t},h=function(){for(var t=0,e=0,n=arguments.length;n>e;e++)t+=arguments[e].length;for(var r=Array(t),o=0,e=0;n>e;e++)for(var a=arguments[e],u=0,c=a.length;c>u;u++,o++)r[o]=a[u];return r},v=function(t){return this instanceof v?(this.v=t,this):new v(t)},d=function(t,e,n){function r(t){l[t]&&(f[t]=function(e){return new Promise(function(n,r){s.push([t,e,n,r])>1||o(t,e)})})}function o(t,e){try{a(l[t](e))}catch(n){i(s[0][3],n)}}function a(t){t.value instanceof v?Promise.resolve(t.value.v).then(u,c):i(s[0][2],t)}function u(t){o("next",t)}function c(t){o("throw",t)}function i(t,e){t(e),s.shift(),s.length&&o(s[0][0],s[0][1])}if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var f,l=n.apply(t,e||[]),s=[];return f={},r("next"),r("throw"),r("return"),f[Symbol.asyncIterator]=function(){return this},f},m=function(t){function e(e,o){n[e]=t[e]?function(n){return(r=!r)?{value:v(t[e](n)),done:"return"===e}:o?o(n):n}:o}var n,r;return n={},e("next"),e("throw",function(t){throw t}),e("return"),n[Symbol.iterator]=function(){return this},n},w=function(t){function e(e){r[e]=t[e]&&function(r){return new Promise(function(o,a){r=t[e](r),n(o,a,r.done,r.value)})}}function n(t,e,n,r){Promise.resolve(r).then(function(e){t({value:e,done:n})},e)}if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var r,o=t[Symbol.asyncIterator];return o?o.call(t):(t="function"==typeof p?p(t):t[Symbol.iterator](),r={},e("next"),e("throw"),e("return"),r[Symbol.asyncIterator]=function(){return this},r)},g=function(t,e){return Object.defineProperty?Object.defineProperty(t,"raw",{value:e}):t.raw=e,t},O=function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var n in t)Object.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e["default"]=t,e},j=function(t){return t&&t.__esModule?t:{"default":t}},t("__extends",o),t("__assign",a),t("__rest",u),t("__decorate",c),t("__param",i),t("__metadata",f),t("__awaiter",l),t("__generator",s),t("__exportStar",y),t("__values",p),t("__read",b),t("__spread",_),t("__spreadArrays",h),t("__await",v),t("__asyncGenerator",d),t("__asyncDelegator",m),t("__asyncValues",w),t("__makeTemplateObject",g),t("__importStar",O),t("__importDefault",j)})});
/**! node_modules/monaco-editor/esm/vs/language/typescript/ts.worker.js*/
define("8361ff2",function(e,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0});var n=e("11ed2ab"),t=n.__importStar(e("ca932bd")),r=e("725fcec");self.onmessage=function(){t.initialize(function(e,i){return new r.TypeScriptWorker(e,i)})}});
require('8361ff2')